


  var gl;
  /**
   * @param {(Array|null)} ctx
   * @return {?}
   */
  var draw = function(ctx) {
    gl.clearColor(0, 0, 0, 1);
    gl.enable(gl.DEPTH_TEST);
    gl.depthFunc(gl.LEQUAL);
    gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
    return "[" + ctx[0] + ", " + ctx[1] + "]";
  };
  /**
   * @param {(WebGLRenderingContext|null)} gl
   * @return {?}
   */
  var getMaxAnisotropy = function(gl) {
    /** @type {(Object|null)} */
    var e = gl.getExtension("EXT_texture_filter_anisotropic") || (gl.getExtension("WEBKIT_EXT_texture_filter_anisotropic") || gl.getExtension("MOZ_EXT_texture_filter_anisotropic"));
    if (e) {
      /** @type {*} */
      var max = gl.getParameter(e.MAX_TEXTURE_MAX_ANISOTROPY_EXT);
      if (max === 0) {
        /** @type {number} */
        max = 2;
      }
      return max;
    } else {
      return null;
    }
  };
  /**
   * @return {?}
   */
  var myFunc = function() {
    /** @type {Element} */
    var canvas = document.createElement("canvas");
    document.body.appendChild(canvas);
    /** @type {null} */
    var gl = null;
    try {
      gl = canvas.getContext("webgl") || canvas.getContext("experimental-webgl");
    } catch (e) {
    }
    if (!gl) {
      /** @type {null} */
      gl = null;
    }
    return gl;
  };

  gl = myFunc();

  if (!gl) {
    document.write("ERRORE");
  }
  /** @type {Array} */
  var serialisedProps = [];
  var toDataURLRes;
  /** @type {string} */
  var shader = "attribute vec2 attrVertex;varying vec2 varyinTexCoordinate;uniform vec2 uniformOffset;void main(){varyinTexCoordinate=attrVertex+uniformOffset;gl_Position=vec4(attrVertex,0,1);}";
  /** @type {string} */
  var vsData = "precision mediump float;varying vec2 varyinTexCoordinate;void main() {gl_FragColor=vec4(varyinTexCoordinate,0,1);}";
  var buffer = gl.createBuffer();
  gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
  /** @type {Float32Array} */
  var dataBuffer = new Float32Array([-0.2, -0.9, 0, 0.4, -0.26, 0, 0, 0.732134444, 0]);
  gl.bufferData(gl.ARRAY_BUFFER, dataBuffer, gl.STATIC_DRAW);
  /** @type {number} */
  buffer.itemSize = 3;
  /** @type {number} */
  buffer.numItems = 3;
  var program = gl.createProgram();
  var vs = gl.createShader(gl.VERTEX_SHADER);
  gl.shaderSource(vs, shader);
  gl.compileShader(vs);
  var fs = gl.createShader(gl.FRAGMENT_SHADER);
  gl.shaderSource(fs, vsData);
  gl.compileShader(fs);
  gl.attachShader(program, vs);
  gl.attachShader(program, fs);
  gl.linkProgram(program);
  gl.useProgram(program);
  program.vertexPosAttrib = gl.getAttribLocation(program, "attrVertex");
  program.offsetUniform = gl.getUniformLocation(program, "uniformOffset");
  gl.enableVertexAttribArray(program.vertexPosArray);
  gl.vertexAttribPointer(program.vertexPosAttrib, buffer.itemSize, gl.FLOAT, false, 0, 0);
  gl.uniform2f(program.offsetUniform, 1, 1);
  gl.drawArrays(gl.TRIANGLE_STRIP, 0, buffer.numItems);
  try {
    toDataURLRes = gl.canvas.toDataURL();
  } catch (e$$14) {
  }
  serialisedProps.push("extensions:" + (gl.getSupportedExtensions() || []).join(";"));
  serialisedProps.push("webgl aliased line width range:" + draw(gl.getParameter(gl.ALIASED_LINE_WIDTH_RANGE)));
  serialisedProps.push("webgl aliased point size range:" + draw(gl.getParameter(gl.ALIASED_POINT_SIZE_RANGE)));
  serialisedProps.push("webgl alpha bits:" + gl.getParameter(gl.ALPHA_BITS));
  serialisedProps.push("webgl antialiasing:" + (gl.getContextAttributes().antialias ? "yes" : "no"));
  serialisedProps.push("webgl blue bits:" + gl.getParameter(gl.BLUE_BITS));
  serialisedProps.push("webgl depth bits:" + gl.getParameter(gl.DEPTH_BITS));
  serialisedProps.push("webgl green bits:" + gl.getParameter(gl.GREEN_BITS));
  serialisedProps.push("webgl max anisotropy:" + getMaxAnisotropy(gl));
  serialisedProps.push("webgl max combined texture image units:" + gl.getParameter(gl.MAX_COMBINED_TEXTURE_IMAGE_UNITS));
  serialisedProps.push("webgl max cube map texture size:" + gl.getParameter(gl.MAX_CUBE_MAP_TEXTURE_SIZE));
  serialisedProps.push("webgl max fragment uniform vectors:" + gl.getParameter(gl.MAX_FRAGMENT_UNIFORM_VECTORS));
  serialisedProps.push("webgl max render buffer size:" + gl.getParameter(gl.MAX_RENDERBUFFER_SIZE));
  serialisedProps.push("webgl max texture image units:" + gl.getParameter(gl.MAX_TEXTURE_IMAGE_UNITS));
  serialisedProps.push("webgl max texture size:" + gl.getParameter(gl.MAX_TEXTURE_SIZE));
  serialisedProps.push("webgl max varying vectors:" + gl.getParameter(gl.MAX_VARYING_VECTORS));
  serialisedProps.push("webgl max vertex attribs:" + gl.getParameter(gl.MAX_VERTEX_ATTRIBS));
  serialisedProps.push("webgl max vertex texture image units:" + gl.getParameter(gl.MAX_VERTEX_TEXTURE_IMAGE_UNITS));
  serialisedProps.push("webgl max vertex uniform vectors:" + gl.getParameter(gl.MAX_VERTEX_UNIFORM_VECTORS));
  serialisedProps.push("webgl max viewport dims:" + draw(gl.getParameter(gl.MAX_VIEWPORT_DIMS)));
  serialisedProps.push("webgl red bits:" + gl.getParameter(gl.RED_BITS));
  serialisedProps.push("webgl renderer:" + gl.getParameter(gl.RENDERER));
  serialisedProps.push("webgl shading language version:" + gl.getParameter(gl.SHADING_LANGUAGE_VERSION));
  serialisedProps.push("webgl stencil bits:" + gl.getParameter(gl.STENCIL_BITS));
  serialisedProps.push("webgl vendor:" + gl.getParameter(gl.VENDOR));
  serialisedProps.push("webgl version:" + gl.getParameter(gl.VERSION));
  try {
    var Constants = gl.getExtension("WEBGL_debug_renderer_info");
    if (Constants) {
      serialisedProps.push("webgl unmasked vendor:" + gl.getParameter(Constants.UNMASKED_VENDOR_WEBGL));
      serialisedProps.push("webgl unmasked renderer:" + gl.getParameter(Constants.UNMASKED_RENDERER_WEBGL));
    }
  } catch (e$$15) {
  }
  if (!gl.getShaderPrecisionFormat) {
    document.write(serialisedProps.join("~"));
  }
  serialisedProps.push("webgl vertex shader high float precision:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.HIGH_FLOAT).precision);
  serialisedProps.push("webgl vertex shader high float precision rangeMin:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.HIGH_FLOAT).rangeMin);
  serialisedProps.push("webgl vertex shader high float precision rangeMax:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.HIGH_FLOAT).rangeMax);
  serialisedProps.push("webgl vertex shader medium float precision:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.MEDIUM_FLOAT).precision);
  serialisedProps.push("webgl vertex shader medium float precision rangeMin:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.MEDIUM_FLOAT).rangeMin);
  serialisedProps.push("webgl vertex shader medium float precision rangeMax:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.MEDIUM_FLOAT).rangeMax);
  serialisedProps.push("webgl vertex shader low float precision:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.LOW_FLOAT).precision);
  serialisedProps.push("webgl vertex shader low float precision rangeMin:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.LOW_FLOAT).rangeMin);
  serialisedProps.push("webgl vertex shader low float precision rangeMax:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.LOW_FLOAT).rangeMax);
  serialisedProps.push("webgl fragment shader high float precision:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.HIGH_FLOAT).precision);
  serialisedProps.push("webgl fragment shader high float precision rangeMin:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.HIGH_FLOAT).rangeMin);
  serialisedProps.push("webgl fragment shader high float precision rangeMax:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.HIGH_FLOAT).rangeMax);
  serialisedProps.push("webgl fragment shader medium float precision:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.MEDIUM_FLOAT).precision);
  serialisedProps.push("webgl fragment shader medium float precision rangeMin:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.MEDIUM_FLOAT).rangeMin);
  serialisedProps.push("webgl fragment shader medium float precision rangeMax:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.MEDIUM_FLOAT).rangeMax);
  serialisedProps.push("webgl fragment shader low float precision:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.LOW_FLOAT).precision);
  serialisedProps.push("webgl fragment shader low float precision rangeMin:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.LOW_FLOAT).rangeMin);
  serialisedProps.push("webgl fragment shader low float precision rangeMax:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.LOW_FLOAT).rangeMax);
  serialisedProps.push("webgl vertex shader high int precision:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.HIGH_INT).precision);
  serialisedProps.push("webgl vertex shader high int precision rangeMin:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.HIGH_INT).rangeMin);
  serialisedProps.push("webgl vertex shader high int precision rangeMax:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.HIGH_INT).rangeMax);
  serialisedProps.push("webgl vertex shader medium int precision:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.MEDIUM_INT).precision);
  serialisedProps.push("webgl vertex shader medium int precision rangeMin:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.MEDIUM_INT).rangeMin);
  serialisedProps.push("webgl vertex shader medium int precision rangeMax:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.MEDIUM_INT).rangeMax);
  serialisedProps.push("webgl vertex shader low int precision:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.LOW_INT).precision);
  serialisedProps.push("webgl vertex shader low int precision rangeMin:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.LOW_INT).rangeMin);
  serialisedProps.push("webgl vertex shader low int precision rangeMax:" + gl.getShaderPrecisionFormat(gl.VERTEX_SHADER, gl.LOW_INT).rangeMax);
  serialisedProps.push("webgl fragment shader high int precision:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.HIGH_INT).precision);
  serialisedProps.push("webgl fragment shader high int precision rangeMin:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.HIGH_INT).rangeMin);
  serialisedProps.push("webgl fragment shader high int precision rangeMax:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.HIGH_INT).rangeMax);
  serialisedProps.push("webgl fragment shader medium int precision:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.MEDIUM_INT).precision);
  serialisedProps.push("webgl fragment shader medium int precision rangeMin:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.MEDIUM_INT).rangeMin);
  serialisedProps.push("webgl fragment shader medium int precision rangeMax:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.MEDIUM_INT).rangeMax);
  serialisedProps.push("webgl fragment shader low int precision:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.LOW_INT).precision);
  serialisedProps.push("webgl fragment shader low int precision rangeMin:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.LOW_INT).rangeMin);
  serialisedProps.push("webgl fragment shader low int precision rangeMax:" + gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.LOW_INT).rangeMax);


  var completeProperties = serialisedProps.join("<br>");
  document.write("<br><br>Hash MD5 del toDataURL:<br><p style='font-size: 8pt'>" + b64_md5(toDataURLRes) + "</p>");
  document.write("<br>Hash MD5 delle proprietà restituite da WebGL:<br><p style='font-size: 8pt'>" + b64_md5(completeProperties) + "</p>");
  document.write("<br><br>Risultato completo toDataURL: <br><p style='font-size: 8pt'>" + toDataURLRes + "</p>");
  document.write("<br><br>Risultato completo proprietà WebGL: <br><p style='font-size: 8pt'>" + completeProperties + "</p>");

