
{
    "@context": "http://schema.org",
    "@type": "Organization",
    "name": "Chewy",
    "url": "http://www.chewy.com",
    "sameAs": [
        "http://www.facebook.com/chewy",
        "https://www.youtube.com/channel/UCpWl2nwLDQQI4TTa1kJgxrg",
        "http://instagram.com/chewy",
        "http://twitter.com/chewy",
        "https://www.linkedin.com/company/2433416",
        "http://pinterest.com/chewy"
    ],
    "contactPoint": [{
        "@type": "ContactPoint",
        "telephone": "+1-800-672-4399",
        "contactType": "customer service"
    }]
}


  window.chewyConf = {
    storeId : 10,
    currency : "USD",

    version : "master-603",
    environment : "production",
    production : true,

    //NOTE: Do NOT expose token. We do not want 3rd party JS to be able to read our secure tokens.
    cid : "-1002",
    uid : "-1002",
    csr : false,
    priviledged : false,
    registeredUser : false,
    genericUser : true,
    authenticated : false,
    personalizationId : "ZhzBh_qvTSitKQAScMJCjg",

    requestId : "3ef847bf,03-5AD46E75-58D629A",
    spider : false,

    viewType : "desktop",
    mobileView : false,
    desktopView : true,
    pageType : "home",

    sentryPublicDsn : "https://9ba125d92cbf4e6d92f28364e8a4aae8@sentry.io/125686"

  }


  
        var visitType = 'landing';
    

  function shouldPassNaniganInfo(trueCb, falseCb) {
    window.criteo_call ? trueCb() : falseCb();
  }

  function naniganSuccess() {
    window.criteo_call();
  }

  function naniganFailure() {
    if (window.Raven && !window.isAdblocked) {
      window.Raven.captureMessage(
        'Nanigans segmentation failed after 10 tries',
        {
          level: 'warning',
        }
      );
    }
  }

  window.chewy = window.chewy || {};
  window.chewy.retry = function (functionToRetry, successCb, failureCb, maxTries, interval) {
    // Wrap original failure method in a function that keeps count
    function OnFailure() {
      if(--maxTries > 0) {
        setTimeout(function() {
          return functionToRetry(successCb, OnFailure);
        }, interval);
      } else {
        failureCb();
      }
    };
    // Make the first call
    setTimeout(function() {
      // Pass wrapped method isntead of original failure callback
      return functionToRetry(successCb, OnFailure);
    }, interval);
  };

  window.NaN_api = [
  [631990, ''],
    ['visit', visitType, 0]
  ];
  window.NaN_api.onsegment = function () {
    window.chewy.retry(shouldPassNaniganInfo, naniganSuccess, naniganFailure, 10, 500);
  };
  (function() {
    var s = document.createElement('script');
    s.async = true;
    s.src = '//cdn.nanigans.com/NaN_tracker.js';
    var h = document.getElementsByTagName('head')[0];
    h.appendChild(s);
  })();


    window.chewy = window.chewy || {};
    window.dataLayer = window.dataLayer || [];
    //JS var only used by GA
    window.chewy.pageType = 'home';
    window.chewy.userId = '-1002';
    window.chewy.environment = 'production'







        var ravenOptions = {
            ignoreErrors: [
                // Random plugins/extensions
                'top.GLOBALS',
                // See: http://blog.errorception.com/2012/03/tale-of-unfindable-js-error. html
                'originalCreateNotification',
                'canvas.contentDocument',
                'MyApp_RemoveAllHighlights',
                'http://tt.epicplay.com',
                'Can\'t find variable: ZiteReader',
                'jigsaw is not defined',
                'ComboSearch is not defined',
                'http://loading.retry.widdit.com/',
                'atomicFindClose',
                // Facebook borked
                'fb_xd_fragment',
                // ISP "optimizing" proxy - `Cache-Control: no-transform` seems to
                // reduce this. (thanks @acdha)
                // See http://stackoverflow.com/questions/4113268
                'bmi_SafeAddOnload',
                'EBCallBackMessageReceived',
                // See http://toolbar.conduit.com/Developer/HtmlAndGadget/Methods/JSInjection.aspx
                'conduitPage'
            ],
            ignoreUrls: [
                // Facebook flakiness
                /graph\.facebook\.com/i,
                // Facebook blocked
                /connect\.facebook\.net\/en_US\/all\.js/i,
                // Woopra flakiness
                /eatdifferent\.com\.woopra-ns\.com/i,
                /static\.woopra\.com\/js\/woopra\.js/i,
                // Chrome extensions
                /extensions\//i,
                /^chrome:\/\//i,
                // Other plugins
                /127\.0\.0\.1:4001\/isrunning/i,  // Cacaoweb
                /webappstoolbarba\.texthelp\.com\//i,
                /metrics\.itunes\.apple\.com\.edgesuite\.net\//i,
                // Kaspersky Labs
                /kaspersky-labs\.com/i,
                // triggers issues with phantomjs and catchpoint
                /sp\.analytics\.yahoo\.com/i,
                // SFW-3951
                /^\/signals\/config/i,
                /magiczoomplus\.js/i,
                /magiczoomplus\.5\.2\.4\.js/i
            ],
            shouldSendCallback: function(data) {

                // SFW-2540: non-issue error log affects only Chrome Mobile iOS on latest OS
                // Check that we are running Chrome Browser iOS, then look for the specific error.
                if(/CriOS/i.test(navigator.userAgent) && data.exception && data.exception.values){
                  // Consider being more specific and only targeting 10.3.x (' 10_3' )
                  for(var i = 0; i < data.exception.values.length; i++ ){
                    var e = data.exception.values[i];

                    if(e.type === 'SecurityError'
                       && e.value.indexOf('Blocked a frame with origin') !== -1
                       && e.value.indexOf('Protocols, domains, and ports must match.') !== -1){
                        return false;
                    }
                  }
                }

                //see SFW-1286
                //can probably remove now that we ignore sp.analytics.yahoo.com
                if(window.location.search.indexOf("catchpoint=true") !== -1 ){
                  return false;
                }

                return true;
            },
            
            // only send 10% of errors in production
            sampleRate: 0.1,
            
            serverName: 'iad1gsfw03.ecom.chewy.com',
            release: 'master-603',
            environment : 'production',
            tags: {
                viewType : 'desktop',
                pageType : 'home'
            },
            extra: {
                rid: '3ef847bf,03-5AD46E75-58D629A',
                cid: '-1002'
            }
        };

        Raven.config('https://9ba125d92cbf4e6d92f28364e8a4aae8@sentry.io/125686', ravenOptions).install();
        Raven.setUserContext({id: '-1002'});

    




    dataLayer.push({
        'viewType': 'desktop',
        'app_version': 'master-603',
        
        'pageType': 'home',
        
        'ecomm_pagetype':'home',

        
    });


    var lpTag = window.lpTag || {};
    lpTag.sdes = lpTag.sdes||[];

    lpTag.sdes.push({
        type: 'ctmrinfo',
        info: {
            customerId: '-1002',
            accountName: ''
        }
    });
    

window.lpTag=window.lpTag||{};if(typeof window.lpTag._tagCount==='undefined'){window.lpTag={site:'91373412'||'',section:lpTag.section||'',autoStart:lpTag.autoStart===false?false:true,ovr:lpTag.ovr||{},_v:'1.5.1',_tagCount:1,protocol:location.protocol,events:{bind:function(app,ev,fn){lpTag.defer(function(){lpTag.events.bind(app,ev,fn);},0);},trigger:function(app,ev,json){lpTag.defer(function(){lpTag.events.trigger(app,ev,json);},1);}},defer:function(fn,fnType){if(fnType==0){this._defB=this._defB||[];this._defB.push(fn);}else if(fnType==1){this._defT=this._defT||[];this._defT.push(fn);}else{this._defL=this._defL||[];this._defL.push(fn);}},load:function(src,chr,id){var t=this;setTimeout(function(){t._load(src,chr,id);},0);},_load:function(src,chr,id){var url=src;if(!src){url=this.protocol+'//'+((this.ovr&&this.ovr.domain)?this.ovr.domain:'lptag.liveperson.net')+'/tag/tag.js?site='+this.site;}var s=document.createElement('script');s.setAttribute('charset',chr?chr:'UTF-8');if(id){s.setAttribute('id',id);}s.setAttribute('src',url);document.getElementsByTagName('head').item(0).appendChild(s);},init:function(){this._timing=this._timing||{};this._timing.start=(new Date()).getTime();var that=this;if(window.attachEvent){window.attachEvent('onload',function(){that._domReady('domReady');});}else{window.addEventListener('DOMContentLoaded',function(){that._domReady('contReady');},false);window.addEventListener('load',function(){that._domReady('domReady');},false);}if(typeof(window._lptStop)=='undefined'){this.load();}},start:function(){this.autoStart=true;},_domReady:function(n){if(!this.isDom){this.isDom=true;this.events.trigger('LPT','DOM_READY',{t:n});}this._timing[n]=(new Date()).getTime();},vars:lpTag.vars||[],dbs:lpTag.dbs||[],ctn:lpTag.ctn||[],sdes:lpTag.sdes||[],ev:lpTag.ev||[]};lpTag.init();}else{window.lpTag._tagCount+=1;} 

    {
      "@context": "http://schema.org",
      "@type": "WebSite",
      "url": "http://www.chewy.com",
      "potentialAction": {
        "@type": "SearchAction",
        "target": "https://www.chewy.com/s?query={search_term_string}&src=searchbox_google&nav-submit-button=",
        "query-input": "required name=search_term_string"
      }
    }

(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
        new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
        j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
        '//www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
})(window,document,'script','dataLayer','GTM-5X325N');

    $(document).on('click', '.js-gtm-proceed-to-checkout-dynamic', function () {
        var productsArray = [];
        $('#gaCartDomParent .ga-eec__container').each(function (index, item) {
            productsArray.push(window.chewy.gaHelper.buildProductFieldObject(item));
        });


        dataLayer.push({
            'event': 'analyticsEvent',
            'eventCategory': 'eec',
            'eventAction': 'checkout',
            'ec:action': 'checkout',
            'eventLabel': undefined,
            'eventNonInt': true,
            'ecommerce': {
              'checkout': {
                'actionField': {
                  'step': 1
                },
                'products': productsArray
              }
            }
        });

    });


    (function(a){function b(c){if(d[c])return d[c].exports;var e=d[c]={i:c,l:!1,exports:{}};return a[c].call(e.exports,e,e.exports,b),e.l=!0,e.exports}var c=window.webpackJsonp;window.webpackJsonp=function(d,f,g){for(var h,j,k,l=0,i=[];l<d.length;l++)j=d[l],e[j]&&i.push(e[j][0]),e[j]=0;for(h in f)Object.prototype.hasOwnProperty.call(f,h)&&(a[h]=f[h]);for(c&&c(d,f,g);i.length;)i.shift()();if(g)for(l=0;l<g.length;l++)k=b(b.s=g[l]);return k};var d={},e={13:0};b.m=a,b.c=d,b.d=function(a,c,d){b.o(a,c)||Object.defineProperty(a,c,{configurable:!1,enumerable:!0,get:d})},b.n=function(a){var c=a&&a.__esModule?function(){return a["default"]}:function(){return a};return b.d(c,"a",c),c},b.o=function(a,b){return Object.prototype.hasOwnProperty.call(a,b)},b.p="/assets/js/packaged/",b.oe=function(a){throw console.error(a),a}})([]);
//# sourceMappingURL=webpack-runtime.932355eb89df528a9d9b.packaged.js.map




  Vue.config.productionTip = false;
  Vue.mixin({
              computed: {
                isMobile: function() {
                  return window.chewyConf.mobileView;
                },
                isDesktop: function() {
                  return window.chewyConf.desktopView;
                }
              }
            });








                
                window._wistiaIframeShim = true
            




            window.criteo_q = window.criteo_q || [];
            var deviceType = true;
            switch (deviceType) {
            case (/Android/.test(navigator.userAgent)) : deviceType = 'Android'; break; case (/iPhone/.test(navigator.userAgent)) : deviceType = 'iPhone'; break; case (/iPad/.test(navigator.userAgent)) : deviceType = 'iPad'; break; default : deviceType = 'desktop';}
            window.criteo_call = function() {
              window.criteo_q.push(
                { event: "setAccount", account: 5494},
                
                { event: "setData", ui_device: deviceType},
                
                { event: "setData", segment: window.NaN_api.segment },
                
                { event: "viewHome"}
              );
            }
        

  var gts = gts || [];

  gts.push(["id", "483342"]);
  gts.push(["badge_position", "USER_DEFINED"]);
  gts.push(["badge_container", "GTS_CONTAINER"]);
  gts.push(["locale", "en_US"]);
  
  gts.push(["google_base_country", "US"]);
  gts.push(["google_base_language", "en"]);

  (function() {
    var gts = document.createElement("script");
    gts.type = "text/javascript";
    gts.async = true;
    gts.src = "https://www.googlecommerce.com/trustedstores/api/js";
    var s = document.getElementsByTagName("script")[0];
    s.parentNode.insertBefore(gts, s);
  })();

(function(w,d,t,r,u){w[u]=w[u]||[];w[u].push({'projectId':'1000174518454','properties':{'pixelId':'437270'}});var s=d.createElement(t);s.src=r;s.async=true;s.onload=s.onreadystatechange=function(){var y,rs=this.readyState,c=w[u];if(rs&&rs!="complete"&&rs!="loaded"){return}try{y=YAHOO.ywa.I13N.fireBeacon;w[u]=[];w[u].push=function(p){y([p])};y(c)}catch(e){}};var scr=d.getElementsByTagName(t)[0],par=scr.parentNode;par.insertBefore(s,scr)})(window,document,"script","https://s.yimg.com/wi/ytc.js","dotq");

                  $(document).ready(function() {
                    $.publish('cwModal.launch', {target:'#referral'});
                    $('.js-changeUrl').on('click', function () {
                      var cleanURL = location.href.split("?")[0];
                      window.history.pushState(null, null, cleanURL);
                    });
                  });
                