var captureObject = new Object();
var serverUrl = document.location.protocol + '//' + location.host + '/airs/olae';

// ユーザエージェントを取得
var userAgent = String(navigator.userAgent);

// ブラウザ判定
var isIE = (navigator.appVersion.indexOf("MSIE") != -1);
var isMac = (navigator.appVersion.toLowerCase().indexOf("macintosh") != -1);
var isOpera = (userAgent.indexOf("Opera") != -1);
var isChrome = (userAgent.indexOf("Chrome") != -1);
var isAOL = (userAgent.indexOf("AOL") != -1) || (userAgent.indexOf("America Online Browser") != -1);

// Javascriptバージョン判定
var jsver = "";
if (jsver == "") {
    createScriptTag(2.2);
}
if (jsver == "") {
    createScriptTag(2.1);
}
if (jsver == "") {
    createScriptTag(2.0);
}
if (jsver == "") {
    createScriptTag(1.9);
}
if (jsver == "") {
    createScriptTag(1.8);
}
if (jsver == "") {
    createScriptTag(1.7);
}
if (jsver == "") {
    createScriptTag(1.6);
}
if (jsver == "") {
    createScriptTag(1.5);
}
if (jsver == "") {
    createScriptTag(1.4);
}
if (jsver == "") {
    createScriptTag(1.3);
}
if (jsver == "") {
    createScriptTag(1.2);
}
if (jsver == "") {
    createScriptTag(1.1);
}

/*---------------------------------------------------------
 * 全ての端末情報を取得
 *--------------------------------------------------------*/
function getMonitorTerminalInfo() {
    
	try {
	    // Javaが利用できる場合のみApplet実行の準備
		if (navigator.javaEnabled()) {
	        initApplet();
		} else {
			addValue("javaApplets", 0);
		    addValue("objectTag", 0);
		    addValue("appletTag", 0);
	    	addValue("fontCount", null);
	        //addValue("plugin01", null);
	        //addValue("plugin02", null);
	        addValue("javaVendor", null);
	        addValue("javaVersion", null);
	        addValue("osArch", null);
	        addValue("osName", null)
	        addValue("osVersion", null);
		}
	    // 筐体情報を取得
	    getMachineInfo();
	    // プラグイン情報を取得
	    getPluginInfo();
	    // ブラウザ情報を取得
	    getBrowserInfo();
	    // ネットワーク情報を取得
	    getNetworkInfo();
	} catch(e) {
	}
}

/*---------------------------------------------------------
 * 筐体情報を取得
 *--------------------------------------------------------*/
function getMachineInfo() {

    // mobileDevice,mobileName,platform,mobileTypeを取得
    isMobile();
    // gmtDiffを取得
    getGmtDiff();
    // colorDepth,displayXdpiactual,displayXdpilogical,displayYdpiactual,displayYdpilogical,fontCursiveInstalled,
    // fontDefaultInstalled,fontKingInstalled,fontPapyrusInstalled,fontCalibriInstalled,height,heightAvail,width,widthAvailを取得
    getScreenInfo();
    // servicepackを取得
    getServicePack();
    // timeZonediffを取得
    getTimeZoneDiff();
    // fontCountを取得
    getFontInfo();
    // winInstallerminverを取得
    getWinInstallerVersion();
    // platformを取得
    //getPlatform();（チューニング用）
}

/*---------------------------------------------------------
 * プラグイン情報を取得
 *--------------------------------------------------------*/
function getPluginInfo() {
    // activexControls,activexEnabledを取得
    getActiveXInfo();
    // director,directorVersionを取得
    getDirectorInfo();
    // flash,flashVersionを取得
    getFlashInfo();
    // acrobatVersionを取得
    getAcrobatInfo();
    // flip4macを取得
    getFlip4mac();
    // mediaplayer,mediaplayerVersionを取得
    getMediaplayerInfo();
    // silverlight,silverlightVersionを取得
    getSilverlightInfo();
    // citrixを取得
    getCitrix();
    // netmeetingBuildを取得
    getNetmeetingBuild();
    // svgviewerを取得
    getSvgviewer();
    // viewpointを取得
    getViewpoint();
    // quicktimeVersionを取得
    getQuicktimeVersion();
    // realplayerBuildを取得
    getRealplayerBuild();
    // nextGenerationJavapluginを取得
    getNextGenerationJavaplugin();
}

/*---------------------------------------------------------
 * ブラウザ情報を取得
 *--------------------------------------------------------*/
function getBrowserInfo() {
    // aolを取得
    isAol();
    // browser,minorVerlet,browserVersion,browserBuild,fullversionを取得
    getBrowserNameAndVersion();
    // dhtmlを取得
    getDhtml();
    // geckoを取得
    gecko();
    // geckoBuilddate,geckoBuilddateintを取得
    getGeckoBuildDate();
    // iframesを取得
    supportIframes();
    // javaEnabledを取得
    supportJava();
    // javascriptBuild,javascriptEnabled,javascriptVersionを取得
    getJavascriptInfo();
    // langUserを取得
    getLangInfo();
    // msxmlを取得
    supportMSXML();
    // persistentCookies,sessionCookiesを取得
    checkCookies();
    // referrerを取得
    existReferrer();
    // textSizeを取得
    getTextSize();
    // vbscript,vbscriptEnabledを取得
    getVbscript();
    // currencyTypeを取得（チューニング用）
    //getCurrencyType();
    // xmlを取得
    supportXML();
    // xmlhttprequestを取得
    supportXmlhttprequest();
    // canSendemailsを取得
    getCanSendemails();
    // containerContainerversion,containerBrowserfullversionを取得
    getContainerContainerversion();
    // containerBrowserを取得
    getContainerBrowserName();
    // fileuploadを取得
    supportFileupload();
    // fontColorを取得
    supportFontColor();
    // fontSizeを取得
    supoorFontSize();
    // framesを取得
    supportFrames();
    // imagesEnabledを取得
    supportImage();
    // stylesheetsを取得
    supportStylesheets();
    // supportsBoldを取得
    supportsBold();
    // supportsItalicを取得
    supportsItalic();
    // tableTagを取得
    supportTableTag();
    // tableBgcolorを取得
    supportTableBgcolor();
    // tableBgimageを取得
    supportTableBgimage();
    // objectTagactivexを取得
    supportObjectTagactivex();
    // objectTagを取得
    //supportObjectTag();
}

/*---------------------------------------------------------
 * ネットワーク情報を取得
 *--------------------------------------------------------*/
function getNetworkInfo() {
    // connectionTypeを取得
    getConnectionType();
    // sslEnabled
    getSslEnabled();
}

// モバイル判定
function isMobile() {
    MobileOSArray = new Array();
    MobileType = new Array();

    MobileType = [ "mobile", "Mobile", "Mobile", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "palm", "Palm", "Palm", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "symbian", "Symbian", "Symbian", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "nokia", "Nokia", "Nokia", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "webos", "WebOS", "WebOS", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "sonyericson", "Sonyericson", "Sonyericson", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "windows phone", "Windows Phone", "Windows Phone", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "smartphone", "Smartphone", "Smartphone", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "windows ce", "windows CE", "windows CE", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "alcatel", "Alcatel", "Alcatel", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "sonyeric", "Sonyeric", "Sonyeric", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "audiovox", "Audiovox", "Audiovox", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "sie-", "sie", "sie", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "lg-", " LG", " LG", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "sec-", "SEC", "SEC", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "rover", "Rover", "Rover", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "ericsson", "Ericsson", "Ericsson", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "sonyeric", "Sonyeric", "Sonyeric", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "ipaq", "ipaq", "ipaq", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "vodaphone", "Vodaphone", "Vodaphone", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "motorola", "Motorola", "Motorola", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "mot-", "Motorola", "Motorola", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "blackberry", "Black Berry", "Black Berry", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "black berry", "Black Berry", "Black Berry", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "android", "Android", "Android", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "iphone", "iPhone", "iPhone", "Phone" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "ipad", "iPad", "iPad", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "itouch", "iTouch", "iTouch", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "Playbook", "RIM Tablet", "RIM Tablet OS", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "SCH-I800", "Samsung Galaxy Tablet", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "GT-P1000", "Samsung Galaxy Tablet", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "SGH-T849", "Samsung Galaxy Tablet", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "GT-I9000T", "Samsung Galaxy Tablet", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "SHW-M180S", "Samsung Galaxy Tablet", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "Xoom|Android", "Motorola Xoom Tablet", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "Kindle", "Amazon Kindle", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "Silk", "Amazon Kindle", "Android", "Tablet" ];
    MobileOSArray.push(MobileType);

    MobileType = [ "Tablet PC", "Tablet PC", "Tablet PC", "Tablet" ];
    MobileOSArray.push(MobileType);

    var found = false;
    var notfound = true;
    var ualist;

    for ( var i = MobileOSArray.length - 1; i >= 0; i--) {
        ualist = MobileOSArray[i][0].toLowerCase().split("|");
        notfound = false;
        for (k = 0; k < ualist.length; k++) {
            if (userAgent.toLowerCase().indexOf(ualist[k]) == -1) {
                notfound = true;
                break;
            }
        }
        if (notfound == false) {
            found = true;
        }

        if (found == true) {
            break;
        }
    }

    if (found == true) {
        addValue("mobileDevice", 1);
        addValue("mobileName", MobileOSArray[i][1]);
        addValue("platform", MobileOSArray[i][2]);
        addValue("mobileType", MobileOSArray[i][3]);
    } else if ((screen.width < 800) || (screen.height < 600)) {
        addValue("mobileDevice", 1);
        addValue("mobileName", null);
        addValue("platform", null);
        addValue("mobileType", null);
    } else {
        addValue("mobileDevice", 0);
        addValue("mobileName", null);
        addValue("platform", null);
        addValue("mobileType", null);
    }
}

// GMTとクライアントＰＣの日付の差異を取得
function getGmtDiff() {
    var date = new Date();
    addValue("gmtDiff", date.getTimezoneOffset());
}

// ディスプレイに関連する情報を取得
function getScreenInfo() {
    addValue("colorDepth", screen.colorDepth);
    addValue("displayXdpiactual", ((isIE) ? screen.deviceXDPI : null));
    addValue("displayXdpilogical", ((isIE) ? screen.logicalXDPI : null));
    addValue("displayYdpiactual", ((isIE) ? screen.deviceYDPI : null));
    addValue("displayYdpilogical", ((isIE) ? screen.logicalYDPI : null));
    addValue("height", screen.height);
    addValue("heightAvail", screen.availHeight);
    addValue("width", screen.width);
    addValue("widthAvail", screen.availWidth);
}

// サービスパックの有無を取得
function getServicePack() {
    var servicepack = 0;
    if (navigator.appMinorVersion) {
        servicepack = navigator.appMinorVersion;
    }
    addValue("servicepack" , servicepack == 0 ? null : servicepack);
}

// タイムゾーンの差を取得
function getTimeZoneDiff() {
    var d = new Date()
    var diff = (-d.getTimezoneOffset() / 60);
    if (isNaN(diff)) {
        ver = 0;
    }
    addValue("timeZonediff", diff);
}

function initApplet() {

    if (!isMac) {
        getAppletInfo();
    } else {
        // Appletのデータ反映のため遅延実行
        setTimeout("getAppletInfo()", 800);
    }
}

// Appletでマシン情報を取得（遅延実行）
function getAppletInfo() {

	var appletEnabled = false;

	try {
		if(document.olaeApplet) {
			appletEnabled = true;
		}
	} catch(e) {
	}
	
	if (appletEnabled) {
        addValue("javaApplets", 1);
        addValue("objectTag", 1);
	} else {
		addValue("javaApplets", 0);
	    addValue("objectTag", 0);
	}

	var appletLoadCheck = false;
	try {
		if(document.olaeApplet.osArch) {
			appletLoadCheck = true;
		}
	} catch(e) {
	}

    if (appletLoadCheck) {
    	addValue("appletTag", 1);
        addValue("fontCount", document.olaeApplet.fontCount);
        //addValue("plugin01", document.olaeApplet.allFontCount);
        //addValue("plugin02", document.olaeApplet.locale);
        addValue("javaVendor", document.olaeApplet.javaVendor);
        addValue("javaVersion", document.olaeApplet.javaVersion);
        addValue("osArch", document.olaeApplet.osArch);
        addValue("osName", document.olaeApplet.osName);
        addValue("osVersion", document.olaeApplet.osVersion);

    } else {
        addValue("appletTag", 0);
    	addValue("fontCount", null);
        //addValue("plugin01", null);
        //addValue("plugin02", null);
        addValue("javaVendor", null);
        addValue("javaVersion", null);
        addValue("osArch", null);
        addValue("osName", null)
        addValue("osVersion", null);
    }
}

// OS種別を取得（チューニング用）
/*
function getOS() {
    MultiArray = new Array();

    MultiArray[0] = new Array(2);
    MultiArray[0][0] = "iPhone";
    MultiArray[0][1] = "iPhone";

    MultiArray[1] = new Array(2);
    MultiArray[1][0] = "Andriod";
    MultiArray[1][1] = "Andriod";

    MultiArray[2] = new Array(2);
    MultiArray[2][0] = "Black Berry";
    MultiArray[2][1] = "Black Berry";

    MultiArray[3] = new Array(2);
    MultiArray[3][0] = "Windows CE";
    MultiArray[3][1] = "Windows CE";

    MultiArray[4] = new Array(2);
    MultiArray[4][0] = "OpenBSD";
    MultiArray[4][1] = "Open BSD";

    MultiArray[5] = new Array(2);
    MultiArray[5][0] = "SunOS";
    MultiArray[5][1] = "Sun OS";

    MultiArray[6] = new Array(2);
    MultiArray[6][0] = "Linux";
    MultiArray[6][1] = "Linux";

    MultiArray[7] = new Array(2);
    MultiArray[7][0] = "X11";
    MultiArray[7][1] = "Linux";

    MultiArray[8] = new Array(2);
    MultiArray[8][0] = "QNX";
    MultiArray[8][1] = "QNX";

    MultiArray[9] = new Array(2);
    MultiArray[9][0] = "BeOS";
    MultiArray[9][1] = "BeOS";

    MultiArray[10] = new Array(2);
    MultiArray[10][0] = "OS/2";
    MultiArray[10][1] = "OS/2";
    
    MultiArray[11] = new Array(2);
    MultiArray[11][0] = "Mac_PowerPC";
    MultiArray[11][1] = "Mac OS";

    MultiArray[12] = new Array(2);
    MultiArray[12][0] = "Macintosh";
    MultiArray[12][1] = "MacOSX";

    MultiArray[13] = new Array(2);
    MultiArray[13][0] = "Win16";
    MultiArray[13][1] = "Windows 3.11";

    MultiArray[14] = new Array(2);
    MultiArray[14][0] = "Windows NT 4.0";
    MultiArray[14][1] = "Windows NT 4.0";

    MultiArray[15] = new Array(2);
    MultiArray[15][0] = "WinNT4.0";
    MultiArray[15][1] = "Windows NT 4.0";

    MultiArray[16] = new Array(2);
    MultiArray[16][0] = "WinNT";
    MultiArray[16][1] = "Windows NT 4.0";

    MultiArray[17] = new Array(2);
    MultiArray[17][0] = "Windows NT";
    MultiArray[17][1] = "Windows NT 4.0";

    MultiArray[18] = new Array(2);
    MultiArray[18][0] = "Windows 95";
    MultiArray[18][1] = "Windows 95";

    MultiArray[19] = new Array(2);
    MultiArray[19][0] = "Win95";
    MultiArray[19][1] = "Windows 95";

    MultiArray[20] = new Array(2);
    MultiArray[20][0] = "Windows_95";
    MultiArray[20][1] = "Windows 95";

    MultiArray[21] = new Array(2);
    MultiArray[21][0] = "Windows 98";
    MultiArray[21][1] = "Windows 98";

    MultiArray[22] = new Array(2);
    MultiArray[22][0] = "Win98";
    MultiArray[22][1] = "Windows 98";

    MultiArray[23] = new Array(2);
    MultiArray[23][0] = "Windows ME";
    MultiArray[23][1] = "Windows ME";

    MultiArray[24] = new Array(2);
    MultiArray[24][0] = "Windows NT 5.0";
    MultiArray[24][1] = "Windows 2000";

    MultiArray[25] = new Array(2);
    MultiArray[25][0] = "Windows NT 5.01";
    MultiArray[25][1] = "Windows 2000";

    MultiArray[26] = new Array(2);
    MultiArray[26][0] = "Windows 2000";
    MultiArray[26][1] = "Windows 2000";

    MultiArray[27] = new Array(2);
    MultiArray[27][0] = "Windows NT 5.2";
    MultiArray[27][1] = "Windows Server 2003";

    MultiArray[28] = new Array(2);
    MultiArray[28][0] = "Windows XP";
    MultiArray[28][1] = "WinXP";

    MultiArray[29] = new Array(2);
    MultiArray[29][0] = "Windows NT 5.1";
    MultiArray[29][1] = "WinXP";

    MultiArray[30] = new Array(2);
    MultiArray[30][0] = "Windows NT 6.0";
    MultiArray[30][1] = "Windows Vista";

    MultiArray[31] = new Array(2);
    MultiArray[31][0] = "Windows NT 6.1";
    MultiArray[31][1] = "Windows 7";

    MultiArray[32] = new Array(2);
    MultiArray[32][0] = "Windows NT 7.0";
    MultiArray[32][1] = "Windows 7";

    MultiArray[33] = new Array(2);
    MultiArray[33][0] = "Windows NT 6.2";
    MultiArray[33][1] = "Windows 8";	

    var OS = "0";

    for (i = MultiArray.length-1; i >= 0; i--) {
        if (userAgent.indexOf(MultiArray[i][0]) != -1) {
            OS = MultiArray[i][1];
            break;
        }
    }
    return OS;
}
*/
// フォント情報を取得
function getFontInfo() {

    var fontObject = new Object();
    fontObject.fontinstalled = function(fontname) {
        var fd = new FontDetector();
        return fd.test(fontname);
    }

    addValue("fontCursiveInstalled", fontObject.fontinstalled("cursive") ? 1 : 0);
    addValue("fontDefaultInstalled", fontObject.fontinstalled("default") ? 1 : 0);
    addValue("fontKingInstalled", fontObject.fontinstalled("King") ? 1 : 0);
    addValue("fontPapyrusInstalled", fontObject.fontinstalled("Papyrus") ? 1 : 0);
    addValue("fontCalibriInstalled", fontObject.fontinstalled("calibri") ? 1 : 0);
    addValue("fontSmoothing", screen.fontSmoothingEnabled ? 1 : 0);
}

// WindowsInstallerのマイナーバージョン
function getWinInstallerVersion() {
    var version = "0";
    try {
        if (window.ActiveXObject) {
            var control = new ActiveXObject("windowsinstaller.installer");
            if (control) {
                version = control.Version;
            }
        } else {
            addValue("winInstallerminver", null);
            return;
        }
    } catch (e) {
    }
    if (version.length > 1) {
        version = version.substring(version.indexOf(".") + 1);
        var i = version.indexOf(".");
        if (i != -1) {
            version = version.substring(0, i);
        }
    }
    addValue("winInstallerminver", isNaN(version) ? null : version);
}

// プラットフォームを取得
function getPlatform() {
	if(document.getElementById("platform").value == "") {
		addValue("platform", navigator.platform);
	}
}

// ActiveX関連情報を取得
function getActiveXInfo() {
    result = false;
    if(window.ActiveXObject) {
        result = true;
    }
    addValue("activexControls", result ? 1 : 0);
    addValue("activexEnabled", result ? 1 : 0);
}

// Shockwaveプラグインの有無
function getDirectorInfo() {

    var tMajorVersion = 15;
    var tMinorVersion = 1;
    var tShockwaveFound = 0;

    if (!isIE && navigator.mimeTypes && 
        navigator.mimeTypes["application/x-director"] && 
        navigator.mimeTypes["application/x-director"].enabledPlugin) {
        if (navigator.plugins && navigator.plugins["Shockwave for Director"] && 
            (tVersionIndex = navigator.plugins["Shockwave for Director"].description.indexOf(".")) != - 1) {

            var tMajorVersionString = navigator.plugins["Shockwave for Director"].description.substring(tVersionIndex-2, tVersionIndex);
            var tMinorVersionString = navigator.plugins["Shockwave for Director"].description.substring(tVersionIndex+1, tVersionIndex+2);
            if (parseInt(tMajorVersionString) > tMajorVersion) {
                tShockwaveFound = 1;
            } else if (parseInt(tMajorVersionString) == tMajorVersion) {
                if (parseInt(tMinorVersionString) >= tMinorVersion) {
                    tShockwaveFound = 1;
                }
            }
        }
    } else if (isIE) {
        for (var i = 12; i > 1; i--) {
            try {
                var obj = new ActiveXObject("SWCtl.SWCtl." + i);
                tMajorVersionString = i;
                tMinorVersionString = 0;
                tShockwaveFound = 1;
                break;
            } catch(e) {
            }
        }
    }
    if (tMajorVersionString != undefined) {
        addValue("director", 1);
        addValue("directorVersion", tMajorVersionString + "." + tMinorVersionString);
    } else {
        addValue("director", 0);
        addValue("directorVersion", null);
    }
}

// Flash関連情報を取得
function getFlashInfo() {
	var flashplayer_ver = null;
    if(navigator.plugins && navigator.mimeTypes['application/x-shockwave-flash']) {
        var plugin = navigator.mimeTypes["application/x-shockwave-flash"].enabledPlugin;
        if(plugin) {
            flashplayer_ver = parseInt(plugin.description.match(/\d+\.\d+/));
        }
    } else {
    	var flashObj = document.getElementById("olaeFls");
    	if (!flashObj) {
    		addValue("flash", 0);
    		addValue("flashVersion", null);
    	}
    	return;
    }
	addValue("flash", flashplayer_ver ? 1 : 0);
	addValue("flashVersion", flashplayer_ver ? flashplayer_ver : null);
}

// Flashのバージョンを設定(ActionScriptから呼び出す)
function SetFlashVersion(str) {
	if (str) {
		str = str.substring(str.indexOf(' ') + 1, str.indexOf(','));
	}
	addValue("flash", 1);
	addValue("flashVersion", str);
}

// AdobeReader関連情報を取得
function getAcrobatInfo() {
    version = $pObject.adobereader.getVersion();
    addValue("acrobat", version ? 1 : 0);
    addValue("acrobatVersion", version ? version : null);
}

// Flip4macのインストール有無を取得
function getFlip4mac() {
    var isInstalled = false;
    if (!isIE) {
        try {
            if (canDetectNavigatorPlugins()) {
                isInstalled = detectPlugin("Flip4Mac");
            }
        } catch (e) {
            isInstalled = false;
        }
    }

    addValue("flip4mac", isInstalled ? 1 : 0);
}

// WindowsMediaPlayer関連情報を取得
function getMediaplayerInfo() {
    var isInstalled = false;
    var version = 0;
	var tset = "";
    
    try {
        if (canDetectNavigatorPlugins()) {
        	
            isInstalled = detectPlugin('Media Player');
        }else {
            if (window.ActiveXObject) {
                var control = null;
                try {
                    control = new ActiveXObject('WMPlayer.OCX');
                } catch (e) {
                    version = 0;
                }
                if (control) {
                    isInstalled = true;
                    version = control.versionInfo;
                }
            }
        }
    } catch (e) {
        isInstalled = false; 
        version = 0;
    }
    addValue("mediaplayer", isInstalled ? 1 : 0);
    addValue("mediaplayerVersion", version ? version : null);
}

//Silverlightバージョンを取得(IE以外)
function getSilverlightInfo() {
    var version = 0;
    try {
        if (!isIE) {
            var plugin = navigator.plugins["Silverlight Plug-In"];
            version = plugin.description.substring(0, 3);
        } else {
			version = $pObject.silverlight.getVersion();
        }
    } catch (e) {
        addValue("silverlight", 0);
        addValue("silverlightVersion", null);
    }
    addValue("silverlight", version != 0 ? 1 : 0);
    addValue("silverlightVersion", version != 0 ? version : null);
}

function GetPlugin(sender, id) {
    var result = null;
    try {

        result = document.getElementById(id);
        if (result) {
            return result;
        }

        result = sender.getHost();
        if (result) {
            return result;
        }
    }
    catch (e) {
    }
    return result;
}

// Citrix関連情報を取得
function getCitrix() {
    var isInstalled = false;
    try {
        if (canDetectNavigatorPlugins()) {
            isInstalled = detectPlugin('Citrix ICA Client');
        } else {
            if (window.ActiveXObject) {
                var control = null;
                try {
                    control = new ActiveXObject('Citrix.ICAClient');
                } catch (e) {
                }
                if (control) {
                    isInstalled = true;
                }
            }
        }
    } catch (e) { 
        isInstalled = false; 
    }
    addValue("citrix", (isInstalled) ? 1 : 0);
}

// NetMeetingBuild関連情報を取得
function getNetmeetingBuild() {
    var build = 0;
    
    if (isIE) {
        try {
            var body1 = document.getElementsByTagName("body");
            if (body1[0].style.behavior == '' || body1[0].style.behavior == null)
                body1[0].style.behavior = "url(#default#clientCaps)";
            build = body1[0].getComponentVersion("{44BBA842-CC51-11CF-AAFA-00AA00B6015B}", "ComponentID");
            if (build == '' || build == undefined)
                build = 0;
        } catch (Error) {
            build = 0;
        }
    }
    addValue("netmeetingBuild", (build == 0) ? null : build.substring(0, 1));
}

// SvgViewer関連情報を取得
function getSvgviewer() {
    var isInstalled = false;
    try {
        if (canDetectNavigatorPlugins()) {
            isInstalled = detectPlugin("Adobe SVG Viewer");
        }
        else {
            if (window.ActiveXObject) {
                var control = null;
                try {
                    control = new ActiveXObject('Adobe.SVGCtl');
                } catch (e) {
                }
                if (control) {
                    isInstalled = true;
                }
            }
        }
    } catch (e) {
        isInstalled = false;
    }
    addValue("svgviewer", (isInstalled) ? 1 : 0);
}

// ViewPoint関連情報を取得
function getViewpoint() {
    var isInstalled = false;
    try {
        if (canDetectNavigatorPlugins()) {
            isInstalled = detectPlugin('Viewpoint');
        } else {
        	try {
        		var control = new ActiveXObject('AxMetaStream.MetaStreamCtl');
        		isInstalled = true;
        	} catch(e) {
        	}
        	
        }
    } catch (e) {
        isInstalled = false;
    }
    addValue("viewpoint", (isInstalled) ? 1 : 0);
}

// QuickTimeのバージョンを取得
function getQuicktimeVersion() {
    version = $pObject.quicktime.getVersion();
    addValue("quicktime", version ? 1 : 0);
    addValue("quicktimeVersion", version ? version : null);
}

// RealPlayerのビルドバージョンを取得
function getRealplayerBuild() {
    var build = 0;
    try {
        if (detectRealPlayer()) {
            if (canDetectNavigatorPlugins()) {
                if (navigator.plugins["RealPlayer Version Plugin"] != undefined) {
                    build = navigator.plugins["RealPlayer Version Plugin"].description;
                }
            }
            else {
                if (window.ActiveXObject) {
                    var control = null;
                    var definedControls = [
                'rmocx.RealPlayer G2 Control',
                'rmocx.RealPlayer G2 Control.1',
                'RealPlayer.RealPlayer(tm) ActiveX Control (32-bit)',
                'RealVideo.RealVideo(tm) ActiveX Control (32-bit)',
                'RealPlayer'
                ];
                    for (var i = 0; i < definedControls.length; i++) {
                        try {
                            control = new ActiveXObject(definedControls[i])
                            if (control) {
                                build = control.GetVersionInfo();
                                break;
                            }
                        } catch (e) { continue; }
                    }
                }
            }
        }
    } catch (e) {
        build = 0;
    }
    addValue("realplayer", build || build != 0 ? 1 : 0);
    addValue("realplayerBuild", build || build != 0 ? build : null);
}

// JavaPlugin関連情報を取得
function getNextGenerationJavaplugin() {

	/*
    var existFlag = false;
    if (!isIE) {
        for(var i in navigator.plugins){
            if((/Next.*Generation.*Java.*Plug-in/i).test(navigator.plugins[i].description)) {
                existFlag = true;
                break;
            }
        }
    } else {
        if (($pObject.java.isPlugin2 == null || $pObject.java.isPlugin2 == undefined) ? -2 : $pObject.java.isPlugin2) {
            existFlag = true;
        }
    }
    addValue("nextGenerationJavaplugin", existFlag ? 1 : 0);
    */
    addValue("nextGenerationJavaplugin", 0);
    
}

// RealPlayerのインストール有無をチェック
function detectRealPlayer() {
    var isInstalled = false;
    try {
        if (canDetectNavigatorPlugins()) {
            isInstalled = detectPlugin('RealPlayer');
        }
        else {
            if (window.ActiveXObject) {
                var control = null;
                var definedControls = [
                'rmocx.RealPlayer G2 Control',
                'rmocx.RealPlayer G2 Control.1',
                'RealPlayer.RealPlayer(tm) ActiveX Control (32-bit)',
                'RealVideo.RealVideo(tm) ActiveX Control (32-bit)',
                'RealPlayer'
                ];
                for (var i = 0; i < definedControls.length; i++) {
                    try {
                        control = new ActiveXObject(definedControls[i])
                        if (control) {
                            isInstalled = true;
                            break;
                        }
                    } catch (e) { continue; }
                }
            }
        }
    } catch (e) {
        isInstalled = false;
    }
    return (isInstalled) ? 1 : 0;

}

// AOL関連情報を取得
function isAol() {
    version = 0;
    if (isAOL) {
        try {
            version = userAgent;
            version = version.substring(version.indexOf("AOL") + 4);
            if (version) {
                version = version.substring(version.indexOf("America Online Browser") + 23);
            }
            version = version.substring(0, version.indexOf(";"));
        } catch(e) {
            version = 0;
        }
    }
    addValue("aol", isAOL ? 1 : 0);
    addValue("aolVersion", version == 0 ? null : version);
}

// ブラウザ関連情報を取得
function getBrowserNameAndVersion() {
    var elements = 1000;
    var regexps = {
        'Maxthon': [/Maxthon\/(\S+)/],
        'Chrome': [/Chrome\/(\S+)/],
        'Safari': [/Version\/(\S+).*?Safari/],
        'IE': [/MSIE (\S+);/],
        'Opera': [
                /Opera\/.*?Version\/(\S+)/,
                /Opera\/(\S+)/,
                /Opera (\S+)/
            ],
        'Firefox': [/Firefox\/(\S+)/]
    }, re, m, browser, version;
    var BrowserObj = new Object;
    BrowserObj.Browser = "0";
    BrowserObj.FullVersion = "0";
    BrowserObj.MinorVersion = "0";
    BrowserObj.MajorVersion = "0";
    BrowserObj.Minorverlet  = "0";
    BrowserObj.Version = "";
    for (browser in regexps) {
        while (re = regexps[browser].shift()) {
            if (m = userAgent.match(re)) {
                version = (m[1].match(new RegExp('[^.]+(?:\.[^.]+){0,' + --elements + '}')))[0];
                BrowserObj.Browser = browser;
                BrowserObj.FullVersion = version;

                var versionArray = version.split(".");
                BrowserObj.MinorVersion = (versionArray[1].replace(/[^0-9]/g, ''));
                BrowserObj.MajorVersion = (versionArray[0].replace(/[^0-9]/g, ''));
                BrowserObj.Version = (versionArray[0].replace(/[^0-9]/g, '')) + "." + (versionArray[1].replace(/[^0-9]/g, ''));
                BrowserObj.Minorverlet = String((versionArray[1].replace(/[0-9]/g, ''))).substring (0,1);
                break;
            }
        }
    }
    addValue("browser", BrowserObj.Browser ? BrowserObj.Browser : null);
    addValue("minorverlet", BrowserObj.Minorverlet ? BrowserObj.Minorverlet : null);
    addValue("browserVersion", BrowserObj.Version ? BrowserObj.Version : null);
    addValue("fullversion", BrowserObj.FullVersion ? BrowserObj.FullVersion : null);
    addValue("majorVer", BrowserObj.MajorVersion ? BrowserObj.MajorVersion : null);
    if (isIE) {
    	addValue("minorVer", navigator.appMinorVersion != 0 ? navigator.appMinorVersion : null);
    } else {
    	addValue("minorVer", BrowserObj.MinorVersion != 0 ? BrowserObj.MinorVersion : null);
    }
    var buildVersion = getBrowserBuild();
    addValue("browserBuild", buildVersion != 0 ? buildVersion : null);
}

// ブラウザのビルドバージョンを取得
function getBrowserBuild() {
    var build = 0;

    if (isIE) {
        try {
            var body = document.getElementsByTagName("body");
            body[0].style.behavior = "url(#default#clientCaps)";
            build = body[0].getComponentVersion("{89820200-ECBD-11CF-8B85-00AA005B4383}", "ComponentID");
            if (build == '' || build == undefined)
                build = 0;
        } catch (Error) {
            build = 0;
        }
    }
    if (build == 0)
        return 0;
    else
        return String(build).replace(/,/gi, ".");
}

// DHTML関連情報を取得
function getDhtml() {
    var support = false;
    try {
        if (document.getElementById || document.all || document.layers || document.createElement) {
            support = true;
        }
    } catch (e) {
        support = false;
    }
    addValue("dhtml", support ? 1 : 0);
}

// Geckoの有無
function gecko() {
    var gecko = false;
    if (navigator.product) {
        if (navigator.product == 'Gecko') {
            gecko = true;
        }
    }
    addValue("gecko", gecko ? 1 : 0);
}

// Geckoのビルド日付
function getGeckoBuildDate() {
    var geckoBuildDate = "0";
    if (detectGecko()) {
        var buildID = navigator.buildID;
        if (!isNaN(buildID)) {
            var year = String(buildID).substring(0, 4);
            var month = String(buildID).substring(4, 6);
            var day = String(buildID).substring(6, 8);
            var hours = String(buildID).substring(8, 10);
            var minutes = String(buildID).substring(10, 12);
            var seconds = String(buildID).substring(12, 14);
            geckoBuildDate = month + "/" + day + "/" + year + " " + hours + ":" + minutes + ":" + seconds;
        }
    }
    addValue("geckoBuilddate", geckoBuildDate != 0 ? geckoBuildDate : null);
    
    if (buildID) {
    	var builddateint = String(buildID).replace("'", "");
        addValue("geckoBuilddateint", builddateint != 0 ? builddateint : null);
    } else {
    	addValue("geckoBuilddateint", null);
    }
}

function getGeckoBuildDateToInt() {
    var geckoBuildDate = "0";

    if (detectGecko()) {

        geckoBuildDate = navigator.buildID;
        if (isNaN(geckoBuildDate)) {		// 09/29/10 - mdel - added undefined
											// check for safari
            geckoBuildDate = "0";
        }
    }

    return String(geckoBuildDate).replace("'", "");
}

// Geckoチェック
function detectGecko() {
    var gecko = false;

    if (navigator.product) {
        if (navigator.product == 'Gecko') {
            gecko = true;
        }
    }
    return gecko;
}

// iFrameのサポート有無を取得
function supportIframes() {
    var e = document.createElement("iframe");
    var iframes = 0;
    try {
        if (e) {
            iframes = 1;
        }
    }
    catch (Error) {
    }
    addValue("iframes", iframes);
}


// Javaのサポート有無を取得
function supportJava() {
    addValue("javaEnabled", navigator.javaEnabled() ? 1 : 0);
}

// Javascriptのバージョンを取得
function getJavascriptVersion() {

    if (isNaN(jsver) || jsver == "") {
        jsver = null;
    }
    return jsver;
}

// Javascript関連情報を取得
function getJavascriptInfo() {
    var jsb = 0;
    if (isIE) {
        try {
            jsb = ScriptEngineMajorVersion() + "." + ScriptEngineMinorVersion() + "." + ScriptEngineBuildVersion();
        } catch (e) {
            jsb = 0;
        }
    }
    addValue("javascriptBuild", jsb);
    addValue("javascriptEnabled", 1);
    addValue("javascriptVersion", getJavascriptVersion());
}

// ブラウザの利用言語を取得
function getLangInfo() {
    var lang = '';
    if (navigator.userLanguage) {
        lang = navigator.userLanguage;
    } else if (navigator.language) {
        lang = navigator.language;
    }
    addValue("langUser", lang);
    if (navigator.systemLanguage) {
        lang = navigator.systemLanguage;
    } else {
        lang = 0;
    }

    addValue("langSystem", lang != 0 ? lang : null);
}

// MSXMLサポート有無を取得
function supportMSXML() {
    var support = 0;
    if (isIE) {
        var progIDs = ['Msxml2.DOMDocument.6.0', 'Msxml2.DOMDocument.5.0', 'Msxml2.DOMDocument.4.0', 'Msxml2.DOMDocument.3.0'];
        for (var i = 0; i < progIDs.length; i++) {
            try {
                var xmlDOM = new ActiveXObject(progIDs[i]);
                break;
            }
            catch (ex) {
            }
        }
        switch (i) {
            case 0:
                support = 6;
                break;
            case 1:
                support = 5;
                break;
            case 2:
                support = 4;
                break;
            case 3:
                support = 3;
                break;
            case 4:
                support = 2;
                break;
            case 5:
                support = 1;
                break;
            default: support = null;
        }
    }
    addValue("msxml", support);
}

// Cookie利用可否を取得
function checkCookies() {
    var cookieValue = 0;
    setCookie('olae', 'it works', '', '/', '', '');
    if (getCookie('olae')) {
        cookieValue = 1;
    }
    addValue("persistentCookies", cookieValue);
    addValue("sessionCookies" , cookieValue);
}

// リファラーの存在有無を取得
function existReferrer() {
    addValue("referrer", ((document.referrer == '') ? 0 : 1));
}

// テキストボックスのデフォルトサイズを取得
function getTextSize() {
    var divIdName = 'olaeTestInput';
    var type = 'text';
    var text = 'test text size';
    var size = 0;
    try {
        var newdiv = document.createElement('input');
        newdiv.setAttribute('type', type);
        newdiv.setAttribute('id', divIdName);
        newdiv.setAttribute('outerText', text);
        size = newdiv.size;
    }
    catch (e) {
        size = 0;
    }
    addValue("textSize", size == 0 ? null : size);
}

// VBScriptの利用可否を取得
function getVbscript() {
    var version = '0';
    if (isIE) {
        try {
            version = GetVbscriptEnabled();
        } catch(e) {
        }
    }
    addValue("vbscript", version != '0' ? 1 : 0);
    addValue("vbscriptEnabled", version != '0' ? 1 : 0);
}

// デフォルト通貨を取得（チューニング用）
/*
function getCurrencyType() {
	var currencyType = null;
	if (isIE) {
		try {
			currencyType = CurrencyType();
		}catch(e) {
		}
	}
	addValue("plugin03", currencyType != null ? currencyType : null);
}
*/
// XMLのサポート状況を取得
function supportXML() {
    var support = false;
    try {
        if (window.ActiveXObject) {
            try {
                var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
                if (xmlDoc) {
                    support = true;
                }
            } catch (Error) {
                support = false;
            }
        } else if (document.implementation && document.implementation.createDocument) {
            var xmlDoc = document.implementation.hasFeature("XML", null);
            support = true;
        }
    } catch (Error) {
        support = false;
    }
    addValue("xml", support ? 1 : 0);
}

// 非同期通信の利用可否を取得
function supportXmlhttprequest() {
    var support = false;
    try {
        if (XMLHttpRequest) {
            support = true;
        }
    } catch (Error) {
        support = false;
    }
    addValue("xmlhttprequest", support ? 1 : 0);
}

// Mailが送信可否を取得
function getCanSendemails() {
    var emailFlag = false;
    try {
        var form = document.createElement("FORM");
        form.id = 'mailform';
        form.action = 'mailto:null';
        form.method = 'get';
        if (form) {
            emailFlag = true;
        }
    } catch(e) {
    }
    addValue("canSendemails", emailFlag ? 1 : 0);
}

// コンテナのバージョンを取得
function getContainerContainerversion() {
    var ContainerBrowserVersion = getContainerFullVersion();

    addValue("containerBrowserfullversion", ContainerBrowserVersion == "0" ? null : ContainerBrowserVersion);

    if (ContainerBrowserVersion == "0") {
        addValue("containerContainerversion", null);
    } else {
        var versions = String(ContainerBrowserVersion).split(".");
        addValue("containerContainerversion", versions ? versions[0] + "." + versions[1] : null);
    }
}

// コンテナ名を取得
function getContainerBrowserName() {
    var browserName = getContainerBrowser();
    addValue("containerBrowser", browserName == 0 ? null : browserName);
}

// コンテナのフルバージョンを取得
function getContainerFullVersion() {
    var ContainerBrowserType = getContainerBrowser();
    var ContainerBrowserFullVersion = "0";
    if (ContainerBrowserType == "0") {
        return "0";
    } else {
        var version = userAgent.substring(userAgent.indexOf(ContainerBrowserType) + ContainerBrowserType.length + 1);
        if (version.indexOf(" ") == -1) {
            ContainerBrowserFullVersion = version;
        } else {
            ContainerBrowserFullVersion = version.substr(0, version.indexOf(" "));
            return ContainerBrowserFullVersion;
        }
    }
}

// コンテナを取得
function getContainerBrowser() {
    var ContainerBrowserTypes = new Array("Windows-Media-Player");
    var ContainerBrowserType = "0";
    for (var i = 0; i < ContainerBrowserTypes.length; i++) {
        if (userAgent.indexOf(ContainerBrowserTypes[i]) != -1) {
            ContainerBrowserType = ContainerBrowserTypes[i];
            break;
        }
    }
    return ContainerBrowserType;
}

// ファイルアップロードが可能か
function supportFileupload() {
    var uploadFile = true;
    var input = document.createElement("input");
    input.setAttribute("type", "file");
    input.setAttribute("name", "isUploadTest");

    if (!input) {
        uploadFile = false;
    }
    addValue("fileupload", uploadFile ? 1 : 0);
}

// フォントの色が変更できるか
function supportFontColor() {
    
    var fontColor = true;
    try {
        "test".fontcolor("#ff0000");
    } catch(e) {
        fontColor = false;
    }
    addValue("fontColor", fontColor ? 1 : 0);
}

// フォントサイズの変更ができるか
function supoorFontSize() {

    var fontSizeFlag = true;
    try {
        var divTag = document.createElement("div");
        divTag.setAttribute("style", "display :none;");
        divTag.style.fontSize = "200%";
    } catch(e) {
        fontSizeFlag = false;
    }
    addValue("fontSize", fontSizeFlag ? 1 : 0);
}

// Frameが使用可能か
function supportFrames() {
    
    var framesFlag = true;
    try {
        var frame = document.createElement("frame");
        frame.id = "test";
    } catch(e) {
        framesFlag = false;
    }
    addValue("frames", framesFlag ? 1 : 0);
}

// ブラウザで画像が使用可能か
function supportImage() {
    addValue("imagesEnabled", ((document.images) ? 1 : 0));
}

// スタイルシートが使用可能か
function supportStylesheets() {
    
    var styleSheetsFlag = true;
    try {
        var css = document.createElement('style'); 
        var rule = document.createTextNode('p{display:none}')
        css.media = 'screen';
        css.type = 'text/css';
    } catch(e) {
        styleSheetsFlag = false;
    }
    
    addValue("stylesheets", styleSheetsFlag ? 1 : 0);
}

// フォントで太字が使用可能か
function supportsBold() {
    var boldFlag = true;
    try {
        var input = document.createElement("text");
        input.style.fontWeight = "bold";
    } catch(e) {
        boldFlag = false;
    }
    addValue("supportsBold", boldFlag ? 1 : 0);
}

// フォントでイタリックが使用可能か
function supportsItalic() {
    var italicFlag = true;
    try {
        var input = document.createElement("text");
        input.style.fontFamily = "italic";
    } catch(e) {
        italicFlag = false;
    }
    addValue("supportsItalic", italicFlag ? 1 : 0);
}

// tableタグが使用可能か
function supportTableTag() {
    var tagFlag = true;
    try {
        var tableTag = document.createElement("table");
        var tbody = document.createElement("tbody");
        var trTag = document.createElement("tr");
        var tdTag = document.createElement("td");
        tableTag.appendChild(tbody);
        tableTag.appendChild(trTag);
        trTag.appendChild(tdTag);
    } catch(e) {
        tagFlag = false;
    }
    addValue("tableTag", tagFlag ? 1 : 0);
}

// tableタグに背景色が使用可能か
function supportTableBgcolor() {
    var oTable = document.createElement("table");
    addValue("tableBgcolor", (oTable.bgColor == null || oTable.bgColor == undefined) ? 0 : 1);
}

// tableタグに背景画像が使用可能か
function supportTableBgimage() {
    var oTable = document.createElement("table"); 
    addValue("tableBgimage", (oTable.style.background == null || oTable.style.background == undefined) ? 0 : 1);

}

// ObjectタグでActiveXが実行できるか
function supportObjectTagactivex() {
    var tagFlag = false;
    
    try {
        var objectTag = document.createElement('object');
        if (objectTag.data != null && captureObject.activexControls == 1) {
            tagFlag = true;
        }
    } catch(e) {
    }
    addValue("objectTagactivex", tagFlag ? 1 : 0);
}

// Objectタグが使用可能か
/*
function supportObjectTag() {
    try {
        var objectTag = document.createElement('object');
        objectTag.data;
    } catch(e) {
        addValue("objectTag", 0);
    }
    addValue("objectTag", 1);
}
*/
// 接続タイプを取得
function getConnectionType() {
    var body = document.getElementsByTagName("body");
    var connType = 0;
    try {
        body[0].style.behavior = "url(#default#clientCaps)";
        connType = body[0].connectionType;
        if (connType == undefined) {
            connType = 0;
        }
    } catch (Error) {
    }
    addValue("connectionType", connType != 0 ? connType : null);
}

// SSL通信の使用可能か
function getSslEnabled() {
    addValue("sslEnabled", location.protocol == 'https' ? 1 : 0);
}

// キャプチャーオブジェクトへのデータ追加
function addValue(name, value) {
    if (value == undefined || value == null) {
        return;
    }
    eval("captureObject." + name + "='" + value + "'");
}

// Hiddenタグへデータコピー
function setHiddenForCapture() {
    for (var name in captureObject) {
    	document.getElementById(name).value = captureObject[name];
    }
}

// Cookie取得ユーティリティ
function getCookie(check_name) {
    var a_all_cookies = document.cookie.split(';');
    var a_temp_cookie = '';
    var cookie_name = '';
    var cookie_value = '';
    var b_cookie_found = false;
    var i = '';
    for (i = 0; i < a_all_cookies.length; i++) {
        a_temp_cookie = a_all_cookies[i].split('=');
        cookie_name = a_temp_cookie[0].replace(/^\s+|\s+$/g, '');

        if (cookie_name == check_name) {
            b_cookie_found = true;
            if (a_temp_cookie.length > 1) {
                cookie_value = unescape(a_temp_cookie[1].replace(/^\s+|\s+$/g, ''));
            }
            return cookie_value;
            break;
        }
        a_temp_cookie = null;
        cookie_name = '';
    }
    if (!b_cookie_found) {
        return null;
    }
}

// Cookie設定ユーティリティ
function setCookie(name, value, expires, path, domain, secure) {
    var today = new Date();
    today.setTime(today.getTime());
    if (expires) {
        expires = expires * 1000 * 60 * 60 * 24;
    }
    var expires_date = new Date(today.getTime() + (expires));
    document.cookie = name + "=" + escape(value) +
        ((expires) ? ";expires=" + expires_date.toGMTString() : "") +
        ((path) ? ";path=" + path : "") +
        ((domain) ? ";domain=" + domain : "") +
        ((secure) ? ";secure" : "");
}

// プラグインの存在チェック
function canDetectNavigatorPlugins() {
    if (navigator.plugins && navigator.plugins.length > 0) {
        return true;
    } else {
        return false;
    }
}

// 特定のプラグインの存在チェック
function detectPlugin() {
    var pluginFound = false;
    try {
        var thePlugins = detectPlugin.arguments;
        if (navigator.plugins && navigator.plugins.length > 0) {
            var pluginsArrayLength = navigator.plugins.length;
            for (pluginsArrayCounter = 0; pluginsArrayCounter < pluginsArrayLength; pluginsArrayCounter++) {
                var numFound = 0;
                for (namesCounter = 0; namesCounter < thePlugins.length; namesCounter++) {
                    if ((navigator.plugins[pluginsArrayCounter].name.indexOf(thePlugins[namesCounter]) >= 0) ||
                        (navigator.plugins[pluginsArrayCounter].description.indexOf(thePlugins[namesCounter]) >= 0)) {
                        numFound++;
                    }
                }
                if (numFound == thePlugins.length) {
                    pluginFound = true;
                    break;
                }
            }
        }
    } catch (e) {
        pluginFound = true;
    }
    return pluginFound;
}

// スクリプトタグ作成ユーティリティ
function createScriptTag(ver) {
    var hDiv = document.getElementsByTagName("head").item(0);
    var scriptTag = document.createElement('script');
    if (isOpera) {
        scriptTag.setAttribute('type', 'application/javascript;version=' + ver);
    } else {
        scriptTag.setAttribute('language', 'Javascript' + ver);
    }
    scriptTag.text = 'jsver = ' + ver + ';';
    hDiv.appendChild(scriptTag);
}

// プラグイン情報オブジェクト
var $pObject = pluginObject = { 
    isDefined: function(b) { return typeof b != "undefined" },
    isArray: function(b) { return (/array/i).test(Object.prototype.toString.call(b)) },
    isFunc: function(b) { return typeof b == "function" },
    isString: function(b) { return typeof b == "string" },
    isNum: function(b) { return typeof b == "number" },
    isStrNum: function(b) { return (typeof b == "string" && (/\d/).test(b)) },
    getNumRegx: /[\d][\d\.\_,-]*/,
    splitNumRegx: /[\.\_,-]/g,
    getNum: function(b, c) { var d = this, a = d.isStrNum(b) ? (d.isDefined(c) ? new RegExp(c) : d.getNumRegx).exec(b) : null; return a ? a[0] : null },
    getNumRegx: /[\d][\d\.\_,-]*/,
    isIE: function() {(navigator.appVersion.indexOf("MSIE") != -1) ? true : false},
    compareNums: function(h, f, d) {
        var e = this, c, b, a, g = parseInt;
        if (e.isStrNum(h) && e.isStrNum(f)) {
            if (e.isDefined(d) && d.compareNums) {
                return d.compareNums(h, f)
            }
            c = h.split(e.splitNumRegx);
            b = f.split(e.splitNumRegx);
            for (a = 0; a < Math.min(c.length, b.length); a++) {
                if (g(c[a], 10) > g(b[a], 10)) {
                    return 1;
                }
                if (g(c[a], 10) < g(b[a], 10)) {
                    return -1;
                }
            }
        } return 0
    },
    silverlight: { 
        mimeType: "application/x-silverlight", 
        progID: "AgControl.AgControl", 
        digits: [9, 20, 9, 12, 31], 
        getVersion: function() { 
            var e = this, c = e.$, k = document, i = null, b = null, f = null, h = true, a = [1, 0, 1, 1, 1], u = [1, 0, 1, 1, 1], j = function(d) { 
                return (d < 10 ? "0" : "") + d.toString() 
            }, 
            n = function(s, d, v, w, t) { 
                return (s + "." + d + "." + v + j(w) + j(t) + ".0") 
            },
            o = function(s, d, t) { 
                return r(s, (d == 0 ? t : u[0]), (d == 1 ? t : u[1]), (d == 2 ? t : u[2]), (d == 3 ? t : u[3]), (d == 4 ? t : u[4])) 
            }, 
            r = function(w, t, s, y, x, v) {
                var v; try { 
                    return w.IsVersionSupported(n(t, s, y, x, v)) 
                } catch (v) { 
                    
                } 
                return false 
            };
            b = new ActiveXObject(e.progID);
            var m, l, q;
            if (b && r(b, a[0], a[1], a[2], a[3], a[4])) { 
                for (m = 0; m < e.digits.length; m++) {
                    q = u[m];
                    for (l = q + (m == 0 ? 0 : 1); l <= e.digits[m]; l++) { 
                        if (o(b, m, l)) { 
                            h  = true;
                            u[m] = l 
                        } else { 
                            break 
                        } 
                    } 
                    if (!h) { 
                        break 
                    } 
                }
                if (h) { 
                    i = n(u[0], u[1], u[2], u[3], u[4]) 
                }
            }
            return i;
        }
    },
    adobereader: { 
		mimeType: "application/pdf", 
		navPluginObj: null, 
		progID: ["AcroPDF.PDF", "PDF.PdfCtrl"], 
		classID: "clsid:CA8A9780-280D-11CF-A24D-444553540000", 
		INSTALLED: {}, 
		pluginHasMimeType: function(d, c, f) { 
			var b = this, e = b.$, a; 
			for (a in d) { 
				if (d[a] && d[a].type && d[a].type == c) { 
					return 1 
				} 
			} 
			if (e.getMimeEnabledPlugin(c, f)) { return 1 } 
			return 0 
		}, 
		getVersion: function(i) { 
			var f = this, c = $pObject, g, d, j, l = p = null, h = null, k = null, a, b; 
			i = (c.isString(i) && i.length) ? i.replace(/\s/, "").toLowerCase() : f.mimeType; 
			if (c.isDefined(f.INSTALLED[i])) { 
				f.installed = f.INSTALLED[i]; 
				return 
			} 
			if (!isIE) { 
				a = "Adobe.*PDF.*Plug-?in|Adobe.*Acrobat.*Plug-?in|Adobe.*Reader.*Plug-?in"; 
				if (f.getVersionDone !== 0) { 
					f.getVersionDone = 0; 
					p = c.getMimeEnabledPlugin(f.mimeType, a); 
					if (!p && c.hasMimeType(f.mimeType)) { 
						p = c.findNavPlugin(a, 0) 
					} 
					if (p) { 
						f.navPluginObj = p; 
						h = c.getNum(p.description) || c.getNum(p.name); 
						h = c.getPluginFileVersion(p, h); 
						if (!h && c.OS == 1) { 
							if (f.pluginHasMimeType(p, "application/vnd.adobe.pdfxml", a)) { 
								h = "9" 
							} else { 
								if (f.pluginHasMimeType(p, "application/vnd.adobe.x-mars", a)) { 
									h = "8" 
								} 
							} 
						} 
					} 
				} else { 
					h = f.version 
				} 
				l = c.getMimeEnabledPlugin(i, a); 
				f.installed = l && h ? 1 : (l ? 0 : (f.navPluginObj ? -0.2 : -1)) 
			} else { 
				p = c.getAXO(f.progID[0]) || c.getAXO(f.progID[1]); 
				b = /=\s*([\d\.]+)/g; 
				try { 
					d = (p || c.getDOMobj(c.insertHTML("object", ["classid", f.classID], ["src", ""], "", f))).GetVersions(); 
					for (j = 0; j < 5; j++) { 
						if (b.test(d) && (!h || RegExp.$1 > h)) {
							h = RegExp.$1 
						} 
					} 
				} catch (g) { } 
				f.installed = h ? 1 : (p ? 0 : -1) 
			} 
			if (!f.version) { 
				f.version = c.formatNum(h) 
			} 
			return f.version ? f.version.replace(/\,/g, ".") : 0;
		} 
	}, 
	quicktime: { 
		mimeType: ["video/quicktime", "application/x-quicktimeplayer", "image/x-macpaint", "image/x-quicktime"], 
		progID: "QuickTimeCheckObject.QuickTimeCheck.1", 
		progID0: "QuickTime.QuickTime", 
		classID: "clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B", 
		minIEver: 7, 
		HTML: ("<") + 'param name="src" value="" />' + ("<") + 'param name="controller" value="false" />', 
		getCodeBaseVersion: function(a) { 
			return 'codebase="#version=' + a + '"' 
		}, 
		digits: [8, 64, 64, 0], 
		getVersion: function() { 
			var d = this, b = $pObject, a = null, c = null; if (!isIE) { 
				if (b.hasMimeType(d.mimeType)) { 
					c = b.OS != 3 ? b.findNavPlugin("QuickTime.*Plug-?in", 0) : null; 
					if (c && c.name) { 
						a = b.getNum(c.name) 
					} 
				} 
			} else { 
				if (b.verIE >= d.minIEver) { 
					if (d.BIfuncs && d.BIfuncs.length && d.BIfuncs[d.BIfuncs.length - 1] !== null) { 
						b.callArray(d.BIfuncs) 
					} 
					a = b.codebaseSearch() 
				} else { 
					c = b.getAXO(d.progID); 
					if (c && c.QuickTimeVersion) { 
						a = c.QuickTimeVersion.toString(16); 
						a = a.charAt(0) + "." + a.charAt(1) + "." + a.charAt(2) 
					} 
				} 
			} 
			d.installed = a ? 1 : (c ? 0 : -1); a = b.formatNum(a); 
			if (isIE && a) { 
				if (b.compareNums(a, "7,50,0,0") >= 0 && b.compareNums(a, "7,60,0,0") < 0) { 
					p = a.split(b.splitNumRegx); 
					a = [p[0], p[1].charAt(0), p[1].charAt(1), p[2]].join(",") 
				} 
			}
			var quickTimeVersion = b.formatNum(a, 3);
			return quickTimeVersion != null ? quickTimeVersion.replace(/\,/g, ".") : 0;
		}
	},
    java: {
        mimeType: ["application/x-java-applet", "application/x-java-vm", "application/x-java-bean"], 
        mimeTypeJPI: "application/x-java-applet;jpi-version=", 
        classID: "clsid:8AD9C840-044E-11D1-B3E9-00805F499D93", 
        DTKclassID: "clsid:CAFEEFAC-DEC7-0000-0000-ABCDEFFEDCBA", 
        DTKmimeType: ["application/java-deployment-toolkit", "application/npruntime-scriptable-plugin;DeploymentToolkit"], 
        forceVerifyTag: [], 
        jar: [], 
        Enabled: navigator.javaEnabled(), 
        VENDORS: ["Sun Microsystems Inc.", "Apple Computer, Inc."], 
        OTF: null, 
        All_versions: [], 
        mimeTypeJPIresult: "", 
        JavaPlugin_versions: [], 
        JavaVersions: [[1, 9, 2, 30], [1, 8, 2, 30], [1, 7, 2, 30], [1, 6, 1, 30], [1, 5, 1, 30], [1, 4, 2, 30], [1, 3, 1, 30]], 
        searchJavaPluginAXO: function() {
            var h = null, a = this, c = a.$, g = [], j = [1, 5, 0, 14], i = [1, 6, 0, 2], f = [1, 3, 1, 0], e = [1, 4, 2, 0], d = [1, 5, 0, 7], b = false; 
            if (!document.getElementById("activexEnabled").value) { 
                return null 
            }; 
            b = true; 
            if (c.verIE >= a.minIEver) { 
                g = a.searchJavaAXO(i, i, b); 
                if (g.length > 0 && b) { 
                    g = a.searchJavaAXO(j, j, b) 
                } 
            } else { 
                if (b) { 
                    g = a.searchJavaAXO(d, d, true) 
                }; 
                if (g.length == 0) { 
                    g = a.searchJavaAXO(f, e, false) 
                } 
            } 
            if (g.length > 0) { 
                h = g[0] 
            } 
            a.JavaPlugin_versions = [].concat(g); 
            return h;
        }, 
        searchJavaAXO: function(l, i, m) { 
            var n, f, h = this.$, q, k, a, e, g, j, b, r = []; 
            if (h.compareNums(l.join(","), i.join(",")) > 0) { 
                i = l 
            } 
            i = h.formatNum(i.join(",")); 
            var o, d = "1,4,2,0", c = "JavaPlugin." + l[0] + "" + l[1] + "" + l[2] + "" + (l[3] > 0 ? ("_" + (l[3] < 10 ? "0" : "") + l[3]) : ""); 
            for (n = 0; n < this.JavaVersions.length; n++) { 
                f = this.JavaVersions[n]; 
                q = "JavaPlugin." + f[0] + "" + f[1]; g = f[0] + "." + f[1] + "."; 
                for (a = f[2]; a >= 0; a--) { 
                    b = "JavaWebStart.isInstalled." + g + a + ".0"; 
                    if (h.compareNums(f[0] + "," + f[1] + "," + a + ",0", i) >= 0 && !h.getAXO(b)) { 
                        continue 
                    } 
                    o = h.compareNums(f[0] + "," + f[1] + "," + a + ",0", d) < 0 ? true : false; 
                    for (e = f[3]; e >= 0; e--) { 
                        k = a + "_" + (e < 10 ? "0" + e : e); j = q + k; 
                        if (h.getAXO(j) && (o || h.getAXO(b))) { 
                            r.push(g + k); 
                            if (!m) { 
                                return r 
                            } 
                        } 
                        if (j == c) { 
                            return r 
                        } 
                    } 
                    if (h.getAXO(q + a) && (o || h.getAXO(b))) { 
                        r.push(g + a); 
                        if (!m) { 
                            return r 
                        } 
                    } 
                    if (q + a == c) { 
                        return r 
                    } 
                } 
            } 
            return r 
        }, 
        minIEver: 7, 
        getMimeJPIversion: function() {
            var h, a = this, d = a.$, c = new RegExp("(" + a.mimeTypeJPI + ")(\\d.*)", "i"), k = new RegExp("Java", "i"), e, j, f = "", i = {}, g = 0, b; 
            for (h = 0; h < navigator.mimeTypes.length; h++) { 
                j = navigator.mimeTypes[h]; 
                if (c.test(j.type) && (e = j.enabledPlugin) && (j = RegExp.$2) && (k.test(e.description || f) || k.test(e.name || f))) { 
                    i["a" + d.formatNum(j)] = j 
                } 
            } 
            b = "0,0,0,0"; for (h in i) { 
                g++; 
                e = h.slice(1); 
                if (d.compareNums(e, b) > 0) { 
                    b = e 
                } 
            } 
            a.mimeTypeJPIresult = g > 0 ? a.mimeTypeJPI + i["a" + b] : ""; return g > 0 ? b : null 
        }, 
        getVersion: function(d, l) { 
            var f, c = this, e = c.$, h = c.NOTF, b = c.applet, j = c.verify, i = vendor = versionEnabled = null; 
            if (c.getVersionDone === null) { 
                c.OTF = 0; 
                c.mimeObj = e.hasMimeType(c.mimeType); 
                c.deployTK.$ = e; 
                c.deployTK.parentNode = c; 
                b.$ = e; 
                b.parentNode = c; 
                if (h) { 
                    h.$ = e; 
                    h.parentNode = c 
                } 
                if (j) { 
                    j.parentNode = c; j.$ = e; j.init() 
                } 
            } 
            var k; 
            if (e.isArray(l)) { 
                for (k = 0; k < b.allowed.length; k++) { 
                    if (e.isNum(l[k])) { 
                        b.allowed[k] = l[k] 
                    } 
                } 
            } 
            for (k = 0; k < c.forceVerifyTag.length; k++) { 
                b.allowed[k] = c.forceVerifyTag[k] 
            } 
            if (e.isString(d)) { 
                c.jar.push(d) 
            } 
            if (c.getVersionDone == 0) { 
                if (!c.version || b.canTryAny()) { 
                    f = b.insertHTMLQueryAll(d); 
                    if (f[0]) { 
                        c.installed = 1; 
                        c.EndGetVersion(f[0], f[1]) 
                    } 
                } 
                return 
            } 
            var g = c.deployTK.query(); 
            if (g.JRE) { 
                i = g.JRE; 
                vendor = c.VENDORS[0] 
            } 
            if (!e.isIE()) { 
                var o, m, a, n; n = (c.mimeObj && c.Enabled) ? true : false; 
                if (!i && (f = c.getMimeJPIversion()) !== null) { 
                    i = f 
                } 
                if (!i && c.mimeObj) { 
                    f = "Java[^\\d]*Plug-in"; a = e.findNavPlugin(f); 
                    if (a) { 
                        f = new RegExp(f, "i"); 
                        o = f.test(a.description || "") ? e.getNum(a.description) : null; 
                        m = f.test(a.name || "") ? e.getNum(a.name) : null; 
                        if (o && m) { 
                            i = (e.compareNums(e.formatNum(o), e.formatNum(m)) >= 0) ? o : m 
                        } else { 
                            i = o || m 
                        } 
                    } 
                } 
                if (!i && c.mimeObj && e.isSafari && e.OS == 2) { 
                    a = e.findNavPlugin("Java.*\\d.*Plug-in.*Cocoa", 0); 
                    if (a) { 
                        o = e.getNum(a.description); 
                        if (o) { 
                            i = o 
                        } 
                    } 
                } 
                if (i) { 
                    c.version0 = i; 
                    if (c.Enabled) { 
                        versionEnabled = i 
                    } 
                } 
            } else { 
                if (!i && g.status == 0) { 
                    i = c.searchJavaPluginAXO(); 
                    if (i) { 
                        vendor = c.VENDORS[0] 
                    } 
                } 
                if (i) { 
                    c.version0 = i; 
                    if (c.Enabled && e.ActiveXEnabled) { 
                        versionEnabled = i 
                    } 
                } 
            } 
            if (!versionEnabled || b.canTryAny()) { 
                f = b.insertHTMLQueryAll(d); if (f[0]) { 
                    versionEnabled = f[0]; vendor = f[1] 
                } 
            } 
            if (!versionEnabled && (f = c.queryWithoutApplets())[0]) { 
                c.version0 = versionEnabled = f[0]; 
                vendor = f[1]; 
                if (c.installed == -0.5) { 
                    c.installed = 0.5 
                } 
            } 
            if (e.isSafari && e.OS == 2) { 
                if (!versionEnabled && n) { 
                    if (c.installed === null) { 
                        c.installed = 0 
                    } else { 
                        if (c.installed == -0.5) { 
                            c.installed = 0.5 
                        } 
                    } 
                } 
            } 
            if (c.jreDisabled()) { 
                versionEnabled = null 
            }; 
            if (c.isPlugin2 == 0 && (f = c.mimeObj) && (f = f.enabledPlugin) && (f = f.description)) { 
                if ((/Next.*Generation.*Java.*Plug-in/i).test(f)) { 
                    c.isPlugin2 = 1 
                } else { 
                    if ((/Classic.*Java.*Plug-in/i).test(f)) { 
                        c.isPlugin2 = -1 
                    } 
                } 
            }; 
            if (c.installed === null) { 
                c.installed = versionEnabled ? 1 : (i ? -0.2 : -1) 
            } 
            c.EndGetVersion(versionEnabled, vendor) 
        }, 
        EndGetVersion: function(b, d) { 
            var a = this, c = a.$; 
            if (a.version0) { 
                a.version0 = c.formatNum(c.getNum(a.version0)) 
            } if (b) { 
                a.version = c.formatNum(c.getNum(b)); 
                a.vendor = (c.isString(d) ? d : "") 
            } 
            if (a.getVersionDone != 1) { 
                a.getVersionDone = 0 
            } 
        }, 
        jreDisabled: function() { 
            var b = this, d = b.$, c = b.deployTK.query().JRE, a; 
            if (c && d.OS == 1) { 
                if ((d.isGecko && d.compareNums(d.verGecko, "1,9,2,0") >= 0 && d.compareNums(c, "1,6,0,12") < 0) || (d.isChrome && d.compareNums(c, "1,6,0,12") < 0)) { 
                    return 1 
                } 
            }; 
            if (d.OS == 3 && (a = b.mimeObj) && (a = a.enabledPlugin) && (a = a.description) && (/Next.*Generation.*Java.*Plug-in/i).test(a) && b.isPlugin2 < 2 && !b.Browser4Plugin2()) { 
                return 1 
            }; 
            if (d.isOpera && d.verOpera >= 9 && !b.Enabled && !b.mimeObj && !b.queryWithoutApplets()[0]) { 
                return 1 
            } 
            if ((d.isGecko || d.isChrome) && !b.mimeObj && !b.queryWithoutApplets()[0]) { 
                return 1 
            } 
            return 0 
        }, 
        deployTK: { 
            status: null, 
            JREall: [], 
            JRE: null, 
            HTML: null, 
            query: function() { 
                var f = this, h = f.$, c = f.parentNode, i, a, b, g = len = null; 
                if (f.status !== null) { return f } 
                f.status = 0; if ((h.isGecko && h.compareNums(h.verGecko, h.formatNum("1.6")) <= 0) || h.isSafari || (h.isIE() && !h.ActiveXEnabled)) { return f } 
                if (h.isIE() && h.verIE >= 6) { 
                    f.HTML = h.insertHTML("object", [], []); g = h.getDOMobj(f.HTML) 
                } else { 
                    if (!h.isIE() && (b = h.hasMimeType(c.DTKmimeType)) && b.type) { 
                        f.HTML = h.insertHTML("object", ["type", b.type], []); 
                        g = h.getDOMobj(f.HTML) 
                    } 
                } 
                if (g) { 
                    if (h.isIE() && h.verIE >= 6) { 
                        try { 
                            g.classid = c.DTKclassID 
                        } catch (i) { } 
                    }; 
                    try { 
                        if (Math.abs(c.isPlugin2) < 2) { 
                            c.isPlugin2 = g.isPlugin2() ? 2 : -2 
                        } 
                    } catch (i) { }; 
                }
                try { 
                    var d = g.jvms; 
                    if (d) { 
                        len = d.getLength(); 
                        if (h.isNum(len)) { 
                            f.status = len > 0 ? 1 : -1; 
                            for (a = 0; a < len; a++) { 
                                b = h.getNum(d.get(len - 1 - a).version); 
                                if (b) { 
                                    f.JREall[a] = b 
                                } 
                            } 
                        } 
                    } 
                } catch (i) {
                } 
            } 
        } 
    }, 
    hasMimeType: function(a) { 
        return function(d) { 
            if (!a.isIE()) { 
                var c, b, e, f = a.isString(d) ? [d] : d;
                for (e = 0; e < f.length; e++) { 
                    if (/[^\s]/.test(f[e]) && (c = navigator.mimeTypes[f[e]]) && (b = c.enabledPlugin) && (b.name || b.description)) { 
                        return c 
                    } 
                } 
            } 
            return null 
        } 
    },
    findNavPlugin: function(l, e, c) { 
        var j = this, h = new RegExp(l, "i"), d = (!j.isDefined(e) || e) ? /\d/ : 0, k = c ? new RegExp(c, "i") : 0, a = navigator.plugins, g = "", f, b, m;
        for (f = 0; f < a.length; f++) { 
            m = a[f].description || g;
            b = a[f].name || g;
            if ((h.test(m) && (!d || d.test(RegExp.leftContext + RegExp.rightContext))) || (h.test(b) && (!d || d.test(RegExp.leftContext + RegExp.rightContext)))) { 
                if (!k || !(k.test(m) || k.test(b))) { 
                    return a[f] 
                } 
            } 
        } 
        return null 
    },
    getMimeEnabledPlugin: function(a, e) { 
        var d = this, b, c = new RegExp(e, "i");
        if ((b = d.hasMimeType(a)) && (b = b.enabledPlugin) && (c.test(b.description || "") || c.test(b.name || ""))) { 
            return b 
        } 
        return 0 
    },
    getPluginFileVersion: function(f, b) { 
        var h = this, e, d, g, a, c = -1;
        if (h.OS > 2 || !f || !f.version || !(e = h.getNum(f.version))) { 
            return b 
        } 
        if (!b) { 
            return e 
        } 
        e = h.formatNum(e);
        b = h.formatNum(b);
        d = b.split(h.splitNumRegx);
        g = e.split(h.splitNumRegx);
        for (a = 0; a < d.length; a++) { 
            if (c > -1 && a > c && d[a] != "0") { 
                return b 
            } 
            if (g[a] != d[a]) { 
                if (c == -1) { 
                    c = a 
                } 
                if (d[a] != "0") { 
                    return b 
                } 
            } 
        } 
        return e 
    },
    formatNum: function(b, c) { 
        var d = this, a, e;
        if (!d.isStrNum(b)) { 
            return null 
        } 
        if (!d.isNum(c)) { 
            c = 4 
        } 
        c--;
        e = b.replace(/\s/g, "").split(d.splitNumRegx).concat(["0", "0", "0", "0"]);
        for (a = 0; a < 4; a++) { 
            if (/^(0+)(.+)$/.test(e[a])) { 
                e[a] = RegExp.$2 
            } 
            if (a > c || !(/\d/).test(e[a])) { 
                e[a] = "0" 
            } 
        } 
        return e.slice(0, 4).join(",") 
    },
    AXO: window.ActiveXObject, 
    getAXO: function(a) { 
        var d = null, c, b = this;
        try { 
            d = new b.AXO(a) 
        } catch (c) { 
        } 
        return d 
    }
}

// フォントオブジェクトを生成
var FontDetector = function() {
    var h = document.getElementsByTagName("body")[0];
    var d = document.createElement("DIV");
    var s = document.createElement("SPAN");
    d.appendChild(s);
    d.style.fontFamily = "sans";
    s.style.fontFamily = "sans";
    s.style.fontSize = "72px";
    s.innerHTML = "mmmmmmmmmmlil";
    h.appendChild(d);
    var defaultWidth = s.offsetWidth;
    var defaultHeight = s.offsetHeight;
    h.removeChild(d);
    function debug(font) {
        h.appendChild(d);
        var f = [];
        f[0] = s.style.fontFamily = font;
        f[1] = s.offsetWidth;
        f[2] = s.offsetHeight;
        h.removeChild(d);
        font = font.toLowerCase();
        if (font == "serif") {
            f[3] = true;
        } else {
            f[3] = (f[1] != defaultWidth || f[2] != defaultHeight);
        }
        return f;
    }
    function test(font) {
        f = debug(font);
        return f[3];
    }
    this.detailedTest = debug;
    this.test = test;
}

// Applet埋め込み
function createAppletObject() {
	var appletUrl = serverUrl + '/aplt/olae.jar';
	document.getElementById("aplt_div").innerHTML = '<applet id="olaeApplet" code="com.macromill.airs.applet.olae.OverlapAnswerExclusionApplet.class" archive="' + appletUrl + '" myscript=true width="0%" height="0%" align="right"></applet>';
}

// Flash埋め込み
function createFlashObject() {
	var flashUrl = serverUrl + '/fls/olae.swf';
	document.write('<object id="olaeFls" classid="CLSID:D27CDB6E-AE6D-11cf-96B8-444553540000" type="application/x-shockwave-flash" width="0%" height="0%" align="right" style="position:relative; top:1000px; left:0px">');
	document.write('<param name="movie" value="' + flashUrl + '" />');
	document.write('<param name="allowScriptAccess" value="always" />');
	document.write('<param name="bgcolor" value="#FFFFFF" />');
	document.write('</object>');
}

