$(function() {
    var animationDuration = 400,
        cpaFormSelector = "form.cpaForm",
        modalSelector = "#cpaContent",
        modalFormSelector = modalSelector + " " + cpaFormSelector,
        overlayId = "overlay",
        overlaySelector = "#" + overlayId,
        signInNavDropdownSelector = "#cpaSignIn",
        win = window,
        winLoc = win.location,
        $bb = $("#bb"),
        $body = $("body"),
        $doc = $(document),
        $header = $("#header"),
        $signInNavDropdown = $(signInNavDropdownSelector),
        $signInNavDropdownForm = $(cpaFormSelector, $signInNavDropdown),
        $signInNavLink = $("a.signIn", $bb),
        $win = $(win),
        isNotLoggedIn = !$body.hasClass("loggedIn"),
        Utils, PA, animationParams;

    (function init() {
        initGeneral();
        initSignInSpecific();
        initPageSpecific();
    }());

    function initGeneral() {
        setupStickyNav();
        setupNavDrawer();
        setupFollowPA();
    }
    function initSignInSpecific() {
        if (isNotLoggedIn) {
//            setupNavLogin();
//            setupNavCreateAccount();
        } else {
            setupAccountInfo();
        }
        displayThankYou();
        armHideExpiryAlert();
        setupNewsletter();
    }
    function initPageSpecific() {
        var pageName = winLoc.pathname,
            isClubPaPage = ((pageName === "/clubpa") || (pageName === "/clubpa/renew"));

        setupToggleComments();
        setupToggleMeta();

        if (isClubPaPage) {
            clubPaBtnSetup();
        }        
    }

    function setupStickyNav() {
        $bb.sticky({ topSpacing: 0, bottomSpacing: 0, center: true, getWidthFrom: 'body' });
        $header.sticky({ topSpacing: 30, bottomSpacing: 0, center: true, getWidthFrom: 'body' });
    }
    function setupNavDrawer() {
        var animationDuration = 400;

        animationParams = {
            "open": {
                "queue": false,
                "duration": animationDuration,
                "easing": "easeOutBack"
            },
            "close": {
                "queue": false,
                "duration": animationDuration,
                "easing": "easeInOutBack"
            }
        };

        function getSubMenuHeight($el) {
            var subMenuHeightFull = "204px",
                subMenuHeightShort = "103px",
                subMenuHeight = subMenuHeightFull;

            if ($el.hasClass("short")) {
                subMenuHeight = subMenuHeightShort;
            }

            return subMenuHeight;
        }

        $("#nav li.dropdown").hoverIntent({
            "over": function() {
                var $this = $(this),
                    $currentSubMenu = $(".subMenu", $this),
                    subMenuHeight = getSubMenuHeight($currentSubMenu);

                $this.addClass("active");
                $currentSubMenu.css("z-index", "3");
                $("ul", $currentSubMenu).stop().animate({ top: '0px' }, animationParams.open);
                $currentSubMenu.stop().animate({ height: subMenuHeight, opacity: '1' }, animationParams.open);
            },
            "out": function() {
                var $this = $(this),
                    $currentSubMenu = $(".subMenu", $this),
                    subMenuHeight = getSubMenuHeight($currentSubMenu);

                $this.removeClass("active");
                $currentSubMenu.css("z-index", "2");
                $("ul", $currentSubMenu).stop().animate({ top: '-' + subMenuHeight }, animationParams.close);
                $currentSubMenu.stop().animate({ height: '0px', opacity: '1' }, animationParams.close);
            },
            "timeout": 100
        });
    }
    function setupFollowPA() {
        var $staffSection = $("#staff"),
            $toggleStaffSectionBtn = $("#btnShowFollow");

        $staffSection.hide();
        $toggleStaffSectionBtn.click(function() { 
            $staffSection.slideToggle("fast");
            $toggleStaffSectionBtn.text(($toggleStaffSectionBtn.text() === "More") ? "Less" : "More");
        });
    }

    function setupNavLogin() {
        $signInNavDropdownForm.on("submit", function(evt) {
            handleLogin(evt, $(this), handleNavLoginResult);
        });
        $signInNavLink.on("click.openSignIn", signInOpenAnimation);
    }
    function setupNavCreateAccount() {
        $("#signInCreateAccount").click(function(evt) {
            signInNavCloseAnimation();
            handleLoginOrCreate(evt, "/clubpa/00_register", function(evt) {
                handleCreateAccount(evt, handleCreateAccountResult);
            });
        });
    }

    function addHideLoginHandlers() {
        $body.on("click.signInCloseClick", function() {
            signInNavCloseAnimation();
        }).on("click.signInClickIgnore", signInNavDropdownSelector, function(evt) {
            evt.stopPropagation();
        });
        $doc.keyup(escSignInNavCloseAnimation);
    }
    function removeHideLoginHandlers() {
        $body.off("click.signInCloseClick").off("click.signInClickIgnore");
        $doc.unbind("keyup", escSignInNavCloseAnimation);
    }
    function handleCreateAccount(evt, resultHandler) {
        evt.preventDefault();
        $('#loading').show();
        var target = $(evt.target);
        target.find('input[type="submit"]').prop('disabled', true);
        target.find('div.cpaSignInError').remove();
        var tosAgree = $('#terms').prop('checked');
        if (!tosAgree) {
            $('#loading').hide();
            var data = { 'message': 'You must agree to the Terms of Service before continuing.' };
            resultHandler(data);
        } else {
            var params = target.serializeArray();
            $.post('/assets/php/cpa/create.php', params, resultHandler, 'json');
        }
    }
    function handleCreateAccountResult(data) {
        var $cpaForm = $(modalFormSelector);

        $("#loading").hide();
        $("input[type='submit']", $cpaForm).prop("disabled", false);
        if (data["status"] == "success") {
            location.reload();
        } else {
            $cpaForm.prepend('<div class="cpaSignInError"><p><strong>ATTENTION:</strong> ' + data["message"] + '</p></div>');
        }
    }
    function setupAccountInfo() {
        $('#userAccount').click(function(evt) {
            evt.preventDefault();
            $.get('/account-details', function(data) {
                var $overlay = $getOverlay(),
                    $modal = $(data).hide(),
                    windowPosition = $win.scrollTop();

                $modal.css('top', windowPosition + 'px');
                $body.prepend($modal);
                $modal.after($overlay.fadeIn(animationDuration)).slideDown(animationDuration);
                armCloseButtons();
            }, 'html');
        });
    }
    function setupNewsletter() {
        var newsletterForm = $("#newsletter");
        if(newsletterForm.length > 0) {
            newsletterForm.find("input[name='email']").focus(function(evt) {
                var target = $(evt.target);
                if(target.val() == 'Email Address') { target.val(''); }
            }).blur(function(evt) {
                var target = $(evt.target);
                if(target.val() == '') { target.val('Email Address'); }
            });

            newsletterForm.submit(function(evt) {
                evt.preventDefault();
                $('.newsletterResponse').remove();
                $("#newsletter input[type='submit']").prop('disabled', true);
                $("#newsletterInfo").before($("<p id='loading'>Submitting&hellip;</p>"));
                var email = $(evt.target).find("input[name='email']").val();
                // TODO: disable button image?
                $.post('/assets/php/mc_subscribe.php', { 'email': email }, function(data) {
                    $("#loading").remove();
                    var response = $(data).addClass('newsletterResponse').hide();
                    $('#newsletterInfo').before(response).slideUp(animationDuration);
                    response.slideDown(animationDuration);
                    $("#newsletter input[type='submit']").prop('disabled', false);
                });
            });
        }   
    }
    function setupToggleComments() {
        // we show/hide on both comic and patv
        // on comic only, we also shift house ads
        $('#vanilla-comments, .vanilla-credit').hide();
        $('#sidebarFeat').hide();
        $('#btnCmntsToggle').click(function(evt) {
            evt.preventDefault();
            var toggle = $('#btnCmntsToggle');
            toggle.toggleClass('btnCmntsShow btnCmntsHide');
            if(toggle.hasClass('btnCmntsShow')) {
                toggle.attr('title', 'Show Comments');
                toggle.find('h5').text('Show Comments');
            } else {
                toggle.attr('title', 'Hide Comments');
                toggle.find('h5').text('Hide Comments');
            }
            $('#vanilla-comments, .vanilla-credit, #bodyFeat, #sidebarFeat').toggle();
        });
    }
    function setupToggleMeta() {
        // we show/hide meta rollovers on comic, podcasts, patv
        var isMobile = /Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent) ? true : false;
        if(!isMobile) {
            $('.metaHover').hide();     
            $(".boxList li").hover(
                function() {
                    $(this).find(".metaHover").stop().animate({
                        height: "toggle",
                        opacity: "toggle"
                    },{
                        queue: false,
                        duration: 600,
                        easing: 'easeOutBack'
                    });
                },
                function() {
                    $(this).find(".metaHover").stop().animate({
                        height: "toggle",
                        opacity: "toggle"
                    },{
                        queue: false,
                        duration: 400,
                        easing: 'easeInBack'
                    });
                }
            );
        } else {
            $('#weeklyComics .metaDesc, #patv .metaDesc, #podcasts .metaDesc').hide();
        }
    }

    function handleLoginOrCreate(evt, ajaxUrl, submitCallback) {
        evt.preventDefault();
        $.get(ajaxUrl, function(data) {
            var $modal = $(data).hide(),
                windowPosition = $win.scrollTop(),
                $overlay = $(overlaySelector),
                missingOverlay = ($overlay.length === 0);

            $modal.css("top", windowPosition + "px").find("#loading").hide();
            $(modalSelector).remove();
            $body.prepend($modal);

            if (missingOverlay) {
                $overlay = $getOverlay();
                $modal.after($overlay);
                $overlay.fadeIn(animationDuration);
            }

            $(cpaFormSelector, $modal).submit(submitCallback);
            $("#signUp10, #signUp30", $modal).click(function(evt) {
                var $chosenLevel = $("#cpaChosenLevel", $modal),
                    isLevel10 = $(this).hasClass("btnSignUp10");

                $chosenLevel.val(isLevel10 ? "10" : "30");
            });
            $modal.slideDown(animationDuration);
            armCloseButtons();
        }, "html");
    }
    function handle03Tinypass(level) {
        $.get('/assets/php/cpa/clear_cache.php');
        $.get('/clubpa/03_tinypass', function(data) {
            var $modal = $(data).hide(),
                windowPosition = $win.scrollTop();

            $modal.css('top', windowPosition + 'px');
            $body.prepend($modal.slideDown(animationDuration));
            $.get('/assets/php/cpa/generate_tp_link.php?l=' + level, function(data) {
                $('#tpRedirect').attr('href', data['message']);
                var countdown = 10,
                    cdTimer = setInterval(function() {
                        if (countdown == 0) { 
                            winLoc.href = data['message'];
                            clearInterval(cdTimer);
                        }
                        $('#timeRemaining').text(countdown);
                        countdown--;
                    }, 1000);
            }, 'json');
            armCloseButtons();
        });
    }
    function armCloseButtons() {
        $body.on("click.modalClose", "a.btnClose", function(evt) {
            evt.preventDefault();
            overlayClose();
        }).on("click.overlay", overlaySelector + ", " + modalSelector, function(evt) {
            overlayClose();
        }).on("click.modalIgnore", "#cpaJoin", function(evt) {
            evt.stopPropagation();
        });
        $doc.keyup(escOverlayClose);
    }
    function disarmCloseButtons() {
        $body.off("click.modalClose").off("click.overlay").off("click.modalIgnore");
        $doc.unbind("keyup", escOverlayClose);
    }
    function displayThankYou() {
        var query = winLoc.search;
        if (query.indexOf('aid=BoIMopkQvy') > -1) {
            var $thanks = $('<h3 id="cpaThankYou">Thank you for supporting the Penny Arcade family. Welcome to Club PA!</h3>');

            $header.append($thanks);

            setTimeout(function() {
                $thanks.animate({ height: '0', opacity: '1' }, animationParams.close);
            }, 4000);
        }
    }
    function armHideExpiryAlert() {
        $body.on('click', 'a#hideAlert', function(evt) {
            evt.preventDefault();
            $.get('/assets/php/cpa/dismiss_expiry_alert.php', function(data) {
                if(data['status'] == 'success') {
                    $('.cpaRenew').slideUp(animationDuration, function() { $(this).remove(); });
                }
            });
        });
    }
    function clubPaBtnSetup() {
        var btnAClass = "btnPriceA",
            btnBClass = "btnPriceB",
            btnASelector = "." + btnAClass,
            btnBSelector = "." + btnBClass,
            $cpaBtns = $(btnASelector + ", " + btnBSelector, "#clubPA");

        $cpaBtns.on("click", function(evt) {
            cpaBtnClickHandler(evt, $(this));
        });

        function cpaBtnClickHandler(evt, $this) {
            evt.preventDefault();

            var $overlay = $getOverlay();
            if (isNotLoggedIn) {
                $.get("/clubpa/01_requireaccount", function(data) {
                    var $modal = $(data).hide(),
                        windowPosition = $win.scrollTop();

                    $body.prepend($modal);
                    $("a.btnDoHave", $modal).click(function(evt) {
                        $("#cpaJoin").hide();
                        handleLoginOrCreate(evt, "/clubpa/02_signin", function(evt) { 
                            handleLogin(evt, $(this), handleCpaPageLoginResult);
                        });
                    });
                    $("a.btnDoNotHave", $modal).click(function(evt) {
                        $("#cpaJoin").hide();
                        handleLoginOrCreate(evt, "/clubpa/02_register", function(evt) {
                            handleCreateAccount(evt, handleCPACreateResult);
                        });
                    });
                    $modal.css("top", windowPosition + "px").after($overlay);
                    $overlay.fadeIn(animationDuration);
                    $modal.slideDown(animationDuration);
                    armCloseButtons();
                }, "html");
            } else {
                $body.prepend($overlay.fadeIn(animationDuration));
                var level = $this.hasClass(btnAClass) ? 10 : 30;
                handle03Tinypass(level);
            }
        }

        if ($win.width() > "1024") {
            $(btnASelector).sticky({ topSpacing: 30, bottomSpacing: 630, center:false, className:"hey", getWidthFrom: btnASelector });
            $(btnBSelector).sticky({ topSpacing: 30, bottomSpacing: 630, center:false, className:"hey", getWidthFrom: btnBSelector });          
        }
        $("#accordionA, #accordionB").accordion({
            heightStyle: "content",
            collapsible: true,
            active: false
        });
    }

    function handleLogin(evt, $this, resultHandler) {
        evt.preventDefault();
        var params = $this.serializeArray();

        $this.find("input[type='submit']").prop("disabled", true);
        $("div.cpaSignInError").remove();
        $.post("/assets/php/cpa/auth.php", params, resultHandler, "json");
    }
    function handleNavLoginResult(data) {
        $("input[type='submit']", $signInNavDropdownForm).prop("disabled", false);
        if (data["status"] == "success") {
            location.reload(true);
        } else {
            $("div.cpaBullets").hide();
            $signInNavDropdownForm.after('<div class="cpaSignInError"><p><strong>ATTENTION:</strong> ' + data["message"] + '</p></div>');
        }
    }
    function handleCpaPageLoginResult(data) {
        var $cpaForm = $(modalFormSelector);
        
        $.get("/assets/php/cpa/clear_cache.php");                       // Clears user from PA Memcache
        $("input[type='submit']", $cpaForm).prop("disabled", false);
        if (data["status"] == "success") {
            $.get("/assets/php/cpa/generate_tp_link.php?l=" + getChosenLevel(), function(data) {
                winLoc.href = data["message"];
            }, "json");
        } else {
            var error = $('<div class="cpaSignInError"><p><strong>ATTENTION:</strong> ' + data["message"] + '</p></div>');
            $cpaForm.prepend(error);
        }
    }
    function handleCPACreateResult(data) {
        var $cpaForm = $(modalFormSelector);

        $("input[type='submit']", $cpaForm).prop("disabled", false);
        if (data["status"] == "success") {
            var level = getChosenLevel();
            $(modalSelector).remove();
            handle03Tinypass(level);
        } else {
            $cpaForm.prepend('<div class="cpaSignInError"><p><strong>ATTENTION:</strong> ' + data['message'] + '</p></div>').find("#loading").hide();
        }
    }

    function $getOverlay() {
        return $('<div id="' + overlayId + '" style="display:none;"></div>');
    }
    function getChosenLevel() {
        return $("#cpaChosenLevel").val();
    }
    function escOverlayClose(evt) {
        if (evt.keyCode == 27) {
            overlayClose();
        }
    }
    function overlayClose() {
        $(modalSelector).remove();
        $(overlaySelector).remove();
        disarmCloseButtons();
    }
    function escSignInNavCloseAnimation(evt) {
        if (evt.keyCode == 27) {
            signInNavCloseAnimation();
        }
    }
    function signInNavCloseAnimation() {
        $signInNavDropdown.slideUp(animationDuration);
        $signInNavLink.removeClass("active").on("click.openSignIn", signInOpenAnimation);
        removeHideLoginHandlers();
    }
    function signInOpenAnimation(evt) {
        evt.preventDefault();
        evt.stopPropagation();
        $signInNavLink.addClass("active").off("click.openSignIn").on("click.closeSignIn", function(evt) {
            evt.preventDefault();
            $(this).off("click.closeSignIn");
        });
        $signInNavDropdown.slideDown(animationDuration);
        setTimeout(addHideLoginHandlers, 0);                     // Need to wait for event bubbling to pass "body"
    }
});
