// creazione slider della home
function creaOpzioniSlider(idPagination, idPrev, idNext, iconPlay, iconPause, loopAttivo, idSliderContainer){
	var opzioniSlider={
		"autoplay": 8000,
		"loop":loopAttivo,
		"autoplayDisableOnInteraction":true,
		"preloadImages": true,
		"lazyLoading": true,
		"lazyLoadingInPrevNext":true,
        "nextButton": idNext,
        "prevButton": idPrev,
		"keyboardControl": true,
		"simulateTouch": false,
		"a11y": true,
		"prevSlideMessage":'Slide precedente',
		"nextSlideMessage":'Slide successiva',
		"firstSlideMessage":'Questa  la prima slide',
		"lastSlideMessage":"Questa  l'ultima slide",
		"paginationBulletMessage":'Vai alla slide {{index}}',
		"effect":	'slide',
		"onAutoplayStart": function(swiper){
			$( iconPlay).hide();
			$( iconPause ).show();
		},
		"onAutoplayStop": function(swiper){
			$( iconPause ).hide();
			$( iconPlay ).show();
		},	
		"onInit": function(swiper){
			$( idSliderContainer + '-play-pause').on('click', function () {
				if (swiper.autoplaying){
					swiper.stopAutoplay();
				}else{
					swiper.startAutoplay();
				};
			}).on('keypress',(function (e) {
			 var key = e.which;
			 if(key == 13)  // the enter key code
			  {
				$(this).click();
				return false;  
			  }
			})); 
			/*sistema 2: imposto i tabindex solo alla slide attiva*/
			if($(idSliderContainer).css("overflow") == "hidden"){
				$(idSliderContainer+' .swiper-slide a').attr("tabindex",-1);
				$(idSliderContainer+' .swiper-slide-active a').attr("tabindex",0);
			}
		},
		"onTransitionEnd": function(swiper){
			var $focused = $( document.activeElement );
			
			if($(idSliderContainer).css("overflow") == "hidden"){
				$(idSliderContainer+' .swiper-slide a').attr("tabindex",-1);
				$(idSliderContainer+' .swiper-slide-active a').attr("tabindex",0);
			}
			if($focused.closest(".swiper-slide").length > 0 && $focused.closest(idSliderContainer).length > 0){
				$(idSliderContainer+' .swiper-slide-active a').first().focus();
			}
		}		
	};
	
	if(idPagination!=undefined){
		opzioniSlider["pagination"]='.swiper-pagination';
        opzioniSlider["paginationClickable"]= idPagination;
	}
	return opzioniSlider;
 }
 
// funzione per inizializzare slider al document ready
 $(document).ready(function () {
	//slider per le immagini in copertina
	var opzioniMainSliderHome=creaOpzioniSlider("#swiper-mainsliderhome-pagination", "#swiper-mainsliderhome-button-prev", "#swiper-mainsliderhome-button-next", "#swiper-mainsliderhome-play-pause .swiper-play-icon", "#swiper-mainsliderhome-play-pause .swiper-pause-icon", false, "#swiper-mainsliderhome");
	var mainSliderHomeSwiper = new Swiper ('#swiper-mainsliderhome', opzioniMainSliderHome);
	
	// slider per le breaking news
	if($("#swiper-breakingnews .swiper-slide").length>1){
		// Modifica RL_01
		var opzioniBreakingNewsSwiper=creaOpzioniSlider(undefined, "#swiper-breakingnews-button-prev", "#swiper-breakingnews-button-next", "#swiper-breakingnews-play-pause .swiper-play-icon", "#swiper-breakingnews-play-pause .swiper-pause-icon", true, "#swiper-breakingnews");
		var breakingNewsSwiper = new Swiper ('#swiper-breakingnews', opzioniBreakingNewsSwiper);
		// END Modifica RL_01
	}else{
		$("#swiper-breakingnews .swiper-play-pause, #swiper-breakingnews .swiper-button-prev, #swiper-breakingnews .swiper-button-next").hide();
	}
	
});