// Generated by CoffeeScript 1.10.0
(function() {
  "use strict";
  var App, maps, mego, module, pathURL, utils,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  utils = Namespace('SEQ.utils');

  maps = Namespace('SEQ.gmaps');

  mego = Namespace("SEQ.mego");

  module = Namespace('SEQ.mego.module');

  pathURL = window.location.href.substr(0, location.href.indexOf("/", 8) + 1);

  App = (function() {
    function App() {
      this.onDocReady = bind(this.onDocReady, this);
      $(document).ready(this.onDocReady);
    }

    App.prototype.onDocReady = function() {
      mego.SITEVARS = $('#site-vars');
      mego.VAR_WEBSITE = mego.SITEVARS.find('.var-website').val() || "world";
      mego.WEBSITE_URL = "";
      mego.WEBSITE_URL = "/" + mego.VAR_WEBSITE;
      this.initFoundation = new mego.module.InitFoundation();
      this.initVisitBritain = new mego.module.InitVisitBritain();
      this.initSitemap = new mego.module.InitSiteMap();
      this.initLanguageToggle = new mego.module.InitLanguageToggle();
      this.initMiniBasket = new mego.module.InitMiniBasket();
      this.initShare = new mego.module.InitShare();
      this.initNewsletterSignup = new mego.module.InitNewsletterSignup();
      this.initSyncHeight = new mego.module.InitSyncHeight();
      this.initProductTabs = new mego.module.InitProductTabs();
      this.InitPaymentAccordion = new mego.module.InitPaymentAccordion();
      this.initSearchResults = new mego.module.InitSearchResults();
      this.initImageMaps = new mego.module.InitImageMaps();
      this.initVideoModal = new mego.module.InitVideoModal();
      this.initGoogleMaps = new mego.module.InitGoogleMaps();
      this.initUserAccount = new mego.module.InitUserAccount();
      this.initAddressTools = new mego.module.InitAddressTools();
      this.initEcommerce = new mego.module.InitEcommerce();
      this.initCurrencyConversion = new mego.module.InitCurrencyConversion();
      this.initLazyPagination = new mego.module.InitLazyPagination();
      this.initToggleSelect = new mego.module.InitToggleSelect();
      this.initProductFilter = new mego.module.InitProductFilter();
      this.initPasswordStrength = new mego.module.InitPasswordStrength();
      return this.InitSwitchFieldType = new mego.module.InitSwitchFieldType();
    };

    return App;

  })();

  mego.app = new App();

}).call(this);


// GDPR stuff hacked in because compilers don't seem to exist any more
// and nobody understands the structure of this code without a lot more time
// being spent on it

(function() {
  // GDPR cookie functionality
  var functionalName = 'gdprFunctional';
  var performanceName = 'gdprPerformance';

  var CookieGDPR = {
    isSet: function() {
      var cookieString = '; ' + document.cookie;
      var functionalCookie = cookieString.split('; ' + functionalName + '=');
      var performanceCookie = cookieString.split('; ' + performanceName + '=');
      return functionalCookie.length === 2 || performanceCookie.length === 2;
    },

    setFunctional: function(value) {
      if (value === undefined) value = 1;
      var date = new Date();
      date.setFullYear(date.getFullYear() + 1);
      date = date.toGMTString();
      document.cookie = functionalName + '=' + String(value) + '; expires=' + date + '; path=/;';
    },

    setPerformance: function(value) {
      if (value === undefined) value = 1;
      var date = new Date();
      date.setFullYear(date.getFullYear() + 1);
      date = date.toGMTString();
      document.cookie = performanceName + '=' + String(value) + '; expires=' + date + '; path=/;';
    },

    getFunctional: function() {
      var cookieString = '; ' + document.cookie;
      var parts = cookieString.split('; ' + functionalName + '=');
      return (parts.length === 2) ? Number(parts.pop().split(';').shift()) : 1;
    },

    getPerformance: function() {
      var cookieString = '; ' + document.cookie;
      var parts = cookieString.split('; ' + performanceName + '=');
      return (parts.length === 2) ? Number(parts.pop().split(';').shift()) : 1;
    }
  };


  // GDPR notice banner
  var cookieNotice = document.querySelector('[data-component="cookie-notice"]');
  var continueButton = document.querySelector('[data-cookie-notice="continue-button"]');

  function handleContinueButtonClick(event) {
    CookieGDPR.setFunctional();
    CookieGDPR.setPerformance();
    cookieNotice.classList.remove('active');
  }

  if (cookieNotice) {
    if (!CookieGDPR.isSet()) cookieNotice.classList.add('active');
    if (continueButton) continueButton.addEventListener('click', handleContinueButtonClick);
  }

  // GDPR options page
  var functionalCheckbox = document.querySelector('[data-cookie-options="functional-checkbox"]');
  var performanceCheckbox = document.querySelector('[data-cookie-options="performance-checkbox"]');

  function handleFunctionalCheckboxChange(event) {
    var value = functionalCheckbox.checked ? 1 : 0;
    CookieGDPR.setFunctional(value);
    location.href = location.href;
  }

  function handlePerformanceCheckboxChange() {
    var value = performanceCheckbox.checked ? 1 : 0;
    CookieGDPR.setPerformance(value);
    location.href = location.href;
  }

  if (functionalCheckbox) {
    if (CookieGDPR.getFunctional() === 1) functionalCheckbox.checked = true;
    functionalCheckbox.addEventListener('change', handleFunctionalCheckboxChange);
  }

  if (performanceCheckbox) {
    if (CookieGDPR.getPerformance() === 1) performanceCheckbox.checked = true;
    performanceCheckbox.addEventListener('change', handlePerformanceCheckboxChange);
  }
})();
