// funzioni per la tooltip
function xstooltip_findPosX(obj)
{
	var curleft = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent) 
		{
			curleft += obj.offsetLeft
			obj = obj.offsetParent;
		}
	}
	else if (obj.x)
		curleft += obj.x;

	return curleft;
}

function xstooltip_findPosY(obj)
{
	var curtop = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curtop += obj.offsetTop
			obj = obj.offsetParent;
		}
	}
	else if (obj.y)
		curtop += obj.y;

	return curtop;
}

function showPopupAlignDX(prefix, i, h, effect)
{
	id = prefix+"_"+i+"_"+h;
	idparent = "parent_"+prefix+"_"+i+"_"+h;
	obj = document.getElementById(id);
	objparent = document.getElementById(idparent);

	doEffect(obj, effect);
	open_box = id;

	obj.style.left = xstooltip_findPosX(objparent)+"px";
	obj.style.top = xstooltip_findPosY(objparent)+20+"px";
}

function showPopupAlignSX(prefix, i, h, effect)
{
	id = prefix+"_"+i+"_"+h;
	idparent = "parent_"+prefix+"_"+i+"_"+h;
	obj = document.getElementById(id);
	objparent = document.getElementById(idparent);

	doEffect(obj, effect);
	open_box = id;

	obj.style.left = xstooltip_findPosX(objparent)-320+"px";
	obj.style.top = xstooltip_findPosY(objparent)+20+"px";
}

function showPopup(prefix, i, h, effect)
{
	id = prefix+"_"+i+"_"+h;
	idparent = "parent_"+prefix+"_"+i+"_"+h;
	obj = document.getElementById(id);
	objparent = document.getElementById(idparent);

	doEffect(obj, effect);
	open_box = id;

	obj.style.left = xstooltip_findPosX(objparent)-320+"px";
	obj.style.top = xstooltip_findPosY(objparent)+20+"px";
}

function showEventPopup(prefixID, tableID, i, h, effect)
{
	id = prefixID+"_"+tableID+"_"+i+"_"+h;
	idparent = tableID+":cell:"+i+":"+h;
	obj = document.getElementById(id);
	objparent = document.getElementById(idparent);

	doEffect(obj, effect);

	obj.style.left = xstooltip_findPosX(objparent)+"px";
	obj.style.top = xstooltip_findPosY(objparent)+20+"px";
}

function showLegend(id, effect, img)
{
	obj = document.getElementById(id);
	doEffect(obj, effect);

	manageOpenCloseButton(img);
}

function showHiddenBox(id, effect)
{
	obj = document.getElementById(id);
	doEffect(obj, effect);
}

function manageOpenCloseButton(img)
{
	var source = img.src;
	parts = source.split('/');
	if (parts.pop() == "plus-icon.png")
		img.src = "images/minus-icon.png";
	else
		img.src = "images/plus-icon.png";
}

function hideDetails(id, effect)
{
	obj = document.getElementById(id);
	doEffect(obj, effect);
}

function showHelp()
{
	id = "id_help_box";
	idparent = "parent_help_box";
	obj = document.getElementById(id);
	objparent = document.getElementById(idparent);

	doEffect(obj, "appear");

	obj.style.left = xstooltip_findPosX(objparent)-380+"px";
	obj.style.top = xstooltip_findPosY(objparent)+20+"px";
}

function hideHelp()
{
	id = "id_help_box";
	obj = document.getElementById(id);
	doEffect(obj, "appear");
}

function showForm(id, effect, img)
{
	obj = document.getElementById(id);
	doEffect(obj, effect);

	manageOpenCloseButton(img);
}

function doEffect(obj, effect)
{
	if (effect == "appear")
		$(obj).fadeToggle();
	else if (effect == "slide" || effect == "blind")
		$(obj).slideToggle();
	else if (effect == "scroll")
		$("html, body").animate({ scrollTop: $(document).height() }, "slow");
}