var bannerWidth = 994,
    currentLoop = 0,
    totalLoops = -1;

var PERSPECTIVE = window.PERSPECTIVE,
    TRANSFORM = window.TRANSFORM;

function setTransform(args) {
    var x = args.x || 0,
        y = args.y || 0,
        rot = args.rot || 0.001,
        scale = typeof args.scale !== 'undefined' ? args.scale : 1;

    if (PERSPECTIVE) args.el.style[TRANSFORM] = 'translate3d(' + x + 'px, ' + y + 'px, 0) rotateZ(' + rot + 'deg) scale(' + scale + ')';
    else args.el.style[TRANSFORM] = 'translate(' + x + 'px, ' + y + 'px) rotate(' + rot + 'deg) scale(' + scale + ')';
}

function loop(time) {
    requestAnimationFrame(loop);
    TWEEN.update(time);
}

// -----------------------------------------------  Sizmek Funtion ------------------------------------------


var adDiv;

function initEB() {
    if (!EB.isInitialized()) {
        EB.addEventListener(EBG.EventName.EB_INITIALIZED, startAd);
    } else {
        startAd();
    }
}

function startAd() {
    adDiv = document.getElementById("geberitStage");

    addEventListeners();
}

function addEventListeners() {
    document.getElementById("clickArea").addEventListener("click", clickthrough);
}

function clickthrough() {
    EB.clickthrough();
    console.log("EB.clickthrough");
}

window.addEventListener("load", initEB);



//--------------------------------------------------------------------------------------------------------------------------
//----------------------------------

if (document.readyState === 'complete') {
    start();
} else {
    window.onload = start;
}

//-----------------------------------

function start() {
    if (typeof TRANSFORM !== 'undefined') {

        loop();
        reset();
        geberitStage.style.opacity = 1;
        step1();
    }
}

function reset() {
    TWEEN.removeAll();

    geberitFace1.style.opacity = 1;
    geberitFace2.style.opacity = 1;
    geberitFace3.style.opacity = 1;
    geberitFace4.style.opacity = 1;

    geberitILW.style.opacity = 0;

    geberitText1.style.opacity = 0;
    geberitText2.style.opacity = 0;
    geberitText3.style.opacity = 0;
    geberitText4.style.opacity = 0;
    geberitText5.style.opacity = 0;
    geberitText6.style.opacity = 0;

    geberitCta.style.opacity = 0;

    setTransform({el: geberitColorOverlay,x: 0});
}

function step1() {
    new TWEEN.Tween({o: 0}).to({o: 1}, 250).onUpdate(function () {
        geberitText1.style.opacity = this.o;
    }).start();

    setTimeout(step2_in, 3500);
}

function step2_in() {
    new TWEEN.Tween({o: 1}).to({o: 0}, 250).onUpdate(function () {
        geberitText1.style.opacity = this.o;
    }).start();

    new TWEEN.Tween({x: 0}).to({x: -1 * bannerWidth}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x});
        })
        .delay(250).start();

    new TWEEN.Tween({o: 0}).to({o: 1}, 250).onUpdate(function () {
        geberitText2.style.opacity = this.o;
    }).delay(250).start();

    setTimeout(step2_out, 2500);
}

function step2_out() {
    new TWEEN.Tween({o: 1}).to({o: 0}, 250).onUpdate(function () {
        geberitText2.style.opacity = this.o;
    }).start();

    new TWEEN.Tween({x: -1 * bannerWidth}).to({x: 0}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x})
        })
        .start();

    setTimeout(step3_in, 500);
}


function step3_in() {

    geberitFace1.style.opacity = 0;

    new TWEEN.Tween({x: 0}).to({x: -1 * bannerWidth}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x});
        })
        .delay(250).start();

    new TWEEN.Tween({o: 0}).to({o: 1}, 250).onUpdate(function () {
        geberitText3.style.opacity = this.o;
    }).delay(250).start();

    setTimeout(step3_out, 2500);
}

function step3_out() {
    new TWEEN.Tween({o: 1}).to({o: 0}, 250).onUpdate(function () {
        geberitText3.style.opacity = this.o;
    }).start();

    new TWEEN.Tween({x: -1 * bannerWidth}).to({x: 0}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x})
        })
        .start();

    setTimeout(step4_in, 500);
}


function step4_in() {

    geberitFace2.style.opacity = 0;

    new TWEEN.Tween({x: 0}).to({x: -1 * bannerWidth}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x});
        })
        .delay(250).start();

    new TWEEN.Tween({o: 0}).to({o: 1}, 250).onUpdate(function () {
        geberitText4.style.opacity = this.o;
    }).delay(250).start();

    setTimeout(step4_out, 2500);
}

function step4_out() {
    new TWEEN.Tween({o: 1}).to({o: 0}, 250).onUpdate(function () {
        geberitText4.style.opacity = this.o;
    }).start();

    new TWEEN.Tween({x: -1 * bannerWidth}).to({x: 0}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x})
        })
        .start();

    setTimeout(step5_in, 500);
}


function step5_in() {

    geberitFace3.style.opacity = 0;

    new TWEEN.Tween({x: 0}).to({x: -1 * bannerWidth}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x});
        })
        .delay(250).start();

    new TWEEN.Tween({o: 0}).to({o: 1}, 250).onUpdate(function () {
        geberitText5.style.opacity = this.o;
    }).delay(250).start();

    setTimeout(step5_out, 2500);
}

function step5_out() {
    new TWEEN.Tween({o: 1}).to({o: 0}, 250).onUpdate(function () {
        geberitText5.style.opacity = this.o;
    }).start();

    new TWEEN.Tween({x: -1 * bannerWidth}).to({x: 0}, 500)
        .easing(TWEEN.Easing.Sinusoidal.InOut)
        .onUpdate(function () {
            setTransform({el: geberitColorOverlay, x: this.x})
        })
        .start();

    setTimeout(step6_in, 500);
}

function step6_in() {

    new TWEEN.Tween({o: 0}).to({o: 1}, 250).onUpdate(function () {
        geberitText6.style.opacity = this.o;
    }).start();

    setTimeout(step6, 500);
}


function step6() {
    new TWEEN.Tween({o: 0}).to({o: 1}, 500).onUpdate(function () {
        geberitCta.style.opacity = this.o;
    }).delay(250).start();

    setTimeout(function () {
        new TWEEN.Tween({o: 1}).to({o: 0.25}, 250).onUpdate(function () {
            geberitCta.style.opacity = this.o;
        }).yoyo(true).repeat(5).start();
    }, 1500);

    if (currentLoop < totalLoops || totalLoops < 0) {
        setTimeout(step6_out, 4000);
        currentLoop++;
    }
}

function step6_out() {

    new TWEEN.Tween({o: 1}).to({o: 0}, 250).onUpdate(function () {
        geberitText6.style.opacity = this.o;
    }).start();

    setTimeout(step7, 500);
}


function step7() {

    new TWEEN.Tween({o: 0}).to({o: 1}, 500).onUpdate(function () {
        geberitILW.style.opacity = this.o;
    }).delay(0).start();

    setTimeout(step8, 4500);
}

function step8() {
    new TWEEN.Tween({o: 1}).to({o: 0}, 500).onUpdate(function () {
        geberitCta.style.opacity = this.o;
    }).start();

    new TWEEN.Tween({o: 1}).to({o: 0}, 500).onUpdate(function () {
        geberitILW.style.opacity = this.o;
    }).start();

    setTimeout(function () {
        reset();
        step1();
    }, 2000);
}