(function(){
	var jml = function (elName, atts, children) {'use strict';var el = typeof elName === 'string' ? document.createElement(elName) : elName;if (atts && Array.isArray(atts)) {children = atts;}else if (atts) {Object.keys(atts).forEach(function (att) {var attVal = atts[att];if (att === '$on') {return Object.keys(attVal).forEach(function(ev){var val = attVal[ev];val=(typeof val === 'function')?[val,false]:val;el.addEventListener(ev,val[0],val[1]);});}if(typeof attVal === 'object'){return Object.keys(attVal).forEach(function(prop) {el[att][prop.replace(/-([a-z])/g,function(n0, n1){return n1.toUpperCase();})]=attVal[prop];});}el.setAttribute(att, attVal);});}(children||[]).forEach(function(child){if(typeof child === 'string'){el.appendChild(document.createTextNode(child));}else {el.appendChild(jml.apply(null, child));}});return el;};
	var TITOLARE = "titolare";
	var TITOLOINFORMATIVA = "titoloinformativa";
	var SERVIZI = "servizi";
	var COOKIETECNICI = "cookietecnici";
	var INFOCOOKIE = "infocookie";
	var COOKIENAME = "cookieprivacysettings";
	var POLICYTITLE = "policytitle";
	var POLICYTEXT = "policytext";
	var OKACTIONTEXT = "okactiontext";
	var MOREACTIONTEXT = "moreactiontext";
	var SCROLLTIMEOUT = "scrolltimeout";
	var PROSEGUI = "prosegui";

	var presets = {};
		presets["cookie-tecnici-sessione"] = {
			title: "Attività strettamente necessarie al funzionamento",
			description: "Questo Sito utilizza Cookie per salvare la sessione dell'Utente e per svolgere altre attività strettamente necessarie al funzionamento dello stesso."
		};
		presets["cookie-tecnici-preferenze"] = {
			title: "Attività di salvataggio delle preferenze e ottimizzazione",
			description: "Questo Sito utilizza Cookie per salvare le preferenze di navigazione ed ottimizzare l'esperienza di navigazione dell'Utente."
		};
		presets["google-analytics"] = {
			name: "Google Analytics",
			company: "Google Inc.",
			description: "Google Analytics è un servizio di analisi web fornito da Google Inc. (“Google”). Google utilizza i Dati Personali raccolti allo scopo di tracciare ed esaminare l’utilizzo di questo Sito, compilare report e condividerli con gli altri servizi sviluppati da Google. Google potrebbe utilizzare i Dati Personali per contestualizzare e personalizzare gli annunci del proprio network pubblicitario.",
			use: "Cookie e Dati di utilizzo.",
			where: "USA",
			policylink: "http://www.google.com/intl/it/policies/privacy/",
			optoutlink: "http://tools.google.com/dlpage/gaoptout?hl=it"
		};

	if(window.COOKPM) {
		return;
	}
	var _ = {};
	_.options = {};
	_.options[COOKIETECNICI] = [];
	_.options[SERVIZI] = [];
	_.options[TITOLOINFORMATIVA] = "Informativa estesa sui cookie";
	_.options[TITOLARE] = {"nominativo":"[INDICARE NOMITIVO]", "email":"[INDICARE EMAIL]"};
	_.options[INFOCOOKIE] = "I Cookie sono costituiti da porzioni di codice installate all'interno del browser che assistono il Titolare nell’erogazione del servizio in base alle finalità descritte. Alcune delle finalità di installazione dei Cookie potrebbero, inoltre, necessitare del consenso dell'Utente.";
	_.options[SCROLLTIMEOUT] = 500;
	_.options[POLICYTITLE] = 'Informativa';
	_.options[POLICYTEXT] = 'Questo sito o gli strumenti terzi da questo utilizzati si avvalgono di cookie necessari al funzionamento ed utili alle finalità illustrate nella cookie policy. Se vuoi saperne di più o negare il consenso a tutti o ad alcuni cookie, consulta la cookie policy. Chiudendo questo banner, scorrendo questa pagina, cliccando su un link o proseguendo la navigazione in altra maniera, acconsenti all’uso dei cookie.';
	_.options[OKACTIONTEXT] = 'Accetto';
	_.options[MOREACTIONTEXT] = 'Cookie policy: dettagli e impostazioni';
	_.options[PROSEGUI] = "Proseguendo la navigazione o chiudendo la finestra presti il tuo consenso all’utilizzo di cookie.";
	_.getOption = function(op) {
		return _.options[op];
	};

	_.userAccepted = function(){
		return /__COOKPM=true/.test(document.cookie);
	};

	_.removeCookie = function(ev){
		document.cookie = '__COOKPM=; expires=Thu, 01 Jan 1970 00:00:01 GMT;';
	};

	_.setOptions = function(ops) {
		for(var op in ops)
		_.setOption(op,ops[op]);
	};

	_.setOption = function(op,val) {
		_.options[op] = val;
	};

	var userAcceptImplicit = function(){
		userAccept();
	};
	var userAcceptExplicit = function(ev){
		if(ev && ev.preventDefault) {
			ev.preventDefault();
		}
		userAccept();
	};
	var userAccept = function(ev){
		if(_.userAccepted()) {
			return;
		}
		var exp = new Date();
		exp = new Date(exp.getTime() + 1000*60*60*24*365); // 365 days
		document.cookie = "__COOKPM=true; expires=" + exp.toGMTString() + ";";
		_.hideBanner();
	};
	var hidePolicy = function(ev){
		if(ev && ev.preventDefault) {
			ev.preventDefault();
		}
		if (ev && ev.stopPropagation) {
			ev.stopPropagation();
		}
		if(document.querySelector("#COOKPM-MODALOVERLAY")) {
			document.querySelector("body").removeChild(document.querySelector("#COOKPM-MODALOVERLAY"));
		}
		userAcceptExplicit();		
	};
	_.showPolicy = function(ev){
		if(ev && ev.preventDefault) {
			ev.preventDefault();
		}

		var policyChildren = [];
		policyChildren.push(["h1",{class: "COOKPM-policytitle"},[_.getOption(TITOLOINFORMATIVA)]]);
		policyChildren.push(["a",{title: "Chiudi", href: "#",class: "COOKPM-x COOKPM-hidden","$on": {click: [hidePolicy]}},["×"]]);
		policyChildren.push(["p",{class:"COOKPM-sub"},[_.getOption(INFOCOOKIE)]]);
		policyChildren.push(["h2",["Cookie tecnici"]]);
		policyChildren.push(["p",{class:"COOKPM-sub"},["I cookie tecnici sono utilizzati al solo fine di erogare i servizi offerti dal sito; per la loro installazione non è richiesto il preventivo consenso degli utenti."]]);

		var cookietecnici = _.getOption(COOKIETECNICI);
		cookietecnici.forEach(function (servizio) {
			if(typeof servizio === "string"){
				if(presets[servizio]) {
					servizio = presets[servizio];
				}
			}
			policyChildren.push(["div",{class:"COOKPM-servizio"},[["h3",[servizio.title]],["p",[servizio.description]]]]);
		});

		policyChildren.push(["h2",["Altre tipologie di Cookie o strumenti terzi che potrebbero farne utilizzo"]]);
		policyChildren.push(["p",{class:"COOKPM-sub"},["Alcuni dei servizi elencati di seguito raccolgono statistiche in forma aggregata e potrebbero non richiedere il consenso dell'Utente o potrebbero essere gestiti direttamente dal Titolare – a seconda di quanto descritto – senza l'ausilio di terzi"]]);
		policyChildren.push(["p",{class:"COOKPM-sub"},["Qualora fra gli strumenti indicati in seguito fossero presenti servizi gestiti da terzi, questi potrebbero – in aggiunta a quanto specificato ed anche all’insaputa del Titolare – compiere attività di tracciamento dell’Utente. Per informazioni dettagliate in merito, si consiglia di consultare le privacy policy dei servizi elencati."]]);

		var servizi = _.getOption(SERVIZI);
		servizi.forEach(function (servizio) {
			if(typeof servizio === "string"){
				if(presets[servizio]) {
					servizio = presets[servizio];
				}
			}
			policyChildren.push(["div",{class:"COOKPM-servizio"},[
				["h3",[servizio.name + (servizio.company ? " (" + servizio.company + ")" : '')]],
				servizio.description ? ["p",[servizio.description]] : "",
				servizio.use ? ["p",["Dati personali raccolti: " + servizio.use]] : "",
				servizio.where ? ["p",["Luogo del trattamento: " + servizio.where]] : "",
				servizio.policylink || servizio.optoutlink ? ["p",[
					servizio.policylink ? ["a",{href:servizio.policylink,target:"_blank"},["Privacy Policy"]] : "",
					servizio.policylink && servizio.optoutlink ? " – " : "",
					servizio.optoutlink ? ["a",{href:servizio.optoutlink,target:"_blank"},["Opt Out"]] : "",
				]] : ''
			]]);
		});

		policyChildren.push(["h2",["Come posso controllare l'installazione di Cookie?"]]);
		policyChildren.push(["p",{class:"COOKPM-sub"},["In aggiunta a quanto indicato in questo documento, l'Utente può gestire le preferenze relative ai Cookie direttamente all'interno del proprio browser ed impedire – ad esempio – che terze parti possano installarne. Tramite le preferenze del browser è inoltre possibile eliminare i Cookie installati in passato, incluso il Cookie in cui venga eventualmente salvato il consenso all'installazione di Cookie da parte di questo sito."]]);
		policyChildren.push(["h2",["Titolare del trattamento dei dati"]]);
		policyChildren.push(["p",[_.getOption(TITOLARE).nominativo + (_.getOption(TITOLARE).email ? ", " + _.getOption(TITOLARE).email : "")]]);
		policyChildren.push(["div",{id: "COOKPM-chiudi",class: "COOKPM-hidden"},[_.getOption(PROSEGUI),["button",{"$on": {click: [hidePolicy]}},["Prosegui la navigazione"]]]]);

		var policy = jml("div",{
			id: "COOKPM-MODAL",
			class: "COOKPM-hidden",
			"$on": {"click":[function(ev){ev.stopPropagation();}]}
		},policyChildren);

		var modaloverlay = document.createElement("div");
			modaloverlay.setAttribute("id","COOKPM-MODALOVERLAY");
			modaloverlay.appendChild(policy);
			modaloverlay.addEventListener("click",function(ev){ev.stopPropagation();});
		var body = document.querySelector("body");
			body.appendChild(modaloverlay);
			setTimeout(function(){
				policy.setAttribute("class","");
				document.querySelector("#COOKPM-chiudi").setAttribute("class","");
				document.querySelector("#COOKPM-MODAL .COOKPM-x").setAttribute("class","COOKPM-x");
			},10);
	};
	var showBanner = function(){
		var x = document.createElement("a");
			x.innerHTML = "&times;";
			x.setAttribute("href","#");
			x.setAttribute("class","COOKPM-x");
			x.addEventListener('click',userAcceptExplicit);
		var body = document.querySelector("body");
		var banner = document.createElement("div");
			banner.setAttribute("id","COOKPM-BANNER");
		var policytitle = document.createElement("div");
			policytitle.setAttribute("class","COOKPM-policytitle");
			policytitle.innerHTML = _.getOption(POLICYTITLE);
		var policytext = document.createElement("div");
			policytext.setAttribute("class","COOKPM-policytext");
			policytext.innerHTML = _.getOption(POLICYTEXT);
		var actions = document.createElement("div");
			actions.setAttribute("class","COOKPM-actions");
		var okaction = document.createElement("button");
			okaction.setAttribute("class","COOKPM-okaction");
			okaction.innerHTML = _.getOption(OKACTIONTEXT);
			okaction.addEventListener('click',userAcceptExplicit);
		var moreaction = document.createElement("button");
			moreaction.setAttribute("class","COOKPM-moreaction");
			moreaction.innerHTML = _.getOption(MOREACTIONTEXT);
			moreaction.addEventListener("click",_.showPolicy);
		banner.addEventListener('click',function(ev) {
			if (!ev){
				ev = window.event;
			}
			//IE9 & Other Browsers
			if (ev.stopPropagation) {
				ev.stopPropagation();
			}
			//IE8 and Lower
			else {
				ev.cancelBubble = true;
			}
		});
		body.appendChild(banner);
		banner.appendChild(policytitle);
		banner.appendChild(policytext);
		banner.appendChild(actions);
		actions.appendChild(okaction);
		actions.appendChild(moreaction);
		policytitle.appendChild(x);
	};

	_.hideBanner = function(){
		if(document.querySelector("#COOKPM-BANNER")) {
			document.querySelector("body").removeChild(document.querySelector("#COOKPM-BANNER"));
		}
	};
	_.showBanner = function(){
		if(_.userAccepted()) {
			return;
		}
		if(document.querySelector("#COOKPM-BANNER")) {
			return;
		}
		showBanner();
	};
	if(!_.userAccepted()) {
		setTimeout(function(){document.addEventListener("scroll",function() {
			if(document.querySelector("#COOKPM-MODAL") === null) {
				userAcceptImplicit();
			}
		});},_.getOption(SCROLLTIMEOUT));
		document.addEventListener("click",userAcceptImplicit);
	}

	window.COOKPM = _;
})();