var GPU = (function () {
    'use strict';
    var console = (function(c){ return { log: function(title,text,returnVal){ if(config.debug && window.console) {c.info(title); c.log(text);} return returnVal;}, info: function (text) { if(config.debug) c.info(text); }};}(window.console && window.console)); window.console = console;
    var config = {
        cookieTime: 10,
        target: "",
        maxPop: 999,
        mobile: true,
        desktop: true,
        tabUnder: false,
        prefix: "gpux",
        refresh : true,
        active: true,
        interval: 5,
        debug:false,
        mobilePopup: true
    };
    var client = (function () {
        var os = {
            isWindows: function() {
                return navigator.userAgent.match(/Windows/i);
            },
            isLinux: function() {
                return navigator.userAgent.match(/Linux|X11/i);
            },
            isMacOs: function() {
                return navigator.userAgent.match(/Mac/i);
            },
            isAndroid: function() {
                return navigator.userAgent.match(/Android/i);
            },
            isBlackBerry: function() {
                return navigator.userAgent.match(/BlackBerry/i);
            },
            isiOS: function() {
                return navigator.userAgent.match(/iPhone|iPad|iPod/i);
            },
            isOpera: function() {
                return navigator.userAgent.match(/Opera Mini/i);
            },
            isWindowsMobile: function() {
                return navigator.userAgent.match(/IEMobile/i) || navigator.userAgent.match(/WPDesktop/i);
            },
            isBlocked : function (){
                var val = navigator.userAgent.match(/Open BSD|QNX|OS\/2|SunOS|BeOS|nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask Jeeves\/Teoma|ia_archiver|UNIX/i);
                return val ? true : false;
            },
            isMobile: function() {
                var val = (os.isAndroid() || os.isBlackBerry() || os.isiOS() || os.isOpera() || os.isWindowsMobile());
                return val ? true : false;
            },
            isDesktop: function() {
                var val = (os.isWindows() || os.isLinux() || os.isMacOs());
                return val ? true : false;
            },
            name: function(){
                return (os.isWindows() || os.isAndroid() || os.isBlackBerry() || os.isiOS() || os.isOpera() || os.isWindowsMobile())
            }
        };
        var browser = {
            isChrome: function(){
                return navigator.vendor.match(/Google Inc/i) && navigator.userAgent.match(/Chrome/i) ;
            },
            isFirefox: function(){
                return navigator.userAgent.match(/Firefox/i);
            },
            isIe: function(){
                return navigator.userAgent.match(/msie|trident/i);
            },
            isEdge: function(){
                return navigator.userAgent.match(/Edge/i);
            },
            isOpera: function(){
                var val = navigator.userAgent.match(/OPR|Opera/i) ;
                return val ? "Opera" : false;
            },
            isSafari: function(){
                return navigator.vendor.match(/Apple Computer/i) && navigator.userAgent.match(/Safari/i) ;
            },
            isChromium: function(){
                return navigator.userAgent.match(/Chromium/i);
            },
            isIosChrome: function(){
                return navigator.userAgent.match(/CriOS/i);
            },
            isBlocked: function(){
                var val = (browser.isChrome() || browser.isFirefox() || browser.isIe() || browser.isEdge() || browser.isOpera() || browser.isSafari() || browser.isChromium() || browser.isIosChrome());
                return val ? false : true;
            },
            name: function(){
                return (browser.isChrome() || browser.isFirefox() || browser.isIe() || browser.isEdge() || browser.isOpera() || browser.isSafari() || browser.isChromium() || browser.isIosChrome())
            }
        };
        var plugins = {
            //Chrome PDF Viewer
            isInstalled : function (pluginName) {
                for (var i=0; i<navigator.plugins.length; i++)
                    if (navigator.plugins[i].name == pluginName) return true;
                return false;
            },
            isAdBlock : function(){
                var test = document.createElement('div');
                test.innerHTML = '&nbsp;';
                test.className = 'adsbox';
                document.body.appendChild(test);
                if(!test.offsetHeight)
                    return true;
                return false;
            }
        };
        var utils = {
            screenWidth: function () {
                return screen.width;
            },
            screenHeight: function () {
                return screen.height;
            },
            documentWidth: function () {
                var w = window,
                    d = document,
                    e = d.documentElement,
                    g = d.getElementsByTagName('body')[0];
                return w.innerWidth || e.clientWidth || g.clientWidth;
            },
            documentHeight: function () {
                var w = window,
                    d = document,
                    e = d.documentElement,
                    g = d.getElementsByTagName('body')[0];
                return w.innerHeight|| e.clientHeight|| g.clientHeight;
            },
            screenPositionX : function (){
                return window.screenLeft ? window.screenLeft : window.screenX;
            },
            screenPositionY: function(){
                return window.screenTop ? window.screenTop : window.screenY;
            }
        };
        var storage = {
            set : function(name,val){
                localStorage.setItem(name,JSON.stringify(val));
            },
            get : function (name) {
                var val = JSON.parse(localStorage.getItem(name));
                return val ? val : false;
            },
            del : function (name) {
                localStorage.removeItem(name);
            }
        };
        var cookie = {
            set : function (name,val,seconds){
                var d = new Date();
                d.setTime(d.getTime() + (seconds * 1000));
                var expires = "expires="+d.toUTCString();
                document.cookie = name + "=" + val + ";" + expires + ";path=/";
            },
            get : function (name) {
                var cookieMatch = document.cookie.match(new RegExp(name + '=([^;]+)'));
                if(cookieMatch) return JSON.parse(decodeURIComponent(cookieMatch[1]));
                return false;
            },
            del : function (name) {
                document.cookie = name + '=; expires=Mon, 01 Feb 1993 10:00:00 GMT;';
            },
            enabled : function () {
                return navigator.cookieEnabled;
            }
        };
        return {
            operatingSystem : os,
            agent: browser,
            plugins: plugins,
            utils : utils,
            cookie : cookie,
            storage : storage
        }
    })();
    var make = (function () {
        var urls = [], url, WinPop,popId, target;
        function make() {
            console.info("GetPopUnder JS V.4");
            console.info("DEBUGGER ON");
            console.info("------------------");
            for(var i = 0; i < arguments.length; i++)
                urls[i] = arguments[i];
            action.target();
            if(!action.canPop()) return;
            win.preCheck();
            win.on({event:"click",target:target,function:action.run});
            if(!config.refresh) {
                config.cookieTime = config.interval;
                setInterval(function () {
                    win.on({event: "click", target: target, function: action.run});
                }, config.interval * 1000);
            }
        }
        var action = {
            canPop : function () {
                if(!config.active)
                    return console.log("Config Active",config.active,false);
                if(urls.length == 0)
                    return console.log("Url List",urls,false);
                if(!client.cookie.enabled())
                    return console.log("Cookie Enabled",client.cookie.enabled(),false);
                if(parseInt(client.cookie.get(config.prefix + "_complete")))
                    return console.log("Waiting Next Pop",parseInt(client.cookie.get(config.prefix + "_complete")),false);
                if(client.operatingSystem.isBlocked())
                    return console.log("Not allowed operating system",client.operatingSystem.isBlocked(),false);
                if(client.operatingSystem.isMobile() && !config.mobile)
                    return console.log("Config Mobile",config.active,false);
                if(client.operatingSystem.isDesktop() && !config.desktop)
                    return console.log("Config Desktop",config.active,false);
                if(parseInt(client.storage.get(config.prefix + "_capped")) >= parseInt(config.maxPop))
                    return console.log("Pop Capped Max:"+parseInt(config.maxPop),parseInt(client.storage.get(config.prefix + "_capped")),false);
                return console.log("Pop Status","Ready Click Bind On " + target,true);
            },
            run : function (e){
                if(!action.canPop()) return;
                if(!client.operatingSystem.isMobile() || client.operatingSystem.isMobile() && client.operatingSystem.isAndroid() && client.agent.isChrome() ) e.preventDefault();
                action.uid();
                console.log("Pop Session ID: ", popId);
                var next =  parseInt(client.storage.get(config.prefix + "_capped")) || 0;
                next = next % urls.length;
                url = urls[next];
                if(client.operatingSystem.isMobile() && client.operatingSystem.isAndroid() && client.agent.isChrome()){
                    win.mobile();
                }
                if(!WinPop && client.plugins.isAdBlock() && !client.operatingSystem.isMobile()){
                    win.behind();
                }
                if(!WinPop && client.operatingSystem.isMobile()){
                    WinPop = win.mobileOthers();
                }
                if(!WinPop && client.agent.isChrome()) {
                    //win.top = 20033;
                    //win.left = 20033;
                    //win.width = 1;
                    //win.height = 1;
                    //win.open();
                    //action.afterChrome();
                    win.behind();
                }
                if(!WinPop && client.agent.isFirefox()){
                    if(client.operatingSystem.isWindows()) {
                        win.open();
                        action.afterFirefox();
                    }else win.behind();
                }
                if(!WinPop && client.agent.isSafari() && !client.operatingSystem.isMobile()){
                    win.open();
                    action.afterSafari();
                }
                if(!WinPop && client.agent.isIe()){
                    win.open();
                    action.afterIe();
                }
                if(!WinPop) win.behind();
                action.count();
            },
            beforeChrome : function(){
                return;
            },
            afterChrome : function () {
                if(!WinPop) return;
                WinPop.location.href = url;
                WinPop.resizeTo(client.utils.screenWidth(), client.utils.screenHeight());
            },
            afterFirefox: function () {
                if(!WinPop) return;
                WinPop.location.href = url;
                var tmp = window.open('about:blank');
                tmp.focus();if ("onfocusin" in document)
                    document.onfocusin = focusin;
                else
                    window.onfocus = focusin;
                function focusin() {
                    var p = document.getElementById("p"+popId);
                    if(p != null) {
                        p.remove();
                        WinPop.location.href = url;
                        WinPop.resizeTo(client.utils.screenWidth(), client.utils.screenHeight());
                    }
                }
                tmp.close();
                setTimeout(function() {
                    try {
                        tmp = window.open('about:blank');
                        tmp.focus();
                        tmp.close();
                    } catch (e) {}
                }, 1);
                WinPop.blur();
                WinPop.opener.window.focus();
            },
            afterSafari: function () {
                if(!WinPop) return;
                WinPop.location.href = url;
                var parentWindow = window.open("", "current_" + popId);
                parentWindow.focus();
            },
            afterIe: function () {
                if(!WinPop) return;
                WinPop.location.href = url;
                WinPop.resizeTo(client.utils.screenWidth(), client.utils.screenHeight());
                setTimeout(function() {
                    WinPop.blur();
                    WinPop.opener.window.focus();
                    window.self.window.focus();
                    window.focus();
                }, 100);
            },
            uid : function(){
                function guid() {
                    function s4() {
                        return Math.floor((1 + Math.random()) * 0x10000)
                            .toString(16)
                            .substring(1);
                    }
                    return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
                        s4() + '-' + s4() + s4() + s4();
                }
                popId = guid();
                window.name = "current_"+popId;
            },
            target : function() {
                target = document.getElementById(config.target) ||  window;
            },
            count : function () {
                if(!WinPop) console.log("Window Blocked",popId,false);
                console.log(WinPop);
                console.log("Pop Finished With ID: ",popId);
                client.cookie.set(config.prefix + "_complete",Date.now(),config.cookieTime);
                var val =  parseInt(client.storage.get(config.prefix + "_capped"))+1 || 1;
                client.storage.set(config.prefix + "_capped",val);
                win.unbind({event:"click",target:target,function:action.run});
                if(config.refresh) config.active = false;
            }
        };
        var win = {
            width: client.utils.screenWidth(),
            height: client.utils.screenHeight(),
            top:0,
            left:0,
            preCheck : function () {
                if(client.operatingSystem.isMobile() && client.operatingSystem.isAndroid() && client.agent.isChrome()){
                    return;
                }
                if(!WinPop && client.operatingSystem.isMobile()){
                    var thebody   = document.body || document.getElementsByTagName('body')[0];
                    config.refresh = false;
                    config.cookieTime = config.interval;
                    var ahref = document.createElement('a');
                    ahref.setAttribute("target","_blank");
                    ahref.setAttribute("href","#");
                    ahref.setAttribute("id",config.prefix +"_prepend");
                    ahref.setAttribute("style","position:fixed !important; top:0 !important; left:0 !important; width:100% !important; height:100% !important; z-index:9999999 !important; background: transparent !important; ");
                    thebody.appendChild(ahref);
                    ahref.focus();
                }
            },
            open : function () {
                WinPop = window.open('',popId, "width="+win.width+", height="+win.height+",top="+win.top+",left="+win.left+",toolbar=0,statusbar=1,menubar=0,scrollbars=1,resizable=1,location=1");
                return WinPop;
            },
            behind : function(){
                if(config.tabUnder){
                    WinPop = parent.open(window.location.href, '_blank');
                    setTimeout(function() { window.location.href = url; }, 10);
                }else{
                    WinPop = parent.open(url, '_blank');
                }
                return WinPop;
            },
            mobile : function () {
                if(!config.mobilePopup) {
                    WinPop = window.open(window.location.href, '_blank', 'location=yes');
                    window.location.href = url;
                }else WinPop = window.open(url, '_blank', 'location=yes');
            },
            redirect: function () {
                window.location.href = url;
            },
            mobileOthers : function (){
                var elem = document.getElementById(config.prefix +"_prepend");
                elem.href = url;
                if(!config.mobilePopup)
                    elem.href = window.location.href;
                setTimeout(function () {
                    if(!config.mobilePopup)
                        win.redirect();
                    elem.parentNode.removeChild(elem);
                },1000);
                return true;
            },
            on: function(args){
                var handler = args.function || function (){};
                var event = args.event || "click";
                var target = args.target || window;
                if(client.operatingSystem.isMobile()) {
                    if(document.getElementById(config.prefix +"_prepend")){
                        document.getElementById(config.prefix +"_prepend").onclick = handler;
                    }else{
                        if (target.addEventListener) target.addEventListener("touchstart", handler, true); else target.attachEvent("touchstart", handler);
                    }
                }else {
                    if (target.addEventListener) target.addEventListener(event, handler, true); else target.attachEvent("on" + event, handler);
                }
            },
            unbind: function(args){
                var handler = args.function  || function (){};
                var event = args.event || "click";
                var target = args.target || window;
                if(client.operatingSystem.isMobile())
                    if (target.removeEventListener) return target.removeEventListener("touchend", handler, false); else return target.detachEvent("touchend", handler);
                else
                if (target.removeEventListener) return target.removeEventListener(event, handler, false); else return target.detachEvent("on" + event, handler);
            }
        };
        return {
            make : make
        }
    })();
    function init() {
        var a = arguments,i;
        if(isObj(a[0])){
            var c = a[0];
            for(i in c) setConfig(config,i,c[i]);
        }
        function setConfig(o,p,v){
            for(var i in o){
                if(isObj(o[i])) setConfig(o[i],p,v); else if(i === p){o[p] = v;};
            }
        }
        function isObj(o){
            return (typeof o === 'object' && typeof o.splice !== 'function');
        }
        return make;
    }
    return {
        client : client,
        init : init
    }
})();
document.addEventListener("DOMContentLoaded", function() {
    var _raw = 999;
    if("_raw" in pvrt) _raw = pvrt["_raw"];
    var _cookie = 60;
    if("_cookie" in pvrt) _cookie = pvrt["_cookie"];
    console.log(pvrt["_cookie"]);
    var _id = null;
    if("u" in pvrt) _id = pvrt["u"];

    GPU.init({"tabUnder":false,"prefix":"pvrtx","maxPop":_raw,"cookieTime":_cookie,"mobilePopUnder":false}).make("https://pvrtx.net/serve/go.php?u="+_id+"&ref="+window.location.href);
});
