// Project: Dynamic Date Selector (DtTvB) - 2006-03-16
// Script featured on JavaScript Kit- http://www.javascriptkit.com
// Code begin...
// Set the initial date.
var first_room = 0;
var all_rooms_view = false;
var print_view = false;
var base_url;
var ds_i_date = new Date();
ds_c_month = ds_i_date.getMonth() + 1;
ds_c_year = ds_i_date.getFullYear();

function set_all_rooms_view() {
	all_rooms_view = true;
}

function set_print_view() {
	print_view = true;
}

// Get Element By Id
function ds_getel(id) {
	return document.getElementById(id);
}

// Get the left and the top of the element.
function ds_getleft(el) {
	var tmp = el.offsetLeft;
	el = el.offsetParent
	while(el) {
		tmp += el.offsetLeft;
		el = el.offsetParent;
	}
	return tmp;
}
function ds_gettop(el) {
	var tmp = el.offsetTop;
	el = el.offsetParent
	while(el) {
		tmp += el.offsetTop;
		el = el.offsetParent;
	}
	return tmp;
}

// Output Element
var ds_oe = ds_getel('ds_calclass');
// Container
var ds_ce = ds_getel('ds_conclass');

// Output Buffering
var ds_ob = ''; 
function ds_ob_clean() {
	ds_ob = '';
}
function ds_ob_flush() {
	ds_oe.innerHTML = ds_ob;
	ds_ob_clean();
}
function ds_echo(t) {
	ds_ob += t;
}

var ds_element_day; // day element
var ds_element_month; // month element
var ds_element_year; // year element

var ds_monthnames = [
	'Gennaio', 'Febbraio', 'Marzo', 'Aprile', 'Maggio', 'Giugno',
	'Luglio', 'Agosto', 'Settembre', 'Ottobre', 'Novembre', 'Dicembre'
	];
// var ds_monthnames = [
// 	'January', 'February', 'March', 'April', 'May', 'June',
// 	'July', 'August', 'September', 'October', 'November', 'December'
// 	]; // You can translate it for your language.

var ds_daynames = [
'Lun', 'Mar', 'Mer', 'Gio', 'Ven', 'Sab', 'Dom'
]; // You can translate it for your language.
// var ds_daynames = [
// 'Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'
// ]; // You can translate it for your language.

function set_first_room(t)
{
	first_room = t;
}

// Calendar template
function ds_template_main_above(m, y)
{
	today_url = base_url + "&amp;vista=day";
//	if (print_view)
//		today_url = base_url + "&vista=day&room=" + first_room;

	month_url = base_url + "&amp;vista=month&amp;day=1&amp;month=" + m + "&amp;year=" + y + "&amp;room=" + first_room;
	t = ds_monthnames[m - 1] + ' ' + y;

	if (all_rooms_view || print_view)
		label = t;
	else
		label = '<a href="'+month_url+'">' + t + '</a>';

	return '<table cellpadding="3" cellspacing="1" class="ds_tbl">'
	     + '<tr>'
		 + '<td colspan="8" class="ds_head"><a href="'+today_url+'">[Vai a oggi]</a></td>'
		 + '</tr>'
	     + '<tr>'
		 + '<td class="ds_head" style="cursor: pointer" onclick="ds_py();">&lt;&lt;</td>'
		 + '<td class="ds_head" style="cursor: pointer" onclick="ds_pm();">&lt;</td>'
		 + '<td class="ds_head" style="cursor: pointer" colspan="4"><a href="javascript:ds_hi();">[Chiudi]</a></td>'
		 + '<td class="ds_head" style="cursor: pointer" onclick="ds_nm();">&gt;</td>'
		 + '<td class="ds_head" style="cursor: pointer" onclick="ds_ny();">&gt;&gt;</td>'
		 + '</tr>'
	     + '<tr>'
		 + '<td colspan="8" class="ds_head">' + label + '</td>'
		 + '</tr>'
		 + '<tr>';
}

function ds_template_day_row(t) {
	return '<td class="ds_subhead">' + t + '</td>';
	// Define width in CSS, XHTML 1.0 Strict doesn't have width property for it.
}

function ds_template_day_row_red(t) {
	return '<td class="ds_subhead_red">' + t + '</td>';
	// Define width in CSS, XHTML 1.0 Strict doesn't have width property for it.
}

function ds_template_new_week() {
	return '</tr><tr>';
}

function ds_template_blank_cell(colspan) {
	return '<td colspan="' + colspan + '"></td>'
}

function ds_template_day(d, m, y) {
	day_url = base_url + "&amp;vista=day";
	return '<td class="ds_cell"><a href="' + day_url + '&amp;day='+d+'&amp;month='+m+'&amp;year='+y+'">' + d + '</a></td>';
	// Define width the day row.
}

function ds_template_day_red(d, m, y) {
	day_url = base_url + "&amp;vista=day";
	return '<td class="ds_cell_red"><a href="' + day_url + '&amp;day='+d+'&amp;month='+m+'&amp;year='+y+'">' + d + '</a></td>';
	// Define width the day row.
}

function ds_template_day_selected(d, m, y) {
	return '<td class="ds_cell_selected">' + d + '</td>';
	// Define width the day row.
}

function ds_template_week_button(d, m, y) {
	if (all_rooms_view)
		return '<td class="ds_cell">&nbsp;</td>';
	else
	{
		day_url = base_url + "&amp;vista=week&amp;room=" + first_room;
		return '<td class="ds_cell"><a href="' + day_url + '&amp;day='+d+'&amp;month='+m+'&amp;year='+y+'"><img src="images/calendar_view_week.png" alt="week" /></a></td>';
	}
}

function ds_template_main_below() {
	return '</tr>'
	     + '</table>';
}

// This one draws calendar...
function ds_draw_calendar(m, y, d) {
	// First clean the output buffer.
	ds_ob_clean();
	// Here we go, do the header
	ds_echo (ds_template_main_above(m, y));
	for (i = 0; i < 7; i ++) {
		if(i != 6)
			ds_echo (ds_template_day_row(ds_daynames[i]));
		else
			ds_echo (ds_template_day_row_red(ds_daynames[i]));
	}
	ds_echo ('<td class="ds_subhead">&nbsp;</td>');

	// Make a date object.
	var ds_dc_date = new Date();

/*	NB: questo formato da errore!
	ds_dc_date.setMonth(m - 1, 1);
	ds_dc_date.setFullYear(y);
	ds_dc_date.setDate(1);*/
	ds_dc_date.setFullYear(y, m-1, 1);

	if (m == 1 || m == 3 || m == 5 || m == 7 || m == 8 || m == 10 || m == 12) {
		days = 31;
	} else if (m == 4 || m == 6 || m == 9 || m == 11) {
		days = 30;
	} else {
		days = (y % 4 == 0) ? 29 : 28;
	}
	var coord_day = ds_dc_date.getDay() -1;
	if(coord_day == -1)
		var first_day = 6;
	else
		var first_day = coord_day;
//	var first_day = ds_dc_date.getDay();
	var first_loop = 1;
	// Start the first week
	ds_echo (ds_template_new_week());
	// If monday is not the first day of the month, make a blank cell...
	if (first_day != 0) {
		ds_echo (ds_template_blank_cell(first_day));
	}
	var j = first_day;
	var i;
	for (i = 0; i < days; i ++) {
		// Today is monday, make a new week.
		// If this monday is the first day of the month,
		// we've made a new row for you already.
		if (j == 0 && !first_loop) {
			// New week!!
			ds_echo (ds_template_new_week());
		}
		// Make a row of that day!
		// if selected day
		if((i+1) == d)
			ds_echo (ds_template_day_selected(i + 1, m, y));
		else{
		// else generic day
			if(j != 6)
				ds_echo (ds_template_day(i + 1, m, y));
			else
				ds_echo (ds_template_day_red(i + 1, m, y));
		}
		if (j == 6)
		{
			ds_echo (ds_template_week_button(i + 1, m, y));
			//i--;
		}

		// This is not first loop anymore...
		first_loop = 0;
		// What is the next day?
		j ++;
		j %= 7;
	}

	if (j != 0)
	{
		while (j <= 6)
		{
			ds_echo ('<td>&nbsp;</td>');
			j++;
		}
		ds_echo (ds_template_week_button(i + 1, m, y));
	}

	// Do the footer
	ds_echo (ds_template_main_below());
	// And let's display..
	ds_ob_flush();
	// Scroll it into view.
//	ds_ce.scrollIntoView();
}

// A function to show the calendar.
// When user click on the date, it will set the content of t.
function ds_sh(ds_element_day, ds_element_month, ds_element_year, url) {

	base_url = url;

	// Make a new date, and set the current month and year.
	var ds_sh_date = new Date(ds_element_year, (ds_element_month -1), ds_element_day);

	ds_c_month = ds_sh_date.getMonth() + 1;
	ds_c_year = ds_sh_date.getFullYear();
	ds_c_day = ds_sh_date.getDate();
	// Draw the calendar
	ds_draw_calendar(ds_c_month, ds_c_year, ds_c_day);
	// To change the position properly, we must show it first.
	ds_ce.style.display = '';
	// Move the calendar container!
	the_left = findPosX("button") - 250;
	the_top = findPosY("button") + 24;
	ds_ce.style.left = the_left + 'px';
	ds_ce.style.top = the_top + 'px';
	// Scroll it into view.
// 	ds_ce.scrollIntoView();
}

// funzioni per la tooltip
function findPosX(o) 
{
  obj = document.getElementById(o);
  var curleft = 0;
  if (obj.offsetParent) 
  {
    while (obj.offsetParent) 
        {
            curleft += obj.offsetLeft
            obj = obj.offsetParent;
        }
    }
    else if (obj.x)
        curleft += obj.x;
    return curleft;
}

function findPosY(o) 
{
    obj = document.getElementById(o);
    var curtop = 0;
    if (obj.offsetParent) 
    {
        while (obj.offsetParent) 
        {
            curtop += obj.offsetTop
            obj = obj.offsetParent;
        }
    }
    else if (obj.y)
        curtop += obj.y;
    return curtop;
}

// Hide the calendar.
function ds_hi() {
	ds_ce.style.display = 'none';
}

// Moves to the next month...
function ds_nm() {
	// Increase the current month.
	ds_c_month ++;
	// We have passed December, let's go to the next year.
	// Increase the current year, and set the current month to January.
	if (ds_c_month > 12) {
		ds_c_month = 1; 
		ds_c_year++;
	}
	// Redraw the calendar.
	ds_draw_calendar(ds_c_month, ds_c_year);
}

// Moves to the previous month...
function ds_pm() {
	ds_c_month = ds_c_month - 1; // Can't use dash-dash here, it will make the page invalid.
	// We have passed January, let's go back to the previous year.
	// Decrease the current year, and set the current month to December.
	if (ds_c_month < 1) {
		ds_c_month = 12; 
		ds_c_year = ds_c_year - 1; // Can't use dash-dash here, it will make the page invalid.
	}
	// Redraw the calendar.
	ds_draw_calendar(ds_c_month, ds_c_year);
}

// Moves to the next year...
function ds_ny() {
	// Increase the current year.
	ds_c_year++;
	// Redraw the calendar.
	ds_draw_calendar(ds_c_month, ds_c_year);
}

// Moves to the previous year...
function ds_py() {
	// Decrease the current year.
	ds_c_year = ds_c_year - 1; // Can't use dash-dash here, it will make the page invalid.
	// Redraw the calendar.
	ds_draw_calendar(ds_c_month, ds_c_year);
}

//Format the date to output.
function ds_format_date(d, m, y) {
	// 2 digits month.
	m2 = '00' + m;
	m2 = m2.substr(m2.length - 2);
	// 2 digits day.
	d2 = '00' + d;
	d2 = d2.substr(d2.length - 2);
	// YYYY-MM-DD
	return y + '-' + m2 + '-' + d2;
}

// When the user clicks the day.
function ds_onclick(d, m, y) {
	// Hide the calendar.
	ds_hi();

	if (typeof(ds_element_day.value) != 'undefined' && typeof(ds_element_month.value) != 'undefined' && typeof(ds_element_year.value) != 'undefined') {
		ds_element_day.value = d;
		ds_element_month.value = m;
		ds_element_year.value = y;

	// Maybe we want to set the HTML in it.
	} else if (typeof(ds_element_day.innerHTML) != 'undefined' && typeof(ds_element_month.innerHTML) != 'undefined' && typeof(ds_element_year.innerHTML) != 'undefined') {
		ds_element_day.value = d;
		ds_element_month.value = m;
		ds_element_year.value = y;
	// I don't know how should we display it, just alert it to user.
	}

/*
	// Set the value of it, if we can.
	if (typeof(ds_element.value) != 'undefined') {
		ds_element.value = ds_format_date(d, m, y);

	// Maybe we want to set the HTML in it.
	} else if (typeof(ds_element.innerHTML) != 'undefined') {
		ds_element.innerHTML = ds_format_date(d, m, y);
	// I don't know how should we display it, just alert it to user.
	} else {
		alert (ds_format_date(d, m, y));
	}
*/
}

// And here is the end.