/*
 * Chart.js
 * http://chartjs.org/
 * Version: 1.0.1
 *
 * Copyright 2015 Nick Downie
 * Released under the MIT license
 * https://github.com/nnnick/Chart.js/blob/master/LICENSE.md
 */
(function(){var V=this,ah=V.Chart,al=function(a){this.canvas=a.canvas,this.ctx=a;this.width=a.canvas.width,this.height=a.canvas.height;return this.aspectRatio=this.width/this.height,X.retinaScale(this),this};al.defaults={global:{animation:!0,animationSteps:60,animationEasing:"easeOutQuart",showScale:!0,scaleOverride:!1,scaleSteps:null,scaleStepWidth:null,scaleStartValue:null,scaleLineColor:"rgba(0,0,0,.1)",scaleLineWidth:1,scaleShowLabels:!0,scaleLabel:"<%=value%>",scaleIntegersOnly:!0,scaleBeginAtZero:!1,scaleFontFamily:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",scaleFontSize:12,scaleFontStyle:"normal",scaleFontColor:"#fff",responsive:!1,maintainAspectRatio:!0,showTooltips:!0,customTooltips:!1,tooltipEvents:["mousemove","touchstart","touchmove","mouseout"],tooltipFillColor:"rgba(0,0,0,0.8)",tooltipFontFamily:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",tooltipFontSize:14,tooltipFontStyle:"normal",tooltipFontColor:"#fff",tooltipTitleFontFamily:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",tooltipTitleFontSize:14,tooltipTitleFontStyle:"bold",tooltipTitleFontColor:"#fff",tooltipYPadding:6,tooltipXPadding:6,tooltipCaretSize:8,tooltipCornerRadius:6,tooltipXOffset:10,tooltipTemplate:"<%if (label){%><%=label%>: <%}%><%= value %>",multiTooltipTemplate:"<%= value %>",multiTooltipKeyBackground:"#fff",onAnimationProgress:function(){},onAnimationComplete:function(){}}},al.types={};var X=al.helpers={},ad=X.each=function(b,a,d){var c=Array.prototype.slice.call(arguments,3);if(b){if(b.length===+b.length){var g;for(g=0;g<b.length;g++){a.apply(d,[b[g],g].concat(c))}}else{for(var f in b){a.apply(d,[b[f],f].concat(c))}}}},ac=X.clone=function(b){var a={};return ad(b,function(d,c){b.hasOwnProperty(c)&&(a[c]=d)}),a},ap=X.extend=function(a){return ad(Array.prototype.slice.call(arguments,1),function(b){ad(b,function(d,c){b.hasOwnProperty(c)&&(a[c]=d)})}),a},ai=X.merge=function(){var a=Array.prototype.slice.call(arguments,0);return a.unshift({}),ap.apply(null,a)},af=X.indexOf=function(b,a){if(Array.prototype.indexOf){return b.indexOf(a)}for(var c=0;c<b.length;c++){if(b[c]===a){return c}}return -1},Z=(X.where=function(b,a){var c=[];return X.each(b,function(d){a(d)&&c.push(d)}),c},X.findNextWhere=function(b,a,d){d||(d=-1);for(var c=d+1;c<b.length;c++){var f=b[c];if(a(f)){return f}}},X.findPreviousWhere=function(b,a,d){d||(d=b.length);for(var c=d-1;c>=0;c--){var f=b[c];if(a(f)){return f}}},X.inherits=function(b){var a=this,d=b&&b.hasOwnProperty("constructor")?b.constructor:function(){return a.apply(this,arguments)},c=function(){this.constructor=d};return c.prototype=a.prototype,d.prototype=new c,d.extend=Z,b&&ap(d.prototype,b),d.__super__=a.prototype,d}),an=X.noop=function(){},U=X.uid=function(){var a=0;return function(){return"chart-"+a++}}(),am=X.warn=function(a){window.console&&"function"==typeof window.console.warn&&console.warn(a)},ab=X.amd="function"==typeof define&&define.amd,ak=X.isNumber=function(a){return !isNaN(parseFloat(a))&&isFinite(a)},aj=X.max=function(a){return Math.max.apply(Math,a)},ae=X.min=function(a){return Math.min.apply(Math,a)},O=(X.cap=function(b,a,c){if(ak(a)){if(b>a){return a}}else{if(ak(c)&&c>b){return c}}return b},X.getDecimalPlaces=function(a){return a%1!==0&&ak(a)?a.toString().split(".")[1].length:0}),B=X.radians=function(a){return a*(Math.PI/180)},K=(X.getAngleFromPoint=function(b,a){var d=a.x-b.x,c=a.y-b.y,g=Math.sqrt(d*d+c*c),f=2*Math.PI+Math.atan2(c,d);return 0>d&&0>c&&(f+=2*Math.PI),{angle:f,distance:g}},X.aliasPixel=function(a){return a%2===0?0:0.5}),J=(X.splineCurve=function(d,c,k,g){var m=Math.sqrt(Math.pow(c.x-d.x,2)+Math.pow(c.y-d.y,2)),l=Math.sqrt(Math.pow(k.x-c.x,2)+Math.pow(k.y-c.y,2)),b=g*m/(m+l),f=g*l/(m+l);return{inner:{x:c.x-b*(k.x-d.x),y:c.y-b*(k.y-d.y)},outer:{x:c.x+f*(k.x-d.x),y:c.y+f*(k.y-d.y)}}},X.calculateOrderOfMagnitude=function(a){return Math.floor(Math.log(a)/Math.LN10)}),Y=(X.calculateScaleRange=function(T,y,C,W,m){var k=2,M=Math.floor(y/(1.5*C)),z=k>=M,w=aj(T),b=ae(T);w===b&&(w+=0.5,b>=0.5&&!W?b-=0.5:w+=0.5);for(var L=Math.abs(w-b),R=J(L),F=Math.ceil(w/(1*Math.pow(10,R)))*Math.pow(10,R),g=W?0:Math.floor(b/(1*Math.pow(10,R)))*Math.pow(10,R),A=F-g,P=Math.pow(10,R),x=Math.round(A/P);(x>M||M>2*x)&&!z;){if(x>M){P*=2,x=Math.round(A/P),x%1!==0&&(z=!0)}else{if(m&&R>=0){if(P/2%1!==0){break}P/=2,x=Math.round(A/P)}else{P/=2,x=Math.round(A/P)}}}return z&&(x=k,P=A/x),{steps:x,stepValue:P,min:g,max:g+x*P}},X.template=function(b,a){function d(g,f){var h=/\W/.test(g)?new Function("obj","var p=[],print=function(){p.push.apply(p,arguments);};with(obj){p.push('"+g.replace(/[\r\t\n]/g," ").split("<%").join("	").replace(/((^|%>)[^\t]*)'/g,"$1\r").replace(/\t=(.*?)%>/g,"',$1,'").split("	").join("');").split("%>").join("p.push('").split("\r").join("\\'")+"');}return p.join('');"):c[g]=c[g];return f?h(f):h}if(b instanceof Function){return b(a)}var c={};return d(b,a)}),N=(X.generateLabels=function(b,a,d,c){var f=new Array(a);return labelTemplateString&&ad(f,function(e,g){f[g]=Y(b,{value:d+c*(g+1)})}),f},X.easingEffects={linear:function(a){return a},easeInQuad:function(a){return a*a},easeOutQuad:function(a){return -1*a*(a-2)},easeInOutQuad:function(a){return(a/=0.5)<1?0.5*a*a:-0.5*(--a*(a-2)-1)},easeInCubic:function(a){return a*a*a},easeOutCubic:function(a){return 1*((a=a/1-1)*a*a+1)},easeInOutCubic:function(a){return(a/=0.5)<1?0.5*a*a*a:0.5*((a-=2)*a*a+2)},easeInQuart:function(a){return a*a*a*a},easeOutQuart:function(a){return -1*((a=a/1-1)*a*a*a-1)},easeInOutQuart:function(a){return(a/=0.5)<1?0.5*a*a*a*a:-0.5*((a-=2)*a*a*a-2)},easeInQuint:function(a){return 1*(a/=1)*a*a*a*a},easeOutQuint:function(a){return 1*((a=a/1-1)*a*a*a*a+1)},easeInOutQuint:function(a){return(a/=0.5)<1?0.5*a*a*a*a*a:0.5*((a-=2)*a*a*a*a+2)},easeInSine:function(a){return -1*Math.cos(a/1*(Math.PI/2))+1},easeOutSine:function(a){return 1*Math.sin(a/1*(Math.PI/2))},easeInOutSine:function(a){return -0.5*(Math.cos(Math.PI*a/1)-1)},easeInExpo:function(a){return 0===a?1:1*Math.pow(2,10*(a/1-1))},easeOutExpo:function(a){return 1===a?1:1*(-Math.pow(2,-10*a/1)+1)},easeInOutExpo:function(a){return 0===a?0:1===a?1:(a/=0.5)<1?0.5*Math.pow(2,10*(a-1)):0.5*(-Math.pow(2,-10*--a)+2)},easeInCirc:function(a){return a>=1?a:-1*(Math.sqrt(1-(a/=1)*a)-1)},easeOutCirc:function(a){return 1*Math.sqrt(1-(a=a/1-1)*a)},easeInOutCirc:function(a){return(a/=0.5)<1?-0.5*(Math.sqrt(1-a*a)-1):0.5*(Math.sqrt(1-(a-=2)*a)+1)},easeInElastic:function(b){var a=1.70158,d=0,c=1;return 0===b?0:1==(b/=1)?1:(d||(d=0.3),c<Math.abs(1)?(c=1,a=d/4):a=d/(2*Math.PI)*Math.asin(1/c),-(c*Math.pow(2,10*(b-=1))*Math.sin(2*(1*b-a)*Math.PI/d)))},easeOutElastic:function(b){var a=1.70158,d=0,c=1;return 0===b?0:1==(b/=1)?1:(d||(d=0.3),c<Math.abs(1)?(c=1,a=d/4):a=d/(2*Math.PI)*Math.asin(1/c),c*Math.pow(2,-10*b)*Math.sin(2*(1*b-a)*Math.PI/d)+1)},easeInOutElastic:function(b){var a=1.70158,d=0,c=1;return 0===b?0:2==(b/=0.5)?1:(d||(d=0.3*1.5),c<Math.abs(1)?(c=1,a=d/4):a=d/(2*Math.PI)*Math.asin(1/c),1>b?-0.5*c*Math.pow(2,10*(b-=1))*Math.sin(2*(1*b-a)*Math.PI/d):c*Math.pow(2,-10*(b-=1))*Math.sin(2*(1*b-a)*Math.PI/d)*0.5+1)},easeInBack:function(b){var a=1.70158;return 1*(b/=1)*b*((a+1)*b-a)},easeOutBack:function(b){var a=1.70158;return 1*((b=b/1-1)*b*((a+1)*b+a)+1)},easeInOutBack:function(b){var a=1.70158;return(b/=0.5)<1?0.5*b*b*(((a*=1.525)+1)*b-a):0.5*((b-=2)*b*(((a*=1.525)+1)*b+a)+2)},easeInBounce:function(a){return 1-N.easeOutBounce(1-a)},easeOutBounce:function(a){return(a/=1)<1/2.75?7.5625*a*a:2/2.75>a?1*(7.5625*(a-=1.5/2.75)*a+0.75):2.5/2.75>a?1*(7.5625*(a-=2.25/2.75)*a+0.9375):1*(7.5625*(a-=2.625/2.75)*a+0.984375)},easeInOutBounce:function(a){return 0.5>a?0.5*N.easeInBounce(2*a):0.5*N.easeOutBounce(2*a-1)+0.5}}),ao=X.requestAnimFrame=function(){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(a){return window.setTimeout(a,1000/60)}}(),E=(X.cancelAnimFrame=function(){return window.cancelAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame||window.oCancelAnimationFrame||window.msCancelAnimationFrame||function(a){return window.clearTimeout(a,1000/60)}}(),X.animationLoop=function(p,f,k,r,c,b){var m=0,g=N[k]||N.linear,d=function(){m++;var h=m/f,a=g(h);p.call(b,a,h,m),r.call(b,a,h),f>m?b.animationFrame=ao(d):c.apply(b)};ao(d)},X.getRelativePosition=function(b){var a,d,c=b.originalEvent||b,g=b.currentTarget||b.srcElement,f=g.getBoundingClientRect();return c.touches?(a=c.touches[0].clientX-f.left,d=c.touches[0].clientY-f.top):(a=c.clientX-f.left,d=c.clientY-f.top),{x:a,y:d}},X.addEvent=function(b,a,c){b.addEventListener?b.addEventListener(a,c):b.attachEvent?b.attachEvent("on"+a,c):b["on"+a]=c}),H=X.removeEvent=function(b,a,c){b.removeEventListener?b.removeEventListener(a,c,!1):b.detachEvent?b.detachEvent("on"+a,c):b["on"+a]=an},ag=(X.bindEvents=function(b,a,c){b.events||(b.events={}),ad(a,function(d){b.events[d]=function(){c.apply(b,arguments)},E(b.chart.canvas,d,b.events[d])})},X.unbindEvents=function(b,a){ad(a,function(c,d){H(b.chart.canvas,d,c)})}),Q=X.getMaximumWidth=function(b){var a=b.parentNode;return a.clientWidth},D=X.getMaximumHeight=function(b){var a=b.parentNode;return a.clientHeight},q=(X.getMaximumSize=X.getMaximumWidth,X.retinaScale=function(b){var a=b.ctx,d=b.canvas.width,c=b.canvas.height;window.devicePixelRatio&&(a.canvas.style.width=d+"px",a.canvas.style.height=c+"px",a.canvas.height=c*window.devicePixelRatio,a.canvas.width=d*window.devicePixelRatio,a.scale(window.devicePixelRatio,window.devicePixelRatio))}),aa=X.clear=function(a){a.ctx.clearRect(0,0,a.width,a.height)},G=X.fontString=function(b,a,c){return a+" "+b+"px "+c},j=X.longestText=function(b,a,d){b.font=a;var c=0;return ad(d,function(f){var g=b.measureText(f).width;c=g>c?g:c}),c},I=X.drawRoundedRectangle=function(b,a,d,c,g,f){b.beginPath(),b.moveTo(a+f,d),b.lineTo(a+c-f,d),b.quadraticCurveTo(a+c,d,a+c,d+f),b.lineTo(a+c,d+g-f),b.quadraticCurveTo(a+c,d+g,a+c-f,d+g),b.lineTo(a+f,d+g),b.quadraticCurveTo(a,d+g,a,d+g-f),b.lineTo(a,d+f),b.quadraticCurveTo(a,d,a+f,d),b.closePath()};al.instances={},al.Type=function(b,a,c){this.options=a,this.chart=c,this.id=U(),al.instances[this.id]=this,a.responsive&&this.resize(),this.initialize.call(this,b)},ap(al.Type.prototype,{initialize:function(){return this},clear:function(){return aa(this.chart),this},stop:function(){return X.cancelAnimFrame.call(V,this.animationFrame),this},resize:function(b){this.stop();var a=this.chart.canvas,d=Q(this.chart.canvas),c=this.options.maintainAspectRatio?d/this.chart.aspectRatio:D(this.chart.canvas);return a.width=this.chart.width=d,a.height=this.chart.height=c,q(this.chart),"function"==typeof b&&b.apply(this,Array.prototype.slice.call(arguments,1)),this},reflow:an,render:function(a){return a&&this.reflow(),this.options.animation&&!a?X.animationLoop(this.draw,this.options.animationSteps,this.options.animationEasing,this.options.onAnimationProgress,this.options.onAnimationComplete,this):(this.draw(),this.options.onAnimationComplete.call(this)),this},generateLegend:function(){return Y(this.options.legendTemplate,this)},destroy:function(){this.clear(),ag(this,this.events);var a=this.chart.canvas;a.width=this.chart.width,a.height=this.chart.height,a.style.removeProperty?(a.style.removeProperty("width"),a.style.removeProperty("height")):(a.style.removeAttribute("width"),a.style.removeAttribute("height")),delete al.instances[this.id]},showTooltip:function(p,f){"undefined"==typeof this.activeElements&&(this.activeElements=[]);var e=function(c){var a=!1;return c.length!==this.activeElements.length?a=!0:(ad(c,function(d,h){d!==this.activeElements[h]&&(a=!0)},this),a)}.call(this,p);if(e||f){if(this.activeElements=p,this.draw(),this.options.customTooltips&&this.options.customTooltips(!1),p.length>0){if(this.datasets&&this.datasets.length>1){for(var m,g,b=this.datasets.length-1;b>=0&&(m=this.datasets[b].points||this.datasets[b].bars||this.datasets[b].segments,g=af(m,p[0]),-1===g);b--){}var l=[],n=[],k=function(){var s,h,v,x,w,d=[],c=[],u=[];return X.each(this.datasets,function(a){s=a.points||a.bars||a.segments,s[g]&&s[g].hasValue()&&d.push(s[g])}),X.each(d,function(a){c.push(a.x),u.push(a.y),l.push(X.template(this.options.multiTooltipTemplate,a)),n.push({fill:a._saved.fillColor||a.fillColor,stroke:a._saved.strokeColor||a.strokeColor})},this),w=ae(u),v=aj(u),x=ae(c),h=aj(c),{x:x>this.chart.width/2?x:h,y:(w+v)/2}}.call(this,g);new al.MultiTooltip({x:k.x,y:k.y,xPadding:this.options.tooltipXPadding,yPadding:this.options.tooltipYPadding,xOffset:this.options.tooltipXOffset,fillColor:this.options.tooltipFillColor,textColor:this.options.tooltipFontColor,fontFamily:this.options.tooltipFontFamily,fontStyle:this.options.tooltipFontStyle,fontSize:this.options.tooltipFontSize,titleTextColor:this.options.tooltipTitleFontColor,titleFontFamily:this.options.tooltipTitleFontFamily,titleFontStyle:this.options.tooltipTitleFontStyle,titleFontSize:this.options.tooltipTitleFontSize,cornerRadius:this.options.tooltipCornerRadius,labels:l,legendColors:n,legendColorBackground:this.options.multiTooltipKeyBackground,title:p[0].label,chart:this.chart,ctx:this.chart.ctx,custom:this.options.customTooltips}).draw()}else{ad(p,function(c){var a=c.tooltipPosition();new al.Tooltip({x:Math.round(a.x),y:Math.round(a.y),xPadding:this.options.tooltipXPadding,yPadding:this.options.tooltipYPadding,fillColor:this.options.tooltipFillColor,textColor:this.options.tooltipFontColor,fontFamily:this.options.tooltipFontFamily,fontStyle:this.options.tooltipFontStyle,fontSize:this.options.tooltipFontSize,caretHeight:this.options.tooltipCaretSize,cornerRadius:this.options.tooltipCornerRadius,text:Y(this.options.tooltipTemplate,c),chart:this.chart,custom:this.options.customTooltips}).draw()},this)}}return this}},toBase64Image:function(){return this.chart.canvas.toDataURL.apply(this.chart.canvas,arguments)}}),al.Type.extend=function(c){var b=this,d=function(){return b.apply(this,arguments)};if(d.prototype=ac(b.prototype),ap(d.prototype,c),d.extend=al.Type.extend,c.name||b.prototype.name){var e=c.name||b.prototype.name,a=al.defaults[b.prototype.name]?ac(al.defaults[b.prototype.name]):{};al.defaults[e]=ap(a,c.defaults),al.types[e]=d,al.prototype[e]=function(g,f){var h=ai(al.defaults.global,al.defaults[e],f||{});return new d(g,h,this)}}else{am("Name not provided for this chart, so it hasn't been registered")}return b},al.Element=function(a){ap(this,a),this.initialize.apply(this,arguments),this.save()},ap(al.Element.prototype,{initialize:function(){},restore:function(a){return a?ad(a,function(b){this[b]=this._saved[b]},this):ap(this,this._saved),this},save:function(){return this._saved=ac(this),delete this._saved._saved,this},update:function(a){return ad(a,function(c,b){this._saved[b]=this[b],this[b]=c},this),this},transition:function(b,a){return ad(b,function(c,d){this[d]=(c-this._saved[d])*a+this._saved[d]},this),this},tooltipPosition:function(){return{x:this.x,y:this.y}},hasValue:function(){return ak(this.value)}}),al.Element.extend=Z,al.Point=al.Element.extend({display:!0,inRange:function(b,a){var c=this.hitDetectionRadius+this.radius;return Math.pow(b-this.x,2)+Math.pow(a-this.y,2)<Math.pow(c,2)},draw:function(){if(this.display){var a=this.ctx;a.beginPath(),a.arc(this.x,this.y,this.radius,0,2*Math.PI),a.closePath(),a.strokeStyle=this.strokeColor,a.lineWidth=this.strokeWidth,a.fillStyle=this.fillColor,a.fill(),a.stroke()}}}),al.Arc=al.Element.extend({inRange:function(b,a){var c=X.getAngleFromPoint(this,{x:b,y:a}),f=c.angle>=this.startAngle&&c.angle<=this.endAngle,d=c.distance>=this.innerRadius&&c.distance<=this.outerRadius;return f&&d},tooltipPosition:function(){var b=this.startAngle+(this.endAngle-this.startAngle)/2,a=(this.outerRadius-this.innerRadius)/2+this.innerRadius;return{x:this.x+Math.cos(b)*a,y:this.y+Math.sin(b)*a}},draw:function(b){var a=this.ctx;a.beginPath(),a.arc(this.x,this.y,this.outerRadius,this.startAngle,this.endAngle),a.arc(this.x,this.y,this.innerRadius,this.endAngle,this.startAngle,!0),a.closePath(),a.strokeStyle=this.strokeColor,a.lineWidth=this.strokeWidth,a.fillStyle=this.fillColor,a.fill(),a.lineJoin="bevel",this.showStroke&&a.stroke()}}),al.Rectangle=al.Element.extend({draw:function(){var b=this.ctx,a=this.width/2,d=this.x-a,c=this.x+a,g=this.base-(this.base-this.y),f=this.strokeWidth/2;this.showStroke&&(d+=f,c-=f,g+=f),b.beginPath(),b.fillStyle=this.fillColor,b.strokeStyle=this.strokeColor,b.lineWidth=this.strokeWidth,b.moveTo(d,this.base),b.lineTo(d,g),b.lineTo(c,g),b.lineTo(c,this.base),b.fill(),this.showStroke&&b.stroke()},height:function(){return this.base-this.y},inRange:function(b,a){return b>=this.x-this.width/2&&b<=this.x+this.width/2&&a>=this.y&&a<=this.base}}),al.Tooltip=al.Element.extend({draw:function(){var d=this.chart.ctx;d.font=G(this.fontSize,this.fontStyle,this.fontFamily),this.xAlign="center",this.yAlign="above";var c=this.caretPadding=2,g=d.measureText(this.text).width+2*this.xPadding,f=this.fontSize+2*this.yPadding,k=f+this.caretHeight+c;this.x+g/2>this.chart.width?this.xAlign="left":this.x-g/2<0&&(this.xAlign="right"),this.y-k<0&&(this.yAlign="below");var h=this.x-g/2,b=this.y-k;if(d.fillStyle=this.fillColor,this.custom){this.custom(this)}else{switch(this.yAlign){case"above":d.beginPath(),d.moveTo(this.x,this.y-c),d.lineTo(this.x+this.caretHeight,this.y-(c+this.caretHeight)),d.lineTo(this.x-this.caretHeight,this.y-(c+this.caretHeight)),d.closePath(),d.fill();break;case"below":b=this.y+c+this.caretHeight,d.beginPath(),d.moveTo(this.x,this.y+c),d.lineTo(this.x+this.caretHeight,this.y+c+this.caretHeight),d.lineTo(this.x-this.caretHeight,this.y+c+this.caretHeight),d.closePath(),d.fill()}switch(this.xAlign){case"left":h=this.x-g+(this.cornerRadius+this.caretHeight);break;case"right":h=this.x-(this.cornerRadius+this.caretHeight)}I(d,h,b,g,f,this.cornerRadius),d.fill(),d.fillStyle=this.textColor,d.textAlign="center",d.textBaseline="middle",d.fillText(this.text,h+g/2,b+f/2)}}}),al.MultiTooltip=al.Element.extend({initialize:function(){this.font=G(this.fontSize,this.fontStyle,this.fontFamily),this.titleFont=G(this.titleFontSize,this.titleFontStyle,this.titleFontFamily),this.height=this.labels.length*this.fontSize+(this.labels.length-1)*(this.fontSize/2)+2*this.yPadding+1.5*this.titleFontSize,this.ctx.font=this.titleFont;var b=this.ctx.measureText(this.title).width,a=j(this.ctx,this.font,this.labels)+this.fontSize+3,d=aj([a,b]);this.width=d+2*this.xPadding;var c=this.height/2;this.y-c<0?this.y=c:this.y+c>this.chart.height&&(this.y=this.chart.height-c),this.x>this.chart.width/2?this.x-=this.xOffset+this.width:this.x+=this.xOffset},getLineHeight:function(b){var a=this.y-this.height/2+this.yPadding,c=b-1;return 0===b?a+this.titleFontSize/2:a+(1.5*this.fontSize*c+this.fontSize/2)+1.5*this.titleFontSize},draw:function(){if(this.custom){this.custom(this)}else{I(this.ctx,this.x,this.y-this.height/2,this.width,this.height,this.cornerRadius);var a=this.ctx;a.fillStyle=this.fillColor,a.fill(),a.closePath(),a.textAlign="left",a.textBaseline="middle",a.fillStyle=this.titleTextColor,a.font=this.titleFont,a.fillText(this.title,this.x+this.xPadding,this.getLineHeight(0)),a.font=this.font,X.each(this.labels,function(b,c){a.fillStyle=this.textColor,a.fillText(b,this.x+this.xPadding+this.fontSize+3,this.getLineHeight(c+1)),a.fillStyle=this.legendColorBackground,a.fillRect(this.x+this.xPadding,this.getLineHeight(c+1)-this.fontSize/2,this.fontSize,this.fontSize),a.fillStyle=this.legendColors[c].fill,a.fillRect(this.x+this.xPadding,this.getLineHeight(c+1)-this.fontSize/2,this.fontSize,this.fontSize)},this)}}}),al.Scale=al.Element.extend({initialize:function(){this.fit()},buildYLabels:function(){this.yLabels=[];for(var b=O(this.stepValue),a=0;a<=this.steps;a++){this.yLabels.push(Y(this.templateString,{value:(this.min+a*this.stepValue).toFixed(b)}))}this.yLabelWidth=this.display&&this.showLabels?j(this.ctx,this.font,this.yLabels):0},addXLabel:function(a){this.xLabels.push(a),this.valuesCount++,this.fit()},removeXLabel:function(){this.xLabels.shift(),this.valuesCount--,this.fit()},fit:function(){this.startPoint=this.display?this.fontSize:0,this.endPoint=this.display?this.height-1.5*this.fontSize-5:this.height,this.startPoint+=this.padding,this.endPoint-=this.padding;var b,a=this.endPoint-this.startPoint;for(this.calculateYRange(a),this.buildYLabels(),this.calculateXLabelRotation();a>this.endPoint-this.startPoint;){a=this.endPoint-this.startPoint,b=this.yLabelWidth,this.calculateYRange(a),this.buildYLabels(),b<this.yLabelWidth&&this.calculateXLabelRotation()}},calculateXLabelRotation:function(){this.ctx.font=this.font;var d,c,g=this.ctx.measureText(this.xLabels[0]).width,f=this.ctx.measureText(this.xLabels[this.xLabels.length-1]).width;if(this.xScalePaddingRight=f/2+3,this.xScalePaddingLeft=g/2>this.yLabelWidth+10?g/2:this.yLabelWidth+10,this.xLabelRotation=0,this.display){var k,h=j(this.ctx,this.font,this.xLabels);this.xLabelWidth=h;for(var b=Math.floor(this.calculateX(1)-this.calculateX(0))-6;this.xLabelWidth>b&&0===this.xLabelRotation||this.xLabelWidth>b&&this.xLabelRotation<=90&&this.xLabelRotation>0;){k=Math.cos(B(this.xLabelRotation)),d=k*g,c=k*f,d+this.fontSize/2>this.yLabelWidth+8&&(this.xScalePaddingLeft=d+this.fontSize/2),this.xScalePaddingRight=this.fontSize/2,this.xLabelRotation++,this.xLabelWidth=k*h}this.xLabelRotation>0&&(this.endPoint-=Math.sin(B(this.xLabelRotation))*h+3)}else{this.xLabelWidth=0,this.xScalePaddingRight=this.padding,this.xScalePaddingLeft=this.padding}},calculateYRange:an,drawingArea:function(){return this.startPoint-this.endPoint},calculateY:function(b){var a=this.drawingArea()/(this.min-this.max);return this.endPoint-a*(b-this.min)},calculateX:function(b){var a=(this.xLabelRotation>0,this.width-(this.xScalePaddingLeft+this.xScalePaddingRight)),d=a/(this.valuesCount-(this.offsetGridLines?0:1)),c=d*b+this.xScalePaddingLeft;return this.offsetGridLines&&(c+=d/2),Math.round(c)},update:function(a){X.extend(this,a),this.fit()},draw:function(){var b=this.ctx,a=(this.endPoint-this.startPoint)/this.steps,c=Math.round(this.xScalePaddingLeft);this.display&&(b.fillStyle=this.textColor,b.font=this.font,ad(this.yLabels,function(i,g){var e=this.endPoint-a*g,f=Math.round(e),d=this.showHorizontalLines;b.textAlign="right",b.textBaseline="middle",this.showLabels&&b.fillText(i,c-10,e),0!==g||d||(d=!0),d&&b.beginPath(),g>0?(b.lineWidth=this.gridLineWidth,b.strokeStyle=this.gridLineColor):(b.lineWidth=this.lineWidth,b.strokeStyle=this.lineColor),f+=X.aliasPixel(b.lineWidth),d&&(b.moveTo(c,f),b.lineTo(this.width,f),b.stroke(),b.closePath()),b.lineWidth=this.lineWidth,b.strokeStyle=this.lineColor,b.beginPath(),b.moveTo(c-5,f),b.lineTo(c,f),b.stroke(),b.closePath()},this),ad(this.xLabels,function(f,h){var g=this.calculateX(h)+K(this.lineWidth),l=this.calculateX(h-(this.offsetGridLines?0.5:0))+K(this.lineWidth),k=this.xLabelRotation>0,d=this.showVerticalLines;0!==h||d||(d=!0),d&&b.beginPath(),h>0?(b.lineWidth=this.gridLineWidth,b.strokeStyle=this.gridLineColor):(b.lineWidth=this.lineWidth,b.strokeStyle=this.lineColor),d&&(b.moveTo(l,this.endPoint),b.lineTo(l,this.startPoint-3),b.stroke(),b.closePath()),b.lineWidth=this.lineWidth,b.strokeStyle=this.lineColor,b.beginPath(),b.moveTo(l,this.endPoint),b.lineTo(l,this.endPoint+5),b.stroke(),b.closePath(),b.save(),b.translate(g,k?this.endPoint+12:this.endPoint+8),b.rotate(-1*B(this.xLabelRotation)),b.font=this.font,b.textAlign=k?"right":"center",b.textBaseline=k?"middle":"top",b.fillText(f,0,0),b.restore()},this))}}),al.RadialScale=al.Element.extend({initialize:function(){this.size=ae([this.height,this.width]),this.drawingArea=this.display?this.size/2-(this.fontSize/2+this.backdropPaddingY):this.size/2},calculateCenterOffset:function(b){var a=this.drawingArea/(this.max-this.min);return(b-this.min)*a},update:function(){this.lineArc?this.drawingArea=this.display?this.size/2-(this.fontSize/2+this.backdropPaddingY):this.size/2:this.setScaleSize(),this.buildYLabels()},buildYLabels:function(){this.yLabels=[];for(var b=O(this.stepValue),a=0;a<=this.steps;a++){this.yLabels.push(Y(this.templateString,{value:(this.min+a*this.stepValue).toFixed(b)}))}},getCircumference:function(){return 2*Math.PI/this.valuesCount},setScaleSize:function(){var M,w,z,P,m,k,F,x,v,b,C,L,A=ae([this.height/2-this.pointLabelFontSize-5,this.width/2]),f=this.width,y=0;for(this.ctx.font=G(this.pointLabelFontSize,this.pointLabelFontStyle,this.pointLabelFontFamily),w=0;w<this.valuesCount;w++){M=this.getPointPosition(w,A),z=this.ctx.measureText(Y(this.templateString,{value:this.labels[w]})).width+5,0===w||w===this.valuesCount/2?(P=z/2,M.x+P>f&&(f=M.x+P,m=w),M.x-P<y&&(y=M.x-P,F=w)):w<this.valuesCount/2?M.x+z>f&&(f=M.x+z,m=w):w>this.valuesCount/2&&M.x-z<y&&(y=M.x-z,F=w)}v=y,b=Math.ceil(f-this.width),k=this.getIndexAngle(m),x=this.getIndexAngle(F),C=b/Math.sin(k+Math.PI/2),L=v/Math.sin(x+Math.PI/2),C=ak(C)?C:0,L=ak(L)?L:0,this.drawingArea=A-(L+C)/2,this.setCenterPoint(L,C)},setCenterPoint:function(b,a){var d=this.width-a-this.drawingArea,c=b+this.drawingArea;this.xCenter=(c+d)/2,this.yCenter=this.height/2},getIndexAngle:function(b){var a=2*Math.PI/this.valuesCount;return b*a-Math.PI/2},getPointPosition:function(b,a){var c=this.getIndexAngle(b);return{x:Math.cos(c)*a+this.xCenter,y:Math.sin(c)*a+this.yCenter}},draw:function(){if(this.display){var n=this.ctx;if(ad(this.yLabels,function(r,v){if(v>0){var u,x=v*(this.drawingArea/this.steps),w=this.yCenter-x;if(this.lineWidth>0){if(n.strokeStyle=this.lineColor,n.lineWidth=this.lineWidth,this.lineArc){n.beginPath(),n.arc(this.xCenter,this.yCenter,x,0,2*Math.PI),n.closePath(),n.stroke()}else{n.beginPath();for(var l=0;l<this.valuesCount;l++){u=this.getPointPosition(l,this.calculateCenterOffset(this.min+v*this.stepValue)),0===l?n.moveTo(u.x,u.y):n.lineTo(u.x,u.y)}n.closePath(),n.stroke()}}if(this.showLabels){if(n.font=G(this.fontSize,this.fontStyle,this.fontFamily),this.showLabelBackdrop){var t=n.measureText(r).width;n.fillStyle=this.backdropColor,n.fillRect(this.xCenter-t/2-this.backdropPaddingX,w-this.fontSize/2-this.backdropPaddingY,t+2*this.backdropPaddingX,this.fontSize+2*this.backdropPaddingY)}n.textAlign="center",n.textBaseline="middle",n.fillStyle=this.fontColor,n.fillText(r,this.xCenter,w)}}},this),!this.lineArc){n.lineWidth=this.angleLineWidth,n.strokeStyle=this.angleLineColor;for(var f=this.valuesCount-1;f>=0;f--){if(this.angleLineWidth>0){var k=this.getPointPosition(f,this.calculateCenterOffset(this.max));n.beginPath(),n.moveTo(this.xCenter,this.yCenter),n.lineTo(k.x,k.y),n.stroke(),n.closePath()}var p=this.getPointPosition(f,this.calculateCenterOffset(this.max)+5);n.font=G(this.pointLabelFontSize,this.pointLabelFontStyle,this.pointLabelFontFamily),n.fillStyle=this.pointLabelFontColor;var c=this.labels.length,m=this.labels.length/2,g=m/2,d=g>f||f>c-g,b=f===g||f===c-g;n.textAlign=0===f?"center":f===m?"center":m>f?"left":"right",n.textBaseline=b?"middle":d?"bottom":"top",n.fillText(this.labels[f],p.x,p.y)}}}}}),X.addEvent(window,"resize",function(){var a;return function(){clearTimeout(a),a=setTimeout(function(){ad(al.instances,function(b){b.options.responsive&&b.resize(b.render,!0)})},50)}}()),ab?define(function(){return al}):"object"==typeof module&&module.exports&&(module.exports=al),V.Chart=al,al.noConflict=function(){return V.Chart=ah,al}}).call(this),function(){var b=this,a=b.Chart,d=a.helpers,c={scaleBeginAtZero:!0,scaleShowGridLines:!0,scaleGridLineColor:"rgba(0,0,0,.05)",scaleGridLineWidth:1,scaleShowHorizontalLines:!0,scaleShowVerticalLines:!0,barShowStroke:!0,barStrokeWidth:2,barValueSpacing:5,barDatasetSpacing:1,legendTemplate:'<ul class="<%=name.toLowerCase()%>-legend"><% for (var i=0; i<datasets.length; i++){%><li><span style="background-color:<%=datasets[i].fillColor%>"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>'};a.Type.extend({name:"Bar",defaults:c,initialize:function(e){var f=this.options;this.ScaleClass=a.Scale.extend({offsetGridLines:!0,calculateBarX:function(j,h,k){var m=this.calculateBaseWidth(),l=this.calculateX(k)-m/2,g=this.calculateBarWidth(j);return l+g*h+h*f.barDatasetSpacing+g/2},calculateBaseWidth:function(){return this.calculateX(1)-this.calculateX(0)-2*f.barValueSpacing},calculateBarWidth:function(h){var g=this.calculateBaseWidth()-(h-1)*f.barDatasetSpacing;return g/h}}),this.datasets=[],this.options.showTooltips&&d.bindEvents(this,this.options.tooltipEvents,function(h){var g="mouseout"!==h.type?this.getBarsAtEvent(h):[];this.eachBars(function(i){i.restore(["fillColor","strokeColor"])}),d.each(g,function(i){i.fillColor=i.highlightFill,i.strokeColor=i.highlightStroke}),this.showTooltip(g)}),this.BarClass=a.Rectangle.extend({strokeWidth:this.options.barStrokeWidth,showStroke:this.options.barShowStroke,ctx:this.chart.ctx}),d.each(e.datasets,function(g){var h={label:g.label||null,fillColor:g.fillColor,strokeColor:g.strokeColor,bars:[]};this.datasets.push(h),d.each(g.data,function(i,j){h.bars.push(new this.BarClass({value:i,label:e.labels[j],datasetLabel:g.label,strokeColor:g.strokeColor,fillColor:g.fillColor,highlightFill:g.highlightFill||g.fillColor,highlightStroke:g.highlightStroke||g.strokeColor}))},this)},this),this.buildScale(e.labels),this.BarClass.prototype.base=this.scale.endPoint,this.eachBars(function(h,g,j){d.extend(h,{width:this.scale.calculateBarWidth(this.datasets.length),x:this.scale.calculateBarX(this.datasets.length,j,g),y:this.scale.endPoint}),h.save()},this),this.render()},update:function(){this.scale.update(),d.each(this.activeElements,function(e){e.restore(["fillColor","strokeColor"])}),this.eachBars(function(e){e.save()}),this.render()},eachBars:function(e){d.each(this.datasets,function(f,g){d.each(f.bars,e,this,g)},this)},getBarsAtEvent:function(g){for(var f,h=[],k=d.getRelativePosition(g),j=function(i){h.push(i.bars[f])},e=0;e<this.datasets.length;e++){for(f=0;f<this.datasets[e].bars.length;f++){if(this.datasets[e].bars[f].inRange(k.x,k.y)){return d.each(this.datasets,j),h}}}return h},buildScale:function(f){var e=this,g=function(){var i=[];return e.eachBars(function(j){i.push(j.value)}),i},h={templateString:this.options.scaleLabel,height:this.chart.height,width:this.chart.width,ctx:this.chart.ctx,textColor:this.options.scaleFontColor,fontSize:this.options.scaleFontSize,fontStyle:this.options.scaleFontStyle,fontFamily:this.options.scaleFontFamily,valuesCount:f.length,beginAtZero:this.options.scaleBeginAtZero,integersOnly:this.options.scaleIntegersOnly,calculateYRange:function(k){var j=d.calculateScaleRange(g(),k,this.fontSize,this.beginAtZero,this.integersOnly);d.extend(this,j)},xLabels:f,font:d.fontString(this.options.scaleFontSize,this.options.scaleFontStyle,this.options.scaleFontFamily),lineWidth:this.options.scaleLineWidth,lineColor:this.options.scaleLineColor,showHorizontalLines:this.options.scaleShowHorizontalLines,showVerticalLines:this.options.scaleShowVerticalLines,gridLineWidth:this.options.scaleShowGridLines?this.options.scaleGridLineWidth:0,gridLineColor:this.options.scaleShowGridLines?this.options.scaleGridLineColor:"rgba(0,0,0,0)",padding:this.options.showScale?0:this.options.barShowStroke?this.options.barStrokeWidth:0,showLabels:this.options.scaleShowLabels,display:this.options.showScale};this.options.scaleOverride&&d.extend(h,{calculateYRange:d.noop,steps:this.options.scaleSteps,stepValue:this.options.scaleStepWidth,min:this.options.scaleStartValue,max:this.options.scaleStartValue+this.options.scaleSteps*this.options.scaleStepWidth}),this.scale=new this.ScaleClass(h)},addData:function(f,e){d.each(f,function(g,h){this.datasets[h].bars.push(new this.BarClass({value:g,label:e,x:this.scale.calculateBarX(this.datasets.length,h,this.scale.valuesCount+1),y:this.scale.endPoint,width:this.scale.calculateBarWidth(this.datasets.length),base:this.scale.endPoint,strokeColor:this.datasets[h].strokeColor,fillColor:this.datasets[h].fillColor}))},this),this.scale.addXLabel(e),this.update()},removeData:function(){this.scale.removeXLabel(),d.each(this.datasets,function(e){e.bars.shift()},this),this.update()},reflow:function(){d.extend(this.BarClass.prototype,{y:this.scale.endPoint,base:this.scale.endPoint});var e=d.extend({height:this.chart.height,width:this.chart.width});this.scale.update(e)},draw:function(f){var e=f||1;this.clear();this.chart.ctx;this.scale.draw(e),d.each(this.datasets,function(g,h){d.each(g.bars,function(i,j){i.hasValue()&&(i.base=this.scale.endPoint,i.transition({x:this.scale.calculateBarX(this.datasets.length,h,j),y:this.scale.calculateY(i.value),width:this.scale.calculateBarWidth(this.datasets.length)},e).draw())},this)},this)}})}.call(this),function(){var b=this,a=b.Chart,d=a.helpers,c={segmentShowStroke:!0,segmentStrokeColor:"#fff",segmentStrokeWidth:2,percentageInnerCutout:50,animationSteps:100,animationEasing:"easeOutBounce",animateRotate:!0,animateScale:!1,legendTemplate:'<ul class="<%=name.toLowerCase()%>-legend"><% for (var i=0; i<segments.length; i++){%><li><span style="background-color:<%=segments[i].fillColor%>"></span><%if(segments[i].label){%><%=segments[i].label%><%}%></li><%}%></ul>'};a.Type.extend({name:"Doughnut",defaults:c,initialize:function(e){this.segments=[],this.outerRadius=(d.min([this.chart.width,this.chart.height])-this.options.segmentStrokeWidth/2)/2,this.SegmentArc=a.Arc.extend({ctx:this.chart.ctx,x:this.chart.width/2,y:this.chart.height/2}),this.options.showTooltips&&d.bindEvents(this,this.options.tooltipEvents,function(g){var f="mouseout"!==g.type?this.getSegmentsAtEvent(g):[];d.each(this.segments,function(h){h.restore(["fillColor"])}),d.each(f,function(h){h.fillColor=h.highlightColor}),this.showTooltip(f)}),this.calculateTotal(e),d.each(e,function(g,f){this.addData(g,f,!0)},this),this.render()},getSegmentsAtEvent:function(f){var e=[],g=d.getRelativePosition(f);return d.each(this.segments,function(h){h.inRange(g.x,g.y)&&e.push(h)},this),e},addData:function(g,f,j){var h=f||this.segments.length;this.segments.splice(h,0,new this.SegmentArc({value:g.value,outerRadius:this.options.animateScale?0:this.outerRadius,innerRadius:this.options.animateScale?0:this.outerRadius/100*this.options.percentageInnerCutout,fillColor:g.color,highlightColor:g.highlight||g.color,showStroke:this.options.segmentShowStroke,strokeWidth:this.options.segmentStrokeWidth,strokeColor:this.options.segmentStrokeColor,startAngle:1.5*Math.PI,circumference:this.options.animateRotate?0:this.calculateCircumference(g.value),label:g.label})),j||(this.reflow(),this.update())},calculateCircumference:function(e){return 2*Math.PI*(e/this.total)},calculateTotal:function(e){this.total=0,d.each(e,function(f){this.total+=f.value},this)},update:function(){this.calculateTotal(this.segments),d.each(this.activeElements,function(e){e.restore(["fillColor"])}),d.each(this.segments,function(e){e.save()}),this.render()},removeData:function(f){var e=d.isNumber(f)?f:this.segments.length-1;this.segments.splice(e,1),this.reflow(),this.update()},reflow:function(){d.extend(this.SegmentArc.prototype,{x:this.chart.width/2,y:this.chart.height/2}),this.outerRadius=(d.min([this.chart.width,this.chart.height])-this.options.segmentStrokeWidth/2)/2,d.each(this.segments,function(e){e.update({outerRadius:this.outerRadius,innerRadius:this.outerRadius/100*this.options.percentageInnerCutout})},this)},draw:function(f){var e=f?f:1;this.clear(),d.each(this.segments,function(g,h){g.transition({circumference:this.calculateCircumference(g.value),outerRadius:this.outerRadius,innerRadius:this.outerRadius/100*this.options.percentageInnerCutout},e),g.endAngle=g.startAngle+g.circumference,g.draw(),0===h&&(g.startAngle=1.5*Math.PI),h<this.segments.length-1&&(this.segments[h+1].startAngle=g.endAngle)},this)}}),a.types.Doughnut.extend({name:"Pie",defaults:d.merge(c,{percentageInnerCutout:0})})}.call(this),function(){var b=this,a=b.Chart,d=a.helpers,c={scaleShowGridLines:!0,scaleGridLineColor:"rgba(0,0,0,.05)",scaleGridLineWidth:1,scaleShowHorizontalLines:!0,scaleShowVerticalLines:!0,bezierCurve:!0,bezierCurveTension:0.4,pointDot:!0,pointDotRadius:4,pointDotStrokeWidth:1,pointHitDetectionRadius:20,datasetStroke:!0,datasetStrokeWidth:2,datasetFill:!0,legendTemplate:'<ul class="<%=name.toLowerCase()%>-legend"><% for (var i=0; i<datasets.length; i++){%><li><span style="background-color:<%=datasets[i].strokeColor%>"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>'};a.Type.extend({name:"Line",defaults:c,initialize:function(e){this.PointClass=a.Point.extend({strokeWidth:this.options.pointDotStrokeWidth,radius:this.options.pointDotRadius,display:this.options.pointDot,hitDetectionRadius:this.options.pointHitDetectionRadius,ctx:this.chart.ctx,inRange:function(f){return Math.pow(f-this.x,2)<Math.pow(this.radius+this.hitDetectionRadius,2)}}),this.datasets=[],this.options.showTooltips&&d.bindEvents(this,this.options.tooltipEvents,function(g){var f="mouseout"!==g.type?this.getPointsAtEvent(g):[];this.eachPoints(function(h){h.restore(["fillColor","strokeColor"])}),d.each(f,function(h){h.fillColor=h.highlightFill,h.strokeColor=h.highlightStroke}),this.showTooltip(f)}),d.each(e.datasets,function(f){var g={label:f.label||null,fillColor:f.fillColor,strokeColor:f.strokeColor,pointColor:f.pointColor,pointStrokeColor:f.pointStrokeColor,points:[]};this.datasets.push(g),d.each(f.data,function(h,i){g.points.push(new this.PointClass({value:h,label:e.labels[i],datasetLabel:f.label,strokeColor:f.pointStrokeColor,fillColor:f.pointColor,highlightFill:f.pointHighlightFill||f.pointColor,highlightStroke:f.pointHighlightStroke||f.pointStrokeColor}))},this),this.buildScale(e.labels),this.eachPoints(function(j,h){d.extend(j,{x:this.scale.calculateX(h),y:this.scale.endPoint}),j.save()},this)},this),this.render()},update:function(){this.scale.update(),d.each(this.activeElements,function(e){e.restore(["fillColor","strokeColor"])}),this.eachPoints(function(e){e.save()}),this.render()},eachPoints:function(e){d.each(this.datasets,function(f){d.each(f.points,e,this)},this)},getPointsAtEvent:function(f){var e=[],g=d.getRelativePosition(f);return d.each(this.datasets,function(h){d.each(h.points,function(i){i.inRange(g.x,g.y)&&e.push(i)})},this),e},buildScale:function(e){var f=this,h=function(){var i=[];return f.eachPoints(function(j){i.push(j.value)}),i},g={templateString:this.options.scaleLabel,height:this.chart.height,width:this.chart.width,ctx:this.chart.ctx,textColor:this.options.scaleFontColor,fontSize:this.options.scaleFontSize,fontStyle:this.options.scaleFontStyle,fontFamily:this.options.scaleFontFamily,valuesCount:e.length,beginAtZero:this.options.scaleBeginAtZero,integersOnly:this.options.scaleIntegersOnly,calculateYRange:function(k){var j=d.calculateScaleRange(h(),k,this.fontSize,this.beginAtZero,this.integersOnly);d.extend(this,j)},xLabels:e,font:d.fontString(this.options.scaleFontSize,this.options.scaleFontStyle,this.options.scaleFontFamily),lineWidth:this.options.scaleLineWidth,lineColor:this.options.scaleLineColor,showHorizontalLines:this.options.scaleShowHorizontalLines,showVerticalLines:this.options.scaleShowVerticalLines,gridLineWidth:this.options.scaleShowGridLines?this.options.scaleGridLineWidth:0,gridLineColor:this.options.scaleShowGridLines?this.options.scaleGridLineColor:"rgba(0,0,0,0)",padding:this.options.showScale?0:this.options.pointDotRadius+this.options.pointDotStrokeWidth,showLabels:this.options.scaleShowLabels,display:this.options.showScale};this.options.scaleOverride&&d.extend(g,{calculateYRange:d.noop,steps:this.options.scaleSteps,stepValue:this.options.scaleStepWidth,min:this.options.scaleStartValue,max:this.options.scaleStartValue+this.options.scaleSteps*this.options.scaleStepWidth}),this.scale=new a.Scale(g)},addData:function(f,e){d.each(f,function(g,h){this.datasets[h].points.push(new this.PointClass({value:g,label:e,x:this.scale.calculateX(this.scale.valuesCount+1),y:this.scale.endPoint,strokeColor:this.datasets[h].pointStrokeColor,fillColor:this.datasets[h].pointColor}))},this),this.scale.addXLabel(e),this.update()},removeData:function(){this.scale.removeXLabel(),d.each(this.datasets,function(e){e.points.shift()},this),this.update()},reflow:function(){var e=d.extend({height:this.chart.height,width:this.chart.width});this.scale.update(e)},draw:function(g){var f=g||1;this.clear();var h=this.chart.ctx,k=function(i){return null!==i.value},j=function(m,l,n){return d.findNextWhere(l,k,n)||m},e=function(m,l,n){return d.findPreviousWhere(l,k,n)||m};this.scale.draw(f),d.each(this.datasets,function(i){var l=d.where(i.points,k);d.each(i.points,function(m,n){m.hasValue()&&m.transition({y:this.scale.calculateY(m.value),x:this.scale.calculateX(n)},f)},this),this.options.bezierCurve&&d.each(l,function(n,m){var o=m>0&&m<l.length-1?this.options.bezierCurveTension:0;n.controlPoints=d.splineCurve(e(n,l,m),n,j(n,l,m),o),n.controlPoints.outer.y>this.scale.endPoint?n.controlPoints.outer.y=this.scale.endPoint:n.controlPoints.outer.y<this.scale.startPoint&&(n.controlPoints.outer.y=this.scale.startPoint),n.controlPoints.inner.y>this.scale.endPoint?n.controlPoints.inner.y=this.scale.endPoint:n.controlPoints.inner.y<this.scale.startPoint&&(n.controlPoints.inner.y=this.scale.startPoint)},this),h.lineWidth=this.options.datasetStrokeWidth,h.strokeStyle=i.strokeColor,h.beginPath(),d.each(l,function(n,m){if(0===m){h.moveTo(n.x,n.y)}else{if(this.options.bezierCurve){var o=e(n,l,m);h.bezierCurveTo(o.controlPoints.outer.x,o.controlPoints.outer.y,n.controlPoints.inner.x,n.controlPoints.inner.y,n.x,n.y)}else{h.lineTo(n.x,n.y)}}},this),h.stroke(),this.options.datasetFill&&l.length>0&&(h.lineTo(l[l.length-1].x,this.scale.endPoint),h.lineTo(l[0].x,this.scale.endPoint),h.fillStyle=i.fillColor,h.closePath(),h.fill()),d.each(l,function(m){m.draw()})},this)}})}.call(this),function(){var b=this,a=b.Chart,d=a.helpers,c={scaleShowLabelBackdrop:!0,scaleBackdropColor:"rgba(255,255,255,0.75)",scaleBeginAtZero:!0,scaleBackdropPaddingY:2,scaleBackdropPaddingX:2,scaleShowLine:!0,segmentShowStroke:!0,segmentStrokeColor:"#fff",segmentStrokeWidth:2,animationSteps:100,animationEasing:"easeOutBounce",animateRotate:!0,animateScale:!1,legendTemplate:'<ul class="<%=name.toLowerCase()%>-legend"><% for (var i=0; i<segments.length; i++){%><li><span style="background-color:<%=segments[i].fillColor%>"></span><%if(segments[i].label){%><%=segments[i].label%><%}%></li><%}%></ul>'};a.Type.extend({name:"PolarArea",defaults:c,initialize:function(e){this.segments=[],this.SegmentArc=a.Arc.extend({showStroke:this.options.segmentShowStroke,strokeWidth:this.options.segmentStrokeWidth,strokeColor:this.options.segmentStrokeColor,ctx:this.chart.ctx,innerRadius:0,x:this.chart.width/2,y:this.chart.height/2}),this.scale=new a.RadialScale({display:this.options.showScale,fontStyle:this.options.scaleFontStyle,fontSize:this.options.scaleFontSize,fontFamily:this.options.scaleFontFamily,fontColor:this.options.scaleFontColor,showLabels:this.options.scaleShowLabels,showLabelBackdrop:this.options.scaleShowLabelBackdrop,backdropColor:this.options.scaleBackdropColor,backdropPaddingY:this.options.scaleBackdropPaddingY,backdropPaddingX:this.options.scaleBackdropPaddingX,lineWidth:this.options.scaleShowLine?this.options.scaleLineWidth:0,lineColor:this.options.scaleLineColor,lineArc:!0,width:this.chart.width,height:this.chart.height,xCenter:this.chart.width/2,yCenter:this.chart.height/2,ctx:this.chart.ctx,templateString:this.options.scaleLabel,valuesCount:e.length}),this.updateScaleRange(e),this.scale.update(),d.each(e,function(g,f){this.addData(g,f,!0)},this),this.options.showTooltips&&d.bindEvents(this,this.options.tooltipEvents,function(g){var f="mouseout"!==g.type?this.getSegmentsAtEvent(g):[];d.each(this.segments,function(h){h.restore(["fillColor"])}),d.each(f,function(h){h.fillColor=h.highlightColor}),this.showTooltip(f)}),this.render()},getSegmentsAtEvent:function(f){var e=[],g=d.getRelativePosition(f);return d.each(this.segments,function(h){h.inRange(g.x,g.y)&&e.push(h)},this),e},addData:function(g,f,j){var h=f||this.segments.length;this.segments.splice(h,0,new this.SegmentArc({fillColor:g.color,highlightColor:g.highlight||g.color,label:g.label,value:g.value,outerRadius:this.options.animateScale?0:this.scale.calculateCenterOffset(g.value),circumference:this.options.animateRotate?0:this.scale.getCircumference(),startAngle:1.5*Math.PI})),j||(this.reflow(),this.update())},removeData:function(f){var e=d.isNumber(f)?f:this.segments.length-1;this.segments.splice(e,1),this.reflow(),this.update()},calculateTotal:function(e){this.total=0,d.each(e,function(f){this.total+=f.value},this),this.scale.valuesCount=this.segments.length},updateScaleRange:function(f){var e=[];d.each(f,function(h){e.push(h.value)});var g=this.options.scaleOverride?{steps:this.options.scaleSteps,stepValue:this.options.scaleStepWidth,min:this.options.scaleStartValue,max:this.options.scaleStartValue+this.options.scaleSteps*this.options.scaleStepWidth}:d.calculateScaleRange(e,d.min([this.chart.width,this.chart.height])/2,this.options.scaleFontSize,this.options.scaleBeginAtZero,this.options.scaleIntegersOnly);d.extend(this.scale,g,{size:d.min([this.chart.width,this.chart.height]),xCenter:this.chart.width/2,yCenter:this.chart.height/2})},update:function(){this.calculateTotal(this.segments),d.each(this.segments,function(e){e.save()}),this.render()},reflow:function(){d.extend(this.SegmentArc.prototype,{x:this.chart.width/2,y:this.chart.height/2}),this.updateScaleRange(this.segments),this.scale.update(),d.extend(this.scale,{xCenter:this.chart.width/2,yCenter:this.chart.height/2}),d.each(this.segments,function(e){e.update({outerRadius:this.scale.calculateCenterOffset(e.value)})},this)},draw:function(f){var e=f||1;this.clear(),d.each(this.segments,function(g,h){g.transition({circumference:this.scale.getCircumference(),outerRadius:this.scale.calculateCenterOffset(g.value)},e),g.endAngle=g.startAngle+g.circumference,0===h&&(g.startAngle=1.5*Math.PI),h<this.segments.length-1&&(this.segments[h+1].startAngle=g.endAngle),g.draw()},this),this.scale.draw()}})}.call(this),function(){var b=this,a=b.Chart,c=a.helpers;a.Type.extend({name:"Radar",defaults:{scaleShowLine:!0,angleShowLineOut:!0,scaleShowLabels:!1,scaleBeginAtZero:!0,angleLineColor:"rgba(0,0,0,.1)",angleLineWidth:1,pointLabelFontFamily:"'Arial'",pointLabelFontStyle:"normal",pointLabelFontSize:10,pointLabelFontColor:"#fff",pointDot:!0,pointDotRadius:3,pointDotStrokeWidth:1,pointHitDetectionRadius:20,datasetStroke:!0,datasetStrokeWidth:2,datasetFill:!0,legendTemplate:'<ul class="<%=name.toLowerCase()%>-legend"><% for (var i=0; i<datasets.length; i++){%><li><span style="background-color:<%=datasets[i].strokeColor%>"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>'},initialize:function(d){this.PointClass=a.Point.extend({strokeWidth:this.options.pointDotStrokeWidth,radius:this.options.pointDotRadius,display:this.options.pointDot,hitDetectionRadius:this.options.pointHitDetectionRadius,ctx:this.chart.ctx}),this.datasets=[],this.buildScale(d),this.options.showTooltips&&c.bindEvents(this,this.options.tooltipEvents,function(f){var e="mouseout"!==f.type?this.getPointsAtEvent(f):[];this.eachPoints(function(g){g.restore(["fillColor","strokeColor"])}),c.each(e,function(g){g.fillColor=g.highlightFill,g.strokeColor=g.highlightStroke}),this.showTooltip(e)}),c.each(d.datasets,function(e){var f={label:e.label||null,fillColor:e.fillColor,strokeColor:e.strokeColor,pointColor:e.pointColor,pointStrokeColor:e.pointStrokeColor,points:[]};this.datasets.push(f),c.each(e.data,function(g,i){var h;this.scale.animation||(h=this.scale.getPointPosition(i,this.scale.calculateCenterOffset(g))),f.points.push(new this.PointClass({value:g,label:d.labels[i],datasetLabel:e.label,x:this.options.animation?this.scale.xCenter:h.x,y:this.options.animation?this.scale.yCenter:h.y,strokeColor:e.pointStrokeColor,fillColor:e.pointColor,highlightFill:e.pointHighlightFill||e.pointColor,highlightStroke:e.pointHighlightStroke||e.pointStrokeColor}))},this)},this),this.render()},eachPoints:function(d){c.each(this.datasets,function(e){c.each(e.points,d,this)},this)},getPointsAtEvent:function(f){var e=c.getRelativePosition(f),g=c.getAngleFromPoint({x:this.scale.xCenter,y:this.scale.yCenter},e),j=2*Math.PI/this.scale.valuesCount,h=Math.round((g.angle-1.5*Math.PI)/j),d=[];return(h>=this.scale.valuesCount||0>h)&&(h=0),g.distance<=this.scale.drawingArea&&c.each(this.datasets,function(i){d.push(i.points[h])}),d},buildScale:function(d){this.scale=new a.RadialScale({display:this.options.showScale,fontStyle:this.options.scaleFontStyle,fontSize:this.options.scaleFontSize,fontFamily:this.options.scaleFontFamily,fontColor:this.options.scaleFontColor,showLabels:this.options.scaleShowLabels,showLabelBackdrop:this.options.scaleShowLabelBackdrop,backdropColor:this.options.scaleBackdropColor,backdropPaddingY:this.options.scaleBackdropPaddingY,backdropPaddingX:this.options.scaleBackdropPaddingX,lineWidth:this.options.scaleShowLine?this.options.scaleLineWidth:0,lineColor:this.options.scaleLineColor,angleLineColor:this.options.angleLineColor,angleLineWidth:this.options.angleShowLineOut?this.options.angleLineWidth:0,pointLabelFontColor:this.options.pointLabelFontColor,pointLabelFontSize:this.options.pointLabelFontSize,pointLabelFontFamily:this.options.pointLabelFontFamily,pointLabelFontStyle:this.options.pointLabelFontStyle,height:this.chart.height,width:this.chart.width,xCenter:this.chart.width/2,yCenter:this.chart.height/2,ctx:this.chart.ctx,templateString:this.options.scaleLabel,labels:d.labels,valuesCount:d.datasets[0].data.length}),this.scale.setScaleSize(),this.updateScaleRange(d.datasets),this.scale.buildYLabels()},updateScaleRange:function(e){var d=function(){var g=[];return c.each(e,function(h){h.data?g=g.concat(h.data):c.each(h.points,function(i){g.push(i.value)})}),g}(),f=this.options.scaleOverride?{steps:this.options.scaleSteps,stepValue:this.options.scaleStepWidth,min:this.options.scaleStartValue,max:this.options.scaleStartValue+this.options.scaleSteps*this.options.scaleStepWidth}:c.calculateScaleRange(d,c.min([this.chart.width,this.chart.height])/2,this.options.scaleFontSize,this.options.scaleBeginAtZero,this.options.scaleIntegersOnly);c.extend(this.scale,f)},addData:function(e,d){this.scale.valuesCount++,c.each(e,function(f,h){var g=this.scale.getPointPosition(this.scale.valuesCount,this.scale.calculateCenterOffset(f));this.datasets[h].points.push(new this.PointClass({value:f,label:d,x:g.x,y:g.y,strokeColor:this.datasets[h].pointStrokeColor,fillColor:this.datasets[h].pointColor}))},this),this.scale.labels.push(d),this.reflow(),this.update()},removeData:function(){this.scale.valuesCount--,this.scale.labels.shift(),c.each(this.datasets,function(d){d.points.shift()},this),this.reflow(),this.update()},update:function(){this.eachPoints(function(d){d.save()}),this.reflow(),this.render()},reflow:function(){c.extend(this.scale,{width:this.chart.width,height:this.chart.height,size:c.min([this.chart.width,this.chart.height]),xCenter:this.chart.width/2,yCenter:this.chart.height/2}),this.updateScaleRange(this.datasets),this.scale.setScaleSize(),this.scale.buildYLabels()},draw:function(e){var d=e||1,f=this.chart.ctx;this.clear(),this.scale.draw(),c.each(this.datasets,function(g){c.each(g.points,function(h,i){h.hasValue()&&h.transition(this.scale.getPointPosition(i,this.scale.calculateCenterOffset(h.value)),d)},this),f.lineWidth=this.options.datasetStrokeWidth,f.strokeStyle=g.strokeColor,f.beginPath(),c.each(g.points,function(j,h){0===h?f.moveTo(j.x,j.y):f.lineTo(j.x,j.y)},this),f.closePath(),f.stroke(),f.fillStyle=g.fillColor,f.fill(),c.each(g.points,function(h){h.hasValue()&&h.draw()})},this)}})}.call(this);