Insticator.logger = (function () { "use strict"; function getParameterByName(name) { var regexS = "[\\?&]" + name + "=([^&#]*)"; var regex = new RegExp(regexS); var results = regex.exec(window.location.search); if (results === null) { return ""; } return decodeURIComponent(results[1].replace(/\+/g, ' ')); } var showLog = getParameterByName("insticator_log"); return { logMessage: function(msg) { if (showLog) { console.log("INSTICATOR_MESSAGE: " + msg); } } } })(); try { Insticator.settings = { tier1GeoList: [], tier2GeoList: [], tier3GeoList: [], tier4GeoList: [], visitorGeo: "UNKNOWN", visitorFloorTier:"UNKNOWN", visitorGeoCookieName: "visitorGeo", visitorFloorTierCookieName: "visitorFloorTier", setCookie: function(cname, cvalue, exdays) { Insticator.logger.logMessage("setCookie"); var d = new Date(); d.setTime(d.getTime() + (exdays*24*60*60*1000)); var expires = "expires="+ d.toUTCString(); document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/"; }, getCookie: function(cname) { var name = cname + "="; var decodedCookie = decodeURIComponent(document.cookie); var ca = decodedCookie.split(';'); for(var i = 0; i < ca.length; i++) { var c=ca[i]; while (c.charAt(0) == ' ') { c=c.substring(1); } if (c.indexOf(name) == 0) { return c.substring(name.length, c.length); } } return ""; }, makeAjaxCall: function(theUrl, callback) { var xmlHttp=new XMLHttpRequest(); xmlHttp.onreadystatechange = function() { if (xmlHttp.readyState == 4 && xmlHttp.status == 200) { callback(xmlHttp.responseText); } }; xmlHttp.open("GET", theUrl, true); xmlHttp.send(null); }, calculateVisitorFloorTier: function(trafficSource) { Insticator.logger.logMessage("trafficSource: " + trafficSource); var sourceJson=JSON.parse(trafficSource); if(sourceJson.hasOwnProperty("country_code")) { Insticator.settings.visitorGeo = sourceJson["country_code"]; if(Insticator.settings.tier1GeoList.indexOf(Insticator.settings.visitorGeo)> -1) { Insticator.settings.visitorFloorTier = "1"; } else if(Insticator.settings.tier2GeoList.indexOf(Insticator.settings.visitorGeo) > -1) { Insticator.settings.visitorFloorTier = "2"; } else if(Insticator.settings.tier3GeoList.indexOf(Insticator.settings.visitorGeo) > -1) { Insticator.settings.visitorFloorTier = "3"; } else { Insticator.settings.visitorFloorTier = "4"; } Insticator.logger.logMessage("Insticator.settings.visitorFloorTier: " + Insticator.settings.visitorFloorTier); Insticator.settings.setCookie(Insticator.settings.visitorGeoCookieName, Insticator.settings.visitorGeo, 1); Insticator.settings.setCookie(Insticator.settings.visitorFloorTierCookieName, Insticator.settings.visitorFloorTier, 1); } else { Insticator.logger.logMessage("countryCode not available in sourceJson: " + sourceJson); } }, checkVisitorFloorTier: function() { Insticator.settings.visitorFloorTier = Insticator.settings.getCookie(Insticator.settings.visitorFloorTierCookieName); if(Insticator.settings.visitorFloorTier !== "") { Insticator.logger.logMessage("find in cookie! visitorFloorTier: " + Insticator.settings.visitorFloorTier); } else { Insticator.logger.logMessage("not in cookie"); Insticator.settings.makeAjaxCall("https://freegeoip.net/json/", Insticator.settings.calculateVisitorFloorTier); } } }; Insticator.settings.tier1GeoList = "US"; Insticator.settings.tier2GeoList = "AU,CA,IE,NZ,SG,GB"; Insticator.settings.tier3GeoList = "AT,BE,DK,FI,DE,HK,NL,NO,SA,SE,CH,AE"; Insticator.settings.tier4GeoList = "AF,AX,AL,DZ,AS,AD,AO,AI,AQ,AG,AR,AM,AW,AZ,BS,BH,BD,BB,BY,BZ,BJ,BM,BT,BO,BA,BW,BV,BR,IO,BN,BG,BF,BI,KH,CM,CV,KY,CF,TD,CL,CN,CX,CC,CO,KM,CG,CD,CK,CR,CI,HR,CU,CY,CZ,DJ,DM,DO,EC,EG,SV,GQ,ER,EE,ET,FK,FO,FJ,FR,GF,PF,TF,GA,GM,GE,GH,GI,GR,GL,GD,GP,GU,GT,GG,GN,GW,GY,HT,HM,VA,HN,HU,IS,IN,ID,IR,IQ,IM,IL,IT,JM,JP,JE,JO,KZ,KE,KI,KR,KW,KG,LA,LV,LB,LS,LR,LY,LI,LT,LU,MO,MK,MG,MW,MY,MV,ML,MT,MH,MQ,MR,MU,YT,MX,FM,MD,MC,MN,ME,MS,MA,MZ,MM,NA,NR,NP,AN,NC,NI,NE,NG,NU,NF,MP,OM,PK,PW,PS,PA,PG,PY,PE,PH,PN,PL,PT,PR,QA,RE,RO,RU,RW,BL,SH,KN,LC,MF,PM,VC,WS,SM,ST,SN,RS,SC,SL,SK,SI,SB,SO,ZA,GS,ES,LK,SD,SR,SJ,SZ,SY,TW,TJ,TZ,TH,TL,TG,TK,TO,TT,TN,TR,TM,TC,TV,UG,UA,UM,UY,UZ,VU,VE,VN,VG,VI,WF,EH,YE,ZM,ZW"; Insticator.settings.checkVisitorFloorTier(); Insticator.helper = (function () { return { isMobileDevice: (function(){return/(android|bb\d |meego). mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0,4))?!0:!1})(), }; }()); var PREBID_TIMEOUT = 2000; var PREBID_MOBILE_TIMEOUT = 2000; var REFRESH_TIMEOUT = 1000; Insticator.ad.ready = false; Insticator.ad.hbFills = {}; Insticator.ad.refreshAdInterval = 30000; var googletag = googletag || {}; googletag.cmd = googletag.cmd || []; var refUrl = window.location.host.replace('www.', ''); Insticator.adSlots = {}; function insticator_defineAdSlots() { googletag.cmd.push(function () { if (!Insticator.helper.isMobileDevice) { Insticator.adSlots['div-insticator-ad-1'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_300x250_1', [300, 250], 'div-insticator-ad-1').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-1'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-10'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_300x250_4', [300, 250], 'div-insticator-ad-10').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-10'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-2'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_300x250_2', [300, 250], 'div-insticator-ad-2').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-2'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-3'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_728x90_1', [728, 90], 'div-insticator-ad-3').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-3'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-4'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_728x90_2', [728, 90], 'div-insticator-ad-4').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-4'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-5'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_160x600_1', [160, 600], 'div-insticator-ad-5').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-5'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-6'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_160x600_2', [160, 600], 'div-insticator-ad-6').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-6'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-7'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_300x250_3', [300, 250], 'div-insticator-ad-7').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-7'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-8'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_728x90_3', [728, 90], 'div-insticator-ad-8').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-8'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-9'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Web_160x600_3', [160, 600], 'div-insticator-ad-9').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-9'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); } else { Insticator.adSlots['div-insticator-ad-1'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_1', [300, 250], 'div-insticator-ad-1').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-1'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-10'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_4', [300, 250], 'div-insticator-ad-10').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-10'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-2'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_2', [300, 250], 'div-insticator-ad-2').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-2'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-3'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_728x90_1', [728, 90], 'div-insticator-ad-3').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-3'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-4'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_728x90_2', [728, 90], 'div-insticator-ad-4').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-4'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-5'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_160x600_1', [160, 600], 'div-insticator-ad-5').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-5'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-6'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_160x600_2', [160, 600], 'div-insticator-ad-6').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-6'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-7'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_3', [300, 250], 'div-insticator-ad-7').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-7'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-8'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_728x90_3', [728, 90], 'div-insticator-ad-8').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-8'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); Insticator.adSlots['div-insticator-ad-9'] = googletag.defineSlot('/27794161/bulbapedia.bulbagarden.net_Mobile_160x600_3', [160, 600], 'div-insticator-ad-9').addService(googletag.pubads()).setTargeting("refurl", refUrl); Insticator.adSlots['div-insticator-ad-9'].setTargeting('ad_group', Adomik.randomAdGroup()).setTargeting('ad_h', (new Date).getUTCHours().toString()); } googletag.enableServices(); }); } function insticator_customTargeting() { var adUnitsSize = JSON.parse(adUnitSizeListJsonString); for (var i in Insticator.adSlots) { var targeting = instBid.getAdserverTargetingForAdUnitCode(i); if(typeof targeting === "undefined" || targeting['instBid_bidder'] === '') { Insticator.logger.logMessage("No fill for: " + i + " , add custom targeting"); Insticator.adSlots[i].setTargeting("instBid_bidder", "nofill").setTargeting("instBid_pb", "0").setTargeting("instBid_adid", "nofill"); var adSize = adUnitsSize[i]; if (typeof adSize !== "undefined") { Insticator.adSlots[i].setTargeting("instBid_size", adSize["width"] + "x" + adSize["height"]); } } } } function insticator_init() { if (instBid.insticator_initSet) return; (function() { var gads = document.createElement('script'); gads.async = true; gads.type = 'text/javascript'; var useSSL = 'https:' == document.location.protocol; gads.src = (useSSL ? 'https:' : 'http:') + '//www.googletagservices.com/tag/js/gpt.js'; var node = document.getElementsByTagName('script')[0]; node.parentNode.insertBefore(gads, node); })(); insticator_defineAdSlots(); googletag.cmd.push(function() { instBid.que.push(function() { instBid.setTargetingForGPTAsync(); insticator_customTargeting(); }); }); Insticator.ad.adPreviousLoadAt = new Date().getTime(); Insticator.ad.ready = true; instBid.insticator_initSet = true; Insticator.ad.loadAllAds(); }; if(Insticator.helper.isMobileDevice) { setTimeout(function() { Insticator.logger.logMessage("Mobile timeout"); insticator_init(); }, PREBID_MOBILE_TIMEOUT); } else { setTimeout(function() { Insticator.logger.logMessage("Desktop timeout"); insticator_init(); }, PREBID_TIMEOUT); } var instBid = instBid || {}; instBid.que = instBid.que || []; (function() { var instBidEle = document.createElement("script"); instBidEle.type = "text/javascript"; instBidEle.async = true; instBidEle.src = "https://df80k0z3fi8zg.cloudfront.net/files/prebid_v4.js"; var instBidTargetEl = document.getElementsByTagName("head")[0]; instBidTargetEl.insertBefore(instBidEle, instBidTargetEl.firstChild); })(); instBid.que.push(function () { instBid.enableAnalytics({ provider: 'roxot', options: { publisherIds: ["1891eb8e-7523-44f3-980f-6201b8d287f0"], "host": "bulbapedia.bulbagarden.net" } }); }); window.Adomik = window.Adomik || {}; Adomik.randomAdGroup = function() { var rand = Math.random(); switch (false) { case !(rand < 0.09): return "ad_ex" + (Math.floor(100 * rand)); case !(rand < 0.10): return "ad_bc"; default: return "ad_opt"; } }; var insticator_webHardFloor_T1 = {}, insticator_mobileHardFloor_T1 = {}, insticator_webHardFloor_T2 = {}, insticator_mobileHardFloor_T2 = {}, insticator_webHardFloor_T3 = {}, insticator_mobileHardFloor_T3 = {}, insticator_webHardFloor_T4 = {}, insticator_mobileHardFloor_T4 = {}; insticator_webHardFloor_T1['sekindo'] = 0.2; insticator_webHardFloor_T1['sovrn'] = 0.2; insticator_webHardFloor_T1['defymedia'] = 0.2; insticator_webHardFloor_T1['pubmatic'] = 0.2; insticator_webHardFloor_T1['openx'] = 0.2; insticator_webHardFloor_T1['conversant'] = 0.2; insticator_webHardFloor_T1['rubicon'] = 0.2; insticator_webHardFloor_T1['rhythmone'] = 0.2; insticator_webHardFloor_T1['districtm'] = 0.2; insticator_webHardFloor_T1['sonobi'] = 0.2; insticator_webHardFloor_T1['appnexus'] = 0.2; insticator_webHardFloor_T1['pulsepoint'] = 0.2; insticator_webHardFloor_T1['sekindoapn'] = 0.2; insticator_webHardFloor_T1['brealtime'] = 0.2; insticator_mobileHardFloor_T1['sekindo'] = 0.2; insticator_mobileHardFloor_T1['sovrn'] = 0.2; insticator_mobileHardFloor_T1['defymedia'] = 0.2; insticator_mobileHardFloor_T1['pubmatic'] = 0.2; insticator_mobileHardFloor_T1['openx'] = 0.2; insticator_mobileHardFloor_T1['conversant'] = 0.2; insticator_mobileHardFloor_T1['rubicon'] = 0.2; insticator_mobileHardFloor_T1['rhythmone'] = 0.2; insticator_mobileHardFloor_T1['districtm'] = 0.2; insticator_mobileHardFloor_T1['sonobi'] = 1.5; insticator_mobileHardFloor_T1['appnexus'] = 0.2; insticator_mobileHardFloor_T1['pulsepoint'] = 0.2; insticator_mobileHardFloor_T1['sekindoapn'] = 0.2; insticator_mobileHardFloor_T1['brealtime'] = 0.2; insticator_webHardFloor_T2['pubmatic'] = 0.2; insticator_webHardFloor_T2['districtm'] = 0.2; insticator_webHardFloor_T2['openx'] = 0.2; insticator_webHardFloor_T2['sekindo'] = 0.2; insticator_webHardFloor_T2['rubicon'] = 0.2; insticator_webHardFloor_T2['pulsepoint'] = 0.2; insticator_webHardFloor_T2['brealtime'] = 0.2; insticator_webHardFloor_T2['rhythmone'] = 0.2; insticator_webHardFloor_T2['sekindoapn'] = 0.2; insticator_webHardFloor_T2['sovrn'] = 0.2; insticator_webHardFloor_T2['sonobi'] = 0.2; insticator_webHardFloor_T2['conversant'] = 0.2; insticator_webHardFloor_T2['appnexus'] = 0.2; insticator_webHardFloor_T2['defymedia'] = 0.2; insticator_mobileHardFloor_T2['pubmatic'] = 0.2; insticator_mobileHardFloor_T2['districtm'] = 0.2; insticator_mobileHardFloor_T2['openx'] = 0.2; insticator_mobileHardFloor_T2['sekindo'] = 0.2; insticator_mobileHardFloor_T2['rubicon'] = 0.2; insticator_mobileHardFloor_T2['pulsepoint'] = 0.2; insticator_mobileHardFloor_T2['brealtime'] = 0.2; insticator_mobileHardFloor_T2['rhythmone'] = 0.2; insticator_mobileHardFloor_T2['sekindoapn'] = 0.2; insticator_mobileHardFloor_T2['sovrn'] = 0.2; insticator_mobileHardFloor_T2['sonobi'] = 1.5; insticator_mobileHardFloor_T2['conversant'] = 0.2; insticator_mobileHardFloor_T2['appnexus'] = 0.2; insticator_mobileHardFloor_T2['defymedia'] = 0.2; insticator_webHardFloor_T3['rhythmone'] = 0.1; insticator_webHardFloor_T3['appnexus'] = 0.1; insticator_webHardFloor_T3['pubmatic'] = 0.1; insticator_webHardFloor_T3['conversant'] = 0.1; insticator_webHardFloor_T3['sonobi'] = 0.1; insticator_webHardFloor_T3['defymedia'] = 0.1; insticator_webHardFloor_T3['districtm'] = 0.1; insticator_webHardFloor_T3['sovrn'] = 0.1; insticator_webHardFloor_T3['sekindoapn'] = 0.1; insticator_webHardFloor_T3['sekindo'] = 0.1; insticator_webHardFloor_T3['openx'] = 0.1; insticator_webHardFloor_T3['pulsepoint'] = 0.1; insticator_webHardFloor_T3['rubicon'] = 0.1; insticator_webHardFloor_T3['brealtime'] = 0.1; insticator_mobileHardFloor_T3['rhythmone'] = 0.1; insticator_mobileHardFloor_T3['appnexus'] = 0.1; insticator_mobileHardFloor_T3['pubmatic'] = 0.1; insticator_mobileHardFloor_T3['conversant'] = 0.1; insticator_mobileHardFloor_T3['sonobi'] = 1.5; insticator_mobileHardFloor_T3['defymedia'] = 0.1; insticator_mobileHardFloor_T3['districtm'] = 0.1; insticator_mobileHardFloor_T3['sovrn'] = 0.1; insticator_mobileHardFloor_T3['sekindoapn'] = 0.1; insticator_mobileHardFloor_T3['sekindo'] = 0.1; insticator_mobileHardFloor_T3['openx'] = 0.1; insticator_mobileHardFloor_T3['pulsepoint'] = 0.1; insticator_mobileHardFloor_T3['rubicon'] = 0.1; insticator_mobileHardFloor_T3['brealtime'] = 0.1; insticator_webHardFloor_T4['appnexus'] = 0.05; insticator_webHardFloor_T4['pulsepoint'] = 0.05; insticator_webHardFloor_T4['rubicon'] = 0.05; insticator_webHardFloor_T4['sekindo'] = 0.05; insticator_webHardFloor_T4['openx'] = 0.05; insticator_webHardFloor_T4['sekindoapn'] = 0.05; insticator_webHardFloor_T4['rhythmone'] = 0.05; insticator_webHardFloor_T4['districtm'] = 0.05; insticator_webHardFloor_T4['sovrn'] = 0.05; insticator_webHardFloor_T4['defymedia'] = 0.05; insticator_webHardFloor_T4['brealtime'] = 0.05; insticator_webHardFloor_T4['conversant'] = 0.05; insticator_webHardFloor_T4['sonobi'] = 0.05; insticator_webHardFloor_T4['pubmatic'] = 0.05; insticator_mobileHardFloor_T4['appnexus'] = 0.05; insticator_mobileHardFloor_T4['pulsepoint'] = 0.05; insticator_mobileHardFloor_T4['rubicon'] = 0.05; insticator_mobileHardFloor_T4['sekindo'] = 0.05; insticator_mobileHardFloor_T4['openx'] = 0.05; insticator_mobileHardFloor_T4['sekindoapn'] = 0.05; insticator_mobileHardFloor_T4['rhythmone'] = 0.05; insticator_mobileHardFloor_T4['districtm'] = 0.05; insticator_mobileHardFloor_T4['sovrn'] = 0.05; insticator_mobileHardFloor_T4['defymedia'] = 0.05; insticator_mobileHardFloor_T4['brealtime'] = 0.05; insticator_mobileHardFloor_T4['conversant'] = 0.05; insticator_mobileHardFloor_T4['sonobi'] = 1.5; insticator_mobileHardFloor_T4['pubmatic'] = 0.05; Insticator.ad.adUnitsMap = {}; if(!Insticator.helper.isMobileDevice) { var adUnits = []; var adUnit = { code: 'div-insticator-ad-1', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522216' } }; bids.push(bid); var bid = { bidder: 'conversant', params: { site_id: '108904', secure: 'false' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152128' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '66978' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-10', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522228' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '66978' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-2', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522219' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152129' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '66978' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-3', sizes: [[728, 90]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522230' } }; bids.push(bid); var bid = { bidder: 'appnexus', params: { placementId: '9856179' } }; bids.push(bid); var bid = { bidder: 'conversant', params: { site_id: '108905', secure: 'false' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152130' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '66978' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-4', sizes: [[728, 90]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522232' } }; bids.push(bid); var bid = { bidder: 'appnexus', params: { placementId: '9856180' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152131' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-5', sizes: [[160, 600]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522210' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152132' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '66978' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-6', sizes: [[160, 600]], }, bids = []; var bid = { bidder: 'appnexus', params: { placementId: '10370820' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152133' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-7', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522226' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152134' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '66978' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-8', sizes: [[728, 90]], }, bids = []; var bid = { bidder: 'appnexus', params: { placementId: '10370821' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152135' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-9', sizes: [[160, 600]], }, bids = []; var bid = { bidder: 'districtmDMX', params: { id: '152136' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; } else { var adUnits = []; var adUnit = { code: 'div-insticator-ad-1', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522192' } }; bids.push(bid); var bid = { bidder: 'appnexus', params: { placementId: '9856181' } }; bids.push(bid); var bid = { bidder: 'conversant', params: { site_id: '108905', secure: 'false' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152137' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '67379' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-10', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522203' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '67379' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-2', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522197' } }; bids.push(bid); var bid = { bidder: 'appnexus', params: { placementId: '9856182' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152138' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '67379' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-3', sizes: [[728, 90]], }, bids = []; var bid = { bidder: 'conversant', params: { site_id: '108904', secure: 'false' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152139' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '67379' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-4', sizes: [[728, 90]], }, bids = []; var bid = { bidder: 'districtmDMX', params: { id: '152140' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-5', sizes: [[160, 600]], }, bids = []; var bid = { bidder: 'districtmDMX', params: { id: '152141' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '67379' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-6', sizes: [[160, 600]], }, bids = []; var bid = { bidder: 'districtmDMX', params: { id: '152142' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-7', sizes: [[300, 250]], }, bids = []; var bid = { bidder: 'sovrn', params: { tagid: '522200' } }; bids.push(bid); var bid = { bidder: 'districtmDMX', params: { id: '152144' } }; bids.push(bid); var bid = { bidder: 'rhythmone', params: { placementId: '67379' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-8', sizes: [[728, 90]], }, bids = []; var bid = { bidder: 'districtmDMX', params: { id: '152145' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; var adUnit = { code: 'div-insticator-ad-9', sizes: [[160, 600]], }, bids = []; var bid = { bidder: 'districtmDMX', params: { id: '152143' } }; bids.push(bid); adUnit.bids = bids; adUnits.push(adUnit); Insticator.ad.adUnitsMap[adUnit.code] = adUnit; } instBid.que.push(function() { instBid.addAdUnits(adUnits); instBid.aliasBidder('appnexus', 'defymedia'); instBid.aliasBidder('appnexus', 'matomy'); instBid.aliasBidder('appnexus', 'sekindoapn'); instBid.requestBids({ bidsBackHandler: function (bidResponses) { Insticator.logger.logMessage("Got all bid responses"); insticator_init(); } }); function insticator_getFinalCPM(cpm) { if(cpm <= 4) { return Math.floor(cpm*100); } else if(cpm <= 8) { return (Math.floor((cpm*50).toFixed(2))/50*100).toFixed(); } else if(cpm <= 12) { return (Math.floor((cpm*20).toFixed(2))/20*100).toFixed(); } else if(cpm <= 16) { return (Math.floor((cpm*10).toFixed(2))/10*100).toFixed(); } else if(cpm <= 20) { return (Math.floor((cpm*5).toFixed(2))/5*100).toFixed(); } else { return 2000; } }; function insticator_getBidFloor(bidCpm, bid, bidder) { if(Insticator.settings.visitorFloorTier === "UNKNOWN") { Insticator.logger.logMessage("visitorFloorTier not available, consider as Tier 1."); Insticator.settings.visitorFloorTier = "1"; } var hardFloor; switch(Insticator.settings.visitorFloorTier) { case "1": hardFloor=!Insticator.helper.isMobileDevice ? insticator_webHardFloor_T1[bidder] : insticator_mobileHardFloor_T1[bidder]; break; case "2": hardFloor=!Insticator.helper.isMobileDevice ? insticator_webHardFloor_T2[bidder] : insticator_mobileHardFloor_T2[bidder]; break; case "3": hardFloor=!Insticator.helper.isMobileDevice ? insticator_webHardFloor_T3[bidder] : insticator_mobileHardFloor_T3[bidder]; break; case "4": hardFloor=!Insticator.helper.isMobileDevice ? insticator_webHardFloor_T4[bidder] : insticator_mobileHardFloor_T4[bidder]; break; default: Insticator.logger.logMessage("Unknown tier: " + Insticator.settings.visitorFloorTier + ", consider as tier 4."); hardFloor=!Insticator.helper.isMobileDevice ? insticator_webHardFloor_T4[bidder] : insticator_mobileHardFloor_T4[bidder]; }; Insticator.logger.logMessage("Postbid floor for: " + bidder + " on: " + (!Insticator.helper.isMobileDevice ? "desktop" : "mobile") + " is: " + hardFloor); if(bidCpm> 0 && bidCpm < hardFloor) { Insticator.logger.logMessage("New bid for: " + bid.adUnitCode + " at: " + bidCpm + " doesn't reach " + bidder + " hardFloor: " + hardFloor + ", consider as invalid bid."); return 0; } }; instBid.bidderSettings = { standard: { adserverTargeting: [{ key: 'instBid_bidder', val: function(bidResponse) { return bidResponse.bidderCode; } }, { key: 'instBid_adid', val: function(bidResponse) { return bidResponse.adId; } }, { key: 'instBid_pb', val: function(bidResponse) { Insticator.logger.logMessage("New bid for: " + bidResponse.adUnitCode + " from: " + bidResponse.bidderCode + " at cpm: " + bidResponse.cpm); if(bidResponse.adUnitCode in Insticator.ad.hbFills) { if(bidResponse.cpm> Insticator.ad.hbFills[bidResponse.adUnitCode].cpm) { Insticator.logger.logMessage("New higher bid for: " + bidResponse.adUnitCode + " with adId: " + bidResponse.adId + " at cpm: " + bidResponse.cpm); Insticator.ad.hbFills[bidResponse.adUnitCode] = {cpm : bidResponse.cpm, adId : bidResponse.adId, bidderCode : bidResponse.bidderCode}; } } else { Insticator.ad.hbFills[bidResponse.adUnitCode] = {cpm : bidResponse.cpm, adId : bidResponse.adId, bidderCode : bidResponse.bidderCode}; } return insticator_getFinalCPM(bidResponse.cpm); } }, { key: 'instBid_size', val: function(bidResponse) { return bidResponse.size; } }] }, openx: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "openx") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, pubmatic: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "pubmatic") === 0) { return 0; } var discrepancy = 0; discrepancy = 8.0; return bidCpm * (1 - (16.0 + discrepancy) / 100); } }, rubicon: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "rubicon") === 0) { return 0; } var discrepancy = 0; discrepancy = 3.0; return bidCpm * (1 - (14.0 + discrepancy) / 100); } }, sovrn: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "sovrn") === 0) { return 0; } var discrepancy = 0; discrepancy = 7.0; return bidCpm * (1 - discrepancy / 100); } }, appnexus: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "appnexus") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, pulsepoint: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "pulsepoint") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, pulsepointLite: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "pulsepoint") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, defymedia: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "defymedia") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - (20.0 + discrepancy) / 100); } }, brealtime: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "brealtime") === 0) { return 0; } var discrepancy = 0; discrepancy = 10.0; return bidCpm * (1 - (15.0 + discrepancy) / 100); } }, sonobi: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "sonobi") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, conversant: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "conversant") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, sekindoUM: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "sekindo") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, sekindoapn: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "sekindoapn") === 0) { return 0; } var discrepancy = 0; discrepancy = 4.0; return bidCpm * (1 - discrepancy / 100); } }, districtmDMX: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "districtm") === 0) { return 0; } var discrepancy = 0; discrepancy = 10.0; return bidCpm * (1 - (15.0 + discrepancy) / 100); } }, rhythmone: { bidCpmAdjustment: function (bidCpm, bid) { if(insticator_getBidFloor(bidCpm, bid, "rhythmone") === 0) { return 0; } var discrepancy = 0; return bidCpm * (1 - discrepancy / 100); } } }; }); if(!Insticator.helper.isMobileDevice) { var adUnitSizeListJsonString = '{'; adUnitSizeListJsonString += '"div-insticator-ad-1" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-10" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-2" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-3" : { "width" : 728, "height" : 90}, '; adUnitSizeListJsonString += '"div-insticator-ad-4" : { "width" : 728, "height" : 90}, '; adUnitSizeListJsonString += '"div-insticator-ad-5" : { "width" : 160, "height" : 600}, '; adUnitSizeListJsonString += '"div-insticator-ad-6" : { "width" : 160, "height" : 600}, '; adUnitSizeListJsonString += '"div-insticator-ad-7" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-8" : { "width" : 728, "height" : 90}, '; adUnitSizeListJsonString += '"div-insticator-ad-9" : { "width" : 160, "height" : 600}, '; adUnitSizeListJsonString = adUnitSizeListJsonString.slice(0, -2); adUnitSizeListJsonString +='}'; } else { var adUnitSizeListJsonString = '{'; adUnitSizeListJsonString += '"div-insticator-ad-1" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-10" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-2" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-3" : { "width" : 728, "height" : 90}, '; adUnitSizeListJsonString += '"div-insticator-ad-4" : { "width" : 728, "height" : 90}, '; adUnitSizeListJsonString += '"div-insticator-ad-5" : { "width" : 160, "height" : 600}, '; adUnitSizeListJsonString += '"div-insticator-ad-6" : { "width" : 160, "height" : 600}, '; adUnitSizeListJsonString += '"div-insticator-ad-7" : { "width" : 300, "height" : 250}, '; adUnitSizeListJsonString += '"div-insticator-ad-8" : { "width" : 728, "height" : 90}, '; adUnitSizeListJsonString += '"div-insticator-ad-9" : { "width" : 160, "height" : 600}, '; adUnitSizeListJsonString = adUnitSizeListJsonString.slice(0, -2); adUnitSizeListJsonString +='}'; } Insticator.adSlots = {}, Insticator.divAdunitsMapping = {}; if (!Insticator.helper.isMobileDevice) { Insticator.divAdunitsMapping['div-insticator-ad-1'] = "/27794161/bulbapedia.bulbagarden.net_Web_300x250_1"; Insticator.divAdunitsMapping['div-insticator-ad-10'] = "/27794161/bulbapedia.bulbagarden.net_Web_300x250_4"; Insticator.divAdunitsMapping['div-insticator-ad-2'] = "/27794161/bulbapedia.bulbagarden.net_Web_300x250_2"; Insticator.divAdunitsMapping['div-insticator-ad-3'] = "/27794161/bulbapedia.bulbagarden.net_Web_728x90_1"; Insticator.divAdunitsMapping['div-insticator-ad-4'] = "/27794161/bulbapedia.bulbagarden.net_Web_728x90_2"; Insticator.divAdunitsMapping['div-insticator-ad-5'] = "/27794161/bulbapedia.bulbagarden.net_Web_160x600_1"; Insticator.divAdunitsMapping['div-insticator-ad-6'] = "/27794161/bulbapedia.bulbagarden.net_Web_160x600_2"; Insticator.divAdunitsMapping['div-insticator-ad-7'] = "/27794161/bulbapedia.bulbagarden.net_Web_300x250_3"; Insticator.divAdunitsMapping['div-insticator-ad-8'] = "/27794161/bulbapedia.bulbagarden.net_Web_728x90_3"; Insticator.divAdunitsMapping['div-insticator-ad-9'] = "/27794161/bulbapedia.bulbagarden.net_Web_160x600_3"; } else { Insticator.divAdunitsMapping['div-insticator-ad-1'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_1"; Insticator.divAdunitsMapping['div-insticator-ad-10'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_4"; Insticator.divAdunitsMapping['div-insticator-ad-2'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_2"; Insticator.divAdunitsMapping['div-insticator-ad-3'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_728x90_1"; Insticator.divAdunitsMapping['div-insticator-ad-4'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_728x90_2"; Insticator.divAdunitsMapping['div-insticator-ad-5'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_160x600_1"; Insticator.divAdunitsMapping['div-insticator-ad-6'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_160x600_2"; Insticator.divAdunitsMapping['div-insticator-ad-7'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_300x250_3"; Insticator.divAdunitsMapping['div-insticator-ad-8'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_728x90_3"; Insticator.divAdunitsMapping['div-insticator-ad-9'] = "/27794161/bulbapedia.bulbagarden.net_Mobile_160x600_3"; } function insticator_removeFirstIframeInsideElement(containerId) { var iframe = insticator_getFirstIframeInsideElement(containerId); iframe.parentNode.removeChild(iframe); } function insticator_createEmptyIframeInsideElement(containerId, width, height) { var iFrame = document.createElement("iframe"); iFrame.width = width + "px"; iFrame.height = height + "px"; iFrame.frameBorder = "0"; iFrame.scrolling = "no"; iFrame.marginheight = "0"; iFrame.marginwidth = "0"; iFrame.topmargin = "0"; iFrame.leftmargin = "0"; iFrame.allowtransparency = "true"; document.getElementById(containerId).appendChild(iFrame); return iFrame; } function insticator_updateIFrameContent(targetIFrame, content) { targetIFrame.contentWindow.document.open(); targetIFrame.contentWindow.document.write(content); targetIFrame.contentWindow.document.close(); } function insticator_getFirstIframeInsideElement(containerId) { var adDiv = document.getElementById(containerId); return adDiv.getElementsByTagName("iframe")[0]; } function insticator_getTargetingString(containerId) { var targetingMap = instBid.getAdserverTargeting()[containerId]; var targetingString = ""; for(var key in targetingMap) { targetingString += ".setTargeting('" + key + "','" + targetingMap[key] + "')"; } Insticator.logger.logMessage("targetingString: " + targetingString); return targetingString; } function insticator_formHBCreative(adunit, width, height, targetings) { return "<scr" + "ipt src='https://www.googletagservices.com/tag/js/gpt.js'>googletag.cmd.push(function() {googletag.defineSlot('" + adunit + "', [" + width + ", " + height + "], 'insticatorAd').addService(googletag.pubads())" + targetings + ";googletag.enableServices();});</scr" + "ipt><style>body { margin: 0px !important;}</style><div id='insticatorAd' style='height:250px; width:300px;'><scr" + "ipt>googletag.cmd.push(function() { googletag.display('insticatorAd'); });</scr" + "ipt></div>"; } function insticator_showCreativeInIframe(containerId, adunit, width, height) { var iFrame=insticator_getFirstIframeInsideElement(containerId); if(!iFrame) { iFrame=insticator_createEmptyIframeInsideElement(containerId, width, height); } var dcContent=insticator_formHBCreative(adunit, width, height, insticator_getTargetingString(containerId)); insticator_updateIFrameContent(iFrame, dcContent); } function insticator_refreshAd(containerId) { var adUnitsSize=JSON.parse(adUnitSizeListJsonString); var adSize=adUnitsSize[containerId]; if(containerId in Insticator.ad.hbFills) { Insticator.logger.logMessage("Fill for: " + containerId + ", id:" + Insticator.ad.hbFills[containerId].adId + ", cpm: " + Insticator.ad.hbFills[containerId].cpm); } else { Insticator.logger.logMessage("No fill for: " + containerId); } if (adSize) { googletag.pubads().refresh([Insticator.adSlots[containerId]]); } } function insticator_refreshBids(hoverUnits) { Insticator.logger.logMessage("Clear map"); Insticator.ad.hbFills = {}; if(hoverUnits.length > 0) { insticator_preAdjustAdUnits(hoverUnits); } instBid.que.push(function() { instBid.requestBids({ timeout: REFRESH_TIMEOUT, bidsBackHandler: function() { Insticator.logger.logMessage("All refresh bids back"); instBid.setTargetingForGPTAsync(); for (var i in Insticator.adSlots) { if(hoverUnits.indexOf(i) > -1) { Insticator.logger.logMessage("Not refresh hover unit: " + i); } else { insticator_refreshAd(i); } } } }); }); if(hoverUnits.length > 0) { insticator_postAdjustAdUnits(hoverUnits); } } function insticator_preAdjustAdUnits(hoverUnits) { for(var i in hoverUnits) { Insticator.logger.logMessage("Remove ad unit to be refreshed: " + hoverUnits[i]); instBid.removeAdUnit(hoverUnits[i]); } } function insticator_postAdjustAdUnits(hoverUnits) { for(var i in hoverUnits) { Insticator.logger.logMessage("Add back ad unit: " + hoverUnits[i]); instBid.addAdUnits(Insticator.ad.adUnitsMap[hoverUnits[i]]); } } (function() { "use strict"; var refreshAd=function(hoverUnits) { var now=new Date().getTime(); var noRefreshUnits=[]; if(now - Insticator.ad.adPreviousLoadAt > Insticator.ad.refreshAdInterval) { Insticator.ad.adPreviousLoadAt = now; Insticator.logger.logMessage("Refresh ad"); if(typeof hoverUnits=== "undefined") { Insticator.logger.logMessage("Refresh all ads"); } else { Insticator.logger.logMessage("Refresh non-hover ads"); if(hoverUnits.indexOf('TOP') > -1) { noRefreshUnits.push('div-insticator-ad-1'); } if(hoverUnits.indexOf('BOTTOM') > -1) { noRefreshUnits.push('div-insticator-ad-2'); } } insticator_refreshBids(noRefreshUnits); } else { Insticator.logger.logMessage("Haven't reach " + 30000/1000 + " seconds yet, won't refresh"); } }; var queue = Insticator.ad.q; var appendAd = function(containerId) { var adUnitsSize = JSON.parse(adUnitSizeListJsonString); var adSize = adUnitsSize[containerId]; if (typeof adSize !== "undefined") { var existingStyle = document.getElementById(containerId).style.cssText; var style = "width:" + adSize["width"] + "px;height:" + adSize["height"] + "px;"; document.getElementById(containerId).setAttribute("style", existingStyle + style); Insticator.logger.logMessage("Display ad for: " + containerId); if(containerId in Insticator.ad.hbFills) { Insticator.logger.logMessage("Fill for: " + containerId + " with adId:" + Insticator.ad.hbFills[containerId].adId + " from: " + Insticator.ad.hbFills[containerId].bidderCode + " at cpm: " + Insticator.ad.hbFills[containerId].cpm); } else { Insticator.logger.logMessage("No fill for: " + containerId); } googletag.cmd.push(function() { googletag.display(containerId); }); } }; Insticator.ad.loadAd = function(containerId) { if(Insticator.ad.ready) { appendAd(containerId); } else { Insticator.logger.logMessage("Add to queue: " + containerId); queue.push(containerId); } }; Insticator.ad.action = function(e) { switch (e.data.action) { case "refreshAd": var hoverUnits = e.data.hoverUnits; refreshAd(hoverUnits); break; } }; Insticator.ad.loadAllAds = function() { Insticator.logger.logMessage("Load all ads"); queue.forEach(function(containerId) { appendAd(containerId); }); }; }()); window.addEventListener("message", Insticator.ad.action, false); } catch(e) { console.error("header code error: ", e.message); }var insticatorEmbedSettings=[{"embedUUID":"93c8d6eb-4090-4682-8b87-a992d51e74c7","embedName":"bulbapedia_bulbagarden_net_1","hashtags":["#eb3eca0a-2ebb-4045-aeac-53edf621bbe9","#dea189ac-864c-4ed5-8aa6-79e305aff4c5"],"isActivate":true,"createdAt":1470939415000,"updatedAt":1517415364000,"colorPalette":{"colorPaletteUUID":"b324b173-f47f-47c4-8a3b-a9f2b4356c5d","colorPaletteName":"bulbapedia.bulbagarden.net","darkColor":"#FFFFFF","mainColor":"#3E7614","alterMainColor":"#FFFFFF","popOutColor":"#E0F2B6","fontColor":"#FFFFFF","alterFontColor":"#FFFFFF","hoverColor":"#FFFFFF","optionTextColor":"#FFFFFF","optionBgColor":"#FFFFFF","buttonColor":"#FFFFFF","createdAt":1471279683000,"updatedAt":1471279683000},"embedSetting":{"embedSettingUUID":"3c17334c-7476-4383-b056-bc90b4807201","brandLogoURL":"","countdown":20,"showCreateEmbedLine":true,"showHeaderLogo":true,"showQuestionImagesForWeb":false,"showQuestionImagesForMobile":false,"showDisplay":false,"showDisplay2":false,"showVideoAd":false,"showLeaderboard":false,"showChatting":false,"chattingTitle":"","showSocialShare":true,"linkToInsticator":true,"showVersusMode":true,"showLoginSignup":true,"showPolls":false,"showPollImages":false,"showArticles":false,"intervalForPolls":4,"designType":"TABBED","isActivate":true,"customTag":"","createdAt":1470939415000,"updatedAt":1517415364000,"difficultyProgressionType":0,"totalIncorrectAnswers":5,"webDesignType":"DESIGN_1","adSettingType":"REGULAR_ADS","webAdDisplayMode":"OVERLAY_BOTTOM_AD","mobileAdDisplayMode":"OVERLAY_BOTTOM_AD","overlayAdShowingInterval":1,"avatarGender":"MIXED","showAdsAfterEvery":1,"widgetHeight250PXForPlatform":"NONE","blockedCountries":[],"bidderRequestURLs":[],"articleScreenHeaderText":"Featured Articles","articleScreenDetailsButtonText":"Read More","articleScreenCountdown":12.0,"articleShowSkipButton":false,"showInstiPoll":false,"instiPollInterval":1,"colorCode":null,"sendLotameEvent":false,"lotameID":null,"showContest":false,"logoClickThroughURL":"","adUnitHoverTime":15,"showValueQuestion":false,"valueQuestionInterval":3,"showMarketResearch":"FALSE","totalTriviaQuestionsToShow":5,"totalPollQuestionsToShow":0,"totalArticlesToShow":0,"pollsHashTagList":[],"showTrivia":true,"instiPollHashTagList":[]},"embedUsers":null,"triviaGroupSet":null,"embedStatus":null,"embedStyleSetting":{"embedStyleSettingUUID":"65820f38-5735-4038-8d93-4fdc5b735d93","adsPosition":"ONE_TOP_ONE_BOTTOM","adsPositionPlatform":"BOTH","adsCentered":true,"maxHeightDesktop":1200,"maxWidthDesktop":1200,"maxHeightMobile":1200,"maxWidthMobile":1200,"adWidth":300,"useCustomStyle":false,"customStyle":null,"sizeSettingsIncludingAds":false,"isActive":true,"createdAt":1470939415000,"updatedAt":1470939415000},"versionCurrentlyUsed":"3.03","configured":true,"articleSet":null,"siteUUID":"78f51a41-dca0-4b07-811d-6991f0e83fa0","siteURL":"http://bulbapedia.bulbagarden.net","siteCategory":"IAB9","tvshowUUID":"eb3eca0a-2ebb-4045-aeac-53edf621bbe9","contest":null,"clientUUID":"dab9d645-64d0-4dfe-a385-e12183083794","googleAnalyticsID":"UA-82915758-9"}, {"embedUUID":"ce834dd9-0605-43af-b2ff-9a8c7b9ea4d7","embedName":"bulbapedia_bulbagarden_net_2","hashtags":["#ec5f787c-7157-461c-8452-039262424447","#7acf34b0-dffa-4200-9e1a-39ca5cd25d0b","#0012832e-327d-4c6b-a27d-235df90277ae","#eb5c155a-75f4-4ba9-a651-b2da5034b128","#3bf6d832-9d4f-4b47-bf29-46cac84ed784"],"isActivate":true,"createdAt":1492175686000,"updatedAt":1492175686000,"colorPalette":{"colorPaletteUUID":"7de7d1b7-17e4-438f-9e7f-8d8565c2a208","colorPaletteName":"V3 default color","darkColor":"#1478b6","mainColor":"#0433ff","alterMainColor":"#ccc","popOutColor":"#f0eff1","fontColor":"#112d3b","alterFontColor":"#999","hoverColor":"#eb9b3c","optionTextColor":"#1d86c0","optionBgColor":"#fff","buttonColor":"#1478b6","createdAt":1469743322000,"updatedAt":1476475836000},"embedSetting":{"embedSettingUUID":"44952bdf-ffd2-4d75-8e0e-e8fa5a380723","brandLogoURL":null,"countdown":10,"showCreateEmbedLine":true,"showHeaderLogo":false,"showQuestionImagesForWeb":false,"showQuestionImagesForMobile":false,"showDisplay":false,"showDisplay2":false,"showVideoAd":false,"showLeaderboard":false,"showChatting":false,"chattingTitle":null,"showSocialShare":true,"linkToInsticator":true,"showVersusMode":true,"showLoginSignup":true,"showPolls":false,"showPollImages":false,"showArticles":false,"intervalForPolls":4,"designType":"TABBED","isActivate":true,"customTag":null,"createdAt":1492175686000,"updatedAt":1492175686000,"difficultyProgressionType":0,"totalIncorrectAnswers":5,"webDesignType":"DESIGN_1","adSettingType":"REGULAR_ADS","webAdDisplayMode":"REGULAR","mobileAdDisplayMode":"REGULAR","overlayAdShowingInterval":1,"avatarGender":"MIXED","showAdsAfterEvery":1,"widgetHeight250PXForPlatform":"NONE","blockedCountries":[],"bidderRequestURLs":[],"articleScreenHeaderText":"Featured Articles","articleScreenDetailsButtonText":"Read More","articleScreenCountdown":12.0,"articleShowSkipButton":false,"showInstiPoll":false,"instiPollInterval":1,"colorCode":null,"sendLotameEvent":false,"lotameID":null,"showContest":false,"logoClickThroughURL":null,"adUnitHoverTime":15,"showValueQuestion":false,"valueQuestionInterval":3,"showMarketResearch":"FALSE","totalTriviaQuestionsToShow":5,"totalPollQuestionsToShow":0,"totalArticlesToShow":0,"pollsHashTagList":[],"showTrivia":true,"instiPollHashTagList":[]},"embedUsers":null,"triviaGroupSet":null,"embedStatus":null,"embedStyleSetting":{"embedStyleSettingUUID":"1eaac8ee-cc09-4dfe-ace8-9e3a8dd8633d","adsPosition":"ONE_TOP_ONE_BOTTOM","adsPositionPlatform":"BOTH","adsCentered":true,"maxHeightDesktop":1200,"maxWidthDesktop":1200,"maxHeightMobile":1200,"maxWidthMobile":1200,"adWidth":300,"useCustomStyle":false,"customStyle":null,"sizeSettingsIncludingAds":false,"isActive":true,"createdAt":1492175686000,"updatedAt":1492175686000},"versionCurrentlyUsed":"3.0","configured":true,"articleSet":null,"siteUUID":"78f51a41-dca0-4b07-811d-6991f0e83fa0","siteURL":"http://bulbapedia.bulbagarden.net","siteCategory":"IAB9","tvshowUUID":"ec5f787c-7157-461c-8452-039262424447","contest":null,"clientUUID":"dab9d645-64d0-4dfe-a385-e12183083794","googleAnalyticsID":"UA-82915758-9"}];!function(e){function t(i){if(n[i])return n[i].exports;var r=n[i]={exports:{},id:i,loaded:!1};return e[i].call(r.exports,r,r.exports,t),r.loaded=!0,r.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){n(27),e.exports=n(27)},,,,,,,,,,,,,,,,,,,,,,,,,,,function(e,t,n){"use strict";function i(){for(var e=window.Insticator.q,t="",n=0;n<e.length;n++)"em"==e[n].t&&(t=e[n].o.id,S.logger("embedUUID : "+t));for(var i=0;i<insticatorEmbedSettings.length;i++)if(insticatorEmbedSettings[i].embedUUID==t){S=insticatorEmbedSettings[i];try{S.logger=Insticator.logger.logMessage}catch(e){}}S.embedSetting.showChatting=!1;var o=null!==S.embedSetting.colorCode?S.embedSetting.colorCode:S.colorPalette.mainColor;S.colorPalette.mainColor=o,S.isActivate?S.isActivate===!0&&(r(S),a(S)):S.logger("embed isActivate set to false")}function r(e){0!==e.hashtags.length&&null!==e.hashtags||(e.embedSetting.showTrivia=!1),0!==e.embedSetting.pollsHashTagList.length&&null!==e.embedSetting.pollsHashTagList||(e.embedSetting.showPolls=!1)}function o(){var e,t=document.getElementById("div-insticator-ad-1"),n=document.getElementById("div-insticator-ad-2");e=S.embedSetting.showAdOnShortWidget?0:S.embedSetting.showHeaderLogo===!0?66.5:60,t&&n&&(S.embedSetting.targetAdDiv="both",S.embedSetting.showOverlay=!0,t.style.position="absolute",t.style.top=e+"px",t.style.left="0px",t.style.background="black",n.style.position="absolute",n.style.top=e+"px",n.style.left="300px",n.style.background="black",t.style.zIndex="-100",n.style.zIndex="-100")}function s(e){if(e&&"REGULAR"===S.embedSetting.mobileAdDisplayMode||!e&&"REGULAR"===S.embedSetting.webAdDisplayMode)return void(S.embedSetting.showOverlay=!1);var t=e?S.embedSetting.mobileAdDisplayMode:S.embedSetting.webAdDisplayMode;if(t){var n,i;if("OVERLAY_BOTTOM_AD"===t)n=document.getElementById("div-insticator-ad-2"),i=!1;else if("OVERLAY_TOP_AD"===t)n=document.getElementById("div-insticator-ad-1"),i=!0;else if("BOTH_OVERLAY_ADS"===t)return void o();var r;r=S.embedSetting.showAdOnShortWidget?0:S.embedSetting.showHeaderLogo===!0?66.5:60,i||(r+=250),n&&(S.embedSetting.targetAdDiv=i?"ad1":"ad2",S.embedSetting.showOverlay=!0,n.style.zIndex="-100",n.style.position="absolute",n.style.top=r+"px",n.style.background="black")}}function a(e){function t(e,t){function n(e,t,n){var i=document.createElement(e);i.innerHTML=t,n.appendChild(i)}if(""!==e.embedSetting.customTag)for(var i=(new DOMParser).parseFromString(e.embedSetting.customTag,"text/html"),r=i.getElementsByTagName("*"),o=0;o<r.length;o++){var s=r[o];switch(s.tagName){case"SCRIPT":n("script",s.innerHTML,t);break;case"STYLE":n("style",s.innerHTML,t)}}}e.logger("setupEmbed() called");var n=!1;C.mobile()&&(n=!0);var i=e.embedSetting.widgetHeight250PXForPlatform;"BOTH"===i?e.embedSetting.showAdOnShortWidget=!0:"BOTH"!==i&&"WEB_ONLY"!==i||n?n&&"MOBILE_ONLY"===i&&(e.embedSetting.showAdOnShortWidget=!0):e.embedSetting.showAdOnShortWidget=!0,e.isMobile=n;var r=document.getElementById("insticator-embed"),o=e.embedStyleSetting.maxHeightDesktop,c=e.embedStyleSetting.maxWidthDesktop,u=e.embedStyleSetting.maxHeightMobile,d=e.embedStyleSetting.maxWidthMobile;if(1200===o?o="350px":o+="px",1200===c?c="300px":c+="px",1200===u?u="350px":u+="px",1200===d?d="300px":d+="px",e.logger("iframe desktopHeight "+o),e.logger("iframe desktopWidth "+c),r.setAttribute("style","height: "+o+";width: "+c+";"),n&&r.setAttribute("style","height: "+u+";width: "+d+";"),"NONE"!==i)"BOTH"!==i&&"MOBILE_ONLY"!==i||!n?"BOTH"!==i&&"WEB_ONLY"!==i||n||(e.embedSetting.showHeaderLogo=!1,r.setAttribute("style","height: 250px;width: "+c+";position: relative; top: 0")):(e.embedSetting.showHeaderLogo=!1,r.setAttribute("style","height: 250px;width: "+d+";position: relative; top: 0"));else if(null!==C.mobile()&&r.setAttribute("style","height: "+u+";width: "+d+";"),e.embedSetting.showHeaderLogo&&null!==e.embedSetting.brandLogoURL&&""!==e.embedSetting.brandLogoURL.trim()){C.mobile()?1200!==e.embedStyleSetting.maxHeightMobile&&350!==e.embedStyleSetting.maxHeightMobile||(r.style.height="350px"):1200!==e.embedStyleSetting.maxHeightDesktop&&350!==e.embedStyleSetting.maxHeightMobile||(r.style.height="350px")}else e.embedSetting.showHeaderLogo=!1;s(n);var p=document.getElementById("insticator-container"),h=document.createElement("style");p&&(p.style.position="relative"),e.embedStyleSetting.useCustomStyle===!0&&(h.innerHTML=e.embedStyleSetting.customStyle,p.appendChild(h));var m;if(document.getElementById("insticator-embed-iframe")){var f=document.getElementById("insticator-embed"),b=document.getElementById("insticator-embed-iframe");f.removeChild(b)}m=document.createElement("iframe"),e.logger("iframe created "+m),m.id="insticator-embed-iframe",m.src="about:blank",m.height="100%",m.width="100%",m.style.borderColor=e.colorPalette.mainColor,m.style.borderStyle="solid",m.style.borderWidth="2px",m.style.userSelect="none",m.style.boxSizing="border-box",r.parentNode.insertBefore(m,r),r.appendChild(m);var v=(e.siteUUID,function(e){var t,n=e,i=new g.default(n);return t=i.getUpdatedStyle()}),y=m.contentDocument||m.contentWindow.document,S="";S=e.embedStyleSetting.maxHeightDesktop<350?"350px":"100%",y.open(),y.write('<style type="text/css">'+v(e.colorPalette.mainColor)+'</style><div id="insticator-embed-app" style="height:'+S+'; width: 100%;"></div>'),y.close();var w=y.getElementById("insticator-embed-app");"complete"===y.readyState&&(t(e,y.getElementsByTagName("body")[0]),l(e,m,y,w)),m.onload=function(){x+=1,x>=T?(e.logger("TOO MANY RELOADS!"),m.onload=null):(e.logger("iframe loaded"),""!==m.contentDocument.head.innerHTML?(e.logger("first load"),t(e,y.getElementsByTagName("body")[0]),l(e,m,y,w)):""===m.contentDocument.head.innerHTML&&(e.logger("HEAD IS EMPTY calling setupElements"),a(e)))}}function l(e,t,n,i){function r(t){var n=document.getElementById(t).scrollHeight;e.parentWindow.postMessage(n,"*")}function o(){var t=e.embedSetting.webAdDisplayMode,n=[];switch(t){case"REGULAR":break;case"OVERLAY_TOP_AD":n=["TOP"];break;case"OVERLAY_BOTTOM_AD":n=["BOTTOM"];break;case"BOTH_OVERLAY_ADS":n=["TOP","BOTTOM"]}return n}e.insticatorEmbedIframe=t,e.document=n,e.parentWindow=window;var s;if(e.embedSetting.showDisplay||e.embedSetting.showDisplay2){var a=window.top.location.protocol;s=a.indexOf("https")>-1?E.insticatorGetDomainLocation:E.insticatorGetUnsecureDomainLocation}e.embedSetting.showDisplay&&(e.logger("showDisplay == true"),e.logger("creating iframe"),e.logger("showDisplay is true... creating iframe"),d("iframe",{src:s+"/embeds/displayAd?embedUUID="+e.embedUUID+"&adPosition=1",class:"displayAds",id:"displayAds1",style:"width:inherit;margin:auto;display:block",frameborder:0,scrolling:"no",onload:r.bind(this,"displayAds1")},"insticator-embed")),e.embedSetting.showDisplay2&&(e.logger("showDisplay2 == true"),e.logger("creating iframe"),e.logger("showDisplay2 is true... creating iframe"),d("iframe",{src:s+"/embeds/displayAd?embedUUID="+e.embedUUID+"&adPosition=2",class:"displayAds",id:"displayAds2",style:"width:inherit;margin:auto;display:block",frameborder:0,scrolling:"no",onload:r.bind(this,"displayAds2")},"insticator-embed"));var l=window.addEventListener?"addEventListener":"attachEvent",c=window[l],u="attachEvent"==l?"onmessage":"message";c(u,function(e){var t=e.data.id,n=e.data.height;if(n){n+="px";var i="height: "+n+";",r=document.getElementById(t);r.setAttribute("style",i)}},!1);var p=o();e.refreshAds=function(){if(e.logger("ads refresh called"),e.embedSetting.showDisplay||e.embedSetting.showDisplay2){if(e.logger("ad refresh within iframe"),e.embedSetting.showDisplay){var t;t=document.getElementById("displayAds1"),t.src=t.src}if(e.embedSetting.showDisplay2){n=document.getElementById("displayAds2");var n;n.src=n.src}}else{e.logger("ads refresh normally");var i=e.parentWindow,r={action:"refreshAd",domain:window.location.href,hoverUnits:p};i.postMessage(r,"*")}},e.refreshAdsOnRestartGame=function(){p=[],e.refreshAds(),p=o()},m.render(h.createElement(f.default,{indexManager:w,embedSettings:e}),i)}function c(){var e=window.navigator.userAgent,t=e.indexOf("MSIE "),n=e.indexOf("Trident/");return t>0||n>0}function u(){var e=window.navigator.userAgent,t=e.indexOf("Edge/");return t>0}function d(e,t,n){S.logger("CreateElement called"),S.logger("createElement type: "+e),S.logger("createElement data: "+t),S.logger("createElement targetID: "+n);var i=document.createElement(e);for(var r in t)i.setAttribute(r,t[r]);var o=document.getElementById(n),s=document.getElementById("insticator-embed-iframe");S.logger("createElement iframe: "+s),"displayAds1"===i.getAttribute("id")?o.insertBefore(i,s):document.getElementById(n).appendChild(i)}function p(){var e=E.pingHostName;S.logger("pingDataScript hostName: "+e),function(e,t,n,i){function r(){function e(e){for(var t="",i=0;i<n.length;i++)n[i].getAttribute("name")!=e&&n[i].getAttribute("property")!=e||(t+=n[i].getAttribute("content"));return t}function t(e){return S.logger("detectCMS() called"),e.length<1?"undefined":e.toLowerCase().indexOf("contao")>-1?"contao":e.toLowerCase().indexOf("wordpress")>-1?"wordpress":e.toLowerCase().indexOf("joomla")>-1?"joomla":e.toLowerCase().indexOf("drupal")>-1?"drupal":e.toLowerCase().indexOf("typo3")>-1?"typo3":e.toLowerCase().indexOf("blogger")>-1?"blogger":"undefined"}S.logger("getCmsUsed() called");var n;n=i.getElementsByTagName("meta");var r=e("generator");return""===r&&(r=e("Generator")),t(r)}function o(){function e(){return"undefined"!=typeof n.Insticator&&n.Insticator.version?n.Insticator.version:"1.0"}function t(){return i.getElementById("insticator-api-iframe-div")?"Asynchronous":i.getElementById("insticator-api-div")?"Synchronous":"Undefined"}var r=e();return"1.0"==r?r+"_"+t():r}function s(){try{return n.self!==n.top}catch(e){return!0}}function a(){for(var e=i.getElementsByTagName("meta"),t=0;t<e.length;t++)if("generator"===e[t].getAttribute("name")&&e[t].getAttribute("content").indexOf("WordPress")>-1)return!0;return!1}function l(){for(var e=i.querySelectorAll("link"),t=0;t<e.length;t++)if(e[t].href.indexOf("/wp-content/")>-1)return S.logger("WordPressLinks:"+e),!0;return!1}function c(e){var t,n="insticator-embed-";return e.indexOf(n)>-1&&(t=parseFloat(e.slice(n.length))),!isNaN(t)}function u(){var e=i.getElementById("insticator-container");if(null===e)return!1;var t=e.parentNode,n=t.parentNode;return c(t.id)||c(n.id)}function d(){var e=i.getElementById("insticator-container");if(null===e)return!1;var t=e.parentNode,n=t.parentNode,r=[];t&&(r=r.concat(t.className.split(" "))),n&&(r=r.concat(n.className.split(" ")));for(var o in r)if(c(r[o]))return!0;return!1}function p(){var e=a(),t=l();if(S.logger("isWordPressMetaPresent:"+e),S.logger("isWordPresslinksPresent:"+t),e||t){var n=u()||d();if(n)return S.logger("WORDPRESS_PLUGIN: true"),!0}return S.logger("WORDPRESS_PLUGIN: false"),!1}function h(){if(n.CloudflareApps)return"CLOUDFLARE-APP"===i.getElementById("insticator-container").parentNode.tagName}function m(){var e=s();if(h())return"CLOUDFLARE_APP";if(e){if(void 0!=n.frameElement&&n.frameElement.id.includes("google_ads_iframe"))return"DFP_WITHOUT_SAFEFRAME";if(n.location.href.includes("googlesyndication")&&n.location.href.includes("safeframe"))return"DFP_WITH_SAFEFRAME"}else if(p())return"WORDPRESS_PLUGIN";return"HARD_CODING"}function f(){var e="N/A";try{e=n.top.location.href}catch(e){S.logger("top window is not accessible from widget.")}var t="N/A"===e?i.referrer:i.location.href;return t}function g(){try{var n={cms:r(),embedCodeVersion:o(),servedOnUrl:f(),embedUUID:e,integrationType:m()};b.default({method:"post",url:t+"/embeds/processembedserved",data:n,headers:{"Content-Type":"application/json"}}),S.logger("sendData: "+JSON.stringify(n))}catch(e){S.logger("sendData ERROR: "+e)}}var v=function(e){var t,r=0;"loading"===i.readyState?t=n.setInterval(function(){r+=250,"interactive"===i.readyState||"complete"===i.readyState?(n.clearInterval(t),e()):5e3===r&&n.clearInterval(t)},250):e()};try{e&&t&&v(g)}catch(n){return Insticator.logger.logMessage("embedUUID !== hostName inside try/catch"),Insticator.logger.logMessage("embedUUID: "+e),Insticator.logger.logMessage("hostName: "+t),Insticator.logger.logMessage(n),""}}(S.embedUUID,e,window,window.document)}var h=n(28),m=n(58),f=n(197),g=n(311),b=n(279);n(309);var v,y,S={},w={pingDataScript:function(){p()}},E=n(201);y=n(234);var C=new y(window.navigator.userAgent),T=5,x=0;E.LOCAL_MODE&&(insticatorEmbedSettings=[v[0]],S.logger=insticatorEmbedSettings[0].logger,Insticator.logger=S.logger,window.Insticator={},window.Insticator.q=[{o:{id:"c51c3f54-17b0-4f0e-9911-40b84a9a3717"},t:"em"}]);try{S.logger=Insticator.logger.logMessage}catch(e){}S.logger("FW VER = "+E.widgetVersion);var _=c(),k=u();_||k?S.logger("ie or edge detected... will NOT show widget"):window.Insticator.q.length>0?i():window.Insticator.load=function(e,t){window.Insticator.q.push({t:e,o:t}),i()}},function(e,t,n){"use strict";e.exports=n(29)},function(e,t,n){"use strict";var i=n(30),r=n(31),o=n(40),s=n(48),a=n(42),l=n(49),c=n(54),u=n(55),d=n(57),p=a.createElement,h=a.createFactory,m=a.cloneElement,f=i,g=function(e){return e},b={Children:{map:o.map,forEach:o.forEach,count:o.count,toArray:o.toArray,only:d},Component:r.Component,PureComponent:r.PureComponent,createElement:p,cloneElement:m,isValidElement:a.isValidElement,PropTypes:l,createClass:u,createFactory:h,createMixin:g,DOM:s,version:c,__spread:f};e.exports=b},function(e,t){"use strict";function n(e){if(null===e||void 0===e)throw new TypeError("Object.assign cannot be called with null or undefined");return Object(e)}function i(){try{if(!Object.assign)return!1;var e=new String("abc");if(e[5]="de","5"===Object.getOwnPropertyNames(e)[0])return!1;for(var t={},n=0;n<10;n++)t["_"+String.fromCharCode(n)]=n;var i=Object.getOwnPropertyNames(t).map(function(e){return t[e]});if("0123456789"!==i.join(""))return!1;var r={};return"abcdefghijklmnopqrst".split("").forEach(function(e){r[e]=e}),"abcdefghijklmnopqrst"===Object.keys(Object.assign({},r)).join("")}catch(e){return!1}}var r=Object.getOwnPropertySymbols,o=Object.prototype.hasOwnProperty,s=Object.prototype.propertyIsEnumerable;e.exports=i()?Object.assign:function(e,t){for(var i,a,l=n(e),c=1;c<arguments.length;c++){i=Object(arguments[c]);for(var u in i)o.call(i,u)&&(l[u]=i[u]);if(r){a=r(i);for(var d=0;d<a.length;d++)s.call(i,a[d])&&(l[a[d]]=i[a[d]])}}return l}},function(e,t,n){"use strict";function i(e,t,n){this.props=e,this.context=t,this.refs=c,this.updater=n||l}function r(e,t,n){this.props=e,this.context=t,this.refs=c,this.updater=n||l}function o(){}var s=n(32),a=n(30),l=n(33),c=(n(36),n(37));n(38),n(39);i.prototype.isReactComponent={},i.prototype.setState=function(e,t){"object"!=typeof e&&"function"!=typeof e&&null!=e?s("85"):void 0,this.updater.enqueueSetState(this,e),t&&this.updater.enqueueCallback(this,t,"setState")},i.prototype.forceUpdate=function(e){this.updater.enqueueForceUpdate(this),e&&this.updater.enqueueCallback(this,e,"forceUpdate")};o.prototype=i.prototype,r.prototype=new o,r.prototype.constructor=r,a(r.prototype,i.prototype),r.prototype.isPureReactComponent=!0,e.exports={Component:i,PureComponent:r}},function(e,t){"use strict";function n(e){for(var t=arguments.length-1,n="Minified React error #"+e+"; visit http://facebook.github.io/react/docs/error-decoder.html?invariant="+e,i=0;i<t;i++)n+="&args[]="+encodeURIComponent(arguments[i+1]);n+=" for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";var r=new Error(n);throw r.name="Invariant Violation",r.framesToPop=1,r}e.exports=n},function(e,t,n){"use strict";function i(e,t){}var r=(n(34),{isMounted:function(e){return!1},enqueueCallback:function(e,t){},enqueueForceUpdate:function(e){i(e,"forceUpdate")},enqueueReplaceState:function(e,t){i(e,"replaceState")},enqueueSetState:function(e,t){i(e,"setState")}});e.exports=r},function(e,t,n){"use strict";var i=n(35),r=i;e.exports=r},function(e,t){"use strict";function n(e){return function(){return e}}var i=function(){};i.thatReturns=n,i.thatReturnsFalse=n(!1),i.thatReturnsTrue=n(!0),i.thatReturnsNull=n(null),i.thatReturnsThis=function(){return this},i.thatReturnsArgument=function(e){return e},e.exports=i},function(e,t,n){"use strict";var i=!1;e.exports=i},function(e,t,n){"use strict";var i={};e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i,o,s,a,l){if(r(t),!e){var c;if(void 0===t)c=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var u=[n,i,o,s,a,l],d=0;c=new Error(t.replace(/%s/g,function(){return u[d++]})),c.name="Invariant Violation"}throw c.framesToPop=1,c}}var r=function(e){};e.exports=i},function(e,t,n){"use strict";var i=function(){};e.exports=i},function(e,t,n){"use strict";function i(e){return(""+e).replace(S,"$&/")}function r(e,t){this.func=e,this.context=t,this.count=0}function o(e,t,n){var i=e.func,r=e.context;i.call(r,t,e.count++)}function s(e,t,n){if(null==e)return e;var i=r.getPooled(t,n);b(e,o,i),r.release(i)}function a(e,t,n,i){this.result=e,this.keyPrefix=t,this.func=n,this.context=i,this.count=0}function l(e,t,n){var r=e.result,o=e.keyPrefix,s=e.func,a=e.context,l=s.call(a,t,e.count++);Array.isArray(l)?c(l,r,n,g.thatReturnsArgument):null!=l&&(f.isValidElement(l)&&(l=f.cloneAndReplaceKey(l,o+(!l.key||t&&t.key===l.key?"":i(l.key)+"/")+n)),r.push(l))}function c(e,t,n,r,o){var s="";null!=n&&(s=i(n)+"/");var c=a.getPooled(t,s,r,o);b(e,l,c),a.release(c)}function u(e,t,n){if(null==e)return e;var i=[];return c(e,i,null,t,n),i}function d(e,t,n){return null}function p(e,t){return b(e,d,null)}function h(e){var t=[];return c(e,t,null,g.thatReturnsArgument),t}var m=n(41),f=n(42),g=n(35),b=n(45),v=m.twoArgumentPooler,y=m.fourArgumentPooler,S=/\/+/g;r.prototype.destructor=function(){this.func=null,this.context=null,this.count=0},m.addPoolingTo(r,v),a.prototype.destructor=function(){this.result=null,this.keyPrefix=null,this.func=null,this.context=null,this.count=0},m.addPoolingTo(a,y);var w={forEach:s,map:u,mapIntoWithKeyPrefixInternal:c,count:p,toArray:h};e.exports=w},function(e,t,n){"use strict";var i=n(32),r=(n(38),function(e){var t=this;if(t.instancePool.length){var n=t.instancePool.pop();return t.call(n,e),n}return new t(e)}),o=function(e,t){var n=this;if(n.instancePool.length){var i=n.instancePool.pop();return n.call(i,e,t),i}return new n(e,t)},s=function(e,t,n){var i=this;if(i.instancePool.length){var r=i.instancePool.pop();return i.call(r,e,t,n),r}return new i(e,t,n)},a=function(e,t,n,i){var r=this;if(r.instancePool.length){var o=r.instancePool.pop();return r.call(o,e,t,n,i),o}return new r(e,t,n,i)},l=function(e){var t=this;e instanceof t?void 0:i("25"),e.destructor(),t.instancePool.length<t.poolSize&&t.instancePool.push(e)},c=10,u=r,d=function(e,t){var n=e;return n.instancePool=[],n.getPooled=t||u,n.poolSize||(n.poolSize=c),n.release=l,n},p={addPoolingTo:d,oneArgumentPooler:r,twoArgumentPooler:o,threeArgumentPooler:s,fourArgumentPooler:a};e.exports=p},function(e,t,n){"use strict";function i(e){return void 0!==e.ref}function r(e){return void 0!==e.key}var o=n(30),s=n(43),a=(n(34),n(36),Object.prototype.hasOwnProperty),l=n(44),c={key:!0,ref:!0,__self:!0,__source:!0},u=function(e,t,n,i,r,o,s){var a={$$typeof:l,type:e,key:t,ref:n,props:s,_owner:o};return a};u.createElement=function(e,t,n){var o,l={},d=null,p=null,h=null,m=null;if(null!=t){i(t)&&(p=t.ref),r(t)&&(d=""+t.key),h=void 0===t.__self?null:t.__self,m=void 0===t.__source?null:t.__source;for(o in t)a.call(t,o)&&!c.hasOwnProperty(o)&&(l[o]=t[o])}var f=arguments.length-2;if(1===f)l.children=n;else if(f>1){for(var g=Array(f),b=0;b<f;b++)g[b]=arguments[b+2];l.children=g}if(e&&e.defaultProps){var v=e.defaultProps;for(o in v)void 0===l[o]&&(l[o]=v[o])}return u(e,d,p,h,m,s.current,l)},u.createFactory=function(e){var t=u.createElement.bind(null,e);return t.type=e,t},u.cloneAndReplaceKey=function(e,t){var n=u(e.type,t,e.ref,e._self,e._source,e._owner,e.props);return n},u.cloneElement=function(e,t,n){var l,d=o({},e.props),p=e.key,h=e.ref,m=e._self,f=e._source,g=e._owner;if(null!=t){i(t)&&(h=t.ref,g=s.current),r(t)&&(p=""+t.key);var b;e.type&&e.type.defaultProps&&(b=e.type.defaultProps);for(l in t)a.call(t,l)&&!c.hasOwnProperty(l)&&(void 0===t[l]&&void 0!==b?d[l]=b[l]:d[l]=t[l])}var v=arguments.length-2;if(1===v)d.children=n;else if(v>1){for(var y=Array(v),S=0;S<v;S++)y[S]=arguments[S+2];d.children=y}return u(e.type,p,h,m,f,g,d)},u.isValidElement=function(e){return"object"==typeof e&&null!==e&&e.$$typeof===l},e.exports=u},function(e,t){"use strict";var n={current:null};e.exports=n},function(e,t){"use strict";var n="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103;e.exports=n},function(e,t,n){"use strict";function i(e,t){return e&&"object"==typeof e&&null!=e.key?c.escape(e.key):t.toString(36)}function r(e,t,n,o){var p=typeof e;if("undefined"!==p&&"boolean"!==p||(e=null),null===e||"string"===p||"number"===p||"object"===p&&e.$$typeof===a)return n(o,e,""===t?u+i(e,0):t),1;var h,m,f=0,g=""===t?u:t+d;if(Array.isArray(e))for(var b=0;b<e.length;b++)h=e[b],m=g+i(h,b),f+=r(h,m,n,o);else{var v=l(e);if(v){var y,S=v.call(e);if(v!==e.entries)for(var w=0;!(y=S.next()).done;)h=y.value,m=g+i(h,w++),f+=r(h,m,n,o);else for(;!(y=S.next()).done;){var E=y.value;E&&(h=E[1],m=g+c.escape(E[0])+d+i(h,0),f+=r(h,m,n,o))}}else if("object"===p){var C="",T=String(e);s("31","[object Object]"===T?"object with keys {"+Object.keys(e).join(", ")+"}":T,C)}}return f}function o(e,t,n){return null==e?0:r(e,"",t,n)}var s=n(32),a=(n(43),n(44)),l=n(46),c=(n(38),n(47)),u=(n(34),"."),d=":";e.exports=o},function(e,t){"use strict";function n(e){var t=e&&(i&&e[i]||e[r]);if("function"==typeof t)return t}var i="function"==typeof Symbol&&Symbol.iterator,r="@@iterator";e.exports=n},function(e,t){"use strict";function n(e){var t=/[=:]/g,n={"=":"=0",":":"=2"},i=(""+e).replace(t,function(e){return n[e]});return"$"+i}function i(e){var t=/(=0|=2)/g,n={"=0":"=","=2":":"},i="."===e[0]&&"$"===e[1]?e.substring(2):e.substring(1);return(""+i).replace(t,function(e){return n[e]})}var r={escape:n,unescape:i};e.exports=r},function(e,t,n){"use strict";var i=n(42),r=i.createFactory,o={a:r("a"),abbr:r("abbr"),address:r("address"),area:r("area"),article:r("article"),aside:r("aside"),audio:r("audio"),b:r("b"),base:r("base"),bdi:r("bdi"),bdo:r("bdo"),big:r("big"),blockquote:r("blockquote"),body:r("body"),br:r("br"),button:r("button"),canvas:r("canvas"),caption:r("caption"),cite:r("cite"),code:r("code"),col:r("col"),colgroup:r("colgroup"),data:r("data"),datalist:r("datalist"),dd:r("dd"),del:r("del"),details:r("details"),dfn:r("dfn"),dialog:r("dialog"),div:r("div"),dl:r("dl"),dt:r("dt"),em:r("em"),embed:r("embed"),fieldset:r("fieldset"),figcaption:r("figcaption"),figure:r("figure"),footer:r("footer"),form:r("form"),h1:r("h1"),h2:r("h2"),h3:r("h3"),h4:r("h4"),h5:r("h5"),h6:r("h6"),head:r("head"),header:r("header"),hgroup:r("hgroup"),hr:r("hr"),html:r("html"),i:r("i"),iframe:r("iframe"),img:r("img"),input:r("input"),ins:r("ins"),kbd:r("kbd"),keygen:r("keygen"),label:r("label"),legend:r("legend"),li:r("li"),link:r("link"),main:r("main"),map:r("map"),mark:r("mark"),menu:r("menu"),menuitem:r("menuitem"),meta:r("meta"),meter:r("meter"),nav:r("nav"),noscript:r("noscript"),object:r("object"),ol:r("ol"),optgroup:r("optgroup"),option:r("option"),output:r("output"),p:r("p"),param:r("param"),picture:r("picture"),pre:r("pre"),progress:r("progress"),q:r("q"),rp:r("rp"),rt:r("rt"),ruby:r("ruby"),s:r("s"),samp:r("samp"),script:r("script"),section:r("section"),select:r("select"),small:r("small"),source:r("source"),span:r("span"),strong:r("strong"),style:r("style"),sub:r("sub"),summary:r("summary"),sup:r("sup"),table:r("table"),tbody:r("tbody"),td:r("td"),textarea:r("textarea"),tfoot:r("tfoot"),th:r("th"),thead:r("thead"),time:r("time"),title:r("title"),tr:r("tr"),track:r("track"),u:r("u"),ul:r("ul"),var:r("var"),video:r("video"),wbr:r("wbr"),circle:r("circle"),clipPath:r("clipPath"),defs:r("defs"),ellipse:r("ellipse"),g:r("g"),image:r("image"),line:r("line"),linearGradient:r("linearGradient"),mask:r("mask"),path:r("path"),pattern:r("pattern"),polygon:r("polygon"),polyline:r("polyline"),radialGradient:r("radialGradient"),rect:r("rect"),stop:r("stop"),svg:r("svg"),text:r("text"),tspan:r("tspan")};e.exports=o},function(e,t,n){"use strict";var i=n(42),r=i.isValidElement,o=n(50);e.exports=o(r)},function(e,t,n){"use strict";var i=n(51);e.exports=function(e){var t=!1;return i(e,t)}},function(e,t,n){"use strict";var i=n(35),r=n(38),o=n(34),s=n(30),a=n(52),l=n(53);e.exports=function(e,t){function n(e){var t=e&&(A&&e[A]||e[P]);if("function"==typeof t)return t}function c(e,t){return e===t?0!==e||1/e===1/t:e!==e&&t!==t}function u(e){this.message=e,this.stack=""}function d(e){function n(n,i,o,s,l,c,d){if(s=s||O,c=c||o,d!==a)if(t)r(!1,"Calling PropTypes validators directly is not supported by the `prop-types` package. Use `PropTypes.checkPropTypes()` to call them. Read more at http://fb.me/use-check-prop-types");else;return null==i[o]?n?new u(null===i[o]?"The "+l+" `"+c+"` is marked as required "+("in `"+s+"`, but its value is `null`."):"The "+l+" `"+c+"` is marked as required in "+("`"+s+"`, but its value is `undefined`.")):null:e(i,o,s,l,c)}var i=n.bind(null,!1);return i.isRequired=n.bind(null,!0),i}function p(e){function t(t,n,i,r,o,s){var a=t[n],l=x(a);if(l!==e){var c=_(a);return new u("Invalid "+r+" `"+o+"` of type "+("`"+c+"` supplied to `"+i+"`, expected ")+("`"+e+"`."))}return null}return d(t)}function h(){return d(i.thatReturnsNull)}function m(e){function t(t,n,i,r,o){if("function"!=typeof e)return new u("Property `"+o+"` of component `"+i+"` has invalid PropType notation inside arrayOf.");var s=t[n];if(!Array.isArray(s)){var l=x(s);return new u("Invalid "+r+" `"+o+"` of type "+("`"+l+"` supplied to `"+i+"`, expected an array."))}for(var c=0;c<s.length;c++){var d=e(s,c,i,r,o+"["+c+"]",a);if(d instanceof Error)return d}return null}return d(t)}function f(){function t(t,n,i,r,o){var s=t[n];if(!e(s)){var a=x(s);return new u("Invalid "+r+" `"+o+"` of type "+("`"+a+"` supplied to `"+i+"`, expected a single ReactElement."))}return null}return d(t)}function g(e){function t(t,n,i,r,o){if(!(t[n]instanceof e)){var s=e.name||O,a=M(t[n]);return new u("Invalid "+r+" `"+o+"` of type "+("`"+a+"` supplied to `"+i+"`, expected ")+("instance of `"+s+"`."))}return null}return d(t)}function b(e){function t(t,n,i,r,o){for(var s=t[n],a=0;a<e.length;a++)if(c(s,e[a]))return null;var l=JSON.stringify(e);return new u("Invalid "+r+" `"+o+"` of value `"+s+"` "+("supplied to `"+i+"`, expected one of "+l+"."))}return Array.isArray(e)?d(t):i.thatReturnsNull}function v(e){function t(t,n,i,r,o){if("function"!=typeof e)return new u("Property `"+o+"` of component `"+i+"` has invalid PropType notation inside objectOf.");var s=t[n],l=x(s);if("object"!==l)return new u("Invalid "+r+" `"+o+"` of type "+("`"+l+"` supplied to `"+i+"`, expected an object."));for(var c in s)if(s.hasOwnProperty(c)){var d=e(s,c,i,r,o+"."+c,a);if(d instanceof Error)return d}return null}return d(t)}function y(e){function t(t,n,i,r,o){for(var s=0;s<e.length;s++){var l=e[s];if(null==l(t,n,i,r,o,a))return null}return new u("Invalid "+r+" `"+o+"` supplied to "+("`"+i+"`."))}if(!Array.isArray(e))return i.thatReturnsNull;for(var n=0;n<e.length;n++){var r=e[n];if("function"!=typeof r)return o(!1,"Invalid argument supplied to oneOfType. Expected an array of check functions, but received %s at index %s.",k(r),n),i.thatReturnsNull}return d(t)}function S(){function e(e,t,n,i,r){return C(e[t])?null:new u("Invalid "+i+" `"+r+"` supplied to "+("`"+n+"`, expected a ReactNode."))}return d(e)}function w(e){function t(t,n,i,r,o){var s=t[n],l=x(s);if("object"!==l)return new u("Invalid "+r+" `"+o+"` of type `"+l+"` "+("supplied to `"+i+"`, expected `object`."));for(var c in e){var d=e[c];if(d){var p=d(s,c,i,r,o+"."+c,a);if(p)return p}}return null}return d(t)}function E(e){function t(t,n,i,r,o){var l=t[n],c=x(l);if("object"!==c)return new u("Invalid "+r+" `"+o+"` of type `"+c+"` "+("supplied to `"+i+"`, expected `object`."));var d=s({},t[n],e);for(var p in d){var h=e[p];if(!h)return new u("Invalid "+r+" `"+o+"` key `"+p+"` supplied to `"+i+"`.\nBad object: "+JSON.stringify(t[n],null,"  ")+"\nValid keys: "+JSON.stringify(Object.keys(e),null,"  "));var m=h(l,p,i,r,o+"."+p,a);if(m)return m}return null}return d(t)}function C(t){switch(typeof t){case"number":case"string":case"undefined":return!0;case"boolean":return!t;case"object":if(Array.isArray(t))return t.every(C);if(null===t||e(t))return!0;var i=n(t);if(!i)return!1;var r,o=i.call(t);if(i!==t.entries){for(;!(r=o.next()).done;)if(!C(r.value))return!1}else for(;!(r=o.next()).done;){var s=r.value;if(s&&!C(s[1]))return!1}return!0;default:return!1}}function T(e,t){return"symbol"===e||("Symbol"===t["@@toStringTag"]||"function"==typeof Symbol&&t instanceof Symbol)}function x(e){var t=typeof e;return Array.isArray(e)?"array":e instanceof RegExp?"object":T(t,e)?"symbol":t}function _(e){if("undefined"==typeof e||null===e)return""+e;var t=x(e);if("object"===t){if(e instanceof Date)return"date";if(e instanceof RegExp)return"regexp"}return t}function k(e){var t=_(e);switch(t){case"array":case"object":return"an "+t;case"boolean":case"date":case"regexp":return"a "+t;default:return t}}function M(e){return e.constructor&&e.constructor.name?e.constructor.name:O}var A="function"==typeof Symbol&&Symbol.iterator,P="@@iterator",O="<<anonymous>>",I={array:p("array"),bool:p("boolean"),func:p("function"),number:p("number"),object:p("object"),string:p("string"),symbol:p("symbol"),any:h(),arrayOf:m,element:f(),instanceOf:g,node:S(),objectOf:v,oneOf:b,oneOfType:y,shape:w,exact:E};return u.prototype=Error.prototype,I.checkPropTypes=l,I.PropTypes=I,I}},function(e,t){"use strict";var n="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED";e.exports=n},function(e,t,n){"use strict";function i(e,t,n,i,r){}e.exports=i},function(e,t){"use strict";e.exports="15.6.2"},function(e,t,n){"use strict";var i=n(31),r=i.Component,o=n(42),s=o.isValidElement,a=n(33),l=n(56);e.exports=l(r,s,a)},function(e,t,n){"use strict";function i(e){return e}function r(e,t,n){function r(e,t){var n=v.hasOwnProperty(t)?v[t]:null;E.hasOwnProperty(t)&&l("OVERRIDE_BASE"===n,"ReactClassInterface: You are attempting to override `%s` from your class specification. Ensure that your method names do not overlap with React methods.",t),e&&l("DEFINE_MANY"===n||"DEFINE_MANY_MERGED"===n,"ReactClassInterface: You are attempting to define `%s` on your component more than once. This conflict may be due to a mixin.",t)}function o(e,n){if(n){l("function"!=typeof n,"ReactClass: You're attempting to use a component class or function as a mixin. Instead, just use a regular object."),l(!t(n),"ReactClass: You're attempting to use a component as a mixin. Instead, just use a regular object.");var i=e.prototype,o=i.__reactAutoBindPairs;n.hasOwnProperty(c)&&y.mixins(e,n.mixins);for(var s in n)if(n.hasOwnProperty(s)&&s!==c){var a=n[s],u=i.hasOwnProperty(s);if(r(u,s),y.hasOwnProperty(s))y[s](e,a);else{var d=v.hasOwnProperty(s),m="function"==typeof a,f=m&&!d&&!u&&n.autobind!==!1;if(f)o.push(s,a),i[s]=a;else if(u){var g=v[s];l(d&&("DEFINE_MANY_MERGED"===g||"DEFINE_MANY"===g),"ReactClass: Unexpected spec policy %s for key %s when mixing in component specs.",g,s),"DEFINE_MANY_MERGED"===g?i[s]=p(i[s],a):"DEFINE_MANY"===g&&(i[s]=h(i[s],a))}else i[s]=a}}}else;}function u(e,t){if(t)for(var n in t){var i=t[n];if(t.hasOwnProperty(n)){var r=n in y;l(!r,'ReactClass: You are attempting to define a reserved property, `%s`, that shouldn\'t be on the "statics" key. Define it as an instance property instead; it will still be accessible on the constructor.',n);var o=n in e;l(!o,"ReactClass: You are attempting to define `%s` on your component more than once. This conflict may be due to a mixin.",n),e[n]=i}}}function d(e,t){l(e&&t&&"object"==typeof e&&"object"==typeof t,"mergeIntoWithNoDuplicateKeys(): Cannot merge non-objects.");
for(var n in t)t.hasOwnProperty(n)&&(l(void 0===e[n],"mergeIntoWithNoDuplicateKeys(): Tried to merge two objects with the same key: `%s`. This conflict may be due to a mixin; in particular, this may be caused by two getInitialState() or getDefaultProps() methods returning objects with clashing keys.",n),e[n]=t[n]);return e}function p(e,t){return function(){var n=e.apply(this,arguments),i=t.apply(this,arguments);if(null==n)return i;if(null==i)return n;var r={};return d(r,n),d(r,i),r}}function h(e,t){return function(){e.apply(this,arguments),t.apply(this,arguments)}}function m(e,t){var n=t.bind(e);return n}function f(e){for(var t=e.__reactAutoBindPairs,n=0;n<t.length;n+=2){var i=t[n],r=t[n+1];e[i]=m(e,r)}}function g(e){var t=i(function(e,i,r){this.__reactAutoBindPairs.length&&f(this),this.props=e,this.context=i,this.refs=a,this.updater=r||n,this.state=null;var o=this.getInitialState?this.getInitialState():null;l("object"==typeof o&&!Array.isArray(o),"%s.getInitialState(): must return an object or null",t.displayName||"ReactCompositeComponent"),this.state=o});t.prototype=new C,t.prototype.constructor=t,t.prototype.__reactAutoBindPairs=[],b.forEach(o.bind(null,t)),o(t,S),o(t,e),o(t,w),t.getDefaultProps&&(t.defaultProps=t.getDefaultProps()),l(t.prototype.render,"createClass(...): Class specification must implement a `render` method.");for(var r in v)t.prototype[r]||(t.prototype[r]=null);return t}var b=[],v={mixins:"DEFINE_MANY",statics:"DEFINE_MANY",propTypes:"DEFINE_MANY",contextTypes:"DEFINE_MANY",childContextTypes:"DEFINE_MANY",getDefaultProps:"DEFINE_MANY_MERGED",getInitialState:"DEFINE_MANY_MERGED",getChildContext:"DEFINE_MANY_MERGED",render:"DEFINE_ONCE",componentWillMount:"DEFINE_MANY",componentDidMount:"DEFINE_MANY",componentWillReceiveProps:"DEFINE_MANY",shouldComponentUpdate:"DEFINE_ONCE",componentWillUpdate:"DEFINE_MANY",componentDidUpdate:"DEFINE_MANY",componentWillUnmount:"DEFINE_MANY",updateComponent:"OVERRIDE_BASE"},y={displayName:function(e,t){e.displayName=t},mixins:function(e,t){if(t)for(var n=0;n<t.length;n++)o(e,t[n])},childContextTypes:function(e,t){e.childContextTypes=s({},e.childContextTypes,t)},contextTypes:function(e,t){e.contextTypes=s({},e.contextTypes,t)},getDefaultProps:function(e,t){e.getDefaultProps?e.getDefaultProps=p(e.getDefaultProps,t):e.getDefaultProps=t},propTypes:function(e,t){e.propTypes=s({},e.propTypes,t)},statics:function(e,t){u(e,t)},autobind:function(){}},S={componentDidMount:function(){this.__isMounted=!0}},w={componentWillUnmount:function(){this.__isMounted=!1}},E={replaceState:function(e,t){this.updater.enqueueReplaceState(this,e,t)},isMounted:function(){return!!this.__isMounted}},C=function(){};return s(C.prototype,e.prototype,E),g}var o,s=n(30),a=n(37),l=n(38),c="mixins";o={},e.exports=r},function(e,t,n){"use strict";function i(e){return o.isValidElement(e)?void 0:r("143"),e}var r=n(32),o=n(42);n(38);e.exports=i},function(e,t,n){"use strict";e.exports=n(59)},function(e,t,n){"use strict";var i=n(60),r=n(64),o=n(188),s=n(85),a=n(82),l=n(193),c=n(194),u=n(195),d=n(196);n(34);r.inject();var p={findDOMNode:c,render:o.render,unmountComponentAtNode:o.unmountComponentAtNode,version:l,unstable_batchedUpdates:a.batchedUpdates,unstable_renderSubtreeIntoContainer:d};"undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__&&"function"==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.inject&&__REACT_DEVTOOLS_GLOBAL_HOOK__.inject({ComponentTree:{getClosestInstanceFromNode:i.getClosestInstanceFromNode,getNodeFromInstance:function(e){return e._renderedComponent&&(e=u(e)),e?i.getNodeFromInstance(e):null}},Mount:o,Reconciler:s});e.exports=p},function(e,t,n){"use strict";function i(e,t){return 1===e.nodeType&&e.getAttribute(m)===String(t)||8===e.nodeType&&e.nodeValue===" react-text: "+t+" "||8===e.nodeType&&e.nodeValue===" react-empty: "+t+" "}function r(e){for(var t;t=e._renderedComponent;)e=t;return e}function o(e,t){var n=r(e);n._hostNode=t,t[g]=n}function s(e){var t=e._hostNode;t&&(delete t[g],e._hostNode=null)}function a(e,t){if(!(e._flags&f.hasCachedChildNodes)){var n=e._renderedChildren,s=t.firstChild;e:for(var a in n)if(n.hasOwnProperty(a)){var l=n[a],c=r(l)._domID;if(0!==c){for(;null!==s;s=s.nextSibling)if(i(s,c)){o(l,s);continue e}d("32",c)}}e._flags|=f.hasCachedChildNodes}}function l(e){if(e[g])return e[g];for(var t=[];!e[g];){if(t.push(e),!e.parentNode)return null;e=e.parentNode}for(var n,i;e&&(i=e[g]);e=t.pop())n=i,t.length&&a(i,e);return n}function c(e){var t=l(e);return null!=t&&t._hostNode===e?t:null}function u(e){if(void 0===e._hostNode?d("33"):void 0,e._hostNode)return e._hostNode;for(var t=[];!e._hostNode;)t.push(e),e._hostParent?void 0:d("34"),e=e._hostParent;for(;t.length;e=t.pop())a(e,e._hostNode);return e._hostNode}var d=n(61),p=n(62),h=n(63),m=(n(38),p.ID_ATTRIBUTE_NAME),f=h,g="__reactInternalInstance$"+Math.random().toString(36).slice(2),b={getClosestInstanceFromNode:l,getInstanceFromNode:c,getNodeFromInstance:u,precacheChildNodes:a,precacheNode:o,uncacheNode:s};e.exports=b},function(e,t){"use strict";function n(e){for(var t=arguments.length-1,n="Minified React error #"+e+"; visit http://facebook.github.io/react/docs/error-decoder.html?invariant="+e,i=0;i<t;i++)n+="&args[]="+encodeURIComponent(arguments[i+1]);n+=" for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";var r=new Error(n);throw r.name="Invariant Violation",r.framesToPop=1,r}e.exports=n},function(e,t,n){"use strict";function i(e,t){return(e&t)===t}var r=n(61),o=(n(38),{MUST_USE_PROPERTY:1,HAS_BOOLEAN_VALUE:4,HAS_NUMERIC_VALUE:8,HAS_POSITIVE_NUMERIC_VALUE:24,HAS_OVERLOADED_BOOLEAN_VALUE:32,injectDOMPropertyConfig:function(e){var t=o,n=e.Properties||{},s=e.DOMAttributeNamespaces||{},l=e.DOMAttributeNames||{},c=e.DOMPropertyNames||{},u=e.DOMMutationMethods||{};e.isCustomAttribute&&a._isCustomAttributeFunctions.push(e.isCustomAttribute);for(var d in n){a.properties.hasOwnProperty(d)?r("48",d):void 0;var p=d.toLowerCase(),h=n[d],m={attributeName:p,attributeNamespace:null,propertyName:d,mutationMethod:null,mustUseProperty:i(h,t.MUST_USE_PROPERTY),hasBooleanValue:i(h,t.HAS_BOOLEAN_VALUE),hasNumericValue:i(h,t.HAS_NUMERIC_VALUE),hasPositiveNumericValue:i(h,t.HAS_POSITIVE_NUMERIC_VALUE),hasOverloadedBooleanValue:i(h,t.HAS_OVERLOADED_BOOLEAN_VALUE)};if(m.hasBooleanValue+m.hasNumericValue+m.hasOverloadedBooleanValue<=1?void 0:r("50",d),l.hasOwnProperty(d)){var f=l[d];m.attributeName=f}s.hasOwnProperty(d)&&(m.attributeNamespace=s[d]),c.hasOwnProperty(d)&&(m.propertyName=c[d]),u.hasOwnProperty(d)&&(m.mutationMethod=u[d]),a.properties[d]=m}}}),s=":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD",a={ID_ATTRIBUTE_NAME:"data-reactid",ROOT_ATTRIBUTE_NAME:"data-reactroot",ATTRIBUTE_NAME_START_CHAR:s,ATTRIBUTE_NAME_CHAR:s+"\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040",properties:{},getPossibleStandardName:null,_isCustomAttributeFunctions:[],isCustomAttribute:function(e){for(var t=0;t<a._isCustomAttributeFunctions.length;t++){var n=a._isCustomAttributeFunctions[t];if(n(e))return!0}return!1},injection:o};e.exports=a},function(e,t){"use strict";var n={hasCachedChildNodes:1};e.exports=n},function(e,t,n){"use strict";function i(){C||(C=!0,v.EventEmitter.injectReactEventListener(b),v.EventPluginHub.injectEventPluginOrder(a),v.EventPluginUtils.injectComponentTree(p),v.EventPluginUtils.injectTreeTraversal(m),v.EventPluginHub.injectEventPluginsByName({SimpleEventPlugin:E,EnterLeaveEventPlugin:l,ChangeEventPlugin:s,SelectEventPlugin:w,BeforeInputEventPlugin:o}),v.HostComponent.injectGenericComponentClass(d),v.HostComponent.injectTextComponentClass(f),v.DOMProperty.injectDOMPropertyConfig(r),v.DOMProperty.injectDOMPropertyConfig(c),v.DOMProperty.injectDOMPropertyConfig(S),v.EmptyComponent.injectEmptyComponentFactory(function(e){return new h(e)}),v.Updates.injectReconcileTransaction(y),v.Updates.injectBatchingStrategy(g),v.Component.injectEnvironment(u))}var r=n(65),o=n(66),s=n(81),a=n(94),l=n(95),c=n(100),u=n(101),d=n(114),p=n(60),h=n(159),m=n(160),f=n(161),g=n(162),b=n(163),v=n(166),y=n(167),S=n(175),w=n(176),E=n(177),C=!1;e.exports={inject:i}},function(e,t){"use strict";var n={Properties:{"aria-current":0,"aria-details":0,"aria-disabled":0,"aria-hidden":0,"aria-invalid":0,"aria-keyshortcuts":0,"aria-label":0,"aria-roledescription":0,"aria-autocomplete":0,"aria-checked":0,"aria-expanded":0,"aria-haspopup":0,"aria-level":0,"aria-modal":0,"aria-multiline":0,"aria-multiselectable":0,"aria-orientation":0,"aria-placeholder":0,"aria-pressed":0,"aria-readonly":0,"aria-required":0,"aria-selected":0,"aria-sort":0,"aria-valuemax":0,"aria-valuemin":0,"aria-valuenow":0,"aria-valuetext":0,"aria-atomic":0,"aria-busy":0,"aria-live":0,"aria-relevant":0,"aria-dropeffect":0,"aria-grabbed":0,"aria-activedescendant":0,"aria-colcount":0,"aria-colindex":0,"aria-colspan":0,"aria-controls":0,"aria-describedby":0,"aria-errormessage":0,"aria-flowto":0,"aria-labelledby":0,"aria-owns":0,"aria-posinset":0,"aria-rowcount":0,"aria-rowindex":0,"aria-rowspan":0,"aria-setsize":0},DOMAttributeNames:{},DOMPropertyNames:{}};e.exports=n},function(e,t,n){"use strict";function i(){var e=window.opera;return"object"==typeof e&&"function"==typeof e.version&&parseInt(e.version(),10)<=12}function r(e){return(e.ctrlKey||e.altKey||e.metaKey)&&!(e.ctrlKey&&e.altKey)}function o(e){switch(e){case"topCompositionStart":return _.compositionStart;case"topCompositionEnd":return _.compositionEnd;case"topCompositionUpdate":return _.compositionUpdate}}function s(e,t){return"topKeyDown"===e&&t.keyCode===y}function a(e,t){switch(e){case"topKeyUp":return v.indexOf(t.keyCode)!==-1;case"topKeyDown":return t.keyCode!==y;case"topKeyPress":case"topMouseDown":case"topBlur":return!0;default:return!1}}function l(e){var t=e.detail;return"object"==typeof t&&"data"in t?t.data:null}function c(e,t,n,i){var r,c;if(S?r=o(e):M?a(e,n)&&(r=_.compositionEnd):s(e,n)&&(r=_.compositionStart),!r)return null;C&&(M||r!==_.compositionStart?r===_.compositionEnd&&M&&(c=M.getData()):M=f.getPooled(i));var u=g.getPooled(r,t,n,i);if(c)u.data=c;else{var d=l(n);null!==d&&(u.data=d)}return h.accumulateTwoPhaseDispatches(u),u}function u(e,t){switch(e){case"topCompositionEnd":return l(t);case"topKeyPress":var n=t.which;return n!==T?null:(k=!0,x);case"topTextInput":var i=t.data;return i===x&&k?null:i;default:return null}}function d(e,t){if(M){if("topCompositionEnd"===e||!S&&a(e,t)){var n=M.getData();return f.release(M),M=null,n}return null}switch(e){case"topPaste":return null;case"topKeyPress":return t.which&&!r(t)?String.fromCharCode(t.which):null;case"topCompositionEnd":return C?null:t.data;default:return null}}function p(e,t,n,i){var r;if(r=E?u(e,n):d(e,n),!r)return null;var o=b.getPooled(_.beforeInput,t,n,i);return o.data=r,h.accumulateTwoPhaseDispatches(o),o}var h=n(67),m=n(74),f=n(75),g=n(78),b=n(80),v=[9,13,27,32],y=229,S=m.canUseDOM&&"CompositionEvent"in window,w=null;m.canUseDOM&&"documentMode"in document&&(w=document.documentMode);var E=m.canUseDOM&&"TextEvent"in window&&!w&&!i(),C=m.canUseDOM&&(!S||w&&w>8&&w<=11),T=32,x=String.fromCharCode(T),_={beforeInput:{phasedRegistrationNames:{bubbled:"onBeforeInput",captured:"onBeforeInputCapture"},dependencies:["topCompositionEnd","topKeyPress","topTextInput","topPaste"]},compositionEnd:{phasedRegistrationNames:{bubbled:"onCompositionEnd",captured:"onCompositionEndCapture"},dependencies:["topBlur","topCompositionEnd","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]},compositionStart:{phasedRegistrationNames:{bubbled:"onCompositionStart",captured:"onCompositionStartCapture"},dependencies:["topBlur","topCompositionStart","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]},compositionUpdate:{phasedRegistrationNames:{bubbled:"onCompositionUpdate",captured:"onCompositionUpdateCapture"},dependencies:["topBlur","topCompositionUpdate","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]}},k=!1,M=null,A={eventTypes:_,extractEvents:function(e,t,n,i){return[c(e,t,n,i),p(e,t,n,i)]}};e.exports=A},function(e,t,n){"use strict";function i(e,t,n){var i=t.dispatchConfig.phasedRegistrationNames[n];return b(e,i)}function r(e,t,n){var r=i(e,n,t);r&&(n._dispatchListeners=f(n._dispatchListeners,r),n._dispatchInstances=f(n._dispatchInstances,e))}function o(e){e&&e.dispatchConfig.phasedRegistrationNames&&m.traverseTwoPhase(e._targetInst,r,e)}function s(e){if(e&&e.dispatchConfig.phasedRegistrationNames){var t=e._targetInst,n=t?m.getParentInstance(t):null;m.traverseTwoPhase(n,r,e)}}function a(e,t,n){if(n&&n.dispatchConfig.registrationName){var i=n.dispatchConfig.registrationName,r=b(e,i);r&&(n._dispatchListeners=f(n._dispatchListeners,r),n._dispatchInstances=f(n._dispatchInstances,e))}}function l(e){e&&e.dispatchConfig.registrationName&&a(e._targetInst,null,e)}function c(e){g(e,o)}function u(e){g(e,s)}function d(e,t,n,i){m.traverseEnterLeave(n,i,a,e,t)}function p(e){g(e,l)}var h=n(68),m=n(70),f=n(72),g=n(73),b=(n(34),h.getListener),v={accumulateTwoPhaseDispatches:c,accumulateTwoPhaseDispatchesSkipTarget:u,accumulateDirectDispatches:p,accumulateEnterLeaveDispatches:d};e.exports=v},function(e,t,n){"use strict";function i(e){return"button"===e||"input"===e||"select"===e||"textarea"===e}function r(e,t,n){switch(e){case"onClick":case"onClickCapture":case"onDoubleClick":case"onDoubleClickCapture":case"onMouseDown":case"onMouseDownCapture":case"onMouseMove":case"onMouseMoveCapture":case"onMouseUp":case"onMouseUpCapture":return!(!n.disabled||!i(t));default:return!1}}var o=n(61),s=n(69),a=n(70),l=n(71),c=n(72),u=n(73),d=(n(38),{}),p=null,h=function(e,t){e&&(a.executeDispatchesInOrder(e,t),e.isPersistent()||e.constructor.release(e))},m=function(e){return h(e,!0)},f=function(e){return h(e,!1)},g=function(e){return"."+e._rootNodeID},b={injection:{injectEventPluginOrder:s.injectEventPluginOrder,injectEventPluginsByName:s.injectEventPluginsByName},putListener:function(e,t,n){"function"!=typeof n?o("94",t,typeof n):void 0;var i=g(e),r=d[t]||(d[t]={});r[i]=n;var a=s.registrationNameModules[t];a&&a.didPutListener&&a.didPutListener(e,t,n)},getListener:function(e,t){var n=d[t];if(r(t,e._currentElement.type,e._currentElement.props))return null;var i=g(e);return n&&n[i]},deleteListener:function(e,t){var n=s.registrationNameModules[t];n&&n.willDeleteListener&&n.willDeleteListener(e,t);var i=d[t];if(i){var r=g(e);delete i[r]}},deleteAllListeners:function(e){var t=g(e);for(var n in d)if(d.hasOwnProperty(n)&&d[n][t]){var i=s.registrationNameModules[n];i&&i.willDeleteListener&&i.willDeleteListener(e,n),delete d[n][t]}},extractEvents:function(e,t,n,i){for(var r,o=s.plugins,a=0;a<o.length;a++){var l=o[a];if(l){var u=l.extractEvents(e,t,n,i);u&&(r=c(r,u))}}return r},enqueueEvents:function(e){e&&(p=c(p,e))},processEventQueue:function(e){var t=p;p=null,e?u(t,m):u(t,f),p?o("95"):void 0,l.rethrowCaughtError()},__purge:function(){d={}},__getListenerBank:function(){return d}};e.exports=b},function(e,t,n){"use strict";function i(){if(a)for(var e in l){var t=l[e],n=a.indexOf(e);if(n>-1?void 0:s("96",e),!c.plugins[n]){t.extractEvents?void 0:s("97",e),c.plugins[n]=t;var i=t.eventTypes;for(var o in i)r(i[o],t,o)?void 0:s("98",o,e)}}}function r(e,t,n){c.eventNameDispatchConfigs.hasOwnProperty(n)?s("99",n):void 0,c.eventNameDispatchConfigs[n]=e;var i=e.phasedRegistrationNames;if(i){for(var r in i)if(i.hasOwnProperty(r)){var a=i[r];o(a,t,n)}return!0}return!!e.registrationName&&(o(e.registrationName,t,n),!0)}function o(e,t,n){c.registrationNameModules[e]?s("100",e):void 0,c.registrationNameModules[e]=t,c.registrationNameDependencies[e]=t.eventTypes[n].dependencies}var s=n(61),a=(n(38),null),l={},c={plugins:[],eventNameDispatchConfigs:{},registrationNameModules:{},registrationNameDependencies:{},possibleRegistrationNames:null,injectEventPluginOrder:function(e){a?s("101"):void 0,a=Array.prototype.slice.call(e),i()},injectEventPluginsByName:function(e){var t=!1;for(var n in e)if(e.hasOwnProperty(n)){var r=e[n];l.hasOwnProperty(n)&&l[n]===r||(l[n]?s("102",n):void 0,l[n]=r,t=!0)}t&&i()},getPluginModuleForEvent:function(e){var t=e.dispatchConfig;if(t.registrationName)return c.registrationNameModules[t.registrationName]||null;if(void 0!==t.phasedRegistrationNames){var n=t.phasedRegistrationNames;for(var i in n)if(n.hasOwnProperty(i)){var r=c.registrationNameModules[n[i]];if(r)return r}}return null},_resetEventPlugins:function(){a=null;for(var e in l)l.hasOwnProperty(e)&&delete l[e];c.plugins.length=0;var t=c.eventNameDispatchConfigs;for(var n in t)t.hasOwnProperty(n)&&delete t[n];var i=c.registrationNameModules;for(var r in i)i.hasOwnProperty(r)&&delete i[r]}};e.exports=c},function(e,t,n){"use strict";function i(e){return"topMouseUp"===e||"topTouchEnd"===e||"topTouchCancel"===e}function r(e){return"topMouseMove"===e||"topTouchMove"===e}function o(e){return"topMouseDown"===e||"topTouchStart"===e}function s(e,t,n,i){var r=e.type||"unknown-event";e.currentTarget=b.getNodeFromInstance(i),t?f.invokeGuardedCallbackWithCatch(r,n,e):f.invokeGuardedCallback(r,n,e),e.currentTarget=null}function a(e,t){var n=e._dispatchListeners,i=e._dispatchInstances;if(Array.isArray(n))for(var r=0;r<n.length&&!e.isPropagationStopped();r++)s(e,t,n[r],i[r]);else n&&s(e,t,n,i);e._dispatchListeners=null,e._dispatchInstances=null}function l(e){var t=e._dispatchListeners,n=e._dispatchInstances;if(Array.isArray(t)){for(var i=0;i<t.length&&!e.isPropagationStopped();i++)if(t[i](e,n[i]))return n[i]}else if(t&&t(e,n))return n;return null}function c(e){var t=l(e);return e._dispatchInstances=null,e._dispatchListeners=null,t}function u(e){var t=e._dispatchListeners,n=e._dispatchInstances;Array.isArray(t)?m("103"):void 0,e.currentTarget=t?b.getNodeFromInstance(n):null;var i=t?t(e):null;return e.currentTarget=null,e._dispatchListeners=null,e._dispatchInstances=null,i}function d(e){return!!e._dispatchListeners}var p,h,m=n(61),f=n(71),g=(n(38),n(34),{injectComponentTree:function(e){p=e},injectTreeTraversal:function(e){h=e}}),b={isEndish:i,isMoveish:r,isStartish:o,executeDirectDispatch:u,executeDispatchesInOrder:a,executeDispatchesInOrderStopAtTrue:c,hasDispatches:d,getInstanceFromNode:function(e){return p.getInstanceFromNode(e)},getNodeFromInstance:function(e){return p.getNodeFromInstance(e)},isAncestor:function(e,t){return h.isAncestor(e,t)},getLowestCommonAncestor:function(e,t){return h.getLowestCommonAncestor(e,t)},getParentInstance:function(e){return h.getParentInstance(e)},traverseTwoPhase:function(e,t,n){return h.traverseTwoPhase(e,t,n)},traverseEnterLeave:function(e,t,n,i,r){return h.traverseEnterLeave(e,t,n,i,r)},injection:g};e.exports=b},function(e,t,n){"use strict";function i(e,t,n){try{t(n)}catch(e){null===r&&(r=e)}}var r=null,o={invokeGuardedCallback:i,invokeGuardedCallbackWithCatch:i,rethrowCaughtError:function(){if(r){var e=r;throw r=null,e}}};e.exports=o},function(e,t,n){"use strict";function i(e,t){return null==t?r("30"):void 0,null==e?t:Array.isArray(e)?Array.isArray(t)?(e.push.apply(e,t),e):(e.push(t),e):Array.isArray(t)?[e].concat(t):[e,t]}var r=n(61);n(38);e.exports=i},function(e,t){"use strict";function n(e,t,n){Array.isArray(e)?e.forEach(t,n):e&&t.call(n,e)}e.exports=n},function(e,t){"use strict";var n=!("undefined"==typeof window||!window.document||!window.document.createElement),i={canUseDOM:n,canUseWorkers:"undefined"!=typeof Worker,canUseEventListeners:n&&!(!window.addEventListener&&!window.attachEvent),canUseViewport:n&&!!window.screen,isInWorker:!n};e.exports=i},function(e,t,n){"use strict";function i(e){this._root=e,this._startText=this.getText(),this._fallbackText=null}var r=n(30),o=n(76),s=n(77);r(i.prototype,{destructor:function(){this._root=null,this._startText=null,this._fallbackText=null},getText:function(){return"value"in this._root?this._root.value:this._root[s()]},getData:function(){if(this._fallbackText)return this._fallbackText;var e,t,n=this._startText,i=n.length,r=this.getText(),o=r.length;for(e=0;e<i&&n[e]===r[e];e++);var s=i-e;for(t=1;t<=s&&n[i-t]===r[o-t];t++);var a=t>1?1-t:void 0;return this._fallbackText=r.slice(e,a),this._fallbackText}}),o.addPoolingTo(i),e.exports=i},function(e,t,n){"use strict";var i=n(61),r=(n(38),function(e){var t=this;if(t.instancePool.length){var n=t.instancePool.pop();return t.call(n,e),n}return new t(e)}),o=function(e,t){var n=this;if(n.instancePool.length){var i=n.instancePool.pop();return n.call(i,e,t),i}return new n(e,t)},s=function(e,t,n){var i=this;if(i.instancePool.length){var r=i.instancePool.pop();return i.call(r,e,t,n),r}return new i(e,t,n)},a=function(e,t,n,i){var r=this;if(r.instancePool.length){var o=r.instancePool.pop();return r.call(o,e,t,n,i),o}return new r(e,t,n,i)},l=function(e){var t=this;e instanceof t?void 0:i("25"),e.destructor(),t.instancePool.length<t.poolSize&&t.instancePool.push(e)},c=10,u=r,d=function(e,t){var n=e;return n.instancePool=[],n.getPooled=t||u,n.poolSize||(n.poolSize=c),n.release=l,n},p={addPoolingTo:d,oneArgumentPooler:r,twoArgumentPooler:o,threeArgumentPooler:s,fourArgumentPooler:a};e.exports=p},function(e,t,n){"use strict";function i(){return!o&&r.canUseDOM&&(o="textContent"in document.documentElement?"textContent":"innerText"),o}var r=n(74),o=null;e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(79),o={data:null};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){this.dispatchConfig=e,this._targetInst=t,this.nativeEvent=n;var r=this.constructor.Interface;for(var o in r)if(r.hasOwnProperty(o)){var a=r[o];a?this[o]=a(n):"target"===o?this.target=i:this[o]=n[o]}var l=null!=n.defaultPrevented?n.defaultPrevented:n.returnValue===!1;return l?this.isDefaultPrevented=s.thatReturnsTrue:this.isDefaultPrevented=s.thatReturnsFalse,this.isPropagationStopped=s.thatReturnsFalse,this}var r=n(30),o=n(76),s=n(35),a=(n(34),"function"==typeof Proxy,["dispatchConfig","_targetInst","nativeEvent","isDefaultPrevented","isPropagationStopped","_dispatchListeners","_dispatchInstances"]),l={type:null,target:null,currentTarget:s.thatReturnsNull,eventPhase:null,bubbles:null,cancelable:null,timeStamp:function(e){return e.timeStamp||Date.now()},defaultPrevented:null,isTrusted:null};r(i.prototype,{preventDefault:function(){this.defaultPrevented=!0;var e=this.nativeEvent;e&&(e.preventDefault?e.preventDefault():"unknown"!=typeof e.returnValue&&(e.returnValue=!1),this.isDefaultPrevented=s.thatReturnsTrue)},stopPropagation:function(){var e=this.nativeEvent;e&&(e.stopPropagation?e.stopPropagation():"unknown"!=typeof e.cancelBubble&&(e.cancelBubble=!0),this.isPropagationStopped=s.thatReturnsTrue)},persist:function(){this.isPersistent=s.thatReturnsTrue},isPersistent:s.thatReturnsFalse,destructor:function(){var e=this.constructor.Interface;for(var t in e)this[t]=null;for(var n=0;n<a.length;n++)this[a[n]]=null}}),i.Interface=l,i.augmentClass=function(e,t){var n=this,i=function(){};i.prototype=n.prototype;var s=new i;r(s,e.prototype),e.prototype=s,e.prototype.constructor=e,e.Interface=r({},n.Interface,t),e.augmentClass=n.augmentClass,o.addPoolingTo(e,o.fourArgumentPooler)},o.addPoolingTo(i,o.fourArgumentPooler),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(79),o={data:null};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t,n){var i=_.getPooled(O.change,e,t,n);return i.type="change",E.accumulateTwoPhaseDispatches(i),i}function r(e){var t=e.nodeName&&e.nodeName.toLowerCase();return"select"===t||"input"===t&&"file"===e.type}function o(e){var t=i(R,e,M(e));x.batchedUpdates(s,t)}function s(e){w.enqueueEvents(e),w.processEventQueue(!1)}function a(e,t){I=e,R=t,I.attachEvent("onchange",o)}function l(){I&&(I.detachEvent("onchange",o),I=null,R=null)}function c(e,t){var n=k.updateValueIfChanged(e),i=t.simulated===!0&&L._allowSimulatedPassThrough;if(n||i)return e}function u(e,t){if("topChange"===e)return t}function d(e,t,n){"topFocus"===e?(l(),a(t,n)):"topBlur"===e&&l()}function p(e,t){I=e,R=t,I.attachEvent("onpropertychange",m)}function h(){I&&(I.detachEvent("onpropertychange",m),I=null,R=null)}function m(e){"value"===e.propertyName&&c(R,e)&&o(e)}function f(e,t,n){"topFocus"===e?(h(),p(t,n)):"topBlur"===e&&h()}function g(e,t,n){if("topSelectionChange"===e||"topKeyUp"===e||"topKeyDown"===e)return c(R,n)}function b(e){var t=e.nodeName;return t&&"input"===t.toLowerCase()&&("checkbox"===e.type||"radio"===e.type)}function v(e,t,n){if("topClick"===e)return c(t,n)}function y(e,t,n){if("topInput"===e||"topChange"===e)return c(t,n)}function S(e,t){if(null!=e){var n=e._wrapperState||t._wrapperState;if(n&&n.controlled&&"number"===t.type){var i=""+t.value;t.getAttribute("value")!==i&&t.setAttribute("value",i)}}}var w=n(68),E=n(67),C=n(74),T=n(60),x=n(82),_=n(79),k=n(90),M=n(91),A=n(92),P=n(93),O={change:{phasedRegistrationNames:{bubbled:"onChange",captured:"onChangeCapture"},dependencies:["topBlur","topChange","topClick","topFocus","topInput","topKeyDown","topKeyUp","topSelectionChange"]}},I=null,R=null,D=!1;C.canUseDOM&&(D=A("change")&&(!document.documentMode||document.documentMode>8));var N=!1;C.canUseDOM&&(N=A("input")&&(!document.documentMode||document.documentMode>9));var L={eventTypes:O,_allowSimulatedPassThrough:!0,_isInputEventSupported:N,extractEvents:function(e,t,n,o){var s,a,l=t?T.getNodeFromInstance(t):window;if(r(l)?D?s=u:a=d:P(l)?N?s=y:(s=g,a=f):b(l)&&(s=v),s){var c=s(e,t,n);if(c){var p=i(c,n,o);return p}}a&&a(e,l,t),"topBlur"===e&&S(t,l)}};e.exports=L},function(e,t,n){"use strict";function i(){M.ReactReconcileTransaction&&E?void 0:u("123")}function r(){this.reinitializeTransaction(),this.dirtyComponentsLength=null,this.callbackQueue=p.getPooled(),this.reconcileTransaction=M.ReactReconcileTransaction.getPooled(!0)}function o(e,t,n,r,o,s){return i(),E.batchedUpdates(e,t,n,r,o,s)}function s(e,t){return e._mountOrder-t._mountOrder}function a(e){var t=e.dirtyComponentsLength;t!==v.length?u("124",t,v.length):void 0,v.sort(s),y++;for(var n=0;n<t;n++){var i=v[n],r=i._pendingCallbacks;i._pendingCallbacks=null;var o;if(m.logTopLevelRenders){var a=i;i._currentElement.type.isReactTopLevelWrapper&&(a=i._renderedComponent),o="React update: "+a.getName(),console.time(o)}if(f.performUpdateIfNecessary(i,e.reconcileTransaction,y),o&&console.timeEnd(o),r)for(var l=0;l<r.length;l++)e.callbackQueue.enqueue(r[l],i.getPublicInstance())}}function l(e){return i(),E.isBatchingUpdates?(v.push(e),void(null==e._updateBatchNumber&&(e._updateBatchNumber=y+1))):void E.batchedUpdates(l,e)}function c(e,t){b(E.isBatchingUpdates,"ReactUpdates.asap: Can't enqueue an asap callback in a context whereupdates are not being batched."),S.enqueue(e,t),w=!0}var u=n(61),d=n(30),p=n(83),h=n(76),m=n(84),f=n(85),g=n(89),b=n(38),v=[],y=0,S=p.getPooled(),w=!1,E=null,C={initialize:function(){this.dirtyComponentsLength=v.length},close:function(){this.dirtyComponentsLength!==v.length?(v.splice(0,this.dirtyComponentsLength),_()):v.length=0}},T={initialize:function(){this.callbackQueue.reset()},close:function(){this.callbackQueue.notifyAll()}},x=[C,T];d(r.prototype,g,{getTransactionWrappers:function(){return x},destructor:function(){this.dirtyComponentsLength=null,p.release(this.callbackQueue),this.callbackQueue=null,M.ReactReconcileTransaction.release(this.reconcileTransaction),this.reconcileTransaction=null},perform:function(e,t,n){return g.perform.call(this,this.reconcileTransaction.perform,this.reconcileTransaction,e,t,n)}}),h.addPoolingTo(r);var _=function(){for(;v.length||w;){if(v.length){var e=r.getPooled();e.perform(a,null,e),r.release(e)}if(w){w=!1;var t=S;S=p.getPooled(),t.notifyAll(),p.release(t)}}},k={injectReconcileTransaction:function(e){e?void 0:u("126"),M.ReactReconcileTransaction=e},injectBatchingStrategy:function(e){e?void 0:u("127"),"function"!=typeof e.batchedUpdates?u("128"):void 0,"boolean"!=typeof e.isBatchingUpdates?u("129"):void 0,E=e}},M={ReactReconcileTransaction:null,batchedUpdates:o,enqueueUpdate:l,flushBatchedUpdates:_,injection:k,asap:c};e.exports=M},function(e,t,n){"use strict";function i(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var r=n(61),o=n(76),s=(n(38),function(){function e(t){i(this,e),this._callbacks=null,this._contexts=null,this._arg=t}return e.prototype.enqueue=function(e,t){this._callbacks=this._callbacks||[],this._callbacks.push(e),this._contexts=this._contexts||[],this._contexts.push(t)},e.prototype.notifyAll=function(){var e=this._callbacks,t=this._contexts,n=this._arg;if(e&&t){e.length!==t.length?r("24"):void 0,this._callbacks=null,this._contexts=null;for(var i=0;i<e.length;i++)e[i].call(t[i],n);e.length=0,t.length=0}},e.prototype.checkpoint=function(){return this._callbacks?this._callbacks.length:0},e.prototype.rollback=function(e){this._callbacks&&this._contexts&&(this._callbacks.length=e,this._contexts.length=e)},e.prototype.reset=function(){this._callbacks=null,this._contexts=null},e.prototype.destructor=function(){this.reset()},e}());e.exports=o.addPoolingTo(s)},function(e,t){"use strict";var n={logTopLevelRenders:!1};e.exports=n},function(e,t,n){"use strict";function i(){r.attachRefs(this,this._currentElement)}var r=n(86),o=(n(88),n(34),{mountComponent:function(e,t,n,r,o,s){var a=e.mountComponent(t,n,r,o,s);return e._currentElement&&null!=e._currentElement.ref&&t.getReactMountReady().enqueue(i,e),a},getHostNode:function(e){return e.getHostNode()},unmountComponent:function(e,t){r.detachRefs(e,e._currentElement),e.unmountComponent(t)},receiveComponent:function(e,t,n,o){var s=e._currentElement;if(t!==s||o!==e._context){var a=r.shouldUpdateRefs(s,t);a&&r.detachRefs(e,s),e.receiveComponent(t,n,o),a&&e._currentElement&&null!=e._currentElement.ref&&n.getReactMountReady().enqueue(i,e)}},performUpdateIfNecessary:function(e,t,n){e._updateBatchNumber===n&&e.performUpdateIfNecessary(t)}});e.exports=o},function(e,t,n){"use strict";function i(e,t,n){"function"==typeof e?e(t.getPublicInstance()):o.addComponentAsRefTo(t,e,n)}function r(e,t,n){"function"==typeof e?e(null):o.removeComponentAsRefFrom(t,e,n)}var o=n(87),s={};s.attachRefs=function(e,t){if(null!==t&&"object"==typeof t){var n=t.ref;null!=n&&i(n,e,t._owner)}},s.shouldUpdateRefs=function(e,t){var n=null,i=null;null!==e&&"object"==typeof e&&(n=e.ref,i=e._owner);var r=null,o=null;return null!==t&&"object"==typeof t&&(r=t.ref,o=t._owner),n!==r||"string"==typeof r&&o!==i},s.detachRefs=function(e,t){if(null!==t&&"object"==typeof t){var n=t.ref;null!=n&&r(n,e,t._owner)}},e.exports=s},function(e,t,n){"use strict";function i(e){return!(!e||"function"!=typeof e.attachRef||"function"!=typeof e.detachRef)}var r=n(61),o=(n(38),{addComponentAsRefTo:function(e,t,n){i(n)?void 0:r("119"),n.attachRef(t,e)},removeComponentAsRefFrom:function(e,t,n){i(n)?void 0:r("120");var o=n.getPublicInstance();o&&o.refs[t]===e.getPublicInstance()&&n.detachRef(t)}});e.exports=o},function(e,t,n){"use strict";var i=null;e.exports={debugTool:i}},function(e,t,n){"use strict";var i=n(61),r=(n(38),{}),o={reinitializeTransaction:function(){this.transactionWrappers=this.getTransactionWrappers(),this.wrapperInitData?this.wrapperInitData.length=0:this.wrapperInitData=[],this._isInTransaction=!1},_isInTransaction:!1,getTransactionWrappers:null,isInTransaction:function(){return!!this._isInTransaction},perform:function(e,t,n,r,o,s,a,l){this.isInTransaction()?i("27"):void 0;var c,u;try{this._isInTransaction=!0,c=!0,this.initializeAll(0),u=e.call(t,n,r,o,s,a,l),c=!1}finally{try{if(c)try{this.closeAll(0)}catch(e){}else this.closeAll(0)}finally{this._isInTransaction=!1}}return u},initializeAll:function(e){for(var t=this.transactionWrappers,n=e;n<t.length;n++){var i=t[n];try{this.wrapperInitData[n]=r,this.wrapperInitData[n]=i.initialize?i.initialize.call(this):null}finally{if(this.wrapperInitData[n]===r)try{this.initializeAll(n+1)}catch(e){}}}},closeAll:function(e){this.isInTransaction()?void 0:i("28");for(var t=this.transactionWrappers,n=e;n<t.length;n++){
var o,s=t[n],a=this.wrapperInitData[n];try{o=!0,a!==r&&s.close&&s.close.call(this,a),o=!1}finally{if(o)try{this.closeAll(n+1)}catch(e){}}}this.wrapperInitData.length=0}};e.exports=o},function(e,t,n){"use strict";function i(e){var t=e.type,n=e.nodeName;return n&&"input"===n.toLowerCase()&&("checkbox"===t||"radio"===t)}function r(e){return e._wrapperState.valueTracker}function o(e,t){e._wrapperState.valueTracker=t}function s(e){e._wrapperState.valueTracker=null}function a(e){var t;return e&&(t=i(e)?""+e.checked:e.value),t}var l=n(60),c={_getTrackerFromNode:function(e){return r(l.getInstanceFromNode(e))},track:function(e){if(!r(e)){var t=l.getNodeFromInstance(e),n=i(t)?"checked":"value",a=Object.getOwnPropertyDescriptor(t.constructor.prototype,n),c=""+t[n];t.hasOwnProperty(n)||"function"!=typeof a.get||"function"!=typeof a.set||(Object.defineProperty(t,n,{enumerable:a.enumerable,configurable:!0,get:function(){return a.get.call(this)},set:function(e){c=""+e,a.set.call(this,e)}}),o(e,{getValue:function(){return c},setValue:function(e){c=""+e},stopTracking:function(){s(e),delete t[n]}}))}},updateValueIfChanged:function(e){if(!e)return!1;var t=r(e);if(!t)return c.track(e),!0;var n=t.getValue(),i=a(l.getNodeFromInstance(e));return i!==n&&(t.setValue(i),!0)},stopTracking:function(e){var t=r(e);t&&t.stopTracking()}};e.exports=c},function(e,t){"use strict";function n(e){var t=e.target||e.srcElement||window;return t.correspondingUseElement&&(t=t.correspondingUseElement),3===t.nodeType?t.parentNode:t}e.exports=n},function(e,t,n){"use strict";function i(e,t){if(!o.canUseDOM||t&&!("addEventListener"in document))return!1;var n="on"+e,i=n in document;if(!i){var s=document.createElement("div");s.setAttribute(n,"return;"),i="function"==typeof s[n]}return!i&&r&&"wheel"===e&&(i=document.implementation.hasFeature("Events.wheel","3.0")),i}var r,o=n(74);o.canUseDOM&&(r=document.implementation&&document.implementation.hasFeature&&document.implementation.hasFeature("","")!==!0),e.exports=i},function(e,t){"use strict";function n(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return"input"===t?!!i[e.type]:"textarea"===t}var i={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};e.exports=n},function(e,t){"use strict";var n=["ResponderEventPlugin","SimpleEventPlugin","TapEventPlugin","EnterLeaveEventPlugin","ChangeEventPlugin","SelectEventPlugin","BeforeInputEventPlugin"];e.exports=n},function(e,t,n){"use strict";var i=n(67),r=n(60),o=n(96),s={mouseEnter:{registrationName:"onMouseEnter",dependencies:["topMouseOut","topMouseOver"]},mouseLeave:{registrationName:"onMouseLeave",dependencies:["topMouseOut","topMouseOver"]}},a={eventTypes:s,extractEvents:function(e,t,n,a){if("topMouseOver"===e&&(n.relatedTarget||n.fromElement))return null;if("topMouseOut"!==e&&"topMouseOver"!==e)return null;var l;if(a.window===a)l=a;else{var c=a.ownerDocument;l=c?c.defaultView||c.parentWindow:window}var u,d;if("topMouseOut"===e){u=t;var p=n.relatedTarget||n.toElement;d=p?r.getClosestInstanceFromNode(p):null}else u=null,d=t;if(u===d)return null;var h=null==u?l:r.getNodeFromInstance(u),m=null==d?l:r.getNodeFromInstance(d),f=o.getPooled(s.mouseLeave,u,n,a);f.type="mouseleave",f.target=h,f.relatedTarget=m;var g=o.getPooled(s.mouseEnter,d,n,a);return g.type="mouseenter",g.target=m,g.relatedTarget=h,i.accumulateEnterLeaveDispatches(f,g,u,d),[f,g]}};e.exports=a},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(97),o=n(98),s=n(99),a={screenX:null,screenY:null,clientX:null,clientY:null,ctrlKey:null,shiftKey:null,altKey:null,metaKey:null,getModifierState:s,button:function(e){var t=e.button;return"which"in e?t:2===t?2:4===t?1:0},buttons:null,relatedTarget:function(e){return e.relatedTarget||(e.fromElement===e.srcElement?e.toElement:e.fromElement)},pageX:function(e){return"pageX"in e?e.pageX:e.clientX+o.currentScrollLeft},pageY:function(e){return"pageY"in e?e.pageY:e.clientY+o.currentScrollTop}};r.augmentClass(i,a),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(79),o=n(91),s={view:function(e){if(e.view)return e.view;var t=o(e);if(t.window===t)return t;var n=t.ownerDocument;return n?n.defaultView||n.parentWindow:window},detail:function(e){return e.detail||0}};r.augmentClass(i,s),e.exports=i},function(e,t){"use strict";var n={currentScrollLeft:0,currentScrollTop:0,refreshScrollValues:function(e){n.currentScrollLeft=e.x,n.currentScrollTop=e.y}};e.exports=n},function(e,t){"use strict";function n(e){var t=this,n=t.nativeEvent;if(n.getModifierState)return n.getModifierState(e);var i=r[e];return!!i&&!!n[i]}function i(e){return n}var r={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};e.exports=i},function(e,t,n){"use strict";var i=n(62),r=i.injection.MUST_USE_PROPERTY,o=i.injection.HAS_BOOLEAN_VALUE,s=i.injection.HAS_NUMERIC_VALUE,a=i.injection.HAS_POSITIVE_NUMERIC_VALUE,l=i.injection.HAS_OVERLOADED_BOOLEAN_VALUE,c={isCustomAttribute:RegExp.prototype.test.bind(new RegExp("^(data|aria)-["+i.ATTRIBUTE_NAME_CHAR+"]*$")),Properties:{accept:0,acceptCharset:0,accessKey:0,action:0,allowFullScreen:o,allowTransparency:0,alt:0,as:0,async:o,autoComplete:0,autoPlay:o,capture:o,cellPadding:0,cellSpacing:0,charSet:0,challenge:0,checked:r|o,cite:0,classID:0,className:0,cols:a,colSpan:0,content:0,contentEditable:0,contextMenu:0,controls:o,controlsList:0,coords:0,crossOrigin:0,data:0,dateTime:0,default:o,defer:o,dir:0,disabled:o,download:l,draggable:0,encType:0,form:0,formAction:0,formEncType:0,formMethod:0,formNoValidate:o,formTarget:0,frameBorder:0,headers:0,height:0,hidden:o,high:0,href:0,hrefLang:0,htmlFor:0,httpEquiv:0,icon:0,id:0,inputMode:0,integrity:0,is:0,keyParams:0,keyType:0,kind:0,label:0,lang:0,list:0,loop:o,low:0,manifest:0,marginHeight:0,marginWidth:0,max:0,maxLength:0,media:0,mediaGroup:0,method:0,min:0,minLength:0,multiple:r|o,muted:r|o,name:0,nonce:0,noValidate:o,open:o,optimum:0,pattern:0,placeholder:0,playsInline:o,poster:0,preload:0,profile:0,radioGroup:0,readOnly:o,referrerPolicy:0,rel:0,required:o,reversed:o,role:0,rows:a,rowSpan:s,sandbox:0,scope:0,scoped:o,scrolling:0,seamless:o,selected:r|o,shape:0,size:a,sizes:0,span:a,spellCheck:0,src:0,srcDoc:0,srcLang:0,srcSet:0,start:s,step:0,style:0,summary:0,tabIndex:0,target:0,title:0,type:0,useMap:0,value:0,width:0,wmode:0,wrap:0,about:0,datatype:0,inlist:0,prefix:0,property:0,resource:0,typeof:0,vocab:0,autoCapitalize:0,autoCorrect:0,autoSave:0,color:0,itemProp:0,itemScope:o,itemType:0,itemID:0,itemRef:0,results:0,security:0,unselectable:0},DOMAttributeNames:{acceptCharset:"accept-charset",className:"class",htmlFor:"for",httpEquiv:"http-equiv"},DOMPropertyNames:{},DOMMutationMethods:{value:function(e,t){return null==t?e.removeAttribute("value"):void("number"!==e.type||e.hasAttribute("value")===!1?e.setAttribute("value",""+t):e.validity&&!e.validity.badInput&&e.ownerDocument.activeElement!==e&&e.setAttribute("value",""+t))}}};e.exports=c},function(e,t,n){"use strict";var i=n(102),r=n(113),o={processChildrenUpdates:r.dangerouslyProcessChildrenUpdates,replaceNodeWithMarkup:i.dangerouslyReplaceNodeWithMarkup};e.exports=o},function(e,t,n){"use strict";function i(e,t){return Array.isArray(t)&&(t=t[1]),t?t.nextSibling:e.firstChild}function r(e,t,n){u.insertTreeBefore(e,t,n)}function o(e,t,n){Array.isArray(t)?a(e,t[0],t[1],n):f(e,t,n)}function s(e,t){if(Array.isArray(t)){var n=t[1];t=t[0],l(e,t,n),e.removeChild(n)}e.removeChild(t)}function a(e,t,n,i){for(var r=t;;){var o=r.nextSibling;if(f(e,r,i),r===n)break;r=o}}function l(e,t,n){for(;;){var i=t.nextSibling;if(i===n)break;e.removeChild(i)}}function c(e,t,n){var i=e.parentNode,r=e.nextSibling;r===t?n&&f(i,document.createTextNode(n),r):n?(m(r,n),l(i,r,t)):l(i,e,t)}var u=n(103),d=n(109),p=(n(60),n(88),n(106)),h=n(105),m=n(107),f=p(function(e,t,n){e.insertBefore(t,n)}),g=d.dangerouslyReplaceNodeWithMarkup,b={dangerouslyReplaceNodeWithMarkup:g,replaceDelimitedText:c,processUpdates:function(e,t){for(var n=0;n<t.length;n++){var a=t[n];switch(a.type){case"INSERT_MARKUP":r(e,a.content,i(e,a.afterNode));break;case"MOVE_EXISTING":o(e,a.fromNode,i(e,a.afterNode));break;case"SET_MARKUP":h(e,a.content);break;case"TEXT_CONTENT":m(e,a.content);break;case"REMOVE_NODE":s(e,a.fromNode)}}}};e.exports=b},function(e,t,n){"use strict";function i(e){if(g){var t=e.node,n=e.children;if(n.length)for(var i=0;i<n.length;i++)b(t,n[i],null);else null!=e.html?d(t,e.html):null!=e.text&&h(t,e.text)}}function r(e,t){e.parentNode.replaceChild(t.node,e),i(t)}function o(e,t){g?e.children.push(t):e.node.appendChild(t.node)}function s(e,t){g?e.html=t:d(e.node,t)}function a(e,t){g?e.text=t:h(e.node,t)}function l(){return this.node.nodeName}function c(e){return{node:e,children:[],html:null,text:null,toString:l}}var u=n(104),d=n(105),p=n(106),h=n(107),m=1,f=11,g="undefined"!=typeof document&&"number"==typeof document.documentMode||"undefined"!=typeof navigator&&"string"==typeof navigator.userAgent&&/\bEdge\/\d/.test(navigator.userAgent),b=p(function(e,t,n){t.node.nodeType===f||t.node.nodeType===m&&"object"===t.node.nodeName.toLowerCase()&&(null==t.node.namespaceURI||t.node.namespaceURI===u.html)?(i(t),e.insertBefore(t.node,n)):(e.insertBefore(t.node,n),i(t))});c.insertTreeBefore=b,c.replaceChildWithTree=r,c.queueChild=o,c.queueHTML=s,c.queueText=a,e.exports=c},function(e,t){"use strict";var n={html:"http://www.w3.org/1999/xhtml",mathml:"http://www.w3.org/1998/Math/MathML",svg:"http://www.w3.org/2000/svg"};e.exports=n},function(e,t,n){"use strict";var i,r=n(74),o=n(104),s=/^[ \r\n\t\f]/,a=/<(!--|link|noscript|meta|script|style)[ \r\n\t\f\/>]/,l=n(106),c=l(function(e,t){if(e.namespaceURI!==o.svg||"innerHTML"in e)e.innerHTML=t;else{i=i||document.createElement("div"),i.innerHTML="<svg>"+t+"</svg>";for(var n=i.firstChild;n.firstChild;)e.appendChild(n.firstChild)}});if(r.canUseDOM){var u=document.createElement("div");u.innerHTML=" ",""===u.innerHTML&&(c=function(e,t){if(e.parentNode&&e.parentNode.replaceChild(e,e),s.test(t)||"<"===t[0]&&a.test(t)){e.innerHTML=String.fromCharCode(65279)+t;var n=e.firstChild;1===n.data.length?e.removeChild(n):n.deleteData(0,1)}else e.innerHTML=t}),u=null}e.exports=c},function(e,t){"use strict";var n=function(e){return"undefined"!=typeof MSApp&&MSApp.execUnsafeLocalFunction?function(t,n,i,r){MSApp.execUnsafeLocalFunction(function(){return e(t,n,i,r)})}:e};e.exports=n},function(e,t,n){"use strict";var i=n(74),r=n(108),o=n(105),s=function(e,t){if(t){var n=e.firstChild;if(n&&n===e.lastChild&&3===n.nodeType)return void(n.nodeValue=t)}e.textContent=t};i.canUseDOM&&("textContent"in document.documentElement||(s=function(e,t){return 3===e.nodeType?void(e.nodeValue=t):void o(e,r(t))})),e.exports=s},function(e,t){"use strict";function n(e){var t=""+e,n=r.exec(t);if(!n)return t;var i,o="",s=0,a=0;for(s=n.index;s<t.length;s++){switch(t.charCodeAt(s)){case 34:i="&quot;";break;case 38:i="&amp;";break;case 39:i="&#x27;";break;case 60:i="&lt;";break;case 62:i="&gt;";break;default:continue}a!==s&&(o+=t.substring(a,s)),a=s+1,o+=i}return a!==s?o+t.substring(a,s):o}function i(e){return"boolean"==typeof e||"number"==typeof e?""+e:n(e)}var r=/["'&<>]/;e.exports=i},function(e,t,n){"use strict";var i=n(61),r=n(103),o=n(74),s=n(110),a=n(35),l=(n(38),{dangerouslyReplaceNodeWithMarkup:function(e,t){if(o.canUseDOM?void 0:i("56"),t?void 0:i("57"),"HTML"===e.nodeName?i("58"):void 0,"string"==typeof t){var n=s(t,a)[0];e.parentNode.replaceChild(n,e)}else r.replaceChildWithTree(e,t)}});e.exports=l},function(e,t,n){"use strict";function i(e){var t=e.match(u);return t&&t[1].toLowerCase()}function r(e,t){var n=c;c?void 0:l(!1);var r=i(e),o=r&&a(r);if(o){n.innerHTML=o[1]+e+o[2];for(var u=o[0];u--;)n=n.lastChild}else n.innerHTML=e;var d=n.getElementsByTagName("script");d.length&&(t?void 0:l(!1),s(d).forEach(t));for(var p=Array.from(n.childNodes);n.lastChild;)n.removeChild(n.lastChild);return p}var o=n(74),s=n(111),a=n(112),l=n(38),c=o.canUseDOM?document.createElement("div"):null,u=/^\s*<(\w+)/;e.exports=r},function(e,t,n){"use strict";function i(e){var t=e.length;if(Array.isArray(e)||"object"!=typeof e&&"function"!=typeof e?s(!1):void 0,"number"!=typeof t?s(!1):void 0,0===t||t-1 in e?void 0:s(!1),"function"==typeof e.callee?s(!1):void 0,e.hasOwnProperty)try{return Array.prototype.slice.call(e)}catch(e){}for(var n=Array(t),i=0;i<t;i++)n[i]=e[i];return n}function r(e){return!!e&&("object"==typeof e||"function"==typeof e)&&"length"in e&&!("setInterval"in e)&&"number"!=typeof e.nodeType&&(Array.isArray(e)||"callee"in e||"item"in e)}function o(e){return r(e)?Array.isArray(e)?e.slice():i(e):[e]}var s=n(38);e.exports=o},function(e,t,n){"use strict";function i(e){return s?void 0:o(!1),p.hasOwnProperty(e)||(e="*"),a.hasOwnProperty(e)||("*"===e?s.innerHTML="<link />":s.innerHTML="<"+e+"></"+e+">",a[e]=!s.firstChild),a[e]?p[e]:null}var r=n(74),o=n(38),s=r.canUseDOM?document.createElement("div"):null,a={},l=[1,'<select multiple="true">',"</select>"],c=[1,"<table>","</table>"],u=[3,"<table><tbody><tr>","</tr></tbody></table>"],d=[1,'<svg xmlns="http://www.w3.org/2000/svg">',"</svg>"],p={"*":[1,"?<div>","</div>"],area:[1,"<map>","</map>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],legend:[1,"<fieldset>","</fieldset>"],param:[1,"<object>","</object>"],tr:[2,"<table><tbody>","</tbody></table>"],optgroup:l,option:l,caption:c,colgroup:c,tbody:c,tfoot:c,thead:c,td:u,th:u},h=["circle","clipPath","defs","ellipse","g","image","line","linearGradient","mask","path","pattern","polygon","polyline","radialGradient","rect","stop","text","tspan"];h.forEach(function(e){p[e]=d,a[e]=!0}),e.exports=i},function(e,t,n){"use strict";var i=n(102),r=n(60),o={dangerouslyProcessChildrenUpdates:function(e,t){var n=r.getNodeFromInstance(e);i.processUpdates(n,t)}};e.exports=o},function(e,t,n){"use strict";function i(e){if(e){var t=e._currentElement._owner||null;if(t){var n=t.getName();if(n)return" This DOM node was rendered by `"+n+"`."}}return""}function r(e,t){t&&(Y[e._tag]&&(null!=t.children||null!=t.dangerouslySetInnerHTML?g("137",e._tag,e._currentElement._owner?" Check the render method of "+e._currentElement._owner.getName()+".":""):void 0),null!=t.dangerouslySetInnerHTML&&(null!=t.children?g("60"):void 0,"object"==typeof t.dangerouslySetInnerHTML&&Q in t.dangerouslySetInnerHTML?void 0:g("61")),null!=t.style&&"object"!=typeof t.style?g("62",i(e)):void 0)}function o(e,t,n,i){if(!(i instanceof D)){var r=e._hostContainerInfo,o=r._node&&r._node.nodeType===z,a=o?r._node:r._ownerDocument;q(t,a),i.getReactMountReady().enqueue(s,{inst:e,registrationName:t,listener:n})}}function s(){var e=this;T.putListener(e.inst,e.registrationName,e.listener)}function a(){var e=this;A.postMountWrapper(e)}function l(){var e=this;I.postMountWrapper(e)}function c(){var e=this;P.postMountWrapper(e)}function u(){L.track(this)}function d(){var e=this;e._rootNodeID?void 0:g("63");var t=U(e);switch(t?void 0:g("64"),e._tag){case"iframe":case"object":e._wrapperState.listeners=[_.trapBubbledEvent("topLoad","load",t)];break;case"video":case"audio":e._wrapperState.listeners=[];for(var n in W)W.hasOwnProperty(n)&&e._wrapperState.listeners.push(_.trapBubbledEvent(n,W[n],t));break;case"source":e._wrapperState.listeners=[_.trapBubbledEvent("topError","error",t)];break;case"img":e._wrapperState.listeners=[_.trapBubbledEvent("topError","error",t),_.trapBubbledEvent("topLoad","load",t)];break;case"form":e._wrapperState.listeners=[_.trapBubbledEvent("topReset","reset",t),_.trapBubbledEvent("topSubmit","submit",t)];break;case"input":case"select":case"textarea":e._wrapperState.listeners=[_.trapBubbledEvent("topInvalid","invalid",t)]}}function p(){O.postUpdateWrapper(this)}function h(e){$.call(Z,e)||(J.test(e)?void 0:g("65",e),Z[e]=!0)}function m(e,t){return e.indexOf("-")>=0||null!=t.is}function f(e){var t=e.type;h(t),this._currentElement=e,this._tag=t.toLowerCase(),this._namespaceURI=null,this._renderedChildren=null,this._previousStyle=null,this._previousStyleCopy=null,this._hostNode=null,this._hostParent=null,this._rootNodeID=0,this._domID=0,this._hostContainerInfo=null,this._wrapperState=null,this._topLevelWrapper=null,this._flags=0}var g=n(61),b=n(30),v=n(115),y=n(117),S=n(103),w=n(104),E=n(62),C=n(125),T=n(68),x=n(69),_=n(127),k=n(63),M=n(60),A=n(130),P=n(133),O=n(134),I=n(135),R=(n(88),n(136)),D=n(155),N=(n(35),n(108)),L=(n(38),n(92),n(144),n(90)),B=(n(158),n(34),k),G=T.deleteListener,U=M.getNodeFromInstance,q=_.listenTo,H=x.registrationNameModules,F={string:!0,number:!0},j="style",Q="__html",V={children:null,dangerouslySetInnerHTML:null,suppressContentEditableWarning:null},z=11,W={topAbort:"abort",topCanPlay:"canplay",topCanPlayThrough:"canplaythrough",topDurationChange:"durationchange",topEmptied:"emptied",topEncrypted:"encrypted",topEnded:"ended",topError:"error",topLoadedData:"loadeddata",topLoadedMetadata:"loadedmetadata",topLoadStart:"loadstart",topPause:"pause",topPlay:"play",topPlaying:"playing",topProgress:"progress",topRateChange:"ratechange",topSeeked:"seeked",topSeeking:"seeking",topStalled:"stalled",topSuspend:"suspend",topTimeUpdate:"timeupdate",topVolumeChange:"volumechange",topWaiting:"waiting"},K={area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0},X={listing:!0,pre:!0,textarea:!0},Y=b({menuitem:!0},K),J=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,Z={},$={}.hasOwnProperty,ee=1;f.displayName="ReactDOMComponent",f.Mixin={mountComponent:function(e,t,n,i){this._rootNodeID=ee++,this._domID=n._idCounter++,this._hostParent=t,this._hostContainerInfo=n;var o=this._currentElement.props;switch(this._tag){case"audio":case"form":case"iframe":case"img":case"link":case"object":case"source":case"video":this._wrapperState={listeners:null},e.getReactMountReady().enqueue(d,this);break;case"input":A.mountWrapper(this,o,t),o=A.getHostProps(this,o),e.getReactMountReady().enqueue(u,this),e.getReactMountReady().enqueue(d,this);break;case"option":P.mountWrapper(this,o,t),o=P.getHostProps(this,o);break;case"select":O.mountWrapper(this,o,t),o=O.getHostProps(this,o),e.getReactMountReady().enqueue(d,this);break;case"textarea":I.mountWrapper(this,o,t),o=I.getHostProps(this,o),e.getReactMountReady().enqueue(u,this),e.getReactMountReady().enqueue(d,this)}r(this,o);var s,p;null!=t?(s=t._namespaceURI,p=t._tag):n._tag&&(s=n._namespaceURI,p=n._tag),(null==s||s===w.svg&&"foreignobject"===p)&&(s=w.html),s===w.html&&("svg"===this._tag?s=w.svg:"math"===this._tag&&(s=w.mathml)),this._namespaceURI=s;var h;if(e.useCreateElement){var m,f=n._ownerDocument;if(s===w.html)if("script"===this._tag){var g=f.createElement("div"),b=this._currentElement.type;g.innerHTML="<"+b+"></"+b+">",m=g.removeChild(g.firstChild)}else m=o.is?f.createElement(this._currentElement.type,o.is):f.createElement(this._currentElement.type);else m=f.createElementNS(s,this._currentElement.type);M.precacheNode(this,m),this._flags|=B.hasCachedChildNodes,this._hostParent||C.setAttributeForRoot(m),this._updateDOMProperties(null,o,e);var y=S(m);this._createInitialChildren(e,o,i,y),h=y}else{var E=this._createOpenTagMarkupAndPutListeners(e,o),T=this._createContentMarkup(e,o,i);h=!T&&K[this._tag]?E+"/>":E+">"+T+"</"+this._currentElement.type+">"}switch(this._tag){case"input":e.getReactMountReady().enqueue(a,this),o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"textarea":e.getReactMountReady().enqueue(l,this),o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"select":o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"button":o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"option":e.getReactMountReady().enqueue(c,this)}return h},_createOpenTagMarkupAndPutListeners:function(e,t){var n="<"+this._currentElement.type;for(var i in t)if(t.hasOwnProperty(i)){var r=t[i];if(null!=r)if(H.hasOwnProperty(i))r&&o(this,i,r,e);else{i===j&&(r&&(r=this._previousStyleCopy=b({},t.style)),r=y.createMarkupForStyles(r,this));var s=null;null!=this._tag&&m(this._tag,t)?V.hasOwnProperty(i)||(s=C.createMarkupForCustomAttribute(i,r)):s=C.createMarkupForProperty(i,r),s&&(n+=" "+s)}}return e.renderToStaticMarkup?n:(this._hostParent||(n+=" "+C.createMarkupForRoot()),n+=" "+C.createMarkupForID(this._domID))},_createContentMarkup:function(e,t,n){var i="",r=t.dangerouslySetInnerHTML;if(null!=r)null!=r.__html&&(i=r.__html);else{var o=F[typeof t.children]?t.children:null,s=null!=o?null:t.children;if(null!=o)i=N(o);else if(null!=s){var a=this.mountChildren(s,e,n);i=a.join("")}}return X[this._tag]&&"\n"===i.charAt(0)?"\n"+i:i},_createInitialChildren:function(e,t,n,i){var r=t.dangerouslySetInnerHTML;if(null!=r)null!=r.__html&&S.queueHTML(i,r.__html);else{var o=F[typeof t.children]?t.children:null,s=null!=o?null:t.children;if(null!=o)""!==o&&S.queueText(i,o);else if(null!=s)for(var a=this.mountChildren(s,e,n),l=0;l<a.length;l++)S.queueChild(i,a[l])}},receiveComponent:function(e,t,n){var i=this._currentElement;this._currentElement=e,this.updateComponent(t,i,e,n)},updateComponent:function(e,t,n,i){var o=t.props,s=this._currentElement.props;switch(this._tag){case"input":o=A.getHostProps(this,o),s=A.getHostProps(this,s);break;case"option":o=P.getHostProps(this,o),s=P.getHostProps(this,s);break;case"select":o=O.getHostProps(this,o),s=O.getHostProps(this,s);break;case"textarea":o=I.getHostProps(this,o),s=I.getHostProps(this,s)}switch(r(this,s),this._updateDOMProperties(o,s,e),this._updateDOMChildren(o,s,e,i),this._tag){case"input":A.updateWrapper(this),L.updateValueIfChanged(this);break;case"textarea":I.updateWrapper(this);break;case"select":e.getReactMountReady().enqueue(p,this)}},_updateDOMProperties:function(e,t,n){var i,r,s;for(i in e)if(!t.hasOwnProperty(i)&&e.hasOwnProperty(i)&&null!=e[i])if(i===j){var a=this._previousStyleCopy;for(r in a)a.hasOwnProperty(r)&&(s=s||{},s[r]="");this._previousStyleCopy=null}else H.hasOwnProperty(i)?e[i]&&G(this,i):m(this._tag,e)?V.hasOwnProperty(i)||C.deleteValueForAttribute(U(this),i):(E.properties[i]||E.isCustomAttribute(i))&&C.deleteValueForProperty(U(this),i);for(i in t){var l=t[i],c=i===j?this._previousStyleCopy:null!=e?e[i]:void 0;if(t.hasOwnProperty(i)&&l!==c&&(null!=l||null!=c))if(i===j)if(l?l=this._previousStyleCopy=b({},l):this._previousStyleCopy=null,c){for(r in c)!c.hasOwnProperty(r)||l&&l.hasOwnProperty(r)||(s=s||{},s[r]="");for(r in l)l.hasOwnProperty(r)&&c[r]!==l[r]&&(s=s||{},s[r]=l[r])}else s=l;else if(H.hasOwnProperty(i))l?o(this,i,l,n):c&&G(this,i);else if(m(this._tag,t))V.hasOwnProperty(i)||C.setValueForAttribute(U(this),i,l);else if(E.properties[i]||E.isCustomAttribute(i)){var u=U(this);null!=l?C.setValueForProperty(u,i,l):C.deleteValueForProperty(u,i)}}s&&y.setValueForStyles(U(this),s,this)},_updateDOMChildren:function(e,t,n,i){var r=F[typeof e.children]?e.children:null,o=F[typeof t.children]?t.children:null,s=e.dangerouslySetInnerHTML&&e.dangerouslySetInnerHTML.__html,a=t.dangerouslySetInnerHTML&&t.dangerouslySetInnerHTML.__html,l=null!=r?null:e.children,c=null!=o?null:t.children,u=null!=r||null!=s,d=null!=o||null!=a;null!=l&&null==c?this.updateChildren(null,n,i):u&&!d&&this.updateTextContent(""),null!=o?r!==o&&this.updateTextContent(""+o):null!=a?s!==a&&this.updateMarkup(""+a):null!=c&&this.updateChildren(c,n,i)},getHostNode:function(){return U(this)},unmountComponent:function(e){switch(this._tag){case"audio":case"form":case"iframe":case"img":case"link":case"object":case"source":case"video":var t=this._wrapperState.listeners;if(t)for(var n=0;n<t.length;n++)t[n].remove();break;case"input":case"textarea":L.stopTracking(this);break;case"html":case"head":case"body":g("66",this._tag)}this.unmountChildren(e),M.uncacheNode(this),T.deleteAllListeners(this),this._rootNodeID=0,this._domID=0,this._wrapperState=null},getPublicInstance:function(){return U(this)}},b(f.prototype,f.Mixin,R.Mixin),e.exports=f},function(e,t,n){"use strict";var i=n(60),r=n(116),o={focusDOMComponent:function(){r(i.getNodeFromInstance(this))}};e.exports=o},function(e,t){"use strict";function n(e){try{e.focus()}catch(e){}}e.exports=n},function(e,t,n){"use strict";var i=n(118),r=n(74),o=(n(88),n(119),n(121)),s=n(122),a=n(124),l=(n(34),a(function(e){return s(e)})),c=!1,u="cssFloat";if(r.canUseDOM){var d=document.createElement("div").style;try{d.font=""}catch(e){c=!0}void 0===document.documentElement.style.cssFloat&&(u="styleFloat")}var p={createMarkupForStyles:function(e,t){var n="";for(var i in e)if(e.hasOwnProperty(i)){var r=0===i.indexOf("--"),s=e[i];null!=s&&(n+=l(i)+":",n+=o(i,s,t,r)+";")}return n||null},setValueForStyles:function(e,t,n){var r=e.style;for(var s in t)if(t.hasOwnProperty(s)){var a=0===s.indexOf("--"),l=o(s,t[s],n,a);if("float"!==s&&"cssFloat"!==s||(s=u),a)r.setProperty(s,l);else if(l)r[s]=l;else{var d=c&&i.shorthandPropertyExpansions[s];if(d)for(var p in d)r[p]="";else r[s]=""}}}};e.exports=p},function(e,t){"use strict";function n(e,t){return e+t.charAt(0).toUpperCase()+t.substring(1)}var i={animationIterationCount:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},r=["Webkit","ms","Moz","O"];Object.keys(i).forEach(function(e){r.forEach(function(t){i[n(t,e)]=i[e]})});var o={background:{backgroundAttachment:!0,backgroundColor:!0,backgroundImage:!0,backgroundPositionX:!0,backgroundPositionY:!0,backgroundRepeat:!0},backgroundPosition:{backgroundPositionX:!0,backgroundPositionY:!0},border:{borderWidth:!0,borderStyle:!0,borderColor:!0},borderBottom:{borderBottomWidth:!0,borderBottomStyle:!0,borderBottomColor:!0},borderLeft:{borderLeftWidth:!0,borderLeftStyle:!0,borderLeftColor:!0},borderRight:{borderRightWidth:!0,borderRightStyle:!0,borderRightColor:!0},borderTop:{borderTopWidth:!0,borderTopStyle:!0,borderTopColor:!0},font:{fontStyle:!0,fontVariant:!0,fontWeight:!0,fontSize:!0,lineHeight:!0,fontFamily:!0},outline:{outlineWidth:!0,outlineStyle:!0,outlineColor:!0}},s={isUnitlessNumber:i,shorthandPropertyExpansions:o};e.exports=s},function(e,t,n){"use strict";function i(e){return r(e.replace(o,"ms-"))}var r=n(120),o=/^-ms-/;e.exports=i},function(e,t){"use strict";function n(e){return e.replace(i,function(e,t){return t.toUpperCase()})}var i=/-(.)/g;e.exports=n},function(e,t,n){"use strict";function i(e,t,n,i){var r=null==t||"boolean"==typeof t||""===t;if(r)return"";var s=isNaN(t);if(i||s||0===t||o.hasOwnProperty(e)&&o[e])return""+t;if("string"==typeof t){t=t.trim()}return t+"px"}var r=n(118),o=(n(34),r.isUnitlessNumber);e.exports=i},function(e,t,n){"use strict";function i(e){return r(e).replace(o,"-ms-")}var r=n(123),o=/^ms-/;e.exports=i},function(e,t){"use strict";function n(e){return e.replace(i,"-$1").toLowerCase()}var i=/([A-Z])/g;e.exports=n},function(e,t){"use strict";function n(e){var t={};return function(n){return t.hasOwnProperty(n)||(t[n]=e.call(this,n)),t[n]}}e.exports=n},function(e,t,n){"use strict";function i(e){return!!c.hasOwnProperty(e)||!l.hasOwnProperty(e)&&(a.test(e)?(c[e]=!0,!0):(l[e]=!0,!1))}function r(e,t){return null==t||e.hasBooleanValue&&!t||e.hasNumericValue&&isNaN(t)||e.hasPositiveNumericValue&&t<1||e.hasOverloadedBooleanValue&&t===!1}var o=n(62),s=(n(60),n(88),n(126)),a=(n(34),new RegExp("^["+o.ATTRIBUTE_NAME_START_CHAR+"]["+o.ATTRIBUTE_NAME_CHAR+"]*$")),l={},c={},u={createMarkupForID:function(e){return o.ID_ATTRIBUTE_NAME+"="+s(e)},setAttributeForID:function(e,t){e.setAttribute(o.ID_ATTRIBUTE_NAME,t)},createMarkupForRoot:function(){return o.ROOT_ATTRIBUTE_NAME+'=""'},setAttributeForRoot:function(e){e.setAttribute(o.ROOT_ATTRIBUTE_NAME,"")},createMarkupForProperty:function(e,t){var n=o.properties.hasOwnProperty(e)?o.properties[e]:null;if(n){if(r(n,t))return"";var i=n.attributeName;return n.hasBooleanValue||n.hasOverloadedBooleanValue&&t===!0?i+'=""':i+"="+s(t)}return o.isCustomAttribute(e)?null==t?"":e+"="+s(t):null},createMarkupForCustomAttribute:function(e,t){return i(e)&&null!=t?e+"="+s(t):""},setValueForProperty:function(e,t,n){var i=o.properties.hasOwnProperty(t)?o.properties[t]:null;if(i){var s=i.mutationMethod;if(s)s(e,n);else{if(r(i,n))return void this.deleteValueForProperty(e,t);if(i.mustUseProperty)e[i.propertyName]=n;else{var a=i.attributeName,l=i.attributeNamespace;l?e.setAttributeNS(l,a,""+n):i.hasBooleanValue||i.hasOverloadedBooleanValue&&n===!0?e.setAttribute(a,""):e.setAttribute(a,""+n)}}}else if(o.isCustomAttribute(t))return void u.setValueForAttribute(e,t,n)},setValueForAttribute:function(e,t,n){if(i(t)){null==n?e.removeAttribute(t):e.setAttribute(t,""+n)}},deleteValueForAttribute:function(e,t){e.removeAttribute(t)},deleteValueForProperty:function(e,t){var n=o.properties.hasOwnProperty(t)?o.properties[t]:null;if(n){var i=n.mutationMethod;if(i)i(e,void 0);else if(n.mustUseProperty){var r=n.propertyName;n.hasBooleanValue?e[r]=!1:e[r]=""}else e.removeAttribute(n.attributeName)}else o.isCustomAttribute(t)&&e.removeAttribute(t)}};e.exports=u},function(e,t,n){"use strict";function i(e){return'"'+r(e)+'"'}var r=n(108);e.exports=i},function(e,t,n){"use strict";function i(e){return Object.prototype.hasOwnProperty.call(e,f)||(e[f]=h++,d[e[f]]={}),d[e[f]]}var r,o=n(30),s=n(69),a=n(128),l=n(98),c=n(129),u=n(92),d={},p=!1,h=0,m={topAbort:"abort",topAnimationEnd:c("animationend")||"animationend",topAnimationIteration:c("animationiteration")||"animationiteration",topAnimationStart:c("animationstart")||"animationstart",topBlur:"blur",topCanPlay:"canplay",topCanPlayThrough:"canplaythrough",topChange:"change",topClick:"click",topCompositionEnd:"compositionend",topCompositionStart:"compositionstart",topCompositionUpdate:"compositionupdate",topContextMenu:"contextmenu",topCopy:"copy",topCut:"cut",topDoubleClick:"dblclick",topDrag:"drag",topDragEnd:"dragend",topDragEnter:"dragenter",topDragExit:"dragexit",topDragLeave:"dragleave",topDragOver:"dragover",topDragStart:"dragstart",topDrop:"drop",topDurationChange:"durationchange",topEmptied:"emptied",topEncrypted:"encrypted",topEnded:"ended",topError:"error",topFocus:"focus",topInput:"input",topKeyDown:"keydown",topKeyPress:"keypress",topKeyUp:"keyup",topLoadedData:"loadeddata",topLoadedMetadata:"loadedmetadata",topLoadStart:"loadstart",topMouseDown:"mousedown",topMouseMove:"mousemove",topMouseOut:"mouseout",topMouseOver:"mouseover",topMouseUp:"mouseup",topPaste:"paste",topPause:"pause",topPlay:"play",topPlaying:"playing",topProgress:"progress",topRateChange:"ratechange",topScroll:"scroll",topSeeked:"seeked",topSeeking:"seeking",topSelectionChange:"selectionchange",topStalled:"stalled",topSuspend:"suspend",topTextInput:"textInput",topTimeUpdate:"timeupdate",topTouchCancel:"touchcancel",topTouchEnd:"touchend",topTouchMove:"touchmove",topTouchStart:"touchstart",topTransitionEnd:c("transitionend")||"transitionend",topVolumeChange:"volumechange",topWaiting:"waiting",topWheel:"wheel"},f="_reactListenersID"+String(Math.random()).slice(2),g=o({},a,{ReactEventListener:null,injection:{injectReactEventListener:function(e){e.setHandleTopLevel(g.handleTopLevel),g.ReactEventListener=e}},setEnabled:function(e){g.ReactEventListener&&g.ReactEventListener.setEnabled(e)},isEnabled:function(){return!(!g.ReactEventListener||!g.ReactEventListener.isEnabled())},listenTo:function(e,t){for(var n=t,r=i(n),o=s.registrationNameDependencies[e],a=0;a<o.length;a++){var l=o[a];r.hasOwnProperty(l)&&r[l]||("topWheel"===l?u("wheel")?g.ReactEventListener.trapBubbledEvent("topWheel","wheel",n):u("mousewheel")?g.ReactEventListener.trapBubbledEvent("topWheel","mousewheel",n):g.ReactEventListener.trapBubbledEvent("topWheel","DOMMouseScroll",n):"topScroll"===l?u("scroll",!0)?g.ReactEventListener.trapCapturedEvent("topScroll","scroll",n):g.ReactEventListener.trapBubbledEvent("topScroll","scroll",g.ReactEventListener.WINDOW_HANDLE):"topFocus"===l||"topBlur"===l?(u("focus",!0)?(g.ReactEventListener.trapCapturedEvent("topFocus","focus",n),
g.ReactEventListener.trapCapturedEvent("topBlur","blur",n)):u("focusin")&&(g.ReactEventListener.trapBubbledEvent("topFocus","focusin",n),g.ReactEventListener.trapBubbledEvent("topBlur","focusout",n)),r.topBlur=!0,r.topFocus=!0):m.hasOwnProperty(l)&&g.ReactEventListener.trapBubbledEvent(l,m[l],n),r[l]=!0)}},trapBubbledEvent:function(e,t,n){return g.ReactEventListener.trapBubbledEvent(e,t,n)},trapCapturedEvent:function(e,t,n){return g.ReactEventListener.trapCapturedEvent(e,t,n)},supportsEventPageXY:function(){if(!document.createEvent)return!1;var e=document.createEvent("MouseEvent");return null!=e&&"pageX"in e},ensureScrollValueMonitoring:function(){if(void 0===r&&(r=g.supportsEventPageXY()),!r&&!p){var e=l.refreshScrollValues;g.ReactEventListener.monitorScrollValue(e),p=!0}}});e.exports=g},function(e,t,n){"use strict";function i(e){r.enqueueEvents(e),r.processEventQueue(!1)}var r=n(68),o={handleTopLevel:function(e,t,n,o){var s=r.extractEvents(e,t,n,o);i(s)}};e.exports=o},function(e,t,n){"use strict";function i(e,t){var n={};return n[e.toLowerCase()]=t.toLowerCase(),n["Webkit"+e]="webkit"+t,n["Moz"+e]="moz"+t,n["ms"+e]="MS"+t,n["O"+e]="o"+t.toLowerCase(),n}function r(e){if(a[e])return a[e];if(!s[e])return e;var t=s[e];for(var n in t)if(t.hasOwnProperty(n)&&n in l)return a[e]=t[n];return""}var o=n(74),s={animationend:i("Animation","AnimationEnd"),animationiteration:i("Animation","AnimationIteration"),animationstart:i("Animation","AnimationStart"),transitionend:i("Transition","TransitionEnd")},a={},l={};o.canUseDOM&&(l=document.createElement("div").style,"AnimationEvent"in window||(delete s.animationend.animation,delete s.animationiteration.animation,delete s.animationstart.animation),"TransitionEvent"in window||delete s.transitionend.transition),e.exports=r},function(e,t,n){"use strict";function i(){this._rootNodeID&&p.updateWrapper(this)}function r(e){var t="checkbox"===e.type||"radio"===e.type;return t?null!=e.checked:null!=e.value}function o(e){var t=this._currentElement.props,n=c.executeOnChange(t,e);d.asap(i,this);var r=t.name;if("radio"===t.type&&null!=r){for(var o=u.getNodeFromInstance(this),a=o;a.parentNode;)a=a.parentNode;for(var l=a.querySelectorAll("input[name="+JSON.stringify(""+r)+'][type="radio"]'),p=0;p<l.length;p++){var h=l[p];if(h!==o&&h.form===o.form){var m=u.getInstanceFromNode(h);m?void 0:s("90"),d.asap(i,m)}}}return n}var s=n(61),a=n(30),l=n(125),c=n(131),u=n(60),d=n(82),p=(n(38),n(34),{getHostProps:function(e,t){var n=c.getValue(t),i=c.getChecked(t),r=a({type:void 0,step:void 0,min:void 0,max:void 0},t,{defaultChecked:void 0,defaultValue:void 0,value:null!=n?n:e._wrapperState.initialValue,checked:null!=i?i:e._wrapperState.initialChecked,onChange:e._wrapperState.onChange});return r},mountWrapper:function(e,t){var n=t.defaultValue;e._wrapperState={initialChecked:null!=t.checked?t.checked:t.defaultChecked,initialValue:null!=t.value?t.value:n,listeners:null,onChange:o.bind(e),controlled:r(t)}},updateWrapper:function(e){var t=e._currentElement.props,n=t.checked;null!=n&&l.setValueForProperty(u.getNodeFromInstance(e),"checked",n||!1);var i=u.getNodeFromInstance(e),r=c.getValue(t);if(null!=r)if(0===r&&""===i.value)i.value="0";else if("number"===t.type){var o=parseFloat(i.value,10)||0;(r!=o||r==o&&i.value!=r)&&(i.value=""+r)}else i.value!==""+r&&(i.value=""+r);else null==t.value&&null!=t.defaultValue&&i.defaultValue!==""+t.defaultValue&&(i.defaultValue=""+t.defaultValue),null==t.checked&&null!=t.defaultChecked&&(i.defaultChecked=!!t.defaultChecked)},postMountWrapper:function(e){var t=e._currentElement.props,n=u.getNodeFromInstance(e);switch(t.type){case"submit":case"reset":break;case"color":case"date":case"datetime":case"datetime-local":case"month":case"time":case"week":n.value="",n.value=n.defaultValue;break;default:n.value=n.value}var i=n.name;""!==i&&(n.name=""),n.defaultChecked=!n.defaultChecked,n.defaultChecked=!n.defaultChecked,""!==i&&(n.name=i)}});e.exports=p},function(e,t,n){"use strict";function i(e){null!=e.checkedLink&&null!=e.valueLink?a("87"):void 0}function r(e){i(e),null!=e.value||null!=e.onChange?a("88"):void 0}function o(e){i(e),null!=e.checked||null!=e.onChange?a("89"):void 0}function s(e){if(e){var t=e.getName();if(t)return" Check the render method of `"+t+"`."}return""}var a=n(61),l=n(132),c=n(50),u=n(29),d=c(u.isValidElement),p=(n(38),n(34),{button:!0,checkbox:!0,image:!0,hidden:!0,radio:!0,reset:!0,submit:!0}),h={value:function(e,t,n){return!e[t]||p[e.type]||e.onChange||e.readOnly||e.disabled?null:new Error("You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`.")},checked:function(e,t,n){return!e[t]||e.onChange||e.readOnly||e.disabled?null:new Error("You provided a `checked` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultChecked`. Otherwise, set either `onChange` or `readOnly`.")},onChange:d.func},m={},f={checkPropTypes:function(e,t,n){for(var i in h){if(h.hasOwnProperty(i))var r=h[i](t,i,e,"prop",null,l);if(r instanceof Error&&!(r.message in m)){m[r.message]=!0;s(n)}}},getValue:function(e){return e.valueLink?(r(e),e.valueLink.value):e.value},getChecked:function(e){return e.checkedLink?(o(e),e.checkedLink.value):e.checked},executeOnChange:function(e,t){return e.valueLink?(r(e),e.valueLink.requestChange(t.target.value)):e.checkedLink?(o(e),e.checkedLink.requestChange(t.target.checked)):e.onChange?e.onChange.call(void 0,t):void 0}};e.exports=f},function(e,t){"use strict";var n="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED";e.exports=n},function(e,t,n){"use strict";function i(e){var t="";return o.Children.forEach(e,function(e){null!=e&&("string"==typeof e||"number"==typeof e?t+=e:l||(l=!0))}),t}var r=n(30),o=n(29),s=n(60),a=n(134),l=(n(34),!1),c={mountWrapper:function(e,t,n){var r=null;if(null!=n){var o=n;"optgroup"===o._tag&&(o=o._hostParent),null!=o&&"select"===o._tag&&(r=a.getSelectValueContext(o))}var s=null;if(null!=r){var l;if(l=null!=t.value?t.value+"":i(t.children),s=!1,Array.isArray(r)){for(var c=0;c<r.length;c++)if(""+r[c]===l){s=!0;break}}else s=""+r===l}e._wrapperState={selected:s}},postMountWrapper:function(e){var t=e._currentElement.props;if(null!=t.value){var n=s.getNodeFromInstance(e);n.setAttribute("value",t.value)}},getHostProps:function(e,t){var n=r({selected:void 0,children:void 0},t);null!=e._wrapperState.selected&&(n.selected=e._wrapperState.selected);var o=i(t.children);return o&&(n.children=o),n}};e.exports=c},function(e,t,n){"use strict";function i(){if(this._rootNodeID&&this._wrapperState.pendingUpdate){this._wrapperState.pendingUpdate=!1;var e=this._currentElement.props,t=a.getValue(e);null!=t&&r(this,Boolean(e.multiple),t)}}function r(e,t,n){var i,r,o=l.getNodeFromInstance(e).options;if(t){for(i={},r=0;r<n.length;r++)i[""+n[r]]=!0;for(r=0;r<o.length;r++){var s=i.hasOwnProperty(o[r].value);o[r].selected!==s&&(o[r].selected=s)}}else{for(i=""+n,r=0;r<o.length;r++)if(o[r].value===i)return void(o[r].selected=!0);o.length&&(o[0].selected=!0)}}function o(e){var t=this._currentElement.props,n=a.executeOnChange(t,e);return this._rootNodeID&&(this._wrapperState.pendingUpdate=!0),c.asap(i,this),n}var s=n(30),a=n(131),l=n(60),c=n(82),u=(n(34),!1),d={getHostProps:function(e,t){return s({},t,{onChange:e._wrapperState.onChange,value:void 0})},mountWrapper:function(e,t){var n=a.getValue(t);e._wrapperState={pendingUpdate:!1,initialValue:null!=n?n:t.defaultValue,listeners:null,onChange:o.bind(e),wasMultiple:Boolean(t.multiple)},void 0===t.value||void 0===t.defaultValue||u||(u=!0)},getSelectValueContext:function(e){return e._wrapperState.initialValue},postUpdateWrapper:function(e){var t=e._currentElement.props;e._wrapperState.initialValue=void 0;var n=e._wrapperState.wasMultiple;e._wrapperState.wasMultiple=Boolean(t.multiple);var i=a.getValue(t);null!=i?(e._wrapperState.pendingUpdate=!1,r(e,Boolean(t.multiple),i)):n!==Boolean(t.multiple)&&(null!=t.defaultValue?r(e,Boolean(t.multiple),t.defaultValue):r(e,Boolean(t.multiple),t.multiple?[]:""))}};e.exports=d},function(e,t,n){"use strict";function i(){this._rootNodeID&&u.updateWrapper(this)}function r(e){var t=this._currentElement.props,n=a.executeOnChange(t,e);return c.asap(i,this),n}var o=n(61),s=n(30),a=n(131),l=n(60),c=n(82),u=(n(38),n(34),{getHostProps:function(e,t){null!=t.dangerouslySetInnerHTML?o("91"):void 0;var n=s({},t,{value:void 0,defaultValue:void 0,children:""+e._wrapperState.initialValue,onChange:e._wrapperState.onChange});return n},mountWrapper:function(e,t){var n=a.getValue(t),i=n;if(null==n){var s=t.defaultValue,l=t.children;null!=l&&(null!=s?o("92"):void 0,Array.isArray(l)&&(l.length<=1?void 0:o("93"),l=l[0]),s=""+l),null==s&&(s=""),i=s}e._wrapperState={initialValue:""+i,listeners:null,onChange:r.bind(e)}},updateWrapper:function(e){var t=e._currentElement.props,n=l.getNodeFromInstance(e),i=a.getValue(t);if(null!=i){var r=""+i;r!==n.value&&(n.value=r),null==t.defaultValue&&(n.defaultValue=r)}null!=t.defaultValue&&(n.defaultValue=t.defaultValue)},postMountWrapper:function(e){var t=l.getNodeFromInstance(e),n=t.textContent;n===e._wrapperState.initialValue&&(t.value=n)}});e.exports=u},function(e,t,n){"use strict";function i(e,t,n){return{type:"INSERT_MARKUP",content:e,fromIndex:null,fromNode:null,toIndex:n,afterNode:t}}function r(e,t,n){return{type:"MOVE_EXISTING",content:null,fromIndex:e._mountIndex,fromNode:p.getHostNode(e),toIndex:n,afterNode:t}}function o(e,t){return{type:"REMOVE_NODE",content:null,fromIndex:e._mountIndex,fromNode:t,toIndex:null,afterNode:null}}function s(e){return{type:"SET_MARKUP",content:e,fromIndex:null,fromNode:null,toIndex:null,afterNode:null}}function a(e){return{type:"TEXT_CONTENT",content:e,fromIndex:null,fromNode:null,toIndex:null,afterNode:null}}function l(e,t){return t&&(e=e||[],e.push(t)),e}function c(e,t){d.processChildrenUpdates(e,t)}var u=n(61),d=n(137),p=(n(138),n(88),n(43),n(85)),h=n(139),m=(n(35),n(154)),f=(n(38),{Mixin:{_reconcilerInstantiateChildren:function(e,t,n){return h.instantiateChildren(e,t,n)},_reconcilerUpdateChildren:function(e,t,n,i,r,o){var s,a=0;return s=m(t,a),h.updateChildren(e,s,n,i,r,this,this._hostContainerInfo,o,a),s},mountChildren:function(e,t,n){var i=this._reconcilerInstantiateChildren(e,t,n);this._renderedChildren=i;var r=[],o=0;for(var s in i)if(i.hasOwnProperty(s)){var a=i[s],l=0,c=p.mountComponent(a,t,this,this._hostContainerInfo,n,l);a._mountIndex=o++,r.push(c)}return r},updateTextContent:function(e){var t=this._renderedChildren;h.unmountChildren(t,!1);for(var n in t)t.hasOwnProperty(n)&&u("118");var i=[a(e)];c(this,i)},updateMarkup:function(e){var t=this._renderedChildren;h.unmountChildren(t,!1);for(var n in t)t.hasOwnProperty(n)&&u("118");var i=[s(e)];c(this,i)},updateChildren:function(e,t,n){this._updateChildren(e,t,n)},_updateChildren:function(e,t,n){var i=this._renderedChildren,r={},o=[],s=this._reconcilerUpdateChildren(i,e,o,r,t,n);if(s||i){var a,u=null,d=0,h=0,m=0,f=null;for(a in s)if(s.hasOwnProperty(a)){var g=i&&i[a],b=s[a];g===b?(u=l(u,this.moveChild(g,f,d,h)),h=Math.max(g._mountIndex,h),g._mountIndex=d):(g&&(h=Math.max(g._mountIndex,h)),u=l(u,this._mountChildAtIndex(b,o[m],f,d,t,n)),m++),d++,f=p.getHostNode(b)}for(a in r)r.hasOwnProperty(a)&&(u=l(u,this._unmountChild(i[a],r[a])));u&&c(this,u),this._renderedChildren=s}},unmountChildren:function(e){var t=this._renderedChildren;h.unmountChildren(t,e),this._renderedChildren=null},moveChild:function(e,t,n,i){if(e._mountIndex<i)return r(e,t,n)},createChild:function(e,t,n){return i(n,t,e._mountIndex)},removeChild:function(e,t){return o(e,t)},_mountChildAtIndex:function(e,t,n,i,r,o){return e._mountIndex=i,this.createChild(e,n,t)},_unmountChild:function(e,t){var n=this.removeChild(e,t);return e._mountIndex=null,n}}});e.exports=f},function(e,t,n){"use strict";var i=n(61),r=(n(38),!1),o={replaceNodeWithMarkup:null,processChildrenUpdates:null,injection:{injectEnvironment:function(e){r?i("104"):void 0,o.replaceNodeWithMarkup=e.replaceNodeWithMarkup,o.processChildrenUpdates=e.processChildrenUpdates,r=!0}}};e.exports=o},function(e,t){"use strict";var n={remove:function(e){e._reactInternalInstance=void 0},get:function(e){return e._reactInternalInstance},has:function(e){return void 0!==e._reactInternalInstance},set:function(e,t){e._reactInternalInstance=t}};e.exports=n},function(e,t,n){(function(t){"use strict";function i(e,t,n,i){var r=void 0===e[n];null!=t&&r&&(e[n]=o(t,!0))}var r=n(85),o=n(141),s=(n(149),n(145)),a=n(150),l=(n(34),{instantiateChildren:function(e,t,n,r){if(null==e)return null;var o={};return a(e,i,o),o},updateChildren:function(e,t,n,i,a,l,c,u,d){if(t||e){var p,h;for(p in t)if(t.hasOwnProperty(p)){h=e&&e[p];var m=h&&h._currentElement,f=t[p];if(null!=h&&s(m,f))r.receiveComponent(h,f,a,u),t[p]=h;else{h&&(i[p]=r.getHostNode(h),r.unmountComponent(h,!1));var g=o(f,!0);t[p]=g;var b=r.mountComponent(g,a,l,c,u,d);n.push(b)}}for(p in e)!e.hasOwnProperty(p)||t&&t.hasOwnProperty(p)||(h=e[p],i[p]=r.getHostNode(h),r.unmountComponent(h,!1))}},unmountChildren:function(e,t){for(var n in e)if(e.hasOwnProperty(n)){var i=e[n];r.unmountComponent(i,t)}}});e.exports=l}).call(t,n(140))},function(e,t){function n(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function r(e){if(u===setTimeout)return setTimeout(e,0);if((u===n||!u)&&setTimeout)return u=setTimeout,setTimeout(e,0);try{return u(e,0)}catch(t){try{return u.call(null,e,0)}catch(t){return u.call(this,e,0)}}}function o(e){if(d===clearTimeout)return clearTimeout(e);if((d===i||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(e);try{return d(e)}catch(t){try{return d.call(null,e)}catch(t){return d.call(this,e)}}}function s(){f&&h&&(f=!1,h.length?m=h.concat(m):g=-1,m.length&&a())}function a(){if(!f){var e=r(s);f=!0;for(var t=m.length;t;){for(h=m,m=[];++g<t;)h&&h[g].run();g=-1,t=m.length}h=null,f=!1,o(e)}}function l(e,t){this.fun=e,this.array=t}function c(){}var u,d,p=e.exports={};!function(){try{u="function"==typeof setTimeout?setTimeout:n}catch(e){u=n}try{d="function"==typeof clearTimeout?clearTimeout:i}catch(e){d=i}}();var h,m=[],f=!1,g=-1;p.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];m.push(new l(e,t)),1!==m.length||f||r(a)},l.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=c,p.addListener=c,p.once=c,p.off=c,p.removeListener=c,p.removeAllListeners=c,p.emit=c,p.prependListener=c,p.prependOnceListener=c,p.listeners=function(e){return[]},p.binding=function(e){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(e){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}},function(e,t,n){"use strict";function i(e){if(e){var t=e.getName();if(t)return" Check the render method of `"+t+"`."}return""}function r(e){return"function"==typeof e&&"undefined"!=typeof e.prototype&&"function"==typeof e.prototype.mountComponent&&"function"==typeof e.prototype.receiveComponent}function o(e,t){var n;if(null===e||e===!1)n=c.create(o);else if("object"==typeof e){var a=e,l=a.type;if("function"!=typeof l&&"string"!=typeof l){var p="";p+=i(a._owner),s("130",null==l?l:typeof l,p)}"string"==typeof a.type?n=u.createInternalComponent(a):r(a.type)?(n=new a.type(a),n.getHostNode||(n.getHostNode=n.getNativeNode)):n=new d(a)}else"string"==typeof e||"number"==typeof e?n=u.createInstanceForText(e):s("131",typeof e);return n._mountIndex=0,n._mountImage=null,n}var s=n(61),a=n(30),l=n(142),c=n(146),u=n(147),d=(n(148),n(38),n(34),function(e){this.construct(e)});a(d.prototype,l,{_instantiateReactComponent:o}),e.exports=o},function(e,t,n){"use strict";function i(e){}function r(e,t){}function o(e){return!(!e.prototype||!e.prototype.isReactComponent)}function s(e){return!(!e.prototype||!e.prototype.isPureReactComponent)}var a=n(61),l=n(30),c=n(29),u=n(137),d=n(43),p=n(71),h=n(138),m=(n(88),n(143)),f=n(85),g=n(37),b=(n(38),n(144)),v=n(145),y=(n(34),{ImpureClass:0,PureClass:1,StatelessFunctional:2});i.prototype.render=function(){var e=h.get(this)._currentElement.type,t=e(this.props,this.context,this.updater);return r(e,t),t};var S=1,w={construct:function(e){this._currentElement=e,this._rootNodeID=0,this._compositeType=null,this._instance=null,this._hostParent=null,this._hostContainerInfo=null,this._updateBatchNumber=null,this._pendingElement=null,this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1,this._renderedNodeType=null,this._renderedComponent=null,this._context=null,this._mountOrder=0,this._topLevelWrapper=null,this._pendingCallbacks=null,this._calledComponentWillUnmount=!1},mountComponent:function(e,t,n,l){this._context=l,this._mountOrder=S++,this._hostParent=t,this._hostContainerInfo=n;var u,d=this._currentElement.props,p=this._processContext(l),m=this._currentElement.type,f=e.getUpdateQueue(),b=o(m),v=this._constructComponent(b,d,p,f);b||null!=v&&null!=v.render?s(m)?this._compositeType=y.PureClass:this._compositeType=y.ImpureClass:(u=v,r(m,u),null===v||v===!1||c.isValidElement(v)?void 0:a("105",m.displayName||m.name||"Component"),v=new i(m),this._compositeType=y.StatelessFunctional);v.props=d,v.context=p,v.refs=g,v.updater=f,this._instance=v,h.set(v,this);var w=v.state;void 0===w&&(v.state=w=null),"object"!=typeof w||Array.isArray(w)?a("106",this.getName()||"ReactCompositeComponent"):void 0,this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1;var E;return E=v.unstable_handleError?this.performInitialMountWithErrorHandling(u,t,n,e,l):this.performInitialMount(u,t,n,e,l),v.componentDidMount&&e.getReactMountReady().enqueue(v.componentDidMount,v),E},_constructComponent:function(e,t,n,i){return this._constructComponentWithoutOwner(e,t,n,i)},_constructComponentWithoutOwner:function(e,t,n,i){var r=this._currentElement.type;return e?new r(t,n,i):r(t,n,i)},performInitialMountWithErrorHandling:function(e,t,n,i,r){var o,s=i.checkpoint();try{o=this.performInitialMount(e,t,n,i,r)}catch(a){i.rollback(s),this._instance.unstable_handleError(a),this._pendingStateQueue&&(this._instance.state=this._processPendingState(this._instance.props,this._instance.context)),s=i.checkpoint(),this._renderedComponent.unmountComponent(!0),i.rollback(s),o=this.performInitialMount(e,t,n,i,r)}return o},performInitialMount:function(e,t,n,i,r){var o=this._instance,s=0;o.componentWillMount&&(o.componentWillMount(),this._pendingStateQueue&&(o.state=this._processPendingState(o.props,o.context))),void 0===e&&(e=this._renderValidatedComponent());var a=m.getType(e);this._renderedNodeType=a;var l=this._instantiateReactComponent(e,a!==m.EMPTY);this._renderedComponent=l;var c=f.mountComponent(l,i,t,n,this._processChildContext(r),s);return c},getHostNode:function(){return f.getHostNode(this._renderedComponent)},unmountComponent:function(e){if(this._renderedComponent){var t=this._instance;if(t.componentWillUnmount&&!t._calledComponentWillUnmount)if(t._calledComponentWillUnmount=!0,e){var n=this.getName()+".componentWillUnmount()";p.invokeGuardedCallback(n,t.componentWillUnmount.bind(t))}else t.componentWillUnmount();this._renderedComponent&&(f.unmountComponent(this._renderedComponent,e),this._renderedNodeType=null,this._renderedComponent=null,this._instance=null),this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1,this._pendingCallbacks=null,this._pendingElement=null,this._context=null,this._rootNodeID=0,this._topLevelWrapper=null,h.remove(t)}},_maskContext:function(e){var t=this._currentElement.type,n=t.contextTypes;if(!n)return g;var i={};for(var r in n)i[r]=e[r];return i},_processContext:function(e){var t=this._maskContext(e);return t},_processChildContext:function(e){var t,n=this._currentElement.type,i=this._instance;if(i.getChildContext&&(t=i.getChildContext()),t){"object"!=typeof n.childContextTypes?a("107",this.getName()||"ReactCompositeComponent"):void 0;for(var r in t)r in n.childContextTypes?void 0:a("108",this.getName()||"ReactCompositeComponent",r);return l({},e,t)}return e},_checkContextTypes:function(e,t,n){},receiveComponent:function(e,t,n){var i=this._currentElement,r=this._context;this._pendingElement=null,this.updateComponent(t,i,e,r,n)},performUpdateIfNecessary:function(e){null!=this._pendingElement?f.receiveComponent(this,this._pendingElement,e,this._context):null!==this._pendingStateQueue||this._pendingForceUpdate?this.updateComponent(e,this._currentElement,this._currentElement,this._context,this._context):this._updateBatchNumber=null},updateComponent:function(e,t,n,i,r){var o=this._instance;null==o?a("136",this.getName()||"ReactCompositeComponent"):void 0;var s,l=!1;this._context===r?s=o.context:(s=this._processContext(r),l=!0);var c=t.props,u=n.props;t!==n&&(l=!0),l&&o.componentWillReceiveProps&&o.componentWillReceiveProps(u,s);var d=this._processPendingState(u,s),p=!0;this._pendingForceUpdate||(o.shouldComponentUpdate?p=o.shouldComponentUpdate(u,d,s):this._compositeType===y.PureClass&&(p=!b(c,u)||!b(o.state,d))),this._updateBatchNumber=null,p?(this._pendingForceUpdate=!1,this._performComponentUpdate(n,u,d,s,e,r)):(this._currentElement=n,this._context=r,o.props=u,o.state=d,o.context=s)},_processPendingState:function(e,t){var n=this._instance,i=this._pendingStateQueue,r=this._pendingReplaceState;if(this._pendingReplaceState=!1,this._pendingStateQueue=null,!i)return n.state;if(r&&1===i.length)return i[0];for(var o=l({},r?i[0]:n.state),s=r?1:0;s<i.length;s++){var a=i[s];l(o,"function"==typeof a?a.call(n,o,e,t):a)}return o},_performComponentUpdate:function(e,t,n,i,r,o){var s,a,l,c=this._instance,u=Boolean(c.componentDidUpdate);u&&(s=c.props,a=c.state,l=c.context),c.componentWillUpdate&&c.componentWillUpdate(t,n,i),this._currentElement=e,this._context=o,c.props=t,c.state=n,c.context=i,this._updateRenderedComponent(r,o),u&&r.getReactMountReady().enqueue(c.componentDidUpdate.bind(c,s,a,l),c)},_updateRenderedComponent:function(e,t){var n=this._renderedComponent,i=n._currentElement,r=this._renderValidatedComponent(),o=0;if(v(i,r))f.receiveComponent(n,r,e,this._processChildContext(t));else{var s=f.getHostNode(n);f.unmountComponent(n,!1);var a=m.getType(r);this._renderedNodeType=a;var l=this._instantiateReactComponent(r,a!==m.EMPTY);this._renderedComponent=l;var c=f.mountComponent(l,e,this._hostParent,this._hostContainerInfo,this._processChildContext(t),o);this._replaceNodeWithMarkup(s,c,n)}},_replaceNodeWithMarkup:function(e,t,n){u.replaceNodeWithMarkup(e,t,n)},_renderValidatedComponentWithoutOwnerOrContext:function(){var e,t=this._instance;return e=t.render()},_renderValidatedComponent:function(){var e;if(this._compositeType!==y.StatelessFunctional){d.current=this;try{e=this._renderValidatedComponentWithoutOwnerOrContext()}finally{d.current=null}}else e=this._renderValidatedComponentWithoutOwnerOrContext();return null===e||e===!1||c.isValidElement(e)?void 0:a("109",this.getName()||"ReactCompositeComponent"),e},attachRef:function(e,t){var n=this.getPublicInstance();null==n?a("110"):void 0;var i=t.getPublicInstance(),r=n.refs===g?n.refs={}:n.refs;r[e]=i},detachRef:function(e){var t=this.getPublicInstance().refs;delete t[e]},getName:function(){var e=this._currentElement.type,t=this._instance&&this._instance.constructor;return e.displayName||t&&t.displayName||e.name||t&&t.name||null},getPublicInstance:function(){var e=this._instance;return this._compositeType===y.StatelessFunctional?null:e},_instantiateReactComponent:null};e.exports=w},function(e,t,n){"use strict";var i=n(61),r=n(29),o=(n(38),{HOST:0,COMPOSITE:1,EMPTY:2,getType:function(e){return null===e||e===!1?o.EMPTY:r.isValidElement(e)?"function"==typeof e.type?o.COMPOSITE:o.HOST:void i("26",e)}});e.exports=o},function(e,t){"use strict";function n(e,t){return e===t?0!==e||0!==t||1/e===1/t:e!==e&&t!==t}function i(e,t){if(n(e,t))return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var i=Object.keys(e),o=Object.keys(t);if(i.length!==o.length)return!1;for(var s=0;s<i.length;s++)if(!r.call(t,i[s])||!n(e[i[s]],t[i[s]]))return!1;return!0}var r=Object.prototype.hasOwnProperty;e.exports=i},function(e,t){"use strict";function n(e,t){var n=null===e||e===!1,i=null===t||t===!1;if(n||i)return n===i;var r=typeof e,o=typeof t;return"string"===r||"number"===r?"string"===o||"number"===o:"object"===o&&e.type===t.type&&e.key===t.key}e.exports=n},function(e,t){"use strict";var n,i={injectEmptyComponentFactory:function(e){n=e}},r={create:function(e){return n(e)}};r.injection=i,e.exports=r},function(e,t,n){"use strict";function i(e){return a?void 0:s("111",e.type),new a(e)}function r(e){return new l(e)}function o(e){return e instanceof l}var s=n(61),a=(n(38),null),l=null,c={injectGenericComponentClass:function(e){a=e},injectTextComponentClass:function(e){l=e}},u={createInternalComponent:i,createInstanceForText:r,isTextComponent:o,injection:c};e.exports=u},function(e,t){"use strict";function n(){return i++}var i=1;e.exports=n},function(e,t){"use strict";function n(e){var t=/[=:]/g,n={"=":"=0",":":"=2"},i=(""+e).replace(t,function(e){return n[e]});return"$"+i}function i(e){var t=/(=0|=2)/g,n={"=0":"=","=2":":"},i="."===e[0]&&"$"===e[1]?e.substring(2):e.substring(1);return(""+i).replace(t,function(e){return n[e]})}var r={escape:n,unescape:i};e.exports=r},function(e,t,n){"use strict";function i(e,t){return e&&"object"==typeof e&&null!=e.key?c.escape(e.key):t.toString(36)}function r(e,t,n,o){var p=typeof e;if("undefined"!==p&&"boolean"!==p||(e=null),null===e||"string"===p||"number"===p||"object"===p&&e.$$typeof===a)return n(o,e,""===t?u+i(e,0):t),1;var h,m,f=0,g=""===t?u:t+d;if(Array.isArray(e))for(var b=0;b<e.length;b++)h=e[b],m=g+i(h,b),f+=r(h,m,n,o);else{var v=l(e);if(v){var y,S=v.call(e);if(v!==e.entries)for(var w=0;!(y=S.next()).done;)h=y.value,m=g+i(h,w++),f+=r(h,m,n,o);else for(;!(y=S.next()).done;){var E=y.value;E&&(h=E[1],m=g+c.escape(E[0])+d+i(h,0),f+=r(h,m,n,o))}}else if("object"===p){var C="",T=String(e);s("31","[object Object]"===T?"object with keys {"+Object.keys(e).join(", ")+"}":T,C)}}return f}function o(e,t,n){return null==e?0:r(e,"",t,n)}var s=n(61),a=(n(43),n(151)),l=n(152),c=(n(38),n(149)),u=(n(34),"."),d=":";e.exports=o},function(e,t){"use strict";var n="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103;e.exports=n},function(e,t){"use strict";function n(e){var t=e&&(i&&e[i]||e[r]);if("function"==typeof t)return t}var i="function"==typeof Symbol&&Symbol.iterator,r="@@iterator";e.exports=n},function(e,t,n){"use strict";function i(e){var t=Function.prototype.toString,n=Object.prototype.hasOwnProperty,i=RegExp("^"+t.call(n).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");try{var r=t.call(e);return i.test(r)}catch(e){return!1}}function r(e){var t=c(e);if(t){var n=t.childIDs;u(e),n.forEach(r)}}function o(e,t,n){return"\n    in "+(e||"Unknown")+(t?" (at "+t.fileName.replace(/^.*[\\\/]/,"")+":"+t.lineNumber+")":n?" (created by "+n+")":"")}function s(e){return null==e?"#empty":"string"==typeof e||"number"==typeof e?"#text":"string"==typeof e.type?e.type:e.type.displayName||e.type.name||"Unknown"}function a(e){var t,n=x.getDisplayName(e),i=x.getElement(e),r=x.getOwnerID(e);return r&&(t=x.getDisplayName(r)),o(n,i&&i._source,t)}var l,c,u,d,p,h,m,f=n(32),g=n(43),b=(n(38),n(34),"function"==typeof Array.from&&"function"==typeof Map&&i(Map)&&null!=Map.prototype&&"function"==typeof Map.prototype.keys&&i(Map.prototype.keys)&&"function"==typeof Set&&i(Set)&&null!=Set.prototype&&"function"==typeof Set.prototype.keys&&i(Set.prototype.keys));if(b){var v=new Map,y=new Set;l=function(e,t){v.set(e,t)},c=function(e){return v.get(e)},u=function(e){v.delete(e)},d=function(){return Array.from(v.keys())},p=function(e){y.add(e)},h=function(e){y.delete(e)},m=function(){return Array.from(y.keys())}}else{var S={},w={},E=function(e){return"."+e},C=function(e){return parseInt(e.substr(1),10)};l=function(e,t){var n=E(e);S[n]=t},c=function(e){var t=E(e);return S[t]},u=function(e){var t=E(e);delete S[t]},d=function(){return Object.keys(S).map(C)},p=function(e){var t=E(e);w[t]=!0},h=function(e){var t=E(e);delete w[t]},m=function(){return Object.keys(w).map(C)}}var T=[],x={onSetChildren:function(e,t){var n=c(e);n?void 0:f("144"),n.childIDs=t;for(var i=0;i<t.length;i++){var r=t[i],o=c(r);o?void 0:f("140"),null==o.childIDs&&"object"==typeof o.element&&null!=o.element?f("141"):void 0,o.isMounted?void 0:f("71"),null==o.parentID&&(o.parentID=e),o.parentID!==e?f("142",r,o.parentID,e):void 0}},onBeforeMountComponent:function(e,t,n){var i={element:t,parentID:n,text:null,childIDs:[],isMounted:!1,updateCount:0};l(e,i)},onBeforeUpdateComponent:function(e,t){var n=c(e);n&&n.isMounted&&(n.element=t)},onMountComponent:function(e){var t=c(e);t?void 0:f("144"),t.isMounted=!0;var n=0===t.parentID;n&&p(e)},onUpdateComponent:function(e){var t=c(e);t&&t.isMounted&&t.updateCount++},onUnmountComponent:function(e){var t=c(e);if(t){t.isMounted=!1;var n=0===t.parentID;n&&h(e)}T.push(e)},purgeUnmountedComponents:function(){if(!x._preventPurging){for(var e=0;e<T.length;e++){var t=T[e];r(t)}T.length=0}},isMounted:function(e){var t=c(e);return!!t&&t.isMounted},getCurrentStackAddendum:function(e){var t="";if(e){var n=s(e),i=e._owner;t+=o(n,e._source,i&&i.getName())}var r=g.current,a=r&&r._debugID;return t+=x.getStackAddendumByID(a)},getStackAddendumByID:function(e){for(var t="";e;)t+=a(e),e=x.getParentID(e);return t},getChildIDs:function(e){var t=c(e);return t?t.childIDs:[]},getDisplayName:function(e){var t=x.getElement(e);return t?s(t):null},getElement:function(e){var t=c(e);return t?t.element:null},getOwnerID:function(e){var t=x.getElement(e);return t&&t._owner?t._owner._debugID:null},getParentID:function(e){var t=c(e);return t?t.parentID:null},getSource:function(e){var t=c(e),n=t?t.element:null,i=null!=n?n._source:null;return i},getText:function(e){var t=x.getElement(e);return"string"==typeof t?t:"number"==typeof t?""+t:null},getUpdateCount:function(e){var t=c(e);return t?t.updateCount:0},getRootIDs:m,getRegisteredIDs:d,pushNonStandardWarningStack:function(e,t){if("function"==typeof console.reactStack){var n=[],i=g.current,r=i&&i._debugID;try{for(e&&n.push({name:r?x.getDisplayName(r):null,fileName:t?t.fileName:null,lineNumber:t?t.lineNumber:null});r;){var o=x.getElement(r),s=x.getParentID(r),a=x.getOwnerID(r),l=a?x.getDisplayName(a):null,c=o&&o._source;n.push({name:l,fileName:c?c.fileName:null,lineNumber:c?c.lineNumber:null}),r=s}}catch(e){}console.reactStack(n)}},popNonStandardWarningStack:function(){"function"==typeof console.reactStackEnd&&console.reactStackEnd()}};e.exports=x},function(e,t,n){(function(t){"use strict";function i(e,t,n,i){if(e&&"object"==typeof e){var r=e,o=void 0===r[n];o&&null!=t&&(r[n]=t)}}function r(e,t){if(null==e)return e;var n={};return o(e,i,n),n}var o=(n(149),n(150));n(34);e.exports=r}).call(t,n(140))},function(e,t,n){"use strict";function i(e){this.reinitializeTransaction(),this.renderToStaticMarkup=e,this.useCreateElement=!1,this.updateQueue=new a(this)}var r=n(30),o=n(76),s=n(89),a=(n(88),n(156)),l=[],c={enqueue:function(){}},u={getTransactionWrappers:function(){return l},getReactMountReady:function(){return c},getUpdateQueue:function(){return this.updateQueue},destructor:function(){},checkpoint:function(){},rollback:function(){}};r(i.prototype,s,u),o.addPoolingTo(i),e.exports=i},function(e,t,n){"use strict";function i(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function r(e,t){}var o=n(157),s=(n(34),function(){function e(t){i(this,e),this.transaction=t}return e.prototype.isMounted=function(e){return!1},e.prototype.enqueueCallback=function(e,t,n){this.transaction.isInTransaction()&&o.enqueueCallback(e,t,n);
},e.prototype.enqueueForceUpdate=function(e){this.transaction.isInTransaction()?o.enqueueForceUpdate(e):r(e,"forceUpdate")},e.prototype.enqueueReplaceState=function(e,t){this.transaction.isInTransaction()?o.enqueueReplaceState(e,t):r(e,"replaceState")},e.prototype.enqueueSetState=function(e,t){this.transaction.isInTransaction()?o.enqueueSetState(e,t):r(e,"setState")},e}());e.exports=s},function(e,t,n){"use strict";function i(e){l.enqueueUpdate(e)}function r(e){var t=typeof e;if("object"!==t)return t;var n=e.constructor&&e.constructor.name||t,i=Object.keys(e);return i.length>0&&i.length<20?n+" (keys: "+i.join(", ")+")":n}function o(e,t){var n=a.get(e);if(!n){return null}return n}var s=n(61),a=(n(43),n(138)),l=(n(88),n(82)),c=(n(38),n(34),{isMounted:function(e){var t=a.get(e);return!!t&&!!t._renderedComponent},enqueueCallback:function(e,t,n){c.validateCallback(t,n);var r=o(e);return r?(r._pendingCallbacks?r._pendingCallbacks.push(t):r._pendingCallbacks=[t],void i(r)):null},enqueueCallbackInternal:function(e,t){e._pendingCallbacks?e._pendingCallbacks.push(t):e._pendingCallbacks=[t],i(e)},enqueueForceUpdate:function(e){var t=o(e,"forceUpdate");t&&(t._pendingForceUpdate=!0,i(t))},enqueueReplaceState:function(e,t,n){var r=o(e,"replaceState");r&&(r._pendingStateQueue=[t],r._pendingReplaceState=!0,void 0!==n&&null!==n&&(c.validateCallback(n,"replaceState"),r._pendingCallbacks?r._pendingCallbacks.push(n):r._pendingCallbacks=[n]),i(r))},enqueueSetState:function(e,t){var n=o(e,"setState");if(n){var r=n._pendingStateQueue||(n._pendingStateQueue=[]);r.push(t),i(n)}},enqueueElementInternal:function(e,t,n){e._pendingElement=t,e._context=n,i(e)},validateCallback:function(e,t){e&&"function"!=typeof e?s("122",t,r(e)):void 0}});e.exports=c},function(e,t,n){"use strict";var i=(n(30),n(35)),r=(n(34),i);e.exports=r},function(e,t,n){"use strict";var i=n(30),r=n(103),o=n(60),s=function(e){this._currentElement=null,this._hostNode=null,this._hostParent=null,this._hostContainerInfo=null,this._domID=0};i(s.prototype,{mountComponent:function(e,t,n,i){var s=n._idCounter++;this._domID=s,this._hostParent=t,this._hostContainerInfo=n;var a=" react-empty: "+this._domID+" ";if(e.useCreateElement){var l=n._ownerDocument,c=l.createComment(a);return o.precacheNode(this,c),r(c)}return e.renderToStaticMarkup?"":"<!--"+a+"-->"},receiveComponent:function(){},getHostNode:function(){return o.getNodeFromInstance(this)},unmountComponent:function(){o.uncacheNode(this)}}),e.exports=s},function(e,t,n){"use strict";function i(e,t){"_hostNode"in e?void 0:l("33"),"_hostNode"in t?void 0:l("33");for(var n=0,i=e;i;i=i._hostParent)n++;for(var r=0,o=t;o;o=o._hostParent)r++;for(;n-r>0;)e=e._hostParent,n--;for(;r-n>0;)t=t._hostParent,r--;for(var s=n;s--;){if(e===t)return e;e=e._hostParent,t=t._hostParent}return null}function r(e,t){"_hostNode"in e?void 0:l("35"),"_hostNode"in t?void 0:l("35");for(;t;){if(t===e)return!0;t=t._hostParent}return!1}function o(e){return"_hostNode"in e?void 0:l("36"),e._hostParent}function s(e,t,n){for(var i=[];e;)i.push(e),e=e._hostParent;var r;for(r=i.length;r-- >0;)t(i[r],"captured",n);for(r=0;r<i.length;r++)t(i[r],"bubbled",n)}function a(e,t,n,r,o){for(var s=e&&t?i(e,t):null,a=[];e&&e!==s;)a.push(e),e=e._hostParent;for(var l=[];t&&t!==s;)l.push(t),t=t._hostParent;var c;for(c=0;c<a.length;c++)n(a[c],"bubbled",r);for(c=l.length;c-- >0;)n(l[c],"captured",o)}var l=n(61);n(38);e.exports={isAncestor:r,getLowestCommonAncestor:i,getParentInstance:o,traverseTwoPhase:s,traverseEnterLeave:a}},function(e,t,n){"use strict";var i=n(61),r=n(30),o=n(102),s=n(103),a=n(60),l=n(108),c=(n(38),n(158),function(e){this._currentElement=e,this._stringText=""+e,this._hostNode=null,this._hostParent=null,this._domID=0,this._mountIndex=0,this._closingComment=null,this._commentNodes=null});r(c.prototype,{mountComponent:function(e,t,n,i){var r=n._idCounter++,o=" react-text: "+r+" ",c=" /react-text ";if(this._domID=r,this._hostParent=t,e.useCreateElement){var u=n._ownerDocument,d=u.createComment(o),p=u.createComment(c),h=s(u.createDocumentFragment());return s.queueChild(h,s(d)),this._stringText&&s.queueChild(h,s(u.createTextNode(this._stringText))),s.queueChild(h,s(p)),a.precacheNode(this,d),this._closingComment=p,h}var m=l(this._stringText);return e.renderToStaticMarkup?m:"<!--"+o+"-->"+m+"<!--"+c+"-->"},receiveComponent:function(e,t){if(e!==this._currentElement){this._currentElement=e;var n=""+e;if(n!==this._stringText){this._stringText=n;var i=this.getHostNode();o.replaceDelimitedText(i[0],i[1],n)}}},getHostNode:function(){var e=this._commentNodes;if(e)return e;if(!this._closingComment)for(var t=a.getNodeFromInstance(this),n=t.nextSibling;;){if(null==n?i("67",this._domID):void 0,8===n.nodeType&&" /react-text "===n.nodeValue){this._closingComment=n;break}n=n.nextSibling}return e=[this._hostNode,this._closingComment],this._commentNodes=e,e},unmountComponent:function(){this._closingComment=null,this._commentNodes=null,a.uncacheNode(this)}}),e.exports=c},function(e,t,n){"use strict";function i(){this.reinitializeTransaction()}var r=n(30),o=n(82),s=n(89),a=n(35),l={initialize:a,close:function(){p.isBatchingUpdates=!1}},c={initialize:a,close:o.flushBatchedUpdates.bind(o)},u=[c,l];r(i.prototype,s,{getTransactionWrappers:function(){return u}});var d=new i,p={isBatchingUpdates:!1,batchedUpdates:function(e,t,n,i,r,o){var s=p.isBatchingUpdates;return p.isBatchingUpdates=!0,s?e(t,n,i,r,o):d.perform(e,null,t,n,i,r,o)}};e.exports=p},function(e,t,n){"use strict";function i(e){for(;e._hostParent;)e=e._hostParent;var t=d.getNodeFromInstance(e),n=t.parentNode;return d.getClosestInstanceFromNode(n)}function r(e,t){this.topLevelType=e,this.nativeEvent=t,this.ancestors=[]}function o(e){var t=h(e.nativeEvent),n=d.getClosestInstanceFromNode(t),r=n;do e.ancestors.push(r),r=r&&i(r);while(r);for(var o=0;o<e.ancestors.length;o++)n=e.ancestors[o],f._handleTopLevel(e.topLevelType,n,e.nativeEvent,h(e.nativeEvent))}function s(e){var t=m(window);e(t)}var a=n(30),l=n(164),c=n(74),u=n(76),d=n(60),p=n(82),h=n(91),m=n(165);a(r.prototype,{destructor:function(){this.topLevelType=null,this.nativeEvent=null,this.ancestors.length=0}}),u.addPoolingTo(r,u.twoArgumentPooler);var f={_enabled:!0,_handleTopLevel:null,WINDOW_HANDLE:c.canUseDOM?window:null,setHandleTopLevel:function(e){f._handleTopLevel=e},setEnabled:function(e){f._enabled=!!e},isEnabled:function(){return f._enabled},trapBubbledEvent:function(e,t,n){return n?l.listen(n,t,f.dispatchEvent.bind(null,e)):null},trapCapturedEvent:function(e,t,n){return n?l.capture(n,t,f.dispatchEvent.bind(null,e)):null},monitorScrollValue:function(e){var t=s.bind(null,e);l.listen(window,"scroll",t)},dispatchEvent:function(e,t){if(f._enabled){var n=r.getPooled(e,t);try{p.batchedUpdates(o,n)}finally{r.release(n)}}}};e.exports=f},function(e,t,n){"use strict";var i=n(35),r={listen:function(e,t,n){return e.addEventListener?(e.addEventListener(t,n,!1),{remove:function(){e.removeEventListener(t,n,!1)}}):e.attachEvent?(e.attachEvent("on"+t,n),{remove:function(){e.detachEvent("on"+t,n)}}):void 0},capture:function(e,t,n){return e.addEventListener?(e.addEventListener(t,n,!0),{remove:function(){e.removeEventListener(t,n,!0)}}):{remove:i}},registerDefault:function(){}};e.exports=r},function(e,t){"use strict";function n(e){return e.Window&&e instanceof e.Window?{x:e.pageXOffset||e.document.documentElement.scrollLeft,y:e.pageYOffset||e.document.documentElement.scrollTop}:{x:e.scrollLeft,y:e.scrollTop}}e.exports=n},function(e,t,n){"use strict";var i=n(62),r=n(68),o=n(70),s=n(137),a=n(146),l=n(127),c=n(147),u=n(82),d={Component:s.injection,DOMProperty:i.injection,EmptyComponent:a.injection,EventPluginHub:r.injection,EventPluginUtils:o.injection,EventEmitter:l.injection,HostComponent:c.injection,Updates:u.injection};e.exports=d},function(e,t,n){"use strict";function i(e){this.reinitializeTransaction(),this.renderToStaticMarkup=!1,this.reactMountReady=o.getPooled(null),this.useCreateElement=e}var r=n(30),o=n(83),s=n(76),a=n(127),l=n(168),c=(n(88),n(89)),u=n(157),d={initialize:l.getSelectionInformation,close:l.restoreSelection},p={initialize:function(){var e=a.isEnabled();return a.setEnabled(!1),e},close:function(e){a.setEnabled(e)}},h={initialize:function(){this.reactMountReady.reset()},close:function(){this.reactMountReady.notifyAll()}},m=[d,p,h],f={getTransactionWrappers:function(){return m},getReactMountReady:function(){return this.reactMountReady},getUpdateQueue:function(){return u},checkpoint:function(){return this.reactMountReady.checkpoint()},rollback:function(e){this.reactMountReady.rollback(e)},destructor:function(){o.release(this.reactMountReady),this.reactMountReady=null}};r(i.prototype,c,f),s.addPoolingTo(i),e.exports=i},function(e,t,n){"use strict";function i(e){return o(document.documentElement,e)}var r=n(169),o=n(171),s=n(116),a=n(174),l={hasSelectionCapabilities:function(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return t&&("input"===t&&"text"===e.type||"textarea"===t||"true"===e.contentEditable)},getSelectionInformation:function(){var e=a();return{focusedElem:e,selectionRange:l.hasSelectionCapabilities(e)?l.getSelection(e):null}},restoreSelection:function(e){var t=a(),n=e.focusedElem,r=e.selectionRange;t!==n&&i(n)&&(l.hasSelectionCapabilities(n)&&l.setSelection(n,r),s(n))},getSelection:function(e){var t;if("selectionStart"in e)t={start:e.selectionStart,end:e.selectionEnd};else if(document.selection&&e.nodeName&&"input"===e.nodeName.toLowerCase()){var n=document.selection.createRange();n.parentElement()===e&&(t={start:-n.moveStart("character",-e.value.length),end:-n.moveEnd("character",-e.value.length)})}else t=r.getOffsets(e);return t||{start:0,end:0}},setSelection:function(e,t){var n=t.start,i=t.end;if(void 0===i&&(i=n),"selectionStart"in e)e.selectionStart=n,e.selectionEnd=Math.min(i,e.value.length);else if(document.selection&&e.nodeName&&"input"===e.nodeName.toLowerCase()){var o=e.createTextRange();o.collapse(!0),o.moveStart("character",n),o.moveEnd("character",i-n),o.select()}else r.setOffsets(e,t)}};e.exports=l},function(e,t,n){"use strict";function i(e,t,n,i){return e===n&&t===i}function r(e){var t=document.selection,n=t.createRange(),i=n.text.length,r=n.duplicate();r.moveToElementText(e),r.setEndPoint("EndToStart",n);var o=r.text.length,s=o+i;return{start:o,end:s}}function o(e){var t=window.getSelection&&window.getSelection();if(!t||0===t.rangeCount)return null;var n=t.anchorNode,r=t.anchorOffset,o=t.focusNode,s=t.focusOffset,a=t.getRangeAt(0);try{a.startContainer.nodeType,a.endContainer.nodeType}catch(e){return null}var l=i(t.anchorNode,t.anchorOffset,t.focusNode,t.focusOffset),c=l?0:a.toString().length,u=a.cloneRange();u.selectNodeContents(e),u.setEnd(a.startContainer,a.startOffset);var d=i(u.startContainer,u.startOffset,u.endContainer,u.endOffset),p=d?0:u.toString().length,h=p+c,m=document.createRange();m.setStart(n,r),m.setEnd(o,s);var f=m.collapsed;return{start:f?h:p,end:f?p:h}}function s(e,t){var n,i,r=document.selection.createRange().duplicate();void 0===t.end?(n=t.start,i=n):t.start>t.end?(n=t.end,i=t.start):(n=t.start,i=t.end),r.moveToElementText(e),r.moveStart("character",n),r.setEndPoint("EndToStart",r),r.moveEnd("character",i-n),r.select()}function a(e,t){if(window.getSelection){var n=window.getSelection(),i=e[u()].length,r=Math.min(t.start,i),o=void 0===t.end?r:Math.min(t.end,i);if(!n.extend&&r>o){var s=o;o=r,r=s}var a=c(e,r),l=c(e,o);if(a&&l){var d=document.createRange();d.setStart(a.node,a.offset),n.removeAllRanges(),r>o?(n.addRange(d),n.extend(l.node,l.offset)):(d.setEnd(l.node,l.offset),n.addRange(d))}}}var l=n(74),c=n(170),u=n(77),d=l.canUseDOM&&"selection"in document&&!("getSelection"in window),p={getOffsets:d?r:o,setOffsets:d?s:a};e.exports=p},function(e,t){"use strict";function n(e){for(;e&&e.firstChild;)e=e.firstChild;return e}function i(e){for(;e;){if(e.nextSibling)return e.nextSibling;e=e.parentNode}}function r(e,t){for(var r=n(e),o=0,s=0;r;){if(3===r.nodeType){if(s=o+r.textContent.length,o<=t&&s>=t)return{node:r,offset:t-o};o=s}r=n(i(r))}}e.exports=r},function(e,t,n){"use strict";function i(e,t){return!(!e||!t)&&(e===t||!r(e)&&(r(t)?i(e,t.parentNode):"contains"in e?e.contains(t):!!e.compareDocumentPosition&&!!(16&e.compareDocumentPosition(t))))}var r=n(172);e.exports=i},function(e,t,n){"use strict";function i(e){return r(e)&&3==e.nodeType}var r=n(173);e.exports=i},function(e,t){"use strict";function n(e){var t=e?e.ownerDocument||e:document,n=t.defaultView||window;return!(!e||!("function"==typeof n.Node?e instanceof n.Node:"object"==typeof e&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName))}e.exports=n},function(e,t){"use strict";function n(e){if(e=e||("undefined"!=typeof document?document:void 0),"undefined"==typeof e)return null;try{return e.activeElement||e.body}catch(t){return e.body}}e.exports=n},function(e,t){"use strict";var n={xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace"},i={accentHeight:"accent-height",accumulate:0,additive:0,alignmentBaseline:"alignment-baseline",allowReorder:"allowReorder",alphabetic:0,amplitude:0,arabicForm:"arabic-form",ascent:0,attributeName:"attributeName",attributeType:"attributeType",autoReverse:"autoReverse",azimuth:0,baseFrequency:"baseFrequency",baseProfile:"baseProfile",baselineShift:"baseline-shift",bbox:0,begin:0,bias:0,by:0,calcMode:"calcMode",capHeight:"cap-height",clip:0,clipPath:"clip-path",clipRule:"clip-rule",clipPathUnits:"clipPathUnits",colorInterpolation:"color-interpolation",colorInterpolationFilters:"color-interpolation-filters",colorProfile:"color-profile",colorRendering:"color-rendering",contentScriptType:"contentScriptType",contentStyleType:"contentStyleType",cursor:0,cx:0,cy:0,d:0,decelerate:0,descent:0,diffuseConstant:"diffuseConstant",direction:0,display:0,divisor:0,dominantBaseline:"dominant-baseline",dur:0,dx:0,dy:0,edgeMode:"edgeMode",elevation:0,enableBackground:"enable-background",end:0,exponent:0,externalResourcesRequired:"externalResourcesRequired",fill:0,fillOpacity:"fill-opacity",fillRule:"fill-rule",filter:0,filterRes:"filterRes",filterUnits:"filterUnits",floodColor:"flood-color",floodOpacity:"flood-opacity",focusable:0,fontFamily:"font-family",fontSize:"font-size",fontSizeAdjust:"font-size-adjust",fontStretch:"font-stretch",fontStyle:"font-style",fontVariant:"font-variant",fontWeight:"font-weight",format:0,from:0,fx:0,fy:0,g1:0,g2:0,glyphName:"glyph-name",glyphOrientationHorizontal:"glyph-orientation-horizontal",glyphOrientationVertical:"glyph-orientation-vertical",glyphRef:"glyphRef",gradientTransform:"gradientTransform",gradientUnits:"gradientUnits",hanging:0,horizAdvX:"horiz-adv-x",horizOriginX:"horiz-origin-x",ideographic:0,imageRendering:"image-rendering",in:0,in2:0,intercept:0,k:0,k1:0,k2:0,k3:0,k4:0,kernelMatrix:"kernelMatrix",kernelUnitLength:"kernelUnitLength",kerning:0,keyPoints:"keyPoints",keySplines:"keySplines",keyTimes:"keyTimes",lengthAdjust:"lengthAdjust",letterSpacing:"letter-spacing",lightingColor:"lighting-color",limitingConeAngle:"limitingConeAngle",local:0,markerEnd:"marker-end",markerMid:"marker-mid",markerStart:"marker-start",markerHeight:"markerHeight",markerUnits:"markerUnits",markerWidth:"markerWidth",mask:0,maskContentUnits:"maskContentUnits",maskUnits:"maskUnits",mathematical:0,mode:0,numOctaves:"numOctaves",offset:0,opacity:0,operator:0,order:0,orient:0,orientation:0,origin:0,overflow:0,overlinePosition:"overline-position",overlineThickness:"overline-thickness",paintOrder:"paint-order",panose1:"panose-1",pathLength:"pathLength",patternContentUnits:"patternContentUnits",patternTransform:"patternTransform",patternUnits:"patternUnits",pointerEvents:"pointer-events",points:0,pointsAtX:"pointsAtX",pointsAtY:"pointsAtY",pointsAtZ:"pointsAtZ",preserveAlpha:"preserveAlpha",preserveAspectRatio:"preserveAspectRatio",primitiveUnits:"primitiveUnits",r:0,radius:0,refX:"refX",refY:"refY",renderingIntent:"rendering-intent",repeatCount:"repeatCount",repeatDur:"repeatDur",requiredExtensions:"requiredExtensions",requiredFeatures:"requiredFeatures",restart:0,result:0,rotate:0,rx:0,ry:0,scale:0,seed:0,shapeRendering:"shape-rendering",slope:0,spacing:0,specularConstant:"specularConstant",specularExponent:"specularExponent",speed:0,spreadMethod:"spreadMethod",startOffset:"startOffset",stdDeviation:"stdDeviation",stemh:0,stemv:0,stitchTiles:"stitchTiles",stopColor:"stop-color",stopOpacity:"stop-opacity",strikethroughPosition:"strikethrough-position",strikethroughThickness:"strikethrough-thickness",string:0,stroke:0,strokeDasharray:"stroke-dasharray",strokeDashoffset:"stroke-dashoffset",strokeLinecap:"stroke-linecap",strokeLinejoin:"stroke-linejoin",strokeMiterlimit:"stroke-miterlimit",strokeOpacity:"stroke-opacity",strokeWidth:"stroke-width",surfaceScale:"surfaceScale",systemLanguage:"systemLanguage",tableValues:"tableValues",targetX:"targetX",targetY:"targetY",textAnchor:"text-anchor",textDecoration:"text-decoration",textRendering:"text-rendering",textLength:"textLength",to:0,transform:0,u1:0,u2:0,underlinePosition:"underline-position",underlineThickness:"underline-thickness",unicode:0,unicodeBidi:"unicode-bidi",unicodeRange:"unicode-range",unitsPerEm:"units-per-em",vAlphabetic:"v-alphabetic",vHanging:"v-hanging",vIdeographic:"v-ideographic",vMathematical:"v-mathematical",values:0,vectorEffect:"vector-effect",version:0,vertAdvY:"vert-adv-y",vertOriginX:"vert-origin-x",vertOriginY:"vert-origin-y",viewBox:"viewBox",viewTarget:"viewTarget",visibility:0,widths:0,wordSpacing:"word-spacing",writingMode:"writing-mode",x:0,xHeight:"x-height",x1:0,x2:0,xChannelSelector:"xChannelSelector",xlinkActuate:"xlink:actuate",xlinkArcrole:"xlink:arcrole",xlinkHref:"xlink:href",xlinkRole:"xlink:role",xlinkShow:"xlink:show",xlinkTitle:"xlink:title",xlinkType:"xlink:type",xmlBase:"xml:base",xmlns:0,xmlnsXlink:"xmlns:xlink",xmlLang:"xml:lang",xmlSpace:"xml:space",y:0,y1:0,y2:0,yChannelSelector:"yChannelSelector",z:0,zoomAndPan:"zoomAndPan"},r={Properties:{},DOMAttributeNamespaces:{xlinkActuate:n.xlink,xlinkArcrole:n.xlink,xlinkHref:n.xlink,xlinkRole:n.xlink,xlinkShow:n.xlink,xlinkTitle:n.xlink,xlinkType:n.xlink,xmlBase:n.xml,xmlLang:n.xml,xmlSpace:n.xml},DOMAttributeNames:{}};Object.keys(i).forEach(function(e){r.Properties[e]=0,i[e]&&(r.DOMAttributeNames[e]=i[e])}),e.exports=r},function(e,t,n){"use strict";function i(e){if("selectionStart"in e&&l.hasSelectionCapabilities(e))return{start:e.selectionStart,end:e.selectionEnd};if(window.getSelection){var t=window.getSelection();return{anchorNode:t.anchorNode,anchorOffset:t.anchorOffset,focusNode:t.focusNode,focusOffset:t.focusOffset}}if(document.selection){var n=document.selection.createRange();return{parentElement:n.parentElement(),text:n.text,top:n.boundingTop,left:n.boundingLeft}}}function r(e,t){if(v||null==f||f!==u())return null;var n=i(f);if(!b||!p(b,n)){b=n;var r=c.getPooled(m.select,g,e,t);return r.type="select",r.target=f,o.accumulateTwoPhaseDispatches(r),r}return null}var o=n(67),s=n(74),a=n(60),l=n(168),c=n(79),u=n(174),d=n(93),p=n(144),h=s.canUseDOM&&"documentMode"in document&&document.documentMode<=11,m={select:{phasedRegistrationNames:{bubbled:"onSelect",captured:"onSelectCapture"},dependencies:["topBlur","topContextMenu","topFocus","topKeyDown","topKeyUp","topMouseDown","topMouseUp","topSelectionChange"]}},f=null,g=null,b=null,v=!1,y=!1,S={eventTypes:m,extractEvents:function(e,t,n,i){if(!y)return null;var o=t?a.getNodeFromInstance(t):window;switch(e){case"topFocus":(d(o)||"true"===o.contentEditable)&&(f=o,g=t,b=null);break;case"topBlur":f=null,g=null,b=null;break;case"topMouseDown":v=!0;break;case"topContextMenu":case"topMouseUp":return v=!1,r(n,i);case"topSelectionChange":if(h)break;case"topKeyDown":case"topKeyUp":return r(n,i)}return null},didPutListener:function(e,t,n){"onSelect"===t&&(y=!0)}};e.exports=S},function(e,t,n){"use strict";function i(e){return"."+e._rootNodeID}function r(e){return"button"===e||"input"===e||"select"===e||"textarea"===e}var o=n(61),s=n(164),a=n(67),l=n(60),c=n(178),u=n(179),d=n(79),p=n(180),h=n(181),m=n(96),f=n(184),g=n(185),b=n(186),v=n(97),y=n(187),S=n(35),w=n(182),E=(n(38),{}),C={};["abort","animationEnd","animationIteration","animationStart","blur","canPlay","canPlayThrough","click","contextMenu","copy","cut","doubleClick","drag","dragEnd","dragEnter","dragExit","dragLeave","dragOver","dragStart","drop","durationChange","emptied","encrypted","ended","error","focus","input","invalid","keyDown","keyPress","keyUp","load","loadedData","loadedMetadata","loadStart","mouseDown","mouseMove","mouseOut","mouseOver","mouseUp","paste","pause","play","playing","progress","rateChange","reset","scroll","seeked","seeking","stalled","submit","suspend","timeUpdate","touchCancel","touchEnd","touchMove","touchStart","transitionEnd","volumeChange","waiting","wheel"].forEach(function(e){var t=e[0].toUpperCase()+e.slice(1),n="on"+t,i="top"+t,r={phasedRegistrationNames:{bubbled:n,captured:n+"Capture"},dependencies:[i]};E[e]=r,C[i]=r});var T={},x={eventTypes:E,extractEvents:function(e,t,n,i){var r=C[e];if(!r)return null;var s;switch(e){case"topAbort":case"topCanPlay":case"topCanPlayThrough":case"topDurationChange":case"topEmptied":case"topEncrypted":case"topEnded":case"topError":case"topInput":case"topInvalid":case"topLoad":case"topLoadedData":case"topLoadedMetadata":case"topLoadStart":case"topPause":case"topPlay":case"topPlaying":case"topProgress":case"topRateChange":case"topReset":case"topSeeked":case"topSeeking":case"topStalled":case"topSubmit":case"topSuspend":case"topTimeUpdate":case"topVolumeChange":case"topWaiting":s=d;break;case"topKeyPress":if(0===w(n))return null;case"topKeyDown":case"topKeyUp":s=h;break;case"topBlur":case"topFocus":s=p;break;case"topClick":if(2===n.button)return null;case"topDoubleClick":case"topMouseDown":case"topMouseMove":case"topMouseUp":case"topMouseOut":case"topMouseOver":case"topContextMenu":s=m;break;case"topDrag":case"topDragEnd":case"topDragEnter":case"topDragExit":case"topDragLeave":case"topDragOver":case"topDragStart":case"topDrop":s=f;break;case"topTouchCancel":case"topTouchEnd":case"topTouchMove":case"topTouchStart":s=g;break;case"topAnimationEnd":case"topAnimationIteration":case"topAnimationStart":s=c;break;case"topTransitionEnd":s=b;break;case"topScroll":s=v;break;case"topWheel":s=y;break;case"topCopy":case"topCut":case"topPaste":s=u}s?void 0:o("86",e);var l=s.getPooled(r,t,n,i);return a.accumulateTwoPhaseDispatches(l),l},didPutListener:function(e,t,n){if("onClick"===t&&!r(e._tag)){var o=i(e),a=l.getNodeFromInstance(e);T[o]||(T[o]=s.listen(a,"click",S))}},willDeleteListener:function(e,t){if("onClick"===t&&!r(e._tag)){var n=i(e);T[n].remove(),delete T[n]}}};e.exports=x},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(79),o={animationName:null,elapsedTime:null,pseudoElement:null};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(79),o={clipboardData:function(e){return"clipboardData"in e?e.clipboardData:window.clipboardData}};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(97),o={relatedTarget:null};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(97),o=n(182),s=n(183),a=n(99),l={key:s,location:null,ctrlKey:null,shiftKey:null,altKey:null,metaKey:null,repeat:null,locale:null,getModifierState:a,charCode:function(e){return"keypress"===e.type?o(e):0},keyCode:function(e){return"keydown"===e.type||"keyup"===e.type?e.keyCode:0},which:function(e){return"keypress"===e.type?o(e):"keydown"===e.type||"keyup"===e.type?e.keyCode:0}};r.augmentClass(i,l),e.exports=i},function(e,t){"use strict";function n(e){var t,n=e.keyCode;return"charCode"in e?(t=e.charCode,0===t&&13===n&&(t=13)):t=n,t>=32||13===t?t:0}e.exports=n},function(e,t,n){"use strict";function i(e){if(e.key){var t=o[e.key]||e.key;if("Unidentified"!==t)return t}if("keypress"===e.type){var n=r(e);return 13===n?"Enter":String.fromCharCode(n)}return"keydown"===e.type||"keyup"===e.type?s[e.keyCode]||"Unidentified":""}var r=n(182),o={Esc:"Escape",Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},s={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"};e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(96),o={dataTransfer:null};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(97),o=n(99),s={touches:null,targetTouches:null,changedTouches:null,altKey:null,metaKey:null,ctrlKey:null,shiftKey:null,getModifierState:o};r.augmentClass(i,s),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(79),o={propertyName:null,elapsedTime:null,pseudoElement:null};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t,n,i){return r.call(this,e,t,n,i)}var r=n(96),o={deltaX:function(e){return"deltaX"in e?e.deltaX:"wheelDeltaX"in e?-e.wheelDeltaX:0},deltaY:function(e){return"deltaY"in e?e.deltaY:"wheelDeltaY"in e?-e.wheelDeltaY:"wheelDelta"in e?-e.wheelDelta:0},deltaZ:null,deltaMode:null};r.augmentClass(i,o),e.exports=i},function(e,t,n){"use strict";function i(e,t){for(var n=Math.min(e.length,t.length),i=0;i<n;i++)if(e.charAt(i)!==t.charAt(i))return i;return e.length===t.length?-1:n}function r(e){return e?e.nodeType===D?e.documentElement:e.firstChild:null}function o(e){return e.getAttribute&&e.getAttribute(O)||""}function s(e,t,n,i,r){var o;if(w.logTopLevelRenders){var s=e._currentElement.props.child,a=s.type;o="React mount: "+("string"==typeof a?a:a.displayName||a.name),console.time(o)}var l=T.mountComponent(e,n,null,y(e,t),r,0);o&&console.timeEnd(o),e._renderedComponent._topLevelWrapper=e,U._mountImageIntoNode(l,t,e,i,n)}function a(e,t,n,i){var r=_.ReactReconcileTransaction.getPooled(!n&&S.useCreateElement);r.perform(s,null,e,t,r,n,i),_.ReactReconcileTransaction.release(r)}function l(e,t,n){for(T.unmountComponent(e,n),t.nodeType===D&&(t=t.documentElement);t.lastChild;)t.removeChild(t.lastChild)}function c(e){var t=r(e);if(t){var n=v.getInstanceFromNode(t);return!(!n||!n._hostParent)}}function u(e){return!(!e||e.nodeType!==R&&e.nodeType!==D&&e.nodeType!==N)}function d(e){var t=r(e),n=t&&v.getInstanceFromNode(t);return n&&!n._hostParent?n:null}function p(e){var t=d(e);return t?t._hostContainerInfo._topLevelWrapper:null}var h=n(61),m=n(103),f=n(62),g=n(29),b=n(127),v=(n(43),n(60)),y=n(189),S=n(190),w=n(84),E=n(138),C=(n(88),n(191)),T=n(85),x=n(157),_=n(82),k=n(37),M=n(141),A=(n(38),n(105)),P=n(145),O=(n(34),f.ID_ATTRIBUTE_NAME),I=f.ROOT_ATTRIBUTE_NAME,R=1,D=9,N=11,L={},B=1,G=function(){this.rootID=B++};G.prototype.isReactComponent={},G.prototype.render=function(){return this.props.child},G.isReactTopLevelWrapper=!0;var U={TopLevelWrapper:G,_instancesByReactRootID:L,scrollMonitor:function(e,t){t()},_updateRootComponent:function(e,t,n,i,r){return U.scrollMonitor(i,function(){x.enqueueElementInternal(e,t,n),r&&x.enqueueCallbackInternal(e,r)}),e},_renderNewRootComponent:function(e,t,n,i){u(t)?void 0:h("37"),b.ensureScrollValueMonitoring();var r=M(e,!1);_.batchedUpdates(a,r,t,n,i);var o=r._instance.rootID;return L[o]=r,r},renderSubtreeIntoContainer:function(e,t,n,i){return null!=e&&E.has(e)?void 0:h("38"),U._renderSubtreeIntoContainer(e,t,n,i)},_renderSubtreeIntoContainer:function(e,t,n,i){x.validateCallback(i,"ReactDOM.render"),g.isValidElement(t)?void 0:h("39","string"==typeof t?" Instead of passing a string like 'div', pass React.createElement('div') or <div />.":"function"==typeof t?" Instead of passing a class like Foo, pass React.createElement(Foo) or <Foo />.":null!=t&&void 0!==t.props?" This may be caused by unintentionally loading two independent copies of React.":"");var s,a=g.createElement(G,{child:t});if(e){var l=E.get(e);s=l._processChildContext(l._context)}else s=k;var u=p(n);if(u){var d=u._currentElement,m=d.props.child;if(P(m,t)){var f=u._renderedComponent.getPublicInstance(),b=i&&function(){i.call(f)};return U._updateRootComponent(u,a,s,n,b),f}U.unmountComponentAtNode(n)}var v=r(n),y=v&&!!o(v),S=c(n),w=y&&!u&&!S,C=U._renderNewRootComponent(a,n,w,s)._renderedComponent.getPublicInstance();return i&&i.call(C),C},render:function(e,t,n){return U._renderSubtreeIntoContainer(null,e,t,n)},unmountComponentAtNode:function(e){u(e)?void 0:h("40");var t=p(e);if(!t){c(e),1===e.nodeType&&e.hasAttribute(I);return!1}return delete L[t._instance.rootID],_.batchedUpdates(l,t,e,!1),!0},_mountImageIntoNode:function(e,t,n,o,s){if(u(t)?void 0:h("41"),o){var a=r(t);if(C.canReuseMarkup(e,a))return void v.precacheNode(n,a);var l=a.getAttribute(C.CHECKSUM_ATTR_NAME);a.removeAttribute(C.CHECKSUM_ATTR_NAME);var c=a.outerHTML;a.setAttribute(C.CHECKSUM_ATTR_NAME,l);var d=e,p=i(d,c),f=" (client) "+d.substring(p-20,p+20)+"\n (server) "+c.substring(p-20,p+20);t.nodeType===D?h("42",f):void 0}if(t.nodeType===D?h("43"):void 0,s.useCreateElement){for(;t.lastChild;)t.removeChild(t.lastChild);m.insertTreeBefore(t,e,null)}else A(t,e),v.precacheNode(n,t.firstChild)}};e.exports=U},function(e,t,n){"use strict";function i(e,t){var n={_topLevelWrapper:e,_idCounter:1,_ownerDocument:t?t.nodeType===r?t:t.ownerDocument:null,_node:t,_tag:t?t.nodeName.toLowerCase():null,_namespaceURI:t?t.namespaceURI:null};return n}var r=(n(158),9);e.exports=i},function(e,t){"use strict";var n={useCreateElement:!0,useFiber:!1};e.exports=n},function(e,t,n){"use strict";var i=n(192),r=/\/?>/,o=/^<\!\-\-/,s={CHECKSUM_ATTR_NAME:"data-react-checksum",addChecksumToMarkup:function(e){var t=i(e);return o.test(e)?e:e.replace(r," "+s.CHECKSUM_ATTR_NAME+'="'+t+'"$&')},canReuseMarkup:function(e,t){var n=t.getAttribute(s.CHECKSUM_ATTR_NAME);n=n&&parseInt(n,10);var r=i(e);return r===n}};e.exports=s},function(e,t){"use strict";function n(e){for(var t=1,n=0,r=0,o=e.length,s=o&-4;r<s;){for(var a=Math.min(r+4096,s);r<a;r+=4)n+=(t+=e.charCodeAt(r))+(t+=e.charCodeAt(r+1))+(t+=e.charCodeAt(r+2))+(t+=e.charCodeAt(r+3));t%=i,n%=i}for(;r<o;r++)n+=t+=e.charCodeAt(r);return t%=i,n%=i,t|n<<16}var i=65521;e.exports=n},function(e,t){"use strict";e.exports="15.6.2"},function(e,t,n){"use strict";function i(e){if(null==e)return null;if(1===e.nodeType)return e;var t=s.get(e);return t?(t=a(t),t?o.getNodeFromInstance(t):null):void("function"==typeof e.render?r("44"):r("45",Object.keys(e)))}var r=n(61),o=(n(43),n(60)),s=n(138),a=n(195);n(38),n(34);e.exports=i},function(e,t,n){"use strict";function i(e){for(var t;(t=e._renderedNodeType)===r.COMPOSITE;)e=e._renderedComponent;return t===r.HOST?e._renderedComponent:t===r.EMPTY?null:void 0}var r=n(143);e.exports=i},function(e,t,n){"use strict";var i=n(188);e.exports=i.renderSubtreeIntoContainer},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(198),s=n(202),a=n(304),l=n(305),c=n(307),u=n(308),d=n(306),p=n(200),h=n(277);n(309);var m,f=n(206),g=n(201);m=n(234);var b=new m(window.navigator.userAgent),v=function(e){function t(){var t=this;e.call(this),this._leaderboardInfoFetched=!1,this._embedNavOptions={},this.state={playerData:{},playScore:0,embedStart:!0,showLeaderboard:!1,enableNav:!0,enableChat:!0,enableleaderBoard:!0,enableShareScreen:!0,firstChatRender:!1,firstShareRender:!1,leaderboardInfoFetched:!1,showUsername:!1,currentContent:"trivia",showLogIn:!1,
leaderBoardData:null,showShareScreen:!1,showIssueReport:!1,showChat:!1,showOptions:!1,config:{userImageRootPath:"https://djswp52cxqmyt.cloudfront.net/public/images/user/"},embedController:{getFirstChatRender:function(){return t.state.firstChatRender},getFirstShareRender:function(){return t.state.firstShareRender},getLeaderboardInfoFetched:function(){return t.state.leaderboardInfoFetched},fetchLeaderBoardInfo:function(){t._fetchLeaderBoardInfo(),t.setState({leaderboardInfoFetched:!0})}}}}return i(t,e),t.prototype.getChildContext=function(){return{embedSettings:this.props.embedSettings}},t.prototype.componentWillMount=function(){this.keenUtil=new f.default(this.props.embedSettings),(this.props.embedSettings.embedSetting.showDisplay||this.props.embedSettings.embedSetting.showDisplay2)&&this.props.embedSettings.refreshAds();var e=!1,t=!1,n=!1;this.props.embedSettings.embedSetting.showChatting&&(e=!0),this.props.embedSettings.embedSetting.showLeaderboard&&(n=!0),this.props.embedSettings.embedSetting.showSocialShare&&(t=!0),this.setState({enableChat:e,enableShareScreen:t,enableleaderBoard:n}),this._generateNewUser(),this._featuresCheck(),this._setNavOptions()},t.prototype.componentDidMount=function(){},t.prototype._setNavOptions=function(){this.props.embedSettings.embedSetting.showLeaderboard===!0&&(this._embedNavOptions.Leaderboard=this.showOptionScreen.bind(this,"leaderBoard","")),this.props.embedSettings.embedSetting.showChatting===!0&&(this._embedNavOptions.Chat=this.showOptionScreen.bind(this,"chat","")),this.props.embedSettings.embedSetting.showSocialShare===!0&&(this._embedNavOptions.Share=this.showOptionScreen.bind(this,"share","")),0===Object.keys(this._embedNavOptions).length&&this._embedNavOptions.constructor===Object&&this.setState({enableNav:!1})},t.prototype._turnNavOff=function(){this.setState({enableNav:!1})},t.prototype._turnNavOn=function(){0===Object.keys(this._embedNavOptions).length&&this._embedNavOptions.constructor===Object?this.setState({enableNav:!1}):this.setState({enableNav:!0})},t.prototype._showOptions=function(){var e=this.state.showOptions;!this.state.leaderboardInfoFetched&&this.props.embedSettings.embedSetting.showLeaderboard?(this._fetchLeaderBoardInfo(),this.setState({showOptions:!e,leaderboardInfoFetched:!0})):this.setState({showOptions:!e})},t.prototype._hideOptions=function(){1==this.state.showOptions&&this.setState({showOptions:!1})},t.prototype._featuresCheck=function(){this.props.embedSettings.showLeaderboard===!1&&this.setState({enableleaderBoard:!1}),this.props.embedSettings.showChatting===!1&&this.setState({enableChat:!1}),this.props.embedSettings.showSocialShare===!1&&this.setState({enableShareScreen:!1})},t.prototype.render=function(){var e,t=this,n={chatScreen:{showChat:this._showChat.bind(this),isActive:this.state.showChat},shareScreen:{showShareScreen:this._showShareScreen.bind(this),isActive:this.state.showShareScreen},leaderBoard:{showLeaderboard:this._showLeaderboard.bind(this),isActive:this.state.showLeaderboard},showOptionScreen:function(e,n){t.showOptionScreen(e,n)},disableAllOptionScreens:function(){t.disableAllOptionScreens()},optionActive:this.state.showChat||this.state.showShareScreen||this.state.showLeaderboard||this.state.showIssueReport};"trivia"==this.state.currentContent&&(e=r.createElement(s.default,{playerData:this.state.playerData,indexManager:this.props.indexManager,embedStart:this.state.embedStart,embedSettings:this.props.embedSettings,embedOptions:n,embedController:this.state.embedController,setEmbedStartFalse:this._setEmbedStartFalse.bind(this),setEmbedStartTrue:this._setEmbedStartTrue.bind(this),turnNavOn:this._turnNavOn.bind(this),turnNavOff:this._turnNavOff.bind(this)}));var i;this.state.enableNav&&(i=r.createElement(a.default,{options:this._embedNavOptions,showOptions:this._showOptions.bind(this),hideOptions:this._hideOptions.bind(this),showOptionsStatus:this.state.showOptions,embedOptions:n,embedSettings:this.props.embedSettings,disableAllOptionScreens:this.disableAllOptionScreens.bind(this)}));var p,h,m=r.createElement(d.default,{embedSettings:this.props.embedSettings}),f={backgroundImage:"url("+this.props.embedSettings.embedSetting.brandLogoURL+")"};this.props.embedSettings.embedSetting.logoClickThroughURL?f.cursor="pointer":null;var g=function(e){return!!t.props.embedSettings.embedSetting.logoClickThroughURL&&void window.open(t.props.embedSettings.embedSetting.logoClickThroughURL)};if(this.props.embedSettings.embedSetting.showHeaderLogo){var v=this.props.embedSettings.embedStyleSetting.maxHeightMobile,y=this.props.embedSettings.embedStyleSetting.maxHeightDesktop,S=45,w="350px";w=b.mobile()?v<350?350-S+"px":1200===v||350===v?350-S-4+"px":v-S-4+"px":y<350?350-S+"px":1200===y||350===y?350-S-4+"px":y-S-4+"px",h={height:w},p=r.createElement("div",{id:"companyLogo"},r.createElement("div",{className:"company-logo",style:f,onClick:g}))}var E;this.state.enableleaderBoard&&(E=r.createElement(l.default,{embedController:this.state.embedController,leaderboardResult:this.state.leaderBoardData,showLeaderBoard:this.state.showLeaderboard,config:this.state.config,changeShowLeaderBoard:this.showOptionScreen.bind(this,"leaderBoard","")}));var C;this.state.enableShareScreen&&(C=r.createElement(c.default,{showShareScreen:this.state.showShareScreen,embedOptions:n,changeShowShareScreen:this.showOptionScreen.bind(this,"share",""),embedController:this.state.embedController}));var T;this.state.enableChat&&(T=r.createElement(o.default,{embedOptions:n,showChat:this.state.showChat,chatChannel:this.props.embedSettings.embedSetting.chattingTitle,playerData:this.state.playerData,changeShowChat:this.showOptionScreen.bind(this,"chat",""),embedController:this.state.embedController}));var x;return x=r.createElement(u.default,{embedSettings:this.props.embedSettings,changeShowIssue:this.showOptionScreen.bind(this,"issue",""),showIssueReport:this.state.showIssueReport}),r.createElement("div",null,p,r.createElement("div",{id:"insticatorEmbed",style:h},r.createElement("link",{href:"https://fonts.googleapis.com/css?family=Source+Sans+Pro:400,400i,600,600i%7CMontserrat:400,700",rel:"stylesheet"}),i,r.createElement("div",{id:"embedContent",onClick:this._hideOptions.bind(this)},e,E,T,C,m)))},t.prototype._setEmbedStartTrue=function(){this.setState({embedStart:!0})},t.prototype._setEmbedStartFalse=function(){this.setState({embedStart:!1})},t.prototype._fetchUserInfo=function(){var e=this,t=new XMLHttpRequest;t.onreadystatechange=function(){4==t.readyState&&200==t.status&&e.setState({playerData:JSON.parse(t.responseText)})},t.open("GET","../JSON/user.json",!0),t.send()},t.prototype._fillLeaderboardData=function(e){for(var t=new p.default(this.props.embedSettings),n=17-e.length,i=0;i<n;i++){var r=t._generateRandomName(),o=Math.floor(2e4*Math.random()),s=Math.floor(100*Math.random()),a={userUUID:"extra-created-user",userName:r,userPoints:o,userRanking:s,properties:{}};e.push(a)}return e},t.prototype._fetchLeaderBoardInfo=function(){var e="insticatorLeaderBoardResults",t=this.props.embedSettings.parentWindow.document.getElementsByTagName("head")[0];this.props.embedSettings.parentWindow.document.createElement("script");this.props.embedSettings.parentWindow.fetchLeaderBoardInfo=function(t){this.props.embedSettings.logger("leaderboardData callback with data: "+JSON.stringify(t));var n=[],i=t,r=i.rankerList;for(var o in r)n.push(r[o]);if(n.length<15){var s=this._fillLeaderboardData(n);n=s}return this.props.embedSettings.logger("leaderboardData formatted after: "+n),window[e]=n,n}.bind(this);var n=this.props.embedSettings.parentWindow.document.createElement("script");n.src=g.apiBaseUrl+"/tvshow/getleaderboard?tvshowUUID="+this.props.embedSettings.tvshowUUID+"&callback=fetchLeaderBoardInfo",this.props.embedSettings.logger("leaderboardData.src: "+n.src),window[e]=null,t.appendChild(n),this.setState({leaderBoardData:e})},t.prototype._generateRandomImage=function(){var e=Math.floor(6*Math.random()),t="https://d2na2p72vtqyok.cloudfront.net/files/images/icon_"+e+".jpg";return t},t.prototype._generateNewUser=function(){var e,t=new h.default(this.props.embedSettings),n=t.generateRandomImgURL();e={uid:"",name:"You",avatar:n,score:0},this.setState({playerData:e})},t.prototype.disableAllOptionScreens=function(){if(this.props.embedSettings.embedSetting.showAdOnShortWidget){var e=this.props.embedSettings.document.getElementById("widgetNav");e&&(e.style.display="none")}this.setState({showChat:!1,showShareScreen:!1,showLeaderboard:!1,showIssueReport:!1})},t.prototype.showOptionScreen=function(e,t){var n=this.props.embedSettings.embedSetting.showOverlay;if(n||this.props.embedSettings.refreshAds(),this.props.embedSettings.embedSetting.showAdOnShortWidget){var i=this.props.embedSettings.document.getElementById("widgetNav");i&&(i.style.display="block")}"leaderBoard"===e?(this.keenUtil.addClickEvent(t,"SHOW LEADERBOARD",null),this.setState({showChat:!1,showShareScreen:!1,showLeaderboard:!this.state.showLeaderboard})):"chat"===e?(this.keenUtil.addClickEvent(t,"SHOW CHAT",null),this.setState({showLeaderboard:!1,showShareScreen:!1,showChat:!this.state.showChat,firstChatRender:!0})):"share"===e?(this.keenUtil.addClickEvent(t,"SHOW SHARE",null),this.setState({showChat:!1,showLeaderboard:!1,showShareScreen:!this.state.showShareScreen,firstShareRender:!0})):"issue"===e&&(this.keenUtil.addClickEvent(t,"SHOW ISSUE",null),this.setState({showChat:!1,showLeaderboard:!1,showShareScreen:!1,showIssueReport:!this.state.showIssueReport}))},t.prototype._showLeaderboard=function(){this.showOptionScreen("leaderBoard","")},t.prototype._showShareScreen=function(){this.showOptionScreen("share","")},t.prototype._showChat=function(){this.showOptionScreen("chat","")},t.contextTypes={embedSettings:r.PropTypes.object},t.childContextTypes={embedSettings:r.PropTypes.object},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=v},function(e,t,n){"use strict";var i,r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28),s=n(199),a=n(200),l="You",c=(Math.floor(6*Math.random()),n(201)),u=function(e){function t(){var t=this;e.call(this),this._previousMessage="",this.chatScreenActive=!1,this._firstRender=!1,this.state={text:"",usersInChat:[],chatHistory:[],msgSent:!1,showChat:!0,showUserList:!1,chatScreen:"",userListManager:{toggleShowUserList:function(){var e=t.state.showUserList;t.setState({showUserList:!e})}}}}return r(t,e),t.prototype.componentWillUpdate=function(e,t){!e.showChat&&this.chatScreenActive?(this.chatScreenActive=!1,this.removeFirebaseListeners()):e.showChat&&!this.chatScreenActive&&this.chatInitalized&&(this.chatScreenActive=!0,this._firstRender=!0,this.resetFirebaseListeners()),this._firstRender&&!this.chatInitalized&&e.showChat&&(this.chatInitalized=!0,this.initFirebaseApi(),this.resetFirebaseListeners()),!e.showChat&&this.state.showUserList&&this.setState({showUserList:!1})},t.prototype.componentWillUnmount=function(){this.removeFirebaseListeners()},t.prototype.componentWillMount=function(){this.siteUUID=this.context.embedSettings.siteUUID,this._firstRender=!0,this.RandomNames=new a.default(this.context.embedSettings),l=this.RandomNames._generateRandomName()},t.prototype.componentDidUpdate=function(e,t){var n=this.context.embedSettings.document.getElementById("msgList");n.scrollTop=n.scrollHeight,this.props.showChat},t.prototype.initChat=function(){},t.prototype.initFirebaseApi=function(){this.firebaseApp=i.initializeApp({apiKey:c.API_KEYS.FIREBASE_API_KEY,authDomain:c.API_KEYS.FIREBASE_AUTH_DOMAIN,databaseURL:c.API_KEYS.FIREBASE_DATABASE_URL,storageBucket:c.API_KEYS.FIREBASE_STORAGE_BUCKET,messagingSenderId:c.API_KEYS.FIREBASE_MESSAGING_SENDER_ID}),this.firebaseDatabase=this.firebaseApp.database()},t.prototype.displayInitialMessageList=function(){var e=this,t=this.firebaseDatabase.ref("/channel/"+this.siteUUID+"/messages");t.limitToLast(10).on("value",function(n){var i=n.val(),r=e.state.chatHistory;for(var o in i)r.push({text:i[o].text,uuid:i[o].username});e.setState({chatHistory:r}),t.off(),e.addMessageListener()})},t.prototype.addActiveUserListener=function(){this.activeUserListener=this.firebaseDatabase.ref("/channel/"+this.siteUUID+"/activeUsers"),this.activeUserListener.on("value",function(e){})},t.prototype.addMessageListener=function(){var e=this;this.messageListener=this.firebaseDatabase.ref("/channel/"+this.siteUUID+"/messages"),this.messageListener.limitToLast(1).on("value",function(t,n){if(e._firstRender)e._firstRender=!1;else{var i=t.val();i=i[Object.keys(i)[0]],e.updateMessageListInDOM({text:i.text,uuid:i.username})}n&&e.context.embedSettings.logger("firebase error: "+n)})},t.prototype.addFirebaseMessage=function(e){var t=this.firebaseDatabase.ref().child("messages").push().key,n={};n["/channel/"+this.siteUUID+"/messages/"+t]={username:l,text:e},this.firebaseDatabase.ref().update(n)},t.prototype.updateMessageListInDOM=function(e){var t=this.state.chatHistory;t.push(e),this.setState({chatHistory:t})},t.prototype.removeFirebaseListeners=function(){this.messageListener&&this.messageListener.off(),this.setState({chatHistory:[]})},t.prototype.resetFirebaseListeners=function(){this.displayInitialMessageList()},t.prototype.handleTextChange=function(e){this.setState({text:e.target.value})},t.prototype.filterMsg=function(e){var t=e;t=e.toLowerCase();var n=t.split(" "),i=e.split(" ");for(var r in n)1===s.default[n[r]]&&(i[r]="***");return i.join(" ")},t.prototype.checkMessage=function(){return""!==this.state.text&&""!==this.state.text.trim()},t.prototype.sendMessage=function(e){if(e.preventDefault(),this.checkMessage()){var t=this.filterMsg(this.state.text);""!==this.state.text&&""!==this.state.text.trim()&&this.addFirebaseMessage(t)}this.setState({text:""})},t.prototype.closeChatScreen=function(){this.removeFirebaseListeners(),!this.state.showUserList==!0&&this.props.changeShowChat()},t.prototype.render=function(){var e,t=this,n=!0,i={},r=this.state.chatHistory;e=r.map(function(e,r){return 0===r?i=n?{justifyContent:"flex-start",clear:"both"}:{justifyContent:"flex-end",clear:"right"}:r<t.state.chatHistory.length+1&&(t.state.chatHistory[r].uuid===t.state.chatHistory[r-1].uuid?i=n?{justifyContent:"flex-start",clear:"both"}:{justifyContent:"flex-end",clear:"right"}:(n=!n,i=n?{justifyContent:"flex-start",clear:"both"}:{justifyContent:"flex-end",clear:"left"})),n?o.createElement("div",{key:r,className:"messageContainer"},o.createElement("div",{className:"usernameContainer"},o.createElement("span",{className:"usernameInChat"},e.uuid," ")),o.createElement("div",{className:"messageContainer",style:i},o.createElement("li",{className:"message",key:r},e.text))):o.createElement("div",{key:r,className:"messageContainer"},o.createElement("div",{className:"messageContainer",style:i},o.createElement("li",{className:"message",key:r},e.text)),o.createElement("div",{className:"usernameContainer"},o.createElement("span",{className:"usernameInChat"},e.uuid," ")))});var s="";this.props.showChat===!0&&(s="slideInLeft");var a;return a=this.context.embedSettings.embedSetting.chattingTitle?this.context.embedSettings.embedSetting.chattingTitle:"Chat",o.createElement("div",null,o.createElement("div",{id:"chatSlider",className:"chatSlider "+s},o.createElement("div",{className:"topContainer"},o.createElement("div",{className:"mainTextContainer"},o.createElement("h2",null,o.createElement("span",null,a)))),o.createElement("div",{className:"chatContainer"},o.createElement("div",{id:"msgList",className:"msgList"},o.createElement("ul",null,e))),o.createElement("div",{className:"chatInputContainer"},o.createElement("form",{onSubmit:this.sendMessage.bind(this)},o.createElement("input",{id:"chatInputField",tabIndex:-100,className:"chatInputField",value:this.state.text,type:"text",onChange:this.handleTextChange.bind(this),placeholder:"Type here...",autoComplete:"off"})),o.createElement("div",{className:"msgSubmitBtnContainer"},o.createElement("div",{className:"msgSubmitBtn",onClick:this.sendMessage.bind(this)},o.createElement("i",{className:"fa fa-paper-plane","aria-hidden":"true"}))))))},t.contextTypes={embedSettings:o.PropTypes.object.isRequired},t}(o.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=u},function(e,t){"use strict";var n={"4r5e":1,"5h1t":1,"5hit":1,a55:1,anal:1,anus:1,ar5e:1,arrse:1,arse:1,ass:1,"ass-fucker":1,asses:1,assfucker:1,assfukka:1,asshole:1,assholes:1,asswhole:1,a_s_s:1,"b!tch":1,b00bs:1,b17ch:1,b1tch:1,ballbag:1,balls:1,ballsack:1,bastard:1,beastial:1,beastiality:1,bellend:1,bestial:1,bestiality:1,"bi+ch":1,biatch:1,bitch:1,bitcher:1,bitchers:1,bitches:1,bitchin:1,bitching:1,bloody:1,"blow job":1,blowjob:1,blowjobs:1,boiolas:1,bollock:1,bollok:1,boner:1,boob:1,boobs:1,booobs:1,boooobs:1,booooobs:1,booooooobs:1,breasts:1,buceta:1,bugger:1,bum:1,"bunny fucker":1,butt:1,butthole:1,buttmuch:1,buttplug:1,c0ck:1,c0cksucker:1,"carpet muncher":1,cawk:1,chink:1,cipa:1,cl1t:1,clit:1,clitoris:1,clits:1,cnut:1,cock:1,"cock-sucker":1,cockface:1,cockhead:1,cockmunch:1,cockmuncher:1,cocks:1,"cocksuck ":1,"cocksucked ":1,cocksucker:1,cocksucking:1,"cocksucks ":1,cocksuka:1,cocksukka:1,cok:1,cokmuncher:1,coksucka:1,coon:1,cox:1,crap:1,cum:1,cummer:1,cumming:1,cums:1,cumshot:1,cunilingus:1,cunillingus:1,cunnilingus:1,cunt:1,"cuntlick ":1,"cuntlicker ":1,"cuntlicking ":1,cunts:1,cyalis:1,cyberfuc:1,"cyberfuck ":1,"cyberfucked ":1,cyberfucker:1,cyberfuckers:1,"cyberfucking ":1,d1ck:1,damn:1,dick:1,dickhead:1,dildo:1,dildos:1,dink:1,dinks:1,dirsa:1,dlck:1,"dog-fucker":1,doggin:1,dogging:1,donkeyribber:1,doosh:1,duche:1,dyke:1,ejaculate:1,ejaculated:1,"ejaculates ":1,"ejaculating ":1,ejaculatings:1,ejaculation:1,ejakulate:1,"f u c k":1,"f u c k e r":1,f4nny:1,fag:1,fagging:1,faggitt:1,faggot:1,faggs:1,fagot:1,fagots:1,fags:1,fanny:1,fannyflaps:1,fannyfucker:1,fanyy:1,fatass:1,fcuk:1,fcuker:1,fcuking:1,feck:1,fecker:1,felching:1,fellate:1,fellatio:1,"fingerfuck ":1,"fingerfucked ":1,"fingerfucker ":1,fingerfuckers:1,"fingerfucking ":1,"fingerfucks ":1,fistfuck:1,"fistfucked ":1,"fistfucker ":1,"fistfuckers ":1,"fistfucking ":1,"fistfuckings ":1,"fistfucks ":1,flange:1,fook:1,fooker:1,fuck:1,fucka:1,fucked:1,fucker:1,fuckers:1,fuckhead:1,fuckheads:1,fuckin:1,fucking:1,fuckings:1,fuckingshitmotherfucker:1,"fuckme ":1,fucks:1,fuckwhit:1,fuckwit:1,"fudge packer":1,fudgepacker:1,fuk:1,fuker:1,fukker:1,fukkin:1,fuks:1,fukwhit:1,fukwit:1,fux:1,fux0r:1,f_u_c_k:1,gangbang:1,"gangbanged ":1,"gangbangs ":1,gaylord:1,gaysex:1,goatse:1,God:1,"god-dam":1,"god-damned":1,goddamn:1,goddamned:1,"hardcoresex ":1,hell:1,heshe:1,hoar:1,hoare:1,hoer:1,homo:1,hore:1,horniest:1,horny:1,hotsex:1,"jack-off ":1,jackoff:1,jap:1,"jerk-off ":1,jism:1,"jiz ":1,"jizm ":1,jizz:1,kawk:1,knob:1,knobead:1,knobed:1,knobend:1,knobhead:1,knobjocky:1,knobjokey:1,kock:1,kondum:1,kondums:1,kum:1,kummer:1,kumming:1,kums:1,kunilingus:1,"l3i+ch":1,l3itch:1,labia:1,lmfao:1,lust:1,lusting:1,m0f0:1,m0fo:1,m45terbate:1,ma5terb8:1,ma5terbate:1,masochist:1,"master-bate":1,masterb8:1,"masterbat*":1,masterbat3:1,masterbate:1,masterbation:1,masterbations:1,masturbate:1,"mo-fo":1,mof0:1,mofo:1,mothafuck:1,mothafucka:1,mothafuckas:1,mothafuckaz:1,"mothafucked ":1,mothafucker:1,mothafuckers:1,mothafuckin:1,"mothafucking ":1,mothafuckings:1,mothafucks:1,"mother fucker":1,motherfuck:1,motherfucked:1,motherfucker:1,motherfuckers:1,motherfuckin:1,motherfucking:1,motherfuckings:1,motherfuckka:1,motherfucks:1,muff:1,mutha:1,muthafecker:1,muthafuckker:1,muther:1,mutherfucker:1,n1gga:1,n1gger:1,nazi:1,nigg3r:1,nigg4h:1,nigga:1,niggah:1,niggas:1,niggaz:1,nigger:1,"niggers ":1,nob:1,"nob jokey":1,nobhead:1,nobjocky:1,nobjokey:1,numbnuts:1,nutsack:1,"orgasim ":1,"orgasims ":1,orgasm:1,"orgasms ":1,p0rn:1,pawn:1,pecker:1,penis:1,penisfucker:1,phonesex:1,phuck:1,phuk:1,phuked:1,phuking:1,phukked:1,phukking:1,phuks:1,phuq:1,pigfucker:1,pimpis:1,piss:1,pissed:1,pisser:1,pissers:1,"pisses ":1,pissflaps:1,"pissin ":1,pissing:1,"pissoff ":1,poop:1,porn:1,porno:1,pornography:1,pornos:1,prick:1,"pricks ":1,pron:1,pube:1,pusse:1,pussi:1,pussies:1,pussy:1,"pussys ":1,rectum:1,retard:1,rimjaw:1,rimming:1,"s hit":1,"s.o.b.":1,sadist:1,schlong:1,screwing:1,scroat:1,scrote:1,scrotum:1,semen:1,sex:1,"sh!+":1,"sh!t":1,sh1t:1,shag:1,shagger:1,shaggin:1,shagging:1,shemale:1,"shi+":1,shit:1,shitdick:1,shite:1,shited:1,shitey:1,shitfuck:1,shitfull:1,shithead:1,shiting:1,shitings:1,shits:1,shitted:1,shitter:1,"shitters ":1,shitting:1,shittings:1,"shitty ":1,skank:1,slut:1,sluts:1,smegma:1,smut:1,snatch:1,"son-of-a-bitch":1,spac:1,spunk:1,s_h_i_t:1,t1tt1e5:1,t1tties:1,teets:1,teez:1,testical:1,testicle:1,tit:1,titfuck:1,tits:1,titt:1,tittie5:1,tittiefucker:1,titties:1,tittyfuck:1,tittywank:1,titwank:1,tosser:1,turd:1,tw4t:1,twat:1,twathead:1,twatty:1,twunt:1,twunter:1,v14gra:1,v1gra:1,vagina:1,viagra:1,vulva:1,w00se:1,wang:1,wank:1,wanker:1,wanky:1,whoar:1,whore:1,willies:1,willy:1,xrated:1,xxx:1};Object.defineProperty(t,"__esModule",{value:!0}),t.default=n},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o={femaleNames:["Ayla","Dena","Dora","Kari","Zoe","Zuri"],maleNames:["Adan","Ade","Aden","Bob","Cian","Dan","Yves","Zac","Zach"],nameArray:["Smith","Ruth","Thomas","Brian","Dorothy","Sharon"],unisexArray:["Oakley","Jayden","Harper"],animalArray:["Tiger","Scallop"],adjectivesArray:["abandoned","zany","zealous","zesty","zigzag"],miscArray:["1","2","3","4","5","6","7","8","9","!","~","X","x"]},s=function(e){function t(t){e.call(this),this.embedSettings=t}return i(t,e),t.prototype._generateRandomName=function(){function e(e){return e.charAt(0).toUpperCase()+e.slice(1)}var t,n=(o.nameArray,o.unisexArray,o.animalArray,o.adjectivesArray,o.miscArray);switch(this.embedSettings.embedSetting.avatarGender){case"MALE":t=[o.maleNames];break;case"FEMALE":t=[o.femaleNames];break;default:t=[o.maleNames,o.femaleNames]}var i,r=t[Math.floor(Math.random()*t.length)],s=Math.floor(Math.random()*r.length),a=n[Math.floor(Math.random()*n.length)];return i=r[s],i=e(i+a)},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t){e.exports={LOCAL_MODE:!1,widgetVersion:"3.5.4",apiBaseUrl:"https://d3i7o8f6agzkus.cloudfront.net",articlesBaseUrl:"https://d1xfp8dpfmykql.cloudfront.net",imgRootPath:"https://djswp52cxqmyt.cloudfront.net/public/images/prediction/original/",instiPollQuestionImgBaseUrl:"https://djswp52cxqmyt.cloudfront.net/public/images/prediction/original",brandLogoBaseUrl:"https://d2na2p72vtqyok.cloudfront.net/trivia-group-image",insticatorGetDomainLocation:"https://www.insticator.com",insticatorGetUnsecureDomainLocation:"http://www.insticator.com",pingHostName:"https://dashboard.insticator.com",surveysBaseUrl:"https://d2na2p72vtqyok.cloudfront.net/files/",API_KEYS:{KEEN_WRITE_KEY:"0d631ed8b607454290d9b1537c10edc501e507a432cde40d6d8cef4f45a994aa80c60a85820efc3a095e70edcfdad924c1a0179244e97a9bc6b1d7c2358b8183d9eae861dda5c702805fd0eca97a3fa7658244687b3d47530c7bf79801814f37",KEEN_READ_KEY:"88fc63c20731c2f09ea44ca264c3043d5403f78329a42a2b435690e94c39dff5d5ae487052e1d583c2dccf5b64cfc9add1c0cc6bb9a661cc91df4d0e545f8ad0ec1d831981907c44bc4ba7f1b062711aadec6e7549800042076726d73dadc454",KEEN_PROJECT_ID:"56ddffe896773d7e98d63393",KEEN_MASTER_KEY:"0089C9DB7CE81C2C9DA92A9C8384BB305A0109424F750A7AB5192473F84C2E47",FIREBASE_API_KEY:"AIzaSyCllpJATWusJMnsXbeiot142jF6Zfoinhg",FIREBASE_AUTH_DOMAIN:"citric-sprite-868.firebaseapp.com",FIREBASE_DATABASE_URL:"https://citric-sprite-868.firebaseio.com",FIREBASE_STORAGE_BUCKET:"citric-sprite-868.appspot.com",FIREBASE_MESSAGING_SENDER_ID:"232555617922"}}},function(e,t,n){"use strict";var i,r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28),s=n(203),a=n(239),l=n(240),c=n(260),u=n(261),d=n(263),p=n(265),h=n(266),m=n(272),f=n(273),g=n(200),b=n(277),v=n(278),y=n(206),S=n(201),w=n(279),E=S.API_KEYS.KEEN_WRITE_KEY,C=S.API_KEYS.KEEN_READ_KEY,T=S.API_KEYS.KEEN_PROJECT_ID,x=n(245),_=new x({projectId:T,writeKey:E,readKey:C});i=n(234);var k=new i(window.navigator.userAgent),M=function(e){function t(){var t=this;e.call(this),this._enemyScore=0,this._resultScreenActive=!1,this.firstQuestionAnswered=!1,this.totalQuestionsAnswered=0,this.totalQuestionsAnsweredInSet=0,this._pollsQuestionCounter=0,this._maxPollsQuestions=0,this._maxInstiPollQuestions=0,this._articleQuestionCounter=0,this._maxarticles=0,this._firstArticleRender=!1,this._instiPollQuestionCount=0,this._interstitialActive=!1,this._instiPollShown=!1,this._firstDataReceived=!1,this._questionCheckTimePassed=0,this.state={enemyData:{},triviaQuestions:[],valueQuestions:[],pollsQuestions:[],fetchedOnLoadPollsQuestions:[],instiPollQuestions:[],pollsResultData:null,instiPollResultData:null,haveFetchedPollResults:!1,haveFetchedInstiPollResults:!1,articles:[],maxTriviaQuestions:null,maxValueQuestions:null,maxPollsQuestions:null,maxInstiPollQuestions:null,maxArticles:null,currentQuestion:null,currentValueQuestion:null,gameEnd:!1,game:null,gameType:null,gamePaused:!1,showInterstitial:!1,currentGameMode:null,enableTrivia:null,enablePolls:null,gameplay:{},userScore:0,enemyScore:0,gameplayCounter:0,questionCounter:1,triviaQuestionCounter:0,pollsQuestionCounter:0,showGameResults:!1,playAgain:!1,clearBoard:!1,triviaQuestionsReady:!1,valueQuestionsReady:!1,pollsQuestionsReady:!1,instiPollQuestionsReady:!1,articlesReady:!1,resultsShown:!1,articlesFromResultsDone:!1,playFromResults:!1,resetDefaultFromResults:!1,firstGameRender:!0,config:{questionImageRootPath:"https://djswp52cxqmyt.cloudfront.net/"},gameManagerOptions:{setInstiPollShown:function(e){t._instiPollShown=!!e},getInstiPollShown:function(){return t._instiPollShown},setFirstArticleRenderTrue:function(){t._firstArticleRender=!0},getFirstArticleRender:function(){return t._firstArticleRender},showOverlayAd:function(e){return(t.totalQuestionsAnswered+1)%e===0},increaseTotalQuestionsAnswered:function(){t.totalQuestionsAnswered+=1},increaseTotalQuestionsAnsweredInSet:function(){t.totalQuestionsAnsweredInSet+=1},resetTotalQuestionsAnsweredInSet:function(){t.totalQuestionsAnsweredInSet=0},increaseInstiPollQuestionCounter:function(){t._instiPollQuestionCount+=1},resetInstiPollQuestionCounter:function(){t._instiPollQuestionCount=0},getTotalQuestionsAnswered:function(){return t.totalQuestionsAnswered},getTotalQuestionsAnsweredInSet:function(){return t.totalQuestionsAnsweredInSet},setFirstQuestionAnsweredTrue:function(){t.firstQuestionAnswered=!0},getFirstQuestionAnswered:function(){return t.firstQuestionAnswered},setGameStartedTrue:function(){t._gameStarted=!0},getGameStarted:function(){return t._gameStarted},changeGameMode:function(e){var n=e;t.setState({currentGameMode:n})},setGameEndTrue:function(){t._playNext()},playAgain:function(){t._playAgainSettings()},setFirstGameRenderFalse:function(){t.setState({firstGameRender:!1})},firstGameRender:function(){return t.state.firstGameRender},playArticles:function(){t.props.setEmbedStartFalse(),t.state.gameManagerOptions.setgameplayCounter(1e12),t.state.gameManagerOptions.setgameType("articlesMode"),t.state.gameManagerOptions.setGame("articles"),t.state.gameManagerOptions.changeGameMode("articles"),t._playAgainSettings()},setPlayFromResultsTrue:function(e){t.setState({playFromResults:!0})},setPlayFromResultsFalse:function(){t.setState({showGameResults:!0,playFromResults:!1,playFromResultsGM:null})},playFromResults:function(){return t.state.playFromResults},restartGame:function(){t.resetGameplay(),t._setGameplay(),t.context.embedSettings.refreshAdsOnRestartGame()},resetDefaultPlay:function(){t._enemyScore=0,t.setState({resetDefaultFromResults:!0,questionCounter:1,userScore:0,gameplayCounter:0,showGameResults:!1})},setResetDefaultFromResultsFalse:function(){t.setState({resetDefaultFromResults:!1})},interruptGameFromResults:function(e,n){t.resetGameplay(),t.setGameplayForSingleMode(e)},interruptGame:function(e,n){"versusMode"===n?(t.props.setEmbedStartFalse(),t._enemyScore=0,t.setState({clearBoard:!0,userScore:0}),t.state.gameManagerOptions.setgameplayCounter(1e12),t.state.gameManagerOptions.setgameType(n),t.state.gameManagerOptions.setGame(e),t.state.gameManagerOptions.changeGameMode(n),t.state.gameManagerOptions.resetQuestionCounter(),t._playAgainSettings(),t._fetchQuestions("trivia")):(t.resetGameplay(),t.setGameplayForSingleMode(e))},setPlayAgainFalse:function(){t.setState({playAgain:!1,gameplayCounter:null})},increaseQuestionCounter:function(e){var n=e;t.setState({questionCounter:t.state.questionCounter+n})},increaseTriviaQuestionCounter:function(e){var n=e;t.setState({triviaQuestionCounter:t.state.triviaQuestionCounter+n})},increasePollsQuestionCounter:function(e){t._pollsQuestionCounter+=1,t._pollsQuestionCounter>=t._maxPollsQuestions;var n=e;t.setState({pollsQuestionCounter:t.state.pollsQuestionCounter+n})},increaseArticleCounter:function(){t._articleQuestionCounter+=1,t._articleQuestionCounter>=t._maxarticles&&(t._articleQuestionCounter=0)},getTotalArticleCount:function(){return t._maxarticles},getArticleCounter:function(){return t._articleQuestionCounter},getPollsQuestionCounter:function(){return t._pollsQuestionCounter},resetTriviaQuestionCounter:function(){t.setState({triviaQuestionCounter:0})},resetPollsQuestionCounter:function(){t.setState({pollsQuestionCounter:0})},resetQuestionCounter:function(){t.setState({questionCounter:1})},resetScores:function(){t._enemyScore=0,t.setState({userScore:0})},resetUserScore:function(){t.setState({userScore:0})},resetEnemyUserScore:function(){t._enemyScore=0,t.setState({})},questionCounter:function(){return t.state.questionCounter},triviaQuestionCounter:function(){return t.state.triviaQuestionCounter},pollsQuestionCounter:function(){return t.state.pollsQuestionCounter},getInstiPollQuestionCounter:function(){return t._instiPollQuestionCount},maxTriviaQuestions:function(){return t.state.maxTriviaQuestions},maxPollsQuestions:function(){return t.state.maxPollsQuestions},getMaxPollsQuestions:function(){return t._maxPollsQuestions},getMaxInstiPollQuestions:function(){return t._maxInstiPollQuestions},maxArticles:function(){return t.state.maxArticles},hideGameResults:function(){t.setState({showGameResults:!1})},showGameResults:function(){t.setState({showGameResults:!0})},increaseUserScore:function(e){var n=e;t.setState({userScore:t.state.userScore+n})},increaseEnemyScore:function(e){t._enemyScore+=e},enemyScore:function(){return t._enemyScore},userScore:function(){return t.state.userScore},getGameType:function(){var e="";return e=t.state.gameplay.embedStart[t.state.gameplayCounter]?t.state.gameplay.embedStart[t.state.gameplayCounter].game:"specialGame"},getGameMode:function(){var e="";return e=t.state.gameplay.embedStart[t.state.gameplayCounter]?t.state.gameplay.embedStart[t.state.gameplayCounter].gameMode:"specialMode"},setGame:function(e){var n=e;t.setState({game:n})},setgameType:function(e){var n=e;t.setState({gameType:n})},setgameplayCounter:function(e){t.setState({gameplayCounter:e})},turnNavOn:function(){t.props.turnNavOn()},turnNavOff:function(){t.props.turnNavOff()},generateEnemyUser:function(){t._generateEnemyUser()},enemyData:function(){return t.state.enemyData},fetchPollResults:function(){t._fetchPollResults()},getPollResults:function(){return t.state.pollsResultData},getArticleData:function(){return t.state.articles},fetchPollData:function(){return t._fetchPollResults()},fetchQuestions:function(e){t._fetchQuestions(e)},reshuffleFetchedPollsQuestion:function(){t._reshuffleFetchedPollsQuestion()},getTriviaQuestions:function(){return t.state.triviaQuestions},getPollQuestions:function(){return t.state.pollsQuestions;
},getFetchedOnLoadPollsQuestions:function(){return t.state.fetchedOnLoadPollsQuestions},getArticles:function(){return t.state.articles},getInstiPollQuestions:function(){return t.state.instiPollQuestions},getInstiPollQuestionsLen:function(){return t.state.instiPollQuestions.length},getTriviaQuestionsLen:function(){return t.state.triviaQuestions.length},getPollsQuestionsLen:function(){return t.state.pollsQuestions.length},adjustPollDataOnAnswer:function(e){var n=t.state.pollsQuestions;n.splice(e,1);var i=t.state.pollsResultData;i.splice(e,1),t.setState({pollsQuestions:n,pollsResultData:i})},getGameplay:function(){return t.state.gameplay},updateGameplay:function(e){t.setState({gameplay:e})},getGamePaused:function(){return t.state.gamePaused},pauseGame:function(){t._interstitialActive=!0,t.setState({gamePaused:!0})},resumeGame:function(){t._interstitialActive=!1,t.setState({gamePaused:!1,showInterstitial:!1})},showInterstitial:function(e){t._showInterstitial(e)},getInterstitialActive:function(){return t._interstitialActive}}}}return r(t,e),t.prototype.getChildContext=function(){return{gameManagerSettings:{gameManagerOptions:this.state.gameManagerOptions,game:this.state.game,gameType:this.state.gameType,currentGameMode:this.state.currentGameMode}}},t.prototype.componentWillMount=function(){this.keenAnalysis=new v.default(this.context.embedSettings),this.keenUtil=new y.default(this.context.embedSettings),this._setGameplay()},t.prototype.componentWillUnmount=function(){clearInterval(this._triviaQuestionTimer),clearInterval(this._pollsQuestionTimer),clearInterval(this._articleTimer),clearInterval(this._instiPollTimer)},t.prototype._generateRandomImage=function(){var e=Math.floor(6*Math.random()),t="https://d2na2p72vtqyok.cloudfront.net/files/images/icon_"+e+".jpg";return t},t.prototype._generateEnemyUser=function(){for(var e,t=new b.default(this.context.embedSettings),n=t.generateRandomImgURL();n===this.props.playerData.avatar;)n=t.generateRandomImgURL();var i=new g.default(this.props.embedSettings),r=i._generateRandomName();e={uid:"",name:r,avatar:n,score:0},this.setState({enemyData:e})},t.prototype.componentDidMount=function(){},t.prototype.componentWillReceiveProps=function(e){},t.prototype.componentWillUpdate=function(){},t.prototype._setupQuantCast=function(){},t.prototype.handleResponseData=function(e,t){if(this._firstDataReceived||(this._firstDataReceived=!0,this.injectScripts()),0===e.data.length)return void this.handleEmptyQuestionData(t);if("trivia"===t){this.setState({triviaQuestions:[]});var n=this._formatRawData(e.data,"trivia"),i=this.limitGameQuestionCount(n,5),r=this._shuffleQuestions(i);this.setState({triviaQuestions:r,triviaQuestionsReady:!0,maxTriviaQuestions:r.length,currentQuestion:0})}else if("polls"===t){this.setState({pollsQuestions:[]});var o=e.data,n=this._formatRawData(o,"polls"),r=this._shuffleQuestions(n),s=this.limitPollQuestionCount(r);this._maxPollsQuestions=s.length,this.state.pollsQuestions.length>0&&(s=this.state.pollsQuestions.unshift(s)),this.setState({fetchedOnLoadPollsQuestions:n,pollsQuestions:s,pollsQuestionsReady:!0,maxPollsQuestions:s.length,currentQuestion:0})}else if("instiPoll"===t){var o=e.data,n=this._formatRawData(o,"instiPoll");this._maxInstiPollQuestions=n.length,this.setState({instiPollQuestions:n,instiPollQuestionsReady:!0,maxInstiPollQuestions:n.length,currentQuestion:0}),this._fetchInstiPollResults(n,"instiPoll")}},t.prototype._reshuffleFetchedPollsQuestion=function(){console.log("Reshuffling questions");var e=this._shuffleQuestions(this.state.fetchedOnLoadPollsQuestions),t=this.limitPollQuestionCount(e);this._maxPollsQuestions=t.length,this.setState({pollsQuestions:t,pollsQuestionsReady:!0,maxPollsQuestions:t.length,currentQuestion:0})},t.prototype.handleValueQuestionResponseData=function(e){var t=[];null!==e.data&&(t=this._formatRawData([e.data],"valueQuestion")),this.setState({valueQuestions:t,valueQuestionsReady:!0,maxValueQuestions:t.length,currentValueQuestion:0})},t.prototype._fetchQuestions=function(e){function t(e,t){for(var n=t,i="",r=0,o=n.length;r<o;r++){var s=void 0;s=0==r?e+n[r]:"&"+e+n[r],i+=s}return i}var n=this;this.context.embedSettings.logger("fetching "+e+" questions");var i,r,o,s,a,l=this.props.embedSettings.siteUUID,c=this.props.embedSettings.embedUUID,u="%23"+this.props.embedSettings.siteCategory,d=new Date(15e3*Math.floor((new Date).getTime()/15e3)).getTime(),p="",h=this.context.embedSettings.embedSetting.showValueQuestion;i=t("hashtagList=",this.context.embedSettings.hashtags).toString().replace(/#/g,"%23"),r=t("siteCategory=",[u]).toString(),o=t("hashtagList=",this.context.embedSettings.embedSetting.pollsHashTagList).toString().replace(/#/g,"%23"),s=t("instiPollUUIDList=",this.context.embedSettings.embedSetting.instiPollHashTagList).toString().replace(/#/g,"");var m,f=this.context.embedSettings.parentWindow.document.getElementsByTagName("head")[0],g=this.context.embedSettings.parentWindow.document.createElement("script");if("trivia"==e)a=S.apiBaseUrl+"/insticator-api/trivia?cbt="+d+"&"+i,p=S.apiBaseUrl+"/insticator-api/valuequestion?cbt="+d+"&"+r;else if("polls"==e)a=S.apiBaseUrl+"/insticator-api/polls?"+o+"&cbt="+d;else if("articles"==e){this.setState({articles:[]}),m="insticatorArticlesData",this.context.embedSettings.parentWindow.fetchArticleInfo=function(e){if(this.context.embedSettings.logger("fetchArticleInfo() data: "+e),window[m]=e,0===e.length){this.context.embedSettings.embedSetting.showArticles=!1;for(var t=this.state.gameplay,n=0;n<this.state.gameplay.embedStart.length;n++)if("articles"===this.state.gameplay.embedStart[n].game){t.embedStart.splice(n,1),t.defaultPlay.splice(n,1);break}this.setState({gameplay:t})}return e}.bind(this);var b=5;"a838890c-7e5e-44ca-bfd1-4de805d3d755"===l&&(b=10);var v=new Date(15e3*Math.floor((new Date).getTime()/15e3)).getTime();S.LOCAL_MODE?g.src=S.articlesBaseUrl+"/articles/getwidgetarticles?siteUUID="+l+"&callback=fetchArticleInfo":g.src=S.articlesBaseUrl+"/articles/getnarticlesforwidget?embedUUID="+c+"&numberOfArticles=50&cbt="+v+"&callback=fetchArticleInfo",this._articlesGlobalName=m,this._questionCheckTimePassed=0,this._articleTimer=setInterval(function(){return n._QuestionCheck(e)},200)}else"instiPoll"===e&&(a=S.apiBaseUrl+"/insticator-api/instipoll?"+s+"&cbt="+d);"articles"===e?(this.context.embedSettings.parentWindow[m]=null,f.appendChild(g)):(w.default.get(a).then(function(t){n.handleResponseData(t,e)}).catch(function(e){n.context.embedSettings.logger("trivia response err: "+e)}),""!==p&&h&&(this.context.embedSettings.logger("fetching value question"),w.default.get(p).then(function(e){n.handleValueQuestionResponseData(e)}).catch(function(e){n.context.embedSettings.logger("value question response err: "+e)})))},t.prototype.limitGameQuestionCount=function(e,t){var n;if(e.length>t)if(e.length%t!==0){var i=e.length%t;n=e.slice(0,e.length-i)}else n=e;else n=e;return this.context.embedSettings.embedSetting.totalTriviaQuestionsToShow<t&&(n=e.slice(0,this.context.embedSettings.embedSetting.totalTriviaQuestionsToShow)),n},t.prototype.limitPollQuestionCount=function(e){return e.slice(0,this.context.embedSettings.embedSetting.totalPollQuestionsToShow)},t.prototype.handleEmptyQuestionData=function(e){var t,n=this.context.embedSettings.embedSetting.showTrivia,i=this.context.embedSettings.embedSetting.showPolls;!n&&i&&"polls"===e?t={embedStart:[{game:"error",gameMode:"errorMode"}],defaultPlay:[{game:"error",gameMode:"errorMode"}]}:this.state.gameplay.embedStart[0].game===e&&1===this.state.gameplay.embedStart.length?(t={embedStart:[{game:"error",gameMode:"errorMode"}],defaultPlay:[{game:"error",gameMode:"errorMode"}]},"polls"===e?(this.context.embedSettings.embedSetting.showPolls=!1,this.setState({pollsQuestionsReady:!0,gameplay:t})):"trivia"===e&&(this.context.embedSettings.embedSetting.showTrivia=!1,this.setState({triviaQuestionsReady:!0,gameplay:t}))):this.state.gameplay.embedStart.length>1&&("trivia"===e?(this._fetchQuestions("polls"),this.props.setEmbedStartTrue(),t={embedStart:[{game:"polls",gameMode:"demoMode"}],defaultPlay:[{game:"polls",gameMode:"pollsMode"}]},this.context.embedSettings.embedSetting.showTrivia=!1,this.setState({triviaQuestionsReady:!0,pollsQuestionsReady:!1,gameEnd:!1,gameplayCounter:0,gameplay:t})):"polls"===e&&(t={embedStart:[{game:"trivia",gameMode:"demoMode"}],defaultPlay:[{game:"trivia",gameMode:"triviaMode"}]},this.context.embedSettings.embedSetting.showPolls=!1,this.setState({pollsQuestionsReady:!0,gameplay:t})),this.context.embedSettings.logger("UPDATED GAMEPLAY AFTER REMOVING "+e+": "+JSON.stringify(t)))},t.prototype._shuffleQuestions=function(e){for(var t,n,i=e.length;0!==i;)n=Math.floor(Math.random()*i),i-=1,t=e[i],e[i]=e[n],e[n]=t;return e},t.prototype._QuestionCheck=function(e){if(this._questionCheckTimePassed+=200,1e4===this._questionCheckTimePassed&&(this.context.embedSettings.logger("10 seconds have passed by ... clearing questionCheck for "+e),this._questionCheckTimePassed=0,clearInterval(this._triviaQuestionTimer),clearInterval(this._pollsQuestionTimer),clearInterval(this._articleTimer),clearInterval(this._instiPollTimer)),"articles"===e&&(this._globalArticleResults=this.context.embedSettings.parentWindow[this._articlesGlobalName],null!==this._globalArticleResults&&void 0!==this._globalArticleResults)){if(clearInterval(this._articleTimer),this._globalArticleResults.indexOf("ERROR")>-1)this.context.embedSettings.logger(this._globalArticleResults),"articles"===this.state.gameplay.embedStart[0].game&&1===this.state.gameplay.embedStart.length&&(this.context.embedSettings.logger("ARTICLES ONLY MODE"),this.context.embedSettings.logger("SHOW WIDGET ERROR SCREEN")),this.context.embedSettings.embedSetting.showArticles=!1,this.setState({articlesReady:!0});else{var t=this._globalArticleResults,n=this._shuffleQuestions(t);n=n.slice(0,this.context.embedSettings.embedSetting.totalArticlesToShow),this._maxarticles=n.length,this.setState({articles:n,articlesReady:!0,maxArticles:n.length,currentQuestion:0})}delete this.context.embedSettings.parentWindow.fetchArticleInfo,delete this.context.embedSettings.parentWindow[this._globalArticleResults]}},t.prototype._formatRawData=function(e,t){for(var n=[],i=e,r=0;r<i.length;r++){var o=void 0,s=void 0,a=void 0,l=void 0,c=[],u=void 0;o=i[r].prediction.predictionUUID,s=i[r].prediction.predictionTitle,a=""+S.imgRootPath+o+".jpg",u=void 0!==i[r].prediction.sendDataToDMP&&i[r].prediction.sendDataToDMP;for(var d=0;d<i[r].predictionOptions.length;d++){var p={predictionOption:i[r].predictionOptions[d].predictionResultString,predictionOptionUUID:i[r].predictionOptions[d].predictionOptionUUID};c.push(p)}if("trivia"==t&&(l=i[r].predictionResult.predictionResultString,n.push({uid:o,question:s,questionImageURL:a,answer:l,options:c,sendDataToDMP:u})),"valueQuestion"==t&&(l=i[r].predictionResult.predictionResultString,n.push({uid:o,question:s,questionImageURL:a,answer:l,options:c,sendDataToDMP:u,valueQuestionKeyword:i[r].valueQuestionKeyword})),"polls"==t&&n.push({uid:o,question:s,questionImageURL:a,options:c,sendDataToDMP:u}),"instiPoll"===t){var h=i[r].instiPollUUID,m=S.brandLogoBaseUrl,f=m+"/"+h+".png",g=i[r].prediction.predictionUUID,b=S.instiPollQuestionImgBaseUrl+"/"+g+".jpg",v=i[r].prediction.predictionUUID;n.push({uid:h,question:s,questionUUID:v,questionImageURL:b,brandLogoURL:f,options:c,sendDataToDMP:u})}}return n},t.prototype._removeGameMode=function(e){this.context.embedSettings.embedSetting.showPolls=!1;var t=this.state.gameplayCounter;if("polls"===e){for(var n=this.state.gameplay,i=0,r=0;r<n.defaultPlay.length;r++)"pollsMode"===n.defaultPlay[r].gameMode&&(n.defaultPlay.splice(r,1),n.embedStart.splice(r,1),r-=1,i+=1);t-=i,t=t<0?0:t,this.setState({gameplay:n,gameplayCounter:t})}},t.prototype.resetGameplay=function(){this._gameStarted=!1,this._enemyScore=0,this._resultScreenActive=!1,this.firstQuestionAnswered=!1,this._pollsQuestionCounter=0,this._maxPollsQuestions=0,this._maxInstiPollQuestions=0,this._articleQuestionCounter=0,this._maxarticles=0,this._interstitialActive=!1,this.setState({enemyData:{},instiPollQuestions:[],pollsResultData:null,instiPollResultData:null,haveFetchedPollResults:!1,haveFetchedInstiPollResults:!1,maxTriviaQuestions:null,maxPollsQuestions:null,maxInstiPollQuestions:null,maxArticles:null,currentQuestion:null,gameEnd:!1,game:null,gameType:null,gamePaused:!1,showInterstitial:!1,currentGameMode:null,enableTrivia:null,enablePolls:null,gameplay:{},userScore:0,enemyScore:0,gameplayCounter:0,questionCounter:1,triviaQuestionCounter:0,pollsQuestionCounter:0,showGameResults:!1,playAgain:!1,clearBoard:!1,triviaQuestionsReady:!1,pollsQuestionsReady:!1,instiPollQuestionsReady:!1,articlesReady:!1,resultsShown:!1,articlesFromResultsDone:!1,playFromResults:!1,resetDefaultFromResults:!1,firstGameRender:!0})},t.prototype.setGameplayForSingleMode=function(e){this._fetchQuestions(e),this.context.embedSettings.embedSetting.showInstiPoll&&this._fetchQuestions("instiPoll");var t=[],n=[],i="FALSE"!==this.context.embedSettings.embedSetting.showMarketResearch;switch(k.mobile()&&(i=!1),e){case"adShow":t.push({game:"adShow",gameMode:"adShowMode"}),n.push({game:"adShow",gameMode:"adShowMode"});break;case"contest":t.push({game:"contest",gameMode:"contestMode"}),n.push({game:"contest",gameMode:"contestMode"});break;case"trivia":this.setState({pollsQuestionsReady:!0,articlesReady:!0}),t.push({game:"trivia",gameMode:"triviaMode"}),n.push({game:"trivia",gameMode:"triviaMode"}),i&&(t.push({game:"marketResearch",gameMode:"marketResearchMode"}),n.push({game:"marketResearch",gameMode:"marketResearchMode"}));break;case"polls":this.setState({triviaQuestionsReady:!0,articlesReady:!0}),t.push({game:"polls",gameMode:"pollsMode"}),n.push({game:"polls",gameMode:"pollsMode"}),i&&(t.push({game:"marketResearch",gameMode:"marketResearchMode"}),n.push({game:"marketResearch",gameMode:"marketResearchMode"}));break;case"articles":this.setState({triviaQuestionsReady:!0,pollsQuestionsReady:!0}),t.push({game:"articles",gameMode:"articlesMode"}),n.push({game:"articles",gameMode:"articlesMode"}),i&&(t.push({game:"marketResearch",gameMode:"marketResearchMode"}),n.push({game:"marketResearch",gameMode:"marketResearchMode"}));break;case"marketResearch":i&&(t.push({game:"marketResearch",gameMode:"marketResearchMode"}),n.push({game:"marketResearch",gameMode:"marketResearchMode"}))}this.setState({gameplay:{embedStart:t,defaultPlay:n}})},t.prototype._setGameplay=function(){var e="REGULAR"!==this.context.embedSettings.embedSetting.webAdDisplayMode,t="FALSE"!==this.context.embedSettings.embedSetting.showMarketResearch;k.mobile()&&(e="REGULAR"!==this.context.embedSettings.embedSetting.mobileAdDisplayMode);var n=this.context.embedSettings.embedSetting.showContest;n&&(n=this.props.embedSettings.insticatorEmbedIframe.contentWindow.localStorage.contestEntered!==this.props.embedSettings.contest.contestUUID);var i=this.context.embedSettings.embedSetting.showTrivia,r=this.context.embedSettings.embedSetting.showPolls,o=this.context.embedSettings.embedSetting.showArticles,s=this.context.embedSettings.embedSetting.instiPollHashTagList.length>0&&this.context.embedSettings.embedSetting.showInstiPoll;this.context.embedSettings.embedSetting.showInstiPoll=s,i?(this._fetchQuestions("trivia"),this.setState({pollsQuestionsReady:!0,articlesReady:!0})):r?(this._fetchQuestions("polls"),this.setState({triviaQuestionsReady:!0,articlesReady:!0})):o&&(this._fetchQuestions("articles"),this.setState({triviaQuestionsReady:!0,pollsQuestionsReady:!0})),s&&this._fetchQuestions("instiPoll");var a=[],l=[],c=[];e&&c.push("adShow"),n&&c.push("contest"),i&&c.push("trivia"),r&&c.push("poll"),o&&c.push("article"),t&&c.push("marketResearch");for(var u=0,d=c;u<d.length;u++){var p=d[u];switch(p){case"adShow":a.push({game:"adShow",gameMode:"adShowMode"}),l.push({game:"adShow",gameMode:"adShowMode"});break;case"contest":a.push({game:"contest",gameMode:"contestMode"}),l.push({game:"contest",gameMode:"contestMode"});break;case"poll":a.push({game:"polls",gameMode:"pollsMode"}),l.push({game:"polls",gameMode:"pollsMode"});break;case"trivia":a.push({game:"trivia",gameMode:"triviaMode"}),l.push({game:"trivia",gameMode:"triviaMode"});break;case"article":a.push({game:"articles",gameMode:"articlesMode"}),l.push({game:"articles",gameMode:"articlesMode"});break;case"marketResearch":a.push({game:"marketResearch",gameMode:"marketResearchMode"}),l.push({game:"marketResearch",gameMode:"marketResearchMode"})}}for(var h=0;h<a.length;h++)if("adShow"!==a[h].game&&"contest"!==a[h].game){a[h].gameMode="demoMode";break}this.setState({gameplay:{embedStart:a,defaultPlay:l}})},t.prototype._fetchPollResults=function(){var e=this;this.setState({haveFetchedPollResults:!0});for(var t=[],n=0;n<this.state.pollsQuestions.length;n++)t.push(this.state.pollsQuestions[n].uid);var i=S.pingHostName+"/getquestionoptionscount?questionUUIDs="+t;w.default.get(i).then(function(t){e.context.embedSettings.logger("POLL RESULT RESPONSE: "+JSON.stringify(t.data));for(var n=t.data,i=e.state.pollsQuestions,r=[],o=0,s=0,a=0,l=i;a<l.length;a++){var c=l[a];r.push([]);for(var u=0,d=c.options;u<d.length;u++){var p=d[u];n[c.uid]&&n[c.uid][p.predictionOptionUUID]?(s+=n[c.uid][p.predictionOptionUUID],r[o].push(n[c.uid][p.predictionOptionUUID])):r[o].push(0)}r[o].push({total:s}),s=0,o+=1}e.context.embedSettings.logger("KEEN updatedPollQuestionData: "+JSON.stringify(r)),e.setState({pollsResultData:r})}).catch(function(t){console.log(t),e.context.embedSettings.logger("polls results response err: "+t)})},t.prototype._fetchInstiPollResults=function(e,t){this.setState({haveFetchedInstiPollResults:!0}),x.ready(function(){for(var t=[],n=0;n<e.length;n++){var i=e[n].questionUUID,r=new x.Query("count",{event_collection:"answerQuestion",timeframe:"this_14_days",group_by:"questionOptionUUID",filters:[{property_name:"questionUUID",operator:"eq",property_value:i}]});t.push(r)}_.run(t,function(e,t){t.length||(t=[t]),this.context.embedSettings.logger("KEEN QUERY CACHED RESPONSE: "+JSON.stringify(t)),e&&this.context.embedSettings.logger("KEEN QUERY ERROR: "+e);for(var n=this.state.instiPollQuestions,i={},r=0,o=t;r<o.length;r++)for(var s=o[r],a=0,l=s.result;a<l.length;a++){var c=l[a];i[c.questionOptionUUID]=c.result}console.log("answerMap",i);for(var u=[],d=0,p=0,h=0,m=n;h<m.length;h++){var f=m[h];u.push([]);for(var g=0,b=f.options;g<b.length;g++){var v=b[g];i[v.predictionOptionUUID]?(p+=i[v.predictionOptionUUID],u[d].push(i[v.predictionOptionUUID])):u[d].push(0)}u[d].push({total:p}),p=0,d+=1}this.context.embedSettings.logger("KEEN updatedPollQuestionData: "+JSON.stringify(u)),this.setState({instiPollResultData:u})}.bind(this))}.bind(this))},t.prototype._play=function(){var e,t,n,i;switch(i=this.props.embedStart?this.state.gameplay.embedStart:this.state.gameplay.defaultPlay,e=i[this.state.gameplayCounter],t=e.game){case"adShow":n=o.createElement(p.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings});break;case"contest":n=o.createElement(d.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings});break;case"trivia":n=o.createElement(l.default,{gameManagerOptions:this.state.gameManagerOptions,playerData:this.props.playerData,gamePaused:this.state.gamePaused,embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,questions:this.state.triviaQuestions,valueQuestions:this.state.valueQuestions,gameManagerQuestionCounter:this.state.questionCounter,playMode:e.gameMode});break;case"polls":n=o.createElement(c.default,{gameManagerOptions:this.state.gameManagerOptions,playerData:this.props.playerData,gamePaused:this.state.gamePaused,embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,questions:this.state.pollsQuestions,gameManagerQuestionCounter:this.state.questionCounter,playMode:e.gameMode,pollsResultData:this.state.pollsResultData});break;case"articles":n=o.createElement(s.default,{gameManagerOptions:this.state.gameManagerOptions,embedOptions:this.props.embedOptions,articles:this.state.articles,displayedFromResults:!1,resultsCardOptions:{}});break;case"marketResearch":n=o.createElement(h.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings});break;case"error":n=o.createElement(a.default,null)}return n},t.prototype._playAgainSettings=function(){this.setState({gameEnd:!0}),this.setState({gameplayCounter:1e13,gameEnd:!1,showGameResults:!1,playAgain:!0})},t.prototype._playAgain=function(){var e,t,n;switch(e=this.state.gameType,t=this.state.game){case"adShow":n=o.createElement(p.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings});break;case"contest":n=o.createElement(d.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings});break;case"trivia":n=o.createElement(l.default,{gameManagerOptions:this.state.gameManagerOptions,playerData:this.props.playerData,gamePaused:this.state.gamePaused,embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,questions:this.state.triviaQuestions,valueQuestions:this.state.valueQuestions,gameManagerQuestionCounter:this.state.questionCounter,playMode:e});break;case"polls":n=o.createElement(c.default,{gameManagerOptions:this.state.gameManagerOptions,playerData:this.props.playerData,gamePaused:this.state.gamePaused,embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,questions:this.state.pollsQuestions,gameManagerQuestionCounter:this.state.questionCounter,playMode:e,pollsResultData:this.state.pollsResultData});break;case"articles":n=o.createElement(s.default,{gameManagerOptions:this.state.gameManagerOptions,embedOptions:this.props.embedOptions,articles:this.state.articles,displayedFromResults:!1,resultsCardOptions:{}});break;case"marketResearch":n=o.createElement(h.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings})}return n},t.prototype._replayGameMode=function(e){this.state.gameManagerOptions.playArticles(),this.state.gameManagerOptions.resetQuestionCounter()},t.prototype._playNext=function(){if(this.setState({gameEnd:!0}),this.props.embedStart)if(this.state.gameplayCounter+1<this.state.gameplay.embedStart.length){var e=void 0,t=void 0,n=void 0,i=void 0;i=this.state.gameplay.embedStart,e=i[this.state.gameplayCounter],t=e.game,n=e.gameMode,this.setState({gameplayCounter:this.state.gameplayCounter+1,gameEnd:!1,game:t,gameType:n})}else this.props.setEmbedStartFalse(),this.setState({gameplayCounter:null,showGameResults:!0});else{var r=void 0;if(r=null==this.state.gameplayCounter?0:this.state.gameplayCounter+1,r<this.state.gameplay.defaultPlay.length&&this.state.gameplay.defaultPlay.length>0){var e=void 0,t=void 0,n=void 0,o=void 0;o=this.state.gameplay.defaultPlay,e=o[r],t=e.game,n=e.gameMode,this.setState({gameplayCounter:r,gameEnd:!1,game:t,gameType:n})}else this.props.setEmbedStartFalse(),this.setState({gameplayCounter:null,showGameResults:!0,resultsShown:!0})}},t.prototype._playFromResults=function(e){var t,n=e;switch(e){case"adShowMode":t=o.createElement(p.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings});break;case"contestMode":t=o.createElement(d.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings});break;case"triviaMode":t=o.createElement(l.default,{gameManagerOptions:this.state.gameManagerOptions,playerData:this.props.playerData,gamePaused:this.state.gamePaused,embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,questions:this.state.triviaQuestions,valueQuestions:this.state.valueQuestions,gameManagerQuestionCounter:this.state.questionCounter,playMode:n});case"pollsMode":t=o.createElement(c.default,{gameManagerOptions:this.state.gameManagerOptions,playerData:this.props.playerData,gamePaused:this.state.gamePaused,embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,questions:this.state.pollsQuestions,gameManagerQuestionCounter:this.state.questionCounter,playMode:n,pollsResultData:this.state.pollsResultData});break;case"articlesMode":t=o.createElement(s.default,{gameManagerOptions:this.state.gameManagerOptions,embedOptions:this.props.embedOptions,articles:this.state.articles,displayedFromResults:!1,resultsCardOptions:{}});break;case"marketResearch":t=o.createElement(h.default,{gameManagerOptions:this.state.gameManagerOptions,embedSettings:this.props.embedSettings})}return t},t.prototype._showInterstitial=function(e){switch(e){case"instiPoll":this.setState({showInterstitial:!0})}},t.prototype.callGAFunctions=function(){var e,t=this.context.embedSettings.siteUUID,n=this.context.embedSettings.parentWindow.ga,i=this.context.embedSettings.googleAnalyticsID;try{e=window.top.location.hostname}catch(t){e=""}finally{n("create",i,"auto",{alwaysSendReferrer:"true",name:"Insticator_Widget"}),n("Insticator_Widget.send","pageview","/"+t),n("Insticator_Widget.set","referrer",e)}},t.prototype.createAndAppendGAScript=function(){var e=document.getElementById("insticator-embed-iframe"),t=e.contentDocument.head,n=this.context.embedSettings.siteUUID,i=this.context.embedSettings.siteURL,r=this.context.embedSettings.googleAnalyticsID,o="(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)})(window,document,'script','https://www.google-analytics.com/analytics.js','ga');ga('create', '"+r+"', 'auto', {'alwaysSendReferrer': 'true'});ga('send', 'pageview', '/"+n+"');ga('set', 'referrer','"+i+"');",s=document.createElement("script");s.innerHTML=o,t.appendChild(s)},t.prototype.createAndAppendLotameScript=function(){var e=this.context.embedSettings.embedSetting.lotameID,t=document.getElementById("insticator-embed-iframe"),n=(t.contentDocument.head,document.createElement("script"));n.src=("https:"==document.location.protocol?"https://":"http://")+"tags.crwdcntrl.net/c/"+e+"/cc.js?ns=_cc"+e,n.id="LOTCC_"+e,window.document.head.appendChild(n)},t.prototype.injectScripts=function(){var e=this.context.embedSettings.parentWindow.ga;e&&e.create?this.callGAFunctions():this.createAndAppendGAScript(),this.props.indexManager.pingDataScript(),this.context.embedSettings.embedSetting.sendLotameEvent&&this.createAndAppendLotameScript()},t.prototype.render=function(){var e,t="REGULAR"!==this.context.embedSettings.embedSetting.webAdDisplayMode;k.mobile()&&(t="REGULAR"!==this.context.embedSettings.embedSetting.mobileAdDisplayMode);var n="FALSE"!==this.context.embedSettings.embedSetting.showMarketResearch,i=(this.context.embedSettings.embedSetting.showContest,this.context.embedSettings.embedSetting.showTrivia),r=this.context.embedSettings.embedSetting.showPolls,s=this.context.embedSettings.embedSetting.showArticles,a=this.state.triviaQuestions.length>0,l=this.state.pollsQuestions.length>0,c=this.state.articles.length>0;this.state.resetDefaultFromResults===!0?e=this._play():1==this.state.clearBoard?e=null:i||r||s||!n?0==this.state.triviaQuestionsReady||0==this.state.pollsQuestionsReady||0==this.state.articlesReady?e=!s||i||r?o.createElement(m.default,{gameType:""}):o.createElement(m.default,{gameType:"articles"}):1==this.state.playAgain?e=this._playAgain():1==this.state.gameEnd||null==this.state.gameplayCounter?e=null:(a||l||c||n)&&null!==this.state.gameManagerOptions.embedOptions&&null!==this.state.gameManagerOptions.playerData&&(0===this.state.gameplay.defaultPlay.length||(e=this._play())):e=this._play();var d;this.state.showGameResults===!0&&(d=o.createElement(f.default,{embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,embedController:this.props.embedController,userInformation:this.props.playerData,currentGameScore:this.state.userScore,gameManagerOptions:this.state.gameManagerOptions,playMode:this.state.gameType}));var p;1==this.state.clearBoard&&0==this.state.gameEnd&&(p=this._playAgain());var h=null;return this.state.showInterstitial&&(h=o.createElement(u.default,{gameManagerOptions:this.state.gameManagerOptions,results:this.state.instiPollResultData})),o.createElement("div",{id:"game"},h,d,p,e)},t.contextTypes={embedSettings:o.PropTypes.object,gameManagerSettings:o.PropTypes.object},t.childContextTypes={gameManagerSettings:o.PropTypes.object},t}(o.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=M},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(204),s=n(206),a=function(e){function t(){var t=this;e.call(this),this.articleCountdown=15,this.maxArticlesPerGameplay=5,this.state={showArticle:!1,firstStart:!0,articles:[],currentIdx:0,articleOptions:{showNextArticle:function(){t.props.gameManagerOptions.increaseTotalQuestionsAnswered(),t.props.gameManagerOptions.increaseArticleCounter();var e=t.state.currentIdx;e+=1,t.setState({currentIdx:e,showArticle:!0})},hideArticle:function(){t.setState({showArticle:!1})},setFirstStartFalse:function(){t.setState({firstStart:!1})},endGameMode:function(){t.props.gameManagerOptions.setGameEndTrue()}}}}return i(t,e),t.prototype.componentWillMount=function(){if(this.props.gameManagerOptions.setGameStartedTrue(),this.keenUtil=new s.default(this.context.embedSettings),this.props.gameManagerOptions.getFirstArticleRender()===!1){var e={articleUUID:this.props.articles[0].articleUUID,title:this.props.articles[0].articleTitle,imgLink:this.props.articles[0].articleImageURL,articleURL:this.props.articles[0].articleURL};this.props.gameManagerOptions.setFirstArticleRenderTrue(),this.keenUtil.addImpressionEvent("IMPRESSIONS","ARTICLE",e)}var t=this.context.embedSettings.embedSetting.showPolls,n=this.context.embedSettings.embedSetting.showTrivia,i=this.context.embedSettings.embedSetting.showArticles,r=!t&&!n&&i;this.articleCountdown=this.context.embedSettings.embedSetting.articleScreenCountdown;var o=this.props.gameManagerOptions.getTotalArticleCount();r?this.maxArticlesPerGameplay=o:o<this.maxArticlesPerGameplay&&(this.maxArticlesPerGameplay=o)},t.prototype.componentWillUnmount=function(){clearTimeout(this._articleTimer)},t.prototype.setArticleTimer=function(){var e=this;this._articleTimer=setTimeout(function(){e.state.articleOptions.showNextArticle()},300)},t.prototype.resetStates=function(){this.setState({currentIdx:0,firstStart:!0,showArticle:!1})},t.prototype.render=function(){var e,t,n,i=(this.state.articles.length,this.context.embedSettings.embedSetting.showPolls),s=this.context.embedSettings.embedSetting.showTrivia,a=this.context.embedSettings.embedSetting.showArticles,l="FALSE"!==this.context.embedSettings.embedSetting.showMarketResearch,c=!i&&!s&&!l&&a,u=this.props.gameManagerOptions.getArticleCounter();if(this.state.currentIdx===this.maxArticlesPerGameplay&&this.props.displayedFromResults)return e=null,t=null,null;if(this.state.currentIdx===this.maxArticlesPerGameplay)c?this.setState({currentIdx:0}):this.props.gameManagerOptions.setGameEndTrue();else{var d=!1;this.state.currentIdx===this.props.articles.length-1&&(d=!0),t=this.props.articles[u].articleURL,e=r.createElement(o.default,{firstStart:this.state.firstStart,lastArticle:d,article:this.props.articles[u],articleOptions:this.state.articleOptions,displayedFromResults:this.props.displayedFromResults,articleCountdown:this.articleCountdown,articleURL:t,gameManagerOptions:this.props.gameManagerOptions,resultsCardOptions:this.props.resultsCardOptions,articlesOnly:c})}n="articleCardSlider";var p=this.context.embedSettings.embedSetting.articleScreenHeaderText;return r.createElement("div",{id:"articleCardSlider",className:n},r.createElement("div",{className:"top-container"},r.createElement("h2",null,p)),e)},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,
gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=a},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(205),s=n(206),a=n(238),l=function(e){function t(){e.call(this),this.articleIndex=0,this.articlesSinceLastAdShow=0,this.articleUUID="",this.articleTitle="",this.articleImageURL="",this.articleURL="",this.specialContainerHeight={},this.interstitialActive=!1,this.gamePaused=!1,this.state={counterActive:!0,counterPaused:!1,skipButtonPressed:!1,showOverlayAd:!1,animateArticle:!1}}return i(t,e),t.prototype.componentWillMount=function(){this.keenUtil=new s.default(this.context.embedSettings),this.articleUUID=this.props.article.articleUUID,this.articleTitle=this.props.article.articleTitle,this.articleImageURL=this.props.article.articleImageURL,this.articleURL=this.props.article.articleURL,this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled},t.prototype.componentDidMount=function(){this.setState({counterActive:!0})},t.prototype.componentWillUpdate=function(e,t){var n=this.context.gameManagerSettings.gameManagerOptions.getGamePaused(),i=this.context.gameManagerSettings.gameManagerOptions.getInterstitialActive();n||!this.interstitialActive||i||(this.gamePaused=n,this.interstitialActive=!1,this.startSequenceForNextArticle(0)),this.articleUUID=e.article.articleUUID,this.articleTitle=e.article.articleTitle,this.articleImageURL=e.article.articleImageURL,this.articleURL=e.article.articleURL},t.prototype.componentWillUnmount=function(){clearInterval(this._counterCheckTimer),clearInterval(this._counterEndCheckSetTimeOut),clearTimeout(this._counterTimeout),clearTimeout(this._nextArticleTimeout),clearTimeout(this._placeholderTimeout)},t.prototype._resetCounterCheckTimer=function(){},t.prototype.counterEndCheck=function(){var e=this,t=this.context.embedSettings.document.getElementById("insticatorEmbed").getElementsByClassName("remain-time-bar")[0];void 0!==t?0===t.clientWidth&&(clearInterval(this._counterCheckTimer),this.setState({counterActive:!1}),this.props.lastArticle===!1?this.state.counterActive===!1&&null!==this.context.embedSettings.document.getElementById("insticatorEmbed").getElementsByClassName("articleCardSlider")[0]&&(this._nextArticleTimeout=window.setTimeout(function(){e.props.articleOptions.showNextArticle()},1e3),this._counterTimeout=window.setTimeout(function(){e._resetCounterCheckTimer(),e.setState({counterActive:!0})},1800)):this.props.articleOptions.showNextArticle()):clearInterval(this._counterCheckTimer)},t.prototype.handleReadMore=function(){this.articleIndex+=1;var e=this.context.embedSettings.embedSetting.overlayAdShowingInterval,t=!1;t?t&&this.articleIndex%e===0&&this.articleIndex>0&&(this.setState({counterActive:!1,skipButtonPressed:!0}),clearInterval(this.counterEndTimeout),clearInterval(this._counterCheckTimer),this.context.embedSettings.refreshAds(),this.setState({showOverlayAd:!0})):this.context.embedSettings.refreshAds()},t.prototype.addKeenClickEvent=function(e,t,n,i,r,o){"LINK"===t&&this.handleReadMore(),this.keenUtil.addArticleClickEvent(e,t,n,i,r,o)},t.prototype.startSequenceForNextArticle=function(e){var t=this;this.props.gameManagerOptions.increaseTotalQuestionsAnsweredInSet(),this.showInstiPollCheck()?(this.props.gameManagerOptions.pauseGame(),this.props.gameManagerOptions.showInterstitial("instiPoll"),this.interstitialActive=!0):(this.props.articlesOnly&&(this.props.gameManagerOptions.fetchQuestions("instiPoll"),this.props.gameManagerOptions.setInstiPollShown(!1)),this.interstitialActive=!1,this.setState({animateArticle:!0}),this._nextArticleTimeout=window.setTimeout(function(){t.props.articleOptions.showNextArticle()},e),this._counterTimeout=window.setTimeout(function(){t._resetCounterCheckTimer(),t.setState({skipButtonPressed:!1,animateArticle:!1,counterActive:!0})},e))},t.prototype.showInstiPollCheck=function(){var e=this.props.gameManagerOptions.getTotalQuestionsAnsweredInSet(),t=this.context.embedSettings.embedSetting.instiPollInterval,n=this.props.gameManagerOptions.getTotalArticleCount();return n<t&&(t=n),!(e%t!==0||this.interstitialActive||!this.props.gameManagerOptions.getGameStarted()||this.props.gameManagerOptions.getInstiPollShown()||!this.context.embedSettings.embedSetting.showInstiPoll)},t.prototype.skipArticle=function(){if(this.articlesSinceLastAdShow+=1,this.articleIndex+=1,clearInterval(this.counterEndTimeout),clearInterval(this._counterCheckTimer),this.setState({counterActive:!1,skipButtonPressed:!0}),!this.state.skipButtonPressed){var e=this.context.embedSettings.embedSetting.overlayAdShowingInterval;this.addKeenClickEvent("ARTICLE","SKIP ARTICLE",this.articleUUID,this.articleTitle,this.articleImageURL,this.articleURL);var t=!1;t?t&&this.articleIndex%e===0&&this.articleIndex>0?(this.context.embedSettings.refreshAds(),this.setState({showOverlayAd:!0})):(this.context.embedSettings.refreshAds(),this.startSequenceForNextArticle(300)):(this.startSequenceForNextArticle(300),this.context.embedSettings.refreshAds())}},t.prototype.timeRanOut=function(){var e=this;clearTimeout(this.counterEndTimeout),this.setState({counterActive:!1,animateArticle:!0});var t=this.props.gameManagerOptions.getTotalQuestionsAnswered(),n=this.context.embedSettings.embedSetting.instiPollInterval,i=this.props.gameManagerOptions.getTotalArticleCount();return i<n&&(n=i),(t+1)%n===0&&!this.interstitialActive&&this.props.gameManagerOptions.getGameStarted()&&!this.props.gameManagerOptions.getInstiPollShown()&&this.context.embedSettings.embedSetting.showInstiPoll?(this.props.gameManagerOptions.pauseGame(),this.props.gameManagerOptions.showInterstitial("instiPoll"),void(this.interstitialActive=!0)):void(this.props.lastArticle===!1?(this._nextArticleTimeout=window.setTimeout(function(){e.props.articleOptions.showNextArticle()},300),this._counterTimeout=window.setTimeout(function(){e.setState({counterActive:!0})},300)):this.props.articleOptions.showNextArticle())},t.prototype.startCountdown=function(){var e=this;this.counterEndTimeout=setTimeout(function(){e.timeRanOut()},1e3*this.props.articleCountdown)},t.prototype.closeAdButtonClicked=function(){var e=this.context.embedSettings.document.getElementById("closeAdBtnContainer");e.style.display="none";for(var t=this.context.embedSettings.document.querySelectorAll("footer"),n=0;n<t.length;n++)t[n].style.zIndex=1e3;var i=this.context.embedSettings.document.getElementById("widgetNav");i&&(i.style.opacity=1);var r=this.context.embedSettings.embedSetting.targetAdDiv;if("ad1"===r)r=document.getElementById("div-insticator-ad-1");else if("ad2"===r)r=document.getElementById("div-insticator-ad-2");else if("both"===r)return document.getElementById("div-insticator-ad-1").style.zIndex="-1000",document.getElementById("div-insticator-ad-2").style.zIndex="-1000",this.setState({showOverlayAd:!1}),void this.startSequenceForNextArticle(300);r.style.zIndex="-1000",this.setState({showOverlayAd:!1}),this.startSequenceForNextArticle(300)},t.prototype.render=function(){var e,t,n,i,s="",l=(this.state.counterPaused,null);this.props.article.articleUUID,this.props.article.articleTitle,this.props.article.articleImageURL,this.props.article.articleURL,this.context.embedSettings.embedSetting.showOverlay;this.state.showOverlayAd&&(i=r.createElement(a.default,{closeBtnClicked:this.closeAdButtonClicked.bind(this),playMode:"articles",renderedFromResults:!1})),!this.state.counterActive&&this.state.animateArticle?(s="slideOutLeft",e=r.createElement("div",{className:"time-bar"},r.createElement("div",{className:"total-time-bar"}))):this.state.counterActive&&(t=null,e=r.createElement(o.default,{countDown:this.props.articleCountdown,countDownDelay:1,active:this.state.counterActive,counterStartFunction:function(){},startCountdown:this.startCountdown.bind(this)}));var c={backgroundImage:"url("+this.props.article.articleImageURL+")"},u=this.context.embedSettings.embedSetting.articleScreenDetailsButtonText;n=r.createElement("a",{target:"_blank",href:this.props.articleURL,onClick:this.addKeenClickEvent.bind(this,"ARTICLE","LINK",this.articleUUID,this.articleTitle,this.articleImageURL,this.articleURL)},r.createElement("div",{className:"bottom-button"},r.createElement("p",null,u)));var d=this.context.embedSettings.embedSetting.articleShowSkipButton;if(d){var p={fontSize:"13px",color:this.context.embedSettings.colorPalette.mainColor,position:"absolute",bottom:"6px",right:"0",cursor:"pointer",userSelect:"none"};l=this.state.skipButtonPressed?r.createElement("div",{id:"skipBtn",style:p},"Skip ",r.createElement("i",{className:"fa fa-step-forward","aria-hidden":"true"})):r.createElement("div",{id:"skipBtn",onClick:this.skipArticle.bind(this),style:p},"Skip ",r.createElement("i",{className:"fa fa-step-forward","aria-hidden":"true"}))}return r.createElement("div",{id:"articleContainer"},i,r.createElement("div",{className:"article-container "+s,style:this.specialContainerHeight},e,r.createElement("a",{target:"_blank",href:this.props.articleURL,onClick:this.addKeenClickEvent.bind(this,"ARTICLE","LINK",this.articleUUID,this.articleTitle,this.articleImageURL,this.articleURL)},r.createElement("div",{className:"article-img",style:c})),r.createElement("a",{target:"_blank",href:this.props.articleURL,onClick:this.addKeenClickEvent.bind(this,"ARTICLE","LINK",this.articleUUID,this.articleTitle,this.articleImageURL,this.articleURL)},r.createElement("div",{className:"article-body"},r.createElement("div",{className:"article-title-container"},r.createElement("div",{className:"article-text"},this.props.article.articleTitle))))),r.createElement("div",{className:"bottom-container"},n,l))},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=l},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(){e.call(this),this.counterStarted=!1,this.totalTimePassed=0,this.state={countDownFinished:!1,startCounter:!1}}return i(t,e),t.prototype.shouldComponentUpdate=function(e,t){switch(!0){case this.props.countDown!==e.countDown:return!0;case this.props.countDownDelay!==e.countDownDelay:return!0;case this.props.active!==e.active:return!0;case this.state.countDownFinished!==t.countDownFinished:return!0}return!1},t.prototype.componentWillMount=function(){},t.prototype.componentWillReceiveProps=function(e,t){e.active||clearTimeout(this._timer)},t.prototype.componentDidMount=function(){this.timebarWidth=this.context.embedSettings.document.getElementById("counterTotalTimeBar").clientWidth;var e=this;this._timer=setTimeout(function(){e.setState({countDownFinished:!0}),e.props.counterStartFunction()},1e3*this.props.countDownDelay),e.counterStarted=!0,e.setState({startCounter:!0})},t.prototype.componentWillUnmount=function(){clearTimeout(this._timer),clearInterval(this.totalTimeCounter)},t.prototype.render=function(){var e="pause",t={},n={},i={},o={WebkitTransform:"translate3d(0, 0, 0)",msTransform:"translate3d(0, 0, 0)",transform:"translate3d(0, 0, 0)"};if(this.props.active&&this.state.countDownFinished&&(e=""),this.state.startCounter&&this.counterStarted&&(this.counterStarted=!1,this.startTime=(new Date).getTime(),this.props.startCountdown(),t={width:this.timebarWidth+"px",msTransform:"translateX(-"+this.timebarWidth+"px) translateZ(0px)",WebkitTransform:"translateX(-"+this.timebarWidth+"px) translateZ(0px)",transform:"translateX(-"+this.timebarWidth+"px) translateZ(0px)",WebkitTransition:"-webkit-transform "+this.props.countDown+"s linear",msTransition:"-moz-transform "+this.props.countDown+"s linear",transition:"transform "+this.props.countDown+"s linear"},i=t),""!==e&&this.state.startCounter){this.endTime=(new Date).getTime();var s=(this.endTime-this.startTime)/1e3,a=this.timebarWidth/this.props.countDown*s,l=this.timebarWidth-a;l<0&&(l=0),n={width:l+"px",msTransform:"translateX(0px)",WebkitTransform:"translateX(0px)",transform:"translateX(0px)",WebkitTransition:"-webkit-transform 0s linear",msTransition:"-moz-transform 0s linear",transition:"transform 0s linear"},i=n,o={}}return r.createElement("div",{className:"time-bar",style:o},r.createElement("div",{id:"counterTotalTimeBar",className:"total-time-bar"},r.createElement("div",{id:"remainTimeBar",className:"remain-time-bar "+e,style:i})))},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i,r=n(201),o=r.API_KEYS.KEEN_WRITE_KEY,s=r.API_KEYS.KEEN_READ_KEY,a=r.API_KEYS.KEEN_PROJECT_ID;i=n(207);var l;l=n(234);var c,u=new l(window.navigator.userAgent),d=n(236);c=new i({projectId:a,writeKey:o,readKey:s});var p=function(){function e(e){this.embedSettings=e,this.keenUserData={widgetVersion:r.widgetVersion,project:"embed",siteVersion:this.getDeviceType(),jsSession:{jsSessionCookie:null,jsPermanentCookie:null},user:{userUUID:null,userName:null},request:{url:document.URL,urlInfo:{},clientUUID:null,siteURL:null,siteUUID:this.embedSettings.siteUUID,embedName:this.embedSettings.embedName,embedUUID:this.embedSettings.embedUUID},embedSetting:this.embedSettings.embedSetting,visitor:{ipAddress:"${keen.ip}",geo:{},userAgent:"${keen.user_agent}",tech:{},referrer:document.referrer,referrerInfo:{}},keen:{addons:[{name:"keen:ip_to_geo",input:{ip:"visitor.ipAddress"},output:"visitor.geo"},{name:"keen:ua_parser",input:{ua_string:"visitor.userAgent"},output:"visitor.tech"},{name:"keen:url_parser",input:{url:"request.url"},output:"request.urlInfo"},{name:"keen:referrer_parser",input:{referrer_url:"visitor.referrer",page_url:"request.url"},output:"visitor.referrerInfo"}]}},this.clickEventItems={element:{type:null,id:null,elementClass:null,innerHtml:null,title:null,value:null,src:null,href:null,analyticsValue:null},article:{articleUUID:null,title:null,imgLink:null},logentriesId:null,_timestamp:(new Date).getTime(),subType:null,type:null},this.answerQuestionFields={questionOptionUUID:null,type:null,questionUUID:null,questionText:null}}return e.prototype.checkCookies=function(){var e=this.readCookie("jsSessionCookie"),t=this.readCookie("jsPermanentCookie");null!==e?this.keenUserData.jsSession.jsSessionCookie=e:(this.setCookie("jsSessionCookie"),this.keenUserData.jsSession.jsSessionCookie=this.readCookie("jsSessionCookie")),null!==t?this.keenUserData.jsSession.jsPermanentCookie=t:(this.setCookie("jsPermanentCookie"),this.keenUserData.jsSession.jsPermanentCookie=this.readCookie("jsPermanentCookie"))},e.prototype.readCookie=function(e){for(var t=e+"=",n=document.cookie.split(";"),i=0;i<n.length;i++){for(var r=n[i];" "==r.charAt(0);)r=r.substring(1,r.length);if(0==r.indexOf(t))return r.substring(t.length,r.length)}return null},e.prototype.setCookie=function(e){var t=d(),n=((new Date).getTime(),new Date);n.setTime(n.getTime()+18e5);var i="";"jsSessionCookie"===e&&(i="expires="+n.toUTCString()),document.cookie=e+"="+t+";"+i+"path=/"},e.prototype.getDeviceType=function(){return u.mobile()?"mobile":"desktop"},e.prototype.addEmbedServedEvent=function(){this.checkCookies(),this.runQuery("embedServed",this.keenUserData)},e.prototype.answerInstiPoll=function(e){var t=this;this.checkCookies();var n={};this.answerQuestionFields.instiPollUUID=e.instiPollUUID,this.answerQuestionFields.questionOptionUUID=e.questionOptionUUID,this.answerQuestionFields.questionUUID=e.questionUUID,this.answerQuestionFields.questionText=e.questionText,this.answerQuestionFields.questionOptionText=e.questionOptionText,this.answerQuestionFields.type=e.keen.type,this.answerQuestionFields.questionNumberOutOfTotal=e.outOf;var i=e.keen.queryCollection;Object.keys(this.answerQuestionFields).forEach(function(e){return n[e]=t.answerQuestionFields[e]}),Object.keys(this.keenUserData).forEach(function(e){return n[e]=t.keenUserData[e]}),this.runQuery(i,n)},e.prototype.answerQuestion=function(e,t,n,i,r){var o=this;this.checkCookies();var s={};this.answerQuestionFields.questionOptionUUID=e,this.answerQuestionFields.questionUUID=t,this.answerQuestionFields.questionText=n,this.answerQuestionFields.type=i,Object.keys(this.answerQuestionFields).forEach(function(e){return s[e]=o.answerQuestionFields[e]}),Object.keys(this.keenUserData).forEach(function(e){return s[e]=o.keenUserData[e]}),this.runQuery(r,s)},e.prototype.addArticleClickEvent=function(e,t,n,i,r,o){var s=this;this.checkCookies(),this.embedSettings.logger("KEEN CLICK EVENT type: "+e),this.embedSettings.logger("KEEN CLICK EVENT subType: "+t);var a={};this.clickEventItems.type=e,this.clickEventItems.subType=t,this.clickEventItems.article.articleUUID=n,this.clickEventItems.article.title=i,this.clickEventItems.article.imgLink=r,this.clickEventItems.element.articleURL=o,Object.keys(this.clickEventItems).forEach(function(e){return a[e]=s.clickEventItems[e]}),Object.keys(this.keenUserData).forEach(function(e){return a[e]=s.keenUserData[e]}),this.runQuery("click",a)},e.prototype.addImpressionEvent=function(e,t,n){var i=this;this.checkCookies(),this.clickEventItems.type=e,this.clickEventItems.subType=t,"ARTICLE"===t&&(this.clickEventItems.article.articleUUID=n.articleUUID,this.clickEventItems.article.title=n.title,this.clickEventItems.article.imgLink=n.imgLink,this.clickEventItems.element.articleURL=n.articleURL);var r={};Object.keys(this.clickEventItems).forEach(function(e){return r[e]=i.clickEventItems[e]}),Object.keys(this.keenUserData).forEach(function(e){return r[e]=i.keenUserData[e]}),this.runQuery("impression",r)},e.prototype.addClickEvent=function(e,t,n){var i=this;this.checkCookies();var r={};this.clickEventItems.type=e,this.clickEventItems.subType=t,this.clickEventItems.element.innerHtml=n,Object.keys(this.clickEventItems).forEach(function(e){return r[e]=i.clickEventItems[e]}),Object.keys(this.keenUserData).forEach(function(e){return r[e]=i.keenUserData[e]}),this.embedSettings.logger("KEEN CLICK EVENT: "+t),this.runQuery("click",r)},e.prototype.addVersusClickEvent=function(){this.checkCookies(),i.ready(function(){c.addEvent("gameStartedEvent",this.keenUserData,function(e,t){e&&this.embedSettings.logger("KEEN VERSUS CLICK EVENT ERROR: "+e)}.bind(this))}.bind(this))},e.prototype.runQuery=function(e,t){i.ready(function(){c.addEvent(e,t,function(e,t){e&&this.embedSettings.logger("KEEN ADD EVENT ERROR: "+e)}.bind(this))}.bind(this))},e}();Object.defineProperty(t,"__esModule",{value:!0}),t.default=p},function(e,t,n){var i,r;(function(o){(function(o){"use strict";function s(e,t,n,i,r){this.emit("error","This method has been deprecated. Check out DOM listeners: https://github.com/keen/keen-tracking.js#listeners");var o,s,a=e,l=a.currentTarget?a.currentTarget:a.srcElement||a.target,c=i||500,u=!1,d="";if(void 0!==l.getAttribute?d=l.getAttribute("target"):l.target&&(d=l.target),"_blank"!=d&&"blank"!=d||a.metaKey||(s=window.open("about:blank"),s.document.location=l.href),"A"===l.nodeName?o=function(){u||a.metaKey||"_blank"===d||"blank"===d||(u=!0,window.location=l.href)}:"FORM"===l.nodeName?o=function(){u||(u=!0,l.submit())}:this.trigger("error","#trackExternalLink method not attached to an <a> or <form> DOM element"),r&&(o=function(){u||(u=!0,r())}),this.recordEvent(t,n,o),setTimeout(o,c),!a.metaKey)return!1}var a=n(208),l=n(215),c=n(216),u=n(218)(a);c(a.prototype,n(219)),c(a.prototype,n(224)),c(a.prototype,{extendEvent:n(222).extendEvent,extendEvents:n(222).extendEvents}),a.prototype.trackExternalLink=s,c(a.helpers,{getBrowserProfile:n(225),getDatetimeIndex:n(228),getDomNodePath:n(229),getScreenProfile:n(226),getUniqueId:n(230),getWindowProfile:n(227)}),c(a.utils,{cookie:n(231),deepExtend:n(223),listener:u,timer:n(233)}),a.listenTo=function(e){l(e,function(e,t){var n=t.split(" "),i=n[0],r=n.slice(1,n.length).join(" ");return u(r).on(i,e)})},Array.prototype.indexOf||(Array.prototype.indexOf=function(e){var t=this.length>>>0,n=Number(arguments[1])||0;for(n=n<0?Math.ceil(n):Math.floor(n),n<0&&(n+=t);n<t;n++)if(n in this&&this[n]===e)return n;return-1}),"undefined"!=typeof e&&e.exports&&(e.exports=a),i=[],r=function(){return a}.apply(t,i),!(void 0!==r&&(e.exports=r)),o.Keen=a.extendLibrary(a)}).call(this,"undefined"!=typeof window?window:"undefined"!=typeof o?o:"undefined"!=typeof self?self:{})}).call(t,function(){return this}())},function(e,t,n){var i=n(209),r=(n(215),n(216),n(217));i.helpers=i.helpers||{},i.on("client",function(e){e.extensions={events:[],collections:{}},e.queue=r(),e.queue.on("flush",function(){e.recordDeferredEvents()})}),i.prototype.writeKey=function(e){return arguments.length?(this.config.writeKey=e?String(e):null,this):this.config.writeKey},i.prototype.setGlobalProperties=function(e){return i.log("This method has been deprecated. Check out #extendEvents: https://github.com/keen/keen-tracking.js#extend-events"),e&&"function"==typeof e?(this.config.globalProperties=e,this):void this.emit("error","Invalid value for global properties: "+e)},e.exports=i},function(e,t,n){(function(t){(function(t){function i(e){return this instanceof i==!1?new i(e):(this.configure(e),i.debug&&this.on("error",i.log),this.emit("ready"),void i.emit("client",this))}function r(e){return i.loaded||"undefined"==typeof document?void e():(null==document.readyState&&document.addEventListener&&(document.addEventListener("DOMContentLoaded",function e(){document.removeEventListener("DOMContentLoaded",e,!1),document.readyState="complete"},!1),document.readyState="loading"),void o(e))}function o(e){/in/.test(document.readyState)?setTimeout(function(){o(e)},9):e()}function s(e){return"undefined"!=typeof e}var a=t.Keen||void 0,l=n(210),c=n(211),u=n(212),d=n(213),p=n(214);a&&"undefined"==typeof a.resources&&(i.legacyVersion=a),p(i),p(i.prototype),c(i,{debug:!1,enabled:!0,loaded:!1,version:"__VERSION__"}),i.helpers=i.helpers||{},i.resources=i.resources||{},c(i.resources,{base:"{protocol}://{host}",version:"{protocol}://{host}/3.0",projects:"{protocol}://{host}/3.0/projects",projectId:"{protocol}://{host}/3.0/projects/{projectId}",events:"{protocol}://{host}/3.0/projects/{projectId}/events",queries:"{protocol}://{host}/3.0/projects/{projectId}/queries"}),i.utils=i.utils||{},c(i.utils,{each:l,extend:c,parseParams:u,serialize:d}),i.extendLibrary=function(e,t){var n=a||t;return s(n)&&s(n.resources)&&(l(n,function(t,n){"object"==typeof t?(e[n]=e[n]||{},c(e[n],t)):e[n]=e[n]||t}),c(e.prototype,n.prototype)),e},i.log=function(e){i.debug&&"object"==typeof console&&console.log("[Keen]",e)},i.noConflict=function(){return"undefined"!=typeof t.Keen&&(t.Keen=i.legacyVersion||a),i},i.ready=function(e){i.loaded?e():i.once("ready",e)},i.prototype.configure=function(e){var t=e||{};return this.config=this.config||{projectId:void 0,writeKey:void 0,host:"api.keen.io",protocol:"https",requestType:"jsonp",resources:c({},i.resources)},"undefined"!=typeof window&&window.navigator&&window.navigator.userAgent&&window.navigator.userAgent.indexOf("MSIE")>-1&&(t.protocol=document.location.protocol.replace(":","")),t.host&&t.host.replace(/.*?:\/\//g,""),c(this.config,t),this},i.prototype.masterKey=function(e){return arguments.length?(this.config.masterKey=e?String(e):null,this):this.config.masterKey},i.prototype.projectId=function(e){return arguments.length?(this.config.projectId=e?String(e):null,this):this.config.projectId},i.prototype.resources=function(e){if(!arguments.length)return this.config.resources;var t=this;return"object"==typeof e&&l(e,function(e,n){t.config.resources[n]=e?e:null}),t},i.prototype.url=function(e){var t,n=Array.prototype.slice.call(arguments,1),i=this.config.resources.base||"{protocol}://{host}";return t=e&&"string"==typeof e?this.config.resources[e]?this.config.resources[e]:i+e:i,l(this.config,function(e,n){"object"!=typeof e&&(t=t.replace("{"+n+"}",e))}),l(n,function(e,n){"string"==typeof e?t+="/"+e:"object"==typeof e&&(t+="?",l(e,function(e,n){t+=n+"="+e+"&"}),t=t.slice(0,-1))}),t},r(function(){i.loaded=!0,i.emit("ready")}),e.exports=i}).call(this,"undefined"!=typeof window?window:"undefined"!=typeof t?t:"undefined"!=typeof self?self:{})}).call(t,function(){return this}())},function(e,t){function n(e,t,n){var i;if(!e)return 0;if(n=n?n:e,e instanceof Array){for(i=0;i<e.length;i++)if(t.call(n,e[i],i,e)===!1)return 0}else for(i in e)if(e.hasOwnProperty(i)&&t.call(n,e[i],i,e)===!1)return 0;return 1}e.exports=n},function(e,t){function n(e){for(var t=1;t<arguments.length;t++)for(var n in arguments[t])e[n]=arguments[t][n];return e}e.exports=n},function(e,t){function n(e){for(var t,n={},i=/\+/g,r=/([^&=]+)=?([^&]*)/g,o=function(e){return decodeURIComponent(e.replace(i," "))},s=e.split("?")[1];t=r.exec(s);)n[o(t[1])]=o(t[2]);return n}e.exports=n},function(e,t,n){function i(e){var t=[];return r(e,function(e,n){"string"!=typeof e&&(e=JSON.stringify(e)),t.push(n+"="+encodeURIComponent(e))}),t.join("&")}var r=n(210);n(211);e.exports=i},function(e,t,n){function i(e){if(e)return r(e)}function r(e){for(var t in i.prototype)e[t]=i.prototype[t];return e}e.exports=i,i.prototype.on=i.prototype.addEventListener=function(e,t){return this._callbacks=this._callbacks||{},(this._callbacks["$"+e]=this._callbacks["$"+e]||[]).push(t),this},i.prototype.once=function(e,t){function n(){this.off(e,n),t.apply(this,arguments)}return n.fn=t,this.on(e,n),this},i.prototype.off=i.prototype.removeListener=i.prototype.removeAllListeners=i.prototype.removeEventListener=function(e,t){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var n=this._callbacks["$"+e];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+e],this;for(var i,r=0;r<n.length;r++)if(i=n[r],i===t||i.fn===t){n.splice(r,1);break}return this},i.prototype.emit=function(e){this._callbacks=this._callbacks||{};var t=[].slice.call(arguments,1),n=this._callbacks["$"+e];if(n){n=n.slice(0);for(var i=0,r=n.length;i<r;++i)n[i].apply(this,t)}return this},i.prototype.listeners=function(e){return this._callbacks=this._callbacks||{},this._callbacks["$"+e]||[]},i.prototype.hasListeners=function(e){return!!this.listeners(e).length}},function(e,t,n){e.exports=n(210)},function(e,t,n){e.exports=n(211)},function(e,t,n){function i(){return this instanceof i==!1?new i:(this.capacity=0,this.config={capacity:5e3,interval:15},this.events={},this.interval=0,this.timer=null,this)}function r(e){return e.capacity>0&&e.interval>=e.config.interval||e.capacity>=e.config.capacity}var o=n(214);o(i.prototype),i.prototype.check=function(){return r(this)&&this.flush(),0!==this.config.interval&&0!==this.capacity||this.pause(),this},i.prototype.flush=function(){return this.emit("flush"),this.interval=0,this},i.prototype.pause=function(){return this.timer&&(clearInterval(this.timer),this.timer=null),this},i.prototype.start=function(){var e=this;return e.pause(),e.timer=setInterval(function(){e.interval++,e.check()},1e3),e},e.exports=i},function(e,t,n){function i(e,t){document.addEventListener?document.addEventListener(e,t,!1):document.attachEvent("on"+e,t)}function r(e,t){for(var n=(e.parentNode||document).querySelectorAll(t)||[],i=n.length;i--;)if(n[i]==e)return!0;return!1}function o(e,t,n){var i,r,o=500;return void 0!==t.getAttribute?i=t.getAttribute("target"):t.target&&(i=t.target),r=n(e),"boolean"==typeof r&&r===!1||e.defaultPrevented||e.returnValue===!1?(e.preventDefault&&e.preventDefault(),e.returnValue=!1,!1):("_blank"===i||"blank"===i||e.metaKey||(e.preventDefault&&e.preventDefault(),e.returnValue=!1,setTimeout(function(){window.location=t.href},o)),!1)}function s(e,t,n){var i=500,r=n(e);return"boolean"==typeof r&&r===!1||e.defaultPrevented||e.returnValue===!1?(e.preventDefault&&e.preventDefault(),e.returnValue=!1,!1):(e.preventDefault&&e.preventDefault(),e.returnValue=!1,setTimeout(function(){t.submit()},i),!1)}var a=(n(214),n(215));e.exports=function(e){function t(e){if(e)return this instanceof t==!1?new t(e):(this.selector=e,this)}function n(t){return function(n){var i,l;i=n||window.event,l=i.target||i.srcElement,"undefined"!==e.domListeners[t]&&a(e.domListeners[t],function(e,n){r(l,n)?a(e,function(e,n){"click"===t&&"A"===l.nodeName?o(i,l,e):"submit"===t&&"FORM"===l.nodeName?s(i,l,e):e(i)}):"window"===n&&a(e,function(e,t){e(i)})})}}return e.domListeners=e.domListeners||{},t.prototype.on=function(t,r){var o=this;return 2!==arguments.length||"string"!=typeof t||"function"!=typeof r?this:("undefined"==typeof e.domListeners[t]&&(i(t,n(t)),e.domListeners[t]={}),e.domListeners[t][o.selector]=e.domListeners[t][o.selector]||[],e.domListeners[t][o.selector].push(r),o)},t.prototype.once=function(e,t){function n(){return i.off(e,n),t.apply(i,arguments)}var i=this;return n.fn=t,i.on(e,n),i},t.prototype.off=function(t,n){var i=this,r=[];if(2===arguments.length)a(e.domListeners[t][i.selector],function(e,t){e!==n&&e.fn!==n&&r.push(e)}),e.domListeners[t][i.selector]=r;else if(1===arguments.length)try{delete e.domListeners[t][i.selector]}catch(n){e.domListeners[t][i.selector]=[]}else a(e.domListeners,function(t,n){try{delete e.domListeners[n][i.selector]}catch(t){e.domListeners[n][i.selector]=function(){}}});return i},t}},function(e,t,n){function i(e,t,n,i){var r,o,s,h,v,w,E;if(r=this.url("events",encodeURIComponent(e)),o={},s=n,E="boolean"!=typeof i||i,a.call(this,s)){if(!e||"string"!=typeof e)return void l.call(this,"Collection name must be a string.",s);if(this.config.globalProperties&&(o=this.config.globalProperties(e)),y(o,t),w={},S.getExtendedEventBody(w,this.extensions.events),S.getExtendedEventBody(w,this.extensions.collections[e]),S.getExtendedEventBody(w,[o]),this.emit("recordEvent",e,w),!g.enabled)return l.call(this,"Keen.enabled is set to false.",s),!1;if(h=this.url("events",encodeURIComponent(e),{api_key:this.writeKey(),data:encodeURIComponent(b.encode(JSON.stringify(w))),modified:(new Date).getTime()}),v=h.length<c(),E)switch(this.config.requestType){case"xhr":d.call(this,"POST",r,w,s);break;case"beacon":v?f.call(this,h,s):u.call(this,r,w,"Beacon URL length exceeds current browser limit, and XHR is not supported.",s);break;default:v?m.call(this,h,s):u.call(this,r,w,"JSONp URL length exceeds current browser limit, and XHR is not supported.",s)}else v&&p(h);return n=s=null,this}}function r(e,t){var n,i,r,o=this;if(n=this.url("events"),i=t,t=null,a.call(this,i))return"object"!=typeof e||e instanceof Array?void l.call(this,"First argument must be an object",i):arguments.length>2?void l.call(this,"Incorrect arguments provided to #recordEvents method",i):(this.config.globalProperties&&v(e,function(t,n){v(t,function(t,i){var r=o.config.globalProperties(n);e[n][i]=y(r,t)})}),r={},v(e,function(e,t){r[t]=r[t]||[],v(e,function(e,n){var i={};S.getExtendedEventBody(i,o.extensions.events),S.getExtendedEventBody(i,o.extensions.collections[t]),S.getExtendedEventBody(i,[e]),r[t].push(i)})}),this.emit("recordEvents",r),g.enabled?(h()&&d.call(this,"POST",n,r,i),t=i=null,this):(l.call(this,"Keen.enabled is set to false.",i),!1))}function o(){this.emit("error","This method has been deprecated. Check out #recordEvent: https://github.com/keen/keen-tracking.js#record-a-single-event"),i.apply(this,arguments)}function s(){this.emit("error","This method has been deprecated. Check out #recordEvents: https://github.com/keen/keen-tracking.js#record-multiple-events"),r.apply(this,arguments)}function a(e){var t=e;return e=null,this.projectId()?!!this.writeKey()||(l.call(this,"Keen.Client is missing a writeKey property.",t),!1):(l.call(this,"Keen.Client is missing a projectId property.",t),!1)}function l(e,t){var n="Event(s) not recorded: "+e;this.emit("error",n),t&&(t.call(this,n,null),t=null)}function c(){return"undefined"!=typeof window&&navigator&&(navigator.userAgent.indexOf("MSIE")!==-1||navigator.appVersion.indexOf("Trident/")>0)?2e3:16e3;
}function u(e,t,n,i){h()?d.call(this,"POST",e,t,i):l.call(this,n)}function d(e,t,n,i){var r,o=this,s=h(),a=i;i=null,s.onreadystatechange=function(){var e;if(4==s.readyState)if(s.status>=200&&s.status<300){try{e=JSON.parse(s.responseText)}catch(e){g.emit("error","Could not parse HTTP response: "+s.responseText),a&&a.call(o,s,null)}a&&e&&a.call(o,null,e)}else g.emit("error","HTTP request failed."),a&&a.call(o,s,null)},s.open(e,t,!0),s.setRequestHeader("Authorization",o.writeKey()),s.setRequestHeader("Content-Type","application/json"),n&&(r=JSON.stringify(n)),"GET"===e.toUpperCase()&&s.send(),"POST"===e.toUpperCase()&&s.send(r)}function p(e){var t=h();t&&(t.open("GET",e,!1),t.send(null))}function h(){var e="undefined"==typeof window?this:window;if(e.XMLHttpRequest&&("file:"!=e.location.protocol||!e.ActiveXObject))return new XMLHttpRequest;try{return new ActiveXObject("Microsoft.XMLHTTP")}catch(e){}try{return new ActiveXObject("Msxml2.XMLHTTP.6.0")}catch(e){}try{return new ActiveXObject("Msxml2.XMLHTTP.3.0")}catch(e){}try{return new ActiveXObject("Msxml2.XMLHTTP")}catch(e){}return!1}function m(e,t){function n(){o&&o.call(r,"An error occurred!",null)}function i(){window[c]=void 0;try{delete window[c]}catch(e){}l.removeChild(a)}var r=this,o=t,s=(new Date).getTime(),a=document.createElement("script"),l=document.getElementsByTagName("head")[0],c="keenJSONPCallback",u=!1;for(t=null,c+=s;c in window;)c+="a";window[c]=function(e){u!==!0&&(u=!0,o&&o.call(r,null,e),i())},a.src=e+"&jsonp="+c,l.appendChild(a),a.onreadystatechange=function(){u===!1&&"loaded"===this.readyState&&(u=!0,n(),i())},a.onerror=function(){u===!1&&(u=!0,n(),i())}}function f(e,t){var n=this,i=t,r=document.createElement("img"),o=!1;t=null,r.onload=function(){if(o=!0,"naturalHeight"in this){if(this.naturalHeight+this.naturalWidth===0)return void this.onerror()}else if(this.width+this.height===0)return void this.onerror();i&&i.call(n)},r.onerror=function(){o=!0,i&&i.call(n,"An error occurred!",null)},r.src=e+"&c=clv1"}var g=n(208),b=n(220),v=n(215),y=n(216),S=n(222);e.exports={recordEvent:i,recordEvents:r,addEvent:o,addEvents:s}},function(e,t,n){e.exports=n(221)},function(e,t){e.exports={map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){"use strict";var t,n,i,r,o,s,a,l="",c=0,u=this.map;for(e=this.utf8.encode(e);c<e.length;)t=e.charCodeAt(c++),n=e.charCodeAt(c++),i=e.charCodeAt(c++),r=t>>2,o=(3&t)<<4|n>>4,s=isNaN(n)?64:(15&n)<<2|i>>6,a=isNaN(n)||isNaN(i)?64:63&i,l=l+u.charAt(r)+u.charAt(o)+u.charAt(s)+u.charAt(a);return l},decode:function(e){"use strict";var t,n,i,r,o,s,a,l="",c=0,u=this.map,d=String.fromCharCode;for(e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");c<e.length;)t=u.indexOf(e.charAt(c++)),n=u.indexOf(e.charAt(c++)),i=u.indexOf(e.charAt(c++)),r=u.indexOf(e.charAt(c++)),o=t<<2|n>>4,s=(15&n)<<4|i>>2,a=(3&i)<<6|r,l=l+(d(o)+(64!=i?d(s):""))+(64!=r?d(a):"");return this.utf8.decode(l)},utf8:{encode:function(e){"use strict";for(var t,n="",i=0,r=String.fromCharCode;i<e.length;)t=e.charCodeAt(i++),n+=t<128?r(t):t>127&&t<2048?r(t>>6|192)+r(63&t|128):r(t>>12|224)+r(t>>6&63|128)+r(63&t|128);return n},decode:function(e){"use strict";for(var t,n,i="",r=0,o=String.fromCharCode;r<e.length;)n=e.charCodeAt(r),i+=n<128?[o(n),r++][0]:n>191&&n<224?[o((31&n)<<6|63&(t=e.charCodeAt(r+1))),r+=2][0]:[o((15&n)<<12|(63&(t=e.charCodeAt(r+1)))<<6|63&(c3=e.charCodeAt(r+2))),r+=3][0];return i}}}},function(e,t,n){function i(e,t){return 2!==arguments.length||"string"!=typeof e||"object"!=typeof t&&"function"!=typeof t?void o.call(this,"Incorrect arguments provided to #extendEvent method"):(this.extensions.collections[e]=this.extensions.collections[e]||[],this.extensions.collections[e].push(t),this.emit("extendEvent",e,t),this)}function r(e){return 1!==arguments.length||"object"!=typeof e&&"function"!=typeof e?void o.call(this,"Incorrect arguments provided to #extendEvents method"):(this.extensions.events.push(e),this.emit("extendEvents",e),this)}function o(e){var t="Event(s) not extended: "+e;this.emit("error",t)}function s(e,t){return t&&t.length>0&&l(t,function(t,n){var i="function"==typeof t?t():t;a(e,i)}),e}var a=n(223),l=n(215);e.exports={extendEvent:i,extendEvents:r,getExtendedEventBody:s}},function(e,t){function n(e){for(var t=1;t<arguments.length;t++)if(e instanceof Array&&arguments[t]instanceof Array)for(var r=0;r<arguments[t].length;r++)e.indexOf(arguments[t][r])<0&&e.push(arguments[t][r]);else for(var o in arguments[t])"undefined"!=typeof e[o]&&"object"==typeof arguments[t][o]&&null!==arguments[t][o]?n(e[o],i(arguments[t][o])):void 0!==arguments[t][o]&&(e[o]=i(arguments[t][o]));return e}function i(e){return JSON.parse(JSON.stringify(e))}e.exports=n},function(e,t,n){function i(e,t){return 2!==arguments.length||"string"!=typeof e?void l.call(this,"Incorrect arguments provided to #deferEvent method"):(this.queue.events[e]=this.queue.events[e]||[],this.queue.events[e].push(t),this.queue.capacity++,this.queue.timer||this.queue.start(),this.emit("deferEvent",e,t),this)}function r(e){var t=this;return 1!==arguments.length||"object"!=typeof e?void l.call(this,"Incorrect arguments provided to #deferEvents method"):(c(e,function(e,n){t.queue.events[n]=t.queue.events[n]||[],t.queue.events[n]=t.queue.events[n].concat(e),t.queue.capacity=t.queue.capacity+e.length,t.queue.timer||t.queue.start()}),t.emit("deferEvents",e),t)}function o(e){return arguments.length?(this.queue.config.capacity=e?Number(e):0,this.queue.check(),this):this.queue.config.capacity}function s(e){return arguments.length?(this.queue.config.interval=e?Number(e):0,this.queue.check(),this):this.queue.config.interval}function a(){var e,t,n=this;return n.queue.capacity>0&&(n.queue.pause(),e=JSON.parse(JSON.stringify(n.queue.config)),t=JSON.parse(JSON.stringify(n.queue.events)),n.queue=u(),n.queue.config=e,n.emit("recordDeferredEvents",t),n.recordEvents(t,function(e,i){e?n.recordEvents(t):t=void 0})),n}function l(e){var t="Event(s) not deferred: "+e;this.emit("error",t)}var c=(n(208),n(215)),u=n(217);e.exports={deferEvent:i,deferEvents:r,queueCapacity:o,queueInterval:s,recordDeferredEvents:a}},function(e,t,n){function i(){return{cookies:"undefined"!=typeof navigator.cookieEnabled&&navigator.cookieEnabled,codeName:navigator.appCodeName,language:navigator.language,name:navigator.appName,online:navigator.onLine,platform:navigator.platform,useragent:navigator.userAgent,version:navigator.appVersion,screen:r(),window:o()}}var r=n(226),o=n(227);e.exports=i},function(e,t){function n(){var e,t;if("undefined"==typeof window||!window.screen)return{};e=["height","width","colorDepth","pixelDepth","availHeight","availWidth"],t={};for(var n=0;n<e.length;n++)t[e[n]]=window.screen[e[n]]?window.screen[e[n]]:null;return t.orientation={angle:window.screen.orientation?window.screen.orientation.angle:0,type:window.innerWidth>window.innerHeight?"landscape":"portrait"},t}e.exports=n},function(e,t){function n(){var e,t,n;return"undefined"==typeof document?{}:(e=document.body,t=document.documentElement,n={height:"innerHeight"in window?window.innerHeight:document.documentElement.offsetHeight,width:"innerWidth"in window?window.innerWidth:document.documentElement.offsetWidth,scrollHeight:Math.max(e.scrollHeight,e.offsetHeight,t.clientHeight,t.scrollHeight,t.offsetHeight)||null},window.screen&&(n.ratio={height:window.screen.availHeight?parseFloat((window.innerHeight/window.screen.availHeight).toFixed(2)):null,width:window.screen.availWidth?parseFloat((window.innerWidth/window.screen.availWidth).toFixed(2)):null}),n)}e.exports=n},function(e,t){function n(e){var t=e||new Date;return{hour_of_day:t.getHours(),day_of_week:parseInt(1+t.getDay()),day_of_month:t.getDate(),month:parseInt(1+t.getMonth()),year:t.getFullYear()}}e.exports=n},function(e,t){function n(e){if(!e.nodeName)return"";for(var t=[];null!=e.parentNode;){for(var n=0,i=0,r=0;r<e.parentNode.childNodes.length;r++){var o=e.parentNode.childNodes[r];o.nodeName==e.nodeName&&(o===e&&(i=n),n++)}e.hasAttribute("id")&&""!=e.id?t.unshift(e.nodeName.toLowerCase()+"#"+e.id):n>1?t.unshift(e.nodeName.toLowerCase()+":eq("+i+")"):t.unshift(e.nodeName.toLowerCase()),e=e.parentNode}return t.slice(1).join(" > ")}e.exports=n},function(e,t){function n(){var e="xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx";return e.replace(/[xy]/g,function(e){var t=16*Math.random()|0,n="x"==e?t:3&t|8;return n.toString(16)})}e.exports=n},function(e,t,n){function i(e){if(arguments.length)return this instanceof i==!1?new i(e):(this.config={key:e,options:{expires:365}},this.data=this.get(),this)}var r=n(232),o=n(216);e.exports=i,i.prototype.get=function(e){var t={};return r.get(this.config.key)&&(t=r.getJSON(this.config.key)),e&&"object"==typeof t&&null!==typeof t?"undefined"!=typeof t[e]?t[e]:null:t},i.prototype.set=function(e,t){return arguments.length&&this.enabled()?("string"==typeof e&&2===arguments.length?this.data[e]=t?t:null:"object"==typeof e&&1===arguments.length&&o(this.data,e),r.set(this.config.key,this.data,this.config.options),this):this},i.prototype.expire=function(e){return e?r.set(this.config.key,this.data,o(this.config.options,{expires:e})):(r.remove(this.config.key),this.data={}),this},i.prototype.options=function(e){return arguments.length?(this.config.options="object"==typeof e?e:{},this):this.config.options},i.prototype.enabled=function(){return navigator.cookieEnabled}},function(e,t,n){var i,r;!function(o){i=o,r="function"==typeof i?i.call(t,n,t,e):i,!(void 0!==r&&(e.exports=r))}(function(){function e(){for(var e=0,t={};e<arguments.length;e++){var n=arguments[e];for(var i in n)t[i]=n[i]}return t}function t(n){function i(t,r,o){var s;if(arguments.length>1){if(o=e({path:"/"},i.defaults,o),"number"==typeof o.expires){var a=new Date;a.setMilliseconds(a.getMilliseconds()+864e5*o.expires),o.expires=a}try{s=JSON.stringify(r),/^[\{\[]/.test(s)&&(r=s)}catch(e){}return r=n.write?n.write(r,t):encodeURIComponent(String(r)).replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g,decodeURIComponent),t=encodeURIComponent(String(t)),t=t.replace(/%(23|24|26|2B|5E|60|7C)/g,decodeURIComponent),t=t.replace(/[\(\)]/g,escape),document.cookie=[t,"=",r,o.expires&&"; expires="+o.expires.toUTCString(),o.path&&"; path="+o.path,o.domain&&"; domain="+o.domain,o.secure?"; secure":""].join("")}t||(s={});for(var l=document.cookie?document.cookie.split("; "):[],c=/(%[0-9A-Z]{2})+/g,u=0;u<l.length;u++){var d=l[u].split("="),p=d[0].replace(c,decodeURIComponent),h=d.slice(1).join("=");'"'===h.charAt(0)&&(h=h.slice(1,-1));try{if(h=n.read?n.read(h,p):n(h,p)||h.replace(c,decodeURIComponent),this.json)try{h=JSON.parse(h)}catch(e){}if(t===p){s=h;break}t||(s[p]=h)}catch(e){}}return s}return i.get=i.set=i,i.getJSON=function(){return i.apply({json:!0},[].slice.call(arguments))},i.defaults={},i.remove=function(t,n){i(t,"",e(n,{expires:-1}))},i.withConverter=t,i}return t(function(){})})},function(e,t){function n(e){return this instanceof n==!1?new n(e):(this.count=e||0,this)}e.exports=n,n.prototype.start=function(){var e=this;return this.pause(),this.interval=setInterval(function(){e.count++},1e3),this},n.prototype.pause=function(){return clearInterval(this.interval),this},n.prototype.value=function(){return this.count},n.prototype.clear=function(){return this.count=0,this}},function(e,t,n){!function(e,t){e(function(){"use strict";function e(e,t){return null!=e&&null!=t&&e.toLowerCase()===t.toLowerCase()}function n(e,t){var n,i,r=e.length;if(!r||!t)return!1;for(n=t.toLowerCase(),i=0;i<r;++i)if(n===e[i].toLowerCase())return!0;return!1}function i(e){for(var t in e)a.call(e,t)&&(e[t]=new RegExp(e[t],"i"))}function r(e,t){this.ua=e||"",this._cache={},this.maxPhoneWidth=t||600}var o={};o.mobileDetectRules={phones:{iPhone:"\\biPhone\\b|\\biPod\\b",BlackBerry:"BlackBerry|\\bBB10\\b|rim[0-9]+",HTC:"HTC|HTC.*(Sensation|Evo|Vision|Explorer|6800|8100|8900|A7272|S510e|C110e|Legend|Desire|T8282)|APX515CKT|Qtek9090|APA9292KT|HD_mini|Sensation.*Z710e|PG86100|Z715e|Desire.*(A8181|HD)|ADR6200|ADR6400L|ADR6425|001HT|Inspire 4G|Android.*\\bEVO\\b|T-Mobile G1|Z520m",Nexus:"Nexus One|Nexus S|Galaxy.*Nexus|Android.*Nexus.*Mobile|Nexus 4|Nexus 5|Nexus 6",Dell:"Dell.*Streak|Dell.*Aero|Dell.*Venue|DELL.*Venue Pro|Dell Flash|Dell Smoke|Dell Mini 3iX|XCD28|XCD35|\\b001DL\\b|\\b101DL\\b|\\bGS01\\b",Motorola:"Motorola|DROIDX|DROID BIONIC|\\bDroid\\b.*Build|Android.*Xoom|HRI39|MOT-|A1260|A1680|A555|A853|A855|A953|A955|A956|Motorola.*ELECTRIFY|Motorola.*i1|i867|i940|MB200|MB300|MB501|MB502|MB508|MB511|MB520|MB525|MB526|MB611|MB612|MB632|MB810|MB855|MB860|MB861|MB865|MB870|ME501|ME502|ME511|ME525|ME600|ME632|ME722|ME811|ME860|ME863|ME865|MT620|MT710|MT716|MT720|MT810|MT870|MT917|Motorola.*TITANIUM|WX435|WX445|XT300|XT301|XT311|XT316|XT317|XT319|XT320|XT390|XT502|XT530|XT531|XT532|XT535|XT603|XT610|XT611|XT615|XT681|XT701|XT702|XT711|XT720|XT800|XT806|XT860|XT862|XT875|XT882|XT883|XT894|XT901|XT907|XT909|XT910|XT912|XT928|XT926|XT915|XT919|XT925|XT1021|\\bMoto E\\b",Samsung:"\\bSamsung\\b|SM-G9250|GT-19300|SGH-I337|BGT-S5230|GT-B2100|GT-B2700|GT-B2710|GT-B3210|GT-B3310|GT-B3410|GT-B3730|GT-B3740|GT-B5510|GT-B5512|GT-B5722|GT-B6520|GT-B7300|GT-B7320|GT-B7330|GT-B7350|GT-B7510|GT-B7722|GT-B7800|GT-C3010|GT-C3011|GT-C3060|GT-C3200|GT-C3212|GT-C3212I|GT-C3262|GT-C3222|GT-C3300|GT-C3300K|GT-C3303|GT-C3303K|GT-C3310|GT-C3322|GT-C3330|GT-C3350|GT-C3500|GT-C3510|GT-C3530|GT-C3630|GT-C3780|GT-C5010|GT-C5212|GT-C6620|GT-C6625|GT-C6712|GT-E1050|GT-E1070|GT-E1075|GT-E1080|GT-E1081|GT-E1085|GT-E1087|GT-E1100|GT-E1107|GT-E1110|GT-E1120|GT-E1125|GT-E1130|GT-E1160|GT-E1170|GT-E1175|GT-E1180|GT-E1182|GT-E1200|GT-E1210|GT-E1225|GT-E1230|GT-E1390|GT-E2100|GT-E2120|GT-E2121|GT-E2152|GT-E2220|GT-E2222|GT-E2230|GT-E2232|GT-E2250|GT-E2370|GT-E2550|GT-E2652|GT-E3210|GT-E3213|GT-I5500|GT-I5503|GT-I5700|GT-I5800|GT-I5801|GT-I6410|GT-I6420|GT-I7110|GT-I7410|GT-I7500|GT-I8000|GT-I8150|GT-I8160|GT-I8190|GT-I8320|GT-I8330|GT-I8350|GT-I8530|GT-I8700|GT-I8703|GT-I8910|GT-I9000|GT-I9001|GT-I9003|GT-I9010|GT-I9020|GT-I9023|GT-I9070|GT-I9082|GT-I9100|GT-I9103|GT-I9220|GT-I9250|GT-I9300|GT-I9305|GT-I9500|GT-I9505|GT-M3510|GT-M5650|GT-M7500|GT-M7600|GT-M7603|GT-M8800|GT-M8910|GT-N7000|GT-S3110|GT-S3310|GT-S3350|GT-S3353|GT-S3370|GT-S3650|GT-S3653|GT-S3770|GT-S3850|GT-S5210|GT-S5220|GT-S5229|GT-S5230|GT-S5233|GT-S5250|GT-S5253|GT-S5260|GT-S5263|GT-S5270|GT-S5300|GT-S5330|GT-S5350|GT-S5360|GT-S5363|GT-S5369|GT-S5380|GT-S5380D|GT-S5560|GT-S5570|GT-S5600|GT-S5603|GT-S5610|GT-S5620|GT-S5660|GT-S5670|GT-S5690|GT-S5750|GT-S5780|GT-S5830|GT-S5839|GT-S6102|GT-S6500|GT-S7070|GT-S7200|GT-S7220|GT-S7230|GT-S7233|GT-S7250|GT-S7500|GT-S7530|GT-S7550|GT-S7562|GT-S7710|GT-S8000|GT-S8003|GT-S8500|GT-S8530|GT-S8600|SCH-A310|SCH-A530|SCH-A570|SCH-A610|SCH-A630|SCH-A650|SCH-A790|SCH-A795|SCH-A850|SCH-A870|SCH-A890|SCH-A930|SCH-A950|SCH-A970|SCH-A990|SCH-I100|SCH-I110|SCH-I400|SCH-I405|SCH-I500|SCH-I510|SCH-I515|SCH-I600|SCH-I730|SCH-I760|SCH-I770|SCH-I830|SCH-I910|SCH-I920|SCH-I959|SCH-LC11|SCH-N150|SCH-N300|SCH-R100|SCH-R300|SCH-R351|SCH-R400|SCH-R410|SCH-T300|SCH-U310|SCH-U320|SCH-U350|SCH-U360|SCH-U365|SCH-U370|SCH-U380|SCH-U410|SCH-U430|SCH-U450|SCH-U460|SCH-U470|SCH-U490|SCH-U540|SCH-U550|SCH-U620|SCH-U640|SCH-U650|SCH-U660|SCH-U700|SCH-U740|SCH-U750|SCH-U810|SCH-U820|SCH-U900|SCH-U940|SCH-U960|SCS-26UC|SGH-A107|SGH-A117|SGH-A127|SGH-A137|SGH-A157|SGH-A167|SGH-A177|SGH-A187|SGH-A197|SGH-A227|SGH-A237|SGH-A257|SGH-A437|SGH-A517|SGH-A597|SGH-A637|SGH-A657|SGH-A667|SGH-A687|SGH-A697|SGH-A707|SGH-A717|SGH-A727|SGH-A737|SGH-A747|SGH-A767|SGH-A777|SGH-A797|SGH-A817|SGH-A827|SGH-A837|SGH-A847|SGH-A867|SGH-A877|SGH-A887|SGH-A897|SGH-A927|SGH-B100|SGH-B130|SGH-B200|SGH-B220|SGH-C100|SGH-C110|SGH-C120|SGH-C130|SGH-C140|SGH-C160|SGH-C170|SGH-C180|SGH-C200|SGH-C207|SGH-C210|SGH-C225|SGH-C230|SGH-C417|SGH-C450|SGH-D307|SGH-D347|SGH-D357|SGH-D407|SGH-D415|SGH-D780|SGH-D807|SGH-D980|SGH-E105|SGH-E200|SGH-E315|SGH-E316|SGH-E317|SGH-E335|SGH-E590|SGH-E635|SGH-E715|SGH-E890|SGH-F300|SGH-F480|SGH-I200|SGH-I300|SGH-I320|SGH-I550|SGH-I577|SGH-I600|SGH-I607|SGH-I617|SGH-I627|SGH-I637|SGH-I677|SGH-I700|SGH-I717|SGH-I727|SGH-i747M|SGH-I777|SGH-I780|SGH-I827|SGH-I847|SGH-I857|SGH-I896|SGH-I897|SGH-I900|SGH-I907|SGH-I917|SGH-I927|SGH-I937|SGH-I997|SGH-J150|SGH-J200|SGH-L170|SGH-L700|SGH-M110|SGH-M150|SGH-M200|SGH-N105|SGH-N500|SGH-N600|SGH-N620|SGH-N625|SGH-N700|SGH-N710|SGH-P107|SGH-P207|SGH-P300|SGH-P310|SGH-P520|SGH-P735|SGH-P777|SGH-Q105|SGH-R210|SGH-R220|SGH-R225|SGH-S105|SGH-S307|SGH-T109|SGH-T119|SGH-T139|SGH-T209|SGH-T219|SGH-T229|SGH-T239|SGH-T249|SGH-T259|SGH-T309|SGH-T319|SGH-T329|SGH-T339|SGH-T349|SGH-T359|SGH-T369|SGH-T379|SGH-T409|SGH-T429|SGH-T439|SGH-T459|SGH-T469|SGH-T479|SGH-T499|SGH-T509|SGH-T519|SGH-T539|SGH-T559|SGH-T589|SGH-T609|SGH-T619|SGH-T629|SGH-T639|SGH-T659|SGH-T669|SGH-T679|SGH-T709|SGH-T719|SGH-T729|SGH-T739|SGH-T746|SGH-T749|SGH-T759|SGH-T769|SGH-T809|SGH-T819|SGH-T839|SGH-T919|SGH-T929|SGH-T939|SGH-T959|SGH-T989|SGH-U100|SGH-U200|SGH-U800|SGH-V205|SGH-V206|SGH-X100|SGH-X105|SGH-X120|SGH-X140|SGH-X426|SGH-X427|SGH-X475|SGH-X495|SGH-X497|SGH-X507|SGH-X600|SGH-X610|SGH-X620|SGH-X630|SGH-X700|SGH-X820|SGH-X890|SGH-Z130|SGH-Z150|SGH-Z170|SGH-ZX10|SGH-ZX20|SHW-M110|SPH-A120|SPH-A400|SPH-A420|SPH-A460|SPH-A500|SPH-A560|SPH-A600|SPH-A620|SPH-A660|SPH-A700|SPH-A740|SPH-A760|SPH-A790|SPH-A800|SPH-A820|SPH-A840|SPH-A880|SPH-A900|SPH-A940|SPH-A960|SPH-D600|SPH-D700|SPH-D710|SPH-D720|SPH-I300|SPH-I325|SPH-I330|SPH-I350|SPH-I500|SPH-I600|SPH-I700|SPH-L700|SPH-M100|SPH-M220|SPH-M240|SPH-M300|SPH-M305|SPH-M320|SPH-M330|SPH-M350|SPH-M360|SPH-M370|SPH-M380|SPH-M510|SPH-M540|SPH-M550|SPH-M560|SPH-M570|SPH-M580|SPH-M610|SPH-M620|SPH-M630|SPH-M800|SPH-M810|SPH-M850|SPH-M900|SPH-M910|SPH-M920|SPH-M930|SPH-N100|SPH-N200|SPH-N240|SPH-N300|SPH-N400|SPH-Z400|SWC-E100|SCH-i909|GT-N7100|GT-N7105|SCH-I535|SM-N900A|SGH-I317|SGH-T999L|GT-S5360B|GT-I8262|GT-S6802|GT-S6312|GT-S6310|GT-S5312|GT-S5310|GT-I9105|GT-I8510|GT-S6790N|SM-G7105|SM-N9005|GT-S5301|GT-I9295|GT-I9195|SM-C101|GT-S7392|GT-S7560|GT-B7610|GT-I5510|GT-S7582|GT-S7530E|GT-I8750|SM-G9006V|SM-G9008V|SM-G9009D|SM-G900A|SM-G900D|SM-G900F|SM-G900H|SM-G900I|SM-G900J|SM-G900K|SM-G900L|SM-G900M|SM-G900P|SM-G900R4|SM-G900S|SM-G900T|SM-G900V|SM-G900W8|SHV-E160K|SCH-P709|SCH-P729|SM-T2558|GT-I9205|SM-G9350|SM-J120F|SM-G920F|SM-G920V|SM-G930F|SM-N910C",LG:"\\bLG\\b;|LG[- ]?(C800|C900|E400|E610|E900|E-900|F160|F180K|F180L|F180S|730|855|L160|LS740|LS840|LS970|LU6200|MS690|MS695|MS770|MS840|MS870|MS910|P500|P700|P705|VM696|AS680|AS695|AX840|C729|E970|GS505|272|C395|E739BK|E960|L55C|L75C|LS696|LS860|P769BK|P350|P500|P509|P870|UN272|US730|VS840|VS950|LN272|LN510|LS670|LS855|LW690|MN270|MN510|P509|P769|P930|UN200|UN270|UN510|UN610|US670|US740|US760|UX265|UX840|VN271|VN530|VS660|VS700|VS740|VS750|VS910|VS920|VS930|VX9200|VX11000|AX840A|LW770|P506|P925|P999|E612|D955|D802|MS323)",Sony:"SonyST|SonyLT|SonyEricsson|SonyEricssonLT15iv|LT18i|E10i|LT28h|LT26w|SonyEricssonMT27i|C5303|C6902|C6903|C6906|C6943|D2533",Asus:"Asus.*Galaxy|PadFone.*Mobile",NokiaLumia:"Lumia [0-9]{3,4}",Micromax:"Micromax.*\\b(A210|A92|A88|A72|A111|A110Q|A115|A116|A110|A90S|A26|A51|A35|A54|A25|A27|A89|A68|A65|A57|A90)\\b",Palm:"PalmSource|Palm",Vertu:"Vertu|Vertu.*Ltd|Vertu.*Ascent|Vertu.*Ayxta|Vertu.*Constellation(F|Quest)?|Vertu.*Monika|Vertu.*Signature",Pantech:"PANTECH|IM-A850S|IM-A840S|IM-A830L|IM-A830K|IM-A830S|IM-A820L|IM-A810K|IM-A810S|IM-A800S|IM-T100K|IM-A725L|IM-A780L|IM-A775C|IM-A770K|IM-A760S|IM-A750K|IM-A740S|IM-A730S|IM-A720L|IM-A710K|IM-A690L|IM-A690S|IM-A650S|IM-A630K|IM-A600S|VEGA PTL21|PT003|P8010|ADR910L|P6030|P6020|P9070|P4100|P9060|P5000|CDM8992|TXT8045|ADR8995|IS11PT|P2030|P6010|P8000|PT002|IS06|CDM8999|P9050|PT001|TXT8040|P2020|P9020|P2000|P7040|P7000|C790",Fly:"IQ230|IQ444|IQ450|IQ440|IQ442|IQ441|IQ245|IQ256|IQ236|IQ255|IQ235|IQ245|IQ275|IQ240|IQ285|IQ280|IQ270|IQ260|IQ250",Wiko:"KITE 4G|HIGHWAY|GETAWAY|STAIRWAY|DARKSIDE|DARKFULL|DARKNIGHT|DARKMOON|SLIDE|WAX 4G|RAINBOW|BLOOM|SUNSET|GOA(?!nna)|LENNY|BARRY|IGGY|OZZY|CINK FIVE|CINK PEAX|CINK PEAX 2|CINK SLIM|CINK SLIM 2|CINK +|CINK KING|CINK PEAX|CINK SLIM|SUBLIM",iMobile:"i-mobile (IQ|i-STYLE|idea|ZAA|Hitz)",SimValley:"\\b(SP-80|XT-930|SX-340|XT-930|SX-310|SP-360|SP60|SPT-800|SP-120|SPT-800|SP-140|SPX-5|SPX-8|SP-100|SPX-8|SPX-12)\\b",Wolfgang:"AT-B24D|AT-AS50HD|AT-AS40W|AT-AS55HD|AT-AS45q2|AT-B26D|AT-AS50Q",Alcatel:"Alcatel",Nintendo:"Nintendo 3DS",Amoi:"Amoi",INQ:"INQ",GenericPhone:"Tapatalk|PDA;|SAGEM|\\bmmp\\b|pocket|\\bpsp\\b|symbian|Smartphone|smartfon|treo|up.browser|up.link|vodafone|\\bwap\\b|nokia|Series40|Series60|S60|SonyEricsson|N900|MAUI.*WAP.*Browser"},tablets:{iPad:"iPad|iPad.*Mobile",NexusTablet:"Android.*Nexus[\\s]+(7|9|10)",SamsungTablet:"SAMSUNG.*Tablet|Galaxy.*Tab|SC-01C|GT-P1000|GT-P1003|GT-P1010|GT-P3105|GT-P6210|GT-P6800|GT-P6810|GT-P7100|GT-P7300|GT-P7310|GT-P7500|GT-P7510|SCH-I800|SCH-I815|SCH-I905|SGH-I957|SGH-I987|SGH-T849|SGH-T859|SGH-T869|SPH-P100|GT-P3100|GT-P3108|GT-P3110|GT-P5100|GT-P5110|GT-P6200|GT-P7320|GT-P7511|GT-N8000|GT-P8510|SGH-I497|SPH-P500|SGH-T779|SCH-I705|SCH-I915|GT-N8013|GT-P3113|GT-P5113|GT-P8110|GT-N8010|GT-N8005|GT-N8020|GT-P1013|GT-P6201|GT-P7501|GT-N5100|GT-N5105|GT-N5110|SHV-E140K|SHV-E140L|SHV-E140S|SHV-E150S|SHV-E230K|SHV-E230L|SHV-E230S|SHW-M180K|SHW-M180L|SHW-M180S|SHW-M180W|SHW-M300W|SHW-M305W|SHW-M380K|SHW-M380S|SHW-M380W|SHW-M430W|SHW-M480K|SHW-M480S|SHW-M480W|SHW-M485W|SHW-M486W|SHW-M500W|GT-I9228|SCH-P739|SCH-I925|GT-I9200|GT-P5200|GT-P5210|GT-P5210X|SM-T311|SM-T310|SM-T310X|SM-T210|SM-T210R|SM-T211|SM-P600|SM-P601|SM-P605|SM-P900|SM-P901|SM-T217|SM-T217A|SM-T217S|SM-P6000|SM-T3100|SGH-I467|XE500|SM-T110|GT-P5220|GT-I9200X|GT-N5110X|GT-N5120|SM-P905|SM-T111|SM-T2105|SM-T315|SM-T320|SM-T320X|SM-T321|SM-T520|SM-T525|SM-T530NU|SM-T230NU|SM-T330NU|SM-T900|XE500T1C|SM-P605V|SM-P905V|SM-T337V|SM-T537V|SM-T707V|SM-T807V|SM-P600X|SM-P900X|SM-T210X|SM-T230|SM-T230X|SM-T325|GT-P7503|SM-T531|SM-T330|SM-T530|SM-T705|SM-T705C|SM-T535|SM-T331|SM-T800|SM-T700|SM-T537|SM-T807|SM-P907A|SM-T337A|SM-T537A|SM-T707A|SM-T807A|SM-T237|SM-T807P|SM-P607T|SM-T217T|SM-T337T|SM-T807T|SM-T116NQ|SM-T116BU|SM-P550|SM-T350|SM-T550|SM-T9000|SM-P9000|SM-T705Y|SM-T805|GT-P3113|SM-T710|SM-T810|SM-T815|SM-T360|SM-T533|SM-T113|SM-T335|SM-T715|SM-T560|SM-T670|SM-T677|SM-T377|SM-T567|SM-T357T|SM-T555|SM-T561|SM-T713|SM-T719|SM-T813|SM-T819|SM-T580|SM-T355Y|SM-T280|SM-T817A|SM-T820|SM-W700|SM-P580|SM-T587|SM-P350|SM-P555M|SM-P355M|SM-T113NU|SM-T815Y",Kindle:"Kindle|Silk.*Accelerated|Android.*\\b(KFOT|KFTT|KFJWI|KFJWA|KFOTE|KFSOWI|KFTHWI|KFTHWA|KFAPWI|KFAPWA|WFJWAE|KFSAWA|KFSAWI|KFASWI|KFARWI|KFFOWI|KFGIWI|KFMEWI)\\b|Android.*Silk/[0-9.]+ like Chrome/[0-9.]+ (?!Mobile)",SurfaceTablet:"Windows NT [0-9.]+; ARM;.*(Tablet|ARMBJS)",HPTablet:"HP Slate (7|8|10)|HP ElitePad 900|hp-tablet|EliteBook.*Touch|HP 8|Slate 21|HP SlateBook 10",AsusTablet:"^.*PadFone((?!Mobile).)*$|Transformer|TF101|TF101G|TF300T|TF300TG|TF300TL|TF700T|TF700KL|TF701T|TF810C|ME171|ME301T|ME302C|ME371MG|ME370T|ME372MG|ME172V|ME173X|ME400C|Slider SL101|\\bK00F\\b|\\bK00C\\b|\\bK00E\\b|\\bK00L\\b|TX201LA|ME176C|ME102A|\\bM80TA\\b|ME372CL|ME560CG|ME372CG|ME302KL| K010 | K011 | K017 | K01E |ME572C|ME103K|ME170C|ME171C|\\bME70C\\b|ME581C|ME581CL|ME8510C|ME181C|P01Y|PO1MA|P01Z|\\bP027\\b",BlackBerryTablet:"PlayBook|RIM Tablet",HTCtablet:"HTC_Flyer_P512|HTC Flyer|HTC Jetstream|HTC-P715a|HTC EVO View 4G|PG41200|PG09410",MotorolaTablet:"xoom|sholest|MZ615|MZ605|MZ505|MZ601|MZ602|MZ603|MZ604|MZ606|MZ607|MZ608|MZ609|MZ615|MZ616|MZ617",NookTablet:"Android.*Nook|NookColor|nook browser|BNRV200|BNRV200A|BNTV250|BNTV250A|BNTV400|BNTV600|LogicPD Zoom2",AcerTablet:"Android.*; \\b(A100|A101|A110|A200|A210|A211|A500|A501|A510|A511|A700|A701|W500|W500P|W501|W501P|W510|W511|W700|G100|G100W|B1-A71|B1-710|B1-711|A1-810|A1-811|A1-830)\\b|W3-810|\\bA3-A10\\b|\\bA3-A11\\b|\\bA3-A20\\b|\\bA3-A30",ToshibaTablet:"Android.*(AT100|AT105|AT200|AT205|AT270|AT275|AT300|AT305|AT1S5|AT500|AT570|AT700|AT830)|TOSHIBA.*FOLIO",LGTablet:"\\bL-06C|LG-V909|LG-V900|LG-V700|LG-V510|LG-V500|LG-V410|LG-V400|LG-VK810\\b",FujitsuTablet:"Android.*\\b(F-01D|F-02F|F-05E|F-10D|M532|Q572)\\b",PrestigioTablet:"PMP3170B|PMP3270B|PMP3470B|PMP7170B|PMP3370B|PMP3570C|PMP5870C|PMP3670B|PMP5570C|PMP5770D|PMP3970B|PMP3870C|PMP5580C|PMP5880D|PMP5780D|PMP5588C|PMP7280C|PMP7280C3G|PMP7280|PMP7880D|PMP5597D|PMP5597|PMP7100D|PER3464|PER3274|PER3574|PER3884|PER5274|PER5474|PMP5097CPRO|PMP5097|PMP7380D|PMP5297C|PMP5297C_QUAD|PMP812E|PMP812E3G|PMP812F|PMP810E|PMP880TD|PMT3017|PMT3037|PMT3047|PMT3057|PMT7008|PMT5887|PMT5001|PMT5002",LenovoTablet:"Lenovo TAB|Idea(Tab|Pad)( A1|A10| K1|)|ThinkPad([ ]+)?Tablet|YT3-850M|YT3-X90L|YT3-X90F|YT3-X90X|Lenovo.*(S2109|S2110|S5000|S6000|K3011|A3000|A3500|A1000|A2107|A2109|A1107|A5500|A7600|B6000|B8000|B8080)(-|)(FL|F|HV|H|)",DellTablet:"Venue 11|Venue 8|Venue 7|Dell Streak 10|Dell Streak 7",YarvikTablet:"Android.*\\b(TAB210|TAB211|TAB224|TAB250|TAB260|TAB264|TAB310|TAB360|TAB364|TAB410|TAB411|TAB420|TAB424|TAB450|TAB460|TAB461|TAB464|TAB465|TAB467|TAB468|TAB07-100|TAB07-101|TAB07-150|TAB07-151|TAB07-152|TAB07-200|TAB07-201-3G|TAB07-210|TAB07-211|TAB07-212|TAB07-214|TAB07-220|TAB07-400|TAB07-485|TAB08-150|TAB08-200|TAB08-201-3G|TAB08-201-30|TAB09-100|TAB09-211|TAB09-410|TAB10-150|TAB10-201|TAB10-211|TAB10-400|TAB10-410|TAB13-201|TAB274EUK|TAB275EUK|TAB374EUK|TAB462EUK|TAB474EUK|TAB9-200)\\b",MedionTablet:"Android.*\\bOYO\\b|LIFE.*(P9212|P9514|P9516|S9512)|LIFETAB",ArnovaTablet:"97G4|AN10G2|AN7bG3|AN7fG3|AN8G3|AN8cG3|AN7G3|AN9G3|AN7dG3|AN7dG3ST|AN7dG3ChildPad|AN10bG3|AN10bG3DT|AN9G2",IntensoTablet:"INM8002KP|INM1010FP|INM805ND|Intenso Tab|TAB1004",IRUTablet:"M702pro",MegafonTablet:"MegaFon V9|\\bZTE V9\\b|Android.*\\bMT7A\\b",EbodaTablet:"E-Boda (Supreme|Impresspeed|Izzycomm|Essential)",AllViewTablet:"Allview.*(Viva|Alldro|City|Speed|All TV|Frenzy|Quasar|Shine|TX1|AX1|AX2)",ArchosTablet:"\\b(101G9|80G9|A101IT)\\b|Qilive 97R|Archos5|\\bARCHOS (70|79|80|90|97|101|FAMILYPAD|)(b|c|)(G10| Cobalt| TITANIUM(HD|)| Xenon| Neon|XSK| 2| XS 2| PLATINUM| CARBON|GAMEPAD)\\b",AinolTablet:"NOVO7|NOVO8|NOVO10|Novo7Aurora|Novo7Basic|NOVO7PALADIN|novo9-Spark",NokiaLumiaTablet:"Lumia 2520",SonyTablet:"Sony.*Tablet|Xperia Tablet|Sony Tablet S|SO-03E|SGPT12|SGPT13|SGPT114|SGPT121|SGPT122|SGPT123|SGPT111|SGPT112|SGPT113|SGPT131|SGPT132|SGPT133|SGPT211|SGPT212|SGPT213|SGP311|SGP312|SGP321|EBRD1101|EBRD1102|EBRD1201|SGP351|SGP341|SGP511|SGP512|SGP521|SGP541|SGP551|SGP621|SGP612|SOT31",PhilipsTablet:"\\b(PI2010|PI3000|PI3100|PI3105|PI3110|PI3205|PI3210|PI3900|PI4010|PI7000|PI7100)\\b",CubeTablet:"Android.*(K8GT|U9GT|U10GT|U16GT|U17GT|U18GT|U19GT|U20GT|U23GT|U30GT)|CUBE U8GT",CobyTablet:"MID1042|MID1045|MID1125|MID1126|MID7012|MID7014|MID7015|MID7034|MID7035|MID7036|MID7042|MID7048|MID7127|MID8042|MID8048|MID8127|MID9042|MID9740|MID9742|MID7022|MID7010",MIDTablet:"M9701|M9000|M9100|M806|M1052|M806|T703|MID701|MID713|MID710|MID727|MID760|MID830|MID728|MID933|MID125|MID810|MID732|MID120|MID930|MID800|MID731|MID900|MID100|MID820|MID735|MID980|MID130|MID833|MID737|MID960|MID135|MID860|MID736|MID140|MID930|MID835|MID733|MID4X10",MSITablet:"MSI \\b(Primo 73K|Primo 73L|Primo 81L|Primo 77|Primo 93|Primo 75|Primo 76|Primo 73|Primo 81|Primo 91|Primo 90|Enjoy 71|Enjoy 7|Enjoy 10)\\b",SMiTTablet:"Android.*(\\bMID\\b|MID-560|MTV-T1200|MTV-PND531|MTV-P1101|MTV-PND530)",RockChipTablet:"Android.*(RK2818|RK2808A|RK2918|RK3066)|RK2738|RK2808A",FlyTablet:"IQ310|Fly Vision",bqTablet:"Android.*(bq)?.*(Elcano|Curie|Edison|Maxwell|Kepler|Pascal|Tesla|Hypatia|Platon|Newton|Livingstone|Cervantes|Avant|Aquaris [E|M]10)|Maxwell.*Lite|Maxwell.*Plus",HuaweiTablet:"MediaPad|MediaPad 7 Youth|IDEOS S7|S7-201c|S7-202u|S7-101|S7-103|S7-104|S7-105|S7-106|S7-201|S7-Slim",NecTablet:"\\bN-06D|\\bN-08D",PantechTablet:"Pantech.*P4100",BronchoTablet:"Broncho.*(N701|N708|N802|a710)",VersusTablet:"TOUCHPAD.*[78910]|\\bTOUCHTAB\\b",ZyncTablet:"z1000|Z99 2G|z99|z930|z999|z990|z909|Z919|z900",PositivoTablet:"TB07STA|TB10STA|TB07FTA|TB10FTA",NabiTablet:"Android.*\\bNabi",KoboTablet:"Kobo Touch|\\bK080\\b|\\bVox\\b Build|\\bArc\\b Build",DanewTablet:"DSlide.*\\b(700|701R|702|703R|704|802|970|971|972|973|974|1010|1012)\\b",TexetTablet:"NaviPad|TB-772A|TM-7045|TM-7055|TM-9750|TM-7016|TM-7024|TM-7026|TM-7041|TM-7043|TM-7047|TM-8041|TM-9741|TM-9747|TM-9748|TM-9751|TM-7022|TM-7021|TM-7020|TM-7011|TM-7010|TM-7023|TM-7025|TM-7037W|TM-7038W|TM-7027W|TM-9720|TM-9725|TM-9737W|TM-1020|TM-9738W|TM-9740|TM-9743W|TB-807A|TB-771A|TB-727A|TB-725A|TB-719A|TB-823A|TB-805A|TB-723A|TB-715A|TB-707A|TB-705A|TB-709A|TB-711A|TB-890HD|TB-880HD|TB-790HD|TB-780HD|TB-770HD|TB-721HD|TB-710HD|TB-434HD|TB-860HD|TB-840HD|TB-760HD|TB-750HD|TB-740HD|TB-730HD|TB-722HD|TB-720HD|TB-700HD|TB-500HD|TB-470HD|TB-431HD|TB-430HD|TB-506|TB-504|TB-446|TB-436|TB-416|TB-146SE|TB-126SE",PlaystationTablet:"Playstation.*(Portable|Vita)",TrekstorTablet:"ST10416-1|VT10416-1|ST70408-1|ST702xx-1|ST702xx-2|ST80208|ST97216|ST70104-2|VT10416-2|ST10216-2A|SurfTab",PyleAudioTablet:"\\b(PTBL10CEU|PTBL10C|PTBL72BC|PTBL72BCEU|PTBL7CEU|PTBL7C|PTBL92BC|PTBL92BCEU|PTBL9CEU|PTBL9CUK|PTBL9C)\\b",AdvanTablet:"Android.* \\b(E3A|T3X|T5C|T5B|T3E|T3C|T3B|T1J|T1F|T2A|T1H|T1i|E1C|T1-E|T5-A|T4|E1-B|T2Ci|T1-B|T1-D|O1-A|E1-A|T1-A|T3A|T4i)\\b ",DanyTechTablet:"Genius Tab G3|Genius Tab S2|Genius Tab Q3|Genius Tab G4|Genius Tab Q4|Genius Tab G-II|Genius TAB GII|Genius TAB GIII|Genius Tab S1",GalapadTablet:"Android.*\\bG1\\b",MicromaxTablet:"Funbook|Micromax.*\\b(P250|P560|P360|P362|P600|P300|P350|P500|P275)\\b",KarbonnTablet:"Android.*\\b(A39|A37|A34|ST8|ST10|ST7|Smart Tab3|Smart Tab2)\\b",AllFineTablet:"Fine7 Genius|Fine7 Shine|Fine7 Air|Fine8 Style|Fine9 More|Fine10 Joy|Fine11 Wide",PROSCANTablet:"\\b(PEM63|PLT1023G|PLT1041|PLT1044|PLT1044G|PLT1091|PLT4311|PLT4311PL|PLT4315|PLT7030|PLT7033|PLT7033D|PLT7035|PLT7035D|PLT7044K|PLT7045K|PLT7045KB|PLT7071KG|PLT7072|PLT7223G|PLT7225G|PLT7777G|PLT7810K|PLT7849G|PLT7851G|PLT7852G|PLT8015|PLT8031|PLT8034|PLT8036|PLT8080K|PLT8082|PLT8088|PLT8223G|PLT8234G|PLT8235G|PLT8816K|PLT9011|PLT9045K|PLT9233G|PLT9735|PLT9760G|PLT9770G)\\b",YONESTablet:"BQ1078|BC1003|BC1077|RK9702|BC9730|BC9001|IT9001|BC7008|BC7010|BC708|BC728|BC7012|BC7030|BC7027|BC7026",ChangJiaTablet:"TPC7102|TPC7103|TPC7105|TPC7106|TPC7107|TPC7201|TPC7203|TPC7205|TPC7210|TPC7708|TPC7709|TPC7712|TPC7110|TPC8101|TPC8103|TPC8105|TPC8106|TPC8203|TPC8205|TPC8503|TPC9106|TPC9701|TPC97101|TPC97103|TPC97105|TPC97106|TPC97111|TPC97113|TPC97203|TPC97603|TPC97809|TPC97205|TPC10101|TPC10103|TPC10106|TPC10111|TPC10203|TPC10205|TPC10503",GUTablet:"TX-A1301|TX-M9002|Q702|kf026",PointOfViewTablet:"TAB-P506|TAB-navi-7-3G-M|TAB-P517|TAB-P-527|TAB-P701|TAB-P703|TAB-P721|TAB-P731N|TAB-P741|TAB-P825|TAB-P905|TAB-P925|TAB-PR945|TAB-PL1015|TAB-P1025|TAB-PI1045|TAB-P1325|TAB-PROTAB[0-9]+|TAB-PROTAB25|TAB-PROTAB26|TAB-PROTAB27|TAB-PROTAB26XL|TAB-PROTAB2-IPS9|TAB-PROTAB30-IPS9|TAB-PROTAB25XXL|TAB-PROTAB26-IPS10|TAB-PROTAB30-IPS10",OvermaxTablet:"OV-(SteelCore|NewBase|Basecore|Baseone|Exellen|Quattor|EduTab|Solution|ACTION|BasicTab|TeddyTab|MagicTab|Stream|TB-08|TB-09)",HCLTablet:"HCL.*Tablet|Connect-3G-2.0|Connect-2G-2.0|ME Tablet U1|ME Tablet U2|ME Tablet G1|ME Tablet X1|ME Tablet Y2|ME Tablet Sync",DPSTablet:"DPS Dream 9|DPS Dual 7",VistureTablet:"V97 HD|i75 3G|Visture V4( HD)?|Visture V5( HD)?|Visture V10",CrestaTablet:"CTP(-)?810|CTP(-)?818|CTP(-)?828|CTP(-)?838|CTP(-)?888|CTP(-)?978|CTP(-)?980|CTP(-)?987|CTP(-)?988|CTP(-)?989",MediatekTablet:"\\bMT8125|MT8389|MT8135|MT8377\\b",ConcordeTablet:"Concorde([ ]+)?Tab|ConCorde ReadMan",GoCleverTablet:"GOCLEVER TAB|A7GOCLEVER|M1042|M7841|M742|R1042BK|R1041|TAB A975|TAB A7842|TAB A741|TAB A741L|TAB M723G|TAB M721|TAB A1021|TAB I921|TAB R721|TAB I720|TAB T76|TAB R70|TAB R76.2|TAB R106|TAB R83.2|TAB M813G|TAB I721|GCTA722|TAB I70|TAB I71|TAB S73|TAB R73|TAB R74|TAB R93|TAB R75|TAB R76.1|TAB A73|TAB A93|TAB A93.2|TAB T72|TAB R83|TAB R974|TAB R973|TAB A101|TAB A103|TAB A104|TAB A104.2|R105BK|M713G|A972BK|TAB A971|TAB R974.2|TAB R104|TAB R83.3|TAB A1042",
ModecomTablet:"FreeTAB 9000|FreeTAB 7.4|FreeTAB 7004|FreeTAB 7800|FreeTAB 2096|FreeTAB 7.5|FreeTAB 1014|FreeTAB 1001 |FreeTAB 8001|FreeTAB 9706|FreeTAB 9702|FreeTAB 7003|FreeTAB 7002|FreeTAB 1002|FreeTAB 7801|FreeTAB 1331|FreeTAB 1004|FreeTAB 8002|FreeTAB 8014|FreeTAB 9704|FreeTAB 1003",VoninoTablet:"\\b(Argus[ _]?S|Diamond[ _]?79HD|Emerald[ _]?78E|Luna[ _]?70C|Onyx[ _]?S|Onyx[ _]?Z|Orin[ _]?HD|Orin[ _]?S|Otis[ _]?S|SpeedStar[ _]?S|Magnet[ _]?M9|Primus[ _]?94[ _]?3G|Primus[ _]?94HD|Primus[ _]?QS|Android.*\\bQ8\\b|Sirius[ _]?EVO[ _]?QS|Sirius[ _]?QS|Spirit[ _]?S)\\b",ECSTablet:"V07OT2|TM105A|S10OT1|TR10CS1",StorexTablet:"eZee[_']?(Tab|Go)[0-9]+|TabLC7|Looney Tunes Tab",VodafoneTablet:"SmartTab([ ]+)?[0-9]+|SmartTabII10|SmartTabII7|VF-1497",EssentielBTablet:"Smart[ ']?TAB[ ]+?[0-9]+|Family[ ']?TAB2",RossMoorTablet:"RM-790|RM-997|RMD-878G|RMD-974R|RMT-705A|RMT-701|RME-601|RMT-501|RMT-711",iMobileTablet:"i-mobile i-note",TolinoTablet:"tolino tab [0-9.]+|tolino shine",AudioSonicTablet:"\\bC-22Q|T7-QC|T-17B|T-17P\\b",AMPETablet:"Android.* A78 ",SkkTablet:"Android.* (SKYPAD|PHOENIX|CYCLOPS)",TecnoTablet:"TECNO P9",JXDTablet:"Android.* \\b(F3000|A3300|JXD5000|JXD3000|JXD2000|JXD300B|JXD300|S5800|S7800|S602b|S5110b|S7300|S5300|S602|S603|S5100|S5110|S601|S7100a|P3000F|P3000s|P101|P200s|P1000m|P200m|P9100|P1000s|S6600b|S908|P1000|P300|S18|S6600|S9100)\\b",iJoyTablet:"Tablet (Spirit 7|Essentia|Galatea|Fusion|Onix 7|Landa|Titan|Scooby|Deox|Stella|Themis|Argon|Unique 7|Sygnus|Hexen|Finity 7|Cream|Cream X2|Jade|Neon 7|Neron 7|Kandy|Scape|Saphyr 7|Rebel|Biox|Rebel|Rebel 8GB|Myst|Draco 7|Myst|Tab7-004|Myst|Tadeo Jones|Tablet Boing|Arrow|Draco Dual Cam|Aurix|Mint|Amity|Revolution|Finity 9|Neon 9|T9w|Amity 4GB Dual Cam|Stone 4GB|Stone 8GB|Andromeda|Silken|X2|Andromeda II|Halley|Flame|Saphyr 9,7|Touch 8|Planet|Triton|Unique 10|Hexen 10|Memphis 4GB|Memphis 8GB|Onix 10)",FX2Tablet:"FX2 PAD7|FX2 PAD10",XoroTablet:"KidsPAD 701|PAD[ ]?712|PAD[ ]?714|PAD[ ]?716|PAD[ ]?717|PAD[ ]?718|PAD[ ]?720|PAD[ ]?721|PAD[ ]?722|PAD[ ]?790|PAD[ ]?792|PAD[ ]?900|PAD[ ]?9715D|PAD[ ]?9716DR|PAD[ ]?9718DR|PAD[ ]?9719QR|PAD[ ]?9720QR|TelePAD1030|Telepad1032|TelePAD730|TelePAD731|TelePAD732|TelePAD735Q|TelePAD830|TelePAD9730|TelePAD795|MegaPAD 1331|MegaPAD 1851|MegaPAD 2151",ViewsonicTablet:"ViewPad 10pi|ViewPad 10e|ViewPad 10s|ViewPad E72|ViewPad7|ViewPad E100|ViewPad 7e|ViewSonic VB733|VB100a",OdysTablet:"LOOX|XENO10|ODYS[ -](Space|EVO|Xpress|NOON)|\\bXELIO\\b|Xelio10Pro|XELIO7PHONETAB|XELIO10EXTREME|XELIOPT2|NEO_QUAD10",CaptivaTablet:"CAPTIVA PAD",IconbitTablet:"NetTAB|NT-3702|NT-3702S|NT-3702S|NT-3603P|NT-3603P|NT-0704S|NT-0704S|NT-3805C|NT-3805C|NT-0806C|NT-0806C|NT-0909T|NT-0909T|NT-0907S|NT-0907S|NT-0902S|NT-0902S",TeclastTablet:"T98 4G|\\bP80\\b|\\bX90HD\\b|X98 Air|X98 Air 3G|\\bX89\\b|P80 3G|\\bX80h\\b|P98 Air|\\bX89HD\\b|P98 3G|\\bP90HD\\b|P89 3G|X98 3G|\\bP70h\\b|P79HD 3G|G18d 3G|\\bP79HD\\b|\\bP89s\\b|\\bA88\\b|\\bP10HD\\b|\\bP19HD\\b|G18 3G|\\bP78HD\\b|\\bA78\\b|\\bP75\\b|G17s 3G|G17h 3G|\\bP85t\\b|\\bP90\\b|\\bP11\\b|\\bP98t\\b|\\bP98HD\\b|\\bG18d\\b|\\bP85s\\b|\\bP11HD\\b|\\bP88s\\b|\\bA80HD\\b|\\bA80se\\b|\\bA10h\\b|\\bP89\\b|\\bP78s\\b|\\bG18\\b|\\bP85\\b|\\bA70h\\b|\\bA70\\b|\\bG17\\b|\\bP18\\b|\\bA80s\\b|\\bA11s\\b|\\bP88HD\\b|\\bA80h\\b|\\bP76s\\b|\\bP76h\\b|\\bP98\\b|\\bA10HD\\b|\\bP78\\b|\\bP88\\b|\\bA11\\b|\\bA10t\\b|\\bP76a\\b|\\bP76t\\b|\\bP76e\\b|\\bP85HD\\b|\\bP85a\\b|\\bP86\\b|\\bP75HD\\b|\\bP76v\\b|\\bA12\\b|\\bP75a\\b|\\bA15\\b|\\bP76Ti\\b|\\bP81HD\\b|\\bA10\\b|\\bT760VE\\b|\\bT720HD\\b|\\bP76\\b|\\bP73\\b|\\bP71\\b|\\bP72\\b|\\bT720SE\\b|\\bC520Ti\\b|\\bT760\\b|\\bT720VE\\b|T720-3GE|T720-WiFi",OndaTablet:"\\b(V975i|Vi30|VX530|V701|Vi60|V701s|Vi50|V801s|V719|Vx610w|VX610W|V819i|Vi10|VX580W|Vi10|V711s|V813|V811|V820w|V820|Vi20|V711|VI30W|V712|V891w|V972|V819w|V820w|Vi60|V820w|V711|V813s|V801|V819|V975s|V801|V819|V819|V818|V811|V712|V975m|V101w|V961w|V812|V818|V971|V971s|V919|V989|V116w|V102w|V973|Vi40)\\b[\\s]+",JaytechTablet:"TPC-PA762",BlaupunktTablet:"Endeavour 800NG|Endeavour 1010",DigmaTablet:"\\b(iDx10|iDx9|iDx8|iDx7|iDxD7|iDxD8|iDsQ8|iDsQ7|iDsQ8|iDsD10|iDnD7|3TS804H|iDsQ11|iDj7|iDs10)\\b",EvolioTablet:"ARIA_Mini_wifi|Aria[ _]Mini|Evolio X10|Evolio X7|Evolio X8|\\bEvotab\\b|\\bNeura\\b",LavaTablet:"QPAD E704|\\bIvoryS\\b|E-TAB IVORY|\\bE-TAB\\b",AocTablet:"MW0811|MW0812|MW0922|MTK8382|MW1031|MW0831|MW0821|MW0931|MW0712",MpmanTablet:"MP11 OCTA|MP10 OCTA|MPQC1114|MPQC1004|MPQC994|MPQC974|MPQC973|MPQC804|MPQC784|MPQC780|\\bMPG7\\b|MPDCG75|MPDCG71|MPDC1006|MP101DC|MPDC9000|MPDC905|MPDC706HD|MPDC706|MPDC705|MPDC110|MPDC100|MPDC99|MPDC97|MPDC88|MPDC8|MPDC77|MP709|MID701|MID711|MID170|MPDC703|MPQC1010",CelkonTablet:"CT695|CT888|CT[\\s]?910|CT7 Tab|CT9 Tab|CT3 Tab|CT2 Tab|CT1 Tab|C820|C720|\\bCT-1\\b",WolderTablet:"miTab \\b(DIAMOND|SPACE|BROOKLYN|NEO|FLY|MANHATTAN|FUNK|EVOLUTION|SKY|GOCAR|IRON|GENIUS|POP|MINT|EPSILON|BROADWAY|JUMP|HOP|LEGEND|NEW AGE|LINE|ADVANCE|FEEL|FOLLOW|LIKE|LINK|LIVE|THINK|FREEDOM|CHICAGO|CLEVELAND|BALTIMORE-GH|IOWA|BOSTON|SEATTLE|PHOENIX|DALLAS|IN 101|MasterChef)\\b",MiTablet:"\\bMI PAD\\b|\\bHM NOTE 1W\\b",NibiruTablet:"Nibiru M1|Nibiru Jupiter One",NexoTablet:"NEXO NOVA|NEXO 10|NEXO AVIO|NEXO FREE|NEXO GO|NEXO EVO|NEXO 3G|NEXO SMART|NEXO KIDDO|NEXO MOBI",LeaderTablet:"TBLT10Q|TBLT10I|TBL-10WDKB|TBL-10WDKBO2013|TBL-W230V2|TBL-W450|TBL-W500|SV572|TBLT7I|TBA-AC7-8G|TBLT79|TBL-8W16|TBL-10W32|TBL-10WKB|TBL-W100",UbislateTablet:"UbiSlate[\\s]?7C",PocketBookTablet:"Pocketbook",KocasoTablet:"\\b(TB-1207)\\b",HisenseTablet:"\\b(F5281|E2371)\\b",Hudl:"Hudl HT7S3|Hudl 2",TelstraTablet:"T-Hub2",GenericTablet:"Android.*\\b97D\\b|Tablet(?!.*PC)|BNTV250A|MID-WCDMA|LogicPD Zoom2|\\bA7EB\\b|CatNova8|A1_07|CT704|CT1002|\\bM721\\b|rk30sdk|\\bEVOTAB\\b|M758A|ET904|ALUMIUM10|Smartfren Tab|Endeavour 1010|Tablet-PC-4|Tagi Tab|\\bM6pro\\b|CT1020W|arc 10HD|\\bTP750\\b|\\bQTAQZ3\\b"},oss:{AndroidOS:"Android",BlackBerryOS:"blackberry|\\bBB10\\b|rim tablet os",PalmOS:"PalmOS|avantgo|blazer|elaine|hiptop|palm|plucker|xiino",SymbianOS:"Symbian|SymbOS|Series60|Series40|SYB-[0-9]+|\\bS60\\b",WindowsMobileOS:"Windows CE.*(PPC|Smartphone|Mobile|[0-9]{3}x[0-9]{3})|Window Mobile|Windows Phone [0-9.]+|WCE;",WindowsPhoneOS:"Windows Phone 10.0|Windows Phone 8.1|Windows Phone 8.0|Windows Phone OS|XBLWP7|ZuneWP7|Windows NT 6.[23]; ARM;",iOS:"\\biPhone.*Mobile|\\biPod|\\biPad",MeeGoOS:"MeeGo",MaemoOS:"Maemo",JavaOS:"J2ME/|\\bMIDP\\b|\\bCLDC\\b",webOS:"webOS|hpwOS",badaOS:"\\bBada\\b",BREWOS:"BREW"},uas:{Chrome:"\\bCrMo\\b|CriOS|Android.*Chrome/[.0-9]* (Mobile)?",Dolfin:"\\bDolfin\\b",Opera:"Opera.*Mini|Opera.*Mobi|Android.*Opera|Mobile.*OPR/[0-9.]+|Coast/[0-9.]+",Skyfire:"Skyfire",Edge:"Mobile Safari/[.0-9]* Edge",IE:"IEMobile|MSIEMobile",Firefox:"fennec|firefox.*maemo|(Mobile|Tablet).*Firefox|Firefox.*Mobile|FxiOS",Bolt:"bolt",TeaShark:"teashark",Blazer:"Blazer",Safari:"Version.*Mobile.*Safari|Safari.*Mobile|MobileSafari",UCBrowser:"UC.*Browser|UCWEB",baiduboxapp:"baiduboxapp",baidubrowser:"baidubrowser",DiigoBrowser:"DiigoBrowser",Puffin:"Puffin",Mercury:"\\bMercury\\b",ObigoBrowser:"Obigo",NetFront:"NF-Browser",GenericBrowser:"NokiaBrowser|OviBrowser|OneBrowser|TwonkyBeamBrowser|SEMC.*Browser|FlyFlow|Minimo|NetFront|Novarra-Vision|MQQBrowser|MicroMessenger",PaleMoon:"Android.*PaleMoon|Mobile.*PaleMoon"},props:{Mobile:"Mobile/[VER]",Build:"Build/[VER]",Version:"Version/[VER]",VendorID:"VendorID/[VER]",iPad:"iPad.*CPU[a-z ]+[VER]",iPhone:"iPhone.*CPU[a-z ]+[VER]",iPod:"iPod.*CPU[a-z ]+[VER]",Kindle:"Kindle/[VER]",Chrome:["Chrome/[VER]","CriOS/[VER]","CrMo/[VER]"],Coast:["Coast/[VER]"],Dolfin:"Dolfin/[VER]",Firefox:["Firefox/[VER]","FxiOS/[VER]"],Fennec:"Fennec/[VER]",Edge:"Edge/[VER]",IE:["IEMobile/[VER];","IEMobile [VER]","MSIE [VER];","Trident/[0-9.]+;.*rv:[VER]"],NetFront:"NetFront/[VER]",NokiaBrowser:"NokiaBrowser/[VER]",Opera:[" OPR/[VER]","Opera Mini/[VER]","Version/[VER]"],"Opera Mini":"Opera Mini/[VER]","Opera Mobi":"Version/[VER]","UC Browser":"UC Browser[VER]",MQQBrowser:"MQQBrowser/[VER]",MicroMessenger:"MicroMessenger/[VER]",baiduboxapp:"baiduboxapp/[VER]",baidubrowser:"baidubrowser/[VER]",SamsungBrowser:"SamsungBrowser/[VER]",Iron:"Iron/[VER]",Safari:["Version/[VER]","Safari/[VER]"],Skyfire:"Skyfire/[VER]",Tizen:"Tizen/[VER]",Webkit:"webkit[ /][VER]",PaleMoon:"PaleMoon/[VER]",Gecko:"Gecko/[VER]",Trident:"Trident/[VER]",Presto:"Presto/[VER]",Goanna:"Goanna/[VER]",iOS:" \\bi?OS\\b [VER][ ;]{1}",Android:"Android [VER]",BlackBerry:["BlackBerry[\\w]+/[VER]","BlackBerry.*Version/[VER]","Version/[VER]"],BREW:"BREW [VER]",Java:"Java/[VER]","Windows Phone OS":["Windows Phone OS [VER]","Windows Phone [VER]"],"Windows Phone":"Windows Phone [VER]","Windows CE":"Windows CE/[VER]","Windows NT":"Windows NT [VER]",Symbian:["SymbianOS/[VER]","Symbian/[VER]"],webOS:["webOS/[VER]","hpwOS/[VER];"]},utils:{Bot:"Googlebot|facebookexternalhit|AdsBot-Google|Google Keyword Suggestion|Facebot|YandexBot|YandexMobileBot|bingbot|ia_archiver|AhrefsBot|Ezooms|GSLFbot|WBSearchBot|Twitterbot|TweetmemeBot|Twikle|PaperLiBot|Wotbox|UnwindFetchor|Exabot|MJ12bot|YandexImages|TurnitinBot|Pingdom",MobileBot:"Googlebot-Mobile|AdsBot-Google-Mobile|YahooSeeker/M1A1-R2D2",DesktopMode:"WPDesktop",TV:"SonyDTV|HbbTV",WebKit:"(webkit)[ /]([\\w.]+)",Console:"\\b(Nintendo|Nintendo WiiU|Nintendo 3DS|PLAYSTATION|Xbox)\\b",Watch:"SM-V700"}},o.detectMobileBrowsers={fullPattern:/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i,shortPattern:/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i,tabletPattern:/android|ipad|playbook|silk/i};var s,a=Object.prototype.hasOwnProperty;return o.FALLBACK_PHONE="UnknownPhone",o.FALLBACK_TABLET="UnknownTablet",o.FALLBACK_MOBILE="UnknownMobile",s="isArray"in Array?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)},function(){var e,t,n,r,l,c,u=o.mobileDetectRules;for(e in u.props)if(a.call(u.props,e)){for(t=u.props[e],s(t)||(t=[t]),l=t.length,r=0;r<l;++r)n=t[r],c=n.indexOf("[VER]"),c>=0&&(n=n.substring(0,c)+"([\\w._\\+]+)"+n.substring(c+5)),t[r]=new RegExp(n,"i");u.props[e]=t}i(u.oss),i(u.phones),i(u.tablets),i(u.uas),i(u.utils),u.oss0={WindowsPhoneOS:u.oss.WindowsPhoneOS,WindowsMobileOS:u.oss.WindowsMobileOS}}(),o.findMatch=function(e,t){for(var n in e)if(a.call(e,n)&&e[n].test(t))return n;return null},o.findMatches=function(e,t){var n=[];for(var i in e)a.call(e,i)&&e[i].test(t)&&n.push(i);return n},o.getVersionStr=function(e,t){var n,i,r,s,l=o.mobileDetectRules.props;if(a.call(l,e))for(n=l[e],r=n.length,i=0;i<r;++i)if(s=n[i].exec(t),null!==s)return s[1];return null},o.getVersion=function(e,t){var n=o.getVersionStr(e,t);return n?o.prepareVersionNo(n):NaN},o.prepareVersionNo=function(e){var t;return t=e.split(/[a-z._ \/\-]/i),1===t.length&&(e=t[0]),t.length>1&&(e=t[0]+".",t.shift(),e+=t.join("")),Number(e)},o.isMobileFallback=function(e){return o.detectMobileBrowsers.fullPattern.test(e)||o.detectMobileBrowsers.shortPattern.test(e.substr(0,4))},o.isTabletFallback=function(e){return o.detectMobileBrowsers.tabletPattern.test(e)},o.prepareDetectionCache=function(e,n,i){if(e.mobile===t){var s,a,l;return(a=o.findMatch(o.mobileDetectRules.tablets,n))?(e.mobile=e.tablet=a,void(e.phone=null)):(s=o.findMatch(o.mobileDetectRules.phones,n))?(e.mobile=e.phone=s,void(e.tablet=null)):void(o.isMobileFallback(n)?(l=r.isPhoneSized(i),l===t?(e.mobile=o.FALLBACK_MOBILE,e.tablet=e.phone=null):l?(e.mobile=e.phone=o.FALLBACK_PHONE,e.tablet=null):(e.mobile=e.tablet=o.FALLBACK_TABLET,e.phone=null)):o.isTabletFallback(n)?(e.mobile=e.tablet=o.FALLBACK_TABLET,e.phone=null):e.mobile=e.tablet=e.phone=null)}},o.mobileGrade=function(e){var t=null!==e.mobile();return e.os("iOS")&&e.version("iPad")>=4.3||e.os("iOS")&&e.version("iPhone")>=3.1||e.os("iOS")&&e.version("iPod")>=3.1||e.version("Android")>2.1&&e.is("Webkit")||e.version("Windows Phone OS")>=7||e.is("BlackBerry")&&e.version("BlackBerry")>=6||e.match("Playbook.*Tablet")||e.version("webOS")>=1.4&&e.match("Palm|Pre|Pixi")||e.match("hp.*TouchPad")||e.is("Firefox")&&e.version("Firefox")>=12||e.is("Chrome")&&e.is("AndroidOS")&&e.version("Android")>=4||e.is("Skyfire")&&e.version("Skyfire")>=4.1&&e.is("AndroidOS")&&e.version("Android")>=2.3||e.is("Opera")&&e.version("Opera Mobi")>11&&e.is("AndroidOS")||e.is("MeeGoOS")||e.is("Tizen")||e.is("Dolfin")&&e.version("Bada")>=2||(e.is("UC Browser")||e.is("Dolfin"))&&e.version("Android")>=2.3||e.match("Kindle Fire")||e.is("Kindle")&&e.version("Kindle")>=3||e.is("AndroidOS")&&e.is("NookTablet")||e.version("Chrome")>=11&&!t||e.version("Safari")>=5&&!t||e.version("Firefox")>=4&&!t||e.version("MSIE")>=7&&!t||e.version("Opera")>=10&&!t?"A":e.os("iOS")&&e.version("iPad")<4.3||e.os("iOS")&&e.version("iPhone")<3.1||e.os("iOS")&&e.version("iPod")<3.1||e.is("Blackberry")&&e.version("BlackBerry")>=5&&e.version("BlackBerry")<6||e.version("Opera Mini")>=5&&e.version("Opera Mini")<=6.5&&(e.version("Android")>=2.3||e.is("iOS"))||e.match("NokiaN8|NokiaC7|N97.*Series60|Symbian/3")||e.version("Opera Mobi")>=11&&e.is("SymbianOS")?"B":(e.version("BlackBerry")<5||e.match("MSIEMobile|Windows CE.*Mobile")||e.version("Windows Mobile")<=5.2,"C")},o.detectOS=function(e){return o.findMatch(o.mobileDetectRules.oss0,e)||o.findMatch(o.mobileDetectRules.oss,e)},o.getDeviceSmallerSide=function(){return window.screen.width<window.screen.height?window.screen.width:window.screen.height},r.prototype={constructor:r,mobile:function(){return o.prepareDetectionCache(this._cache,this.ua,this.maxPhoneWidth),this._cache.mobile},phone:function(){return o.prepareDetectionCache(this._cache,this.ua,this.maxPhoneWidth),this._cache.phone},tablet:function(){return o.prepareDetectionCache(this._cache,this.ua,this.maxPhoneWidth),this._cache.tablet},userAgent:function(){return this._cache.userAgent===t&&(this._cache.userAgent=o.findMatch(o.mobileDetectRules.uas,this.ua)),this._cache.userAgent},userAgents:function(){return this._cache.userAgents===t&&(this._cache.userAgents=o.findMatches(o.mobileDetectRules.uas,this.ua)),this._cache.userAgents},os:function(){return this._cache.os===t&&(this._cache.os=o.detectOS(this.ua)),this._cache.os},version:function(e){return o.getVersion(e,this.ua)},versionStr:function(e){return o.getVersionStr(e,this.ua)},is:function(t){return n(this.userAgents(),t)||e(t,this.os())||e(t,this.phone())||e(t,this.tablet())||n(o.findMatches(o.mobileDetectRules.utils,this.ua),t)},match:function(e){return e instanceof RegExp||(e=new RegExp(e,"i")),e.test(this.ua)},isPhoneSized:function(e){return r.isPhoneSized(e||this.maxPhoneWidth)},mobileGrade:function(){return this._cache.grade===t&&(this._cache.grade=o.mobileGrade(this)),this._cache.grade}},"undefined"!=typeof window&&window.screen?r.isPhoneSized=function(e){return e<0?t:o.getDeviceSmallerSide()<=e}:r.isPhoneSized=function(){},r._impl=o,r.version="1.3.7 2017-09-06",r})}(function(t){return"undefined"!=typeof e&&e.exports?function(t){e.exports=t()}:n(235)}())},function(e,t){e.exports=function(){throw new Error("define cannot be used indirect")}},function(e,t,n){(function(e,t){function n(){var e=Date.now(),t=n.last||e;return n.last=e>t?e:t+1}var i=e&&e.pid?e.pid.toString(36):"",r=null,o=r?parseInt(r.replace(/\:|\D+/gi,"")).toString(36):"";t.exports=function(e){return(e||"")+o+i+n().toString(36)},t.exports.process=function(e){return(e||"")+i+n().toString(36)},t.exports.time=function(e){return(e||"")+n().toString(36)}}).call(t,n(140),n(237)(e))},function(e,t){e.exports=function(e){return e.webpackPolyfill||(e.deprecate=function(){},e.paths=[],e.children=[],e.webpackPolyfill=1),e}},function(e,t,n){"use strict";var i,r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28);i=n(234);var s=new i(window.navigator.userAgent),a=function(e){function t(){e.call(this),this.crazyZIndex=999999999,this.isMobile=!1}return r(t,e),t.prototype.componentWillMount=function(){s.mobile()&&(this.isMobile=!0),this.isMobile?this.embedWidth=this.context.embedSettings.embedStyleSetting.maxWidthMobile:this.embedWidth=this.context.embedSettings.embedStyleSetting.maxWidthDesktop,1200===this.embedWidth&&(this.embedWidth=300),this.displayAd()},t.prototype.componentDidMount=function(){var e=this;if(this.context.embedSettings.embedSetting.showAdOnShortWidget&&"function"==typeof this.props.closeBtnClicked){var t=4e3;window.setTimeout(function(){e.props.closeBtnClicked()},t)}},t.prototype.handleMultiAds=function(){var e=document.getElementById("div-insticator-ad-1"),t=document.getElementById("div-insticator-ad-2");if(e&&t){var n=this.context.embedSettings.document.getElementById("widgetNav");this.embedWidth>600&&(e.style.left=(this.embedWidth-600)/2+"px",t.style.left=(this.embedWidth-600)/2+300+"px"),e.style.zIndex=this.crazyZIndex,t.style.zIndex=this.crazyZIndex,n&&(n.style.opacity=0)}},t.prototype.displayAd=function(){var e,t=this.context.embedSettings.embedSetting.targetAdDiv;if("ad1"===t)t=document.getElementById("div-insticator-ad-1");else if("ad2"===t)t=document.getElementById("div-insticator-ad-2");else if("both"===t)return void this.handleMultiAds();if(t){if(e=this.context.embedSettings.document.getElementById("widgetNav"),this.embedWidth>300){var n=(this.embedWidth-300)/2;t.style.left=n+"px"}t.style.zIndex=this.crazyZIndex,e&&(e.style.opacity=0)}},t.prototype.render=function(){var e="",t="-15px",n=0,i="",r=38,s="-11px",a=-16;if(this.embedWidth>300){var l=this.embedWidth/300;a*=l}if("versusMode"===this.props.playMode)n=-44,e="-74px";else if("triviaMode"===this.props.playMode||"adShowMode"===this.props.playMode)n=this.embedWidth>=400&&this.embedWidth<500?-40:this.embedWidth>=500&&this.embedWidth<=600?-38:-34,e="-62px";else if("pollsMode"===this.props.playMode)n=this.embedWidth>=400&&this.embedWidth<500?-33:this.embedWidth>=500&&this.embedWidth<=600?-35:-28,e="-61px";else if("articles"===this.props.playMode){for(var c=this.context.embedSettings.document.querySelectorAll("footer"),u=0;u<c.length;u++)c[u].style.zIndex=-1;s="4px",n=this.context.embedSettings.embedSetting.showHeaderLogo?10:32}if(this.context.embedSettings.embedSetting.showHeaderLogo===!0&&"articles"!==this.props.playMode&&(n-="versusMode"===this.props.playMode?18:21),i=n+"px",this.props.renderedFromResults&&"articles"!==this.props.playMode){e="0px",t="0px",i="26px",s="2px";for(var c=this.context.embedSettings.document.querySelectorAll("footer"),u=0;u<c.length;u++)c[u].style.zIndex=-1}if(i=this.context.embedSettings.embedSetting.showHeaderLogo?"10px":"30px",this.embedWidth>300){var d=this.embedWidth/2,p=d-150+26-.05*this.embedWidth;s=p+"px"}else s="4px";if("both"===this.context.embedSettings.embedSetting.targetAdDiv){var d=this.embedWidth/2;s=d-300+"px"}var h={position:"absolute",height:"20px",width:r+"px",fontSize:"12px",lineHeight:"20px",textAlign:"center",right:s,top:i,cursor:"pointer",zIndex:this.crazyZIndex+1,borderRadius:"6px",background:"#4d79ff",color:"#ffffff"},m={background:"black",opacity:.87,position:"absolute",top:0,left:0,right:0,bottom:"4%",zIndex:this.crazyZIndex-1},f={};this.context.embedSettings.embedSetting.showAdOnShortWidget&&(f={display:"none"});var g=null;return"function"==typeof this.props.closeBtnClicked&&(g=o.createElement("div",{id:"closeAdBtn",className:"close-ad-btn",onClick:this.props.closeBtnClicked.bind(this),style:h},"close")),o.createElement("div",{id:"closeAdBtnContainer",style:f},g,o.createElement("div",{id:"backgroundCover",style:m}))},t.contextTypes={embedSettings:o.PropTypes.object.isRequired,gameManagerSettings:o.PropTypes.object.isRequired},t}(o.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=a},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(){e.call(this)}return i(t,e),t.prototype.render=function(){var e={textAlign:"center"};return r.createElement("div",{style:e})},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(241),s=n(257),a=n(258),l=n(259),c=n(206),u=function(e){function t(){var t=this;e.call(this),this.firstQuestionAnswered=!1,this._maxQuestionsPerGame=5,this.state={playMode:null,playing:!1,firstStart:!0,questionAnswered:!1,gameEnd:!1,gameManagerQuestionCounter:null,gameResults:[],maxQuestionsPerGame:5,questionInCurrentGame:1,updatingUserScore:"",updatingEnemyScore:"",userScore:0,enemyData:null,enemyScore:0,showTriviaOptions:!1,gamePaused:!1,showValueQuestion:!1,gameScreenOptions:{startGame:function(){t.startGame()},setPlayMode:function(e){t.setState({playMode:e})}}}}return i(t,e),t.prototype.componentWillMount=function(){this.keenUtil=new c.default(this.props.embedSettings);var e=this.context.embedSettings.embedSetting.showPolls;switch(this.props.playMode){case"triviaMode":this._startTriviaMode();break;case"versusMode":this._startVersusMode();break;case"demoMode":this._startDemoMode()}var t=this.props.gameManagerOptions.getTriviaQuestionsLen();t<5?this.setState({maxQuestionsPerGame:t}):!this.props.gameManagerOptions.playFromResults()&&e&&this.setState({maxQuestionsPerGame:5})},t.prototype.shouldComponentUpdate=function(e,t){switch(!0){case this.props.gamePaused!==t.gamePaused:return!0;case this.state.playMode!==t.playMode:return!0;case this.state.playing!==t.playing:return!0;case this.state.firstStart!==t.firstStart:return!0;case this.state.questionAnswered!==t.questionAnswered:return!0;case this.state.gameEnd!==t.gameEnd:return!0;case this.state.gameManagerQuestionCounter!==t.gameManagerQuestionCounter:return!0;case this.state.questionInCurrentGame!==t.questionInCurrentGame:return!0;case this.state.updatingUserScore!==t.updatingUserScore:return!0;case this.state.userScore!==t.userScore:return!0;case this.state.enemyData!==t.enemyData:return!0;case this.state.enemyScore!==t.enemyScore:return!0;case this.state.showTriviaOptions!==t.showTriviaOptions:return!0;case this.state.showValueQuestion!==t.showValueQuestion:return!0;default:return!1}},t.prototype.componentWillReceiveProps=function(e){if(e.gamePaused!==this.state.gamePaused&&this.setState({gamePaused:!this.state.gamePaused}),this.setState({gameManagerQuestionCounter:this.props.gameManagerQuestionCounter}),1==this.state.firstStart&&"triviaMode"==this.state.playMode){var t=2e3,n=this;this._firstLoadSetTimeOut=setTimeout(function(){n._setFirstTimeFalse()},t)}1==this.state.firstStart&&"versusMode"==this.state.playMode&&this.setState({enemyData:this.props.gameManagerOptions.enemyData()})},t.prototype.componentDidMount=function(){},t.prototype.componentWillUnmount=function(){clearTimeout(this._firstLoadSetTimeOut),clearTimeout(this._nextQuestionSetTimeOut)},t.prototype.toggleShowValueQuestion=function(){this.setState({showValueQuestion:!this.state.showValueQuestion})},t.prototype.fetchData=function(){this.context.embedSettings.embedSetting.showPolls&&0===this.props.gameManagerOptions.getPollQuestions().length?this.props.gameManagerOptions.fetchQuestions("polls"):this.context.embedSettings.embedSetting.showPolls&&this.props.gameManagerOptions.getFetchedOnLoadPollsQuestions().length>0&&this.props.gameManagerOptions.reshuffleFetchedPollsQuestion(),this.context.embedSettings.embedSetting.showArticles&&0===this.props.gameManagerOptions.getArticles().length&&this.props.gameManagerOptions.fetchQuestions("articles")},t.prototype.startGame=function(){var e=this.props.gameManagerOptions.getGameType(),t="";"trivia"===e?(this.keenUtil.addClickEvent("TRIVIA","START GAME",null),t="triviaMode"):"versus"===e&&(this.keenUtil.addClickEvent("VERSUS","START GAME",null),t="versusMode",this.keenUtil.addVersusClickEvent()),this.props.gameManagerOptions.getGameStarted()||(this.fetchData(),this.props.gameManagerOptions.setGameStartedTrue()),this._revealAnswerOptions(t)},t.prototype.createQuestionCountBarElem=function(e){var t,n=[],i=this.context.embedSettings.colorPalette.mainColor,o=1/e*100;o=o.toString()+"%";for(var s=1;s<e+1;s++){var a={width:o};this.state.questionInCurrentGame>=s&&(a.backgroundColor=i),n.push(r.createElement("li",{key:s,className:"question-bar",style:a}))}return t=r.createElement("div",{className:"question-count-bar"},r.createElement("ul",{className:"question-bar-container"},n))},t.prototype.createHeaderElem=function(){},t.prototype.createQuestionSectionElem=function(){var e;return null!==this.props.questions&&(this.props.gameManagerOptions.triviaQuestionCounter()>=this.props.gameManagerOptions.maxTriviaQuestions()&&this.props.gameManagerOptions.resetTriviaQuestionCounter(),e=r.createElement(o.default,{playMode:this.state.playMode,question:this.props.questions[this.props.gameManagerOptions.triviaQuestionCounter()],maxQuestionsPerGame:this.state.maxQuestionsPerGame,currentQuestion:this._increaseCurrentGameQuestionCount.bind(this),playing:this._setPlayingSetState.bind(this),nextQuestion:this._nextQuestion.bind(this),questionResults:this._setQuestionResult.bind(this),pollsResultData:"",gameManagerOptions:this.props.gameManagerOptions,embedSettings:this.props.embedSettings,gameScreenOptions:this.state.gameScreenOptions,gamePaused:this.state.gamePaused}),this.state.showValueQuestion&&(e=r.createElement(s.default,{playMode:this.state.playMode,question:this.props.valueQuestions[0],maxQuestionsPerGame:this.state.maxQuestionsPerGame,currentQuestion:this._increaseCurrentGameQuestionCount.bind(this),playing:this._setPlayingSetState.bind(this),nextQuestion:this._nextQuestion.bind(this),questionResults:this._setQuestionResult.bind(this),pollsResultData:"",gameManagerOptions:this.props.gameManagerOptions,embedSettings:this.props.embedSettings,gameScreenOptions:this.state.gameScreenOptions,gamePaused:this.state.gamePaused}))),(this.state.questionAnswered&&"demoMode"===this.state.playMode||this.state.questionAnswered&&this.state.playing||1==this.state.firstStart&&"versusMode"==this.state.playMode)&&(e=null),e},t.prototype.render=function(){var e,t,n,i,o;this.context.embedSettings.embedSetting.showPolls,this.props.gameManagerOptions.playFromResults();i=this.state.maxQuestionsPerGame;var s={backgroundImage:"url("+this.props.playerData.avatar+")"};n=this.context.embedSettings.embedSetting.showVersusMode?r.createElement("div",{className:"trivia-button",onClick:this._switchToVersusMode.bind(this)},"VS MODE"):null,o=this.createQuestionCountBarElem(i);var c;switch(this.state.playMode){case"triviaMode":c=r.createElement("div",{className:"score-btn-container"},r.createElement("div",{className:"score-btn"},this.props.gameManagerOptions.userScore()," ",r.createElement("span",null,"pts"))),e=r.createElement("div",{id:"header",className:"solo-header"},r.createElement("div",{className:"userAvatar",style:s}),r.createElement("div",{className:"name-score-container"},r.createElement("div",{className:"userName"},this.props.playerData.name),r.createElement("div",{className:"score-btn-container"},r.createElement("div",{className:"score-btn"},this.props.gameManagerOptions.userScore()," ",r.createElement("span",null,"pts")))),n);break;case"versusMode":var u=void 0,d=void 0,p=void 0;c=r.createElement("div",{className:"score-btn-container"},r.createElement("div",{className:"score-btn"},this.props.gameManagerOptions.userScore()," ",r.createElement("span",null,"pts"))),p=r.createElement("div",{className:"score-btn-container"},r.createElement("div",{className:"score-btn"},this.props.gameManagerOptions.enemyScore()," ",r.createElement("span",null,"pts"))),null!==this.state.enemyData&&(u={backgroundImage:"url("+this.state.enemyData.avatar+")"},d=this.state.enemyData.name),e=r.createElement("div",{id:"header",className:"versus-header"},r.createElement("div",{className:"player-container"},r.createElement("div",{className:"userSide"},r.createElement("div",{className:"userAvatar",style:s}),r.createElement("div",{className:"name-score-container"},r.createElement("div",{className:"userName"},this.props.playerData.name),c)),r.createElement("h2",null,"VS"),r.createElement("div",{className:"enemySide"},r.createElement("div",{className:"name-score-container"},r.createElement("div",{className:"enemyName"},d),p),r.createElement("div",{className:"enemyAvatar",style:u}))));var h=void 0,m=void 0;h={height:(this.props.gameManagerOptions.userScore()/500*100).toFixed()+"%"},m={height:(this.props.gameManagerOptions.enemyScore()/500*100).toFixed()+"%"},t=r.createElement("div",{id:"versusSidebars"},r.createElement("div",{style:h,className:"userBar"}),r.createElement("div",{style:m,className:"enemyBar"}));break;case"demoMode":e=r.createElement("div",{id:"header",className:"solo-header"},r.createElement("div",{className:"userAvatar",style:s}),r.createElement("div",{className:"name-score-container"},r.createElement("div",{className:"userName"},this.props.playerData.name),r.createElement("div",{className:"score-btn-container"},r.createElement("div",{className:"score-btn"},this.props.gameManagerOptions.userScore()," ",r.createElement("span",null,"pts")))),n)}var f,g;this.state.questionAnswered&&this.state.playing&&0==this.state.gameEnd||1==this.state.firstStart&&"triviaMode"==this.state.playMode?f=null:"demoMode"==this.state.playMode&&this.state.questionAnswered?f=null:this.state.questionAnswered===!1&&this.state.playing&&this.state.gameEnd===!1&&(f=null),1==this.state.firstStart&&"versusMode"==this.state.playMode&&(g=r.createElement(a.default,{startingAction:this.props.gameManagerOptions.generateEnemyUser.bind(this),finishedAction:this._setFirstTimeFalse.bind(this),userData:this.props.playerData,enemyData:this.props.gameManagerOptions.enemyData()}));var b,v=this.createQuestionSectionElem();return this.state.showTriviaOptions===!0&&(b=r.createElement(l.default,{gameScreenOptions:this.state.gameScreenOptions,gameManagerOptions:this.props.gameManagerOptions,embedSettings:this.props.embedSettings})),this.context.embedSettings.embedSetting.showAdOnShortWidget&&(e=null),
r.createElement("div",{id:"gameContainer"},g,e,o,f,v,t)},t.prototype._revealAnswerOptions=function(e){var t=e;switch(t){case"versusMode":this._startVersusMode();break;case"triviaMode":default:this._startTriviaMode()}this.state.firstStart===!0&&this.setState({firstStart:!1})},t.prototype._setPlayingSetState=function(e){return this.setState({playing:e}),e},t.prototype._increaseCurrentGameQuestionCount=function(){this.setState({questionInCurrentGame:this.state.questionInCurrentGame+1})},t.prototype._isKeywordStored=function(){var e=!1;if(localStorage&&"undefined"!=typeof localStorage["insticator-value-keyword"]){var t=JSON.parse(localStorage.getItem("insticator-value-keyword")),n=this.props.valueQuestions[0].valueQuestionKeyword;"boolean"==typeof t[n]&&(e=!0)}return e},t.prototype._shouldValueQuestionShow=function(){var e=this.context.embedSettings.embedSetting.showValueQuestion,t=this.context.embedSettings.embedSetting.valueQuestionInterval;if(e&&t===this.state.questionInCurrentGame&&"triviaMode"===this.state.playMode&&this.props.valueQuestions&&this.props.valueQuestions.length>0){var n=this._isKeywordStored();if(!n)return!0}return!1},t.prototype._nextQuestion=function(){var e=this.state.showValueQuestion,t=this._shouldValueQuestionShow();if((t||e)&&this.toggleShowValueQuestion(),"demoMode"===this.state.playMode||this.state.showValueQuestion||this._increaseCurrentGameQuestionCount(),this.setState({questionAnswered:!0}),"demoMode"==this.state.playMode)if(this.props.gameManagerOptions.maxTriviaQuestions()-2<this.props.gameManagerOptions.triviaQuestionCounter())this.props.gameManagerOptions.resetTriviaQuestionCounter(),this.setState({questionAnswered:!1});else{this.props.gameManagerOptions.increaseTriviaQuestionCounter(1);var n=0,i=this;this._nextQuestionSetTimeOut=setTimeout(function(){i.setState({questionAnswered:!1,updatingUserScore:"",updatingEnemyScore:""})},n)}else if(this.setState({firstStart:!1}),this.state.maxQuestionsPerGame+1<=this.state.questionInCurrentGame)this.setState({gameEnd:!0,playing:!1}),this.props.gameManagerOptions.increaseTriviaQuestionCounter(1),this.props.gameManagerOptions.setGameEndTrue();else if(this.props.gameManagerOptions.maxTriviaQuestions()-2<this.props.gameManagerOptions.triviaQuestionCounter()){this.props.gameManagerOptions.resetTriviaQuestionCounter();var n=0,r=this;this._nextQuestionSetTimeOut=setTimeout(function(){r.setState({questionAnswered:!1,updatingUserScore:"",updatingEnemyScore:""})},n)}else{var n=0,o=this;this.state.showValueQuestion||this.props.gameManagerOptions.increaseTriviaQuestionCounter(1),this._nextQuestionSetTimeOut=setTimeout(function(){o.setState({questionAnswered:!1,updatingUserScore:"",updatingEnemyScore:""})},n)}},t.prototype._calculateScore=function(e){var t,n,i=e;if(t=i.points,n=e.prediction===!0?"right":"wrong",this.props.gameManagerOptions.increaseUserScore(t),"versusMode"==this.state.playMode){var r,o;o=e.enemyPrediction===!0?"right":"wrong",r=i.enemyPoints,this.props.gameManagerOptions.increaseEnemyScore(r),this.setState({userScore:t,updatingUserScore:n,enemyScore:r,updatingEnemyScore:o})}else this.setState({userScore:t,updatingUserScore:n})},t.prototype._setQuestionResult=function(e){this.setState({gameResults:this.state.gameResults.concat(e),updatingUserScore:"",updatingEnemyScore:""}),this._calculateScore(e)},t.prototype._startTriviaMode=function(){this.setState({playMode:"triviaMode",playing:!0}),this.props.gameManagerOptions.changeGameMode("triviaMode"),this.props.gameManagerOptions.setgameType("triviaMode")},t.prototype._switchToVersusMode=function(){this.keenUtil.addVersusClickEvent(),this.keenUtil.addClickEvent("TRIVIA","SWITCH TO VERSUS",null),this.setState({playMode:"versusMode",playing:!0,firstStart:!0,questionInCurrentGame:1}),this.props.gameManagerOptions.setPlayFromResultsTrue(),this.props.gameManagerOptions.interruptGame("trivia","versusMode"),this.props.gameManagerOptions.resetTriviaQuestionCounter()},t.prototype._startVersusMode=function(){var e=this.context.embedSettings.embedSetting.showOverlay;e?this.firstQuestionAnswered?this.context.embedSettings.refreshAds():this.firstQuestionAnswered=!0:this.context.embedSettings.refreshAds(),this.props.gameManagerOptions.getGameStarted()||(this.props.gameManagerOptions.setGameStartedTrue(),this.context.embedSettings.embedSetting.showPolls&&0===this.props.gameManagerOptions.getPollQuestions().length&&this.props.gameManagerOptions.fetchQuestions("polls"),this.context.embedSettings.embedSetting.showArticles&&0===this.props.gameManagerOptions.getArticles().length&&this.props.gameManagerOptions.fetchQuestions("articles")),this.setState({playMode:"versusMode",playing:!0,firstStart:!0}),this.props.gameManagerOptions.maxTriviaQuestions()-2<this.props.gameManagerOptions.triviaQuestionCounter()?(this.props.gameManagerOptions.resetTriviaQuestionCounter(),this.setState({questionAnswered:!1})):(this.setState({questionAnswered:!1}),this.props.gameManagerOptions.increaseTriviaQuestionCounter(1))},t.prototype._setFirstTimeFalse=function(){this.setState({firstStart:!1})},t.prototype._startDemoMode=function(){this.setState({playMode:"demoMode",playing:!1}),this.props.gameManagerOptions.changeGameMode("demoMode"),this.props.gameManagerOptions.setgameType("demoMode")},t.contextTypes={embedSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=u},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(242),s=n(243),a=n(205),l=n(244),c=n(238),u=n(206),d=n(201),p=d.API_KEYS.KEEN_WRITE_KEY,h=d.API_KEYS.KEEN_READ_KEY,m=d.API_KEYS.KEEN_PROJECT_ID,f=n(245),g=(new f({projectId:m,writeKey:p,readKey:h}),function(e){function t(){e.call(this),this.overlayIsActive=!1,this.interstitialActive=!1,this.totalTimePassed=0,this.questionAnswered=!1,this.gamePaused=!1,this.showOverlayAfterInstiPoll=!1,this._questionStartTime=0,this._questionEndTime=0,this._questionPausedStartTime=0,this._questionPausedEndTime=0,this._enemyAnswered=!1,this._keenQueryTimeLimit=0,this.keen=null,this.state={correctAnswer:null,answers:[],answered:!1,answerSubmitted:!1,chosenOption:null,answerTime:null,enemyAnswered:!1,enemyChosenOption:null,enemyAnswerTime:null,counterActive:!0,timeRanOut:!1,questionCountDown:5,pollResults:null,resultsTotal:null,retrySubmitPoll:!1,resultsHoldTime:2300,gameStarted:!1,showSliderAnimation:!1,showOverlayAd:!1,showInterstitial:!1}}return i(t,e),t.prototype.componentWillReceiveProps=function(e,t){var n=this,i=this.context.gameManagerSettings.gameManagerOptions.getGamePaused(),r=this.context.gameManagerSettings.gameManagerOptions.getInterstitialActive();i||!this.interstitialActive||r||(clearTimeout(this.counterEndTimeout),this.gamePaused=i,this.showOverlayAfterInstiPoll?(this.showOverlayAfterInstiPoll=!1,this.context.embedSettings.document.getElementById("questionSection").style.transition="none",this.context.embedSettings.document.getElementById("questionSection").className="",setTimeout(function(){n.context.embedSettings.document.getElementById("questionSection").style.transition="all 0.6s ease-in-out"},600),this.overlayIsActive=!0,this.setState({showOverlayAd:!0})):this.overlayIsActive||this.handleShowNextQuestion(0))},t.prototype.componentWillMount=function(){this.keenUtil=new u.default(this.props.embedSettings),this.context.embedSettings.embedSetting.showPolls===!0&&this.checkForPollData(),this.setState({questionCountDown:this.context.embedSettings.embedSetting.countdown}),"pollsMode"==this.props.playMode&&this.setState({resultsHoldTime:3e3})},t.prototype.checkForPollData=function(){var e,t=this;this._pollDataFetchTimer=window.setInterval(function(){e=t.props.gameManagerOptions.getPollResults(),null!==e&&(t.setupPollQuestions(e),window.clearInterval(t._pollDataFetchTimer))},250)},t.prototype.setupPollQuestions=function(e){if("pollsMode"==this.props.playMode&&e&&e.length>0){for(var t=[],n=this.props.gameManagerOptions.pollsQuestionCounter(),i=e[n].length-1,r=0;r<this.props.question.options.length;r++)t.push({prediction:this.props.question.options[r].predictionOption,predictionOptionUUID:this.props.question.options[r].predictionOptionUUID,result:e[n][r]});this.setState({pollResults:t,resultsTotal:e[n][i].total})}},t.prototype.startCountdown=function(){var e=this;"versusMode"===this.props.playMode?this.totalTimeTracker=setInterval(function(){e.totalTimePassed+=450,e._versusCounterEndCheck()},450):this.interstitialActive||(clearTimeout(this.counterEndTimeout),this.counterEndTimeout=setTimeout(function(){e.interstitialActive||e.overlayIsActive||e.timeRanOut()},1e3*this.state.questionCountDown))},t.prototype._setCounterElem=function(e){var t;return"demoMode"==this.props.playMode&&"polls"!==e&&1==this.state.timeRanOut&&0==this.state.counterActive?t=r.createElement("div",{className:"time-bar demoEnded"}):"polls"!==e&&(t=r.createElement(a.default,{countDown:this.state.questionCountDown,countDownDelay:1.5,active:this.state.counterActive,counterStartFunction:this._getQuestionStartTime.bind(this),startCountdown:this.startCountdown.bind(this)})),t},t.prototype._setQuestionAnswersElem=function(e){var t,n=this;return t="pollsMode"==e?this.questionAnswered&&this.state.chosenOption?this.props.question.options.map(function(e,t){return n._submitPoll(e,t)}):this.props.question.options.map(function(e,t){return r.createElement(o.default,{gameManagerOptions:n.props.gameManagerOptions,playMode:n.props.playMode,answer:e,questionAnswered:n.questionAnswered,setAnsweredTrue:n._setAnsweredTrue.bind(n),indicator:"",key:t})}):"versusMode"==e?this.questionAnswered&&this.state.chosenOption&&this._enemyAnswered&&this._enemyChosenOption?this.props.question.options.map(function(e,t){return n._versusCheckAnswer(e,t)}):this.questionAnswered&&this.state.chosenOption?this.props.question.options.map(function(e,t){return n._versusCheckAnswer(e,t)}):this.state.timeRanOut?this.props.question.options.map(function(e,t){return n._versusCheckAnswer(e,t)}):this.props.question.options.map(function(e,t){return r.createElement(o.default,{gameManagerOptions:n.props.gameManagerOptions,playMode:n.props.playMode,answer:e,questionAnswered:n.questionAnswered,setAnsweredTrue:n._setVersusAnsweredTrue.bind(n),indicator:"",key:t})}):this.questionAnswered&&this.state.chosenOption?this.props.question.options.map(function(e,t){return n._checkAnswer(e,t)}):this.state.timeRanOut&&this.props.gameManagerOptions.getGameStarted()?this.props.question.options.map(function(e,t){return n._checkAnswer(e,t)}):this.props.question.options.map(function(e,t){return r.createElement(o.default,{gameManagerOptions:n.props.gameManagerOptions,playMode:n.props.playMode,answer:e,questionAnswered:n.questionAnswered,setAnsweredTrue:n._setAnsweredTrue.bind(n),indicator:"",key:t})})},t.prototype._setCounterContainerElem=function(e,t){var n,i;return"pollsMode"==e&&(i="hideCounter"),"demoMode"!==e&&"pollsMode"===e?(n=null,clearInterval(this._counterCheckTimer)):n=r.createElement("div",{className:"counter "+i},t),n},t.prototype.closeAdButtonClicked=function(){var e=this.context.embedSettings.document.getElementById("closeAdBtnContainer");e.style.display="none";var t=this.context.embedSettings.document.getElementById("widgetNav");t&&(t.style.opacity=1);var n=this.context.embedSettings.embedSetting.targetAdDiv;"ad1"===n?n=document.getElementById("div-insticator-ad-1"):"ad2"===n?n=document.getElementById("div-insticator-ad-2"):"both"===n&&(document.getElementById("div-insticator-ad-1").style.zIndex="-1000",document.getElementById("div-insticator-ad-2").style.zIndex="-1000"),"both"!==n&&(n.style.zIndex="-1000"),this._setTimeoutForSlider(!0),this._nextQuestionTimeout=setTimeout(function(){this.props.nextQuestion()}.bind(this),1e3)},t.prototype.handleDataPushEvents=function(e){var t=this.props.question.sendDataToDMP;if(t){var n=(this.context.embedSettings.embedSetting.lotameID,this.context.embedSettings.parentWindow._cc10831);if(n){var i=this.props.question.question,r=e.predictionOption;n.add("seg","question:"+i+" -"+r),n.bcp()}}},t.prototype.handleShowNextQuestion=function(e){this.props.gameManagerOptions.increaseTotalQuestionsAnsweredInSet();var t=(this.props.gameManagerOptions.getTotalQuestionsAnswered(),this.props.gameManagerOptions.getTotalQuestionsAnsweredInSet()),n=this.context.embedSettings.embedSetting.showInstiPoll,i=this.context.embedSettings.embedSetting.instiPollInterval,r=this.props.gameManagerOptions.getInstiPollQuestions(),o=!1;n&&r.length>0&&(o=t%i===0),this.props.maxQuestionsPerGame<i&&(i=this.props.maxQuestionsPerGame);var s=!1,a=!1;if(s){var l=this.context.embedSettings.embedSetting.overlayAdShowingInterval;a=this.props.gameManagerOptions.showOverlayAd(l)}return a&&o&&!this.props.gameManagerOptions.getInstiPollShown()?(this.showOverlayAfterInstiPoll=!0,this._setTimeoutForSlider(!1),void(this._nextQuestionTimeout=setTimeout(function(){(this.questionAnswered||"demoMode"===this.props.playMode)&&this.props.gameManagerOptions.increaseTotalQuestionsAnswered(),o&&!this.interstitialActive&&this.props.gameManagerOptions.getGameStarted()&&!this.props.gameManagerOptions.getInstiPollShown()&&this.context.embedSettings.embedSetting.showInstiPoll&&"versusMode"!==this.props.playMode?(this.props.gameManagerOptions.pauseGame(),this.props.gameManagerOptions.showInterstitial("instiPoll"),this.interstitialActive=!0):(this.interstitialActive=!1,this.props.nextQuestion())}.bind(this),e))):void(a&&this.questionAnswered&&"versusMode"!==this.props.playMode?(a?(this.overlayIsActive=!0,setTimeout(function(){this.setState({showOverlayAd:!0})}.bind(this),e)):this._nextQuestionTimeout=setTimeout(function(){this.props.nextQuestion()}.bind(this),e),this.props.gameManagerOptions.increaseTotalQuestionsAnswered()):this.overlayIsActive||(this._setTimeoutForSlider(!1),this._nextQuestionTimeout=setTimeout(function(){return o&&!this.interstitialActive&&this.props.gameManagerOptions.getGameStarted()&&!this.props.gameManagerOptions.getInstiPollShown()&&this.context.embedSettings.embedSetting.showInstiPoll&&"versusMode"!==this.props.playMode?(this.props.gameManagerOptions.pauseGame(),this.props.gameManagerOptions.showInterstitial("instiPoll"),void(this.interstitialActive=!0)):((this.questionAnswered||"demoMode"===this.props.playMode)&&this.props.gameManagerOptions.increaseTotalQuestionsAnswered(),this.interstitialActive=!1,this.props.nextQuestion(),void 0)}.bind(this),e)))},t.prototype.render=function(){var e;this.state.showOverlayAd&&(e=r.createElement(c.default,{closeBtnClicked:this.closeAdButtonClicked.bind(this),playMode:this.props.playMode,renderedFromResults:!1}));var t=this.context.embedSettings.embedSetting.showHeaderLogo,n={};t?n={height:"76px"}:this.context.embedSettings.embedSetting.showAdOnShortWidget&&(n={height:"86px"});var i="";this.state.showSliderAnimation&&(i="slideOutLeft");var o,s,a=null,u=null,d=this.props.gameManagerOptions.getGameType(),p=this.props.playMode;o=this._setQuestionAnswersElem(p),s=r.createElement("div",{id:"questionAnswers"},o),a=this._setCounterElem(d),u=this._setCounterContainerElem(p,a);var h;try{"undefined"==typeof this.props.question.questionImageURL&&null===this.props.question.questionImageURL||(h=this.props.question.questionImageURL)}catch(e){h=""}return r.createElement("div",{id:"questionSection",className:i},e,u,r.createElement("div",{className:"questionContainer",style:n},r.createElement(l.default,{imgURL:h,question:this.props.question.question})),s)},t.prototype.componentDidMount=function(){this._setQuestionAnswers(),this._currentTime=new Date,this._currentTime=this._currentTime.getTime(),"versusMode"==this.props.playMode?this._enemyChoice():"pollsMode"!==this.props.playMode},t.prototype.componentWillUnmount=function(){clearInterval(this._counterCheckTimer),clearInterval(this.totalTimeTracker),clearTimeout(this._versusCounterEndCheckSetTimeOut),clearTimeout(this._counterEndCheckSetTimeOut),clearTimeout(this.counterEndTimeout),this._resetStates()},t.prototype._enemyChoice=function(){function e(e){var t=Math.floor(Math.random()*e+1);return t}var t=this;this._enemyChosenOption="";var n,i,r=!1,o=function(){var i=e(100);if(i>=40)n=t.props.question.answer;else{var r=e(t.props.question.options.length);n=t.props.question.options[r-1].predictionOption}},s=function(){var o,s=e(t.state.questionCountDown-4+1),a=(e(s),e(5)),l=.35*t.state.questionCountDown;if(a<5)o=e(l);else{var c=.65*t.state.questionCountDown;o=e(c)+l}o>=t.state.questionCountDown?(r=!0,i=null,n=null):i=o};o(),s(),this._enemyChosenOption=n,this._enemyAnswerTime=i},t.prototype._setVersusAnsweredTrue=function(e){this.questionAnswered=!0;var t=e.predictionOption,n=e.predictionOptionUUID,i=this.props.question.uid,r=e.predictionOption,o="VERSUS",s="answerQuestion";null!==e&&(this.keenUtil.answerQuestion(n,i,r,o,s),this.handleDataPushEvents(e)),this.setState({answered:!0,chosenOption:t,answerTime:this._getQuestionEndTime()})},t.prototype._setTimeoutForSlider=function(e){this.context.embedSettings.logger("_setTimeoutForSlider called");var t=2e3;e&&(t=0),setTimeout(function(){this.setState({showSliderAnimation:!0})}.bind(this),t)},t.prototype._versusCheckAnswer=function(e,t){var n,i="",s=e.predictionOption;return this.questionAnswered&&null!==this._enemyChosenOption&&(i=this._enemyChosenOption===s&&this._enemyChosenOption!==this.state.correctAnswer?this.state.chosenOption===s?"wrong clicked enemySelected userSelected fadeAway":"wrong clicked enemySelected fadeAway":this.state.correctAnswer==s?this.state.correctAnswer===this.state.chosenOption?this.state.correctAnswer===this._enemyChosenOption?"right clicked enemySelected userSelected":"right clicked userSelected":s===this._enemyChosenOption?"rightDelayed enemySelected":"rightDelayed":this.state.chosenOption===s?s===this._enemyChosenOption?"wrong clicked userSelected fadeAway enemySelected":"wrong clicked userSelected fadeAway":s===this._enemyChosenOption?"fadeAway enemySelected":"fadeAway"),this.questionAnswered&&this.state.chosenOption&&!this._enemyAnswered&&(i=this.state.chosenOption===s?"clicked userSelected":""),this.state.timeRanOut&&(this.questionAnswered&&this.state.chosenOption&&(i=this.state.correctAnswer==s?this.state.correctAnswer===this.state.chosenOption?"right clicked userSelected":"rightDelayed":this.state.chosenOption===s?"wrong clicked userSelected fadeAway":"fadeAway"),this._enemyAnswered&&this._enemyChosenOption&&(i=this.state.correctAnswer==s?this.state.correctAnswer===this._enemyChosenOption?"right clicked enemySelected":"rightDelayed":this._enemyChosenOption===s?"wrong clicked enemySelected fadeAway":"fadeAway"),null==this._enemyAnswerTime&&null==this._enemyChosenOption&&0==this.questionAnswered&&null==this.state.chosenOption&&(i=this.state.correctAnswer==s?"right":"fadeAway")),n=r.createElement(o.default,{gameManagerOptions:this.props.gameManagerOptions,playMode:this.props.playMode,answer:e,questionAnswered:this.questionAnswered,setAnsweredTrue:function(){},indicator:i,key:t})},t.prototype.overlayShowCheck=function(){var e=this.context.embedSettings.embedSetting.showOverlay;if(e)this.overlayIsActive=!0,this.setState({showOverlayAd:!0});else{this._setTimeoutForSlider(!1),clearInterval(this._counterCheckTimer);var t=3e3;this.handleShowNextQuestion(t)}},t.prototype._versusCounterEndCheck=function(){var e=!0;this.state.questionCountDown<=this.totalTimePassed/1e3&&(clearInterval(this.totalTimeTracker),this.totalTimePassed=0,e=!1);var t=this.state.resultsHoldTime+700,n=1e3*this._enemyAnswerTime,i=this._questionStartTime,r=this._currentTime;this._currentTime+=450;var o=1e3*Math.round((r-i)/1e3);if(o<=0&&(o=1e3),o<1e3*this.context.embedSettings.embedSetting.countdown&&o>=n&&(this._enemyAnswered=!0),!e)if(this.setState({counterActive:!1}),0==this._enemyAnswered&&0==this.questionAnswered){this.setState({timeRanOut:!0});this.handleShowNextQuestion(t);var s={prediction:!1,question:this.props.question.question,answer:this.state.correctAnswer,choice:null,timeAnswered:null,points:0,timeOut:!0,enemyTimeAnswered:null,enemyPoints:0,enemyChoice:null,enemyPrediction:!1};this.props.questionResults(s)}else if(1==this._enemyAnswered&&0==this.questionAnswered||0==this._enemyAnswered&&1==this.questionAnswered){this.setState({timeRanOut:!0}),this._calculateScore(this.state.chosenOption);this.handleShowNextQuestion(t)}if(1==this._enemyAnswered&&1==this.questionAnswered){this._calculateScore(this.state.chosenOption),this.setState({counterActive:!1}),clearInterval(this.totalTimeTracker);this.handleShowNextQuestion(t)}},t.prototype.timeRanOut=function(){if(this.setState({timeRanOut:!0,counterActive:!1}),"triviaMode"==this.props.playMode||"versusMode"==this.props.playMode){var e=500;this.handleShowNextQuestion(e);var t={prediction:!1,question:this.props.question.question,answer:this.state.correctAnswer,choice:null,timeAnswered:null,points:0,timeOut:!0};this.props.questionResults(t)}else if("demoMode"==this.props.playMode){var e=1e3;this.handleShowNextQuestion(e)}},t.prototype._getQuestionStartTime=function(){var e=new Date;return this._questionStartTime=e.getTime(),this._questionStartTime},t.prototype._getQuestionEndTime=function(){var e=new Date;return this._questionEndTime=e.getTime(),this._questionEndTime},t.prototype._resetStates=function(){this.questionAnswered=!1,this.setState({correctAnswer:null,answers:[],answered:!1,chosenOption:null,counterActive:!0,timeRanOut:!1,questionCountDown:5,pollResults:null,resultsTotal:null,retrySubmitPoll:!1})},t.prototype._checkAnswer=function(e,t){var n,i,s=e.predictionOption;return i=this.state.correctAnswer==s?this.state.correctAnswer===this.state.chosenOption?"right clicked":"rightDelayed":this.state.chosenOption===s?"wrong clicked":"",n=r.createElement(o.default,{gameManagerOptions:this.props.gameManagerOptions,playMode:this.props.playMode,answer:e,questionAnswered:this.questionAnswered,setAnsweredTrue:function(){},indicator:i,key:t})},t.prototype._submitPoll=function(e,t){var n,i,o,a;if(e=e.predictionOption,this.state.pollResults&&0!==this.state.pollResults.length)for(var l=0;l<this.state.pollResults.length;l++)e==this.state.pollResults[l].prediction&&(i=this.state.pollResults[l].result);a=this.state.chosenOption===e?parseInt(i)+1:parseInt(i),isNaN(a)&&this.state.chosenOption===e&&(a=1);var c=this.state.resultsTotal+1;return o=(a/c*100).toFixed()+"%",n=r.createElement(s.default,{answer:e,result:o,indicator:"clicked",key:t})},t.prototype._setAnsweredTrue=function(e){clearTimeout(this.counterEndTimeout),this.questionAnswered=!0,this.handleDataPushEvents(e);this.props.gameManagerOptions.getGameType();this.props.gameManagerOptions.getGameStarted()||this.props.gameScreenOptions.startGame();var t=e.predictionOption,n=this.props.gameManagerOptions.getGameType();n="trivia"===n?"TRIVIA":"POLL";var i=e.predictionOptionUUID,r=this.props.question.uid,o=e.predictionOption,s="answerQuestion";if(null!==e&&this.keenUtil.answerQuestion(i,r,o,n,s),"pollsMode"===this.props.playMode){this.setState({answered:!0,chosenOption:t,counterActive:!1});var a=3e3;this.handleShowNextQuestion(a)}else{this.setState({answered:!0,chosenOption:t,counterActive:!1}),this._getQuestionEndTime(),this._calculateScore(t);var a=3100;this.handleShowNextQuestion(a)}},t.prototype._calculateScore=function(e){var t,n,i,r,o,s=1e3*this.state.questionCountDown,a=this._questionStartTime,l=this._questionEndTime,c=this._questionPausedStartTime,u=this._questionPausedEndTime,d=e,p=!1,h=this.state.correctAnswer,m=d,f=!1,g=100;if(o=s/5,r=g/5,t=l-a-(u-c),this.state.correctAnswer===d&&(p=!0),p)if(t<o||0===a)n=g;else{var b=Math.round(t/o);5===b&&(b=4),n=g-Math.round(b*r)}else n=0;if(t=0===a?0:t/1e3%60,"versusMode"==this.props.playMode){var v=this._enemyAnswerTime,y=void 0,S=!1,w=this._enemyChosenOption;if(this.state.correctAnswer===w&&(S=!0),S)if(1e3*v<o)y=g;else{var b=Math.round(1e3*v/o);5===b&&(b=4),y=g-Math.round(b*r)}else y=0;v=0===a?0:t/1e3%60,i={prediction:p,question:this.props.question.question,answer:h,choice:m,timeAnswered:t,points:n,timeOut:f,enemyTimeAnswered:v,enemyPoints:y,enemyChoice:w,enemyPrediction:S}}else i={prediction:p,question:this.props.question.question,answer:h,choice:m,timeAnswered:t,points:n,timeOut:f};this.props.questionResults(i)},t.prototype._setQuestionAnswers=function(){for(var e=this.props.question,t=e.options,n=[],i=0;i<t.length;i++)n.push(t[i].predictionOption);"polls"!==this.context.gameManagerSettings.game&&(n=this._shuffleAnswers(n)),this.setState({correctAnswer:e.answer,answers:n})},t.prototype._shuffleAnswers=function(e){for(var t,n,i=e.length;0!==i;)n=Math.floor(Math.random()*i),i-=1,t=e[i],e[i]=e[n],e[n]=t;return e},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component));Object.defineProperty(t,"__esModule",{value:!0}),t.default=g},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(206),s=function(e){function t(){e.call(this),this.specialAnswerFontClass="",this.firstQuestionAnswered=!1,this.optionWasClicked=!1,this.buttonPressed=!1,this.state={indicatorWidthSet:!1}}return i(t,e),t.prototype.componentWillMount=function(){this.keenUtil=new o.default(this.context.embedSettings),this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled&&(this.specialAnswerFontClass="specialAnswerFontClass")},t.prototype.componentDidMount=function(){this.answerWidth=this.context.embedSettings.document.getElementsByClassName("answer")[0].clientWidth,this.setState({indicatorWidthSet:!0})},t.prototype.shouldComponentUpdate=function(e,t){switch(!0){case this.props.answer!==e.answer:return!0;case this.props.setAnsweredTrue!==e.setAnsweredTrue:return!0;case this.props.indicator!==e.indicator:return!0}return!1},t.prototype.optionClicked=function(){if(!this.props.questionAnswered){var e=this.props.gameManagerOptions.getGameType(),t=(this.props.gameManagerOptions.getGameMode(),"");"versusMode"===this.props.playMode?t="VERSUS":"trivia"===e?t="TRIVIA":"pollsMode"===this.props.playMode&&(t="POLL"),this.keenUtil.addClickEvent(t,"OPTION",this.props.answer.predictionOption),this.context.embedSettings.refreshAds(),this.buttonPressed=!0,this.props.setAnsweredTrue(this.props.answer)}},t.prototype.render=function(){var e,t,n="#30a939",i="#e4001c",o="",s="",a="",l="",c=this.props.indicator;if(c.indexOf("enemySelected")>-1&&(a="enemySelected"),c.indexOf("userSelected")>-1&&(l="userSelected"),c.indexOf("wrong")>-1&&(o=i),c.indexOf("right")>-1&&(o=n),c.indexOf("rightDelayed")>-1&&(o=n,s=".9s"),c.indexOf("netural")>-1&&(o=n),this.state.indicatorWidthSet&&(e={width:this.answerWidth+"px",left:"-"+this.answerWidth+"px",transitionDelay:s},t={width:this.answerWidth+"px",left:"-"+this.answerWidth+"px",background:o,msTransform:"translateX("+this.answerWidth+"px)",WebkitTransform:"translateX("+this.answerWidth+"px)",transform:"translateX("+this.answerWidth+"px)",transitionDelay:s}),this.buttonPressed)return r.createElement("div",{className:"answer clicked "+l+" "+a+" "+this.specialAnswerFontClass},this.props.answer.predictionOption,r.createElement("div",{className:"answer-indicator",style:t}));var u=void 0;return u=this.props.indicator?t:e,r.createElement("div",{className:"answer "+l+" "+a+" "+this.specialAnswerFontClass,onClick:this.optionClicked.bind(this)},this.props.answer.predictionOption,r.createElement("div",{className:"answer-indicator",style:u}))},t.contextTypes={embedSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(){e.call(this),this.specialAnswerFontClass="",this.state={answerWidthCalculated:!1}}return i(t,e),t.prototype.componentWillMount=function(){this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled&&(this.specialAnswerFontClass="specialAnswerFontClass")},t.prototype.componentDidMount=function(){this.answerWidth=this.context.embedSettings.document.getElementsByClassName("answer")[0].clientWidth,this.setState({answerWidthCalculated:!0})},t.prototype.render=function(){var e,t,n,i,o,s,a="",l=parseInt(this.props.result);return this.props.indicator.indexOf("clicked")>-1&&(a="clicked"),e={width:this.props.result},t="NaN%"==this.props.result?r.createElement("span",{className:"percentageNum"},"0%"):r.createElement("span",{className:"percentageNum"},this.props.result),this.context.embedSettings.logger("pollOptionResult answer: "+JSON.stringify(this.props.answer)),this.state.answerWidthCalculated&&(l&&(isNaN(l)||l<1)&&(l=0),s=this.answerWidth*(l/100),n={width:this.answerWidth+"px",left:"-"+this.answerWidth+"px"},i={width:this.answerWidth+"px",left:"-"+this.answerWidth+"px",msTransform:"translateX("+s+"px)",WebkitTransform:"translateX("+s+"px)",transform:"translateX("+s+"px)"}),o=this.props.indicator?i:n,r.createElement("div",{className:"answer "+a+" "+this.specialAnswerFontClass},this.props.answer,t,r.createElement("div",{className:"percentageBar",style:o}))},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i,r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28);i=n(234);var s=new i(window.navigator.userAgent),a=function(e){function t(){e.call(this),this.specialFontClass="",this.state={}}return r(t,e),t.prototype.componentWillMount=function(){this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled&&(this.specialFontClass="specialFontClass")},t.prototype.componentWillUnmount=function(){},t.prototype.shouldComponentUpdate=function(e,t){switch(!0){case this.props.question!==e.question:return!0}return!1},t.prototype.render=function(){var e;e=this.context.embedSettings.embedSetting.showQuestionImagesForMobile&&s.mobile()?{backgroundImage:"url("+this.props.imgURL+")"}:this.context.embedSettings.embedSetting.showQuestionImagesForWeb&&!s.mobile()?{backgroundImage:"url("+this.props.imgURL+")"}:null;var t={};return this.context.embedSettings.embedSetting.showAdOnShortWidget&&(t.fontSize="1.6em !important"),o.createElement("div",{className:"question"},o.createElement("div",{className:"questionImage",style:e}),o.createElement("div",{className:"questionText "+this.specialFontClass,style:t},this.props.question))},t.prototype.componentDidMount=function(){},t.contextTypes={embedSettings:o.PropTypes.object.isRequired,gameManagerSettings:o.PropTypes.object.isRequired},t}(o.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=a},function(e,t,n){function i(e,t){this.analysis=e,this.params={},this.set(t),void 0===this.params.timezone&&(this.params.timezone=(new Date).getTimezoneOffset()*-60)}var r=n(246),o=n(251),s=n(247),a=n(248),l=n(255);a(r.prototype,l),r.prototype.readKey=function(e){return arguments.length?(this.config.readKey=e?String(e):null,this):this.config.readKey},r.prototype.query=function(e,t){if(e&&t&&"string"==typeof t)return t.indexOf("/result")<0&&(t+="/result"),this.get(this.url("queries",e,t)).auth(this.readKey()).send();if("dataset"===e&&"object"==typeof t)return this.get(this.url("datasets",t.name,"results")).auth(this.readKey()).send(t);if(e&&t&&"object"==typeof t){var n=a({analysis_type:e},t);return this.post(this.url("queries",e)).auth(this.readKey()).send(n);
}return e&&!t?o.reject({error_code:"SDKError",message:".query() called with incorrect arguments"}):void 0},r.Query=i,r.prototype.run=function(e,t){var n,i,l,c=this,u=t;return t=null,n=e instanceof Array?e:[e],i=[],s(n,function(e,t){"string"==typeof e?i.push(c.query("saved",e+"/result")):e instanceof r.Query&&i.push(c.query(e.analysis,a({analysis_type:e.analysis},e.params)))}),l=i.length>1?o.all(i):i[0],u&&(l.then(function(e){u(null,e)}),l.catch(function(e){u(e,null)})),l},i.prototype.set=function(e){var t=this;return s(e,function(e,n){var i=n,r=e;n.match(new RegExp("[A-Z]"))&&(i=n.replace(/([A-Z])/g,function(e){return"_"+e.toLowerCase()})),t.params[i]=r,r instanceof Array&&s(r,function(e,n){e instanceof Array==0&&"object"==typeof e&&s(e,function(e,r){if(r.match(new RegExp("[A-Z]"))){var o=r.replace(/([A-Z])/g,function(e){return"_"+e.toLowerCase()});delete t.params[i][n][r],t.params[i][n][o]=e}})})}),t},i.prototype.get=function(e){var t=e;if(t.match(new RegExp("[A-Z]"))&&(t=t.replace(/([A-Z])/g,function(e){return"_"+e.toLowerCase()})),this.params)return this.params[t]||null},i.prototype.addFilter=function(e,t,n){return this.params.filters=this.params.filters||[],this.params.filters.push({property_name:e,operator:t,property_value:n}),this},e.exports=r},function(e,t,n){(function(t){(function(t){function i(e){return this instanceof i==!1?new i(e):(this.configure(e),i.debug&&this.on("error",i.log),this.emit("ready"),void i.emit("client",this))}function r(e){return i.loaded||"undefined"==typeof document?void e():(null==document.readyState&&document.addEventListener&&(document.addEventListener("DOMContentLoaded",function e(){document.removeEventListener("DOMContentLoaded",e,!1),document.readyState="complete"},!1),document.readyState="loading"),void o(e))}function o(e){/in/.test(document.readyState)?setTimeout(function(){o(e)},9):e()}function s(e){return"undefined"!=typeof e}var a=t.Keen||void 0,l=n(247),c=n(248),u=n(249),d=n(250),p=n(214);a&&"undefined"==typeof a.resources&&(i.legacyVersion=a),p(i),p(i.prototype),c(i,{debug:!1,enabled:!0,loaded:!1,version:"__VERSION__"}),i.helpers=i.helpers||{},i.resources=i.resources||{},c(i.resources,{base:"{protocol}://{host}",version:"{protocol}://{host}/3.0",projects:"{protocol}://{host}/3.0/projects",projectId:"{protocol}://{host}/3.0/projects/{projectId}",events:"{protocol}://{host}/3.0/projects/{projectId}/events",queries:"{protocol}://{host}/3.0/projects/{projectId}/queries",datasets:"{protocol}://{host}/3.0/projects/{projectId}/datasets"}),i.utils=i.utils||{},c(i.utils,{each:l,extend:c,parseParams:u,serialize:d}),i.extendLibrary=function(e,t){var n=a||t;return s(n)&&s(n.resources)&&(l(n,function(t,n){"object"==typeof t?(e[n]=e[n]||{},c(e[n],t)):e[n]=e[n]||t}),c(e.prototype,n.prototype)),e},i.log=function(e){i.debug&&"object"==typeof console&&console.log("[Keen]",e)},i.noConflict=function(){return"undefined"!=typeof t.Keen&&(t.Keen=i.legacyVersion||a),i},i.ready=function(e){i.loaded?e():i.once("ready",e)},i.prototype.configure=function(e){var t=e||{};return this.config=this.config||{projectId:void 0,writeKey:void 0,host:"api.keen.io",protocol:"https",requestType:"jsonp",resources:c({},i.resources)},"undefined"!=typeof window&&window.navigator&&window.navigator.userAgent&&window.navigator.userAgent.indexOf("MSIE")>-1&&(t.protocol=document.location.protocol.replace(":","")),t.host&&t.host.replace(/.*?:\/\//g,""),c(this.config,t),this},i.prototype.masterKey=function(e){return arguments.length?(this.config.masterKey=e?String(e):null,this):this.config.masterKey},i.prototype.projectId=function(e){return arguments.length?(this.config.projectId=e?String(e):null,this):this.config.projectId},i.prototype.resources=function(e){if(!arguments.length)return this.config.resources;var t=this;return"object"==typeof e&&l(e,function(e,n){t.config.resources[n]=e?e:null}),t},i.prototype.url=function(e){var t,n=Array.prototype.slice.call(arguments,1),i=this.config.resources.base||"{protocol}://{host}";return t=e&&"string"==typeof e?this.config.resources[e]?this.config.resources[e]:i+e:i,l(this.config,function(e,n){"object"!=typeof e&&(t=t.replace("{"+n+"}",e))}),l(n,function(e,n){"string"==typeof e?t+="/"+e:"object"==typeof e&&(t+="?",l(e,function(e,n){t+=n+"="+e+"&"}),t=t.slice(0,-1))}),t},r(function(){i.loaded=!0,i.emit("ready")}),e.exports=i}).call(this,"undefined"!=typeof window?window:"undefined"!=typeof t?t:"undefined"!=typeof self?self:{})}).call(t,function(){return this}())},function(e,t){function n(e,t,n){var i;if(!e)return 0;if(n=n?n:e,e instanceof Array){for(i=0;i<e.length;i++)if(t.call(n,e[i],i,e)===!1)return 0}else for(i in e)if(e.hasOwnProperty(i)&&t.call(n,e[i],i,e)===!1)return 0;return 1}e.exports=n},function(e,t){function n(e){for(var t=1;t<arguments.length;t++)for(var n in arguments[t])e[n]=arguments[t][n];return e}e.exports=n},function(e,t){function n(e){for(var t,n={},i=/\+/g,r=/([^&=]+)=?([^&]*)/g,o=function(e){return decodeURIComponent(e.replace(i," "))},s=e.split("?")[1];t=r.exec(s);)n[o(t[1])]=o(t[2]);return n}e.exports=n},function(e,t,n){function i(e){var t=[];return r(e,function(e,n){"string"!=typeof e&&(e=JSON.stringify(e)),t.push(n+"="+encodeURIComponent(e))}),t.join("&")}var r=n(247);n(248);e.exports=i},function(e,t,n){var i=n(252);i.config({cancellation:!0,longStackTraces:!1,warnings:!1}),e.exports=i},function(e,t,n){(function(t,n,i){!function(t){e.exports=t()}(function(){var e,r,o;return function e(t,n,i){function r(s,a){if(!n[s]){if(!t[s]){var l="function"==typeof _dereq_&&_dereq_;if(!a&&l)return l(s,!0);if(o)return o(s,!0);var c=new Error("Cannot find module '"+s+"'");throw c.code="MODULE_NOT_FOUND",c}var u=n[s]={exports:{}};t[s][0].call(u.exports,function(e){var n=t[s][1][e];return r(n?n:e)},u,u.exports,e,t,n,i)}return n[s].exports}for(var o="function"==typeof _dereq_&&_dereq_,s=0;s<i.length;s++)r(i[s]);return r}({1:[function(e,n,i){"use strict";function r(){this._customScheduler=!1,this._isTickUsed=!1,this._lateQueue=new u(16),this._normalQueue=new u(16),this._haveDrainedQueues=!1,this._trampolineEnabled=!0;var e=this;this.drainQueues=function(){e._drainQueues()},this._schedule=c}function o(e,t,n){this._lateQueue.push(e,t,n),this._queueTick()}function s(e,t,n){this._normalQueue.push(e,t,n),this._queueTick()}function a(e){this._normalQueue._pushOne(e),this._queueTick()}var l;try{throw new Error}catch(e){l=e}var c=e("./schedule"),u=e("./queue"),d=e("./util");r.prototype.setScheduler=function(e){var t=this._schedule;return this._schedule=e,this._customScheduler=!0,t},r.prototype.hasCustomScheduler=function(){return this._customScheduler},r.prototype.enableTrampoline=function(){this._trampolineEnabled=!0},r.prototype.disableTrampolineIfNecessary=function(){d.hasDevTools&&(this._trampolineEnabled=!1)},r.prototype.haveItemsQueued=function(){return this._isTickUsed||this._haveDrainedQueues},r.prototype.fatalError=function(e,n){n?(t.stderr.write("Fatal "+(e instanceof Error?e.stack:e)+"\n"),t.exit(2)):this.throwLater(e)},r.prototype.throwLater=function(e,t){if(1===arguments.length&&(t=e,e=function(){throw t}),"undefined"!=typeof setTimeout)setTimeout(function(){e(t)},0);else try{this._schedule(function(){e(t)})}catch(e){throw new Error("No async scheduler available\n\n    See http://goo.gl/MqrFmX\n")}},d.hasDevTools?(r.prototype.invokeLater=function(e,t,n){this._trampolineEnabled?o.call(this,e,t,n):this._schedule(function(){setTimeout(function(){e.call(t,n)},100)})},r.prototype.invoke=function(e,t,n){this._trampolineEnabled?s.call(this,e,t,n):this._schedule(function(){e.call(t,n)})},r.prototype.settlePromises=function(e){this._trampolineEnabled?a.call(this,e):this._schedule(function(){e._settlePromises()})}):(r.prototype.invokeLater=o,r.prototype.invoke=s,r.prototype.settlePromises=a),r.prototype._drainQueue=function(e){for(;e.length()>0;){var t=e.shift();if("function"==typeof t){var n=e.shift(),i=e.shift();t.call(n,i)}else t._settlePromises()}},r.prototype._drainQueues=function(){this._drainQueue(this._normalQueue),this._reset(),this._haveDrainedQueues=!0,this._drainQueue(this._lateQueue)},r.prototype._queueTick=function(){this._isTickUsed||(this._isTickUsed=!0,this._schedule(this.drainQueues))},r.prototype._reset=function(){this._isTickUsed=!1},n.exports=r,n.exports.firstLineError=l},{"./queue":17,"./schedule":18,"./util":21}],2:[function(e,t,n){"use strict";t.exports=function(e,t,n,i){var r=!1,o=function(e,t){this._reject(t)},s=function(e,t){t.promiseRejectionQueued=!0,t.bindingPromise._then(o,o,null,this,e)},a=function(e,t){0===(50397184&this._bitField)&&this._resolveCallback(t.target)},l=function(e,t){t.promiseRejectionQueued||this._reject(e)};e.prototype.bind=function(o){r||(r=!0,e.prototype._propagateFrom=i.propagateFromFunction(),e.prototype._boundValue=i.boundValueFunction());var c=n(o),u=new e(t);u._propagateFrom(this,1);var d=this._target();if(u._setBoundTo(c),c instanceof e){var p={promiseRejectionQueued:!1,promise:u,target:d,bindingPromise:c};d._then(t,s,void 0,u,p),c._then(a,l,void 0,u,p),u._setOnCancel(c)}else u._resolveCallback(d);return u},e.prototype._setBoundTo=function(e){void 0!==e?(this._bitField=2097152|this._bitField,this._boundTo=e):this._bitField=this._bitField&-2097153},e.prototype._isBound=function(){return 2097152===(2097152&this._bitField)},e.bind=function(t,n){return e.resolve(n).bind(t)}}},{}],3:[function(e,t,n){"use strict";function i(){try{Promise===o&&(Promise=r)}catch(e){}return o}var r;"undefined"!=typeof Promise&&(r=Promise);var o=e("./promise")();o.noConflict=i,t.exports=o},{"./promise":15}],4:[function(e,t,n){"use strict";t.exports=function(t,n,i,r){var o=e("./util"),s=o.tryCatch,a=o.errorObj,l=t._async;t.prototype.break=t.prototype.cancel=function(){if(!r.cancellation())return this._warn("cancellation is disabled");for(var e=this,t=e;e._isCancellable();){if(!e._cancelBy(t)){t._isFollowing()?t._followee().cancel():t._cancelBranched();break}var n=e._cancellationParent;if(null==n||!n._isCancellable()){e._isFollowing()?e._followee().cancel():e._cancelBranched();break}e._isFollowing()&&e._followee().cancel(),e._setWillBeCancelled(),t=e,e=n}},t.prototype._branchHasCancelled=function(){this._branchesRemainingToCancel--},t.prototype._enoughBranchesHaveCancelled=function(){return void 0===this._branchesRemainingToCancel||this._branchesRemainingToCancel<=0},t.prototype._cancelBy=function(e){return e===this?(this._branchesRemainingToCancel=0,this._invokeOnCancel(),!0):(this._branchHasCancelled(),!!this._enoughBranchesHaveCancelled()&&(this._invokeOnCancel(),!0))},t.prototype._cancelBranched=function(){this._enoughBranchesHaveCancelled()&&this._cancel()},t.prototype._cancel=function(){this._isCancellable()&&(this._setCancelled(),l.invoke(this._cancelPromises,this,void 0))},t.prototype._cancelPromises=function(){this._length()>0&&this._settlePromises()},t.prototype._unsetOnCancel=function(){this._onCancelField=void 0},t.prototype._isCancellable=function(){return this.isPending()&&!this._isCancelled()},t.prototype.isCancellable=function(){return this.isPending()&&!this.isCancelled()},t.prototype._doInvokeOnCancel=function(e,t){if(o.isArray(e))for(var n=0;n<e.length;++n)this._doInvokeOnCancel(e[n],t);else if(void 0!==e)if("function"==typeof e){if(!t){var i=s(e).call(this._boundValue());i===a&&(this._attachExtraTrace(i.e),l.throwLater(i.e))}}else e._resultCancelled(this)},t.prototype._invokeOnCancel=function(){var e=this._onCancel();this._unsetOnCancel(),l.invoke(this._doInvokeOnCancel,this,e)},t.prototype._invokeInternalOnCancel=function(){this._isCancellable()&&(this._doInvokeOnCancel(this._onCancel(),!0),this._unsetOnCancel())},t.prototype._resultCancelled=function(){this.cancel()}}},{"./util":21}],5:[function(e,t,n){"use strict";t.exports=function(t){function n(e,n,a){return function(l){var c=a._boundValue();e:for(var u=0;u<e.length;++u){var d=e[u];if(d===Error||null!=d&&d.prototype instanceof Error){if(l instanceof d)return o(n).call(c,l)}else if("function"==typeof d){var p=o(d).call(c,l);if(p===s)return p;if(p)return o(n).call(c,l)}else if(i.isObject(l)){for(var h=r(d),m=0;m<h.length;++m){var f=h[m];if(d[f]!=l[f])continue e}return o(n).call(c,l)}}return t}}var i=e("./util"),r=e("./es5").keys,o=i.tryCatch,s=i.errorObj;return n}},{"./es5":10,"./util":21}],6:[function(e,t,n){"use strict";t.exports=function(e){function t(){this._trace=new t.CapturedTrace(i())}function n(){if(r)return new t}function i(){var e=o.length-1;if(e>=0)return o[e]}var r=!1,o=[];return e.prototype._promiseCreated=function(){},e.prototype._pushContext=function(){},e.prototype._popContext=function(){return null},e._peekContext=e.prototype._peekContext=function(){},t.prototype._pushContext=function(){void 0!==this._trace&&(this._trace._promiseCreated=null,o.push(this._trace))},t.prototype._popContext=function(){if(void 0!==this._trace){var e=o.pop(),t=e._promiseCreated;return e._promiseCreated=null,t}return null},t.CapturedTrace=null,t.create=n,t.deactivateLongStackTraces=function(){},t.activateLongStackTraces=function(){var n=e.prototype._pushContext,o=e.prototype._popContext,s=e._peekContext,a=e.prototype._peekContext,l=e.prototype._promiseCreated;t.deactivateLongStackTraces=function(){e.prototype._pushContext=n,e.prototype._popContext=o,e._peekContext=s,e.prototype._peekContext=a,e.prototype._promiseCreated=l,r=!1},r=!0,e.prototype._pushContext=t.prototype._pushContext,e.prototype._popContext=t.prototype._popContext,e._peekContext=e.prototype._peekContext=i,e.prototype._promiseCreated=function(){var e=this._peekContext();e&&null==e._promiseCreated&&(e._promiseCreated=this)}},t}},{}],7:[function(e,n,i){"use strict";n.exports=function(n,i){function r(e,t){return{promise:t}}function o(){return!1}function s(e,t,n){var i=this;try{e(t,n,function(e){if("function"!=typeof e)throw new TypeError("onCancel must be a function, got: "+U.toString(e));i._attachCancellationCallback(e)})}catch(e){return e}}function a(e){if(!this._isCancellable())return this;var t=this._onCancel();void 0!==t?U.isArray(t)?t.push(e):this._setOnCancel([t,e]):this._setOnCancel(e)}function l(){return this._onCancelField}function c(e){this._onCancelField=e}function u(){this._cancellationParent=void 0,this._onCancelField=void 0}function d(e,t){if(0!==(1&t)){this._cancellationParent=e;var n=e._branchesRemainingToCancel;void 0===n&&(n=0),e._branchesRemainingToCancel=n+1}0!==(2&t)&&e._isBound()&&this._setBoundTo(e._boundTo)}function p(e,t){0!==(2&t)&&e._isBound()&&this._setBoundTo(e._boundTo)}function h(){var e=this._boundTo;return void 0!==e&&e instanceof n?e.isFulfilled()?e.value():void 0:e}function m(){this._trace=new I(this._peekContext())}function f(e,t){if(q(e)){var n=this._trace;if(void 0!==n&&t&&(n=n._parent),void 0!==n)n.attachExtraTrace(e);else if(!e.__stackCleaned__){var i=T(e);U.notEnumerableProp(e,"stack",i.message+"\n"+i.stack.join("\n")),U.notEnumerableProp(e,"__stackCleaned__",!0)}}}function g(e,t,n,i,r){if(void 0===e&&null!==t&&Y){if(void 0!==r&&r._returnedNonUndefined())return;if(0===(65535&i._bitField))return;n&&(n+=" ");var o="",s="";if(t._trace){for(var a=t._trace.stack.split("\n"),l=E(a),c=l.length-1;c>=0;--c){var u=l[c];if(!F.test(u)){var d=u.match(j);d&&(o="at "+d[1]+":"+d[2]+":"+d[3]+" ");break}}if(l.length>0)for(var p=l[0],c=0;c<a.length;++c)if(a[c]===p){c>0&&(s="\n"+a[c-1]);break}}var h="a promise was created in a "+n+"handler "+o+"but was not returned from it, see http://goo.gl/rRqMUw"+s;i._warn(h,!0,t)}}function b(e,t){var n=e+" is deprecated and will be removed in a future version.";return t&&(n+=" Use "+t+" instead."),v(n)}function v(e,t,i){if(se.warnings){var r,o=new G(e);if(t)i._attachExtraTrace(o);else if(se.longStackTraces&&(r=n._peekContext()))r.attachExtraTrace(o);else{var s=T(o);o.stack=s.message+"\n"+s.stack.join("\n")}te("warning",o)||x(o,"",!0)}}function y(e,t){for(var n=0;n<t.length-1;++n)t[n].push("From previous event:"),t[n]=t[n].join("\n");return n<t.length&&(t[n]=t[n].join("\n")),e+"\n"+t.join("\n")}function S(e){for(var t=0;t<e.length;++t)(0===e[t].length||t+1<e.length&&e[t][0]===e[t+1][0])&&(e.splice(t,1),t--)}function w(e){for(var t=e[0],n=1;n<e.length;++n){for(var i=e[n],r=t.length-1,o=t[r],s=-1,a=i.length-1;a>=0;--a)if(i[a]===o){s=a;break}for(var a=s;a>=0;--a){var l=i[a];if(t[r]!==l)break;t.pop(),r--}t=i}}function E(e){for(var t=[],n=0;n<e.length;++n){var i=e[n],r="    (No stack trace)"===i||Q.test(i),o=r&&ie(i);r&&!o&&(z&&" "!==i.charAt(0)&&(i="    "+i),t.push(i))}return t}function C(e){for(var t=e.stack.replace(/\s+$/g,"").split("\n"),n=0;n<t.length;++n){var i=t[n];if("    (No stack trace)"===i||Q.test(i))break}return n>0&&"SyntaxError"!=e.name&&(t=t.slice(n)),t}function T(e){var t=e.stack,n=e.toString();return t="string"==typeof t&&t.length>0?C(e):["    (No stack trace)"],{message:n,stack:"SyntaxError"==e.name?t:E(t)}}function x(e,t,n){if("undefined"!=typeof console){var i;if(U.isObject(e)){var r=e.stack;i=t+V(r,e)}else i=t+String(e);"function"==typeof N?N(i,n):"function"!=typeof console.log&&"object"!=typeof console.log||console.log(i)}}function _(e,t,n,i){var r=!1;try{"function"==typeof t&&(r=!0,"rejectionHandled"===e?t(i):t(n,i))}catch(e){B.throwLater(e)}"unhandledRejection"===e?te(e,n,i)||r||x(n,"Unhandled rejection "):te(e,i)}function k(e){var t;if("function"==typeof e)t="[function "+(e.name||"anonymous")+"]";else{t=e&&"function"==typeof e.toString?e.toString():U.toString(e);var n=/\[object [a-zA-Z0-9$_]+\]/;if(n.test(t))try{var i=JSON.stringify(e);t=i}catch(e){}0===t.length&&(t="(empty array)")}return"(<"+M(t)+">, no stack trace)"}function M(e){var t=41;return e.length<t?e:e.substr(0,t-3)+"..."}function A(){return"function"==typeof oe}function P(e){var t=e.match(re);if(t)return{fileName:t[1],line:parseInt(t[2],10)}}function O(e,t){if(A()){for(var n,i,r=e.stack.split("\n"),o=t.stack.split("\n"),s=-1,a=-1,l=0;l<r.length;++l){var c=P(r[l]);if(c){n=c.fileName,s=c.line;break}}for(var l=0;l<o.length;++l){var c=P(o[l]);if(c){i=c.fileName,a=c.line;break}}s<0||a<0||!n||!i||n!==i||s>=a||(ie=function(e){if(H.test(e))return!0;var t=P(e);return!!(t&&t.fileName===n&&s<=t.line&&t.line<=a)})}}function I(e){this._parent=e,this._promisesCreated=0;var t=this._length=1+(void 0===e?0:e._length);oe(this,I),t>32&&this.uncycle()}var R,D,N,L=n._getDomain,B=n._async,G=e("./errors").Warning,U=e("./util"),q=U.canAttachTrace,H=/[\\\/]bluebird[\\\/]js[\\\/](release|debug|instrumented)/,F=/\((?:timers\.js):\d+:\d+\)/,j=/[\/<\(](.+?):(\d+):(\d+)\)?\s*$/,Q=null,V=null,z=!1,W=!(0==U.env("BLUEBIRD_DEBUG")),K=!(0==U.env("BLUEBIRD_WARNINGS")||!W&&!U.env("BLUEBIRD_WARNINGS")),X=!(0==U.env("BLUEBIRD_LONG_STACK_TRACES")||!W&&!U.env("BLUEBIRD_LONG_STACK_TRACES")),Y=0!=U.env("BLUEBIRD_W_FORGOTTEN_RETURN")&&(K||!!U.env("BLUEBIRD_W_FORGOTTEN_RETURN"));n.prototype.suppressUnhandledRejections=function(){var e=this._target();e._bitField=e._bitField&-1048577|524288},n.prototype._ensurePossibleRejectionHandled=function(){if(0===(524288&this._bitField)){this._setRejectionIsUnhandled();var e=this;setTimeout(function(){e._notifyUnhandledRejection()},1)}},n.prototype._notifyUnhandledRejectionIsHandled=function(){_("rejectionHandled",R,void 0,this)},n.prototype._setReturnedNonUndefined=function(){this._bitField=268435456|this._bitField},n.prototype._returnedNonUndefined=function(){return 0!==(268435456&this._bitField)},n.prototype._notifyUnhandledRejection=function(){if(this._isRejectionUnhandled()){var e=this._settledValue();this._setUnhandledRejectionIsNotified(),_("unhandledRejection",D,e,this)}},n.prototype._setUnhandledRejectionIsNotified=function(){this._bitField=262144|this._bitField},n.prototype._unsetUnhandledRejectionIsNotified=function(){this._bitField=this._bitField&-262145},n.prototype._isUnhandledRejectionNotified=function(){return(262144&this._bitField)>0},n.prototype._setRejectionIsUnhandled=function(){this._bitField=1048576|this._bitField},n.prototype._unsetRejectionIsUnhandled=function(){this._bitField=this._bitField&-1048577,this._isUnhandledRejectionNotified()&&(this._unsetUnhandledRejectionIsNotified(),this._notifyUnhandledRejectionIsHandled())},n.prototype._isRejectionUnhandled=function(){return(1048576&this._bitField)>0},n.prototype._warn=function(e,t,n){return v(e,t,n||this)},n.onPossiblyUnhandledRejection=function(e){var t=L();D="function"==typeof e?null===t?e:U.domainBind(t,e):void 0},n.onUnhandledRejectionHandled=function(e){var t=L();R="function"==typeof e?null===t?e:U.domainBind(t,e):void 0};var J=function(){};n.longStackTraces=function(){if(B.haveItemsQueued()&&!se.longStackTraces)throw new Error("cannot enable long stack traces after promises have been created\n\n    See http://goo.gl/MqrFmX\n");if(!se.longStackTraces&&A()){var e=n.prototype._captureStackTrace,t=n.prototype._attachExtraTrace;se.longStackTraces=!0,J=function(){if(B.haveItemsQueued()&&!se.longStackTraces)throw new Error("cannot enable long stack traces after promises have been created\n\n    See http://goo.gl/MqrFmX\n");n.prototype._captureStackTrace=e,n.prototype._attachExtraTrace=t,i.deactivateLongStackTraces(),B.enableTrampoline(),se.longStackTraces=!1},n.prototype._captureStackTrace=m,n.prototype._attachExtraTrace=f,i.activateLongStackTraces(),B.disableTrampolineIfNecessary()}},n.hasLongStackTraces=function(){return se.longStackTraces&&A()};var Z=function(){try{if("function"==typeof CustomEvent){var e=new CustomEvent("CustomEvent");return U.global.dispatchEvent(e),function(e,t){var n=new CustomEvent(e.toLowerCase(),{detail:t,cancelable:!0});return!U.global.dispatchEvent(n)}}if("function"==typeof Event){var e=new Event("CustomEvent");return U.global.dispatchEvent(e),function(e,t){var n=new Event(e.toLowerCase(),{cancelable:!0});return n.detail=t,!U.global.dispatchEvent(n)}}var e=document.createEvent("CustomEvent");return e.initCustomEvent("testingtheevent",!1,!0,{}),U.global.dispatchEvent(e),function(e,t){var n=document.createEvent("CustomEvent");return n.initCustomEvent(e.toLowerCase(),!1,!0,t),!U.global.dispatchEvent(n)}}catch(e){}return function(){return!1}}(),$=function(){return U.isNode?function(){return t.emit.apply(t,arguments)}:U.global?function(e){var t="on"+e.toLowerCase(),n=U.global[t];return!!n&&(n.apply(U.global,[].slice.call(arguments,1)),!0)}:function(){return!1}}(),ee={promiseCreated:r,promiseFulfilled:r,promiseRejected:r,promiseResolved:r,promiseCancelled:r,promiseChained:function(e,t,n){return{promise:t,child:n}},warning:function(e,t){return{warning:t}},unhandledRejection:function(e,t,n){return{reason:t,promise:n}},rejectionHandled:r},te=function(e){var t=!1;try{t=$.apply(null,arguments)}catch(e){B.throwLater(e),t=!0}var n=!1;try{n=Z(e,ee[e].apply(null,arguments))}catch(e){B.throwLater(e),n=!0}return n||t};n.config=function(e){if(e=Object(e),"longStackTraces"in e&&(e.longStackTraces?n.longStackTraces():!e.longStackTraces&&n.hasLongStackTraces()&&J()),"warnings"in e){var t=e.warnings;se.warnings=!!t,Y=se.warnings,U.isObject(t)&&"wForgottenReturn"in t&&(Y=!!t.wForgottenReturn)}if("cancellation"in e&&e.cancellation&&!se.cancellation){if(B.haveItemsQueued())throw new Error("cannot enable cancellation after promises are in use");n.prototype._clearCancellationData=u,n.prototype._propagateFrom=d,n.prototype._onCancel=l,n.prototype._setOnCancel=c,n.prototype._attachCancellationCallback=a,n.prototype._execute=s,ne=d,se.cancellation=!0}return"monitoring"in e&&(e.monitoring&&!se.monitoring?(se.monitoring=!0,n.prototype._fireEvent=te):!e.monitoring&&se.monitoring&&(se.monitoring=!1,n.prototype._fireEvent=o)),n},n.prototype._fireEvent=o,n.prototype._execute=function(e,t,n){try{e(t,n)}catch(e){return e}},n.prototype._onCancel=function(){},n.prototype._setOnCancel=function(e){},n.prototype._attachCancellationCallback=function(e){},n.prototype._captureStackTrace=function(){},n.prototype._attachExtraTrace=function(){},n.prototype._clearCancellationData=function(){},n.prototype._propagateFrom=function(e,t){};var ne=p,ie=function(){return!1},re=/[\/<\(]([^:\/]+):(\d+):(?:\d+)\)?\s*$/;U.inherits(I,Error),i.CapturedTrace=I,I.prototype.uncycle=function(){var e=this._length;if(!(e<2)){for(var t=[],n={},i=0,r=this;void 0!==r;++i)t.push(r),r=r._parent;e=this._length=i;for(var i=e-1;i>=0;--i){var o=t[i].stack;void 0===n[o]&&(n[o]=i)}for(var i=0;i<e;++i){var s=t[i].stack,a=n[s];if(void 0!==a&&a!==i){a>0&&(t[a-1]._parent=void 0,t[a-1]._length=1),t[i]._parent=void 0,t[i]._length=1;var l=i>0?t[i-1]:this;a<e-1?(l._parent=t[a+1],l._parent.uncycle(),l._length=l._parent._length+1):(l._parent=void 0,l._length=1);for(var c=l._length+1,u=i-2;u>=0;--u)t[u]._length=c,c++;return}}}},I.prototype.attachExtraTrace=function(e){if(!e.__stackCleaned__){this.uncycle();for(var t=T(e),n=t.message,i=[t.stack],r=this;void 0!==r;)i.push(E(r.stack.split("\n"))),r=r._parent;w(i),S(i),U.notEnumerableProp(e,"stack",y(n,i)),U.notEnumerableProp(e,"__stackCleaned__",!0)}};var oe=function(){var e=/^\s*at\s*/,t=function(e,t){return"string"==typeof e?e:void 0!==t.name&&void 0!==t.message?t.toString():k(t)};if("number"==typeof Error.stackTraceLimit&&"function"==typeof Error.captureStackTrace){Error.stackTraceLimit+=6,Q=e,V=t;var n=Error.captureStackTrace;return ie=function(e){return H.test(e)},function(e,t){Error.stackTraceLimit+=6,n(e,t),Error.stackTraceLimit-=6}}var i=new Error;if("string"==typeof i.stack&&i.stack.split("\n")[0].indexOf("stackDetection@")>=0)return Q=/@/,V=t,z=!0,function(e){e.stack=(new Error).stack};var r;try{throw new Error}catch(e){r="stack"in e}return"stack"in i||!r||"number"!=typeof Error.stackTraceLimit?(V=function(e,t){return"string"==typeof e?e:"object"!=typeof t&&"function"!=typeof t||void 0===t.name||void 0===t.message?k(t):t.toString()},null):(Q=e,V=t,function(e){Error.stackTraceLimit+=6;try{throw new Error}catch(t){e.stack=t.stack}Error.stackTraceLimit-=6})}([]);"undefined"!=typeof console&&"undefined"!=typeof console.warn&&(N=function(e){console.warn(e)},U.isNode&&t.stderr.isTTY?N=function(e,t){var n=t?"[33m":"[31m";console.warn(n+e+"[0m\n")}:U.isNode||"string"!=typeof(new Error).stack||(N=function(e,t){console.warn("%c"+e,t?"color: darkorange":"color: red")}));var se={warnings:K,longStackTraces:!1,cancellation:!1,monitoring:!1};return X&&n.longStackTraces(),{longStackTraces:function(){return se.longStackTraces},warnings:function(){return se.warnings},cancellation:function(){return se.cancellation},monitoring:function(){return se.monitoring},propagateFromFunction:function(){return ne},boundValueFunction:function(){return h},checkForgottenReturns:g,setBounds:O,warn:v,deprecated:b,CapturedTrace:I,fireDomEvent:Z,fireGlobalEvent:$}}},{"./errors":9,"./util":21}],8:[function(e,t,n){"use strict";t.exports=function(e){function t(){return this.value}function n(){throw this.reason}e.prototype.return=e.prototype.thenReturn=function(n){return n instanceof e&&n.suppressUnhandledRejections(),this._then(t,void 0,void 0,{value:n},void 0)},e.prototype.throw=e.prototype.thenThrow=function(e){return this._then(n,void 0,void 0,{reason:e},void 0)},e.prototype.catchThrow=function(e){if(arguments.length<=1)return this._then(void 0,n,void 0,{reason:e},void 0);var t=arguments[1],i=function(){throw t};return this.caught(e,i)},e.prototype.catchReturn=function(n){if(arguments.length<=1)return n instanceof e&&n.suppressUnhandledRejections(),this._then(void 0,t,void 0,{value:n},void 0);var i=arguments[1];i instanceof e&&i.suppressUnhandledRejections();var r=function(){return i};return this.caught(n,r)}}},{}],9:[function(e,t,n){"use strict";function i(e,t){function n(i){return this instanceof n?(d(this,"message","string"==typeof i?i:t),d(this,"name",e),void(Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):Error.call(this))):new n(i)}return u(n,Error),n}function r(e){return this instanceof r?(d(this,"name","OperationalError"),d(this,"message",e),this.cause=e,this.isOperational=!0,void(e instanceof Error?(d(this,"message",e.message),d(this,"stack",e.stack)):Error.captureStackTrace&&Error.captureStackTrace(this,this.constructor))):new r(e)}var o,s,a=e("./es5"),l=a.freeze,c=e("./util"),u=c.inherits,d=c.notEnumerableProp,p=i("Warning","warning"),h=i("CancellationError","cancellation error"),m=i("TimeoutError","timeout error"),f=i("AggregateError","aggregate error");try{o=TypeError,s=RangeError}catch(e){o=i("TypeError","type error"),s=i("RangeError","range error")}for(var g="join pop push shift unshift slice filter forEach some every map indexOf lastIndexOf reduce reduceRight sort reverse".split(" "),b=0;b<g.length;++b)"function"==typeof Array.prototype[g[b]]&&(f.prototype[g[b]]=Array.prototype[g[b]]);a.defineProperty(f.prototype,"length",{value:0,configurable:!1,writable:!0,enumerable:!0}),f.prototype.isOperational=!0;var v=0;f.prototype.toString=function(){var e=Array(4*v+1).join(" "),t="\n"+e+"AggregateError of:\n";v++,e=Array(4*v+1).join(" ");for(var n=0;n<this.length;++n){for(var i=this[n]===this?"[Circular AggregateError]":this[n]+"",r=i.split("\n"),o=0;o<r.length;++o)r[o]=e+r[o];i=r.join("\n"),t+=i+"\n"}return v--,t},u(r,Error);var y=Error.__BluebirdErrorTypes__;y||(y=l({CancellationError:h,TimeoutError:m,OperationalError:r,RejectionError:r,AggregateError:f}),a.defineProperty(Error,"__BluebirdErrorTypes__",{value:y,writable:!1,enumerable:!1,configurable:!1})),t.exports={Error:Error,TypeError:o,RangeError:s,CancellationError:y.CancellationError,OperationalError:y.OperationalError,TimeoutError:y.TimeoutError,AggregateError:y.AggregateError,Warning:p}},{"./es5":10,"./util":21}],10:[function(e,t,n){var i=function(){"use strict";return void 0===this}();if(i)t.exports={freeze:Object.freeze,defineProperty:Object.defineProperty,getDescriptor:Object.getOwnPropertyDescriptor,keys:Object.keys,names:Object.getOwnPropertyNames,getPrototypeOf:Object.getPrototypeOf,isArray:Array.isArray,isES5:i,propertyIsWritable:function(e,t){var n=Object.getOwnPropertyDescriptor(e,t);return!(n&&!n.writable&&!n.set)}};else{var r={}.hasOwnProperty,o={}.toString,s={}.constructor.prototype,a=function(e){var t=[];for(var n in e)r.call(e,n)&&t.push(n);return t},l=function(e,t){return{value:e[t]}},c=function(e,t,n){return e[t]=n.value,e},u=function(e){return e},d=function(e){try{return Object(e).constructor.prototype}catch(e){return s}},p=function(e){try{return"[object Array]"===o.call(e)}catch(e){return!1}};t.exports={isArray:p,keys:a,names:a,defineProperty:c,getDescriptor:l,freeze:u,getPrototypeOf:d,isES5:i,propertyIsWritable:function(){return!0}}}},{}],11:[function(e,t,n){"use strict";t.exports=function(t,n,i){function r(e,t,n){this.promise=e,this.type=t,this.handler=n,this.called=!1,this.cancelPromise=null}function o(e){this.finallyHandler=e}function s(e,t){return null!=e.cancelPromise&&(arguments.length>1?e.cancelPromise._reject(t):e.cancelPromise._cancel(),e.cancelPromise=null,!0)}function a(){return c.call(this,this.promise._target()._settledValue())}function l(e){if(!s(this,e))return p.e=e,p}function c(e){var r=this.promise,c=this.handler;if(!this.called){this.called=!0;var u=this.isFinallyHandler()?c.call(r._boundValue()):c.call(r._boundValue(),e);if(u===i)return u;if(void 0!==u){r._setReturnedNonUndefined();var h=n(u,r);if(h instanceof t){if(null!=this.cancelPromise){if(h._isCancelled()){var m=new d("late cancellation observer");return r._attachExtraTrace(m),p.e=m,p}h.isPending()&&h._attachCancellationCallback(new o(this))}return h._then(a,l,void 0,this,void 0)}}}return r.isRejected()?(s(this),p.e=e,p):(s(this),e)}var u=e("./util"),d=t.CancellationError,p=u.errorObj,h=e("./catch_filter")(i);return r.prototype.isFinallyHandler=function(){return 0===this.type},o.prototype._resultCancelled=function(){s(this.finallyHandler)},t.prototype._passThrough=function(e,t,n,i){return"function"!=typeof e?this.then():this._then(n,i,void 0,new r(this,t,e),void 0)},t.prototype.lastly=t.prototype.finally=function(e){return this._passThrough(e,0,c,c)},t.prototype.tap=function(e){return this._passThrough(e,1,c)},t.prototype.tapCatch=function(e){var n=arguments.length;if(1===n)return this._passThrough(e,1,void 0,c);var i,r=new Array(n-1),o=0;for(i=0;i<n-1;++i){
var s=arguments[i];if(!u.isObject(s))return t.reject(new TypeError("tapCatch statement predicate: expecting an object but got "+u.classString(s)));r[o++]=s}r.length=o;var a=arguments[i];return this._passThrough(h(r,a,this),1,void 0,c)},r}},{"./catch_filter":5,"./util":21}],12:[function(e,t,n){"use strict";t.exports=function(t,n,i,r,o,s){var a=e("./util");a.canEvaluate,a.tryCatch,a.errorObj;t.join=function(){var e,t=arguments.length-1;if(t>0&&"function"==typeof arguments[t]){e=arguments[t];var i}var r=[].slice.call(arguments);e&&r.pop();var i=new n(r).promise();return void 0!==e?i.spread(e):i}}},{"./util":21}],13:[function(e,t,n){"use strict";t.exports=function(t,n,i,r,o){var s=e("./util"),a=s.tryCatch;t.method=function(e){if("function"!=typeof e)throw new t.TypeError("expecting a function but got "+s.classString(e));return function(){var i=new t(n);i._captureStackTrace(),i._pushContext();var r=a(e).apply(this,arguments),s=i._popContext();return o.checkForgottenReturns(r,s,"Promise.method",i),i._resolveFromSyncValue(r),i}},t.attempt=t.try=function(e){if("function"!=typeof e)return r("expecting a function but got "+s.classString(e));var i=new t(n);i._captureStackTrace(),i._pushContext();var l;if(arguments.length>1){o.deprecated("calling Promise.try with more than 1 argument");var c=arguments[1],u=arguments[2];l=s.isArray(c)?a(e).apply(u,c):a(e).call(u,c)}else l=a(e)();var d=i._popContext();return o.checkForgottenReturns(l,d,"Promise.try",i),i._resolveFromSyncValue(l),i},t.prototype._resolveFromSyncValue=function(e){e===s.errorObj?this._rejectCallback(e.e,!1):this._resolveCallback(e,!0)}}},{"./util":21}],14:[function(e,t,n){"use strict";function i(e){return e instanceof Error&&u.getPrototypeOf(e)===Error.prototype}function r(e){var t;if(i(e)){t=new c(e),t.name=e.name,t.message=e.message,t.stack=e.stack;for(var n=u.keys(e),r=0;r<n.length;++r){var o=n[r];d.test(o)||(t[o]=e[o])}return t}return s.markAsOriginatingFromRejection(e),e}function o(e,t){return function(n,i){if(null!==e){if(n){var o=r(a(n));e._attachExtraTrace(o),e._reject(o)}else if(t){var s=[].slice.call(arguments,1);e._fulfill(s)}else e._fulfill(i);e=null}}}var s=e("./util"),a=s.maybeWrapAsError,l=e("./errors"),c=l.OperationalError,u=e("./es5"),d=/^(?:name|message|stack|cause)$/;t.exports=o},{"./errors":9,"./es5":10,"./util":21}],15:[function(e,n,i){"use strict";n.exports=function(){function i(){}function r(e,t){if(null==e||e.constructor!==o)throw new y("the promise constructor cannot be invoked directly\n\n    See http://goo.gl/MqrFmX\n");if("function"!=typeof t)throw new y("expecting a function but got "+m.classString(t))}function o(e){e!==w&&r(this,e),this._bitField=0,this._fulfillmentHandler0=void 0,this._rejectionHandler0=void 0,this._promise0=void 0,this._receiver0=void 0,this._resolveFromExecutor(e),this._promiseCreated(),this._fireEvent("promiseCreated",this)}function s(e){this.promise._resolveCallback(e)}function a(e){this.promise._rejectCallback(e,!1)}function l(e){var t=new o(w);t._fulfillmentHandler0=e,t._rejectionHandler0=e,t._promise0=e,t._receiver0=e}var c,u=function(){return new y("circular promise resolution chain\n\n    See http://goo.gl/MqrFmX\n")},d=function(){return new o.PromiseInspection(this._target())},p=function(e){return o.reject(new y(e))},h={},m=e("./util");c=m.isNode?function(){var e=t.domain;return void 0===e&&(e=null),e}:function(){return null},m.notEnumerableProp(o,"_getDomain",c);var f=e("./es5"),g=e("./async"),b=new g;f.defineProperty(o,"_async",{value:b});var v=e("./errors"),y=o.TypeError=v.TypeError;o.RangeError=v.RangeError;var S=o.CancellationError=v.CancellationError;o.TimeoutError=v.TimeoutError,o.OperationalError=v.OperationalError,o.RejectionError=v.OperationalError,o.AggregateError=v.AggregateError;var w=function(){},E={},C={},T=e("./thenables")(o,w),x=e("./promise_array")(o,w,T,p,i),_=e("./context")(o),k=(_.create,e("./debuggability")(o,_)),M=(k.CapturedTrace,e("./finally")(o,T,C)),A=e("./catch_filter")(C),P=e("./nodeback"),O=m.errorObj,I=m.tryCatch;return o.prototype.toString=function(){return"[object Promise]"},o.prototype.caught=o.prototype.catch=function(e){var t=arguments.length;if(t>1){var n,i=new Array(t-1),r=0;for(n=0;n<t-1;++n){var o=arguments[n];if(!m.isObject(o))return p("Catch statement predicate: expecting an object but got "+m.classString(o));i[r++]=o}return i.length=r,e=arguments[n],this.then(void 0,A(i,e,this))}return this.then(void 0,e)},o.prototype.reflect=function(){return this._then(d,d,void 0,this,void 0)},o.prototype.then=function(e,t){if(k.warnings()&&arguments.length>0&&"function"!=typeof e&&"function"!=typeof t){var n=".then() only accepts functions but was passed: "+m.classString(e);arguments.length>1&&(n+=", "+m.classString(t)),this._warn(n)}return this._then(e,t,void 0,void 0,void 0)},o.prototype.done=function(e,t){var n=this._then(e,t,void 0,void 0,void 0);n._setIsFinal()},o.prototype.spread=function(e){return"function"!=typeof e?p("expecting a function but got "+m.classString(e)):this.all()._then(e,void 0,void 0,E,void 0)},o.prototype.toJSON=function(){var e={isFulfilled:!1,isRejected:!1,fulfillmentValue:void 0,rejectionReason:void 0};return this.isFulfilled()?(e.fulfillmentValue=this.value(),e.isFulfilled=!0):this.isRejected()&&(e.rejectionReason=this.reason(),e.isRejected=!0),e},o.prototype.all=function(){return arguments.length>0&&this._warn(".all() was passed arguments but it does not take any"),new x(this).promise()},o.prototype.error=function(e){return this.caught(m.originatesFromRejection,e)},o.getNewLibraryCopy=n.exports,o.is=function(e){return e instanceof o},o.fromNode=o.fromCallback=function(e){var t=new o(w);t._captureStackTrace();var n=arguments.length>1&&!!Object(arguments[1]).multiArgs,i=I(e)(P(t,n));return i===O&&t._rejectCallback(i.e,!0),t._isFateSealed()||t._setAsyncGuaranteed(),t},o.all=function(e){return new x(e).promise()},o.cast=function(e){var t=T(e);return t instanceof o||(t=new o(w),t._captureStackTrace(),t._setFulfilled(),t._rejectionHandler0=e),t},o.resolve=o.fulfilled=o.cast,o.reject=o.rejected=function(e){var t=new o(w);return t._captureStackTrace(),t._rejectCallback(e,!0),t},o.setScheduler=function(e){if("function"!=typeof e)throw new y("expecting a function but got "+m.classString(e));return b.setScheduler(e)},o.prototype._then=function(e,t,n,i,r){var s=void 0!==r,a=s?r:new o(w),l=this._target(),u=l._bitField;s||(a._propagateFrom(this,3),a._captureStackTrace(),void 0===i&&0!==(2097152&this._bitField)&&(i=0!==(50397184&u)?this._boundValue():l===this?void 0:this._boundTo),this._fireEvent("promiseChained",this,a));var d=c();if(0!==(50397184&u)){var p,h,f=l._settlePromiseCtx;0!==(33554432&u)?(h=l._rejectionHandler0,p=e):0!==(16777216&u)?(h=l._fulfillmentHandler0,p=t,l._unsetRejectionIsUnhandled()):(f=l._settlePromiseLateCancellationObserver,h=new S("late cancellation observer"),l._attachExtraTrace(h),p=t),b.invoke(f,l,{handler:null===d?p:"function"==typeof p&&m.domainBind(d,p),promise:a,receiver:i,value:h})}else l._addCallbacks(e,t,a,i,d);return a},o.prototype._length=function(){return 65535&this._bitField},o.prototype._isFateSealed=function(){return 0!==(117506048&this._bitField)},o.prototype._isFollowing=function(){return 67108864===(67108864&this._bitField)},o.prototype._setLength=function(e){this._bitField=this._bitField&-65536|65535&e},o.prototype._setFulfilled=function(){this._bitField=33554432|this._bitField,this._fireEvent("promiseFulfilled",this)},o.prototype._setRejected=function(){this._bitField=16777216|this._bitField,this._fireEvent("promiseRejected",this)},o.prototype._setFollowing=function(){this._bitField=67108864|this._bitField,this._fireEvent("promiseResolved",this)},o.prototype._setIsFinal=function(){this._bitField=4194304|this._bitField},o.prototype._isFinal=function(){return(4194304&this._bitField)>0},o.prototype._unsetCancelled=function(){this._bitField=this._bitField&-65537},o.prototype._setCancelled=function(){this._bitField=65536|this._bitField,this._fireEvent("promiseCancelled",this)},o.prototype._setWillBeCancelled=function(){this._bitField=8388608|this._bitField},o.prototype._setAsyncGuaranteed=function(){b.hasCustomScheduler()||(this._bitField=134217728|this._bitField)},o.prototype._receiverAt=function(e){var t=0===e?this._receiver0:this[4*e-4+3];if(t!==h)return void 0===t&&this._isBound()?this._boundValue():t},o.prototype._promiseAt=function(e){return this[4*e-4+2]},o.prototype._fulfillmentHandlerAt=function(e){return this[4*e-4+0]},o.prototype._rejectionHandlerAt=function(e){return this[4*e-4+1]},o.prototype._boundValue=function(){},o.prototype._migrateCallback0=function(e){var t=(e._bitField,e._fulfillmentHandler0),n=e._rejectionHandler0,i=e._promise0,r=e._receiverAt(0);void 0===r&&(r=h),this._addCallbacks(t,n,i,r,null)},o.prototype._migrateCallbackAt=function(e,t){var n=e._fulfillmentHandlerAt(t),i=e._rejectionHandlerAt(t),r=e._promiseAt(t),o=e._receiverAt(t);void 0===o&&(o=h),this._addCallbacks(n,i,r,o,null)},o.prototype._addCallbacks=function(e,t,n,i,r){var o=this._length();if(o>=65531&&(o=0,this._setLength(0)),0===o)this._promise0=n,this._receiver0=i,"function"==typeof e&&(this._fulfillmentHandler0=null===r?e:m.domainBind(r,e)),"function"==typeof t&&(this._rejectionHandler0=null===r?t:m.domainBind(r,t));else{var s=4*o-4;this[s+2]=n,this[s+3]=i,"function"==typeof e&&(this[s+0]=null===r?e:m.domainBind(r,e)),"function"==typeof t&&(this[s+1]=null===r?t:m.domainBind(r,t))}return this._setLength(o+1),o},o.prototype._proxy=function(e,t){this._addCallbacks(void 0,void 0,t,e,null)},o.prototype._resolveCallback=function(e,t){if(0===(117506048&this._bitField)){if(e===this)return this._rejectCallback(u(),!1);var n=T(e,this);if(!(n instanceof o))return this._fulfill(e);t&&this._propagateFrom(n,2);var i=n._target();if(i===this)return void this._reject(u());var r=i._bitField;if(0===(50397184&r)){var s=this._length();s>0&&i._migrateCallback0(this);for(var a=1;a<s;++a)i._migrateCallbackAt(this,a);this._setFollowing(),this._setLength(0),this._setFollowee(i)}else if(0!==(33554432&r))this._fulfill(i._value());else if(0!==(16777216&r))this._reject(i._reason());else{var l=new S("late cancellation observer");i._attachExtraTrace(l),this._reject(l)}}},o.prototype._rejectCallback=function(e,t,n){var i=m.ensureErrorObject(e),r=i===e;if(!r&&!n&&k.warnings()){var o="a promise was rejected with a non-error: "+m.classString(e);this._warn(o,!0)}this._attachExtraTrace(i,!!t&&r),this._reject(e)},o.prototype._resolveFromExecutor=function(e){if(e!==w){var t=this;this._captureStackTrace(),this._pushContext();var n=!0,i=this._execute(e,function(e){t._resolveCallback(e)},function(e){t._rejectCallback(e,n)});n=!1,this._popContext(),void 0!==i&&t._rejectCallback(i,!0)}},o.prototype._settlePromiseFromHandler=function(e,t,n,i){var r=i._bitField;if(0===(65536&r)){i._pushContext();var o;t===E?n&&"number"==typeof n.length?o=I(e).apply(this._boundValue(),n):(o=O,o.e=new y("cannot .spread() a non-array: "+m.classString(n))):o=I(e).call(t,n);var s=i._popContext();r=i._bitField,0===(65536&r)&&(o===C?i._reject(n):o===O?i._rejectCallback(o.e,!1):(k.checkForgottenReturns(o,s,"",i,this),i._resolveCallback(o)))}},o.prototype._target=function(){for(var e=this;e._isFollowing();)e=e._followee();return e},o.prototype._followee=function(){return this._rejectionHandler0},o.prototype._setFollowee=function(e){this._rejectionHandler0=e},o.prototype._settlePromise=function(e,t,n,r){var s=e instanceof o,a=this._bitField,l=0!==(134217728&a);0!==(65536&a)?(s&&e._invokeInternalOnCancel(),n instanceof M&&n.isFinallyHandler()?(n.cancelPromise=e,I(t).call(n,r)===O&&e._reject(O.e)):t===d?e._fulfill(d.call(n)):n instanceof i?n._promiseCancelled(e):s||e instanceof x?e._cancel():n.cancel()):"function"==typeof t?s?(l&&e._setAsyncGuaranteed(),this._settlePromiseFromHandler(t,n,r,e)):t.call(n,r,e):n instanceof i?n._isResolved()||(0!==(33554432&a)?n._promiseFulfilled(r,e):n._promiseRejected(r,e)):s&&(l&&e._setAsyncGuaranteed(),0!==(33554432&a)?e._fulfill(r):e._reject(r))},o.prototype._settlePromiseLateCancellationObserver=function(e){var t=e.handler,n=e.promise,i=e.receiver,r=e.value;"function"==typeof t?n instanceof o?this._settlePromiseFromHandler(t,i,r,n):t.call(i,r,n):n instanceof o&&n._reject(r)},o.prototype._settlePromiseCtx=function(e){this._settlePromise(e.promise,e.handler,e.receiver,e.value)},o.prototype._settlePromise0=function(e,t,n){var i=this._promise0,r=this._receiverAt(0);this._promise0=void 0,this._receiver0=void 0,this._settlePromise(i,e,r,t)},o.prototype._clearCallbackDataAtIndex=function(e){var t=4*e-4;this[t+2]=this[t+3]=this[t+0]=this[t+1]=void 0},o.prototype._fulfill=function(e){var t=this._bitField;if(!((117506048&t)>>>16)){if(e===this){var n=u();return this._attachExtraTrace(n),this._reject(n)}this._setFulfilled(),this._rejectionHandler0=e,(65535&t)>0&&(0!==(134217728&t)?this._settlePromises():b.settlePromises(this))}},o.prototype._reject=function(e){var t=this._bitField;if(!((117506048&t)>>>16))return this._setRejected(),this._fulfillmentHandler0=e,this._isFinal()?b.fatalError(e,m.isNode):void((65535&t)>0?b.settlePromises(this):this._ensurePossibleRejectionHandled())},o.prototype._fulfillPromises=function(e,t){for(var n=1;n<e;n++){var i=this._fulfillmentHandlerAt(n),r=this._promiseAt(n),o=this._receiverAt(n);this._clearCallbackDataAtIndex(n),this._settlePromise(r,i,o,t)}},o.prototype._rejectPromises=function(e,t){for(var n=1;n<e;n++){var i=this._rejectionHandlerAt(n),r=this._promiseAt(n),o=this._receiverAt(n);this._clearCallbackDataAtIndex(n),this._settlePromise(r,i,o,t)}},o.prototype._settlePromises=function(){var e=this._bitField,t=65535&e;if(t>0){if(0!==(16842752&e)){var n=this._fulfillmentHandler0;this._settlePromise0(this._rejectionHandler0,n,e),this._rejectPromises(t,n)}else{var i=this._rejectionHandler0;this._settlePromise0(this._fulfillmentHandler0,i,e),this._fulfillPromises(t,i)}this._setLength(0)}this._clearCancellationData()},o.prototype._settledValue=function(){var e=this._bitField;return 0!==(33554432&e)?this._rejectionHandler0:0!==(16777216&e)?this._fulfillmentHandler0:void 0},o.defer=o.pending=function(){k.deprecated("Promise.defer","new Promise");var e=new o(w);return{promise:e,resolve:s,reject:a}},m.notEnumerableProp(o,"_makeSelfResolutionError",u),e("./method")(o,w,T,p,k),e("./bind")(o,w,T,k),e("./cancel")(o,x,p,k),e("./direct_resolve")(o),e("./synchronous_inspection")(o),e("./join")(o,x,T,w,b,c),o.Promise=o,o.version="3.5.1",m.toFastProperties(o),m.toFastProperties(o.prototype),l({a:1}),l({b:2}),l({c:3}),l(1),l(function(){}),l(void 0),l(!1),l(new o(w)),k.setBounds(g.firstLineError,m.lastLineError),o}},{"./async":1,"./bind":2,"./cancel":4,"./catch_filter":5,"./context":6,"./debuggability":7,"./direct_resolve":8,"./errors":9,"./es5":10,"./finally":11,"./join":12,"./method":13,"./nodeback":14,"./promise_array":16,"./synchronous_inspection":19,"./thenables":20,"./util":21}],16:[function(e,t,n){"use strict";t.exports=function(t,n,i,r,o){function s(e){switch(e){case-2:return[];case-3:return{};case-6:return new Map}}function a(e){var i=this._promise=new t(n);e instanceof t&&i._propagateFrom(e,3),i._setOnCancel(this),this._values=e,this._length=0,this._totalResolved=0,this._init(void 0,-2)}var l=e("./util");l.isArray;return l.inherits(a,o),a.prototype.length=function(){return this._length},a.prototype.promise=function(){return this._promise},a.prototype._init=function e(n,o){var a=i(this._values,this._promise);if(a instanceof t){a=a._target();var c=a._bitField;if(this._values=a,0===(50397184&c))return this._promise._setAsyncGuaranteed(),a._then(e,this._reject,void 0,this,o);if(0===(33554432&c))return 0!==(16777216&c)?this._reject(a._reason()):this._cancel();a=a._value()}if(a=l.asArray(a),null===a){var u=r("expecting an array or an iterable object but got "+l.classString(a)).reason();return void this._promise._rejectCallback(u,!1)}return 0===a.length?void(o===-5?this._resolveEmptyArray():this._resolve(s(o))):void this._iterate(a)},a.prototype._iterate=function(e){var n=this.getActualLength(e.length);this._length=n,this._values=this.shouldCopyValues()?new Array(n):this._values;for(var r=this._promise,o=!1,s=null,a=0;a<n;++a){var l=i(e[a],r);l instanceof t?(l=l._target(),s=l._bitField):s=null,o?null!==s&&l.suppressUnhandledRejections():null!==s?0===(50397184&s)?(l._proxy(this,a),this._values[a]=l):o=0!==(33554432&s)?this._promiseFulfilled(l._value(),a):0!==(16777216&s)?this._promiseRejected(l._reason(),a):this._promiseCancelled(a):o=this._promiseFulfilled(l,a)}o||r._setAsyncGuaranteed()},a.prototype._isResolved=function(){return null===this._values},a.prototype._resolve=function(e){this._values=null,this._promise._fulfill(e)},a.prototype._cancel=function(){!this._isResolved()&&this._promise._isCancellable()&&(this._values=null,this._promise._cancel())},a.prototype._reject=function(e){this._values=null,this._promise._rejectCallback(e,!1)},a.prototype._promiseFulfilled=function(e,t){this._values[t]=e;var n=++this._totalResolved;return n>=this._length&&(this._resolve(this._values),!0)},a.prototype._promiseCancelled=function(){return this._cancel(),!0},a.prototype._promiseRejected=function(e){return this._totalResolved++,this._reject(e),!0},a.prototype._resultCancelled=function(){if(!this._isResolved()){var e=this._values;if(this._cancel(),e instanceof t)e.cancel();else for(var n=0;n<e.length;++n)e[n]instanceof t&&e[n].cancel()}},a.prototype.shouldCopyValues=function(){return!0},a.prototype.getActualLength=function(e){return e},a}},{"./util":21}],17:[function(e,t,n){"use strict";function i(e,t,n,i,r){for(var o=0;o<r;++o)n[o+i]=e[o+t],e[o+t]=void 0}function r(e){this._capacity=e,this._length=0,this._front=0}r.prototype._willBeOverCapacity=function(e){return this._capacity<e},r.prototype._pushOne=function(e){var t=this.length();this._checkCapacity(t+1);var n=this._front+t&this._capacity-1;this[n]=e,this._length=t+1},r.prototype.push=function(e,t,n){var i=this.length()+3;if(this._willBeOverCapacity(i))return this._pushOne(e),this._pushOne(t),void this._pushOne(n);var r=this._front+i-3;this._checkCapacity(i);var o=this._capacity-1;this[r+0&o]=e,this[r+1&o]=t,this[r+2&o]=n,this._length=i},r.prototype.shift=function(){var e=this._front,t=this[e];return this[e]=void 0,this._front=e+1&this._capacity-1,this._length--,t},r.prototype.length=function(){return this._length},r.prototype._checkCapacity=function(e){this._capacity<e&&this._resizeTo(this._capacity<<1)},r.prototype._resizeTo=function(e){var t=this._capacity;this._capacity=e;var n=this._front,r=this._length,o=n+r&t-1;i(this,0,this,t,o)},t.exports=r},{}],18:[function(e,r,o){"use strict";var s,a=e("./util"),l=function(){throw new Error("No async scheduler available\n\n    See http://goo.gl/MqrFmX\n")},c=a.getNativePromise();if(a.isNode&&"undefined"==typeof MutationObserver){var u=n.setImmediate,d=t.nextTick;s=a.isRecentNode?function(e){u.call(n,e)}:function(e){d.call(t,e)}}else if("function"==typeof c&&"function"==typeof c.resolve){var p=c.resolve();s=function(e){p.then(e)}}else s="undefined"==typeof MutationObserver||"undefined"!=typeof window&&window.navigator&&(window.navigator.standalone||window.cordova)?"undefined"!=typeof i?function(e){i(e)}:"undefined"!=typeof setTimeout?function(e){setTimeout(e,0)}:l:function(){var e=document.createElement("div"),t={attributes:!0},n=!1,i=document.createElement("div"),r=new MutationObserver(function(){e.classList.toggle("foo"),n=!1});r.observe(i,t);var o=function(){n||(n=!0,i.classList.toggle("foo"))};return function(n){var i=new MutationObserver(function(){i.disconnect(),n()});i.observe(e,t),o()}}();r.exports=s},{"./util":21}],19:[function(e,t,n){"use strict";t.exports=function(e){function t(e){void 0!==e?(e=e._target(),this._bitField=e._bitField,this._settledValueField=e._isFateSealed()?e._settledValue():void 0):(this._bitField=0,this._settledValueField=void 0)}t.prototype._settledValue=function(){return this._settledValueField};var n=t.prototype.value=function(){if(!this.isFulfilled())throw new TypeError("cannot get fulfillment value of a non-fulfilled promise\n\n    See http://goo.gl/MqrFmX\n");return this._settledValue()},i=t.prototype.error=t.prototype.reason=function(){if(!this.isRejected())throw new TypeError("cannot get rejection reason of a non-rejected promise\n\n    See http://goo.gl/MqrFmX\n");return this._settledValue()},r=t.prototype.isFulfilled=function(){return 0!==(33554432&this._bitField)},o=t.prototype.isRejected=function(){return 0!==(16777216&this._bitField)},s=t.prototype.isPending=function(){return 0===(50397184&this._bitField)},a=t.prototype.isResolved=function(){return 0!==(50331648&this._bitField)};t.prototype.isCancelled=function(){return 0!==(8454144&this._bitField)},e.prototype.__isCancelled=function(){return 65536===(65536&this._bitField)},e.prototype._isCancelled=function(){return this._target().__isCancelled()},e.prototype.isCancelled=function(){return 0!==(8454144&this._target()._bitField)},e.prototype.isPending=function(){return s.call(this._target())},e.prototype.isRejected=function(){return o.call(this._target())},e.prototype.isFulfilled=function(){return r.call(this._target())},e.prototype.isResolved=function(){return a.call(this._target())},e.prototype.value=function(){return n.call(this._target())},e.prototype.reason=function(){var e=this._target();return e._unsetRejectionIsUnhandled(),i.call(e)},e.prototype._value=function(){return this._settledValue()},e.prototype._reason=function(){return this._unsetRejectionIsUnhandled(),this._settledValue()},e.PromiseInspection=t}},{}],20:[function(e,t,n){"use strict";t.exports=function(t,n){function i(e,i){if(u(e)){if(e instanceof t)return e;var r=o(e);if(r===c){i&&i._pushContext();var l=t.reject(r.e);return i&&i._popContext(),l}if("function"==typeof r){if(s(e)){var l=new t(n);return e._then(l._fulfill,l._reject,void 0,l,null),l}return a(e,r,i)}}return e}function r(e){return e.then}function o(e){try{return r(e)}catch(e){return c.e=e,c}}function s(e){try{return d.call(e,"_promise0")}catch(e){return!1}}function a(e,i,r){function o(e){a&&(a._resolveCallback(e),a=null)}function s(e){a&&(a._rejectCallback(e,d,!0),a=null)}var a=new t(n),u=a;r&&r._pushContext(),a._captureStackTrace(),r&&r._popContext();var d=!0,p=l.tryCatch(i).call(e,o,s);return d=!1,a&&p===c&&(a._rejectCallback(p.e,!0,!0),a=null),u}var l=e("./util"),c=l.errorObj,u=l.isObject,d={}.hasOwnProperty;return i}},{"./util":21}],21:[function(e,i,r){"use strict";function o(){try{var e=O;return O=null,e.apply(this,arguments)}catch(e){return P.e=e,P}}function s(e){return O=e,o}function a(e){return null==e||e===!0||e===!1||"string"==typeof e||"number"==typeof e}function l(e){return"function"==typeof e||"object"==typeof e&&null!==e}function c(e){return a(e)?new Error(v(e)):e}function u(e,t){var n,i=e.length,r=new Array(i+1);for(n=0;n<i;++n)r[n]=e[n];return r[n]=t,r}function d(e,t,n){if(!M.isES5)return{}.hasOwnProperty.call(e,t)?e[t]:void 0;var i=Object.getOwnPropertyDescriptor(e,t);return null!=i?null==i.get&&null==i.set?i.value:n:void 0}function p(e,t,n){if(a(e))return e;var i={value:n,configurable:!0,enumerable:!1,writable:!0};return M.defineProperty(e,t,i),e}function h(e){throw e}function m(e){try{if("function"==typeof e){var t=M.names(e.prototype),n=M.isES5&&t.length>1,i=t.length>0&&!(1===t.length&&"constructor"===t[0]),r=N.test(e+"")&&M.names(e).length>0;if(n||i||r)return!0}return!1}catch(e){return!1}}function f(e){function t(){}t.prototype=e;for(var n=8;n--;)new t;return e}function g(e){return L.test(e)}function b(e,t,n){for(var i=new Array(e),r=0;r<e;++r)i[r]=t+r+n;return i}function v(e){try{return e+""}catch(e){return"[no string representation]"}}function y(e){return e instanceof Error||null!==e&&"object"==typeof e&&"string"==typeof e.message&&"string"==typeof e.name}function S(e){try{p(e,"isOperational",!0)}catch(e){}}function w(e){return null!=e&&(e instanceof Error.__BluebirdErrorTypes__.OperationalError||e.isOperational===!0)}function E(e){return y(e)&&M.propertyIsWritable(e,"stack")}function C(e){return{}.toString.call(e)}function T(e,t,n){for(var i=M.names(e),r=0;r<i.length;++r){var o=i[r];if(n(o))try{M.defineProperty(t,o,M.getDescriptor(e,o))}catch(e){}}}function x(e){return H?{NODE_ENV:"production"}[e]:void 0}function _(){if("function"==typeof Promise)try{var e=new Promise(function(){});if("[object Promise]"==={}.toString.call(e))return Promise}catch(e){}}function k(e,t){return e.bind(t)}var M=e("./es5"),A="undefined"==typeof navigator,P={e:{}},O,I="undefined"!=typeof self?self:"undefined"!=typeof window?window:"undefined"!=typeof n?n:void 0!==this?this:null,R=function(e,t){function n(){this.constructor=e,this.constructor$=t;for(var n in t.prototype)i.call(t.prototype,n)&&"$"!==n.charAt(n.length-1)&&(this[n+"$"]=t.prototype[n])}var i={}.hasOwnProperty;return n.prototype=t.prototype,e.prototype=new n,e.prototype},D=function(){var e=[Array.prototype,Object.prototype,Function.prototype],t=function(t){for(var n=0;n<e.length;++n)if(e[n]===t)return!0;return!1};if(M.isES5){var n=Object.getOwnPropertyNames;return function(e){for(var i=[],r=Object.create(null);null!=e&&!t(e);){var o;try{o=n(e)}catch(e){return i}for(var s=0;s<o.length;++s){var a=o[s];if(!r[a]){r[a]=!0;var l=Object.getOwnPropertyDescriptor(e,a);null!=l&&null==l.get&&null==l.set&&i.push(a)}}e=M.getPrototypeOf(e)}return i}}var i={}.hasOwnProperty;return function(n){if(t(n))return[];var r=[];e:for(var o in n)if(i.call(n,o))r.push(o);else{for(var s=0;s<e.length;++s)if(i.call(e[s],o))continue e;r.push(o)}return r}}(),N=/this\s*\.\s*\S+\s*=/,L=/^[a-z$_][a-z$_0-9]*$/i,B=function(){return"stack"in new Error?function(e){return E(e)?e:new Error(v(e))}:function(e){if(E(e))return e;try{throw new Error(v(e))}catch(e){return e}}}(),G=function(e){return M.isArray(e)?e:null};if("undefined"!=typeof Symbol&&Symbol.iterator){var U="function"==typeof Array.from?function(e){return Array.from(e)}:function(e){for(var t,n=[],i=e[Symbol.iterator]();!(t=i.next()).done;)n.push(t.value);return n};G=function(e){return M.isArray(e)?e:null!=e&&"function"==typeof e[Symbol.iterator]?U(e):null}}var q="undefined"!=typeof t&&"[object process]"===C(t).toLowerCase(),H="undefined"!=typeof t&&!0,F={isClass:m,isIdentifier:g,inheritedDataKeys:D,getDataPropertyOrDefault:d,thrower:h,isArray:M.isArray,asArray:G,notEnumerableProp:p,isPrimitive:a,isObject:l,isError:y,canEvaluate:A,errorObj:P,tryCatch:s,inherits:R,withAppended:u,maybeWrapAsError:c,toFastProperties:f,filledRange:b,toString:v,canAttachTrace:E,ensureErrorObject:B,originatesFromRejection:w,markAsOriginatingFromRejection:S,classString:C,copyDescriptors:T,hasDevTools:"undefined"!=typeof chrome&&chrome&&"function"==typeof chrome.loadTimes,isNode:q,hasEnvVariables:H,env:x,global:I,getNativePromise:_,domainBind:k};F.isRecentNode=F.isNode&&function(){var e=t.versions.node.split(".").map(Number);return 0===e[0]&&e[1]>10||e[0]>0}(),F.isNode&&F.toFastProperties(t);try{throw new Error}catch(e){F.lastLineError=e}i.exports=F},{"./es5":10}]},{},[3])(3)}),"undefined"!=typeof window&&null!==window?window.P=window.Promise:"undefined"!=typeof self&&null!==self&&(self.P=self.Promise)}).call(t,n(140),function(){return this}(),n(253).setImmediate)},function(e,t,n){function i(e,t){this._id=e,this._clearFn=t}var r=Function.prototype.apply;t.setTimeout=function(){return new i(r.call(setTimeout,window,arguments),clearTimeout)},t.setInterval=function(){return new i(r.call(setInterval,window,arguments),clearInterval)},t.clearTimeout=t.clearInterval=function(e){e&&e.close()},i.prototype.unref=i.prototype.ref=function(){},i.prototype.close=function(){this._clearFn.call(window,this._id)},t.enroll=function(e,t){clearTimeout(e._idleTimeoutId),e._idleTimeout=t},t.unenroll=function(e){clearTimeout(e._idleTimeoutId),e._idleTimeout=-1},t._unrefActive=t.active=function(e){clearTimeout(e._idleTimeoutId);var t=e._idleTimeout;t>=0&&(e._idleTimeoutId=setTimeout(function(){e._onTimeout&&e._onTimeout()},t))},n(254),t.setImmediate=setImmediate,t.clearImmediate=clearImmediate},function(e,t,n){(function(e,t){!function(e,n){"use strict";function i(e){"function"!=typeof e&&(e=new Function(""+e));for(var t=new Array(arguments.length-1),n=0;n<t.length;n++)t[n]=arguments[n+1];var i={callback:e,args:t};return f[m]=i,h(m),m++}function r(e){delete f[e]}function o(e){var t=e.callback,i=e.args;switch(i.length){case 0:t();break;case 1:t(i[0]);break;case 2:t(i[0],i[1]);break;case 3:t(i[0],i[1],i[2]);break;default:t.apply(n,i)}}function s(e){if(g)setTimeout(s,0,e);else{var t=f[e];if(t){g=!0;try{o(t)}finally{r(e),g=!1}}}}function a(){h=function(e){t.nextTick(function(){s(e)})}}function l(){if(e.postMessage&&!e.importScripts){var t=!0,n=e.onmessage;return e.onmessage=function(){t=!1},e.postMessage("","*"),e.onmessage=n,t}}function c(){var t="setImmediate$"+Math.random()+"$",n=function(n){n.source===e&&"string"==typeof n.data&&0===n.data.indexOf(t)&&s(+n.data.slice(t.length))};e.addEventListener?e.addEventListener("message",n,!1):e.attachEvent("onmessage",n),h=function(n){e.postMessage(t+n,"*")}}function u(){var e=new MessageChannel;e.port1.onmessage=function(e){var t=e.data;s(t)},h=function(t){e.port2.postMessage(t)}}function d(){var e=b.documentElement;h=function(t){var n=b.createElement("script");n.onreadystatechange=function(){s(t),n.onreadystatechange=null,e.removeChild(n),n=null},e.appendChild(n)}}function p(){h=function(e){setTimeout(s,0,e)}}if(!e.setImmediate){var h,m=1,f={},g=!1,b=e.document,v=Object.getPrototypeOf&&Object.getPrototypeOf(e);v=v&&v.setTimeout?v:e,"[object process]"==={}.toString.call(e.process)?a():l()?c():e.MessageChannel?u():b&&"onreadystatechange"in b.createElement("script")?d():p(),v.setImmediate=i,v.clearImmediate=r}}("undefined"==typeof self?"undefined"==typeof e?this:e:self)}).call(t,function(){return this}(),n(140))},function(e,t,n){function i(e){return function(t){return this.config={api_key:void 0,method:e,params:void 0,timeout:3e5,url:t,headers:{Authorization:"","Content-type":"application/json"}},this}.bind(this)}function r(e){var t=e.split("/queries/");return t[t.length-1]}var o=n(251),s=n(247),a=n(248),l=n(256);e.exports={get:new i("GET"),post:new i("POST"),put:new i("PUT"),del:new i("DELETE")},i.prototype.auth=function(e){return"string"==typeof e&&(this.config.api_key="string"==typeof e?e:void 0,this.headers({Authorization:e})),this},i.prototype.headers=function(e){return"object"==typeof e&&s(e,function(e,t){this.config.headers[t]=e}.bind(this)),this},i.prototype.timeout=function(e){return this.config.timeout="number"==typeof e?e:3e5,this},i.prototype.send=function(e){var t,n;return this.config.params=e&&"object"==typeof e?e:{},t=l[this.config.method],n=a({},this.config),"undefined"==typeof n.params.analysis_type&&n.url.indexOf("/queries/")>-1&&n.url.indexOf("/saved/")<0&&(n.params.analysis_type=r(n.url)),new o(function(e,i,r){var o=t(n,function(t,r){var o=r;t?i(t):("undefined"!=typeof n.params.event_collection&&"undefined"==typeof r.query&&(o=a({query:n.params},r)),e(o))});return r(function(){o.abort&&o.abort()}),o})}},function(e,t,n){function i(e,t){return a()?l("GET",e,t):c()?u("GET",e,t):d(e,t)}function r(e,t){return a()?l("POST",e,t):c()?u("POST",e,t):void t("XHR POST not supported",null)}function o(e,t){return a()?l("PUT",e,t):void t("XHR PUT not supported",null)}function s(e,t){return a()?l("DELETE",e,t):void t("XHR DELETE not supported",null)}function a(){var e="undefined"==typeof window?this:window;if(e.XMLHttpRequest&&("file:"!=e.location.protocol||!e.ActiveXObject))return new XMLHttpRequest;try{return new ActiveXObject("Microsoft.XMLHTTP")}catch(e){}try{return new ActiveXObject("Msxml2.XMLHTTP.6.0")}catch(e){}try{return new ActiveXObject("Msxml2.XMLHTTP.3.0")}catch(e){}try{return new ActiveXObject("Msxml2.XMLHTTP")}catch(e){}return!1}function l(e,t,n){var i=a(),r=n,o=t.url;return n=null,i.onreadystatechange=function(){var e;if(4==i.readyState)if(i.status>=200&&i.status<300)if(204===i.status)r&&r(null,i);else try{e=JSON.parse(i.responseText),r&&e&&r(null,e);
}catch(e){r&&r(i,null)}else try{e=JSON.parse(i.responseText),r&&e&&r(e,null)}catch(e){r&&r(i,null)}},"GET"!==e?(i.open(e,o,!0),p(t.headers,function(e,t){"string"==typeof e&&i.setRequestHeader(t,e)}),t.params?i.send(JSON.stringify(t.params)):i.send()):(o+="?",t.api_key&&(o+="api_key="+t.api_key+"&"),t.params&&(o+=h(t.params)),i.open(e,o,!0),p(t.headers,function(e,t){"string"==typeof e&&i.setRequestHeader(t,e)}),i.send()),i}function c(){var e="undefined"==typeof window?this:window;return!!e.XDomainRequest&&new e.XDomainRequest}function u(e,t,n){function i(e,t){o&&"function"==typeof o&&(o(e,t),n=o=void 0)}var r=c(),o=n;return r&&(r.timeout=t.timeout||3e5,r.ontimeout=function(){i(r,null)},r.onerror=function(){i(r,null)},r.onload=function(){var e=JSON.parse(r.responseText);i(null,e)},r.open(e.toLowerCase(),t.url),setTimeout(function(){t.params?r.send(h(t.params)):r.send()},0)),r}function d(e,t){function n(e,n){c=!0,r&&"function"==typeof r&&(r(e,n),t=r=void 0),window[l]=void 0;try{delete window[l]}catch(e){}a.removeChild(s)}var i=e.url,r=t,o=(new Date).getTime(),s=document.createElement("script"),a=document.getElementsByTagName("head")[0],l="keenJSONPCallback",c=!1;for(l+=o;l in window;)l+="a";window[l]=function(e){c!==!0&&n(null,e)},e.params&&(i+=h(e.params)),s.onreadystatechange=function(){c===!1&&"loaded"===this.readyState&&n("An error occurred",null)},s.onerror=function(){c===!1&&n("An error occurred",null)},s.src=i+"&jsonp="+l,a.appendChild(s)}var p=n(247),h=n(250);e.exports={GET:i,POST:r,PUT:o,DELETE:s}},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(242),s=n(205),a=n(244),l=n(206),c=n(201),u=c.API_KEYS.KEEN_WRITE_KEY,d=c.API_KEYS.KEEN_READ_KEY,p=c.API_KEYS.KEEN_PROJECT_ID,h=n(245),m=(new h({projectId:p,writeKey:u,readKey:d}),function(e){function t(){e.call(this),this.overlayIsActive=!1,this.interstitialActive=!1,this.totalTimePassed=0,this.questionAnswered=!1,this.gamePaused=!1,this.showOverlayAfterInstiPoll=!1,this._questionStartTime=0,this._questionEndTime=0,this._questionPausedStartTime=0,this._questionPausedEndTime=0,this._enemyAnswered=!1,this._keenQueryTimeLimit=0,this.keen=null,this.state={correctAnswer:null,answers:[],answered:!1,answerSubmitted:!1,chosenOption:null,answerTime:null,enemyAnswered:!1,enemyChosenOption:null,enemyAnswerTime:null,counterActive:!0,timeRanOut:!1,questionCountDown:5,pollResults:null,resultsTotal:null,retrySubmitPoll:!1,resultsHoldTime:2300,gameStarted:!1,showSliderAnimation:!1,showOverlayAd:!1,showInterstitial:!1}}return i(t,e),t.prototype.componentWillReceiveProps=function(e,t){var n=this,i=this.context.gameManagerSettings.gameManagerOptions.getGamePaused(),r=this.context.gameManagerSettings.gameManagerOptions.getInterstitialActive();i||!this.interstitialActive||r||(clearTimeout(this.counterEndTimeout),this.gamePaused=i,this.showOverlayAfterInstiPoll?(this.showOverlayAfterInstiPoll=!1,this.context.embedSettings.document.getElementById("questionSection").style.transition="none",this.context.embedSettings.document.getElementById("questionSection").className="",setTimeout(function(){n.context.embedSettings.document.getElementById("questionSection").style.transition="all 0.6s ease-in-out"},600),this.overlayIsActive=!0,this.setState({showOverlayAd:!0})):this.overlayIsActive||this.handleShowNextQuestion(0))},t.prototype.componentWillMount=function(){this.keenUtil=new l.default(this.props.embedSettings),this.setState({questionCountDown:this.context.embedSettings.embedSetting.countdown})},t.prototype.startCountdown=function(){var e=this;this.interstitialActive||(clearTimeout(this.counterEndTimeout),this.counterEndTimeout=setTimeout(function(){e.interstitialActive||e.overlayIsActive||e.timeRanOut()},1e3*this.state.questionCountDown))},t.prototype._setCounterElem=function(e){return r.createElement(s.default,{countDown:this.state.questionCountDown,countDownDelay:1.5,active:this.state.counterActive,counterStartFunction:this._getQuestionStartTime.bind(this),startCountdown:this.startCountdown.bind(this)})},t.prototype._setQuestionAnswersElem=function(e){var t,n=this;return t=this.questionAnswered&&this.state.chosenOption?this.props.question.options.map(function(e,t){return n._checkAnswer(e,t)}):this.state.timeRanOut&&this.props.gameManagerOptions.getGameStarted()?this.props.question.options.map(function(e,t){return n._checkAnswer(e,t)}):this.props.question.options.map(function(e,t){return r.createElement(o.default,{gameManagerOptions:n.props.gameManagerOptions,playMode:n.props.playMode,answer:e,questionAnswered:n.questionAnswered,setAnsweredTrue:n._setAnsweredTrue.bind(n),indicator:"",key:t})})},t.prototype._setCounterContainerElem=function(e,t){return r.createElement("div",{className:"counter"},t)},t.prototype.handleShowNextQuestion=function(e){this._setTimeoutForSlider(),this._nextQuestionTimeout=setTimeout(function(){this.props.nextQuestion()}.bind(this),e)},t.prototype.render=function(){var e=this.context.embedSettings.embedSetting.showHeaderLogo,t={};e?t={height:"76px"}:this.context.embedSettings.embedSetting.showAdOnShortWidget&&(t={height:"86px"});var n="";this.state.showSliderAnimation&&(n="slideOutLeft");var i,o,s=null,l=null,c=this.props.gameManagerOptions.getGameType(),u=this.props.playMode;i=this._setQuestionAnswersElem(u),o=r.createElement("div",{id:"questionAnswers"},i),s=this._setCounterElem(c),l=this._setCounterContainerElem(u,s);var d;try{"undefined"==typeof this.props.question.questionImageURL&&null===this.props.question.questionImageURL||(d=this.props.question.questionImageURL)}catch(e){d=""}return r.createElement("div",{id:"questionSection",className:n},l,r.createElement("div",{className:"questionContainer",style:t},r.createElement(a.default,{imgURL:d,question:this.props.question.question})),o)},t.prototype.componentDidMount=function(){this._setQuestionAnswers(),this._currentTime=new Date,this._currentTime=this._currentTime.getTime()},t.prototype.componentWillUnmount=function(){clearInterval(this._counterCheckTimer),clearInterval(this.totalTimeTracker),clearTimeout(this._versusCounterEndCheckSetTimeOut),clearTimeout(this._counterEndCheckSetTimeOut),clearTimeout(this.counterEndTimeout),this._resetStates()},t.prototype.timeRanOut=function(){this.setState({timeRanOut:!0,counterActive:!1});var e=500;this.handleShowNextQuestion(e);var t={prediction:!1,question:this.props.question.question,answer:this.state.correctAnswer,choice:null,timeAnswered:null,points:0,timeOut:!0};this.props.questionResults(t)},t.prototype._getQuestionStartTime=function(){var e=new Date;return this._questionStartTime=e.getTime(),this._questionStartTime},t.prototype._getQuestionEndTime=function(){var e=new Date;return this._questionEndTime=e.getTime(),this._questionEndTime},t.prototype._resetStates=function(){this.questionAnswered=!1,this.setState({correctAnswer:null,answers:[],answered:!1,chosenOption:null,counterActive:!0,timeRanOut:!1,questionCountDown:5,pollResults:null,resultsTotal:null,retrySubmitPoll:!1})},t.prototype._checkAnswer=function(e,t){var n,i,s=e.predictionOption;return i=this.state.correctAnswer==s?this.state.correctAnswer===this.state.chosenOption?"netural":"":this.state.chosenOption===s?"netural clicked":"",this.state.correctAnswer===this.state.chosenOption?this._storeToLocalStorage(this.props.question.valueQuestionKeyword,!0):this._storeToLocalStorage(this.props.question.valueQuestionKeyword,!1),n=r.createElement(o.default,{gameManagerOptions:this.props.gameManagerOptions,playMode:this.props.playMode,answer:e,questionAnswered:this.questionAnswered,setAnsweredTrue:function(){},indicator:i,key:t})},t.prototype._storeToLocalStorage=function(e,t){if(localStorage)if("undefined"==typeof localStorage["insticator-value-keyword"]){var n={};n[e]=t;var i=JSON.stringify(n);localStorage.setItem("insticator-value-keyword",i)}else{var r=JSON.parse(localStorage.getItem("insticator-value-keyword"));r[e]=t;var o=JSON.stringify(r);localStorage["insticator-value-keyword"]=o}},t.prototype._setAnsweredTrue=function(e){clearTimeout(this.counterEndTimeout),this.questionAnswered=!0;var t=e.predictionOption,n=3100,i=e.predictionOptionUUID,r=this.props.question.uid,o=e.predictionOption,s="VALUE QUESTION",a="answerQuestion";null!==e&&this.keenUtil.answerQuestion(i,r,o,s,a),this.setState({answered:!0,chosenOption:t,counterActive:!1}),this._getQuestionEndTime(),this.handleShowNextQuestion(n)},t.prototype._setTimeoutForSlider=function(){this.context.embedSettings.logger("_setTimeoutForSlider called");var e=2e3;setTimeout(function(){this.setState({showSliderAnimation:!0})}.bind(this),e)},t.prototype._setQuestionAnswers=function(){for(var e=this.props.question,t=e.options,n=[],i=0;i<t.length;i++)n.push(t[i].predictionOption);this.setState({correctAnswer:e.answer,answers:n})},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component));Object.defineProperty(t,"__esModule",{value:!0}),t.default=m},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(){e.call(this),this.state={checkpoint1:!1,checkpoint2:!1,end:!1}}return i(t,e),t.prototype.componentWillMount=function(){this.setState({checkpoint1:!0}),this.props.startingAction();var e=this;setTimeout(function(){e.setState({checkpoint2:!0})},1e3*e._randomIntFromInterval(2,5))},t.prototype.componentDidMount=function(){},t.prototype.componentWillReceiveProps=function(){},t.prototype.componentWillUnmount=function(){},t.prototype._randomIntFromInterval=function(e,t){return Math.floor(Math.random()*(t-e+1)+e)},t.prototype.render=function(){var e,t,n,i,o,s,a;return t={backgroundImage:"url("+this.props.userData.avatar+")"},n={backgroundImage:"url("+this.props.enemyData.avatar+")"},this.state.checkpoint1===this.state.checkpoint2?(this._lastCheckPointTimer(),a="opponentFound",o=r.createElement("div",{className:"avatar",style:n}),s=r.createElement("div",{className:"name"},this.props.enemyData.name),i=null):(a="",i=r.createElement("div",{className:"searching-text"},r.createElement("p",null,"searching"),r.createElement("p",null,"for opponent")),s=null,o=r.createElement("img",{className:"loader",src:"https://d2na2p72vtqyok.cloudfront.net/files/images/loading.gif"})),e=r.createElement("div",{className:"versus-searching-container"},r.createElement("div",{className:"top-container"},r.createElement("h1",null,"VS MODE")),r.createElement("div",{className:"search-container"},r.createElement("div",{className:"box user-box"},r.createElement("div",{className:"name"},this.props.userData.name),r.createElement("div",{className:"avatar",style:t})),r.createElement("div",{className:"middle-vs-container"},r.createElement("h2",null,"VS")),r.createElement("div",{className:"box enemy-box "+a},s,o,i))),r.createElement("div",null,e)},t.prototype._lastCheckPointTimer=function(){var e=this;setTimeout(function(){e.props.finishedAction()},3e3)},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(){var t=this;e.call(this),this.state={animateScreen:!1,animateScreenRight:!1,optionSelected:!1},window.setTimeout(function(){t.animate()},1)}return i(t,e),t.prototype.componentDidMount=function(){},t.prototype.componentWillUnmount=function(){this.props.gameManagerOptions.setFirstGameRenderFalse()},t.prototype.animate=function(){this.setState({animateScreen:!0})},t.prototype.animateRight=function(){this.setState({animateScreen:!1,animateScreenRight:!0})},t.prototype.startGame=function(e){if(this.setState({optionSelected:!0}),this.context.embedSettings.embedSetting.showPolls&&this.props.gameManagerOptions.fetchQuestions("polls"),this.context.embedSettings.embedSetting.showArticles&&this.props.gameManagerOptions.fetchQuestions("articles"),this.animateRight(),"triviaMode"===e){var t=this.props.gameManagerOptions.firstGameRender();this.props.gameScreenOptions.setPlayMode(e),this.props.gameScreenOptions.startGame(e,t)}else this.props.gameManagerOptions.interruptGame("trivia","versusMode"),this.props.gameManagerOptions.resetTriviaQuestionCounter()},t.prototype.render=function(){var e="";this.state.animateScreen===!0?e="slideInLeft":this.state.animateScreenRight===!0&&(e="slideOutRight");var t,n;return this.state.optionSelected||(t=this.startGame.bind(this,"triviaMode"),n=this.startGame.bind(this,"versusMode")),r.createElement("div",{className:"optionContainer "+e},r.createElement("div",{className:"gameModeBtnContainer",onClick:t},r.createElement("div",{className:"innerContainer"},r.createElement("p",{className:"pTitle"},"Single Player"),r.createElement("p",null,"Challenge yourself"),r.createElement("div",{className:"gameModeBtn spButton"},r.createElement("i",{className:"fa fa-user triviaIcon","aria-hidden":"true"})))),r.createElement("div",{className:"gameModeBtnContainer bottomContainer",onClick:n},r.createElement("div",{className:"innerContainer versusInnerContainer"},r.createElement("p",{className:"pTitle"},"VS Mode"),r.createElement("p",null,"Challenge others"),r.createElement("div",{className:"gameModeBtn vsButton"},r.createElement("i",{className:"fa fa-users vsIcon","aria-hidden":"true"})))))},t.contextTypes={embedSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(241),s=n(206),a=function(e){function t(){var t=this;e.call(this),this.pollsOnlyMode=!0,this.currIdx=0,this._timerLimit=5e3,this._currentTime=0,this.state={playMode:null,playing:!1,firstStart:!0,questionAnswered:!1,gameEnd:!1,enemyPlayer:null,gameManagerQuestionCounter:null,maxQuestions:0,gameResults:[],maxQuestionsPerGame:5,questionInCurrentGame:1,demoQuestionSwitching:!1,updatingUserScore:"",userScore:0,enemyScore:0,pollsResultData:null,gamePaused:!1,gameScreenOptions:{startGame:function(){t.startGame()},setPlayMode:function(e){t.setState({playMode:e})}}}}return i(t,e),t.prototype.shouldComponentUpdate=function(e,t){switch(!0){case this.props.gamePaused!==t.gamePaused:return!0;case this.props.playerData!==e.playerData:return!0;case this.props.embedOptions!==e.embedOptions:return!0;case this.props.playMode!==e.playMode:return!0;case this.props.questions!==e.questions:return!0;case this.props.gameManagerQuestionCounter!==e.gameManagerQuestionCounter:return!0;case this.props.pollsResultData!==e.pollsResultData:return!0;case this.state.playMode!==t.playMode:return!0;case this.state.playing!==t.playing:return!0;case this.state.firstStart!==t.firstStart:return!0;case this.state.questionAnswered!==t.questionAnswered:return!0;case this.state.gameEnd!==t.gameEnd:return!0;case this.state.enemyPlayer!==t.enemyPlayer:return!0;case this.state.gameManagerQuestionCounter!==t.gameManagerQuestionCounter:return!0;case this.state.maxQuestions!==t.maxQuestions:return!0;case this.state.questionInCurrentGame!==t.questionInCurrentGame:return!0;case this.state.demoQuestionSwitching!==t.demoQuestionSwitching:return!0;case this.state.updatingUserScore!==t.updatingUserScore:return!0;case this.state.userScore!==t.userScore:return!0;case this.state.enemyScore!==t.enemyScore:return!0;case this.state.pollsResultData!==t.pollsResultData:return!0;default:return!1}},t.prototype.componentWillMount=function(){this.keenUtil=new s.default(this.props.embedSettings);var e,t=this.props.gameManagerOptions.getPollsQuestionsLen()-1-this.props.gameManagerOptions.getPollsQuestionCounter()+1;e=this.state.maxQuestionsPerGame>t?t:this.state.maxQuestionsPerGame,this.setState({maxQuestionsPerGame:e}),null!==this.props.pollsResultData?this.setState({pollsResultData:this.props.pollsResultData[this.props.gameManagerOptions.pollsQuestionCounter()]}):this.setState({pollsResultData:"empty"}),this.setState({pollsResultData:this.props.gameManagerOptions.getPollResults()}),null==this.props.questions||0==this.props.questions.length?this.props.gameManagerOptions.setGameEndTrue():(this._startPollsMode(),(this.props.gameManagerOptions.playFromResults()||0==this.context.embedSettings.embedSetting.showTrivia)&&(this.pollsOnlyMode=!0));var n=this.context.embedSettings.embedSetting.showPolls,i=this.context.embedSettings.embedSetting.showTrivia;if(n&&!i){this.fetchArticleData();var r=100,o=this;setTimeout(function(){o.setState({firstStart:!1})},r)}var a=this.props.gameManagerOptions.getPollsQuestionsLen();a<5&&this.setState({maxQuestionsPerGame:a})},t.prototype.componentWillUpdate=function(e,t){},t.prototype.componentWillReceiveProps=function(e){e.gamePaused!==this.state.gamePaused&&this.setState({gamePaused:!this.state.gamePaused}),this.setState({gameManagerQuestionCounter:this.props.gameManagerQuestionCounter});var t=this.context.embedSettings.embedSetting.showPolls,n=this.context.embedSettings.embedSetting.showTrivia,i=this.props.gameManagerOptions.playFromResults();if(1!=this.state.firstStart||"pollsMode"!=this.state.playMode||t&&!n||i)this.setState({firstStart:!1});else{var r=2e3,o=this;setTimeout(function(){o.setState({firstStart:!1})},r)}},t.prototype.componentDidMount=function(){this._fetchPollResult()},t.prototype.fetchArticleData=function(){this.context.embedSettings.embedSetting.showArticles&&0===this.props.gameManagerOptions.getArticles().length&&this.props.gameManagerOptions.fetchQuestions("articles")},t.prototype._checkForPollResults=function(){this._currentTime+=200;var e=this.props.gameManagerOptions.getPollResults();(this._currentTime>this._timerLimit||null!==e)&&(this.context.embedSettings.logger("pollResults RECEIVED"),this.setState({pollsResultData:e}),clearInterval(this._pollsResultCheckTimer))},t.prototype._revealAnswerOptions=function(){this.keenUtil.addClickEvent("POLL","START GAME",null),this.context.embedSettings.refreshAds(),this.context.embedSettings.embedSetting.showArticles&&this.props.gameManagerOptions.fetchQuestions("articles");this.state.playMode;this._startPollsMode(),this.setState({firstStart:!1})},t.prototype._setPlayingSetState=function(e){return this.setState({playing:e}),e},t.prototype._increaseCurrentGameQuestionCount=function(){this.setState({questionInCurrentGame:this.state.questionInCurrentGame+1}),this.props.gameManagerOptions.increaseQuestionCounter(1)},t.prototype._handleNextForPollOnlyMode=function(){var e=this.currIdx;this.props.gameManagerOptions.getMaxPollsQuestions();if(this.setState({questionAnswered:!0}),"demoMode"==this.state.playMode)this.props.gameManagerOptions.maxPollsQuestions()-2<this.props.gameManagerOptions.pollsQuestionCounter()?(this.props.gameManagerOptions.resetPollsQuestionCounter(),this.setState({questionAnswered:!1})):(this.setState({questionAnswered:!1}),this.props.gameManagerOptions.increasePollsQuestionCounter(1));else if(this.state.maxQuestionsPerGame<this.props.gameManagerOptions.questionCounter()&&this.props.gameManagerOptions.playFromResults()===!0)this.props.gameManagerOptions.increasePollsQuestionCounter(1),this.props.gameManagerOptions.setPlayFromResultsFalse(),this.setState({gameEnd:!0,playing:!1});else if(this.state.maxQuestionsPerGame<=e)this.props.gameManagerOptions.increasePollsQuestionCounter(1),this.props.gameManagerOptions.setGameEndTrue(),this.setState({gameEnd:!0,playing:!1});else{var t=200,n=this;this.props.gameManagerOptions.increasePollsQuestionCounter(1),setTimeout(function(){n.setState({questionAnswered:!1,updatingUserScore:""})},t)}},t.prototype._nextQuestion=function(){if(this.currIdx+=1,this._increaseCurrentGameQuestionCount(),this.pollsOnlyMode)this._handleNextForPollOnlyMode();else if(this.setState({questionAnswered:!0}),"demoMode"==this.state.playMode)this.props.gameManagerOptions.maxPollsQuestions()-2<this.props.gameManagerOptions.pollsQuestionCounter()?this.setState({questionAnswered:!1}):(this.setState({questionAnswered:!1}),this.props.gameManagerOptions.increasePollsQuestionCounter(1));else{this.setState({firstStart:!1});var e=this.context.embedSettings.embedSetting.showTrivia;if(!this.props.gameManagerOptions.playFromResults()&&e)this.setState({gameEnd:!0,playing:!1}),this.props.gameManagerOptions.increasePollsQuestionCounter(1),this.props.gameManagerOptions.setGameEndTrue();else if(this.state.maxQuestionsPerGame<this.state.questionInCurrentGame)if(this.setState({gameEnd:!0,playing:!1}),this.props.gameManagerOptions.maxPollsQuestions()-2<this.props.gameManagerOptions.pollsQuestionCounter()){this.props.gameManagerOptions.setGameEndTrue(),this.props.gameManagerOptions.increasePollsQuestionCounter(1);var t=1e3;setTimeout(function(){},t)}else this.props.gameManagerOptions.increasePollsQuestionCounter(1),this.props.gameManagerOptions.showGameResults();else if(this.props.gameManagerOptions.maxPollsQuestions()-2<this.props.gameManagerOptions.pollsQuestionCounter()){this.context.embedSettings.logger("THIS SHOULD NEVER RUN");var t=2e3,n=this;setTimeout(function(){n.setState({questionAnswered:!1,updatingUserScore:""})},t)}else{var t=2e3,i=this;this.props.gameManagerOptions.increasePollsQuestionCounter(1),setTimeout(function(){i.setState({questionAnswered:!1,updatingUserScore:""})},t)}}},t.prototype._setQuestionResult=function(e){this.setState({gameResults:this.state.gameResults.concat(e),updatingUserScore:""})},t.prototype.startGame=function(){this.props.gameManagerOptions.getGameStarted()||(this.fetchArticleData(),this.props.gameManagerOptions.setGameStartedTrue()),this.setState({playMode:"pollsMode",playing:!0})},t.prototype._startPollsMode=function(){this.setState({playMode:"pollsMode",playing:!0});this.context.embedSettings.embedSetting.showPolls,this.context.embedSettings.embedSetting.showTrivia},t.prototype._endPollsMode=function(){this.keenUtil.addClickEvent("POLL","SKIP",null),this.props.gameManagerOptions.setGameEndTrue()},t.prototype._startDemoMode=function(){this.setState({playMode:"demoMode",playing:!1}),this.props.gameManagerOptions.changeGameMode("demoMode"),this.props.gameManagerOptions.setgameType("demoMode")},t.prototype._fetchPollResult=function(){this.props.gameManagerOptions.fetchPollResults()},t.prototype.createQuestionCountBarElem=function(e){var t,n=[],i=this.context.embedSettings.colorPalette.mainColor,o=(this.props.gameManagerOptions.playFromResults(),this.state.questionInCurrentGame),s=1/e*100;s=s.toString()+"%";for(var a=1;a<e+1;a++){var l={width:s};o>=a&&(l.backgroundColor=i),n.push(r.createElement("li",{key:a,className:"question-bar",style:l}))}return t=r.createElement("div",{className:"question-count-bar"},r.createElement("ul",{className:"question-bar-container"},n))},t.prototype.render=function(){var e,t,n;this.context.embedSettings.embedSetting.showTrivia,this.props.gameManagerOptions.playFromResults(),this.props.gameManagerOptions.getPollsQuestionsLen()-this.props.gameManagerOptions.getPollsQuestionCounter()-1;switch(n=this.state.maxQuestionsPerGame,t=this.createQuestionCountBarElem(n),this.state.playMode){case"pollsMode":({backgroundImage:"url("+this.props.playerData.avatar+")"});e=r.createElement("div",{id:"header",className:"polls-header"},r.createElement("h1",null,"POLL"),r.createElement("div",{className:"skip-button",onClick:this._endPollsMode.bind(this)},"Skip"));break;case"demoMode":default:e=r.createElement("div",{id:"header",className:"polls-header"},r.createElement("h1",null,"POLL"),r.createElement("div",{className:"skip-button",onClick:this._endPollsMode.bind(this)},"Skip"))}var i;(this.state.questionAnswered&&this.state.playing&&0==this.state.gameEnd||1==this.state.firstStart&&"pollsMode"==this.state.playMode)&&(i=(1!==this.state.gameManagerQuestionCounter,null));var s;return s=null!==this.props.questions&&0!==this.props.questions.length?r.createElement(o.default,{playMode:this.state.playMode,question:this.props.questions[this.props.gameManagerOptions.pollsQuestionCounter()],maxQuestionsPerGame:this.state.maxQuestionsPerGame,currentQuestion:this._increaseCurrentGameQuestionCount.bind(this),playing:this._setPlayingSetState.bind(this),gamePaused:this.state.gamePaused,nextQuestion:this._nextQuestion.bind(this),questionResults:this._setQuestionResult.bind(this),pollsResultData:this.state.pollsResultData,gameManagerOptions:this.props.gameManagerOptions,embedSettings:this.props.embedSettings,gameScreenOptions:this.state.gameScreenOptions}):null,(this.state.questionAnswered&&this.state.playing||this.state.gameEnd)&&(s=null),this.state.gameEnd===!0&&(e=null,i=null,s=null,t=null),this.context.embedSettings.embedSetting.showAdOnShortWidget&&(e=null),r.createElement("div",{id:"gameContainer"},e,t,i,s)},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=a},function(e,t,n){"use strict";var i,r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28),s=n(262),a=n(201);i=n(234);var l=new i(window.navigator.userAgent),c=function(e){function t(){var t=this;e.call(this),this.playMode="interstitial",this.currIdx=0,this.pollDataReceived=!1,this.deviceType=null!==l.mobile()?"MOBILE":"DESKTOP",this.firstQuestionAnswered=!1,this.surveyStart=!1,this.allQuestionsAnswered=!0,this.state={questionAnswered:!1,pollResultData:null,currentQuestion:null,instiPollManager:{sendSurveyStart:function(){t.sendSurveyStartEvent()},sendSurveyEnd:function(){t.sendSurveyEndEvent()},getFirstQuestionAnswered:function(){return t.firstQuestionAnswered},setFirstQuestionAnsweredTrue:function(){t.firstQuestionAnswered=!0},setSurveyStartTrue:function(){t.surveyStart=!0},getSurveyStart:function(){return t.surveyStart},getAllQuestionsAnswered:function(){return t.allQuestionsAnswered},setAllQuestionsAnsweredFalse:function(){t.allQuestionsAnswered=!1}}}}return r(t,e),t.prototype.sendInstiEvent=function(e){var t=new XMLHttpRequest,n=a.articlesBaseUrl+"/instipollevent",i="adPlatform="+this.deviceType+"&instiPollUUID="+this.instiPollUUID+"&embedUUID="+this.embedUUID+"&event="+e;t.open("POST",n,!0),t.setRequestHeader("Content-type","application/x-www-form-urlencoded"),t.send(i)},t.prototype.sendImpressionEvent=function(){this.sendInstiEvent("IMPRESSION")},t.prototype.sendSurveyStartEvent=function(){this.sendInstiEvent("SURVEY_START")},t.prototype.sendSurveyEndEvent=function(){this.sendInstiEvent("SURVEY_END")},t.prototype.componentWillReceiveProps=function(e){this.pollDataReceived||null===e.pollResultData||(this.pollDataReceived=!0,this.setState({pollResultData:this.props.results}))},t.prototype.componentWillMount=function(){this.props.gameManagerOptions.setInstiPollShown(!0),this.context.embedSettings.document.getElementById("embedContent").style.position="absolute",this.context.embedSettings.document.getElementById("insticatorEmbed").style.position="absolute",this.context.embedSettings.document.getElementById("insticatorEmbed").style.height="100%",this.context.embedSettings.document.getElementById("poweredBy")&&(this.context.embedSettings.document.getElementById("poweredBy").style.zIndex="99999999999999"),this.context.embedSettings.document.getElementById("widgetNav")&&(this.context.embedSettings.document.getElementById("widgetNav").style.display="none"),this.questions=this.props.gameManagerOptions.getInstiPollQuestions(),this.instiPollUUID=this.questions[this.props.gameManagerOptions.getInstiPollQuestionCounter()].uid,this.embedUUID=this.context.embedSettings.embedUUID,null!==this.props.results&&(this.pollDataReceived=!0),this.setState({currentQuestion:this.questions[this.currIdx],pollResultData:this.props.results}),this.sendImpressionEvent()},t.prototype.componentWillUnmount=function(){this.context.embedSettings.document.getElementById("embedContent").style.position="relative",this.context.embedSettings.document.getElementById("insticatorEmbed").style.position="relative",this.context.embedSettings.embedSetting.showHeaderLogo?this.context.embedSettings.document.getElementById("insticatorEmbed").style.height="301px":this.context.embedSettings.document.getElementById("insticatorEmbed").style.height="100%",this.context.embedSettings.document.getElementById("poweredBy")&&(this.context.embedSettings.document.getElementById("poweredBy").style.zIndex="100"),this.context.embedSettings.document.getElementById("widgetNav")&&(this.context.embedSettings.document.getElementById("widgetNav").style.display="table")},t.prototype.endInstiPoll=function(){},t.prototype.setQuestionResult=function(){},t.prototype._increaseCurrentGameQuestionCount=function(){},t.prototype._setPlayingSetState=function(){},t.prototype._nextQuestion=function(e){var t=this;this.currIdx+=1,this.currIdx>this.questions.length-1?(this.setState({questionAnswered:!0}),this.props.gameManagerOptions.resumeGame()):(this.setState({currentQuestion:this.questions[this.currIdx],questionAnswered:!0}),setTimeout(function(){t.setState({questionAnswered:!1})},1))},t.prototype._setQuestionResult=function(){},t.prototype.createQuestion=function(){var e=this.currIdx===this.questions.length-1,t=0===this.currIdx;return o.createElement(s.default,{playMode:this.playMode,question:this.state.currentQuestion,nextQuestion:this._nextQuestion.bind(this),questionResults:this._setQuestionResult.bind(this),pollsResultData:this.state.pollResultData,gameManagerOptions:this.props.gameManagerOptions,embedSettings:this.context.embedSettings,lastQuestion:e,firstQuestion:t,instiPollManager:this.state.instiPollManager})},t.prototype.render=function(){var e=this.createQuestion();this.state.questionAnswered&&(e=null);return o.createElement("div",{id:"instiPollGameContainer"},e)},t.contextTypes={embedSettings:o.PropTypes.object.isRequired,gameManagerSettings:o.PropTypes.object.isRequired},t}(o.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=c},function(e,t,n){"use strict";var i,r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28),s=n(242),a=n(243),l=n(205),c=n(206),u=n(201);i=n(234);var d=new i(window.navigator.userAgent),p=n(245),h=(new p({projectId:u.API_KEYS.KEEN_PROJECT_ID,writeKey:u.API_KEYS.KEEN_WRITE_KEY,readKey:u.API_KEYS.KEEN_READ_KEY}),function(e){function t(){e.call(this),this.pollDataReceived=!1,this.countDownTime=20,this.state={counterActive:!0,timeRanOut:!1,questionAnswered:!1,countDownTimeVisual:this.countDownTime,slideQuestion:!1}}return r(t,e),t.prototype.clearTimeouts=function(){clearTimeout(this.counterEndTimeout),clearInterval(this.countDownTimeVisualInterval)},t.prototype.componentWillMount=function(){this.keenUtil=new c.default(this.props.embedSettings),null!==this.props.pollsResultData&&(this.pollDataReceived=!0)},t.prototype.componentWillUnmount=function(){this.props.gameManagerOptions.increaseInstiPollQuestionCounter();var e=this.props.gameManagerOptions.getMaxInstiPollQuestions(),t=this.props.gameManagerOptions.getInstiPollQuestionCounter();t===e&&this.props.gameManagerOptions.resetInstiPollQuestionCounter(),this.clearTimeouts()},t.prototype.componentWillReceiveProps=function(e){this.pollDataReceived||null===e.pollsResultData||(this.pollDataReceived=!0)},t.prototype.timeRanOut=function(){this.props.instiPollManager.setAllQuestionsAnsweredFalse(),
this.setState({timeRanOut:!0,counterActive:!1}),this.props.nextQuestion(!0)},t.prototype.startCountdown=function(){var e=this;this.countDownTimeVisualInterval=setInterval(function(){e.setState({countDownTimeVisual:e.state.countDownTimeVisual-1})},1e3),this.counterEndTimeout=setTimeout(function(){e.timeRanOut()},1e3*this.countDownTime)},t.prototype._getQuestionStartTime=function(){var e=new Date;return this._questionStartTime=e.getTime(),this._questionStartTime},t.prototype.fireQuantCastEvt=function(e){var t=this.context.embedSettings.clientUUID,n=this.context.embedSettings.siteUUID,i=this.context.embedSettings.embedUUID,r=e.predictionOptionUUID,o=this.props.question.questionUUID,s=this.props.question.uid,a=this.context.embedSettings.parentWindow._qevents,l="Publisher."+t+"."+n+"."+i+"."+s+"."+o+"."+r;a.push({qacct:"p-8HjSpkz-CQNFT",labels:l,event:"test"})},t.prototype.fireKeenAnswerQuestionEvt=function(e){var t=this.props.gameManagerOptions.getInstiPollQuestionsLen(),n=this.props.gameManagerOptions.getInstiPollQuestionCounter()+1,i={keen:{type:"INSTIPOLL",queryCollection:"answerQuestion"},questionOptionUUID:e.predictionOptionUUID,instiPollUUID:this.props.question.uid,questionText:this.props.question.question,questionOptionText:e.predictionOption,questionUUID:this.props.question.questionUUID,outOf:n+"/"+t};this.keenUtil.answerInstiPoll(i)},t.prototype.fireLotameEvt=function(e){var t=this.props.question.sendDataToDMP;if(t){var n=(this.context.embedSettings.embedSetting.lotameID,this.context.embedSettings.parentWindow._cc10831);if(n){var i=this.props.question.question,r=e.predictionOption;n.add("seg","question:"+i+" -"+r),n.bcp()}}},t.prototype.handleAdRefresh=function(){var e=!1;d.mobile()&&(e=!0);var t=this.context.embedSettings.embedSetting.webAdDisplayMode,n=this.context.embedSettings.embedSetting.mobileAdDisplayMode;("REGULAR"===t&&!e||"REGULAR"===n&&e)&&this.context.embedSettings.refreshAds()},t.prototype._setAnsweredTrue=function(e){var t=this;clearTimeout(this.counterEndTimeout),clearInterval(this.countDownTimeVisualInterval),this.handleAdRefresh(),1===this.props.gameManagerOptions.getInstiPollQuestionsLen()?(this.props.instiPollManager.sendSurveyStart(),this.props.instiPollManager.sendSurveyEnd()):this.props.lastQuestion&&this.props.instiPollManager.getFirstQuestionAnswered()&&this.props.instiPollManager.getAllQuestionsAnswered()?this.props.instiPollManager.sendSurveyEnd():this.props.firstQuestion?(this.props.instiPollManager.sendSurveyStart(),this.props.instiPollManager.setFirstQuestionAnsweredTrue(),this.props.instiPollManager.setSurveyStartTrue()):this.props.instiPollManager.getSurveyStart()||(this.props.instiPollManager.setSurveyStartTrue(),this.props.instiPollManager.sendSurveyStart()),this.setState({questionAnswered:!0,counterActive:!1}),null!==e&&(this._chosenOption=e,this.fireKeenAnswerQuestionEvt(e),this.fireLotameEvt(e)),this.props.lastQuestion?setTimeout(function(){t.props.nextQuestion(!1)},3e3):setTimeout(function(){t.setState({slideQuestion:!0}),setTimeout(function(){t.setState({slideQuestion:!1}),t.props.nextQuestion(!1)},1e3)},2e3)},t.prototype._setQuestionAnswersElem=function(){var e,t=this,n=this.props.gameManagerOptions.getInstiPollQuestionCounter(),i=[];if(null!==this.props.pollsResultData){var r,s=this.props.pollsResultData[n].length,l=this.props.pollsResultData[n][s-1].total+1;i=this.props.pollsResultData[n].map(function(i,s){if("object"!=typeof t.props.pollsResultData[n][s]){r=parseInt(i),t.props.question.options[s]===t._chosenOption&&(r+=1),e=(r/l*100).toFixed()+"%";var c=t.props.question.options[s].predictionOption;return o.createElement(a.default,{answer:c,result:e,indicator:"clicked",key:s})}})}else i=this.props.question.options.map(function(n,i){var r=t.props.question.options[i].predictionOption;return e=t.props.question.options[i]===t._chosenOption?"100%":0,o.createElement(a.default,{answer:r,result:e,indicator:"clicked",key:i})});return i},t.prototype.render=function(){var e=this,t=this.props.question.questionImageURL,n=this.props.question.brandLogoURL,i=this.props.question.options.map(function(t,n){return o.createElement(s.default,{gameManagerOptions:e.props.gameManagerOptions,playMode:e.props.playMode,answer:t,questionAnswered:e.state.questionAnswered,setAnsweredTrue:e._setAnsweredTrue.bind(e),indicator:"",key:n})});this.state.questionAnswered&&(i=this._setQuestionAnswersElem());var r=o.createElement("div",{id:"questionAnswers"},i),a={backgroundImage:"url('"+t+"')"},c={backgroundImage:"url('"+n+"')"},u=o.createElement(l.default,{countDown:this.countDownTime,countDownDelay:0,active:this.state.counterActive,counterStartFunction:this._getQuestionStartTime.bind(this),startCountdown:this.startCountdown.bind(this)}),d={padding:"0 5%",marginTop:"4px"},p=this.state.countDownTimeVisual;p=p<10?"0"+p:p;var h="";return this.state.slideQuestion&&(h="slideOutLeft"),o.createElement("div",{className:"questionSection "+h},o.createElement("div",{className:"questionContainer"},o.createElement("div",{className:"circleImage",style:c}),o.createElement("div",{className:"questionImage",style:a}),o.createElement("div",{className:"sponsoredText"},"Sponsored"),o.createElement("div",{className:"question"},o.createElement("div",{className:"questionText"},this.props.question.question))),o.createElement("div",{className:"counter-container",style:d},o.createElement("div",null,"Time: 00:",p),u),r)},t.contextTypes={embedSettings:o.PropTypes.object.isRequired,gameManagerSettings:o.PropTypes.object.isRequired},t}(o.Component));Object.defineProperty(t,"__esModule",{value:!0}),t.default=h},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(264),s=n(201),a=n(206),l=function(e){function t(t){e.call(this,t),this._parWindow=this.props.embedSettings.parentWindow,this._parDoc=this.props.embedSettings.document,this._embedFrame=this.props.embedSettings.insticatorEmbedIframe,this._contest=this.props.embedSettings.contest,this._frameSrc=s.articlesBaseUrl+"/contest/getfacebookloginlink?contestUUID="+this.props.embedSettings.contest.contestUUID,this._notNullLogo="undefined"!=this._contest.contestBrandLogoUrl,this._notNullBg="undefined"!=this._contest.contestImageUrl,this._notNullCountdown="undefined"!=this._contest.endDate,this._notNullColorOverlay="undefined"!=this._contest.contestOverlayColorCode,this.handleMessage=this.handleMessage.bind(this),this.state={textToDisplay:this.props.embedSettings.contest.bodyText}}return i(t,e),t.prototype.componentWillMount=function(){this.keenUtil=new a.default(this.props.embedSettings)},t.prototype.componentDidMount=function(){this._parDoc.querySelector("#insticator-embed-app").classList.add("isContest"),this._notNullCountdown?this._parDoc.querySelector("#insticator-embed-app").classList.add("hasCountdown"):null,this._embedFrame.contentWindow.addEventListener("message",this.handleMessage),this.keenUtil.addClickEvent("CONTEST","CONTEST_REACHED",null)},t.prototype.componentWillUnmount=function(){this._parDoc.querySelector("#insticator-embed-app").classList.remove("isContest","isEntered","hasCountdown"),this._embedFrame.contentWindow.removeEventListener("message",this.handleMessage)},t.prototype.handleMessage=function(e){var t=this;"connected"===e.data&&(this._embedFrame.contentWindow.localStorage.setItem("contestEntered",this._contest.contestUUID),this._parDoc.querySelector("#insticator-embed-app").classList.add("isEntered"),this.setState({textToDisplay:this.props.embedSettings.contest.successEnrollText}),setTimeout(function(){t.endGame("ENTERED")},2e3))},t.prototype.endGame=function(e){this.keenUtil.addClickEvent("CONTEST",e,null),this.props.gameManagerOptions.setGameEndTrue()},t.prototype.handleSkipLink=function(){this.endGame("SKIP")},t.prototype.handleTermsLink=function(){this.keenUtil.addClickEvent("CONTEST","TERMS",null)},t.prototype.handleCountdownFinish=function(){this.endGame("OVER")},t.prototype.endGameWithoutTracking=function(){this.props.gameManagerOptions.setGameEndTrue()},t.prototype.render=function(){return r.createElement("div",{id:"is-wg-contest"},r.createElement("div",{id:"is-wg-wrapper"},r.createElement("div",{id:"is-wg-content",style:{color:this._contest.contestFontColorCode}},r.createElement("div",{id:"is-wg-logo"},this._notNullLogo?r.createElement("div",{id:"is-wg-company",style:{backgroundImage:"url("+this._contest.contestBrandLogoUrl+")"}}):r.createElement("div",{id:"is-wg-company"})),this._notNullCountdown?r.createElement("div",{id:"is-wg-countdown"},r.createElement(o.default,{endDate:new Date(this._contest.endDate),onEndDate:this.handleCountdownFinish.bind(this),onForcedEnd:this.endGameWithoutTracking.bind(this)})):null,r.createElement("div",{id:"is-wg-copy"},r.createElement("div",{id:"is-wg-text"},r.createElement("h2",null,this.state.textToDisplay))),r.createElement("div",{id:"is-wg-cta"},r.createElement("iframe",{id:"fb-enter",src:this._frameSrc})),r.createElement("div",{id:"is-wg-legal"},r.createElement("p",null,r.createElement("a",{href:this._contest.termsAndConditionsUrl,target:"_blank",onClick:this.handleTermsLink.bind(this)},"See Contest Terms"))),r.createElement("div",{id:"is-wg-skip"},r.createElement("p",null,r.createElement("a",{href:"#",onClick:this.handleSkipLink.bind(this)},"Skip >")))),r.createElement("div",{id:"is-wg-bg"},this._notNullColorOverlay?r.createElement("div",{id:"is-wg-overlay",style:{backgroundColor:this._contest.contestOverlayColorCode}}):null,this._notNullBg?r.createElement("img",{src:this._contest.contestImageUrl,alt:""}):null)))},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=l},function(e,t,n){"use strict";function i(e){return e<10?"0"+e:e}var r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28),s=function(e){function t(t){e.call(this,t),this.state={days:i(0),hours:i(0),minutes:i(0),seconds:i(0)},this.startCountdown=this.startCountdown.bind(this),this.endCountdown=this.endCountdown.bind(this),this.displayTime=this.displayTime.bind(this),this.endDateReached=this.endDateReached.bind(this)}return r(t,e),t.prototype.componentWillMount=function(){},t.prototype.componentDidMount=function(){this.startCountdown()},t.prototype.componentWillUnmount=function(){this.endCountdown()},t.prototype.startCountdown=function(){var e=this;this._endDate=new Date(this.props.endDate),this._timer=setInterval(function(){var t=(new Date).getTime(),n=e._endDate-t;e.displayTime(n),e.endDateReached(n)},1e3)},t.prototype.endCountdown=function(){clearInterval(this._timer)},t.prototype.displayTime=function(e){var t=Math.floor(e/864e5),n=i(Math.floor(e%864e5/36e5)),r=i(Math.floor(e%36e5/6e4)),o=i(Math.floor(e%6e4/1e3));this.setState({days:t,hours:n,minutes:r,seconds:o})},t.prototype.endDateReached=function(e){e<0&&(this.endCountdown(),e>-2e3?this.props.onEndDate():this.props.onForcedEnd())},t.prototype.render=function(){return o.createElement("div",{id:"is-wg-countdown"},o.createElement("div",{className:"react-cntdwn-timer"},o.createElement("span",{className:"react-cntdwn-day"},this.state.days),o.createElement("span",{className:"react-cntdwn-hour"},this.state.hours),o.createElement("span",{className:"react-cntdwn-minute"},this.state.minutes),o.createElement("span",{className:"react-cntdwn-second"},this.state.seconds)))},t}(o.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(238),s=function(e){function t(t){e.call(this,t),this._parDoc=this.props.embedSettings.document,this._adShowScreenInterval=this.props.embedSettings.embedSetting.adUnitHoverTime?1e3*parseInt(this.props.embedSettings.embedSetting.adUnitHoverTime,10):15e3,this.endGameMode=this.endGameMode.bind(this),this.state={}}return i(t,e),t.prototype.componentDidMount=function(){this.triggerAdShowInterval(),this._parDoc.querySelector("#insticator-embed-app").classList.add("isOverlayAd")},t.prototype.componentWillUnmount=function(){this.clearAdShowInterval(),this.showWidgetNav(),this.clearAd(),this._parDoc.querySelector("#insticator-embed-app").classList.remove("isOverlayAd")},t.prototype.triggerAdShowInterval=function(){this._timeoutID=setTimeout(this.endGameMode,this._adShowScreenInterval)},t.prototype.endGameMode=function(){this.props.gameManagerOptions.setGameEndTrue()},t.prototype.clearAdShowInterval=function(){clearTimeout(this._timeoutID)},t.prototype.clearAd=function(){var e=this.props.embedSettings.embedSetting.targetAdDiv;"ad1"===e?e=document.getElementById("div-insticator-ad-1"):"ad2"===e?e=document.getElementById("div-insticator-ad-2"):"both"===e&&(document.getElementById("div-insticator-ad-1").style.zIndex="-1000",document.getElementById("div-insticator-ad-2").style.zIndex="-1000"),"both"!==e&&(e.style.zIndex="-1000")},t.prototype.showWidgetNav=function(){var e=this.props.embedSettings.document.getElementById("widgetNav");e&&(e.style.opacity=1)},t.prototype.render=function(){return r.createElement("div",{id:"is-wg-ad-show"},r.createElement(o.default,{closeBtnClicked:null,playMode:"adShowMode",renderedFromResults:!1}))},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t,n){"use strict";var i,r=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(28),s=n(267),a=n(268),l=n(271),c=n(206);i=n(234);var u=new i(window.navigator.userAgent),d=function(e){function t(t){e.call(this,t),this._parDoc=this.props.embedSettings.document,this._isMajorGameModeEnabled=this.isMajorGameModeEnabled(),this._additionalClass="",this.endGameMode=this.endGameMode.bind(this),this.removeInitialScreen=this.removeInitialScreen.bind(this),this.showUnavalableScreen=this.showUnavalableScreen.bind(this),this.handleKeenClickEvent=this.handleKeenClickEvent.bind(this),this.state={showInitialScreen:!1,showUnavalableScreen:!1}}return r(t,e),t.prototype.componentWillMount=function(){var e=this.props.embedSettings.embedSetting.showMarketResearch;e.includes("WITH_INITIAL_SCREEN")&&this.setState({showInitialScreen:!0,showUnavalableScreen:this.state.showUnavalableScreen}),this.keenUtil=new c.default(this.props.embedSettings),u.mobile()&&(this._additionalClass="is-market-research-mobile")},t.prototype.componentDidMount=function(){this._parDoc.querySelector("#insticator-embed-app").classList.add("isContest"),this.handleKeenClickEvent("MarketResearchReached")},t.prototype.componentWillUnmount=function(){this.showWidgetNav(),this._parDoc.querySelector("#insticator-embed-app").classList.remove("isContest")},t.prototype.isMajorGameModeEnabled=function(){return this.props.embedSettings.embedSetting.showArticles||this.props.embedSettings.embedSetting.showTrivia||this.props.embedSettings.embedSetting.showPolls},t.prototype.removeInitialScreen=function(){this.setState({showInitialScreen:!1,showUnavalableScreen:this.state.showUnavalableScreen})},t.prototype.endGameMode=function(){this.props.gameManagerOptions.setGameEndTrue()},t.prototype.showWidgetNav=function(){var e=this.props.embedSettings.document.getElementById("widgetNav");e&&(e.style.opacity=1)},t.prototype.showUnavalableScreen=function(){this.setState({showInitialScreen:this.state.showInitialScreen,showUnavalableScreen:!0})},t.prototype.handleKeenClickEvent=function(e){this.keenUtil.addClickEvent("MarketResearch",e,null)},t.prototype.render=function(){return o.createElement("div",{id:"is-market-research-screen",className:this._additionalClass},o.createElement(s.default,{showInitialScreen:this.state.showInitialScreen,removeInitialScreen:this.removeInitialScreen,handleKeenClickEvent:this.handleKeenClickEvent}),this.state.showUnavalableScreen&&!this.state.showInitialScreen?o.createElement(l.default,{endGameMode:this.endGameMode,_isMajorGameModeEnabled:this._isMajorGameModeEnabled}):null,o.createElement(a.default,{gameManagerOptions:this.props.gameManagerOptions,embedSettings:this.props.embedSettings,showUnavalableScreen:this.showUnavalableScreen,endGameMode:this.endGameMode,handleKeenClickEvent:this.handleKeenClickEvent,_isMajorGameModeEnabled:this._isMajorGameModeEnabled}))},t}(o.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=d},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(t){e.call(this,t),this.handleClick=this.handleClick.bind(this),this.state={showInitialScreen:this.props.showInitialScreen}}return i(t,e),t.prototype.componentWillReceiveProps=function(e){this.props.showInitialScreen!=e.showInitialScreen&&this.setState({showInitialScreen:e.showInitialScreen})},t.prototype.handleClick=function(){this.props.removeInitialScreen(),this.props.handleKeenClickEvent("MarketResearchButtonClicked")},t.prototype.render=function(){return this.state.showInitialScreen?r.createElement("div",{id:"is-market-research-info-screen"},r.createElement("h1",null,"Nice job!"),r.createElement("h2",null,"Answer this super quick survey to play again!"),r.createElement("div",{onClick:this.handleClick,className:"survay-bttn"},r.createElement("p",null,"Let's Go!"))):null},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(269),s=n(270),a=n(201),l=function(e){function t(t){e.call(this,t),this._parDoc=this.props.embedSettings.document,this._parWindow=this.props.embedSettings.parentWindow,this._parDoc=this.props.embedSettings.document,this._embedFrame=this.props.embedSettings.insticatorEmbedIframe,t.embedSettings.embedSetting.showMarketResearch.includes("CIVICSCIENCE")?this._marketResearchProvider="civicScience":t.embedSettings.embedSetting.showMarketResearch.includes("SURVATA")?(this._frameSrc=a.surveysBaseUrl+"insticator_survata.html",this._marketResearchProvider="survata"):this._marketResearchProvider="none",this.handleMessage=this.handleMessage.bind(this),this.toggleLoadingScreen=this.toggleLoadingScreen.bind(this),this.handleScreenEvents=this.handleScreenEvents.bind(this),this.state={showLoadingScreen:!0,isMainScreenHidden:!0}}return i(t,e),t.prototype.componentWillUnmount=function(){this._embedFrame.contentWindow.removeEventListener("message",this.handleMessage),this.clearTimeout()},t.prototype.componentDidMount=function(){this._embedFrame.contentWindow.addEventListener("message",this.handleMessage),this.triggerTimeout()},t.prototype.triggerTimeout=function(){this._timeoutID=setTimeout(this.props.showUnavalableScreen,5e3)},t.prototype.clearTimeout=function(){clearTimeout(this._timeoutID)},t.prototype.toggleLoadingScreen=function(){this.setState({showLoadingScreen:!1,isMainScreenHidden:this.state.isMainScreenHidden})},t.prototype.toggleScreenVisability=function(){this.setState({showLoadingScreen:this.state.showLoadingScreen,isMainScreenHidden:!this.state.isMainScreenHidden})},t.prototype.handleMessage=function(e){"surveyComplete"===e.data?(this.props._isMajorGameModeEnabled&&this.props.endGameMode(),this.props.handleKeenClickEvent("MarketResearchSurveyCompleted")):"noSurveyAvailable"===e.data?(this.props.showUnavalableScreen(),this.props.handleKeenClickEvent("MarketResearchSurveyRejected")):"removeSpinner"===e.data||"surveyReady"===e.data?(this.toggleLoadingScreen(),this.props.handleKeenClickEvent("MarketResearchSurveyReady")):"surveyShown"===e.data&&(this.clearTimeout(),this.props.handleKeenClickEvent("MarketResearchSurveyShown"))},t.prototype.handleScreenEvents=function(e){switch(e){case"surveyReady":this.props.handleKeenClickEvent("MarketResearchSurveyReady");break;case"surveyShown":this.clearTimeout(),this.toggleScreenVisability(),this.toggleLoadingScreen(),this.props.handleKeenClickEvent("MarketResearchSurveyShown");break;case"surveyComplete":this.props._isMajorGameModeEnabled&&this.props.endGameMode(),this.toggleScreenVisability(),this.props.handleKeenClickEvent("MarketResearchSurveyCompleted");break;default:console.log("Unexpected input")}},t.prototype.render=function(){var e=this,t=this.state.isMainScreenHidden?" wrapper-hidden":"";return r.createElement("div",{id:"is-market-research-main-screen"},r.createElement(o.default,{showLoadingScreen:this.state.showLoadingScreen}),r.createElement("div",{className:"is-market-research-main-screen-wrapper".concat(t)},function(){switch(e._marketResearchProvider){case"civicScience":return r.createElement(s.default,{gameManagerOptions:e.props.gameManagerOptions,embedSettings:e.props.embedSettings,handleScreenEvents:e.handleScreenEvents});case"survata":return r.createElement("iframe",{id:"survey-enter",src:e._frameSrc});default:return null}}()))},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=l},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(t){e.call(this,t),this.state={showLoadingScreen:this.props.showLoadingScreen}}return i(t,e),t.prototype.componentWillReceiveProps=function(e){this.props.showLoadingScreen!=e.showLoadingScreen&&this.setState({showLoadingScreen:e.showLoadingScreen})},t.prototype.render=function(){return this.state.showLoadingScreen?r.createElement("div",{id:"is-market-research-info-screen"},r.createElement("h1",{className:"loader"},"Loading...")):null},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=(n(201),function(e){function t(t){e.call(this,t),this._parDoc=this.props.embedSettings.document,this._parWindow=this.props.embedSettings.parentWindow,this._parDoc=this.props.embedSettings.document,this._embedFrame=this.props.embedSettings.insticatorEmbedIframe,this.handleIframeEvent=this.handleIframeEvent.bind(this),this.handleSurveyReady=this.handleSurveyReady.bind(this),this.handleSurveyShown=this.handleSurveyShown.bind(this),this.handleSurveyComplete=this.handleSurveyComplete.bind(this)}return i(t,e),t.prototype.componentDidMount=function(){var e=this.props.embedSettings.marketResearchSettings.civicscience.widgetID,t=document.createElement("div");t.id="civsci-id-471470438",t.setAttribute("data-civicscience-widget",e),this.iframeEl.contentWindow.document.body.appendChild(t);var n=document.createElement("script");n.type="text/javascript",n.async=!0,n.src="https://www.civicscience.com/jspoll/4/civicscience-widget.js",this.iframeEl.contentWindow.document.head.appendChild(n),this.iframeEl.contentWindow.document.addEventListener("civicscience:beforeFetchingQuestions",this.handleSurveyReady),this.iframeEl.contentWindow.document.addEventListener("civicscience:beforeAskingQuestions",this.handleSurveyShown),this.iframeEl.contentWindow.document.addEventListener("civicscience:afterShowingResults",this.handleSurveyComplete)},t.prototype.componentWillUnmount=function(){this.iframeEl.contentWindow.document.removeEventListener("civicscience:beforeFetchingQuestions",this.handleSurveyReady),this.iframeEl.contentWindow.document.removeEventListener("civicscience:beforeAskingQuestions",this.handleSurveyShown),this.iframeEl.contentWindow.document.removeEventListener("civicscience:afterShowingResults",this.handleSurveyComplete)},t.prototype.handleSurveyReady=function(){this.handleIframeEvent("surveyReady")},t.prototype.handleSurveyShown=function(){this.handleIframeEvent("surveyShown")},t.prototype.handleSurveyComplete=function(){this.handleIframeEvent("surveyComplete")},t.prototype.handleIframeEvent=function(e){this.props.handleScreenEvents(e)},t.prototype.render=function(){var e=this;return r.createElement("iframe",{id:"survey-enter",ref:function(t){return e.iframeEl=t}})},t}(r.Component));Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(t){e.call(this,t),this._screenInterval=3e3,this.state={}}return i(t,e),t.prototype.componentDidMount=function(){this.props._isMajorGameModeEnabled&&this.triggerAdShowInterval()},t.prototype.componentWillUnmount=function(){this.props._isMajorGameModeEnabled&&this.clearAdShowInterval()},t.prototype.triggerAdShowInterval=function(){this._timeoutID=setTimeout(this.props.endGameMode,this._screenInterval)},t.prototype.clearAdShowInterval=function(){clearTimeout(this._timeoutID)},t.prototype.render=function(){var e=this.props._isMajorGameModeEnabled?r.createElement("h3",{onClick:this.props.endGameMode},"Ok, Skip >"):null;return r.createElement("div",{id:"is-market-research-info-screen"},r.createElement("h2",{id:"no-survey"},"No survey available at this time."),e)},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(){e.call(this)}return i(t,e),t.prototype.getTriviaPlaceholder=function(){return r.createElement("div",null,r.createElement("div",{id:"header",className:"solo-header"},r.createElement("div",{className:"userAvatar"}),r.createElement("div",{className:"name-score-container"})),r.createElement("div",{id:"questionSection"},r.createElement("div",{className:"questionContainer"},r.createElement("div",{className:"question"},r.createElement("div",{className:"questionImage"}),r.createElement("div",{className:"questionText"}))),r.createElement("div",{id:"questionAnswers"},r.createElement("div",{className:"answer"}),r.createElement("div",{className:"answer"}),r.createElement("div",{className:"answer"}),r.createElement("div",{className:"answer"}))))},t.prototype.getArticlePlaceholder=function(){var e={position:"relative"},t={backgroundColor:"#bbbbc3"};return r.createElement("div",null,r.createElement("div",{id:"articleCardSlider",className:"articleCardSlider",style:e},r.createElement("div",{className:"top-container"},r.createElement("h2",null)),r.createElement("div",{id:"articleContainer"},r.createElement("div",{className:"article-container"},r.createElement("div",{className:"article-img",style:t}),r.createElement("div",{className:"article-body"},r.createElement("div",{className:"article-title-container"},r.createElement("div",{className:"article-text"})),r.createElement("div",{className:"article-button-container"},r.createElement("div",{className:"article-button"},r.createElement("p",null,"Read more"))))),r.createElement("div",{className:"bottom-container"},r.createElement("div",{className:"bottom-button",style:t},r.createElement("p",null))))))},t.prototype.render=function(){var e;return e="articles"===this.props.gameType?this.getArticlePlaceholder():this.getTriviaPlaceholder(),r.createElement("div",{id:"gameContainer"},e)},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(203),s=n(274),a=n(275),l=n(206),c=function(e){function t(){var t=this;e.call(this),this.specialContainerHeight={},this.specialContainerClass="",this.specialOptionIconClass="",this.specialTopClass="",this.showVersusResults=!1,this.state={gameOptionsCheck:!1,isCounterActive:!0,counterActive:!0,countdownTotal:180,showArticles:!1,startAnimation:!1,resultsCardOptions:{setShowArticlesFalse:function(){t.setState({showArticles:!1})},toggleShowArticles:function(){t.setState({showArticles:!t.state.showArticles})}}}}return i(t,e),t.prototype.componentWillMount=function(){this.props.gameManagerOptions.resetTotalQuestionsAnsweredInSet(),this.props.gameManagerOptions.setInstiPollShown(!1),this.props.gameManagerOptions.setPlayFromResultsTrue(),"versusMode"===this.props.playMode&&(this.showVersusResults=!0),this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled?(this.specialContainerHeight={height:"105px"},this.specialContainerClass="specialContainerClass",this.specialOptionIconClass="specialOptionIconClass",this.specialTopClass="specialTopClass"):this.context.embedSettings.embedSetting.showAdOnShortWidget&&(this.specialContainerHeight={height:"86px"}),!this.props.embedController.getLeaderboardInfoFetched()&&this.context.embedSettings.embedSetting.showLeaderboard&&this.props.embedController.fetchLeaderBoardInfo(),this.keenUtil=new l.default(this.props.embedSettings),this._resultsCheck(),this._optionCheck(),this.props.gameManagerOptions.turnNavOn(),this.props.gameManagerOptions.setResetDefaultFromResultsFalse()},t.prototype.componentDidMount=function(){setTimeout(function(){this.setState({startAnimation:!0})}.bind(this),1);var e=this.context.embedSettings.embedSetting.showTrivia,t=this.context.embedSettings.embedSetting.showPolls,n=this.context.embedSettings.embedSetting.showArticles;if(e||t){if(this.props.gameManagerOptions.setPlayAgainFalse(),"versusMode"==this.props.playMode||"surrender"==this.props.playMode){"surrender"==this.props.playMode&&this.props.gameManagerOptions.setgameType("versusMode");var i={width:"48%",display:"inline-block",marginRight:"2%"},o={width:"48%",display:"inline-block",backgroundColor:"#cccccc",marginLeft:"2%"};this._playButton=r.createElement("div",{id:"PlayButton"},r.createElement("div",{className:"invisible"}),r.createElement("div",{className:"play-again-btn btn",style:i,onClick:this._defaultPlayMode.bind(this)},r.createElement("p",null,"Play Solo")),r.createElement("div",{className:"play-again-btn btn",style:o,onClick:this._playAgain.bind(this)},r.createElement("p",null,"Play VS")))}else this._playButton=r.createElement("div",{id:"PlayButton"},r.createElement("div",{className:"invisible"}),r.createElement("div",{className:"play-again-btn btn",onClick:this._playAgain.bind(this)},r.createElement("p",null,"Play Again")));var s=void 0,a="";"versusMode"==this.props.playMode||"surrender"===this.props.playMode?s=this._soloButton:(s=this._versusButton,a="small-width"),this._options=r.createElement("ul",{className:"options "+a},this._leaderboardButton,s,this._chatButton,this._shareButton),!t||e||n||(this._options=null)}},t.prototype.render=function(){var e="";return this.state.startAnimation&&(e="slideInLeft"),this.state.showArticles?this._articles=r.createElement(o.default,{gameManagerOptions:this.props.gameManagerOptions,embedOptions:this.props.embedOptions,articles:this.props.gameManagerOptions.getArticleData(),displayedFromResults:!1,resultsCardOptions:this.state.resultsCardOptions}):this.state.showArticles===!1&&(this._articles=null),r.createElement("div",{className:"resultCardSlider "+e},this._articles,this._results,this._options)},t.prototype._playArticles=function(){this.keenUtil.addClickEvent("RESULTS","SHOW ARTICLES",null);var e=this.props.embedSettings.embedSetting.showOverlay;
e||this.props.embedSettings.refreshAds(),this.props.gameManagerOptions.interruptGameFromResults("articles"),this.props.embedOptions.disableAllOptionScreens()},t.prototype._playGameMode=function(e){var t="PLAY "+e.toUpperCase();switch(this.keenUtil.addClickEvent("RESULTS",t,null),e){case"polls":this.props.gameManagerOptions.pollsQuestionCounter(),this.props.gameManagerOptions.maxPollsQuestions();this.props.gameManagerOptions.pollsQuestionCounter()===this.props.gameManagerOptions.maxPollsQuestions()-1&&this.context.embedSettings.logger("END OF POLL QUESTIONS"),this.props.gameManagerOptions.interruptGameFromResults("polls","pollsMode");break;case"trivia":this.props.gameManagerOptions.interruptGame("trivia","triviaMode");break;case"versus":this.props.gameManagerOptions.interruptGame("trivia","versusMode")}},t.prototype.componentWillUnmount=function(){clearInterval(this._articleDelay)},t.prototype._playAgain=function(){this.props.gameManagerOptions.restartGame()},t.prototype._defaultPlayMode=function(){this.props.gameManagerOptions.hideGameResults(),this.props.gameManagerOptions.resetUserScore(),this.props.gameManagerOptions.resetEnemyUserScore(),this.props.gameManagerOptions.resetQuestionCounter(),this.props.gameManagerOptions.setGameEndTrue()},t.prototype._optionCheck=function(){var e=this.context.embedSettings.colorPalette.mainColor,t={};this.context.embedSettings.embedSetting.showAdOnShortWidget&&(t.display="none"),1==this.context.embedSettings.embedSetting.showLeaderboard&&(this._leaderboardButton=r.createElement("li",{className:"leaderBoards",onClick:this.props.embedOptions.showOptionScreen.bind(this,"leaderBoard","RESULTS")},r.createElement("div",{className:"top noLeftMargin "+this.specialTopClass},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M522 883q-74-162-74-371h-256v96q0 78 94.5 162t235.5 113zm1078-275v-96h-256q0 209-74 371 141-29 235.5-113t94.5-162zm128-128v128q0 71-41.5 143t-112 130-173 97.5-215.5 44.5q-42 54-95 95-38 34-52.5 72.5t-14.5 89.5q0 54 30.5 91t97.5 37q75 0 133.5 45.5t58.5 114.5v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-69 58.5-114.5t133.5-45.5q67 0 97.5-37t30.5-91q0-51-14.5-89.5t-52.5-72.5q-53-41-95-95-113-5-215.5-44.5t-173-97.5-112-130-41.5-143v-128q0-40 28-68t68-28h288v-96q0-66 47-113t113-47h576q66 0 113 47t47 113v96h288q40 0 68 28t28 68z",fill:e}))),r.createElement("div",{className:"bottom noLeftMargin",style:t},"LEADERBOARD"))),1==this.context.embedSettings.embedSetting.showTrivia&&(this._versusButton=r.createElement("li",{className:"versus",onClick:this._playGameMode.bind(this,"versus")},r.createElement("div",{className:"top noLeftMargin "+this.specialTopClass},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M529 896q-162 5-265 128h-134q-82 0-138-40.5t-56-118.5q0-353 124-353 6 0 43.5 21t97.5 42.5 119 21.5q67 0 133-23-5 37-5 66 0 139 81 256zm1071 637q0 120-73 189.5t-194 69.5h-874q-121 0-194-69.5t-73-189.5q0-53 3.5-103.5t14-109 26.5-108.5 43-97.5 62-81 85.5-53.5 111.5-20q10 0 43 21.5t73 48 107 48 135 21.5 135-21.5 107-48 73-48 43-21.5q61 0 111.5 20t85.5 53.5 62 81 43 97.5 26.5 108.5 14 109 3.5 103.5zm-1024-1277q0 106-75 181t-181 75-181-75-75-181 75-181 181-75 181 75 75 181zm704 384q0 159-112.5 271.5t-271.5 112.5-271.5-112.5-112.5-271.5 112.5-271.5 271.5-112.5 271.5 112.5 112.5 271.5zm576 225q0 78-56 118.5t-138 40.5h-134q-103-123-265-128 81-117 81-256 0-29-5-66 66 23 133 23 59 0 119-21.5t97.5-42.5 43.5-21q124 0 124 353zm-128-609q0 106-75 181t-181 75-181-75-75-181 75-181 181-75 181 75 75 181z",fill:e}))),r.createElement("div",{className:"bottom noLeftMargin",style:t},"VS MODE")),this._soloButton=r.createElement("li",{className:"versus",onClick:this._playGameMode.bind(this,"trivia")},r.createElement("div",{className:"top noLeftMargin "+this.specialTopClass},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M1600 1405q0 120-73 189.5t-194 69.5h-874q-121 0-194-69.5t-73-189.5q0-53 3.5-103.5t14-109 26.5-108.5 43-97.5 62-81 85.5-53.5 111.5-20q9 0 42 21.5t74.5 48 108 48 133.5 21.5 133.5-21.5 108-48 74.5-48 42-21.5q61 0 111.5 20t85.5 53.5 62 81 43 97.5 26.5 108.5 14 109 3.5 103.5zm-320-893q0 159-112.5 271.5t-271.5 112.5-271.5-112.5-112.5-271.5 112.5-271.5 271.5-112.5 271.5 112.5 112.5 271.5z",fill:e}))),r.createElement("div",{className:"bottom noLeftMargin",style:t},"SOLO MODE")),this.context.embedSettings.embedSetting.showVersusMode||(this._versusButton=null)),1==this.context.embedSettings.embedSetting.showChatting&&(this._chatButton=r.createElement("li",{className:"chat",onClick:this.props.embedOptions.showOptionScreen.bind(this,"chat","RESULTS")},r.createElement("div",{className:"top noLeftMargin "+this.specialTopClass},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M1408 768q0 139-94 257t-256.5 186.5-353.5 68.5q-86 0-176-16-124 88-278 128-36 9-86 16h-3q-11 0-20.5-8t-11.5-21q-1-3-1-6.5t.5-6.5 2-6l2.5-5 3.5-5.5 4-5 4.5-5 4-4.5q5-6 23-25t26-29.5 22.5-29 25-38.5 20.5-44q-124-72-195-177t-71-224q0-139 94-257t256.5-186.5 353.5-68.5 353.5 68.5 256.5 186.5 94 257zm384 256q0 120-71 224.5t-195 176.5q10 24 20.5 44t25 38.5 22.5 29 26 29.5 23 25q1 1 4 4.5t4.5 5 4 5 3.5 5.5l2.5 5 2 6 .5 6.5-1 6.5q-3 14-13 22t-22 7q-50-7-86-16-154-40-278-128-90 16-176 16-271 0-472-132 58 4 88 4 161 0 309-45t264-129q125-92 192-212t67-254q0-77-23-152 129 71 204 178t75 230z",fill:e}))),r.createElement("div",{className:"bottom noLeftMargin",style:t},"CHAT"))),1==this.context.embedSettings.embedSetting.showSocialShare&&(this._shareButton=r.createElement("li",{className:"share",onClick:this.props.embedOptions.showOptionScreen.bind(this,"share","RESULTS")},r.createElement("div",{className:"top noRightMargin noLeftMargin "+this.specialTopClass},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M1344 1024q133 0 226.5 93.5t93.5 226.5-93.5 226.5-226.5 93.5-226.5-93.5-93.5-226.5q0-12 2-34l-360-180q-92 86-218 86-133 0-226.5-93.5t-93.5-226.5 93.5-226.5 226.5-93.5q126 0 218 86l360-180q-2-22-2-34 0-133 93.5-226.5t226.5-93.5 226.5 93.5 93.5 226.5-93.5 226.5-226.5 93.5q-126 0-218-86l-360 180q2 22 2 34t-2 34l360 180q92-86 218-86z",fill:e}))),r.createElement("div",{className:"bottom noRightMargin noLeftMargin",style:t},"SHARE")))},t.prototype._resultsCheck=function(){var e,t,n,i,o=this.context.embedSettings.embedSetting.showTrivia,l=this.context.embedSettings.embedSetting.showPolls,c=this.context.embedSettings.embedSetting.showArticles,u=this.props.gameManagerOptions.getPollsQuestionCounter(),d=this.props.gameManagerOptions.getMaxPollsQuestions(),p={},h=u>=d;if(h=!1,l&&!o?!h&&c?i="two-active":(h&&c||!h&&!c)&&(i="one-active"):i=o?l&&c?"three-active":l||c?"two-active":"one-active":"one-active",n=!l&&!o||l&&!o?null:r.createElement("div",{onClick:this._playAgain.bind(this),className:"btn "+i},r.createElement("p",null,"Play Again")),l&&(e=r.createElement("div",{onClick:this._playGameMode.bind(this,"polls"),className:"btn "+i},r.createElement("p",null,"Polls"))),c){var m="Articles";"0e2153a2-ab89-4e66-9c87-69808291ef2b"===this.context.embedSettings.siteUUID&&(m="More Quizzes"),t=r.createElement("div",{onClick:this._playArticles.bind(this),className:"btn "+i},r.createElement("p",null,m))}if("versusMode"==this.props.playMode||"surrender"==this.props.playMode||this.showVersusResults)this._results=r.createElement(s.default,{playMode:this.props.playMode,playerData:this.props.userInformation,userScore:this.props.currentGameScore,enemyScore:this.props.gameManagerOptions.enemyScore(),enemyData:this.props.gameManagerOptions.enemyData(),embedOptions:this.props.embedOptions,embedSettings:this.props.embedSettings,gameManagerOptions:this.props.gameManagerOptions});else{({backgroundImage:"url("+this.props.userInformation.avatar+")"});!c&&!o&&l&&h&&(p={display:"none"});var f={};this.context.embedSettings.embedSetting.showAdOnShortWidget&&(f.display="none"),this._results=r.createElement("div",{id:"triviaResults",className:"triviaResults"},r.createElement("h2",{style:f},"YOU EARNED"),r.createElement("div",{className:"resultsContainer "+this.specialContainerClass,style:this.specialContainerHeight},r.createElement("div",{className:"pointsContainer"},r.createElement("div",{className:"resultValues"},r.createElement("h1",null,this.props.currentGameScore),r.createElement("p",{className:"points"},"POINTS"))),r.createElement("div",{className:"buttonContainer",style:p},n,e,t))),!l||o||c||(this._results=r.createElement(a.default,{showSocialShare:this.context.embedSettings.embedSetting.showSocialShare,mainColor:this.context.embedSettings.colorPalette.mainColor,showOptionScreen:this.props.embedOptions.showOptionScreen}))}},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=c},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(){e.call(this),this.specialTextStyle={},this.specialContainerHeight={},this.specialBtnContainer={},this.specialPlayerBoxClass="",this.specialOptionIconClass="",this.state={}}return i(t,e),t.prototype.componentWillUnmount=function(){},t.prototype.componentWillMount=function(){this.props.gameManagerOptions.setInstiPollShown(!1),this.props.gameManagerOptions.setPlayFromResultsTrue(),this.props.gameManagerOptions.setResetDefaultFromResultsFalse(),this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled?(this.specialTextStyle={margin:0},this.specialContainerHeight={height:"110px"},this.specialPlayerBoxClass="specialPlayerBoxClass"):this.context.embedSettings.embedSetting.showAdOnShortWidget&&(this.specialTextStyle={display:"none"},this.specialBtnContainer={height:"22px"})},t.prototype._playAgain=function(){this.props.gameManagerOptions.interruptGame("trivia","versusMode"),this.props.gameManagerOptions.resetEnemyUserScore()},t.prototype._playPolls=function(){this.props.gameManagerOptions.interruptGameFromResults("polls","pollsMode")},t.prototype._playArticles=function(){this.props.gameManagerOptions.interruptGameFromResults("articles"),this.props.embedOptions.disableAllOptionScreens()},t.prototype.renderPlayerBoxes=function(e){var t="",n="",i="",o="";"surrender"==this.props.playMode?t="playerLose":this.props.userScore>this.props.enemyScore?t="playerWin":this.props.userScore<this.props.enemyScore?t="playerLose":(t="borderRight",n="borderLeft"),"TIED!"===e?(o="tiedColorClass",i="playerScoreTiedText"):i="playerScoreText";var s,a,l,c=this.context.embedSettings.embedSetting.showPolls&&this.props.gameManagerOptions.getPollQuestions().length>0,u=this.context.embedSettings.embedSetting.showArticles&&this.props.gameManagerOptions.getArticleData().length>0,d=this.props.gameManagerOptions.pollsQuestionCounter(),p=this.props.gameManagerOptions.maxPollsQuestions(),h=d>=p-1;if(l=this.context.embedSettings.embedSetting.showPolls&&!this.context.embedSettings.embedSetting.showTrivia?"one-active":c&&!h&&u?"three-active":c&&!h||u?"two-active":"one-active",c&&!h&&(s=r.createElement("div",{onClick:this._playPolls.bind(this),className:"btn "+l},r.createElement("p",null,"Polls"))),u){var m="Articles";"0e2153a2-ab89-4e66-9c87-69808291ef2b"===this.context.embedSettings.siteUUID&&(m="More Quizzes"),a=r.createElement("div",{onClick:this._playArticles.bind(this),className:"btn "+l},r.createElement("p",null,m))}return r.createElement("div",{className:"resultsContainer",style:this.specialContainerHeight},r.createElement("div",{className:"playerBox "+t+" "+this.specialPlayerBoxClass},r.createElement("div",{className:"playerInfoContainer"},r.createElement("span",{className:i},this.props.userScore," POINTS")),r.createElement("div",null,r.createElement("img",{src:this.props.playerData.avatar,alt:"",className:"playerIcon"})),r.createElement("div",{className:"playerName "+o},r.createElement("span",null,this.props.playerData.name))),r.createElement("div",{className:"playerBox "+n+" "+this.specialPlayerBoxClass},r.createElement("div",{className:"playerInfoContainer"},r.createElement("span",{className:"enemyScoreText"},this.props.enemyScore," POINTS")),r.createElement("div",null,r.createElement("img",{src:this.props.enemyData.avatar,alt:"",className:"playerIcon"})),r.createElement("div",{className:"enemyName"},r.createElement("span",null,this.props.enemyData.name))),r.createElement("div",{className:"buttonContainer",style:this.specialBtnContainer},r.createElement("div",{onClick:this._playAgain.bind(this),className:"btn "+l},r.createElement("p",null,"Play Again")),s,a))},t.prototype.render=function(){var e="",t="",n="";"surrender"==this.props.playMode?(e="LOSE",t="playerLoseText",n="playerLoseBar"):this.props.userScore>this.props.enemyScore?(e="WIN!",t="playerWinText",n="playerWinBar"):this.props.userScore<this.props.enemyScore?(e="LOSE",t="playerLoseText",n="playerLoseBar"):(e="TIED!",t="playerTiedText",n="playerLoseBar");var i=this.renderPlayerBoxes(e);return r.createElement("div",{className:"versusResults"},r.createElement("h2",{className:t,style:this.specialTextStyle},r.createElement("span",{className:n},"YOU ",e)),i)},t.contextTypes={embedSettings:r.PropTypes.object.isRequired,gameManagerSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=n(28),r=n(276),o=function(e){var t=e.showSocialShare,n=e.mainColor,o=e.showOptionScreen,s=null,a={marginTop:"40%"};return t&&(a={marginTop:"8%"},s=i.createElement(r.default,{mainColor:n,showOptionScreen:o})),i.createElement("div",{id:"pollOnlyResults",className:""},i.createElement("div",{className:"pollsThankYou",style:a},i.createElement("h2",null,"Thank You"),i.createElement("h2",null,"For Participating in our Poll")),s)};Object.defineProperty(t,"__esModule",{value:!0}),t.default=o},function(e,t,n){"use strict";var i=n(28),r=function(e){return i.createElement("div",{className:"pollsButtonContaner"},i.createElement("div",{className:"pollsTextHolder"},i.createElement("p",null,"Share with friends and"),i.createElement("p",null,"get people talking")),i.createElement("div",{className:"pollsShareButton",onClick:e.showOptionScreen.bind(this,"share","RESULTS")},i.createElement("svg",{viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},i.createElement("path",{d:"M1344 1024q133 0 226.5 93.5t93.5 226.5-93.5 226.5-226.5 93.5-226.5-93.5-93.5-226.5q0-12 2-34l-360-180q-92 86-218 86-133 0-226.5-93.5t-93.5-226.5 93.5-226.5 226.5-93.5q126 0 218 86l360-180q-2-22-2-34 0-133 93.5-226.5t226.5-93.5 226.5 93.5 93.5 226.5-93.5 226.5-226.5 93.5q-126 0-218-86l-360 180q2 22 2 34t-2 34l360 180q92-86 218-86z",fill:e.mainColor})),i.createElement("div",{className:"shareText"},"SHARE")))};Object.defineProperty(t,"__esModule",{value:!0}),t.default=r},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o={femaleImgUrls:["https://d2na2p72vtqyok.cloudfront.net/files/images/icon_0.jpg","https://d2na2p72vtqyok.cloudfront.net/files/images/icon_3.jpg","https://d2na2p72vtqyok.cloudfront.net/files/images/icon_5.jpg"],maleImgUrls:["https://d2na2p72vtqyok.cloudfront.net/files/images/icon_1.jpg","https://d2na2p72vtqyok.cloudfront.net/files/images/icon_2.jpg","https://d2na2p72vtqyok.cloudfront.net/files/images/icon_4.jpg"]},s=function(e){function t(t){e.call(this),this.embedSettings=t}return i(t,e),t.prototype.generateRandomImgURL=function(){if("FEMALE"===this.embedSettings.embedSetting.avatarGender){var e=Math.floor(Math.random()*o.femaleImgUrls.length);return o.femaleImgUrls[e]}if("MALE"===this.embedSettings.embedSetting.avatarGender){var e=Math.floor(Math.random()*o.maleImgUrls.length);return o.maleImgUrls[e]}var t=o.femaleImgUrls.concat(o.maleImgUrls),e=Math.floor(Math.random()*t.length);return t[e]},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t,n){"use strict";var i=n(201),r=i.API_KEYS.KEEN_WRITE_KEY,o=i.API_KEYS.KEEN_READ_KEY,s=i.API_KEYS.KEEN_PROJECT_ID,a=i.API_KEYS.KEEN_MASTER_KEY,l=n(207),c=new l({projectId:s,readKey:o,writeKey:r,masterKey:a}),u=function(){function e(e){this.embedSettings=e}return e.prototype.createSavedQuery=function(e,t){var n=c.savedQueries();n.create(e,t,function(e,t){})},e.prototype.createDataset=function(e,t){var n="https://api.keen.io/3.0/projects/"+s+"/datasets/"+t.display_name;c.put(n).auth(a).send(t).then(function(e){}).catch(function(e){})},e.prototype.runQuery=function(e,t){c.query(e,t).then(function(e){}).catch(function(e){})},e.prototype.parseResultsForPolls=function(e){},e}();Object.defineProperty(t,"__esModule",{value:!0}),t.default=u},function(e,t,n){e.exports=n(280)},function(e,t,n){"use strict";function i(e){var t=new s(e),n=o(s.prototype.request,t);return r.extend(n,s.prototype,t),r.extend(n,t),n}var r=n(281),o=n(282),s=n(283),a=n(284),l=i(a);l.Axios=s,l.create=function(e){return i(r.merge(a,e))},l.Cancel=n(301),l.CancelToken=n(302),l.isCancel=n(298),l.all=function(e){return Promise.all(e)},l.spread=n(303),e.exports=l,e.exports.default=l},function(e,t,n){"use strict";function i(e){return"[object Array]"===C.call(e)}function r(e){return"[object ArrayBuffer]"===C.call(e)}function o(e){return"undefined"!=typeof FormData&&e instanceof FormData}function s(e){var t;return t="undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(e):e&&e.buffer&&e.buffer instanceof ArrayBuffer}function a(e){return"string"==typeof e}function l(e){return"number"==typeof e}function c(e){return"undefined"==typeof e}function u(e){return null!==e&&"object"==typeof e}function d(e){return"[object Date]"===C.call(e)}function p(e){return"[object File]"===C.call(e)}function h(e){return"[object Blob]"===C.call(e)}function m(e){return"[object Function]"===C.call(e)}function f(e){return u(e)&&m(e.pipe)}function g(e){return"undefined"!=typeof URLSearchParams&&e instanceof URLSearchParams}function b(e){return e.replace(/^\s*/,"").replace(/\s*$/,"")}function v(){return"undefined"!=typeof window&&"undefined"!=typeof document&&"function"==typeof document.createElement}function y(e,t){if(null!==e&&"undefined"!=typeof e)if("object"==typeof e||i(e)||(e=[e]),i(e))for(var n=0,r=e.length;n<r;n++)t.call(null,e[n],n,e);else for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t.call(null,e[o],o,e)}function S(){function e(e,n){"object"==typeof t[n]&&"object"==typeof e?t[n]=S(t[n],e):t[n]=e}for(var t={},n=0,i=arguments.length;n<i;n++)y(arguments[n],e);return t}function w(e,t,n){return y(t,function(t,i){n&&"function"==typeof t?e[i]=E(t,n):e[i]=t}),e}var E=n(282),C=Object.prototype.toString;e.exports={isArray:i,isArrayBuffer:r,isFormData:o,isArrayBufferView:s,isString:a,isNumber:l,isObject:u,isUndefined:c,isDate:d,isFile:p,isBlob:h,isFunction:m,isStream:f,isURLSearchParams:g,isStandardBrowserEnv:v,forEach:y,merge:S,extend:w,trim:b}},function(e,t){"use strict";e.exports=function(e,t){return function(){for(var n=new Array(arguments.length),i=0;i<n.length;i++)n[i]=arguments[i];return e.apply(t,n)}}},function(e,t,n){"use strict";function i(e){this.defaults=e,this.interceptors={request:new s,response:new s}}var r=n(284),o=n(281),s=n(295),a=n(296),l=n(299),c=n(300);i.prototype.request=function(e){"string"==typeof e&&(e=o.merge({url:arguments[0]},arguments[1])),e=o.merge(r,this.defaults,{method:"get"},e),e.baseURL&&!l(e.url)&&(e.url=c(e.baseURL,e.url));var t=[a,void 0],n=Promise.resolve(e);for(this.interceptors.request.forEach(function(e){t.unshift(e.fulfilled,e.rejected)}),this.interceptors.response.forEach(function(e){t.push(e.fulfilled,e.rejected)});t.length;)n=n.then(t.shift(),t.shift());return n},o.forEach(["delete","get","head"],function(e){i.prototype[e]=function(t,n){return this.request(o.merge(n||{},{method:e,url:t}))}}),o.forEach(["post","put","patch"],function(e){i.prototype[e]=function(t,n,i){return this.request(o.merge(i||{},{method:e,url:t,data:n}))}}),e.exports=i},function(e,t,n){(function(t){"use strict";function i(e,t){!o.isUndefined(e)&&o.isUndefined(e["Content-Type"])&&(e["Content-Type"]=t)}function r(){var e;return"undefined"!=typeof XMLHttpRequest?e=n(286):"undefined"!=typeof t&&(e=n(286)),e}var o=n(281),s=n(285),a=/^\)\]\}',?\n/,l={"Content-Type":"application/x-www-form-urlencoded"},c={adapter:r(),transformRequest:[function(e,t){return s(t,"Content-Type"),o.isFormData(e)||o.isArrayBuffer(e)||o.isStream(e)||o.isFile(e)||o.isBlob(e)?e:o.isArrayBufferView(e)?e.buffer:o.isURLSearchParams(e)?(i(t,"application/x-www-form-urlencoded;charset=utf-8"),e.toString()):o.isObject(e)?(i(t,"application/json;charset=utf-8"),JSON.stringify(e)):e}],transformResponse:[function(e){if("string"==typeof e){e=e.replace(a,"");try{e=JSON.parse(e)}catch(e){}}return e}],timeout:0,xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN",maxContentLength:-1,validateStatus:function(e){return e>=200&&e<300}};c.headers={common:{Accept:"application/json, text/plain, */*"}},o.forEach(["delete","get","head"],function(e){c.headers[e]={}}),o.forEach(["post","put","patch"],function(e){c.headers[e]=o.merge(l)}),e.exports=c}).call(t,n(140))},function(e,t,n){"use strict";var i=n(281);e.exports=function(e,t){i.forEach(e,function(n,i){i!==t&&i.toUpperCase()===t.toUpperCase()&&(e[t]=n,delete e[i])})}},function(e,t,n){"use strict";var i=n(281),r=n(287),o=n(290),s=n(291),a=n(292),l=n(288),c="undefined"!=typeof window&&window.btoa&&window.btoa.bind(window)||n(293);e.exports=function(e){return new Promise(function(t,u){var d=e.data,p=e.headers;i.isFormData(d)&&delete p["Content-Type"];var h=new XMLHttpRequest,m="onreadystatechange",f=!1;if("undefined"==typeof window||!window.XDomainRequest||"withCredentials"in h||a(e.url)||(h=new window.XDomainRequest,m="onload",f=!0,h.onprogress=function(){},h.ontimeout=function(){}),e.auth){var g=e.auth.username||"",b=e.auth.password||"";p.Authorization="Basic "+c(g+":"+b)}if(h.open(e.method.toUpperCase(),o(e.url,e.params,e.paramsSerializer),!0),h.timeout=e.timeout,h[m]=function(){if(h&&(4===h.readyState||f)&&(0!==h.status||h.responseURL&&0===h.responseURL.indexOf("file:"))){var n="getAllResponseHeaders"in h?s(h.getAllResponseHeaders()):null,i=e.responseType&&"text"!==e.responseType?h.response:h.responseText,o={data:i,status:1223===h.status?204:h.status,statusText:1223===h.status?"No Content":h.statusText,headers:n,config:e,request:h};r(t,u,o),h=null}},h.onerror=function(){u(l("Network Error",e)),h=null},h.ontimeout=function(){u(l("timeout of "+e.timeout+"ms exceeded",e,"ECONNABORTED")),h=null},i.isStandardBrowserEnv()){var v=n(294),y=(e.withCredentials||a(e.url))&&e.xsrfCookieName?v.read(e.xsrfCookieName):void 0;y&&(p[e.xsrfHeaderName]=y)}if("setRequestHeader"in h&&i.forEach(p,function(e,t){"undefined"==typeof d&&"content-type"===t.toLowerCase()?delete p[t]:h.setRequestHeader(t,e)}),e.withCredentials&&(h.withCredentials=!0),e.responseType)try{h.responseType=e.responseType}catch(e){if("json"!==h.responseType)throw e}"function"==typeof e.onDownloadProgress&&h.addEventListener("progress",e.onDownloadProgress),"function"==typeof e.onUploadProgress&&h.upload&&h.upload.addEventListener("progress",e.onUploadProgress),e.cancelToken&&e.cancelToken.promise.then(function(e){h&&(h.abort(),u(e),h=null)}),void 0===d&&(d=null),h.send(d)})}},function(e,t,n){"use strict";var i=n(288);e.exports=function(e,t,n){var r=n.config.validateStatus;n.status&&r&&!r(n.status)?t(i("Request failed with status code "+n.status,n.config,null,n)):e(n)}},function(e,t,n){"use strict";var i=n(289);e.exports=function(e,t,n,r){var o=new Error(e);return i(o,t,n,r)}},function(e,t){"use strict";e.exports=function(e,t,n,i){return e.config=t,n&&(e.code=n),e.response=i,e}},function(e,t,n){"use strict";function i(e){return encodeURIComponent(e).replace(/%40/gi,"@").replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,"+").replace(/%5B/gi,"[").replace(/%5D/gi,"]")}var r=n(281);e.exports=function(e,t,n){if(!t)return e;var o;if(n)o=n(t);else if(r.isURLSearchParams(t))o=t.toString();else{var s=[];r.forEach(t,function(e,t){null!==e&&"undefined"!=typeof e&&(r.isArray(e)&&(t+="[]"),r.isArray(e)||(e=[e]),r.forEach(e,function(e){r.isDate(e)?e=e.toISOString():r.isObject(e)&&(e=JSON.stringify(e)),s.push(i(t)+"="+i(e))}))}),o=s.join("&")}return o&&(e+=(e.indexOf("?")===-1?"?":"&")+o),e}},function(e,t,n){"use strict";var i=n(281);e.exports=function(e){var t,n,r,o={};return e?(i.forEach(e.split("\n"),function(e){r=e.indexOf(":"),t=i.trim(e.substr(0,r)).toLowerCase(),n=i.trim(e.substr(r+1)),t&&(o[t]=o[t]?o[t]+", "+n:n)}),o):o}},function(e,t,n){"use strict";var i=n(281);e.exports=i.isStandardBrowserEnv()?function(){function e(e){var t=e;return n&&(r.setAttribute("href",t),t=r.href),r.setAttribute("href",t),{href:r.href,protocol:r.protocol?r.protocol.replace(/:$/,""):"",host:r.host,search:r.search?r.search.replace(/^\?/,""):"",hash:r.hash?r.hash.replace(/^#/,""):"",hostname:r.hostname,port:r.port,pathname:"/"===r.pathname.charAt(0)?r.pathname:"/"+r.pathname}}var t,n=/(msie|trident)/i.test(navigator.userAgent),r=document.createElement("a");return t=e(window.location.href),function(n){var r=i.isString(n)?e(n):n;return r.protocol===t.protocol&&r.host===t.host}}():function(){return function(){return!0}}()},function(e,t){"use strict";function n(){this.message="String contains an invalid character"}function i(e){for(var t,i,o=String(e),s="",a=0,l=r;o.charAt(0|a)||(l="=",a%1);s+=l.charAt(63&t>>8-a%1*8)){if(i=o.charCodeAt(a+=.75),i>255)throw new n;t=t<<8|i}return s}var r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";n.prototype=new Error,n.prototype.code=5,n.prototype.name="InvalidCharacterError",e.exports=i},function(e,t,n){"use strict";var i=n(281);e.exports=i.isStandardBrowserEnv()?function(){return{write:function(e,t,n,r,o,s){var a=[];a.push(e+"="+encodeURIComponent(t)),i.isNumber(n)&&a.push("expires="+new Date(n).toGMTString()),i.isString(r)&&a.push("path="+r),i.isString(o)&&a.push("domain="+o),s===!0&&a.push("secure"),document.cookie=a.join("; ")},read:function(e){var t=document.cookie.match(new RegExp("(^|;\\s*)("+e+")=([^;]*)"));return t?decodeURIComponent(t[3]):null},remove:function(e){this.write(e,"",Date.now()-864e5)}}}():function(){return{write:function(){},read:function(){return null},remove:function(){}}}()},function(e,t,n){"use strict";function i(){this.handlers=[]}var r=n(281);i.prototype.use=function(e,t){return this.handlers.push({fulfilled:e,rejected:t}),this.handlers.length-1},i.prototype.eject=function(e){this.handlers[e]&&(this.handlers[e]=null)},i.prototype.forEach=function(e){r.forEach(this.handlers,function(t){null!==t&&e(t)})},e.exports=i},function(e,t,n){"use strict";function i(e){e.cancelToken&&e.cancelToken.throwIfRequested()}var r=n(281),o=n(297),s=n(298),a=n(284);e.exports=function(e){i(e),e.headers=e.headers||{},e.data=o(e.data,e.headers,e.transformRequest),e.headers=r.merge(e.headers.common||{},e.headers[e.method]||{},e.headers||{}),r.forEach(["delete","get","head","post","put","patch","common"],function(t){delete e.headers[t]});var t=e.adapter||a.adapter;return t(e).then(function(t){return i(e),t.data=o(t.data,t.headers,e.transformResponse),t},function(t){return s(t)||(i(e),t&&t.response&&(t.response.data=o(t.response.data,t.response.headers,e.transformResponse))),Promise.reject(t)})}},function(e,t,n){"use strict";var i=n(281);e.exports=function(e,t,n){return i.forEach(n,function(n){e=n(e,t)}),e}},function(e,t){"use strict";e.exports=function(e){return!(!e||!e.__CANCEL__)}},function(e,t){"use strict";e.exports=function(e){return/^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(e)}},function(e,t){"use strict";e.exports=function(e,t){return e.replace(/\/+$/,"")+"/"+t.replace(/^\/+/,"")}},function(e,t){"use strict";function n(e){this.message=e}n.prototype.toString=function(){return"Cancel"+(this.message?": "+this.message:"")},n.prototype.__CANCEL__=!0,e.exports=n},function(e,t,n){"use strict";function i(e){if("function"!=typeof e)throw new TypeError("executor must be a function.");var t;this.promise=new Promise(function(e){t=e});var n=this;e(function(e){n.reason||(n.reason=new r(e),t(n.reason))})}var r=n(301);i.prototype.throwIfRequested=function(){if(this.reason)throw this.reason},i.source=function(){var e,t=new i(function(t){e=t});return{token:t,cancel:e}},e.exports=i},function(e,t){"use strict";e.exports=function(e){return function(t){return e.apply(null,t)}}},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(206),s=function(e){function t(){e.call(this),this.state={navOptions:[]}}return i(t,e),t.prototype.componentDidMount=function(){this._setElementHideNavOnClick()},t.prototype.componentWillMount=function(){this.keenUtil=new o.default(this.props.embedSettings),this._optionCheck()},t.prototype._playGame=function(){},t.prototype._showOption=function(e){this.props.hideOptions(),this.props.embedOptions.showOptionScreen(e,"NAV")},t.prototype._optionCheck=function(){var e=this.context.embedSettings.colorPalette.mainColor;this._issueButton=r.createElement("li",{className:"leaderBoards ",onClick:this._showOption.bind(this,"issue")},r.createElement("div",{className:"top"},r.createElement("i",{className:"fa fa-exclamation-triangle option-icon","aria-hidden":"true"})),r.createElement("p",{className:"buttonTitle"},"REPORT")),1==this.context.embedSettings.embedSetting.showLeaderboard&&(this._leaderboardButton=r.createElement("li",{className:"leaderBoards ",onClick:this._showOption.bind(this,"leaderBoard")},r.createElement("div",{className:"top"},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M522 883q-74-162-74-371h-256v96q0 78 94.5 162t235.5 113zm1078-275v-96h-256q0 209-74 371 141-29 235.5-113t94.5-162zm128-128v128q0 71-41.5 143t-112 130-173 97.5-215.5 44.5q-42 54-95 95-38 34-52.5 72.5t-14.5 89.5q0 54 30.5 91t97.5 37q75 0 133.5 45.5t58.5 114.5v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-69 58.5-114.5t133.5-45.5q67 0 97.5-37t30.5-91q0-51-14.5-89.5t-52.5-72.5q-53-41-95-95-113-5-215.5-44.5t-173-97.5-112-130-41.5-143v-128q0-40 28-68t68-28h288v-96q0-66 47-113t113-47h576q66 0 113 47t47 113v96h288q40 0 68 28t28 68z",fill:e}))),r.createElement("p",{className:"buttonTitle"},"LEADERBOARD"))),1==this.context.embedSettings.embedSetting.showSocialShare&&(this._shareButton=r.createElement("li",{className:"versus ",onClick:this._showOption.bind(this,"share")},r.createElement("div",{className:"top"},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M1344 1024q133 0 226.5 93.5t93.5 226.5-93.5 226.5-226.5 93.5-226.5-93.5-93.5-226.5q0-12 2-34l-360-180q-92 86-218 86-133 0-226.5-93.5t-93.5-226.5 93.5-226.5 226.5-93.5q126 0 218 86l360-180q-2-22-2-34 0-133 93.5-226.5t226.5-93.5 226.5 93.5 93.5 226.5-93.5 226.5-226.5 93.5q-126 0-218-86l-360 180q2 22 2 34t-2 34l360 180q92-86 218-86z",fill:e}))),r.createElement("p",{className:"buttonTitle"},"SHARE"))),1==this.context.embedSettings.embedSetting.showChatting&&(this._chatButton=r.createElement("li",{className:"chat ",onClick:this._showOption.bind(this,"chat")},r.createElement("div",{className:"top"},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",
xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M1408 768q0 139-94 257t-256.5 186.5-353.5 68.5q-86 0-176-16-124 88-278 128-36 9-86 16h-3q-11 0-20.5-8t-11.5-21q-1-3-1-6.5t.5-6.5 2-6l2.5-5 3.5-5.5 4-5 4.5-5 4-4.5q5-6 23-25t26-29.5 22.5-29 25-38.5 20.5-44q-124-72-195-177t-71-224q0-139 94-257t256.5-186.5 353.5-68.5 353.5 68.5 256.5 186.5 94 257zm384 256q0 120-71 224.5t-195 176.5q10 24 20.5 44t25 38.5 22.5 29 26 29.5 23 25q1 1 4 4.5t4.5 5 4 5 3.5 5.5l2.5 5 2 6 .5 6.5-1 6.5q-3 14-13 22t-22 7q-50-7-86-16-154-40-278-128-90 16-176 16-271 0-472-132 58 4 88 4 161 0 309-45t264-129q125-92 192-212t67-254q0-77-23-152 129 71 204 178t75 230z",fill:e}))),r.createElement("p",{className:"buttonTitle"},"CHAT")))},t.prototype.showOptionsOnClick=function(){var e=this.props.embedSettings.embedSetting.showOverlay;e||this.props.embedSettings.refreshAds(),this.keenUtil.addClickEvent("NAV","SHOW NAV OPTIONS",null),this.props.embedOptions.optionActive?this.props.disableAllOptionScreens():this.props.showOptions()},t.prototype.addKeenClickEvt=function(){this.props.embedSettings.logger("addKeenClickEvt called"),this.keenUtil.addClickEvent("LINK","INSTICATOR",null)},t.prototype.render=function(){var e="options ",t="";this.props.embedOptions.optionActive===!0?t="activate":this.props.showOptionsStatus&&(e+="activate",t="activate options-activated");var n={};this.context.embedSettings.embedSetting.showAdOnShortWidget&&(n.display="none");var i=null;return this.props.embedSettings.embedSetting.linkToInsticator&&(i=r.createElement("a",{href:"https://www.insticator.com?utm_campaign=%22Create%20Your%20Own%20At%20Insticator%22%20Link&utm_source=Create%20Your%20Own%20At%20Insticator%20Link",target:"_blank",tabIndex:-1,onClick:this.addKeenClickEvt.bind(this)},r.createElement("footer",{id:"poweredByInSlider"},r.createElement("p",null,"Create your own at"),r.createElement("img",{className:"logo",src:"https://d2na2p72vtqyok.cloudfront.net/files/images/insticator_logo_white.png"})))),r.createElement("nav",{id:"widgetNav",style:n},r.createElement("div",{id:"hamburger",className:" tri-menu "+t,onClick:this.showOptionsOnClick.bind(this)},r.createElement("div",{className:"menu-bt-container"},r.createElement("div",{className:"menu-line menu-line-01"}),r.createElement("div",{className:"menu-line menu-line-02"}),r.createElement("div",{className:"menu-line menu-line-03"}))),r.createElement("div",{className:e},r.createElement("ul",{className:"optionListContainer"},this._leaderboardButton,this._shareButton,this._chatButton),i))},t.prototype._setElementHideNavOnClick=function(){},t.prototype._getNavOptions=function(){var e=this.props.options,t=[],n=0,i=this,o=function(o){n++;var s=o.replace(/_/g," "),a=function(){i.props.showOptions(),e[o]()};t.push(r.createElement("li",{className:"",onClick:a,key:n},s))};for(var s in e)o(s);this.setState({navOptions:t})},t.contextTypes={embedSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(306),s=n(277),a=function(e){function t(){e.call(this),this.specialLeaderboardClass="",this.specialLeaderboardStyle={},this._leaderboardInfoFetched=!1,this.state={playerRanks:"",topRank:"",resultsReceived:!1}}return i(t,e),t.prototype.componentWillMount=function(){this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled?this.specialLeaderboardClass="specialLeaderboardClass":this.context.embedSettings.embedSetting.showAdOnShortWidget&&(this.specialLeaderboardStyle.height="105px")},t.prototype.componentDidMount=function(){},t.prototype.initLeaderboard=function(){var e=this;if(this._globalLeaderBoardResults=window[this.props.leaderboardResult],null==this._globalLeaderBoardResults){var t=r.createElement("div",{className:"uil-squares-css",style:{transform:"scale(0.9)",margin:"0 auto 0 auto"}},r.createElement("div",null,r.createElement("div",null)),r.createElement("div",null,r.createElement("div",null)),r.createElement("div",null,r.createElement("div",null)),r.createElement("div",null,r.createElement("div",null)),r.createElement("div",null,r.createElement("div",null)),r.createElement("div",null,r.createElement("div",null)),r.createElement("div",null,r.createElement("div",null)),r.createElement("div",null,r.createElement("div",null)));this.setState({playerRanks:t}),this._leaderBoardResultsTimer=setInterval(function(){return e._leaderBoardResultsCheck()},200)}else{var n=this._globalLeaderBoardResults,i=this._parseLeaderBoardData(n);this.setState({resultsReceived:!0,playerRanks:i,topRank:i[0]})}},t.prototype.componentWillUnmount=function(){clearInterval(this._leaderBoardResultsTimer)},t.prototype._leaderBoardResultsCheck=function(){if(this._globalLeaderBoardResults=this.context.embedSettings.parentWindow[this.props.leaderboardResult],null!==this._globalLeaderBoardResults){var e=this._globalLeaderBoardResults,t=this._parseLeaderBoardData(e);this.setState({resultsReceived:!0,playerRanks:t}),clearInterval(this._leaderBoardResultsTimer),delete window[this.props.leaderboardResult]}},t.prototype._parseLeaderBoardData=function(e){for(var t=e,n=[],i=0;i<t.length;i++){var o=(t[i].userPoints%6,new s.default(this.context.embedSettings)),a=o.generateRandomImgURL(),l={backgroundImage:"url("+a+")"},c="",u=i+1;switch(u){case 1:c="st";break;case 2:c="nd";break;case 3:c="rd";break;default:c="th"}var d=r.createElement("div",{key:i,className:"userBox"},r.createElement("div",{className:"userPlace"},r.createElement("span",null,u,c)),r.createElement("div",{className:"userImg",style:l}),r.createElement("div",{className:"userPoints"},r.createElement("p",{className:"pointsText"},t[i].userPoints),r.createElement("p",{className:"pointsText"},"POINTS")));n.push(d)}return n},t.prototype.render=function(){this.props.embedController.getLeaderboardInfoFetched()&&!this._leaderboardInfoFetched&&(this.initLeaderboard(),this._leaderboardInfoFetched=!0);var e="";this.props.showLeaderBoard&&(e="slideInLeft");var t,n;this.state.resultsReceived?(t=this.state.playerRanks.slice(1,-1),n=this.state.playerRanks[0]):t=r.createElement("div",null,this.state.playerRanks);var i=(r.createElement("div",{className:"logo-container"},r.createElement("div",{id:"insticatorLogo",className:"insticator-logo"},r.createElement("div",{className:"left-logo-container"},r.createElement("div",{className:"top-container"},r.createElement("div",{className:"left-line"}),r.createElement("div",{className:"right-line"})),r.createElement("div",{className:"middle-container"},r.createElement("div",{className:"left-line"}),r.createElement("div",{className:"right-line"})),r.createElement("div",{className:"bottom-container"},r.createElement("div",{className:"left-line"}),r.createElement("div",{className:"right-line"}))),r.createElement("div",{className:"right-logo-container"},r.createElement("div",{className:"bar"})))),r.createElement(o.default,{embedSettings:this.context.embedSettings}));return r.createElement("div",{id:"leaderBoardSlider",className:"leaderBoardSlider "+e},r.createElement("div",{className:"topContainer"},r.createElement("div",{className:"mainTextContainer"},r.createElement("h2",null,"LEADERBOARD"))),r.createElement("div",{className:"leader-container"},n),r.createElement("div",{className:"mainContainer "+this.specialLeaderboardClass,style:this.specialLeaderboardStyle},t),i)},t.contextTypes={embedSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=a},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(206),s=function(e){function t(){e.call(this)}return i(t,e),t.prototype.componentWillMount=function(){this.keenUtil=new o.default(this.props.embedSettings)},t.prototype.addKeenClickEvt=function(){this.props.embedSettings.logger("addKeenClickEvt called");var e=this.context.embedSettings.document.getElementById("poweredBy").querySelector("p").innerHTML;this.keenUtil.addClickEvent("LINK","INSTICATOR",e)},t.prototype.render=function(){var e=null;return this.props.embedSettings.embedSetting.linkToInsticator&&(e=r.createElement("a",{href:"https://www.insticator.com?utm_campaign=%22Create%20Your%20Own%20At%20Insticator%22%20Link&utm_source=Create%20Your%20Own%20At%20Insticator%20Link",target:"_blank",tabIndex:-1,onClick:this.addKeenClickEvt.bind(this)},r.createElement("footer",{id:"poweredBy"},r.createElement("p",null,"Create your own at"),r.createElement("img",{className:"logo",src:"https://d2na2p72vtqyok.cloudfront.net/files/images/insticator_logo.png"})))),e},t.contextTypes={embedSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(306),s=n(206),a="AIzaSyCN56ZDQijRe_WdRyjFtSQZAGKS67gnGdo",l=function(e){function t(){e.call(this),this.specialIconSize={},this._firstRender=!1,this.state={shortURL:""}}return i(t,e),t.prototype.componentWillMount=function(){this.keenUtil=new s.default(this.context.embedSettings),this.companyLogoEnabled=this.context.embedSettings.embedSetting.showHeaderLogo,this.companyLogoEnabled?this.specialIconSize={fontSize:"76px"}:this.context.embedSettings.embedSetting.showAdOnShortWidget&&(this.specialIconSize={fontSize:"56px"})},t.prototype.componentWillReceiveProps=function(e){},t.prototype.getShortURL=function(e){var t="https://www.googleapis.com/urlshortener/v1/url?key="+a,n=new XMLHttpRequest;n.onreadystatechange=function(){if(n.readyState==XMLHttpRequest.DONE&&200==n.status){var e=JSON.parse(n.responseText);this.setState({shortURL:e.id})}}.bind(this);var i={longUrl:e},r=JSON.stringify(i);n.open("POST",t,!0),n.setRequestHeader("Content-Type","application/json; charset=utf-8"),n.send(r)},t.prototype.shareBtnClicked=function(e){this.addKeenEvent(e);var t=this.context.embedSettings.embedSetting.showOverlay;t||this.context.embedSettings.refreshAds()},t.prototype.addKeenEvent=function(e){switch(e){case"twitter":this.keenUtil.addClickEvent("SHARE","TWITTER","");break;case"linkedin":this.keenUtil.addClickEvent("SHARE","LINKEDIN","");break;case"facebook":this.keenUtil.addClickEvent("SHARE","FACEBOOK","")}},t.prototype.render=function(){var e=r.createElement(o.default,{embedSettings:this.context.embedSettings});if(this.props.embedController.getFirstShareRender()===!0&&this._firstRender===!1){this._firstRender=!0;var t=window.location.href;this.getShortURL(t)}var n="";n=this.props.showShareScreen?"slideInLeft":"slideOutRight";var i=window.location.href,s="https://www.facebook.com/sharer/sharer.php?u="+this.state.shortURL,a="Think you can beat my score on the @insticator_inc widget? Take on the challenge yourself! "+this.state.shortURL;a=a.replace(/\s/g,"%20");var l="https://www.linkedin.com/shareArticle?mini=true&",c="url="+i,u="Insticator Widget",d="",p="Advertising Made Awesome. Engagement Made Easy. "+this.state.shortURL;u="&title="+u.replace(/\s/g,"%20"),p="&summary="+p.replace(/\s/g,"%20"),d="&source="+d.replace(/\s/g,"%20");var h=l+c+u+p+d,m=this.context.embedSettings.colorPalette.mainColor;return r.createElement("div",{className:"shareScreenSlider "+n},r.createElement("script",{id:"facebook-jssdk"}),r.createElement("script",{src:"//platform.linkedin.com/in.js",type:"text/javascript"}),r.createElement("script",{type:"IN/Share","data-url":"www.google.com"}),r.createElement("div",{className:"top-container"},r.createElement("h2",{className:"shareTitle"},"SHARE")),r.createElement("div",{className:"shareContainer"},r.createElement("div",{className:"btnContainer"},r.createElement("div",{className:"socialBtn",onClick:this.shareBtnClicked.bind(this,"twitter")},r.createElement("a",{tabIndex:-1,href:"https://twitter.com/intent/tweet?text="+a,"data-size":"large",target:"_blank"},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M1408 610q-56 25-121 34 68-40 93-117-65 38-134 51-61-66-153-66-87 0-148.5 61.5t-61.5 148.5q0 29 5 48-129-7-242-65t-192-155q-29 50-29 106 0 114 91 175-47-1-100-26v2q0 75 50 133.5t123 72.5q-29 8-51 8-13 0-39-4 21 63 74.5 104t121.5 42q-116 90-261 90-26 0-50-3 148 94 322 94 112 0 210-35.5t168-95 120.5-137 75-162 24.5-168.5q0-18-1-27 63-45 105-109zm256-194v960q0 119-84.5 203.5t-203.5 84.5h-960q-119 0-203.5-84.5t-84.5-203.5v-960q0-119 84.5-203.5t203.5-84.5h960q119 0 203.5 84.5t84.5 203.5z",fill:m})))),r.createElement("div",{className:"socialBtn",onClick:this.shareBtnClicked.bind(this,"facebook")},r.createElement("a",{tabIndex:-1,href:s,target:"_blank"},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M1376 128q119 0 203.5 84.5t84.5 203.5v960q0 119-84.5 203.5t-203.5 84.5h-188v-595h199l30-232h-229v-148q0-56 23.5-84t91.5-28l122-1v-207q-63-9-178-9-136 0-217.5 80t-81.5 226v171h-200v232h200v595h-532q-119 0-203.5-84.5t-84.5-203.5v-960q0-119 84.5-203.5t203.5-84.5h960z",fill:m})))),r.createElement("div",{className:"socialBtn",onClick:this.shareBtnClicked.bind(this,"linkedin")},r.createElement("a",{tabIndex:-1,href:h,target:"_blank"},r.createElement("svg",{width:"100%",height:"100%",viewBox:"0 0 1792 1792",xmlns:"http://www.w3.org/2000/svg"},r.createElement("path",{d:"M365 1414h231v-694h-231v694zm246-908q-1-52-36-86t-93-34-94.5 34-36.5 86q0 51 35.5 85.5t92.5 34.5h1q59 0 95-34.5t36-85.5zm585 908h231v-398q0-154-73-233t-193-79q-136 0-209 117h2v-101h-231q3 66 0 694h231v-388q0-38 7-56 15-35 45-59.5t74-24.5q116 0 116 157v371zm468-998v960q0 119-84.5 203.5t-203.5 84.5h-960q-119 0-203.5-84.5t-84.5-203.5v-960q0-119 84.5-203.5t203.5-84.5h960q119 0 203.5 84.5t84.5 203.5z",fill:m})))),r.createElement("div",{tabIndex:-1,className:"slogan-container"},r.createElement("p",null,r.createElement("span",null,"Share your experience"))))),e)},t.contextTypes={embedSettings:r.PropTypes.object.isRequired},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=l},function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=n(201),s=function(e){function t(){e.call(this),this.state={name:"",email:"",issue:"",displayFailure:!1,displaySuccess:!1}}return i(t,e),t.prototype.handleChange=function(e,t){switch(e){case"name":this.setState({name:t.target.value});break;case"email":this.setState({email:t.target.value});break;case"issue":this.setState({issue:t.target.value})}},t.prototype.renderDropdown=function(){var e=["Widget is slow","Widget is cut off","Questions are not loading","Other"],t=e.map(function(e,t){return r.createElement("option",{key:t,value:e,className:"issue-item"},e)});return t},t.prototype.encodeQueryData=function(e){var t=[];for(var n in e)t.push(encodeURIComponent(n)+"="+encodeURIComponent(e[n]));return t.join("&")},t.prototype.submitForm=function(){var e=this.props.embedSettings.document.getElementById("issueDropdown"),t=this.props.embedSettings.siteUUID,n=this.props.embedSettings.embedUUID,i=window.top.location,r=e.options[e.selectedIndex].value,s=this.props.embedSettings.document.getElementById("emailID").value,a=this.props.embedSettings.document.getElementById("issueDesc").value,l=this.props.embedSettings.parentWindow.document.getElementsByTagName("head")[0],c=this.props.embedSettings.parentWindow.document.createElement("script"),u={siteUUID:t,embedUUID:n,siteURL:i,issue:r,description:a,emailId:s},d=this.encodeQueryData(u),p=o.apiBaseUrl+"/embeds/sendfirewidgetissueemail",h=p+"?"+d;c.src=h,l.appendChild(c);var m=new XMLHttpRequest;m.onreadystatechange=function(){if(m.readyState==XMLHttpRequest.DONE)if(200==m.status){JSON.parse(m.responseText);this.setState({displaySuccess:!0,displayFailure:!1})}else this.setState({displaySuccess:!1,displayFailure:!0})}.bind(this);var f=JSON.stringify(u);m.open("POST",p,!0),m.setRequestHeader("Content-Type","application/json; charset=utf-8"),m.send(f)},t.prototype.render=function(){var e="";this.props.showIssueReport&&(e="slideInLeft");var t=this.renderDropdown(),n="",i=r.createElement("div",{id:"successMsg",className:"submit-msg "+n},"Thank you for your feedback!"),o=r.createElement("div",{id:"failMsg",className:"submit-msg "+n},"Oops... something went wrong.");return r.createElement("div",null,r.createElement("div",{id:"issueReportSlider",className:"issueReportSlider "+e},i,o,r.createElement("div",{className:"title"},r.createElement("h2",null,"REPORT ",r.createElement("br",null),"AN ISSUE")),r.createElement("select",{id:"issueDropdown",className:"input-field issue",required:!0},r.createElement("option",{disabled:!0,selected:!0},"Select an issue"),t),r.createElement("input",{id:"emailID",value:this.state.email,onChange:this.handleChange.bind(this,"email"),className:"input-field email",placeholder:"Email-id (optional)"}),r.createElement("textarea",{id:"issueDesc",value:this.state.issue,onChange:this.handleChange.bind(this,"issue"),className:"input-field text-field",placeholder:"Issue"}),r.createElement("button",{className:"submit-btn",onClick:this.submitForm.bind(this)},"Submit")))},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=s},function(e,t){},,function(e,t,n){"use strict";var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},r=n(28),o=function(e){function t(t){e.call(this),this.primaryColor=t,this.secondaryColor="#ffffff",this.styles='/*@font-face {font-family: Gotham Rounded;src: url("/font/GothamRounded-Medium.otf") format("opentype");src: url("/font/GothamRounded-Book.otf") format("opentype");}*/html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,',this.styles+="dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video {margin: 0;padding: 0;border: 0;font-size: 100%;font: inherit;vertical-align: baseline;}/* HTML5 display-role reset for older browsers */article,aside,details,figcaption,figure,",this.styles+='footer,header,hgroup,menu,nav,section {display: block;}body {line-height: 1;}ol,ul {list-style: none;}blockquote,q {quotes: none;}blockquote:before,blockquote:after,q:before,q:after {content: "";content: none;}table {border-collapse: collapse;border-spacing: 0;}html,body {width: 100%;height: 100%;font-family: "Montserrat", "Geomanist", "Roboto", "Helvetica", sans-serif;margin: 0;padding: 0;font-size: 10px;}#insticator-embed-app.isContest #companyLogo {display: none;}#insticator-embed-app.isContest #insticatorEmbed {height: 100% !important;}#insticator-embed-app.isContest #insticatorEmbed #widgetNav,#insticator-embed-app.isContest #insticatorEmbed #leaderBoardSlider,#insticator-embed-app.isContest #insticatorEmbed .shareScreenSlider,#insticator-embed-app.isContest #insticatorEmbed #poweredBy {display: none;',this.styles+='}#insticator-embed-app.isContest.isEntered #is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown,#insticator-embed-app.isContest.isEntered #is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-cta {opacity: 0;pointer-events: none;}#insticator-embed-app.isContest.hasCountdown #is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-copy {margin-top: 0.33333333em;}#is-wg-contest {font-family: "Source Sans Pro", sans-serif;font-size: 16px;height: 100%;width: 100%;position: relative;text-align: center;}#is-wg-contest #is-wg-wrapper {height: 100%;width: 100%;position: relative;}#is-wg-contest #is-wg-wrapper #is-wg-content {width: 100%;height: 100%;position: relative;z-index: 2;}#is-wg-contest #is-wg-wrapper #is-wg-content h1,#is-wg-contest #is-wg-wrapper #is-wg-content h2,#is-wg-contest #is-wg-wrapper #is-wg-content h3,#is-wg-contest #is-wg-wrapper #is-wg-content h4,#is-wg-contest #is-wg-wrapper #is-wg-content h5,#is-wg-contest #is-wg-wrapper #is-wg-content p,#is-wg-contest #is-wg-wrapper #is-wg-content li,#is-wg-contest #is-wg-wrapper #is-wg-content a {color: inherit;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-logo {padding-top: 0.34375em;padding-left: 0.4375em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-logo #is-wg-company {background-repeat: no-repeat;background-size: contain;background-position: 0% 50%;width: 8.875em;height: 1.5625em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown {',this.styles+='margin-top: 0.33333333em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer {font-size: 1.875em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-day,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-hour,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-minute,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-second {display: inline-block;vertical-align: top;position: relative;padding-right: 0.275em;margin-right: 0.475em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-day:before,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-hour:before,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-minute:before,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-second:before {content: ":";position: absolute;top: -0.05em;right: -0.2em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-day:after,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-hour:after,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-minute:after,#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-second:after {display: block;font-size: 0.3em;text-transform: capitalize;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-day {padding-left: 0.375em;margin-left: 0.375em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-day:after {content: "days";}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-hour:after {content: "hours";}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-minute:after {content: "minutes";}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-second:before {display: none;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-countdown .react-cntdwn-timer .react-cntdwn-second:after {content: "seconds";',this.styles+="}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-copy {display: table;margin-top: 3.025em;margin-left: auto;margin-right: auto;line-height: 1.875em;height: 50%;width: 85%;overflow: hidden;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-copy #is-wg-text {display: table-cell;vertical-align: middle;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-copy #is-wg-text h2 {font-size: 1.875em;font-weight: normal;line-height: 1.3;text-transform: capitalize;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-cta {margin-top: 0.625em;margin-left: auto;margin-right: auto;cursor: pointer;width: 10.375em;height: 2.1875em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-cta iframe {width: 100%;height: 100%;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-legal {margin-top: 0.625em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-legal p {font-size: 0.625em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-skip {position: absolute;bottom: 0.625em;right: 0.625em;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-skip p {font-size: 0.75em;}#is-wg-contest #is-wg-wrapper #is-wg-bg {overflow: hidden;height: 100%;",this.styles+="width: 100%;position: absolute;top: 0;left: 0;z-index: 1;}#is-wg-contest #is-wg-wrapper #is-wg-bg img {width: 100%;/*height: 100%;*/height: auto;/*position: relative;*/position: absolute;top: 50%;left: 50%;-webkit-transform: translate(-50%, -50%);-moz-transform: translate(-50%, -50%);-ms-transform: translate(-50%, -50%);-o-transform: translate(-50%, -50%);z-index: 1;}#is-wg-contest #is-wg-wrapper #is-wg-bg #is-wg-overlay {opacity: .5;height: 100%;width: 100%;position: absolute;top: 0;left: 0;z-index: 2;}@media only screen and (min-width: 500px) {#is-wg-contest #is-wg-wrapper {font-size: 120%;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-copy {height: 41%;width: 75%;}#is-wg-contest #is-wg-wrapper #is-wg-bg img {top: 0%;width: 150%;}}@media only screen and (min-width: 295px) and (max-height: 336px) {#is-wg-contest #is-wg-wrapper {font-size: 85%;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-copy {font-size: 90%;height: 40%;}",this.styles+='}@media only screen and (max-width: 294px) {#is-wg-contest #is-wg-wrapper {font-size: 85%;}#is-wg-contest #is-wg-wrapper #is-wg-content #is-wg-copy {font-size: 90%;width: 95%;}#is-wg-contest #is-wg-wrapper #is-wg-bg img {width: 200%;}}#is-wg-ad-show {font-family: "Source Sans Pro", sans-serif;font-size: 16px;height: 100%;width: 100%;position: relative;background-color: #000000;opacity: 0.8;}@media (max-height: 250px) {#insticator-embed-app.isOverlayAd #insticatorEmbed #poweredBy {display: none;}}#is-market-research-screen {font-family: "Source Sans Pro", sans-serif;font-size: 14px;height: 100%;width: 100%;position: relative;}#is-market-research-screen.is-market-research-mobile {-webkit-overflow-scrolling: touch;overflow-y: scroll;}#is-market-research-screen #is-market-research-info-screen {box-sizing: border-box;height: 100%;width: 100%;background-color: '+this.primaryColor+";color: #ffffff;text-align: center;padding-top: 4em;}#is-market-research-screen #is-market-research-info-screen #no-survey {margin: 3em 1em;}",this.styles+="@media screen and (max-height: 250px) {#is-market-research-screen #is-market-research-info-screen #no-survey {margin: 2em 1em;}}@media screen and (min-width: 500px) {#is-market-research-screen #is-market-research-info-screen #no-survey {margin: 4em 1em;}}@media screen and (max-height: 250px) {#is-market-research-screen #is-market-research-info-screen {padding-top: 2em;}}#is-market-research-screen #is-market-research-info-screen h1,#is-market-research-screen #is-market-research-info-screen h2,#is-market-research-screen #is-market-research-info-screen h3,#is-market-research-screen #is-market-research-info-screen p {color: #ffffff;font-size: 1.9em;}#is-market-research-screen #is-market-research-info-screen h2 {font-size: 1.9em;margin: 10% 4%;}@media screen and (max-height: 250px) {#is-market-research-screen #is-market-research-info-screen h2 {margin: 1em 4%;}}#is-market-research-screen #is-market-research-info-screen h3 {font-size: 1.25em;text-align: right;padding: 2em 1em;}@media screen and (max-height: 250px) {#is-market-research-screen #is-market-research-info-screen h3 {padding: 0 8%;}}@media screen and (min-width: 500px) {#is-market-research-screen #is-market-research-info-screen h3 {padding: 0 2em;}}#is-market-research-screen #is-market-research-info-screen .survay-bttn {border: 3px solid #ffffff;width: 60%;text-align: center;",this.styles+='margin: 3.5em auto 0px;}#is-market-research-screen #is-market-research-info-screen .survay-bttn:hover {cursor: pointer;}#is-market-research-screen #is-market-research-info-screen .survay-bttn p:hover {cursor: pointer;}@media screen and (max-height: 250px) {#is-market-research-screen #is-market-research-info-screen .survay-bttn {margin: 0 auto;}}#is-market-research-screen #is-market-research-info-screen .loader,#is-market-research-screen #is-market-research-info-screen .loader:before,#is-market-research-screen #is-market-research-info-screen .loader:after {background: #ffffff;-webkit-animation: load1 1s infinite ease-in-out;animation: load1 1s infinite ease-in-out;width: 1em;height: 4em;}#is-market-research-screen #is-market-research-info-screen .loader {color: #ffffff;text-indent: -9999em;margin: 88px auto;position: relative;font-size: 11px;-webkit-transform: translateZ(0);-ms-transform: translateZ(0);transform: translateZ(0);-webkit-animation-delay: -0.16s;animation-delay: -0.16s;}#is-market-research-screen #is-market-research-info-screen .loader:before,#is-market-research-screen #is-market-research-info-screen .loader:after {position: absolute;top: 0;content: "";}#is-market-research-screen #is-market-research-info-screen .loader:before {left: -1.5em;-webkit-animation-delay: -0.32s;animation-delay: -0.32s;}#is-market-research-screen #is-market-research-info-screen .loader:after {left: 1.5em;}@-webkit-keyframes load1 {0%,',this.styles+="80%,100% {box-shadow: 0 0;height: 4em;}40% {box-shadow: 0 -2em;height: 5em;}}@keyframes load1 {0%,80%,100% {box-shadow: 0 0;height: 4em;}40% {box-shadow: 0 -2em;height: 5em;}}#is-market-research-screen #is-market-research-main-screen {width: 100%;height: 100%;}#is-market-research-screen #is-market-research-main-screen #survey-enter {width: 100%;height: 100%;overflow-y: scroll;}#is-market-research-screen #is-market-research-main-screen .is-market-research-main-screen-wrapper.wrapper-hidden {display: none;}#companyLogo {position: relative;height: 45px;background: "+this.primaryColor+";}#companyLogo .company-logo {position: absolute;top: 0;left: 0;right: 0;margin: 0 auto;height: 45px;width: 80%;border-radius: 0.8em;overflow: hidden;background-repeat: no-repeat;",this.styles+="background-size: contain;background-position: center;}#insticatorEmbed {width: 100%;height: 100%;margin: 0;background-color: #ffffff;position: relative;top: 0%;left: 0%;overflow: hidden;}#insticatorEmbed .invisible {opacity: 0;visibility: hidden;height: 0;}#insticatorEmbed .hidden {display: none;opacity: 0;visibility: hidden;}#insticatorEmbed .counter {height: 4px;}#insticatorEmbed .hideCounter {height: 0;visibility: hidden;}#insticatorEmbed .noLeftMargin {margin-left: 0px !important;}#insticatorEmbed .noRightMargin {margin-right: 0px !important;}#insticatorEmbed h1 {font-size: 2.3em;font-weight: 700;color: "+this.primaryColor+";line-height: 1.15em;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;cursor: default;}#insticatorEmbed h2 {",this.styles+="font-weight: 700;line-height: 1.15em;color: "+this.primaryColor+";font-size: 2.7em;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;cursor: default;}#insticatorEmbed h3 {color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";font-size: 1.3em;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;cursor: default;}#insticatorEmbed p {line-height: 1.3em;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;cursor: default;}#insticatorEmbed a {text-decoration: none;}#insticatorEmbed a:link,#insticatorEmbed a:hover,#insticatorEmbed a:active {text-decoration: none;}#insticatorEmbed nav {display: table;}#insticatorEmbed nav .tri-menu {position: absolute;top: calc(-18px);right: calc(-18px);width: 90px;height: 90px;",
this.styles+="background-color: "+this.primaryColor+";z-index: 1000000000000000;transform: rotateZ(45deg) translateY(-50%);-webkit-transform: rotateZ(45deg) translateY(-50%);transition: all 0s ease;-webkit-transition: all 0s ease;cursor: pointer;}#insticatorEmbed nav .tri-menu .menu-bt-container {position: absolute;top: 0;left: 0;width: calc(35px);height: calc(35px);padding: calc(6.54545455px);z-index: 100;transition: all 0s ease;-webkit-transition: all 0s ease;transform-origin: 100% 100%;-webkit-transform-origin: 100% 100%;transform: scale(0.9) rotateZ(-45deg) translate3d(0, 87%, 0);-webkit-transform: scale(0.9) rotateZ(-45deg) translate3d(0, 87%, 0);}#insticatorEmbed nav .tri-menu .menu-bt-container .menu-line {position: relative;display: block;margin: calc(6px) 0em;top: 0;left: 35%;width: 70%;height: 3px;background-color: #f2f2f2;transition: all 0s ease;-webkit-transition: all 0.6s ease;}#insticatorEmbed nav .tri-menu .menu-bt-container .menu-line.menu-line-01 {width: 60%;left: 30%;}#insticatorEmbed nav .tri-menu .menu-bt-container .menu-line.menu-line-02 {width: 70%;left: 20%;}#insticatorEmbed nav .tri-menu .menu-bt-container .menu-line.menu-line-03 {width: 50%;left: 40%;}#insticatorEmbed nav .tri-menu.options-activated {background: #ffffff;}",this.styles+="#insticatorEmbed nav .tri-menu.options-activated .menu-line-01,#insticatorEmbed nav .tri-menu.options-activated .menu-line-02,#insticatorEmbed nav .tri-menu.options-activated .menu-line-03 {background-color: "+this.primaryColor+";}#insticatorEmbed nav .tri-menu.activate .menu-line-01,#insticatorEmbed nav .tri-menu.activate .menu-line-02,#insticatorEmbed nav .tri-menu.activate .menu-line-03 {width: 40% !important;left: 40% !important;}#insticatorEmbed nav .tri-menu.activate .menu-line-01 {-ms-transform: translate(0px, 9px) rotate(-45deg);-webkit-transform: translate(0px, 9px) rotate(-45deg);transform: translate(0px, 9px) rotate(-45deg);transition: all 0.6s ease;}#insticatorEmbed nav .tri-menu.activate .menu-line-03 {-ms-transform: translate(0px, -9px) rotate(-45deg);-webkit-transform: translate(0px, -9px) rotate(-45deg);transform: translate(0px, -9px) rotate(-45deg);transition: all 0.6s ease;}#insticatorEmbed nav .tri-menu.activate .menu-line-02 {-ms-transform: rotate(45deg);/* IE 9 */-webkit-transform: rotate(45deg);/* Safari */transform: rotate(45deg);transition: all 0.6s ease;}#insticatorEmbed nav .options {padding: 1.5em;position: absolute;width: 100%;height: 100%;top: -1000px;left: 0;z-index: 100;background-color: "+this.primaryColor+";-webkit-transition: all 0.6s ease-in-out;-moz-transition: all 0.6s ease-in-out;-o-transition: all 0.6s ease-in-out;transition: all 0.6s ease-in-out;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;}#insticatorEmbed nav .options .optionListContainer {height: 100%;",this.styles+="display: flex;justify-content: center;flex-flow: wrap;width: 100%;}#insticatorEmbed nav .options li {align-self: center;width: 23%;margin: 0 8% 0 8%;display: inline-block;vertical-align: middle;text-align: center;}#insticatorEmbed nav .options li.leaderBoards .top,#insticatorEmbed nav .options li.versus .top,#insticatorEmbed nav .options li.vsMode .top,#insticatorEmbed nav .options li.chat .top,#insticatorEmbed nav .options li.share .top {display: flex;justify-content: center;width: 100%;height: 80px;width: 100px;margin: 0 auto;background: #ededef;height: 30%;margin: 0 auto 0 auto;border-radius: 1em;overflow: hidden;cursor: pointer;}#insticatorEmbed nav .options li.leaderBoards .buttonTitle,#insticatorEmbed nav .options li.versus .buttonTitle,#insticatorEmbed nav .options li.vsMode .buttonTitle,#insticatorEmbed nav .options li.chat .buttonTitle,#insticatorEmbed nav .options li.share .buttonTitle {margin-top: 5px;width: 100%;color: #ffffff;font-weight: 300;font-size: 1em;}#insticatorEmbed nav .options .option-icon {align-self: center;color: "+this.primaryColor+";font-size: 60px;}#insticatorEmbed nav .options.activate {-ms-transform: translateY(1000px);/* IE 9 */",this.styles+="-webkit-transform: translateY(1000px);/* Safari */transform: translateY(1000px);}@media (min-width: 1px) and (max-width: 299px) {#insticatorEmbed nav .options {padding: 0 !important;}#insticatorEmbed nav .options .top-container {display: block;width: 100%;height: 10%;margin: 0;padding: 0;}#insticatorEmbed nav .options .top-container p {float: left;color: #ffffff;font-size: 20px;font-weight: 500;}#insticatorEmbed nav .options .optionListContainer {display: flex;flex-direction: column;}#insticatorEmbed nav .options li {display: block;width: 46%;margin-bottom: 16px;}#insticatorEmbed nav .options li .top {height: 60px !important;width: 70px !important;}}@media (min-width: 299px) and (max-width: 430px) {#insticatorEmbed nav .options .top-container {display: block;width: 100%;height: 10%;margin: 0;padding: 0;text-align: center;}#insticatorEmbed nav .options .top-container p {color: #ffffff;font-size: 20px;font-weight: 500;}#insticatorEmbed nav .options li {",this.styles+="margin: 0 5% 0 5%;}}@media (min-width: 430px) {#insticatorEmbed nav .options li {width: 16%;}}#insticatorEmbed .time-bar {margin-bottom: 5px;height: 5px;width: 100%;position: relative;overflow: hidden;/* this is used so that overflow only shows the inner border-radius area */-webkit-backface-visibility: hidden;-moz-backface-visibility: hidden;backface-visibility: hidden;}#insticatorEmbed .time-bar .total-time-bar {border-radius: 1em;width: 100%;height: 100%;background-color: #ededef;position: absolute;}#insticatorEmbed .time-bar .total-time-bar.demoEnded {border-radius: 1em;background-color: #ededef;}#insticatorEmbed .time-bar .total-time-bar .remain-time-bar {border-radius: 1em;background-color: "+this.primaryColor+";position: absolute;height: 100%;}#insticatorEmbed .time-bar .total-time-bar .remain-time-bar.pause {-webkit-animation-play-state: paused !important;-moz-animation-play-state: paused !important;-o-animation-play-state: paused !important;animation-play-state: paused !important;}#insticatorEmbed .resultCardSlider {padding: 4%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 100%;top: 0;",this.styles+="left: 1000px;position: absolute;display: table;background-color: #ffffff;-webkit-transition: all 1s ease-in-out;-moz-transition: all 1s ease-in-out;-o-transition: all 1s ease-in-out;transition: all 1s ease-in-out;}#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsThankYou {text-align: center;margin-top: 8%;margin-bottom: 10%;}@media screen and (max-height: 250px), screen and (min-width: 500px) {#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsThankYou {margin-bottom: 5%;}}#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner {width: 85%;padding: 5% 0;text-align: center;margin: auto;background-color: #ededef;}#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner .pollsTextHolder {margin-bottom: 5%;}@media screen and (max-height: 250px), screen and (min-width: 500px) {#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner .pollsTextHolder {display: none;}}#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner p {font-size: 1.4em;font-weight: 600;color: #4b4b4b;}#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner .pollsShareButton {width: 20%;height: 20%;margin: auto;padding: 3% 8%;border: 2px solid #ffffff;border-radius: 3px;}#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner .pollsShareButton .shareText {margin-top: 5px;}",this.styles+="#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner .pollsShareButton:hover {cursor: pointer;}@media screen and (min-width: 500px) {#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner .pollsShareButton {width: 10%;height: 10%;}}@media screen and (min-width: 500px) {#insticatorEmbed .resultCardSlider #pollOnlyResults .pollsButtonContaner {padding: 2% 0;}}#insticatorEmbed .resultCardSlider #pollOnlyResults h2 {font-size: 1.9em;margin-bottom: 3px;}#insticatorEmbed .resultCardSlider.slideInLeft {-ms-transform: translateX(-1000px);/* IE 9 */-webkit-transform: translateX(-1000px);/* Safari */transform: translateX(-1000px);}#insticatorEmbed .resultCardSlider .resultsContainer {margin-top: 10px;height: 150px;width: 100%;display: flex;}#insticatorEmbed .resultCardSlider .resultsContainer .pointsContainer {height: 100%;width: 70%;border-top-left-radius: 1em;border-bottom-left-radius: 1em;background-color: "+this.primaryColor+";display: flex;justify-content: center;color: #ffffff;}#insticatorEmbed .resultCardSlider .resultsContainer .pointsContainer .resultValues {align-self: center;text-align: center;}#insticatorEmbed .resultCardSlider .resultsContainer .pointsContainer .resultValues h1 {font-size: 5.3em !important;align-self: center;color: #ffffff !important;}",this.styles+="#insticatorEmbed .resultCardSlider .resultsContainer .pointsContainer .resultValues p {font-size: 1.9em;font-weight: 300;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer {padding: 0 2% 0 2%;height: 100%;width: 30%;border-radius: 0.5em;background-color: #ededef;color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .three-active:first-of-type {border-bottom: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .three-active:last-of-type {border-top: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .two-active {height: 50% !important;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .two-active:first-of-type {border-bottom: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .one-active {height: 100% !important;border-top: none !important;border-bottom: none !important;border: none !important;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .one-active p {font-size: 1.8em;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .btn {text-align: center;height: 33%;width: 100%;display: flex;justify-content: center;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .btn p {font-size: 1.3em;align-self: center;font-weight: 600;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .btn p:hover {cursor: pointer;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .btn:hover {cursor: pointer;",this.styles+="}#insticatorEmbed .resultCardSlider .thankYouContainer {display: flex;justify-content: center;align-items: center;}#insticatorEmbed .resultCardSlider .thankYouContainer h3 {color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider h2 {padding: 0;}#insticatorEmbed .resultCardSlider h2 span {border-bottom: "+this.primaryColor+" 0.25em solid;}#insticatorEmbed .resultCardSlider .versusResults {/* Scroll down indicator (bouncing) */}#insticatorEmbed .resultCardSlider .versusResults h2 {color: #ffffff;padding: 0;margin: 0 0 0.5em 0;}#insticatorEmbed .resultCardSlider .versusResults .resultsContainer {margin-top: 10px;height: 150px;width: 100%;display: flex;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer {height: 100%;width: 25%;border-radius: 1em;background-color: #ededef;color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .three-active:first-of-type {border-bottom: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .three-active:last-of-type {border-top: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .two-active {height: 50% !important;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .two-active:first-of-type {border-bottom: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .one-active {height: 100% !important;",this.styles+="border-top: none !important;border-bottom: none !important;border: none;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .one-active p {font-size: 1.8em;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .btn {height: 33%;width: 100%;display: flex;justify-content: center;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .btn p {align-self: center;font-weight: 600;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .btn p:hover {cursor: pointer;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .btn:hover {cursor: pointer;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer div:first-of-type {border-bottom: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";border-bottom-width: 90%;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer div:last-of-type {border-top: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";border-top-width: 90%;}#insticatorEmbed .resultCardSlider .versusResults .playerBox {border-radius: 0.5em;margin-right: 1%;width: 48%;height: 100%;display: inline-block;background-color: "+this.LightenDarkenColor(this.secondaryColor,-.09)+";color: "+this.primaryColor+";text-align: center;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;}#insticatorEmbed .resultCardSlider .versusResults .playerLose {background-color: #e4001c;color: #ffffff;}#insticatorEmbed .resultCardSlider .versusResults .playerWin {background-color: #30a939;",this.styles+="color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider .versusResults .playerLoseText,#insticatorEmbed .resultCardSlider .versusResults .playerWinText {color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider .versusResults .playerTiedText {color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider .versusResults .playerLoseBar,#insticatorEmbed .resultCardSlider .versusResults .playerWinBar,#insticatorEmbed .resultCardSlider .versusResults .playerTieBar {border-bottom: #ffffff 0.25em solid;}#insticatorEmbed .resultCardSlider .versusResults .borderLeft {border-left: 1px solid #ffffff;}#insticatorEmbed .resultCardSlider .versusResults .borderRight {border-right: 1px solid #ffffff;}#insticatorEmbed .resultCardSlider .versusResults .tri-box {width: 0;height: 0;border-left: 40px solid transparent;border-right: 40px solid transparent;border-top: 46px solid #43c94d;position: absolute;left: 0;right: 0;margin: 0 auto;}#insticatorEmbed .resultCardSlider .versusResults .playerInfoContainer {padding-top: 18px;}#insticatorEmbed .resultCardSlider .versusResults .playerScoreText {color: #ffffff;font-size: 12px;font-weight: 500;}#insticatorEmbed .resultCardSlider .versusResults .playerScoreTiedText {color: "+this.primaryColor+";font-size: 12px;font-weight: 500;}#insticatorEmbed .resultCardSlider .versusResults .enemyScoreText {font-size: 12px;font-weight: 500;color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider .versusResults p {",this.styles+="font-size: 1em;margin: 2px;}#insticatorEmbed .resultCardSlider .versusResults .bounce {animation: bounce 2s infinite;}@-webkit-keyframes bounce {0%,20%,50%,80%,100% {-webkit-transform: translateY(0);}40% {-webkit-transform: translateY(-30px);}60% {-webkit-transform: translateY(-15px);}}#insticatorEmbed .resultCardSlider .versusResults .playerIcon {border-radius: 1em;margin: 5px auto;height: 52%;width: 37%;}#insticatorEmbed .resultCardSlider .versusResults .playerName {font-size: 1.2em;}#insticatorEmbed .resultCardSlider .versusResults .playerName .playerLevel {font-size: 1.4em;}#insticatorEmbed .resultCardSlider #pollsThankYou .pollsThankYouText {font-weight: bold;color: "+this.primaryColor+";font-size: 2.3em;text-align: center;position: absolute;top: 50%;left: 50%;transform: translate(-50%, -50%);}#insticatorEmbed .resultCardSlider .results {background-color: #ffffff;display: table;width: 100%;height: 230px;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;",this.styles+="box-sizing: border-box;margin: 2.0em 0;}#insticatorEmbed .resultCardSlider .results .avatar,#insticatorEmbed .resultCardSlider .results .info {height: 100%;width: 50%;display: table-cell;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;vertical-align: middle;text-align: center;}#insticatorEmbed .resultCardSlider .results .avatar .userImage {display: inline-block;margin: 0 auto 1em auto;vertical-align: middle;height: 70px;width: 70px;overflow: hidden;text-align: center;background-size: cover;background-repeat: no-repeat;background-position: center center;background-color: #0c1e26;border-radius: 50%;border: 3.33333333px #ffffff solid;}#insticatorEmbed .resultCardSlider .results .avatar .userName {font-size: 1.2em;font-weight: 400;}#insticatorEmbed .resultCardSlider .results .info .userResultPoint {font-size: 3.65em;color: #0c1e26;font-weight: 500;letter-spacing: 0.04em;text-align: center;min-width: 1.2em;padding: 0 .2em;border-bottom: "+this.primaryColor+" 0.25em solid;display: inline-block;line-height: 0.9em;}#insticatorEmbed .resultCardSlider .results .info .points {color: #ffffff;margin-top: 1.5em;width: 100%;height: 0.13em;",this.styles+="font-size: 1.2em;font-weight: 400;}#insticatorEmbed .resultCardSlider .play-again-btn {width: 100%;background-color: #ffffff;color: "+this.primaryColor+";text-align: center;}#insticatorEmbed .resultCardSlider .play-again-btn p {padding: 1em;font-weight: 500;cursor: pointer;}#insticatorEmbed .resultCardSlider .options {height: 20%;width: 100%;display: flex;margin: 30px auto;justify-content: center;}#insticatorEmbed .resultCardSlider .options li {width: 33.33%;margin: 0 10px 0 10px;display: table-cell;align-self: center;text-align: center;}#insticatorEmbed .resultCardSlider .options li.leaderBoards .top,#insticatorEmbed .resultCardSlider .options li.versus .top,#insticatorEmbed .resultCardSlider .options li.vsMode .top,#insticatorEmbed .resultCardSlider .options li.chat .top,#insticatorEmbed .resultCardSlider .options li.share .top {width: 100%;margin: 0 auto;background: #ededef;height: 6em;margin: 0 auto 0 auto;border-radius: 1em;overflow: hidden;cursor: pointer;padding: 6px;box-sizing: border-box;}#insticatorEmbed .resultCardSlider .options li.leaderBoards .bottom,#insticatorEmbed .resultCardSlider .options li.versus .bottom,#insticatorEmbed .resultCardSlider .options li.vsMode .bottom,#insticatorEmbed .resultCardSlider .options li.chat .bottom,#insticatorEmbed .resultCardSlider .options li.share .bottom {user-select: none;",this.styles+="width: 100%;margin: 4px auto;padding-top: 0.1em;color: "+this.primaryColor+";font-weight: 700;font-size: 0.8em;}#insticatorEmbed .resultCardSlider .options .option-icon {color: "+this.primaryColor+";font-size: 38px;height: 4em;vertical-align: middle;margin-top: 14px;}@keyframes resultSlideLeft {0% {left: 100%;}100% {left: 0;}}@keyframes resultSlideOutLeft {0% {left: 0;}100% {right: 100%;}}@media (min-width: 100px) and (max-width: 239px) {#insticatorEmbed .resultCardSlider {display: block;}#insticatorEmbed .resultCardSlider h2 {max-width: 110px;margin: 6px 0 6px 0;font-size: 2.0em !important;}#insticatorEmbed .resultCardSlider .specialContainerClass {height: 136px !important;}#insticatorEmbed .resultCardSlider .resultsContainer {display: inline-flex;display: -webkit-inline-flex;flex-direction: column;margin: 0;height: 190px;}#insticatorEmbed .resultCardSlider .resultsContainer .pointsContainer {",this.styles+="width: 100%;border-radius: 0.5em;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer {display: inline-flex;display: -webkit-inline-flex;border-top-right-radius: 0;border-bottom-right-radius: 0;border: 1em;padding: 0;margin: 5px 0 5px 0;justify-content: center;width: 100%;height: 50px;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .btn {align-self: center;border-bottom: none;border-top: none;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .btn p {font-size: 1em;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .three-active:first-of-type {border-bottom: none;border-right: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .three-active:last-of-type {border-top: none;border-left: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .two-active:last-of-type {border-top: none;}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .two-active:first-of-type {border-bottom: none;border-right: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .resultsContainer .buttonContainer .one-active p {font-size: 1.6em;}#insticatorEmbed .resultCardSlider .small-width {height: 10% !important;}#insticatorEmbed .resultCardSlider .options {margin: 12px auto;}#insticatorEmbed .resultCardSlider .options .specialOptionIconClass {font-size: 20px !important;}",this.styles+="#insticatorEmbed .resultCardSlider .options .option-icon {font-size: 26px;}#insticatorEmbed .resultCardSlider .options li {display: block;width: 22%;margin: 0px 4px 0px 4px;}#insticatorEmbed .resultCardSlider .options li .specialTopClass {height: 46px !important;}#insticatorEmbed .resultCardSlider .options li .top {height: 5em;}#insticatorEmbed .resultCardSlider .options li .bottom {display: none;}#insticatorEmbed .resultCardSlider .versusResults {height: 70%;margin: 0 auto;}#insticatorEmbed .resultCardSlider .versusResults h2 {margin: 6px 0 6px 0;font-size: 2.0em !important;}#insticatorEmbed .resultCardSlider .versusResults .specialPlayerBoxClass {height: 75px !important;}#insticatorEmbed .resultCardSlider .versusResults .playerBox {height: 9em;width: 86%;}#insticatorEmbed .resultCardSlider .versusResults .playerBox .playerIcon {width: 34% !important;height: 45% !important;}#insticatorEmbed .resultCardSlider .versusResults .playerInfoContainer {padding-top: 8px;}#insticatorEmbed .resultCardSlider .versusResults .playerBox:first-child {margin: 0 0 2px 0;}#insticatorEmbed .resultCardSlider .versusResults .resultsContainer {text-align: center;margin: 12px 0 0 0;display: inline-block;height: 88px;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer {height: 20px;",this.styles+="width: 86%;margin: 5px auto;display: flex;justify-content: center;border-radius: 0.5em;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .btn p {font-size: 0.7em !important;}}@media (min-width: 240px) and (max-width: 350px) {#insticatorEmbed .resultCardSlider .triviaResults {margin-bottom: 30px;}#insticatorEmbed .resultCardSlider .options {margin: 0 auto;display: block;}#insticatorEmbed .resultCardSlider .options li {margin: 0 auto;}#insticatorEmbed .resultCardSlider .options li .top {width: 88% !important;margin: 0 auto !important;}#insticatorEmbed .resultCardSlider .options li .bottom {margin: 4px auto !important;}#insticatorEmbed .resultCardSlider .versusResults {height: 70%;}#insticatorEmbed .resultCardSlider .versusResults .resultsContainer {margin: 0;display: inline-block;height: 120px;}#insticatorEmbed .resultCardSlider .versusResults .playerBox {width: 49%;margin-right: 0;}#insticatorEmbed .resultCardSlider .versusResults .playerBox .playerInfoContainer {padding-top: 10px !important;}#insticatorEmbed .resultCardSlider .versusResults .playerBox .playerIcon {width: 48% !important;height: 60% !important;}#insticatorEmbed .resultCardSlider .versusResults .playerBox:first-child {margin-right: 2%;}",this.styles+="#insticatorEmbed .resultCardSlider .versusResults .buttonContainer {padding: 0;margin: 5px 0 5px 0;display: inline-flex;justify-content: center;width: 100%;height: 35px;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .btn {align-self: center;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .three-active:first-of-type {border-bottom: none;border-right: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .three-active:last-of-type {border-top: none;border-left: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .two-active {height: 50% !important;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .two-active:first-of-type {border-bottom: none;border-right: 0.1em solid "+this.LightenDarkenColor(this.secondaryColor,-.3)+";}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .two-active:last-of-type {border: none;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .one-active {height: 100% !important;border-right: none;border: none;}#insticatorEmbed .resultCardSlider .versusResults .buttonContainer .one-active p {font-size: 1.6em;}}@media (max-width: 456px) {#insticatorEmbed .resultCardSlider .options .top {width: 88%;}#insticatorEmbed .resultCardSlider .options .bottom {width: 88%;}#insticatorEmbed .resultCardSlider .buttonContainer .btn p {font-size: 1.1em;}}@media (max-height: 350px) {",this.styles+="#insticatorEmbed .resultCardSlider {padding-top: 20px;padding: 4%;}#insticatorEmbed .resultCardSlider .play-again-btn p {padding: .5em;font-weight: 600;}#insticatorEmbed .resultCardSlider .options .top {height: 5.4em;}#insticatorEmbed .resultCardSlider .options .bottom {height: 3.2em;}#insticatorEmbed .resultCardSlider .resultsContainer,#insticatorEmbed .resultCardSlider .results {margin-top: 15px;}#insticatorEmbed .resultCardSlider .results {margin: 1.1em 0;}#insticatorEmbed .resultCardSlider .results .avatar .userImage {width: 55px;height: 55px;}#insticatorEmbed .resultCardSlider .results .avatar .userName {font-size: 14px;}#insticatorEmbed .resultCardSlider .versusResults .playerInfoContainer {display: flex;justify-content: center;}#insticatorEmbed .resultCardSlider .versusResults .tiedColorClass {color: black  !important;}#insticatorEmbed .resultCardSlider .versusResults .playerName {color: #ffffff;}#insticatorEmbed .resultCardSlider .versusResults .enemyName {color: "+this.primaryColor+";}#insticatorEmbed .resultCardSlider .versusResults .playerScoreText,#insticatorEmbed .resultCardSlider .versusResults .enemyScoreText {font-size: 12px;}}#insticatorEmbed #articleContainer .bottom-container {position: relative;height: 10%;width: 100%;",this.styles+="display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;}#insticatorEmbed #articleContainer .bottom-container .bottom-button {display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;-ms-flex-item-align: center;align-self: center;width: 105px;height: 30px;border-radius: 5em 3em;background: "+this.primaryColor+";}#insticatorEmbed #articleContainer .bottom-container .bottom-button p {color: #ffffff;-ms-flex-item-align: center;-ms-grid-row-align: center;align-self: center;font-size: 1.3em;line-height: 30px;}#insticatorEmbed #articleContainer .bottom-container .bottom-button:hover,#insticatorEmbed #articleContainer .bottom-container p {cursor: pointer;}#insticatorEmbed .articleCardSlider {padding: 4%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 100%;top: 0;position: absolute;display: inline-block;background-color: #ffffff;z-index: 100;}#insticatorEmbed .articleCardSlider .timerPlaceholder {background-color: "+this.primaryColor+";position: absolute;}",this.styles+="#insticatorEmbed .articleCardSlider .top-container {height: 10%;width: 100%;margin: 2% 0 0 0;}#insticatorEmbed .articleCardSlider .top-container h2 {font-size: 2.1em;padding: 0;}#insticatorEmbed .articleCardSlider .article-container {height: 70%;margin: 1em 0 0 0;opacity: 1;-webkit-transition: all 0.3s ease-in-out;transition: all 0.3s ease-in-out;}#insticatorEmbed .articleCardSlider .article-container.slideOutLeft {opacity: 0.1;-webkit-transform: scale(0.8);transform: scale(0.8);}#insticatorEmbed .articleCardSlider .article-container .article-img {width: 100%;height: 58%;background-size: cover;background-repeat: no-repeat;background-position: center center;border-top-left-radius: 1em;border-top-right-radius: 1em;}#insticatorEmbed .articleCardSlider .article-container .article-body {position: relative;padding: 0;margin: 0;height: 30%;width: 100%;background-color: #ededef;color: "+this.primaryColor+";overflow: hidden;display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-title-container {-ms-flex-item-align: center;align-self: center;width: 84%;",this.styles+="text-overflow: ellipsis;font-size: 1.6em;display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-title-container .article-text {width: 100%;-ms-flex-item-align: center;-ms-grid-row-align: center;align-self: center;text-align: left;font-size: 1.2em;line-height: 1.1em;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container {width: 30%;display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button {display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;-ms-flex-item-align: center;align-self: center;width: 76%;height: 28px;background: "+this.primaryColor+";border-radius: 5em 3em;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button a {-ms-flex-item-align: center;-ms-grid-row-align: center;align-self: center;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button p {font-size: 1.3em;color: #ffffff;}",this.styles+="#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button:hover,#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container p,#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container a {cursor: pointer;}#insticatorEmbed .articleCardSlider .article-container .bottom-container {height: 10%;width: 100%;display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;margin-top: 2em;}#insticatorEmbed .articleCardSlider .article-container .bottom-container .bottom-button {display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;-ms-flex-item-align: center;align-self: center;width: 105px;height: 30px;border-radius: 5em 3em;background: "+this.primaryColor+";}#insticatorEmbed .articleCardSlider .article-container .bottom-container .bottom-button p {color: #ffffff;-ms-flex-item-align: center;-ms-grid-row-align: center;align-self: center;font-size: 1.3em;}#insticatorEmbed .articleCardSlider .article-container .bottom-container .bottom-button:hover,#insticatorEmbed .articleCardSlider .article-container .bottom-container p {cursor: pointer;}@media (min-width: 100px) and (max-width: 222px) {#insticatorEmbed #articleContainer .bottom-container #skipBtn {display: none;}}@media (min-width: 100px) and (max-width: 160px) {#insticatorEmbed .articleCardSlider .top-container h2 {font-size: 2.1em;}",
this.styles+="#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container {display: none;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-title-container {width: 100%;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-title-container .article-text {font-size: 0.8em;}}@media (min-width: 100px) and (max-width: 284px) {#insticatorEmbed .articleCardSlider .top-container h2 span {display: none;}}@media (min-width: 250px) and (max-width: 350px) {#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container {display: none !important;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button {width: 91%;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button p {font-size: 1em;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-title-container .article-text {font-size: 0.8em;}}@media (min-width: 100px) and (max-width: 249px) {#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container {display: none !important;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button {width: 91%;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-button-container .article-button p {font-size: 1em;}#insticatorEmbed .articleCardSlider .article-container .article-body .article-title-container .article-text {font-size: 0.7em;}}#insticatorEmbed .leaderBoardSlider {padding: 4%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 100%;",this.styles+="top: 0;left: 1000px;position: absolute;display: table;background-color: #ffffff;z-index: 105;-webkit-transition: all 0.6s ease-in-out;-moz-transition: all 0.6s ease-in-out;-o-transition: all 0.6s ease-in-out;transition: all 0.6s ease-in-out;}#insticatorEmbed .leaderBoardSlider.slideInLeft {-ms-transform: translateX(-1000px);/* IE 9 */-webkit-transform: translateX(-1000px);/* Safari */transform: translateX(-1000px);}#insticatorEmbed .leaderBoardSlider .leader-container {display: flex;display: -webkit-flex;height: 54px;width: 100%;margin-bottom: 4%;border-radius: 0.8em;background-color: #ededef;flex-flow: wrap;align-content: flex-start;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox {display: flex;display: -webkit-flex;justify-content: center;height: 100%;margin: 8px;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox .userPlace span {margin-right: 5px;font-size: 1.4em;font-weight: 700;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox .userImg {height: 42px;width: 47px;background-size: cover;background-repeat: no-repeat;background-position: center center;border-radius: 1em;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox .userPoints {",this.styles+="height: 100%;width: 90%;display: flex;justify-content: center;padding-left: 5px;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox .userPoints .pointsText {padding-left: 5px;font-size: 18px;align-self: center;color: "+this.primaryColor+";}#insticatorEmbed .leaderBoardSlider h2 {padding: 0;}#insticatorEmbed .leaderBoardSlider .topContainer {width: 100%;height: 34px;margin: 0 0 12px 0 !important;}#insticatorEmbed .leaderBoardSlider .mainTextContainer {float: left;}#insticatorEmbed .leaderBoardSlider .specialLeaderboardClass {height: 121px !important;margin-top: 26px !important;}#insticatorEmbed .leaderBoardSlider .mainContainer {display: flex;display: -webkit-flex;border-radius: 0.8em;width: 100%;height: 178px;overflow: hidden;background-color: #ededef;flex-flow: wrap;align-content: flex-start;justify-content: center;}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox {display: flex;justify-content: center;height: 45px;width: 17%;margin: 8px;}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox .userPlace span {margin-right: 5px;font-size: 1em;font-weight: 600;",this.styles+="}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox .userImg {height: 36px;width: 45px;background-size: cover;background-repeat: no-repeat;background-position: center center;border-radius: 1em;}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox .userPoints {display: flex;display: -webkit-flex;height: 35px;width: 90%;justify-content: center;flex-direction: column;}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox .userPoints .pointsText {font-size: 10px;align-self: center;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";}#insticatorEmbed .leaderBoardSlider .footer-container {display: flex;display: -webkit-flex;width: 100%;height: 13%;bottom: 0;justify-content: center;align-items: center;}#insticatorEmbed .leaderBoardSlider .footer-container .poweredBy {height: 4%;width: 100%;bottom: 0;font-weight: 400;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;background-color: #ffffff;text-decoration: none;cursor: pointer;}#insticatorEmbed .leaderBoardSlider .footer-container .poweredBy p {color: "+this.LightenDarkenColor(this.secondaryColor,-.52)+";text-decoration: none;font-size: 1em;position: relative;top: 50%;transform: translateY(-50%);",this.styles+="cursor: pointer;}#insticatorEmbed .leaderBoardSlider .footer-container .poweredBy p .logo {color: "+this.primaryColor+";height: .7em;margin-left: 4px;width: auto;}#insticatorEmbed .leaderBoardSlider .rankingList {width: 100%;color: #ffffff;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;text-indent: 2%;counter-reset: rank-counter;}#insticatorEmbed .leaderBoardSlider .rankingList li {-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;display: table;counter-increment: rank-counter;width: 100%;background-color: #ffffff;margin-bottom: .5em;position: relative;}#insticatorEmbed .leaderBoardSlider .rankingList li:before {content: counter(rank-counter);color: #ffffff;position: absolute;font-size: 1.3em;font-weight: bold;left: -8%;top: 38%;}#insticatorEmbed .leaderBoardSlider .rankingList li .userIdenitity {display: table;overflow: hidden;position: relative;width: 90%;}#insticatorEmbed .leaderBoardSlider .rankingList li .userIdenitity .userName {display: table-cell;vertical-align: middle;color: "+this.primaryColor+";font-weight: 500;font-size: 1em;white-space: nowrap;",this.styles+="overflow: hidden;text-overflow: ellipsis;position: relative;z-index: 100;width: 100%;}#insticatorEmbed .leaderBoardSlider .rankingList li .userIdenitity .rankImage {vertical-align: middle;height: 45px;width: 45px;overflow: hidden;text-align: center;background-size: cover;background-repeat: no-repeat;background-position: center center;background-color: #0c1e26;border-radius: 1em;margin: .4em;}#insticatorEmbed .leaderBoardSlider .rankingList li .scoreBox {background-color: #ffffff;position: relative;z-index: 10;width: 40%;height: 100%;display: table-cell;vertical-align: middle;text-align: right;}#insticatorEmbed .leaderBoardSlider .rankingList li .scoreBox .points {color: #9dcce0;position: absolute;bottom: 5px;right: 10px;}#insticatorEmbed .leaderBoardSlider .rankingList li .scoreBox .score {color: "+this.primaryColor+';font-weight: bold;font-size: 2em;margin: .4em;}#insticatorEmbed .leaderBoardSlider .rankingList li .scoreBox:after {content: "";position: absolute;top: 0;width: 3em;height: 100%;left: -1em;background-color: #ffffff;z-index: -1;',this.styles+="transform: skew(-20deg);-webkit-transform: skew(-19deg);box-shadow: -0.1em 0em 0em rgba(0, 0, 0, 0.01);}@media (min-width: 100px) and (max-width: 289px) {#insticatorEmbed .leaderBoardSlider {height: 100%;padding: 4% 0 0 0 !important;}#insticatorEmbed .leaderBoardSlider .footer-container {height: 6%;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox {margin: 2px;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox .userImg {width: 45px;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox .userPoints .pointsText {padding-left: 1px;font-size: 10px;}#insticatorEmbed .leaderBoardSlider .topContainer {padding-left: 4%;margin: 8px 0 8px 0 !important;}#insticatorEmbed .leaderBoardSlider .topContainer .mainTextContainer {float: none !important;margin-bottom: 5px;word-wrap: break-word;width: 80px;}#insticatorEmbed .leaderBoardSlider .topContainer .mainTextContainer h2 {font-size: 1.8em !important;}#insticatorEmbed .leaderBoardSlider .specialLeaderboardClass {height: 132px !important;}#insticatorEmbed .leaderBoardSlider .mainContainer {display: flex;display: -webkit-flex;margin-top: 18px;height: 176px;flex-flow: wrap;align-content: flex-start;margin-bottom: 4%;overflow: hidden;}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox {height: 42px;",this.styles+="margin: 1px;width: 85%;}#insticatorEmbed .leaderBoardSlider .mainContainer .userImg {height: 28px;width: 28px;}#insticatorEmbed .leaderBoardSlider .mainContainer .userPoints p {font-size: 11px !important;}#insticatorEmbed .leaderBoardSlider .footer-container {height: 6vh;}}@media (min-width: 230px) and (max-width: 290px) {#insticatorEmbed .leaderBoardSlider .mainContainer {height: 176px !important;}}@media (min-width: 361px) and (max-width: 520px) {#insticatorEmbed .leaderBoardSlider .mainContainer .userBox {width: 28%;overflow: hidden;}}@media (min-width: 290px) and (max-width: 360px) {#insticatorEmbed .leaderBoardSlider {height: 100%;}#insticatorEmbed .leaderBoardSlider .footer-container {height: 6vh;}#insticatorEmbed .leaderBoardSlider .topContainer {margin: 0;}#insticatorEmbed .leaderBoardSlider .leader-container .userBox .userImg {width: 45px;}#insticatorEmbed .leaderBoardSlider .mainContainer {display: flex;display: -webkit-flex;flex-flow: wrap;align-content: flex-start;margin-bottom: 2%;}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox {flex: 0 0 44%;}#insticatorEmbed .leaderBoardSlider .mainContainer .userBox .userPoints .pointsText {font-size: 11px;",this.styles+="}}#insticatorEmbed .shareScreenSlider {padding: 4%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 100%;top: 0;left: 1000px;position: absolute;display: table;background-color: #ffffff;z-index: 105;box-shadow: 3px 3px 8px 3px rgba(38, 50, 56, 0.2), 0 8px 0 0 #ffffff;-webkit-transition: all 0.6s ease-in-out;-moz-transition: all 0.6s ease-in-out;-o-transition: all 0.6s ease-in-out;transition: all 0.6s ease-in-out;}#insticatorEmbed .shareScreenSlider.slideInLeft {-ms-transform: translateX(-1000px);/* IE 9 */-webkit-transform: translateX(-1000px);/* Safari */transform: translateX(-1000px);}#insticatorEmbed .shareScreenSlider .top-container {width: 100%;height: 10%;margin: 0;}#insticatorEmbed .shareScreenSlider .shareTitle {float: left;}#insticatorEmbed .shareScreenSlider h2 {padding: 0;}#insticatorEmbed .shareScreenSlider .shareContainer {align-self: center;text-align: center;width: 100%;height: 96%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;display: flex;justify-content: center;}",this.styles+="#insticatorEmbed .shareScreenSlider .hideShareScreenBtn {color: "+this.primaryColor+";margin-top: 20px;width: 100%;height: 30px;}#insticatorEmbed .shareScreenSlider .btnContainer {align-self: center;width: 65%;}#insticatorEmbed .shareScreenSlider .socialBtn {height: 80px;width: 80px;display: inline-block;}#insticatorEmbed .shareScreenSlider .fa {background-color: #ffffff;color: "+this.primaryColor+";font-size: 90px;}#insticatorEmbed .shareScreenSlider .slogan-container {display: flex;justify-content: center;margin: 15px auto;width: 90%;height: 40px;margin: 10px auto;border-radius: 5em 3em;}#insticatorEmbed .shareScreenSlider .slogan-container p {color: "+this.primaryColor+";align-self: center;font-size: 18px;font-weight: 600;}@media (min-width: 100px) and (max-width: 349px) {#insticatorEmbed .shareScreenSlider {display: flex;}#insticatorEmbed .shareScreenSlider .top-container {display: none;}#insticatorEmbed .shareScreenSlider .fa {font-size: 70px;}#insticatorEmbed .shareScreenSlider .btnContainer {width: 100%;display: block;margin: 0 auto;}",this.styles+='#insticatorEmbed .shareScreenSlider .btnContainer .socialBtn {width: 100%;}#insticatorEmbed .shareScreenSlider .slogan-container {width: 140px;height: 30px;}#insticatorEmbed .shareScreenSlider .slogan-container span {display: none;}#insticatorEmbed .shareScreenSlider .slogan-container p:after {content: "SHARE";font-size: 22px;}}@media (max-height: 250px) {#insticatorEmbed .shareScreenSlider .btnContainer {height: 100%;}#insticatorEmbed .shareScreenSlider .btnContainer .socialBtn {height: 60px;}}@media (max-width: 340px) {#insticatorEmbed .shareScreenSlider .btnContainer {width: 90%;}#insticatorEmbed .shareScreenSlider .fa {font-size: 68px;}}@media (max-width: 400px) {#insticatorEmbed .shareScreenSlider .btnContainer {width: 90%;}#insticatorEmbed .shareScreenSlider .fa {font-size: 88px;}}#insticatorEmbed .chatSlider {height: 100%;width: 100%;top: 0;left: 1000px;position: absolute;background-color: #ffffff;z-index: 105;-webkit-transition: all 0.6s ease-in-out;-moz-transition: all 0.6s ease-in-out;-o-transition: all 0.6s ease-in-out;',this.styles+="transition: all 0.6s ease-in-out;}#insticatorEmbed .chatSlider.slideInLeft {-ms-transform: translateX(-1000px);/* IE 9 */-webkit-transform: translateX(-1000px);/* Safari */transform: translateX(-1000px);}#insticatorEmbed .chatSlider h2 {padding: 0;}#insticatorEmbed .chatSlider .topContainer {width: 100%;height: 10%;margin: 5% 0 0 4%;overflow: hidden;}#insticatorEmbed .chatSlider .mainTextContainer {float: left;}#insticatorEmbed .chatSlider .backBtnContainer {height: 40px;width: 40px;text-align: center;float: right;}#insticatorEmbed .chatSlider .backBtn {font-size: 32px;line-height: 40px;color: "+this.primaryColor+";}#insticatorEmbed .chatSlider .chatContainer {height: 71%;width: 100%;}#insticatorEmbed .chatSlider .messageContainer {display: flex;max-width: 95%;}#insticatorEmbed .chatSlider .messageContainer .usernameContainer {margin-top: 8px;display: flex;justify-content: center;align-items: center;width: 10%;}#insticatorEmbed .chatSlider .messageContainer .messageContainer {width: 90%;}",this.styles+="#insticatorEmbed .chatSlider .usernameInChat {margin: 0;font-weight: 500;font-size: 1.5em;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";}#insticatorEmbed .chatSlider .message {margin: 8px 4px 0px 4px;font-size: 14px;padding: 10px;border-radius: 0.2em;word-break: break-all;width: 55%;background-color: "+this.primaryColor+";color: #ffffff;}#insticatorEmbed .chatSlider .repeatedMessage {margin: 5px 16px 0px 16px;font-size: 14px;padding: 14px;border-radius: 14px;word-break: break-all;min-width: 25%;max-width: 52%;background-color: #ffffff;color: #212121;}#insticatorEmbed .chatSlider .msgList {position: relative;width: 100%;height: 100%;overflow: auto;padding-bottom: 4px;margin-left: 4%;margin-right: 4%;}#insticatorEmbed .chatSlider form {width: 100%;}#insticatorEmbed .chatSlider .chatInputContainer {bottom: 0;position: absolute;padding: 0;margin: 0;width: 100%;height: 11%;background-color: #ededef;display: inline-flex;}#insticatorEmbed .chatSlider .chatInputField {",this.styles+="background-color: #ffffff;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";font-size: 14px;margin-top: 4px;padding: 0 0 8px 8px;border: none;width: 100%;height: 100%;}#insticatorEmbed .chatSlider .chatInputField:focus {outline: none;}#insticatorEmbed .chatSlider .msgSubmitBtnContainer {margin: 4px 0 0 0;width: 46px;display: flex;justify-content: center;}#insticatorEmbed .chatSlider .msgSubmitBtn {align-self: center;background-color: "+this.primaryColor+";border-radius: 50%;height: 26px;width: 26px;color: #ffffff;margin: 0 auto;}#insticatorEmbed .chatSlider .msgSubmitBtn:active {background-color: #FAFAFA;}#insticatorEmbed .chatSlider .fa-paper-plane {margin-left: 2px;font-size: 18px;line-height: 26px;cursor: pointer;}#insticatorEmbed .chatSlider .chatUserList {-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 75%;top: 0;left: 110%;position: absolute;display: inline-block;background-color: "+this.primaryColor+";z-index: 101;box-shadow: 3px 3px 14px 12px rgba(38, 50, 56, 0.2), 0 8px 0 0 "+this.primaryColor+";transition: all 1s ease-in-out;",this.styles+="}#insticatorEmbed .chatSlider .chatUserList.slideInLeft {left: 25%;}#insticatorEmbed .chatSlider .chatUserList h2 {padding: 0;}#insticatorEmbed .chatSlider .chatUserList h2 span {border-bottom: #ffffff 0.2em solid;}#insticatorEmbed .chatSlider .chatUserList .topContainer {width: 100%;height: 10%;margin: 4% 0 0 3%;display: inline-block;}#insticatorEmbed .chatSlider .chatUserList .mainTextContainer {float: left;}#insticatorEmbed .chatSlider .chatUserList .userListContainer {position: relative;background-color: "+this.LightenDarkenColor(this.primaryColor,-.07)+";width: 100%;height: 250px;overflow: scroll;margin-top: 8px;margin-bottom: 8px;padding-bottom: 4px;}#insticatorEmbed .chatSlider .chatUserList .userListContainer li:first-child {padding-top: 10px;}#insticatorEmbed .chatSlider .chatUserList .userListContainer li {color: #fafafa;font-size: 1.7em;padding-left: 10px;}#insticatorEmbed .chatSlider .chatUserList .userListItem {font-size: 14px;word-break: break-all;color: #212121;}@media (min-width: 100px) and (max-width: 200px) {#insticatorEmbed .chatSlider .message {font-size: 11px !important;}#insticatorEmbed .chatSlider .messageContainer .usernameContainer {width: 73% !important;}#insticatorEmbed .chatSlider .messageContainer .usernameContainer .usernameInChat {",this.styles+="font-size: 1.1em !important;}}@media (min-width: 100px) and (max-width: 350px) {#insticatorEmbed .chatSlider .messageContainer {width: 100%;}#insticatorEmbed .chatSlider .messageContainer .usernameContainer {width: 16%;}#insticatorEmbed .chatSlider .messageContainer .usernameContainer .usernameInChat {font-size: 1.2em;}}#insticatorEmbed .issueReportSlider {height: 100%;width: 100%;top: 0;left: 110%;position: absolute;background-color: #ededef;z-index: 105;transition: all 1s ease-in-out;}#insticatorEmbed .issueReportSlider.slideInLeft {left: 0;}#insticatorEmbed .issueReportSlider .title {margin: 10px;text-align: center;}#insticatorEmbed .issueReportSlider .input-field {display: block;width: 95%;border-radius: 0.4em;border: none;margin: 0 auto;margin-bottom: 12px;padding-left: 8px;font-size: 14px;color: #737373;}#insticatorEmbed .issueReportSlider .input-field:focus {outline: 0;}#insticatorEmbed .issueReportSlider .issue,#insticatorEmbed .issueReportSlider .email {height: 40px;}#insticatorEmbed .issueReportSlider .text-field {",this.styles+="resize: none;height: 114px;padding-top: 8px;}#insticatorEmbed .issueReportSlider .submit-btn {background: #ffffff;color: #737373;margin-bottom: 8px;float: right;position: relative;margin-right: 2.5%;width: 100px;height: 24px;border-radius: 5em 3em;border: none;cursor: pointer;}#insticatorEmbed .issueReportSlider .submit-msg {padding: 4%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 100%;top: 110%;position: absolute;display: table;background-color: #ffffff;z-index: 105;transition: all 1s ease-in-out;}#insticatorEmbed .issueReportSlider .submit-msg.slideInFromBottom {top: 0;}#insticatorEmbed .optionContainer {padding: 3% 3% 0 3%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 100%;top: 0;left: 100%;position: absolute;display: table;background-color: #ffffff;z-index: 100;transition: all 1s ease-in-out;text-align: center;}",this.styles+="#insticatorEmbed .optionContainer:hover {cursor: pointer;}#insticatorEmbed .optionContainer.slideInLeft {left: 0;}#insticatorEmbed .optionContainer.slideOutRight {left: -100%;}#insticatorEmbed .optionContainer p {font-size: 1em;}#insticatorEmbed .optionContainer .pTitle {font-size: 1.10em;font-weight: 600;}#insticatorEmbed .optionContainer .gameModeBtnContainer {width: 100%;height: 50%;display: flex;display: -webkit-flex;justify-content: center;background-color: #ffffff;}#insticatorEmbed .optionContainer .innerContainer {align-self: center;}#insticatorEmbed .optionContainer .innerContainer p {color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";}#insticatorEmbed .optionContainer .versusInnerContainer {color: #ffffff;}#insticatorEmbed .optionContainer .bottomContainer {background-color: "+this.primaryColor+";border-radius: 0.30em;}#insticatorEmbed .optionContainer .bottomContainer .innerContainer p {color: #ffffff;}#insticatorEmbed .optionContainer .gameModeBtn {height: 60px;width: 60px;margin: 0.4em 0 0 0;display: inline-block;vertical-align: middle;background-color: "+this.primaryColor+";border-radius: 1em;}#insticatorEmbed .optionContainer .vsButton {",this.styles+="background-color: #ffffff;}#insticatorEmbed .optionContainer .triviaIcon {color: #ffffff;}#insticatorEmbed .optionContainer .vsIcon {color: "+this.primaryColor+";}#insticatorEmbed .optionContainer .fa {margin: 0 auto;display: inline-block;font-size: 40px;line-height: 60px;}@media (min-width: 100px) and (max-width: 300px) {#insticatorEmbed .optionContainer .gameModeBtn {height: 65px;width: 65px;}#insticatorEmbed .optionContainer .fa {font-size: 50px;}}#insticatorEmbed #instiPollGameContainer {position: absolute;top: 0;bottom: 0;left: 0;right: 0;width: 100%;height: 100%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;z-index: 9999999;background: #ffffff;}#insticatorEmbed #instiPollGameContainer .questionSection {-webkit-transition: all 0.6s ease-in-out;-moz-transition: all 0.6s ease-in-out;-o-transition: all 0.6s ease-in-out;transition: all 0.6s ease-in-out;}#insticatorEmbed #instiPollGameContainer .questionSection.slideOutLeft {-ms-transform: translateX(-1000px);/* IE 9 */-webkit-transform: translateX(-1000px);/* Safari */transform: translateX(-1000px);}",this.styles+="#insticatorEmbed #instiPollGameContainer .questionSection .questionContainer {position: relative;top: 0;left: 0;right: 0;}#insticatorEmbed #instiPollGameContainer .questionSection .questionContainer .questionImage {width: 100%;height: 150px;overflow: hidden;background-size: cover;background-repeat: no-repeat;background-position: center center;}#insticatorEmbed #instiPollGameContainer .questionSection .questionContainer .circleImage {position: absolute;top: 6px;left: 6px;width: 65px;height: 65px;border-radius: 50%;overflow: hidden;background-size: cover;background-repeat: no-repeat;background-position: center center;}#insticatorEmbed #instiPollGameContainer .questionSection .questionContainer .sponsoredText {position: absolute;top: 6px;right: 0;width: 82px;height: 18px;line-height: 18px;background: black;color: #ffffff;font-size: 1.25em;padding-left: 13px;border-top-left-radius: 10px;border-bottom-left-radius: 10px;}#insticatorEmbed #instiPollGameContainer .questionSection .questionContainer .question {display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;-webkit-box-align: center;-ms-flex-align: center;align-items: center;",this.styles+="height: 40px;background: #ededef;}#insticatorEmbed #instiPollGameContainer .questionSection .questionContainer .question .questionText {color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";background-color: #ededef;font-size: 1.3em;cursor: default;padding: 0 15px 0 15px;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers {padding: 0 5% 0 5%;margin-top: 10px;}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers .answer {display: -webkit-box;display: -ms-flexbox;display: flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;-webkit-box-align: center;-ms-flex-align: center;align-items: center;background-color: #ededef;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";border-radius: 5em 3em;border: transparent;width: 100%;min-height: 22px;text-align: center;margin: 6px 0;font-size: 1.4em;transition: all 0.3s ease-in;background-position: 100% 0;background-size: 200% 100%;position: relative;cursor: pointer;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;",this.styles+='-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;overflow: hidden;/* this is used so that overflow only shows the inner border-radius area */-webkit-backface-visibility: hidden;-moz-backface-visibility: hidden;backface-visibility: hidden;-webkit-transform: translate3d(0, 0, 0);-moz-transform: translate3d(0, 0, 0);transform: translate3d(0, 0, 0);}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers .answer .answer-indicator {-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;top: 0;position: absolute;opacity: 0.5;height: 100%;-webkit-transition: all 0.5s ease-in-out;-moz-transition: all 0.5s ease-in-out;-o-transition: all 0.5s ease-in-out;transition: all 0.5s ease-in-out;}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers .answer.userSelected::before {content: " ";position: absolute;z-index: 104;background-color: '+this.primaryColor+';width: 13%;height: 100%;float: left;left: 0;top: 0;border-radius: 5em 3em;padding: 0;margin: 0;opacity: 0.7;}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers .answer.enemySelected::after {content: " ";position: absolute;z-index: 104;background-color: '+this.primaryColor+";width: 13%;height: 100%;float: right;right: 0;top: 0;",this.styles+="border-radius: 5em 3em;padding: 0;margin: 0;opacity: 0.7;}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers .answer .percentageBar {-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;background: "+this.primaryColor+";top: 0;position: absolute;opacity: 0.5;height: 100%;border-radius: 5em 3em;-webkit-transition: all 0.5s ease-in-out;-moz-transition: all 0.5s ease-in-out;-o-transition: all 0.5s ease-in-out;transition: all 0.5s ease-in-out;}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers .answer.fadeAway {animation: fadeAway 1s linear forwards;pointer-events: none !important;}@keyframes fadeAway {0% {opacity: 1;}100% {opacity: 0.2;}}@keyframes barslide {0% {max-width: 0;}100% {max-width: 100%;}}#insticatorEmbed #instiPollGameContainer .questionSection #questionAnswers .answer .percentageNum {position: absolute;z-index: 11;right: 0;padding-right: 3.5%;font-weight: 500;}@keyframes clickedButton {}#insticatorEmbed #closeAdBtnContainer {",this.styles+="position: absolute;top: 0;left: 0;right: 0;bottom: 0;}#insticatorEmbed #embedContent {position: relative;height: 100%;overflow: hidden;width: 100%;top: 0;z-index: 1;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;}#insticatorEmbed #poweredBy {position: absolute;height: 4%;width: 100%;text-align: center;bottom: 0;left: 0;font-weight: 400;z-index: 100;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;background-color: #ffffff;text-decoration: none;cursor: pointer;}#insticatorEmbed #poweredBy p {display: inline-block;color: "+this.LightenDarkenColor(this.secondaryColor,-.52)+";text-decoration: none;font-size: 1em;position: relative;top: 50%;transform: translateY(-50%);cursor: pointer;}#insticatorEmbed #poweredBy .logo {display: inline-block;color: "+this.primaryColor+";height: .7em;margin-left: 4px;width: auto;}",this.styles+="#insticatorEmbed #poweredByInSlider {position: absolute;height: 4%;width: 100%;text-align: center;bottom: 0;left: 0;font-weight: 400;z-index: 100;background-color: "+this.primaryColor+";text-decoration: none;cursor: pointer;}#insticatorEmbed #poweredByInSlider p {display: inline-block;color: #ffffff;text-decoration: none;font-size: 1em;position: relative;top: 50%;transform: translateY(-50%);cursor: pointer;}#insticatorEmbed #poweredByInSlider .logo {display: inline-block;color: "+this.primaryColor+";height: .7em;margin-left: 4px;width: auto;}#insticatorEmbed #insticatorLogo {height: 40px;width: 70px;padding: 0;margin: 0;background-color: "+this.primaryColor+";display: flex;}#insticatorEmbed #insticatorLogo .left-logo-container {display: inline-block;width: 80%;height: 100%;}#insticatorEmbed #insticatorLogo .right-logo-container {display: inline-block;width: 20%;height: 100%;}#insticatorEmbed #insticatorLogo .top-container,#insticatorEmbed #insticatorLogo .middle-container,",this.styles+="#insticatorEmbed #insticatorLogo .bottom-container {width: 100%;height: 30%;display: flex;justify-content: center;align-items: center;margin: 1% 0 1% 0;}#insticatorEmbed #insticatorLogo .left-line,#insticatorEmbed #insticatorLogo .right-line {background-color: #ffffff;height: 50%;margin: 0;border-radius: 1.5em;}#insticatorEmbed #insticatorLogo .top-container .left-line {width: 25%;margin-left: 30%;margin-right: 5%;}#insticatorEmbed #insticatorLogo .top-container .right-line {float: right;width: 40%;}#insticatorEmbed #insticatorLogo .middle-container .left-line {width: 40%;margin-right: 5%;}#insticatorEmbed #insticatorLogo .middle-container .right-line {width: 55%;}#insticatorEmbed #insticatorLogo .bottom-container .left-line {float: right;width: 40%;margin-left: 30%;margin-right: 5%;}#insticatorEmbed #insticatorLogo .bottom-container .right-line {float: right;width: 40%;}#insticatorEmbed #insticatorLogo .right-logo-container {display: flex;justify-content: center;align-items: center;}#insticatorEmbed #insticatorLogo .right-logo-container .bar {border-top-left-radius: 1.5em;border-top-right-radius: 1.5em;border-bottom-left-radius: 1.5em;",this.styles+="border-bottom-right-radius: 1.5em;height: 80%;width: 36%;background-color: #ffffff;-ms-transform: rotate(4deg);-webkit-transform: rotate(4deg);transform: rotate(4deg);}#insticatorEmbed #gameContainer {padding: 2% 5% 4% 5%;width: 100%;height: 100%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;}#insticatorEmbed #gameContainer .pollHeadline {margin: 20px 0 10px 0 !important;}#insticatorEmbed #gameContainer .headLine {margin: 40px 0 10px 0;}#insticatorEmbed #gameContainer .headLine h1:first-of-type {width: 160px;}#insticatorEmbed #gameContainer .headLine .headLineTitleContainer {display: inline-block;}#insticatorEmbed #gameContainer #startGame {border-radius: 5em 3em;background-color: "+this.primaryColor+";margin: 2.75em auto;bottom: 1.5em;width: 180px;height: 30px;overflow: hidden;text-transform: uppercase;cursor: pointer;}#insticatorEmbed #gameContainer #startGame.waiting {cursor: wait;}#insticatorEmbed #gameContainer #startGame.waiting:active {background-color: "+this.primaryColor+";}#insticatorEmbed #gameContainer #startGame p {color: #ffffff;line-height: 30px;text-align: center;font-weight: 300;",this.styles+="font-size: 1.3em;letter-spacing: 0.07em;position: relative;z-index: 2;cursor: pointer;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}#insticatorEmbed #gameContainer #startGame:active {background-color: "+this.LightenDarkenColor(this.secondaryColor,-.2)+";}@media (min-width: 150px) and (max-width: 200px) {#insticatorEmbed #gameContainer #startGame {width: 125px !important;}}#insticatorEmbed #gameContainer #header .companyLogo {position: absolute;top: 0;left: 0;right: 0;margin: 8px auto;height: 40px;width: 40px;border-radius: 0.8em;overflow: hidden;background-size: cover;background-repeat: no-repeat;background-position: center center;}#insticatorEmbed #gameContainer .polls-header {display: flex;display: -webkit-flex;width: 96%;height: 10%;justify-content: center;align-items: center;padding-bottom: 2%;}#insticatorEmbed #gameContainer .polls-header h1 {text-align: center;}#insticatorEmbed #gameContainer .polls-header .skip-button {display: flex;display: -webkit-flex;font-size: 1.2em;",
this.styles+="height: 24px;width: 115px;border-radius: 5em 3em;background-color: "+this.primaryColor+";color: #ffffff;justify-content: center;align-items: center;margin-left: auto;}#insticatorEmbed #gameContainer .polls-header .skip-button:hover {cursor: pointer;}#insticatorEmbed #gameContainer .solo-header {display: flex;display: -webkit-flex;width: 90%;height: 10%;padding-bottom: 2%;}#insticatorEmbed #gameContainer .solo-header .userAvatar {height: 36px;width: 34px;margin-right: 8px;overflow: hidden;text-align: center;background-size: cover;background-repeat: no-repeat;background-position: center center;border-radius: 1em;}#insticatorEmbed #gameContainer .solo-header .userName {height: 50%;font-weight: 300;font-size: 1.6em;/*line-height: 2em;*/color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}#insticatorEmbed #gameContainer .solo-header .name-score-container {display: flex;justify-content: center;align-items: center;flex-direction: column;width: 50px;}",this.styles+="#insticatorEmbed #gameContainer .solo-header .name-score-container .score-btn-container {display: flex;display: -webkit-flex;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;height: 50%;width: 100%;border-radius: 5em 3em;background-color: "+this.primaryColor+";color: #ffffff;justify-content: center;margin-top: 5%;}#insticatorEmbed #gameContainer .solo-header .name-score-container .score-btn-container .score-btn {font-size: 1em;font-weight: 600;align-self: center;}#insticatorEmbed #gameContainer .solo-header .name-score-container .score-btn-container .score-btn span {font-weight: 500;font-size: 1.05em;padding-left: 2px;}#insticatorEmbed #gameContainer .solo-header .trivia-button {display: flex;display: -webkit-flex;font-size: 1.2em;height: 24px;width: 75px;border-radius: 5em 3em;background-color: "+this.primaryColor+";color: #ffffff;justify-content: center;align-items: center;margin-left: auto;margin-top: auto;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}#insticatorEmbed #gameContainer .solo-header .trivia-button:hover {cursor: pointer;}",this.styles+="#insticatorEmbed #gameContainer .versus-header {display: block;padding-top: 0% !important;}#insticatorEmbed #gameContainer .versus-header h2 {color: "+this.primaryColor+";margin: 0 30px 0 30px;font-size: 1.6em;font-weight: 400;line-height: 2.6em;}#insticatorEmbed #gameContainer .versus-header .player-container {display: flex;display: -webkit-flex;justify-content: center;width: 100%;height: 14%;margin-bottom: 8px;}#insticatorEmbed #gameContainer .versus-header .name-score-container {display: flex;display: -webkit-flex;flex-direction: column;width: 100%;height: 100%;text-align: center;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}#insticatorEmbed #gameContainer .versus-header .score-btn-container {display: flex;display: -webkit-flex;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;height: 54%;width: 100%;border-radius: 5em 3em;background-color: "+this.primaryColor+";color: #ffffff;justify-content: center;margin-top: 5%;}",this.styles+="#insticatorEmbed #gameContainer .versus-header .score-btn-container .score-btn {font-size: 1em;font-weight: 600;align-self: center;}#insticatorEmbed #gameContainer .versus-header .score-btn-container .score-btn span {font-weight: 500;font-size: 1.05em;padding-left: 2px;}#insticatorEmbed #gameContainer .versus-header .userSide,#insticatorEmbed #gameContainer .versus-header .enemySide {display: flex;display: -webkit-flex;max-width: 50%;}#insticatorEmbed #gameContainer .versus-header .enemySide {text-align: right;float: right;}#insticatorEmbed #gameContainer .versus-header .userAvatar {display: table-cell;vertical-align: middle;height: 46px;width: 68px;margin-right: 8px;overflow: hidden;text-align: center;background-size: cover;background-repeat: no-repeat;background-position: center center;border-radius: 1em;}#insticatorEmbed #gameContainer .versus-header .userName {height: 33%;font-weight: 300;font-size: 1.4em;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}#insticatorEmbed #gameContainer .versus-header .enemyAvatar {display: table-cell;vertical-align: middle;height: 46px;width: 68px;",this.styles+="margin-left: 8px;overflow: hidden;text-align: center;background-size: cover;background-repeat: no-repeat;background-position: center center;border-radius: 1em;}#insticatorEmbed #gameContainer .versus-header .enemyName {height: 33%;font-weight: 300;font-size: 1.4em;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}@media (min-width: 300px) and (max-width: 455px) {#insticatorEmbed #gameContainer .solo-header {margin-bottom: 6px;}#insticatorEmbed #gameContainer .versus-header {width: 77%;margin-left: 6%;}#insticatorEmbed #gameContainer .versus-header h2 {margin: 0 1% 0 1%;}#insticatorEmbed #gameContainer .versus-header .userSide {max-width: 43%;}#insticatorEmbed #gameContainer .versus-header .userAvatar,#insticatorEmbed #gameContainer .versus-header .enemyAvatar {width: 54px !important;}}@media (min-width: 100px) and (max-width: 374px) {#insticatorEmbed #gameContainer .versus-header .enemySide,#insticatorEmbed #gameContainer .versus-header .userSide {width: 44%;}#insticatorEmbed #gameContainer .versus-header .userAvatar,#insticatorEmbed #gameContainer .versus-header .enemyAvatar {height: 24px;width: 34px;}#insticatorEmbed #gameContainer .versus-header .player-container {",this.styles+="height: 14%;}#insticatorEmbed #gameContainer .versus-header h2 {margin: 0 10px 0 10px;}}@media (min-width: 300px) and (max-width: 374px) {#insticatorEmbed #gameContainer .versus-header .enemyName,#insticatorEmbed #gameContainer .versus-header .userName {font-size: 1.2em;}#insticatorEmbed #gameContainer .versus-header .userAvatar,#insticatorEmbed #gameContainer .versus-header .enemyAvatar {height: 40px;}#insticatorEmbed #gameContainer .versus-header .score-btn-container .score-btn {font-size: 1em;}#insticatorEmbed #gameContainer .solo-header .userAvatar,#insticatorEmbed #gameContainer .solo-header .enemyAvatar {height: 40px;}#insticatorEmbed #gameContainer .polls-header {width: 88% !important;}#insticatorEmbed #gameContainer .polls-header .skip-button {width: 95px;}}@media (min-width: 251px) and (max-width: 299px) {#insticatorEmbed #gameContainer .polls-header {width: 88% !important;}#insticatorEmbed #gameContainer .solo-header {margin-bottom: 6px !important;}#insticatorEmbed #gameContainer .versus-header {width: 77% !important;margin-left: 6% !important;}#insticatorEmbed #gameContainer .versus-header h2 {margin: 0 1% 0 1% !important;}#insticatorEmbed #gameContainer .versus-header .userSide {max-width: 43% !important;}#insticatorEmbed #gameContainer .versus-header .userAvatar,#insticatorEmbed #gameContainer .versus-header .enemyAvatar {width: 54px !important;height: 42px !important;",this.styles+="}}@media (min-width: 100px) and (max-width: 250px) {#insticatorEmbed #gameContainer .versus-header h2 {position: absolute;font-size: 1.1em;margin-left: 28px;}#insticatorEmbed #gameContainer .versus-header .player-container {height: 14%;display: block;}#insticatorEmbed #gameContainer .versus-header .player-container .userSide,#insticatorEmbed #gameContainer .versus-header .player-container .enemySide {width: 100%;height: 50%;}#insticatorEmbed #gameContainer .versus-header .player-container .userSide .name-score-container .userName,#insticatorEmbed #gameContainer .versus-header .player-container .enemySide .name-score-container .userName,#insticatorEmbed #gameContainer .versus-header .player-container .userSide .name-score-container .enemyName,#insticatorEmbed #gameContainer .versus-header .player-container .enemySide .name-score-container .enemyName {font-size: 1em;}#insticatorEmbed #gameContainer .versus-header .player-container .userSide .name-score-container .score-btn-container .score-btn,#insticatorEmbed #gameContainer .versus-header .player-container .enemySide .name-score-container .score-btn-container .score-btn {font-size: 0.9em;}#insticatorEmbed #gameContainer .versus-header .player-container .enemySide {margin-right: 25px;}#insticatorEmbed #gameContainer .solo-header {padding-top: 5%;padding-bottom: 15px;}#insticatorEmbed #gameContainer .solo-header .trivia-button {display: none;}#insticatorEmbed #gameContainer .polls-header {width: 75%;}#insticatorEmbed #gameContainer .polls-header h1 {font-size: 1.8em;}#insticatorEmbed #gameContainer .polls-header .skip-button {width: 50px;}}#insticatorEmbed #gameContainer .question-count-bar {width: 100%;height: 7px;",this.styles+="/*position: relative;*/display: flex;justify-content: center;align-items: center;flex-direction: row;margin-bottom: 5px;}#insticatorEmbed #gameContainer .question-count-bar .question-bar-container {width: 100%;display: flex;flex-direction: row;}#insticatorEmbed #gameContainer .question-count-bar .question-bar-container .question-bar {background-color: #ededef;height: 7px;border: 1px solid #ffffff;border-radius: 5em 3em;}#insticatorEmbed #gameContainer #versusSidebars {position: absolute;z-index: -1;bottom: 0;left: 0;width: 100%;height: 82%;background-color: none;pointer-events: none;}#insticatorEmbed #gameContainer #versusSidebars .userBar,#insticatorEmbed #gameContainer #versusSidebars .enemyBar {position: absolute;z-index: -1;height: 0%;width: 1.5%;background-color: "+this.primaryColor+";-webkit-transition: all 1s ease-in;-moz-transition: all 1s ease-in;-o-transition: all 1s ease-in;transition: all 1s ease-in;margin-bottom: 4%;border-radius: 0.5em;}#insticatorEmbed #gameContainer #versusSidebars .userBar {left: 0;bottom: 0;margin-left: 1%;}#insticatorEmbed #gameContainer #versusSidebars .enemyBar {right: 0;bottom: 0;",this.styles+="margin-right: 1%;}@media (min-width: 100px) and (max-width: 300px) {#insticatorEmbed #gameContainer #versusSidebars .userBar,#insticatorEmbed #gameContainer #versusSidebars .enemyBar {margin-bottom: 10% !important;width: 3%;}#insticatorEmbed #gameContainer #versusSidebars .userBar {margin-left: 1.5%;}#insticatorEmbed #gameContainer #versusSidebars .enemyBar {margin-right: 1.5%;}}@media (min-width: 300px) and (max-width: 350px) {#insticatorEmbed #gameContainer #versusSidebars .userBar,#insticatorEmbed #gameContainer #versusSidebars .enemyBar {width: 2.3%;margin-bottom: 10%;}}@media (min-width: 351px) and (max-width: 600px) {#insticatorEmbed #gameContainer #versusSidebars .userBar,#insticatorEmbed #gameContainer #versusSidebars .enemyBar {width: 1.5% !important;}}#insticatorEmbed #gameContainer .score-container {display: table;bottom: -1px;left: 0;height: 50px;background-color: "+this.LightenDarkenColor(this.primaryColor,.2)+";box-shadow: -2em 0em 1em rgba(0, 0, 0, 0.1);font-size: 1.8em;}#insticatorEmbed #gameContainer .score-container .user-score {display: table-cell;vertical-align: middle;padding-left: 5%;line-height: 0;font-weight: 500;color: #ffffff;}#insticatorEmbed #gameContainer .score-container .user-score .smallText {font-weight: 100;font-size: .4em;}#insticatorEmbed #gameContainer .score-container .opponent-score {",this.styles+='display: table-cell;vertical-align: middle;text-align: right;padding-right: 5%;line-height: 0;font-weight: 500;color: #ffffff;}#insticatorEmbed #gameContainer .score-container .opponent-score .smallText {font-weight: 100;font-size: .4em;}#insticatorEmbed #gameContainer .score-container #pollsMessage {color: #ffffff;font-weight: 500;text-align: center;margin: auto;display: table-cell;vertical-align: middle;font-size: .95em;}#insticatorEmbed #gameContainer .score-container .VS_btn {position: absolute;display: table;font-weight: 500;text-align: center;bottom: 0;right: -2px;width: 30%;height: 50px;z-index: 1;background-color: #ffffff;cursor: pointer;}#insticatorEmbed #gameContainer .score-container .VS_btn .versusText {display: table-cell;vertical-align: middle;font-size: .8em;line-height: 90%;cursor: pointer;}#insticatorEmbed #gameContainer .score-container .VS_btn .versusText .smallText {font-weight: 100;font-size: .7em;}#insticatorEmbed #gameContainer .score-container .VS_btn::after {content: "";position: absolute;top: 0;width: 2em;',this.styles+="height: 100%;left: -1em;background-color: #ffffff;z-index: -1;transform: skew(-20deg);-webkit-transform: skew(-20deg);box-shadow: -0.1em 0em 0em rgba(0, 0, 0, 0.01);}#insticatorEmbed #gameContainer .score-container .ripple-container {position: absolute;left: 0;bottom: 0;width: 40%;height: 100%;overflow: hidden;}#insticatorEmbed #gameContainer .score-container .ripple-container .ripple {position: absolute;top: 0;left: 0;height: 0;border-radius: 50%;opacity: 0;transform-origin: 5% 5%;-webkit-transform-origin: 5% 5%;transform: scale(1.5) translate3d(-50%, -50%, 0);-webkit-transform: scale(1.5) translate3d(-50%, -50%, 0);}#insticatorEmbed #gameContainer .score-container .ripple-container .ripple.right {background-color: #30a939;}#insticatorEmbed #gameContainer .score-container .ripple-container .ripple.wrong {background-color: #e4001c;}#insticatorEmbed #gameContainer .score-container .ripple-container .ripple:nth-child(1) {width: 140%;padding-top: 140%;}#insticatorEmbed #gameContainer .score-container .ripple-container .ripple:nth-child(2) {width: 100%;padding-top: 100%;}#insticatorEmbed #gameContainer .score-container .ripple-container .ripple:nth-child(3) {width: 50%;padding-top: 50%;}#insticatorEmbed #gameContainer .score-container .rippleAnim {-webkit-animation: rippleAnim 0.7s ease-out forwards;animation: rippleAnim 0.7s ease-out forwards;}",this.styles+="@keyframes rippleAnim {0% {opacity: 0;transform: scale(0) translate3d(-50%, -50%, 0);-webkit-transform: scale(0) translate3d(-50%, -50%, 0);}50% {opacity: 1;}100% {opacity: 0;transform: scale(1.5) translate3d(-50%, -50%, 0);-webkit-transform: scale(1.5) translate3d(-50%, -50%, 0);}}#insticatorEmbed #gameContainer .score-container .enemy-ripple-container {position: absolute;right: 0;bottom: 0;width: 40%;height: 100%;overflow: hidden;transform: rotateY(-180deg);}#insticatorEmbed #gameContainer .score-container .enemy-ripple-container .ripple {position: absolute;top: 0;left: 0;height: 0;border-radius: 50%;opacity: 0;transform-origin: 5% 5%;-webkit-transform-origin: 5% 5%;transform: scale(1.5) translate3d(-50%, -50%, 0);-webkit-transform: scale(1.5) translate3d(-50%, -50%, 0);}#insticatorEmbed #gameContainer .score-container .enemy-ripple-container .ripple.right {background-color: #30a939;}#insticatorEmbed #gameContainer .score-container .enemy-ripple-container .ripple.wrong {background-color: #e4001c;}#insticatorEmbed #gameContainer .score-container .enemy-ripple-container .ripple:nth-child(1) {width: 140%;padding-top: 140%;}#insticatorEmbed #gameContainer .score-container .enemy-ripple-container .ripple:nth-child(2) {width: 100%;padding-top: 100%;}",this.styles+="#insticatorEmbed #gameContainer .score-container .enemy-ripple-container .ripple:nth-child(3) {width: 50%;padding-top: 50%;}#insticatorEmbed #gameContainer .score-container .enemyRippleAnim {-webkit-animation: enemyRippleAnim 0.7s ease-out forwards;animation: enemyRippleAnim 0.7s ease-out forwards;}@keyframes enemyRippleAnim {0% {opacity: 0;transform: scale(0) translate3d(-50%, -50%, 0);-webkit-transform: scale(0) translate3d(-50%, -50%, 0);}50% {opacity: 1;}100% {opacity: 0;transform: scale(1.5) translate3d(-50%, -50%, 0);-webkit-transform: scale(1.5) translate3d(-50%, -50%, 0);}}#insticatorEmbed #gameContainer .queCardSlider {height: 100%;width: 100%;top: 0;bottom: 0;position: absolute;display: table;background-color: "+this.primaryColor+";z-index: 101;box-shadow: 3px 3px 8px 3px rgba(38, 50, 56, 0.2), 0 8px 0 0 "+this.primaryColor+";}#insticatorEmbed #gameContainer .queCardSlider.left {-webkit-animation: queSlideLeft 2s ease-out forwards;animation: queSlideLeft 2s ease-out forwards;}#insticatorEmbed #gameContainer .queCardSlider .slider-container {height: 100%;width: 100%;display: flex;flex-direction: column;justify-content: center;align-items: center;}#insticatorEmbed #gameContainer .queCardSlider .slider-container .number-container,#insticatorEmbed #gameContainer .queCardSlider .slider-container .logo-container {display: block;}",this.styles+="#insticatorEmbed #gameContainer .queCardSlider .slider-container .number-container.hide {display: none;}#insticatorEmbed #gameContainer .queCardSlider .slider-container .logo-container {margin-top: 15px;}#insticatorEmbed #gameContainer .queCardSlider p {font-size: 30px;font-weight: 300;color: #ffffff;}@keyframes queSlideLeft {0% {left: 100%;opacity: 0;}16% {left: 0;opacity: 1;}70% {left: 0;opacity: 1;}100% {left: -150%;opacity: 0;}}@media (min-width: 100px) and (max-width: 200px) {#insticatorEmbed #gameContainer .queCardSlider p {font-size: 25px;}}#insticatorEmbed #gameContainer #questionSection {-webkit-transition: all 0.6s ease-in-out;-moz-transition: all 0.6s ease-in-out;-o-transition: all 0.6s ease-in-out;transition: all 0.6s ease-in-out;}#insticatorEmbed #gameContainer #questionSection.slideOutLeft {-ms-transform: translateX(-1000px);/* IE 9 */-webkit-transform: translateX(-1000px);/* Safari */transform: translateX(-1000px);}@keyframes slideOffLeft {0% {left: 0%;",this.styles+="}10% {left: 0%;transform: scale(0.8);}20% {left: 0%;opacity: 1;}45% {left: -200%;opacity: 0;}50% {opacity: 0;left: -200%;}51% {opacity: 0;left: -200%;}52% {opacity: 1;left: -200%;}70% {opacity: 1;left: -200%;}100% {opacity: 1;left: -200%;}}#insticatorEmbed #gameContainer .questionContainer {width: 100%;height: 118px;background-color: #ededef;}#insticatorEmbed #gameContainer .questionContainer.slideOutLeft {-webkit-animation: slideOutLeft 2s ease-in-out forwards;animation: slideOutLeft 2s ease-in-out forwards;position: relative;}@keyframes slideOutLeft {0% {left: 0%;}10% {left: 0%;",this.styles+="transform: scale(0.8);}20% {left: 0%;transform: scale(0.8);opacity: 1;}45% {transform: scale(0.8);left: -200%;opacity: 0;}50% {transform: scale(0.8);opacity: 0;left: -200%;}51% {transform: scale(0.8);opacity: 0;left: 200%;}52% {transform: scale(0.8);opacity: 1;left: 200%;}70% {transform: scale(0.8);opacity: 1;left: 0%;right: 0%;}100% {transform: scale(1);opacity: 1;left: 0%;right: 0%;}}#insticatorEmbed #gameContainer .questionContainer .question {overflow: hidden;display: flex;justify-content: center;height: 100%;position: relative;}#insticatorEmbed #gameContainer .questionContainer .question .questionImage {position: absolute;height: 100%;",this.styles+="width: 100%;left: 0;opacity: 0.16;overflow: hidden;background-size: cover;background-repeat: no-repeat;background-position: center center;}#insticatorEmbed #gameContainer .questionContainer .question .questionText {text-align: center;align-self: center;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";background-color: #ededef;font-size: 2.25em;cursor: default;padding: 0 15px 0 15px;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}#insticatorEmbed #gameContainer #questionAnswers {margin-top: 10px;}#insticatorEmbed #gameContainer #questionAnswers .answer {background-color: #ededef;color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";border-radius: 5em 3em;border: transparent;width: 100%;min-height: 22px;text-align: center;margin: 10px 0;padding: 4px;font-size: 1.55em;transition: all 0.3s ease-in;background-position: 100% 0;background-size: 200% 100%;position: relative;cursor: pointer;-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;",this.styles+='box-sizing: border-box;overflow: hidden;/* this is used so that overflow only shows the inner border-radius area */-webkit-backface-visibility: hidden;-moz-backface-visibility: hidden;backface-visibility: hidden;-webkit-transform: translate3d(0, 0, 0);-moz-transform: translate3d(0, 0, 0);transform: translate3d(0, 0, 0);}#insticatorEmbed #gameContainer #questionAnswers .answer .answer-indicator {-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;top: 0;position: absolute;opacity: 0.5;height: 100%;-webkit-transition: all 0.5s ease-in-out;-moz-transition: all 0.5s ease-in-out;-o-transition: all 0.5s ease-in-out;transition: all 0.5s ease-in-out;}#insticatorEmbed #gameContainer #questionAnswers .answer.userSelected::before {content: " ";position: absolute;z-index: 104;background-color: '+this.primaryColor+';width: 13%;height: 100%;float: left;left: 0;top: 0;border-radius: 5em 3em;padding: 0;margin: 0;opacity: 0.7;}#insticatorEmbed #gameContainer #questionAnswers .answer.enemySelected::after {content: " ";position: absolute;z-index: 104;background-color: '+this.primaryColor+";width: 13%;height: 100%;float: right;right: 0;top: 0;border-radius: 5em 3em;padding: 0;",this.styles+="margin: 0;opacity: 0.7;}#insticatorEmbed #gameContainer #questionAnswers .answer .percentageBar {-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;background: "+this.primaryColor+";top: 0;position: absolute;opacity: 0.5;height: 100%;border-radius: 5em 3em;-webkit-transition: all 0.5s ease-in-out;-moz-transition: all 0.5s ease-in-out;-o-transition: all 0.5s ease-in-out;transition: all 0.5s ease-in-out;}#insticatorEmbed #gameContainer #questionAnswers .answer.fadeAway {animation: fadeAway 1s linear forwards;pointer-events: none !important;}@keyframes fadeAway {0% {opacity: 1;}100% {opacity: 0.2;}}@keyframes barslide {0% {max-width: 0;}100% {max-width: 100%;}}#insticatorEmbed #gameContainer #questionAnswers .answer .percentageNum {position: absolute;z-index: 11;right: 0;padding-right: 3.5%;font-weight: 500;}@keyframes clickedButton {}@media (min-width: 199px) and (max-width: 301px) {#insticatorEmbed #gameContainer .questionContainer .question .specialFontClass {font-size: 1.3em !important;",this.styles+="}#insticatorEmbed #gameContainer #questionAnswers .specialAnswerFontClass {font-size: 1.2em !important;}}@media (min-width: 100px) and (max-width: 199px) {#insticatorEmbed #gameContainer .questionContainer .question .specialFontClass {font-size: 1em !important;}#insticatorEmbed #gameContainer #questionAnswers .specialAnswerFontClass {font-size: 0.9em !important;}}@media (min-width: 100px) and (max-width: 199px) {#insticatorEmbed #gameContainer #questionAnswers .answer {min-height: 12px;line-height: 12px;font-size: 1.25em;}#insticatorEmbed #gameContainer #questionAnswers .answer .percentageNum {display: none !important;}#insticatorEmbed #gameContainer .questionContainer {height: 120px;}#insticatorEmbed #gameContainer .questionContainer .question .questionText {-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;font-size: 1.45em;}}@media (min-width: 200px) and (max-width: 450px) {#insticatorEmbed #gameContainer #questionAnswers .answer {font-size: 1.4em;}#insticatorEmbed #gameContainer .questionContainer .question .questionText {font-size: 1.7em;}}@media (max-height: 350px) {#insticatorEmbed #gameContainer #questionAnswers .answer {margin: 8px 0;}#insticatorEmbed #gameContainer .questionContainer .question {margin-top: 5px;margin-bottom: 0;",this.styles+="width: 100%;}#insticatorEmbed #gameContainer .questionContainer .question .questionText {color: "+this.LightenDarkenColor(this.secondaryColor,-.85)+";background-color: #ededef;font-weight: 500;}#insticatorEmbed #gameContainer #questionAnswers {margin-top: 8px;}}#insticatorEmbed #gameContainer .versus-searching-container {padding: 4%;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;height: 100%;width: 100%;left: 0;top: 0;position: absolute;display: table;background-color: #ffffff;z-index: 100;}#insticatorEmbed #gameContainer .versus-searching-container .top-container {width: 100%;height: 10%;}#insticatorEmbed #gameContainer .versus-searching-container .search-container {align-self: center;width: 100%;height: 80%;display: flex;display: -webkit-flex;justify-content: center;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .middle-vs-container h2 {line-height: 9.3em;margin: 0 10px 0 10px;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box {border-radius: 0.5em;align-self: center;width: 175px;height: 160px;overflow: hidden;display: flex;display: -webkit-flex;justify-content: center;",this.styles+="align-items: center;flex-direction: column;text-align: center;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box .name {font-size: 1.6em;margin-bottom: 6px;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box .loader {height: 96px;width: 100%;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box .avatar {height: 95px;width: 75px;overflow: hidden;text-align: center;background-size: cover;background-repeat: no-repeat;background-position: center center;border-radius: 1em;border-color: none;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .user-box {background-color: "+this.primaryColor+";color: #ffffff;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .enemy-box {background-color: #fefeff;color: "+this.primaryColor+";}#insticatorEmbed #gameContainer .versus-searching-container .search-container .enemy-box .searching-text {background-color: none;font-size: 1.1em;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .enemy-box.opponentFound {background-color: #ededef !important;}@media (min-width: 100px) and (max-width: 250px) {#insticatorEmbed #gameContainer .versus-searching-container .top-container {margin-top: 5px;}#insticatorEmbed #gameContainer .versus-searching-container .search-container {flex-direction: column;align-items: center;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .middle-vs-container {margin: 20px 0 20px 0;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .middle-vs-container h2 {",this.styles+='line-height: 0px;font-size: 2.2em;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .middle-vs-container::after {content: "";}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box {height: 45%;width: 96%;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box .loader {padding-top: 0 !important;height: 65px !important;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box .avatar {height: 60px;width: 56px;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .enemy-box .searching-text {padding-bottom: 0 !important;margin: 0 auto;bottom: 0;}}@media (min-width: 250px) and (max-width: 450px) {#insticatorEmbed #gameContainer .versus-searching-container .search-container .middle-vs-container {border-radius: 50%;background: #ffffff;height: 40px;width: 40px;align-self: center;display: flex;display: -webkit-flex;justify-content: center;align-items: center;font-size: 2em;font-weight: 600;color: '+this.primaryColor+';position: relative;margin: -20px;padding: 0;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .middle-vs-container h2 {display: none;}#insticatorEmbed #gameContainer .versus-searching-container .search-container .middle-vs-container::after {content: "VS";}#insticatorEmbed #gameContainer .versus-searching-container .search-container .box {height: 60%;',this.styles+="width: 50%;}}#insticatorEmbed #gameContainer .imagePlaceholder {height: 100px;border-top-left-radius: 0.4em;border-top-right-radius: 0.4em;width: 100%;background-color: "+this.primaryColor+";text-align: center;display: flex;justify-content: center;}#insticatorEmbed #gameContainer .imagePlaceholder #title {color: #ffffff;font-size: 1.8em;font-weight: 100;align-self: center;}@media (min-width: 100px) and (max-width: 250px) {#insticatorEmbed #poweredByInSlider p,#insticatorEmbed #poweredBy p {display: none;}#insticatorEmbed #poweredByInSlider {height: 3% !important;padding-bottom: 1% !important;}#insticatorEmbed #poweredByInSlider p {font-size: 0.8em !important;}}@media (min-width: 100px) and (max-width: 450px) {#gameContainer .headLine h1:first-of-type {width: 160px;}}@media (min-width: 191px) and (max-width: 239px) {#gameContainer .headLine h3 {font-size: 0.9em;}#insticatorEmbed #poweredByInSlider p {font-size: 0.8em;}}@media (min-width: 150px) and (max-width: 190px) {#gameContainer .headLine {margin: 0 0 10px 0 !important;padding-top: 52px !important;text-align: center;",this.styles+="}#gameContainer .headLine p {font-size: 1.1em !important;}#gameContainer .headLine h3 {font-size: 1.2em;}#gameContainer .headLine h1:first-of-type {width: 100% !important;padding-top: 0 !important;}}@media (max-height: 350px) {.headLine h1 br {display: none;}#insticatorEmbed .leaderBoardSlider {padding: 4%;}#insticatorEmbed .leaderBoardSlider .topContainer {margin-top: 0;}#insticatorEmbed .leaderBoardSlider .backBtnContainer {display: none;}#insticatorEmbed .leaderBoardSlider .btn.leader-board-icon {display: none;}#insticatorEmbed .leaderBoardSlider .rankingList li .userIdenitity .userName {font-size: 1.3em;}#insticatorEmbed .leaderBoardSlider .rankingList li .userIdenitity .rankImage {height: 30px;width: 30px;}#insticatorEmbed .leaderBoardSlider .rankingList li .scoreBox .points {bottom: -3px;}#insticatorEmbed #gameContainer #versusSidebars .userBar,#insticatorEmbed #gameContainer #versusSidebars .enemyBar {opacity: .8;width: 2%;}#insticatorEmbed #gameContainer #versusSidebars .enemyBar,#insticatorEmbed #gameContainer #versusSidebars .userBar {margin-bottom: 4%;border-radius: 0.5em;}#insticatorEmbed #gameContainer .versus-player-container .userImage {width: 8em;",this.styles+="height: 8em;}#insticatorEmbed #gameContainer .score-container {height: 35px;}#insticatorEmbed #gameContainer .score-container .VS_btn {height: 35px;}}"}return i(t,e),t.prototype.getUpdatedStyle=function(){return this.styles},t.prototype.LightenDarkenColor=function(e,t){var n=parseInt(e.slice(1),16),i=t<0?0:255,r=t<0?t*-1:t,o=n>>16,s=n>>8&255,a=255&n;return"#"+(16777216+65536*(Math.round((i-o)*r)+o)+256*(Math.round((i-s)*r)+s)+(Math.round((i-a)*r)+a)).toString(16).slice(1)},t}(r.Component);Object.defineProperty(t,"__esModule",{value:!0}),t.default=o}]);
//# sourceMappingURL=bundle.js.map