var mod_pagespeed_$q8qcT18Q7 = "/*!\n\nHolder - 2.3.2 - client side image placeholders\n(c) 2012-2014 Ivan Malopinsky / http://imsky.co\n\nProvided under the MIT License.\nCommercial use requires attribution.\n\n*/\nvar Holder = Holder || {};\n(function (app, win) {\nvar system_config = {\n	use_svg: false,\n	use_canvas: false,\n	use_fallback: false\n};\nvar instance_config = {};\nvar preempted = false;\ncanvas = document.createElement('canvas');\nvar dpr = 1, bsr = 1;\nvar resizable_images = [];\n\nif (!canvas.getContext) {\n	system_config.use_fallback = true;\n} else {\n	if (canvas.toDataURL(\"image/png\")\n		.indexOf(\"data:image/png\") < 0) {\n		//Android doesn't support data URI\n		system_config.use_fallback = true;\n	} else {\n		var ctx = canvas.getContext(\"2d\");\n	}\n}\n\nif(!!document.createElementNS && !!document.createElementNS('http://www.w3.org/2000/svg', 'svg').createSVGRect){\n	system_config.use_svg = true;\n	system_config.use_canvas = false;\n}\n\nif(!system_config.use_fallback){\n    dpr = window.devicePixelRatio || 1,\n    bsr = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;\n}\n\nvar ratio = dpr / bsr;\n\nvar settings = {\n	domain: \"holder.js\",\n	images: \"img\",\n	bgnodes: \".holderjs\",\n	themes: {\n		\"gray\": {\n			background: \"#eee\",\n			foreground: \"#aaa\",\n			size: 12\n		},\n		\"social\": {\n			background: \"#3a5a97\",\n			foreground: \"#fff\",\n			size: 12\n		},\n		\"industrial\": {\n			background: \"#434A52\",\n			foreground: \"#C2F200\",\n			size: 12\n		},\n		\"sky\": {\n			background: \"#0D8FDB\",\n			foreground: \"#fff\",\n			size: 12\n		},\n		\"vine\": {\n			background: \"#39DBAC\",\n			foreground: \"#1E292C\",\n			size: 12\n		},\n		\"lava\": {\n			background: \"#F8591A\",\n			foreground: \"#1C2846\",\n			size: 12\n		}\n	},\n	stylesheet: \"\"\n};\napp.flags = {\n	dimensions: {\n		regex: /^(\\d+)x(\\d+)$/,\n		output: function (val) {\n			var exec = this.regex.exec(val);\n			return {\n				width: +exec[1],\n				height: +exec[2]\n			}\n		}\n	},\n	fluid: {\n		regex: /^([0-9%]+)x([0-9%]+)$/,\n		output: function (val) {\n			var exec = this.regex.exec(val);\n			return {\n				width: exec[1],\n				height: exec[2]\n			}\n		}\n	},\n	colors: {\n		regex: /#([0-9a-f]{3,})\\:#([0-9a-f]{3,})/i,\n		output: function (val) {\n			var exec = this.regex.exec(val);\n			return {\n				size: settings.themes.gray.size,\n				foreground: \"#\" + exec[2],\n				background: \"#\" + exec[1]\n			}\n		}\n	},\n	text: {\n		regex: /text\\:(.*)/,\n		output: function (val) {\n			return this.regex.exec(val)[1];\n		}\n	},\n	font: {\n		regex: /font\\:(.*)/,\n		output: function (val) {\n			return this.regex.exec(val)[1];\n		}\n	},\n	auto: {\n		regex: /^auto$/\n	},\n	textmode: {\n		regex: /textmode\\:(.*)/,\n		output: function(val){\n			return this.regex.exec(val)[1];\n		}\n	}\n}\n\nfunction text_size(width, height, template) {\n	height = parseInt(height, 10);\n	width = parseInt(width, 10);\n	var bigSide = Math.max(height, width)\n	var smallSide = Math.min(height, width)\n	var scale = 1 / 12;\n	var newHeight = Math.min(smallSide * 0.75, 0.75 * bigSide * scale);\n	return {\n		height: Math.round(Math.max(template.size, newHeight))\n	}\n}\n\nvar svg_el = (function(){\n	//Prevent IE <9 from initializing SVG renderer\n	if(!window.XMLSerializer) return;\n	var serializer = new XMLSerializer();\n	var svg_ns = \"http://www.w3.org/2000/svg\"\n	var svg = document.createElementNS(svg_ns, \"svg\");\n	//IE throws an exception if this is set and Chrome requires it to be set\n	if(svg.webkitMatchesSelector){\n		svg.setAttribute(\"xmlns\", \"http://www.w3.org/2000/svg\")\n	}\n	var bg_el = document.createElementNS(svg_ns, \"rect\")\n	var text_el = document.createElementNS(svg_ns, \"text\")\n	var textnode_el = document.createTextNode(null)\n	text_el.setAttribute(\"text-anchor\", \"middle\")\n	text_el.appendChild(textnode_el)\n	svg.appendChild(bg_el)\n	svg.appendChild(text_el)\n\n	return function(props){\n		svg.setAttribute(\"width\",props.width);\n		svg.setAttribute(\"height\", props.height);\n		bg_el.setAttribute(\"width\", props.width);\n		bg_el.setAttribute(\"height\", props.height);\n		bg_el.setAttribute(\"fill\", props.template.background);\n		text_el.setAttribute(\"x\", props.width/2)\n		text_el.setAttribute(\"y\", props.height/2)\n		textnode_el.nodeValue=props.text\n		text_el.setAttribute(\"style\", css_properties({\n		\"fill\": props.template.foreground,\n		\"font-weight\": \"bold\",\n		\"font-size\": props.text_height+\"px\",\n		\"font-family\":props.font,\n		\"dominant-baseline\":\"central\"\n		}))\n		return serializer.serializeToString(svg)\n	}\n})()\n\nfunction css_properties(props){\n	var ret = [];\n	for(p in props){\n		if(props.hasOwnProperty(p)){\n			ret.push(p+\":\"+props[p])\n		}\n	}\n	return ret.join(\";\")\n}\n\nfunction draw_canvas(args) {\n	var ctx = args.ctx,\n		dimensions = args.dimensions,\n		template = args.template,\n		ratio = args.ratio,\n		holder = args.holder,\n		literal = holder.textmode == \"literal\",\n		exact = holder.textmode == \"exact\";\n\n	var ts = text_size(dimensions.width, dimensions.height, template);\n	var text_height = ts.height;\n	var width = dimensions.width * ratio,\n		height = dimensions.height * ratio;\n	var font = template.font ? template.font : \"Arial,Helvetica,sans-serif\";\n	canvas.width = width;\n	canvas.height = height;\n	ctx.textAlign = \"center\";\n	ctx.textBaseline = \"middle\";\n	ctx.fillStyle = template.background;\n	ctx.fillRect(0, 0, width, height);\n	ctx.fillStyle = template.foreground;\n	ctx.font = \"bold \" + text_height + \"px \" + font;\n	var text = template.text ? template.text : (Math.floor(dimensions.width) + \"x\" + Math.floor(dimensions.height));\n	if (literal) {\n		var dimensions = holder.dimensions;\n		text = dimensions.width + \"x\" + dimensions.height;\n	}\n	else if(exact && holder.exact_dimensions){\n		var dimensions = holder.exact_dimensions;\n		text = (Math.floor(dimensions.width) + \"x\" + Math.floor(dimensions.height));\n	}\n	var text_width = ctx.measureText(text).width;\n	if (text_width / width >= 0.75) {\n		text_height = Math.floor(text_height * 0.75 * (width / text_width));\n	}\n	//Resetting font size if necessary\n	ctx.font = \"bold \" + (text_height * ratio) + \"px \" + font;\n	ctx.fillText(text, (width / 2), (height / 2), width);\n	return canvas.toDataURL(\"image/png\");\n}\n\nfunction draw_svg(args){\n	var dimensions = args.dimensions,\n		template = args.template,\n		holder = args.holder,\n		literal = holder.textmode == \"literal\",\n		exact = holder.textmode == \"exact\";\n\n	var ts = text_size(dimensions.width, dimensions.height, template);\n	var text_height = ts.height;\n	var width = dimensions.width,\n		height = dimensions.height;\n		\n	var font = template.font ? template.font : \"Arial,Helvetica,sans-serif\";\n	var text = template.text ? template.text : (Math.floor(dimensions.width) + \"x\" + Math.floor(dimensions.height));\n	\n	if (literal) {\n		var dimensions = holder.dimensions;\n		text = dimensions.width + \"x\" + dimensions.height;\n	}\n	else if(exact && holder.exact_dimensions){\n		var dimensions = holder.exact_dimensions;\n		text = (Math.floor(dimensions.width) + \"x\" + Math.floor(dimensions.height));\n	}\n	var string = svg_el({\n		text: text, \n		width:width, \n		height:height, \n		text_height:text_height, \n		font:font, \n		template:template\n	})\n	return \"data:image/svg+xml;base64,\"+btoa(unescape(encodeURIComponent(string)));\n}\n\nfunction draw(args) {\n	if(instance_config.use_canvas && !instance_config.use_svg){\n		return draw_canvas(args);\n	}\n	else{\n		return draw_svg(args);\n	}\n}\n\nfunction render(mode, el, holder, src) {\n	var dimensions = holder.dimensions,\n		theme = holder.theme,\n		text = holder.text ? decodeURIComponent(holder.text) : holder.text;\n	var dimensions_caption = dimensions.width + \"x\" + dimensions.height;\n	theme = (text ? extend(theme, {\n		text: text\n	}) : theme);\n	theme = (holder.font ? extend(theme, {\n		font: holder.font\n	}) : theme);\n	el.setAttribute(\"data-src\", src);\n	holder.theme = theme;\n	el.holder_data = holder;\n	\n	if (mode == \"image\") {\n		el.setAttribute(\"alt\", text ? text : theme.text ? theme.text + \" [\" + dimensions_caption + \"]\" : dimensions_caption);\n		if (instance_config.use_fallback || !holder.auto) {\n			el.style.width = dimensions.width + \"px\";\n			el.style.height = dimensions.height + \"px\";\n		}\n		if (instance_config.use_fallback) {\n			el.style.backgroundColor = theme.background;\n		} else {\n			el.setAttribute(\"src\", draw({ctx: ctx, dimensions: dimensions, template: theme, ratio:ratio, holder: holder}));\n			\n			if(holder.textmode && holder.textmode == \"exact\"){\n				resizable_images.push(el);\n				resizable_update(el);\n			}\n			\n		}\n	} else if (mode == \"background\") {\n		if (!instance_config.use_fallback) {\n			el.style.backgroundImage = \"url(\" + draw({ctx:ctx, dimensions: dimensions, template: theme, ratio: ratio, holder: holder}) + \")\";\n			el.style.backgroundSize = dimensions.width + \"px \" + dimensions.height + \"px\";\n		}\n	} else if (mode == \"fluid\") {\n		el.setAttribute(\"alt\", text ? text : theme.text ? theme.text + \" [\" + dimensions_caption + \"]\" : dimensions_caption);\n		if (dimensions.height.slice(-1) == \"%\") {\n			el.style.height = dimensions.height\n		} else if(holder.auto == null || !holder.auto){\n			el.style.height = dimensions.height + \"px\"\n		}\n		if (dimensions.width.slice(-1) == \"%\") {\n			el.style.width = dimensions.width\n		} else if(holder.auto == null || !holder.auto){\n			el.style.width = dimensions.width + \"px\"\n		}\n		if (el.style.display == \"inline\" || el.style.display === \"\" || el.style.display == \"none\") {\n			el.style.display = \"block\";\n		}\n		\n		set_initial_dimensions(el)\n		\n		if (instance_config.use_fallback) {\n			el.style.backgroundColor = theme.background;\n		} else {\n			resizable_images.push(el);\n			resizable_update(el);\n		}\n	}\n}\n\nfunction dimension_check(el, callback) {\n	var dimensions = {\n		height: el.clientHeight,\n		width: el.clientWidth\n	};\n	if (!dimensions.height && !dimensions.width) {\n		el.setAttribute(\"data-holder-invisible\", true)\n		callback.call(this, el)\n	}\n	else{\n		el.removeAttribute(\"data-holder-invisible\")\n		return dimensions;\n	}\n}\n\nfunction set_initial_dimensions(el){\n	if(el.holder_data){\n		var dimensions = dimension_check(el, app.invisible_error_fn( set_initial_dimensions))\n		if(dimensions){\n			var holder = el.holder_data;\n			holder.initial_dimensions = dimensions;\n			holder.fluid_data = {\n				fluid_height: holder.dimensions.height.slice(-1) == \"%\",\n				fluid_width: holder.dimensions.width.slice(-1) == \"%\",\n				mode: null\n			}\n			if(holder.fluid_data.fluid_width && !holder.fluid_data.fluid_height){\n				holder.fluid_data.mode = \"width\"\n				holder.fluid_data.ratio = holder.initial_dimensions.width / parseFloat(holder.dimensions.height)\n			}\n			else if(!holder.fluid_data.fluid_width && holder.fluid_data.fluid_height){\n				holder.fluid_data.mode = \"height\";\n				holder.fluid_data.ratio = parseFloat(holder.dimensions.width) / holder.initial_dimensions.height\n			}\n		}\n	}\n}\n\nfunction resizable_update(element) {\n	var images;\n	if (element.nodeType == null) {\n		images = resizable_images;\n	} else {\n		images = [element]\n	}\n	for (var i in images) {\n		if (!images.hasOwnProperty(i)) {\n			continue;\n		}\n		var el = images[i]\n		if (el.holder_data) {\n			var holder = el.holder_data;\n			var dimensions = dimension_check(el, app.invisible_error_fn( resizable_update))\n			if(dimensions){\n				if(holder.fluid){\n					if(holder.auto){\n						switch(holder.fluid_data.mode){\n							case \"width\":\n								dimensions.height = dimensions.width / holder.fluid_data.ratio;\n							break;\n							case \"height\":\n								dimensions.width = dimensions.height * holder.fluid_data.ratio;\n							break;\n						}\n					}\n					el.setAttribute(\"src\", draw({\n						ctx: ctx,\n						dimensions: dimensions,\n						template: holder.theme,\n						ratio: ratio,\n						holder: holder\n					}))\n				}\n				if(holder.textmode && holder.textmode == \"exact\"){\n					holder.exact_dimensions = dimensions;\n					el.setAttribute(\"src\", draw({\n						ctx: ctx,\n						dimensions: holder.dimensions,\n						template: holder.theme,\n						ratio: ratio,\n						holder: holder\n					}))\n				}\n			}\n		}\n	}\n}\n\nfunction parse_flags(flags, options) {\n	var ret = {\n		theme: extend(settings.themes.gray, {})\n	};\n	var render = false;\n	for (var fl = flags.length, j = 0; j < fl; j++) {\n		var flag = flags[j];\n		if (app.flags.dimensions.match(flag)) {\n			render = true;\n			ret.dimensions = app.flags.dimensions.output(flag);\n		} else if (app.flags.fluid.match(flag)) {\n			render = true;\n			ret.dimensions = app.flags.fluid.output(flag);\n			ret.fluid = true;\n		} else if (app.flags.textmode.match(flag)) {\n			ret.textmode = app.flags.textmode.output(flag)\n		} else if (app.flags.colors.match(flag)) {\n			ret.theme = app.flags.colors.output(flag);\n		} else if (options.themes[flag]) {\n			//If a theme is specified, it will override custom colors\n			if(options.themes.hasOwnProperty(flag)){\n				ret.theme = extend(options.themes[flag], {});\n			}\n		} else if (app.flags.font.match(flag)) {\n			ret.font = app.flags.font.output(flag);\n		} else if (app.flags.auto.match(flag)) {\n			ret.auto = true;\n		} else if (app.flags.text.match(flag)) {\n			ret.text = app.flags.text.output(flag);\n		}\n	}\n	return render ? ret : false;\n}\n\nfor (var flag in app.flags) {\n	if (!app.flags.hasOwnProperty(flag)) continue;\n	app.flags[flag].match = function (val) {\n		return val.match(this.regex)\n	}\n}\n\napp.invisible_error_fn = function(fn){\n	return function(el){\n		if(el.hasAttribute(\"data-holder-invisible\")){\n			throw new Error(\"Holder: invisible placeholder\")\n		}\n	}\n}\n\napp.add_theme = function (name, theme) {\n	name != null && theme != null && (settings.themes[name] = theme);\n	return app;\n};\n\napp.add_image = function (src, el) {\n	var node = selector(el);\n	if (node.length) {\n		for (var i = 0, l = node.length; i < l; i++) {\n			var img = document.createElement(\"img\")\n			img.setAttribute(\"data-src\", src);\n			node[i].appendChild(img);\n		}\n	}\n	return app;\n};\n\napp.run = function (o) {\n\n	instance_config = extend({}, system_config)\n	preempted = true;\n\n	var options = extend(settings, o),\n		images = [],\n		imageNodes = [],\n		bgnodes = [];\n\n	if(options.use_canvas != null && options.use_canvas){\n		instance_config.use_canvas = true;\n		instance_config.use_svg = false;\n	}\n			\n	if (typeof (options.images) == \"string\") {\n		imageNodes = selector(options.images);\n	} else if (window.NodeList && options.images instanceof window.NodeList) {\n		imageNodes = options.images;\n	} else if (window.Node && options.images instanceof window.Node) {\n		imageNodes = [options.images];\n	} else if(window.HTMLCollection && options.images instanceof window.HTMLCollection){\n		imageNodes = options.images\n	}\n\n	if (typeof (options.bgnodes) == \"string\") {\n		bgnodes = selector(options.bgnodes);\n	} else if (window.NodeList && options.elements instanceof window.NodeList) {\n		bgnodes = options.bgnodes;\n	} else if (window.Node && options.bgnodes instanceof window.Node) {\n		bgnodes = [options.bgnodes];\n	}\n	for (i = 0, l = imageNodes.length; i < l; i++) images.push(imageNodes[i]);\n	\n	var holdercss = document.getElementById(\"holderjs-style\");\n	if (!holdercss) {\n		holdercss = document.createElement(\"style\");\n		holdercss.setAttribute(\"id\", \"holderjs-style\");\n		holdercss.type = \"text/css\";\n		document.getElementsByTagName(\"head\")[0].appendChild(holdercss);\n	}\n	\n	if (!options.nocss) {\n		if (holdercss.styleSheet) {\n			holdercss.styleSheet.cssText += options.stylesheet;\n		} else {\n			if(options.stylesheet.length){\n				holdercss.appendChild(document.createTextNode(options.stylesheet));\n			}\n		}\n	}\n	\n	var cssregex = new RegExp(options.domain + \"\\/(.*?)\\\"?\\\\)\");\n	for (var l = bgnodes.length, i = 0; i < l; i++) {\n		var src = window.getComputedStyle(bgnodes[i], null)\n			.getPropertyValue(\"background-image\");\n		var flags = src.match(cssregex);\n		var bgsrc = bgnodes[i].getAttribute(\"data-background-src\");\n		if (flags) {\n			var holder = parse_flags(flags[1].split(\"/\"), options);\n			if (holder) {\n				render(\"background\", bgnodes[i], holder, src);\n			}\n		} else if (bgsrc != null) {\n			var holder = parse_flags(bgsrc.substr(bgsrc.lastIndexOf(options.domain) + options.domain.length + 1)\n				.split(\"/\"), options);\n			if (holder) {\n				render(\"background\", bgnodes[i], holder, src);\n			}\n		}\n	}\n	for (l = images.length, i = 0; i < l; i++) {\n		var attr_data_src, attr_src;\n		attr_src = attr_data_src = src = null;\n		try {\n			attr_src = images[i].getAttribute(\"src\");\n			attr_datasrc = images[i].getAttribute(\"data-src\");\n		} catch (e) {}\n		if (attr_datasrc == null && !! attr_src && attr_src.indexOf(options.domain) >= 0) {\n			src = attr_src;\n		} else if ( !! attr_datasrc && attr_datasrc.indexOf(options.domain) >= 0) {\n			src = attr_datasrc;\n		}\n		if (src) {\n			var holder = parse_flags(src.substr(src.lastIndexOf(options.domain) + options.domain.length + 1).split(\"/\"), options);\n			if (holder) {\n				if (holder.fluid) {\n					render(\"fluid\", images[i], holder, src)\n				} else {\n					render(\"image\", images[i], holder, src);\n				}\n			}\n		}\n	}\n	return app;\n};\n\ncontentLoaded(win, function () {\n	if (window.addEventListener) {\n		window.addEventListener(\"resize\", resizable_update, false);\n		window.addEventListener(\"orientationchange\", resizable_update, false);\n	} else {\n		window.attachEvent(\"onresize\", resizable_update)\n	}\n	preempted || app.run({});\n\n	if (typeof window.Turbolinks === \"object\") {\n		document.addEventListener(\"page:change\", function() { app.run({}) })\n	}\n});\nif (typeof define === \"function\" && define.amd) {\n	define([], function () {\n		return app;\n	});\n}\n\n//github.com/davidchambers/Base64.js\n(function(){function t(t){this.message=t}var e=\"undefined\"!=typeof exports?exports:this,r=\"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\";t.prototype=Error(),t.prototype.name=\"InvalidCharacterError\",e.btoa||(e.btoa=function(e){for(var o,n,a=0,i=r,c=\"\";e.charAt(0|a)||(i=\"=\",a%1);c+=i.charAt(63&o>>8-8*(a%1))){if(n=e.charCodeAt(a+=.75),n>255)throw new t(\"'btoa' failed\");o=o<<8|n}return c}),e.atob||(e.atob=function(e){if(e=e.replace(/=+$/,\"\"),1==e.length%4)throw new t(\"'atob' failed\");for(var o,n,a=0,i=0,c=\"\";n=e.charAt(i++);~n&&(o=a%4?64*o+n:n,a++%4)?c+=String.fromCharCode(255&o>>(6&-2*a)):0)n=r.indexOf(n);return c})})();\n\n//getElementsByClassName polyfill\ndocument.getElementsByClassName||(document.getElementsByClassName=function(e){var t=document,n,r,i,s=[];if(t.querySelectorAll)return t.querySelectorAll(\".\"+e);if(t.evaluate){r=\".//*[contains(concat(' ', @class, ' '), ' \"+e+\" ')]\",n=t.evaluate(r,t,null,0,null);while(i=n.iterateNext())s.push(i)}else{n=t.getElementsByTagName(\"*\"),r=new RegExp(\"(^|\\\\s)\"+e+\"(\\\\s|$)\");for(i=0;i<n.length;i++)r.test(n[i].className)&&s.push(n[i])}return s})\n\n//getComputedStyle polyfill\nwindow.getComputedStyle||(window.getComputedStyle=function(e){return this.el=e,this.getPropertyValue=function(t){var n=/(\\-([a-z]){1})/g;return t==\"float\"&&(t=\"styleFloat\"),n.test(t)&&(t=t.replace(n,function(){return arguments[2].toUpperCase()})),e.currentStyle[t]?e.currentStyle[t]:null},this})\n\n//http://javascript.nwbox.com/ContentLoaded by Diego Perini with modifications\nfunction contentLoaded(n,t){var l=\"complete\",s=\"readystatechange\",u=!1,h=u,c=!0,i=n.document,a=i.documentElement,e=i.addEventListener?\"addEventListener\":\"attachEvent\",v=i.addEventListener?\"removeEventListener\":\"detachEvent\",f=i.addEventListener?\"\":\"on\",r=function(e){(e.type!=s||i.readyState==l)&&((e.type==\"load\"?n:i)[v](f+e.type,r,u),!h&&(h=!0)&&t.call(n,null))},o=function(){try{a.doScroll(\"left\")}catch(n){setTimeout(o,50);return}r(\"poll\")};if(i.readyState==l)t.call(n,\"lazy\");else{if(i.createEventObject&&a.doScroll){try{c=!n.frameElement}catch(y){}c&&o()}i[e](f+\"DOMContentLoaded\",r,u),i[e](f+s,r,u),n[e](f+\"load\",r,u)}}\n\n//https://gist.github.com/991057 by Jed Schmidt with modifications\nfunction selector(a,b){var a=a.match(/^(\\W)?(.*)/),b=b||document,c=b[\"getElement\"+(a[1]?\"#\"==a[1]?\"ById\":\"sByClassName\":\"sByTagName\")],d=c.call(b,a[2]),e=[];return null!==d&&(e=d.length||0===d.length?d:[d]),e}\n\n//shallow object property extend\nfunction extend(a,b){\n	var c={};\n	for(var i in a){\n		if(a.hasOwnProperty(i)){\n			c[i]=a[i];\n		}\n	}\n	for(var i in b){\n		if(b.hasOwnProperty(i)){\n			c[i]=b[i];\n		}\n	}\n	return c\n}\n\n//hasOwnProperty polyfill\nif (!Object.prototype.hasOwnProperty)\n    /*jshint -W001, -W103 */\n    Object.prototype.hasOwnProperty = function(prop) {\n		var proto = this.__proto__ || this.constructor.prototype;\n		return (prop in this) && (!(prop in proto) || proto[prop] !== this[prop]);\n	}\n    /*jshint +W001, +W103 */\n\n})(Holder, window);\n";
var mod_pagespeed_SZtZ4zU2p9 = "/*!\r\n * Lazy Load - jQuery plugin for lazy loading images\r\n *\r\n * Copyright (c) 2007-2015 Mika Tuupola\r\n *\r\n * Licensed under the MIT license:\r\n *   http://www.opensource.org/licenses/mit-license.php\r\n *\r\n * Project home:\r\n *   http://www.appelsiini.net/projects/lazyload\r\n *\r\n * Version:  1.9.5\r\n *\r\n */\r\n\r\n(function($, window, document, undefined) {\r\n    var $window = $(window);\r\n\r\n    $.fn.lazyload = function(options) {\r\n        var elements = this;\r\n        var $container;\r\n        var settings = {\r\n            threshold       : 0,\r\n            failure_limit   : 0,\r\n            event           : \"scroll\",\r\n            effect          : \"show\",\r\n            container       : window,\r\n            data_attribute  : \"original\",\r\n            skip_invisible  : false,\r\n            appear          : null,\r\n            load            : null,\r\n            placeholder     : \"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsQAAA7EAZUrDhsAAAANSURBVBhXYzh8+PB/AAffA0nNPuCLAAAAAElFTkSuQmCC\"\r\n        };\r\n\r\n        function update() {\r\n            var counter = 0;\r\n\r\n            elements.each(function() {\r\n                var $this = $(this);\r\n                if (settings.skip_invisible && !$this.is(\":visible\")) {\r\n                    return;\r\n                }\r\n                if ($.abovethetop(this, settings) ||\r\n                    $.leftofbegin(this, settings)) {\r\n                        /* Nothing. */\r\n                } else if (!$.belowthefold(this, settings) &&\r\n                    !$.rightoffold(this, settings)) {\r\n                        $this.trigger(\"appear\");\r\n                        /* if we found an image we'll load, reset the counter */\r\n                        counter = 0;\r\n                } else {\r\n                    if (++counter > settings.failure_limit) {\r\n                        return false;\r\n                    }\r\n                }\r\n            });\r\n\r\n        }\r\n\r\n        if(options) {\r\n            /* Maintain BC for a couple of versions. */\r\n            if (undefined !== options.failurelimit) {\r\n                options.failure_limit = options.failurelimit;\r\n                delete options.failurelimit;\r\n            }\r\n            if (undefined !== options.effectspeed) {\r\n                options.effect_speed = options.effectspeed;\r\n                delete options.effectspeed;\r\n            }\r\n\r\n            $.extend(settings, options);\r\n        }\r\n\r\n        /* Cache container as jQuery as object. */\r\n        $container = (settings.container === undefined ||\r\n                      settings.container === window) ? $window : $(settings.container);\r\n\r\n        /* Fire one scroll event per scroll. Not one scroll event per image. */\r\n        if (0 === settings.event.indexOf(\"scroll\")) {\r\n            $container.bind(settings.event, function() {\r\n                return update();\r\n            });\r\n        }\r\n\r\n        this.each(function() {\r\n            var self = this;\r\n            var $self = $(self);\r\n\r\n            self.loaded = false;\r\n\r\n            /* If no src attribute given use data:uri. */\r\n            if ($self.attr(\"src\") === undefined || $self.attr(\"src\") === false) {\r\n                if ($self.is(\"img\")) {\r\n                    $self.attr(\"src\", settings.placeholder);\r\n                }\r\n            }\r\n\r\n            /* When appear is triggered load original image. */\r\n            $self.one(\"appear\", function() {\r\n                if (!this.loaded) {\r\n                    if (settings.appear) {\r\n                        var elements_left = elements.length;\r\n                        settings.appear.call(self, elements_left, settings);\r\n                    }\r\n                    $(\"<img />\")\r\n                        .bind(\"load\", function() {\r\n\r\n                            var original = $self.attr(\"data-\" + settings.data_attribute);\r\n                            $self.hide();\r\n                            if ($self.is(\"img\")) {\r\n                                $self.attr(\"src\", original);\r\n                            } else {\r\n                                $self.css(\"background-image\", \"url('\" + original + \"')\");\r\n                            }\r\n                            $self[settings.effect](settings.effect_speed);\r\n\r\n                            self.loaded = true;\r\n\r\n                            /* Remove image from array so it is not looped next time. */\r\n                            var temp = $.grep(elements, function(element) {\r\n                                return !element.loaded;\r\n                            });\r\n                            elements = $(temp);\r\n\r\n                            if (settings.load) {\r\n                                var elements_left = elements.length;\r\n                                settings.load.call(self, elements_left, settings);\r\n                            }\r\n                        })\r\n                        .attr(\"src\", $self.attr(\"data-\" + settings.data_attribute));\r\n                }\r\n            });\r\n\r\n            /* When wanted event is triggered load original image */\r\n            /* by triggering appear.                              */\r\n            if (0 !== settings.event.indexOf(\"scroll\")) {\r\n                $self.bind(settings.event, function() {\r\n                    if (!self.loaded) {\r\n                        $self.trigger(\"appear\");\r\n                    }\r\n                });\r\n            }\r\n        });\r\n\r\n        /* Check if something appears when window is resized. */\r\n        $window.bind(\"resize\", function() {\r\n            update();\r\n        });\r\n\r\n        /* With IOS5 force loading images when navigating with back button. */\r\n        /* Non optimal workaround. */\r\n        if ((/(?:iphone|ipod|ipad).*os 5/gi).test(navigator.appVersion)) {\r\n            $window.bind(\"pageshow\", function(event) {\r\n                if (event.originalEvent && event.originalEvent.persisted) {\r\n                    elements.each(function() {\r\n                        $(this).trigger(\"appear\");\r\n                    });\r\n                }\r\n            });\r\n        }\r\n\r\n        /* Force initial check if images should appear. */\r\n        $(document).ready(function() {\r\n            update();\r\n        });\r\n\r\n        return this;\r\n    };\r\n\r\n    /* Convenience methods in jQuery namespace.           */\r\n    /* Use as  $.belowthefold(element, {threshold : 100, container : window}) */\r\n\r\n    $.belowthefold = function(element, settings) {\r\n        var fold;\r\n\r\n        if (settings.container === undefined || settings.container === window) {\r\n            fold = (window.innerHeight ? window.innerHeight : $window.height()) + $window.scrollTop();\r\n        } else {\r\n            fold = $(settings.container).offset().top + $(settings.container).height();\r\n        }\r\n\r\n        return fold <= $(element).offset().top - settings.threshold;\r\n    };\r\n\r\n    $.rightoffold = function(element, settings) {\r\n        var fold;\r\n\r\n        if (settings.container === undefined || settings.container === window) {\r\n            fold = $window.width() + $window.scrollLeft();\r\n        } else {\r\n            fold = $(settings.container).offset().left + $(settings.container).width();\r\n        }\r\n\r\n        return fold <= $(element).offset().left - settings.threshold;\r\n    };\r\n\r\n    $.abovethetop = function(element, settings) {\r\n        var fold;\r\n\r\n        if (settings.container === undefined || settings.container === window) {\r\n            fold = $window.scrollTop();\r\n        } else {\r\n            fold = $(settings.container).offset().top;\r\n        }\r\n\r\n        return fold >= $(element).offset().top + settings.threshold  + $(element).height();\r\n    };\r\n\r\n    $.leftofbegin = function(element, settings) {\r\n        var fold;\r\n\r\n        if (settings.container === undefined || settings.container === window) {\r\n            fold = $window.scrollLeft();\r\n        } else {\r\n            fold = $(settings.container).offset().left;\r\n        }\r\n\r\n        return fold >= $(element).offset().left + settings.threshold + $(element).width();\r\n    };\r\n\r\n    $.inviewport = function(element, settings) {\r\n         return !$.rightoffold(element, settings) && !$.leftofbegin(element, settings) &&\r\n                !$.belowthefold(element, settings) && !$.abovethetop(element, settings);\r\n     };\r\n\r\n    /* Custom selectors for your convenience.   */\r\n    /* Use as $(\"img:below-the-fold\").something() or */\r\n    /* $(\"img\").filter(\":below-the-fold\").something() which is faster */\r\n\r\n    $.extend($.expr[\":\"], {\r\n        \"below-the-fold\" : function(a) { return $.belowthefold(a, {threshold : 0}); },\r\n        \"above-the-top\"  : function(a) { return !$.belowthefold(a, {threshold : 0}); },\r\n        \"right-of-screen\": function(a) { return $.rightoffold(a, {threshold : 0}); },\r\n        \"left-of-screen\" : function(a) { return !$.rightoffold(a, {threshold : 0}); },\r\n        \"in-viewport\"    : function(a) { return $.inviewport(a, {threshold : 0}); },\r\n        /* Maintain BC for couple of versions. */\r\n        \"above-the-fold\" : function(a) { return !$.belowthefold(a, {threshold : 0}); },\r\n        \"right-of-fold\"  : function(a) { return $.rightoffold(a, {threshold : 0}); },\r\n        \"left-of-fold\"   : function(a) { return !$.rightoffold(a, {threshold : 0}); }\r\n    });\r\n\r\n})(jQuery, window, document);";
var mod_pagespeed_phuQoKswz2 = "/*!\n * imagesLoaded PACKAGED v3.1.8\n * JavaScript is all like \"You images are done yet or what?\"\n * MIT License\n */\n\n(function(){function e(){}function t(e,t){for(var n=e.length;n--;)if(e[n].listener===t)return n;return-1}function n(e){return function(){return this[e].apply(this,arguments)}}var i=e.prototype,r=this,o=r.EventEmitter;i.getListeners=function(e){var t,n,i=this._getEvents();if(\"object\"==typeof e){t={};for(n in i)i.hasOwnProperty(n)&&e.test(n)&&(t[n]=i[n])}else t=i[e]||(i[e]=[]);return t},i.flattenListeners=function(e){var t,n=[];for(t=0;e.length>t;t+=1)n.push(e[t].listener);return n},i.getListenersAsObject=function(e){var t,n=this.getListeners(e);return n instanceof Array&&(t={},t[e]=n),t||n},i.addListener=function(e,n){var i,r=this.getListenersAsObject(e),o=\"object\"==typeof n;for(i in r)r.hasOwnProperty(i)&&-1===t(r[i],n)&&r[i].push(o?n:{listener:n,once:!1});return this},i.on=n(\"addListener\"),i.addOnceListener=function(e,t){return this.addListener(e,{listener:t,once:!0})},i.once=n(\"addOnceListener\"),i.defineEvent=function(e){return this.getListeners(e),this},i.defineEvents=function(e){for(var t=0;e.length>t;t+=1)this.defineEvent(e[t]);return this},i.removeListener=function(e,n){var i,r,o=this.getListenersAsObject(e);for(r in o)o.hasOwnProperty(r)&&(i=t(o[r],n),-1!==i&&o[r].splice(i,1));return this},i.off=n(\"removeListener\"),i.addListeners=function(e,t){return this.manipulateListeners(!1,e,t)},i.removeListeners=function(e,t){return this.manipulateListeners(!0,e,t)},i.manipulateListeners=function(e,t,n){var i,r,o=e?this.removeListener:this.addListener,s=e?this.removeListeners:this.addListeners;if(\"object\"!=typeof t||t instanceof RegExp)for(i=n.length;i--;)o.call(this,t,n[i]);else for(i in t)t.hasOwnProperty(i)&&(r=t[i])&&(\"function\"==typeof r?o.call(this,i,r):s.call(this,i,r));return this},i.removeEvent=function(e){var t,n=typeof e,i=this._getEvents();if(\"string\"===n)delete i[e];else if(\"object\"===n)for(t in i)i.hasOwnProperty(t)&&e.test(t)&&delete i[t];else delete this._events;return this},i.removeAllListeners=n(\"removeEvent\"),i.emitEvent=function(e,t){var n,i,r,o,s=this.getListenersAsObject(e);for(r in s)if(s.hasOwnProperty(r))for(i=s[r].length;i--;)n=s[r][i],n.once===!0&&this.removeListener(e,n.listener),o=n.listener.apply(this,t||[]),o===this._getOnceReturnValue()&&this.removeListener(e,n.listener);return this},i.trigger=n(\"emitEvent\"),i.emit=function(e){var t=Array.prototype.slice.call(arguments,1);return this.emitEvent(e,t)},i.setOnceReturnValue=function(e){return this._onceReturnValue=e,this},i._getOnceReturnValue=function(){return this.hasOwnProperty(\"_onceReturnValue\")?this._onceReturnValue:!0},i._getEvents=function(){return this._events||(this._events={})},e.noConflict=function(){return r.EventEmitter=o,e},\"function\"==typeof define&&define.amd?define(\"eventEmitter/EventEmitter\",[],function(){return e}):\"object\"==typeof module&&module.exports?module.exports=e:this.EventEmitter=e}).call(this),function(e){function t(t){var n=e.event;return n.target=n.target||n.srcElement||t,n}var n=document.documentElement,i=function(){};n.addEventListener?i=function(e,t,n){e.addEventListener(t,n,!1)}:n.attachEvent&&(i=function(e,n,i){e[n+i]=i.handleEvent?function(){var n=t(e);i.handleEvent.call(i,n)}:function(){var n=t(e);i.call(e,n)},e.attachEvent(\"on\"+n,e[n+i])});var r=function(){};n.removeEventListener?r=function(e,t,n){e.removeEventListener(t,n,!1)}:n.detachEvent&&(r=function(e,t,n){e.detachEvent(\"on\"+t,e[t+n]);try{delete e[t+n]}catch(i){e[t+n]=void 0}});var o={bind:i,unbind:r};\"function\"==typeof define&&define.amd?define(\"eventie/eventie\",o):e.eventie=o}(this),function(e,t){\"function\"==typeof define&&define.amd?define([\"eventEmitter/EventEmitter\",\"eventie/eventie\"],function(n,i){return t(e,n,i)}):\"object\"==typeof exports?module.exports=t(e,require(\"wolfy87-eventemitter\"),require(\"eventie\")):e.imagesLoaded=t(e,e.EventEmitter,e.eventie)}(window,function(e,t,n){function i(e,t){for(var n in t)e[n]=t[n];return e}function r(e){return\"[object Array]\"===d.call(e)}function o(e){var t=[];if(r(e))t=e;else if(\"number\"==typeof e.length)for(var n=0,i=e.length;i>n;n++)t.push(e[n]);else t.push(e);return t}function s(e,t,n){if(!(this instanceof s))return new s(e,t);\"string\"==typeof e&&(e=document.querySelectorAll(e)),this.elements=o(e),this.options=i({},this.options),\"function\"==typeof t?n=t:i(this.options,t),n&&this.on(\"always\",n),this.getImages(),a&&(this.jqDeferred=new a.Deferred);var r=this;setTimeout(function(){r.check()})}function f(e){this.img=e}function c(e){this.src=e,v[e]=this}var a=e.jQuery,u=e.console,h=u!==void 0,d=Object.prototype.toString;s.prototype=new t,s.prototype.options={},s.prototype.getImages=function(){this.images=[];for(var e=0,t=this.elements.length;t>e;e++){var n=this.elements[e];\"IMG\"===n.nodeName&&this.addImage(n);var i=n.nodeType;if(i&&(1===i||9===i||11===i))for(var r=n.querySelectorAll(\"img\"),o=0,s=r.length;s>o;o++){var f=r[o];this.addImage(f)}}},s.prototype.addImage=function(e){var t=new f(e);this.images.push(t)},s.prototype.check=function(){function e(e,r){return t.options.debug&&h&&u.log(\"confirm\",e,r),t.progress(e),n++,n===i&&t.complete(),!0}var t=this,n=0,i=this.images.length;if(this.hasAnyBroken=!1,!i)return this.complete(),void 0;for(var r=0;i>r;r++){var o=this.images[r];o.on(\"confirm\",e),o.check()}},s.prototype.progress=function(e){this.hasAnyBroken=this.hasAnyBroken||!e.isLoaded;var t=this;setTimeout(function(){t.emit(\"progress\",t,e),t.jqDeferred&&t.jqDeferred.notify&&t.jqDeferred.notify(t,e)})},s.prototype.complete=function(){var e=this.hasAnyBroken?\"fail\":\"done\";this.isComplete=!0;var t=this;setTimeout(function(){if(t.emit(e,t),t.emit(\"always\",t),t.jqDeferred){var n=t.hasAnyBroken?\"reject\":\"resolve\";t.jqDeferred[n](t)}})},a&&(a.fn.imagesLoaded=function(e,t){var n=new s(this,e,t);return n.jqDeferred.promise(a(this))}),f.prototype=new t,f.prototype.check=function(){var e=v[this.img.src]||new c(this.img.src);if(e.isConfirmed)return this.confirm(e.isLoaded,\"cached was confirmed\"),void 0;if(this.img.complete&&void 0!==this.img.naturalWidth)return this.confirm(0!==this.img.naturalWidth,\"naturalWidth\"),void 0;var t=this;e.on(\"confirm\",function(e,n){return t.confirm(e.isLoaded,n),!0}),e.check()},f.prototype.confirm=function(e,t){this.isLoaded=e,this.emit(\"confirm\",this,t)};var v={};return c.prototype=new t,c.prototype.check=function(){if(!this.isChecked){var e=new Image;n.bind(e,\"load\",this),n.bind(e,\"error\",this),e.src=this.src,this.isChecked=!0}},c.prototype.handleEvent=function(e){var t=\"on\"+e.type;this[t]&&this[t](e)},c.prototype.onload=function(e){this.confirm(!0,\"onload\"),this.unbindProxyEvents(e)},c.prototype.onerror=function(e){this.confirm(!1,\"onerror\"),this.unbindProxyEvents(e)},c.prototype.confirm=function(e,t){this.isConfirmed=!0,this.isLoaded=e,this.emit(\"confirm\",this,t)},c.prototype.unbindProxyEvents=function(e){n.unbind(e.target,\"load\",this),n.unbind(e.target,\"error\",this)},s});";
var mod_pagespeed_PQXKm34Ma1 = "(function($){$.formatCurrency={};$.formatCurrency.regions=[];$.formatCurrency.regions[\"\"]={symbol:\"$\",positiveFormat:\"%s%n\",negativeFormat:\"(%s%n)\",decimalSymbol:\".\",digitGroupSymbol:\",\",groupDigits:true};\n$.fn.formatCurrency=function(destination,settings){if(arguments.length==1&&typeof destination!==\"string\"){settings=destination;destination=false\n}var defaults={name:\"formatCurrency\",colorize:false,region:\"\",global:true,roundToDecimalPlace:2,eventOnDecimalsEntered:false};defaults=$.extend(defaults,$.formatCurrency.regions[\"\"]);\nsettings=$.extend(defaults,settings);if(settings.region.length>0){settings=$.extend(settings,getRegionOrCulture(settings.region))}settings.regex=generateRegex(settings);\nreturn this.each(function(){$this=$(this);var num=\"0\";num=$this[$this.is(\"input, select, textarea\")?\"val\":\"html\"]();if(num.search(\"\\\\(\")>=0){num=\"-\"+num\n}if(num===\"\"){return}if(isNaN(num)){num=num.replace(settings.regex,\"\");if(num===\"\"){return}if(settings.decimalSymbol!=\".\"){num=num.replace(settings.decimalSymbol,\".\")\n}if(isNaN(num)){num=\"0\"}}var numParts=String(num).split(\".\");var isPositive=(num==Math.abs(num));var hasDecimals=(numParts.length>1);var decimals=(hasDecimals?numParts[1].toString():\"0\");\nvar originalDecimals=decimals;num=Math.abs(numParts[0]);if(settings.roundToDecimalPlace>=0){decimals=parseFloat(\"1.\"+decimals);decimals=decimals.toFixed(settings.roundToDecimalPlace);\nif(decimals.substring(0,1)==\"2\"){num=Number(num)+1}decimals=decimals.substring(2)}num=String(num);if(settings.groupDigits){for(var i=0;i<Math.floor((num.length-(1+i))/3);\ni++){num=num.substring(0,num.length-(4*i+3))+settings.digitGroupSymbol+num.substring(num.length-(4*i+3))}}if((hasDecimals&&settings.roundToDecimalPlace==-1)||settings.roundToDecimalPlace>0){num+=settings.decimalSymbol+decimals\n}var format=isPositive?settings.positiveFormat:settings.negativeFormat;var money=format.replace(/%s/g,settings.symbol);money=money.replace(/%n/g,num);\nvar $destination=$([]);if(!destination){$destination=$this}else{$destination=$(destination)}$destination[$destination.is(\"input, select, textarea\")?\"val\":\"html\"](money);\nif(hasDecimals&&settings.eventOnDecimalsEntered){$destination.trigger(\"decimalsEntered\",originalDecimals)}if(settings.colorize){$destination.css(\"color\",isPositive?\"black\":\"red\")\n}})};$.fn.toNumber=function(settings){var defaults=$.extend({name:\"toNumber\",region:\"\",global:true},$.formatCurrency.regions[\"\"]);settings=jQuery.extend(defaults,settings);\nif(settings.region.length>0){settings=$.extend(settings,getRegionOrCulture(settings.region))}settings.regex=generateRegex(settings);return this.each(function(){var method=$(this).is(\"input, select, textarea\")?\"val\":\"html\";\n$(this)[method]($(this)[method]().replace(\"(\",\"(-\").replace(settings.regex,\"\"))})};$.fn.asNumber=function(settings){var defaults=$.extend({name:\"asNumber\",region:\"\",parse:true,parseType:\"Float\",global:true},$.formatCurrency.regions[\"\"]);\nsettings=jQuery.extend(defaults,settings);if(settings.region.length>0){settings=$.extend(settings,getRegionOrCulture(settings.region))}settings.regex=generateRegex(settings);\nsettings.parseType=validateParseType(settings.parseType);var method=$(this).is(\"input, select, textarea\")?\"val\":\"html\";var num=$(this)[method]();\nnum=num?num:\"\";num=num.replace(\"(\",\"(-\");num=num.replace(settings.regex,\"\");if(!settings.parse){return num}if(num.length==0){num=\"0\"}if(settings.decimalSymbol!=\".\"){num=num.replace(settings.decimalSymbol,\".\")\n}return window[\"parse\"+settings.parseType](num)};function getRegionOrCulture(region){var regionInfo=$.formatCurrency.regions[region];if(regionInfo){return regionInfo\n}else{if(/(\\w+)-(\\w+)/g.test(region)){var culture=region.replace(/(\\w+)-(\\w+)/g,\"$1\");return $.formatCurrency.regions[culture]}}return null}function validateParseType(parseType){switch(parseType.toLowerCase()){case\"int\":return\"Int\";\ncase\"float\":return\"Float\";default:throw\"invalid parseType\"}}function generateRegex(settings){if(settings.symbol===\"\"){return new RegExp(\"[^\\\\d\"+settings.decimalSymbol+\"-]\",\"g\")\n}else{var symbol=settings.symbol.replace(\"$\",\"\\\\$\").replace(\".\",\"\\\\.\");return new RegExp(symbol+\"|[^\\\\d\"+settings.decimalSymbol+\"-]\",\"g\")}}})(jQuery);";
var mod_pagespeed_fd1WpbgZMP = "/*\r\n    jQuery Masked Input Plugin\r\n    Copyright (c) 2007 - 2015 Josh Bush (digitalbush.com)\r\n    Licensed under the MIT license (http://digitalbush.com/projects/masked-input-plugin/#license)\r\n    Version: 1.4.1\r\n*/\r\n!function(a){\"function\"==typeof define&&define.amd?define([\"jquery\"],a):a(\"object\"==typeof exports?require(\"jquery\"):jQuery)}(function(a){var b,c=navigator.userAgent,d=/iphone/i.test(c),e=/chrome/i.test(c),f=/android/i.test(c);a.mask={definitions:{9:\"[0-9]\",a:\"[A-Za-z]\",\"*\":\"[A-Za-z0-9]\"},autoclear:!0,dataName:\"rawMaskFn\",placeholder:\"_\"},a.fn.extend({caret:function(a,b){var c;if(0!==this.length&&!this.is(\":hidden\"))return\"number\"==typeof a?(b=\"number\"==typeof b?b:a,this.each(function(){this.setSelectionRange?this.setSelectionRange(a,b):this.createTextRange&&(c=this.createTextRange(),c.collapse(!0),c.moveEnd(\"character\",b),c.moveStart(\"character\",a),c.select())})):(this[0].setSelectionRange?(a=this[0].selectionStart,b=this[0].selectionEnd):document.selection&&document.selection.createRange&&(c=document.selection.createRange(),a=0-c.duplicate().moveStart(\"character\",-1e5),b=a+c.text.length),{begin:a,end:b})},unmask:function(){return this.trigger(\"unmask\")},mask:function(c,g){var h,i,j,k,l,m,n,o;if(!c&&this.length>0){h=a(this[0]);var p=h.data(a.mask.dataName);return p?p():void 0}return g=a.extend({autoclear:a.mask.autoclear,placeholder:a.mask.placeholder,completed:null},g),i=a.mask.definitions,j=[],k=n=c.length,l=null,a.each(c.split(\"\"),function(a,b){\"?\"==b?(n--,k=a):i[b]?(j.push(new RegExp(i[b])),null===l&&(l=j.length-1),k>a&&(m=j.length-1)):j.push(null)}),this.trigger(\"unmask\").each(function(){function h(){if(g.completed){for(var a=l;m>=a;a++)if(j[a]&&C[a]===p(a))return;g.completed.call(B)}}function p(a){return g.placeholder.charAt(a<g.placeholder.length?a:0)}function q(a){for(;++a<n&&!j[a];);return a}function r(a){for(;--a>=0&&!j[a];);return a}function s(a,b){var c,d;if(!(0>a)){for(c=a,d=q(b);n>c;c++)if(j[c]){if(!(n>d&&j[c].test(C[d])))break;C[c]=C[d],C[d]=p(d),d=q(d)}z(),B.caret(Math.max(l,a))}}function t(a){var b,c,d,e;for(b=a,c=p(a);n>b;b++)if(j[b]){if(d=q(b),e=C[b],C[b]=c,!(n>d&&j[d].test(e)))break;c=e}}function u(){var a=B.val(),b=B.caret();if(o&&o.length&&o.length>a.length){for(A(!0);b.begin>0&&!j[b.begin-1];)b.begin--;if(0===b.begin)for(;b.begin<l&&!j[b.begin];)b.begin++;B.caret(b.begin,b.begin)}else{for(A(!0);b.begin<n&&!j[b.begin];)b.begin++;B.caret(b.begin,b.begin)}h()}function v(){A(),B.val()!=E&&B.change()}function w(a){if(!B.prop(\"readonly\")){var b,c,e,f=a.which||a.keyCode;o=B.val(),8===f||46===f||d&&127===f?(b=B.caret(),c=b.begin,e=b.end,e-c===0&&(c=46!==f?r(c):e=q(c-1),e=46===f?q(e):e),y(c,e),s(c,e-1),a.preventDefault()):13===f?v.call(this,a):27===f&&(B.val(E),B.caret(0,A()),a.preventDefault())}}function x(b){if(!B.prop(\"readonly\")){var c,d,e,g=b.which||b.keyCode,i=B.caret();if(!(b.ctrlKey||b.altKey||b.metaKey||32>g)&&g&&13!==g){if(i.end-i.begin!==0&&(y(i.begin,i.end),s(i.begin,i.end-1)),c=q(i.begin-1),n>c&&(d=String.fromCharCode(g),j[c].test(d))){if(t(c),C[c]=d,z(),e=q(c),f){var k=function(){a.proxy(a.fn.caret,B,e)()};setTimeout(k,0)}else B.caret(e);i.begin<=m&&h()}b.preventDefault()}}}function y(a,b){var c;for(c=a;b>c&&n>c;c++)j[c]&&(C[c]=p(c))}function z(){B.val(C.join(\"\"))}function A(a){var b,c,d,e=B.val(),f=-1;for(b=0,d=0;n>b;b++)if(j[b]){for(C[b]=p(b);d++<e.length;)if(c=e.charAt(d-1),j[b].test(c)){C[b]=c,f=b;break}if(d>e.length){y(b+1,n);break}}else C[b]===e.charAt(d)&&d++,k>b&&(f=b);return a?z():k>f+1?g.autoclear||C.join(\"\")===D?(B.val()&&B.val(\"\"),y(0,n)):z():(z(),B.val(B.val().substring(0,f+1))),k?b:l}var B=a(this),C=a.map(c.split(\"\"),function(a,b){return\"?\"!=a?i[a]?p(b):a:void 0}),D=C.join(\"\"),E=B.val();B.data(a.mask.dataName,function(){return a.map(C,function(a,b){return j[b]&&a!=p(b)?a:null}).join(\"\")}),B.one(\"unmask\",function(){B.off(\".mask\").removeData(a.mask.dataName)}).on(\"focus.mask\",function(){if(!B.prop(\"readonly\")){clearTimeout(b);var a;E=B.val(),a=A(),b=setTimeout(function(){B.get(0)===document.activeElement&&(z(),a==c.replace(\"?\",\"\").length?B.caret(0,a):B.caret(a))},10)}}).on(\"blur.mask\",v).on(\"keydown.mask\",w).on(\"keypress.mask\",x).on(\"input.mask paste.mask\",function(){B.prop(\"readonly\")||setTimeout(function(){var a=A(!0);B.caret(a),h()},0)}),e&&f&&B.off(\"input.mask\").on(\"input.mask\",u),A()})}})});";
var mod_pagespeed_WuW9pTamD1 = "/*!\n * jQuery Validation Plugin v1.14.0\n * http://jqueryvalidation.org/\n *\n * Copyright (c) 2015 Jörn Zaefferer\n * Released under the MIT license\n */\n(function( factory ) {\n	if ( typeof define === \"function\" && define.amd ) {\n		define( [\"jquery\"], factory );\n	} else {\n		factory( jQuery );\n	}\n}(function( $ ) {\n\n$.extend($.fn, {\n	// http://jqueryvalidation.org/validate/\n	validate: function( options ) {\n\n		// if nothing is selected, return nothing; can't chain anyway\n		if ( !this.length ) {\n			if ( options && options.debug && window.console ) {\n				console.warn( \"Nothing selected, can't validate, returning nothing.\" );\n			}\n			return;\n		}\n\n		// check if a validator for this form was already created\n		var validator = $.data( this[ 0 ], \"validator\" );\n		if ( validator ) {\n			return validator;\n		}\n\n		// Add novalidate tag if HTML5.\n		this.attr( \"novalidate\", \"novalidate\" );\n\n		validator = new $.validator( options, this[ 0 ] );\n		$.data( this[ 0 ], \"validator\", validator );\n\n		if ( validator.settings.onsubmit ) {\n\n			this.on( \"click.validate\", \":submit\", function( event ) {\n				if ( validator.settings.submitHandler ) {\n					validator.submitButton = event.target;\n				}\n\n				// allow suppressing validation by adding a cancel class to the submit button\n				if ( $( this ).hasClass( \"cancel\" ) ) {\n					validator.cancelSubmit = true;\n				}\n\n				// allow suppressing validation by adding the html5 formnovalidate attribute to the submit button\n				if ( $( this ).attr( \"formnovalidate\" ) !== undefined ) {\n					validator.cancelSubmit = true;\n				}\n			});\n\n			// validate the form on submit\n			this.on( \"submit.validate\", function( event ) {\n				if ( validator.settings.debug ) {\n					// prevent form submit to be able to see console output\n					event.preventDefault();\n				}\n				function handle() {\n					var hidden, result;\n					if ( validator.settings.submitHandler ) {\n						if ( validator.submitButton ) {\n							// insert a hidden input as a replacement for the missing submit button\n							hidden = $( \"<input type='hidden'/>\" )\n								.attr( \"name\", validator.submitButton.name )\n								.val( $( validator.submitButton ).val() )\n								.appendTo( validator.currentForm );\n						}\n						result = validator.settings.submitHandler.call( validator, validator.currentForm, event );\n						if ( validator.submitButton ) {\n							// and clean up afterwards; thanks to no-block-scope, hidden can be referenced\n							hidden.remove();\n						}\n						if ( result !== undefined ) {\n							return result;\n						}\n						return false;\n					}\n					return true;\n				}\n\n				// prevent submit for invalid forms or custom submit handlers\n				if ( validator.cancelSubmit ) {\n					validator.cancelSubmit = false;\n					return handle();\n				}\n				if ( validator.form() ) {\n					if ( validator.pendingRequest ) {\n						validator.formSubmitted = true;\n						return false;\n					}\n					return handle();\n				} else {\n					validator.focusInvalid();\n					return false;\n				}\n			});\n		}\n\n		return validator;\n	},\n	// http://jqueryvalidation.org/valid/\n	valid: function() {\n		var valid, validator, errorList;\n\n		if ( $( this[ 0 ] ).is( \"form\" ) ) {\n			valid = this.validate().form();\n		} else {\n			errorList = [];\n			valid = true;\n			validator = $( this[ 0 ].form ).validate();\n			this.each( function() {\n				valid = validator.element( this ) && valid;\n				errorList = errorList.concat( validator.errorList );\n			});\n			validator.errorList = errorList;\n		}\n		return valid;\n	},\n\n	// http://jqueryvalidation.org/rules/\n	rules: function( command, argument ) {\n		var element = this[ 0 ],\n			settings, staticRules, existingRules, data, param, filtered;\n\n		if ( command ) {\n			settings = $.data( element.form, \"validator\" ).settings;\n			staticRules = settings.rules;\n			existingRules = $.validator.staticRules( element );\n			switch ( command ) {\n			case \"add\":\n				$.extend( existingRules, $.validator.normalizeRule( argument ) );\n				// remove messages from rules, but allow them to be set separately\n				delete existingRules.messages;\n				staticRules[ element.name ] = existingRules;\n				if ( argument.messages ) {\n					settings.messages[ element.name ] = $.extend( settings.messages[ element.name ], argument.messages );\n				}\n				break;\n			case \"remove\":\n				if ( !argument ) {\n					delete staticRules[ element.name ];\n					return existingRules;\n				}\n				filtered = {};\n				$.each( argument.split( /\\s/ ), function( index, method ) {\n					filtered[ method ] = existingRules[ method ];\n					delete existingRules[ method ];\n					if ( method === \"required\" ) {\n						$( element ).removeAttr( \"aria-required\" );\n					}\n				});\n				return filtered;\n			}\n		}\n\n		data = $.validator.normalizeRules(\n		$.extend(\n			{},\n			$.validator.classRules( element ),\n			$.validator.attributeRules( element ),\n			$.validator.dataRules( element ),\n			$.validator.staticRules( element )\n		), element );\n\n		// make sure required is at front\n		if ( data.required ) {\n			param = data.required;\n			delete data.required;\n			data = $.extend( { required: param }, data );\n			$( element ).attr( \"aria-required\", \"true\" );\n		}\n\n		// make sure remote is at back\n		if ( data.remote ) {\n			param = data.remote;\n			delete data.remote;\n			data = $.extend( data, { remote: param });\n		}\n\n		return data;\n	}\n});\n\n// Custom selectors\n$.extend( $.expr[ \":\" ], {\n	// http://jqueryvalidation.org/blank-selector/\n	blank: function( a ) {\n		return !$.trim( \"\" + $( a ).val() );\n	},\n	// http://jqueryvalidation.org/filled-selector/\n	filled: function( a ) {\n		return !!$.trim( \"\" + $( a ).val() );\n	},\n	// http://jqueryvalidation.org/unchecked-selector/\n	unchecked: function( a ) {\n		return !$( a ).prop( \"checked\" );\n	}\n});\n\n// constructor for validator\n$.validator = function( options, form ) {\n	this.settings = $.extend( true, {}, $.validator.defaults, options );\n	this.currentForm = form;\n	this.init();\n};\n\n// http://jqueryvalidation.org/jQuery.validator.format/\n$.validator.format = function( source, params ) {\n	if ( arguments.length === 1 ) {\n		return function() {\n			var args = $.makeArray( arguments );\n			args.unshift( source );\n			return $.validator.format.apply( this, args );\n		};\n	}\n	if ( arguments.length > 2 && params.constructor !== Array  ) {\n		params = $.makeArray( arguments ).slice( 1 );\n	}\n	if ( params.constructor !== Array ) {\n		params = [ params ];\n	}\n	$.each( params, function( i, n ) {\n		source = source.replace( new RegExp( \"\\\\{\" + i + \"\\\\}\", \"g\" ), function() {\n			return n;\n		});\n	});\n	return source;\n};\n\n$.extend( $.validator, {\n\n	defaults: {\n		messages: {},\n		groups: {},\n		rules: {},\n		errorClass: \"error\",\n		validClass: \"valid\",\n		errorElement: \"label\",\n		focusCleanup: false,\n		focusInvalid: true,\n		errorContainer: $( [] ),\n		errorLabelContainer: $( [] ),\n		onsubmit: true,\n		ignore: \":hidden\",\n		ignoreTitle: false,\n		onfocusin: function( element ) {\n			this.lastActive = element;\n\n			// Hide error label and remove error class on focus if enabled\n			if ( this.settings.focusCleanup ) {\n				if ( this.settings.unhighlight ) {\n					this.settings.unhighlight.call( this, element, this.settings.errorClass, this.settings.validClass );\n				}\n				this.hideThese( this.errorsFor( element ) );\n			}\n		},\n		onfocusout: function( element ) {\n			if ( !this.checkable( element ) && ( element.name in this.submitted || !this.optional( element ) ) ) {\n				this.element( element );\n			}\n		},\n		onkeyup: function( element, event ) {\n			// Avoid revalidate the field when pressing one of the following keys\n			// Shift       => 16\n			// Ctrl        => 17\n			// Alt         => 18\n			// Caps lock   => 20\n			// End         => 35\n			// Home        => 36\n			// Left arrow  => 37\n			// Up arrow    => 38\n			// Right arrow => 39\n			// Down arrow  => 40\n			// Insert      => 45\n			// Num lock    => 144\n			// AltGr key   => 225\n			var excludedKeys = [\n				16, 17, 18, 20, 35, 36, 37,\n				38, 39, 40, 45, 144, 225\n			];\n\n			if ( event.which === 9 && this.elementValue( element ) === \"\" || $.inArray( event.keyCode, excludedKeys ) !== -1 ) {\n				return;\n			} else if ( element.name in this.submitted || element === this.lastElement ) {\n				this.element( element );\n			}\n		},\n		onclick: function( element ) {\n			// click on selects, radiobuttons and checkboxes\n			if ( element.name in this.submitted ) {\n				this.element( element );\n\n			// or option elements, check parent select in that case\n			} else if ( element.parentNode.name in this.submitted ) {\n				this.element( element.parentNode );\n			}\n		},\n		highlight: function( element, errorClass, validClass ) {\n			if ( element.type === \"radio\" ) {\n				this.findByName( element.name ).addClass( errorClass ).removeClass( validClass );\n			} else {\n				$( element ).addClass( errorClass ).removeClass( validClass );\n			}\n		},\n		unhighlight: function( element, errorClass, validClass ) {\n			if ( element.type === \"radio\" ) {\n				this.findByName( element.name ).removeClass( errorClass ).addClass( validClass );\n			} else {\n				$( element ).removeClass( errorClass ).addClass( validClass );\n			}\n		}\n	},\n\n	// http://jqueryvalidation.org/jQuery.validator.setDefaults/\n	setDefaults: function( settings ) {\n		$.extend( $.validator.defaults, settings );\n	},\n\n	messages: {\n		required: \"This field is required.\",\n		remote: \"Please fix this field.\",\n		email: \"Please enter a valid email address.\",\n		url: \"Please enter a valid URL.\",\n		date: \"Please enter a valid date.\",\n		dateISO: \"Please enter a valid date ( ISO ).\",\n		number: \"Please enter a valid number.\",\n		digits: \"Please enter only digits.\",\n		creditcard: \"Please enter a valid credit card number.\",\n		equalTo: \"Please enter the same value again.\",\n		maxlength: $.validator.format( \"Please enter no more than {0} characters.\" ),\n		minlength: $.validator.format( \"Please enter at least {0} characters.\" ),\n		rangelength: $.validator.format( \"Please enter a value between {0} and {1} characters long.\" ),\n		range: $.validator.format( \"Please enter a value between {0} and {1}.\" ),\n		max: $.validator.format( \"Please enter a value less than or equal to {0}.\" ),\n		min: $.validator.format( \"Please enter a value greater than or equal to {0}.\" )\n	},\n\n	autoCreateRanges: false,\n\n	prototype: {\n\n		init: function() {\n			this.labelContainer = $( this.settings.errorLabelContainer );\n			this.errorContext = this.labelContainer.length && this.labelContainer || $( this.currentForm );\n			this.containers = $( this.settings.errorContainer ).add( this.settings.errorLabelContainer );\n			this.submitted = {};\n			this.valueCache = {};\n			this.pendingRequest = 0;\n			this.pending = {};\n			this.invalid = {};\n			this.reset();\n\n			var groups = ( this.groups = {} ),\n				rules;\n			$.each( this.settings.groups, function( key, value ) {\n				if ( typeof value === \"string\" ) {\n					value = value.split( /\\s/ );\n				}\n				$.each( value, function( index, name ) {\n					groups[ name ] = key;\n				});\n			});\n			rules = this.settings.rules;\n			$.each( rules, function( key, value ) {\n				rules[ key ] = $.validator.normalizeRule( value );\n			});\n\n			function delegate( event ) {\n				var validator = $.data( this.form, \"validator\" ),\n					eventType = \"on\" + event.type.replace( /^validate/, \"\" ),\n					settings = validator.settings;\n				if ( settings[ eventType ] && !$( this ).is( settings.ignore ) ) {\n					settings[ eventType ].call( validator, this, event );\n				}\n			}\n\n			$( this.currentForm )\n				.on( \"focusin.validate focusout.validate keyup.validate\",\n					\":text, [type='password'], [type='file'], select, textarea, [type='number'], [type='search'], \" +\n					\"[type='tel'], [type='url'], [type='email'], [type='datetime'], [type='date'], [type='month'], \" +\n					\"[type='week'], [type='time'], [type='datetime-local'], [type='range'], [type='color'], \" +\n					\"[type='radio'], [type='checkbox']\", delegate)\n				// Support: Chrome, oldIE\n				// \"select\" is provided as event.target when clicking a option\n				.on(\"click.validate\", \"select, option, [type='radio'], [type='checkbox']\", delegate);\n\n			if ( this.settings.invalidHandler ) {\n				$( this.currentForm ).on( \"invalid-form.validate\", this.settings.invalidHandler );\n			}\n\n			// Add aria-required to any Static/Data/Class required fields before first validation\n			// Screen readers require this attribute to be present before the initial submission http://www.w3.org/TR/WCAG-TECHS/ARIA2.html\n			$( this.currentForm ).find( \"[required], [data-rule-required], .required\" ).attr( \"aria-required\", \"true\" );\n		},\n\n		// http://jqueryvalidation.org/Validator.form/\n		form: function() {\n			this.checkForm();\n			$.extend( this.submitted, this.errorMap );\n			this.invalid = $.extend({}, this.errorMap );\n			if ( !this.valid() ) {\n				$( this.currentForm ).triggerHandler( \"invalid-form\", [ this ]);\n			}\n			this.showErrors();\n			return this.valid();\n		},\n\n		checkForm: function() {\n			this.prepareForm();\n			for ( var i = 0, elements = ( this.currentElements = this.elements() ); elements[ i ]; i++ ) {\n				this.check( elements[ i ] );\n			}\n			return this.valid();\n		},\n\n		// http://jqueryvalidation.org/Validator.element/\n		element: function( element ) {\n			var cleanElement = this.clean( element ),\n				checkElement = this.validationTargetFor( cleanElement ),\n				result = true;\n\n			this.lastElement = checkElement;\n\n			if ( checkElement === undefined ) {\n				delete this.invalid[ cleanElement.name ];\n			} else {\n				this.prepareElement( checkElement );\n				this.currentElements = $( checkElement );\n\n				result = this.check( checkElement ) !== false;\n				if ( result ) {\n					delete this.invalid[ checkElement.name ];\n				} else {\n					this.invalid[ checkElement.name ] = true;\n				}\n			}\n			// Add aria-invalid status for screen readers\n			$( element ).attr( \"aria-invalid\", !result );\n\n			if ( !this.numberOfInvalids() ) {\n				// Hide error containers on last error\n				this.toHide = this.toHide.add( this.containers );\n			}\n			this.showErrors();\n			return result;\n		},\n\n		// http://jqueryvalidation.org/Validator.showErrors/\n		showErrors: function( errors ) {\n			if ( errors ) {\n				// add items to error list and map\n				$.extend( this.errorMap, errors );\n				this.errorList = [];\n				for ( var name in errors ) {\n					this.errorList.push({\n						message: errors[ name ],\n						element: this.findByName( name )[ 0 ]\n					});\n				}\n				// remove items from success list\n				this.successList = $.grep( this.successList, function( element ) {\n					return !( element.name in errors );\n				});\n			}\n			if ( this.settings.showErrors ) {\n				this.settings.showErrors.call( this, this.errorMap, this.errorList );\n			} else {\n				this.defaultShowErrors();\n			}\n		},\n\n		// http://jqueryvalidation.org/Validator.resetForm/\n		resetForm: function() {\n			if ( $.fn.resetForm ) {\n				$( this.currentForm ).resetForm();\n			}\n			this.submitted = {};\n			this.lastElement = null;\n			this.prepareForm();\n			this.hideErrors();\n			var i, elements = this.elements()\n				.removeData( \"previousValue\" )\n				.removeAttr( \"aria-invalid\" );\n\n			if ( this.settings.unhighlight ) {\n				for ( i = 0; elements[ i ]; i++ ) {\n					this.settings.unhighlight.call( this, elements[ i ],\n						this.settings.errorClass, \"\" );\n				}\n			} else {\n				elements.removeClass( this.settings.errorClass );\n			}\n		},\n\n		numberOfInvalids: function() {\n			return this.objectLength( this.invalid );\n		},\n\n		objectLength: function( obj ) {\n			/* jshint unused: false */\n			var count = 0,\n				i;\n			for ( i in obj ) {\n				count++;\n			}\n			return count;\n		},\n\n		hideErrors: function() {\n			this.hideThese( this.toHide );\n		},\n\n		hideThese: function( errors ) {\n			errors.not( this.containers ).text( \"\" );\n			this.addWrapper( errors ).hide();\n		},\n\n		valid: function() {\n			return this.size() === 0;\n		},\n\n		size: function() {\n			return this.errorList.length;\n		},\n\n		focusInvalid: function() {\n			if ( this.settings.focusInvalid ) {\n				try {\n					$( this.findLastActive() || this.errorList.length && this.errorList[ 0 ].element || [])\n					.filter( \":visible\" )\n					.focus()\n					// manually trigger focusin event; without it, focusin handler isn't called, findLastActive won't have anything to find\n					.trigger( \"focusin\" );\n				} catch ( e ) {\n					// ignore IE throwing errors when focusing hidden elements\n				}\n			}\n		},\n\n		findLastActive: function() {\n			var lastActive = this.lastActive;\n			return lastActive && $.grep( this.errorList, function( n ) {\n				return n.element.name === lastActive.name;\n			}).length === 1 && lastActive;\n		},\n\n		elements: function() {\n			var validator = this,\n				rulesCache = {};\n\n			// select all valid inputs inside the form (no submit or reset buttons)\n			return $( this.currentForm )\n			.find( \"input, select, textarea\" )\n			.not( \":submit, :reset, :image, :disabled\" )\n			.not( this.settings.ignore )\n			.filter( function() {\n				if ( !this.name && validator.settings.debug && window.console ) {\n					console.error( \"%o has no name assigned\", this );\n				}\n\n				// select only the first element for each name, and only those with rules specified\n				if ( this.name in rulesCache || !validator.objectLength( $( this ).rules() ) ) {\n					return false;\n				}\n\n				rulesCache[ this.name ] = true;\n				return true;\n			});\n		},\n\n		clean: function( selector ) {\n			return $( selector )[ 0 ];\n		},\n\n		errors: function() {\n			var errorClass = this.settings.errorClass.split( \" \" ).join( \".\" );\n			return $( this.settings.errorElement + \".\" + errorClass, this.errorContext );\n		},\n\n		reset: function() {\n			this.successList = [];\n			this.errorList = [];\n			this.errorMap = {};\n			this.toShow = $( [] );\n			this.toHide = $( [] );\n			this.currentElements = $( [] );\n		},\n\n		prepareForm: function() {\n			this.reset();\n			this.toHide = this.errors().add( this.containers );\n		},\n\n		prepareElement: function( element ) {\n			this.reset();\n			this.toHide = this.errorsFor( element );\n		},\n\n		elementValue: function( element ) {\n			var val,\n				$element = $( element ),\n				type = element.type;\n\n			if ( type === \"radio\" || type === \"checkbox\" ) {\n				return this.findByName( element.name ).filter(\":checked\").val();\n			} else if ( type === \"number\" && typeof element.validity !== \"undefined\" ) {\n				return element.validity.badInput ? false : $element.val();\n			}\n\n			val = $element.val();\n			if ( typeof val === \"string\" ) {\n				return val.replace(/\\r/g, \"\" );\n			}\n			return val;\n		},\n\n		check: function( element ) {\n			element = this.validationTargetFor( this.clean( element ) );\n\n			var rules = $( element ).rules(),\n				rulesCount = $.map( rules, function( n, i ) {\n					return i;\n				}).length,\n				dependencyMismatch = false,\n				val = this.elementValue( element ),\n				result, method, rule;\n\n			for ( method in rules ) {\n				rule = { method: method, parameters: rules[ method ] };\n				try {\n\n					result = $.validator.methods[ method ].call( this, val, element, rule.parameters );\n\n					// if a method indicates that the field is optional and therefore valid,\n					// don't mark it as valid when there are no other rules\n					if ( result === \"dependency-mismatch\" && rulesCount === 1 ) {\n						dependencyMismatch = true;\n						continue;\n					}\n					dependencyMismatch = false;\n\n					if ( result === \"pending\" ) {\n						this.toHide = this.toHide.not( this.errorsFor( element ) );\n						return;\n					}\n\n					if ( !result ) {\n						this.formatAndAdd( element, rule );\n						return false;\n					}\n				} catch ( e ) {\n					if ( this.settings.debug && window.console ) {\n						console.log( \"Exception occurred when checking element \" + element.id + \", check the '\" + rule.method + \"' method.\", e );\n					}\n					if ( e instanceof TypeError ) {\n						e.message += \".  Exception occurred when checking element \" + element.id + \", check the '\" + rule.method + \"' method.\";\n					}\n\n					throw e;\n				}\n			}\n			if ( dependencyMismatch ) {\n				return;\n			}\n			if ( this.objectLength( rules ) ) {\n				this.successList.push( element );\n			}\n			return true;\n		},\n\n		// return the custom message for the given element and validation method\n		// specified in the element's HTML5 data attribute\n		// return the generic message if present and no method specific message is present\n		customDataMessage: function( element, method ) {\n			return $( element ).data( \"msg\" + method.charAt( 0 ).toUpperCase() +\n				method.substring( 1 ).toLowerCase() ) || $( element ).data( \"msg\" );\n		},\n\n		// return the custom message for the given element name and validation method\n		customMessage: function( name, method ) {\n			var m = this.settings.messages[ name ];\n			return m && ( m.constructor === String ? m : m[ method ]);\n		},\n\n		// return the first defined argument, allowing empty strings\n		findDefined: function() {\n			for ( var i = 0; i < arguments.length; i++) {\n				if ( arguments[ i ] !== undefined ) {\n					return arguments[ i ];\n				}\n			}\n			return undefined;\n		},\n\n		defaultMessage: function( element, method ) {\n			return this.findDefined(\n				this.customMessage( element.name, method ),\n				this.customDataMessage( element, method ),\n				// title is never undefined, so handle empty string as undefined\n				!this.settings.ignoreTitle && element.title || undefined,\n				$.validator.messages[ method ],\n				\"<strong>Warning: No message defined for \" + element.name + \"</strong>\"\n			);\n		},\n\n		formatAndAdd: function( element, rule ) {\n			var message = this.defaultMessage( element, rule.method ),\n				theregex = /\\$?\\{(\\d+)\\}/g;\n			if ( typeof message === \"function\" ) {\n				message = message.call( this, rule.parameters, element );\n			} else if ( theregex.test( message ) ) {\n				message = $.validator.format( message.replace( theregex, \"{$1}\" ), rule.parameters );\n			}\n			this.errorList.push({\n				message: message,\n				element: element,\n				method: rule.method\n			});\n\n			this.errorMap[ element.name ] = message;\n			this.submitted[ element.name ] = message;\n		},\n\n		addWrapper: function( toToggle ) {\n			if ( this.settings.wrapper ) {\n				toToggle = toToggle.add( toToggle.parent( this.settings.wrapper ) );\n			}\n			return toToggle;\n		},\n\n		defaultShowErrors: function() {\n			var i, elements, error;\n			for ( i = 0; this.errorList[ i ]; i++ ) {\n				error = this.errorList[ i ];\n				if ( this.settings.highlight ) {\n					this.settings.highlight.call( this, error.element, this.settings.errorClass, this.settings.validClass );\n				}\n				this.showLabel( error.element, error.message );\n			}\n			if ( this.errorList.length ) {\n				this.toShow = this.toShow.add( this.containers );\n			}\n			if ( this.settings.success ) {\n				for ( i = 0; this.successList[ i ]; i++ ) {\n					this.showLabel( this.successList[ i ] );\n				}\n			}\n			if ( this.settings.unhighlight ) {\n				for ( i = 0, elements = this.validElements(); elements[ i ]; i++ ) {\n					this.settings.unhighlight.call( this, elements[ i ], this.settings.errorClass, this.settings.validClass );\n				}\n			}\n			this.toHide = this.toHide.not( this.toShow );\n			this.hideErrors();\n			this.addWrapper( this.toShow ).show();\n		},\n\n		validElements: function() {\n			return this.currentElements.not( this.invalidElements() );\n		},\n\n		invalidElements: function() {\n			return $( this.errorList ).map(function() {\n				return this.element;\n			});\n		},\n\n		showLabel: function( element, message ) {\n			var place, group, errorID,\n				error = this.errorsFor( element ),\n				elementID = this.idOrName( element ),\n				describedBy = $( element ).attr( \"aria-describedby\" );\n			if ( error.length ) {\n				// refresh error/success class\n				error.removeClass( this.settings.validClass ).addClass( this.settings.errorClass );\n				// replace message on existing label\n				error.html( message );\n			} else {\n				// create error element\n				error = $( \"<\" + this.settings.errorElement + \">\" )\n					.attr( \"id\", elementID + \"-error\" )\n					.addClass( this.settings.errorClass )\n					.html( message || \"\" );\n\n				// Maintain reference to the element to be placed into the DOM\n				place = error;\n				if ( this.settings.wrapper ) {\n					// make sure the element is visible, even in IE\n					// actually showing the wrapped element is handled elsewhere\n					place = error.hide().show().wrap( \"<\" + this.settings.wrapper + \"/>\" ).parent();\n				}\n				if ( this.labelContainer.length ) {\n					this.labelContainer.append( place );\n				} else if ( this.settings.errorPlacement ) {\n					this.settings.errorPlacement( place, $( element ) );\n				} else {\n					place.insertAfter( element );\n				}\n\n				// Link error back to the element\n				if ( error.is( \"label\" ) ) {\n					// If the error is a label, then associate using 'for'\n					error.attr( \"for\", elementID );\n				} else if ( error.parents( \"label[for='\" + elementID + \"']\" ).length === 0 ) {\n					// If the element is not a child of an associated label, then it's necessary\n					// to explicitly apply aria-describedby\n\n					errorID = error.attr( \"id\" ).replace( /(:|\\.|\\[|\\]|\\$)/g, \"\\\\$1\");\n					// Respect existing non-error aria-describedby\n					if ( !describedBy ) {\n						describedBy = errorID;\n					} else if ( !describedBy.match( new RegExp( \"\\\\b\" + errorID + \"\\\\b\" ) ) ) {\n						// Add to end of list if not already present\n						describedBy += \" \" + errorID;\n					}\n					$( element ).attr( \"aria-describedby\", describedBy );\n\n					// If this element is grouped, then assign to all elements in the same group\n					group = this.groups[ element.name ];\n					if ( group ) {\n						$.each( this.groups, function( name, testgroup ) {\n							if ( testgroup === group ) {\n								$( \"[name='\" + name + \"']\", this.currentForm )\n									.attr( \"aria-describedby\", error.attr( \"id\" ) );\n							}\n						});\n					}\n				}\n			}\n			if ( !message && this.settings.success ) {\n				error.text( \"\" );\n				if ( typeof this.settings.success === \"string\" ) {\n					error.addClass( this.settings.success );\n				} else {\n					this.settings.success( error, element );\n				}\n			}\n			this.toShow = this.toShow.add( error );\n		},\n\n		errorsFor: function( element ) {\n			var name = this.idOrName( element ),\n				describer = $( element ).attr( \"aria-describedby\" ),\n				selector = \"label[for='\" + name + \"'], label[for='\" + name + \"'] *\";\n\n			// aria-describedby should directly reference the error element\n			if ( describer ) {\n				selector = selector + \", #\" + describer.replace( /\\s+/g, \", #\" );\n			}\n			return this\n				.errors()\n				.filter( selector );\n		},\n\n		idOrName: function( element ) {\n			return this.groups[ element.name ] || ( this.checkable( element ) ? element.name : element.id || element.name );\n		},\n\n		validationTargetFor: function( element ) {\n\n			// If radio/checkbox, validate first element in group instead\n			if ( this.checkable( element ) ) {\n				element = this.findByName( element.name );\n			}\n\n			// Always apply ignore filter\n			return $( element ).not( this.settings.ignore )[ 0 ];\n		},\n\n		checkable: function( element ) {\n			return ( /radio|checkbox/i ).test( element.type );\n		},\n\n		findByName: function( name ) {\n			return $( this.currentForm ).find( \"[name='\" + name + \"']\" );\n		},\n\n		getLength: function( value, element ) {\n			switch ( element.nodeName.toLowerCase() ) {\n			case \"select\":\n				return $( \"option:selected\", element ).length;\n			case \"input\":\n				if ( this.checkable( element ) ) {\n					return this.findByName( element.name ).filter( \":checked\" ).length;\n				}\n			}\n			return value.length;\n		},\n\n		depend: function( param, element ) {\n			return this.dependTypes[typeof param] ? this.dependTypes[typeof param]( param, element ) : true;\n		},\n\n		dependTypes: {\n			\"boolean\": function( param ) {\n				return param;\n			},\n			\"string\": function( param, element ) {\n				return !!$( param, element.form ).length;\n			},\n			\"function\": function( param, element ) {\n				return param( element );\n			}\n		},\n\n		optional: function( element ) {\n			var val = this.elementValue( element );\n			return !$.validator.methods.required.call( this, val, element ) && \"dependency-mismatch\";\n		},\n\n		startRequest: function( element ) {\n			if ( !this.pending[ element.name ] ) {\n				this.pendingRequest++;\n				this.pending[ element.name ] = true;\n			}\n		},\n\n		stopRequest: function( element, valid ) {\n			this.pendingRequest--;\n			// sometimes synchronization fails, make sure pendingRequest is never < 0\n			if ( this.pendingRequest < 0 ) {\n				this.pendingRequest = 0;\n			}\n			delete this.pending[ element.name ];\n			if ( valid && this.pendingRequest === 0 && this.formSubmitted && this.form() ) {\n				$( this.currentForm ).submit();\n				this.formSubmitted = false;\n			} else if (!valid && this.pendingRequest === 0 && this.formSubmitted ) {\n				$( this.currentForm ).triggerHandler( \"invalid-form\", [ this ]);\n				this.formSubmitted = false;\n			}\n		},\n\n		previousValue: function( element ) {\n			return $.data( element, \"previousValue\" ) || $.data( element, \"previousValue\", {\n				old: null,\n				valid: true,\n				message: this.defaultMessage( element, \"remote\" )\n			});\n		},\n\n		// cleans up all forms and elements, removes validator-specific events\n		destroy: function() {\n			this.resetForm();\n\n			$( this.currentForm )\n				.off( \".validate\" )\n				.removeData( \"validator\" );\n		}\n\n	},\n\n	classRuleSettings: {\n		required: { required: true },\n		email: { email: true },\n		url: { url: true },\n		date: { date: true },\n		dateISO: { dateISO: true },\n		number: { number: true },\n		digits: { digits: true },\n		creditcard: { creditcard: true }\n	},\n\n	addClassRules: function( className, rules ) {\n		if ( className.constructor === String ) {\n			this.classRuleSettings[ className ] = rules;\n		} else {\n			$.extend( this.classRuleSettings, className );\n		}\n	},\n\n	classRules: function( element ) {\n		var rules = {},\n			classes = $( element ).attr( \"class\" );\n\n		if ( classes ) {\n			$.each( classes.split( \" \" ), function() {\n				if ( this in $.validator.classRuleSettings ) {\n					$.extend( rules, $.validator.classRuleSettings[ this ]);\n				}\n			});\n		}\n		return rules;\n	},\n\n	normalizeAttributeRule: function( rules, type, method, value ) {\n\n		// convert the value to a number for number inputs, and for text for backwards compability\n		// allows type=\"date\" and others to be compared as strings\n		if ( /min|max/.test( method ) && ( type === null || /number|range|text/.test( type ) ) ) {\n			value = Number( value );\n\n			// Support Opera Mini, which returns NaN for undefined minlength\n			if ( isNaN( value ) ) {\n				value = undefined;\n			}\n		}\n\n		if ( value || value === 0 ) {\n			rules[ method ] = value;\n		} else if ( type === method && type !== \"range\" ) {\n\n			// exception: the jquery validate 'range' method\n			// does not test for the html5 'range' type\n			rules[ method ] = true;\n		}\n	},\n\n	attributeRules: function( element ) {\n		var rules = {},\n			$element = $( element ),\n			type = element.getAttribute( \"type\" ),\n			method, value;\n\n		for ( method in $.validator.methods ) {\n\n			// support for <input required> in both html5 and older browsers\n			if ( method === \"required\" ) {\n				value = element.getAttribute( method );\n\n				// Some browsers return an empty string for the required attribute\n				// and non-HTML5 browsers might have required=\"\" markup\n				if ( value === \"\" ) {\n					value = true;\n				}\n\n				// force non-HTML5 browsers to return bool\n				value = !!value;\n			} else {\n				value = $element.attr( method );\n			}\n\n			this.normalizeAttributeRule( rules, type, method, value );\n		}\n\n		// maxlength may be returned as -1, 2147483647 ( IE ) and 524288 ( safari ) for text inputs\n		if ( rules.maxlength && /-1|2147483647|524288/.test( rules.maxlength ) ) {\n			delete rules.maxlength;\n		}\n\n		return rules;\n	},\n\n	dataRules: function( element ) {\n		var rules = {},\n			$element = $( element ),\n			type = element.getAttribute( \"type\" ),\n			method, value;\n\n		for ( method in $.validator.methods ) {\n			value = $element.data( \"rule\" + method.charAt( 0 ).toUpperCase() + method.substring( 1 ).toLowerCase() );\n			this.normalizeAttributeRule( rules, type, method, value );\n		}\n		return rules;\n	},\n\n	staticRules: function( element ) {\n		var rules = {},\n			validator = $.data( element.form, \"validator\" );\n\n		if ( validator.settings.rules ) {\n			rules = $.validator.normalizeRule( validator.settings.rules[ element.name ] ) || {};\n		}\n		return rules;\n	},\n\n	normalizeRules: function( rules, element ) {\n		// handle dependency check\n		$.each( rules, function( prop, val ) {\n			// ignore rule when param is explicitly false, eg. required:false\n			if ( val === false ) {\n				delete rules[ prop ];\n				return;\n			}\n			if ( val.param || val.depends ) {\n				var keepRule = true;\n				switch ( typeof val.depends ) {\n				case \"string\":\n					keepRule = !!$( val.depends, element.form ).length;\n					break;\n				case \"function\":\n					keepRule = val.depends.call( element, element );\n					break;\n				}\n				if ( keepRule ) {\n					rules[ prop ] = val.param !== undefined ? val.param : true;\n				} else {\n					delete rules[ prop ];\n				}\n			}\n		});\n\n		// evaluate parameters\n		$.each( rules, function( rule, parameter ) {\n			rules[ rule ] = $.isFunction( parameter ) ? parameter( element ) : parameter;\n		});\n\n		// clean number parameters\n		$.each([ \"minlength\", \"maxlength\" ], function() {\n			if ( rules[ this ] ) {\n				rules[ this ] = Number( rules[ this ] );\n			}\n		});\n		$.each([ \"rangelength\", \"range\" ], function() {\n			var parts;\n			if ( rules[ this ] ) {\n				if ( $.isArray( rules[ this ] ) ) {\n					rules[ this ] = [ Number( rules[ this ][ 0 ]), Number( rules[ this ][ 1 ] ) ];\n				} else if ( typeof rules[ this ] === \"string\" ) {\n					parts = rules[ this ].replace(/[\\[\\]]/g, \"\" ).split( /[\\s,]+/ );\n					rules[ this ] = [ Number( parts[ 0 ]), Number( parts[ 1 ] ) ];\n				}\n			}\n		});\n\n		if ( $.validator.autoCreateRanges ) {\n			// auto-create ranges\n			if ( rules.min != null && rules.max != null ) {\n				rules.range = [ rules.min, rules.max ];\n				delete rules.min;\n				delete rules.max;\n			}\n			if ( rules.minlength != null && rules.maxlength != null ) {\n				rules.rangelength = [ rules.minlength, rules.maxlength ];\n				delete rules.minlength;\n				delete rules.maxlength;\n			}\n		}\n\n		return rules;\n	},\n\n	// Converts a simple string to a {string: true} rule, e.g., \"required\" to {required:true}\n	normalizeRule: function( data ) {\n		if ( typeof data === \"string\" ) {\n			var transformed = {};\n			$.each( data.split( /\\s/ ), function() {\n				transformed[ this ] = true;\n			});\n			data = transformed;\n		}\n		return data;\n	},\n\n	// http://jqueryvalidation.org/jQuery.validator.addMethod/\n	addMethod: function( name, method, message ) {\n		$.validator.methods[ name ] = method;\n		$.validator.messages[ name ] = message !== undefined ? message : $.validator.messages[ name ];\n		if ( method.length < 3 ) {\n			$.validator.addClassRules( name, $.validator.normalizeRule( name ) );\n		}\n	},\n\n	methods: {\n\n		// http://jqueryvalidation.org/required-method/\n		required: function( value, element, param ) {\n			// check if dependency is met\n			if ( !this.depend( param, element ) ) {\n				return \"dependency-mismatch\";\n			}\n			if ( element.nodeName.toLowerCase() === \"select\" ) {\n				// could be an array for select-multiple or a string, both are fine this way\n				var val = $( element ).val();\n				return val && val.length > 0;\n			}\n			if ( this.checkable( element ) ) {\n				return this.getLength( value, element ) > 0;\n			}\n			return value.length > 0;\n		},\n\n		// http://jqueryvalidation.org/email-method/\n		email: function( value, element ) {\n			// From https://html.spec.whatwg.org/multipage/forms.html#valid-e-mail-address\n			// Retrieved 2014-01-14\n			// If you have a problem with this implementation, report a bug against the above spec\n			// Or use custom methods to implement your own email validation\n			return this.optional( element ) || /^[a-zA-Z0-9.!#$%&'*+\\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/.test( value );\n		},\n\n		// http://jqueryvalidation.org/url-method/\n		url: function( value, element ) {\n\n			// Copyright (c) 2010-2013 Diego Perini, MIT licensed\n			// https://gist.github.com/dperini/729294\n			// see also https://mathiasbynens.be/demo/url-regex\n			// modified to allow protocol-relative URLs\n			return this.optional( element ) || /^(?:(?:(?:https?|ftp):)?\\/\\/)(?:\\S+(?::\\S*)?@)?(?:(?!(?:10|127)(?:\\.\\d{1,3}){3})(?!(?:169\\.254|192\\.168)(?:\\.\\d{1,3}){2})(?!172\\.(?:1[6-9]|2\\d|3[0-1])(?:\\.\\d{1,3}){2})(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})).?)(?::\\d{2,5})?(?:[/?#]\\S*)?$/i.test( value );\n		},\n\n		// http://jqueryvalidation.org/date-method/\n		date: function( value, element ) {\n			return this.optional( element ) || !/Invalid|NaN/.test( new Date( value ).toString() );\n		},\n\n		// http://jqueryvalidation.org/dateISO-method/\n		dateISO: function( value, element ) {\n			return this.optional( element ) || /^\\d{4}[\\/\\-](0?[1-9]|1[012])[\\/\\-](0?[1-9]|[12][0-9]|3[01])$/.test( value );\n		},\n\n		// http://jqueryvalidation.org/number-method/\n		number: function( value, element ) {\n			return this.optional( element ) || /^(?:-?\\d+|-?\\d{1,3}(?:,\\d{3})+)?(?:\\.\\d+)?$/.test( value );\n		},\n\n		// http://jqueryvalidation.org/digits-method/\n		digits: function( value, element ) {\n			return this.optional( element ) || /^\\d+$/.test( value );\n		},\n\n		// http://jqueryvalidation.org/creditcard-method/\n		// based on http://en.wikipedia.org/wiki/Luhn_algorithm\n		creditcard: function( value, element ) {\n			if ( this.optional( element ) ) {\n				return \"dependency-mismatch\";\n			}\n			// accept only spaces, digits and dashes\n			if ( /[^0-9 \\-]+/.test( value ) ) {\n				return false;\n			}\n			var nCheck = 0,\n				nDigit = 0,\n				bEven = false,\n				n, cDigit;\n\n			value = value.replace( /\\D/g, \"\" );\n\n			// Basing min and max length on\n			// http://developer.ean.com/general_info/Valid_Credit_Card_Types\n			if ( value.length < 13 || value.length > 19 ) {\n				return false;\n			}\n\n			for ( n = value.length - 1; n >= 0; n--) {\n				cDigit = value.charAt( n );\n				nDigit = parseInt( cDigit, 10 );\n				if ( bEven ) {\n					if ( ( nDigit *= 2 ) > 9 ) {\n						nDigit -= 9;\n					}\n				}\n				nCheck += nDigit;\n				bEven = !bEven;\n			}\n\n			return ( nCheck % 10 ) === 0;\n		},\n\n		// http://jqueryvalidation.org/minlength-method/\n		minlength: function( value, element, param ) {\n			var length = $.isArray( value ) ? value.length : this.getLength( value, element );\n			return this.optional( element ) || length >= param;\n		},\n\n		// http://jqueryvalidation.org/maxlength-method/\n		maxlength: function( value, element, param ) {\n			var length = $.isArray( value ) ? value.length : this.getLength( value, element );\n			return this.optional( element ) || length <= param;\n		},\n\n		// http://jqueryvalidation.org/rangelength-method/\n		rangelength: function( value, element, param ) {\n			var length = $.isArray( value ) ? value.length : this.getLength( value, element );\n			return this.optional( element ) || ( length >= param[ 0 ] && length <= param[ 1 ] );\n		},\n\n		// http://jqueryvalidation.org/min-method/\n		min: function( value, element, param ) {\n			return this.optional( element ) || value >= param;\n		},\n\n		// http://jqueryvalidation.org/max-method/\n		max: function( value, element, param ) {\n			return this.optional( element ) || value <= param;\n		},\n\n		// http://jqueryvalidation.org/range-method/\n		range: function( value, element, param ) {\n			return this.optional( element ) || ( value >= param[ 0 ] && value <= param[ 1 ] );\n		},\n\n		// http://jqueryvalidation.org/equalTo-method/\n		equalTo: function( value, element, param ) {\n			// bind to the blur event of the target in order to revalidate whenever the target field is updated\n			// TODO find a way to bind the event just once, avoiding the unbind-rebind overhead\n			var target = $( param );\n			if ( this.settings.onfocusout ) {\n				target.off( \".validate-equalTo\" ).on( \"blur.validate-equalTo\", function() {\n					$( element ).valid();\n				});\n			}\n			return value === target.val();\n		},\n\n		// http://jqueryvalidation.org/remote-method/\n		remote: function( value, element, param ) {\n			if ( this.optional( element ) ) {\n				return \"dependency-mismatch\";\n			}\n\n			var previous = this.previousValue( element ),\n				validator, data;\n\n			if (!this.settings.messages[ element.name ] ) {\n				this.settings.messages[ element.name ] = {};\n			}\n			previous.originalMessage = this.settings.messages[ element.name ].remote;\n			this.settings.messages[ element.name ].remote = previous.message;\n\n			param = typeof param === \"string\" && { url: param } || param;\n\n			if ( previous.old === value ) {\n				return previous.valid;\n			}\n\n			previous.old = value;\n			validator = this;\n			this.startRequest( element );\n			data = {};\n			data[ element.name ] = value;\n			$.ajax( $.extend( true, {\n				mode: \"abort\",\n				port: \"validate\" + element.name,\n				dataType: \"json\",\n				data: data,\n				context: validator.currentForm,\n				success: function( response ) {\n					var valid = response === true || response === \"true\",\n						errors, message, submitted;\n\n					validator.settings.messages[ element.name ].remote = previous.originalMessage;\n					if ( valid ) {\n						submitted = validator.formSubmitted;\n						validator.prepareElement( element );\n						validator.formSubmitted = submitted;\n						validator.successList.push( element );\n						delete validator.invalid[ element.name ];\n						validator.showErrors();\n					} else {\n						errors = {};\n						message = response || validator.defaultMessage( element, \"remote\" );\n						errors[ element.name ] = previous.message = $.isFunction( message ) ? message( value ) : message;\n						validator.invalid[ element.name ] = true;\n						validator.showErrors( errors );\n					}\n					previous.valid = valid;\n					validator.stopRequest( element, valid );\n				}\n			}, param ) );\n			return \"pending\";\n		}\n	}\n\n});\n\n// ajax mode: abort\n// usage: $.ajax({ mode: \"abort\"[, port: \"uniqueport\"]});\n// if mode:\"abort\" is used, the previous request on that port (port can be undefined) is aborted via XMLHttpRequest.abort()\n\nvar pendingRequests = {},\n	ajax;\n// Use a prefilter if available (1.5+)\nif ( $.ajaxPrefilter ) {\n	$.ajaxPrefilter(function( settings, _, xhr ) {\n		var port = settings.port;\n		if ( settings.mode === \"abort\" ) {\n			if ( pendingRequests[port] ) {\n				pendingRequests[port].abort();\n			}\n			pendingRequests[port] = xhr;\n		}\n	});\n} else {\n	// Proxy ajax\n	ajax = $.ajax;\n	$.ajax = function( settings ) {\n		var mode = ( \"mode\" in settings ? settings : $.ajaxSettings ).mode,\n			port = ( \"port\" in settings ? settings : $.ajaxSettings ).port;\n		if ( mode === \"abort\" ) {\n			if ( pendingRequests[port] ) {\n				pendingRequests[port].abort();\n			}\n			pendingRequests[port] = ajax.apply(this, arguments);\n			return pendingRequests[port];\n		}\n		return ajax.apply(this, arguments);\n	};\n}\n\n}));";
var mod_pagespeed_T1rJglOHAf = "$.validator.setDefaults({\n	highlight: function( element, errorClass, validClass ) {\n        $(element).closest('.form-group').addClass('has-error');\n	},\n	unhighlight: function( element, errorClass, validClass ) {\n        $(element).closest('.form-group').removeClass('has-error');\n	},\n	errorElement : 'span',\n	errorClass : 'help-block',\n	errorPlacement: function(error, element) {\n		if (element.parent().attr('class') == 'checkbox-inline' || element.parent().attr('class') == 'radio-inline'){\n			error.appendTo(element.parent().parent());\n		}else if (element.parent('.input-group').length || element.prop('type') === 'checkbox' || element.prop('type') === 'radio') {\n			error.insertAfter(element.parent());\n		} else {\n			error.insertAfter(element);\n		}\n	},\n});\n\n$.validator.addMethod(\"pwcheck\", function(value) {\n	   return /^[A-Za-z0-9\\d=!\\-@._*]*$/.test(value) // consists of only these\n	       && /[a-z]/.test(value) // has a lowercase letter\n	       && /[A-Z]/.test(value) // has an uppercase letter\n	       && /\\d/.test(value) // has a digit\n}, \"La password deve contenere almeno un carattere maiuscolo (A-Z), uno minuscolo (a-z) e uno numerico (0-9)\");";
