/**
----------------- ThirdPartyNotices------------------------------------------------------------------ 
This file is based on or incorporates material from the projects listed below (collectively, “Third Party Code”). Skype is not the original author of the Third Party Code. The original copyright notice and the license, under which Skype received such Third Party Code, are set forth below. Such licenses and notices are provided for informational purposes only. Skype, not the third party, licenses the Third Party Code to you under the terms set forth in the Terms of Use for the Skype Product. Skype reserves all other rights not expressly granted under this agreement, whether by implication, estoppel or otherwise. 
jQuery 1.6.4 
Copyright 2011, John Resig
Provided for Informational Purposes Only 
MIT License 
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: 
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT OLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

Sizzle.js
Copyright 2011, The Dojo Foundation
Provided for Informational Purposes Only 
MIT License 
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: 
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT OLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
-------------End of ThirdPartyNotices--------------------------------------- 
*/
(function( window, undefined ) {

// Use the correct document accordingly with window argument (sandbox)
var document = window.document,
	navigator = window.navigator,
	location = window.location;
var jQuery = (function() {

// Define a local copy of jQuery
var jQuery = function( selector, context ) {
		// The jQuery object is actually just the init constructor 'enhanced'
		return new jQuery.fn.init( selector, context, rootjQuery );
	},

	// Map over jQuery in case of overwrite
	_jQuery = window.jQuery,

	// Map over the $ in case of overwrite
	_$ = window.$,

	// A central reference to the root jQuery(document)
	rootjQuery,

	// A simple way to check for HTML strings or ID strings
	// Prioritize #id over <tag> to avoid XSS via location.hash (#9521)
	quickExpr = /^(?:[^#<]*(<[\w\W]+>)[^>]*$|#([\w\-]*)$)/,

	// Check if a string has a non-whitespace character in it
	rnotwhite = /\S/,

	// Used for trimming whitespace
	trimLeft = /^\s+/,
	trimRight = /\s+$/,

	// Check for digits
	rdigit = /\d/,

	// Match a standalone tag
	rsingleTag = /^<(\w+)\s*\/?>(?:<\/\1>)?$/,

	// JSON RegExp
	rvalidchars = /^[\],:{}\s]*$/,
	rvalidescape = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,
	rvalidtokens = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,
	rvalidbraces = /(?:^|:|,)(?:\s*\[)+/g,

	// Useragent RegExp
	rwebkit = /(webkit)[ \/]([\w.]+)/,
	ropera = /(opera)(?:.*version)?[ \/]([\w.]+)/,
	rmsie = /(msie) ([\w.]+)/,
	rmozilla = /(mozilla)(?:.*? rv:([\w.]+))?/,

	// Matches dashed string for camelizing
	rdashAlpha = /-([a-z]|[0-9])/ig,
	rmsPrefix = /^-ms-/,

	// Used by jQuery.camelCase as callback to replace()
	fcamelCase = function( all, letter ) {
		return ( letter + "" ).toUpperCase();
	},

	// Keep a UserAgent string for use with jQuery.browser
	userAgent = navigator.userAgent,

	// For matching the engine and version of the browser
	browserMatch,

	// The deferred used on DOM ready
	readyList,

	// The ready event handler
	DOMContentLoaded,

	// Save a reference to some core methods
	toString = Object.prototype.toString,
	hasOwn = Object.prototype.hasOwnProperty,
	push = Array.prototype.push,
	slice = Array.prototype.slice,
	trim = String.prototype.trim,
	indexOf = Array.prototype.indexOf,

	// [[Class]] -> type pairs
	class2type = {};

jQuery.fn = jQuery.prototype = {
	constructor: jQuery,
	init: function( selector, context, rootjQuery ) {
		var match, elem, ret, doc;

		// Handle $(""), $(null), or $(undefined)
		if ( !selector ) {
			return this;
		}

		// Handle $(DOMElement)
		if ( selector.nodeType ) {
			this.context = this[0] = selector;
			this.length = 1;
			return this;
		}

		// The body element only exists once, optimize finding it
		if ( selector === "body" && !context && document.body ) {
			this.context = document;
			this[0] = document.body;
			this.selector = selector;
			this.length = 1;
			return this;
		}

		// Handle HTML strings
		if ( typeof selector === "string" ) {
			// Are we dealing with HTML string or an ID?
			if ( selector.charAt(0) === "<" && selector.charAt( selector.length - 1 ) === ">" && selector.length >= 3 ) {
				// Assume that strings that start and end with <> are HTML and skip the regex check
				match = [ null, selector, null ];

			} else {
				match = quickExpr.exec( selector );
			}

			// Verify a match, and that no context was specified for #id
			if ( match && (match[1] || !context) ) {

				// HANDLE: $(html) -> $(array)
				if ( match[1] ) {
					context = context instanceof jQuery ? context[0] : context;
					doc = (context ? context.ownerDocument || context : document);

					// If a single string is passed in and it's a single tag
					// just do a createElement and skip the rest
					ret = rsingleTag.exec( selector );

					if ( ret ) {
						if ( jQuery.isPlainObject( context ) ) {
							selector = [ document.createElement( ret[1] ) ];
							jQuery.fn.attr.call( selector, context, true );

						} else {
							selector = [ doc.createElement( ret[1] ) ];
						}

					} else {
						ret = jQuery.buildFragment( [ match[1] ], [ doc ] );
						selector = (ret.cacheable ? jQuery.clone(ret.fragment) : ret.fragment).childNodes;
					}

					return jQuery.merge( this, selector );

				// HANDLE: $("#id")
				} else {
					elem = document.getElementById( match[2] );

					// Check parentNode to catch when Blackberry 4.6 returns
					// nodes that are no longer in the document #6963
					if ( elem && elem.parentNode ) {
						// Handle the case where IE and Opera return items
						// by name instead of ID
						if ( elem.id !== match[2] ) {
							return rootjQuery.find( selector );
						}

						// Otherwise, we inject the element directly into the jQuery object
						this.length = 1;
						this[0] = elem;
					}

					this.context = document;
					this.selector = selector;
					return this;
				}

			// HANDLE: $(expr, $(...))
			} else if ( !context || context.jquery ) {
				return (context || rootjQuery).find( selector );

			// HANDLE: $(expr, context)
			// (which is just equivalent to: $(context).find(expr)
			} else {
				return this.constructor( context ).find( selector );
			}

		// HANDLE: $(function)
		// Shortcut for document ready
		} else if ( jQuery.isFunction( selector ) ) {
			return rootjQuery.ready( selector );
		}

		if (selector.selector !== undefined) {
			this.selector = selector.selector;
			this.context = selector.context;
		}

		return jQuery.makeArray( selector, this );
	},

	// Start with an empty selector
	selector: "",

	// The current version of jQuery being used
	jquery: "1.6.4",

	// The default length of a jQuery object is 0
	length: 0,

	// The number of elements contained in the matched element set
	size: function() {
		return this.length;
	},

	toArray: function() {
		return slice.call( this, 0 );
	},

	// Get the Nth element in the matched element set OR
	// Get the whole matched element set as a clean array
	get: function( num ) {
		return num == null ?

			// Return a 'clean' array
			this.toArray() :

			// Return just the object
			( num < 0 ? this[ this.length + num ] : this[ num ] );
	},

	// Take an array of elements and push it onto the stack
	// (returning the new matched element set)
	pushStack: function( elems, name, selector ) {
		// Build a new jQuery matched element set
		var ret = this.constructor();

		if ( jQuery.isArray( elems ) ) {
			push.apply( ret, elems );

		} else {
			jQuery.merge( ret, elems );
		}

		// Add the old object onto the stack (as a reference)
		ret.prevObject = this;

		ret.context = this.context;

		if ( name === "find" ) {
			ret.selector = this.selector + (this.selector ? " " : "") + selector;
		} else if ( name ) {
			ret.selector = this.selector + "." + name + "(" + selector + ")";
		}

		// Return the newly-formed element set
		return ret;
	},

	// Execute a callback for every element in the matched set.
	// (You can seed the arguments with an array of args, but this is
	// only used internally.)
	each: function( callback, args ) {
		return jQuery.each( this, callback, args );
	},

	ready: function( fn ) {
		// Attach the listeners
		jQuery.bindReady();

		// Add the callback
		readyList.done( fn );

		return this;
	},

	eq: function( i ) {
		return i === -1 ?
			this.slice( i ) :
			this.slice( i, +i + 1 );
	},

	first: function() {
		return this.eq( 0 );
	},

	last: function() {
		return this.eq( -1 );
	},

	slice: function() {
		return this.pushStack( slice.apply( this, arguments ),
			"slice", slice.call(arguments).join(",") );
	},

	map: function( callback ) {
		return this.pushStack( jQuery.map(this, function( elem, i ) {
			return callback.call( elem, i, elem );
		}));
	},

	end: function() {
		return this.prevObject || this.constructor(null);
	},

	// For internal use only.
	// Behaves like an Array's method, not like a jQuery method.
	push: push,
	sort: [].sort,
	splice: [].splice
};

// Give the init function the jQuery prototype for later instantiation
jQuery.fn.init.prototype = jQuery.fn;

jQuery.extend = jQuery.fn.extend = function() {
	var options, name, src, copy, copyIsArray, clone,
		target = arguments[0] || {},
		i = 1,
		length = arguments.length,
		deep = false;

	// Handle a deep copy situation
	if ( typeof target === "boolean" ) {
		deep = target;
		target = arguments[1] || {};
		// skip the boolean and the target
		i = 2;
	}

	// Handle case when target is a string or something (possible in deep copy)
	if ( typeof target !== "object" && !jQuery.isFunction(target) ) {
		target = {};
	}

	// extend jQuery itself if only one argument is passed
	if ( length === i ) {
		target = this;
		--i;
	}

	for ( ; i < length; i++ ) {
		// Only deal with non-null/undefined values
		if ( (options = arguments[ i ]) != null ) {
			// Extend the base object
			for ( name in options ) {
				src = target[ name ];
				copy = options[ name ];

				// Prevent never-ending loop
				if ( target === copy ) {
					continue;
				}

				// Recurse if we're merging plain objects or arrays
				if ( deep && copy && ( jQuery.isPlainObject(copy) || (copyIsArray = jQuery.isArray(copy)) ) ) {
					if ( copyIsArray ) {
						copyIsArray = false;
						clone = src && jQuery.isArray(src) ? src : [];

					} else {
						clone = src && jQuery.isPlainObject(src) ? src : {};
					}

					// Never move original objects, clone them
					target[ name ] = jQuery.extend( deep, clone, copy );

				// Don't bring in undefined values
				} else if ( copy !== undefined ) {
					target[ name ] = copy;
				}
			}
		}
	}

	// Return the modified object
	return target;
};

jQuery.extend({
	noConflict: function( deep ) {
		if ( window.$ === jQuery ) {
			window.$ = _$;
		}

		if ( deep && window.jQuery === jQuery ) {
			window.jQuery = _jQuery;
		}

		return jQuery;
	},

	// Is the DOM ready to be used? Set to true once it occurs.
	isReady: false,

	// A counter to track how many items to wait for before
	// the ready event fires. See #6781
	readyWait: 1,

	// Hold (or release) the ready event
	holdReady: function( hold ) {
		if ( hold ) {
			jQuery.readyWait++;
		} else {
			jQuery.ready( true );
		}
	},

	// Handle when the DOM is ready
	ready: function( wait ) {
		// Either a released hold or an DOMready/load event and not yet ready
		if ( (wait === true && !--jQuery.readyWait) || (wait !== true && !jQuery.isReady) ) {
			// Make sure body exists, at least, in case IE gets a little overzealous (ticket #5443).
			if ( !document.body ) {
				return setTimeout( jQuery.ready, 1 );
			}

			// Remember that the DOM is ready
			jQuery.isReady = true;

			// If a normal DOM Ready event fired, decrement, and wait if need be
			if ( wait !== true && --jQuery.readyWait > 0 ) {
				return;
			}

			// If there are functions bound, to execute
			readyList.resolveWith( document, [ jQuery ] );

			// Trigger any bound ready events
			if ( jQuery.fn.trigger ) {
				jQuery( document ).trigger( "ready" ).unbind( "ready" );
			}
		}
	},

	bindReady: function() {
		if ( readyList ) {
			return;
		}

		readyList = jQuery._Deferred();

		// Catch cases where $(document).ready() is called after the
		// browser event has already occurred.
		if ( document.readyState === "complete" ) {
			// Handle it asynchronously to allow scripts the opportunity to delay ready
			return setTimeout( jQuery.ready, 1 );
		}

		// Mozilla, Opera and webkit nightlies currently support this event
		if ( document.addEventListener ) {
			// Use the handy event callback
			document.addEventListener( "DOMContentLoaded", DOMContentLoaded, false );

			// A fallback to window.onload, that will always work
			window.addEventListener( "load", jQuery.ready, false );

		// If IE event model is used
		} else if ( document.attachEvent ) {
			// ensure firing before onload,
			// maybe late but safe also for iframes
			document.attachEvent( "onreadystatechange", DOMContentLoaded );

			// A fallback to window.onload, that will always work
			window.attachEvent( "onload", jQuery.ready );

			// If IE and not a frame
			// continually check to see if the document is ready
			var toplevel = false;

			try {
				toplevel = window.frameElement == null;
			} catch(e) {}

			if ( document.documentElement.doScroll && toplevel ) {
				doScrollCheck();
			}
		}
	},

	// See test/unit/core.js for details concerning isFunction.
	// Since version 1.3, DOM methods and functions like alert
	// aren't supported. They return false on IE (#2968).
	isFunction: function( obj ) {
		return jQuery.type(obj) === "function";
	},

	isArray: Array.isArray || function( obj ) {
		return jQuery.type(obj) === "array";
	},

	// A crude way of determining if an object is a window
	isWindow: function( obj ) {
		return obj && typeof obj === "object" && "setInterval" in obj;
	},

	isNaN: function( obj ) {
		return obj == null || !rdigit.test( obj ) || isNaN( obj );
	},

	type: function( obj ) {
		return obj == null ?
			String( obj ) :
			class2type[ toString.call(obj) ] || "object";
	},

	isPlainObject: function( obj ) {
		// Must be an Object.
		// Because of IE, we also have to check the presence of the constructor property.
		// Make sure that DOM nodes and window objects don't pass through, as well
		if ( !obj || jQuery.type(obj) !== "object" || obj.nodeType || jQuery.isWindow( obj ) ) {
			return false;
		}

		try {
			// Not own constructor property must be Object
			if ( obj.constructor &&
				!hasOwn.call(obj, "constructor") &&
				!hasOwn.call(obj.constructor.prototype, "isPrototypeOf") ) {
				return false;
			}
		} catch ( e ) {
			// IE8,9 Will throw exceptions on certain host objects #9897
			return false;
		}

		// Own properties are enumerated firstly, so to speed up,
		// if last one is own, then all properties are own.

		var key;
		for ( key in obj ) {}

		return key === undefined || hasOwn.call( obj, key );
	},

	isEmptyObject: function( obj ) {
		for ( var name in obj ) {
			return false;
		}
		return true;
	},

	error: function( msg ) {
		throw msg;
	},

	parseJSON: function( data ) {
		if ( typeof data !== "string" || !data ) {
			return null;
		}

		// Make sure leading/trailing whitespace is removed (IE can't handle it)
		data = jQuery.trim( data );

		// Attempt to parse using the native JSON parser first
		if ( window.JSON && window.JSON.parse ) {
			return window.JSON.parse( data );
		}

		// Make sure the incoming data is actual JSON
		// Logic borrowed from http://json.org/json2.js
		if ( rvalidchars.test( data.replace( rvalidescape, "@" )
			.replace( rvalidtokens, "]" )
			.replace( rvalidbraces, "")) ) {

			return (new Function( "return " + data ))();

		}
		jQuery.error( "Invalid JSON: " + data );
	},

	// Cross-browser xml parsing
	parseXML: function( data ) {
		var xml, tmp;
		try {
			if ( window.DOMParser ) { // Standard
				tmp = new DOMParser();
				xml = tmp.parseFromString( data , "text/xml" );
			} else { // IE
				xml = new ActiveXObject( "Microsoft.XMLDOM" );
				xml.async = "false";
				xml.loadXML( data );
			}
		} catch( e ) {
			xml = undefined;
		}
		if ( !xml || !xml.documentElement || xml.getElementsByTagName( "parsererror" ).length ) {
			jQuery.error( "Invalid XML: " + data );
		}
		return xml;
	},

	noop: function() {},

	// Evaluates a script in a global context
	// Workarounds based on findings by Jim Driscoll
	// http://weblogs.java.net/blog/driscoll/archive/2009/09/08/eval-javascript-global-context
	globalEval: function( data ) {
		if ( data && rnotwhite.test( data ) ) {
			// We use execScript on Internet Explorer
			// We use an anonymous function so that context is window
			// rather than jQuery in Firefox
			( window.execScript || function( data ) {
				window[ "eval" ].call( window, data );
			} )( data );
		}
	},

	// Convert dashed to camelCase; used by the css and data modules
	// Microsoft forgot to hump their vendor prefix (#9572)
	camelCase: function( string ) {
		return string.replace( rmsPrefix, "ms-" ).replace( rdashAlpha, fcamelCase );
	},

	nodeName: function( elem, name ) {
		return elem.nodeName && elem.nodeName.toUpperCase() === name.toUpperCase();
	},

	// args is for internal usage only
	each: function( object, callback, args ) {
		var name, i = 0,
			length = object.length,
			isObj = length === undefined || jQuery.isFunction( object );

		if ( args ) {
			if ( isObj ) {
				for ( name in object ) {
					if ( callback.apply( object[ name ], args ) === false ) {
						break;
					}
				}
			} else {
				for ( ; i < length; ) {
					if ( callback.apply( object[ i++ ], args ) === false ) {
						break;
					}
				}
			}

		// A special, fast, case for the most common use of each
		} else {
			if ( isObj ) {
				for ( name in object ) {
					if ( callback.call( object[ name ], name, object[ name ] ) === false ) {
						break;
					}
				}
			} else {
				for ( ; i < length; ) {
					if ( callback.call( object[ i ], i, object[ i++ ] ) === false ) {
						break;
					}
				}
			}
		}

		return object;
	},

	// Use native String.trim function wherever possible
	trim: trim ?
		function( text ) {
			return text == null ?
				"" :
				trim.call( text );
		} :

		// Otherwise use our own trimming functionality
		function( text ) {
			return text == null ?
				"" :
				text.toString().replace( trimLeft, "" ).replace( trimRight, "" );
		},

	// results is for internal usage only
	makeArray: function( array, results ) {
		var ret = results || [];

		if ( array != null ) {
			// The window, strings (and functions) also have 'length'
			// The extra typeof function check is to prevent crashes
			// in Safari 2 (See: #3039)
			// Tweaked logic slightly to handle Blackberry 4.7 RegExp issues #6930
			var type = jQuery.type( array );

			if ( array.length == null || type === "string" || type === "function" || type === "regexp" || jQuery.isWindow( array ) ) {
				push.call( ret, array );
			} else {
				jQuery.merge( ret, array );
			}
		}

		return ret;
	},

	inArray: function( elem, array ) {
		if ( !array ) {
			return -1;
		}

		if ( indexOf ) {
			return indexOf.call( array, elem );
		}

		for ( var i = 0, length = array.length; i < length; i++ ) {
			if ( array[ i ] === elem ) {
				return i;
			}
		}

		return -1;
	},

	merge: function( first, second ) {
		var i = first.length,
			j = 0;

		if ( typeof second.length === "number" ) {
			for ( var l = second.length; j < l; j++ ) {
				first[ i++ ] = second[ j ];
			}

		} else {
			while ( second[j] !== undefined ) {
				first[ i++ ] = second[ j++ ];
			}
		}

		first.length = i;

		return first;
	},

	grep: function( elems, callback, inv ) {
		var ret = [], retVal;
		inv = !!inv;

		// Go through the array, only saving the items
		// that pass the validator function
		for ( var i = 0, length = elems.length; i < length; i++ ) {
			retVal = !!callback( elems[ i ], i );
			if ( inv !== retVal ) {
				ret.push( elems[ i ] );
			}
		}

		return ret;
	},

	// arg is for internal usage only
	map: function( elems, callback, arg ) {
		var value, key, ret = [],
			i = 0,
			length = elems.length,
			// jquery objects are treated as arrays
			isArray = elems instanceof jQuery || length !== undefined && typeof length === "number" && ( ( length > 0 && elems[ 0 ] && elems[ length -1 ] ) || length === 0 || jQuery.isArray( elems ) ) ;

		// Go through the array, translating each of the items to their
		if ( isArray ) {
			for ( ; i < length; i++ ) {
				value = callback( elems[ i ], i, arg );

				if ( value != null ) {
					ret[ ret.length ] = value;
				}
			}

		// Go through every key on the object,
		} else {
			for ( key in elems ) {
				value = callback( elems[ key ], key, arg );

				if ( value != null ) {
					ret[ ret.length ] = value;
				}
			}
		}

		// Flatten any nested arrays
		return ret.concat.apply( [], ret );
	},

	// A global GUID counter for objects
	guid: 1,

	// Bind a function to a context, optionally partially applying any
	// arguments.
	proxy: function( fn, context ) {
		if ( typeof context === "string" ) {
			var tmp = fn[ context ];
			context = fn;
			fn = tmp;
		}

		// Quick check to determine if target is callable, in the spec
		// this throws a TypeError, but we will just return undefined.
		if ( !jQuery.isFunction( fn ) ) {
			return undefined;
		}

		// Simulated bind
		var args = slice.call( arguments, 2 ),
			proxy = function() {
				return fn.apply( context, args.concat( slice.call( arguments ) ) );
			};

		// Set the guid of unique handler to the same of original handler, so it can be removed
		proxy.guid = fn.guid = fn.guid || proxy.guid || jQuery.guid++;

		return proxy;
	},

	// Mutifunctional method to get and set values to a collection
	// The value/s can optionally be executed if it's a function
	access: function( elems, key, value, exec, fn, pass ) {
		var length = elems.length;

		// Setting many attributes
		if ( typeof key === "object" ) {
			for ( var k in key ) {
				jQuery.access( elems, k, key[k], exec, fn, value );
			}
			return elems;
		}

		// Setting one attribute
		if ( value !== undefined ) {
			// Optionally, function values get executed if exec is true
			exec = !pass && exec && jQuery.isFunction(value);

			for ( var i = 0; i < length; i++ ) {
				fn( elems[i], key, exec ? value.call( elems[i], i, fn( elems[i], key ) ) : value, pass );
			}

			return elems;
		}

		// Getting an attribute
		return length ? fn( elems[0], key ) : undefined;
	},

	now: function() {
		return (new Date()).getTime();
	},

	// Use of jQuery.browser is frowned upon.
	// More details: http://docs.jquery.com/Utilities/jQuery.browser
	uaMatch: function( ua ) {
		ua = ua.toLowerCase();

		var match = rwebkit.exec( ua ) ||
			ropera.exec( ua ) ||
			rmsie.exec( ua ) ||
			ua.indexOf("compatible") < 0 && rmozilla.exec( ua ) ||
			[];

		return { browser: match[1] || "", version: match[2] || "0" };
	},

	sub: function() {
		function jQuerySub( selector, context ) {
			return new jQuerySub.fn.init( selector, context );
		}
		jQuery.extend( true, jQuerySub, this );
		jQuerySub.superclass = this;
		jQuerySub.fn = jQuerySub.prototype = this();
		jQuerySub.fn.constructor = jQuerySub;
		jQuerySub.sub = this.sub;
		jQuerySub.fn.init = function init( selector, context ) {
			if ( context && context instanceof jQuery && !(context instanceof jQuerySub) ) {
				context = jQuerySub( context );
			}

			return jQuery.fn.init.call( this, selector, context, rootjQuerySub );
		};
		jQuerySub.fn.init.prototype = jQuerySub.fn;
		var rootjQuerySub = jQuerySub(document);
		return jQuerySub;
	},

	browser: {}
});

// Populate the class2type map
jQuery.each("Boolean Number String Function Array Date RegExp Object".split(" "), function(i, name) {
	class2type[ "[object " + name + "]" ] = name.toLowerCase();
});

browserMatch = jQuery.uaMatch( userAgent );
if ( browserMatch.browser ) {
	jQuery.browser[ browserMatch.browser ] = true;
	jQuery.browser.version = browserMatch.version;
}

// Deprecated, use jQuery.browser.webkit instead
if ( jQuery.browser.webkit ) {
	jQuery.browser.safari = true;
}

// IE doesn't match non-breaking spaces with \s
if ( rnotwhite.test( "\xA0" ) ) {
	trimLeft = /^[\s\xA0]+/;
	trimRight = /[\s\xA0]+$/;
}

// All jQuery objects should point back to these
rootjQuery = jQuery(document);

// Cleanup functions for the document ready method
if ( document.addEventListener ) {
	DOMContentLoaded = function() {
		document.removeEventListener( "DOMContentLoaded", DOMContentLoaded, false );
		jQuery.ready();
	};

} else if ( document.attachEvent ) {
	DOMContentLoaded = function() {
		// Make sure body exists, at least, in case IE gets a little overzealous (ticket #5443).
		if ( document.readyState === "complete" ) {
			document.detachEvent( "onreadystatechange", DOMContentLoaded );
			jQuery.ready();
		}
	};
}

// The DOM ready check for Internet Explorer
function doScrollCheck() {
	if ( jQuery.isReady ) {
		return;
	}

	try {
		// If IE is used, use the trick by Diego Perini
		// http://javascript.nwbox.com/IEContentLoaded/
		document.documentElement.doScroll("left");
	} catch(e) {
		setTimeout( doScrollCheck, 1 );
		return;
	}

	// and execute any waiting functions
	jQuery.ready();
}

return jQuery;

})();


var // Promise methods
	promiseMethods = "done fail isResolved isRejected promise then always pipe".split( " " ),
	// Static reference to slice
	sliceDeferred = [].slice;

jQuery.extend({
	// Create a simple deferred (one callbacks list)
	_Deferred: function() {
		var // callbacks list
			callbacks = [],
			// stored [ context , args ]
			fired,
			// to avoid firing when already doing so
			firing,
			// flag to know if the deferred has been cancelled
			cancelled,
			// the deferred itself
			deferred  = {

				// done( f1, f2, ...)
				done: function() {
					if ( !cancelled ) {
						var args = arguments,
							i,
							length,
							elem,
							type,
							_fired;
						if ( fired ) {
							_fired = fired;
							fired = 0;
						}
						for ( i = 0, length = args.length; i < length; i++ ) {
							elem = args[ i ];
							type = jQuery.type( elem );
							if ( type === "array" ) {
								deferred.done.apply( deferred, elem );
							} else if ( type === "function" ) {
								callbacks.push( elem );
							}
						}
						if ( _fired ) {
							deferred.resolveWith( _fired[ 0 ], _fired[ 1 ] );
						}
					}
					return this;
				},

				// resolve with given context and args
				resolveWith: function( context, args ) {
					if ( !cancelled && !fired && !firing ) {
						// make sure args are available (#8421)
						args = args || [];
						firing = 1;
						try {
							while( callbacks[ 0 ] ) {
								callbacks.shift().apply( context, args );
							}
						}
						finally {
							fired = [ context, args ];
							firing = 0;
						}
					}
					return this;
				},

				// resolve with this as context and given arguments
				resolve: function() {
					deferred.resolveWith( this, arguments );
					return this;
				},

				// Has this deferred been resolved?
				isResolved: function() {
					return !!( firing || fired );
				},

				// Cancel
				cancel: function() {
					cancelled = 1;
					callbacks = [];
					return this;
				}
			};

		return deferred;
	},

	// Full fledged deferred (two callbacks list)
	Deferred: function( func ) {
		var deferred = jQuery._Deferred(),
			failDeferred = jQuery._Deferred(),
			promise;
		// Add errorDeferred methods, then and promise
		jQuery.extend( deferred, {
			then: function( doneCallbacks, failCallbacks ) {
				deferred.done( doneCallbacks ).fail( failCallbacks );
				return this;
			},
			always: function() {
				return deferred.done.apply( deferred, arguments ).fail.apply( this, arguments );
			},
			fail: failDeferred.done,
			rejectWith: failDeferred.resolveWith,
			reject: failDeferred.resolve,
			isRejected: failDeferred.isResolved,
			pipe: function( fnDone, fnFail ) {
				return jQuery.Deferred(function( newDefer ) {
					jQuery.each( {
						done: [ fnDone, "resolve" ],
						fail: [ fnFail, "reject" ]
					}, function( handler, data ) {
						var fn = data[ 0 ],
							action = data[ 1 ],
							returned;
						if ( jQuery.isFunction( fn ) ) {
							deferred[ handler ](function() {
								returned = fn.apply( this, arguments );
								if ( returned && jQuery.isFunction( returned.promise ) ) {
									returned.promise().then( newDefer.resolve, newDefer.reject );
								} else {
									newDefer[ action + "With" ]( this === deferred ? newDefer : this, [ returned ] );
								}
							});
						} else {
							deferred[ handler ]( newDefer[ action ] );
						}
					});
				}).promise();
			},
			// Get a promise for this deferred
			// If obj is provided, the promise aspect is added to the object
			promise: function( obj ) {
				if ( obj == null ) {
					if ( promise ) {
						return promise;
					}
					promise = obj = {};
				}
				var i = promiseMethods.length;
				while( i-- ) {
					obj[ promiseMethods[i] ] = deferred[ promiseMethods[i] ];
				}
				return obj;
			}
		});
		// Make sure only one callback list will be used
		deferred.done( failDeferred.cancel ).fail( deferred.cancel );
		// Unexpose cancel
		delete deferred.cancel;
		// Call given func if any
		if ( func ) {
			func.call( deferred, deferred );
		}
		return deferred;
	},

	// Deferred helper
	when: function( firstParam ) {
		var args = arguments,
			i = 0,
			length = args.length,
			count = length,
			deferred = length <= 1 && firstParam && jQuery.isFunction( firstParam.promise ) ?
				firstParam :
				jQuery.Deferred();
		function resolveFunc( i ) {
			return function( value ) {
				args[ i ] = arguments.length > 1 ? sliceDeferred.call( arguments, 0 ) : value;
				if ( !( --count ) ) {
					// Strange bug in FF4:
					// Values changed onto the arguments object sometimes end up as undefined values
					// outside the $.when method. Cloning the object into a fresh array solves the issue
					deferred.resolveWith( deferred, sliceDeferred.call( args, 0 ) );
				}
			};
		}
		if ( length > 1 ) {
			for( ; i < length; i++ ) {
				if ( args[ i ] && jQuery.isFunction( args[ i ].promise ) ) {
					args[ i ].promise().then( resolveFunc(i), deferred.reject );
				} else {
					--count;
				}
			}
			if ( !count ) {
				deferred.resolveWith( deferred, args );
			}
		} else if ( deferred !== firstParam ) {
			deferred.resolveWith( deferred, length ? [ firstParam ] : [] );
		}
		return deferred.promise();
	}
});



jQuery.support = (function() {

	var div = document.createElement( "div" ),
		documentElement = document.documentElement,
		all,
		a,
		select,
		opt,
		input,
		marginDiv,
		support,
		fragment,
		body,
		testElementParent,
		testElement,
		testElementStyle,
		tds,
		events,
		eventName,
		i,
		isSupported;

	// Preliminary tests
	div.setAttribute("className", "t");
	div.innerHTML = "   <link/><table></table><a href='/a' style='top:1px;float:left;opacity:.55;'>a</a><input type='checkbox'/>";


	all = div.getElementsByTagName( "*" );
	a = div.getElementsByTagName( "a" )[ 0 ];

	// Can't get basic test support
	if ( !all || !all.length || !a ) {
		return {};
	}

	// First batch of supports tests
	select = document.createElement( "select" );
	opt = select.appendChild( document.createElement("option") );
	input = div.getElementsByTagName( "input" )[ 0 ];

	support = {
		// IE strips leading whitespace when .innerHTML is used
		leadingWhitespace: ( div.firstChild.nodeType === 3 ),

		// Make sure that tbody elements aren't automatically inserted
		// IE will insert them into empty tables
		tbody: !div.getElementsByTagName( "tbody" ).length,

		// Make sure that link elements get serialized correctly by innerHTML
		// This requires a wrapper element in IE
		htmlSerialize: !!div.getElementsByTagName( "link" ).length,

		// Get the style information from getAttribute
		// (IE uses .cssText instead)
		style: /top/.test( a.getAttribute("style") ),

		// Make sure that URLs aren't manipulated
		// (IE normalizes it by default)
		hrefNormalized: ( a.getAttribute( "href" ) === "/a" ),

		// Make sure that element opacity exists
		// (IE uses filter instead)
		// Use a regex to work around a WebKit issue. See #5145
		opacity: /^0.55$/.test( a.style.opacity ),

		// Verify style float existence
		// (IE uses styleFloat instead of cssFloat)
		cssFloat: !!a.style.cssFloat,

		// Make sure that if no value is specified for a checkbox
		// that it defaults to "on".
		// (WebKit defaults to "" instead)
		checkOn: ( input.value === "on" ),

		// Make sure that a selected-by-default option has a working selected property.
		// (WebKit defaults to false instead of true, IE too, if it's in an optgroup)
		optSelected: opt.selected,

		// Test setAttribute on camelCase class. If it works, we need attrFixes when doing get/setAttribute (ie6/7)
		getSetAttribute: div.className !== "t",

		// Will be defined later
		submitBubbles: true,
		changeBubbles: true,
		focusinBubbles: false,
		deleteExpando: true,
		noCloneEvent: true,
		inlineBlockNeedsLayout: false,
		shrinkWrapBlocks: false,
		reliableMarginRight: true
	};

	// Make sure checked status is properly cloned
	input.checked = true;
	support.noCloneChecked = input.cloneNode( true ).checked;

	// Make sure that the options inside disabled selects aren't marked as disabled
	// (WebKit marks them as disabled)
	select.disabled = true;
	support.optDisabled = !opt.disabled;

	// Test to see if it's possible to delete an expando from an element
	// Fails in Internet Explorer
	try {
		delete div.test;
	} catch( e ) {
		support.deleteExpando = false;
	}

	if ( !div.addEventListener && div.attachEvent && div.fireEvent ) {
		div.attachEvent( "onclick", function() {
			// Cloning a node shouldn't copy over any
			// bound event handlers (IE does this)
			support.noCloneEvent = false;
		});
		div.cloneNode( true ).fireEvent( "onclick" );
	}

	// Check if a radio maintains it's value
	// after being appended to the DOM
	input = document.createElement("input");
	input.value = "t";
	input.setAttribute("type", "radio");
	support.radioValue = input.value === "t";

	input.setAttribute("checked", "checked");
	div.appendChild( input );
	fragment = document.createDocumentFragment();
	fragment.appendChild( div.firstChild );

	// WebKit doesn't clone checked state correctly in fragments
	support.checkClone = fragment.cloneNode( true ).cloneNode( true ).lastChild.checked;

	div.innerHTML = "";

	// Figure out if the W3C box model works as expected
	div.style.width = div.style.paddingLeft = "1px";

	body = document.getElementsByTagName( "body" )[ 0 ];
	// We use our own, invisible, body unless the body is already present
	// in which case we use a div (#9239)
	testElement = document.createElement( body ? "div" : "body" );
	testElementStyle = {
		visibility: "hidden",
		width: 0,
		height: 0,
		border: 0,
		margin: 0,
		background: "none"
	};
	if ( body ) {
		jQuery.extend( testElementStyle, {
			position: "absolute",
			left: "-1000px",
			top: "-1000px"
		});
	}
	for ( i in testElementStyle ) {
		testElement.style[ i ] = testElementStyle[ i ];
	}
	testElement.appendChild( div );
	testElementParent = body || documentElement;
	testElementParent.insertBefore( testElement, testElementParent.firstChild );

	// Check if a disconnected checkbox will retain its checked
	// value of true after appended to the DOM (IE6/7)
	support.appendChecked = input.checked;

	support.boxModel = div.offsetWidth === 2;

	if ( "zoom" in div.style ) {
		// Check if natively block-level elements act like inline-block
		// elements when setting their display to 'inline' and giving
		// them layout
		// (IE < 8 does this)
		div.style.display = "inline";
		div.style.zoom = 1;
		support.inlineBlockNeedsLayout = ( div.offsetWidth === 2 );

		// Check if elements with layout shrink-wrap their children
		// (IE 6 does this)
		div.style.display = "";
		div.innerHTML = "<div style='width:4px;'></div>";
		support.shrinkWrapBlocks = ( div.offsetWidth !== 2 );
	}

	div.innerHTML = "<table><tr><td style='padding:0;border:0;display:none'></td><td>t</td></tr></table>";
	tds = div.getElementsByTagName( "td" );

	// Check if table cells still have offsetWidth/Height when they are set
	// to display:none and there are still other visible table cells in a
	// table row; if so, offsetWidth/Height are not reliable for use when
	// determining if an element has been hidden directly using
	// display:none (it is still safe to use offsets if a parent element is
	// hidden; don safety goggles and see bug #4512 for more information).
	// (only IE 8 fails this test)
	isSupported = ( tds[ 0 ].offsetHeight === 0 );

	tds[ 0 ].style.display = "";
	tds[ 1 ].style.display = "none";

	// Check if empty table cells still have offsetWidth/Height
	// (IE < 8 fail this test)
	support.reliableHiddenOffsets = isSupported && ( tds[ 0 ].offsetHeight === 0 );
	div.innerHTML = "";

	// Check if div with explicit width and no margin-right incorrectly
	// gets computed margin-right based on width of container. For more
	// info see bug #3333
	// Fails in WebKit before Feb 2011 nightlies
	// WebKit Bug 13343 - getComputedStyle returns wrong value for margin-right
	if ( document.defaultView && document.defaultView.getComputedStyle ) {
		marginDiv = document.createElement( "div" );
		marginDiv.style.width = "0";
		marginDiv.style.marginRight = "0";
		div.appendChild( marginDiv );
		support.reliableMarginRight =
			( parseInt( ( document.defaultView.getComputedStyle( marginDiv, null ) || { marginRight: 0 } ).marginRight, 10 ) || 0 ) === 0;
	}

	// Remove the body element we added
	testElement.innerHTML = "";
	testElementParent.removeChild( testElement );

	// Technique from Juriy Zaytsev
	// http://thinkweb2.com/projects/prototype/detecting-event-support-without-browser-sniffing/
	// We only care about the case where non-standard event systems
	// are used, namely in IE. Short-circuiting here helps us to
	// avoid an eval call (in setAttribute) which can cause CSP
	// to go haywire. See: https://developer.mozilla.org/en/Security/CSP
	if ( div.attachEvent ) {
		for( i in {
			submit: 1,
			change: 1,
			focusin: 1
		} ) {
			eventName = "on" + i;
			isSupported = ( eventName in div );
			if ( !isSupported ) {
				div.setAttribute( eventName, "return;" );
				isSupported = ( typeof div[ eventName ] === "function" );
			}
			support[ i + "Bubbles" ] = isSupported;
		}
	}

	// Null connected elements to avoid leaks in IE
	testElement = fragment = select = opt = body = marginDiv = div = input = null;

	return support;
})();

// Keep track of boxModel
jQuery.boxModel = jQuery.support.boxModel;




var rbrace = /^(?:\{.*\}|\[.*\])$/,
	rmultiDash = /([A-Z])/g;

jQuery.extend({
	cache: {},

	// Please use with caution
	uuid: 0,

	// Unique for each copy of jQuery on the page
	// Non-digits removed to match rinlinejQuery
	expando: "jQuery" + ( jQuery.fn.jquery + Math.random() ).replace( /\D/g, "" ),

	// The following elements throw uncatchable exceptions if you
	// attempt to add expando properties to them.
	noData: {
		"embed": true,
		// Ban all objects except for Flash (which handle expandos)
		"object": "clsid:D27CDB6E-AE6D-11cf-96B8-444553540000",
		"applet": true
	},

	hasData: function( elem ) {
		elem = elem.nodeType ? jQuery.cache[ elem[jQuery.expando] ] : elem[ jQuery.expando ];

		return !!elem && !isEmptyDataObject( elem );
	},

	data: function( elem, name, data, pvt /* Internal Use Only */ ) {
		if ( !jQuery.acceptData( elem ) ) {
			return;
		}

		var thisCache, ret,
			internalKey = jQuery.expando,
			getByName = typeof name === "string",

			// We have to handle DOM nodes and JS objects differently because IE6-7
			// can't GC object references properly across the DOM-JS boundary
			isNode = elem.nodeType,

			// Only DOM nodes need the global jQuery cache; JS object data is
			// attached directly to the object so GC can occur automatically
			cache = isNode ? jQuery.cache : elem,

			// Only defining an ID for JS objects if its cache already exists allows
			// the code to shortcut on the same path as a DOM node with no cache
			id = isNode ? elem[ jQuery.expando ] : elem[ jQuery.expando ] && jQuery.expando;

		// Avoid doing any more work than we need to when trying to get data on an
		// object that has no data at all
		if ( (!id || (pvt && id && (cache[ id ] && !cache[ id ][ internalKey ]))) && getByName && data === undefined ) {
			return;
		}

		if ( !id ) {
			// Only DOM nodes need a new unique ID for each element since their data
			// ends up in the global cache
			if ( isNode ) {
				elem[ jQuery.expando ] = id = ++jQuery.uuid;
			} else {
				id = jQuery.expando;
			}
		}

		if ( !cache[ id ] ) {
			cache[ id ] = {};

			// TODO: This is a hack for 1.5 ONLY. Avoids exposing jQuery
			// metadata on plain JS objects when the object is serialized using
			// JSON.stringify
			if ( !isNode ) {
				cache[ id ].toJSON = jQuery.noop;
			}
		}

		// An object can be passed to jQuery.data instead of a key/value pair; this gets
		// shallow copied over onto the existing cache
		if ( typeof name === "object" || typeof name === "function" ) {
			if ( pvt ) {
				cache[ id ][ internalKey ] = jQuery.extend(cache[ id ][ internalKey ], name);
			} else {
				cache[ id ] = jQuery.extend(cache[ id ], name);
			}
		}

		thisCache = cache[ id ];

		// Internal jQuery data is stored in a separate object inside the object's data
		// cache in order to avoid key collisions between internal data and user-defined
		// data
		if ( pvt ) {
			if ( !thisCache[ internalKey ] ) {
				thisCache[ internalKey ] = {};
			}

			thisCache = thisCache[ internalKey ];
		}

		if ( data !== undefined ) {
			thisCache[ jQuery.camelCase( name ) ] = data;
		}

		// TODO: This is a hack for 1.5 ONLY. It will be removed in 1.6. Users should
		// not attempt to inspect the internal events object using jQuery.data, as this
		// internal data object is undocumented and subject to change.
		if ( name === "events" && !thisCache[name] ) {
			return thisCache[ internalKey ] && thisCache[ internalKey ].events;
		}

		// Check for both converted-to-camel and non-converted data property names
		// If a data property was specified
		if ( getByName ) {

			// First Try to find as-is property data
			ret = thisCache[ name ];

			// Test for null|undefined property data
			if ( ret == null ) {

				// Try to find the camelCased property
				ret = thisCache[ jQuery.camelCase( name ) ];
			}
		} else {
			ret = thisCache;
		}

		return ret;
	},

	removeData: function( elem, name, pvt /* Internal Use Only */ ) {
		if ( !jQuery.acceptData( elem ) ) {
			return;
		}

		var thisCache,

			// Reference to internal data cache key
			internalKey = jQuery.expando,

			isNode = elem.nodeType,

			// See jQuery.data for more information
			cache = isNode ? jQuery.cache : elem,

			// See jQuery.data for more information
			id = isNode ? elem[ jQuery.expando ] : jQuery.expando;

		// If there is already no cache entry for this object, there is no
		// purpose in continuing
		if ( !cache[ id ] ) {
			return;
		}

		if ( name ) {

			thisCache = pvt ? cache[ id ][ internalKey ] : cache[ id ];

			if ( thisCache ) {

				// Support interoperable removal of hyphenated or camelcased keys
				if ( !thisCache[ name ] ) {
					name = jQuery.camelCase( name );
				}

				delete thisCache[ name ];

				// If there is no data left in the cache, we want to continue
				// and let the cache object itself get destroyed
				if ( !isEmptyDataObject(thisCache) ) {
					return;
				}
			}
		}

		// See jQuery.data for more information
		if ( pvt ) {
			delete cache[ id ][ internalKey ];

			// Don't destroy the parent cache unless the internal data object
			// had been the only thing left in it
			if ( !isEmptyDataObject(cache[ id ]) ) {
				return;
			}
		}

		var internalCache = cache[ id ][ internalKey ];

		// Browsers that fail expando deletion also refuse to delete expandos on
		// the window, but it will allow it on all other JS objects; other browsers
		// don't care
		// Ensure that `cache` is not a window object #10080
		if ( jQuery.support.deleteExpando || !cache.setInterval ) {
			delete cache[ id ];
		} else {
			cache[ id ] = null;
		}

		// We destroyed the entire user cache at once because it's faster than
		// iterating through each key, but we need to continue to persist internal
		// data if it existed
		if ( internalCache ) {
			cache[ id ] = {};
			// TODO: This is a hack for 1.5 ONLY. Avoids exposing jQuery
			// metadata on plain JS objects when the object is serialized using
			// JSON.stringify
			if ( !isNode ) {
				cache[ id ].toJSON = jQuery.noop;
			}

			cache[ id ][ internalKey ] = internalCache;

		// Otherwise, we need to eliminate the expando on the node to avoid
		// false lookups in the cache for entries that no longer exist
		} else if ( isNode ) {
			// IE does not allow us to delete expando properties from nodes,
			// nor does it have a removeAttribute function on Document nodes;
			// we must handle all of these cases
			if ( jQuery.support.deleteExpando ) {
				delete elem[ jQuery.expando ];
			} else if ( elem.removeAttribute ) {
				elem.removeAttribute( jQuery.expando );
			} else {
				elem[ jQuery.expando ] = null;
			}
		}
	},

	// For internal use only.
	_data: function( elem, name, data ) {
		return jQuery.data( elem, name, data, true );
	},

	// A method for determining if a DOM node can handle the data expando
	acceptData: function( elem ) {
		if ( elem.nodeName ) {
			var match = jQuery.noData[ elem.nodeName.toLowerCase() ];

			if ( match ) {
				return !(match === true || elem.getAttribute("classid") !== match);
			}
		}

		return true;
	}
});

jQuery.fn.extend({
	data: function( key, value ) {
		var data = null;

		if ( typeof key === "undefined" ) {
			if ( this.length ) {
				data = jQuery.data( this[0] );

				if ( this[0].nodeType === 1 ) {
			    var attr = this[0].attributes, name;
					for ( var i = 0, l = attr.length; i < l; i++ ) {
						name = attr[i].name;

						if ( name.indexOf( "data-" ) === 0 ) {
							name = jQuery.camelCase( name.substring(5) );

							dataAttr( this[0], name, data[ name ] );
						}
					}
				}
			}

			return data;

		} else if ( typeof key === "object" ) {
			return this.each(function() {
				jQuery.data( this, key );
			});
		}

		var parts = key.split(".");
		parts[1] = parts[1] ? "." + parts[1] : "";

		if ( value === undefined ) {
			data = this.triggerHandler("getData" + parts[1] + "!", [parts[0]]);

			// Try to fetch any internally stored data first
			if ( data === undefined && this.length ) {
				data = jQuery.data( this[0], key );
				data = dataAttr( this[0], key, data );
			}

			return data === undefined && parts[1] ?
				this.data( parts[0] ) :
				data;

		} else {
			return this.each(function() {
				var $this = jQuery( this ),
					args = [ parts[0], value ];

				$this.triggerHandler( "setData" + parts[1] + "!", args );
				jQuery.data( this, key, value );
				$this.triggerHandler( "changeData" + parts[1] + "!", args );
			});
		}
	},

	removeData: function( key ) {
		return this.each(function() {
			jQuery.removeData( this, key );
		});
	}
});

function dataAttr( elem, key, data ) {
	// If nothing was found internally, try to fetch any
	// data from the HTML5 data-* attribute
	if ( data === undefined && elem.nodeType === 1 ) {

		var name = "data-" + key.replace( rmultiDash, "-$1" ).toLowerCase();

		data = elem.getAttribute( name );

		if ( typeof data === "string" ) {
			try {
				data = data === "true" ? true :
				data === "false" ? false :
				data === "null" ? null :
				!jQuery.isNaN( data ) ? parseFloat( data ) :
					rbrace.test( data ) ? jQuery.parseJSON( data ) :
					data;
			} catch( e ) {}

			// Make sure we set the data so it isn't changed later
			jQuery.data( elem, key, data );

		} else {
			data = undefined;
		}
	}

	return data;
}

// TODO: This is a hack for 1.5 ONLY to allow objects with a single toJSON
// property to be considered empty objects; this property always exists in
// order to make sure JSON.stringify does not expose internal metadata
function isEmptyDataObject( obj ) {
	for ( var name in obj ) {
		if ( name !== "toJSON" ) {
			return false;
		}
	}

	return true;
}




function handleQueueMarkDefer( elem, type, src ) {
	var deferDataKey = type + "defer",
		queueDataKey = type + "queue",
		markDataKey = type + "mark",
		defer = jQuery.data( elem, deferDataKey, undefined, true );
	if ( defer &&
		( src === "queue" || !jQuery.data( elem, queueDataKey, undefined, true ) ) &&
		( src === "mark" || !jQuery.data( elem, markDataKey, undefined, true ) ) ) {
		// Give room for hard-coded callbacks to fire first
		// and eventually mark/queue something else on the element
		setTimeout( function() {
			if ( !jQuery.data( elem, queueDataKey, undefined, true ) &&
				!jQuery.data( elem, markDataKey, undefined, true ) ) {
				jQuery.removeData( elem, deferDataKey, true );
				defer.resolve();
			}
		}, 0 );
	}
}

jQuery.extend({

	_mark: function( elem, type ) {
		if ( elem ) {
			type = (type || "fx") + "mark";
			jQuery.data( elem, type, (jQuery.data(elem,type,undefined,true) || 0) + 1, true );
		}
	},

	_unmark: function( force, elem, type ) {
		if ( force !== true ) {
			type = elem;
			elem = force;
			force = false;
		}
		if ( elem ) {
			type = type || "fx";
			var key = type + "mark",
				count = force ? 0 : ( (jQuery.data( elem, key, undefined, true) || 1 ) - 1 );
			if ( count ) {
				jQuery.data( elem, key, count, true );
			} else {
				jQuery.removeData( elem, key, true );
				handleQueueMarkDefer( elem, type, "mark" );
			}
		}
	},

	queue: function( elem, type, data ) {
		if ( elem ) {
			type = (type || "fx") + "queue";
			var q = jQuery.data( elem, type, undefined, true );
			// Speed up dequeue by getting out quickly if this is just a lookup
			if ( data ) {
				if ( !q || jQuery.isArray(data) ) {
					q = jQuery.data( elem, type, jQuery.makeArray(data), true );
				} else {
					q.push( data );
				}
			}
			return q || [];
		}
	},

	dequeue: function( elem, type ) {
		type = type || "fx";

		var queue = jQuery.queue( elem, type ),
			fn = queue.shift(),
			defer;

		// If the fx queue is dequeued, always remove the progress sentinel
		if ( fn === "inprogress" ) {
			fn = queue.shift();
		}

		if ( fn ) {
			// Add a progress sentinel to prevent the fx queue from being
			// automatically dequeued
			if ( type === "fx" ) {
				queue.unshift("inprogress");
			}

			fn.call(elem, function() {
				jQuery.dequeue(elem, type);
			});
		}

		if ( !queue.length ) {
			jQuery.removeData( elem, type + "queue", true );
			handleQueueMarkDefer( elem, type, "queue" );
		}
	}
});

jQuery.fn.extend({
	queue: function( type, data ) {
		if ( typeof type !== "string" ) {
			data = type;
			type = "fx";
		}

		if ( data === undefined ) {
			return jQuery.queue( this[0], type );
		}
		return this.each(function() {
			var queue = jQuery.queue( this, type, data );

			if ( type === "fx" && queue[0] !== "inprogress" ) {
				jQuery.dequeue( this, type );
			}
		});
	},
	dequeue: function( type ) {
		return this.each(function() {
			jQuery.dequeue( this, type );
		});
	},
	// Based off of the plugin by Clint Helfers, with permission.
	// http://blindsignals.com/index.php/2009/07/jquery-delay/
	delay: function( time, type ) {
		time = jQuery.fx ? jQuery.fx.speeds[time] || time : time;
		type = type || "fx";

		return this.queue( type, function() {
			var elem = this;
			setTimeout(function() {
				jQuery.dequeue( elem, type );
			}, time );
		});
	},
	clearQueue: function( type ) {
		return this.queue( type || "fx", [] );
	},
	// Get a promise resolved when queues of a certain type
	// are emptied (fx is the type by default)
	promise: function( type, object ) {
		if ( typeof type !== "string" ) {
			object = type;
			type = undefined;
		}
		type = type || "fx";
		var defer = jQuery.Deferred(),
			elements = this,
			i = elements.length,
			count = 1,
			deferDataKey = type + "defer",
			queueDataKey = type + "queue",
			markDataKey = type + "mark",
			tmp;
		function resolve() {
			if ( !( --count ) ) {
				defer.resolveWith( elements, [ elements ] );
			}
		}
		while( i-- ) {
			if (( tmp = jQuery.data( elements[ i ], deferDataKey, undefined, true ) ||
					( jQuery.data( elements[ i ], queueDataKey, undefined, true ) ||
						jQuery.data( elements[ i ], markDataKey, undefined, true ) ) &&
					jQuery.data( elements[ i ], deferDataKey, jQuery._Deferred(), true ) )) {
				count++;
				tmp.done( resolve );
			}
		}
		resolve();
		return defer.promise();
	}
});




var rclass = /[\n\t\r]/g,
	rspace = /\s+/,
	rreturn = /\r/g,
	rtype = /^(?:button|input)$/i,
	rfocusable = /^(?:button|input|object|select|textarea)$/i,
	rclickable = /^a(?:rea)?$/i,
	rboolean = /^(?:autofocus|autoplay|async|checked|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped|selected)$/i,
	nodeHook, boolHook;

jQuery.fn.extend({
	attr: function( name, value ) {
		return jQuery.access( this, name, value, true, jQuery.attr );
	},

	removeAttr: function( name ) {
		return this.each(function() {
			jQuery.removeAttr( this, name );
		});
	},
	
	prop: function( name, value ) {
		return jQuery.access( this, name, value, true, jQuery.prop );
	},
	
	removeProp: function( name ) {
		name = jQuery.propFix[ name ] || name;
		return this.each(function() {
			// try/catch handles cases where IE balks (such as removing a property on window)
			try {
				this[ name ] = undefined;
				delete this[ name ];
			} catch( e ) {}
		});
	},

	addClass: function( value ) {
		var classNames, i, l, elem,
			setClass, c, cl;

		if ( jQuery.isFunction( value ) ) {
			return this.each(function( j ) {
				jQuery( this ).addClass( value.call(this, j, this.className) );
			});
		}

		if ( value && typeof value === "string" ) {
			classNames = value.split( rspace );

			for ( i = 0, l = this.length; i < l; i++ ) {
				elem = this[ i ];

				if ( elem.nodeType === 1 ) {
					if ( !elem.className && classNames.length === 1 ) {
						elem.className = value;

					} else {
						setClass = " " + elem.className + " ";

						for ( c = 0, cl = classNames.length; c < cl; c++ ) {
							if ( !~setClass.indexOf( " " + classNames[ c ] + " " ) ) {
								setClass += classNames[ c ] + " ";
							}
						}
						elem.className = jQuery.trim( setClass );
					}
				}
			}
		}

		return this;
	},

	removeClass: function( value ) {
		var classNames, i, l, elem, className, c, cl;

		if ( jQuery.isFunction( value ) ) {
			return this.each(function( j ) {
				jQuery( this ).removeClass( value.call(this, j, this.className) );
			});
		}

		if ( (value && typeof value === "string") || value === undefined ) {
			classNames = (value || "").split( rspace );

			for ( i = 0, l = this.length; i < l; i++ ) {
				elem = this[ i ];

				if ( elem.nodeType === 1 && elem.className ) {
					if ( value ) {
						className = (" " + elem.className + " ").replace( rclass, " " );
						for ( c = 0, cl = classNames.length; c < cl; c++ ) {
							className = className.replace(" " + classNames[ c ] + " ", " ");
						}
						elem.className = jQuery.trim( className );

					} else {
						elem.className = "";
					}
				}
			}
		}

		return this;
	},

	toggleClass: function( value, stateVal ) {
		var type = typeof value,
			isBool = typeof stateVal === "boolean";

		if ( jQuery.isFunction( value ) ) {
			return this.each(function( i ) {
				jQuery( this ).toggleClass( value.call(this, i, this.className, stateVal), stateVal );
			});
		}

		return this.each(function() {
			if ( type === "string" ) {
				// toggle individual class names
				var className,
					i = 0,
					self = jQuery( this ),
					state = stateVal,
					classNames = value.split( rspace );

				while ( (className = classNames[ i++ ]) ) {
					// check each className given, space seperated list
					state = isBool ? state : !self.hasClass( className );
					self[ state ? "addClass" : "removeClass" ]( className );
				}

			} else if ( type === "undefined" || type === "boolean" ) {
				if ( this.className ) {
					// store className if set
					jQuery._data( this, "__className__", this.className );
				}

				// toggle whole className
				this.className = this.className || value === false ? "" : jQuery._data( this, "__className__" ) || "";
			}
		});
	},

	hasClass: function( selector ) {
		var className = " " + selector + " ";
		for ( var i = 0, l = this.length; i < l; i++ ) {
			if ( this[i].nodeType === 1 && (" " + this[i].className + " ").replace(rclass, " ").indexOf( className ) > -1 ) {
				return true;
			}
		}

		return false;
	},

	val: function( value ) {
		var hooks, ret,
			elem = this[0];
		
		if ( !arguments.length ) {
			if ( elem ) {
				hooks = jQuery.valHooks[ elem.nodeName.toLowerCase() ] || jQuery.valHooks[ elem.type ];

				if ( hooks && "get" in hooks && (ret = hooks.get( elem, "value" )) !== undefined ) {
					return ret;
				}

				ret = elem.value;

				return typeof ret === "string" ? 
					// handle most common string cases
					ret.replace(rreturn, "") : 
					// handle cases where value is null/undef or number
					ret == null ? "" : ret;
			}

			return undefined;
		}

		var isFunction = jQuery.isFunction( value );

		return this.each(function( i ) {
			var self = jQuery(this), val;

			if ( this.nodeType !== 1 ) {
				return;
			}

			if ( isFunction ) {
				val = value.call( this, i, self.val() );
			} else {
				val = value;
			}

			// Treat null/undefined as ""; convert numbers to string
			if ( val == null ) {
				val = "";
			} else if ( typeof val === "number" ) {
				val += "";
			} else if ( jQuery.isArray( val ) ) {
				val = jQuery.map(val, function ( value ) {
					return value == null ? "" : value + "";
				});
			}

			hooks = jQuery.valHooks[ this.nodeName.toLowerCase() ] || jQuery.valHooks[ this.type ];

			// If set returns undefined, fall back to normal setting
			if ( !hooks || !("set" in hooks) || hooks.set( this, val, "value" ) === undefined ) {
				this.value = val;
			}
		});
	}
});

jQuery.extend({
	valHooks: {
		option: {
			get: function( elem ) {
				// attributes.value is undefined in Blackberry 4.7 but
				// uses .value. See #6932
				var val = elem.attributes.value;
				return !val || val.specified ? elem.value : elem.text;
			}
		},
		select: {
			get: function( elem ) {
				var value,
					index = elem.selectedIndex,
					values = [],
					options = elem.options,
					one = elem.type === "select-one";

				// Nothing was selected
				if ( index < 0 ) {
					return null;
				}

				// Loop through all the selected options
				for ( var i = one ? index : 0, max = one ? index + 1 : options.length; i < max; i++ ) {
					var option = options[ i ];

					// Don't return options that are disabled or in a disabled optgroup
					if ( option.selected && (jQuery.support.optDisabled ? !option.disabled : option.getAttribute("disabled") === null) &&
							(!option.parentNode.disabled || !jQuery.nodeName( option.parentNode, "optgroup" )) ) {

						// Get the specific value for the option
						value = jQuery( option ).val();

						// We don't need an array for one selects
						if ( one ) {
							return value;
						}

						// Multi-Selects return an array
						values.push( value );
					}
				}

				// Fixes Bug #2551 -- select.val() broken in IE after form.reset()
				if ( one && !values.length && options.length ) {
					return jQuery( options[ index ] ).val();
				}

				return values;
			},

			set: function( elem, value ) {
				var values = jQuery.makeArray( value );

				jQuery(elem).find("option").each(function() {
					this.selected = jQuery.inArray( jQuery(this).val(), values ) >= 0;
				});

				if ( !values.length ) {
					elem.selectedIndex = -1;
				}
				return values;
			}
		}
	},

	attrFn: {
		val: true,
		css: true,
		html: true,
		text: true,
		data: true,
		width: true,
		height: true,
		offset: true
	},
	
	attrFix: {
		// Always normalize to ensure hook usage
		tabindex: "tabIndex"
	},
	
	attr: function( elem, name, value, pass ) {
		var nType = elem.nodeType;
		
		// don't get/set attributes on text, comment and attribute nodes
		if ( !elem || nType === 3 || nType === 8 || nType === 2 ) {
			return undefined;
		}

		if ( pass && name in jQuery.attrFn ) {
			return jQuery( elem )[ name ]( value );
		}

		// Fallback to prop when attributes are not supported
		if ( !("getAttribute" in elem) ) {
			return jQuery.prop( elem, name, value );
		}

		var ret, hooks,
			notxml = nType !== 1 || !jQuery.isXMLDoc( elem );

		// Normalize the name if needed
		if ( notxml ) {
			name = jQuery.attrFix[ name ] || name;

			hooks = jQuery.attrHooks[ name ];

			if ( !hooks ) {
				// Use boolHook for boolean attributes
				if ( rboolean.test( name ) ) {
					hooks = boolHook;

				// Use nodeHook if available( IE6/7 )
				} else if ( nodeHook ) {
					hooks = nodeHook;
				}
			}
		}

		if ( value !== undefined ) {

			if ( value === null ) {
				jQuery.removeAttr( elem, name );
				return undefined;

			} else if ( hooks && "set" in hooks && notxml && (ret = hooks.set( elem, value, name )) !== undefined ) {
				return ret;

			} else {
				elem.setAttribute( name, "" + value );
				return value;
			}

		} else if ( hooks && "get" in hooks && notxml && (ret = hooks.get( elem, name )) !== null ) {
			return ret;

		} else {

			ret = elem.getAttribute( name );

			// Non-existent attributes return null, we normalize to undefined
			return ret === null ?
				undefined :
				ret;
		}
	},

	removeAttr: function( elem, name ) {
		var propName;
		if ( elem.nodeType === 1 ) {
			name = jQuery.attrFix[ name ] || name;

			jQuery.attr( elem, name, "" );
			elem.removeAttribute( name );

			// Set corresponding property to false for boolean attributes
			if ( rboolean.test( name ) && (propName = jQuery.propFix[ name ] || name) in elem ) {
				elem[ propName ] = false;
			}
		}
	},

	attrHooks: {
		type: {
			set: function( elem, value ) {
				// We can't allow the type property to be changed (since it causes problems in IE)
				if ( rtype.test( elem.nodeName ) && elem.parentNode ) {
					jQuery.error( "type property can't be changed" );
				} else if ( !jQuery.support.radioValue && value === "radio" && jQuery.nodeName(elem, "input") ) {
					// Setting the type on a radio button after the value resets the value in IE6-9
					// Reset value to it's default in case type is set after value
					// This is for element creation
					var val = elem.value;
					elem.setAttribute( "type", value );
					if ( val ) {
						elem.value = val;
					}
					return value;
				}
			}
		},
		// Use the value property for back compat
		// Use the nodeHook for button elements in IE6/7 (#1954)
		value: {
			get: function( elem, name ) {
				if ( nodeHook && jQuery.nodeName( elem, "button" ) ) {
					return nodeHook.get( elem, name );
				}
				return name in elem ?
					elem.value :
					null;
			},
			set: function( elem, value, name ) {
				if ( nodeHook && jQuery.nodeName( elem, "button" ) ) {
					return nodeHook.set( elem, value, name );
				}
				// Does not return so that setAttribute is also used
				elem.value = value;
			}
		}
	},

	propFix: {
		tabindex: "tabIndex",
		readonly: "readOnly",
		"for": "htmlFor",
		"class": "className",
		maxlength: "maxLength",
		cellspacing: "cellSpacing",
		cellpadding: "cellPadding",
		rowspan: "rowSpan",
		colspan: "colSpan",
		usemap: "useMap",
		frameborder: "frameBorder",
		contenteditable: "contentEditable"
	},
	
	prop: function( elem, name, value ) {
		var nType = elem.nodeType;

		// don't get/set properties on text, comment and attribute nodes
		if ( !elem || nType === 3 || nType === 8 || nType === 2 ) {
			return undefined;
		}

		var ret, hooks,
			notxml = nType !== 1 || !jQuery.isXMLDoc( elem );

		if ( notxml ) {
			// Fix name and attach hooks
			name = jQuery.propFix[ name ] || name;
			hooks = jQuery.propHooks[ name ];
		}

		if ( value !== undefined ) {
			if ( hooks && "set" in hooks && (ret = hooks.set( elem, value, name )) !== undefined ) {
				return ret;

			} else {
				return (elem[ name ] = value);
			}

		} else {
			if ( hooks && "get" in hooks && (ret = hooks.get( elem, name )) !== null ) {
				return ret;

			} else {
				return elem[ name ];
			}
		}
	},
	
	propHooks: {
		tabIndex: {
			get: function( elem ) {
				// elem.tabIndex doesn't always return the correct value when it hasn't been explicitly set
				// http://fluidproject.org/blog/2008/01/09/getting-setting-and-removing-tabindex-values-with-javascript/
				var attributeNode = elem.getAttributeNode("tabindex");

				return attributeNode && attributeNode.specified ?
					parseInt( attributeNode.value, 10 ) :
					rfocusable.test( elem.nodeName ) || rclickable.test( elem.nodeName ) && elem.href ?
						0 :
						undefined;
			}
		}
	}
});

// Add the tabindex propHook to attrHooks for back-compat
jQuery.attrHooks.tabIndex = jQuery.propHooks.tabIndex;

// Hook for boolean attributes
boolHook = {
	get: function( elem, name ) {
		// Align boolean attributes with corresponding properties
		// Fall back to attribute presence where some booleans are not supported
		var attrNode;
		return jQuery.prop( elem, name ) === true || ( attrNode = elem.getAttributeNode( name ) ) && attrNode.nodeValue !== false ?
			name.toLowerCase() :
			undefined;
	},
	set: function( elem, value, name ) {
		var propName;
		if ( value === false ) {
			// Remove boolean attributes when set to false
			jQuery.removeAttr( elem, name );
		} else {
			// value is true since we know at this point it's type boolean and not false
			// Set boolean attributes to the same name and set the DOM property
			propName = jQuery.propFix[ name ] || name;
			if ( propName in elem ) {
				// Only set the IDL specifically if it already exists on the element
				elem[ propName ] = true;
			}

			elem.setAttribute( name, name.toLowerCase() );
		}
		return name;
	}
};

// IE6/7 do not support getting/setting some attributes with get/setAttribute
if ( !jQuery.support.getSetAttribute ) {
	
	// Use this for any attribute in IE6/7
	// This fixes almost every IE6/7 issue
	nodeHook = jQuery.valHooks.button = {
		get: function( elem, name ) {
			var ret;
			ret = elem.getAttributeNode( name );
			// Return undefined if nodeValue is empty string
			return ret && ret.nodeValue !== "" ?
				ret.nodeValue :
				undefined;
		},
		set: function( elem, value, name ) {
			// Set the existing or create a new attribute node
			var ret = elem.getAttributeNode( name );
			if ( !ret ) {
				ret = document.createAttribute( name );
				elem.setAttributeNode( ret );
			}
			return (ret.nodeValue = value + "");
		}
	};

	// Set width and height to auto instead of 0 on empty string( Bug #8150 )
	// This is for removals
	jQuery.each([ "width", "height" ], function( i, name ) {
		jQuery.attrHooks[ name ] = jQuery.extend( jQuery.attrHooks[ name ], {
			set: function( elem, value ) {
				if ( value === "" ) {
					elem.setAttribute( name, "auto" );
					return value;
				}
			}
		});
	});
}


// Some attributes require a special call on IE
if ( !jQuery.support.hrefNormalized ) {
	jQuery.each([ "href", "src", "width", "height" ], function( i, name ) {
		jQuery.attrHooks[ name ] = jQuery.extend( jQuery.attrHooks[ name ], {
			get: function( elem ) {
				var ret = elem.getAttribute( name, 2 );
				return ret === null ? undefined : ret;
			}
		});
	});
}

if ( !jQuery.support.style ) {
	jQuery.attrHooks.style = {
		get: function( elem ) {
			// Return undefined in the case of empty string
			// Normalize to lowercase since IE uppercases css property names
			return elem.style.cssText.toLowerCase() || undefined;
		},
		set: function( elem, value ) {
			return (elem.style.cssText = "" + value);
		}
	};
}

// Safari mis-reports the default selected property of an option
// Accessing the parent's selectedIndex property fixes it
if ( !jQuery.support.optSelected ) {
	jQuery.propHooks.selected = jQuery.extend( jQuery.propHooks.selected, {
		get: function( elem ) {
			var parent = elem.parentNode;

			if ( parent ) {
				parent.selectedIndex;

				// Make sure that it also works with optgroups, see #5701
				if ( parent.parentNode ) {
					parent.parentNode.selectedIndex;
				}
			}
			return null;
		}
	});
}

// Radios and checkboxes getter/setter
if ( !jQuery.support.checkOn ) {
	jQuery.each([ "radio", "checkbox" ], function() {
		jQuery.valHooks[ this ] = {
			get: function( elem ) {
				// Handle the case where in Webkit "" is returned instead of "on" if a value isn't specified
				return elem.getAttribute("value") === null ? "on" : elem.value;
			}
		};
	});
}
jQuery.each([ "radio", "checkbox" ], function() {
	jQuery.valHooks[ this ] = jQuery.extend( jQuery.valHooks[ this ], {
		set: function( elem, value ) {
			if ( jQuery.isArray( value ) ) {
				return (elem.checked = jQuery.inArray( jQuery(elem).val(), value ) >= 0);
			}
		}
	});
});




var rnamespaces = /\.(.*)$/,
	rformElems = /^(?:textarea|input|select)$/i,
	rperiod = /\./g,
	rspaces = / /g,
	rescape = /[^\w\s.|`]/g,
	fcleanup = function( nm ) {
		return nm.replace(rescape, "\\$&");
	};

/*
 * A number of helper functions used for managing events.
 * Many of the ideas behind this code originated from
 * Dean Edwards' addEvent library.
 */
jQuery.event = {

	// Bind an event to an element
	// Original by Dean Edwards
	add: function( elem, types, handler, data ) {
		if ( elem.nodeType === 3 || elem.nodeType === 8 ) {
			return;
		}

		if ( handler === false ) {
			handler = returnFalse;
		} else if ( !handler ) {
			// Fixes bug #7229. Fix recommended by jdalton
			return;
		}

		var handleObjIn, handleObj;

		if ( handler.handler ) {
			handleObjIn = handler;
			handler = handleObjIn.handler;
		}

		// Make sure that the function being executed has a unique ID
		if ( !handler.guid ) {
			handler.guid = jQuery.guid++;
		}

		// Init the element's event structure
		var elemData = jQuery._data( elem );

		// If no elemData is found then we must be trying to bind to one of the
		// banned noData elements
		if ( !elemData ) {
			return;
		}

		var events = elemData.events,
			eventHandle = elemData.handle;

		if ( !events ) {
			elemData.events = events = {};
		}

		if ( !eventHandle ) {
			elemData.handle = eventHandle = function( e ) {
				// Discard the second event of a jQuery.event.trigger() and
				// when an event is called after a page has unloaded
				return typeof jQuery !== "undefined" && (!e || jQuery.event.triggered !== e.type) ?
					jQuery.event.handle.apply( eventHandle.elem, arguments ) :
					undefined;
			};
		}

		// Add elem as a property of the handle function
		// This is to prevent a memory leak with non-native events in IE.
		eventHandle.elem = elem;

		// Handle multiple events separated by a space
		// jQuery(...).bind("mouseover mouseout", fn);
		types = types.split(" ");

		var type, i = 0, namespaces;

		while ( (type = types[ i++ ]) ) {
			handleObj = handleObjIn ?
				jQuery.extend({}, handleObjIn) :
				{ handler: handler, data: data };

			// Namespaced event handlers
			if ( type.indexOf(".") > -1 ) {
				namespaces = type.split(".");
				type = namespaces.shift();
				handleObj.namespace = namespaces.slice(0).sort().join(".");

			} else {
				namespaces = [];
				handleObj.namespace = "";
			}

			handleObj.type = type;
			if ( !handleObj.guid ) {
				handleObj.guid = handler.guid;
			}

			// Get the current list of functions bound to this event
			var handlers = events[ type ],
				special = jQuery.event.special[ type ] || {};

			// Init the event handler queue
			if ( !handlers ) {
				handlers = events[ type ] = [];

				// Check for a special event handler
				// Only use addEventListener/attachEvent if the special
				// events handler returns false
				if ( !special.setup || special.setup.call( elem, data, namespaces, eventHandle ) === false ) {
					// Bind the global event handler to the element
					if ( elem.addEventListener ) {
						elem.addEventListener( type, eventHandle, false );

					} else if ( elem.attachEvent ) {
						elem.attachEvent( "on" + type, eventHandle );
					}
				}
			}

			if ( special.add ) {
				special.add.call( elem, handleObj );

				if ( !handleObj.handler.guid ) {
					handleObj.handler.guid = handler.guid;
				}
			}

			// Add the function to the element's handler list
			handlers.push( handleObj );

			// Keep track of which events have been used, for event optimization
			jQuery.event.global[ type ] = true;
		}

		// Nullify elem to prevent memory leaks in IE
		elem = null;
	},

	global: {},

	// Detach an event or set of events from an element
	remove: function( elem, types, handler, pos ) {
		// don't do events on text and comment nodes
		if ( elem.nodeType === 3 || elem.nodeType === 8 ) {
			return;
		}

		if ( handler === false ) {
			handler = returnFalse;
		}

		var ret, type, fn, j, i = 0, all, namespaces, namespace, special, eventType, handleObj, origType,
			elemData = jQuery.hasData( elem ) && jQuery._data( elem ),
			events = elemData && elemData.events;

		if ( !elemData || !events ) {
			return;
		}

		// types is actually an event object here
		if ( types && types.type ) {
			handler = types.handler;
			types = types.type;
		}

		// Unbind all events for the element
		if ( !types || typeof types === "string" && types.charAt(0) === "." ) {
			types = types || "";

			for ( type in events ) {
				jQuery.event.remove( elem, type + types );
			}

			return;
		}

		// Handle multiple events separated by a space
		// jQuery(...).unbind("mouseover mouseout", fn);
		types = types.split(" ");

		while ( (type = types[ i++ ]) ) {
			origType = type;
			handleObj = null;
			all = type.indexOf(".") < 0;
			namespaces = [];

			if ( !all ) {
				// Namespaced event handlers
				namespaces = type.split(".");
				type = namespaces.shift();

				namespace = new RegExp("(^|\\.)" +
					jQuery.map( namespaces.slice(0).sort(), fcleanup ).join("\\.(?:.*\\.)?") + "(\\.|$)");
			}

			eventType = events[ type ];

			if ( !eventType ) {
				continue;
			}

			if ( !handler ) {
				for ( j = 0; j < eventType.length; j++ ) {
					handleObj = eventType[ j ];

					if ( all || namespace.test( handleObj.namespace ) ) {
						jQuery.event.remove( elem, origType, handleObj.handler, j );
						eventType.splice( j--, 1 );
					}
				}

				continue;
			}

			special = jQuery.event.special[ type ] || {};

			for ( j = pos || 0; j < eventType.length; j++ ) {
				handleObj = eventType[ j ];

				if ( handler.guid === handleObj.guid ) {
					// remove the given handler for the given type
					if ( all || namespace.test( handleObj.namespace ) ) {
						if ( pos == null ) {
							eventType.splice( j--, 1 );
						}

						if ( special.remove ) {
							special.remove.call( elem, handleObj );
						}
					}

					if ( pos != null ) {
						break;
					}
				}
			}

			// remove generic event handler if no more handlers exist
			if ( eventType.length === 0 || pos != null && eventType.length === 1 ) {
				if ( !special.teardown || special.teardown.call( elem, namespaces ) === false ) {
					jQuery.removeEvent( elem, type, elemData.handle );
				}

				ret = null;
				delete events[ type ];
			}
		}

		// Remove the expando if it's no longer used
		if ( jQuery.isEmptyObject( events ) ) {
			var handle = elemData.handle;
			if ( handle ) {
				handle.elem = null;
			}

			delete elemData.events;
			delete elemData.handle;

			if ( jQuery.isEmptyObject( elemData ) ) {
				jQuery.removeData( elem, undefined, true );
			}
		}
	},
	
	// Events that are safe to short-circuit if no handlers are attached.
	// Native DOM events should not be added, they may have inline handlers.
	customEvent: {
		"getData": true,
		"setData": true,
		"changeData": true
	},

	trigger: function( event, data, elem, onlyHandlers ) {
		// Event object or event type
		var type = event.type || event,
			namespaces = [],
			exclusive;

		if ( type.indexOf("!") >= 0 ) {
			// Exclusive events trigger only for the exact event (no namespaces)
			type = type.slice(0, -1);
			exclusive = true;
		}

		if ( type.indexOf(".") >= 0 ) {
			// Namespaced trigger; create a regexp to match event type in handle()
			namespaces = type.split(".");
			type = namespaces.shift();
			namespaces.sort();
		}

		if ( (!elem || jQuery.event.customEvent[ type ]) && !jQuery.event.global[ type ] ) {
			// No jQuery handlers for this event type, and it can't have inline handlers
			return;
		}

		// Caller can pass in an Event, Object, or just an event type string
		event = typeof event === "object" ?
			// jQuery.Event object
			event[ jQuery.expando ] ? event :
			// Object literal
			new jQuery.Event( type, event ) :
			// Just the event type (string)
			new jQuery.Event( type );

		event.type = type;
		event.exclusive = exclusive;
		event.namespace = namespaces.join(".");
		event.namespace_re = new RegExp("(^|\\.)" + namespaces.join("\\.(?:.*\\.)?") + "(\\.|$)");
		
		// triggerHandler() and global events don't bubble or run the default action
		if ( onlyHandlers || !elem ) {
			event.preventDefault();
			event.stopPropagation();
		}

		// Handle a global trigger
		if ( !elem ) {
			// TODO: Stop taunting the data cache; remove global events and always attach to document
			jQuery.each( jQuery.cache, function() {
				// internalKey variable is just used to make it easier to find
				// and potentially change this stuff later; currently it just
				// points to jQuery.expando
				var internalKey = jQuery.expando,
					internalCache = this[ internalKey ];
				if ( internalCache && internalCache.events && internalCache.events[ type ] ) {
					jQuery.event.trigger( event, data, internalCache.handle.elem );
				}
			});
			return;
		}

		// Don't do events on text and comment nodes
		if ( elem.nodeType === 3 || elem.nodeType === 8 ) {
			return;
		}

		// Clean up the event in case it is being reused
		event.result = undefined;
		event.target = elem;

		// Clone any incoming data and prepend the event, creating the handler arg list
		data = data != null ? jQuery.makeArray( data ) : [];
		data.unshift( event );

		var cur = elem,
			// IE doesn't like method names with a colon (#3533, #8272)
			ontype = type.indexOf(":") < 0 ? "on" + type : "";

		// Fire event on the current element, then bubble up the DOM tree
		do {
			var handle = jQuery._data( cur, "handle" );

			event.currentTarget = cur;
			if ( handle ) {
				handle.apply( cur, data );
			}

			// Trigger an inline bound script
			if ( ontype && jQuery.acceptData( cur ) && cur[ ontype ] && cur[ ontype ].apply( cur, data ) === false ) {
				event.result = false;
				event.preventDefault();
			}

			// Bubble up to document, then to window
			cur = cur.parentNode || cur.ownerDocument || cur === event.target.ownerDocument && window;
		} while ( cur && !event.isPropagationStopped() );

		// If nobody prevented the default action, do it now
		if ( !event.isDefaultPrevented() ) {
			var old,
				special = jQuery.event.special[ type ] || {};

			if ( (!special._default || special._default.call( elem.ownerDocument, event ) === false) &&
				!(type === "click" && jQuery.nodeName( elem, "a" )) && jQuery.acceptData( elem ) ) {

				// Call a native DOM method on the target with the same name name as the event.
				// Can't use an .isFunction)() check here because IE6/7 fails that test.
				// IE<9 dies on focus to hidden element (#1486), may want to revisit a try/catch.
				try {
					if ( ontype && elem[ type ] ) {
						// Don't re-trigger an onFOO event when we call its FOO() method
						old = elem[ ontype ];

						if ( old ) {
							elem[ ontype ] = null;
						}

						jQuery.event.triggered = type;
						elem[ type ]();
					}
				} catch ( ieError ) {}

				if ( old ) {
					elem[ ontype ] = old;
				}

				jQuery.event.triggered = undefined;
			}
		}
		
		return event.result;
	},

	handle: function( event ) {
		event = jQuery.event.fix( event || window.event );
		// Snapshot the handlers list since a called handler may add/remove events.
		var handlers = ((jQuery._data( this, "events" ) || {})[ event.type ] || []).slice(0),
			run_all = !event.exclusive && !event.namespace,
			args = Array.prototype.slice.call( arguments, 0 );

		// Use the fix-ed Event rather than the (read-only) native event
		args[0] = event;
		event.currentTarget = this;

		for ( var j = 0, l = handlers.length; j < l; j++ ) {
			var handleObj = handlers[ j ];

			// Triggered event must 1) be non-exclusive and have no namespace, or
			// 2) have namespace(s) a subset or equal to those in the bound event.
			if ( run_all || event.namespace_re.test( handleObj.namespace ) ) {
				// Pass in a reference to the handler function itself
				// So that we can later remove it
				event.handler = handleObj.handler;
				event.data = handleObj.data;
				event.handleObj = handleObj;

				var ret = handleObj.handler.apply( this, args );

				if ( ret !== undefined ) {
					event.result = ret;
					if ( ret === false ) {
						event.preventDefault();
						event.stopPropagation();
					}
				}

				if ( event.isImmediatePropagationStopped() ) {
					break;
				}
			}
		}
		return event.result;
	},

	props: "altKey attrChange attrName bubbles button cancelable charCode clientX clientY ctrlKey currentTarget data detail eventPhase fromElement handler keyCode layerX layerY metaKey newValue offsetX offsetY pageX pageY prevValue relatedNode relatedTarget screenX screenY shiftKey srcElement target toElement view wheelDelta which".split(" "),

	fix: function( event ) {
		if ( event[ jQuery.expando ] ) {
			return event;
		}

		// store a copy of the original event object
		// and "clone" to set read-only properties
		var originalEvent = event;
		event = jQuery.Event( originalEvent );

		for ( var i = this.props.length, prop; i; ) {
			prop = this.props[ --i ];
			event[ prop ] = originalEvent[ prop ];
		}

		// Fix target property, if necessary
		if ( !event.target ) {
			// Fixes #1925 where srcElement might not be defined either
			event.target = event.srcElement || document;
		}

		// check if target is a textnode (safari)
		if ( event.target.nodeType === 3 ) {
			event.target = event.target.parentNode;
		}

		// Add relatedTarget, if necessary
		if ( !event.relatedTarget && event.fromElement ) {
			event.relatedTarget = event.fromElement === event.target ? event.toElement : event.fromElement;
		}

		// Calculate pageX/Y if missing and clientX/Y available
		if ( event.pageX == null && event.clientX != null ) {
			var eventDocument = event.target.ownerDocument || document,
				doc = eventDocument.documentElement,
				body = eventDocument.body;

			event.pageX = event.clientX + (doc && doc.scrollLeft || body && body.scrollLeft || 0) - (doc && doc.clientLeft || body && body.clientLeft || 0);
			event.pageY = event.clientY + (doc && doc.scrollTop  || body && body.scrollTop  || 0) - (doc && doc.clientTop  || body && body.clientTop  || 0);
		}

		// Add which for key events
		if ( event.which == null && (event.charCode != null || event.keyCode != null) ) {
			event.which = event.charCode != null ? event.charCode : event.keyCode;
		}

		// Add metaKey to non-Mac browsers (use ctrl for PC's and Meta for Macs)
		if ( !event.metaKey && event.ctrlKey ) {
			event.metaKey = event.ctrlKey;
		}

		// Add which for click: 1 === left; 2 === middle; 3 === right
		// Note: button is not normalized, so don't use it
		if ( !event.which && event.button !== undefined ) {
			event.which = (event.button & 1 ? 1 : ( event.button & 2 ? 3 : ( event.button & 4 ? 2 : 0 ) ));
		}

		return event;
	},

	// Deprecated, use jQuery.guid instead
	guid: 1E8,

	// Deprecated, use jQuery.proxy instead
	proxy: jQuery.proxy,

	special: {
		ready: {
			// Make sure the ready event is setup
			setup: jQuery.bindReady,
			teardown: jQuery.noop
		},

		live: {
			add: function( handleObj ) {
				jQuery.event.add( this,
					liveConvert( handleObj.origType, handleObj.selector ),
					jQuery.extend({}, handleObj, {handler: liveHandler, guid: handleObj.handler.guid}) );
			},

			remove: function( handleObj ) {
				jQuery.event.remove( this, liveConvert( handleObj.origType, handleObj.selector ), handleObj );
			}
		},

		beforeunload: {
			setup: function( data, namespaces, eventHandle ) {
				// We only want to do this special case on windows
				if ( jQuery.isWindow( this ) ) {
					this.onbeforeunload = eventHandle;
				}
			},

			teardown: function( namespaces, eventHandle ) {
				if ( this.onbeforeunload === eventHandle ) {
					this.onbeforeunload = null;
				}
			}
		}
	}
};

jQuery.removeEvent = document.removeEventListener ?
	function( elem, type, handle ) {
		if ( elem.removeEventListener ) {
			elem.removeEventListener( type, handle, false );
		}
	} :
	function( elem, type, handle ) {
		if ( elem.detachEvent ) {
			elem.detachEvent( "on" + type, handle );
		}
	};

jQuery.Event = function( src, props ) {
	// Allow instantiation without the 'new' keyword
	if ( !this.preventDefault ) {
		return new jQuery.Event( src, props );
	}

	// Event object
	if ( src && src.type ) {
		this.originalEvent = src;
		this.type = src.type;

		// Events bubbling up the document may have been marked as prevented
		// by a handler lower down the tree; reflect the correct value.
		this.isDefaultPrevented = (src.defaultPrevented || src.returnValue === false ||
			src.getPreventDefault && src.getPreventDefault()) ? returnTrue : returnFalse;

	// Event type
	} else {
		this.type = src;
	}

	// Put explicitly provided properties onto the event object
	if ( props ) {
		jQuery.extend( this, props );
	}

	// timeStamp is buggy for some events on Firefox(#3843)
	// So we won't rely on the native value
	this.timeStamp = jQuery.now();

	// Mark it as fixed
	this[ jQuery.expando ] = true;
};

function returnFalse() {
	return false;
}
function returnTrue() {
	return true;
}

// jQuery.Event is based on DOM3 Events as specified by the ECMAScript Language Binding
// http://www.w3.org/TR/2003/WD-DOM-Level-3-Events-20030331/ecma-script-binding.html
jQuery.Event.prototype = {
	preventDefault: function() {
		this.isDefaultPrevented = returnTrue;

		var e = this.originalEvent;
		if ( !e ) {
			return;
		}

		// if preventDefault exists run it on the original event
		if ( e.preventDefault ) {
			e.preventDefault();

		// otherwise set the returnValue property of the original event to false (IE)
		} else {
			e.returnValue = false;
		}
	},
	stopPropagation: function() {
		this.isPropagationStopped = returnTrue;

		var e = this.originalEvent;
		if ( !e ) {
			return;
		}
		// if stopPropagation exists run it on the original event
		if ( e.stopPropagation ) {
			e.stopPropagation();
		}
		// otherwise set the cancelBubble property of the original event to true (IE)
		e.cancelBubble = true;
	},
	stopImmediatePropagation: function() {
		this.isImmediatePropagationStopped = returnTrue;
		this.stopPropagation();
	},
	isDefaultPrevented: returnFalse,
	isPropagationStopped: returnFalse,
	isImmediatePropagationStopped: returnFalse
};

// Checks if an event happened on an element within another element
// Used in jQuery.event.special.mouseenter and mouseleave handlers
var withinElement = function( event ) {

	// Check if mouse(over|out) are still within the same parent element
	var related = event.relatedTarget,
		inside = false,
		eventType = event.type;

	event.type = event.data;

	if ( related !== this ) {

		if ( related ) {
			inside = jQuery.contains( this, related );
		}

		if ( !inside ) {

			jQuery.event.handle.apply( this, arguments );

			event.type = eventType;
		}
	}
},

// In case of event delegation, we only need to rename the event.type,
// liveHandler will take care of the rest.
delegate = function( event ) {
	event.type = event.data;
	jQuery.event.handle.apply( this, arguments );
};

// Create mouseenter and mouseleave events
jQuery.each({
	mouseenter: "mouseover",
	mouseleave: "mouseout"
}, function( orig, fix ) {
	jQuery.event.special[ orig ] = {
		setup: function( data ) {
			jQuery.event.add( this, fix, data && data.selector ? delegate : withinElement, orig );
		},
		teardown: function( data ) {
			jQuery.event.remove( this, fix, data && data.selector ? delegate : withinElement );
		}
	};
});

// submit delegation
if ( !jQuery.support.submitBubbles ) {

	jQuery.event.special.submit = {
		setup: function( data, namespaces ) {
			if ( !jQuery.nodeName( this, "form" ) ) {
				jQuery.event.add(this, "click.specialSubmit", function( e ) {
					// Avoid triggering error on non-existent type attribute in IE VML (#7071)
					var elem = e.target,
						type = jQuery.nodeName( elem, "input" ) || jQuery.nodeName( elem, "button" ) ? elem.type : "";

					if ( (type === "submit" || type === "image") && jQuery( elem ).closest("form").length ) {
						trigger( "submit", this, arguments );
					}
				});

				jQuery.event.add(this, "keypress.specialSubmit", function( e ) {
					var elem = e.target,
						type = jQuery.nodeName( elem, "input" ) || jQuery.nodeName( elem, "button" ) ? elem.type : "";

					if ( (type === "text" || type === "password") && jQuery( elem ).closest("form").length && e.keyCode === 13 ) {
						trigger( "submit", this, arguments );
					}
				});

			} else {
				return false;
			}
		},

		teardown: function( namespaces ) {
			jQuery.event.remove( this, ".specialSubmit" );
		}
	};

}

// change delegation, happens here so we have bind.
if ( !jQuery.support.changeBubbles ) {

	var changeFilters,

	getVal = function( elem ) {
		var type = jQuery.nodeName( elem, "input" ) ? elem.type : "",
			val = elem.value;

		if ( type === "radio" || type === "checkbox" ) {
			val = elem.checked;

		} else if ( type === "select-multiple" ) {
			val = elem.selectedIndex > -1 ?
				jQuery.map( elem.options, function( elem ) {
					return elem.selected;
				}).join("-") :
				"";

		} else if ( jQuery.nodeName( elem, "select" ) ) {
			val = elem.selectedIndex;
		}

		return val;
	},

	testChange = function testChange( e ) {
		var elem = e.target, data, val;

		if ( !rformElems.test( elem.nodeName ) || elem.readOnly ) {
			return;
		}

		data = jQuery._data( elem, "_change_data" );
		val = getVal(elem);

		// the current data will be also retrieved by beforeactivate
		if ( e.type !== "focusout" || elem.type !== "radio" ) {
			jQuery._data( elem, "_change_data", val );
		}

		if ( data === undefined || val === data ) {
			return;
		}

		if ( data != null || val ) {
			e.type = "change";
			e.liveFired = undefined;
			jQuery.event.trigger( e, arguments[1], elem );
		}
	};

	jQuery.event.special.change = {
		filters: {
			focusout: testChange,

			beforedeactivate: testChange,

			click: function( e ) {
				var elem = e.target, type = jQuery.nodeName( elem, "input" ) ? elem.type : "";

				if ( type === "radio" || type === "checkbox" || jQuery.nodeName( elem, "select" ) ) {
					testChange.call( this, e );
				}
			},

			// Change has to be called before submit
			// Keydown will be called before keypress, which is used in submit-event delegation
			keydown: function( e ) {
				var elem = e.target, type = jQuery.nodeName( elem, "input" ) ? elem.type : "";

				if ( (e.keyCode === 13 && !jQuery.nodeName( elem, "textarea" ) ) ||
					(e.keyCode === 32 && (type === "checkbox" || type === "radio")) ||
					type === "select-multiple" ) {
					testChange.call( this, e );
				}
			},

			// Beforeactivate happens also before the previous element is blurred
			// with this event you can't trigger a change event, but you can store
			// information
			beforeactivate: function( e ) {
				var elem = e.target;
				jQuery._data( elem, "_change_data", getVal(elem) );
			}
		},

		setup: function( data, namespaces ) {
			if ( this.type === "file" ) {
				return false;
			}

			for ( var type in changeFilters ) {
				jQuery.event.add( this, type + ".specialChange", changeFilters[type] );
			}

			return rformElems.test( this.nodeName );
		},

		teardown: function( namespaces ) {
			jQuery.event.remove( this, ".specialChange" );

			return rformElems.test( this.nodeName );
		}
	};

	changeFilters = jQuery.event.special.change.filters;

	// Handle when the input is .focus()'d
	changeFilters.focus = changeFilters.beforeactivate;
}

function trigger( type, elem, args ) {
	// Piggyback on a donor event to simulate a different one.
	// Fake originalEvent to avoid donor's stopPropagation, but if the
	// simulated event prevents default then we do the same on the donor.
	// Don't pass args or remember liveFired; they apply to the donor event.
	var event = jQuery.extend( {}, args[ 0 ] );
	event.type = type;
	event.originalEvent = {};
	event.liveFired = undefined;
	jQuery.event.handle.call( elem, event );
	if ( event.isDefaultPrevented() ) {
		args[ 0 ].preventDefault();
	}
}

// Create "bubbling" focus and blur events
if ( !jQuery.support.focusinBubbles ) {
	jQuery.each({ focus: "focusin", blur: "focusout" }, function( orig, fix ) {

		// Attach a single capturing handler while someone wants focusin/focusout
		var attaches = 0;

		jQuery.event.special[ fix ] = {
			setup: function() {
				if ( attaches++ === 0 ) {
					document.addEventListener( orig, handler, true );
				}
			},
			teardown: function() {
				if ( --attaches === 0 ) {
					document.removeEventListener( orig, handler, true );
				}
			}
		};

		function handler( donor ) {
			// Donor event is always a native one; fix it and switch its type.
			// Let focusin/out handler cancel the donor focus/blur event.
			var e = jQuery.event.fix( donor );
			e.type = fix;
			e.originalEvent = {};
			jQuery.event.trigger( e, null, e.target );
			if ( e.isDefaultPrevented() ) {
				donor.preventDefault();
			}
		}
	});
}

jQuery.each(["bind", "one"], function( i, name ) {
	jQuery.fn[ name ] = function( type, data, fn ) {
		var handler;

		// Handle object literals
		if ( typeof type === "object" ) {
			for ( var key in type ) {
				this[ name ](key, data, type[key], fn);
			}
			return this;
		}

		if ( arguments.length === 2 || data === false ) {
			fn = data;
			data = undefined;
		}

		if ( name === "one" ) {
			handler = function( event ) {
				jQuery( this ).unbind( event, handler );
				return fn.apply( this, arguments );
			};
			handler.guid = fn.guid || jQuery.guid++;
		} else {
			handler = fn;
		}

		if ( type === "unload" && name !== "one" ) {
			this.one( type, data, fn );

		} else {
			for ( var i = 0, l = this.length; i < l; i++ ) {
				jQuery.event.add( this[i], type, handler, data );
			}
		}

		return this;
	};
});

jQuery.fn.extend({
	unbind: function( type, fn ) {
		// Handle object literals
		if ( typeof type === "object" && !type.preventDefault ) {
			for ( var key in type ) {
				this.unbind(key, type[key]);
			}

		} else {
			for ( var i = 0, l = this.length; i < l; i++ ) {
				jQuery.event.remove( this[i], type, fn );
			}
		}

		return this;
	},

	delegate: function( selector, types, data, fn ) {
		return this.live( types, data, fn, selector );
	},

	undelegate: function( selector, types, fn ) {
		if ( arguments.length === 0 ) {
			return this.unbind( "live" );

		} else {
			return this.die( types, null, fn, selector );
		}
	},

	trigger: function( type, data ) {
		return this.each(function() {
			jQuery.event.trigger( type, data, this );
		});
	},

	triggerHandler: function( type, data ) {
		if ( this[0] ) {
			return jQuery.event.trigger( type, data, this[0], true );
		}
	},

	toggle: function( fn ) {
		// Save reference to arguments for access in closure
		var args = arguments,
			guid = fn.guid || jQuery.guid++,
			i = 0,
			toggler = function( event ) {
				// Figure out which function to execute
				var lastToggle = ( jQuery.data( this, "lastToggle" + fn.guid ) || 0 ) % i;
				jQuery.data( this, "lastToggle" + fn.guid, lastToggle + 1 );

				// Make sure that clicks stop
				event.preventDefault();

				// and execute the function
				return args[ lastToggle ].apply( this, arguments ) || false;
			};

		// link all the functions, so any of them can unbind this click handler
		toggler.guid = guid;
		while ( i < args.length ) {
			args[ i++ ].guid = guid;
		}

		return this.click( toggler );
	},

	hover: function( fnOver, fnOut ) {
		return this.mouseenter( fnOver ).mouseleave( fnOut || fnOver );
	}
});

var liveMap = {
	focus: "focusin",
	blur: "focusout",
	mouseenter: "mouseover",
	mouseleave: "mouseout"
};

jQuery.each(["live", "die"], function( i, name ) {
	jQuery.fn[ name ] = function( types, data, fn, origSelector /* Internal Use Only */ ) {
		var type, i = 0, match, namespaces, preType,
			selector = origSelector || this.selector,
			context = origSelector ? this : jQuery( this.context );

		if ( typeof types === "object" && !types.preventDefault ) {
			for ( var key in types ) {
				context[ name ]( key, data, types[key], selector );
			}

			return this;
		}

		if ( name === "die" && !types &&
					origSelector && origSelector.charAt(0) === "." ) {

			context.unbind( origSelector );

			return this;
		}

		if ( data === false || jQuery.isFunction( data ) ) {
			fn = data || returnFalse;
			data = undefined;
		}

		types = (types || "").split(" ");

		while ( (type = types[ i++ ]) != null ) {
			match = rnamespaces.exec( type );
			namespaces = "";

			if ( match )  {
				namespaces = match[0];
				type = type.replace( rnamespaces, "" );
			}

			if ( type === "hover" ) {
				types.push( "mouseenter" + namespaces, "mouseleave" + namespaces );
				continue;
			}

			preType = type;

			if ( liveMap[ type ] ) {
				types.push( liveMap[ type ] + namespaces );
				type = type + namespaces;

			} else {
				type = (liveMap[ type ] || type) + namespaces;
			}

			if ( name === "live" ) {
				// bind live handler
				for ( var j = 0, l = context.length; j < l; j++ ) {
					jQuery.event.add( context[j], "live." + liveConvert( type, selector ),
						{ data: data, selector: selector, handler: fn, origType: type, origHandler: fn, preType: preType } );
				}

			} else {
				// unbind live handler
				context.unbind( "live." + liveConvert( type, selector ), fn );
			}
		}

		return this;
	};
});

function liveHandler( event ) {
	var stop, maxLevel, related, match, handleObj, elem, j, i, l, data, close, namespace, ret,
		elems = [],
		selectors = [],
		events = jQuery._data( this, "events" );

	// Make sure we avoid non-left-click bubbling in Firefox (#3861) and disabled elements in IE (#6911)
	if ( event.liveFired === this || !events || !events.live || event.target.disabled || event.button && event.type === "click" ) {
		return;
	}

	if ( event.namespace ) {
		namespace = new RegExp("(^|\\.)" + event.namespace.split(".").join("\\.(?:.*\\.)?") + "(\\.|$)");
	}

	event.liveFired = this;

	var live = events.live.slice(0);

	for ( j = 0; j < live.length; j++ ) {
		handleObj = live[j];

		if ( handleObj.origType.replace( rnamespaces, "" ) === event.type ) {
			selectors.push( handleObj.selector );

		} else {
			live.splice( j--, 1 );
		}
	}

	match = jQuery( event.target ).closest( selectors, event.currentTarget );

	for ( i = 0, l = match.length; i < l; i++ ) {
		close = match[i];

		for ( j = 0; j < live.length; j++ ) {
			handleObj = live[j];

			if ( close.selector === handleObj.selector && (!namespace || namespace.test( handleObj.namespace )) && !close.elem.disabled ) {
				elem = close.elem;
				related = null;

				// Those two events require additional checking
				if ( handleObj.preType === "mouseenter" || handleObj.preType === "mouseleave" ) {
					event.type = handleObj.preType;
					related = jQuery( event.relatedTarget ).closest( handleObj.selector )[0];

					// Make sure not to accidentally match a child element with the same selector
					if ( related && jQuery.contains( elem, related ) ) {
						related = elem;
					}
				}

				if ( !related || related !== elem ) {
					elems.push({ elem: elem, handleObj: handleObj, level: close.level });
				}
			}
		}
	}

	for ( i = 0, l = elems.length; i < l; i++ ) {
		match = elems[i];

		if ( maxLevel && match.level > maxLevel ) {
			break;
		}

		event.currentTarget = match.elem;
		event.data = match.handleObj.data;
		event.handleObj = match.handleObj;

		ret = match.handleObj.origHandler.apply( match.elem, arguments );

		if ( ret === false || event.isPropagationStopped() ) {
			maxLevel = match.level;

			if ( ret === false ) {
				stop = false;
			}
			if ( event.isImmediatePropagationStopped() ) {
				break;
			}
		}
	}

	return stop;
}

function liveConvert( type, selector ) {
	return (type && type !== "*" ? type + "." : "") + selector.replace(rperiod, "`").replace(rspaces, "&");
}

jQuery.each( ("blur focus focusin focusout load resize scroll unload click dblclick " +
	"mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave " +
	"change select submit keydown keypress keyup error").split(" "), function( i, name ) {

	// Handle event binding
	jQuery.fn[ name ] = function( data, fn ) {
		if ( fn == null ) {
			fn = data;
			data = null;
		}

		return arguments.length > 0 ?
			this.bind( name, data, fn ) :
			this.trigger( name );
	};

	if ( jQuery.attrFn ) {
		jQuery.attrFn[ name ] = true;
	}
});



/*!
 * Sizzle CSS Selector Engine
 *  Copyright 2011, The Dojo Foundation
 *  Released under the MIT, BSD, and GPL Licenses.
 *  More information: http://sizzlejs.com/
 */
(function(){

var chunker = /((?:\((?:\([^()]+\)|[^()]+)+\)|\[(?:\[[^\[\]]*\]|['"][^'"]*['"]|[^\[\]'"]+)+\]|\\.|[^ >+~,(\[\\]+)+|[>+~])(\s*,\s*)?((?:.|\r|\n)*)/g,
	done = 0,
	toString = Object.prototype.toString,
	hasDuplicate = false,
	baseHasDuplicate = true,
	rBackslash = /\\/g,
	rNonWord = /\W/;

// Here we check if the JavaScript engine is using some sort of
// optimization where it does not always call our comparision
// function. If that is the case, discard the hasDuplicate value.
//   Thus far that includes Google Chrome.
[0, 0].sort(function() {
	baseHasDuplicate = false;
	return 0;
});

var Sizzle = function( selector, context, results, seed ) {
	results = results || [];
	context = context || document;

	var origContext = context;

	if ( context.nodeType !== 1 && context.nodeType !== 9 ) {
		return [];
	}
	
	if ( !selector || typeof selector !== "string" ) {
		return results;
	}

	var m, set, checkSet, extra, ret, cur, pop, i,
		prune = true,
		contextXML = Sizzle.isXML( context ),
		parts = [],
		soFar = selector;
	
	// Reset the position of the chunker regexp (start from head)
	do {
		chunker.exec( "" );
		m = chunker.exec( soFar );

		if ( m ) {
			soFar = m[3];
		
			parts.push( m[1] );
		
			if ( m[2] ) {
				extra = m[3];
				break;
			}
		}
	} while ( m );

	if ( parts.length > 1 && origPOS.exec( selector ) ) {

		if ( parts.length === 2 && Expr.relative[ parts[0] ] ) {
			set = posProcess( parts[0] + parts[1], context );

		} else {
			set = Expr.relative[ parts[0] ] ?
				[ context ] :
				Sizzle( parts.shift(), context );

			while ( parts.length ) {
				selector = parts.shift();

				if ( Expr.relative[ selector ] ) {
					selector += parts.shift();
				}
				
				set = posProcess( selector, set );
			}
		}

	} else {
		// Take a shortcut and set the context if the root selector is an ID
		// (but not if it'll be faster if the inner selector is an ID)
		if ( !seed && parts.length > 1 && context.nodeType === 9 && !contextXML &&
				Expr.match.ID.test(parts[0]) && !Expr.match.ID.test(parts[parts.length - 1]) ) {

			ret = Sizzle.find( parts.shift(), context, contextXML );
			context = ret.expr ?
				Sizzle.filter( ret.expr, ret.set )[0] :
				ret.set[0];
		}

		if ( context ) {
			ret = seed ?
				{ expr: parts.pop(), set: makeArray(seed) } :
				Sizzle.find( parts.pop(), parts.length === 1 && (parts[0] === "~" || parts[0] === "+") && context.parentNode ? context.parentNode : context, contextXML );

			set = ret.expr ?
				Sizzle.filter( ret.expr, ret.set ) :
				ret.set;

			if ( parts.length > 0 ) {
				checkSet = makeArray( set );

			} else {
				prune = false;
			}

			while ( parts.length ) {
				cur = parts.pop();
				pop = cur;

				if ( !Expr.relative[ cur ] ) {
					cur = "";
				} else {
					pop = parts.pop();
				}

				if ( pop == null ) {
					pop = context;
				}

				Expr.relative[ cur ]( checkSet, pop, contextXML );
			}

		} else {
			checkSet = parts = [];
		}
	}

	if ( !checkSet ) {
		checkSet = set;
	}

	if ( !checkSet ) {
		Sizzle.error( cur || selector );
	}

	if ( toString.call(checkSet) === "[object Array]" ) {
		if ( !prune ) {
			results.push.apply( results, checkSet );

		} else if ( context && context.nodeType === 1 ) {
			for ( i = 0; checkSet[i] != null; i++ ) {
				if ( checkSet[i] && (checkSet[i] === true || checkSet[i].nodeType === 1 && Sizzle.contains(context, checkSet[i])) ) {
					results.push( set[i] );
				}
			}

		} else {
			for ( i = 0; checkSet[i] != null; i++ ) {
				if ( checkSet[i] && checkSet[i].nodeType === 1 ) {
					results.push( set[i] );
				}
			}
		}

	} else {
		makeArray( checkSet, results );
	}

	if ( extra ) {
		Sizzle( extra, origContext, results, seed );
		Sizzle.uniqueSort( results );
	}

	return results;
};

Sizzle.uniqueSort = function( results ) {
	if ( sortOrder ) {
		hasDuplicate = baseHasDuplicate;
		results.sort( sortOrder );

		if ( hasDuplicate ) {
			for ( var i = 1; i < results.length; i++ ) {
				if ( results[i] === results[ i - 1 ] ) {
					results.splice( i--, 1 );
				}
			}
		}
	}

	return results;
};

Sizzle.matches = function( expr, set ) {
	return Sizzle( expr, null, null, set );
};

Sizzle.matchesSelector = function( node, expr ) {
	return Sizzle( expr, null, null, [node] ).length > 0;
};

Sizzle.find = function( expr, context, isXML ) {
	var set;

	if ( !expr ) {
		return [];
	}

	for ( var i = 0, l = Expr.order.length; i < l; i++ ) {
		var match,
			type = Expr.order[i];
		
		if ( (match = Expr.leftMatch[ type ].exec( expr )) ) {
			var left = match[1];
			match.splice( 1, 1 );

			if ( left.substr( left.length - 1 ) !== "\\" ) {
				match[1] = (match[1] || "").replace( rBackslash, "" );
				set = Expr.find[ type ]( match, context, isXML );

				if ( set != null ) {
					expr = expr.replace( Expr.match[ type ], "" );
					break;
				}
			}
		}
	}

	if ( !set ) {
		set = typeof context.getElementsByTagName !== "undefined" ?
			context.getElementsByTagName( "*" ) :
			[];
	}

	return { set: set, expr: expr };
};

Sizzle.filter = function( expr, set, inplace, not ) {
	var match, anyFound,
		old = expr,
		result = [],
		curLoop = set,
		isXMLFilter = set && set[0] && Sizzle.isXML( set[0] );

	while ( expr && set.length ) {
		for ( var type in Expr.filter ) {
			if ( (match = Expr.leftMatch[ type ].exec( expr )) != null && match[2] ) {
				var found, item,
					filter = Expr.filter[ type ],
					left = match[1];

				anyFound = false;

				match.splice(1,1);

				if ( left.substr( left.length - 1 ) === "\\" ) {
					continue;
				}

				if ( curLoop === result ) {
					result = [];
				}

				if ( Expr.preFilter[ type ] ) {
					match = Expr.preFilter[ type ]( match, curLoop, inplace, result, not, isXMLFilter );

					if ( !match ) {
						anyFound = found = true;

					} else if ( match === true ) {
						continue;
					}
				}

				if ( match ) {
					for ( var i = 0; (item = curLoop[i]) != null; i++ ) {
						if ( item ) {
							found = filter( item, match, i, curLoop );
							var pass = not ^ !!found;

							if ( inplace && found != null ) {
								if ( pass ) {
									anyFound = true;

								} else {
									curLoop[i] = false;
								}

							} else if ( pass ) {
								result.push( item );
								anyFound = true;
							}
						}
					}
				}

				if ( found !== undefined ) {
					if ( !inplace ) {
						curLoop = result;
					}

					expr = expr.replace( Expr.match[ type ], "" );

					if ( !anyFound ) {
						return [];
					}

					break;
				}
			}
		}

		// Improper expression
		if ( expr === old ) {
			if ( anyFound == null ) {
				Sizzle.error( expr );

			} else {
				break;
			}
		}

		old = expr;
	}

	return curLoop;
};

Sizzle.error = function( msg ) {
	throw "Syntax error, unrecognized expression: " + msg;
};

var Expr = Sizzle.selectors = {
	order: [ "ID", "NAME", "TAG" ],

	match: {
		ID: /#((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,
		CLASS: /\.((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,
		NAME: /\[name=['"]*((?:[\w\u00c0-\uFFFF\-]|\\.)+)['"]*\]/,
		ATTR: /\[\s*((?:[\w\u00c0-\uFFFF\-]|\\.)+)\s*(?:(\S?=)\s*(?:(['"])(.*?)\3|(#?(?:[\w\u00c0-\uFFFF\-]|\\.)*)|)|)\s*\]/,
		TAG: /^((?:[\w\u00c0-\uFFFF\*\-]|\\.)+)/,
		CHILD: /:(only|nth|last|first)-child(?:\(\s*(even|odd|(?:[+\-]?\d+|(?:[+\-]?\d*)?n\s*(?:[+\-]\s*\d+)?))\s*\))?/,
		POS: /:(nth|eq|gt|lt|first|last|even|odd)(?:\((\d*)\))?(?=[^\-]|$)/,
		PSEUDO: /:((?:[\w\u00c0-\uFFFF\-]|\\.)+)(?:\((['"]?)((?:\([^\)]+\)|[^\(\)]*)+)\2\))?/
	},

	leftMatch: {},

	attrMap: {
		"class": "className",
		"for": "htmlFor"
	},

	attrHandle: {
		href: function( elem ) {
			return elem.getAttribute( "href" );
		},
		type: function( elem ) {
			return elem.getAttribute( "type" );
		}
	},

	relative: {
		"+": function(checkSet, part){
			var isPartStr = typeof part === "string",
				isTag = isPartStr && !rNonWord.test( part ),
				isPartStrNotTag = isPartStr && !isTag;

			if ( isTag ) {
				part = part.toLowerCase();
			}

			for ( var i = 0, l = checkSet.length, elem; i < l; i++ ) {
				if ( (elem = checkSet[i]) ) {
					while ( (elem = elem.previousSibling) && elem.nodeType !== 1 ) {}

					checkSet[i] = isPartStrNotTag || elem && elem.nodeName.toLowerCase() === part ?
						elem || false :
						elem === part;
				}
			}

			if ( isPartStrNotTag ) {
				Sizzle.filter( part, checkSet, true );
			}
		},

		">": function( checkSet, part ) {
			var elem,
				isPartStr = typeof part === "string",
				i = 0,
				l = checkSet.length;

			if ( isPartStr && !rNonWord.test( part ) ) {
				part = part.toLowerCase();

				for ( ; i < l; i++ ) {
					elem = checkSet[i];

					if ( elem ) {
						var parent = elem.parentNode;
						checkSet[i] = parent.nodeName.toLowerCase() === part ? parent : false;
					}
				}

			} else {
				for ( ; i < l; i++ ) {
					elem = checkSet[i];

					if ( elem ) {
						checkSet[i] = isPartStr ?
							elem.parentNode :
							elem.parentNode === part;
					}
				}

				if ( isPartStr ) {
					Sizzle.filter( part, checkSet, true );
				}
			}
		},

		"": function(checkSet, part, isXML){
			var nodeCheck,
				doneName = done++,
				checkFn = dirCheck;

			if ( typeof part === "string" && !rNonWord.test( part ) ) {
				part = part.toLowerCase();
				nodeCheck = part;
				checkFn = dirNodeCheck;
			}

			checkFn( "parentNode", part, doneName, checkSet, nodeCheck, isXML );
		},

		"~": function( checkSet, part, isXML ) {
			var nodeCheck,
				doneName = done++,
				checkFn = dirCheck;

			if ( typeof part === "string" && !rNonWord.test( part ) ) {
				part = part.toLowerCase();
				nodeCheck = part;
				checkFn = dirNodeCheck;
			}

			checkFn( "previousSibling", part, doneName, checkSet, nodeCheck, isXML );
		}
	},

	find: {
		ID: function( match, context, isXML ) {
			if ( typeof context.getElementById !== "undefined" && !isXML ) {
				var m = context.getElementById(match[1]);
				// Check parentNode to catch when Blackberry 4.6 returns
				// nodes that are no longer in the document #6963
				return m && m.parentNode ? [m] : [];
			}
		},

		NAME: function( match, context ) {
			if ( typeof context.getElementsByName !== "undefined" ) {
				var ret = [],
					results = context.getElementsByName( match[1] );

				for ( var i = 0, l = results.length; i < l; i++ ) {
					if ( results[i].getAttribute("name") === match[1] ) {
						ret.push( results[i] );
					}
				}

				return ret.length === 0 ? null : ret;
			}
		},

		TAG: function( match, context ) {
			if ( typeof context.getElementsByTagName !== "undefined" ) {
				return context.getElementsByTagName( match[1] );
			}
		}
	},
	preFilter: {
		CLASS: function( match, curLoop, inplace, result, not, isXML ) {
			match = " " + match[1].replace( rBackslash, "" ) + " ";

			if ( isXML ) {
				return match;
			}

			for ( var i = 0, elem; (elem = curLoop[i]) != null; i++ ) {
				if ( elem ) {
					if ( not ^ (elem.className && (" " + elem.className + " ").replace(/[\t\n\r]/g, " ").indexOf(match) >= 0) ) {
						if ( !inplace ) {
							result.push( elem );
						}

					} else if ( inplace ) {
						curLoop[i] = false;
					}
				}
			}

			return false;
		},

		ID: function( match ) {
			return match[1].replace( rBackslash, "" );
		},

		TAG: function( match, curLoop ) {
			return match[1].replace( rBackslash, "" ).toLowerCase();
		},

		CHILD: function( match ) {
			if ( match[1] === "nth" ) {
				if ( !match[2] ) {
					Sizzle.error( match[0] );
				}

				match[2] = match[2].replace(/^\+|\s*/g, '');

				// parse equations like 'even', 'odd', '5', '2n', '3n+2', '4n-1', '-n+6'
				var test = /(-?)(\d*)(?:n([+\-]?\d*))?/.exec(
					match[2] === "even" && "2n" || match[2] === "odd" && "2n+1" ||
					!/\D/.test( match[2] ) && "0n+" + match[2] || match[2]);

				// calculate the numbers (first)n+(last) including if they are negative
				match[2] = (test[1] + (test[2] || 1)) - 0;
				match[3] = test[3] - 0;
			}
			else if ( match[2] ) {
				Sizzle.error( match[0] );
			}

			// TODO: Move to normal caching system
			match[0] = done++;

			return match;
		},

		ATTR: function( match, curLoop, inplace, result, not, isXML ) {
			var name = match[1] = match[1].replace( rBackslash, "" );
			
			if ( !isXML && Expr.attrMap[name] ) {
				match[1] = Expr.attrMap[name];
			}

			// Handle if an un-quoted value was used
			match[4] = ( match[4] || match[5] || "" ).replace( rBackslash, "" );

			if ( match[2] === "~=" ) {
				match[4] = " " + match[4] + " ";
			}

			return match;
		},

		PSEUDO: function( match, curLoop, inplace, result, not ) {
			if ( match[1] === "not" ) {
				// If we're dealing with a complex expression, or a simple one
				if ( ( chunker.exec(match[3]) || "" ).length > 1 || /^\w/.test(match[3]) ) {
					match[3] = Sizzle(match[3], null, null, curLoop);

				} else {
					var ret = Sizzle.filter(match[3], curLoop, inplace, true ^ not);

					if ( !inplace ) {
						result.push.apply( result, ret );
					}

					return false;
				}

			} else if ( Expr.match.POS.test( match[0] ) || Expr.match.CHILD.test( match[0] ) ) {
				return true;
			}
			
			return match;
		},

		POS: function( match ) {
			match.unshift( true );

			return match;
		}
	},
	
	filters: {
		enabled: function( elem ) {
			return elem.disabled === false && elem.type !== "hidden";
		},

		disabled: function( elem ) {
			return elem.disabled === true;
		},

		checked: function( elem ) {
			return elem.checked === true;
		},
		
		selected: function( elem ) {
			// Accessing this property makes selected-by-default
			// options in Safari work properly
			if ( elem.parentNode ) {
				elem.parentNode.selectedIndex;
			}
			
			return elem.selected === true;
		},

		parent: function( elem ) {
			return !!elem.firstChild;
		},

		empty: function( elem ) {
			return !elem.firstChild;
		},

		has: function( elem, i, match ) {
			return !!Sizzle( match[3], elem ).length;
		},

		header: function( elem ) {
			return (/h\d/i).test( elem.nodeName );
		},

		text: function( elem ) {
			var attr = elem.getAttribute( "type" ), type = elem.type;
			// IE6 and 7 will map elem.type to 'text' for new HTML5 types (search, etc) 
			// use getAttribute instead to test this case
			return elem.nodeName.toLowerCase() === "input" && "text" === type && ( attr === type || attr === null );
		},

		radio: function( elem ) {
			return elem.nodeName.toLowerCase() === "input" && "radio" === elem.type;
		},

		checkbox: function( elem ) {
			return elem.nodeName.toLowerCase() === "input" && "checkbox" === elem.type;
		},

		file: function( elem ) {
			return elem.nodeName.toLowerCase() === "input" && "file" === elem.type;
		},

		password: function( elem ) {
			return elem.nodeName.toLowerCase() === "input" && "password" === elem.type;
		},

		submit: function( elem ) {
			var name = elem.nodeName.toLowerCase();
			return (name === "input" || name === "button") && "submit" === elem.type;
		},

		image: function( elem ) {
			return elem.nodeName.toLowerCase() === "input" && "image" === elem.type;
		},

		reset: function( elem ) {
			var name = elem.nodeName.toLowerCase();
			return (name === "input" || name === "button") && "reset" === elem.type;
		},

		button: function( elem ) {
			var name = elem.nodeName.toLowerCase();
			return name === "input" && "button" === elem.type || name === "button";
		},

		input: function( elem ) {
			return (/input|select|textarea|button/i).test( elem.nodeName );
		},

		focus: function( elem ) {
			return elem === elem.ownerDocument.activeElement;
		}
	},
	setFilters: {
		first: function( elem, i ) {
			return i === 0;
		},

		last: function( elem, i, match, array ) {
			return i === array.length - 1;
		},

		even: function( elem, i ) {
			return i % 2 === 0;
		},

		odd: function( elem, i ) {
			return i % 2 === 1;
		},

		lt: function( elem, i, match ) {
			return i < match[3] - 0;
		},

		gt: function( elem, i, match ) {
			return i > match[3] - 0;
		},

		nth: function( elem, i, match ) {
			return match[3] - 0 === i;
		},

		eq: function( elem, i, match ) {
			return match[3] - 0 === i;
		}
	},
	filter: {
		PSEUDO: function( elem, match, i, array ) {
			var name = match[1],
				filter = Expr.filters[ name ];

			if ( filter ) {
				return filter( elem, i, match, array );

			} else if ( name === "contains" ) {
				return (elem.textContent || elem.innerText || Sizzle.getText([ elem ]) || "").indexOf(match[3]) >= 0;

			} else if ( name === "not" ) {
				var not = match[3];

				for ( var j = 0, l = not.length; j < l; j++ ) {
					if ( not[j] === elem ) {
						return false;
					}
				}

				return true;

			} else {
				Sizzle.error( name );
			}
		},

		CHILD: function( elem, match ) {
			var type = match[1],
				node = elem;

			switch ( type ) {
				case "only":
				case "first":
					while ( (node = node.previousSibling) )	 {
						if ( node.nodeType === 1 ) { 
							return false; 
						}
					}

					if ( type === "first" ) { 
						return true; 
					}

					node = elem;

				case "last":
					while ( (node = node.nextSibling) )	 {
						if ( node.nodeType === 1 ) { 
							return false; 
						}
					}

					return true;

				case "nth":
					var first = match[2],
						last = match[3];

					if ( first === 1 && last === 0 ) {
						return true;
					}
					
					var doneName = match[0],
						parent = elem.parentNode;
	
					if ( parent && (parent.sizcache !== doneName || !elem.nodeIndex) ) {
						var count = 0;
						
						for ( node = parent.firstChild; node; node = node.nextSibling ) {
							if ( node.nodeType === 1 ) {
								node.nodeIndex = ++count;
							}
						} 

						parent.sizcache = doneName;
					}
					
					var diff = elem.nodeIndex - last;

					if ( first === 0 ) {
						return diff === 0;

					} else {
						return ( diff % first === 0 && diff / first >= 0 );
					}
			}
		},

		ID: function( elem, match ) {
			return elem.nodeType === 1 && elem.getAttribute("id") === match;
		},

		TAG: function( elem, match ) {
			return (match === "*" && elem.nodeType === 1) || elem.nodeName.toLowerCase() === match;
		},
		
		CLASS: function( elem, match ) {
			return (" " + (elem.className || elem.getAttribute("class")) + " ")
				.indexOf( match ) > -1;
		},

		ATTR: function( elem, match ) {
			var name = match[1],
				result = Expr.attrHandle[ name ] ?
					Expr.attrHandle[ name ]( elem ) :
					elem[ name ] != null ?
						elem[ name ] :
						elem.getAttribute( name ),
				value = result + "",
				type = match[2],
				check = match[4];

			return result == null ?
				type === "!=" :
				type === "=" ?
				value === check :
				type === "*=" ?
				value.indexOf(check) >= 0 :
				type === "~=" ?
				(" " + value + " ").indexOf(check) >= 0 :
				!check ?
				value && result !== false :
				type === "!=" ?
				value !== check :
				type === "^=" ?
				value.indexOf(check) === 0 :
				type === "$=" ?
				value.substr(value.length - check.length) === check :
				type === "|=" ?
				value === check || value.substr(0, check.length + 1) === check + "-" :
				false;
		},

		POS: function( elem, match, i, array ) {
			var name = match[2],
				filter = Expr.setFilters[ name ];

			if ( filter ) {
				return filter( elem, i, match, array );
			}
		}
	}
};

var origPOS = Expr.match.POS,
	fescape = function(all, num){
		return "\\" + (num - 0 + 1);
	};

for ( var type in Expr.match ) {
	Expr.match[ type ] = new RegExp( Expr.match[ type ].source + (/(?![^\[]*\])(?![^\(]*\))/.source) );
	Expr.leftMatch[ type ] = new RegExp( /(^(?:.|\r|\n)*?)/.source + Expr.match[ type ].source.replace(/\\(\d+)/g, fescape) );
}

var makeArray = function( array, results ) {
	array = Array.prototype.slice.call( array, 0 );

	if ( results ) {
		results.push.apply( results, array );
		return results;
	}
	
	return array;
};

// Perform a simple check to determine if the browser is capable of
// converting a NodeList to an array using builtin methods.
// Also verifies that the returned array holds DOM nodes
// (which is not the case in the Blackberry browser)
try {
	Array.prototype.slice.call( document.documentElement.childNodes, 0 )[0].nodeType;

// Provide a fallback method if it does not work
} catch( e ) {
	makeArray = function( array, results ) {
		var i = 0,
			ret = results || [];

		if ( toString.call(array) === "[object Array]" ) {
			Array.prototype.push.apply( ret, array );

		} else {
			if ( typeof array.length === "number" ) {
				for ( var l = array.length; i < l; i++ ) {
					ret.push( array[i] );
				}

			} else {
				for ( ; array[i]; i++ ) {
					ret.push( array[i] );
				}
			}
		}

		return ret;
	};
}

var sortOrder, siblingCheck;

if ( document.documentElement.compareDocumentPosition ) {
	sortOrder = function( a, b ) {
		if ( a === b ) {
			hasDuplicate = true;
			return 0;
		}

		if ( !a.compareDocumentPosition || !b.compareDocumentPosition ) {
			return a.compareDocumentPosition ? -1 : 1;
		}

		return a.compareDocumentPosition(b) & 4 ? -1 : 1;
	};

} else {
	sortOrder = function( a, b ) {
		// The nodes are identical, we can exit early
		if ( a === b ) {
			hasDuplicate = true;
			return 0;

		// Fallback to using sourceIndex (in IE) if it's available on both nodes
		} else if ( a.sourceIndex && b.sourceIndex ) {
			return a.sourceIndex - b.sourceIndex;
		}

		var al, bl,
			ap = [],
			bp = [],
			aup = a.parentNode,
			bup = b.parentNode,
			cur = aup;

		// If the nodes are siblings (or identical) we can do a quick check
		if ( aup === bup ) {
			return siblingCheck( a, b );

		// If no parents were found then the nodes are disconnected
		} else if ( !aup ) {
			return -1;

		} else if ( !bup ) {
			return 1;
		}

		// Otherwise they're somewhere else in the tree so we need
		// to build up a full list of the parentNodes for comparison
		while ( cur ) {
			ap.unshift( cur );
			cur = cur.parentNode;
		}

		cur = bup;

		while ( cur ) {
			bp.unshift( cur );
			cur = cur.parentNode;
		}

		al = ap.length;
		bl = bp.length;

		// Start walking down the tree looking for a discrepancy
		for ( var i = 0; i < al && i < bl; i++ ) {
			if ( ap[i] !== bp[i] ) {
				return siblingCheck( ap[i], bp[i] );
			}
		}

		// We ended someplace up the tree so do a sibling check
		return i === al ?
			siblingCheck( a, bp[i], -1 ) :
			siblingCheck( ap[i], b, 1 );
	};

	siblingCheck = function( a, b, ret ) {
		if ( a === b ) {
			return ret;
		}

		var cur = a.nextSibling;

		while ( cur ) {
			if ( cur === b ) {
				return -1;
			}

			cur = cur.nextSibling;
		}

		return 1;
	};
}

// Utility function for retreiving the text value of an array of DOM nodes
Sizzle.getText = function( elems ) {
	var ret = "", elem;

	for ( var i = 0; elems[i]; i++ ) {
		elem = elems[i];

		// Get the text from text nodes and CDATA nodes
		if ( elem.nodeType === 3 || elem.nodeType === 4 ) {
			ret += elem.nodeValue;

		// Traverse everything else, except comment nodes
		} else if ( elem.nodeType !== 8 ) {
			ret += Sizzle.getText( elem.childNodes );
		}
	}

	return ret;
};

// Check to see if the browser returns elements by name when
// querying by getElementById (and provide a workaround)
(function(){
	// We're going to inject a fake input element with a specified name
	var form = document.createElement("div"),
		id = "script" + (new Date()).getTime(),
		root = document.documentElement;

	form.innerHTML = "<a name='" + id + "'/>";

	// Inject it into the root element, check its status, and remove it quickly
	root.insertBefore( form, root.firstChild );

	// The workaround has to do additional checks after a getElementById
	// Which slows things down for other browsers (hence the branching)
	if ( document.getElementById( id ) ) {
		Expr.find.ID = function( match, context, isXML ) {
			if ( typeof context.getElementById !== "undefined" && !isXML ) {
				var m = context.getElementById(match[1]);

				return m ?
					m.id === match[1] || typeof m.getAttributeNode !== "undefined" && m.getAttributeNode("id").nodeValue === match[1] ?
						[m] :
						undefined :
					[];
			}
		};

		Expr.filter.ID = function( elem, match ) {
			var node = typeof elem.getAttributeNode !== "undefined" && elem.getAttributeNode("id");

			return elem.nodeType === 1 && node && node.nodeValue === match;
		};
	}

	root.removeChild( form );

	// release memory in IE
	root = form = null;
})();

(function(){
	// Check to see if the browser returns only elements
	// when doing getElementsByTagName("*")

	// Create a fake element
	var div = document.createElement("div");
	div.appendChild( document.createComment("") );

	// Make sure no comments are found
	if ( div.getElementsByTagName("*").length > 0 ) {
		Expr.find.TAG = function( match, context ) {
			var results = context.getElementsByTagName( match[1] );

			// Filter out possible comments
			if ( match[1] === "*" ) {
				var tmp = [];

				for ( var i = 0; results[i]; i++ ) {
					if ( results[i].nodeType === 1 ) {
						tmp.push( results[i] );
					}
				}

				results = tmp;
			}

			return results;
		};
	}

	// Check to see if an attribute returns normalized href attributes
	div.innerHTML = "<a href='#'></a>";

	if ( div.firstChild && typeof div.firstChild.getAttribute !== "undefined" &&
			div.firstChild.getAttribute("href") !== "#" ) {

		Expr.attrHandle.href = function( elem ) {
			return elem.getAttribute( "href", 2 );
		};
	}

	// release memory in IE
	div = null;
})();

if ( document.querySelectorAll ) {
	(function(){
		var oldSizzle = Sizzle,
			div = document.createElement("div"),
			id = "__sizzle__";

		div.innerHTML = "<p class='TEST'></p>";

		// Safari can't handle uppercase or unicode characters when
		// in quirks mode.
		if ( div.querySelectorAll && div.querySelectorAll(".TEST").length === 0 ) {
			return;
		}
	
		Sizzle = function( query, context, extra, seed ) {
			context = context || document;

			// Only use querySelectorAll on non-XML documents
			// (ID selectors don't work in non-HTML documents)
			if ( !seed && !Sizzle.isXML(context) ) {
				// See if we find a selector to speed up
				var match = /^(\w+$)|^\.([\w\-]+$)|^#([\w\-]+$)/.exec( query );
				
				if ( match && (context.nodeType === 1 || context.nodeType === 9) ) {
					// Speed-up: Sizzle("TAG")
					if ( match[1] ) {
						return makeArray( context.getElementsByTagName( query ), extra );
					
					// Speed-up: Sizzle(".CLASS")
					} else if ( match[2] && Expr.find.CLASS && context.getElementsByClassName ) {
						return makeArray( context.getElementsByClassName( match[2] ), extra );
					}
				}
				
				if ( context.nodeType === 9 ) {
					// Speed-up: Sizzle("body")
					// The body element only exists once, optimize finding it
					if ( query === "body" && context.body ) {
						return makeArray( [ context.body ], extra );
						
					// Speed-up: Sizzle("#ID")
					} else if ( match && match[3] ) {
						var elem = context.getElementById( match[3] );

						// Check parentNode to catch when Blackberry 4.6 returns
						// nodes that are no longer in the document #6963
						if ( elem && elem.parentNode ) {
							// Handle the case where IE and Opera return items
							// by name instead of ID
							if ( elem.id === match[3] ) {
								return makeArray( [ elem ], extra );
							}
							
						} else {
							return makeArray( [], extra );
						}
					}
					
					try {
						return makeArray( context.querySelectorAll(query), extra );
					} catch(qsaError) {}

				// qSA works strangely on Element-rooted queries
				// We can work around this by specifying an extra ID on the root
				// and working up from there (Thanks to Andrew Dupont for the technique)
				// IE 8 doesn't work on object elements
				} else if ( context.nodeType === 1 && context.nodeName.toLowerCase() !== "object" ) {
					var oldContext = context,
						old = context.getAttribute( "id" ),
						nid = old || id,
						hasParent = context.parentNode,
						relativeHierarchySelector = /^\s*[+~]/.test( query );

					if ( !old ) {
						context.setAttribute( "id", nid );
					} else {
						nid = nid.replace( /'/g, "\\$&" );
					}
					if ( relativeHierarchySelector && hasParent ) {
						context = context.parentNode;
					}

					try {
						if ( !relativeHierarchySelector || hasParent ) {
							return makeArray( context.querySelectorAll( "[id='" + nid + "'] " + query ), extra );
						}

					} catch(pseudoError) {
					} finally {
						if ( !old ) {
							oldContext.removeAttribute( "id" );
						}
					}
				}
			}
		
			return oldSizzle(query, context, extra, seed);
		};

		for ( var prop in oldSizzle ) {
			Sizzle[ prop ] = oldSizzle[ prop ];
		}

		// release memory in IE
		div = null;
	})();
}

(function(){
	var html = document.documentElement,
		matches = html.matchesSelector || html.mozMatchesSelector || html.webkitMatchesSelector || html.msMatchesSelector;

	if ( matches ) {
		// Check to see if it's possible to do matchesSelector
		// on a disconnected node (IE 9 fails this)
		var disconnectedMatch = !matches.call( document.createElement( "div" ), "div" ),
			pseudoWorks = false;

		try {
			// This should fail with an exception
			// Gecko does not error, returns false instead
			matches.call( document.documentElement, "[test!='']:sizzle" );
	
		} catch( pseudoError ) {
			pseudoWorks = true;
		}

		Sizzle.matchesSelector = function( node, expr ) {
			// Make sure that attribute selectors are quoted
			expr = expr.replace(/\=\s*([^'"\]]*)\s*\]/g, "='$1']");

			if ( !Sizzle.isXML( node ) ) {
				try { 
					if ( pseudoWorks || !Expr.match.PSEUDO.test( expr ) && !/!=/.test( expr ) ) {
						var ret = matches.call( node, expr );

						// IE 9's matchesSelector returns false on disconnected nodes
						if ( ret || !disconnectedMatch ||
								// As well, disconnected nodes are said to be in a document
								// fragment in IE 9, so check for that
								node.document && node.document.nodeType !== 11 ) {
							return ret;
						}
					}
				} catch(e) {}
			}

			return Sizzle(expr, null, null, [node]).length > 0;
		};
	}
})();

(function(){
	var div = document.createElement("div");

	div.innerHTML = "<div class='test e'></div><div class='test'></div>";

	// Opera can't find a second classname (in 9.6)
	// Also, make sure that getElementsByClassName actually exists
	if ( !div.getElementsByClassName || div.getElementsByClassName("e").length === 0 ) {
		return;
	}

	// Safari caches class attributes, doesn't catch changes (in 3.2)
	div.lastChild.className = "e";

	if ( div.getElementsByClassName("e").length === 1 ) {
		return;
	}
	
	Expr.order.splice(1, 0, "CLASS");
	Expr.find.CLASS = function( match, context, isXML ) {
		if ( typeof context.getElementsByClassName !== "undefined" && !isXML ) {
			return context.getElementsByClassName(match[1]);
		}
	};

	// release memory in IE
	div = null;
})();

function dirNodeCheck( dir, cur, doneName, checkSet, nodeCheck, isXML ) {
	for ( var i = 0, l = checkSet.length; i < l; i++ ) {
		var elem = checkSet[i];

		if ( elem ) {
			var match = false;

			elem = elem[dir];

			while ( elem ) {
				if ( elem.sizcache === doneName ) {
					match = checkSet[elem.sizset];
					break;
				}

				if ( elem.nodeType === 1 && !isXML ){
					elem.sizcache = doneName;
					elem.sizset = i;
				}

				if ( elem.nodeName.toLowerCase() === cur ) {
					match = elem;
					break;
				}

				elem = elem[dir];
			}

			checkSet[i] = match;
		}
	}
}

function dirCheck( dir, cur, doneName, checkSet, nodeCheck, isXML ) {
	for ( var i = 0, l = checkSet.length; i < l; i++ ) {
		var elem = checkSet[i];

		if ( elem ) {
			var match = false;
			
			elem = elem[dir];

			while ( elem ) {
				if ( elem.sizcache === doneName ) {
					match = checkSet[elem.sizset];
					break;
				}

				if ( elem.nodeType === 1 ) {
					if ( !isXML ) {
						elem.sizcache = doneName;
						elem.sizset = i;
					}

					if ( typeof cur !== "string" ) {
						if ( elem === cur ) {
							match = true;
							break;
						}

					} else if ( Sizzle.filter( cur, [elem] ).length > 0 ) {
						match = elem;
						break;
					}
				}

				elem = elem[dir];
			}

			checkSet[i] = match;
		}
	}
}

if ( document.documentElement.contains ) {
	Sizzle.contains = function( a, b ) {
		return a !== b && (a.contains ? a.contains(b) : true);
	};

} else if ( document.documentElement.compareDocumentPosition ) {
	Sizzle.contains = function( a, b ) {
		return !!(a.compareDocumentPosition(b) & 16);
	};

} else {
	Sizzle.contains = function() {
		return false;
	};
}

Sizzle.isXML = function( elem ) {
	// documentElement is verified for cases where it doesn't yet exist
	// (such as loading iframes in IE - #4833) 
	var documentElement = (elem ? elem.ownerDocument || elem : 0).documentElement;

	return documentElement ? documentElement.nodeName !== "HTML" : false;
};

var posProcess = function( selector, context ) {
	var match,
		tmpSet = [],
		later = "",
		root = context.nodeType ? [context] : context;

	// Position selectors must be done after the filter
	// And so must :not(positional) so we move all PSEUDOs to the end
	while ( (match = Expr.match.PSEUDO.exec( selector )) ) {
		later += match[0];
		selector = selector.replace( Expr.match.PSEUDO, "" );
	}

	selector = Expr.relative[selector] ? selector + "*" : selector;

	for ( var i = 0, l = root.length; i < l; i++ ) {
		Sizzle( selector, root[i], tmpSet );
	}

	return Sizzle.filter( later, tmpSet );
};

// EXPOSE
jQuery.find = Sizzle;
jQuery.expr = Sizzle.selectors;
jQuery.expr[":"] = jQuery.expr.filters;
jQuery.unique = Sizzle.uniqueSort;
jQuery.text = Sizzle.getText;
jQuery.isXMLDoc = Sizzle.isXML;
jQuery.contains = Sizzle.contains;


})();


var runtil = /Until$/,
	rparentsprev = /^(?:parents|prevUntil|prevAll)/,
	// Note: This RegExp should be improved, or likely pulled from Sizzle
	rmultiselector = /,/,
	isSimple = /^.[^:#\[\.,]*$/,
	slice = Array.prototype.slice,
	POS = jQuery.expr.match.POS,
	// methods guaranteed to produce a unique set when starting from a unique set
	guaranteedUnique = {
		children: true,
		contents: true,
		next: true,
		prev: true
	};

jQuery.fn.extend({
	find: function( selector ) {
		var self = this,
			i, l;

		if ( typeof selector !== "string" ) {
			return jQuery( selector ).filter(function() {
				for ( i = 0, l = self.length; i < l; i++ ) {
					if ( jQuery.contains( self[ i ], this ) ) {
						return true;
					}
				}
			});
		}

		var ret = this.pushStack( "", "find", selector ),
			length, n, r;

		for ( i = 0, l = this.length; i < l; i++ ) {
			length = ret.length;
			jQuery.find( selector, this[i], ret );

			if ( i > 0 ) {
				// Make sure that the results are unique
				for ( n = length; n < ret.length; n++ ) {
					for ( r = 0; r < length; r++ ) {
						if ( ret[r] === ret[n] ) {
							ret.splice(n--, 1);
							break;
						}
					}
				}
			}
		}

		return ret;
	},

	has: function( target ) {
		var targets = jQuery( target );
		return this.filter(function() {
			for ( var i = 0, l = targets.length; i < l; i++ ) {
				if ( jQuery.contains( this, targets[i] ) ) {
					return true;
				}
			}
		});
	},

	not: function( selector ) {
		return this.pushStack( winnow(this, selector, false), "not", selector);
	},

	filter: function( selector ) {
		return this.pushStack( winnow(this, selector, true), "filter", selector );
	},

	is: function( selector ) {
		return !!selector && ( typeof selector === "string" ?
			jQuery.filter( selector, this ).length > 0 :
			this.filter( selector ).length > 0 );
	},

	closest: function( selectors, context ) {
		var ret = [], i, l, cur = this[0];
		
		// Array
		if ( jQuery.isArray( selectors ) ) {
			var match, selector,
				matches = {},
				level = 1;

			if ( cur && selectors.length ) {
				for ( i = 0, l = selectors.length; i < l; i++ ) {
					selector = selectors[i];

					if ( !matches[ selector ] ) {
						matches[ selector ] = POS.test( selector ) ?
							jQuery( selector, context || this.context ) :
							selector;
					}
				}

				while ( cur && cur.ownerDocument && cur !== context ) {
					for ( selector in matches ) {
						match = matches[ selector ];

						if ( match.jquery ? match.index( cur ) > -1 : jQuery( cur ).is( match ) ) {
							ret.push({ selector: selector, elem: cur, level: level });
						}
					}

					cur = cur.parentNode;
					level++;
				}
			}

			return ret;
		}

		// String
		var pos = POS.test( selectors ) || typeof selectors !== "string" ?
				jQuery( selectors, context || this.context ) :
				0;

		for ( i = 0, l = this.length; i < l; i++ ) {
			cur = this[i];

			while ( cur ) {
				if ( pos ? pos.index(cur) > -1 : jQuery.find.matchesSelector(cur, selectors) ) {
					ret.push( cur );
					break;

				} else {
					cur = cur.parentNode;
					if ( !cur || !cur.ownerDocument || cur === context || cur.nodeType === 11 ) {
						break;
					}
				}
			}
		}

		ret = ret.length > 1 ? jQuery.unique( ret ) : ret;

		return this.pushStack( ret, "closest", selectors );
	},

	// Determine the position of an element within
	// the matched set of elements
	index: function( elem ) {

		// No argument, return index in parent
		if ( !elem ) {
			return ( this[0] && this[0].parentNode ) ? this.prevAll().length : -1;
		}

		// index in selector
		if ( typeof elem === "string" ) {
			return jQuery.inArray( this[0], jQuery( elem ) );
		}

		// Locate the position of the desired element
		return jQuery.inArray(
			// If it receives a jQuery object, the first element is used
			elem.jquery ? elem[0] : elem, this );
	},

	add: function( selector, context ) {
		var set = typeof selector === "string" ?
				jQuery( selector, context ) :
				jQuery.makeArray( selector && selector.nodeType ? [ selector ] : selector ),
			all = jQuery.merge( this.get(), set );

		return this.pushStack( isDisconnected( set[0] ) || isDisconnected( all[0] ) ?
			all :
			jQuery.unique( all ) );
	},

	andSelf: function() {
		return this.add( this.prevObject );
	}
});

// A painfully simple check to see if an element is disconnected
// from a document (should be improved, where feasible).
function isDisconnected( node ) {
	return !node || !node.parentNode || node.parentNode.nodeType === 11;
}

jQuery.each({
	parent: function( elem ) {
		var parent = elem.parentNode;
		return parent && parent.nodeType !== 11 ? parent : null;
	},
	parents: function( elem ) {
		return jQuery.dir( elem, "parentNode" );
	},
	parentsUntil: function( elem, i, until ) {
		return jQuery.dir( elem, "parentNode", until );
	},
	next: function( elem ) {
		return jQuery.nth( elem, 2, "nextSibling" );
	},
	prev: function( elem ) {
		return jQuery.nth( elem, 2, "previousSibling" );
	},
	nextAll: function( elem ) {
		return jQuery.dir( elem, "nextSibling" );
	},
	prevAll: function( elem ) {
		return jQuery.dir( elem, "previousSibling" );
	},
	nextUntil: function( elem, i, until ) {
		return jQuery.dir( elem, "nextSibling", until );
	},
	prevUntil: function( elem, i, until ) {
		return jQuery.dir( elem, "previousSibling", until );
	},
	siblings: function( elem ) {
		return jQuery.sibling( elem.parentNode.firstChild, elem );
	},
	children: function( elem ) {
		return jQuery.sibling( elem.firstChild );
	},
	contents: function( elem ) {
		return jQuery.nodeName( elem, "iframe" ) ?
			elem.contentDocument || elem.contentWindow.document :
			jQuery.makeArray( elem.childNodes );
	}
}, function( name, fn ) {
	jQuery.fn[ name ] = function( until, selector ) {
		var ret = jQuery.map( this, fn, until ),
			// The variable 'args' was introduced in
			// https://github.com/jquery/jquery/commit/52a0238
			// to work around a bug in Chrome 10 (Dev) and should be removed when the bug is fixed.
			// http://code.google.com/p/v8/issues/detail?id=1050
			args = slice.call(arguments);

		if ( !runtil.test( name ) ) {
			selector = until;
		}

		if ( selector && typeof selector === "string" ) {
			ret = jQuery.filter( selector, ret );
		}

		ret = this.length > 1 && !guaranteedUnique[ name ] ? jQuery.unique( ret ) : ret;

		if ( (this.length > 1 || rmultiselector.test( selector )) && rparentsprev.test( name ) ) {
			ret = ret.reverse();
		}

		return this.pushStack( ret, name, args.join(",") );
	};
});

jQuery.extend({
	filter: function( expr, elems, not ) {
		if ( not ) {
			expr = ":not(" + expr + ")";
		}

		return elems.length === 1 ?
			jQuery.find.matchesSelector(elems[0], expr) ? [ elems[0] ] : [] :
			jQuery.find.matches(expr, elems);
	},

	dir: function( elem, dir, until ) {
		var matched = [],
			cur = elem[ dir ];

		while ( cur && cur.nodeType !== 9 && (until === undefined || cur.nodeType !== 1 || !jQuery( cur ).is( until )) ) {
			if ( cur.nodeType === 1 ) {
				matched.push( cur );
			}
			cur = cur[dir];
		}
		return matched;
	},

	nth: function( cur, result, dir, elem ) {
		result = result || 1;
		var num = 0;

		for ( ; cur; cur = cur[dir] ) {
			if ( cur.nodeType === 1 && ++num === result ) {
				break;
			}
		}

		return cur;
	},

	sibling: function( n, elem ) {
		var r = [];

		for ( ; n; n = n.nextSibling ) {
			if ( n.nodeType === 1 && n !== elem ) {
				r.push( n );
			}
		}

		return r;
	}
});

// Implement the identical functionality for filter and not
function winnow( elements, qualifier, keep ) {

	// Can't pass null or undefined to indexOf in Firefox 4
	// Set to 0 to skip string check
	qualifier = qualifier || 0;

	if ( jQuery.isFunction( qualifier ) ) {
		return jQuery.grep(elements, function( elem, i ) {
			var retVal = !!qualifier.call( elem, i, elem );
			return retVal === keep;
		});

	} else if ( qualifier.nodeType ) {
		return jQuery.grep(elements, function( elem, i ) {
			return (elem === qualifier) === keep;
		});

	} else if ( typeof qualifier === "string" ) {
		var filtered = jQuery.grep(elements, function( elem ) {
			return elem.nodeType === 1;
		});

		if ( isSimple.test( qualifier ) ) {
			return jQuery.filter(qualifier, filtered, !keep);
		} else {
			qualifier = jQuery.filter( qualifier, filtered );
		}
	}

	return jQuery.grep(elements, function( elem, i ) {
		return (jQuery.inArray( elem, qualifier ) >= 0) === keep;
	});
}




var rinlinejQuery = / jQuery\d+="(?:\d+|null)"/g,
	rleadingWhitespace = /^\s+/,
	rxhtmlTag = /<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/ig,
	rtagName = /<([\w:]+)/,
	rtbody = /<tbody/i,
	rhtml = /<|&#?\w+;/,
	rnocache = /<(?:script|object|embed|option|style)/i,
	// checked="checked" or checked
	rchecked = /checked\s*(?:[^=]|=\s*.checked.)/i,
	rscriptType = /\/(java|ecma)script/i,
	rcleanScript = /^\s*<!(?:\[CDATA\[|\-\-)/,
	wrapMap = {
		option: [ 1, "<select multiple='multiple'>", "</select>" ],
		legend: [ 1, "<fieldset>", "</fieldset>" ],
		thead: [ 1, "<table>", "</table>" ],
		tr: [ 2, "<table><tbody>", "</tbody></table>" ],
		td: [ 3, "<table><tbody><tr>", "</tr></tbody></table>" ],
		col: [ 2, "<table><tbody></tbody><colgroup>", "</colgroup></table>" ],
		area: [ 1, "<map>", "</map>" ],
		_default: [ 0, "", "" ]
	};

wrapMap.optgroup = wrapMap.option;
wrapMap.tbody = wrapMap.tfoot = wrapMap.colgroup = wrapMap.caption = wrapMap.thead;
wrapMap.th = wrapMap.td;

// IE can't serialize <link> and <script> tags normally
if ( !jQuery.support.htmlSerialize ) {
	wrapMap._default = [ 1, "div<div>", "</div>" ];
}

jQuery.fn.extend({
	text: function( text ) {
		if ( jQuery.isFunction(text) ) {
			return this.each(function(i) {
				var self = jQuery( this );

				self.text( text.call(this, i, self.text()) );
			});
		}

		if ( typeof text !== "object" && text !== undefined ) {
			return this.empty().append( (this[0] && this[0].ownerDocument || document).createTextNode( text ) );
		}

		return jQuery.text( this );
	},

	wrapAll: function( html ) {
		if ( jQuery.isFunction( html ) ) {
			return this.each(function(i) {
				jQuery(this).wrapAll( html.call(this, i) );
			});
		}

		if ( this[0] ) {
			// The elements to wrap the target around
			var wrap = jQuery( html, this[0].ownerDocument ).eq(0).clone(true);

			if ( this[0].parentNode ) {
				wrap.insertBefore( this[0] );
			}

			wrap.map(function() {
				var elem = this;

				while ( elem.firstChild && elem.firstChild.nodeType === 1 ) {
					elem = elem.firstChild;
				}

				return elem;
			}).append( this );
		}

		return this;
	},

	wrapInner: function( html ) {
		if ( jQuery.isFunction( html ) ) {
			return this.each(function(i) {
				jQuery(this).wrapInner( html.call(this, i) );
			});
		}

		return this.each(function() {
			var self = jQuery( this ),
				contents = self.contents();

			if ( contents.length ) {
				contents.wrapAll( html );

			} else {
				self.append( html );
			}
		});
	},

	wrap: function( html ) {
		return this.each(function() {
			jQuery( this ).wrapAll( html );
		});
	},

	unwrap: function() {
		return this.parent().each(function() {
			if ( !jQuery.nodeName( this, "body" ) ) {
				jQuery( this ).replaceWith( this.childNodes );
			}
		}).end();
	},

	append: function() {
		return this.domManip(arguments, true, function( elem ) {
			if ( this.nodeType === 1 ) {
				this.appendChild( elem );
			}
		});
	},

	prepend: function() {
		return this.domManip(arguments, true, function( elem ) {
			if ( this.nodeType === 1 ) {
				this.insertBefore( elem, this.firstChild );
			}
		});
	},

	before: function() {
		if ( this[0] && this[0].parentNode ) {
			return this.domManip(arguments, false, function( elem ) {
				this.parentNode.insertBefore( elem, this );
			});
		} else if ( arguments.length ) {
			var set = jQuery(arguments[0]);
			set.push.apply( set, this.toArray() );
			return this.pushStack( set, "before", arguments );
		}
	},

	after: function() {
		if ( this[0] && this[0].parentNode ) {
			return this.domManip(arguments, false, function( elem ) {
				this.parentNode.insertBefore( elem, this.nextSibling );
			});
		} else if ( arguments.length ) {
			var set = this.pushStack( this, "after", arguments );
			set.push.apply( set, jQuery(arguments[0]).toArray() );
			return set;
		}
	},

	// keepData is for internal use only--do not document
	remove: function( selector, keepData ) {
		for ( var i = 0, elem; (elem = this[i]) != null; i++ ) {
			if ( !selector || jQuery.filter( selector, [ elem ] ).length ) {
				if ( !keepData && elem.nodeType === 1 ) {
					jQuery.cleanData( elem.getElementsByTagName("*") );
					jQuery.cleanData( [ elem ] );
				}

				if ( elem.parentNode ) {
					elem.parentNode.removeChild( elem );
				}
			}
		}

		return this;
	},

	empty: function() {
		for ( var i = 0, elem; (elem = this[i]) != null; i++ ) {
			// Remove element nodes and prevent memory leaks
			if ( elem.nodeType === 1 ) {
				jQuery.cleanData( elem.getElementsByTagName("*") );
			}

			// Remove any remaining nodes
			while ( elem.firstChild ) {
				elem.removeChild( elem.firstChild );
			}
		}

		return this;
	},

	clone: function( dataAndEvents, deepDataAndEvents ) {
		dataAndEvents = dataAndEvents == null ? false : dataAndEvents;
		deepDataAndEvents = deepDataAndEvents == null ? dataAndEvents : deepDataAndEvents;

		return this.map( function () {
			return jQuery.clone( this, dataAndEvents, deepDataAndEvents );
		});
	},

	html: function( value ) {
		if ( value === undefined ) {
			return this[0] && this[0].nodeType === 1 ?
				this[0].innerHTML.replace(rinlinejQuery, "") :
				null;

		// See if we can take a shortcut and just use innerHTML
		} else if ( typeof value === "string" && !rnocache.test( value ) &&
			(jQuery.support.leadingWhitespace || !rleadingWhitespace.test( value )) &&
			!wrapMap[ (rtagName.exec( value ) || ["", ""])[1].toLowerCase() ] ) {

			value = value.replace(rxhtmlTag, "<$1></$2>");

			try {
				for ( var i = 0, l = this.length; i < l; i++ ) {
					// Remove element nodes and prevent memory leaks
					if ( this[i].nodeType === 1 ) {
						jQuery.cleanData( this[i].getElementsByTagName("*") );
						this[i].innerHTML = value;
					}
				}

			// If using innerHTML throws an exception, use the fallback method
			} catch(e) {
				this.empty().append( value );
			}

		} else if ( jQuery.isFunction( value ) ) {
			this.each(function(i){
				var self = jQuery( this );

				self.html( value.call(this, i, self.html()) );
			});

		} else {
			this.empty().append( value );
		}

		return this;
	},

	replaceWith: function( value ) {
		if ( this[0] && this[0].parentNode ) {
			// Make sure that the elements are removed from the DOM before they are inserted
			// this can help fix replacing a parent with child elements
			if ( jQuery.isFunction( value ) ) {
				return this.each(function(i) {
					var self = jQuery(this), old = self.html();
					self.replaceWith( value.call( this, i, old ) );
				});
			}

			if ( typeof value !== "string" ) {
				value = jQuery( value ).detach();
			}

			return this.each(function() {
				var next = this.nextSibling,
					parent = this.parentNode;

				jQuery( this ).remove();

				if ( next ) {
					jQuery(next).before( value );
				} else {
					jQuery(parent).append( value );
				}
			});
		} else {
			return this.length ?
				this.pushStack( jQuery(jQuery.isFunction(value) ? value() : value), "replaceWith", value ) :
				this;
		}
	},

	detach: function( selector ) {
		return this.remove( selector, true );
	},

	domManip: function( args, table, callback ) {
		var results, first, fragment, parent,
			value = args[0],
			scripts = [];

		// We can't cloneNode fragments that contain checked, in WebKit
		if ( !jQuery.support.checkClone && arguments.length === 3 && typeof value === "string" && rchecked.test( value ) ) {
			return this.each(function() {
				jQuery(this).domManip( args, table, callback, true );
			});
		}

		if ( jQuery.isFunction(value) ) {
			return this.each(function(i) {
				var self = jQuery(this);
				args[0] = value.call(this, i, table ? self.html() : undefined);
				self.domManip( args, table, callback );
			});
		}

		if ( this[0] ) {
			parent = value && value.parentNode;

			// If we're in a fragment, just use that instead of building a new one
			if ( jQuery.support.parentNode && parent && parent.nodeType === 11 && parent.childNodes.length === this.length ) {
				results = { fragment: parent };

			} else {
				results = jQuery.buildFragment( args, this, scripts );
			}

			fragment = results.fragment;

			if ( fragment.childNodes.length === 1 ) {
				first = fragment = fragment.firstChild;
			} else {
				first = fragment.firstChild;
			}

			if ( first ) {
				table = table && jQuery.nodeName( first, "tr" );

				for ( var i = 0, l = this.length, lastIndex = l - 1; i < l; i++ ) {
					callback.call(
						table ?
							root(this[i], first) :
							this[i],
						// Make sure that we do not leak memory by inadvertently discarding
						// the original fragment (which might have attached data) instead of
						// using it; in addition, use the original fragment object for the last
						// item instead of first because it can end up being emptied incorrectly
						// in certain situations (Bug #8070).
						// Fragments from the fragment cache must always be cloned and never used
						// in place.
						results.cacheable || (l > 1 && i < lastIndex) ?
							jQuery.clone( fragment, true, true ) :
							fragment
					);
				}
			}

			if ( scripts.length ) {
				jQuery.each( scripts, evalScript );
			}
		}

		return this;
	}
});

function root( elem, cur ) {
	return jQuery.nodeName(elem, "table") ?
		(elem.getElementsByTagName("tbody")[0] ||
		elem.appendChild(elem.ownerDocument.createElement("tbody"))) :
		elem;
}

function cloneCopyEvent( src, dest ) {

	if ( dest.nodeType !== 1 || !jQuery.hasData( src ) ) {
		return;
	}

	var internalKey = jQuery.expando,
		oldData = jQuery.data( src ),
		curData = jQuery.data( dest, oldData );

	// Switch to use the internal data object, if it exists, for the next
	// stage of data copying
	if ( (oldData = oldData[ internalKey ]) ) {
		var events = oldData.events;
				curData = curData[ internalKey ] = jQuery.extend({}, oldData);

		if ( events ) {
			delete curData.handle;
			curData.events = {};

			for ( var type in events ) {
				for ( var i = 0, l = events[ type ].length; i < l; i++ ) {
					jQuery.event.add( dest, type + ( events[ type ][ i ].namespace ? "." : "" ) + events[ type ][ i ].namespace, events[ type ][ i ], events[ type ][ i ].data );
				}
			}
		}
	}
}

function cloneFixAttributes( src, dest ) {
	var nodeName;

	// We do not need to do anything for non-Elements
	if ( dest.nodeType !== 1 ) {
		return;
	}

	// clearAttributes removes the attributes, which we don't want,
	// but also removes the attachEvent events, which we *do* want
	if ( dest.clearAttributes ) {
		dest.clearAttributes();
	}

	// mergeAttributes, in contrast, only merges back on the
	// original attributes, not the events
	if ( dest.mergeAttributes ) {
		dest.mergeAttributes( src );
	}

	nodeName = dest.nodeName.toLowerCase();

	// IE6-8 fail to clone children inside object elements that use
	// the proprietary classid attribute value (rather than the type
	// attribute) to identify the type of content to display
	if ( nodeName === "object" ) {
		dest.outerHTML = src.outerHTML;

	} else if ( nodeName === "input" && (src.type === "checkbox" || src.type === "radio") ) {
		// IE6-8 fails to persist the checked state of a cloned checkbox
		// or radio button. Worse, IE6-7 fail to give the cloned element
		// a checked appearance if the defaultChecked value isn't also set
		if ( src.checked ) {
			dest.defaultChecked = dest.checked = src.checked;
		}

		// IE6-7 get confused and end up setting the value of a cloned
		// checkbox/radio button to an empty string instead of "on"
		if ( dest.value !== src.value ) {
			dest.value = src.value;
		}

	// IE6-8 fails to return the selected option to the default selected
	// state when cloning options
	} else if ( nodeName === "option" ) {
		dest.selected = src.defaultSelected;

	// IE6-8 fails to set the defaultValue to the correct value when
	// cloning other types of input fields
	} else if ( nodeName === "input" || nodeName === "textarea" ) {
		dest.defaultValue = src.defaultValue;
	}

	// Event data gets referenced instead of copied if the expando
	// gets copied too
	dest.removeAttribute( jQuery.expando );
}

jQuery.buildFragment = function( args, nodes, scripts ) {
	var fragment, cacheable, cacheresults, doc;

  // nodes may contain either an explicit document object,
  // a jQuery collection or context object.
  // If nodes[0] contains a valid object to assign to doc
  if ( nodes && nodes[0] ) {
    doc = nodes[0].ownerDocument || nodes[0];
  }

  // Ensure that an attr object doesn't incorrectly stand in as a document object
	// Chrome and Firefox seem to allow this to occur and will throw exception
	// Fixes #8950
	if ( !doc.createDocumentFragment ) {
		doc = document;
	}

	// Only cache "small" (1/2 KB) HTML strings that are associated with the main document
	// Cloning options loses the selected state, so don't cache them
	// IE 6 doesn't like it when you put <object> or <embed> elements in a fragment
	// Also, WebKit does not clone 'checked' attributes on cloneNode, so don't cache
	if ( args.length === 1 && typeof args[0] === "string" && args[0].length < 512 && doc === document &&
		args[0].charAt(0) === "<" && !rnocache.test( args[0] ) && (jQuery.support.checkClone || !rchecked.test( args[0] )) ) {

		cacheable = true;

		cacheresults = jQuery.fragments[ args[0] ];
		if ( cacheresults && cacheresults !== 1 ) {
			fragment = cacheresults;
		}
	}

	if ( !fragment ) {
		fragment = doc.createDocumentFragment();
		jQuery.clean( args, doc, fragment, scripts );
	}

	if ( cacheable ) {
		jQuery.fragments[ args[0] ] = cacheresults ? fragment : 1;
	}

	return { fragment: fragment, cacheable: cacheable };
};

jQuery.fragments = {};

jQuery.each({
	appendTo: "append",
	prependTo: "prepend",
	insertBefore: "before",
	insertAfter: "after",
	replaceAll: "replaceWith"
}, function( name, original ) {
	jQuery.fn[ name ] = function( selector ) {
		var ret = [],
			insert = jQuery( selector ),
			parent = this.length === 1 && this[0].parentNode;

		if ( parent && parent.nodeType === 11 && parent.childNodes.length === 1 && insert.length === 1 ) {
			insert[ original ]( this[0] );
			return this;

		} else {
			for ( var i = 0, l = insert.length; i < l; i++ ) {
				var elems = (i > 0 ? this.clone(true) : this).get();
				jQuery( insert[i] )[ original ]( elems );
				ret = ret.concat( elems );
			}

			return this.pushStack( ret, name, insert.selector );
		}
	};
});

function getAll( elem ) {
	if ( "getElementsByTagName" in elem ) {
		return elem.getElementsByTagName( "*" );

	} else if ( "querySelectorAll" in elem ) {
		return elem.querySelectorAll( "*" );

	} else {
		return [];
	}
}

// Used in clean, fixes the defaultChecked property
function fixDefaultChecked( elem ) {
	if ( elem.type === "checkbox" || elem.type === "radio" ) {
		elem.defaultChecked = elem.checked;
	}
}
// Finds all inputs and passes them to fixDefaultChecked
function findInputs( elem ) {
	if ( jQuery.nodeName( elem, "input" ) ) {
		fixDefaultChecked( elem );
	} else if ( "getElementsByTagName" in elem ) {
		jQuery.grep( elem.getElementsByTagName("input"), fixDefaultChecked );
	}
}

jQuery.extend({
	clone: function( elem, dataAndEvents, deepDataAndEvents ) {
		var clone = elem.cloneNode(true),
				srcElements,
				destElements,
				i;

		if ( (!jQuery.support.noCloneEvent || !jQuery.support.noCloneChecked) &&
				(elem.nodeType === 1 || elem.nodeType === 11) && !jQuery.isXMLDoc(elem) ) {
			// IE copies events bound via attachEvent when using cloneNode.
			// Calling detachEvent on the clone will also remove the events
			// from the original. In order to get around this, we use some
			// proprietary methods to clear the events. Thanks to MooTools
			// guys for this hotness.

			cloneFixAttributes( elem, clone );

			// Using Sizzle here is crazy slow, so we use getElementsByTagName
			// instead
			srcElements = getAll( elem );
			destElements = getAll( clone );

			// Weird iteration because IE will replace the length property
			// with an element if you are cloning the body and one of the
			// elements on the page has a name or id of "length"
			for ( i = 0; srcElements[i]; ++i ) {
				// Ensure that the destination node is not null; Fixes #9587
				if ( destElements[i] ) {
					cloneFixAttributes( srcElements[i], destElements[i] );
				}
			}
		}

		// Copy the events from the original to the clone
		if ( dataAndEvents ) {
			cloneCopyEvent( elem, clone );

			if ( deepDataAndEvents ) {
				srcElements = getAll( elem );
				destElements = getAll( clone );

				for ( i = 0; srcElements[i]; ++i ) {
					cloneCopyEvent( srcElements[i], destElements[i] );
				}
			}
		}

		srcElements = destElements = null;

		// Return the cloned set
		return clone;
	},

	clean: function( elems, context, fragment, scripts ) {
		var checkScriptType;

		context = context || document;

		// !context.createElement fails in IE with an error but returns typeof 'object'
		if ( typeof context.createElement === "undefined" ) {
			context = context.ownerDocument || context[0] && context[0].ownerDocument || document;
		}

		var ret = [], j;

		for ( var i = 0, elem; (elem = elems[i]) != null; i++ ) {
			if ( typeof elem === "number" ) {
				elem += "";
			}

			if ( !elem ) {
				continue;
			}

			// Convert html string into DOM nodes
			if ( typeof elem === "string" ) {
				if ( !rhtml.test( elem ) ) {
					elem = context.createTextNode( elem );
				} else {
					// Fix "XHTML"-style tags in all browsers
					elem = elem.replace(rxhtmlTag, "<$1></$2>");

					// Trim whitespace, otherwise indexOf won't work as expected
					var tag = (rtagName.exec( elem ) || ["", ""])[1].toLowerCase(),
						wrap = wrapMap[ tag ] || wrapMap._default,
						depth = wrap[0],
						div = context.createElement("div");

					// Go to html and back, then peel off extra wrappers
					div.innerHTML = wrap[1] + elem + wrap[2];

					// Move to the right depth
					while ( depth-- ) {
						div = div.lastChild;
					}

					// Remove IE's autoinserted <tbody> from table fragments
					if ( !jQuery.support.tbody ) {

						// String was a <table>, *may* have spurious <tbody>
						var hasBody = rtbody.test(elem),
							tbody = tag === "table" && !hasBody ?
								div.firstChild && div.firstChild.childNodes :

								// String was a bare <thead> or <tfoot>
								wrap[1] === "<table>" && !hasBody ?
									div.childNodes :
									[];

						for ( j = tbody.length - 1; j >= 0 ; --j ) {
							if ( jQuery.nodeName( tbody[ j ], "tbody" ) && !tbody[ j ].childNodes.length ) {
								tbody[ j ].parentNode.removeChild( tbody[ j ] );
							}
						}
					}

					// IE completely kills leading whitespace when innerHTML is used
					if ( !jQuery.support.leadingWhitespace && rleadingWhitespace.test( elem ) ) {
						div.insertBefore( context.createTextNode( rleadingWhitespace.exec(elem)[0] ), div.firstChild );
					}

					elem = div.childNodes;
				}
			}

			// Resets defaultChecked for any radios and checkboxes
			// about to be appended to the DOM in IE 6/7 (#8060)
			var len;
			if ( !jQuery.support.appendChecked ) {
				if ( elem[0] && typeof (len = elem.length) === "number" ) {
					for ( j = 0; j < len; j++ ) {
						findInputs( elem[j] );
					}
				} else {
					findInputs( elem );
				}
			}

			if ( elem.nodeType ) {
				ret.push( elem );
			} else {
				ret = jQuery.merge( ret, elem );
			}
		}

		if ( fragment ) {
			checkScriptType = function( elem ) {
				return !elem.type || rscriptType.test( elem.type );
			};
			for ( i = 0; ret[i]; i++ ) {
				if ( scripts && jQuery.nodeName( ret[i], "script" ) && (!ret[i].type || ret[i].type.toLowerCase() === "text/javascript") ) {
					scripts.push( ret[i].parentNode ? ret[i].parentNode.removeChild( ret[i] ) : ret[i] );

				} else {
					if ( ret[i].nodeType === 1 ) {
						var jsTags = jQuery.grep( ret[i].getElementsByTagName( "script" ), checkScriptType );

						ret.splice.apply( ret, [i + 1, 0].concat( jsTags ) );
					}
					fragment.appendChild( ret[i] );
				}
			}
		}

		return ret;
	},

	cleanData: function( elems ) {
		var data, id, cache = jQuery.cache, internalKey = jQuery.expando, special = jQuery.event.special,
			deleteExpando = jQuery.support.deleteExpando;

		for ( var i = 0, elem; (elem = elems[i]) != null; i++ ) {
			if ( elem.nodeName && jQuery.noData[elem.nodeName.toLowerCase()] ) {
				continue;
			}

			id = elem[ jQuery.expando ];

			if ( id ) {
				data = cache[ id ] && cache[ id ][ internalKey ];

				if ( data && data.events ) {
					for ( var type in data.events ) {
						if ( special[ type ] ) {
							jQuery.event.remove( elem, type );

						// This is a shortcut to avoid jQuery.event.remove's overhead
						} else {
							jQuery.removeEvent( elem, type, data.handle );
						}
					}

					// Null the DOM reference to avoid IE6/7/8 leak (#7054)
					if ( data.handle ) {
						data.handle.elem = null;
					}
				}

				if ( deleteExpando ) {
					delete elem[ jQuery.expando ];

				} else if ( elem.removeAttribute ) {
					elem.removeAttribute( jQuery.expando );
				}

				delete cache[ id ];
			}
		}
	}
});

function evalScript( i, elem ) {
	if ( elem.src ) {
		jQuery.ajax({
			url: elem.src,
			async: false,
			dataType: "script"
		});
	} else {
		jQuery.globalEval( ( elem.text || elem.textContent || elem.innerHTML || "" ).replace( rcleanScript, "/*$0*/" ) );
	}

	if ( elem.parentNode ) {
		elem.parentNode.removeChild( elem );
	}
}




var ralpha = /alpha\([^)]*\)/i,
	ropacity = /opacity=([^)]*)/,
	// fixed for IE9, see #8346
	rupper = /([A-Z]|^ms)/g,
	rnumpx = /^-?\d+(?:px)?$/i,
	rnum = /^-?\d/,
	rrelNum = /^([\-+])=([\-+.\de]+)/,

	cssShow = { position: "absolute", visibility: "hidden", display: "block" },
	cssWidth = [ "Left", "Right" ],
	cssHeight = [ "Top", "Bottom" ],
	curCSS,

	getComputedStyle,
	currentStyle;

jQuery.fn.css = function( name, value ) {
	// Setting 'undefined' is a no-op
	if ( arguments.length === 2 && value === undefined ) {
		return this;
	}

	return jQuery.access( this, name, value, true, function( elem, name, value ) {
		return value !== undefined ?
			jQuery.style( elem, name, value ) :
			jQuery.css( elem, name );
	});
};

jQuery.extend({
	// Add in style property hooks for overriding the default
	// behavior of getting and setting a style property
	cssHooks: {
		opacity: {
			get: function( elem, computed ) {
				if ( computed ) {
					// We should always get a number back from opacity
					var ret = curCSS( elem, "opacity", "opacity" );
					return ret === "" ? "1" : ret;

				} else {
					return elem.style.opacity;
				}
			}
		}
	},

	// Exclude the following css properties to add px
	cssNumber: {
		"fillOpacity": true,
		"fontWeight": true,
		"lineHeight": true,
		"opacity": true,
		"orphans": true,
		"widows": true,
		"zIndex": true,
		"zoom": true
	},

	// Add in properties whose names you wish to fix before
	// setting or getting the value
	cssProps: {
		// normalize float css property
		"float": jQuery.support.cssFloat ? "cssFloat" : "styleFloat"
	},

	// Get and set the style property on a DOM Node
	style: function( elem, name, value, extra ) {
		// Don't set styles on text and comment nodes
		if ( !elem || elem.nodeType === 3 || elem.nodeType === 8 || !elem.style ) {
			return;
		}

		// Make sure that we're working with the right name
		var ret, type, origName = jQuery.camelCase( name ),
			style = elem.style, hooks = jQuery.cssHooks[ origName ];

		name = jQuery.cssProps[ origName ] || origName;

		// Check if we're setting a value
		if ( value !== undefined ) {
			type = typeof value;

			// convert relative number strings (+= or -=) to relative numbers. #7345
			if ( type === "string" && (ret = rrelNum.exec( value )) ) {
				value = ( +( ret[1] + 1) * +ret[2] ) + parseFloat( jQuery.css( elem, name ) );
				// Fixes bug #9237
				type = "number";
			}

			// Make sure that NaN and null values aren't set. See: #7116
			if ( value == null || type === "number" && isNaN( value ) ) {
				return;
			}

			// If a number was passed in, add 'px' to the (except for certain CSS properties)
			if ( type === "number" && !jQuery.cssNumber[ origName ] ) {
				value += "px";
			}

			// If a hook was provided, use that value, otherwise just set the specified value
			if ( !hooks || !("set" in hooks) || (value = hooks.set( elem, value )) !== undefined ) {
				// Wrapped to prevent IE from throwing errors when 'invalid' values are provided
				// Fixes bug #5509
				try {
					style[ name ] = value;
				} catch(e) {}
			}

		} else {
			// If a hook was provided get the non-computed value from there
			if ( hooks && "get" in hooks && (ret = hooks.get( elem, false, extra )) !== undefined ) {
				return ret;
			}

			// Otherwise just get the value from the style object
			return style[ name ];
		}
	},

	css: function( elem, name, extra ) {
		var ret, hooks;

		// Make sure that we're working with the right name
		name = jQuery.camelCase( name );
		hooks = jQuery.cssHooks[ name ];
		name = jQuery.cssProps[ name ] || name;

		// cssFloat needs a special treatment
		if ( name === "cssFloat" ) {
			name = "float";
		}

		// If a hook was provided get the computed value from there
		if ( hooks && "get" in hooks && (ret = hooks.get( elem, true, extra )) !== undefined ) {
			return ret;

		// Otherwise, if a way to get the computed value exists, use that
		} else if ( curCSS ) {
			return curCSS( elem, name );
		}
	},

	// A method for quickly swapping in/out CSS properties to get correct calculations
	swap: function( elem, options, callback ) {
		var old = {};

		// Remember the old values, and insert the new ones
		for ( var name in options ) {
			old[ name ] = elem.style[ name ];
			elem.style[ name ] = options[ name ];
		}

		callback.call( elem );

		// Revert the old values
		for ( name in options ) {
			elem.style[ name ] = old[ name ];
		}
	}
});

// DEPRECATED, Use jQuery.css() instead
jQuery.curCSS = jQuery.css;

jQuery.each(["height", "width"], function( i, name ) {
	jQuery.cssHooks[ name ] = {
		get: function( elem, computed, extra ) {
			var val;

			if ( computed ) {
				if ( elem.offsetWidth !== 0 ) {
					return getWH( elem, name, extra );
				} else {
					jQuery.swap( elem, cssShow, function() {
						val = getWH( elem, name, extra );
					});
				}

				return val;
			}
		},

		set: function( elem, value ) {
			if ( rnumpx.test( value ) ) {
				// ignore negative width and height values #1599
				value = parseFloat( value );

				if ( value >= 0 ) {
					return value + "px";
				}

			} else {
				return value;
			}
		}
	};
});

if ( !jQuery.support.opacity ) {
	jQuery.cssHooks.opacity = {
		get: function( elem, computed ) {
			// IE uses filters for opacity
			return ropacity.test( (computed && elem.currentStyle ? elem.currentStyle.filter : elem.style.filter) || "" ) ?
				( parseFloat( RegExp.$1 ) / 100 ) + "" :
				computed ? "1" : "";
		},

		set: function( elem, value ) {
			var style = elem.style,
				currentStyle = elem.currentStyle,
				opacity = jQuery.isNaN( value ) ? "" : "alpha(opacity=" + value * 100 + ")",
				filter = currentStyle && currentStyle.filter || style.filter || "";

			// IE has trouble with opacity if it does not have layout
			// Force it by setting the zoom level
			style.zoom = 1;

			// if setting opacity to 1, and no other filters exist - attempt to remove filter attribute #6652
			if ( value >= 1 && jQuery.trim( filter.replace( ralpha, "" ) ) === "" ) {

				// Setting style.filter to null, "" & " " still leave "filter:" in the cssText
				// if "filter:" is present at all, clearType is disabled, we want to avoid this
				// style.removeAttribute is IE Only, but so apparently is this code path...
				style.removeAttribute( "filter" );

				// if there there is no filter style applied in a css rule, we are done
				if ( currentStyle && !currentStyle.filter ) {
					return;
				}
			}

			// otherwise, set new filter values
			style.filter = ralpha.test( filter ) ?
				filter.replace( ralpha, opacity ) :
				filter + " " + opacity;
		}
	};
}

jQuery(function() {
	// This hook cannot be added until DOM ready because the support test
	// for it is not run until after DOM ready
	if ( !jQuery.support.reliableMarginRight ) {
		jQuery.cssHooks.marginRight = {
			get: function( elem, computed ) {
				// WebKit Bug 13343 - getComputedStyle returns wrong value for margin-right
				// Work around by temporarily setting element display to inline-block
				var ret;
				jQuery.swap( elem, { "display": "inline-block" }, function() {
					if ( computed ) {
						ret = curCSS( elem, "margin-right", "marginRight" );
					} else {
						ret = elem.style.marginRight;
					}
				});
				return ret;
			}
		};
	}
});

if ( document.defaultView && document.defaultView.getComputedStyle ) {
	getComputedStyle = function( elem, name ) {
		var ret, defaultView, computedStyle;

		name = name.replace( rupper, "-$1" ).toLowerCase();

		if ( !(defaultView = elem.ownerDocument.defaultView) ) {
			return undefined;
		}

		if ( (computedStyle = defaultView.getComputedStyle( elem, null )) ) {
			ret = computedStyle.getPropertyValue( name );
			if ( ret === "" && !jQuery.contains( elem.ownerDocument.documentElement, elem ) ) {
				ret = jQuery.style( elem, name );
			}
		}

		return ret;
	};
}

if ( document.documentElement.currentStyle ) {
	currentStyle = function( elem, name ) {
		var left,
			ret = elem.currentStyle && elem.currentStyle[ name ],
			rsLeft = elem.runtimeStyle && elem.runtimeStyle[ name ],
			style = elem.style;

		// From the awesome hack by Dean Edwards
		// http://erik.eae.net/archives/2007/07/27/18.54.15/#comment-102291

		// If we're not dealing with a regular pixel number
		// but a number that has a weird ending, we need to convert it to pixels
		if ( !rnumpx.test( ret ) && rnum.test( ret ) ) {
			// Remember the original values
			left = style.left;

			// Put in the new values to get a computed value out
			if ( rsLeft ) {
				elem.runtimeStyle.left = elem.currentStyle.left;
			}
			style.left = name === "fontSize" ? "1em" : (ret || 0);
			ret = style.pixelLeft + "px";

			// Revert the changed values
			style.left = left;
			if ( rsLeft ) {
				elem.runtimeStyle.left = rsLeft;
			}
		}

		return ret === "" ? "auto" : ret;
	};
}

curCSS = getComputedStyle || currentStyle;

function getWH( elem, name, extra ) {

	// Start with offset property
	var val = name === "width" ? elem.offsetWidth : elem.offsetHeight,
		which = name === "width" ? cssWidth : cssHeight;

	if ( val > 0 ) {
		if ( extra !== "border" ) {
			jQuery.each( which, function() {
				if ( !extra ) {
					val -= parseFloat( jQuery.css( elem, "padding" + this ) ) || 0;
				}
				if ( extra === "margin" ) {
					val += parseFloat( jQuery.css( elem, extra + this ) ) || 0;
				} else {
					val -= parseFloat( jQuery.css( elem, "border" + this + "Width" ) ) || 0;
				}
			});
		}

		return val + "px";
	}

	// Fall back to computed then uncomputed css if necessary
	val = curCSS( elem, name, name );
	if ( val < 0 || val == null ) {
		val = elem.style[ name ] || 0;
	}
	// Normalize "", auto, and prepare for extra
	val = parseFloat( val ) || 0;

	// Add padding, border, margin
	if ( extra ) {
		jQuery.each( which, function() {
			val += parseFloat( jQuery.css( elem, "padding" + this ) ) || 0;
			if ( extra !== "padding" ) {
				val += parseFloat( jQuery.css( elem, "border" + this + "Width" ) ) || 0;
			}
			if ( extra === "margin" ) {
				val += parseFloat( jQuery.css( elem, extra + this ) ) || 0;
			}
		});
	}

	return val + "px";
}

if ( jQuery.expr && jQuery.expr.filters ) {
	jQuery.expr.filters.hidden = function( elem ) {
		var width = elem.offsetWidth,
			height = elem.offsetHeight;

		return (width === 0 && height === 0) || (!jQuery.support.reliableHiddenOffsets && (elem.style.display || jQuery.css( elem, "display" )) === "none");
	};

	jQuery.expr.filters.visible = function( elem ) {
		return !jQuery.expr.filters.hidden( elem );
	};
}




var r20 = /%20/g,
	rbracket = /\[\]$/,
	rCRLF = /\r?\n/g,
	rhash = /#.*$/,
	rheaders = /^(.*?):[ \t]*([^\r\n]*)\r?$/mg, // IE leaves an \r character at EOL
	rinput = /^(?:color|date|datetime|datetime-local|email|hidden|month|number|password|range|search|tel|text|time|url|week)$/i,
	// #7653, #8125, #8152: local protocol detection
	rlocalProtocol = /^(?:about|app|app\-storage|.+\-extension|file|res|widget):$/,
	rnoContent = /^(?:GET|HEAD)$/,
	rprotocol = /^\/\//,
	rquery = /\?/,
	rscript = /<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi,
	rselectTextarea = /^(?:select|textarea)/i,
	rspacesAjax = /\s+/,
	rts = /([?&])_=[^&]*/,
	rurl = /^([\w\+\.\-]+:)(?:\/\/([^\/?#:]*)(?::(\d+))?)?/,

	// Keep a copy of the old load method
	_load = jQuery.fn.load,

	/* Prefilters
	 * 1) They are useful to introduce custom dataTypes (see ajax/jsonp.js for an example)
	 * 2) These are called:
	 *    - BEFORE asking for a transport
	 *    - AFTER param serialization (s.data is a string if s.processData is true)
	 * 3) key is the dataType
	 * 4) the catchall symbol "*" can be used
	 * 5) execution will start with transport dataType and THEN continue down to "*" if needed
	 */
	prefilters = {},

	/* Transports bindings
	 * 1) key is the dataType
	 * 2) the catchall symbol "*" can be used
	 * 3) selection will start with transport dataType and THEN go to "*" if needed
	 */
	transports = {},

	// Document location
	ajaxLocation,

	// Document location segments
	ajaxLocParts,
	
	// Avoid comment-prolog char sequence (#10098); must appease lint and evade compression
	allTypes = ["*/"] + ["*"];

// #8138, IE may throw an exception when accessing
// a field from window.location if document.domain has been set
try {
	ajaxLocation = location.href;
} catch( e ) {
	// Use the href attribute of an A element
	// since IE will modify it given document.location
	ajaxLocation = document.createElement( "a" );
	ajaxLocation.href = "";
	ajaxLocation = ajaxLocation.href;
}

// Segment location into parts
ajaxLocParts = rurl.exec( ajaxLocation.toLowerCase() ) || [];

// Base "constructor" for jQuery.ajaxPrefilter and jQuery.ajaxTransport
function addToPrefiltersOrTransports( structure ) {

	// dataTypeExpression is optional and defaults to "*"
	return function( dataTypeExpression, func ) {

		if ( typeof dataTypeExpression !== "string" ) {
			func = dataTypeExpression;
			dataTypeExpression = "*";
		}

		if ( jQuery.isFunction( func ) ) {
			var dataTypes = dataTypeExpression.toLowerCase().split( rspacesAjax ),
				i = 0,
				length = dataTypes.length,
				dataType,
				list,
				placeBefore;

			// For each dataType in the dataTypeExpression
			for(; i < length; i++ ) {
				dataType = dataTypes[ i ];
				// We control if we're asked to add before
				// any existing element
				placeBefore = /^\+/.test( dataType );
				if ( placeBefore ) {
					dataType = dataType.substr( 1 ) || "*";
				}
				list = structure[ dataType ] = structure[ dataType ] || [];
				// then we add to the structure accordingly
				list[ placeBefore ? "unshift" : "push" ]( func );
			}
		}
	};
}

// Base inspection function for prefilters and transports
function inspectPrefiltersOrTransports( structure, options, originalOptions, jqXHR,
		dataType /* internal */, inspected /* internal */ ) {

	dataType = dataType || options.dataTypes[ 0 ];
	inspected = inspected || {};

	inspected[ dataType ] = true;

	var list = structure[ dataType ],
		i = 0,
		length = list ? list.length : 0,
		executeOnly = ( structure === prefilters ),
		selection;

	for(; i < length && ( executeOnly || !selection ); i++ ) {
		selection = list[ i ]( options, originalOptions, jqXHR );
		// If we got redirected to another dataType
		// we try there if executing only and not done already
		if ( typeof selection === "string" ) {
			if ( !executeOnly || inspected[ selection ] ) {
				selection = undefined;
			} else {
				options.dataTypes.unshift( selection );
				selection = inspectPrefiltersOrTransports(
						structure, options, originalOptions, jqXHR, selection, inspected );
			}
		}
	}
	// If we're only executing or nothing was selected
	// we try the catchall dataType if not done already
	if ( ( executeOnly || !selection ) && !inspected[ "*" ] ) {
		selection = inspectPrefiltersOrTransports(
				structure, options, originalOptions, jqXHR, "*", inspected );
	}
	// unnecessary when only executing (prefilters)
	// but it'll be ignored by the caller in that case
	return selection;
}

// A special extend for ajax options
// that takes "flat" options (not to be deep extended)
// Fixes #9887
function ajaxExtend( target, src ) {
	var key, deep,
		flatOptions = jQuery.ajaxSettings.flatOptions || {};
	for( key in src ) {
		if ( src[ key ] !== undefined ) {
			( flatOptions[ key ] ? target : ( deep || ( deep = {} ) ) )[ key ] = src[ key ];
		}
	}
	if ( deep ) {
		jQuery.extend( true, target, deep );
	}
}

jQuery.fn.extend({
	load: function( url, params, callback ) {
		if ( typeof url !== "string" && _load ) {
			return _load.apply( this, arguments );

		// Don't do a request if no elements are being requested
		} else if ( !this.length ) {
			return this;
		}

		var off = url.indexOf( " " );
		if ( off >= 0 ) {
			var selector = url.slice( off, url.length );
			url = url.slice( 0, off );
		}

		// Default to a GET request
		var type = "GET";

		// If the second parameter was provided
		if ( params ) {
			// If it's a function
			if ( jQuery.isFunction( params ) ) {
				// We assume that it's the callback
				callback = params;
				params = undefined;

			// Otherwise, build a param string
			} else if ( typeof params === "object" ) {
				params = jQuery.param( params, jQuery.ajaxSettings.traditional );
				type = "POST";
			}
		}

		var self = this;

		// Request the remote document
		jQuery.ajax({
			url: url,
			type: type,
			dataType: "html",
			data: params,
			// Complete callback (responseText is used internally)
			complete: function( jqXHR, status, responseText ) {
				// Store the response as specified by the jqXHR object
				responseText = jqXHR.responseText;
				// If successful, inject the HTML into all the matched elements
				if ( jqXHR.isResolved() ) {
					// #4825: Get the actual response in case
					// a dataFilter is present in ajaxSettings
					jqXHR.done(function( r ) {
						responseText = r;
					});
					// See if a selector was specified
					self.html( selector ?
						// Create a dummy div to hold the results
						jQuery("<div>")
							// inject the contents of the document in, removing the scripts
							// to avoid any 'Permission Denied' errors in IE
							.append(responseText.replace(rscript, ""))

							// Locate the specified elements
							.find(selector) :

						// If not, just inject the full result
						responseText );
				}

				if ( callback ) {
					self.each( callback, [ responseText, status, jqXHR ] );
				}
			}
		});

		return this;
	},

	serialize: function() {
		return jQuery.param( this.serializeArray() );
	},

	serializeArray: function() {
		return this.map(function(){
			return this.elements ? jQuery.makeArray( this.elements ) : this;
		})
		.filter(function(){
			return this.name && !this.disabled &&
				( this.checked || rselectTextarea.test( this.nodeName ) ||
					rinput.test( this.type ) );
		})
		.map(function( i, elem ){
			var val = jQuery( this ).val();

			return val == null ?
				null :
				jQuery.isArray( val ) ?
					jQuery.map( val, function( val, i ){
						return { name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
					}) :
					{ name: elem.name, value: val.replace( rCRLF, "\r\n" ) };
		}).get();
	}
});

// Attach a bunch of functions for handling common AJAX events
jQuery.each( "ajaxStart ajaxStop ajaxComplete ajaxError ajaxSuccess ajaxSend".split( " " ), function( i, o ){
	jQuery.fn[ o ] = function( f ){
		return this.bind( o, f );
	};
});

jQuery.each( [ "get", "post" ], function( i, method ) {
	jQuery[ method ] = function( url, data, callback, type ) {
		// shift arguments if data argument was omitted
		if ( jQuery.isFunction( data ) ) {
			type = type || callback;
			callback = data;
			data = undefined;
		}

		return jQuery.ajax({
			type: method,
			url: url,
			data: data,
			success: callback,
			dataType: type
		});
	};
});

jQuery.extend({

	getScript: function( url, callback ) {
		return jQuery.get( url, undefined, callback, "script" );
	},

	getJSON: function( url, data, callback ) {
		return jQuery.get( url, data, callback, "json" );
	},

	// Creates a full fledged settings object into target
	// with both ajaxSettings and settings fields.
	// If target is omitted, writes into ajaxSettings.
	ajaxSetup: function( target, settings ) {
		if ( settings ) {
			// Building a settings object
			ajaxExtend( target, jQuery.ajaxSettings );
		} else {
			// Extending ajaxSettings
			settings = target;
			target = jQuery.ajaxSettings;
		}
		ajaxExtend( target, settings );
		return target;
	},

	ajaxSettings: {
		url: ajaxLocation,
		isLocal: rlocalProtocol.test( ajaxLocParts[ 1 ] ),
		global: true,
		type: "GET",
		contentType: "application/x-www-form-urlencoded",
		processData: true,
		async: true,
		/*
		timeout: 0,
		data: null,
		dataType: null,
		username: null,
		password: null,
		cache: null,
		traditional: false,
		headers: {},
		*/

		accepts: {
			xml: "application/xml, text/xml",
			html: "text/html",
			text: "text/plain",
			json: "application/json, text/javascript",
			"*": allTypes
		},

		contents: {
			xml: /xml/,
			html: /html/,
			json: /json/
		},

		responseFields: {
			xml: "responseXML",
			text: "responseText"
		},

		// List of data converters
		// 1) key format is "source_type destination_type" (a single space in-between)
		// 2) the catchall symbol "*" can be used for source_type
		converters: {

			// Convert anything to text
			"* text": window.String,

			// Text to html (true = no transformation)
			"text html": true,

			// Evaluate text as a json expression
			"text json": jQuery.parseJSON,

			// Parse text as xml
			"text xml": jQuery.parseXML
		},

		// For options that shouldn't be deep extended:
		// you can add your own custom options here if
		// and when you create one that shouldn't be
		// deep extended (see ajaxExtend)
		flatOptions: {
			context: true,
			url: true
		}
	},

	ajaxPrefilter: addToPrefiltersOrTransports( prefilters ),
	ajaxTransport: addToPrefiltersOrTransports( transports ),

	// Main method
	ajax: function( url, options ) {

		// If url is an object, simulate pre-1.5 signature
		if ( typeof url === "object" ) {
			options = url;
			url = undefined;
		}

		// Force options to be an object
		options = options || {};

		var // Create the final options object
			s = jQuery.ajaxSetup( {}, options ),
			// Callbacks context
			callbackContext = s.context || s,
			// Context for global events
			// It's the callbackContext if one was provided in the options
			// and if it's a DOM node or a jQuery collection
			globalEventContext = callbackContext !== s &&
				( callbackContext.nodeType || callbackContext instanceof jQuery ) ?
						jQuery( callbackContext ) : jQuery.event,
			// Deferreds
			deferred = jQuery.Deferred(),
			completeDeferred = jQuery._Deferred(),
			// Status-dependent callbacks
			statusCode = s.statusCode || {},
			// ifModified key
			ifModifiedKey,
			// Headers (they are sent all at once)
			requestHeaders = {},
			requestHeadersNames = {},
			// Response headers
			responseHeadersString,
			responseHeaders,
			// transport
			transport,
			// timeout handle
			timeoutTimer,
			// Cross-domain detection vars
			parts,
			// The jqXHR state
			state = 0,
			// To know if global events are to be dispatched
			fireGlobals,
			// Loop variable
			i,
			// Fake xhr
			jqXHR = {

				readyState: 0,

				// Caches the header
				setRequestHeader: function( name, value ) {
					if ( !state ) {
						var lname = name.toLowerCase();
						name = requestHeadersNames[ lname ] = requestHeadersNames[ lname ] || name;
						requestHeaders[ name ] = value;
					}
					return this;
				},

				// Raw string
				getAllResponseHeaders: function() {
					return state === 2 ? responseHeadersString : null;
				},

				// Builds headers hashtable if needed
				getResponseHeader: function( key ) {
					var match;
					if ( state === 2 ) {
						if ( !responseHeaders ) {
							responseHeaders = {};
							while( ( match = rheaders.exec( responseHeadersString ) ) ) {
								responseHeaders[ match[1].toLowerCase() ] = match[ 2 ];
							}
						}
						match = responseHeaders[ key.toLowerCase() ];
					}
					return match === undefined ? null : match;
				},

				// Overrides response content-type header
				overrideMimeType: function( type ) {
					if ( !state ) {
						s.mimeType = type;
					}
					return this;
				},

				// Cancel the request
				abort: function( statusText ) {
					statusText = statusText || "abort";
					if ( transport ) {
						transport.abort( statusText );
					}
					done( 0, statusText );
					return this;
				}
			};

		// Callback for when everything is done
		// It is defined here because jslint complains if it is declared
		// at the end of the function (which would be more logical and readable)
		function done( status, nativeStatusText, responses, headers ) {

			// Called once
			if ( state === 2 ) {
				return;
			}

			// State is "done" now
			state = 2;

			// Clear timeout if it exists
			if ( timeoutTimer ) {
				clearTimeout( timeoutTimer );
			}

			// Dereference transport for early garbage collection
			// (no matter how long the jqXHR object will be used)
			transport = undefined;

			// Cache response headers
			responseHeadersString = headers || "";

			// Set readyState
			jqXHR.readyState = status > 0 ? 4 : 0;

			var isSuccess,
				success,
				error,
				statusText = nativeStatusText,
				response = responses ? ajaxHandleResponses( s, jqXHR, responses ) : undefined,
				lastModified,
				etag;

			// If successful, handle type chaining
			if ( status >= 200 && status < 300 || status === 304 ) {

				// Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.
				if ( s.ifModified ) {

					if ( ( lastModified = jqXHR.getResponseHeader( "Last-Modified" ) ) ) {
						jQuery.lastModified[ ifModifiedKey ] = lastModified;
					}
					if ( ( etag = jqXHR.getResponseHeader( "Etag" ) ) ) {
						jQuery.etag[ ifModifiedKey ] = etag;
					}
				}

				// If not modified
				if ( status === 304 ) {

					statusText = "notmodified";
					isSuccess = true;

				// If we have data
				} else {

					try {
						success = ajaxConvert( s, response );
						statusText = "success";
						isSuccess = true;
					} catch(e) {
						// We have a parsererror
						statusText = "parsererror";
						error = e;
					}
				}
			} else {
				// We extract error from statusText
				// then normalize statusText and status for non-aborts
				error = statusText;
				if( !statusText || status ) {
					statusText = "error";
					if ( status < 0 ) {
						status = 0;
					}
				}
			}

			// Set data for the fake xhr object
			jqXHR.status = status;
			jqXHR.statusText = "" + ( nativeStatusText || statusText );

			// Success/Error
			if ( isSuccess ) {
				deferred.resolveWith( callbackContext, [ success, statusText, jqXHR ] );
			} else {
				deferred.rejectWith( callbackContext, [ jqXHR, statusText, error ] );
			}

			// Status-dependent callbacks
			jqXHR.statusCode( statusCode );
			statusCode = undefined;

			if ( fireGlobals ) {
				globalEventContext.trigger( "ajax" + ( isSuccess ? "Success" : "Error" ),
						[ jqXHR, s, isSuccess ? success : error ] );
			}

			// Complete
			completeDeferred.resolveWith( callbackContext, [ jqXHR, statusText ] );

			if ( fireGlobals ) {
				globalEventContext.trigger( "ajaxComplete", [ jqXHR, s ] );
				// Handle the global AJAX counter
				if ( !( --jQuery.active ) ) {
					jQuery.event.trigger( "ajaxStop" );
				}
			}
		}

		// Attach deferreds
		deferred.promise( jqXHR );
		jqXHR.success = jqXHR.done;
		jqXHR.error = jqXHR.fail;
		jqXHR.complete = completeDeferred.done;

		// Status-dependent callbacks
		jqXHR.statusCode = function( map ) {
			if ( map ) {
				var tmp;
				if ( state < 2 ) {
					for( tmp in map ) {
						statusCode[ tmp ] = [ statusCode[tmp], map[tmp] ];
					}
				} else {
					tmp = map[ jqXHR.status ];
					jqXHR.then( tmp, tmp );
				}
			}
			return this;
		};

		// Remove hash character (#7531: and string promotion)
		// Add protocol if not provided (#5866: IE7 issue with protocol-less urls)
		// We also use the url parameter if available
		s.url = ( ( url || s.url ) + "" ).replace( rhash, "" ).replace( rprotocol, ajaxLocParts[ 1 ] + "//" );

		// Extract dataTypes list
		s.dataTypes = jQuery.trim( s.dataType || "*" ).toLowerCase().split( rspacesAjax );

		// Determine if a cross-domain request is in order
		if ( s.crossDomain == null ) {
			parts = rurl.exec( s.url.toLowerCase() );
			s.crossDomain = !!( parts &&
				( parts[ 1 ] != ajaxLocParts[ 1 ] || parts[ 2 ] != ajaxLocParts[ 2 ] ||
					( parts[ 3 ] || ( parts[ 1 ] === "http:" ? 80 : 443 ) ) !=
						( ajaxLocParts[ 3 ] || ( ajaxLocParts[ 1 ] === "http:" ? 80 : 443 ) ) )
			);
		}

		// Convert data if not already a string
		if ( s.data && s.processData && typeof s.data !== "string" ) {
			s.data = jQuery.param( s.data, s.traditional );
		}

		// Apply prefilters
		inspectPrefiltersOrTransports( prefilters, s, options, jqXHR );

		// If request was aborted inside a prefiler, stop there
		if ( state === 2 ) {
			return false;
		}

		// We can fire global events as of now if asked to
		fireGlobals = s.global;

		// Uppercase the type
		s.type = s.type.toUpperCase();

		// Determine if request has content
		s.hasContent = !rnoContent.test( s.type );

		// Watch for a new set of requests
		if ( fireGlobals && jQuery.active++ === 0 ) {
			jQuery.event.trigger( "ajaxStart" );
		}

		// More options handling for requests with no content
		if ( !s.hasContent ) {

			// If data is available, append data to url
			if ( s.data ) {
				s.url += ( rquery.test( s.url ) ? "&" : "?" ) + s.data;
				// #9682: remove data so that it's not used in an eventual retry
				delete s.data;
			}

			// Get ifModifiedKey before adding the anti-cache parameter
			ifModifiedKey = s.url;

			// Add anti-cache in url if needed
			if ( s.cache === false ) {

				var ts = jQuery.now(),
					// try replacing _= if it is there
					ret = s.url.replace( rts, "$1_=" + ts );

				// if nothing was replaced, add timestamp to the end
				s.url = ret + ( (ret === s.url ) ? ( rquery.test( s.url ) ? "&" : "?" ) + "_=" + ts : "" );
			}
		}

		// Set the correct header, if data is being sent
		if ( s.data && s.hasContent && s.contentType !== false || options.contentType ) {
			jqXHR.setRequestHeader( "Content-Type", s.contentType );
		}

		// Set the If-Modified-Since and/or If-None-Match header, if in ifModified mode.
		if ( s.ifModified ) {
			ifModifiedKey = ifModifiedKey || s.url;
			if ( jQuery.lastModified[ ifModifiedKey ] ) {
				jqXHR.setRequestHeader( "If-Modified-Since", jQuery.lastModified[ ifModifiedKey ] );
			}
			if ( jQuery.etag[ ifModifiedKey ] ) {
				jqXHR.setRequestHeader( "If-None-Match", jQuery.etag[ ifModifiedKey ] );
			}
		}

		// Set the Accepts header for the server, depending on the dataType
		jqXHR.setRequestHeader(
			"Accept",
			s.dataTypes[ 0 ] && s.accepts[ s.dataTypes[0] ] ?
				s.accepts[ s.dataTypes[0] ] + ( s.dataTypes[ 0 ] !== "*" ? ", " + allTypes + "; q=0.01" : "" ) :
				s.accepts[ "*" ]
		);

		// Check for headers option
		for ( i in s.headers ) {
			jqXHR.setRequestHeader( i, s.headers[ i ] );
		}

		// Allow custom headers/mimetypes and early abort
		if ( s.beforeSend && ( s.beforeSend.call( callbackContext, jqXHR, s ) === false || state === 2 ) ) {
				// Abort if not done already
				jqXHR.abort();
				return false;

		}

		// Install callbacks on deferreds
		for ( i in { success: 1, error: 1, complete: 1 } ) {
			jqXHR[ i ]( s[ i ] );
		}

		// Get transport
		transport = inspectPrefiltersOrTransports( transports, s, options, jqXHR );

		// If no transport, we auto-abort
		if ( !transport ) {
			done( -1, "No Transport" );
		} else {
			jqXHR.readyState = 1;
			// Send global event
			if ( fireGlobals ) {
				globalEventContext.trigger( "ajaxSend", [ jqXHR, s ] );
			}
			// Timeout
			if ( s.async && s.timeout > 0 ) {
				timeoutTimer = setTimeout( function(){
					jqXHR.abort( "timeout" );
				}, s.timeout );
			}

			try {
				state = 1;
				transport.send( requestHeaders, done );
			} catch (e) {
				// Propagate exception as error if not done
				if ( state < 2 ) {
					done( -1, e );
				// Simply rethrow otherwise
				} else {
					jQuery.error( e );
				}
			}
		}

		return jqXHR;
	},

	// Serialize an array of form elements or a set of
	// key/values into a query string
	param: function( a, traditional ) {
		var s = [],
			add = function( key, value ) {
				// If value is a function, invoke it and return its value
				value = jQuery.isFunction( value ) ? value() : value;
				s[ s.length ] = encodeURIComponent( key ) + "=" + encodeURIComponent( value );
			};

		// Set traditional to true for jQuery <= 1.3.2 behavior.
		if ( traditional === undefined ) {
			traditional = jQuery.ajaxSettings.traditional;
		}

		// If an array was passed in, assume that it is an array of form elements.
		if ( jQuery.isArray( a ) || ( a.jquery && !jQuery.isPlainObject( a ) ) ) {
			// Serialize the form elements
			jQuery.each( a, function() {
				add( this.name, this.value );
			});

		} else {
			// If traditional, encode the "old" way (the way 1.3.2 or older
			// did it), otherwise encode params recursively.
			for ( var prefix in a ) {
				buildParams( prefix, a[ prefix ], traditional, add );
			}
		}

		// Return the resulting serialization
		return s.join( "&" ).replace( r20, "+" );
	}
});

function buildParams( prefix, obj, traditional, add ) {
	if ( jQuery.isArray( obj ) ) {
		// Serialize array item.
		jQuery.each( obj, function( i, v ) {
			if ( traditional || rbracket.test( prefix ) ) {
				// Treat each array item as a scalar.
				add( prefix, v );

			} else {
				// If array item is non-scalar (array or object), encode its
				// numeric index to resolve deserialization ambiguity issues.
				// Note that rack (as of 1.0.0) can't currently deserialize
				// nested arrays properly, and attempting to do so may cause
				// a server error. Possible fixes are to modify rack's
				// deserialization algorithm or to provide an option or flag
				// to force array serialization to be shallow.
				buildParams( prefix + "[" + ( typeof v === "object" || jQuery.isArray(v) ? i : "" ) + "]", v, traditional, add );
			}
		});

	} else if ( !traditional && obj != null && typeof obj === "object" ) {
		// Serialize object item.
		for ( var name in obj ) {
			buildParams( prefix + "[" + name + "]", obj[ name ], traditional, add );
		}

	} else {
		// Serialize scalar item.
		add( prefix, obj );
	}
}

// This is still on the jQuery object... for now
// Want to move this to jQuery.ajax some day
jQuery.extend({

	// Counter for holding the number of active queries
	active: 0,

	// Last-Modified header cache for next request
	lastModified: {},
	etag: {}

});

/* Handles responses to an ajax request:
 * - sets all responseXXX fields accordingly
 * - finds the right dataType (mediates between content-type and expected dataType)
 * - returns the corresponding response
 */
function ajaxHandleResponses( s, jqXHR, responses ) {

	var contents = s.contents,
		dataTypes = s.dataTypes,
		responseFields = s.responseFields,
		ct,
		type,
		finalDataType,
		firstDataType;

	// Fill responseXXX fields
	for( type in responseFields ) {
		if ( type in responses ) {
			jqXHR[ responseFields[type] ] = responses[ type ];
		}
	}

	// Remove auto dataType and get content-type in the process
	while( dataTypes[ 0 ] === "*" ) {
		dataTypes.shift();
		if ( ct === undefined ) {
			ct = s.mimeType || jqXHR.getResponseHeader( "content-type" );
		}
	}

	// Check if we're dealing with a known content-type
	if ( ct ) {
		for ( type in contents ) {
			if ( contents[ type ] && contents[ type ].test( ct ) ) {
				dataTypes.unshift( type );
				break;
			}
		}
	}

	// Check to see if we have a response for the expected dataType
	if ( dataTypes[ 0 ] in responses ) {
		finalDataType = dataTypes[ 0 ];
	} else {
		// Try convertible dataTypes
		for ( type in responses ) {
			if ( !dataTypes[ 0 ] || s.converters[ type + " " + dataTypes[0] ] ) {
				finalDataType = type;
				break;
			}
			if ( !firstDataType ) {
				firstDataType = type;
			}
		}
		// Or just use first one
		finalDataType = finalDataType || firstDataType;
	}

	// If we found a dataType
	// We add the dataType to the list if needed
	// and return the corresponding response
	if ( finalDataType ) {
		if ( finalDataType !== dataTypes[ 0 ] ) {
			dataTypes.unshift( finalDataType );
		}
		return responses[ finalDataType ];
	}
}

// Chain conversions given the request and the original response
function ajaxConvert( s, response ) {

	// Apply the dataFilter if provided
	if ( s.dataFilter ) {
		response = s.dataFilter( response, s.dataType );
	}

	var dataTypes = s.dataTypes,
		converters = {},
		i,
		key,
		length = dataTypes.length,
		tmp,
		// Current and previous dataTypes
		current = dataTypes[ 0 ],
		prev,
		// Conversion expression
		conversion,
		// Conversion function
		conv,
		// Conversion functions (transitive conversion)
		conv1,
		conv2;

	// For each dataType in the chain
	for( i = 1; i < length; i++ ) {

		// Create converters map
		// with lowercased keys
		if ( i === 1 ) {
			for( key in s.converters ) {
				if( typeof key === "string" ) {
					converters[ key.toLowerCase() ] = s.converters[ key ];
				}
			}
		}

		// Get the dataTypes
		prev = current;
		current = dataTypes[ i ];

		// If current is auto dataType, update it to prev
		if( current === "*" ) {
			current = prev;
		// If no auto and dataTypes are actually different
		} else if ( prev !== "*" && prev !== current ) {

			// Get the converter
			conversion = prev + " " + current;
			conv = converters[ conversion ] || converters[ "* " + current ];

			// If there is no direct converter, search transitively
			if ( !conv ) {
				conv2 = undefined;
				for( conv1 in converters ) {
					tmp = conv1.split( " " );
					if ( tmp[ 0 ] === prev || tmp[ 0 ] === "*" ) {
						conv2 = converters[ tmp[1] + " " + current ];
						if ( conv2 ) {
							conv1 = converters[ conv1 ];
							if ( conv1 === true ) {
								conv = conv2;
							} else if ( conv2 === true ) {
								conv = conv1;
							}
							break;
						}
					}
				}
			}
			// If we found no converter, dispatch an error
			if ( !( conv || conv2 ) ) {
				jQuery.error( "No conversion from " + conversion.replace(" "," to ") );
			}
			// If found converter is not an equivalence
			if ( conv !== true ) {
				// Convert with 1 or 2 converters accordingly
				response = conv ? conv( response ) : conv2( conv1(response) );
			}
		}
	}
	return response;
}




var jsc = jQuery.now(),
	jsre = /(\=)\?(&|$)|\?\?/i;

// Default jsonp settings
jQuery.ajaxSetup({
	jsonp: "callback",
	jsonpCallback: function() {
		return jQuery.expando + "_" + ( jsc++ );
	}
});

// Detect, normalize options and install callbacks for jsonp requests
jQuery.ajaxPrefilter( "json jsonp", function( s, originalSettings, jqXHR ) {

	var inspectData = s.contentType === "application/x-www-form-urlencoded" &&
		( typeof s.data === "string" );

	if ( s.dataTypes[ 0 ] === "jsonp" ||
		s.jsonp !== false && ( jsre.test( s.url ) ||
				inspectData && jsre.test( s.data ) ) ) {

		var responseContainer,
			jsonpCallback = s.jsonpCallback =
				jQuery.isFunction( s.jsonpCallback ) ? s.jsonpCallback() : s.jsonpCallback,
			previous = window[ jsonpCallback ],
			url = s.url,
			data = s.data,
			replace = "$1" + jsonpCallback + "$2";

		if ( s.jsonp !== false ) {
			url = url.replace( jsre, replace );
			if ( s.url === url ) {
				if ( inspectData ) {
					data = data.replace( jsre, replace );
				}
				if ( s.data === data ) {
					// Add callback manually
					url += (/\?/.test( url ) ? "&" : "?") + s.jsonp + "=" + jsonpCallback;
				}
			}
		}

		s.url = url;
		s.data = data;

		// Install callback
		window[ jsonpCallback ] = function( response ) {
			responseContainer = [ response ];
		};

		// Clean-up function
		jqXHR.always(function() {
			// Set callback back to previous value
			window[ jsonpCallback ] = previous;
			// Call if it was a function and we have a response
			if ( responseContainer && jQuery.isFunction( previous ) ) {
				window[ jsonpCallback ]( responseContainer[ 0 ] );
			}
		});

		// Use data converter to retrieve json after script execution
		s.converters["script json"] = function() {
			if ( !responseContainer ) {
				jQuery.error( jsonpCallback + " was not called" );
			}
			return responseContainer[ 0 ];
		};

		// force json dataType
		s.dataTypes[ 0 ] = "json";

		// Delegate to script
		return "script";
	}
});




// Install script dataType
jQuery.ajaxSetup({
	accepts: {
		script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
	},
	contents: {
		script: /javascript|ecmascript/
	},
	converters: {
		"text script": function( text ) {
			jQuery.globalEval( text );
			return text;
		}
	}
});

// Handle cache's special case and global
jQuery.ajaxPrefilter( "script", function( s ) {
	if ( s.cache === undefined ) {
		s.cache = false;
	}
	if ( s.crossDomain ) {
		s.type = "GET";
		s.global = false;
	}
});

// Bind script tag hack transport
jQuery.ajaxTransport( "script", function(s) {

	// This transport only deals with cross domain requests
	if ( s.crossDomain ) {

		var script,
			head = document.head || document.getElementsByTagName( "head" )[0] || document.documentElement;

		return {

			send: function( _, callback ) {

				script = document.createElement( "script" );

				script.async = "async";

				if ( s.scriptCharset ) {
					script.charset = s.scriptCharset;
				}

				script.src = s.url;

				// Attach handlers for all browsers
				script.onload = script.onreadystatechange = function( _, isAbort ) {

					if ( isAbort || !script.readyState || /loaded|complete/.test( script.readyState ) ) {

						// Handle memory leak in IE
						script.onload = script.onreadystatechange = null;

						// Remove the script
						if ( head && script.parentNode ) {
							head.removeChild( script );
						}

						// Dereference the script
						script = undefined;

						// Callback if not abort
						if ( !isAbort ) {
							callback( 200, "success" );
						}
					}
				};
				// Use insertBefore instead of appendChild  to circumvent an IE6 bug.
				// This arises when a base node is used (#2709 and #4378).
				head.insertBefore( script, head.firstChild );
			},

			abort: function() {
				if ( script ) {
					script.onload( 0, 1 );
				}
			}
		};
	}
});




var // #5280: Internet Explorer will keep connections alive if we don't abort on unload
	xhrOnUnloadAbort = window.ActiveXObject ? function() {
		// Abort all pending requests
		for ( var key in xhrCallbacks ) {
			xhrCallbacks[ key ]( 0, 1 );
		}
	} : false,
	xhrId = 0,
	xhrCallbacks;

// Functions to create xhrs
function createStandardXHR() {
	try {
		return new window.XMLHttpRequest();
	} catch( e ) {}
}

function createActiveXHR() {
	try {
		return new window.ActiveXObject( "Microsoft.XMLHTTP" );
	} catch( e ) {}
}

// Create the request object
// (This is still attached to ajaxSettings for backward compatibility)
jQuery.ajaxSettings.xhr = window.ActiveXObject ?
	/* Microsoft failed to properly
	 * implement the XMLHttpRequest in IE7 (can't request local files),
	 * so we use the ActiveXObject when it is available
	 * Additionally XMLHttpRequest can be disabled in IE7/IE8 so
	 * we need a fallback.
	 */
	function() {
		return !this.isLocal && createStandardXHR() || createActiveXHR();
	} :
	// For all other browsers, use the standard XMLHttpRequest object
	createStandardXHR;

// Determine support properties
(function( xhr ) {
	jQuery.extend( jQuery.support, {
		ajax: !!xhr,
		cors: !!xhr && ( "withCredentials" in xhr )
	});
})( jQuery.ajaxSettings.xhr() );

// Create transport if the browser can provide an xhr
if ( jQuery.support.ajax ) {

	jQuery.ajaxTransport(function( s ) {
		// Cross domain only allowed if supported through XMLHttpRequest
		if ( !s.crossDomain || jQuery.support.cors ) {

			var callback;

			return {
				send: function( headers, complete ) {

					// Get a new xhr
					var xhr = s.xhr(),
						handle,
						i;

					// Open the socket
					// Passing null username, generates a login popup on Opera (#2865)
					if ( s.username ) {
						xhr.open( s.type, s.url, s.async, s.username, s.password );
					} else {
						xhr.open( s.type, s.url, s.async );
					}

					// Apply custom fields if provided
					if ( s.xhrFields ) {
						for ( i in s.xhrFields ) {
							xhr[ i ] = s.xhrFields[ i ];
						}
					}

					// Override mime type if needed
					if ( s.mimeType && xhr.overrideMimeType ) {
						xhr.overrideMimeType( s.mimeType );
					}

					// X-Requested-With header
					// For cross-domain requests, seeing as conditions for a preflight are
					// akin to a jigsaw puzzle, we simply never set it to be sure.
					// (it can always be set on a per-request basis or even using ajaxSetup)
					// For same-domain requests, won't change header if already provided.
					if ( !s.crossDomain && !headers["X-Requested-With"] ) {
						headers[ "X-Requested-With" ] = "XMLHttpRequest";
					}

					// Need an extra try/catch for cross domain requests in Firefox 3
					try {
						for ( i in headers ) {
							xhr.setRequestHeader( i, headers[ i ] );
						}
					} catch( _ ) {}

					// Do send the request
					// This may raise an exception which is actually
					// handled in jQuery.ajax (so no try/catch here)
					xhr.send( ( s.hasContent && s.data ) || null );

					// Listener
					callback = function( _, isAbort ) {

						var status,
							statusText,
							responseHeaders,
							responses,
							xml;

						// Firefox throws exceptions when accessing properties
						// of an xhr when a network error occured
						// http://helpful.knobs-dials.com/index.php/Component_returned_failure_code:_0x80040111_(NS_ERROR_NOT_AVAILABLE)
						try {

							// Was never called and is aborted or complete
							if ( callback && ( isAbort || xhr.readyState === 4 ) ) {

								// Only called once
								callback = undefined;

								// Do not keep as active anymore
								if ( handle ) {
									xhr.onreadystatechange = jQuery.noop;
									if ( xhrOnUnloadAbort ) {
										delete xhrCallbacks[ handle ];
									}
								}

								// If it's an abort
								if ( isAbort ) {
									// Abort it manually if needed
									if ( xhr.readyState !== 4 ) {
										xhr.abort();
									}
								} else {
									status = xhr.status;
									responseHeaders = xhr.getAllResponseHeaders();
									responses = {};
									xml = xhr.responseXML;

									// Construct response list
									if ( xml && xml.documentElement /* #4958 */ ) {
										responses.xml = xml;
									}
									responses.text = xhr.responseText;

									// Firefox throws an exception when accessing
									// statusText for faulty cross-domain requests
									try {
										statusText = xhr.statusText;
									} catch( e ) {
										// We normalize with Webkit giving an empty statusText
										statusText = "";
									}

									// Filter status for non standard behaviors

									// If the request is local and we have data: assume a success
									// (success with no data won't get notified, that's the best we
									// can do given current implementations)
									if ( !status && s.isLocal && !s.crossDomain ) {
										status = responses.text ? 200 : 404;
									// IE - #1450: sometimes returns 1223 when it should be 204
									} else if ( status === 1223 ) {
										status = 204;
									}
								}
							}
						} catch( firefoxAccessException ) {
							if ( !isAbort ) {
								complete( -1, firefoxAccessException );
							}
						}

						// Call complete if needed
						if ( responses ) {
							complete( status, statusText, responses, responseHeaders );
						}
					};

					// if we're in sync mode or it's in cache
					// and has been retrieved directly (IE6 & IE7)
					// we need to manually fire the callback
					if ( !s.async || xhr.readyState === 4 ) {
						callback();
					} else {
						handle = ++xhrId;
						if ( xhrOnUnloadAbort ) {
							// Create the active xhrs callbacks list if needed
							// and attach the unload handler
							if ( !xhrCallbacks ) {
								xhrCallbacks = {};
								jQuery( window ).unload( xhrOnUnloadAbort );
							}
							// Add to list of active xhrs callbacks
							xhrCallbacks[ handle ] = callback;
						}
						xhr.onreadystatechange = callback;
					}
				},

				abort: function() {
					if ( callback ) {
						callback(0,1);
					}
				}
			};
		}
	});
}




var elemdisplay = {},
	iframe, iframeDoc,
	rfxtypes = /^(?:toggle|show|hide)$/,
	rfxnum = /^([+\-]=)?([\d+.\-]+)([a-z%]*)$/i,
	timerId,
	fxAttrs = [
		// height animations
		[ "height", "marginTop", "marginBottom", "paddingTop", "paddingBottom" ],
		// width animations
		[ "width", "marginLeft", "marginRight", "paddingLeft", "paddingRight" ],
		// opacity animations
		[ "opacity" ]
	],
	fxNow;

jQuery.fn.extend({
	show: function( speed, easing, callback ) {
		var elem, display;

		if ( speed || speed === 0 ) {
			return this.animate( genFx("show", 3), speed, easing, callback);

		} else {
			for ( var i = 0, j = this.length; i < j; i++ ) {
				elem = this[i];

				if ( elem.style ) {
					display = elem.style.display;

					// Reset the inline display of this element to learn if it is
					// being hidden by cascaded rules or not
					if ( !jQuery._data(elem, "olddisplay") && display === "none" ) {
						display = elem.style.display = "";
					}

					// Set elements which have been overridden with display: none
					// in a stylesheet to whatever the default browser style is
					// for such an element
					if ( display === "" && jQuery.css( elem, "display" ) === "none" ) {
						jQuery._data(elem, "olddisplay", defaultDisplay(elem.nodeName));
					}
				}
			}

			// Set the display of most of the elements in a second loop
			// to avoid the constant reflow
			for ( i = 0; i < j; i++ ) {
				elem = this[i];

				if ( elem.style ) {
					display = elem.style.display;

					if ( display === "" || display === "none" ) {
						elem.style.display = jQuery._data(elem, "olddisplay") || "";
					}
				}
			}

			return this;
		}
	},

	hide: function( speed, easing, callback ) {
		if ( speed || speed === 0 ) {
			return this.animate( genFx("hide", 3), speed, easing, callback);

		} else {
			for ( var i = 0, j = this.length; i < j; i++ ) {
				if ( this[i].style ) {
					var display = jQuery.css( this[i], "display" );

					if ( display !== "none" && !jQuery._data( this[i], "olddisplay" ) ) {
						jQuery._data( this[i], "olddisplay", display );
					}
				}
			}

			// Set the display of the elements in a second loop
			// to avoid the constant reflow
			for ( i = 0; i < j; i++ ) {
				if ( this[i].style ) {
					this[i].style.display = "none";
				}
			}

			return this;
		}
	},

	// Save the old toggle function
	_toggle: jQuery.fn.toggle,

	toggle: function( fn, fn2, callback ) {
		var bool = typeof fn === "boolean";

		if ( jQuery.isFunction(fn) && jQuery.isFunction(fn2) ) {
			this._toggle.apply( this, arguments );

		} else if ( fn == null || bool ) {
			this.each(function() {
				var state = bool ? fn : jQuery(this).is(":hidden");
				jQuery(this)[ state ? "show" : "hide" ]();
			});

		} else {
			this.animate(genFx("toggle", 3), fn, fn2, callback);
		}

		return this;
	},

	fadeTo: function( speed, to, easing, callback ) {
		return this.filter(":hidden").css("opacity", 0).show().end()
					.animate({opacity: to}, speed, easing, callback);
	},

	animate: function( prop, speed, easing, callback ) {
		var optall = jQuery.speed(speed, easing, callback);

		if ( jQuery.isEmptyObject( prop ) ) {
			return this.each( optall.complete, [ false ] );
		}

		// Do not change referenced properties as per-property easing will be lost
		prop = jQuery.extend( {}, prop );

		return this[ optall.queue === false ? "each" : "queue" ](function() {
			// XXX 'this' does not always have a nodeName when running the
			// test suite

			if ( optall.queue === false ) {
				jQuery._mark( this );
			}

			var opt = jQuery.extend( {}, optall ),
				isElement = this.nodeType === 1,
				hidden = isElement && jQuery(this).is(":hidden"),
				name, val, p,
				display, e,
				parts, start, end, unit;

			// will store per property easing and be used to determine when an animation is complete
			opt.animatedProperties = {};

			for ( p in prop ) {

				// property name normalization
				name = jQuery.camelCase( p );
				if ( p !== name ) {
					prop[ name ] = prop[ p ];
					delete prop[ p ];
				}

				val = prop[ name ];

				// easing resolution: per property > opt.specialEasing > opt.easing > 'swing' (default)
				if ( jQuery.isArray( val ) ) {
					opt.animatedProperties[ name ] = val[ 1 ];
					val = prop[ name ] = val[ 0 ];
				} else {
					opt.animatedProperties[ name ] = opt.specialEasing && opt.specialEasing[ name ] || opt.easing || 'swing';
				}

				if ( val === "hide" && hidden || val === "show" && !hidden ) {
					return opt.complete.call( this );
				}

				if ( isElement && ( name === "height" || name === "width" ) ) {
					// Make sure that nothing sneaks out
					// Record all 3 overflow attributes because IE does not
					// change the overflow attribute when overflowX and
					// overflowY are set to the same value
					opt.overflow = [ this.style.overflow, this.style.overflowX, this.style.overflowY ];

					// Set display property to inline-block for height/width
					// animations on inline elements that are having width/height
					// animated
					if ( jQuery.css( this, "display" ) === "inline" &&
							jQuery.css( this, "float" ) === "none" ) {
						if ( !jQuery.support.inlineBlockNeedsLayout ) {
							this.style.display = "inline-block";

						} else {
							display = defaultDisplay( this.nodeName );

							// inline-level elements accept inline-block;
							// block-level elements need to be inline with layout
							if ( display === "inline" ) {
								this.style.display = "inline-block";

							} else {
								this.style.display = "inline";
								this.style.zoom = 1;
							}
						}
					}
				}
			}

			if ( opt.overflow != null ) {
				this.style.overflow = "hidden";
			}

			for ( p in prop ) {
				e = new jQuery.fx( this, opt, p );
				val = prop[ p ];

				if ( rfxtypes.test(val) ) {
					e[ val === "toggle" ? hidden ? "show" : "hide" : val ]();

				} else {
					parts = rfxnum.exec( val );
					start = e.cur();

					if ( parts ) {
						end = parseFloat( parts[2] );
						unit = parts[3] || ( jQuery.cssNumber[ p ] ? "" : "px" );

						// We need to compute starting value
						if ( unit !== "px" ) {
							jQuery.style( this, p, (end || 1) + unit);
							start = ((end || 1) / e.cur()) * start;
							jQuery.style( this, p, start + unit);
						}

						// If a +=/-= token was provided, we're doing a relative animation
						if ( parts[1] ) {
							end = ( (parts[ 1 ] === "-=" ? -1 : 1) * end ) + start;
						}

						e.custom( start, end, unit );

					} else {
						e.custom( start, val, "" );
					}
				}
			}

			// For JS strict compliance
			return true;
		});
	},

	stop: function( clearQueue, gotoEnd ) {
		if ( clearQueue ) {
			this.queue([]);
		}

		this.each(function() {
			var timers = jQuery.timers,
				i = timers.length;
			// clear marker counters if we know they won't be
			if ( !gotoEnd ) {
				jQuery._unmark( true, this );
			}
			while ( i-- ) {
				if ( timers[i].elem === this ) {
					if (gotoEnd) {
						// force the next step to be the last
						timers[i](true);
					}

					timers.splice(i, 1);
				}
			}
		});

		// start the next in the queue if the last step wasn't forced
		if ( !gotoEnd ) {
			this.dequeue();
		}

		return this;
	}

});

// Animations created synchronously will run synchronously
function createFxNow() {
	setTimeout( clearFxNow, 0 );
	return ( fxNow = jQuery.now() );
}

function clearFxNow() {
	fxNow = undefined;
}

// Generate parameters to create a standard animation
function genFx( type, num ) {
	var obj = {};

	jQuery.each( fxAttrs.concat.apply([], fxAttrs.slice(0,num)), function() {
		obj[ this ] = type;
	});

	return obj;
}

// Generate shortcuts for custom animations
jQuery.each({
	slideDown: genFx("show", 1),
	slideUp: genFx("hide", 1),
	slideToggle: genFx("toggle", 1),
	fadeIn: { opacity: "show" },
	fadeOut: { opacity: "hide" },
	fadeToggle: { opacity: "toggle" }
}, function( name, props ) {
	jQuery.fn[ name ] = function( speed, easing, callback ) {
		return this.animate( props, speed, easing, callback );
	};
});

jQuery.extend({
	speed: function( speed, easing, fn ) {
		var opt = speed && typeof speed === "object" ? jQuery.extend({}, speed) : {
			complete: fn || !fn && easing ||
				jQuery.isFunction( speed ) && speed,
			duration: speed,
			easing: fn && easing || easing && !jQuery.isFunction(easing) && easing
		};

		opt.duration = jQuery.fx.off ? 0 : typeof opt.duration === "number" ? opt.duration :
			opt.duration in jQuery.fx.speeds ? jQuery.fx.speeds[opt.duration] : jQuery.fx.speeds._default;

		// Queueing
		opt.old = opt.complete;
		opt.complete = function( noUnmark ) {
			if ( jQuery.isFunction( opt.old ) ) {
				opt.old.call( this );
			}

			if ( opt.queue !== false ) {
				jQuery.dequeue( this );
			} else if ( noUnmark !== false ) {
				jQuery._unmark( this );
			}
		};

		return opt;
	},

	easing: {
		linear: function( p, n, firstNum, diff ) {
			return firstNum + diff * p;
		},
		swing: function( p, n, firstNum, diff ) {
			return ((-Math.cos(p*Math.PI)/2) + 0.5) * diff + firstNum;
		}
	},

	timers: [],

	fx: function( elem, options, prop ) {
		this.options = options;
		this.elem = elem;
		this.prop = prop;

		options.orig = options.orig || {};
	}

});

jQuery.fx.prototype = {
	// Simple function for setting a style value
	update: function() {
		if ( this.options.step ) {
			this.options.step.call( this.elem, this.now, this );
		}

		(jQuery.fx.step[this.prop] || jQuery.fx.step._default)( this );
	},

	// Get the current size
	cur: function() {
		if ( this.elem[this.prop] != null && (!this.elem.style || this.elem.style[this.prop] == null) ) {
			return this.elem[ this.prop ];
		}

		var parsed,
			r = jQuery.css( this.elem, this.prop );
		// Empty strings, null, undefined and "auto" are converted to 0,
		// complex values such as "rotate(1rad)" are returned as is,
		// simple values such as "10px" are parsed to Float.
		return isNaN( parsed = parseFloat( r ) ) ? !r || r === "auto" ? 0 : r : parsed;
	},

	// Start an animation from one number to another
	custom: function( from, to, unit ) {
		var self = this,
			fx = jQuery.fx;

		this.startTime = fxNow || createFxNow();
		this.start = from;
		this.end = to;
		this.unit = unit || this.unit || ( jQuery.cssNumber[ this.prop ] ? "" : "px" );
		this.now = this.start;
		this.pos = this.state = 0;

		function t( gotoEnd ) {
			return self.step(gotoEnd);
		}

		t.elem = this.elem;

		if ( t() && jQuery.timers.push(t) && !timerId ) {
			timerId = setInterval( fx.tick, fx.interval );
		}
	},

	// Simple 'show' function
	show: function() {
		// Remember where we started, so that we can go back to it later
		this.options.orig[this.prop] = jQuery.style( this.elem, this.prop );
		this.options.show = true;

		// Begin the animation
		// Make sure that we start at a small width/height to avoid any
		// flash of content
		this.custom(this.prop === "width" || this.prop === "height" ? 1 : 0, this.cur());

		// Start by showing the element
		jQuery( this.elem ).show();
	},

	// Simple 'hide' function
	hide: function() {
		// Remember where we started, so that we can go back to it later
		this.options.orig[this.prop] = jQuery.style( this.elem, this.prop );
		this.options.hide = true;

		// Begin the animation
		this.custom(this.cur(), 0);
	},

	// Each step of an animation
	step: function( gotoEnd ) {
		var t = fxNow || createFxNow(),
			done = true,
			elem = this.elem,
			options = this.options,
			i, n;

		if ( gotoEnd || t >= options.duration + this.startTime ) {
			this.now = this.end;
			this.pos = this.state = 1;
			this.update();

			options.animatedProperties[ this.prop ] = true;

			for ( i in options.animatedProperties ) {
				if ( options.animatedProperties[i] !== true ) {
					done = false;
				}
			}

			if ( done ) {
				// Reset the overflow
				if ( options.overflow != null && !jQuery.support.shrinkWrapBlocks ) {

					jQuery.each( [ "", "X", "Y" ], function (index, value) {
						elem.style[ "overflow" + value ] = options.overflow[index];
					});
				}

				// Hide the element if the "hide" operation was done
				if ( options.hide ) {
					jQuery(elem).hide();
				}

				// Reset the properties, if the item has been hidden or shown
				if ( options.hide || options.show ) {
					for ( var p in options.animatedProperties ) {
						jQuery.style( elem, p, options.orig[p] );
					}
				}

				// Execute the complete function
				options.complete.call( elem );
			}

			return false;

		} else {
			// classical easing cannot be used with an Infinity duration
			if ( options.duration == Infinity ) {
				this.now = t;
			} else {
				n = t - this.startTime;
				this.state = n / options.duration;

				// Perform the easing function, defaults to swing
				this.pos = jQuery.easing[ options.animatedProperties[ this.prop ] ]( this.state, n, 0, 1, options.duration );
				this.now = this.start + ((this.end - this.start) * this.pos);
			}
			// Perform the next step of the animation
			this.update();
		}

		return true;
	}
};

jQuery.extend( jQuery.fx, {
	tick: function() {
		for ( var timers = jQuery.timers, i = 0 ; i < timers.length ; ++i ) {
			if ( !timers[i]() ) {
				timers.splice(i--, 1);
			}
		}

		if ( !timers.length ) {
			jQuery.fx.stop();
		}
	},

	interval: 13,

	stop: function() {
		clearInterval( timerId );
		timerId = null;
	},

	speeds: {
		slow: 600,
		fast: 200,
		// Default speed
		_default: 400
	},

	step: {
		opacity: function( fx ) {
			jQuery.style( fx.elem, "opacity", fx.now );
		},

		_default: function( fx ) {
			if ( fx.elem.style && fx.elem.style[ fx.prop ] != null ) {
				fx.elem.style[ fx.prop ] = (fx.prop === "width" || fx.prop === "height" ? Math.max(0, fx.now) : fx.now) + fx.unit;
			} else {
				fx.elem[ fx.prop ] = fx.now;
			}
		}
	}
});

if ( jQuery.expr && jQuery.expr.filters ) {
	jQuery.expr.filters.animated = function( elem ) {
		return jQuery.grep(jQuery.timers, function( fn ) {
			return elem === fn.elem;
		}).length;
	};
}

// Try to restore the default display value of an element
function defaultDisplay( nodeName ) {

	if ( !elemdisplay[ nodeName ] ) {

		var body = document.body,
			elem = jQuery( "<" + nodeName + ">" ).appendTo( body ),
			display = elem.css( "display" );

		elem.remove();

		// If the simple way fails,
		// get element's real default display by attaching it to a temp iframe
		if ( display === "none" || display === "" ) {
			// No iframe to use yet, so create it
			if ( !iframe ) {
				iframe = document.createElement( "iframe" );
				iframe.frameBorder = iframe.width = iframe.height = 0;
			}

			body.appendChild( iframe );

			// Create a cacheable copy of the iframe document on first call.
			// IE and Opera will allow us to reuse the iframeDoc without re-writing the fake HTML
			// document to it; WebKit & Firefox won't allow reusing the iframe document.
			if ( !iframeDoc || !iframe.createElement ) {
				iframeDoc = ( iframe.contentWindow || iframe.contentDocument ).document;
				iframeDoc.write( ( document.compatMode === "CSS1Compat" ? "<!doctype html>" : "" ) + "<html><body>" );
				iframeDoc.close();
			}

			elem = iframeDoc.createElement( nodeName );

			iframeDoc.body.appendChild( elem );

			display = jQuery.css( elem, "display" );

			body.removeChild( iframe );
		}

		// Store the correct default display
		elemdisplay[ nodeName ] = display;
	}

	return elemdisplay[ nodeName ];
}




var rtable = /^t(?:able|d|h)$/i,
	rroot = /^(?:body|html)$/i;

if ( "getBoundingClientRect" in document.documentElement ) {
	jQuery.fn.offset = function( options ) {
		var elem = this[0], box;

		if ( options ) {
			return this.each(function( i ) {
				jQuery.offset.setOffset( this, options, i );
			});
		}

		if ( !elem || !elem.ownerDocument ) {
			return null;
		}

		if ( elem === elem.ownerDocument.body ) {
			return jQuery.offset.bodyOffset( elem );
		}

		try {
			box = elem.getBoundingClientRect();
		} catch(e) {}

		var doc = elem.ownerDocument,
			docElem = doc.documentElement;

		// Make sure we're not dealing with a disconnected DOM node
		if ( !box || !jQuery.contains( docElem, elem ) ) {
			return box ? { top: box.top, left: box.left } : { top: 0, left: 0 };
		}

		var body = doc.body,
			win = getWindow(doc),
			clientTop  = docElem.clientTop  || body.clientTop  || 0,
			clientLeft = docElem.clientLeft || body.clientLeft || 0,
			scrollTop  = win.pageYOffset || jQuery.support.boxModel && docElem.scrollTop  || body.scrollTop,
			scrollLeft = win.pageXOffset || jQuery.support.boxModel && docElem.scrollLeft || body.scrollLeft,
			top  = box.top  + scrollTop  - clientTop,
			left = box.left + scrollLeft - clientLeft;

		return { top: top, left: left };
	};

} else {
	jQuery.fn.offset = function( options ) {
		var elem = this[0];

		if ( options ) {
			return this.each(function( i ) {
				jQuery.offset.setOffset( this, options, i );
			});
		}

		if ( !elem || !elem.ownerDocument ) {
			return null;
		}

		if ( elem === elem.ownerDocument.body ) {
			return jQuery.offset.bodyOffset( elem );
		}

		jQuery.offset.initialize();

		var computedStyle,
			offsetParent = elem.offsetParent,
			prevOffsetParent = elem,
			doc = elem.ownerDocument,
			docElem = doc.documentElement,
			body = doc.body,
			defaultView = doc.defaultView,
			prevComputedStyle = defaultView ? defaultView.getComputedStyle( elem, null ) : elem.currentStyle,
			top = elem.offsetTop,
			left = elem.offsetLeft;

		while ( (elem = elem.parentNode) && elem !== body && elem !== docElem ) {
			if ( jQuery.offset.supportsFixedPosition && prevComputedStyle.position === "fixed" ) {
				break;
			}

			computedStyle = defaultView ? defaultView.getComputedStyle(elem, null) : elem.currentStyle;
			top  -= elem.scrollTop;
			left -= elem.scrollLeft;

			if ( elem === offsetParent ) {
				top  += elem.offsetTop;
				left += elem.offsetLeft;

				if ( jQuery.offset.doesNotAddBorder && !(jQuery.offset.doesAddBorderForTableAndCells && rtable.test(elem.nodeName)) ) {
					top  += parseFloat( computedStyle.borderTopWidth  ) || 0;
					left += parseFloat( computedStyle.borderLeftWidth ) || 0;
				}

				prevOffsetParent = offsetParent;
				offsetParent = elem.offsetParent;
			}

			if ( jQuery.offset.subtractsBorderForOverflowNotVisible && computedStyle.overflow !== "visible" ) {
				top  += parseFloat( computedStyle.borderTopWidth  ) || 0;
				left += parseFloat( computedStyle.borderLeftWidth ) || 0;
			}

			prevComputedStyle = computedStyle;
		}

		if ( prevComputedStyle.position === "relative" || prevComputedStyle.position === "static" ) {
			top  += body.offsetTop;
			left += body.offsetLeft;
		}

		if ( jQuery.offset.supportsFixedPosition && prevComputedStyle.position === "fixed" ) {
			top  += Math.max( docElem.scrollTop, body.scrollTop );
			left += Math.max( docElem.scrollLeft, body.scrollLeft );
		}

		return { top: top, left: left };
	};
}

jQuery.offset = {
	initialize: function() {
		var body = document.body, container = document.createElement("div"), innerDiv, checkDiv, table, td, bodyMarginTop = parseFloat( jQuery.css(body, "marginTop") ) || 0,
			html = "<div style='position:absolute;top:0;left:0;margin:0;border:5px solid #000;padding:0;width:1px;height:1px;'><div></div></div><table style='position:absolute;top:0;left:0;margin:0;border:5px solid #000;padding:0;width:1px;height:1px;' cellpadding='0' cellspacing='0'><tr><td></td></tr></table>";

		jQuery.extend( container.style, { position: "absolute", top: 0, left: 0, margin: 0, border: 0, width: "1px", height: "1px", visibility: "hidden" } );

		container.innerHTML = html;
		body.insertBefore( container, body.firstChild );
		innerDiv = container.firstChild;
		checkDiv = innerDiv.firstChild;
		td = innerDiv.nextSibling.firstChild.firstChild;

		this.doesNotAddBorder = (checkDiv.offsetTop !== 5);
		this.doesAddBorderForTableAndCells = (td.offsetTop === 5);

		checkDiv.style.position = "fixed";
		checkDiv.style.top = "20px";

		// safari subtracts parent border width here which is 5px
		this.supportsFixedPosition = (checkDiv.offsetTop === 20 || checkDiv.offsetTop === 15);
		checkDiv.style.position = checkDiv.style.top = "";

		innerDiv.style.overflow = "hidden";
		innerDiv.style.position = "relative";

		this.subtractsBorderForOverflowNotVisible = (checkDiv.offsetTop === -5);

		this.doesNotIncludeMarginInBodyOffset = (body.offsetTop !== bodyMarginTop);

		body.removeChild( container );
		jQuery.offset.initialize = jQuery.noop;
	},

	bodyOffset: function( body ) {
		var top = body.offsetTop,
			left = body.offsetLeft;

		jQuery.offset.initialize();

		if ( jQuery.offset.doesNotIncludeMarginInBodyOffset ) {
			top  += parseFloat( jQuery.css(body, "marginTop") ) || 0;
			left += parseFloat( jQuery.css(body, "marginLeft") ) || 0;
		}

		return { top: top, left: left };
	},

	setOffset: function( elem, options, i ) {
		var position = jQuery.css( elem, "position" );

		// set position first, in-case top/left are set even on static elem
		if ( position === "static" ) {
			elem.style.position = "relative";
		}

		var curElem = jQuery( elem ),
			curOffset = curElem.offset(),
			curCSSTop = jQuery.css( elem, "top" ),
			curCSSLeft = jQuery.css( elem, "left" ),
			calculatePosition = (position === "absolute" || position === "fixed") && jQuery.inArray("auto", [curCSSTop, curCSSLeft]) > -1,
			props = {}, curPosition = {}, curTop, curLeft;

		// need to be able to calculate position if either top or left is auto and position is either absolute or fixed
		if ( calculatePosition ) {
			curPosition = curElem.position();
			curTop = curPosition.top;
			curLeft = curPosition.left;
		} else {
			curTop = parseFloat( curCSSTop ) || 0;
			curLeft = parseFloat( curCSSLeft ) || 0;
		}

		if ( jQuery.isFunction( options ) ) {
			options = options.call( elem, i, curOffset );
		}

		if (options.top != null) {
			props.top = (options.top - curOffset.top) + curTop;
		}
		if (options.left != null) {
			props.left = (options.left - curOffset.left) + curLeft;
		}

		if ( "using" in options ) {
			options.using.call( elem, props );
		} else {
			curElem.css( props );
		}
	}
};


jQuery.fn.extend({
	position: function() {
		if ( !this[0] ) {
			return null;
		}

		var elem = this[0],

		// Get *real* offsetParent
		offsetParent = this.offsetParent(),

		// Get correct offsets
		offset       = this.offset(),
		parentOffset = rroot.test(offsetParent[0].nodeName) ? { top: 0, left: 0 } : offsetParent.offset();

		// Subtract element margins
		// note: when an element has margin: auto the offsetLeft and marginLeft
		// are the same in Safari causing offset.left to incorrectly be 0
		offset.top  -= parseFloat( jQuery.css(elem, "marginTop") ) || 0;
		offset.left -= parseFloat( jQuery.css(elem, "marginLeft") ) || 0;

		// Add offsetParent borders
		parentOffset.top  += parseFloat( jQuery.css(offsetParent[0], "borderTopWidth") ) || 0;
		parentOffset.left += parseFloat( jQuery.css(offsetParent[0], "borderLeftWidth") ) || 0;

		// Subtract the two offsets
		return {
			top:  offset.top  - parentOffset.top,
			left: offset.left - parentOffset.left
		};
	},

	offsetParent: function() {
		return this.map(function() {
			var offsetParent = this.offsetParent || document.body;
			while ( offsetParent && (!rroot.test(offsetParent.nodeName) && jQuery.css(offsetParent, "position") === "static") ) {
				offsetParent = offsetParent.offsetParent;
			}
			return offsetParent;
		});
	}
});


// Create scrollLeft and scrollTop methods
jQuery.each( ["Left", "Top"], function( i, name ) {
	var method = "scroll" + name;

	jQuery.fn[ method ] = function( val ) {
		var elem, win;

		if ( val === undefined ) {
			elem = this[ 0 ];

			if ( !elem ) {
				return null;
			}

			win = getWindow( elem );

			// Return the scroll offset
			return win ? ("pageXOffset" in win) ? win[ i ? "pageYOffset" : "pageXOffset" ] :
				jQuery.support.boxModel && win.document.documentElement[ method ] ||
					win.document.body[ method ] :
				elem[ method ];
		}

		// Set the scroll offset
		return this.each(function() {
			win = getWindow( this );

			if ( win ) {
				win.scrollTo(
					!i ? val : jQuery( win ).scrollLeft(),
					 i ? val : jQuery( win ).scrollTop()
				);

			} else {
				this[ method ] = val;
			}
		});
	};
});

function getWindow( elem ) {
	return jQuery.isWindow( elem ) ?
		elem :
		elem.nodeType === 9 ?
			elem.defaultView || elem.parentWindow :
			false;
}




// Create width, height, innerHeight, innerWidth, outerHeight and outerWidth methods
jQuery.each([ "Height", "Width" ], function( i, name ) {

	var type = name.toLowerCase();

	// innerHeight and innerWidth
	jQuery.fn[ "inner" + name ] = function() {
		var elem = this[0];
		return elem && elem.style ?
			parseFloat( jQuery.css( elem, type, "padding" ) ) :
			null;
	};

	// outerHeight and outerWidth
	jQuery.fn[ "outer" + name ] = function( margin ) {
		var elem = this[0];
		return elem && elem.style ?
			parseFloat( jQuery.css( elem, type, margin ? "margin" : "border" ) ) :
			null;
	};

	jQuery.fn[ type ] = function( size ) {
		// Get window width or height
		var elem = this[0];
		if ( !elem ) {
			return size == null ? null : this;
		}

		if ( jQuery.isFunction( size ) ) {
			return this.each(function( i ) {
				var self = jQuery( this );
				self[ type ]( size.call( this, i, self[ type ]() ) );
			});
		}

		if ( jQuery.isWindow( elem ) ) {
			// Everyone else use document.documentElement or document.body depending on Quirks vs Standards mode
			// 3rd condition allows Nokia support, as it supports the docElem prop but not CSS1Compat
			var docElemProp = elem.document.documentElement[ "client" + name ],
				body = elem.document.body;
			return elem.document.compatMode === "CSS1Compat" && docElemProp ||
				body && body[ "client" + name ] || docElemProp;

		// Get document width or height
		} else if ( elem.nodeType === 9 ) {
			// Either scroll[Width/Height] or offset[Width/Height], whichever is greater
			return Math.max(
				elem.documentElement["client" + name],
				elem.body["scroll" + name], elem.documentElement["scroll" + name],
				elem.body["offset" + name], elem.documentElement["offset" + name]
			);

		// Get or set width or height on the element
		} else if ( size === undefined ) {
			var orig = jQuery.css( elem, type ),
				ret = parseFloat( orig );

			return jQuery.isNaN( ret ) ? orig : ret;

		// Set the width or height on the element (default to pixels if value is unitless)
		} else {
			return this.css( type, typeof size === "string" ? size : size + "px" );
		}
	};

});


// Expose jQuery to the global object
window.jQuery = window.$ = jQuery;
})(window);
﻿/* 
* jQuery touch Plugin v0.1.0
*
* Copyright (c) 2010 Microsoft
*/

LoadjQueryObjectOwa = function ($, interactionMode)
{
    var clickString = "click";
    var tapString = "customEvent_tap";

//#if OWA_BUILD
//    var isTouch = "ontouchstart" in document;
//#else
    var isTouchEvent = "ontouchstart" in document;
    var isPointerEventsIE = window.navigator.msPointerEnabled;
    var isPointerEvents = window.navigator.pointerEnabled; // http://www.w3.org/TR/pointerevents/#extensions-to-the-navigator-interface
    var isTouch = Boolean(isTouchEvent || isPointerEventsIE || isPointerEvents);
//#endif //OWA_BUILD
    var touchMode = "TOUCH";
    var clickMode = "CLICK";
    var mode = (typeof interactionMode != "undefined") ? interactionMode : isTouch ? touchMode : clickMode;
    var clickEvent = (mode == "TOUCH") ? tapString : clickString;
    var bodyEvent = "BODYTOUCH";

    var rightClickEvent = "contextmenu";
    var swipeEvent = "customEvent_swipe";

    // This allows us to emulate touch behavior in a mouse environment
    var touchStartEvent;
    var touchMoveEvent;
    var touchEndEvent;

//#if OWA_BUILD
//    if (isTouch) {
//        touchStartEvent = "touchstart";
//        touchMoveEvent = "touchmove";
//        touchEndEvent = "touchend";
//    }
//    else
//    {
//        touchStartEvent = "mousedown";
//        touchMoveEvent = "mousemove";
//        touchEndEvent = "mouseup mouseleave";
//    }
//#else
    // Gesture events
    var gestureStartEvent;
    var gestureChangeEvent;
    var gestureEndEvent;

    if (isPointerEvents) {
        touchStartEvent = "pointerdown";
        touchMoveEvent = "pointermove";
        touchEndEvent = "pointerup";
        gestureStartEvent = "gesturestart";
        gestureChangeEvent = "gesturechange";
        gestureEndEvent = "gestureend";
    } else if (isPointerEventsIE) {
        touchStartEvent = "MSPointerDown";
        touchMoveEvent = "MSPointerMove";
        touchEndEvent = "MSPointerUp";
        gestureStartEvent = "MSGestureStart";
        gestureChangeEvent = "MSGestureChange";
        gestureEndEvent = "MSGestureEnd";
    } else if (isTouchEvent) {
        touchStartEvent = "touchstart mousedown";
        touchMoveEvent = "touchmove mousemove";
        touchEndEvent = "touchend mouseup mouseleave";
        gestureStartEvent = "gesturestart";
        gestureChangeEvent = "gesturechange";
        gestureEndEvent = "gestureend";
    } else {
        touchStartEvent = "mousedown";
        touchMoveEvent = "mousemove";
        touchEndEvent = "mouseup mouseleave";
        gestureStartEvent = "";
        gestureChangeEvent = "";
        gestureEndEvent = "";
    }
 
//#endif //OWA_BUILD

    /// <summary>
    /// Both click and right click (in touch mode) need to validate that the touch start
    /// and end targets are descendants of the element to which the handler is bound
    /// </summary>
    /// <param name="elem">Element to which the handler is bound (the this object in the callback)</param>
    /// <param name="touches">The data indicating the touchstart and end targets</param>
    function isValidTapOnElement(elem, touches)
    {
        // If touches is undefined then the consumer manually triggered the event, so we'll just return true in that case.
        // otherwise we check to see if elem is the target of the touch or if the targets are descendants of elem
        return ((typeof touches == "undefined")
            || (elem == touches.start && elem == touches.end)
            || ($(elem).has(touches.start).length > 0 && $(elem).has(touches.end).length > 0));
    }

    /// <summary>
    /// Click and right click both process their trigger data the same
    /// Validates the trigger data then places the appropriate data on the
    /// event object
    /// </summary>
    /// <param name="event">Event object to set the data on</param>
    /// <param name="triggerData">Internal data passed on the trigger</param>
    function processTapTriggerData(event, triggerData)
    {
        if (typeof triggerData != "undefined")
        {
            // TODO: this could be better by defining a type for the internal trigger data
            // and then just checking the typeof the data
            if (typeof triggerData.coords == "undefined")
            {
                throw ("Passing data through manual triggers is unsupported");
            }

            // Since in touch mode we manually trigger the event and
            // jQuery generates the event, we need to give the event
            // the location of the native events that triggered it
            // The consumer wouldn't provide these coordinates
            event.pageX = triggerData.coords.x;
            event.pageY = triggerData.coords.y;
        }
    }

    /// <summary>
    /// Click/Tap event.If you're in a touch environment, it will use the tap event, 
    /// if not, it will use click. If you send it a function it will bind the click/tap
    /// gesture to that function.  If you pass nothing it will raise the click/tap gesture.
    /// </summary>
    /// <param name="fn">Callback function to call when tap is raised.</param>
    /// <param name="isCapture">
    /// True if you want this applied on the capture phase of the event.
    /// Only valid in for click events in click mode.
    /// </param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    /// <param name="id">The event handler  id.</param>
    /// <remark>
    /// In touch mode, this binds to a customEvent_tap.  It also verifies that
    /// the element the callback is bound to is the ancestor of the touchstart and touchend
    /// In click mode, this binds to the native click event.  It also verifies that
    /// the click being triggered is not a right click event.
    /// Calling this shortcut with fn not being a function will trigger the click event
    /// </remark>
    $.fn.click = function (fn, isCapture, id, data)
    {
        if ($.isFunction(fn))
        {
            return this.each(function (i, el)
            {
                // If we're in a mobile environment then
                // bind to our own custom event that emulates a click
                // This event will be fired manually through code or by the Bootstrapper
                $(el).bind(
                    clickEvent + (id ? '.' + id : ''),
                    data,
                    mode == touchMode ?
                        function (eventObject, triggerData)
                        {
                            // Verify that the targets are either this element or children
                            // of this element (touch mode only)
                            if (isValidTapOnElement(this, triggerData))
                            {
                                processTapTriggerData(eventObject, triggerData);

                                // Call the function bound to the event
                                // that is stored in the closure
                                fn(eventObject);
                            }
                        }
                        : function (eventObject)
                        {
                            // This code is desktop only which is actually binding to
                            // a real click so we don't care about verifying the start
                            // and end targets since the browser has already done it
                            // Also, the buttons exist only in desktop, so we'll check that here
                            // since we don't want to trigger a click on a right click event
                            // If .which is undefined then the event was triggered manually, otherwise
                            // make sure that it's not a right click event (right button == 3)
                            if ((typeof eventObject.which == "undefined") || eventObject.which != 3)
                            {
                                fn(eventObject);
                            }
                        },
                    isCapture);
            });
        }
        else
        {
            // Fire the click event (in touch mode this is a custom event)
            $(this).trigger(clickEvent);
        }
    }

    /// <summary>
    /// Remove bindings to the click event, this takes care of both tap and click depending on the mode.
    /// </summary>
    /// <param name="fn">Callback function to remove or id of the handler.</param>
    /// <param name="isCapture">If we want to remove the capture handler or the bubble one</param>
    $.fn.unClick = function (fn, iscapture)
    {
        return this.each(function (i, el)
        {
            if ($.isFunction(fn))
            {
                $(el).unbind(clickEvent, fn, iscapture);
            }
            else
            {
                $(el).unbind(clickEvent + (fn ? '.' + fn : ''));
            }
        });
    }

    /// <summary>
    /// Right Click/Tap and Hold event. This is a custom event that will allow us to forgo 
    /// checking which button was clicked in each click event handler. In touch, this will be
    /// fired after holding down a tap for a predetermined amount of time. If you send it a function
    /// it will bind the right click/tap and hold gesture to that function.  If you pass nothing it
    /// will raise the right click/tap and hold gesture.
    /// </summary>
    /// <param name="fn">Callback function to call when right click is raised.</param>
    /// <param name="isCapture">
    /// True if you want this applied on the capture phase of the event.
    /// Only valid for right click events in click mode.
    /// </param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    $.fn.rightClick = function (fn, isCapture, id, data)
    {
        if ($.isFunction(fn))
        {
            return this.each(function (i, el)
            {
                $(el).bind(
                    rightClickEvent + (id ? '.' + id : ''),
                    data,
                    mode == touchMode ?
                        function (eventObject, triggerData)
                        {
                            // Verify that the targets are either this element or children
                            // of this element (touch mode only)
                            // If the user triggers a tap on an element (touches == undefined), we don't 
                            // need to verify the start and end elements since they would be the same
                            if (isValidTapOnElement(this, triggerData))
                            {
                                processTapTriggerData(eventObject, triggerData);

                                // Call the function bound to the event
                                // that is stored in the closure
                                fn(eventObject);
                            }
                        }
                        : function (eventObject)
                        {
                            fn(eventObject)
                        },
                    isCapture);

                // In desktop, in the case that a context menu event isn't triggered and a click event
                // is triggered, we should be checking the button pressed and firing the right click handler
                // if applicable.
                if (mode == clickMode)
                {
                    $(el).bind(
                        clickEvent,
                        data,
                        function (eventObject)
                        {
                            // This code is desktop only which is actually binding to
                            // a real click so we don't care about verifying the start
                            // and end targets since the browser has already done it
                            // Also, the buttons exist only in desktop, so we'll check that here
                            if (eventObject.which && eventObject.which == 3)
                            {
                                // The right click event should be doing this, not the click event.
                                eventObject.type = rightClickEvent;
                                $(this).trigger(eventObject);
                                eventObject.stopPropogation();
                            }
                        },
                        isCapture);
                }
            });
        }
        else
        {
            // Fire the right click event (in touch mode this is a custom event since
            // the 'contextmenu' event doesn't currently exist in touch)
            $(this).trigger(rightClickEvent);
        }
    }

    /// <summary>
    /// Remove bindings to the right click event.
    /// </summary>
    /// <param name="fn">Callback function to remove or id of the handler.</param>
    /// <param name="isCapture">If we want to remove the capture handler or the bubble one</param>
    $.fn.unRightClick = function (fn, iscapture)
    {
        return this.each(function (i, el)
        {
            if ($.isFunction(fn))
            {
                $(el).unbind(rightClickEvent, fn, iscapture);
            }
            else
            {
                $(el).unbind(rightClickEvent + (fn ? '.' + fn : ''));
            }
        });
    }

    /// <summary>
    /// Binds to the Swipe gesture related events for touch-enabled devices
    /// </summary>
    /// <param name="fnSwipe">Callback function to fire when a swipe is detected</param>
    /// <param name="fnTouchStart">Callback function for touchStart event</param>
    /// <param name="fnTouchMove">Callback function for touchMove events</param>
    /// <param name="fnSwipeIncomplete">Callback function to fire when a gesture ends in not being a swipe</param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    /// <remark>For triggering swipes during tests, use the gesture simulator</remark>
    $.fn.swipe = function (fnComplete, fnStart, fnMove, fnIncomplete, id, data)
    {
        if ($.isFunction(fnComplete))
        {
            return this.each(function (i, el)
            {
                $(el).touch(
                function (eventObject)
                {
                    if ($.isFunction(fnMove))
                    {
                        // A callback for the touchmove was provided, so bind to it
                        $(el).touchMove(fnMove, false, id, data);
                    }

                    // We always bind to the swipe event and use the callback wrapper
                    // to determine which end event callback to run
                    $(el).one(
                        swipeEvent + (id ? '.' + id : ''),
                        data,
                        function (eventObject, triggerSwipeData)
                        {
                            // Once we get the swipe event we need to unbind the swipe and touchMove, only if we bound
                            // They will be bound again on the next touchStart event
                            if ($.isFunction(fnMove))
                            {
                                $(this).unbind(touchMoveEvent + (id ? '.' + id : ''));
                            }

                            // TODO: this could be averted by defining a type for the internal trigger data
                            // and then just checking the typeof the data
                            if (typeof triggerSwipeData == "undefined"
                                || typeof triggerSwipeData.coords == "undefined"
                                || typeof triggerSwipeData.direction == "undefined")
                            {
                                // Manual triggering of swipes is unsupported
                                // For testing use the gesture simulator
                                throw ("Manual triggering of swipe events is unsupported");
                            }

                            // Add the direction to the eventObject
                            eventObject.direction = triggerSwipeData.direction;

                            // Add the coordinates
                            eventObject.pageX = triggerSwipeData.coords.x;
                            eventObject.pageY = triggerSwipeData.coords.y;

                            // Determine if we should be firing the swipe complete event or the incomplete event
                            // If a consumer binds to swipe incomplete and tap, they will get both events
                            if (triggerSwipeData.direction == "incomplete")
                            {
                                if ($.isFunction(fnIncomplete))
                                {
                                    fnIncomplete(eventObject);
                                }
                            }
                            else
                            {
                                fnComplete(eventObject);
                            }
                        });

                    if ($.isFunction(fnStart))
                    {
                        // Run the touchstart callback
                        fnStart(eventObject);
                    }
                },
                false,
                id,
                data);
            });
        }
    }

    /// <summary>
    /// Remove bindings to the swipe event, intenally since swipe is really binding to touch, we remove the touchStartEvent.
    /// </summary>
    /// <param name="fn">Callback function to remove or id of the handler.</param>
    /// <param name="isCapture">If we want to remove the capture handler or the bubble one</param>
    $.fn.unSwipe = function (fn, iscapture)
    {
        return this.each(function (i, el)
        {
            if ($.isFunction(fn))
            {
                $(el).unbind(touchStartEvent, fn, iscapture);
            }
            else
            {
                $(el).unbind(touchStartEvent + (fn ? '.' + fn : ''));
            }
        });
    }

//#if !OWA_BUILD    
    /// <summary>
    /// Binds to the gesture related events for touch-enabled devices
    /// </summary>
    /// <param name="fnComplete">Callback function to fire when a gesture is completed</param>
    /// <param name="fnStart">Callback function for gesture start event</param>
    /// <param name="fnChange">Callback function for gesture change </param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    /// <remark>For triggering gestures during tests, use the gesture simulator</remark>
    $.fn.gesture = function (fnComplete, fnStart, fnChange, id, data) {
        if ($.isFunction(fnComplete)) {
            return this.each(function (i, el) {
                $(el).gestureStart(
                function (eventObject) {
                    if ($.isFunction(fnChange)) {
                        // A callback for the gestureChange was provided, so bind to it
                        $(el).gestureChange(fnChange, false, id, data);
                    }

                    // We always bind to the gesture event and use the callback wrapper
                    // to determine which end event callback to run
                    $(el).gestureEnd(
                            function (eventObject) {
                                // unbind gesture change/end events
                                $(el).gestureDone();

                                if ($.isFunction(fnComplete)) {
                                    // Run the touchstart callback
                                    fnComplete(eventObject);
                                }
                            },
                            false,
                            id,
                            data);

                    if ($.isFunction(fnStart)) {
                        // Run the touchstart callback
                        fnStart(eventObject);
                    }
                },
                false,
                id,
                data);
            });
        }
    }

    /// <summary>
    /// Remove bindings to the gesture event, intenally since gesture is really binding to touch, we remove the touchStartEvent.
    /// </summary>
    /// <param name="fn">Callback function to remove or id of the handler.</param>
    /// <param name="isCapture">If we want to remove the capture handler or the bubble one</param>
    $.fn.unGesture = function (fn, iscapture) {
        return this.each(function (i, el) {
            if ($.isFunction(fn)) {
                $(el).unbind(gestureStartEvent, fn, iscapture);
            }
            else {
                $(el).unbind(gestureStartEvent + (fn ? '.' + fn : ''));
            }
        });
    }
//#endif //OWA_BUILD

    /// <summary>
    /// Binds the touchstart/mousedown event to given function depending on the interaction mode.
    /// Fires the touch event if no fn is specified
    /// </summary>
    /// <param name="fn">Callback function to call when touch moves are triggered.</param>
    /// <param name="isCapture">True if you want this applied on the capture phase of the event</param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="disableAxisLock">Should we turn off locking of the axis? This means that once you start a touch in
    /// a direction it will lock to that axis and not allow the axis of the other direction to change.</param>
    $.fn.touch = function (fn, isCapture, id, data, disableAxisLock)
    {
        if ($.isFunction(fn))
        {
            return this.each(function (i, el)
            {
                $(el).bind(
                    touchStartEvent + (id ? '.' + id : ''),
                    data,
                    function (e)
                    {
//#if OWA_BUILD
//                        e.pageX = isTouch ? (e.originalEvent ? e.originalEvent.changedTouches[0].pageX : 0) : e.pageX;
//                        e.pageY = isTouch ? (e.originalEvent ? e.originalEvent.changedTouches[0].pageY : 0) : e.pageY;

//                        // By default we will enable axis lock.  We need to store the initial x and y coords
//                        // so we can later use them to lock in the axis.
//                        if (!disableAxisLock)
                        //#else

                        if (e.type === 'touchstart') {
                            e.pageX = e.originalEvent.changedTouches[0].pageX;
                            e.pageY = e.originalEvent.changedTouches[0].pageY;
                        }

                        // By default we will enable axis lock.  We need to store the initial x and y coords
                        // so we can later use them to lock in the axis.
                        // MDEEPAK: temp change: By default axis lock is enabled so when we move mouse it can only
                        // move either in X or Y axis, this breaks the whiteboard and any draggable control. So temporarily
                        // inverting the code here, so it behaves like axis lock is disabled.
                        if (disableAxisLock)
//#endif //OWA_BUILD
                        {
                            $.data(this, "axisLock", true);
                            $.data(this, "axisDirection", "");
                            $.data(this, "axisX", e.pageX);
                            $.data(this, "axisY", e.pageY);
                        }
                        else
                        {
                            $.data(this, "axisLock", false);
                        }

                        fn(e);
                    },
                    isCapture);
            });
        }
        else
        {
            // Fire the touch event (in touch mode this is a custom event)
            $(this).trigger(touchStartEvent);
        }
    }

    /// <summary>
    /// Remove bindings to the touchstart event
    /// </summary>
    /// <param name="fn">Callback function to remove or id of the handler.</param>
    /// <param name="isCapture">If we want to remove the capture handler or the bubble one</param>
    $.fn.unTouch = function (fn, iscapture)
    {
        return this.each(function (i, el)
        {
            if ($.isFunction(fn))
            {
                $(el).unbind(touchStartEvent, fn, iscapture);
            }
            else
            {
                $(el).unbind(touchStartEvent + (fn ? '.' + fn : ''));
            }
        });
    }

    /// <summary>
    /// Binds the touchmove/mousemove event to given function depending on the interaction mode.
    /// </summary>
    /// <param name="fn">Callback function to call when touch move begins.</param>
    /// <param name="isCapture">True if you want this applied on the capture phase of the event</param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    $.fn.touchMove = function (fn, isCapture, id, data)
    {
        if ($.isFunction(fn))
        {
            return this.each(function (i, el)
            {
                $(el).bind(
                    touchMoveEvent + (id ? '.' + id : ''),
                    data,
                    function (e)
                    {
//#if OWA_BUILD
//                        e.pageX = isTouch ? e.originalEvent.changedTouches[0].pageX : e.pageX;
//                        e.pageY = isTouch ? e.originalEvent.changedTouches[0].pageY : e.pageY;
//#else
                        if (e.type === 'touchmove') {
                            e.pageX = e.originalEvent.changedTouches[0].pageX;
                            e.pageY = e.originalEvent.changedTouches[0].pageY;
                            e.preventDefault();
                        }

//#endif //OWA_BUILD

                        // If axis lock is enabled (default)
                        if ($.data(this, "axisLock"))
                        {
                            var startX = $.data(this, "axisX");
                            var startY = $.data(this, "axisY");

                            // We initially need to figure out what direction we should lock.  We do this by
                            // looking at the first few data points and making a determination on the direction.
                            // This allows us to filter out the jitter that would appear when we attempt to hone in
                            // on the direction.  The number we sample was determine by trial and error.
                            if ($.data(this, "axisDirection") === "")
                            {
                                var dx = Math.abs(e.pageX - startX);
                                var dy = Math.abs(e.pageY - startY);

                                // We check vertical first since this is what happens most of the time
                                // We want vertical to win out in a tie
                                if (dy > 6)
                                {
                                    $.data(this, "axisDirection", "Y");
                                }
                                else if (dx > 6)
                                {
                                    $.data(this, "axisDirection", "X");
                                }
                            }
                            else
                            {
                                // Once we have locked in a direction we just need to change the x or y to match
                                // the original x or y that came from the touch start
                                if ($.data(this, "axisDirection") == "X")
                                {
                                    e.pageY = startY;
                                }
                                else
                                {
                                    e.pageX = startX;
                                }
                                fn(e);
                            }
                        }
                        else
                        {
                            fn(e);
                        }
                    },
                    isCapture);
            });
        }
    }

    /// <summary>
    /// Binds the touchend or mouseup & mouseleave events to given function depending on the interaction mode.
    /// </summary>
    /// <param name="fn">Callback function to call when touch ends.</param>
    /// <param name="isCapture">True if you want this applied on the capture phase of the event</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    $.fn.touchEnd = function (fn, isCapture, data)
    {
        if ($.isFunction(fn))
        {
            return this.each(function (i, el)
            {
                $(el).bind(
                    touchEndEvent,
                    data,
                    function (e)
                    {
//#if OWA_BUILD
//                        e.pageX = isTouch ? e.originalEvent.changedTouches[0].pageX : e.pageX;
//                        e.pageY = isTouch ? e.originalEvent.changedTouches[0].pageY : e.pageY;
//#else
                        if (e.type === 'touchend') {
                            e.pageX = e.originalEvent.changedTouches[0].pageX;
                            e.pageY = e.originalEvent.changedTouches[0].pageY;
                        }
//#endif //OWA_BUILD

                        // If axis lock is enable reset the locked axis and then clear the data storage
                        if ($.data(this, "axisLock"))
                        {
                            if ($.data(this, "axisDirection") == "X")
                            {
                                e.pageY = $.data(this, "axisY");
                            }
                            else
                            {
                                e.pageX = $.data(this, "axisX");
                            }
                        }

                        // Cleanup data storage after touch event
                        $.data(this, "axisLock", "");
                        $.data(this, "axisDirection", "");
                        $.data(this, "axisX", "");
                        $.data(this, "axisY", "");

                        fn(e);
                    },
                    isCapture);
            });
        }
    }

    /// <summary>
    /// Unbinds the touch move and end events (or the mousemove, mouseup, and mouseleave if in mouse mode)
    /// </summary>
    $.fn.touchDone = function ()
    {
        return this.each(function (i, el)
        {
            $(el).unbind(touchMoveEvent + " " + touchEndEvent);
        });
    }

//#if !OWA_BUILD
    /// <summary>
    /// Binds the touchstart/mousedown event to given function depending on the interaction mode.
    /// </summary>
    /// <param name="fn">Callback function to call when touch moves are triggered.</param>
    /// <param name="isCapture">True if you want this applied on the capture phase of the event</param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    /// <param name="id">The event handler  id.</param>
    $.fn.gestureStart = function (fn, isCapture, id, data) {
        if ($.isFunction(fn)) {
            return this.each(function (i, el) {
                $(el).bind(
                    gestureStartEvent + (id ? '.' + id : ''),
                    data,
                    function (e) {
                        fn(e.originalEvent);
                    },
                    isCapture);
            });
        }
    }

    /// <summary>
    /// Remove bindings to the touchstart event
    /// </summary>
    /// <param name="fn">Callback function to remove or id of the handler.</param>
    /// <param name="isCapture">If we want to remove the capture handler or the bubble one</param>
    $.fn.unGestureStart = function (fn, iscapture) {
        return this.each(function (i, el) {
            if ($.isFunction(fn)) {
                $(el).unbind(gestureStartEvent, fn, iscapture);
            }
            else {
                $(el).unbind(gestureStartEvent + (fn ? '.' + fn : ''));
            }
        });
    }

    /// <summary>
    /// Binds the touchmove/mousemove event to given function depending on the interaction mode.
    /// </summary>
    /// <param name="fn">Callback function to call when touch move begins.</param>
    /// <param name="isCapture">True if you want this applied on the capture phase of the event</param>
    /// <param name="id">The event handler  id.</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    $.fn.gestureChange = function (fn, isCapture, id, data) {
        if ($.isFunction(fn)) {
            return this.each(function (i, el) {
                $(el).bind(
                    gestureChangeEvent + (id ? '.' + id : ''),
                    data,
                    function (e) {
                        fn(e.originalEvent);
                    },
                    isCapture);
            });
        }
    }

    /// <summary>
    /// Binds the touchend or mouseup & mouseleave events to given function depending on the interaction mode.
    /// </summary>
    /// <param name="fn">Callback function to call when touch ends.</param>
    /// <param name="isCapture">True if you want this applied on the capture phase of the event</param>
    /// <param name="data">
    /// Data that will be placed on the data property on the event
    /// which will be made available to the bound callback only.
    /// </param>
    $.fn.gestureEnd = function (fn, isCapture, data) {
        if ($.isFunction(fn)) {
            return this.each(function (i, el) {
                $(el).bind(
                    gestureEndEvent,
                    data,
                    function (e) {
                        fn(e.originalEvent);
                    },
                    isCapture);
            });
        }
    }

    /// <summary>
    /// Unbinds the touch move and end events (or the mousemove, mouseup, and mouseleave if in mouse mode)
    /// </summary>
    $.fn.gestureDone = function () {
        return this.each(function (i, el) {
            $(el).unbind(gestureChangeEvent + " " + gestureEndEvent);
        });
    }
//#endif //OWA_BUILD

    // jQuery recently released an alpha with their own attempt at tap and swipe events.
    // It's a very clean system, but it has some limitations that our current implementation solves.
    // The first and foremost problem is that canceling events leaves parent handlers bound that shouldn't be, resulting
    // in an excess of event triggering when the parent handlers eventually do get triggered
    // Bug E15:31868 tracks our research into making their system of managing the events work for us,
    // but for now we need to provide a functioning set of binding functions for owa developers.
    //
    // Here we trigger our own custom event that is the equivalent of a click.
    // We'll only do this in mobile to avoid the inherent click delay that the
    // touch browsers introduce. Also, if the user taps and holds, after 1000ms
    // we'll fire our right click event and cancel the end touch event.
    // So, here's how event handling works:
    //
    // MOUSE MODE:
    // Click: This binds to the native click event, if the mouse button used to generate the click
    //      is the right mouse button, then it will fire the RightClick event
    // Right Click: This binds to the native contextmenu event.  This event is fired by a browser
    //      when it would normally display a contextmenu.  If the consumer binding to this event
    //      doesn't want the context menu to be displayed, they need to preventDefault on it.
    //
    // TOUCH MODE:
    // We place this binding to touchstart on the body.  After we see a touchstart we watch for a touchmove or touchend
    // When we're on a desktop browser using a mouse, we watch the mousedown, mousemove, and mouseup/mouseleave respectively
    // Click: This is fired after every touchstart and touchend.  Each handler is wrapped with code that will determine if both
    //      of the events occurred within the same sub-tree of the element who's handler is firing and execute the tap handler if so.
    //      Due to the nature of the ScrollRegion Control, we must also imply a general move tolerance for taps. A ScrollRegion
    //      moves the element, meaning that the same element will receive the touchstart and touchend events indicating a tap
    //      when really a tap was not intended. 
    //      <reasoning>
    //          We could try tracking the position of the original target, but really it should be trying to track
    //          the position of the element with the handler bound to it, but that also starts implying that a tap
    //          cannot be triggered on an element who changes size or position and is a restriction on how controls behave.
    //          Instead we'll define the limits of the tap (you can't swipe an object and expect a tap). We can fiddle with the
    //          threshold as our UI demands.
    //      </reasoning>
    // Tap and Hold: This is the equivalent of a Right Click in Mouse Mode. The difference here is that once a touch start has fired
    //      we set a timeout that will fire the right click so long as the a touchend has not fired and the touchmove events
    //      fire within a 10px square of the touchstart event by the time the timeout fires.
    // Swipe: This event only gets fired in Touch Mode.  There are 4 directions up, down, left, right; to trigger one, the gesture must be
    //      within 60 degrees from origin in their respective directions. The event will have a direction property that will allow the consumer
    //      to modify their behavior based on the direction of the swipe.  If the any touchStart event does not end in a swipe, a swipe event will be
    //      fired with the direction of "incomplete" when the touchEnd event would fire, but the internal handling will redirect these swipe events
    //      to the provided incomplete swipe handler provided by the consumer.
    if (mode == touchMode)
    {
        $(document).ready(function ()
        {
            var body = $('body');
            body.touch(function (e)
            {
                var moved = false;
                var swiped = false;
                var touchtarget = $(e.target);
                var startcoords = { x: e.pageX, y: e.pageY };
                var currentcoords = { x: e.pageX, y: e.pageY };
                var touches = { start: e.target, end: e.target, coords: currentcoords };
                var swipeData = { direction: "incomplete", coords: currentcoords };

                var tapHoldTimer = setTimeout(function ()
                {
                    body.touchDone();

                    // Just as we trigger a swipe incomplete on a tap we need to trigger a swipe incomplete on tap and hold
                    touchtarget.trigger(swipeEvent, swipeData);

                    // Trigger the tap and hold event
                    touchtarget.trigger(rightClickEvent, touches);
                },
                1000);


                body.touchMove(function (e2)
                {
                    // Update the event coordinates
                    // Since we're manually triggering the events we need to be setting the pageX and pageY when they're handled
                    currentcoords.x = e2.pageX;
                    currentcoords.y = e2.pageY;

                    if (!moved && (Math.abs(startcoords.x - e2.pageX) > 20 || Math.abs(startcoords.y - e2.pageY) > 20))
                    {
                        // If the element is in a scroll region control then we can't be sure of our
                        // logic to determine a good tap.  So if it goes outside the tolerance
                        // range then just cancel the tap / tap and hold
                        moved = true;
                        clearTimeout(tapHoldTimer);

                        // At this point the user is swiping, so we'll fire a swipe event on the touchstart
                        // target.  The !moved of this conditional block will prevent multiple swipe events
                        // from being triggered

                        // Basically, we draw a line from the location of the move event to the 
                        // the location of the start event (effectively our origin on the graph)
                        // Then we check if the angle at which that line leaves the origin is within
                        // the the bounds of the acceptable angles.
                        // This is mathematically called finding the angle of elevation or depression.
                        // We then compare it to our boundary angles so as not to exceed our acceptable angle of elevation
                        var TangentOfThirtyDegrees = 1 / Math.sqrt(3); // max angle of elevation

                        var dx = e2.pageX - startcoords.x;
                        var dy = e2.pageY - startcoords.y;

                        // Absolute values of dx and dy
                        var adx = Math.abs(dx);
                        var ady = Math.abs(dy);

                        // Calculate the slope (rise/run) of the line drawn from the move event to the start event
                        // Swapping the values avoids the undefined tangent of dx = 0, and taking the absolute value
                        // will place all lines in Quadrant I, avoiding negative values and allowing us to check against
                        // just one tangent value.
                        var slopeToOrigin = adx > ady ? ady / adx : adx / ady;

                        if (slopeToOrigin <= TangentOfThirtyDegrees)
                        {
                            swiped = true;

                            // Compare the absolute values of dx and dy to determine axis of movement
                            if (adx > ady)
                            {
                                // Check the sign of delta to determine direction
                                swipeData.direction = dx > 0 ? "right" : "left";
                            }
                            else
                            {
                                // Check the sign of delta to determine direction
                                swipeData.direction = dy > 0 ? "down" : "up";
                            }

                            // Fire the swipe event
                            touchtarget.trigger(swipeEvent, swipeData);
                        }
                    }
                });


                body.touchEnd(function (e3)
                {
                    clearTimeout(tapHoldTimer);
                    body.touchDone();
                    touches.end = e3.target;
                    currentcoords.x = e3.pageX;
                    currentcoords.y = e3.pageY;

                    if (!moved)
                    {
                        // Since the Swipe provides hooks to the touchStart, if we didn't move we need to notify
                        // the swipe handlers that the gesture didn't result in a swipe
                        touchtarget.trigger(swipeEvent, swipeData);

                        // This check is for when we're in touch mode in
                        // a mouse environment, the mouse up and down
                        // with the right button will seem the same as a tap
                        // and since we're distinguishing the events on mobile
                        // we don't want to fire both
                        if (e3.which != 3)
                        {
                            // fire the tap event
                            touchtarget.trigger(clickEvent, touches);
                        }
                    }
                    else if (!swiped)
                    {
                        // If we moved, but that movement didn't result in a swipe, then fire an incomplete swipe
                        // This is the completion of the interaction, much like a touchEnd is the end of a touch
                        touchtarget.trigger(swipeEvent, swipeData);
                    }
                });
            }, false, bodyEvent);
        });
    }
    else
    {
        $(document).ready(function () 
        {
            var body = $('body');
            body.unbind(touchStartEvent + "." + bodyEvent);
        });
    }
}﻿//----------------------------------------------------------
// Copyright (C) Microsoft Corporation. All rights reserved.
//----------------------------------------------------------
// MicrosoftAjax.js
Function.__typeName="Function";Function.__class=true;Function.createCallback=function(b,a){return function(){var e=arguments.length;if(e>0){var d=[];for(var c=0;c<e;c++)d[c]=arguments[c];d[e]=a;return b.apply(this,d)}return b.call(this,a)}};Function.createDelegate=function(a,b){return function(){return b.apply(a,arguments)}};Function.emptyFunction=Function.emptyMethod=function(){};Function.validateParameters=function(c,b,a){return Function._validateParams(c,b,a)};Function._validateParams=function(g,e,c){var a,d=e.length;c=c||typeof c==="undefined";a=Function._validateParameterCount(g,e,c);if(a){a.popStackFrame();return a}for(var b=0,i=g.length;b<i;b++){var f=e[Math.min(b,d-1)],h=f.name;if(f.parameterArray)h+="["+(b-d+1)+"]";else if(!c&&b>=d)break;a=Function._validateParameter(g[b],f,h);if(a){a.popStackFrame();return a}}return null};Function._validateParameterCount=function(j,d,i){var a,c,b=d.length,e=j.length;if(e<b){var f=b;for(a=0;a<b;a++){var g=d[a];if(g.optional||g.parameterArray)f--}if(e<f)c=true}else if(i&&e>b){c=true;for(a=0;a<b;a++)if(d[a].parameterArray){c=false;break}}if(c){var h=Error.parameterCount();h.popStackFrame();return h}return null};Function._validateParameter=function(c,a,h){var b,g=a.type,l=!!a.integer,k=!!a.domElement,m=!!a.mayBeNull;b=Function._validateParameterType(c,g,l,k,m,h);if(b){b.popStackFrame();return b}var e=a.elementType,f=!!a.elementMayBeNull;if(g===Array&&typeof c!=="undefined"&&c!==null&&(e||!f)){var j=!!a.elementInteger,i=!!a.elementDomElement;for(var d=0;d<c.length;d++){var n=c[d];b=Function._validateParameterType(n,e,j,i,f,h+"["+d+"]");if(b){b.popStackFrame();return b}}}return null};Function._validateParameterType=function(b,c,k,j,h,d){var a,g;if(typeof b==="undefined")if(h)return null;else{a=Error.argumentUndefined(d);a.popStackFrame();return a}if(b===null)if(h)return null;else{a=Error.argumentNull(d);a.popStackFrame();return a}if(c&&c.__enum){if(typeof b!=="number"){a=Error.argumentType(d,Object.getType(b),c);a.popStackFrame();return a}if(b%1===0){var e=c.prototype;if(!c.__flags||b===0){for(g in e)if(e[g]===b)return null}else{var i=b;for(g in e){var f=e[g];if(f===0)continue;if((f&b)===f)i-=f;if(i===0)return null}}}a=Error.argumentOutOfRange(d,b,String.format(Sys.Res.enumInvalidValue,b,c.getName()));a.popStackFrame();return a}if(j&&(!Sys._isDomElement(b)||b.nodeType===3)){a=Error.argument(d,Sys.Res.argumentDomElement);a.popStackFrame();return a}if(c&&!Sys._isInstanceOfType(c,b)){a=Error.argumentType(d,Object.getType(b),c);a.popStackFrame();return a}if(c===Number&&k)if(b%1!==0){a=Error.argumentOutOfRange(d,b,Sys.Res.argumentInteger);a.popStackFrame();return a}return null};Error.__typeName="Error";Error.__class=true;Error.create=function(d,b){var a=new Error(d);a.message=d;if(b)for(var c in b)a[c]=b[c];a.popStackFrame();return a};Error.argument=function(a,c){var b="Sys.ArgumentException: "+(c?c:Sys.Res.argument);if(a)b+="\n"+String.format(Sys.Res.paramName,a);var d=Error.create(b,{name:"Sys.ArgumentException",paramName:a});d.popStackFrame();return d};Error.argumentNull=function(a,c){var b="Sys.ArgumentNullException: "+(c?c:Sys.Res.argumentNull);if(a)b+="\n"+String.format(Sys.Res.paramName,a);var d=Error.create(b,{name:"Sys.ArgumentNullException",paramName:a});d.popStackFrame();return d};Error.argumentOutOfRange=function(c,a,d){var b="Sys.ArgumentOutOfRangeException: "+(d?d:Sys.Res.argumentOutOfRange);if(c)b+="\n"+String.format(Sys.Res.paramName,c);if(typeof a!=="undefined"&&a!==null)b+="\n"+String.format(Sys.Res.actualValue,a);var e=Error.create(b,{name:"Sys.ArgumentOutOfRangeException",paramName:c,actualValue:a});e.popStackFrame();return e};Error.argumentType=function(d,c,b,e){var a="Sys.ArgumentTypeException: ";if(e)a+=e;else if(c&&b)a+=String.format(Sys.Res.argumentTypeWithTypes,c.getName(),b.getName());else a+=Sys.Res.argumentType;if(d)a+="\n"+String.format(Sys.Res.paramName,d);var f=Error.create(a,{name:"Sys.ArgumentTypeException",paramName:d,actualType:c,expectedType:b});f.popStackFrame();return f};Error.argumentUndefined=function(a,c){var b="Sys.ArgumentUndefinedException: "+(c?c:Sys.Res.argumentUndefined);if(a)b+="\n"+String.format(Sys.Res.paramName,a);var d=Error.create(b,{name:"Sys.ArgumentUndefinedException",paramName:a});d.popStackFrame();return d};Error.format=function(a){var c="Sys.FormatException: "+(a?a:Sys.Res.format),b=Error.create(c,{name:"Sys.FormatException"});b.popStackFrame();return b};Error.invalidOperation=function(a){var c="Sys.InvalidOperationException: "+(a?a:Sys.Res.invalidOperation),b=Error.create(c,{name:"Sys.InvalidOperationException"});b.popStackFrame();return b};Error.notImplemented=function(a){var c="Sys.NotImplementedException: "+(a?a:Sys.Res.notImplemented),b=Error.create(c,{name:"Sys.NotImplementedException"});b.popStackFrame();return b};Error.parameterCount=function(a){var c="Sys.ParameterCountException: "+(a?a:Sys.Res.parameterCount),b=Error.create(c,{name:"Sys.ParameterCountException"});b.popStackFrame();return b};Error.prototype.popStackFrame=function(){if(typeof this.stack==="undefined"||this.stack===null||typeof this.fileName==="undefined"||this.fileName===null||typeof this.lineNumber==="undefined"||this.lineNumber===null)return;var a=this.stack.split("\n"),c=a[0],e=this.fileName+":"+this.lineNumber;while(typeof c!=="undefined"&&c!==null&&c.indexOf(e)===-1){a.shift();c=a[0]}var d=a[1];if(typeof d==="undefined"||d===null)return;var b=d.match(/@(.*):(\d+)$/);if(typeof b==="undefined"||b===null)return;this.fileName=b[1];this.lineNumber=parseInt(b[2]);a.shift();this.stack=a.join("\n")};Object.__typeName="Object";Object.__class=true;Object.getType=function(b){var a=b.constructor;if(!a||typeof a!=="function"||!a.__typeName||a.__typeName==="Object")return Object;return a};Object.getTypeName=function(a){return Object.getType(a).getName()};String.__typeName="String";String.__class=true;String.prototype.endsWith=function(a){return this.substr(this.length-a.length)===a};String.prototype.startsWith=function(a){return this.substr(0,a.length)===a};String.prototype.trim=function(){return this.replace(/^\s+|\s+$/g,"")};String.prototype.trimEnd=function(){return this.replace(/\s+$/,"")};String.prototype.trimStart=function(){return this.replace(/^\s+/,"")};String.format=function(){return String._toFormattedString(false,arguments)};String._toFormattedString=function(l,j){var c="",e=j[0];for(var a=0;true;){var f=e.indexOf("{",a),d=e.indexOf("}",a);if(f<0&&d<0){c+=e.slice(a);break}if(d>0&&(d<f||f<0)){c+=e.slice(a,d+1);a=d+2;continue}c+=e.slice(a,f);a=f+1;if(e.charAt(a)==="{"){c+="{";a++;continue}if(d<0)break;var h=e.substring(a,d),g=h.indexOf(":"),k=parseInt(g<0?h:h.substring(0,g),10)+1,i=g<0?"":h.substring(g+1),b=j[k];if(typeof b==="undefined"||b===null)b="";if(b.toFormattedString)c+=b.toFormattedString(i);else if(l&&b.localeFormat)c+=b.localeFormat(i);else if(b.format)c+=b.format(i);else c+=b.toString();a=d+1}return c};Boolean.__typeName="Boolean";Boolean.__class=true;Boolean.parse=function(b){var a=b.trim().toLowerCase();if(a==="false")return false;if(a==="true")return true};Date.__typeName="Date";Date.__class=true;Number.__typeName="Number";Number.__class=true;RegExp.__typeName="RegExp";RegExp.__class=true;if(!window)this.window=this;window.Type=Function;Type.prototype.callBaseMethod=function(a,d,b){var c=Sys._getBaseMethod(this,a,d);if(!b)return c.apply(a);else return c.apply(a,b)};Type.prototype.getBaseMethod=function(a,b){return Sys._getBaseMethod(this,a,b)};Type.prototype.getBaseType=function(){return typeof this.__baseType==="undefined"?null:this.__baseType};Type.prototype.getInterfaces=function(){var a=[],b=this;while(b){var c=b.__interfaces;if(c)for(var d=0,f=c.length;d<f;d++){var e=c[d];if(!Array.contains(a,e))a[a.length]=e}b=b.__baseType}return a};Type.prototype.getName=function(){return typeof this.__typeName==="undefined"?"":this.__typeName};Type.prototype.implementsInterface=function(d){this.resolveInheritance();var c=d.getName(),a=this.__interfaceCache;if(a){var e=a[c];if(typeof e!=="undefined")return e}else a=this.__interfaceCache={};var b=this;while(b){var f=b.__interfaces;if(f)if(Array.indexOf(f,d)!==-1)return a[c]=true;b=b.__baseType}return a[c]=false};Type.prototype.inheritsFrom=function(b){this.resolveInheritance();var a=this.__baseType;while(a){if(a===b)return true;a=a.__baseType}return false};Type.prototype.initializeBase=function(a,b){this.resolveInheritance();if(this.__baseType)if(!b)this.__baseType.apply(a);else this.__baseType.apply(a,b);return a};Type.prototype.isImplementedBy=function(a){if(typeof a==="undefined"||a===null)return false;var b=Object.getType(a);return !!(b.implementsInterface&&b.implementsInterface(this))};Type.prototype.isInstanceOfType=function(a){return Sys._isInstanceOfType(this,a)};Type.prototype.registerClass=function(c,b,d){this.prototype.constructor=this;this.__typeName=c;this.__class=true;if(b){this.__baseType=b;this.__basePrototypePending=true}Sys.__upperCaseTypes[c.toUpperCase()]=this;if(d){this.__interfaces=[];for(var a=2,f=arguments.length;a<f;a++){var e=arguments[a];this.__interfaces.push(e)}}return this};Type.prototype.registerInterface=function(a){Sys.__upperCaseTypes[a.toUpperCase()]=this;this.prototype.constructor=this;this.__typeName=a;this.__interface=true;return this};Type.prototype.resolveInheritance=function(){if(this.__basePrototypePending){var b=this.__baseType;b.resolveInheritance();for(var a in b.prototype){var c=b.prototype[a];if(!this.prototype[a])this.prototype[a]=c}delete this.__basePrototypePending}};Type.getRootNamespaces=function(){return Array.clone(Sys.__rootNamespaces)};Type.isClass=function(a){if(typeof a==="undefined"||a===null)return false;return !!a.__class};Type.isInterface=function(a){if(typeof a==="undefined"||a===null)return false;return !!a.__interface};Type.isNamespace=function(a){if(typeof a==="undefined"||a===null)return false;return !!a.__namespace};Type.parse=function(typeName,ns){var fn;if(ns){fn=Sys.__upperCaseTypes[ns.getName().toUpperCase()+"."+typeName.toUpperCase()];return fn||null}if(!typeName)return null;if(!Type.__htClasses)Type.__htClasses={};fn=Type.__htClasses[typeName];if(!fn){fn=eval(typeName);Type.__htClasses[typeName]=fn}return fn};Type.registerNamespace=function(e){var d=window,c=e.split(".");for(var b=0;b<c.length;b++){var f=c[b],a=d[f];if(!a)a=d[f]={};if(!a.__namespace){if(b===0&&e!=="Sys")Sys.__rootNamespaces[Sys.__rootNamespaces.length]=a;a.__namespace=true;a.__typeName=c.slice(0,b+1).join(".");a.getName=function(){return this.__typeName}}d=a}};Type._checkDependency=function(c,a){var d=Type._registerScript._scripts,b=d?!!d[c]:false;if(typeof a!=="undefined"&&!b)throw Error.invalidOperation(String.format(Sys.Res.requiredScriptReferenceNotIncluded,a,c));return b};Type._registerScript=function(a,c){var b=Type._registerScript._scripts;if(!b)Type._registerScript._scripts=b={};if(b[a])throw Error.invalidOperation(String.format(Sys.Res.scriptAlreadyLoaded,a));b[a]=true;if(c)for(var d=0,f=c.length;d<f;d++){var e=c[d];if(!Type._checkDependency(e))throw Error.invalidOperation(String.format(Sys.Res.scriptDependencyNotFound,a,e))}};Type.registerNamespace("Sys");Sys.__upperCaseTypes={};Sys.__rootNamespaces=[Sys];Sys._isInstanceOfType=function(c,b){if(typeof b==="undefined"||b===null)return false;if(b instanceof c)return true;var a=Object.getType(b);return !!(a===c)||a.inheritsFrom&&a.inheritsFrom(c)||a.implementsInterface&&a.implementsInterface(c)};Sys._getBaseMethod=function(d,e,c){var b=d.getBaseType();if(b){var a=b.prototype[c];return a instanceof Function?a:null}return null};Sys._isDomElement=function(a){var c=false;if(typeof a.nodeType!=="number"){var b=a.ownerDocument||a.document||a;if(b!=a){var d=b.defaultView||b.parentWindow;c=d!=a}else c=typeof b.body==="undefined"}return !c};Array.__typeName="Array";Array.__class=true;Array.add=Array.enqueue=function(a,b){a[a.length]=b};Array.addRange=function(a,b){a.push.apply(a,b)};Array.clear=function(a){a.length=0};Array.clone=function(a){if(a.length===1)return [a[0]];else return Array.apply(null,a)};Array.contains=function(a,b){return Sys._indexOf(a,b)>=0};Array.dequeue=function(a){return a.shift()};Array.forEach=function(b,e,d){for(var a=0,f=b.length;a<f;a++){var c=b[a];if(typeof c!=="undefined")e.call(d,c,a,b)}};Array.indexOf=function(a,c,b){return Sys._indexOf(a,c,b)};Array.insert=function(a,b,c){a.splice(b,0,c)};Array.parse=function(value){if(!value)return [];return eval(value)};Array.remove=function(b,c){var a=Sys._indexOf(b,c);if(a>=0)b.splice(a,1);return a>=0};Array.removeAt=function(a,b){a.splice(b,1)};Sys._indexOf=function(d,e,a){if(typeof e==="undefined")return -1;var c=d.length;if(c!==0){a=a-0;if(isNaN(a))a=0;else{if(isFinite(a))a=a-a%1;if(a<0)a=Math.max(0,c+a)}for(var b=a;b<c;b++)if(typeof d[b]!=="undefined"&&d[b]===e)return b}return -1};Type._registerScript._scripts={"MicrosoftAjaxCore.js":true,"MicrosoftAjaxGlobalization.js":true,"MicrosoftAjaxSerialization.js":true,"MicrosoftAjaxComponentModel.js":true,"MicrosoftAjaxHistory.js":true,"MicrosoftAjaxNetwork.js":true,"MicrosoftAjaxWebServices.js":true};Sys.IDisposable=function(){};Sys.IDisposable.prototype={};Sys.IDisposable.registerInterface("Sys.IDisposable");Sys.StringBuilder=function(a){this._parts=typeof a!=="undefined"&&a!==null&&a!==""?[a.toString()]:[];this._value={};this._len=0};Sys.StringBuilder.prototype={append:function(a){this._parts[this._parts.length]=a},appendLine:function(a){this._parts[this._parts.length]=typeof a==="undefined"||a===null||a===""?"\r\n":a+"\r\n"},clear:function(){this._parts=[];this._value={};this._len=0},isEmpty:function(){if(this._parts.length===0)return true;return this.toString()===""},toString:function(a){a=a||"";var b=this._parts;if(this._len!==b.length){this._value={};this._len=b.length}var d=this._value;if(typeof d[a]==="undefined"){if(a!=="")for(var c=0;c<b.length;)if(typeof b[c]==="undefined"||b[c]===""||b[c]===null)b.splice(c,1);else c++;d[a]=this._parts.join(a)}return d[a]}};Sys.StringBuilder.registerClass("Sys.StringBuilder");Sys.Browser={};Sys.Browser.InternetExplorer={};Sys.Browser.Firefox={};Sys.Browser.Safari={};Sys.Browser.Opera={};Sys.Browser.agent=null;Sys.Browser.hasDebuggerStatement=false;Sys.Browser.name=navigator.appName;Sys.Browser.version=parseFloat(navigator.appVersion);Sys.Browser.documentMode=0;if(navigator.userAgent.indexOf(" MSIE ")>-1){Sys.Browser.agent=Sys.Browser.InternetExplorer;Sys.Browser.version=parseFloat(navigator.userAgent.match(/MSIE (\d+\.\d+)/)[1]);if(Sys.Browser.version>=8)if(document.documentMode>=7)Sys.Browser.documentMode=document.documentMode;Sys.Browser.hasDebuggerStatement=true}else if(navigator.userAgent.indexOf(" Firefox/")>-1){Sys.Browser.agent=Sys.Browser.Firefox;Sys.Browser.version=parseFloat(navigator.userAgent.match(/Firefox\/(\d+\.\d+)/)[1]);Sys.Browser.name="Firefox";Sys.Browser.hasDebuggerStatement=true}else if(navigator.userAgent.indexOf(" AppleWebKit/")>-1){Sys.Browser.agent=Sys.Browser.Safari;Sys.Browser.version=parseFloat(navigator.userAgent.match(/AppleWebKit\/(\d+(\.\d+)?)/)[1]);Sys.Browser.name="Safari"}else if(navigator.userAgent.indexOf("Opera/")>-1)Sys.Browser.agent=Sys.Browser.Opera;Sys.EventArgs=function(){};Sys.EventArgs.registerClass("Sys.EventArgs");Sys.EventArgs.Empty=new Sys.EventArgs;Sys.CancelEventArgs=function(){Sys.CancelEventArgs.initializeBase(this);this._cancel=false};Sys.CancelEventArgs.prototype={get_cancel:function(){return this._cancel},set_cancel:function(a){this._cancel=a}};Sys.CancelEventArgs.registerClass("Sys.CancelEventArgs",Sys.EventArgs);Type.registerNamespace("Sys.UI");Sys._Debug=function(){};Sys._Debug.prototype={_appendConsole:function(a){if(typeof Debug!=="undefined"&&Debug.writeln)Debug.writeln(a);if(window.console&&window.console.log)window.console.log(a);if(window.opera)window.opera.postError(a);if(window.debugService)window.debugService.trace(a)},_appendTrace:function(b){var a=document.getElementById("TraceConsole");if(a&&a.tagName.toUpperCase()==="TEXTAREA")a.value+=b+"\n"},assert:function(c,a,b){if(!c){a=b&&this.assert.caller?String.format(Sys.Res.assertFailedCaller,a,this.assert.caller):String.format(Sys.Res.assertFailed,a);if(confirm(String.format(Sys.Res.breakIntoDebugger,a)))this.fail(a)}},clearTrace:function(){var a=document.getElementById("TraceConsole");if(a&&a.tagName.toUpperCase()==="TEXTAREA")a.value=""},fail:function(message){this._appendConsole(message);if(Sys.Browser.hasDebuggerStatement)eval("debugger")},trace:function(a){this._appendConsole(a);this._appendTrace(a)},traceDump:function(a,b){var c=this._traceDump(a,b,true)},_traceDump:function(a,c,f,b,d){c=c?c:"traceDump";b=b?b:"";if(a===null){this.trace(b+c+": null");return}switch(typeof a){case "undefined":this.trace(b+c+": Undefined");break;case "number":case "string":case "boolean":this.trace(b+c+": "+a);break;default:if(Date.isInstanceOfType(a)||RegExp.isInstanceOfType(a)){this.trace(b+c+": "+a.toString());break}if(!d)d=[];else if(Array.contains(d,a)){this.trace(b+c+": ...");return}Array.add(d,a);if(a==window||a===document||window.HTMLElement&&a instanceof HTMLElement||typeof a.nodeName==="string"){var k=a.tagName?a.tagName:"DomElement";if(a.id)k+=" - "+a.id;this.trace(b+c+" {"+k+"}")}else{var i=Object.getTypeName(a);this.trace(b+c+(typeof i==="string"?" {"+i+"}":""));if(b===""||f){b+="    ";var e,j,l,g,h;if(Array.isInstanceOfType(a)){j=a.length;for(e=0;e<j;e++)this._traceDump(a[e],"["+e+"]",f,b,d)}else for(g in a){h=a[g];if(!Function.isInstanceOfType(h))this._traceDump(h,g,f,b,d)}}}Array.remove(d,a)}}};Sys._Debug.registerClass("Sys._Debug");Sys.Debug=new Sys._Debug;Sys.Debug.isDebug=false;function Sys$Enum$parse(c,e){var a,b,i;if(e){a=this.__lowerCaseValues;if(!a){this.__lowerCaseValues=a={};var g=this.prototype;for(var f in g)a[f.toLowerCase()]=g[f]}}else a=this.prototype;if(!this.__flags){i=e?c.toLowerCase():c;b=a[i.trim()];if(typeof b!=="number")throw Error.argument("value",String.format(Sys.Res.enumInvalidValue,c,this.__typeName));return b}else{var h=(e?c.toLowerCase():c).split(","),j=0;for(var d=h.length-1;d>=0;d--){var k=h[d].trim();b=a[k];if(typeof b!=="number")throw Error.argument("value",String.format(Sys.Res.enumInvalidValue,c.split(",")[d].trim(),this.__typeName));j|=b}return j}}function Sys$Enum$toString(c){if(typeof c==="undefined"||c===null)return this.__string;var d=this.prototype,a;if(!this.__flags||c===0){for(a in d)if(d[a]===c)return a}else{var b=this.__sortedValues;if(!b){b=[];for(a in d)b[b.length]={key:a,value:d[a]};b.sort(function(a,b){return a.value-b.value});this.__sortedValues=b}var e=[],g=c;for(a=b.length-1;a>=0;a--){var h=b[a],f=h.value;if(f===0)continue;if((f&c)===f){e[e.length]=h.key;g-=f;if(g===0)break}}if(e.length&&g===0)return e.reverse().join(", ")}return ""}Type.prototype.registerEnum=function(b,c){Sys.__upperCaseTypes[b.toUpperCase()]=this;for(var a in this.prototype)this[a]=this.prototype[a];this.__typeName=b;this.parse=Sys$Enum$parse;this.__string=this.toString();this.toString=Sys$Enum$toString;this.__flags=c;this.__enum=true};Type.isEnum=function(a){if(typeof a==="undefined"||a===null)return false;return !!a.__enum};Type.isFlags=function(a){if(typeof a==="undefined"||a===null)return false;return !!a.__flags};Sys.CollectionChange=function(e,a,c,b,d){this.action=e;if(a)if(!(a instanceof Array))a=[a];this.newItems=a||null;if(typeof c!=="number")c=-1;this.newStartingIndex=c;if(b)if(!(b instanceof Array))b=[b];this.oldItems=b||null;if(typeof d!=="number")d=-1;this.oldStartingIndex=d};Sys.CollectionChange.registerClass("Sys.CollectionChange");Sys.NotifyCollectionChangedAction=function(){throw Error.notImplemented()};Sys.NotifyCollectionChangedAction.prototype={add:0,remove:1,reset:2};Sys.NotifyCollectionChangedAction.registerEnum("Sys.NotifyCollectionChangedAction");Sys.NotifyCollectionChangedEventArgs=function(a){this._changes=a;Sys.NotifyCollectionChangedEventArgs.initializeBase(this)};Sys.NotifyCollectionChangedEventArgs.prototype={get_changes:function(){return this._changes||[]}};Sys.NotifyCollectionChangedEventArgs.registerClass("Sys.NotifyCollectionChangedEventArgs",Sys.EventArgs);Sys.Observer=function(){};Sys.Observer.registerClass("Sys.Observer");Sys.Observer.makeObservable=function(a){var c=a instanceof Array,b=Sys.Observer;if(a.setValue===b._observeMethods.setValue)return a;b._addMethods(a,b._observeMethods);if(c)b._addMethods(a,b._arrayMethods);return a};Sys.Observer._addMethods=function(c,b){for(var a in b)c[a]=b[a]};Sys.Observer._addEventHandler=function(c,a,b){Sys.Observer._getContext(c,true).events._addHandler(a,b)};Sys.Observer.addEventHandler=function(c,a,b){Sys.Observer._addEventHandler(c,a,b)};Sys.Observer._removeEventHandler=function(c,a,b){Sys.Observer._getContext(c,true).events._removeHandler(a,b)};Sys.Observer.removeEventHandler=function(c,a,b){Sys.Observer._removeEventHandler(c,a,b)};Sys.Observer.raiseEvent=function(b,e,d){var c=Sys.Observer._getContext(b);if(!c)return;var a=c.events.getHandler(e);if(a)a(b,d)};Sys.Observer.addPropertyChanged=function(b,a){Sys.Observer._addEventHandler(b,"propertyChanged",a)};Sys.Observer.removePropertyChanged=function(b,a){Sys.Observer._removeEventHandler(b,"propertyChanged",a)};Sys.Observer.beginUpdate=function(a){Sys.Observer._getContext(a,true).updating=true};Sys.Observer.endUpdate=function(b){var a=Sys.Observer._getContext(b);if(!a||!a.updating)return;a.updating=false;var d=a.dirty;a.dirty=false;if(d){if(b instanceof Array){var c=a.changes;a.changes=null;Sys.Observer.raiseCollectionChanged(b,c)}Sys.Observer.raisePropertyChanged(b,"")}};Sys.Observer.isUpdating=function(b){var a=Sys.Observer._getContext(b);return a?a.updating:false};Sys.Observer._setValue=function(a,j,g){var b,f,k=a,d=j.split(".");for(var i=0,m=d.length-1;i<m;i++){var l=d[i];b=a["get_"+l];if(typeof b==="function")a=b.call(a);else a=a[l];var n=typeof a;if(a===null||n==="undefined")throw Error.invalidOperation(String.format(Sys.Res.nullReferenceInPath,j))}var e,c=d[m];b=a["get_"+c];f=a["set_"+c];if(typeof b==="function")e=b.call(a);else e=a[c];if(typeof f==="function")f.call(a,g);else a[c]=g;if(e!==g){var h=Sys.Observer._getContext(k);if(h&&h.updating){h.dirty=true;return}Sys.Observer.raisePropertyChanged(k,d[0])}};Sys.Observer.setValue=function(b,a,c){Sys.Observer._setValue(b,a,c)};Sys.Observer.raisePropertyChanged=function(b,a){Sys.Observer.raiseEvent(b,"propertyChanged",new Sys.PropertyChangedEventArgs(a))};Sys.Observer.addCollectionChanged=function(b,a){Sys.Observer._addEventHandler(b,"collectionChanged",a)};Sys.Observer.removeCollectionChanged=function(b,a){Sys.Observer._removeEventHandler(b,"collectionChanged",a)};Sys.Observer._collectionChange=function(d,c){var a=Sys.Observer._getContext(d);if(a&&a.updating){a.dirty=true;var b=a.changes;if(!b)a.changes=b=[c];else b.push(c)}else{Sys.Observer.raiseCollectionChanged(d,[c]);Sys.Observer.raisePropertyChanged(d,"length")}};Sys.Observer.add=function(a,b){var c=new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.add,[b],a.length);Array.add(a,b);Sys.Observer._collectionChange(a,c)};Sys.Observer.addRange=function(a,b){var c=new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.add,b,a.length);Array.addRange(a,b);Sys.Observer._collectionChange(a,c)};Sys.Observer.clear=function(a){var b=Array.clone(a);Array.clear(a);Sys.Observer._collectionChange(a,new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.reset,null,-1,b,0))};Sys.Observer.insert=function(a,b,c){Array.insert(a,b,c);Sys.Observer._collectionChange(a,new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.add,[c],b))};Sys.Observer.remove=function(a,b){var c=Array.indexOf(a,b);if(c!==-1){Array.remove(a,b);Sys.Observer._collectionChange(a,new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.remove,null,-1,[b],c));return true}return false};Sys.Observer.removeAt=function(b,a){if(a>-1&&a<b.length){var c=b[a];Array.removeAt(b,a);Sys.Observer._collectionChange(b,new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.remove,null,-1,[c],a))}};Sys.Observer.raiseCollectionChanged=function(b,a){Sys.Observer.raiseEvent(b,"collectionChanged",new Sys.NotifyCollectionChangedEventArgs(a))};Sys.Observer._observeMethods={add_propertyChanged:function(a){Sys.Observer._addEventHandler(this,"propertyChanged",a)},remove_propertyChanged:function(a){Sys.Observer._removeEventHandler(this,"propertyChanged",a)},addEventHandler:function(a,b){Sys.Observer._addEventHandler(this,a,b)},removeEventHandler:function(a,b){Sys.Observer._removeEventHandler(this,a,b)},get_isUpdating:function(){return Sys.Observer.isUpdating(this)},beginUpdate:function(){Sys.Observer.beginUpdate(this)},endUpdate:function(){Sys.Observer.endUpdate(this)},setValue:function(b,a){Sys.Observer._setValue(this,b,a)},raiseEvent:function(b,a){Sys.Observer.raiseEvent(this,b,a)},raisePropertyChanged:function(a){Sys.Observer.raiseEvent(this,"propertyChanged",new Sys.PropertyChangedEventArgs(a))}};Sys.Observer._arrayMethods={add_collectionChanged:function(a){Sys.Observer._addEventHandler(this,"collectionChanged",a)},remove_collectionChanged:function(a){Sys.Observer._removeEventHandler(this,"collectionChanged",a)},add:function(a){Sys.Observer.add(this,a)},addRange:function(a){Sys.Observer.addRange(this,a)},clear:function(){Sys.Observer.clear(this)},insert:function(a,b){Sys.Observer.insert(this,a,b)},remove:function(a){return Sys.Observer.remove(this,a)},removeAt:function(a){Sys.Observer.removeAt(this,a)},raiseCollectionChanged:function(a){Sys.Observer.raiseEvent(this,"collectionChanged",new Sys.NotifyCollectionChangedEventArgs(a))}};Sys.Observer._getContext=function(b,c){var a=b._observerContext;if(a)return a();if(c)return (b._observerContext=Sys.Observer._createContext())();return null};Sys.Observer._createContext=function(){var a={events:new Sys.EventHandlerList};return function(){return a}};Date._appendPreOrPostMatch=function(e,b){var d=0,a=false;for(var c=0,g=e.length;c<g;c++){var f=e.charAt(c);switch(f){case "'":if(a)b.append("'");else d++;a=false;break;case "\\":if(a)b.append("\\");a=!a;break;default:b.append(f);a=false}}return d};Date._expandFormat=function(a,b){if(!b)b="F";var c=b.length;if(c===1)switch(b){case "d":return a.ShortDatePattern;case "D":return a.LongDatePattern;case "t":return a.ShortTimePattern;case "T":return a.LongTimePattern;case "f":return a.LongDatePattern+" "+a.ShortTimePattern;case "F":return a.FullDateTimePattern;case "M":case "m":return a.MonthDayPattern;case "s":return a.SortableDateTimePattern;case "Y":case "y":return a.YearMonthPattern;default:throw Error.format(Sys.Res.formatInvalidString)}else if(c===2&&b.charAt(0)==="%")b=b.charAt(1);return b};Date._expandYear=function(c,a){var d=new Date,e=Date._getEra(d);if(a<100){var b=Date._getEraYear(d,c,e);a+=b-b%100;if(a>c.Calendar.TwoDigitYearMax)a-=100}return a};Date._getEra=function(e,c){if(!c)return 0;var b,d=e.getTime();for(var a=0,f=c.length;a<f;a+=4){b=c[a+2];if(b===null||d>=b)return a}return 0};Date._getEraYear=function(d,b,e,c){var a=d.getFullYear();if(!c&&b.eras)a-=b.eras[e+3];return a};Date._getParseRegExp=function(b,e){if(!b._parseRegExp)b._parseRegExp={};else if(b._parseRegExp[e])return b._parseRegExp[e];var c=Date._expandFormat(b,e);c=c.replace(/([\^\$\.\*\+\?\|\[\]\(\)\{\}])/g,"\\\\$1");var a=new Sys.StringBuilder("^"),j=[],f=0,i=0,h=Date._getTokenRegExp(),d;while((d=h.exec(c))!==null){var l=c.slice(f,d.index);f=h.lastIndex;i+=Date._appendPreOrPostMatch(l,a);if(i%2===1){a.append(d[0]);continue}switch(d[0]){case "dddd":case "ddd":case "MMMM":case "MMM":case "gg":case "g":a.append("(\\D+)");break;case "tt":case "t":a.append("(\\D*)");break;case "yyyy":a.append("(\\d{4})");break;case "fff":a.append("(\\d{3})");break;case "ff":a.append("(\\d{2})");break;case "f":a.append("(\\d)");break;case "dd":case "d":case "MM":case "M":case "yy":case "y":case "HH":case "H":case "hh":case "h":case "mm":case "m":case "ss":case "s":a.append("(\\d\\d?)");break;case "zzz":a.append("([+-]?\\d\\d?:\\d{2})");break;case "zz":case "z":a.append("([+-]?\\d\\d?)");break;case "/":a.append("(\\"+b.DateSeparator+")")}Array.add(j,d[0])}Date._appendPreOrPostMatch(c.slice(f),a);a.append("$");var k=a.toString().replace(/\s+/g,"\\s+"),g={"regExp":k,"groups":j};b._parseRegExp[e]=g;return g};Date._getTokenRegExp=function(){return /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g};Date.parseLocale=function(a){return Date._parse(a,Sys.CultureInfo.CurrentCulture,arguments)};Date.parseInvariant=function(a){return Date._parse(a,Sys.CultureInfo.InvariantCulture,arguments)};Date._parse=function(h,d,i){var a,c,b,f,e,g=false;for(a=1,c=i.length;a<c;a++){f=i[a];if(f){g=true;b=Date._parseExact(h,f,d);if(b)return b}}if(!g){e=d._getDateTimeFormats();for(a=0,c=e.length;a<c;a++){b=Date._parseExact(h,e[a],d);if(b)return b}}return null};Date._parseExact=function(w,D,k){w=w.trim();var g=k.dateTimeFormat,A=Date._getParseRegExp(g,D),C=(new RegExp(A.regExp)).exec(w);if(C===null)return null;var B=A.groups,x=null,e=null,c=null,j=null,i=null,d=0,h,p=0,q=0,f=0,l=null,v=false;for(var s=0,E=B.length;s<E;s++){var a=C[s+1];if(a)switch(B[s]){case "dd":case "d":j=parseInt(a,10);if(j<1||j>31)return null;break;case "MMMM":c=k._getMonthIndex(a);if(c<0||c>11)return null;break;case "MMM":c=k._getAbbrMonthIndex(a);if(c<0||c>11)return null;break;case "M":case "MM":c=parseInt(a,10)-1;if(c<0||c>11)return null;break;case "y":case "yy":e=Date._expandYear(g,parseInt(a,10));if(e<0||e>9999)return null;break;case "yyyy":e=parseInt(a,10);if(e<0||e>9999)return null;break;case "h":case "hh":d=parseInt(a,10);if(d===12)d=0;if(d<0||d>11)return null;break;case "H":case "HH":d=parseInt(a,10);if(d<0||d>23)return null;break;case "m":case "mm":p=parseInt(a,10);if(p<0||p>59)return null;break;case "s":case "ss":q=parseInt(a,10);if(q<0||q>59)return null;break;case "tt":case "t":var z=a.toUpperCase();v=z===g.PMDesignator.toUpperCase();if(!v&&z!==g.AMDesignator.toUpperCase())return null;break;case "f":f=parseInt(a,10)*100;if(f<0||f>999)return null;break;case "ff":f=parseInt(a,10)*10;if(f<0||f>999)return null;break;case "fff":f=parseInt(a,10);if(f<0||f>999)return null;break;case "dddd":i=k._getDayIndex(a);if(i<0||i>6)return null;break;case "ddd":i=k._getAbbrDayIndex(a);if(i<0||i>6)return null;break;case "zzz":var u=a.split(/:/);if(u.length!==2)return null;h=parseInt(u[0],10);if(h<-12||h>13)return null;var m=parseInt(u[1],10);if(m<0||m>59)return null;l=h*60+(a.startsWith("-")?-m:m);break;case "z":case "zz":h=parseInt(a,10);if(h<-12||h>13)return null;l=h*60;break;case "g":case "gg":var o=a;if(!o||!g.eras)return null;o=o.toLowerCase().trim();for(var r=0,F=g.eras.length;r<F;r+=4)if(o===g.eras[r+1].toLowerCase()){x=r;break}if(x===null)return null}}var b=new Date,t,n=g.Calendar.convert;if(n)t=n.fromGregorian(b)[0];else t=b.getFullYear();if(e===null)e=t;else if(g.eras)e+=g.eras[(x||0)+3];if(c===null)c=0;if(j===null)j=1;if(n){b=n.toGregorian(e,c,j);if(b===null)return null}else{b.setFullYear(e,c,j);if(b.getDate()!==j)return null;if(i!==null&&b.getDay()!==i)return null}if(v&&d<12)d+=12;b.setHours(d,p,q,f);if(l!==null){var y=b.getMinutes()-(l+b.getTimezoneOffset());b.setHours(b.getHours()+parseInt(y/60,10),y%60)}return b};Date.prototype.format=function(a){return this._toFormattedString(a,Sys.CultureInfo.InvariantCulture)};Date.prototype.localeFormat=function(a){return this._toFormattedString(a,Sys.CultureInfo.CurrentCulture)};Date.prototype._toFormattedString=function(e,j){var b=j.dateTimeFormat,n=b.Calendar.convert;if(!e||!e.length||e==="i")if(j&&j.name.length)if(n)return this._toFormattedString(b.FullDateTimePattern,j);else{var r=new Date(this.getTime()),x=Date._getEra(this,b.eras);r.setFullYear(Date._getEraYear(this,b,x));return r.toLocaleString()}else return this.toString();var l=b.eras,k=e==="s";e=Date._expandFormat(b,e);var a=new Sys.StringBuilder,c;function d(a){if(a<10)return "0"+a;return a.toString()}function m(a){if(a<10)return "00"+a;if(a<100)return "0"+a;return a.toString()}function v(a){if(a<10)return "000"+a;else if(a<100)return "00"+a;else if(a<1000)return "0"+a;return a.toString()}var h,p,t=/([^d]|^)(d|dd)([^d]|$)/g;function s(){if(h||p)return h;h=t.test(e);p=true;return h}var q=0,o=Date._getTokenRegExp(),f;if(!k&&n)f=n.fromGregorian(this);for(;true;){var w=o.lastIndex,i=o.exec(e),u=e.slice(w,i?i.index:e.length);q+=Date._appendPreOrPostMatch(u,a);if(!i)break;if(q%2===1){a.append(i[0]);continue}function g(a,b){if(f)return f[b];switch(b){case 0:return a.getFullYear();case 1:return a.getMonth();case 2:return a.getDate()}}switch(i[0]){case "dddd":a.append(b.DayNames[this.getDay()]);break;case "ddd":a.append(b.AbbreviatedDayNames[this.getDay()]);break;case "dd":h=true;a.append(d(g(this,2)));break;case "d":h=true;a.append(g(this,2));break;case "MMMM":a.append(b.MonthGenitiveNames&&s()?b.MonthGenitiveNames[g(this,1)]:b.MonthNames[g(this,1)]);break;case "MMM":a.append(b.AbbreviatedMonthGenitiveNames&&s()?b.AbbreviatedMonthGenitiveNames[g(this,1)]:b.AbbreviatedMonthNames[g(this,1)]);break;case "MM":a.append(d(g(this,1)+1));break;case "M":a.append(g(this,1)+1);break;case "yyyy":a.append(v(f?f[0]:Date._getEraYear(this,b,Date._getEra(this,l),k)));break;case "yy":a.append(d((f?f[0]:Date._getEraYear(this,b,Date._getEra(this,l),k))%100));break;case "y":a.append((f?f[0]:Date._getEraYear(this,b,Date._getEra(this,l),k))%100);break;case "hh":c=this.getHours()%12;if(c===0)c=12;a.append(d(c));break;case "h":c=this.getHours()%12;if(c===0)c=12;a.append(c);break;case "HH":a.append(d(this.getHours()));break;case "H":a.append(this.getHours());break;case "mm":a.append(d(this.getMinutes()));break;case "m":a.append(this.getMinutes());break;case "ss":a.append(d(this.getSeconds()));break;case "s":a.append(this.getSeconds());break;case "tt":a.append(this.getHours()<12?b.AMDesignator:b.PMDesignator);break;case "t":a.append((this.getHours()<12?b.AMDesignator:b.PMDesignator).charAt(0));break;case "f":a.append(m(this.getMilliseconds()).charAt(0));break;case "ff":a.append(m(this.getMilliseconds()).substr(0,2));break;case "fff":a.append(m(this.getMilliseconds()));break;case "z":c=this.getTimezoneOffset()/60;a.append((c<=0?"+":"-")+Math.floor(Math.abs(c)));break;case "zz":c=this.getTimezoneOffset()/60;a.append((c<=0?"+":"-")+d(Math.floor(Math.abs(c))));break;case "zzz":c=this.getTimezoneOffset()/60;a.append((c<=0?"+":"-")+d(Math.floor(Math.abs(c)))+":"+d(Math.abs(this.getTimezoneOffset()%60)));break;case "g":case "gg":if(b.eras)a.append(b.eras[Date._getEra(this,l)+1]);break;case "/":a.append(b.DateSeparator)}}return a.toString()};String.localeFormat=function(){return String._toFormattedString(true,arguments)};Number.parseLocale=function(a){return Number._parse(a,Sys.CultureInfo.CurrentCulture)};Number.parseInvariant=function(a){return Number._parse(a,Sys.CultureInfo.InvariantCulture)};Number._parse=function(b,o){b=b.trim();if(b.match(/^[+-]?infinity$/i))return parseFloat(b);if(b.match(/^0x[a-f0-9]+$/i))return parseInt(b);var a=o.numberFormat,g=Number._parseNumberNegativePattern(b,a,a.NumberNegativePattern),h=g[0],e=g[1];if(h===""&&a.NumberNegativePattern!==1){g=Number._parseNumberNegativePattern(b,a,1);h=g[0];e=g[1]}if(h==="")h="+";var j,d,f=e.indexOf("e");if(f<0)f=e.indexOf("E");if(f<0){d=e;j=null}else{d=e.substr(0,f);j=e.substr(f+1)}var c,k,m=d.indexOf(a.NumberDecimalSeparator);if(m<0){c=d;k=null}else{c=d.substr(0,m);k=d.substr(m+a.NumberDecimalSeparator.length)}c=c.split(a.NumberGroupSeparator).join("");var n=a.NumberGroupSeparator.replace(/\u00A0/g," ");if(a.NumberGroupSeparator!==n)c=c.split(n).join("");var l=h+c;if(k!==null)l+="."+k;if(j!==null){var i=Number._parseNumberNegativePattern(j,a,1);if(i[0]==="")i[0]="+";l+="e"+i[0]+i[1]}if(l.match(/^[+-]?\d*\.?\d*(e[+-]?\d+)?$/))return parseFloat(l);return Number.NaN};Number._parseNumberNegativePattern=function(a,d,e){var b=d.NegativeSign,c=d.PositiveSign;switch(e){case 4:b=" "+b;c=" "+c;case 3:if(a.endsWith(b))return ["-",a.substr(0,a.length-b.length)];else if(a.endsWith(c))return ["+",a.substr(0,a.length-c.length)];break;case 2:b+=" ";c+=" ";case 1:if(a.startsWith(b))return ["-",a.substr(b.length)];else if(a.startsWith(c))return ["+",a.substr(c.length)];break;case 0:if(a.startsWith("(")&&a.endsWith(")"))return ["-",a.substr(1,a.length-2)]}return ["",a]};Number.prototype.format=function(a){return this._toFormattedString(a,Sys.CultureInfo.InvariantCulture)};Number.prototype.localeFormat=function(a){return this._toFormattedString(a,Sys.CultureInfo.CurrentCulture)};Number.prototype._toFormattedString=function(e,j){if(!e||e.length===0||e==="i")if(j&&j.name.length>0)return this.toLocaleString();else return this.toString();var o=["n %","n%","%n"],n=["-n %","-n%","-%n"],p=["(n)","-n","- n","n-","n -"],m=["$n","n$","$ n","n $"],l=["($n)","-$n","$-n","$n-","(n$)","-n$","n-$","n$-","-n $","-$ n","n $-","$ n-","$ -n","n- $","($ n)","(n $)"];function g(a,c,d){for(var b=a.length;b<c;b++)a=d?"0"+a:a+"0";return a}function i(j,i,l,n,p){var h=l[0],k=1,o=Math.pow(10,i),m=Math.round(j*o)/o;if(!isFinite(m))m=j;j=m;var b=j.toString(),a="",c,e=b.split(/e/i);b=e[0];c=e.length>1?parseInt(e[1]):0;e=b.split(".");b=e[0];a=e.length>1?e[1]:"";var q;if(c>0){a=g(a,c,false);b+=a.slice(0,c);a=a.substr(c)}else if(c<0){c=-c;b=g(b,c+1,true);a=b.slice(-c,b.length)+a;b=b.slice(0,-c)}if(i>0){if(a.length>i)a=a.slice(0,i);else a=g(a,i,false);a=p+a}else a="";var d=b.length-1,f="";while(d>=0){if(h===0||h>d)if(f.length>0)return b.slice(0,d+1)+n+f+a;else return b.slice(0,d+1)+a;if(f.length>0)f=b.slice(d-h+1,d+1)+n+f;else f=b.slice(d-h+1,d+1);d-=h;if(k<l.length){h=l[k];k++}}return b.slice(0,d+1)+n+f+a}var a=j.numberFormat,d=Math.abs(this);if(!e)e="D";var b=-1;if(e.length>1)b=parseInt(e.slice(1),10);var c;switch(e.charAt(0)){case "d":case "D":c="n";if(b!==-1)d=g(""+d,b,true);if(this<0)d=-d;break;case "c":case "C":if(this<0)c=l[a.CurrencyNegativePattern];else c=m[a.CurrencyPositivePattern];if(b===-1)b=a.CurrencyDecimalDigits;d=i(Math.abs(this),b,a.CurrencyGroupSizes,a.CurrencyGroupSeparator,a.CurrencyDecimalSeparator);break;case "n":case "N":if(this<0)c=p[a.NumberNegativePattern];else c="n";if(b===-1)b=a.NumberDecimalDigits;d=i(Math.abs(this),b,a.NumberGroupSizes,a.NumberGroupSeparator,a.NumberDecimalSeparator);break;case "p":case "P":if(this<0)c=n[a.PercentNegativePattern];else c=o[a.PercentPositivePattern];if(b===-1)b=a.PercentDecimalDigits;d=i(Math.abs(this)*100,b,a.PercentGroupSizes,a.PercentGroupSeparator,a.PercentDecimalSeparator);break;default:throw Error.format(Sys.Res.formatBadFormatSpecifier)}var k=/n|\$|-|%/g,f="";for(;true;){var q=k.lastIndex,h=k.exec(c);f+=c.slice(q,h?h.index:c.length);if(!h)break;switch(h[0]){case "n":f+=d;break;case "$":f+=a.CurrencySymbol;break;case "-":if(/[1-9]/.test(d))f+=a.NegativeSign;break;case "%":f+=a.PercentSymbol}}return f};Sys.CultureInfo=function(c,b,a){this.name=c;this.numberFormat=b;this.dateTimeFormat=a};Sys.CultureInfo.prototype={_getDateTimeFormats:function(){if(!this._dateTimeFormats){var a=this.dateTimeFormat;this._dateTimeFormats=[a.MonthDayPattern,a.YearMonthPattern,a.ShortDatePattern,a.ShortTimePattern,a.LongDatePattern,a.LongTimePattern,a.FullDateTimePattern,a.RFC1123Pattern,a.SortableDateTimePattern,a.UniversalSortableDateTimePattern]}return this._dateTimeFormats},_getIndex:function(c,d,e){var b=this._toUpper(c),a=Array.indexOf(d,b);if(a===-1)a=Array.indexOf(e,b);return a},_getMonthIndex:function(a){if(!this._upperMonths){this._upperMonths=this._toUpperArray(this.dateTimeFormat.MonthNames);this._upperMonthsGenitive=this._toUpperArray(this.dateTimeFormat.MonthGenitiveNames)}return this._getIndex(a,this._upperMonths,this._upperMonthsGenitive)},_getAbbrMonthIndex:function(a){if(!this._upperAbbrMonths){this._upperAbbrMonths=this._toUpperArray(this.dateTimeFormat.AbbreviatedMonthNames);this._upperAbbrMonthsGenitive=this._toUpperArray(this.dateTimeFormat.AbbreviatedMonthGenitiveNames)}return this._getIndex(a,this._upperAbbrMonths,this._upperAbbrMonthsGenitive)},_getDayIndex:function(a){if(!this._upperDays)this._upperDays=this._toUpperArray(this.dateTimeFormat.DayNames);return Array.indexOf(this._upperDays,this._toUpper(a))},_getAbbrDayIndex:function(a){if(!this._upperAbbrDays)this._upperAbbrDays=this._toUpperArray(this.dateTimeFormat.AbbreviatedDayNames);return Array.indexOf(this._upperAbbrDays,this._toUpper(a))},_toUpperArray:function(c){var b=[];for(var a=0,d=c.length;a<d;a++)b[a]=this._toUpper(c[a]);return b},_toUpper:function(a){return a.split("\u00a0").join(" ").toUpperCase()}};Sys.CultureInfo.registerClass("Sys.CultureInfo");Sys.CultureInfo._parse=function(a){var b=a.dateTimeFormat;if(b&&!b.eras)b.eras=a.eras;return new Sys.CultureInfo(a.name,a.numberFormat,b)};Sys.CultureInfo.InvariantCulture=Sys.CultureInfo._parse({"name":"","numberFormat":{"CurrencyDecimalDigits":2,"CurrencyDecimalSeparator":".","IsReadOnly":true,"CurrencyGroupSizes":[3],"NumberGroupSizes":[3],"PercentGroupSizes":[3],"CurrencyGroupSeparator":",","CurrencySymbol":"\u00a4","NaNSymbol":"NaN","CurrencyNegativePattern":0,"NumberNegativePattern":1,"PercentPositivePattern":0,"PercentNegativePattern":0,"NegativeInfinitySymbol":"-Infinity","NegativeSign":"-","NumberDecimalDigits":2,"NumberDecimalSeparator":".","NumberGroupSeparator":",","CurrencyPositivePattern":0,"PositiveInfinitySymbol":"Infinity","PositiveSign":"+","PercentDecimalDigits":2,"PercentDecimalSeparator":".","PercentGroupSeparator":",","PercentSymbol":"%","PerMilleSymbol":"\u2030","NativeDigits":["0","1","2","3","4","5","6","7","8","9"],"DigitSubstitution":1},"dateTimeFormat":{"AMDesignator":"AM","Calendar":{"MinSupportedDateTime":"@-62135568000000@","MaxSupportedDateTime":"@253402300799999@","AlgorithmType":1,"CalendarType":1,"Eras":[1],"TwoDigitYearMax":2029,"IsReadOnly":true},"DateSeparator":"/","FirstDayOfWeek":0,"CalendarWeekRule":0,"FullDateTimePattern":"dddd, dd MMMM yyyy HH:mm:ss","LongDatePattern":"dddd, dd MMMM yyyy","LongTimePattern":"HH:mm:ss","MonthDayPattern":"MMMM dd","PMDesignator":"PM","RFC1123Pattern":"ddd, dd MMM yyyy HH':'mm':'ss 'GMT'","ShortDatePattern":"MM/dd/yyyy","ShortTimePattern":"HH:mm","SortableDateTimePattern":"yyyy'-'MM'-'dd'T'HH':'mm':'ss","TimeSeparator":":","UniversalSortableDateTimePattern":"yyyy'-'MM'-'dd HH':'mm':'ss'Z'","YearMonthPattern":"yyyy MMMM","AbbreviatedDayNames":["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],"ShortestDayNames":["Su","Mo","Tu","We","Th","Fr","Sa"],"DayNames":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],"AbbreviatedMonthNames":["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec",""],"MonthNames":["January","February","March","April","May","June","July","August","September","October","November","December",""],"IsReadOnly":true,"NativeCalendarName":"Gregorian Calendar","AbbreviatedMonthGenitiveNames":["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec",""],"MonthGenitiveNames":["January","February","March","April","May","June","July","August","September","October","November","December",""]},"eras":[1,"A.D.",null,0]});if(typeof __cultureInfo==="object"){Sys.CultureInfo.CurrentCulture=Sys.CultureInfo._parse(__cultureInfo);delete __cultureInfo}else Sys.CultureInfo.CurrentCulture=Sys.CultureInfo._parse({"name":"en-US","numberFormat":{"CurrencyDecimalDigits":2,"CurrencyDecimalSeparator":".","IsReadOnly":false,"CurrencyGroupSizes":[3],"NumberGroupSizes":[3],"PercentGroupSizes":[3],"CurrencyGroupSeparator":",","CurrencySymbol":"$","NaNSymbol":"NaN","CurrencyNegativePattern":0,"NumberNegativePattern":1,"PercentPositivePattern":0,"PercentNegativePattern":0,"NegativeInfinitySymbol":"-Infinity","NegativeSign":"-","NumberDecimalDigits":2,"NumberDecimalSeparator":".","NumberGroupSeparator":",","CurrencyPositivePattern":0,"PositiveInfinitySymbol":"Infinity","PositiveSign":"+","PercentDecimalDigits":2,"PercentDecimalSeparator":".","PercentGroupSeparator":",","PercentSymbol":"%","PerMilleSymbol":"\u2030","NativeDigits":["0","1","2","3","4","5","6","7","8","9"],"DigitSubstitution":1},"dateTimeFormat":{"AMDesignator":"AM","Calendar":{"MinSupportedDateTime":"@-62135568000000@","MaxSupportedDateTime":"@253402300799999@","AlgorithmType":1,"CalendarType":1,"Eras":[1],"TwoDigitYearMax":2029,"IsReadOnly":false},"DateSeparator":"/","FirstDayOfWeek":0,"CalendarWeekRule":0,"FullDateTimePattern":"dddd, MMMM dd, yyyy h:mm:ss tt","LongDatePattern":"dddd, MMMM dd, yyyy","LongTimePattern":"h:mm:ss tt","MonthDayPattern":"MMMM dd","PMDesignator":"PM","RFC1123Pattern":"ddd, dd MMM yyyy HH':'mm':'ss 'GMT'","ShortDatePattern":"M/d/yyyy","ShortTimePattern":"h:mm tt","SortableDateTimePattern":"yyyy'-'MM'-'dd'T'HH':'mm':'ss","TimeSeparator":":","UniversalSortableDateTimePattern":"yyyy'-'MM'-'dd HH':'mm':'ss'Z'","YearMonthPattern":"MMMM, yyyy","AbbreviatedDayNames":["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],"ShortestDayNames":["Su","Mo","Tu","We","Th","Fr","Sa"],"DayNames":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],"AbbreviatedMonthNames":["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec",""],"MonthNames":["January","February","March","April","May","June","July","August","September","October","November","December",""],"IsReadOnly":false,"NativeCalendarName":"Gregorian Calendar","AbbreviatedMonthGenitiveNames":["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec",""],"MonthGenitiveNames":["January","February","March","April","May","June","July","August","September","October","November","December",""]},"eras":[1,"A.D.",null,0]});Type.registerNamespace("Sys.Serialization");Sys.Serialization.JavaScriptSerializer=function(){};Sys.Serialization.JavaScriptSerializer.registerClass("Sys.Serialization.JavaScriptSerializer");Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs=[];Sys.Serialization.JavaScriptSerializer._charsToEscape=[];Sys.Serialization.JavaScriptSerializer._dateRegEx=new RegExp('(^|[^\\\\])\\"\\\\/Date\\((-?[0-9]+)(?:[a-zA-Z]|(?:\\+|-)[0-9]{4})?\\)\\\\/\\"',"g");Sys.Serialization.JavaScriptSerializer._escapeChars={};Sys.Serialization.JavaScriptSerializer._escapeRegEx=new RegExp('["\\\\\\x00-\\x1F]',"i");Sys.Serialization.JavaScriptSerializer._escapeRegExGlobal=new RegExp('["\\\\\\x00-\\x1F]',"g");Sys.Serialization.JavaScriptSerializer._jsonRegEx=new RegExp("[^,:{}\\[\\]0-9.\\-+Eaeflnr-u \\n\\r\\t]","g");Sys.Serialization.JavaScriptSerializer._jsonStringRegEx=new RegExp('"(\\\\.|[^"\\\\])*"',"g");Sys.Serialization.JavaScriptSerializer._serverTypeFieldName="__type";Sys.Serialization.JavaScriptSerializer._init=function(){var c=["\\u0000","\\u0001","\\u0002","\\u0003","\\u0004","\\u0005","\\u0006","\\u0007","\\b","\\t","\\n","\\u000b","\\f","\\r","\\u000e","\\u000f","\\u0010","\\u0011","\\u0012","\\u0013","\\u0014","\\u0015","\\u0016","\\u0017","\\u0018","\\u0019","\\u001a","\\u001b","\\u001c","\\u001d","\\u001e","\\u001f"];Sys.Serialization.JavaScriptSerializer._charsToEscape[0]="\\";Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs["\\"]=new RegExp("\\\\","g");Sys.Serialization.JavaScriptSerializer._escapeChars["\\"]="\\\\";Sys.Serialization.JavaScriptSerializer._charsToEscape[1]='"';Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs['"']=new RegExp('"',"g");Sys.Serialization.JavaScriptSerializer._escapeChars['"']='\\"';for(var a=0;a<32;a++){var b=String.fromCharCode(a);Sys.Serialization.JavaScriptSerializer._charsToEscape[a+2]=b;Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs[b]=new RegExp(b,"g");Sys.Serialization.JavaScriptSerializer._escapeChars[b]=c[a]}};Sys.Serialization.JavaScriptSerializer._serializeBooleanWithBuilder=function(b,a){a.append(b.toString())};Sys.Serialization.JavaScriptSerializer._serializeNumberWithBuilder=function(a,b){if(isFinite(a))b.append(String(a));else throw Error.invalidOperation(Sys.Res.cannotSerializeNonFiniteNumbers)};Sys.Serialization.JavaScriptSerializer._serializeStringWithBuilder=function(a,c){c.append('"');if(Sys.Serialization.JavaScriptSerializer._escapeRegEx.test(a)){if(Sys.Serialization.JavaScriptSerializer._charsToEscape.length===0)Sys.Serialization.JavaScriptSerializer._init();if(a.length<128)a=a.replace(Sys.Serialization.JavaScriptSerializer._escapeRegExGlobal,function(a){return Sys.Serialization.JavaScriptSerializer._escapeChars[a]});else for(var d=0;d<34;d++){var b=Sys.Serialization.JavaScriptSerializer._charsToEscape[d];if(a.indexOf(b)!==-1)if(Sys.Browser.agent===Sys.Browser.Opera||Sys.Browser.agent===Sys.Browser.FireFox)a=a.split(b).join(Sys.Serialization.JavaScriptSerializer._escapeChars[b]);else a=a.replace(Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs[b],Sys.Serialization.JavaScriptSerializer._escapeChars[b])}}c.append(a);c.append('"')};Sys.Serialization.JavaScriptSerializer._serializeWithBuilder=function(b,a,i,g){var c;switch(typeof b){case "object":if(b)if(Number.isInstanceOfType(b))Sys.Serialization.JavaScriptSerializer._serializeNumberWithBuilder(b,a);else if(Boolean.isInstanceOfType(b))Sys.Serialization.JavaScriptSerializer._serializeBooleanWithBuilder(b,a);else if(String.isInstanceOfType(b))Sys.Serialization.JavaScriptSerializer._serializeStringWithBuilder(b,a);else if(Array.isInstanceOfType(b)){a.append("[");for(c=0;c<b.length;++c){if(c>0)a.append(",");Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(b[c],a,false,g)}a.append("]")}else{if(Date.isInstanceOfType(b)){a.append('"\\/Date(');a.append(b.getTime());a.append(')\\/"');break}var d=[],f=0;for(var e in b){if(e.startsWith("$"))continue;if(e===Sys.Serialization.JavaScriptSerializer._serverTypeFieldName&&f!==0){d[f++]=d[0];d[0]=e}else d[f++]=e}if(i)d.sort();a.append("{");var j=false;for(c=0;c<f;c++){var h=b[d[c]];if(typeof h!=="undefined"&&typeof h!=="function"){if(j)a.append(",");else j=true;Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(d[c],a,i,g);a.append(":");Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(h,a,i,g)}}a.append("}")}else a.append("null");break;case "number":Sys.Serialization.JavaScriptSerializer._serializeNumberWithBuilder(b,a);break;case "string":Sys.Serialization.JavaScriptSerializer._serializeStringWithBuilder(b,a);break;case "boolean":Sys.Serialization.JavaScriptSerializer._serializeBooleanWithBuilder(b,a);break;default:a.append("null")}};Sys.Serialization.JavaScriptSerializer.serialize=function(b){var a=new Sys.StringBuilder;Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(b,a,false);return a.toString()};Sys.Serialization.JavaScriptSerializer.deserialize=function(data,secure){if(data.length===0)throw Error.argument("data",Sys.Res.cannotDeserializeEmptyString);try{var exp=data.replace(Sys.Serialization.JavaScriptSerializer._dateRegEx,"$1new Date($2)");if(secure&&Sys.Serialization.JavaScriptSerializer._jsonRegEx.test(exp.replace(Sys.Serialization.JavaScriptSerializer._jsonStringRegEx,"")))throw null;return eval("("+exp+")")}catch(a){throw Error.argument("data",Sys.Res.cannotDeserializeInvalidJson)}};Type.registerNamespace("Sys.UI");Sys.EventHandlerList=function(){this._list={}};Sys.EventHandlerList.prototype={_addHandler:function(b,a){Array.add(this._getEvent(b,true),a)},addHandler:function(b,a){this._addHandler(b,a)},_removeHandler:function(c,b){var a=this._getEvent(c);if(!a)return;Array.remove(a,b)},removeHandler:function(b,a){this._removeHandler(b,a)},getHandler:function(b){var a=this._getEvent(b);if(!a||a.length===0)return null;a=Array.clone(a);return function(c,d){for(var b=0,e=a.length;b<e;b++)a[b](c,d)}},_getEvent:function(a,b){if(!this._list[a]){if(!b)return null;this._list[a]=[]}return this._list[a]}};Sys.EventHandlerList.registerClass("Sys.EventHandlerList");Sys.CommandEventArgs=function(c,a,b){Sys.CommandEventArgs.initializeBase(this);this._commandName=c;this._commandArgument=a;this._commandSource=b};Sys.CommandEventArgs.prototype={_commandName:null,_commandArgument:null,_commandSource:null,get_commandName:function(){return this._commandName},get_commandArgument:function(){return this._commandArgument},get_commandSource:function(){return this._commandSource}};Sys.CommandEventArgs.registerClass("Sys.CommandEventArgs",Sys.CancelEventArgs);Sys.INotifyPropertyChange=function(){};Sys.INotifyPropertyChange.prototype={};Sys.INotifyPropertyChange.registerInterface("Sys.INotifyPropertyChange");Sys.PropertyChangedEventArgs=function(a){Sys.PropertyChangedEventArgs.initializeBase(this);this._propertyName=a};Sys.PropertyChangedEventArgs.prototype={get_propertyName:function(){return this._propertyName}};Sys.PropertyChangedEventArgs.registerClass("Sys.PropertyChangedEventArgs",Sys.EventArgs);Sys.INotifyDisposing=function(){};Sys.INotifyDisposing.prototype={};Sys.INotifyDisposing.registerInterface("Sys.INotifyDisposing");Sys.Component=function(){if(Sys.Application)Sys.Application.registerDisposableObject(this)};Sys.Component.prototype={_id:null,_initialized:false,_updating:false,get_events:function(){if(!this._events)this._events=new Sys.EventHandlerList;return this._events},get_id:function(){return this._id},set_id:function(a){this._id=a},get_isInitialized:function(){return this._initialized},get_isUpdating:function(){return this._updating},add_disposing:function(a){this.get_events().addHandler("disposing",a)},remove_disposing:function(a){this.get_events().removeHandler("disposing",a)},add_propertyChanged:function(a){this.get_events().addHandler("propertyChanged",a)},remove_propertyChanged:function(a){this.get_events().removeHandler("propertyChanged",a)},beginUpdate:function(){this._updating=true},dispose:function(){if(this._events){var a=this._events.getHandler("disposing");if(a)a(this,Sys.EventArgs.Empty)}delete this._events;Sys.Application.unregisterDisposableObject(this);Sys.Application.removeComponent(this)},endUpdate:function(){this._updating=false;if(!this._initialized)this.initialize();this.updated()},initialize:function(){this._initialized=true},raisePropertyChanged:function(b){if(!this._events)return;var a=this._events.getHandler("propertyChanged");if(a)a(this,new Sys.PropertyChangedEventArgs(b))},updated:function(){}};Sys.Component.registerClass("Sys.Component",null,Sys.IDisposable,Sys.INotifyPropertyChange,Sys.INotifyDisposing);function Sys$Component$_setProperties(a,i){var d,j=Object.getType(a),e=j===Object||j===Sys.UI.DomElement,h=Sys.Component.isInstanceOfType(a)&&!a.get_isUpdating();if(h)a.beginUpdate();for(var c in i){var b=i[c],f=e?null:a["get_"+c];if(e||typeof f!=="function"){var k=a[c];if(!b||typeof b!=="object"||e&&!k)a[c]=b;else Sys$Component$_setProperties(k,b)}else{var l=a["set_"+c];if(typeof l==="function")l.apply(a,[b]);else if(b instanceof Array){d=f.apply(a);for(var g=0,m=d.length,n=b.length;g<n;g++,m++)d[m]=b[g]}else if(typeof b==="object"&&Object.getType(b)===Object){d=f.apply(a);Sys$Component$_setProperties(d,b)}}}if(h)a.endUpdate()}function Sys$Component$_setReferences(c,b){for(var a in b){var e=c["set_"+a],d=$find(b[a]);e.apply(c,[d])}}var $create=Sys.Component.create=function(h,f,d,c,g){var a=g?new h(g):new h,b=Sys.Application,i=b.get_isCreatingComponents();a.beginUpdate();if(f)Sys$Component$_setProperties(a,f);if(d)for(var e in d)a["add_"+e](d[e]);if(a.get_id())b.addComponent(a);if(i){b._createdComponents[b._createdComponents.length]=a;if(c)b._addComponentToSecondPass(a,c);else a.endUpdate()}else{if(c)Sys$Component$_setReferences(a,c);a.endUpdate()}return a};Sys.UI.MouseButton=function(){throw Error.notImplemented()};Sys.UI.MouseButton.prototype={leftButton:0,middleButton:1,rightButton:2};Sys.UI.MouseButton.registerEnum("Sys.UI.MouseButton");Sys.UI.Key=function(){throw Error.notImplemented()};Sys.UI.Key.prototype={backspace:8,tab:9,enter:13,esc:27,space:32,pageUp:33,pageDown:34,end:35,home:36,left:37,up:38,right:39,down:40,del:127};Sys.UI.Key.registerEnum("Sys.UI.Key");Sys.UI.Point=function(a,b){this.x=a;this.y=b};Sys.UI.Point.registerClass("Sys.UI.Point");Sys.UI.Bounds=function(c,d,b,a){this.x=c;this.y=d;this.height=a;this.width=b};Sys.UI.Bounds.registerClass("Sys.UI.Bounds");Sys.UI.DomEvent=function(e){var a=e,b=this.type=a.type.toLowerCase();this.rawEvent=a;this.altKey=a.altKey;if(typeof a.button!=="undefined")this.button=typeof a.which!=="undefined"?a.button:a.button===4?Sys.UI.MouseButton.middleButton:a.button===2?Sys.UI.MouseButton.rightButton:Sys.UI.MouseButton.leftButton;if(b==="keypress")this.charCode=a.charCode||a.keyCode;else if(a.keyCode&&a.keyCode===46)this.keyCode=127;else this.keyCode=a.keyCode;this.clientX=a.clientX;this.clientY=a.clientY;this.ctrlKey=a.ctrlKey;this.target=a.target?a.target:a.srcElement;if(!b.startsWith("key"))if(typeof a.offsetX!=="undefined"&&typeof a.offsetY!=="undefined"){this.offsetX=a.offsetX;this.offsetY=a.offsetY}else if(this.target&&this.target.nodeType!==3&&typeof a.clientX==="number"){var c=Sys.UI.DomElement.getLocation(this.target),d=Sys.UI.DomElement._getWindow(this.target);this.offsetX=(d.pageXOffset||0)+a.clientX-c.x;this.offsetY=(d.pageYOffset||0)+a.clientY-c.y}this.screenX=a.screenX;this.screenY=a.screenY;this.shiftKey=a.shiftKey};Sys.UI.DomEvent.prototype={preventDefault:function(){if(this.rawEvent.preventDefault)this.rawEvent.preventDefault();else if(window.event)this.rawEvent.returnValue=false},stopPropagation:function(){if(this.rawEvent.stopPropagation)this.rawEvent.stopPropagation();else if(window.event)this.rawEvent.cancelBubble=true}};Sys.UI.DomEvent.registerClass("Sys.UI.DomEvent");var $addHandler=Sys.UI.DomEvent.addHandler=function(a,d,e,g){if(!a._events)a._events={};var c=a._events[d];if(!c)a._events[d]=c=[];var b;if(a.addEventListener){b=function(b){return e.call(a,new Sys.UI.DomEvent(b))};a.addEventListener(d,b,false)}else if(a.attachEvent){b=function(){var b={};try{b=Sys.UI.DomElement._getWindow(a).event}catch(c){}return e.call(a,new Sys.UI.DomEvent(b))};a.attachEvent("on"+d,b)}c[c.length]={handler:e,browserHandler:b,autoRemove:g};if(g){var f=a.dispose;if(f!==Sys.UI.DomEvent._disposeHandlers){a.dispose=Sys.UI.DomEvent._disposeHandlers;if(typeof f!=="undefined")a._chainDispose=f}}},$addHandlers=Sys.UI.DomEvent.addHandlers=function(f,d,c,e){for(var b in d){var a=d[b];if(c)a=Function.createDelegate(c,a);$addHandler(f,b,a,e||false)}},$clearHandlers=Sys.UI.DomEvent.clearHandlers=function(a){Sys.UI.DomEvent._clearHandlers(a,false)};Sys.UI.DomEvent._clearHandlers=function(a,g){if(a._events){var e=a._events;for(var b in e){var d=e[b];for(var c=d.length-1;c>=0;c--){var f=d[c];if(!g||f.autoRemove)$removeHandler(a,b,f.handler)}}a._events=null}};Sys.UI.DomEvent._disposeHandlers=function(){Sys.UI.DomEvent._clearHandlers(this,true);var b=this._chainDispose,a=typeof b;if(a!=="undefined"){this.dispose=b;this._chainDispose=null;if(a==="function")this.dispose()}};var $removeHandler=Sys.UI.DomEvent.removeHandler=function(b,a,c){Sys.UI.DomEvent._removeHandler(b,a,c)};Sys.UI.DomEvent._removeHandler=function(a,e,f){var d=null,c=a._events[e];for(var b=0,g=c.length;b<g;b++)if(c[b].handler===f){d=c[b].browserHandler;break}if(a.removeEventListener)a.removeEventListener(e,d,false);else if(a.detachEvent)a.detachEvent("on"+e,d);c.splice(b,1)};Sys.UI.DomElement=function(){};Sys.UI.DomElement.registerClass("Sys.UI.DomElement");Sys.UI.DomElement.addCssClass=function(a,b){if(!Sys.UI.DomElement.containsCssClass(a,b))if(a.className==="")a.className=b;else a.className+=" "+b};Sys.UI.DomElement.containsCssClass=function(b,a){return Array.contains(b.className.split(" "),a)};Sys.UI.DomElement.getBounds=function(a){var b=Sys.UI.DomElement.getLocation(a);return new Sys.UI.Bounds(b.x,b.y,a.offsetWidth||0,a.offsetHeight||0)};var $get=Sys.UI.DomElement.getElementById=function(f,e){if(!e)return document.getElementById(f);if(e.getElementById)return e.getElementById(f);var c=[],d=e.childNodes;for(var b=0;b<d.length;b++){var a=d[b];if(a.nodeType==1)c[c.length]=a}while(c.length){a=c.shift();if(a.id==f)return a;d=a.childNodes;for(b=0;b<d.length;b++){a=d[b];if(a.nodeType==1)c[c.length]=a}}return null};if(document.documentElement.getBoundingClientRect)Sys.UI.DomElement.getLocation=function(b){if(b.self||b.nodeType===9||b===document.documentElement||b.parentNode===b.ownerDocument.documentElement)return new Sys.UI.Point(0,0);var f=b.getBoundingClientRect();if(!f)return new Sys.UI.Point(0,0);var k,e=b.ownerDocument.documentElement,c=Math.round(f.left)+e.scrollLeft,d=Math.round(f.top)+e.scrollTop;if(Sys.Browser.agent===Sys.Browser.InternetExplorer){try{var g=b.ownerDocument.parentWindow.frameElement||null;if(g){var h=g.frameBorder==="0"||g.frameBorder==="no"?2:0;c+=h;d+=h}}catch(l){}if(Sys.Browser.version===7&&!document.documentMode){var i=document.body,j=i.getBoundingClientRect(),a=(j.right-j.left)/i.clientWidth;a=Math.round(a*100);a=(a-a%5)/100;if(!isNaN(a)&&a!==1){c=Math.round(c/a);d=Math.round(d/a)}}if((document.documentMode||0)<8){c-=e.clientLeft;d-=e.clientTop}}return new Sys.UI.Point(c,d)};else if(Sys.Browser.agent===Sys.Browser.Safari)Sys.UI.DomElement.getLocation=function(c){if(c.window&&c.window===c||c.nodeType===9)return new Sys.UI.Point(0,0);var d=0,e=0,a,j=null,g=null,b;for(a=c;a;j=a,(g=b,a=a.offsetParent)){b=Sys.UI.DomElement._getCurrentStyle(a);var f=a.tagName?a.tagName.toUpperCase():null;if((a.offsetLeft||a.offsetTop)&&(f!=="BODY"||(!g||g.position!=="absolute"))){d+=a.offsetLeft;e+=a.offsetTop}if(j&&Sys.Browser.version>=3){d+=parseInt(b.borderLeftWidth);e+=parseInt(b.borderTopWidth)}}b=Sys.UI.DomElement._getCurrentStyle(c);var h=b?b.position:null;if(!h||h!=="absolute")for(a=c.parentNode;a;a=a.parentNode){f=a.tagName?a.tagName.toUpperCase():null;if(f!=="BODY"&&f!=="HTML"&&(a.scrollLeft||a.scrollTop)){d-=a.scrollLeft||0;e-=a.scrollTop||0}b=Sys.UI.DomElement._getCurrentStyle(a);var i=b?b.position:null;if(i&&i==="absolute")break}return new Sys.UI.Point(d,e)};else Sys.UI.DomElement.getLocation=function(d){if(d.window&&d.window===d||d.nodeType===9)return new Sys.UI.Point(0,0);var e=0,f=0,a,i=null,g=null,b=null;for(a=d;a;i=a,(g=b,a=a.offsetParent)){var c=a.tagName?a.tagName.toUpperCase():null;b=Sys.UI.DomElement._getCurrentStyle(a);if((a.offsetLeft||a.offsetTop)&&!(c==="BODY"&&(!g||g.position!=="absolute"))){e+=a.offsetLeft;f+=a.offsetTop}if(i!==null&&b){if(c!=="TABLE"&&c!=="TD"&&c!=="HTML"){e+=parseInt(b.borderLeftWidth)||0;f+=parseInt(b.borderTopWidth)||0}if(c==="TABLE"&&(b.position==="relative"||b.position==="absolute")){e+=parseInt(b.marginLeft)||0;f+=parseInt(b.marginTop)||0}}}b=Sys.UI.DomElement._getCurrentStyle(d);var h=b?b.position:null;if(!h||h!=="absolute")for(a=d.parentNode;a;a=a.parentNode){c=a.tagName?a.tagName.toUpperCase():null;if(c!=="BODY"&&c!=="HTML"&&(a.scrollLeft||a.scrollTop)){e-=a.scrollLeft||0;f-=a.scrollTop||0;b=Sys.UI.DomElement._getCurrentStyle(a);if(b){e+=parseInt(b.borderLeftWidth)||0;f+=parseInt(b.borderTopWidth)||0}}}return new Sys.UI.Point(e,f)};Sys.UI.DomElement.isDomElement=function(a){return Sys._isDomElement(a)};Sys.UI.DomElement.removeCssClass=function(d,c){var a=" "+d.className+" ",b=a.indexOf(" "+c+" ");if(b>=0)d.className=(a.substr(0,b)+" "+a.substring(b+c.length+1,a.length)).trim()};Sys.UI.DomElement.resolveElement=function(b,c){var a=b;if(!a)return null;if(typeof a==="string")a=Sys.UI.DomElement.getElementById(a,c);return a};Sys.UI.DomElement.raiseBubbleEvent=function(c,d){var b=c;while(b){var a=b.control;if(a&&a.onBubbleEvent&&a.raiseBubbleEvent){Sys.UI.DomElement._raiseBubbleEventFromControl(a,c,d);return}b=b.parentNode}};Sys.UI.DomElement._raiseBubbleEventFromControl=function(a,b,c){if(!a.onBubbleEvent(b,c))a._raiseBubbleEvent(b,c)};Sys.UI.DomElement.setLocation=function(b,c,d){var a=b.style;a.position="absolute";a.left=c+"px";a.top=d+"px"};Sys.UI.DomElement.toggleCssClass=function(b,a){if(Sys.UI.DomElement.containsCssClass(b,a))Sys.UI.DomElement.removeCssClass(b,a);else Sys.UI.DomElement.addCssClass(b,a)};Sys.UI.DomElement.getVisibilityMode=function(a){return a._visibilityMode===Sys.UI.VisibilityMode.hide?Sys.UI.VisibilityMode.hide:Sys.UI.VisibilityMode.collapse};Sys.UI.DomElement.setVisibilityMode=function(a,b){Sys.UI.DomElement._ensureOldDisplayMode(a);if(a._visibilityMode!==b){a._visibilityMode=b;if(Sys.UI.DomElement.getVisible(a)===false)if(a._visibilityMode===Sys.UI.VisibilityMode.hide)a.style.display=a._oldDisplayMode;else a.style.display="none";a._visibilityMode=b}};Sys.UI.DomElement.getVisible=function(b){var a=b.currentStyle||Sys.UI.DomElement._getCurrentStyle(b);if(!a)return true;return a.visibility!=="hidden"&&a.display!=="none"};Sys.UI.DomElement.setVisible=function(a,b){if(b!==Sys.UI.DomElement.getVisible(a)){Sys.UI.DomElement._ensureOldDisplayMode(a);a.style.visibility=b?"visible":"hidden";if(b||a._visibilityMode===Sys.UI.VisibilityMode.hide)a.style.display=a._oldDisplayMode;else a.style.display="none"}};Sys.UI.DomElement._ensureOldDisplayMode=function(a){if(!a._oldDisplayMode){var b=a.currentStyle||Sys.UI.DomElement._getCurrentStyle(a);a._oldDisplayMode=b?b.display:null;if(!a._oldDisplayMode||a._oldDisplayMode==="none")switch(a.tagName.toUpperCase()){case "DIV":case "P":case "ADDRESS":case "BLOCKQUOTE":case "BODY":case "COL":case "COLGROUP":case "DD":case "DL":case "DT":case "FIELDSET":case "FORM":case "H1":case "H2":case "H3":case "H4":case "H5":case "H6":case "HR":case "IFRAME":case "LEGEND":case "OL":case "PRE":case "TABLE":case "TD":case "TH":case "TR":case "UL":a._oldDisplayMode="block";break;case "LI":a._oldDisplayMode="list-item";break;default:a._oldDisplayMode="inline"}}};Sys.UI.DomElement._getWindow=function(a){var b=a.ownerDocument||a.document||a;return b.defaultView||b.parentWindow};Sys.UI.DomElement._getCurrentStyle=function(a){if(a.nodeType===3)return null;var c=Sys.UI.DomElement._getWindow(a);if(a.documentElement)a=a.documentElement;var b=c&&a!==c&&c.getComputedStyle?c.getComputedStyle(a,null):a.currentStyle||a.style;if(!b&&Sys.Browser.agent===Sys.Browser.Safari&&a.style){var g=a.style.display,f=a.style.position;a.style.position="absolute";a.style.display="block";var e=c.getComputedStyle(a,null);a.style.display=g;a.style.position=f;b={};for(var d in e)b[d]=e[d];b.display="none"}return b};Sys.IContainer=function(){};Sys.IContainer.prototype={};Sys.IContainer.registerInterface("Sys.IContainer");Sys.ApplicationLoadEventArgs=function(b,a){Sys.ApplicationLoadEventArgs.initializeBase(this);this._components=b;this._isPartialLoad=a};Sys.ApplicationLoadEventArgs.prototype={get_components:function(){return this._components},get_isPartialLoad:function(){return this._isPartialLoad}};Sys.ApplicationLoadEventArgs.registerClass("Sys.ApplicationLoadEventArgs",Sys.EventArgs);Sys._Application=function(){Sys._Application.initializeBase(this);this._disposableObjects=[];this._components={};this._createdComponents=[];this._secondPassComponents=[];this._unloadHandlerDelegate=Function.createDelegate(this,this._unloadHandler);Sys.UI.DomEvent.addHandler(window,"unload",this._unloadHandlerDelegate);this._domReady()};Sys._Application.prototype={_creatingComponents:false,_disposing:false,_deleteCount:0,get_isCreatingComponents:function(){return this._creatingComponents},get_isDisposing:function(){return this._disposing},add_init:function(a){if(this._initialized)a(this,Sys.EventArgs.Empty);else this.get_events().addHandler("init",a)},remove_init:function(a){this.get_events().removeHandler("init",a)},add_load:function(a){this.get_events().addHandler("load",a)},remove_load:function(a){this.get_events().removeHandler("load",a)},add_unload:function(a){this.get_events().addHandler("unload",a)},remove_unload:function(a){this.get_events().removeHandler("unload",a)},addComponent:function(a){this._components[a.get_id()]=a},beginCreateComponents:function(){this._creatingComponents=true},dispose:function(){if(!this._disposing){this._disposing=true;if(this._timerCookie){window.clearTimeout(this._timerCookie);delete this._timerCookie}if(this._endRequestHandler){Sys.WebForms.PageRequestManager.getInstance().remove_endRequest(this._endRequestHandler);delete this._endRequestHandler}if(this._beginRequestHandler){Sys.WebForms.PageRequestManager.getInstance().remove_beginRequest(this._beginRequestHandler);delete this._beginRequestHandler}if(window.pageUnload)window.pageUnload(this,Sys.EventArgs.Empty);var c=this.get_events().getHandler("unload");if(c)c(this,Sys.EventArgs.Empty);var b=Array.clone(this._disposableObjects);for(var a=0,f=b.length;a<f;a++){var d=b[a];if(typeof d!=="undefined")d.dispose()}Array.clear(this._disposableObjects);Sys.UI.DomEvent.removeHandler(window,"unload",this._unloadHandlerDelegate);if(Sys._ScriptLoader){var e=Sys._ScriptLoader.getInstance();if(e)e.dispose()}Sys._Application.callBaseMethod(this,"dispose")}},disposeElement:function(c,j){if(c.nodeType===1){var b,h=c.getElementsByTagName("*"),g=h.length,i=new Array(g);for(b=0;b<g;b++)i[b]=h[b];for(b=g-1;b>=0;b--){var d=i[b],f=d.dispose;if(f&&typeof f==="function")d.dispose();else{var e=d.control;if(e&&typeof e.dispose==="function")e.dispose()}var a=d._behaviors;if(a)this._disposeComponents(a);a=d._components;if(a){this._disposeComponents(a);d._components=null}}if(!j){var f=c.dispose;if(f&&typeof f==="function")c.dispose();else{var e=c.control;if(e&&typeof e.dispose==="function")e.dispose()}var a=c._behaviors;if(a)this._disposeComponents(a);a=c._components;if(a){this._disposeComponents(a);c._components=null}}}},endCreateComponents:function(){var b=this._secondPassComponents;for(var a=0,d=b.length;a<d;a++){var c=b[a].component;Sys$Component$_setReferences(c,b[a].references);c.endUpdate()}this._secondPassComponents=[];this._creatingComponents=false},findComponent:function(b,a){return a?Sys.IContainer.isInstanceOfType(a)?a.findComponent(b):a[b]||null:Sys.Application._components[b]||null},getComponents:function(){var a=[],b=this._components;for(var c in b)a[a.length]=b[c];return a},initialize:function(){if(!this.get_isInitialized()&&!this._disposing){Sys._Application.callBaseMethod(this,"initialize");this._raiseInit();if(this.get_stateString){if(Sys.WebForms&&Sys.WebForms.PageRequestManager){this._beginRequestHandler=Function.createDelegate(this,this._onPageRequestManagerBeginRequest);Sys.WebForms.PageRequestManager.getInstance().add_beginRequest(this._beginRequestHandler);this._endRequestHandler=Function.createDelegate(this,this._onPageRequestManagerEndRequest);Sys.WebForms.PageRequestManager.getInstance().add_endRequest(this._endRequestHandler)}var a=this.get_stateString();if(a!==this._currentEntry)this._navigate(a);else this._ensureHistory()}this.raiseLoad()}},notifyScriptLoaded:function(){},registerDisposableObject:function(b){if(!this._disposing){var a=this._disposableObjects,c=a.length;a[c]=b;b.__msdisposeindex=c}},raiseLoad:function(){var b=this.get_events().getHandler("load"),a=new Sys.ApplicationLoadEventArgs(Array.clone(this._createdComponents),!!this._loaded);this._loaded=true;if(b)b(this,a);if(window.pageLoad)window.pageLoad(this,a);this._createdComponents=[]},removeComponent:function(b){var a=b.get_id();if(a)delete this._components[a]},unregisterDisposableObject:function(a){if(!this._disposing){var e=a.__msdisposeindex;if(typeof e==="number"){var b=this._disposableObjects;delete b[e];delete a.__msdisposeindex;if(++this._deleteCount>1000){var c=[];for(var d=0,f=b.length;d<f;d++){a=b[d];if(typeof a!=="undefined"){a.__msdisposeindex=c.length;c.push(a)}}this._disposableObjects=c;this._deleteCount=0}}}},_addComponentToSecondPass:function(b,a){this._secondPassComponents[this._secondPassComponents.length]={component:b,references:a}},_disposeComponents:function(a){if(a)for(var b=a.length-1;b>=0;b--){var c=a[b];if(typeof c.dispose==="function")c.dispose()}},_domReady:function(){var a,g,f=this;function b(){f.initialize()}var c=function(){Sys.UI.DomEvent.removeHandler(window,"load",c);b()};Sys.UI.DomEvent.addHandler(window,"load",c);if(document.addEventListener)try{document.addEventListener("DOMContentLoaded",a=function(){document.removeEventListener("DOMContentLoaded",a,false);b()},false)}catch(h){}else if(document.attachEvent)if(window==window.top&&document.documentElement.doScroll){var e,d=document.createElement("div");a=function(){try{d.doScroll("left")}catch(c){e=window.setTimeout(a,0);return}d=null;b()};a()}else document.attachEvent("onreadystatechange",a=function(){if(document.readyState==="complete"){document.detachEvent("onreadystatechange",a);b()}})},_raiseInit:function(){var a=this.get_events().getHandler("init");if(a){this.beginCreateComponents();a(this,Sys.EventArgs.Empty);this.endCreateComponents()}},_unloadHandler:function(){this.dispose()}};Sys._Application.registerClass("Sys._Application",Sys.Component,Sys.IContainer);Sys.Application=new Sys._Application;var $find=Sys.Application.findComponent;Sys.UI.Behavior=function(b){Sys.UI.Behavior.initializeBase(this);this._element=b;var a=b._behaviors;if(!a)b._behaviors=[this];else a[a.length]=this};Sys.UI.Behavior.prototype={_name:null,get_element:function(){return this._element},get_id:function(){var a=Sys.UI.Behavior.callBaseMethod(this,"get_id");if(a)return a;if(!this._element||!this._element.id)return "";return this._element.id+"$"+this.get_name()},get_name:function(){if(this._name)return this._name;var a=Object.getTypeName(this),b=a.lastIndexOf(".");if(b!==-1)a=a.substr(b+1);if(!this.get_isInitialized())this._name=a;return a},set_name:function(a){this._name=a},initialize:function(){Sys.UI.Behavior.callBaseMethod(this,"initialize");var a=this.get_name();if(a)this._element[a]=this},dispose:function(){Sys.UI.Behavior.callBaseMethod(this,"dispose");var a=this._element;if(a){var c=this.get_name();if(c)a[c]=null;var b=a._behaviors;Array.remove(b,this);if(b.length===0)a._behaviors=null;delete this._element}}};Sys.UI.Behavior.registerClass("Sys.UI.Behavior",Sys.Component);Sys.UI.Behavior.getBehaviorByName=function(b,c){var a=b[c];return a&&Sys.UI.Behavior.isInstanceOfType(a)?a:null};Sys.UI.Behavior.getBehaviors=function(a){if(!a._behaviors)return [];return Array.clone(a._behaviors)};Sys.UI.Behavior.getBehaviorsByType=function(d,e){var a=d._behaviors,c=[];if(a)for(var b=0,f=a.length;b<f;b++)if(e.isInstanceOfType(a[b]))c[c.length]=a[b];return c};Sys.UI.VisibilityMode=function(){throw Error.notImplemented()};Sys.UI.VisibilityMode.prototype={hide:0,collapse:1};Sys.UI.VisibilityMode.registerEnum("Sys.UI.VisibilityMode");Sys.UI.Control=function(a){Sys.UI.Control.initializeBase(this);this._element=a;a.control=this;var b=this.get_role();if(b)a.setAttribute("role",b)};Sys.UI.Control.prototype={_parent:null,_visibilityMode:Sys.UI.VisibilityMode.hide,get_element:function(){return this._element},get_id:function(){if(!this._element)return "";return this._element.id},set_id:function(){throw Error.invalidOperation(Sys.Res.cantSetId)},get_parent:function(){if(this._parent)return this._parent;if(!this._element)return null;var a=this._element.parentNode;while(a){if(a.control)return a.control;a=a.parentNode}return null},set_parent:function(a){this._parent=a},get_role:function(){return null},get_visibilityMode:function(){return Sys.UI.DomElement.getVisibilityMode(this._element)},set_visibilityMode:function(a){Sys.UI.DomElement.setVisibilityMode(this._element,a)},get_visible:function(){return Sys.UI.DomElement.getVisible(this._element)},set_visible:function(a){Sys.UI.DomElement.setVisible(this._element,a)},addCssClass:function(a){Sys.UI.DomElement.addCssClass(this._element,a)},dispose:function(){Sys.UI.Control.callBaseMethod(this,"dispose");if(this._element){this._element.control=null;delete this._element}if(this._parent)delete this._parent},onBubbleEvent:function(){return false},raiseBubbleEvent:function(a,b){this._raiseBubbleEvent(a,b)},_raiseBubbleEvent:function(b,c){var a=this.get_parent();while(a){if(a.onBubbleEvent(b,c))return;a=a.get_parent()}},removeCssClass:function(a){Sys.UI.DomElement.removeCssClass(this._element,a)},toggleCssClass:function(a){Sys.UI.DomElement.toggleCssClass(this._element,a)}};Sys.UI.Control.registerClass("Sys.UI.Control",Sys.Component);Sys.HistoryEventArgs=function(a){Sys.HistoryEventArgs.initializeBase(this);this._state=a};Sys.HistoryEventArgs.prototype={get_state:function(){return this._state}};Sys.HistoryEventArgs.registerClass("Sys.HistoryEventArgs",Sys.EventArgs);Sys.Application._appLoadHandler=null;Sys.Application._beginRequestHandler=null;Sys.Application._clientId=null;Sys.Application._currentEntry="";Sys.Application._endRequestHandler=null;Sys.Application._history=null;Sys.Application._enableHistory=false;Sys.Application._historyFrame=null;Sys.Application._historyInitialized=false;Sys.Application._historyPointIsNew=false;Sys.Application._ignoreTimer=false;Sys.Application._initialState=null;Sys.Application._state={};Sys.Application._timerCookie=0;Sys.Application._timerHandler=null;Sys.Application._uniqueId=null;Sys._Application.prototype.get_stateString=function(){var a=null;if(Sys.Browser.agent===Sys.Browser.Firefox){var c=window.location.href,b=c.indexOf("#");if(b!==-1)a=c.substring(b+1);else a="";return a}else a=window.location.hash;if(a.length>0&&a.charAt(0)==="#")a=a.substring(1);return a};Sys._Application.prototype.get_enableHistory=function(){return this._enableHistory};Sys._Application.prototype.set_enableHistory=function(a){this._enableHistory=a};Sys._Application.prototype.add_navigate=function(a){this.get_events().addHandler("navigate",a)};Sys._Application.prototype.remove_navigate=function(a){this.get_events().removeHandler("navigate",a)};Sys._Application.prototype.addHistoryPoint=function(c,f){this._ensureHistory();var b=this._state;for(var a in c){var d=c[a];if(d===null){if(typeof b[a]!=="undefined")delete b[a]}else b[a]=d}var e=this._serializeState(b);this._historyPointIsNew=true;this._setState(e,f);this._raiseNavigate()};Sys._Application.prototype.setServerId=function(a,b){this._clientId=a;this._uniqueId=b};Sys._Application.prototype.setServerState=function(a){this._ensureHistory();this._state.__s=a;this._updateHiddenField(a)};Sys._Application.prototype._deserializeState=function(a){var e={};a=a||"";var b=a.indexOf("&&");if(b!==-1&&b+2<a.length){e.__s=a.substr(b+2);a=a.substr(0,b)}var g=a.split("&");for(var f=0,j=g.length;f<j;f++){var d=g[f],c=d.indexOf("=");if(c!==-1&&c+1<d.length){var i=d.substr(0,c),h=d.substr(c+1);e[i]=decodeURIComponent(h)}}return e};Sys._Application.prototype._enableHistoryInScriptManager=function(){this._enableHistory=true};Sys._Application.prototype._ensureHistory=function(){if(!this._historyInitialized&&this._enableHistory){if(Sys.Browser.agent===Sys.Browser.InternetExplorer&&Sys.Browser.documentMode<8){this._historyFrame=document.getElementById("__historyFrame");this._ignoreIFrame=true}this._timerHandler=Function.createDelegate(this,this._onIdle);this._timerCookie=window.setTimeout(this._timerHandler,100);try{this._initialState=this._deserializeState(this.get_stateString())}catch(a){}this._historyInitialized=true}};Sys._Application.prototype._navigate=function(c){this._ensureHistory();var b=this._deserializeState(c);if(this._uniqueId){var d=this._state.__s||"",a=b.__s||"";if(a!==d){this._updateHiddenField(a);__doPostBack(this._uniqueId,a);this._state=b;return}}this._setState(c);this._state=b;this._raiseNavigate()};Sys._Application.prototype._onIdle=function(){delete this._timerCookie;var a=this.get_stateString();if(a!==this._currentEntry){if(!this._ignoreTimer){this._historyPointIsNew=false;this._navigate(a)}}else this._ignoreTimer=false;this._timerCookie=window.setTimeout(this._timerHandler,100)};Sys._Application.prototype._onIFrameLoad=function(a){this._ensureHistory();if(!this._ignoreIFrame){this._historyPointIsNew=false;this._navigate(a)}this._ignoreIFrame=false};Sys._Application.prototype._onPageRequestManagerBeginRequest=function(){this._ignoreTimer=true;this._originalTitle=document.title};Sys._Application.prototype._onPageRequestManagerEndRequest=function(g,f){var d=f.get_dataItems()[this._clientId],c=this._originalTitle;this._originalTitle=null;var b=document.getElementById("__EVENTTARGET");if(b&&b.value===this._uniqueId)b.value="";if(typeof d!=="undefined"){this.setServerState(d);this._historyPointIsNew=true}else this._ignoreTimer=false;var a=this._serializeState(this._state);if(a!==this._currentEntry){this._ignoreTimer=true;if(typeof c==="string"){if(Sys.Browser.agent!==Sys.Browser.InternetExplorer||Sys.Browser.version>7){var e=document.title;document.title=c;this._setState(a);document.title=e}else this._setState(a);this._raiseNavigate()}else{this._setState(a);this._raiseNavigate()}}};Sys._Application.prototype._raiseNavigate=function(){var d=this._historyPointIsNew,c=this.get_events().getHandler("navigate"),b={};for(var a in this._state)if(a!=="__s")b[a]=this._state[a];var e=new Sys.HistoryEventArgs(b);if(c)c(this,e);if(!d){var f;try{if(Sys.Browser.agent===Sys.Browser.Firefox&&window.location.hash&&(!window.frameElement||window.top.location.hash))Sys.Browser.version<3.5?window.history.go(0):(location.hash=this.get_stateString())}catch(g){}}};Sys._Application.prototype._serializeState=function(d){var b=[];for(var a in d){var e=d[a];if(a==="__s")var c=e;else b[b.length]=a+"="+encodeURIComponent(e)}return b.join("&")+(c?"&&"+c:"")};Sys._Application.prototype._setState=function(a,b){if(this._enableHistory){a=a||"";if(a!==this._currentEntry){if(window.theForm){var d=window.theForm.action,e=d.indexOf("#");window.theForm.action=(e!==-1?d.substring(0,e):d)+"#"+a}if(this._historyFrame&&this._historyPointIsNew){this._ignoreIFrame=true;var c=this._historyFrame.contentWindow.document;c.open("javascript:'<html></html>'");c.write("<html><head><title>"+(b||document.title)+"</title><scri"+'pt type="text/javascript">parent.Sys.Application._onIFrameLoad('+Sys.Serialization.JavaScriptSerializer.serialize(a)+");</scri"+"pt></head><body></body></html>");c.close()}this._ignoreTimer=false;this._currentEntry=a;if(this._historyFrame||this._historyPointIsNew){var f=this.get_stateString();if(a!==f){window.location.hash=a;this._currentEntry=this.get_stateString();if(typeof b!=="undefined"&&b!==null)document.title=b}}this._historyPointIsNew=false}}};Sys._Application.prototype._updateHiddenField=function(b){if(this._clientId){var a=document.getElementById(this._clientId);if(a)a.value=b}};if(!window.XMLHttpRequest)window.XMLHttpRequest=function(){var b=["Msxml2.XMLHTTP.3.0","Msxml2.XMLHTTP"];for(var a=0,c=b.length;a<c;a++)try{return new ActiveXObject(b[a])}catch(d){}return null};Type.registerNamespace("Sys.Net");Sys.Net.WebRequestExecutor=function(){this._webRequest=null;this._resultObject=null};Sys.Net.WebRequestExecutor.prototype={get_webRequest:function(){return this._webRequest},_set_webRequest:function(a){this._webRequest=a},get_started:function(){throw Error.notImplemented()},get_responseAvailable:function(){throw Error.notImplemented()},get_timedOut:function(){throw Error.notImplemented()},get_aborted:function(){throw Error.notImplemented()},get_responseData:function(){throw Error.notImplemented()},get_statusCode:function(){throw Error.notImplemented()},get_statusText:function(){throw Error.notImplemented()},get_xml:function(){throw Error.notImplemented()},get_object:function(){if(!this._resultObject)this._resultObject=Sys.Serialization.JavaScriptSerializer.deserialize(this.get_responseData());return this._resultObject},executeRequest:function(){throw Error.notImplemented()},abort:function(){throw Error.notImplemented()},getResponseHeader:function(){throw Error.notImplemented()},getAllResponseHeaders:function(){throw Error.notImplemented()}};Sys.Net.WebRequestExecutor.registerClass("Sys.Net.WebRequestExecutor");Sys.Net.XMLDOM=function(d){if(!window.DOMParser){var c=["Msxml2.DOMDocument.3.0","Msxml2.DOMDocument"];for(var b=0,f=c.length;b<f;b++)try{var a=new ActiveXObject(c[b]);a.async=false;a.loadXML(d);a.setProperty("SelectionLanguage","XPath");return a}catch(g){}}else try{var e=new window.DOMParser;return e.parseFromString(d,"text/xml")}catch(g){}return null};Sys.Net.XMLHttpExecutor=function(){Sys.Net.XMLHttpExecutor.initializeBase(this);var a=this;this._xmlHttpRequest=null;this._webRequest=null;this._responseAvailable=false;this._timedOut=false;this._timer=null;this._aborted=false;this._started=false;this._onReadyStateChange=function(){if(a._xmlHttpRequest.readyState===4){try{if(typeof a._xmlHttpRequest.status==="undefined")return}catch(b){return}a._clearTimer();a._responseAvailable=true;try{a._webRequest.completed(Sys.EventArgs.Empty)}finally{if(a._xmlHttpRequest!=null){a._xmlHttpRequest.onreadystatechange=Function.emptyMethod;a._xmlHttpRequest=null}}}};this._clearTimer=function(){if(a._timer!=null){window.clearTimeout(a._timer);a._timer=null}};this._onTimeout=function(){if(!a._responseAvailable){a._clearTimer();a._timedOut=true;a._xmlHttpRequest.onreadystatechange=Function.emptyMethod;a._xmlHttpRequest.abort();a._webRequest.completed(Sys.EventArgs.Empty);a._xmlHttpRequest=null}}};Sys.Net.XMLHttpExecutor.prototype={get_timedOut:function(){return this._timedOut},get_started:function(){return this._started},get_responseAvailable:function(){return this._responseAvailable},get_aborted:function(){return this._aborted},executeRequest:function(){this._webRequest=this.get_webRequest();var c=this._webRequest.get_body(),a=this._webRequest.get_headers();this._xmlHttpRequest=new XMLHttpRequest;this._xmlHttpRequest.onreadystatechange=this._onReadyStateChange;var e=this._webRequest.get_httpVerb();this._xmlHttpRequest.open(e,this._webRequest.getResolvedUrl(),true);this._xmlHttpRequest.setRequestHeader("X-Requested-With","XMLHttpRequest");if(a)for(var b in a){var f=a[b];if(typeof f!=="function")this._xmlHttpRequest.setRequestHeader(b,f)}if(e.toLowerCase()==="post"){if(a===null||!a["Content-Type"])this._xmlHttpRequest.setRequestHeader("Content-Type","application/x-www-form-urlencoded; charset=utf-8");if(!c)c=""}var d=this._webRequest.get_timeout();if(d>0)this._timer=window.setTimeout(Function.createDelegate(this,this._onTimeout),d);this._xmlHttpRequest.send(c);this._started=true},getResponseHeader:function(b){var a;try{a=this._xmlHttpRequest.getResponseHeader(b)}catch(c){}if(!a)a="";return a},getAllResponseHeaders:function(){return this._xmlHttpRequest.getAllResponseHeaders()},get_responseData:function(){return this._xmlHttpRequest.responseText},get_statusCode:function(){var a=0;try{a=this._xmlHttpRequest.status}catch(b){}return a},get_statusText:function(){return this._xmlHttpRequest.statusText},get_xml:function(){var a=this._xmlHttpRequest.responseXML;if(!a||!a.documentElement){a=Sys.Net.XMLDOM(this._xmlHttpRequest.responseText);if(!a||!a.documentElement)return null}else if(navigator.userAgent.indexOf("MSIE")!==-1)a.setProperty("SelectionLanguage","XPath");if(a.documentElement.namespaceURI==="http://www.mozilla.org/newlayout/xml/parsererror.xml"&&a.documentElement.tagName==="parsererror")return null;if(a.documentElement.firstChild&&a.documentElement.firstChild.tagName==="parsererror")return null;return a},abort:function(){if(this._aborted||this._responseAvailable||this._timedOut)return;this._aborted=true;this._clearTimer();if(this._xmlHttpRequest&&!this._responseAvailable){this._xmlHttpRequest.onreadystatechange=Function.emptyMethod;this._xmlHttpRequest.abort();this._xmlHttpRequest=null;this._webRequest.completed(Sys.EventArgs.Empty)}}};Sys.Net.XMLHttpExecutor.registerClass("Sys.Net.XMLHttpExecutor",Sys.Net.WebRequestExecutor);Sys.Net._WebRequestManager=function(){this._defaultTimeout=0;this._defaultExecutorType="Sys.Net.XMLHttpExecutor"};Sys.Net._WebRequestManager.prototype={add_invokingRequest:function(a){this._get_eventHandlerList().addHandler("invokingRequest",a)},remove_invokingRequest:function(a){this._get_eventHandlerList().removeHandler("invokingRequest",a)},add_completedRequest:function(a){this._get_eventHandlerList().addHandler("completedRequest",a)},remove_completedRequest:function(a){this._get_eventHandlerList().removeHandler("completedRequest",a)},_get_eventHandlerList:function(){if(!this._events)this._events=new Sys.EventHandlerList;return this._events},get_defaultTimeout:function(){return this._defaultTimeout},set_defaultTimeout:function(a){this._defaultTimeout=a},get_defaultExecutorType:function(){return this._defaultExecutorType},set_defaultExecutorType:function(a){this._defaultExecutorType=a},executeRequest:function(webRequest){var executor=webRequest.get_executor();if(!executor){var failed=false;try{var executorType=eval(this._defaultExecutorType);executor=new executorType}catch(a){failed=true}webRequest.set_executor(executor)}if(executor.get_aborted())return;var evArgs=new Sys.Net.NetworkRequestEventArgs(webRequest),handler=this._get_eventHandlerList().getHandler("invokingRequest");if(handler)handler(this,evArgs);if(!evArgs.get_cancel())executor.executeRequest()}};Sys.Net._WebRequestManager.registerClass("Sys.Net._WebRequestManager");Sys.Net.WebRequestManager=new Sys.Net._WebRequestManager;Sys.Net.NetworkRequestEventArgs=function(a){Sys.Net.NetworkRequestEventArgs.initializeBase(this);this._webRequest=a};Sys.Net.NetworkRequestEventArgs.prototype={get_webRequest:function(){return this._webRequest}};Sys.Net.NetworkRequestEventArgs.registerClass("Sys.Net.NetworkRequestEventArgs",Sys.CancelEventArgs);Sys.Net.WebRequest=function(){this._url="";this._headers={};this._body=null;this._userContext=null;this._httpVerb=null;this._executor=null;this._invokeCalled=false;this._timeout=0};Sys.Net.WebRequest.prototype={add_completed:function(a){this._get_eventHandlerList().addHandler("completed",a)},remove_completed:function(a){this._get_eventHandlerList().removeHandler("completed",a)},completed:function(b){var a=Sys.Net.WebRequestManager._get_eventHandlerList().getHandler("completedRequest");if(a)a(this._executor,b);a=this._get_eventHandlerList().getHandler("completed");if(a)a(this._executor,b)},_get_eventHandlerList:function(){if(!this._events)this._events=new Sys.EventHandlerList;return this._events},get_url:function(){return this._url},set_url:function(a){this._url=a},get_headers:function(){return this._headers},get_httpVerb:function(){if(this._httpVerb===null){if(this._body===null)return "GET";return "POST"}return this._httpVerb},set_httpVerb:function(a){this._httpVerb=a},get_body:function(){return this._body},set_body:function(a){this._body=a},get_userContext:function(){return this._userContext},set_userContext:function(a){this._userContext=a},get_executor:function(){return this._executor},set_executor:function(a){this._executor=a;this._executor._set_webRequest(this)},get_timeout:function(){if(this._timeout===0)return Sys.Net.WebRequestManager.get_defaultTimeout();return this._timeout},set_timeout:function(a){this._timeout=a},getResolvedUrl:function(){return Sys.Net.WebRequest._resolveUrl(this._url)},invoke:function(){Sys.Net.WebRequestManager.executeRequest(this);this._invokeCalled=true}};Sys.Net.WebRequest._resolveUrl=function(b,a){if(b&&b.indexOf("://")!==-1)return b;if(!a||a.length===0){var d=document.getElementsByTagName("base")[0];if(d&&d.href&&d.href.length>0)a=d.href;else a=document.URL}var c=a.indexOf("?");if(c!==-1)a=a.substr(0,c);c=a.indexOf("#");if(c!==-1)a=a.substr(0,c);a=a.substr(0,a.lastIndexOf("/")+1);if(!b||b.length===0)return a;if(b.charAt(0)==="/"){var e=a.indexOf("://"),g=a.indexOf("/",e+3);return a.substr(0,g)+b}else{var f=a.lastIndexOf("/");return a.substr(0,f+1)+b}};Sys.Net.WebRequest._createQueryString=function(c,b,f){b=b||encodeURIComponent;var h=0,e,g,d,a=new Sys.StringBuilder;if(c)for(d in c){e=c[d];if(typeof e==="function")continue;g=Sys.Serialization.JavaScriptSerializer.serialize(e);if(h++)a.append("&");a.append(d);a.append("=");a.append(b(g))}if(f){if(h)a.append("&");a.append(f)}return a.toString()};Sys.Net.WebRequest._createUrl=function(a,b,c){if(!b&&!c)return a;var d=Sys.Net.WebRequest._createQueryString(b,null,c);return d.length?a+(a&&a.indexOf("?")>=0?"&":"?")+d:a};Sys.Net.WebRequest.registerClass("Sys.Net.WebRequest");Sys._ScriptLoaderTask=function(b,a){this._scriptElement=b;this._completedCallback=a};Sys._ScriptLoaderTask.prototype={get_scriptElement:function(){return this._scriptElement},dispose:function(){if(this._disposed)return;this._disposed=true;this._removeScriptElementHandlers();Sys._ScriptLoaderTask._clearScript(this._scriptElement);this._scriptElement=null},execute:function(){this._addScriptElementHandlers();document.getElementsByTagName("head")[0].appendChild(this._scriptElement)},_addScriptElementHandlers:function(){this._scriptLoadDelegate=Function.createDelegate(this,this._scriptLoadHandler);if(Sys.Browser.agent!==Sys.Browser.InternetExplorer){this._scriptElement.readyState="loaded";$addHandler(this._scriptElement,"load",this._scriptLoadDelegate)}else $addHandler(this._scriptElement,"readystatechange",this._scriptLoadDelegate);if(this._scriptElement.addEventListener){this._scriptErrorDelegate=Function.createDelegate(this,this._scriptErrorHandler);this._scriptElement.addEventListener("error",this._scriptErrorDelegate,false)}},_removeScriptElementHandlers:function(){if(this._scriptLoadDelegate){var a=this.get_scriptElement();if(Sys.Browser.agent!==Sys.Browser.InternetExplorer)$removeHandler(a,"load",this._scriptLoadDelegate);else $removeHandler(a,"readystatechange",this._scriptLoadDelegate);if(this._scriptErrorDelegate){this._scriptElement.removeEventListener("error",this._scriptErrorDelegate,false);this._scriptErrorDelegate=null}this._scriptLoadDelegate=null}},_scriptErrorHandler:function(){if(this._disposed)return;this._completedCallback(this.get_scriptElement(),false)},_scriptLoadHandler:function(){if(this._disposed)return;var a=this.get_scriptElement();if(a.readyState!=="loaded"&&a.readyState!=="complete")return;this._completedCallback(a,true)}};Sys._ScriptLoaderTask.registerClass("Sys._ScriptLoaderTask",null,Sys.IDisposable);Sys._ScriptLoaderTask._clearScript=function(a){if(!Sys.Debug.isDebug)a.parentNode.removeChild(a)};Type.registerNamespace("Sys.Net");Sys.Net.WebServiceProxy=function(){};Sys.Net.WebServiceProxy.prototype={get_timeout:function(){return this._timeout||0},set_timeout:function(a){if(a<0)throw Error.argumentOutOfRange("value",a,Sys.Res.invalidTimeout);this._timeout=a},get_defaultUserContext:function(){return typeof this._userContext==="undefined"?null:this._userContext},set_defaultUserContext:function(a){this._userContext=a},get_defaultSucceededCallback:function(){return this._succeeded||null},set_defaultSucceededCallback:function(a){this._succeeded=a},get_defaultFailedCallback:function(){return this._failed||null},set_defaultFailedCallback:function(a){this._failed=a},get_enableJsonp:function(){return !!this._jsonp},set_enableJsonp:function(a){this._jsonp=a},get_path:function(){return this._path||null},set_path:function(a){this._path=a},get_jsonpCallbackParameter:function(){return this._callbackParameter||"callback"},set_jsonpCallbackParameter:function(a){this._callbackParameter=a},_invoke:function(d,e,g,f,c,b,a){c=c||this.get_defaultSucceededCallback();b=b||this.get_defaultFailedCallback();if(a===null||typeof a==="undefined")a=this.get_defaultUserContext();return Sys.Net.WebServiceProxy.invoke(d,e,g,f,c,b,a,this.get_timeout(),this.get_enableJsonp(),this.get_jsonpCallbackParameter())}};Sys.Net.WebServiceProxy.registerClass("Sys.Net.WebServiceProxy");Sys.Net.WebServiceProxy.invoke=function(q,a,m,l,j,b,g,e,w,p){var i=w!==false?Sys.Net.WebServiceProxy._xdomain.exec(q):null,c,n=i&&i.length===3&&(i[1]!==location.protocol||i[2]!==location.host);m=n||m;if(n){p=p||"callback";c="_jsonp"+Sys._jsonp++}if(!l)l={};var r=l;if(!m||!r)r={};var s,h,f=null,k,o=null,u=Sys.Net.WebRequest._createUrl(a?q+"/"+encodeURIComponent(a):q,r,n?p+"=Sys."+c:null);if(n){s=document.createElement("script");s.src=u;k=new Sys._ScriptLoaderTask(s,function(d,b){if(!b||c)t({Message:String.format(Sys.Res.webServiceFailedNoMsg,a)},-1)});function v(){if(f===null)return;f=null;h=new Sys.Net.WebServiceError(true,String.format(Sys.Res.webServiceTimedOut,a));k.dispose();delete Sys[c];if(b)b(h,g,a)}function t(d,e){if(f!==null){window.clearTimeout(f);f=null}k.dispose();delete Sys[c];c=null;if(typeof e!=="undefined"&&e!==200){if(b){h=new Sys.Net.WebServiceError(false,d.Message||String.format(Sys.Res.webServiceFailedNoMsg,a),d.StackTrace||null,d.ExceptionType||null,d);h._statusCode=e;b(h,g,a)}}else if(j)j(d,g,a)}Sys[c]=t;e=e||Sys.Net.WebRequestManager.get_defaultTimeout();if(e>0)f=window.setTimeout(v,e);k.execute();return null}var d=new Sys.Net.WebRequest;d.set_url(u);d.get_headers()["Content-Type"]="application/json; charset=utf-8";if(!m){o=Sys.Serialization.JavaScriptSerializer.serialize(l);if(o==="{}")o=""}d.set_body(o);d.add_completed(x);if(e&&e>0)d.set_timeout(e);d.invoke();function x(d){if(d.get_responseAvailable()){var f=d.get_statusCode(),c=null;try{var e=d.getResponseHeader("Content-Type");if(e.startsWith("application/json"))c=d.get_object();else if(e.startsWith("text/xml"))c=d.get_xml();else c=d.get_responseData()}catch(m){}var k=d.getResponseHeader("jsonerror"),h=k==="true";if(h){if(c)c=new Sys.Net.WebServiceError(false,c.Message,c.StackTrace,c.ExceptionType,c)}else if(e.startsWith("application/json"))c=!c||typeof c.d==="undefined"?c:c.d;if(f<200||f>=300||h){if(b){if(!c||!h)c=new Sys.Net.WebServiceError(false,String.format(Sys.Res.webServiceFailedNoMsg,a));c._statusCode=f;b(c,g,a)}}else if(j)j(c,g,a)}else{var i;if(d.get_timedOut())i=String.format(Sys.Res.webServiceTimedOut,a);else i=String.format(Sys.Res.webServiceFailedNoMsg,a);if(b)b(new Sys.Net.WebServiceError(d.get_timedOut(),i,"",""),g,a)}}return d};Sys.Net.WebServiceProxy._generateTypedConstructor=function(a){return function(b){if(b)for(var c in b)this[c]=b[c];this.__type=a}};Sys._jsonp=0;Sys.Net.WebServiceProxy._xdomain=/^\s*([a-zA-Z0-9\+\-\.]+\:)\/\/([^?#\/]+)/;Sys.Net.WebServiceError=function(d,e,c,a,b){this._timedOut=d;this._message=e;this._stackTrace=c;this._exceptionType=a;this._errorObject=b;this._statusCode=-1};Sys.Net.WebServiceError.prototype={get_timedOut:function(){return this._timedOut},get_statusCode:function(){return this._statusCode},get_message:function(){return this._message},get_stackTrace:function(){return this._stackTrace||""},get_exceptionType:function(){return this._exceptionType||""},get_errorObject:function(){return this._errorObject||null}};Sys.Net.WebServiceError.registerClass("Sys.Net.WebServiceError");
Type.registerNamespace('Sys');Sys.Res={'argumentInteger':'Value must be an integer.','invokeCalledTwice':'Cannot call invoke more than once.','webServiceFailed':'The server method \'{0}\' failed with the following error: {1}','argumentType':'Object cannot be converted to the required type.','argumentNull':'Value cannot be null.','scriptAlreadyLoaded':'The script \'{0}\' has been referenced multiple times. If referencing Microsoft AJAX scripts explicitly, set the MicrosoftAjaxMode property of the ScriptManager to Explicit.','scriptDependencyNotFound':'The script \'{0}\' failed to load because it is dependent on script \'{1}\'.','formatBadFormatSpecifier':'Format specifier was invalid.','requiredScriptReferenceNotIncluded':'\'{0}\' requires that you have included a script reference to \'{1}\'.','webServiceFailedNoMsg':'The server method \'{0}\' failed.','argumentDomElement':'Value must be a DOM element.','invalidExecutorType':'Could not create a valid Sys.Net.WebRequestExecutor from: {0}.','cannotCallBeforeResponse':'Cannot call {0} when responseAvailable is false.','actualValue':'Actual value was {0}.','enumInvalidValue':'\'{0}\' is not a valid value for enum {1}.','scriptLoadFailed':'The script \'{0}\' could not be loaded.','parameterCount':'Parameter count mismatch.','cannotDeserializeEmptyString':'Cannot deserialize empty string.','formatInvalidString':'Input string was not in a correct format.','invalidTimeout':'Value must be greater than or equal to zero.','cannotAbortBeforeStart':'Cannot abort when executor has not started.','argument':'Value does not fall within the expected range.','cannotDeserializeInvalidJson':'Cannot deserialize. The data does not correspond to valid JSON.','invalidHttpVerb':'httpVerb cannot be set to an empty or null string.','nullWebRequest':'Cannot call executeRequest with a null webRequest.','eventHandlerInvalid':'Handler was not added through the Sys.UI.DomEvent.addHandler method.','cannotSerializeNonFiniteNumbers':'Cannot serialize non finite numbers.','argumentUndefined':'Value cannot be undefined.','webServiceInvalidReturnType':'The server method \'{0}\' returned an invalid type. Expected type: {1}','servicePathNotSet':'The path to the web service has not been set.','argumentTypeWithTypes':'Object of type \'{0}\' cannot be converted to type \'{1}\'.','cannotCallOnceStarted':'Cannot call {0} once started.','badBaseUrl1':'Base URL does not contain ://.','badBaseUrl2':'Base URL does not contain another /.','badBaseUrl3':'Cannot find last / in base URL.','setExecutorAfterActive':'Cannot set executor after it has become active.','paramName':'Parameter name: {0}','nullReferenceInPath':'Null reference while evaluating data path: \'{0}\'.','cannotCallOutsideHandler':'Cannot call {0} outside of a completed event handler.','cannotSerializeObjectWithCycle':'Cannot serialize object with cyclic reference within child properties.','format':'One of the identified items was in an invalid format.','assertFailedCaller':'Assertion Failed: {0}\r\nat {1}','argumentOutOfRange':'Specified argument was out of the range of valid values.','webServiceTimedOut':'The server method \'{0}\' timed out.','notImplemented':'The method or operation is not implemented.','assertFailed':'Assertion Failed: {0}','invalidOperation':'Operation is not valid due to the current state of the object.','breakIntoDebugger':'{0}\r\n\r\nBreak into debugger?'};
﻿/* #region Platform Detection */
/* Browser Related Constants */
var INTERNET_EXPLORER = "Microsoft Internet Explorer";
var FIREFOX = "FireFox";
var SAFARI = "Safari";
var CHROME = "Chrome";
/* OS Related Constants */
var WINDOWS = "Windows";
var MAC = "Mac";
var LINUX = "Linux";
/* Variables */
var browserName = "";                                                 /* Browser Name INTERNET_EXPLORER, FIREFOX, SAFARI */
var browserVersion = 0.0;                                             /* Broswer Version x.x */
var tridentVersion = 0.0;                                             /* Trident Token for IE */
var osName = "";                                                      /* Operating System Name WINDOWS, MAC, LINUX */
var osVersion = 0.0;                                                  /* Operating System Version x.x */
var platform = "";
var browserArch = "";
/* Browser Detection */
if (/Firefox[\/\s](\d+\.\d+)/.test(navigator.userAgent)) {
    browserName = FIREFOX;
    browserVersion = RegExp.$1;
} else if (/MSIE (\d+\.\d+)/.test(navigator.userAgent)) {
    browserName = INTERNET_EXPLORER;
    browserVersion = RegExp.$1;

    var regularExpression = new RegExp(/Trident\/(\d+\.\d+)/);
    if (regularExpression.test(navigator.userAgent)) {
        tridentVersion = RegExp.$1;
    }
} else if (/Safari/.test(navigator.userAgent) && !/Chrome/.test(navigator.userAgent)) {
    browserName = SAFARI;
    if (/Version[\/\s](\d+\.\d+)/.test(navigator.userAgent)) {
        browserVersion = RegExp.$1;
    }
} else if (/Chrome[\/\s](\d+\.\d+)/.test(navigator.userAgent)) {
    browserName = CHROME;
    browserVersion = RegExp.$1;
}
/* OS Detection */
if (/Windows NT (\d+\.\d+)/.test(navigator.userAgent)) {
    osName = WINDOWS;
    osVersion = RegExp.$1;
} else if (/Intel Mac OS X/.test(navigator.userAgent)) {
    osName = MAC;
    if (/Intel Mac OS X (\d+\.\d+)/.test(navigator.userAgent)) {
        osVersion = RegExp.$1;
        if (/Intel Mac OS X (\d+\.\d+\.\d+)/.test(navigator.userAgent)) {
            osVersion = RegExp.$1;
        }
    } else if (/Intel Mac OS X (\d+\_\d+)/.test(navigator.userAgent)) {
        osVersion = (RegExp.$1).replace('_', '.');
        if (/Intel Mac OS X (\d+\_\d+\_\d+)/.test(navigator.userAgent)) {
            osVersion = RegExp.$1.replace('_', '.');
        }
    }
} else if (navigator.userAgent.indexOf('Linux') >= 0) {
    osName = LINUX;
    //TODO: version
}
/* Platform Detection */
var info = navigator.platform.toLowerCase();
if (info.match(/win32/)) {
    platform = "win32";
} else if (info.match(/win64/)) {
    platform = "win64";
} else if (info.match(/mac/)) {
    platform = "mac";
} else if (info.match(/linux/)) {
    platform = "linux";
} else {
    platform = "other";
}

if (isPlatformWin32() || isPlatformWin64()) {
    var info = navigator.userAgent.toLowerCase();
    if (matchResult = info.match(/win64; x64/)) {
        browserArch = "amd64";
    } else if (matchResult = info.match(/win64; ia64/)) {
        browserArch = "ia64";
    } else {
        browserArch = "x86";
    }
}
/* OS Methods */
function isWindowsOS() { return (WINDOWS == osName); }
function isMacOS() { return (MAC == osName); }
function isLinuxOS() { return (LINUX == osName); }
function isWindows2k() { return osVersion == 5.0; }
function isWindowsXP() { return osVersion == 5.1; }
function isWindowsXPx64Or2k3() { return osVersion == 5.2; }
function isWindowsVista() { return osVersion == 6.0; }
function isWin7Or2k8() { return osVersion == 6.1; }
function getOSVersion() { return osVersion; }
/* Browser Methods */
function isIE() { return (INTERNET_EXPLORER == browserName); }
function isFF() { return (FIREFOX == browserName); }
function isSafari() { return (SAFARI == browserName); }
function isChrome() { return (CHROME == browserName); }
function getBrowserVersion() { return browserVersion; }
function getTridentVersion() { return tridentVersion; }
function getBrowserArch() { return browserArch; }
/* Platform Methods */
function isPlatformWin32() { return (platform == "win32"); }
function isPlatformWin64() { return (platform == "win64"); }
/* #endregion Platform Detection */

function documentModeSupported() { return document.documentMode; }
/* #region Utility Methods*/
/* Cookie Related Methoda */
function isCookieEnabled() { return navigator.cookieEnabled; }
function createCookie(cookieName, cookieValue, expiryMinutes) {
    var expires = "";
    if (expiryMinutes) {
        var currDate = new Date();
        currDate.setTime(currDate.getTime() + (expiryMinutes * 60 * 1000));
        expires = "; expires=" + currDate.toGMTString();
    }
    document.cookie = cookieName + "=" + cookieValue + expires + "; path=/";
}
function readCookie(cookieName) {
    var nameEQ = cookieName + "=";
    var cookieAttributes = document.cookie.split(';');
    for (var i = 0; i < cookieAttributes.length; i++) {
        var c = cookieAttributes[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1, c.length);
        }
        if (c.indexOf(nameEQ) == 0) {
            return c.substring(nameEQ.length, c.length);
        }
    }
    return null;
}
function eraseCookie(cookieName) {
    createCookie(cookieName, "", -1);
}

/**
* EscapeXmlSensitveChar is a function used to 
* convert '<' -> '&lt;' '>' -> '&gt;' '&' -> '&amp;' ''' -> '&apos;' '"' -> '&quot;'
* for text data in XML format
*/
function EscapeXmlSensitveChar(str) {
    var str = str + "";
    if (!str) {
        return "";
    }
    str = str.replace(/&/ig, "&amp;");
    str = str.replace(/</ig, "&lt;");
    str = str.replace(/>/ig, "&gt;");
    str = str.replace(/\'/ig, "&apos;");
    str = str.replace(/\"/ig, "&quot;");
    return EncodeC0Chars(str);
}
function EscapeXmlSensitiveChars(str) {
    return EscapeXmlSensitveChar(str);
}
function IsStringNullOrEmpty(str) {
    if (str == null || str.length == 0 || str == undefined) {
        return true;
    }
    return false;
}
function StringFormat() {
    var newString = arguments[0];
    for (var i = 0; i < arguments.length - 1; i++) {
        newString = newString.replace("%" + i, arguments[i + 1]);
    }
    return newString;
}
function ShowException(e) {
}
// Generate a regular expression to remove all C0 control chars
// This string will be &#(1|2|3....|1a); to pare the c0 chars
var C0PatternString = "&#(";
for (var i = 0; i < 32; i++) {
    // /r/n is valid char, we just ignore this
    if (i == 10 || i == 13) {
        continue;
    }
    var str = "x" + i.toString(16) + "|" + i;
    if (i == 0) {
        C0PatternString = C0PatternString + str;
    }
    else {
        C0PatternString = C0PatternString + "|" + str;
    }
}
C0PatternString = C0PatternString + ");";
var C0RegExp = new RegExp(C0PatternString, "ig");
/**
*  As browser's XML Dom parser can not parse C0 control chars, so we must remove this chars before we parse it
*/
function RemoveC0Chars(str) {
    // We replace C0 control chars as a " "
    var str = str.replace(C0RegExp, " ");
    return str;
}
/**
* This function used to remove the leading and ending spaces for given string.
*/
function Trim(string) {
    if (string == null) return "";
    // initiliaze regular expression to be used at first time
    if (Trim.SpaceRegExp == null) {
        // 12288 is the unicode of full shape space char
        // 160 is no-break space
        var spaceRegExp = "\\s|" + String.fromCharCode(12288) + "|" + String.fromCharCode(160);
        Trim.SpaceRegExp =
            new RegExp("(^(" + spaceRegExp + ")*)|((" + spaceRegExp + ")*$)", "g");
    }
    return string.toString().replace(Trim.SpaceRegExp, "");
}
/**
*  Encode C0 Chars in a valid xml document
*/
function EncodeC0Chars(str) {
    var str = str + "";

    if (!str) {
        return "";
    }
    else {
        // NOTE: String.fromCharCode(0) is the end of string. There is a bug in safari that will 
        // regard all "" as charcode(0). Such as string "cwa" in safari will be replaced as "&#x0c&#x0w&#x0a".
        for (var i = 1; i < 32; i++) {
            //eg. replace String.fromCharCode(0xB) with "&#xB;"
            str = str.replace(EncodeC0Chars._stringFromCharCode[i], "&#x" + EncodeC0Chars._hex[i] + ";");
        }
        return str;
    }
}
(function () {
    EncodeC0Chars._stringFromCharCode = [];
    EncodeC0Chars._hex = [];

    for (var i = 1; i < 32; ++i) {
        EncodeC0Chars._stringFromCharCode[i] = new RegExp(String.fromCharCode(i), "g");
        EncodeC0Chars._hex[i] = i.toString(16).toUpperCase();
    }
})();
function stringToBytes(str) {
    var ch, st, re = [];
    for (var i = 0; i < str.length; i++) {
        ch = str.charCodeAt(i);  // get char 
        st = [];                 // set up "stack"
        do {
            st.push(ch & 0xFF);  // push byte to stack
            ch = ch >> 8;          // shift value down by 1 byte
        }
        while (ch);
        // add stack contents to result
        // done because chars have "wrong" endianness
        re = re.concat(st.reverse());
    }
    // return an array of bytes
    return re;
}
// input is unicode string, output is the utf-8 encoded byte array
function unicodeStringToUTF8Bytes(string) {
    var output = new Array();
    for (var n = 0; n < string.length; n++) {
        var c = string.charCodeAt(n);
        if (c < 128) {
            output.push(c);
        }
        else if ((c > 127) && (c < 2048)) {
            output.push((c >> 6) | 192);
            output.push((c & 63) | 128);
        }
        else if ((c > 2047) && (c < 65536)) {
            output.push((c >> 12) | 224);
            output.push(((c >> 6) & 63) | 128);
            output.push((c & 63) | 128);
        }
        else if ((c > 65535) && (c < 1114112)) {
            output.push((c >> 18) | 240);
            output.push(((c >> 12) & 63) | 128);
            output.push(((c >> 6) & 63) | 128);
            output.push((c & 63) | 128);
        }
    }
    return output;
}
function getText(element) {
    var returnValue = null;
    try {
        returnValue = element.textContent || element.text;
    }
    catch (e) {
        returnValue = null;
    }
    if (returnValue == null || returnValue == undefined)
        returnValue = "";
    return returnValue;
}

function getFirstElementByTagName(xml, tagname) {
    var allElements = xml.getElementsByTagName(tagname);
    if (allElements.length == 0) {
        return null;
    }
    return allElements[0];
}
Array.prototype.Clear = function () {
    while (this.length > 0) {
        this.pop();
    }
}
/*
1 -> 01 
2 -> 02
11 -> 11
*/
function padDateWithZero(d) {
    var d = Trim(d + "");
    return (d.length == 1) ? "0" + d : d;
}
// This function is similar to Delegate. But it is used in Timer.
// For Firefox/Mozilla, a weird issue is that upon timeout,
// the first parameter sent to handler is always timer ID.
// The handler created by this function will deal with this issue.
function TimerHandler(contextObj, funcObj) {
    var _arguments = null;
    if (arguments.length > 2) {
        _arguments = new Array();
        for (var i = 2; i < arguments.length; i++) {
            _arguments[i - 2] = arguments[i];
        }
    }
    var _delegate = function () {
        if (_arguments) {
            funcObj.apply(contextObj, _arguments);
        }
        else {
            funcObj.apply(contextObj);
        }
    };
    return _delegate;
}
//=================================================
// Delegate
//  Unlike C#, javascript has the first-class function
//  object and it is weak-typed. 
//  The problem of javascript function object is that:
//  it does not include the execution context information.
//  The function 'delegate' is to encapsulate an
//  execution context with a function object, and hence
//  make a delegate object.
//=================================================
// delegate function, it needs that the function object should have build-in 'call' method,
// which is not supported on some down-level browsers like IE5.01, but all of our supported 
// browsers will have this feature.
function Delegate(contextObj, funcObj) {
    var _arguments = null;
    if (arguments.length > 2) {
        _arguments = new Array();
        for (var i = 2; i < arguments.length; i++) {
            _arguments[i - 2] = arguments[i];
        }
    }
    var _delegate = function () {
        if (_arguments) {
            var args;
            if (arguments.length > 0) {
                args = new Array();
                args.push.apply(args, arguments);
                args.push.apply(args, _arguments);
            }
            else {
                args = _arguments;
            }
        }
        else {
            args = arguments;
        }
        return funcObj.apply(contextObj, args);
    };
    return _delegate;
}
/* #endregion Utility Methods*//* Note:  Microsoft Corporation is not the original author of these script files. Microsoft obtained
the original file from http://github.com/jquery/globalize under the license that is referred to below. That
license and the other notices below are provided for informational purposes only and are not
the license terms under which Microsoft distributes the files.  Microsoft grants you the right
to use the files for the sole purpose of using the files in conjunction with the Microsoft
product with which it was distributed subject to that products End User License Agreement.
Unless applicable law gives you more rights, Microsoft reserves all other rights to the files
not expressly granted by Microsoft, whether by implication, estoppel or otherwise.
*/
/*!
* Globalize
*
* http://github.com/jquery/globalize
*
* Copyright Software Freedom Conservancy, Inc.
* ------------------------------------------------------------------------------------
* MIT License
* Permission is hereby granted, free of charge, to any person obtaining
* a copy of this software and associated documentation files (the
* "Software"), to deal in the Software without restriction, including
* without limitation the rights to use, copy, modify, merge, publish,
* distribute, sublicense, and/or sell copies of the Software, and to
* permit persons to whom the Software is furnished to do so, subject to
* the following conditions:
* The above copyright notice and this permission notice shall be
* included in all copies or substantial portions of the Software.
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
* LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
* OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
* WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
* ------------------------------------------------------------------------------------
*/
(function( window, undefined ) {

var Globalize,
	// private variables
	regexHex,
	regexInfinity,
	regexParseFloat,
	regexTrim,
	// private JavaScript utility functions
	arrayIndexOf,
	endsWith,
	extend,
	isArray,
	isFunction,
	isObject,
	startsWith,
	trim,
	truncate,
	zeroPad,
	// private Globalization utility functions
	appendPreOrPostMatch,
	expandFormat,
	formatDate,
	formatNumber,
	getTokenRegExp,
	getEra,
	getEraYear,
	parseExact,
	parseNegativePattern;

// Global variable (Globalize) or CommonJS module (globalize)
Globalize = function( cultureSelector ) {
	return new Globalize.prototype.init( cultureSelector );
};

if ( typeof require !== "undefined"
	&& typeof exports !== "undefined"
	&& typeof module !== "undefined" ) {
	// Assume CommonJS
	module.exports = Globalize;
} else {
	// Export as global variable
	window.Globalize = Globalize;
}

Globalize.cultures = {};

Globalize.prototype = {
	constructor: Globalize,
	init: function( cultureSelector ) {
		this.cultures = Globalize.cultures;
		this.cultureSelector = cultureSelector;

		return this;
	}
};
Globalize.prototype.init.prototype = Globalize.prototype;

// 1.	 When defining a culture, all fields are required except the ones stated as optional.
// 2.	 Each culture should have a ".calendars" object with at least one calendar named "standard"
//		 which serves as the default calendar in use by that culture.
// 3.	 Each culture should have a ".calendar" object which is the current calendar being used,
//		 it may be dynamically changed at any time to one of the calendars in ".calendars".
Globalize.cultures[ "default" ] = {
	// A unique name for the culture in the form <language code>-<country/region code>
	name: "en",
	// the name of the culture in the english language
	englishName: "English",
	// the name of the culture in its own language
	nativeName: "English",
	// whether the culture uses right-to-left text
	isRTL: false,
	// "language" is used for so-called "specific" cultures.
	// For example, the culture "es-CL" means "Spanish, in Chili".
	// It represents the Spanish-speaking culture as it is in Chili,
	// which might have different formatting rules or even translations
	// than Spanish in Spain. A "neutral" culture is one that is not
	// specific to a region. For example, the culture "es" is the generic
	// Spanish culture, which may be a more generalized version of the language
	// that may or may not be what a specific culture expects.
	// For a specific culture like "es-CL", the "language" field refers to the
	// neutral, generic culture information for the language it is using.
	// This is not always a simple matter of the string before the dash.
	// For example, the "zh-Hans" culture is netural (Simplified Chinese).
	// And the "zh-SG" culture is Simplified Chinese in Singapore, whose lanugage
	// field is "zh-CHS", not "zh".
	// This field should be used to navigate from a specific culture to it's
	// more general, neutral culture. If a culture is already as general as it
	// can get, the language may refer to itself.
	language: "en",
	// numberFormat defines general number formatting rules, like the digits in
	// each grouping, the group separator, and how negative numbers are displayed.
	numberFormat: {
		// [negativePattern]
		// Note, numberFormat.pattern has no "positivePattern" unlike percent and currency,
		// but is still defined as an array for consistency with them.
		//   negativePattern: one of "(n)|-n|- n|n-|n -"
		pattern: [ "-n" ],
		// number of decimal places normally shown
		decimals: 2,
		// string that separates number groups, as in 1,000,000
		",": ",",
		// string that separates a number from the fractional portion, as in 1.99
		".": ".",
		// array of numbers indicating the size of each number group.
		// TODO: more detailed description and example
		groupSizes: [ 3 ],
		// symbol used for positive numbers
		"+": "+",
		// symbol used for negative numbers
		"-": "-",
		// symbol used for NaN (Not-A-Number)
		NaN: "NaN",
		// symbol used for Negative Infinity
		negativeInfinity: "-Infinity",
		// symbol used for Positive Infinity
		positiveInfinity: "Infinity",
		percent: {
			// [negativePattern, positivePattern]
			//   negativePattern: one of "-n %|-n%|-%n|%-n|%n-|n-%|n%-|-% n|n %-|% n-|% -n|n- %"
			//   positivePattern: one of "n %|n%|%n|% n"
			pattern: [ "-n %", "n %" ],
			// number of decimal places normally shown
			decimals: 2,
			// array of numbers indicating the size of each number group.
			// TODO: more detailed description and example
			groupSizes: [ 3 ],
			// string that separates number groups, as in 1,000,000
			",": ",",
			// string that separates a number from the fractional portion, as in 1.99
			".": ".",
			// symbol used to represent a percentage
			symbol: "%"
		},
		currency: {
			// [negativePattern, positivePattern]
			//   negativePattern: one of "($n)|-$n|$-n|$n-|(n$)|-n$|n-$|n$-|-n $|-$ n|n $-|$ n-|$ -n|n- $|($ n)|(n $)"
			//   positivePattern: one of "$n|n$|$ n|n $"
			pattern: [ "($n)", "$n" ],
			// number of decimal places normally shown
			decimals: 2,
			// array of numbers indicating the size of each number group.
			// TODO: more detailed description and example
			groupSizes: [ 3 ],
			// string that separates number groups, as in 1,000,000
			",": ",",
			// string that separates a number from the fractional portion, as in 1.99
			".": ".",
			// symbol used to represent currency
			symbol: "$"
		}
	},
	// calendars defines all the possible calendars used by this culture.
	// There should be at least one defined with name "standard", and is the default
	// calendar used by the culture.
	// A calendar contains information about how dates are formatted, information about
	// the calendar's eras, a standard set of the date formats,
	// translations for day and month names, and if the calendar is not based on the Gregorian
	// calendar, conversion functions to and from the Gregorian calendar.
	calendars: {
		standard: {
			// name that identifies the type of calendar this is
			name: "Gregorian_USEnglish",
			// separator of parts of a date (e.g. "/" in 11/05/1955)
			"/": "/",
			// separator of parts of a time (e.g. ":" in 05:44 PM)
			":": ":",
			// the first day of the week (0 = Sunday, 1 = Monday, etc)
			firstDay: 0,
			days: {
				// full day names
				names: [ "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ],
				// abbreviated day names
				namesAbbr: [ "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" ],
				// shortest day names
				namesShort: [ "Su", "Mo", "Tu", "We", "Th", "Fr", "Sa" ]
			},
			months: {
				// full month names (13 months for lunar calendards -- 13th month should be "" if not lunar)
				names: [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", "" ],
				// abbreviated month names
				namesAbbr: [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", "" ]
			},
			// AM and PM designators in one of these forms:
			// The usual view, and the upper and lower case versions
			//   [ standard, lowercase, uppercase ]
			// The culture does not use AM or PM (likely all standard date formats use 24 hour time)
			//   null
			AM: [ "AM", "am", "AM" ],
			PM: [ "PM", "pm", "PM" ],
			eras: [
				// eras in reverse chronological order.
				// name: the name of the era in this culture (e.g. A.D., C.E.)
				// start: when the era starts in ticks (gregorian, gmt), null if it is the earliest supported era.
				// offset: offset in years from gregorian calendar
				{
					"name": "A.D.",
					"start": null,
					"offset": 0
				}
			],
			// when a two digit year is given, it will never be parsed as a four digit
			// year greater than this year (in the appropriate era for the culture)
			// Set it as a full year (e.g. 2029) or use an offset format starting from
			// the current year: "+19" would correspond to 2029 if the current year 2010.
			twoDigitYearMax: 2029,
			// set of predefined date and time patterns used by the culture
			// these represent the format someone in this culture would expect
			// to see given the portions of the date that are shown.
			patterns: {
				// short date pattern
				d: "M/d/yyyy",
				// long date pattern
				D: "dddd, MMMM dd, yyyy",
				// short time pattern
				t: "h:mm tt",
				// long time pattern
				T: "h:mm:ss tt",
				// long date, short time pattern
				f: "dddd, MMMM dd, yyyy h:mm tt",
				// long date, long time pattern
				F: "dddd, MMMM dd, yyyy h:mm:ss tt",
				// month/day pattern
				M: "MMMM dd",
				// month/year pattern
				Y: "yyyy MMMM",
				// S is a sortable format that does not vary by culture
				S: "yyyy\u0027-\u0027MM\u0027-\u0027dd\u0027T\u0027HH\u0027:\u0027mm\u0027:\u0027ss"
			}
			// optional fields for each calendar:
			/*
			monthsGenitive:
				Same as months but used when the day preceeds the month.
				Omit if the culture has no genitive distinction in month names.
				For an explaination of genitive months, see http://blogs.msdn.com/michkap/archive/2004/12/25/332259.aspx
			convert:
				Allows for the support of non-gregorian based calendars. This convert object is used to
				to convert a date to and from a gregorian calendar date to handle parsing and formatting.
				The two functions:
					fromGregorian( date )
						Given the date as a parameter, return an array with parts [ year, month, day ]
						corresponding to the non-gregorian based year, month, and day for the calendar.
					toGregorian( year, month, day )
						Given the non-gregorian year, month, and day, return a new Date() object
						set to the corresponding date in the gregorian calendar.
			*/
		}
	},
	// For localized strings
	messages: {}
};

Globalize.cultures[ "default" ].calendar = Globalize.cultures[ "default" ].calendars.standard;

Globalize.cultures[ "en" ] = Globalize.cultures[ "default" ];

Globalize.cultureSelector = "en";

//
// private variables
//

regexHex = /^0x[a-f0-9]+$/i;
regexInfinity = /^[+-]?infinity$/i;
regexParseFloat = /^[+-]?\d*\.?\d*(e[+-]?\d+)?$/;
regexTrim = /^\s+|\s+$/g;

//
// private JavaScript utility functions
//

arrayIndexOf = function( array, item ) {
	if ( array.indexOf ) {
		return array.indexOf( item );
	}
	for ( var i = 0, length = array.length; i < length; i++ ) {
		if ( array[i] === item ) {
			return i;
		}
	}
	return -1;
};

endsWith = function( value, pattern ) {
	return value.substr( value.length - pattern.length ) === pattern;
};

extend = function( deep ) {
	var options, name, src, copy, copyIsArray, clone,
		target = arguments[0] || {},
		i = 1,
		length = arguments.length,
		deep = false;

	// Handle a deep copy situation
	if ( typeof target === "boolean" ) {
		deep = target;
		target = arguments[1] || {};
		// skip the boolean and the target
		i = 2;
	}

	// Handle case when target is a string or something (possible in deep copy)
	if ( typeof target !== "object" && !isFunction(target) ) {
		target = {};
	}

	for ( ; i < length; i++ ) {
		// Only deal with non-null/undefined values
		if ( (options = arguments[ i ]) != null ) {
			// Extend the base object
			for ( name in options ) {
				src = target[ name ];
				copy = options[ name ];

				// Prevent never-ending loop
				if ( target === copy ) {
					continue;
				}

				// Recurse if we're merging plain objects or arrays
				if ( deep && copy && ( isObject(copy) || (copyIsArray = isArray(copy)) ) ) {
					if ( copyIsArray ) {
						copyIsArray = false;
						clone = src && isArray(src) ? src : [];

					} else {
						clone = src && isObject(src) ? src : {};
					}

					// Never move original objects, clone them
					target[ name ] = extend( deep, clone, copy );

				// Don't bring in undefined values
				} else if ( copy !== undefined ) {
					target[ name ] = copy;
				}
			}
		}
	}

	// Return the modified object
	return target;
};

isArray = Array.isArray || function( obj ) {
	return Object.prototype.toString.call( obj ) === "[object Array]";
};

isFunction = function( obj ) {
	return Object.prototype.toString.call( obj ) === "[object Function]"
}

isObject = function( obj ) {
	return Object.prototype.toString.call( obj ) === "[object Object]";
};

startsWith = function( value, pattern ) {
	return value.indexOf( pattern ) === 0;
};

trim = function( value ) {
	return ( value + "" ).replace( regexTrim, "" );
};

truncate = function( value ) {
	return value | 0;
};

zeroPad = function( str, count, left ) {
	var l;
	for ( l = str.length; l < count; l += 1 ) {
		str = ( left ? ("0" + str) : (str + "0") );
	}
	return str;
};

//
// private Globalization utility functions
//

appendPreOrPostMatch = function( preMatch, strings ) {
	// appends pre- and post- token match strings while removing escaped characters.
	// Returns a single quote count which is used to determine if the token occurs
	// in a string literal.
	var quoteCount = 0,
		escaped = false;
	for ( var i = 0, il = preMatch.length; i < il; i++ ) {
		var c = preMatch.charAt( i );
		switch ( c ) {
			case "\'":
				if ( escaped ) {
					strings.push( "\'" );
				}
				else {
					quoteCount++;
				}
				escaped = false;
				break;
			case "\\":
				if ( escaped ) {
					strings.push( "\\" );
				}
				escaped = !escaped;
				break;
			default:
				strings.push( c );
				escaped = false;
				break;
		}
	}
	return quoteCount;
};

expandFormat = function( cal, format ) {
	// expands unspecified or single character date formats into the full pattern.
	format = format || "F";
	var pattern,
		patterns = cal.patterns,
		len = format.length;
	if ( len === 1 ) {
		pattern = patterns[ format ];
		if ( !pattern ) {
			throw "Invalid date format string \'" + format + "\'.";
		}
		format = pattern;
	}
	else if ( len === 2 && format.charAt(0) === "%" ) {
		// %X escape format -- intended as a custom format string that is only one character, not a built-in format.
		format = format.charAt( 1 );
	}
	return format;
};

formatDate = function( value, format, culture ) {
	var cal = culture.calendar,
		convert = cal.convert;

	if ( !format || !format.length || format === "i" ) {
		var ret;
		if ( culture && culture.name.length ) {
			if ( convert ) {
				// non-gregorian calendar, so we cannot use built-in toLocaleString()
				ret = formatDate( value, cal.patterns.F, culture );
			}
			else {
				var eraDate = new Date( value.getTime() ),
					era = getEra( value, cal.eras );
				eraDate.setFullYear( getEraYear(value, cal, era) );
				ret = eraDate.toLocaleString();
			}
		}
		else {
			ret = value.toString();
		}
		return ret;
	}

	var eras = cal.eras,
		sortable = format === "s";
	format = expandFormat( cal, format );

	// Start with an empty string
	ret = [];
	var hour,
		zeros = [ "0", "00", "000" ],
		foundDay,
		checkedDay,
		dayPartRegExp = /([^d]|^)(d|dd)([^d]|$)/g,
		quoteCount = 0,
		tokenRegExp = getTokenRegExp(),
		converted;

	function padZeros( num, c ) {
		var r, s = num + "";
		if ( c > 1 && s.length < c ) {
			r = ( zeros[c - 2] + s);
			return r.substr( r.length - c, c );
		}
		else {
			r = s;
		}
		return r;
	}

	function hasDay() {
		if ( foundDay || checkedDay ) {
			return foundDay;
		}
		foundDay = dayPartRegExp.test( format );
		checkedDay = true;
		return foundDay;
	}

	function getPart( date, part ) {
		if ( converted ) {
			return converted[ part ];
		}
		switch ( part ) {
			case 0: return date.getFullYear();
			case 1: return date.getMonth();
			case 2: return date.getDate();
		}
	}

	if ( !sortable && convert ) {
		converted = convert.fromGregorian( value );
	}

	for ( ; ; ) {
		// Save the current index
		var index = tokenRegExp.lastIndex,
			// Look for the next pattern
			ar = tokenRegExp.exec( format );

		// Append the text before the pattern (or the end of the string if not found)
		var preMatch = format.slice( index, ar ? ar.index : format.length );
		quoteCount += appendPreOrPostMatch( preMatch, ret );

		if ( !ar ) {
			break;
		}

		// do not replace any matches that occur inside a string literal.
		if ( quoteCount % 2 ) {
			ret.push( ar[0] );
			continue;
		}

		var current = ar[ 0 ],
			clength = current.length;

		switch ( current ) {
			case "ddd":
				//Day of the week, as a three-letter abbreviation
			case "dddd":
				// Day of the week, using the full name
				var names = ( clength === 3 ) ? cal.days.namesAbbr : cal.days.names;
				ret.push( names[value.getDay()] );
				break;
			case "d":
				// Day of month, without leading zero for single-digit days
			case "dd":
				// Day of month, with leading zero for single-digit days
				foundDay = true;
				ret.push(
					padZeros( getPart(value, 2), clength )
				);
				break;
			case "MMM":
				// Month, as a three-letter abbreviation
			case "MMMM":
				// Month, using the full name
				var part = getPart( value, 1 );
				ret.push(
					( cal.monthsGenitive && hasDay() )
					?
					cal.monthsGenitive[ clength === 3 ? "namesAbbr" : "names" ][ part ]
					:
					cal.months[ clength === 3 ? "namesAbbr" : "names" ][ part ]
				);
				break;
			case "M":
				// Month, as digits, with no leading zero for single-digit months
			case "MM":
				// Month, as digits, with leading zero for single-digit months
				ret.push(
					padZeros( getPart(value, 1) + 1, clength )
				);
				break;
			case "y":
				// Year, as two digits, but with no leading zero for years less than 10
			case "yy":
				// Year, as two digits, with leading zero for years less than 10
			case "yyyy":
				// Year represented by four full digits
				part = converted ? converted[ 0 ] : getEraYear( value, cal, getEra(value, eras), sortable );
				if ( clength < 4 ) {
					part = part % 100;
				}
				ret.push(
					padZeros( part, clength )
				);
				break;
			case "h":
				// Hours with no leading zero for single-digit hours, using 12-hour clock
			case "hh":
				// Hours with leading zero for single-digit hours, using 12-hour clock
				hour = value.getHours() % 12;
				if ( hour === 0 ) hour = 12;
				ret.push(
					padZeros( hour, clength )
				);
				break;
			case "H":
				// Hours with no leading zero for single-digit hours, using 24-hour clock
			case "HH":
				// Hours with leading zero for single-digit hours, using 24-hour clock
				ret.push(
					padZeros( value.getHours(), clength )
				);
				break;
			case "m":
				// Minutes with no leading zero for single-digit minutes
			case "mm":
				// Minutes with leading zero for single-digit minutes
				ret.push(
					padZeros( value.getMinutes(), clength )
				);
				break;
			case "s":
				// Seconds with no leading zero for single-digit seconds
			case "ss":
				// Seconds with leading zero for single-digit seconds
				ret.push(
					padZeros( value.getSeconds(), clength )
				);
				break;
			case "t":
				// One character am/pm indicator ("a" or "p")
			case "tt":
				// Multicharacter am/pm indicator
				part = value.getHours() < 12 ? ( cal.AM ? cal.AM[0] : " " ) : ( cal.PM ? cal.PM[0] : " " );
				ret.push( clength === 1 ? part.charAt(0) : part );
				break;
			case "f":
				// Deciseconds
			case "ff":
				// Centiseconds
			case "fff":
				// Milliseconds
				ret.push(
					padZeros( value.getMilliseconds(), 3 ).substr( 0, clength )
				);
				break;
			case "z":
				// Time zone offset, no leading zero
			case "zz":
				// Time zone offset with leading zero
				hour = value.getTimezoneOffset() / 60;
				ret.push(
					( hour <= 0 ? "+" : "-" ) + padZeros( Math.floor(Math.abs(hour)), clength )
				);
				break;
			case "zzz":
				// Time zone offset with leading zero
				hour = value.getTimezoneOffset() / 60;
				ret.push(
					( hour <= 0 ? "+" : "-" ) + padZeros( Math.floor(Math.abs(hour)), 2 )
					// Hard coded ":" separator, rather than using cal.TimeSeparator
					// Repeated here for consistency, plus ":" was already assumed in date parsing.
					+ ":" + padZeros( Math.abs(value.getTimezoneOffset() % 60), 2 )
				);
				break;
			case "g":
			case "gg":
				if ( cal.eras ) {
					ret.push(
						cal.eras[ getEra(value, eras) ].name
					);
				}
				break;
		case "/":
			ret.push( cal["/"] );
			break;
		default:
			throw "Invalid date format pattern \'" + current + "\'.";
			break;
		}
	}
	return ret.join( "" );
};

// formatNumber
(function() {
	var expandNumber;

	expandNumber = function( number, precision, formatInfo ) {
		var groupSizes = formatInfo.groupSizes,
			curSize = groupSizes[ 0 ],
			curGroupIndex = 1,
			factor = Math.pow( 10, precision ),
			rounded = Math.round( number * factor ) / factor;

		if ( !isFinite(rounded) ) {
			rounded = number;
		}
		number = rounded;

		var numberString = number+"",
			right = "",
			split = numberString.split( /e/i ),
			exponent = split.length > 1 ? parseInt( split[1], 10 ) : 0;
		numberString = split[ 0 ];
		split = numberString.split( "." );
		numberString = split[ 0 ];
		right = split.length > 1 ? split[ 1 ] : "";

		var l;
		if ( exponent > 0 ) {
			right = zeroPad( right, exponent, false );
			numberString += right.slice( 0, exponent );
			right = right.substr( exponent );
		}
		else if ( exponent < 0 ) {
			exponent = -exponent;
			numberString = zeroPad( numberString, exponent + 1 );
			right = numberString.slice( -exponent, numberString.length ) + right;
			numberString = numberString.slice( 0, -exponent );
		}

		if ( precision > 0 ) {
			right = formatInfo[ "." ] +
				( (right.length > precision) ? right.slice(0, precision) : zeroPad(right, precision) );
		}
		else {
			right = "";
		}

		var stringIndex = numberString.length - 1,
			sep = formatInfo[ "," ],
			ret = "";

		while ( stringIndex >= 0 ) {
			if ( curSize === 0 || curSize > stringIndex ) {
				return numberString.slice( 0, stringIndex + 1 ) + ( ret.length ? (sep + ret + right) : right );
			}
			ret = numberString.slice( stringIndex - curSize + 1, stringIndex + 1 ) + ( ret.length ? (sep + ret) : "" );

			stringIndex -= curSize;

			if ( curGroupIndex < groupSizes.length ) {
				curSize = groupSizes[ curGroupIndex ];
				curGroupIndex++;
			}
		}

		return numberString.slice( 0, stringIndex + 1 ) + sep + ret + right;
	};

	formatNumber = function( value, format, culture ) {
		if ( !isFinite(value) ) {
			if ( value === Infinity ) {
				return culture.numberFormat.positiveInfinity;
			}
			if ( value === -Infinity ) {
				return culture.numberFormat.negativeInfinity;
			}
			return culture.numberFormat.NaN;
		}
		if ( !format || format === "i" ) {
			return culture.name.length ? value.toLocaleString() : value.toString();
		}
		format = format || "D";

		var nf = culture.numberFormat,
			number = Math.abs( value ),
			precision = -1,
			pattern;
		if ( format.length > 1 ) precision = parseInt( format.slice(1), 10 );

		var current = format.charAt( 0 ).toUpperCase(),
			formatInfo;

		switch ( current ) {
			case "D":
				pattern = "n";
				number = truncate( number );
				if ( precision !== -1 ) {
					number = zeroPad( "" + number, precision, true );
				}
				if ( value < 0 ) number = "-" + number;
				break;
			case "N":
				formatInfo = nf;
				// fall through
			case "C":
				formatInfo = formatInfo || nf.currency;
				// fall through
			case "P":
				formatInfo = formatInfo || nf.percent;
				pattern = value < 0 ? formatInfo.pattern[ 0 ] : ( formatInfo.pattern[1] || "n" );
				if ( precision === -1 ) precision = formatInfo.decimals;
				number = expandNumber( number * (current === "P" ? 100 : 1), precision, formatInfo );
				break;
			default:
				throw "Bad number format specifier: " + current;
		}

		var patternParts = /n|\$|-|%/g,
			ret = "";
		for ( ; ; ) {
			var index = patternParts.lastIndex,
				ar = patternParts.exec( pattern );

			ret += pattern.slice( index, ar ? ar.index : pattern.length );

			if ( !ar ) {
				break;
			}

			switch ( ar[0] ) {
				case "n":
					ret += number;
					break;
				case "$":
					ret += nf.currency.symbol;
					break;
				case "-":
					// don't make 0 negative
					if ( /[1-9]/.test(number) ) {
						ret += nf[ "-" ];
					}
					break;
				case "%":
					ret += nf.percent.symbol;
					break;
			}
		}

		return ret;
	};

}());

getTokenRegExp = function() {
	// regular expression for matching date and time tokens in format strings.
	return /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g;
};

getEra = function( date, eras ) {
	if ( !eras ) return 0;
	var start, ticks = date.getTime();
	for ( var i = 0, l = eras.length; i < l; i++ ) {
		start = eras[ i ].start;
		if ( start === null || ticks >= start ) {
			return i;
		}
	}
	return 0;
};

getEraYear = function( date, cal, era, sortable ) {
	var year = date.getFullYear();
	if ( !sortable && cal.eras ) {
		// convert normal gregorian year to era-shifted gregorian
		// year by subtracting the era offset
		year -= cal.eras[ era ].offset;
	}
	return year;
};

// parseExact
(function() {
	var expandYear,
		getDayIndex,
		getMonthIndex,
		getParseRegExp,
		outOfRange,
		toUpper,
		toUpperArray;

	expandYear = function( cal, year ) {
		// expands 2-digit year into 4 digits.
		var now = new Date(),
			era = getEra( now );
		if ( year < 100 ) {
			var twoDigitYearMax = cal.twoDigitYearMax;
			twoDigitYearMax = typeof twoDigitYearMax === "string" ? new Date().getFullYear() % 100 + parseInt( twoDigitYearMax, 10 ) : twoDigitYearMax;
			var curr = getEraYear( now, cal, era );
			year += curr - ( curr % 100 );
			if ( year > twoDigitYearMax ) {
				year -= 100;
			}
		}
		return year;
	};

	getDayIndex = function	( cal, value, abbr ) {
		var ret,
			days = cal.days,
			upperDays = cal._upperDays;
		if ( !upperDays ) {
			cal._upperDays = upperDays = [
				toUpperArray( days.names ),
				toUpperArray( days.namesAbbr ),
				toUpperArray( days.namesShort )
			];
		}
		value = toUpper( value );
		if ( abbr ) {
			ret = arrayIndexOf( upperDays[1], value );
			if ( ret === -1 ) {
				ret = arrayIndexOf( upperDays[2], value );
			}
		}
		else {
			ret = arrayIndexOf( upperDays[0], value );
		}
		return ret;
	};

	getMonthIndex = function( cal, value, abbr ) {
		var months = cal.months,
			monthsGen = cal.monthsGenitive || cal.months,
			upperMonths = cal._upperMonths,
			upperMonthsGen = cal._upperMonthsGen;
		if ( !upperMonths ) {
			cal._upperMonths = upperMonths = [
				toUpperArray( months.names ),
				toUpperArray( months.namesAbbr )
			];
			cal._upperMonthsGen = upperMonthsGen = [
				toUpperArray( monthsGen.names ),
				toUpperArray( monthsGen.namesAbbr )
			];
		}
		value = toUpper( value );
		var i = arrayIndexOf( abbr ? upperMonths[1] : upperMonths[0], value );
		if ( i < 0 ) {
			i = arrayIndexOf( abbr ? upperMonthsGen[1] : upperMonthsGen[0], value );
		}
		return i;
	};

	getParseRegExp = function( cal, format ) {
		// converts a format string into a regular expression with groups that
		// can be used to extract date fields from a date string.
		// check for a cached parse regex.
		var re = cal._parseRegExp;
		if ( !re ) {
			cal._parseRegExp = re = {};
		}
		else {
			var reFormat = re[ format ];
			if ( reFormat ) {
				return reFormat;
			}
		}

		// expand single digit formats, then escape regular expression characters.
		var expFormat = expandFormat( cal, format ).replace( /([\^\$\.\*\+\?\|\[\]\(\)\{\}])/g, "\\\\$1" ),
			regexp = [ "^" ],
			groups = [],
			index = 0,
			quoteCount = 0,
			tokenRegExp = getTokenRegExp(),
			match;

		// iterate through each date token found.
		while ( (match = tokenRegExp.exec(expFormat)) !== null ) {
			var preMatch = expFormat.slice( index, match.index );
			index = tokenRegExp.lastIndex;

			// don't replace any matches that occur inside a string literal.
			quoteCount += appendPreOrPostMatch( preMatch, regexp );
			if ( quoteCount % 2 ) {
				regexp.push( match[0] );
				continue;
			}

			// add a regex group for the token.
			var m = match[ 0 ],
				len = m.length,
				add;
			switch ( m ) {
				case "dddd": case "ddd":
				case "MMMM": case "MMM":
				case "gg": case "g":
					add = "(\\D+)";
					break;
				case "tt": case "t":
					add = "(\\D*)";
					break;
				case "yyyy":
				case "fff":
				case "ff":
				case "f":
					add = "(\\d{" + len + "})";
					break;
				case "dd": case "d":
				case "MM": case "M":
				case "yy": case "y":
				case "HH": case "H":
				case "hh": case "h":
				case "mm": case "m":
				case "ss": case "s":
					add = "(\\d\\d?)";
					break;
				case "zzz":
					add = "([+-]?\\d\\d?:\\d{2})";
					break;
				case "zz": case "z":
					add = "([+-]?\\d\\d?)";
					break;
				case "/":
					add = "(\\" + cal[ "/" ] + ")";
					break;
				default:
					throw "Invalid date format pattern \'" + m + "\'.";
					break;
			}
			if ( add ) {
				regexp.push( add );
			}
			groups.push( match[0] );
		}
		appendPreOrPostMatch( expFormat.slice(index), regexp );
		regexp.push( "$" );

		// allow whitespace to differ when matching formats.
		var regexpStr = regexp.join( "" ).replace( /\s+/g, "\\s+" ),
			parseRegExp = { "regExp": regexpStr, "groups": groups };

		// cache the regex for this format.
		return re[ format ] = parseRegExp;
	};

	outOfRange = function( value, low, high ) {
		return value < low || value > high;
	};

	toUpper = function( value ) {
		// "he-IL" has non-breaking space in weekday names.
		return value.split( "\u00A0" ).join( " " ).toUpperCase();
	};

	toUpperArray = function( arr ) {
		var results = [];
		for ( var i = 0, l = arr.length; i < l; i++ ) {
			results[ i ] = toUpper( arr[i] );
		}
		return results;
	};

	parseExact = function( value, format, culture ) {
		// try to parse the date string by matching against the format string
		// while using the specified culture for date field names.
		value = trim( value );
		var cal = culture.calendar,
			// convert date formats into regular expressions with groupings.
			// use the regexp to determine the input format and extract the date fields.
			parseInfo = getParseRegExp( cal, format ),
			match = new RegExp( parseInfo.regExp ).exec( value );
		if ( match === null ) {
			return null;
		}
		// found a date format that matches the input.
		var groups = parseInfo.groups,
			era = null, year = null, month = null, date = null, weekDay = null,
			hour = 0, hourOffset, min = 0, sec = 0, msec = 0, tzMinOffset = null,
			pmHour = false;
		// iterate the format groups to extract and set the date fields.
		for ( var j = 0, jl = groups.length; j < jl; j++ ) {
			var matchGroup = match[ j + 1 ];
			if ( matchGroup ) {
				var current = groups[ j ],
					clength = current.length,
					matchInt = parseInt( matchGroup, 10 );
				switch ( current ) {
					case "dd": case "d":
						// Day of month.
						date = matchInt;
						// check that date is generally in valid range, also checking overflow below.
						if ( outOfRange(date, 1, 31) ) return null;
						break;
					case "MMM": case "MMMM":
						month = getMonthIndex( cal, matchGroup, clength === 3 );
						if ( outOfRange(month, 0, 11) ) return null;
						break;
					case "M": case "MM":
						// Month.
						month = matchInt - 1;
						if ( outOfRange(month, 0, 11) ) return null;
						break;
					case "y": case "yy":
					case "yyyy":
						year = clength < 4 ? expandYear( cal, matchInt ) : matchInt;
						if ( outOfRange(year, 0, 9999) ) return null;
						break;
					case "h": case "hh":
						// Hours (12-hour clock).
						hour = matchInt;
						if ( hour === 12 ) hour = 0;
						if ( outOfRange(hour, 0, 11) ) return null;
						break;
					case "H": case "HH":
						// Hours (24-hour clock).
						hour = matchInt;
						if ( outOfRange(hour, 0, 23) ) return null;
						break;
					case "m": case "mm":
						// Minutes.
						min = matchInt;
						if ( outOfRange(min, 0, 59) ) return null;
						break;
					case "s": case "ss":
						// Seconds.
						sec = matchInt;
						if ( outOfRange(sec, 0, 59) ) return null;
						break;
					case "tt": case "t":
						// AM/PM designator.
						// see if it is standard, upper, or lower case PM. If not, ensure it is at least one of
						// the AM tokens. If not, fail the parse for this format.
						pmHour = cal.PM && ( matchGroup === cal.PM[0] || matchGroup === cal.PM[1] || matchGroup === cal.PM[2] );
						if (
							!pmHour && (
								!cal.AM || ( matchGroup !== cal.AM[0] && matchGroup !== cal.AM[1] && matchGroup !== cal.AM[2] )
							)
						) return null;
						break;
					case "f":
						// Deciseconds.
					case "ff":
						// Centiseconds.
					case "fff":
						// Milliseconds.
						msec = matchInt * Math.pow( 10, 3 - clength );
						if ( outOfRange(msec, 0, 999) ) return null;
						break;
					case "ddd":
						// Day of week.
					case "dddd":
						// Day of week.
						weekDay = getDayIndex( cal, matchGroup, clength === 3 );
						if ( outOfRange(weekDay, 0, 6) ) return null;
						break;
					case "zzz":
						// Time zone offset in +/- hours:min.
						var offsets = matchGroup.split( /:/ );
						if ( offsets.length !== 2 ) return null;
						hourOffset = parseInt( offsets[0], 10 );
						if ( outOfRange(hourOffset, -12, 13) ) return null;
						var minOffset = parseInt( offsets[1], 10 );
						if ( outOfRange(minOffset, 0, 59) ) return null;
						tzMinOffset = ( hourOffset * 60 ) + ( startsWith(matchGroup, "-") ? -minOffset : minOffset );
						break;
					case "z": case "zz":
						// Time zone offset in +/- hours.
						hourOffset = matchInt;
						if ( outOfRange(hourOffset, -12, 13) ) return null;
						tzMinOffset = hourOffset * 60;
						break;
					case "g": case "gg":
						var eraName = matchGroup;
						if ( !eraName || !cal.eras ) return null;
						eraName = trim( eraName.toLowerCase() );
						for ( var i = 0, l = cal.eras.length; i < l; i++ ) {
							if ( eraName === cal.eras[i].name.toLowerCase() ) {
								era = i;
								break;
							}
						}
						// could not find an era with that name
						if ( era === null ) return null;
						break;
				}
			}
		}
		var result = new Date(), defaultYear, convert = cal.convert;
		defaultYear = convert ? convert.fromGregorian( result )[ 0 ] : result.getFullYear();
		if ( year === null ) {
			year = defaultYear;
		}
		else if ( cal.eras ) {
			// year must be shifted to normal gregorian year
			// but not if year was not specified, its already normal gregorian
			// per the main if clause above.
			year += cal.eras[( era || 0 )].offset;
		}
		// set default day and month to 1 and January, so if unspecified, these are the defaults
		// instead of the current day/month.
		if ( month === null ) {
			month = 0;
		}
		if ( date === null ) {
			date = 1;
		}
		// now have year, month, and date, but in the culture's calendar.
		// convert to gregorian if necessary
		if ( convert ) {
			result = convert.toGregorian( year, month, date );
			// conversion failed, must be an invalid match
			if ( result === null ) return null;
		}
		else {
			// have to set year, month and date together to avoid overflow based on current date.
			result.setFullYear( year, month, date );
			// check to see if date overflowed for specified month (only checked 1-31 above).
			if ( result.getDate() !== date ) return null;
			// invalid day of week.
			if ( weekDay !== null && result.getDay() !== weekDay ) {
				return null;
			}
		}
		// if pm designator token was found make sure the hours fit the 24-hour clock.
		if ( pmHour && hour < 12 ) {
			hour += 12;
		}
		result.setHours( hour, min, sec, msec );
		if ( tzMinOffset !== null ) {
			// adjust timezone to utc before applying local offset.
			var adjustedMin = result.getMinutes() - ( tzMinOffset + result.getTimezoneOffset() );
			// Safari limits hours and minutes to the range of -127 to 127.	 We need to use setHours
			// to ensure both these fields will not exceed this range.	adjustedMin will range
			// somewhere between -1440 and 1500, so we only need to split this into hours.
			result.setHours( result.getHours() + parseInt(adjustedMin / 60, 10), adjustedMin % 60 );
		}
		return result;
	};
}());

parseNegativePattern = function( value, nf, negativePattern ) {
	var neg = nf[ "-" ],
		pos = nf[ "+" ],
		ret;
	switch ( negativePattern ) {
		case "n -":
			neg = " " + neg;
			pos = " " + pos;
			// fall through
		case "n-":
			if ( endsWith(value, neg) ) {
				ret = [ "-", value.substr(0, value.length - neg.length) ];
			}
			else if ( endsWith(value, pos) ) {
				ret = [ "+", value.substr(0, value.length - pos.length) ];
			}
			break;
		case "- n":
			neg += " ";
			pos += " ";
			// fall through
		case "-n":
			if ( startsWith(value, neg) ) {
				ret = [ "-", value.substr(neg.length) ];
			}
			else if ( startsWith(value, pos) ) {
				ret = [ "+", value.substr(pos.length) ];
			}
			break;
		case "(n)":
			if ( startsWith(value, "(") && endsWith(value, ")") ) {
				ret = [ "-", value.substr(1, value.length - 2) ];
			}
			break;
	}
	return ret || [ "", value ];
};

//
// public instance functions
//

Globalize.prototype.findClosestCulture = function( cultureSelector ) {
	return Globalize.findClosestCulture.call( this, cultureSelector );
};

Globalize.prototype.format = function( value, format, cultureSelector ) {
	return Globalize.format.call( this, value, format, cultureSelector );
};

Globalize.prototype.localize = function( key, cultureSelector ) {
	return Globalize.localize.call( this, key, cultureSelector );
};

Globalize.prototype.parseInt = function( value, radix, cultureSelector ) {
	return Globalize.parseInt.call( this, value, radix, cultureSelector );
};

Globalize.prototype.parseFloat = function( value, radix, cultureSelector ) {
	return Globalize.parseFloat.call( this, value, radix, cultureSelector );
};

Globalize.prototype.culture = function( cultureSelector ) {
	return Globalize.culture.call( this, cultureSelector );
};

//
// public singleton functions
//

Globalize.addCultureInfo = function( cultureName, baseCultureName, info ) {

	var base = {},
		isNew = false;

	if ( typeof cultureName !== "string" ) {
		// cultureName argument is optional string. If not specified, assume info is first
		// and only argument. Specified info deep-extends current culture.
		info = cultureName;
		cultureName = this.culture().name;
		base = this.cultures[ cultureName ];
	} else if ( typeof baseCultureName !== "string" ) {
		// baseCultureName argument is optional string. If not specified, assume info is second
		// argument. Specified info deep-extends specified culture.
		// If specified culture does not exist, create by deep-extending default
		info = baseCultureName;
		isNew = ( this.cultures[ cultureName ] == null );
		base = this.cultures[ cultureName ] || this.cultures[ "default" ];
	} else {
		// cultureName and baseCultureName specified. Assume a new culture is being created
		// by deep-extending an specified base culture
		isNew = true;
		base = this.cultures[ baseCultureName ];
	}

	this.cultures[ cultureName ] = extend(true, {},
		base,
		info
	);
	// Make the standard calendar the current culture if it's a new culture
	if ( isNew ) {
		this.cultures[ cultureName ].calendar = this.cultures[ cultureName ].calendars.standard;
	}
};

Globalize.findClosestCulture = function( name ) {
	var match;
	if ( !name ) {
		return this.cultures[ this.cultureSelector ] || this.cultures[ "default" ];
	}
	if ( typeof name === "string" ) {
		name = name.split( "," );
	}
	if ( isArray(name) ) {
		var lang,
			cultures = this.cultures,
			list = name,
			i, l = list.length,
			prioritized = [];
		for ( i = 0; i < l; i++ ) {
			name = trim( list[i] );
			var pri, parts = name.split( ";" );
			lang = trim( parts[0] );
			if ( parts.length === 1 ) {
				pri = 1;
			}
			else {
				name = trim( parts[1] );
				if ( name.indexOf("q=") === 0 ) {
					name = name.substr( 2 );
					pri = parseFloat( name );
					pri = isNaN( pri ) ? 0 : pri;
				}
				else {
					pri = 1;
				}
			}
			prioritized.push({ lang: lang, pri: pri });
		}
		prioritized.sort(function( a, b ) {
			return a.pri < b.pri ? 1 : -1;
		});

		// exact match
		for ( i = 0; i < l; i++ ) {
			lang = prioritized[ i ].lang;
			match = cultures[ lang ];
			if ( match ) {
				return match;
			}
		}

		// neutral language match
		for ( i = 0; i < l; i++ ) {
			lang = prioritized[ i ].lang;
			do {
				var index = lang.lastIndexOf( "-" );
				if ( index === -1 ) {
					break;
				}
				// strip off the last part. e.g. en-US => en
				lang = lang.substr( 0, index );
				match = cultures[ lang ];
				if ( match ) {
					return match;
				}
			}
			while ( 1 );
		}

		// last resort: match first culture using that language
		for ( i = 0; i < l; i++ ) {
			lang = prioritized[ i ].lang;
			for ( var cultureKey in cultures ) {
				var culture = cultures[ cultureKey ];
				if ( culture.language == lang ) {
					return culture;
				}
			}
		}
	}
	else if ( typeof name === "object" ) {
		return name;
	}
	return match || null;
};

Globalize.format = function( value, format, cultureSelector ) {
	culture = this.findClosestCulture( cultureSelector );
	if ( value instanceof Date ) {
		value = formatDate( value, format, culture );
	}
	else if ( typeof value === "number" ) {
		value = formatNumber( value, format, culture );
	}
	return value;
};

Globalize.localize = function( key, cultureSelector ) {
	return (
		this.findClosestCulture( cultureSelector ).messages[ key ]
		||
		this.cultures[ "default" ].messages[ "key" ]
	);
};

Globalize.parseDate = function( value, formats, culture ) {
	culture = this.findClosestCulture( culture );

	var date, prop, patterns;
	if ( formats ) {
		if ( typeof formats === "string" ) {
			formats = [ formats ];
		}
		if ( formats.length ) {
			for ( var i = 0, l = formats.length; i < l; i++ ) {
				var format = formats[ i ];
				if ( format ) {
					date = parseExact( value, format, culture );
					if ( date ) {
						break;
					}
				}
			}
		}
	} else {
		patterns = culture.calendar.patterns;
		for ( prop in patterns ) {
			date = parseExact( value, patterns[prop], culture );
			if ( date ) {
				break;
			}
		}
	}

	return date || null;
};

Globalize.parseInt = function( value, radix, cultureSelector ) {
	return truncate( Globalize.parseFloat(value, radix, cultureSelector) );
};

Globalize.parseFloat = function( value, radix, cultureSelector ) {
	// radix argument is optional
	if ( typeof radix !== "number" ) {
		cultureSelector = radix;
		radix = 10;
	}

	var culture = this.findClosestCulture( cultureSelector );
	var ret = NaN,
		nf = culture.numberFormat;

	if ( value.indexOf(culture.numberFormat.currency.symbol) > -1 ) {
		// remove currency symbol
		value = value.replace( culture.numberFormat.currency.symbol, "" );
		// replace decimal seperator
		value = value.replace( culture.numberFormat.currency["."], culture.numberFormat["."] );
	}

	// trim leading and trailing whitespace
	value = trim( value );

	// allow infinity or hexidecimal
	if ( regexInfinity.test(value) ) {
		ret = parseFloat( value );
	}
	else if ( !radix && regexHex.test(value) ) {
		ret = parseInt( value, 16 );
	}
	else {
		var signInfo = parseNegativePattern( value, nf, nf.pattern[0] ),
			sign = signInfo[ 0 ],
			num = signInfo[ 1 ];
		// determine sign and number
		if ( sign === "" && nf.pattern[0] !== "-n" ) {
			signInfo = parseNegativePattern( value, nf, "-n" );
			sign = signInfo[ 0 ];
			num = signInfo[ 1 ];
		}
		sign = sign || "+";
		// determine exponent and number
		var exponent,
			intAndFraction,
			exponentPos = num.indexOf( "e" );
		if ( exponentPos < 0 ) exponentPos = num.indexOf( "E" );
		if ( exponentPos < 0 ) {
			intAndFraction = num;
			exponent = null;
		}
		else {
			intAndFraction = num.substr( 0, exponentPos );
			exponent = num.substr( exponentPos + 1 );
		}
		// determine decimal position
		var integer,
			fraction,
			decSep = nf[ "." ],
			decimalPos = intAndFraction.indexOf( decSep );
		if ( decimalPos < 0 ) {
			integer = intAndFraction;
			fraction = null;
		}
		else {
			integer = intAndFraction.substr( 0, decimalPos );
			fraction = intAndFraction.substr( decimalPos + decSep.length );
		}
		// handle groups (e.g. 1,000,000)
		var groupSep = nf[ "," ];
		integer = integer.split( groupSep ).join( "" );
		var altGroupSep = groupSep.replace( /\u00A0/g, " " );
		if ( groupSep !== altGroupSep ) {
			integer = integer.split( altGroupSep ).join( "" );
		}
		// build a natively parsable number string
		var p = sign + integer;
		if ( fraction !== null ) {
			p += "." + fraction;
		}
		if ( exponent !== null ) {
			// exponent itself may have a number patternd
			var expSignInfo = parseNegativePattern( exponent, nf, "-n" );
			p += "e" + ( expSignInfo[0] || "+" ) + expSignInfo[ 1 ];
		}
		if ( regexParseFloat.test(p) ) {
			ret = parseFloat( p );
		}
	}
	return ret;
};

Globalize.culture = function( cultureSelector ) {
	// setter
	if ( typeof cultureSelector !== "undefined" ) {
		this.cultureSelector = cultureSelector;
	}
	// getter
	return this.findClosestCulture( cultureSelector ) || this.culture[ "default" ];
};

}( this ));
Type.registerNamespace('Lync.Client.Common');

Lync.Client.Common.DelayLoadStatus = function() {}
Lync.Client.Common.DelayLoadStatus.prototype = {
    success: 0, 
    fail: 1
}
Lync.Client.Common.DelayLoadStatus.registerEnum('Lync.Client.Common.DelayLoadStatus', false);


Lync.Client.Common.IUtilsLogProvider = function() {}
Lync.Client.Common.IUtilsLogProvider.registerInterface('Lync.Client.Common.IUtilsLogProvider');


Lync.Client.Common.IPostMessageSink = function() {}
Lync.Client.Common.IPostMessageSink.registerInterface('Lync.Client.Common.IPostMessageSink');


Lync.Client.Common.ProfilerInterface = function() {}
Lync.Client.Common.ProfilerInterface.registerInterface('Lync.Client.Common.ProfilerInterface');


Lync.Client.Common.StringComparison = function() {}
Lync.Client.Common.StringComparison.prototype = {
    none: 0, 
    ignoreCase: 1
}
Lync.Client.Common.StringComparison.registerEnum('Lync.Client.Common.StringComparison', false);


Lync.Client.Common.ICustomFormatter = function() {}
Lync.Client.Common.ICustomFormatter.registerInterface('Lync.Client.Common.ICustomFormatter');


Lync.Client.Common.IFormatProvider = function() {}
Lync.Client.Common.IFormatProvider.registerInterface('Lync.Client.Common.IFormatProvider');


Lync.Client.Common.IFormattable = function() {}
Lync.Client.Common.IFormattable.registerInterface('Lync.Client.Common.IFormattable');


Lync.Client.Common.BrowserType = function() {}
Lync.Client.Common.BrowserType.prototype = {
    unknown: 0, 
    internetExplorer: 2, 
    firefox: 3, 
    safari: 4, 
    chrome: 6, 
    edge: 7
}
Lync.Client.Common.BrowserType.registerEnum('Lync.Client.Common.BrowserType', false);


Lync.Client.Common.PlatformType = function() {}
Lync.Client.Common.PlatformType.prototype = {
    unknown: 0, 
    windows: 2, 
    windowsMobile: 3, 
    mac: 4, 
    sun: 5, 
    linux: 6, 
    appleiOS: 7
}
Lync.Client.Common.PlatformType.registerEnum('Lync.Client.Common.PlatformType', false);


Lync.Client.Common.BrowserOsBitness = function() {}
Lync.Client.Common.BrowserOsBitness.prototype = {
    unknown: 0, 
    os32Browser32: 1, 
    os64Browser32: 2, 
    os64Browser64: 3
}
Lync.Client.Common.BrowserOsBitness.registerEnum('Lync.Client.Common.BrowserOsBitness', false);


Lync.Client.Common.ByteArray = function Lync_Client_Common_ByteArray(startSize) {
    this._bytes = [];
    for (var $v_0 = 0; $v_0 < startSize; $v_0++) {
        this.add(0);
    }
}
Lync.Client.Common.ByteArray.fromArray = function Lync_Client_Common_ByteArray$fromArray(bytes) {
    var $v_0 = new Lync.Client.Common.ByteArray(0);
    for (var $v_1 = 0; $v_1 < bytes.length; $v_1++) {
        $v_0.add(bytes[$v_1]);
    }
    return $v_0;
}
Lync.Client.Common.ByteArray.byteArrayToUInt32 = function Lync_Client_Common_ByteArray$byteArrayToUInt32(value, startIndex) {
    if (value.get_length() < (startIndex + 4)) {
        throw Error.argument('byte array to be converted is too small');
    }
    var $v_0;
    var $v_1 = Lync.Client.Common.ByteArray.byteArrayToInt32(value, startIndex);
    if ($v_1 < 0) {
        $v_0 = ($v_1 + Math.pow(2, 32));
    }
    else {
        $v_0 = $v_1;
    }
    return $v_0;
}
Lync.Client.Common.ByteArray.byteArrayToInt32 = function Lync_Client_Common_ByteArray$byteArrayToInt32(value, startIndex) {
    if (value.get_length() < (startIndex + 4)) {
        throw Error.argument('byte array to be converted is too small');
    }
    var $v_0 = ((value.get_item(startIndex) << 24) + (value.get_item(startIndex + 1) << 16) + (value.get_item(startIndex + 2) << 8) + (value.get_item(startIndex + 3)));
    return $v_0;
}
Lync.Client.Common.ByteArray.byteArrayToUInt16 = function Lync_Client_Common_ByteArray$byteArrayToUInt16(value, startIndex) {
    if (value.get_length() < (startIndex + 2)) {
        throw Error.argument('byte array to be converted is too small');
    }
    return ((value.get_item(startIndex) << 8) + (value.get_item(startIndex + 1)));
}
Lync.Client.Common.ByteArray.integerToByteArray = function Lync_Client_Common_ByteArray$integerToByteArray(value) {
    var $v_0 = value;
    var $v_1 = 4;
    var $v_2 = new Lync.Client.Common.ByteArray(0);
    for (var $v_3 = 0; $v_3 < $v_1; $v_3++) {
        $v_2.insert(0, ($v_0 & 255));
        $v_0 = $v_0 >> 8;
    }
    return $v_2;
}
Lync.Client.Common.ByteArray.byteArrayToString = function Lync_Client_Common_ByteArray$byteArrayToString(value) {
    var $v_0 = Lync.Client.Common.StringHelper.empty;
    var $v_1 = 0;
    while ($v_1 < value.get_length()) {
        var $v_2 = value.get_item($v_1);
        if (($v_2 < 0) || ($v_2 > 255)) {
            throw Error.argument('Unexpected utf8 byte');
        }
        if ($v_2 < 128) {
            $v_0 += String.fromCharCode($v_2);
            $v_1++;
        }
        else if (($v_2 & 224) === 192) {
            if (($v_1 + 1) >= value.get_length()) {
                throw Error.argument('Unexpected end of array');
            }
            var $v_3 = value.get_item($v_1 + 1);
            if (($v_3 < 0) || ($v_3 > 255) || (($v_3 & 192) !== 128)) {
                throw Error.argument('Unexpected utf8 byte');
            }
            $v_0 += String.fromCharCode((($v_2 & 31) << 6) | ($v_3 & 63));
            $v_1 += 2;
        }
        else if (($v_2 & 240) === 224) {
            if ((($v_1 + 1) >= value.get_length()) || (($v_1 + 2) >= value.get_length())) {
                throw Error.argument('Unexpected end of array');
            }
            var $v_4 = value.get_item($v_1 + 1);
            var $v_5 = value.get_item($v_1 + 2);
            if (($v_4 < 0) || ($v_4 > 255) || (($v_4 & 192) !== 128)) {
                throw Error.argument('Unexpected utf8 byte');
            }
            if (($v_5 < 0) || ($v_5 > 255) || (($v_5 & 192) !== 128)) {
                throw Error.argument('Unexpected utf8 byte');
            }
            $v_0 += String.fromCharCode((($v_2 & 15) << 12) | (($v_4 & 63) << 6) | ($v_5 & 63));
            $v_1 += 3;
        }
        else if (($v_2 & 248) === 240) {
            if ((($v_1 + 1) >= value.get_length()) || (($v_1 + 2) >= value.get_length()) || (($v_1 + 3) >= value.get_length())) {
                throw Error.argument('Unexpected end of array');
            }
            var $v_6 = value.get_item($v_1 + 1);
            var $v_7 = value.get_item($v_1 + 2);
            var $v_8 = value.get_item($v_1 + 3);
            if (($v_6 < 0) || ($v_6 > 255) || (($v_6 & 192) !== 128)) {
                throw Error.argument('Unexpected utf8 byte');
            }
            if (($v_7 < 0) || ($v_7 > 255) || (($v_7 & 192) !== 128)) {
                throw Error.argument('Unexpected utf8 byte');
            }
            if (($v_8 < 0) || ($v_8 > 255) || (($v_8 & 192) !== 128)) {
                throw Error.argument('Unexpected utf8 byte');
            }
            var $v_9 = (($v_2 & 7) << 18) | (($v_6 & 63) << 12) | (($v_7 & 63) << 6) | ($v_8 & 63);
            var $v_A = 55232;
            var $v_B = $v_A + ($v_9 >> 10);
            var $v_C = 56320 + ($v_9 & 1023);
            $v_0 += String.fromCharCode($v_B);
            $v_0 += String.fromCharCode($v_C);
            $v_1 += 4;
        }
        else {
            throw Error.argument('Illegal utf8 converter input');
        }
    }
    return $v_0;
}
Lync.Client.Common.ByteArray.stringToByteArray = function Lync_Client_Common_ByteArray$stringToByteArray(value) {
    var $v_0 = new Lync.Client.Common.ByteArray(0);
    if (!Lync.Client.Common.Utilities.isNullOrUndefined(value)) {
        var $v_1 = 0;
        while ($v_1 < value.length) {
            var $v_2 = value.charCodeAt($v_1);
            if ($v_2 < 128) {
                $v_0.add($v_2);
                $v_1++;
            }
            else if ($v_2 < 2048) {
                $v_0.add((192 | ($v_2 >> 6)));
                $v_0.add((128 | ($v_2 & 63)));
                $v_1++;
            }
            else if (55296 <= $v_2 && $v_2 <= 56319) {
                var $v_3 = $v_2;
                if (($v_1 + 1) >= value.length) {
                    throw Error.argument('High Surrogate at end of string');
                }
                var $v_4 = value.charCodeAt($v_1 + 1);
                if (!(56320 <= $v_4 && $v_4 <= 57343)) {
                    throw Error.argument('High Surrogate followed by invalid low surrogate');
                }
                var $v_5 = -56613888;
                var $v_6 = ($v_3 << 10) + $v_4 + $v_5;
                $v_0.add((240 | ($v_6 >> 18)));
                $v_0.add((128 | (($v_6 >> 12) & 63)));
                $v_0.add((128 | (($v_6 >> 6) & 63)));
                $v_0.add((128 | ($v_6 & 63)));
                $v_1 = $v_1 + 2;
            }
            else if (56320 <= $v_2 && $v_2 <= 57343) {
                throw Error.argument('Low Surrogate not preceded by high surrogate');
            }
            else if ($v_2 < 65536) {
                $v_0.add((224 | ($v_2 >> 12)));
                $v_0.add((128 | (($v_2 >> 6) & 63)));
                $v_0.add((128 | ($v_2 & 63)));
                $v_1++;
            }
            else {
                throw Error.argument('Illegal utf8 converter input');
            }
        }
    }
    return $v_0;
}
Lync.Client.Common.ByteArray.prototype = {
    _bytes: null,
    
    concat: function Lync_Client_Common_ByteArray$concat(data) {
        this._bytes = this._bytes.concat(data._bytes);
    },
    
    add: function Lync_Client_Common_ByteArray$add(value) {
        this._bytes.push(value);
    },
    
    insert: function Lync_Client_Common_ByteArray$insert(index, value) {
        this._bytes.splice(index, 0, value);
    },
    
    remove: function Lync_Client_Common_ByteArray$remove(index) {
        var $v_0 = this.removeRange(index, 1);
        return $v_0.get_item(0);
    },
    
    removeRange: function Lync_Client_Common_ByteArray$removeRange(start, length) {
        var $v_0 = new Lync.Client.Common.ByteArray(0);
        $v_0._bytes = this._bytes.splice(start, length);
        return $v_0;
    },
    
    clear: function Lync_Client_Common_ByteArray$clear() {
        this._bytes.splice(0, this._bytes.length);
    },
    
    get_item: function Lync_Client_Common_ByteArray$get_item(index) {
        var $v_0 = (this._bytes)[index];
        return $v_0;
    },
    set_item: function Lync_Client_Common_ByteArray$set_item(index, value) {
        if ((index < 0) || (index >= this.get_length())) {
            throw Error.argumentOutOfRange();
        }
        (this._bytes)[index] = value;
        return value;
    },
    
    getRange: function Lync_Client_Common_ByteArray$getRange(start, length) {
        var $v_0 = new Lync.Client.Common.ByteArray(0);
        $v_0._bytes = this._bytes.slice(start, start + length);
        return $v_0;
    },
    
    toArray: function Lync_Client_Common_ByteArray$toArray() {
        var $v_0 = this.get_length();
        var $v_1 = new Array($v_0);
        for (var $v_2 = 0; $v_2 < $v_0; $v_2++) {
            $v_1[$v_2] = this.get_item($v_2);
        }
        return $v_1;
    },
    
    get_length: function Lync_Client_Common_ByteArray$get_length() {
        var $v_0 = this._bytes.length;
        return $v_0;
    }
}


Lync.Client.Common.ObjectArray = function Lync_Client_Common_ObjectArray(startSize) {
    this._bytes = [];
    for (var $v_0 = 0; $v_0 < startSize; $v_0++) {
        this.add(null);
    }
}
Lync.Client.Common.ObjectArray.prototype = {
    _bytes: null,
    
    concat: function Lync_Client_Common_ObjectArray$concat(data) {
        this._bytes = this._bytes.concat(data._bytes);
    },
    
    concatArrayList: function Lync_Client_Common_ObjectArray$concatArrayList(data) {
        for (var $v_0 = 0; $v_0 < data.length; $v_0++) {
            this.add(data[$v_0]);
        }
    },
    
    add: function Lync_Client_Common_ObjectArray$add(value) {
        this._bytes.push(value);
    },
    
    insert: function Lync_Client_Common_ObjectArray$insert(index, value) {
        this._bytes.splice(index, 0, value);
    },
    
    remove: function Lync_Client_Common_ObjectArray$remove(index) {
        var $v_0 = this.removeRange(index, 1);
        return $v_0.get_item(0);
    },
    
    removeRange: function Lync_Client_Common_ObjectArray$removeRange(start, length) {
        var $v_0 = new Lync.Client.Common.ObjectArray(0);
        $v_0._bytes = this._bytes.splice(start, length);
        return $v_0;
    },
    
    clear: function Lync_Client_Common_ObjectArray$clear() {
        this._bytes.splice(0, this._bytes.length);
    },
    
    get_item: function Lync_Client_Common_ObjectArray$get_item(index) {
        var $v_0 = (this._bytes)[index];
        return $v_0;
    },
    set_item: function Lync_Client_Common_ObjectArray$set_item(index, value) {
        if ((index < 0) || (index >= this.get_length())) {
            throw Error.argumentOutOfRange();
        }
        (this._bytes)[index] = value;
        return value;
    },
    
    getRange: function Lync_Client_Common_ObjectArray$getRange(start, length) {
        var $v_0 = new Lync.Client.Common.ObjectArray(0);
        $v_0._bytes = this._bytes.slice(start, start + length);
        return $v_0;
    },
    
    get_length: function Lync_Client_Common_ObjectArray$get_length() {
        var $v_0 = this._bytes.length;
        return $v_0;
    }
}


Lync.Client.Common.Base64 = function Lync_Client_Common_Base64() {
}
Lync.Client.Common.Base64.$14 = function Lync_Client_Common_Base64$$14($p0, $p1) {
    return (($p0 % $p1) + $p1) % $p1;
}
Lync.Client.Common.Base64.encode = function Lync_Client_Common_Base64$encode(input) {
    if (Lync.Client.Common.StringHelper.isNullOrEmpty(input)) {
        return input;
    }
    var $v_0 = Lync.Client.Common.ByteArray.stringToByteArray(input);
    return Lync.Client.Common.Base64.encodeBytes($v_0);
}
Lync.Client.Common.Base64.decode = function Lync_Client_Common_Base64$decode(input) {
    if (Lync.Client.Common.StringHelper.isNullOrEmpty(input)) {
        return input;
    }
    var $v_0 = Lync.Client.Common.Base64.decodeBytes(input);
    return Lync.Client.Common.ByteArray.byteArrayToString($v_0);
}
Lync.Client.Common.Base64.encodeBytes = function Lync_Client_Common_Base64$encodeBytes(input) {
    if (Lync.Client.Common.Utilities.isNullOrUndefined(input)) {
        return null;
    }
    var $v_0 = Lync.Client.Common.StringHelper.empty;
    var $v_1, $v_2, $v_3, $v_4, $v_5, $v_6, $v_7;
    var $v_8 = 0;
    while ($v_8 < input.get_length()) {
        $v_1 = input.get_item($v_8++);
        $v_2 = ($v_8 < input.get_length()) ? input.get_item($v_8++) : 0;
        $v_3 = ($v_8 < input.get_length()) ? input.get_item($v_8++) : 0;
        $v_4 = $v_1 >> 2;
        $v_5 = (($v_1 & 3) << 4) | ($v_2 >> 4);
        $v_6 = (($v_2 & 15) << 2) | ($v_3 >> 6);
        $v_7 = $v_3 & 63;
        if ($v_8 === input.get_length()) {
            if (Lync.Client.Common.Base64.$14(input.get_length(), 3) === 1) {
                $v_6 = 64;
                $v_7 = 64;
            }
            else if (Lync.Client.Common.Base64.$14(input.get_length(), 3) === 2) {
                $v_7 = 64;
            }
        }
        $v_0 += Lync.Client.Common.Base64.$A.charAt($v_4) + Lync.Client.Common.Base64.$A.charAt($v_5) + Lync.Client.Common.Base64.$A.charAt($v_6) + Lync.Client.Common.Base64.$A.charAt($v_7);
    }
    return $v_0;
}
Lync.Client.Common.Base64.decodeBytes = function Lync_Client_Common_Base64$decodeBytes(input) {
    if (Lync.Client.Common.Utilities.isNullOrUndefined(input)) {
        return null;
    }
    var $v_0 = new Lync.Client.Common.ByteArray(0);
    var $v_1, $v_2, $v_3, $v_4, $v_5, $v_6, $v_7;
    var $v_8 = 0;
    while ($v_8 < input.length) {
        $v_4 = Lync.Client.Common.Base64.$A.indexOf(input.charAt($v_8++));
        $v_5 = Lync.Client.Common.Base64.$A.indexOf(input.charAt($v_8++));
        $v_6 = Lync.Client.Common.Base64.$A.indexOf(input.charAt($v_8++));
        $v_7 = Lync.Client.Common.Base64.$A.indexOf(input.charAt($v_8++));
        $v_1 = ($v_4 << 2) | ($v_5 >> 4);
        $v_2 = (($v_5 & 15) << 4) | ($v_6 >> 2);
        $v_3 = (($v_6 & 3) << 6) | $v_7;
        $v_0.add($v_1);
        if ($v_6 !== 64) {
            $v_0.add($v_2);
        }
        if ($v_7 !== 64) {
            $v_0.add($v_3);
        }
    }
    return $v_0;
}
Lync.Client.Common.Base64.safeGetDecodedString = function Lync_Client_Common_Base64$safeGetDecodedString(encodedString) {
    var $v_0 = Lync.Client.Common.StringHelper.empty;
    var $v_1 = encodedString.length % 4;
    if ($v_1 === 2) {
        $v_0 = '==';
    }
    else if ($v_1 === 1 || $v_1 === 3) {
        $v_0 = '=';
    }
    encodedString += $v_0;
    var $v_2 = new RegExp('_', 'g');
    var $v_3 = new RegExp('-', 'g');
    var $v_4 = new RegExp('!', 'g');
    encodedString = encodedString.replace($v_2, '/');
    encodedString = encodedString.replace($v_3, '+');
    encodedString = encodedString.replace($v_4, '=');
    return Lync.Client.Common.Base64.decode(encodedString);
}


Lync.Client.Common.BigInt = function Lync_Client_Common_BigInt(high, low, negative) {
    this.$6_0 = high;
    this.$7_0 = low;
    this.$D_0 = negative;
}
Lync.Client.Common.BigInt.empty = function Lync_Client_Common_BigInt$empty() {
    return new Lync.Client.Common.BigInt(0, 0, false);
}
Lync.Client.Common.BigInt.fromString = function Lync_Client_Common_BigInt$fromString(strValue) {
    var $v_0 = strValue.split(',');
    var $v_1 = new Lync.Client.Common.BigInt(0, 0, false);
    if ($v_0.length >= 2) {
        $v_1.$6_0 = parseInt($v_0[0]);
        $v_1.$7_0 = parseInt($v_0[1]);
        $v_1.$D_0 = Boolean.parse($v_0[2]);
    }
    return $v_1;
}
Lync.Client.Common.BigInt.fromLong = function Lync_Client_Common_BigInt$fromLong(value) {
    if (value > 2147483648 || value <= -2147483648) {
        throw Error.argumentOutOfRange();
    }
    var $v_0 = value;
    var $v_1 = false;
    if (value < 0) {
        $v_0 = -value;
        $v_1 = true;
    }
    var $v_2 = 0;
    var $v_3 = ($v_0 & 4294967295);
    return new Lync.Client.Common.BigInt($v_2, $v_3, $v_1);
}
Lync.Client.Common.BigInt.prototype = {
    
    copy: function Lync_Client_Common_BigInt$copy(orig) {
        this.$6_0 = orig.$6_0;
        this.$7_0 = orig.$7_0;
        this.$D_0 = orig.$D_0;
    },
    
    isEmpty: function Lync_Client_Common_BigInt$isEmpty() {
        return (!this.$6_0 && !this.$7_0);
    },
    
    equals: function Lync_Client_Common_BigInt$equals(bigInt) {
        return ((this.$6_0 === bigInt.$6_0) && (this.$7_0 === bigInt.$7_0));
    },
    
    toLong: function Lync_Client_Common_BigInt$toLong() {
        var $v_0 = (this.$6_0 << 32) | (this.$7_0 & 4294967295);
        if (this.$D_0) {
            return -$v_0;
        }
        else {
            return $v_0;
        }
    },
    
    serialize: function Lync_Client_Common_BigInt$serialize() {
        return this.$6_0.toString() + ',' + this.$7_0.toString() + ',' + this.$D_0.toString();
    },
    
    $6_0: 0,
    
    get_high: function Lync_Client_Common_BigInt$get_high() {
        return this.$6_0;
    },
    set_high: function Lync_Client_Common_BigInt$set_high(value) {
        this.$6_0 = value;
        return value;
    },
    
    $7_0: 0,
    
    get_low: function Lync_Client_Common_BigInt$get_low() {
        return this.$7_0;
    },
    set_low: function Lync_Client_Common_BigInt$set_low(value) {
        this.$7_0 = value;
        return value;
    },
    
    $D_0: false,
    
    get_negative: function Lync_Client_Common_BigInt$get_negative() {
        return this.$D_0;
    },
    set_negative: function Lync_Client_Common_BigInt$set_negative(value) {
        this.$D_0 = value;
        return value;
    }
}


Lync.Client.Common.DelayLoadCompleteArgs = function Lync_Client_Common_DelayLoadCompleteArgs(status) {
    Lync.Client.Common.DelayLoadCompleteArgs.initializeBase(this);
    this.$o_1 = status;
}
Lync.Client.Common.DelayLoadCompleteArgs.prototype = {
    $o_1: 0,
    
    get_status: function Lync_Client_Common_DelayLoadCompleteArgs$get_status() {
        return this.$o_1;
    }
}


Lync.Client.Common.DelayLoader = function Lync_Client_Common_DelayLoader() {
    this.$$d_$1K_1 = Function.createDelegate(this, this.$1K_1);
    this.$O_1 = -1;
    Lync.Client.Common.DelayLoader.initializeBase(this);
}
Lync.Client.Common.DelayLoader.instance = function Lync_Client_Common_DelayLoader$instance() {
    if (!Lync.Client.Common.DelayLoader.$e) {
        Lync.Client.Common.DelayLoader.$e = new Lync.Client.Common.DelayLoader();
    }
    return Lync.Client.Common.DelayLoader.$e;
}
Lync.Client.Common.DelayLoader.ScriptLoaded = function Lync_Client_Common_DelayLoader$ScriptLoaded(e) {
    Lync.Client.Common.DelayLoader.instance().$13_1();
}
Lync.Client.Common.DelayLoader.ScriptReadyStateChanged = function Lync_Client_Common_DelayLoader$ScriptReadyStateChanged(e) {
    var $v_0 = (e.srcElement).readyState;
    if ($v_0 === 'loaded' || $v_0 === 'complete') {
        Lync.Client.Common.DelayLoader.instance().$13_1();
    }
}
Lync.Client.Common.DelayLoader.prototype = {
    $T_1: '',
    $Z_1: null,
    $U_1: null,
    $M_1: 0,
    $P_1: null,
    $H_1: false,
    $j_1: 30000,
    
    reset: function Lync_Client_Common_DelayLoader$reset() {
        this.$T_1 = '';
        this.$Z_1 = null;
        this.$U_1 = null;
        this.$M_1 = -1;
        this.$P_1 = null;
        this.$H_1 = false;
        this.$n_1();
    },
    
    initialize: function Lync_Client_Common_DelayLoader$initialize(basepath, scriptFiles, cssFiles, scriptParentDoc, scriptLoadTimeout) {
        this.$T_1 = basepath;
        this.$M_1 = 0;
        this.$Z_1 = scriptFiles;
        this.$U_1 = cssFiles;
        this.$P_1 = scriptParentDoc;
        this.$j_1 = scriptLoadTimeout;
    },
    
    get_delayLoadInProgress: function Lync_Client_Common_DelayLoader$get_delayLoadInProgress() {
        return this.$H_1;
    },
    
    add_delayLoadCompleted: function Lync_Client_Common_DelayLoader$add_delayLoadCompleted(value) {
        this.$E_0.addHandler(Lync.Client.Common.DelayLoader.$R, value);
    },
    remove_delayLoadCompleted: function Lync_Client_Common_DelayLoader$remove_delayLoadCompleted(value) {
        this.$E_0.removeHandler(Lync.Client.Common.DelayLoader.$R, value);
    },
    
    delayLoadScriptsAndCss: function Lync_Client_Common_DelayLoader$delayLoadScriptsAndCss() {
        if (this.$H_1) {
            return;
        }
        this.$H_1 = true;
        this.$1D_1();
        this.$1E_1();
    },
    
    $1D_1: function Lync_Client_Common_DelayLoader$$1D_1() {
        for (var $v_0 = 0; $v_0 < this.$U_1.length; $v_0++) {
            this.$1A_1(this.$T_1 + this.$U_1[$v_0]);
        }
    },
    
    $1E_1: function Lync_Client_Common_DelayLoader$$1E_1() {
        this.$p_1(this.$M_1);
    },
    
    $1B_1: function Lync_Client_Common_DelayLoader$$1B_1($p0) {
        var $v_0 = this.$1C_1();
        if (this.$j_1 !== -1) {
            this.$O_1 = window.setTimeout(this.$$d_$1K_1, this.$j_1);
        }
        this.$17_1($v_0);
        $v_0.src = $p0 + '?' + 'lcsentwebapp' + '6.0.9299.0';
    },
    
    $1C_1: function Lync_Client_Common_DelayLoader$$1C_1() {
        var $v_0 = this.$P_1.createElement('script');
        $v_0.type = 'text/javascript';
        this.$1I_1($v_0);
        return $v_0;
    },
    
    $1I_1: function Lync_Client_Common_DelayLoader$$1I_1($p0) {
        if (!$p0.readyState) {
            $p0.addEventListener('load', Lync.Client.Common.DelayLoader.ScriptLoaded , false);
        }
        else {
            $p0.attachEvent('onreadystatechange', Lync.Client.Common.DelayLoader.ScriptReadyStateChanged);
        }
    },
    
    $17_1: function Lync_Client_Common_DelayLoader$$17_1($p0) {
        var $v_0 = this.$P_1.getElementsByTagName('script');
        if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_0) && $v_0.length) {
            var $v_1 = $v_0[$v_0.length - 1];
            $v_1.parentNode.insertBefore($p0, $v_1);
        }
        else {
            var $v_2 = this.$P_1.getElementsByTagName('head')[0];
            if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_2)) {
                $v_2.appendChild($p0);
            }
        }
    },
    
    $1K_1: function Lync_Client_Common_DelayLoader$$1K_1() {
        this.$n_1();
        this.$H_1 = false;
        this.fireEvent(Lync.Client.Common.DelayLoader.$R, new Lync.Client.Common.DelayLoadCompleteArgs(1));
    },
    
    $n_1: function Lync_Client_Common_DelayLoader$$n_1() {
        if (this.$O_1 !== -1) {
            window.clearTimeout(this.$O_1);
            this.$O_1 = -1;
        }
    },
    
    $13_1: function Lync_Client_Common_DelayLoader$$13_1() {
        this.$n_1();
        this.$M_1++;
        this.$p_1(this.$M_1);
    },
    
    $p_1: function Lync_Client_Common_DelayLoader$$p_1($p0) {
        if ($p0 < this.$Z_1.length) {
            this.$1B_1(this.$T_1 + this.$Z_1[$p0]);
        }
        else {
            this.$H_1 = false;
            this.fireEvent(Lync.Client.Common.DelayLoader.$R, new Lync.Client.Common.DelayLoadCompleteArgs(0));
        }
    },
    
    $1A_1: function Lync_Client_Common_DelayLoader$$1A_1($p0) {
        $p0 += '?lcsentwebapp6.0.9299.0';
        var $v_0 = document.createElement('link');
        var $v_1 = document.createAttribute('type');
        $v_1.value = 'text/css';
        $v_0.attributes.setNamedItem($v_1);
        var $v_2 = document.createAttribute('rel');
        $v_2.value = 'stylesheet';
        $v_0.attributes.setNamedItem($v_2);
        var $v_3 = document.createAttribute('href');
        $v_3.value = $p0;
        $v_0.attributes.setNamedItem($v_3);
        var $v_4 = window.document.getElementsByTagName('head')[0];
        if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_4)) {
            $v_4.appendChild($v_0);
        }
    }
}


Lync.Client.Common.DictionaryHelper = function Lync_Client_Common_DictionaryHelper() {
}
Lync.Client.Common.DictionaryHelper.containsKey = function Lync_Client_Common_DictionaryHelper$containsKey(dict, key) {
    var $v_0 = Lync.Client.Common.DictionaryHelper.tryGetValue(dict, key);
    if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_0)) {
        return true;
    }
    return false;
}
Lync.Client.Common.DictionaryHelper.tryGetKeyByIndex = function Lync_Client_Common_DictionaryHelper$tryGetKeyByIndex(dictionary, index) {
    var $v_0 = Lync.Client.Common.DictionaryHelper.tryGetDictionaryEntryByIndex(dictionary, index);
    if (!$v_0) {
        return null;
    }
    return $v_0.key;
}
Lync.Client.Common.DictionaryHelper.tryGetDictionaryEntryByIndex = function Lync_Client_Common_DictionaryHelper$tryGetDictionaryEntryByIndex(dictionary, index) {
    if (Lync.Client.Common.Utilities.isNullOrUndefined(dictionary)) {
        return null;
    }
    var $v_0 = 0;
    var $$dict_3 = dictionary;
    for (var $$key_4 in $$dict_3) {
        var $v_1 = { key: $$key_4, value: $$dict_3[$$key_4] };
        if (index === $v_0) {
            return $v_1;
        }
        $v_0++;
    }
    return null;
}
Lync.Client.Common.DictionaryHelper.tryGetValue = function Lync_Client_Common_DictionaryHelper$tryGetValue(dict, key) {
    var $v_0 = null;
    try {
        $v_0 = dict[key];
    }
    catch ($$e_3) {
    }
    return $v_0;
}
Lync.Client.Common.DictionaryHelper.count = function Lync_Client_Common_DictionaryHelper$count(dict) {
    var $v_0 = 0;
    var $$dict_2 = dict;
    for (var $$key_3 in $$dict_2) {
        var $v_1 = { key: $$key_3, value: $$dict_2[$$key_3] };
        $v_0++;
    }
    return $v_0;
}
Lync.Client.Common.DictionaryHelper.clear = function Lync_Client_Common_DictionaryHelper$clear(dict) {
    var $v_0 = [];
    var $$dict_2 = dict;
    for (var $$key_3 in $$dict_2) {
        var $v_1 = { key: $$key_3, value: $$dict_2[$$key_3] };
        Array.add($v_0, $v_1.key);
    }
    for (var $v_2 = 0; $v_2 < $v_0.length; $v_2++) {
        delete dict[$v_0[$v_2].toString()];
    }
}


Lync.Client.Common.EcsParameters = function Lync_Client_Common_EcsParameters() {
}
Lync.Client.Common.EcsParameters.get = function Lync_Client_Common_EcsParameters$get() {
    return Lync.Client.Common.EcsParameters.$i;
}
Lync.Client.Common.EcsParameters.parse = function Lync_Client_Common_EcsParameters$parse(ecsConfiguration) {
    var $v_0 = Sys.Serialization.JavaScriptSerializer.deserialize(ecsConfiguration);
    if (_Script.isNullOrUndefined($v_0)) {
        $v_0 = new Lync.Client.Common.EcsParameters();
    }
    if (Lync.Client.Common.StringHelper.isNullOrEmpty($v_0.pluginLocation)) {
        if (!Lync.Client.Common.StringHelper.isNullOrEmpty($v_0.webAppBase)) {
            $v_0.pluginLocation = $v_0.webAppBase + 'plugins/';
        }
        else {
            $v_0.pluginLocation = '../lwa/plugins/';
        }
    }
    Lync.Client.Common.EcsParameters.$i = $v_0;
    return $v_0;
}
Lync.Client.Common.EcsParameters.prototype = {
    useCdn: false,
    version: null,
    pluginLocation: null,
    webAppBase: null,
    minWinPluginMinorVersion: null,
    minWinPluginVersion: null,
    winPluginVersion: null,
    winPluginUpdateRequired: null,
    enableVBSS: false
}


Lync.Client.Common.HTMLEncoder = function Lync_Client_Common_HTMLEncoder() {
}
Lync.Client.Common.HTMLEncoder.encode = function Lync_Client_Common_HTMLEncoder$encode(rawHtml) {
    if (Lync.Client.Common.StringHelper.isNullOrEmpty(rawHtml)) {
        return rawHtml;
    }
    var $v_0 = rawHtml.replace(Lync.Client.Common.HTMLEncoder.$q, '&amp;');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$12, '&lt;');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$10, '&gt;');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$r, '&apos;');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$15, '&quot;');
    return $v_0;
}
Lync.Client.Common.HTMLEncoder.decode = function Lync_Client_Common_HTMLEncoder$decode(encodedHtml) {
    if (Lync.Client.Common.StringHelper.isNullOrEmpty(encodedHtml)) {
        return encodedHtml;
    }
    var $v_0 = encodedHtml.replace(Lync.Client.Common.HTMLEncoder.$z, '\"');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$w, '\'');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$x, '>');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$y, '<');
    $v_0 = $v_0.replace(Lync.Client.Common.HTMLEncoder.$v, '&');
    return $v_0;
}


Lync.Client.Common.EnumHelper = function Lync_Client_Common_EnumHelper() {
}
Lync.Client.Common.EnumHelper.parse = function Lync_Client_Common_EnumHelper$parse(enumType, enumKey) {
    try {
        return enumType.parse(enumKey, true);
    }
    catch ($v_0) {
        var $v_1 = parseInt(enumKey);
        if (isFinite($v_1) && $v_1 >= 0) {
            return $v_1;
        }
        throw $v_0;
    }
}
Lync.Client.Common.EnumHelper.toString = function Lync_Client_Common_EnumHelper$toString(enumType, value) {
    return enumType.toString(value);
}


Lync.Client.Common.EventSource = function Lync_Client_Common_EventSource(owner) {
    this.$E_0 = new Sys.EventHandlerList();
    this.$g_0 = new Sys.EventHandlerList();
    if (Lync.Client.Common.Utilities.isNullOrUndefined(owner)) {
        this.$Y_0 = this;
    }
    else {
        this.$Y_0 = owner;
    }
}
Lync.Client.Common.EventSource.prototype = {
    $E_0: null,
    $g_0: null,
    $Y_0: null,
    
    $1F_0: function Lync_Client_Common_EventSource$$1F_0($p0, $p1, $p2) {
        var $v_0 = false;
        var $v_1 = this.$g_0.getHandler($p0);
        if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_1)) {
            var $$t_6 = this;
            window.setTimeout(function() {
                try {
                    $v_1($$t_6.$Y_0, $p1);
                }
                catch ($v_2) {
                    Lync.Client.Common.UtilsLogProvider.get_$1().assert(false, 'Exception occured while firing Async Event event id {0} exception {1}', $p0, $v_2.toString());
                }
            }, $p2);
            $v_0 = true;
        }
        return $v_0;
    },
    
    fireEvent: function Lync_Client_Common_EventSource$fireEvent(id, args, eventTypes) {
        if (Lync.Client.Common.Utilities.isNullOrUndefined(eventTypes)) {
            eventTypes = 3;
        }
        var $v_0 = false;
        if ((eventTypes & 1) > 0) {
            try {
                var $v_1 = this.$E_0.getHandler(id);
                if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_1)) {
                    $v_1(this.$Y_0, args);
                    $v_0 = true;
                }
            }
            catch ($v_2) {
                Lync.Client.Common.UtilsLogProvider.get_$1().assert(false, 'Exception occured while firing Async Event event id {0} exception {1}', id, $v_2.toString());
            }
        }
        if ((eventTypes & 2) > 0) {
            $v_0 = this.$1F_0(id, args, 0) || $v_0;
        }
        return $v_0;
    },
    
    get_events: function Lync_Client_Common_EventSource$get_events() {
        return this.$E_0;
    },
    
    get_asyncEvents: function Lync_Client_Common_EventSource$get_asyncEvents() {
        return this.$g_0;
    }
}


Lync.Client.Common.EventSource.EventType = function() {}
Lync.Client.Common.EventSource.EventType.prototype = {
    sync: 1, 
    async: 2
}
Lync.Client.Common.EventSource.EventType.registerEnum('Lync.Client.Common.EventSource.EventType', false);


Lync.Client.Common.JSON = function Lync_Client_Common_JSON() {
}
Lync.Client.Common.JSON.serialize = function Lync_Client_Common_JSON$serialize(data) {
    if (Lync.Client.Common.Utilities.isNullOrUndefined(data)) {
        return Lync.Client.Common.StringHelper.empty;
    }
    var $v_0 = data;
    if (Lync.Client.Common.Utilities.isNullOrUndefined($v_0)) {
        return Lync.Client.Common.StringHelper.empty;
    }
    var $v_1 = {};
    if (Lync.Client.Common.Utilities.isNullOrUndefined((data).length)) {
        var $$dict_3 = $v_0;
        for (var $$key_4 in $$dict_3) {
            var $v_2 = { key: $$key_4, value: $$dict_3[$$key_4] };
            if ($v_2.key !== '_links' && $v_2.key !== '_embedded') {
                $v_1[$v_2.key] = $v_2.value;
            }
        }
    }
    else {
        $v_1 = $v_0;
    }
    return Sys.Serialization.JavaScriptSerializer.serialize($v_1);
}
Lync.Client.Common.JSON.deserialize = function Lync_Client_Common_JSON$deserialize(data) {
    if (Lync.Client.Common.StringHelper.isNullOrEmpty(data)) {
        return null;
    }
    return Sys.Serialization.JavaScriptSerializer.deserialize(data);
}


Lync.Client.Common.LegacyClientSupport = function Lync_Client_Common_LegacyClientSupport() {
}
Lync.Client.Common.LegacyClientSupport.IsOCClientInstalled = function Lync_Client_Common_LegacyClientSupport$IsOCClientInstalled() {
    var $v_0 = GetBrowserTag();
    var $v_1 = GetConfigForClient(InstalledClient.OC, $v_0);
    if (Lync.Client.Common.Utilities.isNullOrUndefined($v_1)) {
        return false;
    }
    try {
        var $v_2 = new PluginLoader();
        $v_2.Initialize('OC', $v_1.Version_Name, $v_1.Version_CLSID, null);
        var $v_3 = $v_2.LoadPlugin();
        var $v_4 = $v_3.object;
        if (Lync.Client.Common.Utilities.isNullOrUndefined($v_4)) {
            return false;
        }
        Lync.Client.Common.LegacyClientSupport.$c = $v_4;
    }
    catch ($v_5) {
        Lync.Client.Common.UtilsLogProvider.get_$1().error('Exception occured while checking if native OC client is present or not! ' + $v_5);
        return false;
    }
    return true;
}
Lync.Client.Common.LegacyClientSupport.IsAOCClientInstalled = function Lync_Client_Common_LegacyClientSupport$IsAOCClientInstalled() {
    var $v_0 = GetBrowserTag();
    var $v_1 = GetConfigForClient(InstalledClient.AOC, $v_0);
    if (Lync.Client.Common.Utilities.isNullOrUndefined($v_1)) {
        return false;
    }
    try {
        var $v_2 = new PluginLoader();
        $v_2.Initialize('AOC', $v_1.Version_Name, $v_1.Version_CLSID, null);
        var $v_3 = $v_2.LoadPlugin();
        var $v_4 = $v_3.object;
        if (Lync.Client.Common.Utilities.isNullOrUndefined($v_4)) {
            return false;
        }
        Lync.Client.Common.LegacyClientSupport.$b = $v_4;
    }
    catch ($v_5) {
        Lync.Client.Common.UtilsLogProvider.get_$1().error('Exception occured while checking if AOC client is present or not! ' + $v_5);
        return false;
    }
    return true;
}
Lync.Client.Common.LegacyClientSupport.LaunchOCClient = function Lync_Client_Common_LegacyClientSupport$LaunchOCClient() {
    try {
        if (Lync.Client.Common.LegacyClientSupport.$c) {
            Lync.Client.Common.LegacyClientSupport.$c.LaunchUCClient(EscapedJoinXML);
        }
    }
    catch ($v_0) {
        Lync.Client.Common.UtilsLogProvider.get_$1().error('Exception occured while launching OC client ' + $v_0);
    }
}
Lync.Client.Common.LegacyClientSupport.LaunchAOCClient = function Lync_Client_Common_LegacyClientSupport$LaunchAOCClient() {
    try {
        if (Lync.Client.Common.LegacyClientSupport.$b) {
            Lync.Client.Common.LegacyClientSupport.$b.LaunchUCClient(EscapedJoinXML);
        }
    }
    catch ($v_0) {
        Lync.Client.Common.UtilsLogProvider.get_$1().error('Exception occured while launching AOC client ' + $v_0);
    }
}


Lync.Client.Common.UtilsLogProvider = function Lync_Client_Common_UtilsLogProvider() {
}
Lync.Client.Common.UtilsLogProvider.get_$1 = function Lync_Client_Common_UtilsLogProvider$get_$1() {
    return Lync.Client.Common.UtilsLogProvider.$X;
}
Lync.Client.Common.UtilsLogProvider.set_$1 = function Lync_Client_Common_UtilsLogProvider$set_$1($p0) {
    if (!Lync.Client.Common.Utilities.isNullOrUndefined($p0)) {
        Lync.Client.Common.UtilsLogProvider.$X = $p0;
    }
    else {
        Lync.Client.Common.UtilsLogProvider.$X = new Lync.Client.Common.UtilsLogProvider();
    }
    return $p0;
}
Lync.Client.Common.UtilsLogProvider.setLogProvider = function Lync_Client_Common_UtilsLogProvider$setLogProvider(provider) {
    Lync.Client.Common.UtilsLogProvider.set_$1(provider);
}
Lync.Client.Common.UtilsLogProvider.prototype = {
    
    $J_0: function Lync_Client_Common_UtilsLogProvider$$J_0() {
        return (typeof console  != 'undefined' && console != null);
    },
    
    assert: function Lync_Client_Common_UtilsLogProvider$assert(condition, message) {
        var args = [];
        for (var $$pai_3 = 2; $$pai_3 < arguments.length; ++$$pai_3) {
            args[$$pai_3 - 2] = arguments[$$pai_3];
        }
        if (!condition && this.$J_0() && console.error != null) {
            console.error(String.format.apply(null, [ message ].concat(args)));;
        }
    },
    
    error: function Lync_Client_Common_UtilsLogProvider$error(message) {
        var args = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            args[$$pai_2 - 1] = arguments[$$pai_2];
        }
        if (this.$J_0() && console.log != null) {
            console.log(String.format.apply(null, [ message ].concat(args)));;
        }
    },
    
    warn: function Lync_Client_Common_UtilsLogProvider$warn(message) {
        var args = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            args[$$pai_2 - 1] = arguments[$$pai_2];
        }
        if (this.$J_0() && console.warn != null) {
            console.warn(String.format.apply(null, [ message ].concat(args)));;
        }
    },
    
    info: function Lync_Client_Common_UtilsLogProvider$info(message) {
        var args = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            args[$$pai_2 - 1] = arguments[$$pai_2];
        }
        if (this.$J_0() && console.info != null) {
            console.info(String.format.apply(null, [ message ].concat(args)));;
        }
    },
    
    verbose: function Lync_Client_Common_UtilsLogProvider$verbose(message) {
        var args = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            args[$$pai_2 - 1] = arguments[$$pai_2];
        }
        if (this.$J_0() && console.log != null) {
            console.log(String.format.apply(null, [ message ].concat(args)));;
        }
    },
    
    noise: function Lync_Client_Common_UtilsLogProvider$noise(message) {
        var args = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            args[$$pai_2 - 1] = arguments[$$pai_2];
        }
        if (this.$J_0() && console.log != null) {
            console.log(String.format.apply(null, [ message ].concat(args)));;
        }
    }
}


function onPostMessage(data) {
    Lync.Client.Common.PostMessage.get_instance().$1N_0(data.data, data.origin);
}


Lync.Client.Common.PostMessage = function Lync_Client_Common_PostMessage() {
    this.$$d_$19_0 = Function.createDelegate(this, this.$19_0);
    this.$N_0 = {};
    this._windowCloseHandler = this.$$d_$19_0;
     if (typeof window.addEventListener != 'undefined') { window.addEventListener('message', onPostMessage, false); } else if (typeof window.attachEvent != 'undefined') { window.attachEvent('onmessage', onPostMessage); };
     if (typeof window.addEventListener != 'undefined') { window.addEventListener('unload', this._windowCloseHandler, false); } else if (typeof window.attachEvent != 'undefined') { window.attachEvent('onunload', this._windowCloseHandler); };
}
Lync.Client.Common.PostMessage.get_instance = function Lync_Client_Common_PostMessage$get_instance() {
    if (Lync.Client.Common.Utilities.isNullOrUndefined(Lync.Client.Common.PostMessage.$V)) {
        Lync.Client.Common.PostMessage.$V = new Lync.Client.Common.PostMessage();
    }
    return Lync.Client.Common.PostMessage.$V;
}
Lync.Client.Common.PostMessage.prototype = {
    $N_0: null,
    _windowCloseHandler: null,
    
    $19_0: function Lync_Client_Common_PostMessage$$19_0() {
         if (typeof window.removeEventListener != 'undefined') { window.removeEventListener('message', onPostMessage, false); } else if (typeof window.detachEvent != 'undefined') { window.detachEvent('onmessage', onPostMessage); };
    },
    
    $1N_0: function Lync_Client_Common_PostMessage$$1N_0($p0, $p1) {
        try {
            var $v_0;
            var $v_1;
            var $v_2 = $p0;
            try {
                $v_0 = Lync.Client.Common.Base64.decode($p0);
                $v_1 = Lync.Client.Common.JSON.deserialize($v_0);
                if (Lync.Client.Common.Utilities.isNullOrUndefined($v_1)) {
                    $v_2 = $v_0;
                    throw Error.create('Unrecoganized request');
                }
            }
            catch ($v_5) {
                Lync.Client.Common.UtilsLogProvider.get_$1().error('Can not decode the message or message unknown, exception {0}', $v_5.toString());
                $v_1 = Lync.Client.Common.PostMessageRequest.create.apply(null, [ 'Lync.Client.Common.PostMessage.Unhandled', null, null ].concat([ $v_2 ]));
            }
            var $v_3 = Lync.Client.Common.DictionaryHelper.tryGetValue(this.$N_0, $v_1.NameSpace);
            if (Lync.Client.Common.Utilities.isNullOrUndefined($v_3)) {
                Lync.Client.Common.UtilsLogProvider.get_$1().info('Handler not registered for namespace {0}', $v_1.NameSpace);
                return;
            }
            var $v_4 = Array.clone($v_3);
            for (var $v_6 = 0; $v_6 < $v_4.length; $v_6++) {
                var $v_7 = $v_4[$v_6];
                if (($v_7.get_allowedOrigin() === '*') || ($v_7.get_allowedOrigin() === $p1)) {
                    if (Lync.Client.Common.StringHelper.isNullOrEmpty($v_1.ObjID) || ($v_7.get_postMessageID() === $v_1.ObjID)) {
                        $v_7.onMessage($v_1.NameSpace, $v_1.Method, $v_1.Params);
                    }
                }
            }
        }
        catch ($v_8) {
            Lync.Client.Common.UtilsLogProvider.get_$1().error('Exception occured in processing of post message, exception {0}', $v_8.toString());
        }
    },
    
    registerObject: function Lync_Client_Common_PostMessage$registerObject(ns, obj) {
        var $v_0 = Lync.Client.Common.DictionaryHelper.tryGetValue(this.$N_0, ns);
        if (Lync.Client.Common.Utilities.isNullOrUndefined($v_0)) {
            $v_0 = [];
            this.$N_0[ns] = $v_0;
        }
        if (!Array.contains($v_0, obj)) {
            Array.add($v_0, obj);
        }
    },
    
    registerUnhandledMessageHandler: function Lync_Client_Common_PostMessage$registerUnhandledMessageHandler(obj) {
        this.registerObject('Lync.Client.Common.PostMessage.Unhandled', obj);
    },
    
    deRegisterUnhandledMessageHandler: function Lync_Client_Common_PostMessage$deRegisterUnhandledMessageHandler(obj) {
        this.deRegisterObject('Lync.Client.Common.PostMessage.Unhandled', obj);
    },
    
    deRegisterObject: function Lync_Client_Common_PostMessage$deRegisterObject(ns, obj) {
        var $v_0 = Lync.Client.Common.DictionaryHelper.tryGetValue(this.$N_0, ns);
        if (Lync.Client.Common.Utilities.isNullOrUndefined($v_0)) {
            return;
        }
        Array.remove($v_0, obj);
    },
    
    call: function Lync_Client_Common_PostMessage$call(target, targetOrigin, ns, method, objId) {
        var args = [];
        for (var $$pai_9 = 5; $$pai_9 < arguments.length; ++$$pai_9) {
            args[$$pai_9 - 5] = arguments[$$pai_9];
        }
        if (Lync.Client.Common.StringHelper.isNullOrEmpty(ns) || Lync.Client.Common.StringHelper.isNullOrEmpty(method)) {
            throw Error.argumentNull('ns/method cannot be empty');
        }
        var $v_0 = Lync.Client.Common.PostMessageRequest.create.apply(null, [ ns, method, objId ].concat(args));
        var $v_1 = Lync.Client.Common.JSON.serialize($v_0);
        var $v_2 = Lync.Client.Common.Base64.encode($v_1);
        if (Lync.Client.Common.Utilities.isNullOrUndefined(target)) {
            window.parent.postMessage($v_2, targetOrigin);
        }
        else if (!Lync.Client.Common.Utilities.isNullOrUndefined(target.contentWindow)) {
            target.contentWindow.postMessage($v_2, targetOrigin);
        }
        else {
            throw Error.argumentNull('target content window cannot be empty');
        }
    }
}


Lync.Client.Common.PostMessageRequest = function Lync_Client_Common_PostMessageRequest() {
}
Lync.Client.Common.PostMessageRequest.create = function Lync_Client_Common_PostMessageRequest$create(ns, method, objId) {
    var args = [];
    for (var $$pai_5 = 3; $$pai_5 < arguments.length; ++$$pai_5) {
        args[$$pai_5 - 3] = arguments[$$pai_5];
    }
    var $v_0 = new Lync.Client.Common.PostMessageRequest();
    $v_0.NameSpace = ns;
    $v_0.Method = method;
    $v_0.ObjID = objId;
    $v_0.Params = args;
    return $v_0;
}
Lync.Client.Common.PostMessageRequest.prototype = {
    NameSpace: null,
    Method: null,
    ObjID: null,
    Params: null
}


Lync.Client.Common.PostMessageData = function Lync_Client_Common_PostMessageData() {
}
Lync.Client.Common.PostMessageData.prototype = {
    data: null,
    origin: null
}


Lync.Client.Common.PIIUtil = function Lync_Client_Common_PIIUtil() {
}
Lync.Client.Common.PIIUtil.mark = function Lync_Client_Common_PIIUtil$mark(type, info) {
    var $v_0 = true;
    var $v_1 = null;
    switch (type) {
        case 'URI':
            if ($v_0) {
                $v_1 = '%!URI!{0}!';
            }
            else {
                $v_1 = '%!URI!';
            }
            break;
        case 'CALLID':
            if ($v_0) {
                $v_1 = '%!CALLID!{0}!';
            }
            else {
                $v_1 = '%!CALLID!';
            }
            break;
        case 'E164':
            if ($v_0) {
                $v_1 = '%!E164!{0}!';
            }
            else {
                $v_1 = '%!E164!';
            }
            break;
        case 'PHONE':
            if ($v_0) {
                $v_1 = '%!PHONE!{0}!';
            }
            else {
                $v_1 = '%!PHONE!';
            }
            break;
        case 'USER':
            if ($v_0) {
                $v_1 = '%!USER!{0}!';
            }
            else {
                $v_1 = '%!USER!';
            }
            break;
        case 'NAME':
            if ($v_0) {
                $v_1 = '%!NAME!{0}!';
            }
            else {
                $v_1 = '%!NAME!';
            }
            break;
        case 'FQDN':
            if ($v_0) {
                $v_1 = '%!FQDN!{0}!';
            }
            else {
                $v_1 = '%!FQDN!';
            }
            break;
        case 'IP':
            if ($v_0) {
                $v_1 = '%!IP!{0}!';
            }
            else {
                $v_1 = '%!IP!';
            }
            break;
        case 'MACHINE':
            if ($v_0) {
                $v_1 = '%!MACHINE!{0}!';
            }
            else {
                $v_1 = '%!MACHINE!';
            }
            break;
        case 'HOST':
            if ($v_0) {
                $v_1 = '%!HOST!{0}!';
            }
            else {
                $v_1 = '%!HOST!';
            }
            break;
        case 'PII':
            if ($v_0) {
                $v_1 = '%!PII!{0}!';
            }
            else {
                $v_1 = '%!PII!';
            }
            break;
        case 'CCCP':
            if ($v_0) {
                $v_1 = '%!CCCP!{0}!';
            }
            else {
                $v_1 = '%!CCCP!';
            }
            break;
        case 'SDP':
            if ($v_0) {
                $v_1 = '%!SDP!{0}!';
            }
            else {
                $v_1 = '%!SDP!';
            }
            break;
        case 'IIS':
            if ($v_0) {
                $v_1 = '%!IIS!{0}!';
            }
            else {
                $v_1 = '%!IIS!';
            }
            break;
        case 'NOPII':
            $v_1 = '{0}';
            break;
    }
    if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_1)) {
        return String.format($v_1, Lync.Client.Common.StringHelper.replaceAll(info, '!', '!!'));
    }
    else {
        return 'INVALID_PII_MARKER';
    }
}


Lync.Client.Common.PIILogFormat = function Lync_Client_Common_PIILogFormat() {
}
Lync.Client.Common.PIILogFormat.prototype = {
    
    getFormat: function Lync_Client_Common_PIILogFormat$getFormat(formatType) {
        if (formatType === Lync.Client.Common.ICustomFormatter) {
            return this;
        }
        else {
            return null;
        }
    },
    
    format: function Lync_Client_Common_PIILogFormat$format(fmt, arg, formatProvider) {
        if (Lync.Client.Common.Utilities.isNullOrUndefined(arg)) {
            arg = 'null';
        }
        if (Lync.Client.Common.StringHelper.isNullOrEmpty(fmt)) {
            return arg.toString();
        }
        var $v_0 = fmt.toUpperCase();
        var $v_1 = arg.toString();
        return Lync.Client.Common.PIIUtil.mark($v_0, $v_1);
    }
}


function startProfilingLWA() {
    Lync.Client.Common.Profiler.startProfiling('generic');
}
function stopProfilingLWA() {
    Lync.Client.Common.Profiler.stopProfiling();
}


Lync.Client.Common.Profiler = function Lync_Client_Common_Profiler() {
}
Lync.Client.Common.Profiler.startProfiling = function Lync_Client_Common_Profiler$startProfiling(id) {
    var $v_0 = false;
    try {
        if (!Lync.Client.Common.Profiler.$B) {
            Lync.Client.Common.Profiler.$B = $get('lwa_profiler');
        }
        if (!Lync.Client.Common.Profiler.$B) {
            var $v_1 = document.createElement('div');
            $v_1.style.position = 'absolute';
            $v_1.style.width = '1px';
            $v_1.style.height = '1px';
            $v_1.style.left = '-100px';
            $v_1.style.top = '0px';
            $v_1.style.overflow = 'hidden';
            $v_1.style.visibility = 'hidden';
            $v_1.innerHTML = '<object id=\"lwa_profiler\" classid=\"CLSID:AF1EC3B0-4EEA-4167-90DF-61D880C30970\" width=\"100%\" height=\"100%\"></object>';
            document.body.appendChild($v_1);
            Lync.Client.Common.Profiler.$B = $v_1.firstChild;
        }
        if (Lync.Client.Common.Profiler.$B) {
            Lync.Client.Common.Profiler.$B.StartProfiling(id);
            $v_0 = true;
        }
    }
    catch ($$e_3) {
    }
    if (!$v_0) {
        Lync.Client.Common.UtilsLogProvider.get_$1().error('Unable to start profiling');
    }
}
Lync.Client.Common.Profiler.stopProfiling = function Lync_Client_Common_Profiler$stopProfiling() {
    var $v_0 = false;
    try {
        if (Lync.Client.Common.Profiler.$B) {
            Lync.Client.Common.Profiler.$B.StopProfiling();
            $v_0 = true;
        }
    }
    catch ($$e_1) {
    }
    if (!$v_0) {
        Lync.Client.Common.UtilsLogProvider.get_$1().error('Unable to stop profiling');
    }
}


Lync.Client.Common.StorageHelper = function Lync_Client_Common_StorageHelper() {
}
Lync.Client.Common.StorageHelper.get_$11 = function Lync_Client_Common_StorageHelper$get_$11() {
    try {
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(Lync.Client.Common.StorageHelper.get_$F())) {
            return true;
        }
    }
    catch ($$e_0) {
    }
    return false;
}
Lync.Client.Common.StorageHelper.get_$1J = function Lync_Client_Common_StorageHelper$get_$1J() {
    try {
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(Lync.Client.Common.StorageHelper.get_$d())) {
            return true;
        }
    }
    catch ($$e_0) {
    }
    return false;
}
Lync.Client.Common.StorageHelper.get_$F = function Lync_Client_Common_StorageHelper$get_$F() {
    return localStorage;
}
Lync.Client.Common.StorageHelper.get_$d = function Lync_Client_Common_StorageHelper$get_$d() {
    return sessionStorage;
}


Lync.Client.Common.BrowserStateHelper = function Lync_Client_Common_BrowserStateHelper() {
}
Lync.Client.Common.BrowserStateHelper.get_isStateSupported = function Lync_Client_Common_BrowserStateHelper$get_isStateSupported() {
    return Lync.Client.Common.BrowserStateHelper.get_isPermanentStateSupported() && Lync.Client.Common.BrowserStateHelper.get_isSessionStateSupported();
}
Lync.Client.Common.BrowserStateHelper.get_isPermanentStateSupported = function Lync_Client_Common_BrowserStateHelper$get_isPermanentStateSupported() {
    if (Lync.Client.Common.BrowserStateHelper.get_$S()) {
        return Lync.Client.Common.CookieHelper.get_areCookiesEnabled();
    }
    else {
        return Lync.Client.Common.StorageHelper.get_$11();
    }
}
Lync.Client.Common.BrowserStateHelper.get_isSessionStateSupported = function Lync_Client_Common_BrowserStateHelper$get_isSessionStateSupported() {
    if (Lync.Client.Common.BrowserStateHelper.get_$S()) {
        return Lync.Client.Common.CookieHelper.get_areCookiesEnabled();
    }
    else {
        return Lync.Client.Common.StorageHelper.get_$1J();
    }
}
Lync.Client.Common.BrowserStateHelper.get_$S = function Lync_Client_Common_BrowserStateHelper$get_$S() {
    var $v_0 = Lync.Client.Common.UserAgent.isShellApp() && Lync.Client.Common.UserAgent.isMac();
    var $v_1 = Lync.Client.Common.UserAgent.isSafari() || $v_0;
    return $v_1 && Lync.Client.Common.CookieHelper.get_areCookiesEnabled();
}
Lync.Client.Common.BrowserStateHelper.setItem = function Lync_Client_Common_BrowserStateHelper$setItem(key, data, permanent) {
    if (Lync.Client.Common.BrowserStateHelper.get_$S()) {
        Lync.Client.Common.CookieHelper.createCookie(key, data, permanent);
    }
    else {
        if (permanent) {
            Lync.Client.Common.StorageHelper.get_$F().setItem(key, data);
        }
        else {
            Lync.Client.Common.StorageHelper.get_$d().setItem(key, data);
        }
    }
}
Lync.Client.Common.BrowserStateHelper.removeItem = function Lync_Client_Common_BrowserStateHelper$removeItem(key, permanent) {
    if (Lync.Client.Common.BrowserStateHelper.get_$S()) {
        Lync.Client.Common.CookieHelper.eraseCookie(key);
    }
    else {
        if (permanent) {
            Lync.Client.Common.StorageHelper.get_$F().removeItem(key);
        }
        else {
            Lync.Client.Common.StorageHelper.get_$d().removeItem(key);
        }
    }
}
Lync.Client.Common.BrowserStateHelper.getItem = function Lync_Client_Common_BrowserStateHelper$getItem(key, permanent) {
    if (Lync.Client.Common.BrowserStateHelper.get_$S()) {
        return Lync.Client.Common.CookieHelper.readCookie(key);
    }
    else {
        if (permanent) {
            return Lync.Client.Common.StorageHelper.get_$F().getItem(key);
        }
        else {
            return Lync.Client.Common.StorageHelper.get_$d().getItem(key);
        }
    }
}


Lync.Client.Common.CookieHelper = function Lync_Client_Common_CookieHelper() {
}
Lync.Client.Common.CookieHelper.get_areCookiesEnabled = function Lync_Client_Common_CookieHelper$get_areCookiesEnabled() {
    return true === navigator.cookieEnabled;
}
Lync.Client.Common.CookieHelper.createCookie = function Lync_Client_Common_CookieHelper$createCookie(cookieName, cookieValue, permanent) {
    var $v_0;
    if (permanent) {
        $v_0 = ' expires=Fri, 31 Dec 9999 23:59:59 GMT;';
    }
    else {
        $v_0 = '';
    }
    var $v_1 = Lync.Client.Common.Base64.encode(cookieValue);
    document.cookie = cookieName + '=' + $v_1 + ';' + $v_0 + ' path=/';
}
Lync.Client.Common.CookieHelper.eraseCookie = function Lync_Client_Common_CookieHelper$eraseCookie(cookieName) {
    var $v_0 = ' expires=Thu, 01 Jan 1970 00:00:01 GMT;';
    document.cookie = cookieName + '=;' + $v_0 + ' path=/';
}
Lync.Client.Common.CookieHelper.readCookie = function Lync_Client_Common_CookieHelper$readCookie(cookieName) {
    var $v_0 = cookieName + '=';
    var $v_1 = document.cookie.split(';');
    for (var $v_2 = 0; $v_2 < $v_1.length; $v_2++) {
        var $v_3 = $v_1[$v_2];
        while ($v_3.charAt(0) === ' ') {
            $v_3 = $v_3.substring(1, $v_3.length);
        }
        if (!$v_3.indexOf($v_0)) {
            var $v_4 = $v_3.substring($v_0.length, $v_3.length);
            return Lync.Client.Common.Base64.decode($v_4);
        }
    }
    return null;
}


Lync.Client.Common.StringHelper = function Lync_Client_Common_StringHelper() {
}
Lync.Client.Common.StringHelper.isNullOrEmpty = function Lync_Client_Common_StringHelper$isNullOrEmpty(str) {
    if (str) {
        return false;
    }
    return true;
}
Lync.Client.Common.StringHelper.equals = function Lync_Client_Common_StringHelper$equals(str1, str2, opt) {
    return (!Lync.Client.Common.StringHelper.compare(str1, str2, opt));
}
Lync.Client.Common.StringHelper.compare = function Lync_Client_Common_StringHelper$compare(str1, str2, opt) {
    if ((!str1) && (str2)) {
        return -1;
    }
    else if ((str1) && (!str2)) {
        return 1;
    }
    else if ((!str1) && (!str2)) {
        return 0;
    }
    if (opt === 1) {
        return str1.toLowerCase().localeCompare(str2.toLowerCase());
    }
    else {
        return str1.localeCompare(str2);
    }
}
Lync.Client.Common.StringHelper.endsWith = function Lync_Client_Common_StringHelper$endsWith(str, endStr, opt) {
    if (opt === 1) {
        return str.toLowerCase().endsWith(endStr.toLowerCase());
    }
    else {
        return str.endsWith(endStr);
    }
}
Lync.Client.Common.StringHelper.startsWith = function Lync_Client_Common_StringHelper$startsWith(str, startStr, opt) {
    if (opt === 1) {
        return str.toLowerCase().startsWith(startStr.toLowerCase());
    }
    else {
        return str.startsWith(startStr);
    }
}
Lync.Client.Common.StringHelper.replaceAll = function Lync_Client_Common_StringHelper$replaceAll(input, from, to) {
    var $v_0 = input;
    var $v_1 = new RegExp(from, 'g');
    $v_0 = input.replace($v_1, to);
    return $v_0;
}
Lync.Client.Common.StringHelper.format = function Lync_Client_Common_StringHelper$format(provider, format) {
    var args = [];
    for (var $$pai_4 = 2; $$pai_4 < arguments.length; ++$$pai_4) {
        args[$$pai_4 - 2] = arguments[$$pai_4];
    }
    if (args && format) {
        var $v_0 = new Sys.StringBuilder();
        $v_0 = Lync.Client.Common.StringHelper.$18.apply(null, [ $v_0, provider, format ].concat(args));
        return $v_0.toString();
    }
    else {
        throw Error.argumentNull((!format) ? 'format' : 'args');
    }
}
Lync.Client.Common.StringHelper.isNullOrEmptyOnTrim = function Lync_Client_Common_StringHelper$isNullOrEmptyOnTrim(str) {
    return (Lync.Client.Common.Utilities.isNullOrUndefined(str) || str.trim() === '');
}
Lync.Client.Common.StringHelper.getJSEquivalentPropertyName = function Lync_Client_Common_StringHelper$getJSEquivalentPropertyName(propertyName) {
    var $v_0 = propertyName.substr(0, 1);
    $v_0 = $v_0.toLowerCase() + propertyName.substr(1);
    return $v_0;
}
Lync.Client.Common.StringHelper.$8 = function Lync_Client_Common_StringHelper$$8() {
}
Lync.Client.Common.StringHelper.$18 = function Lync_Client_Common_StringHelper$$18($p0, $p1, $p2) {
    var $p3 = [];
    for (var $$pai_M = 3; $$pai_M < arguments.length; ++$$pai_M) {
        $p3[$$pai_M - 3] = arguments[$$pai_M];
    }
    var $v_0 = $p0;
    var $v_1;
    var $v_2 = 0;
    var $v_3 = $p2.split('');
    var $v_4 = $p2.length;
    var $v_5 = '\u0000';
    var $v_6 = null;
    if ($p1) {
        $v_6 = $p1.getFormat(Lync.Client.Common.ICustomFormatter);
    }
    var $v_7 = 0;
    var $v_8 = false;
    var $v_9 = null;
    var $v_A = null;
    var $v_B = 0;
    while (true) {
        var $v_C = true;
        var $v_D = false;
        switch ($v_7) {
            case 0:
                $v_1 = $v_2;
                var $v_E = $v_2;
                while ($v_2 < $v_4) {
                    $v_5 = $p2.charAt($v_2);
                    $v_2++;
                    if ($v_5 === '}') {
                        if (($v_2 < $v_4) && ($p2.charAt($v_2) === '}')) {
                            $v_2++;
                        }
                        else {
                            Lync.Client.Common.StringHelper.$8();
                        }
                    }
                    if ($v_5 === '{') {
                        if (($v_2 < $v_4) && ($p2.charAt($v_2) === '{')) {
                            $v_2++;
                        }
                        else {
                            $v_2--;
                            break;
                        }
                    }
                    $v_3[$v_E++] = $v_5.toString();
                }
                if ($v_E > $v_1) {
                    $v_0 = Lync.Client.Common.StringHelper.$t($v_0, $v_3, $v_1, $v_E - $v_1);
                }
                if ($v_2 === $v_4) {
                    return $v_0;
                }
                $v_2++;
                if ((($v_2 === $v_4) || (($v_5 = $p2.charAt($v_2)) < '0')) || ($v_5 > '9')) {
                    Lync.Client.Common.StringHelper.$8();
                }
                var $v_F = 0;
                do {
                    $v_F = (($v_F * 10) + $v_5) - '0';
                    $v_2++;
                    if ($v_2 === $v_4) {
                        Lync.Client.Common.StringHelper.$8();
                    }
                    $v_5 = $p2.charAt($v_2);
                } while ((($v_5 >= '0') && ($v_5 <= '9')) && ($v_F < 1000000));
                if ($v_F >= $p3.length) {
                    throw Error.format('Format_IndexOutOfRange');
                }
                while (($v_2 < $v_4) && (($v_5 = $p2.charAt($v_2)) === ' ')) {
                    $v_2++;
                }
                $v_8 = false;
                $v_B = 0;
                if ($v_5 === ',') {
                    $v_2++;
                    while (($v_2 < $v_4) && ($p2.charAt($v_2) === ' ')) {
                        $v_2++;
                    }
                    if ($v_2 === $v_4) {
                        Lync.Client.Common.StringHelper.$8();
                    }
                    $v_5 = $p2.charAt($v_2);
                    if ($v_5 === '-') {
                        $v_8 = true;
                        $v_2++;
                        if ($v_2 === $v_4) {
                            Lync.Client.Common.StringHelper.$8();
                        }
                        $v_5 = $p2.charAt($v_2);
                    }
                    if (($v_5 < '0') || ($v_5 > '9')) {
                        Lync.Client.Common.StringHelper.$8();
                    }
                    do {
                        $v_B = (($v_B * 10) + $v_5) - '0';
                        $v_2++;
                        if ($v_2 === $v_4) {
                            Lync.Client.Common.StringHelper.$8();
                        }
                        $v_5 = $p2.charAt($v_2);
                    } while ((($v_5 >= '0') && ($v_5 <= '9')) && ($v_B < 1000000));
                }
                while (($v_2 < $v_4) && (($v_5 = $p2.charAt($v_2)) === ' ')) {
                    $v_2++;
                }
                $v_9 = $p3[$v_F];
                $v_A = null;
                if ($v_5 === ':') {
                    $v_2++;
                    $v_1 = $v_2;
                    $v_E = $v_2;
                    while (true) {
                        if ($v_2 === $v_4) {
                            Lync.Client.Common.StringHelper.$8();
                        }
                        $v_5 = $p2.charAt($v_2);
                        $v_2++;
                        switch ($v_5) {
                            case '{':
                                if (($v_2 < $v_4) && ($p2.charAt($v_2) === '{')) {
                                    $v_2++;
                                }
                                else {
                                    Lync.Client.Common.StringHelper.$8();
                                }
                                break;
                            case '}':
                                if (($v_2 < $v_4) && ($p2.charAt($v_2) === '}')) {
                                    $v_2++;
                                }
                                else {
                                    $v_2--;
                                    if ($v_E > $v_1) {
                                        $v_A = Lync.Client.Common.StringHelper.$t(new Sys.StringBuilder(), $v_3, $v_1, $v_E - $v_1).toString();
                                    }
                                    $v_D = true;
                                    $v_C = false;
                                    $v_7 = 1;
                                }
                                break;
                        }
                        if ($v_D) {
                            break;
                        }
                        $v_3[$v_E++] = $v_5.toString();
                    }
                }
                if (!$v_D) {
                    $v_D = true;
                    $v_C = false;
                    $v_7 = 1;
                }
                break;
            case 1:
                if ($v_5 !== '}') {
                    Lync.Client.Common.StringHelper.$8();
                }
                $v_2++;
                var $v_G = null;
                if ($v_6) {
                    $v_G = $v_6.format($v_A, $v_9, $p1);
                }
                if (!$v_G) {
                    if (Lync.Client.Common.IFormattable.isInstanceOfType($v_9)) {
                        $v_G = ($v_9).toString($v_A, $p1);
                    }
                    else if ($v_9) {
                        $v_G = $v_9.toString();
                    }
                }
                if (!$v_G) {
                    $v_G = Lync.Client.Common.StringHelper.empty;
                }
                var $v_H = $v_B - $v_G.length;
                if (!$v_8 && ($v_H > 0)) {
                    $v_0 = Lync.Client.Common.StringHelper.$s($v_0, ' ', $v_H);
                }
                $v_0.append($v_G);
                if ($v_8 && ($v_H > 0)) {
                    $v_0 = Lync.Client.Common.StringHelper.$s($v_0, ' ', $v_H);
                }
                $v_D = true;
                $v_C = false;
                $v_7 = 0;
                break;
        }
        if ($v_C) {
            break;
        }
    }
    return $v_0;
}
Lync.Client.Common.StringHelper.$s = function Lync_Client_Common_StringHelper$$s($p0, $p1, $p2) {
    var $v_0 = $p0;
    if ($p2) {
        if ($p2 < 0) {
            throw Error.argumentOutOfRange('repeatCount', 'ArgumentOutOfRange_NegativeCount');
        }
        for (var $v_1 = 0; $v_1 < $p2; $v_1++) {
            $v_0.append($p1);
        }
    }
    return $v_0;
}
Lync.Client.Common.StringHelper.$t = function Lync_Client_Common_StringHelper$$t($p0, $p1, $p2, $p3) {
    var $v_0 = $p0;
    if (!$p1) {
        if (($p2) || ($p3)) {
            throw Error.argumentNull('charArr');
        }
        return $v_0;
    }
    if ($p3) {
        if ($p2 < 0) {
            throw Error.argumentOutOfRange('start', 'ArgumentOutOfRange_GenericPositive');
        }
        if ($p3 < 0) {
            throw Error.argumentOutOfRange('count', 'ArgumentOutOfRange_GenericPositive');
        }
        if ($p3 > ($p1.length - $p2)) {
            throw Error.argumentOutOfRange('count', 'ArgumentOutOfRange_Index');
        }
        for (var $v_1 = $p2, $v_2 = 0; $v_1 < $p1.length && $v_2 < $p3; $v_1++, $v_2++) {
            $v_0.append($p1[$v_1]);
        }
    }
    return $v_0;
}


Lync.Client.Common.TelemetryEventProperties = function Lync_Client_Common_TelemetryEventProperties() {
}


Lync.Client.Common.ElapsedEventArgs = function Lync_Client_Common_ElapsedEventArgs(start) {
    Lync.Client.Common.ElapsedEventArgs.initializeBase(this);
    this.$l_1 = new Date();
    this.$u_1 = this.$l_1.getTime() - start.getTime();
}
Lync.Client.Common.ElapsedEventArgs.prototype = {
    $l_1: null,
    $u_1: 0,
    
    get_currentTime: function Lync_Client_Common_ElapsedEventArgs$get_currentTime() {
        return this.$l_1;
    },
    
    get_elapsedTime: function Lync_Client_Common_ElapsedEventArgs$get_elapsedTime() {
        return this.$u_1;
    }
}


Lync.Client.Common.Timer = function Lync_Client_Common_Timer(_interval) {
    this.$$d_$1O_1 = Function.createDelegate(this, this.$1O_1);
    Lync.Client.Common.Timer.initializeBase(this);
    if (!(_interval) || undefined === _interval) {
        _interval = 1000;
    }
    this.$a_1 = _interval;
    this.$k_1 = this.$$d_$1O_1;
}
Lync.Client.Common.Timer.prototype = {
    $a_1: 0,
    $f_1: 0,
    $m_1: null,
    $G_1: false,
    $k_1: null,
    
    add_elapsed: function Lync_Client_Common_Timer$add_elapsed(value) {
        this.$E_0.addHandler('Elapsed', value);
    },
    remove_elapsed: function Lync_Client_Common_Timer$remove_elapsed(value) {
        this.$E_0.removeHandler('Elapsed', value);
    },
    
    setInterval: function Lync_Client_Common_Timer$setInterval(_interval) {
        this.$a_1 = _interval;
    },
    
    start: function Lync_Client_Common_Timer$start() {
        if (!this.$G_1) {
            this.$m_1 = new Date();
            this.$f_1 = window.setInterval(this.$k_1, this.$a_1);
            this.$G_1 = true;
        }
    },
    
    $1O_1: function Lync_Client_Common_Timer$$1O_1() {
        this.fireEvent('Elapsed', new Lync.Client.Common.ElapsedEventArgs(this.$m_1));
    },
    
    stop: function Lync_Client_Common_Timer$stop() {
        if (this.$G_1) {
            window.clearInterval(this.$f_1);
            this.$G_1 = false;
        }
    },
    
    isRunning: function Lync_Client_Common_Timer$isRunning() {
        return this.$G_1;
    },
    
    restart: function Lync_Client_Common_Timer$restart() {
        if (this.$G_1) {
            window.clearInterval(this.$f_1);
        }
        this.$m_1 = new Date();
        this.$f_1 = window.setInterval(this.$k_1, this.$a_1);
        this.$G_1 = true;
    }
}


Lync.Client.Common.UserAgent = function Lync_Client_Common_UserAgent() {
}
Lync.Client.Common.UserAgent.$0 = function Lync_Client_Common_UserAgent$$0() {
    if (!Lync.Client.Common.UserAgent.$h) {
        Lync.Client.Common.UserAgent.$1G();
        Lync.Client.Common.UserAgent.$1H();
        Lync.Client.Common.UserAgent.$h = true;
    }
}
Lync.Client.Common.UserAgent.isIE = function Lync_Client_Common_UserAgent$isIE() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$3 === 2;
}
Lync.Client.Common.UserAgent.isIE7 = function Lync_Client_Common_UserAgent$isIE7() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.isIE() && Lync.Client.Common.UserAgent.$2.isEqualTo(Lync.Client.Common.UserAgent.iE7);
}
Lync.Client.Common.UserAgent.isIE8 = function Lync_Client_Common_UserAgent$isIE8() {
    Lync.Client.Common.UserAgent.$0();
    if (Lync.Client.Common.UserAgent.isIE()) {
        if (Lync.Client.Common.UserAgent.$2.isEqualTo(Lync.Client.Common.UserAgent.iE8)) {
            return true;
        }
        if (Lync.Client.Common.UserAgent.$2.isEqualTo(Lync.Client.Common.UserAgent.iE7) && Lync.Client.Common.UserAgent.$I.versionDetails[0] === 4 && !Lync.Client.Common.UserAgent.$I.versionDetails[1]) {
            return true;
        }
    }
    return false;
}
Lync.Client.Common.UserAgent.isIE9 = function Lync_Client_Common_UserAgent$isIE9() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.isIE() && Lync.Client.Common.UserAgent.$2.isEqualTo(Lync.Client.Common.UserAgent.iE9);
}
Lync.Client.Common.UserAgent.isIE10 = function Lync_Client_Common_UserAgent$isIE10() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.isIE() && Lync.Client.Common.UserAgent.$2.isEqualTo(Lync.Client.Common.UserAgent.iE10);
}
Lync.Client.Common.UserAgent.isChrome = function Lync_Client_Common_UserAgent$isChrome() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$3 === 6;
}
Lync.Client.Common.UserAgent.isEdge = function Lync_Client_Common_UserAgent$isEdge() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$3 === 7;
}
Lync.Client.Common.UserAgent.supportsNpapi = function Lync_Client_Common_UserAgent$supportsNpapi() {
    Lync.Client.Common.UserAgent.$0();
    if (Lync.Client.Common.UserAgent.isMac()) {
        return Lync.Client.Common.UserAgent.isShellApp();
    }
    return (!Lync.Client.Common.UserAgent.isChrome() || (Lync.Client.Common.UserAgent.$2.isLessThan(Lync.Client.Common.UserAgent.lastChromeVersionSupportingNpapi) && !Lync.Client.Common.UserAgent.isMac())) && !Lync.Client.Common.UserAgent.isEdge();
}
Lync.Client.Common.UserAgent.isFireFox = function Lync_Client_Common_UserAgent$isFireFox() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$3 === 3;
}
Lync.Client.Common.UserAgent.isSafari = function Lync_Client_Common_UserAgent$isSafari() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$3 === 4;
}
Lync.Client.Common.UserAgent.getBrowserVersion = function Lync_Client_Common_UserAgent$getBrowserVersion() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$2;
}
Lync.Client.Common.UserAgent.getTridentVersion = function Lync_Client_Common_UserAgent$getTridentVersion() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$I;
}
Lync.Client.Common.UserAgent.getBrowserType = function Lync_Client_Common_UserAgent$getBrowserType() {
    return Lync.Client.Common.UserAgent.$3;
}
Lync.Client.Common.UserAgent.getOSPlatform = function Lync_Client_Common_UserAgent$getOSPlatform() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$5;
}
Lync.Client.Common.UserAgent.isWin = function Lync_Client_Common_UserAgent$isWin() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$5 === 2;
}
Lync.Client.Common.UserAgent.isWin2k = function Lync_Client_Common_UserAgent$isWin2k() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$4.isEqualTo(Lync.Client.Common.UserAgent.win2k);
}
Lync.Client.Common.UserAgent.isWinXP = function Lync_Client_Common_UserAgent$isWinXP() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$4.isEqualTo(Lync.Client.Common.UserAgent.winXP);
}
Lync.Client.Common.UserAgent.isWinXPx64Or2k3 = function Lync_Client_Common_UserAgent$isWinXPx64Or2k3() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$4.isEqualTo(Lync.Client.Common.UserAgent.winXPx64Or2k3);
}
Lync.Client.Common.UserAgent.isWinVistaOr2k8 = function Lync_Client_Common_UserAgent$isWinVistaOr2k8() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$4.isEqualTo(Lync.Client.Common.UserAgent.winVistaOr2k8);
}
Lync.Client.Common.UserAgent.isWin7Or2k8R2 = function Lync_Client_Common_UserAgent$isWin7Or2k8R2() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$4.isEqualTo(Lync.Client.Common.UserAgent.win7Or2k8R2);
}
Lync.Client.Common.UserAgent.isWin8 = function Lync_Client_Common_UserAgent$isWin8() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$4.isEqualTo(Lync.Client.Common.UserAgent.win8);
}
Lync.Client.Common.UserAgent.isMac = function Lync_Client_Common_UserAgent$isMac() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$5 === 4;
}
Lync.Client.Common.UserAgent.isLinux = function Lync_Client_Common_UserAgent$isLinux() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$5 === 6;
}
Lync.Client.Common.UserAgent.getOSVersion = function Lync_Client_Common_UserAgent$getOSVersion() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$4;
}
Lync.Client.Common.UserAgent.isARM = function Lync_Client_Common_UserAgent$isARM() {
    var $v_0 = window.navigator.userAgent.toLowerCase();
    return $v_0.indexOf('arm') !== -1;
}
Lync.Client.Common.UserAgent.is64Bit = function Lync_Client_Common_UserAgent$is64Bit() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$9 === 3;
}
Lync.Client.Common.UserAgent.is32Bit = function Lync_Client_Common_UserAgent$is32Bit() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$9 === 1;
}
Lync.Client.Common.UserAgent.isWow64Bit = function Lync_Client_Common_UserAgent$isWow64Bit() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$9 === 2;
}
Lync.Client.Common.UserAgent.isShellApp = function Lync_Client_Common_UserAgent$isShellApp() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$W;
}
Lync.Client.Common.UserAgent.getOSBrowserBittiness = function Lync_Client_Common_UserAgent$getOSBrowserBittiness() {
    Lync.Client.Common.UserAgent.$0();
    return Lync.Client.Common.UserAgent.$9;
}
Lync.Client.Common.UserAgent.$1G = function Lync_Client_Common_UserAgent$$1G() {
    var $v_0 = window.navigator.userAgent.toLowerCase();
    var $v_1 = null;
    Lync.Client.Common.UserAgent.$3 = 0;
    Lync.Client.Common.UserAgent.$2 = new Lync.Client.Common.VersionInfo('0.0');
    Lync.Client.Common.UserAgent.$I = new Lync.Client.Common.VersionInfo('0.0');
    Lync.Client.Common.UserAgent.$W = false;
    $v_1 = $v_0.match(new RegExp('sfbshell'));
    if ($v_1) {
        Lync.Client.Common.UserAgent.$W = true;
    }
    $v_1 = $v_0.match(new RegExp('msie (\\d+\\.\\d+)'));
    if (!$v_1 && $v_0.match(new RegExp('trident\\/\\d+\\.\\d+'))) {
        $v_1 = $v_0.match(new RegExp('\\brv:(\\d+\\.\\d+)'));
    }
    if ($v_1) {
        Lync.Client.Common.UserAgent.$3 = 2;
        Lync.Client.Common.UserAgent.$2 = new Lync.Client.Common.VersionInfo($v_1[1]);
        $v_1 = $v_0.match(new RegExp('trident\\/(\\d+\\.\\d+)'));
        if ($v_1) {
            Lync.Client.Common.UserAgent.$I = new Lync.Client.Common.VersionInfo($v_1[1]);
        }
        return;
    }
    $v_1 = $v_0.match(new RegExp('edge[\\/\\s](\\d+\\.\\d+)'));
    if ($v_1) {
        Lync.Client.Common.UserAgent.$3 = 7;
        Lync.Client.Common.UserAgent.$2 = new Lync.Client.Common.VersionInfo($v_1[1]);
        return;
    }
    $v_1 = $v_0.match(new RegExp('firefox[\\/\\s](\\d+\\.\\d+)'));
    if ($v_1) {
        Lync.Client.Common.UserAgent.$3 = 3;
        Lync.Client.Common.UserAgent.$2 = new Lync.Client.Common.VersionInfo($v_1[1]);
        return;
    }
    $v_1 = $v_0.match(new RegExp('chrome[\\/\\s](\\d+\\.\\d+)'));
    if ($v_1) {
        Lync.Client.Common.UserAgent.$3 = 6;
        Lync.Client.Common.UserAgent.$2 = new Lync.Client.Common.VersionInfo($v_1[1]);
        return;
    }
    $v_1 = $v_0.match(new RegExp('safari'));
    if ($v_1) {
        if ($v_0.indexOf('android') < 0) {
            Lync.Client.Common.UserAgent.$3 = 4;
            $v_1 = $v_0.match(new RegExp('version[\\/\\s](\\d+\\.\\d+)'));
            if ($v_1) {
                Lync.Client.Common.UserAgent.$2 = new Lync.Client.Common.VersionInfo($v_1[1]);
            }
        }
    }
    $v_1 = $v_0.match(new RegExp('applewebkit[\\/\\s](\\d+\\.\\d+)'));
    if ($v_1) {
        Lync.Client.Common.UserAgent.$3 = 4;
        Lync.Client.Common.UserAgent.$2 = new Lync.Client.Common.VersionInfo($v_1[1]);
        return;
    }
}
Lync.Client.Common.UserAgent.$1H = function Lync_Client_Common_UserAgent$$1H() {
    var $v_0 = window.navigator.userAgent.toLowerCase();
    var $v_1 = window.navigator.platform.toLowerCase();
    Lync.Client.Common.UserAgent.$5 = 0;
    Lync.Client.Common.UserAgent.$4 = new Lync.Client.Common.VersionInfo('0.0');
    Lync.Client.Common.UserAgent.$K = Lync.Client.Common.StringHelper.empty;
    Lync.Client.Common.UserAgent.$9 = 0;
    if ($v_0.indexOf('windows nt') >= 0 || $v_0.indexOf('wow64') >= 0 || $v_0.indexOf('win64') >= 0 || $v_0.indexOf('win32') >= 0 || $v_1.indexOf('win64') >= 0 || $v_1.indexOf('win32') >= 0) {
        Lync.Client.Common.UserAgent.$5 = 2;
        var $v_2 = $v_0.match(new RegExp('windows nt (\\d+\\.\\d+)'));
        if ($v_2) {
            Lync.Client.Common.UserAgent.$4 = new Lync.Client.Common.VersionInfo($v_2[1]);
        }
        if ($v_1.indexOf('win32') >= 0 && ($v_0.indexOf('wow64') >= 0 || $v_0.indexOf('win64') >= 0)) {
            Lync.Client.Common.UserAgent.$9 = 2;
        }
        else if ($v_1.indexOf('win64') >= 0 || $v_0.indexOf('win64') >= 0) {
            Lync.Client.Common.UserAgent.$9 = 3;
        }
        else if ($v_1.indexOf('win32') >= 0 || $v_0.indexOf('win32') >= 0) {
            Lync.Client.Common.UserAgent.$9 = 1;
        }
        if ($v_0.indexOf('win64; x64') >= 0) {
            Lync.Client.Common.UserAgent.$K = 'amd64';
        }
        else if ($v_0.indexOf('win64; ia64') >= 0) {
            Lync.Client.Common.UserAgent.$K = 'ia64';
        }
        else {
            Lync.Client.Common.UserAgent.$K = 'x86';
        }
    }
    else if ($v_0.indexOf('macintosh') >= 0 || $v_0.indexOf('ppc') >= 0) {
        Lync.Client.Common.UserAgent.$5 = 4;
        var $v_3 = $v_0.match(new RegExp('intel mac os x (\\d+\\.\\d+\\.\\d+)'));
        if ($v_3) {
            Lync.Client.Common.UserAgent.$4 = new Lync.Client.Common.VersionInfo($v_3[1]);
        }
        else if (($v_3 = $v_0.match(new RegExp('intel mac os x (\\d+\\.\\d+)')))) {
            Lync.Client.Common.UserAgent.$4 = new Lync.Client.Common.VersionInfo($v_3[1]);
        }
        else if (($v_3 = $v_0.match(new RegExp('intel mac os x (\\d+\\_\\d+\\_\\d+)')))) {
            Lync.Client.Common.UserAgent.$4 = new Lync.Client.Common.VersionInfo(Lync.Client.Common.StringHelper.replaceAll($v_3[1], '_', '.'));
        }
        else if (($v_3 = $v_0.match(new RegExp('intel mac os x (\\d+\\_\\d+)')))) {
            Lync.Client.Common.UserAgent.$4 = new Lync.Client.Common.VersionInfo(Lync.Client.Common.StringHelper.replaceAll($v_3[1], '_', '.'));
        }
    }
    else if ($v_0.indexOf('iphone') >= 0 || $v_0.indexOf('ipad') >= 0 || $v_0.indexOf('ipod') >= 0) {
        Lync.Client.Common.UserAgent.$5 = 7;
    }
    else if ($v_0.indexOf('windows ce') !== -1) {
        Lync.Client.Common.UserAgent.$5 = 3;
    }
    else if ($v_0.indexOf('sunos') !== -1) {
        Lync.Client.Common.UserAgent.$5 = 5;
    }
    else if ($v_0.indexOf('linux') !== -1) {
        Lync.Client.Common.UserAgent.$5 = 6;
    }
}


Lync.Client.Common.Utilities = function Lync_Client_Common_Utilities() {
}
Lync.Client.Common.Utilities.isNullOrUndefined = function Lync_Client_Common_Utilities$isNullOrUndefined(value) {
    var $v_0 = typeof(value);
    return (($v_0 === 'undefined') || (($v_0 === 'object') && (null === value)));
}
Lync.Client.Common.Utilities.removeCIDHeader = function Lync_Client_Common_Utilities$removeCIDHeader(inString) {
    var $v_0 = inString;
    var $v_1 = $v_0.toLowerCase().indexOf('cid:');
    if ($v_1 !== -1) {
        var $v_2 = $v_1 + 4;
        if ($v_2 + 1 < inString.length) {
            $v_0 = $v_0.substr($v_2);
        }
    }
    return $v_0;
}
Lync.Client.Common.Utilities.getRpsCookieName = function Lync_Client_Common_Utilities$getRpsCookieName(originalUri) {
    if (Lync.Client.Common.StringHelper.isNullOrEmpty(Lync.Client.Common.Utilities.$C)) {
        Lync.Client.Common.Utilities.$C = Lync.Client.Common.Utilities.getQueryStringValueFromUrl(originalUri, 'AuthCookieName', '');
        if (Lync.Client.Common.StringHelper.isNullOrEmpty(Lync.Client.Common.Utilities.$C)) {
            if (Lync.Client.Common.StorageHelper.get_$11()) {
                try {
                    Lync.Client.Common.Utilities.$C = Lync.Client.Common.StorageHelper.get_$F().getItem('LWARpsCookieName');
                }
                catch ($v_0) {
                    Lync.Client.Common.UtilsLogProvider.get_$1().warn('Failed to read RpsCookieName from Local Storage, Exception: {0}', $v_0);
                }
            }
            if (Lync.Client.Common.StringHelper.isNullOrEmpty(Lync.Client.Common.Utilities.$C)) {
                Lync.Client.Common.UtilsLogProvider.get_$1().warn('No AuthCookieName in URL! Assuming RtcAuth.');
                Lync.Client.Common.Utilities.$C = 'RtcAuth';
            }
        }
        else {
            try {
                Lync.Client.Common.StorageHelper.get_$F().setItem('LWARpsCookieName', Lync.Client.Common.Utilities.$C);
            }
            catch ($v_1) {
                Lync.Client.Common.UtilsLogProvider.get_$1().error('Failed to write RpsCookieName to Local Storage, Exception: {0}', $v_1);
            }
        }
    }
    return Lync.Client.Common.Utilities.$C;
}
Lync.Client.Common.Utilities.clearRpsCookieNameFromStorage = function Lync_Client_Common_Utilities$clearRpsCookieNameFromStorage() {
    try {
        Lync.Client.Common.StorageHelper.get_$F().removeItem('LWARpsCookieName');
    }
    catch ($v_0) {
        Lync.Client.Common.UtilsLogProvider.get_$1().warn('Failed to remove RpsCookieName from Local Storage, Exception: {0}', $v_0);
    }
}
Lync.Client.Common.Utilities.checkCookieExists = function Lync_Client_Common_Utilities$checkCookieExists(cookieName) {
    var $v_0 = readCookie(cookieName);
    return !(Lync.Client.Common.Utilities.isNullOrUndefined($v_0));
}
Lync.Client.Common.Utilities.generateCID = function Lync_Client_Common_Utilities$generateCID() {
    return 'cid:' + Lync.Client.Common.Utilities.getGUID();
}
Lync.Client.Common.Utilities.getGUID = function Lync_Client_Common_Utilities$getGUID() {
    var $v_0 = new Array(36);
    for (var $v_1 = 0; $v_1 < 36; $v_1++) {
        if (($v_1 === 8) || ($v_1 === 13) || ($v_1 === 18) || ($v_1 === 23)) {
            $v_0[$v_1] = '-';
        }
        else if ($v_1 === 14) {
            $v_0[14] = '4';
        }
        else if ($v_1 === 19) {
            $v_0[$v_1] = ((Math.floor(Math.random() * 16) & 3) | 8).toString(16).toUpperCase();
        }
        else {
            $v_0[$v_1] = Math.floor(Math.random() * 16).toString(16).toUpperCase();
        }
    }
    return $v_0.join('');
}
Lync.Client.Common.Utilities.serializeXMLNode = function Lync_Client_Common_Utilities$serializeXMLNode(node) {
    var $v_0 = Lync.Client.Common.StringHelper.empty;
    if (!Lync.Client.Common.Utilities.isNullOrUndefined(node)) {
        if (node.nodeType === 1) {
            $v_0 += '<' + node.nodeName;
            for (var $v_1 = 0; $v_1 < node.attributes.length; $v_1++) {
                var $v_2 = node.attributes.item($v_1);
                $v_0 += ' ' + $v_2.nodeName + '=\"' + $v_2.nodeValue + '\"';
            }
            if (!node.childNodes.length) {
                $v_0 += '/>';
            }
            else {
                $v_0 += '>';
                for (var $v_3 = 0; $v_3 < node.childNodes.length; $v_3++) {
                    var $v_4 = node.childNodes[$v_3];
                    $v_0 += Lync.Client.Common.Utilities.serializeXMLNode($v_4);
                }
                $v_0 += '</' + node.nodeName + '>';
            }
        }
        else if (node.nodeType === 3) {
            $v_0 += node.nodeValue;
        }
        else {
            throw Error.invalidOperation('Invalid node type in xml serializer - ' + XMLNodeType.toString(node.nodeType));
        }
    }
    return $v_0;
}
Lync.Client.Common.Utilities.refreshGeckoPlugin = function Lync_Client_Common_Utilities$refreshGeckoPlugin() {
    eval('navigator.plugins.refresh(false)');
}
Lync.Client.Common.Utilities.getHostFromURL = function Lync_Client_Common_Utilities$getHostFromURL(url) {
    var $v_0 = url.indexOf('//');
    var $v_1 = url.indexOf('/', $v_0 + 2);
    var $v_2 = (($v_1 >= 0) ? url.substring(0, $v_1) : url);
    return $v_2;
}
Lync.Client.Common.Utilities.objectImplementsInterfaceByName = function Lync_Client_Common_Utilities$objectImplementsInterfaceByName(obj, interfaceType) {
    if (!Lync.Client.Common.Utilities.isNullOrUndefined(obj) && !Lync.Client.Common.Utilities.isNullOrUndefined(interfaceType)) {
        var $v_0 = (Object.getType(obj)).getInterfaces();
        var $v_1 = interfaceType.getName();
        for (var $v_2 = 0; $v_2 < $v_0.length; $v_2++) {
            if (Lync.Client.Common.StringHelper.equals($v_0[$v_2].getName(), $v_1, 1)) {
                return true;
            }
        }
    }
    return false;
}
Lync.Client.Common.Utilities.isActiveXFilteringEnabled = function Lync_Client_Common_Utilities$isActiveXFilteringEnabled() {
    try {
        return Lync.Client.Common.UserAgent.isIE() && Boolean(window.external && external.msActiveXFilteringEnabled());
    }
    catch ($$e_0) {
        return false;
    }
}
Lync.Client.Common.Utilities.isActiveXEnabled = function Lync_Client_Common_Utilities$isActiveXEnabled() {
    try {
        return !Lync.Client.Common.UserAgent.isIE() || Boolean(new ActiveXObject('htmlfile'));
    }
    catch ($$e_0) {
        return false;
    }
}
Lync.Client.Common.Utilities.getQueryStringValueFromUrl = function Lync_Client_Common_Utilities$getQueryStringValueFromUrl(url, paramName, defaultValue) {
    var $v_0 = defaultValue;
    if (url.indexOf('?' + paramName + '=') !== -1 || url.indexOf('&' + paramName + '=') !== -1) {
        var $v_1 = '';
        if (url.indexOf('?' + paramName + '=') === -1) {
            $v_1 = '&' + paramName + '=';
        }
        else {
            $v_1 = '?' + paramName + '=';
        }
        var $v_2 = '';
        var $v_3 = url.indexOf($v_1);
        for (var $v_4 = ($v_3 + $v_1.length); $v_4 < url.length; $v_4++) {
            if (url.charAt($v_4) === '&') {
                break;
            }
            else {
                $v_2 += url.charAt($v_4);
            }
        }
        $v_0 = $v_2;
    }
    return $v_0;
}
Lync.Client.Common.Utilities.updateUriWithQueryString = function Lync_Client_Common_Utilities$updateUriWithQueryString(url, paramName, value) {
    var $v_0 = '';
    if (url.indexOf('?') === -1) {
        $v_0 = (url + '?' + paramName + '=' + value);
    }
    else {
        if (url.indexOf('?' + paramName + '=') === -1 && url.indexOf('&' + paramName + '=') === -1) {
            $v_0 = (url + '&' + paramName + '=' + value);
        }
        else {
            var $v_1 = '';
            if (url.indexOf('?' + paramName + '=') === -1) {
                $v_1 = '&' + paramName + '=';
            }
            else {
                $v_1 = '?' + paramName + '=';
            }
            var $v_2 = '';
            var $v_3 = url.indexOf($v_1);
            for (var $v_4 = ($v_3 + $v_1.length); $v_4 < url.length; $v_4++) {
                if (url.charAt($v_4) === '&') {
                    break;
                }
                else {
                    $v_2 += url.charAt($v_4);
                }
            }
            $v_0 = url.replace($v_1 + $v_2, $v_1 + value);
        }
    }
    return $v_0;
}
Lync.Client.Common.Utilities.updateUriWithQueryParams = function Lync_Client_Common_Utilities$updateUriWithQueryParams(url, queryParams) {
    if (Lync.Client.Common.StringHelper.isNullOrEmpty(url)) {
        return null;
    }
    if (url.endsWith('?') || url.endsWith('&')) {
        url = url.substring(0, url.length - 1);
    }
    var $v_0 = new Sys.StringBuilder(url);
    if (!Lync.Client.Common.Utilities.isNullOrUndefined(queryParams) && queryParams.length > 0) {
        var $v_1 = url.indexOf('?');
        if ($v_1 < 0) {
            $v_0.append('?');
        }
        else if (url.length > $v_1 + 1) {
            $v_0.append('&');
        }
        $v_0.append(queryParams[0]);
        for (var $v_2 = 1; $v_2 < queryParams.length; ++$v_2) {
            $v_0.append('&');
            $v_0.append(queryParams[$v_2]);
        }
    }
    return $v_0.toString();
}
Lync.Client.Common.Utilities.getUTCDate = function Lync_Client_Common_Utilities$getUTCDate() {
    var $v_0 = new Date();
    var $v_1 = $v_0.getTime() + $v_0.getTimezoneOffset() * 60 * 1000;
    var $v_2 = new Date();
    $v_2.setTime($v_1);
    return $v_2;
}
Lync.Client.Common.Utilities.insideFrame = function Lync_Client_Common_Utilities$insideFrame() {
    try {
        return window.self !== window.top;
    }
    catch ($$e_0) {
        return true;
    }
}


Lync.Client.Common.VersionInfo = function Lync_Client_Common_VersionInfo(version) {
    this.versionString = version;
    this.versionDetails = new Array(4);
    for (var $v_1 = 0; $v_1 < this.versionDetails.length; $v_1++) {
        this.versionDetails[$v_1] = 0;
    }
    var $v_0 = version.split('.');
    for (var $v_2 = 0; $v_2 < $v_0.length && $v_2 < this.versionDetails.length; $v_2++) {
        try {
            this.versionDetails[$v_2] = parseInt($v_0[$v_2]);
        }
        catch ($$e_4) {
        }
    }
}
Lync.Client.Common.VersionInfo.prototype = {
    versionDetails: null,
    versionString: null,
    
    isLessThan: function Lync_Client_Common_VersionInfo$isLessThan(v2) {
        for (var $v_0 = 0; $v_0 < this.versionDetails.length; $v_0++) {
            if (this.versionDetails[$v_0] < v2.versionDetails[$v_0]) {
                return true;
            }
        }
        return false;
    },
    
    isEqualTo: function Lync_Client_Common_VersionInfo$isEqualTo(v2) {
        for (var $v_0 = 0; $v_0 < this.versionDetails.length; $v_0++) {
            if (this.versionDetails[$v_0] !== v2.versionDetails[$v_0]) {
                return false;
            }
        }
        return true;
    },
    
    toString: function Lync_Client_Common_VersionInfo$toString() {
        var $v_0 = '' + this.versionDetails[0];
        for (var $v_1 = 1; $v_1 < this.versionDetails.length; $v_1++) {
            $v_0 += '.' + this.versionDetails[$v_1];
        }
        return $v_0;
    }
}


Lync.Client.Common.WindowEventHandler = function Lync_Client_Common_WindowEventHandler() {
    this.$$d_$1M_1 = Function.createDelegate(this, this.$1M_1);
    this.$$d_$1L_1 = Function.createDelegate(this, this.$1L_1);
    Lync.Client.Common.WindowEventHandler.initializeBase(this);
    this._frame = null;
    this._frameLoadedHandler = this.$$d_$1L_1;
    this._frameUnLoadedHandler = this.$$d_$1M_1;
    this.$L_1 = null;
    this.$Q_1 = null;
}
Lync.Client.Common.WindowEventHandler.prototype = {
    _frame: null,
    _frameLoadedHandler: null,
    _frameUnLoadedHandler: null,
    $L_1: null,
    $Q_1: null,
    
    attach: function Lync_Client_Common_WindowEventHandler$attach(frame, loadCallback, unloadCallback) {
        this.detach();
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(frame)) {
            this._frame = frame;
            this.$L_1 = loadCallback;
            this.$Q_1 = unloadCallback;
             if (typeof this._frame.addEventListener != 'undefined') { this._frame.addEventListener('load', this._frameLoadedHandler, false); } else if (typeof this._frame.attachEvent != 'undefined') { this._frame.attachEvent('onload', this._frameLoadedHandler); };
             if (typeof this._frame.addEventListener != 'undefined') { this._frame.addEventListener('unload', this._frameUnLoadedHandler, false); } else if (typeof this._frame.attachEvent != 'undefined') { this._frame.attachEvent('onunload', this._frameUnLoadedHandler); };
        }
    },
    
    detach: function Lync_Client_Common_WindowEventHandler$detach() {
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(this._frame)) {
             if (typeof this._frame.removeEventListener != 'undefined') { this._frame.removeEventListener('load', this._frameLoadedHandler, false); } else if (typeof this._frame.detachEvent != 'undefined') { this._frame.detachEvent('onload', this._frameLoadedHandler); };
             if (typeof this._frame.removeEventListener != 'undefined') { this._frame.removeEventListener('unload', this._frameUnLoadedHandler, false); } else if (typeof this._frame.detachEvent != 'undefined') { this._frame.detachEvent('onunload', this._frameUnLoadedHandler); };
            this._frame = null;
            this.$L_1 = null;
            this.$Q_1 = null;
        }
    },
    
    $1L_1: function Lync_Client_Common_WindowEventHandler$$1L_1() {
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(this.$L_1)) {
            this.$L_1();
        }
    },
    
    $1M_1: function Lync_Client_Common_WindowEventHandler$$1M_1() {
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(this.$Q_1)) {
            this.$Q_1();
        }
    }
}


Lync.Client.Common.XmlNodeHelper = function Lync_Client_Common_XmlNodeHelper() {
}
Lync.Client.Common.XmlNodeHelper.getAttribValueById = function Lync_Client_Common_XmlNodeHelper$getAttribValueById(node, attributeId) {
    if (!Lync.Client.Common.Utilities.isNullOrUndefined(node) && !Lync.Client.Common.Utilities.isNullOrUndefined(attributeId)) {
        if (Lync.Client.Common.Utilities.isNullOrUndefined(node.attributes)) {
            try {
                return node.getAttribute(attributeId);
            }
            catch ($$e_2) {
            }
        }
        else {
            var $v_0 = node.attributes.getNamedItem(attributeId);
            if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_0)) {
                return $v_0.nodeValue;
            }
        }
    }
    return null;
}
Lync.Client.Common.XmlNodeHelper.getChildNodeByTag = function Lync_Client_Common_XmlNodeHelper$getChildNodeByTag(node, childTag) {
    var $v_0 = null;
    if (!Lync.Client.Common.Utilities.isNullOrUndefined(childTag) && !Lync.Client.Common.Utilities.isNullOrUndefined(node) && !Lync.Client.Common.Utilities.isNullOrUndefined(node.childNodes)) {
        for (var $v_1 = 0; $v_1 < node.childNodes.length; $v_1++) {
            var $v_2 = node.childNodes[$v_1];
            if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_2) && !Lync.Client.Common.Utilities.isNullOrUndefined($v_2.nodeName) && Lync.Client.Common.StringHelper.equals($v_2.nodeName, childTag, 1)) {
                $v_0 = $v_2;
                break;
            }
        }
    }
    return $v_0;
}


Lync.Client.Common.ByteArray.registerClass('Lync.Client.Common.ByteArray');
Lync.Client.Common.ObjectArray.registerClass('Lync.Client.Common.ObjectArray');
Lync.Client.Common.Base64.registerClass('Lync.Client.Common.Base64');
Lync.Client.Common.BigInt.registerClass('Lync.Client.Common.BigInt');
Lync.Client.Common.DelayLoadCompleteArgs.registerClass('Lync.Client.Common.DelayLoadCompleteArgs', Sys.EventArgs);
Lync.Client.Common.EventSource.registerClass('Lync.Client.Common.EventSource');
Lync.Client.Common.DelayLoader.registerClass('Lync.Client.Common.DelayLoader', Lync.Client.Common.EventSource);
Lync.Client.Common.DictionaryHelper.registerClass('Lync.Client.Common.DictionaryHelper');
Lync.Client.Common.EcsParameters.registerClass('Lync.Client.Common.EcsParameters');
Lync.Client.Common.HTMLEncoder.registerClass('Lync.Client.Common.HTMLEncoder');
Lync.Client.Common.EnumHelper.registerClass('Lync.Client.Common.EnumHelper');
Lync.Client.Common.JSON.registerClass('Lync.Client.Common.JSON');
Lync.Client.Common.LegacyClientSupport.registerClass('Lync.Client.Common.LegacyClientSupport');
Lync.Client.Common.UtilsLogProvider.registerClass('Lync.Client.Common.UtilsLogProvider', null, Lync.Client.Common.IUtilsLogProvider);
Lync.Client.Common.PostMessage.registerClass('Lync.Client.Common.PostMessage');
Lync.Client.Common.PostMessageRequest.registerClass('Lync.Client.Common.PostMessageRequest');
Lync.Client.Common.PostMessageData.registerClass('Lync.Client.Common.PostMessageData');
Lync.Client.Common.PIIUtil.registerClass('Lync.Client.Common.PIIUtil');
Lync.Client.Common.PIILogFormat.registerClass('Lync.Client.Common.PIILogFormat', null, Lync.Client.Common.IFormatProvider, Lync.Client.Common.ICustomFormatter);
Lync.Client.Common.Profiler.registerClass('Lync.Client.Common.Profiler');
Lync.Client.Common.StorageHelper.registerClass('Lync.Client.Common.StorageHelper');
Lync.Client.Common.BrowserStateHelper.registerClass('Lync.Client.Common.BrowserStateHelper');
Lync.Client.Common.CookieHelper.registerClass('Lync.Client.Common.CookieHelper');
Lync.Client.Common.StringHelper.registerClass('Lync.Client.Common.StringHelper');
Lync.Client.Common.TelemetryEventProperties.registerClass('Lync.Client.Common.TelemetryEventProperties');
Lync.Client.Common.ElapsedEventArgs.registerClass('Lync.Client.Common.ElapsedEventArgs', Sys.EventArgs);
Lync.Client.Common.Timer.registerClass('Lync.Client.Common.Timer', Lync.Client.Common.EventSource);
Lync.Client.Common.UserAgent.registerClass('Lync.Client.Common.UserAgent');
Lync.Client.Common.Utilities.registerClass('Lync.Client.Common.Utilities');
Lync.Client.Common.VersionInfo.registerClass('Lync.Client.Common.VersionInfo');
Lync.Client.Common.WindowEventHandler.registerClass('Lync.Client.Common.WindowEventHandler', Lync.Client.Common.EventSource);
Lync.Client.Common.XmlNodeHelper.registerClass('Lync.Client.Common.XmlNodeHelper');
Lync.Client.Common.Base64.$A = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
Lync.Client.Common.DelayLoader.$R = 'DelayLoadCompleted';
Lync.Client.Common.DelayLoader.$e = null;
Lync.Client.Common.EcsParameters.$i = null;
Lync.Client.Common.HTMLEncoder.$q = new RegExp('&', 'g');
Lync.Client.Common.HTMLEncoder.$12 = new RegExp('<', 'g');
Lync.Client.Common.HTMLEncoder.$10 = new RegExp('>', 'g');
Lync.Client.Common.HTMLEncoder.$r = new RegExp('\'', 'g');
Lync.Client.Common.HTMLEncoder.$15 = new RegExp('\"', 'g');
Lync.Client.Common.HTMLEncoder.$v = new RegExp('&amp;', 'g');
Lync.Client.Common.HTMLEncoder.$y = new RegExp('&lt;', 'g');
Lync.Client.Common.HTMLEncoder.$x = new RegExp('&gt;', 'g');
Lync.Client.Common.HTMLEncoder.$w = new RegExp('&apos;', 'g');
Lync.Client.Common.HTMLEncoder.$z = new RegExp('&quot;', 'g');
Lync.Client.Common.LegacyClientSupport.$c = null;
Lync.Client.Common.LegacyClientSupport.$b = null;
Lync.Client.Common.UtilsLogProvider.$X = new Lync.Client.Common.UtilsLogProvider();
Lync.Client.Common.PostMessage.$V = null;
Lync.Client.Common.PostMessage.unhandledPostMessageNamespace = 'Lync.Client.Common.PostMessage.Unhandled';
Lync.Client.Common.PIIUtil.URI = 'URI';
Lync.Client.Common.PIIUtil.CALLID = 'CALLID';
Lync.Client.Common.PIIUtil.e164 = 'E164';
Lync.Client.Common.PIIUtil.PHONE = 'PHONE';
Lync.Client.Common.PIIUtil.USER = 'USER';
Lync.Client.Common.PIIUtil.NAME = 'NAME';
Lync.Client.Common.PIIUtil.FQDN = 'FQDN';
Lync.Client.Common.PIIUtil.IP = 'IP';
Lync.Client.Common.PIIUtil.MACHINE = 'MACHINE';
Lync.Client.Common.PIIUtil.HOST = 'HOST';
Lync.Client.Common.PIIUtil.PII = 'PII';
Lync.Client.Common.PIIUtil.CCCP = 'CCCP';
Lync.Client.Common.PIIUtil.SDP = 'SDP';
Lync.Client.Common.PIIUtil.IIS = 'IIS';
Lync.Client.Common.PIIUtil.NOPII = 'NOPII';
Lync.Client.Common.Profiler.$B = null;
Lync.Client.Common.StringHelper.empty = '';
Lync.Client.Common.TelemetryEventProperties.swaVersion = null;
Lync.Client.Common.TelemetryEventProperties.assetsLocation = null;
Lync.Client.Common.UserAgent.$3 = 0;
Lync.Client.Common.UserAgent.$5 = 0;
Lync.Client.Common.UserAgent.$9 = 0;
Lync.Client.Common.UserAgent.$2 = null;
Lync.Client.Common.UserAgent.$I = null;
Lync.Client.Common.UserAgent.$4 = null;
Lync.Client.Common.UserAgent.$K = null;
Lync.Client.Common.UserAgent.$h = false;
Lync.Client.Common.UserAgent.$W = false;
Lync.Client.Common.UserAgent.win2k = new Lync.Client.Common.VersionInfo('5.0');
Lync.Client.Common.UserAgent.winXP = new Lync.Client.Common.VersionInfo('5.1');
Lync.Client.Common.UserAgent.winXPx64Or2k3 = new Lync.Client.Common.VersionInfo('5.2');
Lync.Client.Common.UserAgent.winVistaOr2k8 = new Lync.Client.Common.VersionInfo('6.0');
Lync.Client.Common.UserAgent.win7Or2k8R2 = new Lync.Client.Common.VersionInfo('6.1');
Lync.Client.Common.UserAgent.win8 = new Lync.Client.Common.VersionInfo('6.2');
Lync.Client.Common.UserAgent.iE7 = new Lync.Client.Common.VersionInfo('7.0');
Lync.Client.Common.UserAgent.iE8 = new Lync.Client.Common.VersionInfo('8.0');
Lync.Client.Common.UserAgent.iE9 = new Lync.Client.Common.VersionInfo('9.0');
Lync.Client.Common.UserAgent.iE10 = new Lync.Client.Common.VersionInfo('10.0');
Lync.Client.Common.UserAgent.lastChromeVersionSupportingNpapi = new Lync.Client.Common.VersionInfo('38.0');
Lync.Client.Common.Utilities.$C = Lync.Client.Common.StringHelper.empty;
Type.registerNamespace('Lync.Client.Logging');

Lync.Client.Logging.TraceLevel = function() {}
Lync.Client.Logging.TraceLevel.prototype = {
    none: 0, 
    error: 1, 
    warn: 2, 
    info: 4, 
    assert: 8, 
    verbose: 16, 
    noise: 32, 
    invalid: 64
}
Lync.Client.Logging.TraceLevel.registerEnum('Lync.Client.Logging.TraceLevel', true);


Lync.Client.Logging.TraceComponent = function() {}
Lync.Client.Logging.TraceComponent.prototype = {
    none: 0, 
    common_Utils: 101, 
    common_Packager: 102, 
    common_Telemetry: 103, 
    transport_General: 201, 
    transport_MimeUtil: 202, 
    transport_Connection: 203, 
    plugin_Framework: 301, 
    plugin_Activity: 302, 
    plugin_AudioVideo: 303, 
    plugin_AppSharing: 304, 
    model_Contacts: 401, 
    model_Self: 402, 
    model_Search: 403, 
    model_Signin: 405, 
    model_Conversations: 406, 
    model_Photo: 407, 
    model_CLM: 408, 
    model_Session: 409, 
    model_UCWACommunication: 410, 
    model_AVModality: 411, 
    model_ASModality: 412, 
    model_MediaPlatformConfig: 413, 
    model_SubscriptionManager: 414, 
    model_ContentManager: 415, 
    model_PluginCompCreator: 416, 
    model_DSModality: 417, 
    model_LyncClient: 418, 
    model_Freemium: 419, 
    auth_ServiceLocator: 450, 
    auth_WebTicketController: 451, 
    auth_LoginFormManager: 452, 
    uI_IM: 501, 
    uI_ContactCard: 502, 
    uI_ContactItem: 503, 
    uI_ContactList: 504, 
    uI_CommonControl: 505, 
    uI_PeopleArea: 506, 
    uI_Presence: 507, 
    uI_AudioVideo: 508, 
    uI_Conversation: 509, 
    uI_MeArea: 510, 
    uI_PreAuthArea: 511, 
    uI_AttachedContentBins: 512, 
    uI_AppShare: 513, 
    uI_Lobby: 514, 
    uI_TitleBar: 515, 
    uI_ContentManagement: 516, 
    uI_LoginControl: 517, 
    uI_Options: 518, 
    uI_MediaDevices: 519, 
    uI_Poll: 520, 
    uI_BRB: 521, 
    uI_BrowserPopup: 522, 
    uI_Qna: 523, 
    uI_ShellAppLoader: 524, 
    uI_WelcomeScreen: 525, 
    ext_ChromeExtension: 550, 
    uiCore_App: 601, 
    uiCore_CoreUX: 602, 
    uiCore_NotificationFramework: 603, 
    uiCore_Conversations: 604, 
    uiCore_Accessibility: 605, 
    uiCore_Animation: 606, 
    uiCore_Touch: 607, 
    uiCore_Peek: 608, 
    perf_View: 701, 
    perf_VM: 702, 
    perf_Model: 703, 
    model_PSOM: 801, 
    uI_PSOM_Common: 802, 
    uI_PSOM_App: 803, 
    uI_PSOM_Notes: 804, 
    uI_PSOM_Powerpoint: 805, 
    uI_PSOM_Poll: 806, 
    uI_PSOM_Annotations: 807, 
    invalid: 900
}
Lync.Client.Logging.TraceComponent.registerEnum('Lync.Client.Logging.TraceComponent', false);


Lync.Client.Logging.TraceModule = function() {}
Lync.Client.Logging.TraceModule.prototype = {
    none: 0, 
    common: 100, 
    transport: 200, 
    plugin: 300, 
    model: 400, 
    UI: 500, 
    uiCore: 600, 
    perf: 700, 
    PSOM: 800, 
    invalid: 900
}
Lync.Client.Logging.TraceModule.registerEnum('Lync.Client.Logging.TraceModule', false);


Lync.Client.Logging.BufferType = function() {}
Lync.Client.Logging.BufferType.prototype = {
    none: 0, 
    small: 1, 
    large: 2
}
Lync.Client.Logging.BufferType.registerEnum('Lync.Client.Logging.BufferType', false);


Lync.Client.Logging.ILogger = function() {}
Lync.Client.Logging.ILogger.registerInterface('Lync.Client.Logging.ILogger');


Lync.Client.Logging.LoggerResources = function Lync_Client_Logging_LoggerResources() {
}
Lync.Client.Logging.LoggerResources.$w = function Lync_Client_Logging_LoggerResources$$w($p0) {
    if (!Lync.Client.Logging.LoggerResources.$A) {
        Lync.Client.Logging.LoggerResources.$A = window.self.ControlRes;
    }
    if (!Lync.Client.Logging.LoggerResources.$1A(Lync.Client.Logging.LoggerResources.$A[$p0])) {
        return Lync.Client.Logging.LoggerResources.$A[$p0];
    }
    return $p0 + '_Undefined';
}
Lync.Client.Logging.LoggerResources.$1A = function Lync_Client_Logging_LoggerResources$$1A($p0) {
    return null === $p0 || $p0 === undefined;
}
Lync.Client.Logging.LoggerResources.get_loggerWindowTitle = function Lync_Client_Logging_LoggerResources$get_loggerWindowTitle() {
    return Lync.Client.Logging.LoggerResources.$w('LoggingTitle');
}


Lync.Client.Logging.LogDataHelper = function Lync_Client_Logging_LogDataHelper() {
}
Lync.Client.Logging.LogDataHelper.$z = function Lync_Client_Logging_LogDataHelper$$z($p0, $p1) {
    var $v_0 = Lync.Client.Logging.LogDataHelper.$l;
    if ($p0.level === 1) {
        $v_0 = Lync.Client.Logging.LogDataHelper.$m;
    }
    var $v_1 = String.format($v_0, $p0.timeString, Lync.Client.Logging.Log.getLevelFriendlyName($p0.level), Lync.Client.Logging.Log.getModuleFriendlyName($p0.module), Lync.Client.Logging.Log.getComponentFriendlyName($p0.component), $p0.message, $p0.caller, $p1, $p0.stackTrace);
    return $v_1;
}


Lync.Client.Logging.UtilLogger = function Lync_Client_Logging_UtilLogger() {
}
Lync.Client.Logging.UtilLogger.prototype = {
    
    assert: function Lync_Client_Logging_UtilLogger$assert($p0, $p1) {
        var $p2 = [];
        for (var $$pai_3 = 2; $$pai_3 < arguments.length; ++$$pai_3) {
            $p2[$$pai_3 - 2] = arguments[$$pai_3];
        }
        Lync.Client.Logging.Log.assert.apply(null, [ $p0, 101, $p1 ].concat($p2));
    },
    
    error: function Lync_Client_Logging_UtilLogger$error($p0) {
        var $p1 = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            $p1[$$pai_2 - 1] = arguments[$$pai_2];
        }
        Lync.Client.Logging.Log.error.apply(null, [ 101, $p0 ].concat($p1));
    },
    
    warn: function Lync_Client_Logging_UtilLogger$warn($p0) {
        var $p1 = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            $p1[$$pai_2 - 1] = arguments[$$pai_2];
        }
        Lync.Client.Logging.Log.warn.apply(null, [ 101, $p0 ].concat($p1));
    },
    
    info: function Lync_Client_Logging_UtilLogger$info($p0) {
        var $p1 = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            $p1[$$pai_2 - 1] = arguments[$$pai_2];
        }
        Lync.Client.Logging.Log.info.apply(null, [ 101, $p0 ].concat($p1));
    },
    
    verbose: function Lync_Client_Logging_UtilLogger$verbose($p0) {
        var $p1 = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            $p1[$$pai_2 - 1] = arguments[$$pai_2];
        }
        Lync.Client.Logging.Log.verbose.apply(null, [ 101, $p0 ].concat($p1));
    },
    
    noise: function Lync_Client_Logging_UtilLogger$noise($p0) {
        var $p1 = [];
        for (var $$pai_2 = 1; $$pai_2 < arguments.length; ++$$pai_2) {
            $p1[$$pai_2 - 1] = arguments[$$pai_2];
        }
        Lync.Client.Logging.Log.noise.apply(null, [ 101, $p0 ].concat($p1));
    }
}


Lync.Client.Logging.ConsoleHelper = function Lync_Client_Logging_ConsoleHelper() {
}
Lync.Client.Logging.ConsoleHelper.get_$6 = function Lync_Client_Logging_ConsoleHelper$get_$6() {
    return window.console;
}
Lync.Client.Logging.ConsoleHelper.log = function Lync_Client_Logging_ConsoleHelper$log(msg) {
    var $v_0 = false;
    if (Lync.Client.Logging.ConsoleHelper.get_$6() && console.log != null) {
        console.log(msg);;
        $v_0 = true;
    }
    return $v_0;
}
Lync.Client.Logging.ConsoleHelper.info = function Lync_Client_Logging_ConsoleHelper$info(msg) {
    var $v_0 = false;
    if (Lync.Client.Logging.ConsoleHelper.get_$6() && console.info != null) {
        console.info(msg);;
        $v_0 = true;
    }
    return $v_0;
}
Lync.Client.Logging.ConsoleHelper.warn = function Lync_Client_Logging_ConsoleHelper$warn(msg) {
    var $v_0 = false;
    if (Lync.Client.Logging.ConsoleHelper.get_$6() && console.warn != null) {
        console.warn(msg);;
        $v_0 = true;
    }
    return $v_0;
}
Lync.Client.Logging.ConsoleHelper.error = function Lync_Client_Logging_ConsoleHelper$error(msg) {
    var $v_0 = false;
    if (Lync.Client.Logging.ConsoleHelper.get_$6() && console.error != null) {
        console.error(msg);;
        $v_0 = true;
    }
    return $v_0;
}


Lync.Client.Logging.ConsoleLogger = function Lync_Client_Logging_ConsoleLogger() {
    this.logMetaInfo(Lync.Client.Logging.LogDataHelper.$T);
}
Lync.Client.Logging.ConsoleLogger.prototype = {
    
    logMetaInfo: function Lync_Client_Logging_ConsoleLogger$logMetaInfo($p0) {
        if (Lync.Client.Logging.ConsoleHelper.get_$6()) {
            Lync.Client.Logging.ConsoleHelper.log($p0);
        }
    },
    
    logOutput: function Lync_Client_Logging_ConsoleLogger$logOutput($p0, $p1, $p2, $p3) {
        if (Lync.Client.Logging.ConsoleHelper.get_$6()) {
            this.$Q_0($p0, $p3);
        }
    },
    
    getLineBreak: function Lync_Client_Logging_ConsoleLogger$getLineBreak() {
        return '\n';
    },
    
    $Q_0: function Lync_Client_Logging_ConsoleLogger$$Q_0($p0, $p1) {
        switch ($p0) {
            case 4:
                Lync.Client.Logging.ConsoleHelper.info($p1);
                break;
            case 2:
                Lync.Client.Logging.ConsoleHelper.warn($p1);
                break;
            case 1:
                Lync.Client.Logging.ConsoleHelper.error($p1);
                break;
            default:
                Lync.Client.Logging.ConsoleHelper.log(String.format('{0}', $p1));
                break;
        }
    }
}


Lync.Client.Logging.FriendlyNames = function Lync_Client_Logging_FriendlyNames() {
}
Lync.Client.Logging.FriendlyNames.$16 = function Lync_Client_Logging_FriendlyNames$$16() {
    var $v_0 = [];
    $v_0[1] = 'TL_ERROR';
    $v_0[2] = 'TL_WARN';
    $v_0[4] = 'TL_INFO';
    $v_0[8] = 'TL_ASSERT';
    $v_0[16] = 'TL_VERBOSE';
    $v_0[32] = 'TL_NOISE';
    return $v_0;
}
Lync.Client.Logging.FriendlyNames.$14 = function Lync_Client_Logging_FriendlyNames$$14() {
    var $v_0 = [];
    $v_0[101] = 'Utils';
    $v_0[102] = 'Packager';
    $v_0[103] = 'Telemetry';
    $v_0[201] = 'General';
    $v_0[202] = 'MimeUtil';
    $v_0[203] = 'Connection';
    $v_0[301] = 'Framework';
    $v_0[302] = 'Activity';
    $v_0[303] = 'AudioVideo';
    $v_0[304] = 'AppSharing';
    $v_0[401] = 'Contacts';
    $v_0[407] = 'Photo';
    $v_0[402] = 'Self';
    $v_0[403] = 'Search';
    $v_0[405] = 'Signin';
    $v_0[406] = 'Conversations';
    $v_0[408] = 'ComponentLifecycleManager';
    $v_0[409] = 'Session';
    $v_0[410] = 'UCWASpecificCommunication';
    $v_0[411] = 'AVModality';
    $v_0[414] = 'SubscriptionManager';
    $v_0[412] = 'ASModality';
    $v_0[416] = 'PluginCompCreator';
    $v_0[413] = 'MediaPlatformConfig';
    $v_0[415] = 'ContentManager';
    $v_0[417] = 'DSModality';
    $v_0[418] = 'LyncCLient';
    $v_0[419] = 'Freemium';
    $v_0[450] = 'ServiceLocator';
    $v_0[451] = 'WebTicketController';
    $v_0[452] = 'LoginFormManager';
    $v_0[501] = 'IM';
    $v_0[502] = 'ContactCard';
    $v_0[503] = 'ContactItem';
    $v_0[512] = 'AttachedContentBins';
    $v_0[504] = 'ContactList';
    $v_0[505] = 'CommonControl';
    $v_0[506] = 'PeopleArea';
    $v_0[507] = 'PresenceControl';
    $v_0[508] = 'AudioVideoUI';
    $v_0[520] = 'PollUI';
    $v_0[509] = 'UIConversation';
    $v_0[510] = 'MeArea';
    $v_0[514] = 'Lobby';
    $v_0[515] = 'TitleBar';
    $v_0[601] = 'App';
    $v_0[602] = 'CoreUX';
    $v_0[603] = 'NotificationFramework';
    $v_0[604] = 'UICoreConversations';
    $v_0[605] = 'Accessibility';
    $v_0[606] = 'Animation';
    $v_0[607] = 'Touch';
    $v_0[608] = 'Peek';
    $v_0[513] = 'AppShare';
    $v_0[511] = 'PreAuthArea';
    $v_0[516] = 'ContentManagement';
    $v_0[518] = 'Options';
    $v_0[519] = 'MediaDevices';
    $v_0[521] = 'BRB';
    $v_0[522] = 'BrowserPopup';
    $v_0[524] = 'ShellAppLoader';
    $v_0[525] = 'WelcomeScreen';
    $v_0[550] = 'ChromeExtension';
    $v_0[701] = 'View';
    $v_0[702] = 'VM';
    $v_0[703] = 'Model';
    $v_0[801] = 'PSOM';
    $v_0[802] = 'PSOMUICommon';
    $v_0[803] = 'PSOMUIApp';
    $v_0[804] = 'PSOMNotesUI';
    $v_0[805] = 'PSOMPowerpointUI';
    $v_0[806] = 'PSOMPollUI';
    $v_0[807] = 'PSOMAnnotationsUI';
    return $v_0;
}
Lync.Client.Logging.FriendlyNames.$17 = function Lync_Client_Logging_FriendlyNames$$17() {
    var $v_0 = [];
    $v_0[100] = 'Common';
    $v_0[200] = 'Transport';
    $v_0[300] = 'Plugin';
    $v_0[400] = 'Model';
    $v_0[500] = 'UI';
    $v_0[600] = 'UICore';
    $v_0[700] = 'Perf';
    return $v_0;
}


Lync.Client.Logging.LogData = function Lync_Client_Logging_LogData() {
}
Lync.Client.Logging.LogData.prototype = {
    timeString: null,
    caller: null,
    level: 0,
    component: 0,
    module: 0,
    message: null,
    stackTrace: null,
    
    serialize: function Lync_Client_Logging_LogData$serialize(lineBreak) {
        return Lync.Client.Logging.LogDataHelper.$z(this, lineBreak);
    }
}


Lync.Client.Logging.LocalLogger = function Lync_Client_Logging_LocalLogger() {
    this.$$d_$v_0 = Function.createDelegate(this, this.$v_0);
    this.$$d_$W_0 = Function.createDelegate(this, this.$W_0);
    this.$D_0 = '';
    this.$E_0 = false;
    this.$2_0 = null;
    this.$8_0 = null;
}
Lync.Client.Logging.LocalLogger.prototype = {
    $D_0: null,
    $2_0: null,
    $8_0: null,
    $E_0: false,
    
    logMetaInfo: function Lync_Client_Logging_LocalLogger$logMetaInfo($p0) {
        this.$Q_0($p0 + '<br/>');
    },
    
    logOutput: function Lync_Client_Logging_LocalLogger$logOutput($p0, $p1, $p2, $p3) {
        var $v_0 = String.format('<font color=\'{0}\'>{1}</font><br/>', this.$b_0($p0), $p3);
        this.$Q_0($v_0);
    },
    
    getLineBreak: function Lync_Client_Logging_LocalLogger$getLineBreak() {
        return '<br/>';
    },
    
    $Q_0: function Lync_Client_Logging_LocalLogger$$Q_0($p0) {
        this.$D_0 += $p0;
        this.$1G_0();
    },
    
    $b_0: function Lync_Client_Logging_LocalLogger$$b_0($p0) {
        switch ($p0) {
            case 1:
                return 'red';
            case 8:
                return 'orangered';
            case 2:
                return 'orange';
            case 4:
                return 'blue';
            case 16:
                return 'green';
            case 32:
                return 'gray';
        }
        return 'black';
    },
    
    $1G_0: function Lync_Client_Logging_LocalLogger$$1G_0() {
        if (!this.$E_0) {
            this.$E_0 = true;
            window.setTimeout(this.$$d_$W_0, 500);
        }
    },
    
    $W_0: function Lync_Client_Logging_LocalLogger$$W_0() {
        try {
            if (!Lync.Client.Common.Utilities.isNullOrUndefined(this.$8_0) && !Lync.Client.Common.Utilities.isNullOrUndefined(this.$8_0.innerHTML) && !this.$O_0()) {
                this.$8_0.innerHTML += this.$D_0;
                this.$2_0.scrollBy(0, 500000);
                this.$D_0 = '';
            }
        }
        catch ($$e_0) {
        }
        this.$E_0 = false;
    },
    
    $13_0: function Lync_Client_Logging_LocalLogger$$13_0() {
        var $v_0 = '';
        for (var $v_1 = 1; $v_1 < 64; $v_1 *= 2) {
            $v_0 += String.format('<font color=\'{0}\'>{1}</font><br/>', this.$b_0($v_1), Lync.Client.Logging.Log.getLevelFriendlyName($v_1));
        }
        return $v_0 + '<br/>';
    },
    
    $k_0: function Lync_Client_Logging_LocalLogger$$k_0() {
        if (this.$O_0()) {
            this.$2_0 = window.open('Toast.htm', '_blank', 'toolbar=no, status=yes, menubar=no, location=no, resizable=yes, scrollbars=yes');
            window.setTimeout(this.$$d_$v_0, 1000);
        }
        else if (!Lync.Client.Common.Utilities.isNullOrUndefined(this.$2_0)) {
            this.$2_0.close();
            this.$2_0 = null;
        }
    },
    
    $v_0: function Lync_Client_Logging_LocalLogger$$v_0() {
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(this.$2_0)) {
            this.$2_0.document.write('This is the Local logs window. Each message is formatted and coded as follows:<br/>');
            this.$2_0.document.write(Lync.Client.Logging.LogDataHelper.$T + '<br/>');
            this.$2_0.document.write(this.$13_0());
            this.$8_0 = this.$2_0.document.createElement('div');
            this.$2_0.document.body.appendChild(this.$8_0);
            this.$W_0();
            this.$2_0.document.title = Lync.Client.Logging.LoggerResources.get_loggerWindowTitle();
        }
    },
    
    $O_0: function Lync_Client_Logging_LocalLogger$$O_0() {
        return (Lync.Client.Common.Utilities.isNullOrUndefined(this.$2_0) || this.$2_0.closed);
    }
}


Lync.Client.Logging.Log = function Lync_Client_Logging_Log() {
}
Lync.Client.Logging.Log.$19 = function Lync_Client_Logging_Log$$19() {
    $addHandler(window.document.documentElement, 'keydown', Lync.Client.Logging.Log.$e);
}
Lync.Client.Logging.Log.$t = function Lync_Client_Logging_Log$$t() {
    $removeHandler(window.document.documentElement, 'keydown', Lync.Client.Logging.Log.$e);
}
Lync.Client.Logging.Log.$1B = function Lync_Client_Logging_Log$$1B() {
    if (Lync.Client.Logging.Log.$0) {
        var $v_0 = new Lync.Client.Logging.ConsoleLogger();
        Lync.Client.Logging.Log.$0.$S_0($v_0);
    }
}
Lync.Client.Logging.Log.$18 = function Lync_Client_Logging_Log$$18() {
    Lync.Client.Logging.Log.$K = Lync.Client.Logging.FriendlyNames.$16();
    Lync.Client.Logging.Log.$L = Lync.Client.Logging.FriendlyNames.$17();
    Lync.Client.Logging.Log.$J = Lync.Client.Logging.FriendlyNames.$14();
}
Lync.Client.Logging.Log.$e = function Lync_Client_Logging_Log$$e($p0) {
    if ($p0.keyCode === 120) {
        var $v_0 = Lync.Client.Logging.Log.$0.$F_0;
        if (!$v_0 || $v_0.$O_0()) {
            if ($v_0) {
                Lync.Client.Logging.Log.$0.$U_0($v_0);
            }
            $v_0 = new Lync.Client.Logging.LocalLogger();
            Lync.Client.Logging.Log.dumpMemoryLogs($v_0, false);
            Lync.Client.Logging.Log.$0.$S_0($v_0);
            $v_0.$k_0();
        }
        else {
            $v_0.$k_0();
            Lync.Client.Logging.Log.$0.$U_0($v_0);
        }
    }
}
Lync.Client.Logging.Log.$h = function Lync_Client_Logging_Log$$h($p0) {
    Lync.Client.Logging.Log.$5.fireEvent(Lync.Client.Logging.Log.$H, new Lync.Client.Logging.TraceBufferFilledEventArgs($p0));
}
Lync.Client.Logging.Log.perfBegin = function Lync_Client_Logging_Log$perfBegin(markerName) {
    Lync.Client.Logging.Log.info(702, Lync.Client.Logging.Log.$f, markerName);
}
Lync.Client.Logging.Log.perfEnd = function Lync_Client_Logging_Log$perfEnd(markerName) {
    Lync.Client.Logging.Log.info(702, Lync.Client.Logging.Log.$g, markerName);
}
Lync.Client.Logging.Log.trace = function Lync_Client_Logging_Log$trace(level, component, message) {
    var args = [];
    for (var $$pai_5 = 3; $$pai_5 < arguments.length; ++$$pai_5) {
        args[$$pai_5 - 3] = arguments[$$pai_5];
    }
    if (Lync.Client.Logging.Log.$0.$4_0) {
        if (level !== 8) {
            var $$t_4;
            ($$t_4 = Lync.Client.Logging.Log.$0).$7_0.apply($$t_4, [ level, component, message ].concat(args));
        }
    }
}
Lync.Client.Logging.Log.assert = function Lync_Client_Logging_Log$assert(condition, component, message) {
    var args = [];
    for (var $$pai_5 = 3; $$pai_5 < arguments.length; ++$$pai_5) {
        args[$$pai_5 - 3] = arguments[$$pai_5];
    }
    if (Lync.Client.Logging.Log.$0.$4_0 && Lync.Client.Logging.Log.$0.$X_0) {
        if (!condition) {
            var $$t_4;
            ($$t_4 = Lync.Client.Logging.Log.$0).$7_0.apply($$t_4, [ 8, component, message ].concat(args));
        }
    }
}
Lync.Client.Logging.Log.error = function Lync_Client_Logging_Log$error(component, message) {
    var args = [];
    for (var $$pai_4 = 2; $$pai_4 < arguments.length; ++$$pai_4) {
        args[$$pai_4 - 2] = arguments[$$pai_4];
    }
    if (Lync.Client.Logging.Log.$0.$4_0 && Lync.Client.Logging.Log.$0.$Y_0) {
        var $$t_3;
        ($$t_3 = Lync.Client.Logging.Log.$0).$7_0.apply($$t_3, [ 1, component, message ].concat(args));
    }
}
Lync.Client.Logging.Log.warn = function Lync_Client_Logging_Log$warn(component, message) {
    var args = [];
    for (var $$pai_4 = 2; $$pai_4 < arguments.length; ++$$pai_4) {
        args[$$pai_4 - 2] = arguments[$$pai_4];
    }
    if (Lync.Client.Logging.Log.$0.$4_0 && Lync.Client.Logging.Log.$0.$p_0) {
        var $$t_3;
        ($$t_3 = Lync.Client.Logging.Log.$0).$7_0.apply($$t_3, [ 2, component, message ].concat(args));
    }
}
Lync.Client.Logging.Log.info = function Lync_Client_Logging_Log$info(component, message) {
    var args = [];
    for (var $$pai_4 = 2; $$pai_4 < arguments.length; ++$$pai_4) {
        args[$$pai_4 - 2] = arguments[$$pai_4];
    }
    if (Lync.Client.Logging.Log.$0.$4_0 && Lync.Client.Logging.Log.$0.$c_0) {
        var $$t_3;
        ($$t_3 = Lync.Client.Logging.Log.$0).$7_0.apply($$t_3, [ 4, component, message ].concat(args));
    }
}
Lync.Client.Logging.Log.verbose = function Lync_Client_Logging_Log$verbose(component, message) {
    var args = [];
    for (var $$pai_4 = 2; $$pai_4 < arguments.length; ++$$pai_4) {
        args[$$pai_4 - 2] = arguments[$$pai_4];
    }
    if (Lync.Client.Logging.Log.$0.$4_0 && Lync.Client.Logging.Log.$0.$o_0) {
        var $$t_3;
        ($$t_3 = Lync.Client.Logging.Log.$0).$7_0.apply($$t_3, [ 16, component, message ].concat(args));
    }
}
Lync.Client.Logging.Log.noise = function Lync_Client_Logging_Log$noise(component, message) {
    var args = [];
    for (var $$pai_4 = 2; $$pai_4 < arguments.length; ++$$pai_4) {
        args[$$pai_4 - 2] = arguments[$$pai_4];
    }
    if (Lync.Client.Logging.Log.$0.$4_0 && Lync.Client.Logging.Log.$0.$d_0) {
        var $$t_3;
        ($$t_3 = Lync.Client.Logging.Log.$0).$7_0.apply($$t_3, [ 32, component, message ].concat(args));
    }
}
Lync.Client.Logging.Log.register = function Lync_Client_Logging_Log$register(logger) {
    return Lync.Client.Logging.Log.$0.$S_0(logger);
}
Lync.Client.Logging.Log.unRegister = function Lync_Client_Logging_Log$unRegister(logger) {
    return Lync.Client.Logging.Log.$0.$U_0(logger);
}
Lync.Client.Logging.Log.setTraceLevel = function Lync_Client_Logging_Log$setTraceLevel(levels, module) {
    var $v_0 = Lync.Client.Logging.Log.$0.$1F_0(levels, module);
    if ($v_0) {
        Lync.Client.Logging.Log.$5.fireEvent(Lync.Client.Logging.Log.$I, new Lync.Client.Logging.TraceLevelsChangedEventArgs(module));
    }
    return $v_0;
}
Lync.Client.Logging.Log.setGlobalTraceLevel = function Lync_Client_Logging_Log$setGlobalTraceLevel(level) {
    if (!Lync.Client.Logging.Log.$0) {
        throw Error.invalidOperation('Logging is not initialized yet or has been uninitialized');
    }
    Lync.Client.Logging.Log.$0.$i_0(level);
    return true;
}
Lync.Client.Logging.Log.setGlobalTraceLevelByBucket = function Lync_Client_Logging_Log$setGlobalTraceLevelByBucket(level) {
    var $v_0 = 0;
    if (Lync.Client.Common.StringHelper.equals(level, Lync.Client.Logging.Log.bucket_Light, 1)) {
        $v_0 = Lync.Client.Logging.Log.$P;
    }
    else if (Lync.Client.Common.StringHelper.equals(level, Lync.Client.Logging.Log.bucket_Full, 1)) {
        $v_0 = Lync.Client.Logging.Log.$a;
    }
    else if (Lync.Client.Common.StringHelper.equals(level, Lync.Client.Logging.Log.bucket_Off, 1)) {
        $v_0 = 0;
    }
    else {
        $v_0 = Lync.Client.Logging.Log.$P;
    }
    return Lync.Client.Logging.Log.setGlobalTraceLevel($v_0);
}
Lync.Client.Logging.Log.setUserTraceLevel = function Lync_Client_Logging_Log$setUserTraceLevel(level) {
    if (Lync.Client.Logging.Log.setGlobalTraceLevelByBucket(level)) {
        Lync.Client.Logging.Log.$M = level;
    }
}
Lync.Client.Logging.Log.getUserTraceLevel = function Lync_Client_Logging_Log$getUserTraceLevel() {
    return Lync.Client.Logging.Log.$M;
}
Lync.Client.Logging.Log.getTraceLevel = function Lync_Client_Logging_Log$getTraceLevel(module) {
    return Lync.Client.Logging.Log.$0.$15_0(module);
}
Lync.Client.Logging.Log.enableLogging = function Lync_Client_Logging_Log$enableLogging(isEnabled) {
    return Lync.Client.Logging.Log.$0.$1E_0(isEnabled);
}
Lync.Client.Logging.Log.isEnabled = function Lync_Client_Logging_Log$isEnabled(level, component) {
    return Lync.Client.Logging.Log.$0.$r_0(level, component);
}
Lync.Client.Logging.Log.add_traceLevelsChanged = function Lync_Client_Logging_Log$add_traceLevelsChanged(value) {
    Lync.Client.Logging.Log.$5.get_events().addHandler(Lync.Client.Logging.Log.$I, value);
}
Lync.Client.Logging.Log.remove_traceLevelsChanged = function Lync_Client_Logging_Log$remove_traceLevelsChanged(value) {
    Lync.Client.Logging.Log.$5.get_events().removeHandler(Lync.Client.Logging.Log.$I, value);
}
Lync.Client.Logging.Log.add_traceBufferFilled = function Lync_Client_Logging_Log$add_traceBufferFilled(value) {
    Lync.Client.Logging.Log.$5.get_events().addHandler(Lync.Client.Logging.Log.$H, value);
}
Lync.Client.Logging.Log.remove_traceBufferFilled = function Lync_Client_Logging_Log$remove_traceBufferFilled(value) {
    Lync.Client.Logging.Log.$5.get_events().removeHandler(Lync.Client.Logging.Log.$H, value);
}
Lync.Client.Logging.Log.initialize = function Lync_Client_Logging_Log$initialize(fRegisterDefaultLoggers) {
    if (Lync.Client.Logging.Log.$0) {
        return;
    }
    Lync.Client.Logging.Log.$0 = new Lync.Client.Logging.LoggingCore();
    Lync.Client.Logging.Log.setBufferedLogging(2);
    Lync.Client.Logging.Log.$18();
    Lync.Client.Logging.Log.enableLogging(true);
    if (fRegisterDefaultLoggers) {
        Lync.Client.Logging.Log.$1B();
    }
    Lync.Client.Logging.Log.$19();
    Lync.Client.Common.UtilsLogProvider.setLogProvider(new Lync.Client.Logging.UtilLogger());
}
Lync.Client.Logging.Log.unInitialize = function Lync_Client_Logging_Log$unInitialize() {
    Lync.Client.Common.UtilsLogProvider.setLogProvider(null);
    Lync.Client.Logging.Log.$t();
    Lync.Client.Logging.Log.$0.$s_0();
    Lync.Client.Logging.Log.$0 = null;
}
Lync.Client.Logging.Log.setBufferedLogging = function Lync_Client_Logging_Log$setBufferedLogging(type) {
    var $v_0 = 0;
    switch (type) {
        case 0:
            $v_0 = 0;
            break;
        case 1:
            $v_0 = 100000;
            break;
        case 2:
            $v_0 = 5000000;
            break;
        default:
            return;
    }
    if (Lync.Client.Logging.Log.$0) {
        Lync.Client.Logging.Log.$0.$1D_0($v_0);
    }
}
Lync.Client.Logging.Log.dumpMemoryLogs = function Lync_Client_Logging_Log$dumpMemoryLogs(logger, clearMemory) {
    return Lync.Client.Logging.Log.$0.$u_0(logger, clearMemory);
}
Lync.Client.Logging.Log.getModuleFriendlyName = function Lync_Client_Logging_Log$getModuleFriendlyName(module) {
    if (module >= 0 && module <= 900) {
        return Lync.Client.Logging.Log.$L[module];
    }
    return '';
}
Lync.Client.Logging.Log.getComponentFriendlyName = function Lync_Client_Logging_Log$getComponentFriendlyName(component) {
    if (component >= 0 && component <= 900) {
        return Lync.Client.Logging.Log.$J[component];
    }
    return '';
}
Lync.Client.Logging.Log.getLevelFriendlyName = function Lync_Client_Logging_Log$getLevelFriendlyName(level) {
    if (level >= 0 && level <= 64) {
        return Lync.Client.Logging.Log.$K[level];
    }
    return '';
}


Lync.Client.Logging.TraceLevelsChangedEventArgs = function Lync_Client_Logging_TraceLevelsChangedEventArgs(module) {
    Lync.Client.Logging.TraceLevelsChangedEventArgs.initializeBase(this);
    this.module = module;
}
Lync.Client.Logging.TraceLevelsChangedEventArgs.prototype = {
    module: 0
}


Lync.Client.Logging.TraceBufferFilledEventArgs = function Lync_Client_Logging_TraceBufferFilledEventArgs(logDataList) {
    Lync.Client.Logging.TraceBufferFilledEventArgs.initializeBase(this);
    this.logDataList = logDataList;
}
Lync.Client.Logging.TraceBufferFilledEventArgs.prototype = {
    logDataList: null
}


Lync.Client.Logging.LoggingCore = function Lync_Client_Logging_LoggingCore() {
    this.$3_0 = [];
    this.$9_0 = {};
    this.$4_0 = false;
    this.$V_0 = new Date();
    this.$B_0 = 0;
    this.$G_0 = 0;
    this.$1_0 = [];
    this.$F_0 = null;
    this.$C_0 = false;
    this.$i_0(15);
}
Lync.Client.Logging.LoggingCore.prototype = {
    $3_0: null,
    $9_0: null,
    $C_0: false,
    $4_0: false,
    $X_0: false,
    $Y_0: false,
    $p_0: false,
    $c_0: false,
    $o_0: false,
    $d_0: false,
    $V_0: null,
    $B_0: 0,
    $G_0: 0,
    $1_0: null,
    $F_0: null,
    
    $S_0: function Lync_Client_Logging_LoggingCore$$S_0($p0) {
        if (!$p0) {
            return false;
        }
        Array.add(this.$1_0, $p0);
        $p0.logMetaInfo(this.$N_0('Logger Registered: {0}, Reference Time - {1}'));
        if (Lync.Client.Logging.LocalLogger.isInstanceOfType($p0)) {
            this.$F_0 = $p0;
        }
        return true;
    },
    
    $U_0: function Lync_Client_Logging_LoggingCore$$U_0($p0) {
        if (!$p0 || !this.$1_0 || !Array.contains(this.$1_0, $p0)) {
            return false;
        }
        Array.remove(this.$1_0, $p0);
        $p0.logMetaInfo(this.$N_0('Logger UnRegistered: {0}, Reference Time - {1}'));
        if (Lync.Client.Logging.LocalLogger.isInstanceOfType($p0)) {
            this.$F_0 = null;
        }
        return true;
    },
    
    $1F_0: function Lync_Client_Logging_LoggingCore$$1F_0($p0, $p1) {
        var $v_0 = false;
        if ($p0 < 0 || $p0 >= 64 || $p1 <= 0 || $p1 >= 900) {
            return $v_0;
        }
        var $v_1 = this.$9_0[($p1).toString()];
        var $v_2 = ((Lync.Client.Common.Utilities.isNullOrUndefined($v_1)) ? 64 : $v_1);
        if ($p0 !== $v_2) {
            this.$9_0[($p1).toString()] = $p0;
            $v_0 = true;
        }
        return $v_0;
    },
    
    $i_0: function Lync_Client_Logging_LoggingCore$$i_0($p0) {
        this.$X_0 = !!($p0 & 8);
        this.$Y_0 = !!($p0 & 1);
        this.$p_0 = !!($p0 & 2);
        this.$c_0 = !!($p0 & 4);
        this.$o_0 = !!($p0 & 16);
        this.$d_0 = !!($p0 & 32);
        for (var $v_0 = 100; $v_0 < 900; $v_0 += 100) {
            this.$9_0[($v_0).toString()] = $p0;
        }
        return true;
    },
    
    $15_0: function Lync_Client_Logging_LoggingCore$$15_0($p0) {
        if ($p0 <= 0 || $p0 >= 900) {
            return 64;
        }
        var $v_0 = this.$9_0[($p0).toString()];
        var $v_1 = ((Lync.Client.Common.Utilities.isNullOrUndefined($v_0)) ? 64 : $v_0);
        return $v_1;
    },
    
    $1E_0: function Lync_Client_Logging_LoggingCore$$1E_0($p0) {
        this.$4_0 = $p0;
        return true;
    },
    
    $1D_0: function Lync_Client_Logging_LoggingCore$$1D_0($p0) {
        this.$G_0 = $p0;
    },
    
    $u_0: function Lync_Client_Logging_LoggingCore$$u_0($p0, $p1) {
        var $v_0 = false;
        if (!Lync.Client.Common.Utilities.isNullOrUndefined($p0) && !Lync.Client.Common.Utilities.isNullOrUndefined(this.$3_0) && (this.$3_0.length > 0)) {
            $p0.logMetaInfo(this.$N_0('Dumping Logs: Dump Requested Time - {0}, Reference Time - {1}'));
            for (var $v_1 = 0; $v_1 < this.$3_0.length; $v_1++) {
                var $v_2 = this.$3_0[$v_1];
                if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_2)) {
                    var $v_3 = $v_2.serialize($p0.getLineBreak());
                    $p0.logOutput($v_2.level, $v_2.component, $v_2.module, $v_3);
                }
            }
            $p0.logMetaInfo('Dumping Logs ENDED');
            if ($p1) {
                Array.clear(this.$3_0);
            }
            $v_0 = true;
        }
        return $v_0;
    },
    
    $s_0: function Lync_Client_Logging_LoggingCore$$s_0() {
        var $v_0 = false;
        var $v_1 = false;
        if (this.$1_0 && this.$1_0.length > 0) {
            while (this.$1_0.length > 0) {
                Array.removeAt(this.$1_0, 0);
            }
            this.$1_0 = null;
            $v_0 = true;
        }
        if (!Lync.Client.Common.Utilities.isNullOrUndefined(this.$3_0)) {
            Array.clear(this.$3_0);
            this.$3_0 = null;
            $v_1 = true;
        }
        return $v_0 && $v_1;
    },
    
    $7_0: function Lync_Client_Logging_LoggingCore$$7_0($p0, $p1, $p2) {
        var $p3 = [];
        for (var $$pai_9 = 3; $$pai_9 < arguments.length; ++$$pai_9) {
            $p3[$$pai_9 - 3] = arguments[$$pai_9];
        }
        if (($p1 === 301) && this.$C_0) {
            return;
        }
        try {
            var $v_0 = new Lync.Client.Logging.LogData();
            var $v_1 = new Date();
            $v_0.timeString = String.format('{0}:{1}:{2}:{3}', $v_1.getHours(), $v_1.getMinutes(), $v_1.getSeconds(), $v_1.getMilliseconds());
            $v_0.level = $p0;
            $v_0.component = $p1;
            var $v_2 = $p2;
            if ($p3 && ($p3.length > 0)) {
                try {
                    $v_2 = Lync.Client.Common.StringHelper.format.apply(null, [ Lync.Client.Logging.LogDataHelper.$Z, $p2 ].concat($p3));
                }
                catch ($v_3) {
                }
            }
            $v_0.message = $v_2;
            $v_0.caller = Lync.Client.Logging.Utils.$y();
            if (($p0 & 1) === 1) {
                $v_0.stackTrace = Lync.Client.Logging.Utils.$12();
            }
            this.$q_0($v_0);
            this.$1C_0($v_0);
            this.$1H_0();
        }
        catch ($v_4) {
        }
    },
    
    $r_0: function Lync_Client_Logging_LoggingCore$$r_0($p0, $p1) {
        var $v_0 = false;
        if (this.$4_0) {
            if ($p1 <= 0 || $p1 >= 900) {
                return $v_0;
            }
            var $v_1 = this.$10_0($p1);
            if ($p0 <= 0 || $p0 >= 64 || (this.$11_0($v_1) & $p0) !== $p0) {
                return $v_0;
            }
            $v_0 = true;
        }
        return $v_0;
    },
    
    $10_0: function Lync_Client_Logging_LoggingCore$$10_0($p0) {
        var $v_0 = 0;
        var $v_1 = $p0 - ($p0 % 100);
        if ($v_1 < 900 && $v_1 > 0) {
            $v_0 = $v_1;
        }
        return $v_0;
    },
    
    $q_0: function Lync_Client_Logging_LoggingCore$$q_0($p0) {
        var $v_0 = this.$x_0($p0);
        this.$B_0 += $v_0;
        Array.add(this.$3_0, $p0);
    },
    
    $1H_0: function Lync_Client_Logging_LoggingCore$$1H_0() {
        if (this.$B_0 > this.$G_0) {
            var $v_0 = this.$3_0;
            this.$3_0 = [];
            this.$B_0 = 0;
            if (!this.$G_0) {
                this.$C_0 = true;
                Lync.Client.Logging.Log.$h($v_0);
                this.$C_0 = false;
            }
            else {
                Lync.Client.Logging.Log.$h($v_0);
            }
        }
    },
    
    $x_0: function Lync_Client_Logging_LoggingCore$$x_0($p0) {
        if (!$p0) {
            return 0;
        }
        var $v_0 = 0;
        if ($p0.timeString) {
            $v_0 += $p0.timeString.length;
        }
        if ($p0.caller) {
            $v_0 += $p0.caller.length;
        }
        $v_0 += 42;
        if ($p0.message) {
            $v_0 += $p0.message.length;
        }
        if ($p0.stackTrace) {
            $v_0 += $p0.stackTrace.length;
        }
        return $v_0;
    },
    
    $1C_0: function Lync_Client_Logging_LoggingCore$$1C_0($p0) {
        if ((this.$1_0) && (this.$1_0.length === 1) && (Lync.Client.Logging.ConsoleLogger.isInstanceOfType(this.$1_0[0])) && !Lync.Client.Logging.ConsoleHelper.get_$6()) {
            return;
        }
        if (this.$1_0 && this.$1_0.length > 0) {
            for (var $v_0 = 0; $v_0 < this.$1_0.length; $v_0++) {
                var $v_1 = this.$1_0[$v_0];
                if ($v_1) {
                    var $v_2 = $p0.serialize($v_1.getLineBreak());
                    $v_1.logOutput($p0.level, $p0.component, $p0.module, $v_2);
                }
            }
        }
    },
    
    $N_0: function Lync_Client_Logging_LoggingCore$$N_0($p0) {
        return String.format($p0, new Date().toString(), this.$V_0.toString());
    },
    
    $11_0: function Lync_Client_Logging_LoggingCore$$11_0($p0) {
        var $v_0 = 15;
        var $v_1 = $p0 / 100;
        $v_0 = this.$9_0[($p0).toString()];
        return $v_0;
    }
}


Lync.Client.Logging.Utils = function Lync_Client_Logging_Utils() {
}
Lync.Client.Logging.Utils.$y = function Lync_Client_Logging_Utils$$y() {
    var $v_0 = '';
    $v_0 = arguments.callee.caller.caller.caller.toString();
    return Lync.Client.Logging.Utils.$n($v_0);
}
Lync.Client.Logging.Utils.$n = function Lync_Client_Logging_Utils$$n($p0) {
    return ($p0.substring($p0.indexOf("function") + 8, $p0.indexOf("(")) || "anonymous");
}
Lync.Client.Logging.Utils.$12 = function Lync_Client_Logging_Utils$$12() {
    var $v_0 = new Sys.StringBuilder();
    var $v_1 = 'arguments.callee.caller.caller.caller';
    var $v_2 = 0;
    while (true) {
        var $v_3 = eval($v_1);
        if (!Lync.Client.Common.Utilities.isNullOrUndefined($v_3) && $v_2 < Lync.Client.Logging.Utils.$R) {
            $v_0.appendLine(Lync.Client.Logging.Utils.$n(eval($v_1).toString()));
            $v_1 += '.caller';
            $v_2++;
        }
        else {
            if ($v_2 >= Lync.Client.Logging.Utils.$R) {
                $v_0.appendLine(Lync.Client.Logging.Utils.$j);
            }
            break;
        }
    }
    return $v_0.toString();
}


Lync.Client.Logging.LoggerResources.registerClass('Lync.Client.Logging.LoggerResources');
Lync.Client.Logging.LogDataHelper.registerClass('Lync.Client.Logging.LogDataHelper');
Lync.Client.Logging.UtilLogger.registerClass('Lync.Client.Logging.UtilLogger', null, Lync.Client.Common.IUtilsLogProvider);
Lync.Client.Logging.ConsoleHelper.registerClass('Lync.Client.Logging.ConsoleHelper');
Lync.Client.Logging.ConsoleLogger.registerClass('Lync.Client.Logging.ConsoleLogger', null, Lync.Client.Logging.ILogger);
Lync.Client.Logging.FriendlyNames.registerClass('Lync.Client.Logging.FriendlyNames');
Lync.Client.Logging.LogData.registerClass('Lync.Client.Logging.LogData');
Lync.Client.Logging.LocalLogger.registerClass('Lync.Client.Logging.LocalLogger', null, Lync.Client.Logging.ILogger);
Lync.Client.Logging.Log.registerClass('Lync.Client.Logging.Log');
Lync.Client.Logging.TraceLevelsChangedEventArgs.registerClass('Lync.Client.Logging.TraceLevelsChangedEventArgs', Sys.EventArgs);
Lync.Client.Logging.TraceBufferFilledEventArgs.registerClass('Lync.Client.Logging.TraceBufferFilledEventArgs', Sys.EventArgs);
Lync.Client.Logging.LoggingCore.registerClass('Lync.Client.Logging.LoggingCore');
Lync.Client.Logging.Utils.registerClass('Lync.Client.Logging.Utils');
Lync.Client.Logging.LoggerResources.$A = null;
Lync.Client.Logging.LogDataHelper.$Z = new Lync.Client.Common.PIILogFormat();
Lync.Client.Logging.LogDataHelper.$T = 'Time, Level, Module, Component, Message, Caller [, Stack]';
Lync.Client.Logging.LogDataHelper.$l = '{0}, {1}, {2}, {3}, {4}, {5}';
Lync.Client.Logging.LogDataHelper.$m = '{0}, {1}, {2}, {3}, {4}, {5}, STACKTRACE:: {6}{7}';
Lync.Client.Logging.Log.$I = 'TraceLevelsChanged';
Lync.Client.Logging.Log.$H = 'TraceBufferFilled';
Lync.Client.Logging.Log.$5 = new Lync.Client.Common.EventSource();
Lync.Client.Logging.Log.$0 = null;
Lync.Client.Logging.Log.$L = null;
Lync.Client.Logging.Log.$J = null;
Lync.Client.Logging.Log.$K = null;
Lync.Client.Logging.Log.$M = null;
Lync.Client.Logging.Log.$f = '#Begin_Perf@{0}';
Lync.Client.Logging.Log.$g = '#End_Perf@{0}';
Lync.Client.Logging.Log.$a = 31;
Lync.Client.Logging.Log.$P = 11;
Lync.Client.Logging.Log.bucket_Light = 'Light';
Lync.Client.Logging.Log.bucket_Full = 'Full';
Lync.Client.Logging.Log.bucket_Off = 'Off';
Lync.Client.Logging.Utils.$R = 50;
Lync.Client.Logging.Utils.$j = 'TRUNCATED';
var clienttelemetry_build;
(function (clienttelemetry_build) {
    clienttelemetry_build.version = "2.6.0";
})(clienttelemetry_build || (clienttelemetry_build = {}));
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Tool     : bondc, Version=3.0.1, Build=bond-git.debug.not
//     Template : Microsoft.Bond.Rules.dll#TypeScript.tt
//     File     : bond_const.ts
//
//     Changes to this file may cause incorrect behavior and will be lost when
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------
var Microsoft;
(function (Microsoft) {
    (function (Bond) {
        (function (BondDataType) {
            BondDataType[BondDataType["BT_STOP"] = 0] = "BT_STOP";
            BondDataType[BondDataType["BT_STOP_BASE"] = 1] = "BT_STOP_BASE";
            BondDataType[BondDataType["BT_BOOL"] = 2] = "BT_BOOL";
            BondDataType[BondDataType["BT_UINT8"] = 3] = "BT_UINT8";
            BondDataType[BondDataType["BT_UINT16"] = 4] = "BT_UINT16";
            BondDataType[BondDataType["BT_UINT32"] = 5] = "BT_UINT32";
            BondDataType[BondDataType["BT_UINT64"] = 6] = "BT_UINT64";
            BondDataType[BondDataType["BT_FLOAT"] = 7] = "BT_FLOAT";
            BondDataType[BondDataType["BT_DOUBLE"] = 8] = "BT_DOUBLE";
            BondDataType[BondDataType["BT_STRING"] = 9] = "BT_STRING";
            BondDataType[BondDataType["BT_STRUCT"] = 10] = "BT_STRUCT";
            BondDataType[BondDataType["BT_LIST"] = 11] = "BT_LIST";
            BondDataType[BondDataType["BT_SET"] = 12] = "BT_SET";
            BondDataType[BondDataType["BT_MAP"] = 13] = "BT_MAP";
            BondDataType[BondDataType["BT_INT8"] = 14] = "BT_INT8";
            BondDataType[BondDataType["BT_INT16"] = 15] = "BT_INT16";
            BondDataType[BondDataType["BT_INT32"] = 16] = "BT_INT32";
            BondDataType[BondDataType["BT_INT64"] = 17] = "BT_INT64";
            BondDataType[BondDataType["BT_WSTRING"] = 18] = "BT_WSTRING";
            BondDataType[BondDataType["BT_UNAVAILABLE"] = 127] = "BT_UNAVAILABLE";
        })(Bond.BondDataType || (Bond.BondDataType = {}));
        var BondDataType = Bond.BondDataType;

        (function (ProtocolType) {
            ProtocolType[ProtocolType["MARSHALED_PROTOCOL"] = 0] = "MARSHALED_PROTOCOL";
            ProtocolType[ProtocolType["MAFIA_PROTOCOL"] = 17997] = "MAFIA_PROTOCOL";
            ProtocolType[ProtocolType["COMPACT_PROTOCOL"] = 16963] = "COMPACT_PROTOCOL";
            ProtocolType[ProtocolType["JSON_PROTOCOL"] = 21322] = "JSON_PROTOCOL";
            ProtocolType[ProtocolType["PRETTY_JSON_PROTOCOL"] = 20554] = "PRETTY_JSON_PROTOCOL";
            ProtocolType[ProtocolType["SIMPLE_PROTOCOL"] = 20563] = "SIMPLE_PROTOCOL";
        })(Bond.ProtocolType || (Bond.ProtocolType = {}));
        var ProtocolType = Bond.ProtocolType;
    })(Microsoft.Bond || (Microsoft.Bond = {}));
    var Bond = Microsoft.Bond;
})(Microsoft || (Microsoft = {}));
var Microsoft;
(function (Microsoft) {
    (function (Bond) {
        (function (Collections) {
            var Set = (function () {
                function Set() {
                    this._buffer = [];
                }
                Set.prototype.Add = function (t) {
                    var i = 0;
                    for (; i < this._buffer.length; ++i) {
                        if (this._buffer[i] == t) {
                            break;
                        }
                    }
                    if (i == this._buffer.length) {
                        this._buffer.push(t);
                    }
                };

                Set.prototype.Count = function () {
                    return this._buffer.length;
                };

                Set.prototype.GetBuffer = function () {
                    return this._buffer;
                };
                return Set;
            })();
            Collections.Set = Set;

            // Modified bond code to add AddorReplace and Remove for Map
            //TODO(abpanwar): Contact the bond team to add this to their library.
            var Map = (function () {
                function Map() {
                    this._buffer = [];
                }
                Map.prototype.Add = function (key, value) {
                    if (this._getIndex(key) == -1) {
                        this._buffer.push({ Key: key, Value: value });
                    }
                };

                Map.prototype.AddOrReplace = function (key, value) {
                    var i = this._getIndex(key);
                    if (i >= 0) {
                        this._buffer[i] = { Key: key, Value: value };
                    } else {
                        this._buffer.push({ Key: key, Value: value });
                    }
                };

                Map.prototype.Remove = function (key) {
                    var i = this._getIndex(key);
                    if (i >= 0) {
                        this._buffer.splice(i, 1);
                    }
                };

                Map.prototype.Count = function () {
                    return this._buffer.length;
                };

                Map.prototype.GetBuffer = function () {
                    return this._buffer;
                };

                Map.prototype.ContainsKey = function (key) {
                    if (this._getIndex(key) >= 0) {
                        return true;
                    }
                    return false;
                };

                Map.prototype.Get = function (key) {
                    var i = this._getIndex(key);
                    if (i >= 0) {
                        return this._buffer[i].Value;
                    }
                    return null;
                };

                Map.prototype._getIndex = function (key) {
                    var i = 0;
                    var index = -1;
                    for (; i < this._buffer.length; ++i) {
                        if (this._buffer[i].Key == key) {
                            index = i;
                            break;
                        }
                    }
                    return index;
                };
                return Map;
            })();
            Collections.Map = Map;
        })(Bond.Collections || (Bond.Collections = {}));
        var Collections = Bond.Collections;
    })(Microsoft.Bond || (Microsoft.Bond = {}));
    var Bond = Microsoft.Bond;
})(Microsoft || (Microsoft = {}));
var Microsoft;
(function (Microsoft) {
    (function (Bond) {
        (function (Encoding) {
            var Utf8 = (function () {
                function Utf8() {
                }
                Utf8.GetBytes = function (value) {
                    var array = [];
                    for (var i = 0; i < value.length; ++i) {
                        var char = value.charCodeAt(i);
                        if (char < 0x80) {
                            array.push(char);
                        } else if (char < 0x800) {
                            array.push(0xc0 | (char >> 6), 0x80 | (char & 0x3f));
                        } else if (char < 0xd800 || char >= 0xe000) {
                            array.push(0xe0 | (char >> 12), 0x80 | ((char >> 6) & 0x3f), 0x80 | (char & 0x3f));
                        } else {
                            char = 0x10000 + (((char & 0x3ff) << 10) | (value.charCodeAt(++i) & 0x3ff));
                            array.push(0xf0 | (char >> 18), 0x80 | ((char >> 12) & 0x3f), 0x80 | ((char >> 6) & 0x3f), 0x80 | (char & 0x3f));
                        }
                    }
                    return array;
                };
                return Utf8;
            })();
            Encoding.Utf8 = Utf8;

            var Base64 = (function () {
                function Base64() {
                }
                Base64.GetString = function (inArray) {
                    var lookup = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                    var output = [];
                    var paddingBytes = inArray.length % 3;
                    var i, temp, length;

                    var toBase64 = function (num) {
                        return [
                            lookup.charAt((num >> 18) & 0x3F),
                            lookup.charAt((num >> 12) & 0x3F),
                            lookup.charAt((num >> 6) & 0x3F),
                            lookup.charAt(num & 0x3F)].join("");
                    };

                    for (i = 0, length = inArray.length - paddingBytes; i < length; i += 3) {
                        temp = (inArray[i] << 16) + (inArray[i + 1] << 8) + (inArray[i + 2]);
                        output.push(toBase64(temp));
                    }

                    switch (paddingBytes) {
                        case 1:
                            temp = inArray[inArray.length - 1];
                            output.push(lookup.charAt(temp >> 2));
                            output.push(lookup.charAt((temp << 4) & 0x3F));
                            output.push('==');
                            break;

                        case 2:
                            temp = (inArray[inArray.length - 2] << 8) + (inArray[inArray.length - 1]);
                            output.push(lookup.charAt(temp >> 10));
                            output.push(lookup.charAt((temp >> 4) & 0x3F));
                            output.push(lookup.charAt((temp << 2) & 0x3F));
                            output.push('=');
                            break;
                    }
                    return output.join("");
                };
                return Base64;
            })();
            Encoding.Base64 = Base64;

            var Varint = (function () {
                function Varint() {
                }
                Varint.GetBytes = function (value) {
                    var array = [];
                    while (value & 0xffffff80) {
                        array.push((value & 0x7f) | 0x80);
                        value >>>= 7;
                    }
                    array.push(value & 0x7f);
                    return array;
                };
                return Varint;
            })();
            Encoding.Varint = Varint;

            var Varint64 = (function () {
                function Varint64() {
                }
                Varint64.GetBytes = function (value) {
                    var low = value.low;
                    var high = value.high;
                    var array = [];
                    while (high || (0xffffff80 & low)) {
                        array.push((low & 0x7f) | 0x80);
                        low = ((high & 0x7f) << 25) | (low >>> 7);
                        high >>>= 7;
                    }
                    array.push(low & 0x7f);
                    return array;
                };
                return Varint64;
            })();
            Encoding.Varint64 = Varint64;

            var Float = (function () {
                function Float() {
                }
                Float.GetBytes = function (value) {
                    if (Bond.BrowserChecker.IsDataViewSupport()) {
                        var view = new DataView(new ArrayBuffer(4));
                        view.setFloat32(0, value, true);

                        var array = [];
                        for (var i = 0; i < 4; ++i) {
                            array.push(view.getUint8(i));
                        }
                        return array;
                    } else {
                        return FloatUtils.ConvertNumberToArray(value, false);
                    }
                };
                return Float;
            })();
            Encoding.Float = Float;

            // Note: see notes of Float.
            var Double = (function () {
                function Double() {
                }
                Double.GetBytes = function (value) {
                    if (Bond.BrowserChecker.IsDataViewSupport()) {
                        var view = new DataView(new ArrayBuffer(8));
                        view.setFloat64(0, value, true);

                        var array = [];
                        for (var i = 0; i < 8; ++i) {
                            array.push(view.getUint8(i));
                        }
                        return array;
                    } else {
                        return FloatUtils.ConvertNumberToArray(value, true);
                    }
                };
                return Double;
            })();
            Encoding.Double = Double;

            var Zigzag = (function () {
                function Zigzag() {
                }
                Zigzag.EncodeZigzag16 = function (value) {
                    value = Bond.Number.ToInt16(value);
                    return ((value << 1) ^ (value >> (2 * 8 - 1)));
                };

                Zigzag.EncodeZigzag32 = function (value) {
                    value = Bond.Number.ToInt32(value);
                    return ((value << 1) ^ (value >> (4 * 8 - 1)));
                };

                Zigzag.EncodeZigzag64 = function (value) {
                    var low = value.low;
                    var high = value.high;
                    var tmpH = (high << 1) | (low >>> 31);
                    var tmpL = low << 1;
                    if (high & 0x80000000) {
                        tmpH = ~tmpH;
                        tmpL = ~tmpL;
                    }

                    var res = new Bond.UInt64("0");
                    res.low = tmpL;
                    res.high = tmpH;
                    return res;
                };
                return Zigzag;
            })();
            Encoding.Zigzag = Zigzag;
        })(Bond.Encoding || (Bond.Encoding = {}));
        var Encoding = Bond.Encoding;

        (function (Decoding) {
            var Utf8 = (function () {
                function Utf8() {
                }
                Utf8.GetString = function (data) {
                    var res = [];
                    for (var i = 0; i < data.length; ++i) {
                        var c1 = data[i];
                        if (c1 <= 191) {
                            res.push(String.fromCharCode(c1));
                        } else if (c1 <= 223) {
                            var c2 = data[++i];
                            res.push(String.fromCharCode(((c1 & 31) << 6) | (c2 & 63)));
                        } else if (c1 <= 239) {
                            var c2 = data[++i];
                            var c3 = data[++i];
                            res.push(String.fromCharCode(((c1 & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63)));
                        } else {
                            var c2 = data[++i];
                            var c3 = data[++i];
                            var c4 = data[++i];
                            c1 = ((c1 & 7) << 18) | ((c2 & 63) << 12) | ((c3 & 63) << 6) | (c4 & 63);
                            c1 -= 0x10000;
                            res.push(String.fromCharCode(0xd800 | ((c1 >> 10) & 0x3ff)));
                            res.push(String.fromCharCode(0xdc00 | (c1 & 0x3ff)));
                        }
                    }
                    return res.join("");
                };
                return Utf8;
            })();
            Decoding.Utf8 = Utf8;

            var Base64 = (function () {
                function Base64() {
                }
                Base64.GetBytes = function (base64Str) {
                    var lookup = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                    var res = [];
                    for (var i = 0; i < base64Str.length; ++i) {
                        var byte1 = lookup.indexOf(base64Str.charAt(i++));
                        var byte2 = lookup.indexOf(base64Str.charAt(i++));
                        var byte3 = lookup.indexOf(base64Str.charAt(i++));
                        var byte4 = lookup.indexOf(base64Str.charAt(i));

                        res.push(byte1 << 2 | byte2 >> 4);
                        if (byte3 >= 0) {
                            res.push((byte2 << 4) & 0xF0 | byte3 >> 2);

                            if (byte4 >= 0) {
                                res.push((byte3 << 6) & 0xC0 | byte4);
                            }
                        }
                    }
                    return res;
                };
                return Base64;
            })();
            Decoding.Base64 = Base64;

            var Varint = (function () {
                function Varint() {
                }
                Varint.GetInt64 = function (buffer) {
                    var int64 = new Microsoft.Bond.Int64("0");
                    var data = this._Read(buffer);
                    int64.low = data[0];
                    if (data.length > 1) {
                        int64.high = data[1];
                    }
                    return int64;
                };

                Varint.GetNumber = function (buffer) {
                    return this._Read(buffer)[0];
                };

                Varint._Read = function (buffer) {
                    var result = [];
                    var tmp = 0;
                    var hasMore = true;
                    var readedBits = 0;

                    while (hasMore) {
                        var raw = buffer.shift();
                        hasMore = (raw & 0x80) != 0;
                        raw = raw & 0x7F;
                        if (readedBits < 28) {
                            tmp |= raw << readedBits;
                            readedBits += 7;
                        } else {
                            // only lower 4 bits can be put
                            tmp |= raw << readedBits;
                            result.push(tmp);
                            tmp = raw >> 4;
                            readedBits = 3;
                            break;
                        }
                    }

                    while (hasMore) {
                        var raw = buffer.shift();
                        hasMore = (raw & 0x80) != 0;
                        raw = raw & 0x7F;
                        tmp |= raw << readedBits;
                        readedBits += 7;
                        if (readedBits >= 32) {
                            break;
                        }
                    }
                    result.push(tmp);
                    return result;
                };
                return Varint;
            })();
            Decoding.Varint = Varint;

            var Float = (function () {
                function Float() {
                }
                Float.GetNumber = function (buffer) {
                    if (Bond.BrowserChecker.IsDataViewSupport()) {
                        var view = new DataView(new ArrayBuffer(4));
                        for (var i = 0; i < 4; ++i) {
                            view.setUint8(i, buffer[i]);
                        }
                        return view.getFloat32(0, true);
                    } else {
                        return FloatUtils.ConvertArrayToNumber(buffer, false);
                    }
                };
                return Float;
            })();
            Decoding.Float = Float;

            var Double = (function () {
                function Double() {
                }
                Double.GetNumber = function (buffer) {
                    if (Bond.BrowserChecker.IsDataViewSupport()) {
                        var view = new DataView(new ArrayBuffer(8));
                        for (var i = 0; i < 8; ++i) {
                            view.setUint8(i, buffer[i]);
                        }
                        return view.getFloat64(0, true);
                    } else {
                        return FloatUtils.ConvertArrayToNumber(buffer, true);
                    }
                };
                return Double;
            })();
            Decoding.Double = Double;

            var Zigzag = (function () {
                function Zigzag() {
                }
                Zigzag.DecodeZigzag16 = function (value) {
                    return (((0xffff & value) >>> 1) ^ (-(value & 1))) << 16 >> 16;
                };

                Zigzag.DecodeZigzag32 = function (value) {
                    return (value >>> 1) ^ (-(value & 1));
                };

                Zigzag.DecodeZigzag64 = function (value) {
                    // implement
                    // (value >>> 1) ^ (-(value & 1))
                    var tmpH = value.high & 1;
                    var high = value.high >>> 1;
                    var tmpL = value.low & 1;
                    var low = value.low >>> 1;
                    low = tmpH << 31 | low;
                    if (tmpL) {
                        low ^= 0xffffffff;
                        high ^= 0xffffffff;
                    }

                    var res = new Microsoft.Bond.UInt64("0");
                    res.low = low;
                    res.high = high;
                    return res;
                };
                return Zigzag;
            })();
            Decoding.Zigzag = Zigzag;
        })(Bond.Decoding || (Bond.Decoding = {}));
        var Decoding = Bond.Decoding;

        /** This class will be used to convert float/double to byte array on browsers which doesn't
        support html5.
        
        Format: IEEE-754, littleEndian, http://en.wikipedia.org/wiki/IEEE_754-1985
        
        \note
        1. Don't have negative zero. All zero will be positive zero.
        2. If the buffer array passed to ConvertArrayToFloat() is actual NaN or Inifinity value,
        exception will be raised.
        */
        var FloatUtils = (function () {
            function FloatUtils() {
            }
            FloatUtils.ConvertNumberToArray = function (num, isDouble) {
                if (!num) {
                    return isDouble ? this._doubleZero : this._floatZero;
                }

                var exponentBits = isDouble ? 11 : 8;
                var precisionBits = isDouble ? 52 : 23;

                // follow IEEE-754, exponent bias is 2^(k-1)-1 where k is the number of bits
                // in the exponent: http://en.wikipedia.org/wiki/Exponent_bias
                var bias = (1 << (exponentBits - 1)) - 1;
                var minExponent = 1 - bias;
                var maxExponent = bias;

                var sign = num < 0 ? 1 : 0;
                num = Math.abs(num);
                var intPart = Math.floor(num);
                var floatPart = num - intPart;

                var len = 2 * (bias + 2) + precisionBits;
                var buffer = new Array(len);
                var i = 0;
                while (i < len) {
                    buffer[i++] = 0;
                }

                // caculate the intPart
                i = bias + 2;
                while (i && intPart) {
                    buffer[--i] = intPart % 2;
                    intPart = Math.floor(intPart / 2);
                }

                // caculate the floatPart
                i = bias + 1;
                while (i < len - 1 && floatPart > 0) {
                    floatPart *= 2;
                    if (floatPart >= 1) {
                        buffer[++i] = 1;
                        --floatPart;
                    } else {
                        buffer[++i] = 0;
                    }
                }

                // find the first 1
                var firstBit = 0;
                for (; firstBit < len && !buffer[firstBit]; ++firstBit)
                    ;

                // caculate exponent
                var exponent = bias + 1 - firstBit;

                // caculate round
                var lastBit = firstBit + precisionBits;
                if (buffer[lastBit + 1]) {
                    for (i = lastBit; i > firstBit; --i) {
                        if (buffer[i] = 1 - buffer[i]) {
                            break;
                        }
                    }
                    if (i == firstBit) {
                        ++exponent;
                    }
                }

                // check overflow
                if (exponent > maxExponent || intPart) {
                    if (sign) {
                        return isDouble ? this._doubleNegInifinity : this._floatNegInifinity;
                    } else {
                        return isDouble ? this._doubleInifinity : this._floatInifinity;
                    }
                } else if (exponent < minExponent) {
                    return isDouble ? this._doubleZero : this._floatZero;
                }

                // caculate the result
                if (isDouble) {
                    var high = 0;
                    for (i = 0; i < 20; ++i) {
                        high = (high << 1) | buffer[++firstBit];
                    }

                    var low = 0;
                    for (; i < 52; ++i) {
                        low = (low << 1) | buffer[++firstBit];
                    }

                    high |= (exponent + bias) << 20;
                    high = (sign << 31) | (high & 0x7FFFFFFF);

                    var resArray = [
                        low & 0xff, (low >> 8) & 0xff, (low >> 16) & 0xff, low >>> 24,
                        high & 0xff, (high >> 8) & 0xff, (high >> 16) & 0xff, high >>> 24];
                    return resArray;
                } else {
                    var result = 0;
                    for (i = 0; i < 23; ++i) {
                        result = (result << 1) | buffer[++firstBit];
                    }

                    result |= (exponent + bias) << 23;
                    result = (sign << 31) | (result & 0x7FFFFFFF);

                    var resArray = [result & 0xff, (result >> 8) & 0xff, (result >> 16) & 0xff, result >>> 24];
                    return resArray;
                }
            };

            FloatUtils.ConvertArrayToNumber = function (buffer, isDouble) {
                var exponentBits = isDouble ? 11 : 8;
                var bias = (1 << (exponentBits - 1)) - 1;
                var sign = (buffer[isDouble ? 7 : 3] & 0x80) != 0;
                var exponent = isDouble ? ((buffer[7] & 0x7f) << 4) | ((buffer[6] & 0xf0) >> 4) : ((buffer[3] & 0x7f) << 1) | ((buffer[2] & 0x80) >> 7);

                // check the buffer is valid or not. If it is invalid (NaN, Infinitive), throw execption.
                if (exponent == 0xff) {
                    throw new Bond.Exception("Not a valid float/double buffer.");
                }

                var res = 1;
                var e = 1;
                if (isDouble) {
                    var high = ((buffer[6] & 0xf) << 28) | ((buffer[5] & 0xff) << 20) | ((buffer[4] & 0xff) << 12);
                    var low = (buffer[3] << 24) | ((buffer[2] & 0xff) << 16) | ((buffer[1] & 0xff) << 8) | (buffer[0] & 0xff);
                    if (!exponent && !high && !low) {
                        return 0.0;
                    }
                    for (var i = 0; i < 20; ++i) {
                        e /= 2;
                        if (high < 0) {
                            res += e;
                        }
                        high <<= 1;
                    }
                    for (var i = 0; i < 32; ++i) {
                        e /= 2;
                        if (low < 0) {
                            res += e;
                        }
                        low <<= 1;
                    }
                } else {
                    var data = ((buffer[2] & 0x7f) << 25) | ((buffer[1] & 0xff) << 17) | ((buffer[0] & 0xff) << 9);
                    if (!exponent && !data) {
                        return 0.0;
                    }
                    for (var i = 0; i < 23; ++i) {
                        e /= 2;
                        if (data < 0) {
                            res += e;
                        }
                        data <<= 1;
                    }
                }
                res *= Math.pow(2, exponent - bias);
                return sign ? 0 - res : res;
            };
            FloatUtils._floatZero = [0x00, 0x00, 0x00, 0x00];
            FloatUtils._doubleZero = [0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00];
            FloatUtils._floatInifinity = [0x00, 0x00, 0x80, 0x7F];
            FloatUtils._floatNegInifinity = [0x00, 0x00, 0x80, 0xFF];
            FloatUtils._doubleInifinity = [0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x7f];
            FloatUtils._doubleNegInifinity = [0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xff];
            return FloatUtils;
        })();
    })(Microsoft.Bond || (Microsoft.Bond = {}));
    var Bond = Microsoft.Bond;
})(Microsoft || (Microsoft = {}));
var Microsoft;
(function (Microsoft) {
    (function (Bond) {
        (function (IO) {
            var MemoryStream = (function () {
                function MemoryStream() {
                    this._buffer = [];
                }
                /*override*/
                MemoryStream.prototype.WriteByte = function (byte) {
                    this._buffer.push(Bond.Number.ToByte(byte));
                };

                /*override*/
                MemoryStream.prototype.Write = function (buffer, offset, count) {
                    while (count--) {
                        this.WriteByte(buffer[offset++]);
                    }
                };

                /**
                * Returns the array of unsigned bytes from which this stream was created.
                */
                MemoryStream.prototype.GetBuffer = function () {
                    return this._buffer;
                };
                return MemoryStream;
            })();
            IO.MemoryStream = MemoryStream;
        })(Bond.IO || (Bond.IO = {}));
        var IO = Bond.IO;
    })(Microsoft.Bond || (Microsoft.Bond = {}));
    var Bond = Microsoft.Bond;
})(Microsoft || (Microsoft = {}));
var Microsoft;
(function (Microsoft) {
    (function (Bond) {
        var FieldTag = (function () {
            function FieldTag(type, id) {
                this.Type = type;
                this.Id = id;
            }
            return FieldTag;
        })();
        Bond.FieldTag = FieldTag;

        var ContainerTag = (function () {
            function ContainerTag(elementType, size) {
                this.ElementType = elementType;
                this.Size = size;
            }
            return ContainerTag;
        })();
        Bond.ContainerTag = ContainerTag;

        var KeyValueContainerTag = (function () {
            function KeyValueContainerTag(keyType, valueType, size) {
                this.KeyType = keyType;
                this.ValueType = valueType;
                this.Size = size;
            }
            return KeyValueContainerTag;
        })();
        Bond.KeyValueContainerTag = KeyValueContainerTag;

        var Bonded = (function () {
            function Bonded() {
            }
            return Bonded;
        })();
        Bond.Bonded = Bonded;

        var Int64 = (function () {
            // BUG!!: need implement, currently, just handle 32bits number
            function Int64(numberStr) {
                this.low = 0;
                this.high = 0;
                this.low = parseInt(numberStr);
                if (this.low < 0) {
                    this.high = -1;
                }
            }
            Int64.prototype.Equals = function (numberStr) {
                var tmp = new Int64(numberStr);
                return this.low == tmp.low && this.high == tmp.high;
            };
            return Int64;
        })();
        Bond.Int64 = Int64;

        var UInt64 = (function () {
            // BUG!!: need implement, currently, just handle 32bits number
            function UInt64(numberStr) {
                this.low = 0;
                this.high = 0;
                this.low = parseInt(numberStr);
            }
            UInt64.prototype.Equals = function (numberStr) {
                var tmp = new UInt64(numberStr);
                return this.low == tmp.low && this.high == tmp.high;
            };
            return UInt64;
        })();
        Bond.UInt64 = UInt64;

        var Number = (function () {
            function Number() {
            }
            Number.ToByte = function (value) {
                return this.ToUInt8(value);
            };

            Number.ToInt8 = function (value) {
                var signMask = (value & 0x80) << 24 >> 24;
                return (value & 0x7f) | signMask;
            };

            Number.ToInt16 = function (value) {
                var signMask = (value & 0x8000) << 16 >> 16;
                return (value & 0x7fff) | signMask;
            };

            Number.ToInt32 = function (value) {
                var signMask = (value & 0x80000000);
                return (value & 0x7fffffff) | signMask;
            };

            Number.ToUInt8 = function (value) {
                return value & 0xff;
            };

            Number.ToUInt16 = function (value) {
                return value & 0xffff;
            };

            Number.ToUInt32 = function (value) {
                return value & 0xffffffff;
            };
            return Number;
        })();
        Bond.Number = Number;

        var Exception = (function () {
            function Exception(message) {
                this.Message = message;
            }
            return Exception;
        })();
        Bond.Exception = Exception;

        var KeyValuePair = (function () {
            function KeyValuePair() {
            }
            return KeyValuePair;
        })();
        Bond.KeyValuePair = KeyValuePair;
        ;

        var BrowserChecker = (function () {
            function BrowserChecker() {
            }
            BrowserChecker.IsDataViewSupport = function () {
                return typeof ArrayBuffer != "undefined" && typeof DataView != "undefined";
            };
            return BrowserChecker;
        })();
        Bond.BrowserChecker = BrowserChecker;
    })(Microsoft.Bond || (Microsoft.Bond = {}));
    var Bond = Microsoft.Bond;
})(Microsoft || (Microsoft = {}));

var Microsoft;
(function (Microsoft) {
    (function (Bond) {


        var CompactBinaryProtocolWriter = (function () {
            function CompactBinaryProtocolWriter(stream) {
                this._stream = stream;
            }
            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteBlob = function (blob) {
                this._stream.Write(blob, 0, blob.length);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteBool = function (value) {
                this._stream.WriteByte(value ? 1 : 0);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteContainerBegin = function (size, elementType) {
                this.WriteUInt8(elementType);
                this.WriteUInt32(size);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteMapContainerBegin = function (size, keyType, valueType) {
                this.WriteUInt8(keyType);
                this.WriteUInt8(valueType);
                this.WriteUInt32(size);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteContainerEnd = function () {
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteDouble = function (value) {
                var array = Bond.Encoding.Double.GetBytes(value);
                this._stream.Write(array, 0, array.length);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteFloat = function (value) {
                var array = Bond.Encoding.Float.GetBytes(value);
                this._stream.Write(array, 0, array.length);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteFieldBegin = function (type, id, metadata) {
                if (id <= 5) {
                    this._stream.WriteByte(type | (id << 5));
                } else if (id <= 0xff) {
                    this._stream.WriteByte(type | (6 << 5));
                    this._stream.WriteByte(id);
                } else {
                    this._stream.WriteByte(type | (7 << 5));
                    this._stream.WriteByte(id);
                    this._stream.WriteByte(id >> 8);
                }
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteFieldEnd = function () {
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteFieldOmitted = function (type, id, metadata) {
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteInt16 = function (value) {
                value = Bond.Encoding.Zigzag.EncodeZigzag16(value);
                this.WriteUInt16(value);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteInt32 = function (value) {
                value = Bond.Encoding.Zigzag.EncodeZigzag32(value);
                this.WriteUInt32(value);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteInt64 = function (value) {
                this.WriteUInt64(Bond.Encoding.Zigzag.EncodeZigzag64(value));
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteInt8 = function (value) {
                this._stream.WriteByte(Bond.Number.ToInt8(value));
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteString = function (value) {
                if (value == "") {
                    this.WriteUInt32(0);
                } else {
                    var array = Bond.Encoding.Utf8.GetBytes(value);
                    this.WriteUInt32(array.length);
                    this._stream.Write(array, 0, array.length);
                }
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteStructBegin = function (metadata, isBase) {
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteStructEnd = function (isBase) {
                this.WriteUInt8(isBase ? 1 /* BT_STOP_BASE */ : 0 /* BT_STOP */);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteUInt16 = function (value) {
                var array = Bond.Encoding.Varint.GetBytes(Bond.Number.ToUInt16(value));
                this._stream.Write(array, 0, array.length);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteUInt32 = function (value) {
                var array = Bond.Encoding.Varint.GetBytes(Bond.Number.ToUInt32(value));
                this._stream.Write(array, 0, array.length);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteUInt64 = function (value) {
                var array = Bond.Encoding.Varint64.GetBytes(value);
                this._stream.Write(array, 0, array.length);
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteUInt8 = function (value) {
                this._stream.WriteByte(Bond.Number.ToUInt8(value));
            };

            /*override*/
            CompactBinaryProtocolWriter.prototype.WriteWString = function (value) {
                this.WriteUInt32(value.length);
                for (var i = 0; i < value.length; ++i) {
                    var charCode = value.charCodeAt(i);
                    this._stream.WriteByte(charCode);
                    this._stream.WriteByte(charCode >>> 8);
                }
            };
            return CompactBinaryProtocolWriter;
        })();
        Bond.CompactBinaryProtocolWriter = CompactBinaryProtocolWriter;

        var CompactBinaryProtocolReader = (function () {
            function CompactBinaryProtocolReader() {
            }
            return CompactBinaryProtocolReader;
        })();
        Bond.CompactBinaryProtocolReader = CompactBinaryProtocolReader;
    })(Microsoft.Bond || (Microsoft.Bond = {}));
    var Bond = Microsoft.Bond;
})(Microsoft || (Microsoft = {}));
var sct;
(function (sct) {
    var Utils = (function () {
        function Utils() {
        }
        Utils.IsSafari = function () {
            if (Utils._isSafari === null) {
                Utils._DetectBrowser();
            }
            return Utils._isSafari;
        };

        //
        // options: {
        //      type:   "GET" or "POST",
        //      url:
        //      headers: {
        //          key1: value1
        //          key2: value2
        //      },
        //      complete: function(xhr)
        // }
        //
        Utils.ajax = function (options, syncRequest) {
            var conn = Utils._createConnection();

            if (options.headers) {
                var params = "qsp=true";
                for (var key in options.headers) {
                    params += "&";
                    params += encodeURIComponent(key);
                    params += "=";
                    params += encodeURIComponent(options.headers[key]);
                }

                if (options.url.indexOf("?") < 0) {
                    options.url += "?";
                } else {
                    options.url += "&";
                }
                options.url += params;
            }

            conn.open(options.type, options.url, !syncRequest);

            if (options.complete) {
                conn.onload = function () {
                    if (typeof conn.status == "undefined") {
                        conn.status = 200;
                    }
                    options.complete(conn);
                };

                conn.ontimeout = function () {
                    if (typeof conn.status == "undefined") {
                        conn.status = 500;
                    }
                    options.complete(conn);
                };

                conn.onerror = function () {
                    options.complete(conn);
                };
            }

            conn.send(options.data);
        };

        // This is a workaround for IE8. That it does not support
        // Object.keys.
        Utils.keys = function (dict) {
            if (Object.keys) {
                return Object.keys(dict);
            } else {
                var keys = [];
                for (var eachKey in dict) {
                    if (dict.hasOwnProperty(eachKey)) {
                        keys.push(eachKey);
                    }
                }
                return keys;
            }
        };
        Utils.IsUsingXDomainRequest = function () {
            if (Utils._usingXDomainRequest == null) {
                var conn = new XMLHttpRequest();
                if (typeof conn.withCredentials == "undefined" && typeof XDomainRequest != "undefined") {
                    Utils._usingXDomainRequest = true;
                } else {
                    Utils._usingXDomainRequest = false;
                }
            }
            return Utils._usingXDomainRequest;
        };

        Utils._createConnection = function () {
            // for all browsers create standard XMLHttpRequest();
            var conn = new XMLHttpRequest();
            if (Utils.IsUsingXDomainRequest()) {
                // this is IE8/IE9, we should use XDomainRequest to support cross domain
                return new XDomainRequest();
            }
            return conn;
        };

        Utils._DetectBrowser = function () {
            var ua = navigator.userAgent.toLowerCase();
            if (ua.indexOf('safari') >= 0 && ua.indexOf('chrome') < 0) {
                Utils._isSafari = true;
            } else {
                Utils._isSafari = false;
            }
        };
        Utils._isSafari = null;
        Utils._usingXDomainRequest = null;
        return Utils;
    })();
    sct.Utils = Utils;
})(sct || (sct = {}));
var microsoft;
(function (microsoft) {
    (function (applications) {
        //------------------------------------------------------------------------------
        //     This code was generated by using the bondc tool and modified to remove
        //      deserialization because it is unused.
        //
        //     Tool     : bondc, Version=3.0.1, Build=bond-git.debug.not
        //     Template : Microsoft.Bond.Rules.dll#TypeScript.tt
        //     File     : DataPackage.ts
        //
        //     Changes to this file may cause incorrect behavior and will be lost when
        //     the code is regenerated.
        //------------------------------------------------------------------------------
        (function (telemetry) {
            (function (datamodels) {
                var utils = (function () {
                    function utils() {
                    }
                    utils.GetGuid = function () {
                        var rd = function () {
                            return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1, 5);
                        };
                        return [rd(), rd(), '-', rd(), '-', rd(), '-', rd(), '-', rd(), rd(), rd()].join("");
                    };

                    utils.GetTimeStamp = function () {
                        var val = new Date().getTime();
                        var timestamp = new Microsoft.Bond.Int64("0");
                        timestamp.low = val & 0xffffffff;
                        timestamp.high = Math.floor(val / 0x100000000);
                        return timestamp;
                    };

                    utils.GetTimeStampWithValue = function (timestamp) {
                        var bond_timestamp = new Microsoft.Bond.Int64("0");
                        bond_timestamp.low = timestamp & 0xffffffff;
                        bond_timestamp.high = Math.floor(timestamp / 0x100000000);
                        return bond_timestamp;
                    };
                    return utils;
                })();
                datamodels.utils = utils;

                (function (RecordType) {
                    RecordType[RecordType["NotSet"] = 0] = "NotSet";
                    RecordType[RecordType["Event"] = 1] = "Event";

                    // Deprecated, please use PerformanceCounterAzure and PerformanceCounterGfs instead
                    RecordType[RecordType["PerformanceCounter"] = 2] = "PerformanceCounter";
                    RecordType[RecordType["Anomaly"] = 3] = "Anomaly";
                    RecordType[RecordType["Prediction"] = 4] = "Prediction";
                    RecordType[RecordType["TraceLog"] = 5] = "TraceLog";
                    RecordType[RecordType["EventSourceLog"] = 6] = "EventSourceLog";
                    RecordType[RecordType["HttpLog"] = 7] = "HttpLog";
                    RecordType[RecordType["PerformanceCounterAzure"] = 8] = "PerformanceCounterAzure";
                    RecordType[RecordType["PerformanceCounterGfs"] = 9] = "PerformanceCounterGfs";
                })(datamodels.RecordType || (datamodels.RecordType = {}));
                var RecordType = datamodels.RecordType;

                (function (PIIScrubber) {
                    PIIScrubber[PIIScrubber["NotSet"] = 0] = "NotSet";
                    PIIScrubber[PIIScrubber["O365"] = 1] = "O365";
                    PIIScrubber[PIIScrubber["SkypeBI"] = 2] = "SkypeBI";
                    PIIScrubber[PIIScrubber["SkypeData"] = 3] = "SkypeData";
                })(datamodels.PIIScrubber || (datamodels.PIIScrubber = {}));
                var PIIScrubber = datamodels.PIIScrubber;

                (function (PIIKind) {
                    PIIKind[PIIKind["NotSet"] = 0] = "NotSet";
                    PIIKind[PIIKind["DistinguishedName"] = 1] = "DistinguishedName";
                    PIIKind[PIIKind["GenericData"] = 2] = "GenericData";
                    PIIKind[PIIKind["IPV4Address"] = 3] = "IPV4Address";
                    PIIKind[PIIKind["IPv6Address"] = 4] = "IPv6Address";
                    PIIKind[PIIKind["MailSubject"] = 5] = "MailSubject";
                    PIIKind[PIIKind["PhoneNumber"] = 6] = "PhoneNumber";
                    PIIKind[PIIKind["QueryString"] = 7] = "QueryString";
                    PIIKind[PIIKind["SipAddress"] = 8] = "SipAddress";
                    PIIKind[PIIKind["SmtpAddress"] = 9] = "SmtpAddress";
                    PIIKind[PIIKind["Identity"] = 10] = "Identity";
                    PIIKind[PIIKind["Uri"] = 11] = "Uri";
                    PIIKind[PIIKind["Fqdn"] = 12] = "Fqdn";

                    // Supports scrubbing of the last octet in a IPV4 address. E.g. 10.121.227.147 becomes 10.121.227.*
                    PIIKind[PIIKind["IPV4AddressLegacy"] = 13] = "IPV4AddressLegacy";
                })(datamodels.PIIKind || (datamodels.PIIKind = {}));
                var PIIKind = datamodels.PIIKind;

                var PII = (function () {
                    function PII() {
                        // 1: optional PIIScrubber ScrubType
                        this.ScrubType = 0 /* NotSet */;
                        // 2: optional PIIKind Kind
                        this.Kind = 0 /* NotSet */;
                        // 3: optional string RawContent
                        this.RawContent = "";
                    }
                    PII.prototype.Write = function (writer) {
                        this.WriteImpl(writer, false);
                    };

                    PII.prototype.WriteImpl = function (writer, isBase) {
                        writer.WriteStructBegin(null, isBase);

                        if (this.ScrubType != 0 /* NotSet */) {
                            writer.WriteFieldBegin(16 /* BT_INT32 */, 1, null);
                            writer.WriteInt32(this.ScrubType);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(16 /* BT_INT32 */, 1, null);
                        }
                        if (this.Kind != 0 /* NotSet */) {
                            writer.WriteFieldBegin(16 /* BT_INT32 */, 2, null);
                            writer.WriteInt32(this.Kind);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(16 /* BT_INT32 */, 2, null);
                        }
                        if (this.RawContent != "") {
                            writer.WriteFieldBegin(9 /* BT_STRING */, 3, null);
                            writer.WriteString(this.RawContent);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(9 /* BT_STRING */, 3, null);
                        }
                        writer.WriteStructEnd(isBase);
                    };

                    PII.prototype.Read = function (reader) {
                        this.ReadImpl(reader, false);
                    };

                    PII.prototype.ReadImpl = function (reader, isBase) {
                    };
                    return PII;
                })();
                datamodels.PII = PII;

                var Record = (function () {
                    function Record() {
                        // 1: optional string Id
                        this.Id = utils.GetGuid();
                        // 3: optional int64 Timestamp
                        this.Timestamp = utils.GetTimeStamp();
                        // 5: optional string Type
                        this.Type = "";
                        // 6: optional string EventType
                        this.EventType = "";
                        // 13: optional map<string, string> Extension
                        this.Extension = new Microsoft.Bond.Collections.Map();
                        // 24: optional RecordType RecordType
                        this.RecordType = 0 /* NotSet */;
                        // 30: optional map<string, PII> PIIExtensions
                        this.PIIExtensions = new Microsoft.Bond.Collections.Map();
                    }
                    Record.prototype.AddOrReplacePII = function (key, piiValue, piiKind) {
                        var pii = new telemetry.datamodels.PII();
                        pii.RawContent = piiValue;
                        pii.Kind = piiKind;
                        pii.ScrubType = 1 /* O365 */;
                        this.PIIExtensions.AddOrReplace(key, pii);
                    };

                    Record.prototype.Write = function (writer) {
                        this.WriteImpl(writer, false);
                    };

                    Record.prototype.WriteImpl = function (writer, isBase) {
                        writer.WriteStructBegin(null, isBase);

                        if (this.Id != "") {
                            writer.WriteFieldBegin(9 /* BT_STRING */, 1, null);
                            writer.WriteString(this.Id);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(9 /* BT_STRING */, 1, null);
                        }
                        if (!this.Timestamp.Equals("0")) {
                            writer.WriteFieldBegin(17 /* BT_INT64 */, 3, null);
                            writer.WriteInt64(this.Timestamp);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(17 /* BT_INT64 */, 3, null);
                        }
                        if (this.Type != "") {
                            writer.WriteFieldBegin(9 /* BT_STRING */, 5, null);
                            writer.WriteString(this.Type);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(9 /* BT_STRING */, 5, null);
                        }
                        if (this.EventType != "") {
                            writer.WriteFieldBegin(9 /* BT_STRING */, 6, null);
                            writer.WriteString(this.EventType);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(9 /* BT_STRING */, 6, null);
                        }
                        if (this.Extension.Count()) {
                            writer.WriteFieldBegin(13 /* BT_MAP */, 13, null);
                            writer.WriteMapContainerBegin(this.Extension.Count(), 9 /* BT_STRING */, 9 /* BT_STRING */);
                            for (var i8 = 0; i8 < this.Extension.GetBuffer().length; ++i8) {
                                writer.WriteString(this.Extension.GetBuffer()[i8].Key);
                                writer.WriteString(this.Extension.GetBuffer()[i8].Value);
                            }
                            writer.WriteContainerEnd();
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(13 /* BT_MAP */, 13, null);
                        }
                        if (this.RecordType != 0 /* NotSet */) {
                            writer.WriteFieldBegin(16 /* BT_INT32 */, 24, null);
                            writer.WriteInt32(this.RecordType);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(16 /* BT_INT32 */, 24, null);
                        }
                        if (this.PIIExtensions.Count()) {
                            writer.WriteFieldBegin(13 /* BT_MAP */, 30, null);
                            writer.WriteMapContainerBegin(this.PIIExtensions.Count(), 9 /* BT_STRING */, 10 /* BT_STRUCT */);
                            for (var i66 = 0; i66 < this.PIIExtensions.GetBuffer().length; ++i66) {
                                writer.WriteString(this.PIIExtensions.GetBuffer()[i66].Key);
                                this.PIIExtensions.GetBuffer()[i66].Value.WriteImpl(writer, false);
                            }
                            writer.WriteContainerEnd();
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(13 /* BT_MAP */, 30, null);
                        }
                        writer.WriteStructEnd(isBase);
                    };

                    Record.prototype.Read = function (reader) {
                        this.ReadImpl(reader, false);
                    };

                    Record.prototype.ReadImpl = function (reader, isBase) {
                    };
                    return Record;
                })();
                datamodels.Record = Record;

                var DataPackage = (function () {
                    function DataPackage() {
                        // 2: optional string Source
                        this.Source = "";
                        // 5: optional string DataPackageId
                        this.DataPackageId = "";
                        // 6: optional int64 Timestamp
                        this.Timestamp = new Microsoft.Bond.Int64("0");
                        // 8: optional vector<clienttelemetry.data.v1.Record> Records
                        this.Records = [];
                    }
                    DataPackage.prototype.Write = function (writer) {
                        this.WriteImpl(writer, false);
                    };

                    DataPackage.prototype.WriteImpl = function (writer, isBase) {
                        writer.WriteStructBegin(null, isBase);

                        if (this.Source != "") {
                            writer.WriteFieldBegin(9 /* BT_STRING */, 2, null);
                            writer.WriteString(this.Source);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(9 /* BT_STRING */, 2, null);
                        }
                        if (this.DataPackageId != "") {
                            writer.WriteFieldBegin(9 /* BT_STRING */, 5, null);
                            writer.WriteString(this.DataPackageId);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(9 /* BT_STRING */, 5, null);
                        }
                        if (!this.Timestamp.Equals("0")) {
                            writer.WriteFieldBegin(17 /* BT_INT64 */, 6, null);
                            writer.WriteInt64(this.Timestamp);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(17 /* BT_INT64 */, 6, null);
                        }
                        if (this.Records.length) {
                            writer.WriteFieldBegin(11 /* BT_LIST */, 8, null);
                            writer.WriteContainerBegin(this.Records.length, 10 /* BT_STRUCT */);
                            for (var i52 = 0; i52 < this.Records.length; ++i52) {
                                this.Records[i52].WriteImpl(writer, false);
                            }
                            writer.WriteContainerEnd();
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(11 /* BT_LIST */, 8, null);
                        }
                        writer.WriteStructEnd(isBase);
                    };

                    DataPackage.prototype.Read = function (reader) {
                        this.ReadImpl(reader, false);
                    };

                    DataPackage.prototype.ReadImpl = function (reader, isBase) {
                    };
                    return DataPackage;
                })();
                datamodels.DataPackage = DataPackage;

                var ClientToCollectorRequest = (function () {
                    function ClientToCollectorRequest() {
                        // 1: optional vector<clienttelemetry.data.v1.DataPackage> DataPackages
                        this.DataPackages = [];
                        // 2: optional int32 RequestRetryCount
                        this.RequestRetryCount = 0;
                    }
                    ClientToCollectorRequest.prototype.Write = function (writer) {
                        this.WriteImpl(writer, false);
                    };

                    ClientToCollectorRequest.prototype.WriteImpl = function (writer, isBase) {
                        writer.WriteStructBegin(null, isBase);

                        if (this.DataPackages.length) {
                            writer.WriteFieldBegin(11 /* BT_LIST */, 1, null);
                            writer.WriteContainerBegin(this.DataPackages.length, 10 /* BT_STRUCT */);
                            for (var i67 = 0; i67 < this.DataPackages.length; ++i67) {
                                this.DataPackages[i67].WriteImpl(writer, false);
                            }
                            writer.WriteContainerEnd();
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(11 /* BT_LIST */, 1, null);
                        }
                        if (this.RequestRetryCount != 0) {
                            writer.WriteFieldBegin(16 /* BT_INT32 */, 2, null);
                            writer.WriteInt32(this.RequestRetryCount);
                            writer.WriteFieldEnd();
                        } else {
                            writer.WriteFieldOmitted(16 /* BT_INT32 */, 2, null);
                        }
                        writer.WriteStructEnd(isBase);
                    };

                    ClientToCollectorRequest.prototype.Read = function (reader) {
                        this.ReadImpl(reader, false);
                    };

                    ClientToCollectorRequest.prototype.ReadImpl = function (reader, isBase) {
                    };
                    return ClientToCollectorRequest;
                })();
                datamodels.ClientToCollectorRequest = ClientToCollectorRequest;
            })(telemetry.datamodels || (telemetry.datamodels = {}));
            var datamodels = telemetry.datamodels;
        })(applications.telemetry || (applications.telemetry = {}));
        var telemetry = applications.telemetry;
    })(microsoft.applications || (microsoft.applications = {}));
    var applications = microsoft.applications;
})(microsoft || (microsoft = {}));
/** \file clienttelemetry.ts
This filed defined the _sender class.
\author yuboxie
\date 2013-12
*/
var microsoft;
(function (microsoft) {
    (function (applications) {
        //TODO(abpanwar): rename files to better match the inner module
        (function (telemetry) {
            (function (_sender) {


                (function (CallbackEventType) {
                    CallbackEventType[CallbackEventType["SENT"] = 0] = "SENT";
                    CallbackEventType[CallbackEventType["SEND_FAILED"] = 1] = "SEND_FAILED";
                })(_sender.CallbackEventType || (_sender.CallbackEventType = {}));
                var CallbackEventType = _sender.CallbackEventType;

                (function (DATARV_ERROR) {
                    DATARV_ERROR[DATARV_ERROR["DATARV_ERROR_OK"] = 0] = "DATARV_ERROR_OK";
                    DATARV_ERROR[DATARV_ERROR["DATARV_ERROR_INVALID_EVENT"] = 1] = "DATARV_ERROR_INVALID_EVENT";
                    DATARV_ERROR[DATARV_ERROR["DATARV_ERROR_INVALID_CONFIG"] = 2] = "DATARV_ERROR_INVALID_CONFIG";
                    DATARV_ERROR[DATARV_ERROR["DATARV_ERROR_INVALID_DEPENDENCIES"] = 3] = "DATARV_ERROR_INVALID_DEPENDENCIES";
                    DATARV_ERROR[DATARV_ERROR["DATARV_ERROR_INVALID_STATUS"] = 4] = "DATARV_ERROR_INVALID_STATUS";
                    DATARV_ERROR[DATARV_ERROR["DATARV_ERROR_INVALID_ARG"] = 5] = "DATARV_ERROR_INVALID_ARG";
                })(_sender.DATARV_ERROR || (_sender.DATARV_ERROR = {}));
                var DATARV_ERROR = _sender.DATARV_ERROR;

                var Exception = (function () {
                    function Exception(errorCode) {
                        this._errorCode = 0 /* DATARV_ERROR_OK */;
                        this._errorCode = errorCode;
                    }
                    Exception.prototype.ErrorCode = function () {
                        return this._errorCode;
                    };

                    Exception.prototype.toString = function () {
                        switch (this._errorCode) {
                            case 0 /* DATARV_ERROR_OK */:
                                return "DATARV_ERROR_OK";
                            case 1 /* DATARV_ERROR_INVALID_EVENT */:
                                return "Event is invalid. Either event.Id is empty, or event.Timestamp is empty, or event.EventType is empty.";
                            case 2 /* DATARV_ERROR_INVALID_CONFIG */:
                                return "Invalid configuration. CollectorUrl is missing.";
                            case 3 /* DATARV_ERROR_INVALID_DEPENDENCIES */:
                                return "DATARV_ERROR_INVALID_DEPENDENCIES";
                            case 4 /* DATARV_ERROR_INVALID_STATUS */:
                                return "Telemetry Manager is not initialized.";
                            case 5 /* DATARV_ERROR_INVALID_ARG */:
                                return "TenantToken is null or empty, or events is null.";
                            default:
                                return "Unknown error";
                        }
                    };
                    return Exception;
                })();
                _sender.Exception = Exception;

                /** TelemetryConfig of TelemetryManager.
                
                \note
                TelemetryManager will hold the reference of this config. After you invoke
                Initialize(), you should never modify any content of this config object.
                Otherwise, the behavior is undefined.
                */
                var TelemetryConfig = (function () {
                    function TelemetryConfig() {
                    }
                    return TelemetryConfig;
                })();
                _sender.TelemetryConfig = TelemetryConfig;

                var TelemetryManagerFactory = (function () {
                    function TelemetryManagerFactory() {
                    }
                    TelemetryManagerFactory.CreateTelemetryManager = function () {
                        return new TelemetryManagerImpl();
                    };
                    return TelemetryManagerFactory;
                })();
                _sender.TelemetryManagerFactory = TelemetryManagerFactory;

                //
                // const
                //
                var Consts = (function () {
                    function Consts() {
                    }
                    Consts.MaxPackageSizeInBytes = function () {
                        return 3 * 1000 * 1000;
                    };
                    Consts.TimeIntervalForNextSendInMS = function () {
                        return 1 * 1000;
                    };
                    return Consts;
                })();
                ;

                //
                // Impl
                //
                /** TelemetryManager status.
                
                \note
                The status order is very important, don't modify it unless you know what you are doing.
                */
                var TelemetryManagerStatus;
                (function (TelemetryManagerStatus) {
                    TelemetryManagerStatus[TelemetryManagerStatus["Created"] = 0] = "Created";
                    TelemetryManagerStatus[TelemetryManagerStatus["Initialized"] = 1] = "Initialized";
                    TelemetryManagerStatus[TelemetryManagerStatus["Started"] = 2] = "Started";
                })(TelemetryManagerStatus || (TelemetryManagerStatus = {}));

                var TelemetryManagerImpl = (function () {
                    function TelemetryManagerImpl() {
                        this._MaxPackageSizeInBytes = Consts.MaxPackageSizeInBytes();
                        this._listeners = [];
                        this._status = 0 /* Created */;
                        //private _ecsClient: ecs.IEcsClient = null;
                        this._etag = null;
                        //private _ecsCallback: any = null;
                        this._testServerResponseHook = null;
                        this._isPaused = false;
                    }
                    TelemetryManagerImpl.prototype.Initialize = function (config) {
                        if (this._status != 0 /* Created */) {
                            throw new Exception(4 /* DATARV_ERROR_INVALID_STATUS */);
                        }

                        if (!config || !config.collectorUrl) {
                            throw new Exception(2 /* DATARV_ERROR_INVALID_CONFIG */);
                        }

                        this._config = config;
                        this._Reset();
                        this._status = 1 /* Initialized */;

                        /*if (config.ecsClient) {
                        this._Verbose("ECS object assigned. Do integration");
                        this._ecsClient = config.ecsClient;
                        }*/
                        this._Verbose("Initialize() done");
                    };

                    TelemetryManagerImpl.prototype.AddListener = function (func) {
                        if (this._status < 1 /* Initialized */) {
                            throw new Exception(4 /* DATARV_ERROR_INVALID_STATUS */);
                        }

                        this._Verbose([
                            "AddListener(), status: ", this._status,
                            " old length: ", this._listeners.length,
                            " func: ", func
                        ].join(""));

                        for (var i = 0; i < this._listeners.length; ++i) {
                            if (this._listeners[i] == func) {
                                this._Verbose("the listener has been added already, index: " + i);
                                return;
                            }
                        }

                        this._listeners.push(func);

                        this._Verbose("AddListener() done, the new length: " + this._listeners.length);
                    };

                    TelemetryManagerImpl.prototype.RemoveListener = function (func) {
                        if (this._status < 1 /* Initialized */) {
                            throw new Exception(4 /* DATARV_ERROR_INVALID_STATUS */);
                        }

                        this._Verbose([
                            "RemoveListener(), status: ", this._status,
                            " old length: ", this._listeners.length,
                            " func: ", func
                        ].join(""));

                        for (var i = 0; i < this._listeners.length; ++i) {
                            if (this._listeners[i] == func) {
                                if (this._listeners.length == 1) {
                                    this._listeners = [];
                                } else if (i == this._listeners.length - 1) {
                                    this._listeners.pop();
                                } else {
                                    this._listeners[i] = this._listeners.pop();
                                }
                                this._Verbose([
                                    "this listener has been found, index: ", i,
                                    "new length: ", this._listeners.length
                                ].join(""));
                                return;
                            }
                        }

                        this._Verbose("listener isn't been found, new length" + this._listeners.length);
                    };

                    TelemetryManagerImpl.prototype.Start = function () {
                        // If it hasn't been initialized, throw exception.
                        if (this._status < 1 /* Initialized */) {
                            throw new Exception(4 /* DATARV_ERROR_INVALID_STATUS */);
                        }

                        this._Verbose([
                            "Start(), status:", this._status,
                            "tag:", TelemetryManagerImpl._tag
                        ].join(" "));

                        if (this._status >= 2 /* Started */) {
                            this._Verbose("Start() already, ignore");
                        }

                        /*if (this._ecsClient) {
                        this._ecsCallback = this._CreateEcsCallback();
                        this._ecsClient.AddListener(this._ecsCallback);
                        this._etag = this._ecsClient.GetETag();
                        }*/
                        // change the status to started.
                        ++TelemetryManagerImpl._tag;
                        this._status = 2 /* Started */;

                        this._Verbose([
                            "Start() done, status: ", this._status,
                            "tag: ", TelemetryManagerImpl._tag
                        ].join(""));
                    };

                    TelemetryManagerImpl.prototype.Stop = function () {
                        // If it hasn't been initialized, throw exception.
                        if (this._status < 1 /* Initialized */) {
                            throw new Exception(4 /* DATARV_ERROR_INVALID_STATUS */);
                        }

                        this._Verbose("Stop(), status: " + this._status);

                        if (this._status == 1 /* Initialized */) {
                            this._Verbose("Stop() already, ignore");
                            return;
                        }

                        //
                        // do stop work
                        //
                        // 1. cleanup states
                        this._Reset();

                        // 2. reset status to initailzied
                        this._status = 1 /* Initialized */;

                        this._Verbose("Stop() done, status: " + this._status);
                    };

                    TelemetryManagerImpl.prototype.Pause = function () {
                        this._isPaused = true;
                        this._CleanTimer();
                    };

                    TelemetryManagerImpl.prototype.Resume = function () {
                        this._isPaused = false;
                        if (!this._eventsCache.IsEmpty() && !this._timer) {
                            this._ScheduleTimer(false);
                        }
                    };

                    TelemetryManagerImpl.prototype.Flush = function (func) {
                        if (!this._eventsCache.IsEmpty()) {
                            this._WorkThread(func, true);
                        }
                    };

                    TelemetryManagerImpl.prototype.SendAsync = function (tenantToken, events) {
                        if (this._status < 1 /* Initialized */) {
                            throw new Exception(4 /* DATARV_ERROR_INVALID_STATUS */);
                        }

                        this._Verbose([
                            "SendAsync(), status:", this._status,
                            "tenantToken:", tenantToken,
                            "count:", events.length
                        ].join(" "));

                        if (this._status < 2 /* Started */) {
                            this._Info("SendAsync(), not started, ignore, return false");
                            return false;
                        }

                        // check the input parameters
                        if (!tenantToken || !events) {
                            this._Error("SendAsync(), tenantToken or events is null or empty");
                            throw new Exception(5 /* DATARV_ERROR_INVALID_ARG */);
                        }

                        for (var i = 0; i < events.length; ++i) {
                            if (!events[i].Id || !TelemetryManagerImpl._eventTypeRegex.test(events[i].EventType) || events[i].Timestamp.Equals("0")) {
                                this._Error([
                                    "eventId:", events[i].Id,
                                    "eventType:", events[i].EventType,
                                    "timestamp high:", events[i].Timestamp.high,
                                    "timestamp low:", events[i].Timestamp.low
                                ].join(""));

                                throw new Exception(1 /* DATARV_ERROR_INVALID_EVENT */);
                            }
                        }

                        // put all events in events queue
                        this._eventsCache.AddEvents(tenantToken, events);

                        this._Verbose([
                            "SendAsync(), currentTimer: ", this._timer,
                            "eventsCacheIsEmpty", this._eventsCache.IsEmpty()
                        ].join(" "));

                        // if the events queue are not empty, and we haven't schedule the send
                        // action, schedule it at once.
                        // Don't invoke _WorkThread() directly, otherwise, it may block UI.
                        if (!this._eventsCache.IsEmpty() && !this._timer) {
                            this._ScheduleTimer(false);
                        }

                        this._Verbose("SendAsync() done");
                        return true;
                    };

                    TelemetryManagerImpl.prototype._WorkThread = function (flushCallback, isFlush) {
                        var _this = this;
                        try {
                            this._Verbose("_WorkThread, status: " + this._status);

                            if (this._status < 2 /* Started */) {
                                this._Verbose("_WorkThread, status is not started, return");
                                return;
                            }

                            // dequeue one tenants events
                            var item = this._eventsCache.DequeuEvents();
                            if (item == null) {
                                this._Verbose("_WorkThread, No events found, return");

                                // no more events need process, so clear the timer and return
                                this._CleanTimer();
                                return;
                            }

                            // pack the events and send
                            var result = this._PackEvents(item.tenantToken, item.events);

                            // add unsend events back to the queue
                            this._eventsCache.AddEvents(item.tenantToken, result.remainedEvents);

                            // check if there is anything packed
                            if (result.buffer == null || result.buffer.length == 0) {
                                // schedule for next check if necessary
                                if (!this._eventsCache.IsEmpty()) {
                                    this._Verbose("eventsCache is not empty, schedule for next run");
                                    this._ScheduleTimer(false);
                                } else {
                                    this._Verbose("eventsCache is empty, stop schedule");
                                    this._CleanTimer();
                                }
                                return;
                            }

                            if (this._testServerResponseHook) {
                                //Using setTimeout with 100 ms to simulate the network time to and fro from the collector and calling _SendCallback asynchronously
                                var xhr = this._testServerResponseHook();
                                setTimeout(this._SendCallback(tag, item.tenantToken, result.sendEvents, xhr, false, null), 100);
                                return;
                            }

                            var postParams = {
                                type: "POST",
                                url: this._config.collectorUrl,
                                processData: false,
                                headers: {
                                    "content-type": "application/bond-compact-binary",
                                    "client-id": "NO_AUTH",
                                    "sdk-version": "ACT-Web-JS-" + clienttelemetry_build.version
                                },
                                complete: function (xhr) {
                                    return _this._SendCallback(tag, item.tenantToken, result.sendEvents, xhr, isFlush, flushCallback);
                                }
                            };

                            if (sct.Utils.IsSafari() || typeof Uint8Array == "undefined") {
                                this._Verbose("Uint8Array is undefined, send with base64 encode.");

                                postParams["data"] = Microsoft.Bond.Encoding.Base64.GetString(result.buffer);
                                postParams["headers"]["content-encoding"] = "base64";
                            } else {
                                this._Verbose("Uint8Array is defined, send with binary format directly.");

                                postParams["data"] = new Uint8Array(result.buffer);
                            }

                            if (item.tenantToken) {
                                postParams["headers"]["x-apikey"] = item.tenantToken;
                            }

                            // send it via jquery
                            var tag = TelemetryManagerImpl._tag;

                            this._lastActiveTime = new Date().getTime();

                            sct.Utils.ajax(postParams, isFlush);

                            this._Verbose("_Workthread, send via jquery, tag: " + tag);
                        } catch (ex) {
                            this._Error("_WorkThread, exception: " + ex);
                        }
                    };

                    /** Package all events to a package.
                    
                    return value is json object:
                    {
                    buffer: bond serialize buffer (binary data),
                    sendEvents: the events are packaged.
                    },
                    
                    events contains unpackaged events.
                    */
                    TelemetryManagerImpl.prototype._PackEvents = function (tenantToken, events) {
                        this._Verbose("_PackageEvents, total Count: " + events.length);

                        // create the client to collector request
                        var collectorRequest = new telemetry.datamodels.ClientToCollectorRequest();

                        // create the data package
                        var pkg = new telemetry.datamodels.DataPackage();
                        pkg.Source = "JS_default_source";
                        pkg.DataPackageId = telemetry.datamodels.utils.GetGuid();
                        pkg.Timestamp = telemetry.datamodels.utils.GetTimeStamp();

                        // first, try to send all events
                        var buffer;
                        var sendEvents = events;
                        events = [];
                        while (true) {
                            pkg.Records = [];
                            pkg.Records.push.apply(pkg.Records, sendEvents);
                            collectorRequest.DataPackages = [];
                            collectorRequest.DataPackages.push(pkg);
                            buffer = this._Serialize(collectorRequest);
                            this._Verbose([
                                "_PackageEvents, sendEvents.length:", sendEvents.length,
                                "buffer.length:", buffer.length,
                                "MaxPackageSize:", this._MaxPackageSizeInBytes
                            ].join(""));

                            if (buffer.length < this._MaxPackageSizeInBytes) {
                                break;
                            } else if (sendEvents.length == 1) {
                                //single record larger than max package size, drop
                                sendEvents = [];
                                buffer = null;
                                break;
                            }

                            // too large, we must reduce it.
                            var tmp = sendEvents.splice(0, Math.floor(sendEvents.length / 2));
                            this._Verbose("_PackageEvents, too large, package again");

                            // add the rest events back to events;
                            events.push.apply(events, sendEvents);
                            sendEvents = tmp;
                        }

                        this._Verbose([
                            "_PakcageEvents done, sendEventsCount:", sendEvents.length,
                            "buffer.length:", buffer == null ? 0 : buffer.length,
                            "remained events:", events.length
                        ].join(""));

                        return { buffer: buffer, sendEvents: sendEvents, remainedEvents: events };
                    };

                    TelemetryManagerImpl.prototype._Serialize = function (collectorRequest) {
                        var stream = new Microsoft.Bond.IO.MemoryStream();
                        var writer = new Microsoft.Bond.CompactBinaryProtocolWriter(stream);
                        collectorRequest.Write(writer);
                        return stream.GetBuffer();
                    };

                    /** This function will handle the callback from ajax    */
                    TelemetryManagerImpl.prototype._SendCallback = function (tag, tenantToken, events, jqXHR, isCalledFromFlush, flushCallback) {
                        this._Verbose([
                            "_SendCallback",
                            "tag:", tag,
                            "current tag:", TelemetryManagerImpl._tag,
                            "tenantToken:", tenantToken,
                            "events count:", events.length,
                            "jqXHR:", jqXHR
                        ].join(""));

                        //Do the flush callback. Since this sending was scheduled synchronously don't schedule timer
                        //again for async sending.
                        if (flushCallback) {
                            flushCallback((jqXHR ? jqXHR.status : 0), tenantToken, events);
                        }

                        if (isCalledFromFlush) {
                            return;
                        }

                        var isSuccess = jqXHR != null && jqXHR.status >= 200 && jqXHR.status < 300;

                        for (var i = 0; i < this._listeners.length; ++i) {
                            this._listeners[i](isSuccess ? 0 /* SENT */ : 1 /* SEND_FAILED */, (jqXHR ? jqXHR.status : 0), tenantToken, events);
                        }

                        // if the status is not sending, do nothing
                        if (this._status < 2 /* Started */ || tag < TelemetryManagerImpl._tag) {
                            this._Verbose("_SendCallback, is not started, or tag is not the same, return");
                            return;
                        }

                        // if need retry, put the events back to the events queue and
                        // try it later. 400 means the data format is not correct, so
                        // don't retry for this case.
                        //
                        // for IE 8/IE 9, there is no way to get the status code, don't retry also.
                        if (!isSuccess && (!jqXHR || jqXHR.status && jqXHR.status != 400)) {
                            this._Verbose("retry statusCode: " + (jqXHR ? jqXHR.status : 0));
                            this._eventsCache.AddEvents(tenantToken, events);
                            this._ScheduleTimer(true);
                            return;
                        }

                        // schedule for next check if necessary
                        if (!this._eventsCache.IsEmpty()) {
                            this._Verbose("eventsCache is not empty, schedule for next run");
                            this._ScheduleTimer(false);
                        } else {
                            this._Verbose("eventsCache is empty, stop schedule");
                            this._CleanTimer();
                        }
                    };

                    TelemetryManagerImpl.prototype._CleanTimer = function () {
                        this._Verbose("_CleanTimer(), timer: " + this._timer);
                        if (this._timer) {
                            clearTimeout(this._timer);
                            this._timer = null;
                        }
                    };

                    /** Schedule Retry.
                    
                    This function will schedule re-try after X seconds. X value is determined
                    by the following algorithm:
                    1. for the 1st, X is a random value between 5~10 (5*2^0~5*2^1).
                    2. for the 2nd, X is a random value between 10~20 (5*2^1~5*2^2).
                    3. for the 3rd, X is a random value between 20~40 (5*2^2~5*2^3).
                    4. for the 4th, X is a random value between 40~80 (5*2^3~5*2^4).
                    5. for the 5th, X is a random value between 80~160 (5*2^4~5*2^5).
                    6. for the 6th, X is a random value between 160~320 (5*2^5~5*2^6).
                    7. Go back to 1.
                    */
                    TelemetryManagerImpl.prototype._ScheduleTimer = function (isRetry) {
                        var _this = this;
                        if (!this._isPaused) {
                            this._Verbose("_ScheduleTimer: isRetry: " + isRetry);

                            // clear previous timer always.
                            this._CleanTimer();

                            if (!isRetry) {
                                // next send will be in at least 1 second later
                                var X = 0;
                                var now = new Date().getTime();
                                var late = now - this._lastActiveTime;
                                if (late > Consts.TimeIntervalForNextSendInMS()) {
                                    // we haven't scheduled in last 1 second, so schedule it at once.
                                    X = 0;
                                } else {
                                    X = Consts.TimeIntervalForNextSendInMS() - late;
                                }

                                this._timer = setTimeout(function () {
                                    return _this._WorkThread(null, false);
                                }, X);
                                this._Verbose("_ScheduleTimer, next try: " + X);
                                this._rescheduleFactor = 1;
                            } else {
                                // retry
                                this._Verbose("_ScheduleTimer, current factor: " + this._rescheduleFactor);

                                var X = Math.floor(5 * this._rescheduleFactor * (1 + Math.random()));
                                this._timer = setTimeout(function () {
                                    return _this._WorkThread(null, false);
                                }, X * 1000);
                                this._Verbose("_ScheduleTimer, next try (s): " + X);

                                this._rescheduleFactor <<= 1;
                                if (this._rescheduleFactor > 64) {
                                    this._rescheduleFactor = 1;
                                }
                            }
                        }
                    };

                    //
                    // Log functions
                    //
                    TelemetryManagerImpl.prototype._Verbose = function (msg) {
                        if (this._config.log) {
                            this._config.log.Verbose("[TelemetryManagerImpl]: " + msg);
                        }
                    };

                    TelemetryManagerImpl.prototype._Info = function (msg) {
                        if (this._config.log) {
                            this._config.log.Info("[TelemetryManagerImpl]: " + msg);
                        }
                    };

                    TelemetryManagerImpl.prototype._Error = function (msg) {
                        if (this._config.log) {
                            this._config.log.Error("[TelemetryManagerImpl]: " + msg);
                        }
                    };

                    /** Clean all stats without listener queue */
                    TelemetryManagerImpl.prototype._Reset = function () {
                        this._Verbose("Reset()");

                        this._CleanTimer();

                        this._lastActiveTime = 0;
                        this._rescheduleFactor = 1;
                        this._sendingEvents = [];
                        this._eventsCache = new TelemetryEventCache();
                        // 3. Shutdown listener
                        /* if (this._ecsClient) {
                        this._ecsClient.RemoveListener(this._ecsCallback);
                        this._ecsCallback = null;
                        // Keep _ecs uncleared, following C++ version.
                        }*/
                    };

                    /******* TEST_INJECTION_START *******/
                    TelemetryManagerImpl.prototype.__GetListenerArray = function () {
                        return this._listeners;
                    };

                    TelemetryManagerImpl.prototype.__GetTotalEventsCount = function () {
                        return this._eventsCache.GetTotalEventsCount();
                    };

                    TelemetryManagerImpl.prototype.__IsScheduled = function () {
                        return this._timer != null;
                    };

                    TelemetryManagerImpl.prototype.__ChageMaxPackageSizeInKB = function (size) {
                        this._MaxPackageSizeInBytes = size * 1024;
                    };

                    TelemetryManagerImpl.prototype.__SetTestServerResponseHook = function (callback) {
                        this._testServerResponseHook = callback;
                    };
                    TelemetryManagerImpl._eventTypeRegex = /^[a-zA-Z0-9]([a-zA-Z0-9]|_){2,98}[a-zA-Z0-9]$/;
                    TelemetryManagerImpl._tag = 0;
                    return TelemetryManagerImpl;
                })();

                var TelemetryEventCache = (function () {
                    function TelemetryEventCache() {
                        this._events = {};
                        this._tokens = [];
                    }
                    TelemetryEventCache.prototype.AddEvents = function (tenantToken, events) {
                        if (!events.length) {
                            return;
                        }

                        if (!this._events[tenantToken]) {
                            this._events[tenantToken] = [];
                            this._tokens.push(tenantToken);
                        }
                        this._events[tenantToken].push.apply(this._events[tenantToken], events);
                    };

                    TelemetryEventCache.prototype.IsEmpty = function () {
                        return this._tokens.length == 0;
                    };

                    TelemetryEventCache.prototype.DequeuEvents = function () {
                        if (this._tokens.length == 0) {
                            return null;
                        }

                        var tenantToken = this._tokens.shift();
                        var events = this._events[tenantToken];
                        delete this._events[tenantToken];
                        return { tenantToken: tenantToken, events: events };
                    };

                    TelemetryEventCache.prototype.GetTotalEventsCount = function () {
                        var sum = 0;
                        for (var key in this._events) {
                            sum += this._events[key].length;
                        }
                        return sum;
                    };
                    return TelemetryEventCache;
                })();
            })(telemetry._sender || (telemetry._sender = {}));
            var _sender = telemetry._sender;
        })(applications.telemetry || (applications.telemetry = {}));
        var telemetry = applications.telemetry;
    })(microsoft.applications || (microsoft.applications = {}));
    var applications = microsoft.applications;
})(microsoft || (microsoft = {}));
var microsoft;
(function (microsoft) {
    (function (applications) {
        (function (telemetry) {
            var globalTelemetryManager = telemetry._sender.TelemetryManagerFactory.CreateTelemetryManager();

            /**
            * Configuration for the ARIA logger.
            */
            var LogConfiguration = (function () {
                function LogConfiguration() {
                    /**
                    *  Set the collector url.
                    */
                    this.collectorUrl = null;
                    /**
                    *  Set to enable automatic instrumenting of session events.
                    */
                    this.enableAutoUserSession = false;
                }
                return LogConfiguration;
            })();
            telemetry.LogConfiguration = LogConfiguration;

            var Property = (function () {
                function Property() {
                    this.key = null;
                    this.value = null;
                    this.pii = null;
                }
                /**
                * Checks if the pii value is in the datamodels.PIIKind enum
                */
                Property._isPii = function (pii) {
                    if (pii == (null || undefined || 0 /* NotSet */)) {
                        return false;
                    }
                    var result = false;
                    for (var val in telemetry.datamodels.PIIKind) {
                        if (!isNaN(val)) {
                            if (val == pii) {
                                result = true;
                            }
                        }
                    }
                    return result;
                };
                return Property;
            })();
            telemetry.Property = Property;

            /**
            * eventProperties class allows adding custom key value pairs, including PII data to events.
            */
            var EventProperties = (function () {
                function EventProperties() {
                    /**
                    * Specify a name for this event. This is required if you send any custom key, value pairs.
                    */
                    this.name = null;
                    /**
                    * Override the timestamp on the event being sent, which is set to the current time by default.
                    */
                    this.timestamp = null;
                    /**
                    * Property bag that can be used to add custom extensions to the logged event.
                    */
                    this.properties = [];
                    /**
                    * Specify a type for this event. The type provided will be prefixed with the string
                    * "Custom.".
                    */
                    this.eventType = null;
                }
                /**
                * Add a named property and optionally tag it as PII.
                */
                EventProperties.prototype.setProperty = function (key, value, pii) {
                    if (!key || !EventProperties._propertyNameRegex.test(key)) {
                        throw new Exception(3 /* INVALID_PROPERTY_NAME */);
                    }
                    if (pii) {
                        this.properties.push({
                            key: key,
                            value: value,
                            pii: pii != 0 /* NotSet */ ? pii : null
                        });
                    } else {
                        this.properties.push({
                            key: key,
                            value: value,
                            pii: null
                        });
                    }
                };

                EventProperties._propertyNameRegex = /^[a-zA-Z0-9](([a-zA-Z0-9|_|\.]){0,98}[a-zA-Z0-9])?$/;
                return EventProperties;
            })();
            telemetry.EventProperties = EventProperties;

            (function (TelemetryError) {
                TelemetryError[TelemetryError["INVALID_TENANT_TOKEN"] = 1] = "INVALID_TENANT_TOKEN";
                TelemetryError[TelemetryError["MISSING_EVENT_PROPERTIES_NAME"] = 2] = "MISSING_EVENT_PROPERTIES_NAME";
                TelemetryError[TelemetryError["INVALID_PROPERTY_NAME"] = 3] = "INVALID_PROPERTY_NAME";
                TelemetryError[TelemetryError["MISSING_FAILURE_SIGNATURE"] = 5] = "MISSING_FAILURE_SIGNATURE";
                TelemetryError[TelemetryError["MISSING_FAILURE_DETAIL"] = 6] = "MISSING_FAILURE_DETAIL";
                TelemetryError[TelemetryError["MISSING_PAGEVIEW_ID"] = 7] = "MISSING_PAGEVIEW_ID";
                TelemetryError[TelemetryError["MISSING_PAGEVIEW_NAME"] = 8] = "MISSING_PAGEVIEW_NAME";
                TelemetryError[TelemetryError["INVALID_SESSION_STATE"] = 9] = "INVALID_SESSION_STATE";
            })(telemetry.TelemetryError || (telemetry.TelemetryError = {}));
            var TelemetryError = telemetry.TelemetryError;

            /**
            * Helper class to throw exceptions.
            */
            var Exception = (function () {
                function Exception(errorCode) {
                    this.errorCode = null;
                    this.errorCode = errorCode;
                }
                Exception.prototype.ErrorCode = function () {
                    return this.errorCode;
                };

                Exception.prototype.toString = function () {
                    switch (this.errorCode) {
                        case 1 /* INVALID_TENANT_TOKEN */:
                            return "Invalid tenant token";
                        case 2 /* MISSING_EVENT_PROPERTIES_NAME */:
                            return "Eventproperties.name can not be null or empty";
                        case 3 /* INVALID_PROPERTY_NAME */:
                            return "Invalid Key. Key does not conform to regular expression ^[a-zA-Z0-9](([a-zA-Z0-9|_|\.]){0,98}[a-zA-Z0-9])?$";
                        case 5 /* MISSING_FAILURE_SIGNATURE */:
                            return "Failure signature can't be null or empty.";
                        case 6 /* MISSING_FAILURE_DETAIL */:
                            return "Failure detail can't be null or empty.";
                        case 7 /* MISSING_PAGEVIEW_ID */:
                            return "Pageview id can't be null or empty.";
                        case 8 /* MISSING_PAGEVIEW_NAME */:
                            return "Pageview name can't be null or empty.";
                        case 9 /* INVALID_SESSION_STATE */:
                            return "Session state has to be a value from the SessionState enum.";
                        default:
                            return "Unknown error";
                    }
                };
                return Exception;
            })();
            telemetry.Exception = Exception;

            var SemanticContext = (function () {
                function SemanticContext(allowDeviceInfoFields) {
                    this.contextMap = new Microsoft.Bond.Collections.Map();
                    this.piiKind = 0 /* NotSet */;
                    this._allowDeviceInfoFields = false;
                    this._allowDeviceInfoFields = allowDeviceInfoFields;
                }
                SemanticContext.prototype.setAppId = function (appId) {
                    if (appId) {
                        this.contextMap.Add("AppInfo.Id", appId);
                    }
                };

                SemanticContext.prototype.setAppVersion = function (appVersion) {
                    if (appVersion) {
                        this.contextMap.Add("AppInfo.Version", appVersion);
                    }
                };

                SemanticContext.prototype.setAppLanguage = function (appLanguage) {
                    if (appLanguage) {
                        this.contextMap.Add("AppInfo.Language", appLanguage);
                    }
                };

                SemanticContext.prototype.setDeviceId = function (deviceId) {
                    if (deviceId && this._allowDeviceInfoFields) {
                        this.contextMap.Add("DeviceInfo.Id", deviceId);
                        SystemInformation.checkAndUpdateDeviceId(deviceId);
                    }
                };

                SemanticContext.prototype.setDeviceOsName = function (deviceOsName) {
                    if (deviceOsName && this._allowDeviceInfoFields) {
                        this.contextMap.Add("DeviceInfo.OsName", deviceOsName);
                    }
                };

                SemanticContext.prototype.setDeviceOsVersion = function (deviceOsVersion) {
                    if (deviceOsVersion && this._allowDeviceInfoFields) {
                        this.contextMap.Add("DeviceInfo.OsVersion", deviceOsVersion);
                    }
                };

                SemanticContext.prototype.setDeviceBrowserName = function (deviceBrowserName) {
                    if (deviceBrowserName && this._allowDeviceInfoFields) {
                        this.contextMap.Add("DeviceInfo.BrowserName", deviceBrowserName);
                    }
                };

                SemanticContext.prototype.setDeviceBrowserVersion = function (deviceBrowserVersion) {
                    if (deviceBrowserVersion && this._allowDeviceInfoFields) {
                        this.contextMap.Add("DeviceInfo.BrowserVersion", deviceBrowserVersion);
                    }
                };

                SemanticContext.prototype.setUserId = function (userId, piiKind) {
                    if (userId) {
                        this.contextMap.Add("UserInfo.Id", userId);
                    }
                    if (Property._isPii(piiKind)) {
                        this.piiKind = piiKind;
                    }
                };

                SemanticContext.prototype.setUserMsaId = function (userMsaId) {
                    if (userMsaId) {
                        this.contextMap.Add("UserInfo.MsaId", userMsaId);
                    }
                };

                SemanticContext.prototype.setUserANID = function (userANID) {
                    if (userANID) {
                        this.contextMap.Add("UserInfo.ANID", userANID);
                    }
                };

                SemanticContext.prototype.setUserAdvertisingId = function (userAdvertisingId) {
                    if (userAdvertisingId) {
                        this.contextMap.Add("UserInfo.AdvertisingId", userAdvertisingId);
                    }
                };

                SemanticContext.prototype.setUserTimeZone = function (userTimeZone) {
                    if (userTimeZone) {
                        this.contextMap.Add("UserInfo.TimeZone", userTimeZone);
                    }
                };

                SemanticContext.prototype.setUserLanguage = function (userLanguage) {
                    if (userLanguage) {
                        this.contextMap.Add("UserInfo.Language", userLanguage);
                    }
                };
                return SemanticContext;
            })();

            var SystemInformation = (function () {
                function SystemInformation() {
                }
                SystemInformation.initialize = function () {
                    var appLanguage = document.documentElement.lang;
                    if (appLanguage) {
                        SystemInformation.semanticContext.setAppLanguage(appLanguage);
                    }
                    var userLanguage = window.navigator.userLanguage || window.navigator.language;
                    if (userLanguage) {
                        SystemInformation.semanticContext.setUserLanguage(userLanguage);
                    }
                    var timeZone = new Date().getTimezoneOffset();
                    var minutes = timeZone % 60;
                    var hours = (timeZone - minutes) / 60;
                    var timeZonePrefix = "+";
                    if (hours > 0) {
                        timeZonePrefix = "-";
                    }
                    SystemInformation.semanticContext.setUserTimeZone(timeZonePrefix + (hours < 10 ? '0' + hours : hours.toString()) + ":" + (minutes < 10 ? '0' + minutes : minutes.toString()));
                    SystemInformation.semanticContext.setDeviceBrowserName(SystemInformation._getBrowserName());
                    SystemInformation.semanticContext.setDeviceBrowserVersion(SystemInformation._getBrowserVersion());
                    SystemInformation.semanticContext.setDeviceOsName(SystemInformation._getOsName());
                    SystemInformation.semanticContext.setDeviceOsVersion(SystemInformation._getOsVersion());
                    var deviceId = SystemInformation._getCookie(SystemInformation.DEVICE_ID_COOKIE);
                    if (deviceId == "") {
                        deviceId = telemetry.datamodels.utils.GetGuid();
                    }
                    SystemInformation.semanticContext.setDeviceId(deviceId);
                };

                SystemInformation.checkAndUpdateDeviceId = function (deviceId) {
                    var oldDeviceId = SystemInformation._getCookie(SystemInformation.DEVICE_ID_COOKIE);
                    if (oldDeviceId != deviceId) {
                        SystemInformation._setCookie(SystemInformation.DEVICE_ID_COOKIE, deviceId);
                        SystemInformation._setCookie(SystemInformation.FIRST_LAUNCH_TIME_COOKIE, (new Date()).getTime().toString());
                    }
                    var firstLaunchTime = SystemInformation._getCookie(SystemInformation.FIRST_LAUNCH_TIME_COOKIE);
                    SystemInformation.firstLaunchTime = parseInt(firstLaunchTime);
                };

                SystemInformation._setCookie = function (cname, cvalue) {
                    var expires = "expires=Mon, 31 Dec 2029 23:59:59 GMT";
                    document.cookie = cname + "=" + cvalue + "; " + expires;
                };

                SystemInformation._getCookie = function (cname) {
                    var name = cname + "=";
                    var ca = document.cookie.split(';');
                    for (var i = 0; i < ca.length; i++) {
                        var c = ca[i];
                        var j = 0;
                        while (c.charAt(j) == ' ') {
                            j++;
                        }
                        c = c.substring(j);
                        if (c.indexOf(name) == 0)
                            return c.substring(name.length, c.length);
                    }
                    return "";
                };

                SystemInformation._getUserAgent = function () {
                    return window.navigator.userAgent;
                };

                SystemInformation._userAgentContainsString = function (searchString) {
                    return SystemInformation._getUserAgent().indexOf(searchString) > -1;
                };

                SystemInformation._isIe = function () {
                    return SystemInformation._userAgentContainsString('Trident');
                };

                SystemInformation._isEdge = function () {
                    return SystemInformation._userAgentContainsString(SystemInformation.BROWSERS.EDGE);
                };

                SystemInformation._isOpera = function () {
                    return SystemInformation._userAgentContainsString('OPR/');
                };

                SystemInformation._getBrowserName = function () {
                    if (SystemInformation._isOpera()) {
                        return SystemInformation.BROWSERS.UNKNOWN;
                    }

                    if (SystemInformation._userAgentContainsString(SystemInformation.BROWSERS.PHANTOMJS)) {
                        return SystemInformation.BROWSERS.PHANTOMJS;
                    }

                    if (SystemInformation._isEdge()) {
                        return SystemInformation.BROWSERS.EDGE;
                    }

                    if (SystemInformation._userAgentContainsString(SystemInformation.BROWSERS.ELECTRON)) {
                        return SystemInformation.BROWSERS.ELECTRON;
                    }

                    if (SystemInformation._userAgentContainsString(SystemInformation.BROWSERS.CHROME)) {
                        return SystemInformation.BROWSERS.CHROME;
                    }

                    if (SystemInformation._userAgentContainsString(SystemInformation.BROWSERS.FIREFOX)) {
                        return SystemInformation.BROWSERS.FIREFOX;
                    }

                    if (SystemInformation._userAgentContainsString(SystemInformation.BROWSERS.SAFARI)) {
                        return SystemInformation.BROWSERS.SAFARI;
                    }

                    if (SystemInformation._userAgentContainsString(SystemInformation.BROWSERS.SKYPE_SHELL)) {
                        return SystemInformation.BROWSERS.SKYPE_SHELL;
                    }

                    if (SystemInformation._isIe()) {
                        return SystemInformation.BROWSERS.MSIE;
                    }

                    return SystemInformation.BROWSERS.UNKNOWN;
                };

                SystemInformation._getBrowserVersion = function () {
                    if (SystemInformation._isIe()) {
                        return getIeVersion();
                    } else {
                        return getOtherVersion(SystemInformation._getBrowserName());
                    }

                    function getIeVersion() {
                        var ieVersionMatches, userAgent = SystemInformation._getUserAgent(), classicIeVersionMatches = userAgent.match(new RegExp(SystemInformation.BROWSERS.MSIE + ' ' + SystemInformation.REGEX_VERSION));

                        if (classicIeVersionMatches) {
                            return classicIeVersionMatches[1];
                        } else {
                            ieVersionMatches = userAgent.match(new RegExp('rv:' + SystemInformation.REGEX_VERSION));
                            if (ieVersionMatches) {
                                return ieVersionMatches[1];
                            }
                        }
                    }

                    function getOtherVersion(browserString) {
                        var matches;

                        if (browserString === SystemInformation.BROWSERS.SAFARI) {
                            browserString = 'Version';
                        }

                        matches = SystemInformation._getUserAgent().match(new RegExp(browserString + '/' + SystemInformation.REGEX_VERSION));

                        if (matches) {
                            return matches[1];
                        }

                        return SystemInformation.UNKNOWN_VERSION;
                    }
                };

                SystemInformation._getOsName = function () {
                    var win = /(windows|win32)/i, winrt = / arm;/i, winphone = /windows\sphone\s\d+\.\d+/i, osx = /(macintosh|mac os x)/i, ios = /(iPad|iPhone|iPod)(?=.*like Mac OS X)/i, linux = /(linux|joli|[kxln]?ubuntu|debian|[open]*suse|gentoo|arch|slackware|fedora|mandriva|centos|pclinuxos|redhat|zenwalk)/i, android = /android/i;

                    if (SystemInformation._getUserAgent().match(winphone)) {
                        return SystemInformation.OPERATING_SYSTEMS.WINDOWS_PHONE;
                    }
                    if (SystemInformation._getUserAgent().match(winrt)) {
                        return SystemInformation.OPERATING_SYSTEMS.WINDOWS_RT;
                    }
                    if (SystemInformation._getUserAgent().match(ios)) {
                        return SystemInformation.OPERATING_SYSTEMS.IOS;
                    }
                    if (SystemInformation._getUserAgent().match(android)) {
                        return SystemInformation.OPERATING_SYSTEMS.ANDROID;
                    }
                    if (SystemInformation._getUserAgent().match(linux)) {
                        return SystemInformation.OPERATING_SYSTEMS.LINUX;
                    }
                    if (SystemInformation._getUserAgent().match(osx)) {
                        return SystemInformation.OPERATING_SYSTEMS.MACOSX;
                    }
                    if (SystemInformation._getUserAgent().match(win)) {
                        return SystemInformation.OPERATING_SYSTEMS.WINDOWS;
                    }

                    return SystemInformation.OPERATING_SYSTEMS.UNKNOWN;
                };

                SystemInformation._getOsVersion = function () {
                    if (SystemInformation._getOsName() === SystemInformation.OPERATING_SYSTEMS.WINDOWS) {
                        return getWindowsVersion();
                    }

                    if (SystemInformation._getOsName() === SystemInformation.OPERATING_SYSTEMS.MACOSX) {
                        return getMacOsxVersion();
                    }

                    return SystemInformation.UNKNOWN_VERSION;

                    function getWindowsVersion() {
                        var ntVersionMatches = SystemInformation._getUserAgent().match(new RegExp('Windows NT ' + SystemInformation.REGEX_VERSION));

                        if (ntVersionMatches && SystemInformation.VERSION_MAPPINGS[ntVersionMatches[1]]) {
                            return SystemInformation.VERSION_MAPPINGS[ntVersionMatches[1]];
                        }

                        return SystemInformation.UNKNOWN_VERSION;
                    }

                    function getMacOsxVersion() {
                        var macOsxVersionInUserAgentMatches = SystemInformation._getUserAgent().match(new RegExp(SystemInformation.OPERATING_SYSTEMS.MACOSX + ' ' + SystemInformation.REGEX_VERSION_MAC));

                        if (macOsxVersionInUserAgentMatches) {
                            var versionString = macOsxVersionInUserAgentMatches[1].replace(/_/g, '.');
                            var components = [];
                            if (versionString) {
                                var delimiter = getDelimiter(versionString);
                                if (delimiter) {
                                    components = versionString.split(delimiter);
                                    return components[0];
                                } else {
                                    return versionString;
                                }
                            }
                        }

                        return SystemInformation.UNKNOWN_VERSION;
                    }

                    function getDelimiter(versionString) {
                        if (versionString.indexOf('.') > -1) {
                            return '.';
                        }

                        if (versionString.indexOf('_') > -1) {
                            return '_';
                        }

                        return null;
                    }
                };
                SystemInformation.semanticContext = new SemanticContext(true);
                SystemInformation.firstLaunchTime = -1;
                SystemInformation.BROWSERS = {
                    MSIE: 'MSIE',
                    CHROME: 'Chrome',
                    FIREFOX: 'Firefox',
                    SAFARI: 'Safari',
                    EDGE: 'Edge',
                    ELECTRON: 'Electron',
                    SKYPE_SHELL: 'SkypeShell',
                    PHANTOMJS: 'PhantomJS',
                    UNKNOWN: 'Unknown'
                };
                SystemInformation.OPERATING_SYSTEMS = {
                    WINDOWS: 'Windows',
                    MACOSX: 'Mac OS X',
                    WINDOWS_PHONE: 'Windows Phone',
                    WINDOWS_RT: 'Windows RT',
                    IOS: 'iOS',
                    ANDROID: 'Android',
                    LINUX: 'Linux',
                    UNKNOWN: 'Unknown'
                };
                SystemInformation.VERSION_MAPPINGS = {
                    '5.1': 'XP',
                    '6.0': 'Vista',
                    '6.1': '7',
                    '6.2': '8',
                    '6.3': '8.1',
                    '10.0': '10'
                };
                SystemInformation.REGEX_VERSION = '([\\d,.]+)';
                SystemInformation.REGEX_VERSION_MAC = '([\\d,_,.]+)';
                SystemInformation.UNKNOWN_VERSION = "Unknown";
                SystemInformation.DEVICE_ID_COOKIE = "MicrosoftApplicationsTelemetryDeviceId";
                SystemInformation.FIRST_LAUNCH_TIME_COOKIE = "MicrosoftApplicationsTelemetryFirstLaunchTime";
                return SystemInformation;
            })();

            (function (SessionState) {
                SessionState[SessionState["STARTED"] = 0] = "STARTED";
                SessionState[SessionState["ENDED"] = 1] = "ENDED";
            })(telemetry.SessionState || (telemetry.SessionState = {}));
            var SessionState = telemetry.SessionState;

            /**
            * LogManager class allows initialization of the telemetry library.
            */
            var LogManager = (function () {
                function LogManager() {
                }
                LogManager.initialize = function (tenantToken, configuration) {
                    if (!LogManager._initialized) {
                        if (!tenantToken) {
                            throw new Exception(1 /* INVALID_TENANT_TOKEN */);
                        }
                        LogManager._defaultToken = tenantToken;
                        LogManager._config.collectorUrl = "https://browser.pipe.aria.microsoft.com/Collector/3.0/";
                        if (configuration && configuration.collectorUrl) {
                            LogManager._config.collectorUrl = configuration.collectorUrl;
                        }

                        globalTelemetryManager.Initialize(LogManager._config);
                        globalTelemetryManager.Start();
                        SystemInformation.initialize();
                        LogManager._initialized = true;

                        if (configuration && configuration.enableAutoUserSession) {
                            LogManager._logger = new Logger();
                            LogManager._logger.logSession(0 /* STARTED */);
                            window.addEventListener("beforeunload", LogManager._logSessionEnd);
                        }
                    }
                };

                /**
                * Pause the transmission of events.
                */
                LogManager.pauseTransmission = function () {
                    globalTelemetryManager.Pause();
                };

                /**
                * Resume the tranmission of events.
                */
                LogManager.resumeTransmission = function () {
                    globalTelemetryManager.Resume();
                };

                /**
                * Send the events in queue synchronously. In case of multi-tenant applications
                * the next tenant whose events need to be sent will be sent.
                */
                LogManager.flush = function (func) {
                    globalTelemetryManager.Flush(func);
                };

                /**
                * When events have been sent or sent failed, you can get the notification
                * if you registered the listener. If the listener has been added already,
                * the function will do nothing.
                *
                * @param func (callbackType: microsoft.applications.telemetry._sender.CallbackEventType, responseCode: number, tenantToken: string,
                *  events: microsoft.applications.telemetry.datamodels.Record[]) => any
                */
                LogManager.addCallbackListener = function (func) {
                    if (LogManager._initialized) {
                        globalTelemetryManager.AddListener(func);
                    }
                };

                LogManager.setContext = function (key, value, pii) {
                    LogManager._contextProperties.setProperty(key, value, pii);
                };

                LogManager.isInitialized = function () {
                    return LogManager._initialized;
                };

                LogManager.getDefaultToken = function () {
                    return LogManager._defaultToken;
                };

                LogManager.getSemanticContext = function () {
                    return LogManager._semanticContext;
                };

                LogManager._logSessionEnd = function () {
                    if (LogManager._logger) {
                        LogManager._logger.logSession(1 /* ENDED */);
                        LogManager.flush();
                    }
                };

                /******* TEST_INJECTION_START *******/
                LogManager.__backToUninitialized = function () {
                    LogManager._config = new telemetry._sender.TelemetryConfig();
                    LogManager._semanticContext = new SemanticContext(true);
                    LogManager._contextProperties = new EventProperties();
                    globalTelemetryManager = telemetry._sender.TelemetryManagerFactory.CreateTelemetryManager();
                    LogManager._initialized = false;
                };
                LogManager._initialized = false;
                LogManager._defaultToken = null;
                LogManager._config = new telemetry._sender.TelemetryConfig();
                LogManager._logger = null;
                LogManager._contextProperties = new EventProperties();
                LogManager._semanticContext = new SemanticContext(true);
                return LogManager;
            })();
            telemetry.LogManager = LogManager;

            /**
            * Contains methods to log custom events.
            */
            var Logger = (function () {
                function Logger(tenantToken) {
                    this._initId = telemetry.datamodels.utils.GetGuid();
                    this._sequence = 0;
                    this._tenantToken = null;
                    this._contextProperties = new EventProperties();
                    this._semanticContext = new SemanticContext(false);
                    this._sessionStartTime = 0;
                    this._sessionId = null;
                    if (!tenantToken) {
                        this._tenantToken = LogManager.getDefaultToken();
                    } else {
                        this._tenantToken = tenantToken;
                    }
                }
                /**
                * Log a custom event, including custom key-value properties.
                * * @param {microsoft.applications.telemetry.EventProperties} eventProperties - properties of the custom event.
                */
                Logger.prototype.logEvent = function (eventProperties) {
                    if (!eventProperties.name) {
                        throw new Exception(2 /* MISSING_EVENT_PROPERTIES_NAME */);
                    }
                    var event = this._createEventRecord(eventProperties.name, eventProperties.eventType);
                    this._addCustomPropertiesToEvent(event, eventProperties);
                    this._sendRecord(event);
                };

                /**
                * Logs a failure event such as an application exception.
                * @param {String} signature (req) - a detailed string that identifies the bucket of the failure.
                * @param {String} detail (req) - details of the failure.
                * @param {String} category - category of the failure such as application error, hang, or crash.
                * @param {String} id - identifier that could be used to uniquely identify or reference this failure.
                * @param {microsoft.applications.telemetry.EventProperties} properties - properties of the failure event, can be null.
                */
                Logger.prototype.logFailure = function (signature, detail, category, id, properties) {
                    if (!signature) {
                        throw new Exception(5 /* MISSING_FAILURE_SIGNATURE */);
                    }
                    if (!detail) {
                        throw new Exception(6 /* MISSING_FAILURE_DETAIL */);
                    }
                    var event = this._createEventRecord("failure", "failure");
                    event.Extension.Add("Failure.Signature", signature);
                    event.Extension.Add("Failure.Detail", detail);
                    if (category) {
                        event.Extension.Add("Failure.Category", category);
                    }
                    if (id) {
                        event.Extension.Add("Failure.Id", id);
                    }
                    this._addCustomPropertiesToEvent(event, properties);
                    this._sendRecord(event);
                };

                /**
                * Logs a page view event which is normally a result of a user action on a UI page such as search query, content request or page navigation.
                * @param {String} id (req) - an identifier that could be used to uniquely identify or reference this page.
                * @param {String} pageName (req) - the name of the page.
                * @param {String} category - the category for which this page belongs to.
                * @param {String} uri - uri of this page.
                * @param {String} referrerUri - uri that refers to this page.
                * @param {microsoft.applications.telemetry.EventProperties} properties - properties of the page view event, can be null.
                */
                Logger.prototype.logPageView = function (id, pageName, category, uri, referrerUri, properties) {
                    if (!id) {
                        throw new Exception(7 /* MISSING_PAGEVIEW_ID */);
                    }
                    if (!pageName) {
                        throw new Exception(8 /* MISSING_PAGEVIEW_NAME */);
                    }
                    var event = this._createEventRecord("pageview", "pageview");
                    event.Extension.Add("PageView.Id", id);
                    event.Extension.Add("PageView.Name", pageName);
                    if (category) {
                        event.Extension.Add("PageView.Category", category);
                    }
                    if (uri) {
                        event.Extension.Add("PageView.Uri", uri);
                    }
                    if (referrerUri) {
                        event.Extension.Add("PageView.ReferrerUri", referrerUri);
                    }
                    this._addCustomPropertiesToEvent(event, properties);
                    this._sendRecord(event);
                };

                /**
                * Logs the session state.
                * Note: Logging session start while a session already exists will be no-op. Similarly, logging
                * session end while a session does not exist will be no-op too.
                * @param {microsoft.applications.telemetry.SessionState} state (req) - the session's state.
                * @param {microsoft.applications.telemetry.EventProperties} properties - properties of the session event, can be null.
                */
                Logger.prototype.logSession = function (state, properties) {
                    if (state !== 0 /* STARTED */ && state !== 1 /* ENDED */) {
                        throw new Exception(9 /* INVALID_SESSION_STATE */);
                    }
                    var event = this._createEventRecord("session", "session");
                    if (state === 0 /* STARTED */) {
                        if (this._sessionStartTime > 0) {
                            //Session already exists
                            return;
                        }
                        this._sessionStartTime = (new Date()).getTime();
                        this._sessionId = telemetry.datamodels.utils.GetGuid();
                        event.Extension.Add("Session.Id", this._sessionId);
                        event.Extension.Add("Session.State", "Started");
                    } else if (state === 1 /* ENDED */) {
                        if (this._sessionStartTime == 0) {
                            //Session does not exist
                            return;
                        }
                        var sessionDuration = Math.floor(((new Date()).getTime() - this._sessionStartTime) / 1000);
                        event.Extension.Add("Session.Duration", sessionDuration.toString());
                        event.Extension.Add("Session.DurationBucket", this._getSessionDurationFromTime(sessionDuration));
                        event.Extension.Add("Session.Id", this._sessionId);
                        event.Extension.Add("Session.State", "Ended");
                        this._sessionId = null;
                        this._sessionStartTime = 0;
                    }
                    event.Extension.Add("Session.FirstLaunchTime", this._getISOString(new Date(SystemInformation.firstLaunchTime)));
                    this._addCustomPropertiesToEvent(event, properties);
                    this._sendRecord(event);
                };

                Logger.prototype.getSessionId = function () {
                    return this._sessionId;
                };

                Logger.prototype.setContext = function (key, value, pii) {
                    this._contextProperties.setProperty(key, value, pii);
                };

                Logger.prototype.getSemanticContext = function () {
                    return this._semanticContext;
                };

                Logger.prototype._getSessionDurationFromTime = function (timeInSec) {
                    if (timeInSec < 0) {
                        return "Undefined";
                    } else if (timeInSec <= 3) {
                        return "UpTo3Sec";
                    } else if (timeInSec <= 10) {
                        return "UpTo10Sec";
                    } else if (timeInSec <= 30) {
                        return "UpTo30Sec";
                    } else if (timeInSec <= 60) {
                        return "UpTo60Sec";
                    } else if (timeInSec <= 180) {
                        return "UpTo3Min";
                    } else if (timeInSec <= 600) {
                        return "UpTo10Min";
                    } else if (timeInSec <= 1800) {
                        return "UpTo30Min";
                    }
                    return "Above30Min";
                };

                Logger.prototype._createEventRecord = function (eventName, recordType) {
                    var event = new telemetry.datamodels.Record();
                    if (!recordType) {
                        recordType = "custom";
                    }
                    event.EventType = eventName.toLowerCase();
                    event.Type = recordType.toLowerCase();

                    event.Extension.Add("EventInfo.Source", "JS_default_source");
                    event.Extension.Add("EventInfo.InitId", this._initId);
                    this._sequence++;
                    event.Extension.Add("EventInfo.Sequence", this._sequence.toString());
                    event.Extension.Add("EventInfo.Name", eventName.toLowerCase());
                    var date = new Date();
                    event.Timestamp = telemetry.datamodels.utils.GetTimeStampWithValue(date.getTime());
                    event.Extension.Add("EventInfo.Time", this._getISOString(date));
                    event.Extension.Add("EventInfo.SdkVersion", "ACT-Web-JS-" + clienttelemetry_build.version);

                    return event;
                };

                Logger.prototype._getISOString = function (date) {
                    function twoDigit(n) {
                        // Format integers to have at least two digits.
                        return n < 10 ? '0' + n : n.toString();
                    }

                    function threeDigit(n) {
                        // Format integers to have at least three digits.
                        if (n < 10) {
                            return '00' + n;
                        } else if (n < 100) {
                            return '0' + n;
                        }
                        return n.toString();
                    }

                    return date.getUTCFullYear() + '-' + twoDigit(date.getUTCMonth() + 1) + '-' + twoDigit(date.getUTCDate()) + 'T' + twoDigit(date.getUTCHours()) + ':' + twoDigit(date.getUTCMinutes()) + ':' + twoDigit(date.getUTCSeconds()) + '.' + threeDigit(date.getUTCMilliseconds()) + 'Z';
                };

                Logger.prototype._addCustomPropertiesToEvent = function (event, eventProperties) {
                    this._addSemanticContext(event, SystemInformation.semanticContext);
                    this._addSemanticContext(event, LogManager._semanticContext);
                    this._addSemanticContext(event, this._semanticContext);
                    if (this._sessionId) {
                        event.Extension.Add("Session.Id", this._sessionId);
                    }
                    this._addEventPropertiesToEvent(event, LogManager._contextProperties);
                    this._addEventPropertiesToEvent(event, this._contextProperties);
                    this._addEventPropertiesToEvent(event, eventProperties);
                };

                Logger.prototype._addSemanticContext = function (event, semanticContext) {
                    if (semanticContext && semanticContext.contextMap.Count() > 0) {
                        var contextBuffer = semanticContext.contextMap.GetBuffer();
                        for (var i = 0; i < contextBuffer.length; i++) {
                            if (contextBuffer[i].Key == "UserInfo.Id" && semanticContext.piiKind != 0 /* NotSet */) {
                                event.AddOrReplacePII(contextBuffer[i].Key, contextBuffer[i].Value, semanticContext.piiKind);
                            } else {
                                event.Extension.AddOrReplace(contextBuffer[i].Key, contextBuffer[i].Value);
                            }
                        }
                    }
                };

                Logger.prototype._addEventPropertiesToEvent = function (event, eventProperties) {
                    if (eventProperties) {
                        if (eventProperties.timestamp && eventProperties.timestamp >= (new Date("1/1/2000")).getTime()) {
                            event.Timestamp = telemetry.datamodels.utils.GetTimeStampWithValue(eventProperties.timestamp);
                            event.Extension.AddOrReplace("EventInfo.Time", this._getISOString(new Date(eventProperties.timestamp)));
                        }

                        if (eventProperties.name) {
                            eventProperties.name = eventProperties.name.replace(".", "_");
                            event.EventType = eventProperties.name.toLowerCase();
                            event.Extension.AddOrReplace("EventInfo.Name", eventProperties.name.toLowerCase());
                        }

                        var properties = eventProperties.properties;
                        if (properties && properties.length > 0) {
                            for (var i = 0; i < properties.length; i++) {
                                if (properties[i].key && (typeof properties[i].key == "string") && (properties[i].value || properties[i].value == false || properties[i].value == 0 || properties[i].value == "")) {
                                    if (Property._isPii(properties[i].pii)) {
                                        event.AddOrReplacePII(properties[i].key, properties[i].value.toString(), properties[i].pii);
                                        event.Extension.Remove(properties[i].key);
                                    } else {
                                        event.Extension.AddOrReplace(properties[i].key, properties[i].value.toString());
                                        event.PIIExtensions.Remove(properties[i].key);
                                    }
                                }
                            }
                        }
                    }
                };

                Logger.prototype._sendRecord = function (record) {
                    if (LogManager.isInitialized()) {
                        globalTelemetryManager.SendAsync(this._tenantToken, [record]);
                    }
                };
                return Logger;
            })();
            telemetry.Logger = Logger;
        })(applications.telemetry || (applications.telemetry = {}));
        var telemetry = applications.telemetry;
    })(microsoft.applications || (microsoft.applications = {}));
    var applications = microsoft.applications;
})(microsoft || (microsoft = {}));
(function () {
	'use strict';

	var isCommonjs = typeof module !== 'undefined' && module.exports;
	var keyboardAllowed = typeof Element !== 'undefined' && 'ALLOW_KEYBOARD_INPUT' in Element;

	var fn = (function () {
		var val;
		var valLength;

		var fnMap = [
			[
				'requestFullscreen',
				'exitFullscreen',
				'fullscreenElement',
				'fullscreenEnabled',
				'fullscreenchange',
				'fullscreenerror'
			],
			// new WebKit
			[
				'webkitRequestFullscreen',
				'webkitExitFullscreen',
				'webkitFullscreenElement',
				'webkitFullscreenEnabled',
				'webkitfullscreenchange',
				'webkitfullscreenerror'

			],
			// old WebKit (Safari 5.1)
			[
				'webkitRequestFullScreen',
				'webkitCancelFullScreen',
				'webkitCurrentFullScreenElement',
				'webkitCancelFullScreen',
				'webkitfullscreenchange',
				'webkitfullscreenerror'

			],
			[
				'mozRequestFullScreen',
				'mozCancelFullScreen',
				'mozFullScreenElement',
				'mozFullScreenEnabled',
				'mozfullscreenchange',
				'mozfullscreenerror'
			],
			[
				'msRequestFullscreen',
				'msExitFullscreen',
				'msFullscreenElement',
				'msFullscreenEnabled',
				'MSFullscreenChange',
				'MSFullscreenError'
			]
		];

		var i = 0;
		var l = fnMap.length;
		var ret = {};

		for (; i < l; i++) {
			val = fnMap[i];
			if (val && val[1] in document) {
				for (i = 0, valLength = val.length; i < valLength; i++) {
					ret[fnMap[0][i]] = val[i];
				}
				return ret;
			}
		}

		return false;
	})();

	var screenfull = {
		request: function (elem) {
			var request = fn.requestFullscreen;

			elem = elem || document.documentElement;

			// Work around Safari 5.1 bug: reports support for
			// keyboard in fullscreen even though it doesn't.
			// Browser sniffing, since the alternative with
			// setTimeout is even worse.
			if (/5\.1[\.\d]* Safari/.test(navigator.userAgent)) {
				elem[request]();
			} else {
				elem[request](keyboardAllowed && Element.ALLOW_KEYBOARD_INPUT);
			}
		},
		exit: function () {
			document[fn.exitFullscreen]();
		},
		toggle: function (elem) {
			if (this.isFullscreen) {
				this.exit();
			} else {
				this.request(elem);
			}
		},
		raw: fn
	};

	if (!fn) {
		if (isCommonjs) {
			module.exports = false;
		} else {
			window.screenfull = false;
		}

		return;
	}

	Object.defineProperties(screenfull, {
		isFullscreen: {
			get: function () {
				return !!document[fn.fullscreenElement];
			}
		},
		element: {
			enumerable: true,
			get: function () {
				return document[fn.fullscreenElement];
			}
		},
		enabled: {
			enumerable: true,
			get: function () {
				// Coerce to boolean in case of old WebKit
				return !!document[fn.fullscreenEnabled];
			}
		}
	});

	if (isCommonjs) {
		module.exports = screenfull;
	} else {
		window.screenfull = screenfull;
	}
})();
