(function (global) {
  var babelHelpers = global.babelHelpers = {};
  babelHelpers.typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  babelHelpers.jsx = function () {
    var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7;
    return function createRawReactElement(type, props, key, children) {
      var defaultProps = type && type.defaultProps;
      var childrenLength = arguments.length - 3;

      if (!props && childrenLength !== 0) {
        props = {};
      }

      if (props && defaultProps) {
        for (var propName in defaultProps) {
          if (props[propName] === void 0) {
            props[propName] = defaultProps[propName];
          }
        }
      } else if (!props) {
        props = defaultProps || {};
      }

      if (childrenLength === 1) {
        props.children = children;
      } else if (childrenLength > 1) {
        var childArray = Array(childrenLength);

        for (var i = 0; i < childrenLength; i++) {
          childArray[i] = arguments[i + 3];
        }

        props.children = childArray;
      }

      return {
        $$typeof: REACT_ELEMENT_TYPE,
        type: type,
        key: key === undefined ? null : '' + key,
        ref: null,
        props: props,
        _owner: null
      };
    };
  }();

  babelHelpers.asyncIterator = function (iterable) {
    if (typeof Symbol === "function") {
      if (Symbol.asyncIterator) {
        var method = iterable[Symbol.asyncIterator];
        if (method != null) return method.call(iterable);
      }

      if (Symbol.iterator) {
        return iterable[Symbol.iterator]();
      }
    }

    throw new TypeError("Object is not async iterable");
  };

  babelHelpers.asyncGenerator = function () {
    function AwaitValue(value) {
      this.value = value;
    }

    function AsyncGenerator(gen) {
      var front, back;

      function send(key, arg) {
        return new Promise(function (resolve, reject) {
          var request = {
            key: key,
            arg: arg,
            resolve: resolve,
            reject: reject,
            next: null
          };

          if (back) {
            back = back.next = request;
          } else {
            front = back = request;
            resume(key, arg);
          }
        });
      }

      function resume(key, arg) {
        try {
          var result = gen[key](arg);
          var value = result.value;

          if (value instanceof AwaitValue) {
            Promise.resolve(value.value).then(function (arg) {
              resume("next", arg);
            }, function (arg) {
              resume("throw", arg);
            });
          } else {
            settle(result.done ? "return" : "normal", result.value);
          }
        } catch (err) {
          settle("throw", err);
        }
      }

      function settle(type, value) {
        switch (type) {
          case "return":
            front.resolve({
              value: value,
              done: true
            });
            break;

          case "throw":
            front.reject(value);
            break;

          default:
            front.resolve({
              value: value,
              done: false
            });
            break;
        }

        front = front.next;

        if (front) {
          resume(front.key, front.arg);
        } else {
          back = null;
        }
      }

      this._invoke = send;

      if (typeof gen.return !== "function") {
        this.return = undefined;
      }
    }

    if (typeof Symbol === "function" && Symbol.asyncIterator) {
      AsyncGenerator.prototype[Symbol.asyncIterator] = function () {
        return this;
      };
    }

    AsyncGenerator.prototype.next = function (arg) {
      return this._invoke("next", arg);
    };

    AsyncGenerator.prototype.throw = function (arg) {
      return this._invoke("throw", arg);
    };

    AsyncGenerator.prototype.return = function (arg) {
      return this._invoke("return", arg);
    };

    return {
      wrap: function (fn) {
        return function () {
          return new AsyncGenerator(fn.apply(this, arguments));
        };
      },
      await: function (value) {
        return new AwaitValue(value);
      }
    };
  }();

  babelHelpers.asyncGeneratorDelegate = function (inner, awaitWrap) {
    var iter = {},
        waiting = false;

    function pump(key, value) {
      waiting = true;
      value = new Promise(function (resolve) {
        resolve(inner[key](value));
      });
      return {
        done: false,
        value: awaitWrap(value)
      };
    }

    ;

    if (typeof Symbol === "function" && Symbol.iterator) {
      iter[Symbol.iterator] = function () {
        return this;
      };
    }

    iter.next = function (value) {
      if (waiting) {
        waiting = false;
        return value;
      }

      return pump("next", value);
    };

    if (typeof inner.throw === "function") {
      iter.throw = function (value) {
        if (waiting) {
          waiting = false;
          throw value;
        }

        return pump("throw", value);
      };
    }

    if (typeof inner.return === "function") {
      iter.return = function (value) {
        return pump("return", value);
      };
    }

    return iter;
  };

  babelHelpers.asyncToGenerator = function (fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  };

  babelHelpers.classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  babelHelpers.createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  babelHelpers.defineEnumerableProperties = function (obj, descs) {
    for (var key in descs) {
      var desc = descs[key];
      desc.configurable = desc.enumerable = true;
      if ("value" in desc) desc.writable = true;
      Object.defineProperty(obj, key, desc);
    }

    return obj;
  };

  babelHelpers.defaults = function (obj, defaults) {
    var keys = Object.getOwnPropertyNames(defaults);

    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      var value = Object.getOwnPropertyDescriptor(defaults, key);

      if (value && value.configurable && obj[key] === undefined) {
        Object.defineProperty(obj, key, value);
      }
    }

    return obj;
  };

  babelHelpers.defineProperty = function (obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  };

  babelHelpers.extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  babelHelpers.get = function get(object, property, receiver) {
    if (object === null) object = Function.prototype;
    var desc = Object.getOwnPropertyDescriptor(object, property);

    if (desc === undefined) {
      var parent = Object.getPrototypeOf(object);

      if (parent === null) {
        return undefined;
      } else {
        return get(parent, property, receiver);
      }
    } else if ("value" in desc) {
      return desc.value;
    } else {
      var getter = desc.get;

      if (getter === undefined) {
        return undefined;
      }

      return getter.call(receiver);
    }
  };

  babelHelpers.inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  babelHelpers.instanceof = function (left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
      return right[Symbol.hasInstance](left);
    } else {
      return left instanceof right;
    }
  };

  babelHelpers.interopRequireDefault = function (obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  };

  babelHelpers.interopRequireWildcard = function (obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};

      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
        }
      }

      newObj.default = obj;
      return newObj;
    }
  };

  babelHelpers.newArrowCheck = function (innerThis, boundThis) {
    if (innerThis !== boundThis) {
      throw new TypeError("Cannot instantiate an arrow function");
    }
  };

  babelHelpers.objectDestructuringEmpty = function (obj) {
    if (obj == null) throw new TypeError("Cannot destructure undefined");
  };

  babelHelpers.objectWithoutProperties = function (obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  babelHelpers.possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  babelHelpers.selfGlobal = typeof global === "undefined" ? self : global;

  babelHelpers.set = function set(object, property, value, receiver) {
    var desc = Object.getOwnPropertyDescriptor(object, property);

    if (desc === undefined) {
      var parent = Object.getPrototypeOf(object);

      if (parent !== null) {
        set(parent, property, value, receiver);
      }
    } else if ("value" in desc && desc.writable) {
      desc.value = value;
    } else {
      var setter = desc.set;

      if (setter !== undefined) {
        setter.call(receiver, value);
      }
    }

    return value;
  };

  babelHelpers.slicedToArray = function () {
    function sliceIterator(arr, i) {
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"]) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    return function (arr, i) {
      if (Array.isArray(arr)) {
        return arr;
      } else if (Symbol.iterator in Object(arr)) {
        return sliceIterator(arr, i);
      } else {
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      }
    };
  }();

  babelHelpers.slicedToArrayLoose = function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      var _arr = [];

      for (var _iterator = arr[Symbol.iterator](), _step; !(_step = _iterator.next()).done;) {
        _arr.push(_step.value);

        if (i && _arr.length === i) break;
      }

      return _arr;
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };

  babelHelpers.taggedTemplateLiteral = function (strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  };

  babelHelpers.taggedTemplateLiteralLoose = function (strings, raw) {
    strings.raw = raw;
    return strings;
  };

  babelHelpers.temporalRef = function (val, name, undef) {
    if (val === undef) {
      throw new ReferenceError(name + " is not defined - temporal dead zone");
    } else {
      return val;
    }
  };

  babelHelpers.temporalUndefined = {};

  babelHelpers.toArray = function (arr) {
    return Array.isArray(arr) ? arr : Array.from(arr);
  };

  babelHelpers.toConsumableArray = function (arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    } else {
      return Array.from(arr);
    }
  };
})(typeof global === "undefined" ? self : global);
!function(e){function t(r){if(n[r])return n[r].exports;var o=n[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,t),o.l=!0,o.exports}var n={};t.m=e,t.c=n,t.i=function(e){return e},t.d=function(e,n,r){t.o(e,n)||Object.defineProperty(e,n,{configurable:!1,enumerable:!0,get:r})},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=819)}([function(e,t,n){var r=n(4),o=n(49),i=n(25),a=n(26),s=n(50),u=function(e,t,n){var l,c,p,d,f=e&u.F,h=e&u.G,m=e&u.S,g=e&u.P,v=e&u.B,b=h?r:m?r[t]||(r[t]={}):(r[t]||{}).prototype,y=h?o:o[t]||(o[t]={}),_=y.prototype||(y.prototype={});h&&(n=t);for(l in n)c=!f&&b&&void 0!==b[l],p=(c?b:n)[l],d=v&&c?s(p,r):g&&"function"==typeof p?s(Function.call,p):p,b&&a(b,l,p,e&u.U),y[l]!=p&&i(y,l,d),g&&_[l]!=p&&(_[l]=p)};r.core=o,u.F=1,u.G=2,u.S=4,u.P=8,u.B=16,u.W=32,u.U=64,u.R=128,e.exports=u},function(e,t,n){"use strict";function r(e,t,n,r,i,a,s,u){if(o(t),!e){var l;if(void 0===t)l=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var c=[n,r,i,a,s,u],p=0;l=new Error(t.replace(/%s/g,function(){return c[p++]})),l.name="Invariant Violation"}throw l.framesToPop=1,l}}var o=function(e){};e.exports=r},function(e,t,n){"use strict";e.exports=n(89)},function(e,t,n){var r=n(9);e.exports=function(e){if(!r(e))throw TypeError(e+" is not an object!");return e}},function(e,t){var n=e.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=n)},function(e,t,n){"use strict";var r=n(32),o=r;e.exports=o},function(e,t){e.exports=function(e){try{return!!e()}catch(e){return!0}}},function(e,t,n){"use strict";function r(e){for(var t=arguments.length-1,n="Minified React error #"+e+"; visit http://facebook.github.io/react/docs/error-decoder.html?invariant="+e,r=0;r<t;r++)n+="&args[]="+encodeURIComponent(arguments[r+1]);n+=" for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";var o=new Error(n);throw o.name="Invariant Violation",o.framesToPop=1,o}e.exports=r},function(e,t,n){"use strict";function r(e){return{type:C,display:e}}function o(e){return{type:T,index:e}}function i(e){return{type:R,val:e}}function a(){return{type:M}}function s(e){return{type:P,val:e}}function u(e){return{type:O,dropdown:e}}function l(){return u(x.INFO)}function c(){return u(x.DOWNLOAD)}function p(){return{type:A}}function d(){return{type:D}}function f(e){return function(t,n){var r=n(),i=E.selectLastSpreadIndex(r),a=Math.max(0,Math.min(e,i));t(o(a)),n().canvasApi.goToSpread(a)}}function h(e){return function(t,n){var r=n(),o=r.reader.targetSpreadIndex,i=E.selectCurrentSpreadIndex(r),a=o>-1?o:i;if(S.selectors.isPreview(r)){var s=S.selectors.previewPages(r),u=E.selectReadMode(r);return t(f((0,w.getTargetSpreadIndex)(a,e,s,u)))}return t(f(a+(e?1:-1)))}}function m(){return h(!1)}function g(){return h(!0)}function v(e,t,n,r,o,i,a,s,u){return function(l,c){l({type:N,currentSpreadIndex:t,currentPageNumber:n,currentPages:r,positionInPercent:o,visiblePages:e,positionInPercentHasChanged:i,currentPagesHasChanged:a,visiblePagesHasChanged:s,isDragging:u})}}function b(e,t){return function(n,r){n({type:k,isPinching:t,zoomLevel:e})}}function y(e,t,n,r,o,i,a){return{type:L,droppedFrames:e,duration:t,frameCountAtStart:n,frameCountAtEnd:r,usesWebGl:a,_interactionStartTime:o,_interactionEndTime:i}}t.__esModule=!0,t.trackDroppedFrames=t.readerZoomLevelChanged=t.readerPositionChanged=t.closeMoreDropdown=t.showMoreDropdown=t.toggleDownloadDropdown=t.toggleInfoDropdown=t.toggleDropdown=t.setHoveringOverControls=t.setInteractedWithReader=t.setInteractingWithControls=t.goToNextPage=t.goToPreviousPage=t.scrollToSpreadIndex=t.setDebugMode=t.types=t.TRACK_DROPPED_FRAMES=t.READER_POSITION_CHANGED=t.READER_ZOOM_LEVEL_CHANCED=t.CLOSE_MORE_DROPDOWN=t.SHOW_MORE_DROPDOWN=t.TOGGLE_DROPDOWN=t.SET_HOVERING_OVER_CONTROLS=t.SET_INTERACTED_WITH_READER=t.SET_INTERACTING_WITH_CONTROLS=t.SET_IS_IDLE=t.SET_DEBUG_MODE=t.SET_TARGET_SPREAD_INDEX=void 0;var _=n(11),E=babelHelpers.interopRequireWildcard(_),w=n(400),S=n(48),x=n(208),T=t.SET_TARGET_SPREAD_INDEX="SET_TARGET_SPREAD_INDEX",C=t.SET_DEBUG_MODE="SET_DEBUG_MODE",I=t.SET_IS_IDLE="SET_IS_IDLE",R=t.SET_INTERACTING_WITH_CONTROLS="SET_INTERACTING_WITH_CONTROLS",M=t.SET_INTERACTED_WITH_READER="SET_INTERACTED_WITH_READER",P=t.SET_HOVERING_OVER_CONTROLS="SET_HOVERING_OVER_CONTROLS",O=t.TOGGLE_DROPDOWN="TOGGLE_DROPDOWN",A=t.SHOW_MORE_DROPDOWN="SHOW_MORE_DROPDOWN",D=t.CLOSE_MORE_DROPDOWN="CLOSE_MORE_DROPDOWN",k=t.READER_ZOOM_LEVEL_CHANCED="READER_ZOOM_LEVEL_CHANCED",N=t.READER_POSITION_CHANGED="READER_POSITION_CHANGED",L=t.TRACK_DROPPED_FRAMES="TRACK_DROPPED_FRAMES";t.types={SET_TARGET_SPREAD_INDEX:T,SET_DEBUG_MODE:C,SET_IS_IDLE:I,SET_INTERACTING_WITH_CONTROLS:R,SET_INTERACTED_WITH_READER:M,SET_HOVERING_OVER_CONTROLS:P,TOGGLE_DROPDOWN:O,SHOW_MORE_DROPDOWN:A,CLOSE_MORE_DROPDOWN:D,READER_ZOOM_LEVEL_CHANCED:k,READER_POSITION_CHANGED:N,TRACK_DROPPED_FRAMES:L};t.setDebugMode=r,t.scrollToSpreadIndex=f,t.goToPreviousPage=m,t.goToNextPage=g,t.setInteractingWithControls=i,t.setInteractedWithReader=a,t.setHoveringOverControls=s,t.toggleDropdown=u,t.toggleInfoDropdown=l,t.toggleDownloadDropdown=c,t.showMoreDropdown=p,t.closeMoreDropdown=d,t.readerPositionChanged=v,t.readerZoomLevelChanged=b,t.trackDroppedFrames=y},function(e,t){e.exports=function(e){return"object"==typeof e?null!==e:"function"==typeof e}},function(e,t,n){e.exports=n(642)()},function(e,t,n){"use strict";function r(e){return(0,v.createSelector)(function(e){return e.features.controls},function(t){return t.find(function(t){return t.type===e})})}function o(e){return(0,v.createSelector)(r(e),function(e){return!!e})}t.__esModule=!0,t.selectShowCTAOverlay=t.moreOverlayVisible=t.isDropdownOpen=t.selectDocumentUrlOnProduction=t.selectDocumentUrlWithPageNumber=t.selectLogo=t.selectBackgroundImage=t.selectBackgroundColor=t.mayRenderLinks=t.selectShowIssuuBranding=t.selectIsSmallReader=t.selectReaderSize=t.selectReaderSizeInPixels=t.isControlsVisible=t.isFirstSpread=t.isLastSpread=t.selectLastSpreadIndex=t.selectCurrentSpreadIndex=t.selectPageSpreadList=t.selectReadMode=t.selectCurrentPageNumbers=t.selectCurrentPages=t.selectCurrentPositionInPercent=t.selectVisiblePages=t.selectFullscreenEnabled=t.selectZoomLevelInPercent=t.selectInfoDialogFeature=t.selectZoomFeature=t.selectFullscreenFeature=t.selectIssuuBrandingFeature=void 0,t.selectFeature=r,t.selectHasFeature=o;var i=n(59),a=n(211),s=babelHelpers.interopRequireWildcard(a),u=n(94),l=babelHelpers.interopRequireWildcard(u),c=n(222),p=n(221),d=n(35),f=n(97),h=n(41),m=n(40),g=n(57),v=n(33),b=t.selectIssuuBrandingFeature=r(h.ISSUU_BRANDING_TYPE),y=t.selectFullscreenFeature=r(h.FULLSCREEN_TYPE),_=(t.selectZoomFeature=r(h.ZOOM_TYPE),t.selectInfoDialogFeature=r(h.INFO_DIALOG_TYPE),t.selectZoomLevelInPercent=(0,v.createSelector)(function(e){return e.reader.zoomLevel},function(e){return 100/(g.MAX_ZOOM_LEVEL-g.MIN_ZOOM_LEVEL)*(e-g.MIN_ZOOM_LEVEL)}),t.selectFullscreenEnabled=(0,v.createSelector)(y,function(e){return e.fullscreen.enabled},function(e,t){return(0,p.isInFullscreen)(e,t)})),E=(t.selectVisiblePages=function(e){return e.reader.visiblePages},t.selectCurrentPositionInPercent=function(e){return e.reader.positionInPercent},t.selectCurrentPages=function(e){return e.reader.currentPages}),w=t.selectCurrentPageNumbers=(0,v.createSelector)(E,function(e){return e.map(function(e){return e.pageNumber})}),S=t.selectReadMode=(0,v.createSelector)(function(e){return e.features.readModeRules},_,function(e){return e.size.width},function(e){return e.size.height},function(e,t,n,r){return(0,c.getReadMode)(n,r,t,e)}),x=(t.selectPageSpreadList=(0,v.createSelector)(S,f.selectPages,f.selectSpreads,function(e,t,n){return e===m.DOUBLE_PAGE_SPREAD?n:t}),t.selectCurrentSpreadIndex=(0,v.createSelector)(w,S,function(e,t){return(0,i.pageNumberToSpreadIndex)(t,e[0])})),T=t.selectLastSpreadIndex=(0,v.createSelector)(S,function(e){return e.documentModel.pageCount},function(e,t){return(0,i.pageNumberToSpreadIndex)(e,t)}),C=(t.isLastSpread=(0,v.createSelector)(x,T,function(e,t){return e===t}),t.isFirstSpread=(0,v.createSelector)(x,function(e){return 0===e}),t.isControlsVisible=function(e){var t=e.features.showControlsUntilFirstInteraction,n=e.reader,r=n.interactedWithReader,o=n.hoveringOverControls,i=n.interactingWithControls,a=n.isIdle,s=e.headerControls,u=s.visibleDropdown,l=s.readMoreDropdownVisible,c=e.find.isVisible;return!!(o||i||null!==u||l||t&&!r||c)||!a},t.selectReaderSizeInPixels=(0,v.createSelector)(function(e){return e.size.width},function(e){return e.size.height},function(e,t){var n=(0,d.getDPR)();return Math.floor(e/n)+"x"+Math.floor(t/n)}),t.selectReaderSize=(0,v.createSelector)(function(e){return e.size.width},function(e){return e.size.height},function(e,t){var n=(0,d.getDPR)();return e<=200*n||t<=150*n?s.TINY:e<=400*n||t<=300*n?s.SMALL:s.NORMAL})),I=t.selectIsSmallReader=(0,v.createSelector)(C,_,function(e,t){return(e===s.TINY||e===s.SMALL)&&!t});t.selectShowIssuuBranding=(0,v.createSelector)(b,function(e){return!!e}),t.mayRenderLinks=(0,v.createSelector)(r(h.LINKS_TYPE),I,function(e,t){return!(!e||!e.allowOnSmallReaders&&t)}),t.selectBackgroundColor=(0,v.createSelector)(_,l.canChangeBackgroundColor,function(e){return e.features.backgroundColor},function(e){return e.features.fullscreenBackgroundColor},function(e,t,n,r){return e?r&&t?r:"#353535":n||"rgba(0, 0, 0, 0.1)"}),t.selectBackgroundImage=(0,v.createSelector)(_,l.canChangeBackgroundImage,function(e){return e.features.backgroundImage},function(e,t,n){if(n&&t&&(e||!n.hideWhenNotInFullscreen))return n}),t.selectLogo=(0,v.createSelector)(_,l.canChangeLogo,function(e){return e.features.logo},function(e,t,n){if(n&&t&&(e||!n.hideWhenNotInFullscreen))return n}),t.selectDocumentUrlWithPageNumber=(0,v.createSelector)(function(e){return e.config.getScheme()},function(e){return e.config.hosts.main},function(e){return e.documentModel.username},function(e){return e.documentModel.documentName},w,function(e,t,n,r,o){return""+e+t+"/"+n+"/docs/"+r+"/"+o[0]}),t.selectDocumentUrlOnProduction=(0,v.createSelector)(function(e){return e.documentModel.username},function(e){return e.documentModel.documentName},w,function(e,t,n){var r="https://issuu.com/"+e+"/docs/"+t,o=n[0];return o>1?r+"/"+o:r}),t.isDropdownOpen=function(e){var t=e.headerControls,n=t.visibleDropdown,r=t.readMoreDropdownVisible;return null!==n||r},t.moreOverlayVisible=(0,v.createSelector)(function(e){return e.headerControls.readMoreDropdownVisible},function(e){return e.readmore.exitedFullscreen},function(e){return e.readMorePlugin},l.canSeeOwnPublication,l.canHideRelated,function(e,t,n,r,o){var i=n&&n.shouldRenderExitFullscreenOverlay(r,o);return!!(e||t&&i)}),t.selectShowCTAOverlay=(0,v.createSelector)(y,I,function(e,t){return!!(e&&e.overlayOnSmallReaders&&t)})},function(e,t,n){var r=n(121)("wks"),o=n(72),i=n(4).Symbol,a="function"==typeof i;(e.exports=function(e){return r[e]||(r[e]=a&&i[e]||(a?i:o)("Symbol."+e))}).store=r},function(e,t,n){"use strict";function r(e){if(null===e||void 0===e)throw new TypeError("Object.assign cannot be called with null or undefined");return Object(e)}/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var o=Object.getOwnPropertySymbols,i=Object.prototype.hasOwnProperty,a=Object.prototype.propertyIsEnumerable;e.exports=function(){try{if(!Object.assign)return!1;var e=new String("abc");if(e[5]="de","5"===Object.getOwnPropertyNames(e)[0])return!1;for(var t={},n=0;n<10;n++)t["_"+String.fromCharCode(n)]=n;if("0123456789"!==Object.getOwnPropertyNames(t).map(function(e){return t[e]}).join(""))return!1;var r={};return"abcdefghijklmnopqrst".split("").forEach(function(e){r[e]=e}),"abcdefghijklmnopqrst"===Object.keys(Object.assign({},r)).join("")}catch(e){return!1}}()?Object.assign:function(e,t){for(var n,s,u=r(e),l=1;l<arguments.length;l++){n=Object(arguments[l]);for(var c in n)i.call(n,c)&&(u[c]=n[c]);if(o){s=o(n);for(var p=0;p<s.length;p++)a.call(n,s[p])&&(u[s[p]]=n[s[p]])}}return u}},function(e,t,n){e.exports=!n(6)(function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})},function(e,t,n){var r=n(3),o=n(231),i=n(44),a=Object.defineProperty;t.f=n(14)?Object.defineProperty:function(e,t,n){if(r(e),t=i(t,!0),r(n),o)try{return a(e,t,n)}catch(e){}if("get"in n||"set"in n)throw TypeError("Accessors not supported!");return"value"in n&&(e[t]=n.value),e}},function(e,t,n){"use strict";function r(e,t){return 1===e.nodeType&&e.getAttribute(h)===String(t)||8===e.nodeType&&e.nodeValue===" react-text: "+t+" "||8===e.nodeType&&e.nodeValue===" react-empty: "+t+" "}function o(e){for(var t;t=e._renderedComponent;)e=t;return e}function i(e,t){var n=o(e);n._hostNode=t,t[g]=n}function a(e){var t=e._hostNode;t&&(delete t[g],e._hostNode=null)}function s(e,t){if(!(e._flags&m.hasCachedChildNodes)){var n=e._renderedChildren,a=t.firstChild;e:for(var s in n)if(n.hasOwnProperty(s)){var u=n[s],l=o(u)._domID;if(0!==l){for(;null!==a;a=a.nextSibling)if(r(a,l)){i(u,a);continue e}p("32",l)}}e._flags|=m.hasCachedChildNodes}}function u(e){if(e[g])return e[g];for(var t=[];!e[g];){if(t.push(e),!e.parentNode)return null;e=e.parentNode}for(var n,r;e&&(r=e[g]);e=t.pop())n=r,t.length&&s(r,e);return n}function l(e){var t=u(e);return null!=t&&t._hostNode===e?t:null}function c(e){if(void 0===e._hostNode&&p("33"),e._hostNode)return e._hostNode;for(var t=[];!e._hostNode;)t.push(e),e._hostParent||p("34"),e=e._hostParent;for(;t.length;e=t.pop())s(e,e._hostNode);return e._hostNode}var p=n(7),d=n(87),f=n(272),h=(n(1),d.ID_ATTRIBUTE_NAME),m=f,g="__reactInternalInstance$"+Math.random().toString(36).slice(2);e.exports={getClosestInstanceFromNode:u,getInstanceFromNode:l,getNodeFromInstance:c,precacheChildNodes:s,precacheNode:i,uncacheNode:a}},function(e,t,n){var r=n(62),o=Math.min;e.exports=function(e){return e>0?o(r(e),9007199254740991):0}},function(e,t,n){var r=n(37);e.exports=function(e){return Object(r(e))}},function(e,t,n){"use strict";function r(e){this.name="FetchNetworkError",this.message=e}function o(e,t){this.name="BackendModelError",this.code=t,this.message=e}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return new Promise(function(n,o){var i=new XMLHttpRequest;i.open("GET",e,!0),i.withCredentials=!!t.withCredentials,t.timeout&&(i.timeout=t.timeout,i.ontimeout=function(e){o(new r("XHR could not load JSON (timeout)"))},i.onabort=function(e){o(new r("XHR could not load JSON (timeout)"))},setTimeout(function(){o(new r("XHR could not load JSON (timeout)")),i.abort()},t.timeout)),i.onreadystatechange=function(){if(i.readyState===N)if(200===i.status)try{n(JSON.parse(i.responseText))}catch(e){o(new r("Could not deserialize loaded JSON: "+e))}else o(new r("XHR could not load JSON"))},i.send()})}function a(e,t,n,r){var a=""+e.getScheme()+e.hosts.api+"/call/reader/api/4/"+t+"/"+n,s=""+e.getScheme()+e.hosts.publication+"/"+t+"/"+n+"/reader3_3.0.json",u=window.performance&&window.performance.now?function(){return window.performance.now()}:function(){return Date.now()},l=u();return Promise.all([i(s),i(a,{withCredentials:!0,timeout:2e3}).then(function(e){return r(u()-l),e}).catch(function(e){return r(u()-l,e),{status:"ok"}})]).then(function(e){var r=e[0],i=e[1];if(0!==r.status||"ok"!==i.status)throw new o("The document could not be loaded.",r.status||i.status);var a=Object.assign({userName:t,documentName:n},r.document);a.clippings={},a.licenses=i.licenses,a.paywallInfo=i.paywallInfo||{};var s={description:"",userDisplayName:t,title:n,contentRating:{},access:"public",downloadable:!1};return Object.assign(a,s,i.metadata),a})}function s(e){return{type:I,timeStamp:e}}function u(e,t){return{type:M,error:e,timeStamp:t}}function l(){return{type:P}}function c(){return{type:O}}function p(e,t,n,r,o,i){return{type:R,initialPageNumber:t,targetSpreadIndex:n,currentPages:r,width:o,height:i,timeStamp:e}}function d(e,t,n,r){return function(o,i){var a=i(),s=a.documentModel,u=a.features.controls.find(function(e){return e.type===x.FULLSCREEN_TYPE}),l=(0,S.isInFullscreen)(u,a.fullscreen.enabled),c=(0,w.getReadMode)(n,r,l,a.features.readModeRules),d=(0,E.pageNumberToSpreadIndex)(c,t),f=c===C.DOUBLE_PAGE_SPREAD?(0,_.selectSpreads)(a)[d].pages:[s.pages[d]];o(p(e,t,d,f,n,r))}}function f(e,t,n){return function(r,o){var i=o(),a=i.documentModel;e&&e.load(t.getScheme(),t.hosts.main,a.publicationId,a.username,(0,y.hasLicense)("customization_show_my_other_publications",a,n),(0,y.hasLicense)("norelated",a,n)).then(function(e){e&&r(l())}).catch(function(){r(c())})}}function h(e,t,n){return function(r){function a(e){i(s,{timeout:u}).then(function(e){if("ok"!==e.status)throw new o("The Clippings could not be loaded.",e.status);r((0,_.linksLoaded)(e.clippings))},function(t){e>1&&a(e-1)})}var s=""+e.getScheme()+e.hosts.api+"/call/reader/clippings/1.0/"+t+"/"+n,u=1e4;a(3)}}function m(e){var t=e.config,n=e.username,i=e.documentName,l=e.initialPageNumber,c=void 0===l?1:l,p=e.getWidthAndHeight,m=void 0===p?function(){}:p,y=e.readMorePlugin,E=void 0===y?null:y;return function(e){e(s(Date.now()));var l=function(t,n){e({type:n?k:D,error:n,loadTime:t})},p=a(t,n,i,l),y=!1;p.then(function(r){var o=m(),a=o[0],s=o[1];y=!r.licenses,y&&e({type:A}),e((0,_.documentLoaded)(r)),r.isPaywalled&&e(v.actions.publicationLoaded(r)),r.textInfoPath&&Number.isInteger(r.textInfoVersion)&&e(b.actions.setTextInfoUrl(r.textInfoPath,r.textInfoVersion));var u=Math.max(1,Math.min(r.pageCount,c));return e(d(Date.now(),u,a,s)),e(h(t,n,i)),e(f(E,t,y)),r}).catch(function(t){if(!(t instanceof r||t instanceof o)){(0,g.captureException)(t,{tags:{errorOrigin:"document-load-fetchDocument"}})}e(u(t,Date.now()))})}}t.__esModule=!0,t.documentLoadFailure=t.documentLoadSuccessAction=t.documentLoadSuccess=t.documentLoading=t.readMoreLoadSuccess=t.BackendModelError=t.FetchNetworkError=t.fetchDocument=t.types=t.DOCUMENTLOAD_SUCCESS=void 0;var g=n(92),v=n(48),b=n(58),y=n(139),_=n(97),E=n(59),w=n(222),S=n(221),x=n(41),T=n(40),C=babelHelpers.interopRequireWildcard(T),I="DOCUMENTLOADING",R=t.DOCUMENTLOAD_SUCCESS="DOCUMENTLOAD_SUCCESS",M="DOCUMENTLOAD_FAILURE",P="READ_MORE_LOAD_SUCCESS",O="READ_MORE_LOAD_FAILURE",A="DISABLE_LICENSE_CHECK",D="DYNAMIC_API_SUCCESS",k="DYNAMIC_API_FAILURE",N=(t.types={DOCUMENTLOADING:I,DOCUMENTLOAD_SUCCESS:R,DOCUMENTLOAD_FAILURE:M,READ_MORE_LOAD_SUCCESS:P,READ_MORE_LOAD_FAILURE:O,DISABLE_LICENSE_CHECK:A,DYNAMIC_API_FAILURE:k,DYNAMIC_API_SUCCESS:D},4);t.fetchDocument=m,t.FetchNetworkError=r,t.BackendModelError=o,t.readMoreLoadSuccess=l,t.documentLoading=s,t.documentLoadSuccess=d,t.documentLoadSuccessAction=p,t.documentLoadFailure=u},function(e,t,n){var r,o;/*!
  Copyright (c) 2016 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
!function(){"use strict";function n(){for(var e=[],t=0;t<arguments.length;t++){var r=arguments[t];if(r){var o=typeof r;if("string"===o||"number"===o)e.push(r);else if(Array.isArray(r))e.push(n.apply(null,r));else if("object"===o)for(var a in r)i.call(r,a)&&r[a]&&e.push(a)}}return e.join(" ")}var i={}.hasOwnProperty;void 0!==e&&e.exports?e.exports=n:(r=[],void 0!==(o=function(){return n}.apply(t,r))&&(e.exports=o))}()},function(e,t,n){"use strict";function r(e,t){return o[e].reduce(function(e,n){return"string"==typeof n?e.push(n):n.hasOwnProperty(t)&&e.push(n[t]),e},[e])}t.__esModule=!0;var o={BUTTON_ARROW_BACKWARD:["HO_CHANGE_PAGE","HO_INPUT_BUTTON"],BUTTON_ARROW_FORWARD:["HO_CHANGE_PAGE","HO_INPUT_BUTTON"],BUTTON_CTA_OVERLAY:["HO_INPUT_BUTTON","HO_ENTER_FULLSCREEN"],BUTTON_FULLSCREEN:["HO_INPUT_BUTTON","HO_ENTER_FULLSCREEN"],BUTTON_ZOOMIN:["HO_CHANGE_ZOOM","HO_INPUT_BUTTON"],BUTTON_ZOOMOUT:["HO_CHANGE_ZOOM","HO_INPUT_BUTTON"],BUTTON_LOGO:["HO_INPUT_BUTTON"],BUTTON_DOWNLOAD:["HO_INPUT_BUTTON"],BUTTON_INFO:["HO_INPUT_BUTTON"],GESTURE_DRAG_PAGES:["HO_CHANGE_PAGE","HO_INPUT_GESTURE"],GESTURE_PINCH_ZOOM:["HO_CHANGE_ZOOM","HO_INPUT_GESTURE"],DOUBLE_TAP_ZOOM:["HO_CHANGE_ZOOM","HO_INPUT_GESTURE"],KEYBOARD_BACKWARD:["HO_CHANGE_PAGE","HO_INPUT_KEYBOARD"],KEYBOARD_FORWARD:["HO_CHANGE_PAGE","HO_INPUT_KEYBOARD"],KEYBOARD_FULLSCREEN_EXIT:["HO_INPUT_KEYBOARD"],SLIDER_PAGES:["HO_CHANGE_PAGE","HO_INPUT_SLIDER"],SLIDER_ZOOM:["HO_CHANGE_ZOOM","HO_INPUT_SLIDER"],BUTTON_SHARE:["HO_INPUT_BUTTON"],SHARE_EMAIL:["HO_SHARE_SOCIAL"],SHARE_FACEBOOK:["HO_SHARE_SOCIAL"],SHARE_TWITTER:["HO_SHARE_SOCIAL"],SHARE_PINTEREST:["HO_SHARE_SOCIAL"],BUTTON_MORE:["HO_MORE_CONTENT","HO_INPUT_BUTTON"],FULLSCREEN_MORE:["HO_MORE_CONTENT"],PUBLICATION_LINK:[],DOWNLOAD_FROM_ISSUU_LINK:[],INFO_PUBLISHER_LINK:[],BUTTON_OPEN_FIND:["HO_INPUT_BUTTON","HO_OPEN_FIND",{opportunity:"HO_FIND"}],KEYBOARD_OPEN_FIND:["HO_INPUT_KEYBOARD","HO_OPEN_FIND",{opportunity:"HO_FIND"}],FIND_QUERY:[{usage:"HO_FIND"}],FIND_NEXT:[],FIND_PREV:[],FIND_CLOSE:[]},i=t.FEATURES=Object.keys(o).reduce(function(e,t){return e[t]=t,e},{});t.FeatureTracker=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this._opportunitySent={},this._usageSent={},this.tracker=t,this.errorHandler=n,this.userId=r}return e.prototype._isValidKey=function(e){return!!i.hasOwnProperty(e)||(this.errorHandler(new Error("Attempted to track invalid key "+e)),!1)},e.prototype.opportunity=function(e){var t=this;this._isValidKey(e)&&!this._opportunitySent.hasOwnProperty(e)&&r(e,"opportunity").forEach(function(e){if(!t._opportunitySent.hasOwnProperty(e)){t.tracker.monitor("reader3-features."+e,{opportunity:1,userId:t.userId},!1),t._opportunitySent[e]=!0}})},e.prototype.usage=function(e){var t=this;this._isValidKey(e)&&r(e,"usage").forEach(function(e){var n="reader3-features."+e,r=t._usageSent.hasOwnProperty(e)?0:1;t.tracker.monitor(n,{usageRepeat:1,usageFirst:r,userId:t.userId},!1),t._usageSent[e]=!0})},e}()},function(e,t){var n={}.hasOwnProperty;e.exports=function(e,t){return n.call(e,t)}},function(e,t,n){"use strict";var r=!("undefined"==typeof window||!window.document||!window.document.createElement);e.exports={canUseDOM:r,canUseWorkers:"undefined"!=typeof Worker,canUseEventListeners:r&&!(!window.addEventListener&&!window.attachEvent),canUseViewport:r&&!!window.screen,isInWorker:!r}},function(e,t){e.exports=function(e){if("function"!=typeof e)throw TypeError(e+" is not a function!");return e}},function(e,t,n){var r=n(15),o=n(61);e.exports=n(14)?function(e,t,n){return r.f(e,t,o(1,n))}:function(e,t,n){return e[t]=n,e}},function(e,t,n){var r=n(4),o=n(25),i=n(22),a=n(72)("src"),s=Function.toString,u=(""+s).split("toString");n(49).inspectSource=function(e){return s.call(e)},(e.exports=function(e,t,n,s){var l="function"==typeof n;l&&(i(n,"name")||o(n,"name",t)),e[t]!==n&&(l&&(i(n,a)||o(n,a,e[t]?""+e[t]:u.join(String(t)))),e===r?e[t]=n:s?e[t]?e[t]=n:o(e,t,n):(delete e[t],o(e,t,n)))})(Function.prototype,"toString",function(){return"function"==typeof this&&this[a]||s.call(this)})},function(e,t,n){var r=n(0),o=n(6),i=n(37),a=function(e,t,n,r){var o=String(i(e)),a="<"+t;return""!==n&&(a+=" "+n+'="'+String(r).replace(/"/g,"&quot;")+'"'),a+">"+o+"</"+t+">"};e.exports=function(e,t){var n={};n[e]=t(a),r(r.P+r.F*o(function(){var t=""[e]('"');return t!==t.toLowerCase()||t.split('"').length>3}),"String",n)}},function(e,t,n){var r=n(99),o=n(37);e.exports=function(e){return r(o(e))}},function(e,t,n){"use strict";function r(){return function(e,t){t().reader.isIdle&&e({type:S.types.SET_IS_IDLE,isIdle:!1}),x&&clearTimeout(x),x=setTimeout(function(){e({type:S.types.SET_IS_IDLE,isIdle:!0})},_.MS_BEFORE_IDLE)}}function o(){return function(e,t){t().reader.isIdle||e({type:S.types.SET_IS_IDLE,isIdle:!0}),x&&(clearTimeout(x),x=null)}}function i(e){return function(t,n){if([w.SPACE,w.RIGHT,w.UP].includes(e)){t(b.selectCurrentSpreadIndex(n())+1<b.selectLastSpreadIndex(n())?o():r())}else if([w.LEFT,w.DOWN].includes(e)){var i=b.selectCurrentSpreadIndex(n());t(i>1?o():r())}else t(r())}}function a(){return function(e,t){e(r())}}function s(){return function(e,t){e(r())}}function u(){return function(e,t){e(r())}}function l(){return function(e,t){e(o())}}function c(){return function(e,t){e(r())}}function p(){return function(e,t){isNaN(T)&&(T=t().reader.zoomLevel),e(1!==T?o():r())}}function d(){return function(e,t){var n=t().reader.zoomLevel;e(1!==T&&1!==n?o():r())}}function f(){return function(e,t){var n=t().reader.zoomLevel;e(1!==T&&1!==n?o():r()),T=NaN}}function h(){return function(e,t){e(r())}}function m(){return function(e,t){e(r())}}function g(){return function(e,t){e(r())}}t.__esModule=!0,t.onResize=t.onDoubleTap=t.onSingleTapConfirmed=t.onInteractingWithSlider=t.onInteractingWithCanvasEnd=t.onInteractingWithCanvas=t.onInteractingWithCanvasStart=t.onMouseLeave=t.onMouseEnter=t.onMouseMove=t.onButtonClick=t.onKeyPress=void 0;var v=n(11),b=babelHelpers.interopRequireWildcard(v),y=n(57),_=babelHelpers.interopRequireWildcard(y),E=n(209),w=babelHelpers.interopRequireWildcard(E),S=n(8),x=void 0,T=NaN;t.onKeyPress=i,t.onButtonClick=a,t.onMouseMove=s,t.onMouseEnter=u,t.onMouseLeave=l,t.onInteractingWithCanvasStart=p,t.onInteractingWithCanvas=d,t.onInteractingWithCanvasEnd=f,t.onInteractingWithSlider=c,t.onSingleTapConfirmed=h,t.onDoubleTap=m,t.onResize=g},function(e,t,n){var r=n(100),o=n(61),i=n(28),a=n(44),s=n(22),u=n(231),l=Object.getOwnPropertyDescriptor;t.f=n(14)?l:function(e,t){if(e=i(e),t=a(t,!0),u)try{return l(e,t)}catch(e){}if(s(e,t))return o(!r.f.call(e,t),e[t])}},function(e,t,n){var r=n(22),o=n(18),i=n(156)("IE_PROTO"),a=Object.prototype;e.exports=Object.getPrototypeOf||function(e){return e=o(e),r(e,i)?e[i]:"function"==typeof e.constructor&&e instanceof e.constructor?e.constructor.prototype:e instanceof Object?a:null}},function(e,t,n){"use strict";function r(e){return function(){return e}}var o=function(){};o.thatReturns=r,o.thatReturnsFalse=r(!1),o.thatReturnsTrue=r(!0),o.thatReturnsNull=r(null),o.thatReturnsThis=function(){return this},o.thatReturnsArgument=function(e){return e},e.exports=o},function(e,t,n){"use strict";function r(e,t){return e===t}function o(e,t,n){if(null===t||null===n||t.length!==n.length)return!1;for(var r=t.length,o=0;o<r;o++)if(!e(t[o],n[o]))return!1;return!0}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:r,n=null,i=null;return function(){return o(t,n,arguments)||(i=e.apply(null,arguments)),n=arguments,i}}function a(e){var t=Array.isArray(e[0])?e[0]:e;if(!t.every(function(e){return"function"==typeof e})){var n=t.map(function(e){return typeof e}).join(", ");throw new Error("Selector creators expect all input-selectors to be functions, instead received the following types: ["+n+"]")}return t}function s(e){for(var t=arguments.length,n=Array(t>1?t-1:0),r=1;r<t;r++)n[r-1]=arguments[r];return function(){for(var t=arguments.length,r=Array(t),o=0;o<t;o++)r[o]=arguments[o];var s=0,u=r.pop(),l=a(r),c=e.apply(void 0,[function(){return s++,u.apply(null,arguments)}].concat(n)),p=i(function(){for(var e=[],t=l.length,n=0;n<t;n++)e.push(l[n].apply(null,arguments));return c.apply(null,e)});return p.resultFunc=u,p.recomputations=function(){return s},p.resetRecomputations=function(){return s=0},p}}function u(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:l;if("object"!=typeof e)throw new Error("createStructuredSelector expects first argument to be an object where each property is a selector, instead received a "+typeof e);var n=Object.keys(e);return t(n.map(function(t){return e[t]}),function(){for(var e=arguments.length,t=Array(e),r=0;r<e;r++)t[r]=arguments[r];return t.reduce(function(e,t,r){return e[n[r]]=t,e},{})})}t.__esModule=!0,t.defaultMemoize=i,t.createSelectorCreator=s,t.createStructuredSelector=u;var l=t.createSelector=s(i)},function(e,t){var n;n=function(){return this}();try{n=n||Function("return this")()||(0,eval)("this")}catch(e){"object"==typeof window&&(n=window)}e.exports=n},function(e,t,n){"use strict";function r(){return window.devicePixelRatio||1}t.__esModule=!0,t.getDPR=r},function(e,t){var n={}.toString;e.exports=function(e){return n.call(e).slice(8,-1)}},function(e,t){e.exports=function(e){if(void 0==e)throw TypeError("Can't call method on  "+e);return e}},function(e,t,n){var r=n(6);e.exports=function(e,t){return!!e&&r(function(){t?e.call(null,function(){},1):e.call(null)})}},function(e,t,n){"use strict";var r=null;e.exports={debugTool:r}},function(e,t,n){"use strict";t.__esModule=!0;t.DOUBLE_PAGE_SPREAD="DOUBLE_PAGE_SPREAD",t.SINGLE_PAGE_SPREAD="SINGLE_PAGE_SPREAD",t.RESPONSIVE={HANDHELD_IN_PORTRAIT:"HANDHELD_IN_PORTRAIT",HANDHELD_IN_PORTRAIT_FULLSCREEN:"HANDHELD_IN_PORTRAIT_IN_FULLSCREEN",PHONE_ISH_IN_PORTRAIT:"PHONE_ISH_IN_PORTRAIT"}},function(e,t,n){"use strict";t.__esModule=!0,t.READ_MODE=t.BACKGROUND_IMAGE_STYLE=t.NAVIGATION_ARROWS_TYPE=t.DOWNLOAD_TYPE=t.ZOOM_TYPE=t.INFO_DIALOG_TYPE=t.SHARE_DIALOG_TYPE=t.LINKS_TYPE=t.ISSUU_BRANDING_KIND=t.ISSUU_BRANDING_TYPE=t.FULLSCREEN_BUTTON=t.FULLSCREEN_KIND=t.FULLSCREEN_TYPE=void 0;var r=n(40),o=babelHelpers.interopRequireWildcard(r);t.FULLSCREEN_TYPE="FEATURE_FULLSCREEN",t.FULLSCREEN_KIND={NORMAL:"NORMAL",FALLBACK:"FALLBACK"},t.FULLSCREEN_BUTTON={ALWAYS:"ALWAYS",HIDE:"HIDE_WHEN_NOT_SUPPORTED"},t.ISSUU_BRANDING_TYPE="FEATURE_ISSUU_BRANDING",t.ISSUU_BRANDING_KIND={LANDING_PAGE:"LANDING_PAGE"},t.LINKS_TYPE="FEATURE_LINKS",t.SHARE_DIALOG_TYPE="FEATURE_SHARE_DIALOG",t.INFO_DIALOG_TYPE="FEATURE_INFO_DIALOG",t.ZOOM_TYPE="FEATURE_ZOOM",t.DOWNLOAD_TYPE="FEATURE_DOWNLOAD",t.NAVIGATION_ARROWS_TYPE="FEATURE_NAVIGATION_ARROWS",t.BACKGROUND_IMAGE_STYLE={STRETCH:"STRETCH",TOP_LEFT:"TOP_LEFT"},t.READ_MODE=o},function(e,t,n){var r=n(50),o=n(99),i=n(18),a=n(17),s=n(408);e.exports=function(e,t){var n=1==e,u=2==e,l=3==e,c=4==e,p=6==e,d=5==e||p,f=t||s;return function(t,s,h){for(var m,g,v=i(t),b=o(v),y=r(s,h,3),_=a(b.length),E=0,w=n?f(t,_):u?f(t,0):void 0;_>E;E++)if((d||E in b)&&(m=b[E],g=y(m,E,v),e))if(n)w[E]=g;else if(g)switch(e){case 3:return!0;case 5:return m;case 6:return E;case 2:w.push(m)}else if(c)return!1;return p?-1:l||c?c:w}}},function(e,t,n){var r=n(0),o=n(49),i=n(6);e.exports=function(e,t){var n=(o.Object||{})[e]||Object[e],a={};a[e]=t(n),r(r.S+r.F*i(function(){n(1)}),"Object",a)}},function(e,t,n){var r=n(9);e.exports=function(e,t){if(!r(e))return e;var n,o;if(t&&"function"==typeof(n=e.toString)&&!r(o=n.call(e)))return o;if("function"==typeof(n=e.valueOf)&&!r(o=n.call(e)))return o;if(!t&&"function"==typeof(n=e.toString)&&!r(o=n.call(e)))return o;throw TypeError("Can't convert object to primitive value")}},function(e,t,n){"use strict";function r(){I.ReactReconcileTransaction&&E||c("123")}function o(){this.reinitializeTransaction(),this.dirtyComponentsLength=null,this.callbackQueue=d.getPooled(),this.reconcileTransaction=I.ReactReconcileTransaction.getPooled(!0)}function i(e,t,n,o,i,a){return r(),E.batchedUpdates(e,t,n,o,i,a)}function a(e,t){return e._mountOrder-t._mountOrder}function s(e){var t=e.dirtyComponentsLength;t!==v.length&&c("124",t,v.length),v.sort(a),b++;for(var n=0;n<t;n++){var r=v[n],o=r._pendingCallbacks;r._pendingCallbacks=null;var i;if(h.logTopLevelRenders){var s=r;r._currentElement.type.isReactTopLevelWrapper&&(s=r._renderedComponent),i="React update: "+s.getName(),console.time(i)}if(m.performUpdateIfNecessary(r,e.reconcileTransaction,b),i&&console.timeEnd(i),o)for(var u=0;u<o.length;u++)e.callbackQueue.enqueue(o[u],r.getPublicInstance())}}function u(e){if(r(),!E.isBatchingUpdates)return void E.batchedUpdates(u,e);v.push(e),null==e._updateBatchNumber&&(e._updateBatchNumber=b+1)}function l(e,t){E.isBatchingUpdates||c("125"),y.enqueue(e,t),_=!0}var c=n(7),p=n(13),d=n(270),f=n(73),h=n(275),m=n(88),g=n(126),v=(n(1),[]),b=0,y=d.getPooled(),_=!1,E=null,w={initialize:function(){this.dirtyComponentsLength=v.length},close:function(){this.dirtyComponentsLength!==v.length?(v.splice(0,this.dirtyComponentsLength),T()):v.length=0}},S={initialize:function(){this.callbackQueue.reset()},close:function(){this.callbackQueue.notifyAll()}},x=[w,S];p(o.prototype,g,{getTransactionWrappers:function(){return x},destructor:function(){this.dirtyComponentsLength=null,d.release(this.callbackQueue),this.callbackQueue=null,I.ReactReconcileTransaction.release(this.reconcileTransaction),this.reconcileTransaction=null},perform:function(e,t,n){return g.perform.call(this,this.reconcileTransaction.perform,this.reconcileTransaction,e,t,n)}}),f.addPoolingTo(o);var T=function(){for(;v.length||_;){if(v.length){var e=o.getPooled();e.perform(s,null,e),o.release(e)}if(_){_=!1;var t=y;y=d.getPooled(),t.notifyAll(),d.release(t)}}},C={injectReconcileTransaction:function(e){e||c("126"),I.ReactReconcileTransaction=e},injectBatchingStrategy:function(e){e||c("127"),"function"!=typeof e.batchedUpdates&&c("128"),"boolean"!=typeof e.isBatchingUpdates&&c("129"),E=e}},I={ReactReconcileTransaction:null,batchedUpdates:i,enqueueUpdate:u,flushBatchedUpdates:T,injection:C,asap:l};e.exports=I},function(e,t,n){"use strict";var r=n(638);e.exports=function(e,t,n,o){var i=n?n.call(o,e,t):void 0;if(void 0!==i)return!!i;if(e===t)return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var a=r(e),s=r(t),u=a.length;if(u!==s.length)return!1;o=o||null;for(var l=Object.prototype.hasOwnProperty.bind(t),c=0;c<u;c++){var p=a[c];if(!l(p))return!1;var d=e[p],f=t[p],h=n?n.call(o,d,f,p):void 0;if(h===!1||void 0===h&&d!==f)return!1}return!0}},function(e,t,n){"use strict";function r(e){return Array.isArray(e)?e:null!==e&&void 0!==e?[e]:b}function o(e,t){var n,r,i,a,s;return regeneratorRuntime.wrap(function(u){for(;;)switch(u.prev=u.next){case 0:n=e.children,r=Array.isArray(n),i=0,n=r?n:n[Symbol.iterator]();case 1:if(!r){u.next=7;break}if(!(i>=n.length)){u.next=4;break}return u.abrupt("break",18);case 4:a=n[i++],u.next=11;break;case 7:if(i=n.next(),!i.done){u.next=10;break}return u.abrupt("break",18);case 10:a=i.value;case 11:if(s=a,s.owner!==t){u.next=15;break}return u.next=15,s;case 15:return u.delegateYield(o(s,t),"t0",16);case 16:u.next=1;break;case 18:case"end":return u.stop()}},c[0],this)}function i(e){var t,n,r,o,a;return regeneratorRuntime.wrap(function(s){for(;;)switch(s.prev=s.next){case 0:t=e.wrappedChildren,n=Array.isArray(t),r=0,t=n?t:t[Symbol.iterator]();case 1:if(!n){s.next=7;break}if(!(r>=t.length)){s.next=4;break}return s.abrupt("break",17);case 4:o=t[r++],s.next=11;break;case 7:if(r=t.next(),!r.done){s.next=10;break}return s.abrupt("break",17);case 10:o=r.value;case 11:return a=o,s.next=14,a;case 14:return s.delegateYield(i(a),"t0",15);case 15:s.next=1;break;case 17:case"end":return s.stop()}},c[1],this)}function a(e){return Object.getPrototypeOf(e)===Object.prototype}t.__esModule=!0,t.CanvasObject=t.HIGHLIGHT_FLASH_OPERATION=t.HIGHLIGHT_OPERATION=t.BENDING_PAGE_OPERATION=t.DEPTH_MAP_OPERATION=t.SHADOW_OPERATION=t.LINK_OPERATION=t.TOOLTIP_OPERATION=t.RENDER_DEBUG=void 0;var s=n(75),u=n(79),l=n(10),c=(babelHelpers.interopRequireDefault(l),[o,i].map(regeneratorRuntime.mark)),p=(t.RENDER_DEBUG=!1,t.TOOLTIP_OPERATION="tooltip-operation"),d=t.LINK_OPERATION="link-operation",f=t.SHADOW_OPERATION="shadow-operation",h=t.DEPTH_MAP_OPERATION="depth-map-operation",m=t.BENDING_PAGE_OPERATION="bending-page-operation",g=t.HIGHLIGHT_OPERATION="highlight-operation",v=t.HIGHLIGHT_FLASH_OPERATION="highlight-flash-operation",b=[],y={_pool:[],created:0,get:function(e,t,n,r){if(this._pool.length){var o=this._pool.pop();return o.x=e,o.y=t,o.width=n,o.height=r,o}return this.created++,{x:e,y:t,width:n,height:r}},release:function(e){this._pool.push(e)},unreleasedCount:function(){return this.created-this._pool.length}};(t.CanvasObject=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.props=t,this.parent=n}return e.prototype.getChildTree=function(e){return e},e.prototype.requestRedraw=function(){this.root._pendingRedraw=!0},e.prototype.getChildrenToTraverse=function(){return this.children},e.prototype.getVisibleChildren=function(){var t=y.get(0,0,this.width,this.height),n=[];return e.traverse(this,function(e,r,o,i){return 0===i||((0,u.overlap)(t,r)&&e.isVisible&&n.push(e),!1)},this.getViewportCTM()),y.release(t),n},e.prototype.getVisibleDescendants=function(){var t=y.get(0,0,this.width,this.height),n=[];return e.traverse(this,function(e,r,o,i){return 0===i||((0,u.overlap)(t,r)&&e.isVisible&&n.push(e),!0)},this.getViewportCTM()),y.release(t),n},e.prototype.overlaps=function(e){var t=this.bbox,n=(0,u.overlap)(e,t);return y.release(t),n},e.prototype.shouldComponentUpdate=function(e){if(this.props===e)return!1;var t=Object.keys(this.props);if(t.length!==Object.keys(e).length)return!0;for(var n=0;n<t.length;n++){var r=t[n];if(babelHelpers.typeof(this.props[r])instanceof s.MatrixTransformation&&!this.props[r].isEqualWith(e[r]))return!0;if(this.props[r]!==e[r])return!0}return!1},e.prototype.getViewportCTM=function(){var e=this.transform;return this.parent&&(e=this.parent.getViewportCTM().multiply(e)),e},e.prototype.forceUpdate=function(){e.updateProps(this,this.props,!0)},e.updateProps=function(t,n,r){e.buildTree({type:Object.getPrototypeOf(t).constructor,props:n,wrappedChildren:[]},t,t,null,r)},e.buildTree=function(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,s=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,u=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,l=arguments.length>4&&void 0!==arguments[4]&&arguments[4],c=arguments.length>5&&void 0!==arguments[5]?arguments[5]:0,p=t.type,d=t.props,f=t.wrappedChildren;if(n){if(p.prototype!==Object.getPrototypeOf(n))throw new Error("Unsupported update. Trying to replace "+Object.getPrototypeOf(n).constructor.name+" with "+p.prototype.constructor.name);var h=Object.assign({},n.props,d),m=l||n.shouldComponentUpdate(h);m&&n.componentWillUpdate&&n.componentWillUpdate(h);var g=n.props;if(n.props=h,m){r(n.getChildTree(f)).forEach(function(t,r){e.buildTree(t,n.children[r],s,l,c+1)}),n.componentDidUpdate&&n.componentDidUpdate(g),n.requestRedraw()}else for(var v=o(n,s),b=i(t),y=b.next();!y.done;)e.buildTree(y.value,v.next().value,s,l,c+1),y=b.next();return n}var _=new p(d,u);_.owner=s;var E=f.map(function(t){if(a(t)){return e.buildTree(t,n,s,_,l,c+1)}return t.parent=_,t}),w=_.getChildTree(E);return _.children=r(w).map(function(t){if(a(t)){return e.buildTree(t,n,_,_,l,c+1)}return t}),_.componentDidMount&&_.componentDidMount(),_},e.createElement=function(e,t){for(var n=[],r=2;r<arguments.length;r++){var o=arguments[r];Array.isArray(o)?Array.prototype.push.apply(n,o):o&&n.push(o)}return"group"===e?n:{type:e,props:t||{},wrappedChildren:n}},e.traverse=function(t,n){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:new s.MatrixTransformation,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,i=r.transformRect(y.get(0,0,t.width,t.height));if(!n(t,i,r,o))return void y.release(i);var a=t.getChildrenToTraverse();if(a&&a.length)for(var l=a.slice(0).sort(function(e,t){return e.zOrder-t.zOrder}),c=l,p=Array.isArray(c),d=0,c=p?c:c[Symbol.iterator]();;){var f;if(p){if(d>=c.length)break;f=c[d++]}else{if(d=c.next(),d.done)break;f=d.value}var h=f,m=r.matrix[0],g=r.matrix[1],v=r.matrix[2],b=r.matrix[3],_=r.matrix[4],E=r.matrix[5];r.mMultiply(h.transform);var w=r.transformRect(y.get(0,0,h.width,h.height));(0,u.overlap)(i,w)&&e.traverse(h,n,r,o+1),r.mSet(m,g,v,b,_,E),y.release(w)}y.release(i)},e.drawWebgl=function(t,n,r,o,i){var a={width:n.gl.drawingBufferWidth,height:n.gl.drawingBufferHeight},s=[];e.drawTree(t,r,o,i,function(e,t){e.appendWebglOps&&e.appendWebglOps(s,t,a,o)}),n.gl.clearColor(0,0,0,0),n.gl.clearStencil(0),n.gl.clear(n.gl.COLOR_BUFFER_BIT|n.gl.DEPTH_BUFFER_BIT|n.gl.STENCIL_BUFFER_BIT),s.forEach(function(e){var t,r,o,i,a,s,u;switch(e.type){case p:(t=n.linkTooltip).draw.apply(t,e.args);break;case d:(r=n.link).draw.apply(r,e.args);break;case f:(o=n.shadowDraw).draw.apply(o,[n.shadow.depthMapTexture].concat(e.args));break;case m:(i=n.bendingPage).draw.apply(i,e.args);break;case h:(a=n.shadow).computeDepthMap.apply(a,e.args);break;case g:(s=n.highlights).draw.apply(s,e.args);break;case v:(u=n.highlights).drawSelected.apply(u,e.args);break;default:throw new Error("Unknown 3d operation: "+e.type)}})},e.draw2d=function(t,n,r,o,i){e.drawTree(t,r,o,i,function(e,t){e.draw&&e.draw(n,t,o)})},e.drawTree=function(t,n,r,o,i){if(t._pendingRedraw&&(t._pendingRedraw=!1),t.isVisible){var a=o?new Float32Array(o.matrix):null;o?o.mMultiply(t.transform):o=(new s.MatrixTransformation).mMultiply(t.getViewportCTM());var l=o.transformRect(y.get(0,0,t.width,t.height));if((0,u.overlap)(n,l)){t.beforeDraw&&t.beforeDraw(l,r),i(t,l);var c=t.getChildrenToTraverse();c&&c.length&&c.slice(0).sort(function(e,t){return e.zOrder-t.zOrder}).forEach(function(t){return e.drawTree(t,n,r,o,i)}),t.afterDraw&&t.afterDraw(l,r)}y.release(l),a&&o.mSetMatrix(a)}},e.connect=function(t,n){return function(r){function o(e,i){babelHelpers.classCallCheck(this,o);var a=e.store||i.root&&i.root.__store__;if(!a)throw new Error("Cannot connect "+t+": Cannot get store!");var s=a.getState();Object.assign(e,{dispatch:a.dispatch},n(s));var u=babelHelpers.possibleConstructorReturn(this,r.call(this,e,i));return u._unsubscribe=function(){},u}return babelHelpers.inherits(o,r),o.prototype.componentDidMount=function(){var r=this,o=this.root.__store__;if(!o)throw new Error("Root component has no store, cannot connect");this._unsubscribe=o.subscribe(function(){var t=o.getState(),i=Object.assign({dispatch:o.dispatch},r.props,n(t));e.updateProps(r,i)}),t.prototype.componentDidMount&&t.prototype.componentDidMount.call(this)},o.prototype.componentWillUnmount=function(){this._unsubscribe(),t.prototype.componentWillUnmount&&t.prototype.componentWillUnmount.call(this)},babelHelpers.createClass(o,[{key:"displayName",get:function(){return"Connected"+t.name}}]),o}(t)},e.unmountTree=function(t){for(var n=t.children,r=Array.isArray(n),o=0,n=r?n:n[Symbol.iterator]();;){var i;if(r){if(o>=n.length)break;i=n[o++]}else{if(o=n.next(),o.done)break;i=o.value}e.unmountTree(i)}t.componentWillUnmount&&t.componentWillUnmount()},babelHelpers.createClass(e,[{key:"root",get:function(){for(var e=this;e.parent;)e=e.parent;return e}},{key:"inAnimation",get:function(){return!!this.parent&&this.parent.inAnimation}},{key:"hasPendingRedraw",get:function(){return this.root._pendingRedraw}},{key:"transform",get:function(){return this._transform||(this._transform=this.props.transform||new s.MatrixTransformation),this._transform}},{key:"viewportBBox",get:function(){return this.getViewportCTM().transformRect(y.get(0,0,this.width,this.height))}},{key:"bbox",get:function(){return this.transform.transformRect(y.get(0,0,this.width,this.height))}},{key:"width",get:function(){return this.props.width}},{key:"height",get:function(){return this.props.height}},{key:"zOrder",get:function(){return 0}},{key:"isVisible",get:function(){return!0}},{key:"displayName",get:function(){return Object.getPrototypeOf(this).constructor.name}}]),e}()).RectPool=y},function(e,t,n){"use strict";t.__esModule=!0,t.selectors=t.createMiddleware=t.createReducer=t.components=t.actions=void 0;var r=n(310),o=babelHelpers.interopRequireDefault(r),i=n(215),a=n(216),s=n(11),u=n(8),l=function(e){return e.config.hosts.main},c=(0,o.default)({onKeepReading:u.goToNextPage,selectCurrentPageNumbers:s.selectCurrentPageNumbers,selectHostName:l,selectPublicationCoverUrl:i.selectPublicationCoverUrl,selectPublicationName:i.selectPublicationName,selectPublicationPageCount:i.selectPublicationPageCount,selectPublicationTitle:i.selectPublicationTitle,selectPublisherDisplayName:a.selectPublisherDisplayName,selectPublisherName:a.selectPublisherName,selectPublisherProfileImageUrl:a.selectPublisherProfileImageUrl,selectPublisherProfileUrl:a.selectPublisherProfileUrl,actionTypes:{READER_POSITION_CHANGED:u.READER_POSITION_CHANGED}}),p=c.actions,d=c.components,f=c.createReducer,h=c.createMiddleware,m=c.selectors;t.actions=p,t.components=d,t.createReducer=f,t.createMiddleware=h,t.selectors=m},function(e,t){var n=e.exports={version:"2.4.0"};"number"==typeof __e&&(__e=n)},function(e,t,n){var r=n(24);e.exports=function(e,t,n){if(r(e),void 0===t)return e;switch(n){case 1:return function(n){return e.call(t,n)};case 2:return function(n,r){return e.call(t,n,r)};case 3:return function(n,r,o){return e.call(t,n,r,o)}}return function(){return e.apply(t,arguments)}}},function(e,t,n){var r=n(247),o=n(0),i=n(121)("metadata"),a=i.store||(i.store=new(n(250))),s=function(e,t,n){var o=a.get(e);if(!o){if(!n)return;a.set(e,o=new r)}var i=o.get(t);if(!i){if(!n)return;o.set(t,i=new r)}return i};e.exports={store:a,map:s,has:function(e,t,n){var r=s(t,n,!1);return void 0!==r&&r.has(e)},get:function(e,t,n){var r=s(t,n,!1);return void 0===r?void 0:r.get(e)},set:function(e,t,n,r){s(n,r,!0).set(e,t)},keys:function(e,t){var n=s(e,t,!1),r=[];return n&&n.forEach(function(e,t){r.push(t)}),r},key:function(e){return void 0===e||"symbol"==typeof e?e:String(e)},exp:function(e){o(o.S,"Reflect",e)}}},function(e,t,n){"use strict";if(n(14)){var r=n(65),o=n(4),i=n(6),a=n(0),s=n(122),u=n(163),l=n(50),c=n(64),p=n(61),d=n(25),f=n(69),h=n(62),m=n(17),g=n(71),v=n(44),b=n(22),y=n(244),_=n(98),E=n(9),w=n(18),S=n(148),x=n(66),T=n(31),C=n(67).f,I=n(165),R=n(72),M=n(12),P=n(42),O=n(112),A=n(157),D=n(166),k=n(82),N=n(118),L=n(70),F=n(141),U=n(224),H=n(15),B=n(30),j=H.f,W=B.f,z=o.RangeError,q=o.TypeError,V=o.Uint8Array,G=Array.prototype,Y=u.ArrayBuffer,$=u.DataView,K=P(0),X=P(2),Z=P(3),Q=P(4),J=P(5),ee=P(6),te=O(!0),ne=O(!1),re=D.values,oe=D.keys,ie=D.entries,ae=G.lastIndexOf,se=G.reduce,ue=G.reduceRight,le=G.join,ce=G.sort,pe=G.slice,de=G.toString,fe=G.toLocaleString,he=M("iterator"),me=M("toStringTag"),ge=R("typed_constructor"),ve=R("def_constructor"),be=s.CONSTR,ye=s.TYPED,_e=s.VIEW,Ee=P(1,function(e,t){return Ie(A(e,e[ve]),t)}),we=i(function(){return 1===new V(new Uint16Array([1]).buffer)[0]}),Se=!!V&&!!V.prototype.set&&i(function(){new V(1).set({})}),xe=function(e,t){if(void 0===e)throw q("Wrong length!");var n=+e,r=m(e);if(t&&!y(n,r))throw z("Wrong length!");return r},Te=function(e,t){var n=h(e);if(n<0||n%t)throw z("Wrong offset!");return n},Ce=function(e){if(E(e)&&ye in e)return e;throw q(e+" is not a typed array!")},Ie=function(e,t){if(!(E(e)&&ge in e))throw q("It is not a typed array constructor!");return new e(t)},Re=function(e,t){return Me(A(e,e[ve]),t)},Me=function(e,t){for(var n=0,r=t.length,o=Ie(e,r);r>n;)o[n]=t[n++];return o},Pe=function(e,t,n){j(e,t,{get:function(){return this._d[n]}})},Oe=function(e){var t,n,r,o,i,a,s=w(e),u=arguments.length,c=u>1?arguments[1]:void 0,p=void 0!==c,d=I(s);if(void 0!=d&&!S(d)){for(a=d.call(s),r=[],t=0;!(i=a.next()).done;t++)r.push(i.value);s=r}for(p&&u>2&&(c=l(c,arguments[2],2)),t=0,n=m(s.length),o=Ie(this,n);n>t;t++)o[t]=p?c(s[t],t):s[t];return o},Ae=function(){for(var e=0,t=arguments.length,n=Ie(this,t);t>e;)n[e]=arguments[e++];return n},De=!!V&&i(function(){fe.call(new V(1))}),ke=function(){return fe.apply(De?pe.call(Ce(this)):Ce(this),arguments)},Ne={copyWithin:function(e,t){return U.call(Ce(this),e,t,arguments.length>2?arguments[2]:void 0)},every:function(e){return Q(Ce(this),e,arguments.length>1?arguments[1]:void 0)},fill:function(e){return F.apply(Ce(this),arguments)},filter:function(e){return Re(this,X(Ce(this),e,arguments.length>1?arguments[1]:void 0))},find:function(e){return J(Ce(this),e,arguments.length>1?arguments[1]:void 0)},findIndex:function(e){return ee(Ce(this),e,arguments.length>1?arguments[1]:void 0)},forEach:function(e){K(Ce(this),e,arguments.length>1?arguments[1]:void 0)},indexOf:function(e){return ne(Ce(this),e,arguments.length>1?arguments[1]:void 0)},includes:function(e){return te(Ce(this),e,arguments.length>1?arguments[1]:void 0)},join:function(e){return le.apply(Ce(this),arguments)},lastIndexOf:function(e){return ae.apply(Ce(this),arguments)},map:function(e){return Ee(Ce(this),e,arguments.length>1?arguments[1]:void 0)},reduce:function(e){return se.apply(Ce(this),arguments)},reduceRight:function(e){return ue.apply(Ce(this),arguments)},reverse:function(){for(var e,t=this,n=Ce(t).length,r=Math.floor(n/2),o=0;o<r;)e=t[o],t[o++]=t[--n],t[n]=e;return t},some:function(e){return Z(Ce(this),e,arguments.length>1?arguments[1]:void 0)},sort:function(e){return ce.call(Ce(this),e)},subarray:function(e,t){var n=Ce(this),r=n.length,o=g(e,r);return new(A(n,n[ve]))(n.buffer,n.byteOffset+o*n.BYTES_PER_ELEMENT,m((void 0===t?r:g(t,r))-o))}},Le=function(e,t){return Re(this,pe.call(Ce(this),e,t))},Fe=function(e){Ce(this);var t=Te(arguments[1],1),n=this.length,r=w(e),o=m(r.length),i=0;if(o+t>n)throw z("Wrong length!");for(;i<o;)this[t+i]=r[i++]},Ue={entries:function(){return ie.call(Ce(this))},keys:function(){return oe.call(Ce(this))},values:function(){return re.call(Ce(this))}},He=function(e,t){return E(e)&&e[ye]&&"symbol"!=typeof t&&t in e&&String(+t)==String(t)},Be=function(e,t){return He(e,t=v(t,!0))?p(2,e[t]):W(e,t)},je=function(e,t,n){return!(He(e,t=v(t,!0))&&E(n)&&b(n,"value"))||b(n,"get")||b(n,"set")||n.configurable||b(n,"writable")&&!n.writable||b(n,"enumerable")&&!n.enumerable?j(e,t,n):(e[t]=n.value,e)};be||(B.f=Be,H.f=je),a(a.S+a.F*!be,"Object",{getOwnPropertyDescriptor:Be,defineProperty:je}),i(function(){de.call({})})&&(de=fe=function(){return le.call(this)});var We=f({},Ne);f(We,Ue),d(We,he,Ue.values),f(We,{slice:Le,set:Fe,constructor:function(){},toString:de,toLocaleString:ke}),Pe(We,"buffer","b"),Pe(We,"byteOffset","o"),Pe(We,"byteLength","l"),Pe(We,"length","e"),j(We,me,{get:function(){return this[ye]}}),e.exports=function(e,t,n,u){u=!!u;var l=e+(u?"Clamped":"")+"Array",p="Uint8Array"!=l,f="get"+e,h="set"+e,g=o[l],v=g||{},b=g&&T(g),y=!g||!s.ABV,w={},S=g&&g.prototype,I=function(e,n){var r=e._d;return r.v[f](n*t+r.o,we)},R=function(e,n,r){var o=e._d;u&&(r=(r=Math.round(r))<0?0:r>255?255:255&r),o.v[h](n*t+o.o,r,we)},M=function(e,t){j(e,t,{get:function(){return I(this,t)},set:function(e){return R(this,t,e)},enumerable:!0})};y?(g=n(function(e,n,r,o){c(e,g,l,"_d");var i,a,s,u,p=0,f=0;if(E(n)){if(!(n instanceof Y||"ArrayBuffer"==(u=_(n))||"SharedArrayBuffer"==u))return ye in n?Me(g,n):Oe.call(g,n);i=n,f=Te(r,t);var h=n.byteLength;if(void 0===o){if(h%t)throw z("Wrong length!");if((a=h-f)<0)throw z("Wrong length!")}else if((a=m(o)*t)+f>h)throw z("Wrong length!");s=a/t}else s=xe(n,!0),a=s*t,i=new Y(a);for(d(e,"_d",{b:i,o:f,l:a,e:s,v:new $(i)});p<s;)M(e,p++)}),S=g.prototype=x(We),d(S,"constructor",g)):N(function(e){new g(null),new g(e)},!0)||(g=n(function(e,n,r,o){c(e,g,l);var i;return E(n)?n instanceof Y||"ArrayBuffer"==(i=_(n))||"SharedArrayBuffer"==i?void 0!==o?new v(n,Te(r,t),o):void 0!==r?new v(n,Te(r,t)):new v(n):ye in n?Me(g,n):Oe.call(g,n):new v(xe(n,p))}),K(b!==Function.prototype?C(v).concat(C(b)):C(v),function(e){e in g||d(g,e,v[e])}),g.prototype=S,r||(S.constructor=g));var P=S[he],O=!!P&&("values"==P.name||void 0==P.name),A=Ue.values;d(g,ge,!0),d(S,ye,l),d(S,_e,!0),d(S,ve,g),(u?new g(1)[me]==l:me in S)||j(S,me,{get:function(){return l}}),w[l]=g,a(a.G+a.W+a.F*(g!=v),w),a(a.S,l,{BYTES_PER_ELEMENT:t,from:Oe,of:Ae}),"BYTES_PER_ELEMENT"in S||d(S,"BYTES_PER_ELEMENT",t),a(a.P,l,Ne),L(l),a(a.P+a.F*Se,l,{set:Fe}),a(a.P+a.F*!O,l,Ue),a(a.P+a.F*(S.toString!=de),l,{toString:de}),a(a.P+a.F*i(function(){new g(1).slice()}),l,{slice:Le}),a(a.P+a.F*(i(function(){return[1,2].toLocaleString()!=new g([1,2]).toLocaleString()})||!i(function(){S.toLocaleString.call([1,2])})),l,{toLocaleString:ke}),k[l]=O?P:A,r||O||d(S,he,A)}}else e.exports=function(){}},function(e,t){var n={};n.EPSILON=1e-6,n.ARRAY_TYPE="undefined"!=typeof Float32Array?Float32Array:Array,n.RANDOM=Math.random,n.ENABLE_SIMD=!1,n.SIMD_AVAILABLE=n.ARRAY_TYPE===Float32Array&&"SIMD"in this,n.USE_SIMD=n.ENABLE_SIMD&&n.SIMD_AVAILABLE,n.setMatrixArrayType=function(e){n.ARRAY_TYPE=e};var r=Math.PI/180;n.toRadian=function(e){return e*r},n.equals=function(e,t){return Math.abs(e-t)<=n.EPSILON*Math.max(1,Math.abs(e),Math.abs(t))},e.exports=n},function(e,t,n){"use strict";function r(e,t,n,r){this.dispatchConfig=e,this._targetInst=t,this.nativeEvent=n;var o=this.constructor.Interface;for(var i in o)if(o.hasOwnProperty(i)){var s=o[i];s?this[i]=s(n):"target"===i?this.target=r:this[i]=n[i]}return this.isDefaultPrevented=(null!=n.defaultPrevented?n.defaultPrevented:n.returnValue===!1)?a.thatReturnsTrue:a.thatReturnsFalse,this.isPropagationStopped=a.thatReturnsFalse,this}var o=n(13),i=n(73),a=n(32),s=(n(5),["dispatchConfig","_targetInst","nativeEvent","isDefaultPrevented","isPropagationStopped","_dispatchListeners","_dispatchInstances"]),u={type:null,target:null,currentTarget:a.thatReturnsNull,eventPhase:null,bubbles:null,cancelable:null,timeStamp:function(e){return e.timeStamp||Date.now()},defaultPrevented:null,isTrusted:null};o(r.prototype,{preventDefault:function(){this.defaultPrevented=!0;var e=this.nativeEvent;e&&(e.preventDefault?e.preventDefault():"unknown"!=typeof e.returnValue&&(e.returnValue=!1),this.isDefaultPrevented=a.thatReturnsTrue)},stopPropagation:function(){var e=this.nativeEvent;e&&(e.stopPropagation?e.stopPropagation():"unknown"!=typeof e.cancelBubble&&(e.cancelBubble=!0),this.isPropagationStopped=a.thatReturnsTrue)},persist:function(){this.isPersistent=a.thatReturnsTrue},isPersistent:a.thatReturnsFalse,destructor:function(){var e=this.constructor.Interface;for(var t in e)this[t]=null;for(var n=0;n<s.length;n++)this[s[n]]=null}}),r.Interface=u,r.augmentClass=function(e,t){var n=this,r=function(){};r.prototype=n.prototype;var a=new r;o(a,e.prototype),e.prototype=a,e.prototype.constructor=e,e.Interface=o({},n.Interface,t),e.augmentClass=n.augmentClass,i.addPoolingTo(e,i.fourArgumentPooler)},i.addPoolingTo(r,i.fourArgumentPooler),e.exports=r},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(713),o=n(289),i=n(714);n.d(t,"Provider",function(){return r.a}),n.d(t,"connectAdvanced",function(){return o.a}),n.d(t,"connect",function(){return i.a})},function(e,t,n){"use strict";e.exports={current:null}},function(e,t,n){"use strict";t.__esModule=!0;t.MIN_ZOOM_LEVEL=1,t.MAX_ZOOM_LEVEL=5,t.SCROLLER_SPEED_MULTIPLIER=1,t.FPS_REPORT_INTERVAL_MS=250,t.KEY_DOWN_INTERVAL=250,t.SPACE_HORIZONTAL_DPS_IN_PIXELS=20,t.SPACE_VERTICAL_DPS_IN_PIXELS=20,t.SPACE_VERTICAL_NO_UI_OVERLAP_DPS_IN_PIXELS=45,t.SPACE_HORIZONTAL_SPS_IN_PIXELS=20,t.SPACE_VERTICAL_SPS_IN_PIXELS=20,t.SPACE_VERTICAL_NO_UI_OVERLAP_SPS_IN_PIXELS=45,t.DISABLE_ADS=!0,t.MS_BEFORE_IDLE=3e3,t.MAX_LOADER_ATTEMPTS=4,t.MAX_CONCURRENT_REQUESTS=6,t.PAGELOAD_FAILURE_RETRY_INTERVAL_IN_MS=2e4,t.FONT_LOAD_TIMEOUT_IN_MS=3e3},function(e,t,n){"use strict";function r(){return g(d.types.READER_POSITION_CHANGED)}t.__esModule=!0,t.selectors=t.components=t.actions=void 0,t.createFindReducer=r;var o=n(33),i=n(307),a=babelHelpers.interopRequireDefault(i),s=n(95),u=n(11),l=n(59),c=n(96),p=n(131),d=n(8),f=(0,a.default)({isMobile:s.device.isMobile(),jumpToPageNumber:function(e,t){e.canvasApi.jumpToPage(t)},resetZoom:function(e){e.canvasApi.zoomCurrentView(1)},selectSpreadCount:(0,o.createSelector)(function(e){return e.canvasApi&&e.canvasApi.getReadMode()},function(e){return e.documentModel},function(e,t){return e&&t.pageCount?(0,l.pageNumberToSpreadIndex)(e,t.pageCount):0}),pageNumberToSpreadIndex:l.pageNumberToSpreadIndex,selectReadMode:(0,o.createSelector)(function(e){return e.canvasApi&&e.canvasApi.getReadMode()},function(e){return e}),selectCurrentPage:function(e){return(0,u.selectCurrentPages)(e)[0].pageNumber},selectPageCount:function(e){return e.documentModel.pageCount},enableWebGL:c.enableWebGL,Spinner:p.Spinner}),h=f.actions,m=f.components,g=f.createReducer,v=f.selectors;t.actions=h,t.components=m,t.selectors=v},function(e,t,n){"use strict";function r(e,t){return e===o.DOUBLE_PAGE_SPREAD?1===t?0:Math.floor(t/2):t-1}t.__esModule=!0,t.pageNumberToSpreadIndex=r;var o=n(40)},function(e,t,n){var r=n(72)("meta"),o=n(9),i=n(22),a=n(15).f,s=0,u=Object.isExtensible||function(){return!0},l=!n(6)(function(){return u(Object.preventExtensions({}))}),c=function(e){a(e,r,{value:{i:"O"+ ++s,w:{}}})},p=function(e,t){if(!o(e))return"symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!i(e,r)){if(!u(e))return"F";if(!t)return"E";c(e)}return e[r].i},d=function(e,t){if(!i(e,r)){if(!u(e))return!0;if(!t)return!1;c(e)}return e[r].w},f=function(e){return l&&h.NEED&&u(e)&&!i(e,r)&&c(e),e},h=e.exports={KEY:r,NEED:!1,fastKey:p,getWeak:d,onFreeze:f}},function(e,t){e.exports=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}}},function(e,t){var n=Math.ceil,r=Math.floor;e.exports=function(e){return isNaN(e=+e)?0:(e>0?r:n)(e)}},function(e,t,n){"use strict";function r(){return{type:d}}function o(e,t){return function(n,r){n({type:h,embedConfig:e,readMorePlugin:t});var o=(0,c.selectReadMode)(r());n((0,s.scrollToSpreadIndex)((0,l.pageNumberToSpreadIndex)(o,e.startPage)));var i=r().config,a=r().documentModel;r().readMorePlugin.load(i.getScheme(),i.hosts.main,a.publicationId,a.username,(0,p.hasLicense)("customization_show_my_other_publications",a,!0),(0,p.hasLicense)("norelated",a,!0)).then(function(e){e&&n((0,u.readMoreLoadSuccess)())})}}function i(e){return function(t,n){var r=(0,c.selectReadMode)(n());return t((0,s.scrollToSpreadIndex)((0,l.pageNumberToSpreadIndex)(r,e)))}}function a(e,t){return{type:f,event:e,func:t}}t.__esModule=!0,t.setCallback=t.setPageNumber=t.embedPreview=t.enableTracking=t.events=t.types=void 0;var s=n(8),u=n(19),l=n(59),c=n(11),p=n(139),d="ENABLE_TRACKING",f="SET_CALLBACK",h="EMBED_PREVIEW";t.types={ENABLE_TRACKING:d,SET_CALLBACK:f,EMBED_PREVIEW:h},t.events={ON_DOCUMENT_LOAD_EVENT:"ON_DOCUMENT_LOAD_EVENT",ON_PAGE_CHANGE_EVENT:"ON_PAGE_CHANGE_EVENT"};t.enableTracking=r,t.embedPreview=o,t.setPageNumber=i,t.setCallback=a},function(e,t){e.exports=function(e,t,n,r){if(!(e instanceof t)||void 0!==r&&r in e)throw TypeError(n+": incorrect invocation!");return e}},function(e,t){e.exports=!1},function(e,t,n){var r=n(3),o=n(237),i=n(144),a=n(156)("IE_PROTO"),s=function(){},u=function(){var e,t=n(143)("iframe"),r=i.length;for(t.style.display="none",n(146).appendChild(t),t.src="javascript:",e=t.contentWindow.document,e.open(),e.write("<script>document.F=Object</script>"),e.close(),u=e.F;r--;)delete u.prototype[i[r]];return u()};e.exports=Object.create||function(e,t){var n;return null!==e?(s.prototype=r(e),n=new s,s.prototype=null,n[a]=e):n=u(),void 0===t?n:o(n,t)}},function(e,t,n){var r=n(239),o=n(144).concat("length","prototype");t.f=Object.getOwnPropertyNames||function(e){return r(e,o)}},function(e,t,n){var r=n(239),o=n(144);e.exports=Object.keys||function(e){return r(e,o)}},function(e,t,n){var r=n(26);e.exports=function(e,t,n){for(var o in t)r(e,o,t[o],n);return e}},function(e,t,n){"use strict";var r=n(4),o=n(15),i=n(14),a=n(12)("species");e.exports=function(e){var t=r[e];i&&t&&!t[a]&&o.f(t,a,{configurable:!0,get:function(){return this}})}},function(e,t,n){var r=n(62),o=Math.max,i=Math.min;e.exports=function(e,t){return e=r(e),e<0?o(e+t,0):i(e,t)}},function(e,t){var n=0,r=Math.random();e.exports=function(e){return"Symbol(".concat(void 0===e?"":e,")_",(++n+r).toString(36))}},function(e,t,n){"use strict";var r=n(7),o=(n(1),function(e){var t=this;if(t.instancePool.length){var n=t.instancePool.pop();return t.call(n,e),n}return new t(e)}),i=function(e,t){var n=this;if(n.instancePool.length){var r=n.instancePool.pop();return n.call(r,e,t),r}return new n(e,t)},a=function(e,t,n){var r=this;if(r.instancePool.length){var o=r.instancePool.pop();return r.call(o,e,t,n),o}return new r(e,t,n)},s=function(e,t,n,r){var o=this;if(o.instancePool.length){var i=o.instancePool.pop();return o.call(i,e,t,n,r),i}return new o(e,t,n,r)},u=function(e){var t=this;e instanceof t||r("25"),e.destructor(),t.instancePool.length<t.poolSize&&t.instancePool.push(e)},l=o;e.exports={addPoolingTo:function(e,t){var n=e;return n.instancePool=[],n.getPooled=t||l,n.poolSize||(n.poolSize=10),n.release=u,n},oneArgumentPooler:o,twoArgumentPooler:i,threeArgumentPooler:a,fourArgumentPooler:s}},function(e,t,n){"use strict";function r(e,t,n){var r=e.createShader(n);if(e.shaderSource(r,t),e.compileShader(r),!e.getShaderParameter(r,e.COMPILE_STATUS)&&!e.isContextLost()){var o=n===e.FRAGMENT_SHADER?"fragment":"vertex",i=e.getShaderInfoLog(r)||"",a=(e.getSupportedExtensions()||[]).join(",");throw new Error("Cannot compile "+o+" shader: "+i+"\n["+a+"]")}return r}function o(e,t){if(e.linkProgram(t),!e.getProgramParameter(t,e.LINK_STATUS)&&!e.isContextLost()){var n=e.getProgramInfoLog(t)||"",r=(e.getSupportedExtensions()||[]).join(",");throw new Error("Cannot link shaderprogram: "+n+"\n["+r+"]")}}function i(){for(var e=/^uniform.*\b(\w+)\s*;/gm,t=/^attribute.*\b(\w+)\s*;/gm,n=arguments.length,r=Array(n),o=0;o<n;o++)r[o]=arguments[o];return r.reduce(function(n,r){for(var o=void 0;o=e.exec(r);)n.uniforms.add(o[1]);for(;o=t.exec(r);)n.attributes.add(o[1]);return n},{uniforms:new Set,attributes:new Set})}function a(e,t,n){var a=r(e,t,e.VERTEX_SHADER),u=r(e,n,e.FRAGMENT_SHADER),l=e.createProgram();e.attachShader(l,a),e.attachShader(l,u),o(e,l);for(var c=i(t,n),p={id:l,bind:function(){if(s!==p){s&&s.unbind(),s=p,e.useProgram(p.id);for(var t=c.attributes,n=Array.isArray(t),r=0,t=n?t:t[Symbol.iterator]();;){var o;if(n){if(r>=t.length)break;o=t[r++]}else{if(r=t.next(),r.done)break;o=r.value}e.enableVertexAttribArray(p[o])}}},unbind:function(){for(var t=c.attributes,n=Array.isArray(t),r=0,t=n?t:t[Symbol.iterator]();;){var o;if(n){if(r>=t.length)break;o=t[r++]}else{if(r=t.next(),r.done)break;o=r.value}e.disableVertexAttribArray(p[o])}},destroy:function(){s&&s===p&&(s.unbind(),s=null),e.detachShader(l,a),e.deleteShader(a),e.detachShader(l,u),e.deleteShader(u),e.deleteProgram(l)}},d=c.attributes,f=Array.isArray(d),h=0,d=f?d:d[Symbol.iterator]();;){var m;if(f){if(h>=d.length)break;m=d[h++]}else{if(h=d.next(),h.done)break;m=h.value}var g=m;p[g]=e.getAttribLocation(l,g)}for(var v=c.uniforms,b=Array.isArray(v),y=0,v=b?v:v[Symbol.iterator]();;){var _;if(b){if(y>=v.length)break;_=v[y++]}else{if(y=v.next(),y.done)break;_=y.value}var E=_;p[E]=e.getUniformLocation(l,E)}return p}t.__esModule=!0,t.createShader=a;var s=void 0},function(e,t,n){"use strict";function r(e){return e}t.__esModule=!0,t.MatrixTransformation=void 0;var o=n(102),i=o.vec2.create(),a=o.vec2.create();t.MatrixTransformation=function(){function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;babelHelpers.classCallCheck(this,e),this.matrix=t||o.mat2d.create()}return e.prototype.inverse=function(){var t=o.mat2d.create();return o.mat2d.invert(t,this.matrix),new e(t)},e.prototype.isIdentityMatrix=function(){return 1===this.matrix[0]&&0===this.matrix[1]&&0===this.matrix[2]&&1===this.matrix[3]&&0===this.matrix[4]&&0===this.matrix[5]},e.prototype.isEqualWith=function(e){for(var t=0;t<this.matrix.length;t++)if(this.matrix[t]!==e.matrix[t])return!1;return!0},e.prototype.multiply=function(t){var n=o.mat2d.create();return o.mat2d.multiply(n,this.matrix,t.matrix),new e(n)},e.prototype.mReset=function(){return o.mat2d.identity(this.matrix),this},e.prototype.mMultiply=function(e){return o.mat2d.multiply(this.matrix,this.matrix,e.matrix),this},e.prototype.mTranslate=function(e,t){var n=o.mat2d.create();return o.mat2d.translate(n,this.matrix,o.vec2.fromValues(e,t)),this.matrix=n,this},e.prototype.mScale=function(e){var t=o.mat2d.create();return o.mat2d.scale(t,this.matrix,o.vec2.fromValues(e,e)),this.matrix=t,this},e.prototype.mSet=function(e,t,n,r,o,i){return this.matrix[0]=e,this.matrix[1]=t,this.matrix[2]=n,this.matrix[3]=r,this.matrix[4]=o,this.matrix[5]=i,this},e.prototype.mSetMatrix=function(e){return this.matrix.set(e),this},e.prototype.transformPoint=function(e,t){var n=o.vec2.create();return o.vec2.transformMat2d(n,o.vec2.fromValues(e,t),this.matrix),Array.from(n).map(r)},e.prototype.transformRect=function(e){o.vec2.transformMat2d(i,o.vec2.set(i,e.x,e.y),this.matrix),o.vec2.transformMat2d(a,o.vec2.set(a,e.x+e.width,e.y+e.height),this.matrix);var t=Math.min(i[0],a[0]),n=Math.max(i[0],a[0]),s=Math.min(i[1],a[1]),u=Math.max(i[1],a[1]);return e.x=r(t),e.y=r(s),e.width=r(n-t),e.height=r(u-s),e},e.prototype.transformCanvasCtx=function(e){e.transform(this.matrix[0],this.matrix[1],this.matrix[2],this.matrix[3],this.matrix[4],this.matrix[5])},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.Button=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(46),u=babelHelpers.interopRequireDefault(s),l=t.Button=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e,t){return!((0,u.default)(this.props,e)&&(0,u.default)(this.state,t))},t.prototype.render=function(){var e={};return this.props.isHidden&&(e.display="none"),o.default.createElement("button",{className:this.props.className,onClick:this.props.onClick,disabled:this.props.isDisabled,id:this.props.id,dangerouslySetInnerHTML:{__html:this.props.content},style:e,type:"button"},this.props.children)},t}(r.Component);l.displayName="Button",l.propTypes={children:a.default.node,className:a.default.string,content:a.default.string,id:a.default.string,isDisabled:a.default.bool,isHidden:a.default.bool,onClick:a.default.func}},function(e,t,n){"use strict";t.__esModule=!0;t.SWIPE_LEFT="SWIPE_LEFT",t.SWIPE_RIGHT="SWIPE_RIGHT",t.SWIPE_UP="SWIPE_UP",t.SWIPE_DOWN="SWIPE_DOWN",t.SWIPE_OTHER="SWIPE_OTHER",t.ZOOM_OUT="ZOOM_OUT",t.ZOOM_IN="ZOOM_IN",t.UNDEFINED="UNDEFINED"},function(e,t,n){"use strict";t.__esModule=!0,t.InputHandler=void 0;var r=n(360),o=n(362),i=n(361),a=n(363),s=n(364),u={BROWSER:"BROWSER",READER:"READER",NONE:"NONE"};t.InputHandler=function(){function e(t,n){var l=this;babelHelpers.classCallCheck(this,e),this._interceptedBy=u.NONE,this._lastPointerEventTimeStamp=0,this._lastTouchEventTimeStamp=0,this.targetElement=t;var c=!!Object.keys(n).find(function(e){return/gesture|tap/i.test(e)});this.options={shouldInvokeSetPointerCapture:function(){return c},shouldInvokePreventDefault:function(){return l._interceptedBy===u.READER},hasBrowserIntercepted:function(){return l._interceptedBy===u.BROWSER},updateInterceptionWithTouchEvent:function(e){e.cancelable||(l._interceptedBy=u.BROWSER)},resetInterception:function(){l._interceptedBy=u.NONE,l.options.activeHandler=null},updateLastPointerEventTimeStamp:function(e){l._lastPointerEventTimeStamp=e.timeStamp},updateLastTouchEventTimeStamp:function(e){l._lastTouchEventTimeStamp=e.timeStamp},isSimulatedMouseEvents:function(e){return l._lastPointerEventTimeStamp>e.timeStamp||l._lastTouchEventTimeStamp>e.timeStamp},activeHandler:null},this._handlers=[new o.TouchHandler(t,n,this.options),new i.PointerHandler(t,n,this.options),new a.TrackpadHandler(t,n,this.options),new r.MouseHandler(t,n,this.options),new s.WheelHandler(t,n,this.options)],this.enableBrowserHandlingOfVerticalPanningGestures()}return e.prototype.destroy=function(){this._handlers.forEach(function(e){e.destroy()})},e.prototype.reset=function(){this._interceptedBy=u.NONE,this._handlers.forEach(function(e){e.reset()}),this.options.activeHandler=null},e.prototype.requestToIntercept=function(){this._interceptedBy===u.NONE&&(this._interceptedBy=u.READER)},e.prototype.enableBrowserHandlingOfVerticalPanningGestures=function(){this.targetElement.style.touchAction="pan-y"},e.prototype.disableBrowserHandlingOfAllPanningGestures=function(){this.targetElement.style.touchAction="none"},e}()},function(e,t,n){"use strict";function r(e,t){var n=e.x,r=e.x+e.width,o=t.x,i=t.x+t.width,a=e.y,s=e.y+e.height,u=t.y,l=t.y+t.height,c=Math.max(0,Math.min(r,i)-Math.max(n,o))*Math.max(0,Math.min(s,l)-Math.max(a,u));return c>0?c/(t.width*t.height):0}function o(e,t,n){return e>=n.x&&e<n.x+n.width&&t>=n.y&&t<n.y+n.height}function i(e,t){return o(e.x,e.y,t)&&o(e.x+e.width,e.y+e.height,t)}function a(e,t,n,r){return n/e<=r/t?n/e:r/t}function s(e,t,n){var r=Number.MAX_VALUE,o=void 0;return n.forEach(function(n){var i=n.x+n.width/2,a=n.y+n.height/2,s=Math.sqrt(Math.pow(i-e,2)+Math.pow(a-t,2));s<r&&(r=s,o=n)}),o}t.__esModule=!0,t.overlap=r,t.pointInRect=o,t.rectInRect=i,t.scaleToFit=a,t.closestRectToPoint=s},function(e,t,n){var r=n(12)("unscopables"),o=Array.prototype;void 0==o[r]&&n(25)(o,r,{}),e.exports=function(e){o[r][e]=!0}},function(e,t,n){var r=n(50),o=n(233),i=n(148),a=n(3),s=n(17),u=n(165),l={},c={},t=e.exports=function(e,t,n,p,d){var f,h,m,g,v=d?function(){return e}:u(e),b=r(n,p,t?2:1),y=0;if("function"!=typeof v)throw TypeError(e+" is not iterable!");if(i(v)){for(f=s(e.length);f>y;y++)if((g=t?b(a(h=e[y])[0],h[1]):b(e[y]))===l||g===c)return g}else for(m=v.call(e);!(h=m.next()).done;)if((g=o(m,b,h.value,t))===l||g===c)return g};t.BREAK=l,t.RETURN=c},function(e,t){e.exports={}},function(e,t,n){var r=n(15).f,o=n(22),i=n(12)("toStringTag");e.exports=function(e,t,n){e&&!o(e=n?e:e.prototype,i)&&r(e,i,{configurable:!0,value:t})}},function(e,t,n){var r=n(0),o=n(37),i=n(6),a=n(161),s="["+a+"]",u="​",l=RegExp("^"+s+s+"*"),c=RegExp(s+s+"*$"),p=function(e,t,n){var o={},s=i(function(){return!!a[e]()||u[e]()!=u}),l=o[e]=s?t(d):a[e];n&&(o[n]=l),r(r.P+r.F*s,"String",o)},d=p.trim=function(e,t){return e=String(o(e)),1&t&&(e=e.replace(l,"")),2&t&&(e=e.replace(c,"")),e};e.exports=p},function(e,t,n){"use strict";e.exports=n(663)},function(e,t,n){"use strict";function r(e){if(h){var t=e.node,n=e.children;if(n.length)for(var r=0;r<n.length;r++)m(t,n[r],null);else null!=e.html?p(t,e.html):null!=e.text&&f(t,e.text)}}function o(e,t){e.parentNode.replaceChild(t.node,e),r(t)}function i(e,t){h?e.children.push(t):e.node.appendChild(t.node)}function a(e,t){h?e.html=t:p(e.node,t)}function s(e,t){h?e.text=t:f(e.node,t)}function u(){return this.node.nodeName}function l(e){return{node:e,children:[],html:null,text:null,toString:u}}var c=n(172),p=n(128),d=n(180),f=n(287),h="undefined"!=typeof document&&"number"==typeof document.documentMode||"undefined"!=typeof navigator&&"string"==typeof navigator.userAgent&&/\bEdge\/\d/.test(navigator.userAgent),m=d(function(e,t,n){11===t.node.nodeType||1===t.node.nodeType&&"object"===t.node.nodeName.toLowerCase()&&(null==t.node.namespaceURI||t.node.namespaceURI===c.html)?(r(t),e.insertBefore(t.node,n)):(e.insertBefore(t.node,n),r(t))});l.insertTreeBefore=m,l.replaceChildWithTree=o,l.queueChild=i,l.queueHTML=a,l.queueText=s,e.exports=l},function(e,t,n){"use strict";function r(e,t){return(e&t)===t}var o=n(7),i=(n(1),{MUST_USE_PROPERTY:1,HAS_BOOLEAN_VALUE:4,HAS_NUMERIC_VALUE:8,HAS_POSITIVE_NUMERIC_VALUE:24,HAS_OVERLOADED_BOOLEAN_VALUE:32,injectDOMPropertyConfig:function(e){var t=i,n=e.Properties||{},a=e.DOMAttributeNamespaces||{},u=e.DOMAttributeNames||{},l=e.DOMPropertyNames||{},c=e.DOMMutationMethods||{};e.isCustomAttribute&&s._isCustomAttributeFunctions.push(e.isCustomAttribute);for(var p in n){s.properties.hasOwnProperty(p)&&o("48",p);var d=p.toLowerCase(),f=n[p],h={attributeName:d,attributeNamespace:null,propertyName:p,mutationMethod:null,mustUseProperty:r(f,t.MUST_USE_PROPERTY),hasBooleanValue:r(f,t.HAS_BOOLEAN_VALUE),hasNumericValue:r(f,t.HAS_NUMERIC_VALUE),hasPositiveNumericValue:r(f,t.HAS_POSITIVE_NUMERIC_VALUE),hasOverloadedBooleanValue:r(f,t.HAS_OVERLOADED_BOOLEAN_VALUE)};if(h.hasBooleanValue+h.hasNumericValue+h.hasOverloadedBooleanValue<=1||o("50",p),u.hasOwnProperty(p)){var m=u[p];h.attributeName=m}a.hasOwnProperty(p)&&(h.attributeNamespace=a[p]),l.hasOwnProperty(p)&&(h.propertyName=l[p]),c.hasOwnProperty(p)&&(h.mutationMethod=c[p]),s.properties[p]=h}}}),a=":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD",s={ID_ATTRIBUTE_NAME:"data-reactid",ROOT_ATTRIBUTE_NAME:"data-reactroot",ATTRIBUTE_NAME_START_CHAR:a,ATTRIBUTE_NAME_CHAR:a+"\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040",properties:{},getPossibleStandardName:null,_isCustomAttributeFunctions:[],isCustomAttribute:function(e){for(var t=0;t<s._isCustomAttributeFunctions.length;t++){if((0,s._isCustomAttributeFunctions[t])(e))return!0}return!1},injection:i};e.exports=s},function(e,t,n){"use strict";function r(){o.attachRefs(this,this._currentElement)}var o=n(686);n(39),n(5);e.exports={mountComponent:function(e,t,n,o,i,a){var s=e.mountComponent(t,n,o,i,a);return e._currentElement&&null!=e._currentElement.ref&&t.getReactMountReady().enqueue(r,e),s},getHostNode:function(e){return e.getHostNode()},unmountComponent:function(e,t){o.detachRefs(e,e._currentElement),e.unmountComponent(t)},receiveComponent:function(e,t,n,i){var a=e._currentElement;if(t!==a||i!==e._context){var s=o.shouldUpdateRefs(a,t);s&&o.detachRefs(e,a),e.receiveComponent(t,n,i),s&&e._currentElement&&null!=e._currentElement.ref&&n.getReactMountReady().enqueue(r,e)}},performUpdateIfNecessary:function(e,t,n){e._updateBatchNumber===n&&e.performUpdateIfNecessary(t)}}},function(e,t,n){"use strict";var r=n(13),o=n(724),i=n(188),a=n(729),s=n(725),u=n(726),l=n(90),c=n(728),p=n(730),d=n(733),f=(n(5),l.createElement),h=l.createFactory,m=l.cloneElement,g=r,v={Children:{map:o.map,forEach:o.forEach,count:o.count,toArray:o.toArray,only:d},Component:i,PureComponent:a,createElement:f,cloneElement:m,isValidElement:l.isValidElement,PropTypes:c,createClass:s.createClass,createFactory:h,createMixin:function(e){return e},DOM:u,version:p,__spread:g};e.exports=v},function(e,t,n){"use strict";function r(e){return void 0!==e.ref}function o(e){return void 0!==e.key}var i=n(13),a=n(56),s=(n(5),n(295),Object.prototype.hasOwnProperty),u=n(294),l={key:!0,ref:!0,__self:!0,__source:!0},c=function(e,t,n,r,o,i,a){var s={$$typeof:u,type:e,key:t,ref:n,props:a,_owner:i};return s};c.createElement=function(e,t,n){var i,u={},p=null,d=null;if(null!=t){r(t)&&(d=t.ref),o(t)&&(p=""+t.key),void 0===t.__self?null:t.__self,void 0===t.__source?null:t.__source;for(i in t)s.call(t,i)&&!l.hasOwnProperty(i)&&(u[i]=t[i])}var f=arguments.length-2;if(1===f)u.children=n;else if(f>1){for(var h=Array(f),m=0;m<f;m++)h[m]=arguments[m+2];u.children=h}if(e&&e.defaultProps){var g=e.defaultProps;for(i in g)void 0===u[i]&&(u[i]=g[i])}return c(e,p,d,0,0,a.current,u)},c.createFactory=function(e){var t=c.createElement.bind(null,e);return t.type=e,t},c.cloneAndReplaceKey=function(e,t){return c(e.type,t,e.ref,0,0,e._owner,e.props)},c.cloneElement=function(e,t,n){var u,p=i({},e.props),d=e.key,f=e.ref,h=e._owner;if(null!=t){r(t)&&(f=t.ref,h=a.current),o(t)&&(d=""+t.key);var m;e.type&&e.type.defaultProps&&(m=e.type.defaultProps);for(u in t)s.call(t,u)&&!l.hasOwnProperty(u)&&(p[u]=void 0===t[u]&&void 0!==m?m[u]:t[u])}var g=arguments.length-2;if(1===g)p.children=n;else if(g>1){for(var v=Array(g),b=0;b<g;b++)v[b]=arguments[b+2];p.children=v}return c(e.type,d,f,0,0,h,p)},c.isValidElement=function(e){return"object"==typeof e&&null!==e&&e.$$typeof===u},e.exports=c},function(e,t,n){"use strict";function r(e){for(var t=arguments.length-1,n="Minified React error #"+e+"; visit http://facebook.github.io/react/docs/error-decoder.html?invariant="+e,r=0;r<t;r++)n+="&args[]="+encodeURIComponent(arguments[r+1]);n+=" for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";var o=new Error(n);throw o.name="Invariant Violation",o.framesToPop=1,o}e.exports=r},function(e,t,n){"use strict";function r(e,t){a.default.captureMessage(e,t)}function o(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};t.extra=Object.assign({},t.extra,e.sentry_extra),a.default.captureException(e,t)}t.__esModule=!0,t.RavenConfiguration=void 0,t.captureMessage=r,t.captureException=o;var i=n(267),a=babelHelpers.interopRequireDefault(i),s=[];t.RavenConfiguration=function(){function e(){babelHelpers.classCallCheck(this,e)}return e.install=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=e.sessionId,n=void 0===t?null:t,r=e.extraContext,o=void 0===r?{}:r,i=e.tagsContext,u=void 0===i?{}:i;a.default.config("https://4ff726251e854b6187703bf21547f686@sentry.issuu.com/18",{ignoreErrors:["top.GLOBALS","originalCreateNotification","canvas.contentDocument","MyApp_RemoveAllHighlights","http://tt.epicplay.com","Can't find variable: ZiteReader","jigsaw is not defined","ComboSearch is not defined","http://loading.retry.widdit.com/","atomicFindClose","fb_xd_fragment","bmi_SafeAddOnload","EBCallBackMessageReceived","conduitPage","Javascript error: ReferenceError: Can't find variable: dataKeys on line 0","Javascript error: ReferenceError: Can't find variable: dataKeys on line 1","Javascript error: ReferenceError: Can't find variable: dataKeys on line 13","Javascript error: Script error. on line 0","Javascript error: Script error on line 0","Modernizr is not defined","$ is not a function","__gCrWeb",/^resource:\/\//i,"shopex"],collectWindowErrors:!0,maxMessageLength:1e3,maxBreadcrumbs:30,autoBreadcrumbs:{xhr:!0,console:!1,dom:!1,location:!1},environment:"production",release:"1.0.1074",tags:{embed:"fullscreen_fallback",twittercard:!1},shouldSendCallback:function(e){var t=Date.now();if(s.push(t),s.length>5){return t-s.shift()>6e4}return!0},dataCallback:function(e){return e.request.url.match(/embed.html#iargs/)&&e.extra&&e.extra.hostUrl&&"unknown"!==e.extra.hostUrl&&(e.request.url=e.extra.hostUrl+"#"+e.request.url.split("#")[1]),e}}),a.default.setUserContext({id:n}),o&&Object.keys(o).length&&a.default.setExtraContext(o),u&&Object.keys(u).length&&a.default.setTagsContext(u),a.default.install()},e}()},function(e,t,n){"use strict";function r(e,t){return function(n,r){var o=r(),i=o.fullscreen.enabled;a.isFullscreenAPISupported()?i||a.enterFullscreen(e).then(function(){n({type:l,fullscreenMethod:u.FULLSCREEN_API})}).then(a.waitForExitFullscreen).then(function(){n({type:c,fullscreenMethod:u.FULLSCREEN_API})}):(window.open(t,"_blank"),n({type:l,fullscreenMethod:u.TAB}))}}function o(){return function(e,t){t().fullscreen.enabled&&a.exitFullscreen().then(function(){e({type:c,fullscreenMethod:u.FULLSCREEN_API})})}}t.__esModule=!0,t.types=void 0,t.enterFullscreen=r,t.exitFullscreen=o;var i=n(217),a=babelHelpers.interopRequireWildcard(i),s=n(132),u=babelHelpers.interopRequireWildcard(s),l="ENTER_FULLSCREEN",c="EXIT_FULLSCREEN";t.types={ENTER_FULLSCREEN:l,EXIT_FULLSCREEN:c}},function(e,t,n){"use strict";function r(e){return(0,o.createSelector)(function(e){return e.documentModel},function(e){return e.features.disableLicenseCheck},function(t,n){return(0,i.hasLicense)(e,t,n)})}t.__esModule=!0,t.canDownloadAnonymously=t.canHideRelated=t.canSeeOwnPublication=t.canChangeLogo=t.canChangeBackgroundImage=t.canHideIssuuBranding=t.canHideShareButton=t.canChangeBackgroundColor=void 0;var o=n(33),i=n(139);t.canChangeBackgroundColor=r("customization_set_bg_color"),t.canHideShareButton=r("customization_disable_share"),t.canHideIssuuBranding=r("customization_remove_link_below"),t.canChangeBackgroundImage=r("customization_set_bg_image"),t.canChangeLogo=r("customization_set_logo"),t.canSeeOwnPublication=r("customization_show_my_other_publications"),t.canHideRelated=r("norelated"),t.canDownloadAnonymously=function(e){return(0,i.hasLicense)("download",e.documentModel,!1)}},function(e,t,n){"use strict";t.__esModule=!0;var r=function(){return Math.min(window.screen.width,window.screen.height)},o=function(){return!!window.FEATURE_TEST_IS_TOUCH||"ontouchstart"in window||window.navigator.maxTouchPoints>0||window.navigator.msMaxTouchPoints>0},i=function(){return o()&&r()<480},a=function(){return o()&&!i()&&r()<=1024},s=function(){return"callPhantom"in window},u=function(){return!!navigator.platform&&["iPad Simulator","iPhone Simulator","iPod Simulator","iPad","iPhone","iPod"].includes(navigator.platform)};t.device={isTouch:o,isMobile:i,isTablet:a,isPhantom:s,isIOS:u}},function(e,t,n){"use strict";function r(){return{type:c}}function o(){return{type:p}}function i(){return{type:d}}function a(e){return{type:f,width:e}}function s(e){return{type:h,height:e}}function u(e){var t={supportsWebGL:e,maxDrawingBufferWidth:6e3,maxDrawingBufferHeight:6e3,forceTo2D:!0};return function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:t,n=arguments[1];switch(n.type){case c:return Object.assign({},e,{supportsWebGL:!1});case p:return Object.assign({},e,{forceTo2D:!1});case d:return Object.assign({},e,{forceTo2D:!0});case f:return Object.assign({},e,{maxDrawingBufferWidth:n.width});case h:return Object.assign({},e,{maxDrawingBufferHeight:n.height});default:return e}}}t.__esModule=!0,t.selectUseWebGL=void 0,t.onWebGLError=r,t.enableWebGL=o,t.disableWebGL=i,t.setMaxDrawingBufferWidth=a,t.setMaxDrawingBufferHeight=s,t.createReducer=u;var l=n(33),c="WEBGL_ERROR",p="ENABLE_WEBGL",d="DISABLE_WEBGL",f="SET_MAX_DRAWING_BUFFER_WIDTH",h="SET_MAX_DRAWING_BUFFER_HEIGHT";t.selectUseWebGL=(0,l.createSelector)(function(e){return e.canvasContext},function(e){return e.size},function(e,t){return!(!e.supportsWebGL||e.forceTo2D)&&(e.maxDrawingBufferWidth>=t.width&&e.maxDrawingBufferHeight>=t.height)})},function(e,t,n){"use strict";function r(e,t,n,r){var o=r.specs,i=void 0===o?{}:o,a=r.action,s=void 0===a?{}:a,u=s.data,l=void 0===u?{}:u,c=i.x,p=i.y,f=i.width,h=i.height,m={};switch(m.type=s.type,m.x=c*t,m.y=p*n,m.width=f*t,m.height=h*n,m.clippingId=r.id,m.page={pageNumber:e},m.isShoppingLink="shopping_new"===r.icon,m.isVideoLink=!(m.type!==d.TYPE_OPEN_URL||!l.service||!l.videoid),m.isVideoLink&&(m.videoLink={isSafe:!l.explicit,service:l.service,videoId:l.videoid}),m.type){case d.TYPE_OPEN_URL:m.url=l.url;break;case d.TYPE_GOTO_PAGE:m.pageNumber=l.pageNumber;break;default:throw new Error("Unknown link type: "+m.type)}return Object.keys(m).forEach(function(e){if(void 0===m[e])throw new Error("Property "+e+" is not defined")}),m}function o(e,t,n){return(arguments.length>3&&void 0!==arguments[3]?arguments[3]:[]).map(function(o){return r(e,t,n,o)})}function i(e,t){return{documentId:e,pageNumber:t.pageNumber,width:t.width,height:t.height,layersInfo:t.layersInfo,imageUri:t.imageUri,links:o(t.pageNumber,t.width,t.height,arguments.length>2&&void 0!==arguments[2]?arguments[2]:[])}}function a(e){var t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return(arguments.length>1&&void 0!==arguments[1]?arguments[1]:[]).map(function(n){return i(e,n,t[n.pageNumber])}).sort(function(e,t){return e.pageNumber-t.pageNumber})}function s(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return Object.keys(e||{}).map(function(t){return{name:t,value:e[t]}})}function u(e){return{type:h,doc:e}}function l(e){return{type:m,clippings:e}}function c(){return function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{linksLoaded:!1},t=arguments[1];switch(t.type){case m:var n=t.clippings;return Object.assign({},e,{linksLoaded:!0,pages:e.pages.map(function(e){return Object.assign({},e,{links:o(e.pageNumber,e.width,e.height,n[e.pageNumber])})})});case h:var r=t.doc,i=r.revisionId+"-"+r.publicationId;return Object.assign({},e,{documentName:r.documentName.toLowerCase(),username:r.userName.toLowerCase(),userDisplayName:r.userDisplayName,publicationId:r.publicationId,revisionId:r.revisionId,pageCount:r.pageCount,title:r.title,publishDate:r.originalPublishDate,downloadable:r.downloadable,documentId:i,pages:a(i,r.pages,r.clippings),licenses:s(r.licenses)});default:return e}}}t.__esModule=!0,t.selectPageCount=t.selectSpreads=t.selectPages=void 0,t.documentLoaded=u,t.linksLoaded=l,t.createReducer=c;var p=n(33),d=n(133),f=n(58),h=Symbol("DOCUMENTLOADED"),m=Symbol("LINKSLOADED"),g=t.selectPages=(0,p.createSelector)(function(e){return e.documentModel.pages},f.selectors.selectTextInfoPageModels,f.selectors.selectResults,f.selectors.selectCurrentResult,function(e,t,n,r){return e.map(function(e){return Object.assign({},e,{textInfoPage:t.find(function(t){return t.pageNumber===e.pageNumber}),findResults:n.reduce(function(t,n){return n.pageNo===e.pageNumber&&t.push(n.result),t},[]),selectedFindResult:r&&r.pageNo===e.pageNumber?r.result:null})})});t.selectSpreads=(0,p.createSelector)(g,function(e){var t=[],n=e.length;if(n>0){t.push({pages:[e[0]]});for(var r=1;r<n-1;r+=2)t.push({pages:[e[r],e[r+1]]});n%2==0&&t.push({pages:[e[n-1]]})}return t}),t.selectPageCount=function(e){return e.documentModel.pageCount}},function(e,t,n){var r=n(36),o=n(12)("toStringTag"),i="Arguments"==r(function(){return arguments}()),a=function(e,t){try{return e[t]}catch(e){}};e.exports=function(e){var t,n,s;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(n=a(t=Object(e),o))?n:i?r(t):"Object"==(s=r(t))&&"function"==typeof t.callee?"Arguments":s}},function(e,t,n){var r=n(36);e.exports=Object("z").propertyIsEnumerable(0)?Object:function(e){return"String"==r(e)?e.split(""):Object(e)}},function(e,t){t.f={}.propertyIsEnumerable},function(e,t,n){"use strict";var r={};e.exports=r},function(e,t,n){t.glMatrix=n(53),t.mat2=n(606),t.mat2d=n(607),t.mat3=n(262),t.mat4=n(608),t.quat=n(609),t.vec2=n(610),t.vec3=n(263),t.vec4=n(264)},function(e,t,n){"use strict";function r(e){return"button"===e||"input"===e||"select"===e||"textarea"===e}function o(e,t,n){switch(e){case"onClick":case"onClickCapture":case"onDoubleClick":case"onDoubleClickCapture":case"onMouseDown":case"onMouseDownCapture":case"onMouseMove":case"onMouseMoveCapture":case"onMouseUp":case"onMouseUpCapture":return!(!n.disabled||!r(t));default:return!1}}var i=n(7),a=n(173),s=n(174),u=n(178),l=n(281),c=n(282),p=(n(1),{}),d=null,f=function(e,t){e&&(s.executeDispatchesInOrder(e,t),e.isPersistent()||e.constructor.release(e))},h=function(e){return f(e,!0)},m=function(e){return f(e,!1)},g=function(e){return"."+e._rootNodeID};e.exports={injection:{injectEventPluginOrder:a.injectEventPluginOrder,injectEventPluginsByName:a.injectEventPluginsByName},putListener:function(e,t,n){"function"!=typeof n&&i("94",t,typeof n);var r=g(e);(p[t]||(p[t]={}))[r]=n;var o=a.registrationNameModules[t];o&&o.didPutListener&&o.didPutListener(e,t,n)},getListener:function(e,t){var n=p[t];if(o(t,e._currentElement.type,e._currentElement.props))return null;var r=g(e);return n&&n[r]},deleteListener:function(e,t){var n=a.registrationNameModules[t];n&&n.willDeleteListener&&n.willDeleteListener(e,t);var r=p[t];if(r){delete r[g(e)]}},deleteAllListeners:function(e){var t=g(e);for(var n in p)if(p.hasOwnProperty(n)&&p[n][t]){var r=a.registrationNameModules[n];r&&r.willDeleteListener&&r.willDeleteListener(e,n),delete p[n][t]}},extractEvents:function(e,t,n,r){for(var o,i=a.plugins,s=0;s<i.length;s++){var u=i[s];if(u){var c=u.extractEvents(e,t,n,r);c&&(o=l(o,c))}}return o},enqueueEvents:function(e){e&&(d=l(d,e))},processEventQueue:function(e){var t=d;d=null,e?c(t,h):c(t,m),d&&i("95"),u.rethrowCaughtError()},__purge:function(){p={}},__getListenerBank:function(){return p}}},function(e,t,n){"use strict";function r(e,t,n){return v(e,t.dispatchConfig.phasedRegistrationNames[n])}function o(e,t,n){var o=r(e,n,t);o&&(n._dispatchListeners=m(n._dispatchListeners,o),n._dispatchInstances=m(n._dispatchInstances,e))}function i(e){e&&e.dispatchConfig.phasedRegistrationNames&&h.traverseTwoPhase(e._targetInst,o,e)}function a(e){if(e&&e.dispatchConfig.phasedRegistrationNames){var t=e._targetInst,n=t?h.getParentInstance(t):null;h.traverseTwoPhase(n,o,e)}}function s(e,t,n){if(n&&n.dispatchConfig.registrationName){var r=n.dispatchConfig.registrationName,o=v(e,r);o&&(n._dispatchListeners=m(n._dispatchListeners,o),n._dispatchInstances=m(n._dispatchInstances,e))}}function u(e){e&&e.dispatchConfig.registrationName&&s(e._targetInst,null,e)}function l(e){g(e,i)}function c(e){g(e,a)}function p(e,t,n,r){h.traverseEnterLeave(n,r,s,e,t)}function d(e){g(e,u)}var f=n(103),h=n(174),m=n(281),g=n(282),v=(n(5),f.getListener);e.exports={accumulateTwoPhaseDispatches:l,accumulateTwoPhaseDispatchesSkipTarget:c,accumulateDirectDispatches:d,accumulateEnterLeaveDispatches:p}},function(e,t,n){"use strict";e.exports={remove:function(e){e._reactInternalInstance=void 0},get:function(e){return e._reactInternalInstance},has:function(e){return void 0!==e._reactInternalInstance},set:function(e,t){e._reactInternalInstance=t}}},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(54),i=n(183);o.augmentClass(r,{view:function(e){if(e.view)return e.view;var t=i(e);if(t.window===t)return t;var n=t.ownerDocument;return n?n.defaultView||n.parentWindow:window},detail:function(e){return e.detail||0}}),e.exports=r},function(e,t){function n(){throw new Error("setTimeout has not been defined")}function r(){throw new Error("clearTimeout has not been defined")}function o(e){if(c===setTimeout)return setTimeout(e,0);if((c===n||!c)&&setTimeout)return c=setTimeout,setTimeout(e,0);try{return c(e,0)}catch(t){try{return c.call(null,e,0)}catch(t){return c.call(this,e,0)}}}function i(e){if(p===clearTimeout)return clearTimeout(e);if((p===r||!p)&&clearTimeout)return p=clearTimeout,clearTimeout(e);try{return p(e)}catch(t){try{return p.call(null,e)}catch(t){return p.call(this,e)}}}function a(){m&&f&&(m=!1,f.length?h=f.concat(h):g=-1,h.length&&s())}function s(){if(!m){var e=o(a);m=!0;for(var t=h.length;t;){for(f=h,h=[];++g<t;)f&&f[g].run();g=-1,t=h.length}f=null,m=!1,i(e)}}function u(e,t){this.fun=e,this.array=t}function l(){}var c,p,d=e.exports={};!function(){try{c="function"==typeof setTimeout?setTimeout:n}catch(e){c=n}try{p="function"==typeof clearTimeout?clearTimeout:r}catch(e){p=r}}();var f,h=[],m=!1,g=-1;d.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];h.push(new u(e,t)),1!==h.length||m||o(s)},u.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=l,d.addListener=l,d.once=l,d.off=l,d.removeListener=l,d.removeAllListeners=l,d.emit=l,d.prependListener=l,d.prependOnceListener=l,d.listeners=function(e){return[]},d.binding=function(e){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(e){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}},function(module,exports,__webpack_require__){"use strict";(function(global){function createCommonjsModule(e,t){return t={exports:{}},e(t,t.exports),t.exports}function asPromise(e,t){for(var n=new Array(arguments.length-1),r=0,o=2,i=!0;o<arguments.length;)n[r++]=arguments[o++];return new Promise(function(o,a){n[r]=function(e){if(i)if(i=!1,e)a(e);else{for(var t=new Array(arguments.length-1),n=0;n<t.length;)t[n++]=arguments[n];o.apply(null,t)}};try{e.apply(t||null,n)}catch(e){i&&(i=!1,a(e))}})}function EventEmitter(){this._listeners={}}function factory(e){return"undefined"!=typeof Float32Array?function(){function t(e,t,n){i[0]=e,t[n]=a[0],t[n+1]=a[1],t[n+2]=a[2],t[n+3]=a[3]}function n(e,t,n){i[0]=e,t[n]=a[3],t[n+1]=a[2],t[n+2]=a[1],t[n+3]=a[0]}function r(e,t){return a[0]=e[t],a[1]=e[t+1],a[2]=e[t+2],a[3]=e[t+3],i[0]}function o(e,t){return a[3]=e[t],a[2]=e[t+1],a[1]=e[t+2],a[0]=e[t+3],i[0]}var i=new Float32Array([-0]),a=new Uint8Array(i.buffer),s=128===a[3];e.writeFloatLE=s?t:n,e.writeFloatBE=s?n:t,e.readFloatLE=s?r:o,e.readFloatBE=s?o:r}():function(){function t(e,t,n,r){var o=t<0?1:0;if(o&&(t=-t),0===t)e(1/t>0?0:2147483648,n,r);else if(isNaN(t))e(2143289344,n,r);else if(t>3.4028234663852886e38)e((o<<31|2139095040)>>>0,n,r);else if(t<1.1754943508222875e-38)e((o<<31|Math.round(t/1.401298464324817e-45))>>>0,n,r);else{var i=Math.floor(Math.log(t)/Math.LN2),a=8388607&Math.round(t*Math.pow(2,-i)*8388608);e((o<<31|i+127<<23|a)>>>0,n,r)}}function n(e,t,n){var r=e(t,n),o=2*(r>>31)+1,i=r>>>23&255,a=8388607&r;return 255===i?a?NaN:o*(1/0):0===i?1.401298464324817e-45*o*a:o*Math.pow(2,i-150)*(a+8388608)}e.writeFloatLE=t.bind(null,writeUintLE),e.writeFloatBE=t.bind(null,writeUintBE),e.readFloatLE=n.bind(null,readUintLE),e.readFloatBE=n.bind(null,readUintBE)}(),"undefined"!=typeof Float64Array?function(){function t(e,t,n){i[0]=e,t[n]=a[0],t[n+1]=a[1],t[n+2]=a[2],t[n+3]=a[3],t[n+4]=a[4],t[n+5]=a[5],t[n+6]=a[6],t[n+7]=a[7]}function n(e,t,n){i[0]=e,t[n]=a[7],t[n+1]=a[6],t[n+2]=a[5],t[n+3]=a[4],t[n+4]=a[3],t[n+5]=a[2],t[n+6]=a[1],t[n+7]=a[0]}function r(e,t){return a[0]=e[t],a[1]=e[t+1],a[2]=e[t+2],a[3]=e[t+3],a[4]=e[t+4],a[5]=e[t+5],a[6]=e[t+6],a[7]=e[t+7],i[0]}function o(e,t){return a[7]=e[t],a[6]=e[t+1],a[5]=e[t+2],a[4]=e[t+3],a[3]=e[t+4],a[2]=e[t+5],a[1]=e[t+6],a[0]=e[t+7],i[0]}var i=new Float64Array([-0]),a=new Uint8Array(i.buffer),s=128===a[7];e.writeDoubleLE=s?t:n,e.writeDoubleBE=s?n:t,e.readDoubleLE=s?r:o,e.readDoubleBE=s?o:r}():function(){function t(e,t,n,r,o,i){var a=r<0?1:0;if(a&&(r=-r),0===r)e(0,o,i+t),e(1/r>0?0:2147483648,o,i+n);else if(isNaN(r))e(0,o,i+t),e(2146959360,o,i+n);else if(r>1.7976931348623157e308)e(0,o,i+t),e((a<<31|2146435072)>>>0,o,i+n);else{var s;if(r<2.2250738585072014e-308)s=r/5e-324,e(s>>>0,o,i+t),e((a<<31|s/4294967296)>>>0,o,i+n);else{var u=Math.floor(Math.log(r)/Math.LN2);1024===u&&(u=1023),s=r*Math.pow(2,-u),e(4503599627370496*s>>>0,o,i+t),e((a<<31|u+1023<<20|1048576*s&1048575)>>>0,o,i+n)}}}function n(e,t,n,r,o){var i=e(r,o+t),a=e(r,o+n),s=2*(a>>31)+1,u=a>>>20&2047,l=4294967296*(1048575&a)+i;return 2047===u?l?NaN:s*(1/0):0===u?5e-324*s*l:s*Math.pow(2,u-1075)*(l+4503599627370496)}e.writeDoubleLE=t.bind(null,writeUintLE,0,4),e.writeDoubleBE=t.bind(null,writeUintBE,4,0),e.readDoubleLE=n.bind(null,readUintLE,0,4),e.readDoubleBE=n.bind(null,readUintBE,4,0)}(),e}function writeUintLE(e,t,n){t[n]=255&e,t[n+1]=e>>>8&255,t[n+2]=e>>>16&255,t[n+3]=e>>>24}function writeUintBE(e,t,n){t[n]=e>>>24,t[n+1]=e>>>16&255,t[n+2]=e>>>8&255,t[n+3]=255&e}function readUintLE(e,t){return(e[t]|e[t+1]<<8|e[t+2]<<16|e[t+3]<<24)>>>0}function readUintBE(e,t){return(e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3])>>>0}function inquire(moduleName){try{var mod=eval("quire".replace(/^/,"re"))(moduleName);if(mod&&(mod.length||Object.keys(mod).length))return mod}catch(e){}return null}function pool(e,t,n){var r=n||8192,o=r>>>1,i=null,a=r;return function(n){if(n<1||n>o)return e(n);a+n>r&&(i=e(r),a=0);var s=t.call(i,a,a+=n);return 7&a&&(a=1+(7|a)),s}}function LongBits$1(e,t){this.lo=e>>>0,this.hi=t>>>0}function Op(e,t,n){this.fn=e,this.len=t,this.next=void 0,this.val=n}function noop(){}function State(e){this.head=e.head,this.tail=e.tail,this.len=e.len,this.next=e.states}function Writer(){this.len=0,this.head=new Op(noop,0,0),this.tail=this.head,this.states=null}function writeByte(e,t,n){t[n]=255&e}function writeVarint32(e,t,n){for(;e>127;)t[n++]=127&e|128,e>>>=7;t[n]=e}function VarintOp(e,t){this.len=e,this.next=void 0,this.val=t}function writeVarint64(e,t,n){for(;e.hi;)t[n++]=127&e.lo|128,e.lo=(e.lo>>>7|e.hi<<25)>>>0,e.hi>>>=7;for(;e.lo>127;)t[n++]=127&e.lo|128,e.lo=e.lo>>>7;t[n++]=e.lo}function writeFixed32(e,t,n){t[n]=255&e,t[n+1]=e>>>8&255,t[n+2]=e>>>16&255,t[n+3]=e>>>24}function BufferWriter$1(){Writer$1.call(this)}function writeStringBuffer(e,t,n){e.length<40?util$2.utf8.write(e,t,n):t.utf8Write(e,n)}function indexOutOfRange(e,t){return RangeError("index out of range: "+e.pos+" + "+(t||1)+" > "+e.len)}function Reader(e){this.buf=e,this.pos=0,this.len=e.length}function readLongVarint(){var e=new LongBits$2(0,0),t=0;if(!(this.len-this.pos>4)){for(;t<3;++t){if(this.pos>=this.len)throw indexOutOfRange(this);if(e.lo=(e.lo|(127&this.buf[this.pos])<<7*t)>>>0,this.buf[this.pos++]<128)return e}return e.lo=(e.lo|(127&this.buf[this.pos++])<<7*t)>>>0,e}for(;t<4;++t)if(e.lo=(e.lo|(127&this.buf[this.pos])<<7*t)>>>0,this.buf[this.pos++]<128)return e;if(e.lo=(e.lo|(127&this.buf[this.pos])<<28)>>>0,e.hi=(e.hi|(127&this.buf[this.pos])>>4)>>>0,this.buf[this.pos++]<128)return e;if(t=0,this.len-this.pos>4){for(;t<5;++t)if(e.hi=(e.hi|(127&this.buf[this.pos])<<7*t+3)>>>0,this.buf[this.pos++]<128)return e}else for(;t<5;++t){if(this.pos>=this.len)throw indexOutOfRange(this);if(e.hi=(e.hi|(127&this.buf[this.pos])<<7*t+3)>>>0,this.buf[this.pos++]<128)return e}throw Error("invalid varint encoding")}function readFixed32_end(e,t){return(e[t-4]|e[t-3]<<8|e[t-2]<<16|e[t-1]<<24)>>>0}function readFixed64(){if(this.pos+8>this.len)throw indexOutOfRange(this,8);return new LongBits$2(readFixed32_end(this.buf,this.pos+=4),readFixed32_end(this.buf,this.pos+=4))}function BufferReader$1(e){Reader$1.call(this,e)}function Service(e,t,n){if("function"!=typeof e)throw TypeError("rpcImpl must be a function");util$5.EventEmitter.call(this),this.rpcImpl=e,this.requestDelimited=Boolean(t),this.responseDelimited=Boolean(n)}function xhrSupportsResponseTypeArrayBuffer(){var e=new XMLHttpRequest;if("string"==typeof e.responseType)try{return"arraybuffer"===(e.responseType="arraybuffer")}catch(e){return!1}return!1}function decodeAsync(e){var t=new Uint8Array(e.length);return new Promise(function(n){function r(o){for(var i=Math.min(t.length,o+1e4),a=o;a<i;a++)t[a]=255&e.charCodeAt(a);i<t.length?setTimeout(function(){return r(i)},0):n(t)}setTimeout(function(){return r(0)},0)})}function loadBinaryFallback(e,t){return new Promise(function(n,r){var o=new XMLHttpRequest;if(o.open("GET",e,!0),o.withCredentials=!!t,!o.overrideMimeType)return r("cannot load binary files");o.overrideMimeType("text/plain; charset=x-user-defined"),o.onreadystatechange=function(){if(4===o.readyState)return 200===o.status?n(o.responseText):r()},o.send()}).then(decodeAsync)}function loadBinaryBuffer(e,t){return new Promise(function(n,r){var o=new XMLHttpRequest;o.open("GET",e,!0),o.responseType="arraybuffer",o.withCredentials=!!t,o.onload=function(){var e=o.response;return e?n(new Uint8Array(e)):r()},o.onerror=function(){return r()},o.send()})}function retry(e,t){return new Promise(function n(r,o){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1,a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:100;return e().then(function(e){return r([e,i])}).catch(function(e){i<t?setTimeout(function(){return n(r,o,i+1,5*a)},a):o([e,i])})})}function fontLoadNative(e,t,n,r){var o=new FontFace(t,n,{});e.add(o);var i=e.load("12px "+t).then(function(e){if(0===e.length)throw new Error("Native font load failed");return o}),a=null,s=new Promise(function(e,t){a=setTimeout(function(){return t(new Error("Native font load timeout"))},r)});return Promise.race([i,s]).then(function(e){return clearTimeout(a),e},function(e){return clearTimeout(a),Promise.reject(e)})}function fontLoadCompat(e,t,n,r){var o='@font-face { font-family: "'+e+'"; src: '+t+'; format("woff"); }';styleNode.appendChild(document.createTextNode(o));var i=new fontfaceobserver_standalone(e);if(n){return i.load(n.text.substring(0,8),r).catch(function(e){var t=new Error('Compat font load failed: "'+e+'"');throw t.skipTracking=!0,t})}return Promise.resolve(i)}function fontLoad(e,t,n,r){if(fonts.hasOwnProperty(e))return fonts[e];var o=document.fonts;return fonts[e]=o?fontLoadNative(o,e,t,r):fontLoadCompat(e,t,n,r)}function fetchImage(e){return new Promise(function(t,n){var r=new Image;"data"!==e.substr(0,4)&&(r.crossOrigin="Anonymous"),r.onload=function(){return t(r)},r.onerror=function(){return n(new TypeError("Could not load image"))},r.src=e})}function createImageLayer(e,t,n,r){return{page:e,width:n||t.width,height:r||t.height,layers:[{type:"image",image:0,width:n||t.width,height:r||t.height}],images:[t],fonts:[]}}function loadImageAsLayer(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},r=n.width,o=n.height,i=n.loadStatsTracker;return i&&i.onPageLoadStart(t,"image"),retry(function(){return fetchImage(e)},3).then(function(e){var n=e[0];return e[1]>1?i&&i.onPageLoadSuccessAfterRetry(t,"image"):i&&i.onPageLoadSuccess(t,"image"),createImageLayer(t,n,r,o)}).catch(function(e){return i&&i.onPageLoadFailure(t,"image"),Promise.reject(e)})}function hydrateLayers(e,t,n,r){var o=e.images.map(function(e){r&&r.onImageDecodeStart(e);var n=void 0;switch(e.type){case"embed":n="data:image/jpeg;base64,"+e.resource;break;case"file":n=t+"/"+e.resource;break;default:throw new Error("cannot process image resource with type "+e.type)}return fetchImage(n).then(function(t){return r&&r.onImageDecodeEnd(e),t})}),i=e.fonts.map(function(n,o){var i="f"+e.page+"_"+o;r&&r.onFontLoadStart(i);var a=void 0;switch(n.type){case"embed":a="url(data:application/x-font-woff;charset=utf-8;base64,"+n.resource+")";break;case"file":a="url("+t+"/"+n.resource+")";break;default:throw new Error("cannot process font resource with type "+n.type)}var s=e.layers.find(function(e){return"text"===e.type&&e.font===o&&e.text.trim().length>0});return fontLoad(i,a,s,FONT_LOAD_TIMEOUT_IN_MS).then(function(e){return r&&r.onFontLoadEnd(i),e})});return Promise.all([Promise.all(o),Promise.all(i)]).then(function(t){return{layers:e.layers,images:t[0],fonts:e.fonts.map(function(e){return{type:e.type,weight:e.weight}}),width:e.width,height:e.height,page:e.page,version:e.version,usable:e.usable}})}function base64(e){for(var t=[],n=0;n<e.length;n+=32768)t.push(String.fromCharCode.apply(null,e.subarray(n,n+32768)));return btoa(t.join(""))}function blendTypeToString(e){switch(e){case layersProto.layers.BlendType.Normal:return"source-over";case layersProto.layers.BlendType.Multiply:return"multiply";case layersProto.layers.BlendType.Screen:return"screen";case layersProto.layers.BlendType.Overlay:return"overlay";case layersProto.layers.BlendType.Darken:return"overlay";case layersProto.layers.BlendType.Lighten:return"lighten";case layersProto.layers.BlendType.Colordodge:return"color-dodge";case layersProto.layers.BlendType.Colorburn:return"color-burn";case layersProto.layers.BlendType.Hardlight:return"hard-light";case layersProto.layers.BlendType.Softlight:return"soft-light";case layersProto.layers.BlendType.Difference:return"difference";case layersProto.layers.BlendType.Exclusion:return"exclusion";case layersProto.layers.BlendType.Hue:return"hue";case layersProto.layers.BlendType.Saturation:return"saturation";case layersProto.layers.BlendType.Color:return"color";case layersProto.layers.BlendType.Luminosity:return"luminosity"}}function protoToColorArray(e){return[e>>16&255,e>>8&255,e>>0&255,(e>>24&255)/255]}function protoToLayer(e){switch(e.kind){case"image":return{type:"image",image:e.image.image,width:e.image.width,height:e.image.height};case"rect":return{type:"rect",box:e.rect.box,color:protoToColorArray(e.rect.color),blend:blendTypeToString(e.rect.blend)};case"line":return{type:"line",coords:e.line.coord,color:protoToColorArray(e.line.color),blend:blendTypeToString(e.line.blend)};case"text":return{type:"text",text:e.text.text,font:e.text.font,size:e.text.size,color:protoToColorArray(e.text.color),matrix:e.text.matrix,originx:e.text.originx,originy:e.text.originy,scale:e.text.scale}}}function loadLayersProto(e,t,n){var r=n.loadStatsTracker,o=n.withCredentials;r&&r.onPageLoadStart(t,"layers");var i=e.split("?",2)[0].split("/").slice(0,-1).join("/");return retry(function(){return loadBinary(e,!!o)},3).then(function(e){var n=e[0],o=e[1],a=layersProto.layers.Page.decode(n);return hydrateLayers({layers:a.layer.map(protoToLayer),images:a.image.map(function(e){return{type:"embed",resource:base64(e.resource)}}),fonts:a.font.map(function(e){return{type:"embed",resource:base64(e.resource)}}),width:a.width,height:a.height,page:a.page,version:a.version,usable:a.usable},i,t,r).then(function(e){return o>1?r&&r.onPageLoadSuccessAfterRetry(t,"layers"):r&&r.onPageLoadSuccess(t,"layers"),e}).catch(function(e){return r&&r.onPageLoadFailure(t,"layers"),Promise.reject(e)})})}function loadLayersJson(e,t,n){var r=n.loadStatsTracker,o=n.withCredentials;r&&r.onPageLoadStart(t,"layers");var i=e.split("?",2)[0].split("/").slice(0,-1).join("/");return retry(function(){return fetch(e,{mode:"cors",credentials:o?"include":"omit"}).then(function(e){return e.json()})},3).then(function(e){var n=e[1];return hydrateLayers(e[0],i,t,r).then(function(e){return n>1?r&&r.onPageLoadSuccessAfterRetry(t,"layers"):r&&r.onPageLoadSuccess(t,"layers"),e}).catch(function(e){return r&&r.onPageLoadFailure(t,"layers"),Promise.reject(e)})})}function loadLayers(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{loadStatsTracker:void 0,withCredentials:void 0};switch(n){case 1:return loadLayersJson(e,t,r);case 2:return loadLayersProto(e,t,r);default:return Promise.reject("Unknown version "+n)}}function accentFold(e){return e in accent_map?accent_map[e]:e}function filterAccents(e){return e.split("").map(function(e){return accentFold(e)}).join("")}function filterAccentsInData(e){return{page:e.page.map(function(e){return{height:e.height,page_number:e.page_number,width:e.width,text_block:e.text_block.map(function(e){return{char_offset:e.char_offset,height:e.height,matrix:e.matrix,text:filterAccents(e.text)}})}})}}function computeSearchRegexp(e){for(var t="",n=e.length,r=0;r<n;r++){var o=e[r];o.match(_reNonBlank)?(t+=o.replace(_reEscape,"\\$&"),t+="\n?"):t+=" "}return t=t.replace(/[ ]+/g,"\\s+"),new RegExp(t,"mig")}function loadFindData(e){return(e.match(/\.json(?:\?.*)$/)?fetch(e).then(function(e){return e.json()}):loadBinary(e).then(function(e){return textProto.text.Document.decode(e)})).then(function(e){return{pages:filterAccentsInData(e).page.map(function(e){return{pageNumber:e.page_number,textBlocks:(e.text_block||[]).map(function(e){var t=e.char_offset.reduce(function(e,t){return e.push((e[e.length-1]||0)+t),e},[]);return t.push(t[t.length-1]),{text:e.text+"\n",height:e.height,matrix:e.matrix,charOffsets:t}}),text:(e.text_block||[]).reduce(function(e,t){return e+t.text+"\n"},""),width:e.width,height:e.height}})}})}function sliceTextBlocks(e,t,n){for(var r=[],o=0;o<n.length;o++){var i=n[o].text.length;if(r.length?r.push(n[o]):e<i?r.push(n[o]):e-=i,r.length&&t<=i)return{start:e,end:t,blocks:r};t-=i}throw new Error("index out of range")}function getResultFromIndex(e,t,n){var r=sliceTextBlocks(e,e+t,n),o=r.start,i=r.end,a=r.blocks;return a.map(function(e,t){var n=0===t?o:0,r=t===a.length-1?i:e.charOffsets.length-1,s=e.charOffsets[n];return{x:s,y:0,width:e.charOffsets[r]-s,height:e.height,matrix:e.matrix}})}function find(e,t){var n=[];if(e=e.trim(),!e.length)return n;e=filterAccents(e);for(var r=computeSearchRegexp(e),o=t.pages,i=Array.isArray(o),a=0,o=i?o:o[Symbol.iterator]();;){var s;if(i){if(a>=o.length)break;s=o[a++]}else{if(a=o.next(),a.done)break;s=a.value}for(var u=s,l=r.exec(u.text);l;l=r.exec(u.text))n.push({pageNo:u.pageNumber,result:getResultFromIndex(l.index,l[0].length,u.textBlocks)})}return n}function highlight(e,t,n){e.save(),e.fillStyle="rgba(0,255,0,0.3)";for(var r=t,o=Array.isArray(r),i=0,r=o?r:r[Symbol.iterator]();;){var a;if(o){if(i>=r.length)break;a=r[i++]}else{if(i=r.next(),i.done)break;a=i.value}var s=a;e.setTransform(e.canvas.width/n.width,0,0,e.canvas.height/n.height,0,0),e.transform(s.matrix[0],s.matrix[1],s.matrix[2],s.matrix[3],s.matrix[4],s.matrix[5]),e.fillRect(s.x,s.y,s.width,s.height)}return e.restore(),t}function color(e){return"rgba("+e.join(",")+")"}function symbolsForEach(e,t){for(var n=0,r=0,o=e.length;r<o-1;++r){var i=e.charCodeAt(r);i>=55296&&i<=56319&&(i=e.charCodeAt(r+1))>=56320&&i<=57343?(t(e.slice(r,r+2),n++),++r):t(e.charAt(r),n++)}t(e.charAt(r),n++)}function renderLayers(e,t,n,r){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];r&&r.onFontRenderingStart(),e.save(),e.beginPath(),e.rect(0,0,e.canvas.width,e.canvas.height),e.closePath(),e.clip(),n.layers.forEach(function(r){var i=r;if("image"===i.type){var a=n.images[i.image];try{if(!(t[0]<2||t[3]<2)||NEVER_USE_TWOPASS||o)e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.drawImage(a,0,0,i.width,i.height);else{var s=document.createElement("canvas");s.width=2*e.canvas.width,s.height=2*e.canvas.height,s.id="reader3-twopass-canvas-"+s.width+"x"+s.height;var u=s.getContext("2d");if(!u)throw new Error("could not get canvas for twopass scaling");u.save(),u.beginPath(),u.rect(0,0,s.width,s.height),u.closePath(),u.clip(),u.setTransform(2*t[0],2*t[1],2*t[2],2*t[3],2*t[4],2*t[5]),u.drawImage(a,0,0,i.width,i.height),u.restore(),e.setTransform(1,0,0,1,0,0),e.drawImage(s,0,0,s.width,s.height,0,0,e.canvas.width,e.canvas.height),s.width=0,s.height=0}}catch(t){var l={has_image:!!a,image_width:a&&a.width,image_height:a&&a.height,dst_width:i.width,dst_height:i.height,canvas_width:e.canvas.width,canvas_height:e.canvas.height};throw t.sentry_extra=Object.assign({textRender:l},t.sentry_extra),t}}else if("text"===i.type){var c=100*Math.ceil(n.fonts[i.font].weight/100)||400;e.font=c+" "+i.size+'px "f'+n.page+"_"+i.font+'"',e.fillStyle=color(i.color),e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.transform(i.matrix[0],i.matrix[1],i.matrix[2],i.matrix[3],i.matrix[4],i.matrix[5]);var p=i.scale.some(function(e){return 1!==e});symbolsForEach(i.text,function(n,r){var o=i.originx[r],a=i.originy[r],s=i.scale[r];p&&(e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.transform(i.matrix[0]*s,i.matrix[1]*s,i.matrix[2],i.matrix[3],i.matrix[4],i.matrix[5])),e.fillText(n,o/s,a)})}else if("rect"===i.type){e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.fillStyle=color(i.color);var d=e.globalCompositeOperation;e.globalCompositeOperation=i.blend,e.fillRect(i.box[0],i.box[1],i.box[2],i.box[3]),e.globalCompositeOperation=d}else if("line"===i.type){e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.strokeStyle=color(i.color),e.lineWidth=1;var f=e.globalCompositeOperation;e.globalCompositeOperation=i.blend,e.beginPath(),e.moveTo(i.coords[0],i.coords[1]),e.lineTo(i.coords[2],i.coords[3]),e.stroke(),e.globalCompositeOperation=f}}),e.restore(),r&&r.onFontRenderingEnd()}exports.__esModule=!0;var commonjsGlobal="undefined"!=typeof window?window:void 0!==global?global:"undefined"!=typeof self?self:{},index=asPromise,index$2=createCommonjsModule(function(e,t){var n=t;n.length=function(e){var t=e.length;if(!t)return 0;for(var n=0;--t%4>1&&"="===e.charAt(t);)++n;return Math.ceil(3*e.length)/4-n};for(var r=new Array(64),o=new Array(123),i=0;i<64;)o[r[i]=i<26?i+65:i<52?i+71:i<62?i-4:i-59|43]=i++;n.encode=function(e,t,n){for(var o,i=[],a=0,s=0;t<n;){var u=e[t++];switch(s){case 0:i[a++]=r[u>>2],o=(3&u)<<4,s=1;break;case 1:i[a++]=r[o|u>>4],o=(15&u)<<2,s=2;break;case 2:i[a++]=r[o|u>>6],i[a++]=r[63&u],s=0}}return s&&(i[a++]=r[o],i[a]=61,1===s&&(i[a+1]=61)),String.fromCharCode.apply(String,i)};n.decode=function(e,t,n){for(var r,i=n,a=0,s=0;s<e.length;){var u=e.charCodeAt(s++);if(61===u&&a>1)break;if(void 0===(u=o[u]))throw Error("invalid encoding");switch(a){case 0:r=u,a=1;break;case 1:t[n++]=r<<2|(48&u)>>4,r=u,a=2;break;case 2:t[n++]=(15&r)<<4|(60&u)>>2,r=u,a=3;break;case 3:t[n++]=(3&r)<<6|u,a=0}}if(1===a)throw Error("invalid encoding");return n-i},n.test=function(e){return/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.test(e)}}),index$4=EventEmitter;EventEmitter.prototype.on=function(e,t,n){return(this._listeners[e]||(this._listeners[e]=[])).push({fn:t,ctx:n||this}),this},EventEmitter.prototype.off=function(e,t){if(void 0===e)this._listeners={};else if(void 0===t)this._listeners[e]=[];else for(var n=this._listeners[e],r=0;r<n.length;)n[r].fn===t?n.splice(r,1):++r;return this},EventEmitter.prototype.emit=function(e){var t=this._listeners[e];if(t){for(var n=[],r=1;r<arguments.length;)n.push(arguments[r++]);for(r=0;r<t.length;)t[r].fn.apply(t[r++].ctx,n)}return this};var index$6=factory(factory),index$8=inquire,index$10=createCommonjsModule(function(e,t){var n=t;n.length=function(e){for(var t=0,n=0,r=0;r<e.length;++r)n=e.charCodeAt(r),n<128?t+=1:n<2048?t+=2:55296==(64512&n)&&56320==(64512&e.charCodeAt(r+1))?(++r,t+=4):t+=3;return t},n.read=function(e,t,n){if(n-t<1)return"";for(var r,o=null,i=[],a=0;t<n;)r=e[t++],r<128?i[a++]=r:r>191&&r<224?i[a++]=(31&r)<<6|63&e[t++]:r>239&&r<365?(r=((7&r)<<18|(63&e[t++])<<12|(63&e[t++])<<6|63&e[t++])-65536,i[a++]=55296+(r>>10),i[a++]=56320+(1023&r)):i[a++]=(15&r)<<12|(63&e[t++])<<6|63&e[t++],a>8191&&((o||(o=[])).push(String.fromCharCode.apply(String,i)),a=0);return o?(a&&o.push(String.fromCharCode.apply(String,i.slice(0,a))),o.join("")):String.fromCharCode.apply(String,i.slice(0,a))},n.write=function(e,t,n){for(var r,o,i=n,a=0;a<e.length;++a)r=e.charCodeAt(a),r<128?t[n++]=r:r<2048?(t[n++]=r>>6|192,t[n++]=63&r|128):55296==(64512&r)&&56320==(64512&(o=e.charCodeAt(a+1)))?(r=65536+((1023&r)<<10)+(1023&o),++a,t[n++]=r>>18|240,t[n++]=r>>12&63|128,t[n++]=r>>6&63|128,t[n++]=63&r|128):(t[n++]=r>>12|224,t[n++]=r>>6&63|128,t[n++]=63&r|128);return n-i}}),index$12=pool,longbits=LongBits$1,util$1=minimal$2,zero=LongBits$1.zero=new LongBits$1(0,0);zero.toNumber=function(){return 0},zero.zzEncode=zero.zzDecode=function(){return this},zero.length=function(){return 1};var zeroHash=LongBits$1.zeroHash="\0\0\0\0\0\0\0\0";LongBits$1.fromNumber=function(e){if(0===e)return zero;var t=e<0;t&&(e=-e);var n=e>>>0,r=(e-n)/4294967296>>>0;return t&&(r=~r>>>0,n=~n>>>0,++n>4294967295&&(n=0,++r>4294967295&&(r=0))),new LongBits$1(n,r)},LongBits$1.from=function(e){if("number"==typeof e)return LongBits$1.fromNumber(e);if(util$1.isString(e)){if(!util$1.Long)return LongBits$1.fromNumber(parseInt(e,10));e=util$1.Long.fromString(e)}return e.low||e.high?new LongBits$1(e.low>>>0,e.high>>>0):zero},LongBits$1.prototype.toNumber=function(e){if(!e&&this.hi>>>31){var t=1+~this.lo>>>0,n=~this.hi>>>0;return t||(n=n+1>>>0),-(t+4294967296*n)}return this.lo+4294967296*this.hi},LongBits$1.prototype.toLong=function(e){return util$1.Long?new util$1.Long(0|this.lo,0|this.hi,Boolean(e)):{low:0|this.lo,high:0|this.hi,unsigned:Boolean(e)}};var charCodeAt=String.prototype.charCodeAt;LongBits$1.fromHash=function(e){return e===zeroHash?zero:new LongBits$1((charCodeAt.call(e,0)|charCodeAt.call(e,1)<<8|charCodeAt.call(e,2)<<16|charCodeAt.call(e,3)<<24)>>>0,(charCodeAt.call(e,4)|charCodeAt.call(e,5)<<8|charCodeAt.call(e,6)<<16|charCodeAt.call(e,7)<<24)>>>0)},LongBits$1.prototype.toHash=function(){return String.fromCharCode(255&this.lo,this.lo>>>8&255,this.lo>>>16&255,this.lo>>>24,255&this.hi,this.hi>>>8&255,this.hi>>>16&255,this.hi>>>24)},LongBits$1.prototype.zzEncode=function(){var e=this.hi>>31;return this.hi=((this.hi<<1|this.lo>>>31)^e)>>>0,this.lo=(this.lo<<1^e)>>>0,this},LongBits$1.prototype.zzDecode=function(){var e=-(1&this.lo);return this.lo=((this.lo>>>1|this.hi<<31)^e)>>>0,this.hi=(this.hi>>>1^e)>>>0,this},LongBits$1.prototype.length=function(){var e=this.lo,t=(this.lo>>>28|this.hi<<4)>>>0,n=this.hi>>>24;return 0===n?0===t?e<16384?e<128?1:2:e<2097152?3:4:t<16384?t<128?5:6:t<2097152?7:8:n<128?9:10};var minimal$2=createCommonjsModule(function(e,t){function n(e,t,n){for(var r=Object.keys(t),o=0;o<r.length;++o)void 0!==e[r[o]]&&n||(e[r[o]]=t[r[o]]);return e}function r(e){function t(e,r){if(!(this instanceof t))return new t(e,r);Object.defineProperty(this,"message",{get:function(){return e}}),Error.captureStackTrace?Error.captureStackTrace(this,t):Object.defineProperty(this,"stack",{value:(new Error).stack||""}),r&&n(this,r)}return(t.prototype=Object.create(Error.prototype)).constructor=t,Object.defineProperty(t.prototype,"name",{get:function(){return e}}),t.prototype.toString=function(){return this.name+": "+this.message},t}var o=t;o.asPromise=index,o.base64=index$2,o.EventEmitter=index$4,o.float=index$6,o.inquire=index$8,o.utf8=index$10,o.pool=index$12,o.LongBits=longbits,o.emptyArray=Object.freeze?Object.freeze([]):[],o.emptyObject=Object.freeze?Object.freeze({}):{},o.isNode=Boolean(commonjsGlobal.process&&commonjsGlobal.process.versions&&commonjsGlobal.process.versions.node),o.isInteger=Number.isInteger||function(e){return"number"==typeof e&&isFinite(e)&&Math.floor(e)===e},o.isString=function(e){return"string"==typeof e||e instanceof String},o.isObject=function(e){return e&&"object"===(void 0===e?"undefined":babelHelpers.typeof(e))},o.isset=o.isSet=function(e,t){var n=e[t];return!(null==n||!e.hasOwnProperty(t))&&("object"!==(void 0===n?"undefined":babelHelpers.typeof(n))||(Array.isArray(n)?n.length:Object.keys(n).length)>0)},o.Buffer=function(){try{var e=o.inquire("buffer").Buffer;return e.prototype.utf8Write?e:null}catch(e){return null}}(),o._Buffer_from=null,o._Buffer_allocUnsafe=null,o.newBuffer=function(e){return"number"==typeof e?o.Buffer?o._Buffer_allocUnsafe(e):new o.Array(e):o.Buffer?o._Buffer_from(e):"undefined"==typeof Uint8Array?e:new Uint8Array(e)},o.Array="undefined"!=typeof Uint8Array?Uint8Array:Array,o.Long=commonjsGlobal.dcodeIO&&commonjsGlobal.dcodeIO.Long||o.inquire("long"),o.key2Re=/^true|false|0|1$/,o.key32Re=/^-?(?:0|[1-9][0-9]*)$/,o.key64Re=/^(?:[\\x00-\\xff]{8}|-?(?:0|[1-9][0-9]*))$/,o.longToHash=function(e){return e?o.LongBits.from(e).toHash():o.LongBits.zeroHash},o.longFromHash=function(e,t){var n=o.LongBits.fromHash(e);return o.Long?o.Long.fromBits(n.lo,n.hi,t):n.toNumber(Boolean(t))},o.merge=n,o.lcFirst=function(e){return e.charAt(0).toLowerCase()+e.substring(1)},o.newError=r,o.ProtocolError=r("ProtocolError"),o.oneOfGetter=function(e){for(var t={},n=0;n<e.length;++n)t[e[n]]=1;return function(){for(var e=Object.keys(this),n=e.length-1;n>-1;--n)if(1===t[e[n]]&&void 0!==this[e[n]]&&null!==this[e[n]])return e[n]}},o.oneOfSetter=function(e){return function(t){for(var n=0;n<e.length;++n)e[n]!==t&&delete this[e[n]]}},o.lazyResolve=function(e,t){for(var n=0;n<t.length;++n)for(var r=Object.keys(t[n]),o=0;o<r.length;++o){for(var i=t[n][r[o]].split("."),a=e;i.length;)a=a[i.shift()];t[n][r[o]]=a}},o.toJSONOptions={longs:String,enums:String,bytes:String},o._configure=function(){var e=o.Buffer;if(!e)return void(o._Buffer_from=o._Buffer_allocUnsafe=null);o._Buffer_from=e.from!==Uint8Array.from&&e.from||function(t,n){return new e(t,n)},o._Buffer_allocUnsafe=e.allocUnsafe||function(t){return new e(t)}}}),writer=Writer,util=minimal$2,BufferWriter,LongBits=util.LongBits,base64$1=util.base64,utf8=util.utf8;Writer.create=util.Buffer?function(){return(Writer.create=function(){return new BufferWriter})()}:function(){return new Writer},Writer.alloc=function(e){return new util.Array(e)},util.Array!==Array&&(Writer.alloc=util.pool(Writer.alloc,util.Array.prototype.subarray)),Writer.prototype.push=function(e,t,n){return this.tail=this.tail.next=new Op(e,t,n),this.len+=t,this},VarintOp.prototype=Object.create(Op.prototype),VarintOp.prototype.fn=writeVarint32,Writer.prototype.uint32=function(e){return this.len+=(this.tail=this.tail.next=new VarintOp((e>>>=0)<128?1:e<16384?2:e<2097152?3:e<268435456?4:5,e)).len,this},Writer.prototype.int32=function(e){return e<0?this.push(writeVarint64,10,LongBits.fromNumber(e)):this.uint32(e)},Writer.prototype.sint32=function(e){return this.uint32((e<<1^e>>31)>>>0)},Writer.prototype.uint64=function(e){var t=LongBits.from(e);return this.push(writeVarint64,t.length(),t)},Writer.prototype.int64=Writer.prototype.uint64,Writer.prototype.sint64=function(e){var t=LongBits.from(e).zzEncode();return this.push(writeVarint64,t.length(),t)},Writer.prototype.bool=function(e){return this.push(writeByte,1,e?1:0)},Writer.prototype.fixed32=function(e){return this.push(writeFixed32,4,e>>>0)},Writer.prototype.sfixed32=Writer.prototype.fixed32,Writer.prototype.fixed64=function(e){var t=LongBits.from(e);return this.push(writeFixed32,4,t.lo).push(writeFixed32,4,t.hi)},Writer.prototype.sfixed64=Writer.prototype.fixed64,Writer.prototype.float=function(e){return this.push(util.float.writeFloatLE,4,e)},Writer.prototype.double=function(e){return this.push(util.float.writeDoubleLE,8,e)};var writeBytes=util.Array.prototype.set?function(e,t,n){t.set(e,n)}:function(e,t,n){for(var r=0;r<e.length;++r)t[n+r]=e[r]};Writer.prototype.bytes=function(e){var t=e.length>>>0;if(!t)return this.push(writeByte,1,0);if(util.isString(e)){var n=Writer.alloc(t=base64$1.length(e));base64$1.decode(e,n,0),e=n}return this.uint32(t).push(writeBytes,t,e)},Writer.prototype.string=function(e){var t=utf8.length(e);return t?this.uint32(t).push(utf8.write,t,e):this.push(writeByte,1,0)},Writer.prototype.fork=function(){return this.states=new State(this),this.head=this.tail=new Op(noop,0,0),this.len=0,this},Writer.prototype.reset=function(){return this.states?(this.head=this.states.head,this.tail=this.states.tail,this.len=this.states.len,this.states=this.states.next):(this.head=this.tail=new Op(noop,0,0),this.len=0),this},Writer.prototype.ldelim=function(){var e=this.head,t=this.tail,n=this.len;return this.reset().uint32(n),n&&(this.tail.next=e.next,this.tail=t,this.len+=n),this},Writer.prototype.finish=function(){for(var e=this.head.next,t=this.constructor.alloc(this.len),n=0;e;)e.fn(e.val,t,n),n+=e.len,e=e.next;return t},Writer._configure=function(e){BufferWriter=e};var writer_buffer=BufferWriter$1,Writer$1=writer;(BufferWriter$1.prototype=Object.create(Writer$1.prototype)).constructor=BufferWriter$1;var util$2=minimal$2,Buffer=util$2.Buffer;BufferWriter$1.alloc=function(e){return(BufferWriter$1.alloc=util$2._Buffer_allocUnsafe)(e)};var writeBytesBuffer=Buffer&&Buffer.prototype instanceof Uint8Array&&"set"===Buffer.prototype.set.name?function(e,t,n){t.set(e,n)}:function(e,t,n){if(e.copy)e.copy(t,n,0,e.length);else for(var r=0;r<e.length;)t[n++]=e[r++]};BufferWriter$1.prototype.bytes=function(e){util$2.isString(e)&&(e=util$2._Buffer_from(e,"base64"));var t=e.length>>>0;return this.uint32(t),t&&this.push(writeBytesBuffer,t,e),this},BufferWriter$1.prototype.string=function(e){var t=Buffer.byteLength(e);return this.uint32(t),t&&this.push(writeStringBuffer,t,e),this};var reader=Reader,util$3=minimal$2,BufferReader,LongBits$2=util$3.LongBits,utf8$1=util$3.utf8,create_array="undefined"!=typeof Uint8Array?function(e){if(e instanceof Uint8Array||Array.isArray(e))return new Reader(e);throw Error("illegal buffer")}:function(e){if(Array.isArray(e))return new Reader(e);throw Error("illegal buffer")};Reader.create=util$3.Buffer?function(e){return(Reader.create=function(e){return util$3.Buffer.isBuffer(e)?new BufferReader(e):create_array(e)})(e)}:create_array,Reader.prototype._slice=util$3.Array.prototype.subarray||util$3.Array.prototype.slice,Reader.prototype.uint32=function(){var e=4294967295;return function(){if(e=(127&this.buf[this.pos])>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(127&this.buf[this.pos])<<7)>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(127&this.buf[this.pos])<<14)>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(127&this.buf[this.pos])<<21)>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(15&this.buf[this.pos])<<28)>>>0,this.buf[this.pos++]<128)return e;if((this.pos+=5)>this.len)throw this.pos=this.len,indexOutOfRange(this,10);return e}}(),Reader.prototype.int32=function(){return 0|this.uint32()},Reader.prototype.sint32=function(){var e=this.uint32();return e>>>1^-(1&e)|0},Reader.prototype.bool=function(){return 0!==this.uint32()},Reader.prototype.fixed32=function(){if(this.pos+4>this.len)throw indexOutOfRange(this,4);return readFixed32_end(this.buf,this.pos+=4)},Reader.prototype.sfixed32=function(){if(this.pos+4>this.len)throw indexOutOfRange(this,4);return 0|readFixed32_end(this.buf,this.pos+=4)},Reader.prototype.float=function(){if(this.pos+4>this.len)throw indexOutOfRange(this,4);var e=util$3.float.readFloatLE(this.buf,this.pos);return this.pos+=4,e},Reader.prototype.double=function(){if(this.pos+8>this.len)throw indexOutOfRange(this,4);var e=util$3.float.readDoubleLE(this.buf,this.pos);return this.pos+=8,e},Reader.prototype.bytes=function(){var e=this.uint32(),t=this.pos,n=this.pos+e;if(n>this.len)throw indexOutOfRange(this,e);return this.pos+=e,t===n?new this.buf.constructor(0):this._slice.call(this.buf,t,n)},Reader.prototype.string=function(){var e=this.bytes();return utf8$1.read(e,0,e.length)},Reader.prototype.skip=function(e){if("number"==typeof e){if(this.pos+e>this.len)throw indexOutOfRange(this,e);this.pos+=e}else do{if(this.pos>=this.len)throw indexOutOfRange(this)}while(128&this.buf[this.pos++]);return this},Reader.prototype.skipType=function(e){switch(e){case 0:this.skip();break;case 1:this.skip(8);break;case 2:this.skip(this.uint32());break;case 3:for(;;){if(4==(e=7&this.uint32()))break;this.skipType(e)}break;case 5:this.skip(4);break;default:throw Error("invalid wire type "+e+" at offset "+this.pos)}return this},Reader._configure=function(e){BufferReader=e;var t=util$3.Long?"toLong":"toNumber";util$3.merge(Reader.prototype,{int64:function(){return readLongVarint.call(this)[t](!1)},uint64:function(){return readLongVarint.call(this)[t](!0)},sint64:function(){return readLongVarint.call(this).zzDecode()[t](!1)},fixed64:function(){return readFixed64.call(this)[t](!0)},sfixed64:function(){return readFixed64.call(this)[t](!1)}})};var reader_buffer=BufferReader$1,Reader$1=reader;(BufferReader$1.prototype=Object.create(Reader$1.prototype)).constructor=BufferReader$1;var util$4=minimal$2;util$4.Buffer&&(BufferReader$1.prototype._slice=util$4.Buffer.prototype.slice),BufferReader$1.prototype.string=function(){var e=this.uint32();return this.buf.utf8Slice(this.pos,this.pos=Math.min(this.pos+e,this.len))};var service=Service,util$5=minimal$2;(Service.prototype=Object.create(util$5.EventEmitter.prototype)).constructor=Service,Service.prototype.rpcCall=function e(t,n,r,o,i){if(!o)throw TypeError("request must be specified");var a=this;if(!i)return util$5.asPromise(e,a,t,n,r,o);if(!a.rpcImpl)return void setTimeout(function(){i(Error("already ended"))},0);try{return a.rpcImpl(t,n[a.requestDelimited?"encodeDelimited":"encode"](o).finish(),function(e,n){if(e)return a.emit("error",e,t),i(e);if(null===n)return void a.end(!0);if(!(n instanceof r))try{n=r[a.responseDelimited?"decodeDelimited":"decode"](n)}catch(e){return a.emit("error",e,t),i(e)}return a.emit("data",n,t),i(null,n)})}catch(e){return a.emit("error",e,t),void setTimeout(function(){i(e)},0)}},Service.prototype.end=function(e){return this.rpcImpl&&(e||this.rpcImpl(null,null,null),this.rpcImpl=null,this.emit("end").off()),this};var rpc_1=createCommonjsModule(function(e,t){t.Service=service}),indexMinimal=createCommonjsModule(function(e,t){function n(){r.Reader._configure(r.BufferReader),r.util._configure()}var r=t;r.build="minimal",r.roots={},r.Writer=writer,r.BufferWriter=writer_buffer,r.Reader=reader,r.BufferReader=reader_buffer,r.util=minimal$2,r.rpc=rpc_1,r.configure=n,r.Writer._configure(r.BufferWriter),n()}),minimal=indexMinimal,$protobuf=minimal,$Reader=$protobuf.Reader,$util=$protobuf.util,$root=$protobuf.roots.default||($protobuf.roots.default={});$root.layers=function(){var e={};return e.BlendType=function(){var e={},t=Object.create(e);return t[e[0]="Normal"]=0,t[e[1]="Multiply"]=1,t[e[2]="Screen"]=2,t[e[3]="Overlay"]=3,t[e[4]="Darken"]=4,t[e[5]="Lighten"]=5,t[e[6]="Colordodge"]=6,t[e[7]="Colorburn"]=7,t[e[8]="Hardlight"]=8,t[e[9]="Softlight"]=9,t[e[10]="Difference"]=10,t[e[11]="Exclusion"]=11,t[e[12]="Hue"]=12,t[e[13]="Saturation"]=13,t[e[14]="Color"]=14,t[e[15]="Luminosity"]=15,t}(),e.ImageLayer=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.image=0,e.prototype.width=0,e.prototype.height=0,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.ImageLayer;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.image=e.uint32();break;case 2:r.width=e.uint32();break;case 3:r.height=e.uint32();break;default:e.skipType(7&o)}}return r},e}(),e.TextLayer=function(){function e(e){if(this.matrix=[],this.originx=[],this.originy=[],this.scale=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.text="",e.prototype.font=0,e.prototype.size=0,e.prototype.color=0,e.prototype.matrix=$util.emptyArray,e.prototype.originx=$util.emptyArray,e.prototype.originy=$util.emptyArray,e.prototype.scale=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.TextLayer;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.text=e.string();break;case 2:r.font=e.uint32();break;case 3:r.size=e.float();break;case 4:r.color=e.uint32();break;case 5:if(r.matrix&&r.matrix.length||(r.matrix=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.matrix.push(e.float());else r.matrix.push(e.float());break;case 6:if(r.originx&&r.originx.length||(r.originx=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.originx.push(e.float());else r.originx.push(e.float());break;case 7:if(r.originy&&r.originy.length||(r.originy=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.originy.push(e.float());else r.originy.push(e.float());break;case 8:if(r.scale&&r.scale.length||(r.scale=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.scale.push(e.float());else r.scale.push(e.float());break;default:e.skipType(7&o)}}return r},e}(),e.RectLayer=function(){function e(e){if(this.box=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.color=0,e.prototype.blend=0,e.prototype.box=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.RectLayer;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.color=e.uint32();break;case 2:r.blend=e.uint32();break;case 3:if(r.box&&r.box.length||(r.box=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.box.push(e.float());else r.box.push(e.float());break;default:e.skipType(7&o)}}return r},e}(),e.LineLayer=function(){function e(e){if(this.coord=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.color=0,e.prototype.blend=0,e.prototype.coord=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.LineLayer;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.color=e.uint32();break;case 2:r.blend=e.uint32();break;case 3:if(r.coord&&r.coord.length||(r.coord=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.coord.push(e.float());else r.coord.push(e.float());break;default:e.skipType(7&o)}}return r},e}(),e.Font=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.resource=$util.newBuffer([]),e.prototype.weight=0,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Font;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.resource=e.bytes();break;case 2:r.weight=e.uint32();break;default:e.skipType(7&o)}}return r},e}(),e.Image=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.resource=$util.newBuffer([]),e.prototype.width=0,e.prototype.height=0,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Image;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.resource=e.bytes();break;case 2:r.width=e.uint32();break;case 3:r.height=e.uint32();break;default:e.skipType(7&o)}}return r},e}(),e.Layer=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}e.prototype.image=null,e.prototype.text=null,e.prototype.rect=null,e.prototype.line=null;var t;return Object.defineProperty(e.prototype,"kind",{get:$util.oneOfGetter(t=["image","text","rect","line"]),set:$util.oneOfSetter(t)}),e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Layer;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.image=$root.layers.ImageLayer.decode(e,e.uint32());break;case 2:r.text=$root.layers.TextLayer.decode(e,e.uint32());break;case 3:r.rect=$root.layers.RectLayer.decode(e,e.uint32());break;case 4:r.line=$root.layers.LineLayer.decode(e,e.uint32());break;default:e.skipType(7&o)}}return r},e}(),e.Page=function(){function e(e){if(this.layer=[],this.font=[],this.image=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.page=0,e.prototype.version=0,e.prototype.build="",e.prototype.width=0,e.prototype.height=0,e.prototype.usable=!1,e.prototype.rmse=0,e.prototype.fallback="",e.prototype.layer=$util.emptyArray,e.prototype.font=$util.emptyArray,e.prototype.image=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Page;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.page=e.uint32();break;case 2:r.version=e.uint32();break;case 3:r.build=e.string();break;case 4:r.width=e.uint32();break;case 5:r.height=e.uint32();break;case 6:r.usable=e.bool();break;case 7:r.rmse=e.float();break;case 8:r.fallback=e.string();break;case 9:r.layer&&r.layer.length||(r.layer=[]),r.layer.push($root.layers.Layer.decode(e,e.uint32()));break;case 10:r.font&&r.font.length||(r.font=[]),r.font.push($root.layers.Font.decode(e,e.uint32()));break;case 11:r.image&&r.image.length||(r.image=[]),r.image.push($root.layers.Image.decode(e,e.uint32()));break;default:e.skipType(7&o)}}return r},e}(),e}();var layersProto=$root,loadBinary=xhrSupportsResponseTypeArrayBuffer()?loadBinaryBuffer:loadBinaryFallback,fontfaceobserver_standalone=createCommonjsModule(function(e){!function(){function t(e,t){document.addEventListener?e.addEventListener("scroll",t,!1):e.attachEvent("scroll",t)}function n(e){document.body?e():document.addEventListener?document.addEventListener("DOMContentLoaded",function t(){document.removeEventListener("DOMContentLoaded",t),e()}):document.attachEvent("onreadystatechange",function t(){"interactive"!=document.readyState&&"complete"!=document.readyState||(document.detachEvent("onreadystatechange",t),e())})}function r(e){this.a=document.createElement("div"),this.a.setAttribute("aria-hidden","true"),this.a.appendChild(document.createTextNode(e)),this.b=document.createElement("span"),this.c=document.createElement("span"),this.h=document.createElement("span"),this.f=document.createElement("span"),this.g=-1,this.b.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.c.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.f.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.h.style.cssText="display:inline-block;width:200%;height:200%;font-size:16px;max-width:none;",this.b.appendChild(this.h),this.c.appendChild(this.f),this.a.appendChild(this.b),this.a.appendChild(this.c)}function o(e,t){e.a.style.cssText="max-width:none;min-width:20px;min-height:20px;display:inline-block;overflow:hidden;position:absolute;width:auto;margin:0;padding:0;top:-999px;left:-999px;white-space:nowrap;font-synthesis:none;font:"+t+";"}function i(e){var t=e.a.offsetWidth,n=t+100;return e.f.style.width=n+"px",e.c.scrollLeft=n,e.b.scrollLeft=e.b.scrollWidth+100,e.g!==t&&(e.g=t,!0)}function a(e,n){function r(){var e=o;i(e)&&e.a.parentNode&&n(e.g)}var o=e;t(e.b,r),t(e.c,r),i(e)}function s(e,t){var n=t||{};this.family=e,this.style=n.style||"normal",this.weight=n.weight||"normal",this.stretch=n.stretch||"normal"}function u(){if(null===f)if(l()&&/Apple/.test(window.navigator.vendor)){var e=/AppleWebKit\/([0-9]+)(?:\.([0-9]+))(?:\.([0-9]+))/.exec(window.navigator.userAgent);f=!!e&&603>parseInt(e[1],10)}else f=!1;return f}function l(){return null===m&&(m=!!document.fonts),m}function c(){if(null===h){var e=document.createElement("div");try{e.style.font="condensed 100px sans-serif"}catch(e){}h=""!==e.style.font}return h}function p(e,t){return[e.style,e.weight,c()?e.stretch:"","100px",t].join(" ")}var d=null,f=null,h=null,m=null;s.prototype.load=function(e,t){var i=this,s=e||"BESbswy",c=0,f=t||3e3,h=(new Date).getTime();return new Promise(function(e,t){if(l()&&!u()){var m=new Promise(function(e,t){function n(){(new Date).getTime()-h>=f?t():document.fonts.load(p(i,'"'+i.family+'"'),s).then(function(t){1<=t.length?e():setTimeout(n,25)},function(){t()})}n()}),g=new Promise(function(e,t){c=setTimeout(t,f)});Promise.race([g,m]).then(function(){clearTimeout(c),e(i)},function(){t(i)})}else n(function(){function n(){var t;(t=-1!=v&&-1!=b||-1!=v&&-1!=y||-1!=b&&-1!=y)&&((t=v!=b&&v!=y&&b!=y)||(null===d&&(t=/AppleWebKit\/([0-9]+)(?:\.([0-9]+))/.exec(window.navigator.userAgent),d=!!t&&(536>parseInt(t[1],10)||536===parseInt(t[1],10)&&11>=parseInt(t[2],10))),t=d&&(v==_&&b==_&&y==_||v==E&&b==E&&y==E||v==w&&b==w&&y==w)),t=!t),t&&(S.parentNode&&S.parentNode.removeChild(S),clearTimeout(c),e(i))}function u(){if((new Date).getTime()-h>=f)S.parentNode&&S.parentNode.removeChild(S),t(i);else{var e=document.hidden;!0!==e&&void 0!==e||(v=l.a.offsetWidth,b=m.a.offsetWidth,y=g.a.offsetWidth,n()),c=setTimeout(u,50)}}var l=new r(s),m=new r(s),g=new r(s),v=-1,b=-1,y=-1,_=-1,E=-1,w=-1,S=document.createElement("div");S.dir="ltr",o(l,p(i,"sans-serif")),o(m,p(i,"serif")),o(g,p(i,"monospace")),S.appendChild(l.a),S.appendChild(m.a),S.appendChild(g.a),document.body.appendChild(S),_=l.a.offsetWidth,E=m.a.offsetWidth,w=g.a.offsetWidth,u(),a(l,function(e){v=e,n()}),o(l,p(i,'"'+i.family+'",sans-serif')),a(m,function(e){b=e,n()}),o(m,p(i,'"'+i.family+'",serif')),a(g,function(e){y=e,n()}),o(g,p(i,'"'+i.family+'",monospace'))})})},e.exports=s}()}),FONT_LOAD_TIMEOUT_IN_MS=3e3,styleNode=document.createElement("style");styleNode.id="reader3-fonts",styleNode.type="text/css",document.head&&document.head.appendChild(styleNode);var fonts={},$protobuf$1=minimal,$Reader$1=$protobuf$1.Reader,$util$1=$protobuf$1.util,$root$1=$protobuf$1.roots.default||($protobuf$1.roots.default={});$root$1.text=function(){var e={};return e.TextBlock=function(){function e(e){if(this.matrix=[],this.char_offset=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.text="",e.prototype.height=0,e.prototype.matrix=$util$1.emptyArray,e.prototype.char_offset=$util$1.emptyArray,e.decode=function(e,t){e instanceof $Reader$1||(e=$Reader$1.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root$1.text.TextBlock;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.text=e.string();break;case 2:r.height=e.float();break;case 3:if(r.matrix&&r.matrix.length||(r.matrix=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.matrix.push(e.float());else r.matrix.push(e.float());break;case 4:if(r.char_offset&&r.char_offset.length||(r.char_offset=[]),2==(7&o))for(var i=e.uint32()+e.pos;e.pos<i;)r.char_offset.push(e.int32());else r.char_offset.push(e.int32());break;default:e.skipType(7&o)}}return r},e}(),e.Page=function(){function e(e){if(this.text_block=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.page_number=0,e.prototype.width=0,e.prototype.height=0,e.prototype.text_block=$util$1.emptyArray,e.decode=function(e,t){e instanceof $Reader$1||(e=$Reader$1.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root$1.text.Page;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.page_number=e.uint32();break;case 2:r.width=e.uint32();break;case 3:r.height=e.uint32();break;case 4:r.text_block&&r.text_block.length||(r.text_block=[]),r.text_block.push($root$1.text.TextBlock.decode(e,e.uint32()));break;default:e.skipType(7&o)}}return r},e}(),e.Document=function(){function e(e){if(this.page=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.page=$util$1.emptyArray,e.decode=function(e,t){e instanceof $Reader$1||(e=$Reader$1.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root$1.text.Document;e.pos<n;){var o=e.uint32();switch(o>>>3){case 1:r.page&&r.page.length||(r.page=[]),r.page.push($root$1.text.Page.decode(e,e.uint32()));break;default:e.skipType(7&o)}}return r},e}(),e}();var textProto=$root$1,accent_map={"ẚ":"a","Á":"a","á":"a","À":"a","à":"a","Ă":"a","ă":"a","Ắ":"a","ắ":"a","Ằ":"a","ằ":"a","Ẵ":"a","ẵ":"a","Ẳ":"a","ẳ":"a","Â":"a","â":"a","Ấ":"a","ấ":"a","Ầ":"a","ầ":"a","Ẫ":"a","ẫ":"a","Ẩ":"a","ẩ":"a","Ǎ":"a","ǎ":"a","Å":"a","å":"a","Ǻ":"a","ǻ":"a","Ä":"a","ä":"a","Ǟ":"a","ǟ":"a","Ã":"a","ã":"a","Ȧ":"a","ȧ":"a","Ǡ":"a","ǡ":"a","Ą":"a","ą":"a","Ā":"a","ā":"a","Ả":"a","ả":"a","Ȁ":"a","ȁ":"a","Ȃ":"a","ȃ":"a","Ạ":"a","ạ":"a","Ặ":"a","ặ":"a","Ậ":"a","ậ":"a","Ḁ":"a","ḁ":"a","Ⱥ":"a","ⱥ":"a","Ǽ":"a","ǽ":"a","Ǣ":"a","ǣ":"a","Ḃ":"b","ḃ":"b","Ḅ":"b","ḅ":"b","Ḇ":"b","ḇ":"b","Ƀ":"b","ƀ":"b","ᵬ":"b","Ɓ":"b","ɓ":"b","Ƃ":"b","ƃ":"b","Ć":"c","ć":"c","Ĉ":"c","ĉ":"c","Č":"c","č":"c","Ċ":"c","ċ":"c","Ç":"c","ç":"c","Ḉ":"c","ḉ":"c","Ȼ":"c","ȼ":"c","Ƈ":"c","ƈ":"c","ɕ":"c","Ď":"d","ď":"d","Ḋ":"d","ḋ":"d","Ḑ":"d","ḑ":"d","Ḍ":"d","ḍ":"d","Ḓ":"d","ḓ":"d","Ḏ":"d","ḏ":"d","Đ":"d","đ":"d","ᵭ":"d","Ɖ":"d","ɖ":"d","Ɗ":"d","ɗ":"d","Ƌ":"d","ƌ":"d","ȡ":"d","ð":"d","É":"e","Ə":"e","Ǝ":"e","ǝ":"e","é":"e","È":"e","è":"e","Ĕ":"e","ĕ":"e","Ê":"e","ê":"e","Ế":"e","ế":"e","Ề":"e","ề":"e","Ễ":"e","ễ":"e","Ể":"e","ể":"e","Ě":"e","ě":"e","Ë":"e","ë":"e","Ẽ":"e","ẽ":"e","Ė":"e","ė":"e","Ȩ":"e","ȩ":"e","Ḝ":"e","ḝ":"e","Ę":"e","ę":"e","Ē":"e","ē":"e","Ḗ":"e","ḗ":"e","Ḕ":"e","ḕ":"e","Ẻ":"e","ẻ":"e","Ȅ":"e","ȅ":"e","Ȇ":"e","ȇ":"e","Ẹ":"e","ẹ":"e","Ệ":"e","ệ":"e","Ḙ":"e","ḙ":"e","Ḛ":"e","ḛ":"e","Ɇ":"e","ɇ":"e","ɚ":"e","ɝ":"e","Ḟ":"f","ḟ":"f","ᵮ":"f","Ƒ":"f","ƒ":"f","Ǵ":"g","ǵ":"g","Ğ":"g","ğ":"g","Ĝ":"g","ĝ":"g","Ǧ":"g","ǧ":"g","Ġ":"g","ġ":"g","Ģ":"g","ģ":"g","Ḡ":"g","ḡ":"g","Ǥ":"g","ǥ":"g","Ɠ":"g","ɠ":"g","Ĥ":"h","ĥ":"h","Ȟ":"h","ȟ":"h","Ḧ":"h","ḧ":"h","Ḣ":"h","ḣ":"h","Ḩ":"h","ḩ":"h","Ḥ":"h","ḥ":"h","Ḫ":"h","ḫ":"h",H:"h","ẖ":"h","Ħ":"h","ħ":"h","Ⱨ":"h","ⱨ":"h","Í":"i","í":"i","Ì":"i","ì":"i","Ĭ":"i","ĭ":"i","Î":"i","î":"i","Ǐ":"i","ǐ":"i","Ï":"i","ï":"i","Ḯ":"i","ḯ":"i","Ĩ":"i","ĩ":"i","İ":"i",i:"i","Į":"i","į":"i","Ī":"i","ī":"i","Ỉ":"i","ỉ":"i","Ȉ":"i","ȉ":"i","Ȋ":"i","ȋ":"i","Ị":"i","ị":"i","Ḭ":"i","ḭ":"i",I:"i","ı":"i","Ɨ":"i","ɨ":"i","Ĵ":"j","ĵ":"j",J:"j","ǰ":"j","ȷ":"j","Ɉ":"j","ɉ":"j","ʝ":"j","ɟ":"j","ʄ":"j","Ḱ":"k","ḱ":"k","Ǩ":"k","ǩ":"k","Ķ":"k","ķ":"k","Ḳ":"k","ḳ":"k","Ḵ":"k","ḵ":"k","Ƙ":"k","ƙ":"k","Ⱪ":"k","ⱪ":"k","Ĺ":"a","ĺ":"l","Ľ":"l","ľ":"l","Ļ":"l","ļ":"l","Ḷ":"l","ḷ":"l","Ḹ":"l","ḹ":"l","Ḽ":"l","ḽ":"l","Ḻ":"l","ḻ":"l","Ł":"l","ł":"l","Ŀ":"l","ŀ":"l","Ƚ":"l","ƚ":"l","Ⱡ":"l","ⱡ":"l","Ɫ":"l","ɫ":"l","ɬ":"l","ɭ":"l","ȴ":"l","Ḿ":"m","ḿ":"m","Ṁ":"m","ṁ":"m","Ṃ":"m","ṃ":"m","ɱ":"m","Ń":"n","ń":"n","Ǹ":"n","ǹ":"n","Ň":"n","ň":"n","Ñ":"n","ñ":"n","Ṅ":"n","ṅ":"n","Ņ":"n","ņ":"n","Ṇ":"n","ṇ":"n","Ṋ":"n","ṋ":"n","Ṉ":"n","ṉ":"n","Ɲ":"n","ɲ":"n","Ƞ":"n","ƞ":"n","ɳ":"n","ȵ":"n",N:"n",n:"n","Ó":"o","ó":"o","Ò":"o","ò":"o","Ŏ":"o","ŏ":"o","Ô":"o","ô":"o","Ố":"o","ố":"o","Ồ":"o","ồ":"o","Ỗ":"o","ỗ":"o","Ổ":"o","ổ":"o","Ǒ":"o","ǒ":"o","Ö":"o","ö":"o","Ȫ":"o","ȫ":"o","Ő":"o","ő":"o","Õ":"o","õ":"o","Ṍ":"o","ṍ":"o","Ṏ":"o","ṏ":"o","Ȭ":"o","ȭ":"o","Ȯ":"o","ȯ":"o","Ȱ":"o","ȱ":"o","Ø":"o","ø":"o","Ǿ":"o","ǿ":"o","Ǫ":"o","ǫ":"o","Ǭ":"o","ǭ":"o","Ō":"o","ō":"o","Ṓ":"o","ṓ":"o","Ṑ":"o","ṑ":"o","Ỏ":"o","ỏ":"o","Ȍ":"o","ȍ":"o","Ȏ":"o","ȏ":"o","Ơ":"o","ơ":"o","Ớ":"o","ớ":"o","Ờ":"o","ờ":"o","Ỡ":"o","ỡ":"o","Ở":"o","ở":"o","Ợ":"o","ợ":"o","Ọ":"o","ọ":"o","Ộ":"o","ộ":"o","Ɵ":"o","ɵ":"o","Ṕ":"p","ṕ":"p","Ṗ":"p","ṗ":"p","Ᵽ":"p","Ƥ":"p","ƥ":"p",p:"p","ʠ":"q","Ɋ":"q","ɋ":"q","Ŕ":"r","ŕ":"r","Ř":"r","ř":"r","Ṙ":"r","ṙ":"r","Ŗ":"r","ŗ":"r","Ȑ":"r","ȑ":"r","Ȓ":"r","ȓ":"r","Ṛ":"r","ṛ":"r","Ṝ":"r","ṝ":"r","Ṟ":"r","ṟ":"r","Ɍ":"r","ɍ":"r","ᵲ":"r","ɼ":"r","Ɽ":"r","ɽ":"r","ɾ":"r","ᵳ":"r","ß":"s","Ś":"s","ś":"s","Ṥ":"s","ṥ":"s","Ŝ":"s","ŝ":"s","Š":"s","š":"s","Ṧ":"s","ṧ":"s","Ṡ":"s","ṡ":"s","ẛ":"s","Ş":"s","ş":"s","Ṣ":"s","ṣ":"s","Ṩ":"s","ṩ":"s","Ș":"s","ș":"s","ʂ":"s",S:"s",s:"s","Þ":"t","þ":"t","Ť":"t","ť":"t",T:"t","ẗ":"t","Ṫ":"t","ṫ":"t","Ţ":"t","ţ":"t","Ṭ":"t","ṭ":"t","Ț":"t","ț":"t","Ṱ":"t","ṱ":"t","Ṯ":"t","ṯ":"t","Ŧ":"t","ŧ":"t","Ⱦ":"t","ⱦ":"t","ᵵ":"t","ƫ":"t","Ƭ":"t","ƭ":"t","Ʈ":"t","ʈ":"t","ȶ":"t","Ú":"u","ú":"u","Ù":"u","ù":"u","Ŭ":"u","ŭ":"u","Û":"u","û":"u","Ǔ":"u","ǔ":"u","Ů":"u","ů":"u","Ü":"u","ü":"u","Ǘ":"u","ǘ":"u","Ǜ":"u","ǜ":"u","Ǚ":"u","ǚ":"u","Ǖ":"u","ǖ":"u","Ű":"u","ű":"u","Ũ":"u","ũ":"u","Ṹ":"u","ṹ":"u","Ų":"u","ų":"u","Ū":"u","ū":"u","Ṻ":"u","ṻ":"u","Ủ":"u","ủ":"u","Ȕ":"u","ȕ":"u","Ȗ":"u","ȗ":"u","Ư":"u","ư":"u","Ứ":"u","ứ":"u","Ừ":"u","ừ":"u","Ữ":"u","ữ":"u","Ử":"u","ử":"u","Ự":"u","ự":"u","Ụ":"u","ụ":"u","Ṳ":"u","ṳ":"u","Ṷ":"u","ṷ":"u","Ṵ":"u","ṵ":"u","Ʉ":"u","ʉ":"u","Ṽ":"v","ṽ":"v","Ṿ":"v","ṿ":"v","Ʋ":"v","ʋ":"v","Ẃ":"w","ẃ":"w","Ẁ":"w","ẁ":"w","Ŵ":"w","ŵ":"w",W:"w","ẘ":"w","Ẅ":"w","ẅ":"w","Ẇ":"w","ẇ":"w","Ẉ":"w","ẉ":"w","Ẍ":"x","ẍ":"x","Ẋ":"x","ẋ":"x","Ý":"y","ý":"y","Ỳ":"y","ỳ":"y","Ŷ":"y","ŷ":"y",Y:"y","ẙ":"y","Ÿ":"y","ÿ":"y","Ỹ":"y","ỹ":"y","Ẏ":"y","ẏ":"y","Ȳ":"y","ȳ":"y","Ỷ":"y","ỷ":"y","Ỵ":"y","ỵ":"y","ʏ":"y","Ɏ":"y","ɏ":"y","Ƴ":"y","ƴ":"y","Ź":"z","ź":"z","Ẑ":"z","ẑ":"z","Ž":"z","ž":"z","Ż":"z","ż":"z","Ẓ":"z","ẓ":"z","Ẕ":"z","ẕ":"z","Ƶ":"z","ƶ":"z","Ȥ":"z","ȥ":"z","ʐ":"z","ʑ":"z","Ⱬ":"z","ⱬ":"z","Ǯ":"z","ǯ":"z","ƺ":"z","２":"2","６":"6","Ｂ":"B","Ｆ":"F","Ｊ":"J","Ｎ":"N","Ｒ":"R","Ｖ":"V","Ｚ":"Z","ｂ":"b","ｆ":"f","ｊ":"j","ｎ":"n","ｒ":"r","ｖ":"v","ｚ":"z","１":"1","５":"5","９":"9","Ａ":"A","Ｅ":"E","Ｉ":"I","Ｍ":"M","Ｑ":"Q","Ｕ":"U","Ｙ":"Y","ａ":"a","ｅ":"e","ｉ":"i","ｍ":"m","ｑ":"q","ｕ":"u","ｙ":"y","０":"0","４":"4","８":"8","Ｄ":"D","Ｈ":"H","Ｌ":"L","Ｐ":"P","Ｔ":"T","Ｘ":"X","ｄ":"d","ｈ":"h","ｌ":"l","ｐ":"p","ｔ":"t","ｘ":"x","３":"3","７":"7","Ｃ":"C","Ｇ":"G","Ｋ":"K","Ｏ":"O","Ｓ":"S","Ｗ":"W","ｃ":"c","ｇ":"g","ｋ":"k","ｏ":"o","ｓ":"s","ｗ":"w"},_reEscape=/[-\/\\^$*+?.()|[\]{}]/,_reNonBlank=/\S/,NEVER_USE_TWOPASS=/(iPad|iPhone|iPod).*(AppleWebKit\/).*(Mobile\/).*(Safari\/)/i.test(navigator.userAgent);exports.loadImageAsLayer=loadImageAsLayer,exports.loadLayers=loadLayers,exports.renderLayers=renderLayers,exports.loadFindData=loadFindData,exports.find=find,exports.highlight=highlight}).call(exports,__webpack_require__(34))},function(e,t,n){"use strict";function r(e){return e.readMorePlugin&&e.readMorePlugin.getButtonUnreadCount()||0}t.__esModule=!0,t.selectShowAsOverlay=t.selectShouldRenderExitFullscreenOverlay=t.selectShouldRenderButton=t.selectReadyToRender=void 0,t.selectButtonUnreadCount=r;var o=n(33),i=n(11),a=babelHelpers.interopRequireWildcard(i),s=n(94),u=n(211),l=babelHelpers.interopRequireWildcard(u),c=n(35),p=t.selectReadyToRender=(0,o.createSelector)(function(e){return e.readMorePlugin},function(e){return e.readmore.loaded},a.selectReaderSize,function(e,t,n){return!(!e||!t||n===l.TINY)});t.selectShouldRenderButton=(0,o.createSelector)(p,function(e){return e.readMorePlugin},a.selectShowCTAOverlay,a.selectFullscreenEnabled,s.canSeeOwnPublication,s.canHideRelated,function(e,t,n,r,o,i){return!(!e||n)&&t.shouldRenderButton(o,i,r)}),t.selectShouldRenderExitFullscreenOverlay=(0,o.createSelector)(p,function(e){return e.readMorePlugin},s.canSeeOwnPublication,s.canHideRelated,function(e,t,n,r){return e&&t.shouldRenderExitFullscreenOverlay(n,r)}),t.selectShowAsOverlay=(0,o.createSelector)(p,function(e){return e.readMorePlugin},function(e){return e.readmore.forceOverlay},function(e){return e.size.width},function(e){return e.size.height},function(e,t,n,r,o){if(e){var i=r<o,a=!i,s=(0,c.getDPR)();return n||t.shouldAlwaysBeOverlay()||i&&r<=414*s||a&&r<=736*s}return!1})},function(e,t,n){"use strict";function r(e,t){return{type:a,width:e,height:t}}function o(){var e={width:0,height:0};return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,n=arguments[1];switch(n.type){case i.DOCUMENTLOAD_SUCCESS:return Object.assign({},t,{width:n.width,height:n.height});case a:return Object.assign({},t,{width:n.width,height:n.height});default:return t}}}t.__esModule=!0,t.RESIZE=void 0,t.resize=r,t.createReducer=o;var i=n(19),a=t.RESIZE="RESIZE"},function(e,t,n){"use strict";t.__esModule=!0;t.trackingMiddlewarePrototype=function(e,t){return function(n){return function(r){return function(o){var i=n.getState(),a=r(o),s=n.getState();try{e.hasOwnProperty(o.type)&&e[o.type](i,s,o)}catch(e){t(e)}return a}}}}},function(e,t,n){var r=n(28),o=n(17),i=n(71);e.exports=function(e){return function(t,n,a){var s,u=r(t),l=o(u.length),c=i(a,l);if(e&&n!=n){for(;l>c;)if((s=u[c++])!=s)return!0}else for(;l>c;c++)if((e||c in u)&&u[c]===n)return e||c||0;return!e&&-1}}},function(e,t,n){"use strict";var r=n(4),o=n(0),i=n(26),a=n(69),s=n(60),u=n(81),l=n(64),c=n(9),p=n(6),d=n(118),f=n(83),h=n(147);e.exports=function(e,t,n,m,g,v){var b=r[e],y=b,_=g?"set":"add",E=y&&y.prototype,w={},S=function(e){var t=E[e];i(E,e,"delete"==e?function(e){return!(v&&!c(e))&&t.call(this,0===e?0:e)}:"has"==e?function(e){return!(v&&!c(e))&&t.call(this,0===e?0:e)}:"get"==e?function(e){return v&&!c(e)?void 0:t.call(this,0===e?0:e)}:"add"==e?function(e){return t.call(this,0===e?0:e),this}:function(e,n){return t.call(this,0===e?0:e,n),this})};if("function"==typeof y&&(v||E.forEach&&!p(function(){(new y).entries().next()}))){var x=new y,T=x[_](v?{}:-0,1)!=x,C=p(function(){x.has(1)}),I=d(function(e){new y(e)}),R=!v&&p(function(){for(var e=new y,t=5;t--;)e[_](t,t);return!e.has(-0)});I||(y=t(function(t,n){l(t,y,e);var r=h(new b,t,y);return void 0!=n&&u(n,g,r[_],r),r}),y.prototype=E,E.constructor=y),(C||R)&&(S("delete"),S("has"),g&&S("get")),(R||T)&&S(_),v&&E.clear&&delete E.clear}else y=m.getConstructor(t,e,g,_),a(y.prototype,n),s.NEED=!0;return f(y,e),w[e]=y,o(o.G+o.W+o.F*(y!=b),w),v||m.setStrong(y,e,g),y}},function(e,t,n){"use strict";var r=n(25),o=n(26),i=n(6),a=n(37),s=n(12);e.exports=function(e,t,n){var u=s(e),l=n(a,u,""[e]),c=l[0],p=l[1];i(function(){var t={};return t[u]=function(){return 7},7!=""[e](t)})&&(o(String.prototype,e,c),r(RegExp.prototype,u,2==t?function(e,t){return p.call(e,this,t)}:function(e){return p.call(e,this)}))}},function(e,t,n){"use strict";var r=n(3);e.exports=function(){var e=r(this),t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),e.sticky&&(t+="y"),t}},function(e,t){e.exports=function(e,t,n){var r=void 0===n;switch(t.length){case 0:return r?e():e.call(n);case 1:return r?e(t[0]):e.call(n,t[0]);case 2:return r?e(t[0],t[1]):e.call(n,t[0],t[1]);case 3:return r?e(t[0],t[1],t[2]):e.call(n,t[0],t[1],t[2]);case 4:return r?e(t[0],t[1],t[2],t[3]):e.call(n,t[0],t[1],t[2],t[3])}return e.apply(n,t)}},function(e,t,n){var r=n(9),o=n(36),i=n(12)("match");e.exports=function(e){var t;return r(e)&&(void 0!==(t=e[i])?!!t:"RegExp"==o(e))}},function(e,t,n){var r=n(12)("iterator"),o=!1;try{var i=[7][r]();i.return=function(){o=!0},Array.from(i,function(){throw 2})}catch(e){}e.exports=function(e,t){if(!t&&!o)return!1;var n=!1;try{var i=[7],a=i[r]();a.next=function(){return{done:n=!0}},i[r]=function(){return a},e(i)}catch(e){}return n}},function(e,t,n){e.exports=n(65)||!n(6)(function(){var e=Math.random();__defineSetter__.call(null,e,function(){}),delete n(4)[e]})},function(e,t){t.f=Object.getOwnPropertySymbols},function(e,t,n){var r=n(4),o=r["__core-js_shared__"]||(r["__core-js_shared__"]={});e.exports=function(e){return o[e]||(o[e]={})}},function(e,t,n){for(var r,o=n(4),i=n(25),a=n(72),s=a("typed_array"),u=a("view"),l=!(!o.ArrayBuffer||!o.DataView),c=l,p=0,d="Int8Array,Uint8Array,Uint8ClampedArray,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array".split(",");p<9;)(r=o[d[p++]])?(i(r.prototype,s,!0),i(r.prototype,u,!0)):c=!1;e.exports={ABV:l,CONSTR:c,TYPED:s,VIEW:u}},function(e,t,n){var r=n(605);e.exports=Function.prototype.bind||r},function(e,t,n){"use strict";function r(e){return Object.prototype.hasOwnProperty.call(e,m)||(e[m]=f++,p[e[m]]={}),p[e[m]]}var o,i=n(13),a=n(173),s=n(678),u=n(280),l=n(710),c=n(184),p={},d=!1,f=0,h={topAbort:"abort",topAnimationEnd:l("animationend")||"animationend",topAnimationIteration:l("animationiteration")||"animationiteration",topAnimationStart:l("animationstart")||"animationstart",topBlur:"blur",topCanPlay:"canplay",topCanPlayThrough:"canplaythrough",topChange:"change",topClick:"click",topCompositionEnd:"compositionend",topCompositionStart:"compositionstart",topCompositionUpdate:"compositionupdate",topContextMenu:"contextmenu",topCopy:"copy",topCut:"cut",topDoubleClick:"dblclick",topDrag:"drag",topDragEnd:"dragend",topDragEnter:"dragenter",topDragExit:"dragexit",topDragLeave:"dragleave",topDragOver:"dragover",topDragStart:"dragstart",topDrop:"drop",topDurationChange:"durationchange",topEmptied:"emptied",topEncrypted:"encrypted",topEnded:"ended",topError:"error",topFocus:"focus",topInput:"input",topKeyDown:"keydown",topKeyPress:"keypress",topKeyUp:"keyup",topLoadedData:"loadeddata",topLoadedMetadata:"loadedmetadata",topLoadStart:"loadstart",topMouseDown:"mousedown",topMouseMove:"mousemove",topMouseOut:"mouseout",topMouseOver:"mouseover",topMouseUp:"mouseup",topPaste:"paste",topPause:"pause",topPlay:"play",topPlaying:"playing",topProgress:"progress",topRateChange:"ratechange",topScroll:"scroll",topSeeked:"seeked",topSeeking:"seeking",topSelectionChange:"selectionchange",topStalled:"stalled",topSuspend:"suspend",topTextInput:"textInput",topTimeUpdate:"timeupdate",topTouchCancel:"touchcancel",topTouchEnd:"touchend",topTouchMove:"touchmove",topTouchStart:"touchstart",topTransitionEnd:l("transitionend")||"transitionend",topVolumeChange:"volumechange",topWaiting:"waiting",topWheel:"wheel"},m="_reactListenersID"+String(Math.random()).slice(2),g=i({},s,{ReactEventListener:null,injection:{injectReactEventListener:function(e){e.setHandleTopLevel(g.handleTopLevel),g.ReactEventListener=e}},setEnabled:function(e){g.ReactEventListener&&g.ReactEventListener.setEnabled(e)},isEnabled:function(){return!(!g.ReactEventListener||!g.ReactEventListener.isEnabled())},listenTo:function(e,t){for(var n=t,o=r(n),i=a.registrationNameDependencies[e],s=0;s<i.length;s++){var u=i[s];o.hasOwnProperty(u)&&o[u]||("topWheel"===u?c("wheel")?g.ReactEventListener.trapBubbledEvent("topWheel","wheel",n):c("mousewheel")?g.ReactEventListener.trapBubbledEvent("topWheel","mousewheel",n):g.ReactEventListener.trapBubbledEvent("topWheel","DOMMouseScroll",n):"topScroll"===u?c("scroll",!0)?g.ReactEventListener.trapCapturedEvent("topScroll","scroll",n):g.ReactEventListener.trapBubbledEvent("topScroll","scroll",g.ReactEventListener.WINDOW_HANDLE):"topFocus"===u||"topBlur"===u?(c("focus",!0)?(g.ReactEventListener.trapCapturedEvent("topFocus","focus",n),g.ReactEventListener.trapCapturedEvent("topBlur","blur",n)):c("focusin")&&(g.ReactEventListener.trapBubbledEvent("topFocus","focusin",n),g.ReactEventListener.trapBubbledEvent("topBlur","focusout",n)),o.topBlur=!0,o.topFocus=!0):h.hasOwnProperty(u)&&g.ReactEventListener.trapBubbledEvent(u,h[u],n),o[u]=!0)}},trapBubbledEvent:function(e,t,n){return g.ReactEventListener.trapBubbledEvent(e,t,n)},trapCapturedEvent:function(e,t,n){return g.ReactEventListener.trapCapturedEvent(e,t,n)},supportsEventPageXY:function(){if(!document.createEvent)return!1;var e=document.createEvent("MouseEvent");return null!=e&&"pageX"in e},ensureScrollValueMonitoring:function(){if(void 0===o&&(o=g.supportsEventPageXY()),!o&&!d){g.ReactEventListener.monitorScrollValue(u.refreshScrollValues),d=!0}}});e.exports=g},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(106),i=n(280),a=n(182);o.augmentClass(r,{screenX:null,screenY:null,clientX:null,clientY:null,ctrlKey:null,shiftKey:null,altKey:null,metaKey:null,getModifierState:a,button:function(e){var t=e.button;return"which"in e?t:2===t?2:4===t?1:0},buttons:null,relatedTarget:function(e){return e.relatedTarget||(e.fromElement===e.srcElement?e.toElement:e.fromElement)},pageX:function(e){return"pageX"in e?e.pageX:e.clientX+i.currentScrollLeft},pageY:function(e){return"pageY"in e?e.pageY:e.clientY+i.currentScrollTop}}),e.exports=r},function(e,t,n){"use strict";var r=n(7),o=(n(1),{});e.exports={reinitializeTransaction:function(){this.transactionWrappers=this.getTransactionWrappers(),this.wrapperInitData?this.wrapperInitData.length=0:this.wrapperInitData=[],this._isInTransaction=!1},_isInTransaction:!1,getTransactionWrappers:null,isInTransaction:function(){return!!this._isInTransaction},perform:function(e,t,n,o,i,a,s,u){this.isInTransaction()&&r("27");var l,c;try{this._isInTransaction=!0,l=!0,this.initializeAll(0),c=e.call(t,n,o,i,a,s,u),l=!1}finally{try{if(l)try{this.closeAll(0)}catch(e){}else this.closeAll(0)}finally{this._isInTransaction=!1}}return c},initializeAll:function(e){for(var t=this.transactionWrappers,n=e;n<t.length;n++){var r=t[n];try{this.wrapperInitData[n]=o,this.wrapperInitData[n]=r.initialize?r.initialize.call(this):null}finally{if(this.wrapperInitData[n]===o)try{this.initializeAll(n+1)}catch(e){}}}},closeAll:function(e){this.isInTransaction()||r("28");for(var t=this.transactionWrappers,n=e;n<t.length;n++){var i,a=t[n],s=this.wrapperInitData[n];try{i=!0,s!==o&&a.close&&a.close.call(this,s),i=!1}finally{if(i)try{this.closeAll(n+1)}catch(e){}}}this.wrapperInitData.length=0}}},function(e,t,n){"use strict";function r(e){var t=""+e,n=i.exec(t);if(!n)return t;var r,o="",a=0,s=0;for(a=n.index;a<t.length;a++){switch(t.charCodeAt(a)){case 34:r="&quot;";break;case 38:r="&amp;";break;case 39:r="&#x27;";break;case 60:r="&lt;";break;case 62:r="&gt;";break;default:continue}s!==a&&(o+=t.substring(s,a)),s=a+1,o+=r}return s!==a?o+t.substring(s,a):o}function o(e){return"boolean"==typeof e||"number"==typeof e?""+e:r(e)}var i=/["'&<>]/;e.exports=o},function(e,t,n){"use strict";var r,o=n(23),i=n(172),a=/^[ \r\n\t\f]/,s=/<(!--|link|noscript|meta|script|style)[ \r\n\t\f\/>]/,u=n(180),l=u(function(e,t){if(e.namespaceURI!==i.svg||"innerHTML"in e)e.innerHTML=t;else{r=r||document.createElement("div"),r.innerHTML="<svg>"+t+"</svg>";for(var n=r.firstChild;n.firstChild;)e.appendChild(n.firstChild)}});if(o.canUseDOM){var c=document.createElement("div");c.innerHTML=" ",""===c.innerHTML&&(l=function(e,t){if(e.parentNode&&e.parentNode.replaceChild(e,e),a.test(t)||"<"===t[0]&&s.test(t)){e.innerHTML=String.fromCharCode(65279)+t;var n=e.firstChild;1===n.data.length?e.removeChild(n):n.deleteData(0,1)}else e.innerHTML=t}),c=null}e.exports=l},function(e,t,n){"use strict";function r(e,t){e({type:t}),window.setTimeout(function(){e({type:i})},2e3)}function o(){return function(e,t){e({type:a});var n=t().config.getScheme(),o=t().config.hosts.api,i=t().documentModel.documentId,l=""+n+o+"/query?action=issuu.document.download_external&documentId="+i+"&format=json";fetch(l).then(function(e){return e.json()}).then(function(t){window.open(t.rsp._content.redirect.url,"_top"),r(e,s)}).catch(function(){r(e,u)})}}t.__esModule=!0;var i="DOWNLOAD_READY",a="DOWNLOAD_LOADING",s="DOWNLOAD_SUCCESS",u="DOWNLOAD_FAILURE";t.types={DOWNLOAD_READY:i,DOWNLOAD_LOADING:a,DOWNLOAD_SUCCESS:s,DOWNLOAD_FAILURE:u};t.downloadAnonymously=o},function(e,t,n){"use strict";function r(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*n+e}function o(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*(1-Math.pow(2,-10*n))+e}function i(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*Math.pow(2,10*(n-1))+e}function a(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*n*n+e}function s(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*n*(2-n)+e}function u(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*Math.pow(n,4)+e}function l(e,t,n){return n=Math.max(Math.min(n,1),0),n<.5?(t-e)/2*Math.pow(2*n,4)+e:-(t-e)/2*(Math.pow(2*n-2,4)-2)+e}function c(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*Math.pow(n,100)+e}t.__esModule=!0,t.linear=r,t.easeOutExpo=o,t.easeInExpo=i,t.easeInQuad=a,t.easeOutQuad=s,t.easeInQuart=u,t.easeInOutQuart=l,t.easeInHighOrder=c},function(e,t,n){"use strict";t.__esModule=!0,t.Spinner=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(46),a=babelHelpers.interopRequireDefault(i),s=n(205),u=t.Spinner=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e){return!(0,a.default)(this.props,e)},t.prototype.render=function(){var e=this.props.size*this.props.zoomLevel,n={width:e,height:e},r=["spinner"];return this.props.type===t.SPINNER_TYPE_ALTERNATE&&r.push("spinner--alternate"),o.default.createElement("div",{className:r.join(" "),style:n,dangerouslySetInnerHTML:{__html:s.SpinnerIcon}})},t}(r.Component);u.displayName="Spinner",u.SPINNER_SIZE_DEFAULT=24,u.SPINNER_SIZE_TINY=14,u.SPINNER_SIZE_SMALL=19,u.SPINNER_TYPE_DEFAULT="SPINNER_TYPE_DEFAULT",u.SPINNER_TYPE_ALTERNATE="SPINNER_TYPE_ALTERNATE",u.defaultProps={type:u.SPINNER_TYPE_DEFAULT,size:u.SPINNER_SIZE_DEFAULT,zoomLevel:1}},function(e,t,n){"use strict";t.__esModule=!0;t.FULLSCREEN_API="FULLSCREEN@FULLSCREEN_API",t.TAB="FULLSCREEN@TAB"},function(e,t,n){"use strict";t.__esModule=!0;t.TYPE_OPEN_URL="openUrl",t.TYPE_GOTO_PAGE="gotoPage"},function(e,t,n){"use strict";t.__esModule=!0,t.BaseInputHandler=void 0;var r=n(359),o=n(77),i=babelHelpers.interopRequireWildcard(o);t.BaseInputHandler=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this.initialGesture=i.UNDEFINED,this.pointers={},this._lastGestureMoveTimestamp=0,this._initialPinchDistance=NaN,this._targetElementOffset=null,this.targetElement=t,this.callbacks=n,this.options=r}return e.prototype.destroy=function(){},e.prototype.reset=function(){this.pointers={},this._lastGestureMoveTimestamp=0,this._initialPinchDistance=NaN,this.initialGesture=i.UNDEFINED,this._targetElementOffset=null},e.prototype.isDeactivated=function(){return this.options.activeHandler&&this.options.activeHandler!==this},e.prototype._isAnyButtonPressed=function(e){return!(!e.buttons&&!this.getPointerCount())},e.prototype._isGeneratedByMouseDevice=function(e){return!e.pointerType||"mouse"===e.pointerType},e.prototype.getScalingFactor=function(){return this.callbacks.getScalingFactor?this.callbacks.getScalingFactor():1},e.prototype.fireGestureStart=function(){var e=this.callbacks.onGestureStart;e&&e(this._getTouches(),this._getLastEventTimestamp())},e.prototype.fireGestureChange=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:NaN,t=this._getLastEventTimestamp();if(t-this._lastGestureMoveTimestamp>10){var n=isNaN(e)?this._getCurrentPinchDistance()/this._initialPinchDistance:e;if(!isNaN(n)){var r=this.callbacks.onGestureChange;r&&r(this._getTouches(),t,n,this.initialGesture),this._lastGestureMoveTimestamp=t}}},e.prototype.fireGestureEnd=function(){var e=this.callbacks.onGestureEnd;e&&e(this._getLastEventTimestamp())},e.prototype.fireMouseMove=function(e){if(this._isGeneratedByMouseDevice(e)&&!this._isAnyButtonPressed(e)){var t=e.pageX,n=e.pageY,r=this._getOffsetPosition(t,n),o=this.getScalingFactor(),i=this.callbacks.onMouseMove;i&&i(r.x*o,r.y*o,e.timeStamp)}},e.prototype.fireMouseEnter=function(e){if(this._isGeneratedByMouseDevice(e)){var t=this.callbacks.onMouseEnter;t&&t(e.timeStamp)}},e.prototype.fireMouseLeave=function(e){if(this._isGeneratedByMouseDevice(e)){var t=this.callbacks.onMouseLeave;t&&t(e.timeStamp)}},e.prototype.saveTargetElementOffset=function(){this._targetElementOffset=(0,r.getElementOffset)(this.targetElement)},e.prototype.saveInitialPinchDistance=function(){this._initialPinchDistance=this._getCurrentPinchDistance()},e.prototype.saveInitialGestureIfUndefined=function(){if(this.initialGesture===i.UNDEFINED){var e=Object.keys(this.pointers);if(e.length>=2){var t=this._getCurrentPinchDistance();t-this._initialPinchDistance>5?this.initialGesture=i.ZOOM_IN:this._initialPinchDistance-t>10&&(this.initialGesture=i.ZOOM_OUT)}else{var n=this.pointers[e[0]],r=n.last.position.x-n.initial.position.x,o=n.last.position.y-n.initial.position.y,a=n.last.timestamp-n.initial.timestamp;if(Math.max(Math.abs(r),Math.abs(o))<10||a<10)return;var s=Math.atan2(-o,r)*(180/Math.PI);this.initialGesture=s>=-25&&s<=25?i.SWIPE_RIGHT:s>=60&&s<=120?i.SWIPE_UP:s>=155||s<=-155?i.SWIPE_LEFT:s>=-120&&s<=-60?i.SWIPE_DOWN:i.SWIPE_OTHER}}},e.prototype.isValidPointer=function(e){return!!this.pointers[e]},e.prototype.savePointer=function(e,t,n,r){var o=this._getOffsetPosition(t,n),i=this._getValidTimestamp(r);this.pointers[e]=this.pointers[e]||{initial:{position:o,timestamp:i}},this.pointers[e].last={position:o,timestamp:i}},e.prototype.deletePointer=function(e){delete this.pointers[e],0===this.getPointerCount()&&(this.initialGesture=i.UNDEFINED,this._initialPinchDistance=NaN)},e.prototype.isPointerMoved=function(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=this._getOffsetPosition(t,n),i=this.pointers[e].last.position;return Math.abs(i.x-o.x)>Math.abs(r)||Math.abs(i.y-o.y)>Math.abs(r)},e.prototype._getValidTimestamp=function(e){return parseInt((""+e).substring(0,13),10)},e.prototype._getOffsetPosition=function(e,t){this._targetElementOffset||this.saveTargetElementOffset();var n=this._targetElementOffset||{},r=n.left,o=void 0===r?0:r,i=n.top,a=void 0===i?0:i;return{x:Math.round(e-o),y:Math.round(t-a)}},e.prototype._getLastEventTimestamp=function(){var e=this,t=0;return Object.keys(this.pointers).forEach(function(n){var r=e.pointers[n];t=Math.max(t,r.last.timestamp)}),t},e.prototype._getCurrentPinchDistance=function(){var e=Object.keys(this.pointers);if(e.length<=1)return 1;var t=this.pointers[e[0]],n=this.pointers[e[1]];return Math.sqrt(Math.pow(t.last.position.x-n.last.position.x,2)+Math.pow(t.last.position.y-n.last.position.y,2))},e.prototype.getPointerCount=function(){return Object.keys(this.pointers).length},e.prototype._getTouches=function(){var e=this,t=this.getScalingFactor();return Object.keys(this.pointers).map(function(n){var r=e.pointers[n];return{x:r.last.position.x*t,y:r.last.position.y*t}})},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.TapHandler=void 0;var r=n(134);t.TapHandler=function(e){function t(n,r,o){babelHelpers.classCallCheck(this,t);var i=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,o));return i._singleTapConfirmedTimeoutId=null,i._doubleTapConfirmedTimeoutId=null,i}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.unregisterTapHandlers()},t.prototype.reset=function(){e.prototype.reset.call(this),this.unregisterTapHandlers()},t.prototype.registerTapHandlers=function(){var e=this,t=this._getFirstPointerId(),n=this.pointers[t].last.position;window.clearTimeout(this._doubleTapConfirmedTimeoutId),this._doubleTapConfirmedTimeoutId=null,window.clearTimeout(this._singleTapConfirmedTimeoutId),this._singleTapConfirmedTimeoutId&&1===this.getPointerCount()&&(this._doubleTapConfirmedTimeoutId=window.setTimeout(function(){e._doubleTapConfirmedTimeoutId=null,0===e.getPointerCount()&&e._fireDoubleTapConfirmed(n.x,n.y)},200)),this._singleTapConfirmedTimeoutId=null,this._doubleTapConfirmedTimeoutId||1!==this.getPointerCount()||(this._singleTapConfirmedTimeoutId=window.setTimeout(function(){e._singleTapConfirmedTimeoutId=null,0===e.getPointerCount()&&e._fireSingleTapConfirmed(n.x,n.y)},200))},t.prototype.unregisterTapHandlers=function(){window.clearTimeout(this._singleTapConfirmedTimeoutId),this._singleTapConfirmedTimeoutId=null,window.clearTimeout(this._doubleTapConfirmedTimeoutId),this._doubleTapConfirmedTimeoutId=null},t.prototype.validateTapHandlers=function(){var e=this._getFirstPointerId(),t=this.pointers[e].last.position;this._isPointerCloseToInitialPosition(e,t.x,t.y)||this.unregisterTapHandlers()},t.prototype.executeTapHandlers=function(){var e=this._getFirstPointerId(),t=this.pointers[e].last.position;this._singleTapConfirmedTimeoutId&&this._fireSingleTap(t.x,t.y),this._doubleTapConfirmedTimeoutId&&(this._fireSingleTap(t.x,t.y),this._fireDoubleTap(t.x,t.y))},t.prototype._fireSingleTap=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onSingleTap;r&&r(e*n,t*n)},t.prototype._fireSingleTapConfirmed=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onSingleTapConfirmed;r&&r(e*n,t*n)},t.prototype._fireDoubleTap=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onDoubleTap;r&&r(e*n,t*n)},t.prototype._fireDoubleTapConfirmed=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onDoubleTapConfirmed;r&&r(e*n,t*n)},t.prototype._getFirstPointerId=function(){return Object.keys(this.pointers)[0]},t.prototype._isPointerCloseToInitialPosition=function(e,t,n){var r=this.pointers[e];return Math.abs(r.initial.position.x-t)<5&&Math.abs(r.initial.position.y-n)<5},t}(r.BaseInputHandler)},function(e,t,n){"use strict";t.__esModule=!0;t.SHARE="SHARE"},function(e,t,n){"use strict";function r(e,t){return{type:f,service:e,videoId:t}}function o(){return{type:h}}function i(e,t){switch(t.type){case f:return Object.assign({},e,{showOverlay:!0,service:t.service,videoId:t.videoId});case h:return Object.assign({},e,{showOverlay:!1});default:return e}}function a(){var e={showOverlay:!1,service:null,videoId:null};return function(){return i(arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,arguments[1])}}t.__esModule=!0,t.VideoOverlay=t.selectVideoId=t.selectService=t.selectShowOverlay=void 0,t.showVideoOverlay=r,t.createReducer=a;var s=n(2),u=babelHelpers.interopRequireDefault(s),l=n(29),c=babelHelpers.interopRequireWildcard(l),p=n(76),d=n(201),f="SHOW_VIDEO_OVERLAY",h="HIDE_VIDEO_OVERLAY";t.selectShowOverlay=function(e){return e.videoOverlay.showOverlay},t.selectService=function(e){return e.videoOverlay.service},t.selectVideoId=function(e){return e.videoOverlay.videoId};(t.VideoOverlay=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var a=arguments.length,s=Array(a),u=0;u<a;u++)s[u]=arguments[u];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(s))),r.onBackgroundClick=function(){r.props.dispatch(o())},r.onCloseButtonClick=function(){r.props.dispatch(o()),r.props.dispatch(c.onButtonClick())},r.getVideoUrl=function(){switch(r.props.service){case"youtube":return"https://www.youtube.com/embed/"+r.props.videoId;case"vimeo":return"https://player.vimeo.com/video/"+r.props.videoId;default:return""}},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.render=function(){return u.default.createElement("div",{className:"video-overlay"},u.default.createElement("div",{className:"video-overlay__background",onClick:this.onBackgroundClick}),u.default.createElement("div",{className:"video-overlay__content"},u.default.createElement("iframe",{className:"video-overlay__player",src:this.getVideoUrl(),frameBorder:"0",allowFullScreen:!0}),u.default.createElement(p.Button,{className:"svg-btn video-overlay__close-button",content:d.CloseIcon,onClick:this.onCloseButtonClick})))},t}(s.Component)).displayName="VideoOverlay"},function(e,t,n){"use strict";function r(e){return{type:a,api:e}}function o(){return r({getVisiblePages:function(){return[]},getVisibleComponents:function(){return[]},getViewportBBoxForComponent:function(e){},getRenderedViews:function(e){return[]},getReadMode:function(){},getPageComponent:function(e){},goToPage:function(e){},goToSpread:function(e){},jumpToPage:function(e){},jumpToSpread:function(e){},setSnapping:function(e){},jumpToPositionByPercent:function(e){},zoomCurrentView:function(e){},getPosition:function(){},setPosition:function(e){},tweakAnimation:function(e){}})}function i(){return function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null,t=arguments[1];switch(t.type){case a:return Object.assign({},e,t.api);default:return e}}}t.__esModule=!0,t.setCanvasApi=r,t.setEmptyCanvasApi=o,t.createReducer=i;var a="SET_CANVAS_API";t.types={SET_CANVAS_API:a}},function(e,t,n){"use strict";function r(e,t,n){return!(!n&&t&&t.licenses)||!!t.licenses.find(function(t){return t.name===e})}t.__esModule=!0,t.hasLicense=r},function(e,t,n){"use strict";function r(e){return!!(window.WebGLRenderingContext&&e instanceof window.WebGLRenderingContext)||!(!e||!e.hasOwnProperty("drawingBufferWidth"))}function o(e,t){var n={failIfMajorPerformanceCaveat:!0,stencil:!!t};try{var r=e.getContext("webgl",n);if(r)return r}catch(e){}try{var o=e.getContext("experimental-webgl",n);if(o)return o}catch(e){}return null}t.__esModule=!0,t.isWebGLContext=r,t.getWebGLContext=o},function(e,t,n){"use strict";var r=n(18),o=n(71),i=n(17);e.exports=function(e){for(var t=r(this),n=i(t.length),a=arguments.length,s=o(a>1?arguments[1]:void 0,n),u=a>2?arguments[2]:void 0,l=void 0===u?n:o(u,n);l>s;)t[s++]=e;return t}},function(e,t,n){"use strict";var r=n(15),o=n(61);e.exports=function(e,t,n){t in e?r.f(e,t,o(0,n)):e[t]=n}},function(e,t,n){var r=n(9),o=n(4).document,i=r(o)&&r(o.createElement);e.exports=function(e){return i?o.createElement(e):{}}},function(e,t){e.exports="constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",")},function(e,t,n){var r=n(12)("match");e.exports=function(e){var t=/./;try{"/./"[e](t)}catch(n){try{return t[r]=!1,!"/./"[e](t)}catch(e){}}return!0}},function(e,t,n){e.exports=n(4).document&&document.documentElement},function(e,t,n){var r=n(9),o=n(155).set;e.exports=function(e,t,n){var i,a=t.constructor;return a!==n&&"function"==typeof a&&(i=a.prototype)!==n.prototype&&r(i)&&o&&o(e,i),e}},function(e,t,n){var r=n(82),o=n(12)("iterator"),i=Array.prototype;e.exports=function(e){return void 0!==e&&(r.Array===e||i[o]===e)}},function(e,t,n){var r=n(36);e.exports=Array.isArray||function(e){return"Array"==r(e)}},function(e,t,n){"use strict";var r=n(66),o=n(61),i=n(83),a={};n(25)(a,n(12)("iterator"),function(){return this}),e.exports=function(e,t,n){e.prototype=r(a,{next:o(1,n)}),i(e,t+" Iterator")}},function(e,t,n){"use strict";var r=n(65),o=n(0),i=n(26),a=n(25),s=n(22),u=n(82),l=n(150),c=n(83),p=n(31),d=n(12)("iterator"),f=!([].keys&&"next"in[].keys()),h=function(){return this};e.exports=function(e,t,n,m,g,v,b){l(n,t,m);var y,_,E,w=function(e){if(!f&&e in C)return C[e];switch(e){case"keys":return function(){return new n(this,e)};case"values":return function(){return new n(this,e)}}return function(){return new n(this,e)}},S=t+" Iterator",x="values"==g,T=!1,C=e.prototype,I=C[d]||C["@@iterator"]||g&&C[g],R=I||w(g),M=g?x?w("entries"):R:void 0,P="Array"==t?C.entries||I:I;if(P&&(E=p(P.call(new e)))!==Object.prototype&&(c(E,S,!0),r||s(E,d)||a(E,d,h)),x&&I&&"values"!==I.name&&(T=!0,R=function(){return I.call(this)}),r&&!b||!f&&!T&&C[d]||a(C,d,R),u[t]=R,u[S]=h,g)if(y={values:x?R:w("values"),keys:v?R:w("keys"),entries:M},b)for(_ in y)_ in C||i(C,_,y[_]);else o(o.P+o.F*(f||T),t,y);return y}},function(e,t){var n=Math.expm1;e.exports=!n||n(10)>22025.465794806718||n(10)<22025.465794806718||n(-2e-17)!=-2e-17?function(e){return 0==(e=+e)?e:e>-1e-6&&e<1e-6?e+e*e/2:Math.exp(e)-1}:n},function(e,t){e.exports=Math.sign||function(e){return 0==(e=+e)||e!=e?e:e<0?-1:1}},function(e,t,n){var r=n(4),o=n(162).set,i=r.MutationObserver||r.WebKitMutationObserver,a=r.process,s=r.Promise,u="process"==n(36)(a);e.exports=function(){var e,t,n,l=function(){var r,o;for(u&&(r=a.domain)&&r.exit();e;){o=e.fn,e=e.next;try{o()}catch(r){throw e?n():t=void 0,r}}t=void 0,r&&r.enter()};if(u)n=function(){a.nextTick(l)};else if(i){var c=!0,p=document.createTextNode("");new i(l).observe(p,{characterData:!0}),n=function(){p.data=c=!c}}else if(s&&s.resolve){var d=s.resolve();n=function(){d.then(l)}}else n=function(){o.call(r,l)};return function(r){var o={fn:r,next:void 0};t&&(t.next=o),e||(e=o,n()),t=o}}},function(e,t,n){var r=n(9),o=n(3),i=function(e,t){if(o(e),!r(t)&&null!==t)throw TypeError(t+": can't set as prototype!")};e.exports={set:Object.setPrototypeOf||("__proto__"in{}?function(e,t,r){try{r=n(50)(Function.call,n(30).f(Object.prototype,"__proto__").set,2),r(e,[]),t=!(e instanceof Array)}catch(e){t=!0}return function(e,n){return i(e,n),t?e.__proto__=n:r(e,n),e}}({},!1):void 0),check:i}},function(e,t,n){var r=n(121)("keys"),o=n(72);e.exports=function(e){return r[e]||(r[e]=o(e))}},function(e,t,n){var r=n(3),o=n(24),i=n(12)("species");e.exports=function(e,t){var n,a=r(e).constructor;return void 0===a||void 0==(n=r(a)[i])?t:o(n)}},function(e,t,n){var r=n(62),o=n(37);e.exports=function(e){return function(t,n){var i,a,s=String(o(t)),u=r(n),l=s.length;return u<0||u>=l?e?"":void 0:(i=s.charCodeAt(u),i<55296||i>56319||u+1===l||(a=s.charCodeAt(u+1))<56320||a>57343?e?s.charAt(u):i:e?s.slice(u,u+2):a-56320+(i-55296<<10)+65536)}}},function(e,t,n){var r=n(117),o=n(37);e.exports=function(e,t,n){if(r(t))throw TypeError("String#"+n+" doesn't accept regex!");return String(o(e))}},function(e,t,n){"use strict";var r=n(62),o=n(37);e.exports=function(e){var t=String(o(this)),n="",i=r(e);if(i<0||i==1/0)throw RangeError("Count can't be negative");for(;i>0;(i>>>=1)&&(t+=t))1&i&&(n+=t);return n}},function(e,t){e.exports="\t\n\v\f\r   ᠎             　\u2028\u2029\ufeff"},function(e,t,n){var r,o,i,a=n(50),s=n(116),u=n(146),l=n(143),c=n(4),p=c.process,d=c.setImmediate,f=c.clearImmediate,h=c.MessageChannel,m=0,g={},v=function(){var e=+this;if(g.hasOwnProperty(e)){var t=g[e];delete g[e],t()}},b=function(e){v.call(e.data)};d&&f||(d=function(e){for(var t=[],n=1;arguments.length>n;)t.push(arguments[n++]);return g[++m]=function(){s("function"==typeof e?e:Function(e),t)},r(m),m},f=function(e){delete g[e]},"process"==n(36)(p)?r=function(e){p.nextTick(a(v,e,1))}:h?(o=new h,i=o.port2,o.port1.onmessage=b,r=a(i.postMessage,i,1)):c.addEventListener&&"function"==typeof postMessage&&!c.importScripts?(r=function(e){c.postMessage(e+"","*")},c.addEventListener("message",b,!1)):r="onreadystatechange"in l("script")?function(e){u.appendChild(l("script")).onreadystatechange=function(){u.removeChild(this),v.call(e)}}:function(e){setTimeout(a(v,e,1),0)}),e.exports={set:d,clear:f}},function(e,t,n){"use strict";var r=n(4),o=n(14),i=n(65),a=n(122),s=n(25),u=n(69),l=n(6),c=n(64),p=n(62),d=n(17),f=n(67).f,h=n(15).f,m=n(141),g=n(83),v=r.ArrayBuffer,b=r.DataView,y=r.Math,_=r.RangeError,E=r.Infinity,w=v,S=y.abs,x=y.pow,T=y.floor,C=y.log,I=y.LN2,R=o?"_b":"buffer",M=o?"_l":"byteLength",P=o?"_o":"byteOffset",O=function(e,t,n){var r,o,i,a=Array(n),s=8*n-t-1,u=(1<<s)-1,l=u>>1,c=23===t?x(2,-24)-x(2,-77):0,p=0,d=e<0||0===e&&1/e<0?1:0;for(e=S(e),e!=e||e===E?(o=e!=e?1:0,r=u):(r=T(C(e)/I),e*(i=x(2,-r))<1&&(r--,i*=2),e+=r+l>=1?c/i:c*x(2,1-l),e*i>=2&&(r++,i/=2),r+l>=u?(o=0,r=u):r+l>=1?(o=(e*i-1)*x(2,t),r+=l):(o=e*x(2,l-1)*x(2,t),r=0));t>=8;a[p++]=255&o,o/=256,t-=8);for(r=r<<t|o,s+=t;s>0;a[p++]=255&r,r/=256,s-=8);return a[--p]|=128*d,a},A=function(e,t,n){var r,o=8*n-t-1,i=(1<<o)-1,a=i>>1,s=o-7,u=n-1,l=e[u--],c=127&l;for(l>>=7;s>0;c=256*c+e[u],u--,s-=8);for(r=c&(1<<-s)-1,c>>=-s,s+=t;s>0;r=256*r+e[u],u--,s-=8);if(0===c)c=1-a;else{if(c===i)return r?NaN:l?-E:E;r+=x(2,t),c-=a}return(l?-1:1)*r*x(2,c-t)},D=function(e){return e[3]<<24|e[2]<<16|e[1]<<8|e[0]},k=function(e){return[255&e]},N=function(e){return[255&e,e>>8&255]},L=function(e){return[255&e,e>>8&255,e>>16&255,e>>24&255]},F=function(e){return O(e,52,8)},U=function(e){return O(e,23,4)},H=function(e,t,n){h(e.prototype,t,{get:function(){return this[n]}})},B=function(e,t,n,r){var o=+n,i=p(o);if(o!=i||i<0||i+t>e[M])throw _("Wrong index!");var a=e[R]._b,s=i+e[P],u=a.slice(s,s+t);return r?u:u.reverse()},j=function(e,t,n,r,o,i){var a=+n,s=p(a);if(a!=s||s<0||s+t>e[M])throw _("Wrong index!");for(var u=e[R]._b,l=s+e[P],c=r(+o),d=0;d<t;d++)u[l+d]=c[i?d:t-d-1]},W=function(e,t){c(e,v,"ArrayBuffer");var n=+t,r=d(n);if(n!=r)throw _("Wrong length!");return r};if(a.ABV){if(!l(function(){new v})||!l(function(){new v(.5)})){v=function(e){return new w(W(this,e))};for(var z,q=v.prototype=w.prototype,V=f(w),G=0;V.length>G;)(z=V[G++])in v||s(v,z,w[z]);i||(q.constructor=v)}var Y=new b(new v(2)),$=b.prototype.setInt8;Y.setInt8(0,2147483648),Y.setInt8(1,2147483649),!Y.getInt8(0)&&Y.getInt8(1)||u(b.prototype,{setInt8:function(e,t){$.call(this,e,t<<24>>24)},setUint8:function(e,t){$.call(this,e,t<<24>>24)}},!0)}else v=function(e){var t=W(this,e);this._b=m.call(Array(t),0),this[M]=t},b=function(e,t,n){c(this,b,"DataView"),c(e,v,"DataView");var r=e[M],o=p(t);if(o<0||o>r)throw _("Wrong offset!");if(n=void 0===n?r-o:d(n),o+n>r)throw _("Wrong length!");this[R]=e,this[P]=o,this[M]=n},o&&(H(v,"byteLength","_l"),H(b,"buffer","_b"),H(b,"byteLength","_l"),H(b,"byteOffset","_o")),u(b.prototype,{getInt8:function(e){return B(this,1,e)[0]<<24>>24},getUint8:function(e){return B(this,1,e)[0]},getInt16:function(e){var t=B(this,2,e,arguments[1]);return(t[1]<<8|t[0])<<16>>16},getUint16:function(e){var t=B(this,2,e,arguments[1]);return t[1]<<8|t[0]},getInt32:function(e){return D(B(this,4,e,arguments[1]))},getUint32:function(e){return D(B(this,4,e,arguments[1]))>>>0},getFloat32:function(e){return A(B(this,4,e,arguments[1]),23,4)},getFloat64:function(e){return A(B(this,8,e,arguments[1]),52,8)},setInt8:function(e,t){j(this,1,e,k,t)},setUint8:function(e,t){j(this,1,e,k,t)},setInt16:function(e,t){j(this,2,e,N,t,arguments[2])},setUint16:function(e,t){j(this,2,e,N,t,arguments[2])},setInt32:function(e,t){j(this,4,e,L,t,arguments[2])},setUint32:function(e,t){j(this,4,e,L,t,arguments[2])},setFloat32:function(e,t){j(this,4,e,U,t,arguments[2])},setFloat64:function(e,t){j(this,8,e,F,t,arguments[2])}});g(v,"ArrayBuffer"),g(b,"DataView"),s(b.prototype,a.VIEW,!0),t.ArrayBuffer=v,t.DataView=b},function(e,t,n){var r=n(4),o=n(49),i=n(65),a=n(246),s=n(15).f;e.exports=function(e){var t=o.Symbol||(o.Symbol=i?{}:r.Symbol||{});"_"==e.charAt(0)||e in t||s(t,e,{value:a.f(e)})}},function(e,t,n){var r=n(98),o=n(12)("iterator"),i=n(82);e.exports=n(49).getIteratorMethod=function(e){if(void 0!=e)return e[o]||e["@@iterator"]||i[r(e)]}},function(e,t,n){"use strict";var r=n(80),o=n(234),i=n(82),a=n(28);e.exports=n(151)(Array,"Array",function(e,t){this._t=a(e),this._i=0,this._k=t},function(){var e=this._t,t=this._k,n=this._i++;return!e||n>=e.length?(this._t=void 0,o(1)):"keys"==t?o(0,n):"values"==t?o(0,e[n]):o(0,[n,e[n]])},"values"),i.Arguments=i.Array,r("keys"),r("values"),r("entries")},function(e,t,n){"use strict";function r(e,t){return e===t?0!==e||0!==t||1/e==1/t:e!==e&&t!==t}function o(e,t){if(r(e,t))return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var n=Object.keys(e);if(n.length!==Object.keys(t).length)return!1;for(var o=0;o<n.length;o++)if(!i.call(t,n[o])||!r(e[n[o]],t[n[o]]))return!1;return!0}var i=Object.prototype.hasOwnProperty;e.exports=o},function(e,t,n){"use strict";var r=Function.prototype.toString,o=/^\s*class /,i=function(e){try{var t=r.call(e),n=t.replace(/\/\/.*\n/g,""),i=n.replace(/\/\*[.\s\S]*\*\//g,""),a=i.replace(/\n/gm," ").replace(/ {2}/g," ");return o.test(a)}catch(e){return!1}},a=function(e){try{return!i(e)&&(r.call(e),!0)}catch(e){return!1}},s=Object.prototype.toString,u="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;e.exports=function(e){if(!e)return!1;if("function"!=typeof e&&"object"!=typeof e)return!1;if(u)return a(e);if(i(e))return!1;var t=s.call(e);return"[object Function]"===t||"[object GeneratorFunction]"===t}},function(e,t){function n(){var e=/debugads=([^;]*)/,t=e.exec(document.cookie);return t&&"true"===t.pop()||"undefined"!=typeof window&&window.location.search.indexOf("debugads=true")>-1}e.exports={log:function(){n()&&console.debug(arguments)}}},function(e,t,n){"use strict";function r(e){if(!n.i(a.a)(e)||n.i(o.a)(e)!=s)return!1;var t=n.i(i.a)(e);if(null===t)return!0;var r=p.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&c.call(r)==d}var o=n(627),i=n(629),a=n(634),s="[object Object]",u=Function.prototype,l=Object.prototype,c=u.toString,p=l.hasOwnProperty,d=c.call(Object);t.a=r},function(e,t,n){"use strict";function r(e,t){return Array.isArray(t)&&(t=t[1]),t?t.nextSibling:e.firstChild}function o(e,t,n){c.insertTreeBefore(e,t,n)}function i(e,t,n){Array.isArray(t)?s(e,t[0],t[1],n):m(e,t,n)}function a(e,t){if(Array.isArray(t)){var n=t[1];t=t[0],u(e,t,n),e.removeChild(n)}e.removeChild(t)}function s(e,t,n,r){for(var o=t;;){var i=o.nextSibling;if(m(e,o,r),o===n)break;o=i}}function u(e,t,n){for(;;){var r=t.nextSibling;if(r===n)break;e.removeChild(r)}}function l(e,t,n){var r=e.parentNode,o=e.nextSibling;o===t?n&&m(r,document.createTextNode(n),o):n?(h(o,n),u(r,o,t)):u(r,e,t)}var c=n(86),p=n(655),d=(n(16),n(39),n(180)),f=n(128),h=n(287),m=d(function(e,t,n){e.insertBefore(t,n)}),g=p.dangerouslyReplaceNodeWithMarkup;e.exports={dangerouslyReplaceNodeWithMarkup:g,replaceDelimitedText:l,processUpdates:function(e,t){for(var n=0;n<t.length;n++){var s=t[n];switch(s.type){case"INSERT_MARKUP":o(e,s.content,r(e,s.afterNode));break;case"MOVE_EXISTING":i(e,s.fromNode,r(e,s.afterNode));break;case"SET_MARKUP":f(e,s.content);break;case"TEXT_CONTENT":h(e,s.content);break;case"REMOVE_NODE":a(e,s.fromNode)}}}}},function(e,t,n){"use strict";e.exports={html:"http://www.w3.org/1999/xhtml",mathml:"http://www.w3.org/1998/Math/MathML",svg:"http://www.w3.org/2000/svg"}},function(e,t,n){"use strict";function r(){if(s)for(var e in u){var t=u[e],n=s.indexOf(e);if(n>-1||a("96",e),!l.plugins[n]){t.extractEvents||a("97",e),l.plugins[n]=t;var r=t.eventTypes;for(var i in r)o(r[i],t,i)||a("98",i,e)}}}function o(e,t,n){l.eventNameDispatchConfigs.hasOwnProperty(n)&&a("99",n),l.eventNameDispatchConfigs[n]=e;var r=e.phasedRegistrationNames;if(r){for(var o in r)if(r.hasOwnProperty(o)){var s=r[o];i(s,t,n)}return!0}return!!e.registrationName&&(i(e.registrationName,t,n),!0)}function i(e,t,n){l.registrationNameModules[e]&&a("100",e),l.registrationNameModules[e]=t,l.registrationNameDependencies[e]=t.eventTypes[n].dependencies}var a=n(7),s=(n(1),null),u={},l={plugins:[],eventNameDispatchConfigs:{},registrationNameModules:{},registrationNameDependencies:{},possibleRegistrationNames:null,injectEventPluginOrder:function(e){s&&a("101"),s=Array.prototype.slice.call(e),r()},injectEventPluginsByName:function(e){var t=!1;for(var n in e)if(e.hasOwnProperty(n)){var o=e[n];u.hasOwnProperty(n)&&u[n]===o||(u[n]&&a("102",n),u[n]=o,t=!0)}t&&r()},getPluginModuleForEvent:function(e){var t=e.dispatchConfig;if(t.registrationName)return l.registrationNameModules[t.registrationName]||null;if(void 0!==t.phasedRegistrationNames){var n=t.phasedRegistrationNames;for(var r in n)if(n.hasOwnProperty(r)){var o=l.registrationNameModules[n[r]];if(o)return o}}return null},_resetEventPlugins:function(){s=null;for(var e in u)u.hasOwnProperty(e)&&delete u[e];l.plugins.length=0;var t=l.eventNameDispatchConfigs;for(var n in t)t.hasOwnProperty(n)&&delete t[n];var r=l.registrationNameModules;for(var o in r)r.hasOwnProperty(o)&&delete r[o]}};e.exports=l},function(e,t,n){"use strict";function r(e){return"topMouseUp"===e||"topTouchEnd"===e||"topTouchCancel"===e}function o(e){return"topMouseMove"===e||"topTouchMove"===e}function i(e){return"topMouseDown"===e||"topTouchStart"===e}function a(e,t,n,r){var o=e.type||"unknown-event";e.currentTarget=v.getNodeFromInstance(r),t?m.invokeGuardedCallbackWithCatch(o,n,e):m.invokeGuardedCallback(o,n,e),e.currentTarget=null}function s(e,t){var n=e._dispatchListeners,r=e._dispatchInstances;if(Array.isArray(n))for(var o=0;o<n.length&&!e.isPropagationStopped();o++)a(e,t,n[o],r[o]);else n&&a(e,t,n,r);e._dispatchListeners=null,e._dispatchInstances=null}function u(e){var t=e._dispatchListeners,n=e._dispatchInstances;if(Array.isArray(t)){for(var r=0;r<t.length&&!e.isPropagationStopped();r++)if(t[r](e,n[r]))return n[r]}else if(t&&t(e,n))return n;return null}function l(e){var t=u(e);return e._dispatchInstances=null,e._dispatchListeners=null,t}function c(e){var t=e._dispatchListeners,n=e._dispatchInstances;Array.isArray(t)&&h("103"),e.currentTarget=t?v.getNodeFromInstance(n):null;var r=t?t(e):null;return e.currentTarget=null,e._dispatchListeners=null,e._dispatchInstances=null,r}function p(e){return!!e._dispatchListeners}var d,f,h=n(7),m=n(178),g=(n(1),n(5),{injectComponentTree:function(e){d=e},injectTreeTraversal:function(e){f=e}}),v={isEndish:r,isMoveish:o,isStartish:i,executeDirectDispatch:c,executeDispatchesInOrder:s,executeDispatchesInOrderStopAtTrue:l,hasDispatches:p,getInstanceFromNode:function(e){return d.getInstanceFromNode(e)},getNodeFromInstance:function(e){return d.getNodeFromInstance(e)},isAncestor:function(e,t){return f.isAncestor(e,t)},getLowestCommonAncestor:function(e,t){return f.getLowestCommonAncestor(e,t)},getParentInstance:function(e){return f.getParentInstance(e)},traverseTwoPhase:function(e,t,n){return f.traverseTwoPhase(e,t,n)},traverseEnterLeave:function(e,t,n,r,o){return f.traverseEnterLeave(e,t,n,r,o)},injection:g};e.exports=v},function(e,t,n){"use strict";function r(e){var t={"=":"=0",":":"=2"};return"$"+(""+e).replace(/[=:]/g,function(e){return t[e]})}function o(e){var t={"=0":"=","=2":":"};return(""+e.substring("."===e[0]&&"$"===e[1]?2:1)).replace(/(=0|=2)/g,function(e){return t[e]})}e.exports={escape:r,unescape:o}},function(e,t,n){"use strict";function r(e){null!=e.checkedLink&&null!=e.valueLink&&s("87")}function o(e){r(e),(null!=e.value||null!=e.onChange)&&s("88")}function i(e){r(e),(null!=e.checked||null!=e.onChange)&&s("89")}function a(e){if(e){var t=e.getName();if(t)return" Check the render method of `"+t+"`."}return""}var s=n(7),u=n(684),l=n(266),c=n(89),p=l(c.isValidElement),d=(n(1),n(5),{button:!0,checkbox:!0,image:!0,hidden:!0,radio:!0,reset:!0,submit:!0}),f={value:function(e,t,n){return!e[t]||d[e.type]||e.onChange||e.readOnly||e.disabled?null:new Error("You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`.")},checked:function(e,t,n){return!e[t]||e.onChange||e.readOnly||e.disabled?null:new Error("You provided a `checked` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultChecked`. Otherwise, set either `onChange` or `readOnly`.")},onChange:p.func},h={};e.exports={checkPropTypes:function(e,t,n){for(var r in f){if(f.hasOwnProperty(r))var o=f[r](t,r,e,"prop",null,u);if(o instanceof Error&&!(o.message in h)){h[o.message]=!0;a(n)}}},getValue:function(e){return e.valueLink?(o(e),e.valueLink.value):e.value},getChecked:function(e){return e.checkedLink?(i(e),e.checkedLink.value):e.checked},executeOnChange:function(e,t){return e.valueLink?(o(e),e.valueLink.requestChange(t.target.value)):e.checkedLink?(i(e),e.checkedLink.requestChange(t.target.checked)):e.onChange?e.onChange.call(void 0,t):void 0}}},function(e,t,n){"use strict";var r=n(7),o=(n(1),!1),i={replaceNodeWithMarkup:null,processChildrenUpdates:null,injection:{injectEnvironment:function(e){o&&r("104"),i.replaceNodeWithMarkup=e.replaceNodeWithMarkup,i.processChildrenUpdates=e.processChildrenUpdates,o=!0}}};e.exports=i},function(e,t,n){"use strict";function r(e,t,n){try{t(n)}catch(e){null===o&&(o=e)}}var o=null,i={invokeGuardedCallback:r,invokeGuardedCallbackWithCatch:r,rethrowCaughtError:function(){if(o){var e=o;throw o=null,e}}};e.exports=i},function(e,t,n){"use strict";function r(e){u.enqueueUpdate(e)}function o(e){var t=typeof e;if("object"!==t)return t;var n=e.constructor&&e.constructor.name||t,r=Object.keys(e);return r.length>0&&r.length<20?n+" (keys: "+r.join(", ")+")":n}function i(e,t){var n=s.get(e);if(!n){return null}return n}var a=n(7),s=(n(56),n(105)),u=(n(39),n(45)),l=(n(1),n(5),{isMounted:function(e){var t=s.get(e);return!!t&&!!t._renderedComponent},enqueueCallback:function(e,t,n){l.validateCallback(t,n);var o=i(e);if(!o)return null;o._pendingCallbacks?o._pendingCallbacks.push(t):o._pendingCallbacks=[t],r(o)},enqueueCallbackInternal:function(e,t){e._pendingCallbacks?e._pendingCallbacks.push(t):e._pendingCallbacks=[t],r(e)},enqueueForceUpdate:function(e){var t=i(e,"forceUpdate");t&&(t._pendingForceUpdate=!0,r(t))},enqueueReplaceState:function(e,t,n){var o=i(e,"replaceState");o&&(o._pendingStateQueue=[t],o._pendingReplaceState=!0,void 0!==n&&null!==n&&(l.validateCallback(n,"replaceState"),o._pendingCallbacks?o._pendingCallbacks.push(n):o._pendingCallbacks=[n]),r(o))},enqueueSetState:function(e,t){var n=i(e,"setState");if(n){(n._pendingStateQueue||(n._pendingStateQueue=[])).push(t),r(n)}},enqueueElementInternal:function(e,t,n){e._pendingElement=t,e._context=n,r(e)},validateCallback:function(e,t){e&&"function"!=typeof e&&a("122",t,o(e))}});e.exports=l},function(e,t,n){"use strict";e.exports=function(e){return"undefined"!=typeof MSApp&&MSApp.execUnsafeLocalFunction?function(t,n,r,o){MSApp.execUnsafeLocalFunction(function(){return e(t,n,r,o)})}:e}},function(e,t,n){"use strict";function r(e){var t,n=e.keyCode;return"charCode"in e?0===(t=e.charCode)&&13===n&&(t=13):t=n,t>=32||13===t?t:0}e.exports=r},function(e,t,n){"use strict";function r(e){var t=this,n=t.nativeEvent;if(n.getModifierState)return n.getModifierState(e);var r=i[e];return!!r&&!!n[r]}function o(e){return r}var i={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};e.exports=o},function(e,t,n){"use strict";function r(e){var t=e.target||e.srcElement||window;return t.correspondingUseElement&&(t=t.correspondingUseElement),3===t.nodeType?t.parentNode:t}e.exports=r},function(e,t,n){"use strict";/**
 * Checks if an event is supported in the current execution environment.
 *
 * NOTE: This will not work correctly for non-generic events such as `change`,
 * `reset`, `load`, `error`, and `select`.
 *
 * Borrows from Modernizr.
 *
 * @param {string} eventNameSuffix Event name, e.g. "click".
 * @param {?boolean} capture Check if the capture phase is supported.
 * @return {boolean} True if the event is supported.
 * @internal
 * @license Modernizr 3.0.0pre (Custom Build) | MIT
 */
function r(e,t){if(!i.canUseDOM||t&&!("addEventListener"in document))return!1;var n="on"+e,r=n in document;if(!r){var a=document.createElement("div");a.setAttribute(n,"return;"),r="function"==typeof a[n]}return!r&&o&&"wheel"===e&&(r=document.implementation.hasFeature("Events.wheel","3.0")),r}var o,i=n(23);i.canUseDOM&&(o=document.implementation&&document.implementation.hasFeature&&document.implementation.hasFeature("","")!==!0),e.exports=r},function(e,t,n){"use strict";function r(e,t){var n=null===e||e===!1,r=null===t||t===!1;if(n||r)return n===r;var o=typeof e,i=typeof t;return"string"===o||"number"===o?"string"===i||"number"===i:"object"===i&&e.type===t.type&&e.key===t.key}e.exports=r},function(e,t,n){"use strict";var r=(n(13),n(32)),o=(n(5),r);e.exports=o},function(e,t,n){"use strict";function r(e){"undefined"!=typeof console&&"function"==typeof console.error&&console.error(e);try{throw new Error(e)}catch(e){}}t.a=r},function(e,t,n){"use strict";function r(e,t,n){this.props=e,this.context=t,this.refs=a,this.updater=n||i}var o=n(91),i=n(189),a=(n(295),n(101));n(1),n(5);r.prototype.isReactComponent={},r.prototype.setState=function(e,t){"object"!=typeof e&&"function"!=typeof e&&null!=e&&o("85"),this.updater.enqueueSetState(this,e),t&&this.updater.enqueueCallback(this,t,"setState")},r.prototype.forceUpdate=function(e){this.updater.enqueueForceUpdate(this),e&&this.updater.enqueueCallback(this,e,"forceUpdate")};e.exports=r},function(e,t,n){"use strict";n(5);e.exports={isMounted:function(e){return!1},enqueueCallback:function(e,t){},enqueueForceUpdate:function(e){},enqueueReplaceState:function(e,t){},enqueueSetState:function(e,t){}}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(297),o=n(738),i=n(737),a=n(736),s=n(296);n(298);n.d(t,"createStore",function(){return r.a}),n.d(t,"combineReducers",function(){return o.a}),n.d(t,"bindActionCreators",function(){return i.a}),n.d(t,"applyMiddleware",function(){return a.a}),n.d(t,"compose",function(){return s.a})},function(e,t,n){"use strict";var r=n(304);babelHelpers.interopRequireDefault(r).default.polyfill()},function(e,t){!function(e){"use strict";function t(e){if("string"!=typeof e&&(e=String(e)),/[^a-z0-9\-#$%&'*+.\^_`|~]/i.test(e))throw new TypeError("Invalid character in header field name");return e.toLowerCase()}function n(e){return"string"!=typeof e&&(e=String(e)),e}function r(e){var t={next:function(){var t=e.shift();return{done:void 0===t,value:t}}};return v.iterable&&(t[Symbol.iterator]=function(){return t}),t}function o(e){this.map={},e instanceof o?e.forEach(function(e,t){this.append(t,e)},this):Array.isArray(e)?e.forEach(function(e){this.append(e[0],e[1])},this):e&&Object.getOwnPropertyNames(e).forEach(function(t){this.append(t,e[t])},this)}function i(e){if(e.bodyUsed)return Promise.reject(new TypeError("Already read"));e.bodyUsed=!0}function a(e){return new Promise(function(t,n){e.onload=function(){t(e.result)},e.onerror=function(){n(e.error)}})}function s(e){var t=new FileReader,n=a(t);return t.readAsArrayBuffer(e),n}function u(e){var t=new FileReader,n=a(t);return t.readAsText(e),n}function l(e){for(var t=new Uint8Array(e),n=new Array(t.length),r=0;r<t.length;r++)n[r]=String.fromCharCode(t[r]);return n.join("")}function c(e){if(e.slice)return e.slice(0);var t=new Uint8Array(e.byteLength);return t.set(new Uint8Array(e)),t.buffer}function p(){return this.bodyUsed=!1,this._initBody=function(e){if(this._bodyInit=e,e)if("string"==typeof e)this._bodyText=e;else if(v.blob&&Blob.prototype.isPrototypeOf(e))this._bodyBlob=e;else if(v.formData&&FormData.prototype.isPrototypeOf(e))this._bodyFormData=e;else if(v.searchParams&&URLSearchParams.prototype.isPrototypeOf(e))this._bodyText=e.toString();else if(v.arrayBuffer&&v.blob&&y(e))this._bodyArrayBuffer=c(e.buffer),this._bodyInit=new Blob([this._bodyArrayBuffer]);else{if(!v.arrayBuffer||!ArrayBuffer.prototype.isPrototypeOf(e)&&!_(e))throw new Error("unsupported BodyInit type");this._bodyArrayBuffer=c(e)}else this._bodyText="";this.headers.get("content-type")||("string"==typeof e?this.headers.set("content-type","text/plain;charset=UTF-8"):this._bodyBlob&&this._bodyBlob.type?this.headers.set("content-type",this._bodyBlob.type):v.searchParams&&URLSearchParams.prototype.isPrototypeOf(e)&&this.headers.set("content-type","application/x-www-form-urlencoded;charset=UTF-8"))},v.blob&&(this.blob=function(){var e=i(this);if(e)return e;if(this._bodyBlob)return Promise.resolve(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(new Blob([this._bodyArrayBuffer]));if(this._bodyFormData)throw new Error("could not read FormData body as blob");return Promise.resolve(new Blob([this._bodyText]))},this.arrayBuffer=function(){return this._bodyArrayBuffer?i(this)||Promise.resolve(this._bodyArrayBuffer):this.blob().then(s)}),this.text=function(){var e=i(this);if(e)return e;if(this._bodyBlob)return u(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(l(this._bodyArrayBuffer));if(this._bodyFormData)throw new Error("could not read FormData body as text");return Promise.resolve(this._bodyText)},v.formData&&(this.formData=function(){return this.text().then(h)}),this.json=function(){return this.text().then(JSON.parse)},this}function d(e){var t=e.toUpperCase();return E.indexOf(t)>-1?t:e}function f(e,t){t=t||{};var n=t.body;if(e instanceof f){if(e.bodyUsed)throw new TypeError("Already read");this.url=e.url,this.credentials=e.credentials,t.headers||(this.headers=new o(e.headers)),this.method=e.method,this.mode=e.mode,n||null==e._bodyInit||(n=e._bodyInit,e.bodyUsed=!0)}else this.url=String(e);if(this.credentials=t.credentials||this.credentials||"omit",!t.headers&&this.headers||(this.headers=new o(t.headers)),this.method=d(t.method||this.method||"GET"),this.mode=t.mode||this.mode||null,this.referrer=null,("GET"===this.method||"HEAD"===this.method)&&n)throw new TypeError("Body not allowed for GET or HEAD requests");this._initBody(n)}function h(e){var t=new FormData;return e.trim().split("&").forEach(function(e){if(e){var n=e.split("="),r=n.shift().replace(/\+/g," "),o=n.join("=").replace(/\+/g," ");t.append(decodeURIComponent(r),decodeURIComponent(o))}}),t}function m(e){var t=new o;return e.split(/\r?\n/).forEach(function(e){var n=e.split(":"),r=n.shift().trim();if(r){var o=n.join(":").trim();t.append(r,o)}}),t}function g(e,t){t||(t={}),this.type="default",this.status="status"in t?t.status:200,this.ok=this.status>=200&&this.status<300,this.statusText="statusText"in t?t.statusText:"OK",this.headers=new o(t.headers),this.url=t.url||"",this._initBody(e)}if(!e.fetch){var v={searchParams:"URLSearchParams"in e,iterable:"Symbol"in e&&"iterator"in Symbol,blob:"FileReader"in e&&"Blob"in e&&function(){try{return new Blob,!0}catch(e){return!1}}(),formData:"FormData"in e,arrayBuffer:"ArrayBuffer"in e};if(v.arrayBuffer)var b=["[object Int8Array]","[object Uint8Array]","[object Uint8ClampedArray]","[object Int16Array]","[object Uint16Array]","[object Int32Array]","[object Uint32Array]","[object Float32Array]","[object Float64Array]"],y=function(e){return e&&DataView.prototype.isPrototypeOf(e)},_=ArrayBuffer.isView||function(e){return e&&b.indexOf(Object.prototype.toString.call(e))>-1};o.prototype.append=function(e,r){e=t(e),r=n(r);var o=this.map[e];this.map[e]=o?o+","+r:r},o.prototype.delete=function(e){delete this.map[t(e)]},o.prototype.get=function(e){return e=t(e),this.has(e)?this.map[e]:null},o.prototype.has=function(e){return this.map.hasOwnProperty(t(e))},o.prototype.set=function(e,r){this.map[t(e)]=n(r)},o.prototype.forEach=function(e,t){for(var n in this.map)this.map.hasOwnProperty(n)&&e.call(t,this.map[n],n,this)},o.prototype.keys=function(){var e=[];return this.forEach(function(t,n){e.push(n)}),r(e)},o.prototype.values=function(){var e=[];return this.forEach(function(t){e.push(t)}),r(e)},o.prototype.entries=function(){var e=[];return this.forEach(function(t,n){e.push([n,t])}),r(e)},v.iterable&&(o.prototype[Symbol.iterator]=o.prototype.entries);var E=["DELETE","GET","HEAD","OPTIONS","POST","PUT"];f.prototype.clone=function(){return new f(this,{body:this._bodyInit})},p.call(f.prototype),p.call(g.prototype),g.prototype.clone=function(){return new g(this._bodyInit,{status:this.status,statusText:this.statusText,headers:new o(this.headers),url:this.url})},g.error=function(){var e=new g(null,{status:0,statusText:""});return e.type="error",e};var w=[301,302,303,307,308];g.redirect=function(e,t){if(w.indexOf(t)===-1)throw new RangeError("Invalid status code");return new g(null,{status:t,headers:{location:e}})},e.Headers=o,e.Request=f,e.Response=g,e.fetch=function(e,t){return new Promise(function(n,r){var o=new f(e,t),i=new XMLHttpRequest;i.onload=function(){var e={status:i.status,statusText:i.statusText,headers:m(i.getAllResponseHeaders()||"")};e.url="responseURL"in i?i.responseURL:e.headers.get("X-Request-URL"),n(new g("response"in i?i.response:i.responseText,e))},i.onerror=function(){r(new TypeError("Network request failed"))},i.ontimeout=function(){r(new TypeError("Network request failed"))},i.open(o.method,o.url,!0),"include"===o.credentials&&(i.withCredentials=!0),"responseType"in i&&v.blob&&(i.responseType="blob"),o.headers.forEach(function(e,t){i.setRequestHeader(t,e)}),i.send(void 0===o._bodyInit?null:o._bodyInit)})},e.fetch.polyfill=!0}}("undefined"!=typeof self?self:this)},function(e,t,n){"use strict";function r(e){return{type:o,enableInPubAds:e}}t.__esModule=!0;var o="SET_INPUBADS";t.types={SET_INPUBADS:o};t.setInPubAds=r},function(e,t,n){"use strict";function r(e){return{type:h,val:e}}function o(e,t){return{type:m,linkModel:e,viewportBBox:t}}function i(e){return{type:g,linkModel:e}}function a(e){return function(t,n){t({type:v,linkModel:e});var r=(0,d.pageNumberToSpreadIndex)((0,f.selectReadMode)(n()),e.pageNumber);t(l.scrollToSpreadIndex(r))}}function s(e){return function(t,n){if(t({type:b,linkModel:e}),e.isVideoLink&&e.videoLink.isSafe){var r=e.videoLink;return void t(p.showVideoOverlay(r.service,r.videoId))}var o=e.url;o.includes(":")||o.startsWith("//")||(o=o.includes("@")?"mailto:"+o:"http://"+o);var i=/^(https?:)?\/\//i.test(o)?"_blank":"_top";window.open(o,i)}}t.__esModule=!0,t.openUrl=t.gotoPage=t.hideLinkTooltip=t.showLinkTooltip=t.setShowLinks=t.types=void 0;var u=n(8),l=babelHelpers.interopRequireWildcard(u),c=n(137),p=babelHelpers.interopRequireWildcard(c),d=n(59),f=n(11),h="SET_SHOW_LINKS",m="SHOW_LINK_TOOLTIP",g="HIDE_LINK_TOOLTIP",v="GOTO_PAGE",b="OPEN_URL";t.types={SET_SHOW_LINKS:h,SHOW_LINK_TOOLTIP:m,HIDE_LINK_TOOLTIP:g,GOTO_PAGE:v,OPEN_URL:b};t.setShowLinks=r,t.showLinkTooltip=o,t.hideLinkTooltip=i,t.gotoPage=a,t.openUrl=s},function(e,t,n){"use strict";function r(){return{type:o}}t.__esModule=!0,t.onVisibilityChange=r;var o="ON_VISIBILITY_CHANGE";t.types={ON_VISIBILITY_CHANGE:o}},function(e,t,n){"use strict";t.__esModule=!0,t.ShoppingIcon=void 0;var r=n(314),o=babelHelpers.interopRequireDefault(r);t.ShoppingIcon={draw:function(e,t,n,r){var i=1.8*r;e.save(),e.beginPath(),e.arc(t,n,r,0,2*Math.PI),e.fill(),e.translate(t-i/2,n-i/2),e.scale(i/o.default.w,i/o.default.h),o.default.d[0](e,{stack:0}),e.restore()}}},function(e,t,n){"use strict";t.__esModule=!0,t.VideoPlayIcon=void 0;var r=n(317),o=babelHelpers.interopRequireDefault(r);t.VideoPlayIcon={draw:function(e,t,n,r){var i=1.8*r;e.save(),e.beginPath(),e.arc(t,n,r,0,2*Math.PI),e.fill(),e.translate(t-i/2,n-i/2),e.scale(i/o.default.w,i/o.default.h),o.default.d[0](e,{stack:0}),e.restore()}}},function(e,t,n){"use strict";function r(e,t,n){var r=Math.max(e.x,0),o=Math.min(e.x+e.width,t),i=Math.max(e.y,0),a=Math.min(e.y+e.height,n);return{cappedOriginX:Math.min(r,t),cappedOriginY:Math.min(i,n),cappedWidth:Math.max(0,o-r),cappedHeight:Math.max(0,a-i)}}function o(e,t){var n=Math.floor(e.width),r=t===l?Math.floor(e.x+e.width+.001)-n:Math.floor(e.x),o=Math.floor(e.height);return{x:r,y:Math.floor(e.y),width:n,height:o}}t.__esModule=!0,t.Page=t.RIGHT_PAGE=t.LEFT_PAGE=void 0,t.alignBBox=o;var i=n(316),a=n(319),s=n(312),u=n(47),l=t.LEFT_PAGE=0;t.RIGHT_PAGE=1,t.Page=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.unzoomedWidthInHWPx=0,r.unzoomedHeightInHWPx=0,o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.updateUnzoomedSizes()},t.prototype.componentDidUpdate=function(e){this.props.transform.isEqualWith(e.transform)||this.updateUnzoomedSizes()},t.prototype.updateUnzoomedSizes=function(){var e=this.transform.transformRect(u.CanvasObject.RectPool.get(0,0,this.width,this.height));this.unzoomedWidthInHWPx=Math.floor(e.width),this.unzoomedHeightInHWPx=Math.floor(e.height),u.CanvasObject.RectPool.release(e)},t.prototype.getChildrenToTraverse=function(){return this.props.mayRenderLinks?e.prototype.getChildrenToTraverse.call(this):e.prototype.getChildrenToTraverse.call(this).filter(function(e){return!(e instanceof a.Link)})},t.prototype.getChildTree=function(){var e=this;return[u.CanvasObject.createElement(s.FindResults,{model:this.props.isPaywalled?null:this.model.textInfoPage,results:this.props.isPaywalled?[]:this.model.findResults,selectedResult:this.props.isPaywalled?null:this.model.selectedFindResult,renderManager:this.props.renderManager})].concat(this.model.links.map(function(t){return u.CanvasObject.createElement(a.Link,{arrivedAtSpreadTick:e.props.arrivedAtSpreadTick,dispatch:e.props.dispatch,featureTracker:e.props.featureTracker,hideLinkToolTip:e.props.hideLinkToolTip,isToggledOn:e.props.isLinksToggledOn,model:t,showLinkToolTip:e.props.showLinkToolTip})}))},t.prototype.getOperations=function(e,t,n,i){var a=o(e,i),s=a.x,u=a.y,l=a.width,c=a.height,p=r({x:s,y:u,width:l,height:c},t,n),d=p.cappedOriginX,f=p.cappedOriginY,h=p.cappedWidth,m=p.cappedHeight;if(0===h||0===m)return{ops:null,originX:0,originY:0};var g=[l/this.props.model.width,0,0,c/this.props.model.height,Math.min(0,s),Math.min(0,u)];try{return{ops:this.props.renderManager.render(g,h,m,this.unzoomedWidthInHWPx,this.unzoomedHeightInHWPx,this.pageNumber,this.inAnimation),originX:d,originY:f}}catch(e){var v={matrix:g,cappedWidth:h,cappedHeight:m,unzoomedWidthInHWPx:this.unzoomedWidthInHWPx,unzoomedHeightInHWPx:this.unzoomedHeightInHWPx,pageNumber:this.pageNumber,inAnimation:this.inAnimation};throw e.sentry_extra=babelHelpers.extends({},e.sentry_extra,{renderOps:v}),e}},t.prototype.draw=function(e,t,n){var r=this.getOperations(t,e.canvas.width,e.canvas.height,this.props.pageType),o=r.originX,a=r.originY,s=r.ops;null!==s?s.forEach(function(t){if(!(t.src_px.width<=0||t.src_px.height<=0))try{e.drawImage(t.surface,t.src_px.x,t.src_px.y,t.src_px.width,t.src_px.height,t.dest_px.x+o,t.dest_px.y+a,t.dest_px.width,t.dest_px.height)}catch(e){var n={src_px:t.src_px,dest_px:t.dest_px,width:t.surface.width,height:t.surface.height};throw e.sentry_extra=babelHelpers.extends({},e.sentry_extra,{renderImage:n}),e}}):(e.fillStyle="#f2f2f2",e.fillRect(t.x,t.y,t.width,t.height),i.SpinnerIcon.draw(e,t.x+t.width/2,t.y+t.height/2,n),this.requestRedraw())},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"Page"}},{key:"width",get:function(){return this.props.model.width}},{key:"height",get:function(){return this.props.model.height}},{key:"model",get:function(){return this.props.model}},{key:"pageType",get:function(){return this.props.pageType}},{key:"pageNumber",get:function(){return this.props.model.pageNumber}},{key:"transform",get:function(){return this.props.transform}}]),t}(u.CanvasObject)},function(e,t,n){"use strict";function r(e){return{min:{x:Math.min(e.p1.x,e.p2.x,e.p3.x,e.p4.x),y:Math.min(e.p1.y,e.p2.y,e.p3.y,e.p4.y)},max:{x:Math.max(e.p1.x,e.p2.x,e.p3.x,e.p4.x),y:Math.max(e.p1.y,e.p2.y,e.p3.y,e.p4.y)}}}function o(e){var t=new Float32Array(6*e.length*2);return e.forEach(function(e,n){t[12*n+0]=e.p1.x,t[12*n+1]=e.p1.y,t[12*n+2]=e.p3.x,t[12*n+3]=e.p3.y,t[12*n+4]=e.p2.x,t[12*n+5]=e.p2.y,t[12*n+6]=e.p2.x,t[12*n+7]=e.p2.y,t[12*n+8]=e.p3.x,t[12*n+9]=e.p3.y,t[12*n+10]=e.p4.x,t[12*n+11]=e.p4.y}),t}function i(e){var t=new Float32Array(6*e.length*2);return e.forEach(function(e,n){var o=r(e),i=function(e){return(e-o.min.x)/(o.max.x-o.min.x)},a=function(e){return(o.max.y-e)/(o.max.y-o.min.y)};t[12*n+0]=i(e.p1.x),t[12*n+1]=a(e.p1.y),t[12*n+2]=i(e.p3.x),t[12*n+3]=a(e.p3.y),t[12*n+4]=i(e.p2.x),t[12*n+5]=a(e.p2.y),t[12*n+6]=i(e.p2.x),t[12*n+7]=a(e.p2.y),t[12*n+8]=i(e.p3.x),t[12*n+9]=a(e.p3.y),t[12*n+10]=i(e.p4.x),t[12*n+11]=a(e.p4.y)}),t}t.__esModule=!0,t.Highlights=void 0,t.getBBox=r;var a=n(74),s=n(751),u=babelHelpers.interopRequireDefault(s),l=n(752),c=babelHelpers.interopRequireDefault(l),p=n(759),d=babelHelpers.interopRequireDefault(p),f=n(760),h=babelHelpers.interopRequireDefault(f),m=n(102),g=new Float32Array([1,1,0,.5]),v=new Float32Array([0,0,0,.3]),b=function(){var e=m.mat3.create();return function(t,n){return m.mat3.set(e,2/t,0,0,0,-(2/n),0,-1,1,1)}}(),y=function(){var e=m.vec2.create(),t=m.mat3.create();return function(n,r,o){return m.mat3.translate(t,n,m.vec2.set(e,o.x,o.y)),m.mat3.scale(t,t,m.vec2.set(e,r,r)),m.mat3.translate(t,t,m.vec2.set(e,-o.x,-o.y)),t}}();t.Highlights=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=(0,a.createShader)(t,c.default,u.default),this.selectedShader=(0,a.createShader)(t,h.default,d.default),this.verticeBuffer=t.createBuffer(),this.texCoordBuffer=t.createBuffer(),this.emptyTexture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.emptyTexture),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,1,1,0,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array([255,255,255,255])),t.bindTexture(t.TEXTURE_2D,null)}return e.prototype.draw=function(e,t){var n=this.gl,r=this.shader,i=this.verticeBuffer;n.disable(n.DEPTH_TEST),n.enable(n.STENCIL_TEST),r.bind(),n.bindBuffer(n.ARRAY_BUFFER,i),n.vertexAttribPointer(r.a_vertex,2,n.FLOAT,!1,0,0),n.uniformMatrix3fv(r.u_displayMatrix,!1,b(n.drawingBufferWidth,n.drawingBufferHeight)),t.length&&(n.stencilFunc(n.NEVER,1,1),n.stencilOp(n.REPLACE,n.KEEP,n.KEEP),n.bufferData(n.ARRAY_BUFFER,o(t),n.DYNAMIC_DRAW),n.drawArrays(n.TRIANGLES,0,6*t.length)),n.enable(n.BLEND),n.uniform4fv(r.u_color,v),n.stencilFunc(n.NOTEQUAL,1,1),n.blendFuncSeparate(n.SRC_ALPHA,n.ONE_MINUS_SRC_ALPHA,n.ZERO,n.ONE),n.blendEquation(n.FUNC_ADD),n.bufferData(n.ARRAY_BUFFER,o([{p1:{x:e.x,y:e.y},p2:{x:e.x+e.width,y:e.y},p3:{x:e.x,y:e.y+e.height},p4:{x:e.x+e.width,y:e.y+e.height}}]),n.DYNAMIC_DRAW),n.drawArrays(n.TRIANGLES,0,6),n.enable(n.DEPTH_TEST),n.disable(n.STENCIL_TEST),n.disable(n.BLEND)},e.prototype.drawSelected=function(e,t,n,r){var a=this.gl,s=this.shader,u=this.selectedShader,l=this.verticeBuffer,c=this.texCoordBuffer;if(a.disable(a.DEPTH_TEST),a.bindBuffer(a.ARRAY_BUFFER,l),a.bufferData(a.ARRAY_BUFFER,o(e),a.DYNAMIC_DRAW),a.bindBuffer(a.ARRAY_BUFFER,null),r>1){u.bind();a.uniformMatrix3fv(u.u_displayMatrix,!1,y(b(a.drawingBufferWidth,a.drawingBufferHeight),r,n)),a.bindBuffer(a.ARRAY_BUFFER,l),a.vertexAttribPointer(u.a_vertex,2,a.FLOAT,!1,0,0),a.bindBuffer(a.ARRAY_BUFFER,c),a.bufferData(a.ARRAY_BUFFER,i(e),a.DYNAMIC_DRAW),a.vertexAttribPointer(u.a_texCoord,2,a.FLOAT,!1,0,0),a.activeTexture(a.TEXTURE0),a.uniform1i(u.u_texture,0),a.uniform4fv(u.u_color,g);for(var p=0;p<e.length;p++)a.bindTexture(a.TEXTURE_2D,t[p]&&t[p].texture?t[p].texture:this.emptyTexture),a.drawArrays(a.TRIANGLES,6*p,6)}else a.enable(a.BLEND),s.bind(),a.blendFuncSeparate(a.SRC_ALPHA,a.ONE_MINUS_SRC_ALPHA,a.ZERO,a.ONE),a.blendEquation(a.FUNC_ADD),a.bindBuffer(a.ARRAY_BUFFER,l),a.vertexAttribPointer(s.a_vertex,2,a.FLOAT,!1,0,0),a.uniform4fv(s.u_color,g),a.drawArrays(a.TRIANGLES,0,6*e.length),a.disable(a.BLEND);a.enable(a.DEPTH_TEST)},e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.texCoordBuffer),e.deleteTexture(this.emptyTexture),this.shader.destroy(),this.selectedShader.destroy()},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.Spread=void 0;var r=n(212),o=n(77),i=babelHelpers.interopRequireWildcard(o),a=n(75),s=n(47),u=n(198),l=n(8),c=babelHelpers.interopRequireWildcard(l),p=n(79),d=n(40),f=n(21);t.Spread=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r._lastZoom=1,r._arrivedAtTick=0,r._zoomBeforeStart=1,o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentWillUpdate=function(e){(!this.props.isCurrentSpread&&e.isCurrentSpread||this.props.isCurrentSpread&&0===this._arrivedAtTick)&&(this._arrivedAtTick=this.isAllPagesLoaded()&&e.isSnapped?this.root.tick:0),e.isCurrentSpread||(this._arrivedAtTick=0)},t.prototype.componentDidMount=function(){this.scroller=new r.Scroller(0,0,1,this.width,this.height,this.width,this.height),this.scroller.setSnap(!0,function(e,t,n){var r=void 0;if(n>1){var o=this.width/n,i=this.height/n,a=void 0;a=this.borders.right-this.borders.left<o?this.borders.left-(o-(this.borders.right-this.borders.left))/2:Math.max(Math.min(t,this.borders.right-o),this.borders.left);var s=void 0;s=this.borders.bottom-this.borders.top<i?this.borders.top-(i-(this.borders.bottom-this.borders.top))/2:Math.max(Math.min(e,this.borders.bottom-i),this.borders.top),r={top:s,left:a,zoom:n}}else r={top:0,left:0,zoom:1};return r}.bind(this),!1)},t.prototype.componentDidUpdate=function(e){if(this.props.width!==e.width||this.props.height!==e.height){var t=this.getCenter();this.scroller.resize(t.y*this.height-this.height/this.scroller.zoom/2,t.x*this.width-this.width/this.scroller.zoom/2,this.scroller.zoom,this.width,this.height,this.width,this.height)}this.props.isCurrentSpread&&!e.isCurrentSpread&&this.props.dispatch(c.readerZoomLevelChanged(this.scroller.zoom,this.scroller.isDragging))},t.prototype.onGestureStart=function(e,t,n,r,o){return this.scroller.touchStart(e,t,o),this._zoomBeforeStart=this.scroller.zoom,this.scroller.zoom>1},t.prototype.onGestureChange=function(e,t,n,r,o,a,s){return(1===this.scroller.zoom&&s===i.ZOOM_IN||this.scroller.zoom>1)&&(this.scroller.touchMove(e,t,o,a),this.requestRedraw(),!0)},t.prototype.onGestureEnd=function(e,t){return this.scroller.touchEnd(t,e),this.scroller.isMoving&&this.requestRedraw(),this.scroller.zoom!==this._zoomBeforeStart&&this.props.featureTracker.usage(f.FEATURES.GESTURE_PINCH_ZOOM),this.scroller.zoom>1},t.prototype.onDoubleTap=function(e,t,n){if(this.scroller.zoom>1)this.scroller.scrollTo(0,0,1,n);else{this.props.featureTracker.usage(f.FEATURES.DOUBLE_TAP_ZOOM);var r=this.getViewportCTM().inverse().transformPoint(e,t);this.scroller.scrollTo(r[1]-this.scroller.height/4,r[0]-this.scroller.width/4,2,n)}return this.requestRedraw(),!0},t.prototype.setZoom=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=this.scroller.top+this.scroller.height/this.scroller.zoom/2,r=this.scroller.left+this.scroller.width/this.scroller.zoom/2,o=n-this.scroller.height/e/2,i=r-this.scroller.width/e/2;t?this.scroller.scrollTo(o,i,e,this.root.tick):this.scroller.jumpTo(o,i,e),this.requestRedraw()},t.prototype.getZoom=function(){return this.scroller.zoom},t.prototype.getCenter=function(){return{x:(this.scroller.left+this.scroller.width/this.scroller.zoom/2)/this.scroller.width,y:(this.scroller.top+this.scroller.height/this.scroller.zoom/2)/this.scroller.height}},t.prototype.setCenter=function(e){var t=e.y-this.height/this.scroller.zoom/2,n=e.x-this.width/this.scroller.zoom/2,r=this.scroller.zoom,o=this.scroller.snapFunction(t,n,r);this.scroller.top=o.top,this.scroller.left=o.left},t.prototype.isAllPagesLoaded=function(){for(var e=this.props.pageModels,t=Array.isArray(e),n=0,e=t?e:e[Symbol.iterator]();;){var r;if(t){if(n>=e.length)break;r=e[n++]}else{if(n=e.next(),n.done)break;r=n.value}if(!this.props.renderManager.isPageReady(r.pageNumber))return!1}return!0},t.prototype.getChildTree=function(){var e=this.props.pageModels,t=this.props.width,n=this.props.height,r=e.map(function(e){return e.width}).reduce(function(e,t){return e+t},0),o=Math.max.apply(Math,e.map(function(e){return e.height})),i=(0,p.scaleToFit)(1===e.length&&this.props.readMode===d.DOUBLE_PAGE_SPREAD?e[0].width:r,o,t,n),l=t/i,c=n/i,f=(l-r)/2,h=(c-o)/2;this.borders={top:h*i,right:t-f*i,bottom:n-h*i,left:f*i};var m=f,g=(c-e[0].height)/2,v=(new a.MatrixTransformation).mScale(i).mTranslate(m,g),b=s.CanvasObject.createElement(u.Page,{arrivedAtSpreadTick:this._arrivedAtTick,dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,hideLinkToolTip:this.props.hideLinkToolTip,isLinksToggledOn:this.props.isLinksToggledOn,isPaywalled:this.props.paywalledPageStatus[0],mayRenderLinks:this.props.mayRenderLinks,model:e[0],pageType:u.LEFT_PAGE,showLinkToolTip:this.props.showLinkToolTip,transform:v,renderManager:this.props.renderManager});if(2===e.length){m=f+e[0].width,g=(c-e[1].height)/2;var y=(new a.MatrixTransformation).mScale(i).mTranslate(m,g);return[b,s.CanvasObject.createElement(u.Page,{arrivedAtSpreadTick:this._arrivedAtTick,dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,hideLinkToolTip:this.props.hideLinkToolTip,isLinksToggledOn:this.props.isLinksToggledOn,isPaywalled:this.props.paywalledPageStatus[1],mayRenderLinks:this.props.mayRenderLinks,model:e[1],pageType:u.RIGHT_PAGE,showLinkToolTip:this.props.showLinkToolTip,transform:y,renderManager:this.props.renderManager})]}return b},t.prototype.afterDraw=function(e,t){var n=this.scroller.isAnimating||this.scroller.isDragging||this.scroller.isMoving;this.scroller.update(t),(this.scroller.isAnimating||this.scroller.isDragging||this.scroller.isMoving||n)&&this.requestRedraw(),this.props.isCurrentSpread&&!this._arrivedAtTick&&this.isAllPagesLoaded&&this.forceUpdate(),this._lastZoom!==this.scroller.zoom&&(this._lastZoom=this.scroller.zoom,this.props.dispatch(c.readerZoomLevelChanged(this.scroller.zoom,this.scroller.isDragging)))},babelHelpers.createClass(t,[{key:"zOrder",get:function(){return this.props.isCurrentSpread?1:0}},{key:"displayName",get:function(){return"Spread"}},{key:"transform",get:function(){return this._transform||(this._transform=new a.MatrixTransformation),this._transform.mSetMatrix(this.props.transform.matrix).mScale(this.scroller.zoom).mTranslate(-this.scroller.left,-this.scroller.top),this._transform}},{key:"inAnimation",get:function(){return!!this.scroller.isMoving||this.parent.inAnimation}},{key:"unzoomedBBox",get:function(){return this.props.transform.transformRect(s.CanvasObject.RectPool.get(0,0,this.width,this.height))}}]),t}(s.CanvasObject)},function(e,t,n){"use strict";t.__esModule=!0;t.CloseIcon='\n    <svg width="60%" height="60%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g fill="#F2F2F2">\n                <path d="M16.4456672,18.0003762 L10.3219784,24.1243529 C9.89267388,24.5536776 9.89267388,25.249654 10.3219784,25.6787588 C10.5365207,25.8933112 10.8178877,26.0008073 11.0990349,26.0008073 C11.3804019,26.0008073 11.6617688,25.8933112 11.8763112,25.6787588 L18,19.5547821 L24.1236888,25.6787588 C24.3382312,25.8933112 24.6195981,26.0008073 24.9009651,26.0008073 C25.1821123,26.0008073 25.4634793,25.8933112 25.6780216,25.6787588 C26.1073261,25.249654 26.1073261,24.5536776 25.6780216,24.1243529 L19.5543328,18.0003762 L25.6780216,11.8763994 C26.1073261,11.4472946 26.1073261,10.7510983 25.6780216,10.3219935 C25.2487172,9.89266883 24.5529933,9.89266883 24.1236888,10.3219935 L18,16.4459703 L11.8763112,10.3219935 C11.4470067,9.89266883 10.7512828,9.89266883 10.3219784,10.3219935 C9.89267388,10.7510983 9.89267388,11.4472946 10.3219784,11.8763994 L16.4456672,18.0003762 Z"></path>\n            </g>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0;var r='d="M27.7068284,10.2884629 C27.5277733,10.1097429 27.2813055,10 27.009222,10 L22.990778,10 C22.4509752,10 22,10.4477153 22,11 C22,11.5561352 22.4435864,12 22.990778,12 L26,12 L26,15.009222 C26,15.5490248 26.4477153,16 27,16 C27.5561352,16 28,15.5564136 28,15.009222 L28,10.990778 C28,10.7223751 27.8893106,10.4759332 27.7101145,10.2959709 Z" fill="#F5F5F5" transform="translate(25.000000, 13.000000) rotate(-180.000000) translate(-25.000000, -13.000000)"',o='d="M13.7068284,10.2884629 C13.5277733,10.1097429 13.2813055,10 13.009222,10 L8.99077797,10 C8.45097518,10 8,10.4477153 8,11 C8,11.5561352 8.44358641,12 8.99077797,12 L12,12 L12,15.009222 C12,15.5490248 12.4477153,16 13,16 C13.5561352,16 14,15.5564136 14,15.009222 L14,10.990778 C14,10.7223751 13.8893106,10.4759332 13.7101145,10.2959709 Z" fill="#F5F5F5" transform="translate(11.000000, 13.000000) scale(-1, 1) rotate(-180.000000) translate(-11.000000, -13.000000)"',i='d="M27.7068284,20.2884629 C27.5277733,20.1097429 27.2813055,20 27.009222,20 L22.990778,20 C22.4509752,20 22,20.4477153 22,21 C22,21.5561352 22.4435864,22 22.990778,22 L26,22 L26,25.009222 C26,25.5490248 26.4477153,26 27,26 C27.5561352,26 28,25.5564136 28,25.009222 L28,20.990778 C28,20.7223751 27.8893106,20.4759332 27.7101145,20.2959709 Z" fill="#F5F5F5" transform="translate(25.000000, 23.000000) rotate(-90.000000) translate(-25.000000, -23.000000)"',a='d="M13.7068284,20.2884629 C13.5277733,20.1097429 13.2813055,20 13.009222,20 L8.99077797,20 C8.45097518,20 8,20.4477153 8,21 C8,21.5561352 8.44358641,22 8.99077797,22 L12,22 L12,25.009222 C12,25.5490248 12.4477153,26 13,26 C13.5561352,26 14,25.5564136 14,25.009222 L14,20.990778 C14,20.7223751 13.8893106,20.4759332 13.7101145,20.2959709 Z" fill="#F5F5F5" transform="translate(11.000000, 23.000000) scale(-1, 1) rotate(-90.000000) translate(-11.000000, -23.000000)"';t.ExitFullscreenIcon='\n    <svg width="100%" height="100%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <path '+r+"></path>\n                <path "+o+"></path>\n                <path "+i+"></path>\n                <path "+a+'></path>\n            </g>\n        </g>\n        <path class="shadow" '+r+'></path>\n        <path class="shadow" '+o+'></path>\n        <path class="shadow" '+i+'></path>\n        <path class="shadow" '+a+'></path>\n        <path class="icon" '+r+'></path>\n        <path class="icon" '+o+'></path>\n        <path class="icon" '+i+'></path>\n        <path class="icon" '+a+"></path>\n    </svg>\n"},function(e,t,n){"use strict";t.__esModule=!0;var r='d="M27.7068284,10.2884629 C27.5277733,10.1097429 27.2813055,10 27.009222,10 L22.990778,10 C22.4509752,10 22,10.4477153 22,11 C22,11.5561352 22.4435864,12 22.990778,12 L26,12 L26,15.009222 C26,15.5490248 26.4477153,16 27,16 C27.5561352,16 28,15.5564136 28,15.009222 L28,10.990778 C28,10.7223751 27.8893106,10.4759332 27.7101145,10.2959709 Z"',o='d="M13.7068284,10.2884629 C13.5277733,10.1097429 13.2813055,10 13.009222,10 L8.99077797,10 C8.45097518,10 8,10.4477153 8,11 C8,11.5561352 8.44358641,12 8.99077797,12 L12,12 L12,15.009222 C12,15.5490248 12.4477153,16 13,16 C13.5561352,16 14,15.5564136 14,15.009222 L14,10.990778 C14,10.7223751 13.8893106,10.4759332 13.7101145,10.2959709 Z" transform="translate(11.000000, 13.000000) scale(-1, 1) translate(-11.000000, -13.000000)"',i='d="M27.7068284,20.2884629 C27.5277733,20.1097429 27.2813055,20 27.009222,20 L22.990778,20 C22.4509752,20 22,20.4477153 22,21 C22,21.5561352 22.4435864,22 22.990778,22 L26,22 L26,25.009222 C26,25.5490248 26.4477153,26 27,26 C27.5561352,26 28,25.5564136 28,25.009222 L28,20.990778 C28,20.7223751 27.8893106,20.4759332 27.7101145,20.2959709 Z" transform="translate(25.000000, 23.000000) rotate(-270.000000) translate(-25.000000, -23.000000)"',a='d="M13.7068284,20.2884629 C13.5277733,20.1097429 13.2813055,20 13.009222,20 L8.99077797,20 C8.45097518,20 8,20.4477153 8,21 C8,21.5561352 8.44358641,22 8.99077797,22 L12,22 L12,25.009222 C12,25.5490248 12.4477153,26 13,26 C13.5561352,26 14,25.5564136 14,25.009222 L14,20.990778 C14,20.7223751 13.8893106,20.4759332 13.7101145,20.2959709 Z" transform="translate(11.000000, 23.000000) scale(-1, 1) rotate(-270.000000) translate(-11.000000, -23.000000)"';t.FullscreenIcon='\n    <svg width="100%" height="100%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <path '+r+"></path>\n                <path "+o+"></path>\n                <path "+i+"></path>\n                <path "+a+'></path>\n            </g>\n        </g>\n        <path class="shadow" '+r+'></path>\n        <path class="shadow" '+o+'></path>\n        <path class="shadow" '+i+'></path>\n        <path class="shadow" '+a+'></path>\n        <path class="icon" '+r+'></path>\n        <path class="icon" '+o+'></path>\n        <path class="icon" '+i+'></path>\n        <path class="icon" '+a+"></path>\n    </svg>\n"},function(e,t,n){"use strict";t.__esModule=!0;var r='d="M6.83590808,3.64127016 C5.02752664,3.6236996 3.54764132,5.11190524 3.53049341,6.96464718 C3.5133455,8.81760081 4.96575284,10.3339617 6.77413428,10.3515323 C8.58251571,10.3688911 10.0626076,8.88089718 10.0795489,7.02815524 C10.0966969,5.17520161 8.64428951,3.65862903 6.83590808,3.64127016 L6.83590808,3.64127016 Z M6.78942278,8.69524194 C5.87376569,8.68635081 5.13826495,7.91853831 5.14694221,6.9803125 C5.15561947,6.04208669 5.90496249,5.28845766 6.82061958,5.29734879 C7.73627667,5.30623992 8.4717774,6.07405242 8.46310015,7.01248992 C8.45442289,7.95050403 7.70507987,8.70413306 6.78942278,8.69524194 L6.78942278,8.69524194 Z"',o='d="M6.75843258,0.424375 C6.74830911,0.424375 6.73818565,0.424798387 6.72785558,0.424798387 L6.72785558,0.424163306 L0.856245804,0.424163306 C0.562045511,0.424163306 0.321148361,0.67078629 0.321148361,0.972449597 L0.321148361,7.02053427 C0.321148361,10.6633569 3.2032369,13.6164819 6.75843258,13.6164819 C10.3138349,13.6164819 13.1957168,10.6633569 13.1957168,7.02053427 C13.1957168,3.3775 10.3138349,0.424375 6.75843258,0.424375 L6.75843258,0.424375 Z M2.33592452,6.92929435 C2.35927047,4.40019153 4.37921167,2.36920363 6.84747775,2.39291331 C9.31574383,2.41683468 11.2980836,4.48677419 11.274531,7.01566532 C11.2513917,9.54455645 9.23124389,11.5755444 6.76318441,11.551623 C4.29491833,11.5277016 2.31257857,9.45797379 2.33592452,6.92929435 L2.33592452,6.92929435 Z"',i='d="M1.18803132,0.461209677 C1.75267275,0.461209677 2.22289738,0.943235887 2.22289738,1.52137097 C2.22289738,2.09950605 1.75267275,2.58110887 1.18803132,2.58110887 C0.624009688,2.58110887 0.153578461,2.09950605 0.153578461,1.52137097 C0.153578461,0.943235887 0.624009688,0.461209677 1.18803132,0.461209677 L1.18803132,0.461209677 Z M1.18803132,12.5656351 C0.661197927,12.5656351 0.30419083,12.160877 0.30419083,11.6597984 L0.30419083,4.79775202 C0.30419083,4.29709677 0.680411851,3.89212702 1.18803132,3.89212702 C1.69627059,3.89212702 2.07228501,4.29709677 2.07228501,4.79775202 L2.07228501,11.6597984 C2.07228501,12.160877 1.71486471,12.5656351 1.18803132,12.5656351 L1.18803132,12.5656351 Z"',a='d="M7.56498795,12.6429032 C6.37971612,12.6429032 5.32646254,12.2574093 4.5742271,11.6597984 C4.31101701,11.4478931 4.19779948,11.1587198 4.19779948,10.9080746 C4.19779948,10.522369 4.49902422,10.2715121 4.87524524,10.2715121 C5.17585017,10.2715121 5.36427059,10.3877319 5.57107852,10.5420565 C6.07890458,10.9273387 6.79353858,11.2931452 7.69679959,11.2931452 C8.71265833,11.2931452 9.25808584,10.9080746 9.25808584,10.3104637 C9.25808584,9.65548387 8.73125245,9.40462702 7.41437558,9.03797379 C5.10085389,8.40268145 4.25440825,7.59231855 4.25440825,6.20509073 C4.25440825,4.75943548 5.5522778,3.81485887 7.58399527,3.81485887 C8.35503143,3.81485887 9.2200712,4.00771169 9.91631767,4.35446573 C10.4241437,4.60511089 10.781564,4.91333669 10.781564,5.29904234 C10.781564,5.64579637 10.5935568,5.97392137 10.1045315,5.97392137 C9.85991551,5.97392137 9.61529954,5.858125 9.33328872,5.70337702 C8.80624873,5.41462702 8.22321978,5.26114919 7.54639383,5.26114919 C6.60573797,5.26114919 5.96610026,5.51137097 5.96610026,6.18561492 C5.96610026,6.84144153 6.53053509,7.05292339 7.8848068,7.45789315 C9.91631767,8.05529234 10.9697779,8.61416331 10.9697779,10.1754032 C10.9697779,11.602006 9.80351335,12.6429032 7.56498795,12.6429032"',s='d="M16.0804749,12.6429032 C14.8952031,12.6429032 13.8415363,12.2574093 13.0893009,11.6597984 C12.8258842,11.4478931 12.7130799,11.1587198 12.7130799,10.9080746 C12.7130799,10.522369 13.014098,10.2715121 13.390319,10.2715121 C13.6913372,10.2715121 13.8791378,10.3877319 14.0863589,10.5420565 C14.5939784,10.9273387 15.3086124,11.2931452 16.2114602,11.2931452 C17.2275255,11.2931452 17.772953,10.9080746 17.772953,10.3104637 C17.772953,9.65548387 17.2465328,9.40462702 15.9298626,9.03797379 C13.6159277,8.40268145 12.7696886,7.59231855 12.7696886,6.20509073 C12.7696886,4.75943548 14.0677648,3.81485887 16.0990691,3.81485887 C16.8703118,3.81485887 17.7357648,4.00771169 18.4318047,4.35446573 C18.9392175,4.60511089 19.297051,4.91333669 19.297051,5.29904234 C19.297051,5.64579637 19.1088372,5.97392137 18.6193987,5.97392137 C18.3749893,5.97392137 18.1303733,5.858125 17.8485691,5.70337702 C17.3219423,5.41462702 16.7385002,5.26114919 16.0614676,5.26114919 C15.1208118,5.26114919 14.4813806,5.51137097 14.4813806,6.18561492 C14.4813806,6.84144153 15.0454023,7.05292339 16.4000872,7.45789315 C18.4318047,8.05529234 19.4850582,8.61416331 19.4850582,10.1754032 C19.4850582,11.602006 18.3185871,12.6429032 16.0804749,12.6429032"',u='d="M21.1926182,8.61416331 L21.1926182,4.79775202 C21.1926182,4.29709677 21.5878466,3.89212702 22.0768719,3.89212702 C22.5658973,3.89212702 22.9611256,4.29709677 22.9611256,4.79775202 L22.9611256,8.82606855 C22.9611256,10.0409778 23.8823609,10.9849194 25.1246547,10.9849194 C26.3659155,10.9849194 27.3063648,10.0409778 27.3063648,8.82606855 L27.3063648,4.79775202 C27.3063648,4.29709677 27.7015931,3.89212702 28.1902052,3.89212702 C28.679024,3.89212702 29.0740457,4.29709677 29.0740457,4.79775202 L29.0740457,8.61416331 C29.0740457,10.8697581 27.4001618,12.6429032 25.1246547,12.6429032 C22.8481147,12.6429032 21.1926182,10.8697581 21.1926182,8.61416331"',l='d="M31.0324197,8.61416331 L31.0324197,4.79775202 C31.0324197,4.29709677 31.4272349,3.89212702 31.9164668,3.89212702 C32.405079,3.89212702 32.8003073,4.29709677 32.8003073,4.79775202 L32.8003073,8.82606855 C32.8003073,10.0409778 33.7225756,10.9849194 34.9636298,10.9849194 C36.2048906,10.9849194 37.1455465,10.0409778 37.1455465,8.82606855 L37.1455465,4.79775202 C37.1455465,4.29709677 37.5407748,3.89212702 38.0298002,3.89212702 C38.5192387,3.89212702 38.9136406,4.29709677 38.9136406,4.79775202 L38.9136406,8.61416331 C38.9136406,10.8697581 37.2401699,12.6429032 34.9636298,12.6429032 C32.6872964,12.6429032 31.0324197,10.8697581 31.0324197,8.61416331"';t.IssuuLogo='\n<svg width="100%" height="100%" viewBox="-2 0 60 14">\n    <g class="logo__icon">\n        <path class="shadow" '+r+'></path>\n        <path class="shadow" '+o+'></path>\n        <path class="icon" '+r+'></path>\n        <path class="icon" '+o+'></path>\n    </g>\n    <g class="logo__title" transform="translate(17.000000, 0.000000)">\n        <path class="shadow" '+i+'></path>\n        <path class="shadow" '+a+'></path>\n        <path class="shadow" '+s+'></path>\n        <path class="shadow" '+u+'></path>\n        <path class="shadow" '+l+'></path>\n\n        <path class="icon" '+i+'></path>\n        <path class="icon" '+a+'></path>\n        <path class="icon" '+s+'></path>\n        <path class="icon" '+u+'></path>\n        <path class="icon" '+l+"></path>\n    </g>\n</svg>\n"},function(e,t,n){"use strict";t.__esModule=!0;t.SpinnerIcon='\n    <svg width="100%" height="100%" viewBox="0 0 24 24">\n        <g class="spinner__icon" fill-rule="evenodd">\n            <g transform="translate(7.000000, 7.000000)">\n                    <path d="M6.77787915,6.84548427 C5.79003176,7.83333166 4.18814246,7.83322341 3.2001563,6.84523725 C2.21223953,5.85732047 2.21223953,4.25567819 3.2001563,3.26776142 C4.18822365,2.27969408 5.7896189,2.27974819 6.77763213,3.26776142 C7.76571475,4.25584404 7.76587711,5.8574863 6.77787915,6.84548427 L8.24993998,8.31754509 C10.0510015,6.51648357 10.0507055,3.59671316 8.24969296,1.79570059 C6.44870526,-0.00528710987 3.52918184,-0.00538576575 1.72809548,1.79570059 C-0.0728180424,3.59661411 -0.0728180424,6.51638456 1.72809548,8.31729807 C3.52903385,10.1182364 6.4490513,10.1184338 8.24993998,8.31754509 L6.77787915,6.84548427 L6.77787915,6.84548427 Z"></path>\n            </g>\n            <path d="M12,23 C18.0751322,23 23,18.0751322 23,12 C23,5.92486775 18.0751322,1 12,1 C5.92486775,1 1,5.92486775 1,12 C1,18.0751322 5.92486775,23 12,23 Z M12,20.0250244 C16.4320986,20.0250244 20.0250244,16.4320986 20.0250244,12 C20.0250244,7.5679014 16.4320986,3.97497559 12,3.97497559 C7.5679014,3.97497559 3.97497559,7.5679014 3.97497559,12 C3.97497559,16.4320986 7.5679014,20.0250244 12,20.0250244 Z" fill-opacity="0.5"></path>\n            <path d="M3.97746854,12.2020107 C3.88040309,13.3666506 2.94475898,13.6536116 2.48144531,13.6567993 C1.99243164,13.6601639 0.999999997,13.1174211 1,12 C1.00000002,5.92486775 5.92486775,1 12,1 C18.0751322,1 23,5.92486775 23,12 C23,13.1278573 22.0378909,13.5112302 21.5430908,13.5112305 C21.0482908,13.5112307 20.0457764,13.2033275 20.0457764,12 C20.0457764,11.9485283 20.0382948,11.8986091 20.0236545,11.8502139 C19.9437915,7.48723335 16.3820616,3.97497559 12,3.97497559 C7.5679014,3.97497559 3.97497559,7.5679014 3.97497559,12 C3.97497559,12.067535 3.97580982,12.1348751 3.97746854,12.2020107 Z"></path>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0;t.WarningIcon='\n    <svg width="36" height="31" viewBox="0 0 36 31" xmlns="http://www.w3.org/2000/svg">\n        <title>Group</title>\n        <g fill="#9AA8A9" fill-rule="evenodd" opacity=".3">\n            <path d="M32.333 30.77H3.267c-1.1 0-2.1-.564-2.667-1.53-.533-.964-.533-2.095.033-3.06L15.5 1.464C16.067.532 17.033 0 18.133 0 19.2 0 20.2.566 20.767 1.464l14.5 24.118c.633 1.064.666 2.362.033 3.46-.6 1.097-1.7 1.73-2.967 1.73zm-14.2-28.475c-.133 0-.433.034-.633.333L2.667 27.378c-.2.333-.067.6 0 .732.066.133.233.366.633.366h29.033c.567 0 .867-.4.967-.566.1-.166.3-.6 0-1.098L18.767 2.663c-.2-.333-.5-.367-.634-.367z"/><path d="M18.133 20.825c-.633 0-1.166-.533-1.166-1.165v-8.15c0-.632.533-1.164 1.166-1.164.634 0 1.167.532 1.167 1.164v8.15c0 .666-.5 1.165-1.167 1.165zM18.133 25.05c-.633 0-1.166-.533-1.166-1.165v-.665c0-.632.533-1.165 1.166-1.165.634 0 1.167.533 1.167 1.165v.665c0 .665-.5 1.164-1.167 1.164z"/>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";function r(e,t){return Math.min(Math.max(e/t*100,0),100)}t.__esModule=!0,t.Slider=void 0;var o=n(2),i=babelHelpers.interopRequireDefault(o),a=n(85),s=babelHelpers.interopRequireDefault(a),u=n(46),l=babelHelpers.interopRequireDefault(u),c=n(58),p=n(78),d=t.Slider=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r._hover=!1,o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.container=s.default.findDOMNode(this.refs.container),this.inputHandler=new p.InputHandler(this.container,{onGestureStart:function(t,n){e.props.locked||(e._containerWidth=e.container.clientWidth,e.props.onChangeStart(),e.props.onChange(r(t[0].x,e._containerWidth)))},onGestureChange:function(t,n,o,i){e.props.locked||(e.inputHandler.requestToIntercept(),e.props.onChange(r(t[0].x,e._containerWidth)))},onGestureEnd:function(t){e.props.locked||e.props.onChangeEnd(e.props.value)},onMouseEnter:function(){e._hover=!0,e.container.classList.toggle("slider--hover",e._hover)},onMouseLeave:function(){e._hover=!1,e.container.classList.toggle("slider--hover",e._hover)}})},t.prototype.shouldComponentUpdate=function(e){return!(0,l.default)(this.props,e)},t.prototype.render=function(){var e=["slider"];this._hover&&e.push("slider--hover"),this.props.type===t.SLIDER_TYPE_ALTERNATE&&e.push("slider--alternate"),this.props.locked&&e.push("slider--locked");var n=!1;return i.default.createElement("div",{className:e.join(" "),ref:"container"},i.default.createElement("div",{className:"slider__track-container-container"},i.default.createElement("div",{className:"slider__track-container"},this.props.segments.map(function(e,t){var r=["slider__track"];e.available||r.push("slider__track--unavailable"),e.done&&r.push("slider__track--done");var o={flex:e.proportion},a=!n&&!e.done;return a&&(n=!0),i.default.createElement("div",{key:t,className:r.join(" "),style:o},a&&i.default.createElement("div",{className:"slider__thumb"}))}),!n&&i.default.createElement("div",{className:"slider__thumb slider__thumb--end"}),this.props.markers&&!!this.props.markers.length&&i.default.createElement(c.components.SliderMarkers,{markers:this.props.markers,value:this.props.value}))),i.default.createElement("span",{style:{position:"absolute",visibility:"hidden"}},this.props.value))},t}(o.Component);d.displayName="Slider",d.SLIDER_TYPE_DEFAULT="SLIDER_TYPE_DEFAULT",d.SLIDER_TYPE_ALTERNATE="SLIDER_TYPE_ALTERNATE"},function(e,t,n){"use strict";t.__esModule=!0;t.INFO="info",t.DOWNLOAD="download"},function(e,t,n){"use strict";t.__esModule=!0;t.ESCAPE=27,t.HOME=36,t.END=35,t.SPACE=32,t.D=68,t.E=69,t.F=70,t.I=73,t.LEFT=37,t.RIGHT=39,t.UP=38,t.DOWN=40,t.FORWARD_SLASH=191},function(e,t,n){"use strict";t.__esModule=!0;t.INITIALIZED="loading-status@INITIALIZED",t.LOADING="loading-status@LOADING",t.FAILED="loading-status@FAILED",t.SUCCESS="loading-status@SUCCESS"},function(e,t,n){"use strict";t.__esModule=!0;t.TINY="reader-sizes@TINY",t.SMALL="reader-sizes@SMALL",t.NORMAL="reader-sizes@NORMAL"},function(e,t,n){"use strict";function r(e,t,n){var r=Math.max(1,n);return{x:-t.x/r*.6+.4*e.x,y:-t.y/r*.6+.4*e.y}}function o(e){return Math.sqrt(e.x*e.x+e.y*e.y)}function i(e,t,n,r,o,i,a){return{top:Math.max(Math.min(e,a-o/n),0),left:Math.max(Math.min(t,i-r/n),0),zoom:Math.max(Math.min(n,s.MAX_ZOOM_LEVEL),s.MIN_ZOOM_LEVEL)}}function a(e,t,n){for(var r=0,o=e.x,i=e.y,a=0,s=0;Math.sqrt(o*o+i*i)>t;)r+=u,o*=n,i*=n,a+=o*u,s+=i*u;return{duration:r,distanceX:a,distanceY:s}}t.__esModule=!0,t.Scroller=void 0;var s=n(57),u=1e3/60,l=1/u,c=.1/u,p=6/u,d=Math.ceil(250/u)*u,f=function(e){return Math.pow(e-1,3)+1},h=function(e){var t=2*e;return t<1?.5*Math.pow(t,3):.5*(Math.pow(t-2,3)+2)},m=function(e){return 1-Math.pow(2,-10*e)};t.Scroller=function(){function e(t,n,r,o,i,a,s){babelHelpers.classCallCheck(this,e),this.top=t,this.left=n,this.zoom=r,this.width=o,this.height=i,this.contentWidth=a,this.contentHeight=s,this.snap=!1,this.snapFunction=function(){},this.scrollingX=!0,this.scrollingY=!0,this._lastUpdate={left:n,top:t,zoom:r},this._isMoving=!1,this._lastTouchPosition={x:0,y:0},this._initialZoomLevel=1,this._lastTouchTime=0,this._velocity={x:0,y:0},this._animate=!1,this._isDragging=!1,this._lastMoveTs=0}return e.prototype.touchStart=function(e,t,n){this._lastTouchPosition.x=e,this._lastTouchPosition.y=t,this._initialZoomLevel=this.zoom,this._lastTouchTime=n,this._velocity={x:0,y:0},this._animate=!1},e.prototype.touchMove=function(e,t,n,o){var i=this._lastTouchPosition,a=n-this._lastTouchTime,u=this.top,l=this.left,c=this.zoom;if(o){var p=this.zoom;c=Math.max(Math.min(o*this._initialZoomLevel,s.MAX_ZOOM_LEVEL),s.MIN_ZOOM_LEVEL),c!==p&&(l+=e/p-e/c,u+=t/p-t/c)}var d={x:(e-i.x)/c,y:(t-i.y)/c};this.scrollingX||1!==c||(d.x=0),this.scrollingY||1!==c||(d.y=0),l-=1*d.x,(l>this.contentWidth-this.width/c||l<0)&&(l+=.8*d.x*1),((u-=1*d.y)>this.contentHeight-this.height/c||u<0)&&(u+=.8*d.y*1);var f=r(this._velocity,d,a);this._isDragging=!0,this.left=l,this.top=u,this.zoom=c,this._velocity=f,this._lastTouchPosition.x=e,this._lastTouchPosition.y=t,this._lastTouchTime=n},e.prototype.touchEnd=function(e,t){var n=this._velocity,r=(this.snap?p:l)/this.zoom;if(this._isDragging=!1,o(n)>r){var s=this.zoom,u=(this.snap?p:c)/s,f=a(n,u,1-.11/s),h=f.duration,m=f.distanceX,g=f.distanceY,v=this.left+m,b=this.top+g,y=this.snap?this.snapFunction(b,v,s):i(b,v,s,this.width,this.height,this.contentWidth,this.contentHeight),_=Math.sqrt(Math.pow(m,2)+Math.pow(g,2));this.animateToPosition(y.top,y.left,y.zoom,t,h*(Math.sqrt(Math.pow(b-y.top,2)+Math.pow(v-y.left,2))+_)/_,"EASING_OUT_EXPO")}else this.animateToPosition(this.top,this.left,this.zoom,t,d)},e.prototype.scrollTo=function(e,t,n,r){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:d;this.animateToPosition(e,t,n||this.zoom,r,o)},e.prototype.jumpTo=function(e,t,n){var r=i(e,t,n||this.zoom,this.width,this.height,this.contentWidth,this.contentHeight);if(this.snap){var o=this.snapFunction(r.top,r.left,r.zoom);this.top=o.top,this.left=o.left,this.zoom=o.zoom}else this.top=r.top,this.left=r.left,this.zoom=r.zoom},e.prototype.setSnap=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(t&&(this.snapFunction=t),e&&!this.snap){if(!this.snapFunction)throw new Error("Cannot snap without snap function!");if(this.snap=e,n)this.animateToPosition(this.top,this.left,this.zoom,r,d);else{var o=this.snapFunction(this.top,this.left,this.zoom);this.top=o.top,this.left=o.left,this.zoom=o.zoom}}else this.snap=e},e.prototype.setScrolling=function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.scrollingX=e,this.scrollingY=t},e.prototype.resize=function(e,t,n,r,o,i,a){if(this.top=e,this.left=t,this.zoom=n,this.width=r,this.height=o,this.contentWidth=i,this.contentHeight=a,this.snap){var s=this.snapFunction(e,t,n);this.top=s.top,this.left=s.left,this.zoom=s.zoom}},e.prototype.isSnapped=function(){if(!this.snapFunction)return!0;var e=this.snapFunction(this.top,this.left,this.zoom);return Math.abs(e.left-this.left)<1&&Math.abs(e.top-this.top)<1&&Math.abs(e.zoom-this.zoom)<.2},e.prototype.update=function(e){var t=this._animate;if(this._animate){var n=this._animation,r=n.start,o=n.end,i=n.startTime,a=n.duration,s=n.easing,u=o.left-r.left,l=o.top-r.top,c=Math.min(e-i,a),p=Math.max(c/a,0);p<1&&p>0&&("EASING_OUT"===s?p=f(p):"EASING_IN_OUT"===s?p=h(p):"EASING_OUT_EXPO"===s&&(p=m(p)));var d=r.left+u*p,g=r.top+l*p,v=this.width/o.zoom-this.width/r.zoom,b=this.width/r.zoom+v*p,y=this.width/b;this.left=d,this.top=g,this.zoom=y,this._animate=c<a}this._lastUpdate.left===this.left&&this._lastUpdate.top===this.top&&this._lastUpdate.zoom===this.zoom||(this._lastMoveTs=e),this._isMoving=t||this._isDragging&&e-this._lastMoveTs<100,this._lastUpdate.left=this.left,this._lastUpdate.top=this.top,this._lastUpdate.zoom=this.zoom},e.prototype.getHorizontalPositionInPercent=function(){var e=Math.max(Math.min(100*this.left/(this.contentWidth-this.width),100),0);return Number.isFinite(e)?e:0},e.prototype.animateToPosition=function(e,t,n,r,o,a){var s=i(e,t,n,this.width,this.height,this.contentWidth,this.contentHeight),u=s.top,l=s.left,c=s.zoom;if(this.snap){var p=this.snapFunction(u,l,c);u=p.top,l=p.left,c=p.zoom}if(l===this.left&&u===this.top&&c===this.zoom)return void(this._animate=!1);this._animation={startTime:r,easing:a||(this._animate?"EASING_OUT":"EASING_IN_OUT"),duration:o,start:{top:this.top,left:this.left,zoom:this.zoom},end:{top:u,left:l,zoom:c}},this._animate=!0},babelHelpers.createClass(e,[{key:"isDragging",get:function(){return this._isDragging}},{key:"isAnimating",get:function(){return this._animate}},{key:"isMoving",get:function(){return this._isMoving||this._animate}}]),e}()},function(e,t,n){"use strict";t.__esModule=!0,t.shouldRenderInfoButton=t.shouldRenderDownloadButton=t.visibleDropdown=void 0;var r=n(33),o=n(48),i=n(41),a=n(11);t.visibleDropdown=function(e){return e.headerControls.visibleDropdown},t.shouldRenderDownloadButton=(0,r.createSelector)((0,a.selectFeature)(i.DOWNLOAD_TYPE),function(e){return e.documentModel.downloadable},a.selectShowCTAOverlay,function(e,t,n){return!(!e||!t||n)}),t.shouldRenderInfoButton=(0,r.createSelector)((0,a.selectFeature)(i.INFO_DIALOG_TYPE),a.selectShowCTAOverlay,a.selectFullscreenEnabled,o.selectors.isPreview,function(e,t,n,r){return!(!e||r||t||e.hideWhenNotInFullscreen&&!n)})},function(e,t,n){"use strict";t.__esModule=!0,t.isRightArrowVisible=t.isLeftArrowVisible=t.isNavigationArrowsVisible=void 0;var r=n(33),o=n(11),i=babelHelpers.interopRequireWildcard(o),a=n(109),s=babelHelpers.interopRequireWildcard(a),u=n(41),l=t.isNavigationArrowsVisible=(0,r.createSelector)(i.selectFeature(u.NAVIGATION_ARROWS_TYPE),i.isControlsVisible,i.moreOverlayVisible,i.selectShowCTAOverlay,s.selectShowAsOverlay,function(e){return e.reader.zoomLevel},function(e,t,n,r,o,i){return!!e&&((!o||!n)&&(t||r||1===i))});t.isLeftArrowVisible=(0,r.createSelector)(l,i.isFirstSpread,i.selectCurrentSpreadIndex,function(e,t,n){return e&&!t&&n>-1}),t.isRightArrowVisible=(0,r.createSelector)(l,i.isLastSpread,i.selectCurrentSpreadIndex,function(e,t,n){return e&&!t&&n>-1})},function(e,t,n){"use strict";t.__esModule=!0;var r=function(e){return e.documentModel||{}};t.selectPublicationTitle=function(e){return r(e).title},t.selectPublicationName=function(e){return r(e).documentName},t.selectPublicationCoverUrl=function(e){return"https://"+e.config.hosts.image+"/"+r(e).documentId+"/jpg/page_1.jpg"},t.selectPublicationPageCount=function(e){return r(e).pageCount}},function(e,t,n){"use strict";t.__esModule=!0;var r=function(e){return e.documentModel||{}},o=(t.selectPublisherDisplayName=function(e){return r(e).userDisplayName},t.selectPublisherName=function(e){return r(e).username});t.selectPublisherProfileImageUrl=function(e){return"https://"+e.config.hosts.photo+"/"+o(e)+"/photo_large.jpg"},t.selectPublisherProfileUrl=function(e){return"https://"+e.config.hosts.main+"/"+o(e)}},function(e,t,n){"use strict";function r(){var e=navigator.userAgent,t=new RegExp("^Mozilla/5\\.0.*Android.*AppleWebKit.*Chrome/(\\d+).*$","i"),n=t.exec(e),r=!1;if(n&&n.length>0){r=parseInt(n[1],10)<=33}return r}function o(e,t){"onmsfullscreenchange"in document||"msfullscreenerror"in document?document["on"+e]=t:document.addEventListener(e,t)}function i(e,t){"onmsfullscreenchange"in document||"msfullscreenerror"in document?document["on"+e]=null:document.removeEventListener(e,t)}function a(){if(r())return!1;var e=p.enabled.filter(function(e){return e in document})[0];return Boolean(document[e])}function s(){var e=p.element.filter(function(e){return e in document})[0];if(e)return document[e];throw new Error("Fullscreen not supported")}function u(){return new Promise(function(e,t){try{var n=p.change.filter(function(e){return"on"+e in document})[0];if(n){o(n,function t(){s()||(i(n,t),e(!0))})}else t("native fullscreen api not supported")}catch(e){t(e)}})}function l(e){return new Promise(function(t,n){try{var r=p.request.filter(function(t){return t in e})[0],a=p.change.filter(function(e){return"on"+e in document})[0];if(r&&a){o(a,function e(){i(a,e),t(!0)}),e[r]()}else n("native fullscreen api not supported")}catch(e){n(e)}})}function c(){return new Promise(function(e,t){try{var n=p.exit.filter(function(e){return e in document})[0],r=p.change.filter(function(e){return"on"+e in document})[0];if(n)if(s()){var a=function t(){i(r,t),e(!0)};o(r,a),document[n]()}else e(!0);else t("native fullscreen api not supported")}catch(e){t(e)}})}t.__esModule=!0,t.isFullscreenAPISupported=a,t.getFullscreenElement=s,t.waitForExitFullscreen=u,t.enterFullscreen=l,t.exitFullscreen=c;var p={request:["requestFullscreen","webkitRequestFullscreen","webkitRequestFullScreen","mozRequestFullScreen","msRequestFullscreen"],exit:["exitFullscreen","webkitCancelFullScreen","webkitExitFullscreen","mozCancelFullScreen","msExitFullscreen"],enabled:["fullscreenEnabled","webkitFullscreenEnabled","mozFullScreenEnabled","msFullscreenEnabled"],element:["fullscreenElement","webkitFullscreenElement","webkitCurrentFullScreenElement","mozFullScreenElement","msFullscreenElement"],change:["fullscreenchange","webkitfullscreenchange","mozfullscreenchange","msfullscreenchange"],error:["fullscreenerror","webkitfullscreenerror","mozfullscreenerror","msfullscreenerror"]}},function(e,t,n){"use strict";function r(e,t,n,o){if(void 0===t.layersInfo){var i=""+e.getScheme()+t.imageUri;return(0,l.loadImageAsLayer)(i,t.pageNumber,{width:t.width,height:t.height,loadStatsTracker:n})}var a=""+e.getScheme()+t.layersInfo.uri;return(0,l.loadLayers)(a,t.pageNumber,t.layersInfo.version,{withCredentials:o.includes(t.pageNumber),loadStatsTracker:n}).catch(function(i){return i&&i.skipTracking||(0,u.captureException)(i,{fingerprint:["load-layer-error"],level:"warning",extra:{layers_failed:!0}}),n.onLayersImageFallback(),t.layersInfo=void 0,r(e,t,n,o)})}function o(e,t,n,i,a){var s=t.pageNumber-1;switch(n[s].state){case p:return h<c.MAX_CONCURRENT_REQUESTS&&(h++,n[s]={state:d},r(e,t,i,a).then(function(e){n[s]={state:f,data:e},h--},function(){})),null;case d:return null;case f:return n[s].data.images.some(function(e){return 0===e.width||0===e.height})?(n[s]={state:p},o(e,t,n,i,a)):n[s].data;default:return null}}function i(e,t,n){var r=Math.round(e[0]*n.width),o=Math.round(t[0]*n.width),i=Math.round(e[3]*n.height),a=Math.round(t[3]*n.height);return r-o==0&&i-a==0}function a(e,t,n){return e[4]===t[4]&&e[5]===t[5]&&i(e,t,n)}function s(e,t,n,r){e.forEach(function(o,i){var a=e[i],s=t[i],l=a.src_px.x<0||a.src_px.width<=0||a.src_px.x+a.src_px.width>s.width_px,c=a.src_px.y<0||a.src_px.height<=0||a.src_px.y+a.src_px.height>s.height_px,p=a.dest_px.x<0||a.dest_px.width<=0||a.dest_px.x+a.dest_px.width>n,d=a.dest_px.y<0||a.dest_px.height<=0||a.dest_px.y+a.dest_px.height>r;if(l||c||p||d){(0,u.captureMessage)("Ops Validation failed",{fingerprint:["render-manager","operations-validation-failed"],level:"warning",extra:{ops_validation:{idx:i,src_x:a.src_px.x,src_y:a.src_px.y,src_w:a.src_px.width,src_h:a.src_px.height,s_w:s.width_px,s_h:s.height_px,dst_x:a.dest_px.x,dst_y:a.dest_px.y,dst_w:a.dest_px.width,dst_h:a.dest_px.height,d_w:n,d_h:r}},stacktrace:!0})}})}t.__esModule=!0,t.Render=void 0;var u=n(92),l=n(108),c=n(57),p=0,d=1,f=2,h=0;t.Render=function(){function e(t,n,r,o,i){babelHelpers.classCallCheck(this,e),this.config={},this.resources=[],this.renderer=t,this.pageModels=n,this.config=r,this.loadStatsTracker=o,this.pageNumbersThatNeedsCredentials=i,this.pageData=new Array(n.length).fill({state:p}),this.resources=[]}return e.prototype.getResource=function(e){var t=e%6,n=this.resources[t];return void 0===n&&(n={},this.resources[t]=n),n},e.prototype.renderUncached=function(e,t,n,r){var i=this.renderer,a=r-1,s=o(this.config,this.pageModels[a],this.pageData,this.loadStatsTracker,this.pageNumbersThatNeedsCredentials);return s?(e[0]*=this.pageModels[a].width/s.width,e[3]*=this.pageModels[a].height/s.height,i.draw(null,s,e,t,n,!0,null)):null},e.prototype.render=function(e,t,n,r,u,l,c){var p=this.renderer,d=l-1,f=o(this.config,this.pageModels[d],this.pageData,this.loadStatsTracker,this.pageNumbersThatNeedsCredentials);if(!f)return null;e[0]*=this.pageModels[d].width/f.width,e[3]*=this.pageModels[d].height/f.height;var h=this.getResource(d);if(c){if(!h.preview||h.preview.page!==d){var m=r/f.width,g=u/f.height,v=[m,0,0,g,0,0];this.loadStatsTracker.onFontRenderingStart();var b=h.preview;h.preview={state:p.draw(b&&b.state,f,v,r,u,!1,this.loadStatsTracker),matrix:v,width_px:r,height_px:u,page:d}}var y=h.preview;if(!y)return[];var _=-e[4]/e[0]*y.matrix[0],E=-e[5]/e[3]*y.matrix[3],w=t/e[0]*y.matrix[0],S=n/e[3]*y.matrix[3],x=[{surface:p.getSurface(y.state),src_px:{x:_,y:E,width:Math.min(w+_,y.width_px)-_,height:Math.min(S+E,y.height_px)-E},dest_px:{x:0,y:0,width:t,height:n}}],T=[y],C=h.hires;if(C&&C.page===d&&i(C.matrix,e,f)){var I=Math.floor(C.matrix[4]-e[4]),R=Math.floor(C.matrix[5]-e[5]),M=Math.max(I,0),P=Math.max(R,0),O=Math.max(-I,0),A=Math.max(-R,0),D=Math.min(C.width_px-M,t-O),k=Math.min(C.height_px-P,n-A);if(D>0&&k>0){x.push({surface:p.getSurface(C.state),src_px:{x:M,y:P,width:D,height:k},dest_px:{x:O,y:A,width:D,height:k}}),T.push(C)}}return s(x,T,t,n),x}var N=h.hires;return N&&N.page===d&&N.width_px===t&&N.height_px===n&&a(e,N.matrix,f)||(N={state:p.draw(N&&N.state,f,e,t,n,!0,this.loadStatsTracker),matrix:e,width_px:t,height_px:n,page:d},h.hires=N),[{surface:p.getSurface(N.state),src_px:{x:0,y:0,width:t,height:n},dest_px:{x:0,y:0,width:t,height:n}}]},e.prototype.reusePageData=function(e){this.pageData=e.pageData},e.prototype.isPageReady=function(e){return this.pageData[e-1].state===f},e.prototype.setActivePages=function(e){var t=this;e.forEach(function(e){return o(t.config,t.pageModels[e-1],t.pageData,t.loadStatsTracker,t.pageNumbersThatNeedsCredentials)});for(var n=e[e.length-1]+2;n>e[0]-2;n--)n>0&&n<=this.pageModels.length&&o(this.config,this.pageModels[n-1],this.pageData,this.loadStatsTracker,this.pageNumbersThatNeedsCredentials);this.pageData.forEach(function(t,n){t.state!==f||e.includes(n+1)||(delete t.data,t.state=p)})},e.prototype.release=function(){var e=this.renderer;this.resources.forEach(function(t){if(t){var n=t.hires;n&&e.release(n.state);var r=t.preview;r&&e.release(r.state)}}),this.resources=[]},e}()},function(e,t,n){"use strict";function r(){var e=["webkit","moz","ms","o"];if("hidden"in document)return"hidden";for(var t=0;t<e.length;t++)if(e[t]+"Hidden"in document)return e[t]+"Hidden";return null}function o(){var e=r();return!!e&&!!document[e]}function i(){return!!r()}function a(e){var t=r();if(t){var n=t.replace(/[H|h]idden/,"")+"visibilitychange";document.addEventListener(n,e)}}t.__esModule=!0,t.isVisibilityAPISupported=i,t.isHidden=o,t.listenToVisibilityChangeEvent=a},function(e,t,n){"use strict";t.__esModule=!0;t.Animation=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this.start=t,this.duration=n,this.options=Object.assign(r||{},{easing:e.LINEAR,clipStart:!0,clipEnd:!0,reverse:!1})}return e.LINEAR=function(e,t,n,r){return n*e/r+t},e.EASE_IN_CUBIC=function(e,t,n,r){return e/=r,n*e*e*e+t},e.EASE_OUT_CUBIC=function(e,t,n,r){return e/=r,e--,n*(e*e*e+1)+t},e.EASE_IN_OUT_CUBIC=function(e,t,n,r){return(e/=r/2)<1?n/2*e*e*e+t:(e-=2,n/2*(e*e*e+2)+t)},e.calc=function(t,n,r){return(arguments.length>3&&void 0!==arguments[3]?arguments[3]:e.LINEAR)(t-n,0,1,r)},e.prototype.reset=function(e){return this.start=e,this},e.prototype.isRunning=function(e){return e>=this.start&&e<=this.start+this.duration},e.prototype.isWaitingToRun=function(e){return e<this.start},e.prototype.value=function(t){var n=e.calc(t,this.start,this.duration,this.options.easing);return this.options.clipStart&&n<0?n=0:this.options.clipEnd&&n>1&&(n=1),this.options.reverse&&(n=1-n),n},e}()},function(e,t,n){"use strict";function r(e,t){return e&&e.kind===o.FULLSCREEN_KIND.FALLBACK||t}t.__esModule=!0,t.isInFullscreen=r;var o=n(41)},function(e,t,n){"use strict";function r(e,t,n,r){var s=window.matchMedia("(orientation: portrait)").matches,u=i.device.isMobile()||i.device.isTablet(),l=i.device.isMobile()&&s,c=u&&s;switch(r.responsiveModeWhen){case o.RESPONSIVE.HANDHELD_IN_PORTRAIT_FULLSCREEN:if(c&&n)return o.SINGLE_PAGE_SPREAD;break;case o.RESPONSIVE.HANDHELD_IN_PORTRAIT:if(c)return o.SINGLE_PAGE_SPREAD;break;case o.RESPONSIVE.PHONE_ISH_IN_PORTRAIT:var p=480*(0,a.getDPR)();if(l||e<=p&&e<t)return o.SINGLE_PAGE_SPREAD}return r.defaultMode}t.__esModule=!0,t.getReadMode=r;var o=n(40),i=n(95),a=n(35)},function(e,t,n){var r=n(36);e.exports=function(e,t){if("number"!=typeof e&&"Number"!=r(e))throw TypeError(t);return+e}},function(e,t,n){"use strict";var r=n(18),o=n(71),i=n(17);e.exports=[].copyWithin||function(e,t){var n=r(this),a=i(n.length),s=o(e,a),u=o(t,a),l=arguments.length>2?arguments[2]:void 0,c=Math.min((void 0===l?a:o(l,a))-u,a-s),p=1;for(u<s&&s<u+c&&(p=-1,u+=c-1,s+=c-1);c-- >0;)u in n?n[s]=n[u]:delete n[s],s+=p,u+=p;return n}},function(e,t,n){var r=n(81);e.exports=function(e,t){var n=[];return r(e,!1,n.push,n,t),n}},function(e,t,n){var r=n(24),o=n(18),i=n(99),a=n(17);e.exports=function(e,t,n,s,u){r(t);var l=o(e),c=i(l),p=a(l.length),d=u?p-1:0,f=u?-1:1;if(n<2)for(;;){if(d in c){s=c[d],d+=f;break}if(d+=f,u?d<0:p<=d)throw TypeError("Reduce of empty array with no initial value")}for(;u?d>=0:p>d;d+=f)d in c&&(s=t(s,c[d],d,l));return s}},function(e,t,n){"use strict";var r=n(24),o=n(9),i=n(116),a=[].slice,s={},u=function(e,t,n){if(!(t in s)){for(var r=[],o=0;o<t;o++)r[o]="a["+o+"]";s[t]=Function("F,a","return new F("+r.join(",")+")")}return s[t](e,n)};e.exports=Function.bind||function(e){var t=r(this),n=a.call(arguments,1),s=function(){var r=n.concat(a.call(arguments));return this instanceof s?u(t,r.length,r):i(t,r,e)};return o(t.prototype)&&(s.prototype=t.prototype),s}},function(e,t,n){"use strict";var r=n(15).f,o=n(66),i=n(69),a=n(50),s=n(64),u=n(37),l=n(81),c=n(151),p=n(234),d=n(70),f=n(14),h=n(60).fastKey,m=f?"_s":"size",g=function(e,t){var n,r=h(t);if("F"!==r)return e._i[r];for(n=e._f;n;n=n.n)if(n.k==t)return n};e.exports={getConstructor:function(e,t,n,c){var p=e(function(e,r){s(e,p,t,"_i"),e._i=o(null),e._f=void 0,e._l=void 0,e[m]=0,void 0!=r&&l(r,n,e[c],e)});return i(p.prototype,{clear:function(){for(var e=this,t=e._i,n=e._f;n;n=n.n)n.r=!0,n.p&&(n.p=n.p.n=void 0),delete t[n.i];e._f=e._l=void 0,e[m]=0},delete:function(e){var t=this,n=g(t,e);if(n){var r=n.n,o=n.p;delete t._i[n.i],n.r=!0,o&&(o.n=r),r&&(r.p=o),t._f==n&&(t._f=r),t._l==n&&(t._l=o),t[m]--}return!!n},forEach:function(e){s(this,p,"forEach");for(var t,n=a(e,arguments.length>1?arguments[1]:void 0,3);t=t?t.n:this._f;)for(n(t.v,t.k,this);t&&t.r;)t=t.p},has:function(e){return!!g(this,e)}}),f&&r(p.prototype,"size",{get:function(){return u(this[m])}}),p},def:function(e,t,n){var r,o,i=g(e,t);return i?i.v=n:(e._l=i={i:o=h(t,!0),k:t,v:n,p:r=e._l,n:void 0,r:!1},e._f||(e._f=i),r&&(r.n=i),e[m]++,"F"!==o&&(e._i[o]=i)),e},getEntry:g,setStrong:function(e,t,n){c(e,t,function(e,t){this._t=e,this._k=t,this._l=void 0},function(){for(var e=this,t=e._k,n=e._l;n&&n.r;)n=n.p;return e._t&&(e._l=n=n?n.n:e._t._f)?"keys"==t?p(0,n.k):"values"==t?p(0,n.v):p(0,[n.k,n.v]):(e._t=void 0,p(1))},n?"entries":"values",!n,!0),d(t)}}},function(e,t,n){var r=n(98),o=n(225);e.exports=function(e){return function(){if(r(this)!=e)throw TypeError(e+"#toJSON isn't generic");return o(this)}}},function(e,t,n){"use strict";var r=n(69),o=n(60).getWeak,i=n(3),a=n(9),s=n(64),u=n(81),l=n(42),c=n(22),p=l(5),d=l(6),f=0,h=function(e){return e._l||(e._l=new m)},m=function(){this.a=[]},g=function(e,t){return p(e.a,function(e){return e[0]===t})};m.prototype={get:function(e){var t=g(this,e);if(t)return t[1]},has:function(e){return!!g(this,e)},set:function(e,t){var n=g(this,e);n?n[1]=t:this.a.push([e,t])},delete:function(e){var t=d(this.a,function(t){return t[0]===e});return~t&&this.a.splice(t,1),!!~t}},e.exports={getConstructor:function(e,t,n,i){var l=e(function(e,r){s(e,l,t,"_i"),e._i=f++,e._l=void 0,void 0!=r&&u(r,n,e[i],e)});return r(l.prototype,{delete:function(e){if(!a(e))return!1;var t=o(e);return t===!0?h(this).delete(e):t&&c(t,this._i)&&delete t[this._i]},has:function(e){if(!a(e))return!1;var t=o(e);return t===!0?h(this).has(e):t&&c(t,this._i)}}),l},def:function(e,t,n){var r=o(i(t),!0);return r===!0?h(e).set(t,n):r[e._i]=n,e},ufstore:h}},function(e,t,n){e.exports=!n(14)&&!n(6)(function(){return 7!=Object.defineProperty(n(143)("div"),"a",{get:function(){return 7}}).a})},function(e,t,n){var r=n(9),o=Math.floor;e.exports=function(e){return!r(e)&&isFinite(e)&&o(e)===e}},function(e,t,n){var r=n(3);e.exports=function(e,t,n,o){try{return o?t(r(n)[0],n[1]):t(n)}catch(t){var i=e.return;throw void 0!==i&&r(i.call(e)),t}}},function(e,t){e.exports=function(e,t){return{value:t,done:!!e}}},function(e,t){e.exports=Math.log1p||function(e){return(e=+e)>-1e-8&&e<1e-8?e-e*e/2:Math.log(1+e)}},function(e,t,n){"use strict";var r=n(68),o=n(120),i=n(100),a=n(18),s=n(99),u=Object.assign;e.exports=!u||n(6)(function(){var e={},t={},n=Symbol(),r="abcdefghijklmnopqrst";return e[n]=7,r.split("").forEach(function(e){t[e]=e}),7!=u({},e)[n]||Object.keys(u({},t)).join("")!=r})?function(e,t){for(var n=a(e),u=arguments.length,l=1,c=o.f,p=i.f;u>l;)for(var d,f=s(arguments[l++]),h=c?r(f).concat(c(f)):r(f),m=h.length,g=0;m>g;)p.call(f,d=h[g++])&&(n[d]=f[d]);return n}:u},function(e,t,n){var r=n(15),o=n(3),i=n(68);e.exports=n(14)?Object.defineProperties:function(e,t){o(e);for(var n,a=i(t),s=a.length,u=0;s>u;)r.f(e,n=a[u++],t[n]);return e}},function(e,t,n){var r=n(28),o=n(67).f,i={}.toString,a="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],s=function(e){try{return o(e)}catch(e){return a.slice()}};e.exports.f=function(e){return a&&"[object Window]"==i.call(e)?s(e):o(r(e))}},function(e,t,n){var r=n(22),o=n(28),i=n(112)(!1),a=n(156)("IE_PROTO");e.exports=function(e,t){var n,s=o(e),u=0,l=[];for(n in s)n!=a&&r(s,n)&&l.push(n);for(;t.length>u;)r(s,n=t[u++])&&(~i(l,n)||l.push(n));return l}},function(e,t,n){var r=n(68),o=n(28),i=n(100).f;e.exports=function(e){return function(t){for(var n,a=o(t),s=r(a),u=s.length,l=0,c=[];u>l;)i.call(a,n=s[l++])&&c.push(e?[n,a[n]]:a[n]);return c}}},function(e,t,n){var r=n(67),o=n(120),i=n(3),a=n(4).Reflect;e.exports=a&&a.ownKeys||function(e){var t=r.f(i(e)),n=o.f;return n?t.concat(n(e)):t}},function(e,t,n){var r=n(4).parseFloat,o=n(84).trim;e.exports=1/r(n(161)+"-0")!=-(1/0)?function(e){var t=o(String(e),3),n=r(t);return 0===n&&"-"==t.charAt(0)?-0:n}:r},function(e,t,n){var r=n(4).parseInt,o=n(84).trim,i=n(161),a=/^[\-+]?0[xX]/;e.exports=8!==r(i+"08")||22!==r(i+"0x16")?function(e,t){var n=o(String(e),3);return r(n,t>>>0||(a.test(n)?16:10))}:r},function(e,t){e.exports=Object.is||function(e,t){return e===t?0!==e||1/e==1/t:e!=e&&t!=t}},function(e,t,n){var r=n(17),o=n(160),i=n(37);e.exports=function(e,t,n,a){var s=String(i(e)),u=s.length,l=void 0===n?" ":String(n),c=r(t);if(c<=u||""==l)return s;var p=c-u,d=o.call(l,Math.ceil(p/l.length));return d.length>p&&(d=d.slice(0,p)),a?d+s:s+d}},function(e,t,n){t.f=n(12)},function(e,t,n){"use strict";var r=n(228);e.exports=n(113)("Map",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{get:function(e){var t=r.getEntry(this,e);return t&&t.v},set:function(e,t){return r.def(this,0===e?0:e,t)}},r,!0)},function(e,t,n){n(14)&&"g"!=/./g.flags&&n(15).f(RegExp.prototype,"flags",{configurable:!0,get:n(115)})},function(e,t,n){"use strict";var r=n(228);e.exports=n(113)("Set",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{add:function(e){return r.def(this,e=0===e?0:e,e)}},r)},function(e,t,n){"use strict";var r,o=n(42)(0),i=n(26),a=n(60),s=n(236),u=n(230),l=n(9),c=a.getWeak,p=Object.isExtensible,d=u.ufstore,f={},h=function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},m={get:function(e){if(l(e)){var t=c(e);return t===!0?d(this).get(e):t?t[this._i]:void 0}},set:function(e,t){return u.def(this,e,t)}},g=e.exports=n(113)("WeakMap",h,m,u,!0,!0);7!=(new g).set((Object.freeze||Object)(f),7).get(f)&&(r=u.getConstructor(h),s(r.prototype,m),a.NEED=!0,o(["delete","has","get","set"],function(e){var t=g.prototype,n=t[e];i(t,e,function(t,o){if(l(t)&&!p(t)){this._f||(this._f=new r);var i=this._f[e](t,o);return"set"==e?this:i}return n.call(this,t,o)})}))},function(e,t,n){"use strict";var r=n(639),o=n(604),i="function"==typeof Symbol&&"symbol"==typeof Symbol(),a=Object.prototype.toString,s=function(e){return"function"==typeof e&&"[object Function]"===a.call(e)},u=Object.defineProperty&&function(){var e={};try{Object.defineProperty(e,"x",{enumerable:!1,value:e});for(var t in e)return!1;return e.x===e}catch(e){return!1}}(),l=function(e,t,n,r){(!(t in e)||s(r)&&r())&&(u?Object.defineProperty(e,t,{configurable:!0,enumerable:!1,value:n,writable:!0}):e[t]=n)},c=function(e,t){var n=arguments.length>2?arguments[2]:{},a=r(t);i&&(a=a.concat(Object.getOwnPropertySymbols(t))),o(a,function(r){l(e,r,t[r],n[r])})};c.supportsDescriptors=!!u,e.exports=c},function(e,t,n){"use strict";var r=n(588);e.exports=n(253)(r,{SameValueNonNumber:function(e,t){if("number"==typeof e||typeof e!=typeof t)throw new TypeError("SameValueNonNumber requires two non-number values of the same type.");return this.SameValue(e,t)}})},function(e,t){var n=Object.prototype.hasOwnProperty;e.exports=Object.assign||function(e,t){for(var r in t)n.call(t,r)&&(e[r]=t[r]);return e}},function(e,t){var n=Number.isNaN||function(e){return e!==e};e.exports=Number.isFinite||function(e){return"number"==typeof e&&!n(e)&&e!==1/0&&e!==-(1/0)}},function(e,t){e.exports=Number.isNaN||function(e){return e!==e}},function(e,t){e.exports=function(e,t){var n=e%t;return Math.floor(n>=0?n:n+t)}},function(e,t){e.exports=function(e){return e>=0?1:-1}},function(e,t){e.exports=function(e){return null===e||"function"!=typeof e&&"object"!=typeof e}},function(e,t,n){"use strict";var r=n(32);e.exports={listen:function(e,t,n){return e.addEventListener?(e.addEventListener(t,n,!1),{remove:function(){e.removeEventListener(t,n,!1)}}):e.attachEvent?(e.attachEvent("on"+t,n),{remove:function(){e.detachEvent("on"+t,n)}}):void 0},capture:function(e,t,n){return e.addEventListener?(e.addEventListener(t,n,!0),{remove:function(){e.removeEventListener(t,n,!0)}}):{remove:r}},registerDefault:function(){}}},function(e,t,n){"use strict";function r(e){try{e.focus()}catch(e){}}e.exports=r},function(e,t,n){"use strict";(function(t){function n(e){if(void 0===(e=e||t.document))return null;try{return e.activeElement||e.body}catch(t){return e.body}}e.exports=n}).call(t,n(34))},function(e,t,n){var r=n(53),o={};o.create=function(){var e=new r.ARRAY_TYPE(9);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},o.fromMat4=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[4],e[4]=t[5],e[5]=t[6],e[6]=t[8],e[7]=t[9],e[8]=t[10],e},o.clone=function(e){var t=new r.ARRAY_TYPE(9);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},o.fromValues=function(e,t,n,o,i,a,s,u,l){var c=new r.ARRAY_TYPE(9);return c[0]=e,c[1]=t,c[2]=n,c[3]=o,c[4]=i,c[5]=a,c[6]=s,c[7]=u,c[8]=l,c},o.set=function(e,t,n,r,o,i,a,s,u,l){return e[0]=t,e[1]=n,e[2]=r,e[3]=o,e[4]=i,e[5]=a,e[6]=s,e[7]=u,e[8]=l,e},o.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},o.transpose=function(e,t){if(e===t){var n=t[1],r=t[2],o=t[5];e[1]=t[3],e[2]=t[6],e[3]=n,e[5]=t[7],e[6]=r,e[7]=o}else e[0]=t[0],e[1]=t[3],e[2]=t[6],e[3]=t[1],e[4]=t[4],e[5]=t[7],e[6]=t[2],e[7]=t[5],e[8]=t[8];return e},o.invert=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=t[4],s=t[5],u=t[6],l=t[7],c=t[8],p=c*a-s*l,d=-c*i+s*u,f=l*i-a*u,h=n*p+r*d+o*f;return h?(h=1/h,e[0]=p*h,e[1]=(-c*r+o*l)*h,e[2]=(s*r-o*a)*h,e[3]=d*h,e[4]=(c*n-o*u)*h,e[5]=(-s*n+o*i)*h,e[6]=f*h,e[7]=(-l*n+r*u)*h,e[8]=(a*n-r*i)*h,e):null},o.adjoint=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=t[4],s=t[5],u=t[6],l=t[7],c=t[8];return e[0]=a*c-s*l,e[1]=o*l-r*c,e[2]=r*s-o*a,e[3]=s*u-i*c,e[4]=n*c-o*u,e[5]=o*i-n*s,e[6]=i*l-a*u,e[7]=r*u-n*l,e[8]=n*a-r*i,e},o.determinant=function(e){var t=e[0],n=e[1],r=e[2],o=e[3],i=e[4],a=e[5],s=e[6],u=e[7],l=e[8];return t*(l*i-a*u)+n*(-l*o+a*s)+r*(u*o-i*s)},o.multiply=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=t[6],c=t[7],p=t[8],d=n[0],f=n[1],h=n[2],m=n[3],g=n[4],v=n[5],b=n[6],y=n[7],_=n[8];return e[0]=d*r+f*a+h*l,e[1]=d*o+f*s+h*c,e[2]=d*i+f*u+h*p,e[3]=m*r+g*a+v*l,e[4]=m*o+g*s+v*c,e[5]=m*i+g*u+v*p,e[6]=b*r+y*a+_*l,e[7]=b*o+y*s+_*c,e[8]=b*i+y*u+_*p,e},o.mul=o.multiply,o.translate=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=t[6],c=t[7],p=t[8],d=n[0],f=n[1];return e[0]=r,e[1]=o,e[2]=i,e[3]=a,e[4]=s,e[5]=u,e[6]=d*r+f*a+l,e[7]=d*o+f*s+c,e[8]=d*i+f*u+p,e},o.rotate=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=t[6],c=t[7],p=t[8],d=Math.sin(n),f=Math.cos(n);return e[0]=f*r+d*a,e[1]=f*o+d*s,e[2]=f*i+d*u,e[3]=f*a-d*r,e[4]=f*s-d*o,e[5]=f*u-d*i,e[6]=l,e[7]=c,e[8]=p,e},o.scale=function(e,t,n){var r=n[0],o=n[1];return e[0]=r*t[0],e[1]=r*t[1],e[2]=r*t[2],e[3]=o*t[3],e[4]=o*t[4],e[5]=o*t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},o.fromTranslation=function(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=t[0],e[7]=t[1],e[8]=1,e},o.fromRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=0,e[3]=-n,e[4]=r,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},o.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=0,e[4]=t[1],e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},o.fromMat2d=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=0,e[3]=t[2],e[4]=t[3],e[5]=0,e[6]=t[4],e[7]=t[5],e[8]=1,e},o.fromQuat=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=n+n,s=r+r,u=o+o,l=n*a,c=r*a,p=r*s,d=o*a,f=o*s,h=o*u,m=i*a,g=i*s,v=i*u;return e[0]=1-p-h,e[3]=c-v,e[6]=d+g,e[1]=c+v,e[4]=1-l-h,e[7]=f-m,e[2]=d-g,e[5]=f+m,e[8]=1-l-p,e},o.normalFromMat4=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=t[4],s=t[5],u=t[6],l=t[7],c=t[8],p=t[9],d=t[10],f=t[11],h=t[12],m=t[13],g=t[14],v=t[15],b=n*s-r*a,y=n*u-o*a,_=n*l-i*a,E=r*u-o*s,w=r*l-i*s,S=o*l-i*u,x=c*m-p*h,T=c*g-d*h,C=c*v-f*h,I=p*g-d*m,R=p*v-f*m,M=d*v-f*g,P=b*M-y*R+_*I+E*C-w*T+S*x;return P?(P=1/P,e[0]=(s*M-u*R+l*I)*P,e[1]=(u*C-a*M-l*T)*P,e[2]=(a*R-s*C+l*x)*P,e[3]=(o*R-r*M-i*I)*P,e[4]=(n*M-o*C+i*T)*P,e[5]=(r*C-n*R-i*x)*P,e[6]=(m*S-g*w+v*E)*P,e[7]=(g*_-h*S-v*y)*P,e[8]=(h*w-m*_+v*b)*P,e):null},o.str=function(e){return"mat3("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+")"},o.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+Math.pow(e[6],2)+Math.pow(e[7],2)+Math.pow(e[8],2))},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e[6]=t[6]+n[6],e[7]=t[7]+n[7],e[8]=t[8]+n[8],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e[6]=t[6]-n[6],e[7]=t[7]-n[7],e[8]=t[8]-n[8],e},o.sub=o.subtract,o.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e[8]=t[8]*n,e},o.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e[4]=t[4]+n[4]*r,e[5]=t[5]+n[5]*r,e[6]=t[6]+n[6]*r,e[7]=t[7]+n[7]*r,e[8]=t[8]+n[8]*r,e},o.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]},o.equals=function(e,t){var n=e[0],o=e[1],i=e[2],a=e[3],s=e[4],u=e[5],l=e[6],c=e[7],p=e[8],d=t[0],f=t[1],h=t[2],m=t[3],g=t[4],v=t[5],b=e[6],y=t[7],_=t[8];return Math.abs(n-d)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(d))&&Math.abs(o-f)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(f))&&Math.abs(i-h)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(h))&&Math.abs(a-m)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(m))&&Math.abs(s-g)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(g))&&Math.abs(u-v)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(v))&&Math.abs(l-b)<=r.EPSILON*Math.max(1,Math.abs(l),Math.abs(b))&&Math.abs(c-y)<=r.EPSILON*Math.max(1,Math.abs(c),Math.abs(y))&&Math.abs(p-_)<=r.EPSILON*Math.max(1,Math.abs(p),Math.abs(_))},e.exports=o},function(e,t,n){var r=n(53),o={};o.create=function(){var e=new r.ARRAY_TYPE(3);return e[0]=0,e[1]=0,e[2]=0,e},o.clone=function(e){var t=new r.ARRAY_TYPE(3);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},o.fromValues=function(e,t,n){var o=new r.ARRAY_TYPE(3);return o[0]=e,o[1]=t,o[2]=n,o},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},o.set=function(e,t,n,r){return e[0]=t,e[1]=n,e[2]=r,e},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e},o.sub=o.subtract,o.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e},o.mul=o.multiply,o.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e},o.div=o.divide,o.ceil=function(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e[2]=Math.ceil(t[2]),e},o.floor=function(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e[2]=Math.floor(t[2]),e},o.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e},o.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e},o.round=function(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e[2]=Math.round(t[2]),e},o.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e},o.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e},o.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],o=t[2]-e[2];return Math.sqrt(n*n+r*r+o*o)},o.dist=o.distance,o.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],o=t[2]-e[2];return n*n+r*r+o*o},o.sqrDist=o.squaredDistance,o.length=function(e){var t=e[0],n=e[1],r=e[2];return Math.sqrt(t*t+n*n+r*r)},o.len=o.length,o.squaredLength=function(e){var t=e[0],n=e[1],r=e[2];return t*t+n*n+r*r},o.sqrLen=o.squaredLength,o.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e},o.inverse=function(e,t){return e[0]=1/t[0],e[1]=1/t[1],e[2]=1/t[2],e},o.normalize=function(e,t){var n=t[0],r=t[1],o=t[2],i=n*n+r*r+o*o;return i>0&&(i=1/Math.sqrt(i),e[0]=t[0]*i,e[1]=t[1]*i,e[2]=t[2]*i),e},o.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]},o.cross=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=n[0],s=n[1],u=n[2];return e[0]=o*u-i*s,e[1]=i*a-r*u,e[2]=r*s-o*a,e},o.lerp=function(e,t,n,r){var o=t[0],i=t[1],a=t[2];return e[0]=o+r*(n[0]-o),e[1]=i+r*(n[1]-i),e[2]=a+r*(n[2]-a),e},o.hermite=function(e,t,n,r,o,i){var a=i*i,s=a*(2*i-3)+1,u=a*(i-2)+i,l=a*(i-1),c=a*(3-2*i);return e[0]=t[0]*s+n[0]*u+r[0]*l+o[0]*c,e[1]=t[1]*s+n[1]*u+r[1]*l+o[1]*c,e[2]=t[2]*s+n[2]*u+r[2]*l+o[2]*c,e},o.bezier=function(e,t,n,r,o,i){var a=1-i,s=a*a,u=i*i,l=s*a,c=3*i*s,p=3*u*a,d=u*i;return e[0]=t[0]*l+n[0]*c+r[0]*p+o[0]*d,e[1]=t[1]*l+n[1]*c+r[1]*p+o[1]*d,e[2]=t[2]*l+n[2]*c+r[2]*p+o[2]*d,e},o.random=function(e,t){t=t||1;var n=2*r.RANDOM()*Math.PI,o=2*r.RANDOM()-1,i=Math.sqrt(1-o*o)*t;return e[0]=Math.cos(n)*i,e[1]=Math.sin(n)*i,e[2]=o*t,e},o.transformMat4=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=n[3]*r+n[7]*o+n[11]*i+n[15];return a=a||1,e[0]=(n[0]*r+n[4]*o+n[8]*i+n[12])/a,e[1]=(n[1]*r+n[5]*o+n[9]*i+n[13])/a,e[2]=(n[2]*r+n[6]*o+n[10]*i+n[14])/a,e},o.transformMat3=function(e,t,n){var r=t[0],o=t[1],i=t[2];return e[0]=r*n[0]+o*n[3]+i*n[6],e[1]=r*n[1]+o*n[4]+i*n[7],e[2]=r*n[2]+o*n[5]+i*n[8],e},o.transformQuat=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=n[0],s=n[1],u=n[2],l=n[3],c=l*r+s*i-u*o,p=l*o+u*r-a*i,d=l*i+a*o-s*r,f=-a*r-s*o-u*i;return e[0]=c*l+f*-a+p*-u-d*-s,e[1]=p*l+f*-s+d*-a-c*-u,e[2]=d*l+f*-u+c*-s-p*-a,e},o.rotateX=function(e,t,n,r){var o=[],i=[];return o[0]=t[0]-n[0],o[1]=t[1]-n[1],o[2]=t[2]-n[2],i[0]=o[0],i[1]=o[1]*Math.cos(r)-o[2]*Math.sin(r),i[2]=o[1]*Math.sin(r)+o[2]*Math.cos(r),e[0]=i[0]+n[0],e[1]=i[1]+n[1],e[2]=i[2]+n[2],e},o.rotateY=function(e,t,n,r){var o=[],i=[];return o[0]=t[0]-n[0],o[1]=t[1]-n[1],o[2]=t[2]-n[2],i[0]=o[2]*Math.sin(r)+o[0]*Math.cos(r),i[1]=o[1],i[2]=o[2]*Math.cos(r)-o[0]*Math.sin(r),e[0]=i[0]+n[0],e[1]=i[1]+n[1],e[2]=i[2]+n[2],e},o.rotateZ=function(e,t,n,r){var o=[],i=[];return o[0]=t[0]-n[0],o[1]=t[1]-n[1],o[2]=t[2]-n[2],i[0]=o[0]*Math.cos(r)-o[1]*Math.sin(r),i[1]=o[0]*Math.sin(r)+o[1]*Math.cos(r),i[2]=o[2],e[0]=i[0]+n[0],e[1]=i[1]+n[1],e[2]=i[2]+n[2],e},o.forEach=function(){var e=o.create();return function(t,n,r,o,i,a){var s,u;for(n||(n=3),r||(r=0),u=o?Math.min(o*n+r,t.length):t.length,s=r;s<u;s+=n)e[0]=t[s],e[1]=t[s+1],e[2]=t[s+2],i(e,e,a),t[s]=e[0],t[s+1]=e[1],t[s+2]=e[2];return t}}(),o.angle=function(e,t){var n=o.fromValues(e[0],e[1],e[2]),r=o.fromValues(t[0],t[1],t[2]);o.normalize(n,n),o.normalize(r,r);var i=o.dot(n,r);return i>1?0:Math.acos(i)},o.str=function(e){return"vec3("+e[0]+", "+e[1]+", "+e[2]+")"},o.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]},o.equals=function(e,t){var n=e[0],o=e[1],i=e[2],a=t[0],s=t[1],u=t[2];return Math.abs(n-a)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(a))&&Math.abs(o-s)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(s))&&Math.abs(i-u)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(u))},e.exports=o},function(e,t,n){var r=n(53),o={};o.create=function(){var e=new r.ARRAY_TYPE(4);return e[0]=0,e[1]=0,e[2]=0,e[3]=0,e},o.clone=function(e){var t=new r.ARRAY_TYPE(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},o.fromValues=function(e,t,n,o){var i=new r.ARRAY_TYPE(4);return i[0]=e,i[1]=t,i[2]=n,i[3]=o,i},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},o.set=function(e,t,n,r,o){return e[0]=t,e[1]=n,e[2]=r,e[3]=o,e},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e},o.sub=o.subtract,o.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e[3]=t[3]*n[3],e},o.mul=o.multiply,o.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e[3]=t[3]/n[3],e},o.div=o.divide,o.ceil=function(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e[2]=Math.ceil(t[2]),e[3]=Math.ceil(t[3]),e},o.floor=function(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e[2]=Math.floor(t[2]),e[3]=Math.floor(t[3]),e},o.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e[3]=Math.min(t[3],n[3]),e},o.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e[3]=Math.max(t[3],n[3]),e},o.round=function(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e[2]=Math.round(t[2]),e[3]=Math.round(t[3]),e},o.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e},o.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e},o.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],o=t[2]-e[2],i=t[3]-e[3];return Math.sqrt(n*n+r*r+o*o+i*i)},o.dist=o.distance,o.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],o=t[2]-e[2],i=t[3]-e[3];return n*n+r*r+o*o+i*i},o.sqrDist=o.squaredDistance,o.length=function(e){var t=e[0],n=e[1],r=e[2],o=e[3];return Math.sqrt(t*t+n*n+r*r+o*o)},o.len=o.length,o.squaredLength=function(e){var t=e[0],n=e[1],r=e[2],o=e[3];return t*t+n*n+r*r+o*o},o.sqrLen=o.squaredLength,o.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=-t[3],e},o.inverse=function(e,t){return e[0]=1/t[0],e[1]=1/t[1],e[2]=1/t[2],e[3]=1/t[3],e},o.normalize=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=n*n+r*r+o*o+i*i;return a>0&&(a=1/Math.sqrt(a),e[0]=n*a,e[1]=r*a,e[2]=o*a,e[3]=i*a),e},o.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]+e[3]*t[3]},o.lerp=function(e,t,n,r){var o=t[0],i=t[1],a=t[2],s=t[3];return e[0]=o+r*(n[0]-o),e[1]=i+r*(n[1]-i),e[2]=a+r*(n[2]-a),e[3]=s+r*(n[3]-s),e},o.random=function(e,t){return t=t||1,e[0]=r.RANDOM(),e[1]=r.RANDOM(),e[2]=r.RANDOM(),e[3]=r.RANDOM(),o.normalize(e,e),o.scale(e,e,t),e},o.transformMat4=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3];return e[0]=n[0]*r+n[4]*o+n[8]*i+n[12]*a,e[1]=n[1]*r+n[5]*o+n[9]*i+n[13]*a,e[2]=n[2]*r+n[6]*o+n[10]*i+n[14]*a,e[3]=n[3]*r+n[7]*o+n[11]*i+n[15]*a,e},o.transformQuat=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=n[0],s=n[1],u=n[2],l=n[3],c=l*r+s*i-u*o,p=l*o+u*r-a*i,d=l*i+a*o-s*r,f=-a*r-s*o-u*i;return e[0]=c*l+f*-a+p*-u-d*-s,e[1]=p*l+f*-s+d*-a-c*-u,e[2]=d*l+f*-u+c*-s-p*-a,e[3]=t[3],e},o.forEach=function(){var e=o.create();return function(t,n,r,o,i,a){var s,u;for(n||(n=4),r||(r=0),u=o?Math.min(o*n+r,t.length):t.length,s=r;s<u;s+=n)e[0]=t[s],e[1]=t[s+1],e[2]=t[s+2],e[3]=t[s+3],i(e,e,a),t[s]=e[0],t[s+1]=e[1],t[s+2]=e[2],t[s+3]=e[3];return t}}(),o.str=function(e){return"vec4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},o.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]},o.equals=function(e,t){var n=e[0],o=e[1],i=e[2],a=e[3],s=t[0],u=t[1],l=t[2],c=t[3];return Math.abs(n-s)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(s))&&Math.abs(o-u)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(u))&&Math.abs(i-l)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(a-c)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(c))},e.exports=o},function(e,t,n){"use strict";t.a=n(633).a.Symbol},function(e,t,n){"use strict";var r=n(643);e.exports=function(e){return r(e,!1)}},function(e,t,n){"use strict";(function(t){var r=n(647),o="undefined"!=typeof window?window:void 0!==t?t:"undefined"!=typeof self?self:{},i=o.Raven,a=new r;a.noConflict=function(){return o.Raven=i,a},a.afterLoad(),e.exports=a}).call(t,n(34))},function(e,t,n){"use strict";function r(e){return"object"==typeof e&&null!==e}function o(e){switch({}.toString.call(e)){case"[object Error]":return!0;case"[object Exception]":return!0;case"[object DOMException]":return!0;default:return e instanceof Error}}e.exports={isObject:r,isError:o}},function(e,t,n){"use strict";function r(e,t){return e+t.charAt(0).toUpperCase()+t.substring(1)}var o={animationIterationCount:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridRow:!0,gridColumn:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},i=["Webkit","ms","Moz","O"];Object.keys(o).forEach(function(e){i.forEach(function(t){o[r(t,e)]=o[e]})}),e.exports={isUnitlessNumber:o,shorthandPropertyExpansions:{background:{backgroundAttachment:!0,backgroundColor:!0,backgroundImage:!0,backgroundPositionX:!0,backgroundPositionY:!0,backgroundRepeat:!0},backgroundPosition:{backgroundPositionX:!0,backgroundPositionY:!0},border:{borderWidth:!0,borderStyle:!0,borderColor:!0},borderBottom:{borderBottomWidth:!0,borderBottomStyle:!0,borderBottomColor:!0},borderLeft:{borderLeftWidth:!0,borderLeftStyle:!0,borderLeftColor:!0},borderRight:{borderRightWidth:!0,borderRightStyle:!0,borderRightColor:!0},borderTop:{borderTopWidth:!0,borderTopStyle:!0,borderTopColor:!0},font:{fontStyle:!0,fontVariant:!0,fontWeight:!0,fontSize:!0,lineHeight:!0,fontFamily:!0},outline:{outlineWidth:!0,outlineStyle:!0,outlineColor:!0}}}},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var o=n(7),i=n(73);n(1);e.exports=i.addPoolingTo(function(){function e(t){r(this,e),this._callbacks=null,this._contexts=null,this._arg=t}return e.prototype.enqueue=function(e,t){this._callbacks=this._callbacks||[],this._callbacks.push(e),this._contexts=this._contexts||[],this._contexts.push(t)},e.prototype.notifyAll=function(){var e=this._callbacks,t=this._contexts,n=this._arg;if(e&&t){e.length!==t.length&&o("24"),this._callbacks=null,this._contexts=null;for(var r=0;r<e.length;r++)e[r].call(t[r],n);e.length=0,t.length=0}},e.prototype.checkpoint=function(){return this._callbacks?this._callbacks.length:0},e.prototype.rollback=function(e){this._callbacks&&this._contexts&&(this._callbacks.length=e,this._contexts.length=e)},e.prototype.reset=function(){this._callbacks=null,this._contexts=null},e.prototype.destructor=function(){this.reset()},e}())},function(e,t,n){"use strict";function r(e){return!!l.hasOwnProperty(e)||!u.hasOwnProperty(e)&&(s.test(e)?(l[e]=!0,!0):(u[e]=!0,!1))}function o(e,t){return null==t||e.hasBooleanValue&&!t||e.hasNumericValue&&isNaN(t)||e.hasPositiveNumericValue&&t<1||e.hasOverloadedBooleanValue&&t===!1}var i=n(87),a=(n(16),n(39),n(711)),s=(n(5),new RegExp("^["+i.ATTRIBUTE_NAME_START_CHAR+"]["+i.ATTRIBUTE_NAME_CHAR+"]*$")),u={},l={},c={createMarkupForID:function(e){return i.ID_ATTRIBUTE_NAME+"="+a(e)},setAttributeForID:function(e,t){e.setAttribute(i.ID_ATTRIBUTE_NAME,t)},createMarkupForRoot:function(){return i.ROOT_ATTRIBUTE_NAME+'=""'},setAttributeForRoot:function(e){e.setAttribute(i.ROOT_ATTRIBUTE_NAME,"")},createMarkupForProperty:function(e,t){var n=i.properties.hasOwnProperty(e)?i.properties[e]:null;if(n){if(o(n,t))return"";var r=n.attributeName;return n.hasBooleanValue||n.hasOverloadedBooleanValue&&t===!0?r+'=""':r+"="+a(t)}return i.isCustomAttribute(e)?null==t?"":e+"="+a(t):null},createMarkupForCustomAttribute:function(e,t){return r(e)&&null!=t?e+"="+a(t):""},setValueForProperty:function(e,t,n){var r=i.properties.hasOwnProperty(t)?i.properties[t]:null;if(r){var a=r.mutationMethod;if(a)a(e,n);else{if(o(r,n))return void this.deleteValueForProperty(e,t);if(r.mustUseProperty)e[r.propertyName]=n;else{var s=r.attributeName,u=r.attributeNamespace;u?e.setAttributeNS(u,s,""+n):r.hasBooleanValue||r.hasOverloadedBooleanValue&&n===!0?e.setAttribute(s,""):e.setAttribute(s,""+n)}}}else if(i.isCustomAttribute(t))return void c.setValueForAttribute(e,t,n)},setValueForAttribute:function(e,t,n){if(r(t)){null==n?e.removeAttribute(t):e.setAttribute(t,""+n)}},deleteValueForAttribute:function(e,t){e.removeAttribute(t)},deleteValueForProperty:function(e,t){var n=i.properties.hasOwnProperty(t)?i.properties[t]:null;if(n){var r=n.mutationMethod;if(r)r(e,void 0);else if(n.mustUseProperty){var o=n.propertyName;e[o]=!n.hasBooleanValue&&""}else e.removeAttribute(n.attributeName)}else i.isCustomAttribute(t)&&e.removeAttribute(t)}};e.exports=c},function(e,t,n){"use strict";e.exports={hasCachedChildNodes:1}},function(e,t,n){"use strict";function r(){if(this._rootNodeID&&this._wrapperState.pendingUpdate){this._wrapperState.pendingUpdate=!1;var e=this._currentElement.props,t=s.getValue(e);null!=t&&o(this,Boolean(e.multiple),t)}}function o(e,t,n){var r,o,i=u.getNodeFromInstance(e).options;if(t){for(r={},o=0;o<n.length;o++)r[""+n[o]]=!0;for(o=0;o<i.length;o++){var a=r.hasOwnProperty(i[o].value);i[o].selected!==a&&(i[o].selected=a)}}else{for(r=""+n,o=0;o<i.length;o++)if(i[o].value===r)return void(i[o].selected=!0);i.length&&(i[0].selected=!0)}}function i(e){var t=this._currentElement.props,n=s.executeOnChange(t,e);return this._rootNodeID&&(this._wrapperState.pendingUpdate=!0),l.asap(r,this),n}var a=n(13),s=n(176),u=n(16),l=n(45),c=(n(5),!1);e.exports={getHostProps:function(e,t){return a({},t,{onChange:e._wrapperState.onChange,value:void 0})},mountWrapper:function(e,t){var n=s.getValue(t);e._wrapperState={pendingUpdate:!1,initialValue:null!=n?n:t.defaultValue,listeners:null,onChange:i.bind(e),wasMultiple:Boolean(t.multiple)},void 0===t.value||void 0===t.defaultValue||c||(c=!0)},getSelectValueContext:function(e){return e._wrapperState.initialValue},postUpdateWrapper:function(e){var t=e._currentElement.props;e._wrapperState.initialValue=void 0;var n=e._wrapperState.wasMultiple;e._wrapperState.wasMultiple=Boolean(t.multiple);var r=s.getValue(t);null!=r?(e._wrapperState.pendingUpdate=!1,o(e,Boolean(t.multiple),r)):n!==Boolean(t.multiple)&&(null!=t.defaultValue?o(e,Boolean(t.multiple),t.defaultValue):o(e,Boolean(t.multiple),t.multiple?[]:""))}}},function(e,t,n){"use strict";var r,o={injectEmptyComponentFactory:function(e){r=e}},i={create:function(e){return r(e)}};i.injection=o,e.exports=i},function(e,t,n){"use strict";e.exports={logTopLevelRenders:!1}},function(e,t,n){"use strict";function r(e){return s||a("111",e.type),new s(e)}function o(e){return new u(e)}function i(e){return e instanceof u}var a=n(7),s=(n(1),null),u=null;e.exports={createInternalComponent:r,createInstanceForText:o,isTextComponent:i,injection:{injectGenericComponentClass:function(e){s=e},injectTextComponentClass:function(e){u=e}}}},function(e,t,n){"use strict";function r(e){return i(document.documentElement,e)}var o=n(671),i=n(594),a=n(260),s=n(261),u={hasSelectionCapabilities:function(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return t&&("input"===t&&"text"===e.type||"textarea"===t||"true"===e.contentEditable)},getSelectionInformation:function(){var e=s();return{focusedElem:e,selectionRange:u.hasSelectionCapabilities(e)?u.getSelection(e):null}},restoreSelection:function(e){var t=s(),n=e.focusedElem,o=e.selectionRange;t!==n&&r(n)&&(u.hasSelectionCapabilities(n)&&u.setSelection(n,o),a(n))},getSelection:function(e){var t;if("selectionStart"in e)t={start:e.selectionStart,end:e.selectionEnd};else if(document.selection&&e.nodeName&&"input"===e.nodeName.toLowerCase()){var n=document.selection.createRange();n.parentElement()===e&&(t={start:-n.moveStart("character",-e.value.length),end:-n.moveEnd("character",-e.value.length)})}else t=o.getOffsets(e);return t||{start:0,end:0}},setSelection:function(e,t){var n=t.start,r=t.end;if(void 0===r&&(r=n),"selectionStart"in e)e.selectionStart=n,e.selectionEnd=Math.min(r,e.value.length);else if(document.selection&&e.nodeName&&"input"===e.nodeName.toLowerCase()){var i=e.createTextRange();i.collapse(!0),i.moveStart("character",n),i.moveEnd("character",r-n),i.select()}else o.setOffsets(e,t)}};e.exports=u},function(e,t,n){"use strict";function r(e,t){for(var n=Math.min(e.length,t.length),r=0;r<n;r++)if(e.charAt(r)!==t.charAt(r))return r;return e.length===t.length?-1:n}function o(e){return e?e.nodeType===k?e.documentElement:e.firstChild:null}function i(e){return e.getAttribute&&e.getAttribute(O)||""}function a(e,t,n,r,o){var i;if(E.logTopLevelRenders){var a=e._currentElement.props.child,s=a.type;i="React mount: "+("string"==typeof s?s:s.displayName||s.name),console.time(i)}var u=x.mountComponent(e,n,null,y(e,t),o,0);i&&console.timeEnd(i),e._renderedComponent._topLevelWrapper=e,H._mountImageIntoNode(u,t,e,r,n)}function s(e,t,n,r){var o=C.ReactReconcileTransaction.getPooled(!n&&_.useCreateElement);o.perform(a,null,e,t,o,n,r),C.ReactReconcileTransaction.release(o)}function u(e,t,n){for(x.unmountComponent(e,n),t.nodeType===k&&(t=t.documentElement);t.lastChild;)t.removeChild(t.lastChild)}function l(e){var t=o(e);if(t){var n=b.getInstanceFromNode(t);return!(!n||!n._hostParent)}}function c(e){return!(!e||e.nodeType!==D&&e.nodeType!==k&&e.nodeType!==N)}function p(e){var t=o(e),n=t&&b.getInstanceFromNode(t);return n&&!n._hostParent?n:null}function d(e){var t=p(e);return t?t._hostContainerInfo._topLevelWrapper:null}var f=n(7),h=n(86),m=n(87),g=n(89),v=n(124),b=(n(56),n(16)),y=n(665),_=n(667),E=n(275),w=n(105),S=(n(39),n(681)),x=n(88),T=n(179),C=n(45),I=n(101),R=n(285),M=(n(1),n(128)),P=n(185),O=(n(5),m.ID_ATTRIBUTE_NAME),A=m.ROOT_ATTRIBUTE_NAME,D=1,k=9,N=11,L={},F=1,U=function(){this.rootID=F++};U.prototype.isReactComponent={},U.prototype.render=function(){return this.props.child},U.isReactTopLevelWrapper=!0;var H={TopLevelWrapper:U,_instancesByReactRootID:L,scrollMonitor:function(e,t){t()},_updateRootComponent:function(e,t,n,r,o){return H.scrollMonitor(r,function(){T.enqueueElementInternal(e,t,n),o&&T.enqueueCallbackInternal(e,o)}),e},_renderNewRootComponent:function(e,t,n,r){c(t)||f("37"),v.ensureScrollValueMonitoring();var o=R(e,!1);return C.batchedUpdates(s,o,t,n,r),L[o._instance.rootID]=o,o},renderSubtreeIntoContainer:function(e,t,n,r){return null!=e&&w.has(e)||f("38"),H._renderSubtreeIntoContainer(e,t,n,r)},_renderSubtreeIntoContainer:function(e,t,n,r){T.validateCallback(r,"ReactDOM.render"),g.isValidElement(t)||f("39","string"==typeof t?" Instead of passing a string like 'div', pass React.createElement('div') or <div />.":"function"==typeof t?" Instead of passing a class like Foo, pass React.createElement(Foo) or <Foo />.":null!=t&&void 0!==t.props?" This may be caused by unintentionally loading two independent copies of React.":"");var a,s=g.createElement(U,{child:t});if(e){var u=w.get(e);a=u._processChildContext(u._context)}else a=I;var c=d(n);if(c){if(P(c._currentElement.props.child,t)){var p=c._renderedComponent.getPublicInstance();return H._updateRootComponent(c,s,a,n,r&&function(){r.call(p)}),p}H.unmountComponentAtNode(n)}var h=o(n),m=h&&!!i(h),v=l(n),b=m&&!c&&!v,y=H._renderNewRootComponent(s,n,b,a)._renderedComponent.getPublicInstance();return r&&r.call(y),y},render:function(e,t,n){return H._renderSubtreeIntoContainer(null,e,t,n)},unmountComponentAtNode:function(e){c(e)||f("40");var t=d(e);if(!t){l(e),1===e.nodeType&&e.hasAttribute(A);return!1}return delete L[t._instance.rootID],C.batchedUpdates(u,t,e,!1),!0},_mountImageIntoNode:function(e,t,n,i,a){if(c(t)||f("41"),i){var s=o(t);if(S.canReuseMarkup(e,s))return void b.precacheNode(n,s);var u=s.getAttribute(S.CHECKSUM_ATTR_NAME);s.removeAttribute(S.CHECKSUM_ATTR_NAME);var l=s.outerHTML;s.setAttribute(S.CHECKSUM_ATTR_NAME,u);var p=e,d=r(p,l),m=" (client) "+p.substring(d-20,d+20)+"\n (server) "+l.substring(d-20,d+20);t.nodeType===k&&f("42",m)}if(t.nodeType===k&&f("43"),a.useCreateElement){for(;t.lastChild;)t.removeChild(t.lastChild);h.insertTreeBefore(t,e,null)}else M(t,e),b.precacheNode(n,t.firstChild)}};e.exports=H},function(e,t,n){"use strict";var r=n(7),o=n(89),i=(n(1),{HOST:0,COMPOSITE:1,EMPTY:2,getType:function(e){return null===e||e===!1?i.EMPTY:o.isValidElement(e)?"function"==typeof e.type?i.COMPOSITE:i.HOST:void r("26",e)}});e.exports=i},function(e,t,n){"use strict";var r={currentScrollLeft:0,currentScrollTop:0,refreshScrollValues:function(e){r.currentScrollLeft=e.x,r.currentScrollTop=e.y}};e.exports=r},function(e,t,n){"use strict";function r(e,t){return null==t&&o("30"),null==e?t:Array.isArray(e)?Array.isArray(t)?(e.push.apply(e,t),e):(e.push(t),e):Array.isArray(t)?[e].concat(t):[e,t]}var o=n(7);n(1);e.exports=r},function(e,t,n){"use strict";function r(e,t,n){Array.isArray(e)?e.forEach(t,n):e&&t.call(n,e)}e.exports=r},function(e,t,n){"use strict";function r(e){for(var t;(t=e._renderedNodeType)===o.COMPOSITE;)e=e._renderedComponent;return t===o.HOST?e._renderedComponent:t===o.EMPTY?null:void 0}var o=n(279);e.exports=r},function(e,t,n){"use strict";function r(){return!i&&o.canUseDOM&&(i="textContent"in document.documentElement?"textContent":"innerText"),i}var o=n(23),i=null;e.exports=r},function(e,t,n){"use strict";function r(e){if(e){var t=e.getName();if(t)return" Check the render method of `"+t+"`."}return""}function o(e){return"function"==typeof e&&void 0!==e.prototype&&"function"==typeof e.prototype.mountComponent&&"function"==typeof e.prototype.receiveComponent}function i(e,t){var n;if(null===e||e===!1)n=l.create(i);else if("object"==typeof e){var s=e,u=s.type;if("function"!=typeof u&&"string"!=typeof u){var d="";d+=r(s._owner),a("130",null==u?u:typeof u,d)}"string"==typeof s.type?n=c.createInternalComponent(s):o(s.type)?(n=new s.type(s),n.getHostNode||(n.getHostNode=n.getNativeNode)):n=new p(s)}else"string"==typeof e||"number"==typeof e?n=c.createInstanceForText(e):a("131",typeof e);return n._mountIndex=0,n._mountImage=null,n}var a=n(7),s=n(13),u=n(662),l=n(274),c=n(276),p=(n(732),n(1),n(5),function(e){this.construct(e)});s(p.prototype,u,{_instantiateReactComponent:i}),e.exports=i},function(e,t,n){"use strict";function r(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return"input"===t?!!o[e.type]:"textarea"===t}var o={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};e.exports=r},function(e,t,n){"use strict";var r=n(23),o=n(127),i=n(128),a=function(e,t){if(t){var n=e.firstChild;if(n&&n===e.lastChild&&3===n.nodeType)return void(n.nodeValue=t)}e.textContent=t};r.canUseDOM&&("textContent"in document.documentElement||(a=function(e,t){if(3===e.nodeType)return void(e.nodeValue=t);i(e,o(t))})),e.exports=a},function(e,t,n){"use strict";function r(e,t){return e&&"object"==typeof e&&null!=e.key?l.escape(e.key):t.toString(36)}function o(e,t,n,i){var d=typeof e;if("undefined"!==d&&"boolean"!==d||(e=null),null===e||"string"===d||"number"===d||"object"===d&&e.$$typeof===s)return n(i,e,""===t?c+r(e,0):t),1;var f,h,m=0,g=""===t?c:t+p;if(Array.isArray(e))for(var v=0;v<e.length;v++)f=e[v],h=g+r(f,v),m+=o(f,h,n,i);else{var b=u(e);if(b){var y,_=b.call(e);if(b!==e.entries)for(var E=0;!(y=_.next()).done;)f=y.value,h=g+r(f,E++),m+=o(f,h,n,i);else for(;!(y=_.next()).done;){var w=y.value;w&&(f=w[1],h=g+l.escape(w[0])+p+r(f,0),m+=o(f,h,n,i))}}else if("object"===d){var S="",x=String(e);a("31","[object Object]"===x?"object with keys {"+Object.keys(e).join(", ")+"}":x,S)}}return m}function i(e,t,n){return null==e?0:o(e,"",t,n)}var a=n(7),s=(n(56),n(677)),u=n(708),l=(n(1),n(175)),c=(n(5),"."),p=":";e.exports=i},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function o(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function i(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}function a(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}function s(){}function u(e,t){var n={run:function(r){try{var o=e(t.getState(),r);(o!==n.props||n.error)&&(n.shouldComponentUpdate=!0,n.props=o,n.error=null)}catch(e){n.shouldComponentUpdate=!0,n.error=e}}};return n}function l(e){var t,l,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},d=c.getDisplayName,_=void 0===d?function(e){return"ConnectAdvanced("+e+")"}:d,E=c.methodName,w=void 0===E?"connectAdvanced":E,S=c.renderCountProp,x=void 0===S?void 0:S,T=c.shouldHandleStateChanges,C=void 0===T||T,I=c.storeKey,R=void 0===I?"store":I,M=c.withRef,P=void 0!==M&&M,O=a(c,["getDisplayName","methodName","renderCountProp","shouldHandleStateChanges","storeKey","withRef"]),A=R+"Subscription",D=b++,k=(t={},t[R]=g.a,t[A]=g.b,t),N=(l={},l[A]=g.b,l);return function(t){f()("function"==typeof t,"You must pass a component to the function returned by connect. Instead received "+JSON.stringify(t));var a=t.displayName||t.name||"Component",l=_(a),c=v({},O,{getDisplayName:_,methodName:w,renderCountProp:x,shouldHandleStateChanges:C,storeKey:R,withRef:P,displayName:l,wrappedComponentName:a,WrappedComponent:t}),d=function(a){function p(e,t){r(this,p);var n=o(this,a.call(this,e,t));return n.version=D,n.state={},n.renderCount=0,n.store=e[R]||t[R],n.propsMode=Boolean(e[R]),n.setWrappedInstance=n.setWrappedInstance.bind(n),f()(n.store,'Could not find "'+R+'" in either the context or props of "'+l+'". Either wrap the root component in a <Provider>, or explicitly pass "'+R+'" as a prop to "'+l+'".'),n.initSelector(),n.initSubscription(),n}return i(p,a),p.prototype.getChildContext=function(){var e,t=this.propsMode?null:this.subscription;return e={},e[A]=t||this.context[A],e},p.prototype.componentDidMount=function(){C&&(this.subscription.trySubscribe(),this.selector.run(this.props),this.selector.shouldComponentUpdate&&this.forceUpdate())},p.prototype.componentWillReceiveProps=function(e){this.selector.run(e)},p.prototype.shouldComponentUpdate=function(){return this.selector.shouldComponentUpdate},p.prototype.componentWillUnmount=function(){this.subscription&&this.subscription.tryUnsubscribe(),this.subscription=null,this.notifyNestedSubs=s,this.store=null,this.selector.run=s,this.selector.shouldComponentUpdate=!1},p.prototype.getWrappedInstance=function(){return f()(P,"To access the wrapped instance, you need to specify { withRef: true } in the options argument of the "+w+"() call."),this.wrappedInstance},p.prototype.setWrappedInstance=function(e){this.wrappedInstance=e},p.prototype.initSelector=function(){this.selector=u(e(this.store.dispatch,c),this.store),this.selector.run(this.props)},p.prototype.initSubscription=function(){if(C){this.subscription=new m.a(this.store,(this.propsMode?this.props:this.context)[A],this.onStateChange.bind(this)),this.notifyNestedSubs=this.subscription.notifyNestedSubs.bind(this.subscription)}},p.prototype.onStateChange=function(){this.selector.run(this.props),this.selector.shouldComponentUpdate?(this.componentDidUpdate=this.notifyNestedSubsOnComponentDidUpdate,this.setState(y)):this.notifyNestedSubs()},p.prototype.notifyNestedSubsOnComponentDidUpdate=function(){this.componentDidUpdate=void 0,this.notifyNestedSubs()},p.prototype.isSubscribed=function(){return Boolean(this.subscription)&&this.subscription.isSubscribed()},p.prototype.addExtraProps=function(e){if(!(P||x||this.propsMode&&this.subscription))return e;var t=v({},e);return P&&(t.ref=this.setWrappedInstance),x&&(t[x]=this.renderCount++),this.propsMode&&this.subscription&&(t[A]=this.subscription),t},p.prototype.render=function(){var e=this.selector;if(e.shouldComponentUpdate=!1,e.error)throw e.error;return n.i(h.createElement)(t,this.addExtraProps(e.props))},p}(h.Component);return d.WrappedComponent=t,d.displayName=l,d.childContextTypes=N,d.contextTypes=k,d.propTypes=k,p()(d,t)}}t.a=l;var c=n(612),p=n.n(c),d=n(613),f=n.n(d),h=n(2),m=(n.n(h),n(720)),g=n(291),v=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},b=0,y={}},function(e,t,n){"use strict";function r(e){return function(t,n){function r(){return o}var o=e(t,n);return r.dependsOnOwnProps=!1,r}}function o(e){return null!==e.dependsOnOwnProps&&void 0!==e.dependsOnOwnProps?Boolean(e.dependsOnOwnProps):1!==e.length}function i(e,t){return function(t,n){var r=function(e,t){return r.dependsOnOwnProps?r.mapToProps(e,t):r.mapToProps(e)};return r.dependsOnOwnProps=!0,r.mapToProps=function(t,n){r.mapToProps=e,r.dependsOnOwnProps=o(e);var i=r(t,n);return"function"==typeof i&&(r.mapToProps=i,r.dependsOnOwnProps=o(i),i=r(t,n)),i},r}}t.b=r,t.a=i;n(292)},function(e,t,n){"use strict";n.d(t,"b",function(){return i}),n.d(t,"a",function(){return a});var r=n(10),o=n.n(r),i=o.a.shape({trySubscribe:o.a.func.isRequired,tryUnsubscribe:o.a.func.isRequired,notifyNestedSubs:o.a.func.isRequired,isSubscribed:o.a.func.isRequired}),a=o.a.shape({subscribe:o.a.func.isRequired,dispatch:o.a.func.isRequired,getState:o.a.func.isRequired})},function(e,t,n){"use strict";n(170),n(187)},function(e,t,n){"use strict";function r(e){var t=Function.prototype.toString,n=Object.prototype.hasOwnProperty,r=RegExp("^"+t.call(n).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");try{return r.test(t.call(e))}catch(e){return!1}}function o(e){var t=l(e);if(t){var n=t.childIDs;c(e),n.forEach(o)}}function i(e,t,n){return"\n    in "+(e||"Unknown")+(t?" (at "+t.fileName.replace(/^.*[\\\/]/,"")+":"+t.lineNumber+")":n?" (created by "+n+")":"")}function a(e){return null==e?"#empty":"string"==typeof e||"number"==typeof e?"#text":"string"==typeof e.type?e.type:e.type.displayName||e.type.name||"Unknown"}function s(e){var t,n=T.getDisplayName(e),r=T.getElement(e),o=T.getOwnerID(e);return o&&(t=T.getDisplayName(o)),i(n,r&&r._source,t)}var u,l,c,p,d,f,h,m=n(91),g=n(56),v=(n(1),n(5),"function"==typeof Array.from&&"function"==typeof Map&&r(Map)&&null!=Map.prototype&&"function"==typeof Map.prototype.keys&&r(Map.prototype.keys)&&"function"==typeof Set&&r(Set)&&null!=Set.prototype&&"function"==typeof Set.prototype.keys&&r(Set.prototype.keys));if(v){var b=new Map,y=new Set;u=function(e,t){b.set(e,t)},l=function(e){return b.get(e)},c=function(e){b.delete(e)},p=function(){return Array.from(b.keys())},d=function(e){y.add(e)},f=function(e){y.delete(e)},h=function(){return Array.from(y.keys())}}else{var _={},E={},w=function(e){return"."+e},S=function(e){return parseInt(e.substr(1),10)};u=function(e,t){var n=w(e);_[n]=t},l=function(e){var t=w(e);return _[t]},c=function(e){var t=w(e);delete _[t]},p=function(){return Object.keys(_).map(S)},d=function(e){var t=w(e);E[t]=!0},f=function(e){var t=w(e);delete E[t]},h=function(){return Object.keys(E).map(S)}}var x=[],T={onSetChildren:function(e,t){var n=l(e);n||m("144"),n.childIDs=t;for(var r=0;r<t.length;r++){var o=t[r],i=l(o);i||m("140"),null==i.childIDs&&"object"==typeof i.element&&null!=i.element&&m("141"),i.isMounted||m("71"),null==i.parentID&&(i.parentID=e),i.parentID!==e&&m("142",o,i.parentID,e)}},onBeforeMountComponent:function(e,t,n){u(e,{element:t,parentID:n,text:null,childIDs:[],isMounted:!1,updateCount:0})},onBeforeUpdateComponent:function(e,t){var n=l(e);n&&n.isMounted&&(n.element=t)},onMountComponent:function(e){var t=l(e);t||m("144"),t.isMounted=!0,0===t.parentID&&d(e)},onUpdateComponent:function(e){var t=l(e);t&&t.isMounted&&t.updateCount++},onUnmountComponent:function(e){var t=l(e);if(t){t.isMounted=!1;0===t.parentID&&f(e)}x.push(e)},purgeUnmountedComponents:function(){if(!T._preventPurging){for(var e=0;e<x.length;e++){o(x[e])}x.length=0}},isMounted:function(e){var t=l(e);return!!t&&t.isMounted},getCurrentStackAddendum:function(e){var t="";if(e){var n=a(e),r=e._owner;t+=i(n,e._source,r&&r.getName())}var o=g.current;return t+=T.getStackAddendumByID(o&&o._debugID)},getStackAddendumByID:function(e){for(var t="";e;)t+=s(e),e=T.getParentID(e);return t},getChildIDs:function(e){var t=l(e);return t?t.childIDs:[]},getDisplayName:function(e){var t=T.getElement(e);return t?a(t):null},getElement:function(e){var t=l(e);return t?t.element:null},getOwnerID:function(e){var t=T.getElement(e);return t&&t._owner?t._owner._debugID:null},getParentID:function(e){var t=l(e);return t?t.parentID:null},getSource:function(e){var t=l(e),n=t?t.element:null;return null!=n?n._source:null},getText:function(e){var t=T.getElement(e);return"string"==typeof t?t:"number"==typeof t?""+t:null},getUpdateCount:function(e){var t=l(e);return t?t.updateCount:0},getRootIDs:h,getRegisteredIDs:p};e.exports=T},function(e,t,n){"use strict";e.exports="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103},function(e,t,n){"use strict";var r=!1;e.exports=r},function(e,t,n){"use strict";function r(){for(var e=arguments.length,t=Array(e),n=0;n<e;n++)t[n]=arguments[n];if(0===t.length)return function(e){return e};if(1===t.length)return t[0];var r=t[t.length-1],o=t.slice(0,-1);return function(){return o.reduceRight(function(e,t){return t(e)},r.apply(void 0,arguments))}}t.a=r},function(e,t,n){"use strict";function r(e,t,i){function u(){b===v&&(b=v.slice())}function l(){return g}function c(e){if("function"!=typeof e)throw new Error("Expected listener to be a function.");var t=!0;return u(),b.push(e),function(){if(t){t=!1,u();var n=b.indexOf(e);b.splice(n,1)}}}function p(e){if(!n.i(o.a)(e))throw new Error("Actions must be plain objects. Use custom middleware for async actions.");if(void 0===e.type)throw new Error('Actions may not have an undefined "type" property. Have you misspelled a constant?');if(y)throw new Error("Reducers may not dispatch actions.");try{y=!0,g=m(g,e)}finally{y=!1}for(var t=v=b,r=0;r<t.length;r++)t[r]();return e}function d(e){if("function"!=typeof e)throw new Error("Expected the nextReducer to be a function.");m=e,p({type:s.INIT})}function f(){var e,t=c;return e={subscribe:function(e){function n(){e.next&&e.next(l())}if("object"!=typeof e)throw new TypeError("Expected the observer to be an object.");return n(),{unsubscribe:t(n)}}},e[a.a]=function(){return this},e}var h;if("function"==typeof t&&void 0===i&&(i=t,t=void 0),void 0!==i){if("function"!=typeof i)throw new Error("Expected the enhancer to be a function.");return i(r)(e,t)}if("function"!=typeof e)throw new Error("Expected the reducer to be a function.");var m=e,g=t,v=[],b=v,y=!1;return p({type:s.INIT}),h={dispatch:p,subscribe:c,getState:l,replaceReducer:d},h[a.a]=f,h}n.d(t,"b",function(){return s}),t.a=r;var o=n(170),i=n(742),a=n.n(i),s={INIT:"@@redux/INIT"}},function(e,t,n){"use strict"},function(e,t,n){"use strict";var r=n(123),o=n(252),i=r.call(Function.call,String.prototype.slice);e.exports=function(e){var t,n=o.RequireObjectCoercible(this),r=o.ToString(n),a=o.ToLength(r.length);arguments.length>1&&(t=arguments[1]);var s=void 0===t?"":o.ToString(t);""===s&&(s=" ");var u=o.ToLength(e);if(u<=a)return r;for(var l=u-a;s.length<l;){var c=s.length,p=l-c;s+=c>p?i(s,0,p):s}return(s.length>l?i(s,0,l):s)+r}},function(e,t,n){"use strict";var r=n(299);e.exports=function(){return"function"==typeof String.prototype.padStart?String.prototype.padStart:r}},function(e,t,n){"use strict";(function(e){function t(e,t,n){e[t]||Object[r](e,t,{writable:!0,configurable:!0,value:n})}if(n(586),n(739),n(406),e._babelPolyfill)throw new Error("only one instance of babel-polyfill is allowed");e._babelPolyfill=!0;var r="defineProperty";t(String.prototype,"padLeft","".padStart),t(String.prototype,"padRight","".padEnd),"pop,reverse,shift,keys,values,entries,indexOf,every,some,forEach,map,filter,find,findIndex,includes,join,slice,concat,push,splice,unshift,sort,lastIndexOf,reduce,reduceRight,copyWithin,fill".split(",").forEach(function(e){[][e]&&t(Array,e,Function.call.bind([][e]))})}).call(t,n(34))},function(e,t,n){function r(){}var o=n(625),i=n(626),a=n(169);t.create=function(e){function t(){return(new Date).getTime()-v}function n(){if(!y){y=!0,a.log("ads","widget",h.trackingKey,"unfilled"),clearTimeout(g),m.adUnfilled(t());try{h.callbacks.onAdUnfilled()}catch(e){throw a.log("ads","widget","ad callback onAdUnfilled threw an error",e),e}}}function s(){a.log("ads","widget",h.trackingKey,"failed"),clearTimeout(g),m.adFailed(t());try{h.callbacks.onAdFailed()}catch(e){throw a.log("ads","widget","ad callback onAdFailed threw an error",e),e}}function u(){return b===!0||y===!0||_===!0}function l(){a.log("ads","widget",h.trackingKey,"timeout"),u()===!1&&(m.adTimeout(t()),s())}function c(){if(!_){_=!0,a.log("ads","widget",h.trackingKey,"viewable"),clearTimeout(g),m.adViewable(t());try{h.callbacks.onAdViewable()}catch(e){throw a.log("ads","widget","ad callback onAdViewable threw an error",e),e}}}function p(){if(!b){b=!0,a.log("ads","widget",h.trackingKey,"filled"),clearTimeout(g),m.adLoaded(t());try{h.callbacks.onAdFilled()}catch(e){throw a.log("ads","widget","ad callback onAdFilled threw an error",e),e}}}function d(){o.create({rootElm:h.rootElm,config:h.adProviderConfig,callbacks:{onAdFilled:p,onAdFailed:s,onAdViewable:c,onAdUnfilled:n},targeting:h.dfpTargeting}),m.adRequested(t()),a.log("ads","widget",h.trackingKey,"requested")}function f(){v=(new Date).getTime(),g=setTimeout(l,1e4),d()}var h,m,g,v,b=!1,y=!1,_=!1;return function(){h=e||{},h=Object.assign({},{adProviderConfig:{},dfpTargeting:[],isProductionEnv:!0,trackingKey:"",callbacks:{onAdFilled:r,onAdFailed:r,onAdViewable:r,onAdUnfilled:r}},h),m=i.create({trackingKey:h.trackingKey,isProductionEnv:h.isProductionEnv})}(),{show:f}}},function(e,t,n){(function(t){(function(){var n,r,o;"undefined"!=typeof performance&&null!==performance&&performance.now?e.exports=function(){return performance.now()}:void 0!==t&&null!==t&&t.hrtime?(e.exports=function(){return(n()-o)/1e6},r=t.hrtime,n=function(){var e;return e=r(),1e9*e[0]+e[1]},o=n()):Date.now?(e.exports=function(){return Date.now()-o},o=Date.now()):(e.exports=function(){return(new Date).getTime()-o},o=(new Date).getTime())}).call(this)}).call(t,n(107))},function(e,t,n){(function(t){for(var r=n(303),o="undefined"==typeof window?t:window,i=["moz","webkit"],a="AnimationFrame",s=o["request"+a],u=o["cancel"+a]||o["cancelRequest"+a],l=0;!s&&l<i.length;l++)s=o[i[l]+"Request"+a],u=o[i[l]+"Cancel"+a]||o[i[l]+"CancelRequest"+a];if(!s||!u){var c=0,p=0,d=[];s=function(e){if(0===d.length){var t=r(),n=Math.max(0,1e3/60-(t-c));c=n+t,setTimeout(function(){var e=d.slice(0);d.length=0;for(var t=0;t<e.length;t++)if(!e[t].cancelled)try{e[t].callback(c)}catch(e){setTimeout(function(){throw e},0)}},Math.round(n))}return d.push({handle:++p,callback:e,cancelled:!1}),p},u=function(e){for(var t=0;t<d.length;t++)d[t].handle===e&&(d[t].cancelled=!0)}}e.exports=function(e){return s.call(o,e)},e.exports.cancel=function(){u.apply(o,arguments)},e.exports.polyfill=function(){o.requestAnimationFrame=s,o.cancelAnimationFrame=u}}).call(t,n(34))},function(e,t,n){"use strict";t.__esModule=!0,t.FindButton=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(20),a=babelHelpers.interopRequireDefault(i),s=n(405),u=babelHelpers.interopRequireDefault(s);t.FindButton=function(e){function t(n){babelHelpers.classCallCheck(this,t);var r=babelHelpers.possibleConstructorReturn(this,e.call(this,n));return r.onClick=r.onClick.bind(r),r}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.props.featureTracker.opportunity("BUTTON_OPEN_FIND")},t.prototype.onClick=function(){this.props.featureTracker.usage("BUTTON_OPEN_FIND"),this.props.onClick()},t.prototype.render=function(){var e=this.props.findAvailable,t=e?"Find":"Find is not available";return o.default.createElement("div",{className:(0,a.default)("controls__find-button",{"controls__find-button--disabled":!e}),"data-tooltip":t},o.default.createElement("button",{type:"button",className:(0,a.default)("find-button svg-btn",{"svg-btn--disabled":!e}),onClick:this.onClick,dangerouslySetInnerHTML:{__html:u.default},disabled:!e}))},t}(r.Component)},function(e,t,n){"use strict";t.__esModule=!0,t.FindOverlay=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(20),a=babelHelpers.interopRequireDefault(i),s=n(46),u=babelHelpers.interopRequireDefault(s),l=n(404),c=babelHelpers.interopRequireDefault(l),p=n(403),d=babelHelpers.interopRequireDefault(p),f=n(402),h=babelHelpers.interopRequireDefault(f);t.FindOverlay=function(e){function t(n){babelHelpers.classCallCheck(this,t);var r=babelHelpers.possibleConstructorReturn(this,e.call(this,n));return r.state={timerId:null,lastValue:"",showSpinner:!1},r.handleKeyDown=r.handleKeyDown.bind(r),r.next=r.next.bind(r),r.previous=r.previous.bind(r),r.search=r.search.bind(r),r.close=r.close.bind(r),r.focusInputField=r.focusInputField.bind(r),r}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.props.isVisible&&(this.refs.input.focus(),this.props.featureTracker.opportunity("FIND_QUERY"),this.props.featureTracker.opportunity("FIND_NEXT"),this.props.featureTracker.opportunity("FIND_PREV"),this.props.featureTracker.opportunity("FIND_CLOSE"))},t.prototype.componentWillReceiveProps=function(e){e.textInfo&&this.setState({showSpinner:!1})},t.prototype.shouldComponentUpdate=function(e,t){var n=!(0,u.default)(this.props,e),r=this.state.showSpinner!==t.showSpinner;return n||r},t.prototype.componentDidUpdate=function(e,t){this.props.isVisible&&!e.isVisible?(this.refs.input.focus(),this.props.featureTracker.opportunity("FIND_QUERY"),this.props.featureTracker.opportunity("FIND_NEXT"),this.props.featureTracker.opportunity("FIND_PREV"),this.props.featureTracker.opportunity("FIND_CLOSE")):!this.props.isVisible&&e.isVisible&&this.refs.input.blur(),t.showSpinner&&!this.state.showSpinner&&this.search(this.refs.input.value)},t.prototype.handleKeyDown=function(e){var t=this;clearTimeout(this.state.timerId);var n=e.target,r=null;71===e.keyCode&&e.metaKey?(e.preventDefault(),e.shiftKey?this.previous():this.next()):"Enter"===e.key?(this.state.lastValue===n.value?e.shiftKey?this.previous():this.next():(this.search(n.value),this.setState({lastValue:n.value})),this.props.isMobile&&n.blur()):this.props.enableIncrementalSearch&&(r=setTimeout(function(){t.state.lastValue!==n.value&&(t.search(n.value),t.setState({lastValue:n.value}))},500)),this.setState({timerId:r})},t.prototype.next=function(){this.props.featureTracker.usage("FIND_NEXT"),this.props.onNextButtonClick()},t.prototype.previous=function(){this.props.featureTracker.usage("FIND_PREV"),this.props.onPreviousButtonClick()},t.prototype.search=function(e){this.props.featureTracker.usage("FIND_QUERY"),this.props.textInfo?this.props.onSearch(e,this.props.textInfo,this.props.currentPage):this.setState({showSpinner:!0})},t.prototype.close=function(){this.props.featureTracker.usage("FIND_CLOSE"),this.props.onCloseButtonClick()},t.prototype.focusInputField=function(){this.refs.input.focus()},t.prototype.render=function(){var e=this.props,t=e.isVisible,n=e.currentResult,r=e.numberOfResults,i=e.isMobile,s=e.Spinner,u=this.state.showSpinner;return o.default.createElement("div",{className:(0,a.default)("find-widget",{"find-widget--hidden":!t})},o.default.createElement("button",{className:"find-widget__button find-widget__close-button",type:"button",dangerouslySetInnerHTML:{__html:c.default},onClick:this.close}),o.default.createElement("form",{className:"find-widget__input-wrapper",action:"javascript:void(0)"},o.default.createElement("input",{className:(0,a.default)("find-widget__input",{"find-widget__input--large-font":i}),ref:"input",type:"search",onKeyDown:this.handleKeyDown,placeholder:"Find in publication..."}),o.default.createElement("div",{className:"find-widget__results-wrapper"},"number"==typeof r&&o.default.createElement("span",{className:"find-widget__results"},n," of ",r),u&&o.default.createElement(s,{size:s.SPINNER_SIZE_TINY}))),o.default.createElement("button",{className:(0,a.default)("find-widget__button","find-widget__previous-button",{"find-widget__button--disabled":!r}),dangerouslySetInnerHTML:{__html:h.default},type:"button",onClick:this.previous,onFocus:this.focusInputField,disabled:!r}),o.default.createElement("button",{className:(0,a.default)("find-widget__button","find-widget__next-button",{"find-widget__button--disabled":!r}),dangerouslySetInnerHTML:{__html:d.default},type:"button",onClick:this.next,onFocus:this.focusInputField,disabled:!r}))},t}(o.default.Component)},function(e,t,n){"use strict";function r(e){function t(e){return function(){for(var t=arguments.length,n=Array(t),o=0;o<t;o++)n[o]=arguments[o];return function(t,o){t(e.apply(void 0,n));var i=o(),a=(0,l.selectCurrentResult)(i);a&&r(i,a.pageNo)}}}var n=e.enableWebGL,r=e.jumpToPageNumber,c=e.pageNumberToSpreadIndex,p=e.resetZoom,d=e.selectCurrentPage,f=e.selectReadMode,h=e.selectSpreadCount,m=e.isMobile,g=e.Spinner,v=(0,l.findStringFactory)(u.find),b=t(v),y=t(l.setCurrentResultIdx),_=function(){return function(e,t){e((0,l.openFindDialog)()),e(n()),p(t())}},E=(0,o.connect)(function(e){return{isVisible:(0,l.isVisible)(e),findAvailable:(0,l.selectIsAvailable)(e)}},{closeFindDialog:l.closeFindDialog,openFindDialog:_},function(e,t,n){return Object.assign({},n,e,{onClick:e.isVisible?t.closeFindDialog:t.openFindDialog,findAvailable:e.findAvailable})})(a.FindButton),w=function(e){return{isMobile:m,isVisible:(0,l.isVisible)(e),currentResult:(0,l.selectCurrentResultNo)(e),numberOfResults:(0,l.selectNumberOfResults)(e),textInfo:(0,l.selectTextInfo)(e),currentPage:d(e),nextResultIdx:(0,l.selectNextResultIdx)(e),previousResultIdx:(0,l.selectPreviousResultIdx)(e),Spinner:g}},S={onCloseButtonClick:l.closeFindDialog,onSearch:b,setCurrentResultIdx:y},x=function(e,t,n){return Object.assign({},n,e,{onSearch:t.onSearch,onCloseButtonClick:t.onCloseButtonClick,onNextButtonClick:function(){return t.setCurrentResultIdx(e.nextResultIdx)},onPreviousButtonClick:function(){return t.setCurrentResultIdx(e.previousResultIdx)}})},T=(0,o.connect)(w,S,x)(i.FindOverlay);return{actions:{setTextInfoUrl:l.setTextInfoUrl,openFindDialog:_,closeFindDialog:l.closeFindDialog},components:{FindOverlay:T,FindButton:E,SliderMarkers:s.SliderMarkers},createReducer:l.createReducer,selectors:{isVisible:l.isVisible,selectResults:l.selectResults,selectCurrentResult:l.selectCurrentResult,selectTextInfoPageModels:l.selectTextInfoPageModels,selectIsAvailable:l.selectIsAvailable,selectResultMarkers:(0,l.createSelectResultMarkers)(l.isVisible,h,f,c)}}}t.__esModule=!0,t.default=r;var o=n(55),i=n(306),a=n(305),s=n(308),u=n(108),l=n(309)},function(e,t,n){"use strict";t.__esModule=!0,t.SliderMarkers=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(46),a=babelHelpers.interopRequireDefault(i);t.SliderMarkers=function(e){function t(n){babelHelpers.classCallCheck(this,t);var r=babelHelpers.possibleConstructorReturn(this,e.call(this,n));return r.redraw=r.redraw.bind(r),r.resize=r.resize.bind(r),r}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){window.addEventListener("resize",this.resize),requestAnimationFrame(this.redraw)},t.prototype.shouldComponentUpdate=function(e){return!(0,a.default)(this.props,e)},t.prototype.componentDidUpdate=function(e){requestAnimationFrame(this.redraw)},t.prototype.componentWillUnmount=function(){window.removeEventListener("resize",this.resize)},t.prototype.resize=function(){requestAnimationFrame(this.redraw)},t.prototype.redraw=function(){var e=this.props.markers,t=this.refs.canvas;if(t){var n=t.getContext("2d");if(n){var r=t.width=t.clientWidth;n.clearRect(0,0,r,1),n.fillStyle="yellow",e.forEach(function(e){n.fillRect(Math.round(e*(r-1)),0,1,1)})}}},t.prototype.render=function(){return o.default.createElement("canvas",{ref:"canvas",className:"slider-markers",height:1})},t}(r.Component)},function(e,t,n){"use strict";function r(){return function(e,t){var n=t().find.textInfoUrl;if(!n)throw new Error("attempting to with find textInfoUrl unset!");(0,p.loadFindData)("//"+n).then(function(t){e({type:"TEXT_INFO",textInfo:t})}),e({type:"FIND_OPEN_DIALOG"})}}function o(){return{type:"FIND_CLOSE_DIALOG"}}function i(e){return{type:"FIND_SET_CURRENT_RESULT",idx:e}}function a(e){return function(t,n,r){if(t){var o=e(t,n),i=o.findIndex(function(e){return e.pageNo>=r});return{type:"FIND_SET_RESULTS",results:o,currentResultIdx:i<0?o.length-1:i}}return{type:"FIND_SET_RESULTS",results:null,currentResultIdx:null}}}function s(e,t){return{type:"FIND_SET_TEXT_INFO_URL",url:e,version:t}}function u(e){return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:d,n=arguments[1];switch(n.type){case"FIND_OPEN_DIALOG":return Object.assign({},t,{isVisible:!0});case"FIND_CLOSE_DIALOG":return Object.assign({},t,{isVisible:!1});case"FIND_SET_TEXT_INFO_URL":return Object.assign({},t,{textInfoUrl:n.url,version:n.version});case"TEXT_INFO":return Object.assign({},t,{textInfo:n.textInfo});case"FIND_SET_RESULTS":return Object.assign({},t,{results:n.results,currentResultIdx:n.currentResultIdx});case"FIND_SET_CURRENT_RESULT":return Object.assign({},t,{currentResultIdx:n.idx});case e:if(t.results){var r=n.currentPageNumber,o=t.results.findIndex(function(e){return e.pageNo>=r});return Object.assign({},t,{currentResultIdx:o<0?t.currentResultIdx:o})}return t;default:return t}}}function l(e,t,n,r){return(0,c.createSelector)(e,t,n,f,function(e,t,n,o){if(!e||!n)return[];var i=o.reduce(function(e,t){return e.add(r(n,t.pageNo))},new Set);return Array.from(i).map(function(e){return e*(1/t)})})}t.__esModule=!0,t.selectIsAvailable=t.selectTextInfoPageModels=t.selectTextInfo=t.selectPreviousResult=t.selectNextResult=t.selectCurrentResult=t.selectPreviousResultIdx=t.selectNextResultIdx=t.selectCurrentResultIdx=t.selectCurrentResultNo=t.selectNumberOfResults=t.selectResults=t.isVisible=t.initialState=void 0,t.openFindDialog=r,t.closeFindDialog=o,t.setCurrentResultIdx=i,t.findStringFactory=a,t.setTextInfoUrl=s,t.createReducer=u,t.createSelectResultMarkers=l;var c=n(33),p=n(108),d=t.initialState={isVisible:!1,results:null,textInfo:null,textInfoUrl:null,version:null,currentResultIdx:null},f=(t.isVisible=function(e){return e.find.isVisible},t.selectResults=(0,c.createSelector)(function(e){return e.find.results},function(e){return e||[]})),h=(t.selectNumberOfResults=function(e){return Array.isArray(e.find.results)?e.find.results.length:null},t.selectCurrentResultNo=function(e){return"number"==typeof e.find.currentResultIdx?e.find.currentResultIdx+1:0}),m=t.selectCurrentResultIdx=(0,c.createSelector)(h,function(e){return e-1}),g=t.selectNextResultIdx=(0,c.createSelector)(f,m,function(e,t){return e.length?(t+1)%e.length:t}),v=t.selectPreviousResultIdx=(0,c.createSelector)(f,m,function(e,t){return e.length?(t+e.length-1)%e.length:t}),b=(t.selectCurrentResult=(0,c.createSelector)(f,m,function(e,t){return e[t]}),t.selectNextResult=(0,c.createSelector)(f,g,function(e,t){return e[t]}),t.selectPreviousResult=(0,c.createSelector)(f,v,function(e,t){return e[t]}),t.selectTextInfo=function(e){return e.find.textInfo});t.selectTextInfoPageModels=(0,c.createSelector)(b,function(e){return e?e.pages.map(function(e){return{width:e.width,height:e.height,pageNumber:e.pageNumber}}):[]}),t.selectIsAvailable=function(e){return!!e.find.textInfoUrl}},function(e,t,n){"use strict";function r(e){var t=e.onKeepReading,n=e.selectCurrentPageNumbers,r=e.selectHostName,u=e.selectPublicationCoverUrl,l=e.selectPublicationName,c=e.selectPublicationPageCount,p=e.selectPublicationTitle,d=e.selectPublisherDisplayName,f=e.selectPublisherName,h=e.selectPublisherProfileImageUrl,m=e.selectPublisherProfileUrl,g=e.actionTypes,v=(0,s.showKeepReadingButtonFactory)(n,c),b=function(e){return{hostName:r(e),price:e.paywall.publicationPrice,publicationName:l(e),publisherName:f(e)}},y=function(e){return{hostName:r(e),price:e.paywall.publicationPrice,publicationCoverUrl:u(e),publicationName:l(e),publicationTitle:p(e),publisherDisplayName:d(e),publisherName:f(e),publisherProfileImageUrl:h(e),publisherProfileUrl:m(e),showKeepReading:v(e)}},_=function(e){return{onKeepReading:(0,i.bindActionCreators)(t,e)}},E={pure:!0},w={PaywallButton:(0,o.connect)(b,void 0,void 0,E)(a.Button),PaywallOverlay:(0,o.connect)(y,_,void 0,E)(a.Overlay)},S={publicationLoaded:s.publicationLoaded},x=(0,s.showPaywallOverlayFactory)(n),T={isPreview:s.isPreview,previewPages:s.previewPages,isVisible:x},C=function(){return s.reducer},I={overlayDisplayed:!1,paywalledDocumentDisplayed:!1},R=g.READER_POSITION_CHANGED;return{actions:S,components:w,createReducer:C,createMiddleware:function(e){return function(t){return function(n){return function(r){var o=n(r);if(!I.paywalledDocumentDisplayed&&r){var i=t.getState();(0,s.isPreview)(i)&&(e.monitorBatched({type:"paywall.reader3.show-document"}),I.paywalledDocumentDisplayed=!0)}if(!I.overlayDisplayed&&r&&r.type===R){var a=t.getState();(0,s.isPreview)(a)&&x(a)&&(e.monitorBatched({type:"paywall.reader3.show-overlay"}),I.overlayDisplayed=!0)}return o}}}},selectors:T}}t.__esModule=!0,t.default=r;var o=n(55),i=n(190),a=n(624),s=n(311)},function(e,t,n){"use strict";function r(e){return{type:i,document:e}}t.__esModule=!0,t.showKeepReadingButtonFactory=t.showPaywallOverlayFactory=t.isPreview=t.previewPages=t.reducer=void 0,t.publicationLoaded=r;var o=n(33),i=Symbol("PAYWALL_PUBLICATION_LOADED"),a=function(){return{isPayWall:!1,isPaid:!1,listPayWallPages:[],publicationPrice:0}},s=(t.reducer=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:a(),t=arguments[1];switch(t.type){case i:var n=t.document||{},r=n.pages||[],o=r.filter(function(e){return e&&e.isPaywalledPage}).map(function(e){return e.pageNumber}).sort(function(e,t){return e-t});return Object.assign({},e,{isPayWall:!!n.isPaywalled,isPaid:!!n.paywallInfo.currentUserPurchased,publicationPrice:n.paywallInfo.price,listPayWallPages:o});default:return e}},t.previewPages=function(e){return e.paywall.listPayWallPages}),u=t.isPreview=function(e){return e.paywall.isPayWall&&!e.paywall.isPaid},l=(t.showPaywallOverlayFactory=function(e){return(0,o.createSelector)(u,e,s,function(e,t,n){return e&&t.reduce(function(e,t){return e||n.includes(t)},!1)})},function(e,t){for(var n=e;n>0;n--)if(!t.includes(n))return n;return 0});t.showKeepReadingButtonFactory=function(e,t){return(0,o.createSelector)(e,t,s,function(e,t,n){return l(t,n)>e[e.length-1]})}},function(e,t,n){"use strict";function r(e,t,n){var r=s.vec2.create(),o=s.vec2.create();return s.vec2.set(r,t,n),s.vec2.transformMat2d(o,r,e),{x:o[0],y:o[1]}}function o(e,t){var n=s.mat2d.create();return s.mat2d.multiply(n,t,e.matrix),{p1:r(n,e.x,e.y),p2:r(n,e.x+e.width,e.y),p3:r(n,e.x,e.y+e.height),p4:r(n,e.x+e.width,e.y+e.height)}}t.__esModule=!0,t.FindResults=void 0;var i=n(47),a=n(75),s=n(102),u=(n(218),n(58)),l=n(198),c=n(130),p=n(199),d=n(46),f=babelHelpers.interopRequireDefault(d);t.FindResults=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var o=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return o._lastActionTick=0,o}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(e){(0,f.default)(e.selectedResult,this.props.selectedResult)||(this._lastActionTick=this.props.selectedResult?this.root.tick:0)},t.prototype.isAnimating=function(e){return e-500<this._lastActionTick},t.prototype.draw=function(e,t,n){var r=(0,l.alignBBox)(t,this.parent.pageType),o=this.getViewportCTM().matrix;if(e.save(),this.selectedResult){e.fillStyle="rgba(255, 255, 0, 0.5)";for(var i=this.selectedResult,a=Array.isArray(i),s=0,i=a?i:i[Symbol.iterator]();;){var u;if(a){if(s>=i.length)break;u=i[s++]}else{if(s=i.next(),s.done)break;u=s.value}var c=u,p=c.matrix;e.setTransform(o[0],o[1],o[2],o[3],o[4],o[5]),e.transform(p[0],p[1],p[2],p[3],p[4],p[5]),e.fillRect(c.x,c.y,c.width,c.height)}}for(var d=this.results,f=Array.isArray(d),h=0,d=f?d:d[Symbol.iterator]();;){var m;if(f){if(h>=d.length)break;m=d[h++]}else{if(h=d.next(),h.done)break;m=h.value}for(var g=m,v=g,b=Array.isArray(v),y=0,v=b?v:v[Symbol.iterator]();;){var _;if(b){if(y>=v.length)break;_=v[y++]}else{if(y=v.next(),y.done)break;_=y.value}var E=_;e.beginPath(),e.setTransform(1,0,0,1,0,0),e.rect(r.x,r.y,r.width,r.height);var w=E.matrix;e.setTransform(o[0],o[1],o[2],o[3],o[4],o[5]),e.transform(w[0],w[1],w[2],w[3],w[4],w[5]),e.rect(E.x,E.y,E.width,E.height),e.clip("evenodd")}}e.setTransform(1,0,0,1,0,0),e.fillStyle="rgba(0, 0, 0, 0.3)",e.fillRect(r.x,r.y,r.width,r.height),e.restore()},t.prototype.appendWebglOps=function(e,t,n,r){for(var a=(0,l.alignBBox)(t,this.parent.pageType),s=this.getViewportCTM().matrix,u=this.transform.matrix,d=this.model.pageNumber,f=[],h=this.results,m=Array.isArray(h),g=0,h=m?h:h[Symbol.iterator]();;){var v;if(m){if(g>=h.length)break;v=h[g++]}else{if(g=h.next(),g.done)break;v=g.value}for(var b=v,y=b,_=Array.isArray(y),E=0,y=_?y:y[Symbol.iterator]();;){var w;if(_){if(E>=y.length)break;w=y[E++]}else{if(E=y.next(),E.done)break;w=E.value}f.push(o(w,s))}}var S=this.selectedResult,x=[],T=[];if(S)for(var C=S,I=Array.isArray(C),R=0,C=I?C:C[Symbol.iterator]();;){var M;if(I){if(R>=C.length)break;M=C[R++]}else{if(R=C.next(),R.done)break;M=R.value}var P=M,O=o(P,s),A=(0,p.getBBox)(O);if(x.push(O),this.isAnimating(r)){var D=o(P,u),k=(0,p.getBBox)(D),N=null;if(k.max.x-k.min.x>=1&&k.max.y-k.min.y>=1){var L=(A.max.x-A.min.x+40)/(k.max.x-k.min.x);N=this.props.renderManager.renderUncached([L,0,0,L,k.min.x*L*-1,k.min.y*L*-1],(k.max.x-k.min.x)*L,(k.max.y-k.min.y)*L,d)}T.push(N)}}if(e.push({type:i.HIGHLIGHT_OPERATION,args:[a,f]}),x.length){var F=x.reduce(function(e,t){var n=(0,p.getBBox)(t);return e.left=Math.min(n.min.x,e.left),e.top=Math.min(n.min.y,e.top),e.right=Math.max(n.max.x,e.right),e.bottom=Math.max(n.max.y,e.bottom),e},{left:1/0,top:1/0,right:-(1/0),bottom:-(1/0)}),U=Math.max(F.right-F.left,F.bottom-F.top),H=(r-this._lastActionTick)/500,B=H<.5?(U+(0,c.easeOutQuad)(0,40,2*H))/U:(U+(0,c.easeInQuad)(40,0,2*(H-.5)))/U;e.push({type:i.HIGHLIGHT_FLASH_OPERATION,args:[x,T,{x:(F.left+F.right)/2,y:(F.top+F.bottom)/2},B]})}},t.prototype.afterDraw=function(e,t){this.isAnimating(t)&&this.requestRedraw()},babelHelpers.createClass(t,[{key:"isVisible",get:function(){return!!this.model&&u.selectors.isVisible(this.root.__store__.getState())}},{key:"width",get:function(){return this.model?this.model.width:0}},{key:"height",get:function(){return this.model?this.model.height:0}},{key:"results",get:function(){return this.props.results}},{key:"selectedResult",get:function(){return this.props.selectedResult}},{key:"model",get:function(){return this.props.model}},{key:"transform",get:function(){return this._transform||(this._transform=new a.MatrixTransformation),this.width&&this.height&&this._transform.mSet(this.parent.width/this.width,0,0,this.parent.height/this.height,0,0),this._transform}}]),t}(i.CanvasObject)},function(e,t,n){"use strict";t.__esModule=!0,t.HorizontalList=void 0;var r=n(75),o=n(47),i=n(200),a=n(212),s=n(8),u=babelHelpers.interopRequireWildcard(s),l=n(77),c=babelHelpers.interopRequireWildcard(l),p=n(79),d=n(35),f=n(21),h=n(40),m=n(57);t.HorizontalList=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var o=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return o._isSnapped=!0,o._scrollerMovedLastFrame=!1,o._lastVisiblePages="",o._lastPositionInPercent=0,o._spreadIndexBeforeGestureStart=0,o.scroller=new a.Scroller(0,0,1,o.props.viewportWidth,o.props.viewportHeight,o.width,o.height),o._lastCenterSpreadIndex=o.props.currentSpreadIndex,o}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.scroller.resize(0,0,1,this.props.viewportWidth,this.props.viewportHeight,this.width,this.height),this.scroller.setSnap(!0,function(t,n,r){var i=e.getSpreadIndexAt(n+e.props.viewportWidth/2),a=e.children[i].unzoomedBBox,s=a.x-e.xMargin;return o.CanvasObject.RectPool.release(a),{left:s,top:0,zoom:1}},!1);var t=this.props.currentSpreadIndex,n=this.children[t].unzoomedBBox;this.scroller.jumpTo(0,n.x-this.xMargin,1),o.CanvasObject.RectPool.release(n),this.props.featureTracker.opportunity(f.FEATURES.DOUBLE_TAP_ZOOM),this.props.featureTracker.opportunity(f.FEATURES.GESTURE_PINCH_ZOOM),this.props.canChangePages&&this.props.featureTracker.opportunity(f.FEATURES.GESTURE_DRAG_PAGES)},t.prototype.componentDidUpdate=function(e){if(this.props.viewportWidth!==e.viewportWidth||this.props.viewportHeight!==e.viewportHeight){var t=this.children[this._lastCenterSpreadIndex],n=t.unzoomedBBox;this.scroller.resize(0,n.x-this.xMargin,1,this.props.viewportWidth,this.props.viewportHeight,this.width,this.height),o.CanvasObject.RectPool.release(n)}},t.prototype.getChildrenToTraverse=function(){var e=this.getSpreadIndexAt(this.scroller.left),t=this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth-1);return this.children.slice(Math.max(e,0),Math.min(t,this.children.length-1)+1)},t.prototype.onGestureStart=function(e,t,n,r,o){return this._spreadIndexBeforeGestureStart=this.props.currentSpreadIndex,this.scroller.touchStart(e,t,o),1===r.length},t.prototype.onGestureChange=function(e,t,n,r,o,i,a){return(a===c.SWIPE_LEFT||a===c.SWIPE_RIGHT)&&1===r.length&&(this.scroller.touchMove(e,t,o,i),this.requestRedraw(),!0)},t.prototype.onGestureEnd=function(e,t){return this.scroller.touchEnd(t,e),this.props.currentSpreadIndex!==this._spreadIndexBeforeGestureStart&&this.props.featureTracker.usage(f.FEATURES.GESTURE_DRAG_PAGES),this.scroller.isMoving&&this.requestRedraw(),!0},t.prototype.onSingleTapConfirmed=function(e,t,n,r){var o=this.getCurrentSpread(),i=o.children[0].viewportBBox;if(o.children.length>1){var a=o.children[1].viewportBBox;i.width+=a.width,i.height=Math.max(i.height,a.height),i.y=Math.min(i.y,a.y)}if(t>i.y&&t<i.y+i.height){var s=this.children.indexOf(o);if(e<i.x)return this.goToSpread(s-1,n),!0;if(e>i.x+i.width)return this.goToSpread(s+1,n),!0}return!1},t.prototype.getCurrentSpreadIndex=function(){return this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth/2)},t.prototype.getCurrentSpread=function(){return this.children[this.getCurrentSpreadIndex()]},t.prototype.getVisiblePages=function(){for(var e=[],t=Math.max(this.getSpreadIndexAt(this.scroller.left),0),n=this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth-1),r=o.CanvasObject.RectPool.get(0,0,this.props.viewportWidth,this.props.viewportHeight),i=t;i<=n;i++)for(var a=this.children[i],s=a.children,u=Array.isArray(s),l=0,s=u?s:s[Symbol.iterator]();;){var c;if(u){if(l>=s.length)break;c=s[l++]}else{if(l=s.next(),l.done)break;c=l.value}var d=c,f=d.viewportBBox;(0,p.overlap)(r,f)&&e.push(d.model),o.CanvasObject.RectPool.release(f)}return o.CanvasObject.RectPool.release(r),e},t.prototype.setSnapping=function(e,t){this.scroller.setSnap(e,null,!0,t),this.requestRedraw()},t.prototype.jumpToPositionByPercent=function(e,t){this.getCurrentSpread().setZoom(1),this.scroller.jumpTo(0,e*(this.width-this.props.viewportWidth)/100),this.requestRedraw()},t.prototype.goToSpread=function(e,t){if(this.getCurrentSpreadIndex()!==e){this.getCurrentSpread().setZoom(1);var n=Math.max(Math.min(e,this.children.length-1),0),r=this.children[n].unzoomedBBox;this.scroller.scrollTo(0,r.x-this.xMargin,1,t),o.CanvasObject.RectPool.release(r),this.requestRedraw()}},t.prototype.jumpToSpread=function(e,t){if(this.getCurrentSpreadIndex()!==e){this.getCurrentSpread().setZoom(1);var n=Math.max(Math.min(e,this.children.length-1),0),r=this.children[n].unzoomedBBox;this.scroller.jumpTo(0,r.x-this.xMargin,1),o.CanvasObject.RectPool.release(r),this.requestRedraw()}},t.prototype.getSpreadIndexAt=function(e){var t=Math.floor((e-this.xMargin)/(this.props.viewportWidth-this.xMargin-this.xOverlap));return Math.min(Math.max(t,0),this.children.length-1)},t.prototype.getChildTree=function(){var e=this;return this.props.documentPageSpreadList.map(function(t,n){var a=(e.props.viewportWidth-e.xMargin-e.xOverlap)*n+e.xMargin,s=new r.MatrixTransformation;return s.mTranslate(a,e.yMargin),o.CanvasObject.createElement(i.Spread,{dispatch:e.props.dispatch,featureTracker:e.props.featureTracker,height:e.props.viewportHeight-2*e.yMargin,hideLinkToolTip:e.props.hideLinkToolTip,isCurrentSpread:n===e.props.currentSpreadIndex,isLinksToggledOn:e.props.isLinksToggledOn,isSnapped:e._isSnapped,mayRenderLinks:e.props.mayRenderLinks,pageModels:t.pages?t.pages:[t],paywalledPageStatus:t.pages?t.pages.map(function(t){return e.props.paywalledPageNumbers.includes(t.pageNumber)}):[e.props.paywalledPageNumbers.includes(t.pageNumber)],readMode:e.props.readMode,showLinkToolTip:e.props.showLinkToolTip,transform:s,width:e.props.viewportWidth-2*e.xMargin,renderManager:e.props.renderManager})})},t.prototype.afterDraw=function(e,t){var n=this.scroller.isDragging||this.scroller.isAnimating||this.scroller.isMoving;this.scroller.update(t);var r=this.scroller.isDragging||this.scroller.isAnimating||this.scroller.isMoving;(r||n)&&(this._isSnapped?(this._isSnapped=!1,this.forceUpdate()):this.requestRedraw()),r||!this.scroller.isSnapped()||this._isSnapped?this._isSnapped||this.requestRedraw():(this._isSnapped=!0,this.forceUpdate()),!this._scrollerMovedLastFrame&&r?this.props.onAnimationStart():this._scrollerMovedLastFrame&&!r&&this.props.onAnimationEnd(),this._scrollerMovedLastFrame=r,this.getCurrentSpreadIndex()!==this.props.currentSpreadIndex&&this.props.onSpreadChange(this.getCurrentSpreadIndex());var o=this.getVisiblePages(),i=o.map(function(e){return e.pageNumber}).join()!==this._lastVisiblePages;this._lastVisiblePages=o.map(function(e){return e.pageNumber}).join();var a=this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth/2),s=this._lastCenterSpreadIndex!==a,l=this.children[a].children.map(function(e){return e.model}),c=this.props.currentPageNumber;if(s)c=l[0].pageNumber;else if(!o.find(function(e){return e.pageNumber===c})){var p=o.find(function(e){return l.includes(e)});p&&(c=p.pageNumber)}this._lastCenterSpreadIndex=a;var d=this.scroller.getHorizontalPositionInPercent(),f=d!==this._lastPositionInPercent;if(this._lastPositionInPercent=d,(f||s||i)&&this.props.dispatch(u.readerPositionChanged(o,a,c,l,d,f,s,i,this.scroller.isDragging)),i){var h=o.map(function(e){return e.pageNumber}),m=l.map(function(e){return e.pageNumber});this.props.renderManager.setActivePages(Array.from(new Set([].concat(h,m))))}},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"HorizontalList"}},{key:"width",get:function(){var e=this.children?this.children.length:0;return this.props.viewportWidth*e-(this.xMargin+this.xOverlap)*(e-1)}},{key:"height",get:function(){return this.props.viewportHeight}},{key:"transform",get:function(){return this._transform||(this._transform=new r.MatrixTransformation),this._transform.mReset().mTranslate(-this.scroller.left,-this.scroller.top),this._transform}},{key:"inAnimation",get:function(){return!!this.scroller.isMoving||this.parent.inAnimation}},{key:"xMargin",get:function(){var e=this.props.readMode===h.DOUBLE_PAGE_SPREAD?m.SPACE_HORIZONTAL_DPS_IN_PIXELS:m.SPACE_HORIZONTAL_SPS_IN_PIXELS;return(0,d.getDPR)()*e}},{key:"yMargin",get:function(){var e=0;return e=this.props.readMode===h.DOUBLE_PAGE_SPREAD?this.props.allowUIToOverlayCover?m.SPACE_VERTICAL_DPS_IN_PIXELS:m.SPACE_VERTICAL_NO_UI_OVERLAP_DPS_IN_PIXELS:this.props.allowUIToOverlayCover?m.SPACE_VERTICAL_SPS_IN_PIXELS:m.SPACE_VERTICAL_NO_UI_OVERLAP_SPS_IN_PIXELS,(0,d.getDPR)()*e}},{key:"xOverlap",get:function(){return 0}}]),t}(o.CanvasObject)},function(e,t,n){"use strict";t.__esModule=!0,t.default={w:36,h:36,d:[function(e,t){e.save(),t.stack++,e.strokeStyle="rgba(0,0,0,0)",e.lineCap="butt",e.lineJoin="miter",e.miterLimit=4,e.translate(0,0),e.translate(0,0),e.translate(0,0),e.scale(1,1),e.translate(0,0),e.save(),t.stack++,e.fillStyle="rgba(0,0,0,0)",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.translate(8,10),e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.beginPath(),e.moveTo(16.683499,11.621507),e.bezierCurveTo(15.72267,11.621507,14.892862,12.262398,14.630817,13.116921),e.lineTo(7.861335,13.116921),e.bezierCurveTo(7.59929,12.347851,6.987853,11.792411,6.158046,11.664233),e.lineTo(6.027023,10.766984),e.lineTo(17.513307,9.228843),e.bezierCurveTo(17.819025,9.186117,18.08107,8.929761,18.08107,8.587952),e.lineTo(18.08107,2.520841),e.bezierCurveTo(18.08107,2.179032,17.775351,1.87995,17.425959,1.87995),e.lineTo(4.760475,1.87995),e.lineTo(4.585779,.55544),e.bezierCurveTo(4.542105,.256357,4.28006,0,3.930667,0),e.lineTo(.655111,0),e.bezierCurveTo(.305719,0,0,.299083,0,.640892),e.bezierCurveTo(0,.982701,.305719,1.281784,.655111,1.281784),e.lineTo(3.31923,1.281784),e.lineTo(4.891497,11.792411),e.bezierCurveTo(4.149038,12.13422,3.624949,12.860564,3.624949,13.715087),e.bezierCurveTo(3.624949,14.911418,4.585779,15.851393,5.808653,15.851393),e.bezierCurveTo(6.769483,15.851393,7.59929,15.210501,7.861335,14.355979),e.lineTo(14.587143,14.355979),e.bezierCurveTo(14.849188,15.210501,15.678995,15.851393,16.639825,15.851393),e.bezierCurveTo(17.8627,15.851393,18.823529,14.911418,18.823529,13.715087),e.bezierCurveTo(18.823529,12.518755,17.8627,11.621507,16.683499,11.621507),e.lineTo(16.683499,11.621507),e.closePath(),e.moveTo(16.770848,3.161733),e.lineTo(16.770848,8.032512),e.lineTo(5.896001,9.442474),e.lineTo(4.978845,3.119007),e.lineTo(16.770848,3.161733),e.lineTo(16.770848,3.161733),e.closePath(),e.moveTo(5.808653,14.612336),e.bezierCurveTo(5.328238,14.612336,4.935171,14.2278,4.935171,13.757813),e.bezierCurveTo(4.935171,13.287826,5.328238,12.90329,5.808653,12.90329),e.bezierCurveTo(6.289068,12.90329,6.682135,13.287826,6.682135,13.757813),e.bezierCurveTo(6.682135,14.2278,6.289068,14.612336,5.808653,14.612336),e.lineTo(5.808653,14.612336),e.closePath(),e.moveTo(16.683499,14.612336),e.bezierCurveTo(16.203084,14.612336,15.810018,14.2278,15.810018,13.757813),e.bezierCurveTo(15.810018,13.287826,16.203084,12.90329,16.683499,12.90329),e.bezierCurveTo(17.163914,12.90329,17.556981,13.287826,17.556981,13.757813),e.bezierCurveTo(17.556981,14.2278,17.163914,14.612336,16.683499,14.612336),e.lineTo(16.683499,14.612336),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--}],i:{}}},function(e,t,n){"use strict";t.__esModule=!0,t.default={w:24,h:24,d:[function(e,t){e.save(),t.stack++,e.strokeStyle="rgba(0,0,0,0)",e.fillStyle="rgba(154, 168, 169, 0.5)",e.lineCap="butt",e.lineJoin="miter",e.miterLimit=4,e.translate(0,0),e.translate(0,0),e.translate(0,0),e.scale(1,1),e.translate(0,0),e.save(),t.stack++,e.save(),t.stack++,e.translate(7,7),e.save(),t.stack++,e.beginPath(),e.moveTo(6.777879,6.845484),e.bezierCurveTo(5.790032,7.833332,4.188142,7.833223,3.200156,6.845237),e.bezierCurveTo(2.21224,5.85732,2.21224,4.255678,3.200156,3.267761),e.bezierCurveTo(4.188224,2.279694,5.789619,2.279748,6.777632,3.267761),e.bezierCurveTo(7.765715,4.255844,7.765877,5.857486,6.777879,6.845484),e.lineTo(8.24994,8.317545),e.bezierCurveTo(10.051001,6.516484,10.050705,3.596713,8.249693,1.795701),e.bezierCurveTo(6.448705,-.005287,3.529182,-.005386,1.728095,1.795701),e.bezierCurveTo(-.072818,3.596614,-.072818,6.516385,1.728095,8.317298),e.bezierCurveTo(3.529034,10.118236,6.449051,10.118434,8.24994,8.317545),e.lineTo(6.777879,6.845484),e.lineTo(6.777879,6.845484),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.save(),t.stack++,e.fillStyle="rgba(154, 168, 169, 0.5)",e.beginPath(),e.moveTo(12,23),e.bezierCurveTo(18.075132,23,23,18.075132,23,12),e.bezierCurveTo(23,5.924868,18.075132,1,12,1),e.bezierCurveTo(5.924868,1,1,5.924868,1,12),e.bezierCurveTo(1,18.075132,5.924868,23,12,23),e.closePath(),e.moveTo(12,20.025024),e.bezierCurveTo(16.432099,20.025024,20.025024,16.432099,20.025024,12),e.bezierCurveTo(20.025024,7.567901,16.432099,3.974976,12,3.974976),e.bezierCurveTo(7.567901,3.974976,3.974976,7.567901,3.974976,12),e.bezierCurveTo(3.974976,16.432099,7.567901,20.025024,12,20.025024),e.closePath(),e.fill("evenodd"),e.stroke(),e.restore(),t.stack--,e.save(),t.stack++,e.fillStyle="#9AA8A9",e.beginPath(),e.moveTo(3.977469,12.202011),e.bezierCurveTo(3.880403,13.366651,2.944759,13.653612,2.481445,13.656799),e.bezierCurveTo(1.992432,13.660164,1,13.117421,1,12),e.bezierCurveTo(1,5.924868,5.924868,1,12,1),e.bezierCurveTo(18.075132,1,23,5.924868,23,12),e.bezierCurveTo(23,13.127857,22.037891,13.51123,21.543091,13.51123),e.bezierCurveTo(21.048291,13.511231,20.045776,13.203328,20.045776,12),e.bezierCurveTo(20.045776,11.948528,20.038295,11.898609,20.023654,11.850214),e.bezierCurveTo(19.943791,7.487233,16.382062,3.974976,12,3.974976),e.bezierCurveTo(7.567901,3.974976,3.974976,7.567901,3.974976,12),e.bezierCurveTo(3.974976,12.067535,3.97581,12.134875,3.977469,12.202011),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--}],i:{}}},function(e,t,n){"use strict";t.__esModule=!0,t.SpinnerIcon=void 0;var r=n(315),o=babelHelpers.interopRequireDefault(r),i=n(35);t.SpinnerIcon={draw:function(e,t,n,r){var a=(0,i.getDPR)();e.save(),e.translate(t,n),e.scale(a,a),e.rotate(r/230),e.translate(-o.default.w/2,-o.default.h/2),o.default.d[0](e,{stack:0}),e.restore()}}},function(e,t,n){"use strict";t.__esModule=!0,t.default={w:36,h:36,d:[function(e,t){e.save(),t.stack++,e.strokeStyle="rgba(0,0,0,0)",e.lineCap="butt",e.lineJoin="miter",e.miterLimit=4,e.translate(0,0),e.translate(0,0),e.translate(0,0),e.scale(1,1),e.translate(0,0),e.save(),t.stack++,e.fillStyle="rgba(0,0,0,0)",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="#F2F2F2",e.lineWidth=2,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="#F2F2F2",e.lineWidth=2,e.beginPath(),e.moveTo(12.340871,10.014123),e.bezierCurveTo(12.438705,9.987436,12.545844,9.99788,12.638453,10.051348),e.lineTo(25.723194,17.605827),e.bezierCurveTo(25.744171,17.617938,25.76355,17.631794,25.781276,17.647113),e.bezierCurveTo(25.850585,17.681197,25.910658,17.735014,25.951029,17.804939),e.bezierCurveTo(26.061419,17.99614,25.995389,18.240929,25.808595,18.348775),e.lineTo(12.645177,25.948678),e.bezierCurveTo(12.576466,25.988348,12.500235,26.004075,12.425883,25.999113),e.bezierCurveTo(12.41723,25.999695,12.408519,25.99999,12.399759,25.99999),e.bezierCurveTo(12.178978,25.99999,12,25.820411,12,25.604721),e.lineTo(12,10.404915),e.bezierCurveTo(12,10.206904,12.152566,10.0429,12.340871,10.014123),e.lineTo(12.340871,10.014123),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--}],i:{}}},function(e,t,n){"use strict";t.__esModule=!0,t.LinkTooltip=void 0;var r=n(10),o=babelHelpers.interopRequireDefault(r),i=n(140),a=n(47),s=n(133),u=n(35),l="'Open Sans', Helvetica, Arial, Tahoma, Sans-serif",c=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var o=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return o._renderedText="",o._textWidth=0,(0,i.isWebGLContext)(o.root.props.ctx)&&(o.gl=o.root.props.ctx,o.initializeTexture()),o}return babelHelpers.inherits(t,e),t.prototype.componentWillUnmount=function(){this.gl&&this._texture&&this.gl.deleteTexture(this._texture)},t.prototype.initializeTexture=function(){var e=this.gl;this._texture=e.createTexture(),e.bindTexture(e.TEXTURE_2D,this._texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE)},t.prototype.drawRoundRect=function(e,t,n,r,o,i){e.beginPath(),e.moveTo(t+i,n),e.lineTo(t+r-i,n),e.quadraticCurveTo(t+r,n,t+r,n+i),e.lineTo(t+r,n+o-i),e.quadraticCurveTo(t+r,n+o,t+r-i,n+o),e.lineTo(t+i,n+o),e.quadraticCurveTo(t,n+o,t,n+o-i),e.lineTo(t,n+i),e.quadraticCurveTo(t,n,t+i,n),e.closePath(),e.fill(),e.stroke()},t.prototype.updateOffscreenCanvases=function(){var e=document.createElement("canvas"),t=e.getContext("2d",{alpha:!1});t.font="12px "+l;var n=Math.ceil(t.measureText(this.text).width+12),r=(0,u.getDPR)(),o=n*r,i=20*r,a=4*r,s=3.5*r;return e.width=o,e.height=i,t.fillStyle="#4c4c4c",t.strokeStyle="#4c4c4c",t.clearRect(0,0,o,i),this.drawRoundRect(t,0,0,o,i,a),t.fillStyle="#ffffff",t.textBaseline="alphabetic",t.textAlign="center",t.font=12*r+"px "+l,t.fillText(this.text,o/2,i/2+s),this._textWidth=n,this._renderedText=this.text,e},t.prototype.updateTexture=function(e){var t=this.gl;t.pixelStorei(t.UNPACK_FLIP_Y_WEBGL,!1),t.bindTexture(t.TEXTURE_2D,this._texture),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,e)},t.prototype.appendWebglOps=function(e,t,n,r){this._renderedText!==this.text&&this.updateTexture(this.updateOffscreenCanvases());var o=(0,u.getDPR)(),i=this._textWidth*o,s=20*o,l=15*o,c=this.props.link.viewportBBox;e.push({type:a.TOOLTIP_OPERATION,args:[this._texture,{x:c.x+c.width/2-i/2,y:c.y+c.height+(l-s/2),width:i,height:s},{x:0,y:0,width:1,height:1}]})},t.prototype.draw=function(e,t,n){this.alphaCanvas&&this._renderedText===this.text||(this._alphaCanvas=this.updateOffscreenCanvases());var r=(0,u.getDPR)(),o=this._textWidth*r,i=20*r,a=15*r,s=this.props.link.viewportBBox;e.drawImage(this._alphaCanvas,Math.round(s.x+s.width/2-o/2),Math.round(s.y+s.height+a-i/2),o,i)},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"LinkTooltip"}},{key:"width",get:function(){return this.props.link?this.props.link.width:0}},{key:"height",get:function(){return this.props.link?20:0}},{key:"isVisible",get:function(){return this.props.link&&this.props.link.isVisible}},{key:"model",get:function(){return this.props.link.model}},{key:"text",get:function(){var e="";return this.model.type===s.TYPE_OPEN_URL?e=""+this.model.url:this.model.type===s.TYPE_GOTO_PAGE&&(e="Navigate to page "+this.model.pageNumber),e}}]),t}(a.CanvasObject);c.propTypes={glManager:o.default.object,link:o.default.object},t.LinkTooltip=c},function(e,t,n){"use strict";t.__esModule=!0,t.Link=void 0;var r=n(10),o=babelHelpers.interopRequireDefault(r),i=n(47),a=n(75),s=n(220),u=n(196),l=n(197),c=n(21),p=n(133),d=n(194),f=babelHelpers.interopRequireWildcard(d),h=n(35),m=100,g=100,v=800,b=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var o=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return o._isHovered=!1,o._hoverAnimation=new s.Animation(Number.MAX_VALUE,m),o._initialFlashAnimation=new s.Animation(Number.MAX_VALUE,v),o._toggleAnimation=new s.Animation(Number.MAX_VALUE,g),o._initialFlashTimeoutId=null,o}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(e){var t=this;this.props.arrivedAtSpreadTick&&!e.arrivedAtSpreadTick?this._initialFlashTimeoutId=window.setTimeout(function(){t._initialFlashTimeoutId=null,t._initialFlashAnimation.reset(t.root.tick),t.requestRedraw()},1e3):!this.props.arrivedAtSpreadTick&&e.arrivedAtSpreadTick&&(window.clearTimeout(this._initialFlashTimeoutId),this._initialFlashTimeoutId=null),this.props.isToggledOn&&!e.isToggledOn&&(this._toggleAnimation.options.reverse=!1,this._toggleAnimation.reset(this.root.tick)),!this.props.isToggledOn&&e.isToggledOn&&(this._toggleAnimation.options.reverse=!0,this._toggleAnimation.reset(this.root.tick))},t.prototype.onMouseEnter=function(e,t){this._hoverAnimation.reset(t),this._hoverAnimation.options.reverse=!1,this._isHovered=!0,this.props.showLinkToolTip(this),this.requestRedraw()},t.prototype.onMouseLeave=function(e,t){this._hoverAnimation.reset(t-(1-this._hoverAnimation.value(t))*m),this._hoverAnimation.options.reverse=!0,this._isHovered=!1,this.props.hideLinkToolTip(),this.requestRedraw()},t.prototype.onSingleTap=function(e,t,n){return this.props.featureTracker.usage(c.FEATURES.PUBLICATION_LINK),this.model.type===p.TYPE_OPEN_URL?this.props.dispatch(f.openUrl(this.model)):this.model.type===p.TYPE_GOTO_PAGE&&this.props.dispatch(f.gotoPage(this.model)),!0},t.prototype.isAnimating=function(e){return this._initialFlashAnimation.isRunning(e)||this._toggleAnimation.isRunning(e)||this._hoverAnimation.isRunning(e)},t.prototype.hoverOpacity=function(e){return this._hoverAnimation.isRunning(e)?this._hoverAnimation.value(e):this._isHovered?1:0},t.prototype.initialFlashOpacity=function(e){if(this.parent.parent.getZoom()>1)return 0;if(this._initialFlashAnimation.isRunning(e)){var t=this._initialFlashAnimation.value(e);return t<.2?t/.2:t<.5?1:1-2*(t-.5)}return 0},t.prototype.linkToggleOpacity=function(e){return this._toggleAnimation.isRunning(e)?this._toggleAnimation.value(e):this.props.isToggledOn?1:0},t.prototype.calculateOpacityForDrawing=function(e){var t=this.initialFlashOpacity(e),n=this.linkToggleOpacity(e),r=this.hoverOpacity(e);return Math.max(t,n,r)},t.prototype.getCustomCursor=function(){return!!this._isHovered&&"pointer"},t.prototype.draw=function(e,t,n){e.save(),e.beginPath();var r=this.calculateOpacityForDrawing(n);e.rect(t.x+.5,t.y+.5,t.width-1,t.height-1),e.strokeStyle="rgba(118, 165, 204, "+r+")",e.fillStyle="rgba(118, 165, 204, "+.5*r+")",e.fill(),e.stroke();var o=20*(0,h.getDPR)();t.width>50&&t.height>50&&(this.model.isShoppingLink&&(e.globalAlpha=r,e.fillStyle="rgba(0, 0, 0, 0.7)",u.ShoppingIcon.draw(e,t.x+t.width/2,t.y+t.height/2,o)),this.model.isVideoLink&&(e.globalAlpha=r,e.fillStyle="rgba(0, 0, 0, 0.7)",l.VideoPlayIcon.draw(e,t.x+t.width/2,t.y+t.height/2,o))),e.restore()},t.prototype.appendWebglOps=function(e,t,n,r){var o=this.calculateOpacityForDrawing(r);o>0&&e.push({type:i.LINK_OPERATION,args:[this.model,o,Object.assign({},t)]})},t.prototype.afterDraw=function(e,t){this.isAnimating(t)&&this.requestRedraw(),this.props.featureTracker.opportunity(c.FEATURES.PUBLICATION_LINK)},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"Link"}},{key:"model",get:function(){return this.props.model}},{key:"width",get:function(){return this.model.width}},{key:"height",get:function(){return this.model.height}},{key:"transform",get:function(){return this._transform||(this._transform=new a.MatrixTransformation,this._transform.mTranslate(this.model.x,this.model.y)),this._transform}},{key:"isVisible",get:function(){return!!this.props.arrivedAtSpreadTick&&(!!this.props.isToggledOn||(!!this._isHovered||!!this.isAnimating(this.root.tick)))}}]),t}(i.CanvasObject);b.propTypes={arrivedAtSpreadTick:o.default.number.isRequired,dispatch:o.default.func.isRequired,featureTracker:o.default.object.isRequired,hideLinkToolTip:o.default.func.isRequired,isToggledOn:o.default.bool.isRequired,model:o.default.object.isRequired,showLinkToolTip:o.default.func.isRequired},t.Link=b},function(e,t,n){"use strict";t.__esModule=!0,t.GlManager=void 0;var r=n(330),o=n(329),i=n(326),a=n(325),s=n(328),u=n(327),l=n(199);t.GlManager=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shadow=new r.Shadow(t),this.shadowDraw=new o.ShadowDraw(t),this.bendingPage=new a.BendingPage(t),this.imagePrimitive=new i.Image(t),this.link=new s.Link(t,this.imagePrimitive),this.linkTooltip=new u.LinkTooltip(t,this.imagePrimitive),this.highlights=new l.Highlights(t)}return e.prototype.destroy=function(){this.shadow.destroy(),this.shadowDraw.destroy(),this.bendingPage.destroy(),this.imagePrimitive.destroy(),this.link.destroy(),this.linkTooltip.destroy(),this.highlights.destroy(),this.gl=null},e}()},function(e,t,n){"use strict";function r(e,t,n){var r=e.y-n,o=Math.sqrt(e.x*e.x+r*r),i=Math.asin(e.x/o),a=i/Math.sin(t),s=o*Math.sin(t);e.x=s*Math.sin(a),e.y=o+n-s*(1-Math.cos(a))*Math.sin(t),e.z=s*(1-Math.cos(a))*Math.cos(t)}function o(e,t,n){var r=Math.sqrt(1+(1-n)*(1-n))*Math.sin(t),o=e.x/r;e.x=r*Math.sin(o),e.z=r-r*Math.cos(o)}function i(e,t,n,i){var a={x:e.x,y:e.y,z:e.z},s={x:e.x,y:e.y,z:e.z};i>0&&(a.y=1-a.y),r(a,t,n),i>0&&(a.y=1-a.y),o(s,t,n);var u=Math.abs(i);e.x=u*a.x+(1-u)*s.x,e.y=u*a.y+(1-u)*s.y,e.z=u*a.z+(1-u)*s.z}function a(e,t){var n=e.x*Math.cos(t)-e.z*Math.sin(t),r=e.x*Math.sin(t)+e.z*Math.cos(t);e.x=n,e.z=r}function s(e){return d.easeInExpo(0,1,e)*Math.PI}function u(e){return d.easeOutExpo(.5,.082,e)*Math.PI}function l(e){var t=.98,n=-8.1;return e=Math.max(Math.min(e,1),0),e<t?-6.8*Math.pow(e/t,20)-1.3:-391.9*Math.pow((e-t)/(1-t),6)+n}t.__esModule=!0,t.BendingMesh=void 0;var c=n(322),p=n(130),d=babelHelpers.interopRequireWildcard(p);t.BendingMesh=function(){function e(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0;if(babelHelpers.classCallCheck(this,e),t<2)throw new Error("size must be at least 2");this.minDepth=n;for(var r=[],o=[],i=[],a=[],s=[],u=[],l=[],c=[],p=0;p<t;p++)for(var d=p/(t-1),f=0;f<t;f++){var h=f/(t-1),m=this._tweakDepth(0);r.push(h,d,m),o.push(0,0,1),a.push(this._getPerspectiveCorrection(m)),s.push(h,d),u.push(0,0,-1),c.push(1-h,d)}for(var g=0;g<t-1;g++)for(var v=(g+0)*t,b=(g+1)*t,y=0;y<t-1;y++){var _=v+y,E=b+y;i.push(E,_,E+1),i.push(_,_+1,E+1),l.push(E+1,_+1,E),l.push(_+1,_,E)}this.size=t,this.indices=new Uint16Array(i),this.vertices=new Float32Array(r),this.normals=new Float32Array(o),this.perspectiveCorrections=new Float32Array(a),this.textureCoords=new Float32Array(s),this.backFacingIndices=new Uint16Array(l),this.backFacingNormals=new Float32Array(u),this.backFacingTextureCoords=new Float32Array(c)}return e.prototype._tweakDepth=function(e){return.8*Math.max(e,this.minDepth)},e.prototype._getPerspectiveCorrection=function(e){return 1+e/.8*-.2},e.prototype._bendPoint=function(e,t,n,r,o,s){i(e,t,n,o),a(e,r),e.x*=s?-1:1,e.z=this._tweakDepth(e.z)},e.prototype.bend=function(e,t){for(var n=1/e<0,r=Math.abs(e),o=s(r),i=u(r),a=l(r),p={x:0,y:0,z:0},d=0;d<this.size;d++)for(var f=0;f<this.size;f++){p.x=f/(this.size-1),p.y=d/(this.size-1),p.z=0,this._bendPoint(p,i,a,o,t,n);var h=d*this.size*3+3*f;this.vertices[h+0]=p.x,this.vertices[h+1]=p.y,this.vertices[h+2]=p.z,this.perspectiveCorrections[d*this.size+f]=this._getPerspectiveCorrection(p.z)}(0,c.calculateNormals)(this.size,this.vertices,this.normals,this.backFacingNormals)},e.prototype.calculateProgress=function(e,t,n,r,o){var i=e<t;if(i){if(n<=e)return-0;if(n>=t)return-1}else{if(n>=e)return 0;if(n<=t)return 1}for(var a={x:0,y:0,z:0},c=i?-.5:.5,p=0;p<16;p++){var d=Math.abs(c),f=s(d),h=u(d),m=l(d);a.x=1,a.y=(o+1)/2,a.z=0,this._bendPoint(a,h,m,f,o,i);var g=a.x/this._getPerspectiveCorrection(a.z),v=r.x+r.width*g;if(Math.abs(v-n)<1)break;c+=Math.sign(v-n)/Math.pow(2,p+2)}return Math.max(Math.min(c,1),-1)},e}()},function(e,t,n){"use strict";function r(e){var t=Math.sqrt(e.x*e.x+e.y*e.y+e.z*e.z);e.x/=t,e.y/=t,e.z/=t}function o(e,t,n,r,o,i,a){a.x+=i*t-o*n,a.y+=r*n-i*e,a.z+=o*e-r*t}function i(e,t,n,r,o){e<n-1&&o.push(r[t+0+3*n]-r[t+0],r[t+1+3*n]-r[t+1],r[t+2+3*n]-r[t+2])}function a(e,t,n,r,o){e>0&&o.push(r[t+0-3*n]-r[t+0],r[t+1-3*n]-r[t+1],r[t+2-3*n]-r[t+2])}function s(e,t,n,r,o){e>0&&o.push(r[t+0-3]-r[t+0],r[t+1-3]-r[t+1],r[t+2-3]-r[t+2])}function u(e,t,n,r,o){e<n-1&&o.push(r[t+0+3]-r[t+0],r[t+1+3]-r[t+1],r[t+2+3]-r[t+2])}function l(e,t,n,r,l,c,p){t===r-1?(s(e,n,r,l,c),a(t,n,r,l,c),u(e,n,r,l,c)):0===e?(a(t,n,r,l,c),u(e,n,r,l,c),i(t,n,r,l,c)):0===t?(u(e,n,r,l,c),i(t,n,r,l,c),s(e,n,r,l,c)):e===r-1?(i(t,n,r,l,c),s(e,n,r,l,c),a(t,n,r,l,c)):(i(t,n,r,l,c),s(e,n,r,l,c),a(t,n,r,l,c),u(e,n,r,l,c));for(var d=c.length/3,f=0;f<d-1;f++)o(c[3*f+0],c[3*f+1],c[3*f+2],c[3*(f+1)+0],c[3*(f+1)+1],c[3*(f+1)+2],p)}function c(e,t,n,o){for(var i={x:0,y:0,z:0},a=[],s=0;s<e;s++)for(var u=0;u<e;u++){i.x=0,i.y=0,i.z=0,a.length=0;var c=s*e*3+3*u;l(u,s,c,e,t,a,i),r(i),n[c+0]=i.x,n[c+1]=i.y,n[c+2]=i.z,o[c+0]=-i.x,o[c+1]=-i.y,o[c+2]=-i.z}}t.__esModule=!0,t.calculateNormals=c},function(e,t,n){"use strict";function r(e){return e===d.SINGLE_PAGE_SPREAD?200:400}function o(e){var t=Math.abs(e);return t<.1?m.easeOutExpo(0,1,10*t):t>.9?m.easeOutExpo(0,1,10*(1-t)):1}t.__esModule=!0,t.PageFlip=void 0;var i=n(75),a=n(47),s=n(200),u=n(57),l=n(8),c=babelHelpers.interopRequireWildcard(l),p=n(321),d=n(40),f=n(220),h=n(130),m=babelHelpers.interopRequireWildcard(h),g=n(77),v=babelHelpers.interopRequireWildcard(g),b=n(79),y=n(35),_=n(21),E=n(324),w=0,S=.001;t.PageFlip=function(e){function t(n,i){babelHelpers.classCallCheck(this,t);var a=babelHelpers.possibleConstructorReturn(this,e.call(this,n,i));return a._bendingMesh=new p.BendingMesh(25,S),a._flatMesh=new p.BendingMesh(2,w),a._isSnapped=!0,a._wasAnimatingLastFrame=!1,a._lastPositionInPercent=0,a._lastVisiblePages="",a._pendingTargetSpreadIndex=NaN,a._lightRatioEasing=o,a._progressEasing=function(e){return a.animation.value(e)},a._justStartedAnimation=!1,a._targetSpreadIndex=a.props.currentSpreadIndex,a._lastSpreadIndex=a.props.currentSpreadIndex,a.animation=new f.Animation(Number.MAX_VALUE,r(a.props.readMode)),a}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.props.featureTracker.opportunity(_.FEATURES.DOUBLE_TAP_ZOOM),this.props.featureTracker.opportunity(_.FEATURES.GESTURE_PINCH_ZOOM),this.props.canChangePages&&this.props.featureTracker.opportunity(_.FEATURES.GESTURE_DRAG_PAGES)},t.prototype.onGestureStart=function(e,t,n,r,o){return!this.props.disableGestures&&(this.animation.isRunning(n)&&this.jumpToSpread(this._targetSpreadIndex,n),this._gesture={startX:e,startY:t,endX:e,endY:t,velocity:0,timeStamp:o},!0)},t.prototype.onGestureChange=function(e,t,n,r,o,i,a){if(this.props.disableGestures)return!1;if((a===v.SWIPE_LEFT||a===v.SWIPE_RIGHT)&&1===r.length){var s=e-this._gesture.endX,u=Math.max(1,o-this._gesture.timeStamp),l=-s/u*.6+.4*this._gesture.velocity;this._gesture.endX=e,this._gesture.endY=t,this._gesture.timeStamp=o,this._gesture.velocity=l;var c=this.getCurrentSpreadIndex(),p=this._getValidSpreadIndex(c+(a===v.SWIPE_LEFT?1:-1));return c!==p&&this.tweakAnimation({duration:Number.MAX_VALUE,targetSpreadIndex:p}),!0}return!1},t.prototype.onGestureEnd=function(e,t){if(this.props.disableGestures)return!1;if(this.animation.duration===Number.MAX_VALUE){var n=this._getPageSetupForFlip(this.getCurrentSpreadIndex(),this._targetSpreadIndex),o=this._getProgressBasedOnFingerPosition(n.start.edge,n.end.edge,e),i=this._targetSpreadIndex>this.getCurrentSpreadIndex()?this._gesture.velocity>0:this._gesture.velocity<0,a=Math.abs(this._gesture.velocity),s=i&&(o>.6||a>.36),u=r(this.props.readMode)*(.95-Math.atan(a)/Math.PI);return this.tweakAnimation({duration:u,startTime:e-u*(s?o:1-o),reverse:!s}),s&&this.props.featureTracker.usage(_.FEATURES.GESTURE_DRAG_PAGES),!0}return!1},t.prototype.onSingleTapConfirmed=function(e,t,n,r){var o=this.getCurrentSpread(),i=o.children[0].viewportBBox;if(o.children.length>1){var a=o.children[1].viewportBBox;i.width+=a.width,i.height=Math.max(i.height,a.height),i.y=Math.min(i.y,a.y)}if(t>i.y&&t<i.y+i.height){var s=this.children.indexOf(o);if(e<i.x)return this.goToSpread(Math.max(s-1,0),n),!0;if(e>i.x+i.width)return this.goToSpread(Math.min(s+1,this.children.length-1),n),!0}return!1},t.prototype.getCurrentSpreadIndex=function(){return this.props.currentSpreadIndex},t.prototype.getCurrentSpread=function(){return this.children[this.getCurrentSpreadIndex()]},t.prototype.getVisiblePages=function(){var e=[];if(this.getCurrentSpreadIndex()!==this._targetSpreadIndex){var t=Math.min(this.getCurrentSpreadIndex(),this._targetSpreadIndex),n=Math.max(this.getCurrentSpreadIndex(),this._targetSpreadIndex);e.push.apply(e,this.children[t].children.map(function(e){return e.model})),e.push.apply(e,this.children[n].children.map(function(e){return e.model}))}else{for(var r=a.CanvasObject.RectPool.get(0,0,this.props.viewportWidth,this.props.viewportHeight),o=this.getCurrentSpread(),i=o.children,s=Array.isArray(i),u=0,i=s?i:i[Symbol.iterator]();;){var l;if(s){if(u>=i.length)break;l=i[u++]}else{if(u=i.next(),u.done)break;l=u.value}var c=l,p=c.viewportBBox;(0,b.overlap)(r,p)&&e.push(c.model),a.CanvasObject.RectPool.release(p)}a.CanvasObject.RectPool.release(r)}return e},t.prototype.setSnapping=function(e,t){},t.prototype.jumpToPositionByPercent=function(e,t){this.getCurrentSpread().setZoom(1),this.jumpToSpread(Math.round(e/100*(this.children.length-1)),t)},t.prototype.goToSpread=function(e,t){if(this.animation.isRunning(t))return void(this._pendingTargetSpreadIndex=e);this._animateToSpread(e,t,r(this.props.readMode))},t.prototype.jumpToSpread=function(e,t){this._animateToSpread(e,t,0)},t.prototype.tweakAnimation=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.animation.duration=e.hasOwnProperty("duration")?e.duration:r(this.props.readMode),this._targetSpreadIndex=this._getValidSpreadIndex(e.hasOwnProperty("targetSpreadIndex")?e.targetSpreadIndex:this._targetSpreadIndex),this.animation.reset(e.startTime||0),this.animation.options.reverse=!!e.hasOwnProperty("reverse")&&e.reverse,this._justStartedAnimation=!0,this.requestRedraw()},t.prototype._getValidSpreadIndex=function(e){return Math.max(0,Math.min(this.children.length-1,e))},t.prototype._animateToSpread=function(e,t,n){this._targetSpreadIndex=this._getValidSpreadIndex(e),this.getCurrentSpreadIndex()!==this._targetSpreadIndex&&(this.getCurrentSpread().setZoom(1),this.tweakAnimation({startTime:t,duration:n}))},t.prototype.getChildrenToTraverse=function(){return this.children.slice(this.getCurrentSpreadIndex(),this.getCurrentSpreadIndex()+1)},t.prototype.getChildTree=function(){var e=this;return this.props.documentPageSpreadList.map(function(t,n){var r=new i.MatrixTransformation;return r.mTranslate(e.xMargin,e.yMargin),a.CanvasObject.createElement(s.Spread,{dispatch:e.props.dispatch,featureTracker:e.props.featureTracker,height:e.props.viewportHeight-2*e.yMargin,hideLinkToolTip:e.props.hideLinkToolTip,isCurrentSpread:n===e.props.currentSpreadIndex,isLinksToggledOn:e.props.isLinksToggledOn,isSnapped:e._isSnapped,mayRenderLinks:e.props.mayRenderLinks&&e._isSnapped,pageModels:t.pages?t.pages:[t],paywalledPageStatus:t.pages?t.pages.map(function(t){return e.props.paywalledPageNumbers.includes(t.pageNumber)}):[e.props.paywalledPageNumbers.includes(t.pageNumber)],readMode:e.props.readMode,renderManager:e.props.renderManager,showLinkToolTip:e.props.showLinkToolTip,transform:r,width:e.props.viewportWidth-2*e.xMargin})})},t.prototype.beforeDraw=function(e,t){(!this.animation.isRunning(t)&&(this._wasAnimatingLastFrame||this._justStartedAnimation)||0===this.animation.duration)&&(this.animation.options.reverse&&(this._targetSpreadIndex=this.getCurrentSpreadIndex()),this._targetSpreadIndex!==this.getCurrentSpreadIndex()&&this.props.onSpreadChange(this._targetSpreadIndex),isNaN(this._pendingTargetSpreadIndex)||(this.goToSpread(this._pendingTargetSpreadIndex,t),this._pendingTargetSpreadIndex=NaN))},t.prototype.appendWebglOps=function(e,t,n,r){this.animation.isRunning(r)?this._appendWebglOpsForFlipping(e,this.getCurrentSpreadIndex(),this._targetSpreadIndex,n,r):this._appendWebglOpsForPages(e,n,r),this._justStartedAnimation=!1},t.prototype.afterDraw=function(e,t){!this._wasAnimatingLastFrame&&this.animation.isRunning(t)?this.props.onAnimationStart():this._wasAnimatingLastFrame&&!this.animation.isRunning(t)&&this.props.onAnimationEnd(),(this._wasAnimatingLastFrame=this.animation.isRunning(t))&&this.requestRedraw();var n=this.getVisiblePages(),r=this.getCurrentSpreadIndex(),o=this.children[r].children.map(function(e){return e.model}),i=r/(this.children.length-1)*100,a=this._lastPositionInPercent!==i,s=this._lastSpreadIndex!==r,u=n.map(function(e){return e.pageNumber}).join()!==this._lastVisiblePages,l=this.props.currentPageNumber;if(s)l=o[0].pageNumber;else if(!n.find(function(e){return e.pageNumber===l})){var p=n.find(function(e){return o.includes(e)});p&&(l=p.pageNumber)}if(this._lastPositionInPercent=i,this._lastSpreadIndex=r,this._lastVisiblePages=n.map(function(e){return e.pageNumber}).join(),(a||s||u)&&this.props.dispatch(c.readerPositionChanged(n,r,l,o,i,a,s,u,!1)),this._wasAnimatingLastFrame===this._isSnapped&&(this._isSnapped=!this._wasAnimatingLastFrame,this._isSnapped||this.props.hideLinkToolTip(),this.forceUpdate()),u){var d=n.map(function(e){return e.pageNumber}),f=o.map(function(e){return e.pageNumber});this.props.renderManager.setActivePages(Array.from(new Set([].concat(d,f))))}},t.prototype._appendWebglOpsForFlipping=function(e,t,n,r,o){var i=this._getPageSetupForFlip(t,n),s=n<t,u=this._getConicContribution(),l=this._getProgressBasedOnFingerPosition(i.start.edge,i.end.edge,o),c=this._transformBBox(i.start.bbox,i.end.bbox,l);this._bendingMesh.bend(this._bendingMesh.calculateProgress(i.start.edge,i.end.edge,this._getFingerPosition(i.start.edge,i.end.edge,o),c,u),u);var p=i.start.bending?this._loadPreviewTextureInfo(i.start.bending,c,r):null,d=i.end.bending?this._loadPreviewTextureInfo(i.end.bending,c,r):null,f=this._lightRatioEasing(l);if(e.push({type:a.BENDING_PAGE_OPERATION,args:[this._bendingMesh,p,c,f,s,!!i.start.bending,o]},{type:a.BENDING_PAGE_OPERATION,args:[this._bendingMesh,d,c,f,!s,!!i.end.bending,o]},{type:a.DEPTH_MAP_OPERATION,args:[this._bendingMesh,c]}),i.start.flat){var h=this._transformBBox(i.start.flat.viewportBBox,i.end.bending.viewportBBox,l);this._appendWebglOpsForPage(e,i.start.flat,h,r,o),e.push({type:a.SHADOW_OPERATION,args:[h,1e-4]})}if(i.end.flat){var m=this._transformBBox(i.start.bending.viewportBBox,i.end.flat.viewportBBox,l);this._appendWebglOpsForPage(e,i.end.flat,m,r,o),e.push({type:a.SHADOW_OPERATION,args:[m,1e-4]})}},t.prototype._transformBBox=function(e,t,n){var r=Math.abs(n);return{x:m.linear(e.x,t.x,r),y:m.linear(e.y,t.y,r),width:m.linear(e.width,t.width,r),height:m.linear(e.height,t.height,r)}},t.prototype._getConicContribution=function(){if(this.animation.duration!==r(this.props.readMode)&&this._gesture){var e=(this._gesture.endY-this._gesture.startY)/(this.height-this._gesture.startY);return Math.min(1,Math.max(-1,e))}return-.5},t.prototype._getFingerPosition=function(e,t,n){return this.animation.duration===Number.MAX_VALUE&&this._gesture?this._gesture.endX-this._gesture.startX+e:e+(t-e)*this._progressEasing(n)},t.prototype._getProgressBasedOnFingerPosition=function(e,t,n){var r=this._getFingerPosition(e,t,n);return Math.min(1,Math.max(0,(r-e)/(t-e)))},t.prototype._getPageSetupForFlip=function(e,t){return(0,E.pageSetupForFlip)(this.children[e].children,this.children[t].children,this.props.readMode,t<e)},t.prototype._appendWebglOpsForPages=function(e,t,n){var r=this;this.getCurrentSpread().children.forEach(function(o){r._appendWebglOpsForPage(e,o,o.viewportBBox,t,n)})},t.prototype._appendWebglOpsForPage=function(e,t,n,r,o){var i=this;if(this.overlaps(n)){var s=this._lightRatioEasing(0),u=this._loadTextureInfos(t,n,r);(u||[null]).forEach(function(t){e.push({type:a.BENDING_PAGE_OPERATION,args:[i._flatMesh,t,n,s,!1,!0,o]})}),u||this.requestRedraw()}},t.prototype._loadPreviewTextureInfo=function(e,t,n){var r=t.x,o=t.y,i=this._loadTextureInfos(e,Object.assign({},t,{x:t.x-r,y:t.y-o}),n),a=i&&i[0];return a&&(a.dstX+=r,a.dstY+=o),a},t.prototype._loadTextureInfos=function(e,t,n){var r=e.getOperations(t,n.width,n.height,e.pageType),o=r.originX,i=r.originY,a=r.ops;return a&&a.reverse().map(function(e,t){return{surface:e.surface,srcX:e.src_px.x,srcY:e.src_px.y,srcW:e.src_px.width,srcH:e.src_px.height,dstX:e.dest_px.x+o,dstY:e.dest_px.y+i,dstW:e.dest_px.width,dstH:e.dest_px.height}})},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"PageFlip"}},{key:"width",get:function(){return this.props.viewportWidth}},{key:"height",get:function(){return this.props.viewportHeight}},{key:"xMargin",get:function(){var e=u.SPACE_HORIZONTAL_DPS_IN_PIXELS;return(0,y.getDPR)()*e}},{key:"yMargin",get:function(){var e=this.props.allowUIToOverlayCover?u.SPACE_VERTICAL_DPS_IN_PIXELS:u.SPACE_VERTICAL_NO_UI_OVERLAP_DPS_IN_PIXELS;return(0,y.getDPR)()*e}}]),t}(a.CanvasObject)},function(e,t,n){"use strict";function r(e,t){var n=e[0].viewportBBox,r=t[0].viewportBBox;return{start:{bending:e[0],flat:null,bbox:n,edge:n.x+n.width},end:{bending:null,flat:t[0],bbox:r,edge:r.x}}}function o(e,t){var n=e[0].viewportBBox,r=t[0].viewportBBox;return{start:{bending:null,flat:e[0],bbox:n,edge:n.x},end:{bending:t[0],flat:null,bbox:r,edge:r.x+r.width}}}function i(e,t){var n=e[e.length-1].viewportBBox,r=t[0].viewportBBox;return{start:{bending:e[e.length-1],flat:e.length>1?e[0]:null,bbox:n,edge:n.x+n.width},end:{bending:t[0],flat:t.length>1?t[t.length-1]:null,bbox:Object.assign({},r,{x:r.x+r.width}),edge:r.x}}}function a(e,t){var n=e[0].viewportBBox,r=t[t.length-1].viewportBBox;return{start:{bending:e[0],flat:e.length>1?e[e.length-1]:null,bbox:Object.assign({},n,{x:n.x+n.width}),edge:n.x},end:{bending:t[t.length-1],flat:t.length>1?t[0]:null,bbox:r,edge:r.x+r.width}}}function s(e,t,n,s){return n===u.SINGLE_PAGE_SPREAD?s?o(e,t):r(e,t):s?a(e,t):i(e,t)}t.__esModule=!0,t.pageSetupForFlip=s;var u=n(40)},function(e,t,n){"use strict";t.__esModule=!0,t.BendingPage=void 0;var r=n(74),o=n(35),i=n(102),a=n(749),s=babelHelpers.interopRequireDefault(a),u=n(750),l=babelHelpers.interopRequireDefault(u),c=n(758),p=babelHelpers.interopRequireDefault(c),d=n(757),f=babelHelpers.interopRequireDefault(d),h=!1;t.BendingPage=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=(0,r.createShader)(t,l.default,s.default);this.verticeBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.verticeBuffer),t.bufferData(t.ARRAY_BUFFER,7500,t.DYNAMIC_DRAW),this.normalsBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.normalsBuffer),t.bufferData(t.ARRAY_BUFFER,7500,t.DYNAMIC_DRAW),this.textureCoordsBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.textureCoordsBuffer),t.bufferData(t.ARRAY_BUFFER,5e3,t.DYNAMIC_DRAW),this.perspectiveCorrectionsBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.perspectiveCorrectionsBuffer),t.bufferData(t.ARRAY_BUFFER,2500,t.DYNAMIC_DRAW);this.indiceBuffer=t.createBuffer(),t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),t.bufferData(t.ELEMENT_ARRAY_BUFFER,6912,t.DYNAMIC_DRAW),this.whitePaperTexture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.whitePaperTexture),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,1,1,0,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array([255,255,255,255])),t.bindTexture(t.TEXTURE_2D,null),h&&(this.normalShader=(0,r.createShader)(t,p.default,f.default),this.normalLinesBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.normalLinesBuffer),t.bufferData(t.ARRAY_BUFFER,15e3,t.DYNAMIC_DRAW))}return e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.normalsBuffer),e.deleteBuffer(this.textureCoordsBuffer),e.deleteBuffer(this.perspectiveCorrectionsBuffer),e.deleteBuffer(this.indiceBuffer),e.deleteTexture(this.whitePaperTexture),this.shader.destroy(),h&&(e.deleteBuffer(this.normalLinesBuffer),this.normalShader.destroy())},e.prototype._calculateMatrix=function(e,t,n){var r=t?t.srcX:0,o=t?t.srcY:0,a=t?t.srcW:n.width,s=t?t.srcH:n.height,u=t?t.dstX:n.x,l=t?t.dstY:n.y,c=t?t.dstW:n.width,p=t?t.dstH:n.height,d=t?t.surface.width:n.width,f=t?t.surface.height:n.height;o=(t?t.surface.imgHeight:n.height)-o-s,l=e.drawingBufferHeight-l-p;var h=new Float32Array([c,0,0,0,p,0,u,l,1]),m=new Float32Array([2/e.drawingBufferWidth,0,0,0,2/e.drawingBufferHeight,0,-1,-1,1]);i.mat3.multiply(h,m,h);var g=Math.max(0,(1-a/c)/2),v=Math.max(0,(1-s/p)/2);return{matrix:h,texMatrix:new Float32Array([(a-2*g)/d,0,0,0,(s-2*v)/f,0,(r+g)/d,(o+v)/f,1])}},e.prototype.draw=function(e,t,n,r,i,a){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:0,u=this.gl,l=this.shader;u.enable(u.DEPTH_TEST),u.disable(u.BLEND),u.enable(u.CULL_FACE),u.cullFace(u.BACK),l.bind(u);var c=this._calculateMatrix(u,t,n),p=c.matrix,d=c.texMatrix;u.uniformMatrix3fv(l.u_matrix,!1,p),u.uniformMatrix3fv(l.u_texMatrix,!1,d);var f=u.canvas.width,m=u.canvas.height,g=n.x/f*2-1,v=n.y/m*2-1,b=n.width/f*2,y=n.height/m*2;if(u.uniform1f(l.lightRatio,r),u.uniform1f(l.tick,s),u.uniform1f(l.spinnerSize,22*(0,o.getDPR)()),u.uniform1i(l.showSpinner,!t&&a),u.uniform4f(l.bbox,g,v,b,y),u.uniform2f(l.viewport,u.drawingBufferWidth,u.drawingBufferHeight),u.activeTexture(u.TEXTURE0),u.bindTexture(u.TEXTURE_2D,t?t.surface.texture:this.whitePaperTexture),u.uniform1i(l.texture,0),u.bindBuffer(u.ARRAY_BUFFER,this.verticeBuffer),u.bufferSubData(u.ARRAY_BUFFER,0,e.vertices),u.vertexAttribPointer(l.vertex,3,u.FLOAT,u.FALSE,0,0),u.bindBuffer(u.ARRAY_BUFFER,this.normalsBuffer),u.bufferSubData(u.ARRAY_BUFFER,0,i?e.backFacingNormals:e.normals),u.vertexAttribPointer(l.normal,3,u.FLOAT,u.FALSE,0,0),u.bindBuffer(u.ARRAY_BUFFER,this.textureCoordsBuffer),u.bufferSubData(u.ARRAY_BUFFER,0,i?e.backFacingTextureCoords:e.textureCoords),u.vertexAttribPointer(l.textureCoord,2,u.FLOAT,u.FALSE,0,0),u.bindBuffer(u.ARRAY_BUFFER,this.perspectiveCorrectionsBuffer),u.bufferSubData(u.ARRAY_BUFFER,0,e.perspectiveCorrections),u.vertexAttribPointer(l.perspectiveCorrection,1,u.FLOAT,u.FALSE,0,0),u.bindBuffer(u.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),u.bufferSubData(u.ELEMENT_ARRAY_BUFFER,0,i?e.backFacingIndices:e.indices),u.drawElements(u.TRIANGLES,6*(e.size-1)*(e.size-1),u.UNSIGNED_SHORT,0),h){this.normalShader.bind(u),u.uniformMatrix3fv(this.normalShader.u_matrix,!1,p),u.uniform1i(this.normalShader.backFacing,i);for(var _=[],E=i?e.backFacingNormals:e.normals,w=0;w<e.vertices.length;w+=3){var S=e.vertices[w+0],x=e.vertices[w+1],T=e.vertices[w+2];_.push(S,x,T,S+E[w+0],x+E[w+1],T+E[w+2])}u.bindBuffer(u.ARRAY_BUFFER,this.normalLinesBuffer),u.bufferSubData(u.ARRAY_BUFFER,0,new Float32Array(_)),u.vertexAttribPointer(this.normalShader.vertex,3,u.FLOAT,u.FALSE,0,0),u.drawArrays(u.LINES,0,_.length/3)}},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.Image=void 0;var r=n(74),o=n(753),i=babelHelpers.interopRequireDefault(o),a=n(754),s=babelHelpers.interopRequireDefault(a);t.Image=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=(0,r.createShader)(t,s.default,i.default);var n=t.createBuffer();t.bindBuffer(t.ARRAY_BUFFER,n),t.bufferData(t.ARRAY_BUFFER,new Float32Array([0,0,0,1,1,0,1,1]),t.STATIC_DRAW),this.verticeBuffer=n}return e.prototype.destroy=function(){var e=this.gl;e.bindBuffer(e.ARRAY_BUFFER,null),e.deleteBuffer(this.verticeBuffer),this.shader.destroy()},e.prototype.draw=function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{x:0,y:0,width:1,height:1},r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,o=this.gl,i=this.shader;i.bind(),o.disable(o.DEPTH_TEST),o.uniform2f(i.viewport,o.drawingBufferWidth,o.drawingBufferHeight),o.uniform4f(i.bbox,t.x,t.y,t.width,t.height),o.uniform4f(i.texCoords,n.x,n.y,n.width,n.height),o.uniform1f(i.opacity,r),o.activeTexture(o.TEXTURE0),o.bindTexture(o.TEXTURE_2D,e),o.uniform1i(i.texture,0),o.bindBuffer(o.ARRAY_BUFFER,this.verticeBuffer),o.vertexAttribPointer(i.vertex,2,o.FLOAT,!1,0,0),o.drawArrays(o.TRIANGLE_STRIP,0,4)},e}()},function(e,t,n){"use strict";t.__esModule=!0;t.LinkTooltip=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.gl=t,this.imagePrimitive=n}return e.prototype.destroy=function(){},e.prototype.draw=function(e,t,n,r){var o=this.gl;o.disable(o.DEPTH_TEST),o.enable(o.BLEND),o.blendFuncSeparate(o.SRC_ALPHA,o.ONE_MINUS_SRC_ALPHA,o.ONE,o.ONE_MINUS_SRC_ALPHA),o.blendEquation(o.FUNC_ADD),this.imagePrimitive.draw(e,t,n,r)},e}()},function(e,t,n){"use strict";function r(e){return 1<<1+Math.floor(Math.log2(e))}t.__esModule=!0,t.Link=void 0;var o=n(74),i=n(755),a=babelHelpers.interopRequireDefault(i),s=n(756),u=babelHelpers.interopRequireDefault(s),l=n(35),c=n(196),p=n(197);t.Link=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=(0,o.createShader)(t,u.default,a.default),this.imagePrimitive=n;var r=t.createBuffer();t.bindBuffer(t.ARRAY_BUFFER,r),t.bufferData(t.ARRAY_BUFFER,new Float32Array([0,0,0,1,1,0,1,1]),t.STATIC_DRAW),this.verticeBuffer=r;var i=t.createBuffer();t.bindBuffer(t.ARRAY_BUFFER,i),t.bufferData(t.ARRAY_BUFFER,new Float32Array([1,1,0,0,1,0,0,1,0,1,1,0,0,0,1,1]),t.STATIC_DRAW),this.barycentricBuffer=i,this.initializeTexture()}return e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.barycentricBuffer),e.deleteTexture(this.texture),this.shader.destroy()},e.prototype._iconRadius=function(){return 20*(0,l.getDPR)()},e.prototype.initializeTexture=function(){var e=this.gl,t=2*this._iconRadius(),n=r(2*t),o=document.createElement("canvas");o.width=n,o.height=n;var i=o.getContext("2d");i.fillStyle="rgba(0, 1, 0, 0.0)",i.fillRect(0,0,o.width,o.height),i.fillStyle="rgba(0, 0, 0, 0.7)",p.VideoPlayIcon.draw(i,t/2,t/2,this._iconRadius()),c.ShoppingIcon.draw(i,t+t/2,t/2,this._iconRadius()),this.texture&&e.deleteTexture(this.texture);var a=e.createTexture();e.bindTexture(e.TEXTURE_2D,a),e.texImage2D(e.TEXTURE_2D,0,e.RGBA,e.RGBA,e.UNSIGNED_BYTE,o),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),this.texture=a,this.textureSize=n},e.prototype.draw=function(e,t,n){var r=this.gl,o=this.shader;if(r.disable(r.DEPTH_TEST),r.enable(r.BLEND),r.blendFuncSeparate(r.SRC_ALPHA,r.ONE_MINUS_SRC_ALPHA,r.ZERO,r.ONE),r.blendEquation(r.FUNC_ADD),o.bind(),r.uniform2f(o.viewport,r.drawingBufferWidth,r.drawingBufferHeight),r.uniform4f(o.bbox,n.x,n.y,n.width,n.height),r.uniform1f(o.opacity,t),r.uniform1f(o.strokeWidth,1),r.bindBuffer(r.ARRAY_BUFFER,this.verticeBuffer),r.vertexAttribPointer(o.vertex,2,r.FLOAT,!1,0,0),r.bindBuffer(r.ARRAY_BUFFER,this.barycentricBuffer),r.vertexAttribPointer(o.barycentric,4,r.FLOAT,!1,0,0),r.drawArrays(r.TRIANGLE_STRIP,0,4),(e.isShoppingLink||e.isVideoLink)&&n.width>50&&n.height>50){var i={x:n.x+n.width/2-this._iconRadius(),y:n.y+n.height/2-this._iconRadius(),width:2*this._iconRadius(),height:2*this._iconRadius()},a={x:0,y:0,width:2*this._iconRadius()/this.textureSize,height:2*this._iconRadius()/this.textureSize};e.isVideoLink&&this.imagePrimitive.draw(this.texture,i,a,t),e.isShoppingLink&&(a.x+=a.width,this.imagePrimitive.draw(this.texture,i,a,t))}},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.ShadowDraw=void 0;var r=n(74),o=n(761),i=babelHelpers.interopRequireDefault(o),a=n(762),s=babelHelpers.interopRequireDefault(a);t.ShadowDraw=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=(0,r.createShader)(t,s.default,i.default);this.verticeBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.verticeBuffer),t.bufferData(t.ARRAY_BUFFER,72,t.DYNAMIC_DRAW)}return e.prototype.draw=function(e,t,n){var r=this.gl,o=this.shader;r.enable(r.DEPTH_TEST),r.enable(r.BLEND),r.blendFuncSeparate(r.SRC_ALPHA,r.ONE_MINUS_SRC_ALPHA,r.ZERO,r.ONE),o.bind(r);var i=r.canvas.width,a=r.canvas.height,s=(t.x-i/2)/(i/2),u=(0-t.y+a/2)/(a/2),l=(t.x+t.width-i/2)/(i/2),c=(0-(t.y+t.height)+a/2)/(a/2),p=new Float32Array([s,u,n,s,c,n,l,u,n,l,u,n,s,c,n,l,c,n]);r.activeTexture(r.TEXTURE0),r.bindTexture(r.TEXTURE_2D,e),r.uniform1i(o.depthMapTexture,0),r.bindBuffer(r.ARRAY_BUFFER,this.verticeBuffer),r.bufferSubData(r.ARRAY_BUFFER,0,p),r.vertexAttribPointer(o.vertex,3,r.FLOAT,!1,0,0),r.drawArrays(r.TRIANGLES,0,6)},e.prototype.destroy=function(){this.gl.deleteBuffer(this.verticeBuffer),this.shader.destroy()},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.Shadow=void 0;var r=n(74),o=n(102),i=n(763),a=babelHelpers.interopRequireDefault(i),s=n(764),u=babelHelpers.interopRequireDefault(s),l=512;t.Shadow=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=(0,r.createShader)(t,u.default,a.default);this.verticeBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.verticeBuffer),t.bufferData(t.ARRAY_BUFFER,7500,t.DYNAMIC_DRAW);this.indiceBuffer=t.createBuffer(),t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),t.bufferData(t.ELEMENT_ARRAY_BUFFER,6912,t.DYNAMIC_DRAW),this.depthMapTexture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.depthMapTexture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,l,l,0,t.RGBA,t.UNSIGNED_BYTE,null),this.depthMapFrameBuffer=t.createFramebuffer(),t.bindFramebuffer(t.FRAMEBUFFER,this.depthMapFrameBuffer),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,this.depthMapTexture,0),t.bindFramebuffer(t.FRAMEBUFFER,null)}return e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.indiceBuffer),e.deleteTexture(this.depthMapTexture),e.deleteFramebuffer(this.depthMapFrameBuffer),this.shader.destroy()},e.prototype._calculateMatrix=function(e,t){var n=t.x,r=e.drawingBufferHeight-t.y-t.height,i=t.width,a=t.height,s=new Float32Array([i,0,0,0,a,0,n,r,1]),u=new Float32Array([2/e.drawingBufferWidth,0,0,0,2/e.drawingBufferHeight,0,-1,-1,1]);return o.mat3.multiply(s,u,s),{matrix:s}},e.prototype.computeDepthMap=function(e,t){var n=this.gl,r=this.shader;n.disable(n.DEPTH_TEST),n.enable(n.BLEND),n.blendFunc(n.ONE,n.ZERO),n.blendEquation(n.FUNC_ADD),n.disable(n.CULL_FACE),n.bindFramebuffer(n.FRAMEBUFFER,this.depthMapFrameBuffer),n.viewport(0,0,l,l),n.clear(n.COLOR_BUFFER_BIT),r.bind(n),n.uniformMatrix3fv(r.u_matrix,!1,this._calculateMatrix(n,t).matrix),n.bindBuffer(n.ARRAY_BUFFER,this.verticeBuffer),n.bufferSubData(n.ARRAY_BUFFER,0,e.vertices),n.vertexAttribPointer(r.vertex,3,n.FLOAT,n.FALSE,0,0),n.bindBuffer(n.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),n.bufferSubData(n.ELEMENT_ARRAY_BUFFER,0,e.indices),n.drawElements(n.TRIANGLES,6*(e.size-1)*(e.size-1),n.UNSIGNED_SHORT,0),n.bindFramebuffer(n.FRAMEBUFFER,null),n.viewport(0,0,n.drawingBufferWidth,n.drawingBufferHeight)},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.ConnectedRoot=t.Root=void 0;var r=n(138),o=babelHelpers.interopRequireWildcard(r),i=n(96),a=n(8),s=babelHelpers.interopRequireWildcard(a),u=n(11),l=babelHelpers.interopRequireWildcard(u),c=n(58),p=n(48),d=n(59),f=n(79),h=n(47),m=n(313),g=n(318),v=n(323),b=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var o=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return o._isLinkToggledOn=!1,o._showTooltip=null,o._frameCountAtAnimationStart=-1,o._interactionStartTime=-1,o._inAnimation=!1,o.onSpreadChange=function(e){o._currentSpreadIndex=e,o._isLinkToggledOn=!1,o.forceUpdate()},o.onAnimationStart=function(){o._frameCountAtAnimationStart=o.frameCount,o._interactionStartTime=o.tick,o._inAnimation=!0},o.onAnimationEnd=function(){if(o._inAnimation=!1,o._frameCountAtAnimationStart>=0&&o._interactionStartTime>=0){var e=o.tick-o._interactionStartTime,t=e/(1e3/60),n=t-(o.frameCount-o._frameCountAtAnimationStart);n>0&&o.props.dispatch(s.trackDroppedFrames(n,e,o._frameCountAtAnimationStart,o.frameCount,o._interactionStartTime,o.tick,o.props.usePageFlip))}},o.showLinkToolTip=function(e){o._showTooltip=e,o.forceUpdate()},o.hideLinkToolTip=function(){o._showTooltip=null,o.forceUpdate()},o.__store__=n.store,o._currentSpreadIndex=(0,d.pageNumberToSpreadIndex)(n.readMode,n.currentPageNumber),o}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.spreadAnimator=this.children[0];var t={getVisiblePages:function(){return e.spreadAnimator.getVisiblePages()},getVisibleComponents:function(){return e.getVisibleDescendants()},getViewportBBoxForComponent:function(t){return e.component.viewportBBox},getRenderedViews:function(t){return e.getRenderedViews(t)},getReadMode:function(){return e.props.readMode},getPageComponent:function(t){var n=(0,d.pageNumberToSpreadIndex)(e.props.readMode,t),r=e.spreadAnimator.children[n];return r.children[0].pageNumber===t?r.children[0]:r.children[1]},goToPage:function(e){t.goToSpread((0,d.pageNumberToSpreadIndex)(t.getReadMode(),e))},goToSpread:function(t){if(e.props.findIsVisible)return void e.spreadAnimator.jumpToSpread(t,e.tick);var n=e.owner;e.props.dispatch((0,i.enableWebGL)()),setTimeout(function(){n.canvasObjectTree&&n.canvasObjectTree.spreadAnimator.goToSpread(t,e.tick)},0)},jumpToPage:function(e){t.jumpToSpread((0,d.pageNumberToSpreadIndex)(t.getReadMode(),e))},jumpToSpread:function(t){e.spreadAnimator.jumpToSpread(t,e.tick)},setSnapping:function(t){return e.spreadAnimator.setSnapping(t,e.tick)},jumpToPositionByPercent:function(t){return e.spreadAnimator.jumpToPositionByPercent(t,e.tick)},zoomCurrentView:function(t){return e.spreadAnimator.getCurrentSpread().setZoom(t,!1)},getPosition:function(){return e.getPosition()},setPosition:function(t){return e.setPosition(t)},tweakAnimation:function(t){e.spreadAnimator.tweakAnimation&&e.spreadAnimator.tweakAnimation(t)}};this.props.dispatch(o.setCanvasApi(t))},t.prototype.componentDidUpdate=function(e){!e.browserTabIsVisible&&this.props.browserTabIsVisible&&(this._interactionStartTime=-1,this._frameCountAtAnimationStart=-1)},t.prototype.componentWillUnmount=function(){this.props.dispatch(o.setEmptyCanvasApi())},t.prototype.getChildTree=function(){var e={allowUIToOverlayCover:this.props.allowUIToOverlayCover,canChangePages:this.props.documentPageSpreadList.length>1,currentSpreadIndex:this._currentSpreadIndex,currentPageNumber:this.props.currentPageNumber,disableGestures:this.props.findIsVisible,dispatch:this.props.dispatch,documentPageSpreadList:this.props.documentPageSpreadList,featureTracker:this.props.featureTracker,glManager:this.props.glManager,hideLinkToolTip:this.hideLinkToolTip,isLinksToggledOn:this._isLinkToggledOn,mayRenderLinks:this.props.mayRenderLinks,paywalledPageNumbers:this.props.paywalledPageNumbers,onAnimationEnd:this.onAnimationEnd,onAnimationStart:this.onAnimationStart,onSpreadChange:this.onSpreadChange,readMode:this.props.readMode,showLinkToolTip:this.showLinkToolTip,viewportHeight:this.props.height,viewportWidth:this.props.width,renderManager:this.props.renderManager};return h.CanvasObject.createElement("group",null,this.props.usePageFlip&&h.CanvasObject.createElement(v.PageFlip,e),!this.props.usePageFlip&&h.CanvasObject.createElement(m.HorizontalList,e),h.CanvasObject.createElement(g.LinkTooltip,{glManager:this.props.glManager,link:this._showTooltip}))},t.prototype.onSingleTapConfirmed=function(e,t,n,r){return this._isLinkToggledOn=!this._isLinkToggledOn,this.forceUpdate(),!0},t.prototype.getPosition=function(){var e=this,t=this.spreadAnimator.getCurrentSpread(),n=t.children,r=void 0;if(n.length<2)r=n[0];else{var o=h.CanvasObject.RectPool.get(0,0,this.props.width,this.props.height),i=n[0].viewportBBox,a=n[1].viewportBBox,s=(0,f.overlap)(o,i)-(0,f.overlap)(o,a);r=s>0?n[0]:s<0?n[1]:n.find(function(t){return t.model.pageNumber===e.props.currentPageNumber}),h.CanvasObject.RectPool.release(o)}if(!r)return null;var u=t.getCenter(),l=r.transform.inverse().transformPoint(u.x*t.width,u.y*t.height);return{x:l[0]/r.width,y:l[1]/r.height,zoom:t.getZoom(),pageNumber:r.pageNumber}},t.prototype.setPosition=function(e){var t=(0,d.pageNumberToSpreadIndex)(this.props.readMode,e.pageNumber),n=this.spreadAnimator.children[t],r=n.children.find(function(t){return t.pageNumber===e.pageNumber});n.scroller.zoom=e.zoom;var o=r.transform.transformPoint(e.x*r.width,e.y*r.height);n.setCenter({x:o[0],y:o[1]}),this.spreadAnimator.jumpToSpread(t,this.tick),this.requestRedraw()},t.prototype.getRenderedViews=function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],t={},n={x:0,y:0,width:this.width,height:this.height};return h.CanvasObject.traverse(this,function(r,o,i,a){if(!(0,f.overlap)(n,o))return!1;if(e&&!r.isVisible)return!0;t.hasOwnProperty(r.displayName)||(t[r.displayName]=[]);for(var s={},u=Object.keys(r).concat(Object.getOwnPropertyNames(Object.getPrototypeOf(r))),l=u,c=Array.isArray(l),p=0,l=c?l:l[Symbol.iterator]();;){var d;if(c){if(p>=l.length)break;d=l[p++]}else{if(p=l.next(),p.done)break;d=p.value}var h=d,m=r[h];"number"!=typeof m&&"string"!=typeof m&&"boolean"!=typeof m||(s[h]=m)}var g=r.model||{};return t[r.displayName].push(Object.assign(r.viewportBBox,{model:g,view:s})),!0}),JSON.parse(JSON.stringify(t))},babelHelpers.createClass(t,[{key:"tick",get:function(){return this.owner._lastTick}},{key:"frameCount",get:function(){return this.owner.frameCount}},{key:"inAnimation",get:function(){return this._inAnimation}}]),t}(h.CanvasObject),y=h.CanvasObject.connect(b,function(e){return{allowUIToOverlayCover:l.selectIsSmallReader(e)||e.features.allowUIToOverlayCover,browserTabIsVisible:!e.visibility.isHidden,currentPageNumber:e.reader.currentPageNumber||e.reader.initialPageNumber,currentSpreadIndex:e.reader.currentSpreadIndex,documentPageSpreadList:l.selectPageSpreadList(e),findIsVisible:c.selectors.isVisible(e),featureTracker:e.featureTracker,mayRenderLinks:l.mayRenderLinks(e)&&!c.selectors.isVisible(e),paywalledPageNumbers:p.selectors.previewPages(e)}});t.Root=b,t.ConnectedRoot=y},function(e,t,n){"use strict";t.__esModule=!0;t.ChromeFixSvg='\n    <svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="1px" height="1px">\n    <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g></svg>\n'},function(e,t,n){"use strict";function r(e){for(var t={x:0,y:0},n=0;n<e.length;n++)t.x+=e[n].x,t.y+=e[n].y;return{x:t.x/e.length,y:t.y/e.length}}function o(e,t){for(var n=e.length-1;n>=0;n--){var r=e[n];if(t(r))return r}}t.__esModule=!0,t.ConnectedCanvas=t.Canvas=void 0;var i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(2),u=babelHelpers.interopRequireDefault(s),l=n(55),c=n(92),p=n(47),d=n(331),f=n(110),h=n(29),m=babelHelpers.interopRequireWildcard(h),g=n(138),v=babelHelpers.interopRequireWildcard(g),b=n(78),y=n(35),_=n(79),E=n(11),w=n(96),S=n(97),x=n(140),T=n(48),C=n(320),I=n(218),R=babelHelpers.interopRequireWildcard(I),M=n(392),P=babelHelpers.interopRequireWildcard(M),O=n(746),A=(babelHelpers.interopRequireWildcard(O),t.Canvas=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),D.call(r),o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this._webglEnabled=!1,this._singleTapWasHandled=!1,this._lastMoveHitlist=[],this._handlersOfCurrentGesture=[],this._lastTick=0,this.frameCount=0,this.createContextAndInitializeCanvas(),this.fallbackTo2DIfViewportExceedGPULimit(),this.buildCanvasObjectTree(),this.canvasObjectTree?this.canvasObjectTree.requestRedraw():this.props.dispatch(v.setEmptyCanvasApi()),this.inputHandler=new b.InputHandler(this.refs.canvasContainer,{getScalingFactor:function(){return(0,y.getDPR)()},catchWheelEvent:function(){return e.props.fullscreenEnabled},onSingleTap:function(t,n){e._singleTapWasHandled=e.bubbleEvent(function(e){return e.onSingleTap},t,n,e._lastTick).handled,e.inputHandler.requestToIntercept()},onSingleTapConfirmed:function(t,n){e.bubbleEvent(function(e){return e.onSingleTapConfirmed},t,n,e._lastTick,e._singleTapWasHandled),e._singleTapWasHandled=!1,e.props.dispatch(m.onSingleTapConfirmed())},onDoubleTap:function(t,n){e.bubbleEvent(function(e){return e.onDoubleTap},t,n,e._lastTick),e.props.dispatch(m.onDoubleTap())},onGestureStart:function(t,n){e.props.dispatch((0,w.enableWebGL)());var o=r(t),i=o.x,a=o.y;e.bubbleEvent(function(e){return e.onGestureStart},i,a,e._lastTick,t,n).possibleHandlers.forEach(function(t){e._handlersOfCurrentGesture.push(t)}),e.props.dispatch(m.onInteractingWithCanvasStart())},onGestureChange:function(t,n,i,a){e.releaseMouseHitlist(e._lastTick,n);var s=r(t),u=s.x,l=s.y;o(e._handlersOfCurrentGesture,function(r){return!(!r.onGestureChange||!r.onGestureChange(u,l,e._lastTick,t,n,i,a))&&(e.inputHandler.requestToIntercept(),!0)}),e.props.dispatch(m.onInteractingWithCanvas())},onGestureEnd:function(t){o(e._handlersOfCurrentGesture,function(n){return n.onGestureEnd&&n.onGestureEnd(e._lastTick,t)}),e._handlersOfCurrentGesture.length=0,e.props.dispatch(m.onInteractingWithCanvasEnd())},onMouseEnter:function(t){e.props.dispatch((0,w.enableWebGL)())},onMouseMove:function(t,n,r){e.updateMouseHitlist(t,n,e._lastTick,r)},onMouseLeave:function(t){e.releaseMouseHitlist(e._lastTick,t)}});var t=function t(n){e._lastTick=n;var r=(0,y.getDPR)(),o=e.canvas.clientWidth*r,i=e.canvas.clientHeight*r;o!==e.props.width||i!==e.props.height?(e.props.dispatch((0,f.resize)(o,i)),e.props.dispatch(m.onResize())):e.canvasObjectTree&&e.canvasObjectTree.hasPendingRedraw&&e.drawCanvasObjectTree(),requestAnimationFrame(t)};requestAnimationFrame(t)},t.prototype.componentWillReceiveProps=function(e){var t=this,n=this.props;this.props=e;var r=n.readMode!==this.props.readMode||n.usePageFlip!==this.props.usePageFlip||n.visible!==this.props.visible||n.linksLoaded!==this.props.linksLoaded;this.canvasObjectTree&&r&&(this.previousPosition=this.canvasObjectTree.getPosition(),p.CanvasObject.unmountTree(this.canvasObjectTree),this.canvasObjectTree=null),n.usePageFlip!==this.props.usePageFlip&&this.createContextAndInitializeCanvas();var o=n.width!==this.props.width||n.height!==this.props.height;o&&(this.canvas.width=this.props.width,this.canvas.height=this.props.height,this.fallbackTo2DIfViewportExceedGPULimit()),this.props.usePageFlip&&(o&&this.ctx&&this.ctx.viewport(0,0,this.ctx.drawingBufferWidth,this.ctx.drawingBufferHeight),/(iPad|iPhone|iPod).*(AppleWebKit\/).*(Version\/9\.).*(Mobile\/).*(Safari\/)/i.test(navigator.userAgent)&&(n.visible&&!this.props.visible&&(this.canvas.style.display=""),!n.visible&&this.props.visible&&(this.canvas.style.display="none",setTimeout(function(){t.canvas.style.display=""},250)))),this.buildCanvasObjectTree(o),this.canvasObjectTree&&this.canvasObjectTree.requestRedraw(),1===this.props.zoomLevel?this.inputHandler.enableBrowserHandlingOfVerticalPanningGestures():this.inputHandler.disableBrowserHandlingOfAllPanningGestures()},t.prototype.shouldComponentUpdate=function(){return!1},t.prototype.componentWillUnmount=function(){this.inputHandler&&this.inputHandler.destroy(),this.renderManager&&this.renderManager.release(),this.glManager&&(this.glManager.destroy(),this.glManager=null),this.ctx=null,this._glExtOesStandardDerivatives=null,this.canvas.removeEventListener("webglcontextlost",this.handleContextLost,!1),this.canvas.removeEventListener("webglcontextrestored",this.handleContextRestored,!1)},t.prototype.render=function(){return u.default.createElement("div",{ref:"canvasContainer",style:{width:"100%",height:"100%"}})},t}(s.Component));A.displayName="Canvas",A.contextTypes={store:a.default.object};var D=function(){var e=this;this.onFallbackTo2D=function(){e.inputHandler&&e.inputHandler.reset(),e.props.tracker.monitorBatched({type:"reader3-fallback-to-2d",fallback:1})},this.getCustomCursor=function(){for(var t=e._lastMoveHitlist.length-1;t>=0;t--)if(e._lastMoveHitlist[t].getCustomCursor&&e._lastMoveHitlist[t].getCustomCursor())return e._lastMoveHitlist[t].getCustomCursor();return"default"},this.createRenderManager=function(){var t=null;t=e.props.usePageFlip?new P.DrawWebgl(e.ctx,e.props.width,e.props.height):new P.Draw2d(e.props.width,e.props.height);var n=new R.Render(t,e.props.documentPages,e.props.config,e.props.loadStatsTracker,e.props.paywallPreviewPages);e.renderManager&&n.reusePageData(e.renderManager),e.renderManager&&e.renderManager.release(),e.renderManager=n},this.createContextAndInitializeCanvas=function(){var t=document.createElement("canvas");if(t.className="document-canvas",t.style.width=t.style.height="100%",t.width=e.props.width,t.height=e.props.height,e.glManager&&(e.glManager.destroy(),e.glManager=null),e.canvas?(e._glExtOesStandardDerivatives=null,e.canvas.removeEventListener("webglcontextlost",e.handleContextLost,!1),e.canvas.removeEventListener("webglcontextrestored",e.handleContextRestored,!1),e.refs.canvasContainer.replaceChild(t,e.canvas)):e.refs.canvasContainer.appendChild(t),e.canvas=t,e.props.usePageFlip){var n=void 0;n=(0,x.getWebGLContext)(e.canvas,e.props.withStencilBuffer),e.ctx=n,n?(e._glExtOesStandardDerivatives=n.getExtension("OES_standard_derivatives"),n.viewport(0,0,n.drawingBufferWidth,n.drawingBufferHeight),e.glManager=new C.GlManager(n),e.canvas.addEventListener("webglcontextlost",e.handleContextLost,!1),e.canvas.addEventListener("webglcontextrestored",e.handleContextRestored,!1)):e.handleWebGLError()}else e.ctx=e.canvas.getContext("2d")},this.findComponentsAtPoint=function(t,n){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],o=[];return e.canvasObjectTree&&p.CanvasObject.traverse(e.canvasObjectTree,function(e,i,a,s){return!(r&&!e.isVisible)&&(!!(0,_.pointInRect)(t,n,i)&&(o.push(e),!0))}),o},this.bubbleEvent=function(t,n,r){for(var i=arguments.length,a=Array(i>3?i-3:0),s=3;s<i;s++)a[s-3]=arguments[s];for(var u={handled:!1,possibleHandlers:[]},l=e.findComponentsAtPoint(n,r),c=Array.isArray(l),p=0,l=c?l:l[Symbol.iterator]();;){var d;if(c){if(p>=l.length)break;d=l[p++]}else{if(p=l.next(),p.done)break;d=p.value}var f=d;t(f)&&u.possibleHandlers.push(f)}return o(u.possibleHandlers,function(e){var o=t(e);return!(!o||!o.call.apply(o,[e,n,r].concat(a)))&&(u.handled=!0,!0)}),u},this.updateMouseHitlist=function(t,n,r){var i=e.findComponentsAtPoint(t,n,!1),a=i[i.length-1],s=e._lastMoveHitlist[e._lastMoveHitlist.length-1];a!==s&&(s&&s.onMouseLeave&&s.onMouseLeave(r,e._lastTick),a&&a.onMouseEnter&&a.onMouseEnter(r,e._lastTick)),e._lastMoveHitlist=i,o(i,function(e){return e.onMouseMove&&e.onMouseMove(t,n,r)})},this.releaseMouseHitlist=function(t){var n=e._lastMoveHitlist[e._lastMoveHitlist.length-1];n&&n.onMouseLeave&&n.onMouseLeave(t),e._lastMoveHitlist=[]},this.fallbackTo2DIfViewportExceedGPULimit=function(){if(e.ctx&&(0,x.isWebGLContext)(e.ctx)){var t=e.props.width-e.ctx.drawingBufferWidth>1,n=e.props.height-e.ctx.drawingBufferHeight>1;(t||n)&&(t&&e.props.dispatch((0,w.setMaxDrawingBufferWidth)(e.ctx.drawingBufferWidth)),n&&e.props.dispatch((0,w.setMaxDrawingBufferHeight)(e.ctx.drawingBufferHeight)),e.onFallbackTo2D())}},this.handleWebGLError=function(t){t&&(0,c.captureException)(t,{extra:{"fallback-to-2d":!0}}),e.onFallbackTo2D(),e.props.dispatch((0,w.onWebGLError)())},this.buildCanvasObjectTree=function(t){if(e.props.visible&&!(!e.ctx||(0,x.isWebGLContext)(e.ctx)&&e.ctx.isContextLost())){try{e.canvasObjectTree&&!t||e.createRenderManager(),e.canvasObjectTree=p.CanvasObject.buildTree(p.CanvasObject.createElement(d.ConnectedRoot,{ctx:e.ctx,height:e.props.height,loadStatsTracker:e.props.loadStatsTracker,readMode:e.props.readMode,renderManager:e.renderManager,store:e.context.store,usePageFlip:e.props.usePageFlip,width:e.props.width}),e.canvasObjectTree,e)}catch(t){if(!(0,x.isWebGLContext)(e.ctx))throw t;e.handleWebGLError(t)}e.canvasObjectTree&&e.previousPosition&&(e.canvasObjectTree.setPosition(e.previousPosition),e.previousPosition=null)}},this.drawCanvasObjectTree=function(){if(e.ctx&&e.props.visible){if((0,x.isWebGLContext)(e.ctx)){if(e.ctx.isContextLost())return}else e.ctx.clearRect(0,0,e.props.width,e.props.height);try{var t={x:0,y:0,width:e.props.width,height:e.props.height};(0,x.isWebGLContext)(e.ctx)?p.CanvasObject.drawWebgl(e.canvasObjectTree,e.glManager,t,e._lastTick):p.CanvasObject.draw2d(e.canvasObjectTree,e.ctx,t,e._lastTick)}catch(t){if(!(0,x.isWebGLContext)(e.ctx))throw t;e.handleWebGLError(t)}var n=e.getCustomCursor();e.refs.canvasContainer&&e.refs.canvasContainer.style.cursor!==n&&(e.refs.canvasContainer.style.cursor=n),e.frameCount+=1}},this.handleContextLost=function(t){t.preventDefault(),e.props.onWebGLContextLost&&e.props.onWebGLContextLost(),e.props.dispatch((0,w.disableWebGL)())},this.handleContextRestored=function(t){e.props.onWebGLContextRestored&&e.props.onWebGLContextRestored(),e.buildCanvasObjectTree(),e.canvasObjectTree&&e.canvasObjectTree.requestRedraw()},this._webglEnabled=!1,this._singleTapWasHandled=!1,this._lastMoveHitlist=[],this._handlersOfCurrentGesture=[],this._lastTick=0,this.frameCount=0};t.ConnectedCanvas=(0,l.connect)(function(e){return{height:e.size.height,width:e.size.width,readMode:(0,E.selectReadMode)(e),visible:!e.visibility.supported||!e.visibility.isHidden,usePageFlip:(0,w.selectUseWebGL)(e),fullscreenEnabled:(0,E.selectFullscreenEnabled)(e),config:e.config,documentPages:(0,S.selectPages)(e),dropdownOpen:(0,E.isDropdownOpen)(e),linksLoaded:e.documentModel.linksLoaded,zoomLevel:e.reader.zoomLevel,paywallPreviewPages:T.selectors.previewPages(e),isIdle:e.reader.isIdle}},null,null,{pure:!1,withRef:!0})(A)},function(e,t,n){"use strict";t.__esModule=!0,t.ConnectedControls=t.Controls=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(55),a=n(85),s=babelHelpers.interopRequireDefault(a),u=n(46),l=babelHelpers.interopRequireDefault(u),c=n(20),p=babelHelpers.interopRequireDefault(c),d=n(76),f=n(354),h=n(356),m=n(338),g=n(78),v=n(58),b=n(8),y=babelHelpers.interopRequireWildcard(b),_=n(29),E=babelHelpers.interopRequireWildcard(_),w=n(11),S=babelHelpers.interopRequireWildcard(w),x=n(388),T=babelHelpers.interopRequireWildcard(x),C=n(97),I=n(41),R=n(21),M=n(204),P=t.Controls=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onReadOnIssuuClick=function(){r.props.brandingFeature.kind===I.ISSUU_BRANDING_KIND.LANDING_PAGE&&(window.open("https://issuu.com","_blank"),r.props.dispatch(E.onButtonClick()),r.props.featureTracker.usage(R.FEATURES.BUTTON_LOGO))},r.onToggleFullscreenClick=function(){r.props.toggleFullscreen(),r.props.featureTracker.usage(R.FEATURES.BUTTON_FULLSCREEN),r.props.dispatch(E.onButtonClick())},r.onSliderActivityStart=function(){r.props.dispatch(y.setInteractingWithControls(!0)),r.props.dispatch(E.onInteractingWithSlider())},r.onSliderActivityChange=function(){r.props.dispatch(E.onInteractingWithSlider())},r.onSliderActivityEnd=function(){r.props.dispatch(y.setInteractingWithControls(!1)),r.props.dispatch(E.onInteractingWithSlider())},r.getReadOnIssuuTooltip=function(){return r.props.brandingFeature.kind===I.ISSUU_BRANDING_KIND.LANDING_PAGE?"See more on issuu":null},r.handlePageSliderOnChangeStart=function(){r.props.canvasApi.setSnapping(!1),r.onSliderActivityStart(),r._percentBeforeSlider=r.props.currentPageSliderPosition},r.handlePageSliderOnChange=function(e){r.onSliderActivityChange(),r.props.canvasApi.jumpToPositionByPercent(e)},r.handlePageSliderOnChangeEnd=function(e){r.props.canvasApi.setSnapping(!0),r.onSliderActivityEnd(),r.props.currentPageSliderPosition!==r._percentBeforeSlider&&r.props.featureTracker.usage(R.FEATURES.SLIDER_PAGES)},r.handleZoomSliderOnChangeStart=function(){r.onSliderActivityStart()},r.handleZoomSliderOnChange=function(e){r.onSliderActivityChange(),r.props.canvasApi.zoomCurrentView(e)},r.handleZoomSliderOnChangeEnd=function(){r.onSliderActivityEnd()},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.inputHandler=new g.InputHandler(s.default.findDOMNode(this.refs.controlsContainer),{onMouseEnter:function(){e.props.visible&&e.props.dispatch(y.setHoveringOverControls(!0))},onMouseLeave:function(){e.props.dispatch(y.setHoveringOverControls(!1))}}),this.props.featureTracker.opportunity(R.FEATURES.SLIDER_PAGES)},t.prototype.shouldComponentUpdate=function(e,t){var n=this.props.visible!==e.visible;return e.visible&&(n=n||!((0,l.default)(this.props,e)&&(0,l.default)(this.state,t))),n},t.prototype.componentWillUnmount=function(){this.inputHandler&&this.inputHandler.destroy()},t.prototype.render=function(){var e=void 0;this.props.brandingFeature&&!this.props.isTinyEmbed&&this.props.brandingFeature.kind===I.ISSUU_BRANDING_KIND.LANDING_PAGE&&(e=o.default.createElement("div",{className:"controls__read-on-issuu"},o.default.createElement("div",{className:"controls__read-on-issuu-button","data-tooltip":this.getReadOnIssuuTooltip()},o.default.createElement(d.Button,{className:"svg-btn logo-icon",onClick:this.onReadOnIssuuClick,content:M.IssuuLogo}))),this.props.featureTracker.opportunity(R.FEATURES.BUTTON_LOGO));var t=null;if(this.props.fullscreenFeature){var n=!1;switch(this.props.fullscreenFeature.showButtons){case I.FULLSCREEN_BUTTON.ALWAYS:n=!0;break;case I.FULLSCREEN_BUTTON.HIDE:n=this.props.fullscreenIsSupported}n&&(t=o.default.createElement(m.FullscreenControls,{fullscreenEnabled:this.props.fullscreenEnabled,toggleFullscreen:this.onToggleFullscreenClick}),this.props.featureTracker.opportunity(R.FEATURES.BUTTON_FULLSCREEN))}var r=(0,p.default)("controls",{"controls--hidden":!this.props.visible});return o.default.createElement("div",{className:r,ref:"controlsContainer"},o.default.createElement("div",{className:"controls__part controls__part--page-controls"},o.default.createElement(f.PageControls,{currentPageSliderPosition:this.props.currentPageSliderPosition,currentPageNumbers:this.props.currentPageNumbers,pageCount:this.props.pageCount,pageSliderOnChangeStart:this.handlePageSliderOnChangeStart,pageSliderOnChange:this.handlePageSliderOnChange,pageSliderOnChangeEnd:this.handlePageSliderOnChangeEnd,segments:this.props.pageSegments,resultMarkers:this.props.resultMarkers})),this.props.zoomFeature&&o.default.createElement("div",{className:"controls__part controls__part--zoom-controls"},o.default.createElement(h.ZoomControls,{currentZoomLevel:this.props.zoomLevel,dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,segments:this.props.zoomSegments,zoomSliderOnChangeStart:this.handleZoomSliderOnChangeStart,zoomSliderOnChange:this.handleZoomSliderOnChange,zoomSliderOnChangeEnd:this.handleZoomSliderOnChangeEnd})),e&&o.default.createElement("div",{className:"controls__part"},e),this.props.enableFind&&o.default.createElement("div",{className:"controls__part"},o.default.createElement(v.components.FindButton,{featureTracker:this.props.featureTracker})),t&&o.default.createElement("div",{className:"controls__part controls__part--fullscreen-controls"},t))},t}(r.Component);P.displayName="Controls";var O=function(e){return{brandingFeature:S.selectIssuuBrandingFeature(e),canvasApi:e.canvasApi,enableFind:e.features.enableFind,currentPageNumbers:S.selectCurrentPageNumbers(e).join("-"),currentPageSliderPosition:S.selectCurrentPositionInPercent(e),featureTracker:e.featureTracker,fullscreenEnabled:S.selectFullscreenEnabled(e),fullscreenIsSupported:e.fullscreen.supported,pageCount:(0,C.selectPageCount)(e),pageSegments:T.segmentPages(e),resultMarkers:v.selectors.selectResultMarkers(e),fullscreenFeature:S.selectFullscreenFeature(e),zoomFeature:S.selectZoomFeature(e),zoomLevel:e.reader.zoomLevel,zoomSegments:T.segmentZoom(e)}};t.ConnectedControls=(0,i.connect)(O,void 0,void 0,{pure:!1})(P)},function(e,t,n){"use strict";t.__esModule=!0,t.CTAOverlay=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(85),u=babelHelpers.interopRequireDefault(s),l=n(8),c=babelHelpers.interopRequireWildcard(l),p=n(29),d=babelHelpers.interopRequireWildcard(p),f=n(76),h=n(78),m=n(21),g=n(202),v=n(203),b=t.CTAOverlay=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onClickHandler=function(){r.props.featureTracker.usage(m.FEATURES.BUTTON_CTA_OVERLAY),r.props.dispatch(d.onButtonClick()),r.props.toggleFullscreen()},r.trackOpportunities=function(){r.props.visible&&r.props.featureTracker.opportunity(m.FEATURES.BUTTON_CTA_OVERLAY)},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.inputHandler=new h.InputHandler(u.default.findDOMNode(this.refs.button),{onMouseEnter:function(){e.props.visible&&e.props.dispatch(c.setHoveringOverControls(!0))},onMouseLeave:function(){e.props.dispatch(c.setHoveringOverControls(!1))}}),this.trackOpportunities()},t.prototype.componentDidUpdate=function(){this.trackOpportunities()},t.prototype.render=function(){var e=this.props.fullscreenEnabled?g.ExitFullscreenIcon:v.FullscreenIcon,t=this.props.fullscreenEnabled?"Exit":"Fullscreen";return o.default.createElement("div",{ref:"button",className:"cta-overlay "+(this.props.visible?"":"cta-overlay--hidden"),"data-tooltip":t,onClick:this.onClickHandler},o.default.createElement(f.Button,{id:"ird3-button-fullscreen",className:"svg-btn cta-overlay__button",content:e}))},t}(r.Component);b.displayName="CTAOverlay",b.propTypes={dispatch:a.default.func.isRequired,featureTracker:a.default.object.isRequired,fullscreenEnabled:a.default.bool.isRequired,toggleFullscreen:a.default.func.isRequired,visible:a.default.bool.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.DownloadDropdown=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(8),a=babelHelpers.interopRequireWildcard(i),s=n(29),u=babelHelpers.interopRequireWildcard(s),l=n(21),c=n(10),p=babelHelpers.interopRequireDefault(c),d=t.DownloadDropdown=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,s=Array(i),c=0;c<i;c++)s[c]=arguments[c];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(s))),r.onDimmerClick=function(){r.props.dispatch(a.toggleDownloadDropdown()),r.props.dispatch(u.onButtonClick())},r.onDownloadFromIssuuLinkClick=function(){r.props.featureTracker.usage(l.FEATURES.DOWNLOAD_FROM_ISSUU_LINK),r.onDimmerClick()},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){this.props.visible&&this.props.featureTracker.opportunity(l.FEATURES.DOWNLOAD_FROM_ISSUU_LINK)},t.prototype.render=function(){return o.default.createElement("div",{className:"download-dropdown"},o.default.createElement("div",{className:"download-dropdown__dimmer",onClick:this.onDimmerClick}),o.default.createElement("div",{className:"download-dropdown__inner"},o.default.createElement("div",{className:"download-dropdown__content"},o.default.createElement("span",null,"Go to "),o.default.createElement("a",{href:this.props.downloadUrl,onClick:this.onDownloadFromIssuuLinkClick,className:"download-dropdown__download-link",target:"_blank"},"issuu.com"),o.default.createElement("span",null," and sign in or create a free account to download"))))},t}(r.Component);d.displayName="DownloadDropdown",d.propTypes={dispatch:p.default.func.isRequired,downloadUrl:p.default.string.isRequired,featureTracker:p.default.object.isRequired,visible:p.default.bool.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.Failed=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(340),a=n(206),s=n(131),u=n(357),l=babelHelpers.interopRequireWildcard(u),c=n(10),p=babelHelpers.interopRequireDefault(c),d=t.Failed=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onRetry=function(e){e.preventDefault(),r.props.loadDocument()},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.props.error.code===l.PENDING&&window.setTimeout(function(){e.props.loadDocument()},1e4)},t.prototype.render=function(){var e="Something went wrong",t=o.default.createElement("div",{className:"failed__icon",dangerouslySetInnerHTML:{__html:i.BrokenEmbedIcon}}),n={},r={};switch(this.props.error.code){case l.CONVERSION_ERROR:e="Conversion failed",t=o.default.createElement("div",{className:"failed__icon",dangerouslySetInnerHTML:{__html:a.WarningIcon}}),n.display="none",r.display="none";break;case l.PENDING:e="Document is getting ready, hang on",t=o.default.createElement("div",{className:"failed__icon"},o.default.createElement(s.Spinner,null)),n.display="none",r.display="none";break;case l.QUARANTINED:e="This publication is no longer available\ndue to a copyright claim by a third party.",t=o.default.createElement("div",{className:"failed__icon",dangerouslySetInnerHTML:{__html:a.WarningIcon}}),n.display="none",r.display="none";break;case l.DELETED:case l.MAX_RETRY_MATERIALIZER_ERROR:case l.NAME_MISSING:case l.PAGES_MISSING:case l.PAGE_COUNT_MISSING:case l.UNKNOWN_MATERIALIZER_ERROR:case l.USER_MISSING:e="Sorry, this publication is not available",n.display="none",r.display="none"}return o.default.createElement("div",{className:"failed"},t,o.default.createElement("h1",{className:"failed__message"},e),o.default.createElement("div",{className:"failed__retry-link-container",style:n},o.default.createElement("a",{className:"failed__retry-link",href:"#",onClick:this.onRetry},"Try again")),o.default.createElement("div",{className:"failed__help"},o.default.createElement("div",{className:"failed__error-token",style:r},"Error ID: ",this.props.sessionId),o.default.createElement("div",{className:"failed__spacer",style:r}),o.default.createElement("div",{className:"failed__support-link-container"},o.default.createElement("a",{className:"failed__support-link",href:"http://help.issuu.com",target:"_blank"},"help.issuu.com"))))},t}(r.Component);d.displayName="Failed",d.propTypes={error:p.default.object.isRequired,loadDocument:p.default.func.isRequired,sessionId:p.default.string.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.FullscreenControls=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(76),u=n(202),l=n(203),c=t.FullscreenControls=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e,t){return this.props.fullscreenEnabled!==e.fullscreenEnabled},t.prototype.render=function(){var e=this.props.fullscreenEnabled?u.ExitFullscreenIcon:l.FullscreenIcon;return o.default.createElement("div",{className:"fullscreen-controls"},o.default.createElement("div",{className:"fullscreen-controls__button","data-tooltip":this.props.fullscreenEnabled?"Exit":"Fullscreen"},o.default.createElement(s.Button,{id:"ird3-button-fullscreen",className:"svg-btn ",onClick:this.props.toggleFullscreen,content:e})))},t}(r.Component);c.displayName="FullscreenControls",c.propTypes={fullscreenEnabled:a.default.bool.isRequired,toggleFullscreen:a.default.func.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.ConnectedHeaderControls=t.HeaderControls=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(85),a=babelHelpers.interopRequireDefault(i),s=n(20),u=babelHelpers.interopRequireDefault(s),l=n(55),c=n(78),p=n(378),d=babelHelpers.interopRequireWildcard(p),f=n(346),h=n(336),m=n(95),g=n(8),v=babelHelpers.interopRequireWildcard(g),b=n(129),y=babelHelpers.interopRequireWildcard(b),_=n(29),E=babelHelpers.interopRequireWildcard(_),w=n(11),S=babelHelpers.interopRequireWildcard(w),x=n(213),T=babelHelpers.interopRequireWildcard(x),C=n(94),I=babelHelpers.interopRequireWildcard(C),R=n(215),M=babelHelpers.interopRequireWildcard(R),P=n(216),O=babelHelpers.interopRequireWildcard(P),A=n(109),D=babelHelpers.interopRequireWildcard(A),k=n(208),N=n(342),L=n(341),F=n(206),U=n(205),H=n(21),B=t.HeaderControls=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onMoreToggleClick=function(){r.props.readMoreDropdownVisible?r.props.dispatch(v.closeMoreDropdown()):r.props.readMorePlugin&&(r.props.readMorePlugin.clearButtonUnreadCount(),r.props.dispatch(v.showMoreDropdown()),r.props.featureTracker.usage(H.FEATURES.BUTTON_MORE)),r.props.dispatch(E.onButtonClick())},r.onInfoToggleClick=function(){r.props.dispatch(v.toggleInfoDropdown()),r.props.dispatch(E.onButtonClick()),r.props.featureTracker.usage(H.FEATURES.BUTTON_INFO)},r.onDownloadButtonClick=function(){r.props.downloadButtonStatus===y.types.DOWNLOAD_READY&&(r.props.dispatch(r.props.canDownloadAnonymously?y.downloadAnonymously():v.toggleDownloadDropdown()),r.props.dispatch(E.onButtonClick()),r.props.featureTracker.usage(H.FEATURES.BUTTON_DOWNLOAD))},r.trackOpportunities=function(){r.props.shouldRenderReadMoreButton&&r.props.featureTracker.opportunity(H.FEATURES.BUTTON_MORE),r.props.shouldRenderShareButton&&r.props.featureTracker.opportunity(H.FEATURES.BUTTON_SHARE),r.props.shouldRenderInfoButton&&r.props.featureTracker.opportunity(H.FEATURES.BUTTON_INFO),r.props.shouldRenderDownloadButton&&r.props.featureTracker.opportunity(H.FEATURES.BUTTON_DOWNLOAD)},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.inputHandler=new c.InputHandler(a.default.findDOMNode(this.refs.headerControlsContainer),{onMouseEnter:function(){e.props.isVisible&&e.props.dispatch(v.setHoveringOverControls(!0))},onMouseLeave:function(){e.props.dispatch(v.setHoveringOverControls(!1))}}),this.trackOpportunities()},t.prototype.componentDidUpdate=function(e,t){this.trackOpportunities()},t.prototype.render=function(){var e=(0,u.default)("header-controls",{"is-visible":this.props.isVisible}),t=(0,u.default)("header-controls__share-dropdown-wrapper",{"is-visible":this.props.shareDropdownVisible}),n=(0,u.default)("header-controls__info-dropdown-wrapper",{"is-visible":this.props.infoDropdownVisible}),r=(0,u.default)("header-controls__button","header-controls__info-toggle",{"is-visible":!m.device.isMobile(),"header-controls__info-toggle--active":this.props.infoDropdownVisible}),i=(0,u.default)("header-controls__download-dropdown-wrapper",{"is-visible":this.props.downloadDropdownVisible}),a=(0,u.default)({"header-controls__item--tooltip":!this.props.downloadDropdownVisible}),s=(0,u.default)("header-controls__button","header-controls__download",{"is-visible":!0,"is-loading":this.props.downloadButtonStatus===y.types.DOWNLOAD_LOADING,"is-failure":this.props.downloadButtonStatus===y.types.DOWNLOAD_FAILURE,spinner:this.props.downloadButtonStatus===y.types.DOWNLOAD_LOADING}),l=L.DownloadIcon,c="Download";return this.props.downloadButtonStatus===y.types.DOWNLOAD_LOADING?(l=U.SpinnerIcon,c="Downloading"):this.props.downloadButtonStatus===y.types.DOWNLOAD_FAILURE&&(l=F.WarningIcon,c="Failed to download"),o.default.createElement("div",{ref:"headerControlsContainer",className:e},o.default.createElement("div",{className:"header-controls__items"},this.props.shouldRenderInfoButton&&o.default.createElement("div",{className:"header-controls__item"},o.default.createElement("div",{className:r,onClick:this.onInfoToggleClick,dangerouslySetInnerHTML:{__html:N.InfoIcon}}),o.default.createElement("div",{className:n},o.default.createElement(f.InfoDropdown,{coverImageUrl:this.props.coverImageUrl,dispatch:this.props.dispatch,documentTitle:this.props.documentTitle,featureTracker:this.props.featureTracker,profileImageUrl:this.props.publisherProfileImageUrl,publishDate:this.props.publishDate,publisherName:this.props.publisherName,publisherUrl:this.props.publisherUrl,visible:this.props.infoDropdownVisible}))),this.props.shouldRenderDownloadButton&&o.default.createElement("div",{className:"header-controls__item"},o.default.createElement("div",{className:a,"data-tooltip":c},o.default.createElement("div",{className:s,onClick:this.onDownloadButtonClick,dangerouslySetInnerHTML:{__html:l}})),o.default.createElement("div",{className:i},o.default.createElement(h.DownloadDropdown,{dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,downloadUrl:this.props.downloadFromIssuuUrl,visible:this.props.downloadDropdownVisible}))),o.default.createElement("div",{className:"header-controls__item header-controls__item--spacer"}),this.props.shouldRenderReadMoreButton&&o.default.createElement("div",{className:(0,u.default)("header-controls__item",{"header-controls__item--centered":this.props.readMoreButtonCentered})},o.default.createElement("div",{className:(0,u.default)("header-controls__more-toggle",{"header-controls__more-toggle--activated":this.props.readMoreDropdownVisible}),onClick:this.onMoreToggleClick},o.default.createElement("span",{className:"header-controls__more-toggle-text-wrapper"},"See More",this.props.readMoreButtonUnreadCount>0&&o.default.createElement("div",{className:"header-controls__morecount"},this.props.readMoreButtonUnreadCount)))),this.props.shouldRenderShareButton&&o.default.createElement("div",{className:"header-controls__item"},o.default.createElement(d.Button,{dispatch:this.props.dispatch,featureTracker:this.props.featureTracker}),o.default.createElement("div",{className:t},o.default.createElement(d.Dropdown,{dispatch:this.props.dispatch,documentTitle:this.props.documentTitle,documentUrl:this.props.documentUrl,coverImageUrl:this.props.coverImageUrl,visible:this.props.shareDropdownVisible,featureTracker:this.props.featureTracker})))))},t}(r.Component);B.displayName="HeaderControls";var j=function(e){return{coverImageUrl:M.selectPublicationCoverUrl(e),documentTitle:e.documentModel.title,documentUrl:S.selectDocumentUrlOnProduction(e),featureTracker:e.featureTracker,publishDate:e.documentModel.publishDate,publisherName:e.documentModel.userDisplayName,publisherProfileImageUrl:O.selectPublisherProfileImageUrl(e),publisherUrl:O.selectPublisherProfileUrl(e),readMorePlugin:e.readMorePlugin,downloadFromIssuuUrl:"https://"+e.config.hosts.main+"/"+e.documentModel.username+"/docs/"+e.documentModel.documentName+"/#download",shouldRenderDownloadButton:T.shouldRenderDownloadButton(e),shouldRenderInfoButton:T.shouldRenderInfoButton(e),shouldRenderReadMoreButton:D.selectShouldRenderButton(e),shouldRenderShareButton:d.shouldRenderShareButton(e),downloadButtonStatus:e.headerControls.downloadButtonStatus,canDownloadAnonymously:I.canDownloadAnonymously(e),infoDropdownVisible:e.headerControls.visibleDropdown===k.INFO,downloadDropdownVisible:e.headerControls.visibleDropdown===k.DOWNLOAD,readMoreButtonCentered:m.device.isMobile()&&window.innerWidth<window.innerHeight,readMoreButtonUnreadCount:D.selectButtonUnreadCount(e),isVisible:S.isControlsVisible(e)&&(D.selectShouldRenderButton(e)||d.shouldRenderShareButton(e)||T.shouldRenderDownloadButton(e)||T.shouldRenderInfoButton(e)),readMoreDropdownVisible:S.moreOverlayVisible(e),shareDropdownVisible:d.isDropdownVisible(e)}};t.ConnectedHeaderControls=(0,l.connect)(j,void 0,void 0,{pure:!0})(B)},function(e,t,n){"use strict";t.__esModule=!0;t.BrokenEmbedIcon='\n    <svg width="43" height="36" viewBox="0 0 43 36" xmlns="http://www.w3.org/2000/svg">\n        <title>Rectangle 425 + Rectangle 425 Copy 2 + Rectangle 429</title>\n        <g fill="#9AA8A9" fill-rule="evenodd" opacity=".3">\n            <path d="M42.934 18.503c.032-.338-.107-.682-.396-.9L30.273 8.36c-.435-.327-1.08-.243-1.418.206-.34.45-.25 1.084.194 1.42l11.303 8.517L29.05 27.02c-.446.336-.535.97-.195 1.42.338.45.983.533 1.418.205l12.265-9.242c.29-.218.428-.562.396-.9zM.466 18.503c-.032-.338.107-.682.397-.9L13.127 8.36c.435-.327 1.08-.243 1.418.206.34.45.25 1.084-.194 1.42L3.05 18.502 14.35 27.02c.446.336.536.97.195 1.42-.338.45-.983.533-1.418.205L.863 19.403c-.29-.218-.43-.562-.397-.9z"/><rect transform="rotate(14 22.02 17.898)" x="21.039" y="-.102" width="1.964" height="36" rx=".982"/>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0;var r='d="M7.593 13.866c.07.072.153.13.247.165.08.04.16.06.26.06l.01.005c.18 0 .36-.08.5-.223l4.037-4.016c.282-.253.282-.688 0-.967-.258-.277-.697-.277-.978 0L8.8 11.723V.732C8.8.357 8.48.04 8.1.04 7.72.04 7.4.356 7.4.73v10.992L4.52 8.885c-.26-.277-.7-.277-.98 0-.28.258-.28.693 0 .97l4.053 4.01zm6.398 3.228L2 17.1c-2.02 0-1.24-1.356.02-1.356l11.975-.005c1.26 0 2.024 1.36.005 1.36l-.01-.006z" fill="#F2F2F2" fill-rule="evenodd"';t.DownloadIcon='<svg width="16" height="18" viewBox="-2 0 20 18" xmlns="http://www.w3.org/2000/svg">\n  <path class="shadow" '+r+'></path>\n  <path class="icon" '+r+"></path>\n</svg>"},function(e,t,n){"use strict";t.__esModule=!0;t.InfoIcon='<svg width="100%" height="100%" viewBox="-1 0 18 16">\n    <g stroke="none" stroke-width="1" fill-rule="evenodd">\n        <g transform="translate(-24.000000, -77.000000)">\n            <path class="shadow" d="M32,93 C36.418278,93 40,89.418278 40,85 C40,80.581722 36.418278,77 32,77 C27.581722,77 24,80.581722 24,85 C24,89.418278 27.581722,93 32,93 Z M30.9494629,81.0688477 C30.9494629,80.4383106 31.3006964,80.1230469 32.0031739,80.1230469 C32.7056513,80.1230469 33.0568848,80.4383106 33.0568848,81.0688477 C33.0568848,81.3693049 32.9690764,81.6031079 32.7934571,81.7702637 C32.6178377,81.9374195 32.3544126,82.0209961 32.0031739,82.0209961 C31.3006964,82.0209961 30.9494629,81.7036165 30.9494629,81.0688477 Z M32.9680176,90 L31.0319825,90 L31.0319825,82.9033203 L32.9680176,82.9033203 L32.9680176,90 Z"></path>\n            <path class="icon" d="M32,93 C36.418278,93 40,89.418278 40,85 C40,80.581722 36.418278,77 32,77 C27.581722,77 24,80.581722 24,85 C24,89.418278 27.581722,93 32,93 Z M30.9494629,81.0688477 C30.9494629,80.4383106 31.3006964,80.1230469 32.0031739,80.1230469 C32.7056513,80.1230469 33.0568848,80.4383106 33.0568848,81.0688477 C33.0568848,81.3693049 32.9690764,81.6031079 32.7934571,81.7702637 C32.6178377,81.9374195 32.3544126,82.0209961 32.0031739,82.0209961 C31.3006964,82.0209961 30.9494629,81.7036165 30.9494629,81.0688477 Z M32.9680176,90 L31.0319825,90 L31.0319825,82.9033203 L32.9680176,82.9033203 L32.9680176,90 Z"></path>\n        </g>\n    </g>\n</svg>'},function(e,t,n){"use strict";t.__esModule=!0;t.NavigationArrowIcon='\n    <svg width="100%" height="100%" viewBox="-4 -4 30 52">\n        <defs>\n        </defs>\n        <g fill="none" class="navigation-arrow__shadow" stroke="#000" stroke-width="4" transform="translate(9 22)">\n            <path d="M2.65002234,43.5538147 C1.78774217,42.6020596 1.78774217,41.0560678 2.65002234,40.1030925 L17.6687127,23.4986273 L2.64671013,6.89660245 C1.78442996,5.94362719 1.78442996,4.39885551 2.64671013,3.44588025 C3.5089903,2.49290499 4.90674535,2.49290499 5.76902553,3.44588025 L22.3532899,21.7732662 C23.21557,22.7250212 23.21557,24.2697929 22.3532899,25.2239884 L5.77233774,43.5538147 C5.34174969,44.0309124 4.77646487,44.2688512 4.21118004,44.2688512 C3.64589522,44.2688512 3.08171447,44.0309124 2.65002234,43.5538147 Z" transform="translate(-10.5, -23.5)"/>\n        </g>\n        <g fill="white" class="navigation-arrow__path" transform="translate(9 22)">\n            <path d="M2.65002234,43.5538147 C1.78774217,42.6020596 1.78774217,41.0560678 2.65002234,40.1030925 L17.6687127,23.4986273 L2.64671013,6.89660245 C1.78442996,5.94362719 1.78442996,4.39885551 2.64671013,3.44588025 C3.5089903,2.49290499 4.90674535,2.49290499 5.76902553,3.44588025 L22.3532899,21.7732662 C23.21557,22.7250212 23.21557,24.2697929 22.3532899,25.2239884 L5.77233774,43.5538147 C5.34174969,44.0309124 4.77646487,44.2688512 4.21118004,44.2688512 C3.64589522,44.2688512 3.08171447,44.0309124 2.65002234,43.5538147 Z" transform="translate(-10.5, -23.5)"/>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0;var r='x="17" y="10" width="2" height="16" rx="2"',o='transform="translate(18.000000, 18.000000) scale(-1, -1) rotate(-270.000000) translate(-18.000000, -18.000000) " x="17" y="10" width="2" height="16" rx="2"';t.ZoomInIcon='\n    <svg width="100%" height="100%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <rect '+r+"></rect>\n                <rect "+o+'></rect>\n            </g>\n        </g>\n        <rect class="shadow" '+r+'></rect>\n        <rect class="shadow" '+o+'></rect>\n        <rect class="icon" '+r+'></rect>\n        <rect class="icon" '+o+"></rect>\n    </svg>\n"},function(e,t,n){"use strict";t.__esModule=!0;var r='transform="translate(18.000000, 18.000000) rotate(-270.000000) translate(-18.000000, -18.000000) " x="17" y="10" width="2" height="16" rx="2"';t.ZoomOutIcon='\n    <svg width="36px" height="36px" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <rect '+r+'></rect>\n            </g>\n        </g>\n        <rect class="shadow" '+r+'></rect>\n        <rect class="icon" '+r+"></rect>\n    </svg>\n"},function(e,t,n){"use strict";t.__esModule=!0,t.InfoDropdown=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(8),u=babelHelpers.interopRequireWildcard(s),l=n(29),c=babelHelpers.interopRequireWildcard(l),p=n(21),d=t.InfoDropdown=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onPublisherLinkClick=function(){r.props.featureTracker.usage(p.FEATURES.INFO_PUBLISHER_LINK),r.props.dispatch(c.onButtonClick())},r.onDimmerClick=function(){r.props.dispatch(u.toggleInfoDropdown()),r.props.dispatch(c.onButtonClick())},r.formatTimeString=function(e,t){var n="";if(!isNaN(t)){var r=e-t,o=Math.floor(r/1e3),i=Math.floor(o/60),a=Math.floor(i/60),s=Math.floor(a/24),u=Math.floor(s/31),l=Math.floor(u/12);n=l>1?l+" years ago":1===l?l+" year ago":u>1?u+" months ago":1===u?u+" month ago":s>1?s+" days ago":1===s?s+" day ago":a>1?a+" hours ago":1===a?a+" hour ago":i>1?i+" minutes ago":1===i?i+" minute ago":o+" seconds ago"}return n},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){this.props.visible&&this.props.featureTracker.opportunity(p.FEATURES.INFO_PUBLISHER_LINK)},t.prototype.render=function(){var e=Date.now(),t=Date.parse(this.props.publishDate),n=this.formatTimeString(e,t);return o.default.createElement("div",{className:"info-dropdown"},o.default.createElement("div",{className:"info-dropdown__dimmer",onClick:this.onDimmerClick}),o.default.createElement("div",{className:"info-dropdown__inner"},o.default.createElement("div",{className:"info-dropdown__cover-image-wrapper"},o.default.createElement("img",{className:"info-dropdown__cover-image",crossOrigin:!0,src:this.props.coverImageUrl})),o.default.createElement("div",{className:"info-dropdown__content"},o.default.createElement("span",{className:"info-dropdown__title"},this.props.documentTitle),o.default.createElement("time",{className:"info-dropdown__time",itemProp:"datePublished",dateTime:this.props.publishDate,title:this.props.publishDate},n),o.default.createElement("a",{href:this.props.publisherUrl,onClick:this.onPublisherLinkClick,className:"info-dropdown__publisher-link",target:"_blank"},o.default.createElement("img",{className:"info-dropdown__profile-image",src:this.props.profileImageUrl}),o.default.createElement("span",{className:"info-dropdown__publisher-name"},this.props.publisherName)))))},t}(r.Component);d.displayName="InfoDropdown",d.propTypes={coverImageUrl:a.default.string.isRequired,dispatch:a.default.func.isRequired,documentTitle:a.default.string.isRequired,featureTracker:a.default.object.isRequired,profileImageUrl:a.default.string.isRequired,publishDate:a.default.string.isRequired,publisherName:a.default.string.isRequired,publisherUrl:a.default.string.isRequired,visible:a.default.bool.isRequired}},function(e,t,n){"use strict";function r(e){return new Promise(function(t,n){var r=new XMLHttpRequest;r.open("GET",e,!0),r.onreadystatechange=function(){if(r.readyState===h)if(r.status<400)try{t(JSON.parse(r.responseText))}catch(e){n("jsonParseError")}else n(r.status<500?"requestError":"serverError")},r.send()})}t.__esModule=!0,t.ConnectedInPubAds=t.InPubAds=void 0;var o=n(2),i=babelHelpers.interopRequireDefault(o),a=n(10),s=babelHelpers.interopRequireDefault(a),u=n(55),l=n(20),c=babelHelpers.interopRequireDefault(l),p=n(302),d=babelHelpers.interopRequireWildcard(p),f=n(348),h=4,m=!1,g=t.InPubAds=function(e){function t(){babelHelpers.classCallCheck(this,t);var n=babelHelpers.possibleConstructorReturn(this,e.call(this));return n.state={isAdEnabled:!1,networkCode:void 0,adUnitCode:void 0,isMinimized:!1,canShowAd:!1},n.minimizeAd=n.minimizeAd.bind(n),n.maximizeAd=n.maximizeAd.bind(n),n.onInteraction=n.onInteraction.bind(n),n.onPostMessage=n.onPostMessage.bind(n),n.pagesFlippedCount=0,n.autoMinTimer=void 0,n}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this,t=this.props.documentId,n=t.split("-")[1],o=this.props.config,i="//"+o.hosts.api+"/call/inpubads/publication?publicationId="+n;window.addEventListener("message",this.onPostMessage),r(i).then(function(t){e.setState({networkCode:t.response.networkCode,adUnitCode:t.response.adUnitCode})}).catch(function(t){if("requestError"===t)return void e.props.tracker.monitorBatched({type:"inpubads.reader3.fetch.request-error"});e.props.tracker.monitorBatched({type:"inpubads.reader3.fetch.server-error"})})},t.prototype.componentWillReceiveProps=function(e){this.props.currentSpreadIndex>-1&&e.currentSpreadIndex!==this.props.currentSpreadIndex&&2==++this.pagesFlippedCount&&this.setState({canShowAd:!0})},t.prototype.componentDidUpdate=function(e,t){this.state.networkCode&&this.state.adUnitCode&&this.state.canShowAd&&m===!1&&this.loadAd(this.state.networkCode,this.state.adUnitCode)},t.prototype.componentWillUnmount=function(){window.removeEventListener("message",this.onPostMessage)},t.prototype.onPostMessage=function(e){var t=e.origin===window.document.location.origin,n=0===e.origin.search("http://tpc.googlesyndication.com"),r=0===e.origin.search("https://tpc.googlesyndication.com"),o=0===e.origin.search("http://site.3rdparty.co.aq");if((t||r||o||n)&&e.data&&"eagles.dfp.inpubad.load"===e.data.message){this.props.tracker.monitorBatched({type:"inpubads.reader3.post-message"});var i=decodeURI(e.data.clickUrl);this.setState(Object.assign({},{isAdEnabled:!0,ad:{adId:e.data.ad.adId,docname:e.data.ad.docname,documentId:e.data.ad.documentId,headline:e.data.ad.headline,ownerUsername:e.data.ad.ownerUsername,adUrl:e.data.ad.url,clickTrackingUrl:i,url:""+i+e.data.ad.url}})),this.startAutoMinTimer()}},t.prototype.onInteraction=function(e){window.clearTimeout(this.autoMinTimer)},t.prototype.startAutoMinTimer=function(){var e=this;this.autoMinTimer=window.setTimeout(function(){e.setState({isMinimized:!0})},3e4)},t.prototype.loadAd=function(e,t){var n=[[1,1]],r="/"+e+"/"+t,o=[["isInPubAd","true"],["isDevelopmentTest","true"]];this.props.tracker.monitorBatched({type:"inpubads.reader3.load-ad"}),m=!0,this.clearAd(),this.adElement=document.createElement("div"),this.adContainer.appendChild(this.adElement),this.ad=d.create({rootElm:this.adElement,dfpTargeting:o,adProviderConfig:{network:r,sizes:n},isProductionEnv:!1,trackingKey:"ads-widget."+r.replace("/"+this.state.networkCode+"/","")}),this.ad.show()},t.prototype.clearAd=function(){this.adElement&&(this.props.tracker.monitorBatched({type:"inpubads.reader3.clear-ad"}),this.adElement.parentNode&&this.adElement.parentNode.removeChild(this.adElement),delete this.adElement)},t.prototype.minimizeAd=function(e){e.preventDefault(),this.props.tracker.monitorBatched({type:"inpubads.reader3.ui.minimize-ad"}),this.setState({isMinimized:!0})},t.prototype.maximizeAd=function(e){e.preventDefault(),this.props.tracker.monitorBatched({type:"inpubads.reader3.ui.maximize-ad"}),this.setState({isMinimized:!1})},t.prototype.render=function(){var e=this,t=this.state.canShowAd&&this.state.isAdEnabled,n={adContainer:"inpubads__ad-container ixu-cascading-theme-inverse",main:(0,c.default)("inpubads",{"inpubads--visible":t})};return i.default.createElement("div",{className:n.main},i.default.createElement("div",{ref:function(t){e.adContainer=t},className:n.adContainer}),t?i.default.createElement(f.InPubAdsMinimal,{ad:this.state.ad,minimizeAd:this.minimizeAd,maximizeAd:this.maximizeAd,onInteraction:this.onInteraction,isMinimized:this.state.isMinimized,config:this.props.config,isControlsVisible:this.props.isControlsVisible}):null)},t}(i.default.Component);g.displayName="InPubAds",g.propTypes={config:s.default.object.isRequired,currentSpreadIndex:s.default.number.isRequired,documentId:s.default.string.isRequired,isControlsVisible:s.default.bool.isRequired,tracker:s.default.object.isRequired};t.ConnectedInPubAds=(0,u.connect)(function(e){return{currentSpreadIndex:e.reader.currentSpreadIndex,config:Object.assign({},e.config),documentId:e.documentModel.revisionId+"-"+e.documentModel.publicationId}},function(e){return{onClick:function(){e()}}})(g)},function(e,t,n){"use strict";function r(e){var t=e.ad,n=e.config,r={main:(0,i.default)("inpubads-minimal ixu-background ixu-background--secondary ixu-cascading-theme ixu-cascading-theme-inverse",{"inpubads-minimal--invisible":!(e.isControlsVisible||!e.isMinimized),"inpubads-minimal--only-chrome":!e.isControlsVisible}),minimized:(0,i.default)("inpubads-minimal inpubads-minimal--minimized ixu-cascading-theme ixu-cascading-theme-inverse",{"inpubads-minimal--invisible":!(e.isControlsVisible||!e.isMinimized)}),headline:"ixu-heading ixu-heading--tiny ixu-heading--semibold ixu-heading--pronounced inpubads-minimal__headline",metadata:"inpubads-minimal__metadata",coverContainer:"inpubads-minimal__cover-container",cover:"inpubads-minimal__cover",callToAction:"ixu-button ixu-button--pronounced ixu-button--outline inpubads-minimal__cta",creative:"inpubads-minimal__creative",adNotice:"inpubads-minimal__ad-notice",maximizer:"inpubads-minimal__maximizer",minimizer:"inpubads-minimal__minimizer",tooltip:"inpubads-minimal__tooltip ixu-paragraph ixu-paragraph--pronounced ixu-background ixu-background--secondary ixu-cascading-theme ixu-cascading-theme-inverse"},o=s.default.createElement("div",{className:r.main,onMouseOver:e.onInteraction,onClick:e.onInteraction,onFocus:e.onInteraction},s.default.createElement("div",{className:r.creative},s.default.createElement("a",{href:"javascript:void(0);",className:r.minimizer,onClick:e.minimizeAd},s.default.createElement("svg",{viewBox:"0 0 9 9"},s.default.createElement("polygon",{fillRule:"evenodd",points:"910.424 592.242 914.555 592.242 914.555 593.625 910.424 593.625 910.424 597.897 909.03 597.897 909.03 593.625 904.919 593.625 904.919 592.242 909.03 592.242 909.03 587.95 910.424 587.95",transform:"rotate(-45 -252.542 1391.355)"}))),s.default.createElement("div",{className:r.metadata},s.default.createElement("div",{className:r.adNotice},"Advertisement"),s.default.createElement("h1",{className:r.headline},t.headline),s.default.createElement("a",{href:t.url,target:"_blank",className:r.callToAction},"Read in new tab")),s.default.createElement("a",{href:t.url,target:"_blank",className:r.coverContainer},s.default.createElement("img",{className:r.cover,src:"//"+n.hosts.image+"/"+t.documentId+"/jpg/page_1_thumb_large.jpg",alt:"Cover"})))),a=s.default.createElement("div",{className:r.minimized},s.default.createElement("a",{href:"javascript:void(0);",className:r.maximizer,onClick:e.maximizeAd},s.default.createElement("svg",{viewBox:"0 0 27 27"},s.default.createElement("g",null,s.default.createElement("circle",{cx:"12.5",cy:"12.5",r:"12.5",stroke:"#FFF",strokeWidth:".25"}),s.default.createElement("path",{fill:"#FFF",d:"M10.7954102,16 L10.2260742,14.1308594 L7.36328125,14.1308594 L6.79394531,16 L5,16 L7.77148438,8.11523438 L9.80712891,8.11523438 L12.5893555,16 L10.7954102,16 Z M9.82861328,12.734375 C9.30224346,11.0406816 9.00594109,10.0828462 8.93969727,9.86083984 C8.87345344,9.63883353 8.82600926,9.46337955 8.79736328,9.33447266 C8.67919863,9.79280828 8.34082311,10.9260977 7.78222656,12.734375 L9.82861328,12.734375 Z M20.0927734,11.9985352 C20.0927734,13.2911848 19.7248572,14.2812466 18.9890137,14.96875 C18.2531701,15.6562534 17.1905994,16 15.8012695,16 L13.5776367,16 L13.5776367,8.14746094 L16.0429688,8.14746094 C17.3248762,8.14746094 18.320309,8.48583646 19.0292969,9.16259766 C19.7382848,9.83935885 20.0927734,10.7846619 20.0927734,11.9985352 Z M18.3632812,12.0415039 C18.3632812,10.354972 17.618497,9.51171875 16.1289062,9.51171875 L15.2426758,9.51171875 L15.2426758,14.625 L15.9570313,14.625 C17.5612059,14.625 18.3632812,13.7638432 18.3632812,12.0415039 Z"})))),s.default.createElement("p",{className:r.tooltip},"Recommended for you"));return e.isMinimized?a:o}t.__esModule=!0,t.InPubAdsMinimal=r;var o=n(20),i=babelHelpers.interopRequireDefault(o),a=n(2),s=babelHelpers.interopRequireDefault(a),u=n(10),l=babelHelpers.interopRequireDefault(u);r.propTypes={ad:l.default.object.isRequired,config:l.default.object.isRequired,isControlsVisible:l.default.bool.isRequired,isMinimized:l.default.bool.isRequired,maximizeAd:l.default.func.isRequired,minimizeAd:l.default.func.isRequired,onInteraction:l.default.func.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.Loading=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(131),u=n(350),l=t.Loading=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.render=function(){return o.default.createElement("div",{className:"loading"},o.default.createElement("div",{className:"loading__spinner"},o.default.createElement(s.Spinner,{type:s.Spinner.SPINNER_TYPE_ALTERNATE})),this.props.showBranding&&o.default.createElement("div",{className:"loading__watermark"},o.default.createElement(u.Logo,{type:u.Logo.LOGO_TYPE_ALTERNATE})))},t}(r.Component);l.displayName="Loading",l.propTypes={showBranding:a.default.bool.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.Logo=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(20),u=babelHelpers.interopRequireDefault(s),l=n(204),c=t.Logo=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.render=function(){var e=(0,u.default)("logo",{"logo--alternate":this.props.type===t.LOGO_TYPE_ALTERNATE});return o.default.createElement("div",{className:e},o.default.createElement("p",{className:"logo__text"},"Powered by"),o.default.createElement("div",{className:"logo__wrapper",dangerouslySetInnerHTML:{__html:l.IssuuLogo}}))},t}(r.Component);c.displayName="Logo",c.propTypes={type:a.default.string},c.defaultProps={type:c.LOGO_TYPE_DEFAULT},c.LOGO_TYPE_DEFAULT="LOGO_TYPE_DEFAULT",c.LOGO_TYPE_ALTERNATE="LOGO_TYPE_ALTERNATE"},function(e,t,n){"use strict";t.__esModule=!0,t.ConnectedMain=t.Main=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(85),a=babelHelpers.interopRequireDefault(i),s=n(55),u=n(19),l=babelHelpers.interopRequireWildcard(u),c=n(93),p=babelHelpers.interopRequireWildcard(c),d=n(195),f=babelHelpers.interopRequireWildcard(d),h=n(210),m=babelHelpers.interopRequireWildcard(h),g=n(41),v=n(219),b=babelHelpers.interopRequireWildcard(v),y=n(11),_=babelHelpers.interopRequireWildcard(y),E=n(337),w=n(349),S=n(355),x=t.Main=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.getFullscreenFallbackPageUrl=function(){return r.props.embedId?r.props.documentUrl+"?ff=true&e="+r.props.embedId:r.props.documentUrl+"?ff=true"},r.loadDocument=function(){r.props.dispatch(l.fetchDocument({config:r.props.config,username:r.props.loading.username,documentName:r.props.loading.documentName,documentId:r.props.loading.documentId,initialPageNumber:r.props.initialPageNumber,getWidthAndHeight:function(){return[r.container.clientWidth,r.container.clientHeight]},readMorePlugin:r.props.readMorePlugin}))},r.listenToVisibilityChangeEvent=function(){b.isVisibilityAPISupported()&&b.listenToVisibilityChangeEvent(function(){r.props.dispatch(f.onVisibilityChange())})},r.toggleFullscreen=function(){r.props.fullscreenFeature&&r.props.fullscreenFeature.kind!==g.FULLSCREEN_KIND.FALLBACK&&r.props.dispatch(r.props.fullscreenEnabled?p.exitFullscreen():p.enterFullscreen(r.container,r.getFullscreenFallbackPageUrl()))},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.container=a.default.findDOMNode(this.refs.main),this.loadDocument(),this.listenToVisibilityChangeEvent()},t.prototype.shouldComponentUpdate=function(e,t){return this.props.loading.status!==e.loading.status||this.props.backgroundColor!==e.backgroundColor||this.props.backgroundImage!==e.backgroundImage},t.prototype.render=function(){var e=["reader-container"];document.documentMode&&10===document.documentMode&&e.push("ie10");var t=null;switch(this.props.loading.status){case m.FAILED:t=o.default.createElement(E.Failed,{sessionId:this.props.sessionId,loadDocument:this.loadDocument,error:this.props.loading.error});break;case m.SUCCESS:t=o.default.createElement(S.ConnectedReader,{config:this.props.config,initialPageNumber:this.props.initialPageNumber,toggleFullscreen:this.toggleFullscreen,tracker:this.props.tracker,loadStatsTracker:this.props.loadStatsTracker});break;case m.INITIALIZED:case m.LOADING:default:t=o.default.createElement(w.Loading,{showBranding:this.props.showBranding})}this.props.backgroundImage&&(this.props.backgroundImage.style===g.BACKGROUND_IMAGE_STYLE.TOP_LEFT?e.push("reader-container--background-image-top-left"):this.props.backgroundImage.style===g.BACKGROUND_IMAGE_STYLE.STRETCH&&e.push("reader-container--background-image-stretch"));var n={width:"100%",height:"100%",backgroundColor:this.props.backgroundColor,backgroundImage:this.props.backgroundImage?"url('"+this.props.backgroundImage.url+"')":"none"};return o.default.createElement("div",{ref:"main",id:"ird3-main",className:e.join(" "),style:n},t)},t}(r.Component);x.displayName="Main";var T=function(e){return{backgroundColor:_.selectBackgroundColor(e),backgroundImage:_.selectBackgroundImage(e),config:e.config,documentUrl:e.reader.isReady?_.selectDocumentUrlWithPageNumber(e):"",fullscreenEnabled:_.selectFullscreenEnabled(e),fullscreenFeature:_.selectFullscreenFeature(e),loading:e.loading,readMorePlugin:e.readMorePlugin,showBranding:_.selectShowIssuuBranding(e)}};t.ConnectedMain=(0,s.connect)(T,void 0,void 0,{pure:!1})(x)},function(e,t,n){"use strict";t.__esModule=!0,t.MoreContentContainer=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(20),u=babelHelpers.interopRequireDefault(s),l=n(8),c=babelHelpers.interopRequireWildcard(l),p=n(29),d=babelHelpers.interopRequireWildcard(p),f=n(201),h=n(95),m=t.MoreContentContainer=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onCloseButtonClick=function(){r.props.dispatch(c.closeMoreDropdown()),r.props.dispatch(d.onButtonClick())},r.onBackgroundClick=function(){r.props.dispatch(c.closeMoreDropdown())},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.render=function(){return o.default.createElement("div",{className:(0,u.default)("more-content-container",{"more-content-container--hidden":!this.props.visible,"more-content-container--overlay":this.props.showAsOverlay})},this.props.children,o.default.createElement("button",{type:"button",className:(0,u.default)("more-content-container__close-button",{"more-content-container__close-button--left":h.device.isMobile()}),onClick:this.onCloseButtonClick,dangerouslySetInnerHTML:{__html:f.CloseIcon}}),!this.props.showAsOverlay&&o.default.createElement("div",{className:"more-content-container__clickable-background",onClick:this.onBackgroundClick}))},t}(r.Component);m.displayName="MoreContentContainer",m.propTypes={children:a.default.node,dispatch:a.default.func.isRequired,readerSizeInPixels:a.default.string.isRequired,showAsOverlay:a.default.bool,visible:a.default.bool.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.NavigationArrows=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(76),u=n(343),l=t.NavigationArrows=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.render=function(){return o.default.createElement("div",null,o.default.createElement(s.Button,{ref:"buttonPrevious",className:"navigation-arrow navigation-arrow--left",onClick:this.props.onClickLeftArrow,isHidden:!this.props.leftArrowVisible,id:"ird3-button-previous",content:u.NavigationArrowIcon}),o.default.createElement(s.Button,{ref:"buttonNext",className:"navigation-arrow navigation-arrow--right",onClick:this.props.onClickRightArrow,isHidden:!this.props.rightArrowVisible,id:"ird3-button-next",content:u.NavigationArrowIcon}))},t}(r.Component);l.displayName="NavigationArrows",l.propTypes={leftArrowVisible:a.default.bool.isRequired,onClickLeftArrow:a.default.func.isRequired,onClickRightArrow:a.default.func.isRequired,rightArrowVisible:a.default.bool.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.PageControls=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(207),u=n(46),l=babelHelpers.interopRequireDefault(u),c=t.PageControls=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){window.ISSUU_READER_PAGE_SLIDER=this.refs.pageSlider},t.prototype.shouldComponentUpdate=function(e,t){return!((0,l.default)(this.props,e)&&(0,l.default)(this.state,t))},t.prototype.render=function(){return o.default.createElement("div",{className:"page-controls"},o.default.createElement("span",{className:"page-controls__page-numbers"},this.props.currentPageNumbers," / ",this.props.pageCount),o.default.createElement("div",{className:"page-controls__slider"},o.default.createElement(s.Slider,{ref:"pageSlider",value:this.props.currentPageSliderPosition,onChange:this.props.pageSliderOnChange,onChangeStart:this.props.pageSliderOnChangeStart,onChangeEnd:this.props.pageSliderOnChangeEnd,locked:1===this.props.pageCount,segments:this.props.segments,markers:this.props.resultMarkers})))},t}(r.Component);c.displayName="PageControls",c.propTypes={currentPageNumbers:a.default.string.isRequired,currentPageSliderPosition:a.default.number.isRequired,pageCount:a.default.number.isRequired,pageSliderOnChange:a.default.func.isRequired,pageSliderOnChangeEnd:a.default.func.isRequired,pageSliderOnChangeStart:a.default.func.isRequired,resultMarkers:a.default.arrayOf(a.default.number),segments:a.default.arrayOf(a.default.shape({proportion:a.default.number.isRequired,done:a.default.bool.isRequired,available:a.default.bool.isRequired}))}},function(e,t,n){"use strict";t.__esModule=!0,t.ConnectedReader=t.mapState=t.Reader=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(55),a=n(20),s=babelHelpers.interopRequireDefault(a),u=n(334),l=n(339),c=n(333),p=n(353),d=n(335),f=n(352),h=n(347),m=n(48),g=n(58),v=n(137),b=babelHelpers.interopRequireWildcard(v),y=n(8),_=babelHelpers.interopRequireWildcard(y),E=n(193),w=babelHelpers.interopRequireWildcard(E),S=n(29),x=babelHelpers.interopRequireWildcard(S),T=n(57),C=babelHelpers.interopRequireWildcard(T),I=n(209),R=babelHelpers.interopRequireWildcard(I),M=n(11),P=babelHelpers.interopRequireWildcard(M),O=n(214),A=babelHelpers.interopRequireWildcard(O),D=n(109),k=babelHelpers.interopRequireWildcard(D),N=n(95),L=n(21),F=n(398),U=n(78),H=t.Reader=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onKeyUp=function(e){switch(e.keyCode){case R.SPACE:case R.LEFT:case R.DOWN:case R.RIGHT:case R.UP:clearInterval(r.mover),r.mover=0}},r.onKeyDown=function(e){if(e.keyCode===R.ESCAPE&&(r.props.moreContentContainerIsVisible?r.props.dispatch(_.closeMoreDropdown()):r.props.isFindOverlayVisible?r.props.dispatch(g.actions.closeFindDialog()):r.props.fullscreenEnabled&&r.props.toggleFullscreen()),!(r.mover||document.activeElement&&"INPUT"===document.activeElement.tagName)){switch(e.keyCode){case R.F:r.props.enableFind&&e.metaKey?(e.preventDefault(),r.props.featureTracker.usage(L.FEATURES.KEYBOARD_OPEN_FIND),r.props.dispatch(g.actions.openFindDialog())):r.props.toggleFullscreen();break;case R.FORWARD_SLASH:r.props.enableFind&&(e.preventDefault(),r.props.featureTracker.usage(L.FEATURES.KEYBOARD_OPEN_FIND),r.props.dispatch(g.actions.openFindDialog()));break;case R.LEFT:case R.DOWN:if(e.metaKey)break;r.previousSpread(),r.mover=setInterval(function(){r.previousSpread(),r.props.dispatch(x.onKeyPress(e.keyCode))},C.KEY_DOWN_INTERVAL);break;case R.SPACE:case R.RIGHT:case R.UP:if(e.metaKey)break;r.nextSpread(),r.mover=setInterval(function(){r.nextSpread(),r.props.dispatch(x.onKeyPress(e.keyCode))},C.KEY_DOWN_INTERVAL);break;case R.HOME:r.props.dispatch(_.scrollToSpreadIndex(0));break;case R.END:r.props.dispatch(_.scrollToSpreadIndex(r.props.lastSpreadIndex));break;case R.D:e.shiftKey&&r.toggleDebugMode();break;case R.I:e.shiftKey&&r.toggleInPubAds()}r.props.dispatch(x.onKeyPress(e.keyCode))}},r.onWebGLContextLost=function(){r.props.tracker.monitorBatched({type:"reader3-webgl-context-lost"})},r.onWebGLContextRestored=function(){r.props.tracker.monitorBatched({type:"reader3-webgl-context-restored"})},r.onNextSpreadButtonClick=function(e){e.preventDefault(),r.props.featureTracker.usage(L.FEATURES.BUTTON_ARROW_FORWARD),r.props.dispatch(x.onButtonClick()),r.nextSpread()},r.onPreviousSpreadButtonClick=function(e){e.preventDefault(),r.props.featureTracker.usage(L.FEATURES.BUTTON_ARROW_BACKWARD),r.props.dispatch(x.onButtonClick()),r.previousSpread()},r.trackOpportunities=function(){r.props.featureTracker.opportunity(L.FEATURES.FULLSCREEN_MORE),r.props.isLeftArrowVisible&&r.props.featureTracker.opportunity(L.FEATURES.BUTTON_ARROW_BACKWARD),r.props.isRightArrowVisible&&r.props.featureTracker.opportunity(L.FEATURES.BUTTON_ARROW_FORWARD),r.props.enableFind&&r.props.featureTracker.opportunity(L.FEATURES.KEYBOARD_OPEN_FIND)},r.nextSpread=function(){r.props.dispatch(_.goToNextPage())},r.previousSpread=function(){r.props.dispatch(_.goToPreviousPage())},r.toggleDebugMode=function(){r.props.dispatch(_.setDebugMode(!r.props.debugMode))},r.toggleInPubAds=function(){r.props.dispatch(w.setInPubAds(!r.props.enableInPubAds))},r.mover=0,o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this,t=this.refs.canvas.getWrappedInstance();window.ISSUU_READER_DOCUMENTCANVAS=t,window.addEventListener("keydown",this.onKeyDown),window.addEventListener("keyup",this.onKeyUp),this.interactionDetector=new F.InteractionDetector(this.refs.mainReader,function(){e.props.interactedWithReader||window.setTimeout(function(){e.props.dispatch(_.setInteractedWithReader())},500)}),this.inputHandler=new U.InputHandler(this.refs.mainReader,{onMouseMove:function(t,n,r){e.props.dispatch(x.onMouseMove())},onMouseEnter:function(t){e.props.dispatch(x.onMouseEnter())},onMouseLeave:function(t){e.props.dispatch(x.onMouseLeave())}}),this.trackOpportunities(),100*Math.random()<1&&this.props.enableInPubAds===!1&&this.toggleInPubAds()},t.prototype.componentDidUpdate=function(e){this.props.renderReadmore&&this.props.exitedFullscreen&&this.props.moreContentContainerIsVisible&&this.props.moreContentContainerIsVisible!==e.moreContentContainerIsVisible&&this.props.featureTracker.usage(L.FEATURES.FULLSCREEN_MORE),this.trackOpportunities()},t.prototype.componentWillUnmount=function(){clearInterval(this.mover),window.removeEventListener("keydown",this.onKeyDown),window.removeEventListener("keyup",this.onKeyUp),this.interactionDetector&&this.interactionDetector.destroy()},t.prototype.render=function(){var e=void 0;return e=this.props.showCTAOverlay?o.default.createElement(d.CTAOverlay,{dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,fullscreenEnabled:this.props.fullscreenEnabled,toggleFullscreen:this.props.toggleFullscreen,visible:this.props.isControlsVisible}):o.default.createElement(u.ConnectedControls,{toggleFullscreen:this.props.toggleFullscreen,isTinyEmbed:!1,visible:this.props.isControlsVisible}),o.default.createElement("div",{ref:"mainReader",tabIndex:"1",className:"reader",style:{backgroundImage:this.props.logo?"url('"+this.props.logo.url+"')":"none"}},o.default.createElement("div",{className:"reader__layout"},o.default.createElement(l.ConnectedHeaderControls,null),this.props.enableFind&&o.default.createElement(g.components.FindOverlay,{featureTracker:this.props.featureTracker,enableIncrementalSearch:!N.device.isIOS()}),o.default.createElement("div",{className:"reader__canvas-container"},o.default.createElement(c.ConnectedCanvas,{ref:"canvas",loadStatsTracker:this.props.loadStatsTracker,onWebGLContextLost:this.onWebGLContextLost,onWebGLContextRestored:this.onWebGLContextRestored,tracker:this.props.tracker,withStencilBuffer:this.props.enableFind}),o.default.createElement(p.NavigationArrows,{leftArrowVisible:this.props.isLeftArrowVisible,rightArrowVisible:this.props.isRightArrowVisible,onClickLeftArrow:this.onPreviousSpreadButtonClick,onClickRightArrow:this.onNextSpreadButtonClick}),this.props.enableInPubAds&&o.default.createElement(h.ConnectedInPubAds,{tracker:this.props.tracker,isControlsVisible:this.props.isControlsVisible})),e,this.props.renderReadmore&&o.default.createElement(f.MoreContentContainer,{dispatch:this.props.dispatch,visible:this.props.moreContentContainerIsVisible,showAsOverlay:this.props.showReadmoreAsOverlay,readerSizeInPixels:this.props.readerSizeInPixels},this.props.readMorePlugin.render(this.props.config,this.props.debugMode,this.props.exitedFullscreen,this.props.moreContentContainerIsVisible,this.props.showReadmoreAsOverlay,this.props.isLoggedIn)),this.props.isPaywallPreview&&o.default.createElement("div",{className:(0,s.default)("paywall-btn--header",{"is-hidden":this.props.isPaywallOverlayVisible})},o.default.createElement(m.components.PaywallButton,null)),this.props.isPaywallPreview&&o.default.createElement("div",{className:(0,s.default)("paywall-overlay",{"is-hidden":!this.props.isPaywallOverlayVisible})},o.default.createElement(m.components.PaywallOverlay,null)),this.props.renderVideoOverlay&&o.default.createElement(b.VideoOverlay,{dispatch:this.props.dispatch,service:this.props.videoService,videoId:this.props.videoId})))},t}(r.Component);H.displayName="Reader";var B=t.mapState=function(e){return{debugMode:e.reader.debugMode,documentId:e.documentModel.documentId,exitedFullscreen:e.readmore.exitedFullscreen,featureTracker:e.featureTracker,interactedWithReader:e.reader.interactedWithReader,readMorePlugin:e.readMorePlugin,enableInPubAds:e.features.enableInPubAds,enableFind:e.features.enableFind,isLoggedIn:e.isLoggedIn,isPaywallPreview:m.selectors.isPreview(e),isPaywallOverlayVisible:m.selectors.isVisible(e),isFindOverlayVisible:g.selectors.isVisible(e),showReadmoreAsOverlay:k.selectShowAsOverlay(e),fullscreenEnabled:P.selectFullscreenEnabled(e),isControlsVisible:P.isControlsVisible(e),logo:P.selectLogo(e),isLeftArrowVisible:A.isLeftArrowVisible(e),isRightArrowVisible:A.isRightArrowVisible(e),lastSpreadIndex:P.selectLastSpreadIndex(e),moreContentContainerIsVisible:P.moreOverlayVisible(e),readerSizeInPixels:P.selectReaderSizeInPixels(e),renderReadmore:k.selectReadyToRender(e),showCTAOverlay:P.selectShowCTAOverlay(e),renderVideoOverlay:b.selectShowOverlay(e),videoService:b.selectService(e),videoId:b.selectVideoId(e)}};t.ConnectedReader=(0,i.connect)(B,void 0,void 0,{pure:!0})(H)},function(e,t,n){"use strict";t.__esModule=!0,t.ZoomControls=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(46),a=babelHelpers.interopRequireDefault(i),s=n(76),u=n(10),l=babelHelpers.interopRequireDefault(u),c=n(207),p=n(57),d=n(29),f=babelHelpers.interopRequireWildcard(d),h=n(345),m=n(344),g=n(21),v=t.ZoomControls=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.trackOpportunities=function(){r.isZoomControlsVisible()&&(r.props.featureTracker.opportunity(g.FEATURES.BUTTON_ZOOMIN),r.props.featureTracker.opportunity(g.FEATURES.BUTTON_ZOOMOUT),r.props.featureTracker.opportunity(g.FEATURES.SLIDER_ZOOM))},r.isZoomControlsVisible=function(){var e=window.getComputedStyle(r.refs.zoomControls.parentNode);return e&&"none"!==e.display},r.handleZoomInButtonClick=function(){r.props.currentZoomLevel>=p.MAX_ZOOM_LEVEL||(r.props.zoomSliderOnChange(r.props.currentZoomLevel+1),r.props.featureTracker.usage(g.FEATURES.BUTTON_ZOOMIN),r.props.dispatch(f.onButtonClick()))},r.handleZoomOutButtonClick=function(){r.props.zoomSliderOnChange(r.props.currentZoomLevel-1),r.props.featureTracker.usage(g.FEATURES.BUTTON_ZOOMOUT),r.props.dispatch(f.onButtonClick())},r.handleZoomSliderChangeStart=function(){r.props.zoomSliderOnChangeStart(),r._zoomBeforeSliderStart=r.props.currentZoomLevel},r.handleZoomSliderChange=function(e){r.props.zoomSliderOnChange(e/100*(p.MAX_ZOOM_LEVEL-p.MIN_ZOOM_LEVEL)+p.MIN_ZOOM_LEVEL)},r.handleZoomSliderChangeEnd=function(){r.props.zoomSliderOnChangeEnd(),r.props.currentZoomLevel!==r._zoomBeforeSliderStart&&r.props.featureTracker.usage(g.FEATURES.SLIDER_ZOOM)},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.trackOpportunities()},t.prototype.shouldComponentUpdate=function(e,t){return!((0,a.default)(this.props,e)&&(0,a.default)(this.state,t))},t.prototype.componentDidUpdate=function(){this.trackOpportunities()},t.prototype.render=function(){var e=100/(p.MAX_ZOOM_LEVEL-p.MIN_ZOOM_LEVEL)*(this.props.currentZoomLevel-p.MIN_ZOOM_LEVEL);return o.default.createElement("div",{className:"zoom-controls",ref:"zoomControls"},o.default.createElement("div",{className:"zoom-controls__button","data-tooltip":"Zoom out"},o.default.createElement(s.Button,{id:"ird3-button-zoomout",className:"svg-btn",onClick:this.handleZoomOutButtonClick,content:h.ZoomOutIcon})),o.default.createElement("div",{className:"zoom-controls__slider"},o.default.createElement(c.Slider,{value:e,onChange:this.handleZoomSliderChange,onChangeStart:this.handleZoomSliderChangeStart,onChangeEnd:this.handleZoomSliderChangeEnd,segments:this.props.segments,type:c.Slider.SLIDER_TYPE_ALTERNATE})),o.default.createElement("div",{className:"zoom-controls__button","data-tooltip":"Zoom in"},o.default.createElement(s.Button,{id:"ird3-button-zoomin",className:"svg-btn",onClick:this.handleZoomInButtonClick,content:m.ZoomInIcon})))},t}(r.Component);v.displayName="ZoomControls",v.propTypes={currentZoomLevel:l.default.number.isRequired,dispatch:l.default.func.isRequired,featureTracker:l.default.object.isRequired,segments:l.default.arrayOf(l.default.shape({proportion:l.default.number.isRequired,done:l.default.bool.isRequired,available:l.default.bool.isRequired})).isRequired,zoomSliderOnChange:l.default.func.isRequired,zoomSliderOnChangeEnd:l.default.func.isRequired,zoomSliderOnChangeStart:l.default.func.isRequired}},function(e,t,n){"use strict";t.__esModule=!0;t.SUCCESS=0,t.CONVERSION_ERROR=2,t.DELETED=4,t.PENDING=5,t.QUARANTINED=6,t.USER_MISSING=7,t.NAME_MISSING=8,t.PAGE_COUNT_MISSING=9,t.PAGES_MISSING=10,t.UNKNOWN_MATERIALIZER_ERROR=11,t.MAX_RETRY_MATERIALIZER_ERROR=12},function(e,t,n){"use strict";function r(e){var t={type:"READER3_POLYFILLS","whatwg-fetch":0};(0,B.isNative)(window.fetch)||(t["whatwg-fetch"]=1),e.monitorBatched(t)}function o(e,t){for(var n=Object.keys(t),r=Array.isArray(n),i=0,n=r?n:n[Symbol.iterator]();;){var a;if(r){if(i>=n.length)break;a=n[i++]}else{if(i=n.next(),i.done)break;a=i.value}var s=a,u=t[s];"object"!==(void 0===u?"undefined":babelHelpers.typeof(u))||(0,B.isNative)(u)?null!==e[s]&&void 0!==e[s]||(e[s]=u):e[s]=o(e[s]||{},u)}return e}function i(e){o(e,{document:{initialPageNumber:1},features:{allowUIToOverlayCover:!0,backgroundColor:"#353535",fullscreenBackgroundColor:"#353535",enableInPubAds:!1,enableFind:!0},network:{ImageLoader:Image,imagePath:"jpg"},trackerConfig:{streamData:{}},isFeatureTest:!1});var t=e.tracker,n=e.network,i=e.trackerConfig,a=e.gaTracker,s=e.quantcastTracker,u=e.isFeatureTest,f=e.features,m=e.readMorePlugin,D=e.isLoggedIn,N=j.WebGLFeatureTests.isWebGLSupported();t.monitorBatched({type:"READER3_WEBGL",webgl:N?1:0,no_webgl:N?0:1}),r(t);var F=new w.TrackingService(t,i,e.document.embedId),B=new S.LoadStatsTracker(F,i.loadStartTimestamp),W=[g.default,b.autoFlipMiddleWare,(0,x.insightTracking)(F,_.captureException),(0,T.loadingTracking)(B,_.captureException),(0,C.performanceTracking)(F,_.captureException),(0,I.readerTracking)(F,_.captureException,i.startTrackingOnLoad),(0,H.externalApiMiddleWare)(_.captureException),y.ravenTagsMiddleware,(0,E.createMiddleware)(t)];if(s){var z=new M.QuantcastService(s);W.push((0,P.quantcastMiddleWare)(z,_.captureException))}if(a){var V=new O.GAService(a);W.push((0,A.gaMiddleWare)(V,_.captureException))}(q||u)&&W.push(v.logger);var G=new R.FeatureTracker(F,_.captureException,i.sessionId),Y=h.create(n,e.document.username,e.document.name,f,G,m,D,N),$=c.compose,K=(0,c.createStore)(Y,{},$(c.applyMiddleware.apply(void 0,W)));window.ISSUU_READER_STORE=K;var X=l.default.createElement(p.Provider,{store:K},l.default.createElement(d.ConnectedMain,{embedId:e.document.embedId,initialPageNumber:e.document.initialPageNumber?Number(e.document.initialPageNumber):1,loadStatsTracker:B,tracker:t,features:f,sessionId:i.sessionId})),Z={beginTrackingReads:function(){K.dispatch(k.enableTracking())},embedPreview:function(e,t){K.dispatch(k.embedPreview(e,t))},getPageNumbers:function(){return U.selectCurrentPageNumbers(K.getState())},getPageCount:function(){return K.getState().documentModel.pageCount},setPageNumber:function(e){K.dispatch(k.setPageNumber(e))},goToPreviousPage:function(){K.dispatch(L.goToPreviousPage())},goToNextPage:function(){K.dispatch(L.goToNextPage())},setCallback:function(e,t){K.dispatch(k.setCallback(e,t))}};return window.ISSUU_READER_OBJECT=X,window.ISSUU_READER_EXTERNAL_API=Z,{reader:X,api:Z}}t.__esModule=!0,t.readerArgs=void 0,t.createReader=i;var a=n(41),s=babelHelpers.interopRequireWildcard(a),u=n(2),l=babelHelpers.interopRequireDefault(u),c=n(190),p=n(55),d=n(351),f=n(386),h=babelHelpers.interopRequireWildcard(f),m=n(735),g=babelHelpers.interopRequireDefault(m),v=n(368),b=n(365),y=n(370),_=n(92),E=n(48),w=n(393),S=n(390),x=n(394),T=n(395),C=n(396),I=n(397),R=n(21),M=n(391),P=n(369),O=n(389),A=n(367),D=n(63),k=babelHelpers.interopRequireWildcard(D),N=n(8),L=babelHelpers.interopRequireWildcard(N),F=n(11),U=babelHelpers.interopRequireWildcard(F),H=n(366),B=n(399),j=n(401),W=n(332);if(window.chrome){var z=document.createElement("div");z.style.position="absolute",z.style.left="0px",z.style.top="0px",z.innerHTML=W.ChromeFixSvg,document.body&&document.body.appendChild(z)}var q=!1;t.readerArgs=s},function(e,t,n){"use strict";function r(e){if(!e.getClientRects().length)return{top:0,left:0};var t=e.getBoundingClientRect();if(t.width||t.height){var n=e.ownerDocument,r=n.documentElement||{};return{top:t.top+window.pageYOffset-r.clientTop,left:t.left+window.pageXOffset-r.clientLeft}}return t}t.__esModule=!0,t.getElementOffset=r},function(e,t,n){"use strict";t.__esModule=!0,t.MouseHandler=void 0;var r=n(135),o=1;t.MouseHandler=function(e){function t(n,r,i){babelHelpers.classCallCheck(this,t);var a=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,i));return a._elementMouseDownHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.isDeactivated()||(a.options.activeHandler=a,a.saveTargetElementOffset(),a.savePointer(o,e.pageX,e.pageY,e.timeStamp),a.saveInitialPinchDistance(),a.fireGestureStart(),a.registerTapHandlers(),a.targetElement.ownerDocument.addEventListener("mousemove",a._ownerDocumentMouseMoveHandler,!1),a.targetElement.ownerDocument.addEventListener("mouseup",a._ownerDocumentMouseUpHandler,!1))},a._ownerDocumentMouseMoveHandler=function(e){a.savePointer(o,e.pageX,e.pageY,e.timeStamp),a.saveInitialGestureIfUndefined(),a.fireGestureChange(),a.validateTapHandlers(),a.options.shouldInvokePreventDefault()&&e.preventDefault()},a._ownerDocumentMouseUpHandler=function(e){a.savePointer(o,e.pageX,e.pageY,e.timeStamp),a.fireGestureEnd(),a.executeTapHandlers(),a.deletePointer(o),a.options.shouldInvokePreventDefault()&&e.preventDefault(),a.options.resetInterception(),a._removeEventListenersFromOwnerDocument()},a._elementMouseMoveHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.fireMouseMove(e)},a._elementMouseEnterHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.fireMouseEnter(e)},a._elementMouseLeaveHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.fireMouseLeave(e)},a.targetElement.addEventListener("mousedown",a._elementMouseDownHandler,!1),a.targetElement.addEventListener("mousemove",a._elementMouseMoveHandler,!1),a.targetElement.addEventListener("mouseenter",a._elementMouseEnterHandler,!1),a.targetElement.addEventListener("mouseleave",a._elementMouseLeaveHandler,!1),a}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("mousedown",this._elementMouseDownHandler,!1),this.targetElement.removeEventListener("mousemove",this._elementMouseMoveHandler,!1),this.targetElement.removeEventListener("mouseenter",this._elementMouseEnterHandler,!1),this.targetElement.removeEventListener("mouseleave",this._elementMouseLeaveHandler,!1),this._removeEventListenersFromOwnerDocument()},t.prototype.reset=function(){e.prototype.reset.call(this),this._removeEventListenersFromOwnerDocument()},t.prototype._removeEventListenersFromOwnerDocument=function(){this.targetElement.ownerDocument.removeEventListener("mousemove",this._ownerDocumentMouseMoveHandler,!1),this.targetElement.ownerDocument.removeEventListener("mouseup",this._ownerDocumentMouseUpHandler,!1)},t}(r.TapHandler)},function(e,t,n){"use strict";function r(){var e=!!window.PointerEvent;return{DOWN:e?"pointerdown":"MSPointerDown",MOVE:e?"pointermove":"MSPointerMove",UP:e?"pointerup":"MSPointerUp",CANCEL:e?"pointercancel":"MSPointerCancel",ENTER:e?"pointerenter":"MSPointerEnter",LEAVE:e?"pointerleave":"MSPointerLeave"}}t.__esModule=!0,t.PointerHandler=void 0;var o=n(135);t.PointerHandler=function(e){function t(n,o,i){babelHelpers.classCallCheck(this,t);var a=babelHelpers.possibleConstructorReturn(this,e.call(this,n,o,i));return a._elementPointerDownHandler=function(e){if(!a.isDeactivated()){a.options.activeHandler=a,a.options.updateLastPointerEventTimeStamp(e);var t=e.pointerId,n=e.pageX,r=e.pageY;if(a.options.shouldInvokeSetPointerCapture())try{a.targetElement.setPointerCapture?a.targetElement.setPointerCapture(""+t):a.targetElement.msSetPointerCapture&&a.targetElement.msSetPointerCapture(t)}catch(e){}0===a.getPointerCount()&&a.saveTargetElementOffset(),a.savePointer(t,n,r,e.timeStamp),a.saveInitialPinchDistance(),a.saveInitialGestureIfUndefined(),a.fireGestureStart(),a.registerTapHandlers()}},a._elementPointerMoveHandler=function(e){if(!a.isDeactivated()){a.options.updateLastPointerEventTimeStamp(e),a.fireMouseMove(e);var t=e.pointerId,n=e.pageX,r=e.pageY;a.isValidPointer(t)&&(a.isPointerMoved(t,n,r,2)&&(a.savePointer(t,n,r,e.timeStamp),a.saveInitialGestureIfUndefined(),a.fireGestureChange()),a.validateTapHandlers(),a.options.shouldInvokePreventDefault()&&e.preventDefault())}},a._elementPointerUpHandler=function(e){if(!a.isDeactivated()){a.options.updateLastPointerEventTimeStamp(e);var t=e.pointerId,n=e.pageX,r=e.pageY;if(a.isValidPointer(t)){a.savePointer(t,n,r,e.timeStamp);var o=!1;1===a.getPointerCount()?(a.fireGestureEnd(),a.executeTapHandlers(),a.deletePointer(t),o=!0):(a.fireGestureStart(),a.deletePointer(t),a.saveInitialPinchDistance()),a.options.shouldInvokePreventDefault()&&e.preventDefault(),o&&a.options.resetInterception()}}},a._elementPointerCancelHandler=function(e){a.unregisterTapHandlers(),a._elementPointerUpHandler(e)},a._elementPointerEnterHandler=function(e){a.options.updateLastPointerEventTimeStamp(e),a.fireMouseEnter(e)},a._elementPointerLeaveHandler=function(e){a.options.updateLastPointerEventTimeStamp(e),a.fireMouseLeave(e)},a.pointerEventTypes=r(),a.targetElement.addEventListener(a.pointerEventTypes.DOWN,a._elementPointerDownHandler,!1),a.targetElement.addEventListener(a.pointerEventTypes.MOVE,a._elementPointerMoveHandler,!1),a.targetElement.addEventListener(a.pointerEventTypes.UP,a._elementPointerUpHandler,!1),a.targetElement.addEventListener(a.pointerEventTypes.CANCEL,a._elementPointerCancelHandler,!1),a.targetElement.addEventListener(a.pointerEventTypes.ENTER,a._elementPointerEnterHandler,!1),a.targetElement.addEventListener(a.pointerEventTypes.LEAVE,a._elementPointerLeaveHandler,!1),a}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener(this.pointerEventTypes.DOWN,this._elementPointerDownHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.MOVE,this._elementPointerMoveHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.UP,this._elementPointerUpHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.CANCEL,this._elementPointerCancelHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.ENTER,this._elementPointerEnterHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.LEAVE,this._elementPointerLeaveHandler,!1)},t}(o.TapHandler)},function(e,t,n){"use strict";t.__esModule=!0,t.TouchHandler=void 0;var r=n(135);t.TouchHandler=function(e){function t(n,r,o){babelHelpers.classCallCheck(this,t);var i=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,o));return i._elementTouchStartHandler=function(e){i.isDeactivated()||(i.options.activeHandler=i,i.options.updateLastTouchEventTimeStamp(e),0===i.getPointerCount()&&i.saveTargetElementOffset(),i._saveChangedPointers(e),i.saveInitialPinchDistance(),i.saveInitialGestureIfUndefined(),i.fireGestureStart(),i.registerTapHandlers(),i.options.updateInterceptionWithTouchEvent(e),i.options.shouldInvokePreventDefault()&&e.preventDefault())},i._elementTouchMoveHandler=function(e){if(!i.isDeactivated()){i.options.updateLastTouchEventTimeStamp(e);0!==i._getValidChangedPointers(e).length&&(i._saveValidChangedPointers(e),i.saveInitialGestureIfUndefined(),i.options.updateInterceptionWithTouchEvent(e),i.options.hasBrowserIntercepted()?i.unregisterTapHandlers():(i.fireGestureChange(),i.validateTapHandlers()),i.options.shouldInvokePreventDefault()&&e.preventDefault())}},i._elementTouchEndHandler=function(e){if(!i.isDeactivated()){i.options.updateLastTouchEventTimeStamp(e);var t=i._getValidChangedPointers(e);if(0!==t.length){i._saveValidChangedPointers(e),i.options.updateInterceptionWithTouchEvent(e);var n=!1;i.getPointerCount()===t.length?(i.fireGestureEnd(),i.executeTapHandlers(),i._deleteValidChangedPointers(e),n=!0):(i._deleteValidChangedPointers(e),i.fireGestureStart(),i.saveInitialPinchDistance()),i.options.shouldInvokePreventDefault()&&e.preventDefault(),n&&i.options.resetInterception()}}},i._elementTouchCancelHandler=function(e){i._elementTouchEndHandler(e)},i.targetElement.addEventListener("touchstart",i._elementTouchStartHandler,!1),i.targetElement.addEventListener("touchmove",i._elementTouchMoveHandler,!1),i.targetElement.addEventListener("touchend",i._elementTouchEndHandler,!1),i.targetElement.addEventListener("touchcancel",i._elementTouchCancelHandler,!1),i}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("touchstart",this._elementTouchStartHandler,!1),this.targetElement.removeEventListener("touchmove",this._elementTouchMoveHandler,!1),this.targetElement.removeEventListener("touchend",this._elementTouchEndHandler,!1),this.targetElement.removeEventListener("touchcancel",this._elementTouchCancelHandler,!1)},t.prototype._getValidChangedPointers=function(e){for(var t=[],n=0;n<e.changedTouches.length;n++){var r=e.changedTouches.item(n);r&&this.isValidPointer(r.identifier)&&t.push(r)}return t},t.prototype._saveValidChangedPointers=function(e){var t=this;this._getValidChangedPointers(e).forEach(function(n){t.savePointer(n.identifier,n.pageX,n.pageY,e.timeStamp)})},t.prototype._saveChangedPointers=function(e){for(var t=0;t<e.changedTouches.length;t++){var n=e.changedTouches.item(t);n&&this.savePointer(n.identifier,n.pageX,n.pageY,e.timeStamp)}},t.prototype._deleteValidChangedPointers=function(e){var t=this;this._getValidChangedPointers(e).forEach(function(e){t.deletePointer(e.identifier)})},t}(r.TapHandler)},function(e,t,n){"use strict";t.__esModule=!0,t.TrackpadHandler=void 0;var r=n(134),o=n(77),i=babelHelpers.interopRequireWildcard(o),a=1;t.TrackpadHandler=function(e){function t(n,r,o){babelHelpers.classCallCheck(this,t);var s=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,o));return s._totalDeltaY=0,s._idleTimeoutId=null,s._elementGestureStartHandler=function(e){s.isDeactivated()||(s.options.activeHandler=s,s.saveTargetElementOffset(),s.savePointer(a,e.pageX,e.pageY,e.timeStamp),s.fireGestureStart(),e.preventDefault())},s._elementGestureChangeHandler=function(e){if(!s.isDeactivated()){s.savePointer(a,e.pageX,e.pageY,e.timeStamp);var t=e.scale;!isNaN(t)&&isFinite(t)&&(s.initialGesture===i.UNDEFINED&&(s.initialGesture=t>1?i.ZOOM_IN:i.ZOOM_OUT),s.fireGestureChange(t)),s.options.shouldInvokePreventDefault()&&e.preventDefault()}},s._elementGestureEndHandler=function(e){s.isDeactivated()||(s.savePointer(a,e.pageX,e.pageY,e.timeStamp),s.fireGestureEnd(),s.deletePointer(a),s.options.shouldInvokePreventDefault()&&e.preventDefault(),s.options.resetInterception())},s._elementWheelHandler=function(e){if(e.ctrlKey&&!s.isDeactivated()){s.options.activeHandler=s,s.savePointer(a,e.pageX,e.pageY,e.timeStamp),s.initialGesture===i.UNDEFINED&&(s.initialGesture=e.deltaY>0?i.ZOOM_OUT:i.ZOOM_IN);var t=!1;if(0===s._totalDeltaY)s.fireGestureStart(),s._totalDeltaY+=e.deltaY,s._resetIdleTimeout();else if(0===e.deltaY)s._totalDeltaY=0,s.fireGestureEnd(),s.deletePointer(a),t=!0,s._cancelIdleTimeout();else{s._totalDeltaY+=e.deltaY;var n=1-s._totalDeltaY/100;s.fireGestureChange(n),s._resetIdleTimeout()}s.options.shouldInvokePreventDefault()&&e.preventDefault(),t&&s.options.resetInterception()}},s.targetElement.addEventListener("gesturestart",s._elementGestureStartHandler,!1),s.targetElement.addEventListener("gesturechange",s._elementGestureChangeHandler,!1),s.targetElement.addEventListener("gestureend",s._elementGestureEndHandler,!1),s.targetElement.addEventListener("wheel",s._elementWheelHandler,!1),s}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("gesturestart",this._elementGestureStartHandler,!1),this.targetElement.removeEventListener("gesturechange",this._elementGestureChangeHandler,!1),this.targetElement.removeEventListener("gestureend",this._elementGestureEndHandler,!1),this.targetElement.removeEventListener("wheel",this._elementWheelHandler,!1)},t.prototype.reset=function(){e.prototype.reset.call(this),this._cancelIdleTimeout(),this._totalDeltaY=0,this._idleTimeoutId=null},t.prototype._resetIdleTimeout=function(){var e=this;this._cancelIdleTimeout(),this._idleTimeoutId=window.setTimeout(function(){e._idleTimeoutId=null,e._onIdle()},250)},t.prototype._cancelIdleTimeout=function(){window.clearTimeout(this._idleTimeoutId)},t.prototype._onIdle=function(){this._totalDeltaY=0,this.fireGestureEnd(),this.deletePointer(a),this.options.resetInterception()},t}(r.BaseInputHandler)},function(e,t,n){"use strict";t.__esModule=!0,t.WheelHandler=void 0;var r=n(134),o=n(77),i=babelHelpers.interopRequireWildcard(o),a=1;t.WheelHandler=function(e){function t(n,r,o){babelHelpers.classCallCheck(this,t);var s=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,o));return s._totalDeltaY=0,s._idleTimeoutId=null,s._elementWheelHandler=function(e){if(!e.ctrlKey&&s.callbacks.catchWheelEvent&&s.callbacks.catchWheelEvent()&&!s.isDeactivated()){if(s.options.activeHandler=s,s.savePointer(a,e.pageX,e.pageY,e.timeStamp),s.initialGesture===i.UNDEFINED&&(s.initialGesture=e.deltaY>0?i.ZOOM_OUT:i.ZOOM_IN),0===s._totalDeltaY)s.fireGestureStart(),s._totalDeltaY+=e.deltaY;else{s._totalDeltaY+=e.deltaY;s.fireGestureChange(1-s._totalDeltaY/200)}s._resetIdleTimeout(),s.options.shouldInvokePreventDefault()&&e.preventDefault()}},s.targetElement.addEventListener("wheel",s._elementWheelHandler,!1),s}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("wheel",this._elementWheelHandler,!1)},t.prototype.reset=function(){e.prototype.reset.call(this),this._cancelIdleTimeout(),this._totalDeltaY=0,this._idleTimeoutId=null},t.prototype._resetIdleTimeout=function(){var e=this;this._cancelIdleTimeout(),this._idleTimeoutId=window.setTimeout(function(){e._idleTimeoutId=null,e._onIdle()},250)},t.prototype._cancelIdleTimeout=function(){window.clearTimeout(this._idleTimeoutId)},t.prototype._onIdle=function(){this._totalDeltaY=0,this.fireGestureEnd(),this.deletePointer(a),this.options.resetInterception()},t}(r.BaseInputHandler)},function(e,t,n){"use strict";function r(e){d=window.setInterval(function(){c.isFirstSpread(e.getState())?f=!0:c.isLastSpread(e.getState())&&(f=!1),e.dispatch(f?(0,a.goToNextPage)():(0,a.goToPreviousPage)())},p)}function o(){d&&(window.clearInterval(d),d=void 0)}t.__esModule=!0,t.autoFlipMiddleWare=void 0;var i=n(19),a=n(8),s=n(63),u=babelHelpers.interopRequireWildcard(s),l=n(11),c=babelHelpers.interopRequireWildcard(l),p=1e4,d=void 0,f=!0;t.autoFlipMiddleWare=function(e){return function(t){return function(n){var s=t(n);switch(n.type){case i.types.DOCUMENTLOAD_SUCCESS:e.getState().reader.autoFlipInitially&&r(e);break;case a.types.SET_INTERACTED_WITH_READER:e.getState().reader.interactedWithReader&&o();break;case u.types.EMBED_PREVIEW:o(),e.getState().features.autoFlip&&r(e)}return s}}}},function(e,t,n){"use strict";t.__esModule=!0,t.externalApiMiddleWare=void 0;var r=n(8),o=n(19),i=n(63),a=n(11),s=babelHelpers.interopRequireWildcard(a);t.externalApiMiddleWare=function(e){var t={};return function(n){return function(a){return function(u){var l=a(u),c=n.getState();try{switch(u.type){case i.types.SET_CALLBACK:i.events.hasOwnProperty(u.event)&&(t[u.event]=u.func);break;case o.types.DOCUMENTLOAD_SUCCESS:var p=s.selectCurrentPageNumbers(c);t.hasOwnProperty(i.events.ON_DOCUMENT_LOAD_EVENT)&&t[i.events.ON_DOCUMENT_LOAD_EVENT](p);break;case r.types.READER_POSITION_CHANGED:if(u.currentPagesHasChanged){var d=u.currentPages.map(function(e){return e.pageNumber});t.hasOwnProperty(i.events.ON_PAGE_CHANGE_EVENT)&&t[i.events.ON_PAGE_CHANGE_EVENT](d)}}}catch(t){e(t)}return l}}}}},function(e,t,n){"use strict";t.__esModule=!0,t.gaMiddleWare=void 0;var r=n(19),o=n(8),i=n(11),a=babelHelpers.interopRequireWildcard(i);t.gaMiddleWare=function(e,t){return function(n){return function(i){return function(s){var u=i(s),l=n.getState();try{switch(s.type){case r.types.DOCUMENTLOAD_SUCCESS:var c=a.selectCurrentPageNumbers(l);e.onDocumentLoaded(l.documentModel,l.reader.initialPageNumber,c);break;case o.types.READER_POSITION_CHANGED:if(s.currentPagesHasChanged){var p=s.currentPages.map(function(e){return e.pageNumber});e.onPageChanged(p)}}}catch(e){t(e)}return u}}}}},function(e,t,n){"use strict";function r(e){window.fetch("http://pingback.tissuu.com/pong",{method:"post",body:JSON.stringify(e)}).catch(function(e){})}t.__esModule=!0,t.logger=void 0;var o=n(94),i=(babelHelpers.interopRequireWildcard(o),n(109)),a=(babelHelpers.interopRequireWildcard(i),n(214)),s=(babelHelpers.interopRequireWildcard(a),n(11));babelHelpers.interopRequireWildcard(s);t.logger=function(e){return function(t){return function(n){console.group(n.type),console.info("dispatching",n);var o=t(n);return console.log("next state",e.getState()),console.groupEnd(n.type),r(n),o}}}},function(e,t,n){"use strict";t.__esModule=!0,t.quantcastMiddleWare=void 0;var r=n(8),o=n(19),i=n(11),a=babelHelpers.interopRequireWildcard(i);t.quantcastMiddleWare=function(e,t){return function(n){return function(i){return function(s){var u=i(s),l=n.getState();try{switch(s.type){case o.types.DOCUMENTLOAD_SUCCESS:var c=a.selectCurrentPageNumbers(l);e.onDocumentLoaded(l.documentModel,c);break;case r.types.READER_POSITION_CHANGED:if(l.reader.isReady&&s.currentPagesHasChanged){var p=a.selectCurrentPageNumbers(l);e.onPageChanged(p)}}}catch(e){t(e)}return u}}}}},function(e,t,n){"use strict";t.__esModule=!0,t.ravenTagsMiddleware=void 0;var r=n(96),o=n(267),i=babelHelpers.interopRequireDefault(o);t.ravenTagsMiddleware=function(e){return function(t){return function(n){var o=t(n),a=e.getState();return i.default.setTagsContext({webgl:(0,r.selectUseWebGL)(a)}),o}}}},function(e,t,n){"use strict";function r(e,t,n){var r={width:t,height:n,left:(screen.width-t)/2,top:(screen.height-n)/2},o=Object.keys(r).map(function(e){return e+"="+r[e]}).join(",");window.open(e,"_blank",o)}function o(e,t){return function(n){var r=encodeURIComponent("I found this great publication on issuu.com"),o=encodeURIComponent("Hi,\n\nI found this publication on issuu.com which seems totally made for you.\n\n"+e+":\n"+t+"\n\nCheck it out and let me know what you think.\n\n- Me"),i="mailto:?subject="+r+"&body="+o;window.open(i,"_top")}}function i(e){return function(t){r("https://www.facebook.com/sharer.php?u="+encodeURIComponent(e),575,300)}}function a(e,t){return function(n){var o={url:encodeURIComponent(t),text:encodeURIComponent(e),via:"issuu"};r("https://twitter.com/intent/tweet?"+Object.keys(o).map(function(e){return e+"="+o[e]}).join("&"),550,420)}}function s(e,t,n){return function(o){var i={url:encodeURIComponent(e),media:encodeURIComponent(t),description:encodeURIComponent(n)};r("https://pinterest.com/pin/create/button/?"+Object.keys(i).map(function(e){return e+"="+i[e]}).join("&"),750,500)}}t.__esModule=!0,t.shareOnEmail=o,t.shareOnFacebook=i,t.shareOnTwitter=a,t.shareOnPinterest=s},function(e,t,n){"use strict";t.__esModule=!0,t.Button=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(8),u=babelHelpers.interopRequireWildcard(s),l=n(29),c=babelHelpers.interopRequireWildcard(l),p=n(21),d=n(136),f=t.Button=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.onClick=function(){this.props.dispatch(u.toggleDropdown(d.SHARE)),this.props.featureTracker.usage(p.FEATURES.BUTTON_SHARE),this.props.dispatch(c.onButtonClick())},t.prototype.render=function(){var e=this;return o.default.createElement("div",{className:"header-controls__share-toggle",onClick:function(){return e.onClick()}},"Share")},t}(r.Component);f.displayName="ShareButton",f.propTypes={dispatch:a.default.func.isRequired,featureTracker:a.default.object.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.Dropdown=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(371),u=babelHelpers.interopRequireWildcard(s),l=n(136),c=n(8),p=babelHelpers.interopRequireWildcard(c),d=n(29),f=babelHelpers.interopRequireWildcard(d),h=n(21),m=n(375),g=n(377),v=n(376),b=n(374),y=t.Dropdown=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onShareOnEmail=function(){r.props.featureTracker.usage(h.FEATURES.SHARE_EMAIL),r.props.dispatch(u.shareOnEmail(r.props.documentTitle,r.props.documentUrl)),r.props.dispatch(f.onButtonClick())},r.onShareOnFacebook=function(){r.props.featureTracker.usage(h.FEATURES.SHARE_FACEBOOK),r.props.dispatch(u.shareOnFacebook(r.props.documentUrl)),r.props.dispatch(f.onButtonClick())},r.onShareOnTwitter=function(){r.props.featureTracker.usage(h.FEATURES.SHARE_TWITTER),r.props.dispatch(u.shareOnTwitter(r.props.documentTitle,r.props.documentUrl)),r.props.dispatch(f.onButtonClick())},r.onShareOnPinterest=function(){r.props.featureTracker.usage(h.FEATURES.SHARE_PINTEREST),r.props.dispatch(u.shareOnPinterest(r.props.documentUrl,r.props.coverImageUrl,r.props.documentTitle)),r.props.dispatch(f.onButtonClick())},r.onDimmerClick=function(){r.props.dispatch(p.toggleDropdown(l.SHARE))},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){var e=this.refs.shareDropdownInput;this.props.visible&&(e.setSelectionRange(0,e.value.length),this.props.featureTracker.opportunity(h.FEATURES.SHARE_EMAIL),this.props.featureTracker.opportunity(h.FEATURES.SHARE_FACEBOOK),this.props.featureTracker.opportunity(h.FEATURES.SHARE_TWITTER),this.props.featureTracker.opportunity(h.FEATURES.SHARE_PINTEREST))},t.prototype.render=function(){var e=this.props.documentUrl;return o.default.createElement("div",{className:"share-dropdown"},o.default.createElement("div",{className:"share-dropdown__dimmer",onClick:this.onDimmerClick}),o.default.createElement("div",{className:"share-dropdown__inner"},o.default.createElement("div",{className:"share-dropdown__social-buttons"},o.default.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--facebook",onClick:this.onShareOnFacebook,dangerouslySetInnerHTML:{__html:m.FacebookIcon},href:"javascript:void(0)","data-tooltip":"Facebook"}),o.default.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--twitter",onClick:this.onShareOnTwitter,dangerouslySetInnerHTML:{__html:g.TwitterIcon},href:"javascript:void(0)","data-tooltip":"Twitter"}),o.default.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--pinterest",onClick:this.onShareOnPinterest,dangerouslySetInnerHTML:{__html:v.PinterestIcon},href:"javascript:void(0)","data-tooltip":"Pinterest"}),o.default.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--mailto",onClick:this.onShareOnEmail,dangerouslySetInnerHTML:{__html:b.EmailIcon},href:"javascript:void(0)","data-tooltip":"E-mail"})),o.default.createElement("div",{className:"share-dropdown__direct-link"},o.default.createElement("input",{className:"share-dropdown__input",readOnly:!0,type:"text",value:e,ref:"shareDropdownInput"}))))},t}(r.Component);y.displayName="ShareDropdown",y.propTypes={coverImageUrl:a.default.string.isRequired,dispatch:a.default.func.isRequired,documentTitle:a.default.string.isRequired,documentUrl:a.default.string.isRequired,featureTracker:a.default.object.isRequired,visible:a.default.bool.isRequired}},function(e,t,n){"use strict";t.__esModule=!0;t.EmailIcon='\n  <svg width="20" height="15" viewBox="0 0 20 15" xmlns="http://www.w3.org/2000/svg">\n    <g fill="none" fill-rule="evenodd">\n      <path d="M-11.336-15.286h42.24v42.24h-42.24z"/>\n      <path class="icon" d="M.845 12.877c0 .315.112.583.336.806.225.222.495.333.812.333h16.05c.317 0 .587-.11.81-.333.225-.223.337-.49.337-.806V3.534l-9.173 6.834L.845 3.534v9.343zm0-11.39l9.172 6.834 9.172-6.833c0-.314-.113-.582-.337-.805-.224-.222-.494-.334-.81-.334H1.992c-.318 0-.588.112-.812.334-.223.223-.335.49-.335.805z"/>\n    </g>\n  </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0;t.FacebookIcon='\n  <svg width="17" height="18" viewBox="0 0 17 18" xmlns="http://www.w3.org/2000/svg">\n    <path class="icon" d="M16.082.34H.964c-.518 0-.938.42-.938.94v15.116c0 .518.42.938.938.938h8.14v-6.58H6.887V8.188h2.215V6.296c0-2.195 1.34-3.39 3.298-3.39.94 0 1.745.07 1.98.1v2.295h-1.358c-1.064 0-1.27.507-1.27 1.25v1.637h2.54l-.332 2.563h-2.21v6.58h4.332c.518 0 .938-.42.938-.937V1.28c0-.52-.42-.94-.938-.94" fill-rule="evenodd"></path>\n  </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0;t.PinterestIcon='\n  <svg width="18" height="19" viewBox="0 0 18 19" xmlns="http://www.w3.org/2000/svg">\n    <g fill="none" fill-rule="evenodd">\n      <path d="M-11.695-11.286h42.24v42.24h-42.24z"/>\n      <path class="icon" d="M8.898.796C4.028.796.078 4.72.078 9.558c0 3.588 2.172 6.67 5.28 8.025-.025-.612-.005-1.347.153-2.012l1.136-4.773s-.282-.56-.282-1.387c0-1.298.758-2.268 1.7-2.268.803 0 1.19.6 1.19 1.316 0 .8-.513 2-.778 3.11-.22.928.47 1.686 1.392 1.686 1.67 0 2.796-2.132 2.796-4.658 0-1.92-1.302-3.357-3.67-3.357-2.675 0-4.34 1.98-4.34 4.194 0 .764.225 1.302.58 1.72.163.19.186.267.127.487-.04.162-.14.55-.18.704-.058.222-.238.302-.44.22-1.233-.5-1.806-1.84-1.806-3.348 0-2.49 2.112-5.473 6.303-5.473 3.367 0 5.583 2.42 5.583 5.02 0 3.436-1.923 6.004-4.76 6.004-.95 0-1.846-.51-2.153-1.092 0 0-.512 2.02-.62 2.408-.188.676-.554 1.35-.888 1.877.792.233 1.63.36 2.498.36 4.87 0 8.82-3.923 8.82-8.762 0-4.84-3.95-8.762-8.82-8.762z"/>\n    </g>\n  </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0;t.TwitterIcon='\n  <svg width="21" height="18" viewBox="0 0 21 18" xmlns="http://www.w3.org/2000/svg">\n    <g fill="none" fill-rule="evenodd">\n      <path d="M-11.12-12.286h42.24v42.24h-42.24z"/>\n      <path class="icon" d="M0 15.526c1.757 1.122 3.886 1.683 6.39 1.683 1.22 0 2.39-.162 3.506-.483 1.116-.322 2.106-.774 2.97-1.358.853-.572 1.622-1.238 2.31-2 .686-.76 1.247-1.577 1.683-2.45.904-1.816 1.356-3.64 1.356-5.47v-.542c.812-.584 1.502-1.3 2.07-2.145-.818.36-1.618.58-2.397.66.89-.526 1.502-1.29 1.832-2.294-.852.49-1.727.826-2.625 1.003-.403-.413-.87-.733-1.397-.96-.528-.226-1.083-.34-1.664-.34-1.15 0-2.128.403-2.937 1.206-.81.803-1.214 1.776-1.214 2.917 0 .374.03.692.09.955C8.27 5.82 6.68 5.407 5.2 4.672S2.457 2.937 1.407 1.67C1.03 2.313.842 2.983.842 3.678c0 .695.165 1.345.495 1.948.33.604.786 1.096 1.367 1.477-.667-.02-1.294-.19-1.882-.512v.05c0 .99.315 1.867.946 2.628.63.76 1.428 1.236 2.392 1.426-.396.1-.766.148-1.11.148-.217 0-.475-.026-.772-.08.264.835.755 1.52 1.47 2.058.718.538 1.518.81 2.403.817-1.63 1.305-3.35 1.958-5.16 1.958-.376 0-.706-.023-.99-.07z"/>\n    </g>\n  </svg>\n'},function(e,t,n){"use strict";t.__esModule=!0,t.shouldRenderShareButton=t.isDropdownVisible=t.Dropdown=t.Button=void 0;var r=n(372),o=n(373),i=n(379);t.Button=r.Button,t.Dropdown=o.Dropdown,t.isDropdownVisible=i.isDropdownVisible,t.shouldRenderShareButton=i.shouldRenderShareButton},function(e,t,n){"use strict";t.__esModule=!0,t.isDropdownVisible=t.shouldRenderShareButton=void 0;var r=n(33),o=n(11),i=babelHelpers.interopRequireWildcard(o),a=n(94),s=babelHelpers.interopRequireWildcard(a),u=n(213),l=n(41),c=n(136);t.shouldRenderShareButton=(0,r.createSelector)(s.canHideShareButton,i.selectShowCTAOverlay,i.selectFullscreenEnabled,i.selectFeature(l.SHARE_DIALOG_TYPE),function(e,t,n,r){return!(!r||r.customizedToNotShow&&e||t||r.hideWhenNotInFullscreen&&!n)}),t.isDropdownVisible=function(e){return(0,u.visibleDropdown)(e)===c.SHARE}},function(e,t,n){"use strict";function r(e){if(e.backgroundImage){var t=null;if("topleft"===e.backgroundImagePosition?t=c.BACKGROUND_IMAGE_STYLE.TOP_LEFT:"stretch"===e.backgroundImagePosition&&(t=c.BACKGROUND_IMAGE_STYLE.STRETCH),t)return{url:e.backgroundImage,style:t,hideWhenNotInFullscreen:!0}}return null}function o(e){return e.logo?{url:e.logo,hideWhenNotInFullscreen:!0}:null}function i(e,t,n){switch(t.type){case s.types.SET_INPUBADS:return Object.assign({},e,{enableInPubAds:t.enableInPubAds});case u.types.DISABLE_LICENSE_CHECK:return n?e:Object.assign({},e,{disableLicenseCheck:!0});case l.types.EMBED_PREVIEW:var i=t.embedConfig,a=Object.assign({},e,{autoFlip:i.autoFlip,backgroundImage:r(i),logo:o(i),backgroundColor:i.backgroundColor,fullscreenBackgroundColor:i.fullscreenBackgroundColor,readModeRules:{defaultMode:"singlePage"===i.viewMode?c.READ_MODE.SINGLE_PAGE_SPREAD:c.READ_MODE.DOUBLE_PAGE_SPREAD,responsiveModeWhen:c.READ_MODE.RESPONSIVE.HANDHELD_IN_PORTRAIT_FULLSCREEN}});return a.controls=a.controls.map(function(e){return e.type===c.SHARE_DIALOG_TYPE?Object.assign({},e,{customizedToNotShow:!i.shareButtonEnabled}):e}),a;default:return e}}function a(e){return function(){return i(arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,arguments[1],arguments[2])}}t.__esModule=!0,t.reducer=t.create=void 0;var s=n(193),u=n(19),l=n(63),c=n(41);t.create=a,t.reducer=i},function(e,t,n){"use strict";function r(){var e={enabled:!1,supported:u.isFullscreenAPISupported()};return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,n=arguments[1];switch(n.type){case o.types.ENTER_FULLSCREEN:return Object.assign({},t,{enabled:n.fullscreenMethod===a.FULLSCREEN_API});case o.types.EXIT_FULLSCREEN:return Object.assign({},t,{enabled:!1});default:return t}}}t.__esModule=!0,t.create=void 0;var o=n(93),i=n(132),a=babelHelpers.interopRequireWildcard(i),s=n(217),u=babelHelpers.interopRequireWildcard(s);t.create=r},function(e,t,n){"use strict";function r(e){return Object.assign({},e,{visibleDropdown:null,readMoreDropdownVisible:!1})}function o(e,t){return Object.assign(r(e),{visibleDropdown:t!==e.visibleDropdown?t:null})}function i(e){return Object.assign(r(e),{readMoreDropdownVisible:!0})}function a(e,t){switch(t.type){case u.types.TOGGLE_DROPDOWN:return o(e,t.dropdown);case u.types.SHOW_MORE_DROPDOWN:return i(e);case u.types.CLOSE_MORE_DROPDOWN:case u.types.SET_TARGET_SPREAD_INDEX:case u.types.SET_INTERACTING_WITH_CONTROLS:case l.types.ENTER_FULLSCREEN:case l.types.EXIT_FULLSCREEN:return r(e);case u.types.READER_POSITION_CHANGED:return t.isDragging?r(e):e;case u.types.READER_ZOOM_LEVEL_CHANCED:return t.isPinching?r(e):e;case c.types.DOWNLOAD_READY:case c.types.DOWNLOAD_LOADING:case c.types.DOWNLOAD_SUCCESS:case c.types.DOWNLOAD_FAILURE:return Object.assign(r(e),{downloadButtonStatus:t.type});default:return e}}function s(){var e={visibleDropdown:null,readMoreDropdownVisible:!1,downloadButtonStatus:c.types.DOWNLOAD_READY};return function(){return a(arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,arguments[1])}}t.__esModule=!0,t.reducer=t.create=void 0;var u=n(8),l=n(93),c=n(129);t.create=s,t.reducer=a},function(e,t,n){"use strict";function r(e,t){switch(t.type){case i.types.DOCUMENTLOADING:return Object.assign({},e,{status:s.LOADING,loadStartTime:t.timeStamp});case i.types.DOCUMENTLOAD_SUCCESS:return Object.assign({},e,{status:s.SUCCESS,loadSuccessTime:t.timeStamp});case i.types.DOCUMENTLOAD_FAILURE:return Object.assign({},e,{status:s.FAILED,error:t.error,loadFailureTime:t.timeStamp});default:return e}}function o(e,t){var n={status:null,username:e,documentName:t,error:null};return function(){return r(arguments.length>0&&void 0!==arguments[0]?arguments[0]:n,arguments[1])}}t.__esModule=!0,t.reducer=r,t.create=o;var i=n(19),a=n(210),s=babelHelpers.interopRequireWildcard(a)},function(e,t,n){"use strict";function r(e,t){return Object.assign({},e,{targetSpreadIndex:t.index})}function o(e,t){return Object.assign({},e,{debugMode:t.display})}function i(e,t){var n=t.initialPageNumber,r=t.targetSpreadIndex,o=t.currentPages;return Object.assign({},e,{targetSpreadIndex:r,currentPages:o,initialPageNumber:n,isReady:!0})}function a(e,t){return Object.assign({},e,{visiblePages:t.visiblePages,currentPages:t.currentPages,currentSpreadIndex:t.currentSpreadIndex,currentPageNumber:t.currentPageNumber,positionInPercent:t.positionInPercent,targetSpreadIndex:t.currentSpreadIndex===e.targetSpreadIndex?-1:e.targetSpreadIndex})}function s(e,t){return Object.assign({},e,{zoomLevel:t.zoomLevel})}function u(e,t){return Object.assign({},e,{isIdle:t.isIdle})}function l(e,t){return Object.assign({},e,{interactingWithControls:t.val})}function c(e,t){return Object.assign({},e,{interactedWithReader:!0})}function p(e,t){return Object.assign({},e,{interactedWithReader:!1})}function d(e,t){return Object.assign({},e,{hoveringOverControls:t})}function f(e,t){switch(t.type){case m.types.SET_DEBUG_MODE:return o(e,t);case m.types.SET_TARGET_SPREAD_INDEX:return r(e,t);case m.types.SET_IS_IDLE:return u(e,t);case m.types.SET_INTERACTING_WITH_CONTROLS:return l(e,t);case m.types.SET_INTERACTED_WITH_READER:return c(e,t);case m.types.SET_HOVERING_OVER_CONTROLS:return d(e,t.val);case y.RESIZE:return d(e,!1);case m.types.READER_POSITION_CHANGED:return a(e,t);case m.types.READER_ZOOM_LEVEL_CHANCED:return s(e,t);case v.types.EMBED_PREVIEW:return p(e,t);case b.types.DOCUMENTLOAD_SUCCESS:return i(e,t);default:return e}}function h(e){var t={arrivedAtSpreadTimeStamp:0,autoFlipInitially:e,debugMode:!1,hoveringOverControls:!1,initialPageNumber:0,interactedWithReader:!1,interactingWithControls:!1,interactingWithCanvas:!1,isIdle:!0,isReady:!1,lastSpreadIndexArrivedAt:-1,targetSpreadIndex:0,visiblePages:[],currentPages:[],currentPageNumber:0,currentSpreadIndex:-1,positionInPercent:0,zoomLevel:1};return function(){return f(arguments.length>0&&void 0!==arguments[0]?arguments[0]:t,arguments[1],arguments.length>2&&void 0!==arguments[2]?arguments[2]:{})}}t.__esModule=!0,t.reducer=t.create=void 0;var m=n(8),g=n(63),v=babelHelpers.interopRequireWildcard(g),b=n(19),y=n(110);t.create=h,t.reducer=f},function(e,t,n){"use strict";function r(e,t){switch(t.type){case s.types.READ_MORE_LOAD_SUCCESS:return Object.assign({},e,{loaded:!0});case i.types.SHOW_MORE_DROPDOWN:return Object.assign({},e,{forceOverlay:!1});case i.types.CLOSE_MORE_DROPDOWN:return Object.assign({},e,{exitedFullscreen:!1});case a.types.ENTER_FULLSCREEN:return t.fullscreenMethod===c.FULLSCREEN_API?e:Object.assign({},e,{exitedFullscreen:!0,forceOverlay:!0});case a.types.EXIT_FULLSCREEN:return Object.assign({},e,{exitedFullscreen:!0,forceOverlay:!0});case u.types.EMBED_PREVIEW:return Object.assign({},p);default:return e}}function o(){return function(){return r(arguments.length>0&&void 0!==arguments[0]?arguments[0]:p,arguments[1])}}t.__esModule=!0,t.reducer=r,t.create=o;var i=n(8),a=n(93),s=n(19),u=n(63),l=n(132),c=babelHelpers.interopRequireWildcard(l),p={loaded:!1,exitedFullscreen:!1,forceOverlay:!1}},function(e,t,n){"use strict";function r(e,t,n,r,o,a,u,c){var d=s.create(r.autoFlip),h=i.create(t,n),g=l.create(),x=f.create(),C=m.create(),I=T.createReducer(),R=v.create(r),M=(0,b.createReducer)(c),P=(0,E.createReducer)(),O=(0,y.createReducer)(),A=(0,_.createReducer)(),D=(0,w.createReducer)(),k=p.create(),N=(0,S.createFindReducer)();return function(t,n){return{documentModel:A(t.documentModel,n),canvasContext:M(t.canvasContext,n),fullscreen:g(t.fullscreen,n),headerControls:k(t.headerControls,n),loading:h(t.loading,n),reader:d(t.reader,n),readmore:x(t.readmore,n),paywall:P(t.paywall,n),size:O(t.size,n),videoOverlay:I(t.videoOverlay,n),visibility:C(t.visibility,n),features:R(t.features,n,!!t.reader&&t.reader.isReady),canvasApi:D(t.canvasApi,n),find:N(t.find,n),config:e,featureTracker:o,isLoggedIn:u,readMorePlugin:n.readMorePlugin||t.readMorePlugin||a}}}t.__esModule=!0,t.create=void 0;var o=n(383),i=babelHelpers.interopRequireWildcard(o),a=n(384),s=babelHelpers.interopRequireWildcard(a),u=n(381),l=babelHelpers.interopRequireWildcard(u),c=n(382),p=babelHelpers.interopRequireWildcard(c),d=n(385),f=babelHelpers.interopRequireWildcard(d),h=n(387),m=babelHelpers.interopRequireWildcard(h),g=n(380),v=babelHelpers.interopRequireWildcard(g),b=n(96),y=n(110),_=n(97),E=n(48),w=n(138),S=n(58),x=n(137),T=babelHelpers.interopRequireWildcard(x);t.create=r},function(e,t,n){"use strict";function r(e,t){return Object.assign({},e,{isHidden:s.isHidden()})}function o(){var e={isHidden:s.isHidden(),supported:s.isVisibilityAPISupported()};return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,n=arguments[1];switch(n.type){case i.types.ON_VISIBILITY_CHANGE:return r(t,n);default:return t}}}t.__esModule=!0,t.create=void 0;var i=n(195),a=n(219),s=babelHelpers.interopRequireWildcard(a);t.create=o},function(e,t,n){"use strict";function r(e,t,n){return{proportion:e,done:t,available:n}}t.__esModule=!0,t.segmentPages=t.segmentZoom=void 0;var o=n(33),i=n(48),a=n(11),s=babelHelpers.interopRequireWildcard(a),u=n(59),l=n(40);t.segmentZoom=(0,o.createSelector)(s.selectZoomLevelInPercent,function(e){return e>0&&e<100?[{proportion:Math.round(e),done:!0,available:!0},{proportion:100-Math.round(e),done:!1,available:!0}]:[{proportion:100,done:100===e,available:!0}]}),t.segmentPages=(0,o.createSelector)(s.selectCurrentSpreadIndex,s.selectLastSpreadIndex,function(e){return e.documentModel.pageCount},i.selectors.previewPages,i.selectors.isPreview,s.selectReadMode,function(e,t,n,o,i,a){for(var s=t+1,c=[r(2,e>0,!0)],p=i?o.map(function(e){return(0,u.pageNumberToSpreadIndex)(a,e)}):[],d=1;d<s;d++){var f=c[c.length-1],h=!p.includes(d),m=d<=e,g=2;a===l.DOUBLE_PAGE_SPREAD&&d<t&&(g=4),d===e&&d<t?(c.push(r(a===l.DOUBLE_PAGE_SPREAD?2:1,!0,h)),c.push(r(a===l.DOUBLE_PAGE_SPREAD?2:1,!1,h))):m===f.done&&h===f.available?f.proportion+=g:c.push(r(g,m,h))}return c})},function(e,t,n){"use strict";t.__esModule=!0;t.GAService=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gaTracker=t,this._baseUrl=null,this._previousPageNumbers=[],this._timeoutId=null}return e.prototype.destroy=function(){window.clearTimeout(this._timeoutId)},e.prototype.onDocumentLoaded=function(e,t,n){this._baseUrl="/"+e.username+"/docs/"+e.documentName,this._previousPageNumbers=n,this.gaTracker.sendInitialPageview(this._baseUrl+"/"+t),this.gaTracker.handleDocumentLoadByPublisherAccount(this._baseUrl,this._previousPageNumbers)},e.prototype.onPageChanged=function(e){var t=this;this._previousPageNumbers.join()!==e.join()&&(this._previousPageNumbers=e,window.clearTimeout(this._timeoutId),this._timeoutId=window.setTimeout(function(){t._previousPageNumbers.forEach(function(e){t.gaTracker.sendVirtualPageview(t._baseUrl+"/"+e)})},1e3))},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.LoadStatsTracker=void 0;var r=n(19),o=window.performance&&window.performance.now?function(){return window.performance.now()}:function(){return Date.now()};t.LoadStatsTracker=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this._hasTrackedTimeToCover=!1,this._pageLoadStartTime=new Map,this._fontLoadStartTime=new Map,this._imageDecodeStartTime=new Map,this._pageLoadStats={failedCount:0,successCount:0,successAfterRetryCount:0,failedTotalTime:0,successTotalTime:0,layersImageFallbackCount:0,fontloadCount:0,fontloadTotalTime:0},this._pageLoadStatsTimerId=null,this._totalFontRenderCalls=0,this._totalSlowFontRenderCalls=0,this._totalFramesDroppedOnFontRendering=0,this._fontRenderingStartTimeStamp=0,this._fontLoadTimings=[],this._imageDecodeTimings=[],this.trackingService=t}return e.prototype.onDocumentLoadSuccess=function(e){this.trackingService.monitor("reader3-documentload-stats",{success_time:e},!1)},e.prototype.onDocumentLoadFailure=function(e,t){this.trackingService.monitor("reader3-documentload-stats",{failed_time:e,backend_error:t instanceof r.BackendModelError?1:0,fetch_error:t instanceof r.FetchNetworkError?1:0})},e.prototype.onDynamicApiLoadComplete=function(e,t){t?this.trackingService.monitor("reader3-dynamicapi-stats",{failure:1,failure_time:Math.round(e)},!1):this.trackingService.monitor("reader3-dynamicapi-stats",{success:1,success_time:Math.round(e)},!1)},e.prototype.onReadMoreLoadComplete=function(e){this.trackingService.monitor("reader3-readmoreload-stats",e?{success:1}:{failure:1},!1)},e.prototype.onPageLoadStart=function(e,t){this.mode=t,this._pageLoadStartTime.set(e,o())},e.prototype.onPageLoadSuccess=function(e){var t=o();if(!this._hasTrackedTimeToCover){var n=void 0;if(window.performance&&window.performance.now&&window.performance.timing&&window.performance.timing.fetchStart){var r=window.performance.timing.fetchStart-window.performance.timing.navigationStart;n=window.performance.now()-r}else n=Date.now()-this._loadStartTimeStamp;this.trackingService.monitor("reader3-time-to-cover",{ms_to_cover:n},!1),this._hasTrackedTimeToCover=!0}this._pageLoadStats.successCount+=1,this._pageLoadStats.successTotalTime+=t-(this._pageLoadStartTime.get(e)||0),this._pageLoadStartTime.delete(e),this.batchPageLoadStats()},e.prototype.onPageLoadSuccessAfterRetry=function(e){this._pageLoadStats.successAfterRetryCount+=1,this.onPageLoadSuccess(e)},e.prototype.onPageLoadFailure=function(e){this._pageLoadStats.failedCount+=1,this._pageLoadStats.failedTotalTime+=o()-(this._pageLoadStartTime.get(e)||0),this.batchPageLoadStats()},e.prototype.onLayersImageFallback=function(){this._pageLoadStats.layersImageFallbackCount+=1,this.batchPageLoadStats()},e.prototype.onFontRenderingStart=function(){this._fontRenderingStartTimeStamp=o()},e.prototype.onFontRenderingEnd=function(){var e=o()-this._fontRenderingStartTimeStamp,t=Math.max(Math.floor(e/(1e3/60))-1,0);this._totalFontRenderCalls+=1,t&&(this._totalSlowFontRenderCalls+=1,this._totalFramesDroppedOnFontRendering+=t),this.batchPageLoadStats()},e.prototype.onFontLoadStart=function(e){this._fontLoadStartTime.set(e,o())},e.prototype.onFontLoadEnd=function(e){var t=o()-(this._fontLoadStartTime.get(e)||0);this._fontLoadTimings.push(Math.round(t)),this._fontLoadStartTime.delete(e)},e.prototype.onImageDecodeStart=function(e){this._imageDecodeStartTime.set(e,o())},e.prototype.onImageDecodeEnd=function(e){var t=o()-(this._imageDecodeStartTime.get(e)||0);this._imageDecodeTimings.push(Math.round(t)),this._imageDecodeStartTime.delete(e)},e.prototype.batchPageLoadStats=function(){var e=this;if(!this._pageLoadStatsTimerId){var t=this._pageLoadStats;this._pageLoadStatsTimerId=setTimeout(function(){if(e._pageLoadStatsTimerId=0,t.successCount>0){var n={success_count:t.successCount,success_total_time:t.successTotalTime,success_avg_time:t.successTotalTime/t.successCount,success_after_retry:t.successAfterRetryCount,mode:e.mode,load_and_decode_count:void 0,load_and_decode_total_time:void 0,load_and_decode_avg_time:void 0};t.fontloadCount>0&&(Object.assign(n,{load_and_decode_count:t.fontloadCount,load_and_decode_total_time:t.fontloadTotalTime,load_and_decode_avg_time:t.fontloadTotalTime/t.fontloadCount}),t.fontloadCount=0,t.fontloadTotalTime=0),e.trackingService.monitor("reader3-pageload-stats",n,!1),t.successCount=0,t.successAfterRetryCount=0,t.successTotalTime=0}t.layersImageFallbackCount>0&&(e.trackingService.monitor("reader3-pageload-stats",{layers_image_fallback_count:t.layersImageFallbackCount},!1),t.layersImageFallbackCount=0),t.failedCount>0&&(e.trackingService.monitor("reader3-pageload-stats",{failed_count:t.failedCount,failed_total_time:t.failedTotalTime,failed_avg_time:t.failedTotalTime/t.failedCount,mode:e.mode},!1),t.failedCount=0,t.failedTotalTime=0),e._totalFontRenderCalls>0&&(e.trackingService.monitor("reader3-fontrender-stats",{total:e._totalFontRenderCalls,total_slow:e._totalSlowFontRenderCalls,total_frames_dropped:e._totalFramesDroppedOnFontRendering,mode:e.mode},!1),e._totalFontRenderCalls=0,e._totalSlowFontRenderCalls=0,e._totalFramesDroppedOnFontRendering=0),(e._fontLoadTimings.length||e._imageDecodeTimings.length)&&(e.trackingService.monitor("reader3-fontload-stats",{image_decode:e._fontLoadTimings.slice(0),font_load:e._imageDecodeTimings.slice(0),mode:e.mode},!1),e._fontLoadTimings.length=0,e._imageDecodeTimings.length=0)},5e3)}},e}()},function(e,t,n){"use strict";t.__esModule=!0;t.QuantcastService=function(){function e(t){babelHelpers.classCallCheck(this,e),this.quantcastTracker=t,this._previousPageNumbers=[],this._timeoutId=null}return e.prototype.destroy=function(){window.clearTimeout(this._timeoutId)},e.prototype.onDocumentLoaded=function(e,t){this._previousPageNumbers=t,this.quantcastTracker.track()},e.prototype.onPageChanged=function(e){var t=this;this._previousPageNumbers.join()!==e.join()&&(this._previousPageNumbers=e,window.clearTimeout(this._timeoutId),this._timeoutId=window.setTimeout(function(){t._previousPageNumbers.forEach(function(e){t.quantcastTracker.track()})},1e3))},e}()},function(e,t,n){"use strict";function r(e){return Math.pow(2,Math.ceil(Math.log2(e)))}t.__esModule=!0,t.DrawWebgl=t.Draw2d=void 0;var o=n(108),i=t.Draw2d=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.hintMaxWidth=t,this.hintMaxHeight=n}return e.prototype.draw=function(e,t,n,r,i,a,s){var u=e;if(!u||u.canvas.width!==r||u.canvas.height!==i){var l=u?u.canvas:document.createElement("canvas");l.width=r,l.height=i,u=l.getContext("2d",{alpha:!a})}return u&&u.canvas&&(u.canvas.id="reader3-canvas-"+t.page+"-"+r+"x"+i+(a?"-preview":""),(0,o.renderLayers)(u,n,t,s)),u},e.prototype.release=function(e){e.canvas.width=0,e.canvas.height=0,e.canvas.id=(e.canvas.id||"")+"DELETED"},e.prototype.getSurface=function(e){return e.canvas},e}();t.DrawWebgl=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this.gl=t,this.draw2d=new i(n,r)}return e.prototype.draw=function(e,t,n,o,i,a,s){var u=this.gl,l=this.draw2d.draw(null,t,n,o,i,a,s),c=l,p=this.draw2d.getSurface(c),d=r(Math.max(p.width,p.height)),f=a?p.width:d,h=a?p.height:d,m=u.getParameter(u.MAX_TEXTURE_SIZE);if(f>m||h>m)throw new Error("Requested creation of too large texture of size "+f+"x"+h+". maxTextureSize: "+m);var g=e?e.texture:u.createTexture();if(u.pixelStorei(u.UNPACK_FLIP_Y_WEBGL,!0),u.bindTexture(u.TEXTURE_2D,g),e&&e.width===f&&e.height===h||u.texImage2D(u.TEXTURE_2D,0,u.RGBA,f,h,0,u.RGBA,u.UNSIGNED_BYTE,null),u.texSubImage2D(u.TEXTURE_2D,0,0,0,u.RGBA,u.UNSIGNED_BYTE,p),u.getError()!==u.NO_ERROR)throw new Error("GL_ERROR: ("+u.getError()+") from gl.texSubImage2D");return u.texParameteri(u.TEXTURE_2D,u.TEXTURE_MAG_FILTER,u.LINEAR),u.texParameteri(u.TEXTURE_2D,u.TEXTURE_WRAP_S,u.CLAMP_TO_EDGE),u.texParameteri(u.TEXTURE_2D,u.TEXTURE_WRAP_T,u.CLAMP_TO_EDGE),a?u.texParameteri(u.TEXTURE_2D,u.TEXTURE_MIN_FILTER,u.NEAREST):(u.texParameteri(u.TEXTURE_2D,u.TEXTURE_MIN_FILTER,u.LINEAR_MIPMAP_LINEAR),u.generateMipmap(u.TEXTURE_2D)),u.bindTexture(u.TEXTURE_2D,null),this.draw2d.release(c),{texture:g,width:f,height:h,imgWidth:o,imgHeight:i}},e.prototype.release=function(e){this.gl.deleteTexture(e.texture)},e.prototype.getSurface=function(e){return{texture:e.texture,width:e.width,height:e.height,imgWidth:e.imgWidth,imgHeight:e.imgHeight}},e}()},function(e,t,n){"use strict";t.__esModule=!0;t.TrackingService=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this._isTrackerReady=!1,this._interactedWithReader=!1,this._previousPages=[],this._previousZoom=1,this.tracker=t,this.streamData=n.streamData,this.isEmbed=n.isEmbed,this.adpageId=n.adpageId,this.embedId=r}return e.prototype.monitor=function(e,t){var n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=Object.assign({type:e},t);n?this.tracker.monitor(r):this.tracker.monitorBatched(r)},e.prototype.onDocumentLoaded=function(e,t){this._previousPages=t,this._isTrackerReady=!0,this.tracker.documentLoad({isEmbed:this.isEmbed,isFullscreen:!1,revisionId:e.revisionId,publicationId:e.publicationId,publicationName:e.documentName,ownerUsername:e.username,pages:t,pageNumber:t[0],embedId:this.embedId,adpageId:this.adpageId,streamOrigin:this.streamData.origin,streamRanking:this.streamData.ranking})},e.prototype.onActivity=function(e){this._isTrackerReady&&e&&!this._interactedWithReader&&(this._interactedWithReader=!0,this.tracker.userInteracted())},e.prototype.onPageChanged=function(e){this._isTrackerReady&&0!==e.length&&this._previousPages.join()!==e.join()&&(this._previousPages=e,this.tracker.pageChange({pages:e,pageNumber:e[0]}))},e.prototype.onZoom=function(e){this._isTrackerReady&&this._previousZoom!==e&&(this._previousZoom=e,this.tracker.zoom())},e.prototype.onResize=function(e,t){this._isTrackerReady&&this.tracker.resize({displaySize:e,isFullscreen:t})},e.prototype.onDownload=function(e){this.tracker.documentDownload({anonymous:!0,revisionId:e.revisionId,publicationId:e.publicationId,publicationName:e.documentName,ownerUsername:e.username})},e.prototype.onClippingActionGotoPage=function(e){this._isTrackerReady&&this.tracker.clippingAction({clippingId:e.clippingId,action:"gotoPage",onPage:e.page.pageNumber,page:e.pageNumber,creator:"publisher"})},e.prototype.onClippingActionOpenUrl=function(e){this._isTrackerReady&&this.tracker.clippingAction({clippingId:e.clippingId,action:"openUrl",onPage:e.page.pageNumber,creator:"publisher",url:e.url})},e}()},function(e,t,n){"use strict";t.__esModule=!0,t.insightTracking=void 0;var r=n(111),o=n(19),i=n(93),a=n(11),s=babelHelpers.interopRequireWildcard(a);t.insightTracking=function(e,t){var n={};return n[o.types.DOCUMENTLOAD_SUCCESS]=function(t,n,r){if(e.isEmbed){var o={};o[s.selectReaderSize(n)]=1,e.monitor("reader3-embed-size",o,!1)}},n[i.types.ENTER_FULLSCREEN]=function(t,n,r){e.monitor("reader3-fullscreen-method."+r.fullscreenMethod,{count:1})},(0,r.trackingMiddlewarePrototype)(n,t)}},function(e,t,n){"use strict";t.__esModule=!0,t.loadingTracking=void 0;var r=n(19),o=n(111);t.loadingTracking=function(e,t){var n={};return n[r.types.DOCUMENTLOAD_SUCCESS]=function(t,n,r){e.onDocumentLoadSuccess(r.timeStamp-n.loading.loadStartTime)},n[r.types.DOCUMENTLOAD_FAILURE]=function(t,n,r){e.onDocumentLoadFailure(r.timeStamp-n.loading.loadStartTime,r.error)},n[r.types.DYNAMIC_API_FAILURE]=function(t,n,r){e.onDynamicApiLoadComplete(r.loadTime,r.error)},n[r.types.DYNAMIC_API_SUCCESS]=function(t,n,r){e.onDynamicApiLoadComplete(r.loadTime)},n[r.types.READ_MORE_LOAD_SUCCESS]=function(t,n,r){e.onReadMoreLoadComplete(!0)},n[r.types.READ_MORE_LOAD_FAILURE]=function(t,n,r){e.onReadMoreLoadComplete(!1)},(0,o.trackingMiddlewarePrototype)(n,t)}},function(e,t,n){"use strict";t.__esModule=!0,t.performanceTracking=void 0;var r=n(8),o=n(111),i=n(745);t.performanceTracking=function(e,t){var n="unknownDevice",a="unknownBrowser";try{var s=(new i).getResult();n=s.device.type||"desktop",a=s.browser.name||"unknownBrowser"}catch(e){}n=n.replace(" ","_"),a=a.replace(" ","_");var u={};return u[r.types.TRACK_DROPPED_FRAMES]=function(t,r,o){var i={dropped:Math.round(o.droppedFrames),dropped_per_sec:Math.round(Math.min(o.droppedFrames/o.duration*1e3,o.droppedFrames)),duration_in_ms:Math.round(o.duration),webgl:o.usesWebGl};e.monitor("reader3-dropped-frames",i,!1),e.monitor("reader3-dropped-frames.browser."+a,i,!1),e.monitor("reader3-dropped-frames.device."+n,i,!1)},(0,o.trackingMiddlewarePrototype)(u,t)}},function(e,t,n){"use strict";t.__esModule=!0,t.readerTracking=void 0;var r=n(63),o=n(8),i=n(194),a=n(129),s=n(19),u=n(110),l=n(11),c=babelHelpers.interopRequireWildcard(l),p=n(111);t.readerTracking=function(e,t){var n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],l=[],d={};d[o.types.SET_INTERACTED_WITH_READER]=function(t,n,r){e.onActivity(n.reader.interactedWithReader)},d[o.types.READER_ZOOM_LEVEL_CHANCED]=function(t,n,r){e.onZoom(n.reader.zoomLevel)},d[a.types.DOWNLOAD_SUCCESS]=function(t,n,r){e.onDownload(n.documentModel)},d[o.types.READER_POSITION_CHANGED]=function(t,n,r){if(n.reader.isReady){var o=t.reader.currentPages,i=n.reader.currentPages;o[0]===i[0]&&o[1]===i[1]||e.onPageChanged(i.map(function(e){return e.pageNumber}))}},d[s.types.DOCUMENTLOAD_SUCCESS]=function(t,n,r){var o=c.selectCurrentPageNumbers(n);e.onDocumentLoaded(n.documentModel,o)},d[u.RESIZE]=function(t,n,r){n.reader.isReady&&e.onResize(r.width+"x"+r.height,c.selectFullscreenEnabled(n))},d[i.types.GOTO_PAGE]=function(t,n,r){e.onClippingActionGotoPage(r.linkModel)},d[i.types.OPEN_URL]=function(t,n,r){e.onClippingActionOpenUrl(r.linkModel)};var f={};if(n)for(var h=Object.keys(d),m=Array.isArray(h),g=0,h=m?h:h[Symbol.iterator]();;){var v;if(m){if(g>=h.length)break;v=h[g++]}else{if(g=h.next(),g.done)break;v=g.value}var b=v;f[b]=d[b]}else f[s.types.DOCUMENTLOAD_SUCCESS]=function(t,n,r){var o=c.selectCurrentPageNumbers(n);l.push(function(){return e.onDocumentLoaded(n.documentModel,o)})},f[r.types.ENABLE_TRACKING]=function(e,t,n){for(var r=l,o=Array.isArray(r),i=0,r=o?r:r[Symbol.iterator]();;){var a;if(o){if(i>=r.length)break;a=r[i++]}else{if(i=r.next(),i.done)break;a=i.value}a()}for(var s=Object.keys(d),u=Array.isArray(s),c=0,s=u?s:s[Symbol.iterator]();;){var p;if(u){if(c>=s.length)break;p=s[c++]}else{if(c=s.next(),c.done)break;p=c.value}var h=p;f[h]=d[h]}};return(0,p.trackingMiddlewarePrototype)(f,t)}},function(e,t,n){"use strict";t.__esModule=!0,t.InteractionDetector=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.target=t,this.callback=n,this._eventHandler=this._eventHandler.bind(this),this.target.addEventListener("mousedown",this._eventHandler,!0),this.target.addEventListener("touchstart",this._eventHandler,!0),this.target.addEventListener("pointerdown",this._eventHandler,!0),this.target.addEventListener("MSPointerDown",this._eventHandler,!0),this.target.addEventListener("gesturestart",this._eventHandler,!0),this.target.addEventListener("wheel",this._eventHandler,!0),this.target.ownerDocument.addEventListener("keydown",this._eventHandler,!0)}return e.prototype._eventHandler=function(e){("wheel"!==e.type||e.ctrlKey)&&this.callback()},e.prototype.destroy=function(){this.target.removeEventListener("mousedown",this._eventHandler,!0),this.target.removeEventListener("touchstart",this._eventHandler,!0),this.target.removeEventListener("pointerdown",this._eventHandler,!0),this.target.removeEventListener("MSPointerDown",this._eventHandler,!0),this.target.removeEventListener("gesturestart",this._eventHandler,!0),this.target.removeEventListener("wheel",this._eventHandler,!0),this.target.ownerDocument.removeEventListener("keydown",this._eventHandler,!0)},e}()},function(e,t,n){"use strict";function r(e){var t=void 0===e?"undefined":babelHelpers.typeof(e);return"function"===t?s.test(i.call(e)):e&&"object"===t&&a.test(o.call(e))||!1}t.__esModule=!0;var o=Object.prototype.toString,i=Function.prototype.toString,a=/^\[object .+?Constructor\]$/,s=RegExp("^"+String(o).replace(/[.*+?^${}()|[\]\/\\]/g,"\\$&").replace(/toString|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");t.isNative=r},function(e,t,n){"use strict";function r(e,t,n,r){var i=t?1:-1,a=n.map(function(e){return(0,o.pageNumberToSpreadIndex)(r,e)}),s=Array.from(new Set(a)).sort(function(e,t){return e-t});if(s.includes(e))for(;s.includes(e+i);)i+=t?1:-1;return e+i}t.__esModule=!0,t.getTargetSpreadIndex=r;var o=n(59)},function(e,t,n){"use strict";function r(e,t,n){var r=e.createShader(n);if(e.shaderSource(r,t),e.compileShader(r),!e.getShaderParameter(r,e.COMPILE_STATUS))throw new Error("Cannot compile "+n+" shader: "+e.getShaderInfoLog(r));return r}function o(e,t){var n=e.getExtension(t);if(!n)throw new Error("does not support extension ");return n}function i(e,t,n,r,o){if(e.checkFramebufferStatus(e.FRAMEBUFFER)!==e.FRAMEBUFFER_COMPLETE)throw new Error("cannot read from framebuffer");var i=new Uint8Array(u*u*4);e.readPixels(0,0,u,u,e.RGBA,e.UNSIGNED_BYTE,i);for(var a=0;a<u*u;a++){var s=i.subarray(4*a,4*(a+1));if(s[0]!==t||s[1]!==n||s[2]!==r||s[3]!==o)return!1}return!0}function a(e){[].push(o(e,"OES_standard_derivatives"));var t=e.createProgram(),n=r(e,c,e.VERTEX_SHADER),a=r(e,l,e.FRAGMENT_SHADER);if(e.attachShader(t,n),e.attachShader(t,a),e.linkProgram(t),!e.getProgramParameter(t,e.LINK_STATUS))throw new Error("Cannot link shaderprogram: "+e.getProgramInfoLog(t));e.enableVertexAttribArray(e.getAttribLocation(t,"vertex"));var s=e.createBuffer();e.bindBuffer(e.ARRAY_BUFFER,s),e.bufferData(e.ARRAY_BUFFER,new Float32Array([0,0,0,1,1,0,1,1]),e.STATIC_DRAW),e.vertexAttribPointer(t.vertex,2,e.FLOAT,!1,0,0);var p=e.createTexture();e.bindTexture(e.TEXTURE_2D,p),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),e.texImage2D(e.TEXTURE_2D,0,e.RGBA,u,u,0,e.RGBA,e.UNSIGNED_BYTE,null);var d=e.createFramebuffer();if(e.bindFramebuffer(e.FRAMEBUFFER,d),e.framebufferTexture2D(e.FRAMEBUFFER,e.COLOR_ATTACHMENT0,e.TEXTURE_2D,p,0),e.viewport(0,0,u,u),e.useProgram(t),e.drawArrays(e.TRIANGLE_STRIP,0,4),!i(e,255,0,0,255))throw new Error("did not render correct color (frontfacing)");if(e.bufferData(e.ARRAY_BUFFER,new Float32Array([0,1,0,0,1,1,1,0]),e.STATIC_DRAW),e.drawArrays(e.TRIANGLE_STRIP,0,4),!i(e,0,0,255,255))throw new Error("did not render correct color (backfacing)");e.bindFramebuffer(e.FRAMEBUFFER,null),e.bindTexture(e.TEXTURE_2D,null),e.bindBuffer(e.ARRAY_BUFFER,null),e.deleteFramebuffer(d),e.deleteTexture(p),e.deleteBuffer(s),e.detachShader(t,n),e.deleteShader(n),e.detachShader(t,a),e.deleteShader(a),e.deleteProgram(t)}t.__esModule=!0,t.WebGLFeatureTests=void 0;var s=n(140),u=16,l="\n#extension GL_OES_standard_derivatives : require\nprecision highp float;\nvarying vec3 v[8];\nvoid main(void) {\n    vec3 d = smoothstep(0.0, v[3].x, dFdx(vec3(v[1])) * fwidth(v[2])); // Undeclared identifier 'dFdx'\n    if (gl_FrontFacing) { // This hardware is unable to support gl_FrontFacing\n        gl_FragColor = vec4(1, d.x, 0, 1);\n    } else {\n        gl_FragColor = vec4(0, d.x, 1, 1);\n    }\n}\n",c="\nprecision highp float;\nattribute vec2 vertex;\nvarying vec3 v[8];\nvoid main(void) {\n    v[0] = vec3(0); // Maximum varying vector count exceeded\n    v[1] = vec3(1); // Maximum varying vector count exceeded\n    v[2] = vec3(2); // Maximum varying vector count exceeded\n    v[3] = vec3(3); // Maximum varying vector count exceeded\n    v[4] = vec3(4); // Maximum varying vector count exceeded\n    v[5] = vec3(5); // Maximum varying vector count exceeded\n    v[6] = vec3(6); // Maximum varying vector count exceeded\n    v[7] = vec3(7); // Maximum varying vector count exceeded\n\n    vec2 p = 2.0 * vertex - 1.0;\n    gl_Position = vec4(p.x, -p.y, 0.0, 1.0);\n}\n";t.WebGLFeatureTests=function(){function e(){babelHelpers.classCallCheck(this,e)}return e.isWebGLSupported=function(){try{var e=(0,s.getWebGLContext)(document.createElement("canvas"));return!!e&&(a(e),!0)}catch(e){return!1}},e}()},function(e,t){e.exports='<svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">\n  <path d="M12.052 16c.243 0 .484-.092.67-.275.37-.367.37-.963 0-1.33L6.284 8l6.438-6.395c.37-.368.37-.963 0-1.33-.37-.367-.97-.367-1.338 0l-7.108 7.06c-.37.366-.37.962 0 1.33l7.106 7.06c.185.183.427.275.67.275" fill="#FFFFFF" fill-rule="evenodd"/>\n</svg>\n'},function(e,t){e.exports='<svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">\n  <path d="M4.948 16c-.243 0-.484-.092-.67-.275-.37-.367-.37-.963 0-1.33L10.716 8 4.277 1.604c-.37-.368-.37-.963 0-1.33.37-.367.97-.367 1.338 0l7.108 7.06c.37.366.37.962 0 1.33l-7.106 7.06c-.185.183-.427.275-.67.275" fill="#FFFFFF" fill-rule="evenodd"/>\n</svg>\n'},function(e,t){e.exports='<svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">\n  <path d="M6.446 8L.322 14.124c-.43.43-.43 1.126 0 1.555.215.213.496.32.777.32.28 0 .562-.107.776-.32L8 9.554l6.124 6.124c.214.213.496.32.777.32.282 0 .563-.107.778-.32.43-.43.43-1.126 0-1.556L9.554 8l6.124-6.124c.43-.43.43-1.125 0-1.554-.43-.43-1.125-.43-1.554 0L8 6.446 1.876.322c-.43-.43-1.125-.43-1.554 0-.43.43-.43 1.125 0 1.554L6.446 8z" fill="#FFFFFF" fill-rule="evenodd"/>\n</svg>\n'},function(e,t){e.exports='<svg width="100%" height="100%" viewBox="-9 -9 34 34" xmlns="http://www.w3.org/2000/svg">\n  <path d="M6.29 12.58c3.474 0 6.29-2.816 6.29-6.29S9.765 0 6.29 0 0 2.816 0 6.29s2.816 6.29 6.29 6.29zm0-1.677c2.548 0 4.613-2.065 4.613-4.613 0-2.548-2.065-4.613-4.613-4.613-2.548 0-4.613 2.065-4.613 4.613 0 2.548 2.065 4.613 4.613 4.613zm4.665 1.83c-.492-.49-.496-1.284 0-1.78.49-.49 1.287-.49 1.78.002l2.895 2.895c.49.492.495 1.286 0 1.78-.49.492-1.288.49-1.78 0l-2.895-2.896zm-3.18-3.507L7.34 7.8H5.157l-.436 1.426H3.355l2.113-6.012H7.02l2.122 6.012H7.775zm-.738-2.49c-.403-1.29-.627-2.022-.678-2.19-.05-.17-.088-.304-.11-.403-.09.35-.348 1.214-.774 2.592h1.56z" class="shadow" fill-rule="evenodd" />\n  <path d="M6.29 12.58c3.474 0 6.29-2.816 6.29-6.29S9.765 0 6.29 0 0 2.816 0 6.29s2.816 6.29 6.29 6.29zm0-1.677c2.548 0 4.613-2.065 4.613-4.613 0-2.548-2.065-4.613-4.613-4.613-2.548 0-4.613 2.065-4.613 4.613 0 2.548 2.065 4.613 4.613 4.613zm4.665 1.83c-.492-.49-.496-1.284 0-1.78.49-.49 1.287-.49 1.78.002l2.895 2.895c.49.492.495 1.286 0 1.78-.49.492-1.288.49-1.78 0l-2.895-2.896zm-3.18-3.507L7.34 7.8H5.157l-.436 1.426H3.355l2.113-6.012H7.02l2.122 6.012H7.775zm-.738-2.49c-.403-1.29-.627-2.022-.678-2.19-.05-.17-.088-.304-.11-.403-.09.35-.348 1.214-.774 2.592h1.56z" class="icon" fill-rule="evenodd"/>\n</svg>\n'},function(e,t,n){n(415),e.exports=n(49).RegExp.escape},function(e,t,n){var r=n(9),o=n(149),i=n(12)("species");e.exports=function(e){var t;return o(e)&&(t=e.constructor,"function"!=typeof t||t!==Array&&!o(t.prototype)||(t=void 0),r(t)&&null===(t=t[i])&&(t=void 0)),void 0===t?Array:t}},function(e,t,n){var r=n(407);e.exports=function(e,t){return new(r(e))(t)}},function(e,t,n){"use strict";var r=n(3),o=n(44);e.exports=function(e){if("string"!==e&&"number"!==e&&"default"!==e)throw TypeError("Incorrect hint");return o(r(this),"number"!=e)}},function(e,t,n){var r=n(68),o=n(120),i=n(100);e.exports=function(e){var t=r(e),n=o.f;if(n)for(var a,s=n(e),u=i.f,l=0;s.length>l;)u.call(e,a=s[l++])&&t.push(a);return t}},function(e,t,n){var r=n(68),o=n(28);e.exports=function(e,t){for(var n,i=o(e),a=r(i),s=a.length,u=0;s>u;)if(i[n=a[u++]]===t)return n}},function(e,t,n){"use strict";var r=n(413),o=n(116),i=n(24);e.exports=function(){for(var e=i(this),t=arguments.length,n=Array(t),a=0,s=r._,u=!1;t>a;)(n[a]=arguments[a++])===s&&(u=!0);return function(){var r,i=this,a=arguments.length,l=0,c=0;if(!u&&!a)return o(e,n,i);if(r=n.slice(),u)for(;t>l;l++)r[l]===s&&(r[l]=arguments[c++]);for(;a>c;)r.push(arguments[c++]);return o(e,r,i)}}},function(e,t,n){e.exports=n(4)},function(e,t){e.exports=function(e,t){var n=t===Object(t)?function(e){return t[e]}:t;return function(t){return String(t).replace(e,n)}}},function(e,t,n){var r=n(0),o=n(414)(/[\\^$*+?.()|[\]{}]/g,"\\$&");r(r.S,"RegExp",{escape:function(e){return o(e)}})},function(e,t,n){var r=n(0);r(r.P,"Array",{copyWithin:n(224)}),n(80)("copyWithin")},function(e,t,n){"use strict";var r=n(0),o=n(42)(4);r(r.P+r.F*!n(38)([].every,!0),"Array",{every:function(e){return o(this,e,arguments[1])}})},function(e,t,n){var r=n(0);r(r.P,"Array",{fill:n(141)}),n(80)("fill")},function(e,t,n){"use strict";var r=n(0),o=n(42)(2);r(r.P+r.F*!n(38)([].filter,!0),"Array",{filter:function(e){return o(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(0),o=n(42)(6),i="findIndex",a=!0;i in[]&&Array(1)[i](function(){a=!1}),r(r.P+r.F*a,"Array",{findIndex:function(e){return o(this,e,arguments.length>1?arguments[1]:void 0)}}),n(80)(i)},function(e,t,n){"use strict";var r=n(0),o=n(42)(5),i=!0;"find"in[]&&Array(1).find(function(){i=!1}),r(r.P+r.F*i,"Array",{find:function(e){return o(this,e,arguments.length>1?arguments[1]:void 0)}}),n(80)("find")},function(e,t,n){"use strict";var r=n(0),o=n(42)(0);r(r.P+r.F*!n(38)([].forEach,!0),"Array",{forEach:function(e){return o(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(50),o=n(0),i=n(18),a=n(233),s=n(148),u=n(17),l=n(142),c=n(165);o(o.S+o.F*!n(118)(function(e){Array.from(e)}),"Array",{from:function(e){var t,n,o,p,d=i(e),f="function"==typeof this?this:Array,h=arguments.length,m=h>1?arguments[1]:void 0,g=void 0!==m,v=0,b=c(d);if(g&&(m=r(m,h>2?arguments[2]:void 0,2)),void 0==b||f==Array&&s(b))for(t=u(d.length),n=new f(t);t>v;v++)l(n,v,g?m(d[v],v):d[v]);else for(p=b.call(d),n=new f;!(o=p.next()).done;v++)l(n,v,g?a(p,m,[o.value,v],!0):o.value);return n.length=v,n}})},function(e,t,n){"use strict";var r=n(0),o=n(112)(!1),i=[].indexOf,a=!!i&&1/[1].indexOf(1,-0)<0;r(r.P+r.F*(a||!n(38)(i)),"Array",{indexOf:function(e){return a?i.apply(this,arguments)||0:o(this,e,arguments[1])}})},function(e,t,n){var r=n(0);r(r.S,"Array",{isArray:n(149)})},function(e,t,n){"use strict";var r=n(0),o=n(28),i=[].join;r(r.P+r.F*(n(99)!=Object||!n(38)(i)),"Array",{join:function(e){return i.call(o(this),void 0===e?",":e)}})},function(e,t,n){"use strict";var r=n(0),o=n(28),i=n(62),a=n(17),s=[].lastIndexOf,u=!!s&&1/[1].lastIndexOf(1,-0)<0;r(r.P+r.F*(u||!n(38)(s)),"Array",{lastIndexOf:function(e){if(u)return s.apply(this,arguments)||0;var t=o(this),n=a(t.length),r=n-1;for(arguments.length>1&&(r=Math.min(r,i(arguments[1]))),r<0&&(r=n+r);r>=0;r--)if(r in t&&t[r]===e)return r||0;return-1}})},function(e,t,n){"use strict";var r=n(0),o=n(42)(1);r(r.P+r.F*!n(38)([].map,!0),"Array",{map:function(e){return o(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(0),o=n(142);r(r.S+r.F*n(6)(function(){function e(){}return!(Array.of.call(e)instanceof e)}),"Array",{of:function(){for(var e=0,t=arguments.length,n=new("function"==typeof this?this:Array)(t);t>e;)o(n,e,arguments[e++]);return n.length=t,n}})},function(e,t,n){"use strict";var r=n(0),o=n(226);r(r.P+r.F*!n(38)([].reduceRight,!0),"Array",{reduceRight:function(e){return o(this,e,arguments.length,arguments[1],!0)}})},function(e,t,n){"use strict";var r=n(0),o=n(226);r(r.P+r.F*!n(38)([].reduce,!0),"Array",{reduce:function(e){return o(this,e,arguments.length,arguments[1],!1)}})},function(e,t,n){"use strict";var r=n(0),o=n(146),i=n(36),a=n(71),s=n(17),u=[].slice;r(r.P+r.F*n(6)(function(){o&&u.call(o)}),"Array",{slice:function(e,t){var n=s(this.length),r=i(this);if(t=void 0===t?n:t,"Array"==r)return u.call(this,e,t);for(var o=a(e,n),l=a(t,n),c=s(l-o),p=Array(c),d=0;d<c;d++)p[d]="String"==r?this.charAt(o+d):this[o+d];return p}})},function(e,t,n){"use strict";var r=n(0),o=n(42)(3);r(r.P+r.F*!n(38)([].some,!0),"Array",{some:function(e){return o(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(0),o=n(24),i=n(18),a=n(6),s=[].sort,u=[1,2,3];r(r.P+r.F*(a(function(){u.sort(void 0)})||!a(function(){u.sort(null)})||!n(38)(s)),"Array",{sort:function(e){return void 0===e?s.call(i(this)):s.call(i(this),o(e))}})},function(e,t,n){n(70)("Array")},function(e,t,n){var r=n(0);r(r.S,"Date",{now:function(){return(new Date).getTime()}})},function(e,t,n){"use strict";var r=n(0),o=n(6),i=Date.prototype.getTime,a=function(e){return e>9?e:"0"+e};r(r.P+r.F*(o(function(){return"0385-07-25T07:06:39.999Z"!=new Date(-5e13-1).toISOString()})||!o(function(){new Date(NaN).toISOString()})),"Date",{toISOString:function(){if(!isFinite(i.call(this)))throw RangeError("Invalid time value");var e=this,t=e.getUTCFullYear(),n=e.getUTCMilliseconds(),r=t<0?"-":t>9999?"+":"";return r+("00000"+Math.abs(t)).slice(r?-6:-4)+"-"+a(e.getUTCMonth()+1)+"-"+a(e.getUTCDate())+"T"+a(e.getUTCHours())+":"+a(e.getUTCMinutes())+":"+a(e.getUTCSeconds())+"."+(n>99?n:"0"+a(n))+"Z"}})},function(e,t,n){"use strict";var r=n(0),o=n(18),i=n(44);r(r.P+r.F*n(6)(function(){return null!==new Date(NaN).toJSON()||1!==Date.prototype.toJSON.call({toISOString:function(){return 1}})}),"Date",{toJSON:function(e){var t=o(this),n=i(t);return"number"!=typeof n||isFinite(n)?t.toISOString():null}})},function(e,t,n){var r=n(12)("toPrimitive"),o=Date.prototype;r in o||n(25)(o,r,n(409))},function(e,t,n){var r=Date.prototype,o=r.toString,i=r.getTime;new Date(NaN)+""!="Invalid Date"&&n(26)(r,"toString",function(){var e=i.call(this);return e===e?o.call(this):"Invalid Date"})},function(e,t,n){var r=n(0);r(r.P,"Function",{bind:n(227)})},function(e,t,n){"use strict";var r=n(9),o=n(31),i=n(12)("hasInstance"),a=Function.prototype;i in a||n(15).f(a,i,{value:function(e){if("function"!=typeof this||!r(e))return!1;if(!r(this.prototype))return e instanceof this;for(;e=o(e);)if(this.prototype===e)return!0;return!1}})},function(e,t,n){var r=n(15).f,o=n(61),i=n(22),a=Function.prototype,s=Object.isExtensible||function(){return!0};"name"in a||n(14)&&r(a,"name",{configurable:!0,get:function(){try{var e=this,t=(""+e).match(/^\s*function ([^ (]*)/)[1];return i(e,"name")||!s(e)||r(e,"name",o(5,t)),t}catch(e){return""}}})},function(e,t,n){var r=n(0),o=n(235),i=Math.sqrt,a=Math.acosh;r(r.S+r.F*!(a&&710==Math.floor(a(Number.MAX_VALUE))&&a(1/0)==1/0),"Math",{acosh:function(e){return(e=+e)<1?NaN:e>94906265.62425156?Math.log(e)+Math.LN2:o(e-1+i(e-1)*i(e+1))}})},function(e,t,n){function r(e){return isFinite(e=+e)&&0!=e?e<0?-r(-e):Math.log(e+Math.sqrt(e*e+1)):e}var o=n(0),i=Math.asinh;o(o.S+o.F*!(i&&1/i(0)>0),"Math",{asinh:r})},function(e,t,n){var r=n(0),o=Math.atanh;r(r.S+r.F*!(o&&1/o(-0)<0),"Math",{atanh:function(e){return 0==(e=+e)?e:Math.log((1+e)/(1-e))/2}})},function(e,t,n){var r=n(0),o=n(153);r(r.S,"Math",{cbrt:function(e){return o(e=+e)*Math.pow(Math.abs(e),1/3)}})},function(e,t,n){var r=n(0);r(r.S,"Math",{clz32:function(e){return(e>>>=0)?31-Math.floor(Math.log(e+.5)*Math.LOG2E):32}})},function(e,t,n){var r=n(0),o=Math.exp;r(r.S,"Math",{cosh:function(e){return(o(e=+e)+o(-e))/2}})},function(e,t,n){var r=n(0),o=n(152);r(r.S+r.F*(o!=Math.expm1),"Math",{expm1:o})},function(e,t,n){var r=n(0),o=n(153),i=Math.pow,a=i(2,-52),s=i(2,-23),u=i(2,127)*(2-s),l=i(2,-126),c=function(e){return e+1/a-1/a};r(r.S,"Math",{fround:function(e){var t,n,r=Math.abs(e),i=o(e);return r<l?i*c(r/l/s)*l*s:(t=(1+s/a)*r,n=t-(t-r),n>u||n!=n?i*(1/0):i*n)}})},function(e,t,n){var r=n(0),o=Math.abs;r(r.S,"Math",{hypot:function(e,t){for(var n,r,i=0,a=0,s=arguments.length,u=0;a<s;)n=o(arguments[a++]),u<n?(r=u/n,i=i*r*r+1,u=n):n>0?(r=n/u,i+=r*r):i+=n;return u===1/0?1/0:u*Math.sqrt(i)}})},function(e,t,n){var r=n(0),o=Math.imul;r(r.S+r.F*n(6)(function(){return o(4294967295,5)!=-5||2!=o.length}),"Math",{imul:function(e,t){var n=+e,r=+t,o=65535&n,i=65535&r;return 0|o*i+((65535&n>>>16)*i+o*(65535&r>>>16)<<16>>>0)}})},function(e,t,n){var r=n(0);r(r.S,"Math",{log10:function(e){return Math.log(e)/Math.LN10}})},function(e,t,n){var r=n(0);r(r.S,"Math",{log1p:n(235)})},function(e,t,n){var r=n(0);r(r.S,"Math",{log2:function(e){return Math.log(e)/Math.LN2}})},function(e,t,n){var r=n(0);r(r.S,"Math",{sign:n(153)})},function(e,t,n){var r=n(0),o=n(152),i=Math.exp;r(r.S+r.F*n(6)(function(){return!Math.sinh(-2e-17)!=-2e-17}),"Math",{sinh:function(e){return Math.abs(e=+e)<1?(o(e)-o(-e))/2:(i(e-1)-i(-e-1))*(Math.E/2)}})},function(e,t,n){var r=n(0),o=n(152),i=Math.exp;r(r.S,"Math",{tanh:function(e){var t=o(e=+e),n=o(-e);return t==1/0?1:n==1/0?-1:(t-n)/(i(e)+i(-e))}})},function(e,t,n){var r=n(0);r(r.S,"Math",{trunc:function(e){return(e>0?Math.floor:Math.ceil)(e)}})},function(e,t,n){"use strict";var r=n(4),o=n(22),i=n(36),a=n(147),s=n(44),u=n(6),l=n(67).f,c=n(30).f,p=n(15).f,d=n(84).trim,f=r.Number,h=f,m=f.prototype,g="Number"==i(n(66)(m)),v="trim"in String.prototype,b=function(e){var t=s(e,!1);if("string"==typeof t&&t.length>2){t=v?t.trim():d(t,3);var n,r,o,i=t.charCodeAt(0);if(43===i||45===i){if(88===(n=t.charCodeAt(2))||120===n)return NaN}else if(48===i){switch(t.charCodeAt(1)){case 66:case 98:r=2,o=49;break;case 79:case 111:r=8,o=55;break;default:return+t}for(var a,u=t.slice(2),l=0,c=u.length;l<c;l++)if((a=u.charCodeAt(l))<48||a>o)return NaN;return parseInt(u,r)}}return+t};if(!f(" 0o1")||!f("0b1")||f("+0x1")){f=function(e){var t=arguments.length<1?0:e,n=this;return n instanceof f&&(g?u(function(){m.valueOf.call(n)}):"Number"!=i(n))?a(new h(b(t)),n,f):b(t)};for(var y,_=n(14)?l(h):"MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,EPSILON,isFinite,isInteger,isNaN,isSafeInteger,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,parseFloat,parseInt,isInteger".split(","),E=0;_.length>E;E++)o(h,y=_[E])&&!o(f,y)&&p(f,y,c(h,y));f.prototype=m,m.constructor=f,n(26)(r,"Number",f)}},function(e,t,n){var r=n(0);r(r.S,"Number",{EPSILON:Math.pow(2,-52)})},function(e,t,n){var r=n(0),o=n(4).isFinite;r(r.S,"Number",{isFinite:function(e){return"number"==typeof e&&o(e)}})},function(e,t,n){var r=n(0);r(r.S,"Number",{isInteger:n(232)})},function(e,t,n){var r=n(0);r(r.S,"Number",{isNaN:function(e){return e!=e}})},function(e,t,n){var r=n(0),o=n(232),i=Math.abs;r(r.S,"Number",{isSafeInteger:function(e){return o(e)&&i(e)<=9007199254740991}})},function(e,t,n){var r=n(0);r(r.S,"Number",{MAX_SAFE_INTEGER:9007199254740991})},function(e,t,n){var r=n(0);r(r.S,"Number",{MIN_SAFE_INTEGER:-9007199254740991})},function(e,t,n){var r=n(0),o=n(242);r(r.S+r.F*(Number.parseFloat!=o),"Number",{parseFloat:o})},function(e,t,n){var r=n(0),o=n(243);r(r.S+r.F*(Number.parseInt!=o),"Number",{parseInt:o})},function(e,t,n){"use strict";var r=n(0),o=n(62),i=n(223),a=n(160),s=1..toFixed,u=Math.floor,l=[0,0,0,0,0,0],c="Number.toFixed: incorrect invocation!",p=function(e,t){for(var n=-1,r=t;++n<6;)r+=e*l[n],l[n]=r%1e7,r=u(r/1e7)},d=function(e){for(var t=6,n=0;--t>=0;)n+=l[t],l[t]=u(n/e),n=n%e*1e7},f=function(){for(var e=6,t="";--e>=0;)if(""!==t||0===e||0!==l[e]){var n=String(l[e]);t=""===t?n:t+a.call("0",7-n.length)+n}return t},h=function(e,t,n){return 0===t?n:t%2==1?h(e,t-1,n*e):h(e*e,t/2,n)},m=function(e){for(var t=0,n=e;n>=4096;)t+=12,n/=4096;for(;n>=2;)t+=1,n/=2;return t};r(r.P+r.F*(!!s&&("0.000"!==8e-5.toFixed(3)||"1"!==.9.toFixed(0)||"1.25"!==1.255.toFixed(2)||"1000000000000000128"!==(0xde0b6b3a7640080).toFixed(0))||!n(6)(function(){s.call({})})),"Number",{toFixed:function(e){var t,n,r,s,u=i(this,c),l=o(e),g="",v="0";if(l<0||l>20)throw RangeError(c);if(u!=u)return"NaN";if(u<=-1e21||u>=1e21)return String(u);if(u<0&&(g="-",u=-u),u>1e-21)if(t=m(u*h(2,69,1))-69,n=t<0?u*h(2,-t,1):u/h(2,t,1),n*=4503599627370496,(t=52-t)>0){for(p(0,n),r=l;r>=7;)p(1e7,0),r-=7;for(p(h(10,r,1),0),r=t-1;r>=23;)d(1<<23),r-=23;d(1<<r),p(1,1),d(2),v=f()}else p(0,n),p(1<<-t,0),v=f()+a.call("0",l);return l>0?(s=v.length,v=g+(s<=l?"0."+a.call("0",l-s)+v:v.slice(0,s-l)+"."+v.slice(s-l))):v=g+v,v}})},function(e,t,n){"use strict";var r=n(0),o=n(6),i=n(223),a=1..toPrecision;r(r.P+r.F*(o(function(){return"1"!==a.call(1,void 0)})||!o(function(){a.call({})})),"Number",{toPrecision:function(e){var t=i(this,"Number#toPrecision: incorrect invocation!");return void 0===e?a.call(t):a.call(t,e)}})},function(e,t,n){var r=n(0);r(r.S+r.F,"Object",{assign:n(236)})},function(e,t,n){var r=n(0);r(r.S,"Object",{create:n(66)})},function(e,t,n){var r=n(0);r(r.S+r.F*!n(14),"Object",{defineProperties:n(237)})},function(e,t,n){var r=n(0);r(r.S+r.F*!n(14),"Object",{defineProperty:n(15).f})},function(e,t,n){var r=n(9),o=n(60).onFreeze;n(43)("freeze",function(e){return function(t){return e&&r(t)?e(o(t)):t}})},function(e,t,n){var r=n(28),o=n(30).f;n(43)("getOwnPropertyDescriptor",function(){return function(e,t){return o(r(e),t)}})},function(e,t,n){n(43)("getOwnPropertyNames",function(){return n(238).f})},function(e,t,n){var r=n(18),o=n(31);n(43)("getPrototypeOf",function(){return function(e){return o(r(e))}})},function(e,t,n){var r=n(9);n(43)("isExtensible",function(e){return function(t){return!!r(t)&&(!e||e(t))}})},function(e,t,n){var r=n(9);n(43)("isFrozen",function(e){return function(t){return!r(t)||!!e&&e(t)}})},function(e,t,n){var r=n(9);n(43)("isSealed",function(e){return function(t){return!r(t)||!!e&&e(t)}})},function(e,t,n){var r=n(0);r(r.S,"Object",{is:n(244)})},function(e,t,n){var r=n(18),o=n(68);n(43)("keys",function(){return function(e){return o(r(e))}})},function(e,t,n){var r=n(9),o=n(60).onFreeze;n(43)("preventExtensions",function(e){return function(t){return e&&r(t)?e(o(t)):t}})},function(e,t,n){var r=n(9),o=n(60).onFreeze;n(43)("seal",function(e){return function(t){return e&&r(t)?e(o(t)):t}})},function(e,t,n){var r=n(0);r(r.S,"Object",{setPrototypeOf:n(155).set})},function(e,t,n){"use strict";var r=n(98),o={};o[n(12)("toStringTag")]="z",o+""!="[object z]"&&n(26)(Object.prototype,"toString",function(){return"[object "+r(this)+"]"},!0)},function(e,t,n){var r=n(0),o=n(242);r(r.G+r.F*(parseFloat!=o),{parseFloat:o})},function(e,t,n){var r=n(0),o=n(243);r(r.G+r.F*(parseInt!=o),{parseInt:o})},function(e,t,n){"use strict";var r,o,i,a=n(65),s=n(4),u=n(50),l=n(98),c=n(0),p=n(9),d=n(24),f=n(64),h=n(81),m=n(157),g=n(162).set,v=n(154)(),b=s.TypeError,y=s.process,_=s.Promise,y=s.process,E="process"==l(y),w=function(){},S=!!function(){try{var e=_.resolve(1),t=(e.constructor={})[n(12)("species")]=function(e){e(w,w)};return(E||"function"==typeof PromiseRejectionEvent)&&e.then(w)instanceof t}catch(e){}}(),x=function(e,t){return e===t||e===_&&t===i},T=function(e){var t;return!(!p(e)||"function"!=typeof(t=e.then))&&t},C=function(e){return x(_,e)?new I(e):new o(e)},I=o=function(e){var t,n;this.promise=new e(function(e,r){if(void 0!==t||void 0!==n)throw b("Bad Promise constructor");t=e,n=r}),this.resolve=d(t),this.reject=d(n)},R=function(e){try{e()}catch(e){return{error:e}}},M=function(e,t){if(!e._n){e._n=!0;var n=e._c;v(function(){for(var r=e._v,o=1==e._s,i=0;n.length>i;)!function(t){var n,i,a=o?t.ok:t.fail,s=t.resolve,u=t.reject,l=t.domain;try{a?(o||(2==e._h&&A(e),e._h=1),a===!0?n=r:(l&&l.enter(),n=a(r),l&&l.exit()),n===t.promise?u(b("Promise-chain cycle")):(i=T(n))?i.call(n,s,u):s(n)):u(r)}catch(e){u(e)}}(n[i++]);e._c=[],e._n=!1,t&&!e._h&&P(e)})}},P=function(e){g.call(s,function(){var t,n,r,o=e._v;if(O(e)&&(t=R(function(){E?y.emit("unhandledRejection",o,e):(n=s.onunhandledrejection)?n({promise:e,reason:o}):(r=s.console)&&r.error&&r.error("Unhandled promise rejection",o)}),e._h=E||O(e)?2:1),e._a=void 0,t)throw t.error})},O=function(e){if(1==e._h)return!1;for(var t,n=e._a||e._c,r=0;n.length>r;)if(t=n[r++],t.fail||!O(t.promise))return!1;return!0},A=function(e){g.call(s,function(){var t;E?y.emit("rejectionHandled",e):(t=s.onrejectionhandled)&&t({promise:e,reason:e._v})})},D=function(e){var t=this;t._d||(t._d=!0,t=t._w||t,t._v=e,t._s=2,t._a||(t._a=t._c.slice()),M(t,!0))},k=function(e){var t,n=this;if(!n._d){n._d=!0,n=n._w||n;try{if(n===e)throw b("Promise can't be resolved itself");(t=T(e))?v(function(){var r={_w:n,_d:!1};try{t.call(e,u(k,r,1),u(D,r,1))}catch(e){D.call(r,e)}}):(n._v=e,n._s=1,M(n,!1))}catch(e){D.call({_w:n,_d:!1},e)}}};S||(_=function(e){f(this,_,"Promise","_h"),d(e),r.call(this);try{e(u(k,this,1),u(D,this,1))}catch(e){D.call(this,e)}},r=function(e){this._c=[],this._a=void 0,this._s=0,this._d=!1,this._v=void 0,this._h=0,this._n=!1},r.prototype=n(69)(_.prototype,{then:function(e,t){var n=C(m(this,_));return n.ok="function"!=typeof e||e,n.fail="function"==typeof t&&t,n.domain=E?y.domain:void 0,this._c.push(n),this._a&&this._a.push(n),this._s&&M(this,!1),n.promise},catch:function(e){return this.then(void 0,e)}}),I=function(){var e=new r;this.promise=e,this.resolve=u(k,e,1),this.reject=u(D,e,1)}),c(c.G+c.W+c.F*!S,{Promise:_}),n(83)(_,"Promise"),n(70)("Promise"),i=n(49).Promise,c(c.S+c.F*!S,"Promise",{reject:function(e){var t=C(this);return(0,t.reject)(e),t.promise}}),c(c.S+c.F*(a||!S),"Promise",{resolve:function(e){if(e instanceof _&&x(e.constructor,this))return e;var t=C(this);return(0,t.resolve)(e),t.promise}}),c(c.S+c.F*!(S&&n(118)(function(e){_.all(e).catch(w)})),"Promise",{all:function(e){var t=this,n=C(t),r=n.resolve,o=n.reject,i=R(function(){var n=[],i=0,a=1;h(e,!1,function(e){var s=i++,u=!1;n.push(void 0),a++,t.resolve(e).then(function(e){u||(u=!0,n[s]=e,--a||r(n))},o)}),--a||r(n)});return i&&o(i.error),n.promise},race:function(e){var t=this,n=C(t),r=n.reject,o=R(function(){h(e,!1,function(e){t.resolve(e).then(n.resolve,r)})});return o&&r(o.error),n.promise}})},function(e,t,n){var r=n(0),o=n(24),i=n(3),a=(n(4).Reflect||{}).apply,s=Function.apply;r(r.S+r.F*!n(6)(function(){a(function(){})}),"Reflect",{apply:function(e,t,n){var r=o(e),u=i(n);return a?a(r,t,u):s.call(r,t,u)}})},function(e,t,n){var r=n(0),o=n(66),i=n(24),a=n(3),s=n(9),u=n(6),l=n(227),c=(n(4).Reflect||{}).construct,p=u(function(){function e(){}return!(c(function(){},[],e)instanceof e)}),d=!u(function(){c(function(){})});r(r.S+r.F*(p||d),"Reflect",{construct:function(e,t){i(e),a(t);var n=arguments.length<3?e:i(arguments[2]);if(d&&!p)return c(e,t,n);if(e==n){switch(t.length){case 0:return new e;case 1:return new e(t[0]);case 2:return new e(t[0],t[1]);case 3:return new e(t[0],t[1],t[2]);case 4:return new e(t[0],t[1],t[2],t[3])}var r=[null];return r.push.apply(r,t),new(l.apply(e,r))}var u=n.prototype,f=o(s(u)?u:Object.prototype),h=Function.apply.call(e,f,t);return s(h)?h:f}})},function(e,t,n){var r=n(15),o=n(0),i=n(3),a=n(44);o(o.S+o.F*n(6)(function(){Reflect.defineProperty(r.f({},1,{value:1}),1,{value:2})}),"Reflect",{defineProperty:function(e,t,n){i(e),t=a(t,!0),i(n);try{return r.f(e,t,n),!0}catch(e){return!1}}})},function(e,t,n){var r=n(0),o=n(30).f,i=n(3);r(r.S,"Reflect",{deleteProperty:function(e,t){var n=o(i(e),t);return!(n&&!n.configurable)&&delete e[t]}})},function(e,t,n){"use strict";var r=n(0),o=n(3),i=function(e){this._t=o(e),this._i=0;var t,n=this._k=[];for(t in e)n.push(t)};n(150)(i,"Object",function(){var e,t=this,n=t._k;do{if(t._i>=n.length)return{value:void 0,done:!0}}while(!((e=n[t._i++])in t._t));return{value:e,done:!1}}),r(r.S,"Reflect",{enumerate:function(e){return new i(e)}})},function(e,t,n){var r=n(30),o=n(0),i=n(3);o(o.S,"Reflect",{getOwnPropertyDescriptor:function(e,t){return r.f(i(e),t)}})},function(e,t,n){var r=n(0),o=n(31),i=n(3);r(r.S,"Reflect",{getPrototypeOf:function(e){return o(i(e))}})},function(e,t,n){function r(e,t){var n,s,c=arguments.length<3?e:arguments[2];return l(e)===c?e[t]:(n=o.f(e,t))?a(n,"value")?n.value:void 0!==n.get?n.get.call(c):void 0:u(s=i(e))?r(s,t,c):void 0}var o=n(30),i=n(31),a=n(22),s=n(0),u=n(9),l=n(3);s(s.S,"Reflect",{get:r})},function(e,t,n){var r=n(0);r(r.S,"Reflect",{has:function(e,t){return t in e}})},function(e,t,n){var r=n(0),o=n(3),i=Object.isExtensible;r(r.S,"Reflect",{isExtensible:function(e){return o(e),!i||i(e)}})},function(e,t,n){var r=n(0);r(r.S,"Reflect",{ownKeys:n(241)})},function(e,t,n){var r=n(0),o=n(3),i=Object.preventExtensions;r(r.S,"Reflect",{preventExtensions:function(e){o(e);try{return i&&i(e),!0}catch(e){return!1}}})},function(e,t,n){var r=n(0),o=n(155);o&&r(r.S,"Reflect",{setPrototypeOf:function(e,t){o.check(e,t);try{return o.set(e,t),!0}catch(e){return!1}}})},function(e,t,n){function r(e,t,n){var u,d,f=arguments.length<4?e:arguments[3],h=i.f(c(e),t);if(!h){if(p(d=a(e)))return r(d,t,n,f);h=l(0)}return s(h,"value")?!(h.writable===!1||!p(f))&&(u=i.f(f,t)||l(0),u.value=n,o.f(f,t,u),!0):void 0!==h.set&&(h.set.call(f,n),!0)}var o=n(15),i=n(30),a=n(31),s=n(22),u=n(0),l=n(61),c=n(3),p=n(9);u(u.S,"Reflect",{set:r})},function(e,t,n){var r=n(4),o=n(147),i=n(15).f,a=n(67).f,s=n(117),u=n(115),l=r.RegExp,c=l,p=l.prototype,d=/a/g,f=/a/g!==new l(/a/g);if(n(14)&&(!f||n(6)(function(){return d[n(12)("match")]=!1,/a/g!=l(/a/g)||l(d)==d||"/a/i"!=l(/a/g,"i")}))){l=function(e,t){var n=this instanceof l,r=s(e),i=void 0===t;return!n&&r&&e.constructor===l&&i?e:o(f?new c(r&&!i?e.source:e,t):c((r=e instanceof l)?e.source:e,r&&i?u.call(e):t),n?this:p,l)};for(var h=a(c),m=0;h.length>m;)!function(e){e in l||i(l,e,{configurable:!0,get:function(){return c[e]},set:function(t){c[e]=t}})}(h[m++]);p.constructor=l,l.prototype=p,n(26)(r,"RegExp",l)}n(70)("RegExp")},function(e,t,n){n(114)("match",1,function(e,t,n){return[function(n){"use strict";var r=e(this),o=void 0==n?void 0:n[t];return void 0!==o?o.call(n,r):new RegExp(n)[t](String(r))},n]})},function(e,t,n){n(114)("replace",2,function(e,t,n){return[function(r,o){"use strict";var i=e(this),a=void 0==r?void 0:r[t];return void 0!==a?a.call(r,i,o):n.call(String(i),r,o)},n]})},function(e,t,n){n(114)("search",1,function(e,t,n){return[function(n){"use strict";var r=e(this),o=void 0==n?void 0:n[t];return void 0!==o?o.call(n,r):new RegExp(n)[t](String(r))},n]})},function(e,t,n){n(114)("split",2,function(e,t,r){"use strict";var o=n(117),i=r,a=[].push,s="length";if("c"=="abbc".split(/(b)*/)[1]||4!="test".split(/(?:)/,-1)[s]||2!="ab".split(/(?:ab)*/)[s]||4!=".".split(/(.?)(.?)/)[s]||".".split(/()()/)[s]>1||"".split(/.?/)[s]){var u=void 0===/()??/.exec("")[1];r=function(e,t){var n=String(this);if(void 0===e&&0===t)return[];if(!o(e))return i.call(n,e,t);var r,l,c,p,d,f=[],h=(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")+(e.sticky?"y":""),m=0,g=void 0===t?4294967295:t>>>0,v=new RegExp(e.source,h+"g");for(u||(r=new RegExp("^"+v.source+"$(?!\\s)",h));(l=v.exec(n))&&!((c=l.index+l[0][s])>m&&(f.push(n.slice(m,l.index)),!u&&l[s]>1&&l[0].replace(r,function(){for(d=1;d<arguments[s]-2;d++)void 0===arguments[d]&&(l[d]=void 0)}),l[s]>1&&l.index<n[s]&&a.apply(f,l.slice(1)),p=l[0][s],m=c,f[s]>=g));)v.lastIndex===l.index&&v.lastIndex++;return m===n[s]?!p&&v.test("")||f.push(""):f.push(n.slice(m)),f[s]>g?f.slice(0,g):f}}else"0".split(void 0,0)[s]&&(r=function(e,t){return void 0===e&&0===t?[]:i.call(this,e,t)});return[function(n,o){var i=e(this),a=void 0==n?void 0:n[t];return void 0!==a?a.call(n,i,o):r.call(String(i),n,o)},r]})},function(e,t,n){"use strict";n(248);var r=n(3),o=n(115),i=n(14),a=/./.toString,s=function(e){n(26)(RegExp.prototype,"toString",e,!0)};n(6)(function(){return"/a/b"!=a.call({source:"a",flags:"b"})})?s(function(){var e=r(this);return"/".concat(e.source,"/","flags"in e?e.flags:!i&&e instanceof RegExp?o.call(e):void 0)}):"toString"!=a.name&&s(function(){return a.call(this)})},function(e,t,n){"use strict";n(27)("anchor",function(e){return function(t){return e(this,"a","name",t)}})},function(e,t,n){"use strict";n(27)("big",function(e){return function(){return e(this,"big","","")}})},function(e,t,n){"use strict";n(27)("blink",function(e){return function(){return e(this,"blink","","")}})},function(e,t,n){"use strict";n(27)("bold",function(e){return function(){return e(this,"b","","")}})},function(e,t,n){"use strict";var r=n(0),o=n(158)(!1);r(r.P,"String",{codePointAt:function(e){return o(this,e)}})},function(e,t,n){"use strict";var r=n(0),o=n(17),i=n(159),a="".endsWith;r(r.P+r.F*n(145)("endsWith"),"String",{endsWith:function(e){var t=i(this,e,"endsWith"),n=arguments.length>1?arguments[1]:void 0,r=o(t.length),s=void 0===n?r:Math.min(o(n),r),u=String(e);return a?a.call(t,u,s):t.slice(s-u.length,s)===u}})},function(e,t,n){"use strict";n(27)("fixed",function(e){return function(){return e(this,"tt","","")}})},function(e,t,n){"use strict";n(27)("fontcolor",function(e){return function(t){return e(this,"font","color",t)}})},function(e,t,n){"use strict";n(27)("fontsize",function(e){return function(t){return e(this,"font","size",t)}})},function(e,t,n){var r=n(0),o=n(71),i=String.fromCharCode,a=String.fromCodePoint;r(r.S+r.F*(!!a&&1!=a.length),"String",{fromCodePoint:function(e){for(var t,n=[],r=arguments.length,a=0;r>a;){if(t=+arguments[a++],o(t,1114111)!==t)throw RangeError(t+" is not a valid code point");n.push(t<65536?i(t):i(55296+((t-=65536)>>10),t%1024+56320))}return n.join("")}})},function(e,t,n){"use strict";var r=n(0),o=n(159);r(r.P+r.F*n(145)("includes"),"String",{includes:function(e){return!!~o(this,e,"includes").indexOf(e,arguments.length>1?arguments[1]:void 0)}})},function(e,t,n){"use strict";n(27)("italics",function(e){return function(){return e(this,"i","","")}})},function(e,t,n){"use strict";var r=n(158)(!0);n(151)(String,"String",function(e){this._t=String(e),this._i=0},function(){var e,t=this._t,n=this._i;return n>=t.length?{value:void 0,done:!0}:(e=r(t,n),this._i+=e.length,{value:e,done:!1})})},function(e,t,n){"use strict";n(27)("link",function(e){return function(t){return e(this,"a","href",t)}})},function(e,t,n){var r=n(0),o=n(28),i=n(17);r(r.S,"String",{raw:function(e){for(var t=o(e.raw),n=i(t.length),r=arguments.length,a=[],s=0;n>s;)a.push(String(t[s++])),s<r&&a.push(String(arguments[s]));return a.join("")}})},function(e,t,n){var r=n(0);r(r.P,"String",{repeat:n(160)})},function(e,t,n){"use strict";n(27)("small",function(e){return function(){return e(this,"small","","")}})},function(e,t,n){"use strict";var r=n(0),o=n(17),i=n(159),a="".startsWith;r(r.P+r.F*n(145)("startsWith"),"String",{startsWith:function(e){var t=i(this,e,"startsWith"),n=o(Math.min(arguments.length>1?arguments[1]:void 0,t.length)),r=String(e);return a?a.call(t,r,n):t.slice(n,n+r.length)===r}})},function(e,t,n){"use strict";n(27)("strike",function(e){return function(){return e(this,"strike","","")}})},function(e,t,n){"use strict";n(27)("sub",function(e){return function(){return e(this,"sub","","")}})},function(e,t,n){"use strict";n(27)("sup",function(e){return function(){return e(this,"sup","","")}})},function(e,t,n){"use strict";n(84)("trim",function(e){return function(){return e(this,3)}})},function(e,t,n){"use strict";var r=n(4),o=n(22),i=n(14),a=n(0),s=n(26),u=n(60).KEY,l=n(6),c=n(121),p=n(83),d=n(72),f=n(12),h=n(246),m=n(164),g=n(411),v=n(410),b=n(149),y=n(3),_=n(28),E=n(44),w=n(61),S=n(66),x=n(238),T=n(30),C=n(15),I=n(68),R=T.f,M=C.f,P=x.f,O=r.Symbol,A=r.JSON,D=A&&A.stringify,k=f("_hidden"),N=f("toPrimitive"),L={}.propertyIsEnumerable,F=c("symbol-registry"),U=c("symbols"),H=c("op-symbols"),B=Object.prototype,j="function"==typeof O,W=r.QObject,z=!W||!W.prototype||!W.prototype.findChild,q=i&&l(function(){return 7!=S(M({},"a",{get:function(){return M(this,"a",{value:7}).a}})).a})?function(e,t,n){var r=R(B,t);r&&delete B[t],M(e,t,n),r&&e!==B&&M(B,t,r)}:M,V=function(e){var t=U[e]=S(O.prototype);return t._k=e,t},G=j&&"symbol"==typeof O.iterator?function(e){return"symbol"==typeof e}:function(e){return e instanceof O},Y=function(e,t,n){return e===B&&Y(H,t,n),y(e),t=E(t,!0),y(n),o(U,t)?(n.enumerable?(o(e,k)&&e[k][t]&&(e[k][t]=!1),n=S(n,{enumerable:w(0,!1)})):(o(e,k)||M(e,k,w(1,{})),e[k][t]=!0),q(e,t,n)):M(e,t,n)},$=function(e,t){y(e);for(var n,r=v(t=_(t)),o=0,i=r.length;i>o;)Y(e,n=r[o++],t[n]);return e},K=function(e,t){return void 0===t?S(e):$(S(e),t)},X=function(e){var t=L.call(this,e=E(e,!0));return!(this===B&&o(U,e)&&!o(H,e))&&(!(t||!o(this,e)||!o(U,e)||o(this,k)&&this[k][e])||t)},Z=function(e,t){if(e=_(e),t=E(t,!0),e!==B||!o(U,t)||o(H,t)){var n=R(e,t);return!n||!o(U,t)||o(e,k)&&e[k][t]||(n.enumerable=!0),n}},Q=function(e){for(var t,n=P(_(e)),r=[],i=0;n.length>i;)o(U,t=n[i++])||t==k||t==u||r.push(t);return r},J=function(e){for(var t,n=e===B,r=P(n?H:_(e)),i=[],a=0;r.length>a;)!o(U,t=r[a++])||n&&!o(B,t)||i.push(U[t]);return i};j||(O=function(){if(this instanceof O)throw TypeError("Symbol is not a constructor!");var e=d(arguments.length>0?arguments[0]:void 0),t=function(n){this===B&&t.call(H,n),o(this,k)&&o(this[k],e)&&(this[k][e]=!1),q(this,e,w(1,n))};return i&&z&&q(B,e,{configurable:!0,set:t}),V(e)},s(O.prototype,"toString",function(){return this._k}),T.f=Z,C.f=Y,n(67).f=x.f=Q,n(100).f=X,n(120).f=J,i&&!n(65)&&s(B,"propertyIsEnumerable",X,!0),h.f=function(e){return V(f(e))}),a(a.G+a.W+a.F*!j,{Symbol:O});for(var ee="hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","),te=0;ee.length>te;)f(ee[te++]);for(var ee=I(f.store),te=0;ee.length>te;)m(ee[te++]);a(a.S+a.F*!j,"Symbol",{for:function(e){return o(F,e+="")?F[e]:F[e]=O(e)},keyFor:function(e){if(G(e))return g(F,e);throw TypeError(e+" is not a symbol!")},useSetter:function(){z=!0},useSimple:function(){z=!1}}),a(a.S+a.F*!j,"Object",{create:K,defineProperty:Y,defineProperties:$,getOwnPropertyDescriptor:Z,getOwnPropertyNames:Q,getOwnPropertySymbols:J}),A&&a(a.S+a.F*(!j||l(function(){var e=O();return"[null]"!=D([e])||"{}"!=D({a:e})||"{}"!=D(Object(e))})),"JSON",{stringify:function(e){if(void 0!==e&&!G(e)){for(var t,n,r=[e],o=1;arguments.length>o;)r.push(arguments[o++]);return t=r[1],"function"==typeof t&&(n=t),!n&&b(t)||(t=function(e,t){if(n&&(t=n.call(this,e,t)),!G(t))return t}),r[1]=t,D.apply(A,r)}}}),O.prototype[N]||n(25)(O.prototype,N,O.prototype.valueOf),p(O,"Symbol"),p(Math,"Math",!0),p(r.JSON,"JSON",!0)},function(e,t,n){"use strict";var r=n(0),o=n(122),i=n(163),a=n(3),s=n(71),u=n(17),l=n(9),c=n(4).ArrayBuffer,p=n(157),d=i.ArrayBuffer,f=i.DataView,h=o.ABV&&c.isView,m=d.prototype.slice,g=o.VIEW;r(r.G+r.W+r.F*(c!==d),{ArrayBuffer:d}),r(r.S+r.F*!o.CONSTR,"ArrayBuffer",{isView:function(e){return h&&h(e)||l(e)&&g in e}}),r(r.P+r.U+r.F*n(6)(function(){return!new d(2).slice(1,void 0).byteLength}),"ArrayBuffer",{slice:function(e,t){if(void 0!==m&&void 0===t)return m.call(a(this),e);for(var n=a(this).byteLength,r=s(e,n),o=s(void 0===t?n:t,n),i=new(p(this,d))(u(o-r)),l=new f(this),c=new f(i),h=0;r<o;)c.setUint8(h++,l.getUint8(r++));return i}}),n(70)("ArrayBuffer")},function(e,t,n){var r=n(0);r(r.G+r.W+r.F*!n(122).ABV,{DataView:n(163).DataView})},function(e,t,n){n(52)("Float32",4,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Float64",8,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Int16",2,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Int32",4,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Int8",1,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Uint16",2,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Uint32",4,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Uint8",1,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(52)("Uint8",1,function(e){return function(t,n,r){return e(this,t,n,r)}},!0)},function(e,t,n){"use strict";var r=n(230);n(113)("WeakSet",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{add:function(e){return r.def(this,e,!0)}},r,!1,!0)},function(e,t,n){"use strict";var r=n(0),o=n(112)(!0);r(r.P,"Array",{includes:function(e){return o(this,e,arguments.length>1?arguments[1]:void 0)}}),n(80)("includes")},function(e,t,n){var r=n(0),o=n(154)(),i=n(4).process,a="process"==n(36)(i);r(r.G,{asap:function(e){var t=a&&i.domain;o(t?t.bind(e):e)}})},function(e,t,n){var r=n(0),o=n(36);r(r.S,"Error",{isError:function(e){return"Error"===o(e)}})},function(e,t,n){var r=n(0);r(r.P+r.R,"Map",{toJSON:n(229)("Map")})},function(e,t,n){var r=n(0);r(r.S,"Math",{iaddh:function(e,t,n,r){var o=e>>>0,i=t>>>0,a=n>>>0;return i+(r>>>0)+((o&a|(o|a)&~(o+a>>>0))>>>31)|0}})},function(e,t,n){var r=n(0);r(r.S,"Math",{imulh:function(e,t){var n=+e,r=+t,o=65535&n,i=65535&r,a=n>>16,s=r>>16,u=(a*i>>>0)+(o*i>>>16);return a*s+(u>>16)+((o*s>>>0)+(65535&u)>>16)}})},function(e,t,n){var r=n(0);r(r.S,"Math",{isubh:function(e,t,n,r){var o=e>>>0,i=t>>>0,a=n>>>0;return i-(r>>>0)-((~o&a|~(o^a)&o-a>>>0)>>>31)|0}})},function(e,t,n){var r=n(0);r(r.S,"Math",{umulh:function(e,t){var n=+e,r=+t,o=65535&n,i=65535&r,a=n>>>16,s=r>>>16,u=(a*i>>>0)+(o*i>>>16);return a*s+(u>>>16)+((o*s>>>0)+(65535&u)>>>16)}})},function(e,t,n){"use strict";var r=n(0),o=n(18),i=n(24),a=n(15);n(14)&&r(r.P+n(119),"Object",{__defineGetter__:function(e,t){a.f(o(this),e,{get:i(t),enumerable:!0,configurable:!0})}})},function(e,t,n){"use strict";var r=n(0),o=n(18),i=n(24),a=n(15);n(14)&&r(r.P+n(119),"Object",{__defineSetter__:function(e,t){a.f(o(this),e,{set:i(t),enumerable:!0,configurable:!0})}})},function(e,t,n){var r=n(0),o=n(240)(!0);r(r.S,"Object",{entries:function(e){return o(e)}})},function(e,t,n){var r=n(0),o=n(241),i=n(28),a=n(30),s=n(142);r(r.S,"Object",{getOwnPropertyDescriptors:function(e){for(var t,n=i(e),r=a.f,u=o(n),l={},c=0;u.length>c;)s(l,t=u[c++],r(n,t));return l}})},function(e,t,n){"use strict";var r=n(0),o=n(18),i=n(44),a=n(31),s=n(30).f;n(14)&&r(r.P+n(119),"Object",{__lookupGetter__:function(e){var t,n=o(this),r=i(e,!0);do{if(t=s(n,r))return t.get}while(n=a(n))}})},function(e,t,n){"use strict";var r=n(0),o=n(18),i=n(44),a=n(31),s=n(30).f;n(14)&&r(r.P+n(119),"Object",{__lookupSetter__:function(e){var t,n=o(this),r=i(e,!0);do{if(t=s(n,r))return t.set}while(n=a(n))}})},function(e,t,n){var r=n(0),o=n(240)(!1);r(r.S,"Object",{values:function(e){return o(e)}})},function(e,t,n){"use strict";var r=n(0),o=n(4),i=n(49),a=n(154)(),s=n(12)("observable"),u=n(24),l=n(3),c=n(64),p=n(69),d=n(25),f=n(81),h=f.RETURN,m=function(e){return null==e?void 0:u(e)},g=function(e){var t=e._c;t&&(e._c=void 0,t())},v=function(e){return void 0===e._o},b=function(e){v(e)||(e._o=void 0,g(e))},y=function(e,t){l(e),this._c=void 0,this._o=e,e=new _(this);try{var n=t(e),r=n;null!=n&&("function"==typeof n.unsubscribe?n=function(){r.unsubscribe()}:u(n),this._c=n)}catch(t){return void e.error(t)}v(this)&&g(this)};y.prototype=p({},{unsubscribe:function(){b(this)}});var _=function(e){this._s=e};_.prototype=p({},{next:function(e){var t=this._s;if(!v(t)){var n=t._o;try{var r=m(n.next);if(r)return r.call(n,e)}catch(e){try{b(t)}finally{throw e}}}},error:function(e){var t=this._s;if(v(t))throw e;var n=t._o;t._o=void 0;try{var r=m(n.error);if(!r)throw e;e=r.call(n,e)}catch(e){try{g(t)}finally{throw e}}return g(t),e},complete:function(e){var t=this._s;if(!v(t)){var n=t._o;t._o=void 0;try{var r=m(n.complete);e=r?r.call(n,e):void 0}catch(e){try{g(t)}finally{throw e}}return g(t),e}}});var E=function(e){c(this,E,"Observable","_f")._f=u(e)};p(E.prototype,{subscribe:function(e){return new y(e,this._f)},forEach:function(e){var t=this;return new(i.Promise||o.Promise)(function(n,r){u(e);var o=t.subscribe({next:function(t){try{return e(t)}catch(e){r(e),o.unsubscribe()}},error:r,complete:n})})}}),p(E,{from:function(e){var t="function"==typeof this?this:E,n=m(l(e)[s]);if(n){var r=l(n.call(e));return r.constructor===t?r:new t(function(e){return r.subscribe(e)})}return new t(function(t){var n=!1;return a(function(){if(!n){try{if(f(e,!1,function(e){if(t.next(e),n)return h})===h)return}catch(e){if(n)throw e;return void t.error(e)}t.complete()}}),function(){n=!0}})},of:function(){for(var e=0,t=arguments.length,n=Array(t);e<t;)n[e]=arguments[e++];return new("function"==typeof this?this:E)(function(e){var t=!1;return a(function(){if(!t){for(var r=0;r<n.length;++r)if(e.next(n[r]),t)return;e.complete()}}),function(){t=!0}})}}),d(E.prototype,s,function(){return this}),r(r.G,{Observable:E}),n(70)("Observable")},function(e,t,n){var r=n(51),o=n(3),i=r.key,a=r.set;r.exp({defineMetadata:function(e,t,n,r){a(e,t,o(n),i(r))}})},function(e,t,n){var r=n(51),o=n(3),i=r.key,a=r.map,s=r.store;r.exp({deleteMetadata:function(e,t){var n=arguments.length<3?void 0:i(arguments[2]),r=a(o(t),n,!1);if(void 0===r||!r.delete(e))return!1;if(r.size)return!0;var u=s.get(t);return u.delete(n),!!u.size||s.delete(t)}})},function(e,t,n){var r=n(249),o=n(225),i=n(51),a=n(3),s=n(31),u=i.keys,l=i.key,c=function(e,t){var n=u(e,t),i=s(e);if(null===i)return n;var a=c(i,t);return a.length?n.length?o(new r(n.concat(a))):a:n};i.exp({getMetadataKeys:function(e){return c(a(e),arguments.length<2?void 0:l(arguments[1]))}})},function(e,t,n){var r=n(51),o=n(3),i=n(31),a=r.has,s=r.get,u=r.key,l=function(e,t,n){if(a(e,t,n))return s(e,t,n);var r=i(t);return null!==r?l(e,r,n):void 0};r.exp({getMetadata:function(e,t){return l(e,o(t),arguments.length<3?void 0:u(arguments[2]))}})},function(e,t,n){var r=n(51),o=n(3),i=r.keys,a=r.key;r.exp({getOwnMetadataKeys:function(e){return i(o(e),arguments.length<2?void 0:a(arguments[1]))}})},function(e,t,n){var r=n(51),o=n(3),i=r.get,a=r.key;r.exp({getOwnMetadata:function(e,t){return i(e,o(t),arguments.length<3?void 0:a(arguments[2]))}})},function(e,t,n){var r=n(51),o=n(3),i=n(31),a=r.has,s=r.key,u=function(e,t,n){if(a(e,t,n))return!0;var r=i(t);return null!==r&&u(e,r,n)};r.exp({hasMetadata:function(e,t){return u(e,o(t),arguments.length<3?void 0:s(arguments[2]))}})},function(e,t,n){var r=n(51),o=n(3),i=r.has,a=r.key;r.exp({hasOwnMetadata:function(e,t){return i(e,o(t),arguments.length<3?void 0:a(arguments[2]))}})},function(e,t,n){var r=n(51),o=n(3),i=n(24),a=r.key,s=r.set;r.exp({metadata:function(e,t){return function(n,r){s(e,t,(void 0!==r?o:i)(n),a(r))}}})},function(e,t,n){var r=n(0);r(r.P+r.R,"Set",{toJSON:n(229)("Set")})},function(e,t,n){"use strict";var r=n(0),o=n(158)(!0);r(r.P,"String",{at:function(e){return o(this,e)}})},function(e,t,n){"use strict";var r=n(0),o=n(37),i=n(17),a=n(117),s=n(115),u=RegExp.prototype,l=function(e,t){this._r=e,this._s=t};n(150)(l,"RegExp String",function(){var e=this._r.exec(this._s);return{value:e,done:null===e}}),r(r.P,"String",{matchAll:function(e){if(o(this),!a(e))throw TypeError(e+" is not a regexp!");var t=String(this),n="flags"in u?String(e.flags):s.call(e),r=new RegExp(e.source,~n.indexOf("g")?n:"g"+n);return r.lastIndex=i(e.lastIndex),new l(r,t)}})},function(e,t,n){"use strict";var r=n(0),o=n(245);r(r.P,"String",{padEnd:function(e){return o(this,e,arguments.length>1?arguments[1]:void 0,!1)}})},function(e,t,n){"use strict";var r=n(0),o=n(245);r(r.P,"String",{padStart:function(e){return o(this,e,arguments.length>1?arguments[1]:void 0,!0)}})},function(e,t,n){"use strict";n(84)("trimLeft",function(e){return function(){return e(this,1)}},"trimStart")},function(e,t,n){"use strict";n(84)("trimRight",function(e){return function(){return e(this,2)}},"trimEnd")},function(e,t,n){n(164)("asyncIterator")},function(e,t,n){n(164)("observable")},function(e,t,n){var r=n(0);r(r.S,"System",{global:n(4)})},function(e,t,n){for(var r=n(166),o=n(26),i=n(4),a=n(25),s=n(82),u=n(12),l=u("iterator"),c=u("toStringTag"),p=s.Array,d=["NodeList","DOMTokenList","MediaList","StyleSheetList","CSSRuleList"],f=0;f<5;f++){var h,m=d[f],g=i[m],v=g&&g.prototype;if(v){v[l]||a(v,l,p),v[c]||a(v,c,m),s[m]=p;for(h in r)v[h]||o(v,h,r[h],!0)}}},function(e,t,n){var r=n(0),o=n(162);r(r.G+r.B,{setImmediate:o.set,clearImmediate:o.clear})},function(e,t,n){var r=n(4),o=n(0),i=n(116),a=n(412),s=r.navigator,u=!!s&&/MSIE .\./.test(s.userAgent),l=function(e){return u?function(t,n){return e(i(a,[].slice.call(arguments,2),"function"==typeof t?t:Function(t)),n)}:e};o(o.G+o.B+o.F*u,{setTimeout:l(r.setTimeout),setInterval:l(r.setInterval)})},function(e,t,n){n(535),n(474),n(476),n(475),n(478),n(480),n(485),n(479),n(477),n(487),n(486),n(482),n(483),n(481),n(473),n(484),n(488),n(489),n(441),n(443),n(442),n(491),n(490),n(461),n(471),n(472),n(462),n(463),n(464),n(465),n(466),n(467),n(468),n(469),n(470),n(444),n(445),n(446),n(447),n(448),n(449),n(450),n(451),n(452),n(453),n(454),n(455),n(456),n(457),n(458),n(459),n(460),n(522),n(527),n(534),n(525),n(517),n(518),n(523),n(528),n(530),n(513),n(514),n(515),n(516),n(519),n(520),n(521),n(524),n(526),n(529),n(531),n(532),n(533),n(436),n(438),n(437),n(440),n(439),n(425),n(423),n(429),n(426),n(432),n(434),n(422),n(428),n(419),n(433),n(417),n(431),n(430),n(424),n(427),n(416),n(418),n(421),n(420),n(435),n(166),n(507),n(512),n(248),n(508),n(509),n(510),n(511),n(492),n(247),n(249),n(250),n(547),n(536),n(537),n(542),n(545),n(546),n(540),n(543),n(541),n(544),n(538),n(539),n(493),n(494),n(495),n(496),n(497),n(500),n(498),n(499),n(501),n(502),n(503),n(504),n(506),n(505),n(548),n(574),n(577),n(576),n(578),n(579),n(575),n(580),n(581),n(559),n(562),n(558),n(556),n(557),n(560),n(561),n(551),n(573),n(582),n(550),n(552),n(554),n(553),n(555),n(564),n(565),n(567),n(566),n(569),n(568),n(570),n(571),n(572),n(549),n(563),n(585),n(584),n(583),e.exports=n(49)},function(e,t,n){"use strict";var r=n(255),o=n(254),i=n(257),a=n(256),s=n(168);e.exports={ToPrimitive:n(590),ToBoolean:function(e){return Boolean(e)},ToNumber:function(e){return Number(e)},ToInteger:function(e){var t=this.ToNumber(e);return r(t)?0:0!==t&&o(t)?i(t)*Math.floor(Math.abs(t)):t},ToInt32:function(e){return this.ToNumber(e)>>0},ToUint32:function(e){return this.ToNumber(e)>>>0},ToUint16:function(e){var t=this.ToNumber(e);if(r(t)||0===t||!o(t))return 0;var n=i(t)*Math.floor(Math.abs(t));return a(n,65536)},ToString:function(e){return String(e)},ToObject:function(e){return this.CheckObjectCoercible(e),Object(e)},CheckObjectCoercible:function(e,t){if(null==e)throw new TypeError(t||"Cannot call method on "+e);return e},IsCallable:s,SameValue:function(e,t){return e===t?0!==e||1/e==1/t:r(e)&&r(t)},Type:function(e){return null===e?"Null":void 0===e?"Undefined":"function"==typeof e||"object"==typeof e?"Object":"number"==typeof e?"Number":"boolean"==typeof e?"Boolean":"string"==typeof e?"String":void 0}}},function(e,t,n){"use strict";var r=Object.prototype.toString,o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator,i=o?Symbol.prototype.toString:r,a=n(255),s=n(254),u=Number.MAX_SAFE_INTEGER||Math.pow(2,53)-1,l=n(253),c=n(257),p=n(256),d=n(589),f=n(591),h=parseInt,m=n(123),g=m.call(Function.call,String.prototype.slice),v=m.call(Function.call,RegExp.prototype.test,/^0b[01]+$/i),b=m.call(Function.call,RegExp.prototype.test,/^0o[0-7]+$/i),y=["","​","￾"].join(""),_=new RegExp("["+y+"]","g"),E=m.call(Function.call,RegExp.prototype.test,_),w=m.call(Function.call,RegExp.prototype.test,/^[-+]0x[0-9a-f]+$/i),S=["\t\n\v\f\r   ᠎    ","         　\u2028","\u2029\ufeff"].join(""),x=new RegExp("(^["+S+"]+)|(["+S+"]+$)","g"),T=m.call(Function.call,String.prototype.replace),C=function(e){return T(e,x,"")},I=n(587),R=n(615),M=l(l({},I),{Call:function(e,t){var n=arguments.length>2?arguments[2]:[];if(!this.IsCallable(e))throw new TypeError(e+" is not a function");return e.apply(t,n)},ToPrimitive:f,ToNumber:function(e){var t=d(e)?e:f(e,"number");if("symbol"==typeof t)throw new TypeError("Cannot convert a Symbol value to a number");if("string"==typeof t){if(v(t))return this.ToNumber(h(g(t,2),2));if(b(t))return this.ToNumber(h(g(t,2),8));if(E(t)||w(t))return NaN;var n=C(t);if(n!==t)return this.ToNumber(n)}return Number(t)},ToInt16:function(e){var t=this.ToUint16(e);return t>=32768?t-65536:t},ToInt8:function(e){var t=this.ToUint8(e);return t>=128?t-256:t},ToUint8:function(e){var t=this.ToNumber(e);if(a(t)||0===t||!s(t))return 0;var n=c(t)*Math.floor(Math.abs(t));return p(n,256)},ToUint8Clamp:function(e){var t=this.ToNumber(e);if(a(t)||t<=0)return 0;if(t>=255)return 255;var n=Math.floor(e);return n+.5<t?n+1:t<n+.5?n:n%2!=0?n+1:n},ToString:function(e){if("symbol"==typeof e)throw new TypeError("Cannot convert a Symbol value to a string");return String(e)},ToObject:function(e){return this.RequireObjectCoercible(e),Object(e)},ToPropertyKey:function(e){var t=this.ToPrimitive(e,String);return"symbol"==typeof t?i.call(t):this.ToString(t)},ToLength:function(e){var t=this.ToInteger(e);return t<=0?0:t>u?u:t},CanonicalNumericIndexString:function(e){if("[object String]"!==r.call(e))throw new TypeError("must be a string");if("-0"===e)return-0;var t=this.ToNumber(e);return this.SameValue(this.ToString(t),e)?t:void 0},RequireObjectCoercible:I.CheckObjectCoercible,IsArray:Array.isArray||function(e){return"[object Array]"===r.call(e)},IsConstructor:function(e){return"function"==typeof e&&!!e.prototype},IsExtensible:function(e){return!Object.preventExtensions||!d(e)&&Object.isExtensible(e)},IsInteger:function(e){if("number"!=typeof e||a(e)||!s(e))return!1;var t=Math.abs(e);return Math.floor(t)===t},IsPropertyKey:function(e){return"string"==typeof e||"symbol"==typeof e},IsRegExp:function(e){if(!e||"object"!=typeof e)return!1;if(o){var t=e[Symbol.match];if(void 0!==t)return I.ToBoolean(t)}return R(e)},SameValueZero:function(e,t){return e===t||a(e)&&a(t)},GetV:function(e,t){if(!this.IsPropertyKey(t))throw new TypeError("Assertion failed: IsPropertyKey(P) is not true");return this.ToObject(e)[t]},GetMethod:function(e,t){if(!this.IsPropertyKey(t))throw new TypeError("Assertion failed: IsPropertyKey(P) is not true");var n=this.GetV(e,t);if(null!=n){if(!this.IsCallable(n))throw new TypeError(t+"is not a function");return n}},Get:function(e,t){if("Object"!==this.Type(e))throw new TypeError("Assertion failed: Type(O) is not Object");if(!this.IsPropertyKey(t))throw new TypeError("Assertion failed: IsPropertyKey(P) is not true");return e[t]},Type:function(e){return"symbol"==typeof e?"Symbol":I.Type(e)},SpeciesConstructor:function(e,t){if("Object"!==this.Type(e))throw new TypeError("Assertion failed: Type(O) is not Object");var n=e.constructor;if(void 0===n)return t;if("Object"!==this.Type(n))throw new TypeError("O.constructor is not an Object");var r=o&&Symbol.species?n[Symbol.species]:void 0;if(null==r)return t;if(this.IsConstructor(r))return r;throw new TypeError("no constructor found")}});delete M.CheckObjectCoercible,e.exports=M},function(e,t){e.exports=function(e){return null===e||"function"!=typeof e&&"object"!=typeof e}},function(e,t,n){"use strict";var r=Object.prototype.toString,o=n(258),i=n(168),a={"[[DefaultValue]]":function(e,t){var n=t||("[object Date]"===r.call(e)?String:Number);if(n===String||n===Number){var a,s,u=n===String?["toString","valueOf"]:["valueOf","toString"];for(s=0;s<u.length;++s)if(i(e[u[s]])&&(a=e[u[s]](),o(a)))return a;throw new TypeError("No default value")}throw new TypeError("invalid [[DefaultValue]] hint supplied")}};e.exports=function(e,t){return o(e)?e:a["[[DefaultValue]]"](e,t)}},function(e,t,n){"use strict";var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator,o=n(258),i=n(168),a=n(614),s=n(616),u=function(e,t){if(void 0===e||null===e)throw new TypeError("Cannot call method on "+e);if("string"!=typeof t||"number"!==t&&"string"!==t)throw new TypeError('hint must be "string" or "number"');var n,r,a,s="string"===t?["toString","valueOf"]:["valueOf","toString"];for(a=0;a<s.length;++a)if(n=e[s[a]],i(n)&&(r=n.call(e),o(r)))return r;throw new TypeError("No default value")},l=function(e,t){var n=e[t];if(null!==n&&void 0!==n){if(!i(n))throw new TypeError(n+" returned for property "+t+" of object "+e+" is not a function");return n}};e.exports=function(e,t){if(o(e))return e;var n="default";arguments.length>1&&(t===String?n="string":t===Number&&(n="number"));var i;if(r&&(Symbol.toPrimitive?i=l(e,Symbol.toPrimitive):s(e)&&(i=Symbol.prototype.valueOf)),void 0!==i){var c=i.call(e,n);if(o(c))return c;throw new TypeError("unable to convert exotic object to primitive")}return"default"===n&&(a(e)||s(e))&&(n="string"),u(e,"default"===n?"number":n)}},function(e,t,n){"use strict";function r(e){return e.replace(o,function(e,t){return t.toUpperCase()})}var o=/-(.)/g;e.exports=r},function(e,t,n){"use strict";function r(e){return o(e.replace(i,"ms-"))}var o=n(592),i=/^-ms-/;e.exports=r},function(e,t,n){"use strict";function r(e,t){return!(!e||!t)&&(e===t||!o(e)&&(o(t)?r(e,t.parentNode):"contains"in e?e.contains(t):!!e.compareDocumentPosition&&!!(16&e.compareDocumentPosition(t))))}var o=n(602);e.exports=r},function(e,t,n){"use strict";function r(e){var t=e.length;if((Array.isArray(e)||"object"!=typeof e&&"function"!=typeof e)&&a(!1),"number"!=typeof t&&a(!1),0===t||t-1 in e||a(!1),"function"==typeof e.callee&&a(!1),e.hasOwnProperty)try{return Array.prototype.slice.call(e)}catch(e){}for(var n=Array(t),r=0;r<t;r++)n[r]=e[r];return n}function o(e){return!!e&&("object"==typeof e||"function"==typeof e)&&"length"in e&&!("setInterval"in e)&&"number"!=typeof e.nodeType&&(Array.isArray(e)||"callee"in e||"item"in e)}function i(e){return o(e)?Array.isArray(e)?e.slice():r(e):[e]}var a=n(1);e.exports=i},function(e,t,n){"use strict";function r(e){var t=e.match(c);return t&&t[1].toLowerCase()}function o(e,t){var n=l;l||u(!1);var o=r(e),i=o&&s(o);if(i){n.innerHTML=i[1]+e+i[2];for(var c=i[0];c--;)n=n.lastChild}else n.innerHTML=e;var p=n.getElementsByTagName("script");p.length&&(t||u(!1),a(p).forEach(t));for(var d=Array.from(n.childNodes);n.lastChild;)n.removeChild(n.lastChild);return d}var i=n(23),a=n(595),s=n(597),u=n(1),l=i.canUseDOM?document.createElement("div"):null,c=/^\s*<(\w+)/;e.exports=o},function(e,t,n){"use strict";function r(e){return a||i(!1),d.hasOwnProperty(e)||(e="*"),s.hasOwnProperty(e)||(a.innerHTML="*"===e?"<link />":"<"+e+"></"+e+">",s[e]=!a.firstChild),s[e]?d[e]:null}var o=n(23),i=n(1),a=o.canUseDOM?document.createElement("div"):null,s={},u=[1,'<select multiple="true">',"</select>"],l=[1,"<table>","</table>"],c=[3,"<table><tbody><tr>","</tr></tbody></table>"],p=[1,'<svg xmlns="http://www.w3.org/2000/svg">',"</svg>"],d={"*":[1,"?<div>","</div>"],area:[1,"<map>","</map>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],legend:[1,"<fieldset>","</fieldset>"],param:[1,"<object>","</object>"],tr:[2,"<table><tbody>","</tbody></table>"],optgroup:u,option:u,caption:l,colgroup:l,tbody:l,tfoot:l,thead:l,td:c,th:c};["circle","clipPath","defs","ellipse","g","image","line","linearGradient","mask","path","pattern","polygon","polyline","radialGradient","rect","stop","text","tspan"].forEach(function(e){d[e]=p,s[e]=!0}),e.exports=r},function(e,t,n){"use strict";function r(e){return e.Window&&e instanceof e.Window?{x:e.pageXOffset||e.document.documentElement.scrollLeft,y:e.pageYOffset||e.document.documentElement.scrollTop}:{x:e.scrollLeft,y:e.scrollTop}}e.exports=r},function(e,t,n){"use strict";function r(e){return e.replace(o,"-$1").toLowerCase()}var o=/([A-Z])/g;e.exports=r},function(e,t,n){"use strict";function r(e){return o(e).replace(i,"-ms-")}var o=n(599),i=/^ms-/;e.exports=r},function(e,t,n){"use strict";function r(e){var t=e?e.ownerDocument||e:document,n=t.defaultView||window;return!(!e||!("function"==typeof n.Node?e instanceof n.Node:"object"==typeof e&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName))}e.exports=r},function(e,t,n){"use strict";function r(e){return o(e)&&3==e.nodeType}var o=n(601);e.exports=r},function(e,t,n){"use strict";function r(e){var t={};return function(n){return t.hasOwnProperty(n)||(t[n]=e.call(this,n)),t[n]}}e.exports=r},function(e,t){var n=Object.prototype.hasOwnProperty,r=Object.prototype.toString;e.exports=function(e,t,o){if("[object Function]"!==r.call(t))throw new TypeError("iterator must be a function");var i=e.length;if(i===+i)for(var a=0;a<i;a++)t.call(o,e[a],a,e);else for(var s in e)n.call(e,s)&&t.call(o,e[s],s,e)}},function(e,t){var n=Array.prototype.slice,r=Object.prototype.toString;e.exports=function(e){var t=this;if("function"!=typeof t||"[object Function]"!==r.call(t))throw new TypeError("Function.prototype.bind called on incompatible "+t);for(var o,i=n.call(arguments,1),a=function(){if(this instanceof o){var r=t.apply(this,i.concat(n.call(arguments)));return Object(r)===r?r:this}return t.apply(e,i.concat(n.call(arguments)))},s=Math.max(0,t.length-i.length),u=[],l=0;l<s;l++)u.push("$"+l);if(o=Function("binder","return function ("+u.join(",")+"){ return binder.apply(this,arguments); }")(a),t.prototype){var c=function(){};c.prototype=t.prototype,o.prototype=new c,c.prototype=null}return o}},function(e,t,n){var r=n(53),o={};o.create=function(){var e=new r.ARRAY_TYPE(4);return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e},o.clone=function(e){var t=new r.ARRAY_TYPE(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},o.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e},o.fromValues=function(e,t,n,o){var i=new r.ARRAY_TYPE(4);return i[0]=e,i[1]=t,i[2]=n,i[3]=o,i},o.set=function(e,t,n,r,o){return e[0]=t,e[1]=n,e[2]=r,e[3]=o,e},o.transpose=function(e,t){if(e===t){var n=t[1];e[1]=t[2],e[2]=n}else e[0]=t[0],e[1]=t[2],e[2]=t[1],e[3]=t[3];return e},o.invert=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=n*i-o*r;return a?(a=1/a,e[0]=i*a,e[1]=-r*a,e[2]=-o*a,e[3]=n*a,e):null},o.adjoint=function(e,t){var n=t[0];return e[0]=t[3],e[1]=-t[1],e[2]=-t[2],e[3]=n,e},o.determinant=function(e){return e[0]*e[3]-e[2]*e[1]},o.multiply=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=n[0],u=n[1],l=n[2],c=n[3];return e[0]=r*s+i*u,e[1]=o*s+a*u,e[2]=r*l+i*c,e[3]=o*l+a*c,e},o.mul=o.multiply,o.rotate=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u+i*s,e[1]=o*u+a*s,e[2]=r*-s+i*u,e[3]=o*-s+a*u,e},o.scale=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=n[0],u=n[1];return e[0]=r*s,e[1]=o*s,e[2]=i*u,e[3]=a*u,e},o.fromRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=-n,e[3]=r,e},o.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=t[1],e},o.str=function(e){return"mat2("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},o.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2))},o.LDU=function(e,t,n,r){return e[2]=r[2]/r[0],n[0]=r[0],n[1]=r[1],n[3]=r[3]-e[2]*n[1],[e,t,n]},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e},o.sub=o.subtract,o.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]},o.equals=function(e,t){var n=e[0],o=e[1],i=e[2],a=e[3],s=t[0],u=t[1],l=t[2],c=t[3];return Math.abs(n-s)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(s))&&Math.abs(o-u)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(u))&&Math.abs(i-l)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(a-c)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(c))},o.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e},o.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e},e.exports=o},function(e,t,n){var r=n(53),o={};o.create=function(){var e=new r.ARRAY_TYPE(6);return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e},o.clone=function(e){var t=new r.ARRAY_TYPE(6);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e},o.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e},o.fromValues=function(e,t,n,o,i,a){var s=new r.ARRAY_TYPE(6);return s[0]=e,s[1]=t,s[2]=n,s[3]=o,s[4]=i,s[5]=a,s},o.set=function(e,t,n,r,o,i,a){return e[0]=t,e[1]=n,e[2]=r,e[3]=o,e[4]=i,e[5]=a,e},o.invert=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=t[4],s=t[5],u=n*i-r*o;return u?(u=1/u,e[0]=i*u,e[1]=-r*u,e[2]=-o*u,e[3]=n*u,e[4]=(o*s-i*a)*u,e[5]=(r*a-n*s)*u,e):null},o.determinant=function(e){return e[0]*e[3]-e[1]*e[2]},o.multiply=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=n[0],c=n[1],p=n[2],d=n[3],f=n[4],h=n[5];return e[0]=r*l+i*c,e[1]=o*l+a*c,e[2]=r*p+i*d,e[3]=o*p+a*d,e[4]=r*f+i*h+s,e[5]=o*f+a*h+u,e},o.mul=o.multiply,o.rotate=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=Math.sin(n),c=Math.cos(n);return e[0]=r*c+i*l,e[1]=o*c+a*l,e[2]=r*-l+i*c,e[3]=o*-l+a*c,e[4]=s,e[5]=u,e},o.scale=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=n[0],c=n[1];return e[0]=r*l,e[1]=o*l,e[2]=i*c,e[3]=a*c,e[4]=s,e[5]=u,e},o.translate=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=n[0],c=n[1];return e[0]=r,e[1]=o,e[2]=i,e[3]=a,e[4]=r*l+i*c+s,e[5]=o*l+a*c+u,e},o.fromRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=-n,e[3]=r,e[4]=0,e[5]=0,e},o.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=t[1],e[4]=0,e[5]=0,e},o.fromTranslation=function(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=t[0],e[5]=t[1],e},o.str=function(e){return"mat2d("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+")"},o.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+1)},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e},o.sub=o.subtract,o.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e},o.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e[4]=t[4]+n[4]*r,e[5]=t[5]+n[5]*r,e},o.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]},o.equals=function(e,t){var n=e[0],o=e[1],i=e[2],a=e[3],s=e[4],u=e[5],l=t[0],c=t[1],p=t[2],d=t[3],f=t[4],h=t[5];return Math.abs(n-l)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(l))&&Math.abs(o-c)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))&&Math.abs(i-p)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(p))&&Math.abs(a-d)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(d))&&Math.abs(s-f)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(f))&&Math.abs(u-h)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(h))},e.exports=o},function(e,t,n){var r=n(53),o={scalar:{},SIMD:{}};o.create=function(){var e=new r.ARRAY_TYPE(16);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},o.clone=function(e){var t=new r.ARRAY_TYPE(16);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},o.fromValues=function(e,t,n,o,i,a,s,u,l,c,p,d,f,h,m,g){var v=new r.ARRAY_TYPE(16);return v[0]=e,v[1]=t,v[2]=n,v[3]=o,v[4]=i,v[5]=a,v[6]=s,v[7]=u,v[8]=l,v[9]=c,v[10]=p,v[11]=d,v[12]=f,v[13]=h,v[14]=m,v[15]=g,v},o.set=function(e,t,n,r,o,i,a,s,u,l,c,p,d,f,h,m,g){return e[0]=t,e[1]=n,e[2]=r,e[3]=o,e[4]=i,e[5]=a,e[6]=s,e[7]=u,e[8]=l,e[9]=c,e[10]=p,e[11]=d,e[12]=f,e[13]=h,e[14]=m,e[15]=g,e},o.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},o.scalar.transpose=function(e,t){if(e===t){var n=t[1],r=t[2],o=t[3],i=t[6],a=t[7],s=t[11];e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=n,e[6]=t[9],e[7]=t[13],e[8]=r,e[9]=i,e[11]=t[14],e[12]=o,e[13]=a,e[14]=s}else e[0]=t[0],e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=t[1],e[5]=t[5],e[6]=t[9],e[7]=t[13],e[8]=t[2],e[9]=t[6],e[10]=t[10],e[11]=t[14],e[12]=t[3],e[13]=t[7],e[14]=t[11],e[15]=t[15];return e},o.SIMD.transpose=function(e,t){var n,r,o,i,a,s,u,l,c,p;return n=SIMD.Float32x4.load(t,0),r=SIMD.Float32x4.load(t,4),o=SIMD.Float32x4.load(t,8),i=SIMD.Float32x4.load(t,12),a=SIMD.Float32x4.shuffle(n,r,0,1,4,5),s=SIMD.Float32x4.shuffle(o,i,0,1,4,5),u=SIMD.Float32x4.shuffle(a,s,0,2,4,6),l=SIMD.Float32x4.shuffle(a,s,1,3,5,7),SIMD.Float32x4.store(e,0,u),SIMD.Float32x4.store(e,4,l),a=SIMD.Float32x4.shuffle(n,r,2,3,6,7),s=SIMD.Float32x4.shuffle(o,i,2,3,6,7),c=SIMD.Float32x4.shuffle(a,s,0,2,4,6),p=SIMD.Float32x4.shuffle(a,s,1,3,5,7),SIMD.Float32x4.store(e,8,c),SIMD.Float32x4.store(e,12,p),e},o.transpose=r.USE_SIMD?o.SIMD.transpose:o.scalar.transpose,o.scalar.invert=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=t[4],s=t[5],u=t[6],l=t[7],c=t[8],p=t[9],d=t[10],f=t[11],h=t[12],m=t[13],g=t[14],v=t[15],b=n*s-r*a,y=n*u-o*a,_=n*l-i*a,E=r*u-o*s,w=r*l-i*s,S=o*l-i*u,x=c*m-p*h,T=c*g-d*h,C=c*v-f*h,I=p*g-d*m,R=p*v-f*m,M=d*v-f*g,P=b*M-y*R+_*I+E*C-w*T+S*x;return P?(P=1/P,e[0]=(s*M-u*R+l*I)*P,e[1]=(o*R-r*M-i*I)*P,e[2]=(m*S-g*w+v*E)*P,e[3]=(d*w-p*S-f*E)*P,e[4]=(u*C-a*M-l*T)*P,e[5]=(n*M-o*C+i*T)*P,e[6]=(g*_-h*S-v*y)*P,e[7]=(c*S-d*_+f*y)*P,e[8]=(a*R-s*C+l*x)*P,e[9]=(r*C-n*R-i*x)*P,e[10]=(h*w-m*_+v*b)*P,e[11]=(p*_-c*w-f*b)*P,e[12]=(s*T-a*I-u*x)*P,e[13]=(n*I-r*T+o*x)*P,e[14]=(m*y-h*E-g*b)*P,e[15]=(c*E-p*y+d*b)*P,e):null},o.SIMD.invert=function(e,t){var n,r,o,i,a,s,u,l,c,p,d=SIMD.Float32x4.load(t,0),f=SIMD.Float32x4.load(t,4),h=SIMD.Float32x4.load(t,8),m=SIMD.Float32x4.load(t,12);return a=SIMD.Float32x4.shuffle(d,f,0,1,4,5),r=SIMD.Float32x4.shuffle(h,m,0,1,4,5),n=SIMD.Float32x4.shuffle(a,r,0,2,4,6),r=SIMD.Float32x4.shuffle(r,a,1,3,5,7),a=SIMD.Float32x4.shuffle(d,f,2,3,6,7),i=SIMD.Float32x4.shuffle(h,m,2,3,6,7),o=SIMD.Float32x4.shuffle(a,i,0,2,4,6),i=SIMD.Float32x4.shuffle(i,a,1,3,5,7),a=SIMD.Float32x4.mul(o,i),a=SIMD.Float32x4.swizzle(a,1,0,3,2),s=SIMD.Float32x4.mul(r,a),u=SIMD.Float32x4.mul(n,a),a=SIMD.Float32x4.swizzle(a,2,3,0,1),s=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,a),s),u=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,a),u),u=SIMD.Float32x4.swizzle(u,2,3,0,1),a=SIMD.Float32x4.mul(r,o),a=SIMD.Float32x4.swizzle(a,1,0,3,2),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,a),s),c=SIMD.Float32x4.mul(n,a),a=SIMD.Float32x4.swizzle(a,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(i,a)),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,a),c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),a=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(r,2,3,0,1),i),a=SIMD.Float32x4.swizzle(a,1,0,3,2),o=SIMD.Float32x4.swizzle(o,2,3,0,1),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(o,a),s),l=SIMD.Float32x4.mul(n,a),a=SIMD.Float32x4.swizzle(a,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(o,a)),l=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,a),l),l=SIMD.Float32x4.swizzle(l,2,3,0,1),a=SIMD.Float32x4.mul(n,r),a=SIMD.Float32x4.swizzle(a,1,0,3,2),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,a),l),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,a),c),a=SIMD.Float32x4.swizzle(a,2,3,0,1),l=SIMD.Float32x4.sub(SIMD.Float32x4.mul(i,a),l),c=SIMD.Float32x4.sub(c,SIMD.Float32x4.mul(o,a)),a=SIMD.Float32x4.mul(n,i),a=SIMD.Float32x4.swizzle(a,1,0,3,2),u=SIMD.Float32x4.sub(u,SIMD.Float32x4.mul(o,a)),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(r,a),l),a=SIMD.Float32x4.swizzle(a,2,3,0,1),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(o,a),u),l=SIMD.Float32x4.sub(l,SIMD.Float32x4.mul(r,a)),a=SIMD.Float32x4.mul(n,o),a=SIMD.Float32x4.swizzle(a,1,0,3,2),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,a),u),c=SIMD.Float32x4.sub(c,SIMD.Float32x4.mul(r,a)),a=SIMD.Float32x4.swizzle(a,2,3,0,1),u=SIMD.Float32x4.sub(u,SIMD.Float32x4.mul(i,a)),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(r,a),c),p=SIMD.Float32x4.mul(n,s),p=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(p,2,3,0,1),p),p=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(p,1,0,3,2),p),a=SIMD.Float32x4.reciprocalApproximation(p),p=SIMD.Float32x4.sub(SIMD.Float32x4.add(a,a),SIMD.Float32x4.mul(p,SIMD.Float32x4.mul(a,a))),(p=SIMD.Float32x4.swizzle(p,0,0,0,0))?(SIMD.Float32x4.store(e,0,SIMD.Float32x4.mul(p,s)),SIMD.Float32x4.store(e,4,SIMD.Float32x4.mul(p,u)),SIMD.Float32x4.store(e,8,SIMD.Float32x4.mul(p,l)),SIMD.Float32x4.store(e,12,SIMD.Float32x4.mul(p,c)),e):null},o.invert=r.USE_SIMD?o.SIMD.invert:o.scalar.invert,o.scalar.adjoint=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=t[4],s=t[5],u=t[6],l=t[7],c=t[8],p=t[9],d=t[10],f=t[11],h=t[12],m=t[13],g=t[14],v=t[15];return e[0]=s*(d*v-f*g)-p*(u*v-l*g)+m*(u*f-l*d),e[1]=-(r*(d*v-f*g)-p*(o*v-i*g)+m*(o*f-i*d)),e[2]=r*(u*v-l*g)-s*(o*v-i*g)+m*(o*l-i*u),e[3]=-(r*(u*f-l*d)-s*(o*f-i*d)+p*(o*l-i*u)),e[4]=-(a*(d*v-f*g)-c*(u*v-l*g)+h*(u*f-l*d)),e[5]=n*(d*v-f*g)-c*(o*v-i*g)+h*(o*f-i*d),e[6]=-(n*(u*v-l*g)-a*(o*v-i*g)+h*(o*l-i*u)),e[7]=n*(u*f-l*d)-a*(o*f-i*d)+c*(o*l-i*u),e[8]=a*(p*v-f*m)-c*(s*v-l*m)+h*(s*f-l*p),e[9]=-(n*(p*v-f*m)-c*(r*v-i*m)+h*(r*f-i*p)),e[10]=n*(s*v-l*m)-a*(r*v-i*m)+h*(r*l-i*s),e[11]=-(n*(s*f-l*p)-a*(r*f-i*p)+c*(r*l-i*s)),e[12]=-(a*(p*g-d*m)-c*(s*g-u*m)+h*(s*d-u*p)),e[13]=n*(p*g-d*m)-c*(r*g-o*m)+h*(r*d-o*p),e[14]=-(n*(s*g-u*m)-a*(r*g-o*m)+h*(r*u-o*s)),e[15]=n*(s*d-u*p)-a*(r*d-o*p)+c*(r*u-o*s),e},o.SIMD.adjoint=function(e,t){var n,r,o,i,a,s,u,l,c,p,d,f,h,n=SIMD.Float32x4.load(t,0),r=SIMD.Float32x4.load(t,4),o=SIMD.Float32x4.load(t,8),i=SIMD.Float32x4.load(t,12);return c=SIMD.Float32x4.shuffle(n,r,0,1,4,5),s=SIMD.Float32x4.shuffle(o,i,0,1,4,5),a=SIMD.Float32x4.shuffle(c,s,0,2,4,6),s=SIMD.Float32x4.shuffle(s,c,1,3,5,7),c=SIMD.Float32x4.shuffle(n,r,2,3,6,7),l=SIMD.Float32x4.shuffle(o,i,2,3,6,7),u=SIMD.Float32x4.shuffle(c,l,0,2,4,6),l=SIMD.Float32x4.shuffle(l,c,1,3,5,7),c=SIMD.Float32x4.mul(u,l),c=SIMD.Float32x4.swizzle(c,1,0,3,2),p=SIMD.Float32x4.mul(s,c),d=SIMD.Float32x4.mul(a,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),p=SIMD.Float32x4.sub(SIMD.Float32x4.mul(s,c),p),d=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,c),d),d=SIMD.Float32x4.swizzle(d,2,3,0,1),c=SIMD.Float32x4.mul(s,u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(l,c),p),h=SIMD.Float32x4.mul(a,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(l,c)),h=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,c),h),h=SIMD.Float32x4.swizzle(h,2,3,0,1),c=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,3,0,1),l),c=SIMD.Float32x4.swizzle(c,1,0,3,2),u=SIMD.Float32x4.swizzle(u,2,3,0,1),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),p),f=SIMD.Float32x4.mul(a,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(u,c)),f=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,c),f),f=SIMD.Float32x4.swizzle(f,2,3,0,1),c=SIMD.Float32x4.mul(a,s),c=SIMD.Float32x4.swizzle(c,1,0,3,2),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(l,c),f),h=SIMD.Float32x4.sub(SIMD.Float32x4.mul(u,c),h),c=SIMD.Float32x4.swizzle(c,2,3,0,1),f=SIMD.Float32x4.sub(SIMD.Float32x4.mul(l,c),f),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(u,c)),c=SIMD.Float32x4.mul(a,l),c=SIMD.Float32x4.swizzle(c,1,0,3,2),d=SIMD.Float32x4.sub(d,SIMD.Float32x4.mul(u,c)),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,c),f),c=SIMD.Float32x4.swizzle(c,2,3,0,1),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),d),f=SIMD.Float32x4.sub(f,SIMD.Float32x4.mul(s,c)),c=SIMD.Float32x4.mul(a,u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(l,c),d),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(s,c)),c=SIMD.Float32x4.swizzle(c,2,3,0,1),d=SIMD.Float32x4.sub(d,SIMD.Float32x4.mul(l,c)),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,c),h),SIMD.Float32x4.store(e,0,p),SIMD.Float32x4.store(e,4,d),SIMD.Float32x4.store(e,8,f),SIMD.Float32x4.store(e,12,h),e},o.adjoint=r.USE_SIMD?o.SIMD.adjoint:o.scalar.adjoint,o.determinant=function(e){var t=e[0],n=e[1],r=e[2],o=e[3],i=e[4],a=e[5],s=e[6],u=e[7],l=e[8],c=e[9],p=e[10],d=e[11],f=e[12],h=e[13],m=e[14],g=e[15];return(t*a-n*i)*(p*g-d*m)-(t*s-r*i)*(c*g-d*h)+(t*u-o*i)*(c*m-p*h)+(n*s-r*a)*(l*g-d*f)-(n*u-o*a)*(l*m-p*f)+(r*u-o*s)*(l*h-c*f)},o.SIMD.multiply=function(e,t,n){var r=SIMD.Float32x4.load(t,0),o=SIMD.Float32x4.load(t,4),i=SIMD.Float32x4.load(t,8),a=SIMD.Float32x4.load(t,12),s=SIMD.Float32x4.load(n,0),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,1,1,1,1),o),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,2,2,2),i),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,3,3,3,3),a))));SIMD.Float32x4.store(e,0,u);var l=SIMD.Float32x4.load(n,4),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(l,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(l,1,1,1,1),o),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(l,2,2,2,2),i),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(l,3,3,3,3),a))));SIMD.Float32x4.store(e,4,c);var p=SIMD.Float32x4.load(n,8),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,1,1,1,1),o),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,2,2,2,2),i),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,3,3,3,3),a))));SIMD.Float32x4.store(e,8,d);var f=SIMD.Float32x4.load(n,12),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,1,1,1,1),o),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,2,2,2,2),i),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,3,3,3,3),a))));return SIMD.Float32x4.store(e,12,h),e},o.scalar.multiply=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=t[6],c=t[7],p=t[8],d=t[9],f=t[10],h=t[11],m=t[12],g=t[13],v=t[14],b=t[15],y=n[0],_=n[1],E=n[2],w=n[3];return e[0]=y*r+_*s+E*p+w*m,e[1]=y*o+_*u+E*d+w*g,e[2]=y*i+_*l+E*f+w*v,e[3]=y*a+_*c+E*h+w*b,y=n[4],_=n[5],E=n[6],w=n[7],e[4]=y*r+_*s+E*p+w*m,e[5]=y*o+_*u+E*d+w*g,e[6]=y*i+_*l+E*f+w*v,e[7]=y*a+_*c+E*h+w*b,y=n[8],_=n[9],E=n[10],w=n[11],e[8]=y*r+_*s+E*p+w*m,e[9]=y*o+_*u+E*d+w*g,e[10]=y*i+_*l+E*f+w*v,e[11]=y*a+_*c+E*h+w*b,y=n[12],_=n[13],E=n[14],w=n[15],e[12]=y*r+_*s+E*p+w*m,e[13]=y*o+_*u+E*d+w*g,e[14]=y*i+_*l+E*f+w*v,e[15]=y*a+_*c+E*h+w*b,e},o.multiply=r.USE_SIMD?o.SIMD.multiply:o.scalar.multiply,o.mul=o.multiply,o.scalar.translate=function(e,t,n){var r,o,i,a,s,u,l,c,p,d,f,h,m=n[0],g=n[1],v=n[2];return t===e?(e[12]=t[0]*m+t[4]*g+t[8]*v+t[12],e[13]=t[1]*m+t[5]*g+t[9]*v+t[13],e[14]=t[2]*m+t[6]*g+t[10]*v+t[14],e[15]=t[3]*m+t[7]*g+t[11]*v+t[15]):(r=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=t[6],c=t[7],p=t[8],d=t[9],f=t[10],h=t[11],e[0]=r,e[1]=o,e[2]=i,e[3]=a,e[4]=s,e[5]=u,e[6]=l,e[7]=c,e[8]=p,e[9]=d,e[10]=f,e[11]=h,e[12]=r*m+s*g+p*v+t[12],e[13]=o*m+u*g+d*v+t[13],e[14]=i*m+l*g+f*v+t[14],e[15]=a*m+c*g+h*v+t[15]),e},o.SIMD.translate=function(e,t,n){var r=SIMD.Float32x4.load(t,0),o=SIMD.Float32x4.load(t,4),i=SIMD.Float32x4.load(t,8),a=SIMD.Float32x4.load(t,12),s=SIMD.Float32x4(n[0],n[1],n[2],0);t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11]),r=SIMD.Float32x4.mul(r,SIMD.Float32x4.swizzle(s,0,0,0,0)),o=SIMD.Float32x4.mul(o,SIMD.Float32x4.swizzle(s,1,1,1,1)),i=SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(s,2,2,2,2));var u=SIMD.Float32x4.add(r,SIMD.Float32x4.add(o,SIMD.Float32x4.add(i,a)));return SIMD.Float32x4.store(e,12,u),e},o.translate=r.USE_SIMD?o.SIMD.translate:o.scalar.translate,o.scalar.scale=function(e,t,n){var r=n[0],o=n[1],i=n[2];return e[0]=t[0]*r,e[1]=t[1]*r,e[2]=t[2]*r,e[3]=t[3]*r,e[4]=t[4]*o,e[5]=t[5]*o,e[6]=t[6]*o,e[7]=t[7]*o,e[8]=t[8]*i,e[9]=t[9]*i,e[10]=t[10]*i,e[11]=t[11]*i,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},o.SIMD.scale=function(e,t,n){var r,o,i,a=SIMD.Float32x4(n[0],n[1],n[2],0);return r=SIMD.Float32x4.load(t,0),SIMD.Float32x4.store(e,0,SIMD.Float32x4.mul(r,SIMD.Float32x4.swizzle(a,0,0,0,0))),o=SIMD.Float32x4.load(t,4),SIMD.Float32x4.store(e,4,SIMD.Float32x4.mul(o,SIMD.Float32x4.swizzle(a,1,1,1,1))),i=SIMD.Float32x4.load(t,8),SIMD.Float32x4.store(e,8,SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(a,2,2,2,2))),e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},o.scale=r.USE_SIMD?o.SIMD.scale:o.scalar.scale,o.rotate=function(e,t,n,o){var i,a,s,u,l,c,p,d,f,h,m,g,v,b,y,_,E,w,S,x,T,C,I,R,M=o[0],P=o[1],O=o[2],A=Math.sqrt(M*M+P*P+O*O);return Math.abs(A)<r.EPSILON?null:(A=1/A,M*=A,P*=A,O*=A,i=Math.sin(n),a=Math.cos(n),s=1-a,u=t[0],l=t[1],c=t[2],p=t[3],d=t[4],f=t[5],h=t[6],m=t[7],g=t[8],v=t[9],b=t[10],y=t[11],_=M*M*s+a,E=P*M*s+O*i,w=O*M*s-P*i,S=M*P*s-O*i,x=P*P*s+a,T=O*P*s+M*i,C=M*O*s+P*i,I=P*O*s-M*i,R=O*O*s+a,e[0]=u*_+d*E+g*w,e[1]=l*_+f*E+v*w,e[2]=c*_+h*E+b*w,e[3]=p*_+m*E+y*w,e[4]=u*S+d*x+g*T,e[5]=l*S+f*x+v*T,e[6]=c*S+h*x+b*T,e[7]=p*S+m*x+y*T,e[8]=u*C+d*I+g*R,e[9]=l*C+f*I+v*R,e[10]=c*C+h*I+b*R,e[11]=p*C+m*I+y*R,t!==e&&(e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e)},o.scalar.rotateX=function(e,t,n){var r=Math.sin(n),o=Math.cos(n),i=t[4],a=t[5],s=t[6],u=t[7],l=t[8],c=t[9],p=t[10],d=t[11];return t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[4]=i*o+l*r,e[5]=a*o+c*r,e[6]=s*o+p*r,e[7]=u*o+d*r,e[8]=l*o-i*r,e[9]=c*o-a*r,e[10]=p*o-s*r,e[11]=d*o-u*r,e},o.SIMD.rotateX=function(e,t,n){var r=SIMD.Float32x4.splat(Math.sin(n)),o=SIMD.Float32x4.splat(Math.cos(n));t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]);var i=SIMD.Float32x4.load(t,4),a=SIMD.Float32x4.load(t,8);return SIMD.Float32x4.store(e,4,SIMD.Float32x4.add(SIMD.Float32x4.mul(i,o),SIMD.Float32x4.mul(a,r))),SIMD.Float32x4.store(e,8,SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,o),SIMD.Float32x4.mul(i,r))),e},o.rotateX=r.USE_SIMD?o.SIMD.rotateX:o.scalar.rotateX,o.scalar.rotateY=function(e,t,n){var r=Math.sin(n),o=Math.cos(n),i=t[0],a=t[1],s=t[2],u=t[3],l=t[8],c=t[9],p=t[10],d=t[11];return t!==e&&(e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=i*o-l*r,e[1]=a*o-c*r,e[2]=s*o-p*r,e[3]=u*o-d*r,e[8]=i*r+l*o,e[9]=a*r+c*o,e[10]=s*r+p*o,e[11]=u*r+d*o,e},o.SIMD.rotateY=function(e,t,n){var r=SIMD.Float32x4.splat(Math.sin(n)),o=SIMD.Float32x4.splat(Math.cos(n));t!==e&&(e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]);var i=SIMD.Float32x4.load(t,0),a=SIMD.Float32x4.load(t,8);return SIMD.Float32x4.store(e,0,SIMD.Float32x4.sub(SIMD.Float32x4.mul(i,o),SIMD.Float32x4.mul(a,r))),SIMD.Float32x4.store(e,8,SIMD.Float32x4.add(SIMD.Float32x4.mul(i,r),SIMD.Float32x4.mul(a,o))),e},o.rotateY=r.USE_SIMD?o.SIMD.rotateY:o.scalar.rotateY,o.scalar.rotateZ=function(e,t,n){var r=Math.sin(n),o=Math.cos(n),i=t[0],a=t[1],s=t[2],u=t[3],l=t[4],c=t[5],p=t[6],d=t[7];return t!==e&&(e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=i*o+l*r,e[1]=a*o+c*r,e[2]=s*o+p*r,e[3]=u*o+d*r,e[4]=l*o-i*r,e[5]=c*o-a*r,e[6]=p*o-s*r,e[7]=d*o-u*r,e},o.SIMD.rotateZ=function(e,t,n){var r=SIMD.Float32x4.splat(Math.sin(n)),o=SIMD.Float32x4.splat(Math.cos(n));t!==e&&(e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]);var i=SIMD.Float32x4.load(t,0),a=SIMD.Float32x4.load(t,4);return SIMD.Float32x4.store(e,0,SIMD.Float32x4.add(SIMD.Float32x4.mul(i,o),SIMD.Float32x4.mul(a,r))),SIMD.Float32x4.store(e,4,SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,o),SIMD.Float32x4.mul(i,r))),e},o.rotateZ=r.USE_SIMD?o.SIMD.rotateZ:o.scalar.rotateZ,o.fromTranslation=function(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=t[0],e[13]=t[1],e[14]=t[2],e[15]=1,e},o.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=t[1],e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=t[2],e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},o.fromRotation=function(e,t,n){var o,i,a,s=n[0],u=n[1],l=n[2],c=Math.sqrt(s*s+u*u+l*l);return Math.abs(c)<r.EPSILON?null:(c=1/c,s*=c,u*=c,l*=c,o=Math.sin(t),i=Math.cos(t),a=1-i,e[0]=s*s*a+i,e[1]=u*s*a+l*o,e[2]=l*s*a-u*o,e[3]=0,e[4]=s*u*a-l*o,e[5]=u*u*a+i,e[6]=l*u*a+s*o,e[7]=0,e[8]=s*l*a+u*o,e[9]=u*l*a-s*o,e[10]=l*l*a+i,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e)},o.fromXRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=r,e[6]=n,e[7]=0,e[8]=0,e[9]=-n,e[10]=r,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},o.fromYRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=0,e[2]=-n,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=n,e[9]=0,e[10]=r,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},o.fromZRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=0,e[3]=0,e[4]=-n,e[5]=r,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},o.fromRotationTranslation=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=r+r,u=o+o,l=i+i,c=r*s,p=r*u,d=r*l,f=o*u,h=o*l,m=i*l,g=a*s,v=a*u,b=a*l;return e[0]=1-(f+m),e[1]=p+b,e[2]=d-v,e[3]=0,e[4]=p-b,e[5]=1-(c+m),e[6]=h+g,e[7]=0,e[8]=d+v,e[9]=h-g,e[10]=1-(c+f),e[11]=0,e[12]=n[0],e[13]=n[1],e[14]=n[2],e[15]=1,e},o.getTranslation=function(e,t){return e[0]=t[12],e[1]=t[13],e[2]=t[14],e},o.getRotation=function(e,t){var n=t[0]+t[5]+t[10],r=0;return n>0?(r=2*Math.sqrt(n+1),e[3]=.25*r,e[0]=(t[6]-t[9])/r,e[1]=(t[8]-t[2])/r,e[2]=(t[1]-t[4])/r):t[0]>t[5]&t[0]>t[10]?(r=2*Math.sqrt(1+t[0]-t[5]-t[10]),e[3]=(t[6]-t[9])/r,e[0]=.25*r,e[1]=(t[1]+t[4])/r,e[2]=(t[8]+t[2])/r):t[5]>t[10]?(r=2*Math.sqrt(1+t[5]-t[0]-t[10]),e[3]=(t[8]-t[2])/r,e[0]=(t[1]+t[4])/r,e[1]=.25*r,e[2]=(t[6]+t[9])/r):(r=2*Math.sqrt(1+t[10]-t[0]-t[5]),e[3]=(t[1]-t[4])/r,e[0]=(t[8]+t[2])/r,e[1]=(t[6]+t[9])/r,e[2]=.25*r),e},o.fromRotationTranslationScale=function(e,t,n,r){var o=t[0],i=t[1],a=t[2],s=t[3],u=o+o,l=i+i,c=a+a,p=o*u,d=o*l,f=o*c,h=i*l,m=i*c,g=a*c,v=s*u,b=s*l,y=s*c,_=r[0],E=r[1],w=r[2];return e[0]=(1-(h+g))*_,e[1]=(d+y)*_,e[2]=(f-b)*_,e[3]=0,e[4]=(d-y)*E,e[5]=(1-(p+g))*E,e[6]=(m+v)*E,e[7]=0,e[8]=(f+b)*w,e[9]=(m-v)*w,e[10]=(1-(p+h))*w,e[11]=0,e[12]=n[0],e[13]=n[1],e[14]=n[2],e[15]=1,e},o.fromRotationTranslationScaleOrigin=function(e,t,n,r,o){var i=t[0],a=t[1],s=t[2],u=t[3],l=i+i,c=a+a,p=s+s,d=i*l,f=i*c,h=i*p,m=a*c,g=a*p,v=s*p,b=u*l,y=u*c,_=u*p,E=r[0],w=r[1],S=r[2],x=o[0],T=o[1],C=o[2];return e[0]=(1-(m+v))*E,e[1]=(f+_)*E,e[2]=(h-y)*E,e[3]=0,e[4]=(f-_)*w,e[5]=(1-(d+v))*w,e[6]=(g+b)*w,e[7]=0,e[8]=(h+y)*S,e[9]=(g-b)*S,e[10]=(1-(d+m))*S,e[11]=0,e[12]=n[0]+x-(e[0]*x+e[4]*T+e[8]*C),e[13]=n[1]+T-(e[1]*x+e[5]*T+e[9]*C),e[14]=n[2]+C-(e[2]*x+e[6]*T+e[10]*C),e[15]=1,e},o.fromQuat=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=n+n,s=r+r,u=o+o,l=n*a,c=r*a,p=r*s,d=o*a,f=o*s,h=o*u,m=i*a,g=i*s,v=i*u;return e[0]=1-p-h,e[1]=c+v,e[2]=d-g,e[3]=0,e[4]=c-v,e[5]=1-l-h,e[6]=f+m,e[7]=0,e[8]=d+g,e[9]=f-m,e[10]=1-l-p,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},o.frustum=function(e,t,n,r,o,i,a){var s=1/(n-t),u=1/(o-r),l=1/(i-a);return e[0]=2*i*s,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=2*i*u,e[6]=0,e[7]=0,e[8]=(n+t)*s,e[9]=(o+r)*u,e[10]=(a+i)*l,e[11]=-1,e[12]=0,e[13]=0,e[14]=a*i*2*l,e[15]=0,e},o.perspective=function(e,t,n,r,o){var i=1/Math.tan(t/2),a=1/(r-o);return e[0]=i/n,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=i,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=(o+r)*a,e[11]=-1,e[12]=0,e[13]=0,e[14]=2*o*r*a,e[15]=0,e},o.perspectiveFromFieldOfView=function(e,t,n,r){var o=Math.tan(t.upDegrees*Math.PI/180),i=Math.tan(t.downDegrees*Math.PI/180),a=Math.tan(t.leftDegrees*Math.PI/180),s=Math.tan(t.rightDegrees*Math.PI/180),u=2/(a+s),l=2/(o+i);return e[0]=u,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=l,e[6]=0,e[7]=0,e[8]=-((a-s)*u*.5),e[9]=(o-i)*l*.5,e[10]=r/(n-r),e[11]=-1,e[12]=0,e[13]=0,e[14]=r*n/(n-r),e[15]=0,e},o.ortho=function(e,t,n,r,o,i,a){var s=1/(t-n),u=1/(r-o),l=1/(i-a);return e[0]=-2*s,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=-2*u,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=2*l,e[11]=0,e[12]=(t+n)*s,e[13]=(o+r)*u,e[14]=(a+i)*l,e[15]=1,e},o.lookAt=function(e,t,n,i){var a,s,u,l,c,p,d,f,h,m,g=t[0],v=t[1],b=t[2],y=i[0],_=i[1],E=i[2],w=n[0],S=n[1],x=n[2];return Math.abs(g-w)<r.EPSILON&&Math.abs(v-S)<r.EPSILON&&Math.abs(b-x)<r.EPSILON?o.identity(e):(d=g-w,f=v-S,h=b-x,m=1/Math.sqrt(d*d+f*f+h*h),d*=m,f*=m,h*=m,a=_*h-E*f,s=E*d-y*h,u=y*f-_*d,m=Math.sqrt(a*a+s*s+u*u),m?(m=1/m,a*=m,s*=m,u*=m):(a=0,s=0,u=0),l=f*u-h*s,c=h*a-d*u,p=d*s-f*a,m=Math.sqrt(l*l+c*c+p*p),m?(m=1/m,l*=m,c*=m,p*=m):(l=0,c=0,p=0),e[0]=a,e[1]=l,e[2]=d,e[3]=0,e[4]=s,e[5]=c,e[6]=f,e[7]=0,e[8]=u,e[9]=p,e[10]=h,e[11]=0,e[12]=-(a*g+s*v+u*b),e[13]=-(l*g+c*v+p*b),e[14]=-(d*g+f*v+h*b),e[15]=1,e)},o.str=function(e){return"mat4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+", "+e[9]+", "+e[10]+", "+e[11]+", "+e[12]+", "+e[13]+", "+e[14]+", "+e[15]+")"},o.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+Math.pow(e[6],2)+Math.pow(e[7],2)+Math.pow(e[8],2)+Math.pow(e[9],2)+Math.pow(e[10],2)+Math.pow(e[11],2)+Math.pow(e[12],2)+Math.pow(e[13],2)+Math.pow(e[14],2)+Math.pow(e[15],2))},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e[6]=t[6]+n[6],e[7]=t[7]+n[7],e[8]=t[8]+n[8],e[9]=t[9]+n[9],e[10]=t[10]+n[10],e[11]=t[11]+n[11],e[12]=t[12]+n[12],e[13]=t[13]+n[13],e[14]=t[14]+n[14],e[15]=t[15]+n[15],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e[6]=t[6]-n[6],e[7]=t[7]-n[7],e[8]=t[8]-n[8],e[9]=t[9]-n[9],e[10]=t[10]-n[10],e[11]=t[11]-n[11],e[12]=t[12]-n[12],e[13]=t[13]-n[13],e[14]=t[14]-n[14],e[15]=t[15]-n[15],e},o.sub=o.subtract,o.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e[8]=t[8]*n,e[9]=t[9]*n,e[10]=t[10]*n,e[11]=t[11]*n,e[12]=t[12]*n,e[13]=t[13]*n,e[14]=t[14]*n,e[15]=t[15]*n,e},o.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e[4]=t[4]+n[4]*r,e[5]=t[5]+n[5]*r,e[6]=t[6]+n[6]*r,e[7]=t[7]+n[7]*r,e[8]=t[8]+n[8]*r,e[9]=t[9]+n[9]*r,e[10]=t[10]+n[10]*r,e[11]=t[11]+n[11]*r,e[12]=t[12]+n[12]*r,e[13]=t[13]+n[13]*r,e[14]=t[14]+n[14]*r,e[15]=t[15]+n[15]*r,e},o.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]&&e[9]===t[9]&&e[10]===t[10]&&e[11]===t[11]&&e[12]===t[12]&&e[13]===t[13]&&e[14]===t[14]&&e[15]===t[15]},o.equals=function(e,t){var n=e[0],o=e[1],i=e[2],a=e[3],s=e[4],u=e[5],l=e[6],c=e[7],p=e[8],d=e[9],f=e[10],h=e[11],m=e[12],g=e[13],v=e[14],b=e[15],y=t[0],_=t[1],E=t[2],w=t[3],S=t[4],x=t[5],T=t[6],C=t[7],I=t[8],R=t[9],M=t[10],P=t[11],O=t[12],A=t[13],D=t[14],k=t[15];return Math.abs(n-y)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(y))&&Math.abs(o-_)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(_))&&Math.abs(i-E)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(E))&&Math.abs(a-w)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(w))&&Math.abs(s-S)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(S))&&Math.abs(u-x)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(x))&&Math.abs(l-T)<=r.EPSILON*Math.max(1,Math.abs(l),Math.abs(T))&&Math.abs(c-C)<=r.EPSILON*Math.max(1,Math.abs(c),Math.abs(C))&&Math.abs(p-I)<=r.EPSILON*Math.max(1,Math.abs(p),Math.abs(I))&&Math.abs(d-R)<=r.EPSILON*Math.max(1,Math.abs(d),Math.abs(R))&&Math.abs(f-M)<=r.EPSILON*Math.max(1,Math.abs(f),Math.abs(M))&&Math.abs(h-P)<=r.EPSILON*Math.max(1,Math.abs(h),Math.abs(P))&&Math.abs(m-O)<=r.EPSILON*Math.max(1,Math.abs(m),Math.abs(O))&&Math.abs(g-A)<=r.EPSILON*Math.max(1,Math.abs(g),Math.abs(A))&&Math.abs(v-D)<=r.EPSILON*Math.max(1,Math.abs(v),Math.abs(D))&&Math.abs(b-k)<=r.EPSILON*Math.max(1,Math.abs(b),Math.abs(k))},e.exports=o},function(e,t,n){var r=n(53),o=n(262),i=n(263),a=n(264),s={};s.create=function(){var e=new r.ARRAY_TYPE(4);return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e},s.rotationTo=function(){var e=i.create(),t=i.fromValues(1,0,0),n=i.fromValues(0,1,0);return function(r,o,a){var u=i.dot(o,a);return u<-.999999?(i.cross(e,t,o),i.length(e)<1e-6&&i.cross(e,n,o),i.normalize(e,e),s.setAxisAngle(r,e,Math.PI),r):u>.999999?(r[0]=0,r[1]=0,r[2]=0,r[3]=1,r):(i.cross(e,o,a),r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=1+u,s.normalize(r,r))}}(),s.setAxes=function(){var e=o.create();return function(t,n,r,o){return e[0]=r[0],e[3]=r[1],e[6]=r[2],e[1]=o[0],e[4]=o[1],e[7]=o[2],e[2]=-n[0],e[5]=-n[1],e[8]=-n[2],s.normalize(t,s.fromMat3(t,e))}}(),s.clone=a.clone,s.fromValues=a.fromValues,s.copy=a.copy,s.set=a.set,s.identity=function(e){return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e},s.setAxisAngle=function(e,t,n){n*=.5;var r=Math.sin(n);return e[0]=r*t[0],e[1]=r*t[1],e[2]=r*t[2],e[3]=Math.cos(n),e},s.getAxisAngle=function(e,t){var n=2*Math.acos(t[3]),r=Math.sin(n/2);return 0!=r?(e[0]=t[0]/r,e[1]=t[1]/r,e[2]=t[2]/r):(e[0]=1,e[1]=0,e[2]=0),n},s.add=a.add,s.multiply=function(e,t,n){var r=t[0],o=t[1],i=t[2],a=t[3],s=n[0],u=n[1],l=n[2],c=n[3];return e[0]=r*c+a*s+o*l-i*u,e[1]=o*c+a*u+i*s-r*l,e[2]=i*c+a*l+r*u-o*s,e[3]=a*c-r*s-o*u-i*l,e},s.mul=s.multiply,s.scale=a.scale,s.rotateX=function(e,t,n){n*=.5;var r=t[0],o=t[1],i=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u+a*s,e[1]=o*u+i*s,e[2]=i*u-o*s,e[3]=a*u-r*s,e},s.rotateY=function(e,t,n){n*=.5;var r=t[0],o=t[1],i=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u-i*s,e[1]=o*u+a*s,e[2]=i*u+r*s,e[3]=a*u-o*s,e},s.rotateZ=function(e,t,n){n*=.5;var r=t[0],o=t[1],i=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u+o*s,e[1]=o*u-r*s,e[2]=i*u+a*s,e[3]=a*u-i*s,e},s.calculateW=function(e,t){var n=t[0],r=t[1],o=t[2];return e[0]=n,e[1]=r,e[2]=o,e[3]=Math.sqrt(Math.abs(1-n*n-r*r-o*o)),e},s.dot=a.dot,s.lerp=a.lerp,s.slerp=function(e,t,n,r){var o,i,a,s,u,l=t[0],c=t[1],p=t[2],d=t[3],f=n[0],h=n[1],m=n[2],g=n[3];return i=l*f+c*h+p*m+d*g,i<0&&(i=-i,f=-f,h=-h,m=-m,g=-g),1-i>1e-6?(o=Math.acos(i),a=Math.sin(o),s=Math.sin((1-r)*o)/a,u=Math.sin(r*o)/a):(s=1-r,u=r),e[0]=s*l+u*f,e[1]=s*c+u*h,e[2]=s*p+u*m,e[3]=s*d+u*g,e},s.sqlerp=function(){var e=s.create(),t=s.create();return function(n,r,o,i,a,u){return s.slerp(e,r,a,u),s.slerp(t,o,i,u),s.slerp(n,e,t,2*u*(1-u)),n}}(),s.invert=function(e,t){var n=t[0],r=t[1],o=t[2],i=t[3],a=n*n+r*r+o*o+i*i,s=a?1/a:0;return e[0]=-n*s,e[1]=-r*s,e[2]=-o*s,e[3]=i*s,e},s.conjugate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=t[3],e},s.length=a.length,s.len=s.length,s.squaredLength=a.squaredLength,s.sqrLen=s.squaredLength,s.normalize=a.normalize,s.fromMat3=function(e,t){var n,r=t[0]+t[4]+t[8];if(r>0)n=Math.sqrt(r+1),e[3]=.5*n,n=.5/n,e[0]=(t[5]-t[7])*n,e[1]=(t[6]-t[2])*n,e[2]=(t[1]-t[3])*n;else{var o=0;t[4]>t[0]&&(o=1),t[8]>t[3*o+o]&&(o=2);var i=(o+1)%3,a=(o+2)%3;n=Math.sqrt(t[3*o+o]-t[3*i+i]-t[3*a+a]+1),e[o]=.5*n,n=.5/n,e[3]=(t[3*i+a]-t[3*a+i])*n,e[i]=(t[3*i+o]+t[3*o+i])*n,e[a]=(t[3*a+o]+t[3*o+a])*n}return e},s.str=function(e){return"quat("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},s.exactEquals=a.exactEquals,s.equals=a.equals,e.exports=s},function(e,t,n){var r=n(53),o={};o.create=function(){var e=new r.ARRAY_TYPE(2);return e[0]=0,e[1]=0,e},o.clone=function(e){var t=new r.ARRAY_TYPE(2);return t[0]=e[0],t[1]=e[1],t},o.fromValues=function(e,t){var n=new r.ARRAY_TYPE(2);return n[0]=e,n[1]=t,n},o.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e},o.set=function(e,t,n){return e[0]=t,e[1]=n,e},o.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e},o.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e},o.sub=o.subtract,o.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e},o.mul=o.multiply,o.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e},o.div=o.divide,o.ceil=function(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e},o.floor=function(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e},o.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e},o.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e},o.round=function(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e},o.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e},o.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e},o.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1];return Math.sqrt(n*n+r*r)},o.dist=o.distance,o.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1];return n*n+r*r},o.sqrDist=o.squaredDistance,o.length=function(e){var t=e[0],n=e[1];return Math.sqrt(t*t+n*n)},o.len=o.length,o.squaredLength=function(e){var t=e[0],n=e[1];return t*t+n*n},o.sqrLen=o.squaredLength,o.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e},o.inverse=function(e,t){return e[0]=1/t[0],e[1]=1/t[1],e},o.normalize=function(e,t){var n=t[0],r=t[1],o=n*n+r*r;return o>0&&(o=1/Math.sqrt(o),e[0]=t[0]*o,e[1]=t[1]*o),e},o.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]},o.cross=function(e,t,n){var r=t[0]*n[1]-t[1]*n[0];return e[0]=e[1]=0,e[2]=r,e},o.lerp=function(e,t,n,r){var o=t[0],i=t[1];return e[0]=o+r*(n[0]-o),e[1]=i+r*(n[1]-i),e},o.random=function(e,t){t=t||1;var n=2*r.RANDOM()*Math.PI;return e[0]=Math.cos(n)*t,e[1]=Math.sin(n)*t,e},o.transformMat2=function(e,t,n){var r=t[0],o=t[1];return e[0]=n[0]*r+n[2]*o,e[1]=n[1]*r+n[3]*o,e},o.transformMat2d=function(e,t,n){var r=t[0],o=t[1];return e[0]=n[0]*r+n[2]*o+n[4],e[1]=n[1]*r+n[3]*o+n[5],e},o.transformMat3=function(e,t,n){var r=t[0],o=t[1];return e[0]=n[0]*r+n[3]*o+n[6],e[1]=n[1]*r+n[4]*o+n[7],e},o.transformMat4=function(e,t,n){var r=t[0],o=t[1];return e[0]=n[0]*r+n[4]*o+n[12],e[1]=n[1]*r+n[5]*o+n[13],e},o.forEach=function(){var e=o.create();return function(t,n,r,o,i,a){var s,u;for(n||(n=2),r||(r=0),u=o?Math.min(o*n+r,t.length):t.length,s=r;s<u;s+=n)e[0]=t[s],e[1]=t[s+1],i(e,e,a),t[s]=e[0],t[s+1]=e[1];return t}}(),o.str=function(e){return"vec2("+e[0]+", "+e[1]+")"},o.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]},o.equals=function(e,t){var n=e[0],o=e[1],i=t[0],a=t[1];return Math.abs(n-i)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(i))&&Math.abs(o-a)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(a))},e.exports=o},function(e,t,n){e.exports=n(123).call(Function.call,Object.prototype.hasOwnProperty)},function(e,t,n){"use strict";var r={childContextTypes:!0,contextTypes:!0,defaultProps:!0,displayName:!0,getDefaultProps:!0,mixins:!0,propTypes:!0,type:!0},o={name:!0,length:!0,prototype:!0,caller:!0,arguments:!0,arity:!0},i="function"==typeof Object.getOwnPropertySymbols;e.exports=function(e,t,n){if("string"!=typeof t){var a=Object.getOwnPropertyNames(t);i&&(a=a.concat(Object.getOwnPropertySymbols(t)));for(var s=0;s<a.length;++s)if(!(r[a[s]]||o[a[s]]||n&&n[a[s]]))try{e[a[s]]=t[a[s]]}catch(e){}}return e}},function(e,t,n){"use strict";e.exports=function(e,t,n,r,o,i,a,s){if(!e){var u;if(void 0===t)u=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var l=[n,r,o,i,a,s],c=0;u=new Error(t.replace(/%s/g,function(){return l[c++]})),u.name="Invariant Violation"}throw u.framesToPop=1,u}}},function(e,t,n){"use strict";var r=Date.prototype.getDay,o=function(e){try{return r.call(e),!0}catch(e){return!1}},i=Object.prototype.toString,a="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;e.exports=function(e){return"object"==typeof e&&null!==e&&(a?o(e):"[object Date]"===i.call(e))}},function(e,t,n){"use strict";var r=n(611),o=RegExp.prototype.exec,i=Object.getOwnPropertyDescriptor,a=function(e){try{var t=e.lastIndex;return e.lastIndex=0,o.call(e),!0}catch(e){return!1}finally{e.lastIndex=t}},s=Object.prototype.toString,u="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;e.exports=function(e){if(!e||"object"!=typeof e)return!1;if(!u)return"[object RegExp]"===s.call(e);var t=i(e,"lastIndex");return!(!t||!r(t,"value"))&&a(e)}},function(e,t,n){"use strict";var r=Object.prototype.toString;if("function"==typeof Symbol&&"symbol"==typeof Symbol()){var o=Symbol.prototype.toString,i=/^Symbol\(.*\)$/,a=function(e){return"symbol"==typeof e.valueOf()&&i.test(o.call(e))};e.exports=function(e){if("symbol"==typeof e)return!0;if("[object Symbol]"!==r.call(e))return!1;try{return a(e)}catch(e){return!1}}}else e.exports=function(e){return!1}},function(e,t){function n(e){var t=window.document.createElement("script");t.async=!0,t.type="text/javascript",t.src=("https:"===window.document.location.protocol?"https:":"http:")+"//www.googletagservices.com/tag/js/gpt.js",window.document.head.appendChild(t),t.addEventListener("error",e.onError)}function r(e){i||(i=window.googletag=window.googletag||{},i.cmd=i.cmd||[],n(e),i.cmd.push(function(){i.pubads().disableInitialLoad(),i.enableServices()}))}function o(){}var i,a=[];t.create=function(e){function t(e,t,n,r){if(e&&t){var o=r||[];2===o.length&&"string"==typeof o[0]&&(o=[o]),i.cmd.push(function(){var r=i.defineSlot(t,n||[],e);a[e]=r;for(var s=0;s<o.length;s++){var u=o[s];2===u.length&&(r=r.setTargeting(u[0],u[1]))}r=r.setCollapseEmptyDiv(!0).addService(i.pubads()),i.display(e),i.pubads().refresh([r])})}}function n(e,t){i.cmd.push(function(){i.display(e),i.pubads().refresh([t])})}function s(e,t){i.cmd.push(function(){i.pubads().addEventListener(e,t)})}function u(e){return a[e]}var l=e||{};return l.onError=l.onError||o,r(l),{addPlacement:t,addEventListener:s,getSlotById:u,refreshPlacement:n}}},function(e,t){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var o=n[r]={exports:{},id:r,loaded:!1};return e[r].call(o.exports,o,o.exports,t),o.loaded=!0,o.exports}var n={};return t.m=e,t.c=n,t.p="_build/157",t(0)}([function(e,t,n){e.exports=n(1)},function(e,t,n){function r(e){o.forOwn({post:function(e,t,n){},handleError:function(e){},getWidth:function(){},getHeight:function(){},getUsername:function(){},getLocation:function(){},getReferrer:function(){},getSource:function(){},getOrigin:function(){},getLanguage:function(){},setTimeout:function(e,t){},clearTimeout:function(e){},setInterval:function(e,t){},clearInterval:function(e){},nagleTimeout:0},function(t,n){if(void 0===e[n]||null!==e[n]&&typeof e[n]!=typeof t)throw new Error("Initialization error: You must specify options correctly. On key "+n+" value "+e[n]+" is not of correct type "+typeof t)});var t={getUsername:e.getUsername,getLanguage:e.getLanguage,getLocation:e.getLocation,getReferrer:e.getReferrer,getSource:e.getSource,getWidth:e.getWidth,getHeight:e.getHeight,getBrowserSize:function(){return t.getWidth()+"x"+t.getHeight()}},n=function(t){e.post("/ping",{Accept:"application/json","Content-Type":"text/plain;charset=UTF-8"},t)},r=new i,m=new u(e.getOrigin()+"_tracking-v1.3.157");this._handlers={};var g=function(t){o.forOwn(t.handlers(),function(n,i){this._handlers[i]=this._handlers[i]||[],this._handlers[i].push(n.bind(t)),this[i]=function(t){var n=r.validate(i,t);if(n)return void e.handleError(new Error(JSON.stringify(n)));o.forEach(this._handlers[i],function(e){e.call(null,t)},this)}.bind(this)},this)}.bind(this),v=new c(e.handleError,m,n,t,e.setTimeout,e.clearTimeout,e.nagleTimeout);g(new s(m,n)),g(new a(m,n,e.setTimeout,e.clearTimeout)),g(new d(v)),g(new p(v)),g(new f(v)),g(new h(v,e.setTimeout,e.clearTimeout)),g(new l(m,n,t,e.setTimeout,e.clearTimeout)),this._handleError=e.handleError}var o=(n(2),n(3)),i=n(4).RequestValidator,a=n(7).MonitorHandler,s=n(8).IgnoreHandler,u=n(9).Wrapper,l=n(10).WebsiteSignalHandler,c=n(11).ReaderSignalHandler,p=n(13).LinkEventsHandler,d=n(14).SidebarHandler,f=n(15).ClipEventsHandler,h=n(12).DocumentEventsHandler;r.prototype.legacyInterface=function(){var e=function(){for(var e=0;e<arguments.length;e++){var t=arguments[e];if("object"!=typeof t&&"string"!=typeof t)return void this._handleError(new Error("Invalid argument: "+t+", it must be a string or an object."));var n="string"==typeof t?t:t.event,r="string"==typeof t?null:t.data;if(!this.hasOwnProperty(n))return void this._handleError(new Error("Unknown action: "+n+", please use this library according to the reference."));this[n](r)}}.bind(this);null!==window._tracq&&void 0!==window._tracq&&void 0!==window._tracq.length&&e.apply(null,window._tracq),window._tracq={push:e}},r.defaultWebConfiguration=function(){return n(16)},t.Tracker=r},function(e,t){Function.prototype.bind||(Function.prototype.bind=function(e){if("function"!=typeof this)throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");var t=Array.prototype.slice.call(arguments,1),n=this,r=function(){},o=function(){return n.apply(this instanceof r?this:e,t.concat(Array.prototype.slice.call(arguments)))};return this.prototype&&(r.prototype=this.prototype),o.prototype=new r,o})},function(e,t){function n(e,t,n){var r=p(e);if(t&&r)if(Array.prototype.forEach)for(var o=-1,i=e.length,a="object"==typeof n?n:e;++o<i&&t.call(a,e[o],o,e)!==!1;);else Array.prototype.forEach.call(e,t,n);return e}function r(e,t,n){var r=d(e);if(t&&r){var o="object"==typeof n?n:e;for(var i in e)if(e.hasOwnProperty(i)&&t.call(o,e[i],i,e)===!1)break}return e}function o(e,t){return r(t,function(t,n){e[n]=t}),e}function i(e){if(d(e)&&arguments.length>1)for(var t=1;t<arguments.length;t++)o(e,arguments[t]);return e}var a=Object.prototype.toString,s=a.call([]),u=String(a);u=u.replace(/[.*+?^${}()|[\]\\]/g,"\\$&"),u=u.replace(/toString| for [^\]]+/g,".*?");var l=new RegExp("^"+u+"$"),c=function(e){return"function"==typeof e&&l.test(e)}(c=Array.isArray)&&c,p=c||function(e){return e&&"object"==typeof e&&"number"==typeof e.length&&a.call(e)===s||!1},d=function(e){return e&&"object"==typeof e&&!p(e)};e.exports.isObject=d,e.exports.isArray=p,e.exports.forEach=n,e.exports.forOwn=r,e.exports.extend=i},function(e,t,n){function r(e){return/^\?(\w+)$/.test(e)}function o(e,t){var n=/^[\?]?(\w+)$/.exec(t);if(n&&n[1])return e[n[1]]}function i(e,t){switch(e){case"array":return u.isArray(t);case"null":case"undefined":return null===t||void 0===t;case"arrayOfNumbers":return p(t);default:return typeof t===e}}function a(e,t,n){var s;return!(!r(n)||!i("null",t))||(i("string",e)?i(e,t):"function"==typeof e?!!e(t):u.isArray(e)?(s=!1,u.forEach(e,function(e,n){return!(s=s||e===t)}),s):!(!u.isObject(e)||!u.isObject(t))&&(s=!0,u.forOwn(e,function(e,n){var r=o(t,n);return s=s&&a(e,r,n)}),s))}function s(){}var u=n(3),l=n(5),c=n(6),p=function(e){return function(t){if(u.isArray(t)){var n=!0;return u.forEach(t,function(t){return n=n&&a(e,t)}),n}return!1}}("number");s.prototype.validate=function(e,t){var n=u.extend({},l,c);if(n.hasOwnProperty(e)){var r=o(n,e);if(!a(r,t,e))return{action:e,expect:r,got:t}}},e.exports.RequestValidator=s},function(e,t){e.exports={webpageLoad:"null",streamScrolling:{index:"number"},documentShare:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",service:"string"},documentDownload:{anonymous:"boolean",revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string"},streamDocumentLoad:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string","?section":"string","?adpageId":"string",pageNumber:"number","?streamOrigin":"array",streamRanking:"number"},streamDocumentClick:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string","?adpageId":"string","?adpageToken":"string","?streamOrigin":"array",streamRanking:"number","?clickCoordinates":"string"},infoboxLoad:{infoboxId:"string","?streamOrigin":"array",streamRanking:"number"},infoboxClick:{infoboxId:"string",link:"string","?streamOrigin":"array",streamRanking:"number","?clickCoordinates":"string"},curatedLoad:{source:"string",link:"string",ranking:"number"},curatedClick:{source:"string",link:"string",ranking:"number"},embedLoad:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",embedId:"string"},embedClick:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",embedId:"string"},streamAdRequest:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number"},streamAdInserted:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number",timespan:"number"},streamAdNotAvailable:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number",timespan:"number"},streamAdImpression:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number"}}},function(e,t){e.exports={documentLoad:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",pages:"arrayOfNumbers",pageNumber:"number",isFullscreen:"boolean",isEmbed:"boolean","?embedId":"string","?adpageId":"string","?adpageToken":"string","?streamOrigin":"array","?streamRanking":"number"},documentUnLoad:"null",userInteracted:"null",pageChange:{pages:"arrayOfNumbers",pageNumber:"number"},zoom:"null",resize:{displaySize:"string",isFullscreen:"boolean"},linkClick:{url:"string",pageNumber:"number",linkPosition:"string"},watermarkClick:{url:"string"},ctaLoad:{type:"string",pageNumber:"number"},ctaClick:{type:"string",pageNumber:"number"},adpageLoad:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",adpageId:"string",absolutePosition:"number",relativePosition:"number"},adpageClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",adpageId:"string",adpageToken:"string",absolutePosition:"number",relativePosition:"number"},relatedLoad:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",absolutePosition:"number",relativePosition:"number"},relatedClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",absolutePosition:"number",relativePosition:"number"},moreContentDocumentShow:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",streamOrigin:"array",streamRanking:"number"},moreContentDocumentClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",streamOrigin:"array",streamRanking:"number"},archiveLoad:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",absolutePosition:"number",relativePosition:"number"},archiveClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",absolutePosition:"number",relativePosition:"number"},clippingLayer:{action:"string"},clippingComment:{onPage:"number",action:"string",clippingId:"string",commentId:"number","?url":"string",creator:"string"},clippingAction:{clippingId:"string",action:"string",onPage:"number",creator:"string","?url":"string","?page":"number","?service":"string","?videoid":"string","?opened_in_reader":"boolean"}}},function(e,t,n){function r(e,t,n,r){this.wrapper=e,this.post=t,this.setTimeout=n,this.clearTimeout=r,this._postBatchedTimeoutId=void 0,this._batchedQueue=[]}var o=n(3);r.prototype._queueLength=function(){return this._batchedQueue.length},r.prototype._addToQueue=function(e){this._batchedQueue.push(o.extend(e,{version:"1.0.0",type:e.type}))},r.prototype._startPostTimer=function(){void 0===this._postBatchedTimeoutId&&(this._postBatchedTimeoutId=this.setTimeout(function(){this._postBatchedTimeoutId=void 0,this._postAllQueued()}.bind(this),2e3))},r.prototype._postAllQueued=function(){if(0!==this._queueLength()){void 0!==this._postBatchedTimeoutId&&(this.clearTimeout(this._postBatchedTimeoutId),this._postBatchedTimeoutId=void 0);var e=this.wrapper.getSignalWrapper("monitor");e.data=this._batchedQueue,this._batchedQueue=[],this.post(e)}},r.prototype.monitor=function(e){this._addToQueue(e),this._postAllQueued()},r.prototype.monitorBatched=function(e){this._addToQueue(e),this._queueLength()>=20?this._postAllQueued():this._startPostTimer()},r.prototype.flush=function(){this._postAllQueued()},r.prototype.handlers=function(){return{monitor:this.monitor,monitorBatched:this.monitorBatched,flush:this.flush}},e.exports.MonitorHandler=r},function(e,t){function n(e,t){this.wrapper=e,this.post=t}n.prototype.ignore=function(e){var t=this.wrapper.getSignalWrapper("ignore");t.data=e,this.post(t)},n.prototype.flush=function(){},n.prototype.handlers=function(){return{ignore:this.ignore,flush:this.flush}},e.exports.IgnoreHandler=n},function(e,t){function n(e){this.origin=e}n.prototype.getSignalWrapper=function(e){return{version:"2.2.0",origin:this.origin,type:e}},e.exports.Wrapper=n},function(e,t,n){function r(e,t,n,r,o){this.sectionsDocImpression={},this.wrapper=e,this.post=t,this.environment=n,this.setTimeout=r,this.clearTimeout=o}var o=n(3);r.prototype.getSignalData=function(e){return{version:"2.2.2",username:e?null:this.environment.getUsername(),ui_language:this.environment.getLanguage(),location:this.environment.getLocation(),referrer:this.environment.getReferrer(),contexts:[]}},r.prototype.executePingbackIfPlatformHasChanged=function(){if(this.signal){var e=!1,t=this.getSignalData();o.forEach(["version","username","location","referrer"],function(n){e=e||this.signal.data[n]!==t[n]},this),e&&this.executePingback()}},r.prototype.isContextChanged=function(){var e=this.signal.data.contexts.length;return 0===e||this.signal.data.contexts[e-1].browser_size!==this.environment.getBrowserSize()},r.prototype.updateSignal=function(e){if(this.executePingbackIfPlatformHasChanged(),this.signal=this.signal||this.wrapper.getSignalWrapper("website"),this.signal.data=this.signal.data||this.getSignalData(),this.isContextChanged()&&this.signal.data.contexts.push({browser_size:this.environment.getBrowserSize(),events:[]}),e){this.signal.data.contexts[this.signal.data.contexts.length-1].events.push(e)}},r.prototype.timeoutPingback=function(){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0);for(var e=0,t=this.signal.data.contexts.length-1;t>=0;t--)e+=this.signal.data.contexts[t].events.length;e>=20?this.executePingback():this.timeoutId=this.setTimeout(this.executePingback.bind(this),1500)},r.prototype.executePingback=function(){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0),this.signal&&(this.post(this.signal),this.signal=void 0)},r.prototype.generateAndExecuteAnonymousPingback=function(e){var t=this.wrapper.getSignalWrapper("website");t.data=this.getSignalData(!0),t.data.contexts.push({browser_size:this.environment.getBrowserSize(),events:[e]}),this.post(t)},r.prototype.webpageLoadHandler=function(){this.sectionsDocImpression={},this.updateSignal({type:"webpage_load"}),this.timeoutPingback()},r.prototype.streamScrollingHandler=function(e){this.updateSignal({type:"webpage_continuation",index:e.index}),this.timeoutPingback()},r.prototype.documentShareHandler=function(e){this.updateSignal({type:"document_share",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),service:e.service}),this.executePingback()},r.prototype.documentDownloadHandler=function(e){var t={type:"document_download",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase()};e.anonymous&&this.environment.username?this.generateAndExecuteAnonymousPingback(t):(this.updateSignal(t),this.timeoutPingback())},r.prototype.getDocImpForSection=function(e){return this.sectionsDocImpression[e]=this.sectionsDocImpression[e]||{}},r.prototype.streamDocumentLoadHandler=function(e){if(e.section){var t=this.getDocImpForSection(e.section),n=e.publicationId;if(t[n])return;t[n]=!0}this.updateSignal({type:"document_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),ad_id:e.adpageId||null,page:e.pageNumber,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking}),this.timeoutPingback()},r.prototype.streamDocumentClickHandler=function(e){this.updateSignal({type:"document_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),ad_id:e.adpageId||null,ad_token:e.adpageToken||null,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking,click_coordinates:e.clickCoordinates||null}),this.executePingback()},r.prototype.infoboxLoadHandler=function(e){this.updateSignal({type:"infobox_impression",id:e.infoboxId,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking}),this.timeoutPingback()},r.prototype.infoboxClickHandler=function(e){this.updateSignal({type:"infobox_click",id:e.infoboxId,link:e.link,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking,click_coordinates:e.clickCoordinates||null}),this.executePingback()},r.prototype.curatedLoadHandler=function(e){this.updateSignal({type:"curated_impression",source:e.source,link:e.link,ranking:e.ranking}),this.timeoutPingback()},r.prototype.curatedClickHandler=function(e){this.updateSignal({type:"curated_click",source:e.source,link:e.link,ranking:e.ranking}),this.executePingback()},r.prototype.embedLoadHandler=function(e){this.updateSignal({type:"embed_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),embed_id:e.embedId}),this.executePingback()},r.prototype.embedClickHandler=function(e){this.updateSignal({type:"embed_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),embed_id:e.embedId}),this.executePingback()},r.prototype.streamAdRequestHandler=function(e){this.updateSignal({type:"stream_ad_request",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking}),this.timeoutPingback()},r.prototype.streamAdInsertedHandler=function(e){this.updateSignal({type:"stream_ad_inserted",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking,timespan:e.timespan}),this.timeoutPingback()},r.prototype.streamAdNotAvailableHandler=function(e){this.updateSignal({type:"stream_ad_not_available",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking,timespan:e.timespan}),this.timeoutPingback()},r.prototype.streamAdImpressionHandler=function(e){this.updateSignal({type:"stream_ad_impression",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking}),this.timeoutPingback()},r.prototype.flushHandler=function(e){this.executePingback()},r.prototype.handlers=function(){return{webpageLoad:this.webpageLoadHandler,streamScrolling:this.streamScrollingHandler,documentShare:this.documentShareHandler,documentDownload:this.documentDownloadHandler,streamDocumentLoad:this.streamDocumentLoadHandler,streamDocumentClick:this.streamDocumentClickHandler,infoboxLoad:this.infoboxLoadHandler,infoboxClick:this.infoboxClickHandler,curatedLoad:this.curatedLoadHandler,curatedClick:this.curatedClickHandler,embedLoad:this.embedLoadHandler,embedClick:this.embedClickHandler,streamAdRequest:this.streamAdRequestHandler,streamAdInserted:this.streamAdInsertedHandler,streamAdNotAvailable:this.streamAdNotAvailableHandler,streamAdImpression:this.streamAdImpressionHandler,flush:this.flushHandler}},e.exports.WebsiteSignalHandler=r},function(e,t,n){function r(){var e=[];return e.push("diic:"+u),e.push("dcic:"+l),e.push("dmo:"+c),e.push(n(12).getDebugString()),"("+e.join()+")"}function o(e){return{version:"1.3.3",username:e.getUsername(),ui_language:e.getLanguage(),location:e.getLocation(),referrer:e.getReferrer(),source:e.getSource(),contexts:[]}}function i(e,t){var n=e.data.contexts.length;if(0===n)return!0;var r=!1;return s.forEach(["doc_id","doc_creator","doc_name","ad_id","ad_token","embed_id","display_size","stream_origin","stream_ranking"],function(o){r=r||e.data.contexts[n-1][o]!==t[o]}),r=r||e.data.contexts[n-1].pages.toString()!==t.pages.toString()}function a(e,t,n,r,o,i,a){this.handleError=e,this.wrapper=t,this.post=n,this.environment=r,this.setTimeout=o,this.clearTimeout=i,this.nagleTimeout=a}var s=n(3),u=0,l=0,c=null;a.prototype.initializeModel=function(e){u++,this.model={doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),pages:e.pages,pageNumber:e.pageNumber,ad_id:e.adpageId||null,ad_token:e.adpageToken||null,is_embed:e.isEmbed,embed_id:e.embedId||null,display_size:e.displaySize||this.environment.getBrowserSize(),is_fullscreen:e.isFullscreen,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking,user_interacted:!1},c=this.model},a.prototype.clearModel=function(){l++,this.executePingback(),this.model=void 0},a.prototype.updateModel=function(e){this.model?(this.model.pages=e.pages||this.model.pages,this.model.display_size=e.displaySize||this.model.display_size,this.model.is_fullscreen=void 0!==e.isFullscreen?e.isFullscreen:this.model.is_fullscreen,this.model.user_interacted=e.userInteracted||this.model.user_interacted):this.handleError(new Error("reader pingback handler - update model - no model."+r()))},a.prototype.executePingbackIfPlatformHasChanged=function(){if(this.signal){var e=!1,t=o(this.environment);s.forEach(["version","username","location","referrer","source"],function(n){e=e||this.signal.data[n]!==t[n]},this),e&&this.executePingback()}},a.prototype.viewportHasUserAttention=function(){if(this.model)return!this.model.is_embed||this.model.is_fullscreen||this.model.user_interacted;this.handleError(new Error("reader pingback handler - viewportHasUserAttention - no model."+r()))},a.prototype.updateSignal=function(e){if(!this.model)return void this.handleError(new Error("reader pingback handler - update signal - no model."+r()));if(this.executePingbackIfPlatformHasChanged(),this.signal=this.signal||this.wrapper.getSignalWrapper("reader"),this.signal.data=this.signal.data||o(this.environment),i(this.signal,this.model)&&this.signal.data.contexts.push({doc_id:this.model.doc_id,doc_creator:this.model.doc_creator,doc_name:this.model.doc_name,pages:this.model.pages,ad_id:this.model.ad_id,ad_token:this.model.ad_token,embed_id:this.model.embed_id,display_size:this.model.display_size,display_state:null,stream_origin:this.model.stream_origin,stream_ranking:this.model.stream_ranking,events:[]}),e){var t=this.signal.data.contexts.length;t>0?this.signal.data.contexts[t-1].events.push(e):this.handleError(new Error("reader pingback handler context length invalid."))}},a.prototype.getCurrentPages=function(){if(this.model)return this.model.pages;this.handleError(new Error("reader pingback handler - get current pages - no model."+r()))},a.prototype.timeoutPingback=function(){if(this.signal){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0);for(var e=0,t=this.signal.data.contexts.length-1;t>=0;t--)e+=this.signal.data.contexts[t].events.length;e>=20?this.executePingback():this.timeoutId=this.setTimeout(this.executePingback.bind(this),this.nagleTimeout)}},a.prototype.executePingback=function(){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0),this.signal&&(this.post(this.signal),this.signal=void 0)},e.exports.ReaderSignalHandler=a},function(e,t){function n(e,t,n){this.readerSignalHandler=e,this.setTimeout=t,this.clearTimeout=n,this.eventsAfterDocumentRead=[],this.documentReadTimeoutId=void 0,this.documentReadTriggered=!1,this.pageReadLastPages=null,this.pageReadStartTime=null,this.pageReadLastEndTime=null,this.delays=null,this.pageReadTimeTimeoutId=void 0,this.idleTimeoutId=void 0}var r=[2e3,3e3,4e3,6e3,8e3,12e3],o=0;n.prototype.setUpPageReadTimers=function(){this.delays=r.slice(0),this.pageReadStartTime=this.pageReadLastEndTime=(new Date).getTime(),this.startPageReadTimer()},n.prototype.startPageReadTimer=function(){this.pageReadTimeTimeoutId=this.setTimeout(function(){this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime(),this.startPageReadTimer()}.bind(this),this.getNextPageReadTimeout())},n.prototype.startIdleTimer=function(){this.idleTimeoutId=this.setTimeout(function(){this.idleTimeoutId=void 0,void 0!==this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime())}.bind(this),6e5)},n.prototype.resetIdleTimer=function(){void 0!==this.idleTimeoutId?(this.clearTimeout(this.idleTimeoutId),this.idleTimeoutId=void 0):this.readerSignalHandler.viewportHasUserAttention()&&(this.pageReadLastEndTime=(new Date).getTime(),this.delays?this.startPageReadTimer():this.setUpPageReadTimers()),this.startIdleTimer()},n.prototype.clearTimers=function(){void 0!==this.idleTimeoutId&&(this.clearTimeout(this.idleTimeoutId),this.idleTimeoutId=void 0),void 0!==this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime()),void 0!==this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0)},n.prototype.getNextPageReadTimeout=function(){var e=this.delays.shift();if(isNaN(e)){return r[r.length-1]+.2*((new Date).getTime()-this.pageReadStartTime)}return e},n.prototype.trackDocumentImpression=function(e){this.readerSignalHandler.updateSignal({type:"document_impression"}),this.readerSignalHandler.timeoutPingback()},n.prototype.trackDocumentRead=function(){for(;this.eventsAfterDocumentRead.length>0;)this.readerSignalHandler.updateSignal(this.eventsAfterDocumentRead.shift());this.readerSignalHandler.updateSignal({type:"document_read"}),this.readerSignalHandler.executePingback(),this.documentReadTriggered=!0,this.documentReadTimeoutId=void 0},n.prototype.trackPageImpression=function(e){for(var t in e.pages){this.readerSignalHandler.updateSignal({type:"page_impression",page:e.pages[t]})}this.readerSignalHandler.timeoutPingback()},n.prototype.maybeTrackPageRead=function(){var e=this.readerSignalHandler.getCurrentPages(),t=JSON.stringify(e);if(this.pageReadLastPages!==t){this.pageReadLastPages=t;for(var n in e){var r={type:"page_read",page:e[n]};this.documentReadTriggered?this.readerSignalHandler.updateSignal(r):this.eventsAfterDocumentRead.push(r)}this.readerSignalHandler.timeoutPingback()}},n.prototype.trackPageReadTime=function(){var e=(new Date).getTime(),t=this.readerSignalHandler.getCurrentPages(),n=Math.floor((e-this.pageReadLastEndTime)/t.length);if(!(n<=0)){for(var r in t){var o={type:"page_read_time",time_increment:n,page:t[r]};this.documentReadTriggered?this.readerSignalHandler.updateSignal(o):this.eventsAfterDocumentRead.push(o)}this.pageReadLastEndTime=e,this.readerSignalHandler.timeoutPingback()}},n.prototype.maybeStartDocumentReadTimer=function(){void 0!==this.documentReadTimeoutId||this.documentReadTriggered||(this.documentReadTimeoutId=this.setTimeout(function(){this.trackDocumentRead()}.bind(this),2e3))},n.prototype.documentLoad=function(e){o++,this.clearTimers(),this.eventsAfterDocumentRead=[],this.readerSignalHandler.initializeModel(e),this.trackDocumentImpression(e),this.trackPageImpression(e),this.readerSignalHandler.viewportHasUserAttention()&&(this.maybeStartDocumentReadTimer(),this.maybeTrackPageRead(),this.setUpPageReadTimers()),this.startIdleTimer()},n.prototype.documentUnLoad=function(e){this.flush(),this.readerSignalHandler.clearModel()},n.prototype.userInteracted=function(){this.readerSignalHandler.updateModel({userInteracted:!0}),this.resetIdleTimer(),this.readerSignalHandler.viewportHasUserAttention()&&(this.maybeStartDocumentReadTimer(),this.maybeTrackPageRead(),this.setUpPageReadTimers()),void 0!==this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0,this.trackDocumentRead())},n.prototype.pageChange=function(e){this.resetIdleTimer(),void 0!==this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0,this.trackDocumentRead()),void 0!==this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime()),this.readerSignalHandler.updateModel(e),this.trackPageImpression(e),this.readerSignalHandler.viewportHasUserAttention()&&(this.maybeTrackPageRead(),this.setUpPageReadTimers())},n.prototype.zoom=function(e){this.resetIdleTimer()},n.prototype.resize=function(e){this.resetIdleTimer(),this.readerSignalHandler.updateModel(e),this.readerSignalHandler.viewportHasUserAttention()?(this.maybeStartDocumentReadTimer(),void 0===this.pageReadTimeTimeoutId&&this.setUpPageReadTimers(),this.maybeTrackPageRead()):(this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0),this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime()))},n.prototype.flush=function(e){this.clearTimers(),this.eventsAfterDocumentRead=[],this.readerSignalHandler.executePingback()},n.prototype.handlers=function(){return{documentLoad:this.documentLoad,documentUnLoad:this.documentUnLoad,userInteracted:this.userInteracted,pageChange:this.pageChange,zoom:this.zoom,resize:this.resize,flush:this.flush}},e.exports.DocumentEventsHandler=n,e.exports.getDebugString=function(){return"ddic:"+o}},function(e,t){function n(e){this.readerSignalHandler=e}n.prototype.linkClick=function(e){this.readerSignalHandler.updateSignal({type:"link_click",page:e.pageNumber,url:e.url,link_position:e.linkPosition}),this.readerSignalHandler.executePingback()},n.prototype.watermarkClick=function(e){this.readerSignalHandler.updateSignal({type:"watermark_click",url:e.url}),this.readerSignalHandler.executePingback()},n.prototype.ctaLoad=function(e){this.readerSignalHandler.updateSignal({type:"ad_cta_impression",cta_type:e.type,page:e.pageNumber}),this.readerSignalHandler.timeoutPingback()},n.prototype.ctaClick=function(e){this.readerSignalHandler.updateSignal({type:"ad_cta_click",cta_type:e.type,page:e.pageNumber}),this.readerSignalHandler.executePingback()},n.prototype.flush=function(e){},n.prototype.handlers=function(){return{linkClick:this.linkClick,watermarkClick:this.watermarkClick,ctaLoad:this.ctaLoad,ctaClick:this.ctaClick,flush:this.flush}},e.exports.LinkEventsHandler=n},function(e,t){function n(e){this.readerSignalHandler=e}n.prototype.adpageLoad=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_ad_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,ad_id:e.adpageId,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.timeoutPingback()},n.prototype.adpageClick=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_ad_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),ad_id:e.adpageId,token:e.adpageToken,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.executePingback()},n.prototype.relatedLoad=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_related_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.timeoutPingback()},n.prototype.relatedClick=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_related_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.executePingback()},n.prototype.moreContentDocumentShow=function(e){this.readerSignalHandler.updateSignal({type:"more_content_document_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,stream_origin:e.streamOrigin,stream_ranking:e.streamRanking}),this.readerSignalHandler.timeoutPingback()},n.prototype.moreContentDocumentClick=function(e){this.readerSignalHandler.updateSignal({type:"more_content_document_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),stream_origin:e.streamOrigin,stream_ranking:e.streamRanking}),this.readerSignalHandler.executePingback()},n.prototype.archiveLoad=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_archive_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.timeoutPingback()},n.prototype.archiveClick=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_archive_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.executePingback()},n.prototype.flush=function(e){},n.prototype.handlers=function(){return{adpageLoad:this.adpageLoad,adpageClick:this.adpageClick,relatedLoad:this.relatedLoad,relatedClick:this.relatedClick,archiveLoad:this.archiveLoad,archiveClick:this.archiveClick,moreContentDocumentShow:this.moreContentDocumentShow,moreContentDocumentClick:this.moreContentDocumentClick,flush:this.flush}},e.exports.SidebarHandler=n},function(e,t){function n(e){this.readerSignalHandler=e}n.prototype.clippingLayer=function(e){this.readerSignalHandler.updateSignal({type:"clipping_layer",action:e.action}),this.readerSignalHandler.timeoutPingback()},n.prototype.clippingAction=function(e){this.readerSignalHandler.updateSignal({type:"clipping_action",clippingId:e.clippingId,action:e.action,on_page:e.onPage,creator:e.creator,url:e.url,page:e.page,service:e.service,videoid:e.videoid,opened_in_reader:e.opened_in_reader}),this.readerSignalHandler.timeoutPingback()},n.prototype.clippingComment=function(e){this.readerSignalHandler.updateSignal({type:"clipping_comment",clippingId:e.clippingId,commentId:e.commentId,action:e.action,on_page:e.onPage,creator:e.creator,url:e.url}),this.readerSignalHandler.timeoutPingback()},n.prototype.flush=function(e){},n.prototype.handlers=function(){return{clippingLayer:this.clippingLayer,clippingAction:this.clippingAction,clippingComment:this.clippingComment,flush:this.flush}},e.exports.ClipEventsHandler=n},function(e,t){function n(e,t,n){var r="//"+d+e;n="string"==typeof n?n:JSON.stringify(n),window.fetch?window.fetch(r,{method:"post",headers:t,credentials:"include",body:n}).catch(function(t){console.log("frontend-tracking POST to "+d+e+" failed:",t)}):window.jQuery&&window.jQuery.ajax&&window.jQuery.ajax({type:"POST",url:r,data:n,crossDomain:!0,headers:t,xhrFields:{withCredentials:!0}}).fail(function(t){console.log("frontend-tracking POST to "+d+e+" failed:",t)})}function r(e){var t=window.Raven;t&&t.captureException?t.captureException(e):console.error(e)}function o(){var e=document.cookie.match(/site\.model\.username=([^;$]+)/);return e&&e.length>=2?e[1]:null}function i(){return window.innerWidth?window.innerWidth:window.document.documentElement&&window.document.documentElement.clientWidth?window.document.documentElement.clientWidth:window.document.body?window.document.body.clientWidth:0}function a(){return window.innerHeight?window.innerHeight:window.document.documentElement&&window.document.documentElement.clientHeight?window.document.documentElement.clientHeight:window.document.body?window.document.body.clientHeight:0}function s(){return window.location.href.toString()}function u(){return window.document.referrer||null}function l(){return(window.document.referrer||"").indexOf("issuu.com")!==-1?"internal":"external"}function c(){return"web"}function p(){return document.documentElement.lang||null}var d;d=__issuuConfig&&__issuuConfig.production&&"issuu"===__issuuConfig.tracking.settings?"pingback.issuu.com":"pingback.tissuu.com",e.exports={post:n,handleError:r,getWidth:i,getHeight:a,getUsername:o,getLocation:s,getReferrer:u,getSource:l,getLanguage:p,getOrigin:c,setTimeout:function(e,t){return window.setTimeout(e,t)},clearTimeout:function(e){return window.clearTimeout(e)},setInterval:function(e,t){return window.setInterval(e,t)},clearInterval:function(e){return window.clearInterval(e)},nagleTimeout:1500}}])},function(e,t,n){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var o=n[r]={exports:{},id:r,loaded:!1};return e[r].call(o.exports,o,o.exports,t),o.loaded=!0,o.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(8)},,,function(e,t){e.exports=n(2)},function(e,t){e.exports=n(20)},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(6),o=function(e){return e&&e.__esModule?e:{default:e}}(r);t.default=function(e){return o.default.bind(null,e)},e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function o(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function i(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var a=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},s=n(3),u=r(s),l=n(7),c=r(l),p=function(e){var t=parseInt(c.default["ixu-base-size"].replace("px",""),10);switch(e){case"small":return t/2+"px";case"normal":return t+"px";case"large":return 2*t+"px";case"none":return 0;default:return null}},d=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(t.style)return u.default.createElement(e,t);var n=t.spacing,r=t.spacingVertical,s=t.spacingHorizontal,l=t.spacingLeft,c=t.spacingRight,d=t.spacingTop,f=t.spacingBottom,h=i(t,["spacing","spacingVertical","spacingHorizontal","spacingLeft","spacingRight","spacingTop","spacingBottom"]),m={top:d||r||n,right:c||s||n,bottom:f||r||n,left:l||s||n},g=Object.keys(m).reduce(function(e,t){return Object.assign(e,o({},t,p(m[t])))},{});return u.default.createElement(e,a({},h,{style:{marginTop:g.top,marginRight:g.right,marginBottom:g.bottom,marginLeft:g.left}}))};d.propTypes={spacing:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingBottom:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingHorizontal:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingLeft:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingRight:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingTop:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingVertical:u.default.PropTypes.oneOf(["none","small","normal","large"])},t.default=d,e.exports=t.default},function(e,t){e.exports={"ixu-base-size":"12px","ixu-base-duration":"150ms"}},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0});var o=n(9),i=r(o);t.default=(0,r(n(5)).default)(i.default),e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function o(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var i=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},a=n(3),s=r(a),u=n(4),l=r(u),c=function(e){var t=e.actionState,n=e.children,r=e.extraClass,a=e.href,u=e.htmlType,c=e.isDisabled,p=e.isOutlined,d=e.isRounded,f=e.look,h=e.size,m=e.onClick,g=o(e,["actionState","children","extraClass","href","htmlType","isDisabled","isOutlined","isRounded","look","size","onClick"]),v=(0,l.default)("ixu-button",r,{"ixu-button--discreet":"discreet"===f,"ixu-button--positive":"positive"===f,"ixu-button--pronounced":"pronounced"===f,"ixu-button--danger":"danger"===f,"ixu-button--large":"large"===h,"ixu-button--rounded":d,"ixu-button--outline":p,"is-done":"done"===t,"is-error":"error"===t,"is-loading":"loading"===t});return s.default.createElement(a?"a":"button",i({},g,{type:a?null:u,href:a,className:v,onClick:function(e){return m(e)},disabled:c||t}),n)};c.defaultProps={look:"default",htmlType:"button",isDisabled:!1,isOutlined:!1,isRounded:!1,onClick:function(){}},c.propTypes={actionState:s.default.PropTypes.oneOf(["done","error","loading"]),extraClass:s.default.PropTypes.string,href:s.default.PropTypes.string,htmlType:s.default.PropTypes.oneOf(["button","reset","submit"]),isDisabled:s.default.PropTypes.bool,isOutlined:s.default.PropTypes.bool,isRounded:s.default.PropTypes.bool,look:s.default.PropTypes.oneOf(["default","discreet","positive","pronounced","danger"]),onClick:s.default.PropTypes.func,size:s.default.PropTypes.oneOf(["default","large"])},c.displayName="Button",t.default=c,e.exports=t.default}])},function(e,t,n){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var o=n[r]={exports:{},id:r,loaded:!1};return e[r].call(o.exports,o,o.exports,t),o.loaded=!0,o.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(12)},,,function(e,t){e.exports=n(2)},function(e,t){e.exports=n(20)},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(6),o=function(e){return e&&e.__esModule?e:{default:e}}(r);t.default=function(e){return o.default.bind(null,e)},e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function o(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function i(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var a=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},s=n(3),u=r(s),l=n(7),c=r(l),p=function(e){var t=parseInt(c.default["ixu-base-size"].replace("px",""),10);switch(e){case"small":return t/2+"px";case"normal":return t+"px";case"large":return 2*t+"px";case"none":return 0;default:return null}},d=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(t.style)return u.default.createElement(e,t);var n=t.spacing,r=t.spacingVertical,s=t.spacingHorizontal,l=t.spacingLeft,c=t.spacingRight,d=t.spacingTop,f=t.spacingBottom,h=i(t,["spacing","spacingVertical","spacingHorizontal","spacingLeft","spacingRight","spacingTop","spacingBottom"]),m={top:d||r||n,right:c||s||n,bottom:f||r||n,left:l||s||n},g=Object.keys(m).reduce(function(e,t){return Object.assign(e,o({},t,p(m[t])))},{});return u.default.createElement(e,a({},h,{style:{marginTop:g.top,marginRight:g.right,marginBottom:g.bottom,marginLeft:g.left}}))};d.propTypes={spacing:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingBottom:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingHorizontal:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingLeft:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingRight:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingTop:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingVertical:u.default.PropTypes.oneOf(["none","small","normal","large"])},t.default=d,e.exports=t.default},function(e,t){e.exports={"ixu-base-size":"12px","ixu-base-duration":"150ms"}},,,,,function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0});var o=n(13),i=r(o);t.default=(0,r(n(5)).default)(i.default),e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function o(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var i=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},a=n(3),s=r(a),u=n(4),l=r(u),c=function(e){var t=e.children,n=e.extraClass,r=e.size,a=e.look,u=e.tag,c=e.weight,p=o(e,["children","extraClass","size","look","tag","weight"]),d=(0,l.default)("ixu-heading",n,{"ixu-heading--pronounced":"pronounced"===a,"ixu-heading--issuu-brand":"issuu-brand"===a,"ixu-heading--light":"light"===c,"ixu-heading--semibold":"semibold"===c,"ixu-heading--bold":"bold"===c,"ixu-heading--hero":"hero"===r,"ixu-heading--huge":"huge"===r,"ixu-heading--large":"large"===r,"ixu-heading--small":"small"===r,"ixu-heading--tiny":"tiny"===r});return s.default.createElement(u,i({},p,{className:d}),t)};c.defaultProps={size:"default",look:"default",tag:"div",weight:"normal"},c.propTypes={extraClass:s.default.PropTypes.string,look:s.default.PropTypes.oneOf(["default","pronounced","issuu-brand"]),size:s.default.PropTypes.oneOf(["default","hero","huge","large","small","tiny"]),tag:s.default.PropTypes.oneOf(["div","h1","h2","h3","h4","h5","h6","span"]),weight:s.default.PropTypes.oneOf(["bold","light","normal","semibold"])},c.displayName="Heading",t.default=c,e.exports=t.default}])},function(e,t,n){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var o=n[r]={exports:{},id:r,loaded:!1};return e[r].call(o.exports,o,o.exports,t),o.loaded=!0,o.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(18)},,,function(e,t){e.exports=n(2)},function(e,t){e.exports=n(20)},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(6),o=function(e){return e&&e.__esModule?e:{default:e}}(r);t.default=function(e){return o.default.bind(null,e)},e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function o(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function i(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var a=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},s=n(3),u=r(s),l=n(7),c=r(l),p=function(e){var t=parseInt(c.default["ixu-base-size"].replace("px",""),10);switch(e){case"small":return t/2+"px";case"normal":return t+"px";case"large":return 2*t+"px";case"none":return 0;default:return null}},d=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(t.style)return u.default.createElement(e,t);var n=t.spacing,r=t.spacingVertical,s=t.spacingHorizontal,l=t.spacingLeft,c=t.spacingRight,d=t.spacingTop,f=t.spacingBottom,h=i(t,["spacing","spacingVertical","spacingHorizontal","spacingLeft","spacingRight","spacingTop","spacingBottom"]),m={top:d||r||n,right:c||s||n,bottom:f||r||n,left:l||s||n},g=Object.keys(m).reduce(function(e,t){return Object.assign(e,o({},t,p(m[t])))},{});return u.default.createElement(e,a({},h,{style:{marginTop:g.top,marginRight:g.right,marginBottom:g.bottom,marginLeft:g.left}}))};d.propTypes={spacing:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingBottom:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingHorizontal:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingLeft:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingRight:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingTop:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingVertical:u.default.PropTypes.oneOf(["none","small","normal","large"])},t.default=d,e.exports=t.default},function(e,t){e.exports={"ixu-base-size":"12px","ixu-base-duration":"150ms"}},,,,,,,,,,,function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0});var o=n(19),i=r(o);t.default=(0,r(n(5)).default)(i.default),e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function o(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var i=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},a=n(3),s=r(a),u=n(4),l=r(u),c=function(e){var t=e.children,n=e.extraClass,r=e.look,a=e.size,u=e.onClick,c=e.weight,p=o(e,["children","extraClass","look","size","onClick","weight"]),d=(0,l.default)("ixu-paragraph",n,{"ixu-paragraph--pronounced":"pronounced"===r,"ixu-paragraph--issuu-brand":"issuu-brand"===r,"ixu-paragraph--huge":"huge"===a,"ixu-paragraph--large":"large"===a,"ixu-paragraph--small":"small"===a,"ixu-paragraph--tiny":"tiny"===a,"ixu-paragraph--bold":"bold"===c,"ixu-paragraph--light":"light"===c,"ixu-paragraph--semibold":"semibold"===c});return s.default.createElement("p",i({},p,{className:d,onClick:u}),t)};c.defaultProps={look:"default",size:"medium",weight:"normal"},c.propTypes={children:s.default.PropTypes.node.isRequired,extraClass:s.default.PropTypes.string,look:s.default.PropTypes.oneOf(["default","pronounced","issuu-brand"]),onClick:s.default.PropTypes.func,size:s.default.PropTypes.oneOf(["huge","large","medium","small","tiny"]),weight:s.default.PropTypes.oneOf(["bold","light","normal","semibold"])},c.displayName="Paragraph",t.default=c,e.exports=t.default}])},function(e,t,n){"use strict";function r(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=t.thousandsSeparator,r=void 0===n?" ":n,o=t.precision,i=void 0===o?2:o,a=t.decimalSeparator,u=void 0===a?".":a,l=t.currencySymbol,c=void 0===l?"$":l,p=t.suffix,d=void 0===p?"USD":p,f=t.showExact,h=void 0!==f&&f,m=t.showShort,g=void 0!==m&&m,v=e;!isNaN(parseInt(e,10))&&e||(v=0);var b=i+1,y=s(""+v,b,"0"),_=y.slice(y.length-i),E=0!==parseInt(_,10),w=i&&(h||!h&&E),S=y.slice(0,y.length-i).split("").reduce(function(e,t,n,o){var i=o.length-n-1;return 0!==i&&i%3==0?""+e+t+r:""+e+t},""),x=g?c:"",T=g?"":" "+d;return(""+x+S+(w?u:"")+(w?_:"")).trim()+""+T}function o(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=t.thousandsSeparator,r=void 0===n?" ":n,o=t.decimalSeparator,i=void 0===o?".":o,a=t.currencySymbol,s=void 0===a?"$":a,u=t.precision,l=void 0===u?2:u,c=t.suffix,p=void 0===c?"USD":c,d=0===l||String(e).indexOf(i)!==-1,f=String(e).trim().replace(" "+p,"").concat(d?"":Array(l+1).join("0")).replace(s,"").replace(r,"").replace(i,"").trim();return parseInt(f,10)||0}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=u[t.currency||"USD"]||u.USD;return r(e,{currencySymbol:n.symbol,precision:n.precision,suffix:t.currency in u?t.currency:"USD",showExact:t.showExact,showShort:t.showShort})}function a(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=u[t.currency||"USD"]||u.USD;return o(e,{currencySymbol:n.symbol,precision:n.precision,suffix:t.currency in u?t.currency:"USD"})}Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){return e&&"object"==typeof e&&"default"in e?e.default:e}(n(740)),u={USD:{symbol:"$",precision:2},EUR:{symbol:"€",precision:2}};t.formatCurrency=i,t.unformatCurrency=a},function(e,t,n){"use strict";function r(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:console;return function(r){if(!r||Array.isArray(r)&&0===r.length)return Promise.resolve();var o=Array.isArray(r)?r:[r],s=o.map(function(e){return Object.assign({version:"1.0.0"},e)});return a({type:"monitor",version:"2.2.0",origin:i,data:s},e,t,n)}}function o(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:console;return function(r,o,s){if(!r||Array.isArray(r)&&0===r.length)return Promise.resolve();var u=Object.assign({},o,{browser_size:window.innerWidth+"x"+window.innerWidth,events:Array.isArray(r)?r:[r]}),l={type:"website",version:"2.2.0",origin:i,data:{username:document.cookie.replace(/(?:(?:^|.*;\s*)site.model.username\s*\=\s*([^;]*).*$)|^.*$/,"$1")||null,ui_language:document.documentElement.lang||null,location:window.location.href.toString(),referrer:s||document.referrer||null,version:"2.2.2",contexts:[u]}};return a(l,e,t,n)}}Object.defineProperty(t,"__esModule",{value:!0});var i="issuu-libs-tracking-micro-v2.2.0",a=function(e,t,n,r){return n(t,{method:"post",credentials:"include",headers:{Accept:"application/json","Content-Type":"application/json"},body:JSON.stringify(e)}).catch(function(t){return r.error(e.type+" pingback failed:",t)})};t.initMonitor=r,t.initWebsite=o},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n.d(t,"Overlay",function(){return f}),n.d(t,"Button",function(){return d});var r=n(2),o=n.n(r),i=n(620),a=n.n(i),s=n(619),u=n.n(s),l=n(621),c=n.n(l),p=n(622),d=(n.n(p),function(e){var t=e.hostName,r=e.publisherName,i=e.publicationName,a=e.price,s=e.referrer,l=void 0===s?"reader.button":s,c=a?o.a.createElement("span",null,n.i(p.formatCurrency)(a)):null;return o.a.createElement(u.a,{look:"positive",href:"https://"+t+"/store/publishers/"+r+"/docs/"+i+"?r="+l,target:"_blank"},"Buy ",c)});d.propTypes={hostName:r.PropTypes.string.isRequired,price:r.PropTypes.number,publicationName:r.PropTypes.string.isRequired,publisherName:r.PropTypes.string.isRequired,referrer:r.PropTypes.string};var f=function(e){var t=e.hostName,n=e.onKeepReading,r=e.price,i=e.publicationCoverUrl,s=e.publicationName,l=e.publicationTitle,p=e.publisherDisplayName,f=e.publisherName,h=e.publisherProfileImageUrl,m=e.publisherProfileUrl,g=e.showKeepReading;return o.a.createElement("div",{className:"PaywallOverlay ixu-cascading-fluid-typography ixu-cascading-theme-inverse"},o.a.createElement("div",{className:"PaywallOverlay-content"},o.a.createElement("div",{className:"PaywallOverlay-cover"},o.a.createElement("div",{className:"PaywallOverlay-coverWrapper"},o.a.createElement("img",{src:i,alt:"Cover of "+l}))),o.a.createElement("div",{className:"PaywallOverlay-info"},o.a.createElement(a.a,{weight:"light",look:"pronounced"},"Unlock full access to"),o.a.createElement(a.a,{weight:"bold",look:"pronounced",spacingBottom:"large"},l),o.a.createElement("div",{className:"PaywallOverlay-actions"},o.a.createElement(d,{hostName:t,publisherName:f,publicationName:s,price:r,referrer:"reader.overlay"}),g&&o.a.createElement(u.a,{isOutlined:!0,onClick:n},"Keep reading")),o.a.createElement("div",{className:"PaywallOverlay-publisher"},o.a.createElement("div",{className:"PaywallOverlay-publisherImage"},o.a.createElement("img",{src:h,alt:"Avatar of "+p})),o.a.createElement("div",null,o.a.createElement(c.a,null,"Published by"),o.a.createElement(c.a,{size:"large",weight:"bold"},o.a.createElement("a",{href:m,target:"_blank",rel:"noopener noreferrer"},p)))))))};f.propTypes={hostName:r.PropTypes.string.isRequired,onKeepReading:r.PropTypes.func.isRequired,price:r.PropTypes.number,publicationCoverUrl:r.PropTypes.string.isRequired,publicationName:r.PropTypes.string.isRequired,publicationTitle:r.PropTypes.string.isRequired,publisherDisplayName:r.PropTypes.string.isRequired,publisherName:r.PropTypes.string.isRequired,publisherProfileImageUrl:r.PropTypes.string.isRequired,publisherProfileUrl:r.PropTypes.string.isRequired,showKeepReading:r.PropTypes.bool}},function(e,t,n){function r(){}function o(e){var t,n=e.config.network,o=e.rootElm.getAttribute("id")||"div-"+Math.round(1e4*Math.random());!function(){var s=e.targeting||[];if(a.log("ads","widget","gpt","addPlacementWithTargeting",n,s),e.callbacks=Object.assign({onAdFilled:r,onAdViewable:r,onAdFailed:r,onAdUnfilled:r},e.callbacks),a.log("ads","widget","gpt","create",e),!n)return void e.callbacks.onAdFailed();t=i.create({onError:e.callbacks.onAdFailed}),e.rootElm.setAttribute("id",o),t.addPlacement(o,n,e.config.sizes,s),a.log("ads","widget","gpt","addPlacement",o,n,e.config.sizes,s),t.addEventListener("slotRenderEnded",function(t){t.slot.getSlotElementId()===o&&(a.log("ads","widget","gpt","slotRendered",t),t.isEmpty?e.callbacks.onAdUnfilled():e.callbacks.onAdFilled())}),t.addEventListener("impressionViewable",function(t){t.slot.getSlotElementId()===o&&(a.log("ads","widget","gpt","impressionViewable",t),e.callbacks.onAdViewable())})}()}var i=n(617),a=n(169);t.create=o},function(e,t,n){var r=n(169),o=n(623).initMonitor;t.create=function(e){function t(e,t){var n={type:c+"-"+e},o={type:c+"."+e,timeElapsed:t,screenWidth:Number(window.innerWidth),screenHeight:Number(window.innerHeight),screenResolution:Number(window.innerHeight)*Number(window.innerWidth)};r.log("ads","pingback",o),p([o,n])}function n(e){t("requested",e)}function i(e){t("failed",e)}function a(e){t("filled",e)}function s(e){t("viewable",e)}function u(e){t("timeout",e)}function l(e){t("unfilled",e)}var c,p;return function(){p=e&&e.isProductionEnv===!0?o("//pingback.issuu.com/ping",window.fetch):o("//pingback.tissuu.com/ping",window.fetch),c=e&&e.trackingKey||"ads-widget"}(),{adRequested:n,adFailed:i,adLoaded:a,adViewable:s,adTimeout:u,adUnfilled:l}}},function(e,t,n){"use strict";function r(e){return null==e?void 0===e?u:s:l&&l in Object(e)?n.i(i.a)(e):n.i(a.a)(e)}var o=n(265),i=n(630),a=n(631),s="[object Null]",u="[object Undefined]",l=o.a?o.a.toStringTag:void 0;t.a=r},function(e,t,n){"use strict";(function(e){var n="object"==typeof e&&e&&e.Object===Object&&e;t.a=n}).call(t,n(34))},function(e,t,n){"use strict";t.a=n.i(n(632).a)(Object.getPrototypeOf,Object)},function(e,t,n){"use strict";function r(e){var t=a.call(e,u),n=e[u];try{e[u]=void 0}catch(e){}var r=s.call(e);return t?e[u]=n:delete e[u],r}var o=n(265),i=Object.prototype,a=i.hasOwnProperty,s=i.toString,u=o.a?o.a.toStringTag:void 0;t.a=r},function(e,t,n){"use strict";function r(e){return i.call(e)}var o=Object.prototype,i=o.toString;t.a=r},function(e,t,n){"use strict";function r(e,t){return function(n){return e(t(n))}}t.a=r},function(e,t,n){"use strict";var r=n(628),o="object"==typeof self&&self&&self.Object===Object&&self;t.a=r.a||o||Function("return this")()},function(e,t,n){"use strict";function r(e){return null!=e&&"object"==typeof e}t.a=r},function(e,t){function n(e){return!!e&&"object"==typeof e}function r(e,t){var n=null==e?void 0:e[t];return a(n)?n:void 0}function o(e){return i(e)&&d.call(e)==s}function i(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function a(e){return null!=e&&(o(e)?f.test(c.call(e)):n(e)&&u.test(e))}var s="[object Function]",u=/^\[object .+?Constructor\]$/,l=Object.prototype,c=Function.prototype.toString,p=l.hasOwnProperty,d=l.toString,f=RegExp("^"+c.call(p).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=r},function(e,t){function n(e){return o(e)&&h.call(e,"callee")&&(!g.call(e,"callee")||m.call(e)==c)}function r(e){return null!=e&&a(e.length)&&!i(e)}function o(e){return u(e)&&r(e)}function i(e){var t=s(e)?m.call(e):"";return t==p||t==d}function a(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=l}function s(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function u(e){return!!e&&"object"==typeof e}var l=9007199254740991,c="[object Arguments]",p="[object Function]",d="[object GeneratorFunction]",f=Object.prototype,h=f.hasOwnProperty,m=f.toString,g=f.propertyIsEnumerable;e.exports=n},function(e,t){function n(e){return!!e&&"object"==typeof e}function r(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=h}function o(e){return i(e)&&d.call(e)==s}function i(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function a(e){return null!=e&&(o(e)?f.test(c.call(e)):n(e)&&u.test(e))}var s="[object Function]",u=/^\[object .+?Constructor\]$/,l=Object.prototype,c=Function.prototype.toString,p=l.hasOwnProperty,d=l.toString,f=RegExp("^"+c.call(p).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),h=9007199254740991;e.exports=function(e,t){var n=null==e?void 0:e[t];return a(n)?n:void 0}(Array,"isArray")||function(e){return n(e)&&r(e.length)&&"[object Array]"==d.call(e)}},function(e,t,n){function r(e){return null!=e&&i(v(e))}function o(e,t){return e="number"==typeof e||d.test(e)?+e:-1,t=null==t?g:t,e>-1&&e%1==0&&e<t}function i(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=g}function a(e){for(var t=u(e),n=t.length,r=n&&e.length,a=!!r&&i(r)&&(p(e)||c(e)),s=-1,l=[];++s<n;){var d=t[s];(a&&o(d,r)||h.call(e,d))&&l.push(d)}return l}function s(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function u(e){if(null==e)return[];s(e)||(e=Object(e));var t=e.length;t=t&&i(t)&&(p(e)||c(e))&&t||0;for(var n=e.constructor,r=-1,a="function"==typeof n&&n.prototype===e,u=Array(t),l=t>0;++r<t;)u[r]=r+"";for(var d in e)l&&o(d,t)||"constructor"==d&&(a||!h.call(e,d))||u.push(d);return u}var l=n(635),c=n(636),p=n(637),d=/^\d+$/,f=Object.prototype,h=f.hasOwnProperty,m=l(Object,"keys"),g=9007199254740991,v=function(e){return function(t){return null==t?void 0:t[e]}}("length");e.exports=m?function(e){var t=null==e?void 0:e.constructor;return"function"==typeof t&&t.prototype===e||"function"!=typeof e&&r(e)?a(e):s(e)?m(e):[]}:a},function(e,t,n){"use strict";var r=Object.prototype.hasOwnProperty,o=Object.prototype.toString,i=Array.prototype.slice,a=n(640),s=Object.prototype.propertyIsEnumerable,u=!s.call({toString:null},"toString"),l=s.call(function(){},"prototype"),c=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],p=function(e){var t=e.constructor;return t&&t.prototype===e},d={$console:!0,$external:!0,$frame:!0,$frameElement:!0,$frames:!0,$innerHeight:!0,$innerWidth:!0,$outerHeight:!0,$outerWidth:!0,$pageXOffset:!0,$pageYOffset:!0,$parent:!0,$scrollLeft:!0,$scrollTop:!0,$scrollX:!0,$scrollY:!0,$self:!0,$webkitIndexedDB:!0,$webkitStorageInfo:!0,$window:!0},f=function(){if("undefined"==typeof window)return!1;for(var e in window)try{if(!d["$"+e]&&r.call(window,e)&&null!==window[e]&&"object"==typeof window[e])try{p(window[e])}catch(e){return!0}}catch(e){return!0}return!1}(),h=function(e){if("undefined"==typeof window||!f)return p(e);try{return p(e)}catch(e){return!1}},m=function(e){var t=null!==e&&"object"==typeof e,n="[object Function]"===o.call(e),i=a(e),s=t&&"[object String]"===o.call(e),p=[];if(!t&&!n&&!i)throw new TypeError("Object.keys called on a non-object");var d=l&&n;if(s&&e.length>0&&!r.call(e,0))for(var f=0;f<e.length;++f)p.push(String(f));if(i&&e.length>0)for(var m=0;m<e.length;++m)p.push(String(m));else for(var g in e)d&&"prototype"===g||!r.call(e,g)||p.push(String(g));if(u)for(var v=h(e),b=0;b<c.length;++b)v&&"constructor"===c[b]||!r.call(e,c[b])||p.push(c[b]);return p};m.shim=function(){if(Object.keys){if(!function(){return 2===(Object.keys(arguments)||"").length}(1,2)){var e=Object.keys;Object.keys=function(t){return e(a(t)?i.call(t):t)}}}else Object.keys=m;return Object.keys||m},e.exports=m},function(e,t,n){"use strict";var r=Object.prototype.toString;e.exports=function(e){var t=r.call(e),n="[object Arguments]"===t;return n||(n="[object Array]"!==t&&null!==e&&"object"==typeof e&&"number"==typeof e.length&&e.length>=0&&"[object Function]"===r.call(e.callee)),n}},function(e,t,n){"use strict";function r(e,t,n,r,o){}e.exports=r},function(e,t,n){"use strict";var r=n(32),o=n(1);e.exports=function(){function e(){o(!1,"Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types")}function t(){return e}e.isRequired=e;var n={array:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t};return n.checkPropTypes=r,n.PropTypes=n,n}},function(e,t,n){"use strict";var r=n(32),o=n(1),i=(n(5),n(644)),a=n(641);e.exports=function(e,t){function n(e){var t=e&&(w&&e[w]||e[S]);if("function"==typeof t)return t}function s(e,t){return e===t?0!==e||1/e==1/t:e!==e&&t!==t}function u(e){this.message=e,this.stack=""}function l(e){function n(n,r,a,s,l,c,p){if(s=s||x,c=c||a,p!==i)if(t)o(!1,"Calling PropTypes validators directly is not supported by the `prop-types` package. Use `PropTypes.checkPropTypes()` to call them. Read more at http://fb.me/use-check-prop-types");else;return null==r[a]?n?new u(null===r[a]?"The "+l+" `"+c+"` is marked as required in `"+s+"`, but its value is `null`.":"The "+l+" `"+c+"` is marked as required in `"+s+"`, but its value is `undefined`."):null:e(r,a,s,l,c)}var r=n.bind(null,!1);return r.isRequired=n.bind(null,!0),r}function c(e){function t(t,n,r,o,i,a){var s=t[n];if(y(s)!==e)return new u("Invalid "+o+" `"+i+"` of type `"+_(s)+"` supplied to `"+r+"`, expected `"+e+"`.");return null}return l(t)}function p(e){function t(t,n,r,o,a){if("function"!=typeof e)return new u("Property `"+a+"` of component `"+r+"` has invalid PropType notation inside arrayOf.");var s=t[n];if(!Array.isArray(s)){return new u("Invalid "+o+" `"+a+"` of type `"+y(s)+"` supplied to `"+r+"`, expected an array.")}for(var l=0;l<s.length;l++){var c=e(s,l,r,o,a+"["+l+"]",i);if(c instanceof Error)return c}return null}return l(t)}function d(e){function t(t,n,r,o,i){if(!(t[n]instanceof e)){var a=e.name||x;return new u("Invalid "+o+" `"+i+"` of type `"+E(t[n])+"` supplied to `"+r+"`, expected instance of `"+a+"`.")}return null}return l(t)}function f(e){function t(t,n,r,o,i){for(var a=t[n],l=0;l<e.length;l++)if(s(a,e[l]))return null;return new u("Invalid "+o+" `"+i+"` of value `"+a+"` supplied to `"+r+"`, expected one of "+JSON.stringify(e)+".")}return Array.isArray(e)?l(t):r.thatReturnsNull}function h(e){function t(t,n,r,o,a){if("function"!=typeof e)return new u("Property `"+a+"` of component `"+r+"` has invalid PropType notation inside objectOf.");var s=t[n],l=y(s);if("object"!==l)return new u("Invalid "+o+" `"+a+"` of type `"+l+"` supplied to `"+r+"`, expected an object.");for(var c in s)if(s.hasOwnProperty(c)){var p=e(s,c,r,o,a+"."+c,i);if(p instanceof Error)return p}return null}return l(t)}function m(e){function t(t,n,r,o,a){for(var s=0;s<e.length;s++){if(null==(0,e[s])(t,n,r,o,a,i))return null}return new u("Invalid "+o+" `"+a+"` supplied to `"+r+"`.")}return Array.isArray(e)?l(t):r.thatReturnsNull}function g(e){function t(t,n,r,o,a){var s=t[n],l=y(s);if("object"!==l)return new u("Invalid "+o+" `"+a+"` of type `"+l+"` supplied to `"+r+"`, expected `object`.");for(var c in e){var p=e[c];if(p){var d=p(s,c,r,o,a+"."+c,i);if(d)return d}}return null}return l(t)}function v(t){switch(typeof t){case"number":case"string":case"undefined":return!0;case"boolean":return!t;case"object":if(Array.isArray(t))return t.every(v);if(null===t||e(t))return!0;var r=n(t);if(!r)return!1;var o,i=r.call(t);if(r!==t.entries){for(;!(o=i.next()).done;)if(!v(o.value))return!1}else for(;!(o=i.next()).done;){var a=o.value;if(a&&!v(a[1]))return!1}return!0;default:return!1}}function b(e,t){return"symbol"===e||("Symbol"===t["@@toStringTag"]||"function"==typeof Symbol&&t instanceof Symbol)}function y(e){var t=typeof e;return Array.isArray(e)?"array":e instanceof RegExp?"object":b(t,e)?"symbol":t}function _(e){var t=y(e);if("object"===t){if(e instanceof Date)return"date";if(e instanceof RegExp)return"regexp"}return t}function E(e){return e.constructor&&e.constructor.name?e.constructor.name:x}var w="function"==typeof Symbol&&Symbol.iterator,S="@@iterator",x="<<anonymous>>",T={array:c("array"),bool:c("boolean"),func:c("function"),number:c("number"),object:c("object"),string:c("string"),symbol:c("symbol"),any:function(){return l(r.thatReturnsNull)}(),arrayOf:p,element:function(){function t(t,n,r,o,i){var a=t[n];if(!e(a)){return new u("Invalid "+o+" `"+i+"` of type `"+y(a)+"` supplied to `"+r+"`, expected a single ReactElement.")}return null}return l(t)}(),instanceOf:d,node:function(){function e(e,t,n,r,o){return v(e[t])?null:new u("Invalid "+r+" `"+o+"` supplied to `"+n+"`, expected a ReactNode.")}return l(e)}(),objectOf:h,oneOf:f,oneOfType:m,shape:g};return u.prototype=Error.prototype,T.checkPropTypes=a,T.PropTypes=T,T}},function(e,t,n){"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},function(e,t,n){"use strict";function r(e){this.name="RavenConfigError",this.message=e}r.prototype=new Error,r.prototype.constructor=r,e.exports=r},function(e,t,n){"use strict";e.exports={wrapMethod:function(e,t,n){var r=e[t],o=e;if(t in e){var i="warn"===t?"warning":t;e[t]=function(){var e=[].slice.call(arguments),t=""+e.join(" "),a={level:i,logger:"console",extra:{arguments:e}};n&&n(t,a),r&&Function.prototype.apply.call(r,o,e)}}}}},function(e,t,n){"use strict";(function(t){function r(){return+new Date}function o(){this._hasJSON=!("object"!=typeof JSON||!JSON.stringify),this._hasDocument=!i(D),this._hasNavigator=!i(k),this._lastCapturedException=null,this._lastData=null,this._lastEventId=null,this._globalServer=null,this._globalKey=null,this._globalProject=null,this._globalContext={},this._globalOptions={logger:"javascript",ignoreErrors:[],ignoreUrls:[],whitelistUrls:[],includePaths:[],crossOrigin:"anonymous",collectWindowErrors:!0,maxMessageLength:0,maxUrlLength:250,stackTraceLimit:50,autoBreadcrumbs:!0,sampleRate:1},this._ignoreOnError=0,this._isRavenInstalled=!1,this._originalErrorStackTraceLimit=Error.stackTraceLimit,this._originalConsole=A.console||{},this._originalConsoleMethods={},this._plugins=[],this._startTime=r(),this._wrappedBuiltIns=[],this._breadcrumbs=[],this._lastCapturedEvent=null,this._location=A.location,this._lastHref=this._location&&this._location.href,this._resetBackoff();for(var e in this._originalConsole)this._originalConsoleMethods[e]=this._originalConsole[e]}function i(e){return void 0===e}function a(e){return"function"==typeof e}function s(e){return"[object String]"===N.toString.call(e)}function u(e){for(var t in e)return!1;return!0}function l(e,t){var n,r;if(i(e.length))for(n in e)d(e,n)&&t.call(null,n,e[n]);else if(r=e.length)for(n=0;n<r;n++)t.call(null,n,e[n])}function c(e,t){return t?(l(t,function(t,n){e[t]=n}),e):e}function p(e,t){return!t||e.length<=t?e:e.substr(0,t)+"…"}function d(e,t){return N.hasOwnProperty.call(e,t)}function f(e){for(var t,n=[],r=0,o=e.length;r<o;r++)t=e[r],s(t)?n.push(t.replace(/([.*+?^=!:${}()|\[\]\/\\])/g,"\\$1")):t&&t.source&&n.push(t.source);return new RegExp(n.join("|"),"i")}function h(e){var t=[];return l(e,function(e,n){t.push(encodeURIComponent(e)+"="+encodeURIComponent(n))}),t.join("&")}function m(e){var t=e.match(/^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?$/);return t?{protocol:t[2],host:t[4],path:t[5],relative:t[5]+(t[6]||"")+(t[8]||"")}:{}}function g(){var e=A.crypto||A.msCrypto;if(!i(e)&&e.getRandomValues){var t=new Uint16Array(8);e.getRandomValues(t),t[3]=4095&t[3]|16384,t[4]=16383&t[4]|32768;var n=function(e){for(var t=e.toString(16);t.length<4;)t="0"+t;return t};return n(t[0])+n(t[1])+n(t[2])+n(t[3])+n(t[4])+n(t[5])+n(t[6])+n(t[7])}return"xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0;return("x"===e?t:3&t|8).toString(16)})}function v(e){for(var t,n=[],r=0,o=0,i=" > ".length;e&&r++<5&&!("html"===(t=b(e))||r>1&&o+n.length*i+t.length>=80);)n.push(t),o+=t.length,e=e.parentNode;return n.reverse().join(" > ")}function b(e){var t,n,r,o,i,a=[];if(!e||!e.tagName)return"";if(a.push(e.tagName.toLowerCase()),e.id&&a.push("#"+e.id),(t=e.className)&&s(t))for(n=t.split(/\s+/),i=0;i<n.length;i++)a.push("."+n[i]);var u=["type","name","title","alt"];for(i=0;i<u.length;i++)r=u[i],(o=e.getAttribute(r))&&a.push("["+r+'="'+o+'"]');return a.join("")}function y(e,t){return!!(!!e^!!t)}function _(e,t){return!y(e,t)&&(e=e.values[0],t=t.values[0],e.type===t.type&&e.value===t.value&&E(e.stacktrace,t.stacktrace))}function E(e,t){if(y(e,t))return!1;var n=e.frames,r=t.frames;if(n.length!==r.length)return!1;for(var o,i,a=0;a<n.length;a++)if(o=n[a],i=r[a],o.filename!==i.filename||o.lineno!==i.lineno||o.colno!==i.colno||o.function!==i.function)return!1;return!0}function w(e,t,n,r){var o=e[t];e[t]=n(o),r&&r.push([e,t,o])}var S=n(648),x=n(649),T=n(645),C=n(268),I=C.isError,R=C.isObject,M=n(646).wrapMethod,P="source protocol user pass host port path".split(" "),O=/^(?:(\w+):)?\/\/(?:(\w+)(:\w+)?@)?([\w\.-]+)(?::(\d+))?(\/.*)/,A="undefined"!=typeof window?window:void 0!==t?t:"undefined"!=typeof self?self:{},D=A.document,k=A.navigator;o.prototype={VERSION:"3.14.2",debug:!1,TraceKit:S,config:function(e,t){var n=this;if(n._globalServer)return this._logDebug("error","Error: Raven has already been configured"),n;if(!e)return n;var r=n._globalOptions;t&&l(t,function(e,t){"tags"===e||"extra"===e||"user"===e?n._globalContext[e]=t:r[e]=t}),n.setDSN(e),r.ignoreErrors.push(/^Script error\.?$/),r.ignoreErrors.push(/^Javascript error: Script error\.? on line 0$/),r.ignoreErrors=f(r.ignoreErrors),r.ignoreUrls=!!r.ignoreUrls.length&&f(r.ignoreUrls),r.whitelistUrls=!!r.whitelistUrls.length&&f(r.whitelistUrls),r.includePaths=f(r.includePaths),r.maxBreadcrumbs=Math.max(0,Math.min(r.maxBreadcrumbs||100,100));var o={xhr:!0,console:!0,dom:!0,location:!0},i=r.autoBreadcrumbs;return"[object Object]"==={}.toString.call(i)?i=c(o,i):i!==!1&&(i=o),r.autoBreadcrumbs=i,S.collectWindowErrors=!!r.collectWindowErrors,n},install:function(){var e=this;return e.isSetup()&&!e._isRavenInstalled&&(S.report.subscribe(function(){e._handleOnErrorStackInfo.apply(e,arguments)}),e._instrumentTryCatch(),e._globalOptions.autoBreadcrumbs&&e._instrumentBreadcrumbs(),e._drainPlugins(),e._isRavenInstalled=!0),Error.stackTraceLimit=e._globalOptions.stackTraceLimit,this},setDSN:function(e){var t=this,n=t._parseDSN(e),r=n.path.lastIndexOf("/"),o=n.path.substr(1,r);t._dsn=e,t._globalKey=n.user,t._globalSecret=n.pass&&n.pass.substr(1),t._globalProject=n.path.substr(r+1),t._globalServer=t._getGlobalServer(n),t._globalEndpoint=t._globalServer+"/"+o+"api/"+t._globalProject+"/store/",this._resetBackoff()},context:function(e,t,n){return a(e)&&(n=t||[],t=e,e=void 0),this.wrap(e,t).apply(this,n)},wrap:function(e,t,n){function r(){var r=[],i=arguments.length,s=!e||e&&e.deep!==!1;for(n&&a(n)&&n.apply(this,arguments);i--;)r[i]=s?o.wrap(e,arguments[i]):arguments[i];try{return t.apply(this,r)}catch(t){throw o._ignoreNextOnError(),o.captureException(t,e),t}}var o=this;if(i(t)&&!a(e))return e;if(a(e)&&(t=e,e=void 0),!a(t))return t;try{if(t.__raven__)return t;if(t.__raven_wrapper__)return t.__raven_wrapper__}catch(e){return t}for(var s in t)d(t,s)&&(r[s]=t[s]);return r.prototype=t.prototype,t.__raven_wrapper__=r,r.__raven__=!0,r.__inner__=t,r},uninstall:function(){return S.report.uninstall(),this._restoreBuiltIns(),Error.stackTraceLimit=this._originalErrorStackTraceLimit,this._isRavenInstalled=!1,this},captureException:function(e,t){if(!I(e))return this.captureMessage(e,c({trimHeadFrames:1,stacktrace:!0},t));this._lastCapturedException=e;try{this._handleStackInfo(S.computeStackTrace(e),t)}catch(t){if(e!==t)throw t}return this},captureMessage:function(e,t){if(!this._globalOptions.ignoreErrors.test||!this._globalOptions.ignoreErrors.test(e)){t=t||{};var n=c({message:e+""},t);if(this._globalOptions.stacktrace||t&&t.stacktrace){var r;try{throw new Error(e)}catch(e){r=e}r.name=null,t=c({fingerprint:e,trimHeadFrames:(t.trimHeadFrames||0)+1},t);n.stacktrace={frames:this._prepareFrames(S.computeStackTrace(r),t).reverse()}}return this._send(n),this}},captureBreadcrumb:function(e){var t=c({timestamp:r()/1e3},e);if(a(this._globalOptions.breadcrumbCallback)){var n=this._globalOptions.breadcrumbCallback(t);if(R(n)&&!u(n))t=n;else if(n===!1)return this}return this._breadcrumbs.push(t),this._breadcrumbs.length>this._globalOptions.maxBreadcrumbs&&this._breadcrumbs.shift(),this},addPlugin:function(e){return this._plugins.push([e,[].slice.call(arguments,1)]),this._isRavenInstalled&&this._drainPlugins(),this},setUserContext:function(e){return this._globalContext.user=e,this},setExtraContext:function(e){return this._mergeContext("extra",e),this},setTagsContext:function(e){return this._mergeContext("tags",e),this},clearContext:function(){return this._globalContext={},this},getContext:function(){return JSON.parse(x(this._globalContext))},setEnvironment:function(e){return this._globalOptions.environment=e,this},setRelease:function(e){return this._globalOptions.release=e,this},setDataCallback:function(e){var t=this._globalOptions.dataCallback;return this._globalOptions.dataCallback=a(e)?function(n){return e(n,t)}:e,this},setBreadcrumbCallback:function(e){var t=this._globalOptions.breadcrumbCallback;return this._globalOptions.breadcrumbCallback=a(e)?function(n){return e(n,t)}:e,this},setShouldSendCallback:function(e){var t=this._globalOptions.shouldSendCallback;return this._globalOptions.shouldSendCallback=a(e)?function(n){return e(n,t)}:e,this},setTransport:function(e){return this._globalOptions.transport=e,this},lastException:function(){return this._lastCapturedException},lastEventId:function(){return this._lastEventId},isSetup:function(){return!!this._hasJSON&&(!!this._globalServer||(this.ravenNotConfiguredError||(this.ravenNotConfiguredError=!0,this._logDebug("error","Error: Raven has not been configured.")),!1))},afterLoad:function(){var e=A.RavenConfig;e&&this.config(e.dsn,e.config).install()},showReportDialog:function(e){if(D){e=e||{};var t=e.eventId||this.lastEventId();if(!t)throw new T("Missing eventId");var n=e.dsn||this._dsn;if(!n)throw new T("Missing DSN");var r=encodeURIComponent,o="";o+="?eventId="+r(t),o+="&dsn="+r(n);var i=e.user||this._globalContext.user;i&&(i.name&&(o+="&name="+r(i.name)),i.email&&(o+="&email="+r(i.email)));var a=this._getGlobalServer(this._parseDSN(n)),s=D.createElement("script");s.async=!0,s.src=a+"/api/embed/error-page/"+o,(D.head||D.body).appendChild(s)}},_ignoreNextOnError:function(){var e=this;this._ignoreOnError+=1,setTimeout(function(){e._ignoreOnError-=1})},_triggerEvent:function(e,t){var n,r;if(this._hasDocument){t=t||{},e="raven"+e.substr(0,1).toUpperCase()+e.substr(1),D.createEvent?(n=D.createEvent("HTMLEvents"),n.initEvent(e,!0,!0)):(n=D.createEventObject(),n.eventType=e);for(r in t)d(t,r)&&(n[r]=t[r]);if(D.createEvent)D.dispatchEvent(n);else try{D.fireEvent("on"+n.eventType.toLowerCase(),n)}catch(e){}}},_breadcrumbEventHandler:function(e){var t=this;return function(n){if(t._keypressTimeout=null,t._lastCapturedEvent!==n){t._lastCapturedEvent=n;var r;try{r=v(n.target)}catch(e){r="<unknown>"}t.captureBreadcrumb({category:"ui."+e,message:r})}}},_keypressEventHandler:function(){var e=this;return function(t){var n;try{n=t.target}catch(e){return}var r=n&&n.tagName;if(r&&("INPUT"===r||"TEXTAREA"===r||n.isContentEditable)){var o=e._keypressTimeout;o||e._breadcrumbEventHandler("input")(t),clearTimeout(o),e._keypressTimeout=setTimeout(function(){e._keypressTimeout=null},1e3)}}},_captureUrlChange:function(e,t){var n=m(this._location.href),r=m(t),o=m(e);this._lastHref=t,n.protocol===r.protocol&&n.host===r.host&&(t=r.relative),n.protocol===o.protocol&&n.host===o.host&&(e=o.relative),this.captureBreadcrumb({category:"navigation",data:{to:t,from:e}})},_instrumentTryCatch:function(){function e(e){return function(n,r){for(var o=new Array(arguments.length),i=0;i<o.length;++i)o[i]=arguments[i];var s=o[0];return a(s)&&(o[0]=t.wrap(s)),e.apply?e.apply(this,o):e(o[0],o[1])}}var t=this,n=t._wrappedBuiltIns,r=this._globalOptions.autoBreadcrumbs;w(A,"setTimeout",e,n),w(A,"setInterval",e,n),A.requestAnimationFrame&&w(A,"requestAnimationFrame",function(e){return function(n){return e(t.wrap(n))}},n);for(var o=["EventTarget","Window","Node","ApplicationCache","AudioTrackList","ChannelMergerNode","CryptoOperation","EventSource","FileReader","HTMLUnknownElement","IDBDatabase","IDBRequest","IDBTransaction","KeyOperation","MediaController","MessagePort","ModalWindow","Notification","SVGElementInstance","Screen","TextTrack","TextTrackCue","TextTrackList","WebSocket","WebSocketWorker","Worker","XMLHttpRequest","XMLHttpRequestEventTarget","XMLHttpRequestUpload"],i=0;i<o.length;i++)!function(e){var o=A[e]&&A[e].prototype;o&&o.hasOwnProperty&&o.hasOwnProperty("addEventListener")&&(w(o,"addEventListener",function(n){return function(o,i,a,s){try{i&&i.handleEvent&&(i.handleEvent=t.wrap(i.handleEvent))}catch(e){}var u,l,c;return r&&r.dom&&("EventTarget"===e||"Node"===e)&&(l=t._breadcrumbEventHandler("click"),c=t._keypressEventHandler(),u=function(e){if(e){var t;try{t=e.type}catch(e){return}return"click"===t?l(e):"keypress"===t?c(e):void 0}}),n.call(this,o,t.wrap(i,void 0,u),a,s)}},n),w(o,"removeEventListener",function(e){return function(t,n,r,o){try{n=n&&(n.__raven_wrapper__?n.__raven_wrapper__:n)}catch(e){}return e.call(this,t,n,r,o)}},n))}(o[i])},_instrumentBreadcrumbs:function(){function e(e,n){e in n&&a(n[e])&&w(n,e,function(e){return t.wrap(e)})}var t=this,n=this._globalOptions.autoBreadcrumbs,r=t._wrappedBuiltIns;if(n.xhr&&"XMLHttpRequest"in A){var o=XMLHttpRequest.prototype;w(o,"open",function(e){return function(n,r){return s(r)&&r.indexOf(t._globalKey)===-1&&(this.__raven_xhr={method:n,url:r,status_code:null}),e.apply(this,arguments)}},r),w(o,"send",function(n){return function(r){function o(){if(i.__raven_xhr&&(1===i.readyState||4===i.readyState)){try{i.__raven_xhr.status_code=i.status}catch(e){}t.captureBreadcrumb({type:"http",category:"xhr",data:i.__raven_xhr})}}for(var i=this,s=["onload","onerror","onprogress"],u=0;u<s.length;u++)e(s[u],i);return"onreadystatechange"in i&&a(i.onreadystatechange)?w(i,"onreadystatechange",function(e){return t.wrap(e,void 0,o)}):i.onreadystatechange=o,n.apply(this,arguments)}},r)}n.xhr&&"fetch"in A&&w(A,"fetch",function(e){return function(n,r){for(var o=new Array(arguments.length),i=0;i<o.length;++i)o[i]=arguments[i];var a,s=o[0],u="GET";"string"==typeof s?a=s:(a=s.url,s.method&&(u=s.method)),o[1]&&o[1].method&&(u=o[1].method);var l={method:u,url:a,status_code:null};return t.captureBreadcrumb({type:"http",category:"fetch",data:l}),e.apply(this,o).then(function(e){return l.status_code=e.status,e})}},r),n.dom&&this._hasDocument&&(D.addEventListener?(D.addEventListener("click",t._breadcrumbEventHandler("click"),!1),D.addEventListener("keypress",t._keypressEventHandler(),!1)):(D.attachEvent("onclick",t._breadcrumbEventHandler("click")),D.attachEvent("onkeypress",t._keypressEventHandler())));var i=A.chrome,u=i&&i.app&&i.app.runtime,c=!u&&A.history&&history.pushState;if(n.location&&c){var p=A.onpopstate;A.onpopstate=function(){if(t._captureUrlChange(t._lastHref,t._location.href),p)return p.apply(this,arguments)},w(history,"pushState",function(e){return function(){var n=arguments.length>2?arguments[2]:void 0;return n&&t._captureUrlChange(t._lastHref,n+""),e.apply(this,arguments)}},r)}if(n.console&&"console"in A&&console.log){var d=function(e,n){t.captureBreadcrumb({message:e,level:n.level,category:"console"})};l(["debug","info","warn","error","log"],function(e,t){M(console,t,d)})}},_restoreBuiltIns:function(){for(var e;this._wrappedBuiltIns.length;){e=this._wrappedBuiltIns.shift();e[0][e[1]]=e[2]}},_drainPlugins:function(){var e=this;l(this._plugins,function(t,n){n[0].apply(e,[e].concat(n[1]))})},_parseDSN:function(e){var t=O.exec(e),n={},r=7;try{for(;r--;)n[P[r]]=t[r]||""}catch(t){throw new T("Invalid DSN: "+e)}if(n.pass&&!this._globalOptions.allowSecretKey)throw new T("Do not specify your secret key in the DSN. See: http://bit.ly/raven-secret-key");return n},_getGlobalServer:function(e){var t="//"+e.host+(e.port?":"+e.port:"");return e.protocol&&(t=e.protocol+":"+t),t},_handleOnErrorStackInfo:function(){this._ignoreOnError||this._handleStackInfo.apply(this,arguments)},_handleStackInfo:function(e,t){var n=this._prepareFrames(e,t);this._triggerEvent("handle",{stackInfo:e,options:t}),this._processException(e.name,e.message,e.url,e.lineno,n,t)},_prepareFrames:function(e,t){var n=this,r=[];if(e.stack&&e.stack.length&&(l(e.stack,function(e,t){var o=n._normalizeFrame(t);o&&r.push(o)}),t&&t.trimHeadFrames))for(var o=0;o<t.trimHeadFrames&&o<r.length;o++)r[o].in_app=!1;return r=r.slice(0,this._globalOptions.stackTraceLimit)},_normalizeFrame:function(e){if(e.url){var t={filename:e.url,lineno:e.line,colno:e.column,function:e.func||"?"};return t.in_app=!(this._globalOptions.includePaths.test&&!this._globalOptions.includePaths.test(t.filename)||/(Raven|TraceKit)\./.test(t.function)||/raven\.(min\.)?js$/.test(t.filename)),t}},_processException:function(e,t,n,r,o,i){var a;if((!this._globalOptions.ignoreErrors.test||!this._globalOptions.ignoreErrors.test(t))&&(t+="",o&&o.length?(n=o[0].filename||n,o.reverse(),a={frames:o}):n&&(a={frames:[{filename:n,lineno:r,in_app:!0}]}),(!this._globalOptions.ignoreUrls.test||!this._globalOptions.ignoreUrls.test(n))&&(!this._globalOptions.whitelistUrls.test||this._globalOptions.whitelistUrls.test(n)))){this._send(c({exception:{values:[{type:e,value:t,stacktrace:a}]},culprit:n},i))}},_trimPacket:function(e){var t=this._globalOptions.maxMessageLength;if(e.message&&(e.message=p(e.message,t)),e.exception){var n=e.exception.values[0];n.value=p(n.value,t)}var r=e.request;return r&&(r.url&&(r.url=p(r.url,this._globalOptions.maxUrlLength)),r.Referer&&(r.Referer=p(r.Referer,this._globalOptions.maxUrlLength))),e.breadcrumbs&&e.breadcrumbs.values&&this._trimBreadcrumbs(e.breadcrumbs),e},_trimBreadcrumbs:function(e){for(var t,n,r,o=["to","from","url"],i=0;i<e.values.length;++i)if(n=e.values[i],n.hasOwnProperty("data")&&R(n.data)){r=n.data;for(var a=0;a<o.length;++a)t=o[a],r.hasOwnProperty(t)&&(r[t]=p(r[t],this._globalOptions.maxUrlLength))}},_getHttpData:function(){if(this._hasNavigator||this._hasDocument){var e={};return this._hasNavigator&&k.userAgent&&(e.headers={"User-Agent":navigator.userAgent}),this._hasDocument&&(D.location&&D.location.href&&(e.url=D.location.href),D.referrer&&(e.headers||(e.headers={}),e.headers.Referer=D.referrer)),e}},_resetBackoff:function(){this._backoffDuration=0,this._backoffStart=null},_shouldBackoff:function(){return this._backoffDuration&&r()-this._backoffStart<this._backoffDuration},_isRepeatData:function(e){var t=this._lastData;return!(!t||e.message!==t.message||e.culprit!==t.culprit)&&(e.stacktrace||t.stacktrace?E(e.stacktrace,t.stacktrace):!e.exception&&!t.exception||_(e.exception,t.exception))},_setBackoffState:function(e){if(!this._shouldBackoff()){var t=e.status;if(400===t||401===t||429===t){var n;try{n=e.getResponseHeader("Retry-After"),n=1e3*parseInt(n,10)}catch(e){}this._backoffDuration=n?n:2*this._backoffDuration||1e3,this._backoffStart=r()}}},_send:function(e){var t=this._globalOptions,n={project:this._globalProject,logger:t.logger,platform:"javascript"},o=this._getHttpData();if(o&&(n.request=o),e.trimHeadFrames&&delete e.trimHeadFrames,e=c(n,e),e.tags=c(c({},this._globalContext.tags),e.tags),e.extra=c(c({},this._globalContext.extra),e.extra),e.extra["session:duration"]=r()-this._startTime,this._breadcrumbs&&this._breadcrumbs.length>0&&(e.breadcrumbs={values:[].slice.call(this._breadcrumbs,0)}),u(e.tags)&&delete e.tags,this._globalContext.user&&(e.user=this._globalContext.user),t.environment&&(e.environment=t.environment),t.release&&(e.release=t.release),t.serverName&&(e.server_name=t.serverName),a(t.dataCallback)&&(e=t.dataCallback(e)||e),e&&!u(e)&&(!a(t.shouldSendCallback)||t.shouldSendCallback(e)))return this._shouldBackoff()?void this._logDebug("warn","Raven dropped error due to backoff: ",e):void("number"==typeof t.sampleRate?Math.random()<t.sampleRate&&this._sendProcessedPayload(e):this._sendProcessedPayload(e))},_getUuid:function(){return g()},_sendProcessedPayload:function(e,t){var n=this,r=this._globalOptions;if(this.isSetup()){if(this._lastEventId=e.event_id||(e.event_id=this._getUuid()),e=this._trimPacket(e),!this._globalOptions.allowDuplicates&&this._isRepeatData(e))return void this._logDebug("warn","Raven dropped repeat event: ",e);this._lastData=e,this._logDebug("debug","Raven about to send:",e);var o={sentry_version:"7",sentry_client:"raven-js/"+this.VERSION,sentry_key:this._globalKey};this._globalSecret&&(o.sentry_secret=this._globalSecret);var i=e.exception&&e.exception.values[0];this.captureBreadcrumb({category:"sentry",message:i?(i.type?i.type+": ":"")+i.value:e.message,event_id:e.event_id,level:e.level||"error"});var a=this._globalEndpoint;(r.transport||this._makeRequest).call(this,{url:a,auth:o,data:e,options:r,onSuccess:function(){n._resetBackoff(),n._triggerEvent("success",{data:e,src:a}),t&&t()},onError:function(r){n._logDebug("error","Raven transport failed to send: ",r),r.request&&n._setBackoffState(r.request),n._triggerEvent("failure",{data:e,src:a}),r=r||new Error("Raven send failed (no additional details provided)"),t&&t(r)}})}},_makeRequest:function(e){var t=new XMLHttpRequest;if("withCredentials"in t||"undefined"!=typeof XDomainRequest){var n=e.url;"withCredentials"in t?t.onreadystatechange=function(){if(4===t.readyState)if(200===t.status)e.onSuccess&&e.onSuccess();else if(e.onError){var n=new Error("Sentry error code: "+t.status);n.request=t,e.onError(n)}}:(t=new XDomainRequest,n=n.replace(/^https?:/,""),e.onSuccess&&(t.onload=e.onSuccess),e.onError&&(t.onerror=function(){var n=new Error("Sentry error code: XDomainRequest");n.request=t,e.onError(n)})),t.open("POST",n+"?"+h(e.auth)),t.send(x(e.data))}},_logDebug:function(e){this._originalConsoleMethods[e]&&this.debug&&Function.prototype.apply.call(this._originalConsoleMethods[e],this._originalConsole,[].slice.call(arguments,1))},_mergeContext:function(e,t){i(t)?delete this._globalContext[e]:this._globalContext[e]=c(this._globalContext[e]||{},t)}};var N=Object.prototype;o.prototype.setUser=o.prototype.setUserContext,o.prototype.setReleaseContext=o.prototype.setRelease,e.exports=o}).call(t,n(34))},function(e,t,n){"use strict";(function(t){function r(){return"undefined"==typeof document||void 0===document.location?"":document.location.href}var o=n(268),i={collectWindowErrors:!0,debug:!1},a="undefined"!=typeof window?window:void 0!==t?t:"undefined"!=typeof self?self:{},s=[].slice,u="?",l=/^(?:[Uu]ncaught (?:exception: )?)?(?:((?:Eval|Internal|Range|Reference|Syntax|Type|URI|)Error): )?(.*)$/;i.report=function(){function e(e){d(),b.push(e)}function t(e){for(var t=b.length-1;t>=0;--t)b[t]===e&&b.splice(t,1)}function n(){f(),b=[]}function c(e,t){var n=null;if(!t||i.collectWindowErrors){for(var r in b)if(b.hasOwnProperty(r))try{b[r].apply(null,[e].concat(s.call(arguments,2)))}catch(e){n=e}if(n)throw n}}function p(e,t,n,a,s){var p=null;if(E)i.computeStackTrace.augmentStackTraceWithInitialElement(E,t,n,e),h();else if(s&&o.isError(s))p=i.computeStackTrace(s),c(p,!0);else{var d,f={url:t,line:n,column:a},m=void 0,v=e;if("[object String]"==={}.toString.call(e)){var d=e.match(l);d&&(m=d[1],v=d[2])}f.func=u,p={name:m,message:v,url:r(),stack:[f]},c(p,!0)}return!!g&&g.apply(this,arguments)}function d(){v||(g=a.onerror,a.onerror=p,v=!0)}function f(){v&&(a.onerror=g,v=!1,g=void 0)}function h(){var e=E,t=y;y=null,E=null,_=null,c.apply(null,[e,!1].concat(t))}function m(e,t){var n=s.call(arguments,1);if(E){if(_===e)return;h()}var r=i.computeStackTrace(e);if(E=r,_=e,y=n,setTimeout(function(){_===e&&h()},r.incomplete?2e3:0),t!==!1)throw e}var g,v,b=[],y=null,_=null,E=null;return m.subscribe=e,m.unsubscribe=t,m.uninstall=n,m}(),i.computeStackTrace=function(){function e(e){if(void 0!==e.stack&&e.stack){for(var t,n,o,i=/^\s*at (.*?) ?\(((?:file|https?|blob|chrome-extension|native|eval|webpack|<anonymous>|\/).*?)(?::(\d+))?(?::(\d+))?\)?\s*$/i,a=/^\s*(.*?)(?:\((.*?)\))?(?:^|@)((?:file|https?|blob|chrome|webpack|resource|\[native).*?)(?::(\d+))?(?::(\d+))?\s*$/i,s=/^\s*at (?:((?:\[object object\])?.+) )?\(?((?:file|ms-appx|https?|webpack|blob):.*?):(\d+)(?::(\d+))?\)?\s*$/i,l=/(\S+) line (\d+)(?: > eval line \d+)* > eval/i,c=/\((\S*)(?::(\d+))(?::(\d+))\)/,p=e.stack.split("\n"),d=[],f=(/^(.*) is undefined$/.exec(e.message),0),h=p.length;f<h;++f){if(n=i.exec(p[f])){var m=n[2]&&0===n[2].indexOf("native"),g=n[2]&&0===n[2].indexOf("eval");g&&(t=c.exec(n[2]))&&(n[2]=t[1],n[3]=t[2],n[4]=t[3]),o={url:m?null:n[2],func:n[1]||u,args:m?[n[2]]:[],line:n[3]?+n[3]:null,column:n[4]?+n[4]:null}}else if(n=s.exec(p[f]))o={url:n[2],func:n[1]||u,args:[],line:+n[3],column:n[4]?+n[4]:null};else{if(!(n=a.exec(p[f])))continue;var g=n[3]&&n[3].indexOf(" > eval")>-1;g&&(t=l.exec(n[3]))?(n[3]=t[1],n[4]=t[2],n[5]=null):0!==f||n[5]||void 0===e.columnNumber||(d[0].column=e.columnNumber+1),o={url:n[3],func:n[1]||u,args:n[2]?n[2].split(","):[],line:n[4]?+n[4]:null,column:n[5]?+n[5]:null}}!o.func&&o.line&&(o.func=u),d.push(o)}return d.length?{name:e.name,message:e.message,url:r(),stack:d}:null}}function t(e,t,n,r){var o={url:t,line:n};if(o.url&&o.line){if(e.incomplete=!1,o.func||(o.func=u),e.stack.length>0&&e.stack[0].url===o.url){if(e.stack[0].line===o.line)return!1;if(!e.stack[0].line&&e.stack[0].func===o.func)return e.stack[0].line=o.line,!1}return e.stack.unshift(o),e.partial=!0,!0}return e.incomplete=!0,!1}function n(e,a){for(var s,l,c=/function\s+([_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*)?\s*\(/i,p=[],d={},f=!1,h=n.caller;h&&!f;h=h.caller)if(h!==o&&h!==i.report){if(l={url:null,func:u,line:null,column:null},h.name?l.func=h.name:(s=c.exec(h.toString()))&&(l.func=s[1]),void 0===l.func)try{l.func=s.input.substring(0,s.input.indexOf("{"))}catch(e){}d[""+h]?f=!0:d[""+h]=!0,p.push(l)}a&&p.splice(0,a);var m={name:e.name,message:e.message,url:r(),stack:p};return t(m,e.sourceURL||e.fileName,e.line||e.lineNumber,e.message||e.description),m}function o(t,o){var a=null;o=null==o?0:+o;try{if(a=e(t))return a}catch(e){if(i.debug)throw e}try{if(a=n(t,o+1))return a}catch(e){if(i.debug)throw e}return{name:t.name,message:t.message,url:r()}}return o.augmentStackTraceWithInitialElement=t,o.computeStackTraceFromStackProp=e,o}(),e.exports=i}).call(t,n(34))},function(e,t,n){"use strict";function r(e,t){for(var n=0;n<e.length;++n)if(e[n]===t)return n;return-1}function o(e,t,n,r){return JSON.stringify(e,i(t,r),n)}function i(e,t){var n=[],o=[];return null==t&&(t=function(e,t){return n[0]===t?"[Circular ~]":"[Circular ~."+o.slice(0,r(n,t)).join(".")+"]"}),function(i,a){if(n.length>0){var s=r(n,this);~s?n.splice(s+1):n.push(this),~s?o.splice(s,1/0,i):o.push(i),~r(n,a)&&(a=t.call(this,i,a))}else n.push(a);return null==e?a:e.call(this,i,a)}}t=e.exports=o,t.getSerialize=i},function(e,t,n){"use strict";e.exports={Properties:{"aria-current":0,"aria-details":0,"aria-disabled":0,"aria-hidden":0,"aria-invalid":0,"aria-keyshortcuts":0,"aria-label":0,"aria-roledescription":0,"aria-autocomplete":0,"aria-checked":0,"aria-expanded":0,"aria-haspopup":0,"aria-level":0,"aria-modal":0,"aria-multiline":0,"aria-multiselectable":0,"aria-orientation":0,"aria-placeholder":0,"aria-pressed":0,"aria-readonly":0,"aria-required":0,"aria-selected":0,"aria-sort":0,"aria-valuemax":0,"aria-valuemin":0,"aria-valuenow":0,"aria-valuetext":0,"aria-atomic":0,"aria-busy":0,"aria-live":0,"aria-relevant":0,"aria-dropeffect":0,"aria-grabbed":0,"aria-activedescendant":0,"aria-colcount":0,"aria-colindex":0,"aria-colspan":0,"aria-controls":0,"aria-describedby":0,"aria-errormessage":0,"aria-flowto":0,"aria-labelledby":0,"aria-owns":0,"aria-posinset":0,"aria-rowcount":0,"aria-rowindex":0,"aria-rowspan":0,"aria-setsize":0},DOMAttributeNames:{},DOMPropertyNames:{}}},function(e,t,n){"use strict";var r=n(16),o=n(260);e.exports={focusDOMComponent:function(){o(r.getNodeFromInstance(this))}}},function(e,t,n){"use strict";function r(e){return(e.ctrlKey||e.altKey||e.metaKey)&&!(e.ctrlKey&&e.altKey)}function o(e){switch(e){case"topCompositionStart":return T.compositionStart;case"topCompositionEnd":return T.compositionEnd;case"topCompositionUpdate":return T.compositionUpdate}}function i(e,t){return"topKeyDown"===e&&t.keyCode===b}function a(e,t){switch(e){case"topKeyUp":return v.indexOf(t.keyCode)!==-1;case"topKeyDown":return t.keyCode!==b;case"topKeyPress":case"topMouseDown":case"topBlur":return!0;default:return!1}}function s(e){var t=e.detail;return"object"==typeof t&&"data"in t?t.data:null}function u(e,t,n,r){var u,l;if(y?u=o(e):I?a(e,n)&&(u=T.compositionEnd):i(e,n)&&(u=T.compositionStart),!u)return null;w&&(I||u!==T.compositionStart?u===T.compositionEnd&&I&&(l=I.getData()):I=h.getPooled(r));var c=m.getPooled(u,t,n,r);if(l)c.data=l;else{var p=s(n);null!==p&&(c.data=p)}return d.accumulateTwoPhaseDispatches(c),c}function l(e,t){switch(e){case"topCompositionEnd":return s(t);case"topKeyPress":return t.which!==S?null:(C=!0,x);case"topTextInput":var n=t.data;return n===x&&C?null:n;default:return null}}function c(e,t){if(I){if("topCompositionEnd"===e||!y&&a(e,t)){var n=I.getData();return h.release(I),I=null,n}return null}switch(e){case"topPaste":return null;case"topKeyPress":return t.which&&!r(t)?String.fromCharCode(t.which):null;case"topCompositionEnd":return w?null:t.data;default:return null}}function p(e,t,n,r){var o;if(!(o=E?l(e,n):c(e,n)))return null;var i=g.getPooled(T.beforeInput,t,n,r);return i.data=o,d.accumulateTwoPhaseDispatches(i),i}var d=n(104),f=n(23),h=n(658),m=n(695),g=n(698),v=[9,13,27,32],b=229,y=f.canUseDOM&&"CompositionEvent"in window,_=null;f.canUseDOM&&"documentMode"in document&&(_=document.documentMode);var E=f.canUseDOM&&"TextEvent"in window&&!_&&!function(){var e=window.opera;return"object"==typeof e&&"function"==typeof e.version&&parseInt(e.version(),10)<=12}(),w=f.canUseDOM&&(!y||_&&_>8&&_<=11),S=32,x=String.fromCharCode(S),T={beforeInput:{phasedRegistrationNames:{bubbled:"onBeforeInput",captured:"onBeforeInputCapture"},dependencies:["topCompositionEnd","topKeyPress","topTextInput","topPaste"]},compositionEnd:{phasedRegistrationNames:{bubbled:"onCompositionEnd",captured:"onCompositionEndCapture"},dependencies:["topBlur","topCompositionEnd","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]},compositionStart:{phasedRegistrationNames:{bubbled:"onCompositionStart",captured:"onCompositionStartCapture"},dependencies:["topBlur","topCompositionStart","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]},compositionUpdate:{phasedRegistrationNames:{bubbled:"onCompositionUpdate",captured:"onCompositionUpdateCapture"},dependencies:["topBlur","topCompositionUpdate","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]}},C=!1,I=null;e.exports={eventTypes:T,extractEvents:function(e,t,n,r){return[u(e,t,n,r),p(e,t,n,r)]}}},function(e,t,n){"use strict";var r=n(269),o=n(23),i=(n(39),n(593),n(704)),a=n(600),s=n(603),u=(n(5),s(function(e){return a(e)})),l=!1,c="cssFloat";if(o.canUseDOM){var p=document.createElement("div").style;try{p.font=""}catch(e){l=!0}void 0===document.documentElement.style.cssFloat&&(c="styleFloat")}e.exports={createMarkupForStyles:function(e,t){var n="";for(var r in e)if(e.hasOwnProperty(r)){var o=e[r];null!=o&&(n+=u(r)+":",n+=i(r,o,t)+";")}return n||null},setValueForStyles:function(e,t,n){var o=e.style;for(var a in t)if(t.hasOwnProperty(a)){var s=i(a,t[a],n);if("float"!==a&&"cssFloat"!==a||(a=c),s)o[a]=s;else{var u=l&&r.shorthandPropertyExpansions[a];if(u)for(var p in u)o[p]="";else o[a]=""}}}}},function(e,t,n){"use strict";function r(e){var t=e.nodeName&&e.nodeName.toLowerCase();return"select"===t||"input"===t&&"file"===e.type}function o(e){var t=x.getPooled(R.change,P,e,T(e));_.accumulateTwoPhaseDispatches(t),S.batchedUpdates(i,t)}function i(e){y.enqueueEvents(e),y.processEventQueue(!1)}function a(e,t){M=e,P=t,M.attachEvent("onchange",o)}function s(){M&&(M.detachEvent("onchange",o),M=null,P=null)}function u(e,t){if("topChange"===e)return t}function l(e,t,n){"topFocus"===e?(s(),a(t,n)):"topBlur"===e&&s()}function c(e,t){M=e,P=t,O=e.value,A=Object.getOwnPropertyDescriptor(e.constructor.prototype,"value"),Object.defineProperty(M,"value",N),M.attachEvent?M.attachEvent("onpropertychange",d):M.addEventListener("propertychange",d,!1)}function p(){M&&(delete M.value,M.detachEvent?M.detachEvent("onpropertychange",d):M.removeEventListener("propertychange",d,!1),M=null,P=null,O=null,A=null)}function d(e){if("value"===e.propertyName){var t=e.srcElement.value;t!==O&&(O=t,o(e))}}function f(e,t){if("topInput"===e)return t}function h(e,t,n){"topFocus"===e?(p(),c(t,n)):"topBlur"===e&&p()}function m(e,t){if(("topSelectionChange"===e||"topKeyUp"===e||"topKeyDown"===e)&&M&&M.value!==O)return O=M.value,P}function g(e){return e.nodeName&&"input"===e.nodeName.toLowerCase()&&("checkbox"===e.type||"radio"===e.type)}function v(e,t){if("topClick"===e)return t}function b(e,t){if(null!=e){var n=e._wrapperState||t._wrapperState;if(n&&n.controlled&&"number"===t.type){var r=""+t.value;t.getAttribute("value")!==r&&t.setAttribute("value",r)}}}var y=n(103),_=n(104),E=n(23),w=n(16),S=n(45),x=n(54),T=n(183),C=n(184),I=n(286),R={change:{phasedRegistrationNames:{bubbled:"onChange",captured:"onChangeCapture"},dependencies:["topBlur","topChange","topClick","topFocus","topInput","topKeyDown","topKeyUp","topSelectionChange"]}},M=null,P=null,O=null,A=null,D=!1;E.canUseDOM&&(D=C("change")&&(!document.documentMode||document.documentMode>8));var k=!1;E.canUseDOM&&(k=C("input")&&(!document.documentMode||document.documentMode>11));var N={get:function(){return A.get.call(this)},set:function(e){O=""+e,A.set.call(this,e)}};e.exports={eventTypes:R,extractEvents:function(e,t,n,o){var i,a,s=t?w.getNodeFromInstance(t):window;if(r(s)?D?i=u:a=l:I(s)?k?i=f:(i=m,a=h):g(s)&&(i=v),i){var c=i(e,t);if(c){var p=x.getPooled(R.change,c,n,o);return p.type="change",_.accumulateTwoPhaseDispatches(p),p}}a&&a(e,s,t),"topBlur"===e&&b(t,s)}}},function(e,t,n){"use strict";var r=n(7),o=n(86),i=n(23),a=n(596),s=n(32);n(1);e.exports={dangerouslyReplaceNodeWithMarkup:function(e,t){if(i.canUseDOM||r("56"),t||r("57"),"HTML"===e.nodeName&&r("58"),"string"==typeof t){e.parentNode.replaceChild(a(t,s)[0],e)}else o.replaceChildWithTree(e,t)}}},function(e,t,n){"use strict";e.exports=["ResponderEventPlugin","SimpleEventPlugin","TapEventPlugin","EnterLeaveEventPlugin","ChangeEventPlugin","SelectEventPlugin","BeforeInputEventPlugin"]},function(e,t,n){"use strict";var r=n(104),o=n(16),i=n(125),a={mouseEnter:{registrationName:"onMouseEnter",dependencies:["topMouseOut","topMouseOver"]},mouseLeave:{registrationName:"onMouseLeave",dependencies:["topMouseOut","topMouseOver"]}};e.exports={eventTypes:a,extractEvents:function(e,t,n,s){if("topMouseOver"===e&&(n.relatedTarget||n.fromElement))return null;if("topMouseOut"!==e&&"topMouseOver"!==e)return null;var u;if(s.window===s)u=s;else{var l=s.ownerDocument;u=l?l.defaultView||l.parentWindow:window}var c,p;if("topMouseOut"===e){c=t;var d=n.relatedTarget||n.toElement;p=d?o.getClosestInstanceFromNode(d):null}else c=null,p=t;if(c===p)return null;var f=null==c?u:o.getNodeFromInstance(c),h=null==p?u:o.getNodeFromInstance(p),m=i.getPooled(a.mouseLeave,c,n,s);m.type="mouseleave",m.target=f,m.relatedTarget=h;var g=i.getPooled(a.mouseEnter,p,n,s);return g.type="mouseenter",g.target=h,g.relatedTarget=f,r.accumulateEnterLeaveDispatches(m,g,c,p),[m,g]}}},function(e,t,n){"use strict";function r(e){this._root=e,this._startText=this.getText(),this._fallbackText=null}var o=n(13),i=n(73),a=n(284);o(r.prototype,{destructor:function(){this._root=null,this._startText=null,this._fallbackText=null},getText:function(){return"value"in this._root?this._root.value:this._root[a()]},getData:function(){if(this._fallbackText)return this._fallbackText;var e,t,n=this._startText,r=n.length,o=this.getText(),i=o.length;for(e=0;e<r&&n[e]===o[e];e++);var a=r-e;for(t=1;t<=a&&n[r-t]===o[i-t];t++);return this._fallbackText=o.slice(e,t>1?1-t:void 0)}}),i.addPoolingTo(r),e.exports=r},function(e,t,n){"use strict";var r=n(87),o=r.injection.MUST_USE_PROPERTY,i=r.injection.HAS_BOOLEAN_VALUE,a=r.injection.HAS_NUMERIC_VALUE,s=r.injection.HAS_POSITIVE_NUMERIC_VALUE,u=r.injection.HAS_OVERLOADED_BOOLEAN_VALUE;e.exports={isCustomAttribute:RegExp.prototype.test.bind(new RegExp("^(data|aria)-["+r.ATTRIBUTE_NAME_CHAR+"]*$")),Properties:{accept:0,acceptCharset:0,accessKey:0,action:0,allowFullScreen:i,allowTransparency:0,alt:0,as:0,async:i,autoComplete:0,autoPlay:i,capture:i,cellPadding:0,cellSpacing:0,charSet:0,challenge:0,checked:o|i,cite:0,classID:0,className:0,cols:s,colSpan:0,content:0,contentEditable:0,contextMenu:0,controls:i,coords:0,crossOrigin:0,data:0,dateTime:0,default:i,defer:i,dir:0,disabled:i,download:u,draggable:0,encType:0,form:0,formAction:0,formEncType:0,formMethod:0,formNoValidate:i,formTarget:0,frameBorder:0,headers:0,height:0,hidden:i,high:0,href:0,hrefLang:0,htmlFor:0,httpEquiv:0,icon:0,id:0,inputMode:0,integrity:0,is:0,keyParams:0,keyType:0,kind:0,label:0,lang:0,list:0,loop:i,low:0,manifest:0,marginHeight:0,marginWidth:0,max:0,maxLength:0,media:0,mediaGroup:0,method:0,min:0,minLength:0,multiple:o|i,muted:o|i,name:0,nonce:0,noValidate:i,open:i,optimum:0,pattern:0,placeholder:0,playsInline:i,poster:0,preload:0,profile:0,radioGroup:0,readOnly:i,referrerPolicy:0,rel:0,required:i,reversed:i,role:0,rows:s,rowSpan:a,sandbox:0,scope:0,scoped:i,scrolling:0,seamless:i,selected:o|i,shape:0,size:s,sizes:0,span:s,spellCheck:0,src:0,srcDoc:0,srcLang:0,srcSet:0,start:a,step:0,style:0,summary:0,tabIndex:0,target:0,title:0,type:0,useMap:0,value:0,width:0,wmode:0,wrap:0,about:0,datatype:0,inlist:0,prefix:0,property:0,resource:0,typeof:0,vocab:0,autoCapitalize:0,autoCorrect:0,autoSave:0,color:0,itemProp:0,itemScope:i,itemType:0,itemID:0,itemRef:0,results:0,security:0,unselectable:0},DOMAttributeNames:{acceptCharset:"accept-charset",className:"class",htmlFor:"for",httpEquiv:"http-equiv"},DOMPropertyNames:{},DOMMutationMethods:{value:function(e,t){if(null==t)return e.removeAttribute("value");"number"!==e.type||e.hasAttribute("value")===!1?e.setAttribute("value",""+t):e.validity&&!e.validity.badInput&&e.ownerDocument.activeElement!==e&&e.setAttribute("value",""+t)}}}},function(e,t,n){"use strict";(function(t){function r(e,t,n,r){var o=void 0===e[n];null!=t&&o&&(e[n]=i(t,!0))}var o=n(88),i=n(285),a=(n(175),n(185)),s=n(288);n(5);void 0!==t&&n.i({NODE_ENV:"production"}),e.exports={instantiateChildren:function(e,t,n,o){if(null==e)return null;var i={};return s(e,r,i),i},updateChildren:function(e,t,n,r,s,u,l,c,p){if(t||e){var d,f;for(d in t)if(t.hasOwnProperty(d)){f=e&&e[d];var h=f&&f._currentElement,m=t[d];if(null!=f&&a(h,m))o.receiveComponent(f,m,s,c),t[d]=f;else{f&&(r[d]=o.getHostNode(f),o.unmountComponent(f,!1));var g=i(m,!0);t[d]=g;var v=o.mountComponent(g,s,u,l,c,p);n.push(v)}}for(d in e)!e.hasOwnProperty(d)||t&&t.hasOwnProperty(d)||(f=e[d],r[d]=o.getHostNode(f),o.unmountComponent(f,!1))}},unmountChildren:function(e,t){for(var n in e)if(e.hasOwnProperty(n)){var r=e[n];o.unmountComponent(r,t)}}}}).call(t,n(107))},function(e,t,n){"use strict";var r=n(171);e.exports={processChildrenUpdates:n(668).dangerouslyProcessChildrenUpdates,replaceNodeWithMarkup:r.dangerouslyReplaceNodeWithMarkup}},function(e,t,n){"use strict";function r(e){}function o(e){return!(!e.prototype||!e.prototype.isReactComponent)}function i(e){return!(!e.prototype||!e.prototype.isPureReactComponent)}var a=n(7),s=n(13),u=n(89),l=n(177),c=n(56),p=n(178),d=n(105),f=(n(39),n(279)),h=n(88),m=n(101),g=(n(1),n(167)),v=n(185),b=(n(5),{ImpureClass:0,PureClass:1,StatelessFunctional:2});r.prototype.render=function(){var e=d.get(this)._currentElement.type,t=e(this.props,this.context,this.updater);return t};var y=1;e.exports={construct:function(e){this._currentElement=e,this._rootNodeID=0,this._compositeType=null,this._instance=null,this._hostParent=null,this._hostContainerInfo=null,this._updateBatchNumber=null,this._pendingElement=null,this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1,this._renderedNodeType=null,this._renderedComponent=null,this._context=null,this._mountOrder=0,this._topLevelWrapper=null,this._pendingCallbacks=null,this._calledComponentWillUnmount=!1},mountComponent:function(e,t,n,s){this._context=s,this._mountOrder=y++,this._hostParent=t,this._hostContainerInfo=n;var l,c=this._currentElement.props,p=this._processContext(s),f=this._currentElement.type,h=e.getUpdateQueue(),g=o(f),v=this._constructComponent(g,c,p,h);g||null!=v&&null!=v.render?this._compositeType=i(f)?b.PureClass:b.ImpureClass:(l=v,null===v||v===!1||u.isValidElement(v)||a("105",f.displayName||f.name||"Component"),v=new r(f),this._compositeType=b.StatelessFunctional);v.props=c,v.context=p,v.refs=m,v.updater=h,this._instance=v,d.set(v,this);var _=v.state;void 0===_&&(v.state=_=null),("object"!=typeof _||Array.isArray(_))&&a("106",this.getName()||"ReactCompositeComponent"),this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1;var E;return E=v.unstable_handleError?this.performInitialMountWithErrorHandling(l,t,n,e,s):this.performInitialMount(l,t,n,e,s),v.componentDidMount&&e.getReactMountReady().enqueue(v.componentDidMount,v),E},_constructComponent:function(e,t,n,r){return this._constructComponentWithoutOwner(e,t,n,r)},_constructComponentWithoutOwner:function(e,t,n,r){var o=this._currentElement.type;return e?new o(t,n,r):o(t,n,r)},performInitialMountWithErrorHandling:function(e,t,n,r,o){var i,a=r.checkpoint();try{i=this.performInitialMount(e,t,n,r,o)}catch(s){r.rollback(a),this._instance.unstable_handleError(s),this._pendingStateQueue&&(this._instance.state=this._processPendingState(this._instance.props,this._instance.context)),a=r.checkpoint(),this._renderedComponent.unmountComponent(!0),r.rollback(a),i=this.performInitialMount(e,t,n,r,o)}return i},performInitialMount:function(e,t,n,r,o){var i=this._instance,a=0;i.componentWillMount&&(i.componentWillMount(),this._pendingStateQueue&&(i.state=this._processPendingState(i.props,i.context))),void 0===e&&(e=this._renderValidatedComponent());var s=f.getType(e);this._renderedNodeType=s;var u=this._instantiateReactComponent(e,s!==f.EMPTY);this._renderedComponent=u;var l=h.mountComponent(u,r,t,n,this._processChildContext(o),a);return l},getHostNode:function(){return h.getHostNode(this._renderedComponent)},unmountComponent:function(e){if(this._renderedComponent){var t=this._instance;if(t.componentWillUnmount&&!t._calledComponentWillUnmount)if(t._calledComponentWillUnmount=!0,e){var n=this.getName()+".componentWillUnmount()";p.invokeGuardedCallback(n,t.componentWillUnmount.bind(t))}else t.componentWillUnmount();this._renderedComponent&&(h.unmountComponent(this._renderedComponent,e),this._renderedNodeType=null,this._renderedComponent=null,this._instance=null),this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1,this._pendingCallbacks=null,this._pendingElement=null,this._context=null,this._rootNodeID=0,this._topLevelWrapper=null,d.remove(t)}},_maskContext:function(e){var t=this._currentElement.type,n=t.contextTypes;if(!n)return m;var r={};for(var o in n)r[o]=e[o];return r},_processContext:function(e){var t=this._maskContext(e);return t},_processChildContext:function(e){var t,n=this._currentElement.type,r=this._instance;if(r.getChildContext&&(t=r.getChildContext()),t){"object"!=typeof n.childContextTypes&&a("107",this.getName()||"ReactCompositeComponent");for(var o in t)o in n.childContextTypes||a("108",this.getName()||"ReactCompositeComponent",o);return s({},e,t)}return e},_checkContextTypes:function(e,t,n){},receiveComponent:function(e,t,n){var r=this._currentElement,o=this._context;this._pendingElement=null,this.updateComponent(t,r,e,o,n)},performUpdateIfNecessary:function(e){null!=this._pendingElement?h.receiveComponent(this,this._pendingElement,e,this._context):null!==this._pendingStateQueue||this._pendingForceUpdate?this.updateComponent(e,this._currentElement,this._currentElement,this._context,this._context):this._updateBatchNumber=null},updateComponent:function(e,t,n,r,o){var i=this._instance;null==i&&a("136",this.getName()||"ReactCompositeComponent");var s,u=!1;this._context===o?s=i.context:(s=this._processContext(o),u=!0);var l=t.props,c=n.props;t!==n&&(u=!0),u&&i.componentWillReceiveProps&&i.componentWillReceiveProps(c,s);var p=this._processPendingState(c,s),d=!0;this._pendingForceUpdate||(i.shouldComponentUpdate?d=i.shouldComponentUpdate(c,p,s):this._compositeType===b.PureClass&&(d=!g(l,c)||!g(i.state,p))),this._updateBatchNumber=null,d?(this._pendingForceUpdate=!1,this._performComponentUpdate(n,c,p,s,e,o)):(this._currentElement=n,this._context=o,i.props=c,i.state=p,i.context=s)},_processPendingState:function(e,t){var n=this._instance,r=this._pendingStateQueue,o=this._pendingReplaceState;if(this._pendingReplaceState=!1,this._pendingStateQueue=null,!r)return n.state;if(o&&1===r.length)return r[0];for(var i=s({},o?r[0]:n.state),a=o?1:0;a<r.length;a++){var u=r[a];s(i,"function"==typeof u?u.call(n,i,e,t):u)}return i},_performComponentUpdate:function(e,t,n,r,o,i){var a,s,u,l=this._instance,c=Boolean(l.componentDidUpdate);c&&(a=l.props,s=l.state,u=l.context),l.componentWillUpdate&&l.componentWillUpdate(t,n,r),this._currentElement=e,this._context=i,l.props=t,l.state=n,l.context=r,this._updateRenderedComponent(o,i),c&&o.getReactMountReady().enqueue(l.componentDidUpdate.bind(l,a,s,u),l)},_updateRenderedComponent:function(e,t){var n=this._renderedComponent,r=n._currentElement,o=this._renderValidatedComponent(),i=0;if(v(r,o))h.receiveComponent(n,o,e,this._processChildContext(t));else{var a=h.getHostNode(n);h.unmountComponent(n,!1);var s=f.getType(o);this._renderedNodeType=s;var u=this._instantiateReactComponent(o,s!==f.EMPTY);this._renderedComponent=u;var l=h.mountComponent(u,e,this._hostParent,this._hostContainerInfo,this._processChildContext(t),i);this._replaceNodeWithMarkup(a,l,n)}},_replaceNodeWithMarkup:function(e,t,n){l.replaceNodeWithMarkup(e,t,n)},_renderValidatedComponentWithoutOwnerOrContext:function(){var e=this._instance;return e.render()},_renderValidatedComponent:function(){var e;if(this._compositeType!==b.StatelessFunctional){c.current=this;try{e=this._renderValidatedComponentWithoutOwnerOrContext()}finally{c.current=null}}else e=this._renderValidatedComponentWithoutOwnerOrContext();return null===e||e===!1||u.isValidElement(e)||a("109",this.getName()||"ReactCompositeComponent"),e},attachRef:function(e,t){var n=this.getPublicInstance();null==n&&a("110");var r=t.getPublicInstance();(n.refs===m?n.refs={}:n.refs)[e]=r},detachRef:function(e){delete this.getPublicInstance().refs[e]},getName:function(){var e=this._currentElement.type,t=this._instance&&this._instance.constructor;return e.displayName||t&&t.displayName||e.name||t&&t.name||null},getPublicInstance:function(){var e=this._instance;return this._compositeType===b.StatelessFunctional?null:e},_instantiateReactComponent:null}},function(e,t,n){"use strict";var r=n(16),o=n(676),i=n(278),a=n(88),s=n(45),u=n(689),l=n(705),c=n(283),p=n(712);n(5);o.inject();var d={findDOMNode:l,render:i.render,unmountComponentAtNode:i.unmountComponentAtNode,version:u,unstable_batchedUpdates:s.batchedUpdates,unstable_renderSubtreeIntoContainer:p};"undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__&&"function"==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.inject&&__REACT_DEVTOOLS_GLOBAL_HOOK__.inject({ComponentTree:{getClosestInstanceFromNode:r.getClosestInstanceFromNode,getNodeFromInstance:function(e){return e._renderedComponent&&(e=c(e)),e?r.getNodeFromInstance(e):null}},Mount:i,Reconciler:a});e.exports=d},function(e,t,n){"use strict";function r(e){if(e){var t=e._currentElement._owner||null;if(t){var n=t.getName();if(n)return" This DOM node was rendered by `"+n+"`."}}return""}function o(e,t){t&&(Y[e._tag]&&(null!=t.children||null!=t.dangerouslySetInnerHTML)&&m("137",e._tag,e._currentElement._owner?" Check the render method of "+e._currentElement._owner.getName()+".":""),null!=t.dangerouslySetInnerHTML&&(null!=t.children&&m("60"),"object"==typeof t.dangerouslySetInnerHTML&&j in t.dangerouslySetInnerHTML||m("61")),null!=t.style&&"object"!=typeof t.style&&m("62",r(e)))}function i(e,t,n,r){if(!(r instanceof D)){var o=e._hostContainerInfo;U(t,o._node&&o._node.nodeType===z?o._node:o._ownerDocument),r.getReactMountReady().enqueue(a,{inst:e,registrationName:t,listener:n})}}function a(){var e=this;S.putListener(e.inst,e.registrationName,e.listener)}function s(){R.postMountWrapper(this)}function u(){O.postMountWrapper(this)}function l(){M.postMountWrapper(this)}function c(){var e=this;e._rootNodeID||m("63");var t=F(e);switch(t||m("64"),e._tag){case"iframe":case"object":e._wrapperState.listeners=[T.trapBubbledEvent("topLoad","load",t)];break;case"video":case"audio":e._wrapperState.listeners=[];for(var n in q)q.hasOwnProperty(n)&&e._wrapperState.listeners.push(T.trapBubbledEvent(n,q[n],t));break;case"source":e._wrapperState.listeners=[T.trapBubbledEvent("topError","error",t)];break;case"img":e._wrapperState.listeners=[T.trapBubbledEvent("topError","error",t),T.trapBubbledEvent("topLoad","load",t)];break;case"form":e._wrapperState.listeners=[T.trapBubbledEvent("topReset","reset",t),T.trapBubbledEvent("topSubmit","submit",t)];break;case"input":case"select":case"textarea":e._wrapperState.listeners=[T.trapBubbledEvent("topInvalid","invalid",t)]}}function p(){P.postUpdateWrapper(this)}function d(e){X.call(K,e)||($.test(e)||m("65",e),K[e]=!0)}function f(e,t){return e.indexOf("-")>=0||null!=t.is}function h(e){var t=e.type;d(t),this._currentElement=e,this._tag=t.toLowerCase(),this._namespaceURI=null,this._renderedChildren=null,this._previousStyle=null,this._previousStyleCopy=null,this._hostNode=null,this._hostParent=null,this._rootNodeID=0,this._domID=0,this._hostContainerInfo=null,this._wrapperState=null,this._topLevelWrapper=null,this._flags=0}var m=n(7),g=n(13),v=n(651),b=n(653),y=n(86),_=n(172),E=n(87),w=n(271),S=n(103),x=n(173),T=n(124),C=n(272),I=n(16),R=n(669),M=n(670),P=n(273),O=n(673),A=(n(39),n(682)),D=n(687),k=(n(32),n(127)),N=(n(1),n(184),n(167),n(186),n(5),C),L=S.deleteListener,F=I.getNodeFromInstance,U=T.listenTo,H=x.registrationNameModules,B={string:!0,number:!0},j="__html",W={children:null,dangerouslySetInnerHTML:null,suppressContentEditableWarning:null},z=11,q={topAbort:"abort",topCanPlay:"canplay",topCanPlayThrough:"canplaythrough",topDurationChange:"durationchange",topEmptied:"emptied",topEncrypted:"encrypted",topEnded:"ended",topError:"error",topLoadedData:"loadeddata",topLoadedMetadata:"loadedmetadata",topLoadStart:"loadstart",topPause:"pause",topPlay:"play",topPlaying:"playing",topProgress:"progress",topRateChange:"ratechange",topSeeked:"seeked",topSeeking:"seeking",topStalled:"stalled",topSuspend:"suspend",topTimeUpdate:"timeupdate",topVolumeChange:"volumechange",topWaiting:"waiting"},V={area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0},G={listing:!0,pre:!0,textarea:!0},Y=g({menuitem:!0},V),$=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,K={},X={}.hasOwnProperty,Z=1;h.displayName="ReactDOMComponent",h.Mixin={mountComponent:function(e,t,n,r){this._rootNodeID=Z++,this._domID=n._idCounter++,this._hostParent=t,this._hostContainerInfo=n;var i=this._currentElement.props;switch(this._tag){case"audio":case"form":case"iframe":case"img":case"link":case"object":case"source":case"video":this._wrapperState={listeners:null},e.getReactMountReady().enqueue(c,this);break;case"input":R.mountWrapper(this,i,t),i=R.getHostProps(this,i),e.getReactMountReady().enqueue(c,this);break;case"option":M.mountWrapper(this,i,t),i=M.getHostProps(this,i);break;case"select":P.mountWrapper(this,i,t),i=P.getHostProps(this,i),e.getReactMountReady().enqueue(c,this);break;case"textarea":O.mountWrapper(this,i,t),i=O.getHostProps(this,i),e.getReactMountReady().enqueue(c,this)}o(this,i);var a,p;null!=t?(a=t._namespaceURI,p=t._tag):n._tag&&(a=n._namespaceURI,p=n._tag),(null==a||a===_.svg&&"foreignobject"===p)&&(a=_.html),a===_.html&&("svg"===this._tag?a=_.svg:"math"===this._tag&&(a=_.mathml)),this._namespaceURI=a;var d;if(e.useCreateElement){var f,h=n._ownerDocument;if(a===_.html)if("script"===this._tag){var m=h.createElement("div"),g=this._currentElement.type;m.innerHTML="<"+g+"></"+g+">",f=m.removeChild(m.firstChild)}else f=i.is?h.createElement(this._currentElement.type,i.is):h.createElement(this._currentElement.type);else f=h.createElementNS(a,this._currentElement.type);I.precacheNode(this,f),this._flags|=N.hasCachedChildNodes,this._hostParent||w.setAttributeForRoot(f),this._updateDOMProperties(null,i,e);var b=y(f);this._createInitialChildren(e,i,r,b),d=b}else{var E=this._createOpenTagMarkupAndPutListeners(e,i),S=this._createContentMarkup(e,i,r);d=!S&&V[this._tag]?E+"/>":E+">"+S+"</"+this._currentElement.type+">"}switch(this._tag){case"input":e.getReactMountReady().enqueue(s,this),i.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"textarea":e.getReactMountReady().enqueue(u,this),i.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"select":i.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"button":i.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"option":e.getReactMountReady().enqueue(l,this)}return d},_createOpenTagMarkupAndPutListeners:function(e,t){var n="<"+this._currentElement.type;for(var r in t)if(t.hasOwnProperty(r)){var o=t[r];if(null!=o)if(H.hasOwnProperty(r))o&&i(this,r,o,e);else{"style"===r&&(o&&(o=this._previousStyleCopy=g({},t.style)),o=b.createMarkupForStyles(o,this));var a=null;null!=this._tag&&f(this._tag,t)?W.hasOwnProperty(r)||(a=w.createMarkupForCustomAttribute(r,o)):a=w.createMarkupForProperty(r,o),a&&(n+=" "+a)}}return e.renderToStaticMarkup?n:(this._hostParent||(n+=" "+w.createMarkupForRoot()),n+=" "+w.createMarkupForID(this._domID))},_createContentMarkup:function(e,t,n){var r="",o=t.dangerouslySetInnerHTML;if(null!=o)null!=o.__html&&(r=o.__html);else{var i=B[typeof t.children]?t.children:null,a=null!=i?null:t.children;if(null!=i)r=k(i);else if(null!=a){var s=this.mountChildren(a,e,n);r=s.join("")}}return G[this._tag]&&"\n"===r.charAt(0)?"\n"+r:r},_createInitialChildren:function(e,t,n,r){var o=t.dangerouslySetInnerHTML;if(null!=o)null!=o.__html&&y.queueHTML(r,o.__html);else{var i=B[typeof t.children]?t.children:null,a=null!=i?null:t.children;if(null!=i)""!==i&&y.queueText(r,i);else if(null!=a)for(var s=this.mountChildren(a,e,n),u=0;u<s.length;u++)y.queueChild(r,s[u])}},receiveComponent:function(e,t,n){var r=this._currentElement;this._currentElement=e,this.updateComponent(t,r,e,n)},updateComponent:function(e,t,n,r){var i=t.props,a=this._currentElement.props;switch(this._tag){case"input":i=R.getHostProps(this,i),a=R.getHostProps(this,a);break;case"option":i=M.getHostProps(this,i),a=M.getHostProps(this,a);break;case"select":i=P.getHostProps(this,i),a=P.getHostProps(this,a);break;case"textarea":i=O.getHostProps(this,i),a=O.getHostProps(this,a)}switch(o(this,a),this._updateDOMProperties(i,a,e),this._updateDOMChildren(i,a,e,r),this._tag){case"input":R.updateWrapper(this);break;case"textarea":O.updateWrapper(this);break;case"select":e.getReactMountReady().enqueue(p,this)}},_updateDOMProperties:function(e,t,n){var r,o,a;for(r in e)if(!t.hasOwnProperty(r)&&e.hasOwnProperty(r)&&null!=e[r])if("style"===r){var s=this._previousStyleCopy;for(o in s)s.hasOwnProperty(o)&&(a=a||{},a[o]="");this._previousStyleCopy=null}else H.hasOwnProperty(r)?e[r]&&L(this,r):f(this._tag,e)?W.hasOwnProperty(r)||w.deleteValueForAttribute(F(this),r):(E.properties[r]||E.isCustomAttribute(r))&&w.deleteValueForProperty(F(this),r);for(r in t){var u=t[r],l="style"===r?this._previousStyleCopy:null!=e?e[r]:void 0;if(t.hasOwnProperty(r)&&u!==l&&(null!=u||null!=l))if("style"===r)if(u?u=this._previousStyleCopy=g({},u):this._previousStyleCopy=null,l){for(o in l)!l.hasOwnProperty(o)||u&&u.hasOwnProperty(o)||(a=a||{},a[o]="");for(o in u)u.hasOwnProperty(o)&&l[o]!==u[o]&&(a=a||{},a[o]=u[o])}else a=u;else if(H.hasOwnProperty(r))u?i(this,r,u,n):l&&L(this,r);else if(f(this._tag,t))W.hasOwnProperty(r)||w.setValueForAttribute(F(this),r,u);else if(E.properties[r]||E.isCustomAttribute(r)){var c=F(this);null!=u?w.setValueForProperty(c,r,u):w.deleteValueForProperty(c,r)}}a&&b.setValueForStyles(F(this),a,this)},_updateDOMChildren:function(e,t,n,r){var o=B[typeof e.children]?e.children:null,i=B[typeof t.children]?t.children:null,a=e.dangerouslySetInnerHTML&&e.dangerouslySetInnerHTML.__html,s=t.dangerouslySetInnerHTML&&t.dangerouslySetInnerHTML.__html,u=null!=o?null:e.children,l=null!=i?null:t.children,c=null!=o||null!=a,p=null!=i||null!=s;null!=u&&null==l?this.updateChildren(null,n,r):c&&!p&&this.updateTextContent(""),null!=i?o!==i&&this.updateTextContent(""+i):null!=s?a!==s&&this.updateMarkup(""+s):null!=l&&this.updateChildren(l,n,r)},getHostNode:function(){return F(this)},unmountComponent:function(e){switch(this._tag){case"audio":case"form":case"iframe":case"img":case"link":case"object":case"source":case"video":var t=this._wrapperState.listeners;if(t)for(var n=0;n<t.length;n++)t[n].remove();break;case"html":case"head":case"body":m("66",this._tag)}this.unmountChildren(e),I.uncacheNode(this),S.deleteAllListeners(this),this._rootNodeID=0,this._domID=0,this._wrapperState=null},getPublicInstance:function(){return F(this)}},g(h.prototype,h.Mixin,A.Mixin),e.exports=h},function(e,t,n){"use strict";function r(e,t){var n={_topLevelWrapper:e,_idCounter:1,_ownerDocument:t?t.nodeType===o?t:t.ownerDocument:null,_node:t,_tag:t?t.nodeName.toLowerCase():null,_namespaceURI:t?t.namespaceURI:null};return n}var o=(n(186),9);e.exports=r},function(e,t,n){"use strict";var r=n(13),o=n(86),i=n(16),a=function(e){this._currentElement=null,this._hostNode=null,this._hostParent=null,this._hostContainerInfo=null,this._domID=0};r(a.prototype,{mountComponent:function(e,t,n,r){this._domID=n._idCounter++,this._hostParent=t,this._hostContainerInfo=n;var a=" react-empty: "+this._domID+" ";if(e.useCreateElement){var s=n._ownerDocument,u=s.createComment(a);return i.precacheNode(this,u),o(u)}return e.renderToStaticMarkup?"":"<!--"+a+"-->"},receiveComponent:function(){},getHostNode:function(){return i.getNodeFromInstance(this)},unmountComponent:function(){i.uncacheNode(this)}}),e.exports=a},function(e,t,n){"use strict";e.exports={useCreateElement:!0,useFiber:!1}},function(e,t,n){"use strict";var r=n(171),o=n(16);e.exports={dangerouslyProcessChildrenUpdates:function(e,t){var n=o.getNodeFromInstance(e);r.processUpdates(n,t)}}},function(e,t,n){"use strict";function r(){this._rootNodeID&&d.updateWrapper(this)}function o(e){return"checkbox"===e.type||"radio"===e.type?null!=e.checked:null!=e.value}function i(e){var t=this._currentElement.props,n=l.executeOnChange(t,e);p.asap(r,this);var o=t.name;if("radio"===t.type&&null!=o){for(var i=c.getNodeFromInstance(this),s=i;s.parentNode;)s=s.parentNode;for(var u=s.querySelectorAll("input[name="+JSON.stringify(""+o)+'][type="radio"]'),d=0;d<u.length;d++){var f=u[d];if(f!==i&&f.form===i.form){var h=c.getInstanceFromNode(f);h||a("90"),p.asap(r,h)}}}return n}var a=n(7),s=n(13),u=n(271),l=n(176),c=n(16),p=n(45),d=(n(1),n(5),{getHostProps:function(e,t){var n=l.getValue(t),r=l.getChecked(t);return s({type:void 0,step:void 0,min:void 0,max:void 0},t,{defaultChecked:void 0,defaultValue:void 0,value:null!=n?n:e._wrapperState.initialValue,checked:null!=r?r:e._wrapperState.initialChecked,onChange:e._wrapperState.onChange})},mountWrapper:function(e,t){var n=t.defaultValue;e._wrapperState={initialChecked:null!=t.checked?t.checked:t.defaultChecked,initialValue:null!=t.value?t.value:n,listeners:null,onChange:i.bind(e),controlled:o(t)}},updateWrapper:function(e){var t=e._currentElement.props,n=t.checked;null!=n&&u.setValueForProperty(c.getNodeFromInstance(e),"checked",n||!1);var r=c.getNodeFromInstance(e),o=l.getValue(t);if(null!=o)if(0===o&&""===r.value)r.value="0";else if("number"===t.type){var i=parseFloat(r.value,10)||0;o!=i&&(r.value=""+o)}else o!=r.value&&(r.value=""+o);else null==t.value&&null!=t.defaultValue&&r.defaultValue!==""+t.defaultValue&&(r.defaultValue=""+t.defaultValue),null==t.checked&&null!=t.defaultChecked&&(r.defaultChecked=!!t.defaultChecked)},postMountWrapper:function(e){var t=e._currentElement.props,n=c.getNodeFromInstance(e);switch(t.type){case"submit":case"reset":break;case"color":case"date":case"datetime":case"datetime-local":case"month":case"time":case"week":n.value="",n.value=n.defaultValue;break;default:n.value=n.value}var r=n.name;""!==r&&(n.name=""),n.defaultChecked=!n.defaultChecked,n.defaultChecked=!n.defaultChecked,""!==r&&(n.name=r)}});e.exports=d},function(e,t,n){"use strict";function r(e){var t="";return i.Children.forEach(e,function(e){null!=e&&("string"==typeof e||"number"==typeof e?t+=e:u||(u=!0))}),t}var o=n(13),i=n(89),a=n(16),s=n(273),u=(n(5),!1);e.exports={mountWrapper:function(e,t,n){var o=null;if(null!=n){var i=n;"optgroup"===i._tag&&(i=i._hostParent),null!=i&&"select"===i._tag&&(o=s.getSelectValueContext(i))}var a=null;if(null!=o){var u;if(u=null!=t.value?t.value+"":r(t.children),a=!1,Array.isArray(o)){for(var l=0;l<o.length;l++)if(""+o[l]===u){a=!0;break}}else a=""+o===u}e._wrapperState={selected:a}},postMountWrapper:function(e){var t=e._currentElement.props;if(null!=t.value){a.getNodeFromInstance(e).setAttribute("value",t.value)}},getHostProps:function(e,t){var n=o({selected:void 0,children:void 0},t);null!=e._wrapperState.selected&&(n.selected=e._wrapperState.selected);var i=r(t.children);return i&&(n.children=i),n}}},function(e,t,n){"use strict";function r(e,t,n,r){return e===n&&t===r}function o(e){var t=document.selection,n=t.createRange(),r=n.text.length,o=n.duplicate();o.moveToElementText(e),o.setEndPoint("EndToStart",n);var i=o.text.length;return{start:i,end:i+r}}function i(e){var t=window.getSelection&&window.getSelection();if(!t||0===t.rangeCount)return null;var n=t.anchorNode,o=t.anchorOffset,i=t.focusNode,a=t.focusOffset,s=t.getRangeAt(0);try{}catch(e){return null}var u=r(t.anchorNode,t.anchorOffset,t.focusNode,t.focusOffset),l=u?0:s.toString().length,c=s.cloneRange();c.selectNodeContents(e),c.setEnd(s.startContainer,s.startOffset);var p=r(c.startContainer,c.startOffset,c.endContainer,c.endOffset),d=p?0:c.toString().length,f=d+l,h=document.createRange();h.setStart(n,o),h.setEnd(i,a);var m=h.collapsed;return{start:m?f:d,end:m?d:f}}function a(e,t){var n,r,o=document.selection.createRange().duplicate();void 0===t.end?(n=t.start,r=n):t.start>t.end?(n=t.end,r=t.start):(n=t.start,r=t.end),o.moveToElementText(e),o.moveStart("character",n),o.setEndPoint("EndToStart",o),o.moveEnd("character",r-n),o.select()}function s(e,t){if(window.getSelection){var n=window.getSelection(),r=e[c()].length,o=Math.min(t.start,r),i=void 0===t.end?o:Math.min(t.end,r);if(!n.extend&&o>i){var a=i;i=o,o=a}var s=l(e,o),u=l(e,i);if(s&&u){var p=document.createRange();p.setStart(s.node,s.offset),n.removeAllRanges(),o>i?(n.addRange(p),n.extend(u.node,u.offset)):(p.setEnd(u.node,u.offset),n.addRange(p))}}}var u=n(23),l=n(709),c=n(284),p=u.canUseDOM&&"selection"in document&&!("getSelection"in window);e.exports={getOffsets:p?o:i,setOffsets:p?a:s}},function(e,t,n){"use strict";var r=n(7),o=n(13),i=n(171),a=n(86),s=n(16),u=n(127),l=(n(1),n(186),function(e){this._currentElement=e,this._stringText=""+e,this._hostNode=null,this._hostParent=null,this._domID=0,this._mountIndex=0,this._closingComment=null,this._commentNodes=null});o(l.prototype,{mountComponent:function(e,t,n,r){var o=n._idCounter++,i=" react-text: "+o+" ";if(this._domID=o,this._hostParent=t,e.useCreateElement){var l=n._ownerDocument,c=l.createComment(i),p=l.createComment(" /react-text "),d=a(l.createDocumentFragment());return a.queueChild(d,a(c)),this._stringText&&a.queueChild(d,a(l.createTextNode(this._stringText))),a.queueChild(d,a(p)),s.precacheNode(this,c),this._closingComment=p,d}var f=u(this._stringText);return e.renderToStaticMarkup?f:"<!--"+i+"-->"+f+"<!-- /react-text -->"},receiveComponent:function(e,t){if(e!==this._currentElement){this._currentElement=e;var n=""+e;if(n!==this._stringText){this._stringText=n;var r=this.getHostNode();i.replaceDelimitedText(r[0],r[1],n)}}},getHostNode:function(){var e=this._commentNodes;if(e)return e;if(!this._closingComment)for(var t=s.getNodeFromInstance(this),n=t.nextSibling;;){if(null==n&&r("67",this._domID),8===n.nodeType&&" /react-text "===n.nodeValue){this._closingComment=n;break}n=n.nextSibling}return e=[this._hostNode,this._closingComment],this._commentNodes=e,e},unmountComponent:function(){this._closingComment=null,this._commentNodes=null,s.uncacheNode(this)}}),e.exports=l},function(e,t,n){"use strict";function r(){this._rootNodeID&&c.updateWrapper(this)}function o(e){var t=this._currentElement.props,n=s.executeOnChange(t,e);return l.asap(r,this),n}var i=n(7),a=n(13),s=n(176),u=n(16),l=n(45),c=(n(1),n(5),{getHostProps:function(e,t){return null!=t.dangerouslySetInnerHTML&&i("91"),a({},t,{value:void 0,defaultValue:void 0,children:""+e._wrapperState.initialValue,onChange:e._wrapperState.onChange})},mountWrapper:function(e,t){var n=s.getValue(t),r=n;if(null==n){var a=t.defaultValue,u=t.children;null!=u&&(null!=a&&i("92"),Array.isArray(u)&&(u.length<=1||i("93"),u=u[0]),a=""+u),null==a&&(a=""),r=a}e._wrapperState={initialValue:""+r,listeners:null,onChange:o.bind(e)}},updateWrapper:function(e){var t=e._currentElement.props,n=u.getNodeFromInstance(e),r=s.getValue(t);if(null!=r){var o=""+r;o!==n.value&&(n.value=o),null==t.defaultValue&&(n.defaultValue=o)}null!=t.defaultValue&&(n.defaultValue=t.defaultValue)},postMountWrapper:function(e){var t=u.getNodeFromInstance(e),n=t.textContent;n===e._wrapperState.initialValue&&(t.value=n)}});e.exports=c},function(e,t,n){"use strict";function r(e,t){"_hostNode"in e||u("33"),"_hostNode"in t||u("33");for(var n=0,r=e;r;r=r._hostParent)n++;for(var o=0,i=t;i;i=i._hostParent)o++;for(;n-o>0;)e=e._hostParent,n--;for(;o-n>0;)t=t._hostParent,o--;for(var a=n;a--;){if(e===t)return e;e=e._hostParent,t=t._hostParent}return null}function o(e,t){"_hostNode"in e||u("35"),"_hostNode"in t||u("35");for(;t;){if(t===e)return!0;t=t._hostParent}return!1}function i(e){return"_hostNode"in e||u("36"),e._hostParent}function a(e,t,n){for(var r=[];e;)r.push(e),e=e._hostParent;var o;for(o=r.length;o-- >0;)t(r[o],"captured",n);for(o=0;o<r.length;o++)t(r[o],"bubbled",n)}function s(e,t,n,o,i){for(var a=e&&t?r(e,t):null,s=[];e&&e!==a;)s.push(e),e=e._hostParent;for(var u=[];t&&t!==a;)u.push(t),t=t._hostParent;var l;for(l=0;l<s.length;l++)n(s[l],"bubbled",o);for(l=u.length;l-- >0;)n(u[l],"captured",i)}var u=n(7);n(1);e.exports={isAncestor:o,getLowestCommonAncestor:r,getParentInstance:i,traverseTwoPhase:a,traverseEnterLeave:s}},function(e,t,n){"use strict";function r(){this.reinitializeTransaction()}var o=n(13),i=n(45),a=n(126),s=n(32),u={initialize:s,close:function(){d.isBatchingUpdates=!1}},l={initialize:s,close:i.flushBatchedUpdates.bind(i)},c=[l,u];o(r.prototype,a,{getTransactionWrappers:function(){return c}});var p=new r,d={isBatchingUpdates:!1,batchedUpdates:function(e,t,n,r,o,i){var a=d.isBatchingUpdates;return d.isBatchingUpdates=!0,a?e(t,n,r,o,i):p.perform(e,null,t,n,r,o,i)}};e.exports=d},function(e,t,n){"use strict";function r(){S||(S=!0,b.EventEmitter.injectReactEventListener(v),b.EventPluginHub.injectEventPluginOrder(s),b.EventPluginUtils.injectComponentTree(d),b.EventPluginUtils.injectTreeTraversal(h),b.EventPluginHub.injectEventPluginsByName({SimpleEventPlugin:w,EnterLeaveEventPlugin:u,ChangeEventPlugin:a,SelectEventPlugin:E,BeforeInputEventPlugin:i}),b.HostComponent.injectGenericComponentClass(p),b.HostComponent.injectTextComponentClass(m),b.DOMProperty.injectDOMPropertyConfig(o),b.DOMProperty.injectDOMPropertyConfig(l),b.DOMProperty.injectDOMPropertyConfig(_),b.EmptyComponent.injectEmptyComponentFactory(function(e){return new f(e)}),b.Updates.injectReconcileTransaction(y),b.Updates.injectBatchingStrategy(g),b.Component.injectEnvironment(c))}var o=n(650),i=n(652),a=n(654),s=n(656),u=n(657),l=n(659),c=n(661),p=n(664),d=n(16),f=n(666),h=n(674),m=n(672),g=n(675),v=n(679),b=n(680),y=n(685),_=n(690),E=n(691),w=n(692),S=!1;e.exports={inject:r}},function(e,t,n){"use strict";e.exports="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103},function(e,t,n){"use strict";function r(e){o.enqueueEvents(e),o.processEventQueue(!1)}var o=n(103);e.exports={handleTopLevel:function(e,t,n,i){r(o.extractEvents(e,t,n,i))}}},function(e,t,n){"use strict";function r(e){for(;e._hostParent;)e=e._hostParent;var t=p.getNodeFromInstance(e);return p.getClosestInstanceFromNode(t.parentNode)}function o(e,t){this.topLevelType=e,this.nativeEvent=t,this.ancestors=[]}function i(e){var t=f(e.nativeEvent),n=p.getClosestInstanceFromNode(t),o=n;do{e.ancestors.push(o),o=o&&r(o)}while(o);for(var i=0;i<e.ancestors.length;i++)n=e.ancestors[i],m._handleTopLevel(e.topLevelType,n,e.nativeEvent,f(e.nativeEvent))}function a(e){e(h(window))}var s=n(13),u=n(259),l=n(23),c=n(73),p=n(16),d=n(45),f=n(183),h=n(598);s(o.prototype,{destructor:function(){this.topLevelType=null,this.nativeEvent=null,this.ancestors.length=0}}),c.addPoolingTo(o,c.twoArgumentPooler);var m={_enabled:!0,_handleTopLevel:null,WINDOW_HANDLE:l.canUseDOM?window:null,setHandleTopLevel:function(e){m._handleTopLevel=e},setEnabled:function(e){m._enabled=!!e},isEnabled:function(){return m._enabled},trapBubbledEvent:function(e,t,n){return n?u.listen(n,t,m.dispatchEvent.bind(null,e)):null},trapCapturedEvent:function(e,t,n){return n?u.capture(n,t,m.dispatchEvent.bind(null,e)):null},monitorScrollValue:function(e){var t=a.bind(null,e);u.listen(window,"scroll",t)},dispatchEvent:function(e,t){if(m._enabled){var n=o.getPooled(e,t);try{d.batchedUpdates(i,n)}finally{o.release(n)}}}};e.exports=m},function(e,t,n){"use strict";var r=n(87),o=n(103),i=n(174);e.exports={Component:n(177).injection,DOMProperty:r.injection,EmptyComponent:n(274).injection,EventPluginHub:o.injection,EventPluginUtils:i.injection,EventEmitter:n(124).injection,HostComponent:n(276).injection,Updates:n(45).injection}},function(e,t,n){"use strict";var r=n(703),o=/^<\!\-\-/,i={CHECKSUM_ATTR_NAME:"data-react-checksum",addChecksumToMarkup:function(e){var t=r(e);return o.test(e)?e:e.replace(/\/?>/," "+i.CHECKSUM_ATTR_NAME+'="'+t+'"$&')},canReuseMarkup:function(e,t){var n=t.getAttribute(i.CHECKSUM_ATTR_NAME);return n=n&&parseInt(n,10),r(e)===n}};e.exports=i},function(e,t,n){"use strict";function r(e,t,n){return{type:"INSERT_MARKUP",content:e,fromIndex:null,fromNode:null,toIndex:n,afterNode:t}}function o(e,t,n){return{type:"MOVE_EXISTING",content:null,fromIndex:e._mountIndex,fromNode:d.getHostNode(e),toIndex:n,afterNode:t}}function i(e,t){return{type:"REMOVE_NODE",content:null,fromIndex:e._mountIndex,fromNode:t,toIndex:null,afterNode:null}}function a(e){return{type:"SET_MARKUP",content:e,fromIndex:null,fromNode:null,toIndex:null,afterNode:null}}function s(e){return{type:"TEXT_CONTENT",content:e,fromIndex:null,fromNode:null,toIndex:null,afterNode:null}}function u(e,t){return t&&(e=e||[],e.push(t)),e}function l(e,t){p.processChildrenUpdates(e,t)}var c=n(7),p=n(177),d=(n(105),n(39),n(56),n(88)),f=n(660),h=(n(32),n(706));n(1);e.exports={Mixin:{_reconcilerInstantiateChildren:function(e,t,n){return f.instantiateChildren(e,t,n)},_reconcilerUpdateChildren:function(e,t,n,r,o,i){var a,s=0;return a=h(t,s),f.updateChildren(e,a,n,r,o,this,this._hostContainerInfo,i,s),a},mountChildren:function(e,t,n){var r=this._reconcilerInstantiateChildren(e,t,n);this._renderedChildren=r;var o=[],i=0;for(var a in r)if(r.hasOwnProperty(a)){var s=r[a],u=0,l=d.mountComponent(s,t,this,this._hostContainerInfo,n,u);s._mountIndex=i++,o.push(l)}return o},updateTextContent:function(e){var t=this._renderedChildren;f.unmountChildren(t,!1);for(var n in t)t.hasOwnProperty(n)&&c("118");l(this,[s(e)])},updateMarkup:function(e){var t=this._renderedChildren;f.unmountChildren(t,!1);for(var n in t)t.hasOwnProperty(n)&&c("118");l(this,[a(e)])},updateChildren:function(e,t,n){this._updateChildren(e,t,n)},_updateChildren:function(e,t,n){var r=this._renderedChildren,o={},i=[],a=this._reconcilerUpdateChildren(r,e,i,o,t,n);if(a||r){var s,c=null,p=0,f=0,h=0,m=null;for(s in a)if(a.hasOwnProperty(s)){var g=r&&r[s],v=a[s];g===v?(c=u(c,this.moveChild(g,m,p,f)),f=Math.max(g._mountIndex,f),g._mountIndex=p):(g&&(f=Math.max(g._mountIndex,f)),c=u(c,this._mountChildAtIndex(v,i[h],m,p,t,n)),h++),p++,m=d.getHostNode(v)}for(s in o)o.hasOwnProperty(s)&&(c=u(c,this._unmountChild(r[s],o[s])));c&&l(this,c),this._renderedChildren=a}},unmountChildren:function(e){f.unmountChildren(this._renderedChildren,e),this._renderedChildren=null},moveChild:function(e,t,n,r){if(e._mountIndex<r)return o(e,t,n)},createChild:function(e,t,n){return r(n,t,e._mountIndex)},removeChild:function(e,t){return i(e,t)},_mountChildAtIndex:function(e,t,n,r,o,i){return e._mountIndex=r,this.createChild(e,n,t)},_unmountChild:function(e,t){var n=this.removeChild(e,t);return e._mountIndex=null,n}}}},function(e,t,n){"use strict";function r(e){return!(!e||"function"!=typeof e.attachRef||"function"!=typeof e.detachRef)}var o=n(7);n(1);e.exports={addComponentAsRefTo:function(e,t,n){r(n)||o("119"),n.attachRef(t,e)},removeComponentAsRefFrom:function(e,t,n){r(n)||o("120");var i=n.getPublicInstance();i&&i.refs[t]===e.getPublicInstance()&&n.detachRef(t)}}},function(e,t,n){"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},function(e,t,n){"use strict";function r(e){this.reinitializeTransaction(),this.renderToStaticMarkup=!1,this.reactMountReady=i.getPooled(null),this.useCreateElement=e}var o=n(13),i=n(270),a=n(73),s=n(124),u=n(277),l=(n(39),n(126)),c=n(179),p={initialize:u.getSelectionInformation,close:u.restoreSelection},d={initialize:function(){var e=s.isEnabled();return s.setEnabled(!1),e},close:function(e){s.setEnabled(e)}},f={initialize:function(){this.reactMountReady.reset()},close:function(){this.reactMountReady.notifyAll()}},h=[p,d,f];o(r.prototype,l,{getTransactionWrappers:function(){return h},getReactMountReady:function(){return this.reactMountReady},getUpdateQueue:function(){return c},checkpoint:function(){return this.reactMountReady.checkpoint()},rollback:function(e){this.reactMountReady.rollback(e)},destructor:function(){i.release(this.reactMountReady),this.reactMountReady=null}}),a.addPoolingTo(r),e.exports=r},function(e,t,n){"use strict";function r(e,t,n){"function"==typeof e?e(t.getPublicInstance()):i.addComponentAsRefTo(t,e,n)}function o(e,t,n){"function"==typeof e?e(null):i.removeComponentAsRefFrom(t,e,n)}var i=n(683),a={};a.attachRefs=function(e,t){if(null!==t&&"object"==typeof t){var n=t.ref;null!=n&&r(n,e,t._owner)}},a.shouldUpdateRefs=function(e,t){var n=null,r=null;null!==e&&"object"==typeof e&&(n=e.ref,r=e._owner);var o=null,i=null;return null!==t&&"object"==typeof t&&(o=t.ref,i=t._owner),n!==o||"string"==typeof o&&i!==r},a.detachRefs=function(e,t){if(null!==t&&"object"==typeof t){var n=t.ref;null!=n&&o(n,e,t._owner)}},e.exports=a},function(e,t,n){"use strict";function r(e){this.reinitializeTransaction(),this.renderToStaticMarkup=e,this.useCreateElement=!1,this.updateQueue=new s(this)}var o=n(13),i=n(73),a=n(126),s=(n(39),n(688)),u=[],l={enqueue:function(){}};o(r.prototype,a,{getTransactionWrappers:function(){return u},getReactMountReady:function(){return l},getUpdateQueue:function(){return this.updateQueue},destructor:function(){},checkpoint:function(){},rollback:function(){}}),i.addPoolingTo(r),e.exports=r},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var o=n(179);n(5);e.exports=function(){function e(t){r(this,e),this.transaction=t}return e.prototype.isMounted=function(e){return!1},e.prototype.enqueueCallback=function(e,t,n){this.transaction.isInTransaction()&&o.enqueueCallback(e,t,n)},e.prototype.enqueueForceUpdate=function(e){this.transaction.isInTransaction()&&o.enqueueForceUpdate(e)},e.prototype.enqueueReplaceState=function(e,t){this.transaction.isInTransaction()&&o.enqueueReplaceState(e,t)},e.prototype.enqueueSetState=function(e,t){this.transaction.isInTransaction()&&o.enqueueSetState(e,t)},e}()},function(e,t,n){"use strict";e.exports="15.5.4"},function(e,t,n){"use strict";var r={xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace"},o={accentHeight:"accent-height",accumulate:0,additive:0,alignmentBaseline:"alignment-baseline",allowReorder:"allowReorder",alphabetic:0,amplitude:0,arabicForm:"arabic-form",ascent:0,attributeName:"attributeName",attributeType:"attributeType",autoReverse:"autoReverse",azimuth:0,baseFrequency:"baseFrequency",baseProfile:"baseProfile",baselineShift:"baseline-shift",bbox:0,begin:0,bias:0,by:0,calcMode:"calcMode",capHeight:"cap-height",clip:0,clipPath:"clip-path",clipRule:"clip-rule",clipPathUnits:"clipPathUnits",colorInterpolation:"color-interpolation",colorInterpolationFilters:"color-interpolation-filters",colorProfile:"color-profile",colorRendering:"color-rendering",contentScriptType:"contentScriptType",contentStyleType:"contentStyleType",cursor:0,cx:0,cy:0,d:0,decelerate:0,descent:0,diffuseConstant:"diffuseConstant",direction:0,display:0,divisor:0,dominantBaseline:"dominant-baseline",dur:0,dx:0,dy:0,edgeMode:"edgeMode",elevation:0,enableBackground:"enable-background",end:0,exponent:0,externalResourcesRequired:"externalResourcesRequired",fill:0,fillOpacity:"fill-opacity",fillRule:"fill-rule",filter:0,filterRes:"filterRes",filterUnits:"filterUnits",floodColor:"flood-color",floodOpacity:"flood-opacity",focusable:0,fontFamily:"font-family",fontSize:"font-size",fontSizeAdjust:"font-size-adjust",fontStretch:"font-stretch",fontStyle:"font-style",fontVariant:"font-variant",fontWeight:"font-weight",format:0,from:0,fx:0,fy:0,g1:0,g2:0,glyphName:"glyph-name",glyphOrientationHorizontal:"glyph-orientation-horizontal",glyphOrientationVertical:"glyph-orientation-vertical",glyphRef:"glyphRef",gradientTransform:"gradientTransform",gradientUnits:"gradientUnits",hanging:0,horizAdvX:"horiz-adv-x",horizOriginX:"horiz-origin-x",ideographic:0,imageRendering:"image-rendering",in:0,in2:0,intercept:0,k:0,k1:0,k2:0,k3:0,k4:0,kernelMatrix:"kernelMatrix",kernelUnitLength:"kernelUnitLength",kerning:0,keyPoints:"keyPoints",keySplines:"keySplines",keyTimes:"keyTimes",lengthAdjust:"lengthAdjust",letterSpacing:"letter-spacing",lightingColor:"lighting-color",limitingConeAngle:"limitingConeAngle",local:0,markerEnd:"marker-end",markerMid:"marker-mid",markerStart:"marker-start",markerHeight:"markerHeight",markerUnits:"markerUnits",markerWidth:"markerWidth",mask:0,maskContentUnits:"maskContentUnits",maskUnits:"maskUnits",mathematical:0,mode:0,numOctaves:"numOctaves",offset:0,opacity:0,operator:0,order:0,orient:0,orientation:0,origin:0,overflow:0,overlinePosition:"overline-position",overlineThickness:"overline-thickness",paintOrder:"paint-order",panose1:"panose-1",pathLength:"pathLength",patternContentUnits:"patternContentUnits",patternTransform:"patternTransform",patternUnits:"patternUnits",pointerEvents:"pointer-events",points:0,pointsAtX:"pointsAtX",pointsAtY:"pointsAtY",pointsAtZ:"pointsAtZ",preserveAlpha:"preserveAlpha",preserveAspectRatio:"preserveAspectRatio",primitiveUnits:"primitiveUnits",r:0,radius:0,refX:"refX",refY:"refY",renderingIntent:"rendering-intent",repeatCount:"repeatCount",repeatDur:"repeatDur",requiredExtensions:"requiredExtensions",requiredFeatures:"requiredFeatures",restart:0,result:0,rotate:0,rx:0,ry:0,scale:0,seed:0,shapeRendering:"shape-rendering",slope:0,spacing:0,specularConstant:"specularConstant",specularExponent:"specularExponent",speed:0,spreadMethod:"spreadMethod",startOffset:"startOffset",stdDeviation:"stdDeviation",stemh:0,stemv:0,stitchTiles:"stitchTiles",stopColor:"stop-color",stopOpacity:"stop-opacity",strikethroughPosition:"strikethrough-position",strikethroughThickness:"strikethrough-thickness",string:0,stroke:0,strokeDasharray:"stroke-dasharray",strokeDashoffset:"stroke-dashoffset",strokeLinecap:"stroke-linecap",strokeLinejoin:"stroke-linejoin",strokeMiterlimit:"stroke-miterlimit",strokeOpacity:"stroke-opacity",strokeWidth:"stroke-width",surfaceScale:"surfaceScale",systemLanguage:"systemLanguage",tableValues:"tableValues",targetX:"targetX",targetY:"targetY",textAnchor:"text-anchor",textDecoration:"text-decoration",textRendering:"text-rendering",textLength:"textLength",to:0,transform:0,u1:0,u2:0,underlinePosition:"underline-position",underlineThickness:"underline-thickness",unicode:0,unicodeBidi:"unicode-bidi",unicodeRange:"unicode-range",unitsPerEm:"units-per-em",vAlphabetic:"v-alphabetic",vHanging:"v-hanging",vIdeographic:"v-ideographic",vMathematical:"v-mathematical",values:0,vectorEffect:"vector-effect",version:0,vertAdvY:"vert-adv-y",vertOriginX:"vert-origin-x",vertOriginY:"vert-origin-y",viewBox:"viewBox",viewTarget:"viewTarget",visibility:0,widths:0,wordSpacing:"word-spacing",writingMode:"writing-mode",x:0,xHeight:"x-height",x1:0,x2:0,xChannelSelector:"xChannelSelector",xlinkActuate:"xlink:actuate",xlinkArcrole:"xlink:arcrole",xlinkHref:"xlink:href",xlinkRole:"xlink:role",xlinkShow:"xlink:show",xlinkTitle:"xlink:title",xlinkType:"xlink:type",xmlBase:"xml:base",xmlns:0,xmlnsXlink:"xmlns:xlink",xmlLang:"xml:lang",xmlSpace:"xml:space",y:0,y1:0,y2:0,yChannelSelector:"yChannelSelector",z:0,zoomAndPan:"zoomAndPan"},i={Properties:{},DOMAttributeNamespaces:{xlinkActuate:r.xlink,xlinkArcrole:r.xlink,xlinkHref:r.xlink,xlinkRole:r.xlink,xlinkShow:r.xlink,xlinkTitle:r.xlink,xlinkType:r.xlink,xmlBase:r.xml,xmlLang:r.xml,xmlSpace:r.xml},DOMAttributeNames:{}};Object.keys(o).forEach(function(e){i.Properties[e]=0,o[e]&&(i.DOMAttributeNames[e]=o[e])}),e.exports=i},function(e,t,n){"use strict";function r(e){if("selectionStart"in e&&u.hasSelectionCapabilities(e))return{start:e.selectionStart,end:e.selectionEnd};if(window.getSelection){var t=window.getSelection();return{anchorNode:t.anchorNode,anchorOffset:t.anchorOffset,focusNode:t.focusNode,focusOffset:t.focusOffset}}if(document.selection){var n=document.selection.createRange();return{parentElement:n.parentElement(),text:n.text,top:n.boundingTop,left:n.boundingLeft}}}function o(e,t){if(b||null==m||m!==c())return null;var n=r(m);if(!v||!d(v,n)){v=n;var o=l.getPooled(h.select,g,e,t);return o.type="select",o.target=m,i.accumulateTwoPhaseDispatches(o),o}return null}var i=n(104),a=n(23),s=n(16),u=n(277),l=n(54),c=n(261),p=n(286),d=n(167),f=a.canUseDOM&&"documentMode"in document&&document.documentMode<=11,h={select:{phasedRegistrationNames:{bubbled:"onSelect",captured:"onSelectCapture"},dependencies:["topBlur","topContextMenu","topFocus","topKeyDown","topKeyUp","topMouseDown","topMouseUp","topSelectionChange"]}},m=null,g=null,v=null,b=!1,y=!1;e.exports={eventTypes:h,extractEvents:function(e,t,n,r){if(!y)return null;var i=t?s.getNodeFromInstance(t):window;switch(e){case"topFocus":(p(i)||"true"===i.contentEditable)&&(m=i,g=t,v=null);break;case"topBlur":m=null,g=null,v=null;break;case"topMouseDown":b=!0;break;case"topContextMenu":case"topMouseUp":return b=!1,o(n,r);case"topSelectionChange":if(f)break;case"topKeyDown":case"topKeyUp":return o(n,r)}return null},didPutListener:function(e,t,n){"onSelect"===t&&(y=!0)}}},function(e,t,n){"use strict";function r(e){return"."+e._rootNodeID}function o(e){return"button"===e||"input"===e||"select"===e||"textarea"===e}var i=n(7),a=n(259),s=n(104),u=n(16),l=n(693),c=n(694),p=n(54),d=n(697),f=n(699),h=n(125),m=n(696),g=n(700),v=n(701),b=n(106),y=n(702),_=n(32),E=n(181),w=(n(1),{}),S={};["abort","animationEnd","animationIteration","animationStart","blur","canPlay","canPlayThrough","click","contextMenu","copy","cut","doubleClick","drag","dragEnd","dragEnter","dragExit","dragLeave","dragOver","dragStart","drop","durationChange","emptied","encrypted","ended","error","focus","input","invalid","keyDown","keyPress","keyUp","load","loadedData","loadedMetadata","loadStart","mouseDown","mouseMove","mouseOut","mouseOver","mouseUp","paste","pause","play","playing","progress","rateChange","reset","scroll","seeked","seeking","stalled","submit","suspend","timeUpdate","touchCancel","touchEnd","touchMove","touchStart","transitionEnd","volumeChange","waiting","wheel"].forEach(function(e){var t=e[0].toUpperCase()+e.slice(1),n="on"+t,r="top"+t,o={phasedRegistrationNames:{bubbled:n,captured:n+"Capture"},dependencies:[r]};w[e]=o,S[r]=o});var x={};e.exports={eventTypes:w,extractEvents:function(e,t,n,r){var o=S[e];if(!o)return null;var a;switch(e){case"topAbort":case"topCanPlay":case"topCanPlayThrough":case"topDurationChange":case"topEmptied":case"topEncrypted":case"topEnded":case"topError":case"topInput":case"topInvalid":case"topLoad":case"topLoadedData":case"topLoadedMetadata":case"topLoadStart":case"topPause":case"topPlay":case"topPlaying":case"topProgress":case"topRateChange":case"topReset":case"topSeeked":case"topSeeking":case"topStalled":case"topSubmit":case"topSuspend":case"topTimeUpdate":case"topVolumeChange":case"topWaiting":a=p;break;case"topKeyPress":if(0===E(n))return null;case"topKeyDown":case"topKeyUp":a=f;break;case"topBlur":case"topFocus":a=d;break;case"topClick":if(2===n.button)return null;case"topDoubleClick":case"topMouseDown":case"topMouseMove":case"topMouseUp":case"topMouseOut":case"topMouseOver":case"topContextMenu":a=h;break;case"topDrag":case"topDragEnd":case"topDragEnter":case"topDragExit":case"topDragLeave":case"topDragOver":case"topDragStart":case"topDrop":a=m;break;case"topTouchCancel":case"topTouchEnd":case"topTouchMove":case"topTouchStart":a=g;break;case"topAnimationEnd":case"topAnimationIteration":case"topAnimationStart":a=l;break;case"topTransitionEnd":a=v;break;case"topScroll":a=b;break;case"topWheel":a=y;break;case"topCopy":case"topCut":case"topPaste":a=c}a||i("86",e);var u=a.getPooled(o,t,n,r);return s.accumulateTwoPhaseDispatches(u),u},didPutListener:function(e,t,n){if("onClick"===t&&!o(e._tag)){var i=r(e),s=u.getNodeFromInstance(e);x[i]||(x[i]=a.listen(s,"click",_))}},willDeleteListener:function(e,t){if("onClick"===t&&!o(e._tag)){var n=r(e);x[n].remove(),delete x[n]}}}},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(54);o.augmentClass(r,{animationName:null,elapsedTime:null,pseudoElement:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(54);o.augmentClass(r,{clipboardData:function(e){return"clipboardData"in e?e.clipboardData:window.clipboardData}}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(54);o.augmentClass(r,{data:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(125);o.augmentClass(r,{dataTransfer:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(106);o.augmentClass(r,{relatedTarget:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(54);o.augmentClass(r,{data:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(106),i=n(181),a=n(707),s=n(182);o.augmentClass(r,{key:a,location:null,ctrlKey:null,shiftKey:null,altKey:null,metaKey:null,repeat:null,locale:null,getModifierState:s,charCode:function(e){return"keypress"===e.type?i(e):0},keyCode:function(e){return"keydown"===e.type||"keyup"===e.type?e.keyCode:0},which:function(e){return"keypress"===e.type?i(e):"keydown"===e.type||"keyup"===e.type?e.keyCode:0}}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(106),i=n(182);o.augmentClass(r,{touches:null,targetTouches:null,changedTouches:null,altKey:null,metaKey:null,ctrlKey:null,shiftKey:null,getModifierState:i}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(54);o.augmentClass(r,{propertyName:null,elapsedTime:null,pseudoElement:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return o.call(this,e,t,n,r)}var o=n(125);o.augmentClass(r,{deltaX:function(e){return"deltaX"in e?e.deltaX:"wheelDeltaX"in e?-e.wheelDeltaX:0},deltaY:function(e){return"deltaY"in e?e.deltaY:"wheelDeltaY"in e?-e.wheelDeltaY:"wheelDelta"in e?-e.wheelDelta:0},deltaZ:null,deltaMode:null}),e.exports=r},function(e,t,n){"use strict";function r(e){for(var t=1,n=0,r=0,i=e.length,a=i&-4;r<a;){for(var s=Math.min(r+4096,a);r<s;r+=4)n+=(t+=e.charCodeAt(r))+(t+=e.charCodeAt(r+1))+(t+=e.charCodeAt(r+2))+(t+=e.charCodeAt(r+3));t%=o,n%=o}for(;r<i;r++)n+=t+=e.charCodeAt(r);return t%=o,n%=o,t|n<<16}var o=65521;e.exports=r},function(e,t,n){"use strict";function r(e,t,n){if(null==t||"boolean"==typeof t||""===t)return"";if(isNaN(t)||0===t||i.hasOwnProperty(e)&&i[e])return""+t;if("string"==typeof t){t=t.trim()}return t+"px"}var o=n(269),i=(n(5),o.isUnitlessNumber);e.exports=r},function(e,t,n){"use strict";function r(e){if(null==e)return null;if(1===e.nodeType)return e;var t=a.get(e);if(t)return t=s(t),t?i.getNodeFromInstance(t):null;"function"==typeof e.render?o("44"):o("45",Object.keys(e))}var o=n(7),i=(n(56),n(16)),a=n(105),s=n(283);n(1),n(5);e.exports=r},function(e,t,n){"use strict";(function(t){function r(e,t,n,r){if(e&&"object"==typeof e){var o=e,i=void 0===o[n];i&&null!=t&&(o[n]=t)}}function o(e,t){if(null==e)return e;var n={};return i(e,r,n),n}var i=(n(175),n(288));n(5);void 0!==t&&n.i({NODE_ENV:"production"}),e.exports=o}).call(t,n(107))},function(e,t,n){"use strict";function r(e){if(e.key){var t=i[e.key]||e.key;if("Unidentified"!==t)return t}if("keypress"===e.type){var n=o(e);return 13===n?"Enter":String.fromCharCode(n)}return"keydown"===e.type||"keyup"===e.type?a[e.keyCode]||"Unidentified":""}var o=n(181),i={Esc:"Escape",Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},a={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"};e.exports=r},function(e,t,n){"use strict";function r(e){var t=e&&(o&&e[o]||e[i]);if("function"==typeof t)return t}var o="function"==typeof Symbol&&Symbol.iterator,i="@@iterator";e.exports=r},function(e,t,n){"use strict";function r(e){for(;e&&e.firstChild;)e=e.firstChild;return e}function o(e){for(;e;){if(e.nextSibling)return e.nextSibling;e=e.parentNode}}function i(e,t){for(var n=r(e),i=0,a=0;n;){if(3===n.nodeType){if(a=i+n.textContent.length,i<=t&&a>=t)return{node:n,offset:t-i};i=a}n=r(o(n))}}e.exports=i},function(e,t,n){"use strict";function r(e,t){var n={};return n[e.toLowerCase()]=t.toLowerCase(),n["Webkit"+e]="webkit"+t,n["Moz"+e]="moz"+t,n["ms"+e]="MS"+t,n["O"+e]="o"+t.toLowerCase(),n}function o(e){if(s[e])return s[e];if(!a[e])return e;var t=a[e];for(var n in t)if(t.hasOwnProperty(n)&&n in u)return s[e]=t[n];return""}var i=n(23),a={animationend:r("Animation","AnimationEnd"),animationiteration:r("Animation","AnimationIteration"),animationstart:r("Animation","AnimationStart"),transitionend:r("Transition","TransitionEnd")},s={},u={};i.canUseDOM&&(u=document.createElement("div").style,"AnimationEvent"in window||(delete a.animationend.animation,delete a.animationiteration.animation,delete a.animationstart.animation),"TransitionEvent"in window||delete a.transitionend.transition),e.exports=o},function(e,t,n){"use strict";function r(e){return'"'+o(e)+'"'}var o=n(127);e.exports=r},function(e,t,n){"use strict";e.exports=n(278).renderSubtreeIntoContainer},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function o(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function i(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}n.d(t,"a",function(){return c});var a=n(2),s=(n.n(a),n(10)),u=n.n(s),l=n(291),c=(n(187),function(e){function t(n,i){r(this,t);var a=o(this,e.call(this,n,i));return a.store=n.store,a}return i(t,e),t.prototype.getChildContext=function(){return{store:this.store,storeSubscription:null}},t.prototype.render=function(){return a.Children.only(this.props.children)},t}(a.Component));c.propTypes={store:l.a.isRequired,children:u.a.element.isRequired},c.childContextTypes={store:l.a.isRequired,storeSubscription:l.b},c.displayName="Provider"},function(e,t,n){"use strict";function r(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}function o(e,t,n){for(var r=t.length-1;r>=0;r--){var o=t[r](e);if(o)return o}return function(t,r){throw new Error("Invalid value of type "+typeof e+" for "+n+" argument when connecting component "+r.wrappedComponentName+".")}}function i(e,t){return e===t}var a=n(289),s=n(721),u=n(715),l=n(716),c=n(717),p=n(718),d=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e};t.a=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=e.connectHOC,n=void 0===t?a.a:t,f=e.mapStateToPropsFactories,h=void 0===f?l.a:f,m=e.mapDispatchToPropsFactories,g=void 0===m?u.a:m,v=e.mergePropsFactories,b=void 0===v?c.a:v,y=e.selectorFactory,_=void 0===y?p.a:y;return function(e,t,a){var u=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},l=u.pure,c=void 0===l||l,p=u.areStatesEqual,f=void 0===p?i:p,m=u.areOwnPropsEqual,v=void 0===m?s.a:m,y=u.areStatePropsEqual,E=void 0===y?s.a:y,w=u.areMergedPropsEqual,S=void 0===w?s.a:w,x=r(u,["pure","areStatesEqual","areOwnPropsEqual","areStatePropsEqual","areMergedPropsEqual"]),T=o(e,h,"mapStateToProps"),C=o(t,g,"mapDispatchToProps"),I=o(a,b,"mergeProps");return n(_,d({methodName:"connect",getDisplayName:function(e){return"Connect("+e+")"},shouldHandleStateChanges:Boolean(e),initMapStateToProps:T,initMapDispatchToProps:C,initMergeProps:I,pure:c,areStatesEqual:f,areOwnPropsEqual:v,areStatePropsEqual:E,areMergedPropsEqual:S},x))}}()},function(e,t,n){"use strict";function r(e){return"function"==typeof e?n.i(s.a)(e,"mapDispatchToProps"):void 0}function o(e){return e?void 0:n.i(s.b)(function(e){return{dispatch:e}})}function i(e){return e&&"object"==typeof e?n.i(s.b)(function(t){return n.i(a.bindActionCreators)(e,t)}):void 0}var a=n(190),s=n(290);t.a=[r,o,i]},function(e,t,n){"use strict";function r(e){return"function"==typeof e?n.i(i.a)(e,"mapStateToProps"):void 0}function o(e){return e?void 0:n.i(i.b)(function(){return{}})}var i=n(290);t.a=[r,o]},function(e,t,n){"use strict";function r(e,t,n){return s({},n,e,t)}function o(e){return function(t,n){var r=n.pure,o=n.areMergedPropsEqual,i=!1,a=void 0;return function(t,n,s){var u=e(t,n,s);return i?r&&o(u,a)||(a=u):(i=!0,a=u),a}}}function i(e){return"function"==typeof e?o(e):void 0}function a(e){return e?void 0:function(){return r}}var s=(n(292),Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e});t.a=[i,a]},function(e,t,n){"use strict";function r(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}function o(e,t,n,r){return function(o,i){return n(e(o,i),t(r,i),i)}}function i(e,t,n,r,o){function i(o,i){return h=o,m=i,g=e(h,m),v=t(r,m),b=n(g,v,m),f=!0,b}function a(){return g=e(h,m),t.dependsOnOwnProps&&(v=t(r,m)),b=n(g,v,m)}function s(){return e.dependsOnOwnProps&&(g=e(h,m)),t.dependsOnOwnProps&&(v=t(r,m)),b=n(g,v,m)}function u(){var t=e(h,m),r=!d(t,g);return g=t,r&&(b=n(g,v,m)),b}function l(e,t){var n=!p(t,m),r=!c(e,h);return h=e,m=t,n&&r?a():n?s():r?u():b}var c=o.areStatesEqual,p=o.areOwnPropsEqual,d=o.areStatePropsEqual,f=!1,h=void 0,m=void 0,g=void 0,v=void 0,b=void 0;return function(e,t){return f?l(e,t):i(e,t)}}function a(e,t){var n=t.initMapStateToProps,a=t.initMapDispatchToProps,s=t.initMergeProps,u=r(t,["initMapStateToProps","initMapDispatchToProps","initMergeProps"]),l=n(e,u),c=a(e,u),p=s(e,u);return(u.pure?i:o)(l,c,p,e,u)}t.a=a;n(719)},function(e,t,n){"use strict";n(187)},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function o(){var e=[],t=[];return{clear:function(){t=i,e=i},notify:function(){for(var n=e=t,r=0;r<n.length;r++)n[r]()},subscribe:function(n){var r=!0;return t===e&&(t=e.slice()),t.push(n),function(){r&&e!==i&&(r=!1,t===e&&(t=e.slice()),t.splice(t.indexOf(n),1))}}}}n.d(t,"a",function(){return s});var i=null,a={notify:function(){}},s=function(){function e(t,n,o){r(this,e),this.store=t,this.parentSub=n,this.onStateChange=o,this.unsubscribe=null,this.listeners=a}return e.prototype.addNestedSub=function(e){return this.trySubscribe(),this.listeners.subscribe(e)},e.prototype.notifyNestedSubs=function(){this.listeners.notify()},e.prototype.isSubscribed=function(){return Boolean(this.unsubscribe)},e.prototype.trySubscribe=function(){this.unsubscribe||(this.unsubscribe=this.parentSub?this.parentSub.addNestedSub(this.onStateChange):this.store.subscribe(this.onStateChange),this.listeners=o())},e.prototype.tryUnsubscribe=function(){this.unsubscribe&&(this.unsubscribe(),this.unsubscribe=null,this.listeners.clear(),this.listeners=a)},e}()},function(e,t,n){"use strict";function r(e,t){return e===t?0!==e||0!==t||1/e==1/t:e!==e&&t!==t}function o(e,t){if(r(e,t))return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var n=Object.keys(e);if(n.length!==Object.keys(t).length)return!1;for(var o=0;o<n.length;o++)if(!i.call(t,n[o])||!r(e[n[o]],t[n[o]]))return!1;return!0}t.a=o;var i=Object.prototype.hasOwnProperty},function(e,t,n){"use strict";function r(e){var t={"=":"=0",":":"=2"};return"$"+(""+e).replace(/[=:]/g,function(e){return t[e]})}function o(e){var t={"=0":"=","=2":":"};return(""+e.substring("."===e[0]&&"$"===e[1]?2:1)).replace(/(=0|=2)/g,function(e){return t[e]})}e.exports={escape:r,unescape:o}},function(e,t,n){"use strict";var r=n(91),o=(n(1),function(e){var t=this;if(t.instancePool.length){var n=t.instancePool.pop();return t.call(n,e),n}return new t(e)}),i=function(e,t){var n=this;if(n.instancePool.length){var r=n.instancePool.pop();return n.call(r,e,t),r}return new n(e,t)},a=function(e,t,n){var r=this;if(r.instancePool.length){var o=r.instancePool.pop();return r.call(o,e,t,n),o}return new r(e,t,n)},s=function(e,t,n,r){var o=this;if(o.instancePool.length){var i=o.instancePool.pop();return o.call(i,e,t,n,r),i}return new o(e,t,n,r)},u=function(e){var t=this;e instanceof t||r("25"),e.destructor(),t.instancePool.length<t.poolSize&&t.instancePool.push(e)},l=o;e.exports={addPoolingTo:function(e,t){var n=e;return n.instancePool=[],n.getPooled=t||l,n.poolSize||(n.poolSize=10),n.release=u,n},oneArgumentPooler:o,twoArgumentPooler:i,threeArgumentPooler:a,fourArgumentPooler:s}},function(e,t,n){"use strict";function r(e){return(""+e).replace(_,"$&/")}function o(e,t){this.func=e,this.context=t,this.count=0}function i(e,t,n){e.func.call(e.context,t,e.count++)}function a(e,t,n){if(null==e)return e;var r=o.getPooled(t,n);v(e,i,r),o.release(r)}function s(e,t,n,r){this.result=e,this.keyPrefix=t,this.func=n,this.context=r,this.count=0}function u(e,t,n){var o=e.result,i=e.keyPrefix,a=e.func,s=e.context,u=a.call(s,t,e.count++);Array.isArray(u)?l(u,o,n,g.thatReturnsArgument):null!=u&&(m.isValidElement(u)&&(u=m.cloneAndReplaceKey(u,i+(!u.key||t&&t.key===u.key?"":r(u.key)+"/")+n)),o.push(u))}function l(e,t,n,o,i){var a="";null!=n&&(a=r(n)+"/");var l=s.getPooled(t,a,o,i);v(e,u,l),s.release(l)}function c(e,t,n){if(null==e)return e;var r=[];return l(e,r,null,t,n),r}function p(e,t,n){return null}function d(e,t){return v(e,p,null)}function f(e){var t=[];return l(e,t,null,g.thatReturnsArgument),t}var h=n(723),m=n(90),g=n(32),v=n(734),b=h.twoArgumentPooler,y=h.fourArgumentPooler,_=/\/+/g;o.prototype.destructor=function(){this.func=null,this.context=null,this.count=0},h.addPoolingTo(o,b),s.prototype.destructor=function(){this.result=null,this.keyPrefix=null,this.func=null,this.context=null,this.count=0},h.addPoolingTo(s,y),e.exports={forEach:a,map:c,mapIntoWithKeyPrefixInternal:l,count:d,toArray:f}},function(e,t,n){"use strict";function r(e){return e}function o(e,t){var n=_.hasOwnProperty(t)?_[t]:null;w.hasOwnProperty(t)&&"OVERRIDE_BASE"!==n&&d("73",t),e&&"DEFINE_MANY"!==n&&"DEFINE_MANY_MERGED"!==n&&d("74",t)}function i(e,t){if(t){"function"==typeof t&&d("75"),m.isValidElement(t)&&d("76");var n=e.prototype,r=n.__reactAutoBindPairs;t.hasOwnProperty(b)&&E.mixins(e,t.mixins);for(var i in t)if(t.hasOwnProperty(i)&&i!==b){var a=t[i],s=n.hasOwnProperty(i);if(o(s,i),E.hasOwnProperty(i))E[i](e,a);else{var c=_.hasOwnProperty(i),p="function"==typeof a,f=p&&!c&&!s&&t.autobind!==!1;if(f)r.push(i,a),n[i]=a;else if(s){var h=_[i];(!c||"DEFINE_MANY_MERGED"!==h&&"DEFINE_MANY"!==h)&&d("77",h,i),"DEFINE_MANY_MERGED"===h?n[i]=u(n[i],a):"DEFINE_MANY"===h&&(n[i]=l(n[i],a))}else n[i]=a}}}else;}function a(e,t){if(t)for(var n in t){var r=t[n];if(t.hasOwnProperty(n)){var o=n in E;o&&d("78",n);var i=n in e;i&&d("79",n),e[n]=r}}}function s(e,t){e&&t&&"object"==typeof e&&"object"==typeof t||d("80");for(var n in t)t.hasOwnProperty(n)&&(void 0!==e[n]&&d("81",n),e[n]=t[n]);return e}function u(e,t){return function(){var n=e.apply(this,arguments),r=t.apply(this,arguments);if(null==n)return r;if(null==r)return n;var o={};return s(o,n),s(o,r),o}}function l(e,t){return function(){e.apply(this,arguments),t.apply(this,arguments)}}function c(e,t){var n=t.bind(e);return n}function p(e){for(var t=e.__reactAutoBindPairs,n=0;n<t.length;n+=2){e[t[n]]=c(e,t[n+1])}}var d=n(91),f=n(13),h=n(188),m=n(90),g=(n(727),n(189)),v=n(101),b=(n(1),n(5),"mixins"),y=[],_={mixins:"DEFINE_MANY",statics:"DEFINE_MANY",propTypes:"DEFINE_MANY",contextTypes:"DEFINE_MANY",childContextTypes:"DEFINE_MANY",getDefaultProps:"DEFINE_MANY_MERGED",getInitialState:"DEFINE_MANY_MERGED",getChildContext:"DEFINE_MANY_MERGED",render:"DEFINE_ONCE",componentWillMount:"DEFINE_MANY",componentDidMount:"DEFINE_MANY",componentWillReceiveProps:"DEFINE_MANY",shouldComponentUpdate:"DEFINE_ONCE",componentWillUpdate:"DEFINE_MANY",componentDidUpdate:"DEFINE_MANY",componentWillUnmount:"DEFINE_MANY",updateComponent:"OVERRIDE_BASE"},E={displayName:function(e,t){e.displayName=t},mixins:function(e,t){if(t)for(var n=0;n<t.length;n++)i(e,t[n])},childContextTypes:function(e,t){e.childContextTypes=f({},e.childContextTypes,t)},contextTypes:function(e,t){e.contextTypes=f({},e.contextTypes,t)},getDefaultProps:function(e,t){e.getDefaultProps=e.getDefaultProps?u(e.getDefaultProps,t):t},propTypes:function(e,t){e.propTypes=f({},e.propTypes,t)},statics:function(e,t){a(e,t)},autobind:function(){}},w={replaceState:function(e,t){this.updater.enqueueReplaceState(this,e),t&&this.updater.enqueueCallback(this,t,"replaceState")},isMounted:function(){return this.updater.isMounted(this)}},S=function(){};f(S.prototype,h.prototype,w);e.exports={createClass:function(e){var t=r(function(e,n,r){this.__reactAutoBindPairs.length&&p(this),this.props=e,this.context=n,this.refs=v,this.updater=r||g,this.state=null;var o=this.getInitialState?this.getInitialState():null;("object"!=typeof o||Array.isArray(o))&&d("82",t.displayName||"ReactCompositeComponent"),this.state=o});t.prototype=new S,t.prototype.constructor=t,t.prototype.__reactAutoBindPairs=[],y.forEach(i.bind(null,t)),i(t,e),t.getDefaultProps&&(t.defaultProps=t.getDefaultProps()),t.prototype.render||d("83");for(var n in _)t.prototype[n]||(t.prototype[n]=null);return t},injection:{injectMixin:function(e){y.push(e)}}}},function(e,t,n){"use strict";var r=n(90),o=r.createFactory;e.exports={a:o("a"),abbr:o("abbr"),address:o("address"),area:o("area"),article:o("article"),aside:o("aside"),audio:o("audio"),b:o("b"),base:o("base"),bdi:o("bdi"),bdo:o("bdo"),big:o("big"),blockquote:o("blockquote"),body:o("body"),br:o("br"),button:o("button"),canvas:o("canvas"),caption:o("caption"),cite:o("cite"),code:o("code"),col:o("col"),colgroup:o("colgroup"),data:o("data"),datalist:o("datalist"),dd:o("dd"),del:o("del"),details:o("details"),dfn:o("dfn"),dialog:o("dialog"),div:o("div"),dl:o("dl"),dt:o("dt"),em:o("em"),embed:o("embed"),fieldset:o("fieldset"),figcaption:o("figcaption"),figure:o("figure"),footer:o("footer"),form:o("form"),h1:o("h1"),h2:o("h2"),h3:o("h3"),h4:o("h4"),h5:o("h5"),h6:o("h6"),head:o("head"),header:o("header"),hgroup:o("hgroup"),hr:o("hr"),html:o("html"),i:o("i"),iframe:o("iframe"),img:o("img"),input:o("input"),ins:o("ins"),kbd:o("kbd"),keygen:o("keygen"),label:o("label"),legend:o("legend"),li:o("li"),link:o("link"),main:o("main"),map:o("map"),mark:o("mark"),menu:o("menu"),menuitem:o("menuitem"),meta:o("meta"),meter:o("meter"),nav:o("nav"),noscript:o("noscript"),object:o("object"),ol:o("ol"),optgroup:o("optgroup"),option:o("option"),output:o("output"),p:o("p"),param:o("param"),picture:o("picture"),pre:o("pre"),progress:o("progress"),q:o("q"),rp:o("rp"),rt:o("rt"),ruby:o("ruby"),s:o("s"),samp:o("samp"),script:o("script"),section:o("section"),select:o("select"),small:o("small"),source:o("source"),span:o("span"),strong:o("strong"),style:o("style"),sub:o("sub"),summary:o("summary"),sup:o("sup"),table:o("table"),tbody:o("tbody"),td:o("td"),textarea:o("textarea"),tfoot:o("tfoot"),th:o("th"),thead:o("thead"),time:o("time"),title:o("title"),tr:o("tr"),track:o("track"),u:o("u"),ul:o("ul"),var:o("var"),video:o("video"),wbr:o("wbr"),circle:o("circle"),clipPath:o("clipPath"),defs:o("defs"),ellipse:o("ellipse"),g:o("g"),image:o("image"),line:o("line"),linearGradient:o("linearGradient"),mask:o("mask"),path:o("path"),pattern:o("pattern"),polygon:o("polygon"),polyline:o("polyline"),radialGradient:o("radialGradient"),rect:o("rect"),stop:o("stop"),svg:o("svg"),text:o("text"),tspan:o("tspan")}},function(e,t,n){"use strict";var r={};e.exports=r},function(e,t,n){"use strict";var r=n(90),o=r.isValidElement;e.exports=n(266)(o)},function(e,t,n){"use strict";function r(e,t,n){this.props=e,this.context=t,this.refs=u,this.updater=n||s}function o(){}var i=n(13),a=n(188),s=n(189),u=n(101);o.prototype=a.prototype,r.prototype=new o,r.prototype.constructor=r,i(r.prototype,a.prototype),r.prototype.isPureReactComponent=!0,e.exports=r},function(e,t,n){"use strict";e.exports="15.5.4"},function(e,t,n){"use strict";function r(e){var t=e&&(o&&e[o]||e[i]);if("function"==typeof t)return t}var o="function"==typeof Symbol&&Symbol.iterator,i="@@iterator";e.exports=r},function(e,t,n){"use strict";function r(){return o++}var o=1;e.exports=r},function(e,t,n){"use strict";function r(e){return i.isValidElement(e)||o("143"),e}var o=n(91),i=n(90);n(1);e.exports=r},function(e,t,n){"use strict";function r(e,t){return e&&"object"==typeof e&&null!=e.key?l.escape(e.key):t.toString(36)}function o(e,t,n,i){var d=typeof e;if("undefined"!==d&&"boolean"!==d||(e=null),null===e||"string"===d||"number"===d||"object"===d&&e.$$typeof===s)return n(i,e,""===t?c+r(e,0):t),1;var f,h,m=0,g=""===t?c:t+p;if(Array.isArray(e))for(var v=0;v<e.length;v++)f=e[v],h=g+r(f,v),m+=o(f,h,n,i);else{var b=u(e);if(b){var y,_=b.call(e);if(b!==e.entries)for(var E=0;!(y=_.next()).done;)f=y.value,h=g+r(f,E++),m+=o(f,h,n,i);else for(;!(y=_.next()).done;){var w=y.value;w&&(f=w[1],h=g+l.escape(w[0])+p+r(f,0),m+=o(f,h,n,i))}}else if("object"===d){var S="",x=String(e);a("31","[object Object]"===x?"object with keys {"+Object.keys(e).join(", ")+"}":x,S)}}return m}function i(e,t,n){return null==e?0:o(e,"",t,n)}var a=n(91),s=(n(56),n(294)),u=n(731),l=(n(1),n(722)),c=(n(5),"."),p=":";e.exports=i},function(e,t,n){"use strict";function r(e){return function(t){var n=t.dispatch,r=t.getState;return function(t){return function(o){return"function"==typeof o?o(n,r,e):t(o)}}}}t.__esModule=!0;var o=r();o.withExtraArgument=r,t.default=o},function(e,t,n){"use strict";function r(){for(var e=arguments.length,t=Array(e),n=0;n<e;n++)t[n]=arguments[n];return function(e){return function(n,r,a){var s=e(n,r,a),u=s.dispatch,l=[],c={getState:s.getState,dispatch:function(e){return u(e)}};return l=t.map(function(e){return e(c)}),u=o.a.apply(void 0,l)(s.dispatch),i({},s,{dispatch:u})}}}t.a=r;var o=n(296),i=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e}},function(e,t,n){"use strict";function r(e,t){return function(){return t(e.apply(void 0,arguments))}}function o(e,t){if("function"==typeof e)return r(e,t);if("object"!=typeof e||null===e)throw new Error("bindActionCreators expected an object or a function, instead received "+(null===e?"null":typeof e)+'. Did you write "import ActionCreators from" instead of "import * as ActionCreators from"?');for(var n=Object.keys(e),o={},i=0;i<n.length;i++){var a=n[i],s=e[a];"function"==typeof s&&(o[a]=r(s,t))}return o}t.a=o},function(e,t,n){"use strict";function r(e,t){var n=t&&t.type;return"Given action "+(n&&'"'+n.toString()+'"'||"an action")+', reducer "'+e+'" returned undefined. To ignore an action, you must explicitly return the previous state.'}function o(e){Object.keys(e).forEach(function(t){var n=e[t];if(void 0===n(void 0,{type:a.b.INIT}))throw new Error('Reducer "'+t+'" returned undefined during initialization. If the state passed to the reducer is undefined, you must explicitly return the initial state. The initial state may not be undefined.');if(void 0===n(void 0,{type:"@@redux/PROBE_UNKNOWN_ACTION_"+Math.random().toString(36).substring(7).split("").join(".")}))throw new Error('Reducer "'+t+"\" returned undefined when probed with a random type. Don't try to handle "+a.b.INIT+' or other actions in "redux/*" namespace. They are considered private. Instead, you must return the current state for any unknown actions, unless it is undefined, in which case you must return the initial state, regardless of the action type. The initial state may not be undefined.')})}function i(e){for(var t=Object.keys(e),n={},i=0;i<t.length;i++){var a=t[i];"function"==typeof e[a]&&(n[a]=e[a])}var s,u=Object.keys(n);try{o(n)}catch(e){s=e}return function(){var e=arguments.length<=0||void 0===arguments[0]?{}:arguments[0],t=arguments[1];if(s)throw s;for(var o=!1,i={},a=0;a<u.length;a++){var l=u[a],c=n[l],p=e[l],d=c(p,t);if(void 0===d){var f=r(l,t);throw new Error(f)}i[l]=d,o=o||d!==p}return o?i:e}}t.a=i;var a=n(297);n(170),n(298)},function(e,t,n){(function(t,n){!function(t){"use strict";function r(e,t,n,r){var o=t&&t.prototype instanceof i?t:i,a=Object.create(o.prototype);return a._invoke=c(e,n,new h(r||[])),a}function o(e,t,n){try{return{type:"normal",arg:e.call(t,n)}}catch(e){return{type:"throw",arg:e}}}function i(){}function a(){}function s(){}function u(e){["next","throw","return"].forEach(function(t){e[t]=function(e){return this._invoke(t,e)}})}function l(e){function t(n,r,i,a){var s=o(e[n],e,r);if("throw"!==s.type){var u=s.arg,l=u.value;return l&&"object"==typeof l&&y.call(l,"__await")?Promise.resolve(l.__await).then(function(e){t("next",e,i,a)},function(e){t("throw",e,i,a)}):Promise.resolve(l).then(function(e){u.value=e,i(u)},a)}a(s.arg)}function r(e,n){function r(){return new Promise(function(r,o){t(e,n,r,o)})}return i=i?i.then(r,r):r()}"object"==typeof n&&n.domain&&(t=n.domain.bind(t));var i;this._invoke=r}function c(e,t,n){var r=T;return function(i,a){if(r===I)throw new Error("Generator is already running");if(r===R){if("throw"===i)throw a;return g()}for(n.method=i,n.arg=a;;){var s=n.delegate;if(s){var u=p(s,n);if(u){if(u===M)continue;return u}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===T)throw r=R,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=I;var l=o(e,t,n);if("normal"===l.type){if(r=n.done?R:C,l.arg===M)continue;return{value:l.arg,done:n.done}}"throw"===l.type&&(r=R,n.method="throw",n.arg=l.arg)}}}function p(e,t){var n=e.iterator[t.method];if(n===v){if(t.delegate=null,"throw"===t.method){if(e.iterator.return&&(t.method="return",t.arg=v,p(e,t),"throw"===t.method))return M;t.method="throw",t.arg=new TypeError("The iterator does not provide a 'throw' method")}return M}var r=o(n,e.iterator,t.arg);if("throw"===r.type)return t.method="throw",t.arg=r.arg,t.delegate=null,M;var i=r.arg;return i?i.done?(t[e.resultName]=i.value,t.next=e.nextLoc,"return"!==t.method&&(t.method="next",t.arg=v),t.delegate=null,M):i:(t.method="throw",t.arg=new TypeError("iterator result is not an object"),t.delegate=null,M)}function d(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function f(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function h(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(d,this),this.reset(!0)}function m(e){if(e){var t=e[E];if(t)return t.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var n=-1,r=function t(){for(;++n<e.length;)if(y.call(e,n))return t.value=e[n],t.done=!1,t;return t.value=v,t.done=!0,t};return r.next=r}}return{next:g}}function g(){return{value:v,done:!0}}var v,b=Object.prototype,y=b.hasOwnProperty,_="function"==typeof Symbol?Symbol:{},E=_.iterator||"@@iterator",w=_.toStringTag||"@@toStringTag",S="object"==typeof e,x=t.regeneratorRuntime;if(x)return void(S&&(e.exports=x));x=t.regeneratorRuntime=S?e.exports:{},x.wrap=r;var T="suspendedStart",C="suspendedYield",I="executing",R="completed",M={},P={};P[E]=function(){return this};var O=Object.getPrototypeOf,A=O&&O(O(m([])));A&&A!==b&&y.call(A,E)&&(P=A);var D=s.prototype=i.prototype=Object.create(P);a.prototype=D.constructor=s,s.constructor=a,s[w]=a.displayName="GeneratorFunction",x.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===a||"GeneratorFunction"===(t.displayName||t.name))},x.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,s):(e.__proto__=s,w in e||(e[w]="GeneratorFunction")),e.prototype=Object.create(D),e},x.awrap=function(e){return{__await:e}},u(l.prototype),x.AsyncIterator=l,x.async=function(e,t,n,o){var i=new l(r(e,t,n,o));return x.isGeneratorFunction(t)?i:i.next().then(function(e){return e.done?e.value:i.next()})},u(D),D[w]="Generator",D.toString=function(){return"[object Generator]"},x.keys=function(e){var t=[];for(var n in e)t.push(n);return t.reverse(),function n(){for(;t.length;){var r=t.pop();if(r in e)return n.value=r,n.done=!1,n}return n.done=!0,n}},x.values=m,h.prototype={constructor:h,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=v,this.done=!1,this.delegate=null,this.method="next",this.arg=v,this.tryEntries.forEach(f),!e)for(var t in this)"t"===t.charAt(0)&&y.call(this,t)&&!isNaN(+t.slice(1))&&(this[t]=v)},stop:function(){this.done=!0;var e=this.tryEntries[0],t=e.completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(e){function t(t,r){return i.type="throw",i.arg=e,n.next=t,r&&(n.method="next",n.arg=v),!!r}if(this.done)throw e;for(var n=this,r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r],i=o.completion;if("root"===o.tryLoc)return t("end");if(o.tryLoc<=this.prev){var a=y.call(o,"catchLoc"),s=y.call(o,"finallyLoc");if(a&&s){if(this.prev<o.catchLoc)return t(o.catchLoc,!0);if(this.prev<o.finallyLoc)return t(o.finallyLoc)}else if(a){if(this.prev<o.catchLoc)return t(o.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return t(o.finallyLoc)}}}},abrupt:function(e,t){for(var n=this.tryEntries.length-1;n>=0;--n){var r=this.tryEntries[n];if(r.tryLoc<=this.prev&&y.call(r,"finallyLoc")&&this.prev<r.finallyLoc){var o=r;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=e,i.arg=t,o?(this.method="next",this.next=o.finallyLoc,M):this.complete(i)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),M},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.finallyLoc===e)return this.complete(n.completion,n.afterLoc),f(n),M}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.tryLoc===e){var r=n.completion;if("throw"===r.type){var o=r.arg;f(n)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(e,t,n){return this.delegate={iterator:m(e),resultName:t,nextLoc:n},"next"===this.method&&(this.arg=v),M}}}("object"==typeof t?t:"object"==typeof window?window:"object"==typeof self?self:this)}).call(t,n(34),n(107))},function(e,t,n){"use strict";var r=n(123),o=n(251),i=n(252),a=n(299),s=n(300),u=n(741),l=r.call(Function.apply,a),c=function(e,t){i.RequireObjectCoercible(e);var n=[t];return arguments.length>2&&n.push(arguments[2]),l(e,n)};o(c,{getPolyfill:s,implementation:a,shim:u}),e.exports=c},function(e,t,n){"use strict";var r=n(300),o=n(251);e.exports=function(){var e=r();return o(String.prototype,{padStart:e},{padStart:function(){return String.prototype.padStart!==e}}),e}},function(e,t,n){e.exports=n(743)},function(e,t,n){"use strict";(function(e,r){Object.defineProperty(t,"__esModule",{value:!0});var o,i=n(744),a=function(e){return e&&e.__esModule?e:{default:e}}(i);o="undefined"!=typeof self?self:"undefined"!=typeof window?window:void 0!==e?e:r;var s=(0,a.default)(o);t.default=s}).call(t,n(34),n(747)(e))},function(e,t,n){"use strict";function r(e){var t,n=e.Symbol;return"function"==typeof n?n.observable?t=n.observable:(t=n("observable"),n.observable=t):t="@@observable",t}Object.defineProperty(t,"__esModule",{value:!0}),t.default=r},function(e,t,n){var r;!function(o,i){"use strict";var a="model",s="name",u="type",l="vendor",c="version",p="mobile",d="tablet",f={extend:function(e,t){var n={};for(var r in e)n[r]=t[r]&&t[r].length%2==0?t[r].concat(e[r]):e[r];return n},has:function(e,t){return"string"==typeof e&&t.toLowerCase().indexOf(e.toLowerCase())!==-1},lowerize:function(e){return e.toLowerCase()},major:function(e){return"string"==typeof e?e.replace(/[^\d\.]/g,"").split(".")[0]:void 0},trim:function(e){return e.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")}},h={rgx:function(){for(var e,t,n,r,o,i,a,s=0,u=arguments;s<u.length&&!i;){var l=u[s],c=u[s+1];if(void 0===e){e={};for(r in c)c.hasOwnProperty(r)&&(o=c[r],"object"==typeof o?e[o[0]]=void 0:e[o]=void 0)}for(t=n=0;t<l.length&&!i;)if(i=l[t++].exec(this.getUA()))for(r=0;r<c.length;r++)a=i[++n],o=c[r],"object"==typeof o&&o.length>0?2==o.length?e[o[0]]="function"==typeof o[1]?o[1].call(this,a):o[1]:3==o.length?e[o[0]]="function"!=typeof o[1]||o[1].exec&&o[1].test?a?a.replace(o[1],o[2]):void 0:a?o[1].call(this,a,o[2]):void 0:4==o.length&&(e[o[0]]=a?o[3].call(this,a.replace(o[1],o[2])):void 0):e[o]=a?a:void 0;s+=2}return e},str:function(e,t){for(var n in t)if("object"==typeof t[n]&&t[n].length>0){for(var r=0;r<t[n].length;r++)if(f.has(t[n][r],e))return"?"===n?void 0:n}else if(f.has(t[n],e))return"?"===n?void 0:n;return e}},m={browser:{oldsafari:{version:{"1.0":"/8",1.2:"/1",1.3:"/3","2.0":"/412","2.0.2":"/416","2.0.3":"/417","2.0.4":"/419","?":"/"}}},device:{amazon:{model:{"Fire Phone":["SD","KF"]}},sprint:{model:{"Evo Shift 4G":"7373KT"},vendor:{HTC:"APA",Sprint:"Sprint"}}},os:{windows:{version:{ME:"4.90","NT 3.11":"NT3.51","NT 4.0":"NT4.0",2000:"NT 5.0",XP:["NT 5.1","NT 5.2"],Vista:"NT 6.0",7:"NT 6.1",8:"NT 6.2",8.1:"NT 6.3",10:["NT 6.4","NT 10.0"],RT:"ARM"}}}},g={browser:[[/(opera\smini)\/([\w\.-]+)/i,/(opera\s[mobiletab]+).+version\/([\w\.-]+)/i,/(opera).+version\/([\w\.]+)/i,/(opera)[\/\s]+([\w\.]+)/i],[s,c],[/(opios)[\/\s]+([\w\.]+)/i],[[s,"Opera Mini"],c],[/\s(opr)\/([\w\.]+)/i],[[s,"Opera"],c],[/(kindle)\/([\w\.]+)/i,/(lunascape|maxthon|netfront|jasmine|blazer)[\/\s]?([\w\.]+)*/i,/(avant\s|iemobile|slim|baidu)(?:browser)?[\/\s]?([\w\.]*)/i,/(?:ms|\()(ie)\s([\w\.]+)/i,/(rekonq)\/([\w\.]+)*/i,/(chromium|flock|rockmelt|midori|epiphany|silk|skyfire|ovibrowser|bolt|iron|vivaldi|iridium|phantomjs)\/([\w\.-]+)/i],[s,c],[/(trident).+rv[:\s]([\w\.]+).+like\sgecko/i],[[s,"IE"],c],[/(edge)\/((\d+)?[\w\.]+)/i],[s,c],[/(yabrowser)\/([\w\.]+)/i],[[s,"Yandex"],c],[/(comodo_dragon)\/([\w\.]+)/i],[[s,/_/g," "],c],[/(micromessenger)\/([\w\.]+)/i],[[s,"WeChat"],c],[/xiaomi\/miuibrowser\/([\w\.]+)/i],[c,[s,"MIUI Browser"]],[/\swv\).+(chrome)\/([\w\.]+)/i],[[s,/(.+)/,"$1 WebView"],c],[/android.+samsungbrowser\/([\w\.]+)/i,/android.+version\/([\w\.]+)\s+(?:mobile\s?safari|safari)*/i],[c,[s,"Android Browser"]],[/(chrome|omniweb|arora|[tizenoka]{5}\s?browser)\/v?([\w\.]+)/i,/(qqbrowser)[\/\s]?([\w\.]+)/i],[s,c],[/(uc\s?browser)[\/\s]?([\w\.]+)/i,/ucweb.+(ucbrowser)[\/\s]?([\w\.]+)/i,/juc.+(ucweb)[\/\s]?([\w\.]+)/i],[[s,"UCBrowser"],c],[/(dolfin)\/([\w\.]+)/i],[[s,"Dolphin"],c],[/((?:android.+)crmo|crios)\/([\w\.]+)/i],[[s,"Chrome"],c],[/;fbav\/([\w\.]+);/i],[c,[s,"Facebook"]],[/fxios\/([\w\.-]+)/i],[c,[s,"Firefox"]],[/version\/([\w\.]+).+?mobile\/\w+\s(safari)/i],[c,[s,"Mobile Safari"]],[/version\/([\w\.]+).+?(mobile\s?safari|safari)/i],[c,s],[/webkit.+?(mobile\s?safari|safari)(\/[\w\.]+)/i],[s,[c,h.str,m.browser.oldsafari.version]],[/(konqueror)\/([\w\.]+)/i,/(webkit|khtml)\/([\w\.]+)/i],[s,c],[/(navigator|netscape)\/([\w\.-]+)/i],[[s,"Netscape"],c],[/(swiftfox)/i,/(icedragon|iceweasel|camino|chimera|fennec|maemo\sbrowser|minimo|conkeror)[\/\s]?([\w\.\+]+)/i,/(firefox|seamonkey|k-meleon|icecat|iceape|firebird|phoenix)\/([\w\.-]+)/i,/(mozilla)\/([\w\.]+).+rv\:.+gecko\/\d+/i,/(polaris|lynx|dillo|icab|doris|amaya|w3m|netsurf|sleipnir)[\/\s]?([\w\.]+)/i,/(links)\s\(([\w\.]+)/i,/(gobrowser)\/?([\w\.]+)*/i,/(ice\s?browser)\/v?([\w\._]+)/i,/(mosaic)[\/\s]([\w\.]+)/i],[s,c]],cpu:[[/(?:(amd|x(?:(?:86|64)[_-])?|wow|win)64)[;\)]/i],[["architecture","amd64"]],[/(ia32(?=;))/i],[["architecture",f.lowerize]],[/((?:i[346]|x)86)[;\)]/i],[["architecture","ia32"]],[/windows\s(ce|mobile);\sppc;/i],[["architecture","arm"]],[/((?:ppc|powerpc)(?:64)?)(?:\smac|;|\))/i],[["architecture",/ower/,"",f.lowerize]],[/(sun4\w)[;\)]/i],[["architecture","sparc"]],[/((?:avr32|ia64(?=;))|68k(?=\))|arm(?:64|(?=v\d+;))|(?=atmel\s)avr|(?:irix|mips|sparc)(?:64)?(?=;)|pa-risc)/i],[["architecture",f.lowerize]]],device:[[/\((ipad|playbook);[\w\s\);-]+(rim|apple)/i],[a,l,[u,d]],[/applecoremedia\/[\w\.]+ \((ipad)/],[a,[l,"Apple"],[u,d]],[/(apple\s{0,1}tv)/i],[[a,"Apple TV"],[l,"Apple"]],[/(archos)\s(gamepad2?)/i,/(hp).+(touchpad)/i,/(hp).+(tablet)/i,/(kindle)\/([\w\.]+)/i,/\s(nook)[\w\s]+build\/(\w+)/i,/(dell)\s(strea[kpr\s\d]*[\dko])/i],[l,a,[u,d]],[/(kf[A-z]+)\sbuild\/[\w\.]+.*silk\//i],[a,[l,"Amazon"],[u,d]],[/(sd|kf)[0349hijorstuw]+\sbuild\/[\w\.]+.*silk\//i],[[a,h.str,m.device.amazon.model],[l,"Amazon"],[u,p]],[/\((ip[honed|\s\w*]+);.+(apple)/i],[a,l,[u,p]],[/\((ip[honed|\s\w*]+);/i],[a,[l,"Apple"],[u,p]],[/(blackberry)[\s-]?(\w+)/i,/(blackberry|benq|palm(?=\-)|sonyericsson|acer|asus|dell|huawei|meizu|motorola|polytron)[\s_-]?([\w-]+)*/i,/(hp)\s([\w\s]+\w)/i,/(asus)-?(\w+)/i],[l,a,[u,p]],[/\(bb10;\s(\w+)/i],[a,[l,"BlackBerry"],[u,p]],[/android.+(transfo[prime\s]{4,10}\s\w+|eeepc|slider\s\w+|nexus 7|padfone)/i],[a,[l,"Asus"],[u,d]],[/(sony)\s(tablet\s[ps])\sbuild\//i,/(sony)?(?:sgp.+)\sbuild\//i],[[l,"Sony"],[a,"Xperia Tablet"],[u,d]],[/(?:sony)?(?:(?:(?:c|d)\d{4})|(?:so[-l].+))\sbuild\//i],[[l,"Sony"],[a,"Xperia Phone"],[u,p]],[/\s(ouya)\s/i,/(nintendo)\s([wids3u]+)/i],[l,a,[u,"console"]],[/android.+;\s(shield)\sbuild/i],[a,[l,"Nvidia"],[u,"console"]],[/(playstation\s[34portablevi]+)/i],[a,[l,"Sony"],[u,"console"]],[/(sprint\s(\w+))/i],[[l,h.str,m.device.sprint.vendor],[a,h.str,m.device.sprint.model],[u,p]],[/(lenovo)\s?(S(?:5000|6000)+(?:[-][\w+]))/i],[l,a,[u,d]],[/(htc)[;_\s-]+([\w\s]+(?=\))|\w+)*/i,/(zte)-(\w+)*/i,/(alcatel|geeksphone|huawei|lenovo|nexian|panasonic|(?=;\s)sony)[_\s-]?([\w-]+)*/i],[l,[a,/_/g," "],[u,p]],[/(nexus\s9)/i],[a,[l,"HTC"],[u,d]],[/(nexus\s6p)/i],[a,[l,"Huawei"],[u,p]],[/(microsoft);\s(lumia[\s\w]+)/i],[l,a,[u,p]],[/[\s\(;](xbox(?:\sone)?)[\s\);]/i],[a,[l,"Microsoft"],[u,"console"]],[/(kin\.[onetw]{3})/i],[[a,/\./g," "],[l,"Microsoft"],[u,p]],[/\s(milestone|droid(?:[2-4x]|\s(?:bionic|x2|pro|razr))?(:?\s4g)?)[\w\s]+build\//i,/mot[\s-]?(\w+)*/i,/(XT\d{3,4}) build\//i,/(nexus\s6)/i],[a,[l,"Motorola"],[u,p]],[/android.+\s(mz60\d|xoom[\s2]{0,2})\sbuild\//i],[a,[l,"Motorola"],[u,d]],[/hbbtv\/\d+\.\d+\.\d+\s+\([\w\s]*;\s*(\w[^;]*);([^;]*)/i],[[l,f.trim],[a,f.trim],[u,"smarttv"]],[/hbbtv.+maple;(\d+)/i],[[a,/^/,"SmartTV"],[l,"Samsung"],[u,"smarttv"]],[/\(dtv[\);].+(aquos)/i],[a,[l,"Sharp"],[u,"smarttv"]],[/android.+((sch-i[89]0\d|shw-m380s|gt-p\d{4}|gt-n\d+|sgh-t8[56]9|nexus 10))/i,/((SM-T\w+))/i],[[l,"Samsung"],a,[u,d]],[/smart-tv.+(samsung)/i],[l,[u,"smarttv"],a],[/((s[cgp]h-\w+|gt-\w+|galaxy\snexus|sm-\w[\w\d]+))/i,/(sam[sung]*)[\s-]*(\w+-?[\w-]*)*/i,/sec-((sgh\w+))/i],[[l,"Samsung"],a,[u,p]],[/sie-(\w+)*/i],[a,[l,"Siemens"],[u,p]],[/(maemo|nokia).*(n900|lumia\s\d+)/i,/(nokia)[\s_-]?([\w-]+)*/i],[[l,"Nokia"],a,[u,p]],[/android\s3\.[\s\w;-]{10}(a\d{3})/i],[a,[l,"Acer"],[u,d]],[/android\s3\.[\s\w;-]{10}(lg?)-([06cv9]{3,4})/i],[[l,"LG"],a,[u,d]],[/(lg) netcast\.tv/i],[l,a,[u,"smarttv"]],[/(nexus\s[45])/i,/lg[e;\s\/-]+(\w+)*/i],[a,[l,"LG"],[u,p]],[/android.+(ideatab[a-z0-9\-\s]+)/i],[a,[l,"Lenovo"],[u,d]],[/linux;.+((jolla));/i],[l,a,[u,p]],[/((pebble))app\/[\d\.]+\s/i],[l,a,[u,"wearable"]],[/android.+;\s(glass)\s\d/i],[a,[l,"Google"],[u,"wearable"]],[/android.+(\w+)\s+build\/hm\1/i,/android.+(hm[\s\-_]*note?[\s_]*(?:\d\w)?)\s+build/i,/android.+(mi[\s\-_]*(?:one|one[\s_]plus|note lte)?[\s_]*(?:\d\w)?)\s+build/i],[[a,/_/g," "],[l,"Xiaomi"],[u,p]],[/android.+a000(1)\s+build/i],[a,[l,"OnePlus"],[u,p]],[/\s(tablet)[;\/]/i,/\s(mobile)(?:[;\/]|\ssafari)/i],[[u,f.lowerize],l,a]],engine:[[/windows.+\sedge\/([\w\.]+)/i],[c,[s,"EdgeHTML"]],[/(presto)\/([\w\.]+)/i,/(webkit|trident|netfront|netsurf|amaya|lynx|w3m)\/([\w\.]+)/i,/(khtml|tasman|links)[\/\s]\(?([\w\.]+)/i,/(icab)[\/\s]([23]\.[\d\.]+)/i],[s,c],[/rv\:([\w\.]+).*(gecko)/i],[c,s]],os:[[/microsoft\s(windows)\s(vista|xp)/i],[s,c],[/(windows)\snt\s6\.2;\s(arm)/i,/(windows\sphone(?:\sos)*)[\s\/]?([\d\.\s]+\w)*/i,/(windows\smobile|windows)[\s\/]?([ntce\d\.\s]+\w)/i],[s,[c,h.str,m.os.windows.version]],[/(win(?=3|9|n)|win\s9x\s)([nt\d\.]+)/i],[[s,"Windows"],[c,h.str,m.os.windows.version]],[/\((bb)(10);/i],[[s,"BlackBerry"],c],[/(blackberry)\w*\/?([\w\.]+)*/i,/(tizen)[\/\s]([\w\.]+)/i,/(android|webos|palm\sos|qnx|bada|rim\stablet\sos|meego|contiki)[\/\s-]?([\w\.]+)*/i,/linux;.+(sailfish);/i],[s,c],[/(symbian\s?os|symbos|s60(?=;))[\/\s-]?([\w\.]+)*/i],[[s,"Symbian"],c],[/\((series40);/i],[s],[/mozilla.+\(mobile;.+gecko.+firefox/i],[[s,"Firefox OS"],c],[/(nintendo|playstation)\s([wids34portablevu]+)/i,/(mint)[\/\s\(]?(\w+)*/i,/(mageia|vectorlinux)[;\s]/i,/(joli|[kxln]?ubuntu|debian|[open]*suse|gentoo|(?=\s)arch|slackware|fedora|mandriva|centos|pclinuxos|redhat|zenwalk|linpus)[\/\s-]?(?!chrom)([\w\.-]+)*/i,/(hurd|linux)\s?([\w\.]+)*/i,/(gnu)\s?([\w\.]+)*/i],[s,c],[/(cros)\s[\w]+\s([\w\.]+\w)/i],[[s,"Chromium OS"],c],[/(sunos)\s?([\w\.]+\d)*/i],[[s,"Solaris"],c],[/\s([frentopc-]{0,4}bsd|dragonfly)\s?([\w\.]+)*/i],[s,c],[/(haiku)\s(\w+)/i],[s,c],[/(ip[honead]+)(?:.*os\s([\w]+)*\slike\smac|;\sopera)/i],[[s,"iOS"],[c,/_/g,"."]],[/(mac\sos\sx)\s?([\w\s\.]+\w)*/i,/(macintosh|mac(?=_powerpc)\s)/i],[[s,"Mac OS"],[c,/_/g,"."]],[/((?:open)?solaris)[\/\s-]?([\w\.]+)*/i,/(aix)\s((\d)(?=\.|\)|\s)[\w\.]*)*/i,/(plan\s9|minix|beos|os\/2|amigaos|morphos|risc\sos|openvms)/i,/(unix)\s?([\w\.]+)*/i],[s,c]]},v=function(e,t){if(!(this instanceof v))return new v(e,t).getResult();var n=e||(o&&o.navigator&&o.navigator.userAgent?o.navigator.userAgent:""),r=t?f.extend(g,t):g;return this.getBrowser=function(){var e=h.rgx.apply(this,r.browser);return e.major=f.major(e.version),e},this.getCPU=function(){return h.rgx.apply(this,r.cpu)},this.getDevice=function(){return h.rgx.apply(this,r.device)},this.getEngine=function(){return h.rgx.apply(this,r.engine)},this.getOS=function(){return h.rgx.apply(this,r.os)},this.getResult=function(){return{ua:this.getUA(),browser:this.getBrowser(),engine:this.getEngine(),os:this.getOS(),device:this.getDevice(),cpu:this.getCPU()}},this.getUA=function(){return n},this.setUA=function(e){return n=e,this},this};v.VERSION="0.7.12",v.BROWSER={NAME:s,MAJOR:"major",VERSION:c},v.CPU={ARCHITECTURE:"architecture"},v.DEVICE={MODEL:a,VENDOR:l,TYPE:u,CONSOLE:"console",MOBILE:p,SMARTTV:"smarttv",TABLET:d,WEARABLE:"wearable",EMBEDDED:"embedded"},v.ENGINE={NAME:s,VERSION:c},v.OS={NAME:s,VERSION:c},void 0!==t?(void 0!==e&&e.exports&&(t=e.exports=v),t.UAParser=v):n(748)?void 0!==(r=function(){return v}.call(t,n,t,e))&&(e.exports=r):o.UAParser=v;var b=o.jQuery||o.Zepto;if(void 0!==b){var y=new v;b.ua=y.getResult(),b.ua.get=function(){return y.getUA()},b.ua.set=function(e){y.setUA(e);var t=y.getResult();for(var n in t)b.ua[n]=t[n]}}}("object"==typeof window?window:this)},function(e,t,n){(function(t){WebGLDebugUtils=function(){function e(e){if(null==h){h={},m={};for(var t in e)"number"==typeof e[t]&&(h[e[t]]=t,m[t]=e[t])}}function n(){if(null==h)throw"WebGLDebugUtils.init(ctx) not called"}function r(e){return n(),void 0!==h[e]}function o(e){n();var t=h[e];return void 0!==t?"gl."+t:"/*UNKNOWN WebGL ENUM*/ 0x"+e.toString(16)}function i(e,t,n,r){var i=f[e];if(void 0!==i){var i=i[t];if(void 0!==i&&i[n]){if("object"==typeof i[n]&&void 0!==i[n].enumBitwiseOr){for(var a=i[n].enumBitwiseOr,s=0,u=[],l=0;l<a.length;++l){var c=m[a[l]];0!=(r&c)&&(s|=c,u.push(o(c)))}return s===r?u.join(" | "):o(r)}return o(r)}}return null===r?"null":void 0===r?"undefined":r.toString()}function a(e,t){for(var n="",r=t.length,o=0;o<r;++o)n+=(0==o?"":", ")+i(e,r,o,t[o]);return n}function s(e,t,n){e.__defineGetter__(n,function(){return t[n]}),e.__defineSetter__(n,function(e){t[n]=e})}function u(t,n,r,a){function l(e,t){return function(){r&&r(t,arguments);var o=e[t].apply(e,arguments),i=a.getError();return 0!=i&&(c[i]=!0,n(i,t,arguments)),o}}a=a||t,e(t),n=n||function(e,t,n){for(var r="",a=n.length,s=0;s<a;++s)r+=(0==s?"":", ")+i(t,a,s,n[s]);d("WebGL error "+o(e)+" in "+t+"("+r+")")};var c={},p={};for(var f in t)if("function"==typeof t[f])if("getExtension"!=f)p[f]=l(t,f);else{var h=l(t,f);p[f]=function(){return u(h.apply(t,arguments),n,r,a)}}else s(p,t,f);return p.getError=function(){for(var e in c)if(c.hasOwnProperty(e)&&c[e])return c[e]=!1,e;return t.NO_ERROR},p}function l(e){var t=e.getParameter(e.MAX_VERTEX_ATTRIBS),n=e.createBuffer();e.bindBuffer(e.ARRAY_BUFFER,n);for(var r=0;r<t;++r)e.disableVertexAttribArray(r),e.vertexAttribPointer(r,4,e.FLOAT,!1,0,0),e.vertexAttrib1f(r,0);e.deleteBuffer(n);for(var o=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS),r=0;r<o;++r)e.activeTexture(e.TEXTURE0+r),e.bindTexture(e.TEXTURE_CUBE_MAP,null),e.bindTexture(e.TEXTURE_2D,null);for(e.activeTexture(e.TEXTURE0),e.useProgram(null),e.bindBuffer(e.ARRAY_BUFFER,null),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null),e.bindFramebuffer(e.FRAMEBUFFER,null),e.bindRenderbuffer(e.RENDERBUFFER,null),e.disable(e.BLEND),e.disable(e.CULL_FACE),e.disable(e.DEPTH_TEST),e.disable(e.DITHER),e.disable(e.SCISSOR_TEST),e.blendColor(0,0,0,0),e.blendEquation(e.FUNC_ADD),e.blendFunc(e.ONE,e.ZERO),e.clearColor(0,0,0,0),e.clearDepth(1),e.clearStencil(-1),e.colorMask(!0,!0,!0,!0),e.cullFace(e.BACK),e.depthFunc(e.LESS),e.depthMask(!0),e.depthRange(0,1),e.frontFace(e.CCW),e.hint(e.GENERATE_MIPMAP_HINT,e.DONT_CARE),e.lineWidth(1),e.pixelStorei(e.PACK_ALIGNMENT,4),e.pixelStorei(e.UNPACK_ALIGNMENT,4),e.pixelStorei(e.UNPACK_FLIP_Y_WEBGL,!1),e.pixelStorei(e.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!1),e.UNPACK_COLORSPACE_CONVERSION_WEBGL&&e.pixelStorei(e.UNPACK_COLORSPACE_CONVERSION_WEBGL,e.BROWSER_DEFAULT_WEBGL),e.polygonOffset(0,0),e.sampleCoverage(1,!1),e.scissor(0,0,e.canvas.width,e.canvas.height),e.stencilFunc(e.ALWAYS,0,4294967295),e.stencilMask(4294967295),e.stencilOp(e.KEEP,e.KEEP,e.KEEP),e.viewport(0,0,e.canvas.width,e.canvas.height),e.clear(e.COLOR_BUFFER_BIT|e.DEPTH_BUFFER_BIT|e.STENCIL_BUFFER_BIT);e.getError(););}function c(e){function t(e){return"function"==typeof e?e:function(t){e.handleEvent(t)}}function n(){for(var e=Object.keys(E),t=0;t<e.length;++t)delete E[e]}function r(){++b,m||v==b&&e.loseContext()}function o(e,t){var n=e[t];return function(){if(r(),!m){return n.apply(e,arguments)}}}function i(){for(var e=0;e<g.length;++e){var t=g[e];t instanceof WebGLBuffer?c.deleteBuffer(t):t instanceof WebGLFramebuffer?c.deleteFramebuffer(t):t instanceof WebGLProgram?c.deleteProgram(t):t instanceof WebGLRenderbuffer?c.deleteRenderbuffer(t):t instanceof WebGLShader?c.deleteShader(t):t instanceof WebGLTexture&&c.deleteTexture(t)}}function a(e){return{statusMessage:e,preventDefault:function(){y=!0}}}function u(e){for(var t in e)"function"==typeof e[t]?p[t]=o(e,t):s(p,e,t);p.getError=function(){if(r(),!m)for(var e;e=c.getError();)E[e]=!0;for(var e in E)if(E[e])return delete E[e],e;return p.NO_ERROR};for(var n=["createBuffer","createFramebuffer","createProgram","createRenderbuffer","createShader","createTexture"],i=0;i<n.length;++i){var a=n[i];p[a]=function(t){return function(){if(r(),m)return null;var n=t.apply(e,arguments);return n.__webglDebugContextLostId__=h,g.push(n),n}}(e[a])}for(var u=["getActiveAttrib","getActiveUniform","getBufferParameter","getContextAttributes","getAttachedShaders","getFramebufferAttachmentParameter","getParameter","getProgramParameter","getProgramInfoLog","getRenderbufferParameter","getShaderParameter","getShaderInfoLog","getShaderSource","getTexParameter","getUniform","getUniformLocation","getVertexAttrib"],i=0;i<u.length;++i){var a=u[i];p[a]=function(t){return function(){return r(),m?null:t.apply(e,arguments)}}(p[a])}for(var l=["isBuffer","isEnabled","isFramebuffer","isProgram","isRenderbuffer","isShader","isTexture"],i=0;i<l.length;++i){var a=l[i];p[a]=function(t){return function(){return r(),!m&&t.apply(e,arguments)}}(p[a])}return p.checkFramebufferStatus=function(t){return function(){return r(),m?p.FRAMEBUFFER_UNSUPPORTED:t.apply(e,arguments)}}(p.checkFramebufferStatus),p.getAttribLocation=function(t){return function(){return r(),m?-1:t.apply(e,arguments)}}(p.getAttribLocation),p.getVertexAttribOffset=function(t){return function(){return r(),m?0:t.apply(e,arguments)}}(p.getVertexAttribOffset),p.isContextLost=function(){return m},p}var c,p,d=[],f=[],p={},h=1,m=!1,g=[],v=0,b=0,y=!1,_=0,E={};e.getContext=function(t){return function(){var n=t.apply(e,arguments);if(n instanceof WebGLRenderingContext){if(n!=c){if(c)throw"got different context";c=n,p=u(c)}return p}return n}}(e.getContext);var w=function(e){d.push(t(e))},S=function(e){f.push(t(e))};return function(e){var t=e.addEventListener;e.addEventListener=function(n,r,o){switch(n){case"webglcontextlost":w(r);break;case"webglcontextrestored":S(r);break;default:t.apply(e,arguments)}}}(e),e.loseContext=function(){if(!m){for(m=!0,v=0,++h;c.getError(););n(),E[c.CONTEXT_LOST_WEBGL]=!0;var t=a("context lost"),r=d.slice();setTimeout(function(){for(var n=0;n<r.length;++n)r[n](t);_>=0&&setTimeout(function(){e.restoreContext()},_)},0)}},e.restoreContext=function(){m&&f.length&&setTimeout(function(){if(!y)throw"can not restore. webglcontestlost listener did not call event.preventDefault";i(),l(c),m=!1,b=0,y=!1;for(var e=f.slice(),t=a("context restored"),n=0;n<e.length;++n)e[n](t)},0)},e.loseContextInNCalls=function(e){if(m)throw"You can not ask a lost contet to be lost";v=b+e},e.getNumCalls=function(){return b},e.setRestoreTimeout=function(e){_=e},e}"undefined"==typeof window&&(window=t);var p=function(e){window.console&&window.console.log&&window.console.log(e)},d=function(e){window.console&&window.console.error?window.console.error(e):p(e)},f={enable:{1:{0:!0}},disable:{1:{0:!0}},getParameter:{1:{0:!0}},drawArrays:{3:{0:!0}},drawElements:{4:{0:!0,2:!0}},createShader:{1:{0:!0}},getShaderParameter:{2:{1:!0}},getProgramParameter:{2:{1:!0}},getShaderPrecisionFormat:{2:{0:!0,1:!0}},getVertexAttrib:{2:{1:!0}},vertexAttribPointer:{6:{2:!0}},bindTexture:{2:{0:!0}},activeTexture:{1:{0:!0}},getTexParameter:{2:{0:!0,1:!0}},texParameterf:{3:{0:!0,1:!0}},texParameteri:{3:{0:!0,1:!0,2:!0}},texImage2D:{9:{0:!0,2:!0,6:!0,7:!0},6:{0:!0,2:!0,3:!0,4:!0}},texSubImage2D:{9:{0:!0,6:!0,7:!0},7:{0:!0,4:!0,5:!0}},copyTexImage2D:{8:{0:!0,2:!0}},copyTexSubImage2D:{8:{0:!0}},generateMipmap:{1:{0:!0}},compressedTexImage2D:{7:{0:!0,2:!0}},compressedTexSubImage2D:{8:{0:!0,6:!0}},bindBuffer:{2:{0:!0}},bufferData:{3:{0:!0,2:!0}},bufferSubData:{3:{0:!0}},getBufferParameter:{2:{0:!0,1:!0}},pixelStorei:{2:{0:!0,1:!0}},readPixels:{7:{4:!0,5:!0}},bindRenderbuffer:{2:{0:!0}},bindFramebuffer:{2:{0:!0}},checkFramebufferStatus:{1:{0:!0}},framebufferRenderbuffer:{4:{0:!0,1:!0,2:!0}},framebufferTexture2D:{5:{0:!0,1:!0,2:!0}},getFramebufferAttachmentParameter:{3:{0:!0,1:!0,2:!0}},getRenderbufferParameter:{2:{0:!0,1:!0}},renderbufferStorage:{4:{0:!0,1:!0}},clear:{1:{0:{enumBitwiseOr:["COLOR_BUFFER_BIT","DEPTH_BUFFER_BIT","STENCIL_BUFFER_BIT"]}}},depthFunc:{1:{0:!0}},blendFunc:{2:{0:!0,1:!0}},blendFuncSeparate:{4:{0:!0,1:!0,2:!0,3:!0}},blendEquation:{1:{0:!0}},blendEquationSeparate:{2:{0:!0,1:!0}},stencilFunc:{3:{0:!0}},stencilFuncSeparate:{4:{0:!0,1:!0}},stencilMaskSeparate:{2:{0:!0}},stencilOp:{3:{0:!0,1:!0,2:!0}},stencilOpSeparate:{4:{0:!0,1:!0,2:!0,3:!0}},cullFace:{1:{0:!0}},frontFace:{1:{0:!0}},drawArraysInstancedANGLE:{4:{0:!0}},drawElementsInstancedANGLE:{5:{0:!0,2:!0}},blendEquationEXT:{1:{0:!0}}},h=null,m=null;return{init:e,mightBeEnum:r,glEnumToString:o,glFunctionArgToString:i,glFunctionArgsToString:a,makeDebugContext:u,makeLostContextSimulatingCanvas:c,resetToInitialState:l}}(),e.exports=WebGLDebugUtils}).call(t,n(34))},function(e,t){e.exports=function(e){return e.webpackPolyfill||(e.deprecate=function(){},e.paths=[],e.children||(e.children=[]),Object.defineProperty(e,"loaded",{enumerable:!0,get:function(){return e.l}}),Object.defineProperty(e,"id",{enumerable:!0,get:function(){return e.i}}),e.webpackPolyfill=1),e}},function(e,t){(function(t){e.exports=t}).call(t,{})},function(e,t){e.exports="precision highp float;\nvarying vec3 vnormal;\nvarying vec3 cameraDirection;\nvarying vec3 lightDirection;\nvarying vec2 texcoord;\nuniform float lightRatio;\nuniform sampler2D texture;\nuniform bool showSpinner;\nuniform float tick;\nuniform float spinnerSize;\nuniform vec4 bbox;\nuniform vec2 viewport;\nvoid main ()\n{\n  lowp vec3 col_1;\n  if (showSpinner) {\n    float tmpvar_2;\n    float tmpvar_3;\n    tmpvar_3 = (bbox.w * viewport.y);\n    tmpvar_2 = (1.0/((tmpvar_3 / 2.0)));\n    vec2 tmpvar_4;\n    tmpvar_4.x = ((texcoord.x - 0.5) * ((bbox.z * viewport.x) / tmpvar_3));\n    tmpvar_4.y = (texcoord.y - 0.5);\n    float tmpvar_5;\n    tmpvar_5 = (((spinnerSize * tmpvar_2) * 2.5) / 15.7);\n    float tmpvar_6;\n    tmpvar_6 = (((spinnerSize * tmpvar_2) * 6.75) / 15.7);\n    float tmpvar_7;\n    tmpvar_7 = sqrt(dot (tmpvar_4, tmpvar_4));\n    float tmpvar_8;\n    tmpvar_8 = (((spinnerSize * tmpvar_2) * 0.6) / 15.7);\n    float tmpvar_9;\n    tmpvar_9 = ((spinnerSize * tmpvar_2) / 15.7);\n    vec2 tmpvar_10;\n    float tmpvar_11;\n    tmpvar_11 = (tick * 0.00435);\n    tmpvar_10.x = sin(tmpvar_11);\n    tmpvar_10.y = cos(tmpvar_11);\n    vec2 tmpvar_12;\n    tmpvar_12 = normalize(tmpvar_10);\n    float tmpvar_13;\n    float x_14;\n    x_14 = (dot (tmpvar_4, tmpvar_12) / sqrt(dot (tmpvar_4, tmpvar_4)));\n    tmpvar_13 = (1.570796 - (sign(x_14) * (1.570796 - \n      (sqrt((1.0 - abs(x_14))) * (1.570796 + (abs(x_14) * (-0.2146018 + \n        (abs(x_14) * (0.08656672 + (abs(x_14) * -0.03102955)))\n      ))))\n    )));\n    float edge0_15;\n    edge0_15 = ((tmpvar_5 - tmpvar_8) - tmpvar_2);\n    float tmpvar_16;\n    tmpvar_16 = clamp (((tmpvar_7 - edge0_15) / (\n      (tmpvar_5 - tmpvar_8)\n     - edge0_15)), 0.0, 1.0);\n    float edge0_17;\n    edge0_17 = (tmpvar_5 + tmpvar_8);\n    float tmpvar_18;\n    tmpvar_18 = clamp (((tmpvar_7 - edge0_17) / (\n      ((tmpvar_5 + tmpvar_8) + tmpvar_2)\n     - edge0_17)), 0.0, 1.0);\n    float tmpvar_19;\n    tmpvar_19 = ((tmpvar_16 * (tmpvar_16 * \n      (3.0 - (2.0 * tmpvar_16))\n    )) * (1.0 - (tmpvar_18 * \n      (tmpvar_18 * (3.0 - (2.0 * tmpvar_18)))\n    )));\n    float edge0_20;\n    edge0_20 = ((tmpvar_6 - tmpvar_9) - tmpvar_2);\n    float tmpvar_21;\n    tmpvar_21 = clamp (((tmpvar_7 - edge0_20) / (\n      (tmpvar_6 - tmpvar_9)\n     - edge0_20)), 0.0, 1.0);\n    float edge0_22;\n    edge0_22 = (tmpvar_6 + tmpvar_9);\n    float tmpvar_23;\n    tmpvar_23 = clamp (((tmpvar_7 - edge0_22) / (\n      ((tmpvar_6 + tmpvar_9) + tmpvar_2)\n     - edge0_22)), 0.0, 1.0);\n    float tmpvar_24;\n    tmpvar_24 = ((tmpvar_21 * (tmpvar_21 * \n      (3.0 - (2.0 * tmpvar_21))\n    )) * (1.0 - (tmpvar_23 * \n      (tmpvar_23 * (3.0 - (2.0 * tmpvar_23)))\n    )));\n    vec2 tmpvar_25;\n    tmpvar_25.x = tmpvar_12.y;\n    tmpvar_25.y = -(tmpvar_12.x);\n    vec2 x_26;\n    x_26 = (tmpvar_4 - (tmpvar_25 * tmpvar_6));\n    float tmpvar_27;\n    tmpvar_27 = clamp (((\n      sqrt(dot (x_26, x_26))\n     - tmpvar_9) / (\n      (tmpvar_9 + tmpvar_2)\n     - tmpvar_9)), 0.0, 1.0);\n    float tmpvar_28;\n    tmpvar_28 = (1.0 - (tmpvar_27 * (tmpvar_27 * \n      (3.0 - (2.0 * tmpvar_27))\n    )));\n    vec2 tmpvar_29;\n    tmpvar_29.x = -(tmpvar_12.y);\n    tmpvar_29.y = tmpvar_12.x;\n    vec2 x_30;\n    x_30 = (tmpvar_4 - (tmpvar_29 * tmpvar_6));\n    float tmpvar_31;\n    tmpvar_31 = clamp (((\n      sqrt(dot (x_30, x_30))\n     - tmpvar_9) / (\n      (tmpvar_9 + tmpvar_2)\n     - tmpvar_9)), 0.0, 1.0);\n    float tmpvar_32;\n    tmpvar_32 = (1.0 - (tmpvar_31 * (tmpvar_31 * \n      (3.0 - (2.0 * tmpvar_31))\n    )));\n    float tmpvar_33;\n    tmpvar_33 = (max (tmpvar_19, tmpvar_24) * 0.5);\n    float tmpvar_34;\n    if ((tmpvar_13 < 1.570796)) {\n      tmpvar_34 = tmpvar_24;\n    } else {\n      tmpvar_34 = 0.0;\n    };\n    col_1 = mix (vec3(0.9453125, 0.9453125, 0.9453125), vec3(0.6015625, 0.65625, 0.6601562), max (max (tmpvar_33, tmpvar_34), max (\n      max (tmpvar_28, tmpvar_32)\n    , tmpvar_19)));\n  } else {\n    col_1 = texture2D (texture, texcoord).xyz;\n  };\n  lowp vec3 tmpvar_35;\n  vec3 I_36;\n  I_36 = -(lightDirection);\n  tmpvar_35 = (((\n    ((vec3(0.9, 0.9, 0.9) * col_1) + ((vec3(0.2, 0.2, 0.2) * clamp (\n      dot (vnormal, lightDirection)\n    , 0.0, 1.0)) * col_1))\n   + \n    (vec3(0.3, 0.3, 0.3) * pow (max (dot (\n      (I_36 - (2.0 * (dot (vnormal, I_36) * vnormal)))\n    , cameraDirection), 0.0), 5.0))\n  ) * lightRatio) + ((1.0 - lightRatio) * col_1));\n  mediump vec4 tmpvar_37;\n  tmpvar_37.w = 1.0;\n  tmpvar_37.xyz = tmpvar_35;\n  gl_FragColor = tmpvar_37;\n}\n\n"},function(e,t){e.exports="precision highp float;\nattribute vec3 vertex;\nattribute vec3 normal;\nattribute vec2 textureCoord;\nattribute float perspectiveCorrection;\nuniform mat3 u_matrix;\nuniform mat3 u_texMatrix;\nvarying vec3 vnormal;\nvarying vec3 lightDirection;\nvarying vec3 cameraDirection;\nvarying vec2 texcoord;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = vertex.xy;\n  vec3 tmpvar_2;\n  tmpvar_2.xy = (u_matrix * tmpvar_1).xy;\n  tmpvar_2.z = vertex.z;\n  vnormal = normal;\n  lightDirection = normalize((vec3(10.0, 5.0, 4.0) - tmpvar_2));\n  cameraDirection = normalize((vec3(0.0, 0.0, 1.0) - tmpvar_2));\n  vec3 tmpvar_3;\n  tmpvar_3.z = 1.0;\n  tmpvar_3.xy = textureCoord;\n  texcoord = (u_texMatrix * tmpvar_3).xy;\n  highp vec4 tmpvar_4;\n  tmpvar_4.xy = tmpvar_2.xy;\n  tmpvar_4.z = -(vertex.z);\n  tmpvar_4.w = perspectiveCorrection;\n  gl_Position = tmpvar_4;\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform vec4 u_color;\nvoid main ()\n{\n  gl_FragColor = u_color;\n}\n\n"},function(e,t){e.exports="attribute vec2 a_vertex;\nuniform mat3 u_displayMatrix;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = a_vertex;\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 1.0;\n  tmpvar_2.xyz = (u_displayMatrix * tmpvar_1);\n  gl_Position = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision mediump float;\nuniform sampler2D texture;\nvarying vec2 textureCoordinate;\nuniform float opacity;\nvoid main ()\n{\n  lowp vec4 tmpvar_1;\n  tmpvar_1 = texture2D (texture, textureCoordinate);\n  gl_FragColor = (tmpvar_1 * opacity);\n}\n\n"},function(e,t){e.exports="attribute vec2 vertex;\nuniform vec4 texCoords;\nuniform vec4 bbox;\nuniform vec2 viewport;\nvarying vec2 textureCoordinate;\nvoid main ()\n{\n  vec2 tmpvar_1;\n  tmpvar_1 = ((2.0 * bbox.xz) / viewport.x);\n  vec2 tmpvar_2;\n  tmpvar_2 = ((2.0 * bbox.yw) / viewport.y);\n  highp vec2 tmpvar_3;\n  tmpvar_3.x = ((tmpvar_1.x - 1.0) + (vertex.x * tmpvar_1.y));\n  tmpvar_3.y = ((1.0 - tmpvar_2.x) - (vertex.y * tmpvar_2.y));\n  vec2 tmpvar_4;\n  tmpvar_4.x = (texCoords.x + (vertex.x * texCoords.z));\n  tmpvar_4.y = (texCoords.y + (vertex.y * texCoords.w));\n  textureCoordinate = tmpvar_4;\n  highp vec4 tmpvar_5;\n  tmpvar_5.zw = vec2(0.0, 1.0);\n  tmpvar_5.xy = tmpvar_3;\n  gl_Position = tmpvar_5;\n}\n\n"},function(e,t){e.exports="#extension GL_OES_standard_derivatives : enable\nprecision highp float;\nuniform float opacity;\nuniform float strokeWidth;\nvarying vec4 vBC;\nvoid main ()\n{\n  vec4 tmpvar_1;\n  tmpvar_1.xyz = vec3(0.4627451, 0.6470588, 0.8);\n  tmpvar_1.w = opacity;\n  vec4 tmpvar_2;\n  tmpvar_2.xyz = vec3(0.4627451, 0.6470588, 0.8);\n  tmpvar_2.w = (opacity / 2.0);\n  vec4 tmpvar_3;\n  vec4 tmpvar_4;\n  tmpvar_4 = clamp ((vBC / (\n    (abs(dFdx(vBC)) + abs(dFdy(vBC)))\n   * strokeWidth)), 0.0, 1.0);\n  tmpvar_3 = (tmpvar_4 * (tmpvar_4 * (3.0 - \n    (2.0 * tmpvar_4)\n  )));\n  gl_FragColor = mix (tmpvar_1, tmpvar_2, min (min (tmpvar_3.x, tmpvar_3.y), min (tmpvar_3.z, tmpvar_3.w)));\n}\n\n"},function(e,t){e.exports="attribute vec2 vertex;\nattribute vec4 barycentric;\nuniform vec2 viewport;\nuniform vec4 bbox;\nvarying vec4 vBC;\nvoid main ()\n{\n  vec2 tmpvar_1;\n  tmpvar_1 = ((2.0 * bbox.xz) / viewport.x);\n  vec2 tmpvar_2;\n  tmpvar_2 = ((2.0 * bbox.yw) / viewport.y);\n  highp vec2 tmpvar_3;\n  tmpvar_3.x = ((tmpvar_1.x - 1.0) + (vertex.x * tmpvar_1.y));\n  tmpvar_3.y = ((1.0 - tmpvar_2.x) - (vertex.y * tmpvar_2.y));\n  vBC = barycentric;\n  highp vec4 tmpvar_4;\n  tmpvar_4.zw = vec2(0.0, 1.0);\n  tmpvar_4.xy = tmpvar_3;\n  gl_Position = tmpvar_4;\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform bool backFacing;\nvoid main ()\n{\n  if (backFacing) {\n    gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);\n  } else {\n    gl_FragColor = vec4(0.0, 1.0, 0.0, 1.0);\n  };\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform mat3 u_matrix;\nattribute vec3 vertex;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = vertex.xy;\n  vec3 tmpvar_2;\n  tmpvar_2.xy = (u_matrix * tmpvar_1).xy;\n  tmpvar_2.z = vertex.z;\n  highp vec4 tmpvar_3;\n  tmpvar_3.xy = tmpvar_2.xy;\n  tmpvar_3.z = (-(vertex.z) * 0.8);\n  tmpvar_3.w = (1.0 + (vertex.z * -0.2));\n  gl_Position = tmpvar_3;\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform vec4 u_color;\nuniform sampler2D u_texture;\nvarying vec2 v_texCoord;\nvoid main ()\n{\n  lowp vec4 tmpvar_1;\n  tmpvar_1.w = 1.0;\n  tmpvar_1.xyz = ((texture2D (u_texture, v_texCoord).xyz * u_color.w) + (u_color.xyz * u_color.w));\n  gl_FragColor = tmpvar_1;\n}\n\n"},function(e,t){e.exports="precision highp float;\nattribute vec2 a_vertex;\nattribute vec2 a_texCoord;\nuniform mat3 u_displayMatrix;\nvarying vec2 v_texCoord;\nvoid main ()\n{\n  v_texCoord = a_texCoord;\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = a_vertex;\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 1.0;\n  tmpvar_2.xyz = (u_displayMatrix * tmpvar_1);\n  gl_Position = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision mediump float;\nuniform sampler2D depthMapTexture;\nvarying vec2 v_shadowTexcoord;\nvarying vec2 v_shadowBlurCoords[8];\nvoid main ()\n{\n  lowp vec4 color_1;\n  color_1 = (texture2D (depthMapTexture, v_shadowBlurCoords[0]) * 0.04436833);\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[1]) * 0.07767442));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[2]) * 0.1158766));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[3]) * 0.1473081));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowTexcoord) * 0.1595769));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[4]) * 0.1473081));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[5]) * 0.1158766));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[6]) * 0.07767442));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[7]) * 0.04436833));\n  gl_FragColor = color_1;\n}\n\n"},function(e,t){e.exports="attribute vec3 vertex;\nvarying vec2 v_shadowTexcoord;\nvarying vec2 v_shadowBlurCoords[8];\nvoid main ()\n{\n  vec2 tmpvar_1;\n  tmpvar_1 = ((vertex.xy + vec2(1.0, 1.0)) / vec2(2.0, 2.0));\n  v_shadowTexcoord = tmpvar_1;\n  v_shadowBlurCoords[0] = (tmpvar_1 + vec2(0.0, -0.016));\n  v_shadowBlurCoords[1] = (tmpvar_1 + vec2(0.0, -0.012));\n  v_shadowBlurCoords[2] = (tmpvar_1 + vec2(0.0, -0.008));\n  v_shadowBlurCoords[3] = (tmpvar_1 + vec2(0.0, -0.004));\n  v_shadowBlurCoords[4] = (tmpvar_1 + vec2(0.0, 0.004));\n  v_shadowBlurCoords[5] = (tmpvar_1 + vec2(0.0, 0.008));\n  v_shadowBlurCoords[6] = (tmpvar_1 + vec2(0.0, 0.012));\n  v_shadowBlurCoords[7] = (tmpvar_1 + vec2(0.0, 0.016));\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 1.0;\n  tmpvar_2.xy = vertex.xy;\n  tmpvar_2.z = -(vertex.z);\n  gl_Position = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision highp float;\nvoid main ()\n{\n  highp float tmpvar_1;\n  tmpvar_1 = abs(gl_FragCoord.z);\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 0.25;\n  tmpvar_2.x = tmpvar_1;\n  tmpvar_2.y = tmpvar_1;\n  tmpvar_2.z = tmpvar_1;\n  gl_FragColor = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision highp float;\nattribute vec3 vertex;\nuniform mat3 u_matrix;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = vertex.xy;\n  vec3 tmpvar_2;\n  tmpvar_2.xy = (u_matrix * tmpvar_1).xy;\n  tmpvar_2.z = vertex.z;\n  highp vec4 tmpvar_3;\n  tmpvar_3.xy = tmpvar_2.xy;\n  tmpvar_3.z = (-(vertex.z) * 0.7);\n  tmpvar_3.w = (1.0 + (vertex.z * -0.35));\n  gl_Position = tmpvar_3;\n}\n\n"},,function(e,t,n){"use strict";function r(){return window.innerWidth<470&&window.innerWidth>window.innerHeight}t.__esModule=!0,t.ReadMorePlugin=void 0;var o=n(773),i=n(772),a=n(2),s=babelHelpers.interopRequireDefault(a),u=t.ReadMorePlugin=function(){function e(t){var n=t.tracker,r=t.show,o=void 0===r?e.RELATED:r,i=t.alwaysOverlay,a=void 0!==i&&i,s=t.hideWhenNotInFullscreen,u=void 0!==s&&s,l=t.openInNewTab,c=void 0===l||l;babelHelpers.classCallCheck(this,e),this.showMore=!1,this.showAd=!1,this.tracker=n,this.show=o,this.alwaysOverlay=a,this.hideWhenNotInFullscreen=u,this.openInNewTab=c,this.showOwnDocuments=this.show===e.OWN_DOCUMENTS}return e.prototype.load=function(e,t,n,r,o,a){var s=this;return this.showMore=this.shouldShowMore(o,a),this.showOwnDocuments=this.shouldShowOwnDocuments(o),this.showAd=!a,this.publicationId=n,this.username=r,this.showMore?(0,i.loadStreamState)(e,t,n,r,this.showOwnDocuments).then(function(e){return s.streamState=e,!0}):Promise.resolve(!1)},e.prototype.loadComplete=function(){return void 0!==this.streamState},e.prototype.shouldShowOwnDocuments=function(t){return this.show===e.OWN_DOCUMENTS&&t},e.prototype.shouldShowRelated=function(t,n){return this.show===e.RELATED||this.show===e.RELATED_FOR_FREE_PUBLISHERS&&!n||this.show===e.OWN_DOCUMENTS&&!t&&!n},e.prototype.shouldShowMore=function(e,t){return this.shouldShowRelated(e,t)||this.shouldShowOwnDocuments(e)},e.prototype.shouldAlwaysBeOverlay=function(){return this.alwaysOverlay},e.prototype.hasStreamData=function(){return this.loadComplete()&&this.streamState.buttonStream&&this.streamState.buttonStream.length>0},e.prototype.shouldRenderButton=function(e,t,n){return!(this.hideWhenNotInFullscreen&&!n)&&(this.hasStreamData()&&this.shouldShowMore(e,t))},e.prototype.shouldRenderExitFullscreenOverlay=function(e,t){return!this.hideWhenNotInFullscreen&&this.hasStreamData()&&this.shouldShowMore(e,t)},e.prototype.getButtonUnreadCount=function(){var e=void 0;return e=void 0!==this.unreadCount?this.unreadCount:this.streamState&&this.streamState.buttonStream?this.streamState.buttonStream.length:void 0,e&&r()&&(e=Math.min(e,3)),e},e.prototype.clearButtonUnreadCount=function(){this.unreadCount=0},e.prototype.render=function(e,t,n,i,a,u){return s.default.createElement(o.MoreContent,{config:e,debug:t,exitedFullscreen:n,isLoggedIn:u,isVisible:i,openInNewTab:this.openInNewTab,publicationId:this.publicationId,shouldHackStreamCount:r(),showAd:this.showAd,showAsOverlay:a,showMore:this.showMore,showOwnDocuments:this.showOwnDocuments,streamState:this.streamState,tracker:this.tracker,username:this.username})},e}();u.OWN_DOCUMENTS="READ_MORE_PlUGIN_OWN_DOCUMENTS",u.RELATED_FOR_FREE_PUBLISHERS="READ_MORE_PlUGIN_RELATED_FOR_FREE_PUBLISHERS",u.RELATED="READ_MORE_PlUGIN_RELATED"},function(e,t,n){var r;/*!
 * jsUri
 * https://github.com/derek-watson/jsUri
 *
 * Copyright 2013, Derek Watson
 * Released under the MIT license.
 *
 * Includes parseUri regular expressions
 * http://blog.stevenlevithan.com/archives/parseuri
 * Copyright 2007, Steven Levithan
 * Released under the MIT license.
 */
!function(o){function i(e){return e&&(e=e.toString().replace(l.pluses,"%20"),e=decodeURIComponent(e)),e}function a(e){var t=l.uri_parser,n=["source","protocol","authority","userInfo","user","password","host","port","isColonUri","relative","path","directory","file","query","anchor"],r=t.exec(e||""),o={};return n.forEach(function(e,t){o[e]=r[t]||""}),o}function s(e){var t,n,r,o,a,s,u,c=[];if(void 0===e||null===e||""===e)return c;for(0===e.indexOf("?")&&(e=e.substring(1)),n=e.toString().split(l.query_separator),t=0,u=n.length;t<u;t++)r=n[t],0!==(o=r.indexOf("="))&&(a=i(r.substring(0,o)),s=i(r.substring(o+1)),c.push(o===-1?[r,null]:[a,s]));return c}function u(e){this.uriParts=a(e),this.queryPairs=s(this.uriParts.query),this.hasAuthorityPrefixUserPref=null}var l={starts_with_slashes:/^\/+/,ends_with_slashes:/\/+$/,pluses:/\+/g,query_separator:/[&;]/,uri_parser:/^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@\/]*)(?::([^:@]*))?)?@)?(\[[0-9a-fA-F:.]+\]|[^:\/?#]*)(?::(\d+|(?=:)))?(:)?)((((?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/};Array.prototype.forEach||(Array.prototype.forEach=function(e,t){var n,r;if(null==this)throw new TypeError(" this is null or not defined");var o=Object(this),i=o.length>>>0;if("function"!=typeof e)throw new TypeError(e+" is not a function");for(arguments.length>1&&(n=t),r=0;r<i;){var a;r in o&&(a=o[r],e.call(n,a,r,o)),r++}}),["protocol","userInfo","host","port","path","anchor"].forEach(function(e){u.prototype[e]=function(t){return void 0!==t&&(this.uriParts[e]=t),this.uriParts[e]}}),u.prototype.hasAuthorityPrefix=function(e){return void 0!==e&&(this.hasAuthorityPrefixUserPref=e),null===this.hasAuthorityPrefixUserPref?this.uriParts.source.indexOf("//")!==-1:this.hasAuthorityPrefixUserPref},u.prototype.isColonUri=function(e){if(void 0===e)return!!this.uriParts.isColonUri;this.uriParts.isColonUri=!!e},u.prototype.query=function(e){var t,n,r,o="";for(void 0!==e&&(this.queryPairs=s(e)),t=0,r=this.queryPairs.length;t<r;t++)n=this.queryPairs[t],o.length>0&&(o+="&"),null===n[1]?o+=n[0]:(o+=n[0],o+="=",void 0!==n[1]&&(o+=encodeURIComponent(n[1])));return o.length>0?"?"+o:o},u.prototype.getQueryParamValue=function(e){var t,n,r;for(n=0,r=this.queryPairs.length;n<r;n++)if(t=this.queryPairs[n],e===t[0])return t[1]},u.prototype.getQueryParamValues=function(e){var t,n,r,o=[];for(t=0,r=this.queryPairs.length;t<r;t++)n=this.queryPairs[t],e===n[0]&&o.push(n[1]);return o},u.prototype.deleteQueryParam=function(e,t){var n,r,o,a,s,u=[];for(n=0,s=this.queryPairs.length;n<s;n++)r=this.queryPairs[n],o=i(r[0])===i(e),a=r[1]===t,(1!==arguments.length||o)&&(2!==arguments.length||o&&a)||u.push(r);return this.queryPairs=u,this},u.prototype.addQueryParam=function(e,t,n){return 3===arguments.length&&n!==-1?(n=Math.min(n,this.queryPairs.length),this.queryPairs.splice(n,0,[e,t])):arguments.length>0&&this.queryPairs.push([e,t]),this},u.prototype.hasQueryParam=function(e){var t,n=this.queryPairs.length;for(t=0;t<n;t++)if(this.queryPairs[t][0]==e)return!0;return!1},u.prototype.replaceQueryParam=function(e,t,n){var r,o,a=-1,s=this.queryPairs.length;if(3===arguments.length){for(r=0;r<s;r++)if(o=this.queryPairs[r],i(o[0])===i(e)&&decodeURIComponent(o[1])===i(n)){a=r;break}a>=0&&this.deleteQueryParam(e,i(n)).addQueryParam(e,t,a)}else{for(r=0;r<s;r++)if(o=this.queryPairs[r],i(o[0])===i(e)){a=r;break}this.deleteQueryParam(e),this.addQueryParam(e,t,a)}return this},["protocol","hasAuthorityPrefix","isColonUri","userInfo","host","port","path","query","anchor"].forEach(function(e){u.prototype["set"+e.charAt(0).toUpperCase()+e.slice(1)]=function(t){return this[e](t),this}}),u.prototype.scheme=function(){var e="";return this.protocol()?(e+=this.protocol(),this.protocol().indexOf(":")!==this.protocol().length-1&&(e+=":"),e+="//"):this.hasAuthorityPrefix()&&this.host()&&(e+="//"),e},u.prototype.origin=function(){var e=this.scheme();return this.userInfo()&&this.host()&&(e+=this.userInfo(),this.userInfo().indexOf("@")!==this.userInfo().length-1&&(e+="@")),this.host()&&(e+=this.host(),(this.port()||this.path()&&this.path().substr(0,1).match(/[0-9]/))&&(e+=":"+this.port())),e},u.prototype.addTrailingSlash=function(){var e=this.path()||"";return"/"!==e.substr(-1)&&this.path(e+"/"),this},u.prototype.toString=function(){var e,t=this.origin();return this.isColonUri()?this.path()&&(t+=":"+this.path()):this.path()?(e=this.path(),l.ends_with_slashes.test(t)||l.starts_with_slashes.test(e)?(t&&t.replace(l.ends_with_slashes,"/"),e=e.replace(l.starts_with_slashes,"/")):t+="/",t+=e):this.host()&&(this.query().toString()||this.anchor())&&(t+="/"),this.query().toString()&&(t+=this.query().toString()),this.anchor()&&(0!==this.anchor().indexOf("#")&&(t+="#"),t+=this.anchor()),t},u.prototype.clone=function(){return new u(this.toString())},void 0!==(r=function(){return u}.call(t,n,t,e))&&(e.exports=r)}()},,function(e,t,n){"use strict";function r(e,t){return Math.floor(Math.random()*(t-e+1)+e)}t.__esModule=!0,t.Ad=void 0;var o=n(2),i=babelHelpers.interopRequireDefault(o),a=n(10),s=babelHelpers.interopRequireDefault(a),u=n(302),l=babelHelpers.interopRequireWildcard(u),c=t.Ad=function(e){function t(){babelHelpers.classCallCheck(this,t);var n=babelHelpers.possibleConstructorReturn(this,e.call(this));return n.adLoaded=!1,n.randomBucketInt=r(1,10),n}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){this.props.isVisible&&!this.adLoaded&&this.loadAd()},t.prototype.loadAd=function(){var e=[["pageType","embed"],["isLoggedIn",this.props.isLoggedIn.toString()],["fullUrl","undefined"!=typeof window?window.document.location.href:""],["publicationId",this.props.publicationId],["ownerUsername",this.props.publisherUsername],["randomBucket",this.randomBucketInt],["isDevelopmentTest",(!1).toString()]],t=this.props.fallbackCover;t&&(e.push(["fallbackLink",encodeURIComponent(t.linkUrl)]),e.push(["fallbackCover",encodeURIComponent(t.imageUrl)])),this.adElement=document.createElement("div"),this.adContainer.appendChild(this.adElement),this.ad=l.create({rootElm:this.adElement,dfpTargeting:e,adProviderConfig:{network:"/30443627/Embed_ReadMore",sizes:[[1,1]]},isProductionEnv:!0,trackingKey:"ads-widget.Embed_ReadMore"}),this.ad.show(),this.adLoaded=!0},t.prototype.render=function(){var e=this;return i.default.createElement("div",{className:"item-container stream-list__item"},i.default.createElement("div",{className:"ad-container",ref:function(t){e.adContainer=t}}))},t}(i.default.Component);c.displayName="Ad",c.propTypes={fallbackCover:s.default.object,isLoggedIn:s.default.bool.isRequired,isVisible:s.default.bool.isRequired,publicationId:s.default.string.isRequired,publisherUsername:s.default.string.isRequired},c.defaultProps={}},function(e,t,n){"use strict";function r(e){for(var t=e+"=",n=document.cookie.split(";"),r=0;r<n.length;r++)try{var o=decodeURIComponent(n[r]).trim();if(0===o.indexOf(t))return o.substring(t.length,o.length)}catch(e){continue}return null}function o(){var e=r("issuu.comstream.debug.style");return!!window.ISSUU_STREAM_DEBUG||null!==e}t.__esModule=!0,t.debugStreams=o},function(e,t,n){"use strict";t.__esModule=!0,t.Header=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(20),u=babelHelpers.interopRequireDefault(s),l=n(46),c=babelHelpers.interopRequireDefault(l),p=t.Header=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e,t){return!((0,c.default)(this.props,e)&&(0,c.default)(this.state,t))},t.prototype.render=function(){var e=(0,u.default)("readmore-header",{"readmore-header--large":!!this.props.large,"readmore-header--one-line":!!this.props.oneLine});return o.default.createElement("div",{className:e},o.default.createElement("span",{className:"readmore-header__text"},"Here's more to read..."))},t}(r.Component);p.displayName="Header",p.propTypes={config:a.default.object.isRequired,large:a.default.bool,oneLine:a.default.bool}},function(e,t,n){"use strict";function r(e){return fetch(e).then(function(e){return e.ok?e.json().then(function(e){return"fail"===e.rsp.stat?Promise.reject():e.rsp._content.stream}):Promise.reject()})}function o(e,t,n){return r(""+e+t+"/call/stream/web/embed/read_more_by_button_click/initial?publicationId="+n+"&seed=42&pageSize=8")}function i(e,t,n){return r(""+e+t+"/call/stream/web/embed/read_more_exit_from_fullscreen/initial?publicationId="+n+"&seed=42&pageSize=8")}function a(e,t,n,o){return r(""+e+t+"/call/stream/web/embed/read_more_from_paying_publisher/initial?ownerUsername="+o+"&publicationId="+n+"&pageSize=8")}function s(e,t,n,o){return r(""+e+t+"/call/stream/web/embed/read_more_from_paying_publisher_from_fullscreen/initial?ownerUsername="+o+"&publicationId="+n+"&pageSize=8")}function u(e,t,n,r,u){var c=null,p=null;return u?(c=a(e,t,n,r),p=s(e,t,n,r)):(c=o(e,t,n),p=i(e,t,n)),Promise.all([c,p]).then(function(e){return new l.StreamState(e[0],e[1])})}t.__esModule=!0,t.loadStreamState=u;var l=n(775)},function(e,t,n){"use strict";t.__esModule=!0,t.MoreContent=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(774),u=n(771),l=n(770),c=n(20),p=babelHelpers.interopRequireDefault(c),d=t.MoreContent=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onClickStreamItem=function(e,t){r.props.tracker.moreContentDocumentClick({revisionId:e.content.revisionId,publicationId:e.content.publicationId,ownerUsername:e.content.ownerUsername,publicationName:e.content.publicationName,streamOrigin:e.origin,streamRanking:t})},r.onClickSeeMore=function(){r.props.tracker.monitor({type:"reader3-readmore-seemore",click:1,msToClick:Date.now()-r._visibilityTime})},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this._streamDebugMode=(0,l.debugStreams)()},t.prototype.componentDidUpdate=function(e,t){!e.isVisible&&this.props.isVisible&&this.trackOnVisible(this.decideStream())},t.prototype.trackOnVisible=function(e){var t=this;e.map(function(e,n){t.props.tracker.moreContentDocumentShow({revisionId:e.content.revisionId,publicationId:e.content.publicationId,ownerUsername:e.content.ownerUsername,publicationName:e.content.publicationName,pageNumber:1,streamOrigin:e.origin,streamRanking:n})}),this.showReadmoreButton(e)&&this.props.tracker.monitorBatched({type:"reader3-readmore-seemore",impression:1}),this.showHeader(e)&&this.props.tracker.monitorBatched({type:"reader3-readmore-logo",impression:1}),this._visibilityTime=Date.now()},t.prototype.decideStream=function(){if(!this.props.streamState)return[];var e=this.props.exitedFullscreen?this.props.streamState.exitFullscreenStream:this.props.streamState.buttonStream;return this.props.shouldHackStreamCount?e.slice(0,3):e},t.prototype.showHeader=function(e){return this.props.showAsOverlay||e.length>1},t.prototype.showReadmoreButton=function(e){return 4===e.length&&(!this.props.showAsOverlay||window.innerHeight>400)},t.prototype.seeMoreUrl=function(){return this.props.showOwnDocuments&&this.props.username?""+this.props.config.getScheme()+this.props.config.hosts.main+"/"+this.props.username:""+this.props.config.getScheme()+this.props.config.hosts.main+"/explore"},t.prototype.render=function(){var e=this.decideStream();if(!e||0===e.length||!this.props.showMore)return null;var t=window.innerWidth<window.innerHeight,n=t&&this.props.showAsOverlay,r=this.seeMoreUrl(),i=(0,p.default)("readmore",{"readmore--overlay":this.props.showAsOverlay,"readmore--overlay-landscape":this.props.showAsOverlay&&!t,"readmore--overlay-portrait":this.props.showAsOverlay&&t,"readmore--dropdown-4-items":!this.props.showAsOverlay&&4===e.length,"readmore--dropdown-3-items":!this.props.showAsOverlay&&3===e.length,"readmore--dropdown-2-items":!this.props.showAsOverlay&&2===e.length,"readmore--dropdown-1-items":!this.props.showAsOverlay&&1===e.length}),a=this.props.openInNewTab?"_blank":"_top";return o.default.createElement("div",{className:i},this.showHeader(e)&&o.default.createElement(u.Header,{config:this.props.config,large:this.props.showAsOverlay&&window.innerHeight>360&&!t,oneLine:!this.props.showAsOverlay}),o.default.createElement(s.StreamList,{animate:!n,config:this.props.config,debug:this.props.debug||this._streamDebugMode,isLoggedIn:this.props.isLoggedIn,isVisible:this.props.isVisible,onClickElement:this.onClickStreamItem,openInNewTab:this.props.openInNewTab,publicationId:this.props.publicationId,publisherUsername:this.props.username,showAd:this.props.showAd,showAsColumns:n,stream:e}),this.showReadmoreButton(e)&&o.default.createElement("div",{className:"readmore__see-more-wrapper"},o.default.createElement("a",{className:"readmore__see-more",href:r,target:a,onClick:this.onClickSeeMore},"See more on issuu")))},t}(r.Component);d.displayName="MoreContent",d.propTypes={config:a.default.object.isRequired,debug:a.default.bool,exitedFullscreen:a.default.bool.isRequired,isLoggedIn:a.default.bool.isRequired,isVisible:a.default.bool.isRequired,openInNewTab:a.default.bool.isRequired,publicationId:a.default.string.isRequired,shouldHackStreamCount:a.default.bool,showAd:a.default.bool.isRequired,showAsOverlay:a.default.bool.isRequired,showMore:a.default.bool.isRequired,showOwnDocuments:a.default.bool.isRequired,streamState:a.default.object,tracker:a.default.object.isRequired,username:a.default.string.isRequired}},function(e,t,n){"use strict";t.__esModule=!0,t.StreamList=void 0;var r=n(2),o=babelHelpers.interopRequireDefault(r),i=n(10),a=babelHelpers.interopRequireDefault(i),s=n(20),u=babelHelpers.interopRequireDefault(s),l=n(769),c=t.StreamList=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onClickStreamItem=function(e,t){r.props.onClickElement(e,t),r.storeOriginStreamItem(e,t)},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.componentWillUpdate=function(e,t){!this.props.isVisible&&e.isVisible&&e.animate?this.refs.stream.classList.add("stream-list--animate"):this.props.isVisible&&!e.isVisible&&this.refs.stream.classList.remove("stream-list--animate")},t.prototype.storeOriginStreamItem=function(e,t){var n="tracking."+e.content.publicationId+".";try{for(var r=Object.keys(window.localStorage),o=Array.isArray(r),i=0,r=o?r:r[Symbol.iterator]();;){var a;if(o){if(i>=r.length)break;a=r[i++]}else{if(i=r.next(),i.done)break;a=i.value}var s=a;s.startsWith("tracking.")&&s.endsWith("__maxAge__")&&window.localStorage.getItem(s)<Date.now()&&(window.localStorage.removeItem(s),window.localStorage.removeItem(s.slice(0,-"__maxAge__".length)))}}catch(e){}var u=(new Date).getTime()+12e4;try{window.localStorage.setItem(n+"stream-origin",e.origin),window.localStorage.setItem(n+"stream-origin__maxAge__",u),window.localStorage.setItem(n+"stream-ranking",t),window.localStorage.setItem(n+"stream-ranking__maxAge__",u)}catch(e){}},t.prototype._documentPageUrl=function(e,t){var n=""+this.props.config.getScheme()+this.props.config.hosts.main+"/"+e.content.ownerUsername+"/docs/"+e.content.publicationName,r="?streamOrigin="+encodeURIComponent(e.origin.join(";"))+"&streamRanking="+t;return n.toLowerCase()+r},t.prototype._imgUrl=function(e){var t=e.content.revisionId+"-"+e.content.publicationId;return""+this.props.config.getScheme()+this.props.config.hosts.image+"/"+t+"/jpg/page_1_thumb_large.jpg"},t.prototype._getStreamWithAds=function(e,t){var n=e.slice();return n.splice(t,1,{isAd:!0}),n},t.prototype._getCoverMarkup=function(e,t){var n=this,r=e.content.height/e.content.width,i=e.content.revisionId+"-"+e.content.publicationId,a=this._imgUrl(e),s=this._documentPageUrl(e,t),u={backgroundImage:"url("+a+")"},l=this.props.openInNewTab?"_blank":"_top",c=null;return this.props.debug&&(u.border="5px solid "+e.debug_info.color,c=o.default.createElement("span",{className:"stream-list__debug"},e.origin.join(";"))),o.default.createElement("a",{key:i,className:"stream-list__item stream-list__cover",href:s,style:u,target:l,title:e.content.title,onClick:function(r){return n.onClickStreamItem(e,t)}},c,o.default.createElement("div",{className:"stream-list__item-aspect",style:{paddingTop:100*r+"%"}}))},t.prototype.render=function(){var e=this,t=this.props.showAsColumns&&2!==this.props.stream.length,n=(0,u.default)("stream-list",{"stream-list--columns":t,"stream-list--shelf":!t}),r=this.props.stream.length-1,i=this.props.showAd?this._getStreamWithAds(this.props.stream,r):this.props.stream;return o.default.createElement("div",{ref:"stream",className:n},i.map(function(t,n){return t.isAd?o.default.createElement(l.Ad,{key:"ad-key-"+r,isVisible:e.props.isVisible,fallbackCover:{linkUrl:e._documentPageUrl(e.props.stream[r],1),imageUrl:e._imgUrl(e.props.stream[r])},isLoggedIn:e.props.isLoggedIn,publicationId:e.props.publicationId,publisherUsername:e.props.publisherUsername}):e._getCoverMarkup(t,n)}))},t}(r.Component);c.displayName="StreamList",c.propTypes={animate:a.default.bool,config:a.default.object.isRequired,debug:a.default.bool,isLoggedIn:a.default.bool.isRequired,isVisible:a.default.bool,onClickElement:a.default.func.isRequired,openInNewTab:a.default.bool.isRequired,publicationId:a.default.string.isRequired,publisherUsername:a.default.string.isRequired,showAd:a.default.bool.isRequired,showAsColumns:a.default.bool.isRequired,stream:a.default.array.isRequired}},function(e,t,n){"use strict";t.__esModule=!0;t.StreamState=function e(t,n){babelHelpers.classCallCheck(this,e),this.buttonStream=t,this.exitFullscreenStream=n}},,function(e,t,n){"use strict";function r(){return window.FEATURE_TEST?"http://":"//"}var o=n(85),i=babelHelpers.interopRequireDefault(o),a=n(767),s=babelHelpers.interopRequireDefault(a),u=n(358),l=n(618),c=n(805),p=babelHelpers.interopRequireWildcard(c),d=n(766),f=n(92),h=n(806),m=n(804);if(!(0,n(807).isValidUsage)())throw new Error("Embed preview can only be used inside an iframe, which is hosted on *.issuu.com");var g=Date.now(),v=document.getElementById("app"),b=new s.default(document.location.toString()),y=b.getQueryParamValue("u"),_=b.getQueryParamValue("d"),E=parseInt(b.getQueryParamValue("p"),10)||1,w=(0,h.sessionId)();f.RavenConfiguration.install({sessionId:w,extraContext:{username:y,documentName:_,initialPageNumber:E,hostUrl:document.location.toString(),hostReferrer:document.referrer.toString()},tagsContext:{embed:"embed_wizard"}});try{document.domain=(document.domain||"").split(".").slice(-2).join(".")}catch(e){}var S=new l.Tracker({post:function(e,t,n){},handleError:function(e){(0,f.captureException)(e,{fingerprint:["issuu-frontend-tracking"],level:"warning",tags:{errorOrigin:"tracker"}})},getWidth:function(){return window.innerWidth},getHeight:function(){return window.innerHeight},getUsername:function(){try{return window.parent.document.cookie.match(/\bsite.model.username=([^;]+);/)[1]}catch(e){return null}},getLocation:function(){try{return window.parent.document.location.toString()}catch(e){return null}},getReferrer:function(){try{return window.parent.document.referrer.toString()}catch(e){return null}},getSource:function(){return"internal"},getOrigin:function(){return"reader3-v1.0.1074_embedpreview-v1.0.1074"},getLanguage:function(){return"en"},setTimeout:function(e,t){return window.setTimeout(e,t)},clearTimeout:function(e){return window.clearTimeout(e)},setInterval:function(e,t){return window.setInterval(e,t)},clearInterval:function(e){return window.clearInterval(e)},nagleTimeout:1500});window.ISSUU_READER_ARGUMENTS={tracker:S};var x=(0,u.createReader)({document:{username:y,name:_,initialPageNumber:E},network:{hosts:{api:"api.issuu.com",layers:"layers.isu.pub",main:"issuu.com",image:"image.isu.pub",photo:"photo.isu.pub",publication:"publication.isu.pub"},imagePath:b.getQueryParamValue("image_path"),getScheme:r},features:{controls:[{type:u.readerArgs.INFO_DIALOG_TYPE},{type:u.readerArgs.DOWNLOAD_TYPE},{type:u.readerArgs.SHARE_DIALOG_TYPE},{type:u.readerArgs.NAVIGATION_ARROWS_TYPE},{type:u.readerArgs.LINKS_TYPE},{type:u.readerArgs.ZOOM_TYPE},{type:u.readerArgs.FULLSCREEN_TYPE,kind:u.readerArgs.FULLSCREEN_KIND.NORMAL,overlayOnSmallReaders:!0,showButtons:u.readerArgs.FULLSCREEN_BUTTON.ALWAYS},{type:u.readerArgs.ISSUU_BRANDING_TYPE,kind:u.readerArgs.ISSUU_BRANDING_KIND.LANDING_PAGE}],allowUIToOverlayCover:!1,autoFlip:!1,backgroundColor:"rgba(0, 0, 0, 0)",disableLicenseCheck:!0,showControlsUntilFirstInteraction:!0,readModeRules:{defaultMode:u.readerArgs.READ_MODE.DOUBLE_PAGE_SPREAD,responsiveModeWhen:u.readerArgs.READ_MODE.RESPONSIVE.HANDHELD_IN_PORTRAIT_FULLSCREEN}},isLoggedIn:!1,trackerConfig:{streamData:function(){var e=p.parse(document.location.search),t=null,n=null;return e.streamOrigin&&e.streamRanking&&(t=e.streamOrigin.split(";"),n=parseInt(e.streamRanking,10)),{origin:t,ranking:n}}(),startTrackingOnLoad:!0,loadStartTimestamp:g,sessionId:w,isEmbed:!0},tracker:S,readMorePlugin:new d.ReadMorePlugin({tracker:S,show:d.ReadMorePlugin.RELATED_FOR_FREE_PUBLISHERS,alwaysOverlay:!0}),isFeatureTest:!!window.FEATURE_TEST});i.default.render(x.reader,v),(0,m.setup)(x.api,S)},,,,,,,,,,,,function(e,t){},,,,,,,,,,,,,,,function(e,t,n){"use strict";function r(e){try{window.parent.postMessage(e,"*")}catch(e){}}function o(e,t){var n=document.getElementById("poweredBy"),o=document.getElementById("app");window.addEventListener("message",function(r){"preview"===r.data.type&&(e.embedPreview(r.data,new i.ReadMorePlugin({tracker:t,show:r.data.proSidebarEnabled?i.ReadMorePlugin.OWN_DOCUMENTS:i.ReadMorePlugin.RELATED_FOR_FREE_PUBLISHERS,alwaysOverlay:!0})),r.data.showIssuuBranding?(n.style.display="flex",o.style.height="calc(100% - 25px)"):(n.style.display="none",o.style.height="100%"))},!1),e.setCallback("ON_DOCUMENT_LOAD_EVENT",function(){r({type:"documentLoaded"})})}t.__esModule=!0,t.setup=void 0;var i=n(766);t.setup=o},function(e,t,n){"use strict";function r(e){var t={};return e?(e.slice(1,e.length).split("&").map(function(e){return e.split("=")}).forEach(function(e){t[e[0]]=decodeURIComponent(e[1])}),t):t}function o(e){var t=Object.keys(e).filter(function(t){return void 0!==e[t]}).map(function(t){return t+"="+encodeURIComponent(e[t])}).join("&");return t?"?"+t:""}t.__esModule=!0,t.parse=r,t.format=o},function(e,t,n){"use strict";function r(e){return Math.floor(e*Math.random())}function o(){for(var e="abcdefghijklmnopqrstuvwxyz0123456789",t="",n=0;n<12;n++)t+=e.charAt(r(e.length));return t}t.__esModule=!0,t.sessionId=o},function(e,t,n){"use strict";function r(){return parent!==window&&/https?:\/\/(.*\.)?t?issuu\.com(:\d+)?\//.test(document.referrer)}t.__esModule=!0,t.isValidUsage=r},,,,,,,,,,,,function(e,t,n){n(301),n(192),n(191),n(777),e.exports=n(789)}]);
//# sourceMappingURL=http://sourcemaps.issuu.com/issuu-reader3-embed-files/1074/embed-preview.js.map