(function (global) {
  var babelHelpers = global.babelHelpers = {};
  babelHelpers.typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  babelHelpers.jsx = function () {
    var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7;
    return function createRawReactElement(type, props, key, children) {
      var defaultProps = type && type.defaultProps;
      var childrenLength = arguments.length - 3;

      if (!props && childrenLength !== 0) {
        props = {};
      }

      if (props && defaultProps) {
        for (var propName in defaultProps) {
          if (props[propName] === void 0) {
            props[propName] = defaultProps[propName];
          }
        }
      } else if (!props) {
        props = defaultProps || {};
      }

      if (childrenLength === 1) {
        props.children = children;
      } else if (childrenLength > 1) {
        var childArray = Array(childrenLength);

        for (var i = 0; i < childrenLength; i++) {
          childArray[i] = arguments[i + 3];
        }

        props.children = childArray;
      }

      return {
        $$typeof: REACT_ELEMENT_TYPE,
        type: type,
        key: key === undefined ? null : '' + key,
        ref: null,
        props: props,
        _owner: null
      };
    };
  }();

  babelHelpers.asyncIterator = function (iterable) {
    if (typeof Symbol === "function") {
      if (Symbol.asyncIterator) {
        var method = iterable[Symbol.asyncIterator];
        if (method != null) return method.call(iterable);
      }

      if (Symbol.iterator) {
        return iterable[Symbol.iterator]();
      }
    }

    throw new TypeError("Object is not async iterable");
  };

  babelHelpers.asyncGenerator = function () {
    function AwaitValue(value) {
      this.value = value;
    }

    function AsyncGenerator(gen) {
      var front, back;

      function send(key, arg) {
        return new Promise(function (resolve, reject) {
          var request = {
            key: key,
            arg: arg,
            resolve: resolve,
            reject: reject,
            next: null
          };

          if (back) {
            back = back.next = request;
          } else {
            front = back = request;
            resume(key, arg);
          }
        });
      }

      function resume(key, arg) {
        try {
          var result = gen[key](arg);
          var value = result.value;

          if (value instanceof AwaitValue) {
            Promise.resolve(value.value).then(function (arg) {
              resume("next", arg);
            }, function (arg) {
              resume("throw", arg);
            });
          } else {
            settle(result.done ? "return" : "normal", result.value);
          }
        } catch (err) {
          settle("throw", err);
        }
      }

      function settle(type, value) {
        switch (type) {
          case "return":
            front.resolve({
              value: value,
              done: true
            });
            break;

          case "throw":
            front.reject(value);
            break;

          default:
            front.resolve({
              value: value,
              done: false
            });
            break;
        }

        front = front.next;

        if (front) {
          resume(front.key, front.arg);
        } else {
          back = null;
        }
      }

      this._invoke = send;

      if (typeof gen.return !== "function") {
        this.return = undefined;
      }
    }

    if (typeof Symbol === "function" && Symbol.asyncIterator) {
      AsyncGenerator.prototype[Symbol.asyncIterator] = function () {
        return this;
      };
    }

    AsyncGenerator.prototype.next = function (arg) {
      return this._invoke("next", arg);
    };

    AsyncGenerator.prototype.throw = function (arg) {
      return this._invoke("throw", arg);
    };

    AsyncGenerator.prototype.return = function (arg) {
      return this._invoke("return", arg);
    };

    return {
      wrap: function (fn) {
        return function () {
          return new AsyncGenerator(fn.apply(this, arguments));
        };
      },
      await: function (value) {
        return new AwaitValue(value);
      }
    };
  }();

  babelHelpers.asyncGeneratorDelegate = function (inner, awaitWrap) {
    var iter = {},
        waiting = false;

    function pump(key, value) {
      waiting = true;
      value = new Promise(function (resolve) {
        resolve(inner[key](value));
      });
      return {
        done: false,
        value: awaitWrap(value)
      };
    }

    ;

    if (typeof Symbol === "function" && Symbol.iterator) {
      iter[Symbol.iterator] = function () {
        return this;
      };
    }

    iter.next = function (value) {
      if (waiting) {
        waiting = false;
        return value;
      }

      return pump("next", value);
    };

    if (typeof inner.throw === "function") {
      iter.throw = function (value) {
        if (waiting) {
          waiting = false;
          throw value;
        }

        return pump("throw", value);
      };
    }

    if (typeof inner.return === "function") {
      iter.return = function (value) {
        return pump("return", value);
      };
    }

    return iter;
  };

  babelHelpers.asyncToGenerator = function (fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  };

  babelHelpers.classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  babelHelpers.createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  babelHelpers.defineEnumerableProperties = function (obj, descs) {
    for (var key in descs) {
      var desc = descs[key];
      desc.configurable = desc.enumerable = true;
      if ("value" in desc) desc.writable = true;
      Object.defineProperty(obj, key, desc);
    }

    return obj;
  };

  babelHelpers.defaults = function (obj, defaults) {
    var keys = Object.getOwnPropertyNames(defaults);

    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      var value = Object.getOwnPropertyDescriptor(defaults, key);

      if (value && value.configurable && obj[key] === undefined) {
        Object.defineProperty(obj, key, value);
      }
    }

    return obj;
  };

  babelHelpers.defineProperty = function (obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  };

  babelHelpers.extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  babelHelpers.get = function get(object, property, receiver) {
    if (object === null) object = Function.prototype;
    var desc = Object.getOwnPropertyDescriptor(object, property);

    if (desc === undefined) {
      var parent = Object.getPrototypeOf(object);

      if (parent === null) {
        return undefined;
      } else {
        return get(parent, property, receiver);
      }
    } else if ("value" in desc) {
      return desc.value;
    } else {
      var getter = desc.get;

      if (getter === undefined) {
        return undefined;
      }

      return getter.call(receiver);
    }
  };

  babelHelpers.inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  babelHelpers.instanceof = function (left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
      return right[Symbol.hasInstance](left);
    } else {
      return left instanceof right;
    }
  };

  babelHelpers.interopRequireDefault = function (obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  };

  babelHelpers.interopRequireWildcard = function (obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};

      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
        }
      }

      newObj.default = obj;
      return newObj;
    }
  };

  babelHelpers.newArrowCheck = function (innerThis, boundThis) {
    if (innerThis !== boundThis) {
      throw new TypeError("Cannot instantiate an arrow function");
    }
  };

  babelHelpers.objectDestructuringEmpty = function (obj) {
    if (obj == null) throw new TypeError("Cannot destructure undefined");
  };

  babelHelpers.objectWithoutProperties = function (obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  babelHelpers.possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  babelHelpers.selfGlobal = typeof global === "undefined" ? self : global;

  babelHelpers.set = function set(object, property, value, receiver) {
    var desc = Object.getOwnPropertyDescriptor(object, property);

    if (desc === undefined) {
      var parent = Object.getPrototypeOf(object);

      if (parent !== null) {
        set(parent, property, value, receiver);
      }
    } else if ("value" in desc && desc.writable) {
      desc.value = value;
    } else {
      var setter = desc.set;

      if (setter !== undefined) {
        setter.call(receiver, value);
      }
    }

    return value;
  };

  babelHelpers.slicedToArray = function () {
    function sliceIterator(arr, i) {
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"]) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    return function (arr, i) {
      if (Array.isArray(arr)) {
        return arr;
      } else if (Symbol.iterator in Object(arr)) {
        return sliceIterator(arr, i);
      } else {
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      }
    };
  }();

  babelHelpers.slicedToArrayLoose = function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      var _arr = [];

      for (var _iterator = arr[Symbol.iterator](), _step; !(_step = _iterator.next()).done;) {
        _arr.push(_step.value);

        if (i && _arr.length === i) break;
      }

      return _arr;
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };

  babelHelpers.taggedTemplateLiteral = function (strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  };

  babelHelpers.taggedTemplateLiteralLoose = function (strings, raw) {
    strings.raw = raw;
    return strings;
  };

  babelHelpers.temporalRef = function (val, name, undef) {
    if (val === undef) {
      throw new ReferenceError(name + " is not defined - temporal dead zone");
    } else {
      return val;
    }
  };

  babelHelpers.temporalUndefined = {};

  babelHelpers.toArray = function (arr) {
    return Array.isArray(arr) ? arr : Array.from(arr);
  };

  babelHelpers.toConsumableArray = function (arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    } else {
      return Array.from(arr);
    }
  };
})(typeof global === "undefined" ? self : global);
!function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={i:r,l:!1,exports:{}};return e[r].call(i.exports,i,i.exports,t),i.l=!0,i.exports}var n={};t.m=e,t.c=n,t.i=function(e){return e},t.d=function(e,n,r){t.o(e,n)||Object.defineProperty(e,n,{configurable:!1,enumerable:!0,get:r})},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=821)}([function(e,t,n){var r=n(4),i=n(50),o=n(26),a=n(27),s=n(51),u=function(e,t,n){var c,l,p,d,f=e&u.F,h=e&u.G,m=e&u.S,g=e&u.P,v=e&u.B,b=h?r:m?r[t]||(r[t]={}):(r[t]||{}).prototype,y=h?i:i[t]||(i[t]={}),_=y.prototype||(y.prototype={});h&&(n=t);for(c in n)l=!f&&b&&void 0!==b[c],p=(l?b:n)[c],d=v&&l?s(p,r):g&&"function"==typeof p?s(Function.call,p):p,b&&a(b,c,p,e&u.U),y[c]!=p&&o(y,c,d),g&&_[c]!=p&&(_[c]=p)};r.core=i,u.F=1,u.G=2,u.S=4,u.P=8,u.B=16,u.W=32,u.U=64,u.R=128,e.exports=u},function(e,t,n){"use strict";function r(e,t,n,r,o,a,s,u){if(i(t),!e){var c;if(void 0===t)c=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var l=[n,r,o,a,s,u],p=0;c=new Error(t.replace(/%s/g,function(){return l[p++]})),c.name="Invariant Violation"}throw c.framesToPop=1,c}}var i=function(e){};e.exports=r},function(e,t,n){"use strict";e.exports=n(90)},function(e,t,n){var r=n(9);e.exports=function(e){if(!r(e))throw TypeError(e+" is not an object!");return e}},function(e,t){var n=e.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=n)},function(e,t,n){"use strict";var r=n(32),i=r;e.exports=i},function(e,t){e.exports=function(e){try{return!!e()}catch(e){return!0}}},function(e,t,n){"use strict";function r(e){for(var t=arguments.length-1,n="Minified React error #"+e+"; visit http://facebook.github.io/react/docs/error-decoder.html?invariant="+e,r=0;r<t;r++)n+="&args[]="+encodeURIComponent(arguments[r+1]);n+=" for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";var i=new Error(n);throw i.name="Invariant Violation",i.framesToPop=1,i}e.exports=r},function(e,t,n){"use strict";function r(e){return{type:T,display:e}}function i(e){return{type:S,index:e}}function o(e){return{type:C,val:e}}function a(){return{type:I}}function s(e){return{type:M,val:e}}function u(e){return{type:P,dropdown:e}}function c(){return u(x.a)}function l(){return u(x.b)}function p(){return{type:R}}function d(){return{type:O}}function f(e){return function(t,n){var r=n(),o=_.selectLastSpreadIndex(r),a=Math.max(0,Math.min(e,o));t(i(a)),n().canvasApi.goToSpread(a)}}function h(e){return function(t,r){var i=r(),o=i.reader.targetSpreadIndex,a=_.selectCurrentSpreadIndex(i),s=o>-1?o:a;if(E.b.isPreview(i)){var u=E.b.previewPages(i),c=_.selectReadMode(i);return t(f(n.i(w.a)(s,e,u,c)))}return t(f(s+(e?1:-1)))}}function m(){return h(!1)}function g(){return h(!0)}function v(e,t,n,r,i,o,a,s,u){return function(c,l){c({type:A,currentSpreadIndex:t,currentPageNumber:n,currentPages:r,positionInPercent:i,visiblePages:e,positionInPercentHasChanged:o,currentPagesHasChanged:a,visiblePagesHasChanged:s,isDragging:u})}}function b(e,t){return function(n,r){n({type:k,isPinching:t,zoomLevel:e})}}function y(e,t,n,r,i,o,a){return{type:N,droppedFrames:e,duration:t,frameCountAtStart:n,frameCountAtEnd:r,usesWebGl:a,_interactionStartTime:i,_interactionEndTime:o}}n.d(t,"c",function(){return A}),n.d(t,"a",function(){return D}),n.d(t,"q",function(){return r}),n.d(t,"j",function(){return f}),n.d(t,"d",function(){return m}),n.d(t,"b",function(){return g}),n.d(t,"p",function(){return o}),n.d(t,"e",function(){return a}),n.d(t,"n",function(){return s}),n.d(t,"o",function(){return u}),n.d(t,"l",function(){return c}),n.d(t,"m",function(){return l}),n.d(t,"k",function(){return p}),n.d(t,"f",function(){return d}),n.d(t,"h",function(){return v}),n.d(t,"i",function(){return b}),n.d(t,"g",function(){return y});var _=n(11),w=n(400),E=n(49),x=n(209),S="SET_TARGET_SPREAD_INDEX",T="SET_DEBUG_MODE",C="SET_INTERACTING_WITH_CONTROLS",I="SET_INTERACTED_WITH_READER",M="SET_HOVERING_OVER_CONTROLS",P="TOGGLE_DROPDOWN",R="SHOW_MORE_DROPDOWN",O="CLOSE_MORE_DROPDOWN",k="READER_ZOOM_LEVEL_CHANCED",A="READER_POSITION_CHANGED",N="TRACK_DROPPED_FRAMES",D={SET_TARGET_SPREAD_INDEX:S,SET_DEBUG_MODE:T,SET_IS_IDLE:"SET_IS_IDLE",SET_INTERACTING_WITH_CONTROLS:C,SET_INTERACTED_WITH_READER:I,SET_HOVERING_OVER_CONTROLS:M,TOGGLE_DROPDOWN:P,SHOW_MORE_DROPDOWN:R,CLOSE_MORE_DROPDOWN:O,READER_ZOOM_LEVEL_CHANCED:k,READER_POSITION_CHANGED:A,TRACK_DROPPED_FRAMES:N}},function(e,t){e.exports=function(e){return"object"==typeof e?null!==e:"function"==typeof e}},function(e,t,n){e.exports=n(642)()},function(e,t,n){"use strict";function r(e){return n.i(m.createSelector)(function(e){return e.features.controls},function(t){return t.find(function(t){return t.type===e})})}function i(e){return n.i(m.createSelector)(r(e),function(e){return!!e})}Object.defineProperty(t,"__esModule",{value:!0}),t.selectFeature=r,t.selectHasFeature=i,n.d(t,"selectIssuuBrandingFeature",function(){return g}),n.d(t,"selectFullscreenFeature",function(){return v}),n.d(t,"selectZoomFeature",function(){return b}),n.d(t,"selectInfoDialogFeature",function(){return y}),n.d(t,"selectZoomLevelInPercent",function(){return _}),n.d(t,"selectFullscreenEnabled",function(){return w}),n.d(t,"selectVisiblePages",function(){return E}),n.d(t,"selectCurrentPositionInPercent",function(){return x}),n.d(t,"selectCurrentPages",function(){return S}),n.d(t,"selectCurrentPageNumbers",function(){return T}),n.d(t,"selectReadMode",function(){return C}),n.d(t,"selectPageSpreadList",function(){return I}),n.d(t,"selectCurrentSpreadIndex",function(){return M}),n.d(t,"selectLastSpreadIndex",function(){return P}),n.d(t,"isLastSpread",function(){return R}),n.d(t,"isFirstSpread",function(){return O}),n.d(t,"isControlsVisible",function(){return k}),n.d(t,"selectReaderSizeInPixels",function(){return A}),n.d(t,"selectReaderSize",function(){return N}),n.d(t,"selectIsSmallReader",function(){return D}),n.d(t,"selectShowIssuuBranding",function(){return L}),n.d(t,"mayRenderLinks",function(){return F}),n.d(t,"selectBackgroundColor",function(){return U}),n.d(t,"selectBackgroundImage",function(){return B}),n.d(t,"selectLogo",function(){return H}),n.d(t,"selectDocumentUrlWithPageNumber",function(){return j}),n.d(t,"selectDocumentUrlOnProduction",function(){return z}),n.d(t,"isDropdownOpen",function(){return W}),n.d(t,"moreOverlayVisible",function(){return V}),n.d(t,"selectShowCTAOverlay",function(){return G});var o=n(59),a=n(212),s=n(93),u=n(222),c=n(221),l=n(35),p=n(96),d=n(41),f=n(40),h=n(58),m=n(33),g=(n.n(m),r(d.ISSUU_BRANDING_TYPE)),v=r(d.FULLSCREEN_TYPE),b=r(d.ZOOM_TYPE),y=r(d.INFO_DIALOG_TYPE),_=n.i(m.createSelector)(function(e){return e.reader.zoomLevel},function(e){return 100/(h.a-h.b)*(e-h.b)}),w=n.i(m.createSelector)(v,function(e){return e.fullscreen.enabled},function(e,t){return n.i(c.a)(e,t)}),E=function(e){return e.reader.visiblePages},x=function(e){return e.reader.positionInPercent},S=function(e){return e.reader.currentPages},T=n.i(m.createSelector)(S,function(e){return e.map(function(e){return e.pageNumber})}),C=n.i(m.createSelector)(function(e){return e.features.readModeRules},w,function(e){return e.size.width},function(e){return e.size.height},function(e,t,r,i){return n.i(u.a)(r,i,t,e)}),I=n.i(m.createSelector)(C,p.a,p.b,function(e,t,n){return e===f.DOUBLE_PAGE_SPREAD?n:t}),M=n.i(m.createSelector)(T,C,function(e,t){return n.i(o.a)(t,e[0])}),P=n.i(m.createSelector)(C,function(e){return e.documentModel.pageCount},function(e,t){return n.i(o.a)(e,t)}),R=n.i(m.createSelector)(M,P,function(e,t){return e===t}),O=n.i(m.createSelector)(M,function(e){return 0===e}),k=function(e){var t=e.features.showControlsUntilFirstInteraction,n=e.reader,r=n.interactedWithReader,i=n.hoveringOverControls,o=n.interactingWithControls,a=n.isIdle,s=e.headerControls,u=s.visibleDropdown,c=s.readMoreDropdownVisible,l=e.find.isVisible;return!!(i||o||null!==u||c||t&&!r||l)||!a},A=n.i(m.createSelector)(function(e){return e.size.width},function(e){return e.size.height},function(e,t){var r=n.i(l.a)();return Math.floor(e/r)+"x"+Math.floor(t/r)}),N=n.i(m.createSelector)(function(e){return e.size.width},function(e){return e.size.height},function(e,t){var r=n.i(l.a)();return e<=200*r||t<=150*r?a.a:e<=400*r||t<=300*r?a.b:a.c}),D=n.i(m.createSelector)(N,w,function(e,t){return(e===a.a||e===a.b)&&!t}),L=n.i(m.createSelector)(g,function(e){return!!e}),F=n.i(m.createSelector)(r(d.LINKS_TYPE),D,function(e,t){return!(!e||!e.allowOnSmallReaders&&t)}),U=n.i(m.createSelector)(w,s.canChangeBackgroundColor,function(e){return e.features.backgroundColor},function(e){return e.features.fullscreenBackgroundColor},function(e,t,n,r){return e?r&&t?r:"#353535":n||"rgba(0, 0, 0, 0.1)"}),B=n.i(m.createSelector)(w,s.canChangeBackgroundImage,function(e){return e.features.backgroundImage},function(e,t,n){if(n&&t&&(e||!n.hideWhenNotInFullscreen))return n}),H=n.i(m.createSelector)(w,s.canChangeLogo,function(e){return e.features.logo},function(e,t,n){if(n&&t&&(e||!n.hideWhenNotInFullscreen))return n}),j=n.i(m.createSelector)(function(e){return e.config.getScheme()},function(e){return e.config.hosts.main},function(e){return e.documentModel.username},function(e){return e.documentModel.documentName},T,function(e,t,n,r,i){return""+e+t+"/"+n+"/docs/"+r+"/"+i[0]}),z=n.i(m.createSelector)(function(e){return e.documentModel.username},function(e){return e.documentModel.documentName},T,function(e,t,n){var r="https://issuu.com/"+e+"/docs/"+t,i=n[0];return i>1?r+"/"+i:r}),W=function(e){var t=e.headerControls,n=t.visibleDropdown,r=t.readMoreDropdownVisible;return null!==n||r},V=n.i(m.createSelector)(function(e){return e.headerControls.readMoreDropdownVisible},function(e){return e.readmore.exitedFullscreen},function(e){return e.readMorePlugin},s.canSeeOwnPublication,s.canHideRelated,function(e,t,n,r,i){var o=n&&n.shouldRenderExitFullscreenOverlay(r,i);return!!(e||t&&o)}),G=n.i(m.createSelector)(v,D,function(e,t){return!!(e&&e.overlayOnSmallReaders&&t)})},function(e,t,n){var r=n(121)("wks"),i=n(71),o=n(4).Symbol,a="function"==typeof o;(e.exports=function(e){return r[e]||(r[e]=a&&o[e]||(a?o:i)("Symbol."+e))}).store=r},function(e,t,n){"use strict";function r(e){if(null===e||void 0===e)throw new TypeError("Object.assign cannot be called with null or undefined");return Object(e)}/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var i=Object.getOwnPropertySymbols,o=Object.prototype.hasOwnProperty,a=Object.prototype.propertyIsEnumerable;e.exports=function(){try{if(!Object.assign)return!1;var e=new String("abc");if(e[5]="de","5"===Object.getOwnPropertyNames(e)[0])return!1;for(var t={},n=0;n<10;n++)t["_"+String.fromCharCode(n)]=n;if("0123456789"!==Object.getOwnPropertyNames(t).map(function(e){return t[e]}).join(""))return!1;var r={};return"abcdefghijklmnopqrst".split("").forEach(function(e){r[e]=e}),"abcdefghijklmnopqrst"===Object.keys(Object.assign({},r)).join("")}catch(e){return!1}}()?Object.assign:function(e,t){for(var n,s,u=r(e),c=1;c<arguments.length;c++){n=Object(arguments[c]);for(var l in n)o.call(n,l)&&(u[l]=n[l]);if(i){s=i(n);for(var p=0;p<s.length;p++)a.call(n,s[p])&&(u[s[p]]=n[s[p]])}}return u}},function(e,t,n){e.exports=!n(6)(function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})},function(e,t,n){var r=n(3),i=n(231),o=n(45),a=Object.defineProperty;t.f=n(14)?Object.defineProperty:function(e,t,n){if(r(e),t=o(t,!0),r(n),i)try{return a(e,t,n)}catch(e){}if("get"in n||"set"in n)throw TypeError("Accessors not supported!");return"value"in n&&(e[t]=n.value),e}},function(e,t,n){"use strict";function r(e,t){return 1===e.nodeType&&e.getAttribute(h)===String(t)||8===e.nodeType&&e.nodeValue===" react-text: "+t+" "||8===e.nodeType&&e.nodeValue===" react-empty: "+t+" "}function i(e){for(var t;t=e._renderedComponent;)e=t;return e}function o(e,t){var n=i(e);n._hostNode=t,t[g]=n}function a(e){var t=e._hostNode;t&&(delete t[g],e._hostNode=null)}function s(e,t){if(!(e._flags&m.hasCachedChildNodes)){var n=e._renderedChildren,a=t.firstChild;e:for(var s in n)if(n.hasOwnProperty(s)){var u=n[s],c=i(u)._domID;if(0!==c){for(;null!==a;a=a.nextSibling)if(r(a,c)){o(u,a);continue e}p("32",c)}}e._flags|=m.hasCachedChildNodes}}function u(e){if(e[g])return e[g];for(var t=[];!e[g];){if(t.push(e),!e.parentNode)return null;e=e.parentNode}for(var n,r;e&&(r=e[g]);e=t.pop())n=r,t.length&&s(r,e);return n}function c(e){var t=u(e);return null!=t&&t._hostNode===e?t:null}function l(e){if(void 0===e._hostNode&&p("33"),e._hostNode)return e._hostNode;for(var t=[];!e._hostNode;)t.push(e),e._hostParent||p("34"),e=e._hostParent;for(;t.length;e=t.pop())s(e,e._hostNode);return e._hostNode}var p=n(7),d=n(88),f=n(272),h=(n(1),d.ID_ATTRIBUTE_NAME),m=f,g="__reactInternalInstance$"+Math.random().toString(36).slice(2);e.exports={getClosestInstanceFromNode:u,getInstanceFromNode:c,getNodeFromInstance:l,precacheChildNodes:s,precacheNode:o,uncacheNode:a}},function(e,t,n){var r=n(62),i=Math.min;e.exports=function(e){return e>0?i(r(e),9007199254740991):0}},function(e,t,n){var r=n(37);e.exports=function(e){return Object(r(e))}},function(e,t,n){"use strict";function r(e){this.name="FetchNetworkError",this.message=e}function i(e,t){this.name="BackendModelError",this.code=t,this.message=e}function o(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return new Promise(function(n,i){var o=new XMLHttpRequest;o.open("GET",e,!0),o.withCredentials=!!t.withCredentials&&t.withCredentials,t.timeout&&(o.timeout=t.timeout,o.ontimeout=function(e){i(new r("XHR could not load JSON (timeout)"))},o.onabort=function(e){i(new r("XHR could not load JSON (timeout)"))},setTimeout(function(){i(new r("XHR could not load JSON (timeout)")),o.abort()},t.timeout)),o.onreadystatechange=function(){if(o.readyState===D)if(200===o.status)try{n(JSON.parse(o.responseText))}catch(e){i(new r("Could not deserialize loaded JSON: "+e))}else i(new r("XHR could not load JSON"))},o.send()})}function a(e,t,n,r){var a=""+e.getScheme()+e.hosts.api+"/call/reader/api/4/"+t+"/"+n,s=""+e.getScheme()+e.hosts.publication+"/"+t+"/"+n+"/reader3_3.0.json",u=window.performance&&window.performance.now?function(){return window.performance.now()}:function(){return Date.now()},c=u();return Promise.all([o(s),o(a,{withCredentials:!0,timeout:2e3}).then(function(e){return r(u()-c),e}).catch(function(e){return r(u()-c,e),{status:"ok"}})]).then(function(e){var r=e[0],o=e[1];if(0!==r.status||"ok"!==o.status)throw new i("The document could not be loaded.",r.status||o.status);var a=Object.assign({userName:t,documentName:n},r.document);a.clippings={},a.licenses=o.licenses||null,a.paywallInfo=o.paywallInfo||{};var s={description:"",userDisplayName:t,title:n,contentRating:{},access:"public",downloadable:!1};return Object.assign(a,s,o.metadata||{}),a})}function s(e){return{type:C,timeStamp:e}}function u(e,t){return{type:M,error:e,timeStamp:t}}function c(){return{type:P}}function l(){return{type:R}}function p(e,t,n,r,i,o){return{type:I,initialPageNumber:t,targetSpreadIndex:n,currentPages:r,width:i,height:o,timeStamp:e}}function d(e,t,r,i){return function(o,a){var s=a(),u=s.documentModel,c=s.features.controls.find(function(e){return e.type===S.FULLSCREEN_TYPE}),l=n.i(x.a)(c,s.fullscreen.enabled),d=n.i(E.a)(r,i,l,s.features.readModeRules),f=n.i(w.a)(d,t),h=d===T.DOUBLE_PAGE_SPREAD?n.i(_.b)(s)[f].pages:[u.pages[f]];o(p(e,t,f,h,r,i))}}function f(e,t,r){return function(i,o){var a=o(),s=a.documentModel;e&&e.load(t.getScheme(),t.hosts.main,s.publicationId,s.username,n.i(y.a)("customization_show_my_other_publications",s,r),n.i(y.a)("norelated",s,r)).then(function(e){e&&i(c())}).catch(function(){i(l())})}}function h(e,t,r){return function(a){function s(e){o(u,{timeout:c}).then(function(e){if("ok"!==e.status)throw new i("The Clippings could not be loaded.",e.status);a(n.i(_.c)(e.clippings))},function(t){e>1&&s(e-1)})}var u=""+e.getScheme()+e.hosts.api+"/call/reader/clippings/1.0/"+t+"/"+r,c=1e4;s(3)}}function m(e){var t=e.config,o=e.username,c=e.documentName,l=e.initialPageNumber,p=void 0===l?1:l,m=e.getWidthAndHeight,y=void 0===m?function(){}:m,w=e.readMorePlugin,E=void 0===w?null:w;return function(e){e(s(Date.now()));var l=function(t,n){e({type:n?A:k,error:n,loadTime:t})},m=a(t,o,c,l),w=!1;return m.then(function(r){var i=y(),a=i[0],s=i[1];w=!r.licenses,w&&e({type:O}),e(n.i(_.d)(r)),r.isPaywalled&&e(v.d.publicationLoaded(r)),r.textInfoPath&&Number.isInteger(r.textInfoVersion)&&e(b.c.setTextInfoUrl(r.textInfoPath,r.textInfoVersion));var u=Math.max(1,Math.min(r.pageCount,p));return e(d(Date.now(),u,a,s)),e(h(t,o,c)),e(f(E,t,w)),r}).catch(function(t){if(!(t instanceof r||t instanceof i)){var o={errorOrigin:"document-load-fetchDocument"};n.i(g.b)(t,{tags:o})}e(u(t,Date.now()))})}}n.d(t,"b",function(){return I}),n.d(t,"c",function(){return N}),n.d(t,"a",function(){return m}),n.d(t,"f",function(){return r}),n.d(t,"e",function(){return i}),n.d(t,"d",function(){return c});var g=n(108),v=n(49),b=n(42),y=n(141),_=n(96),w=n(59),E=n(222),x=n(221),S=n(41),T=n(40),C="DOCUMENTLOADING",I="DOCUMENTLOAD_SUCCESS",M="DOCUMENTLOAD_FAILURE",P="READ_MORE_LOAD_SUCCESS",R="READ_MORE_LOAD_FAILURE",O="DISABLE_LICENSE_CHECK",k="DYNAMIC_API_SUCCESS",A="DYNAMIC_API_FAILURE",N={DOCUMENTLOADING:C,DOCUMENTLOAD_SUCCESS:I,DOCUMENTLOAD_FAILURE:M,READ_MORE_LOAD_SUCCESS:P,READ_MORE_LOAD_FAILURE:R,DISABLE_LICENSE_CHECK:O,DYNAMIC_API_FAILURE:A,DYNAMIC_API_SUCCESS:k},D=4},function(e,t,n){"use strict";function r(e,t){return i[e].reduce(function(e,n){return"string"==typeof n?e.push(n):n.hasOwnProperty(t)&&e.push(n[t]),e},[e])}n.d(t,"b",function(){return o}),n.d(t,"a",function(){return a});var i={BUTTON_ARROW_BACKWARD:["HO_CHANGE_PAGE","HO_INPUT_BUTTON"],BUTTON_ARROW_FORWARD:["HO_CHANGE_PAGE","HO_INPUT_BUTTON"],BUTTON_CTA_OVERLAY:["HO_INPUT_BUTTON","HO_ENTER_FULLSCREEN"],BUTTON_FULLSCREEN:["HO_INPUT_BUTTON","HO_ENTER_FULLSCREEN"],BUTTON_ZOOMIN:["HO_CHANGE_ZOOM","HO_INPUT_BUTTON"],BUTTON_ZOOMOUT:["HO_CHANGE_ZOOM","HO_INPUT_BUTTON"],BUTTON_LOGO:["HO_INPUT_BUTTON"],BUTTON_DOWNLOAD:["HO_INPUT_BUTTON"],BUTTON_INFO:["HO_INPUT_BUTTON"],GESTURE_DRAG_PAGES:["HO_CHANGE_PAGE","HO_INPUT_GESTURE"],GESTURE_PINCH_ZOOM:["HO_CHANGE_ZOOM","HO_INPUT_GESTURE"],DOUBLE_TAP_ZOOM:["HO_CHANGE_ZOOM","HO_INPUT_GESTURE"],KEYBOARD_BACKWARD:["HO_CHANGE_PAGE","HO_INPUT_KEYBOARD"],KEYBOARD_FORWARD:["HO_CHANGE_PAGE","HO_INPUT_KEYBOARD"],SLIDER_PAGES:["HO_CHANGE_PAGE","HO_INPUT_SLIDER"],SLIDER_ZOOM:["HO_CHANGE_ZOOM","HO_INPUT_SLIDER"],BUTTON_SHARE:["HO_INPUT_BUTTON"],SHARE_EMAIL:["HO_SHARE_SOCIAL"],SHARE_FACEBOOK:["HO_SHARE_SOCIAL"],SHARE_TWITTER:["HO_SHARE_SOCIAL"],SHARE_PINTEREST:["HO_SHARE_SOCIAL"],BUTTON_MORE:["HO_MORE_CONTENT","HO_INPUT_BUTTON"],FULLSCREEN_MORE:["HO_MORE_CONTENT"],PUBLICATION_LINK:[],DOWNLOAD_FROM_ISSUU_LINK:[],INFO_PUBLISHER_LINK:[],BUTTON_OPEN_FIND:["HO_INPUT_BUTTON","HO_OPEN_FIND",{opportunity:"HO_FIND"}],KEYBOARD_OPEN_FIND:["HO_INPUT_KEYBOARD","HO_OPEN_FIND",{opportunity:"HO_FIND"}],FIND_QUERY:[{usage:"HO_FIND"}],FIND_NEXT:[],FIND_PREV:[],FIND_CLOSE:[],FIND_CLOSE_BLUR:[]},o=Object.keys(i).reduce(function(e,t){return e[t]=t,e},{}),a=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this._opportunitySent={},this._usageSent={},this.tracker=t,this.errorHandler=n,this.userId=r}return e.prototype._isValidKey=function(e){return!!o.hasOwnProperty(e)||(this.errorHandler(new Error("Attempted to track invalid key "+e)),!1)},e.prototype.opportunity=function(e){var t=this;this._isValidKey(e)&&!this._opportunitySent.hasOwnProperty(e)&&r(e,"opportunity").forEach(function(e){if(!t._opportunitySent.hasOwnProperty(e)){t.tracker.monitor("reader3-features."+e,{opportunity:1,userId:t.userId},!1),t._opportunitySent[e]=!0}})},e.prototype.usage=function(e){var t=this;this._isValidKey(e)&&r(e,"usage").forEach(function(e){var n="reader3-features."+e,r=t._usageSent.hasOwnProperty(e)?0:1;t.tracker.monitor(n,{usageRepeat:1,usageFirst:r,userId:t.userId},!1),t._usageSent[e]=!0})},e}()},function(e,t,n){var r,i;/*!
  Copyright (c) 2016 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
!function(){"use strict";function n(){for(var e=[],t=0;t<arguments.length;t++){var r=arguments[t];if(r){var i=typeof r;if("string"===i||"number"===i)e.push(r);else if(Array.isArray(r))e.push(n.apply(null,r));else if("object"===i)for(var a in r)o.call(r,a)&&r[a]&&e.push(a)}}return e.join(" ")}var o={}.hasOwnProperty;void 0!==e&&e.exports?e.exports=n:(r=[],void 0!==(i=function(){return n}.apply(t,r))&&(e.exports=i))}()},function(e,t,n){"use strict";function r(e){var t=e.reader.zoomLevel;return b.selectFullscreenEnabled(e)||b.selectShowCTAOverlay(e)||1!==t?y.j:31536e6}function i(){return function(e,t){var n=t();n.reader.isIdle&&e({type:w.a.SET_IS_IDLE,isIdle:!1}),E&&clearTimeout(E),E=setTimeout(function(){e({type:w.a.SET_IS_IDLE,isIdle:!0})},r(n))}}function o(){return function(e,t){t().reader.isIdle||e({type:w.a.SET_IS_IDLE,isIdle:!0}),E&&(clearTimeout(E),E=null)}}function a(e){return function(t,n){if([_.a,_.b,_.c].includes(e)){t(b.selectCurrentSpreadIndex(n())+1<b.selectLastSpreadIndex(n())?o():i())}else if([_.d,_.e].includes(e)){var r=b.selectCurrentSpreadIndex(n());t(r>1?o():i())}else t(i())}}function s(){return function(e,t){e(i())}}function u(){return function(e,t){e(i())}}function c(){return function(e,t){e(i())}}function l(){return function(e,t){e(o())}}function p(){return function(e,t){e(i())}}function d(){return function(e,t){isNaN(x)&&(x=t().reader.zoomLevel),e(1!==x?o():i())}}function f(){return function(e,t){var n=t().reader.zoomLevel;e(1!==x&&1!==n?o():i())}}function h(){return function(e,t){var n=t().reader.zoomLevel;e(1!==x&&1!==n?o():i()),x=NaN}}function m(){return function(e,t){e(i())}}function g(){return function(e,t){e(i())}}function v(){return function(e,t){e(i())}}t.l=a,t.a=s,t.b=u,t.c=c,t.d=l,t.k=p,t.g=d,t.h=f,t.i=h,t.e=m,t.f=g,t.j=v;var b=n(11),y=n(58),_=n(210),w=n(8),E=void 0,x=NaN},function(e,t){var n={}.hasOwnProperty;e.exports=function(e,t){return n.call(e,t)}},function(e,t,n){"use strict";var r=!("undefined"==typeof window||!window.document||!window.document.createElement);e.exports={canUseDOM:r,canUseWorkers:"undefined"!=typeof Worker,canUseEventListeners:r&&!(!window.addEventListener&&!window.attachEvent),canUseViewport:r&&!!window.screen,isInWorker:!r}},function(e,t){e.exports=function(e){if("function"!=typeof e)throw TypeError(e+" is not a function!");return e}},function(e,t,n){var r=n(15),i=n(61);e.exports=n(14)?function(e,t,n){return r.f(e,t,i(1,n))}:function(e,t,n){return e[t]=n,e}},function(e,t,n){var r=n(4),i=n(26),o=n(23),a=n(71)("src"),s=Function.toString,u=(""+s).split("toString");n(50).inspectSource=function(e){return s.call(e)},(e.exports=function(e,t,n,s){var c="function"==typeof n;c&&(o(n,"name")||i(n,"name",t)),e[t]!==n&&(c&&(o(n,a)||i(n,a,e[t]?""+e[t]:u.join(String(t)))),e===r?e[t]=n:s?e[t]?e[t]=n:i(e,t,n):(delete e[t],i(e,t,n)))})(Function.prototype,"toString",function(){return"function"==typeof this&&this[a]||s.call(this)})},function(e,t,n){var r=n(0),i=n(6),o=n(37),a=function(e,t,n,r){var i=String(o(e)),a="<"+t;return""!==n&&(a+=" "+n+'="'+String(r).replace(/"/g,"&quot;")+'"'),a+">"+i+"</"+t+">"};e.exports=function(e,t){var n={};n[e]=t(a),r(r.P+r.F*i(function(){var t=""[e]('"');return t!==t.toLowerCase()||t.split('"').length>3}),"String",n)}},function(e,t,n){var r=n(98),i=n(37);e.exports=function(e){return r(i(e))}},function(e,t,n){var r=n(99),i=n(61),o=n(29),a=n(45),s=n(23),u=n(231),c=Object.getOwnPropertyDescriptor;t.f=n(14)?c:function(e,t){if(e=o(e),t=a(t,!0),u)try{return c(e,t)}catch(e){}if(s(e,t))return i(!r.f.call(e,t),e[t])}},function(e,t,n){var r=n(23),i=n(18),o=n(158)("IE_PROTO"),a=Object.prototype;e.exports=Object.getPrototypeOf||function(e){return e=i(e),r(e,o)?e[o]:"function"==typeof e.constructor&&e instanceof e.constructor?e.constructor.prototype:e instanceof Object?a:null}},function(e,t,n){"use strict";function r(e){return function(){return e}}var i=function(){};i.thatReturns=r,i.thatReturnsFalse=r(!1),i.thatReturnsTrue=r(!0),i.thatReturnsNull=r(null),i.thatReturnsThis=function(){return this},i.thatReturnsArgument=function(e){return e},e.exports=i},function(e,t,n){"use strict";function r(e,t){return e===t}function i(e,t,n){if(null===t||null===n||t.length!==n.length)return!1;for(var r=t.length,i=0;i<r;i++)if(!e(t[i],n[i]))return!1;return!0}function o(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:r,n=null,o=null;return function(){return i(t,n,arguments)||(o=e.apply(null,arguments)),n=arguments,o}}function a(e){var t=Array.isArray(e[0])?e[0]:e;if(!t.every(function(e){return"function"==typeof e})){var n=t.map(function(e){return typeof e}).join(", ");throw new Error("Selector creators expect all input-selectors to be functions, instead received the following types: ["+n+"]")}return t}function s(e){for(var t=arguments.length,n=Array(t>1?t-1:0),r=1;r<t;r++)n[r-1]=arguments[r];return function(){for(var t=arguments.length,r=Array(t),i=0;i<t;i++)r[i]=arguments[i];var s=0,u=r.pop(),c=a(r),l=e.apply(void 0,[function(){return s++,u.apply(null,arguments)}].concat(n)),p=o(function(){for(var e=[],t=c.length,n=0;n<t;n++)e.push(c[n].apply(null,arguments));return l.apply(null,e)});return p.resultFunc=u,p.recomputations=function(){return s},p.resetRecomputations=function(){return s=0},p}}function u(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:c;if("object"!=typeof e)throw new Error("createStructuredSelector expects first argument to be an object where each property is a selector, instead received a "+typeof e);var n=Object.keys(e);return t(n.map(function(t){return e[t]}),function(){for(var e=arguments.length,t=Array(e),r=0;r<e;r++)t[r]=arguments[r];return t.reduce(function(e,t,r){return e[n[r]]=t,e},{})})}t.__esModule=!0,t.defaultMemoize=o,t.createSelectorCreator=s,t.createStructuredSelector=u;var c=t.createSelector=s(o)},function(e,t){var n;n=function(){return this}();try{n=n||Function("return this")()||(0,eval)("this")}catch(e){"object"==typeof window&&(n=window)}e.exports=n},function(e,t,n){"use strict";function r(){return window.devicePixelRatio||1}t.a=r},function(e,t){var n={}.toString;e.exports=function(e){return n.call(e).slice(8,-1)}},function(e,t){e.exports=function(e){if(void 0==e)throw TypeError("Can't call method on  "+e);return e}},function(e,t,n){var r=n(6);e.exports=function(e,t){return!!e&&r(function(){t?e.call(null,function(){},1):e.call(null)})}},function(e,t,n){"use strict";var r=null;e.exports={debugTool:r}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n.d(t,"DOUBLE_PAGE_SPREAD",function(){return r}),n.d(t,"SINGLE_PAGE_SPREAD",function(){return i}),n.d(t,"RESPONSIVE",function(){return o});var r="DOUBLE_PAGE_SPREAD",i="SINGLE_PAGE_SPREAD",o={HANDHELD_IN_PORTRAIT:"HANDHELD_IN_PORTRAIT",HANDHELD_IN_PORTRAIT_FULLSCREEN:"HANDHELD_IN_PORTRAIT_IN_FULLSCREEN",PHONE_ISH_IN_PORTRAIT:"PHONE_ISH_IN_PORTRAIT"}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n.d(t,"FULLSCREEN_TYPE",function(){return i}),n.d(t,"FULLSCREEN_KIND",function(){return o}),n.d(t,"FULLSCREEN_BUTTON",function(){return a}),n.d(t,"ISSUU_BRANDING_TYPE",function(){return s}),n.d(t,"ISSUU_BRANDING_KIND",function(){return u}),n.d(t,"LINKS_TYPE",function(){return c}),n.d(t,"SHARE_DIALOG_TYPE",function(){return l}),n.d(t,"INFO_DIALOG_TYPE",function(){return p}),n.d(t,"ZOOM_TYPE",function(){return d}),n.d(t,"DOWNLOAD_TYPE",function(){return f}),n.d(t,"NAVIGATION_ARROWS_TYPE",function(){return h}),n.d(t,"BACKGROUND_IMAGE_STYLE",function(){return m}),n.d(t,"READ_MODE",function(){return g});var r=n(40),i="FEATURE_FULLSCREEN",o={NORMAL:"NORMAL",FALLBACK:"FALLBACK"},a={ALWAYS:"ALWAYS",HIDE:"HIDE_WHEN_NOT_SUPPORTED"},s="FEATURE_ISSUU_BRANDING",u={LANDING_PAGE:"LANDING_PAGE"},c="FEATURE_LINKS",l="FEATURE_SHARE_DIALOG",p="FEATURE_INFO_DIALOG",d="FEATURE_ZOOM",f="FEATURE_DOWNLOAD",h="FEATURE_NAVIGATION_ARROWS",m={STRETCH:"STRETCH",TOP_LEFT:"TOP_LEFT"},g=r},function(e,t,n){"use strict";function r(){return m(p.a.READER_POSITION_CHANGED)}t.d=r,n.d(t,"c",function(){return f}),n.d(t,"b",function(){return h}),n.d(t,"a",function(){return g});var i=n(33),o=(n.n(i),n(307)),a=n(94),s=n(11),u=n(59),c=n(95),l=n(132),p=n(8),d=n.i(o.a)({isMobile:a.a.isMobile(),jumpToPageNumber:function(e,t){e.canvasApi.jumpToPage(t)},resetZoom:function(e){e.canvasApi.zoomCurrentView(1)},selectSpreadCount:n.i(i.createSelector)(function(e){return e.canvasApi&&e.canvasApi.getReadMode()},function(e){return e.documentModel},function(e,t){return e&&t.pageCount?n.i(u.a)(e,t.pageCount):0}),pageNumberToSpreadIndex:u.a,selectReadMode:n.i(i.createSelector)(function(e){return e.canvasApi&&e.canvasApi.getReadMode()},function(e){return e}),selectCurrentPage:function(e){return n.i(s.selectCurrentPages)(e)[0].pageNumber},selectPageCount:function(e){return e.documentModel.pageCount},enableWebGL:c.a,Spinner:l.a}),f=d.actions,h=d.components,m=d.createReducer,g=d.selectors},function(e,t,n){var r=n(51),i=n(98),o=n(18),a=n(17),s=n(408);e.exports=function(e,t){var n=1==e,u=2==e,c=3==e,l=4==e,p=6==e,d=5==e||p,f=t||s;return function(t,s,h){for(var m,g,v=o(t),b=i(v),y=r(s,h,3),_=a(b.length),w=0,E=n?f(t,_):u?f(t,0):void 0;_>w;w++)if((d||w in b)&&(m=b[w],g=y(m,w,v),e))if(n)E[w]=g;else if(g)switch(e){case 3:return!0;case 5:return m;case 6:return w;case 2:E.push(m)}else if(l)return!1;return p?-1:c||l?l:E}}},function(e,t,n){var r=n(0),i=n(50),o=n(6);e.exports=function(e,t){var n=(i.Object||{})[e]||Object[e],a={};a[e]=t(n),r(r.S+r.F*o(function(){n(1)}),"Object",a)}},function(e,t,n){var r=n(9);e.exports=function(e,t){if(!r(e))return e;var n,i;if(t&&"function"==typeof(n=e.toString)&&!r(i=n.call(e)))return i;if("function"==typeof(n=e.valueOf)&&!r(i=n.call(e)))return i;if(!t&&"function"==typeof(n=e.toString)&&!r(i=n.call(e)))return i;throw TypeError("Can't convert object to primitive value")}},function(e,t,n){"use strict";function r(){I.ReactReconcileTransaction&&w||l("123")}function i(){this.reinitializeTransaction(),this.dirtyComponentsLength=null,this.callbackQueue=d.getPooled(),this.reconcileTransaction=I.ReactReconcileTransaction.getPooled(!0)}function o(e,t,n,i,o,a){return r(),w.batchedUpdates(e,t,n,i,o,a)}function a(e,t){return e._mountOrder-t._mountOrder}function s(e){var t=e.dirtyComponentsLength;t!==v.length&&l("124",t,v.length),v.sort(a),b++;for(var n=0;n<t;n++){var r=v[n],i=r._pendingCallbacks;r._pendingCallbacks=null;var o;if(h.logTopLevelRenders){var s=r;r._currentElement.type.isReactTopLevelWrapper&&(s=r._renderedComponent),o="React update: "+s.getName(),console.time(o)}if(m.performUpdateIfNecessary(r,e.reconcileTransaction,b),o&&console.timeEnd(o),i)for(var u=0;u<i.length;u++)e.callbackQueue.enqueue(i[u],r.getPublicInstance())}}function u(e){if(r(),!w.isBatchingUpdates)return void w.batchedUpdates(u,e);v.push(e),null==e._updateBatchNumber&&(e._updateBatchNumber=b+1)}function c(e,t){w.isBatchingUpdates||l("125"),y.enqueue(e,t),_=!0}var l=n(7),p=n(13),d=n(270),f=n(72),h=n(275),m=n(89),g=n(126),v=(n(1),[]),b=0,y=d.getPooled(),_=!1,w=null,E={initialize:function(){this.dirtyComponentsLength=v.length},close:function(){this.dirtyComponentsLength!==v.length?(v.splice(0,this.dirtyComponentsLength),T()):v.length=0}},x={initialize:function(){this.callbackQueue.reset()},close:function(){this.callbackQueue.notifyAll()}},S=[E,x];p(i.prototype,g,{getTransactionWrappers:function(){return S},destructor:function(){this.dirtyComponentsLength=null,d.release(this.callbackQueue),this.callbackQueue=null,I.ReactReconcileTransaction.release(this.reconcileTransaction),this.reconcileTransaction=null},perform:function(e,t,n){return g.perform.call(this,this.reconcileTransaction.perform,this.reconcileTransaction,e,t,n)}}),f.addPoolingTo(i);var T=function(){for(;v.length||_;){if(v.length){var e=i.getPooled();e.perform(s,null,e),i.release(e)}if(_){_=!1;var t=y;y=d.getPooled(),t.notifyAll(),d.release(t)}}},C={injectReconcileTransaction:function(e){e||l("126"),I.ReactReconcileTransaction=e},injectBatchingStrategy:function(e){e||l("127"),"function"!=typeof e.batchedUpdates&&l("128"),"boolean"!=typeof e.isBatchingUpdates&&l("129"),w=e}},I={ReactReconcileTransaction:null,batchedUpdates:o,enqueueUpdate:u,flushBatchedUpdates:T,injection:C,asap:c};e.exports=I},function(e,t,n){"use strict";var r=n(713),i=(n(289),n(714));n.d(t,"a",function(){return r.a}),n.d(t,"b",function(){return i.a})},function(e,t,n){"use strict";function r(e){return Array.isArray(e)?e:null!==e&&void 0!==e?[e]:b}function i(e,t){var n,r,o,a,s;return regeneratorRuntime.wrap(function(u){for(;;)switch(u.prev=u.next){case 0:n=e.children,r=Array.isArray(n),o=0,n=r?n:n[Symbol.iterator]();case 1:if(!r){u.next=7;break}if(!(o>=n.length)){u.next=4;break}return u.abrupt("break",18);case 4:a=n[o++],u.next=11;break;case 7:if(o=n.next(),!o.done){u.next=10;break}return u.abrupt("break",18);case 10:a=o.value;case 11:if(s=a,s.owner!==t){u.next=15;break}return u.next=15,s;case 15:return u.delegateYield(i(s,t),"t0",16);case 16:u.next=1;break;case 18:case"end":return u.stop()}},l[0],this)}function o(e){var t,n,r,i,a;return regeneratorRuntime.wrap(function(s){for(;;)switch(s.prev=s.next){case 0:t=e.wrappedChildren,n=Array.isArray(t),r=0,t=n?t:t[Symbol.iterator]();case 1:if(!n){s.next=7;break}if(!(r>=t.length)){s.next=4;break}return s.abrupt("break",17);case 4:i=t[r++],s.next=11;break;case 7:if(r=t.next(),!r.done){s.next=10;break}return s.abrupt("break",17);case 10:i=r.value;case 11:return a=i,s.next=14,a;case 14:return s.delegateYield(o(a),"t0",15);case 15:s.next=1;break;case 17:case"end":return s.stop()}},l[1],this)}function a(e){return Object.getPrototypeOf(e)===Object.prototype}n.d(t,"b",function(){return p}),n.d(t,"e",function(){return d}),n.d(t,"h",function(){return f}),n.d(t,"g",function(){return h}),n.d(t,"f",function(){return m}),n.d(t,"c",function(){return g}),n.d(t,"d",function(){return v}),n.d(t,"a",function(){return _});var s=n(75),u=n(80),c=n(10),l=(n.n(c),[i,o].map(regeneratorRuntime.mark)),p="tooltip-operation",d="link-operation",f="shadow-operation",h="depth-map-operation",m="bending-page-operation",g="highlight-operation",v="highlight-flash-operation",b=[],y={_pool:[],created:0,get:function(e,t,n,r){if(this._pool.length){var i=this._pool.pop();return i.x=e,i.y=t,i.width=n,i.height=r,i}return this.created++,{x:e,y:t,width:n,height:r}},release:function(e){this._pool.push(e)},unreleasedCount:function(){return this.created-this._pool.length}},_=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.props=t,this.parent=n}return e.prototype.getChildTree=function(e){return e},e.prototype.requestRedraw=function(){this.root._pendingRedraw=!0},e.prototype.getChildrenToTraverse=function(){return this.children},e.prototype.getVisibleChildren=function(){var t=y.get(0,0,this.width,this.height),r=[];return e.traverse(this,function(e,i,o,a){return 0===a||(n.i(u.b)(t,i)&&e.isVisible&&r.push(e),!1)},this.getViewportCTM()),y.release(t),r},e.prototype.getVisibleDescendants=function(){var t=y.get(0,0,this.width,this.height),r=[];return e.traverse(this,function(e,i,o,a){return 0===a||(n.i(u.b)(t,i)&&e.isVisible&&r.push(e),!0)},this.getViewportCTM()),y.release(t),r},e.prototype.overlaps=function(e){var t=this.bbox,r=n.i(u.b)(e,t);return y.release(t),r},e.prototype.shouldComponentUpdate=function(e){if(this.props===e)return!1;var t=Object.keys(this.props);if(t.length!==Object.keys(e).length)return!0;for(var n=0;n<t.length;n++){var r=t[n];if(babelHelpers.typeof(this.props[r])instanceof s.a&&!this.props[r].isEqualWith(e[r]))return!0;if(this.props[r]!==e[r])return!0}return!1},e.prototype.getViewportCTM=function(){var e=this.transform;return this.parent&&(e=this.parent.getViewportCTM().multiply(e)),e},e.prototype.forceUpdate=function(){e.updateProps(this,this.props,!0)},e.updateProps=function(t,n,r){e.buildTree({type:Object.getPrototypeOf(t).constructor,props:n,wrappedChildren:[]},t,t,null,r)},e.buildTree=function(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,s=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,u=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,c=arguments.length>4&&void 0!==arguments[4]&&arguments[4],l=arguments.length>5&&void 0!==arguments[5]?arguments[5]:0,p=t.type,d=t.props,f=t.wrappedChildren;if(n){if(p.prototype!==Object.getPrototypeOf(n))throw new Error("Unsupported update. Trying to replace "+Object.getPrototypeOf(n).constructor.name+" with "+p.prototype.constructor.name);var h=Object.assign({},n.props,d),m=c||n.shouldComponentUpdate(h);m&&n.componentWillUpdate&&n.componentWillUpdate(h);var g=n.props;if(n.props=h,m){r(n.getChildTree(f)).forEach(function(t,r){e.buildTree(t,n.children[r],s,c,l+1)}),n.componentDidUpdate&&n.componentDidUpdate(g),n.requestRedraw()}else for(var v=i(n,s),b=o(t),y=b.next();!y.done;)e.buildTree(y.value,v.next().value,s,c,l+1),y=b.next();return n}var _=new p(d,u);_.owner=s;var w=f.map(function(t){if(a(t)){return e.buildTree(t,n,s,_,c,l+1)}return t.parent=_,t}),E=_.getChildTree(w);return _.children=r(E).map(function(t){if(a(t)){return e.buildTree(t,n,_,_,c,l+1)}return t}),_.componentDidMount&&_.componentDidMount(),_},e.createElement=function(e,t){for(var n=[],r=2;r<arguments.length;r++){var i=arguments[r];Array.isArray(i)?Array.prototype.push.apply(n,i):i&&n.push(i)}return"group"===e?n:{type:e,props:t||{},wrappedChildren:n}},e.traverse=function(t,r){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:new s.a,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,a=i.transformRect(y.get(0,0,t.width,t.height));if(!r(t,a,i,o))return void y.release(a);var c=t.getChildrenToTraverse();if(c&&c.length)for(var l=c.slice(0).sort(function(e,t){return e.zOrder-t.zOrder}),p=l,d=Array.isArray(p),f=0,p=d?p:p[Symbol.iterator]();;){var h;if(d){if(f>=p.length)break;h=p[f++]}else{if(f=p.next(),f.done)break;h=f.value}var m=h,g=i.matrix[0],v=i.matrix[1],b=i.matrix[2],_=i.matrix[3],w=i.matrix[4],E=i.matrix[5];i.mMultiply(m.transform);var x=i.transformRect(y.get(0,0,m.width,m.height));n.i(u.b)(a,x)&&e.traverse(m,r,i,o+1),i.mSet(g,v,b,_,w,E),y.release(x)}y.release(a)},e.drawWebgl=function(t,n,r,i,o){var a={width:n.gl.drawingBufferWidth,height:n.gl.drawingBufferHeight},s=[];e.drawTree(t,r,i,o,function(e,t){e.appendWebglOps&&e.appendWebglOps(s,t,a,i)}),n.gl.clearColor(0,0,0,0),n.gl.clearStencil(0),n.gl.clear(n.gl.COLOR_BUFFER_BIT|n.gl.DEPTH_BUFFER_BIT|n.gl.STENCIL_BUFFER_BIT),s.forEach(function(e){var t,r,i,o,a,s,u;switch(e.type){case p:(t=n.linkTooltip).draw.apply(t,e.args);break;case d:(r=n.link).draw.apply(r,e.args);break;case f:(i=n.shadowDraw).draw.apply(i,[n.shadow.depthMapTexture].concat(e.args));break;case m:(o=n.bendingPage).draw.apply(o,e.args);break;case h:(a=n.shadow).computeDepthMap.apply(a,e.args);break;case g:(s=n.highlights).draw.apply(s,e.args);break;case v:(u=n.highlights).drawSelected.apply(u,e.args);break;default:throw new Error("Unknown 3d operation: "+e.type)}})},e.draw2d=function(t,n,r,i,o){e.drawTree(t,r,i,o,function(e,t){e.draw&&e.draw(n,t,i)})},e.drawTree=function(t,r,i,o,a){if(t._pendingRedraw&&(t._pendingRedraw=!1),t.isVisible){var c=o?new Float32Array(o.matrix):null;o?o.mMultiply(t.transform):o=(new s.a).mMultiply(t.getViewportCTM());var l=o.transformRect(y.get(0,0,t.width,t.height));if(n.i(u.b)(r,l)){t.beforeDraw&&t.beforeDraw(l,i),a(t,l);var p=t.getChildrenToTraverse();p&&p.length&&p.slice(0).sort(function(e,t){return e.zOrder-t.zOrder}).forEach(function(t){return e.drawTree(t,r,i,o,a)}),t.afterDraw&&t.afterDraw(l,i)}y.release(l),c&&o.mSetMatrix(c)}},e.connect=function(t,n){return function(r){function i(e,o){babelHelpers.classCallCheck(this,i);var a=e.store||o.root&&o.root.__store__;if(!a)throw new Error("Cannot connect "+t+": Cannot get store!");var s=a.getState();Object.assign(e,{dispatch:a.dispatch},n(s));var u=babelHelpers.possibleConstructorReturn(this,r.call(this,e,o));return u._unsubscribe=function(){},u}return babelHelpers.inherits(i,r),i.prototype.componentDidMount=function(){var r=this,i=this.root.__store__;if(!i)throw new Error("Root component has no store, cannot connect");this._unsubscribe=i.subscribe(function(){var t=i.getState(),o=Object.assign({dispatch:i.dispatch},r.props,n(t));e.updateProps(r,o)}),t.prototype.componentDidMount&&t.prototype.componentDidMount.call(this)},i.prototype.componentWillUnmount=function(){this._unsubscribe(),t.prototype.componentWillUnmount&&t.prototype.componentWillUnmount.call(this)},babelHelpers.createClass(i,[{key:"displayName",get:function(){return"Connected"+t.name}}]),i}(t)},e.unmountTree=function(t){for(var n=t.children,r=Array.isArray(n),i=0,n=r?n:n[Symbol.iterator]();;){var o;if(r){if(i>=n.length)break;o=n[i++]}else{if(i=n.next(),i.done)break;o=i.value}e.unmountTree(o)}t.componentWillUnmount&&t.componentWillUnmount()},babelHelpers.createClass(e,[{key:"root",get:function(){for(var e=this;e.parent;)e=e.parent;return e}},{key:"inAnimation",get:function(){return!!this.parent&&this.parent.inAnimation}},{key:"hasPendingRedraw",get:function(){return this.root._pendingRedraw}},{key:"transform",get:function(){return this._transform||(this._transform=this.props.transform||new s.a),this._transform}},{key:"viewportBBox",get:function(){return this.getViewportCTM().transformRect(y.get(0,0,this.width,this.height))}},{key:"bbox",get:function(){return this.transform.transformRect(y.get(0,0,this.width,this.height))}},{key:"width",get:function(){return this.props.width}},{key:"height",get:function(){return this.props.height}},{key:"zOrder",get:function(){return 0}},{key:"isVisible",get:function(){return!0}},{key:"displayName",get:function(){return Object.getPrototypeOf(this).constructor.name}}]),e}();_.RectPool=y},function(e,t,n){"use strict";n.d(t,"d",function(){return l}),n.d(t,"c",function(){return p}),n.d(t,"e",function(){return d}),n.d(t,"a",function(){return f}),n.d(t,"b",function(){return h});var r=n(310),i=n(215),o=n(216),a=n(11),s=n(8),u=function(e){return e.config.hosts.main},c=n.i(r.a)({onKeepReading:s.b,selectCurrentPageNumbers:a.selectCurrentPageNumbers,selectHostName:u,selectPublicationCoverUrl:i.a,selectPublicationName:i.b,selectPublicationPageCount:i.c,selectPublicationTitle:i.d,selectPublisherDisplayName:o.a,selectPublisherName:o.b,selectPublisherProfileImageUrl:o.c,selectPublisherProfileUrl:o.d,actionTypes:{READER_POSITION_CHANGED:s.c}}),l=c.actions,p=c.components,d=c.createReducer,f=c.createMiddleware,h=c.selectors},function(e,t){var n=e.exports={version:"2.4.0"};"number"==typeof __e&&(__e=n)},function(e,t,n){var r=n(25);e.exports=function(e,t,n){if(r(e),void 0===t)return e;switch(n){case 1:return function(n){return e.call(t,n)};case 2:return function(n,r){return e.call(t,n,r)};case 3:return function(n,r,i){return e.call(t,n,r,i)}}return function(){return e.apply(t,arguments)}}},function(e,t,n){var r=n(247),i=n(0),o=n(121)("metadata"),a=o.store||(o.store=new(n(250))),s=function(e,t,n){var i=a.get(e);if(!i){if(!n)return;a.set(e,i=new r)}var o=i.get(t);if(!o){if(!n)return;i.set(t,o=new r)}return o};e.exports={store:a,map:s,has:function(e,t,n){var r=s(t,n,!1);return void 0!==r&&r.has(e)},get:function(e,t,n){var r=s(t,n,!1);return void 0===r?void 0:r.get(e)},set:function(e,t,n,r){s(n,r,!0).set(e,t)},keys:function(e,t){var n=s(e,t,!1),r=[];return n&&n.forEach(function(e,t){r.push(t)}),r},key:function(e){return void 0===e||"symbol"==typeof e?e:String(e)},exp:function(e){i(i.S,"Reflect",e)}}},function(e,t,n){"use strict";if(n(14)){var r=n(64),i=n(4),o=n(6),a=n(0),s=n(122),u=n(165),c=n(51),l=n(63),p=n(61),d=n(26),f=n(68),h=n(62),m=n(17),g=n(70),v=n(45),b=n(23),y=n(244),_=n(97),w=n(9),E=n(18),x=n(150),S=n(65),T=n(31),C=n(66).f,I=n(167),M=n(71),P=n(12),R=n(43),O=n(112),k=n(159),A=n(168),N=n(83),D=n(118),L=n(69),F=n(143),U=n(224),B=n(15),H=n(30),j=B.f,z=H.f,W=i.RangeError,V=i.TypeError,G=i.Uint8Array,q=Array.prototype,Y=u.ArrayBuffer,$=u.DataView,K=R(0),X=R(2),Z=R(3),Q=R(4),J=R(5),ee=R(6),te=O(!0),ne=O(!1),re=A.values,ie=A.keys,oe=A.entries,ae=q.lastIndexOf,se=q.reduce,ue=q.reduceRight,ce=q.join,le=q.sort,pe=q.slice,de=q.toString,fe=q.toLocaleString,he=P("iterator"),me=P("toStringTag"),ge=M("typed_constructor"),ve=M("def_constructor"),be=s.CONSTR,ye=s.TYPED,_e=s.VIEW,we=R(1,function(e,t){return Ie(k(e,e[ve]),t)}),Ee=o(function(){return 1===new G(new Uint16Array([1]).buffer)[0]}),xe=!!G&&!!G.prototype.set&&o(function(){new G(1).set({})}),Se=function(e,t){if(void 0===e)throw V("Wrong length!");var n=+e,r=m(e);if(t&&!y(n,r))throw W("Wrong length!");return r},Te=function(e,t){var n=h(e);if(n<0||n%t)throw W("Wrong offset!");return n},Ce=function(e){if(w(e)&&ye in e)return e;throw V(e+" is not a typed array!")},Ie=function(e,t){if(!(w(e)&&ge in e))throw V("It is not a typed array constructor!");return new e(t)},Me=function(e,t){return Pe(k(e,e[ve]),t)},Pe=function(e,t){for(var n=0,r=t.length,i=Ie(e,r);r>n;)i[n]=t[n++];return i},Re=function(e,t,n){j(e,t,{get:function(){return this._d[n]}})},Oe=function(e){var t,n,r,i,o,a,s=E(e),u=arguments.length,l=u>1?arguments[1]:void 0,p=void 0!==l,d=I(s);if(void 0!=d&&!x(d)){for(a=d.call(s),r=[],t=0;!(o=a.next()).done;t++)r.push(o.value);s=r}for(p&&u>2&&(l=c(l,arguments[2],2)),t=0,n=m(s.length),i=Ie(this,n);n>t;t++)i[t]=p?l(s[t],t):s[t];return i},ke=function(){for(var e=0,t=arguments.length,n=Ie(this,t);t>e;)n[e]=arguments[e++];return n},Ae=!!G&&o(function(){fe.call(new G(1))}),Ne=function(){return fe.apply(Ae?pe.call(Ce(this)):Ce(this),arguments)},De={copyWithin:function(e,t){return U.call(Ce(this),e,t,arguments.length>2?arguments[2]:void 0)},every:function(e){return Q(Ce(this),e,arguments.length>1?arguments[1]:void 0)},fill:function(e){return F.apply(Ce(this),arguments)},filter:function(e){return Me(this,X(Ce(this),e,arguments.length>1?arguments[1]:void 0))},find:function(e){return J(Ce(this),e,arguments.length>1?arguments[1]:void 0)},findIndex:function(e){return ee(Ce(this),e,arguments.length>1?arguments[1]:void 0)},forEach:function(e){K(Ce(this),e,arguments.length>1?arguments[1]:void 0)},indexOf:function(e){return ne(Ce(this),e,arguments.length>1?arguments[1]:void 0)},includes:function(e){return te(Ce(this),e,arguments.length>1?arguments[1]:void 0)},join:function(e){return ce.apply(Ce(this),arguments)},lastIndexOf:function(e){return ae.apply(Ce(this),arguments)},map:function(e){return we(Ce(this),e,arguments.length>1?arguments[1]:void 0)},reduce:function(e){return se.apply(Ce(this),arguments)},reduceRight:function(e){return ue.apply(Ce(this),arguments)},reverse:function(){for(var e,t=this,n=Ce(t).length,r=Math.floor(n/2),i=0;i<r;)e=t[i],t[i++]=t[--n],t[n]=e;return t},some:function(e){return Z(Ce(this),e,arguments.length>1?arguments[1]:void 0)},sort:function(e){return le.call(Ce(this),e)},subarray:function(e,t){var n=Ce(this),r=n.length,i=g(e,r);return new(k(n,n[ve]))(n.buffer,n.byteOffset+i*n.BYTES_PER_ELEMENT,m((void 0===t?r:g(t,r))-i))}},Le=function(e,t){return Me(this,pe.call(Ce(this),e,t))},Fe=function(e){Ce(this);var t=Te(arguments[1],1),n=this.length,r=E(e),i=m(r.length),o=0;if(i+t>n)throw W("Wrong length!");for(;o<i;)this[t+o]=r[o++]},Ue={entries:function(){return oe.call(Ce(this))},keys:function(){return ie.call(Ce(this))},values:function(){return re.call(Ce(this))}},Be=function(e,t){return w(e)&&e[ye]&&"symbol"!=typeof t&&t in e&&String(+t)==String(t)},He=function(e,t){return Be(e,t=v(t,!0))?p(2,e[t]):z(e,t)},je=function(e,t,n){return!(Be(e,t=v(t,!0))&&w(n)&&b(n,"value"))||b(n,"get")||b(n,"set")||n.configurable||b(n,"writable")&&!n.writable||b(n,"enumerable")&&!n.enumerable?j(e,t,n):(e[t]=n.value,e)};be||(H.f=He,B.f=je),a(a.S+a.F*!be,"Object",{getOwnPropertyDescriptor:He,defineProperty:je}),o(function(){de.call({})})&&(de=fe=function(){return ce.call(this)});var ze=f({},De);f(ze,Ue),d(ze,he,Ue.values),f(ze,{slice:Le,set:Fe,constructor:function(){},toString:de,toLocaleString:Ne}),Re(ze,"buffer","b"),Re(ze,"byteOffset","o"),Re(ze,"byteLength","l"),Re(ze,"length","e"),j(ze,me,{get:function(){return this[ye]}}),e.exports=function(e,t,n,u){u=!!u;var c=e+(u?"Clamped":"")+"Array",p="Uint8Array"!=c,f="get"+e,h="set"+e,g=i[c],v=g||{},b=g&&T(g),y=!g||!s.ABV,E={},x=g&&g.prototype,I=function(e,n){var r=e._d;return r.v[f](n*t+r.o,Ee)},M=function(e,n,r){var i=e._d;u&&(r=(r=Math.round(r))<0?0:r>255?255:255&r),i.v[h](n*t+i.o,r,Ee)},P=function(e,t){j(e,t,{get:function(){return I(this,t)},set:function(e){return M(this,t,e)},enumerable:!0})};y?(g=n(function(e,n,r,i){l(e,g,c,"_d");var o,a,s,u,p=0,f=0;if(w(n)){if(!(n instanceof Y||"ArrayBuffer"==(u=_(n))||"SharedArrayBuffer"==u))return ye in n?Pe(g,n):Oe.call(g,n);o=n,f=Te(r,t);var h=n.byteLength;if(void 0===i){if(h%t)throw W("Wrong length!");if((a=h-f)<0)throw W("Wrong length!")}else if((a=m(i)*t)+f>h)throw W("Wrong length!");s=a/t}else s=Se(n,!0),a=s*t,o=new Y(a);for(d(e,"_d",{b:o,o:f,l:a,e:s,v:new $(o)});p<s;)P(e,p++)}),x=g.prototype=S(ze),d(x,"constructor",g)):D(function(e){new g(null),new g(e)},!0)||(g=n(function(e,n,r,i){l(e,g,c);var o;return w(n)?n instanceof Y||"ArrayBuffer"==(o=_(n))||"SharedArrayBuffer"==o?void 0!==i?new v(n,Te(r,t),i):void 0!==r?new v(n,Te(r,t)):new v(n):ye in n?Pe(g,n):Oe.call(g,n):new v(Se(n,p))}),K(b!==Function.prototype?C(v).concat(C(b)):C(v),function(e){e in g||d(g,e,v[e])}),g.prototype=x,r||(x.constructor=g));var R=x[he],O=!!R&&("values"==R.name||void 0==R.name),k=Ue.values;d(g,ge,!0),d(x,ye,c),d(x,_e,!0),d(x,ve,g),(u?new g(1)[me]==c:me in x)||j(x,me,{get:function(){return c}}),E[c]=g,a(a.G+a.W+a.F*(g!=v),E),a(a.S,c,{BYTES_PER_ELEMENT:t,from:Oe,of:ke}),"BYTES_PER_ELEMENT"in x||d(x,"BYTES_PER_ELEMENT",t),a(a.P,c,De),L(c),a(a.P+a.F*xe,c,{set:Fe}),a(a.P+a.F*!O,c,Ue),a(a.P+a.F*(x.toString!=de),c,{toString:de}),a(a.P+a.F*o(function(){new g(1).slice()}),c,{slice:Le}),a(a.P+a.F*(o(function(){return[1,2].toLocaleString()!=new g([1,2]).toLocaleString()})||!o(function(){x.toLocaleString.call([1,2])})),c,{toLocaleString:Ne}),N[c]=O?R:k,r||O||d(x,he,k)}}else e.exports=function(){}},function(e,t){var n={};n.EPSILON=1e-6,n.ARRAY_TYPE="undefined"!=typeof Float32Array?Float32Array:Array,n.RANDOM=Math.random,n.ENABLE_SIMD=!1,n.SIMD_AVAILABLE=n.ARRAY_TYPE===Float32Array&&"SIMD"in this,n.USE_SIMD=n.ENABLE_SIMD&&n.SIMD_AVAILABLE,n.setMatrixArrayType=function(e){n.ARRAY_TYPE=e};var r=Math.PI/180;n.toRadian=function(e){return e*r},n.equals=function(e,t){return Math.abs(e-t)<=n.EPSILON*Math.max(1,Math.abs(e),Math.abs(t))},e.exports=n},function(e,t,n){"use strict";function r(e,t,n,r){this.dispatchConfig=e,this._targetInst=t,this.nativeEvent=n;var i=this.constructor.Interface;for(var o in i)if(i.hasOwnProperty(o)){var s=i[o];s?this[o]=s(n):"target"===o?this.target=r:this[o]=n[o]}return this.isDefaultPrevented=(null!=n.defaultPrevented?n.defaultPrevented:n.returnValue===!1)?a.thatReturnsTrue:a.thatReturnsFalse,this.isPropagationStopped=a.thatReturnsFalse,this}var i=n(13),o=n(72),a=n(32),s=(n(5),["dispatchConfig","_targetInst","nativeEvent","isDefaultPrevented","isPropagationStopped","_dispatchListeners","_dispatchInstances"]),u={type:null,target:null,currentTarget:a.thatReturnsNull,eventPhase:null,bubbles:null,cancelable:null,timeStamp:function(e){return e.timeStamp||Date.now()},defaultPrevented:null,isTrusted:null};i(r.prototype,{preventDefault:function(){this.defaultPrevented=!0;var e=this.nativeEvent;e&&(e.preventDefault?e.preventDefault():"unknown"!=typeof e.returnValue&&(e.returnValue=!1),this.isDefaultPrevented=a.thatReturnsTrue)},stopPropagation:function(){var e=this.nativeEvent;e&&(e.stopPropagation?e.stopPropagation():"unknown"!=typeof e.cancelBubble&&(e.cancelBubble=!0),this.isPropagationStopped=a.thatReturnsTrue)},persist:function(){this.isPersistent=a.thatReturnsTrue},isPersistent:a.thatReturnsFalse,destructor:function(){var e=this.constructor.Interface;for(var t in e)this[t]=null;for(var n=0;n<s.length;n++)this[s[n]]=null}}),r.Interface=u,r.augmentClass=function(e,t){var n=this,r=function(){};r.prototype=n.prototype;var a=new r;i(a,e.prototype),e.prototype=a,e.prototype.constructor=e,e.Interface=i({},n.Interface,t),e.augmentClass=n.augmentClass,o.addPoolingTo(e,o.fourArgumentPooler)},o.addPoolingTo(r,o.fourArgumentPooler),e.exports=r},function(e,t,n){"use strict";e.exports={current:null}},function(e,t,n){"use strict";var r=n(638);e.exports=function(e,t,n,i){var o=n?n.call(i,e,t):void 0;if(void 0!==o)return!!o;if(e===t)return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var a=r(e),s=r(t),u=a.length;if(u!==s.length)return!1;i=i||null;for(var c=Object.prototype.hasOwnProperty.bind(t),l=0;l<u;l++){var p=a[l];if(!c(p))return!1;var d=e[p],f=t[p],h=n?n.call(i,d,f,p):void 0;if(h===!1||void 0===h&&d!==f)return!1}return!0}},function(e,t,n){"use strict";n.d(t,"b",function(){return r}),n.d(t,"a",function(){return i}),n.d(t,"k",function(){return o}),n.d(t,"c",function(){return a}),n.d(t,"e",function(){return s}),n.d(t,"f",function(){return u}),n.d(t,"d",function(){return c}),n.d(t,"g",function(){return l}),n.d(t,"h",function(){return p}),n.d(t,"j",function(){return d}),n.d(t,"i",function(){return f});var r=1,i=5,o=250,a=20,s=20,u=45,c=20,l=20,p=45,d=3e3,f=6},function(e,t,n){"use strict";function r(e,t){return e===i.DOUBLE_PAGE_SPREAD?1===t?0:Math.floor(t/2):t-1}t.a=r;var i=n(40)},function(e,t,n){var r=n(71)("meta"),i=n(9),o=n(23),a=n(15).f,s=0,u=Object.isExtensible||function(){return!0},c=!n(6)(function(){return u(Object.preventExtensions({}))}),l=function(e){a(e,r,{value:{i:"O"+ ++s,w:{}}})},p=function(e,t){if(!i(e))return"symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!o(e,r)){if(!u(e))return"F";if(!t)return"E";l(e)}return e[r].i},d=function(e,t){if(!o(e,r)){if(!u(e))return!0;if(!t)return!1;l(e)}return e[r].w},f=function(e){return c&&h.NEED&&u(e)&&!o(e,r)&&l(e),e},h=e.exports={KEY:r,NEED:!1,fastKey:p,getWeak:d,onFreeze:f}},function(e,t){e.exports=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}}},function(e,t){var n=Math.ceil,r=Math.floor;e.exports=function(e){return isNaN(e=+e)?0:(e>0?r:n)(e)}},function(e,t){e.exports=function(e,t,n,r){if(!(e instanceof t)||void 0!==r&&r in e)throw TypeError(n+": incorrect invocation!");return e}},function(e,t){e.exports=!1},function(e,t,n){var r=n(3),i=n(237),o=n(146),a=n(158)("IE_PROTO"),s=function(){},u=function(){var e,t=n(145)("iframe"),r=o.length;for(t.style.display="none",n(148).appendChild(t),t.src="javascript:",e=t.contentWindow.document,e.open(),e.write("<script>document.F=Object</script>"),e.close(),u=e.F;r--;)delete u.prototype[o[r]];return u()};e.exports=Object.create||function(e,t){var n;return null!==e?(s.prototype=r(e),n=new s,s.prototype=null,n[a]=e):n=u(),void 0===t?n:i(n,t)}},function(e,t,n){var r=n(239),i=n(146).concat("length","prototype");t.f=Object.getOwnPropertyNames||function(e){return r(e,i)}},function(e,t,n){var r=n(239),i=n(146);e.exports=Object.keys||function(e){return r(e,i)}},function(e,t,n){var r=n(27);e.exports=function(e,t,n){for(var i in t)r(e,i,t[i],n);return e}},function(e,t,n){"use strict";var r=n(4),i=n(15),o=n(14),a=n(12)("species");e.exports=function(e){var t=r[e];o&&t&&!t[a]&&i.f(t,a,{configurable:!0,get:function(){return this}})}},function(e,t,n){var r=n(62),i=Math.max,o=Math.min;e.exports=function(e,t){return e=r(e),e<0?i(e+t,0):o(e,t)}},function(e,t){var n=0,r=Math.random();e.exports=function(e){return"Symbol(".concat(void 0===e?"":e,")_",(++n+r).toString(36))}},function(e,t,n){"use strict";var r=n(7),i=(n(1),function(e){var t=this;if(t.instancePool.length){var n=t.instancePool.pop();return t.call(n,e),n}return new t(e)}),o=function(e,t){var n=this;if(n.instancePool.length){var r=n.instancePool.pop();return n.call(r,e,t),r}return new n(e,t)},a=function(e,t,n){var r=this;if(r.instancePool.length){var i=r.instancePool.pop();return r.call(i,e,t,n),i}return new r(e,t,n)},s=function(e,t,n,r){var i=this;if(i.instancePool.length){var o=i.instancePool.pop();return i.call(o,e,t,n,r),o}return new i(e,t,n,r)},u=function(e){var t=this;e instanceof t||r("25"),e.destructor(),t.instancePool.length<t.poolSize&&t.instancePool.push(e)},c=i;e.exports={addPoolingTo:function(e,t){var n=e;return n.instancePool=[],n.getPooled=t||c,n.poolSize||(n.poolSize=10),n.release=u,n},oneArgumentPooler:i,twoArgumentPooler:o,threeArgumentPooler:a,fourArgumentPooler:s}},function(e,t,n){"use strict";function r(e,t){return function(n,r){var i=r(),c=i.fullscreen.enabled;o.a()?c||o.b(e).then(function(){n({type:s,fullscreenMethod:a.b})}).then(o.c).then(function(){n({type:u,fullscreenMethod:a.b})}):(window.open(t,"_blank"),n({type:s,fullscreenMethod:a.a}))}}function i(){return function(e,t){t().fullscreen.enabled&&o.d().then(function(){e({type:u,fullscreenMethod:a.b})})}}n.d(t,"c",function(){return c}),t.b=r,t.a=i;var o=n(217),a=n(133),s="ENTER_FULLSCREEN",u="EXIT_FULLSCREEN",c={ENTER_FULLSCREEN:s,EXIT_FULLSCREEN:u}},function(e,t,n){"use strict";function r(e,t,n){var r=e.createShader(n);if(e.shaderSource(r,t),e.compileShader(r),!e.getShaderParameter(r,e.COMPILE_STATUS)&&!e.isContextLost()){var i=n===e.FRAGMENT_SHADER?"fragment":"vertex",o=e.getShaderInfoLog(r)||"",a=(e.getSupportedExtensions()||[]).join(",");throw new Error("Cannot compile "+i+" shader: "+o+"\n["+a+"]")}return r}function i(e,t){if(e.linkProgram(t),!e.getProgramParameter(t,e.LINK_STATUS)&&!e.isContextLost()){var n=e.getProgramInfoLog(t)||"",r=(e.getSupportedExtensions()||[]).join(",");throw new Error("Cannot link shaderprogram: "+n+"\n["+r+"]")}}function o(){for(var e=/^uniform.*\b(\w+)\s*;/gm,t=/^attribute.*\b(\w+)\s*;/gm,n=arguments.length,r=Array(n),i=0;i<n;i++)r[i]=arguments[i];return r.reduce(function(n,r){for(var i=void 0;i=e.exec(r);)n.uniforms.add(i[1]);for(;i=t.exec(r);)n.attributes.add(i[1]);return n},{uniforms:new Set,attributes:new Set})}function a(e,t,n){var a=r(e,t,e.VERTEX_SHADER),u=r(e,n,e.FRAGMENT_SHADER),c=e.createProgram();e.attachShader(c,a),e.attachShader(c,u),i(e,c);for(var l=o(t,n),p={id:c,bind:function(){if(s!==p){s&&s.unbind(),s=p,e.useProgram(p.id);for(var t=l.attributes,n=Array.isArray(t),r=0,t=n?t:t[Symbol.iterator]();;){var i;if(n){if(r>=t.length)break;i=t[r++]}else{if(r=t.next(),r.done)break;i=r.value}e.enableVertexAttribArray(p[i])}}},unbind:function(){for(var t=l.attributes,n=Array.isArray(t),r=0,t=n?t:t[Symbol.iterator]();;){var i;if(n){if(r>=t.length)break;i=t[r++]}else{if(r=t.next(),r.done)break;i=r.value}e.disableVertexAttribArray(p[i])}},destroy:function(){s&&s===p&&(s.unbind(),s=null),e.detachShader(c,a),e.deleteShader(a),e.detachShader(c,u),e.deleteShader(u),e.deleteProgram(c)}},d=l.attributes,f=Array.isArray(d),h=0,d=f?d:d[Symbol.iterator]();;){var m;if(f){if(h>=d.length)break;m=d[h++]}else{if(h=d.next(),h.done)break;m=h.value}var g=m;p[g]=e.getAttribLocation(c,g)}for(var v=l.uniforms,b=Array.isArray(v),y=0,v=b?v:v[Symbol.iterator]();;){var _;if(b){if(y>=v.length)break;_=v[y++]}else{if(y=v.next(),y.done)break;_=y.value}var w=_;p[w]=e.getUniformLocation(c,w)}return p}t.a=a;var s=void 0},function(e,t,n){"use strict";function r(e){return e}n.d(t,"a",function(){return s});var i=n(101),o=(n.n(i),i.vec2.create()),a=i.vec2.create(),s=function(){function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;babelHelpers.classCallCheck(this,e),this.matrix=t||i.mat2d.create()}return e.prototype.inverse=function(){var t=i.mat2d.create();return i.mat2d.invert(t,this.matrix),new e(t)},e.prototype.isIdentityMatrix=function(){return 1===this.matrix[0]&&0===this.matrix[1]&&0===this.matrix[2]&&1===this.matrix[3]&&0===this.matrix[4]&&0===this.matrix[5]},e.prototype.isEqualWith=function(e){for(var t=0;t<this.matrix.length;t++)if(this.matrix[t]!==e.matrix[t])return!1;return!0},e.prototype.multiply=function(t){var n=i.mat2d.create();return i.mat2d.multiply(n,this.matrix,t.matrix),new e(n)},e.prototype.mReset=function(){return i.mat2d.identity(this.matrix),this},e.prototype.mMultiply=function(e){return i.mat2d.multiply(this.matrix,this.matrix,e.matrix),this},e.prototype.mTranslate=function(e,t){var n=i.mat2d.create();return i.mat2d.translate(n,this.matrix,i.vec2.fromValues(e,t)),this.matrix=n,this},e.prototype.mScale=function(e){var t=i.mat2d.create();return i.mat2d.scale(t,this.matrix,i.vec2.fromValues(e,e)),this.matrix=t,this},e.prototype.mSet=function(e,t,n,r,i,o){return this.matrix[0]=e,this.matrix[1]=t,this.matrix[2]=n,this.matrix[3]=r,this.matrix[4]=i,this.matrix[5]=o,this},e.prototype.mSetMatrix=function(e){return this.matrix.set(e),this},e.prototype.transformPoint=function(e,t){var n=i.vec2.create();return i.vec2.transformMat2d(n,i.vec2.fromValues(e,t),this.matrix),Array.from(n).map(r)},e.prototype.transformRect=function(e){i.vec2.transformMat2d(o,i.vec2.set(o,e.x,e.y),this.matrix),i.vec2.transformMat2d(a,i.vec2.set(a,e.x+e.width,e.y+e.height),this.matrix);var t=Math.min(o[0],a[0]),n=Math.max(o[0],a[0]),s=Math.min(o[1],a[1]),u=Math.max(o[1],a[1]);return e.x=r(t),e.y=r(s),e.width=r(n-t),e.height=r(u-s),e},e.prototype.transformCanvasCtx=function(e){e.transform(this.matrix[0],this.matrix[1],this.matrix[2],this.matrix[3],this.matrix[4],this.matrix[5])},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return c});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(57),u=n.n(s),c=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e,t){return!(u()(this.props,e)&&u()(this.state,t))},t.prototype.render=function(){var e={};return this.props.isHidden&&(e.display="none"),i.a.createElement("button",{className:this.props.className,onClick:this.props.onClick,disabled:this.props.isDisabled,id:this.props.id,dangerouslySetInnerHTML:{__html:this.props.content},style:e,type:"button"},this.props.children)},t}(r.Component);c.displayName="Button",c.propTypes={children:a.a.node,className:a.a.string,content:a.a.string,id:a.a.string,isDisabled:a.a.bool,isHidden:a.a.bool,onClick:a.a.func}},function(e,t,n){"use strict";function r(e,t){return function(r,i){r({type:f,embedConfig:e,readMorePlugin:t});var o=n.i(c.selectReadMode)(i());r(n.i(a.j)(n.i(u.a)(o,e.startPage)));var p=i().config,d=i().documentModel;i().readMorePlugin.load(p.getScheme(),p.hosts.main,d.publicationId,d.username,n.i(l.a)("customization_show_my_other_publications",d,!0),n.i(l.a)("norelated",d,!0)).then(function(e){e&&r(n.i(s.d)())})}}function i(e){return function(t,r){var i=n.i(c.selectReadMode)(r());return t(n.i(a.j)(n.i(u.a)(i,e)))}}function o(e){var t={ON_DOCUMENT_LOAD_EVENT:h,ON_PAGE_CHANGE_EVENT:h,ON_ENTER_FULLSCREEN:h,ON_EXIT_FULLSCREEN:h};return{types:{ENABLE_TRACKING:d,EMBED_PREVIEW:f},middleware:function(n){return function(r){return function(i){var o=r(i),u=n.getState();try{switch(i.type){case p.c.ENTER_FULLSCREEN:t.ON_ENTER_FULLSCREEN();break;case p.c.EXIT_FULLSCREEN:t.ON_EXIT_FULLSCREEN();break;case s.c.DOCUMENTLOAD_SUCCESS:var l=c.selectCurrentPageNumbers(u);t.ON_DOCUMENT_LOAD_EVENT(l);break;case a.a.READER_POSITION_CHANGED:if(i.currentPagesHasChanged){var d=i.currentPages.map(function(e){return e.pageNumber});t.ON_PAGE_CHANGE_EVENT(d)}}}catch(t){e(t)}return o}}},api:function(e){return{beginTrackingReads:function(){e.dispatch({type:d})},embedPreview:function(t,n){e.dispatch(r(t,n))},getPageNumbers:function(){return c.selectCurrentPageNumbers(e.getState())},getPageCount:function(){return e.getState().documentModel.pageCount},setPageNumber:function(t){e.dispatch(i(t))},goToPreviousPage:function(){e.dispatch(n.i(a.d)())},goToNextPage:function(){e.dispatch(n.i(a.b)())},setCallback:function(e,n){t.hasOwnProperty(e)&&(t[e]=n)}}}}}n.d(t,"c",function(){return d}),n.d(t,"b",function(){return f}),t.a=o;var a=n(8),s=n(19),u=n(59),c=n(11),l=n(141),p=n(73),d="ENABLE_TRACKING",f="EMBED_PREVIEW",h=function(){}},function(e,t,n){"use strict";n.d(t,"a",function(){return r}),n.d(t,"b",function(){return i}),n.d(t,"f",function(){return o}),n.d(t,"g",function(){return a}),n.d(t,"h",function(){return s}),n.d(t,"e",function(){return u}),n.d(t,"c",function(){return c}),n.d(t,"d",function(){return l});var r="SWIPE_LEFT",i="SWIPE_RIGHT",o="SWIPE_UP",a="SWIPE_DOWN",s="SWIPE_OTHER",u="ZOOM_OUT",c="ZOOM_IN",l="UNDEFINED"},function(e,t,n){"use strict";n.d(t,"a",function(){return c});var r=n(360),i=n(362),o=n(361),a=n(363),s=n(364),u={BROWSER:"BROWSER",READER:"READER",NONE:"NONE"},c=function(){function e(t,n){var c=this;babelHelpers.classCallCheck(this,e),this._interceptedBy=u.NONE,this._lastPointerEventTimeStamp=0,this._lastTouchEventTimeStamp=0,this.targetElement=t;var l=!!Object.keys(n).find(function(e){return/gesture|tap/i.test(e)});this.options={shouldInvokeSetPointerCapture:function(){return l},shouldInvokePreventDefault:function(){return c._interceptedBy===u.READER},hasBrowserIntercepted:function(){return c._interceptedBy===u.BROWSER},updateInterceptionWithTouchEvent:function(e){e.cancelable||(c._interceptedBy=u.BROWSER)},resetInterception:function(){c._interceptedBy=u.NONE,c.options.activeHandler=null},updateLastPointerEventTimeStamp:function(e){c._lastPointerEventTimeStamp=e.timeStamp},updateLastTouchEventTimeStamp:function(e){c._lastTouchEventTimeStamp=e.timeStamp},isSimulatedMouseEvents:function(e){return c._lastPointerEventTimeStamp>e.timeStamp||c._lastTouchEventTimeStamp>e.timeStamp},activeHandler:null},this._handlers=[new i.a(t,n,this.options),new o.a(t,n,this.options),new a.a(t,n,this.options),new r.a(t,n,this.options),new s.a(t,n,this.options)],this.enableBrowserHandlingOfVerticalPanningGestures()}return e.prototype.destroy=function(){this._handlers.forEach(function(e){e.destroy()})},e.prototype.reset=function(){this._interceptedBy=u.NONE,this._handlers.forEach(function(e){e.reset()}),this.options.activeHandler=null},e.prototype.requestToIntercept=function(){this._interceptedBy===u.NONE&&(this._interceptedBy=u.READER)},e.prototype.enableBrowserHandlingOfVerticalPanningGestures=function(){this.targetElement.style.touchAction="pan-y"},e.prototype.disableBrowserHandlingOfAllPanningGestures=function(){this.targetElement.style.touchAction="none"},e}()},function(e,t,n){"use strict";function r(e,t){var n=e.x,r=e.x+e.width,i=t.x,o=t.x+t.width,a=e.y,s=e.y+e.height,u=t.y,c=t.y+t.height,l=Math.max(0,Math.min(r,o)-Math.max(n,i))*Math.max(0,Math.min(s,c)-Math.max(a,u));return l>0?l/(t.width*t.height):0}function i(e,t,n){return e>=n.x&&e<n.x+n.width&&t>=n.y&&t<n.y+n.height}function o(e,t,n,r){return n/e<=r/t?n/e:r/t}t.b=r,t.a=i,t.c=o},function(e,t,n){var r=n(12)("unscopables"),i=Array.prototype;void 0==i[r]&&n(26)(i,r,{}),e.exports=function(e){i[r][e]=!0}},function(e,t,n){var r=n(51),i=n(233),o=n(150),a=n(3),s=n(17),u=n(167),c={},l={},t=e.exports=function(e,t,n,p,d){var f,h,m,g,v=d?function(){return e}:u(e),b=r(n,p,t?2:1),y=0;if("function"!=typeof v)throw TypeError(e+" is not iterable!");if(o(v)){for(f=s(e.length);f>y;y++)if((g=t?b(a(h=e[y])[0],h[1]):b(e[y]))===c||g===l)return g}else for(m=v.call(e);!(h=m.next()).done;)if((g=i(m,b,h.value,t))===c||g===l)return g};t.BREAK=c,t.RETURN=l},function(e,t){e.exports={}},function(e,t,n){var r=n(15).f,i=n(23),o=n(12)("toStringTag");e.exports=function(e,t,n){e&&!i(e=n?e:e.prototype,o)&&r(e,o,{configurable:!0,value:t})}},function(e,t,n){var r=n(0),i=n(37),o=n(6),a=n(163),s="["+a+"]",u="​",c=RegExp("^"+s+s+"*"),l=RegExp(s+s+"*$"),p=function(e,t,n){var i={},s=o(function(){return!!a[e]()||u[e]()!=u}),c=i[e]=s?t(d):a[e];n&&(i[n]=c),r(r.P+r.F*s,"String",i)},d=p.trim=function(e,t){return e=String(i(e)),1&t&&(e=e.replace(c,"")),2&t&&(e=e.replace(l,"")),e};e.exports=p},function(e,t,n){"use strict";e.exports=n(663)},function(e,t,n){"use strict";function r(e){if(h){var t=e.node,n=e.children;if(n.length)for(var r=0;r<n.length;r++)m(t,n[r],null);else null!=e.html?p(t,e.html):null!=e.text&&f(t,e.text)}}function i(e,t){e.parentNode.replaceChild(t.node,e),r(t)}function o(e,t){h?e.children.push(t):e.node.appendChild(t.node)}function a(e,t){h?e.html=t:p(e.node,t)}function s(e,t){h?e.text=t:f(e.node,t)}function u(){return this.node.nodeName}function c(e){return{node:e,children:[],html:null,text:null,toString:u}}var l=n(174),p=n(128),d=n(182),f=n(287),h="undefined"!=typeof document&&"number"==typeof document.documentMode||"undefined"!=typeof navigator&&"string"==typeof navigator.userAgent&&/\bEdge\/\d/.test(navigator.userAgent),m=d(function(e,t,n){11===t.node.nodeType||1===t.node.nodeType&&"object"===t.node.nodeName.toLowerCase()&&(null==t.node.namespaceURI||t.node.namespaceURI===l.html)?(r(t),e.insertBefore(t.node,n)):(e.insertBefore(t.node,n),r(t))});c.insertTreeBefore=m,c.replaceChildWithTree=i,c.queueChild=o,c.queueHTML=a,c.queueText=s,e.exports=c},function(e,t,n){"use strict";function r(e,t){return(e&t)===t}var i=n(7),o=(n(1),{MUST_USE_PROPERTY:1,HAS_BOOLEAN_VALUE:4,HAS_NUMERIC_VALUE:8,HAS_POSITIVE_NUMERIC_VALUE:24,HAS_OVERLOADED_BOOLEAN_VALUE:32,injectDOMPropertyConfig:function(e){var t=o,n=e.Properties||{},a=e.DOMAttributeNamespaces||{},u=e.DOMAttributeNames||{},c=e.DOMPropertyNames||{},l=e.DOMMutationMethods||{};e.isCustomAttribute&&s._isCustomAttributeFunctions.push(e.isCustomAttribute);for(var p in n){s.properties.hasOwnProperty(p)&&i("48",p);var d=p.toLowerCase(),f=n[p],h={attributeName:d,attributeNamespace:null,propertyName:p,mutationMethod:null,mustUseProperty:r(f,t.MUST_USE_PROPERTY),hasBooleanValue:r(f,t.HAS_BOOLEAN_VALUE),hasNumericValue:r(f,t.HAS_NUMERIC_VALUE),hasPositiveNumericValue:r(f,t.HAS_POSITIVE_NUMERIC_VALUE),hasOverloadedBooleanValue:r(f,t.HAS_OVERLOADED_BOOLEAN_VALUE)};if(h.hasBooleanValue+h.hasNumericValue+h.hasOverloadedBooleanValue<=1||i("50",p),u.hasOwnProperty(p)){var m=u[p];h.attributeName=m}a.hasOwnProperty(p)&&(h.attributeNamespace=a[p]),c.hasOwnProperty(p)&&(h.propertyName=c[p]),l.hasOwnProperty(p)&&(h.mutationMethod=l[p]),s.properties[p]=h}}}),a=":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD",s={ID_ATTRIBUTE_NAME:"data-reactid",ROOT_ATTRIBUTE_NAME:"data-reactroot",ATTRIBUTE_NAME_START_CHAR:a,ATTRIBUTE_NAME_CHAR:a+"\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040",properties:{},getPossibleStandardName:null,_isCustomAttributeFunctions:[],isCustomAttribute:function(e){for(var t=0;t<s._isCustomAttributeFunctions.length;t++){if((0,s._isCustomAttributeFunctions[t])(e))return!0}return!1},injection:o};e.exports=s},function(e,t,n){"use strict";function r(){i.attachRefs(this,this._currentElement)}var i=n(686);n(39),n(5);e.exports={mountComponent:function(e,t,n,i,o,a){var s=e.mountComponent(t,n,i,o,a);return e._currentElement&&null!=e._currentElement.ref&&t.getReactMountReady().enqueue(r,e),s},getHostNode:function(e){return e.getHostNode()},unmountComponent:function(e,t){i.detachRefs(e,e._currentElement),e.unmountComponent(t)},receiveComponent:function(e,t,n,o){var a=e._currentElement;if(t!==a||o!==e._context){var s=i.shouldUpdateRefs(a,t);s&&i.detachRefs(e,a),e.receiveComponent(t,n,o),s&&e._currentElement&&null!=e._currentElement.ref&&n.getReactMountReady().enqueue(r,e)}},performUpdateIfNecessary:function(e,t,n){e._updateBatchNumber===n&&e.performUpdateIfNecessary(t)}}},function(e,t,n){"use strict";var r=n(13),i=n(724),o=n(190),a=n(729),s=n(725),u=n(726),c=n(91),l=n(728),p=n(730),d=n(733),f=(n(5),c.createElement),h=c.createFactory,m=c.cloneElement,g=r,v={Children:{map:i.map,forEach:i.forEach,count:i.count,toArray:i.toArray,only:d},Component:o,PureComponent:a,createElement:f,cloneElement:m,isValidElement:c.isValidElement,PropTypes:l,createClass:s.createClass,createFactory:h,createMixin:function(e){return e},DOM:u,version:p,__spread:g};e.exports=v},function(e,t,n){"use strict";function r(e){return void 0!==e.ref}function i(e){return void 0!==e.key}var o=n(13),a=n(56),s=(n(5),n(295),Object.prototype.hasOwnProperty),u=n(294),c={key:!0,ref:!0,__self:!0,__source:!0},l=function(e,t,n,r,i,o,a){var s={$$typeof:u,type:e,key:t,ref:n,props:a,_owner:o};return s};l.createElement=function(e,t,n){var o,u={},p=null,d=null;if(null!=t){r(t)&&(d=t.ref),i(t)&&(p=""+t.key),void 0===t.__self?null:t.__self,void 0===t.__source?null:t.__source;for(o in t)s.call(t,o)&&!c.hasOwnProperty(o)&&(u[o]=t[o])}var f=arguments.length-2;if(1===f)u.children=n;else if(f>1){for(var h=Array(f),m=0;m<f;m++)h[m]=arguments[m+2];u.children=h}if(e&&e.defaultProps){var g=e.defaultProps;for(o in g)void 0===u[o]&&(u[o]=g[o])}return l(e,p,d,0,0,a.current,u)},l.createFactory=function(e){var t=l.createElement.bind(null,e);return t.type=e,t},l.cloneAndReplaceKey=function(e,t){return l(e.type,t,e.ref,0,0,e._owner,e.props)},l.cloneElement=function(e,t,n){var u,p=o({},e.props),d=e.key,f=e.ref,h=e._owner;if(null!=t){r(t)&&(f=t.ref,h=a.current),i(t)&&(d=""+t.key);var m;e.type&&e.type.defaultProps&&(m=e.type.defaultProps);for(u in t)s.call(t,u)&&!c.hasOwnProperty(u)&&(p[u]=void 0===t[u]&&void 0!==m?m[u]:t[u])}var g=arguments.length-2;if(1===g)p.children=n;else if(g>1){for(var v=Array(g),b=0;b<g;b++)v[b]=arguments[b+2];p.children=v}return l(e.type,d,f,0,0,h,p)},l.isValidElement=function(e){return"object"==typeof e&&null!==e&&e.$$typeof===u},e.exports=l},function(e,t,n){"use strict";function r(e){for(var t=arguments.length-1,n="Minified React error #"+e+"; visit http://facebook.github.io/react/docs/error-decoder.html?invariant="+e,r=0;r<t;r++)n+="&args[]="+encodeURIComponent(arguments[r+1]);n+=" for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";var i=new Error(n);throw i.name="Invariant Violation",i.framesToPop=1,i}e.exports=r},function(e,t,n){"use strict";function r(e){return n.i(i.createSelector)(function(e){return e.documentModel},function(e){return e.features.disableLicenseCheck},function(t,r){return n.i(o.a)(e,t,r)})}Object.defineProperty(t,"__esModule",{value:!0}),n.d(t,"canChangeBackgroundColor",function(){return a}),n.d(t,"canHideShareButton",function(){return s}),n.d(t,"canHideIssuuBranding",function(){return u}),n.d(t,"canChangeBackgroundImage",function(){return c}),n.d(t,"canChangeLogo",function(){return l}),n.d(t,"canSeeOwnPublication",function(){return p}),n.d(t,"canHideRelated",function(){return d}),n.d(t,"canDownloadAnonymously",function(){return f});var i=n(33),o=(n.n(i),n(141)),a=r("customization_set_bg_color"),s=r("customization_disable_share"),u=r("customization_remove_link_below"),c=r("customization_set_bg_image"),l=r("customization_set_logo"),p=r("customization_show_my_other_publications"),d=r("norelated"),f=function(e){return n.i(o.a)("download",e.documentModel,!1)}},function(e,t,n){"use strict";n.d(t,"a",function(){return c});var r=function(){return Math.min(window.screen.width,window.screen.height)},i=function(){return!!window.FEATURE_TEST_IS_TOUCH||"ontouchstart"in window||window.navigator.maxTouchPoints>0||window.navigator.msMaxTouchPoints>0},o=function(){return i()&&r()<480},a=function(){return i()&&!o()&&r()<=1024},s=function(){return"callPhantom"in window},u=function(){return!!navigator.platform&&["iPad Simulator","iPhone Simulator","iPod Simulator","iPad","iPhone","iPod"].includes(navigator.platform)},c={isTouch:i,isMobile:o,isTablet:a,isPhantom:s,isIOS:u}},function(e,t,n){"use strict";function r(){return{type:l}}function i(){return{type:p}}function o(){return{type:d}}function a(e){return{type:f,width:e}}function s(e){return{type:h,height:e}}function u(e){var t={supportsWebGL:e,maxDrawingBufferWidth:6e3,maxDrawingBufferHeight:6e3,forceTo2D:!0};return function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:t,n=arguments[1];switch(n.type){case l:return Object.assign({},e,{supportsWebGL:!1});case p:return Object.assign({},e,{forceTo2D:!1});case d:return Object.assign({},e,{forceTo2D:!0});case f:return Object.assign({},e,{maxDrawingBufferWidth:n.width});case h:return Object.assign({},e,{maxDrawingBufferHeight:n.height});default:return e}}}t.d=r,t.a=i,t.e=o,t.b=a,t.c=s,t.g=u,n.d(t,"f",function(){return m});var c=n(33),l=(n.n(c),"WEBGL_ERROR"),p="ENABLE_WEBGL",d="DISABLE_WEBGL",f="SET_MAX_DRAWING_BUFFER_WIDTH",h="SET_MAX_DRAWING_BUFFER_HEIGHT",m=n.i(c.createSelector)(function(e){return e.canvasContext},function(e){return e.size},function(e,t){return!(!e.supportsWebGL||e.forceTo2D)&&(e.maxDrawingBufferWidth>=t.width&&e.maxDrawingBufferHeight>=t.height)})},function(e,t,n){"use strict";function r(e,t,n,r){var i=r.specs,o=void 0===i?{}:i,a=r.action,s=void 0===a?{}:a,u=s.data,c=void 0===u?{}:u,l=o.x,p=o.y,f=o.width,h=o.height,m={};switch(m.type=s.type,m.x=l*t,m.y=p*n,m.width=f*t,m.height=h*n,m.clippingId=r.id,m.page={pageNumber:e},m.isShoppingLink="shopping_new"===r.icon,m.isVideoLink=!(m.type!==d.a||!c.service||!c.videoid),m.isVideoLink&&(m.videoLink={isSafe:!c.explicit,service:c.service,videoId:c.videoid}),m.type){case d.a:m.url=c.url;break;case d.b:m.pageNumber=c.pageNumber;break;default:throw new Error("Unknown link type: "+m.type)}return Object.keys(m).forEach(function(e){if(void 0===m[e])throw new Error("Property "+e+" is not defined")}),m}function i(e,t,n){return(arguments.length>3&&void 0!==arguments[3]?arguments[3]:[]).map(function(i){return r(e,t,n,i)})}function o(e,t){return{documentId:e,pageNumber:t.pageNumber,width:t.width,height:t.height,layersInfo:t.layersInfo,imageUri:t.imageUri,links:i(t.pageNumber,t.width,t.height,arguments.length>2&&void 0!==arguments[2]?arguments[2]:[])}}function a(e){var t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return(arguments.length>1&&void 0!==arguments[1]?arguments[1]:[]).map(function(n){return o(e,n,t[n.pageNumber])}).sort(function(e,t){return e.pageNumber-t.pageNumber})}function s(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return Object.keys(e||{}).map(function(t){return{name:t,value:e[t]}})}function u(e){return{type:h,doc:e}}function c(e){return{type:m,clippings:e}}function l(){return function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{linksLoaded:!1},t=arguments[1];switch(t.type){case m:var n=t.clippings;return Object.assign({},e,{linksLoaded:!0,pages:e.pages.map(function(e){return Object.assign({},e,{links:i(e.pageNumber,e.width,e.height,n[e.pageNumber])})})});case h:var r=t.doc,o=r.revisionId+"-"+r.publicationId;return Object.assign({},e,{documentName:r.documentName.toLowerCase(),username:r.userName.toLowerCase(),userDisplayName:r.userDisplayName,publicationId:r.publicationId,revisionId:r.revisionId,pageCount:r.pageCount,title:r.title,publishDate:r.originalPublishDate,downloadable:r.downloadable,documentId:o,pages:a(o,r.pages,r.clippings),licenses:s(r.licenses)});default:return e}}}t.d=u,t.c=c,t.f=l,n.d(t,"a",function(){return g}),n.d(t,"b",function(){return v}),n.d(t,"e",function(){return b});var p=n(33),d=(n.n(p),n(134)),f=n(42),h=Symbol("DOCUMENTLOADED"),m=Symbol("LINKSLOADED"),g=n.i(p.createSelector)(function(e){return e.documentModel.pages},f.a.selectTextInfoPageModels,f.a.selectResults,f.a.selectCurrentResult,function(e,t,n,r){return e.map(function(e){return Object.assign({},e,{textInfoPage:t.find(function(t){return t.pageNumber===e.pageNumber}),findResults:n.reduce(function(t,n){return n.pageNo===e.pageNumber&&t.push(n.result),t},[]),selectedFindResult:r&&r.pageNo===e.pageNumber?r.result:null})})}),v=n.i(p.createSelector)(g,function(e){var t=[],n=e.length;if(n>0){t.push({pages:[e[0]]});for(var r=1;r<n-1;r+=2)t.push({pages:[e[r],e[r+1]]});n%2==0&&t.push({pages:[e[n-1]]})}return t}),b=function(e){return e.documentModel.pageCount}},function(e,t,n){var r=n(36),i=n(12)("toStringTag"),o="Arguments"==r(function(){return arguments}()),a=function(e,t){try{return e[t]}catch(e){}};e.exports=function(e){var t,n,s;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(n=a(t=Object(e),i))?n:o?r(t):"Object"==(s=r(t))&&"function"==typeof t.callee?"Arguments":s}},function(e,t,n){var r=n(36);e.exports=Object("z").propertyIsEnumerable(0)?Object:function(e){return"String"==r(e)?e.split(""):Object(e)}},function(e,t){t.f={}.propertyIsEnumerable},function(e,t,n){"use strict";var r={};e.exports=r},function(e,t,n){t.glMatrix=n(54),t.mat2=n(606),t.mat2d=n(607),t.mat3=n(262),t.mat4=n(608),t.quat=n(609),t.vec2=n(610),t.vec3=n(263),t.vec4=n(264)},function(e,t,n){"use strict";function r(e){return"button"===e||"input"===e||"select"===e||"textarea"===e}function i(e,t,n){switch(e){case"onClick":case"onClickCapture":case"onDoubleClick":case"onDoubleClickCapture":case"onMouseDown":case"onMouseDownCapture":case"onMouseMove":case"onMouseMoveCapture":case"onMouseUp":case"onMouseUpCapture":return!(!n.disabled||!r(t));default:return!1}}var o=n(7),a=n(175),s=n(176),u=n(180),c=n(281),l=n(282),p=(n(1),{}),d=null,f=function(e,t){e&&(s.executeDispatchesInOrder(e,t),e.isPersistent()||e.constructor.release(e))},h=function(e){return f(e,!0)},m=function(e){return f(e,!1)},g=function(e){return"."+e._rootNodeID};e.exports={injection:{injectEventPluginOrder:a.injectEventPluginOrder,injectEventPluginsByName:a.injectEventPluginsByName},putListener:function(e,t,n){"function"!=typeof n&&o("94",t,typeof n);var r=g(e);(p[t]||(p[t]={}))[r]=n;var i=a.registrationNameModules[t];i&&i.didPutListener&&i.didPutListener(e,t,n)},getListener:function(e,t){var n=p[t];if(i(t,e._currentElement.type,e._currentElement.props))return null;var r=g(e);return n&&n[r]},deleteListener:function(e,t){var n=a.registrationNameModules[t];n&&n.willDeleteListener&&n.willDeleteListener(e,t);var r=p[t];if(r){delete r[g(e)]}},deleteAllListeners:function(e){var t=g(e);for(var n in p)if(p.hasOwnProperty(n)&&p[n][t]){var r=a.registrationNameModules[n];r&&r.willDeleteListener&&r.willDeleteListener(e,n),delete p[n][t]}},extractEvents:function(e,t,n,r){for(var i,o=a.plugins,s=0;s<o.length;s++){var u=o[s];if(u){var l=u.extractEvents(e,t,n,r);l&&(i=c(i,l))}}return i},enqueueEvents:function(e){e&&(d=c(d,e))},processEventQueue:function(e){var t=d;d=null,e?l(t,h):l(t,m),d&&o("95"),u.rethrowCaughtError()},__purge:function(){p={}},__getListenerBank:function(){return p}}},function(e,t,n){"use strict";function r(e,t,n){return v(e,t.dispatchConfig.phasedRegistrationNames[n])}function i(e,t,n){var i=r(e,n,t);i&&(n._dispatchListeners=m(n._dispatchListeners,i),n._dispatchInstances=m(n._dispatchInstances,e))}function o(e){e&&e.dispatchConfig.phasedRegistrationNames&&h.traverseTwoPhase(e._targetInst,i,e)}function a(e){if(e&&e.dispatchConfig.phasedRegistrationNames){var t=e._targetInst,n=t?h.getParentInstance(t):null;h.traverseTwoPhase(n,i,e)}}function s(e,t,n){if(n&&n.dispatchConfig.registrationName){var r=n.dispatchConfig.registrationName,i=v(e,r);i&&(n._dispatchListeners=m(n._dispatchListeners,i),n._dispatchInstances=m(n._dispatchInstances,e))}}function u(e){e&&e.dispatchConfig.registrationName&&s(e._targetInst,null,e)}function c(e){g(e,o)}function l(e){g(e,a)}function p(e,t,n,r){h.traverseEnterLeave(n,r,s,e,t)}function d(e){g(e,u)}var f=n(102),h=n(176),m=n(281),g=n(282),v=(n(5),f.getListener);e.exports={accumulateTwoPhaseDispatches:c,accumulateTwoPhaseDispatchesSkipTarget:l,accumulateDirectDispatches:d,accumulateEnterLeaveDispatches:p}},function(e,t,n){"use strict";e.exports={remove:function(e){e._reactInternalInstance=void 0},get:function(e){return e._reactInternalInstance},has:function(e){return void 0!==e._reactInternalInstance},set:function(e,t){e._reactInternalInstance=t}}},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(55),o=n(185);i.augmentClass(r,{view:function(e){if(e.view)return e.view;var t=o(e);if(t.window===t)return t;var n=t.ownerDocument;return n?n.defaultView||n.parentWindow:window},detail:function(e){return e.detail||0}}),e.exports=r},function(e,t){function n(){throw new Error("setTimeout has not been defined")}function r(){throw new Error("clearTimeout has not been defined")}function i(e){if(l===setTimeout)return setTimeout(e,0);if((l===n||!l)&&setTimeout)return l=setTimeout,setTimeout(e,0);try{return l(e,0)}catch(t){try{return l.call(null,e,0)}catch(t){return l.call(this,e,0)}}}function o(e){if(p===clearTimeout)return clearTimeout(e);if((p===r||!p)&&clearTimeout)return p=clearTimeout,clearTimeout(e);try{return p(e)}catch(t){try{return p.call(null,e)}catch(t){return p.call(this,e)}}}function a(){m&&f&&(m=!1,f.length?h=f.concat(h):g=-1,h.length&&s())}function s(){if(!m){var e=i(a);m=!0;for(var t=h.length;t;){for(f=h,h=[];++g<t;)f&&f[g].run();g=-1,t=h.length}f=null,m=!1,o(e)}}function u(e,t){this.fun=e,this.array=t}function c(){}var l,p,d=e.exports={};!function(){try{l="function"==typeof setTimeout?setTimeout:n}catch(e){l=n}try{p="function"==typeof clearTimeout?clearTimeout:r}catch(e){p=r}}();var f,h=[],m=!1,g=-1;d.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];h.push(new u(e,t)),1!==h.length||m||i(s)},u.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=c,d.addListener=c,d.once=c,d.off=c,d.removeListener=c,d.removeAllListeners=c,d.emit=c,d.prependListener=c,d.prependOnceListener=c,d.listeners=function(e){return[]},d.binding=function(e){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(e){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}},function(module,__webpack_exports__,__webpack_require__){"use strict";(function(global){function createCommonjsModule(e,t){return t={exports:{}},e(t,t.exports),t.exports}function asPromise(e,t){for(var n=new Array(arguments.length-1),r=0,i=2,o=!0;i<arguments.length;)n[r++]=arguments[i++];return new Promise(function(i,a){n[r]=function(e){if(o)if(o=!1,e)a(e);else{for(var t=new Array(arguments.length-1),n=0;n<t.length;)t[n++]=arguments[n];i.apply(null,t)}};try{e.apply(t||null,n)}catch(e){o&&(o=!1,a(e))}})}function EventEmitter(){this._listeners={}}function factory(e){return"undefined"!=typeof Float32Array?function(){function t(e,t,n){o[0]=e,t[n]=a[0],t[n+1]=a[1],t[n+2]=a[2],t[n+3]=a[3]}function n(e,t,n){o[0]=e,t[n]=a[3],t[n+1]=a[2],t[n+2]=a[1],t[n+3]=a[0]}function r(e,t){return a[0]=e[t],a[1]=e[t+1],a[2]=e[t+2],a[3]=e[t+3],o[0]}function i(e,t){return a[3]=e[t],a[2]=e[t+1],a[1]=e[t+2],a[0]=e[t+3],o[0]}var o=new Float32Array([-0]),a=new Uint8Array(o.buffer),s=128===a[3];e.writeFloatLE=s?t:n,e.writeFloatBE=s?n:t,e.readFloatLE=s?r:i,e.readFloatBE=s?i:r}():function(){function t(e,t,n,r){var i=t<0?1:0;if(i&&(t=-t),0===t)e(1/t>0?0:2147483648,n,r);else if(isNaN(t))e(2143289344,n,r);else if(t>3.4028234663852886e38)e((i<<31|2139095040)>>>0,n,r);else if(t<1.1754943508222875e-38)e((i<<31|Math.round(t/1.401298464324817e-45))>>>0,n,r);else{var o=Math.floor(Math.log(t)/Math.LN2),a=8388607&Math.round(t*Math.pow(2,-o)*8388608);e((i<<31|o+127<<23|a)>>>0,n,r)}}function n(e,t,n){var r=e(t,n),i=2*(r>>31)+1,o=r>>>23&255,a=8388607&r;return 255===o?a?NaN:i*(1/0):0===o?1.401298464324817e-45*i*a:i*Math.pow(2,o-150)*(a+8388608)}e.writeFloatLE=t.bind(null,writeUintLE),e.writeFloatBE=t.bind(null,writeUintBE),e.readFloatLE=n.bind(null,readUintLE),e.readFloatBE=n.bind(null,readUintBE)}(),"undefined"!=typeof Float64Array?function(){function t(e,t,n){o[0]=e,t[n]=a[0],t[n+1]=a[1],t[n+2]=a[2],t[n+3]=a[3],t[n+4]=a[4],t[n+5]=a[5],t[n+6]=a[6],t[n+7]=a[7]}function n(e,t,n){o[0]=e,t[n]=a[7],t[n+1]=a[6],t[n+2]=a[5],t[n+3]=a[4],t[n+4]=a[3],t[n+5]=a[2],t[n+6]=a[1],t[n+7]=a[0]}function r(e,t){return a[0]=e[t],a[1]=e[t+1],a[2]=e[t+2],a[3]=e[t+3],a[4]=e[t+4],a[5]=e[t+5],a[6]=e[t+6],a[7]=e[t+7],o[0]}function i(e,t){return a[7]=e[t],a[6]=e[t+1],a[5]=e[t+2],a[4]=e[t+3],a[3]=e[t+4],a[2]=e[t+5],a[1]=e[t+6],a[0]=e[t+7],o[0]}var o=new Float64Array([-0]),a=new Uint8Array(o.buffer),s=128===a[7];e.writeDoubleLE=s?t:n,e.writeDoubleBE=s?n:t,e.readDoubleLE=s?r:i,e.readDoubleBE=s?i:r}():function(){function t(e,t,n,r,i,o){var a=r<0?1:0;if(a&&(r=-r),0===r)e(0,i,o+t),e(1/r>0?0:2147483648,i,o+n);else if(isNaN(r))e(0,i,o+t),e(2146959360,i,o+n);else if(r>1.7976931348623157e308)e(0,i,o+t),e((a<<31|2146435072)>>>0,i,o+n);else{var s;if(r<2.2250738585072014e-308)s=r/5e-324,e(s>>>0,i,o+t),e((a<<31|s/4294967296)>>>0,i,o+n);else{var u=Math.floor(Math.log(r)/Math.LN2);1024===u&&(u=1023),s=r*Math.pow(2,-u),e(4503599627370496*s>>>0,i,o+t),e((a<<31|u+1023<<20|1048576*s&1048575)>>>0,i,o+n)}}}function n(e,t,n,r,i){var o=e(r,i+t),a=e(r,i+n),s=2*(a>>31)+1,u=a>>>20&2047,c=4294967296*(1048575&a)+o;return 2047===u?c?NaN:s*(1/0):0===u?5e-324*s*c:s*Math.pow(2,u-1075)*(c+4503599627370496)}e.writeDoubleLE=t.bind(null,writeUintLE,0,4),e.writeDoubleBE=t.bind(null,writeUintBE,4,0),e.readDoubleLE=n.bind(null,readUintLE,0,4),e.readDoubleBE=n.bind(null,readUintBE,4,0)}(),e}function writeUintLE(e,t,n){t[n]=255&e,t[n+1]=e>>>8&255,t[n+2]=e>>>16&255,t[n+3]=e>>>24}function writeUintBE(e,t,n){t[n]=e>>>24,t[n+1]=e>>>16&255,t[n+2]=e>>>8&255,t[n+3]=255&e}function readUintLE(e,t){return(e[t]|e[t+1]<<8|e[t+2]<<16|e[t+3]<<24)>>>0}function readUintBE(e,t){return(e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3])>>>0}function inquire(moduleName){try{var mod=eval("quire".replace(/^/,"re"))(moduleName);if(mod&&(mod.length||Object.keys(mod).length))return mod}catch(e){}return null}function pool(e,t,n){var r=n||8192,i=r>>>1,o=null,a=r;return function(n){if(n<1||n>i)return e(n);a+n>r&&(o=e(r),a=0);var s=t.call(o,a,a+=n);return 7&a&&(a=1+(7|a)),s}}function LongBits$1(e,t){this.lo=e>>>0,this.hi=t>>>0}function Op(e,t,n){this.fn=e,this.len=t,this.next=void 0,this.val=n}function noop(){}function State(e){this.head=e.head,this.tail=e.tail,this.len=e.len,this.next=e.states}function Writer(){this.len=0,this.head=new Op(noop,0,0),this.tail=this.head,this.states=null}function writeByte(e,t,n){t[n]=255&e}function writeVarint32(e,t,n){for(;e>127;)t[n++]=127&e|128,e>>>=7;t[n]=e}function VarintOp(e,t){this.len=e,this.next=void 0,this.val=t}function writeVarint64(e,t,n){for(;e.hi;)t[n++]=127&e.lo|128,e.lo=(e.lo>>>7|e.hi<<25)>>>0,e.hi>>>=7;for(;e.lo>127;)t[n++]=127&e.lo|128,e.lo=e.lo>>>7;t[n++]=e.lo}function writeFixed32(e,t,n){t[n]=255&e,t[n+1]=e>>>8&255,t[n+2]=e>>>16&255,t[n+3]=e>>>24}function BufferWriter$1(){writer.call(this)}function writeStringBuffer(e,t,n){e.length<40?minimal$2.utf8.write(e,t,n):t.utf8Write(e,n)}function indexOutOfRange(e,t){return RangeError("index out of range: "+e.pos+" + "+(t||1)+" > "+e.len)}function Reader(e){this.buf=e,this.pos=0,this.len=e.length}function readLongVarint(){var e=new LongBits$2(0,0),t=0;if(!(this.len-this.pos>4)){for(;t<3;++t){if(this.pos>=this.len)throw indexOutOfRange(this);if(e.lo=(e.lo|(127&this.buf[this.pos])<<7*t)>>>0,this.buf[this.pos++]<128)return e}return e.lo=(e.lo|(127&this.buf[this.pos++])<<7*t)>>>0,e}for(;t<4;++t)if(e.lo=(e.lo|(127&this.buf[this.pos])<<7*t)>>>0,this.buf[this.pos++]<128)return e;if(e.lo=(e.lo|(127&this.buf[this.pos])<<28)>>>0,e.hi=(e.hi|(127&this.buf[this.pos])>>4)>>>0,this.buf[this.pos++]<128)return e;if(t=0,this.len-this.pos>4){for(;t<5;++t)if(e.hi=(e.hi|(127&this.buf[this.pos])<<7*t+3)>>>0,this.buf[this.pos++]<128)return e}else for(;t<5;++t){if(this.pos>=this.len)throw indexOutOfRange(this);if(e.hi=(e.hi|(127&this.buf[this.pos])<<7*t+3)>>>0,this.buf[this.pos++]<128)return e}throw Error("invalid varint encoding")}function readFixed32_end(e,t){return(e[t-4]|e[t-3]<<8|e[t-2]<<16|e[t-1]<<24)>>>0}function readFixed64(){if(this.pos+8>this.len)throw indexOutOfRange(this,8);return new LongBits$2(readFixed32_end(this.buf,this.pos+=4),readFixed32_end(this.buf,this.pos+=4))}function BufferReader$1(e){reader.call(this,e)}function Service(e,t,n){if("function"!=typeof e)throw TypeError("rpcImpl must be a function");minimal$2.EventEmitter.call(this),this.rpcImpl=e,this.requestDelimited=Boolean(t),this.responseDelimited=Boolean(n)}function xhrSupportsResponseTypeArrayBuffer(){var e=new XMLHttpRequest;if("string"==typeof e.responseType)try{return"arraybuffer"===(e.responseType="arraybuffer")}catch(e){return!1}return!1}function decodeAsync(e){var t=new Uint8Array(e.length);return new Promise(function(n){function r(i){for(var o=Math.min(t.length,i+1e4),a=i;a<o;a++)t[a]=255&e.charCodeAt(a);o<t.length?setTimeout(function(){return r(o)},0):n(t)}setTimeout(function(){return r(0)},0)})}function loadBinaryFallback(e,t){return new Promise(function(n,r){var i=new XMLHttpRequest;if(i.open("GET",e,!0),i.withCredentials=!!t,!i.overrideMimeType)return r("cannot load binary files");i.overrideMimeType("text/plain; charset=x-user-defined"),i.onreadystatechange=function(){if(4===i.readyState)return 200===i.status?n(i.responseText):r()},i.send()}).then(decodeAsync)}function loadBinaryBuffer(e,t){return new Promise(function(n,r){var i=new XMLHttpRequest;i.open("GET",e,!0),i.responseType="arraybuffer",i.withCredentials=!!t,i.onload=function(){var e=i.response;return e?n(new Uint8Array(e)):r()},i.onerror=function(){return r()},i.send()})}function retry(e,t){return new Promise(function n(r,i){var o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1,a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:100;return e().then(function(e){return r([e,o])}).catch(function(e){o<t?setTimeout(function(){return n(r,i,o+1,5*a)},a):i([e,o])})})}function fontLoadNative(e,t,n,r){var i=new FontFace(t,n,{});e.add(i);var o=e.load("12px "+t).then(function(e){if(0===e.length)throw new Error("Native font load failed");return i}),a=null,s=new Promise(function(e,t){a=setTimeout(function(){return t(new Error("Native font load timeout"))},r)});return Promise.race([o,s]).then(function(e){return clearTimeout(a),e},function(e){return clearTimeout(a),Promise.reject(e)})}function fontLoadCompat(e,t,n,r){var i='@font-face { font-family: "'+e+'"; src: '+t+'; format("woff"); }';styleNode.appendChild(document.createTextNode(i));var o=new fontfaceobserver_standalone(e);if(n){return o.load(n.text.substring(0,8),r).catch(function(e){var t=new Error('Compat font load failed: "'+e+'"');throw t.skipTracking=!0,t})}return Promise.resolve(o)}function fontLoad(e,t,n,r){if(fonts.hasOwnProperty(e))return fonts[e];var i=document.fonts;return fonts[e]=i?fontLoadNative(i,e,t,r):fontLoadCompat(e,t,n,r)}function fetchImage(e){return new Promise(function(t,n){var r=new Image;"data"!==e.substr(0,4)&&(r.crossOrigin="Anonymous"),r.onload=function(){return t(r)},r.onerror=function(){return n(new TypeError("Could not load image"))},r.src=e})}function createImageLayer(e,t,n,r){return{page:e,width:n||t.width,height:r||t.height,layers:[{type:"image",image:0,width:n||t.width,height:r||t.height}],images:[t],fonts:[]}}function loadImageAsLayer(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},r=n.width,i=n.height,o=n.loadStatsTracker;return o&&o.onPageLoadStart(t,"image"),retry(function(){return fetchImage(e)},3).then(function(e){var n=e[0];return e[1]>1?o&&o.onPageLoadSuccessAfterRetry(t,"image"):o&&o.onPageLoadSuccess(t,"image"),createImageLayer(t,n,r,i)}).catch(function(e){return o&&o.onPageLoadFailure(t,"image"),Promise.reject(e)})}function hydrateLayers(e,t,n,r){var i=e.images.map(function(e){r&&r.onImageDecodeStart(e);var n=void 0;switch(e.type){case"embed":n="data:image/jpeg;base64,"+e.resource;break;case"file":n=t+"/"+e.resource;break;default:throw new Error("cannot process image resource with type "+e.type)}return fetchImage(n).then(function(t){return r&&r.onImageDecodeEnd(e),t})}),o=e.fonts.map(function(n,i){var o="f"+e.page+"_"+i;r&&r.onFontLoadStart(o);var a=void 0;switch(n.type){case"embed":a="url(data:application/x-font-woff;charset=utf-8;base64,"+n.resource+")";break;case"file":a="url("+t+"/"+n.resource+")";break;default:throw new Error("cannot process font resource with type "+n.type)}var s=e.layers.find(function(e){return"text"===e.type&&e.font===i&&e.text.trim().length>0});return fontLoad(o,a,s,FONT_LOAD_TIMEOUT_IN_MS).then(function(e){return r&&r.onFontLoadEnd(o),e})});return Promise.all([Promise.all(i),Promise.all(o)]).then(function(t){return{layers:e.layers,images:t[0],fonts:e.fonts.map(function(e){return{type:e.type,weight:e.weight}}),width:e.width,height:e.height,page:e.page,version:e.version,usable:e.usable}})}function base64(e){for(var t=[],n=0;n<e.length;n+=32768)t.push(String.fromCharCode.apply(null,e.subarray(n,n+32768)));return btoa(t.join(""))}function blendTypeToString(e){switch(e){case layersProto.layers.BlendType.Normal:return"source-over";case layersProto.layers.BlendType.Multiply:return"multiply";case layersProto.layers.BlendType.Screen:return"screen";case layersProto.layers.BlendType.Overlay:return"overlay";case layersProto.layers.BlendType.Darken:return"overlay";case layersProto.layers.BlendType.Lighten:return"lighten";case layersProto.layers.BlendType.Colordodge:return"color-dodge";case layersProto.layers.BlendType.Colorburn:return"color-burn";case layersProto.layers.BlendType.Hardlight:return"hard-light";case layersProto.layers.BlendType.Softlight:return"soft-light";case layersProto.layers.BlendType.Difference:return"difference";case layersProto.layers.BlendType.Exclusion:return"exclusion";case layersProto.layers.BlendType.Hue:return"hue";case layersProto.layers.BlendType.Saturation:return"saturation";case layersProto.layers.BlendType.Color:return"color";case layersProto.layers.BlendType.Luminosity:return"luminosity"}}function protoToColorArray(e){return[e>>16&255,e>>8&255,e>>0&255,(e>>24&255)/255]}function protoToLayer(e){switch(e.kind){case"image":return{type:"image",image:e.image.image,width:e.image.width,height:e.image.height};case"rect":return{type:"rect",box:e.rect.box,color:protoToColorArray(e.rect.color),blend:blendTypeToString(e.rect.blend)};case"line":return{type:"line",coords:e.line.coord,color:protoToColorArray(e.line.color),blend:blendTypeToString(e.line.blend)};case"text":return{type:"text",text:e.text.text,font:e.text.font,size:e.text.size,color:protoToColorArray(e.text.color),matrix:e.text.matrix,originx:e.text.originx,originy:e.text.originy,scale:e.text.scale}}}function loadLayersProto(e,t,n){var r=n.loadStatsTracker,i=n.withCredentials;r&&r.onPageLoadStart(t,"layers");var o=e.split("?",2)[0].split("/").slice(0,-1).join("/");return retry(function(){return loadBinary(e,!!i)},3).then(function(e){var n=e[0],i=e[1],a=layersProto.layers.Page.decode(n);return hydrateLayers({layers:a.layer.map(protoToLayer),images:a.image.map(function(e){return{type:"embed",resource:base64(e.resource)}}),fonts:a.font.map(function(e){return{type:"embed",resource:base64(e.resource)}}),width:a.width,height:a.height,page:a.page,version:a.version,usable:a.usable},o,t,r).then(function(e){return i>1?r&&r.onPageLoadSuccessAfterRetry(t,"layers"):r&&r.onPageLoadSuccess(t,"layers"),e}).catch(function(e){return r&&r.onPageLoadFailure(t,"layers"),Promise.reject(e)})})}function loadLayersJson(e,t,n){var r=n.loadStatsTracker,i=n.withCredentials;r&&r.onPageLoadStart(t,"layers");var o=e.split("?",2)[0].split("/").slice(0,-1).join("/");return retry(function(){return fetch(e,{mode:"cors",credentials:i?"include":"omit"}).then(function(e){return e.json()})},3).then(function(e){var n=e[1];return hydrateLayers(e[0],o,t,r).then(function(e){return n>1?r&&r.onPageLoadSuccessAfterRetry(t,"layers"):r&&r.onPageLoadSuccess(t,"layers"),e}).catch(function(e){return r&&r.onPageLoadFailure(t,"layers"),Promise.reject(e)})})}function loadLayers(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{loadStatsTracker:void 0,withCredentials:void 0};switch(n){case 1:return loadLayersJson(e,t,r);case 2:return loadLayersProto(e,t,r);default:return Promise.reject("Unknown version "+n)}}function accentFold(e){return e in accent_map?accent_map[e]:e}function filterAccents(e){return e.split("").map(function(e){return accentFold(e)}).join("")}function filterAccentsInData(e){return{page:e.page.map(function(e){return{height:e.height,page_number:e.page_number,width:e.width,text_block:e.text_block.map(function(e){return{char_offset:e.char_offset,height:e.height,matrix:e.matrix,text:filterAccents(e.text)}})}})}}function computeSearchRegexp(e){for(var t="",n=e.length,r=0;r<n;r++){var i=e[r];i.match(_reNonBlank)?(t+=i.replace(_reEscape,"\\$&"),t+="\n?"):t+=" "}return t=t.replace(/[ ]+/g,"\\s+"),new RegExp(t,"mig")}function loadFindData(e){return(e.match(/\.json(?:\?.*)$/)?fetch(e).then(function(e){return e.json()}):loadBinary(e).then(function(e){return textProto.text.Document.decode(e)})).then(function(e){return{pages:filterAccentsInData(e).page.map(function(e){return{pageNumber:e.page_number,textBlocks:(e.text_block||[]).map(function(e){var t=e.char_offset.reduce(function(e,t){return e.push((e[e.length-1]||0)+t),e},[]);return t.push(t[t.length-1]),{text:e.text+"\n",height:e.height,matrix:e.matrix,charOffsets:t}}),text:(e.text_block||[]).reduce(function(e,t){return e+t.text+"\n"},""),width:e.width,height:e.height}})}})}function sliceTextBlocks(e,t,n){for(var r=[],i=0;i<n.length;i++){var o=n[i].text.length;if(r.length?r.push(n[i]):e<o?r.push(n[i]):e-=o,r.length&&t<=o)return{start:e,end:t,blocks:r};t-=o}throw new Error("index out of range")}function getResultFromIndex(e,t,n){var r=sliceTextBlocks(e,e+t,n),i=r.start,o=r.end,a=r.blocks;return a.map(function(e,t){var n=0===t?i:0,r=t===a.length-1?o:e.charOffsets.length-1,s=e.charOffsets[n];return{x:s,y:0,width:e.charOffsets[r]-s,height:e.height,matrix:e.matrix}})}function find(e,t){var n=[];if(e=e.trim(),!e.length)return n;e=filterAccents(e);for(var r=computeSearchRegexp(e),i=t.pages,o=Array.isArray(i),a=0,i=o?i:i[Symbol.iterator]();;){var s;if(o){if(a>=i.length)break;s=i[a++]}else{if(a=i.next(),a.done)break;s=a.value}for(var u=s,c=r.exec(u.text);c;c=r.exec(u.text))n.push({pageNo:u.pageNumber,result:getResultFromIndex(c.index,c[0].length,u.textBlocks)})}return n}function highlight(e,t,n){e.save(),e.fillStyle="rgba(0,255,0,0.3)";for(var r=t,i=Array.isArray(r),o=0,r=i?r:r[Symbol.iterator]();;){var a;if(i){if(o>=r.length)break;a=r[o++]}else{if(o=r.next(),o.done)break;a=o.value}var s=a;e.setTransform(e.canvas.width/n.width,0,0,e.canvas.height/n.height,0,0),e.transform(s.matrix[0],s.matrix[1],s.matrix[2],s.matrix[3],s.matrix[4],s.matrix[5]),e.fillRect(s.x,s.y,s.width,s.height)}return e.restore(),t}function color(e){return"rgba("+e.join(",")+")"}function symbolsForEach(e,t){for(var n=0,r=0,i=e.length;r<i-1;++r){var o=e.charCodeAt(r);o>=55296&&o<=56319&&(o=e.charCodeAt(r+1))>=56320&&o<=57343?(t(e.slice(r,r+2),n++),++r):t(e.charAt(r),n++)}t(e.charAt(r),n++)}function renderLayers(e,t,n,r){var i=arguments.length>4&&void 0!==arguments[4]&&arguments[4];r&&r.onFontRenderingStart(),e.save(),e.beginPath(),e.rect(0,0,e.canvas.width,e.canvas.height),e.closePath(),e.clip(),n.layers.forEach(function(r){var o=r;if("image"===o.type){var a=n.images[o.image];try{if(!(t[0]<2||t[3]<2)||NEVER_USE_TWOPASS||i)e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.drawImage(a,0,0,o.width,o.height);else{var s=document.createElement("canvas");s.width=2*e.canvas.width,s.height=2*e.canvas.height,s.id="reader3-twopass-canvas-"+s.width+"x"+s.height;var u=s.getContext("2d");if(!u)throw new Error("could not get canvas for twopass scaling");u.save(),u.beginPath(),u.rect(0,0,s.width,s.height),u.closePath(),u.clip(),u.setTransform(2*t[0],2*t[1],2*t[2],2*t[3],2*t[4],2*t[5]),u.drawImage(a,0,0,o.width,o.height),u.restore(),e.setTransform(1,0,0,1,0,0),e.drawImage(s,0,0,s.width,s.height,0,0,e.canvas.width,e.canvas.height),s.width=0,s.height=0}}catch(t){var c={has_image:!!a,image_width:a&&a.width,image_height:a&&a.height,dst_width:o.width,dst_height:o.height,canvas_width:e.canvas.width,canvas_height:e.canvas.height};throw t.sentry_extra=Object.assign({textRender:c},t.sentry_extra),t}}else if("text"===o.type){var l=100*Math.ceil(n.fonts[o.font].weight/100)||400;e.font=l+" "+o.size+'px "f'+n.page+"_"+o.font+'"',e.fillStyle=color(o.color),e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.transform(o.matrix[0],o.matrix[1],o.matrix[2],o.matrix[3],o.matrix[4],o.matrix[5]);var p=o.scale.some(function(e){return 1!==e});symbolsForEach(o.text,function(n,r){var i=o.originx[r],a=o.originy[r],s=o.scale[r];p&&(e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.transform(o.matrix[0]*s,o.matrix[1]*s,o.matrix[2],o.matrix[3],o.matrix[4],o.matrix[5])),e.fillText(n,i/s,a)})}else if("rect"===o.type){e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.fillStyle=color(o.color);var d=e.globalCompositeOperation;e.globalCompositeOperation=o.blend,e.fillRect(o.box[0],o.box[1],o.box[2],o.box[3]),e.globalCompositeOperation=d}else if("line"===o.type){e.setTransform(t[0],t[1],t[2],t[3],t[4],t[5]),e.strokeStyle=color(o.color),e.lineWidth=1;var f=e.globalCompositeOperation;e.globalCompositeOperation=o.blend,e.beginPath(),e.moveTo(o.coords[0],o.coords[1]),e.lineTo(o.coords[2],o.coords[3]),e.stroke(),e.globalCompositeOperation=f}}),e.restore(),r&&r.onFontRenderingEnd()}__webpack_require__.d(__webpack_exports__,"c",function(){return loadImageAsLayer}),__webpack_require__.d(__webpack_exports__,"d",function(){return loadLayers}),__webpack_require__.d(__webpack_exports__,"e",function(){return renderLayers}),__webpack_require__.d(__webpack_exports__,"b",function(){return loadFindData}),__webpack_require__.d(__webpack_exports__,"a",function(){return find});var commonjsGlobal="undefined"!=typeof window?window:void 0!==global?global:"undefined"!=typeof self?self:{},index=asPromise,index$2=createCommonjsModule(function(e,t){var n=t;n.length=function(e){var t=e.length;if(!t)return 0;for(var n=0;--t%4>1&&"="===e.charAt(t);)++n;return Math.ceil(3*e.length)/4-n};for(var r=new Array(64),i=new Array(123),o=0;o<64;)i[r[o]=o<26?o+65:o<52?o+71:o<62?o-4:o-59|43]=o++;n.encode=function(e,t,n){for(var i,o=[],a=0,s=0;t<n;){var u=e[t++];switch(s){case 0:o[a++]=r[u>>2],i=(3&u)<<4,s=1;break;case 1:o[a++]=r[i|u>>4],i=(15&u)<<2,s=2;break;case 2:o[a++]=r[i|u>>6],o[a++]=r[63&u],s=0}}return s&&(o[a++]=r[i],o[a]=61,1===s&&(o[a+1]=61)),String.fromCharCode.apply(String,o)};n.decode=function(e,t,n){for(var r,o=n,a=0,s=0;s<e.length;){var u=e.charCodeAt(s++);if(61===u&&a>1)break;if(void 0===(u=i[u]))throw Error("invalid encoding");switch(a){case 0:r=u,a=1;break;case 1:t[n++]=r<<2|(48&u)>>4,r=u,a=2;break;case 2:t[n++]=(15&r)<<4|(60&u)>>2,r=u,a=3;break;case 3:t[n++]=(3&r)<<6|u,a=0}}if(1===a)throw Error("invalid encoding");return n-o},n.test=function(e){return/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/.test(e)}}),index$4=EventEmitter;EventEmitter.prototype.on=function(e,t,n){return(this._listeners[e]||(this._listeners[e]=[])).push({fn:t,ctx:n||this}),this},EventEmitter.prototype.off=function(e,t){if(void 0===e)this._listeners={};else if(void 0===t)this._listeners[e]=[];else for(var n=this._listeners[e],r=0;r<n.length;)n[r].fn===t?n.splice(r,1):++r;return this},EventEmitter.prototype.emit=function(e){var t=this._listeners[e];if(t){for(var n=[],r=1;r<arguments.length;)n.push(arguments[r++]);for(r=0;r<t.length;)t[r].fn.apply(t[r++].ctx,n)}return this};var index$6=factory(factory),index$8=inquire,index$10=createCommonjsModule(function(e,t){var n=t;n.length=function(e){for(var t=0,n=0,r=0;r<e.length;++r)n=e.charCodeAt(r),n<128?t+=1:n<2048?t+=2:55296==(64512&n)&&56320==(64512&e.charCodeAt(r+1))?(++r,t+=4):t+=3;return t},n.read=function(e,t,n){if(n-t<1)return"";for(var r,i=null,o=[],a=0;t<n;)r=e[t++],r<128?o[a++]=r:r>191&&r<224?o[a++]=(31&r)<<6|63&e[t++]:r>239&&r<365?(r=((7&r)<<18|(63&e[t++])<<12|(63&e[t++])<<6|63&e[t++])-65536,o[a++]=55296+(r>>10),o[a++]=56320+(1023&r)):o[a++]=(15&r)<<12|(63&e[t++])<<6|63&e[t++],a>8191&&((i||(i=[])).push(String.fromCharCode.apply(String,o)),a=0);return i?(a&&i.push(String.fromCharCode.apply(String,o.slice(0,a))),i.join("")):String.fromCharCode.apply(String,o.slice(0,a))},n.write=function(e,t,n){for(var r,i,o=n,a=0;a<e.length;++a)r=e.charCodeAt(a),r<128?t[n++]=r:r<2048?(t[n++]=r>>6|192,t[n++]=63&r|128):55296==(64512&r)&&56320==(64512&(i=e.charCodeAt(a+1)))?(r=65536+((1023&r)<<10)+(1023&i),++a,t[n++]=r>>18|240,t[n++]=r>>12&63|128,t[n++]=r>>6&63|128,t[n++]=63&r|128):(t[n++]=r>>12|224,t[n++]=r>>6&63|128,t[n++]=63&r|128);return n-o}}),index$12=pool,longbits=LongBits$1,zero=LongBits$1.zero=new LongBits$1(0,0);zero.toNumber=function(){return 0},zero.zzEncode=zero.zzDecode=function(){return this},zero.length=function(){return 1};var zeroHash=LongBits$1.zeroHash="\0\0\0\0\0\0\0\0";LongBits$1.fromNumber=function(e){if(0===e)return zero;var t=e<0;t&&(e=-e);var n=e>>>0,r=(e-n)/4294967296>>>0;return t&&(r=~r>>>0,n=~n>>>0,++n>4294967295&&(n=0,++r>4294967295&&(r=0))),new LongBits$1(n,r)},LongBits$1.from=function(e){if("number"==typeof e)return LongBits$1.fromNumber(e);if(minimal$2.isString(e)){if(!minimal$2.Long)return LongBits$1.fromNumber(parseInt(e,10));e=minimal$2.Long.fromString(e)}return e.low||e.high?new LongBits$1(e.low>>>0,e.high>>>0):zero},LongBits$1.prototype.toNumber=function(e){if(!e&&this.hi>>>31){var t=1+~this.lo>>>0,n=~this.hi>>>0;return t||(n=n+1>>>0),-(t+4294967296*n)}return this.lo+4294967296*this.hi},LongBits$1.prototype.toLong=function(e){return minimal$2.Long?new minimal$2.Long(0|this.lo,0|this.hi,Boolean(e)):{low:0|this.lo,high:0|this.hi,unsigned:Boolean(e)}};var charCodeAt=String.prototype.charCodeAt;LongBits$1.fromHash=function(e){return e===zeroHash?zero:new LongBits$1((charCodeAt.call(e,0)|charCodeAt.call(e,1)<<8|charCodeAt.call(e,2)<<16|charCodeAt.call(e,3)<<24)>>>0,(charCodeAt.call(e,4)|charCodeAt.call(e,5)<<8|charCodeAt.call(e,6)<<16|charCodeAt.call(e,7)<<24)>>>0)},LongBits$1.prototype.toHash=function(){return String.fromCharCode(255&this.lo,this.lo>>>8&255,this.lo>>>16&255,this.lo>>>24,255&this.hi,this.hi>>>8&255,this.hi>>>16&255,this.hi>>>24)},LongBits$1.prototype.zzEncode=function(){var e=this.hi>>31;return this.hi=((this.hi<<1|this.lo>>>31)^e)>>>0,this.lo=(this.lo<<1^e)>>>0,this},LongBits$1.prototype.zzDecode=function(){var e=-(1&this.lo);return this.lo=((this.lo>>>1|this.hi<<31)^e)>>>0,this.hi=(this.hi>>>1^e)>>>0,this},LongBits$1.prototype.length=function(){var e=this.lo,t=(this.lo>>>28|this.hi<<4)>>>0,n=this.hi>>>24;return 0===n?0===t?e<16384?e<128?1:2:e<2097152?3:4:t<16384?t<128?5:6:t<2097152?7:8:n<128?9:10};var minimal$2=createCommonjsModule(function(e,t){function n(e,t,n){for(var r=Object.keys(t),i=0;i<r.length;++i)void 0!==e[r[i]]&&n||(e[r[i]]=t[r[i]]);return e}function r(e){function t(e,r){if(!(this instanceof t))return new t(e,r);Object.defineProperty(this,"message",{get:function(){return e}}),Error.captureStackTrace?Error.captureStackTrace(this,t):Object.defineProperty(this,"stack",{value:(new Error).stack||""}),r&&n(this,r)}return(t.prototype=Object.create(Error.prototype)).constructor=t,Object.defineProperty(t.prototype,"name",{get:function(){return e}}),t.prototype.toString=function(){return this.name+": "+this.message},t}var i=t;i.asPromise=index,i.base64=index$2,i.EventEmitter=index$4,i.float=index$6,i.inquire=index$8,i.utf8=index$10,i.pool=index$12,i.LongBits=longbits,i.emptyArray=Object.freeze?Object.freeze([]):[],i.emptyObject=Object.freeze?Object.freeze({}):{},i.isNode=Boolean(commonjsGlobal.process&&commonjsGlobal.process.versions&&commonjsGlobal.process.versions.node),i.isInteger=Number.isInteger||function(e){return"number"==typeof e&&isFinite(e)&&Math.floor(e)===e},i.isString=function(e){return"string"==typeof e||e instanceof String},i.isObject=function(e){return e&&"object"===(void 0===e?"undefined":babelHelpers.typeof(e))},i.isset=i.isSet=function(e,t){var n=e[t];return!(null==n||!e.hasOwnProperty(t))&&("object"!==(void 0===n?"undefined":babelHelpers.typeof(n))||(Array.isArray(n)?n.length:Object.keys(n).length)>0)},i.Buffer=function(){try{var e=i.inquire("buffer").Buffer;return e.prototype.utf8Write?e:null}catch(e){return null}}(),i._Buffer_from=null,i._Buffer_allocUnsafe=null,i.newBuffer=function(e){return"number"==typeof e?i.Buffer?i._Buffer_allocUnsafe(e):new i.Array(e):i.Buffer?i._Buffer_from(e):"undefined"==typeof Uint8Array?e:new Uint8Array(e)},i.Array="undefined"!=typeof Uint8Array?Uint8Array:Array,i.Long=commonjsGlobal.dcodeIO&&commonjsGlobal.dcodeIO.Long||i.inquire("long"),i.key2Re=/^true|false|0|1$/,i.key32Re=/^-?(?:0|[1-9][0-9]*)$/,i.key64Re=/^(?:[\\x00-\\xff]{8}|-?(?:0|[1-9][0-9]*))$/,i.longToHash=function(e){return e?i.LongBits.from(e).toHash():i.LongBits.zeroHash},i.longFromHash=function(e,t){var n=i.LongBits.fromHash(e);return i.Long?i.Long.fromBits(n.lo,n.hi,t):n.toNumber(Boolean(t))},i.merge=n,i.lcFirst=function(e){return e.charAt(0).toLowerCase()+e.substring(1)},i.newError=r,i.ProtocolError=r("ProtocolError"),i.oneOfGetter=function(e){for(var t={},n=0;n<e.length;++n)t[e[n]]=1;return function(){for(var e=Object.keys(this),n=e.length-1;n>-1;--n)if(1===t[e[n]]&&void 0!==this[e[n]]&&null!==this[e[n]])return e[n]}},i.oneOfSetter=function(e){return function(t){for(var n=0;n<e.length;++n)e[n]!==t&&delete this[e[n]]}},i.lazyResolve=function(e,t){for(var n=0;n<t.length;++n)for(var r=Object.keys(t[n]),i=0;i<r.length;++i){for(var o=t[n][r[i]].split("."),a=e;o.length;)a=a[o.shift()];t[n][r[i]]=a}},i.toJSONOptions={longs:String,enums:String,bytes:String},i._configure=function(){var e=i.Buffer;if(!e)return void(i._Buffer_from=i._Buffer_allocUnsafe=null);i._Buffer_from=e.from!==Uint8Array.from&&e.from||function(t,n){return new e(t,n)},i._Buffer_allocUnsafe=e.allocUnsafe||function(t){return new e(t)}}}),writer=Writer,BufferWriter,LongBits=minimal$2.LongBits,base64$1=minimal$2.base64,utf8=minimal$2.utf8;Writer.create=minimal$2.Buffer?function(){return(Writer.create=function(){return new BufferWriter})()}:function(){return new Writer},Writer.alloc=function(e){return new minimal$2.Array(e)},minimal$2.Array!==Array&&(Writer.alloc=minimal$2.pool(Writer.alloc,minimal$2.Array.prototype.subarray)),Writer.prototype.push=function(e,t,n){return this.tail=this.tail.next=new Op(e,t,n),this.len+=t,this},VarintOp.prototype=Object.create(Op.prototype),VarintOp.prototype.fn=writeVarint32,Writer.prototype.uint32=function(e){return this.len+=(this.tail=this.tail.next=new VarintOp((e>>>=0)<128?1:e<16384?2:e<2097152?3:e<268435456?4:5,e)).len,this},Writer.prototype.int32=function(e){return e<0?this.push(writeVarint64,10,LongBits.fromNumber(e)):this.uint32(e)},Writer.prototype.sint32=function(e){return this.uint32((e<<1^e>>31)>>>0)},Writer.prototype.uint64=function(e){var t=LongBits.from(e);return this.push(writeVarint64,t.length(),t)},Writer.prototype.int64=Writer.prototype.uint64,Writer.prototype.sint64=function(e){var t=LongBits.from(e).zzEncode();return this.push(writeVarint64,t.length(),t)},Writer.prototype.bool=function(e){return this.push(writeByte,1,e?1:0)},Writer.prototype.fixed32=function(e){return this.push(writeFixed32,4,e>>>0)},Writer.prototype.sfixed32=Writer.prototype.fixed32,Writer.prototype.fixed64=function(e){var t=LongBits.from(e);return this.push(writeFixed32,4,t.lo).push(writeFixed32,4,t.hi)},Writer.prototype.sfixed64=Writer.prototype.fixed64,Writer.prototype.float=function(e){return this.push(minimal$2.float.writeFloatLE,4,e)},Writer.prototype.double=function(e){return this.push(minimal$2.float.writeDoubleLE,8,e)};var writeBytes=minimal$2.Array.prototype.set?function(e,t,n){t.set(e,n)}:function(e,t,n){for(var r=0;r<e.length;++r)t[n+r]=e[r]};Writer.prototype.bytes=function(e){var t=e.length>>>0;if(!t)return this.push(writeByte,1,0);if(minimal$2.isString(e)){var n=Writer.alloc(t=base64$1.length(e));base64$1.decode(e,n,0),e=n}return this.uint32(t).push(writeBytes,t,e)},Writer.prototype.string=function(e){var t=utf8.length(e);return t?this.uint32(t).push(utf8.write,t,e):this.push(writeByte,1,0)},Writer.prototype.fork=function(){return this.states=new State(this),this.head=this.tail=new Op(noop,0,0),this.len=0,this},Writer.prototype.reset=function(){return this.states?(this.head=this.states.head,this.tail=this.states.tail,this.len=this.states.len,this.states=this.states.next):(this.head=this.tail=new Op(noop,0,0),this.len=0),this},Writer.prototype.ldelim=function(){var e=this.head,t=this.tail,n=this.len;return this.reset().uint32(n),n&&(this.tail.next=e.next,this.tail=t,this.len+=n),this},Writer.prototype.finish=function(){for(var e=this.head.next,t=this.constructor.alloc(this.len),n=0;e;)e.fn(e.val,t,n),n+=e.len,e=e.next;return t},Writer._configure=function(e){BufferWriter=e};var writer_buffer=BufferWriter$1;(BufferWriter$1.prototype=Object.create(writer.prototype)).constructor=BufferWriter$1;var Buffer=minimal$2.Buffer;BufferWriter$1.alloc=function(e){return(BufferWriter$1.alloc=minimal$2._Buffer_allocUnsafe)(e)};var writeBytesBuffer=Buffer&&Buffer.prototype instanceof Uint8Array&&"set"===Buffer.prototype.set.name?function(e,t,n){t.set(e,n)}:function(e,t,n){if(e.copy)e.copy(t,n,0,e.length);else for(var r=0;r<e.length;)t[n++]=e[r++]};BufferWriter$1.prototype.bytes=function(e){minimal$2.isString(e)&&(e=minimal$2._Buffer_from(e,"base64"));var t=e.length>>>0;return this.uint32(t),t&&this.push(writeBytesBuffer,t,e),this},BufferWriter$1.prototype.string=function(e){var t=Buffer.byteLength(e);return this.uint32(t),t&&this.push(writeStringBuffer,t,e),this};var reader=Reader,BufferReader,LongBits$2=minimal$2.LongBits,utf8$1=minimal$2.utf8,create_array="undefined"!=typeof Uint8Array?function(e){if(e instanceof Uint8Array||Array.isArray(e))return new Reader(e);throw Error("illegal buffer")}:function(e){if(Array.isArray(e))return new Reader(e);throw Error("illegal buffer")};Reader.create=minimal$2.Buffer?function(e){return(Reader.create=function(e){return minimal$2.Buffer.isBuffer(e)?new BufferReader(e):create_array(e)})(e)}:create_array,Reader.prototype._slice=minimal$2.Array.prototype.subarray||minimal$2.Array.prototype.slice,Reader.prototype.uint32=function(){var e=4294967295;return function(){if(e=(127&this.buf[this.pos])>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(127&this.buf[this.pos])<<7)>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(127&this.buf[this.pos])<<14)>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(127&this.buf[this.pos])<<21)>>>0,this.buf[this.pos++]<128)return e;if(e=(e|(15&this.buf[this.pos])<<28)>>>0,this.buf[this.pos++]<128)return e;if((this.pos+=5)>this.len)throw this.pos=this.len,indexOutOfRange(this,10);return e}}(),Reader.prototype.int32=function(){return 0|this.uint32()},Reader.prototype.sint32=function(){var e=this.uint32();return e>>>1^-(1&e)|0},Reader.prototype.bool=function(){return 0!==this.uint32()},Reader.prototype.fixed32=function(){if(this.pos+4>this.len)throw indexOutOfRange(this,4);return readFixed32_end(this.buf,this.pos+=4)},Reader.prototype.sfixed32=function(){if(this.pos+4>this.len)throw indexOutOfRange(this,4);return 0|readFixed32_end(this.buf,this.pos+=4)},Reader.prototype.float=function(){if(this.pos+4>this.len)throw indexOutOfRange(this,4);var e=minimal$2.float.readFloatLE(this.buf,this.pos);return this.pos+=4,e},Reader.prototype.double=function(){if(this.pos+8>this.len)throw indexOutOfRange(this,4);var e=minimal$2.float.readDoubleLE(this.buf,this.pos);return this.pos+=8,e},Reader.prototype.bytes=function(){var e=this.uint32(),t=this.pos,n=this.pos+e;if(n>this.len)throw indexOutOfRange(this,e);return this.pos+=e,t===n?new this.buf.constructor(0):this._slice.call(this.buf,t,n)},Reader.prototype.string=function(){var e=this.bytes();return utf8$1.read(e,0,e.length)},Reader.prototype.skip=function(e){if("number"==typeof e){if(this.pos+e>this.len)throw indexOutOfRange(this,e);this.pos+=e}else do{if(this.pos>=this.len)throw indexOutOfRange(this)}while(128&this.buf[this.pos++]);return this},Reader.prototype.skipType=function(e){switch(e){case 0:this.skip();break;case 1:this.skip(8);break;case 2:this.skip(this.uint32());break;case 3:for(;;){if(4==(e=7&this.uint32()))break;this.skipType(e)}break;case 5:this.skip(4);break;default:throw Error("invalid wire type "+e+" at offset "+this.pos)}return this},Reader._configure=function(e){BufferReader=e;var t=minimal$2.Long?"toLong":"toNumber";minimal$2.merge(Reader.prototype,{int64:function(){return readLongVarint.call(this)[t](!1)},uint64:function(){return readLongVarint.call(this)[t](!0)},sint64:function(){return readLongVarint.call(this).zzDecode()[t](!1)},fixed64:function(){return readFixed64.call(this)[t](!0)},sfixed64:function(){return readFixed64.call(this)[t](!1)}})};var reader_buffer=BufferReader$1;(BufferReader$1.prototype=Object.create(reader.prototype)).constructor=BufferReader$1,minimal$2.Buffer&&(BufferReader$1.prototype._slice=minimal$2.Buffer.prototype.slice),BufferReader$1.prototype.string=function(){var e=this.uint32();return this.buf.utf8Slice(this.pos,this.pos=Math.min(this.pos+e,this.len))};var service=Service;(Service.prototype=Object.create(minimal$2.EventEmitter.prototype)).constructor=Service,Service.prototype.rpcCall=function e(t,n,r,i,o){if(!i)throw TypeError("request must be specified");var a=this;if(!o)return minimal$2.asPromise(e,a,t,n,r,i);if(!a.rpcImpl)return void setTimeout(function(){o(Error("already ended"))},0);try{return a.rpcImpl(t,n[a.requestDelimited?"encodeDelimited":"encode"](i).finish(),function(e,n){if(e)return a.emit("error",e,t),o(e);if(null===n)return void a.end(!0);if(!(n instanceof r))try{n=r[a.responseDelimited?"decodeDelimited":"decode"](n)}catch(e){return a.emit("error",e,t),o(e)}return a.emit("data",n,t),o(null,n)})}catch(e){return a.emit("error",e,t),void setTimeout(function(){o(e)},0)}},Service.prototype.end=function(e){return this.rpcImpl&&(e||this.rpcImpl(null,null,null),this.rpcImpl=null,this.emit("end").off()),this};var rpc_1=createCommonjsModule(function(e,t){t.Service=service}),indexMinimal=createCommonjsModule(function(e,t){function n(){r.Reader._configure(r.BufferReader),r.util._configure()}var r=t;r.build="minimal",r.roots={},r.Writer=writer,r.BufferWriter=writer_buffer,r.Reader=reader,r.BufferReader=reader_buffer,r.util=minimal$2,r.rpc=rpc_1,r.configure=n,r.Writer._configure(r.BufferWriter),n()}),minimal=indexMinimal,$Reader=minimal.Reader,$util=minimal.util,$root=minimal.roots.default||(minimal.roots.default={});$root.layers=function(){var e={};return e.BlendType=function(){var e={},t=Object.create(e);return t[e[0]="Normal"]=0,t[e[1]="Multiply"]=1,t[e[2]="Screen"]=2,t[e[3]="Overlay"]=3,t[e[4]="Darken"]=4,t[e[5]="Lighten"]=5,t[e[6]="Colordodge"]=6,t[e[7]="Colorburn"]=7,t[e[8]="Hardlight"]=8,t[e[9]="Softlight"]=9,t[e[10]="Difference"]=10,t[e[11]="Exclusion"]=11,t[e[12]="Hue"]=12,t[e[13]="Saturation"]=13,t[e[14]="Color"]=14,t[e[15]="Luminosity"]=15,t}(),e.ImageLayer=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.image=0,e.prototype.width=0,e.prototype.height=0,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.ImageLayer;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.image=e.uint32();break;case 2:r.width=e.uint32();break;case 3:r.height=e.uint32();break;default:e.skipType(7&i)}}return r},e}(),e.TextLayer=function(){function e(e){if(this.matrix=[],this.originx=[],this.originy=[],this.scale=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.text="",e.prototype.font=0,e.prototype.size=0,e.prototype.color=0,e.prototype.matrix=$util.emptyArray,e.prototype.originx=$util.emptyArray,e.prototype.originy=$util.emptyArray,e.prototype.scale=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.TextLayer;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.text=e.string();break;case 2:r.font=e.uint32();break;case 3:r.size=e.float();break;case 4:r.color=e.uint32();break;case 5:if(r.matrix&&r.matrix.length||(r.matrix=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.matrix.push(e.float());else r.matrix.push(e.float());break;case 6:if(r.originx&&r.originx.length||(r.originx=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.originx.push(e.float());else r.originx.push(e.float());break;case 7:if(r.originy&&r.originy.length||(r.originy=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.originy.push(e.float());else r.originy.push(e.float());break;case 8:if(r.scale&&r.scale.length||(r.scale=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.scale.push(e.float());else r.scale.push(e.float());break;default:e.skipType(7&i)}}return r},e}(),e.RectLayer=function(){function e(e){if(this.box=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.color=0,e.prototype.blend=0,e.prototype.box=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.RectLayer;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.color=e.uint32();break;case 2:r.blend=e.uint32();break;case 3:if(r.box&&r.box.length||(r.box=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.box.push(e.float());else r.box.push(e.float());break;default:e.skipType(7&i)}}return r},e}(),e.LineLayer=function(){function e(e){if(this.coord=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.color=0,e.prototype.blend=0,e.prototype.coord=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.LineLayer;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.color=e.uint32();break;case 2:r.blend=e.uint32();break;case 3:if(r.coord&&r.coord.length||(r.coord=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.coord.push(e.float());else r.coord.push(e.float());break;default:e.skipType(7&i)}}return r},e}(),e.Font=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.resource=$util.newBuffer([]),e.prototype.weight=0,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Font;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.resource=e.bytes();break;case 2:r.weight=e.uint32();break;default:e.skipType(7&i)}}return r},e}(),e.Image=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.resource=$util.newBuffer([]),e.prototype.width=0,e.prototype.height=0,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Image;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.resource=e.bytes();break;case 2:r.width=e.uint32();break;case 3:r.height=e.uint32();break;default:e.skipType(7&i)}}return r},e}(),e.Layer=function(){function e(e){if(e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}e.prototype.image=null,e.prototype.text=null,e.prototype.rect=null,e.prototype.line=null;var t;return Object.defineProperty(e.prototype,"kind",{get:$util.oneOfGetter(t=["image","text","rect","line"]),set:$util.oneOfSetter(t)}),e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Layer;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.image=$root.layers.ImageLayer.decode(e,e.uint32());break;case 2:r.text=$root.layers.TextLayer.decode(e,e.uint32());break;case 3:r.rect=$root.layers.RectLayer.decode(e,e.uint32());break;case 4:r.line=$root.layers.LineLayer.decode(e,e.uint32());break;default:e.skipType(7&i)}}return r},e}(),e.Page=function(){function e(e){if(this.layer=[],this.font=[],this.image=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.page=0,e.prototype.version=0,e.prototype.build="",e.prototype.width=0,e.prototype.height=0,e.prototype.usable=!1,e.prototype.rmse=0,e.prototype.fallback="",e.prototype.layer=$util.emptyArray,e.prototype.font=$util.emptyArray,e.prototype.image=$util.emptyArray,e.decode=function(e,t){e instanceof $Reader||(e=$Reader.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root.layers.Page;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.page=e.uint32();break;case 2:r.version=e.uint32();break;case 3:r.build=e.string();break;case 4:r.width=e.uint32();break;case 5:r.height=e.uint32();break;case 6:r.usable=e.bool();break;case 7:r.rmse=e.float();break;case 8:r.fallback=e.string();break;case 9:r.layer&&r.layer.length||(r.layer=[]),r.layer.push($root.layers.Layer.decode(e,e.uint32()));break;case 10:r.font&&r.font.length||(r.font=[]),r.font.push($root.layers.Font.decode(e,e.uint32()));break;case 11:r.image&&r.image.length||(r.image=[]),r.image.push($root.layers.Image.decode(e,e.uint32()));break;default:e.skipType(7&i)}}return r},e}(),e}();var layersProto=$root,loadBinary=xhrSupportsResponseTypeArrayBuffer()?loadBinaryBuffer:loadBinaryFallback,fontfaceobserver_standalone=createCommonjsModule(function(e){!function(){function t(e,t){document.addEventListener?e.addEventListener("scroll",t,!1):e.attachEvent("scroll",t)}function n(e){document.body?e():document.addEventListener?document.addEventListener("DOMContentLoaded",function t(){document.removeEventListener("DOMContentLoaded",t),e()}):document.attachEvent("onreadystatechange",function t(){"interactive"!=document.readyState&&"complete"!=document.readyState||(document.detachEvent("onreadystatechange",t),e())})}function r(e){this.a=document.createElement("div"),this.a.setAttribute("aria-hidden","true"),this.a.appendChild(document.createTextNode(e)),this.b=document.createElement("span"),this.c=document.createElement("span"),this.h=document.createElement("span"),this.f=document.createElement("span"),this.g=-1,this.b.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.c.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.f.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.h.style.cssText="display:inline-block;width:200%;height:200%;font-size:16px;max-width:none;",this.b.appendChild(this.h),this.c.appendChild(this.f),this.a.appendChild(this.b),this.a.appendChild(this.c)}function i(e,t){e.a.style.cssText="max-width:none;min-width:20px;min-height:20px;display:inline-block;overflow:hidden;position:absolute;width:auto;margin:0;padding:0;top:-999px;left:-999px;white-space:nowrap;font-synthesis:none;font:"+t+";"}function o(e){var t=e.a.offsetWidth,n=t+100;return e.f.style.width=n+"px",e.c.scrollLeft=n,e.b.scrollLeft=e.b.scrollWidth+100,e.g!==t&&(e.g=t,!0)}function a(e,n){function r(){var e=i;o(e)&&e.a.parentNode&&n(e.g)}var i=e;t(e.b,r),t(e.c,r),o(e)}function s(e,t){var n=t||{};this.family=e,this.style=n.style||"normal",this.weight=n.weight||"normal",this.stretch=n.stretch||"normal"}function u(){if(null===f)if(c()&&/Apple/.test(window.navigator.vendor)){var e=/AppleWebKit\/([0-9]+)(?:\.([0-9]+))(?:\.([0-9]+))/.exec(window.navigator.userAgent);f=!!e&&603>parseInt(e[1],10)}else f=!1;return f}function c(){return null===m&&(m=!!document.fonts),m}function l(){if(null===h){var e=document.createElement("div");try{e.style.font="condensed 100px sans-serif"}catch(e){}h=""!==e.style.font}return h}function p(e,t){return[e.style,e.weight,l()?e.stretch:"","100px",t].join(" ")}var d=null,f=null,h=null,m=null;s.prototype.load=function(e,t){var o=this,s=e||"BESbswy",l=0,f=t||3e3,h=(new Date).getTime();return new Promise(function(e,t){if(c()&&!u()){var m=new Promise(function(e,t){function n(){(new Date).getTime()-h>=f?t():document.fonts.load(p(o,'"'+o.family+'"'),s).then(function(t){1<=t.length?e():setTimeout(n,25)},function(){t()})}n()}),g=new Promise(function(e,t){l=setTimeout(t,f)});Promise.race([g,m]).then(function(){clearTimeout(l),e(o)},function(){t(o)})}else n(function(){function n(){var t;(t=-1!=v&&-1!=b||-1!=v&&-1!=y||-1!=b&&-1!=y)&&((t=v!=b&&v!=y&&b!=y)||(null===d&&(t=/AppleWebKit\/([0-9]+)(?:\.([0-9]+))/.exec(window.navigator.userAgent),d=!!t&&(536>parseInt(t[1],10)||536===parseInt(t[1],10)&&11>=parseInt(t[2],10))),t=d&&(v==_&&b==_&&y==_||v==w&&b==w&&y==w||v==E&&b==E&&y==E)),t=!t),t&&(x.parentNode&&x.parentNode.removeChild(x),clearTimeout(l),e(o))}function u(){if((new Date).getTime()-h>=f)x.parentNode&&x.parentNode.removeChild(x),t(o);else{var e=document.hidden;!0!==e&&void 0!==e||(v=c.a.offsetWidth,b=m.a.offsetWidth,y=g.a.offsetWidth,n()),l=setTimeout(u,50)}}var c=new r(s),m=new r(s),g=new r(s),v=-1,b=-1,y=-1,_=-1,w=-1,E=-1,x=document.createElement("div");x.dir="ltr",i(c,p(o,"sans-serif")),i(m,p(o,"serif")),i(g,p(o,"monospace")),x.appendChild(c.a),x.appendChild(m.a),x.appendChild(g.a),document.body.appendChild(x),_=c.a.offsetWidth,w=m.a.offsetWidth,E=g.a.offsetWidth,u(),a(c,function(e){v=e,n()}),i(c,p(o,'"'+o.family+'",sans-serif')),a(m,function(e){b=e,n()}),i(m,p(o,'"'+o.family+'",serif')),a(g,function(e){y=e,n()}),i(g,p(o,'"'+o.family+'",monospace'))})})},e.exports=s}()}),FONT_LOAD_TIMEOUT_IN_MS=3e3,styleNode=document.createElement("style");styleNode.id="reader3-fonts",styleNode.type="text/css",document.head&&document.head.appendChild(styleNode);var fonts={},$Reader$1=minimal.Reader,$util$1=minimal.util,$root$1=minimal.roots.default||(minimal.roots.default={});$root$1.text=function(){var e={};return e.TextBlock=function(){function e(e){if(this.matrix=[],this.char_offset=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.text="",e.prototype.height=0,e.prototype.matrix=$util$1.emptyArray,e.prototype.char_offset=$util$1.emptyArray,e.decode=function(e,t){e instanceof $Reader$1||(e=$Reader$1.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root$1.text.TextBlock;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.text=e.string();break;case 2:r.height=e.float();break;case 3:if(r.matrix&&r.matrix.length||(r.matrix=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.matrix.push(e.float());else r.matrix.push(e.float());break;case 4:if(r.char_offset&&r.char_offset.length||(r.char_offset=[]),2==(7&i))for(var o=e.uint32()+e.pos;e.pos<o;)r.char_offset.push(e.int32());else r.char_offset.push(e.int32());break;default:e.skipType(7&i)}}return r},e}(),e.Page=function(){function e(e){if(this.text_block=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.page_number=0,e.prototype.width=0,e.prototype.height=0,e.prototype.text_block=$util$1.emptyArray,e.decode=function(e,t){e instanceof $Reader$1||(e=$Reader$1.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root$1.text.Page;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.page_number=e.uint32();break;case 2:r.width=e.uint32();break;case 3:r.height=e.uint32();break;case 4:r.text_block&&r.text_block.length||(r.text_block=[]),r.text_block.push($root$1.text.TextBlock.decode(e,e.uint32()));break;default:e.skipType(7&i)}}return r},e}(),e.Document=function(){function e(e){if(this.page=[],e)for(var t=Object.keys(e),n=0;n<t.length;++n)null!=e[t[n]]&&(this[t[n]]=e[t[n]])}return e.prototype.page=$util$1.emptyArray,e.decode=function(e,t){e instanceof $Reader$1||(e=$Reader$1.create(e));for(var n=void 0===t?e.len:e.pos+t,r=new $root$1.text.Document;e.pos<n;){var i=e.uint32();switch(i>>>3){case 1:r.page&&r.page.length||(r.page=[]),r.page.push($root$1.text.Page.decode(e,e.uint32()));break;default:e.skipType(7&i)}}return r},e}(),e}();var textProto=$root$1,accent_map={"ẚ":"a","Á":"a","á":"a","À":"a","à":"a","Ă":"a","ă":"a","Ắ":"a","ắ":"a","Ằ":"a","ằ":"a","Ẵ":"a","ẵ":"a","Ẳ":"a","ẳ":"a","Â":"a","â":"a","Ấ":"a","ấ":"a","Ầ":"a","ầ":"a","Ẫ":"a","ẫ":"a","Ẩ":"a","ẩ":"a","Ǎ":"a","ǎ":"a","Å":"a","å":"a","Ǻ":"a","ǻ":"a","Ä":"a","ä":"a","Ǟ":"a","ǟ":"a","Ã":"a","ã":"a","Ȧ":"a","ȧ":"a","Ǡ":"a","ǡ":"a","Ą":"a","ą":"a","Ā":"a","ā":"a","Ả":"a","ả":"a","Ȁ":"a","ȁ":"a","Ȃ":"a","ȃ":"a","Ạ":"a","ạ":"a","Ặ":"a","ặ":"a","Ậ":"a","ậ":"a","Ḁ":"a","ḁ":"a","Ⱥ":"a","ⱥ":"a","Ǽ":"a","ǽ":"a","Ǣ":"a","ǣ":"a","Ḃ":"b","ḃ":"b","Ḅ":"b","ḅ":"b","Ḇ":"b","ḇ":"b","Ƀ":"b","ƀ":"b","ᵬ":"b","Ɓ":"b","ɓ":"b","Ƃ":"b","ƃ":"b","Ć":"c","ć":"c","Ĉ":"c","ĉ":"c","Č":"c","č":"c","Ċ":"c","ċ":"c","Ç":"c","ç":"c","Ḉ":"c","ḉ":"c","Ȼ":"c","ȼ":"c","Ƈ":"c","ƈ":"c","ɕ":"c","Ď":"d","ď":"d","Ḋ":"d","ḋ":"d","Ḑ":"d","ḑ":"d","Ḍ":"d","ḍ":"d","Ḓ":"d","ḓ":"d","Ḏ":"d","ḏ":"d","Đ":"d","đ":"d","ᵭ":"d","Ɖ":"d","ɖ":"d","Ɗ":"d","ɗ":"d","Ƌ":"d","ƌ":"d","ȡ":"d","ð":"d","É":"e","Ə":"e","Ǝ":"e","ǝ":"e","é":"e","È":"e","è":"e","Ĕ":"e","ĕ":"e","Ê":"e","ê":"e","Ế":"e","ế":"e","Ề":"e","ề":"e","Ễ":"e","ễ":"e","Ể":"e","ể":"e","Ě":"e","ě":"e","Ë":"e","ë":"e","Ẽ":"e","ẽ":"e","Ė":"e","ė":"e","Ȩ":"e","ȩ":"e","Ḝ":"e","ḝ":"e","Ę":"e","ę":"e","Ē":"e","ē":"e","Ḗ":"e","ḗ":"e","Ḕ":"e","ḕ":"e","Ẻ":"e","ẻ":"e","Ȅ":"e","ȅ":"e","Ȇ":"e","ȇ":"e","Ẹ":"e","ẹ":"e","Ệ":"e","ệ":"e","Ḙ":"e","ḙ":"e","Ḛ":"e","ḛ":"e","Ɇ":"e","ɇ":"e","ɚ":"e","ɝ":"e","Ḟ":"f","ḟ":"f","ᵮ":"f","Ƒ":"f","ƒ":"f","Ǵ":"g","ǵ":"g","Ğ":"g","ğ":"g","Ĝ":"g","ĝ":"g","Ǧ":"g","ǧ":"g","Ġ":"g","ġ":"g","Ģ":"g","ģ":"g","Ḡ":"g","ḡ":"g","Ǥ":"g","ǥ":"g","Ɠ":"g","ɠ":"g","Ĥ":"h","ĥ":"h","Ȟ":"h","ȟ":"h","Ḧ":"h","ḧ":"h","Ḣ":"h","ḣ":"h","Ḩ":"h","ḩ":"h","Ḥ":"h","ḥ":"h","Ḫ":"h","ḫ":"h",H:"h","ẖ":"h","Ħ":"h","ħ":"h","Ⱨ":"h","ⱨ":"h","Í":"i","í":"i","Ì":"i","ì":"i","Ĭ":"i","ĭ":"i","Î":"i","î":"i","Ǐ":"i","ǐ":"i","Ï":"i","ï":"i","Ḯ":"i","ḯ":"i","Ĩ":"i","ĩ":"i","İ":"i",i:"i","Į":"i","į":"i","Ī":"i","ī":"i","Ỉ":"i","ỉ":"i","Ȉ":"i","ȉ":"i","Ȋ":"i","ȋ":"i","Ị":"i","ị":"i","Ḭ":"i","ḭ":"i",I:"i","ı":"i","Ɨ":"i","ɨ":"i","Ĵ":"j","ĵ":"j",J:"j","ǰ":"j","ȷ":"j","Ɉ":"j","ɉ":"j","ʝ":"j","ɟ":"j","ʄ":"j","Ḱ":"k","ḱ":"k","Ǩ":"k","ǩ":"k","Ķ":"k","ķ":"k","Ḳ":"k","ḳ":"k","Ḵ":"k","ḵ":"k","Ƙ":"k","ƙ":"k","Ⱪ":"k","ⱪ":"k","Ĺ":"a","ĺ":"l","Ľ":"l","ľ":"l","Ļ":"l","ļ":"l","Ḷ":"l","ḷ":"l","Ḹ":"l","ḹ":"l","Ḽ":"l","ḽ":"l","Ḻ":"l","ḻ":"l","Ł":"l","ł":"l","Ŀ":"l","ŀ":"l","Ƚ":"l","ƚ":"l","Ⱡ":"l","ⱡ":"l","Ɫ":"l","ɫ":"l","ɬ":"l","ɭ":"l","ȴ":"l","Ḿ":"m","ḿ":"m","Ṁ":"m","ṁ":"m","Ṃ":"m","ṃ":"m","ɱ":"m","Ń":"n","ń":"n","Ǹ":"n","ǹ":"n","Ň":"n","ň":"n","Ñ":"n","ñ":"n","Ṅ":"n","ṅ":"n","Ņ":"n","ņ":"n","Ṇ":"n","ṇ":"n","Ṋ":"n","ṋ":"n","Ṉ":"n","ṉ":"n","Ɲ":"n","ɲ":"n","Ƞ":"n","ƞ":"n","ɳ":"n","ȵ":"n",N:"n",n:"n","Ó":"o","ó":"o","Ò":"o","ò":"o","Ŏ":"o","ŏ":"o","Ô":"o","ô":"o","Ố":"o","ố":"o","Ồ":"o","ồ":"o","Ỗ":"o","ỗ":"o","Ổ":"o","ổ":"o","Ǒ":"o","ǒ":"o","Ö":"o","ö":"o","Ȫ":"o","ȫ":"o","Ő":"o","ő":"o","Õ":"o","õ":"o","Ṍ":"o","ṍ":"o","Ṏ":"o","ṏ":"o","Ȭ":"o","ȭ":"o","Ȯ":"o","ȯ":"o","Ȱ":"o","ȱ":"o","Ø":"o","ø":"o","Ǿ":"o","ǿ":"o","Ǫ":"o","ǫ":"o","Ǭ":"o","ǭ":"o","Ō":"o","ō":"o","Ṓ":"o","ṓ":"o","Ṑ":"o","ṑ":"o","Ỏ":"o","ỏ":"o","Ȍ":"o","ȍ":"o","Ȏ":"o","ȏ":"o","Ơ":"o","ơ":"o","Ớ":"o","ớ":"o","Ờ":"o","ờ":"o","Ỡ":"o","ỡ":"o","Ở":"o","ở":"o","Ợ":"o","ợ":"o","Ọ":"o","ọ":"o","Ộ":"o","ộ":"o","Ɵ":"o","ɵ":"o","Ṕ":"p","ṕ":"p","Ṗ":"p","ṗ":"p","Ᵽ":"p","Ƥ":"p","ƥ":"p",p:"p","ʠ":"q","Ɋ":"q","ɋ":"q","Ŕ":"r","ŕ":"r","Ř":"r","ř":"r","Ṙ":"r","ṙ":"r","Ŗ":"r","ŗ":"r","Ȑ":"r","ȑ":"r","Ȓ":"r","ȓ":"r","Ṛ":"r","ṛ":"r","Ṝ":"r","ṝ":"r","Ṟ":"r","ṟ":"r","Ɍ":"r","ɍ":"r","ᵲ":"r","ɼ":"r","Ɽ":"r","ɽ":"r","ɾ":"r","ᵳ":"r","ß":"s","Ś":"s","ś":"s","Ṥ":"s","ṥ":"s","Ŝ":"s","ŝ":"s","Š":"s","š":"s","Ṧ":"s","ṧ":"s","Ṡ":"s","ṡ":"s","ẛ":"s","Ş":"s","ş":"s","Ṣ":"s","ṣ":"s","Ṩ":"s","ṩ":"s","Ș":"s","ș":"s","ʂ":"s",S:"s",s:"s","Þ":"t","þ":"t","Ť":"t","ť":"t",T:"t","ẗ":"t","Ṫ":"t","ṫ":"t","Ţ":"t","ţ":"t","Ṭ":"t","ṭ":"t","Ț":"t","ț":"t","Ṱ":"t","ṱ":"t","Ṯ":"t","ṯ":"t","Ŧ":"t","ŧ":"t","Ⱦ":"t","ⱦ":"t","ᵵ":"t","ƫ":"t","Ƭ":"t","ƭ":"t","Ʈ":"t","ʈ":"t","ȶ":"t","Ú":"u","ú":"u","Ù":"u","ù":"u","Ŭ":"u","ŭ":"u","Û":"u","û":"u","Ǔ":"u","ǔ":"u","Ů":"u","ů":"u","Ü":"u","ü":"u","Ǘ":"u","ǘ":"u","Ǜ":"u","ǜ":"u","Ǚ":"u","ǚ":"u","Ǖ":"u","ǖ":"u","Ű":"u","ű":"u","Ũ":"u","ũ":"u","Ṹ":"u","ṹ":"u","Ų":"u","ų":"u","Ū":"u","ū":"u","Ṻ":"u","ṻ":"u","Ủ":"u","ủ":"u","Ȕ":"u","ȕ":"u","Ȗ":"u","ȗ":"u","Ư":"u","ư":"u","Ứ":"u","ứ":"u","Ừ":"u","ừ":"u","Ữ":"u","ữ":"u","Ử":"u","ử":"u","Ự":"u","ự":"u","Ụ":"u","ụ":"u","Ṳ":"u","ṳ":"u","Ṷ":"u","ṷ":"u","Ṵ":"u","ṵ":"u","Ʉ":"u","ʉ":"u","Ṽ":"v","ṽ":"v","Ṿ":"v","ṿ":"v","Ʋ":"v","ʋ":"v","Ẃ":"w","ẃ":"w","Ẁ":"w","ẁ":"w","Ŵ":"w","ŵ":"w",W:"w","ẘ":"w","Ẅ":"w","ẅ":"w","Ẇ":"w","ẇ":"w","Ẉ":"w","ẉ":"w","Ẍ":"x","ẍ":"x","Ẋ":"x","ẋ":"x","Ý":"y","ý":"y","Ỳ":"y","ỳ":"y","Ŷ":"y","ŷ":"y",Y:"y","ẙ":"y","Ÿ":"y","ÿ":"y","Ỹ":"y","ỹ":"y","Ẏ":"y","ẏ":"y","Ȳ":"y","ȳ":"y","Ỷ":"y","ỷ":"y","Ỵ":"y","ỵ":"y","ʏ":"y","Ɏ":"y","ɏ":"y","Ƴ":"y","ƴ":"y","Ź":"z","ź":"z","Ẑ":"z","ẑ":"z","Ž":"z","ž":"z","Ż":"z","ż":"z","Ẓ":"z","ẓ":"z","Ẕ":"z","ẕ":"z","Ƶ":"z","ƶ":"z","Ȥ":"z","ȥ":"z","ʐ":"z","ʑ":"z","Ⱬ":"z","ⱬ":"z","Ǯ":"z","ǯ":"z","ƺ":"z","２":"2","６":"6","Ｂ":"B","Ｆ":"F","Ｊ":"J","Ｎ":"N","Ｒ":"R","Ｖ":"V","Ｚ":"Z","ｂ":"b","ｆ":"f","ｊ":"j","ｎ":"n","ｒ":"r","ｖ":"v","ｚ":"z","１":"1","５":"5","９":"9","Ａ":"A","Ｅ":"E","Ｉ":"I","Ｍ":"M","Ｑ":"Q","Ｕ":"U","Ｙ":"Y","ａ":"a","ｅ":"e","ｉ":"i","ｍ":"m","ｑ":"q","ｕ":"u","ｙ":"y","０":"0","４":"4","８":"8","Ｄ":"D","Ｈ":"H","Ｌ":"L","Ｐ":"P","Ｔ":"T","Ｘ":"X","ｄ":"d","ｈ":"h","ｌ":"l","ｐ":"p","ｔ":"t","ｘ":"x","３":"3","７":"7","Ｃ":"C","Ｇ":"G","Ｋ":"K","Ｏ":"O","Ｓ":"S","Ｗ":"W","ｃ":"c","ｇ":"g","ｋ":"k","ｏ":"o","ｓ":"s","ｗ":"w"},_reEscape=/[-\/\\^$*+?.()|[\]{}]/,_reNonBlank=/\S/,NEVER_USE_TWOPASS=/(iPad|iPhone|iPod).*(AppleWebKit\/).*(Mobile\/).*(Safari\/)/i.test(navigator.userAgent)}).call(__webpack_exports__,__webpack_require__(34))},function(e,t,n){"use strict";function r(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};t.extra=Object.assign({},t.extra,e.sentry_extra),o.a.captureException(e,t)}n.d(t,"a",function(){return s}),t.b=r;var i=n(267),o=n.n(i),a=[],s=function(){function e(){babelHelpers.classCallCheck(this,e)}return e.install=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=e.sessionId,n=void 0===t?null:t,r=e.extraContext,i=void 0===r?{}:r,s=e.tagsContext,u=void 0===s?{}:s;o.a.config("https://4ff726251e854b6187703bf21547f686@sentry.issuu.com/18",{ignoreErrors:["top.GLOBALS","originalCreateNotification","canvas.contentDocument","MyApp_RemoveAllHighlights","http://tt.epicplay.com","Can't find variable: ZiteReader","jigsaw is not defined","ComboSearch is not defined","http://loading.retry.widdit.com/","atomicFindClose","fb_xd_fragment","bmi_SafeAddOnload","EBCallBackMessageReceived","conduitPage","Javascript error: ReferenceError: Can't find variable: dataKeys on line 0","Javascript error: ReferenceError: Can't find variable: dataKeys on line 1","Javascript error: ReferenceError: Can't find variable: dataKeys on line 13","Javascript error: Script error. on line 0","Javascript error: Script error on line 0","Modernizr is not defined","$ is not a function","__gCrWeb",/^resource:\/\//i,"shopex"],collectWindowErrors:!0,maxMessageLength:1e3,maxBreadcrumbs:30,autoBreadcrumbs:{xhr:!0,console:!1,dom:!1,location:!1},environment:"production",release:"1.0.1102",tags:{embed:"fullscreen_fallback",twittercard:!1},shouldSendCallback:function(e){var t=Date.now();if(a.push(t),a.length>5){return t-a.shift()>6e4}return!0},dataCallback:function(e){return e.request.url.match(/embed.html#iargs/)&&e.extra&&e.extra.hostUrl&&"unknown"!==e.extra.hostUrl&&(e.request.url=e.extra.hostUrl+"#"+e.request.url.split("#")[1]),e}}),o.a.setUserContext({id:n}),i&&Object.keys(i).length&&o.a.setExtraContext(i),u&&Object.keys(u).length&&o.a.setTagsContext(u),o.a.install()},e}()},function(e,t,n){"use strict";function r(e){return e.readMorePlugin&&e.readMorePlugin.getButtonUnreadCount()||0}Object.defineProperty(t,"__esModule",{value:!0}),n.d(t,"selectReadyToRender",function(){return c}),t.selectButtonUnreadCount=r,n.d(t,"selectShouldRenderButton",function(){return l}),n.d(t,"selectShouldRenderExitFullscreenOverlay",function(){return p}),n.d(t,"selectShowAsOverlay",function(){return d});var i=n(33),o=(n.n(i),n(11)),a=n(93),s=n(212),u=n(35),c=n.i(i.createSelector)(function(e){return e.readMorePlugin},function(e){return e.readmore.loaded},o.selectReaderSize,function(e,t,n){return!(!e||!t||n===s.a)}),l=n.i(i.createSelector)(c,function(e){return e.readMorePlugin},o.selectShowCTAOverlay,o.selectFullscreenEnabled,a.canSeeOwnPublication,a.canHideRelated,function(e,t,n,r,i,o){return!(!e||n)&&t.shouldRenderButton(i,o,r)}),p=n.i(i.createSelector)(c,function(e){return e.readMorePlugin},a.canSeeOwnPublication,a.canHideRelated,function(e,t,n,r){return e&&t.shouldRenderExitFullscreenOverlay(n,r)}),d=n.i(i.createSelector)(c,function(e){return e.readMorePlugin},function(e){return e.readmore.forceOverlay},function(e){return e.size.width},function(e){return e.size.height},function(e,t,r,i,o){if(e){var a=i<o,s=!a,c=n.i(u.a)();return r||t.shouldAlwaysBeOverlay()||a&&i<=414*c||s&&i<=736*c}return!1})},function(e,t,n){"use strict";function r(e,t){return{type:a,width:e,height:t}}function i(){var e={width:0,height:0};return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,n=arguments[1];switch(n.type){case o.b:return Object.assign({},t,{width:n.width,height:n.height});case a:return Object.assign({},t,{width:n.width,height:n.height});default:return t}}}n.d(t,"c",function(){return a}),t.a=r,t.b=i;var o=n(19),a="RESIZE"},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function(e,t){return function(n){return function(r){return function(i){var o=n.getState(),a=r(i),s=n.getState();try{e.hasOwnProperty(i.type)&&e[i.type](o,s,i)}catch(e){t(e)}return a}}}}},function(e,t,n){var r=n(29),i=n(17),o=n(70);e.exports=function(e){return function(t,n,a){var s,u=r(t),c=i(u.length),l=o(a,c);if(e&&n!=n){for(;c>l;)if((s=u[l++])!=s)return!0}else for(;c>l;l++)if((e||l in u)&&u[l]===n)return e||l||0;return!e&&-1}}},function(e,t,n){"use strict";var r=n(4),i=n(0),o=n(27),a=n(68),s=n(60),u=n(82),c=n(63),l=n(9),p=n(6),d=n(118),f=n(84),h=n(149);e.exports=function(e,t,n,m,g,v){var b=r[e],y=b,_=g?"set":"add",w=y&&y.prototype,E={},x=function(e){var t=w[e];o(w,e,"delete"==e?function(e){return!(v&&!l(e))&&t.call(this,0===e?0:e)}:"has"==e?function(e){return!(v&&!l(e))&&t.call(this,0===e?0:e)}:"get"==e?function(e){return v&&!l(e)?void 0:t.call(this,0===e?0:e)}:"add"==e?function(e){return t.call(this,0===e?0:e),this}:function(e,n){return t.call(this,0===e?0:e,n),this})};if("function"==typeof y&&(v||w.forEach&&!p(function(){(new y).entries().next()}))){var S=new y,T=S[_](v?{}:-0,1)!=S,C=p(function(){S.has(1)}),I=d(function(e){new y(e)}),M=!v&&p(function(){for(var e=new y,t=5;t--;)e[_](t,t);return!e.has(-0)});I||(y=t(function(t,n){c(t,y,e);var r=h(new b,t,y);return void 0!=n&&u(n,g,r[_],r),r}),y.prototype=w,w.constructor=y),(C||M)&&(x("delete"),x("has"),g&&x("get")),(M||T)&&x(_),v&&w.clear&&delete w.clear}else y=m.getConstructor(t,e,g,_),a(y.prototype,n),s.NEED=!0;return f(y,e),E[e]=y,i(i.G+i.W+i.F*(y!=b),E),v||m.setStrong(y,e,g),y}},function(e,t,n){"use strict";var r=n(26),i=n(27),o=n(6),a=n(37),s=n(12);e.exports=function(e,t,n){var u=s(e),c=n(a,u,""[e]),l=c[0],p=c[1];o(function(){var t={};return t[u]=function(){return 7},7!=""[e](t)})&&(i(String.prototype,e,l),r(RegExp.prototype,u,2==t?function(e,t){return p.call(e,this,t)}:function(e){return p.call(e,this)}))}},function(e,t,n){"use strict";var r=n(3);e.exports=function(){var e=r(this),t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),e.sticky&&(t+="y"),t}},function(e,t){e.exports=function(e,t,n){var r=void 0===n;switch(t.length){case 0:return r?e():e.call(n);case 1:return r?e(t[0]):e.call(n,t[0]);case 2:return r?e(t[0],t[1]):e.call(n,t[0],t[1]);case 3:return r?e(t[0],t[1],t[2]):e.call(n,t[0],t[1],t[2]);case 4:return r?e(t[0],t[1],t[2],t[3]):e.call(n,t[0],t[1],t[2],t[3])}return e.apply(n,t)}},function(e,t,n){var r=n(9),i=n(36),o=n(12)("match");e.exports=function(e){var t;return r(e)&&(void 0!==(t=e[o])?!!t:"RegExp"==i(e))}},function(e,t,n){var r=n(12)("iterator"),i=!1;try{var o=[7][r]();o.return=function(){i=!0},Array.from(o,function(){throw 2})}catch(e){}e.exports=function(e,t){if(!t&&!i)return!1;var n=!1;try{var o=[7],a=o[r]();a.next=function(){return{done:n=!0}},o[r]=function(){return a},e(o)}catch(e){}return n}},function(e,t,n){e.exports=n(64)||!n(6)(function(){var e=Math.random();__defineSetter__.call(null,e,function(){}),delete n(4)[e]})},function(e,t){t.f=Object.getOwnPropertySymbols},function(e,t,n){var r=n(4),i=r["__core-js_shared__"]||(r["__core-js_shared__"]={});e.exports=function(e){return i[e]||(i[e]={})}},function(e,t,n){for(var r,i=n(4),o=n(26),a=n(71),s=a("typed_array"),u=a("view"),c=!(!i.ArrayBuffer||!i.DataView),l=c,p=0,d="Int8Array,Uint8Array,Uint8ClampedArray,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array".split(",");p<9;)(r=i[d[p++]])?(o(r.prototype,s,!0),o(r.prototype,u,!0)):l=!1;e.exports={ABV:c,CONSTR:l,TYPED:s,VIEW:u}},function(e,t,n){var r=n(605);e.exports=Function.prototype.bind||r},function(e,t,n){"use strict";function r(e){return Object.prototype.hasOwnProperty.call(e,m)||(e[m]=f++,p[e[m]]={}),p[e[m]]}var i,o=n(13),a=n(175),s=n(678),u=n(280),c=n(710),l=n(186),p={},d=!1,f=0,h={topAbort:"abort",topAnimationEnd:c("animationend")||"animationend",topAnimationIteration:c("animationiteration")||"animationiteration",topAnimationStart:c("animationstart")||"animationstart",topBlur:"blur",topCanPlay:"canplay",topCanPlayThrough:"canplaythrough",topChange:"change",topClick:"click",topCompositionEnd:"compositionend",topCompositionStart:"compositionstart",topCompositionUpdate:"compositionupdate",topContextMenu:"contextmenu",topCopy:"copy",topCut:"cut",topDoubleClick:"dblclick",topDrag:"drag",topDragEnd:"dragend",topDragEnter:"dragenter",topDragExit:"dragexit",topDragLeave:"dragleave",topDragOver:"dragover",topDragStart:"dragstart",topDrop:"drop",topDurationChange:"durationchange",topEmptied:"emptied",topEncrypted:"encrypted",topEnded:"ended",topError:"error",topFocus:"focus",topInput:"input",topKeyDown:"keydown",topKeyPress:"keypress",topKeyUp:"keyup",topLoadedData:"loadeddata",topLoadedMetadata:"loadedmetadata",topLoadStart:"loadstart",topMouseDown:"mousedown",topMouseMove:"mousemove",topMouseOut:"mouseout",topMouseOver:"mouseover",topMouseUp:"mouseup",topPaste:"paste",topPause:"pause",topPlay:"play",topPlaying:"playing",topProgress:"progress",topRateChange:"ratechange",topScroll:"scroll",topSeeked:"seeked",topSeeking:"seeking",topSelectionChange:"selectionchange",topStalled:"stalled",topSuspend:"suspend",topTextInput:"textInput",topTimeUpdate:"timeupdate",topTouchCancel:"touchcancel",topTouchEnd:"touchend",topTouchMove:"touchmove",topTouchStart:"touchstart",topTransitionEnd:c("transitionend")||"transitionend",topVolumeChange:"volumechange",topWaiting:"waiting",topWheel:"wheel"},m="_reactListenersID"+String(Math.random()).slice(2),g=o({},s,{ReactEventListener:null,injection:{injectReactEventListener:function(e){e.setHandleTopLevel(g.handleTopLevel),g.ReactEventListener=e}},setEnabled:function(e){g.ReactEventListener&&g.ReactEventListener.setEnabled(e)},isEnabled:function(){return!(!g.ReactEventListener||!g.ReactEventListener.isEnabled())},listenTo:function(e,t){for(var n=t,i=r(n),o=a.registrationNameDependencies[e],s=0;s<o.length;s++){var u=o[s];i.hasOwnProperty(u)&&i[u]||("topWheel"===u?l("wheel")?g.ReactEventListener.trapBubbledEvent("topWheel","wheel",n):l("mousewheel")?g.ReactEventListener.trapBubbledEvent("topWheel","mousewheel",n):g.ReactEventListener.trapBubbledEvent("topWheel","DOMMouseScroll",n):"topScroll"===u?l("scroll",!0)?g.ReactEventListener.trapCapturedEvent("topScroll","scroll",n):g.ReactEventListener.trapBubbledEvent("topScroll","scroll",g.ReactEventListener.WINDOW_HANDLE):"topFocus"===u||"topBlur"===u?(l("focus",!0)?(g.ReactEventListener.trapCapturedEvent("topFocus","focus",n),g.ReactEventListener.trapCapturedEvent("topBlur","blur",n)):l("focusin")&&(g.ReactEventListener.trapBubbledEvent("topFocus","focusin",n),g.ReactEventListener.trapBubbledEvent("topBlur","focusout",n)),i.topBlur=!0,i.topFocus=!0):h.hasOwnProperty(u)&&g.ReactEventListener.trapBubbledEvent(u,h[u],n),i[u]=!0)}},trapBubbledEvent:function(e,t,n){return g.ReactEventListener.trapBubbledEvent(e,t,n)},trapCapturedEvent:function(e,t,n){return g.ReactEventListener.trapCapturedEvent(e,t,n)},supportsEventPageXY:function(){if(!document.createEvent)return!1;var e=document.createEvent("MouseEvent");return null!=e&&"pageX"in e},ensureScrollValueMonitoring:function(){if(void 0===i&&(i=g.supportsEventPageXY()),!i&&!d){g.ReactEventListener.monitorScrollValue(u.refreshScrollValues),d=!0}}});e.exports=g},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(105),o=n(280),a=n(184);i.augmentClass(r,{screenX:null,screenY:null,clientX:null,clientY:null,ctrlKey:null,shiftKey:null,altKey:null,metaKey:null,getModifierState:a,button:function(e){var t=e.button;return"which"in e?t:2===t?2:4===t?1:0},buttons:null,relatedTarget:function(e){return e.relatedTarget||(e.fromElement===e.srcElement?e.toElement:e.fromElement)},pageX:function(e){return"pageX"in e?e.pageX:e.clientX+o.currentScrollLeft},pageY:function(e){return"pageY"in e?e.pageY:e.clientY+o.currentScrollTop}}),e.exports=r},function(e,t,n){"use strict";var r=n(7),i=(n(1),{});e.exports={reinitializeTransaction:function(){this.transactionWrappers=this.getTransactionWrappers(),this.wrapperInitData?this.wrapperInitData.length=0:this.wrapperInitData=[],this._isInTransaction=!1},_isInTransaction:!1,getTransactionWrappers:null,isInTransaction:function(){return!!this._isInTransaction},perform:function(e,t,n,i,o,a,s,u){this.isInTransaction()&&r("27");var c,l;try{this._isInTransaction=!0,c=!0,this.initializeAll(0),l=e.call(t,n,i,o,a,s,u),c=!1}finally{try{if(c)try{this.closeAll(0)}catch(e){}else this.closeAll(0)}finally{this._isInTransaction=!1}}return l},initializeAll:function(e){for(var t=this.transactionWrappers,n=e;n<t.length;n++){var r=t[n];try{this.wrapperInitData[n]=i,this.wrapperInitData[n]=r.initialize?r.initialize.call(this):null}finally{if(this.wrapperInitData[n]===i)try{this.initializeAll(n+1)}catch(e){}}}},closeAll:function(e){this.isInTransaction()||r("28");for(var t=this.transactionWrappers,n=e;n<t.length;n++){var o,a=t[n],s=this.wrapperInitData[n];try{o=!0,s!==i&&a.close&&a.close.call(this,s),o=!1}finally{if(o)try{this.closeAll(n+1)}catch(e){}}}this.wrapperInitData.length=0}}},function(e,t,n){"use strict";function r(e){var t=""+e,n=o.exec(t);if(!n)return t;var r,i="",a=0,s=0;for(a=n.index;a<t.length;a++){switch(t.charCodeAt(a)){case 34:r="&quot;";break;case 38:r="&amp;";break;case 39:r="&#x27;";break;case 60:r="&lt;";break;case 62:r="&gt;";break;default:continue}s!==a&&(i+=t.substring(s,a)),s=a+1,i+=r}return s!==a?i+t.substring(s,a):i}function i(e){return"boolean"==typeof e||"number"==typeof e?""+e:r(e)}var o=/["'&<>]/;e.exports=i},function(e,t,n){"use strict";var r,i=n(24),o=n(174),a=/^[ \r\n\t\f]/,s=/<(!--|link|noscript|meta|script|style)[ \r\n\t\f\/>]/,u=n(182),c=u(function(e,t){if(e.namespaceURI!==o.svg||"innerHTML"in e)e.innerHTML=t;else{r=r||document.createElement("div"),r.innerHTML="<svg>"+t+"</svg>";for(var n=r.firstChild;n.firstChild;)e.appendChild(n.firstChild)}});if(i.canUseDOM){var l=document.createElement("div");l.innerHTML=" ",""===l.innerHTML&&(c=function(e,t){if(e.parentNode&&e.parentNode.replaceChild(e,e),a.test(t)||"<"===t[0]&&s.test(t)){e.innerHTML=String.fromCharCode(65279)+t;var n=e.firstChild;1===n.data.length?e.removeChild(n):n.deleteData(0,1)}else e.innerHTML=t}),l=null}e.exports=c},function(e,t,n){"use strict";function r(e,t){e({type:t}),window.setTimeout(function(){e({type:o})},2e3)}function i(){return function(e,t){e({type:a});var n=t().config.getScheme(),i=t().config.hosts.api,o=t().documentModel.documentId,c=""+n+i+"/query?action=issuu.document.download_external&documentId="+o+"&format=json";fetch(c).then(function(e){return e.json()}).then(function(t){window.open(t.rsp._content.redirect.url,"_top"),r(e,s)}).catch(function(){r(e,u)})}}n.d(t,"a",function(){return c}),n.d(t,"b",function(){return i});var o="DOWNLOAD_READY",a="DOWNLOAD_LOADING",s="DOWNLOAD_SUCCESS",u="DOWNLOAD_FAILURE",c={DOWNLOAD_READY:o,DOWNLOAD_LOADING:a,DOWNLOAD_SUCCESS:s,DOWNLOAD_FAILURE:u}},function(e,t,n){"use strict";function r(e){return{type:i,enableInPubAds:e}}n.d(t,"b",function(){return o}),n.d(t,"a",function(){return r});var i="SET_INPUBADS",o={SET_INPUBADS:i}},function(e,t,n){"use strict";function r(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*n+e}function i(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*(1-Math.pow(2,-10*n))+e}function o(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*Math.pow(2,10*(n-1))+e}function a(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*n*n+e}function s(e,t,n){return n=Math.max(Math.min(n,1),0),(t-e)*n*(2-n)+e}t.d=r,t.c=i,t.e=o,t.b=a,t.a=s},function(e,t,n){"use strict";n.d(t,"a",function(){return u});var r=n(2),i=n.n(r),o=n(57),a=n.n(o),s=n(206),u=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e){return!a()(this.props,e)},t.prototype.render=function(){var e=this.props.size*this.props.zoomLevel,n={width:e,height:e},r=["spinner"];return this.props.type===t.SPINNER_TYPE_ALTERNATE&&r.push("spinner--alternate"),i.a.createElement("div",{className:r.join(" "),style:n,dangerouslySetInnerHTML:{__html:s.a}})},t}(r.Component);u.displayName="Spinner",u.SPINNER_SIZE_DEFAULT=24,u.SPINNER_SIZE_TINY=14,u.SPINNER_SIZE_SMALL=19,u.SPINNER_TYPE_DEFAULT="SPINNER_TYPE_DEFAULT",u.SPINNER_TYPE_ALTERNATE="SPINNER_TYPE_ALTERNATE",u.defaultProps={type:u.SPINNER_TYPE_DEFAULT,size:u.SPINNER_SIZE_DEFAULT,zoomLevel:1}},function(e,t,n){"use strict";n.d(t,"b",function(){return r}),n.d(t,"a",function(){return i});var r="FULLSCREEN@FULLSCREEN_API",i="FULLSCREEN@TAB"},function(e,t,n){"use strict";n.d(t,"a",function(){return r}),n.d(t,"b",function(){return i});var r="openUrl",i="gotoPage"},function(e,t,n){"use strict";n.d(t,"a",function(){return o});var r=n(359),i=n(78),o=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this.initialGesture=i.d,this.pointers={},this._lastGestureMoveTimestamp=0,this._initialPinchDistance=NaN,this._targetElementOffset=null,this.targetElement=t,this.callbacks=n,this.options=r}return e.prototype.destroy=function(){},e.prototype.reset=function(){this.pointers={},this._lastGestureMoveTimestamp=0,this._initialPinchDistance=NaN,this.initialGesture=i.d,this._targetElementOffset=null},e.prototype.isDeactivated=function(){return this.options.activeHandler&&this.options.activeHandler!==this},e.prototype._isAnyButtonPressed=function(e){return!(!e.buttons&&!this.getPointerCount())},e.prototype._isGeneratedByMouseDevice=function(e){return!e.pointerType||"mouse"===e.pointerType},e.prototype.getScalingFactor=function(){return this.callbacks.getScalingFactor?this.callbacks.getScalingFactor():1},e.prototype.fireGestureStart=function(){var e=this.callbacks.onGestureStart;e&&e(this._getTouches(),this._getLastEventTimestamp())},e.prototype.fireGestureChange=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:NaN,t=this._getLastEventTimestamp();if(t-this._lastGestureMoveTimestamp>10){var n=isNaN(e)?this._getCurrentPinchDistance()/this._initialPinchDistance:e;if(!isNaN(n)){var r=this.callbacks.onGestureChange;r&&r(this._getTouches(),t,n,this.initialGesture),this._lastGestureMoveTimestamp=t}}},e.prototype.fireGestureEnd=function(){var e=this.callbacks.onGestureEnd;e&&e(this._getLastEventTimestamp())},e.prototype.fireMouseMove=function(e){if(this._isGeneratedByMouseDevice(e)&&!this._isAnyButtonPressed(e)){var t=e.pageX,n=e.pageY,r=this._getOffsetPosition(t,n),i=this.getScalingFactor(),o=this.callbacks.onMouseMove;o&&o(r.x*i,r.y*i,e.timeStamp)}},e.prototype.fireMouseEnter=function(e){if(this._isGeneratedByMouseDevice(e)){var t=this.callbacks.onMouseEnter;t&&t(e.timeStamp)}},e.prototype.fireMouseLeave=function(e){if(this._isGeneratedByMouseDevice(e)){var t=this.callbacks.onMouseLeave;t&&t(e.timeStamp)}},e.prototype.saveTargetElementOffset=function(){this._targetElementOffset=n.i(r.a)(this.targetElement)},e.prototype.saveInitialPinchDistance=function(){this._initialPinchDistance=this._getCurrentPinchDistance()},e.prototype.saveInitialGestureIfUndefined=function(){if(this.initialGesture===i.d){var e=Object.keys(this.pointers);if(e.length>=2){var t=this._getCurrentPinchDistance();t-this._initialPinchDistance>5?this.initialGesture=i.c:this._initialPinchDistance-t>10&&(this.initialGesture=i.e)}else{var n=this.pointers[e[0]],r=n.last.position.x-n.initial.position.x,o=n.last.position.y-n.initial.position.y,a=n.last.timestamp-n.initial.timestamp;if(Math.max(Math.abs(r),Math.abs(o))<10||a<10)return;var s=Math.atan2(-o,r)*(180/Math.PI);this.initialGesture=s>=-25&&s<=25?i.b:s>=60&&s<=120?i.f:s>=155||s<=-155?i.a:s>=-120&&s<=-60?i.g:i.h}}},e.prototype.isValidPointer=function(e){return!!this.pointers[e]},e.prototype.savePointer=function(e,t,n,r){var i=this._getOffsetPosition(t,n),o=this._getValidTimestamp(r);this.pointers[e]=this.pointers[e]||{initial:{position:i,timestamp:o}},this.pointers[e].last={position:i,timestamp:o}},e.prototype.deletePointer=function(e){delete this.pointers[e],0===this.getPointerCount()&&(this.initialGesture=i.d,this._initialPinchDistance=NaN)},e.prototype.isPointerMoved=function(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,i=this._getOffsetPosition(t,n),o=this.pointers[e].last.position;return Math.abs(o.x-i.x)>Math.abs(r)||Math.abs(o.y-i.y)>Math.abs(r)},e.prototype._getValidTimestamp=function(e){return parseInt((""+e).substring(0,13),10)},e.prototype._getOffsetPosition=function(e,t){this._targetElementOffset||this.saveTargetElementOffset();var n=this._targetElementOffset||{},r=n.left,i=void 0===r?0:r,o=n.top,a=void 0===o?0:o;return{x:Math.round(e-i),y:Math.round(t-a)}},e.prototype._getLastEventTimestamp=function(){var e=this,t=0;return Object.keys(this.pointers).forEach(function(n){var r=e.pointers[n];t=Math.max(t,r.last.timestamp)}),t},e.prototype._getCurrentPinchDistance=function(){var e=Object.keys(this.pointers);if(e.length<=1)return 1;var t=this.pointers[e[0]],n=this.pointers[e[1]];return Math.sqrt(Math.pow(t.last.position.x-n.last.position.x,2)+Math.pow(t.last.position.y-n.last.position.y,2))},e.prototype.getPointerCount=function(){return Object.keys(this.pointers).length},e.prototype._getTouches=function(){var e=this,t=this.getScalingFactor();return Object.keys(this.pointers).map(function(n){var r=e.pointers[n];return{x:r.last.position.x*t,y:r.last.position.y*t}})},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return i});var r=n(135),i=function(e){function t(n,r,i){babelHelpers.classCallCheck(this,t);var o=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,i));return o._singleTapConfirmedTimeoutId=null,o._doubleTapConfirmedTimeoutId=null,o}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.unregisterTapHandlers()},t.prototype.reset=function(){e.prototype.reset.call(this),this.unregisterTapHandlers()},t.prototype.registerTapHandlers=function(){var e=this,t=this._getFirstPointerId(),n=this.pointers[t].last.position;window.clearTimeout(this._doubleTapConfirmedTimeoutId),this._doubleTapConfirmedTimeoutId=null,window.clearTimeout(this._singleTapConfirmedTimeoutId),this._singleTapConfirmedTimeoutId&&1===this.getPointerCount()&&(this._doubleTapConfirmedTimeoutId=window.setTimeout(function(){e._doubleTapConfirmedTimeoutId=null,0===e.getPointerCount()&&e._fireDoubleTapConfirmed(n.x,n.y)},200)),this._singleTapConfirmedTimeoutId=null,this._doubleTapConfirmedTimeoutId||1!==this.getPointerCount()||(this._singleTapConfirmedTimeoutId=window.setTimeout(function(){e._singleTapConfirmedTimeoutId=null,0===e.getPointerCount()&&e._fireSingleTapConfirmed(n.x,n.y)},200))},t.prototype.unregisterTapHandlers=function(){window.clearTimeout(this._singleTapConfirmedTimeoutId),this._singleTapConfirmedTimeoutId=null,window.clearTimeout(this._doubleTapConfirmedTimeoutId),this._doubleTapConfirmedTimeoutId=null},t.prototype.validateTapHandlers=function(){var e=this._getFirstPointerId(),t=this.pointers[e].last.position;this._isPointerCloseToInitialPosition(e,t.x,t.y)||this.unregisterTapHandlers()},t.prototype.executeTapHandlers=function(){var e=this._getFirstPointerId(),t=this.pointers[e].last.position;this._singleTapConfirmedTimeoutId&&this._fireSingleTap(t.x,t.y),this._doubleTapConfirmedTimeoutId&&(this._fireSingleTap(t.x,t.y),this._fireDoubleTap(t.x,t.y))},t.prototype._fireSingleTap=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onSingleTap;r&&r(e*n,t*n)},t.prototype._fireSingleTapConfirmed=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onSingleTapConfirmed;r&&r(e*n,t*n)},t.prototype._fireDoubleTap=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onDoubleTap;r&&r(e*n,t*n)},t.prototype._fireDoubleTapConfirmed=function(e,t){var n=this.getScalingFactor(),r=this.callbacks.onDoubleTapConfirmed;r&&r(e*n,t*n)},t.prototype._getFirstPointerId=function(){return Object.keys(this.pointers)[0]},t.prototype._isPointerCloseToInitialPosition=function(e,t,n){var r=this.pointers[e];return Math.abs(r.initial.position.x-t)<5&&Math.abs(r.initial.position.y-n)<5},t}(r.a)},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r="SHARE"},function(e,t,n){"use strict";function r(e,t){return{type:d,service:e,videoId:t}}function i(){return{type:f}}function o(e,t){switch(t.type){case d:return Object.assign({},e,{showOverlay:!0,service:t.service,videoId:t.videoId});case f:return Object.assign({},e,{showOverlay:!1});default:return e}}function a(){var e={showOverlay:!1,service:null,videoId:null};return function(){return o(arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,arguments[1])}}t.e=r,t.f=a,n.d(t,"b",function(){return h}),n.d(t,"c",function(){return m}),n.d(t,"d",function(){return g}),n.d(t,"a",function(){return v});var s=n(2),u=n.n(s),c=n(22),l=n(76),p=n(202),d="SHOW_VIDEO_OVERLAY",f="HIDE_VIDEO_OVERLAY",h=function(e){return e.videoOverlay.showOverlay},m=function(e){return e.videoOverlay.service},g=function(e){return e.videoOverlay.videoId},v=function(e){function t(){var n,r,o;babelHelpers.classCallCheck(this,t);for(var a=arguments.length,s=Array(a),u=0;u<a;u++)s[u]=arguments[u];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(s))),r.onBackgroundClick=function(){r.props.dispatch(i())},r.onCloseButtonClick=function(){r.props.dispatch(i()),r.props.dispatch(c.a())},r.getVideoUrl=function(){switch(r.props.service){case"youtube":return"https://www.youtube.com/embed/"+r.props.videoId;case"vimeo":return"https://player.vimeo.com/video/"+r.props.videoId;default:return""}},o=n,babelHelpers.possibleConstructorReturn(r,o)}return babelHelpers.inherits(t,e),t.prototype.render=function(){return u.a.createElement("div",{className:"video-overlay"},u.a.createElement("div",{className:"video-overlay__background",onClick:this.onBackgroundClick}),u.a.createElement("div",{className:"video-overlay__content"},u.a.createElement("iframe",{className:"video-overlay__player",src:this.getVideoUrl(),frameBorder:"0",allowFullScreen:!0}),u.a.createElement(l.a,{className:"svg-btn video-overlay__close-button",content:p.a,onClick:this.onCloseButtonClick})))},t}(s.Component);v.displayName="VideoOverlay"},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n.d(t,"isNavigationArrowsVisible",function(){return s}),n.d(t,"isLeftArrowVisible",function(){return u}),n.d(t,"isRightArrowVisible",function(){return c});var r=n(33),i=(n.n(r),n(11)),o=n(109),a=n(41),s=n.i(r.createSelector)(i.selectFeature(a.NAVIGATION_ARROWS_TYPE),i.isControlsVisible,i.moreOverlayVisible,i.selectShowCTAOverlay,o.selectShowAsOverlay,function(e){return e.reader.zoomLevel},function(e,t,n,r,i,o){return!!e&&((!i||!n)&&(t||r||1===o))}),u=n.i(r.createSelector)(s,i.isFirstSpread,i.selectCurrentSpreadIndex,function(e,t,n){return e&&!t&&n>-1}),c=n.i(r.createSelector)(s,i.isLastSpread,i.selectCurrentSpreadIndex,function(e,t,n){return e&&!t&&n>-1})},function(e,t,n){"use strict";function r(e){return{type:a,api:e}}function i(){return r({getVisiblePages:function(){return[]},getVisibleComponents:function(){return[]},getViewportBBoxForComponent:function(e){},getRenderedViews:function(e){return[]},getReadMode:function(){},getPageComponent:function(e){},goToPage:function(e){},goToSpread:function(e){},jumpToPage:function(e){},jumpToSpread:function(e){},setSnapping:function(e){},jumpToPositionByPercent:function(e){},zoomCurrentView:function(e){},getPosition:function(){},setPosition:function(e){},tweakAnimation:function(e){}})}function o(){return function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null,t=arguments[1];switch(t.type){case a:return Object.assign({},e,t.api);default:return e}}}t.b=r,t.a=i,t.c=o;var a="SET_CANVAS_API"},function(e,t,n){"use strict";function r(e,t,n){return!(!n&&t&&t.licenses)||!!t.licenses.find(function(t){return t.name===e})}t.a=r},function(e,t,n){"use strict";function r(e){return!!(window.WebGLRenderingContext&&e instanceof window.WebGLRenderingContext)||!(!e||!e.hasOwnProperty("drawingBufferWidth"))}function i(e,t){var n={failIfMajorPerformanceCaveat:!0,stencil:!!t};try{var r=e.getContext("webgl",n);if(r)return r}catch(e){}try{var i=e.getContext("experimental-webgl",n);if(i)return i}catch(e){}return null}n.d(t,"b",function(){return r}),n.d(t,"a",function(){return i})},function(e,t,n){"use strict";var r=n(18),i=n(70),o=n(17);e.exports=function(e){for(var t=r(this),n=o(t.length),a=arguments.length,s=i(a>1?arguments[1]:void 0,n),u=a>2?arguments[2]:void 0,c=void 0===u?n:i(u,n);c>s;)t[s++]=e;return t}},function(e,t,n){"use strict";var r=n(15),i=n(61);e.exports=function(e,t,n){t in e?r.f(e,t,i(0,n)):e[t]=n}},function(e,t,n){var r=n(9),i=n(4).document,o=r(i)&&r(i.createElement);e.exports=function(e){return o?i.createElement(e):{}}},function(e,t){e.exports="constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",")},function(e,t,n){var r=n(12)("match");e.exports=function(e){var t=/./;try{"/./"[e](t)}catch(n){try{return t[r]=!1,!"/./"[e](t)}catch(e){}}return!0}},function(e,t,n){e.exports=n(4).document&&document.documentElement},function(e,t,n){var r=n(9),i=n(157).set;e.exports=function(e,t,n){var o,a=t.constructor;return a!==n&&"function"==typeof a&&(o=a.prototype)!==n.prototype&&r(o)&&i&&i(e,o),e}},function(e,t,n){var r=n(83),i=n(12)("iterator"),o=Array.prototype;e.exports=function(e){return void 0!==e&&(r.Array===e||o[i]===e)}},function(e,t,n){var r=n(36);e.exports=Array.isArray||function(e){return"Array"==r(e)}},function(e,t,n){"use strict";var r=n(65),i=n(61),o=n(84),a={};n(26)(a,n(12)("iterator"),function(){return this}),e.exports=function(e,t,n){e.prototype=r(a,{next:i(1,n)}),o(e,t+" Iterator")}},function(e,t,n){"use strict";var r=n(64),i=n(0),o=n(27),a=n(26),s=n(23),u=n(83),c=n(152),l=n(84),p=n(31),d=n(12)("iterator"),f=!([].keys&&"next"in[].keys()),h=function(){return this};e.exports=function(e,t,n,m,g,v,b){c(n,t,m);var y,_,w,E=function(e){if(!f&&e in C)return C[e];switch(e){case"keys":return function(){return new n(this,e)};case"values":return function(){return new n(this,e)}}return function(){return new n(this,e)}},x=t+" Iterator",S="values"==g,T=!1,C=e.prototype,I=C[d]||C["@@iterator"]||g&&C[g],M=I||E(g),P=g?S?E("entries"):M:void 0,R="Array"==t?C.entries||I:I;if(R&&(w=p(R.call(new e)))!==Object.prototype&&(l(w,x,!0),r||s(w,d)||a(w,d,h)),S&&I&&"values"!==I.name&&(T=!0,M=function(){return I.call(this)}),r&&!b||!f&&!T&&C[d]||a(C,d,M),u[t]=M,u[x]=h,g)if(y={values:S?M:E("values"),keys:v?M:E("keys"),entries:P},b)for(_ in y)_ in C||o(C,_,y[_]);else i(i.P+i.F*(f||T),t,y);return y}},function(e,t){var n=Math.expm1;e.exports=!n||n(10)>22025.465794806718||n(10)<22025.465794806718||n(-2e-17)!=-2e-17?function(e){return 0==(e=+e)?e:e>-1e-6&&e<1e-6?e+e*e/2:Math.exp(e)-1}:n},function(e,t){e.exports=Math.sign||function(e){return 0==(e=+e)||e!=e?e:e<0?-1:1}},function(e,t,n){var r=n(4),i=n(164).set,o=r.MutationObserver||r.WebKitMutationObserver,a=r.process,s=r.Promise,u="process"==n(36)(a);e.exports=function(){var e,t,n,c=function(){var r,i;for(u&&(r=a.domain)&&r.exit();e;){i=e.fn,e=e.next;try{i()}catch(r){throw e?n():t=void 0,r}}t=void 0,r&&r.enter()};if(u)n=function(){a.nextTick(c)};else if(o){var l=!0,p=document.createTextNode("");new o(c).observe(p,{characterData:!0}),n=function(){p.data=l=!l}}else if(s&&s.resolve){var d=s.resolve();n=function(){d.then(c)}}else n=function(){i.call(r,c)};return function(r){var i={fn:r,next:void 0};t&&(t.next=i),e||(e=i,n()),t=i}}},function(e,t,n){var r=n(9),i=n(3),o=function(e,t){if(i(e),!r(t)&&null!==t)throw TypeError(t+": can't set as prototype!")};e.exports={set:Object.setPrototypeOf||("__proto__"in{}?function(e,t,r){try{r=n(51)(Function.call,n(30).f(Object.prototype,"__proto__").set,2),r(e,[]),t=!(e instanceof Array)}catch(e){t=!0}return function(e,n){return o(e,n),t?e.__proto__=n:r(e,n),e}}({},!1):void 0),check:o}},function(e,t,n){var r=n(121)("keys"),i=n(71);e.exports=function(e){return r[e]||(r[e]=i(e))}},function(e,t,n){var r=n(3),i=n(25),o=n(12)("species");e.exports=function(e,t){var n,a=r(e).constructor;return void 0===a||void 0==(n=r(a)[o])?t:i(n)}},function(e,t,n){var r=n(62),i=n(37);e.exports=function(e){return function(t,n){var o,a,s=String(i(t)),u=r(n),c=s.length;return u<0||u>=c?e?"":void 0:(o=s.charCodeAt(u),o<55296||o>56319||u+1===c||(a=s.charCodeAt(u+1))<56320||a>57343?e?s.charAt(u):o:e?s.slice(u,u+2):a-56320+(o-55296<<10)+65536)}}},function(e,t,n){var r=n(117),i=n(37);e.exports=function(e,t,n){if(r(t))throw TypeError("String#"+n+" doesn't accept regex!");return String(i(e))}},function(e,t,n){"use strict";var r=n(62),i=n(37);e.exports=function(e){var t=String(i(this)),n="",o=r(e);if(o<0||o==1/0)throw RangeError("Count can't be negative");for(;o>0;(o>>>=1)&&(t+=t))1&o&&(n+=t);return n}},function(e,t){e.exports="\t\n\v\f\r   ᠎             　\u2028\u2029\ufeff"},function(e,t,n){var r,i,o,a=n(51),s=n(116),u=n(148),c=n(145),l=n(4),p=l.process,d=l.setImmediate,f=l.clearImmediate,h=l.MessageChannel,m=0,g={},v=function(){var e=+this;if(g.hasOwnProperty(e)){var t=g[e];delete g[e],t()}},b=function(e){v.call(e.data)};d&&f||(d=function(e){for(var t=[],n=1;arguments.length>n;)t.push(arguments[n++]);return g[++m]=function(){s("function"==typeof e?e:Function(e),t)},r(m),m},f=function(e){delete g[e]},"process"==n(36)(p)?r=function(e){p.nextTick(a(v,e,1))}:h?(i=new h,o=i.port2,i.port1.onmessage=b,r=a(o.postMessage,o,1)):l.addEventListener&&"function"==typeof postMessage&&!l.importScripts?(r=function(e){l.postMessage(e+"","*")},l.addEventListener("message",b,!1)):r="onreadystatechange"in c("script")?function(e){u.appendChild(c("script")).onreadystatechange=function(){u.removeChild(this),v.call(e)}}:function(e){setTimeout(a(v,e,1),0)}),e.exports={set:d,clear:f}},function(e,t,n){"use strict";var r=n(4),i=n(14),o=n(64),a=n(122),s=n(26),u=n(68),c=n(6),l=n(63),p=n(62),d=n(17),f=n(66).f,h=n(15).f,m=n(143),g=n(84),v=r.ArrayBuffer,b=r.DataView,y=r.Math,_=r.RangeError,w=r.Infinity,E=v,x=y.abs,S=y.pow,T=y.floor,C=y.log,I=y.LN2,M=i?"_b":"buffer",P=i?"_l":"byteLength",R=i?"_o":"byteOffset",O=function(e,t,n){var r,i,o,a=Array(n),s=8*n-t-1,u=(1<<s)-1,c=u>>1,l=23===t?S(2,-24)-S(2,-77):0,p=0,d=e<0||0===e&&1/e<0?1:0;for(e=x(e),e!=e||e===w?(i=e!=e?1:0,r=u):(r=T(C(e)/I),e*(o=S(2,-r))<1&&(r--,o*=2),e+=r+c>=1?l/o:l*S(2,1-c),e*o>=2&&(r++,o/=2),r+c>=u?(i=0,r=u):r+c>=1?(i=(e*o-1)*S(2,t),r+=c):(i=e*S(2,c-1)*S(2,t),r=0));t>=8;a[p++]=255&i,i/=256,t-=8);for(r=r<<t|i,s+=t;s>0;a[p++]=255&r,r/=256,s-=8);return a[--p]|=128*d,a},k=function(e,t,n){var r,i=8*n-t-1,o=(1<<i)-1,a=o>>1,s=i-7,u=n-1,c=e[u--],l=127&c;for(c>>=7;s>0;l=256*l+e[u],u--,s-=8);for(r=l&(1<<-s)-1,l>>=-s,s+=t;s>0;r=256*r+e[u],u--,s-=8);if(0===l)l=1-a;else{if(l===o)return r?NaN:c?-w:w;r+=S(2,t),l-=a}return(c?-1:1)*r*S(2,l-t)},A=function(e){return e[3]<<24|e[2]<<16|e[1]<<8|e[0]},N=function(e){return[255&e]},D=function(e){return[255&e,e>>8&255]},L=function(e){return[255&e,e>>8&255,e>>16&255,e>>24&255]},F=function(e){return O(e,52,8)},U=function(e){return O(e,23,4)},B=function(e,t,n){h(e.prototype,t,{get:function(){return this[n]}})},H=function(e,t,n,r){var i=+n,o=p(i);if(i!=o||o<0||o+t>e[P])throw _("Wrong index!");var a=e[M]._b,s=o+e[R],u=a.slice(s,s+t);return r?u:u.reverse()},j=function(e,t,n,r,i,o){var a=+n,s=p(a);if(a!=s||s<0||s+t>e[P])throw _("Wrong index!");for(var u=e[M]._b,c=s+e[R],l=r(+i),d=0;d<t;d++)u[c+d]=l[o?d:t-d-1]},z=function(e,t){l(e,v,"ArrayBuffer");var n=+t,r=d(n);if(n!=r)throw _("Wrong length!");return r};if(a.ABV){if(!c(function(){new v})||!c(function(){new v(.5)})){v=function(e){return new E(z(this,e))};for(var W,V=v.prototype=E.prototype,G=f(E),q=0;G.length>q;)(W=G[q++])in v||s(v,W,E[W]);o||(V.constructor=v)}var Y=new b(new v(2)),$=b.prototype.setInt8;Y.setInt8(0,2147483648),Y.setInt8(1,2147483649),!Y.getInt8(0)&&Y.getInt8(1)||u(b.prototype,{setInt8:function(e,t){$.call(this,e,t<<24>>24)},setUint8:function(e,t){$.call(this,e,t<<24>>24)}},!0)}else v=function(e){var t=z(this,e);this._b=m.call(Array(t),0),this[P]=t},b=function(e,t,n){l(this,b,"DataView"),l(e,v,"DataView");var r=e[P],i=p(t);if(i<0||i>r)throw _("Wrong offset!");if(n=void 0===n?r-i:d(n),i+n>r)throw _("Wrong length!");this[M]=e,this[R]=i,this[P]=n},i&&(B(v,"byteLength","_l"),B(b,"buffer","_b"),B(b,"byteLength","_l"),B(b,"byteOffset","_o")),u(b.prototype,{getInt8:function(e){return H(this,1,e)[0]<<24>>24},getUint8:function(e){return H(this,1,e)[0]},getInt16:function(e){var t=H(this,2,e,arguments[1]);return(t[1]<<8|t[0])<<16>>16},getUint16:function(e){var t=H(this,2,e,arguments[1]);return t[1]<<8|t[0]},getInt32:function(e){return A(H(this,4,e,arguments[1]))},getUint32:function(e){return A(H(this,4,e,arguments[1]))>>>0},getFloat32:function(e){return k(H(this,4,e,arguments[1]),23,4)},getFloat64:function(e){return k(H(this,8,e,arguments[1]),52,8)},setInt8:function(e,t){j(this,1,e,N,t)},setUint8:function(e,t){j(this,1,e,N,t)},setInt16:function(e,t){j(this,2,e,D,t,arguments[2])},setUint16:function(e,t){j(this,2,e,D,t,arguments[2])},setInt32:function(e,t){j(this,4,e,L,t,arguments[2])},setUint32:function(e,t){j(this,4,e,L,t,arguments[2])},setFloat32:function(e,t){j(this,4,e,U,t,arguments[2])},setFloat64:function(e,t){j(this,8,e,F,t,arguments[2])}});g(v,"ArrayBuffer"),g(b,"DataView"),s(b.prototype,a.VIEW,!0),t.ArrayBuffer=v,t.DataView=b},function(e,t,n){var r=n(4),i=n(50),o=n(64),a=n(246),s=n(15).f;e.exports=function(e){var t=i.Symbol||(i.Symbol=o?{}:r.Symbol||{});"_"==e.charAt(0)||e in t||s(t,e,{value:a.f(e)})}},function(e,t,n){var r=n(97),i=n(12)("iterator"),o=n(83);e.exports=n(50).getIteratorMethod=function(e){if(void 0!=e)return e[i]||e["@@iterator"]||o[r(e)]}},function(e,t,n){"use strict";var r=n(81),i=n(234),o=n(83),a=n(29);e.exports=n(153)(Array,"Array",function(e,t){this._t=a(e),this._i=0,this._k=t},function(){var e=this._t,t=this._k,n=this._i++;return!e||n>=e.length?(this._t=void 0,i(1)):"keys"==t?i(0,n):"values"==t?i(0,e[n]):i(0,[n,e[n]])},"values"),o.Arguments=o.Array,r("keys"),r("values"),r("entries")},function(e,t,n){"use strict";function r(e,t){return e===t?0!==e||0!==t||1/e==1/t:e!==e&&t!==t}function i(e,t){if(r(e,t))return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var n=Object.keys(e);if(n.length!==Object.keys(t).length)return!1;for(var i=0;i<n.length;i++)if(!o.call(t,n[i])||!r(e[n[i]],t[n[i]]))return!1;return!0}var o=Object.prototype.hasOwnProperty;e.exports=i},function(e,t,n){"use strict";var r=Function.prototype.toString,i=/^\s*class /,o=function(e){try{var t=r.call(e),n=t.replace(/\/\/.*\n/g,""),o=n.replace(/\/\*[.\s\S]*\*\//g,""),a=o.replace(/\n/gm," ").replace(/ {2}/g," ");return i.test(a)}catch(e){return!1}},a=function(e){try{return!o(e)&&(r.call(e),!0)}catch(e){return!1}},s=Object.prototype.toString,u="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;e.exports=function(e){if(!e)return!1;if("function"!=typeof e&&"object"!=typeof e)return!1;if(u)return a(e);if(o(e))return!1;var t=s.call(e);return"[object Function]"===t||"[object GeneratorFunction]"===t}},function(e,t){function n(){var e=/debugads=([^;]*)/,t=e.exec(document.cookie);return t&&"true"===t.pop()||"undefined"!=typeof window&&window.location.search.indexOf("debugads=true")>-1}e.exports={log:function(){n()&&console.debug(arguments)}}},function(e,t,n){"use strict";function r(e){if(!n.i(a.a)(e)||n.i(i.a)(e)!=s)return!1;var t=n.i(o.a)(e);if(null===t)return!0;var r=p.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&l.call(r)==d}var i=n(627),o=n(629),a=n(634),s="[object Object]",u=Function.prototype,c=Object.prototype,l=u.toString,p=c.hasOwnProperty,d=l.call(Object);t.a=r},function(e,t,n){"use strict";function r(e,t){return Array.isArray(t)&&(t=t[1]),t?t.nextSibling:e.firstChild}function i(e,t,n){l.insertTreeBefore(e,t,n)}function o(e,t,n){Array.isArray(t)?s(e,t[0],t[1],n):m(e,t,n)}function a(e,t){if(Array.isArray(t)){var n=t[1];t=t[0],u(e,t,n),e.removeChild(n)}e.removeChild(t)}function s(e,t,n,r){for(var i=t;;){var o=i.nextSibling;if(m(e,i,r),i===n)break;i=o}}function u(e,t,n){for(;;){var r=t.nextSibling;if(r===n)break;e.removeChild(r)}}function c(e,t,n){var r=e.parentNode,i=e.nextSibling;i===t?n&&m(r,document.createTextNode(n),i):n?(h(i,n),u(r,i,t)):u(r,e,t)}var l=n(87),p=n(655),d=(n(16),n(39),n(182)),f=n(128),h=n(287),m=d(function(e,t,n){e.insertBefore(t,n)}),g=p.dangerouslyReplaceNodeWithMarkup;e.exports={dangerouslyReplaceNodeWithMarkup:g,replaceDelimitedText:c,processUpdates:function(e,t){for(var n=0;n<t.length;n++){var s=t[n];switch(s.type){case"INSERT_MARKUP":i(e,s.content,r(e,s.afterNode));break;case"MOVE_EXISTING":o(e,s.fromNode,r(e,s.afterNode));break;case"SET_MARKUP":f(e,s.content);break;case"TEXT_CONTENT":h(e,s.content);break;case"REMOVE_NODE":a(e,s.fromNode)}}}}},function(e,t,n){"use strict";e.exports={html:"http://www.w3.org/1999/xhtml",mathml:"http://www.w3.org/1998/Math/MathML",svg:"http://www.w3.org/2000/svg"}},function(e,t,n){"use strict";function r(){if(s)for(var e in u){var t=u[e],n=s.indexOf(e);if(n>-1||a("96",e),!c.plugins[n]){t.extractEvents||a("97",e),c.plugins[n]=t;var r=t.eventTypes;for(var o in r)i(r[o],t,o)||a("98",o,e)}}}function i(e,t,n){c.eventNameDispatchConfigs.hasOwnProperty(n)&&a("99",n),c.eventNameDispatchConfigs[n]=e;var r=e.phasedRegistrationNames;if(r){for(var i in r)if(r.hasOwnProperty(i)){var s=r[i];o(s,t,n)}return!0}return!!e.registrationName&&(o(e.registrationName,t,n),!0)}function o(e,t,n){c.registrationNameModules[e]&&a("100",e),c.registrationNameModules[e]=t,c.registrationNameDependencies[e]=t.eventTypes[n].dependencies}var a=n(7),s=(n(1),null),u={},c={plugins:[],eventNameDispatchConfigs:{},registrationNameModules:{},registrationNameDependencies:{},possibleRegistrationNames:null,injectEventPluginOrder:function(e){s&&a("101"),s=Array.prototype.slice.call(e),r()},injectEventPluginsByName:function(e){var t=!1;for(var n in e)if(e.hasOwnProperty(n)){var i=e[n];u.hasOwnProperty(n)&&u[n]===i||(u[n]&&a("102",n),u[n]=i,t=!0)}t&&r()},getPluginModuleForEvent:function(e){var t=e.dispatchConfig;if(t.registrationName)return c.registrationNameModules[t.registrationName]||null;if(void 0!==t.phasedRegistrationNames){var n=t.phasedRegistrationNames;for(var r in n)if(n.hasOwnProperty(r)){var i=c.registrationNameModules[n[r]];if(i)return i}}return null},_resetEventPlugins:function(){s=null;for(var e in u)u.hasOwnProperty(e)&&delete u[e];c.plugins.length=0;var t=c.eventNameDispatchConfigs;for(var n in t)t.hasOwnProperty(n)&&delete t[n];var r=c.registrationNameModules;for(var i in r)r.hasOwnProperty(i)&&delete r[i]}};e.exports=c},function(e,t,n){"use strict";function r(e){return"topMouseUp"===e||"topTouchEnd"===e||"topTouchCancel"===e}function i(e){return"topMouseMove"===e||"topTouchMove"===e}function o(e){return"topMouseDown"===e||"topTouchStart"===e}function a(e,t,n,r){var i=e.type||"unknown-event";e.currentTarget=v.getNodeFromInstance(r),t?m.invokeGuardedCallbackWithCatch(i,n,e):m.invokeGuardedCallback(i,n,e),e.currentTarget=null}function s(e,t){var n=e._dispatchListeners,r=e._dispatchInstances;if(Array.isArray(n))for(var i=0;i<n.length&&!e.isPropagationStopped();i++)a(e,t,n[i],r[i]);else n&&a(e,t,n,r);e._dispatchListeners=null,e._dispatchInstances=null}function u(e){var t=e._dispatchListeners,n=e._dispatchInstances;if(Array.isArray(t)){for(var r=0;r<t.length&&!e.isPropagationStopped();r++)if(t[r](e,n[r]))return n[r]}else if(t&&t(e,n))return n;return null}function c(e){var t=u(e);return e._dispatchInstances=null,e._dispatchListeners=null,t}function l(e){var t=e._dispatchListeners,n=e._dispatchInstances;Array.isArray(t)&&h("103"),e.currentTarget=t?v.getNodeFromInstance(n):null;var r=t?t(e):null;return e.currentTarget=null,e._dispatchListeners=null,e._dispatchInstances=null,r}function p(e){return!!e._dispatchListeners}var d,f,h=n(7),m=n(180),g=(n(1),n(5),{injectComponentTree:function(e){d=e},injectTreeTraversal:function(e){f=e}}),v={isEndish:r,isMoveish:i,isStartish:o,executeDirectDispatch:l,executeDispatchesInOrder:s,executeDispatchesInOrderStopAtTrue:c,hasDispatches:p,getInstanceFromNode:function(e){return d.getInstanceFromNode(e)},getNodeFromInstance:function(e){return d.getNodeFromInstance(e)},isAncestor:function(e,t){return f.isAncestor(e,t)},getLowestCommonAncestor:function(e,t){return f.getLowestCommonAncestor(e,t)},getParentInstance:function(e){return f.getParentInstance(e)},traverseTwoPhase:function(e,t,n){return f.traverseTwoPhase(e,t,n)},traverseEnterLeave:function(e,t,n,r,i){return f.traverseEnterLeave(e,t,n,r,i)},injection:g};e.exports=v},function(e,t,n){"use strict";function r(e){var t={"=":"=0",":":"=2"};return"$"+(""+e).replace(/[=:]/g,function(e){return t[e]})}function i(e){var t={"=0":"=","=2":":"};return(""+e.substring("."===e[0]&&"$"===e[1]?2:1)).replace(/(=0|=2)/g,function(e){return t[e]})}e.exports={escape:r,unescape:i}},function(e,t,n){"use strict";function r(e){null!=e.checkedLink&&null!=e.valueLink&&s("87")}function i(e){r(e),(null!=e.value||null!=e.onChange)&&s("88")}function o(e){r(e),(null!=e.checked||null!=e.onChange)&&s("89")}function a(e){if(e){var t=e.getName();if(t)return" Check the render method of `"+t+"`."}return""}var s=n(7),u=n(684),c=n(266),l=n(90),p=c(l.isValidElement),d=(n(1),n(5),{button:!0,checkbox:!0,image:!0,hidden:!0,radio:!0,reset:!0,submit:!0}),f={value:function(e,t,n){return!e[t]||d[e.type]||e.onChange||e.readOnly||e.disabled?null:new Error("You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`.")},checked:function(e,t,n){return!e[t]||e.onChange||e.readOnly||e.disabled?null:new Error("You provided a `checked` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultChecked`. Otherwise, set either `onChange` or `readOnly`.")},onChange:p.func},h={};e.exports={checkPropTypes:function(e,t,n){for(var r in f){if(f.hasOwnProperty(r))var i=f[r](t,r,e,"prop",null,u);if(i instanceof Error&&!(i.message in h)){h[i.message]=!0;a(n)}}},getValue:function(e){return e.valueLink?(i(e),e.valueLink.value):e.value},getChecked:function(e){return e.checkedLink?(o(e),e.checkedLink.value):e.checked},executeOnChange:function(e,t){return e.valueLink?(i(e),e.valueLink.requestChange(t.target.value)):e.checkedLink?(o(e),e.checkedLink.requestChange(t.target.checked)):e.onChange?e.onChange.call(void 0,t):void 0}}},function(e,t,n){"use strict";var r=n(7),i=(n(1),!1),o={replaceNodeWithMarkup:null,processChildrenUpdates:null,injection:{injectEnvironment:function(e){i&&r("104"),o.replaceNodeWithMarkup=e.replaceNodeWithMarkup,o.processChildrenUpdates=e.processChildrenUpdates,i=!0}}};e.exports=o},function(e,t,n){"use strict";function r(e,t,n){try{t(n)}catch(e){null===i&&(i=e)}}var i=null,o={invokeGuardedCallback:r,invokeGuardedCallbackWithCatch:r,rethrowCaughtError:function(){if(i){var e=i;throw i=null,e}}};e.exports=o},function(e,t,n){"use strict";function r(e){u.enqueueUpdate(e)}function i(e){var t=typeof e;if("object"!==t)return t;var n=e.constructor&&e.constructor.name||t,r=Object.keys(e);return r.length>0&&r.length<20?n+" (keys: "+r.join(", ")+")":n}function o(e,t){var n=s.get(e);if(!n){return null}return n}var a=n(7),s=(n(56),n(104)),u=(n(39),n(46)),c=(n(1),n(5),{isMounted:function(e){var t=s.get(e);return!!t&&!!t._renderedComponent},enqueueCallback:function(e,t,n){c.validateCallback(t,n);var i=o(e);if(!i)return null;i._pendingCallbacks?i._pendingCallbacks.push(t):i._pendingCallbacks=[t],r(i)},enqueueCallbackInternal:function(e,t){e._pendingCallbacks?e._pendingCallbacks.push(t):e._pendingCallbacks=[t],r(e)},enqueueForceUpdate:function(e){var t=o(e,"forceUpdate");t&&(t._pendingForceUpdate=!0,r(t))},enqueueReplaceState:function(e,t,n){var i=o(e,"replaceState");i&&(i._pendingStateQueue=[t],i._pendingReplaceState=!0,void 0!==n&&null!==n&&(c.validateCallback(n,"replaceState"),i._pendingCallbacks?i._pendingCallbacks.push(n):i._pendingCallbacks=[n]),r(i))},enqueueSetState:function(e,t){var n=o(e,"setState");if(n){(n._pendingStateQueue||(n._pendingStateQueue=[])).push(t),r(n)}},enqueueElementInternal:function(e,t,n){e._pendingElement=t,e._context=n,r(e)},validateCallback:function(e,t){e&&"function"!=typeof e&&a("122",t,i(e))}});e.exports=c},function(e,t,n){"use strict";e.exports=function(e){return"undefined"!=typeof MSApp&&MSApp.execUnsafeLocalFunction?function(t,n,r,i){MSApp.execUnsafeLocalFunction(function(){return e(t,n,r,i)})}:e}},function(e,t,n){"use strict";function r(e){var t,n=e.keyCode;return"charCode"in e?0===(t=e.charCode)&&13===n&&(t=13):t=n,t>=32||13===t?t:0}e.exports=r},function(e,t,n){"use strict";function r(e){var t=this,n=t.nativeEvent;if(n.getModifierState)return n.getModifierState(e);var r=o[e];return!!r&&!!n[r]}function i(e){return r}var o={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};e.exports=i},function(e,t,n){"use strict";function r(e){var t=e.target||e.srcElement||window;return t.correspondingUseElement&&(t=t.correspondingUseElement),3===t.nodeType?t.parentNode:t}e.exports=r},function(e,t,n){"use strict";/**
 * Checks if an event is supported in the current execution environment.
 *
 * NOTE: This will not work correctly for non-generic events such as `change`,
 * `reset`, `load`, `error`, and `select`.
 *
 * Borrows from Modernizr.
 *
 * @param {string} eventNameSuffix Event name, e.g. "click".
 * @param {?boolean} capture Check if the capture phase is supported.
 * @return {boolean} True if the event is supported.
 * @internal
 * @license Modernizr 3.0.0pre (Custom Build) | MIT
 */
function r(e,t){if(!o.canUseDOM||t&&!("addEventListener"in document))return!1;var n="on"+e,r=n in document;if(!r){var a=document.createElement("div");a.setAttribute(n,"return;"),r="function"==typeof a[n]}return!r&&i&&"wheel"===e&&(r=document.implementation.hasFeature("Events.wheel","3.0")),r}var i,o=n(24);o.canUseDOM&&(i=document.implementation&&document.implementation.hasFeature&&document.implementation.hasFeature("","")!==!0),e.exports=r},function(e,t,n){"use strict";function r(e,t){var n=null===e||e===!1,r=null===t||t===!1;if(n||r)return n===r;var i=typeof e,o=typeof t;return"string"===i||"number"===i?"string"===o||"number"===o:"object"===o&&e.type===t.type&&e.key===t.key}e.exports=r},function(e,t,n){"use strict";var r=(n(13),n(32)),i=(n(5),r);e.exports=i},function(e,t,n){"use strict";function r(e){"undefined"!=typeof console&&"function"==typeof console.error&&console.error(e);try{throw new Error(e)}catch(e){}}t.a=r},function(e,t,n){"use strict";function r(e,t,n){this.props=e,this.context=t,this.refs=a,this.updater=n||o}var i=n(92),o=n(191),a=(n(295),n(100));n(1),n(5);r.prototype.isReactComponent={},r.prototype.setState=function(e,t){"object"!=typeof e&&"function"!=typeof e&&null!=e&&i("85"),this.updater.enqueueSetState(this,e),t&&this.updater.enqueueCallback(this,t,"setState")},r.prototype.forceUpdate=function(e){this.updater.enqueueForceUpdate(this),e&&this.updater.enqueueCallback(this,e,"forceUpdate")};e.exports=r},function(e,t,n){"use strict";n(5);e.exports={isMounted:function(e){return!1},enqueueCallback:function(e,t){},enqueueForceUpdate:function(e){},enqueueReplaceState:function(e,t){},enqueueSetState:function(e,t){}}},function(e,t,n){"use strict";var r=n(297),i=(n(738),n(737)),o=n(736),a=n(296);n(298);n.d(t,"b",function(){return r.a}),n.d(t,"d",function(){return i.a}),n.d(t,"c",function(){return o.a}),n.d(t,"a",function(){return a.a})},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n.n(n(304)).a.polyfill()},function(e,t){!function(e){"use strict";function t(e){if("string"!=typeof e&&(e=String(e)),/[^a-z0-9\-#$%&'*+.\^_`|~]/i.test(e))throw new TypeError("Invalid character in header field name");return e.toLowerCase()}function n(e){return"string"!=typeof e&&(e=String(e)),e}function r(e){var t={next:function(){var t=e.shift();return{done:void 0===t,value:t}}};return v.iterable&&(t[Symbol.iterator]=function(){return t}),t}function i(e){this.map={},e instanceof i?e.forEach(function(e,t){this.append(t,e)},this):Array.isArray(e)?e.forEach(function(e){this.append(e[0],e[1])},this):e&&Object.getOwnPropertyNames(e).forEach(function(t){this.append(t,e[t])},this)}function o(e){if(e.bodyUsed)return Promise.reject(new TypeError("Already read"));e.bodyUsed=!0}function a(e){return new Promise(function(t,n){e.onload=function(){t(e.result)},e.onerror=function(){n(e.error)}})}function s(e){var t=new FileReader,n=a(t);return t.readAsArrayBuffer(e),n}function u(e){var t=new FileReader,n=a(t);return t.readAsText(e),n}function c(e){for(var t=new Uint8Array(e),n=new Array(t.length),r=0;r<t.length;r++)n[r]=String.fromCharCode(t[r]);return n.join("")}function l(e){if(e.slice)return e.slice(0);var t=new Uint8Array(e.byteLength);return t.set(new Uint8Array(e)),t.buffer}function p(){return this.bodyUsed=!1,this._initBody=function(e){if(this._bodyInit=e,e)if("string"==typeof e)this._bodyText=e;else if(v.blob&&Blob.prototype.isPrototypeOf(e))this._bodyBlob=e;else if(v.formData&&FormData.prototype.isPrototypeOf(e))this._bodyFormData=e;else if(v.searchParams&&URLSearchParams.prototype.isPrototypeOf(e))this._bodyText=e.toString();else if(v.arrayBuffer&&v.blob&&y(e))this._bodyArrayBuffer=l(e.buffer),this._bodyInit=new Blob([this._bodyArrayBuffer]);else{if(!v.arrayBuffer||!ArrayBuffer.prototype.isPrototypeOf(e)&&!_(e))throw new Error("unsupported BodyInit type");this._bodyArrayBuffer=l(e)}else this._bodyText="";this.headers.get("content-type")||("string"==typeof e?this.headers.set("content-type","text/plain;charset=UTF-8"):this._bodyBlob&&this._bodyBlob.type?this.headers.set("content-type",this._bodyBlob.type):v.searchParams&&URLSearchParams.prototype.isPrototypeOf(e)&&this.headers.set("content-type","application/x-www-form-urlencoded;charset=UTF-8"))},v.blob&&(this.blob=function(){var e=o(this);if(e)return e;if(this._bodyBlob)return Promise.resolve(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(new Blob([this._bodyArrayBuffer]));if(this._bodyFormData)throw new Error("could not read FormData body as blob");return Promise.resolve(new Blob([this._bodyText]))},this.arrayBuffer=function(){return this._bodyArrayBuffer?o(this)||Promise.resolve(this._bodyArrayBuffer):this.blob().then(s)}),this.text=function(){var e=o(this);if(e)return e;if(this._bodyBlob)return u(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(c(this._bodyArrayBuffer));if(this._bodyFormData)throw new Error("could not read FormData body as text");return Promise.resolve(this._bodyText)},v.formData&&(this.formData=function(){return this.text().then(h)}),this.json=function(){return this.text().then(JSON.parse)},this}function d(e){var t=e.toUpperCase();return w.indexOf(t)>-1?t:e}function f(e,t){t=t||{};var n=t.body;if(e instanceof f){if(e.bodyUsed)throw new TypeError("Already read");this.url=e.url,this.credentials=e.credentials,t.headers||(this.headers=new i(e.headers)),this.method=e.method,this.mode=e.mode,n||null==e._bodyInit||(n=e._bodyInit,e.bodyUsed=!0)}else this.url=String(e);if(this.credentials=t.credentials||this.credentials||"omit",!t.headers&&this.headers||(this.headers=new i(t.headers)),this.method=d(t.method||this.method||"GET"),this.mode=t.mode||this.mode||null,this.referrer=null,("GET"===this.method||"HEAD"===this.method)&&n)throw new TypeError("Body not allowed for GET or HEAD requests");this._initBody(n)}function h(e){var t=new FormData;return e.trim().split("&").forEach(function(e){if(e){var n=e.split("="),r=n.shift().replace(/\+/g," "),i=n.join("=").replace(/\+/g," ");t.append(decodeURIComponent(r),decodeURIComponent(i))}}),t}function m(e){var t=new i;return e.split(/\r?\n/).forEach(function(e){var n=e.split(":"),r=n.shift().trim();if(r){var i=n.join(":").trim();t.append(r,i)}}),t}function g(e,t){t||(t={}),this.type="default",this.status="status"in t?t.status:200,this.ok=this.status>=200&&this.status<300,this.statusText="statusText"in t?t.statusText:"OK",this.headers=new i(t.headers),this.url=t.url||"",this._initBody(e)}if(!e.fetch){var v={searchParams:"URLSearchParams"in e,iterable:"Symbol"in e&&"iterator"in Symbol,blob:"FileReader"in e&&"Blob"in e&&function(){try{return new Blob,!0}catch(e){return!1}}(),formData:"FormData"in e,arrayBuffer:"ArrayBuffer"in e};if(v.arrayBuffer)var b=["[object Int8Array]","[object Uint8Array]","[object Uint8ClampedArray]","[object Int16Array]","[object Uint16Array]","[object Int32Array]","[object Uint32Array]","[object Float32Array]","[object Float64Array]"],y=function(e){return e&&DataView.prototype.isPrototypeOf(e)},_=ArrayBuffer.isView||function(e){return e&&b.indexOf(Object.prototype.toString.call(e))>-1};i.prototype.append=function(e,r){e=t(e),r=n(r);var i=this.map[e];this.map[e]=i?i+","+r:r},i.prototype.delete=function(e){delete this.map[t(e)]},i.prototype.get=function(e){return e=t(e),this.has(e)?this.map[e]:null},i.prototype.has=function(e){return this.map.hasOwnProperty(t(e))},i.prototype.set=function(e,r){this.map[t(e)]=n(r)},i.prototype.forEach=function(e,t){for(var n in this.map)this.map.hasOwnProperty(n)&&e.call(t,this.map[n],n,this)},i.prototype.keys=function(){var e=[];return this.forEach(function(t,n){e.push(n)}),r(e)},i.prototype.values=function(){var e=[];return this.forEach(function(t){e.push(t)}),r(e)},i.prototype.entries=function(){var e=[];return this.forEach(function(t,n){e.push([n,t])}),r(e)},v.iterable&&(i.prototype[Symbol.iterator]=i.prototype.entries);var w=["DELETE","GET","HEAD","OPTIONS","POST","PUT"];f.prototype.clone=function(){return new f(this,{body:this._bodyInit})},p.call(f.prototype),p.call(g.prototype),g.prototype.clone=function(){return new g(this._bodyInit,{status:this.status,statusText:this.statusText,headers:new i(this.headers),url:this.url})},g.error=function(){var e=new g(null,{status:0,statusText:""});return e.type="error",e};var E=[301,302,303,307,308];g.redirect=function(e,t){if(E.indexOf(t)===-1)throw new RangeError("Invalid status code");return new g(null,{status:t,headers:{location:e}})},e.Headers=i,e.Request=f,e.Response=g,e.fetch=function(e,t){return new Promise(function(n,r){var i=new f(e,t),o=new XMLHttpRequest;o.onload=function(){var e={status:o.status,statusText:o.statusText,headers:m(o.getAllResponseHeaders()||"")};e.url="responseURL"in o?o.responseURL:e.headers.get("X-Request-URL"),n(new g("response"in o?o.response:o.responseText,e))},o.onerror=function(){r(new TypeError("Network request failed"))},o.ontimeout=function(){r(new TypeError("Network request failed"))},o.open(i.method,i.url,!0),"include"===i.credentials&&(o.withCredentials=!0),"responseType"in o&&v.blob&&(o.responseType="blob"),i.headers.forEach(function(e,t){o.setRequestHeader(t,e)}),o.send(void 0===i._bodyInit?null:i._bodyInit)})},e.fetch.polyfill=!0}}("undefined"!=typeof self?self:this)},function(e,t,n){"use strict";function r(e){return function(t,r){t({type:d,linkModel:e});var i=n.i(s.a)(n.i(u.selectReadMode)(r()),e.pageNumber);t(o.j(i))}}function i(e){return function(t,n){if(t({type:f,linkModel:e}),e.isVideoLink&&e.videoLink.isSafe){var r=e.videoLink;return void t(a.e(r.service,r.videoId))}var i=e.url;i.includes(":")||i.startsWith("//")||(i=i.includes("@")?"mailto:"+i:"http://"+i);var o=/^(https?:)?\/\//i.test(i)?"_blank":"_top";window.open(i,o)}}n.d(t,"c",function(){return h}),n.d(t,"b",function(){return r}),n.d(t,"a",function(){return i});var o=n(8),a=n(138),s=n(59),u=n(11),c="SET_SHOW_LINKS",l="SHOW_LINK_TOOLTIP",p="HIDE_LINK_TOOLTIP",d="GOTO_PAGE",f="OPEN_URL",h={SET_SHOW_LINKS:c,SHOW_LINK_TOOLTIP:l,HIDE_LINK_TOOLTIP:p,GOTO_PAGE:d,OPEN_URL:f}},function(e,t,n){"use strict";function r(){return{type:i}}n.d(t,"b",function(){return o}),t.a=r;var i="ON_VISIBILITY_CHANGE",o={ON_VISIBILITY_CHANGE:i}},function(e,t,n){"use strict";n.d(t,"a",function(){return i});var r=n(314),i={draw:function(e,t,n,i){var o=1.8*i;e.save(),e.beginPath(),e.arc(t,n,i,0,2*Math.PI),e.fill(),e.translate(t-o/2,n-o/2),e.scale(o/r.a.w,o/r.a.h),r.a.d[0](e,{stack:0}),e.restore()}}},function(e,t,n){"use strict";n.d(t,"a",function(){return i});var r=n(317),i={draw:function(e,t,n,i){var o=1.8*i;e.save(),e.beginPath(),e.arc(t,n,i,0,2*Math.PI),e.fill(),e.translate(t-o/2,n-o/2),e.scale(o/r.a.w,o/r.a.h),r.a.d[0](e,{stack:0}),e.restore()}}},function(e,t,n){"use strict";function r(e,t,n){var r=Math.max(e.x,0),i=Math.min(e.x+e.width,t),o=Math.max(e.y,0),a=Math.min(e.y+e.height,n);return{cappedOriginX:Math.min(r,t),cappedOriginY:Math.min(o,n),cappedWidth:Math.max(0,i-r),cappedHeight:Math.max(0,a-o)}}function i(e,t){var n=Math.floor(e.width),r=t===c?Math.floor(e.x+e.width+.001)-n:Math.floor(e.x),i=Math.floor(e.height);return{x:r,y:Math.floor(e.y),width:n,height:i}}n.d(t,"b",function(){return c}),n.d(t,"c",function(){return l}),t.d=i,n.d(t,"a",function(){return p});var o=n(316),a=n(319),s=n(312),u=n(48),c=0,l=1,p=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.unzoomedWidthInHWPx=0,r.unzoomedHeightInHWPx=0,i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.updateUnzoomedSizes()},t.prototype.componentDidUpdate=function(e){this.props.transform.isEqualWith(e.transform)||this.updateUnzoomedSizes()},t.prototype.updateUnzoomedSizes=function(){var e=this.transform.transformRect(u.a.RectPool.get(0,0,this.width,this.height));this.unzoomedWidthInHWPx=Math.floor(e.width),this.unzoomedHeightInHWPx=Math.floor(e.height),u.a.RectPool.release(e)},t.prototype.getChildrenToTraverse=function(){return this.props.mayRenderLinks?e.prototype.getChildrenToTraverse.call(this):e.prototype.getChildrenToTraverse.call(this).filter(function(e){return!(e instanceof a.a)})},t.prototype.getChildTree=function(){var e=this;return[u.a.createElement(s.a,{model:this.props.isPaywalled?null:this.model.textInfoPage,results:this.props.isPaywalled?[]:this.model.findResults,selectedResult:this.props.isPaywalled?null:this.model.selectedFindResult,renderManager:this.props.renderManager})].concat(this.model.links.map(function(t){return u.a.createElement(a.a,{arrivedAtSpreadTick:e.props.arrivedAtSpreadTick,dispatch:e.props.dispatch,featureTracker:e.props.featureTracker,hideLinkToolTip:e.props.hideLinkToolTip,isToggledOn:e.props.isLinksToggledOn,model:t,showLinkToolTip:e.props.showLinkToolTip})}))},t.prototype.getOperations=function(e,t,n,o){var a=i(e,o),s=a.x,u=a.y,c=a.width,l=a.height,p=r({x:s,y:u,width:c,height:l},t,n),d=p.cappedOriginX,f=p.cappedOriginY,h=p.cappedWidth,m=p.cappedHeight;if(0===h||0===m)return{ops:null,originX:0,originY:0};var g=[c/this.props.model.width,0,0,l/this.props.model.height,Math.min(0,s),Math.min(0,u)];try{return{ops:this.props.renderManager.render(g,h,m,this.unzoomedWidthInHWPx,this.unzoomedHeightInHWPx,this.pageNumber,this.inAnimation),originX:d,originY:f}}catch(e){var v={matrix:g,cappedWidth:h,cappedHeight:m,unzoomedWidthInHWPx:this.unzoomedWidthInHWPx,unzoomedHeightInHWPx:this.unzoomedHeightInHWPx,pageNumber:this.pageNumber,inAnimation:this.inAnimation};throw e.sentry_extra=babelHelpers.extends({},e.sentry_extra,{renderOps:v}),e}},t.prototype.draw=function(e,t,n){var r=this.getOperations(t,e.canvas.width,e.canvas.height,this.props.pageType),i=r.originX,a=r.originY,s=r.ops;null!==s?s.forEach(function(t){if(!(t.src_px.width<=0||t.src_px.height<=0))try{e.drawImage(t.surface,t.src_px.x,t.src_px.y,t.src_px.width,t.src_px.height,t.dest_px.x+i,t.dest_px.y+a,t.dest_px.width,t.dest_px.height)}catch(e){var n={src_px:t.src_px,dest_px:t.dest_px,width:t.surface.width,height:t.surface.height};throw e.sentry_extra=babelHelpers.extends({},e.sentry_extra,{renderImage:n}),e}}):(e.fillStyle="#f2f2f2",e.fillRect(t.x,t.y,t.width,t.height),o.a.draw(e,t.x+t.width/2,t.y+t.height/2,n),this.requestRedraw())},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"Page"}},{key:"width",get:function(){return this.props.model.width}},{key:"height",get:function(){return this.props.model.height}},{key:"model",get:function(){return this.props.model}},{key:"pageType",get:function(){return this.props.pageType}},{key:"pageNumber",get:function(){return this.props.model.pageNumber}},{key:"transform",get:function(){return this.props.transform}}]),t}(u.a)},function(e,t,n){"use strict";function r(e){return{min:{x:Math.min(e.p1.x,e.p2.x,e.p3.x,e.p4.x),y:Math.min(e.p1.y,e.p2.y,e.p3.y,e.p4.y)},max:{x:Math.max(e.p1.x,e.p2.x,e.p3.x,e.p4.x),y:Math.max(e.p1.y,e.p2.y,e.p3.y,e.p4.y)}}}function i(e){var t=new Float32Array(6*e.length*2);return e.forEach(function(e,n){t[12*n+0]=e.p1.x,t[12*n+1]=e.p1.y,t[12*n+2]=e.p3.x,t[12*n+3]=e.p3.y,t[12*n+4]=e.p2.x,t[12*n+5]=e.p2.y,t[12*n+6]=e.p2.x,t[12*n+7]=e.p2.y,t[12*n+8]=e.p3.x,t[12*n+9]=e.p3.y,t[12*n+10]=e.p4.x,t[12*n+11]=e.p4.y}),t}function o(e){var t=new Float32Array(6*e.length*2);return e.forEach(function(e,n){var i=r(e),o=function(e){return(e-i.min.x)/(i.max.x-i.min.x)},a=function(e){return(i.max.y-e)/(i.max.y-i.min.y)};t[12*n+0]=o(e.p1.x),t[12*n+1]=a(e.p1.y),t[12*n+2]=o(e.p3.x),t[12*n+3]=a(e.p3.y),t[12*n+4]=o(e.p2.x),t[12*n+5]=a(e.p2.y),t[12*n+6]=o(e.p2.x),t[12*n+7]=a(e.p2.y),t[12*n+8]=o(e.p3.x),t[12*n+9]=a(e.p3.y),t[12*n+10]=o(e.p4.x),t[12*n+11]=a(e.p4.y)}),t}t.a=r,n.d(t,"b",function(){return _});var a=n(74),s=n(751),u=n.n(s),c=n(752),l=n.n(c),p=n(759),d=n.n(p),f=n(760),h=n.n(f),m=n(101),g=(n.n(m),new Float32Array([1,1,0,.5])),v=new Float32Array([0,0,0,.3]),b=function(){var e=m.mat3.create();return function(t,n){return m.mat3.set(e,2/t,0,0,0,-(2/n),0,-1,1,1)}}(),y=function(){var e=m.vec2.create(),t=m.mat3.create();return function(n,r,i){return m.mat3.translate(t,n,m.vec2.set(e,i.x,i.y)),m.mat3.scale(t,t,m.vec2.set(e,r,r)),m.mat3.translate(t,t,m.vec2.set(e,-i.x,-i.y)),t}}(),_=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=n.i(a.a)(t,l.a,u.a),this.selectedShader=n.i(a.a)(t,h.a,d.a),this.verticeBuffer=t.createBuffer(),this.texCoordBuffer=t.createBuffer(),this.emptyTexture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.emptyTexture),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,1,1,0,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array([255,255,255,255])),t.bindTexture(t.TEXTURE_2D,null)}return e.prototype.draw=function(e,t){var n=this.gl,r=this.shader,o=this.verticeBuffer;n.disable(n.DEPTH_TEST),n.disable(n.CULL_FACE),n.enable(n.STENCIL_TEST),r.bind(),n.bindBuffer(n.ARRAY_BUFFER,o),n.vertexAttribPointer(r.a_vertex,2,n.FLOAT,!1,0,0),n.uniformMatrix3fv(r.u_displayMatrix,!1,b(n.drawingBufferWidth,n.drawingBufferHeight)),t.length&&(n.stencilFunc(n.NEVER,1,1),n.stencilOp(n.REPLACE,n.KEEP,n.KEEP),n.bufferData(n.ARRAY_BUFFER,i(t),n.DYNAMIC_DRAW),n.drawArrays(n.TRIANGLES,0,6*t.length)),n.enable(n.BLEND),n.uniform4fv(r.u_color,v),n.stencilFunc(n.NOTEQUAL,1,1),n.blendFuncSeparate(n.SRC_ALPHA,n.ONE_MINUS_SRC_ALPHA,n.ZERO,n.ONE),n.blendEquation(n.FUNC_ADD),n.bufferData(n.ARRAY_BUFFER,i([{p1:{x:e.x,y:e.y},p2:{x:e.x+e.width,y:e.y},p3:{x:e.x,y:e.y+e.height},p4:{x:e.x+e.width,y:e.y+e.height}}]),n.DYNAMIC_DRAW),n.drawArrays(n.TRIANGLES,0,6),n.disable(n.BLEND),n.disable(n.STENCIL_TEST),n.enable(n.CULL_FACE),n.enable(n.DEPTH_TEST)},e.prototype.drawSelected=function(e,t,n,r){var a=this.gl,s=this.shader,u=this.selectedShader,c=this.verticeBuffer,l=this.texCoordBuffer;if(a.disable(a.DEPTH_TEST),a.disable(a.CULL_FACE),a.bindBuffer(a.ARRAY_BUFFER,c),a.bufferData(a.ARRAY_BUFFER,i(e),a.DYNAMIC_DRAW),a.bindBuffer(a.ARRAY_BUFFER,null),r>1){u.bind();a.uniformMatrix3fv(u.u_displayMatrix,!1,y(b(a.drawingBufferWidth,a.drawingBufferHeight),r,n)),a.bindBuffer(a.ARRAY_BUFFER,c),a.vertexAttribPointer(u.a_vertex,2,a.FLOAT,!1,0,0),a.bindBuffer(a.ARRAY_BUFFER,l),a.bufferData(a.ARRAY_BUFFER,o(e),a.DYNAMIC_DRAW),a.vertexAttribPointer(u.a_texCoord,2,a.FLOAT,!1,0,0),a.activeTexture(a.TEXTURE0),a.uniform1i(u.u_texture,0),a.uniform4fv(u.u_color,g);for(var p=0;p<e.length;p++)a.bindTexture(a.TEXTURE_2D,t[p]&&t[p].texture?t[p].texture:this.emptyTexture),a.drawArrays(a.TRIANGLES,6*p,6)}else a.enable(a.BLEND),s.bind(),a.blendFuncSeparate(a.SRC_ALPHA,a.ONE_MINUS_SRC_ALPHA,a.ZERO,a.ONE),a.blendEquation(a.FUNC_ADD),a.bindBuffer(a.ARRAY_BUFFER,c),a.vertexAttribPointer(s.a_vertex,2,a.FLOAT,!1,0,0),a.uniform4fv(s.u_color,g),a.drawArrays(a.TRIANGLES,0,6*e.length),a.disable(a.BLEND);a.enable(a.CULL_FACE),a.enable(a.DEPTH_TEST)},e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.texCoordBuffer),e.deleteTexture(this.emptyTexture),this.shader.destroy(),this.selectedShader.destroy()},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return f});var r=n(213),i=n(78),o=n(75),a=n(48),s=n(199),u=n(8),c=n(22),l=n(80),p=n(40),d=n(20),f=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r._lastZoom=1,r._arrivedAtTick=0,r._zoomBeforeStart=1,i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentWillUpdate=function(e){(!this.props.isCurrentSpread&&e.isCurrentSpread||this.props.isCurrentSpread&&0===this._arrivedAtTick)&&(this._arrivedAtTick=this.isAllPagesLoaded()&&e.isSnapped?this.root.tick:0),e.isCurrentSpread||(this._arrivedAtTick=0)},t.prototype.componentDidMount=function(){this.scroller=new r.a(0,0,1,this.width,this.height,this.width,this.height),this.scroller.setSnap(!0,function(e,t,n){var r=void 0;if(n>1){var i=this.width/n,o=this.height/n,a=void 0;a=this.borders.right-this.borders.left<i?this.borders.left-(i-(this.borders.right-this.borders.left))/2:Math.max(Math.min(t,this.borders.right-i),this.borders.left);var s=void 0;s=this.borders.bottom-this.borders.top<o?this.borders.top-(o-(this.borders.bottom-this.borders.top))/2:Math.max(Math.min(e,this.borders.bottom-o),this.borders.top),r={top:s,left:a,zoom:n}}else r={top:0,left:0,zoom:1};return r}.bind(this),!1)},t.prototype.componentDidUpdate=function(e){if(this.props.width!==e.width||this.props.height!==e.height){var t=this.getCenter();this.scroller.resize(t.y*this.height-this.height/this.scroller.zoom/2,t.x*this.width-this.width/this.scroller.zoom/2,this.scroller.zoom,this.width,this.height,this.width,this.height)}this.props.isCurrentSpread&&!e.isCurrentSpread&&this.props.dispatch(u.i(this.scroller.zoom,this.scroller.isDragging))},t.prototype.onGestureStart=function(e,t,n,r,i){return this.scroller.touchStart(e,t,i),this._zoomBeforeStart=this.scroller.zoom,this.scroller.zoom>1},t.prototype.onGestureChange=function(e,t,n,r,o,a,s){return(1===this.scroller.zoom&&s===i.c||this.scroller.zoom>1)&&(this.scroller.touchMove(e,t,o,a),this.requestRedraw(),!0)},t.prototype.onGestureEnd=function(e,t){return this.scroller.touchEnd(t,e),this.scroller.isMoving&&this.requestRedraw(),this.scroller.zoom!==this._zoomBeforeStart&&this.props.featureTracker.usage(d.b.GESTURE_PINCH_ZOOM),this.scroller.zoom>1},t.prototype.onDoubleTap=function(e,t,n){var r=this;if(this.props.dispatch(c.g()),this.scroller.zoom>1)this.scroller.scrollTo(0,0,1,n).then(function(){r.props.dispatch(c.i())});else{this.props.featureTracker.usage(d.b.DOUBLE_TAP_ZOOM);var i=this.getViewportCTM().inverse().transformPoint(e,t);this.scroller.scrollTo(i[1]-this.scroller.height/4,i[0]-this.scroller.width/4,2,n).then(function(){r.props.dispatch(c.i())})}return this.requestRedraw(),!0},t.prototype.setZoom=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=this.scroller.top+this.scroller.height/this.scroller.zoom/2,r=this.scroller.left+this.scroller.width/this.scroller.zoom/2,i=n-this.scroller.height/e/2,o=r-this.scroller.width/e/2;t?this.scroller.scrollTo(i,o,e,this.root.tick):this.scroller.jumpTo(i,o,e),this.requestRedraw()},t.prototype.getZoom=function(){return this.scroller.zoom},t.prototype.getCenter=function(){return{x:(this.scroller.left+this.scroller.width/this.scroller.zoom/2)/this.scroller.width,y:(this.scroller.top+this.scroller.height/this.scroller.zoom/2)/this.scroller.height}},t.prototype.setCenter=function(e){var t=e.y-this.height/this.scroller.zoom/2,n=e.x-this.width/this.scroller.zoom/2,r=this.scroller.zoom,i=this.scroller.snapFunction(t,n,r);this.scroller.top=i.top,this.scroller.left=i.left},t.prototype.isAllPagesLoaded=function(){for(var e=this.props.pageModels,t=Array.isArray(e),n=0,e=t?e:e[Symbol.iterator]();;){var r;if(t){if(n>=e.length)break;r=e[n++]}else{if(n=e.next(),n.done)break;r=n.value}if(!this.props.renderManager.isPageReady(r.pageNumber))return!1}return!0},t.prototype.getChildTree=function(){var e=this.props.pageModels,t=this.props.width,r=this.props.height,i=e.map(function(e){return e.width}).reduce(function(e,t){return e+t},0),u=Math.max.apply(Math,e.map(function(e){return e.height})),c=n.i(l.c)(1===e.length&&this.props.readMode===p.DOUBLE_PAGE_SPREAD?e[0].width:i,u,t,r),d=t/c,f=r/c,h=(d-i)/2,m=(f-u)/2;this.borders={top:m*c,right:t-h*c,bottom:r-m*c,left:h*c};var g=h,v=(f-e[0].height)/2,b=(new o.a).mScale(c).mTranslate(g,v),y=a.a.createElement(s.a,{arrivedAtSpreadTick:this._arrivedAtTick,dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,hideLinkToolTip:this.props.hideLinkToolTip,isLinksToggledOn:this.props.isLinksToggledOn,isPaywalled:this.props.paywalledPageStatus[0],mayRenderLinks:this.props.mayRenderLinks,model:e[0],pageType:s.b,showLinkToolTip:this.props.showLinkToolTip,transform:b,renderManager:this.props.renderManager});if(2===e.length){g=h+e[0].width,v=(f-e[1].height)/2;var _=(new o.a).mScale(c).mTranslate(g,v);return[y,a.a.createElement(s.a,{arrivedAtSpreadTick:this._arrivedAtTick,dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,hideLinkToolTip:this.props.hideLinkToolTip,isLinksToggledOn:this.props.isLinksToggledOn,isPaywalled:this.props.paywalledPageStatus[1],mayRenderLinks:this.props.mayRenderLinks,model:e[1],pageType:s.c,showLinkToolTip:this.props.showLinkToolTip,transform:_,renderManager:this.props.renderManager})]}return y},t.prototype.afterDraw=function(e,t){var n=this.scroller.isAnimating||this.scroller.isDragging||this.scroller.isMoving;this.scroller.update(t),(this.scroller.isAnimating||this.scroller.isDragging||this.scroller.isMoving||n)&&this.requestRedraw(),this.props.isCurrentSpread&&!this._arrivedAtTick&&this.isAllPagesLoaded&&this.forceUpdate(),this._lastZoom!==this.scroller.zoom&&(this._lastZoom=this.scroller.zoom,this.props.dispatch(u.i(this.scroller.zoom,this.scroller.isDragging)))},babelHelpers.createClass(t,[{key:"zOrder",get:function(){return this.props.isCurrentSpread?1:0}},{key:"displayName",get:function(){return"Spread"}},{key:"transform",get:function(){return this._transform||(this._transform=new o.a),this._transform.mSetMatrix(this.props.transform.matrix).mScale(this.scroller.zoom).mTranslate(-this.scroller.left,-this.scroller.top),this._transform}},{key:"inAnimation",get:function(){return!!this.scroller.isMoving||this.parent.inAnimation}},{key:"unzoomedBBox",get:function(){return this.props.transform.transformRect(a.a.RectPool.get(0,0,this.width,this.height))}}]),t}(a.a)},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n    <svg width="60%" height="60%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g fill="#F2F2F2">\n                <path d="M16.4456672,18.0003762 L10.3219784,24.1243529 C9.89267388,24.5536776 9.89267388,25.249654 10.3219784,25.6787588 C10.5365207,25.8933112 10.8178877,26.0008073 11.0990349,26.0008073 C11.3804019,26.0008073 11.6617688,25.8933112 11.8763112,25.6787588 L18,19.5547821 L24.1236888,25.6787588 C24.3382312,25.8933112 24.6195981,26.0008073 24.9009651,26.0008073 C25.1821123,26.0008073 25.4634793,25.8933112 25.6780216,25.6787588 C26.1073261,25.249654 26.1073261,24.5536776 25.6780216,24.1243529 L19.5543328,18.0003762 L25.6780216,11.8763994 C26.1073261,11.4472946 26.1073261,10.7510983 25.6780216,10.3219935 C25.2487172,9.89266883 24.5529933,9.89266883 24.1236888,10.3219935 L18,16.4459703 L11.8763112,10.3219935 C11.4470067,9.89266883 10.7512828,9.89266883 10.3219784,10.3219935 C9.89267388,10.7510983 9.89267388,11.4472946 10.3219784,11.8763994 L16.4456672,18.0003762 Z"></path>\n            </g>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";n.d(t,"a",function(){return s});var r='d="M27.7068284,10.2884629 C27.5277733,10.1097429 27.2813055,10 27.009222,10 L22.990778,10 C22.4509752,10 22,10.4477153 22,11 C22,11.5561352 22.4435864,12 22.990778,12 L26,12 L26,15.009222 C26,15.5490248 26.4477153,16 27,16 C27.5561352,16 28,15.5564136 28,15.009222 L28,10.990778 C28,10.7223751 27.8893106,10.4759332 27.7101145,10.2959709 Z" fill="#F5F5F5" transform="translate(25.000000, 13.000000) rotate(-180.000000) translate(-25.000000, -13.000000)"',i='d="M13.7068284,10.2884629 C13.5277733,10.1097429 13.2813055,10 13.009222,10 L8.99077797,10 C8.45097518,10 8,10.4477153 8,11 C8,11.5561352 8.44358641,12 8.99077797,12 L12,12 L12,15.009222 C12,15.5490248 12.4477153,16 13,16 C13.5561352,16 14,15.5564136 14,15.009222 L14,10.990778 C14,10.7223751 13.8893106,10.4759332 13.7101145,10.2959709 Z" fill="#F5F5F5" transform="translate(11.000000, 13.000000) scale(-1, 1) rotate(-180.000000) translate(-11.000000, -13.000000)"',o='d="M27.7068284,20.2884629 C27.5277733,20.1097429 27.2813055,20 27.009222,20 L22.990778,20 C22.4509752,20 22,20.4477153 22,21 C22,21.5561352 22.4435864,22 22.990778,22 L26,22 L26,25.009222 C26,25.5490248 26.4477153,26 27,26 C27.5561352,26 28,25.5564136 28,25.009222 L28,20.990778 C28,20.7223751 27.8893106,20.4759332 27.7101145,20.2959709 Z" fill="#F5F5F5" transform="translate(25.000000, 23.000000) rotate(-90.000000) translate(-25.000000, -23.000000)"',a='d="M13.7068284,20.2884629 C13.5277733,20.1097429 13.2813055,20 13.009222,20 L8.99077797,20 C8.45097518,20 8,20.4477153 8,21 C8,21.5561352 8.44358641,22 8.99077797,22 L12,22 L12,25.009222 C12,25.5490248 12.4477153,26 13,26 C13.5561352,26 14,25.5564136 14,25.009222 L14,20.990778 C14,20.7223751 13.8893106,20.4759332 13.7101145,20.2959709 Z" fill="#F5F5F5" transform="translate(11.000000, 23.000000) scale(-1, 1) rotate(-90.000000) translate(-11.000000, -23.000000)"',s='\n    <svg width="100%" height="100%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <path '+r+"></path>\n                <path "+i+"></path>\n                <path "+o+"></path>\n                <path "+a+'></path>\n            </g>\n        </g>\n        <path class="shadow" '+r+'></path>\n        <path class="shadow" '+i+'></path>\n        <path class="shadow" '+o+'></path>\n        <path class="shadow" '+a+'></path>\n        <path class="icon" '+r+'></path>\n        <path class="icon" '+i+'></path>\n        <path class="icon" '+o+'></path>\n        <path class="icon" '+a+"></path>\n    </svg>\n"},function(e,t,n){"use strict";n.d(t,"a",function(){return s});var r='d="M27.7068284,10.2884629 C27.5277733,10.1097429 27.2813055,10 27.009222,10 L22.990778,10 C22.4509752,10 22,10.4477153 22,11 C22,11.5561352 22.4435864,12 22.990778,12 L26,12 L26,15.009222 C26,15.5490248 26.4477153,16 27,16 C27.5561352,16 28,15.5564136 28,15.009222 L28,10.990778 C28,10.7223751 27.8893106,10.4759332 27.7101145,10.2959709 Z"',i='d="M13.7068284,10.2884629 C13.5277733,10.1097429 13.2813055,10 13.009222,10 L8.99077797,10 C8.45097518,10 8,10.4477153 8,11 C8,11.5561352 8.44358641,12 8.99077797,12 L12,12 L12,15.009222 C12,15.5490248 12.4477153,16 13,16 C13.5561352,16 14,15.5564136 14,15.009222 L14,10.990778 C14,10.7223751 13.8893106,10.4759332 13.7101145,10.2959709 Z" transform="translate(11.000000, 13.000000) scale(-1, 1) translate(-11.000000, -13.000000)"',o='d="M27.7068284,20.2884629 C27.5277733,20.1097429 27.2813055,20 27.009222,20 L22.990778,20 C22.4509752,20 22,20.4477153 22,21 C22,21.5561352 22.4435864,22 22.990778,22 L26,22 L26,25.009222 C26,25.5490248 26.4477153,26 27,26 C27.5561352,26 28,25.5564136 28,25.009222 L28,20.990778 C28,20.7223751 27.8893106,20.4759332 27.7101145,20.2959709 Z" transform="translate(25.000000, 23.000000) rotate(-270.000000) translate(-25.000000, -23.000000)"',a='d="M13.7068284,20.2884629 C13.5277733,20.1097429 13.2813055,20 13.009222,20 L8.99077797,20 C8.45097518,20 8,20.4477153 8,21 C8,21.5561352 8.44358641,22 8.99077797,22 L12,22 L12,25.009222 C12,25.5490248 12.4477153,26 13,26 C13.5561352,26 14,25.5564136 14,25.009222 L14,20.990778 C14,20.7223751 13.8893106,20.4759332 13.7101145,20.2959709 Z" transform="translate(11.000000, 23.000000) scale(-1, 1) rotate(-270.000000) translate(-11.000000, -23.000000)"',s='\n    <svg width="100%" height="100%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <path '+r+"></path>\n                <path "+i+"></path>\n                <path "+o+"></path>\n                <path "+a+'></path>\n            </g>\n        </g>\n        <path class="shadow" '+r+'></path>\n        <path class="shadow" '+i+'></path>\n        <path class="shadow" '+o+'></path>\n        <path class="shadow" '+a+'></path>\n        <path class="icon" '+r+'></path>\n        <path class="icon" '+i+'></path>\n        <path class="icon" '+o+'></path>\n        <path class="icon" '+a+"></path>\n    </svg>\n"},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r='d="M6.83590808,3.64127016 C5.02752664,3.6236996 3.54764132,5.11190524 3.53049341,6.96464718 C3.5133455,8.81760081 4.96575284,10.3339617 6.77413428,10.3515323 C8.58251571,10.3688911 10.0626076,8.88089718 10.0795489,7.02815524 C10.0966969,5.17520161 8.64428951,3.65862903 6.83590808,3.64127016 L6.83590808,3.64127016 Z M6.78942278,8.69524194 C5.87376569,8.68635081 5.13826495,7.91853831 5.14694221,6.9803125 C5.15561947,6.04208669 5.90496249,5.28845766 6.82061958,5.29734879 C7.73627667,5.30623992 8.4717774,6.07405242 8.46310015,7.01248992 C8.45442289,7.95050403 7.70507987,8.70413306 6.78942278,8.69524194 L6.78942278,8.69524194 Z"',i='d="M6.75843258,0.424375 C6.74830911,0.424375 6.73818565,0.424798387 6.72785558,0.424798387 L6.72785558,0.424163306 L0.856245804,0.424163306 C0.562045511,0.424163306 0.321148361,0.67078629 0.321148361,0.972449597 L0.321148361,7.02053427 C0.321148361,10.6633569 3.2032369,13.6164819 6.75843258,13.6164819 C10.3138349,13.6164819 13.1957168,10.6633569 13.1957168,7.02053427 C13.1957168,3.3775 10.3138349,0.424375 6.75843258,0.424375 L6.75843258,0.424375 Z M2.33592452,6.92929435 C2.35927047,4.40019153 4.37921167,2.36920363 6.84747775,2.39291331 C9.31574383,2.41683468 11.2980836,4.48677419 11.274531,7.01566532 C11.2513917,9.54455645 9.23124389,11.5755444 6.76318441,11.551623 C4.29491833,11.5277016 2.31257857,9.45797379 2.33592452,6.92929435 L2.33592452,6.92929435 Z"',o='d="M1.18803132,0.461209677 C1.75267275,0.461209677 2.22289738,0.943235887 2.22289738,1.52137097 C2.22289738,2.09950605 1.75267275,2.58110887 1.18803132,2.58110887 C0.624009688,2.58110887 0.153578461,2.09950605 0.153578461,1.52137097 C0.153578461,0.943235887 0.624009688,0.461209677 1.18803132,0.461209677 L1.18803132,0.461209677 Z M1.18803132,12.5656351 C0.661197927,12.5656351 0.30419083,12.160877 0.30419083,11.6597984 L0.30419083,4.79775202 C0.30419083,4.29709677 0.680411851,3.89212702 1.18803132,3.89212702 C1.69627059,3.89212702 2.07228501,4.29709677 2.07228501,4.79775202 L2.07228501,11.6597984 C2.07228501,12.160877 1.71486471,12.5656351 1.18803132,12.5656351 L1.18803132,12.5656351 Z"',a='d="M7.56498795,12.6429032 C6.37971612,12.6429032 5.32646254,12.2574093 4.5742271,11.6597984 C4.31101701,11.4478931 4.19779948,11.1587198 4.19779948,10.9080746 C4.19779948,10.522369 4.49902422,10.2715121 4.87524524,10.2715121 C5.17585017,10.2715121 5.36427059,10.3877319 5.57107852,10.5420565 C6.07890458,10.9273387 6.79353858,11.2931452 7.69679959,11.2931452 C8.71265833,11.2931452 9.25808584,10.9080746 9.25808584,10.3104637 C9.25808584,9.65548387 8.73125245,9.40462702 7.41437558,9.03797379 C5.10085389,8.40268145 4.25440825,7.59231855 4.25440825,6.20509073 C4.25440825,4.75943548 5.5522778,3.81485887 7.58399527,3.81485887 C8.35503143,3.81485887 9.2200712,4.00771169 9.91631767,4.35446573 C10.4241437,4.60511089 10.781564,4.91333669 10.781564,5.29904234 C10.781564,5.64579637 10.5935568,5.97392137 10.1045315,5.97392137 C9.85991551,5.97392137 9.61529954,5.858125 9.33328872,5.70337702 C8.80624873,5.41462702 8.22321978,5.26114919 7.54639383,5.26114919 C6.60573797,5.26114919 5.96610026,5.51137097 5.96610026,6.18561492 C5.96610026,6.84144153 6.53053509,7.05292339 7.8848068,7.45789315 C9.91631767,8.05529234 10.9697779,8.61416331 10.9697779,10.1754032 C10.9697779,11.602006 9.80351335,12.6429032 7.56498795,12.6429032"',s='d="M16.0804749,12.6429032 C14.8952031,12.6429032 13.8415363,12.2574093 13.0893009,11.6597984 C12.8258842,11.4478931 12.7130799,11.1587198 12.7130799,10.9080746 C12.7130799,10.522369 13.014098,10.2715121 13.390319,10.2715121 C13.6913372,10.2715121 13.8791378,10.3877319 14.0863589,10.5420565 C14.5939784,10.9273387 15.3086124,11.2931452 16.2114602,11.2931452 C17.2275255,11.2931452 17.772953,10.9080746 17.772953,10.3104637 C17.772953,9.65548387 17.2465328,9.40462702 15.9298626,9.03797379 C13.6159277,8.40268145 12.7696886,7.59231855 12.7696886,6.20509073 C12.7696886,4.75943548 14.0677648,3.81485887 16.0990691,3.81485887 C16.8703118,3.81485887 17.7357648,4.00771169 18.4318047,4.35446573 C18.9392175,4.60511089 19.297051,4.91333669 19.297051,5.29904234 C19.297051,5.64579637 19.1088372,5.97392137 18.6193987,5.97392137 C18.3749893,5.97392137 18.1303733,5.858125 17.8485691,5.70337702 C17.3219423,5.41462702 16.7385002,5.26114919 16.0614676,5.26114919 C15.1208118,5.26114919 14.4813806,5.51137097 14.4813806,6.18561492 C14.4813806,6.84144153 15.0454023,7.05292339 16.4000872,7.45789315 C18.4318047,8.05529234 19.4850582,8.61416331 19.4850582,10.1754032 C19.4850582,11.602006 18.3185871,12.6429032 16.0804749,12.6429032"',u='d="M21.1926182,8.61416331 L21.1926182,4.79775202 C21.1926182,4.29709677 21.5878466,3.89212702 22.0768719,3.89212702 C22.5658973,3.89212702 22.9611256,4.29709677 22.9611256,4.79775202 L22.9611256,8.82606855 C22.9611256,10.0409778 23.8823609,10.9849194 25.1246547,10.9849194 C26.3659155,10.9849194 27.3063648,10.0409778 27.3063648,8.82606855 L27.3063648,4.79775202 C27.3063648,4.29709677 27.7015931,3.89212702 28.1902052,3.89212702 C28.679024,3.89212702 29.0740457,4.29709677 29.0740457,4.79775202 L29.0740457,8.61416331 C29.0740457,10.8697581 27.4001618,12.6429032 25.1246547,12.6429032 C22.8481147,12.6429032 21.1926182,10.8697581 21.1926182,8.61416331"',c='d="M31.0324197,8.61416331 L31.0324197,4.79775202 C31.0324197,4.29709677 31.4272349,3.89212702 31.9164668,3.89212702 C32.405079,3.89212702 32.8003073,4.29709677 32.8003073,4.79775202 L32.8003073,8.82606855 C32.8003073,10.0409778 33.7225756,10.9849194 34.9636298,10.9849194 C36.2048906,10.9849194 37.1455465,10.0409778 37.1455465,8.82606855 L37.1455465,4.79775202 C37.1455465,4.29709677 37.5407748,3.89212702 38.0298002,3.89212702 C38.5192387,3.89212702 38.9136406,4.29709677 38.9136406,4.79775202 L38.9136406,8.61416331 C38.9136406,10.8697581 37.2401699,12.6429032 34.9636298,12.6429032 C32.6872964,12.6429032 31.0324197,10.8697581 31.0324197,8.61416331"',l='\n<svg width="100%" height="100%" viewBox="-2 0 60 14">\n    <g class="logo__icon">\n        <path class="shadow" '+r+'></path>\n        <path class="shadow" '+i+'></path>\n        <path class="icon" '+r+'></path>\n        <path class="icon" '+i+'></path>\n    </g>\n    <g class="logo__title" transform="translate(17.000000, 0.000000)">\n        <path class="shadow" '+o+'></path>\n        <path class="shadow" '+a+'></path>\n        <path class="shadow" '+s+'></path>\n        <path class="shadow" '+u+'></path>\n        <path class="shadow" '+c+'></path>\n\n        <path class="icon" '+o+'></path>\n        <path class="icon" '+a+'></path>\n        <path class="icon" '+s+'></path>\n        <path class="icon" '+u+'></path>\n        <path class="icon" '+c+"></path>\n    </g>\n</svg>\n"},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n    <svg width="100%" height="100%" viewBox="0 0 24 24">\n        <g class="spinner__icon" fill-rule="evenodd">\n            <g transform="translate(7.000000, 7.000000)">\n                    <path d="M6.77787915,6.84548427 C5.79003176,7.83333166 4.18814246,7.83322341 3.2001563,6.84523725 C2.21223953,5.85732047 2.21223953,4.25567819 3.2001563,3.26776142 C4.18822365,2.27969408 5.7896189,2.27974819 6.77763213,3.26776142 C7.76571475,4.25584404 7.76587711,5.8574863 6.77787915,6.84548427 L8.24993998,8.31754509 C10.0510015,6.51648357 10.0507055,3.59671316 8.24969296,1.79570059 C6.44870526,-0.00528710987 3.52918184,-0.00538576575 1.72809548,1.79570059 C-0.0728180424,3.59661411 -0.0728180424,6.51638456 1.72809548,8.31729807 C3.52903385,10.1182364 6.4490513,10.1184338 8.24993998,8.31754509 L6.77787915,6.84548427 L6.77787915,6.84548427 Z"></path>\n            </g>\n            <path d="M12,23 C18.0751322,23 23,18.0751322 23,12 C23,5.92486775 18.0751322,1 12,1 C5.92486775,1 1,5.92486775 1,12 C1,18.0751322 5.92486775,23 12,23 Z M12,20.0250244 C16.4320986,20.0250244 20.0250244,16.4320986 20.0250244,12 C20.0250244,7.5679014 16.4320986,3.97497559 12,3.97497559 C7.5679014,3.97497559 3.97497559,7.5679014 3.97497559,12 C3.97497559,16.4320986 7.5679014,20.0250244 12,20.0250244 Z" fill-opacity="0.5"></path>\n            <path d="M3.97746854,12.2020107 C3.88040309,13.3666506 2.94475898,13.6536116 2.48144531,13.6567993 C1.99243164,13.6601639 0.999999997,13.1174211 1,12 C1.00000002,5.92486775 5.92486775,1 12,1 C18.0751322,1 23,5.92486775 23,12 C23,13.1278573 22.0378909,13.5112302 21.5430908,13.5112305 C21.0482908,13.5112307 20.0457764,13.2033275 20.0457764,12 C20.0457764,11.9485283 20.0382948,11.8986091 20.0236545,11.8502139 C19.9437915,7.48723335 16.3820616,3.97497559 12,3.97497559 C7.5679014,3.97497559 3.97497559,7.5679014 3.97497559,12 C3.97497559,12.067535 3.97580982,12.1348751 3.97746854,12.2020107 Z"></path>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n    <svg width="36" height="31" viewBox="0 0 36 31" xmlns="http://www.w3.org/2000/svg">\n        <title>Group</title>\n        <g fill="#9AA8A9" fill-rule="evenodd" opacity=".3">\n            <path d="M32.333 30.77H3.267c-1.1 0-2.1-.564-2.667-1.53-.533-.964-.533-2.095.033-3.06L15.5 1.464C16.067.532 17.033 0 18.133 0 19.2 0 20.2.566 20.767 1.464l14.5 24.118c.633 1.064.666 2.362.033 3.46-.6 1.097-1.7 1.73-2.967 1.73zm-14.2-28.475c-.133 0-.433.034-.633.333L2.667 27.378c-.2.333-.067.6 0 .732.066.133.233.366.633.366h29.033c.567 0 .867-.4.967-.566.1-.166.3-.6 0-1.098L18.767 2.663c-.2-.333-.5-.367-.634-.367z"/><path d="M18.133 20.825c-.633 0-1.166-.533-1.166-1.165v-8.15c0-.632.533-1.164 1.166-1.164.634 0 1.167.532 1.167 1.164v8.15c0 .666-.5 1.165-1.167 1.165zM18.133 25.05c-.633 0-1.166-.533-1.166-1.165v-.665c0-.632.533-1.165 1.166-1.165.634 0 1.167.533 1.167 1.165v.665c0 .665-.5 1.164-1.167 1.164z"/>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";function r(e,t){return Math.min(Math.max(e/t*100,0),100)}n.d(t,"a",function(){return d});var i=n(2),o=n.n(i),a=n(86),s=n.n(a),u=n(57),c=n.n(u),l=n(42),p=n(79),d=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r._hover=!1,i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.container=s.a.findDOMNode(this.refs.container),this.inputHandler=new p.a(this.container,{onGestureStart:function(t,n){e.props.locked||(e._containerWidth=e.container.clientWidth,e.props.onChangeStart(),e.props.onChange(r(t[0].x,e._containerWidth)))},onGestureChange:function(t,n,i,o){e.props.locked||(e.inputHandler.requestToIntercept(),e.props.onChange(r(t[0].x,e._containerWidth)))},onGestureEnd:function(t){e.props.locked||e.props.onChangeEnd(e.props.value)},onMouseEnter:function(){e._hover=!0,e.container.classList.toggle("slider--hover",e._hover)},onMouseLeave:function(){e._hover=!1,e.container.classList.toggle("slider--hover",e._hover)}})},t.prototype.shouldComponentUpdate=function(e){return!c()(this.props,e)},t.prototype.render=function(){var e=["slider"];this._hover&&e.push("slider--hover"),this.props.type===t.SLIDER_TYPE_ALTERNATE&&e.push("slider--alternate"),this.props.locked&&e.push("slider--locked");var n=!1;return o.a.createElement("div",{className:e.join(" "),ref:"container"},o.a.createElement("div",{className:"slider__track-container-container"},o.a.createElement("div",{className:"slider__track-container"},this.props.segments.map(function(e,t){var r=["slider__track"];e.available||r.push("slider__track--unavailable"),e.done&&r.push("slider__track--done");var i={flex:e.proportion},a=!n&&!e.done;return a&&(n=!0),o.a.createElement("div",{key:t,className:r.join(" "),style:i},a&&o.a.createElement("div",{className:"slider__thumb"}))}),!n&&o.a.createElement("div",{className:"slider__thumb slider__thumb--end"}),this.props.markers&&!!this.props.markers.length&&o.a.createElement(l.b.SliderMarkers,{markers:this.props.markers,value:this.props.value}))),o.a.createElement("span",{style:{position:"absolute",visibility:"hidden"}},this.props.value))},t}(i.Component);d.displayName="Slider",d.SLIDER_TYPE_DEFAULT="SLIDER_TYPE_DEFAULT",d.SLIDER_TYPE_ALTERNATE="SLIDER_TYPE_ALTERNATE"},function(e,t,n){"use strict";n.d(t,"a",function(){return r}),n.d(t,"b",function(){return i});var r="info",i="download"},function(e,t,n){"use strict";n.d(t,"f",function(){return r}),n.d(t,"j",function(){return i}),n.d(t,"k",function(){return o}),n.d(t,"a",function(){return a}),n.d(t,"l",function(){return s}),n.d(t,"g",function(){return u}),n.d(t,"m",function(){return c}),n.d(t,"d",function(){return l}),n.d(t,"b",function(){return p}),n.d(t,"c",function(){return d}),n.d(t,"e",function(){return f}),n.d(t,"i",function(){return h}),n.d(t,"h",function(){return m});var r=27,i=36,o=35,a=32,s=68,u=70,c=73,l=37,p=39,d=38,f=40,h=191,m=114},function(e,t,n){"use strict";n.d(t,"c",function(){return r}),n.d(t,"d",function(){return i}),n.d(t,"a",function(){return o}),n.d(t,"b",function(){return a});var r="loading-status@INITIALIZED",i="loading-status@LOADING",o="loading-status@FAILED",a="loading-status@SUCCESS"},function(e,t,n){"use strict";n.d(t,"a",function(){return r}),n.d(t,"b",function(){return i}),n.d(t,"c",function(){return o});var r="reader-sizes@TINY",i="reader-sizes@SMALL",o="reader-sizes@NORMAL"},function(e,t,n){"use strict";function r(e,t,n){var r=Math.max(1,n);return{x:-t.x/r*.6+.4*e.x,y:-t.y/r*.6+.4*e.y}}function i(e){return Math.sqrt(e.x*e.x+e.y*e.y)}function o(e,t,n,r,i,o,a){return{top:Math.max(Math.min(e,a-i/n),0),left:Math.max(Math.min(t,o-r/n),0),zoom:Math.max(Math.min(n,s.a),s.b)}}function a(e,t,n){for(var r=0,i=e.x,o=e.y,a=0,s=0;Math.sqrt(i*i+o*o)>t;)r+=u,i*=n,o*=n,a+=i*u,s+=o*u;return{duration:r,distanceX:a,distanceY:s}}n.d(t,"a",function(){return g});var s=n(58),u=1e3/60,c=1/u,l=.1/u,p=6/u,d=Math.ceil(250/u)*u,f=function(e){return Math.pow(e-1,3)+1},h=function(e){var t=2*e;return t<1?.5*Math.pow(t,3):.5*(Math.pow(t-2,3)+2)},m=function(e){return 1-Math.pow(2,-10*e)},g=function(){function e(t,n,r,i,o,a,s){babelHelpers.classCallCheck(this,e),this.top=t,this.left=n,this.zoom=r,this.width=i,this.height=o,this.contentWidth=a,this.contentHeight=s,this.snap=!1,this.snapFunction=function(){},this.scrollingX=!0,this.scrollingY=!0,this._lastUpdate={left:n,top:t,zoom:r},this._isMoving=!1,this._lastTouchPosition={x:0,y:0},this._initialZoomLevel=1,this._lastTouchTime=0,this._velocity={x:0,y:0},this._animate=!1,this._isDragging=!1,this._lastMoveTs=0}return e.prototype.touchStart=function(e,t,n){this._lastTouchPosition.x=e,this._lastTouchPosition.y=t,this._initialZoomLevel=this.zoom,this._lastTouchTime=n,this._velocity={x:0,y:0},this._animate=!1,this._animation&&this._animation.deferred&&this._animation.deferred.resolve()},e.prototype.touchMove=function(e,t,n,i){var o=this._lastTouchPosition,a=n-this._lastTouchTime,u=this.top,c=this.left,l=this.zoom;if(i){var p=this.zoom;l=Math.max(Math.min(i*this._initialZoomLevel,s.a),s.b),l!==p&&(c+=e/p-e/l,u+=t/p-t/l)}var d={x:(e-o.x)/l,y:(t-o.y)/l};this.scrollingX||1!==l||(d.x=0),this.scrollingY||1!==l||(d.y=0),c-=1*d.x,(c>this.contentWidth-this.width/l||c<0)&&(c+=.8*d.x*1),((u-=1*d.y)>this.contentHeight-this.height/l||u<0)&&(u+=.8*d.y*1);var f=r(this._velocity,d,a);this._isDragging=!0,this.left=c,this.top=u,this.zoom=l,this._velocity=f,this._lastTouchPosition.x=e,this._lastTouchPosition.y=t,this._lastTouchTime=n},e.prototype.touchEnd=function(e,t){var n=this._velocity,r=(this.snap?p:c)/this.zoom;if(this._isDragging=!1,i(n)>r){var s=this.zoom,u=(this.snap?p:l)/s,f=a(n,u,1-.11/s),h=f.duration,m=f.distanceX,g=f.distanceY,v=this.left+m,b=this.top+g,y=this.snap?this.snapFunction(b,v,s):o(b,v,s,this.width,this.height,this.contentWidth,this.contentHeight),_=Math.sqrt(Math.pow(m,2)+Math.pow(g,2));this.animateToPosition(y.top,y.left,y.zoom,t,h*(Math.sqrt(Math.pow(b-y.top,2)+Math.pow(v-y.left,2))+_)/_,"EASING_OUT_EXPO")}else this.animateToPosition(this.top,this.left,this.zoom,t,d)},e.prototype.scrollTo=function(e,t,n,r){var i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:d;return this.animateToPosition(e,t,n||this.zoom,r,i)},e.prototype.jumpTo=function(e,t,n){var r=o(e,t,n||this.zoom,this.width,this.height,this.contentWidth,this.contentHeight);if(this.snap){var i=this.snapFunction(r.top,r.left,r.zoom);this.top=i.top,this.left=i.left,this.zoom=i.zoom}else this.top=r.top,this.left=r.left,this.zoom=r.zoom},e.prototype.setSnap=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(t&&(this.snapFunction=t),e&&!this.snap){if(!this.snapFunction)throw new Error("Cannot snap without snap function!");if(this.snap=e,n)this.animateToPosition(this.top,this.left,this.zoom,r,d);else{var i=this.snapFunction(this.top,this.left,this.zoom);this.top=i.top,this.left=i.left,this.zoom=i.zoom}}else this.snap=e},e.prototype.setScrolling=function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.scrollingX=e,this.scrollingY=t},e.prototype.resize=function(e,t,n,r,i,o,a){if(this.top=e,this.left=t,this.zoom=n,this.width=r,this.height=i,this.contentWidth=o,this.contentHeight=a,this.snap){var s=this.snapFunction(e,t,n);this.top=s.top,this.left=s.left,this.zoom=s.zoom}},e.prototype.isSnapped=function(){if(!this.snapFunction)return!0;var e=this.snapFunction(this.top,this.left,this.zoom);return Math.abs(e.left-this.left)<1&&Math.abs(e.top-this.top)<1&&Math.abs(e.zoom-this.zoom)<.2},e.prototype.update=function(e){var t=this._animate;if(this._animate){var n=this._animation,r=n.start,i=n.end,o=n.startTime,a=n.duration,s=n.easing,u=i.left-r.left,c=i.top-r.top,l=Math.min(e-o,a),p=Math.max(l/a,0);p<1&&p>0&&("EASING_OUT"===s?p=f(p):"EASING_IN_OUT"===s?p=h(p):"EASING_OUT_EXPO"===s&&(p=m(p)));var d=r.left+u*p,g=r.top+c*p,v=this.width/i.zoom-this.width/r.zoom,b=this.width/r.zoom+v*p,y=this.width/b;this.left=d,this.top=g,this.zoom=y,this._animate=l<a,this._animate||this._animation.deferred.resolve()}this._lastUpdate.left===this.left&&this._lastUpdate.top===this.top&&this._lastUpdate.zoom===this.zoom||(this._lastMoveTs=e),this._isMoving=t||this._isDragging&&e-this._lastMoveTs<100,this._lastUpdate.left=this.left,this._lastUpdate.top=this.top,this._lastUpdate.zoom=this.zoom},e.prototype.getHorizontalPositionInPercent=function(){var e=Math.max(Math.min(100*this.left/(this.contentWidth-this.width),100),0);return Number.isFinite(e)?e:0},e.prototype.animateToPosition=function(e,t,n,r,i,a){var s=o(e,t,n,this.width,this.height,this.contentWidth,this.contentHeight),u=s.top,c=s.left,l=s.zoom;if(this.snap){var p=this.snapFunction(u,c,l);u=p.top,c=p.left,l=p.zoom}if(c===this.left&&u===this.top&&l===this.zoom)return this._animate=!1,Promise.resolve();var d={resolve:null,promise:null};return d.promise=new Promise(function(e){d.resolve=e}),this._animation={startTime:r,easing:a||(this._animate?"EASING_OUT":"EASING_IN_OUT"),duration:i,start:{top:this.top,left:this.left,zoom:this.zoom},end:{top:u,left:c,zoom:l},deferred:d},this._animate=!0,d.promise},babelHelpers.createClass(e,[{key:"isDragging",get:function(){return this._isDragging}},{key:"isAnimating",get:function(){return this._animate}},{key:"isMoving",get:function(){return this._isMoving||this._animate}}]),e}()},function(e,t,n){"use strict";n.d(t,"c",function(){return s}),n.d(t,"a",function(){return u}),n.d(t,"b",function(){return c});var r=n(33),i=(n.n(r),n(49)),o=n(41),a=n(11),s=function(e){return e.headerControls.visibleDropdown},u=n.i(r.createSelector)(n.i(a.selectFeature)(o.DOWNLOAD_TYPE),function(e){return e.documentModel.downloadable},a.selectShowCTAOverlay,function(e,t,n){return!(!e||!t||n)}),c=n.i(r.createSelector)(n.i(a.selectFeature)(o.INFO_DIALOG_TYPE),a.selectShowCTAOverlay,a.selectFullscreenEnabled,i.b.isPreview,function(e,t,n,r){return!(!e||r||t||e.hideWhenNotInFullscreen&&!n)})},function(e,t,n){"use strict";n.d(t,"d",function(){return i}),n.d(t,"b",function(){return o}),n.d(t,"a",function(){return a}),n.d(t,"c",function(){return s});var r=function(e){return e.documentModel||{}},i=function(e){return r(e).title},o=function(e){return r(e).documentName},a=function(e){return"https://"+e.config.hosts.image+"/"+r(e).documentId+"/jpg/page_1.jpg"},s=function(e){return r(e).pageCount}},function(e,t,n){"use strict";n.d(t,"a",function(){return i}),n.d(t,"b",function(){return o}),n.d(t,"c",function(){return a}),n.d(t,"d",function(){return s});var r=function(e){return e.documentModel||{}},i=function(e){return r(e).userDisplayName},o=function(e){return r(e).username},a=function(e){return"https://"+e.config.hosts.photo+"/"+o(e)+"/photo_large.jpg"},s=function(e){return"https://"+e.config.hosts.main+"/"+o(e)}},function(e,t,n){"use strict";function r(){var e=navigator.userAgent,t=new RegExp("^Mozilla/5\\.0.*Android.*AppleWebKit.*Chrome/(\\d+).*$","i"),n=t.exec(e),r=!1;if(n&&n.length>0){r=parseInt(n[1],10)<=33}return r}function i(e,t){"onmsfullscreenchange"in document||"msfullscreenerror"in document?document["on"+e]=t:document.addEventListener(e,t)}function o(e,t){"onmsfullscreenchange"in document||"msfullscreenerror"in document?document["on"+e]=null:document.removeEventListener(e,t)}function a(){if(r())return!1;var e=p.enabled.filter(function(e){return e in document})[0];return Boolean(document[e])}function s(){var e=p.element.filter(function(e){return e in document})[0];if(e)return document[e];throw new Error("Fullscreen not supported")}function u(){return new Promise(function(e,t){try{var n=p.change.filter(function(e){return"on"+e in document})[0];if(n){i(n,function t(){s()||(o(n,t),e(!0))})}else t("native fullscreen api not supported")}catch(e){t(e)}})}function c(e){return new Promise(function(t,n){try{var r=p.request.filter(function(t){return t in e})[0],a=p.change.filter(function(e){return"on"+e in document})[0];if(r&&a){i(a,function e(){o(a,e),t(!0)}),e[r]()}else n("native fullscreen api not supported")}catch(e){n(e)}})}function l(){return new Promise(function(e,t){try{var n=p.exit.filter(function(e){return e in document})[0],r=p.change.filter(function(e){return"on"+e in document})[0];if(n)if(s()){var a=function t(){o(r,t),e(!0)};i(r,a),document[n]()}else e(!0);else t("native fullscreen api not supported")}catch(e){t(e)}})}t.a=a,t.c=u,t.b=c,t.d=l;var p={request:["requestFullscreen","webkitRequestFullscreen","webkitRequestFullScreen","mozRequestFullScreen","msRequestFullscreen"],exit:["exitFullscreen","webkitCancelFullScreen","webkitExitFullscreen","mozCancelFullScreen","msExitFullscreen"],enabled:["fullscreenEnabled","webkitFullscreenEnabled","mozFullScreenEnabled","msFullscreenEnabled"],element:["fullscreenElement","webkitFullscreenElement","webkitCurrentFullScreenElement","mozFullScreenElement","msFullscreenElement"],change:["fullscreenchange","webkitfullscreenchange","mozfullscreenchange","msfullscreenchange"],error:["fullscreenerror","webkitfullscreenerror","mozfullscreenerror","msfullscreenerror"]}},function(e,t,n){"use strict";function r(e,t,i,o){if(void 0===t.layersInfo){var a=""+e.getScheme()+t.imageUri;return n.i(u.c)(a,t.pageNumber,{width:t.width,height:t.height,loadStatsTracker:i})}var s=""+e.getScheme()+t.layersInfo.uri;return n.i(u.d)(s,t.pageNumber,t.layersInfo.version,{withCredentials:o.includes(t.pageNumber),loadStatsTracker:i}).catch(function(n){return n&&n.skipTracking||i.onLoaderError(n),i.onLayersImageFallback(),t.layersInfo=void 0,r(e,t,i,o)})}function i(e,t,n,o,a){var s=t.pageNumber-1;switch(n[s].state){case l:return f<c.i&&(f++,n[s]={state:p},r(e,t,o,a).then(function(e){n[s]={state:d,data:e},f--},function(){})),null;case p:return null;case d:return n[s].data.images.some(function(e){return 0===e.width||0===e.height})?(n[s]={state:l},i(e,t,n,o,a)):n[s].data;default:return null}}function o(e,t,n){var r=Math.round(e[0]*n.width),i=Math.round(t[0]*n.width),o=Math.round(e[3]*n.height),a=Math.round(t[3]*n.height);return r-i==0&&o-a==0}function a(e,t,n){return e[4]===t[4]&&e[5]===t[5]&&o(e,t,n)}function s(e,t,n,r){return e.map(function(e,i){var o=t[i],a=e.src_px.x<0||e.src_px.width<=0||e.src_px.x+e.src_px.width>o.width_px,s=e.src_px.y<0||e.src_px.height<=0||e.src_px.y+e.src_px.height>o.height_px,u=e.dest_px.x<0||e.dest_px.width<=0||e.dest_px.x+e.dest_px.width>n,c=e.dest_px.y<0||e.dest_px.height<=0||e.dest_px.y+e.dest_px.height>r;return a||s||u||c?{idx:i,src_x:e.src_px.x,src_y:e.src_px.y,src_w:e.src_px.width,src_h:e.src_px.height,s_w:o.width_px,s_h:o.height_px,dst_x:e.dest_px.x,dst_y:e.dest_px.y,dst_w:e.dest_px.width,dst_h:e.dest_px.height,d_w:n,d_h:r}:null}).filter(function(e){return!!e})}n.d(t,"a",function(){return h});var u=n(107),c=n(58),l=0,p=1,d=2,f=0,h=function(){function e(t,n,r,i,o){babelHelpers.classCallCheck(this,e),this.config={},this.resources=[],this.renderer=t,this.pageModels=n,this.config=r,this.loadStatsTracker=i,this.pageNumbersThatNeedsCredentials=o,this.pageData=new Array(n.length).fill({state:l}),this.resources=[]}return e.prototype.getResource=function(e){var t=e%6,n=this.resources[t];return void 0===n&&(n={},this.resources[t]=n),n},e.prototype.renderUncached=function(e,t,n,r){var o=this.renderer,a=r-1,s=i(this.config,this.pageModels[a],this.pageData,this.loadStatsTracker,this.pageNumbersThatNeedsCredentials);return s?(e[0]*=this.pageModels[a].width/s.width,e[3]*=this.pageModels[a].height/s.height,o.draw(null,s,e,t,n,!0,null)):null},e.prototype.render=function(e,t,n,r,u,c,l){var p=this.renderer,d=c-1,f=i(this.config,this.pageModels[d],this.pageData,this.loadStatsTracker,this.pageNumbersThatNeedsCredentials);if(!f)return null;e[0]*=this.pageModels[d].width/f.width,e[3]*=this.pageModels[d].height/f.height;var h=this.getResource(d);if(l){if(!h.preview||h.preview.page!==d){var m=r/f.width,g=u/f.height,v=[m,0,0,g,0,0];this.loadStatsTracker.onFontRenderingStart();var b=h.preview;h.preview={state:p.draw(b&&b.state,f,v,r,u,!1,this.loadStatsTracker),matrix:v,width_px:r,height_px:u,page:d}}var y=h.preview;if(!y)return[];var _=-e[4]/e[0]*y.matrix[0],w=-e[5]/e[3]*y.matrix[3],E=t/e[0]*y.matrix[0],x=n/e[3]*y.matrix[3],S=[{surface:p.getSurface(y.state),src_px:{x:_,y:w,width:Math.min(E+_,y.width_px)-_,height:Math.min(x+w,y.height_px)-w},dest_px:{x:0,y:0,width:t,height:n}}],T=[y],C=h.hires;if(C&&C.page===d&&o(C.matrix,e,f)){var I=Math.floor(C.matrix[4]-e[4]),M=Math.floor(C.matrix[5]-e[5]),P=Math.max(I,0),R=Math.max(M,0),O=Math.max(-I,0),k=Math.max(-M,0),A=Math.min(C.width_px-P,t-O),N=Math.min(C.height_px-R,n-k);if(A>0&&N>0){S.push({surface:p.getSurface(C.state),src_px:{x:P,y:R,width:A,height:N},dest_px:{x:O,y:k,width:A,height:N}}),T.push(C)}}var D=s(S,T,t,n);return D.length&&this.loadStatsTracker.onOpsValidationError(D.length),S}var L=h.hires;return L&&L.page===d&&L.width_px===t&&L.height_px===n&&a(e,L.matrix,f)||(L={state:p.draw(L&&L.state,f,e,t,n,!0,this.loadStatsTracker),matrix:e,width_px:t,height_px:n,page:d},h.hires=L),[{surface:p.getSurface(L.state),src_px:{x:0,y:0,width:t,height:n},dest_px:{x:0,y:0,width:t,height:n}}]},e.prototype.reusePageData=function(e){this.pageData=e.pageData},e.prototype.isPageReady=function(e){return this.pageData[e-1].state===d},e.prototype.setActivePages=function(e){var t=this;e.forEach(function(e){return i(t.config,t.pageModels[e-1],t.pageData,t.loadStatsTracker,t.pageNumbersThatNeedsCredentials)});for(var n=e[e.length-1]+2;n>e[0]-2;n--)n>0&&n<=this.pageModels.length&&i(this.config,this.pageModels[n-1],this.pageData,this.loadStatsTracker,this.pageNumbersThatNeedsCredentials);this.pageData.forEach(function(t,n){t.state!==d||e.includes(n+1)||(delete t.data,t.state=l)})},e.prototype.release=function(){var e=this.renderer;this.resources.forEach(function(t){if(t){var n=t.hires;n&&e.release(n.state);var r=t.preview;r&&e.release(r.state)}}),this.resources=[]},e}()},function(e,t,n){"use strict";function r(){var e=["webkit","moz","ms","o"];if("hidden"in document)return"hidden";for(var t=0;t<e.length;t++)if(e[t]+"Hidden"in document)return e[t]+"Hidden";return null}function i(){var e=r();return!!e&&!!document[e]}function o(){return!!r()}function a(e){var t=r();if(t){var n=t.replace(/[H|h]idden/,"")+"visibilitychange";document.addEventListener(n,e)}}n.d(t,"a",function(){return o}),n.d(t,"c",function(){return i}),n.d(t,"b",function(){return a})},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this.start=t,this.duration=n,this.options=Object.assign(r||{},{easing:e.LINEAR,clipStart:!0,clipEnd:!0,reverse:!1})}return e.LINEAR=function(e,t,n,r){return n*e/r+t},e.EASE_IN_CUBIC=function(e,t,n,r){return e/=r,n*e*e*e+t},e.EASE_OUT_CUBIC=function(e,t,n,r){return e/=r,e--,n*(e*e*e+1)+t},e.EASE_IN_OUT_CUBIC=function(e,t,n,r){return(e/=r/2)<1?n/2*e*e*e+t:(e-=2,n/2*(e*e*e+2)+t)},e.calc=function(t,n,r){return(arguments.length>3&&void 0!==arguments[3]?arguments[3]:e.LINEAR)(t-n,0,1,r)},e.prototype.reset=function(e){return this.start=e,this},e.prototype.isRunning=function(e){return e>=this.start&&e<=this.start+this.duration},e.prototype.isWaitingToRun=function(e){return e<this.start},e.prototype.value=function(t){var n=e.calc(t,this.start,this.duration,this.options.easing);return this.options.clipStart&&n<0?n=0:this.options.clipEnd&&n>1&&(n=1),this.options.reverse&&(n=1-n),n},e}()},function(e,t,n){"use strict";function r(e,t){return e&&e.kind===i.FULLSCREEN_KIND.FALLBACK||t}t.a=r;var i=n(41)},function(e,t,n){"use strict";function r(e,t,r,s){var u=window.matchMedia("(orientation: portrait)").matches,c=o.a.isMobile()||o.a.isTablet(),l=o.a.isMobile()&&u,p=c&&u;switch(s.responsiveModeWhen){case i.RESPONSIVE.HANDHELD_IN_PORTRAIT_FULLSCREEN:if(p&&r)return i.SINGLE_PAGE_SPREAD;break;case i.RESPONSIVE.HANDHELD_IN_PORTRAIT:if(p)return i.SINGLE_PAGE_SPREAD;break;case i.RESPONSIVE.PHONE_ISH_IN_PORTRAIT:var d=480*n.i(a.a)();if(l||e<=d&&e<t)return i.SINGLE_PAGE_SPREAD}return s.defaultMode}t.a=r;var i=n(40),o=n(94),a=n(35)},function(e,t,n){var r=n(36);e.exports=function(e,t){if("number"!=typeof e&&"Number"!=r(e))throw TypeError(t);return+e}},function(e,t,n){"use strict";var r=n(18),i=n(70),o=n(17);e.exports=[].copyWithin||function(e,t){var n=r(this),a=o(n.length),s=i(e,a),u=i(t,a),c=arguments.length>2?arguments[2]:void 0,l=Math.min((void 0===c?a:i(c,a))-u,a-s),p=1;for(u<s&&s<u+l&&(p=-1,u+=l-1,s+=l-1);l-- >0;)u in n?n[s]=n[u]:delete n[s],s+=p,u+=p;return n}},function(e,t,n){var r=n(82);e.exports=function(e,t){var n=[];return r(e,!1,n.push,n,t),n}},function(e,t,n){var r=n(25),i=n(18),o=n(98),a=n(17);e.exports=function(e,t,n,s,u){r(t);var c=i(e),l=o(c),p=a(c.length),d=u?p-1:0,f=u?-1:1;if(n<2)for(;;){if(d in l){s=l[d],d+=f;break}if(d+=f,u?d<0:p<=d)throw TypeError("Reduce of empty array with no initial value")}for(;u?d>=0:p>d;d+=f)d in l&&(s=t(s,l[d],d,c));return s}},function(e,t,n){"use strict";var r=n(25),i=n(9),o=n(116),a=[].slice,s={},u=function(e,t,n){if(!(t in s)){for(var r=[],i=0;i<t;i++)r[i]="a["+i+"]";s[t]=Function("F,a","return new F("+r.join(",")+")")}return s[t](e,n)};e.exports=Function.bind||function(e){var t=r(this),n=a.call(arguments,1),s=function(){var r=n.concat(a.call(arguments));return this instanceof s?u(t,r.length,r):o(t,r,e)};return i(t.prototype)&&(s.prototype=t.prototype),s}},function(e,t,n){"use strict";var r=n(15).f,i=n(65),o=n(68),a=n(51),s=n(63),u=n(37),c=n(82),l=n(153),p=n(234),d=n(69),f=n(14),h=n(60).fastKey,m=f?"_s":"size",g=function(e,t){var n,r=h(t);if("F"!==r)return e._i[r];for(n=e._f;n;n=n.n)if(n.k==t)return n};e.exports={getConstructor:function(e,t,n,l){var p=e(function(e,r){s(e,p,t,"_i"),e._i=i(null),e._f=void 0,e._l=void 0,e[m]=0,void 0!=r&&c(r,n,e[l],e)});return o(p.prototype,{clear:function(){for(var e=this,t=e._i,n=e._f;n;n=n.n)n.r=!0,n.p&&(n.p=n.p.n=void 0),delete t[n.i];e._f=e._l=void 0,e[m]=0},delete:function(e){var t=this,n=g(t,e);if(n){var r=n.n,i=n.p;delete t._i[n.i],n.r=!0,i&&(i.n=r),r&&(r.p=i),t._f==n&&(t._f=r),t._l==n&&(t._l=i),t[m]--}return!!n},forEach:function(e){s(this,p,"forEach");for(var t,n=a(e,arguments.length>1?arguments[1]:void 0,3);t=t?t.n:this._f;)for(n(t.v,t.k,this);t&&t.r;)t=t.p},has:function(e){return!!g(this,e)}}),f&&r(p.prototype,"size",{get:function(){return u(this[m])}}),p},def:function(e,t,n){var r,i,o=g(e,t);return o?o.v=n:(e._l=o={i:i=h(t,!0),k:t,v:n,p:r=e._l,n:void 0,r:!1},e._f||(e._f=o),r&&(r.n=o),e[m]++,"F"!==i&&(e._i[i]=o)),e},getEntry:g,setStrong:function(e,t,n){l(e,t,function(e,t){this._t=e,this._k=t,this._l=void 0},function(){for(var e=this,t=e._k,n=e._l;n&&n.r;)n=n.p;return e._t&&(e._l=n=n?n.n:e._t._f)?"keys"==t?p(0,n.k):"values"==t?p(0,n.v):p(0,[n.k,n.v]):(e._t=void 0,p(1))},n?"entries":"values",!n,!0),d(t)}}},function(e,t,n){var r=n(97),i=n(225);e.exports=function(e){return function(){if(r(this)!=e)throw TypeError(e+"#toJSON isn't generic");return i(this)}}},function(e,t,n){"use strict";var r=n(68),i=n(60).getWeak,o=n(3),a=n(9),s=n(63),u=n(82),c=n(43),l=n(23),p=c(5),d=c(6),f=0,h=function(e){return e._l||(e._l=new m)},m=function(){this.a=[]},g=function(e,t){return p(e.a,function(e){return e[0]===t})};m.prototype={get:function(e){var t=g(this,e);if(t)return t[1]},has:function(e){return!!g(this,e)},set:function(e,t){var n=g(this,e);n?n[1]=t:this.a.push([e,t])},delete:function(e){var t=d(this.a,function(t){return t[0]===e});return~t&&this.a.splice(t,1),!!~t}},e.exports={getConstructor:function(e,t,n,o){var c=e(function(e,r){s(e,c,t,"_i"),e._i=f++,e._l=void 0,void 0!=r&&u(r,n,e[o],e)});return r(c.prototype,{delete:function(e){if(!a(e))return!1;var t=i(e);return t===!0?h(this).delete(e):t&&l(t,this._i)&&delete t[this._i]},has:function(e){if(!a(e))return!1;var t=i(e);return t===!0?h(this).has(e):t&&l(t,this._i)}}),c},def:function(e,t,n){var r=i(o(t),!0);return r===!0?h(e).set(t,n):r[e._i]=n,e},ufstore:h}},function(e,t,n){e.exports=!n(14)&&!n(6)(function(){return 7!=Object.defineProperty(n(145)("div"),"a",{get:function(){return 7}}).a})},function(e,t,n){var r=n(9),i=Math.floor;e.exports=function(e){return!r(e)&&isFinite(e)&&i(e)===e}},function(e,t,n){var r=n(3);e.exports=function(e,t,n,i){try{return i?t(r(n)[0],n[1]):t(n)}catch(t){var o=e.return;throw void 0!==o&&r(o.call(e)),t}}},function(e,t){e.exports=function(e,t){return{value:t,done:!!e}}},function(e,t){e.exports=Math.log1p||function(e){return(e=+e)>-1e-8&&e<1e-8?e-e*e/2:Math.log(1+e)}},function(e,t,n){"use strict";var r=n(67),i=n(120),o=n(99),a=n(18),s=n(98),u=Object.assign;e.exports=!u||n(6)(function(){var e={},t={},n=Symbol(),r="abcdefghijklmnopqrst";return e[n]=7,r.split("").forEach(function(e){t[e]=e}),7!=u({},e)[n]||Object.keys(u({},t)).join("")!=r})?function(e,t){for(var n=a(e),u=arguments.length,c=1,l=i.f,p=o.f;u>c;)for(var d,f=s(arguments[c++]),h=l?r(f).concat(l(f)):r(f),m=h.length,g=0;m>g;)p.call(f,d=h[g++])&&(n[d]=f[d]);return n}:u},function(e,t,n){var r=n(15),i=n(3),o=n(67);e.exports=n(14)?Object.defineProperties:function(e,t){i(e);for(var n,a=o(t),s=a.length,u=0;s>u;)r.f(e,n=a[u++],t[n]);return e}},function(e,t,n){var r=n(29),i=n(66).f,o={}.toString,a="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],s=function(e){try{return i(e)}catch(e){return a.slice()}};e.exports.f=function(e){return a&&"[object Window]"==o.call(e)?s(e):i(r(e))}},function(e,t,n){var r=n(23),i=n(29),o=n(112)(!1),a=n(158)("IE_PROTO");e.exports=function(e,t){var n,s=i(e),u=0,c=[];for(n in s)n!=a&&r(s,n)&&c.push(n);for(;t.length>u;)r(s,n=t[u++])&&(~o(c,n)||c.push(n));return c}},function(e,t,n){var r=n(67),i=n(29),o=n(99).f;e.exports=function(e){return function(t){for(var n,a=i(t),s=r(a),u=s.length,c=0,l=[];u>c;)o.call(a,n=s[c++])&&l.push(e?[n,a[n]]:a[n]);return l}}},function(e,t,n){var r=n(66),i=n(120),o=n(3),a=n(4).Reflect;e.exports=a&&a.ownKeys||function(e){var t=r.f(o(e)),n=i.f;return n?t.concat(n(e)):t}},function(e,t,n){var r=n(4).parseFloat,i=n(85).trim;e.exports=1/r(n(163)+"-0")!=-(1/0)?function(e){var t=i(String(e),3),n=r(t);return 0===n&&"-"==t.charAt(0)?-0:n}:r},function(e,t,n){var r=n(4).parseInt,i=n(85).trim,o=n(163),a=/^[\-+]?0[xX]/;e.exports=8!==r(o+"08")||22!==r(o+"0x16")?function(e,t){var n=i(String(e),3);return r(n,t>>>0||(a.test(n)?16:10))}:r},function(e,t){e.exports=Object.is||function(e,t){return e===t?0!==e||1/e==1/t:e!=e&&t!=t}},function(e,t,n){var r=n(17),i=n(162),o=n(37);e.exports=function(e,t,n,a){var s=String(o(e)),u=s.length,c=void 0===n?" ":String(n),l=r(t);if(l<=u||""==c)return s;var p=l-u,d=i.call(c,Math.ceil(p/c.length));return d.length>p&&(d=d.slice(0,p)),a?d+s:s+d}},function(e,t,n){t.f=n(12)},function(e,t,n){"use strict";var r=n(228);e.exports=n(113)("Map",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{get:function(e){var t=r.getEntry(this,e);return t&&t.v},set:function(e,t){return r.def(this,0===e?0:e,t)}},r,!0)},function(e,t,n){n(14)&&"g"!=/./g.flags&&n(15).f(RegExp.prototype,"flags",{configurable:!0,get:n(115)})},function(e,t,n){"use strict";var r=n(228);e.exports=n(113)("Set",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{add:function(e){return r.def(this,e=0===e?0:e,e)}},r)},function(e,t,n){"use strict";var r,i=n(43)(0),o=n(27),a=n(60),s=n(236),u=n(230),c=n(9),l=a.getWeak,p=Object.isExtensible,d=u.ufstore,f={},h=function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},m={get:function(e){if(c(e)){var t=l(e);return t===!0?d(this).get(e):t?t[this._i]:void 0}},set:function(e,t){return u.def(this,e,t)}},g=e.exports=n(113)("WeakMap",h,m,u,!0,!0);7!=(new g).set((Object.freeze||Object)(f),7).get(f)&&(r=u.getConstructor(h),s(r.prototype,m),a.NEED=!0,i(["delete","has","get","set"],function(e){var t=g.prototype,n=t[e];o(t,e,function(t,i){if(c(t)&&!p(t)){this._f||(this._f=new r);var o=this._f[e](t,i);return"set"==e?this:o}return n.call(this,t,i)})}))},function(e,t,n){"use strict";var r=n(639),i=n(604),o="function"==typeof Symbol&&"symbol"==typeof Symbol(),a=Object.prototype.toString,s=function(e){return"function"==typeof e&&"[object Function]"===a.call(e)},u=Object.defineProperty&&function(){var e={};try{Object.defineProperty(e,"x",{enumerable:!1,value:e});for(var t in e)return!1;return e.x===e}catch(e){return!1}}(),c=function(e,t,n,r){(!(t in e)||s(r)&&r())&&(u?Object.defineProperty(e,t,{configurable:!0,enumerable:!1,value:n,writable:!0}):e[t]=n)},l=function(e,t){var n=arguments.length>2?arguments[2]:{},a=r(t);o&&(a=a.concat(Object.getOwnPropertySymbols(t))),i(a,function(r){c(e,r,t[r],n[r])})};l.supportsDescriptors=!!u,e.exports=l},function(e,t,n){"use strict";var r=n(588);e.exports=n(253)(r,{SameValueNonNumber:function(e,t){if("number"==typeof e||typeof e!=typeof t)throw new TypeError("SameValueNonNumber requires two non-number values of the same type.");return this.SameValue(e,t)}})},function(e,t){var n=Object.prototype.hasOwnProperty;e.exports=Object.assign||function(e,t){for(var r in t)n.call(t,r)&&(e[r]=t[r]);return e}},function(e,t){var n=Number.isNaN||function(e){return e!==e};e.exports=Number.isFinite||function(e){return"number"==typeof e&&!n(e)&&e!==1/0&&e!==-(1/0)}},function(e,t){e.exports=Number.isNaN||function(e){return e!==e}},function(e,t){e.exports=function(e,t){var n=e%t;return Math.floor(n>=0?n:n+t)}},function(e,t){e.exports=function(e){return e>=0?1:-1}},function(e,t){e.exports=function(e){return null===e||"function"!=typeof e&&"object"!=typeof e}},function(e,t,n){"use strict";var r=n(32);e.exports={listen:function(e,t,n){return e.addEventListener?(e.addEventListener(t,n,!1),{remove:function(){e.removeEventListener(t,n,!1)}}):e.attachEvent?(e.attachEvent("on"+t,n),{remove:function(){e.detachEvent("on"+t,n)}}):void 0},capture:function(e,t,n){return e.addEventListener?(e.addEventListener(t,n,!0),{remove:function(){e.removeEventListener(t,n,!0)}}):{remove:r}},registerDefault:function(){}}},function(e,t,n){"use strict";function r(e){try{e.focus()}catch(e){}}e.exports=r},function(e,t,n){"use strict";(function(t){function n(e){if(void 0===(e=e||t.document))return null;try{return e.activeElement||e.body}catch(t){return e.body}}e.exports=n}).call(t,n(34))},function(e,t,n){var r=n(54),i={};i.create=function(){var e=new r.ARRAY_TYPE(9);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},i.fromMat4=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[4],e[4]=t[5],e[5]=t[6],e[6]=t[8],e[7]=t[9],e[8]=t[10],e},i.clone=function(e){var t=new r.ARRAY_TYPE(9);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},i.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},i.fromValues=function(e,t,n,i,o,a,s,u,c){var l=new r.ARRAY_TYPE(9);return l[0]=e,l[1]=t,l[2]=n,l[3]=i,l[4]=o,l[5]=a,l[6]=s,l[7]=u,l[8]=c,l},i.set=function(e,t,n,r,i,o,a,s,u,c){return e[0]=t,e[1]=n,e[2]=r,e[3]=i,e[4]=o,e[5]=a,e[6]=s,e[7]=u,e[8]=c,e},i.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},i.transpose=function(e,t){if(e===t){var n=t[1],r=t[2],i=t[5];e[1]=t[3],e[2]=t[6],e[3]=n,e[5]=t[7],e[6]=r,e[7]=i}else e[0]=t[0],e[1]=t[3],e[2]=t[6],e[3]=t[1],e[4]=t[4],e[5]=t[7],e[6]=t[2],e[7]=t[5],e[8]=t[8];return e},i.invert=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=t[4],s=t[5],u=t[6],c=t[7],l=t[8],p=l*a-s*c,d=-l*o+s*u,f=c*o-a*u,h=n*p+r*d+i*f;return h?(h=1/h,e[0]=p*h,e[1]=(-l*r+i*c)*h,e[2]=(s*r-i*a)*h,e[3]=d*h,e[4]=(l*n-i*u)*h,e[5]=(-s*n+i*o)*h,e[6]=f*h,e[7]=(-c*n+r*u)*h,e[8]=(a*n-r*o)*h,e):null},i.adjoint=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=t[4],s=t[5],u=t[6],c=t[7],l=t[8];return e[0]=a*l-s*c,e[1]=i*c-r*l,e[2]=r*s-i*a,e[3]=s*u-o*l,e[4]=n*l-i*u,e[5]=i*o-n*s,e[6]=o*c-a*u,e[7]=r*u-n*c,e[8]=n*a-r*o,e},i.determinant=function(e){var t=e[0],n=e[1],r=e[2],i=e[3],o=e[4],a=e[5],s=e[6],u=e[7],c=e[8];return t*(c*o-a*u)+n*(-c*i+a*s)+r*(u*i-o*s)},i.multiply=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=t[6],l=t[7],p=t[8],d=n[0],f=n[1],h=n[2],m=n[3],g=n[4],v=n[5],b=n[6],y=n[7],_=n[8];return e[0]=d*r+f*a+h*c,e[1]=d*i+f*s+h*l,e[2]=d*o+f*u+h*p,e[3]=m*r+g*a+v*c,e[4]=m*i+g*s+v*l,e[5]=m*o+g*u+v*p,e[6]=b*r+y*a+_*c,e[7]=b*i+y*s+_*l,e[8]=b*o+y*u+_*p,e},i.mul=i.multiply,i.translate=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=t[6],l=t[7],p=t[8],d=n[0],f=n[1];return e[0]=r,e[1]=i,e[2]=o,e[3]=a,e[4]=s,e[5]=u,e[6]=d*r+f*a+c,e[7]=d*i+f*s+l,e[8]=d*o+f*u+p,e},i.rotate=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=t[6],l=t[7],p=t[8],d=Math.sin(n),f=Math.cos(n);return e[0]=f*r+d*a,e[1]=f*i+d*s,e[2]=f*o+d*u,e[3]=f*a-d*r,e[4]=f*s-d*i,e[5]=f*u-d*o,e[6]=c,e[7]=l,e[8]=p,e},i.scale=function(e,t,n){var r=n[0],i=n[1];return e[0]=r*t[0],e[1]=r*t[1],e[2]=r*t[2],e[3]=i*t[3],e[4]=i*t[4],e[5]=i*t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},i.fromTranslation=function(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=1,e[5]=0,e[6]=t[0],e[7]=t[1],e[8]=1,e},i.fromRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=0,e[3]=-n,e[4]=r,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},i.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=0,e[4]=t[1],e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},i.fromMat2d=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=0,e[3]=t[2],e[4]=t[3],e[5]=0,e[6]=t[4],e[7]=t[5],e[8]=1,e},i.fromQuat=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=n+n,s=r+r,u=i+i,c=n*a,l=r*a,p=r*s,d=i*a,f=i*s,h=i*u,m=o*a,g=o*s,v=o*u;return e[0]=1-p-h,e[3]=l-v,e[6]=d+g,e[1]=l+v,e[4]=1-c-h,e[7]=f-m,e[2]=d-g,e[5]=f+m,e[8]=1-c-p,e},i.normalFromMat4=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=t[4],s=t[5],u=t[6],c=t[7],l=t[8],p=t[9],d=t[10],f=t[11],h=t[12],m=t[13],g=t[14],v=t[15],b=n*s-r*a,y=n*u-i*a,_=n*c-o*a,w=r*u-i*s,E=r*c-o*s,x=i*c-o*u,S=l*m-p*h,T=l*g-d*h,C=l*v-f*h,I=p*g-d*m,M=p*v-f*m,P=d*v-f*g,R=b*P-y*M+_*I+w*C-E*T+x*S;return R?(R=1/R,e[0]=(s*P-u*M+c*I)*R,e[1]=(u*C-a*P-c*T)*R,e[2]=(a*M-s*C+c*S)*R,e[3]=(i*M-r*P-o*I)*R,e[4]=(n*P-i*C+o*T)*R,e[5]=(r*C-n*M-o*S)*R,e[6]=(m*x-g*E+v*w)*R,e[7]=(g*_-h*x-v*y)*R,e[8]=(h*E-m*_+v*b)*R,e):null},i.str=function(e){return"mat3("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+")"},i.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+Math.pow(e[6],2)+Math.pow(e[7],2)+Math.pow(e[8],2))},i.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e[6]=t[6]+n[6],e[7]=t[7]+n[7],e[8]=t[8]+n[8],e},i.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e[6]=t[6]-n[6],e[7]=t[7]-n[7],e[8]=t[8]-n[8],e},i.sub=i.subtract,i.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e[8]=t[8]*n,e},i.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e[4]=t[4]+n[4]*r,e[5]=t[5]+n[5]*r,e[6]=t[6]+n[6]*r,e[7]=t[7]+n[7]*r,e[8]=t[8]+n[8]*r,e},i.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]},i.equals=function(e,t){var n=e[0],i=e[1],o=e[2],a=e[3],s=e[4],u=e[5],c=e[6],l=e[7],p=e[8],d=t[0],f=t[1],h=t[2],m=t[3],g=t[4],v=t[5],b=e[6],y=t[7],_=t[8];return Math.abs(n-d)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(d))&&Math.abs(i-f)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(f))&&Math.abs(o-h)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(h))&&Math.abs(a-m)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(m))&&Math.abs(s-g)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(g))&&Math.abs(u-v)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(v))&&Math.abs(c-b)<=r.EPSILON*Math.max(1,Math.abs(c),Math.abs(b))&&Math.abs(l-y)<=r.EPSILON*Math.max(1,Math.abs(l),Math.abs(y))&&Math.abs(p-_)<=r.EPSILON*Math.max(1,Math.abs(p),Math.abs(_))},e.exports=i},function(e,t,n){var r=n(54),i={};i.create=function(){var e=new r.ARRAY_TYPE(3);return e[0]=0,e[1]=0,e[2]=0,e},i.clone=function(e){var t=new r.ARRAY_TYPE(3);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},i.fromValues=function(e,t,n){var i=new r.ARRAY_TYPE(3);return i[0]=e,i[1]=t,i[2]=n,i},i.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},i.set=function(e,t,n,r){return e[0]=t,e[1]=n,e[2]=r,e},i.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e},i.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e},i.sub=i.subtract,i.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e},i.mul=i.multiply,i.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e},i.div=i.divide,i.ceil=function(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e[2]=Math.ceil(t[2]),e},i.floor=function(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e[2]=Math.floor(t[2]),e},i.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e},i.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e},i.round=function(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e[2]=Math.round(t[2]),e},i.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e},i.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e},i.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2];return Math.sqrt(n*n+r*r+i*i)},i.dist=i.distance,i.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2];return n*n+r*r+i*i},i.sqrDist=i.squaredDistance,i.length=function(e){var t=e[0],n=e[1],r=e[2];return Math.sqrt(t*t+n*n+r*r)},i.len=i.length,i.squaredLength=function(e){var t=e[0],n=e[1],r=e[2];return t*t+n*n+r*r},i.sqrLen=i.squaredLength,i.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e},i.inverse=function(e,t){return e[0]=1/t[0],e[1]=1/t[1],e[2]=1/t[2],e},i.normalize=function(e,t){var n=t[0],r=t[1],i=t[2],o=n*n+r*r+i*i;return o>0&&(o=1/Math.sqrt(o),e[0]=t[0]*o,e[1]=t[1]*o,e[2]=t[2]*o),e},i.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]},i.cross=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=n[0],s=n[1],u=n[2];return e[0]=i*u-o*s,e[1]=o*a-r*u,e[2]=r*s-i*a,e},i.lerp=function(e,t,n,r){var i=t[0],o=t[1],a=t[2];return e[0]=i+r*(n[0]-i),e[1]=o+r*(n[1]-o),e[2]=a+r*(n[2]-a),e},i.hermite=function(e,t,n,r,i,o){var a=o*o,s=a*(2*o-3)+1,u=a*(o-2)+o,c=a*(o-1),l=a*(3-2*o);return e[0]=t[0]*s+n[0]*u+r[0]*c+i[0]*l,e[1]=t[1]*s+n[1]*u+r[1]*c+i[1]*l,e[2]=t[2]*s+n[2]*u+r[2]*c+i[2]*l,e},i.bezier=function(e,t,n,r,i,o){var a=1-o,s=a*a,u=o*o,c=s*a,l=3*o*s,p=3*u*a,d=u*o;return e[0]=t[0]*c+n[0]*l+r[0]*p+i[0]*d,e[1]=t[1]*c+n[1]*l+r[1]*p+i[1]*d,e[2]=t[2]*c+n[2]*l+r[2]*p+i[2]*d,e},i.random=function(e,t){t=t||1;var n=2*r.RANDOM()*Math.PI,i=2*r.RANDOM()-1,o=Math.sqrt(1-i*i)*t;return e[0]=Math.cos(n)*o,e[1]=Math.sin(n)*o,e[2]=i*t,e},i.transformMat4=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=n[3]*r+n[7]*i+n[11]*o+n[15];return a=a||1,e[0]=(n[0]*r+n[4]*i+n[8]*o+n[12])/a,e[1]=(n[1]*r+n[5]*i+n[9]*o+n[13])/a,e[2]=(n[2]*r+n[6]*i+n[10]*o+n[14])/a,e},i.transformMat3=function(e,t,n){var r=t[0],i=t[1],o=t[2];return e[0]=r*n[0]+i*n[3]+o*n[6],e[1]=r*n[1]+i*n[4]+o*n[7],e[2]=r*n[2]+i*n[5]+o*n[8],e},i.transformQuat=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=n[0],s=n[1],u=n[2],c=n[3],l=c*r+s*o-u*i,p=c*i+u*r-a*o,d=c*o+a*i-s*r,f=-a*r-s*i-u*o;return e[0]=l*c+f*-a+p*-u-d*-s,e[1]=p*c+f*-s+d*-a-l*-u,e[2]=d*c+f*-u+l*-s-p*-a,e},i.rotateX=function(e,t,n,r){var i=[],o=[];return i[0]=t[0]-n[0],i[1]=t[1]-n[1],i[2]=t[2]-n[2],o[0]=i[0],o[1]=i[1]*Math.cos(r)-i[2]*Math.sin(r),o[2]=i[1]*Math.sin(r)+i[2]*Math.cos(r),e[0]=o[0]+n[0],e[1]=o[1]+n[1],e[2]=o[2]+n[2],e},i.rotateY=function(e,t,n,r){var i=[],o=[];return i[0]=t[0]-n[0],i[1]=t[1]-n[1],i[2]=t[2]-n[2],o[0]=i[2]*Math.sin(r)+i[0]*Math.cos(r),o[1]=i[1],o[2]=i[2]*Math.cos(r)-i[0]*Math.sin(r),e[0]=o[0]+n[0],e[1]=o[1]+n[1],e[2]=o[2]+n[2],e},i.rotateZ=function(e,t,n,r){var i=[],o=[];return i[0]=t[0]-n[0],i[1]=t[1]-n[1],i[2]=t[2]-n[2],o[0]=i[0]*Math.cos(r)-i[1]*Math.sin(r),o[1]=i[0]*Math.sin(r)+i[1]*Math.cos(r),o[2]=i[2],e[0]=o[0]+n[0],e[1]=o[1]+n[1],e[2]=o[2]+n[2],e},i.forEach=function(){var e=i.create();return function(t,n,r,i,o,a){var s,u;for(n||(n=3),r||(r=0),u=i?Math.min(i*n+r,t.length):t.length,s=r;s<u;s+=n)e[0]=t[s],e[1]=t[s+1],e[2]=t[s+2],o(e,e,a),t[s]=e[0],t[s+1]=e[1],t[s+2]=e[2];return t}}(),i.angle=function(e,t){var n=i.fromValues(e[0],e[1],e[2]),r=i.fromValues(t[0],t[1],t[2]);i.normalize(n,n),i.normalize(r,r);var o=i.dot(n,r);return o>1?0:Math.acos(o)},i.str=function(e){return"vec3("+e[0]+", "+e[1]+", "+e[2]+")"},i.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]},i.equals=function(e,t){var n=e[0],i=e[1],o=e[2],a=t[0],s=t[1],u=t[2];return Math.abs(n-a)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(a))&&Math.abs(i-s)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(s))&&Math.abs(o-u)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(u))},e.exports=i},function(e,t,n){var r=n(54),i={};i.create=function(){var e=new r.ARRAY_TYPE(4);return e[0]=0,e[1]=0,e[2]=0,e[3]=0,e},i.clone=function(e){var t=new r.ARRAY_TYPE(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},i.fromValues=function(e,t,n,i){var o=new r.ARRAY_TYPE(4);return o[0]=e,o[1]=t,o[2]=n,o[3]=i,o},i.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},i.set=function(e,t,n,r,i){return e[0]=t,e[1]=n,e[2]=r,e[3]=i,e},i.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e},i.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e},i.sub=i.subtract,i.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e[2]=t[2]*n[2],e[3]=t[3]*n[3],e},i.mul=i.multiply,i.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e[2]=t[2]/n[2],e[3]=t[3]/n[3],e},i.div=i.divide,i.ceil=function(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e[2]=Math.ceil(t[2]),e[3]=Math.ceil(t[3]),e},i.floor=function(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e[2]=Math.floor(t[2]),e[3]=Math.floor(t[3]),e},i.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e[2]=Math.min(t[2],n[2]),e[3]=Math.min(t[3],n[3]),e},i.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e[2]=Math.max(t[2],n[2]),e[3]=Math.max(t[3],n[3]),e},i.round=function(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e[2]=Math.round(t[2]),e[3]=Math.round(t[3]),e},i.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e},i.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e},i.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2],o=t[3]-e[3];return Math.sqrt(n*n+r*r+i*i+o*o)},i.dist=i.distance,i.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1],i=t[2]-e[2],o=t[3]-e[3];return n*n+r*r+i*i+o*o},i.sqrDist=i.squaredDistance,i.length=function(e){var t=e[0],n=e[1],r=e[2],i=e[3];return Math.sqrt(t*t+n*n+r*r+i*i)},i.len=i.length,i.squaredLength=function(e){var t=e[0],n=e[1],r=e[2],i=e[3];return t*t+n*n+r*r+i*i},i.sqrLen=i.squaredLength,i.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=-t[3],e},i.inverse=function(e,t){return e[0]=1/t[0],e[1]=1/t[1],e[2]=1/t[2],e[3]=1/t[3],e},i.normalize=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=n*n+r*r+i*i+o*o;return a>0&&(a=1/Math.sqrt(a),e[0]=n*a,e[1]=r*a,e[2]=i*a,e[3]=o*a),e},i.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]+e[3]*t[3]},i.lerp=function(e,t,n,r){var i=t[0],o=t[1],a=t[2],s=t[3];return e[0]=i+r*(n[0]-i),e[1]=o+r*(n[1]-o),e[2]=a+r*(n[2]-a),e[3]=s+r*(n[3]-s),e},i.random=function(e,t){return t=t||1,e[0]=r.RANDOM(),e[1]=r.RANDOM(),e[2]=r.RANDOM(),e[3]=r.RANDOM(),i.normalize(e,e),i.scale(e,e,t),e},i.transformMat4=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3];return e[0]=n[0]*r+n[4]*i+n[8]*o+n[12]*a,e[1]=n[1]*r+n[5]*i+n[9]*o+n[13]*a,e[2]=n[2]*r+n[6]*i+n[10]*o+n[14]*a,e[3]=n[3]*r+n[7]*i+n[11]*o+n[15]*a,e},i.transformQuat=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=n[0],s=n[1],u=n[2],c=n[3],l=c*r+s*o-u*i,p=c*i+u*r-a*o,d=c*o+a*i-s*r,f=-a*r-s*i-u*o;return e[0]=l*c+f*-a+p*-u-d*-s,e[1]=p*c+f*-s+d*-a-l*-u,e[2]=d*c+f*-u+l*-s-p*-a,e[3]=t[3],e},i.forEach=function(){var e=i.create();return function(t,n,r,i,o,a){var s,u;for(n||(n=4),r||(r=0),u=i?Math.min(i*n+r,t.length):t.length,s=r;s<u;s+=n)e[0]=t[s],e[1]=t[s+1],e[2]=t[s+2],e[3]=t[s+3],o(e,e,a),t[s]=e[0],t[s+1]=e[1],t[s+2]=e[2],t[s+3]=e[3];return t}}(),i.str=function(e){return"vec4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},i.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]},i.equals=function(e,t){var n=e[0],i=e[1],o=e[2],a=e[3],s=t[0],u=t[1],c=t[2],l=t[3];return Math.abs(n-s)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(s))&&Math.abs(i-u)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(u))&&Math.abs(o-c)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))&&Math.abs(a-l)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(l))},e.exports=i},function(e,t,n){"use strict";t.a=n(633).a.Symbol},function(e,t,n){"use strict";var r=n(643);e.exports=function(e){return r(e,!1)}},function(e,t,n){"use strict";(function(t){var r=n(647),i="undefined"!=typeof window?window:void 0!==t?t:"undefined"!=typeof self?self:{},o=i.Raven,a=new r;a.noConflict=function(){return i.Raven=o,a},a.afterLoad(),e.exports=a}).call(t,n(34))},function(e,t,n){"use strict";function r(e){return"object"==typeof e&&null!==e}function i(e){switch({}.toString.call(e)){case"[object Error]":return!0;case"[object Exception]":return!0;case"[object DOMException]":return!0;default:return e instanceof Error}}e.exports={isObject:r,isError:i}},function(e,t,n){"use strict";function r(e,t){return e+t.charAt(0).toUpperCase()+t.substring(1)}var i={animationIterationCount:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridRow:!0,gridColumn:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},o=["Webkit","ms","Moz","O"];Object.keys(i).forEach(function(e){o.forEach(function(t){i[r(t,e)]=i[e]})}),e.exports={isUnitlessNumber:i,shorthandPropertyExpansions:{background:{backgroundAttachment:!0,backgroundColor:!0,backgroundImage:!0,backgroundPositionX:!0,backgroundPositionY:!0,backgroundRepeat:!0},backgroundPosition:{backgroundPositionX:!0,backgroundPositionY:!0},border:{borderWidth:!0,borderStyle:!0,borderColor:!0},borderBottom:{borderBottomWidth:!0,borderBottomStyle:!0,borderBottomColor:!0},borderLeft:{borderLeftWidth:!0,borderLeftStyle:!0,borderLeftColor:!0},borderRight:{borderRightWidth:!0,borderRightStyle:!0,borderRightColor:!0},borderTop:{borderTopWidth:!0,borderTopStyle:!0,borderTopColor:!0},font:{fontStyle:!0,fontVariant:!0,fontWeight:!0,fontSize:!0,lineHeight:!0,fontFamily:!0},outline:{outlineWidth:!0,outlineStyle:!0,outlineColor:!0}}}},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var i=n(7),o=n(72);n(1);e.exports=o.addPoolingTo(function(){function e(t){r(this,e),this._callbacks=null,this._contexts=null,this._arg=t}return e.prototype.enqueue=function(e,t){this._callbacks=this._callbacks||[],this._callbacks.push(e),this._contexts=this._contexts||[],this._contexts.push(t)},e.prototype.notifyAll=function(){var e=this._callbacks,t=this._contexts,n=this._arg;if(e&&t){e.length!==t.length&&i("24"),this._callbacks=null,this._contexts=null;for(var r=0;r<e.length;r++)e[r].call(t[r],n);e.length=0,t.length=0}},e.prototype.checkpoint=function(){return this._callbacks?this._callbacks.length:0},e.prototype.rollback=function(e){this._callbacks&&this._contexts&&(this._callbacks.length=e,this._contexts.length=e)},e.prototype.reset=function(){this._callbacks=null,this._contexts=null},e.prototype.destructor=function(){this.reset()},e}())},function(e,t,n){"use strict";function r(e){return!!c.hasOwnProperty(e)||!u.hasOwnProperty(e)&&(s.test(e)?(c[e]=!0,!0):(u[e]=!0,!1))}function i(e,t){return null==t||e.hasBooleanValue&&!t||e.hasNumericValue&&isNaN(t)||e.hasPositiveNumericValue&&t<1||e.hasOverloadedBooleanValue&&t===!1}var o=n(88),a=(n(16),n(39),n(711)),s=(n(5),new RegExp("^["+o.ATTRIBUTE_NAME_START_CHAR+"]["+o.ATTRIBUTE_NAME_CHAR+"]*$")),u={},c={},l={createMarkupForID:function(e){return o.ID_ATTRIBUTE_NAME+"="+a(e)},setAttributeForID:function(e,t){e.setAttribute(o.ID_ATTRIBUTE_NAME,t)},createMarkupForRoot:function(){return o.ROOT_ATTRIBUTE_NAME+'=""'},setAttributeForRoot:function(e){e.setAttribute(o.ROOT_ATTRIBUTE_NAME,"")},createMarkupForProperty:function(e,t){var n=o.properties.hasOwnProperty(e)?o.properties[e]:null;if(n){if(i(n,t))return"";var r=n.attributeName;return n.hasBooleanValue||n.hasOverloadedBooleanValue&&t===!0?r+'=""':r+"="+a(t)}return o.isCustomAttribute(e)?null==t?"":e+"="+a(t):null},createMarkupForCustomAttribute:function(e,t){return r(e)&&null!=t?e+"="+a(t):""},setValueForProperty:function(e,t,n){var r=o.properties.hasOwnProperty(t)?o.properties[t]:null;if(r){var a=r.mutationMethod;if(a)a(e,n);else{if(i(r,n))return void this.deleteValueForProperty(e,t);if(r.mustUseProperty)e[r.propertyName]=n;else{var s=r.attributeName,u=r.attributeNamespace;u?e.setAttributeNS(u,s,""+n):r.hasBooleanValue||r.hasOverloadedBooleanValue&&n===!0?e.setAttribute(s,""):e.setAttribute(s,""+n)}}}else if(o.isCustomAttribute(t))return void l.setValueForAttribute(e,t,n)},setValueForAttribute:function(e,t,n){if(r(t)){null==n?e.removeAttribute(t):e.setAttribute(t,""+n)}},deleteValueForAttribute:function(e,t){e.removeAttribute(t)},deleteValueForProperty:function(e,t){var n=o.properties.hasOwnProperty(t)?o.properties[t]:null;if(n){var r=n.mutationMethod;if(r)r(e,void 0);else if(n.mustUseProperty){var i=n.propertyName;e[i]=!n.hasBooleanValue&&""}else e.removeAttribute(n.attributeName)}else o.isCustomAttribute(t)&&e.removeAttribute(t)}};e.exports=l},function(e,t,n){"use strict";e.exports={hasCachedChildNodes:1}},function(e,t,n){"use strict";function r(){if(this._rootNodeID&&this._wrapperState.pendingUpdate){this._wrapperState.pendingUpdate=!1;var e=this._currentElement.props,t=s.getValue(e);null!=t&&i(this,Boolean(e.multiple),t)}}function i(e,t,n){var r,i,o=u.getNodeFromInstance(e).options;if(t){for(r={},i=0;i<n.length;i++)r[""+n[i]]=!0;for(i=0;i<o.length;i++){var a=r.hasOwnProperty(o[i].value);o[i].selected!==a&&(o[i].selected=a)}}else{for(r=""+n,i=0;i<o.length;i++)if(o[i].value===r)return void(o[i].selected=!0);o.length&&(o[0].selected=!0)}}function o(e){var t=this._currentElement.props,n=s.executeOnChange(t,e);return this._rootNodeID&&(this._wrapperState.pendingUpdate=!0),c.asap(r,this),n}var a=n(13),s=n(178),u=n(16),c=n(46),l=(n(5),!1);e.exports={getHostProps:function(e,t){return a({},t,{onChange:e._wrapperState.onChange,value:void 0})},mountWrapper:function(e,t){var n=s.getValue(t);e._wrapperState={pendingUpdate:!1,initialValue:null!=n?n:t.defaultValue,listeners:null,onChange:o.bind(e),wasMultiple:Boolean(t.multiple)},void 0===t.value||void 0===t.defaultValue||l||(l=!0)},getSelectValueContext:function(e){return e._wrapperState.initialValue},postUpdateWrapper:function(e){var t=e._currentElement.props;e._wrapperState.initialValue=void 0;var n=e._wrapperState.wasMultiple;e._wrapperState.wasMultiple=Boolean(t.multiple);var r=s.getValue(t);null!=r?(e._wrapperState.pendingUpdate=!1,i(e,Boolean(t.multiple),r)):n!==Boolean(t.multiple)&&(null!=t.defaultValue?i(e,Boolean(t.multiple),t.defaultValue):i(e,Boolean(t.multiple),t.multiple?[]:""))}}},function(e,t,n){"use strict";var r,i={injectEmptyComponentFactory:function(e){r=e}},o={create:function(e){return r(e)}};o.injection=i,e.exports=o},function(e,t,n){"use strict";e.exports={logTopLevelRenders:!1}},function(e,t,n){"use strict";function r(e){return s||a("111",e.type),new s(e)}function i(e){return new u(e)}function o(e){return e instanceof u}var a=n(7),s=(n(1),null),u=null;e.exports={createInternalComponent:r,createInstanceForText:i,isTextComponent:o,injection:{injectGenericComponentClass:function(e){s=e},injectTextComponentClass:function(e){u=e}}}},function(e,t,n){"use strict";function r(e){return o(document.documentElement,e)}var i=n(671),o=n(594),a=n(260),s=n(261),u={hasSelectionCapabilities:function(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return t&&("input"===t&&"text"===e.type||"textarea"===t||"true"===e.contentEditable)},getSelectionInformation:function(){var e=s();return{focusedElem:e,selectionRange:u.hasSelectionCapabilities(e)?u.getSelection(e):null}},restoreSelection:function(e){var t=s(),n=e.focusedElem,i=e.selectionRange;t!==n&&r(n)&&(u.hasSelectionCapabilities(n)&&u.setSelection(n,i),a(n))},getSelection:function(e){var t;if("selectionStart"in e)t={start:e.selectionStart,end:e.selectionEnd};else if(document.selection&&e.nodeName&&"input"===e.nodeName.toLowerCase()){var n=document.selection.createRange();n.parentElement()===e&&(t={start:-n.moveStart("character",-e.value.length),end:-n.moveEnd("character",-e.value.length)})}else t=i.getOffsets(e);return t||{start:0,end:0}},setSelection:function(e,t){var n=t.start,r=t.end;if(void 0===r&&(r=n),"selectionStart"in e)e.selectionStart=n,e.selectionEnd=Math.min(r,e.value.length);else if(document.selection&&e.nodeName&&"input"===e.nodeName.toLowerCase()){var o=e.createTextRange();o.collapse(!0),o.moveStart("character",n),o.moveEnd("character",r-n),o.select()}else i.setOffsets(e,t)}};e.exports=u},function(e,t,n){"use strict";function r(e,t){for(var n=Math.min(e.length,t.length),r=0;r<n;r++)if(e.charAt(r)!==t.charAt(r))return r;return e.length===t.length?-1:n}function i(e){return e?e.nodeType===N?e.documentElement:e.firstChild:null}function o(e){return e.getAttribute&&e.getAttribute(O)||""}function a(e,t,n,r,i){var o;if(w.logTopLevelRenders){var a=e._currentElement.props.child,s=a.type;o="React mount: "+("string"==typeof s?s:s.displayName||s.name),console.time(o)}var u=S.mountComponent(e,n,null,y(e,t),i,0);o&&console.timeEnd(o),e._renderedComponent._topLevelWrapper=e,B._mountImageIntoNode(u,t,e,r,n)}function s(e,t,n,r){var i=C.ReactReconcileTransaction.getPooled(!n&&_.useCreateElement);i.perform(a,null,e,t,i,n,r),C.ReactReconcileTransaction.release(i)}function u(e,t,n){for(S.unmountComponent(e,n),t.nodeType===N&&(t=t.documentElement);t.lastChild;)t.removeChild(t.lastChild)}function c(e){var t=i(e);if(t){var n=b.getInstanceFromNode(t);return!(!n||!n._hostParent)}}function l(e){return!(!e||e.nodeType!==A&&e.nodeType!==N&&e.nodeType!==D)}function p(e){var t=i(e),n=t&&b.getInstanceFromNode(t);return n&&!n._hostParent?n:null}function d(e){var t=p(e);return t?t._hostContainerInfo._topLevelWrapper:null}var f=n(7),h=n(87),m=n(88),g=n(90),v=n(124),b=(n(56),n(16)),y=n(665),_=n(667),w=n(275),E=n(104),x=(n(39),n(681)),S=n(89),T=n(181),C=n(46),I=n(100),M=n(285),P=(n(1),n(128)),R=n(187),O=(n(5),m.ID_ATTRIBUTE_NAME),k=m.ROOT_ATTRIBUTE_NAME,A=1,N=9,D=11,L={},F=1,U=function(){this.rootID=F++};U.prototype.isReactComponent={},U.prototype.render=function(){return this.props.child},U.isReactTopLevelWrapper=!0;var B={TopLevelWrapper:U,_instancesByReactRootID:L,scrollMonitor:function(e,t){t()},_updateRootComponent:function(e,t,n,r,i){return B.scrollMonitor(r,function(){T.enqueueElementInternal(e,t,n),i&&T.enqueueCallbackInternal(e,i)}),e},_renderNewRootComponent:function(e,t,n,r){l(t)||f("37"),v.ensureScrollValueMonitoring();var i=M(e,!1);return C.batchedUpdates(s,i,t,n,r),L[i._instance.rootID]=i,i},renderSubtreeIntoContainer:function(e,t,n,r){return null!=e&&E.has(e)||f("38"),B._renderSubtreeIntoContainer(e,t,n,r)},_renderSubtreeIntoContainer:function(e,t,n,r){T.validateCallback(r,"ReactDOM.render"),g.isValidElement(t)||f("39","string"==typeof t?" Instead of passing a string like 'div', pass React.createElement('div') or <div />.":"function"==typeof t?" Instead of passing a class like Foo, pass React.createElement(Foo) or <Foo />.":null!=t&&void 0!==t.props?" This may be caused by unintentionally loading two independent copies of React.":"");var a,s=g.createElement(U,{child:t});if(e){var u=E.get(e);a=u._processChildContext(u._context)}else a=I;var l=d(n);if(l){if(R(l._currentElement.props.child,t)){var p=l._renderedComponent.getPublicInstance();return B._updateRootComponent(l,s,a,n,r&&function(){r.call(p)}),p}B.unmountComponentAtNode(n)}var h=i(n),m=h&&!!o(h),v=c(n),b=m&&!l&&!v,y=B._renderNewRootComponent(s,n,b,a)._renderedComponent.getPublicInstance();return r&&r.call(y),y},render:function(e,t,n){return B._renderSubtreeIntoContainer(null,e,t,n)},unmountComponentAtNode:function(e){l(e)||f("40");var t=d(e);if(!t){c(e),1===e.nodeType&&e.hasAttribute(k);return!1}return delete L[t._instance.rootID],C.batchedUpdates(u,t,e,!1),!0},_mountImageIntoNode:function(e,t,n,o,a){if(l(t)||f("41"),o){var s=i(t);if(x.canReuseMarkup(e,s))return void b.precacheNode(n,s);var u=s.getAttribute(x.CHECKSUM_ATTR_NAME);s.removeAttribute(x.CHECKSUM_ATTR_NAME);var c=s.outerHTML;s.setAttribute(x.CHECKSUM_ATTR_NAME,u);var p=e,d=r(p,c),m=" (client) "+p.substring(d-20,d+20)+"\n (server) "+c.substring(d-20,d+20);t.nodeType===N&&f("42",m)}if(t.nodeType===N&&f("43"),a.useCreateElement){for(;t.lastChild;)t.removeChild(t.lastChild);h.insertTreeBefore(t,e,null)}else P(t,e),b.precacheNode(n,t.firstChild)}};e.exports=B},function(e,t,n){"use strict";var r=n(7),i=n(90),o=(n(1),{HOST:0,COMPOSITE:1,EMPTY:2,getType:function(e){return null===e||e===!1?o.EMPTY:i.isValidElement(e)?"function"==typeof e.type?o.COMPOSITE:o.HOST:void r("26",e)}});e.exports=o},function(e,t,n){"use strict";var r={currentScrollLeft:0,currentScrollTop:0,refreshScrollValues:function(e){r.currentScrollLeft=e.x,r.currentScrollTop=e.y}};e.exports=r},function(e,t,n){"use strict";function r(e,t){return null==t&&i("30"),null==e?t:Array.isArray(e)?Array.isArray(t)?(e.push.apply(e,t),e):(e.push(t),e):Array.isArray(t)?[e].concat(t):[e,t]}var i=n(7);n(1);e.exports=r},function(e,t,n){"use strict";function r(e,t,n){Array.isArray(e)?e.forEach(t,n):e&&t.call(n,e)}e.exports=r},function(e,t,n){"use strict";function r(e){for(var t;(t=e._renderedNodeType)===i.COMPOSITE;)e=e._renderedComponent;return t===i.HOST?e._renderedComponent:t===i.EMPTY?null:void 0}var i=n(279);e.exports=r},function(e,t,n){"use strict";function r(){return!o&&i.canUseDOM&&(o="textContent"in document.documentElement?"textContent":"innerText"),o}var i=n(24),o=null;e.exports=r},function(e,t,n){"use strict";function r(e){if(e){var t=e.getName();if(t)return" Check the render method of `"+t+"`."}return""}function i(e){return"function"==typeof e&&void 0!==e.prototype&&"function"==typeof e.prototype.mountComponent&&"function"==typeof e.prototype.receiveComponent}function o(e,t){var n;if(null===e||e===!1)n=c.create(o);else if("object"==typeof e){var s=e,u=s.type;if("function"!=typeof u&&"string"!=typeof u){var d="";d+=r(s._owner),a("130",null==u?u:typeof u,d)}"string"==typeof s.type?n=l.createInternalComponent(s):i(s.type)?(n=new s.type(s),n.getHostNode||(n.getHostNode=n.getNativeNode)):n=new p(s)}else"string"==typeof e||"number"==typeof e?n=l.createInstanceForText(e):a("131",typeof e);return n._mountIndex=0,n._mountImage=null,n}var a=n(7),s=n(13),u=n(662),c=n(274),l=n(276),p=(n(732),n(1),n(5),function(e){this.construct(e)});s(p.prototype,u,{_instantiateReactComponent:o}),e.exports=o},function(e,t,n){"use strict";function r(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return"input"===t?!!i[e.type]:"textarea"===t}var i={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};e.exports=r},function(e,t,n){"use strict";var r=n(24),i=n(127),o=n(128),a=function(e,t){if(t){var n=e.firstChild;if(n&&n===e.lastChild&&3===n.nodeType)return void(n.nodeValue=t)}e.textContent=t};r.canUseDOM&&("textContent"in document.documentElement||(a=function(e,t){if(3===e.nodeType)return void(e.nodeValue=t);o(e,i(t))})),e.exports=a},function(e,t,n){"use strict";function r(e,t){return e&&"object"==typeof e&&null!=e.key?c.escape(e.key):t.toString(36)}function i(e,t,n,o){var d=typeof e;if("undefined"!==d&&"boolean"!==d||(e=null),null===e||"string"===d||"number"===d||"object"===d&&e.$$typeof===s)return n(o,e,""===t?l+r(e,0):t),1;var f,h,m=0,g=""===t?l:t+p;if(Array.isArray(e))for(var v=0;v<e.length;v++)f=e[v],h=g+r(f,v),m+=i(f,h,n,o);else{var b=u(e);if(b){var y,_=b.call(e);if(b!==e.entries)for(var w=0;!(y=_.next()).done;)f=y.value,h=g+r(f,w++),m+=i(f,h,n,o);else for(;!(y=_.next()).done;){var E=y.value;E&&(f=E[1],h=g+c.escape(E[0])+p+r(f,0),m+=i(f,h,n,o))}}else if("object"===d){var x="",S=String(e);a("31","[object Object]"===S?"object with keys {"+Object.keys(e).join(", ")+"}":S,x)}}return m}function o(e,t,n){return null==e?0:i(e,"",t,n)}var a=n(7),s=(n(56),n(677)),u=n(708),c=(n(1),n(177)),l=(n(5),"."),p=":";e.exports=o},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function i(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}function a(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}function s(){}function u(e,t){var n={run:function(r){try{var i=e(t.getState(),r);(i!==n.props||n.error)&&(n.shouldComponentUpdate=!0,n.props=i,n.error=null)}catch(e){n.shouldComponentUpdate=!0,n.error=e}}};return n}function c(e){var t,c,l=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},d=l.getDisplayName,_=void 0===d?function(e){return"ConnectAdvanced("+e+")"}:d,w=l.methodName,E=void 0===w?"connectAdvanced":w,x=l.renderCountProp,S=void 0===x?void 0:x,T=l.shouldHandleStateChanges,C=void 0===T||T,I=l.storeKey,M=void 0===I?"store":I,P=l.withRef,R=void 0!==P&&P,O=a(l,["getDisplayName","methodName","renderCountProp","shouldHandleStateChanges","storeKey","withRef"]),k=M+"Subscription",A=b++,N=(t={},t[M]=g.a,t[k]=g.b,t),D=(c={},c[k]=g.b,c);return function(t){f()("function"==typeof t,"You must pass a component to the function returned by connect. Instead received "+JSON.stringify(t));var a=t.displayName||t.name||"Component",c=_(a),l=v({},O,{getDisplayName:_,methodName:E,renderCountProp:S,shouldHandleStateChanges:C,storeKey:M,withRef:R,displayName:c,wrappedComponentName:a,WrappedComponent:t}),d=function(a){function p(e,t){r(this,p);var n=i(this,a.call(this,e,t));return n.version=A,n.state={},n.renderCount=0,n.store=e[M]||t[M],n.propsMode=Boolean(e[M]),n.setWrappedInstance=n.setWrappedInstance.bind(n),f()(n.store,'Could not find "'+M+'" in either the context or props of "'+c+'". Either wrap the root component in a <Provider>, or explicitly pass "'+M+'" as a prop to "'+c+'".'),n.initSelector(),n.initSubscription(),n}return o(p,a),p.prototype.getChildContext=function(){var e,t=this.propsMode?null:this.subscription;return e={},e[k]=t||this.context[k],e},p.prototype.componentDidMount=function(){C&&(this.subscription.trySubscribe(),this.selector.run(this.props),this.selector.shouldComponentUpdate&&this.forceUpdate())},p.prototype.componentWillReceiveProps=function(e){this.selector.run(e)},p.prototype.shouldComponentUpdate=function(){return this.selector.shouldComponentUpdate},p.prototype.componentWillUnmount=function(){this.subscription&&this.subscription.tryUnsubscribe(),this.subscription=null,this.notifyNestedSubs=s,this.store=null,this.selector.run=s,this.selector.shouldComponentUpdate=!1},p.prototype.getWrappedInstance=function(){return f()(R,"To access the wrapped instance, you need to specify { withRef: true } in the options argument of the "+E+"() call."),this.wrappedInstance},p.prototype.setWrappedInstance=function(e){this.wrappedInstance=e},p.prototype.initSelector=function(){this.selector=u(e(this.store.dispatch,l),this.store),this.selector.run(this.props)},p.prototype.initSubscription=function(){if(C){this.subscription=new m.a(this.store,(this.propsMode?this.props:this.context)[k],this.onStateChange.bind(this)),this.notifyNestedSubs=this.subscription.notifyNestedSubs.bind(this.subscription)}},p.prototype.onStateChange=function(){this.selector.run(this.props),this.selector.shouldComponentUpdate?(this.componentDidUpdate=this.notifyNestedSubsOnComponentDidUpdate,this.setState(y)):this.notifyNestedSubs()},p.prototype.notifyNestedSubsOnComponentDidUpdate=function(){this.componentDidUpdate=void 0,this.notifyNestedSubs()},p.prototype.isSubscribed=function(){return Boolean(this.subscription)&&this.subscription.isSubscribed()},p.prototype.addExtraProps=function(e){if(!(R||S||this.propsMode&&this.subscription))return e;var t=v({},e);return R&&(t.ref=this.setWrappedInstance),S&&(t[S]=this.renderCount++),this.propsMode&&this.subscription&&(t[k]=this.subscription),t},p.prototype.render=function(){var e=this.selector;if(e.shouldComponentUpdate=!1,e.error)throw e.error;return n.i(h.createElement)(t,this.addExtraProps(e.props))},p}(h.Component);return d.WrappedComponent=t,d.displayName=c,d.childContextTypes=D,d.contextTypes=N,d.propTypes=N,p()(d,t)}}t.a=c;var l=n(612),p=n.n(l),d=n(613),f=n.n(d),h=n(2),m=(n.n(h),n(720)),g=n(291),v=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},b=0,y={}},function(e,t,n){"use strict";function r(e){return function(t,n){function r(){return i}var i=e(t,n);return r.dependsOnOwnProps=!1,r}}function i(e){return null!==e.dependsOnOwnProps&&void 0!==e.dependsOnOwnProps?Boolean(e.dependsOnOwnProps):1!==e.length}function o(e,t){return function(t,n){var r=function(e,t){return r.dependsOnOwnProps?r.mapToProps(e,t):r.mapToProps(e)};return r.dependsOnOwnProps=!0,r.mapToProps=function(t,n){r.mapToProps=e,r.dependsOnOwnProps=i(e);var o=r(t,n);return"function"==typeof o&&(r.mapToProps=o,r.dependsOnOwnProps=i(o),o=r(t,n)),o},r}}t.b=r,t.a=o;n(292)},function(e,t,n){"use strict";n.d(t,"b",function(){return o}),n.d(t,"a",function(){return a});var r=n(10),i=n.n(r),o=i.a.shape({trySubscribe:i.a.func.isRequired,tryUnsubscribe:i.a.func.isRequired,notifyNestedSubs:i.a.func.isRequired,isSubscribed:i.a.func.isRequired}),a=i.a.shape({subscribe:i.a.func.isRequired,dispatch:i.a.func.isRequired,getState:i.a.func.isRequired})},function(e,t,n){"use strict";n(172),n(189)},function(e,t,n){"use strict";function r(e){var t=Function.prototype.toString,n=Object.prototype.hasOwnProperty,r=RegExp("^"+t.call(n).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");try{return r.test(t.call(e))}catch(e){return!1}}function i(e){var t=c(e);if(t){var n=t.childIDs;l(e),n.forEach(i)}}function o(e,t,n){return"\n    in "+(e||"Unknown")+(t?" (at "+t.fileName.replace(/^.*[\\\/]/,"")+":"+t.lineNumber+")":n?" (created by "+n+")":"")}function a(e){return null==e?"#empty":"string"==typeof e||"number"==typeof e?"#text":"string"==typeof e.type?e.type:e.type.displayName||e.type.name||"Unknown"}function s(e){var t,n=T.getDisplayName(e),r=T.getElement(e),i=T.getOwnerID(e);return i&&(t=T.getDisplayName(i)),o(n,r&&r._source,t)}var u,c,l,p,d,f,h,m=n(92),g=n(56),v=(n(1),n(5),"function"==typeof Array.from&&"function"==typeof Map&&r(Map)&&null!=Map.prototype&&"function"==typeof Map.prototype.keys&&r(Map.prototype.keys)&&"function"==typeof Set&&r(Set)&&null!=Set.prototype&&"function"==typeof Set.prototype.keys&&r(Set.prototype.keys));if(v){var b=new Map,y=new Set;u=function(e,t){b.set(e,t)},c=function(e){return b.get(e)},l=function(e){b.delete(e)},p=function(){return Array.from(b.keys())},d=function(e){y.add(e)},f=function(e){y.delete(e)},h=function(){return Array.from(y.keys())}}else{var _={},w={},E=function(e){return"."+e},x=function(e){return parseInt(e.substr(1),10)};u=function(e,t){var n=E(e);_[n]=t},c=function(e){var t=E(e);return _[t]},l=function(e){var t=E(e);delete _[t]},p=function(){return Object.keys(_).map(x)},d=function(e){var t=E(e);w[t]=!0},f=function(e){var t=E(e);delete w[t]},h=function(){return Object.keys(w).map(x)}}var S=[],T={onSetChildren:function(e,t){var n=c(e);n||m("144"),n.childIDs=t;for(var r=0;r<t.length;r++){var i=t[r],o=c(i);o||m("140"),null==o.childIDs&&"object"==typeof o.element&&null!=o.element&&m("141"),o.isMounted||m("71"),null==o.parentID&&(o.parentID=e),o.parentID!==e&&m("142",i,o.parentID,e)}},onBeforeMountComponent:function(e,t,n){u(e,{element:t,parentID:n,text:null,childIDs:[],isMounted:!1,updateCount:0})},onBeforeUpdateComponent:function(e,t){var n=c(e);n&&n.isMounted&&(n.element=t)},onMountComponent:function(e){var t=c(e);t||m("144"),t.isMounted=!0,0===t.parentID&&d(e)},onUpdateComponent:function(e){var t=c(e);t&&t.isMounted&&t.updateCount++},onUnmountComponent:function(e){var t=c(e);if(t){t.isMounted=!1;0===t.parentID&&f(e)}S.push(e)},purgeUnmountedComponents:function(){if(!T._preventPurging){for(var e=0;e<S.length;e++){i(S[e])}S.length=0}},isMounted:function(e){var t=c(e);return!!t&&t.isMounted},getCurrentStackAddendum:function(e){var t="";if(e){var n=a(e),r=e._owner;t+=o(n,e._source,r&&r.getName())}var i=g.current;return t+=T.getStackAddendumByID(i&&i._debugID)},getStackAddendumByID:function(e){for(var t="";e;)t+=s(e),e=T.getParentID(e);return t},getChildIDs:function(e){var t=c(e);return t?t.childIDs:[]},getDisplayName:function(e){var t=T.getElement(e);return t?a(t):null},getElement:function(e){var t=c(e);return t?t.element:null},getOwnerID:function(e){var t=T.getElement(e);return t&&t._owner?t._owner._debugID:null},getParentID:function(e){var t=c(e);return t?t.parentID:null},getSource:function(e){var t=c(e),n=t?t.element:null;return null!=n?n._source:null},getText:function(e){var t=T.getElement(e);return"string"==typeof t?t:"number"==typeof t?""+t:null},getUpdateCount:function(e){var t=c(e);return t?t.updateCount:0},getRootIDs:h,getRegisteredIDs:p};e.exports=T},function(e,t,n){"use strict";e.exports="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103},function(e,t,n){"use strict";var r=!1;e.exports=r},function(e,t,n){"use strict";function r(){for(var e=arguments.length,t=Array(e),n=0;n<e;n++)t[n]=arguments[n];if(0===t.length)return function(e){return e};if(1===t.length)return t[0];var r=t[t.length-1],i=t.slice(0,-1);return function(){return i.reduceRight(function(e,t){return t(e)},r.apply(void 0,arguments))}}t.a=r},function(e,t,n){"use strict";function r(e,t,o){function u(){b===v&&(b=v.slice())}function c(){return g}function l(e){if("function"!=typeof e)throw new Error("Expected listener to be a function.");var t=!0;return u(),b.push(e),function(){if(t){t=!1,u();var n=b.indexOf(e);b.splice(n,1)}}}function p(e){if(!n.i(i.a)(e))throw new Error("Actions must be plain objects. Use custom middleware for async actions.");if(void 0===e.type)throw new Error('Actions may not have an undefined "type" property. Have you misspelled a constant?');if(y)throw new Error("Reducers may not dispatch actions.");try{y=!0,g=m(g,e)}finally{y=!1}for(var t=v=b,r=0;r<t.length;r++)t[r]();return e}function d(e){if("function"!=typeof e)throw new Error("Expected the nextReducer to be a function.");m=e,p({type:s.INIT})}function f(){var e,t=l;return e={subscribe:function(e){function n(){e.next&&e.next(c())}if("object"!=typeof e)throw new TypeError("Expected the observer to be an object.");return n(),{unsubscribe:t(n)}}},e[a.a]=function(){return this},e}var h;if("function"==typeof t&&void 0===o&&(o=t,t=void 0),void 0!==o){if("function"!=typeof o)throw new Error("Expected the enhancer to be a function.");return o(r)(e,t)}if("function"!=typeof e)throw new Error("Expected the reducer to be a function.");var m=e,g=t,v=[],b=v,y=!1;return p({type:s.INIT}),h={dispatch:p,subscribe:l,getState:c,replaceReducer:d},h[a.a]=f,h}n.d(t,"b",function(){return s}),t.a=r;var i=n(172),o=n(742),a=n.n(o),s={INIT:"@@redux/INIT"}},function(e,t,n){"use strict"},function(e,t,n){"use strict";var r=n(123),i=n(252),o=r.call(Function.call,String.prototype.slice);e.exports=function(e){var t,n=i.RequireObjectCoercible(this),r=i.ToString(n),a=i.ToLength(r.length);arguments.length>1&&(t=arguments[1]);var s=void 0===t?"":i.ToString(t);""===s&&(s=" ");var u=i.ToLength(e);if(u<=a)return r;for(var c=u-a;s.length<c;){var l=s.length,p=c-l;s+=l>p?o(s,0,p):s}return(s.length>c?o(s,0,c):s)+r}},function(e,t,n){"use strict";var r=n(299);e.exports=function(){return"function"==typeof String.prototype.padStart?String.prototype.padStart:r}},function(e,t,n){"use strict";(function(e){function t(e,t,n){e[t]||Object[r](e,t,{writable:!0,configurable:!0,value:n})}if(n(586),n(739),n(406),e._babelPolyfill)throw new Error("only one instance of babel-polyfill is allowed");e._babelPolyfill=!0;var r="defineProperty";t(String.prototype,"padLeft","".padStart),t(String.prototype,"padRight","".padEnd),"pop,reverse,shift,keys,values,entries,indexOf,every,some,forEach,map,filter,find,findIndex,includes,join,slice,concat,push,splice,unshift,sort,lastIndexOf,reduce,reduceRight,copyWithin,fill".split(",").forEach(function(e){[][e]&&t(Array,e,Function.call.bind([][e]))})}).call(t,n(34))},function(e,t,n){function r(){}var i=n(625),o=n(626),a=n(171);t.create=function(e){function t(){return(new Date).getTime()-v}function n(){if(!y){y=!0,a.log("ads","widget",h.trackingKey,"unfilled"),clearTimeout(g),m.adUnfilled(t());try{h.callbacks.onAdUnfilled()}catch(e){throw a.log("ads","widget","ad callback onAdUnfilled threw an error",e),e}}}function s(){a.log("ads","widget",h.trackingKey,"failed"),clearTimeout(g),m.adFailed(t());try{h.callbacks.onAdFailed()}catch(e){throw a.log("ads","widget","ad callback onAdFailed threw an error",e),e}}function u(){return b===!0||y===!0||_===!0}function c(){a.log("ads","widget",h.trackingKey,"timeout"),u()===!1&&(m.adTimeout(t()),s())}function l(){if(!_){_=!0,a.log("ads","widget",h.trackingKey,"viewable"),clearTimeout(g),m.adViewable(t());try{h.callbacks.onAdViewable()}catch(e){throw a.log("ads","widget","ad callback onAdViewable threw an error",e),e}}}function p(){if(!b){b=!0,a.log("ads","widget",h.trackingKey,"filled"),clearTimeout(g),m.adLoaded(t());try{h.callbacks.onAdFilled()}catch(e){throw a.log("ads","widget","ad callback onAdFilled threw an error",e),e}}}function d(){i.create({rootElm:h.rootElm,config:h.adProviderConfig,callbacks:{onAdFilled:p,onAdFailed:s,onAdViewable:l,onAdUnfilled:n},targeting:h.dfpTargeting}),m.adRequested(t()),a.log("ads","widget",h.trackingKey,"requested")}function f(){v=(new Date).getTime(),g=setTimeout(c,1e4),d()}var h,m,g,v,b=!1,y=!1,_=!1;return function(){h=e||{},h=Object.assign({},{adProviderConfig:{},dfpTargeting:[],isProductionEnv:!0,trackingKey:"",callbacks:{onAdFilled:r,onAdFailed:r,onAdViewable:r,onAdUnfilled:r}},h),m=o.create({trackingKey:h.trackingKey,isProductionEnv:h.isProductionEnv})}(),{show:f}}},function(e,t,n){(function(t){(function(){var n,r,i;"undefined"!=typeof performance&&null!==performance&&performance.now?e.exports=function(){return performance.now()}:void 0!==t&&null!==t&&t.hrtime?(e.exports=function(){return(n()-i)/1e6},r=t.hrtime,n=function(){var e;return e=r(),1e9*e[0]+e[1]},i=n()):Date.now?(e.exports=function(){return Date.now()-i},i=Date.now()):(e.exports=function(){return(new Date).getTime()-i},i=(new Date).getTime())}).call(this)}).call(t,n(106))},function(e,t,n){(function(t){for(var r=n(303),i="undefined"==typeof window?t:window,o=["moz","webkit"],a="AnimationFrame",s=i["request"+a],u=i["cancel"+a]||i["cancelRequest"+a],c=0;!s&&c<o.length;c++)s=i[o[c]+"Request"+a],u=i[o[c]+"Cancel"+a]||i[o[c]+"CancelRequest"+a];if(!s||!u){var l=0,p=0,d=[];s=function(e){if(0===d.length){var t=r(),n=Math.max(0,1e3/60-(t-l));l=n+t,setTimeout(function(){var e=d.slice(0);d.length=0;for(var t=0;t<e.length;t++)if(!e[t].cancelled)try{e[t].callback(l)}catch(e){setTimeout(function(){throw e},0)}},Math.round(n))}return d.push({handle:++p,callback:e,cancelled:!1}),p},u=function(e){for(var t=0;t<d.length;t++)d[t].handle===e&&(d[t].cancelled=!0)}}e.exports=function(e){return s.call(i,e)},e.exports.cancel=function(){u.apply(i,arguments)},e.exports.polyfill=function(){i.requestAnimationFrame=s,i.cancelAnimationFrame=u}}).call(t,n(34))},function(e,t,n){"use strict";n.d(t,"a",function(){return c});var r=n(2),i=n.n(r),o=n(21),a=n.n(o),s=n(405),u=n.n(s),c=function(e){function t(n){babelHelpers.classCallCheck(this,t);var r=babelHelpers.possibleConstructorReturn(this,e.call(this,n));return r.onClick=r.onClick.bind(r),r}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.props.featureTracker.opportunity("BUTTON_OPEN_FIND")},t.prototype.onClick=function(){this.props.featureTracker.usage("BUTTON_OPEN_FIND"),this.props.onClick()},t.prototype.render=function(){var e=this.props.findAvailable,t=e?"Find":"Find is not available";return i.a.createElement("div",{className:a()("controls__find-button",{"controls__find-button--disabled":!e}),"data-tooltip":t},i.a.createElement("button",{type:"button",className:a()("find-button svg-btn",{"svg-btn--disabled":!e}),onClick:this.onClick,dangerouslySetInnerHTML:{__html:u.a},disabled:!e}))},t}(r.Component)},function(e,t,n){"use strict";n.d(t,"a",function(){return f});var r=n(2),i=n.n(r),o=n(21),a=n.n(o),s=n(404),u=n.n(s),c=n(403),l=n.n(c),p=n(402),d=n.n(p),f=function(e){function t(n){babelHelpers.classCallCheck(this,t);var r=babelHelpers.possibleConstructorReturn(this,e.call(this,n));return r.state={timerId:null},r.handleKeyDown=r.handleKeyDown.bind(r),r.next=r.next.bind(r),r.previous=r.previous.bind(r),r.close=r.close.bind(r),r.handleInputChange=r.handleInputChange.bind(r),r.handleInputBlur=r.handleInputBlur.bind(r),r}return babelHelpers.inherits(t,e),t.prototype.handleVisibilityChanged=function(e,t){!e&&t?(this.refs.input.focus(),this.props.featureTracker.opportunity("FIND_QUERY"),this.props.featureTracker.opportunity("FIND_NEXT"),this.props.featureTracker.opportunity("FIND_PREV"),this.props.featureTracker.opportunity("FIND_CLOSE"),this.props.featureTracker.opportunity("FIND_CLOSE_BLUR")):!t&&e&&this.refs.input.blur()},t.prototype.componentDidMount=function(){this.handleVisibilityChanged(!1,this.props.isVisible)},t.prototype.componentDidUpdate=function(e,t){this.handleVisibilityChanged(e.isVisible,this.props.isVisible)},t.prototype.handleKeyDown=function(e){var t="MacIntel"===window.navigator.platform;if(71===e.keyCode&&t&&e.metaKey||!t&&e.ctrlKey)e.preventDefault(),e.shiftKey?this.previous():this.next();else if("Enter"===e.key&&(e.preventDefault(),this.props.isNewQuery?(clearTimeout(this.state.timerId),this.search(this.props.inputFieldValue)):e.shiftKey?this.previous():this.next(),this.props.isMobile)){var n=e.target;n.blur()}},t.prototype.handleInputChange=function(e){var t=this;clearTimeout(this.state.timerId),this.props.inputFieldChanged(e);var n=null;this.props.enableIncrementalSearch&&(n=setTimeout(function(){t.search(t.props.inputFieldValue)},500)),this.setState({timerId:n})},t.prototype.handleInputBlur=function(e){this.props.inputFieldValue||(this.props.featureTracker.usage("FIND_CLOSE_BLUR"),this.props.onCloseButtonClick())},t.prototype.next=function(){this.props.featureTracker.usage("FIND_NEXT"),this.props.onNextButtonClick()},t.prototype.previous=function(){this.props.featureTracker.usage("FIND_PREV"),this.props.onPreviousButtonClick()},t.prototype.search=function(e){this.props.featureTracker.usage("FIND_QUERY"),this.props.onSearch(e,this.props.currentPage)},t.prototype.close=function(){this.props.featureTracker.usage("FIND_CLOSE"),this.props.onCloseButtonClick()},t.prototype.render=function(){var e=this.props,t=e.isVisible,n=e.currentResult,r=e.numberOfResults,o=e.isMobile,s=e.Spinner,c=e.inputFieldValue,p=e.isLoading,f=e.onRetryClick;return i.a.createElement("div",{className:a()("find-widget",{"find-widget--hidden":!t})},i.a.createElement("button",{className:"find-widget__button find-widget__close-button",type:"button",dangerouslySetInnerHTML:{__html:u.a},onClick:this.close}),i.a.createElement("form",{className:"find-widget__input-wrapper",action:"javascript:void(0)"},i.a.createElement("input",{className:a()("find-widget__input",{"find-widget__input--large-font":o}),ref:"input",type:"search",onKeyDown:this.handleKeyDown,placeholder:"Find in publication...",value:c,onChange:this.handleInputChange,onBlur:this.handleInputBlur}),i.a.createElement("div",{className:"find-widget__results-wrapper"},"READY"===p&&"number"==typeof r&&i.a.createElement("span",{className:"find-widget__results"},n," of ",r),"FAILED"===p&&i.a.createElement("button",{type:"button",onClick:f,className:"find-widget__retry-button"},"retry"),"LOADING"===p&&i.a.createElement(s,{size:s.SPINNER_SIZE_TINY}))),i.a.createElement("button",{className:a()("find-widget__button","find-widget__previous-button",{"find-widget__button--disabled":!r}),dangerouslySetInnerHTML:{__html:d.a},type:"button",onKeyDown:this.handleKeyDown,onClick:this.previous,disabled:!r}),i.a.createElement("button",{className:a()("find-widget__button","find-widget__next-button",{"find-widget__button--disabled":!r}),dangerouslySetInnerHTML:{__html:l.a},type:"button",onKeyDown:this.handleKeyDown,onClick:this.next,disabled:!r}),"FAILED"===p&&i.a.createElement("span",{className:"find-widget__error-message"},"Oops, something went wrong"))},t}(i.a.Component)},function(e,t,n){"use strict";function r(e){function t(e){return function(){for(var t=arguments.length,r=Array(t),i=0;i<t;i++)r[i]=arguments[i];return function(t,i){return t(e.apply(void 0,r)).then(function(){var e=i(),t=n.i(c.a)(e);t&&l(e,t.pageNo)})}}}var r=e.enableWebGL,l=e.jumpToPageNumber,p=e.pageNumberToSpreadIndex,d=e.resetZoom,f=e.selectCurrentPage,h=e.selectReadMode,m=e.selectSpreadCount,g=e.isMobile,v=e.Spinner,b=n.i(c.b)(u.a),y=t(b),_=t(c.c),w=function(){return function(e,t){return e(n.i(c.d)()).then(function(r){return e(y(n.i(c.e)(t()),f(t())))}),e(r()),d(t()),Promise.resolve()}},E=function(){return function(e,t){return e(y(n.i(c.e)(t()),f(t())))}},x=n.i(i.b)(function(e){return{isVisible:n.i(c.f)(e),findAvailable:n.i(c.g)(e)}},{closeFindDialog:c.h,openFindDialog:w},function(e,t,n){return Object.assign({},n,e,{onClick:e.isVisible?t.closeFindDialog:t.openFindDialog,findAvailable:e.findAvailable})})(a.a),S=function(e){return{isMobile:g,isVisible:n.i(c.f)(e),currentResult:n.i(c.i)(e),numberOfResults:n.i(c.j)(e),currentPage:f(e),nextResultIdx:n.i(c.k)(e),previousResultIdx:n.i(c.l)(e),inputFieldValue:n.i(c.m)(e),isLoading:n.i(c.n)(e),isNewQuery:n.i(c.o)(e),Spinner:v}},T={onCloseButtonClick:c.h,onSearch:y,setCurrentResultIdx:_,triggerLoadTextInfo:E,inputFieldChanged:c.p},C=function(e,t,n){return Object.assign({},n,e,t,{onNextButtonClick:function(){return t.setCurrentResultIdx(e.nextResultIdx)},onPreviousButtonClick:function(){return t.setCurrentResultIdx(e.previousResultIdx)},onRetryClick:t.triggerLoadTextInfo})},I=n.i(i.b)(S,T,C)(o.a);return{actions:{setTextInfoUrl:c.q,openFindDialog:w,closeFindDialog:c.h},components:{FindOverlay:I,FindButton:x,SliderMarkers:s.a},createReducer:c.r,selectors:{isVisible:c.f,selectResults:c.s,selectCurrentResult:c.a,selectTextInfoPageModels:c.t,selectIsAvailable:c.g,selectResultMarkers:n.i(c.u)(c.f,m,h,p)}}}t.a=r;var i=n(47),o=n(306),a=n(305),s=n(308),u=n(107),c=n(309)},function(e,t,n){"use strict";n.d(t,"a",function(){return s});var r=n(2),i=n.n(r),o=n(57),a=n.n(o),s=function(e){function t(n){babelHelpers.classCallCheck(this,t);var r=babelHelpers.possibleConstructorReturn(this,e.call(this,n));return r.redraw=r.redraw.bind(r),r.resize=r.resize.bind(r),r}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){window.addEventListener("resize",this.resize),requestAnimationFrame(this.redraw)},t.prototype.shouldComponentUpdate=function(e){return!a()(this.props,e)},t.prototype.componentDidUpdate=function(e){requestAnimationFrame(this.redraw)},t.prototype.componentWillUnmount=function(){window.removeEventListener("resize",this.resize)},t.prototype.resize=function(){requestAnimationFrame(this.redraw)},t.prototype.redraw=function(){var e=this.props.markers,t=this.refs.canvas;if(t){var n=t.getContext("2d");if(n){var r=t.width=t.clientWidth;n.clearRect(0,0,r,1),n.fillStyle="yellow",e.forEach(function(e){n.fillRect(Math.round(e*(r-1)),0,1,1)})}}},t.prototype.render=function(){return i.a.createElement("canvas",{ref:"canvas",className:"slider-markers",height:1})},t}(r.Component)},function(e,t,n){"use strict";function r(){return function(e,t){var n=t().find,r=n.textInfoUrl,i=n.loadTextInfo;if(!r)throw new Error("attempting to find with textInfoUrl unset!");return e({type:"FIND_SET_TEXT_INFO_REQUESTED"}),i("//"+r).then(function(t){return e({type:"FIND_SET_TEXT_INFO",textInfo:t})}).catch(function(t){return e({type:"FIND_SET_TEXT_INFO_FAILED"})})}}function i(){return function(e,t){switch(t().find.textInfo){case"INITIAL":case"FAILED":return e(r());default:return Promise.resolve()}}}function o(){return function(e,t){return e({type:"FIND_OPEN_DIALOG"}),e(i()),Promise.resolve()}}function a(){return{type:"FIND_CLOSE_DIALOG"}}function s(e){return function(t,n){return Promise.resolve(t({type:"FIND_SET_CURRENT_RESULT",idx:e}))}}function u(e){if(e.target instanceof HTMLInputElement)return{type:"FIND_SET_INPUT_VALUE",value:e.target.value};throw new Error("type mismatch. Excpected input element!")}function c(e){return function(t,n){return function(r,o){return r({type:"FIND_SET_LATEST_QUERY",value:t}),r(i()).then(function(i){var a=o().find.textInfo;if(t&&a instanceof Object){var s=e(t,a),u=s.findIndex(function(e){return e.pageNo>=n});return r({type:"FIND_SET_RESULTS",results:s,currentResultIdx:u<0?s.length-1:u})}return r({type:"FIND_SET_RESULTS",results:null,currentResultIdx:null})})}}}function l(e,t){return{type:"FIND_SET_TEXT_INFO_URL",url:e,version:t}}function p(e){return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:b,n=arguments[1];switch(n.type){case"FIND_OPEN_DIALOG":return Object.assign({},t,{isVisible:!0});case"FIND_CLOSE_DIALOG":return Object.assign({},t,{isVisible:!1});case"FIND_SET_TEXT_INFO_URL":return Object.assign({},t,{textInfoUrl:n.url,version:n.version});case"FIND_SET_TEXT_INFO_REQUESTED":return Object.assign({},t,{textInfo:"REQUESTED"});case"FIND_SET_TEXT_INFO_FAILED":return Object.assign({},t,{textInfo:"FAILED"});case"FIND_SET_TEXT_INFO":return Object.assign({},t,{textInfo:n.textInfo});case"FIND_SET_RESULTS":return Object.assign({},t,{results:n.results,currentResultIdx:n.currentResultIdx});case"FIND_SET_CURRENT_RESULT":return Object.assign({},t,{currentResultIdx:n.idx});case"FIND_SET_INPUT_VALUE":return Object.assign({},t,{inputFieldValue:n.value});case"FIND_SET_LATEST_QUERY":return Object.assign({},t,{latestQuery:n.value});case e:if(t.results){var r=n.currentPageNumber,i=t.results.findIndex(function(e){return e.pageNo>=r});return Object.assign({},t,{currentResultIdx:i<0?t.currentResultIdx:i})}return t;default:return t}}}function d(e){return!_(e)||"REQUESTED"!==e.find.textInfo&&"INITIAL"!==e.find.textInfo?"FAILED"===e.find.textInfo?"FAILED":"READY":"LOADING"}function f(e){var t=e.find.textInfo;return t instanceof Object?t.pages.map(function(e){return{width:e.width,height:e.height,pageNumber:e.pageNumber}}):[]}function h(e){var t=e.find;return t.latestQuery!==t.inputFieldValue}function m(e,t,r,i){return n.i(g.createSelector)(e,t,r,w,function(e,t,n,r){if(!e||!n)return[];var o=r.reduce(function(e,t){return e.add(i(n,t.pageNo))},new Set);return Array.from(o).map(function(e){return e*(1/t)})})}t.d=o,t.h=a,t.c=s,t.p=u,t.b=c,t.q=l,t.r=p,n.d(t,"f",function(){return y}),n.d(t,"e",function(){return _}),t.n=d,n.d(t,"s",function(){return w}),n.d(t,"j",function(){return E}),n.d(t,"i",function(){return x}),n.d(t,"k",function(){return T}),n.d(t,"l",function(){return C}),n.d(t,"a",function(){return I}),n.d(t,"m",function(){return M}),t.t=f,t.o=h,n.d(t,"g",function(){return P}),t.u=m;var g=n(33),v=(n.n(g),n(107)),b={isVisible:!1,results:null,textInfoUrl:null,version:null,currentResultIdx:null,inputFieldValue:"",latestQuery:"",textInfo:"INITIAL",loadTextInfo:v.b},y=function(e){return e.find.isVisible},_=function(e){return e.find.latestQuery},w=n.i(g.createSelector)(function(e){return e.find.results},function(e){return e||[]}),E=function(e){return Array.isArray(e.find.results)?e.find.results.length:null},x=function(e){return"number"==typeof e.find.currentResultIdx?e.find.currentResultIdx+1:0},S=n.i(g.createSelector)(x,function(e){return e-1}),T=n.i(g.createSelector)(w,S,function(e,t){return e.length?(t+1)%e.length:t}),C=n.i(g.createSelector)(w,S,function(e,t){return e.length?(t+e.length-1)%e.length:t}),I=n.i(g.createSelector)(w,S,function(e,t){return e[t]}),M=function(e){return e.find.inputFieldValue},P=(n.i(g.createSelector)(w,T,function(e,t){return e[t]}),n.i(g.createSelector)(w,C,function(e,t){return e[t]}),function(e){return!!e.find.textInfoUrl})},function(e,t,n){"use strict";function r(e){var t=e.onKeepReading,r=e.selectCurrentPageNumbers,u=e.selectHostName,c=e.selectPublicationCoverUrl,l=e.selectPublicationName,p=e.selectPublicationPageCount,d=e.selectPublicationTitle,f=e.selectPublisherDisplayName,h=e.selectPublisherName,m=e.selectPublisherProfileImageUrl,g=e.selectPublisherProfileUrl,v=e.actionTypes,b=n.i(s.a)(r,p),y=function(e){return{hostName:u(e),price:e.paywall.publicationPrice,publicationName:l(e),publisherName:h(e)}},_=function(e){return{hostName:u(e),price:e.paywall.publicationPrice,publicationCoverUrl:c(e),publicationName:l(e),publicationTitle:d(e),publisherDisplayName:f(e),publisherName:h(e),publisherProfileImageUrl:m(e),publisherProfileUrl:g(e),showKeepReading:b(e)}},w=function(e){return{onKeepReading:n.i(o.d)(t,e)}},E={pure:!0},x={PaywallButton:n.i(i.b)(y,void 0,void 0,E)(a.a),PaywallOverlay:n.i(i.b)(_,w,void 0,E)(a.b)},S={publicationLoaded:s.b},T=n.i(s.c)(r),C={isPreview:s.d,previewPages:s.e,isVisible:T},I=function(){return s.f},M={overlayDisplayed:!1,paywalledDocumentDisplayed:!1},P=v.READER_POSITION_CHANGED;return{actions:S,components:x,createReducer:I,createMiddleware:function(e){return function(t){return function(r){return function(i){var o=r(i);if(!M.paywalledDocumentDisplayed&&i){var a=t.getState();n.i(s.d)(a)&&(e.monitorBatched({type:"paywall.reader3.show-document"}),M.paywalledDocumentDisplayed=!0)}if(!M.overlayDisplayed&&i&&i.type===P){var u=t.getState();n.i(s.d)(u)&&T(u)&&(e.monitorBatched({type:"paywall.reader3.show-overlay"}),M.overlayDisplayed=!0)}return o}}}},selectors:C}}t.a=r;var i=n(47),o=n(192),a=n(624),s=n(311)},function(e,t,n){"use strict";function r(e){return{type:o,document:e}}t.b=r,n.d(t,"f",function(){return s}),n.d(t,"e",function(){return u}),n.d(t,"d",function(){return c}),n.d(t,"c",function(){return l}),n.d(t,"a",function(){return d});var i=n(33),o=(n.n(i),Symbol("PAYWALL_PUBLICATION_LOADED")),a=function(){return{isPayWall:!1,isPaid:!1,listPayWallPages:[],publicationPrice:0}},s=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:a(),t=arguments[1];switch(t.type){case o:var n=t.document||{},r=n.pages||[],i=r.filter(function(e){return e&&e.isPaywalledPage}).map(function(e){return e.pageNumber}).sort(function(e,t){return e-t});return Object.assign({},e,{isPayWall:!!n.isPaywalled,isPaid:!!n.paywallInfo.currentUserPurchased,publicationPrice:n.paywallInfo.price,listPayWallPages:i});default:return e}},u=function(e){return e.paywall.listPayWallPages},c=function(e){return e.paywall.isPayWall&&!e.paywall.isPaid},l=function(e){return n.i(i.createSelector)(c,e,u,function(e,t,n){return e&&t.reduce(function(e,t){return e||n.includes(t)},!1)})},p=function(e,t){for(var n=e;n>0;n--)if(!t.includes(n))return n;return 0},d=function(e,t){return n.i(i.createSelector)(e,t,u,function(e,t,n){return p(t,n)>e[e.length-1]})}},function(e,t,n){"use strict";function r(e,t,n){var r=s.vec2.create(),i=s.vec2.create();return s.vec2.set(r,t,n),s.vec2.transformMat2d(i,r,e),{x:i[0],y:i[1]}}function i(e,t){var n=s.mat2d.create();return s.mat2d.multiply(n,t,e.matrix),{p1:r(n,e.x,e.y),p2:r(n,e.x+e.width,e.y),p3:r(n,e.x,e.y+e.height),p4:r(n,e.x+e.width,e.y+e.height)}}n.d(t,"a",function(){return h});var o=n(48),a=n(75),s=n(101),u=(n.n(s),n(218),n(42)),c=n(199),l=n(131),p=n(200),d=n(57),f=n.n(d),h=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var i=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return i._lastActionTick=0,i}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(e){f()(e.selectedResult,this.props.selectedResult)||(this._lastActionTick=this.props.selectedResult?this.root.tick:0)},t.prototype.isAnimating=function(e){return e-500<this._lastActionTick},t.prototype.draw=function(e,t,r){var i=n.i(c.d)(t,this.parent.pageType),o=this.getViewportCTM().matrix;if(e.save(),this.selectedResult){e.fillStyle="rgba(255, 255, 0, 0.5)";for(var a=this.selectedResult,s=Array.isArray(a),u=0,a=s?a:a[Symbol.iterator]();;){var l;if(s){if(u>=a.length)break;l=a[u++]}else{if(u=a.next(),u.done)break;l=u.value}var p=l,d=p.matrix;e.setTransform(o[0],o[1],o[2],o[3],o[4],o[5]),e.transform(d[0],d[1],d[2],d[3],d[4],d[5]),e.fillRect(p.x,p.y,p.width,p.height)}}for(var f=this.results,h=Array.isArray(f),m=0,f=h?f:f[Symbol.iterator]();;){var g;if(h){if(m>=f.length)break;g=f[m++]}else{if(m=f.next(),m.done)break;g=m.value}for(var v=g,b=v,y=Array.isArray(b),_=0,b=y?b:b[Symbol.iterator]();;){var w;if(y){if(_>=b.length)break;w=b[_++]}else{if(_=b.next(),_.done)break;w=_.value}var E=w;e.beginPath(),e.setTransform(1,0,0,1,0,0),e.rect(i.x,i.y,i.width,i.height);var x=E.matrix;e.setTransform(o[0],o[1],o[2],o[3],o[4],o[5]),e.transform(x[0],x[1],x[2],x[3],x[4],x[5]),e.rect(E.x,E.y,E.width,E.height),e.clip("evenodd")}}e.setTransform(1,0,0,1,0,0),e.fillStyle="rgba(0, 0, 0, 0.3)",e.fillRect(i.x,i.y,i.width,i.height),e.restore()},t.prototype.appendWebglOps=function(e,t,r,a){for(var s=n.i(c.d)(t,this.parent.pageType),u=this.getViewportCTM().matrix,d=this.transform.matrix,f=this.model.pageNumber,h=[],m=this.results,g=Array.isArray(m),v=0,m=g?m:m[Symbol.iterator]();;){var b;if(g){if(v>=m.length)break;b=m[v++]}else{if(v=m.next(),v.done)break;b=v.value}for(var y=b,_=y,w=Array.isArray(_),E=0,_=w?_:_[Symbol.iterator]();;){var x;if(w){if(E>=_.length)break;x=_[E++]}else{if(E=_.next(),E.done)break;x=E.value}h.push(i(x,u))}}var S=this.selectedResult,T=[],C=[];if(S)for(var I=S,M=Array.isArray(I),P=0,I=M?I:I[Symbol.iterator]();;){var R;if(M){if(P>=I.length)break;R=I[P++]}else{if(P=I.next(),P.done)break;R=P.value}var O=R,k=i(O,u),A=n.i(p.a)(k);if(T.push(k),this.isAnimating(a)){var N=i(O,d),D=n.i(p.a)(N),L=null;if(D.max.x-D.min.x>=1&&D.max.y-D.min.y>=1){var F=(A.max.x-A.min.x+40)/(D.max.x-D.min.x);L=this.props.renderManager.renderUncached([F,0,0,F,D.min.x*F*-1,D.min.y*F*-1],(D.max.x-D.min.x)*F,(D.max.y-D.min.y)*F,f)}C.push(L)}}if(e.push({type:o.c,args:[s,h]}),T.length){var U=T.reduce(function(e,t){var r=n.i(p.a)(t);return e.left=Math.min(r.min.x,e.left),e.top=Math.min(r.min.y,e.top),e.right=Math.max(r.max.x,e.right),e.bottom=Math.max(r.max.y,e.bottom),e},{left:1/0,top:1/0,right:-(1/0),bottom:-(1/0)}),B=Math.max(U.right-U.left,U.bottom-U.top),H=(a-this._lastActionTick)/500,j=H<.5?(B+n.i(l.a)(0,40,2*H))/B:(B+n.i(l.b)(40,0,2*(H-.5)))/B;e.push({type:o.d,args:[T,C,{x:(U.left+U.right)/2,y:(U.top+U.bottom)/2},j]})}},t.prototype.afterDraw=function(e,t){this.isAnimating(t)&&this.requestRedraw()},babelHelpers.createClass(t,[{key:"isVisible",get:function(){return!!this.model&&u.a.isVisible(this.root.__store__.getState())}},{key:"width",get:function(){return this.model?this.model.width:0}},{key:"height",get:function(){return this.model?this.model.height:0}},{key:"results",get:function(){return this.props.results}},{key:"selectedResult",get:function(){return this.props.selectedResult}},{key:"model",get:function(){return this.props.model}},{key:"transform",get:function(){return this._transform||(this._transform=new a.a),this.width&&this.height&&this._transform.mSet(this.parent.width/this.width,0,0,this.parent.height/this.height,0,0),this._transform}}]),t}(o.a)},function(e,t,n){"use strict";n.d(t,"a",function(){return h});var r=n(75),i=n(48),o=n(201),a=n(213),s=n(8),u=n(78),c=n(80),l=n(35),p=n(20),d=n(40),f=n(58),h=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var i=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return i._isSnapped=!0,i._scrollerMovedLastFrame=!1,i._lastVisiblePages="",i._lastPositionInPercent=0,i._spreadIndexBeforeGestureStart=0,i.scroller=new a.a(0,0,1,i.props.viewportWidth,i.props.viewportHeight,i.width,i.height),i._lastCenterSpreadIndex=i.props.currentSpreadIndex,i}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.scroller.resize(0,0,1,this.props.viewportWidth,this.props.viewportHeight,this.width,this.height),this.scroller.setSnap(!0,function(t,n,r){var o=e.getSpreadIndexAt(n+e.props.viewportWidth/2),a=e.children[o].unzoomedBBox,s=a.x-e.xMargin;return i.a.RectPool.release(a),{left:s,top:0,zoom:1}},!1);var t=this.props.currentSpreadIndex,n=this.children[t].unzoomedBBox;this.scroller.jumpTo(0,n.x-this.xMargin,1),i.a.RectPool.release(n),this.props.featureTracker.opportunity(p.b.DOUBLE_TAP_ZOOM),this.props.featureTracker.opportunity(p.b.GESTURE_PINCH_ZOOM),this.props.canChangePages&&this.props.featureTracker.opportunity(p.b.GESTURE_DRAG_PAGES)},t.prototype.componentDidUpdate=function(e){if(this.props.viewportWidth!==e.viewportWidth||this.props.viewportHeight!==e.viewportHeight){var t=this.children[this._lastCenterSpreadIndex],n=t.unzoomedBBox;this.scroller.resize(0,n.x-this.xMargin,1,this.props.viewportWidth,this.props.viewportHeight,this.width,this.height),i.a.RectPool.release(n)}},t.prototype.getChildrenToTraverse=function(){var e=this.getSpreadIndexAt(this.scroller.left),t=this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth-1);return this.children.slice(Math.max(e,0),Math.min(t,this.children.length-1)+1)},t.prototype.onGestureStart=function(e,t,n,r,i){return this._spreadIndexBeforeGestureStart=this.props.currentSpreadIndex,this.scroller.touchStart(e,t,i),1===r.length},t.prototype.onGestureChange=function(e,t,n,r,i,o,a){return(a===u.a||a===u.b)&&1===r.length&&(this.scroller.touchMove(e,t,i,o),this.requestRedraw(),!0)},t.prototype.onGestureEnd=function(e,t){return this.scroller.touchEnd(t,e),this.props.currentSpreadIndex!==this._spreadIndexBeforeGestureStart&&this.props.featureTracker.usage(p.b.GESTURE_DRAG_PAGES),this.scroller.isMoving&&this.requestRedraw(),!0},t.prototype.onSingleTapConfirmed=function(e,t,n,r){var i=this.getCurrentSpread(),o=i.children[0].viewportBBox;if(i.children.length>1){var a=i.children[1].viewportBBox;o.width+=a.width,o.height=Math.max(o.height,a.height),o.y=Math.min(o.y,a.y)}if(t>o.y&&t<o.y+o.height){var s=this.children.indexOf(i);if(e<o.x)return this.goToSpread(s-1,n),!0;if(e>o.x+o.width)return this.goToSpread(s+1,n),!0}return!1},t.prototype.getCurrentSpreadIndex=function(){return this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth/2)},t.prototype.getCurrentSpread=function(){return this.children[this.getCurrentSpreadIndex()]},t.prototype.getVisiblePages=function(){for(var e=[],t=Math.max(this.getSpreadIndexAt(this.scroller.left),0),r=this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth-1),o=i.a.RectPool.get(0,0,this.props.viewportWidth,this.props.viewportHeight),a=t;a<=r;a++)for(var s=this.children[a],u=s.children,l=Array.isArray(u),p=0,u=l?u:u[Symbol.iterator]();;){var d;if(l){if(p>=u.length)break;d=u[p++]}else{if(p=u.next(),p.done)break;d=p.value}var f=d,h=f.viewportBBox;n.i(c.b)(o,h)&&e.push(f.model),i.a.RectPool.release(h)}return i.a.RectPool.release(o),e},t.prototype.setSnapping=function(e,t){this.scroller.setSnap(e,null,!0,t),this.requestRedraw()},t.prototype.jumpToPositionByPercent=function(e,t){this.getCurrentSpread().setZoom(1),this.scroller.jumpTo(0,e*(this.width-this.props.viewportWidth)/100),this.requestRedraw()},t.prototype.goToSpread=function(e,t){if(this.getCurrentSpreadIndex()!==e){this.getCurrentSpread().setZoom(1);var n=Math.max(Math.min(e,this.children.length-1),0),r=this.children[n].unzoomedBBox;this.scroller.scrollTo(0,r.x-this.xMargin,1,t),i.a.RectPool.release(r),this.requestRedraw()}},t.prototype.jumpToSpread=function(e,t){if(this.getCurrentSpreadIndex()!==e){this.getCurrentSpread().setZoom(1);var n=Math.max(Math.min(e,this.children.length-1),0),r=this.children[n].unzoomedBBox;this.scroller.jumpTo(0,r.x-this.xMargin,1),i.a.RectPool.release(r),this.requestRedraw()}},t.prototype.getSpreadIndexAt=function(e){var t=Math.floor((e-this.xMargin)/(this.props.viewportWidth-this.xMargin-this.xOverlap));return Math.min(Math.max(t,0),this.children.length-1)},t.prototype.getChildTree=function(){var e=this;return this.props.documentPageSpreadList.map(function(t,n){var a=(e.props.viewportWidth-e.xMargin-e.xOverlap)*n+e.xMargin,s=new r.a;return s.mTranslate(a,e.yMargin),i.a.createElement(o.a,{dispatch:e.props.dispatch,featureTracker:e.props.featureTracker,height:e.props.viewportHeight-2*e.yMargin,hideLinkToolTip:e.props.hideLinkToolTip,isCurrentSpread:n===e.props.currentSpreadIndex,isLinksToggledOn:e.props.isLinksToggledOn,isSnapped:e._isSnapped,mayRenderLinks:e.props.mayRenderLinks,pageModels:t.pages?t.pages:[t],paywalledPageStatus:t.pages?t.pages.map(function(t){return e.props.paywalledPageNumbers.includes(t.pageNumber)}):[e.props.paywalledPageNumbers.includes(t.pageNumber)],readMode:e.props.readMode,showLinkToolTip:e.props.showLinkToolTip,transform:s,width:e.props.viewportWidth-2*e.xMargin,renderManager:e.props.renderManager})})},t.prototype.afterDraw=function(e,t){var n=this.scroller.isDragging||this.scroller.isAnimating||this.scroller.isMoving;this.scroller.update(t);var r=this.scroller.isDragging||this.scroller.isAnimating||this.scroller.isMoving;(r||n)&&(this._isSnapped?(this._isSnapped=!1,this.forceUpdate()):this.requestRedraw()),r||!this.scroller.isSnapped()||this._isSnapped?this._isSnapped||this.requestRedraw():(this._isSnapped=!0,this.forceUpdate()),!this._scrollerMovedLastFrame&&r?this.props.onAnimationStart():this._scrollerMovedLastFrame&&!r&&this.props.onAnimationEnd(),this._scrollerMovedLastFrame=r,this.getCurrentSpreadIndex()!==this.props.currentSpreadIndex&&this.props.onSpreadChange(this.getCurrentSpreadIndex());var i=this.getVisiblePages(),o=i.map(function(e){return e.pageNumber}).join()!==this._lastVisiblePages;this._lastVisiblePages=i.map(function(e){return e.pageNumber}).join();var a=this.getSpreadIndexAt(this.scroller.left+this.props.viewportWidth/2),u=this._lastCenterSpreadIndex!==a,c=this.children[a].children.map(function(e){return e.model}),l=this.props.currentPageNumber;if(u)l=c[0].pageNumber;else if(!i.find(function(e){return e.pageNumber===l})){var p=i.find(function(e){return c.includes(e)});p&&(l=p.pageNumber)}this._lastCenterSpreadIndex=a;var d=this.scroller.getHorizontalPositionInPercent(),f=d!==this._lastPositionInPercent;if(this._lastPositionInPercent=d,(f||u||o)&&this.props.dispatch(s.h(i,a,l,c,d,f,u,o,this.scroller.isDragging)),o){var h=i.map(function(e){return e.pageNumber}),m=c.map(function(e){return e.pageNumber});this.props.renderManager.setActivePages(Array.from(new Set([].concat(h,m))))}},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"HorizontalList"}},{key:"width",get:function(){var e=this.children?this.children.length:0;return this.props.viewportWidth*e-(this.xMargin+this.xOverlap)*(e-1)}},{key:"height",get:function(){return this.props.viewportHeight}},{key:"transform",get:function(){return this._transform||(this._transform=new r.a),this._transform.mReset().mTranslate(-this.scroller.left,-this.scroller.top),this._transform}},{key:"inAnimation",get:function(){return!!this.scroller.isMoving||this.parent.inAnimation}},{key:"xMargin",get:function(){var e=this.props.readMode===d.DOUBLE_PAGE_SPREAD?f.c:f.d;return n.i(l.a)()*e}},{key:"yMargin",get:function(){var e=0;return e=this.props.readMode===d.DOUBLE_PAGE_SPREAD?this.props.allowUIToOverlayCover?f.e:f.f:this.props.allowUIToOverlayCover?f.g:f.h,n.i(l.a)()*e}},{key:"xOverlap",get:function(){return 0}}]),t}(i.a)},function(e,t,n){"use strict";t.a={w:36,h:36,d:[function(e,t){e.save(),t.stack++,e.strokeStyle="rgba(0,0,0,0)",e.lineCap="butt",e.lineJoin="miter",e.miterLimit=4,e.translate(0,0),e.translate(0,0),e.translate(0,0),e.scale(1,1),e.translate(0,0),e.save(),t.stack++,e.fillStyle="rgba(0,0,0,0)",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.translate(8,10),e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.beginPath(),e.moveTo(16.683499,11.621507),e.bezierCurveTo(15.72267,11.621507,14.892862,12.262398,14.630817,13.116921),e.lineTo(7.861335,13.116921),e.bezierCurveTo(7.59929,12.347851,6.987853,11.792411,6.158046,11.664233),e.lineTo(6.027023,10.766984),e.lineTo(17.513307,9.228843),e.bezierCurveTo(17.819025,9.186117,18.08107,8.929761,18.08107,8.587952),e.lineTo(18.08107,2.520841),e.bezierCurveTo(18.08107,2.179032,17.775351,1.87995,17.425959,1.87995),e.lineTo(4.760475,1.87995),e.lineTo(4.585779,.55544),e.bezierCurveTo(4.542105,.256357,4.28006,0,3.930667,0),e.lineTo(.655111,0),e.bezierCurveTo(.305719,0,0,.299083,0,.640892),e.bezierCurveTo(0,.982701,.305719,1.281784,.655111,1.281784),e.lineTo(3.31923,1.281784),e.lineTo(4.891497,11.792411),e.bezierCurveTo(4.149038,12.13422,3.624949,12.860564,3.624949,13.715087),e.bezierCurveTo(3.624949,14.911418,4.585779,15.851393,5.808653,15.851393),e.bezierCurveTo(6.769483,15.851393,7.59929,15.210501,7.861335,14.355979),e.lineTo(14.587143,14.355979),e.bezierCurveTo(14.849188,15.210501,15.678995,15.851393,16.639825,15.851393),e.bezierCurveTo(17.8627,15.851393,18.823529,14.911418,18.823529,13.715087),e.bezierCurveTo(18.823529,12.518755,17.8627,11.621507,16.683499,11.621507),e.lineTo(16.683499,11.621507),e.closePath(),e.moveTo(16.770848,3.161733),e.lineTo(16.770848,8.032512),e.lineTo(5.896001,9.442474),e.lineTo(4.978845,3.119007),e.lineTo(16.770848,3.161733),e.lineTo(16.770848,3.161733),e.closePath(),e.moveTo(5.808653,14.612336),e.bezierCurveTo(5.328238,14.612336,4.935171,14.2278,4.935171,13.757813),e.bezierCurveTo(4.935171,13.287826,5.328238,12.90329,5.808653,12.90329),e.bezierCurveTo(6.289068,12.90329,6.682135,13.287826,6.682135,13.757813),e.bezierCurveTo(6.682135,14.2278,6.289068,14.612336,5.808653,14.612336),e.lineTo(5.808653,14.612336),e.closePath(),e.moveTo(16.683499,14.612336),e.bezierCurveTo(16.203084,14.612336,15.810018,14.2278,15.810018,13.757813),e.bezierCurveTo(15.810018,13.287826,16.203084,12.90329,16.683499,12.90329),e.bezierCurveTo(17.163914,12.90329,17.556981,13.287826,17.556981,13.757813),e.bezierCurveTo(17.556981,14.2278,17.163914,14.612336,16.683499,14.612336),e.lineTo(16.683499,14.612336),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--}],i:{}}},function(e,t,n){"use strict";t.a={w:24,h:24,d:[function(e,t){e.save(),t.stack++,e.strokeStyle="rgba(0,0,0,0)",e.fillStyle="rgba(154, 168, 169, 0.5)",e.lineCap="butt",e.lineJoin="miter",e.miterLimit=4,e.translate(0,0),e.translate(0,0),e.translate(0,0),e.scale(1,1),e.translate(0,0),e.save(),t.stack++,e.save(),t.stack++,e.translate(7,7),e.save(),t.stack++,e.beginPath(),e.moveTo(6.777879,6.845484),e.bezierCurveTo(5.790032,7.833332,4.188142,7.833223,3.200156,6.845237),e.bezierCurveTo(2.21224,5.85732,2.21224,4.255678,3.200156,3.267761),e.bezierCurveTo(4.188224,2.279694,5.789619,2.279748,6.777632,3.267761),e.bezierCurveTo(7.765715,4.255844,7.765877,5.857486,6.777879,6.845484),e.lineTo(8.24994,8.317545),e.bezierCurveTo(10.051001,6.516484,10.050705,3.596713,8.249693,1.795701),e.bezierCurveTo(6.448705,-.005287,3.529182,-.005386,1.728095,1.795701),e.bezierCurveTo(-.072818,3.596614,-.072818,6.516385,1.728095,8.317298),e.bezierCurveTo(3.529034,10.118236,6.449051,10.118434,8.24994,8.317545),e.lineTo(6.777879,6.845484),e.lineTo(6.777879,6.845484),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.save(),t.stack++,e.fillStyle="rgba(154, 168, 169, 0.5)",e.beginPath(),e.moveTo(12,23),e.bezierCurveTo(18.075132,23,23,18.075132,23,12),e.bezierCurveTo(23,5.924868,18.075132,1,12,1),e.bezierCurveTo(5.924868,1,1,5.924868,1,12),e.bezierCurveTo(1,18.075132,5.924868,23,12,23),e.closePath(),e.moveTo(12,20.025024),e.bezierCurveTo(16.432099,20.025024,20.025024,16.432099,20.025024,12),e.bezierCurveTo(20.025024,7.567901,16.432099,3.974976,12,3.974976),e.bezierCurveTo(7.567901,3.974976,3.974976,7.567901,3.974976,12),e.bezierCurveTo(3.974976,16.432099,7.567901,20.025024,12,20.025024),e.closePath(),e.fill("evenodd"),e.stroke(),e.restore(),t.stack--,e.save(),t.stack++,e.fillStyle="#9AA8A9",e.beginPath(),e.moveTo(3.977469,12.202011),e.bezierCurveTo(3.880403,13.366651,2.944759,13.653612,2.481445,13.656799),e.bezierCurveTo(1.992432,13.660164,1,13.117421,1,12),e.bezierCurveTo(1,5.924868,5.924868,1,12,1),e.bezierCurveTo(18.075132,1,23,5.924868,23,12),e.bezierCurveTo(23,13.127857,22.037891,13.51123,21.543091,13.51123),e.bezierCurveTo(21.048291,13.511231,20.045776,13.203328,20.045776,12),e.bezierCurveTo(20.045776,11.948528,20.038295,11.898609,20.023654,11.850214),e.bezierCurveTo(19.943791,7.487233,16.382062,3.974976,12,3.974976),e.bezierCurveTo(7.567901,3.974976,3.974976,7.567901,3.974976,12),e.bezierCurveTo(3.974976,12.067535,3.97581,12.134875,3.977469,12.202011),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--}],i:{}}},function(e,t,n){"use strict";n.d(t,"a",function(){return o});var r=n(315),i=n(35),o={draw:function(e,t,o,a){var s=n.i(i.a)();e.save(),e.translate(t,o),e.scale(s,s),e.rotate(a/230),e.translate(-r.a.w/2,-r.a.h/2),r.a.d[0](e,{stack:0}),e.restore()}}},function(e,t,n){"use strict";t.a={w:36,h:36,d:[function(e,t){e.save(),t.stack++,e.strokeStyle="rgba(0,0,0,0)",e.lineCap="butt",e.lineJoin="miter",e.miterLimit=4,e.translate(0,0),e.translate(0,0),e.translate(0,0),e.scale(1,1),e.translate(0,0),e.save(),t.stack++,e.fillStyle="rgba(0,0,0,0)",e.strokeStyle="rgba(0,0,0,0)",e.lineWidth=1,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="#F2F2F2",e.lineWidth=2,e.save(),t.stack++,e.fillStyle="#F2F2F2",e.strokeStyle="#F2F2F2",e.lineWidth=2,e.beginPath(),e.moveTo(12.340871,10.014123),e.bezierCurveTo(12.438705,9.987436,12.545844,9.99788,12.638453,10.051348),e.lineTo(25.723194,17.605827),e.bezierCurveTo(25.744171,17.617938,25.76355,17.631794,25.781276,17.647113),e.bezierCurveTo(25.850585,17.681197,25.910658,17.735014,25.951029,17.804939),e.bezierCurveTo(26.061419,17.99614,25.995389,18.240929,25.808595,18.348775),e.lineTo(12.645177,25.948678),e.bezierCurveTo(12.576466,25.988348,12.500235,26.004075,12.425883,25.999113),e.bezierCurveTo(12.41723,25.999695,12.408519,25.99999,12.399759,25.99999),e.bezierCurveTo(12.178978,25.99999,12,25.820411,12,25.604721),e.lineTo(12,10.404915),e.bezierCurveTo(12,10.206904,12.152566,10.0429,12.340871,10.014123),e.lineTo(12.340871,10.014123),e.closePath(),e.fill(),e.stroke(),e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--,e.restore(),t.stack--}],i:{}}},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(10),i=n.n(r),o=n(142),a=n(48),s=n(134),u=n(35),c="'Open Sans', Helvetica, Arial, Tahoma, Sans-serif",l=function(e){function t(r,i){babelHelpers.classCallCheck(this,t);var a=babelHelpers.possibleConstructorReturn(this,e.call(this,r,i));return a._renderedText="",a._textWidth=0,n.i(o.b)(a.root.props.ctx)&&(a.gl=a.root.props.ctx,a.initializeTexture()),a}return babelHelpers.inherits(t,e),t.prototype.componentWillUnmount=function(){this.gl&&this._texture&&this.gl.deleteTexture(this._texture)},t.prototype.initializeTexture=function(){var e=this.gl;this._texture=e.createTexture(),e.bindTexture(e.TEXTURE_2D,this._texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE)},t.prototype.drawRoundRect=function(e,t,n,r,i,o){e.beginPath(),e.moveTo(t+o,n),e.lineTo(t+r-o,n),e.quadraticCurveTo(t+r,n,t+r,n+o),e.lineTo(t+r,n+i-o),e.quadraticCurveTo(t+r,n+i,t+r-o,n+i),e.lineTo(t+o,n+i),e.quadraticCurveTo(t,n+i,t,n+i-o),e.lineTo(t,n+o),e.quadraticCurveTo(t,n,t+o,n),e.closePath(),e.fill(),e.stroke()},t.prototype.updateOffscreenCanvases=function(){var e=document.createElement("canvas"),t=e.getContext("2d",{alpha:!1});t.font="12px "+c;var r=Math.ceil(t.measureText(this.text).width+12),i=n.i(u.a)(),o=r*i,a=20*i,s=4*i,l=3.5*i;return e.width=o,e.height=a,t.fillStyle="#4c4c4c",t.strokeStyle="#4c4c4c",t.clearRect(0,0,o,a),this.drawRoundRect(t,0,0,o,a,s),t.fillStyle="#ffffff",t.textBaseline="alphabetic",t.textAlign="center",t.font=12*i+"px "+c,t.fillText(this.text,o/2,a/2+l),this._textWidth=r,this._renderedText=this.text,e},t.prototype.updateTexture=function(e){var t=this.gl;t.pixelStorei(t.UNPACK_FLIP_Y_WEBGL,!1),t.bindTexture(t.TEXTURE_2D,this._texture),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,e)},t.prototype.appendWebglOps=function(e,t,r,i){this._renderedText!==this.text&&this.updateTexture(this.updateOffscreenCanvases());var o=n.i(u.a)(),s=this._textWidth*o,c=20*o,l=15*o,p=this.props.link.viewportBBox;e.push({type:a.b,args:[this._texture,{x:p.x+p.width/2-s/2,y:p.y+p.height+(l-c/2),width:s,height:c},{x:0,y:0,width:1,height:1}]})},t.prototype.draw=function(e,t,r){this.alphaCanvas&&this._renderedText===this.text||(this._alphaCanvas=this.updateOffscreenCanvases());var i=n.i(u.a)(),o=this._textWidth*i,a=20*i,s=15*i,c=this.props.link.viewportBBox;e.drawImage(this._alphaCanvas,Math.round(c.x+c.width/2-o/2),Math.round(c.y+c.height+s-a/2),o,a)},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"LinkTooltip"}},{key:"width",get:function(){return this.props.link?this.props.link.width:0}},{key:"height",get:function(){return this.props.link?20:0}},{key:"isVisible",get:function(){return this.props.link&&this.props.link.isVisible}},{key:"model",get:function(){return this.props.link.model}},{key:"text",get:function(){var e="";return this.model.type===s.a?e=""+this.model.url:this.model.type===s.b&&(e="Navigate to page "+this.model.pageNumber),e}}]),t}(a.a);l.propTypes={glManager:i.a.object,link:i.a.object}},function(e,t,n){"use strict";n.d(t,"a",function(){return v});var r=n(10),i=n.n(r),o=n(48),a=n(75),s=n(220),u=n(197),c=n(198),l=n(20),p=n(134),d=n(195),f=n(35),h=100,m=100,g=800,v=function(e){function t(n,r){babelHelpers.classCallCheck(this,t);var i=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r));return i._isHovered=!1,i._hoverAnimation=new s.a(Number.MAX_VALUE,h),i._initialFlashAnimation=new s.a(Number.MAX_VALUE,g),i._toggleAnimation=new s.a(Number.MAX_VALUE,m),i._initialFlashTimeoutId=null,i}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(e){var t=this;this.props.arrivedAtSpreadTick&&!e.arrivedAtSpreadTick?this._initialFlashTimeoutId=window.setTimeout(function(){t._initialFlashTimeoutId=null,t._initialFlashAnimation.reset(t.root.tick),t.requestRedraw()},1e3):!this.props.arrivedAtSpreadTick&&e.arrivedAtSpreadTick&&(window.clearTimeout(this._initialFlashTimeoutId),this._initialFlashTimeoutId=null),this.props.isToggledOn&&!e.isToggledOn&&(this._toggleAnimation.options.reverse=!1,this._toggleAnimation.reset(this.root.tick)),!this.props.isToggledOn&&e.isToggledOn&&(this._toggleAnimation.options.reverse=!0,this._toggleAnimation.reset(this.root.tick))},t.prototype.onMouseEnter=function(e,t){this._hoverAnimation.reset(t),this._hoverAnimation.options.reverse=!1,this._isHovered=!0,this.props.showLinkToolTip(this),this.requestRedraw()},t.prototype.onMouseLeave=function(e,t){this._hoverAnimation.reset(t-(1-this._hoverAnimation.value(t))*h),this._hoverAnimation.options.reverse=!0,this._isHovered=!1,this.props.hideLinkToolTip(),this.requestRedraw()},t.prototype.onSingleTap=function(e,t,n){return this.props.featureTracker.usage(l.b.PUBLICATION_LINK),this.model.type===p.a?this.props.dispatch(d.a(this.model)):this.model.type===p.b&&this.props.dispatch(d.b(this.model)),!0},t.prototype.isAnimating=function(e){return this._initialFlashAnimation.isRunning(e)||this._toggleAnimation.isRunning(e)||this._hoverAnimation.isRunning(e)},t.prototype.hoverOpacity=function(e){return this._hoverAnimation.isRunning(e)?this._hoverAnimation.value(e):this._isHovered?1:0},t.prototype.initialFlashOpacity=function(e){if(this.parent.parent.getZoom()>1)return 0;if(this._initialFlashAnimation.isRunning(e)){var t=this._initialFlashAnimation.value(e);return t<.2?t/.2:t<.5?1:1-2*(t-.5)}return 0},t.prototype.linkToggleOpacity=function(e){return this._toggleAnimation.isRunning(e)?this._toggleAnimation.value(e):this.props.isToggledOn?1:0},t.prototype.calculateOpacityForDrawing=function(e){var t=this.initialFlashOpacity(e),n=this.linkToggleOpacity(e),r=this.hoverOpacity(e);return Math.max(t,n,r)},t.prototype.getCustomCursor=function(){return!!this._isHovered&&"pointer"},t.prototype.draw=function(e,t,r){e.save(),e.beginPath();var i=this.calculateOpacityForDrawing(r);e.rect(t.x+.5,t.y+.5,t.width-1,t.height-1),e.strokeStyle="rgba(118, 165, 204, "+i+")",e.fillStyle="rgba(118, 165, 204, "+.5*i+")",e.fill(),e.stroke();var o=20*n.i(f.a)();t.width>50&&t.height>50&&(this.model.isShoppingLink&&(e.globalAlpha=i,e.fillStyle="rgba(0, 0, 0, 0.7)",u.a.draw(e,t.x+t.width/2,t.y+t.height/2,o)),this.model.isVideoLink&&(e.globalAlpha=i,e.fillStyle="rgba(0, 0, 0, 0.7)",c.a.draw(e,t.x+t.width/2,t.y+t.height/2,o))),e.restore()},t.prototype.appendWebglOps=function(e,t,n,r){var i=this.calculateOpacityForDrawing(r);i>0&&e.push({type:o.e,args:[this.model,i,Object.assign({},t)]})},t.prototype.afterDraw=function(e,t){this.isAnimating(t)&&this.requestRedraw(),this.props.featureTracker.opportunity(l.b.PUBLICATION_LINK)},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"Link"}},{key:"model",get:function(){return this.props.model}},{key:"width",get:function(){return this.model.width}},{key:"height",get:function(){return this.model.height}},{key:"transform",get:function(){return this._transform||(this._transform=new a.a,this._transform.mTranslate(this.model.x,this.model.y)),this._transform}},{key:"isVisible",get:function(){return!!this.props.arrivedAtSpreadTick&&(!!this.props.isToggledOn||(!!this._isHovered||!!this.isAnimating(this.root.tick)))}}]),t}(o.a);v.propTypes={arrivedAtSpreadTick:i.a.number.isRequired,dispatch:i.a.func.isRequired,featureTracker:i.a.object.isRequired,hideLinkToolTip:i.a.func.isRequired,isToggledOn:i.a.bool.isRequired,model:i.a.object.isRequired,showLinkToolTip:i.a.func.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(330),i=n(329),o=n(326),a=n(325),s=n(328),u=n(327),c=n(200),l=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shadow=new r.a(t),this.shadowDraw=new i.a(t),this.bendingPage=new a.a(t),this.imagePrimitive=new o.a(t),this.link=new s.a(t,this.imagePrimitive),this.linkTooltip=new u.a(t,this.imagePrimitive),this.highlights=new c.b(t)}return e.prototype.destroy=function(){this.shadow.destroy(),this.shadowDraw.destroy(),this.bendingPage.destroy(),this.imagePrimitive.destroy(),this.link.destroy(),this.linkTooltip.destroy(),this.highlights.destroy(),this.gl=null},e}()},function(e,t,n){"use strict";function r(e,t,n){var r=e.y-n,i=Math.sqrt(e.x*e.x+r*r),o=Math.asin(e.x/i),a=o/Math.sin(t),s=i*Math.sin(t);e.x=s*Math.sin(a),e.y=i+n-s*(1-Math.cos(a))*Math.sin(t),e.z=s*(1-Math.cos(a))*Math.cos(t)}function i(e,t,n){var r=Math.sqrt(1+(1-n)*(1-n))*Math.sin(t),i=e.x/r;e.x=r*Math.sin(i),e.z=r-r*Math.cos(i)}function o(e,t,n,o){var a={x:e.x,y:e.y,z:e.z},s={x:e.x,y:e.y,z:e.z};o>0&&(a.y=1-a.y),r(a,t,n),o>0&&(a.y=1-a.y),i(s,t,n);var u=Math.abs(o);e.x=u*a.x+(1-u)*s.x,e.y=u*a.y+(1-u)*s.y,e.z=u*a.z+(1-u)*s.z}function a(e,t){var n=e.x*Math.cos(t)-e.z*Math.sin(t),r=e.x*Math.sin(t)+e.z*Math.cos(t);e.x=n,e.z=r}function s(e){return p.e(0,1,e)*Math.PI}function u(e){return p.c(.5,.082,e)*Math.PI}function c(e){var t=.98,n=-8.1;return e=Math.max(Math.min(e,1),0),e<t?-6.8*Math.pow(e/t,20)-1.3:-391.9*Math.pow((e-t)/(1-t),6)+n}n.d(t,"a",function(){return d});var l=n(322),p=n(131),d=function(){function e(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0;if(babelHelpers.classCallCheck(this,e),t<2)throw new Error("size must be at least 2");this.minDepth=n;for(var r=[],i=[],o=[],a=[],s=[],u=[],c=[],l=[],p=0;p<t;p++)for(var d=p/(t-1),f=0;f<t;f++){var h=f/(t-1),m=this._tweakDepth(0);r.push(h,d,m),i.push(0,0,1),a.push(this._getPerspectiveCorrection(m)),s.push(h,d),u.push(0,0,-1),l.push(1-h,d)}for(var g=0;g<t-1;g++)for(var v=(g+0)*t,b=(g+1)*t,y=0;y<t-1;y++){var _=v+y,w=b+y;o.push(w,_,w+1),o.push(_,_+1,w+1),c.push(w+1,_+1,w),c.push(_+1,_,w)}this.size=t,this.indices=new Uint16Array(o),this.vertices=new Float32Array(r),this.normals=new Float32Array(i),this.perspectiveCorrections=new Float32Array(a),this.textureCoords=new Float32Array(s),this.backFacingIndices=new Uint16Array(c),this.backFacingNormals=new Float32Array(u),this.backFacingTextureCoords=new Float32Array(l)}return e.prototype._tweakDepth=function(e){return.8*Math.max(e,this.minDepth)},e.prototype._getPerspectiveCorrection=function(e){return 1+e/.8*-.2},e.prototype._bendPoint=function(e,t,n,r,i,s){o(e,t,n,i),a(e,r),e.x*=s?-1:1,e.z=this._tweakDepth(e.z)},e.prototype.bend=function(e,t){for(var r=1/e<0,i=Math.abs(e),o=s(i),a=u(i),p=c(i),d={x:0,y:0,z:0},f=0;f<this.size;f++)for(var h=0;h<this.size;h++){d.x=h/(this.size-1),d.y=f/(this.size-1),d.z=0,this._bendPoint(d,a,p,o,t,r);var m=f*this.size*3+3*h;this.vertices[m+0]=d.x,this.vertices[m+1]=d.y,this.vertices[m+2]=d.z,this.perspectiveCorrections[f*this.size+h]=this._getPerspectiveCorrection(d.z)}n.i(l.a)(this.size,this.vertices,this.normals,this.backFacingNormals)},e.prototype.calculateProgress=function(e,t,n,r,i){var o=e<t;if(o){if(n<=e)return-0;if(n>=t)return-1}else{if(n>=e)return 0;if(n<=t)return 1}for(var a={x:0,y:0,z:0},l=o?-.5:.5,p=0;p<16;p++){var d=Math.abs(l),f=s(d),h=u(d),m=c(d);a.x=1,a.y=(i+1)/2,a.z=0,this._bendPoint(a,h,m,f,i,o);var g=a.x/this._getPerspectiveCorrection(a.z),v=r.x+r.width*g;if(Math.abs(v-n)<1)break;l+=Math.sign(v-n)/Math.pow(2,p+2)}return Math.max(Math.min(l,1),-1)},e}()},function(e,t,n){"use strict";function r(e){var t=Math.sqrt(e.x*e.x+e.y*e.y+e.z*e.z);e.x/=t,e.y/=t,e.z/=t}function i(e,t,n,r,i,o,a){a.x+=o*t-i*n,a.y+=r*n-o*e,a.z+=i*e-r*t}function o(e,t,n,r,i){e<n-1&&i.push(r[t+0+3*n]-r[t+0],r[t+1+3*n]-r[t+1],r[t+2+3*n]-r[t+2])}function a(e,t,n,r,i){e>0&&i.push(r[t+0-3*n]-r[t+0],r[t+1-3*n]-r[t+1],r[t+2-3*n]-r[t+2])}function s(e,t,n,r,i){e>0&&i.push(r[t+0-3]-r[t+0],r[t+1-3]-r[t+1],r[t+2-3]-r[t+2])}function u(e,t,n,r,i){e<n-1&&i.push(r[t+0+3]-r[t+0],r[t+1+3]-r[t+1],r[t+2+3]-r[t+2])}function c(e,t,n,r,c,l,p){t===r-1?(s(e,n,r,c,l),a(t,n,r,c,l),u(e,n,r,c,l)):0===e?(a(t,n,r,c,l),u(e,n,r,c,l),o(t,n,r,c,l)):0===t?(u(e,n,r,c,l),o(t,n,r,c,l),s(e,n,r,c,l)):e===r-1?(o(t,n,r,c,l),s(e,n,r,c,l),a(t,n,r,c,l)):(o(t,n,r,c,l),s(e,n,r,c,l),a(t,n,r,c,l),u(e,n,r,c,l));for(var d=l.length/3,f=0;f<d-1;f++)i(l[3*f+0],l[3*f+1],l[3*f+2],l[3*(f+1)+0],l[3*(f+1)+1],l[3*(f+1)+2],p)}function l(e,t,n,i){for(var o={x:0,y:0,z:0},a=[],s=0;s<e;s++)for(var u=0;u<e;u++){o.x=0,o.y=0,o.z=0,a.length=0;var l=s*e*3+3*u;c(u,s,l,e,t,a,o),r(o),n[l+0]=o.x,n[l+1]=o.y,n[l+2]=o.z,i[l+0]=-o.x,i[l+1]=-o.y,i[l+2]=-o.z}}t.a=l},function(e,t,n){"use strict";function r(e){return e===p.SINGLE_PAGE_SPREAD?200:400}function i(e){var t=Math.abs(e);return t<.1?f.c(0,1,10*t):t>.9?f.c(0,1,10*(1-t)):1}n.d(t,"a",function(){return w});var o=n(75),a=n(48),s=n(201),u=n(58),c=n(8),l=n(321),p=n(40),d=n(220),f=n(131),h=n(78),m=n(80),g=n(35),v=n(20),b=n(324),y=0,_=.001,w=function(e){function t(n,o){babelHelpers.classCallCheck(this,t);var a=babelHelpers.possibleConstructorReturn(this,e.call(this,n,o));return a._bendingMesh=new l.a(25,_),a._flatMesh=new l.a(2,y),a._isSnapped=!0,a._wasAnimatingLastFrame=!1,a._lastPositionInPercent=0,a._lastVisiblePages="",a._pendingTargetSpreadIndex=NaN,a._lightRatioEasing=i,a._progressEasing=function(e){return a.animation.value(e)},a._justStartedAnimation=!1,a._targetSpreadIndex=a.props.currentSpreadIndex,a._lastSpreadIndex=a.props.currentSpreadIndex,a.animation=new d.a(Number.MAX_VALUE,r(a.props.readMode)),a}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.props.featureTracker.opportunity(v.b.DOUBLE_TAP_ZOOM),this.props.featureTracker.opportunity(v.b.GESTURE_PINCH_ZOOM),this.props.canChangePages&&this.props.featureTracker.opportunity(v.b.GESTURE_DRAG_PAGES)},t.prototype.onGestureStart=function(e,t,n,r,i){return!this.props.disableGestures&&(this.animation.isRunning(n)&&this.jumpToSpread(this._targetSpreadIndex,n),this._gesture={startX:e,startY:t,endX:e,endY:t,velocity:0,timeStamp:i},!0)},t.prototype.onGestureChange=function(e,t,n,r,i,o,a){if(this.props.disableGestures)return!1;if((a===h.a||a===h.b)&&1===r.length){var s=e-this._gesture.endX,u=Math.max(1,i-this._gesture.timeStamp),c=-s/u*.6+.4*this._gesture.velocity;this._gesture.endX=e,this._gesture.endY=t,this._gesture.timeStamp=i,this._gesture.velocity=c;var l=this.getCurrentSpreadIndex(),p=this._getValidSpreadIndex(l+(a===h.a?1:-1));return l!==p&&this.tweakAnimation({duration:Number.MAX_VALUE,targetSpreadIndex:p}),!0}return!1},t.prototype.onGestureEnd=function(e,t){if(this.props.disableGestures)return!1;if(this.animation.duration===Number.MAX_VALUE){var n=this._getPageSetupForFlip(this.getCurrentSpreadIndex(),this._targetSpreadIndex),i=this._getProgressBasedOnFingerPosition(n.start.edge,n.end.edge,e),o=this._targetSpreadIndex>this.getCurrentSpreadIndex()?this._gesture.velocity>0:this._gesture.velocity<0,a=Math.abs(this._gesture.velocity),s=o&&(i>.6||a>.36),u=r(this.props.readMode)*(.95-Math.atan(a)/Math.PI);return this.tweakAnimation({duration:u,startTime:e-u*(s?i:1-i),reverse:!s}),s&&this.props.featureTracker.usage(v.b.GESTURE_DRAG_PAGES),!0}return!1},t.prototype.onSingleTapConfirmed=function(e,t,n,r){var i=this.getCurrentSpread(),o=i.children[0].viewportBBox;if(i.children.length>1){var a=i.children[1].viewportBBox;o.width+=a.width,o.height=Math.max(o.height,a.height),o.y=Math.min(o.y,a.y)}if(t>o.y&&t<o.y+o.height){var s=this.children.indexOf(i);if(e<o.x)return this.props.disableGestures?this.jumpToSpread(Math.max(s-1,0),n):this.goToSpread(Math.max(s-1,0),n),!0;if(e>o.x+o.width)return this.props.disableGestures?this.jumpToSpread(Math.min(s+1,this.children.length-1),n):this.goToSpread(Math.min(s+1,this.children.length-1),n),!0}return!1},t.prototype.getCurrentSpreadIndex=function(){return this.props.currentSpreadIndex},t.prototype.getCurrentSpread=function(){return this.children[this.getCurrentSpreadIndex()]},t.prototype.getVisiblePages=function(){var e=[];if(this.getCurrentSpreadIndex()!==this._targetSpreadIndex){var t=Math.min(this.getCurrentSpreadIndex(),this._targetSpreadIndex),r=Math.max(this.getCurrentSpreadIndex(),this._targetSpreadIndex);e.push.apply(e,this.children[t].children.map(function(e){return e.model})),e.push.apply(e,this.children[r].children.map(function(e){return e.model}))}else{for(var i=a.a.RectPool.get(0,0,this.props.viewportWidth,this.props.viewportHeight),o=this.getCurrentSpread(),s=o.children,u=Array.isArray(s),c=0,s=u?s:s[Symbol.iterator]();;){var l;if(u){if(c>=s.length)break;l=s[c++]}else{if(c=s.next(),c.done)break;l=c.value}var p=l,d=p.viewportBBox;n.i(m.b)(i,d)&&e.push(p.model),a.a.RectPool.release(d)}a.a.RectPool.release(i)}return e},t.prototype.setSnapping=function(e,t){},t.prototype.jumpToPositionByPercent=function(e,t){this.getCurrentSpread().setZoom(1),this.jumpToSpread(Math.round(e/100*(this.children.length-1)),t)},t.prototype.goToSpread=function(e,t){if(this.animation.isRunning(t))return void(this._pendingTargetSpreadIndex=e);this._animateToSpread(e,t,r(this.props.readMode))},t.prototype.jumpToSpread=function(e,t){this._animateToSpread(e,t,0)},t.prototype.tweakAnimation=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.animation.duration=e.hasOwnProperty("duration")?e.duration:r(this.props.readMode),this._targetSpreadIndex=this._getValidSpreadIndex(e.hasOwnProperty("targetSpreadIndex")?e.targetSpreadIndex:this._targetSpreadIndex),this.animation.reset(e.startTime||0),this.animation.options.reverse=!!e.hasOwnProperty("reverse")&&e.reverse,this._justStartedAnimation=!0,this.requestRedraw()},t.prototype._getValidSpreadIndex=function(e){return Math.max(0,Math.min(this.children.length-1,e))},t.prototype._animateToSpread=function(e,t,n){this._targetSpreadIndex=this._getValidSpreadIndex(e),this.getCurrentSpreadIndex()!==this._targetSpreadIndex&&(this.getCurrentSpread().setZoom(1),this.tweakAnimation({startTime:t,duration:n}))},t.prototype.getChildrenToTraverse=function(){return this.children.slice(this.getCurrentSpreadIndex(),this.getCurrentSpreadIndex()+1)},t.prototype.getChildTree=function(){var e=this;return this.props.documentPageSpreadList.map(function(t,n){var r=new o.a;return r.mTranslate(e.xMargin,e.yMargin),a.a.createElement(s.a,{dispatch:e.props.dispatch,featureTracker:e.props.featureTracker,height:e.props.viewportHeight-2*e.yMargin,hideLinkToolTip:e.props.hideLinkToolTip,isCurrentSpread:n===e.props.currentSpreadIndex,isLinksToggledOn:e.props.isLinksToggledOn,isSnapped:e._isSnapped,mayRenderLinks:e.props.mayRenderLinks&&e._isSnapped,pageModels:t.pages?t.pages:[t],paywalledPageStatus:t.pages?t.pages.map(function(t){return e.props.paywalledPageNumbers.includes(t.pageNumber)}):[e.props.paywalledPageNumbers.includes(t.pageNumber)],readMode:e.props.readMode,renderManager:e.props.renderManager,showLinkToolTip:e.props.showLinkToolTip,transform:r,width:e.props.viewportWidth-2*e.xMargin})})},t.prototype.beforeDraw=function(e,t){(!this.animation.isRunning(t)&&(this._wasAnimatingLastFrame||this._justStartedAnimation)||0===this.animation.duration)&&(this.animation.options.reverse&&(this._targetSpreadIndex=this.getCurrentSpreadIndex()),this._targetSpreadIndex!==this.getCurrentSpreadIndex()&&this.props.onSpreadChange(this._targetSpreadIndex),isNaN(this._pendingTargetSpreadIndex)||(this.goToSpread(this._pendingTargetSpreadIndex,t),this._pendingTargetSpreadIndex=NaN))},t.prototype.appendWebglOps=function(e,t,n,r){this.animation.isRunning(r)?this._appendWebglOpsForFlipping(e,this.getCurrentSpreadIndex(),this._targetSpreadIndex,n,r):this._appendWebglOpsForPages(e,n,r),this._justStartedAnimation=!1},t.prototype.afterDraw=function(e,t){!this._wasAnimatingLastFrame&&this.animation.isRunning(t)?this.props.onAnimationStart():this._wasAnimatingLastFrame&&!this.animation.isRunning(t)&&this.props.onAnimationEnd(),(this._wasAnimatingLastFrame=this.animation.isRunning(t))&&this.requestRedraw();var n=this.getVisiblePages(),r=this.getCurrentSpreadIndex(),i=this.children[r].children.map(function(e){return e.model}),o=r/(this.children.length-1)*100,a=this._lastPositionInPercent!==o,s=this._lastSpreadIndex!==r,u=n.map(function(e){return e.pageNumber}).join()!==this._lastVisiblePages,l=this.props.currentPageNumber;if(s)l=i[0].pageNumber;else if(!n.find(function(e){return e.pageNumber===l})){var p=n.find(function(e){return i.includes(e)});p&&(l=p.pageNumber)}if(this._lastPositionInPercent=o,this._lastSpreadIndex=r,this._lastVisiblePages=n.map(function(e){return e.pageNumber}).join(),(a||s||u)&&this.props.dispatch(c.h(n,r,l,i,o,a,s,u,!1)),this._wasAnimatingLastFrame===this._isSnapped&&(this._isSnapped=!this._wasAnimatingLastFrame,this._isSnapped||this.props.hideLinkToolTip(),this.forceUpdate()),u){var d=n.map(function(e){return e.pageNumber}),f=i.map(function(e){return e.pageNumber});this.props.renderManager.setActivePages(Array.from(new Set([].concat(d,f))))}},t.prototype._appendWebglOpsForFlipping=function(e,t,n,r,i){var o=this._getPageSetupForFlip(t,n),s=n<t,u=this._getConicContribution(),c=this._getProgressBasedOnFingerPosition(o.start.edge,o.end.edge,i),l=this._transformBBox(o.start.bbox,o.end.bbox,c);this._bendingMesh.bend(this._bendingMesh.calculateProgress(o.start.edge,o.end.edge,this._getFingerPosition(o.start.edge,o.end.edge,i),l,u),u);var p=o.start.bending?this._loadPreviewTextureInfo(o.start.bending,l,r):null,d=o.end.bending?this._loadPreviewTextureInfo(o.end.bending,l,r):null,f=this._lightRatioEasing(c);if(e.push({type:a.f,args:[this._bendingMesh,p,l,f,s,!!o.start.bending,i]},{type:a.f,args:[this._bendingMesh,d,l,f,!s,!!o.end.bending,i]},{type:a.g,args:[this._bendingMesh,l]}),o.start.flat){var h=this._transformBBox(o.start.flat.viewportBBox,o.end.bending.viewportBBox,c);this._appendWebglOpsForPage(e,o.start.flat,h,r,i),e.push({type:a.h,args:[h,1e-4]})}if(o.end.flat){var m=this._transformBBox(o.start.bending.viewportBBox,o.end.flat.viewportBBox,c);this._appendWebglOpsForPage(e,o.end.flat,m,r,i),e.push({type:a.h,args:[m,1e-4]})}},t.prototype._transformBBox=function(e,t,n){var r=Math.abs(n);return{x:f.d(e.x,t.x,r),y:f.d(e.y,t.y,r),width:f.d(e.width,t.width,r),height:f.d(e.height,t.height,r)}},t.prototype._getConicContribution=function(){if(this.animation.duration!==r(this.props.readMode)&&this._gesture){var e=(this._gesture.endY-this._gesture.startY)/(this.height-this._gesture.startY);return Math.min(1,Math.max(-1,e))}return-.5},t.prototype._getFingerPosition=function(e,t,n){return this.animation.duration===Number.MAX_VALUE&&this._gesture?this._gesture.endX-this._gesture.startX+e:e+(t-e)*this._progressEasing(n)},t.prototype._getProgressBasedOnFingerPosition=function(e,t,n){var r=this._getFingerPosition(e,t,n);return Math.min(1,Math.max(0,(r-e)/(t-e)))},t.prototype._getPageSetupForFlip=function(e,t){var r=t<e,i=this.children[e].children,o=this.children[t].children;return n.i(b.a)(i,o,this.props.readMode,r)},t.prototype._appendWebglOpsForPages=function(e,t,n){var r=this;this.getCurrentSpread().children.forEach(function(i){r._appendWebglOpsForPage(e,i,i.viewportBBox,t,n)})},t.prototype._appendWebglOpsForPage=function(e,t,n,r,i){var o=this;if(this.overlaps(n)){var s=this._lightRatioEasing(0),u=this._loadTextureInfos(t,n,r);(u||[null]).forEach(function(t){e.push({type:a.f,args:[o._flatMesh,t,n,s,!1,!0,i]})}),u||this.requestRedraw()}},t.prototype._loadPreviewTextureInfo=function(e,t,n){var r=t.x,i=t.y,o=this._loadTextureInfos(e,Object.assign({},t,{x:t.x-r,y:t.y-i}),n),a=o&&o[0];return a&&(a.dstX+=r,a.dstY+=i),a},t.prototype._loadTextureInfos=function(e,t,n){var r=e.getOperations(t,n.width,n.height,e.pageType),i=r.originX,o=r.originY,a=r.ops;return a&&a.reverse().map(function(e,t){return{surface:e.surface,srcX:e.src_px.x,srcY:e.src_px.y,srcW:e.src_px.width,srcH:e.src_px.height,dstX:e.dest_px.x+i,dstY:e.dest_px.y+o,dstW:e.dest_px.width,dstH:e.dest_px.height}})},babelHelpers.createClass(t,[{key:"displayName",get:function(){return"PageFlip"}},{key:"width",get:function(){return this.props.viewportWidth}},{key:"height",get:function(){return this.props.viewportHeight}},{key:"xMargin",get:function(){var e=u.c;return n.i(g.a)()*e}},{key:"yMargin",get:function(){var e=this.props.allowUIToOverlayCover?u.e:u.f;return n.i(g.a)()*e}}]),t}(a.a)},function(e,t,n){"use strict";function r(e,t){var n=e[0].viewportBBox,r=t[0].viewportBBox;return{start:{bending:e[0],flat:null,bbox:n,edge:n.x+n.width},end:{bending:null,flat:t[0],bbox:r,edge:r.x}}}function i(e,t){var n=e[0].viewportBBox,r=t[0].viewportBBox;return{start:{bending:null,flat:e[0],bbox:n,edge:n.x},end:{bending:t[0],flat:null,bbox:r,edge:r.x+r.width}}}function o(e,t){var n=e[e.length-1].viewportBBox,r=t[0].viewportBBox;return{start:{bending:e[e.length-1],flat:e.length>1?e[0]:null,bbox:n,edge:n.x+n.width},end:{bending:t[0],flat:t.length>1?t[t.length-1]:null,bbox:Object.assign({},r,{x:r.x+r.width}),edge:r.x}}}function a(e,t){var n=e[0].viewportBBox,r=t[t.length-1].viewportBBox;return{start:{bending:e[0],flat:e.length>1?e[e.length-1]:null,bbox:Object.assign({},n,{x:n.x+n.width}),edge:n.x},end:{bending:t[t.length-1],flat:t.length>1?t[0]:null,bbox:r,edge:r.x+r.width}}}function s(e,t,n,s){return n===u.SINGLE_PAGE_SPREAD?s?i(e,t):r(e,t):s?a(e,t):o(e,t)}t.a=s;var u=n(40)},function(e,t,n){"use strict";n.d(t,"a",function(){return m});var r=n(74),i=n(35),o=n(101),a=(n.n(o),n(749)),s=n.n(a),u=n(750),c=n.n(u),l=n(758),p=n.n(l),d=n(757),f=n.n(d),h=!1,m=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=n.i(r.a)(t,c.a,s.a);this.verticeBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.verticeBuffer),t.bufferData(t.ARRAY_BUFFER,7500,t.DYNAMIC_DRAW),this.normalsBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.normalsBuffer),t.bufferData(t.ARRAY_BUFFER,7500,t.DYNAMIC_DRAW),this.textureCoordsBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.textureCoordsBuffer),t.bufferData(t.ARRAY_BUFFER,5e3,t.DYNAMIC_DRAW),this.perspectiveCorrectionsBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.perspectiveCorrectionsBuffer),t.bufferData(t.ARRAY_BUFFER,2500,t.DYNAMIC_DRAW);this.indiceBuffer=t.createBuffer(),t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),t.bufferData(t.ELEMENT_ARRAY_BUFFER,6912,t.DYNAMIC_DRAW),this.whitePaperTexture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.whitePaperTexture),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,1,1,0,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array([255,255,255,255])),t.bindTexture(t.TEXTURE_2D,null),h&&(this.normalShader=n.i(r.a)(t,p.a,f.a),this.normalLinesBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.normalLinesBuffer),t.bufferData(t.ARRAY_BUFFER,15e3,t.DYNAMIC_DRAW))}return e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.normalsBuffer),e.deleteBuffer(this.textureCoordsBuffer),e.deleteBuffer(this.perspectiveCorrectionsBuffer),e.deleteBuffer(this.indiceBuffer),e.deleteTexture(this.whitePaperTexture),this.shader.destroy(),h&&(e.deleteBuffer(this.normalLinesBuffer),this.normalShader.destroy())},e.prototype._calculateMatrix=function(e,t,n){var r=t?t.srcX:0,i=t?t.srcY:0,a=t?t.srcW:n.width,s=t?t.srcH:n.height,u=t?t.dstX:n.x,c=t?t.dstY:n.y,l=t?t.dstW:n.width,p=t?t.dstH:n.height,d=t?t.surface.width:n.width,f=t?t.surface.height:n.height;i=(t?t.surface.imgHeight:n.height)-i-s,c=e.drawingBufferHeight-c-p;var h=new Float32Array([l,0,0,0,p,0,u,c,1]),m=new Float32Array([2/e.drawingBufferWidth,0,0,0,2/e.drawingBufferHeight,0,-1,-1,1]);o.mat3.multiply(h,m,h);var g=Math.max(0,(1-a/l)/2),v=Math.max(0,(1-s/p)/2);return{matrix:h,texMatrix:new Float32Array([(a-2*g)/d,0,0,0,(s-2*v)/f,0,(r+g)/d,(i+v)/f,1])}},e.prototype.draw=function(e,t,r,o,a,s){var u=arguments.length>6&&void 0!==arguments[6]?arguments[6]:0,c=this.gl,l=this.shader;c.enable(c.DEPTH_TEST),c.disable(c.BLEND),c.enable(c.CULL_FACE),c.cullFace(c.BACK),l.bind(c);var p=this._calculateMatrix(c,t,r),d=p.matrix,f=p.texMatrix;c.uniformMatrix3fv(l.u_matrix,!1,d),c.uniformMatrix3fv(l.u_texMatrix,!1,f);var m=c.canvas.width,g=c.canvas.height,v=r.x/m*2-1,b=r.y/g*2-1,y=r.width/m*2,_=r.height/g*2;if(c.uniform1f(l.lightRatio,o),c.uniform1f(l.tick,u),c.uniform1f(l.spinnerSize,22*n.i(i.a)()),c.uniform1i(l.showSpinner,!t&&s),c.uniform4f(l.bbox,v,b,y,_),c.uniform2f(l.viewport,c.drawingBufferWidth,c.drawingBufferHeight),c.activeTexture(c.TEXTURE0),c.bindTexture(c.TEXTURE_2D,t?t.surface.texture:this.whitePaperTexture),c.uniform1i(l.texture,0),c.bindBuffer(c.ARRAY_BUFFER,this.verticeBuffer),c.bufferSubData(c.ARRAY_BUFFER,0,e.vertices),c.vertexAttribPointer(l.vertex,3,c.FLOAT,c.FALSE,0,0),c.bindBuffer(c.ARRAY_BUFFER,this.normalsBuffer),c.bufferSubData(c.ARRAY_BUFFER,0,a?e.backFacingNormals:e.normals),c.vertexAttribPointer(l.normal,3,c.FLOAT,c.FALSE,0,0),c.bindBuffer(c.ARRAY_BUFFER,this.textureCoordsBuffer),c.bufferSubData(c.ARRAY_BUFFER,0,a?e.backFacingTextureCoords:e.textureCoords),c.vertexAttribPointer(l.textureCoord,2,c.FLOAT,c.FALSE,0,0),c.bindBuffer(c.ARRAY_BUFFER,this.perspectiveCorrectionsBuffer),c.bufferSubData(c.ARRAY_BUFFER,0,e.perspectiveCorrections),c.vertexAttribPointer(l.perspectiveCorrection,1,c.FLOAT,c.FALSE,0,0),c.bindBuffer(c.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),c.bufferSubData(c.ELEMENT_ARRAY_BUFFER,0,a?e.backFacingIndices:e.indices),c.drawElements(c.TRIANGLES,6*(e.size-1)*(e.size-1),c.UNSIGNED_SHORT,0),h){this.normalShader.bind(c),c.uniformMatrix3fv(this.normalShader.u_matrix,!1,d),c.uniform1i(this.normalShader.backFacing,a);for(var w=[],E=a?e.backFacingNormals:e.normals,x=0;x<e.vertices.length;x+=3){var S=e.vertices[x+0],T=e.vertices[x+1],C=e.vertices[x+2];w.push(S,T,C,S+E[x+0],T+E[x+1],C+E[x+2])}c.bindBuffer(c.ARRAY_BUFFER,this.normalLinesBuffer),c.bufferSubData(c.ARRAY_BUFFER,0,new Float32Array(w)),c.vertexAttribPointer(this.normalShader.vertex,3,c.FLOAT,c.FALSE,0,0),c.drawArrays(c.LINES,0,w.length/3)}},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return u});var r=n(74),i=n(753),o=n.n(i),a=n(754),s=n.n(a),u=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=n.i(r.a)(t,s.a,o.a);var i=t.createBuffer();t.bindBuffer(t.ARRAY_BUFFER,i),t.bufferData(t.ARRAY_BUFFER,new Float32Array([0,0,0,1,1,0,1,1]),t.STATIC_DRAW),this.verticeBuffer=i}return e.prototype.destroy=function(){var e=this.gl;e.bindBuffer(e.ARRAY_BUFFER,null),e.deleteBuffer(this.verticeBuffer),this.shader.destroy()},e.prototype.draw=function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{x:0,y:0,width:1,height:1},r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,i=this.gl,o=this.shader;o.bind(),i.disable(i.DEPTH_TEST),i.uniform2f(o.viewport,i.drawingBufferWidth,i.drawingBufferHeight),i.uniform4f(o.bbox,t.x,t.y,t.width,t.height),i.uniform4f(o.texCoords,n.x,n.y,n.width,n.height),i.uniform1f(o.opacity,r),i.activeTexture(i.TEXTURE0),i.bindTexture(i.TEXTURE_2D,e),i.uniform1i(o.texture,0),i.bindBuffer(i.ARRAY_BUFFER,this.verticeBuffer),i.vertexAttribPointer(o.vertex,2,i.FLOAT,!1,0,0),i.drawArrays(i.TRIANGLE_STRIP,0,4)},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.gl=t,this.imagePrimitive=n}return e.prototype.destroy=function(){},e.prototype.draw=function(e,t,n,r){var i=this.gl;i.disable(i.DEPTH_TEST),i.enable(i.BLEND),i.blendFuncSeparate(i.SRC_ALPHA,i.ONE_MINUS_SRC_ALPHA,i.ONE,i.ONE_MINUS_SRC_ALPHA),i.blendEquation(i.FUNC_ADD),this.imagePrimitive.draw(e,t,n,r)},e}()},function(e,t,n){"use strict";function r(e){return 1<<1+Math.floor(Math.log2(e))}n.d(t,"a",function(){return d});var i=n(74),o=n(755),a=n.n(o),s=n(756),u=n.n(s),c=n(35),l=n(197),p=n(198),d=function(){function e(t,r){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=n.i(i.a)(t,u.a,a.a),this.imagePrimitive=r;var o=t.createBuffer();t.bindBuffer(t.ARRAY_BUFFER,o),t.bufferData(t.ARRAY_BUFFER,new Float32Array([0,0,0,1,1,0,1,1]),t.STATIC_DRAW),this.verticeBuffer=o;var s=t.createBuffer();t.bindBuffer(t.ARRAY_BUFFER,s),t.bufferData(t.ARRAY_BUFFER,new Float32Array([1,1,0,0,1,0,0,1,0,1,1,0,0,0,1,1]),t.STATIC_DRAW),this.barycentricBuffer=s,this.initializeTexture()}return e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.barycentricBuffer),e.deleteTexture(this.texture),this.shader.destroy()},e.prototype._iconRadius=function(){return 20*n.i(c.a)()},e.prototype.initializeTexture=function(){var e=this.gl,t=2*this._iconRadius(),n=r(2*t),i=document.createElement("canvas");i.width=n,i.height=n;var o=i.getContext("2d");o.fillStyle="rgba(0, 1, 0, 0.0)",o.fillRect(0,0,i.width,i.height),o.fillStyle="rgba(0, 0, 0, 0.7)",p.a.draw(o,t/2,t/2,this._iconRadius()),l.a.draw(o,t+t/2,t/2,this._iconRadius()),this.texture&&e.deleteTexture(this.texture);var a=e.createTexture();e.bindTexture(e.TEXTURE_2D,a),e.texImage2D(e.TEXTURE_2D,0,e.RGBA,e.RGBA,e.UNSIGNED_BYTE,i),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.NEAREST),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),this.texture=a,this.textureSize=n},e.prototype.draw=function(e,t,n){var r=this.gl,i=this.shader;if(r.disable(r.DEPTH_TEST),r.enable(r.BLEND),r.blendFuncSeparate(r.SRC_ALPHA,r.ONE_MINUS_SRC_ALPHA,r.ZERO,r.ONE),r.blendEquation(r.FUNC_ADD),i.bind(),r.uniform2f(i.viewport,r.drawingBufferWidth,r.drawingBufferHeight),r.uniform4f(i.bbox,n.x,n.y,n.width,n.height),r.uniform1f(i.opacity,t),r.uniform1f(i.strokeWidth,1),r.bindBuffer(r.ARRAY_BUFFER,this.verticeBuffer),r.vertexAttribPointer(i.vertex,2,r.FLOAT,!1,0,0),r.bindBuffer(r.ARRAY_BUFFER,this.barycentricBuffer),r.vertexAttribPointer(i.barycentric,4,r.FLOAT,!1,0,0),r.drawArrays(r.TRIANGLE_STRIP,0,4),(e.isShoppingLink||e.isVideoLink)&&n.width>50&&n.height>50){var o={x:n.x+n.width/2-this._iconRadius(),y:n.y+n.height/2-this._iconRadius(),width:2*this._iconRadius(),height:2*this._iconRadius()},a={x:0,y:0,width:2*this._iconRadius()/this.textureSize,height:2*this._iconRadius()/this.textureSize};e.isVideoLink&&this.imagePrimitive.draw(this.texture,o,a,t),e.isShoppingLink&&(a.x+=a.width,this.imagePrimitive.draw(this.texture,o,a,t))}},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return u});var r=n(74),i=n(761),o=n.n(i),a=n(762),s=n.n(a),u=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=n.i(r.a)(t,s.a,o.a);this.verticeBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.verticeBuffer),t.bufferData(t.ARRAY_BUFFER,72,t.DYNAMIC_DRAW)}return e.prototype.draw=function(e,t,n){var r=this.gl,i=this.shader;r.enable(r.DEPTH_TEST),r.enable(r.BLEND),r.blendFuncSeparate(r.SRC_ALPHA,r.ONE_MINUS_SRC_ALPHA,r.ZERO,r.ONE),i.bind(r);var o=r.canvas.width,a=r.canvas.height,s=(t.x-o/2)/(o/2),u=(0-t.y+a/2)/(a/2),c=(t.x+t.width-o/2)/(o/2),l=(0-(t.y+t.height)+a/2)/(a/2),p=new Float32Array([s,u,n,s,l,n,c,u,n,c,u,n,s,l,n,c,l,n]);r.activeTexture(r.TEXTURE0),r.bindTexture(r.TEXTURE_2D,e),r.uniform1i(i.depthMapTexture,0),r.bindBuffer(r.ARRAY_BUFFER,this.verticeBuffer),r.bufferSubData(r.ARRAY_BUFFER,0,p),r.vertexAttribPointer(i.vertex,3,r.FLOAT,!1,0,0),r.drawArrays(r.TRIANGLES,0,6)},e.prototype.destroy=function(){this.gl.deleteBuffer(this.verticeBuffer),this.shader.destroy()},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(74),i=n(101),o=(n.n(i),n(763)),a=n.n(o),s=n(764),u=n.n(s),c=512,l=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gl=t,this.shader=n.i(r.a)(t,u.a,a.a);this.verticeBuffer=t.createBuffer(),t.bindBuffer(t.ARRAY_BUFFER,this.verticeBuffer),t.bufferData(t.ARRAY_BUFFER,7500,t.DYNAMIC_DRAW);this.indiceBuffer=t.createBuffer(),t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),t.bufferData(t.ELEMENT_ARRAY_BUFFER,6912,t.DYNAMIC_DRAW),this.depthMapTexture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.depthMapTexture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,c,c,0,t.RGBA,t.UNSIGNED_BYTE,null),this.depthMapFrameBuffer=t.createFramebuffer(),t.bindFramebuffer(t.FRAMEBUFFER,this.depthMapFrameBuffer),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,this.depthMapTexture,0),t.bindFramebuffer(t.FRAMEBUFFER,null)}return e.prototype.destroy=function(){var e=this.gl;e.deleteBuffer(this.verticeBuffer),e.deleteBuffer(this.indiceBuffer),e.deleteTexture(this.depthMapTexture),e.deleteFramebuffer(this.depthMapFrameBuffer),this.shader.destroy()},e.prototype._calculateMatrix=function(e,t){var n=t.x,r=e.drawingBufferHeight-t.y-t.height,o=t.width,a=t.height,s=new Float32Array([o,0,0,0,a,0,n,r,1]),u=new Float32Array([2/e.drawingBufferWidth,0,0,0,2/e.drawingBufferHeight,0,-1,-1,1]);return i.mat3.multiply(s,u,s),{matrix:s}},e.prototype.computeDepthMap=function(e,t){var n=this.gl,r=this.shader;n.disable(n.DEPTH_TEST),n.enable(n.BLEND),n.blendFunc(n.ONE,n.ZERO),n.blendEquation(n.FUNC_ADD),n.disable(n.CULL_FACE),n.bindFramebuffer(n.FRAMEBUFFER,this.depthMapFrameBuffer),n.viewport(0,0,c,c),n.clear(n.COLOR_BUFFER_BIT),r.bind(n),n.uniformMatrix3fv(r.u_matrix,!1,this._calculateMatrix(n,t).matrix),n.bindBuffer(n.ARRAY_BUFFER,this.verticeBuffer),n.bufferSubData(n.ARRAY_BUFFER,0,e.vertices),n.vertexAttribPointer(r.vertex,3,n.FLOAT,n.FALSE,0,0),n.bindBuffer(n.ELEMENT_ARRAY_BUFFER,this.indiceBuffer),n.bufferSubData(n.ELEMENT_ARRAY_BUFFER,0,e.indices),n.drawElements(n.TRIANGLES,6*(e.size-1)*(e.size-1),n.UNSIGNED_SHORT,0),n.bindFramebuffer(n.FRAMEBUFFER,null),n.viewport(0,0,n.drawingBufferWidth,n.drawingBufferHeight)},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return g});var r=n(140),i=n(95),o=n(8),a=n(11),s=n(42),u=n(49),c=n(59),l=n(80),p=n(48),d=n(313),f=n(318),h=n(323),m=function(e){function t(r,i){babelHelpers.classCallCheck(this,t);var a=babelHelpers.possibleConstructorReturn(this,e.call(this,r,i));return a._isLinkToggledOn=!1,a._showTooltip=null,a._frameCountAtAnimationStart=-1,a._interactionStartTime=-1,a._inAnimation=!1,a.onSpreadChange=function(e){a._currentSpreadIndex=e,a._isLinkToggledOn=!1,a.forceUpdate()},a.onAnimationStart=function(){a._frameCountAtAnimationStart=a.frameCount,a._interactionStartTime=a.tick,a._inAnimation=!0},a.onAnimationEnd=function(){if(a._inAnimation=!1,a._frameCountAtAnimationStart>=0&&a._interactionStartTime>=0){var e=a.tick-a._interactionStartTime,t=e/(1e3/60),n=t-(a.frameCount-a._frameCountAtAnimationStart);n>0&&a.props.dispatch(o.g(n,e,a._frameCountAtAnimationStart,a.frameCount,a._interactionStartTime,a.tick,a.props.usePageFlip))}},a.showLinkToolTip=function(e){a._showTooltip=e,a.forceUpdate()},a.hideLinkToolTip=function(){a._showTooltip=null,a.forceUpdate()},a.__store__=r.store,a._currentSpreadIndex=n.i(c.a)(r.readMode,r.currentPageNumber),a}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.spreadAnimator=this.children[0];var t={getVisiblePages:function(){return e.spreadAnimator.getVisiblePages()},getVisibleComponents:function(){return e.getVisibleDescendants()},getViewportBBoxForComponent:function(t){return e.component.viewportBBox},getRenderedViews:function(t){return e.getRenderedViews(t)},getReadMode:function(){return e.props.readMode},getPageComponent:function(t){var r=n.i(c.a)(e.props.readMode,t),i=e.spreadAnimator.children[r];return i.children[0].pageNumber===t?i.children[0]:i.children[1]},goToPage:function(e){t.goToSpread(n.i(c.a)(t.getReadMode(),e))},goToSpread:function(t){if(e.props.findIsVisible)return void e.spreadAnimator.jumpToSpread(t,e.tick);var r=e.owner;e.props.dispatch(n.i(i.a)()),setTimeout(function(){r.canvasObjectTree&&r.canvasObjectTree.spreadAnimator.goToSpread(t,e.tick)},0)},jumpToPage:function(e){t.jumpToSpread(n.i(c.a)(t.getReadMode(),e))},jumpToSpread:function(t){e.spreadAnimator.jumpToSpread(t,e.tick)},setSnapping:function(t){return e.spreadAnimator.setSnapping(t,e.tick)},jumpToPositionByPercent:function(t){return e.spreadAnimator.jumpToPositionByPercent(t,e.tick)},zoomCurrentView:function(t){return e.spreadAnimator.getCurrentSpread().setZoom(t,!1)},getPosition:function(){return e.getPosition()},setPosition:function(t){return e.setPosition(t)},tweakAnimation:function(t){e.spreadAnimator.tweakAnimation&&e.spreadAnimator.tweakAnimation(t)}};this.props.dispatch(r.b(t))},t.prototype.componentDidUpdate=function(e){!e.browserTabIsVisible&&this.props.browserTabIsVisible&&(this._interactionStartTime=-1,this._frameCountAtAnimationStart=-1)},t.prototype.componentWillUnmount=function(){this.props.dispatch(r.a())},t.prototype.getChildTree=function(){var e={allowUIToOverlayCover:this.props.allowUIToOverlayCover,canChangePages:this.props.documentPageSpreadList.length>1,currentSpreadIndex:this._currentSpreadIndex,currentPageNumber:this.props.currentPageNumber,disableGestures:this.props.findIsVisible,dispatch:this.props.dispatch,documentPageSpreadList:this.props.documentPageSpreadList,featureTracker:this.props.featureTracker,glManager:this.props.glManager,hideLinkToolTip:this.hideLinkToolTip,isLinksToggledOn:this._isLinkToggledOn,mayRenderLinks:this.props.mayRenderLinks,paywalledPageNumbers:this.props.paywalledPageNumbers,onAnimationEnd:this.onAnimationEnd,onAnimationStart:this.onAnimationStart,onSpreadChange:this.onSpreadChange,readMode:this.props.readMode,showLinkToolTip:this.showLinkToolTip,viewportHeight:this.props.height,viewportWidth:this.props.width,renderManager:this.props.renderManager};return p.a.createElement("group",null,this.props.usePageFlip&&p.a.createElement(h.a,e),!this.props.usePageFlip&&p.a.createElement(d.a,e),p.a.createElement(f.a,{glManager:this.props.glManager,link:this._showTooltip}))},t.prototype.onSingleTapConfirmed=function(e,t,n,r){return this._isLinkToggledOn=!this._isLinkToggledOn,this.forceUpdate(),!0},t.prototype.getPosition=function(){var e=this,t=this.spreadAnimator.getCurrentSpread(),r=t.children,i=void 0;if(r.length<2)i=r[0];else{var o=p.a.RectPool.get(0,0,this.props.width,this.props.height),a=r[0].viewportBBox,s=r[1].viewportBBox,u=n.i(l.b)(o,a)-n.i(l.b)(o,s);i=u>0?r[0]:u<0?r[1]:r.find(function(t){return t.model.pageNumber===e.props.currentPageNumber}),p.a.RectPool.release(o)}if(!i)return null;var c=t.getCenter(),d=i.transform.inverse().transformPoint(c.x*t.width,c.y*t.height);return{x:d[0]/i.width,y:d[1]/i.height,zoom:t.getZoom(),pageNumber:i.pageNumber}},t.prototype.setPosition=function(e){var t=n.i(c.a)(this.props.readMode,e.pageNumber),r=this.spreadAnimator.children[t],i=r.children.find(function(t){return t.pageNumber===e.pageNumber});r.scroller.zoom=e.zoom;var o=i.transform.transformPoint(e.x*i.width,e.y*i.height);r.setCenter({x:o[0],y:o[1]}),this.spreadAnimator.jumpToSpread(t,this.tick),this.requestRedraw()},t.prototype.getRenderedViews=function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],t={},r={x:0,y:0,width:this.width,height:this.height};return p.a.traverse(this,function(i,o,a,s){if(!n.i(l.b)(r,o))return!1;if(e&&!i.isVisible)return!0;t.hasOwnProperty(i.displayName)||(t[i.displayName]=[]);for(var u={},c=Object.keys(i).concat(Object.getOwnPropertyNames(Object.getPrototypeOf(i))),p=c,d=Array.isArray(p),f=0,p=d?p:p[Symbol.iterator]();;){var h;if(d){if(f>=p.length)break;h=p[f++]}else{if(f=p.next(),f.done)break;h=f.value}var m=h,g=i[m];"number"!=typeof g&&"string"!=typeof g&&"boolean"!=typeof g||(u[m]=g)}var v=i.model||{};return t[i.displayName].push(Object.assign(i.viewportBBox,{model:v,view:u})),!0}),JSON.parse(JSON.stringify(t))},babelHelpers.createClass(t,[{key:"tick",get:function(){return this.owner._lastTick}},{key:"frameCount",get:function(){return this.owner.frameCount}},{key:"inAnimation",get:function(){return this._inAnimation}}]),t}(p.a),g=p.a.connect(m,function(e){return{allowUIToOverlayCover:a.selectIsSmallReader(e)||e.features.allowUIToOverlayCover,browserTabIsVisible:!e.visibility.isHidden,currentPageNumber:e.reader.currentPageNumber||e.reader.initialPageNumber,currentSpreadIndex:e.reader.currentSpreadIndex,documentPageSpreadList:a.selectPageSpreadList(e),findIsVisible:s.a.isVisible(e),featureTracker:e.featureTracker,mayRenderLinks:a.mayRenderLinks(e)&&!s.a.isVisible(e),paywalledPageNumbers:u.b.previewPages(e)}})},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n    <svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="1px" height="1px">\n    <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g>  <g transform="translate(16,179)">    <path fill="#995ba5" d="m 0,8 A 8,8 0 0,1 8,0 H 15 l 6,4 3,0 6,-4 H 40 H 136.64189910888672 v 35 H 29.5 l -6,4 -3,0 -6,-4 H 8 a 8,8 0 0,1 -8,-8 z M 47.832489013671875,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z M 126.64189910888672,5 h -14.5 v 5 c 0,10 -8,-8 -8,7.5 s 8,-2.5 8,7.5 v 6 h 14.5 z"></path>\n    </g></svg>\n'},function(e,t,n){"use strict";function r(e){for(var t={x:0,y:0},n=0;n<e.length;n++)t.x+=e[n].x,t.y+=e[n].y;return{x:t.x/e.length,y:t.y/e.length}}function i(e,t){for(var n=e.length-1;n>=0;n--){var r=e[n];if(t(r))return r}}n.d(t,"a",function(){return R});var o=n(10),a=n.n(o),s=n(2),u=n.n(s),c=n(47),l=n(108),p=n(48),d=n(331),f=n(110),h=n(22),m=n(140),g=n(79),v=n(35),b=n(80),y=n(11),_=n(95),w=n(96),E=n(142),x=n(49),S=n(320),T=n(218),C=n(392),I=n(746),M=(n.n(I),function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),P.call(r),i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this._webglEnabled=!1,this._singleTapWasHandled=!1,this._lastMoveHitlist=[],this._handlersOfCurrentGesture=[],this._lastTick=0,this.frameCount=0,this.createContextAndInitializeCanvas(),this.fallbackTo2DIfViewportExceedGPULimit(),this.buildCanvasObjectTree(),this.canvasObjectTree?this.canvasObjectTree.requestRedraw():this.props.dispatch(m.a()),this.inputHandler=new g.a(this.refs.canvasContainer,{getScalingFactor:function(){return n.i(v.a)()},catchWheelEvent:function(){return e.props.fullscreenEnabled},onSingleTap:function(t,n){e._singleTapWasHandled=e.bubbleEvent(function(e){return e.onSingleTap},t,n,e._lastTick).handled,e.inputHandler.requestToIntercept()},onSingleTapConfirmed:function(t,n){e.bubbleEvent(function(e){return e.onSingleTapConfirmed},t,n,e._lastTick,e._singleTapWasHandled),e._singleTapWasHandled=!1,e.props.dispatch(h.e())},onDoubleTap:function(t,n){e.bubbleEvent(function(e){return e.onDoubleTap},t,n,e._lastTick),e.props.dispatch(h.f())},onGestureStart:function(t,i){e.props.dispatch(n.i(_.a)());var o=r(t),a=o.x,s=o.y;e.bubbleEvent(function(e){return e.onGestureStart},a,s,e._lastTick,t,i).possibleHandlers.forEach(function(t){e._handlersOfCurrentGesture.push(t)}),e.props.dispatch(h.g())},onGestureChange:function(t,n,o,a){e.releaseMouseHitlist(n);var s=r(t),u=s.x,c=s.y;i(e._handlersOfCurrentGesture,function(r){return!(!r.onGestureChange||!r.onGestureChange(u,c,e._lastTick,t,n,o,a))&&(e.inputHandler.requestToIntercept(),!0)}),e.props.dispatch(h.h())},onGestureEnd:function(t){i(e._handlersOfCurrentGesture,function(n){return n.onGestureEnd&&n.onGestureEnd(e._lastTick,t)}),e._handlersOfCurrentGesture.length=0,e.props.dispatch(h.i())},onMouseEnter:function(t){e.props.dispatch(n.i(_.a)())},onMouseMove:function(t,n,r){e.updateMouseHitlist(t,n,r)},onMouseLeave:function(t){e.releaseMouseHitlist(t)}});var t=function t(r){e._lastTick=r;var i=n.i(v.a)(),o=e.canvas.clientWidth*i,a=e.canvas.clientHeight*i;o!==e.props.width||a!==e.props.height?(e.props.dispatch(n.i(f.a)(o,a)),e.props.dispatch(h.j())):e.canvasObjectTree&&e.canvasObjectTree.hasPendingRedraw&&e.drawCanvasObjectTree(),requestAnimationFrame(t)};requestAnimationFrame(t)},t.prototype.componentWillReceiveProps=function(e){var t=this,n=this.props;this.props=e;var r=n.readMode!==this.props.readMode||n.usePageFlip!==this.props.usePageFlip||n.visible!==this.props.visible||n.linksLoaded!==this.props.linksLoaded;this.canvasObjectTree&&r&&(this.previousPosition=this.canvasObjectTree.getPosition(),p.a.unmountTree(this.canvasObjectTree),this.canvasObjectTree=null),n.usePageFlip!==this.props.usePageFlip&&this.createContextAndInitializeCanvas();var i=n.width!==this.props.width||n.height!==this.props.height;i&&(this.canvas.width=this.props.width,this.canvas.height=this.props.height,this.fallbackTo2DIfViewportExceedGPULimit()),this.props.usePageFlip&&(i&&this.ctx&&this.ctx.viewport(0,0,this.ctx.drawingBufferWidth,this.ctx.drawingBufferHeight),/(iPad|iPhone|iPod).*(AppleWebKit\/).*(Version\/9\.).*(Mobile\/).*(Safari\/)/i.test(navigator.userAgent)&&(n.visible&&!this.props.visible&&(this.canvas.style.display=""),!n.visible&&this.props.visible&&(this.canvas.style.display="none",setTimeout(function(){t.canvas.style.display=""},250)))),this.buildCanvasObjectTree(i),this.canvasObjectTree&&this.canvasObjectTree.requestRedraw(),1===this.props.zoomLevel?this.inputHandler.enableBrowserHandlingOfVerticalPanningGestures():this.inputHandler.disableBrowserHandlingOfAllPanningGestures()},t.prototype.shouldComponentUpdate=function(){return!1},t.prototype.componentWillUnmount=function(){this.inputHandler&&this.inputHandler.destroy(),this.renderManager&&this.renderManager.release(),this.glManager&&(this.glManager.destroy(),this.glManager=null),this.ctx=null,this._glExtOesStandardDerivatives=null,this.canvas.removeEventListener("webglcontextlost",this.handleContextLost,!1),this.canvas.removeEventListener("webglcontextrestored",this.handleContextRestored,!1)},t.prototype.render=function(){return u.a.createElement("div",{ref:"canvasContainer",style:{width:"100%",height:"100%"}})},t}(s.Component));M.displayName="Canvas",M.contextTypes={store:a.a.object};var P=function(){var e=this;this.onFallbackTo2D=function(){e.inputHandler&&e.inputHandler.reset(),e.props.tracker.monitorBatched({type:"reader3-fallback-to-2d",fallback:1})},this.getCustomCursor=function(){for(var t=e._lastMoveHitlist.length-1;t>=0;t--)if(e._lastMoveHitlist[t].getCustomCursor&&e._lastMoveHitlist[t].getCustomCursor())return e._lastMoveHitlist[t].getCustomCursor();return"default"},this.createRenderManager=function(){var t=null;t=e.props.usePageFlip?new C.a(e.ctx,e.props.width,e.props.height):new C.b(e.props.width,e.props.height);var n=new T.a(t,e.props.documentPages,e.props.config,e.props.loadStatsTracker,e.props.paywallPreviewPages);e.renderManager&&n.reusePageData(e.renderManager),e.renderManager&&e.renderManager.release(),e.renderManager=n},this.createContextAndInitializeCanvas=function(){var t=document.createElement("canvas");if(t.className="document-canvas",t.style.width=t.style.height="100%",t.width=e.props.width,t.height=e.props.height,e.glManager&&(e.glManager.destroy(),e.glManager=null),e.canvas?(e._glExtOesStandardDerivatives=null,e.canvas.removeEventListener("webglcontextlost",e.handleContextLost,!1),e.canvas.removeEventListener("webglcontextrestored",e.handleContextRestored,!1),e.refs.canvasContainer.replaceChild(t,e.canvas)):e.refs.canvasContainer.appendChild(t),e.canvas=t,e.props.usePageFlip){var r=void 0;r=n.i(E.a)(e.canvas,e.props.withStencilBuffer),e.ctx=r,r?(e._glExtOesStandardDerivatives=r.getExtension("OES_standard_derivatives"),r.viewport(0,0,r.drawingBufferWidth,r.drawingBufferHeight),e.glManager=new S.a(r),e.canvas.addEventListener("webglcontextlost",e.handleContextLost,!1),e.canvas.addEventListener("webglcontextrestored",e.handleContextRestored,!1)):e.handleWebGLError()}else e.ctx=e.canvas.getContext("2d")},this.findComponentsAtPoint=function(t,r){var i=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],o=[];return e.canvasObjectTree&&p.a.traverse(e.canvasObjectTree,function(e,a,s,u){return!(i&&!e.isVisible)&&(!!n.i(b.a)(t,r,a)&&(o.push(e),!0))}),o},this.bubbleEvent=function(t,n,r){for(var o=arguments.length,a=Array(o>3?o-3:0),s=3;s<o;s++)a[s-3]=arguments[s];for(var u={handled:!1,possibleHandlers:[]},c=e.findComponentsAtPoint(n,r),l=Array.isArray(c),p=0,c=l?c:c[Symbol.iterator]();;){var d;if(l){if(p>=c.length)break;d=c[p++]}else{if(p=c.next(),p.done)break;d=p.value}var f=d;t(f)&&u.possibleHandlers.push(f)}return i(u.possibleHandlers,function(e){var i=t(e);return!(!i||!i.call.apply(i,[e,n,r].concat(a)))&&(u.handled=!0,!0)}),u},this.updateMouseHitlist=function(t,n,r){var o=e.findComponentsAtPoint(t,n,!1),a=o[o.length-1],s=e._lastMoveHitlist[e._lastMoveHitlist.length-1];a!==s&&(s&&s.onMouseLeave&&s.onMouseLeave(r,e._lastTick),a&&a.onMouseEnter&&a.onMouseEnter(r,e._lastTick)),e._lastMoveHitlist=o,i(o,function(e){return e.onMouseMove&&e.onMouseMove(t,n,r)})},this.releaseMouseHitlist=function(t){var n=e._lastMoveHitlist[e._lastMoveHitlist.length-1];n&&n.onMouseLeave&&n.onMouseLeave(t,e._lastTick),e._lastMoveHitlist=[]},this.fallbackTo2DIfViewportExceedGPULimit=function(){if(e.ctx&&n.i(E.b)(e.ctx)){var t=e.props.width-e.ctx.drawingBufferWidth>1,r=e.props.height-e.ctx.drawingBufferHeight>1;(t||r)&&(t&&e.props.dispatch(n.i(_.b)(e.ctx.drawingBufferWidth)),r&&e.props.dispatch(n.i(_.c)(e.ctx.drawingBufferHeight)),e.onFallbackTo2D())}},this.handleWebGLError=function(t){t&&n.i(l.b)(t,{extra:{"fallback-to-2d":!0}}),e.onFallbackTo2D(),e.props.dispatch(n.i(_.d)())},this.buildCanvasObjectTree=function(t){if(e.props.visible&&!(!e.ctx||n.i(E.b)(e.ctx)&&e.ctx.isContextLost())){try{e.canvasObjectTree&&!t||e.createRenderManager(),e.canvasObjectTree=p.a.buildTree(p.a.createElement(d.a,{ctx:e.ctx,height:e.props.height,loadStatsTracker:e.props.loadStatsTracker,readMode:e.props.readMode,renderManager:e.renderManager,store:e.context.store,usePageFlip:e.props.usePageFlip,width:e.props.width}),e.canvasObjectTree,e)}catch(t){if(!n.i(E.b)(e.ctx))throw t;e.handleWebGLError(t)}e.canvasObjectTree&&e.previousPosition&&(e.canvasObjectTree.setPosition(e.previousPosition),e.previousPosition=null)}},this.drawCanvasObjectTree=function(){if(e.ctx&&e.props.visible){if(n.i(E.b)(e.ctx)){if(e.ctx.isContextLost())return}else e.ctx.clearRect(0,0,e.props.width,e.props.height);try{var t={x:0,y:0,width:e.props.width,height:e.props.height};n.i(E.b)(e.ctx)?p.a.drawWebgl(e.canvasObjectTree,e.glManager,t,e._lastTick):p.a.draw2d(e.canvasObjectTree,e.ctx,t,e._lastTick)}catch(t){if(!n.i(E.b)(e.ctx))throw t;e.handleWebGLError(t)}var r=e.getCustomCursor();e.refs.canvasContainer&&e.refs.canvasContainer.style.cursor!==r&&(e.refs.canvasContainer.style.cursor=r),e.frameCount+=1}},this.handleContextLost=function(t){t.preventDefault(),e.props.onWebGLContextLost&&e.props.onWebGLContextLost(),e.props.dispatch(n.i(_.e)())},this.handleContextRestored=function(t){e.props.onWebGLContextRestored&&e.props.onWebGLContextRestored(),e.buildCanvasObjectTree(),e.canvasObjectTree&&e.canvasObjectTree.requestRedraw()},this._webglEnabled=!1,this._singleTapWasHandled=!1,this._lastMoveHitlist=[],this._handlersOfCurrentGesture=[],this._lastTick=0,this.frameCount=0},R=n.i(c.b)(function(e){return{height:e.size.height,width:e.size.width,readMode:n.i(y.selectReadMode)(e),visible:!e.visibility.supported||!e.visibility.isHidden,usePageFlip:n.i(_.f)(e),fullscreenEnabled:n.i(y.selectFullscreenEnabled)(e),config:e.config,documentPages:n.i(w.a)(e),dropdownOpen:n.i(y.isDropdownOpen)(e),linksLoaded:e.documentModel.linksLoaded,zoomLevel:e.reader.zoomLevel,paywallPreviewPages:x.b.previewPages(e),isIdle:e.reader.isIdle}},null,null,{pure:!1,withRef:!0})(M)},function(e,t,n){"use strict";n.d(t,"a",function(){return M});var r=n(2),i=n.n(r),o=n(47),a=n(86),s=n.n(a),u=n(57),c=n.n(u),l=n(21),p=n.n(l),d=n(76),f=n(354),h=n(356),m=n(338),g=n(79),v=n(42),b=n(8),y=n(22),_=n(11),w=n(388),E=n(96),x=n(41),S=n(20),T=n(205),C=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onReadOnIssuuClick=function(){r.props.brandingFeature.kind===x.ISSUU_BRANDING_KIND.LANDING_PAGE&&(window.open("https://issuu.com","_blank"),r.props.dispatch(y.a()),r.props.featureTracker.usage(S.b.BUTTON_LOGO))},r.onToggleFullscreenClick=function(){r.props.toggleFullscreen(),r.props.featureTracker.usage(S.b.BUTTON_FULLSCREEN),r.props.dispatch(y.a())},r.onSliderActivityStart=function(){r.props.dispatch(b.p(!0)),r.props.dispatch(y.k())},r.onSliderActivityChange=function(){r.props.dispatch(y.k())},r.onSliderActivityEnd=function(){r.props.dispatch(b.p(!1)),r.props.dispatch(y.k())},r.getReadOnIssuuTooltip=function(){return r.props.brandingFeature.kind===x.ISSUU_BRANDING_KIND.LANDING_PAGE?"See more on issuu":null},r.handlePageSliderOnChangeStart=function(){r.props.canvasApi.setSnapping(!1),r.onSliderActivityStart(),r._percentBeforeSlider=r.props.currentPageSliderPosition},r.handlePageSliderOnChange=function(e){r.onSliderActivityChange(),r.props.canvasApi.jumpToPositionByPercent(e)},r.handlePageSliderOnChangeEnd=function(e){r.props.canvasApi.setSnapping(!0),r.onSliderActivityEnd(),r.props.currentPageSliderPosition!==r._percentBeforeSlider&&r.props.featureTracker.usage(S.b.SLIDER_PAGES)},r.handleZoomSliderOnChangeStart=function(){r.onSliderActivityStart()},r.handleZoomSliderOnChange=function(e){r.onSliderActivityChange(),r.props.canvasApi.zoomCurrentView(e)},r.handleZoomSliderOnChangeEnd=function(){r.onSliderActivityEnd()},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.inputHandler=new g.a(s.a.findDOMNode(this.refs.controlsContainer),{onMouseEnter:function(){e.props.visible&&e.props.dispatch(b.n(!0))},onMouseLeave:function(){e.props.dispatch(b.n(!1))}}),this.props.featureTracker.opportunity(S.b.SLIDER_PAGES)},t.prototype.shouldComponentUpdate=function(e,t){var n=this.props.visible!==e.visible;return e.visible&&(n=n||!(c()(this.props,e)&&c()(this.state,t))),n},t.prototype.componentWillUnmount=function(){this.inputHandler&&this.inputHandler.destroy()},t.prototype.render=function(){var e=void 0;this.props.brandingFeature&&!this.props.isTinyEmbed&&this.props.brandingFeature.kind===x.ISSUU_BRANDING_KIND.LANDING_PAGE&&(e=i.a.createElement("div",{className:"controls__read-on-issuu"},i.a.createElement("div",{className:"controls__read-on-issuu-button","data-tooltip":this.getReadOnIssuuTooltip()},i.a.createElement(d.a,{className:"svg-btn logo-icon",onClick:this.onReadOnIssuuClick,content:T.a}))),this.props.featureTracker.opportunity(S.b.BUTTON_LOGO));var t=null;if(this.props.fullscreenFeature){var n=!1;switch(this.props.fullscreenFeature.showButtons){case x.FULLSCREEN_BUTTON.ALWAYS:n=!0;break;case x.FULLSCREEN_BUTTON.HIDE:n=this.props.fullscreenIsSupported}n&&(t=i.a.createElement(m.a,{fullscreenEnabled:this.props.fullscreenEnabled,toggleFullscreen:this.onToggleFullscreenClick}),this.props.featureTracker.opportunity(S.b.BUTTON_FULLSCREEN))}var r=p()("controls",{"controls--hidden":!this.props.visible});return i.a.createElement("div",{className:r,ref:"controlsContainer"},i.a.createElement("div",{className:"controls__part controls__part--page-controls"},i.a.createElement(f.a,{currentPageSliderPosition:this.props.currentPageSliderPosition,currentPageNumbers:this.props.currentPageNumbers,pageCount:this.props.pageCount,pageSliderOnChangeStart:this.handlePageSliderOnChangeStart,pageSliderOnChange:this.handlePageSliderOnChange,pageSliderOnChangeEnd:this.handlePageSliderOnChangeEnd,segments:this.props.pageSegments,resultMarkers:this.props.resultMarkers})),this.props.zoomFeature&&i.a.createElement("div",{className:"controls__part controls__part--zoom-controls"},i.a.createElement(h.a,{currentZoomLevel:this.props.zoomLevel,dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,segments:this.props.zoomSegments,zoomSliderOnChangeStart:this.handleZoomSliderOnChangeStart,zoomSliderOnChange:this.handleZoomSliderOnChange,zoomSliderOnChangeEnd:this.handleZoomSliderOnChangeEnd})),e&&i.a.createElement("div",{className:"controls__part"},e),this.props.enableFind&&i.a.createElement("div",{className:"controls__part"},i.a.createElement(v.b.FindButton,{featureTracker:this.props.featureTracker})),t&&i.a.createElement("div",{className:"controls__part controls__part--fullscreen-controls"},t))},t}(r.Component);C.displayName="Controls";var I=function(e){return{brandingFeature:_.selectIssuuBrandingFeature(e),canvasApi:e.canvasApi,enableFind:e.features.enableFind,currentPageNumbers:_.selectCurrentPageNumbers(e).join("-"),currentPageSliderPosition:_.selectCurrentPositionInPercent(e),featureTracker:e.featureTracker,fullscreenEnabled:_.selectFullscreenEnabled(e),fullscreenIsSupported:e.fullscreen.supported,pageCount:n.i(E.e)(e),pageSegments:w.a(e),resultMarkers:v.a.selectResultMarkers(e),fullscreenFeature:_.selectFullscreenFeature(e),zoomFeature:_.selectZoomFeature(e),zoomLevel:e.reader.zoomLevel,zoomSegments:w.b(e)}},M=n.i(o.b)(I,void 0,void 0,{pure:!1})(C)},function(e,t,n){"use strict";n.d(t,"a",function(){return g});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(86),u=n.n(s),c=n(8),l=n(22),p=n(76),d=n(79),f=n(20),h=n(203),m=n(204),g=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onClickHandler=function(){r.props.featureTracker.usage(f.b.BUTTON_CTA_OVERLAY),r.props.dispatch(l.a()),r.props.toggleFullscreen()},r.trackOpportunities=function(){r.props.visible&&r.props.featureTracker.opportunity(f.b.BUTTON_CTA_OVERLAY)},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.inputHandler=new d.a(u.a.findDOMNode(this.refs.button),{onMouseEnter:function(){e.props.visible&&e.props.dispatch(c.n(!0))},onMouseLeave:function(){e.props.dispatch(c.n(!1))}}),this.trackOpportunities()},t.prototype.componentDidUpdate=function(){this.trackOpportunities()},t.prototype.render=function(){var e=this.props.fullscreenEnabled?h.a:m.a,t=this.props.fullscreenEnabled?"Exit":"Fullscreen";return i.a.createElement("div",{ref:"button",className:"cta-overlay "+(this.props.visible?"":"cta-overlay--hidden"),"data-tooltip":t,onClick:this.onClickHandler},i.a.createElement(p.a,{id:"ird3-button-fullscreen",className:"svg-btn cta-overlay__button",content:e}))},t}(r.Component);g.displayName="CTAOverlay",g.propTypes={dispatch:a.a.func.isRequired,featureTracker:a.a.object.isRequired,fullscreenEnabled:a.a.bool.isRequired,toggleFullscreen:a.a.func.isRequired,visible:a.a.bool.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(2),i=n.n(r),o=n(8),a=n(22),s=n(20),u=n(10),c=n.n(u),l=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var u=arguments.length,c=Array(u),l=0;l<u;l++)c[l]=arguments[l];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(c))),r.onDimmerClick=function(){r.props.dispatch(o.m()),r.props.dispatch(a.a())},r.onDownloadFromIssuuLinkClick=function(){r.props.featureTracker.usage(s.b.DOWNLOAD_FROM_ISSUU_LINK),r.onDimmerClick()},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){this.props.visible&&this.props.featureTracker.opportunity(s.b.DOWNLOAD_FROM_ISSUU_LINK)},t.prototype.render=function(){return i.a.createElement("div",{className:"download-dropdown"},i.a.createElement("div",{className:"download-dropdown__dimmer",onClick:this.onDimmerClick}),i.a.createElement("div",{className:"download-dropdown__inner"},i.a.createElement("div",{className:"download-dropdown__content"},i.a.createElement("span",null,"Go to "),i.a.createElement("a",{href:this.props.downloadUrl,onClick:this.onDownloadFromIssuuLinkClick,className:"download-dropdown__download-link",target:"_blank"},"issuu.com"),i.a.createElement("span",null," and sign in or create a free account to download"))))},t}(r.Component);l.displayName="DownloadDropdown",l.propTypes={dispatch:c.a.func.isRequired,downloadUrl:c.a.string.isRequired,featureTracker:c.a.object.isRequired,visible:c.a.bool.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return p});var r=n(2),i=n.n(r),o=n(340),a=n(207),s=n(132),u=n(357),c=n(10),l=n.n(c),p=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onRetry=function(e){e.preventDefault(),r.props.loadDocument()},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.props.error.code===u.a&&window.setTimeout(function(){e.props.loadDocument()},1e4)},t.prototype.render=function(){var e="Something went wrong",t=i.a.createElement("div",{className:"failed__icon",dangerouslySetInnerHTML:{__html:o.a}}),n={},r={};switch(this.props.error.code){case u.b:e="Conversion failed",t=i.a.createElement("div",{className:"failed__icon",dangerouslySetInnerHTML:{__html:a.a}}),n.display="none",r.display="none";break;case u.a:e="Document is getting ready, hang on",t=i.a.createElement("div",{className:"failed__icon"},i.a.createElement(s.a,null)),n.display="none",r.display="none";break;case u.c:e="This publication is no longer available\ndue to a copyright claim by a third party.",t=i.a.createElement("div",{className:"failed__icon",dangerouslySetInnerHTML:{__html:a.a}}),n.display="none",r.display="none";break;case u.d:case u.e:case u.f:case u.g:case u.h:case u.i:case u.j:e="Sorry, this publication is not available",n.display="none",r.display="none"}return i.a.createElement("div",{className:"failed"},t,i.a.createElement("h1",{className:"failed__message"},e),i.a.createElement("div",{className:"failed__retry-link-container",style:n},i.a.createElement("a",{className:"failed__retry-link",href:"#",onClick:this.onRetry},"Try again")),i.a.createElement("div",{className:"failed__help"},i.a.createElement("div",{className:"failed__error-token",style:r},"Error ID: ",this.props.sessionId),i.a.createElement("div",{className:"failed__spacer",style:r}),i.a.createElement("div",{className:"failed__support-link-container"},i.a.createElement("a",{className:"failed__support-link",href:"http://help.issuu.com",target:"_blank"},"help.issuu.com"))))},t}(r.Component);p.displayName="Failed",p.propTypes={error:l.a.object.isRequired,loadDocument:l.a.func.isRequired,sessionId:l.a.string.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(76),u=n(203),c=n(204),l=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e,t){return this.props.fullscreenEnabled!==e.fullscreenEnabled},t.prototype.render=function(){var e=this.props.fullscreenEnabled?u.a:c.a;return i.a.createElement("div",{className:"fullscreen-controls"},i.a.createElement("div",{className:"fullscreen-controls__button","data-tooltip":this.props.fullscreenEnabled?"Exit":"Fullscreen"},i.a.createElement(s.a,{id:"ird3-button-fullscreen",className:"svg-btn ",onClick:this.props.toggleFullscreen,content:e})))},t}(r.Component);l.displayName="FullscreenControls",l.propTypes={fullscreenEnabled:a.a.bool.isRequired,toggleFullscreen:a.a.func.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return k});var r=n(2),i=n.n(r),o=n(86),a=n.n(o),s=n(21),u=n.n(s),c=n(47),l=n(79),p=n(378),d=n(346),f=n(336),h=n(94),m=n(8),g=n(129),v=n(22),b=n(11),y=n(214),_=n(93),w=n(215),E=n(216),x=n(109),S=n(209),T=n(342),C=n(341),I=n(207),M=n(206),P=n(20),R=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onMoreToggleClick=function(){r.props.readMoreDropdownVisible?r.props.dispatch(m.f()):r.props.readMorePlugin&&(r.props.readMorePlugin.clearButtonUnreadCount(),r.props.dispatch(m.k()),r.props.featureTracker.usage(P.b.BUTTON_MORE)),r.props.dispatch(v.a())},r.onInfoToggleClick=function(){r.props.dispatch(m.l()),r.props.dispatch(v.a()),r.props.featureTracker.usage(P.b.BUTTON_INFO)},r.onDownloadButtonClick=function(){r.props.downloadButtonStatus===g.a.DOWNLOAD_READY&&(r.props.dispatch(r.props.canDownloadAnonymously?g.b():m.m()),r.props.dispatch(v.a()),r.props.featureTracker.usage(P.b.BUTTON_DOWNLOAD))},r.trackOpportunities=function(){r.props.shouldRenderReadMoreButton&&r.props.featureTracker.opportunity(P.b.BUTTON_MORE),r.props.shouldRenderShareButton&&r.props.featureTracker.opportunity(P.b.BUTTON_SHARE),r.props.shouldRenderInfoButton&&r.props.featureTracker.opportunity(P.b.BUTTON_INFO),r.props.shouldRenderDownloadButton&&r.props.featureTracker.opportunity(P.b.BUTTON_DOWNLOAD)},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this;this.inputHandler=new l.a(a.a.findDOMNode(this.refs.headerControlsContainer),{onMouseEnter:function(){e.props.isVisible&&e.props.dispatch(m.n(!0))},onMouseLeave:function(){e.props.dispatch(m.n(!1))}}),this.trackOpportunities()},t.prototype.componentDidUpdate=function(e,t){this.trackOpportunities()},t.prototype.render=function(){var e=u()("header-controls",{"is-visible":this.props.isVisible}),t=u()("header-controls__share-dropdown-wrapper",{"is-visible":this.props.shareDropdownVisible}),n=u()("header-controls__info-dropdown-wrapper",{"is-visible":this.props.infoDropdownVisible}),r=u()("header-controls__button","header-controls__info-toggle",{"is-visible":!h.a.isMobile(),"header-controls__info-toggle--active":this.props.infoDropdownVisible}),o=u()("header-controls__download-dropdown-wrapper",{"is-visible":this.props.downloadDropdownVisible}),a=u()({"header-controls__item--tooltip":!this.props.downloadDropdownVisible}),s=u()("header-controls__button","header-controls__download",{"is-visible":!0,"is-loading":this.props.downloadButtonStatus===g.a.DOWNLOAD_LOADING,"is-failure":this.props.downloadButtonStatus===g.a.DOWNLOAD_FAILURE,spinner:this.props.downloadButtonStatus===g.a.DOWNLOAD_LOADING}),c=C.a,l="Download";return this.props.downloadButtonStatus===g.a.DOWNLOAD_LOADING?(c=M.a,l="Downloading"):this.props.downloadButtonStatus===g.a.DOWNLOAD_FAILURE&&(c=I.a,l="Failed to download"),i.a.createElement("div",{ref:"headerControlsContainer",className:e},i.a.createElement("div",{className:"header-controls__items"},this.props.shouldRenderInfoButton&&i.a.createElement("div",{className:"header-controls__item"},i.a.createElement("div",{className:r,onClick:this.onInfoToggleClick,dangerouslySetInnerHTML:{__html:T.a}}),i.a.createElement("div",{className:n},i.a.createElement(d.a,{coverImageUrl:this.props.coverImageUrl,dispatch:this.props.dispatch,documentTitle:this.props.documentTitle,featureTracker:this.props.featureTracker,profileImageUrl:this.props.publisherProfileImageUrl,publishDate:this.props.publishDate,publisherName:this.props.publisherName,publisherUrl:this.props.publisherUrl,visible:this.props.infoDropdownVisible}))),this.props.shouldRenderDownloadButton&&i.a.createElement("div",{className:"header-controls__item"},i.a.createElement("div",{className:a,"data-tooltip":l},i.a.createElement("div",{className:s,onClick:this.onDownloadButtonClick,dangerouslySetInnerHTML:{__html:c}})),i.a.createElement("div",{className:o},i.a.createElement(f.a,{dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,downloadUrl:this.props.downloadFromIssuuUrl,visible:this.props.downloadDropdownVisible}))),i.a.createElement("div",{className:"header-controls__item header-controls__item--spacer"}),this.props.shouldRenderReadMoreButton&&i.a.createElement("div",{className:u()("header-controls__item",{"header-controls__item--centered":this.props.readMoreButtonCentered})},i.a.createElement("div",{className:u()("header-controls__more-toggle",{"header-controls__more-toggle--activated":this.props.readMoreDropdownVisible}),onClick:this.onMoreToggleClick},i.a.createElement("span",{className:"header-controls__more-toggle-text-wrapper"},"See More",this.props.readMoreButtonUnreadCount>0&&i.a.createElement("div",{className:"header-controls__morecount"},this.props.readMoreButtonUnreadCount)))),this.props.shouldRenderShareButton&&i.a.createElement("div",{className:"header-controls__item"},i.a.createElement(p.a,{dispatch:this.props.dispatch,featureTracker:this.props.featureTracker}),i.a.createElement("div",{className:t},i.a.createElement(p.b,{dispatch:this.props.dispatch,documentTitle:this.props.documentTitle,documentUrl:this.props.documentUrl,coverImageUrl:this.props.coverImageUrl,visible:this.props.shareDropdownVisible,featureTracker:this.props.featureTracker})))))},t}(r.Component);R.displayName="HeaderControls";var O=function(e){return{coverImageUrl:w.a(e),documentTitle:e.documentModel.title,documentUrl:b.selectDocumentUrlOnProduction(e),featureTracker:e.featureTracker,publishDate:e.documentModel.publishDate,publisherName:e.documentModel.userDisplayName,publisherProfileImageUrl:E.c(e),publisherUrl:E.d(e),readMorePlugin:e.readMorePlugin,downloadFromIssuuUrl:"https://"+e.config.hosts.main+"/"+e.documentModel.username+"/docs/"+e.documentModel.documentName+"/#download",shouldRenderDownloadButton:y.a(e),shouldRenderInfoButton:y.b(e),shouldRenderReadMoreButton:x.selectShouldRenderButton(e),shouldRenderShareButton:p.c(e),downloadButtonStatus:e.headerControls.downloadButtonStatus,canDownloadAnonymously:_.canDownloadAnonymously(e),infoDropdownVisible:e.headerControls.visibleDropdown===S.a,downloadDropdownVisible:e.headerControls.visibleDropdown===S.b,readMoreButtonCentered:h.a.isMobile()&&window.innerWidth<window.innerHeight,readMoreButtonUnreadCount:x.selectButtonUnreadCount(e),isVisible:b.isControlsVisible(e)&&(x.selectShouldRenderButton(e)||p.c(e)||y.a(e)||y.b(e)),readMoreDropdownVisible:b.moreOverlayVisible(e),shareDropdownVisible:p.d(e)}},k=n.i(c.b)(O,void 0,void 0,{pure:!0})(R)},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n    <svg width="43" height="36" viewBox="0 0 43 36" xmlns="http://www.w3.org/2000/svg">\n        <title>Rectangle 425 + Rectangle 425 Copy 2 + Rectangle 429</title>\n        <g fill="#9AA8A9" fill-rule="evenodd" opacity=".3">\n            <path d="M42.934 18.503c.032-.338-.107-.682-.396-.9L30.273 8.36c-.435-.327-1.08-.243-1.418.206-.34.45-.25 1.084.194 1.42l11.303 8.517L29.05 27.02c-.446.336-.535.97-.195 1.42.338.45.983.533 1.418.205l12.265-9.242c.29-.218.428-.562.396-.9zM.466 18.503c-.032-.338.107-.682.397-.9L13.127 8.36c.435-.327 1.08-.243 1.418.206.34.45.25 1.084-.194 1.42L3.05 18.502 14.35 27.02c.446.336.536.97.195 1.42-.338.45-.983.533-1.418.205L.863 19.403c-.29-.218-.43-.562-.397-.9z"/><rect transform="rotate(14 22.02 17.898)" x="21.039" y="-.102" width="1.964" height="36" rx=".982"/>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";n.d(t,"a",function(){return i});var r='d="M7.593 13.866c.07.072.153.13.247.165.08.04.16.06.26.06l.01.005c.18 0 .36-.08.5-.223l4.037-4.016c.282-.253.282-.688 0-.967-.258-.277-.697-.277-.978 0L8.8 11.723V.732C8.8.357 8.48.04 8.1.04 7.72.04 7.4.356 7.4.73v10.992L4.52 8.885c-.26-.277-.7-.277-.98 0-.28.258-.28.693 0 .97l4.053 4.01zm6.398 3.228L2 17.1c-2.02 0-1.24-1.356.02-1.356l11.975-.005c1.26 0 2.024 1.36.005 1.36l-.01-.006z" fill="#F2F2F2" fill-rule="evenodd"',i='<svg width="16" height="18" viewBox="-2 0 20 18" xmlns="http://www.w3.org/2000/svg">\n  <path class="shadow" '+r+'></path>\n  <path class="icon" '+r+"></path>\n</svg>"},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='<svg width="100%" height="100%" viewBox="-1 0 18 16">\n    <g stroke="none" stroke-width="1" fill-rule="evenodd">\n        <g transform="translate(-24.000000, -77.000000)">\n            <path class="shadow" d="M32,93 C36.418278,93 40,89.418278 40,85 C40,80.581722 36.418278,77 32,77 C27.581722,77 24,80.581722 24,85 C24,89.418278 27.581722,93 32,93 Z M30.9494629,81.0688477 C30.9494629,80.4383106 31.3006964,80.1230469 32.0031739,80.1230469 C32.7056513,80.1230469 33.0568848,80.4383106 33.0568848,81.0688477 C33.0568848,81.3693049 32.9690764,81.6031079 32.7934571,81.7702637 C32.6178377,81.9374195 32.3544126,82.0209961 32.0031739,82.0209961 C31.3006964,82.0209961 30.9494629,81.7036165 30.9494629,81.0688477 Z M32.9680176,90 L31.0319825,90 L31.0319825,82.9033203 L32.9680176,82.9033203 L32.9680176,90 Z"></path>\n            <path class="icon" d="M32,93 C36.418278,93 40,89.418278 40,85 C40,80.581722 36.418278,77 32,77 C27.581722,77 24,80.581722 24,85 C24,89.418278 27.581722,93 32,93 Z M30.9494629,81.0688477 C30.9494629,80.4383106 31.3006964,80.1230469 32.0031739,80.1230469 C32.7056513,80.1230469 33.0568848,80.4383106 33.0568848,81.0688477 C33.0568848,81.3693049 32.9690764,81.6031079 32.7934571,81.7702637 C32.6178377,81.9374195 32.3544126,82.0209961 32.0031739,82.0209961 C31.3006964,82.0209961 30.9494629,81.7036165 30.9494629,81.0688477 Z M32.9680176,90 L31.0319825,90 L31.0319825,82.9033203 L32.9680176,82.9033203 L32.9680176,90 Z"></path>\n        </g>\n    </g>\n</svg>'},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n    <svg width="100%" height="100%" viewBox="-4 -4 30 52">\n        <defs>\n        </defs>\n        <g fill="none" class="navigation-arrow__shadow" stroke="#000" stroke-width="4" transform="translate(9 22)">\n            <path d="M2.65002234,43.5538147 C1.78774217,42.6020596 1.78774217,41.0560678 2.65002234,40.1030925 L17.6687127,23.4986273 L2.64671013,6.89660245 C1.78442996,5.94362719 1.78442996,4.39885551 2.64671013,3.44588025 C3.5089903,2.49290499 4.90674535,2.49290499 5.76902553,3.44588025 L22.3532899,21.7732662 C23.21557,22.7250212 23.21557,24.2697929 22.3532899,25.2239884 L5.77233774,43.5538147 C5.34174969,44.0309124 4.77646487,44.2688512 4.21118004,44.2688512 C3.64589522,44.2688512 3.08171447,44.0309124 2.65002234,43.5538147 Z" transform="translate(-10.5, -23.5)"/>\n        </g>\n        <g fill="white" class="navigation-arrow__path" transform="translate(9 22)">\n            <path d="M2.65002234,43.5538147 C1.78774217,42.6020596 1.78774217,41.0560678 2.65002234,40.1030925 L17.6687127,23.4986273 L2.64671013,6.89660245 C1.78442996,5.94362719 1.78442996,4.39885551 2.64671013,3.44588025 C3.5089903,2.49290499 4.90674535,2.49290499 5.76902553,3.44588025 L22.3532899,21.7732662 C23.21557,22.7250212 23.21557,24.2697929 22.3532899,25.2239884 L5.77233774,43.5538147 C5.34174969,44.0309124 4.77646487,44.2688512 4.21118004,44.2688512 C3.64589522,44.2688512 3.08171447,44.0309124 2.65002234,43.5538147 Z" transform="translate(-10.5, -23.5)"/>\n        </g>\n    </svg>\n'},function(e,t,n){"use strict";n.d(t,"a",function(){return o});var r='x="17" y="10" width="2" height="16" rx="2"',i='transform="translate(18.000000, 18.000000) scale(-1, -1) rotate(-270.000000) translate(-18.000000, -18.000000) " x="17" y="10" width="2" height="16" rx="2"',o='\n    <svg width="100%" height="100%" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <rect '+r+"></rect>\n                <rect "+i+'></rect>\n            </g>\n        </g>\n        <rect class="shadow" '+r+'></rect>\n        <rect class="shadow" '+i+'></rect>\n        <rect class="icon" '+r+'></rect>\n        <rect class="icon" '+i+"></rect>\n    </svg>\n"},function(e,t,n){"use strict";n.d(t,"a",function(){return i});var r='transform="translate(18.000000, 18.000000) rotate(-270.000000) translate(-18.000000, -18.000000) " x="17" y="10" width="2" height="16" rx="2"',i='\n    <svg width="36px" height="36px" viewBox="0 0 36 36">\n        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g>\n                <rect '+r+'></rect>\n            </g>\n        </g>\n        <rect class="shadow" '+r+'></rect>\n        <rect class="icon" '+r+"></rect>\n    </svg>\n"},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(8),u=n(22),c=n(20),l=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),l=0;l<o;l++)a[l]=arguments[l];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onPublisherLinkClick=function(){r.props.featureTracker.usage(c.b.INFO_PUBLISHER_LINK),r.props.dispatch(u.a())},r.onDimmerClick=function(){r.props.dispatch(s.l()),r.props.dispatch(u.a())},r.formatTimeString=function(e,t){var n="";if(!isNaN(t)){var r=e-t,i=Math.floor(r/1e3),o=Math.floor(i/60),a=Math.floor(o/60),s=Math.floor(a/24),u=Math.floor(s/31),c=Math.floor(u/12);n=c>1?c+" years ago":1===c?c+" year ago":u>1?u+" months ago":1===u?u+" month ago":s>1?s+" days ago":1===s?s+" day ago":a>1?a+" hours ago":1===a?a+" hour ago":o>1?o+" minutes ago":1===o?o+" minute ago":i+" seconds ago"}return n},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){this.props.visible&&this.props.featureTracker.opportunity(c.b.INFO_PUBLISHER_LINK)},t.prototype.render=function(){var e=Date.now(),t=Date.parse(this.props.publishDate),n=this.formatTimeString(e,t);return i.a.createElement("div",{className:"info-dropdown"},i.a.createElement("div",{className:"info-dropdown__dimmer",onClick:this.onDimmerClick}),i.a.createElement("div",{className:"info-dropdown__inner"},i.a.createElement("div",{className:"info-dropdown__cover-image-wrapper"},i.a.createElement("img",{className:"info-dropdown__cover-image",crossOrigin:!0,src:this.props.coverImageUrl})),i.a.createElement("div",{className:"info-dropdown__content"},i.a.createElement("span",{className:"info-dropdown__title"},this.props.documentTitle),i.a.createElement("time",{className:"info-dropdown__time",itemProp:"datePublished",dateTime:this.props.publishDate,title:this.props.publishDate},n),i.a.createElement("a",{href:this.props.publisherUrl,onClick:this.onPublisherLinkClick,className:"info-dropdown__publisher-link",target:"_blank"},i.a.createElement("img",{className:"info-dropdown__profile-image",src:this.props.profileImageUrl}),i.a.createElement("span",{className:"info-dropdown__publisher-name"},this.props.publisherName)))))},t}(r.Component);l.displayName="InfoDropdown",l.propTypes={coverImageUrl:a.a.string.isRequired,dispatch:a.a.func.isRequired,documentTitle:a.a.string.isRequired,featureTracker:a.a.object.isRequired,profileImageUrl:a.a.string.isRequired,publishDate:a.a.string.isRequired,publisherName:a.a.string.isRequired,publisherUrl:a.a.string.isRequired,visible:a.a.bool.isRequired}},function(e,t,n){"use strict";function r(e){return new Promise(function(t,n){var r=new XMLHttpRequest;r.open("GET",e,!0),r.onreadystatechange=function(){if(r.readyState===f)if(r.status<400)try{t(JSON.parse(r.responseText))}catch(e){n("jsonParseError")}else n(r.status<500?"requestError":"serverError")},r.send()})}n.d(t,"a",function(){return g});var i=n(2),o=n.n(i),a=n(10),s=n.n(a),u=n(47),c=n(21),l=n.n(c),p=n(302),d=(n.n(p),n(348)),f=4,h=!1,m=function(e){function t(){babelHelpers.classCallCheck(this,t);var n=babelHelpers.possibleConstructorReturn(this,e.call(this));return n.state={isAdEnabled:!1,networkCode:void 0,adUnitCode:void 0,isMinimized:!1,canShowAd:!1},n.minimizeAd=n.minimizeAd.bind(n),n.maximizeAd=n.maximizeAd.bind(n),n.onInteraction=n.onInteraction.bind(n),n.onPostMessage=n.onPostMessage.bind(n),n.pagesFlippedCount=0,n.autoMinTimer=void 0,n}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this,t=this.props.documentId,n=t.split("-")[1],i=this.props.config,o="//"+i.hosts.api+"/call/inpubads/publication?publicationId="+n;window.addEventListener("message",this.onPostMessage),r(o).then(function(t){e.setState({networkCode:t.response.networkCode,adUnitCode:t.response.adUnitCode})}).catch(function(t){if("requestError"===t)return void e.props.tracker.monitorBatched({type:"inpubads.reader3.fetch.request-error"});e.props.tracker.monitorBatched({type:"inpubads.reader3.fetch.server-error"})})},t.prototype.componentWillReceiveProps=function(e){this.props.currentSpreadIndex>-1&&e.currentSpreadIndex!==this.props.currentSpreadIndex&&2==++this.pagesFlippedCount&&this.setState({canShowAd:!0})},t.prototype.componentDidUpdate=function(e,t){this.state.networkCode&&this.state.adUnitCode&&this.state.canShowAd&&h===!1&&this.loadAd(this.state.networkCode,this.state.adUnitCode)},t.prototype.componentWillUnmount=function(){window.removeEventListener("message",this.onPostMessage)},t.prototype.onPostMessage=function(e){var t=e.origin===window.document.location.origin,n=0===e.origin.search("http://tpc.googlesyndication.com"),r=0===e.origin.search("https://tpc.googlesyndication.com"),i=0===e.origin.search("http://site.3rdparty.co.aq");if((t||r||i||n)&&e.data&&"eagles.dfp.inpubad.load"===e.data.message){this.props.tracker.monitorBatched({type:"inpubads.reader3.post-message"});var o=decodeURI(e.data.clickUrl);this.setState(Object.assign({},{isAdEnabled:!0,ad:{adId:e.data.ad.adId,docname:e.data.ad.docname,documentId:e.data.ad.documentId,headline:e.data.ad.headline,ownerUsername:e.data.ad.ownerUsername,adUrl:e.data.ad.url,clickTrackingUrl:o,url:""+o+e.data.ad.url}})),this.startAutoMinTimer()}},t.prototype.onInteraction=function(e){window.clearTimeout(this.autoMinTimer)},t.prototype.startAutoMinTimer=function(){var e=this;this.autoMinTimer=window.setTimeout(function(){e.setState({isMinimized:!0})},3e4)},t.prototype.loadAd=function(e,t){var n=[[1,1]],r="/"+e+"/"+t,i=[["isInPubAd","true"],["isDevelopmentTest","true"]];this.props.tracker.monitorBatched({type:"inpubads.reader3.load-ad"}),h=!0,this.clearAd(),this.adElement=document.createElement("div"),this.adContainer.appendChild(this.adElement),this.ad=p.create({rootElm:this.adElement,dfpTargeting:i,adProviderConfig:{network:r,sizes:n},isProductionEnv:!1,trackingKey:"ads-widget."+r.replace("/"+this.state.networkCode+"/","")}),this.ad.show()},t.prototype.clearAd=function(){this.adElement&&(this.props.tracker.monitorBatched({type:"inpubads.reader3.clear-ad"}),this.adElement.parentNode&&this.adElement.parentNode.removeChild(this.adElement),delete this.adElement)},t.prototype.minimizeAd=function(e){e.preventDefault(),this.props.tracker.monitorBatched({type:"inpubads.reader3.ui.minimize-ad"}),this.setState({isMinimized:!0})},t.prototype.maximizeAd=function(e){e.preventDefault(),this.props.tracker.monitorBatched({type:"inpubads.reader3.ui.maximize-ad"}),this.setState({isMinimized:!1})},t.prototype.render=function(){var e=this,t=this.state.canShowAd&&this.state.isAdEnabled,n={adContainer:"inpubads__ad-container ixu-cascading-theme-inverse",main:l()("inpubads",{"inpubads--visible":t})};return o.a.createElement("div",{className:n.main},o.a.createElement("div",{ref:function(t){e.adContainer=t},className:n.adContainer}),t?o.a.createElement(d.a,{ad:this.state.ad,minimizeAd:this.minimizeAd,maximizeAd:this.maximizeAd,onInteraction:this.onInteraction,isMinimized:this.state.isMinimized,config:this.props.config,isControlsVisible:this.props.isControlsVisible}):null)},t}(o.a.Component);m.displayName="InPubAds",m.propTypes={config:s.a.object.isRequired,currentSpreadIndex:s.a.number.isRequired,documentId:s.a.string.isRequired,isControlsVisible:s.a.bool.isRequired,tracker:s.a.object.isRequired};var g=n.i(u.b)(function(e){return{currentSpreadIndex:e.reader.currentSpreadIndex,config:Object.assign({},e.config),documentId:e.documentModel.revisionId+"-"+e.documentModel.publicationId}},function(e){return{onClick:function(){e()}}})(m)},function(e,t,n){"use strict";function r(e){var t=e.ad,n=e.config,r={main:o()("inpubads-minimal ixu-background ixu-background--secondary ixu-cascading-theme ixu-cascading-theme-inverse",{"inpubads-minimal--invisible":!(e.isControlsVisible||!e.isMinimized),"inpubads-minimal--only-chrome":!e.isControlsVisible}),minimized:o()("inpubads-minimal inpubads-minimal--minimized ixu-cascading-theme ixu-cascading-theme-inverse",{"inpubads-minimal--invisible":!(e.isControlsVisible||!e.isMinimized)}),headline:"ixu-heading ixu-heading--tiny ixu-heading--semibold ixu-heading--pronounced inpubads-minimal__headline",metadata:"inpubads-minimal__metadata",coverContainer:"inpubads-minimal__cover-container",cover:"inpubads-minimal__cover",callToAction:"ixu-button ixu-button--pronounced ixu-button--outline inpubads-minimal__cta",creative:"inpubads-minimal__creative",adNotice:"inpubads-minimal__ad-notice",maximizer:"inpubads-minimal__maximizer",minimizer:"inpubads-minimal__minimizer",tooltip:"inpubads-minimal__tooltip ixu-paragraph ixu-paragraph--pronounced ixu-background ixu-background--secondary ixu-cascading-theme ixu-cascading-theme-inverse"},i=s.a.createElement("div",{className:r.main,onMouseOver:e.onInteraction,onClick:e.onInteraction,onFocus:e.onInteraction},s.a.createElement("div",{className:r.creative},s.a.createElement("a",{href:"javascript:void(0);",className:r.minimizer,onClick:e.minimizeAd},s.a.createElement("svg",{viewBox:"0 0 9 9"},s.a.createElement("polygon",{fillRule:"evenodd",points:"910.424 592.242 914.555 592.242 914.555 593.625 910.424 593.625 910.424 597.897 909.03 597.897 909.03 593.625 904.919 593.625 904.919 592.242 909.03 592.242 909.03 587.95 910.424 587.95",transform:"rotate(-45 -252.542 1391.355)"}))),s.a.createElement("div",{className:r.metadata},s.a.createElement("div",{className:r.adNotice},"Advertisement"),s.a.createElement("h1",{className:r.headline},t.headline),s.a.createElement("a",{href:t.url,target:"_blank",className:r.callToAction},"Read in new tab")),s.a.createElement("a",{href:t.url,target:"_blank",className:r.coverContainer},s.a.createElement("img",{className:r.cover,src:"//"+n.hosts.image+"/"+t.documentId+"/jpg/page_1_thumb_large.jpg",alt:"Cover"})))),a=s.a.createElement("div",{className:r.minimized},s.a.createElement("a",{href:"javascript:void(0);",className:r.maximizer,onClick:e.maximizeAd},s.a.createElement("svg",{viewBox:"0 0 27 27"},s.a.createElement("g",null,s.a.createElement("circle",{cx:"12.5",cy:"12.5",r:"12.5",stroke:"#FFF",strokeWidth:".25"}),s.a.createElement("path",{fill:"#FFF",d:"M10.7954102,16 L10.2260742,14.1308594 L7.36328125,14.1308594 L6.79394531,16 L5,16 L7.77148438,8.11523438 L9.80712891,8.11523438 L12.5893555,16 L10.7954102,16 Z M9.82861328,12.734375 C9.30224346,11.0406816 9.00594109,10.0828462 8.93969727,9.86083984 C8.87345344,9.63883353 8.82600926,9.46337955 8.79736328,9.33447266 C8.67919863,9.79280828 8.34082311,10.9260977 7.78222656,12.734375 L9.82861328,12.734375 Z M20.0927734,11.9985352 C20.0927734,13.2911848 19.7248572,14.2812466 18.9890137,14.96875 C18.2531701,15.6562534 17.1905994,16 15.8012695,16 L13.5776367,16 L13.5776367,8.14746094 L16.0429688,8.14746094 C17.3248762,8.14746094 18.320309,8.48583646 19.0292969,9.16259766 C19.7382848,9.83935885 20.0927734,10.7846619 20.0927734,11.9985352 Z M18.3632812,12.0415039 C18.3632812,10.354972 17.618497,9.51171875 16.1289062,9.51171875 L15.2426758,9.51171875 L15.2426758,14.625 L15.9570313,14.625 C17.5612059,14.625 18.3632812,13.7638432 18.3632812,12.0415039 Z"})))),s.a.createElement("p",{className:r.tooltip},"Recommended for you"));return e.isMinimized?a:i}t.a=r;var i=n(21),o=n.n(i),a=n(2),s=n.n(a),u=n(10),c=n.n(u);r.propTypes={ad:c.a.object.isRequired,config:c.a.object.isRequired,isControlsVisible:c.a.bool.isRequired,isMinimized:c.a.bool.isRequired,maximizeAd:c.a.func.isRequired,minimizeAd:c.a.func.isRequired,onInteraction:c.a.func.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return c});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(132),u=n(350),c=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.render=function(){return i.a.createElement("div",{className:"loading"},i.a.createElement("div",{className:"loading__spinner"},i.a.createElement(s.a,{type:s.a.SPINNER_TYPE_ALTERNATE})),this.props.showBranding&&i.a.createElement("div",{className:"loading__watermark"},i.a.createElement(u.a,{type:u.a.LOGO_TYPE_ALTERNATE})))},t}(r.Component);c.displayName="Loading",c.propTypes={showBranding:a.a.bool.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(21),u=n.n(s),c=n(205),l=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.render=function(){var e=u()("logo",{"logo--alternate":this.props.type===t.LOGO_TYPE_ALTERNATE});return i.a.createElement("div",{className:e},i.a.createElement("p",{className:"logo__text"},"Powered by"),i.a.createElement("div",{className:"logo__wrapper",dangerouslySetInnerHTML:{__html:c.a}}))},t}(r.Component);l.displayName="Logo",l.propTypes={type:a.a.string},l.defaultProps={type:l.LOGO_TYPE_DEFAULT},l.LOGO_TYPE_DEFAULT="LOGO_TYPE_DEFAULT",l.LOGO_TYPE_ALTERNATE="LOGO_TYPE_ALTERNATE"},function(e,t,n){"use strict";n.d(t,"a",function(){return w});var r=n(2),i=n.n(r),o=n(86),a=n.n(o),s=n(47),u=n(19),c=n(73),l=n(196),p=n(211),d=n(41),f=n(219),h=n(11),m=n(337),g=n(349),v=n(355),b=n(365),y=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.getFullscreenFallbackPageUrl=function(){return r.props.embedId?r.props.documentUrl+"?ff=true&e="+r.props.embedId:r.props.documentUrl+"?ff=true"},r.loadDocument=function(){return r.props.dispatch(u.a({config:r.props.config,username:r.props.loading.username,documentName:r.props.loading.documentName,documentId:r.props.loading.documentId,initialPageNumber:r.props.initialPageNumber,getWidthAndHeight:function(){return[r.container.clientWidth,r.container.clientHeight]},readMorePlugin:r.props.readMorePlugin}))},r.listenToVisibilityChangeEvent=function(){f.a()&&f.b(function(){r.props.dispatch(l.a())})},r.toggleFullscreen=function(){r.props.fullscreenFeature&&r.props.fullscreenFeature.kind!==d.FULLSCREEN_KIND.FALLBACK&&r.props.dispatch(r.props.fullscreenEnabled?c.a():c.b(r.container,r.getFullscreenFallbackPageUrl()))},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.container=a.a.findDOMNode(this.refs.main),this.loadDocument(),this.listenToVisibilityChangeEvent()},t.prototype.shouldComponentUpdate=function(e){return this.props.loading.status!==e.loading.status||this.props.backgroundColor!==e.backgroundColor||this.props.backgroundImage!==e.backgroundImage},t.prototype.render=function(){var e=["reader-container"];document.documentMode&&10===document.documentMode&&e.push("ie10");var t=null;switch(this.props.loading.status){case p.a:t=i.a.createElement(m.a,{sessionId:this.props.sessionId,loadDocument:this.loadDocument,error:this.props.loading.error});break;case p.b:t=i.a.createElement(b.a,{featureTracker:this.props.featureTracker,toggleFullscreen:this.toggleFullscreen},i.a.createElement(v.a,{config:this.props.config,initialPageNumber:this.props.initialPageNumber,toggleFullscreen:this.toggleFullscreen,tracker:this.props.tracker,loadStatsTracker:this.props.loadStatsTracker}));break;case p.c:case p.d:default:t=i.a.createElement(g.a,{showBranding:this.props.showBranding})}this.props.backgroundImage&&(this.props.backgroundImage.style===d.BACKGROUND_IMAGE_STYLE.TOP_LEFT?e.push("reader-container--background-image-top-left"):this.props.backgroundImage.style===d.BACKGROUND_IMAGE_STYLE.STRETCH&&e.push("reader-container--background-image-stretch"));var n={width:"100%",height:"100%",backgroundColor:this.props.backgroundColor,backgroundImage:this.props.backgroundImage?"url('"+this.props.backgroundImage.url+"')":"none"};return i.a.createElement("div",{ref:"main",id:"ird3-main",className:e.join(" "),style:n},t)},t}(r.Component);y.displayName="Main";var _=function(e){return{backgroundColor:h.selectBackgroundColor(e),backgroundImage:h.selectBackgroundImage(e),config:e.config,documentUrl:e.reader.isReady?h.selectDocumentUrlWithPageNumber(e):"",fullscreenEnabled:h.selectFullscreenEnabled(e),fullscreenFeature:h.selectFullscreenFeature(e),loading:e.loading,readMorePlugin:e.readMorePlugin,showBranding:h.selectShowIssuuBranding(e)}},w=n.i(s.b)(_,void 0,void 0,{pure:!1})(y)},function(e,t,n){"use strict";n.d(t,"a",function(){return f});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(21),u=n.n(s),c=n(8),l=n(22),p=n(202),d=n(94),f=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onCloseButtonClick=function(){r.props.dispatch(c.f()),r.props.dispatch(l.a())},r.onBackgroundClick=function(){r.props.dispatch(c.f())},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.render=function(){return i.a.createElement("div",{className:u()("more-content-container",{"more-content-container--hidden":!this.props.visible,"more-content-container--overlay":this.props.showAsOverlay})},this.props.children,i.a.createElement("button",{type:"button",className:u()("more-content-container__close-button",{"more-content-container__close-button--left":d.a.isMobile()}),onClick:this.onCloseButtonClick,dangerouslySetInnerHTML:{__html:p.a}}),!this.props.showAsOverlay&&i.a.createElement("div",{className:"more-content-container__clickable-background",onClick:this.onBackgroundClick}))},t}(r.Component);f.displayName="MoreContentContainer",f.propTypes={children:a.a.node,dispatch:a.a.func.isRequired,readerSizeInPixels:a.a.string.isRequired,showAsOverlay:a.a.bool,visible:a.a.bool.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return c});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(76),u=n(343),c=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.render=function(){return i.a.createElement("div",null,i.a.createElement(s.a,{ref:"buttonPrevious",className:"navigation-arrow navigation-arrow--left",onClick:this.props.onClickLeftArrow,isHidden:!this.props.leftArrowVisible,id:"ird3-button-previous",content:u.a}),i.a.createElement(s.a,{ref:"buttonNext",className:"navigation-arrow navigation-arrow--right",onClick:this.props.onClickRightArrow,isHidden:!this.props.rightArrowVisible,id:"ird3-button-next",content:u.a}))},t}(r.Component);c.displayName="NavigationArrows",c.propTypes={leftArrowVisible:a.a.bool.isRequired,onClickLeftArrow:a.a.func.isRequired,onClickRightArrow:a.a.func.isRequired,rightArrowVisible:a.a.bool.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(208),u=n(57),c=n.n(u),l=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){window.ISSUU_READER_PAGE_SLIDER=this.refs.pageSlider},t.prototype.shouldComponentUpdate=function(e,t){return!(c()(this.props,e)&&c()(this.state,t))},t.prototype.render=function(){return i.a.createElement("div",{className:"page-controls"},i.a.createElement("span",{className:"page-controls__page-numbers"},this.props.currentPageNumbers," / ",this.props.pageCount),i.a.createElement("div",{className:"page-controls__slider"},i.a.createElement(s.a,{ref:"pageSlider",value:this.props.currentPageSliderPosition,onChange:this.props.pageSliderOnChange,onChangeStart:this.props.pageSliderOnChangeStart,onChangeEnd:this.props.pageSliderOnChangeEnd,locked:1===this.props.pageCount,segments:this.props.segments,markers:this.props.resultMarkers})))},t}(r.Component);l.displayName="PageControls",l.propTypes={currentPageNumbers:a.a.string.isRequired,currentPageSliderPosition:a.a.number.isRequired,pageCount:a.a.number.isRequired,pageSliderOnChange:a.a.func.isRequired,pageSliderOnChangeEnd:a.a.func.isRequired,pageSliderOnChangeStart:a.a.func.isRequired,resultMarkers:a.a.arrayOf(a.a.number),segments:a.a.arrayOf(a.a.shape({proportion:a.a.number.isRequired,done:a.a.bool.isRequired,available:a.a.bool.isRequired}))}},function(e,t,n){"use strict";n.d(t,"a",function(){return R});var r=n(2),i=n.n(r),o=n(47),a=n(21),s=n.n(a),u=n(334),c=n(339),l=n(333),p=n(353),d=n(335),f=n(352),h=n(347),m=n(49),g=n(42),v=n(138),b=n(8),y=n(130),_=n(22),w=n(11),E=n(139),x=n(109),S=n(94),T=n(20),C=n(398),I=n(79),M=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onWebGLContextLost=function(){r.props.tracker.monitorBatched({type:"reader3-webgl-context-lost"})},r.onWebGLContextRestored=function(){r.props.tracker.monitorBatched({type:"reader3-webgl-context-restored"})},r.onNextSpreadButtonClick=function(e){e.preventDefault(),r.props.featureTracker.usage(T.b.BUTTON_ARROW_FORWARD),r.props.dispatch(_.a()),r.nextSpread()},r.onPreviousSpreadButtonClick=function(e){e.preventDefault(),r.props.featureTracker.usage(T.b.BUTTON_ARROW_BACKWARD),r.props.dispatch(_.a()),r.previousSpread()},r.trackOpportunities=function(){r.props.featureTracker.opportunity(T.b.FULLSCREEN_MORE),r.props.isLeftArrowVisible&&r.props.featureTracker.opportunity(T.b.BUTTON_ARROW_BACKWARD),r.props.isRightArrowVisible&&r.props.featureTracker.opportunity(T.b.BUTTON_ARROW_FORWARD)},r.nextSpread=function(){r.props.dispatch(b.b())},r.previousSpread=function(){r.props.dispatch(b.d())},r.toggleInPubAds=function(){r.props.dispatch(y.a(!r.props.enableInPubAds))},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){var e=this,t=this.refs.canvas.getWrappedInstance();window.ISSUU_READER_DOCUMENTCANVAS=t,this.interactionDetector=new C.a(this.refs.mainReader,function(){e.props.interactedWithReader||window.setTimeout(function(){e.props.dispatch(b.e())},500)}),this.inputHandler=new I.a(this.refs.mainReader,{onMouseMove:function(t,n,r){e.props.dispatch(_.b())},onMouseEnter:function(t){e.props.dispatch(_.c())},onMouseLeave:function(t){e.props.dispatch(_.d())}}),this.trackOpportunities()},t.prototype.componentDidUpdate=function(e){this.props.renderReadmore&&this.props.exitedFullscreen&&this.props.moreContentContainerIsVisible&&this.props.moreContentContainerIsVisible!==e.moreContentContainerIsVisible&&this.props.featureTracker.usage(T.b.FULLSCREEN_MORE),this.trackOpportunities()},t.prototype.componentWillUnmount=function(){this.interactionDetector&&this.interactionDetector.destroy()},t.prototype.render=function(){var e=void 0;return e=this.props.showCTAOverlay?i.a.createElement(d.a,{dispatch:this.props.dispatch,featureTracker:this.props.featureTracker,fullscreenEnabled:this.props.fullscreenEnabled,toggleFullscreen:this.props.toggleFullscreen,visible:this.props.isControlsVisible}):i.a.createElement(u.a,{toggleFullscreen:this.props.toggleFullscreen,isTinyEmbed:!1,visible:this.props.isControlsVisible}),i.a.createElement("div",{ref:"mainReader",tabIndex:"1",className:"reader",style:{backgroundImage:this.props.logo?"url('"+this.props.logo.url+"')":"none"}},i.a.createElement("div",{className:"reader__layout"},i.a.createElement(c.a,null),this.props.enableFind&&!this.props.showCTAOverlay&&i.a.createElement(g.b.FindOverlay,{featureTracker:this.props.featureTracker,enableIncrementalSearch:!S.a.isIOS()}),i.a.createElement("div",{className:"reader__canvas-container"},i.a.createElement(l.a,{ref:"canvas",loadStatsTracker:this.props.loadStatsTracker,onWebGLContextLost:this.onWebGLContextLost,onWebGLContextRestored:this.onWebGLContextRestored,tracker:this.props.tracker,withStencilBuffer:this.props.enableFind}),i.a.createElement(p.a,{leftArrowVisible:this.props.isLeftArrowVisible,rightArrowVisible:this.props.isRightArrowVisible,onClickLeftArrow:this.onPreviousSpreadButtonClick,onClickRightArrow:this.onNextSpreadButtonClick}),this.props.enableInPubAds&&i.a.createElement(h.a,{tracker:this.props.tracker,isControlsVisible:this.props.isControlsVisible})),e,this.props.renderReadmore&&i.a.createElement(f.a,{dispatch:this.props.dispatch,visible:this.props.moreContentContainerIsVisible,showAsOverlay:this.props.showReadmoreAsOverlay,readerSizeInPixels:this.props.readerSizeInPixels},this.props.readMorePlugin.render(this.props.config,this.props.debugMode,this.props.exitedFullscreen,this.props.moreContentContainerIsVisible,this.props.showReadmoreAsOverlay,this.props.isLoggedIn)),this.props.isPaywallPreview&&i.a.createElement("div",{className:s()("paywall-btn--header",{"is-hidden":this.props.isPaywallOverlayVisible})},i.a.createElement(m.c.PaywallButton,null)),this.props.isPaywallPreview&&i.a.createElement("div",{className:s()("paywall-overlay",{"is-hidden":!this.props.isPaywallOverlayVisible})},i.a.createElement(m.c.PaywallOverlay,null)),this.props.renderVideoOverlay&&i.a.createElement(v.a,{dispatch:this.props.dispatch,service:this.props.videoService,videoId:this.props.videoId})))},t}(r.Component);M.displayName="Reader";var P=function(e){return{debugMode:e.reader.debugMode,exitedFullscreen:e.readmore.exitedFullscreen,featureTracker:e.featureTracker,interactedWithReader:e.reader.interactedWithReader,readMorePlugin:e.readMorePlugin,enableInPubAds:e.features.enableInPubAds,enableFind:e.features.enableFind,isLoggedIn:e.isLoggedIn,isPaywallPreview:m.b.isPreview(e),isPaywallOverlayVisible:m.b.isVisible(e),showReadmoreAsOverlay:x.selectShowAsOverlay(e),fullscreenEnabled:w.selectFullscreenEnabled(e),isControlsVisible:w.isControlsVisible(e),logo:w.selectLogo(e),isLeftArrowVisible:E.isLeftArrowVisible(e),isRightArrowVisible:E.isRightArrowVisible(e),moreContentContainerIsVisible:w.moreOverlayVisible(e),readerSizeInPixels:w.selectReaderSizeInPixels(e),renderReadmore:x.selectReadyToRender(e),showCTAOverlay:w.selectShowCTAOverlay(e),renderVideoOverlay:v.b(e),videoService:v.c(e),videoId:v.d(e)}},R=n.i(o.b)(P,void 0,void 0,{pure:!0})(M)},function(e,t,n){"use strict";n.d(t,"a",function(){return g});var r=n(2),i=n.n(r),o=n(57),a=n.n(o),s=n(76),u=n(10),c=n.n(u),l=n(208),p=n(58),d=n(22),f=n(345),h=n(344),m=n(20),g=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.trackOpportunities=function(){r.isZoomControlsVisible()&&(r.props.featureTracker.opportunity(m.b.BUTTON_ZOOMIN),r.props.featureTracker.opportunity(m.b.BUTTON_ZOOMOUT),r.props.featureTracker.opportunity(m.b.SLIDER_ZOOM))},r.isZoomControlsVisible=function(){var e=window.getComputedStyle(r.refs.zoomControls.parentNode);return e&&"none"!==e.display},r.handleZoomInButtonClick=function(){r.props.currentZoomLevel>=p.a||(r.props.zoomSliderOnChange(r.props.currentZoomLevel+1),r.props.featureTracker.usage(m.b.BUTTON_ZOOMIN),r.props.dispatch(d.a()))},r.handleZoomOutButtonClick=function(){r.props.zoomSliderOnChange(r.props.currentZoomLevel-1),r.props.featureTracker.usage(m.b.BUTTON_ZOOMOUT),r.props.dispatch(d.a())},r.handleZoomSliderChangeStart=function(){r.props.zoomSliderOnChangeStart(),r._zoomBeforeSliderStart=r.props.currentZoomLevel},r.handleZoomSliderChange=function(e){r.props.zoomSliderOnChange(e/100*(p.a-p.b)+p.b)},r.handleZoomSliderChangeEnd=function(){r.props.zoomSliderOnChangeEnd(),r.props.currentZoomLevel!==r._zoomBeforeSliderStart&&r.props.featureTracker.usage(m.b.SLIDER_ZOOM)},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.trackOpportunities()},t.prototype.shouldComponentUpdate=function(e,t){return!(a()(this.props,e)&&a()(this.state,t))},t.prototype.componentDidUpdate=function(){this.trackOpportunities()},t.prototype.render=function(){var e=100/(p.a-p.b)*(this.props.currentZoomLevel-p.b);return i.a.createElement("div",{className:"zoom-controls",ref:"zoomControls"},i.a.createElement("div",{className:"zoom-controls__button","data-tooltip":"Zoom out"},i.a.createElement(s.a,{id:"ird3-button-zoomout",className:"svg-btn",onClick:this.handleZoomOutButtonClick,content:f.a})),i.a.createElement("div",{className:"zoom-controls__slider"},i.a.createElement(l.a,{value:e,onChange:this.handleZoomSliderChange,onChangeStart:this.handleZoomSliderChangeStart,onChangeEnd:this.handleZoomSliderChangeEnd,segments:this.props.segments,type:l.a.SLIDER_TYPE_ALTERNATE})),i.a.createElement("div",{className:"zoom-controls__button","data-tooltip":"Zoom in"},i.a.createElement(s.a,{id:"ird3-button-zoomin",className:"svg-btn",onClick:this.handleZoomInButtonClick,content:h.a})))},t}(r.Component);g.displayName="ZoomControls",g.propTypes={currentZoomLevel:c.a.number.isRequired,dispatch:c.a.func.isRequired,featureTracker:c.a.object.isRequired,segments:c.a.arrayOf(c.a.shape({proportion:c.a.number.isRequired,done:c.a.bool.isRequired,available:c.a.bool.isRequired})).isRequired,zoomSliderOnChange:c.a.func.isRequired,zoomSliderOnChangeEnd:c.a.func.isRequired,zoomSliderOnChangeStart:c.a.func.isRequired}},function(e,t,n){"use strict";n.d(t,"b",function(){return r}),n.d(t,"d",function(){return i}),n.d(t,"a",function(){return o}),n.d(t,"c",function(){return a}),n.d(t,"j",function(){return s}),n.d(t,"f",function(){return u}),n.d(t,"h",function(){return c}),n.d(t,"g",function(){return l}),n.d(t,"i",function(){return p}),n.d(t,"e",function(){return d});var r=2,i=4,o=5,a=6,s=7,u=8,c=9,l=10,p=11,d=12},function(e,t,n){"use strict";function r(e){var t={type:"READER3_POLYFILLS","whatwg-fetch":0};n.i(k.a)(window.fetch)||(t["whatwg-fetch"]=1),e.monitorBatched(t)}function i(e,t){for(var r=Object.keys(t),o=Array.isArray(r),a=0,r=o?r:r[Symbol.iterator]();;){var s;if(o){if(a>=r.length)break;s=r[a++]}else{if(a=r.next(),a.done)break;s=a.value}var u=s,c=t[u];"object"!==(void 0===c?"undefined":babelHelpers.typeof(c))||n.i(k.a)(c)?null!==e[u]&&void 0!==e[u]||(e[u]=c):e[u]=i(e[u]||{},c)}return e}function o(e){i(e,{document:{initialPageNumber:1},features:{allowUIToOverlayCover:!0,backgroundColor:"#353535",fullscreenBackgroundColor:"#353535",enableInPubAds:!1,enableFind:!0},network:{ImageLoader:Image,imagePath:"jpg"},trackerConfig:{streamData:{}},isFeatureTest:!1});var t=e.tracker,o=e.network,a=e.trackerConfig,s=e.gaTracker,f=e.quantcastTracker,k=e.isFeatureTest,N=e.features,D=e.readMorePlugin,F=e.isLoggedIn,U=A.a.isWebGLSupported();t.monitorBatched({type:"READER3_WEBGL",webgl:U?1:0,no_webgl:U?0:1}),r(t);var B=new _.a(t,a,e.document.embedId),H=new w.a(B,a.loadStartTimestamp),j=n.i(O.a)(b.b),z=[h.a,g.a,n.i(E.a)(B,b.b),n.i(x.a)(H,b.b),n.i(S.a)(B,b.b),n.i(T.a)(B,b.b,a.startTrackingOnLoad),j.middleware,v.a,n.i(y.a)(t)];if(f){var W=new I.a(f);z.push(n.i(M.a)(W,b.b))}if(s){var V=new P.a(s);z.push(n.i(R.a)(V,b.b))}(L||k)&&z.push(m.a);var G=new C.a(B,b.b,a.sessionId),q=d.a(o,e.document.username,e.document.name,N,G,D,F,U),Y=c.a,$=n.i(c.b)(q,{},Y(c.c.apply(void 0,z))),K=u.a.createElement(l.a,{store:$},u.a.createElement(p.a,{embedId:e.document.embedId,initialPageNumber:e.document.initialPageNumber?Number(e.document.initialPageNumber):1,loadStatsTracker:H,featureTracker:G,tracker:t,features:N,sessionId:a.sessionId})),X=j.api($);return window.ISSUU_READER_STORE=$,window.ISSUU_READER_OBJECT=K,window.ISSUU_READER_EXTERNAL_API=X,{reader:K,api:X}}t.b=o;var a=n(41),s=n(2),u=n.n(s),c=n(192),l=n(47),p=n(351),d=n(386),f=n(735),h=n.n(f),m=n(368),g=n(366),v=n(370),b=n(108),y=n(49),_=n(393),w=n(390),E=n(394),x=n(395),S=n(396),T=n(397),C=n(20),I=n(391),M=n(369),P=n(389),R=n(367),O=n(77),k=n(399),A=n(401),N=n(332);if(n.d(t,"a",function(){return a}),window.chrome){var D=document.createElement("div");D.style.position="absolute",D.style.left="0px",D.style.top="0px",D.innerHTML=N.a,document.body&&document.body.appendChild(D)}var L=!1},function(e,t,n){"use strict";function r(e){if(!e.getClientRects().length)return{top:0,left:0};var t=e.getBoundingClientRect();if(t.width||t.height){var n=e.ownerDocument,r=n.documentElement||{};return{top:t.top+window.pageYOffset-r.clientTop,left:t.left+window.pageXOffset-r.clientLeft}}return t}t.a=r},function(e,t,n){"use strict";n.d(t,"a",function(){return o});var r=n(136),i=1,o=function(e){function t(n,r,o){babelHelpers.classCallCheck(this,t);var a=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,o));return a._elementMouseDownHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.isDeactivated()||(a.options.activeHandler=a,a.saveTargetElementOffset(),a.savePointer(i,e.pageX,e.pageY,e.timeStamp),a.saveInitialPinchDistance(),a.fireGestureStart(),a.registerTapHandlers(),a.targetElement.ownerDocument.addEventListener("mousemove",a._ownerDocumentMouseMoveHandler,!1),a.targetElement.ownerDocument.addEventListener("mouseup",a._ownerDocumentMouseUpHandler,!1))},a._ownerDocumentMouseMoveHandler=function(e){a.savePointer(i,e.pageX,e.pageY,e.timeStamp),a.saveInitialGestureIfUndefined(),a.fireGestureChange(),a.validateTapHandlers(),a.options.shouldInvokePreventDefault()&&e.preventDefault()},a._ownerDocumentMouseUpHandler=function(e){a.savePointer(i,e.pageX,e.pageY,e.timeStamp),a.fireGestureEnd(),a.executeTapHandlers(),a.deletePointer(i),a.options.shouldInvokePreventDefault()&&e.preventDefault(),a.options.resetInterception(),a._removeEventListenersFromOwnerDocument()},a._elementMouseMoveHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.fireMouseMove(e)},a._elementMouseEnterHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.fireMouseEnter(e)},a._elementMouseLeaveHandler=function(e){a.options.isSimulatedMouseEvents(e)||a.fireMouseLeave(e)},a.targetElement.addEventListener("mousedown",a._elementMouseDownHandler,!1),a.targetElement.addEventListener("mousemove",a._elementMouseMoveHandler,!1),a.targetElement.addEventListener("mouseenter",a._elementMouseEnterHandler,!1),a.targetElement.addEventListener("mouseleave",a._elementMouseLeaveHandler,!1),a}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("mousedown",this._elementMouseDownHandler,!1),this.targetElement.removeEventListener("mousemove",this._elementMouseMoveHandler,!1),this.targetElement.removeEventListener("mouseenter",this._elementMouseEnterHandler,!1),this.targetElement.removeEventListener("mouseleave",this._elementMouseLeaveHandler,!1),this._removeEventListenersFromOwnerDocument()},t.prototype.reset=function(){e.prototype.reset.call(this),this._removeEventListenersFromOwnerDocument()},t.prototype._removeEventListenersFromOwnerDocument=function(){this.targetElement.ownerDocument.removeEventListener("mousemove",this._ownerDocumentMouseMoveHandler,!1),this.targetElement.ownerDocument.removeEventListener("mouseup",this._ownerDocumentMouseUpHandler,!1)},t}(r.a)},function(e,t,n){"use strict";function r(){var e=!!window.PointerEvent;return{DOWN:e?"pointerdown":"MSPointerDown",MOVE:e?"pointermove":"MSPointerMove",UP:e?"pointerup":"MSPointerUp",CANCEL:e?"pointercancel":"MSPointerCancel",ENTER:e?"pointerenter":"MSPointerEnter",LEAVE:e?"pointerleave":"MSPointerLeave"}}n.d(t,"a",function(){return a});var i=n(136),o=2,a=function(e){function t(n,i,a){babelHelpers.classCallCheck(this,t);var s=babelHelpers.possibleConstructorReturn(this,e.call(this,n,i,a));return s._elementPointerDownHandler=function(e){if(!s.isDeactivated()){s.options.activeHandler=s,s.options.updateLastPointerEventTimeStamp(e);var t=e.pointerId,n=e.pageX,r=e.pageY;if(s.options.shouldInvokeSetPointerCapture())try{s.targetElement.setPointerCapture?s.targetElement.setPointerCapture(""+t):s.targetElement.msSetPointerCapture&&s.targetElement.msSetPointerCapture(t)}catch(e){}0===s.getPointerCount()&&s.saveTargetElementOffset(),s.savePointer(t,n,r,e.timeStamp),s.saveInitialPinchDistance(),s.saveInitialGestureIfUndefined(),s.fireGestureStart(),s.registerTapHandlers()}},s._elementPointerMoveHandler=function(e){if(!s.isDeactivated()){s.options.updateLastPointerEventTimeStamp(e),s.fireMouseMove(e);var t=e.pointerId,n=e.pageX,r=e.pageY;s.isValidPointer(t)&&(s.isPointerMoved(t,n,r,o)&&(s.savePointer(t,n,r,e.timeStamp),s.saveInitialGestureIfUndefined(),s.fireGestureChange()),s.validateTapHandlers(),s.options.shouldInvokePreventDefault()&&e.preventDefault())}},s._elementPointerUpHandler=function(e){if(!s.isDeactivated()){s.options.updateLastPointerEventTimeStamp(e);var t=e.pointerId,n=e.pageX,r=e.pageY;if(s.isValidPointer(t)){s.savePointer(t,n,r,e.timeStamp);var i=!1;1===s.getPointerCount()?(s.fireGestureEnd(),s.executeTapHandlers(),s.deletePointer(t),i=!0):(s.fireGestureStart(),s.deletePointer(t),s.saveInitialPinchDistance()),s.options.shouldInvokePreventDefault()&&e.preventDefault(),i&&s.options.resetInterception()}}},s._elementPointerCancelHandler=function(e){s.unregisterTapHandlers(),s._elementPointerUpHandler(e)},s._elementPointerEnterHandler=function(e){s.options.updateLastPointerEventTimeStamp(e),s.fireMouseEnter(e)},s._elementPointerLeaveHandler=function(e){s.options.updateLastPointerEventTimeStamp(e),s.fireMouseLeave(e)},s.pointerEventTypes=r(),s.targetElement.addEventListener(s.pointerEventTypes.DOWN,s._elementPointerDownHandler,!1),s.targetElement.addEventListener(s.pointerEventTypes.MOVE,s._elementPointerMoveHandler,!1),s.targetElement.addEventListener(s.pointerEventTypes.UP,s._elementPointerUpHandler,!1),s.targetElement.addEventListener(s.pointerEventTypes.CANCEL,s._elementPointerCancelHandler,!1),s.targetElement.addEventListener(s.pointerEventTypes.ENTER,s._elementPointerEnterHandler,!1),s.targetElement.addEventListener(s.pointerEventTypes.LEAVE,s._elementPointerLeaveHandler,!1),s}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener(this.pointerEventTypes.DOWN,this._elementPointerDownHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.MOVE,this._elementPointerMoveHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.UP,this._elementPointerUpHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.CANCEL,this._elementPointerCancelHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.ENTER,this._elementPointerEnterHandler,!1),this.targetElement.removeEventListener(this.pointerEventTypes.LEAVE,this._elementPointerLeaveHandler,!1)},t}(i.a)},function(e,t,n){"use strict";n.d(t,"a",function(){return i});var r=n(136),i=function(e){function t(n,r,i){babelHelpers.classCallCheck(this,t);var o=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,i));return o._elementTouchStartHandler=function(e){o.isDeactivated()||(o.options.activeHandler=o,o.options.updateLastTouchEventTimeStamp(e),0===o.getPointerCount()&&o.saveTargetElementOffset(),o._saveChangedPointers(e),o.saveInitialPinchDistance(),o.saveInitialGestureIfUndefined(),o.fireGestureStart(),o.registerTapHandlers(),o.options.updateInterceptionWithTouchEvent(e),o.options.shouldInvokePreventDefault()&&e.preventDefault())},o._elementTouchMoveHandler=function(e){if(!o.isDeactivated()){o.options.updateLastTouchEventTimeStamp(e);0!==o._getValidChangedPointers(e).length&&(o._saveValidChangedPointers(e),o.saveInitialGestureIfUndefined(),o.options.updateInterceptionWithTouchEvent(e),o.options.hasBrowserIntercepted()?o.unregisterTapHandlers():(o.fireGestureChange(),o.validateTapHandlers()),o.options.shouldInvokePreventDefault()&&e.preventDefault())}},o._elementTouchEndHandler=function(e){if(!o.isDeactivated()){o.options.updateLastTouchEventTimeStamp(e);var t=o._getValidChangedPointers(e);if(0!==t.length){o._saveValidChangedPointers(e),o.options.updateInterceptionWithTouchEvent(e);var n=!1;o.getPointerCount()===t.length?(o.fireGestureEnd(),o.executeTapHandlers(),o._deleteValidChangedPointers(e),n=!0):(o._deleteValidChangedPointers(e),o.fireGestureStart(),o.saveInitialPinchDistance()),o.options.shouldInvokePreventDefault()&&e.preventDefault(),n&&o.options.resetInterception()}}},o._elementTouchCancelHandler=function(e){o._elementTouchEndHandler(e)},o.targetElement.addEventListener("touchstart",o._elementTouchStartHandler,!1),o.targetElement.addEventListener("touchmove",o._elementTouchMoveHandler,!1),o.targetElement.addEventListener("touchend",o._elementTouchEndHandler,!1),o.targetElement.addEventListener("touchcancel",o._elementTouchCancelHandler,!1),o}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("touchstart",this._elementTouchStartHandler,!1),this.targetElement.removeEventListener("touchmove",this._elementTouchMoveHandler,!1),this.targetElement.removeEventListener("touchend",this._elementTouchEndHandler,!1),this.targetElement.removeEventListener("touchcancel",this._elementTouchCancelHandler,!1)},t.prototype._getValidChangedPointers=function(e){for(var t=[],n=0;n<e.changedTouches.length;n++){var r=e.changedTouches.item(n);r&&this.isValidPointer(r.identifier)&&t.push(r)}return t},t.prototype._saveValidChangedPointers=function(e){var t=this;this._getValidChangedPointers(e).forEach(function(n){t.savePointer(n.identifier,n.pageX,n.pageY,e.timeStamp)})},t.prototype._saveChangedPointers=function(e){for(var t=0;t<e.changedTouches.length;t++){var n=e.changedTouches.item(t);n&&this.savePointer(n.identifier,n.pageX,n.pageY,e.timeStamp)}},t.prototype._deleteValidChangedPointers=function(e){var t=this;this._getValidChangedPointers(e).forEach(function(e){t.deletePointer(e.identifier)})},t}(r.a)},function(e,t,n){"use strict";n.d(t,"a",function(){return s});var r=n(135),i=n(78),o=1,a=100,s=function(e){function t(n,r,s){babelHelpers.classCallCheck(this,t);var u=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,s));return u._totalDeltaY=0,u._idleTimeoutId=null,u._elementGestureStartHandler=function(e){if(!u.isDeactivated()){u.options.activeHandler=u,u.saveTargetElementOffset();u.savePointer(o,e.pageX,e.pageY,e.timeStamp),u.fireGestureStart(),e.preventDefault()}},u._elementGestureChangeHandler=function(e){if(!u.isDeactivated()){u.savePointer(o,e.pageX,e.pageY,e.timeStamp);var t=e.scale;!isNaN(t)&&isFinite(t)&&(u.initialGesture===i.d&&(u.initialGesture=t>1?i.c:i.e),u.fireGestureChange(t)),u.options.shouldInvokePreventDefault()&&e.preventDefault()}},u._elementGestureEndHandler=function(e){if(!u.isDeactivated()){u.savePointer(o,e.pageX,e.pageY,e.timeStamp),u.fireGestureEnd(),u.deletePointer(o),u.options.shouldInvokePreventDefault()&&e.preventDefault(),u.options.resetInterception()}},u._elementWheelHandler=function(e){if(e.ctrlKey&&!u.isDeactivated()){u.options.activeHandler=u,u.savePointer(o,e.pageX,e.pageY,e.timeStamp),u.initialGesture===i.d&&(u.initialGesture=e.deltaY>0?i.e:i.c);var t=!1;if(0===u._totalDeltaY)u.fireGestureStart(),u._totalDeltaY+=e.deltaY,u._resetIdleTimeout();else if(0===e.deltaY)u._totalDeltaY=0,u.fireGestureEnd(),u.deletePointer(o),t=!0,u._cancelIdleTimeout();else{u._totalDeltaY+=e.deltaY;var n=1-u._totalDeltaY/a;u.fireGestureChange(n),u._resetIdleTimeout()}u.options.shouldInvokePreventDefault()&&e.preventDefault(),t&&u.options.resetInterception()}},u.targetElement.addEventListener("gesturestart",u._elementGestureStartHandler,!1),u.targetElement.addEventListener("gesturechange",u._elementGestureChangeHandler,!1),u.targetElement.addEventListener("gestureend",u._elementGestureEndHandler,!1),u.targetElement.addEventListener("wheel",u._elementWheelHandler,!1),u}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("gesturestart",this._elementGestureStartHandler,!1),this.targetElement.removeEventListener("gesturechange",this._elementGestureChangeHandler,!1),this.targetElement.removeEventListener("gestureend",this._elementGestureEndHandler,!1),this.targetElement.removeEventListener("wheel",this._elementWheelHandler,!1)},t.prototype.reset=function(){e.prototype.reset.call(this),this._cancelIdleTimeout(),this._totalDeltaY=0,this._idleTimeoutId=null},t.prototype._resetIdleTimeout=function(){var e=this;this._cancelIdleTimeout(),this._idleTimeoutId=window.setTimeout(function(){e._idleTimeoutId=null,e._onIdle()},250)},t.prototype._cancelIdleTimeout=function(){window.clearTimeout(this._idleTimeoutId)},t.prototype._onIdle=function(){this._totalDeltaY=0,this.fireGestureEnd(),this.deletePointer(o),this.options.resetInterception()},t}(r.a)},function(e,t,n){"use strict";n.d(t,"a",function(){return a});var r=n(135),i=n(78),o=1,a=function(e){function t(n,r,a){babelHelpers.classCallCheck(this,t);var s=babelHelpers.possibleConstructorReturn(this,e.call(this,n,r,a));return s._totalDeltaY=0,s._idleTimeoutId=null,s._elementWheelHandler=function(e){if(!e.ctrlKey&&s.callbacks.catchWheelEvent&&s.callbacks.catchWheelEvent()&&!s.isDeactivated()){if(s.options.activeHandler=s,s.savePointer(o,e.pageX,e.pageY,e.timeStamp),s.initialGesture===i.d&&(s.initialGesture=e.deltaY>0?i.e:i.c),0===s._totalDeltaY)s.fireGestureStart(),s._totalDeltaY+=e.deltaY;else{s._totalDeltaY+=e.deltaY;s.fireGestureChange(1-s._totalDeltaY/200)}s._resetIdleTimeout(),s.options.shouldInvokePreventDefault()&&e.preventDefault()}},s.targetElement.addEventListener("wheel",s._elementWheelHandler,!1),s}return babelHelpers.inherits(t,e),t.prototype.destroy=function(){this.targetElement.removeEventListener("wheel",this._elementWheelHandler,!1)},t.prototype.reset=function(){e.prototype.reset.call(this),this._cancelIdleTimeout(),this._totalDeltaY=0,this._idleTimeoutId=null},t.prototype._resetIdleTimeout=function(){var e=this;this._cancelIdleTimeout(),this._idleTimeoutId=window.setTimeout(function(){e._idleTimeoutId=null,e._onIdle()},250)},t.prototype._cancelIdleTimeout=function(){window.clearTimeout(this._idleTimeoutId)},t.prototype._onIdle=function(){this._totalDeltaY=0,this.fireGestureEnd(),this.deletePointer(o),this.options.resetInterception()},t}(r.a)},function(e,t,n){"use strict";function r(e){return{canFind:e.features.enableFind&&!u.selectShowCTAOverlay(e)&&f.a.selectIsAvailable(e),canGoBackward:c.isLeftArrowVisible(e),canGoForward:c.isRightArrowVisible(e),debugMode:e.reader.debugMode,enableInPubAds:e.features.enableInPubAds,lastSpreadIndex:u.selectLastSpreadIndex(e),moreContentContainerIsVisible:u.moreOverlayVisible(e),isFindOverlayVisible:f.a.isVisible(e),fullscreenEnabled:u.selectFullscreenEnabled(e)}}n.d(t,"a",function(){return g});var i=n(2),o=(n.n(i),n(47)),a=n(130),s=n(8),u=n(11),c=n(139),l=n(22),p=n(210),d=n(58),f=n(42),h=n(20),m=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,u=Array(o),c=0;c<o;c++)u[c]=arguments[c];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(u))),r.onKeyDown=function(e){var t=r.props,n=t.dispatch,i=t.toggleFullscreen,o=t.canFind,u=t.canGoBackward,c=t.canGoForward,h=t.debugMode,m=t.enableInPubAds,g=t.lastSpreadIndex,v=t.moreContentContainerIsVisible,b=t.isFindOverlayVisible,y=t.fullscreenEnabled,_=r,w=_.isOSX;if(e.keyCode===p.f&&(v?n(s.f()):b?n(f.c.closeFindDialog()):y&&i()),!(r._mover||document.activeElement&&"INPUT"===document.activeElement.tagName)){switch(e.keyCode){case p.g:o&&w&&e.metaKey||!w&&e.ctrlKey?(e.preventDefault(),r.openFindDialog()):i();break;case p.h:o&&!w&&(e.preventDefault(),r.openFindDialog());break;case p.i:o&&(e.preventDefault(),r.openFindDialog());break;case p.d:case p.e:if(e.metaKey)break;u&&r.goToPreviousPage(),r._mover=setInterval(function(){u&&r.goToPreviousPage(),n(l.l(e.keyCode))},d.k);break;case p.a:case p.b:case p.c:if(e.metaKey)break;c&&r.goToNextPage(),r._mover=setInterval(function(){c&&r.goToNextPage(),n(l.l(e.keyCode))},d.k);break;case p.j:n(s.j(0));break;case p.k:n(s.j(g));break;case p.l:e.shiftKey&&n(s.q(!h));break;case p.m:e.shiftKey&&n(a.a(!m))}n(l.l(e.keyCode))}},r.onKeyUp=function(e){switch(e.keyCode){case p.a:case p.d:case p.e:case p.b:case p.c:clearInterval(r._mover),r._mover=0}},r._mover=0,i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this.isOSX="MacIntel"===window.navigator.platform,window.addEventListener("keyup",this.onKeyUp,!1),window.addEventListener("keydown",this.onKeyDown,!1)},t.prototype.componentDidUpdate=function(){var e=this.props,t=e.canGoBackward,n=e.canGoForward,r=e.canFind,i=e.featureTracker;t&&i.opportunity(h.b.KEYBOARD_BACKWARD),n&&i.opportunity(h.b.KEYBOARD_FORWARD),r&&i.opportunity(h.b.KEYBOARD_OPEN_FIND)},t.prototype.componentWillUnmount=function(){clearInterval(this._mover),window.removeEventListener("keyup",this.onKeyUp,!1),window.removeEventListener("keydown",this.onKeyDown,!1)},t.prototype.goToPreviousPage=function(){var e=this.props,t=e.dispatch,n=e.featureTracker;t(s.d()),n.usage(h.b.KEYBOARD_BACKWARD)},t.prototype.goToNextPage=function(){var e=this.props,t=e.dispatch,n=e.featureTracker;t(s.b()),n.usage(h.b.KEYBOARD_FORWARD)},t.prototype.openFindDialog=function(){var e=this.props,t=e.dispatch,n=e.featureTracker;t(f.c.openFindDialog()),n.usage(h.b.KEYBOARD_OPEN_FIND)},t.prototype.render=function(){return i.Children.only(this.props.children)},t}(i.Component),g=n.i(o.b)(r)(m)},function(e,t,n){"use strict";function r(e){l=window.setInterval(function(){u.isFirstSpread(e.getState())?p=!0:u.isLastSpread(e.getState())&&(p=!1),e.dispatch(p?n.i(a.b)():n.i(a.d)())},c)}function i(){l&&(window.clearInterval(l),l=void 0)}n.d(t,"a",function(){return d});var o=n(19),a=n(8),s=n(77),u=n(11),c=1e4,l=void 0,p=!0,d=function(e){return function(t){return function(n){var u=t(n);switch(n.type){case o.c.DOCUMENTLOAD_SUCCESS:e.getState().reader.autoFlipInitially&&r(e);break;case a.a.SET_INTERACTED_WITH_READER:e.getState().reader.interactedWithReader&&i();break;case s.b:i(),e.getState().features.autoFlip&&r(e)}return u}}}},function(e,t,n){"use strict";n.d(t,"a",function(){return a});var r=n(19),i=n(8),o=n(11),a=function(e,t){return function(n){return function(a){return function(s){var u=a(s),c=n.getState();try{switch(s.type){case r.c.DOCUMENTLOAD_SUCCESS:var l=o.selectCurrentPageNumbers(c);e.onDocumentLoaded(c.documentModel,c.reader.initialPageNumber,l);break;case i.a.READER_POSITION_CHANGED:if(s.currentPagesHasChanged){var p=s.currentPages.map(function(e){return e.pageNumber});e.onPageChanged(p)}}}catch(e){t(e)}return u}}}}},function(e,t,n){"use strict";function r(e){window.fetch("http://pingback.tissuu.com/pong",{method:"post",body:JSON.stringify(e)}).catch(function(e){})}n.d(t,"a",function(){return i});var i=(n(93),n(109),n(139),n(11),function(e){return function(t){return function(n){console.group(n.type),console.info("dispatching",n);var i=t(n);return console.log("next state",e.getState()),console.groupEnd(n.type),r(n),i}}})},function(e,t,n){"use strict";n.d(t,"a",function(){return a});var r=n(8),i=n(19),o=n(11),a=function(e,t){return function(n){return function(a){return function(s){var u=a(s),c=n.getState();try{switch(s.type){case i.c.DOCUMENTLOAD_SUCCESS:var l=o.selectCurrentPageNumbers(c);e.onDocumentLoaded(c.documentModel,l);break;case r.a.READER_POSITION_CHANGED:if(c.reader.isReady&&s.currentPagesHasChanged){var p=o.selectCurrentPageNumbers(c);e.onPageChanged(p)}}}catch(e){t(e)}return u}}}}},function(e,t,n){"use strict";n.d(t,"a",function(){return a});var r=n(95),i=n(267),o=n.n(i),a=function(e){return function(t){return function(i){var a=t(i),s=e.getState();return o.a.setTagsContext({webgl:n.i(r.f)(s)}),a}}}},function(e,t,n){"use strict";function r(e,t,n){var r={width:t,height:n,left:(screen.width-t)/2,top:(screen.height-n)/2},i=Object.keys(r).map(function(e){return e+"="+r[e]}).join(",");window.open(e,"_blank",i)}function i(e,t){return function(n){var r=encodeURIComponent("I found this great publication on issuu.com"),i=encodeURIComponent("Hi,\n\nI found this publication on issuu.com which seems totally made for you.\n\n"+e+":\n"+t+"\n\nCheck it out and let me know what you think.\n\n- Me"),o="mailto:?subject="+r+"&body="+i;window.open(o,"_top")}}function o(e){return function(t){r("https://www.facebook.com/sharer.php?u="+encodeURIComponent(e),575,300)}}function a(e,t){return function(n){var i={url:encodeURIComponent(t),text:encodeURIComponent(e),via:"issuu"};r("https://twitter.com/intent/tweet?"+Object.keys(i).map(function(e){return e+"="+i[e]}).join("&"),550,420)}}function s(e,t,n){return function(i){var o={url:encodeURIComponent(e),media:encodeURIComponent(t),description:encodeURIComponent(n)};r("https://pinterest.com/pin/create/button/?"+Object.keys(o).map(function(e){return e+"="+o[e]}).join("&"),750,500)}}t.a=i,t.b=o,t.c=a,t.d=s},function(e,t,n){"use strict";n.d(t,"a",function(){return p});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(8),u=n(22),c=n(20),l=n(137),p=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.onClick=function(){this.props.dispatch(s.o(l.a)),this.props.featureTracker.usage(c.b.BUTTON_SHARE),this.props.dispatch(u.a())},t.prototype.render=function(){var e=this;return i.a.createElement("div",{className:"header-controls__share-toggle",onClick:function(){return e.onClick()}},"Share")},t}(r.Component);p.displayName="ShareButton",p.propTypes={dispatch:a.a.func.isRequired,featureTracker:a.a.object.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return g});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(371),u=n(137),c=n(8),l=n(22),p=n(20),d=n(375),f=n(377),h=n(376),m=n(374),g=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),d=0;d<o;d++)a[d]=arguments[d];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onShareOnEmail=function(){r.props.featureTracker.usage(p.b.SHARE_EMAIL),r.props.dispatch(s.a(r.props.documentTitle,r.props.documentUrl)),r.props.dispatch(l.a())},r.onShareOnFacebook=function(){r.props.featureTracker.usage(p.b.SHARE_FACEBOOK),r.props.dispatch(s.b(r.props.documentUrl)),r.props.dispatch(l.a())},r.onShareOnTwitter=function(){r.props.featureTracker.usage(p.b.SHARE_TWITTER),r.props.dispatch(s.c(r.props.documentTitle,r.props.documentUrl)),r.props.dispatch(l.a())},r.onShareOnPinterest=function(){r.props.featureTracker.usage(p.b.SHARE_PINTEREST),r.props.dispatch(s.d(r.props.documentUrl,r.props.coverImageUrl,r.props.documentTitle)),r.props.dispatch(l.a())},r.onDimmerClick=function(){r.props.dispatch(c.o(u.a))},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){var e=this.refs.shareDropdownInput;this.props.visible&&(e.setSelectionRange(0,e.value.length),this.props.featureTracker.opportunity(p.b.SHARE_EMAIL),this.props.featureTracker.opportunity(p.b.SHARE_FACEBOOK),this.props.featureTracker.opportunity(p.b.SHARE_TWITTER),this.props.featureTracker.opportunity(p.b.SHARE_PINTEREST))},t.prototype.render=function(){var e=this.props.documentUrl;return i.a.createElement("div",{className:"share-dropdown"},i.a.createElement("div",{className:"share-dropdown__dimmer",onClick:this.onDimmerClick}),i.a.createElement("div",{className:"share-dropdown__inner"},i.a.createElement("div",{className:"share-dropdown__social-buttons"},i.a.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--facebook",onClick:this.onShareOnFacebook,dangerouslySetInnerHTML:{__html:d.a},href:"javascript:void(0)","data-tooltip":"Facebook"}),i.a.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--twitter",onClick:this.onShareOnTwitter,dangerouslySetInnerHTML:{__html:f.a},href:"javascript:void(0)","data-tooltip":"Twitter"}),i.a.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--pinterest",onClick:this.onShareOnPinterest,dangerouslySetInnerHTML:{__html:h.a},href:"javascript:void(0)","data-tooltip":"Pinterest"}),i.a.createElement("a",{className:"share-dropdown__social-button share-dropdown__social-button--mailto",onClick:this.onShareOnEmail,dangerouslySetInnerHTML:{__html:m.a},href:"javascript:void(0)","data-tooltip":"E-mail"})),i.a.createElement("div",{className:"share-dropdown__direct-link"},i.a.createElement("input",{className:"share-dropdown__input",readOnly:!0,type:"text",value:e,ref:"shareDropdownInput"}))))},t}(r.Component);g.displayName="ShareDropdown",g.propTypes={coverImageUrl:a.a.string.isRequired,dispatch:a.a.func.isRequired,documentTitle:a.a.string.isRequired,documentUrl:a.a.string.isRequired,featureTracker:a.a.object.isRequired,visible:a.a.bool.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n  <svg width="20" height="15" viewBox="0 0 20 15" xmlns="http://www.w3.org/2000/svg">\n    <g fill="none" fill-rule="evenodd">\n      <path d="M-11.336-15.286h42.24v42.24h-42.24z"/>\n      <path class="icon" d="M.845 12.877c0 .315.112.583.336.806.225.222.495.333.812.333h16.05c.317 0 .587-.11.81-.333.225-.223.337-.49.337-.806V3.534l-9.173 6.834L.845 3.534v9.343zm0-11.39l9.172 6.834 9.172-6.833c0-.314-.113-.582-.337-.805-.224-.222-.494-.334-.81-.334H1.992c-.318 0-.588.112-.812.334-.223.223-.335.49-.335.805z"/>\n    </g>\n  </svg>\n'},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n  <svg width="17" height="18" viewBox="0 0 17 18" xmlns="http://www.w3.org/2000/svg">\n    <path class="icon" d="M16.082.34H.964c-.518 0-.938.42-.938.94v15.116c0 .518.42.938.938.938h8.14v-6.58H6.887V8.188h2.215V6.296c0-2.195 1.34-3.39 3.298-3.39.94 0 1.745.07 1.98.1v2.295h-1.358c-1.064 0-1.27.507-1.27 1.25v1.637h2.54l-.332 2.563h-2.21v6.58h4.332c.518 0 .938-.42.938-.937V1.28c0-.52-.42-.94-.938-.94" fill-rule="evenodd"></path>\n  </svg>\n'},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n  <svg width="18" height="19" viewBox="0 0 18 19" xmlns="http://www.w3.org/2000/svg">\n    <g fill="none" fill-rule="evenodd">\n      <path d="M-11.695-11.286h42.24v42.24h-42.24z"/>\n      <path class="icon" d="M8.898.796C4.028.796.078 4.72.078 9.558c0 3.588 2.172 6.67 5.28 8.025-.025-.612-.005-1.347.153-2.012l1.136-4.773s-.282-.56-.282-1.387c0-1.298.758-2.268 1.7-2.268.803 0 1.19.6 1.19 1.316 0 .8-.513 2-.778 3.11-.22.928.47 1.686 1.392 1.686 1.67 0 2.796-2.132 2.796-4.658 0-1.92-1.302-3.357-3.67-3.357-2.675 0-4.34 1.98-4.34 4.194 0 .764.225 1.302.58 1.72.163.19.186.267.127.487-.04.162-.14.55-.18.704-.058.222-.238.302-.44.22-1.233-.5-1.806-1.84-1.806-3.348 0-2.49 2.112-5.473 6.303-5.473 3.367 0 5.583 2.42 5.583 5.02 0 3.436-1.923 6.004-4.76 6.004-.95 0-1.846-.51-2.153-1.092 0 0-.512 2.02-.62 2.408-.188.676-.554 1.35-.888 1.877.792.233 1.63.36 2.498.36 4.87 0 8.82-3.923 8.82-8.762 0-4.84-3.95-8.762-8.82-8.762z"/>\n    </g>\n  </svg>\n'},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r='\n  <svg width="21" height="18" viewBox="0 0 21 18" xmlns="http://www.w3.org/2000/svg">\n    <g fill="none" fill-rule="evenodd">\n      <path d="M-11.12-12.286h42.24v42.24h-42.24z"/>\n      <path class="icon" d="M0 15.526c1.757 1.122 3.886 1.683 6.39 1.683 1.22 0 2.39-.162 3.506-.483 1.116-.322 2.106-.774 2.97-1.358.853-.572 1.622-1.238 2.31-2 .686-.76 1.247-1.577 1.683-2.45.904-1.816 1.356-3.64 1.356-5.47v-.542c.812-.584 1.502-1.3 2.07-2.145-.818.36-1.618.58-2.397.66.89-.526 1.502-1.29 1.832-2.294-.852.49-1.727.826-2.625 1.003-.403-.413-.87-.733-1.397-.96-.528-.226-1.083-.34-1.664-.34-1.15 0-2.128.403-2.937 1.206-.81.803-1.214 1.776-1.214 2.917 0 .374.03.692.09.955C8.27 5.82 6.68 5.407 5.2 4.672S2.457 2.937 1.407 1.67C1.03 2.313.842 2.983.842 3.678c0 .695.165 1.345.495 1.948.33.604.786 1.096 1.367 1.477-.667-.02-1.294-.19-1.882-.512v.05c0 .99.315 1.867.946 2.628.63.76 1.428 1.236 2.392 1.426-.396.1-.766.148-1.11.148-.217 0-.475-.026-.772-.08.264.835.755 1.52 1.47 2.058.718.538 1.518.81 2.403.817-1.63 1.305-3.35 1.958-5.16 1.958-.376 0-.706-.023-.99-.07z"/>\n    </g>\n  </svg>\n'},function(e,t,n){"use strict";var r=n(372),i=n(373),o=n(379);n.d(t,"a",function(){return r.a}),n.d(t,"b",function(){return i.a}),n.d(t,"d",function(){return o.a}),n.d(t,"c",function(){return o.b})},function(e,t,n){"use strict";n.d(t,"b",function(){return c}),n.d(t,"a",function(){return l});var r=n(33),i=(n.n(r),n(11)),o=n(93),a=n(214),s=n(41),u=n(137),c=n.i(r.createSelector)(o.canHideShareButton,i.selectShowCTAOverlay,i.selectFullscreenEnabled,i.selectFeature(s.SHARE_DIALOG_TYPE),function(e,t,n,r){return!(!r||r.customizedToNotShow&&e||t||r.hideWhenNotInFullscreen&&!n)}),l=function(e){return n.i(a.c)(e)===u.a}},function(e,t,n){"use strict";function r(e){if(e.backgroundImage){var t=null;if("topleft"===e.backgroundImagePosition?t=l.BACKGROUND_IMAGE_STYLE.TOP_LEFT:"stretch"===e.backgroundImagePosition&&(t=l.BACKGROUND_IMAGE_STYLE.STRETCH),t)return{url:e.backgroundImage,style:t,hideWhenNotInFullscreen:!0}}return null}function i(e){return e.logo?{url:e.logo,hideWhenNotInFullscreen:!0}:null}function o(e,t,n){switch(t.type){case s.b.SET_INPUBADS:return Object.assign({},e,{enableInPubAds:t.enableInPubAds});case u.c.DISABLE_LICENSE_CHECK:return n?e:Object.assign({},e,{disableLicenseCheck:!0});case c.b:var o=t.embedConfig,a=Object.assign({},e,{autoFlip:o.autoFlip,backgroundImage:r(o),logo:i(o),backgroundColor:o.backgroundColor,fullscreenBackgroundColor:o.fullscreenBackgroundColor,readModeRules:{defaultMode:"singlePage"===o.viewMode?l.READ_MODE.SINGLE_PAGE_SPREAD:l.READ_MODE.DOUBLE_PAGE_SPREAD,responsiveModeWhen:l.READ_MODE.RESPONSIVE.HANDHELD_IN_PORTRAIT_FULLSCREEN}});return a.controls=a.controls.map(function(e){return e.type===l.SHARE_DIALOG_TYPE?Object.assign({},e,{customizedToNotShow:!o.shareButtonEnabled}):e}),a;default:return e}}function a(e){return function(){return o(arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,arguments[1],arguments[2])}}n.d(t,"a",function(){return a});var s=n(130),u=n(19),c=n(77),l=n(41)},function(e,t,n){"use strict";function r(){var e={enabled:!1,supported:a.a()};return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,n=arguments[1];switch(n.type){case i.c.ENTER_FULLSCREEN:return Object.assign({},t,{enabled:n.fullscreenMethod===o.b});case i.c.EXIT_FULLSCREEN:return Object.assign({},t,{enabled:!1});default:return t}}}n.d(t,"a",function(){return r});var i=n(73),o=n(133),a=n(217)},function(e,t,n){"use strict";function r(e){return Object.assign({},e,{visibleDropdown:null,readMoreDropdownVisible:!1})}function i(e,t){return Object.assign(r(e),{visibleDropdown:t!==e.visibleDropdown?t:null})}function o(e){return Object.assign(r(e),{readMoreDropdownVisible:!0})}function a(e,t){switch(t.type){case u.a.TOGGLE_DROPDOWN:return i(e,t.dropdown);case u.a.SHOW_MORE_DROPDOWN:return o(e);case u.a.CLOSE_MORE_DROPDOWN:case u.a.SET_TARGET_SPREAD_INDEX:case u.a.SET_INTERACTING_WITH_CONTROLS:case c.c.ENTER_FULLSCREEN:case c.c.EXIT_FULLSCREEN:return r(e);case u.a.READER_POSITION_CHANGED:return t.isDragging?r(e):e;case u.a.READER_ZOOM_LEVEL_CHANCED:return t.isPinching?r(e):e;case l.a.DOWNLOAD_READY:case l.a.DOWNLOAD_LOADING:case l.a.DOWNLOAD_SUCCESS:case l.a.DOWNLOAD_FAILURE:return Object.assign(r(e),{downloadButtonStatus:t.type});default:return e}}function s(){var e={visibleDropdown:null,readMoreDropdownVisible:!1,downloadButtonStatus:l.a.DOWNLOAD_READY};return function(){return a(arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,arguments[1])}}n.d(t,"a",function(){return s});var u=n(8),c=n(73),l=n(129)},function(e,t,n){"use strict";function r(e,t){switch(t.type){case o.c.DOCUMENTLOADING:return Object.assign({},e,{status:a.d,loadStartTime:t.timeStamp});case o.c.DOCUMENTLOAD_SUCCESS:return Object.assign({},e,{status:a.b,loadSuccessTime:t.timeStamp});case o.c.DOCUMENTLOAD_FAILURE:return Object.assign({},e,{status:a.a,error:t.error,loadFailureTime:t.timeStamp});default:return e}}function i(e,t){var n={status:null,username:e,documentName:t,error:null};return function(){return r(arguments.length>0&&void 0!==arguments[0]?arguments[0]:n,arguments[1])}}t.a=i;var o=n(19),a=n(211)},function(e,t,n){"use strict";function r(e,t){return Object.assign({},e,{targetSpreadIndex:t.index})}function i(e,t){return Object.assign({},e,{debugMode:t.display})}function o(e,t){var n=t.initialPageNumber,r=t.targetSpreadIndex,i=t.currentPages;return Object.assign({},e,{targetSpreadIndex:r,currentPages:i,initialPageNumber:n,isReady:!0})}function a(e,t){return Object.assign({},e,{visiblePages:t.visiblePages,currentPages:t.currentPages,currentSpreadIndex:t.currentSpreadIndex,currentPageNumber:t.currentPageNumber,positionInPercent:t.positionInPercent,targetSpreadIndex:t.currentSpreadIndex===e.targetSpreadIndex?-1:e.targetSpreadIndex})}function s(e,t){return Object.assign({},e,{zoomLevel:t.zoomLevel})}function u(e,t){return Object.assign({},e,{isIdle:t.isIdle})}function c(e,t){return Object.assign({},e,{interactingWithControls:t.val})}function l(e,t){return Object.assign({},e,{interactedWithReader:!0})}function p(e,t){return Object.assign({},e,{interactedWithReader:!1})}function d(e,t){return Object.assign({},e,{hoveringOverControls:t})}function f(e,t){switch(t.type){case m.a.SET_DEBUG_MODE:return i(e,t);case m.a.SET_TARGET_SPREAD_INDEX:return r(e,t);case m.a.SET_IS_IDLE:return u(e,t);case m.a.SET_INTERACTING_WITH_CONTROLS:return c(e,t);case m.a.SET_INTERACTED_WITH_READER:return l(e,t);case m.a.SET_HOVERING_OVER_CONTROLS:return d(e,t.val);case b.c:return d(e,!1);case m.a.READER_POSITION_CHANGED:return a(e,t);case m.a.READER_ZOOM_LEVEL_CHANCED:return s(e,t);case g.b:return p(e,t);case v.c.DOCUMENTLOAD_SUCCESS:return o(e,t);default:return e}}function h(e){var t={arrivedAtSpreadTimeStamp:0,autoFlipInitially:e,debugMode:!1,hoveringOverControls:!1,initialPageNumber:0,interactedWithReader:!1,interactingWithControls:!1,interactingWithCanvas:!1,isIdle:!0,isReady:!1,lastSpreadIndexArrivedAt:-1,targetSpreadIndex:0,visiblePages:[],currentPages:[],currentPageNumber:0,currentSpreadIndex:-1,positionInPercent:0,zoomLevel:1};return function(){return f(arguments.length>0&&void 0!==arguments[0]?arguments[0]:t,arguments[1],arguments.length>2&&void 0!==arguments[2]?arguments[2]:{})}}n.d(t,"a",function(){return h});var m=n(8),g=n(77),v=n(19),b=n(110)},function(e,t,n){"use strict";function r(e,t){switch(t.type){case s.c.READ_MORE_LOAD_SUCCESS:return Object.assign({},e,{loaded:!0});case o.a.SHOW_MORE_DROPDOWN:return Object.assign({},e,{forceOverlay:!1});case o.a.CLOSE_MORE_DROPDOWN:return Object.assign({},e,{exitedFullscreen:!1});case a.c.ENTER_FULLSCREEN:return t.fullscreenMethod===c.b?e:Object.assign({},e,{exitedFullscreen:!0,forceOverlay:!0});case a.c.EXIT_FULLSCREEN:return Object.assign({},e,{exitedFullscreen:!0,forceOverlay:!0});case u.b:return Object.assign({},l);default:return e}}function i(){return function(){return r(arguments.length>0&&void 0!==arguments[0]?arguments[0]:l,arguments[1])}}t.a=i;var o=n(8),a=n(73),s=n(19),u=n(77),c=n(133),l={loaded:!1,exitedFullscreen:!1,forceOverlay:!1}},function(e,t,n){"use strict";function r(e,t,r,b,y,_,w,E){var x=o.a(b.autoFlip),S=i.a(t,r),T=a.a(),C=u.a(),I=c.a(),M=v.f(),P=l.a(b),R=n.i(p.g)(E),O=n.i(h.e)(),k=n.i(d.b)(),A=n.i(f.f)(),N=n.i(m.c)(),D=s.a(),L=n.i(g.d)();return function(t,n){return{documentModel:A(t.documentModel,n),canvasContext:R(t.canvasContext,n),fullscreen:T(t.fullscreen,n),headerControls:D(t.headerControls,n),loading:S(t.loading,n),reader:x(t.reader,n),readmore:C(t.readmore,n),paywall:O(t.paywall,n),size:k(t.size,n),videoOverlay:M(t.videoOverlay,n),visibility:I(t.visibility,n),features:P(t.features,n,!!t.reader&&t.reader.isReady),canvasApi:N(t.canvasApi,n),find:L(t.find,n),config:e,featureTracker:y,isLoggedIn:w,readMorePlugin:n.readMorePlugin||t.readMorePlugin||_}}}n.d(t,"a",function(){return r});var i=n(383),o=n(384),a=n(381),s=n(382),u=n(385),c=n(387),l=n(380),p=n(95),d=n(110),f=n(96),h=n(49),m=n(140),g=n(42),v=n(138)},function(e,t,n){"use strict";function r(e,t){return Object.assign({},e,{isHidden:a.c()})}function i(){var e={isHidden:a.c(),supported:a.a()};return function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:e,n=arguments[1];switch(n.type){case o.b.ON_VISIBILITY_CHANGE:return r(t,n);default:return t}}}n.d(t,"a",function(){return i});var o=n(196),a=n(219)},function(e,t,n){"use strict";function r(e,t,n){return{proportion:e,done:t,available:n}}n.d(t,"b",function(){return c}),n.d(t,"a",function(){return l});var i=n(33),o=(n.n(i),n(49)),a=n(11),s=n(59),u=n(40),c=n.i(i.createSelector)(a.selectZoomLevelInPercent,function(e){return e>0&&e<100?[{proportion:Math.round(e),done:!0,available:!0},{proportion:100-Math.round(e),done:!1,available:!0}]:[{proportion:100,done:100===e,available:!0}]}),l=n.i(i.createSelector)(a.selectCurrentSpreadIndex,a.selectLastSpreadIndex,function(e){return e.documentModel.pageCount},o.b.previewPages,o.b.isPreview,a.selectReadMode,function(e,t,i,o,a,c){for(var l=t+1,p=[r(2,e>0,!0)],d=a?o.map(function(e){return n.i(s.a)(c,e)}):[],f=1;f<l;f++){var h=p[p.length-1],m=!d.includes(f),g=f<=e,v=2;c===u.DOUBLE_PAGE_SPREAD&&f<t&&(v=4),f===e&&f<t?(p.push(r(c===u.DOUBLE_PAGE_SPREAD?2:1,!0,m)),p.push(r(c===u.DOUBLE_PAGE_SPREAD?2:1,!1,m))):g===h.done&&m===h.available?h.proportion+=v:p.push(r(v,g,m))}return p})},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function(){function e(t){babelHelpers.classCallCheck(this,e),this.gaTracker=t,this._baseUrl=null,this._previousPageNumbers=[],this._timeoutId=null}return e.prototype.destroy=function(){window.clearTimeout(this._timeoutId)},e.prototype.onDocumentLoaded=function(e,t,n){this._baseUrl="/"+e.username+"/docs/"+e.documentName,this._previousPageNumbers=n,this.gaTracker.sendInitialPageview(this._baseUrl+"/"+t),this.gaTracker.handleDocumentLoadByPublisherAccount(this._baseUrl,this._previousPageNumbers)},e.prototype.onPageChanged=function(e){var t=this;this._previousPageNumbers.join()!==e.join()&&(this._previousPageNumbers=e,window.clearTimeout(this._timeoutId),this._timeoutId=window.setTimeout(function(){t._previousPageNumbers.forEach(function(e){t.gaTracker.sendVirtualPageview(t._baseUrl+"/"+e)})},1e3))},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return o});var r=n(19),i=window.performance&&window.performance.now?function(){return window.performance.now()}:function(){return Date.now()},o=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this._hasTrackedTimeToCover=!1,this._pageLoadStartTime=new Map,this._fontLoadStartTime=new Map,this._imageDecodeStartTime=new Map,this._pageLoadStats={failedCount:0,successCount:0,successAfterRetryCount:0,failedTotalTime:0,successTotalTime:0,layersImageFallbackCount:0,fontloadCount:0,fontloadTotalTime:0},this._pageLoadStatsTimerId=null,this._totalFontRenderCalls=0,this._totalSlowFontRenderCalls=0,this._totalFramesDroppedOnFontRendering=0,this._fontRenderingStartTimeStamp=0,this._fontLoadTimings=[],this._imageDecodeTimings=[],this.trackingService=t}return e.prototype.onLoaderError=function(e){this.trackingService.monitor("reader3-render-manager-load-layer-error",{reason:e})},e.prototype.onOpsValidationError=function(e){this.trackingService.monitor("reader3-render-manager-ops-validation-failed",{count:e})},e.prototype.onDocumentLoadSuccess=function(e){this.trackingService.monitor("reader3-documentload-stats",{success_time:e},!1)},e.prototype.onDocumentLoadFailure=function(e,t){this.trackingService.monitor("reader3-documentload-stats",{failed_time:e,backend_error:t instanceof r.e?1:0,fetch_error:t instanceof r.f?1:0})},e.prototype.onDynamicApiLoadComplete=function(e,t){t?this.trackingService.monitor("reader3-dynamicapi-stats",{failure:1,failure_time:Math.round(e)},!1):this.trackingService.monitor("reader3-dynamicapi-stats",{success:1,success_time:Math.round(e)},!1)},e.prototype.onReadMoreLoadComplete=function(e){this.trackingService.monitor("reader3-readmoreload-stats",e?{success:1}:{failure:1},!1)},e.prototype.onPageLoadStart=function(e,t){this.mode=t,this._pageLoadStartTime.set(e,i())},e.prototype.onPageLoadSuccess=function(e){var t=i();if(!this._hasTrackedTimeToCover){var n=void 0;if(window.performance&&window.performance.now&&window.performance.timing&&window.performance.timing.fetchStart){var r=window.performance.timing.fetchStart-window.performance.timing.navigationStart;n=window.performance.now()-r}else n=Date.now()-this._loadStartTimeStamp;this.trackingService.monitor("reader3-time-to-cover",{ms_to_cover:n},!1),this._hasTrackedTimeToCover=!0}this._pageLoadStats.successCount+=1,this._pageLoadStats.successTotalTime+=t-(this._pageLoadStartTime.get(e)||0),this._pageLoadStartTime.delete(e),this.batchPageLoadStats()},e.prototype.onPageLoadSuccessAfterRetry=function(e){this._pageLoadStats.successAfterRetryCount+=1,this.onPageLoadSuccess(e)},e.prototype.onPageLoadFailure=function(e){this._pageLoadStats.failedCount+=1,this._pageLoadStats.failedTotalTime+=i()-(this._pageLoadStartTime.get(e)||0),this.batchPageLoadStats()},e.prototype.onLayersImageFallback=function(){this._pageLoadStats.layersImageFallbackCount+=1,this.batchPageLoadStats()},e.prototype.onFontRenderingStart=function(){this._fontRenderingStartTimeStamp=i()},e.prototype.onFontRenderingEnd=function(){var e=i()-this._fontRenderingStartTimeStamp,t=Math.max(Math.floor(e/(1e3/60))-1,0);this._totalFontRenderCalls+=1,t&&(this._totalSlowFontRenderCalls+=1,this._totalFramesDroppedOnFontRendering+=t),this.batchPageLoadStats()},e.prototype.onFontLoadStart=function(e){this._fontLoadStartTime.set(e,i())},e.prototype.onFontLoadEnd=function(e){var t=i()-(this._fontLoadStartTime.get(e)||0);this._fontLoadTimings.push(Math.round(t)),this._fontLoadStartTime.delete(e)},e.prototype.onImageDecodeStart=function(e){this._imageDecodeStartTime.set(e,i())},e.prototype.onImageDecodeEnd=function(e){var t=i()-(this._imageDecodeStartTime.get(e)||0);this._imageDecodeTimings.push(Math.round(t)),this._imageDecodeStartTime.delete(e)},e.prototype.batchPageLoadStats=function(){var e=this;if(!this._pageLoadStatsTimerId){var t=this._pageLoadStats;this._pageLoadStatsTimerId=setTimeout(function(){if(e._pageLoadStatsTimerId=0,t.successCount>0){var n={success_count:t.successCount,success_total_time:t.successTotalTime,success_avg_time:t.successTotalTime/t.successCount,success_after_retry:t.successAfterRetryCount,mode:e.mode,load_and_decode_count:void 0,load_and_decode_total_time:void 0,load_and_decode_avg_time:void 0};t.fontloadCount>0&&(Object.assign(n,{load_and_decode_count:t.fontloadCount,load_and_decode_total_time:t.fontloadTotalTime,load_and_decode_avg_time:t.fontloadTotalTime/t.fontloadCount}),t.fontloadCount=0,t.fontloadTotalTime=0),e.trackingService.monitor("reader3-pageload-stats",n,!1),t.successCount=0,t.successAfterRetryCount=0,t.successTotalTime=0}t.layersImageFallbackCount>0&&(e.trackingService.monitor("reader3-pageload-stats",{layers_image_fallback_count:t.layersImageFallbackCount},!1),t.layersImageFallbackCount=0),t.failedCount>0&&(e.trackingService.monitor("reader3-pageload-stats",{failed_count:t.failedCount,failed_total_time:t.failedTotalTime,failed_avg_time:t.failedTotalTime/t.failedCount,mode:e.mode},!1),t.failedCount=0,t.failedTotalTime=0),e._totalFontRenderCalls>0&&(e.trackingService.monitor("reader3-fontrender-stats",{total:e._totalFontRenderCalls,total_slow:e._totalSlowFontRenderCalls,total_frames_dropped:e._totalFramesDroppedOnFontRendering,mode:e.mode},!1),e._totalFontRenderCalls=0,e._totalSlowFontRenderCalls=0,e._totalFramesDroppedOnFontRendering=0),(e._fontLoadTimings.length||e._imageDecodeTimings.length)&&(e.trackingService.monitor("reader3-fontload-stats",{image_decode:e._fontLoadTimings.slice(0),font_load:e._imageDecodeTimings.slice(0),mode:e.mode},!1),e._fontLoadTimings.length=0,e._imageDecodeTimings.length=0)},5e3)}},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function(){function e(t){babelHelpers.classCallCheck(this,e),this.quantcastTracker=t,this._previousPageNumbers=[],this._timeoutId=null}return e.prototype.destroy=function(){window.clearTimeout(this._timeoutId)},e.prototype.onDocumentLoaded=function(e,t){this._previousPageNumbers=t,this.quantcastTracker.track()},e.prototype.onPageChanged=function(e){var t=this;this._previousPageNumbers.join()!==e.join()&&(this._previousPageNumbers=e,window.clearTimeout(this._timeoutId),this._timeoutId=window.setTimeout(function(){t._previousPageNumbers.forEach(function(e){t.quantcastTracker.track()})},1e3))},e}()},function(e,t,n){"use strict";function r(e){return Math.pow(2,Math.ceil(Math.log2(e)))}n.d(t,"b",function(){return o}),n.d(t,"a",function(){return a});var i=n(107),o=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.hintMaxWidth=t,this.hintMaxHeight=n}return e.prototype.draw=function(e,t,r,o,a,s,u){var c=e;if(!c||c.canvas.width!==o||c.canvas.height!==a){var l=c?c.canvas:document.createElement("canvas");l.width=o,l.height=a,c=l.getContext("2d",{alpha:!s})}return c&&c.canvas&&(c.canvas.id="reader3-canvas-"+t.page+"-"+o+"x"+a+(s?"-preview":""),n.i(i.e)(c,r,t,u)),c},e.prototype.release=function(e){e.canvas.width=0,e.canvas.height=0,e.canvas.id=(e.canvas.id||"")+"DELETED"},e.prototype.getSurface=function(e){return e.canvas},e}(),a=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this.gl=t,this.draw2d=new o(n,r)}return e.prototype.draw=function(e,t,n,i,o,a,s){var u=this.gl,c=this.draw2d.draw(null,t,n,i,o,a,s),l=c,p=this.draw2d.getSurface(l),d=r(Math.max(p.width,p.height)),f=a?p.width:d,h=a?p.height:d,m=u.getParameter(u.MAX_TEXTURE_SIZE);if(f>m||h>m)throw new Error("Requested creation of too large texture of size "+f+"x"+h+". maxTextureSize: "+m);var g=e?e.texture:u.createTexture();if(u.pixelStorei(u.UNPACK_FLIP_Y_WEBGL,!0),u.bindTexture(u.TEXTURE_2D,g),e&&e.width===f&&e.height===h||u.texImage2D(u.TEXTURE_2D,0,u.RGBA,f,h,0,u.RGBA,u.UNSIGNED_BYTE,null),u.texSubImage2D(u.TEXTURE_2D,0,0,0,u.RGBA,u.UNSIGNED_BYTE,p),u.getError()!==u.NO_ERROR)throw new Error("GL_ERROR: ("+u.getError()+") from gl.texSubImage2D");return u.texParameteri(u.TEXTURE_2D,u.TEXTURE_MAG_FILTER,u.LINEAR),u.texParameteri(u.TEXTURE_2D,u.TEXTURE_WRAP_S,u.CLAMP_TO_EDGE),u.texParameteri(u.TEXTURE_2D,u.TEXTURE_WRAP_T,u.CLAMP_TO_EDGE),a?u.texParameteri(u.TEXTURE_2D,u.TEXTURE_MIN_FILTER,u.NEAREST):(u.texParameteri(u.TEXTURE_2D,u.TEXTURE_MIN_FILTER,u.LINEAR_MIPMAP_LINEAR),u.generateMipmap(u.TEXTURE_2D)),u.bindTexture(u.TEXTURE_2D,null),this.draw2d.release(l),{texture:g,width:f,height:h,imgWidth:i,imgHeight:o}},e.prototype.release=function(e){this.gl.deleteTexture(e.texture)},e.prototype.getSurface=function(e){return{texture:e.texture,width:e.width,height:e.height,imgWidth:e.imgWidth,imgHeight:e.imgHeight}},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function(){function e(t,n,r){babelHelpers.classCallCheck(this,e),this._isTrackerReady=!1,this._interactedWithReader=!1,this._previousPages=[],this._previousZoom=1,this.tracker=t,this.streamData=n.streamData,this.isEmbed=n.isEmbed,this.adpageId=n.adpageId,this.embedId=r}return e.prototype.monitor=function(e,t){var n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=Object.assign({type:e},t);n?this.tracker.monitor(r):this.tracker.monitorBatched(r)},e.prototype.onDocumentLoaded=function(e,t){this._previousPages=t,this._isTrackerReady=!0,this.tracker.documentLoad({isEmbed:this.isEmbed,isFullscreen:!1,revisionId:e.revisionId,publicationId:e.publicationId,publicationName:e.documentName,ownerUsername:e.username,pages:t,pageNumber:t[0],embedId:this.embedId,adpageId:this.adpageId,streamOrigin:this.streamData.origin,streamRanking:this.streamData.ranking})},e.prototype.onActivity=function(e){this._isTrackerReady&&e&&!this._interactedWithReader&&(this._interactedWithReader=!0,this.tracker.userInteracted())},e.prototype.onPageChanged=function(e){this._isTrackerReady&&0!==e.length&&this._previousPages.join()!==e.join()&&(this._previousPages=e,this.tracker.pageChange({pages:e,pageNumber:e[0]}))},e.prototype.onZoom=function(e){this._isTrackerReady&&this._previousZoom!==e&&(this._previousZoom=e,this.tracker.zoom())},e.prototype.onResize=function(e,t){this._isTrackerReady&&this.tracker.resize({displaySize:e,isFullscreen:t})},e.prototype.onDownload=function(e){this.tracker.documentDownload({anonymous:!0,revisionId:e.revisionId,publicationId:e.publicationId,publicationName:e.documentName,ownerUsername:e.username})},e.prototype.onClippingActionGotoPage=function(e){this._isTrackerReady&&this.tracker.clippingAction({clippingId:e.clippingId,action:"gotoPage",onPage:e.page.pageNumber,page:e.pageNumber,creator:"publisher"})},e.prototype.onClippingActionOpenUrl=function(e){this._isTrackerReady&&this.tracker.clippingAction({clippingId:e.clippingId,action:"openUrl",onPage:e.page.pageNumber,creator:"publisher",url:e.url})},e}()},function(e,t,n){"use strict";n.d(t,"a",function(){return s});var r=n(111),i=n(19),o=n(73),a=n(11),s=function(e,t){var s={};return s[i.c.DOCUMENTLOAD_SUCCESS]=function(t,n,r){if(e.isEmbed){var i={};i[a.selectReaderSize(n)]=1,e.monitor("reader3-embed-size",i,!1)}},s[o.c.ENTER_FULLSCREEN]=function(t,n,r){e.monitor("reader3-fullscreen-method."+r.fullscreenMethod,{count:1})},n.i(r.a)(s,t)}},function(e,t,n){"use strict";n.d(t,"a",function(){return o});var r=n(19),i=n(111),o=function(e,t){var o={};return o[r.c.DOCUMENTLOAD_SUCCESS]=function(t,n,r){e.onDocumentLoadSuccess(r.timeStamp-n.loading.loadStartTime)},o[r.c.DOCUMENTLOAD_FAILURE]=function(t,n,r){e.onDocumentLoadFailure(r.timeStamp-n.loading.loadStartTime,r.error)},o[r.c.DYNAMIC_API_FAILURE]=function(t,n,r){e.onDynamicApiLoadComplete(r.loadTime,r.error)},o[r.c.DYNAMIC_API_SUCCESS]=function(t,n,r){e.onDynamicApiLoadComplete(r.loadTime)},o[r.c.READ_MORE_LOAD_SUCCESS]=function(t,n,r){e.onReadMoreLoadComplete(!0)},o[r.c.READ_MORE_LOAD_FAILURE]=function(t,n,r){e.onReadMoreLoadComplete(!1)},n.i(i.a)(o,t)}},function(e,t,n){"use strict";n.d(t,"a",function(){return a});var r=n(8),i=n(111),o=n(745),a=function(e,t){var a="unknownDevice",s="unknownBrowser";try{var u=(new o).getResult();a=u.device.type||"desktop",s=u.browser.name||"unknownBrowser"}catch(e){}a=a.replace(" ","_"),s=s.replace(" ","_");var c={};return c[r.a.TRACK_DROPPED_FRAMES]=function(t,n,r){var i={dropped:Math.round(r.droppedFrames),dropped_per_sec:Math.round(Math.min(r.droppedFrames/r.duration*1e3,r.droppedFrames)),duration_in_ms:Math.round(r.duration),webgl:r.usesWebGl};e.monitor("reader3-dropped-frames",i,!1),e.monitor("reader3-dropped-frames.browser."+s,i,!1),e.monitor("reader3-dropped-frames.device."+a,i,!1)},n.i(i.a)(c,t)}},function(e,t,n){"use strict";n.d(t,"a",function(){return p});var r=n(77),i=n(8),o=n(195),a=n(129),s=n(19),u=n(110),c=n(11),l=n(111),p=function(e,t){var p=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],d=[],f={};f[i.a.SET_INTERACTED_WITH_READER]=function(t,n,r){e.onActivity(n.reader.interactedWithReader)},f[i.a.READER_ZOOM_LEVEL_CHANCED]=function(t,n,r){e.onZoom(n.reader.zoomLevel)},f[a.a.DOWNLOAD_SUCCESS]=function(t,n,r){e.onDownload(n.documentModel)},f[i.a.READER_POSITION_CHANGED]=function(t,n,r){if(n.reader.isReady){var i=t.reader.currentPages,o=n.reader.currentPages;i[0]===o[0]&&i[1]===o[1]||e.onPageChanged(o.map(function(e){return e.pageNumber}))}},f[s.c.DOCUMENTLOAD_SUCCESS]=function(t,n,r){var i=c.selectCurrentPageNumbers(n);e.onDocumentLoaded(n.documentModel,i)},f[u.c]=function(t,n,r){n.reader.isReady&&e.onResize(r.width+"x"+r.height,c.selectFullscreenEnabled(n))},f[o.c.GOTO_PAGE]=function(t,n,r){e.onClippingActionGotoPage(r.linkModel)},f[o.c.OPEN_URL]=function(t,n,r){e.onClippingActionOpenUrl(r.linkModel)};var h={};if(p)for(var m=Object.keys(f),g=Array.isArray(m),v=0,m=g?m:m[Symbol.iterator]();;){var b;if(g){if(v>=m.length)break;b=m[v++]}else{if(v=m.next(),v.done)break;b=v.value}var y=b;h[y]=f[y]}else h[s.c.DOCUMENTLOAD_SUCCESS]=function(t,n,r){var i=c.selectCurrentPageNumbers(n);d.push(function(){return e.onDocumentLoaded(n.documentModel,i)})},h[r.c]=function(e,t,n){for(var r=d,i=Array.isArray(r),o=0,r=i?r:r[Symbol.iterator]();;){var a;if(i){if(o>=r.length)break;a=r[o++]}else{if(o=r.next(),o.done)break;a=o.value}a()}for(var s=Object.keys(f),u=Array.isArray(s),c=0,s=u?s:s[Symbol.iterator]();;){var l;if(u){if(c>=s.length)break;l=s[c++]}else{if(c=s.next(),c.done)break;l=c.value}var p=l;h[p]=f[p]}};return n.i(l.a)(h,t)}},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function(){function e(t,n){babelHelpers.classCallCheck(this,e),this.target=t,this.callback=n,this._eventHandler=this._eventHandler.bind(this),this.target.addEventListener("mousedown",this._eventHandler,!0),this.target.addEventListener("touchstart",this._eventHandler,!0),this.target.addEventListener("pointerdown",this._eventHandler,!0),this.target.addEventListener("MSPointerDown",this._eventHandler,!0),this.target.addEventListener("gesturestart",this._eventHandler,!0),this.target.addEventListener("wheel",this._eventHandler,!0),this.target.ownerDocument.addEventListener("keydown",this._eventHandler,!0)}return e.prototype._eventHandler=function(e){("wheel"!==e.type||e.ctrlKey)&&this.callback()},e.prototype.destroy=function(){this.target.removeEventListener("mousedown",this._eventHandler,!0),this.target.removeEventListener("touchstart",this._eventHandler,!0),this.target.removeEventListener("pointerdown",this._eventHandler,!0),this.target.removeEventListener("MSPointerDown",this._eventHandler,!0),this.target.removeEventListener("gesturestart",this._eventHandler,!0),this.target.removeEventListener("wheel",this._eventHandler,!0),this.target.ownerDocument.removeEventListener("keydown",this._eventHandler,!0)},e}()},function(e,t,n){"use strict";function r(e){var t=void 0===e?"undefined":babelHelpers.typeof(e);return"function"===t?s.test(o.call(e)):e&&"object"===t&&a.test(i.call(e))||!1}n.d(t,"a",function(){return r});var i=Object.prototype.toString,o=Function.prototype.toString,a=/^\[object .+?Constructor\]$/,s=RegExp("^"+String(i).replace(/[.*+?^${}()|[\]\/\\]/g,"\\$&").replace(/toString|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$")},function(e,t,n){"use strict";function r(e,t,r,o){var a=t?1:-1,s=r.map(function(e){return n.i(i.a)(o,e)}),u=Array.from(new Set(s)).sort(function(e,t){return e-t});if(u.includes(e))for(;u.includes(e+a);)a+=t?1:-1;return e+a}t.a=r;var i=n(59)},function(e,t,n){"use strict";function r(e,t,n){var r=e.createShader(n);if(e.shaderSource(r,t),e.compileShader(r),!e.getShaderParameter(r,e.COMPILE_STATUS))throw new Error("Cannot compile "+n+" shader: "+e.getShaderInfoLog(r));return r}function i(e,t){var n=e.getExtension(t);if(!n)throw new Error("does not support extension ");return n}function o(e,t,n,r,i){if(e.checkFramebufferStatus(e.FRAMEBUFFER)!==e.FRAMEBUFFER_COMPLETE)throw new Error("cannot read from framebuffer");var o=new Uint8Array(u*u*4);e.readPixels(0,0,u,u,e.RGBA,e.UNSIGNED_BYTE,o);for(var a=0;a<u*u;a++){var s=o.subarray(4*a,4*(a+1));if(s[0]!==t||s[1]!==n||s[2]!==r||s[3]!==i)return!1}return!0}function a(e){[].push(i(e,"OES_standard_derivatives"));var t=e.createProgram(),n=r(e,l,e.VERTEX_SHADER),a=r(e,c,e.FRAGMENT_SHADER);if(e.attachShader(t,n),e.attachShader(t,a),e.linkProgram(t),!e.getProgramParameter(t,e.LINK_STATUS))throw new Error("Cannot link shaderprogram: "+e.getProgramInfoLog(t));e.enableVertexAttribArray(e.getAttribLocation(t,"vertex"));var s=e.createBuffer();e.bindBuffer(e.ARRAY_BUFFER,s),e.bufferData(e.ARRAY_BUFFER,new Float32Array([0,0,0,1,1,0,1,1]),e.STATIC_DRAW),e.vertexAttribPointer(t.vertex,2,e.FLOAT,!1,0,0);var p=e.createTexture();e.bindTexture(e.TEXTURE_2D,p),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),e.texImage2D(e.TEXTURE_2D,0,e.RGBA,u,u,0,e.RGBA,e.UNSIGNED_BYTE,null);var d=e.createFramebuffer();if(e.bindFramebuffer(e.FRAMEBUFFER,d),e.framebufferTexture2D(e.FRAMEBUFFER,e.COLOR_ATTACHMENT0,e.TEXTURE_2D,p,0),e.viewport(0,0,u,u),e.useProgram(t),e.drawArrays(e.TRIANGLE_STRIP,0,4),!o(e,255,0,0,255))throw new Error("did not render correct color (frontfacing)");if(e.bufferData(e.ARRAY_BUFFER,new Float32Array([0,1,0,0,1,1,1,0]),e.STATIC_DRAW),e.drawArrays(e.TRIANGLE_STRIP,0,4),!o(e,0,0,255,255))throw new Error("did not render correct color (backfacing)");e.bindFramebuffer(e.FRAMEBUFFER,null),e.bindTexture(e.TEXTURE_2D,null),e.bindBuffer(e.ARRAY_BUFFER,null),e.deleteFramebuffer(d),e.deleteTexture(p),e.deleteBuffer(s),e.detachShader(t,n),e.deleteShader(n),e.detachShader(t,a),e.deleteShader(a),e.deleteProgram(t)}n.d(t,"a",function(){return p});var s=n(142),u=16,c="\n#extension GL_OES_standard_derivatives : require\nprecision highp float;\nvarying vec3 v[8];\nvoid main(void) {\n    vec3 d = smoothstep(0.0, v[3].x, dFdx(vec3(v[1])) * fwidth(v[2])); // Undeclared identifier 'dFdx'\n    if (gl_FrontFacing) { // This hardware is unable to support gl_FrontFacing\n        gl_FragColor = vec4(1, d.x, 0, 1);\n    } else {\n        gl_FragColor = vec4(0, d.x, 1, 1);\n    }\n}\n",l="\nprecision highp float;\nattribute vec2 vertex;\nvarying vec3 v[8];\nvoid main(void) {\n    v[0] = vec3(0); // Maximum varying vector count exceeded\n    v[1] = vec3(1); // Maximum varying vector count exceeded\n    v[2] = vec3(2); // Maximum varying vector count exceeded\n    v[3] = vec3(3); // Maximum varying vector count exceeded\n    v[4] = vec3(4); // Maximum varying vector count exceeded\n    v[5] = vec3(5); // Maximum varying vector count exceeded\n    v[6] = vec3(6); // Maximum varying vector count exceeded\n    v[7] = vec3(7); // Maximum varying vector count exceeded\n\n    vec2 p = 2.0 * vertex - 1.0;\n    gl_Position = vec4(p.x, -p.y, 0.0, 1.0);\n}\n",p=function(){function e(){babelHelpers.classCallCheck(this,e)}return e.isWebGLSupported=function(){try{var e=n.i(s.a)(document.createElement("canvas"));return!!e&&(a(e),!0)}catch(e){return!1}},e}()},function(e,t){e.exports='<svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">\n  <path d="M12.052 16c.243 0 .484-.092.67-.275.37-.367.37-.963 0-1.33L6.284 8l6.438-6.395c.37-.368.37-.963 0-1.33-.37-.367-.97-.367-1.338 0l-7.108 7.06c-.37.366-.37.962 0 1.33l7.106 7.06c.185.183.427.275.67.275" fill="#FFFFFF" fill-rule="evenodd"/>\n</svg>\n'},function(e,t){e.exports='<svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">\n  <path d="M4.948 16c-.243 0-.484-.092-.67-.275-.37-.367-.37-.963 0-1.33L10.716 8 4.277 1.604c-.37-.368-.37-.963 0-1.33.37-.367.97-.367 1.338 0l7.108 7.06c.37.366.37.962 0 1.33l-7.106 7.06c-.185.183-.427.275-.67.275" fill="#FFFFFF" fill-rule="evenodd"/>\n</svg>\n'},function(e,t){e.exports='<svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">\n  <path d="M6.446 8L.322 14.124c-.43.43-.43 1.126 0 1.555.215.213.496.32.777.32.28 0 .562-.107.776-.32L8 9.554l6.124 6.124c.214.213.496.32.777.32.282 0 .563-.107.778-.32.43-.43.43-1.126 0-1.556L9.554 8l6.124-6.124c.43-.43.43-1.125 0-1.554-.43-.43-1.125-.43-1.554 0L8 6.446 1.876.322c-.43-.43-1.125-.43-1.554 0-.43.43-.43 1.125 0 1.554L6.446 8z" fill="#FFFFFF" fill-rule="evenodd"/>\n</svg>\n'},function(e,t){e.exports='<svg width="100%" height="100%" viewBox="-9 -9 34 34" xmlns="http://www.w3.org/2000/svg">\n  <path d="M6.29 12.58c3.474 0 6.29-2.816 6.29-6.29S9.765 0 6.29 0 0 2.816 0 6.29s2.816 6.29 6.29 6.29zm0-1.677c2.548 0 4.613-2.065 4.613-4.613 0-2.548-2.065-4.613-4.613-4.613-2.548 0-4.613 2.065-4.613 4.613 0 2.548 2.065 4.613 4.613 4.613zm4.665 1.83c-.492-.49-.496-1.284 0-1.78.49-.49 1.287-.49 1.78.002l2.895 2.895c.49.492.495 1.286 0 1.78-.49.492-1.288.49-1.78 0l-2.895-2.896zm-3.18-3.507L7.34 7.8H5.157l-.436 1.426H3.355l2.113-6.012H7.02l2.122 6.012H7.775zm-.738-2.49c-.403-1.29-.627-2.022-.678-2.19-.05-.17-.088-.304-.11-.403-.09.35-.348 1.214-.774 2.592h1.56z" class="shadow" fill-rule="evenodd" />\n  <path d="M6.29 12.58c3.474 0 6.29-2.816 6.29-6.29S9.765 0 6.29 0 0 2.816 0 6.29s2.816 6.29 6.29 6.29zm0-1.677c2.548 0 4.613-2.065 4.613-4.613 0-2.548-2.065-4.613-4.613-4.613-2.548 0-4.613 2.065-4.613 4.613 0 2.548 2.065 4.613 4.613 4.613zm4.665 1.83c-.492-.49-.496-1.284 0-1.78.49-.49 1.287-.49 1.78.002l2.895 2.895c.49.492.495 1.286 0 1.78-.49.492-1.288.49-1.78 0l-2.895-2.896zm-3.18-3.507L7.34 7.8H5.157l-.436 1.426H3.355l2.113-6.012H7.02l2.122 6.012H7.775zm-.738-2.49c-.403-1.29-.627-2.022-.678-2.19-.05-.17-.088-.304-.11-.403-.09.35-.348 1.214-.774 2.592h1.56z" class="icon" fill-rule="evenodd"/>\n</svg>\n'},function(e,t,n){n(415),e.exports=n(50).RegExp.escape},function(e,t,n){var r=n(9),i=n(151),o=n(12)("species");e.exports=function(e){var t;return i(e)&&(t=e.constructor,"function"!=typeof t||t!==Array&&!i(t.prototype)||(t=void 0),r(t)&&null===(t=t[o])&&(t=void 0)),void 0===t?Array:t}},function(e,t,n){var r=n(407);e.exports=function(e,t){return new(r(e))(t)}},function(e,t,n){"use strict";var r=n(3),i=n(45);e.exports=function(e){if("string"!==e&&"number"!==e&&"default"!==e)throw TypeError("Incorrect hint");return i(r(this),"number"!=e)}},function(e,t,n){var r=n(67),i=n(120),o=n(99);e.exports=function(e){var t=r(e),n=i.f;if(n)for(var a,s=n(e),u=o.f,c=0;s.length>c;)u.call(e,a=s[c++])&&t.push(a);return t}},function(e,t,n){var r=n(67),i=n(29);e.exports=function(e,t){for(var n,o=i(e),a=r(o),s=a.length,u=0;s>u;)if(o[n=a[u++]]===t)return n}},function(e,t,n){"use strict";var r=n(413),i=n(116),o=n(25);e.exports=function(){for(var e=o(this),t=arguments.length,n=Array(t),a=0,s=r._,u=!1;t>a;)(n[a]=arguments[a++])===s&&(u=!0);return function(){var r,o=this,a=arguments.length,c=0,l=0;if(!u&&!a)return i(e,n,o);if(r=n.slice(),u)for(;t>c;c++)r[c]===s&&(r[c]=arguments[l++]);for(;a>l;)r.push(arguments[l++]);return i(e,r,o)}}},function(e,t,n){e.exports=n(4)},function(e,t){e.exports=function(e,t){var n=t===Object(t)?function(e){return t[e]}:t;return function(t){return String(t).replace(e,n)}}},function(e,t,n){var r=n(0),i=n(414)(/[\\^$*+?.()|[\]{}]/g,"\\$&");r(r.S,"RegExp",{escape:function(e){return i(e)}})},function(e,t,n){var r=n(0);r(r.P,"Array",{copyWithin:n(224)}),n(81)("copyWithin")},function(e,t,n){"use strict";var r=n(0),i=n(43)(4);r(r.P+r.F*!n(38)([].every,!0),"Array",{every:function(e){return i(this,e,arguments[1])}})},function(e,t,n){var r=n(0);r(r.P,"Array",{fill:n(143)}),n(81)("fill")},function(e,t,n){"use strict";var r=n(0),i=n(43)(2);r(r.P+r.F*!n(38)([].filter,!0),"Array",{filter:function(e){return i(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(0),i=n(43)(6),o="findIndex",a=!0;o in[]&&Array(1)[o](function(){a=!1}),r(r.P+r.F*a,"Array",{findIndex:function(e){return i(this,e,arguments.length>1?arguments[1]:void 0)}}),n(81)(o)},function(e,t,n){"use strict";var r=n(0),i=n(43)(5),o=!0;"find"in[]&&Array(1).find(function(){o=!1}),r(r.P+r.F*o,"Array",{find:function(e){return i(this,e,arguments.length>1?arguments[1]:void 0)}}),n(81)("find")},function(e,t,n){"use strict";var r=n(0),i=n(43)(0);r(r.P+r.F*!n(38)([].forEach,!0),"Array",{forEach:function(e){return i(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(51),i=n(0),o=n(18),a=n(233),s=n(150),u=n(17),c=n(144),l=n(167);i(i.S+i.F*!n(118)(function(e){Array.from(e)}),"Array",{from:function(e){var t,n,i,p,d=o(e),f="function"==typeof this?this:Array,h=arguments.length,m=h>1?arguments[1]:void 0,g=void 0!==m,v=0,b=l(d);if(g&&(m=r(m,h>2?arguments[2]:void 0,2)),void 0==b||f==Array&&s(b))for(t=u(d.length),n=new f(t);t>v;v++)c(n,v,g?m(d[v],v):d[v]);else for(p=b.call(d),n=new f;!(i=p.next()).done;v++)c(n,v,g?a(p,m,[i.value,v],!0):i.value);return n.length=v,n}})},function(e,t,n){"use strict";var r=n(0),i=n(112)(!1),o=[].indexOf,a=!!o&&1/[1].indexOf(1,-0)<0;r(r.P+r.F*(a||!n(38)(o)),"Array",{indexOf:function(e){return a?o.apply(this,arguments)||0:i(this,e,arguments[1])}})},function(e,t,n){var r=n(0);r(r.S,"Array",{isArray:n(151)})},function(e,t,n){"use strict";var r=n(0),i=n(29),o=[].join;r(r.P+r.F*(n(98)!=Object||!n(38)(o)),"Array",{join:function(e){return o.call(i(this),void 0===e?",":e)}})},function(e,t,n){"use strict";var r=n(0),i=n(29),o=n(62),a=n(17),s=[].lastIndexOf,u=!!s&&1/[1].lastIndexOf(1,-0)<0;r(r.P+r.F*(u||!n(38)(s)),"Array",{lastIndexOf:function(e){if(u)return s.apply(this,arguments)||0;var t=i(this),n=a(t.length),r=n-1;for(arguments.length>1&&(r=Math.min(r,o(arguments[1]))),r<0&&(r=n+r);r>=0;r--)if(r in t&&t[r]===e)return r||0;return-1}})},function(e,t,n){"use strict";var r=n(0),i=n(43)(1);r(r.P+r.F*!n(38)([].map,!0),"Array",{map:function(e){return i(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(0),i=n(144);r(r.S+r.F*n(6)(function(){function e(){}return!(Array.of.call(e)instanceof e)}),"Array",{of:function(){for(var e=0,t=arguments.length,n=new("function"==typeof this?this:Array)(t);t>e;)i(n,e,arguments[e++]);return n.length=t,n}})},function(e,t,n){"use strict";var r=n(0),i=n(226);r(r.P+r.F*!n(38)([].reduceRight,!0),"Array",{reduceRight:function(e){return i(this,e,arguments.length,arguments[1],!0)}})},function(e,t,n){"use strict";var r=n(0),i=n(226);r(r.P+r.F*!n(38)([].reduce,!0),"Array",{reduce:function(e){return i(this,e,arguments.length,arguments[1],!1)}})},function(e,t,n){"use strict";var r=n(0),i=n(148),o=n(36),a=n(70),s=n(17),u=[].slice;r(r.P+r.F*n(6)(function(){i&&u.call(i)}),"Array",{slice:function(e,t){var n=s(this.length),r=o(this);if(t=void 0===t?n:t,"Array"==r)return u.call(this,e,t);for(var i=a(e,n),c=a(t,n),l=s(c-i),p=Array(l),d=0;d<l;d++)p[d]="String"==r?this.charAt(i+d):this[i+d];return p}})},function(e,t,n){"use strict";var r=n(0),i=n(43)(3);r(r.P+r.F*!n(38)([].some,!0),"Array",{some:function(e){return i(this,e,arguments[1])}})},function(e,t,n){"use strict";var r=n(0),i=n(25),o=n(18),a=n(6),s=[].sort,u=[1,2,3];r(r.P+r.F*(a(function(){u.sort(void 0)})||!a(function(){u.sort(null)})||!n(38)(s)),"Array",{sort:function(e){return void 0===e?s.call(o(this)):s.call(o(this),i(e))}})},function(e,t,n){n(69)("Array")},function(e,t,n){var r=n(0);r(r.S,"Date",{now:function(){return(new Date).getTime()}})},function(e,t,n){"use strict";var r=n(0),i=n(6),o=Date.prototype.getTime,a=function(e){return e>9?e:"0"+e};r(r.P+r.F*(i(function(){return"0385-07-25T07:06:39.999Z"!=new Date(-5e13-1).toISOString()})||!i(function(){new Date(NaN).toISOString()})),"Date",{toISOString:function(){if(!isFinite(o.call(this)))throw RangeError("Invalid time value");var e=this,t=e.getUTCFullYear(),n=e.getUTCMilliseconds(),r=t<0?"-":t>9999?"+":"";return r+("00000"+Math.abs(t)).slice(r?-6:-4)+"-"+a(e.getUTCMonth()+1)+"-"+a(e.getUTCDate())+"T"+a(e.getUTCHours())+":"+a(e.getUTCMinutes())+":"+a(e.getUTCSeconds())+"."+(n>99?n:"0"+a(n))+"Z"}})},function(e,t,n){"use strict";var r=n(0),i=n(18),o=n(45);r(r.P+r.F*n(6)(function(){return null!==new Date(NaN).toJSON()||1!==Date.prototype.toJSON.call({toISOString:function(){return 1}})}),"Date",{toJSON:function(e){var t=i(this),n=o(t);return"number"!=typeof n||isFinite(n)?t.toISOString():null}})},function(e,t,n){var r=n(12)("toPrimitive"),i=Date.prototype;r in i||n(26)(i,r,n(409))},function(e,t,n){var r=Date.prototype,i=r.toString,o=r.getTime;new Date(NaN)+""!="Invalid Date"&&n(27)(r,"toString",function(){var e=o.call(this);return e===e?i.call(this):"Invalid Date"})},function(e,t,n){var r=n(0);r(r.P,"Function",{bind:n(227)})},function(e,t,n){"use strict";var r=n(9),i=n(31),o=n(12)("hasInstance"),a=Function.prototype;o in a||n(15).f(a,o,{value:function(e){if("function"!=typeof this||!r(e))return!1;if(!r(this.prototype))return e instanceof this;for(;e=i(e);)if(this.prototype===e)return!0;return!1}})},function(e,t,n){var r=n(15).f,i=n(61),o=n(23),a=Function.prototype,s=Object.isExtensible||function(){return!0};"name"in a||n(14)&&r(a,"name",{configurable:!0,get:function(){try{var e=this,t=(""+e).match(/^\s*function ([^ (]*)/)[1];return o(e,"name")||!s(e)||r(e,"name",i(5,t)),t}catch(e){return""}}})},function(e,t,n){var r=n(0),i=n(235),o=Math.sqrt,a=Math.acosh;r(r.S+r.F*!(a&&710==Math.floor(a(Number.MAX_VALUE))&&a(1/0)==1/0),"Math",{acosh:function(e){return(e=+e)<1?NaN:e>94906265.62425156?Math.log(e)+Math.LN2:i(e-1+o(e-1)*o(e+1))}})},function(e,t,n){function r(e){return isFinite(e=+e)&&0!=e?e<0?-r(-e):Math.log(e+Math.sqrt(e*e+1)):e}var i=n(0),o=Math.asinh;i(i.S+i.F*!(o&&1/o(0)>0),"Math",{asinh:r})},function(e,t,n){var r=n(0),i=Math.atanh;r(r.S+r.F*!(i&&1/i(-0)<0),"Math",{atanh:function(e){return 0==(e=+e)?e:Math.log((1+e)/(1-e))/2}})},function(e,t,n){var r=n(0),i=n(155);r(r.S,"Math",{cbrt:function(e){return i(e=+e)*Math.pow(Math.abs(e),1/3)}})},function(e,t,n){var r=n(0);r(r.S,"Math",{clz32:function(e){return(e>>>=0)?31-Math.floor(Math.log(e+.5)*Math.LOG2E):32}})},function(e,t,n){var r=n(0),i=Math.exp;r(r.S,"Math",{cosh:function(e){return(i(e=+e)+i(-e))/2}})},function(e,t,n){var r=n(0),i=n(154);r(r.S+r.F*(i!=Math.expm1),"Math",{expm1:i})},function(e,t,n){var r=n(0),i=n(155),o=Math.pow,a=o(2,-52),s=o(2,-23),u=o(2,127)*(2-s),c=o(2,-126),l=function(e){return e+1/a-1/a};r(r.S,"Math",{fround:function(e){var t,n,r=Math.abs(e),o=i(e);return r<c?o*l(r/c/s)*c*s:(t=(1+s/a)*r,n=t-(t-r),n>u||n!=n?o*(1/0):o*n)}})},function(e,t,n){var r=n(0),i=Math.abs;r(r.S,"Math",{hypot:function(e,t){for(var n,r,o=0,a=0,s=arguments.length,u=0;a<s;)n=i(arguments[a++]),u<n?(r=u/n,o=o*r*r+1,u=n):n>0?(r=n/u,o+=r*r):o+=n;return u===1/0?1/0:u*Math.sqrt(o)}})},function(e,t,n){var r=n(0),i=Math.imul;r(r.S+r.F*n(6)(function(){return i(4294967295,5)!=-5||2!=i.length}),"Math",{imul:function(e,t){var n=+e,r=+t,i=65535&n,o=65535&r;return 0|i*o+((65535&n>>>16)*o+i*(65535&r>>>16)<<16>>>0)}})},function(e,t,n){var r=n(0);r(r.S,"Math",{log10:function(e){return Math.log(e)/Math.LN10}})},function(e,t,n){var r=n(0);r(r.S,"Math",{log1p:n(235)})},function(e,t,n){var r=n(0);r(r.S,"Math",{log2:function(e){return Math.log(e)/Math.LN2}})},function(e,t,n){var r=n(0);r(r.S,"Math",{sign:n(155)})},function(e,t,n){var r=n(0),i=n(154),o=Math.exp;r(r.S+r.F*n(6)(function(){return!Math.sinh(-2e-17)!=-2e-17}),"Math",{sinh:function(e){return Math.abs(e=+e)<1?(i(e)-i(-e))/2:(o(e-1)-o(-e-1))*(Math.E/2)}})},function(e,t,n){var r=n(0),i=n(154),o=Math.exp;r(r.S,"Math",{tanh:function(e){var t=i(e=+e),n=i(-e);return t==1/0?1:n==1/0?-1:(t-n)/(o(e)+o(-e))}})},function(e,t,n){var r=n(0);r(r.S,"Math",{trunc:function(e){return(e>0?Math.floor:Math.ceil)(e)}})},function(e,t,n){"use strict";var r=n(4),i=n(23),o=n(36),a=n(149),s=n(45),u=n(6),c=n(66).f,l=n(30).f,p=n(15).f,d=n(85).trim,f=r.Number,h=f,m=f.prototype,g="Number"==o(n(65)(m)),v="trim"in String.prototype,b=function(e){var t=s(e,!1);if("string"==typeof t&&t.length>2){t=v?t.trim():d(t,3);var n,r,i,o=t.charCodeAt(0);if(43===o||45===o){if(88===(n=t.charCodeAt(2))||120===n)return NaN}else if(48===o){switch(t.charCodeAt(1)){case 66:case 98:r=2,i=49;break;case 79:case 111:r=8,i=55;break;default:return+t}for(var a,u=t.slice(2),c=0,l=u.length;c<l;c++)if((a=u.charCodeAt(c))<48||a>i)return NaN;return parseInt(u,r)}}return+t};if(!f(" 0o1")||!f("0b1")||f("+0x1")){f=function(e){var t=arguments.length<1?0:e,n=this;return n instanceof f&&(g?u(function(){m.valueOf.call(n)}):"Number"!=o(n))?a(new h(b(t)),n,f):b(t)};for(var y,_=n(14)?c(h):"MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,EPSILON,isFinite,isInteger,isNaN,isSafeInteger,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,parseFloat,parseInt,isInteger".split(","),w=0;_.length>w;w++)i(h,y=_[w])&&!i(f,y)&&p(f,y,l(h,y));f.prototype=m,m.constructor=f,n(27)(r,"Number",f)}},function(e,t,n){var r=n(0);r(r.S,"Number",{EPSILON:Math.pow(2,-52)})},function(e,t,n){var r=n(0),i=n(4).isFinite;r(r.S,"Number",{isFinite:function(e){return"number"==typeof e&&i(e)}})},function(e,t,n){var r=n(0);r(r.S,"Number",{isInteger:n(232)})},function(e,t,n){var r=n(0);r(r.S,"Number",{isNaN:function(e){return e!=e}})},function(e,t,n){var r=n(0),i=n(232),o=Math.abs;r(r.S,"Number",{isSafeInteger:function(e){return i(e)&&o(e)<=9007199254740991}})},function(e,t,n){var r=n(0);r(r.S,"Number",{MAX_SAFE_INTEGER:9007199254740991})},function(e,t,n){var r=n(0);r(r.S,"Number",{MIN_SAFE_INTEGER:-9007199254740991})},function(e,t,n){var r=n(0),i=n(242);r(r.S+r.F*(Number.parseFloat!=i),"Number",{parseFloat:i})},function(e,t,n){var r=n(0),i=n(243);r(r.S+r.F*(Number.parseInt!=i),"Number",{parseInt:i})},function(e,t,n){"use strict";var r=n(0),i=n(62),o=n(223),a=n(162),s=1..toFixed,u=Math.floor,c=[0,0,0,0,0,0],l="Number.toFixed: incorrect invocation!",p=function(e,t){for(var n=-1,r=t;++n<6;)r+=e*c[n],c[n]=r%1e7,r=u(r/1e7)},d=function(e){for(var t=6,n=0;--t>=0;)n+=c[t],c[t]=u(n/e),n=n%e*1e7},f=function(){for(var e=6,t="";--e>=0;)if(""!==t||0===e||0!==c[e]){var n=String(c[e]);t=""===t?n:t+a.call("0",7-n.length)+n}return t},h=function(e,t,n){return 0===t?n:t%2==1?h(e,t-1,n*e):h(e*e,t/2,n)},m=function(e){for(var t=0,n=e;n>=4096;)t+=12,n/=4096;for(;n>=2;)t+=1,n/=2;return t};r(r.P+r.F*(!!s&&("0.000"!==8e-5.toFixed(3)||"1"!==.9.toFixed(0)||"1.25"!==1.255.toFixed(2)||"1000000000000000128"!==(0xde0b6b3a7640080).toFixed(0))||!n(6)(function(){s.call({})})),"Number",{toFixed:function(e){var t,n,r,s,u=o(this,l),c=i(e),g="",v="0";if(c<0||c>20)throw RangeError(l);if(u!=u)return"NaN";if(u<=-1e21||u>=1e21)return String(u);if(u<0&&(g="-",u=-u),u>1e-21)if(t=m(u*h(2,69,1))-69,n=t<0?u*h(2,-t,1):u/h(2,t,1),n*=4503599627370496,(t=52-t)>0){for(p(0,n),r=c;r>=7;)p(1e7,0),r-=7;for(p(h(10,r,1),0),r=t-1;r>=23;)d(1<<23),r-=23;d(1<<r),p(1,1),d(2),v=f()}else p(0,n),p(1<<-t,0),v=f()+a.call("0",c);return c>0?(s=v.length,v=g+(s<=c?"0."+a.call("0",c-s)+v:v.slice(0,s-c)+"."+v.slice(s-c))):v=g+v,v}})},function(e,t,n){"use strict";var r=n(0),i=n(6),o=n(223),a=1..toPrecision;r(r.P+r.F*(i(function(){return"1"!==a.call(1,void 0)})||!i(function(){a.call({})})),"Number",{toPrecision:function(e){var t=o(this,"Number#toPrecision: incorrect invocation!");return void 0===e?a.call(t):a.call(t,e)}})},function(e,t,n){var r=n(0);r(r.S+r.F,"Object",{assign:n(236)})},function(e,t,n){var r=n(0);r(r.S,"Object",{create:n(65)})},function(e,t,n){var r=n(0);r(r.S+r.F*!n(14),"Object",{defineProperties:n(237)})},function(e,t,n){var r=n(0);r(r.S+r.F*!n(14),"Object",{defineProperty:n(15).f})},function(e,t,n){var r=n(9),i=n(60).onFreeze;n(44)("freeze",function(e){return function(t){return e&&r(t)?e(i(t)):t}})},function(e,t,n){var r=n(29),i=n(30).f;n(44)("getOwnPropertyDescriptor",function(){return function(e,t){return i(r(e),t)}})},function(e,t,n){n(44)("getOwnPropertyNames",function(){return n(238).f})},function(e,t,n){var r=n(18),i=n(31);n(44)("getPrototypeOf",function(){return function(e){return i(r(e))}})},function(e,t,n){var r=n(9);n(44)("isExtensible",function(e){return function(t){return!!r(t)&&(!e||e(t))}})},function(e,t,n){var r=n(9);n(44)("isFrozen",function(e){return function(t){return!r(t)||!!e&&e(t)}})},function(e,t,n){var r=n(9);n(44)("isSealed",function(e){return function(t){return!r(t)||!!e&&e(t)}})},function(e,t,n){var r=n(0);r(r.S,"Object",{is:n(244)})},function(e,t,n){var r=n(18),i=n(67);n(44)("keys",function(){return function(e){return i(r(e))}})},function(e,t,n){var r=n(9),i=n(60).onFreeze;n(44)("preventExtensions",function(e){return function(t){return e&&r(t)?e(i(t)):t}})},function(e,t,n){var r=n(9),i=n(60).onFreeze;n(44)("seal",function(e){return function(t){return e&&r(t)?e(i(t)):t}})},function(e,t,n){var r=n(0);r(r.S,"Object",{setPrototypeOf:n(157).set})},function(e,t,n){"use strict";var r=n(97),i={};i[n(12)("toStringTag")]="z",i+""!="[object z]"&&n(27)(Object.prototype,"toString",function(){return"[object "+r(this)+"]"},!0)},function(e,t,n){var r=n(0),i=n(242);r(r.G+r.F*(parseFloat!=i),{parseFloat:i})},function(e,t,n){var r=n(0),i=n(243);r(r.G+r.F*(parseInt!=i),{parseInt:i})},function(e,t,n){"use strict";var r,i,o,a=n(64),s=n(4),u=n(51),c=n(97),l=n(0),p=n(9),d=n(25),f=n(63),h=n(82),m=n(159),g=n(164).set,v=n(156)(),b=s.TypeError,y=s.process,_=s.Promise,y=s.process,w="process"==c(y),E=function(){},x=!!function(){try{var e=_.resolve(1),t=(e.constructor={})[n(12)("species")]=function(e){e(E,E)};return(w||"function"==typeof PromiseRejectionEvent)&&e.then(E)instanceof t}catch(e){}}(),S=function(e,t){return e===t||e===_&&t===o},T=function(e){var t;return!(!p(e)||"function"!=typeof(t=e.then))&&t},C=function(e){return S(_,e)?new I(e):new i(e)},I=i=function(e){var t,n;this.promise=new e(function(e,r){if(void 0!==t||void 0!==n)throw b("Bad Promise constructor");t=e,n=r}),this.resolve=d(t),this.reject=d(n)},M=function(e){try{e()}catch(e){return{error:e}}},P=function(e,t){if(!e._n){e._n=!0;var n=e._c;v(function(){for(var r=e._v,i=1==e._s,o=0;n.length>o;)!function(t){var n,o,a=i?t.ok:t.fail,s=t.resolve,u=t.reject,c=t.domain;try{a?(i||(2==e._h&&k(e),e._h=1),a===!0?n=r:(c&&c.enter(),n=a(r),c&&c.exit()),n===t.promise?u(b("Promise-chain cycle")):(o=T(n))?o.call(n,s,u):s(n)):u(r)}catch(e){u(e)}}(n[o++]);e._c=[],e._n=!1,t&&!e._h&&R(e)})}},R=function(e){g.call(s,function(){var t,n,r,i=e._v;if(O(e)&&(t=M(function(){w?y.emit("unhandledRejection",i,e):(n=s.onunhandledrejection)?n({promise:e,reason:i}):(r=s.console)&&r.error&&r.error("Unhandled promise rejection",i)}),e._h=w||O(e)?2:1),e._a=void 0,t)throw t.error})},O=function(e){if(1==e._h)return!1;for(var t,n=e._a||e._c,r=0;n.length>r;)if(t=n[r++],t.fail||!O(t.promise))return!1;return!0},k=function(e){g.call(s,function(){var t;w?y.emit("rejectionHandled",e):(t=s.onrejectionhandled)&&t({promise:e,reason:e._v})})},A=function(e){var t=this;t._d||(t._d=!0,t=t._w||t,t._v=e,t._s=2,t._a||(t._a=t._c.slice()),P(t,!0))},N=function(e){var t,n=this;if(!n._d){n._d=!0,n=n._w||n;try{if(n===e)throw b("Promise can't be resolved itself");(t=T(e))?v(function(){var r={_w:n,_d:!1};try{t.call(e,u(N,r,1),u(A,r,1))}catch(e){A.call(r,e)}}):(n._v=e,n._s=1,P(n,!1))}catch(e){A.call({_w:n,_d:!1},e)}}};x||(_=function(e){f(this,_,"Promise","_h"),d(e),r.call(this);try{e(u(N,this,1),u(A,this,1))}catch(e){A.call(this,e)}},r=function(e){this._c=[],this._a=void 0,this._s=0,this._d=!1,this._v=void 0,this._h=0,this._n=!1},r.prototype=n(68)(_.prototype,{then:function(e,t){var n=C(m(this,_));return n.ok="function"!=typeof e||e,n.fail="function"==typeof t&&t,n.domain=w?y.domain:void 0,this._c.push(n),this._a&&this._a.push(n),this._s&&P(this,!1),n.promise},catch:function(e){return this.then(void 0,e)}}),I=function(){var e=new r;this.promise=e,this.resolve=u(N,e,1),this.reject=u(A,e,1)}),l(l.G+l.W+l.F*!x,{Promise:_}),n(84)(_,"Promise"),n(69)("Promise"),o=n(50).Promise,l(l.S+l.F*!x,"Promise",{reject:function(e){var t=C(this);return(0,t.reject)(e),t.promise}}),l(l.S+l.F*(a||!x),"Promise",{resolve:function(e){if(e instanceof _&&S(e.constructor,this))return e;var t=C(this);return(0,t.resolve)(e),t.promise}}),l(l.S+l.F*!(x&&n(118)(function(e){_.all(e).catch(E)})),"Promise",{all:function(e){var t=this,n=C(t),r=n.resolve,i=n.reject,o=M(function(){var n=[],o=0,a=1;h(e,!1,function(e){var s=o++,u=!1;n.push(void 0),a++,t.resolve(e).then(function(e){u||(u=!0,n[s]=e,--a||r(n))},i)}),--a||r(n)});return o&&i(o.error),n.promise},race:function(e){var t=this,n=C(t),r=n.reject,i=M(function(){h(e,!1,function(e){t.resolve(e).then(n.resolve,r)})});return i&&r(i.error),n.promise}})},function(e,t,n){var r=n(0),i=n(25),o=n(3),a=(n(4).Reflect||{}).apply,s=Function.apply;r(r.S+r.F*!n(6)(function(){a(function(){})}),"Reflect",{apply:function(e,t,n){var r=i(e),u=o(n);return a?a(r,t,u):s.call(r,t,u)}})},function(e,t,n){var r=n(0),i=n(65),o=n(25),a=n(3),s=n(9),u=n(6),c=n(227),l=(n(4).Reflect||{}).construct,p=u(function(){function e(){}return!(l(function(){},[],e)instanceof e)}),d=!u(function(){l(function(){})});r(r.S+r.F*(p||d),"Reflect",{construct:function(e,t){o(e),a(t);var n=arguments.length<3?e:o(arguments[2]);if(d&&!p)return l(e,t,n);if(e==n){switch(t.length){case 0:return new e;case 1:return new e(t[0]);case 2:return new e(t[0],t[1]);case 3:return new e(t[0],t[1],t[2]);case 4:return new e(t[0],t[1],t[2],t[3])}var r=[null];return r.push.apply(r,t),new(c.apply(e,r))}var u=n.prototype,f=i(s(u)?u:Object.prototype),h=Function.apply.call(e,f,t);return s(h)?h:f}})},function(e,t,n){var r=n(15),i=n(0),o=n(3),a=n(45);i(i.S+i.F*n(6)(function(){Reflect.defineProperty(r.f({},1,{value:1}),1,{value:2})}),"Reflect",{defineProperty:function(e,t,n){o(e),t=a(t,!0),o(n);try{return r.f(e,t,n),!0}catch(e){return!1}}})},function(e,t,n){var r=n(0),i=n(30).f,o=n(3);r(r.S,"Reflect",{deleteProperty:function(e,t){var n=i(o(e),t);return!(n&&!n.configurable)&&delete e[t]}})},function(e,t,n){"use strict";var r=n(0),i=n(3),o=function(e){this._t=i(e),this._i=0;var t,n=this._k=[];for(t in e)n.push(t)};n(152)(o,"Object",function(){var e,t=this,n=t._k;do{if(t._i>=n.length)return{value:void 0,done:!0}}while(!((e=n[t._i++])in t._t));return{value:e,done:!1}}),r(r.S,"Reflect",{enumerate:function(e){return new o(e)}})},function(e,t,n){var r=n(30),i=n(0),o=n(3);i(i.S,"Reflect",{getOwnPropertyDescriptor:function(e,t){return r.f(o(e),t)}})},function(e,t,n){var r=n(0),i=n(31),o=n(3);r(r.S,"Reflect",{getPrototypeOf:function(e){return i(o(e))}})},function(e,t,n){function r(e,t){var n,s,l=arguments.length<3?e:arguments[2];return c(e)===l?e[t]:(n=i.f(e,t))?a(n,"value")?n.value:void 0!==n.get?n.get.call(l):void 0:u(s=o(e))?r(s,t,l):void 0}var i=n(30),o=n(31),a=n(23),s=n(0),u=n(9),c=n(3);s(s.S,"Reflect",{get:r})},function(e,t,n){var r=n(0);r(r.S,"Reflect",{has:function(e,t){return t in e}})},function(e,t,n){var r=n(0),i=n(3),o=Object.isExtensible;r(r.S,"Reflect",{isExtensible:function(e){return i(e),!o||o(e)}})},function(e,t,n){var r=n(0);r(r.S,"Reflect",{ownKeys:n(241)})},function(e,t,n){var r=n(0),i=n(3),o=Object.preventExtensions;r(r.S,"Reflect",{preventExtensions:function(e){i(e);try{return o&&o(e),!0}catch(e){return!1}}})},function(e,t,n){var r=n(0),i=n(157);i&&r(r.S,"Reflect",{setPrototypeOf:function(e,t){i.check(e,t);try{return i.set(e,t),!0}catch(e){return!1}}})},function(e,t,n){function r(e,t,n){var u,d,f=arguments.length<4?e:arguments[3],h=o.f(l(e),t);if(!h){if(p(d=a(e)))return r(d,t,n,f);h=c(0)}return s(h,"value")?!(h.writable===!1||!p(f))&&(u=o.f(f,t)||c(0),u.value=n,i.f(f,t,u),!0):void 0!==h.set&&(h.set.call(f,n),!0)}var i=n(15),o=n(30),a=n(31),s=n(23),u=n(0),c=n(61),l=n(3),p=n(9);u(u.S,"Reflect",{set:r})},function(e,t,n){var r=n(4),i=n(149),o=n(15).f,a=n(66).f,s=n(117),u=n(115),c=r.RegExp,l=c,p=c.prototype,d=/a/g,f=/a/g!==new c(/a/g);if(n(14)&&(!f||n(6)(function(){return d[n(12)("match")]=!1,/a/g!=c(/a/g)||c(d)==d||"/a/i"!=c(/a/g,"i")}))){c=function(e,t){var n=this instanceof c,r=s(e),o=void 0===t;return!n&&r&&e.constructor===c&&o?e:i(f?new l(r&&!o?e.source:e,t):l((r=e instanceof c)?e.source:e,r&&o?u.call(e):t),n?this:p,c)};for(var h=a(l),m=0;h.length>m;)!function(e){e in c||o(c,e,{configurable:!0,get:function(){return l[e]},set:function(t){l[e]=t}})}(h[m++]);p.constructor=c,c.prototype=p,n(27)(r,"RegExp",c)}n(69)("RegExp")},function(e,t,n){n(114)("match",1,function(e,t,n){return[function(n){"use strict";var r=e(this),i=void 0==n?void 0:n[t];return void 0!==i?i.call(n,r):new RegExp(n)[t](String(r))},n]})},function(e,t,n){n(114)("replace",2,function(e,t,n){return[function(r,i){"use strict";var o=e(this),a=void 0==r?void 0:r[t];return void 0!==a?a.call(r,o,i):n.call(String(o),r,i)},n]})},function(e,t,n){n(114)("search",1,function(e,t,n){return[function(n){"use strict";var r=e(this),i=void 0==n?void 0:n[t];return void 0!==i?i.call(n,r):new RegExp(n)[t](String(r))},n]})},function(e,t,n){n(114)("split",2,function(e,t,r){"use strict";var i=n(117),o=r,a=[].push,s="length";if("c"=="abbc".split(/(b)*/)[1]||4!="test".split(/(?:)/,-1)[s]||2!="ab".split(/(?:ab)*/)[s]||4!=".".split(/(.?)(.?)/)[s]||".".split(/()()/)[s]>1||"".split(/.?/)[s]){var u=void 0===/()??/.exec("")[1];r=function(e,t){var n=String(this);if(void 0===e&&0===t)return[];if(!i(e))return o.call(n,e,t);var r,c,l,p,d,f=[],h=(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")+(e.sticky?"y":""),m=0,g=void 0===t?4294967295:t>>>0,v=new RegExp(e.source,h+"g");for(u||(r=new RegExp("^"+v.source+"$(?!\\s)",h));(c=v.exec(n))&&!((l=c.index+c[0][s])>m&&(f.push(n.slice(m,c.index)),!u&&c[s]>1&&c[0].replace(r,function(){for(d=1;d<arguments[s]-2;d++)void 0===arguments[d]&&(c[d]=void 0)}),c[s]>1&&c.index<n[s]&&a.apply(f,c.slice(1)),p=c[0][s],m=l,f[s]>=g));)v.lastIndex===c.index&&v.lastIndex++;return m===n[s]?!p&&v.test("")||f.push(""):f.push(n.slice(m)),f[s]>g?f.slice(0,g):f}}else"0".split(void 0,0)[s]&&(r=function(e,t){return void 0===e&&0===t?[]:o.call(this,e,t)});return[function(n,i){var o=e(this),a=void 0==n?void 0:n[t];return void 0!==a?a.call(n,o,i):r.call(String(o),n,i)},r]})},function(e,t,n){"use strict";n(248);var r=n(3),i=n(115),o=n(14),a=/./.toString,s=function(e){n(27)(RegExp.prototype,"toString",e,!0)};n(6)(function(){return"/a/b"!=a.call({source:"a",flags:"b"})})?s(function(){var e=r(this);return"/".concat(e.source,"/","flags"in e?e.flags:!o&&e instanceof RegExp?i.call(e):void 0)}):"toString"!=a.name&&s(function(){return a.call(this)})},function(e,t,n){"use strict";n(28)("anchor",function(e){return function(t){return e(this,"a","name",t)}})},function(e,t,n){"use strict";n(28)("big",function(e){return function(){return e(this,"big","","")}})},function(e,t,n){"use strict";n(28)("blink",function(e){return function(){return e(this,"blink","","")}})},function(e,t,n){"use strict";n(28)("bold",function(e){return function(){return e(this,"b","","")}})},function(e,t,n){"use strict";var r=n(0),i=n(160)(!1);r(r.P,"String",{codePointAt:function(e){return i(this,e)}})},function(e,t,n){"use strict";var r=n(0),i=n(17),o=n(161),a="".endsWith;r(r.P+r.F*n(147)("endsWith"),"String",{endsWith:function(e){var t=o(this,e,"endsWith"),n=arguments.length>1?arguments[1]:void 0,r=i(t.length),s=void 0===n?r:Math.min(i(n),r),u=String(e);return a?a.call(t,u,s):t.slice(s-u.length,s)===u}})},function(e,t,n){"use strict";n(28)("fixed",function(e){return function(){return e(this,"tt","","")}})},function(e,t,n){"use strict";n(28)("fontcolor",function(e){return function(t){return e(this,"font","color",t)}})},function(e,t,n){"use strict";n(28)("fontsize",function(e){return function(t){return e(this,"font","size",t)}})},function(e,t,n){var r=n(0),i=n(70),o=String.fromCharCode,a=String.fromCodePoint;r(r.S+r.F*(!!a&&1!=a.length),"String",{fromCodePoint:function(e){for(var t,n=[],r=arguments.length,a=0;r>a;){if(t=+arguments[a++],i(t,1114111)!==t)throw RangeError(t+" is not a valid code point");n.push(t<65536?o(t):o(55296+((t-=65536)>>10),t%1024+56320))}return n.join("")}})},function(e,t,n){"use strict";var r=n(0),i=n(161);r(r.P+r.F*n(147)("includes"),"String",{includes:function(e){return!!~i(this,e,"includes").indexOf(e,arguments.length>1?arguments[1]:void 0)}})},function(e,t,n){"use strict";n(28)("italics",function(e){return function(){return e(this,"i","","")}})},function(e,t,n){"use strict";var r=n(160)(!0);n(153)(String,"String",function(e){this._t=String(e),this._i=0},function(){var e,t=this._t,n=this._i;return n>=t.length?{value:void 0,done:!0}:(e=r(t,n),this._i+=e.length,{value:e,done:!1})})},function(e,t,n){"use strict";n(28)("link",function(e){return function(t){return e(this,"a","href",t)}})},function(e,t,n){var r=n(0),i=n(29),o=n(17);r(r.S,"String",{raw:function(e){for(var t=i(e.raw),n=o(t.length),r=arguments.length,a=[],s=0;n>s;)a.push(String(t[s++])),s<r&&a.push(String(arguments[s]));return a.join("")}})},function(e,t,n){var r=n(0);r(r.P,"String",{repeat:n(162)})},function(e,t,n){"use strict";n(28)("small",function(e){return function(){return e(this,"small","","")}})},function(e,t,n){"use strict";var r=n(0),i=n(17),o=n(161),a="".startsWith;r(r.P+r.F*n(147)("startsWith"),"String",{startsWith:function(e){var t=o(this,e,"startsWith"),n=i(Math.min(arguments.length>1?arguments[1]:void 0,t.length)),r=String(e);return a?a.call(t,r,n):t.slice(n,n+r.length)===r}})},function(e,t,n){"use strict";n(28)("strike",function(e){return function(){return e(this,"strike","","")}})},function(e,t,n){"use strict";n(28)("sub",function(e){return function(){return e(this,"sub","","")}})},function(e,t,n){"use strict";n(28)("sup",function(e){return function(){return e(this,"sup","","")}})},function(e,t,n){"use strict";n(85)("trim",function(e){return function(){return e(this,3)}})},function(e,t,n){"use strict";var r=n(4),i=n(23),o=n(14),a=n(0),s=n(27),u=n(60).KEY,c=n(6),l=n(121),p=n(84),d=n(71),f=n(12),h=n(246),m=n(166),g=n(411),v=n(410),b=n(151),y=n(3),_=n(29),w=n(45),E=n(61),x=n(65),S=n(238),T=n(30),C=n(15),I=n(67),M=T.f,P=C.f,R=S.f,O=r.Symbol,k=r.JSON,A=k&&k.stringify,N=f("_hidden"),D=f("toPrimitive"),L={}.propertyIsEnumerable,F=l("symbol-registry"),U=l("symbols"),B=l("op-symbols"),H=Object.prototype,j="function"==typeof O,z=r.QObject,W=!z||!z.prototype||!z.prototype.findChild,V=o&&c(function(){return 7!=x(P({},"a",{get:function(){return P(this,"a",{value:7}).a}})).a})?function(e,t,n){var r=M(H,t);r&&delete H[t],P(e,t,n),r&&e!==H&&P(H,t,r)}:P,G=function(e){var t=U[e]=x(O.prototype);return t._k=e,t},q=j&&"symbol"==typeof O.iterator?function(e){return"symbol"==typeof e}:function(e){return e instanceof O},Y=function(e,t,n){return e===H&&Y(B,t,n),y(e),t=w(t,!0),y(n),i(U,t)?(n.enumerable?(i(e,N)&&e[N][t]&&(e[N][t]=!1),n=x(n,{enumerable:E(0,!1)})):(i(e,N)||P(e,N,E(1,{})),e[N][t]=!0),V(e,t,n)):P(e,t,n)},$=function(e,t){y(e);for(var n,r=v(t=_(t)),i=0,o=r.length;o>i;)Y(e,n=r[i++],t[n]);return e},K=function(e,t){return void 0===t?x(e):$(x(e),t)},X=function(e){var t=L.call(this,e=w(e,!0));return!(this===H&&i(U,e)&&!i(B,e))&&(!(t||!i(this,e)||!i(U,e)||i(this,N)&&this[N][e])||t)},Z=function(e,t){if(e=_(e),t=w(t,!0),e!==H||!i(U,t)||i(B,t)){var n=M(e,t);return!n||!i(U,t)||i(e,N)&&e[N][t]||(n.enumerable=!0),n}},Q=function(e){for(var t,n=R(_(e)),r=[],o=0;n.length>o;)i(U,t=n[o++])||t==N||t==u||r.push(t);return r},J=function(e){for(var t,n=e===H,r=R(n?B:_(e)),o=[],a=0;r.length>a;)!i(U,t=r[a++])||n&&!i(H,t)||o.push(U[t]);return o};j||(O=function(){if(this instanceof O)throw TypeError("Symbol is not a constructor!");var e=d(arguments.length>0?arguments[0]:void 0),t=function(n){this===H&&t.call(B,n),i(this,N)&&i(this[N],e)&&(this[N][e]=!1),V(this,e,E(1,n))};return o&&W&&V(H,e,{configurable:!0,set:t}),G(e)},s(O.prototype,"toString",function(){return this._k}),T.f=Z,C.f=Y,n(66).f=S.f=Q,n(99).f=X,n(120).f=J,o&&!n(64)&&s(H,"propertyIsEnumerable",X,!0),h.f=function(e){return G(f(e))}),a(a.G+a.W+a.F*!j,{Symbol:O});for(var ee="hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","),te=0;ee.length>te;)f(ee[te++]);for(var ee=I(f.store),te=0;ee.length>te;)m(ee[te++]);a(a.S+a.F*!j,"Symbol",{for:function(e){return i(F,e+="")?F[e]:F[e]=O(e)},keyFor:function(e){if(q(e))return g(F,e);throw TypeError(e+" is not a symbol!")},useSetter:function(){W=!0},useSimple:function(){W=!1}}),a(a.S+a.F*!j,"Object",{create:K,defineProperty:Y,defineProperties:$,getOwnPropertyDescriptor:Z,getOwnPropertyNames:Q,getOwnPropertySymbols:J}),k&&a(a.S+a.F*(!j||c(function(){var e=O();return"[null]"!=A([e])||"{}"!=A({a:e})||"{}"!=A(Object(e))})),"JSON",{stringify:function(e){if(void 0!==e&&!q(e)){for(var t,n,r=[e],i=1;arguments.length>i;)r.push(arguments[i++]);return t=r[1],"function"==typeof t&&(n=t),!n&&b(t)||(t=function(e,t){if(n&&(t=n.call(this,e,t)),!q(t))return t}),r[1]=t,A.apply(k,r)}}}),O.prototype[D]||n(26)(O.prototype,D,O.prototype.valueOf),p(O,"Symbol"),p(Math,"Math",!0),p(r.JSON,"JSON",!0)},function(e,t,n){"use strict";var r=n(0),i=n(122),o=n(165),a=n(3),s=n(70),u=n(17),c=n(9),l=n(4).ArrayBuffer,p=n(159),d=o.ArrayBuffer,f=o.DataView,h=i.ABV&&l.isView,m=d.prototype.slice,g=i.VIEW;r(r.G+r.W+r.F*(l!==d),{ArrayBuffer:d}),r(r.S+r.F*!i.CONSTR,"ArrayBuffer",{isView:function(e){return h&&h(e)||c(e)&&g in e}}),r(r.P+r.U+r.F*n(6)(function(){return!new d(2).slice(1,void 0).byteLength}),"ArrayBuffer",{slice:function(e,t){if(void 0!==m&&void 0===t)return m.call(a(this),e);for(var n=a(this).byteLength,r=s(e,n),i=s(void 0===t?n:t,n),o=new(p(this,d))(u(i-r)),c=new f(this),l=new f(o),h=0;r<i;)l.setUint8(h++,c.getUint8(r++));return o}}),n(69)("ArrayBuffer")},function(e,t,n){var r=n(0);r(r.G+r.W+r.F*!n(122).ABV,{DataView:n(165).DataView})},function(e,t,n){n(53)("Float32",4,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Float64",8,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Int16",2,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Int32",4,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Int8",1,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Uint16",2,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Uint32",4,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Uint8",1,function(e){return function(t,n,r){return e(this,t,n,r)}})},function(e,t,n){n(53)("Uint8",1,function(e){return function(t,n,r){return e(this,t,n,r)}},!0)},function(e,t,n){"use strict";var r=n(230);n(113)("WeakSet",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{add:function(e){return r.def(this,e,!0)}},r,!1,!0)},function(e,t,n){"use strict";var r=n(0),i=n(112)(!0);r(r.P,"Array",{includes:function(e){return i(this,e,arguments.length>1?arguments[1]:void 0)}}),n(81)("includes")},function(e,t,n){var r=n(0),i=n(156)(),o=n(4).process,a="process"==n(36)(o);r(r.G,{asap:function(e){var t=a&&o.domain;i(t?t.bind(e):e)}})},function(e,t,n){var r=n(0),i=n(36);r(r.S,"Error",{isError:function(e){return"Error"===i(e)}})},function(e,t,n){var r=n(0);r(r.P+r.R,"Map",{toJSON:n(229)("Map")})},function(e,t,n){var r=n(0);r(r.S,"Math",{iaddh:function(e,t,n,r){var i=e>>>0,o=t>>>0,a=n>>>0;return o+(r>>>0)+((i&a|(i|a)&~(i+a>>>0))>>>31)|0}})},function(e,t,n){var r=n(0);r(r.S,"Math",{imulh:function(e,t){var n=+e,r=+t,i=65535&n,o=65535&r,a=n>>16,s=r>>16,u=(a*o>>>0)+(i*o>>>16);return a*s+(u>>16)+((i*s>>>0)+(65535&u)>>16)}})},function(e,t,n){var r=n(0);r(r.S,"Math",{isubh:function(e,t,n,r){var i=e>>>0,o=t>>>0,a=n>>>0;return o-(r>>>0)-((~i&a|~(i^a)&i-a>>>0)>>>31)|0}})},function(e,t,n){var r=n(0);r(r.S,"Math",{umulh:function(e,t){var n=+e,r=+t,i=65535&n,o=65535&r,a=n>>>16,s=r>>>16,u=(a*o>>>0)+(i*o>>>16);return a*s+(u>>>16)+((i*s>>>0)+(65535&u)>>>16)}})},function(e,t,n){"use strict";var r=n(0),i=n(18),o=n(25),a=n(15);n(14)&&r(r.P+n(119),"Object",{__defineGetter__:function(e,t){a.f(i(this),e,{get:o(t),enumerable:!0,configurable:!0})}})},function(e,t,n){"use strict";var r=n(0),i=n(18),o=n(25),a=n(15);n(14)&&r(r.P+n(119),"Object",{__defineSetter__:function(e,t){a.f(i(this),e,{set:o(t),enumerable:!0,configurable:!0})}})},function(e,t,n){var r=n(0),i=n(240)(!0);r(r.S,"Object",{entries:function(e){return i(e)}})},function(e,t,n){var r=n(0),i=n(241),o=n(29),a=n(30),s=n(144);r(r.S,"Object",{getOwnPropertyDescriptors:function(e){for(var t,n=o(e),r=a.f,u=i(n),c={},l=0;u.length>l;)s(c,t=u[l++],r(n,t));return c}})},function(e,t,n){"use strict";var r=n(0),i=n(18),o=n(45),a=n(31),s=n(30).f;n(14)&&r(r.P+n(119),"Object",{__lookupGetter__:function(e){var t,n=i(this),r=o(e,!0);do{if(t=s(n,r))return t.get}while(n=a(n))}})},function(e,t,n){"use strict";var r=n(0),i=n(18),o=n(45),a=n(31),s=n(30).f;n(14)&&r(r.P+n(119),"Object",{__lookupSetter__:function(e){var t,n=i(this),r=o(e,!0);do{if(t=s(n,r))return t.set}while(n=a(n))}})},function(e,t,n){var r=n(0),i=n(240)(!1);r(r.S,"Object",{values:function(e){return i(e)}})},function(e,t,n){"use strict";var r=n(0),i=n(4),o=n(50),a=n(156)(),s=n(12)("observable"),u=n(25),c=n(3),l=n(63),p=n(68),d=n(26),f=n(82),h=f.RETURN,m=function(e){return null==e?void 0:u(e)},g=function(e){var t=e._c;t&&(e._c=void 0,t())},v=function(e){return void 0===e._o},b=function(e){v(e)||(e._o=void 0,g(e))},y=function(e,t){c(e),this._c=void 0,this._o=e,e=new _(this);try{var n=t(e),r=n;null!=n&&("function"==typeof n.unsubscribe?n=function(){r.unsubscribe()}:u(n),this._c=n)}catch(t){return void e.error(t)}v(this)&&g(this)};y.prototype=p({},{unsubscribe:function(){b(this)}});var _=function(e){this._s=e};_.prototype=p({},{next:function(e){var t=this._s;if(!v(t)){var n=t._o;try{var r=m(n.next);if(r)return r.call(n,e)}catch(e){try{b(t)}finally{throw e}}}},error:function(e){var t=this._s;if(v(t))throw e;var n=t._o;t._o=void 0;try{var r=m(n.error);if(!r)throw e;e=r.call(n,e)}catch(e){try{g(t)}finally{throw e}}return g(t),e},complete:function(e){var t=this._s;if(!v(t)){var n=t._o;t._o=void 0;try{var r=m(n.complete);e=r?r.call(n,e):void 0}catch(e){try{g(t)}finally{throw e}}return g(t),e}}});var w=function(e){l(this,w,"Observable","_f")._f=u(e)};p(w.prototype,{subscribe:function(e){return new y(e,this._f)},forEach:function(e){var t=this;return new(o.Promise||i.Promise)(function(n,r){u(e);var i=t.subscribe({next:function(t){try{return e(t)}catch(e){r(e),i.unsubscribe()}},error:r,complete:n})})}}),p(w,{from:function(e){var t="function"==typeof this?this:w,n=m(c(e)[s]);if(n){var r=c(n.call(e));return r.constructor===t?r:new t(function(e){return r.subscribe(e)})}return new t(function(t){var n=!1;return a(function(){if(!n){try{if(f(e,!1,function(e){if(t.next(e),n)return h})===h)return}catch(e){if(n)throw e;return void t.error(e)}t.complete()}}),function(){n=!0}})},of:function(){for(var e=0,t=arguments.length,n=Array(t);e<t;)n[e]=arguments[e++];return new("function"==typeof this?this:w)(function(e){var t=!1;return a(function(){if(!t){for(var r=0;r<n.length;++r)if(e.next(n[r]),t)return;e.complete()}}),function(){t=!0}})}}),d(w.prototype,s,function(){return this}),r(r.G,{Observable:w}),n(69)("Observable")},function(e,t,n){var r=n(52),i=n(3),o=r.key,a=r.set;r.exp({defineMetadata:function(e,t,n,r){a(e,t,i(n),o(r))}})},function(e,t,n){var r=n(52),i=n(3),o=r.key,a=r.map,s=r.store;r.exp({deleteMetadata:function(e,t){var n=arguments.length<3?void 0:o(arguments[2]),r=a(i(t),n,!1);if(void 0===r||!r.delete(e))return!1;if(r.size)return!0;var u=s.get(t);return u.delete(n),!!u.size||s.delete(t)}})},function(e,t,n){var r=n(249),i=n(225),o=n(52),a=n(3),s=n(31),u=o.keys,c=o.key,l=function(e,t){var n=u(e,t),o=s(e);if(null===o)return n;var a=l(o,t);return a.length?n.length?i(new r(n.concat(a))):a:n};o.exp({getMetadataKeys:function(e){return l(a(e),arguments.length<2?void 0:c(arguments[1]))}})},function(e,t,n){var r=n(52),i=n(3),o=n(31),a=r.has,s=r.get,u=r.key,c=function(e,t,n){if(a(e,t,n))return s(e,t,n);var r=o(t);return null!==r?c(e,r,n):void 0};r.exp({getMetadata:function(e,t){return c(e,i(t),arguments.length<3?void 0:u(arguments[2]))}})},function(e,t,n){var r=n(52),i=n(3),o=r.keys,a=r.key;r.exp({getOwnMetadataKeys:function(e){return o(i(e),arguments.length<2?void 0:a(arguments[1]))}})},function(e,t,n){var r=n(52),i=n(3),o=r.get,a=r.key;r.exp({getOwnMetadata:function(e,t){return o(e,i(t),arguments.length<3?void 0:a(arguments[2]))}})},function(e,t,n){var r=n(52),i=n(3),o=n(31),a=r.has,s=r.key,u=function(e,t,n){if(a(e,t,n))return!0;var r=o(t);return null!==r&&u(e,r,n)};r.exp({hasMetadata:function(e,t){return u(e,i(t),arguments.length<3?void 0:s(arguments[2]))}})},function(e,t,n){var r=n(52),i=n(3),o=r.has,a=r.key;r.exp({hasOwnMetadata:function(e,t){return o(e,i(t),arguments.length<3?void 0:a(arguments[2]))}})},function(e,t,n){var r=n(52),i=n(3),o=n(25),a=r.key,s=r.set;r.exp({metadata:function(e,t){return function(n,r){s(e,t,(void 0!==r?i:o)(n),a(r))}}})},function(e,t,n){var r=n(0);r(r.P+r.R,"Set",{toJSON:n(229)("Set")})},function(e,t,n){"use strict";var r=n(0),i=n(160)(!0);r(r.P,"String",{at:function(e){return i(this,e)}})},function(e,t,n){"use strict";var r=n(0),i=n(37),o=n(17),a=n(117),s=n(115),u=RegExp.prototype,c=function(e,t){this._r=e,this._s=t};n(152)(c,"RegExp String",function(){var e=this._r.exec(this._s);return{value:e,done:null===e}}),r(r.P,"String",{matchAll:function(e){if(i(this),!a(e))throw TypeError(e+" is not a regexp!");var t=String(this),n="flags"in u?String(e.flags):s.call(e),r=new RegExp(e.source,~n.indexOf("g")?n:"g"+n);return r.lastIndex=o(e.lastIndex),new c(r,t)}})},function(e,t,n){"use strict";var r=n(0),i=n(245);r(r.P,"String",{padEnd:function(e){return i(this,e,arguments.length>1?arguments[1]:void 0,!1)}})},function(e,t,n){"use strict";var r=n(0),i=n(245);r(r.P,"String",{padStart:function(e){return i(this,e,arguments.length>1?arguments[1]:void 0,!0)}})},function(e,t,n){"use strict";n(85)("trimLeft",function(e){return function(){return e(this,1)}},"trimStart")},function(e,t,n){"use strict";n(85)("trimRight",function(e){return function(){return e(this,2)}},"trimEnd")},function(e,t,n){n(166)("asyncIterator")},function(e,t,n){n(166)("observable")},function(e,t,n){var r=n(0);r(r.S,"System",{global:n(4)})},function(e,t,n){for(var r=n(168),i=n(27),o=n(4),a=n(26),s=n(83),u=n(12),c=u("iterator"),l=u("toStringTag"),p=s.Array,d=["NodeList","DOMTokenList","MediaList","StyleSheetList","CSSRuleList"],f=0;f<5;f++){var h,m=d[f],g=o[m],v=g&&g.prototype;if(v){v[c]||a(v,c,p),v[l]||a(v,l,m),s[m]=p;for(h in r)v[h]||i(v,h,r[h],!0)}}},function(e,t,n){var r=n(0),i=n(164);r(r.G+r.B,{setImmediate:i.set,clearImmediate:i.clear})},function(e,t,n){var r=n(4),i=n(0),o=n(116),a=n(412),s=r.navigator,u=!!s&&/MSIE .\./.test(s.userAgent),c=function(e){return u?function(t,n){return e(o(a,[].slice.call(arguments,2),"function"==typeof t?t:Function(t)),n)}:e};i(i.G+i.B+i.F*u,{setTimeout:c(r.setTimeout),setInterval:c(r.setInterval)})},function(e,t,n){n(535),n(474),n(476),n(475),n(478),n(480),n(485),n(479),n(477),n(487),n(486),n(482),n(483),n(481),n(473),n(484),n(488),n(489),n(441),n(443),n(442),n(491),n(490),n(461),n(471),n(472),n(462),n(463),n(464),n(465),n(466),n(467),n(468),n(469),n(470),n(444),n(445),n(446),n(447),n(448),n(449),n(450),n(451),n(452),n(453),n(454),n(455),n(456),n(457),n(458),n(459),n(460),n(522),n(527),n(534),n(525),n(517),n(518),n(523),n(528),n(530),n(513),n(514),n(515),n(516),n(519),n(520),n(521),n(524),n(526),n(529),n(531),n(532),n(533),n(436),n(438),n(437),n(440),n(439),n(425),n(423),n(429),n(426),n(432),n(434),n(422),n(428),n(419),n(433),n(417),n(431),n(430),n(424),n(427),n(416),n(418),n(421),n(420),n(435),n(168),n(507),n(512),n(248),n(508),n(509),n(510),n(511),n(492),n(247),n(249),n(250),n(547),n(536),n(537),n(542),n(545),n(546),n(540),n(543),n(541),n(544),n(538),n(539),n(493),n(494),n(495),n(496),n(497),n(500),n(498),n(499),n(501),n(502),n(503),n(504),n(506),n(505),n(548),n(574),n(577),n(576),n(578),n(579),n(575),n(580),n(581),n(559),n(562),n(558),n(556),n(557),n(560),n(561),n(551),n(573),n(582),n(550),n(552),n(554),n(553),n(555),n(564),n(565),n(567),n(566),n(569),n(568),n(570),n(571),n(572),n(549),n(563),n(585),n(584),n(583),e.exports=n(50)},function(e,t,n){"use strict";var r=n(255),i=n(254),o=n(257),a=n(256),s=n(170);e.exports={ToPrimitive:n(590),ToBoolean:function(e){return Boolean(e)},ToNumber:function(e){return Number(e)},ToInteger:function(e){var t=this.ToNumber(e);return r(t)?0:0!==t&&i(t)?o(t)*Math.floor(Math.abs(t)):t},ToInt32:function(e){return this.ToNumber(e)>>0},ToUint32:function(e){return this.ToNumber(e)>>>0},ToUint16:function(e){var t=this.ToNumber(e);if(r(t)||0===t||!i(t))return 0;var n=o(t)*Math.floor(Math.abs(t));return a(n,65536)},ToString:function(e){return String(e)},ToObject:function(e){return this.CheckObjectCoercible(e),Object(e)},CheckObjectCoercible:function(e,t){if(null==e)throw new TypeError(t||"Cannot call method on "+e);return e},IsCallable:s,SameValue:function(e,t){return e===t?0!==e||1/e==1/t:r(e)&&r(t)},Type:function(e){return null===e?"Null":void 0===e?"Undefined":"function"==typeof e||"object"==typeof e?"Object":"number"==typeof e?"Number":"boolean"==typeof e?"Boolean":"string"==typeof e?"String":void 0}}},function(e,t,n){"use strict";var r=Object.prototype.toString,i="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator,o=i?Symbol.prototype.toString:r,a=n(255),s=n(254),u=Number.MAX_SAFE_INTEGER||Math.pow(2,53)-1,c=n(253),l=n(257),p=n(256),d=n(589),f=n(591),h=parseInt,m=n(123),g=m.call(Function.call,String.prototype.slice),v=m.call(Function.call,RegExp.prototype.test,/^0b[01]+$/i),b=m.call(Function.call,RegExp.prototype.test,/^0o[0-7]+$/i),y=["","​","￾"].join(""),_=new RegExp("["+y+"]","g"),w=m.call(Function.call,RegExp.prototype.test,_),E=m.call(Function.call,RegExp.prototype.test,/^[-+]0x[0-9a-f]+$/i),x=["\t\n\v\f\r   ᠎    ","         　\u2028","\u2029\ufeff"].join(""),S=new RegExp("(^["+x+"]+)|(["+x+"]+$)","g"),T=m.call(Function.call,String.prototype.replace),C=function(e){return T(e,S,"")},I=n(587),M=n(615),P=c(c({},I),{Call:function(e,t){var n=arguments.length>2?arguments[2]:[];if(!this.IsCallable(e))throw new TypeError(e+" is not a function");return e.apply(t,n)},ToPrimitive:f,ToNumber:function(e){var t=d(e)?e:f(e,"number");if("symbol"==typeof t)throw new TypeError("Cannot convert a Symbol value to a number");if("string"==typeof t){if(v(t))return this.ToNumber(h(g(t,2),2));if(b(t))return this.ToNumber(h(g(t,2),8));if(w(t)||E(t))return NaN;var n=C(t);if(n!==t)return this.ToNumber(n)}return Number(t)},ToInt16:function(e){var t=this.ToUint16(e);return t>=32768?t-65536:t},ToInt8:function(e){var t=this.ToUint8(e);return t>=128?t-256:t},ToUint8:function(e){var t=this.ToNumber(e);if(a(t)||0===t||!s(t))return 0;var n=l(t)*Math.floor(Math.abs(t));return p(n,256)},ToUint8Clamp:function(e){var t=this.ToNumber(e);if(a(t)||t<=0)return 0;if(t>=255)return 255;var n=Math.floor(e);return n+.5<t?n+1:t<n+.5?n:n%2!=0?n+1:n},ToString:function(e){if("symbol"==typeof e)throw new TypeError("Cannot convert a Symbol value to a string");return String(e)},ToObject:function(e){return this.RequireObjectCoercible(e),Object(e)},ToPropertyKey:function(e){var t=this.ToPrimitive(e,String);return"symbol"==typeof t?o.call(t):this.ToString(t)},ToLength:function(e){var t=this.ToInteger(e);return t<=0?0:t>u?u:t},CanonicalNumericIndexString:function(e){if("[object String]"!==r.call(e))throw new TypeError("must be a string");if("-0"===e)return-0;var t=this.ToNumber(e);return this.SameValue(this.ToString(t),e)?t:void 0},RequireObjectCoercible:I.CheckObjectCoercible,IsArray:Array.isArray||function(e){return"[object Array]"===r.call(e)},IsConstructor:function(e){return"function"==typeof e&&!!e.prototype},IsExtensible:function(e){return!Object.preventExtensions||!d(e)&&Object.isExtensible(e)},IsInteger:function(e){if("number"!=typeof e||a(e)||!s(e))return!1;var t=Math.abs(e);return Math.floor(t)===t},IsPropertyKey:function(e){return"string"==typeof e||"symbol"==typeof e},IsRegExp:function(e){if(!e||"object"!=typeof e)return!1;if(i){var t=e[Symbol.match];if(void 0!==t)return I.ToBoolean(t)}return M(e)},SameValueZero:function(e,t){return e===t||a(e)&&a(t)},GetV:function(e,t){if(!this.IsPropertyKey(t))throw new TypeError("Assertion failed: IsPropertyKey(P) is not true");return this.ToObject(e)[t]},GetMethod:function(e,t){if(!this.IsPropertyKey(t))throw new TypeError("Assertion failed: IsPropertyKey(P) is not true");var n=this.GetV(e,t);if(null!=n){if(!this.IsCallable(n))throw new TypeError(t+"is not a function");return n}},Get:function(e,t){if("Object"!==this.Type(e))throw new TypeError("Assertion failed: Type(O) is not Object");if(!this.IsPropertyKey(t))throw new TypeError("Assertion failed: IsPropertyKey(P) is not true");return e[t]},Type:function(e){return"symbol"==typeof e?"Symbol":I.Type(e)},SpeciesConstructor:function(e,t){if("Object"!==this.Type(e))throw new TypeError("Assertion failed: Type(O) is not Object");var n=e.constructor;if(void 0===n)return t;if("Object"!==this.Type(n))throw new TypeError("O.constructor is not an Object");var r=i&&Symbol.species?n[Symbol.species]:void 0;if(null==r)return t;if(this.IsConstructor(r))return r;throw new TypeError("no constructor found")}});delete P.CheckObjectCoercible,e.exports=P},function(e,t){e.exports=function(e){return null===e||"function"!=typeof e&&"object"!=typeof e}},function(e,t,n){"use strict";var r=Object.prototype.toString,i=n(258),o=n(170),a={"[[DefaultValue]]":function(e,t){var n=t||("[object Date]"===r.call(e)?String:Number);if(n===String||n===Number){var a,s,u=n===String?["toString","valueOf"]:["valueOf","toString"];for(s=0;s<u.length;++s)if(o(e[u[s]])&&(a=e[u[s]](),i(a)))return a;throw new TypeError("No default value")}throw new TypeError("invalid [[DefaultValue]] hint supplied")}};e.exports=function(e,t){return i(e)?e:a["[[DefaultValue]]"](e,t)}},function(e,t,n){"use strict";var r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator,i=n(258),o=n(170),a=n(614),s=n(616),u=function(e,t){if(void 0===e||null===e)throw new TypeError("Cannot call method on "+e);if("string"!=typeof t||"number"!==t&&"string"!==t)throw new TypeError('hint must be "string" or "number"');var n,r,a,s="string"===t?["toString","valueOf"]:["valueOf","toString"];for(a=0;a<s.length;++a)if(n=e[s[a]],o(n)&&(r=n.call(e),i(r)))return r;throw new TypeError("No default value")},c=function(e,t){var n=e[t];if(null!==n&&void 0!==n){if(!o(n))throw new TypeError(n+" returned for property "+t+" of object "+e+" is not a function");return n}};e.exports=function(e,t){if(i(e))return e;var n="default";arguments.length>1&&(t===String?n="string":t===Number&&(n="number"));var o;if(r&&(Symbol.toPrimitive?o=c(e,Symbol.toPrimitive):s(e)&&(o=Symbol.prototype.valueOf)),void 0!==o){var l=o.call(e,n);if(i(l))return l;throw new TypeError("unable to convert exotic object to primitive")}return"default"===n&&(a(e)||s(e))&&(n="string"),u(e,"default"===n?"number":n)}},function(e,t,n){"use strict";function r(e){return e.replace(i,function(e,t){return t.toUpperCase()})}var i=/-(.)/g;e.exports=r},function(e,t,n){"use strict";function r(e){return i(e.replace(o,"ms-"))}var i=n(592),o=/^-ms-/;e.exports=r},function(e,t,n){"use strict";function r(e,t){return!(!e||!t)&&(e===t||!i(e)&&(i(t)?r(e,t.parentNode):"contains"in e?e.contains(t):!!e.compareDocumentPosition&&!!(16&e.compareDocumentPosition(t))))}var i=n(602);e.exports=r},function(e,t,n){"use strict";function r(e){var t=e.length;if((Array.isArray(e)||"object"!=typeof e&&"function"!=typeof e)&&a(!1),"number"!=typeof t&&a(!1),0===t||t-1 in e||a(!1),"function"==typeof e.callee&&a(!1),e.hasOwnProperty)try{return Array.prototype.slice.call(e)}catch(e){}for(var n=Array(t),r=0;r<t;r++)n[r]=e[r];return n}function i(e){return!!e&&("object"==typeof e||"function"==typeof e)&&"length"in e&&!("setInterval"in e)&&"number"!=typeof e.nodeType&&(Array.isArray(e)||"callee"in e||"item"in e)}function o(e){return i(e)?Array.isArray(e)?e.slice():r(e):[e]}var a=n(1);e.exports=o},function(e,t,n){"use strict";function r(e){var t=e.match(l);return t&&t[1].toLowerCase()}function i(e,t){var n=c;c||u(!1);var i=r(e),o=i&&s(i);if(o){n.innerHTML=o[1]+e+o[2];for(var l=o[0];l--;)n=n.lastChild}else n.innerHTML=e;var p=n.getElementsByTagName("script");p.length&&(t||u(!1),a(p).forEach(t));for(var d=Array.from(n.childNodes);n.lastChild;)n.removeChild(n.lastChild);return d}var o=n(24),a=n(595),s=n(597),u=n(1),c=o.canUseDOM?document.createElement("div"):null,l=/^\s*<(\w+)/;e.exports=i},function(e,t,n){"use strict";function r(e){return a||o(!1),d.hasOwnProperty(e)||(e="*"),s.hasOwnProperty(e)||(a.innerHTML="*"===e?"<link />":"<"+e+"></"+e+">",s[e]=!a.firstChild),s[e]?d[e]:null}var i=n(24),o=n(1),a=i.canUseDOM?document.createElement("div"):null,s={},u=[1,'<select multiple="true">',"</select>"],c=[1,"<table>","</table>"],l=[3,"<table><tbody><tr>","</tr></tbody></table>"],p=[1,'<svg xmlns="http://www.w3.org/2000/svg">',"</svg>"],d={"*":[1,"?<div>","</div>"],area:[1,"<map>","</map>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],legend:[1,"<fieldset>","</fieldset>"],param:[1,"<object>","</object>"],tr:[2,"<table><tbody>","</tbody></table>"],optgroup:u,option:u,caption:c,colgroup:c,tbody:c,tfoot:c,thead:c,td:l,th:l};["circle","clipPath","defs","ellipse","g","image","line","linearGradient","mask","path","pattern","polygon","polyline","radialGradient","rect","stop","text","tspan"].forEach(function(e){d[e]=p,s[e]=!0}),e.exports=r},function(e,t,n){"use strict";function r(e){return e.Window&&e instanceof e.Window?{x:e.pageXOffset||e.document.documentElement.scrollLeft,y:e.pageYOffset||e.document.documentElement.scrollTop}:{x:e.scrollLeft,y:e.scrollTop}}e.exports=r},function(e,t,n){"use strict";function r(e){return e.replace(i,"-$1").toLowerCase()}var i=/([A-Z])/g;e.exports=r},function(e,t,n){"use strict";function r(e){return i(e).replace(o,"-ms-")}var i=n(599),o=/^ms-/;e.exports=r},function(e,t,n){"use strict";function r(e){var t=e?e.ownerDocument||e:document,n=t.defaultView||window;return!(!e||!("function"==typeof n.Node?e instanceof n.Node:"object"==typeof e&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName))}e.exports=r},function(e,t,n){"use strict";function r(e){return i(e)&&3==e.nodeType}var i=n(601);e.exports=r},function(e,t,n){"use strict";function r(e){var t={};return function(n){return t.hasOwnProperty(n)||(t[n]=e.call(this,n)),t[n]}}e.exports=r},function(e,t){var n=Object.prototype.hasOwnProperty,r=Object.prototype.toString;e.exports=function(e,t,i){if("[object Function]"!==r.call(t))throw new TypeError("iterator must be a function");var o=e.length;if(o===+o)for(var a=0;a<o;a++)t.call(i,e[a],a,e);else for(var s in e)n.call(e,s)&&t.call(i,e[s],s,e)}},function(e,t){var n=Array.prototype.slice,r=Object.prototype.toString;e.exports=function(e){var t=this;if("function"!=typeof t||"[object Function]"!==r.call(t))throw new TypeError("Function.prototype.bind called on incompatible "+t);for(var i,o=n.call(arguments,1),a=function(){if(this instanceof i){var r=t.apply(this,o.concat(n.call(arguments)));return Object(r)===r?r:this}return t.apply(e,o.concat(n.call(arguments)))},s=Math.max(0,t.length-o.length),u=[],c=0;c<s;c++)u.push("$"+c);if(i=Function("binder","return function ("+u.join(",")+"){ return binder.apply(this,arguments); }")(a),t.prototype){var l=function(){};l.prototype=t.prototype,i.prototype=new l,l.prototype=null}return i}},function(e,t,n){var r=n(54),i={};i.create=function(){var e=new r.ARRAY_TYPE(4);return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e},i.clone=function(e){var t=new r.ARRAY_TYPE(4);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},i.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},i.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e},i.fromValues=function(e,t,n,i){var o=new r.ARRAY_TYPE(4);return o[0]=e,o[1]=t,o[2]=n,o[3]=i,o},i.set=function(e,t,n,r,i){return e[0]=t,e[1]=n,e[2]=r,e[3]=i,e},i.transpose=function(e,t){if(e===t){var n=t[1];e[1]=t[2],e[2]=n}else e[0]=t[0],e[1]=t[2],e[2]=t[1],e[3]=t[3];return e},i.invert=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=n*o-i*r;return a?(a=1/a,e[0]=o*a,e[1]=-r*a,e[2]=-i*a,e[3]=n*a,e):null},i.adjoint=function(e,t){var n=t[0];return e[0]=t[3],e[1]=-t[1],e[2]=-t[2],e[3]=n,e},i.determinant=function(e){return e[0]*e[3]-e[2]*e[1]},i.multiply=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=n[0],u=n[1],c=n[2],l=n[3];return e[0]=r*s+o*u,e[1]=i*s+a*u,e[2]=r*c+o*l,e[3]=i*c+a*l,e},i.mul=i.multiply,i.rotate=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u+o*s,e[1]=i*u+a*s,e[2]=r*-s+o*u,e[3]=i*-s+a*u,e},i.scale=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=n[0],u=n[1];return e[0]=r*s,e[1]=i*s,e[2]=o*u,e[3]=a*u,e},i.fromRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=-n,e[3]=r,e},i.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=t[1],e},i.str=function(e){return"mat2("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},i.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2))},i.LDU=function(e,t,n,r){return e[2]=r[2]/r[0],n[0]=r[0],n[1]=r[1],n[3]=r[3]-e[2]*n[1],[e,t,n]},i.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e},i.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e},i.sub=i.subtract,i.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]},i.equals=function(e,t){var n=e[0],i=e[1],o=e[2],a=e[3],s=t[0],u=t[1],c=t[2],l=t[3];return Math.abs(n-s)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(s))&&Math.abs(i-u)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(u))&&Math.abs(o-c)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))&&Math.abs(a-l)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(l))},i.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e},i.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e},e.exports=i},function(e,t,n){var r=n(54),i={};i.create=function(){var e=new r.ARRAY_TYPE(6);return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e},i.clone=function(e){var t=new r.ARRAY_TYPE(6);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t},i.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e},i.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=0,e[5]=0,e},i.fromValues=function(e,t,n,i,o,a){var s=new r.ARRAY_TYPE(6);return s[0]=e,s[1]=t,s[2]=n,s[3]=i,s[4]=o,s[5]=a,s},i.set=function(e,t,n,r,i,o,a){return e[0]=t,e[1]=n,e[2]=r,e[3]=i,e[4]=o,e[5]=a,e},i.invert=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=t[4],s=t[5],u=n*o-r*i;return u?(u=1/u,e[0]=o*u,e[1]=-r*u,e[2]=-i*u,e[3]=n*u,e[4]=(i*s-o*a)*u,e[5]=(r*a-n*s)*u,e):null},i.determinant=function(e){return e[0]*e[3]-e[1]*e[2]},i.multiply=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=n[0],l=n[1],p=n[2],d=n[3],f=n[4],h=n[5];return e[0]=r*c+o*l,e[1]=i*c+a*l,e[2]=r*p+o*d,e[3]=i*p+a*d,e[4]=r*f+o*h+s,e[5]=i*f+a*h+u,e},i.mul=i.multiply,i.rotate=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=Math.sin(n),l=Math.cos(n);return e[0]=r*l+o*c,e[1]=i*l+a*c,e[2]=r*-c+o*l,e[3]=i*-c+a*l,e[4]=s,e[5]=u,e},i.scale=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=n[0],l=n[1];return e[0]=r*c,e[1]=i*c,e[2]=o*l,e[3]=a*l,e[4]=s,e[5]=u,e},i.translate=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=n[0],l=n[1];return e[0]=r,e[1]=i,e[2]=o,e[3]=a,e[4]=r*c+o*l+s,e[5]=i*c+a*l+u,e},i.fromRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=-n,e[3]=r,e[4]=0,e[5]=0,e},i.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=t[1],e[4]=0,e[5]=0,e},i.fromTranslation=function(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=1,e[4]=t[0],e[5]=t[1],e},i.str=function(e){return"mat2d("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+")"},i.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+1)},i.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e},i.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e},i.sub=i.subtract,i.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e},i.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e[4]=t[4]+n[4]*r,e[5]=t[5]+n[5]*r,e},i.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]},i.equals=function(e,t){var n=e[0],i=e[1],o=e[2],a=e[3],s=e[4],u=e[5],c=t[0],l=t[1],p=t[2],d=t[3],f=t[4],h=t[5];return Math.abs(n-c)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(c))&&Math.abs(i-l)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(o-p)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(p))&&Math.abs(a-d)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(d))&&Math.abs(s-f)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(f))&&Math.abs(u-h)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(h))},e.exports=i},function(e,t,n){var r=n(54),i={scalar:{},SIMD:{}};i.create=function(){var e=new r.ARRAY_TYPE(16);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},i.clone=function(e){var t=new r.ARRAY_TYPE(16);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},i.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},i.fromValues=function(e,t,n,i,o,a,s,u,c,l,p,d,f,h,m,g){var v=new r.ARRAY_TYPE(16);return v[0]=e,v[1]=t,v[2]=n,v[3]=i,v[4]=o,v[5]=a,v[6]=s,v[7]=u,v[8]=c,v[9]=l,v[10]=p,v[11]=d,v[12]=f,v[13]=h,v[14]=m,v[15]=g,v},i.set=function(e,t,n,r,i,o,a,s,u,c,l,p,d,f,h,m,g){return e[0]=t,e[1]=n,e[2]=r,e[3]=i,e[4]=o,e[5]=a,e[6]=s,e[7]=u,e[8]=c,e[9]=l,e[10]=p,e[11]=d,e[12]=f,e[13]=h,e[14]=m,e[15]=g,e},i.identity=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},i.scalar.transpose=function(e,t){if(e===t){var n=t[1],r=t[2],i=t[3],o=t[6],a=t[7],s=t[11];e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=n,e[6]=t[9],e[7]=t[13],e[8]=r,e[9]=o,e[11]=t[14],e[12]=i,e[13]=a,e[14]=s}else e[0]=t[0],e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=t[1],e[5]=t[5],e[6]=t[9],e[7]=t[13],e[8]=t[2],e[9]=t[6],e[10]=t[10],e[11]=t[14],e[12]=t[3],e[13]=t[7],e[14]=t[11],e[15]=t[15];return e},i.SIMD.transpose=function(e,t){var n,r,i,o,a,s,u,c,l,p;return n=SIMD.Float32x4.load(t,0),r=SIMD.Float32x4.load(t,4),i=SIMD.Float32x4.load(t,8),o=SIMD.Float32x4.load(t,12),a=SIMD.Float32x4.shuffle(n,r,0,1,4,5),s=SIMD.Float32x4.shuffle(i,o,0,1,4,5),u=SIMD.Float32x4.shuffle(a,s,0,2,4,6),c=SIMD.Float32x4.shuffle(a,s,1,3,5,7),SIMD.Float32x4.store(e,0,u),SIMD.Float32x4.store(e,4,c),a=SIMD.Float32x4.shuffle(n,r,2,3,6,7),s=SIMD.Float32x4.shuffle(i,o,2,3,6,7),l=SIMD.Float32x4.shuffle(a,s,0,2,4,6),p=SIMD.Float32x4.shuffle(a,s,1,3,5,7),SIMD.Float32x4.store(e,8,l),SIMD.Float32x4.store(e,12,p),e},i.transpose=r.USE_SIMD?i.SIMD.transpose:i.scalar.transpose,i.scalar.invert=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=t[4],s=t[5],u=t[6],c=t[7],l=t[8],p=t[9],d=t[10],f=t[11],h=t[12],m=t[13],g=t[14],v=t[15],b=n*s-r*a,y=n*u-i*a,_=n*c-o*a,w=r*u-i*s,E=r*c-o*s,x=i*c-o*u,S=l*m-p*h,T=l*g-d*h,C=l*v-f*h,I=p*g-d*m,M=p*v-f*m,P=d*v-f*g,R=b*P-y*M+_*I+w*C-E*T+x*S;return R?(R=1/R,e[0]=(s*P-u*M+c*I)*R,e[1]=(i*M-r*P-o*I)*R,e[2]=(m*x-g*E+v*w)*R,e[3]=(d*E-p*x-f*w)*R,e[4]=(u*C-a*P-c*T)*R,e[5]=(n*P-i*C+o*T)*R,e[6]=(g*_-h*x-v*y)*R,e[7]=(l*x-d*_+f*y)*R,e[8]=(a*M-s*C+c*S)*R,e[9]=(r*C-n*M-o*S)*R,e[10]=(h*E-m*_+v*b)*R,e[11]=(p*_-l*E-f*b)*R,e[12]=(s*T-a*I-u*S)*R,e[13]=(n*I-r*T+i*S)*R,e[14]=(m*y-h*w-g*b)*R,e[15]=(l*w-p*y+d*b)*R,e):null},i.SIMD.invert=function(e,t){var n,r,i,o,a,s,u,c,l,p,d=SIMD.Float32x4.load(t,0),f=SIMD.Float32x4.load(t,4),h=SIMD.Float32x4.load(t,8),m=SIMD.Float32x4.load(t,12);return a=SIMD.Float32x4.shuffle(d,f,0,1,4,5),r=SIMD.Float32x4.shuffle(h,m,0,1,4,5),n=SIMD.Float32x4.shuffle(a,r,0,2,4,6),r=SIMD.Float32x4.shuffle(r,a,1,3,5,7),a=SIMD.Float32x4.shuffle(d,f,2,3,6,7),o=SIMD.Float32x4.shuffle(h,m,2,3,6,7),i=SIMD.Float32x4.shuffle(a,o,0,2,4,6),o=SIMD.Float32x4.shuffle(o,a,1,3,5,7),a=SIMD.Float32x4.mul(i,o),a=SIMD.Float32x4.swizzle(a,1,0,3,2),s=SIMD.Float32x4.mul(r,a),u=SIMD.Float32x4.mul(n,a),a=SIMD.Float32x4.swizzle(a,2,3,0,1),s=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,a),s),u=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,a),u),u=SIMD.Float32x4.swizzle(u,2,3,0,1),a=SIMD.Float32x4.mul(r,i),a=SIMD.Float32x4.swizzle(a,1,0,3,2),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(o,a),s),l=SIMD.Float32x4.mul(n,a),a=SIMD.Float32x4.swizzle(a,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(o,a)),l=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,a),l),l=SIMD.Float32x4.swizzle(l,2,3,0,1),a=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(r,2,3,0,1),o),a=SIMD.Float32x4.swizzle(a,1,0,3,2),i=SIMD.Float32x4.swizzle(i,2,3,0,1),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,a),s),c=SIMD.Float32x4.mul(n,a),a=SIMD.Float32x4.swizzle(a,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(i,a)),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,a),c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),a=SIMD.Float32x4.mul(n,r),a=SIMD.Float32x4.swizzle(a,1,0,3,2),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(o,a),c),l=SIMD.Float32x4.sub(SIMD.Float32x4.mul(i,a),l),a=SIMD.Float32x4.swizzle(a,2,3,0,1),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,a),c),l=SIMD.Float32x4.sub(l,SIMD.Float32x4.mul(i,a)),a=SIMD.Float32x4.mul(n,o),a=SIMD.Float32x4.swizzle(a,1,0,3,2),u=SIMD.Float32x4.sub(u,SIMD.Float32x4.mul(i,a)),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(r,a),c),a=SIMD.Float32x4.swizzle(a,2,3,0,1),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,a),u),c=SIMD.Float32x4.sub(c,SIMD.Float32x4.mul(r,a)),a=SIMD.Float32x4.mul(n,i),a=SIMD.Float32x4.swizzle(a,1,0,3,2),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(o,a),u),l=SIMD.Float32x4.sub(l,SIMD.Float32x4.mul(r,a)),a=SIMD.Float32x4.swizzle(a,2,3,0,1),u=SIMD.Float32x4.sub(u,SIMD.Float32x4.mul(o,a)),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(r,a),l),p=SIMD.Float32x4.mul(n,s),p=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(p,2,3,0,1),p),p=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(p,1,0,3,2),p),a=SIMD.Float32x4.reciprocalApproximation(p),p=SIMD.Float32x4.sub(SIMD.Float32x4.add(a,a),SIMD.Float32x4.mul(p,SIMD.Float32x4.mul(a,a))),(p=SIMD.Float32x4.swizzle(p,0,0,0,0))?(SIMD.Float32x4.store(e,0,SIMD.Float32x4.mul(p,s)),SIMD.Float32x4.store(e,4,SIMD.Float32x4.mul(p,u)),SIMD.Float32x4.store(e,8,SIMD.Float32x4.mul(p,c)),SIMD.Float32x4.store(e,12,SIMD.Float32x4.mul(p,l)),e):null},i.invert=r.USE_SIMD?i.SIMD.invert:i.scalar.invert,i.scalar.adjoint=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=t[4],s=t[5],u=t[6],c=t[7],l=t[8],p=t[9],d=t[10],f=t[11],h=t[12],m=t[13],g=t[14],v=t[15];return e[0]=s*(d*v-f*g)-p*(u*v-c*g)+m*(u*f-c*d),e[1]=-(r*(d*v-f*g)-p*(i*v-o*g)+m*(i*f-o*d)),e[2]=r*(u*v-c*g)-s*(i*v-o*g)+m*(i*c-o*u),e[3]=-(r*(u*f-c*d)-s*(i*f-o*d)+p*(i*c-o*u)),e[4]=-(a*(d*v-f*g)-l*(u*v-c*g)+h*(u*f-c*d)),e[5]=n*(d*v-f*g)-l*(i*v-o*g)+h*(i*f-o*d),e[6]=-(n*(u*v-c*g)-a*(i*v-o*g)+h*(i*c-o*u)),e[7]=n*(u*f-c*d)-a*(i*f-o*d)+l*(i*c-o*u),e[8]=a*(p*v-f*m)-l*(s*v-c*m)+h*(s*f-c*p),e[9]=-(n*(p*v-f*m)-l*(r*v-o*m)+h*(r*f-o*p)),e[10]=n*(s*v-c*m)-a*(r*v-o*m)+h*(r*c-o*s),e[11]=-(n*(s*f-c*p)-a*(r*f-o*p)+l*(r*c-o*s)),e[12]=-(a*(p*g-d*m)-l*(s*g-u*m)+h*(s*d-u*p)),e[13]=n*(p*g-d*m)-l*(r*g-i*m)+h*(r*d-i*p),e[14]=-(n*(s*g-u*m)-a*(r*g-i*m)+h*(r*u-i*s)),e[15]=n*(s*d-u*p)-a*(r*d-i*p)+l*(r*u-i*s),e},i.SIMD.adjoint=function(e,t){var n,r,i,o,a,s,u,c,l,p,d,f,h,n=SIMD.Float32x4.load(t,0),r=SIMD.Float32x4.load(t,4),i=SIMD.Float32x4.load(t,8),o=SIMD.Float32x4.load(t,12);return l=SIMD.Float32x4.shuffle(n,r,0,1,4,5),s=SIMD.Float32x4.shuffle(i,o,0,1,4,5),a=SIMD.Float32x4.shuffle(l,s,0,2,4,6),s=SIMD.Float32x4.shuffle(s,l,1,3,5,7),l=SIMD.Float32x4.shuffle(n,r,2,3,6,7),c=SIMD.Float32x4.shuffle(i,o,2,3,6,7),u=SIMD.Float32x4.shuffle(l,c,0,2,4,6),c=SIMD.Float32x4.shuffle(c,l,1,3,5,7),l=SIMD.Float32x4.mul(u,c),l=SIMD.Float32x4.swizzle(l,1,0,3,2),p=SIMD.Float32x4.mul(s,l),d=SIMD.Float32x4.mul(a,l),l=SIMD.Float32x4.swizzle(l,2,3,0,1),p=SIMD.Float32x4.sub(SIMD.Float32x4.mul(s,l),p),d=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,l),d),d=SIMD.Float32x4.swizzle(d,2,3,0,1),l=SIMD.Float32x4.mul(s,u),l=SIMD.Float32x4.swizzle(l,1,0,3,2),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(c,l),p),h=SIMD.Float32x4.mul(a,l),l=SIMD.Float32x4.swizzle(l,2,3,0,1),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(c,l)),h=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,l),h),h=SIMD.Float32x4.swizzle(h,2,3,0,1),l=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,3,0,1),c),l=SIMD.Float32x4.swizzle(l,1,0,3,2),u=SIMD.Float32x4.swizzle(u,2,3,0,1),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,l),p),f=SIMD.Float32x4.mul(a,l),l=SIMD.Float32x4.swizzle(l,2,3,0,1),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(u,l)),f=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,l),f),f=SIMD.Float32x4.swizzle(f,2,3,0,1),l=SIMD.Float32x4.mul(a,s),l=SIMD.Float32x4.swizzle(l,1,0,3,2),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(c,l),f),h=SIMD.Float32x4.sub(SIMD.Float32x4.mul(u,l),h),l=SIMD.Float32x4.swizzle(l,2,3,0,1),f=SIMD.Float32x4.sub(SIMD.Float32x4.mul(c,l),f),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(u,l)),l=SIMD.Float32x4.mul(a,c),l=SIMD.Float32x4.swizzle(l,1,0,3,2),d=SIMD.Float32x4.sub(d,SIMD.Float32x4.mul(u,l)),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,l),f),l=SIMD.Float32x4.swizzle(l,2,3,0,1),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,l),d),f=SIMD.Float32x4.sub(f,SIMD.Float32x4.mul(s,l)),l=SIMD.Float32x4.mul(a,u),l=SIMD.Float32x4.swizzle(l,1,0,3,2),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(c,l),d),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(s,l)),l=SIMD.Float32x4.swizzle(l,2,3,0,1),d=SIMD.Float32x4.sub(d,SIMD.Float32x4.mul(c,l)),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,l),h),SIMD.Float32x4.store(e,0,p),SIMD.Float32x4.store(e,4,d),SIMD.Float32x4.store(e,8,f),SIMD.Float32x4.store(e,12,h),e},i.adjoint=r.USE_SIMD?i.SIMD.adjoint:i.scalar.adjoint,i.determinant=function(e){var t=e[0],n=e[1],r=e[2],i=e[3],o=e[4],a=e[5],s=e[6],u=e[7],c=e[8],l=e[9],p=e[10],d=e[11],f=e[12],h=e[13],m=e[14],g=e[15];return(t*a-n*o)*(p*g-d*m)-(t*s-r*o)*(l*g-d*h)+(t*u-i*o)*(l*m-p*h)+(n*s-r*a)*(c*g-d*f)-(n*u-i*a)*(c*m-p*f)+(r*u-i*s)*(c*h-l*f)},i.SIMD.multiply=function(e,t,n){var r=SIMD.Float32x4.load(t,0),i=SIMD.Float32x4.load(t,4),o=SIMD.Float32x4.load(t,8),a=SIMD.Float32x4.load(t,12),s=SIMD.Float32x4.load(n,0),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,2,2,2),o),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,3,3,3,3),a))));SIMD.Float32x4.store(e,0,u);var c=SIMD.Float32x4.load(n,4),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(c,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(c,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(c,2,2,2,2),o),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(c,3,3,3,3),a))));SIMD.Float32x4.store(e,4,l);var p=SIMD.Float32x4.load(n,8),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,2,2,2,2),o),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(p,3,3,3,3),a))));SIMD.Float32x4.store(e,8,d);var f=SIMD.Float32x4.load(n,12),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,0,0,0,0),r),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,2,2,2,2),o),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(f,3,3,3,3),a))));return SIMD.Float32x4.store(e,12,h),e},i.scalar.multiply=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=t[6],l=t[7],p=t[8],d=t[9],f=t[10],h=t[11],m=t[12],g=t[13],v=t[14],b=t[15],y=n[0],_=n[1],w=n[2],E=n[3];return e[0]=y*r+_*s+w*p+E*m,e[1]=y*i+_*u+w*d+E*g,e[2]=y*o+_*c+w*f+E*v,e[3]=y*a+_*l+w*h+E*b,y=n[4],_=n[5],w=n[6],E=n[7],e[4]=y*r+_*s+w*p+E*m,e[5]=y*i+_*u+w*d+E*g,e[6]=y*o+_*c+w*f+E*v,e[7]=y*a+_*l+w*h+E*b,y=n[8],_=n[9],w=n[10],E=n[11],e[8]=y*r+_*s+w*p+E*m,e[9]=y*i+_*u+w*d+E*g,e[10]=y*o+_*c+w*f+E*v,e[11]=y*a+_*l+w*h+E*b,y=n[12],_=n[13],w=n[14],E=n[15],e[12]=y*r+_*s+w*p+E*m,e[13]=y*i+_*u+w*d+E*g,e[14]=y*o+_*c+w*f+E*v,e[15]=y*a+_*l+w*h+E*b,e},i.multiply=r.USE_SIMD?i.SIMD.multiply:i.scalar.multiply,i.mul=i.multiply,i.scalar.translate=function(e,t,n){var r,i,o,a,s,u,c,l,p,d,f,h,m=n[0],g=n[1],v=n[2];return t===e?(e[12]=t[0]*m+t[4]*g+t[8]*v+t[12],e[13]=t[1]*m+t[5]*g+t[9]*v+t[13],e[14]=t[2]*m+t[6]*g+t[10]*v+t[14],e[15]=t[3]*m+t[7]*g+t[11]*v+t[15]):(r=t[0],i=t[1],o=t[2],a=t[3],s=t[4],u=t[5],c=t[6],l=t[7],p=t[8],d=t[9],f=t[10],h=t[11],e[0]=r,e[1]=i,e[2]=o,e[3]=a,e[4]=s,e[5]=u,e[6]=c,e[7]=l,e[8]=p,e[9]=d,e[10]=f,e[11]=h,e[12]=r*m+s*g+p*v+t[12],e[13]=i*m+u*g+d*v+t[13],e[14]=o*m+c*g+f*v+t[14],e[15]=a*m+l*g+h*v+t[15]),e},i.SIMD.translate=function(e,t,n){var r=SIMD.Float32x4.load(t,0),i=SIMD.Float32x4.load(t,4),o=SIMD.Float32x4.load(t,8),a=SIMD.Float32x4.load(t,12),s=SIMD.Float32x4(n[0],n[1],n[2],0);t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11]),r=SIMD.Float32x4.mul(r,SIMD.Float32x4.swizzle(s,0,0,0,0)),i=SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(s,1,1,1,1)),o=SIMD.Float32x4.mul(o,SIMD.Float32x4.swizzle(s,2,2,2,2));var u=SIMD.Float32x4.add(r,SIMD.Float32x4.add(i,SIMD.Float32x4.add(o,a)));return SIMD.Float32x4.store(e,12,u),e},i.translate=r.USE_SIMD?i.SIMD.translate:i.scalar.translate,i.scalar.scale=function(e,t,n){var r=n[0],i=n[1],o=n[2];return e[0]=t[0]*r,e[1]=t[1]*r,e[2]=t[2]*r,e[3]=t[3]*r,e[4]=t[4]*i,e[5]=t[5]*i,e[6]=t[6]*i,e[7]=t[7]*i,e[8]=t[8]*o,e[9]=t[9]*o,e[10]=t[10]*o,e[11]=t[11]*o,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},i.SIMD.scale=function(e,t,n){var r,i,o,a=SIMD.Float32x4(n[0],n[1],n[2],0);return r=SIMD.Float32x4.load(t,0),SIMD.Float32x4.store(e,0,SIMD.Float32x4.mul(r,SIMD.Float32x4.swizzle(a,0,0,0,0))),i=SIMD.Float32x4.load(t,4),SIMD.Float32x4.store(e,4,SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(a,1,1,1,1))),o=SIMD.Float32x4.load(t,8),SIMD.Float32x4.store(e,8,SIMD.Float32x4.mul(o,SIMD.Float32x4.swizzle(a,2,2,2,2))),e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},i.scale=r.USE_SIMD?i.SIMD.scale:i.scalar.scale,i.rotate=function(e,t,n,i){var o,a,s,u,c,l,p,d,f,h,m,g,v,b,y,_,w,E,x,S,T,C,I,M,P=i[0],R=i[1],O=i[2],k=Math.sqrt(P*P+R*R+O*O);return Math.abs(k)<r.EPSILON?null:(k=1/k,P*=k,R*=k,O*=k,o=Math.sin(n),a=Math.cos(n),s=1-a,u=t[0],c=t[1],l=t[2],p=t[3],d=t[4],f=t[5],h=t[6],m=t[7],g=t[8],v=t[9],b=t[10],y=t[11],_=P*P*s+a,w=R*P*s+O*o,E=O*P*s-R*o,x=P*R*s-O*o,S=R*R*s+a,T=O*R*s+P*o,C=P*O*s+R*o,I=R*O*s-P*o,M=O*O*s+a,e[0]=u*_+d*w+g*E,e[1]=c*_+f*w+v*E,e[2]=l*_+h*w+b*E,e[3]=p*_+m*w+y*E,e[4]=u*x+d*S+g*T,e[5]=c*x+f*S+v*T,e[6]=l*x+h*S+b*T,e[7]=p*x+m*S+y*T,e[8]=u*C+d*I+g*M,e[9]=c*C+f*I+v*M,e[10]=l*C+h*I+b*M,e[11]=p*C+m*I+y*M,t!==e&&(e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e)},i.scalar.rotateX=function(e,t,n){var r=Math.sin(n),i=Math.cos(n),o=t[4],a=t[5],s=t[6],u=t[7],c=t[8],l=t[9],p=t[10],d=t[11];return t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[4]=o*i+c*r,e[5]=a*i+l*r,e[6]=s*i+p*r,e[7]=u*i+d*r,e[8]=c*i-o*r,e[9]=l*i-a*r,e[10]=p*i-s*r,e[11]=d*i-u*r,e},i.SIMD.rotateX=function(e,t,n){var r=SIMD.Float32x4.splat(Math.sin(n)),i=SIMD.Float32x4.splat(Math.cos(n));t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]);var o=SIMD.Float32x4.load(t,4),a=SIMD.Float32x4.load(t,8);return SIMD.Float32x4.store(e,4,SIMD.Float32x4.add(SIMD.Float32x4.mul(o,i),SIMD.Float32x4.mul(a,r))),SIMD.Float32x4.store(e,8,SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,r))),e},i.rotateX=r.USE_SIMD?i.SIMD.rotateX:i.scalar.rotateX,i.scalar.rotateY=function(e,t,n){var r=Math.sin(n),i=Math.cos(n),o=t[0],a=t[1],s=t[2],u=t[3],c=t[8],l=t[9],p=t[10],d=t[11];return t!==e&&(e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=o*i-c*r,e[1]=a*i-l*r,e[2]=s*i-p*r,e[3]=u*i-d*r,e[8]=o*r+c*i,e[9]=a*r+l*i,e[10]=s*r+p*i,e[11]=u*r+d*i,e},i.SIMD.rotateY=function(e,t,n){var r=SIMD.Float32x4.splat(Math.sin(n)),i=SIMD.Float32x4.splat(Math.cos(n));t!==e&&(e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]);var o=SIMD.Float32x4.load(t,0),a=SIMD.Float32x4.load(t,8);return SIMD.Float32x4.store(e,0,SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,i),SIMD.Float32x4.mul(a,r))),SIMD.Float32x4.store(e,8,SIMD.Float32x4.add(SIMD.Float32x4.mul(o,r),SIMD.Float32x4.mul(a,i))),e},i.rotateY=r.USE_SIMD?i.SIMD.rotateY:i.scalar.rotateY,i.scalar.rotateZ=function(e,t,n){var r=Math.sin(n),i=Math.cos(n),o=t[0],a=t[1],s=t[2],u=t[3],c=t[4],l=t[5],p=t[6],d=t[7];return t!==e&&(e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=o*i+c*r,e[1]=a*i+l*r,e[2]=s*i+p*r,e[3]=u*i+d*r,e[4]=c*i-o*r,e[5]=l*i-a*r,e[6]=p*i-s*r,e[7]=d*i-u*r,e},i.SIMD.rotateZ=function(e,t,n){var r=SIMD.Float32x4.splat(Math.sin(n)),i=SIMD.Float32x4.splat(Math.cos(n));t!==e&&(e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]);var o=SIMD.Float32x4.load(t,0),a=SIMD.Float32x4.load(t,4);return SIMD.Float32x4.store(e,0,SIMD.Float32x4.add(SIMD.Float32x4.mul(o,i),SIMD.Float32x4.mul(a,r))),SIMD.Float32x4.store(e,4,SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,r))),e},i.rotateZ=r.USE_SIMD?i.SIMD.rotateZ:i.scalar.rotateZ,i.fromTranslation=function(e,t){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=t[0],e[13]=t[1],e[14]=t[2],e[15]=1,e},i.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=t[1],e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=t[2],e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},i.fromRotation=function(e,t,n){var i,o,a,s=n[0],u=n[1],c=n[2],l=Math.sqrt(s*s+u*u+c*c);return Math.abs(l)<r.EPSILON?null:(l=1/l,s*=l,u*=l,c*=l,i=Math.sin(t),o=Math.cos(t),a=1-o,e[0]=s*s*a+o,e[1]=u*s*a+c*i,e[2]=c*s*a-u*i,e[3]=0,e[4]=s*u*a-c*i,e[5]=u*u*a+o,e[6]=c*u*a+s*i,e[7]=0,e[8]=s*c*a+u*i,e[9]=u*c*a-s*i,e[10]=c*c*a+o,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e)},i.fromXRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=r,e[6]=n,e[7]=0,e[8]=0,e[9]=-n,e[10]=r,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},i.fromYRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=0,e[2]=-n,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=n,e[9]=0,e[10]=r,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},i.fromZRotation=function(e,t){var n=Math.sin(t),r=Math.cos(t);return e[0]=r,e[1]=n,e[2]=0,e[3]=0,e[4]=-n,e[5]=r,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},i.fromRotationTranslation=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=r+r,u=i+i,c=o+o,l=r*s,p=r*u,d=r*c,f=i*u,h=i*c,m=o*c,g=a*s,v=a*u,b=a*c;return e[0]=1-(f+m),e[1]=p+b,e[2]=d-v,e[3]=0,e[4]=p-b,e[5]=1-(l+m),e[6]=h+g,e[7]=0,e[8]=d+v,e[9]=h-g,e[10]=1-(l+f),e[11]=0,e[12]=n[0],e[13]=n[1],e[14]=n[2],e[15]=1,e},i.getTranslation=function(e,t){return e[0]=t[12],e[1]=t[13],e[2]=t[14],e},i.getRotation=function(e,t){var n=t[0]+t[5]+t[10],r=0;return n>0?(r=2*Math.sqrt(n+1),e[3]=.25*r,e[0]=(t[6]-t[9])/r,e[1]=(t[8]-t[2])/r,e[2]=(t[1]-t[4])/r):t[0]>t[5]&t[0]>t[10]?(r=2*Math.sqrt(1+t[0]-t[5]-t[10]),e[3]=(t[6]-t[9])/r,e[0]=.25*r,e[1]=(t[1]+t[4])/r,e[2]=(t[8]+t[2])/r):t[5]>t[10]?(r=2*Math.sqrt(1+t[5]-t[0]-t[10]),e[3]=(t[8]-t[2])/r,e[0]=(t[1]+t[4])/r,e[1]=.25*r,e[2]=(t[6]+t[9])/r):(r=2*Math.sqrt(1+t[10]-t[0]-t[5]),e[3]=(t[1]-t[4])/r,e[0]=(t[8]+t[2])/r,e[1]=(t[6]+t[9])/r,e[2]=.25*r),e},i.fromRotationTranslationScale=function(e,t,n,r){var i=t[0],o=t[1],a=t[2],s=t[3],u=i+i,c=o+o,l=a+a,p=i*u,d=i*c,f=i*l,h=o*c,m=o*l,g=a*l,v=s*u,b=s*c,y=s*l,_=r[0],w=r[1],E=r[2];return e[0]=(1-(h+g))*_,e[1]=(d+y)*_,e[2]=(f-b)*_,e[3]=0,e[4]=(d-y)*w,e[5]=(1-(p+g))*w,e[6]=(m+v)*w,e[7]=0,e[8]=(f+b)*E,e[9]=(m-v)*E,e[10]=(1-(p+h))*E,e[11]=0,e[12]=n[0],e[13]=n[1],e[14]=n[2],e[15]=1,e},i.fromRotationTranslationScaleOrigin=function(e,t,n,r,i){var o=t[0],a=t[1],s=t[2],u=t[3],c=o+o,l=a+a,p=s+s,d=o*c,f=o*l,h=o*p,m=a*l,g=a*p,v=s*p,b=u*c,y=u*l,_=u*p,w=r[0],E=r[1],x=r[2],S=i[0],T=i[1],C=i[2];return e[0]=(1-(m+v))*w,e[1]=(f+_)*w,e[2]=(h-y)*w,e[3]=0,e[4]=(f-_)*E,e[5]=(1-(d+v))*E,e[6]=(g+b)*E,e[7]=0,e[8]=(h+y)*x,e[9]=(g-b)*x,e[10]=(1-(d+m))*x,e[11]=0,e[12]=n[0]+S-(e[0]*S+e[4]*T+e[8]*C),e[13]=n[1]+T-(e[1]*S+e[5]*T+e[9]*C),e[14]=n[2]+C-(e[2]*S+e[6]*T+e[10]*C),e[15]=1,e},i.fromQuat=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=n+n,s=r+r,u=i+i,c=n*a,l=r*a,p=r*s,d=i*a,f=i*s,h=i*u,m=o*a,g=o*s,v=o*u;return e[0]=1-p-h,e[1]=l+v,e[2]=d-g,e[3]=0,e[4]=l-v,e[5]=1-c-h,e[6]=f+m,e[7]=0,e[8]=d+g,e[9]=f-m,e[10]=1-c-p,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},i.frustum=function(e,t,n,r,i,o,a){var s=1/(n-t),u=1/(i-r),c=1/(o-a);return e[0]=2*o*s,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=2*o*u,e[6]=0,e[7]=0,e[8]=(n+t)*s,e[9]=(i+r)*u,e[10]=(a+o)*c,e[11]=-1,e[12]=0,e[13]=0,e[14]=a*o*2*c,e[15]=0,e},i.perspective=function(e,t,n,r,i){var o=1/Math.tan(t/2),a=1/(r-i);return e[0]=o/n,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=o,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=(i+r)*a,e[11]=-1,e[12]=0,e[13]=0,e[14]=2*i*r*a,e[15]=0,e},i.perspectiveFromFieldOfView=function(e,t,n,r){var i=Math.tan(t.upDegrees*Math.PI/180),o=Math.tan(t.downDegrees*Math.PI/180),a=Math.tan(t.leftDegrees*Math.PI/180),s=Math.tan(t.rightDegrees*Math.PI/180),u=2/(a+s),c=2/(i+o);return e[0]=u,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=c,e[6]=0,e[7]=0,e[8]=-((a-s)*u*.5),e[9]=(i-o)*c*.5,e[10]=r/(n-r),e[11]=-1,e[12]=0,e[13]=0,e[14]=r*n/(n-r),e[15]=0,e},i.ortho=function(e,t,n,r,i,o,a){var s=1/(t-n),u=1/(r-i),c=1/(o-a);return e[0]=-2*s,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=-2*u,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=2*c,e[11]=0,e[12]=(t+n)*s,e[13]=(i+r)*u,e[14]=(a+o)*c,e[15]=1,e},i.lookAt=function(e,t,n,o){var a,s,u,c,l,p,d,f,h,m,g=t[0],v=t[1],b=t[2],y=o[0],_=o[1],w=o[2],E=n[0],x=n[1],S=n[2];return Math.abs(g-E)<r.EPSILON&&Math.abs(v-x)<r.EPSILON&&Math.abs(b-S)<r.EPSILON?i.identity(e):(d=g-E,f=v-x,h=b-S,m=1/Math.sqrt(d*d+f*f+h*h),d*=m,f*=m,h*=m,a=_*h-w*f,s=w*d-y*h,u=y*f-_*d,m=Math.sqrt(a*a+s*s+u*u),m?(m=1/m,a*=m,s*=m,u*=m):(a=0,s=0,u=0),c=f*u-h*s,l=h*a-d*u,p=d*s-f*a,m=Math.sqrt(c*c+l*l+p*p),m?(m=1/m,c*=m,l*=m,p*=m):(c=0,l=0,p=0),e[0]=a,e[1]=c,e[2]=d,e[3]=0,e[4]=s,e[5]=l,e[6]=f,e[7]=0,e[8]=u,e[9]=p,e[10]=h,e[11]=0,e[12]=-(a*g+s*v+u*b),e[13]=-(c*g+l*v+p*b),e[14]=-(d*g+f*v+h*b),e[15]=1,e)},i.str=function(e){return"mat4("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+", "+e[4]+", "+e[5]+", "+e[6]+", "+e[7]+", "+e[8]+", "+e[9]+", "+e[10]+", "+e[11]+", "+e[12]+", "+e[13]+", "+e[14]+", "+e[15]+")"},i.frob=function(e){return Math.sqrt(Math.pow(e[0],2)+Math.pow(e[1],2)+Math.pow(e[2],2)+Math.pow(e[3],2)+Math.pow(e[4],2)+Math.pow(e[5],2)+Math.pow(e[6],2)+Math.pow(e[7],2)+Math.pow(e[8],2)+Math.pow(e[9],2)+Math.pow(e[10],2)+Math.pow(e[11],2)+Math.pow(e[12],2)+Math.pow(e[13],2)+Math.pow(e[14],2)+Math.pow(e[15],2))},i.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e[2]=t[2]+n[2],e[3]=t[3]+n[3],e[4]=t[4]+n[4],e[5]=t[5]+n[5],e[6]=t[6]+n[6],e[7]=t[7]+n[7],e[8]=t[8]+n[8],e[9]=t[9]+n[9],e[10]=t[10]+n[10],e[11]=t[11]+n[11],e[12]=t[12]+n[12],e[13]=t[13]+n[13],e[14]=t[14]+n[14],e[15]=t[15]+n[15],e},i.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e[2]=t[2]-n[2],e[3]=t[3]-n[3],e[4]=t[4]-n[4],e[5]=t[5]-n[5],e[6]=t[6]-n[6],e[7]=t[7]-n[7],e[8]=t[8]-n[8],e[9]=t[9]-n[9],e[10]=t[10]-n[10],e[11]=t[11]-n[11],e[12]=t[12]-n[12],e[13]=t[13]-n[13],e[14]=t[14]-n[14],e[15]=t[15]-n[15],e},i.sub=i.subtract,i.multiplyScalar=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e[8]=t[8]*n,e[9]=t[9]*n,e[10]=t[10]*n,e[11]=t[11]*n,e[12]=t[12]*n,e[13]=t[13]*n,e[14]=t[14]*n,e[15]=t[15]*n,e},i.multiplyScalarAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e[2]=t[2]+n[2]*r,e[3]=t[3]+n[3]*r,e[4]=t[4]+n[4]*r,e[5]=t[5]+n[5]*r,e[6]=t[6]+n[6]*r,e[7]=t[7]+n[7]*r,e[8]=t[8]+n[8]*r,e[9]=t[9]+n[9]*r,e[10]=t[10]+n[10]*r,e[11]=t[11]+n[11]*r,e[12]=t[12]+n[12]*r,e[13]=t[13]+n[13]*r,e[14]=t[14]+n[14]*r,e[15]=t[15]+n[15]*r,e},i.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]&&e[9]===t[9]&&e[10]===t[10]&&e[11]===t[11]&&e[12]===t[12]&&e[13]===t[13]&&e[14]===t[14]&&e[15]===t[15]},i.equals=function(e,t){var n=e[0],i=e[1],o=e[2],a=e[3],s=e[4],u=e[5],c=e[6],l=e[7],p=e[8],d=e[9],f=e[10],h=e[11],m=e[12],g=e[13],v=e[14],b=e[15],y=t[0],_=t[1],w=t[2],E=t[3],x=t[4],S=t[5],T=t[6],C=t[7],I=t[8],M=t[9],P=t[10],R=t[11],O=t[12],k=t[13],A=t[14],N=t[15];return Math.abs(n-y)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(y))&&Math.abs(i-_)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(_))&&Math.abs(o-w)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(w))&&Math.abs(a-E)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(E))&&Math.abs(s-x)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(x))&&Math.abs(u-S)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(S))&&Math.abs(c-T)<=r.EPSILON*Math.max(1,Math.abs(c),Math.abs(T))&&Math.abs(l-C)<=r.EPSILON*Math.max(1,Math.abs(l),Math.abs(C))&&Math.abs(p-I)<=r.EPSILON*Math.max(1,Math.abs(p),Math.abs(I))&&Math.abs(d-M)<=r.EPSILON*Math.max(1,Math.abs(d),Math.abs(M))&&Math.abs(f-P)<=r.EPSILON*Math.max(1,Math.abs(f),Math.abs(P))&&Math.abs(h-R)<=r.EPSILON*Math.max(1,Math.abs(h),Math.abs(R))&&Math.abs(m-O)<=r.EPSILON*Math.max(1,Math.abs(m),Math.abs(O))&&Math.abs(g-k)<=r.EPSILON*Math.max(1,Math.abs(g),Math.abs(k))&&Math.abs(v-A)<=r.EPSILON*Math.max(1,Math.abs(v),Math.abs(A))&&Math.abs(b-N)<=r.EPSILON*Math.max(1,Math.abs(b),Math.abs(N))},e.exports=i},function(e,t,n){var r=n(54),i=n(262),o=n(263),a=n(264),s={};s.create=function(){var e=new r.ARRAY_TYPE(4);return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e},s.rotationTo=function(){var e=o.create(),t=o.fromValues(1,0,0),n=o.fromValues(0,1,0);return function(r,i,a){var u=o.dot(i,a);return u<-.999999?(o.cross(e,t,i),o.length(e)<1e-6&&o.cross(e,n,i),o.normalize(e,e),s.setAxisAngle(r,e,Math.PI),r):u>.999999?(r[0]=0,r[1]=0,r[2]=0,r[3]=1,r):(o.cross(e,i,a),r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=1+u,s.normalize(r,r))}}(),s.setAxes=function(){var e=i.create();return function(t,n,r,i){return e[0]=r[0],e[3]=r[1],e[6]=r[2],e[1]=i[0],e[4]=i[1],e[7]=i[2],e[2]=-n[0],e[5]=-n[1],e[8]=-n[2],s.normalize(t,s.fromMat3(t,e))}}(),s.clone=a.clone,s.fromValues=a.fromValues,s.copy=a.copy,s.set=a.set,s.identity=function(e){return e[0]=0,e[1]=0,e[2]=0,e[3]=1,e},s.setAxisAngle=function(e,t,n){n*=.5;var r=Math.sin(n);return e[0]=r*t[0],e[1]=r*t[1],e[2]=r*t[2],e[3]=Math.cos(n),e},s.getAxisAngle=function(e,t){var n=2*Math.acos(t[3]),r=Math.sin(n/2);return 0!=r?(e[0]=t[0]/r,e[1]=t[1]/r,e[2]=t[2]/r):(e[0]=1,e[1]=0,e[2]=0),n},s.add=a.add,s.multiply=function(e,t,n){var r=t[0],i=t[1],o=t[2],a=t[3],s=n[0],u=n[1],c=n[2],l=n[3];return e[0]=r*l+a*s+i*c-o*u,e[1]=i*l+a*u+o*s-r*c,e[2]=o*l+a*c+r*u-i*s,e[3]=a*l-r*s-i*u-o*c,e},s.mul=s.multiply,s.scale=a.scale,s.rotateX=function(e,t,n){n*=.5;var r=t[0],i=t[1],o=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u+a*s,e[1]=i*u+o*s,e[2]=o*u-i*s,e[3]=a*u-r*s,e},s.rotateY=function(e,t,n){n*=.5;var r=t[0],i=t[1],o=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u-o*s,e[1]=i*u+a*s,e[2]=o*u+r*s,e[3]=a*u-i*s,e},s.rotateZ=function(e,t,n){n*=.5;var r=t[0],i=t[1],o=t[2],a=t[3],s=Math.sin(n),u=Math.cos(n);return e[0]=r*u+i*s,e[1]=i*u-r*s,e[2]=o*u+a*s,e[3]=a*u-o*s,e},s.calculateW=function(e,t){var n=t[0],r=t[1],i=t[2];return e[0]=n,e[1]=r,e[2]=i,e[3]=Math.sqrt(Math.abs(1-n*n-r*r-i*i)),e},s.dot=a.dot,s.lerp=a.lerp,s.slerp=function(e,t,n,r){var i,o,a,s,u,c=t[0],l=t[1],p=t[2],d=t[3],f=n[0],h=n[1],m=n[2],g=n[3];return o=c*f+l*h+p*m+d*g,o<0&&(o=-o,f=-f,h=-h,m=-m,g=-g),1-o>1e-6?(i=Math.acos(o),a=Math.sin(i),s=Math.sin((1-r)*i)/a,u=Math.sin(r*i)/a):(s=1-r,u=r),e[0]=s*c+u*f,e[1]=s*l+u*h,e[2]=s*p+u*m,e[3]=s*d+u*g,e},s.sqlerp=function(){var e=s.create(),t=s.create();return function(n,r,i,o,a,u){return s.slerp(e,r,a,u),s.slerp(t,i,o,u),s.slerp(n,e,t,2*u*(1-u)),n}}(),s.invert=function(e,t){var n=t[0],r=t[1],i=t[2],o=t[3],a=n*n+r*r+i*i+o*o,s=a?1/a:0;return e[0]=-n*s,e[1]=-r*s,e[2]=-i*s,e[3]=o*s,e},s.conjugate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=t[3],e},s.length=a.length,s.len=s.length,s.squaredLength=a.squaredLength,s.sqrLen=s.squaredLength,s.normalize=a.normalize,s.fromMat3=function(e,t){var n,r=t[0]+t[4]+t[8];if(r>0)n=Math.sqrt(r+1),e[3]=.5*n,n=.5/n,e[0]=(t[5]-t[7])*n,e[1]=(t[6]-t[2])*n,e[2]=(t[1]-t[3])*n;else{var i=0;t[4]>t[0]&&(i=1),t[8]>t[3*i+i]&&(i=2);var o=(i+1)%3,a=(i+2)%3;n=Math.sqrt(t[3*i+i]-t[3*o+o]-t[3*a+a]+1),e[i]=.5*n,n=.5/n,e[3]=(t[3*o+a]-t[3*a+o])*n,e[o]=(t[3*o+i]+t[3*i+o])*n,e[a]=(t[3*a+i]+t[3*i+a])*n}return e},s.str=function(e){return"quat("+e[0]+", "+e[1]+", "+e[2]+", "+e[3]+")"},s.exactEquals=a.exactEquals,s.equals=a.equals,e.exports=s},function(e,t,n){var r=n(54),i={};i.create=function(){var e=new r.ARRAY_TYPE(2);return e[0]=0,e[1]=0,e},i.clone=function(e){var t=new r.ARRAY_TYPE(2);return t[0]=e[0],t[1]=e[1],t},i.fromValues=function(e,t){var n=new r.ARRAY_TYPE(2);return n[0]=e,n[1]=t,n},i.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e},i.set=function(e,t,n){return e[0]=t,e[1]=n,e},i.add=function(e,t,n){return e[0]=t[0]+n[0],e[1]=t[1]+n[1],e},i.subtract=function(e,t,n){return e[0]=t[0]-n[0],e[1]=t[1]-n[1],e},i.sub=i.subtract,i.multiply=function(e,t,n){return e[0]=t[0]*n[0],e[1]=t[1]*n[1],e},i.mul=i.multiply,i.divide=function(e,t,n){return e[0]=t[0]/n[0],e[1]=t[1]/n[1],e},i.div=i.divide,i.ceil=function(e,t){return e[0]=Math.ceil(t[0]),e[1]=Math.ceil(t[1]),e},i.floor=function(e,t){return e[0]=Math.floor(t[0]),e[1]=Math.floor(t[1]),e},i.min=function(e,t,n){return e[0]=Math.min(t[0],n[0]),e[1]=Math.min(t[1],n[1]),e},i.max=function(e,t,n){return e[0]=Math.max(t[0],n[0]),e[1]=Math.max(t[1],n[1]),e},i.round=function(e,t){return e[0]=Math.round(t[0]),e[1]=Math.round(t[1]),e},i.scale=function(e,t,n){return e[0]=t[0]*n,e[1]=t[1]*n,e},i.scaleAndAdd=function(e,t,n,r){return e[0]=t[0]+n[0]*r,e[1]=t[1]+n[1]*r,e},i.distance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1];return Math.sqrt(n*n+r*r)},i.dist=i.distance,i.squaredDistance=function(e,t){var n=t[0]-e[0],r=t[1]-e[1];return n*n+r*r},i.sqrDist=i.squaredDistance,i.length=function(e){var t=e[0],n=e[1];return Math.sqrt(t*t+n*n)},i.len=i.length,i.squaredLength=function(e){var t=e[0],n=e[1];return t*t+n*n},i.sqrLen=i.squaredLength,i.negate=function(e,t){return e[0]=-t[0],e[1]=-t[1],e},i.inverse=function(e,t){return e[0]=1/t[0],e[1]=1/t[1],e},i.normalize=function(e,t){var n=t[0],r=t[1],i=n*n+r*r;return i>0&&(i=1/Math.sqrt(i),e[0]=t[0]*i,e[1]=t[1]*i),e},i.dot=function(e,t){return e[0]*t[0]+e[1]*t[1]},i.cross=function(e,t,n){var r=t[0]*n[1]-t[1]*n[0];return e[0]=e[1]=0,e[2]=r,e},i.lerp=function(e,t,n,r){var i=t[0],o=t[1];return e[0]=i+r*(n[0]-i),e[1]=o+r*(n[1]-o),e},i.random=function(e,t){t=t||1;var n=2*r.RANDOM()*Math.PI;return e[0]=Math.cos(n)*t,e[1]=Math.sin(n)*t,e},i.transformMat2=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[2]*i,e[1]=n[1]*r+n[3]*i,e},i.transformMat2d=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[2]*i+n[4],e[1]=n[1]*r+n[3]*i+n[5],e},i.transformMat3=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[3]*i+n[6],e[1]=n[1]*r+n[4]*i+n[7],e},i.transformMat4=function(e,t,n){var r=t[0],i=t[1];return e[0]=n[0]*r+n[4]*i+n[12],e[1]=n[1]*r+n[5]*i+n[13],e},i.forEach=function(){var e=i.create();return function(t,n,r,i,o,a){var s,u;for(n||(n=2),r||(r=0),u=i?Math.min(i*n+r,t.length):t.length,s=r;s<u;s+=n)e[0]=t[s],e[1]=t[s+1],o(e,e,a),t[s]=e[0],t[s+1]=e[1];return t}}(),i.str=function(e){return"vec2("+e[0]+", "+e[1]+")"},i.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]},i.equals=function(e,t){var n=e[0],i=e[1],o=t[0],a=t[1];return Math.abs(n-o)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(o))&&Math.abs(i-a)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(a))},e.exports=i},function(e,t,n){e.exports=n(123).call(Function.call,Object.prototype.hasOwnProperty)},function(e,t,n){"use strict";var r={childContextTypes:!0,contextTypes:!0,defaultProps:!0,displayName:!0,getDefaultProps:!0,mixins:!0,propTypes:!0,type:!0},i={name:!0,length:!0,prototype:!0,caller:!0,arguments:!0,arity:!0},o="function"==typeof Object.getOwnPropertySymbols;e.exports=function(e,t,n){if("string"!=typeof t){var a=Object.getOwnPropertyNames(t);o&&(a=a.concat(Object.getOwnPropertySymbols(t)));for(var s=0;s<a.length;++s)if(!(r[a[s]]||i[a[s]]||n&&n[a[s]]))try{e[a[s]]=t[a[s]]}catch(e){}}return e}},function(e,t,n){"use strict";e.exports=function(e,t,n,r,i,o,a,s){if(!e){var u;if(void 0===t)u=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var c=[n,r,i,o,a,s],l=0;u=new Error(t.replace(/%s/g,function(){return c[l++]})),u.name="Invariant Violation"}throw u.framesToPop=1,u}}},function(e,t,n){"use strict";var r=Date.prototype.getDay,i=function(e){try{return r.call(e),!0}catch(e){return!1}},o=Object.prototype.toString,a="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;e.exports=function(e){return"object"==typeof e&&null!==e&&(a?i(e):"[object Date]"===o.call(e))}},function(e,t,n){"use strict";var r=n(611),i=RegExp.prototype.exec,o=Object.getOwnPropertyDescriptor,a=function(e){try{var t=e.lastIndex;return e.lastIndex=0,i.call(e),!0}catch(e){return!1}finally{e.lastIndex=t}},s=Object.prototype.toString,u="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;e.exports=function(e){if(!e||"object"!=typeof e)return!1;if(!u)return"[object RegExp]"===s.call(e);var t=o(e,"lastIndex");return!(!t||!r(t,"value"))&&a(e)}},function(e,t,n){"use strict";var r=Object.prototype.toString;if("function"==typeof Symbol&&"symbol"==typeof Symbol()){var i=Symbol.prototype.toString,o=/^Symbol\(.*\)$/,a=function(e){return"symbol"==typeof e.valueOf()&&o.test(i.call(e))};e.exports=function(e){if("symbol"==typeof e)return!0;if("[object Symbol]"!==r.call(e))return!1;try{return a(e)}catch(e){return!1}}}else e.exports=function(e){return!1}},function(e,t){function n(e){var t=window.document.createElement("script");t.async=!0,t.type="text/javascript",t.src=("https:"===window.document.location.protocol?"https:":"http:")+"//www.googletagservices.com/tag/js/gpt.js",window.document.head.appendChild(t),t.addEventListener("error",e.onError)}function r(e){o||(o=window.googletag=window.googletag||{},o.cmd=o.cmd||[],n(e),o.cmd.push(function(){o.pubads().disableInitialLoad(),o.enableServices()}))}function i(){}var o,a=[];t.create=function(e){function t(e,t,n,r){if(e&&t){var i=r||[];2===i.length&&"string"==typeof i[0]&&(i=[i]),o.cmd.push(function(){var r=o.defineSlot(t,n||[],e);a[e]=r;for(var s=0;s<i.length;s++){var u=i[s];2===u.length&&(r=r.setTargeting(u[0],u[1]))}r=r.setCollapseEmptyDiv(!0).addService(o.pubads()),o.display(e),o.pubads().refresh([r])})}}function n(e,t){o.cmd.push(function(){o.display(e),o.pubads().refresh([t])})}function s(e,t){o.cmd.push(function(){o.pubads().addEventListener(e,t)})}function u(e){return a[e]}var c=e||{};return c.onError=c.onError||i,r(c),{addPlacement:t,addEventListener:s,getSlotById:u,refreshPlacement:n}}},function(e,t){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="_build/157",t(0)}([function(e,t,n){e.exports=n(1)},function(e,t,n){function r(e){i.forOwn({post:function(e,t,n){},handleError:function(e){},getWidth:function(){},getHeight:function(){},getUsername:function(){},getLocation:function(){},getReferrer:function(){},getSource:function(){},getOrigin:function(){},getLanguage:function(){},setTimeout:function(e,t){},clearTimeout:function(e){},setInterval:function(e,t){},clearInterval:function(e){},nagleTimeout:0},function(t,n){if(void 0===e[n]||null!==e[n]&&typeof e[n]!=typeof t)throw new Error("Initialization error: You must specify options correctly. On key "+n+" value "+e[n]+" is not of correct type "+typeof t)});var t={getUsername:e.getUsername,getLanguage:e.getLanguage,getLocation:e.getLocation,getReferrer:e.getReferrer,getSource:e.getSource,getWidth:e.getWidth,getHeight:e.getHeight,getBrowserSize:function(){return t.getWidth()+"x"+t.getHeight()}},n=function(t){e.post("/ping",{Accept:"application/json","Content-Type":"text/plain;charset=UTF-8"},t)},r=new o,m=new u(e.getOrigin()+"_tracking-v1.3.157");this._handlers={};var g=function(t){i.forOwn(t.handlers(),function(n,o){this._handlers[o]=this._handlers[o]||[],this._handlers[o].push(n.bind(t)),this[o]=function(t){var n=r.validate(o,t);if(n)return void e.handleError(new Error(JSON.stringify(n)));i.forEach(this._handlers[o],function(e){e.call(null,t)},this)}.bind(this)},this)}.bind(this),v=new l(e.handleError,m,n,t,e.setTimeout,e.clearTimeout,e.nagleTimeout);g(new s(m,n)),g(new a(m,n,e.setTimeout,e.clearTimeout)),g(new d(v)),g(new p(v)),g(new f(v)),g(new h(v,e.setTimeout,e.clearTimeout)),g(new c(m,n,t,e.setTimeout,e.clearTimeout)),this._handleError=e.handleError}var i=(n(2),n(3)),o=n(4).RequestValidator,a=n(7).MonitorHandler,s=n(8).IgnoreHandler,u=n(9).Wrapper,c=n(10).WebsiteSignalHandler,l=n(11).ReaderSignalHandler,p=n(13).LinkEventsHandler,d=n(14).SidebarHandler,f=n(15).ClipEventsHandler,h=n(12).DocumentEventsHandler;r.prototype.legacyInterface=function(){var e=function(){for(var e=0;e<arguments.length;e++){var t=arguments[e];if("object"!=typeof t&&"string"!=typeof t)return void this._handleError(new Error("Invalid argument: "+t+", it must be a string or an object."));var n="string"==typeof t?t:t.event,r="string"==typeof t?null:t.data;if(!this.hasOwnProperty(n))return void this._handleError(new Error("Unknown action: "+n+", please use this library according to the reference."));this[n](r)}}.bind(this);null!==window._tracq&&void 0!==window._tracq&&void 0!==window._tracq.length&&e.apply(null,window._tracq),window._tracq={push:e}},r.defaultWebConfiguration=function(){return n(16)},t.Tracker=r},function(e,t){Function.prototype.bind||(Function.prototype.bind=function(e){if("function"!=typeof this)throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");var t=Array.prototype.slice.call(arguments,1),n=this,r=function(){},i=function(){return n.apply(this instanceof r?this:e,t.concat(Array.prototype.slice.call(arguments)))};return this.prototype&&(r.prototype=this.prototype),i.prototype=new r,i})},function(e,t){function n(e,t,n){var r=p(e);if(t&&r)if(Array.prototype.forEach)for(var i=-1,o=e.length,a="object"==typeof n?n:e;++i<o&&t.call(a,e[i],i,e)!==!1;);else Array.prototype.forEach.call(e,t,n);return e}function r(e,t,n){var r=d(e);if(t&&r){var i="object"==typeof n?n:e;for(var o in e)if(e.hasOwnProperty(o)&&t.call(i,e[o],o,e)===!1)break}return e}function i(e,t){return r(t,function(t,n){e[n]=t}),e}function o(e){if(d(e)&&arguments.length>1)for(var t=1;t<arguments.length;t++)i(e,arguments[t]);return e}var a=Object.prototype.toString,s=a.call([]),u=String(a);u=u.replace(/[.*+?^${}()|[\]\\]/g,"\\$&"),u=u.replace(/toString| for [^\]]+/g,".*?");var c=new RegExp("^"+u+"$"),l=function(e){return"function"==typeof e&&c.test(e)}(l=Array.isArray)&&l,p=l||function(e){return e&&"object"==typeof e&&"number"==typeof e.length&&a.call(e)===s||!1},d=function(e){return e&&"object"==typeof e&&!p(e)};e.exports.isObject=d,e.exports.isArray=p,e.exports.forEach=n,e.exports.forOwn=r,e.exports.extend=o},function(e,t,n){function r(e){return/^\?(\w+)$/.test(e)}function i(e,t){var n=/^[\?]?(\w+)$/.exec(t);if(n&&n[1])return e[n[1]]}function o(e,t){switch(e){case"array":return u.isArray(t);case"null":case"undefined":return null===t||void 0===t;case"arrayOfNumbers":return p(t);default:return typeof t===e}}function a(e,t,n){var s;return!(!r(n)||!o("null",t))||(o("string",e)?o(e,t):"function"==typeof e?!!e(t):u.isArray(e)?(s=!1,u.forEach(e,function(e,n){return!(s=s||e===t)}),s):!(!u.isObject(e)||!u.isObject(t))&&(s=!0,u.forOwn(e,function(e,n){var r=i(t,n);return s=s&&a(e,r,n)}),s))}function s(){}var u=n(3),c=n(5),l=n(6),p=function(e){return function(t){if(u.isArray(t)){var n=!0;return u.forEach(t,function(t){return n=n&&a(e,t)}),n}return!1}}("number");s.prototype.validate=function(e,t){var n=u.extend({},c,l);if(n.hasOwnProperty(e)){var r=i(n,e);if(!a(r,t,e))return{action:e,expect:r,got:t}}},e.exports.RequestValidator=s},function(e,t){e.exports={webpageLoad:"null",streamScrolling:{index:"number"},documentShare:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",service:"string"},documentDownload:{anonymous:"boolean",revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string"},streamDocumentLoad:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string","?section":"string","?adpageId":"string",pageNumber:"number","?streamOrigin":"array",streamRanking:"number"},streamDocumentClick:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string","?adpageId":"string","?adpageToken":"string","?streamOrigin":"array",streamRanking:"number","?clickCoordinates":"string"},infoboxLoad:{infoboxId:"string","?streamOrigin":"array",streamRanking:"number"},infoboxClick:{infoboxId:"string",link:"string","?streamOrigin":"array",streamRanking:"number","?clickCoordinates":"string"},curatedLoad:{source:"string",link:"string",ranking:"number"},curatedClick:{source:"string",link:"string",ranking:"number"},embedLoad:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",embedId:"string"},embedClick:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",embedId:"string"},streamAdRequest:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number"},streamAdInserted:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number",timespan:"number"},streamAdNotAvailable:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number",timespan:"number"},streamAdImpression:{adProvider:"string",placement:"string","?streamOrigin":"array",ranking:"number"}}},function(e,t){e.exports={documentLoad:{revisionId:"string",publicationId:"string",publicationName:"string",ownerUsername:"string",pages:"arrayOfNumbers",pageNumber:"number",isFullscreen:"boolean",isEmbed:"boolean","?embedId":"string","?adpageId":"string","?adpageToken":"string","?streamOrigin":"array","?streamRanking":"number"},documentUnLoad:"null",userInteracted:"null",pageChange:{pages:"arrayOfNumbers",pageNumber:"number"},zoom:"null",resize:{displaySize:"string",isFullscreen:"boolean"},linkClick:{url:"string",pageNumber:"number",linkPosition:"string"},watermarkClick:{url:"string"},ctaLoad:{type:"string",pageNumber:"number"},ctaClick:{type:"string",pageNumber:"number"},adpageLoad:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",adpageId:"string",absolutePosition:"number",relativePosition:"number"},adpageClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",adpageId:"string",adpageToken:"string",absolutePosition:"number",relativePosition:"number"},relatedLoad:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",absolutePosition:"number",relativePosition:"number"},relatedClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",absolutePosition:"number",relativePosition:"number"},moreContentDocumentShow:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",streamOrigin:"array",streamRanking:"number"},moreContentDocumentClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",streamOrigin:"array",streamRanking:"number"},archiveLoad:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",pageNumber:"number",absolutePosition:"number",relativePosition:"number"},archiveClick:{revisionId:"string",publicationId:"string",ownerUsername:"string",publicationName:"string",absolutePosition:"number",relativePosition:"number"},clippingLayer:{action:"string"},clippingComment:{onPage:"number",action:"string",clippingId:"string",commentId:"number","?url":"string",creator:"string"},clippingAction:{clippingId:"string",action:"string",onPage:"number",creator:"string","?url":"string","?page":"number","?service":"string","?videoid":"string","?opened_in_reader":"boolean"}}},function(e,t,n){function r(e,t,n,r){this.wrapper=e,this.post=t,this.setTimeout=n,this.clearTimeout=r,this._postBatchedTimeoutId=void 0,this._batchedQueue=[]}var i=n(3);r.prototype._queueLength=function(){return this._batchedQueue.length},r.prototype._addToQueue=function(e){this._batchedQueue.push(i.extend(e,{version:"1.0.0",type:e.type}))},r.prototype._startPostTimer=function(){void 0===this._postBatchedTimeoutId&&(this._postBatchedTimeoutId=this.setTimeout(function(){this._postBatchedTimeoutId=void 0,this._postAllQueued()}.bind(this),2e3))},r.prototype._postAllQueued=function(){if(0!==this._queueLength()){void 0!==this._postBatchedTimeoutId&&(this.clearTimeout(this._postBatchedTimeoutId),this._postBatchedTimeoutId=void 0);var e=this.wrapper.getSignalWrapper("monitor");e.data=this._batchedQueue,this._batchedQueue=[],this.post(e)}},r.prototype.monitor=function(e){this._addToQueue(e),this._postAllQueued()},r.prototype.monitorBatched=function(e){this._addToQueue(e),this._queueLength()>=20?this._postAllQueued():this._startPostTimer()},r.prototype.flush=function(){this._postAllQueued()},r.prototype.handlers=function(){return{monitor:this.monitor,monitorBatched:this.monitorBatched,flush:this.flush}},e.exports.MonitorHandler=r},function(e,t){function n(e,t){this.wrapper=e,this.post=t}n.prototype.ignore=function(e){var t=this.wrapper.getSignalWrapper("ignore");t.data=e,this.post(t)},n.prototype.flush=function(){},n.prototype.handlers=function(){return{ignore:this.ignore,flush:this.flush}},e.exports.IgnoreHandler=n},function(e,t){function n(e){this.origin=e}n.prototype.getSignalWrapper=function(e){return{version:"2.2.0",origin:this.origin,type:e}},e.exports.Wrapper=n},function(e,t,n){function r(e,t,n,r,i){this.sectionsDocImpression={},this.wrapper=e,this.post=t,this.environment=n,this.setTimeout=r,this.clearTimeout=i}var i=n(3);r.prototype.getSignalData=function(e){return{version:"2.2.2",username:e?null:this.environment.getUsername(),ui_language:this.environment.getLanguage(),location:this.environment.getLocation(),referrer:this.environment.getReferrer(),contexts:[]}},r.prototype.executePingbackIfPlatformHasChanged=function(){if(this.signal){var e=!1,t=this.getSignalData();i.forEach(["version","username","location","referrer"],function(n){e=e||this.signal.data[n]!==t[n]},this),e&&this.executePingback()}},r.prototype.isContextChanged=function(){var e=this.signal.data.contexts.length;return 0===e||this.signal.data.contexts[e-1].browser_size!==this.environment.getBrowserSize()},r.prototype.updateSignal=function(e){if(this.executePingbackIfPlatformHasChanged(),this.signal=this.signal||this.wrapper.getSignalWrapper("website"),this.signal.data=this.signal.data||this.getSignalData(),this.isContextChanged()&&this.signal.data.contexts.push({browser_size:this.environment.getBrowserSize(),events:[]}),e){this.signal.data.contexts[this.signal.data.contexts.length-1].events.push(e)}},r.prototype.timeoutPingback=function(){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0);for(var e=0,t=this.signal.data.contexts.length-1;t>=0;t--)e+=this.signal.data.contexts[t].events.length;e>=20?this.executePingback():this.timeoutId=this.setTimeout(this.executePingback.bind(this),1500)},r.prototype.executePingback=function(){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0),this.signal&&(this.post(this.signal),this.signal=void 0)},r.prototype.generateAndExecuteAnonymousPingback=function(e){var t=this.wrapper.getSignalWrapper("website");t.data=this.getSignalData(!0),t.data.contexts.push({browser_size:this.environment.getBrowserSize(),events:[e]}),this.post(t)},r.prototype.webpageLoadHandler=function(){this.sectionsDocImpression={},this.updateSignal({type:"webpage_load"}),this.timeoutPingback()},r.prototype.streamScrollingHandler=function(e){this.updateSignal({type:"webpage_continuation",index:e.index}),this.timeoutPingback()},r.prototype.documentShareHandler=function(e){this.updateSignal({type:"document_share",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),service:e.service}),this.executePingback()},r.prototype.documentDownloadHandler=function(e){var t={type:"document_download",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase()};e.anonymous&&this.environment.username?this.generateAndExecuteAnonymousPingback(t):(this.updateSignal(t),this.timeoutPingback())},r.prototype.getDocImpForSection=function(e){return this.sectionsDocImpression[e]=this.sectionsDocImpression[e]||{}},r.prototype.streamDocumentLoadHandler=function(e){if(e.section){var t=this.getDocImpForSection(e.section),n=e.publicationId;if(t[n])return;t[n]=!0}this.updateSignal({type:"document_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),ad_id:e.adpageId||null,page:e.pageNumber,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking}),this.timeoutPingback()},r.prototype.streamDocumentClickHandler=function(e){this.updateSignal({type:"document_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),ad_id:e.adpageId||null,ad_token:e.adpageToken||null,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking,click_coordinates:e.clickCoordinates||null}),this.executePingback()},r.prototype.infoboxLoadHandler=function(e){this.updateSignal({type:"infobox_impression",id:e.infoboxId,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking}),this.timeoutPingback()},r.prototype.infoboxClickHandler=function(e){this.updateSignal({type:"infobox_click",id:e.infoboxId,link:e.link,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking,click_coordinates:e.clickCoordinates||null}),this.executePingback()},r.prototype.curatedLoadHandler=function(e){this.updateSignal({type:"curated_impression",source:e.source,link:e.link,ranking:e.ranking}),this.timeoutPingback()},r.prototype.curatedClickHandler=function(e){this.updateSignal({type:"curated_click",source:e.source,link:e.link,ranking:e.ranking}),this.executePingback()},r.prototype.embedLoadHandler=function(e){this.updateSignal({type:"embed_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),embed_id:e.embedId}),this.executePingback()},r.prototype.embedClickHandler=function(e){this.updateSignal({type:"embed_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),embed_id:e.embedId}),this.executePingback()},r.prototype.streamAdRequestHandler=function(e){this.updateSignal({type:"stream_ad_request",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking}),this.timeoutPingback()},r.prototype.streamAdInsertedHandler=function(e){this.updateSignal({type:"stream_ad_inserted",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking,timespan:e.timespan}),this.timeoutPingback()},r.prototype.streamAdNotAvailableHandler=function(e){this.updateSignal({type:"stream_ad_not_available",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking,timespan:e.timespan}),this.timeoutPingback()},r.prototype.streamAdImpressionHandler=function(e){this.updateSignal({type:"stream_ad_impression",ad_provider:e.adProvider,placement:e.placement,stream_origin:e.streamOrigin,ranking:e.ranking}),this.timeoutPingback()},r.prototype.flushHandler=function(e){this.executePingback()},r.prototype.handlers=function(){return{webpageLoad:this.webpageLoadHandler,streamScrolling:this.streamScrollingHandler,documentShare:this.documentShareHandler,documentDownload:this.documentDownloadHandler,streamDocumentLoad:this.streamDocumentLoadHandler,streamDocumentClick:this.streamDocumentClickHandler,infoboxLoad:this.infoboxLoadHandler,infoboxClick:this.infoboxClickHandler,curatedLoad:this.curatedLoadHandler,curatedClick:this.curatedClickHandler,embedLoad:this.embedLoadHandler,embedClick:this.embedClickHandler,streamAdRequest:this.streamAdRequestHandler,streamAdInserted:this.streamAdInsertedHandler,streamAdNotAvailable:this.streamAdNotAvailableHandler,streamAdImpression:this.streamAdImpressionHandler,flush:this.flushHandler}},e.exports.WebsiteSignalHandler=r},function(e,t,n){function r(){var e=[];return e.push("diic:"+u),e.push("dcic:"+c),e.push("dmo:"+l),e.push(n(12).getDebugString()),"("+e.join()+")"}function i(e){return{version:"1.3.3",username:e.getUsername(),ui_language:e.getLanguage(),location:e.getLocation(),referrer:e.getReferrer(),source:e.getSource(),contexts:[]}}function o(e,t){var n=e.data.contexts.length;if(0===n)return!0;var r=!1;return s.forEach(["doc_id","doc_creator","doc_name","ad_id","ad_token","embed_id","display_size","stream_origin","stream_ranking"],function(i){r=r||e.data.contexts[n-1][i]!==t[i]}),r=r||e.data.contexts[n-1].pages.toString()!==t.pages.toString()}function a(e,t,n,r,i,o,a){this.handleError=e,this.wrapper=t,this.post=n,this.environment=r,this.setTimeout=i,this.clearTimeout=o,this.nagleTimeout=a}var s=n(3),u=0,c=0,l=null;a.prototype.initializeModel=function(e){u++,this.model={doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),pages:e.pages,pageNumber:e.pageNumber,ad_id:e.adpageId||null,ad_token:e.adpageToken||null,is_embed:e.isEmbed,embed_id:e.embedId||null,display_size:e.displaySize||this.environment.getBrowserSize(),is_fullscreen:e.isFullscreen,stream_origin:e.streamOrigin||null,stream_ranking:e.streamRanking,user_interacted:!1},l=this.model},a.prototype.clearModel=function(){c++,this.executePingback(),this.model=void 0},a.prototype.updateModel=function(e){this.model?(this.model.pages=e.pages||this.model.pages,this.model.display_size=e.displaySize||this.model.display_size,this.model.is_fullscreen=void 0!==e.isFullscreen?e.isFullscreen:this.model.is_fullscreen,this.model.user_interacted=e.userInteracted||this.model.user_interacted):this.handleError(new Error("reader pingback handler - update model - no model."+r()))},a.prototype.executePingbackIfPlatformHasChanged=function(){if(this.signal){var e=!1,t=i(this.environment);s.forEach(["version","username","location","referrer","source"],function(n){e=e||this.signal.data[n]!==t[n]},this),e&&this.executePingback()}},a.prototype.viewportHasUserAttention=function(){if(this.model)return!this.model.is_embed||this.model.is_fullscreen||this.model.user_interacted;this.handleError(new Error("reader pingback handler - viewportHasUserAttention - no model."+r()))},a.prototype.updateSignal=function(e){if(!this.model)return void this.handleError(new Error("reader pingback handler - update signal - no model."+r()));if(this.executePingbackIfPlatformHasChanged(),this.signal=this.signal||this.wrapper.getSignalWrapper("reader"),this.signal.data=this.signal.data||i(this.environment),o(this.signal,this.model)&&this.signal.data.contexts.push({doc_id:this.model.doc_id,doc_creator:this.model.doc_creator,doc_name:this.model.doc_name,pages:this.model.pages,ad_id:this.model.ad_id,ad_token:this.model.ad_token,embed_id:this.model.embed_id,display_size:this.model.display_size,display_state:null,stream_origin:this.model.stream_origin,stream_ranking:this.model.stream_ranking,events:[]}),e){var t=this.signal.data.contexts.length;t>0?this.signal.data.contexts[t-1].events.push(e):this.handleError(new Error("reader pingback handler context length invalid."))}},a.prototype.getCurrentPages=function(){if(this.model)return this.model.pages;this.handleError(new Error("reader pingback handler - get current pages - no model."+r()))},a.prototype.timeoutPingback=function(){if(this.signal){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0);for(var e=0,t=this.signal.data.contexts.length-1;t>=0;t--)e+=this.signal.data.contexts[t].events.length;e>=20?this.executePingback():this.timeoutId=this.setTimeout(this.executePingback.bind(this),this.nagleTimeout)}},a.prototype.executePingback=function(){this.timeoutId&&(this.clearTimeout(this.timeoutId),this.timeoutId=void 0),this.signal&&(this.post(this.signal),this.signal=void 0)},e.exports.ReaderSignalHandler=a},function(e,t){function n(e,t,n){this.readerSignalHandler=e,this.setTimeout=t,this.clearTimeout=n,this.eventsAfterDocumentRead=[],this.documentReadTimeoutId=void 0,this.documentReadTriggered=!1,this.pageReadLastPages=null,this.pageReadStartTime=null,this.pageReadLastEndTime=null,this.delays=null,this.pageReadTimeTimeoutId=void 0,this.idleTimeoutId=void 0}var r=[2e3,3e3,4e3,6e3,8e3,12e3],i=0;n.prototype.setUpPageReadTimers=function(){this.delays=r.slice(0),this.pageReadStartTime=this.pageReadLastEndTime=(new Date).getTime(),this.startPageReadTimer()},n.prototype.startPageReadTimer=function(){this.pageReadTimeTimeoutId=this.setTimeout(function(){this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime(),this.startPageReadTimer()}.bind(this),this.getNextPageReadTimeout())},n.prototype.startIdleTimer=function(){this.idleTimeoutId=this.setTimeout(function(){this.idleTimeoutId=void 0,void 0!==this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime())}.bind(this),6e5)},n.prototype.resetIdleTimer=function(){void 0!==this.idleTimeoutId?(this.clearTimeout(this.idleTimeoutId),this.idleTimeoutId=void 0):this.readerSignalHandler.viewportHasUserAttention()&&(this.pageReadLastEndTime=(new Date).getTime(),this.delays?this.startPageReadTimer():this.setUpPageReadTimers()),this.startIdleTimer()},n.prototype.clearTimers=function(){void 0!==this.idleTimeoutId&&(this.clearTimeout(this.idleTimeoutId),this.idleTimeoutId=void 0),void 0!==this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime()),void 0!==this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0)},n.prototype.getNextPageReadTimeout=function(){var e=this.delays.shift();if(isNaN(e)){return r[r.length-1]+.2*((new Date).getTime()-this.pageReadStartTime)}return e},n.prototype.trackDocumentImpression=function(e){this.readerSignalHandler.updateSignal({type:"document_impression"}),this.readerSignalHandler.timeoutPingback()},n.prototype.trackDocumentRead=function(){for(;this.eventsAfterDocumentRead.length>0;)this.readerSignalHandler.updateSignal(this.eventsAfterDocumentRead.shift());this.readerSignalHandler.updateSignal({type:"document_read"}),this.readerSignalHandler.executePingback(),this.documentReadTriggered=!0,this.documentReadTimeoutId=void 0},n.prototype.trackPageImpression=function(e){for(var t in e.pages){this.readerSignalHandler.updateSignal({type:"page_impression",page:e.pages[t]})}this.readerSignalHandler.timeoutPingback()},n.prototype.maybeTrackPageRead=function(){var e=this.readerSignalHandler.getCurrentPages(),t=JSON.stringify(e);if(this.pageReadLastPages!==t){this.pageReadLastPages=t;for(var n in e){var r={type:"page_read",page:e[n]};this.documentReadTriggered?this.readerSignalHandler.updateSignal(r):this.eventsAfterDocumentRead.push(r)}this.readerSignalHandler.timeoutPingback()}},n.prototype.trackPageReadTime=function(){var e=(new Date).getTime(),t=this.readerSignalHandler.getCurrentPages(),n=Math.floor((e-this.pageReadLastEndTime)/t.length);if(!(n<=0)){for(var r in t){var i={type:"page_read_time",time_increment:n,page:t[r]};this.documentReadTriggered?this.readerSignalHandler.updateSignal(i):this.eventsAfterDocumentRead.push(i)}this.pageReadLastEndTime=e,this.readerSignalHandler.timeoutPingback()}},n.prototype.maybeStartDocumentReadTimer=function(){void 0!==this.documentReadTimeoutId||this.documentReadTriggered||(this.documentReadTimeoutId=this.setTimeout(function(){this.trackDocumentRead()}.bind(this),2e3))},n.prototype.documentLoad=function(e){i++,this.clearTimers(),this.eventsAfterDocumentRead=[],this.readerSignalHandler.initializeModel(e),this.trackDocumentImpression(e),this.trackPageImpression(e),this.readerSignalHandler.viewportHasUserAttention()&&(this.maybeStartDocumentReadTimer(),this.maybeTrackPageRead(),this.setUpPageReadTimers()),this.startIdleTimer()},n.prototype.documentUnLoad=function(e){this.flush(),this.readerSignalHandler.clearModel()},n.prototype.userInteracted=function(){this.readerSignalHandler.updateModel({userInteracted:!0}),this.resetIdleTimer(),this.readerSignalHandler.viewportHasUserAttention()&&(this.maybeStartDocumentReadTimer(),this.maybeTrackPageRead(),this.setUpPageReadTimers()),void 0!==this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0,this.trackDocumentRead())},n.prototype.pageChange=function(e){this.resetIdleTimer(),void 0!==this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0,this.trackDocumentRead()),void 0!==this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime()),this.readerSignalHandler.updateModel(e),this.trackPageImpression(e),this.readerSignalHandler.viewportHasUserAttention()&&(this.maybeTrackPageRead(),this.setUpPageReadTimers())},n.prototype.zoom=function(e){this.resetIdleTimer()},n.prototype.resize=function(e){this.resetIdleTimer(),this.readerSignalHandler.updateModel(e),this.readerSignalHandler.viewportHasUserAttention()?(this.maybeStartDocumentReadTimer(),void 0===this.pageReadTimeTimeoutId&&this.setUpPageReadTimers(),this.maybeTrackPageRead()):(this.documentReadTimeoutId&&(this.clearTimeout(this.documentReadTimeoutId),this.documentReadTimeoutId=void 0),this.pageReadTimeTimeoutId&&(this.clearTimeout(this.pageReadTimeTimeoutId),this.pageReadTimeTimeoutId=void 0,this.trackPageReadTime()))},n.prototype.flush=function(e){this.clearTimers(),this.eventsAfterDocumentRead=[],this.readerSignalHandler.executePingback()},n.prototype.handlers=function(){return{documentLoad:this.documentLoad,documentUnLoad:this.documentUnLoad,userInteracted:this.userInteracted,pageChange:this.pageChange,zoom:this.zoom,resize:this.resize,flush:this.flush}},e.exports.DocumentEventsHandler=n,e.exports.getDebugString=function(){return"ddic:"+i}},function(e,t){function n(e){this.readerSignalHandler=e}n.prototype.linkClick=function(e){this.readerSignalHandler.updateSignal({type:"link_click",page:e.pageNumber,url:e.url,link_position:e.linkPosition}),this.readerSignalHandler.executePingback()},n.prototype.watermarkClick=function(e){this.readerSignalHandler.updateSignal({type:"watermark_click",url:e.url}),this.readerSignalHandler.executePingback()},n.prototype.ctaLoad=function(e){this.readerSignalHandler.updateSignal({type:"ad_cta_impression",cta_type:e.type,page:e.pageNumber}),this.readerSignalHandler.timeoutPingback()},n.prototype.ctaClick=function(e){this.readerSignalHandler.updateSignal({type:"ad_cta_click",cta_type:e.type,page:e.pageNumber}),this.readerSignalHandler.executePingback()},n.prototype.flush=function(e){},n.prototype.handlers=function(){return{linkClick:this.linkClick,watermarkClick:this.watermarkClick,ctaLoad:this.ctaLoad,ctaClick:this.ctaClick,flush:this.flush}},e.exports.LinkEventsHandler=n},function(e,t){function n(e){this.readerSignalHandler=e}n.prototype.adpageLoad=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_ad_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,ad_id:e.adpageId,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.timeoutPingback()},n.prototype.adpageClick=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_ad_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),ad_id:e.adpageId,token:e.adpageToken,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.executePingback()},n.prototype.relatedLoad=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_related_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.timeoutPingback()},n.prototype.relatedClick=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_related_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.executePingback()},n.prototype.moreContentDocumentShow=function(e){this.readerSignalHandler.updateSignal({type:"more_content_document_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,stream_origin:e.streamOrigin,stream_ranking:e.streamRanking}),this.readerSignalHandler.timeoutPingback()},n.prototype.moreContentDocumentClick=function(e){this.readerSignalHandler.updateSignal({type:"more_content_document_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),stream_origin:e.streamOrigin,stream_ranking:e.streamRanking}),this.readerSignalHandler.executePingback()},n.prototype.archiveLoad=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_archive_impression",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),page:e.pageNumber,absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.timeoutPingback()},n.prototype.archiveClick=function(e){this.readerSignalHandler.updateSignal({type:"sidebar_archive_click",doc_id:e.revisionId+"-"+e.publicationId,doc_creator:e.ownerUsername.toLowerCase(),doc_name:e.publicationName.toLowerCase(),absolute_position:e.absolutePosition,relative_position:e.relativePosition}),this.readerSignalHandler.executePingback()},n.prototype.flush=function(e){},n.prototype.handlers=function(){return{adpageLoad:this.adpageLoad,adpageClick:this.adpageClick,relatedLoad:this.relatedLoad,relatedClick:this.relatedClick,archiveLoad:this.archiveLoad,archiveClick:this.archiveClick,moreContentDocumentShow:this.moreContentDocumentShow,moreContentDocumentClick:this.moreContentDocumentClick,flush:this.flush}},e.exports.SidebarHandler=n},function(e,t){function n(e){this.readerSignalHandler=e}n.prototype.clippingLayer=function(e){this.readerSignalHandler.updateSignal({type:"clipping_layer",action:e.action}),this.readerSignalHandler.timeoutPingback()},n.prototype.clippingAction=function(e){this.readerSignalHandler.updateSignal({type:"clipping_action",clippingId:e.clippingId,action:e.action,on_page:e.onPage,creator:e.creator,url:e.url,page:e.page,service:e.service,videoid:e.videoid,opened_in_reader:e.opened_in_reader}),this.readerSignalHandler.timeoutPingback()},n.prototype.clippingComment=function(e){this.readerSignalHandler.updateSignal({type:"clipping_comment",clippingId:e.clippingId,commentId:e.commentId,action:e.action,on_page:e.onPage,creator:e.creator,url:e.url}),this.readerSignalHandler.timeoutPingback()},n.prototype.flush=function(e){},n.prototype.handlers=function(){return{clippingLayer:this.clippingLayer,clippingAction:this.clippingAction,clippingComment:this.clippingComment,flush:this.flush}},e.exports.ClipEventsHandler=n},function(e,t){function n(e,t,n){var r="//"+d+e;n="string"==typeof n?n:JSON.stringify(n),window.fetch?window.fetch(r,{method:"post",headers:t,credentials:"include",body:n}).catch(function(t){console.log("frontend-tracking POST to "+d+e+" failed:",t)}):window.jQuery&&window.jQuery.ajax&&window.jQuery.ajax({type:"POST",url:r,data:n,crossDomain:!0,headers:t,xhrFields:{withCredentials:!0}}).fail(function(t){console.log("frontend-tracking POST to "+d+e+" failed:",t)})}function r(e){var t=window.Raven;t&&t.captureException?t.captureException(e):console.error(e)}function i(){var e=document.cookie.match(/site\.model\.username=([^;$]+)/);return e&&e.length>=2?e[1]:null}function o(){return window.innerWidth?window.innerWidth:window.document.documentElement&&window.document.documentElement.clientWidth?window.document.documentElement.clientWidth:window.document.body?window.document.body.clientWidth:0}function a(){return window.innerHeight?window.innerHeight:window.document.documentElement&&window.document.documentElement.clientHeight?window.document.documentElement.clientHeight:window.document.body?window.document.body.clientHeight:0}function s(){return window.location.href.toString()}function u(){return window.document.referrer||null}function c(){return(window.document.referrer||"").indexOf("issuu.com")!==-1?"internal":"external"}function l(){return"web"}function p(){return document.documentElement.lang||null}var d;d=__issuuConfig&&__issuuConfig.production&&"issuu"===__issuuConfig.tracking.settings?"pingback.issuu.com":"pingback.tissuu.com",e.exports={post:n,handleError:r,getWidth:o,getHeight:a,getUsername:i,getLocation:s,getReferrer:u,getSource:c,getLanguage:p,getOrigin:l,setTimeout:function(e,t){return window.setTimeout(e,t)},clearTimeout:function(e){return window.clearTimeout(e)},setInterval:function(e,t){return window.setInterval(e,t)},clearInterval:function(e){return window.clearInterval(e)},nagleTimeout:1500}}])},function(e,t,n){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(8)},,,function(e,t){e.exports=n(2)},function(e,t){e.exports=n(21)},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(6),i=function(e){return e&&e.__esModule?e:{default:e}}(r);t.default=function(e){return i.default.bind(null,e)},e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function i(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function o(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var a=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},s=n(3),u=r(s),c=n(7),l=r(c),p=function(e){var t=parseInt(l.default["ixu-base-size"].replace("px",""),10);switch(e){case"small":return t/2+"px";case"normal":return t+"px";case"large":return 2*t+"px";case"none":return 0;default:return null}},d=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(t.style)return u.default.createElement(e,t);var n=t.spacing,r=t.spacingVertical,s=t.spacingHorizontal,c=t.spacingLeft,l=t.spacingRight,d=t.spacingTop,f=t.spacingBottom,h=o(t,["spacing","spacingVertical","spacingHorizontal","spacingLeft","spacingRight","spacingTop","spacingBottom"]),m={top:d||r||n,right:l||s||n,bottom:f||r||n,left:c||s||n},g=Object.keys(m).reduce(function(e,t){return Object.assign(e,i({},t,p(m[t])))},{});return u.default.createElement(e,a({},h,{style:{marginTop:g.top,marginRight:g.right,marginBottom:g.bottom,marginLeft:g.left}}))};d.propTypes={spacing:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingBottom:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingHorizontal:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingLeft:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingRight:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingTop:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingVertical:u.default.PropTypes.oneOf(["none","small","normal","large"])},t.default=d,e.exports=t.default},function(e,t){e.exports={"ixu-base-size":"12px","ixu-base-duration":"150ms"}},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0});var i=n(9),o=r(i);t.default=(0,r(n(5)).default)(o.default),e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function i(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var o=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},a=n(3),s=r(a),u=n(4),c=r(u),l=function(e){var t=e.actionState,n=e.children,r=e.extraClass,a=e.href,u=e.htmlType,l=e.isDisabled,p=e.isOutlined,d=e.isRounded,f=e.look,h=e.size,m=e.onClick,g=i(e,["actionState","children","extraClass","href","htmlType","isDisabled","isOutlined","isRounded","look","size","onClick"]),v=(0,c.default)("ixu-button",r,{"ixu-button--discreet":"discreet"===f,"ixu-button--positive":"positive"===f,"ixu-button--pronounced":"pronounced"===f,"ixu-button--danger":"danger"===f,"ixu-button--large":"large"===h,"ixu-button--rounded":d,"ixu-button--outline":p,"is-done":"done"===t,"is-error":"error"===t,"is-loading":"loading"===t});return s.default.createElement(a?"a":"button",o({},g,{type:a?null:u,href:a,className:v,onClick:function(e){return m(e)},disabled:l||t}),n)};l.defaultProps={look:"default",htmlType:"button",isDisabled:!1,isOutlined:!1,isRounded:!1,onClick:function(){}},l.propTypes={actionState:s.default.PropTypes.oneOf(["done","error","loading"]),extraClass:s.default.PropTypes.string,href:s.default.PropTypes.string,htmlType:s.default.PropTypes.oneOf(["button","reset","submit"]),isDisabled:s.default.PropTypes.bool,isOutlined:s.default.PropTypes.bool,isRounded:s.default.PropTypes.bool,look:s.default.PropTypes.oneOf(["default","discreet","positive","pronounced","danger"]),onClick:s.default.PropTypes.func,size:s.default.PropTypes.oneOf(["default","large"])},l.displayName="Button",t.default=l,e.exports=t.default}])},function(e,t,n){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(12)},,,function(e,t){e.exports=n(2)},function(e,t){e.exports=n(21)},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(6),i=function(e){return e&&e.__esModule?e:{default:e}}(r);t.default=function(e){return i.default.bind(null,e)},e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function i(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function o(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var a=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},s=n(3),u=r(s),c=n(7),l=r(c),p=function(e){var t=parseInt(l.default["ixu-base-size"].replace("px",""),10);switch(e){case"small":return t/2+"px";case"normal":return t+"px";case"large":return 2*t+"px";case"none":return 0;default:return null}},d=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(t.style)return u.default.createElement(e,t);var n=t.spacing,r=t.spacingVertical,s=t.spacingHorizontal,c=t.spacingLeft,l=t.spacingRight,d=t.spacingTop,f=t.spacingBottom,h=o(t,["spacing","spacingVertical","spacingHorizontal","spacingLeft","spacingRight","spacingTop","spacingBottom"]),m={top:d||r||n,right:l||s||n,bottom:f||r||n,left:c||s||n},g=Object.keys(m).reduce(function(e,t){return Object.assign(e,i({},t,p(m[t])))},{});return u.default.createElement(e,a({},h,{style:{marginTop:g.top,marginRight:g.right,marginBottom:g.bottom,marginLeft:g.left}}))};d.propTypes={spacing:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingBottom:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingHorizontal:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingLeft:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingRight:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingTop:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingVertical:u.default.PropTypes.oneOf(["none","small","normal","large"])},t.default=d,e.exports=t.default},function(e,t){e.exports={"ixu-base-size":"12px","ixu-base-duration":"150ms"}},,,,,function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0});var i=n(13),o=r(i);t.default=(0,r(n(5)).default)(o.default),e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function i(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var o=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},a=n(3),s=r(a),u=n(4),c=r(u),l=function(e){var t=e.children,n=e.extraClass,r=e.size,a=e.look,u=e.tag,l=e.weight,p=i(e,["children","extraClass","size","look","tag","weight"]),d=(0,c.default)("ixu-heading",n,{"ixu-heading--pronounced":"pronounced"===a,"ixu-heading--issuu-brand":"issuu-brand"===a,"ixu-heading--light":"light"===l,"ixu-heading--semibold":"semibold"===l,"ixu-heading--bold":"bold"===l,"ixu-heading--hero":"hero"===r,"ixu-heading--huge":"huge"===r,"ixu-heading--large":"large"===r,"ixu-heading--small":"small"===r,"ixu-heading--tiny":"tiny"===r});return s.default.createElement(u,o({},p,{className:d}),t)};l.defaultProps={size:"default",look:"default",tag:"div",weight:"normal"},l.propTypes={extraClass:s.default.PropTypes.string,look:s.default.PropTypes.oneOf(["default","pronounced","issuu-brand"]),size:s.default.PropTypes.oneOf(["default","hero","huge","large","small","tiny"]),tag:s.default.PropTypes.oneOf(["div","h1","h2","h3","h4","h5","h6","span"]),weight:s.default.PropTypes.oneOf(["bold","light","normal","semibold"])},l.displayName="Heading",t.default=l,e.exports=t.default}])},function(e,t,n){e.exports=function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(18)},,,function(e,t){e.exports=n(2)},function(e,t){e.exports=n(21)},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(6),i=function(e){return e&&e.__esModule?e:{default:e}}(r);t.default=function(e){return i.default.bind(null,e)},e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function i(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function o(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var a=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},s=n(3),u=r(s),c=n(7),l=r(c),p=function(e){var t=parseInt(l.default["ixu-base-size"].replace("px",""),10);switch(e){case"small":return t/2+"px";case"normal":return t+"px";case"large":return 2*t+"px";case"none":return 0;default:return null}},d=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(t.style)return u.default.createElement(e,t);var n=t.spacing,r=t.spacingVertical,s=t.spacingHorizontal,c=t.spacingLeft,l=t.spacingRight,d=t.spacingTop,f=t.spacingBottom,h=o(t,["spacing","spacingVertical","spacingHorizontal","spacingLeft","spacingRight","spacingTop","spacingBottom"]),m={top:d||r||n,right:l||s||n,bottom:f||r||n,left:c||s||n},g=Object.keys(m).reduce(function(e,t){return Object.assign(e,i({},t,p(m[t])))},{});return u.default.createElement(e,a({},h,{style:{marginTop:g.top,marginRight:g.right,marginBottom:g.bottom,marginLeft:g.left}}))};d.propTypes={spacing:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingBottom:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingHorizontal:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingLeft:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingRight:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingTop:u.default.PropTypes.oneOf(["none","small","normal","large"]),spacingVertical:u.default.PropTypes.oneOf(["none","small","normal","large"])},t.default=d,e.exports=t.default},function(e,t){e.exports={"ixu-base-size":"12px","ixu-base-duration":"150ms"}},,,,,,,,,,,function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(t,"__esModule",{value:!0});var i=n(19),o=r(i);t.default=(0,r(n(5)).default)(o.default),e.exports=t.default},function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{default:e}}function i(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}Object.defineProperty(t,"__esModule",{value:!0});var o=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},a=n(3),s=r(a),u=n(4),c=r(u),l=function(e){var t=e.children,n=e.extraClass,r=e.look,a=e.size,u=e.onClick,l=e.weight,p=i(e,["children","extraClass","look","size","onClick","weight"]),d=(0,c.default)("ixu-paragraph",n,{"ixu-paragraph--pronounced":"pronounced"===r,"ixu-paragraph--issuu-brand":"issuu-brand"===r,"ixu-paragraph--huge":"huge"===a,"ixu-paragraph--large":"large"===a,"ixu-paragraph--small":"small"===a,"ixu-paragraph--tiny":"tiny"===a,"ixu-paragraph--bold":"bold"===l,"ixu-paragraph--light":"light"===l,"ixu-paragraph--semibold":"semibold"===l});return s.default.createElement("p",o({},p,{className:d,onClick:u}),t)};l.defaultProps={look:"default",size:"medium",weight:"normal"},l.propTypes={children:s.default.PropTypes.node.isRequired,extraClass:s.default.PropTypes.string,look:s.default.PropTypes.oneOf(["default","pronounced","issuu-brand"]),onClick:s.default.PropTypes.func,size:s.default.PropTypes.oneOf(["huge","large","medium","small","tiny"]),weight:s.default.PropTypes.oneOf(["bold","light","normal","semibold"])},l.displayName="Paragraph",t.default=l,e.exports=t.default}])},function(e,t,n){"use strict";function r(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=t.thousandsSeparator,r=void 0===n?" ":n,i=t.precision,o=void 0===i?2:i,a=t.decimalSeparator,u=void 0===a?".":a,c=t.currencySymbol,l=void 0===c?"$":c,p=t.suffix,d=void 0===p?"USD":p,f=t.showExact,h=void 0!==f&&f,m=t.showShort,g=void 0!==m&&m,v=e;!isNaN(parseInt(e,10))&&e||(v=0);var b=o+1,y=s(""+v,b,"0"),_=y.slice(y.length-o),w=0!==parseInt(_,10),E=o&&(h||!h&&w),x=y.slice(0,y.length-o).split("").reduce(function(e,t,n,i){var o=i.length-n-1;return 0!==o&&o%3==0?""+e+t+r:""+e+t},""),S=g?l:"",T=g?"":" "+d;return(""+S+x+(E?u:"")+(E?_:"")).trim()+""+T}function i(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=t.thousandsSeparator,r=void 0===n?" ":n,i=t.decimalSeparator,o=void 0===i?".":i,a=t.currencySymbol,s=void 0===a?"$":a,u=t.precision,c=void 0===u?2:u,l=t.suffix,p=void 0===l?"USD":l,d=0===c||String(e).indexOf(o)!==-1,f=String(e).trim().replace(" "+p,"").concat(d?"":Array(c+1).join("0")).replace(s,"").replace(r,"").replace(o,"").trim();return parseInt(f,10)||0}function o(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=u[t.currency||"USD"]||u.USD;return r(e,{currencySymbol:n.symbol,precision:n.precision,suffix:t.currency in u?t.currency:"USD",showExact:t.showExact,showShort:t.showShort})}function a(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=u[t.currency||"USD"]||u.USD;return i(e,{currencySymbol:n.symbol,precision:n.precision,suffix:t.currency in u?t.currency:"USD"})}Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){return e&&"object"==typeof e&&"default"in e?e.default:e}(n(740)),u={USD:{symbol:"$",precision:2},EUR:{symbol:"€",precision:2}};t.formatCurrency=o,t.unformatCurrency=a},function(e,t,n){"use strict";function r(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:console;return function(r){if(!r||Array.isArray(r)&&0===r.length)return Promise.resolve();var i=Array.isArray(r)?r:[r],s=i.map(function(e){return Object.assign({version:"1.0.0"},e)});return a({type:"monitor",version:"2.2.0",origin:o,data:s},e,t,n)}}function i(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:console;return function(r,i,s){if(!r||Array.isArray(r)&&0===r.length)return Promise.resolve();var u=Object.assign({},i,{browser_size:window.innerWidth+"x"+window.innerWidth,events:Array.isArray(r)?r:[r]}),c={type:"website",version:"2.2.0",origin:o,data:{username:document.cookie.replace(/(?:(?:^|.*;\s*)site.model.username\s*\=\s*([^;]*).*$)|^.*$/,"$1")||null,ui_language:document.documentElement.lang||null,location:window.location.href.toString(),referrer:s||document.referrer||null,version:"2.2.2",contexts:[u]}};return a(c,e,t,n)}}Object.defineProperty(t,"__esModule",{value:!0});var o="issuu-libs-tracking-micro-v2.2.0",a=function(e,t,n,r){return n(t,{method:"post",credentials:"include",headers:{Accept:"application/json","Content-Type":"application/json"},body:JSON.stringify(e)}).catch(function(t){return r.error(e.type+" pingback failed:",t)})};t.initMonitor=r,t.initWebsite=i},function(e,t,n){"use strict";n.d(t,"b",function(){return f}),n.d(t,"a",function(){return d});var r=n(2),i=n.n(r),o=n(620),a=n.n(o),s=n(619),u=n.n(s),c=n(621),l=n.n(c),p=n(622),d=(n.n(p),function(e){var t=e.hostName,r=e.publisherName,o=e.publicationName,a=e.price,s=e.referrer,c=void 0===s?"reader.button":s,l=a?i.a.createElement("span",null,n.i(p.formatCurrency)(a)):null;return i.a.createElement(u.a,{look:"positive",href:"https://"+t+"/store/publishers/"+r+"/docs/"+o+"?r="+c,target:"_blank"},"Buy ",l)});d.propTypes={hostName:r.PropTypes.string.isRequired,price:r.PropTypes.number,publicationName:r.PropTypes.string.isRequired,publisherName:r.PropTypes.string.isRequired,referrer:r.PropTypes.string};var f=function(e){var t=e.hostName,n=e.onKeepReading,r=e.price,o=e.publicationCoverUrl,s=e.publicationName,c=e.publicationTitle,p=e.publisherDisplayName,f=e.publisherName,h=e.publisherProfileImageUrl,m=e.publisherProfileUrl,g=e.showKeepReading;return i.a.createElement("div",{className:"PaywallOverlay ixu-cascading-fluid-typography ixu-cascading-theme-inverse"},i.a.createElement("div",{className:"PaywallOverlay-content"},i.a.createElement("div",{className:"PaywallOverlay-cover"},i.a.createElement("div",{className:"PaywallOverlay-coverWrapper"},i.a.createElement("img",{src:o,alt:"Cover of "+c}))),i.a.createElement("div",{className:"PaywallOverlay-info"},i.a.createElement(a.a,{weight:"light",look:"pronounced"},"Unlock full access to"),i.a.createElement(a.a,{weight:"bold",look:"pronounced",spacingBottom:"large"},c),i.a.createElement("div",{className:"PaywallOverlay-actions"},i.a.createElement(d,{hostName:t,publisherName:f,publicationName:s,price:r,referrer:"reader.overlay"}),g&&i.a.createElement(u.a,{isOutlined:!0,onClick:n},"Keep reading")),i.a.createElement("div",{className:"PaywallOverlay-publisher"},i.a.createElement("div",{className:"PaywallOverlay-publisherImage"},i.a.createElement("img",{src:h,alt:"Avatar of "+p})),i.a.createElement("div",null,i.a.createElement(l.a,null,"Published by"),i.a.createElement(l.a,{size:"large",weight:"bold"},i.a.createElement("a",{href:m,target:"_blank",rel:"noopener noreferrer"},p)))))))};f.propTypes={hostName:r.PropTypes.string.isRequired,onKeepReading:r.PropTypes.func.isRequired,price:r.PropTypes.number,publicationCoverUrl:r.PropTypes.string.isRequired,publicationName:r.PropTypes.string.isRequired,publicationTitle:r.PropTypes.string.isRequired,publisherDisplayName:r.PropTypes.string.isRequired,publisherName:r.PropTypes.string.isRequired,publisherProfileImageUrl:r.PropTypes.string.isRequired,publisherProfileUrl:r.PropTypes.string.isRequired,showKeepReading:r.PropTypes.bool}},function(e,t,n){function r(){}function i(e){var t,n=e.config.network,i=e.rootElm.getAttribute("id")||"div-"+Math.round(1e4*Math.random());!function(){var s=e.targeting||[];if(a.log("ads","widget","gpt","addPlacementWithTargeting",n,s),e.callbacks=Object.assign({onAdFilled:r,onAdViewable:r,onAdFailed:r,onAdUnfilled:r},e.callbacks),a.log("ads","widget","gpt","create",e),!n)return void e.callbacks.onAdFailed();t=o.create({onError:e.callbacks.onAdFailed}),e.rootElm.setAttribute("id",i),t.addPlacement(i,n,e.config.sizes,s),a.log("ads","widget","gpt","addPlacement",i,n,e.config.sizes,s),t.addEventListener("slotRenderEnded",function(t){t.slot.getSlotElementId()===i&&(a.log("ads","widget","gpt","slotRendered",t),t.isEmpty?e.callbacks.onAdUnfilled():e.callbacks.onAdFilled())}),t.addEventListener("impressionViewable",function(t){t.slot.getSlotElementId()===i&&(a.log("ads","widget","gpt","impressionViewable",t),e.callbacks.onAdViewable())})}()}var o=n(617),a=n(171);t.create=i},function(e,t,n){var r=n(171),i=n(623).initMonitor;t.create=function(e){function t(e,t){var n={type:l+"-"+e},i={type:l+"."+e,timeElapsed:t,screenWidth:Number(window.innerWidth),screenHeight:Number(window.innerHeight),screenResolution:Number(window.innerHeight)*Number(window.innerWidth)};r.log("ads","pingback",i),p([i,n])}function n(e){t("requested",e)}function o(e){t("failed",e)}function a(e){t("filled",e)}function s(e){t("viewable",e)}function u(e){t("timeout",e)}function c(e){t("unfilled",e)}var l,p;return function(){p=e&&e.isProductionEnv===!0?i("//pingback.issuu.com/ping",window.fetch):i("//pingback.tissuu.com/ping",window.fetch),l=e&&e.trackingKey||"ads-widget"}(),{adRequested:n,adFailed:o,adLoaded:a,adViewable:s,adTimeout:u,adUnfilled:c}}},function(e,t,n){"use strict";function r(e){return null==e?void 0===e?u:s:c&&c in Object(e)?n.i(o.a)(e):n.i(a.a)(e)}var i=n(265),o=n(630),a=n(631),s="[object Null]",u="[object Undefined]",c=i.a?i.a.toStringTag:void 0;t.a=r},function(e,t,n){"use strict";(function(e){var n="object"==typeof e&&e&&e.Object===Object&&e;t.a=n}).call(t,n(34))},function(e,t,n){"use strict";t.a=n.i(n(632).a)(Object.getPrototypeOf,Object)},function(e,t,n){"use strict";function r(e){var t=a.call(e,u),n=e[u];try{e[u]=void 0}catch(e){}var r=s.call(e);return t?e[u]=n:delete e[u],r}var i=n(265),o=Object.prototype,a=o.hasOwnProperty,s=o.toString,u=i.a?i.a.toStringTag:void 0;t.a=r},function(e,t,n){"use strict";function r(e){return o.call(e)}var i=Object.prototype,o=i.toString;t.a=r},function(e,t,n){"use strict";function r(e,t){return function(n){return e(t(n))}}t.a=r},function(e,t,n){"use strict";var r=n(628),i="object"==typeof self&&self&&self.Object===Object&&self;t.a=r.a||i||Function("return this")()},function(e,t,n){"use strict";function r(e){return null!=e&&"object"==typeof e}t.a=r},function(e,t){function n(e){return!!e&&"object"==typeof e}function r(e,t){var n=null==e?void 0:e[t];return a(n)?n:void 0}function i(e){return o(e)&&d.call(e)==s}function o(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function a(e){return null!=e&&(i(e)?f.test(l.call(e)):n(e)&&u.test(e))}var s="[object Function]",u=/^\[object .+?Constructor\]$/,c=Object.prototype,l=Function.prototype.toString,p=c.hasOwnProperty,d=c.toString,f=RegExp("^"+l.call(p).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=r},function(e,t){function n(e){return i(e)&&h.call(e,"callee")&&(!g.call(e,"callee")||m.call(e)==l)}function r(e){return null!=e&&a(e.length)&&!o(e)}function i(e){return u(e)&&r(e)}function o(e){var t=s(e)?m.call(e):"";return t==p||t==d}function a(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=c}function s(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function u(e){return!!e&&"object"==typeof e}var c=9007199254740991,l="[object Arguments]",p="[object Function]",d="[object GeneratorFunction]",f=Object.prototype,h=f.hasOwnProperty,m=f.toString,g=f.propertyIsEnumerable;e.exports=n},function(e,t){function n(e){return!!e&&"object"==typeof e}function r(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=h}function i(e){return o(e)&&d.call(e)==s}function o(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function a(e){return null!=e&&(i(e)?f.test(l.call(e)):n(e)&&u.test(e))}var s="[object Function]",u=/^\[object .+?Constructor\]$/,c=Object.prototype,l=Function.prototype.toString,p=c.hasOwnProperty,d=c.toString,f=RegExp("^"+l.call(p).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),h=9007199254740991;e.exports=function(e,t){var n=null==e?void 0:e[t];return a(n)?n:void 0}(Array,"isArray")||function(e){return n(e)&&r(e.length)&&"[object Array]"==d.call(e)}},function(e,t,n){function r(e){return null!=e&&o(v(e))}function i(e,t){return e="number"==typeof e||d.test(e)?+e:-1,t=null==t?g:t,e>-1&&e%1==0&&e<t}function o(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=g}function a(e){for(var t=u(e),n=t.length,r=n&&e.length,a=!!r&&o(r)&&(p(e)||l(e)),s=-1,c=[];++s<n;){var d=t[s];(a&&i(d,r)||h.call(e,d))&&c.push(d)}return c}function s(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function u(e){if(null==e)return[];s(e)||(e=Object(e));var t=e.length;t=t&&o(t)&&(p(e)||l(e))&&t||0;for(var n=e.constructor,r=-1,a="function"==typeof n&&n.prototype===e,u=Array(t),c=t>0;++r<t;)u[r]=r+"";for(var d in e)c&&i(d,t)||"constructor"==d&&(a||!h.call(e,d))||u.push(d);return u}var c=n(635),l=n(636),p=n(637),d=/^\d+$/,f=Object.prototype,h=f.hasOwnProperty,m=c(Object,"keys"),g=9007199254740991,v=function(e){return function(t){return null==t?void 0:t[e]}}("length");e.exports=m?function(e){var t=null==e?void 0:e.constructor;return"function"==typeof t&&t.prototype===e||"function"!=typeof e&&r(e)?a(e):s(e)?m(e):[]}:a},function(e,t,n){"use strict";var r=Object.prototype.hasOwnProperty,i=Object.prototype.toString,o=Array.prototype.slice,a=n(640),s=Object.prototype.propertyIsEnumerable,u=!s.call({toString:null},"toString"),c=s.call(function(){},"prototype"),l=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],p=function(e){var t=e.constructor;return t&&t.prototype===e},d={$console:!0,$external:!0,$frame:!0,$frameElement:!0,$frames:!0,$innerHeight:!0,$innerWidth:!0,$outerHeight:!0,$outerWidth:!0,$pageXOffset:!0,$pageYOffset:!0,$parent:!0,$scrollLeft:!0,$scrollTop:!0,$scrollX:!0,$scrollY:!0,$self:!0,$webkitIndexedDB:!0,$webkitStorageInfo:!0,$window:!0},f=function(){if("undefined"==typeof window)return!1;for(var e in window)try{if(!d["$"+e]&&r.call(window,e)&&null!==window[e]&&"object"==typeof window[e])try{p(window[e])}catch(e){return!0}}catch(e){return!0}return!1}(),h=function(e){if("undefined"==typeof window||!f)return p(e);try{return p(e)}catch(e){return!1}},m=function(e){var t=null!==e&&"object"==typeof e,n="[object Function]"===i.call(e),o=a(e),s=t&&"[object String]"===i.call(e),p=[];if(!t&&!n&&!o)throw new TypeError("Object.keys called on a non-object");var d=c&&n;if(s&&e.length>0&&!r.call(e,0))for(var f=0;f<e.length;++f)p.push(String(f));if(o&&e.length>0)for(var m=0;m<e.length;++m)p.push(String(m));else for(var g in e)d&&"prototype"===g||!r.call(e,g)||p.push(String(g));if(u)for(var v=h(e),b=0;b<l.length;++b)v&&"constructor"===l[b]||!r.call(e,l[b])||p.push(l[b]);return p};m.shim=function(){if(Object.keys){if(!function(){return 2===(Object.keys(arguments)||"").length}(1,2)){var e=Object.keys;Object.keys=function(t){return e(a(t)?o.call(t):t)}}}else Object.keys=m;return Object.keys||m},e.exports=m},function(e,t,n){"use strict";var r=Object.prototype.toString;e.exports=function(e){var t=r.call(e),n="[object Arguments]"===t;return n||(n="[object Array]"!==t&&null!==e&&"object"==typeof e&&"number"==typeof e.length&&e.length>=0&&"[object Function]"===r.call(e.callee)),n}},function(e,t,n){"use strict";function r(e,t,n,r,i){}e.exports=r},function(e,t,n){"use strict";var r=n(32),i=n(1);e.exports=function(){function e(){i(!1,"Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types")}function t(){return e}e.isRequired=e;var n={array:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t};return n.checkPropTypes=r,n.PropTypes=n,n}},function(e,t,n){"use strict";var r=n(32),i=n(1),o=(n(5),n(644)),a=n(641);e.exports=function(e,t){function n(e){var t=e&&(E&&e[E]||e[x]);if("function"==typeof t)return t}function s(e,t){return e===t?0!==e||1/e==1/t:e!==e&&t!==t}function u(e){this.message=e,this.stack=""}function c(e){function n(n,r,a,s,c,l,p){if(s=s||S,l=l||a,p!==o)if(t)i(!1,"Calling PropTypes validators directly is not supported by the `prop-types` package. Use `PropTypes.checkPropTypes()` to call them. Read more at http://fb.me/use-check-prop-types");else;return null==r[a]?n?new u(null===r[a]?"The "+c+" `"+l+"` is marked as required in `"+s+"`, but its value is `null`.":"The "+c+" `"+l+"` is marked as required in `"+s+"`, but its value is `undefined`."):null:e(r,a,s,c,l)}var r=n.bind(null,!1);return r.isRequired=n.bind(null,!0),r}function l(e){function t(t,n,r,i,o,a){var s=t[n];if(y(s)!==e)return new u("Invalid "+i+" `"+o+"` of type `"+_(s)+"` supplied to `"+r+"`, expected `"+e+"`.");return null}return c(t)}function p(e){function t(t,n,r,i,a){if("function"!=typeof e)return new u("Property `"+a+"` of component `"+r+"` has invalid PropType notation inside arrayOf.");var s=t[n];if(!Array.isArray(s)){return new u("Invalid "+i+" `"+a+"` of type `"+y(s)+"` supplied to `"+r+"`, expected an array.")}for(var c=0;c<s.length;c++){var l=e(s,c,r,i,a+"["+c+"]",o);if(l instanceof Error)return l}return null}return c(t)}function d(e){function t(t,n,r,i,o){if(!(t[n]instanceof e)){var a=e.name||S;return new u("Invalid "+i+" `"+o+"` of type `"+w(t[n])+"` supplied to `"+r+"`, expected instance of `"+a+"`.")}return null}return c(t)}function f(e){function t(t,n,r,i,o){for(var a=t[n],c=0;c<e.length;c++)if(s(a,e[c]))return null;return new u("Invalid "+i+" `"+o+"` of value `"+a+"` supplied to `"+r+"`, expected one of "+JSON.stringify(e)+".")}return Array.isArray(e)?c(t):r.thatReturnsNull}function h(e){function t(t,n,r,i,a){if("function"!=typeof e)return new u("Property `"+a+"` of component `"+r+"` has invalid PropType notation inside objectOf.");var s=t[n],c=y(s);if("object"!==c)return new u("Invalid "+i+" `"+a+"` of type `"+c+"` supplied to `"+r+"`, expected an object.");for(var l in s)if(s.hasOwnProperty(l)){var p=e(s,l,r,i,a+"."+l,o);if(p instanceof Error)return p}return null}return c(t)}function m(e){function t(t,n,r,i,a){for(var s=0;s<e.length;s++){if(null==(0,e[s])(t,n,r,i,a,o))return null}return new u("Invalid "+i+" `"+a+"` supplied to `"+r+"`.")}return Array.isArray(e)?c(t):r.thatReturnsNull}function g(e){function t(t,n,r,i,a){var s=t[n],c=y(s);if("object"!==c)return new u("Invalid "+i+" `"+a+"` of type `"+c+"` supplied to `"+r+"`, expected `object`.");for(var l in e){var p=e[l];if(p){var d=p(s,l,r,i,a+"."+l,o);if(d)return d}}return null}return c(t)}function v(t){switch(typeof t){case"number":case"string":case"undefined":return!0;case"boolean":return!t;case"object":if(Array.isArray(t))return t.every(v);if(null===t||e(t))return!0;var r=n(t);if(!r)return!1;var i,o=r.call(t);if(r!==t.entries){for(;!(i=o.next()).done;)if(!v(i.value))return!1}else for(;!(i=o.next()).done;){var a=i.value;if(a&&!v(a[1]))return!1}return!0;default:return!1}}function b(e,t){return"symbol"===e||("Symbol"===t["@@toStringTag"]||"function"==typeof Symbol&&t instanceof Symbol)}function y(e){var t=typeof e;return Array.isArray(e)?"array":e instanceof RegExp?"object":b(t,e)?"symbol":t}function _(e){var t=y(e);if("object"===t){if(e instanceof Date)return"date";if(e instanceof RegExp)return"regexp"}return t}function w(e){return e.constructor&&e.constructor.name?e.constructor.name:S}var E="function"==typeof Symbol&&Symbol.iterator,x="@@iterator",S="<<anonymous>>",T={array:l("array"),bool:l("boolean"),func:l("function"),number:l("number"),object:l("object"),string:l("string"),symbol:l("symbol"),any:function(){return c(r.thatReturnsNull)}(),arrayOf:p,element:function(){function t(t,n,r,i,o){var a=t[n];if(!e(a)){return new u("Invalid "+i+" `"+o+"` of type `"+y(a)+"` supplied to `"+r+"`, expected a single ReactElement.")}return null}return c(t)}(),instanceOf:d,node:function(){function e(e,t,n,r,i){return v(e[t])?null:new u("Invalid "+r+" `"+i+"` supplied to `"+n+"`, expected a ReactNode.")}return c(e)}(),objectOf:h,oneOf:f,oneOfType:m,shape:g};return u.prototype=Error.prototype,T.checkPropTypes=a,T.PropTypes=T,T}},function(e,t,n){"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},function(e,t,n){"use strict";function r(e){this.name="RavenConfigError",this.message=e}r.prototype=new Error,r.prototype.constructor=r,e.exports=r},function(e,t,n){"use strict";e.exports={wrapMethod:function(e,t,n){var r=e[t],i=e;if(t in e){var o="warn"===t?"warning":t;e[t]=function(){var e=[].slice.call(arguments),t=""+e.join(" "),a={level:o,logger:"console",extra:{arguments:e}};n&&n(t,a),r&&Function.prototype.apply.call(r,i,e)}}}}},function(e,t,n){"use strict";(function(t){function r(){return+new Date}function i(){this._hasJSON=!("object"!=typeof JSON||!JSON.stringify),this._hasDocument=!o(A),this._hasNavigator=!o(N),this._lastCapturedException=null,this._lastData=null,this._lastEventId=null,this._globalServer=null,this._globalKey=null,this._globalProject=null,this._globalContext={},this._globalOptions={logger:"javascript",ignoreErrors:[],ignoreUrls:[],whitelistUrls:[],includePaths:[],crossOrigin:"anonymous",collectWindowErrors:!0,maxMessageLength:0,maxUrlLength:250,stackTraceLimit:50,autoBreadcrumbs:!0,sampleRate:1},this._ignoreOnError=0,this._isRavenInstalled=!1,this._originalErrorStackTraceLimit=Error.stackTraceLimit,this._originalConsole=k.console||{},this._originalConsoleMethods={},this._plugins=[],this._startTime=r(),this._wrappedBuiltIns=[],this._breadcrumbs=[],this._lastCapturedEvent=null,this._location=k.location,this._lastHref=this._location&&this._location.href,this._resetBackoff();for(var e in this._originalConsole)this._originalConsoleMethods[e]=this._originalConsole[e]}function o(e){return void 0===e}function a(e){return"function"==typeof e}function s(e){return"[object String]"===D.toString.call(e)}function u(e){for(var t in e)return!1;return!0}function c(e,t){var n,r;if(o(e.length))for(n in e)d(e,n)&&t.call(null,n,e[n]);else if(r=e.length)for(n=0;n<r;n++)t.call(null,n,e[n])}function l(e,t){return t?(c(t,function(t,n){e[t]=n}),e):e}function p(e,t){return!t||e.length<=t?e:e.substr(0,t)+"…"}function d(e,t){return D.hasOwnProperty.call(e,t)}function f(e){for(var t,n=[],r=0,i=e.length;r<i;r++)t=e[r],s(t)?n.push(t.replace(/([.*+?^=!:${}()|\[\]\/\\])/g,"\\$1")):t&&t.source&&n.push(t.source);return new RegExp(n.join("|"),"i")}function h(e){var t=[];return c(e,function(e,n){t.push(encodeURIComponent(e)+"="+encodeURIComponent(n))}),t.join("&")}function m(e){var t=e.match(/^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?$/);return t?{protocol:t[2],host:t[4],path:t[5],relative:t[5]+(t[6]||"")+(t[8]||"")}:{}}function g(){var e=k.crypto||k.msCrypto;if(!o(e)&&e.getRandomValues){var t=new Uint16Array(8);e.getRandomValues(t),t[3]=4095&t[3]|16384,t[4]=16383&t[4]|32768;var n=function(e){for(var t=e.toString(16);t.length<4;)t="0"+t;return t};return n(t[0])+n(t[1])+n(t[2])+n(t[3])+n(t[4])+n(t[5])+n(t[6])+n(t[7])}return"xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0;return("x"===e?t:3&t|8).toString(16)})}function v(e){for(var t,n=[],r=0,i=0,o=" > ".length;e&&r++<5&&!("html"===(t=b(e))||r>1&&i+n.length*o+t.length>=80);)n.push(t),i+=t.length,e=e.parentNode;return n.reverse().join(" > ")}function b(e){var t,n,r,i,o,a=[];if(!e||!e.tagName)return"";if(a.push(e.tagName.toLowerCase()),e.id&&a.push("#"+e.id),(t=e.className)&&s(t))for(n=t.split(/\s+/),o=0;o<n.length;o++)a.push("."+n[o]);var u=["type","name","title","alt"];for(o=0;o<u.length;o++)r=u[o],(i=e.getAttribute(r))&&a.push("["+r+'="'+i+'"]');return a.join("")}function y(e,t){return!!(!!e^!!t)}function _(e,t){return!y(e,t)&&(e=e.values[0],t=t.values[0],e.type===t.type&&e.value===t.value&&w(e.stacktrace,t.stacktrace))}function w(e,t){if(y(e,t))return!1;var n=e.frames,r=t.frames;if(n.length!==r.length)return!1;for(var i,o,a=0;a<n.length;a++)if(i=n[a],o=r[a],i.filename!==o.filename||i.lineno!==o.lineno||i.colno!==o.colno||i.function!==o.function)return!1;return!0}function E(e,t,n,r){var i=e[t];e[t]=n(i),r&&r.push([e,t,i])}var x=n(648),S=n(649),T=n(645),C=n(268),I=C.isError,M=C.isObject,P=n(646).wrapMethod,R="source protocol user pass host port path".split(" "),O=/^(?:(\w+):)?\/\/(?:(\w+)(:\w+)?@)?([\w\.-]+)(?::(\d+))?(\/.*)/,k="undefined"!=typeof window?window:void 0!==t?t:"undefined"!=typeof self?self:{},A=k.document,N=k.navigator;i.prototype={VERSION:"3.14.2",debug:!1,TraceKit:x,config:function(e,t){var n=this;if(n._globalServer)return this._logDebug("error","Error: Raven has already been configured"),n;if(!e)return n;var r=n._globalOptions;t&&c(t,function(e,t){"tags"===e||"extra"===e||"user"===e?n._globalContext[e]=t:r[e]=t}),n.setDSN(e),r.ignoreErrors.push(/^Script error\.?$/),r.ignoreErrors.push(/^Javascript error: Script error\.? on line 0$/),r.ignoreErrors=f(r.ignoreErrors),r.ignoreUrls=!!r.ignoreUrls.length&&f(r.ignoreUrls),r.whitelistUrls=!!r.whitelistUrls.length&&f(r.whitelistUrls),r.includePaths=f(r.includePaths),r.maxBreadcrumbs=Math.max(0,Math.min(r.maxBreadcrumbs||100,100));var i={xhr:!0,console:!0,dom:!0,location:!0},o=r.autoBreadcrumbs;return"[object Object]"==={}.toString.call(o)?o=l(i,o):o!==!1&&(o=i),r.autoBreadcrumbs=o,x.collectWindowErrors=!!r.collectWindowErrors,n},install:function(){var e=this;return e.isSetup()&&!e._isRavenInstalled&&(x.report.subscribe(function(){e._handleOnErrorStackInfo.apply(e,arguments)}),e._instrumentTryCatch(),e._globalOptions.autoBreadcrumbs&&e._instrumentBreadcrumbs(),e._drainPlugins(),e._isRavenInstalled=!0),Error.stackTraceLimit=e._globalOptions.stackTraceLimit,this},setDSN:function(e){var t=this,n=t._parseDSN(e),r=n.path.lastIndexOf("/"),i=n.path.substr(1,r);t._dsn=e,t._globalKey=n.user,t._globalSecret=n.pass&&n.pass.substr(1),t._globalProject=n.path.substr(r+1),t._globalServer=t._getGlobalServer(n),t._globalEndpoint=t._globalServer+"/"+i+"api/"+t._globalProject+"/store/",this._resetBackoff()},context:function(e,t,n){return a(e)&&(n=t||[],t=e,e=void 0),this.wrap(e,t).apply(this,n)},wrap:function(e,t,n){function r(){var r=[],o=arguments.length,s=!e||e&&e.deep!==!1;for(n&&a(n)&&n.apply(this,arguments);o--;)r[o]=s?i.wrap(e,arguments[o]):arguments[o];try{return t.apply(this,r)}catch(t){throw i._ignoreNextOnError(),i.captureException(t,e),t}}var i=this;if(o(t)&&!a(e))return e;if(a(e)&&(t=e,e=void 0),!a(t))return t;try{if(t.__raven__)return t;if(t.__raven_wrapper__)return t.__raven_wrapper__}catch(e){return t}for(var s in t)d(t,s)&&(r[s]=t[s]);return r.prototype=t.prototype,t.__raven_wrapper__=r,r.__raven__=!0,r.__inner__=t,r},uninstall:function(){return x.report.uninstall(),this._restoreBuiltIns(),Error.stackTraceLimit=this._originalErrorStackTraceLimit,this._isRavenInstalled=!1,this},captureException:function(e,t){if(!I(e))return this.captureMessage(e,l({trimHeadFrames:1,stacktrace:!0},t));this._lastCapturedException=e;try{this._handleStackInfo(x.computeStackTrace(e),t)}catch(t){if(e!==t)throw t}return this},captureMessage:function(e,t){if(!this._globalOptions.ignoreErrors.test||!this._globalOptions.ignoreErrors.test(e)){t=t||{};var n=l({message:e+""},t);if(this._globalOptions.stacktrace||t&&t.stacktrace){var r;try{throw new Error(e)}catch(e){r=e}r.name=null,t=l({fingerprint:e,trimHeadFrames:(t.trimHeadFrames||0)+1},t);n.stacktrace={frames:this._prepareFrames(x.computeStackTrace(r),t).reverse()}}return this._send(n),this}},captureBreadcrumb:function(e){var t=l({timestamp:r()/1e3},e);if(a(this._globalOptions.breadcrumbCallback)){var n=this._globalOptions.breadcrumbCallback(t);if(M(n)&&!u(n))t=n;else if(n===!1)return this}return this._breadcrumbs.push(t),this._breadcrumbs.length>this._globalOptions.maxBreadcrumbs&&this._breadcrumbs.shift(),this},addPlugin:function(e){return this._plugins.push([e,[].slice.call(arguments,1)]),this._isRavenInstalled&&this._drainPlugins(),this},setUserContext:function(e){return this._globalContext.user=e,this},setExtraContext:function(e){return this._mergeContext("extra",e),this},setTagsContext:function(e){return this._mergeContext("tags",e),this},clearContext:function(){return this._globalContext={},this},getContext:function(){return JSON.parse(S(this._globalContext))},setEnvironment:function(e){return this._globalOptions.environment=e,this},setRelease:function(e){return this._globalOptions.release=e,this},setDataCallback:function(e){var t=this._globalOptions.dataCallback;return this._globalOptions.dataCallback=a(e)?function(n){return e(n,t)}:e,this},setBreadcrumbCallback:function(e){var t=this._globalOptions.breadcrumbCallback;return this._globalOptions.breadcrumbCallback=a(e)?function(n){return e(n,t)}:e,this},setShouldSendCallback:function(e){var t=this._globalOptions.shouldSendCallback;return this._globalOptions.shouldSendCallback=a(e)?function(n){return e(n,t)}:e,this},setTransport:function(e){return this._globalOptions.transport=e,this},lastException:function(){return this._lastCapturedException},lastEventId:function(){return this._lastEventId},isSetup:function(){return!!this._hasJSON&&(!!this._globalServer||(this.ravenNotConfiguredError||(this.ravenNotConfiguredError=!0,this._logDebug("error","Error: Raven has not been configured.")),!1))},afterLoad:function(){var e=k.RavenConfig;e&&this.config(e.dsn,e.config).install()},showReportDialog:function(e){if(A){e=e||{};var t=e.eventId||this.lastEventId();if(!t)throw new T("Missing eventId");var n=e.dsn||this._dsn;if(!n)throw new T("Missing DSN");var r=encodeURIComponent,i="";i+="?eventId="+r(t),i+="&dsn="+r(n);var o=e.user||this._globalContext.user;o&&(o.name&&(i+="&name="+r(o.name)),o.email&&(i+="&email="+r(o.email)));var a=this._getGlobalServer(this._parseDSN(n)),s=A.createElement("script");s.async=!0,s.src=a+"/api/embed/error-page/"+i,(A.head||A.body).appendChild(s)}},_ignoreNextOnError:function(){var e=this;this._ignoreOnError+=1,setTimeout(function(){e._ignoreOnError-=1})},_triggerEvent:function(e,t){var n,r;if(this._hasDocument){t=t||{},e="raven"+e.substr(0,1).toUpperCase()+e.substr(1),A.createEvent?(n=A.createEvent("HTMLEvents"),n.initEvent(e,!0,!0)):(n=A.createEventObject(),n.eventType=e);for(r in t)d(t,r)&&(n[r]=t[r]);if(A.createEvent)A.dispatchEvent(n);else try{A.fireEvent("on"+n.eventType.toLowerCase(),n)}catch(e){}}},_breadcrumbEventHandler:function(e){var t=this;return function(n){if(t._keypressTimeout=null,t._lastCapturedEvent!==n){t._lastCapturedEvent=n;var r;try{r=v(n.target)}catch(e){r="<unknown>"}t.captureBreadcrumb({category:"ui."+e,message:r})}}},_keypressEventHandler:function(){var e=this;return function(t){var n;try{n=t.target}catch(e){return}var r=n&&n.tagName;if(r&&("INPUT"===r||"TEXTAREA"===r||n.isContentEditable)){var i=e._keypressTimeout;i||e._breadcrumbEventHandler("input")(t),clearTimeout(i),e._keypressTimeout=setTimeout(function(){e._keypressTimeout=null},1e3)}}},_captureUrlChange:function(e,t){var n=m(this._location.href),r=m(t),i=m(e);this._lastHref=t,n.protocol===r.protocol&&n.host===r.host&&(t=r.relative),n.protocol===i.protocol&&n.host===i.host&&(e=i.relative),this.captureBreadcrumb({category:"navigation",data:{to:t,from:e}})},_instrumentTryCatch:function(){function e(e){return function(n,r){for(var i=new Array(arguments.length),o=0;o<i.length;++o)i[o]=arguments[o];var s=i[0];return a(s)&&(i[0]=t.wrap(s)),e.apply?e.apply(this,i):e(i[0],i[1])}}var t=this,n=t._wrappedBuiltIns,r=this._globalOptions.autoBreadcrumbs;E(k,"setTimeout",e,n),E(k,"setInterval",e,n),k.requestAnimationFrame&&E(k,"requestAnimationFrame",function(e){return function(n){return e(t.wrap(n))}},n);for(var i=["EventTarget","Window","Node","ApplicationCache","AudioTrackList","ChannelMergerNode","CryptoOperation","EventSource","FileReader","HTMLUnknownElement","IDBDatabase","IDBRequest","IDBTransaction","KeyOperation","MediaController","MessagePort","ModalWindow","Notification","SVGElementInstance","Screen","TextTrack","TextTrackCue","TextTrackList","WebSocket","WebSocketWorker","Worker","XMLHttpRequest","XMLHttpRequestEventTarget","XMLHttpRequestUpload"],o=0;o<i.length;o++)!function(e){var i=k[e]&&k[e].prototype;i&&i.hasOwnProperty&&i.hasOwnProperty("addEventListener")&&(E(i,"addEventListener",function(n){return function(i,o,a,s){try{o&&o.handleEvent&&(o.handleEvent=t.wrap(o.handleEvent))}catch(e){}var u,c,l;return r&&r.dom&&("EventTarget"===e||"Node"===e)&&(c=t._breadcrumbEventHandler("click"),l=t._keypressEventHandler(),u=function(e){if(e){var t;try{t=e.type}catch(e){return}return"click"===t?c(e):"keypress"===t?l(e):void 0}}),n.call(this,i,t.wrap(o,void 0,u),a,s)}},n),E(i,"removeEventListener",function(e){return function(t,n,r,i){try{n=n&&(n.__raven_wrapper__?n.__raven_wrapper__:n)}catch(e){}return e.call(this,t,n,r,i)}},n))}(i[o])},_instrumentBreadcrumbs:function(){function e(e,n){e in n&&a(n[e])&&E(n,e,function(e){return t.wrap(e)})}var t=this,n=this._globalOptions.autoBreadcrumbs,r=t._wrappedBuiltIns;if(n.xhr&&"XMLHttpRequest"in k){var i=XMLHttpRequest.prototype;E(i,"open",function(e){return function(n,r){return s(r)&&r.indexOf(t._globalKey)===-1&&(this.__raven_xhr={method:n,url:r,status_code:null}),e.apply(this,arguments)}},r),E(i,"send",function(n){return function(r){function i(){if(o.__raven_xhr&&(1===o.readyState||4===o.readyState)){try{o.__raven_xhr.status_code=o.status}catch(e){}t.captureBreadcrumb({type:"http",category:"xhr",data:o.__raven_xhr})}}for(var o=this,s=["onload","onerror","onprogress"],u=0;u<s.length;u++)e(s[u],o);return"onreadystatechange"in o&&a(o.onreadystatechange)?E(o,"onreadystatechange",function(e){return t.wrap(e,void 0,i)}):o.onreadystatechange=i,n.apply(this,arguments)}},r)}n.xhr&&"fetch"in k&&E(k,"fetch",function(e){return function(n,r){for(var i=new Array(arguments.length),o=0;o<i.length;++o)i[o]=arguments[o];var a,s=i[0],u="GET";"string"==typeof s?a=s:(a=s.url,s.method&&(u=s.method)),i[1]&&i[1].method&&(u=i[1].method);var c={method:u,url:a,status_code:null};return t.captureBreadcrumb({type:"http",category:"fetch",data:c}),e.apply(this,i).then(function(e){return c.status_code=e.status,e})}},r),n.dom&&this._hasDocument&&(A.addEventListener?(A.addEventListener("click",t._breadcrumbEventHandler("click"),!1),A.addEventListener("keypress",t._keypressEventHandler(),!1)):(A.attachEvent("onclick",t._breadcrumbEventHandler("click")),A.attachEvent("onkeypress",t._keypressEventHandler())));var o=k.chrome,u=o&&o.app&&o.app.runtime,l=!u&&k.history&&history.pushState;if(n.location&&l){var p=k.onpopstate;k.onpopstate=function(){if(t._captureUrlChange(t._lastHref,t._location.href),p)return p.apply(this,arguments)},E(history,"pushState",function(e){return function(){var n=arguments.length>2?arguments[2]:void 0;return n&&t._captureUrlChange(t._lastHref,n+""),e.apply(this,arguments)}},r)}if(n.console&&"console"in k&&console.log){var d=function(e,n){t.captureBreadcrumb({message:e,level:n.level,category:"console"})};c(["debug","info","warn","error","log"],function(e,t){P(console,t,d)})}},_restoreBuiltIns:function(){for(var e;this._wrappedBuiltIns.length;){e=this._wrappedBuiltIns.shift();e[0][e[1]]=e[2]}},_drainPlugins:function(){var e=this;c(this._plugins,function(t,n){n[0].apply(e,[e].concat(n[1]))})},_parseDSN:function(e){var t=O.exec(e),n={},r=7;try{for(;r--;)n[R[r]]=t[r]||""}catch(t){throw new T("Invalid DSN: "+e)}if(n.pass&&!this._globalOptions.allowSecretKey)throw new T("Do not specify your secret key in the DSN. See: http://bit.ly/raven-secret-key");return n},_getGlobalServer:function(e){var t="//"+e.host+(e.port?":"+e.port:"");return e.protocol&&(t=e.protocol+":"+t),t},_handleOnErrorStackInfo:function(){this._ignoreOnError||this._handleStackInfo.apply(this,arguments)},_handleStackInfo:function(e,t){var n=this._prepareFrames(e,t);this._triggerEvent("handle",{stackInfo:e,options:t}),this._processException(e.name,e.message,e.url,e.lineno,n,t)},_prepareFrames:function(e,t){var n=this,r=[];if(e.stack&&e.stack.length&&(c(e.stack,function(e,t){var i=n._normalizeFrame(t);i&&r.push(i)}),t&&t.trimHeadFrames))for(var i=0;i<t.trimHeadFrames&&i<r.length;i++)r[i].in_app=!1;return r=r.slice(0,this._globalOptions.stackTraceLimit)},_normalizeFrame:function(e){if(e.url){var t={filename:e.url,lineno:e.line,colno:e.column,function:e.func||"?"};return t.in_app=!(this._globalOptions.includePaths.test&&!this._globalOptions.includePaths.test(t.filename)||/(Raven|TraceKit)\./.test(t.function)||/raven\.(min\.)?js$/.test(t.filename)),t}},_processException:function(e,t,n,r,i,o){var a;if((!this._globalOptions.ignoreErrors.test||!this._globalOptions.ignoreErrors.test(t))&&(t+="",i&&i.length?(n=i[0].filename||n,i.reverse(),a={frames:i}):n&&(a={frames:[{filename:n,lineno:r,in_app:!0}]}),(!this._globalOptions.ignoreUrls.test||!this._globalOptions.ignoreUrls.test(n))&&(!this._globalOptions.whitelistUrls.test||this._globalOptions.whitelistUrls.test(n)))){this._send(l({exception:{values:[{type:e,value:t,stacktrace:a}]},culprit:n},o))}},_trimPacket:function(e){var t=this._globalOptions.maxMessageLength;if(e.message&&(e.message=p(e.message,t)),e.exception){var n=e.exception.values[0];n.value=p(n.value,t)}var r=e.request;return r&&(r.url&&(r.url=p(r.url,this._globalOptions.maxUrlLength)),r.Referer&&(r.Referer=p(r.Referer,this._globalOptions.maxUrlLength))),e.breadcrumbs&&e.breadcrumbs.values&&this._trimBreadcrumbs(e.breadcrumbs),e},_trimBreadcrumbs:function(e){for(var t,n,r,i=["to","from","url"],o=0;o<e.values.length;++o)if(n=e.values[o],n.hasOwnProperty("data")&&M(n.data)){r=n.data;for(var a=0;a<i.length;++a)t=i[a],r.hasOwnProperty(t)&&(r[t]=p(r[t],this._globalOptions.maxUrlLength))}},_getHttpData:function(){if(this._hasNavigator||this._hasDocument){var e={};return this._hasNavigator&&N.userAgent&&(e.headers={"User-Agent":navigator.userAgent}),this._hasDocument&&(A.location&&A.location.href&&(e.url=A.location.href),A.referrer&&(e.headers||(e.headers={}),e.headers.Referer=A.referrer)),e}},_resetBackoff:function(){this._backoffDuration=0,this._backoffStart=null},_shouldBackoff:function(){return this._backoffDuration&&r()-this._backoffStart<this._backoffDuration},_isRepeatData:function(e){var t=this._lastData;return!(!t||e.message!==t.message||e.culprit!==t.culprit)&&(e.stacktrace||t.stacktrace?w(e.stacktrace,t.stacktrace):!e.exception&&!t.exception||_(e.exception,t.exception))},_setBackoffState:function(e){if(!this._shouldBackoff()){var t=e.status;if(400===t||401===t||429===t){var n;try{n=e.getResponseHeader("Retry-After"),n=1e3*parseInt(n,10)}catch(e){}this._backoffDuration=n?n:2*this._backoffDuration||1e3,this._backoffStart=r()}}},_send:function(e){var t=this._globalOptions,n={project:this._globalProject,logger:t.logger,platform:"javascript"},i=this._getHttpData();if(i&&(n.request=i),e.trimHeadFrames&&delete e.trimHeadFrames,e=l(n,e),e.tags=l(l({},this._globalContext.tags),e.tags),e.extra=l(l({},this._globalContext.extra),e.extra),e.extra["session:duration"]=r()-this._startTime,this._breadcrumbs&&this._breadcrumbs.length>0&&(e.breadcrumbs={values:[].slice.call(this._breadcrumbs,0)}),u(e.tags)&&delete e.tags,this._globalContext.user&&(e.user=this._globalContext.user),t.environment&&(e.environment=t.environment),t.release&&(e.release=t.release),t.serverName&&(e.server_name=t.serverName),a(t.dataCallback)&&(e=t.dataCallback(e)||e),e&&!u(e)&&(!a(t.shouldSendCallback)||t.shouldSendCallback(e)))return this._shouldBackoff()?void this._logDebug("warn","Raven dropped error due to backoff: ",e):void("number"==typeof t.sampleRate?Math.random()<t.sampleRate&&this._sendProcessedPayload(e):this._sendProcessedPayload(e))},_getUuid:function(){return g()},_sendProcessedPayload:function(e,t){var n=this,r=this._globalOptions;if(this.isSetup()){if(this._lastEventId=e.event_id||(e.event_id=this._getUuid()),e=this._trimPacket(e),!this._globalOptions.allowDuplicates&&this._isRepeatData(e))return void this._logDebug("warn","Raven dropped repeat event: ",e);this._lastData=e,this._logDebug("debug","Raven about to send:",e);var i={sentry_version:"7",sentry_client:"raven-js/"+this.VERSION,sentry_key:this._globalKey};this._globalSecret&&(i.sentry_secret=this._globalSecret);var o=e.exception&&e.exception.values[0];this.captureBreadcrumb({category:"sentry",message:o?(o.type?o.type+": ":"")+o.value:e.message,event_id:e.event_id,level:e.level||"error"});var a=this._globalEndpoint;(r.transport||this._makeRequest).call(this,{url:a,auth:i,data:e,options:r,onSuccess:function(){n._resetBackoff(),n._triggerEvent("success",{data:e,src:a}),t&&t()},onError:function(r){n._logDebug("error","Raven transport failed to send: ",r),r.request&&n._setBackoffState(r.request),n._triggerEvent("failure",{data:e,src:a}),r=r||new Error("Raven send failed (no additional details provided)"),t&&t(r)}})}},_makeRequest:function(e){var t=new XMLHttpRequest;if("withCredentials"in t||"undefined"!=typeof XDomainRequest){var n=e.url;"withCredentials"in t?t.onreadystatechange=function(){if(4===t.readyState)if(200===t.status)e.onSuccess&&e.onSuccess();else if(e.onError){var n=new Error("Sentry error code: "+t.status);n.request=t,e.onError(n)}}:(t=new XDomainRequest,n=n.replace(/^https?:/,""),e.onSuccess&&(t.onload=e.onSuccess),e.onError&&(t.onerror=function(){var n=new Error("Sentry error code: XDomainRequest");n.request=t,e.onError(n)})),t.open("POST",n+"?"+h(e.auth)),t.send(S(e.data))}},_logDebug:function(e){this._originalConsoleMethods[e]&&this.debug&&Function.prototype.apply.call(this._originalConsoleMethods[e],this._originalConsole,[].slice.call(arguments,1))},_mergeContext:function(e,t){o(t)?delete this._globalContext[e]:this._globalContext[e]=l(this._globalContext[e]||{},t)}};var D=Object.prototype;i.prototype.setUser=i.prototype.setUserContext,i.prototype.setReleaseContext=i.prototype.setRelease,e.exports=i}).call(t,n(34))},function(e,t,n){"use strict";(function(t){function r(){return"undefined"==typeof document||void 0===document.location?"":document.location.href}var i=n(268),o={collectWindowErrors:!0,debug:!1},a="undefined"!=typeof window?window:void 0!==t?t:"undefined"!=typeof self?self:{},s=[].slice,u="?",c=/^(?:[Uu]ncaught (?:exception: )?)?(?:((?:Eval|Internal|Range|Reference|Syntax|Type|URI|)Error): )?(.*)$/;o.report=function(){function e(e){d(),b.push(e)}function t(e){for(var t=b.length-1;t>=0;--t)b[t]===e&&b.splice(t,1)}function n(){f(),b=[]}function l(e,t){var n=null;if(!t||o.collectWindowErrors){for(var r in b)if(b.hasOwnProperty(r))try{b[r].apply(null,[e].concat(s.call(arguments,2)))}catch(e){n=e}if(n)throw n}}function p(e,t,n,a,s){var p=null;if(w)o.computeStackTrace.augmentStackTraceWithInitialElement(w,t,n,e),h();else if(s&&i.isError(s))p=o.computeStackTrace(s),l(p,!0);else{var d,f={url:t,line:n,column:a},m=void 0,v=e;if("[object String]"==={}.toString.call(e)){var d=e.match(c);d&&(m=d[1],v=d[2])}f.func=u,p={name:m,message:v,url:r(),stack:[f]},l(p,!0)}return!!g&&g.apply(this,arguments)}function d(){v||(g=a.onerror,a.onerror=p,v=!0)}function f(){v&&(a.onerror=g,v=!1,g=void 0)}function h(){var e=w,t=y;y=null,w=null,_=null,l.apply(null,[e,!1].concat(t))}function m(e,t){var n=s.call(arguments,1);if(w){if(_===e)return;h()}var r=o.computeStackTrace(e);if(w=r,_=e,y=n,setTimeout(function(){_===e&&h()},r.incomplete?2e3:0),t!==!1)throw e}var g,v,b=[],y=null,_=null,w=null;return m.subscribe=e,m.unsubscribe=t,m.uninstall=n,m}(),o.computeStackTrace=function(){function e(e){if(void 0!==e.stack&&e.stack){for(var t,n,i,o=/^\s*at (.*?) ?\(((?:file|https?|blob|chrome-extension|native|eval|webpack|<anonymous>|\/).*?)(?::(\d+))?(?::(\d+))?\)?\s*$/i,a=/^\s*(.*?)(?:\((.*?)\))?(?:^|@)((?:file|https?|blob|chrome|webpack|resource|\[native).*?)(?::(\d+))?(?::(\d+))?\s*$/i,s=/^\s*at (?:((?:\[object object\])?.+) )?\(?((?:file|ms-appx|https?|webpack|blob):.*?):(\d+)(?::(\d+))?\)?\s*$/i,c=/(\S+) line (\d+)(?: > eval line \d+)* > eval/i,l=/\((\S*)(?::(\d+))(?::(\d+))\)/,p=e.stack.split("\n"),d=[],f=(/^(.*) is undefined$/.exec(e.message),0),h=p.length;f<h;++f){if(n=o.exec(p[f])){var m=n[2]&&0===n[2].indexOf("native"),g=n[2]&&0===n[2].indexOf("eval");g&&(t=l.exec(n[2]))&&(n[2]=t[1],n[3]=t[2],n[4]=t[3]),i={url:m?null:n[2],func:n[1]||u,args:m?[n[2]]:[],line:n[3]?+n[3]:null,column:n[4]?+n[4]:null}}else if(n=s.exec(p[f]))i={url:n[2],func:n[1]||u,args:[],line:+n[3],column:n[4]?+n[4]:null};else{if(!(n=a.exec(p[f])))continue;var g=n[3]&&n[3].indexOf(" > eval")>-1;g&&(t=c.exec(n[3]))?(n[3]=t[1],n[4]=t[2],n[5]=null):0!==f||n[5]||void 0===e.columnNumber||(d[0].column=e.columnNumber+1),i={url:n[3],func:n[1]||u,args:n[2]?n[2].split(","):[],line:n[4]?+n[4]:null,column:n[5]?+n[5]:null}}!i.func&&i.line&&(i.func=u),d.push(i)}return d.length?{name:e.name,message:e.message,url:r(),stack:d}:null}}function t(e,t,n,r){var i={url:t,line:n};if(i.url&&i.line){if(e.incomplete=!1,i.func||(i.func=u),e.stack.length>0&&e.stack[0].url===i.url){if(e.stack[0].line===i.line)return!1;if(!e.stack[0].line&&e.stack[0].func===i.func)return e.stack[0].line=i.line,!1}return e.stack.unshift(i),e.partial=!0,!0}return e.incomplete=!0,!1}function n(e,a){for(var s,c,l=/function\s+([_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*)?\s*\(/i,p=[],d={},f=!1,h=n.caller;h&&!f;h=h.caller)if(h!==i&&h!==o.report){if(c={url:null,func:u,line:null,column:null},h.name?c.func=h.name:(s=l.exec(h.toString()))&&(c.func=s[1]),void 0===c.func)try{c.func=s.input.substring(0,s.input.indexOf("{"))}catch(e){}d[""+h]?f=!0:d[""+h]=!0,p.push(c)}a&&p.splice(0,a);var m={name:e.name,message:e.message,url:r(),stack:p};return t(m,e.sourceURL||e.fileName,e.line||e.lineNumber,e.message||e.description),m}function i(t,i){var a=null;i=null==i?0:+i;try{if(a=e(t))return a}catch(e){if(o.debug)throw e}try{if(a=n(t,i+1))return a}catch(e){if(o.debug)throw e}return{name:t.name,message:t.message,url:r()}}return i.augmentStackTraceWithInitialElement=t,i.computeStackTraceFromStackProp=e,i}(),e.exports=o}).call(t,n(34))},function(e,t,n){"use strict";function r(e,t){for(var n=0;n<e.length;++n)if(e[n]===t)return n;return-1}function i(e,t,n,r){return JSON.stringify(e,o(t,r),n)}function o(e,t){var n=[],i=[];return null==t&&(t=function(e,t){return n[0]===t?"[Circular ~]":"[Circular ~."+i.slice(0,r(n,t)).join(".")+"]"}),function(o,a){if(n.length>0){var s=r(n,this);~s?n.splice(s+1):n.push(this),~s?i.splice(s,1/0,o):i.push(o),~r(n,a)&&(a=t.call(this,o,a))}else n.push(a);return null==e?a:e.call(this,o,a)}}t=e.exports=i,t.getSerialize=o},function(e,t,n){"use strict";e.exports={Properties:{"aria-current":0,"aria-details":0,"aria-disabled":0,"aria-hidden":0,"aria-invalid":0,"aria-keyshortcuts":0,"aria-label":0,"aria-roledescription":0,"aria-autocomplete":0,"aria-checked":0,"aria-expanded":0,"aria-haspopup":0,"aria-level":0,"aria-modal":0,"aria-multiline":0,"aria-multiselectable":0,"aria-orientation":0,"aria-placeholder":0,"aria-pressed":0,"aria-readonly":0,"aria-required":0,"aria-selected":0,"aria-sort":0,"aria-valuemax":0,"aria-valuemin":0,"aria-valuenow":0,"aria-valuetext":0,"aria-atomic":0,"aria-busy":0,"aria-live":0,"aria-relevant":0,"aria-dropeffect":0,"aria-grabbed":0,"aria-activedescendant":0,"aria-colcount":0,"aria-colindex":0,"aria-colspan":0,"aria-controls":0,"aria-describedby":0,"aria-errormessage":0,"aria-flowto":0,"aria-labelledby":0,"aria-owns":0,"aria-posinset":0,"aria-rowcount":0,"aria-rowindex":0,"aria-rowspan":0,"aria-setsize":0},DOMAttributeNames:{},DOMPropertyNames:{}}},function(e,t,n){"use strict";var r=n(16),i=n(260);e.exports={focusDOMComponent:function(){i(r.getNodeFromInstance(this))}}},function(e,t,n){"use strict";function r(e){return(e.ctrlKey||e.altKey||e.metaKey)&&!(e.ctrlKey&&e.altKey)}function i(e){switch(e){case"topCompositionStart":return T.compositionStart;case"topCompositionEnd":return T.compositionEnd;case"topCompositionUpdate":return T.compositionUpdate}}function o(e,t){return"topKeyDown"===e&&t.keyCode===b}function a(e,t){switch(e){case"topKeyUp":return v.indexOf(t.keyCode)!==-1;case"topKeyDown":return t.keyCode!==b;case"topKeyPress":case"topMouseDown":case"topBlur":return!0;default:return!1}}function s(e){var t=e.detail;return"object"==typeof t&&"data"in t?t.data:null}function u(e,t,n,r){var u,c;if(y?u=i(e):I?a(e,n)&&(u=T.compositionEnd):o(e,n)&&(u=T.compositionStart),!u)return null;E&&(I||u!==T.compositionStart?u===T.compositionEnd&&I&&(c=I.getData()):I=h.getPooled(r));var l=m.getPooled(u,t,n,r);if(c)l.data=c;else{var p=s(n);null!==p&&(l.data=p)}return d.accumulateTwoPhaseDispatches(l),l}function c(e,t){switch(e){case"topCompositionEnd":return s(t);case"topKeyPress":return t.which!==x?null:(C=!0,S);case"topTextInput":var n=t.data;return n===S&&C?null:n;default:return null}}function l(e,t){if(I){if("topCompositionEnd"===e||!y&&a(e,t)){var n=I.getData();return h.release(I),I=null,n}return null}switch(e){case"topPaste":return null;case"topKeyPress":return t.which&&!r(t)?String.fromCharCode(t.which):null;case"topCompositionEnd":return E?null:t.data;default:return null}}function p(e,t,n,r){var i;if(!(i=w?c(e,n):l(e,n)))return null;var o=g.getPooled(T.beforeInput,t,n,r);return o.data=i,d.accumulateTwoPhaseDispatches(o),o}var d=n(103),f=n(24),h=n(658),m=n(695),g=n(698),v=[9,13,27,32],b=229,y=f.canUseDOM&&"CompositionEvent"in window,_=null;f.canUseDOM&&"documentMode"in document&&(_=document.documentMode);var w=f.canUseDOM&&"TextEvent"in window&&!_&&!function(){var e=window.opera;return"object"==typeof e&&"function"==typeof e.version&&parseInt(e.version(),10)<=12}(),E=f.canUseDOM&&(!y||_&&_>8&&_<=11),x=32,S=String.fromCharCode(x),T={beforeInput:{phasedRegistrationNames:{bubbled:"onBeforeInput",captured:"onBeforeInputCapture"},dependencies:["topCompositionEnd","topKeyPress","topTextInput","topPaste"]},compositionEnd:{phasedRegistrationNames:{bubbled:"onCompositionEnd",captured:"onCompositionEndCapture"},dependencies:["topBlur","topCompositionEnd","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]},compositionStart:{phasedRegistrationNames:{bubbled:"onCompositionStart",captured:"onCompositionStartCapture"},dependencies:["topBlur","topCompositionStart","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]},compositionUpdate:{phasedRegistrationNames:{bubbled:"onCompositionUpdate",captured:"onCompositionUpdateCapture"},dependencies:["topBlur","topCompositionUpdate","topKeyDown","topKeyPress","topKeyUp","topMouseDown"]}},C=!1,I=null;e.exports={eventTypes:T,extractEvents:function(e,t,n,r){return[u(e,t,n,r),p(e,t,n,r)]}}},function(e,t,n){"use strict";var r=n(269),i=n(24),o=(n(39),n(593),n(704)),a=n(600),s=n(603),u=(n(5),s(function(e){return a(e)})),c=!1,l="cssFloat";if(i.canUseDOM){var p=document.createElement("div").style;try{p.font=""}catch(e){c=!0}void 0===document.documentElement.style.cssFloat&&(l="styleFloat")}e.exports={createMarkupForStyles:function(e,t){var n="";for(var r in e)if(e.hasOwnProperty(r)){var i=e[r];null!=i&&(n+=u(r)+":",n+=o(r,i,t)+";")}return n||null},setValueForStyles:function(e,t,n){var i=e.style;for(var a in t)if(t.hasOwnProperty(a)){var s=o(a,t[a],n);if("float"!==a&&"cssFloat"!==a||(a=l),s)i[a]=s;else{var u=c&&r.shorthandPropertyExpansions[a];if(u)for(var p in u)i[p]="";else i[a]=""}}}}},function(e,t,n){"use strict";function r(e){var t=e.nodeName&&e.nodeName.toLowerCase();return"select"===t||"input"===t&&"file"===e.type}function i(e){var t=S.getPooled(M.change,R,e,T(e));_.accumulateTwoPhaseDispatches(t),x.batchedUpdates(o,t)}function o(e){y.enqueueEvents(e),y.processEventQueue(!1)}function a(e,t){P=e,R=t,P.attachEvent("onchange",i)}function s(){P&&(P.detachEvent("onchange",i),P=null,R=null)}function u(e,t){if("topChange"===e)return t}function c(e,t,n){"topFocus"===e?(s(),a(t,n)):"topBlur"===e&&s()}function l(e,t){P=e,R=t,O=e.value,k=Object.getOwnPropertyDescriptor(e.constructor.prototype,"value"),Object.defineProperty(P,"value",D),P.attachEvent?P.attachEvent("onpropertychange",d):P.addEventListener("propertychange",d,!1)}function p(){P&&(delete P.value,P.detachEvent?P.detachEvent("onpropertychange",d):P.removeEventListener("propertychange",d,!1),P=null,R=null,O=null,k=null)}function d(e){if("value"===e.propertyName){var t=e.srcElement.value;t!==O&&(O=t,i(e))}}function f(e,t){if("topInput"===e)return t}function h(e,t,n){"topFocus"===e?(p(),l(t,n)):"topBlur"===e&&p()}function m(e,t){if(("topSelectionChange"===e||"topKeyUp"===e||"topKeyDown"===e)&&P&&P.value!==O)return O=P.value,R}function g(e){return e.nodeName&&"input"===e.nodeName.toLowerCase()&&("checkbox"===e.type||"radio"===e.type)}function v(e,t){if("topClick"===e)return t}function b(e,t){if(null!=e){var n=e._wrapperState||t._wrapperState;if(n&&n.controlled&&"number"===t.type){var r=""+t.value;t.getAttribute("value")!==r&&t.setAttribute("value",r)}}}var y=n(102),_=n(103),w=n(24),E=n(16),x=n(46),S=n(55),T=n(185),C=n(186),I=n(286),M={change:{phasedRegistrationNames:{bubbled:"onChange",captured:"onChangeCapture"},dependencies:["topBlur","topChange","topClick","topFocus","topInput","topKeyDown","topKeyUp","topSelectionChange"]}},P=null,R=null,O=null,k=null,A=!1;w.canUseDOM&&(A=C("change")&&(!document.documentMode||document.documentMode>8));var N=!1;w.canUseDOM&&(N=C("input")&&(!document.documentMode||document.documentMode>11));var D={get:function(){return k.get.call(this)},set:function(e){O=""+e,k.set.call(this,e)}};e.exports={eventTypes:M,extractEvents:function(e,t,n,i){var o,a,s=t?E.getNodeFromInstance(t):window;if(r(s)?A?o=u:a=c:I(s)?N?o=f:(o=m,a=h):g(s)&&(o=v),o){var l=o(e,t);if(l){var p=S.getPooled(M.change,l,n,i);return p.type="change",_.accumulateTwoPhaseDispatches(p),p}}a&&a(e,s,t),"topBlur"===e&&b(t,s)}}},function(e,t,n){"use strict";var r=n(7),i=n(87),o=n(24),a=n(596),s=n(32);n(1);e.exports={dangerouslyReplaceNodeWithMarkup:function(e,t){if(o.canUseDOM||r("56"),t||r("57"),"HTML"===e.nodeName&&r("58"),"string"==typeof t){e.parentNode.replaceChild(a(t,s)[0],e)}else i.replaceChildWithTree(e,t)}}},function(e,t,n){"use strict";e.exports=["ResponderEventPlugin","SimpleEventPlugin","TapEventPlugin","EnterLeaveEventPlugin","ChangeEventPlugin","SelectEventPlugin","BeforeInputEventPlugin"]},function(e,t,n){"use strict";var r=n(103),i=n(16),o=n(125),a={mouseEnter:{registrationName:"onMouseEnter",dependencies:["topMouseOut","topMouseOver"]},mouseLeave:{registrationName:"onMouseLeave",dependencies:["topMouseOut","topMouseOver"]}};e.exports={eventTypes:a,extractEvents:function(e,t,n,s){if("topMouseOver"===e&&(n.relatedTarget||n.fromElement))return null;if("topMouseOut"!==e&&"topMouseOver"!==e)return null;var u;if(s.window===s)u=s;else{var c=s.ownerDocument;u=c?c.defaultView||c.parentWindow:window}var l,p;if("topMouseOut"===e){l=t;var d=n.relatedTarget||n.toElement;p=d?i.getClosestInstanceFromNode(d):null}else l=null,p=t;if(l===p)return null;var f=null==l?u:i.getNodeFromInstance(l),h=null==p?u:i.getNodeFromInstance(p),m=o.getPooled(a.mouseLeave,l,n,s);m.type="mouseleave",m.target=f,m.relatedTarget=h;var g=o.getPooled(a.mouseEnter,p,n,s);return g.type="mouseenter",g.target=h,g.relatedTarget=f,r.accumulateEnterLeaveDispatches(m,g,l,p),[m,g]}}},function(e,t,n){"use strict";function r(e){this._root=e,this._startText=this.getText(),this._fallbackText=null}var i=n(13),o=n(72),a=n(284);i(r.prototype,{destructor:function(){this._root=null,this._startText=null,this._fallbackText=null},getText:function(){return"value"in this._root?this._root.value:this._root[a()]},getData:function(){if(this._fallbackText)return this._fallbackText;var e,t,n=this._startText,r=n.length,i=this.getText(),o=i.length;for(e=0;e<r&&n[e]===i[e];e++);var a=r-e;for(t=1;t<=a&&n[r-t]===i[o-t];t++);return this._fallbackText=i.slice(e,t>1?1-t:void 0)}}),o.addPoolingTo(r),e.exports=r},function(e,t,n){"use strict";var r=n(88),i=r.injection.MUST_USE_PROPERTY,o=r.injection.HAS_BOOLEAN_VALUE,a=r.injection.HAS_NUMERIC_VALUE,s=r.injection.HAS_POSITIVE_NUMERIC_VALUE,u=r.injection.HAS_OVERLOADED_BOOLEAN_VALUE;e.exports={isCustomAttribute:RegExp.prototype.test.bind(new RegExp("^(data|aria)-["+r.ATTRIBUTE_NAME_CHAR+"]*$")),Properties:{accept:0,acceptCharset:0,accessKey:0,action:0,allowFullScreen:o,allowTransparency:0,alt:0,as:0,async:o,autoComplete:0,autoPlay:o,capture:o,cellPadding:0,cellSpacing:0,charSet:0,challenge:0,checked:i|o,cite:0,classID:0,className:0,cols:s,colSpan:0,content:0,contentEditable:0,contextMenu:0,controls:o,coords:0,crossOrigin:0,data:0,dateTime:0,default:o,defer:o,dir:0,disabled:o,download:u,draggable:0,encType:0,form:0,formAction:0,formEncType:0,formMethod:0,formNoValidate:o,formTarget:0,frameBorder:0,headers:0,height:0,hidden:o,high:0,href:0,hrefLang:0,htmlFor:0,httpEquiv:0,icon:0,id:0,inputMode:0,integrity:0,is:0,keyParams:0,keyType:0,kind:0,label:0,lang:0,list:0,loop:o,low:0,manifest:0,marginHeight:0,marginWidth:0,max:0,maxLength:0,media:0,mediaGroup:0,method:0,min:0,minLength:0,multiple:i|o,muted:i|o,name:0,nonce:0,noValidate:o,open:o,optimum:0,pattern:0,placeholder:0,playsInline:o,poster:0,preload:0,profile:0,radioGroup:0,readOnly:o,referrerPolicy:0,rel:0,required:o,reversed:o,role:0,rows:s,rowSpan:a,sandbox:0,scope:0,scoped:o,scrolling:0,seamless:o,selected:i|o,shape:0,size:s,sizes:0,span:s,spellCheck:0,src:0,srcDoc:0,srcLang:0,srcSet:0,start:a,step:0,style:0,summary:0,tabIndex:0,target:0,title:0,type:0,useMap:0,value:0,width:0,wmode:0,wrap:0,about:0,datatype:0,inlist:0,prefix:0,property:0,resource:0,typeof:0,vocab:0,autoCapitalize:0,autoCorrect:0,autoSave:0,color:0,itemProp:0,itemScope:o,itemType:0,itemID:0,itemRef:0,results:0,security:0,unselectable:0},DOMAttributeNames:{acceptCharset:"accept-charset",className:"class",htmlFor:"for",httpEquiv:"http-equiv"},DOMPropertyNames:{},DOMMutationMethods:{value:function(e,t){if(null==t)return e.removeAttribute("value");"number"!==e.type||e.hasAttribute("value")===!1?e.setAttribute("value",""+t):e.validity&&!e.validity.badInput&&e.ownerDocument.activeElement!==e&&e.setAttribute("value",""+t)}}}},function(e,t,n){"use strict";(function(t){function r(e,t,n,r){var i=void 0===e[n];null!=t&&i&&(e[n]=o(t,!0))}var i=n(89),o=n(285),a=(n(177),n(187)),s=n(288);n(5);void 0!==t&&n.i({NODE_ENV:"production"}),e.exports={instantiateChildren:function(e,t,n,i){if(null==e)return null;var o={};return s(e,r,o),o},updateChildren:function(e,t,n,r,s,u,c,l,p){if(t||e){var d,f;for(d in t)if(t.hasOwnProperty(d)){f=e&&e[d];var h=f&&f._currentElement,m=t[d];if(null!=f&&a(h,m))i.receiveComponent(f,m,s,l),t[d]=f;else{f&&(r[d]=i.getHostNode(f),i.unmountComponent(f,!1));var g=o(m,!0);t[d]=g;var v=i.mountComponent(g,s,u,c,l,p);n.push(v)}}for(d in e)!e.hasOwnProperty(d)||t&&t.hasOwnProperty(d)||(f=e[d],r[d]=i.getHostNode(f),i.unmountComponent(f,!1))}},unmountChildren:function(e,t){for(var n in e)if(e.hasOwnProperty(n)){var r=e[n];i.unmountComponent(r,t)}}}}).call(t,n(106))},function(e,t,n){"use strict";var r=n(173);e.exports={processChildrenUpdates:n(668).dangerouslyProcessChildrenUpdates,replaceNodeWithMarkup:r.dangerouslyReplaceNodeWithMarkup}},function(e,t,n){"use strict";function r(e){}function i(e){return!(!e.prototype||!e.prototype.isReactComponent)}function o(e){return!(!e.prototype||!e.prototype.isPureReactComponent)}var a=n(7),s=n(13),u=n(90),c=n(179),l=n(56),p=n(180),d=n(104),f=(n(39),n(279)),h=n(89),m=n(100),g=(n(1),n(169)),v=n(187),b=(n(5),{ImpureClass:0,PureClass:1,StatelessFunctional:2});r.prototype.render=function(){var e=d.get(this)._currentElement.type,t=e(this.props,this.context,this.updater);return t};var y=1;e.exports={construct:function(e){this._currentElement=e,this._rootNodeID=0,this._compositeType=null,this._instance=null,this._hostParent=null,this._hostContainerInfo=null,this._updateBatchNumber=null,this._pendingElement=null,this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1,this._renderedNodeType=null,this._renderedComponent=null,this._context=null,this._mountOrder=0,this._topLevelWrapper=null,this._pendingCallbacks=null,this._calledComponentWillUnmount=!1},mountComponent:function(e,t,n,s){this._context=s,this._mountOrder=y++,this._hostParent=t,this._hostContainerInfo=n;var c,l=this._currentElement.props,p=this._processContext(s),f=this._currentElement.type,h=e.getUpdateQueue(),g=i(f),v=this._constructComponent(g,l,p,h);g||null!=v&&null!=v.render?this._compositeType=o(f)?b.PureClass:b.ImpureClass:(c=v,null===v||v===!1||u.isValidElement(v)||a("105",f.displayName||f.name||"Component"),v=new r(f),this._compositeType=b.StatelessFunctional);v.props=l,v.context=p,v.refs=m,v.updater=h,this._instance=v,d.set(v,this);var _=v.state;void 0===_&&(v.state=_=null),("object"!=typeof _||Array.isArray(_))&&a("106",this.getName()||"ReactCompositeComponent"),this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1;var w;return w=v.unstable_handleError?this.performInitialMountWithErrorHandling(c,t,n,e,s):this.performInitialMount(c,t,n,e,s),v.componentDidMount&&e.getReactMountReady().enqueue(v.componentDidMount,v),w},_constructComponent:function(e,t,n,r){return this._constructComponentWithoutOwner(e,t,n,r)},_constructComponentWithoutOwner:function(e,t,n,r){var i=this._currentElement.type;return e?new i(t,n,r):i(t,n,r)},performInitialMountWithErrorHandling:function(e,t,n,r,i){var o,a=r.checkpoint();try{o=this.performInitialMount(e,t,n,r,i)}catch(s){r.rollback(a),this._instance.unstable_handleError(s),this._pendingStateQueue&&(this._instance.state=this._processPendingState(this._instance.props,this._instance.context)),a=r.checkpoint(),this._renderedComponent.unmountComponent(!0),r.rollback(a),o=this.performInitialMount(e,t,n,r,i)}return o},performInitialMount:function(e,t,n,r,i){var o=this._instance,a=0;o.componentWillMount&&(o.componentWillMount(),this._pendingStateQueue&&(o.state=this._processPendingState(o.props,o.context))),void 0===e&&(e=this._renderValidatedComponent());var s=f.getType(e);this._renderedNodeType=s;var u=this._instantiateReactComponent(e,s!==f.EMPTY);this._renderedComponent=u;var c=h.mountComponent(u,r,t,n,this._processChildContext(i),a);return c},getHostNode:function(){return h.getHostNode(this._renderedComponent)},unmountComponent:function(e){if(this._renderedComponent){var t=this._instance;if(t.componentWillUnmount&&!t._calledComponentWillUnmount)if(t._calledComponentWillUnmount=!0,e){var n=this.getName()+".componentWillUnmount()";p.invokeGuardedCallback(n,t.componentWillUnmount.bind(t))}else t.componentWillUnmount();this._renderedComponent&&(h.unmountComponent(this._renderedComponent,e),this._renderedNodeType=null,this._renderedComponent=null,this._instance=null),this._pendingStateQueue=null,this._pendingReplaceState=!1,this._pendingForceUpdate=!1,this._pendingCallbacks=null,this._pendingElement=null,this._context=null,this._rootNodeID=0,this._topLevelWrapper=null,d.remove(t)}},_maskContext:function(e){var t=this._currentElement.type,n=t.contextTypes;if(!n)return m;var r={};for(var i in n)r[i]=e[i];return r},_processContext:function(e){var t=this._maskContext(e);return t},_processChildContext:function(e){var t,n=this._currentElement.type,r=this._instance;if(r.getChildContext&&(t=r.getChildContext()),t){"object"!=typeof n.childContextTypes&&a("107",this.getName()||"ReactCompositeComponent");for(var i in t)i in n.childContextTypes||a("108",this.getName()||"ReactCompositeComponent",i);return s({},e,t)}return e},_checkContextTypes:function(e,t,n){},receiveComponent:function(e,t,n){var r=this._currentElement,i=this._context;this._pendingElement=null,this.updateComponent(t,r,e,i,n)},performUpdateIfNecessary:function(e){null!=this._pendingElement?h.receiveComponent(this,this._pendingElement,e,this._context):null!==this._pendingStateQueue||this._pendingForceUpdate?this.updateComponent(e,this._currentElement,this._currentElement,this._context,this._context):this._updateBatchNumber=null},updateComponent:function(e,t,n,r,i){var o=this._instance;null==o&&a("136",this.getName()||"ReactCompositeComponent");var s,u=!1;this._context===i?s=o.context:(s=this._processContext(i),u=!0);var c=t.props,l=n.props;t!==n&&(u=!0),u&&o.componentWillReceiveProps&&o.componentWillReceiveProps(l,s);var p=this._processPendingState(l,s),d=!0;this._pendingForceUpdate||(o.shouldComponentUpdate?d=o.shouldComponentUpdate(l,p,s):this._compositeType===b.PureClass&&(d=!g(c,l)||!g(o.state,p))),this._updateBatchNumber=null,d?(this._pendingForceUpdate=!1,this._performComponentUpdate(n,l,p,s,e,i)):(this._currentElement=n,this._context=i,o.props=l,o.state=p,o.context=s)},_processPendingState:function(e,t){var n=this._instance,r=this._pendingStateQueue,i=this._pendingReplaceState;if(this._pendingReplaceState=!1,this._pendingStateQueue=null,!r)return n.state;if(i&&1===r.length)return r[0];for(var o=s({},i?r[0]:n.state),a=i?1:0;a<r.length;a++){var u=r[a];s(o,"function"==typeof u?u.call(n,o,e,t):u)}return o},_performComponentUpdate:function(e,t,n,r,i,o){var a,s,u,c=this._instance,l=Boolean(c.componentDidUpdate);l&&(a=c.props,s=c.state,u=c.context),c.componentWillUpdate&&c.componentWillUpdate(t,n,r),this._currentElement=e,this._context=o,c.props=t,c.state=n,c.context=r,this._updateRenderedComponent(i,o),l&&i.getReactMountReady().enqueue(c.componentDidUpdate.bind(c,a,s,u),c)},_updateRenderedComponent:function(e,t){var n=this._renderedComponent,r=n._currentElement,i=this._renderValidatedComponent(),o=0;if(v(r,i))h.receiveComponent(n,i,e,this._processChildContext(t));else{var a=h.getHostNode(n);h.unmountComponent(n,!1);var s=f.getType(i);this._renderedNodeType=s;var u=this._instantiateReactComponent(i,s!==f.EMPTY);this._renderedComponent=u;var c=h.mountComponent(u,e,this._hostParent,this._hostContainerInfo,this._processChildContext(t),o);this._replaceNodeWithMarkup(a,c,n)}},_replaceNodeWithMarkup:function(e,t,n){c.replaceNodeWithMarkup(e,t,n)},_renderValidatedComponentWithoutOwnerOrContext:function(){var e=this._instance;return e.render()},_renderValidatedComponent:function(){var e;if(this._compositeType!==b.StatelessFunctional){l.current=this;try{e=this._renderValidatedComponentWithoutOwnerOrContext()}finally{l.current=null}}else e=this._renderValidatedComponentWithoutOwnerOrContext();return null===e||e===!1||u.isValidElement(e)||a("109",this.getName()||"ReactCompositeComponent"),e},attachRef:function(e,t){var n=this.getPublicInstance();null==n&&a("110");var r=t.getPublicInstance();(n.refs===m?n.refs={}:n.refs)[e]=r},detachRef:function(e){delete this.getPublicInstance().refs[e]},getName:function(){var e=this._currentElement.type,t=this._instance&&this._instance.constructor;return e.displayName||t&&t.displayName||e.name||t&&t.name||null},getPublicInstance:function(){var e=this._instance;return this._compositeType===b.StatelessFunctional?null:e},_instantiateReactComponent:null}},function(e,t,n){"use strict";var r=n(16),i=n(676),o=n(278),a=n(89),s=n(46),u=n(689),c=n(705),l=n(283),p=n(712);n(5);i.inject();var d={findDOMNode:c,render:o.render,unmountComponentAtNode:o.unmountComponentAtNode,version:u,unstable_batchedUpdates:s.batchedUpdates,unstable_renderSubtreeIntoContainer:p};"undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__&&"function"==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.inject&&__REACT_DEVTOOLS_GLOBAL_HOOK__.inject({ComponentTree:{getClosestInstanceFromNode:r.getClosestInstanceFromNode,getNodeFromInstance:function(e){return e._renderedComponent&&(e=l(e)),e?r.getNodeFromInstance(e):null}},Mount:o,Reconciler:a});e.exports=d},function(e,t,n){"use strict";function r(e){if(e){var t=e._currentElement._owner||null;if(t){var n=t.getName();if(n)return" This DOM node was rendered by `"+n+"`."}}return""}function i(e,t){t&&(Y[e._tag]&&(null!=t.children||null!=t.dangerouslySetInnerHTML)&&m("137",e._tag,e._currentElement._owner?" Check the render method of "+e._currentElement._owner.getName()+".":""),null!=t.dangerouslySetInnerHTML&&(null!=t.children&&m("60"),"object"==typeof t.dangerouslySetInnerHTML&&j in t.dangerouslySetInnerHTML||m("61")),null!=t.style&&"object"!=typeof t.style&&m("62",r(e)))}function o(e,t,n,r){if(!(r instanceof A)){var i=e._hostContainerInfo;U(t,i._node&&i._node.nodeType===W?i._node:i._ownerDocument),r.getReactMountReady().enqueue(a,{inst:e,registrationName:t,listener:n})}}function a(){var e=this;x.putListener(e.inst,e.registrationName,e.listener)}function s(){M.postMountWrapper(this)}function u(){O.postMountWrapper(this)}function c(){P.postMountWrapper(this)}function l(){var e=this;e._rootNodeID||m("63");var t=F(e);switch(t||m("64"),e._tag){case"iframe":case"object":e._wrapperState.listeners=[T.trapBubbledEvent("topLoad","load",t)];break;case"video":case"audio":e._wrapperState.listeners=[];for(var n in V)V.hasOwnProperty(n)&&e._wrapperState.listeners.push(T.trapBubbledEvent(n,V[n],t));break;case"source":e._wrapperState.listeners=[T.trapBubbledEvent("topError","error",t)];break;case"img":e._wrapperState.listeners=[T.trapBubbledEvent("topError","error",t),T.trapBubbledEvent("topLoad","load",t)];break;case"form":e._wrapperState.listeners=[T.trapBubbledEvent("topReset","reset",t),T.trapBubbledEvent("topSubmit","submit",t)];break;case"input":case"select":case"textarea":e._wrapperState.listeners=[T.trapBubbledEvent("topInvalid","invalid",t)]}}function p(){R.postUpdateWrapper(this)}function d(e){X.call(K,e)||($.test(e)||m("65",e),K[e]=!0)}function f(e,t){return e.indexOf("-")>=0||null!=t.is}function h(e){var t=e.type;d(t),this._currentElement=e,this._tag=t.toLowerCase(),this._namespaceURI=null,this._renderedChildren=null,this._previousStyle=null,this._previousStyleCopy=null,this._hostNode=null,this._hostParent=null,this._rootNodeID=0,this._domID=0,this._hostContainerInfo=null,this._wrapperState=null,this._topLevelWrapper=null,this._flags=0}var m=n(7),g=n(13),v=n(651),b=n(653),y=n(87),_=n(174),w=n(88),E=n(271),x=n(102),S=n(175),T=n(124),C=n(272),I=n(16),M=n(669),P=n(670),R=n(273),O=n(673),k=(n(39),n(682)),A=n(687),N=(n(32),n(127)),D=(n(1),n(186),n(169),n(188),n(5),C),L=x.deleteListener,F=I.getNodeFromInstance,U=T.listenTo,B=S.registrationNameModules,H={string:!0,number:!0},j="__html",z={children:null,dangerouslySetInnerHTML:null,suppressContentEditableWarning:null},W=11,V={topAbort:"abort",topCanPlay:"canplay",topCanPlayThrough:"canplaythrough",topDurationChange:"durationchange",topEmptied:"emptied",topEncrypted:"encrypted",topEnded:"ended",topError:"error",topLoadedData:"loadeddata",topLoadedMetadata:"loadedmetadata",topLoadStart:"loadstart",topPause:"pause",topPlay:"play",topPlaying:"playing",topProgress:"progress",topRateChange:"ratechange",topSeeked:"seeked",topSeeking:"seeking",topStalled:"stalled",topSuspend:"suspend",topTimeUpdate:"timeupdate",topVolumeChange:"volumechange",topWaiting:"waiting"},G={area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0},q={listing:!0,pre:!0,textarea:!0},Y=g({menuitem:!0},G),$=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,K={},X={}.hasOwnProperty,Z=1;h.displayName="ReactDOMComponent",h.Mixin={mountComponent:function(e,t,n,r){this._rootNodeID=Z++,this._domID=n._idCounter++,this._hostParent=t,this._hostContainerInfo=n;var o=this._currentElement.props;switch(this._tag){case"audio":case"form":case"iframe":case"img":case"link":case"object":case"source":case"video":this._wrapperState={listeners:null},e.getReactMountReady().enqueue(l,this);break;case"input":M.mountWrapper(this,o,t),o=M.getHostProps(this,o),e.getReactMountReady().enqueue(l,this);break;case"option":P.mountWrapper(this,o,t),o=P.getHostProps(this,o);break;case"select":R.mountWrapper(this,o,t),o=R.getHostProps(this,o),e.getReactMountReady().enqueue(l,this);break;case"textarea":O.mountWrapper(this,o,t),o=O.getHostProps(this,o),e.getReactMountReady().enqueue(l,this)}i(this,o);var a,p;null!=t?(a=t._namespaceURI,p=t._tag):n._tag&&(a=n._namespaceURI,p=n._tag),(null==a||a===_.svg&&"foreignobject"===p)&&(a=_.html),a===_.html&&("svg"===this._tag?a=_.svg:"math"===this._tag&&(a=_.mathml)),this._namespaceURI=a;var d;if(e.useCreateElement){var f,h=n._ownerDocument;if(a===_.html)if("script"===this._tag){var m=h.createElement("div"),g=this._currentElement.type;m.innerHTML="<"+g+"></"+g+">",f=m.removeChild(m.firstChild)}else f=o.is?h.createElement(this._currentElement.type,o.is):h.createElement(this._currentElement.type);else f=h.createElementNS(a,this._currentElement.type);I.precacheNode(this,f),this._flags|=D.hasCachedChildNodes,this._hostParent||E.setAttributeForRoot(f),this._updateDOMProperties(null,o,e);var b=y(f);this._createInitialChildren(e,o,r,b),d=b}else{var w=this._createOpenTagMarkupAndPutListeners(e,o),x=this._createContentMarkup(e,o,r);d=!x&&G[this._tag]?w+"/>":w+">"+x+"</"+this._currentElement.type+">"}switch(this._tag){case"input":e.getReactMountReady().enqueue(s,this),o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"textarea":e.getReactMountReady().enqueue(u,this),o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"select":o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"button":o.autoFocus&&e.getReactMountReady().enqueue(v.focusDOMComponent,this);break;case"option":e.getReactMountReady().enqueue(c,this)}return d},_createOpenTagMarkupAndPutListeners:function(e,t){var n="<"+this._currentElement.type;for(var r in t)if(t.hasOwnProperty(r)){var i=t[r];if(null!=i)if(B.hasOwnProperty(r))i&&o(this,r,i,e);else{"style"===r&&(i&&(i=this._previousStyleCopy=g({},t.style)),i=b.createMarkupForStyles(i,this));var a=null;null!=this._tag&&f(this._tag,t)?z.hasOwnProperty(r)||(a=E.createMarkupForCustomAttribute(r,i)):a=E.createMarkupForProperty(r,i),a&&(n+=" "+a)}}return e.renderToStaticMarkup?n:(this._hostParent||(n+=" "+E.createMarkupForRoot()),n+=" "+E.createMarkupForID(this._domID))},_createContentMarkup:function(e,t,n){var r="",i=t.dangerouslySetInnerHTML;if(null!=i)null!=i.__html&&(r=i.__html);else{var o=H[typeof t.children]?t.children:null,a=null!=o?null:t.children;if(null!=o)r=N(o);else if(null!=a){var s=this.mountChildren(a,e,n);r=s.join("")}}return q[this._tag]&&"\n"===r.charAt(0)?"\n"+r:r},_createInitialChildren:function(e,t,n,r){var i=t.dangerouslySetInnerHTML;if(null!=i)null!=i.__html&&y.queueHTML(r,i.__html);else{var o=H[typeof t.children]?t.children:null,a=null!=o?null:t.children;if(null!=o)""!==o&&y.queueText(r,o);else if(null!=a)for(var s=this.mountChildren(a,e,n),u=0;u<s.length;u++)y.queueChild(r,s[u])}},receiveComponent:function(e,t,n){var r=this._currentElement;this._currentElement=e,this.updateComponent(t,r,e,n)},updateComponent:function(e,t,n,r){var o=t.props,a=this._currentElement.props;switch(this._tag){case"input":o=M.getHostProps(this,o),a=M.getHostProps(this,a);break;case"option":o=P.getHostProps(this,o),a=P.getHostProps(this,a);break;case"select":o=R.getHostProps(this,o),a=R.getHostProps(this,a);break;case"textarea":o=O.getHostProps(this,o),a=O.getHostProps(this,a)}switch(i(this,a),this._updateDOMProperties(o,a,e),this._updateDOMChildren(o,a,e,r),this._tag){case"input":M.updateWrapper(this);break;case"textarea":O.updateWrapper(this);break;case"select":e.getReactMountReady().enqueue(p,this)}},_updateDOMProperties:function(e,t,n){var r,i,a;for(r in e)if(!t.hasOwnProperty(r)&&e.hasOwnProperty(r)&&null!=e[r])if("style"===r){var s=this._previousStyleCopy;for(i in s)s.hasOwnProperty(i)&&(a=a||{},a[i]="");this._previousStyleCopy=null}else B.hasOwnProperty(r)?e[r]&&L(this,r):f(this._tag,e)?z.hasOwnProperty(r)||E.deleteValueForAttribute(F(this),r):(w.properties[r]||w.isCustomAttribute(r))&&E.deleteValueForProperty(F(this),r);for(r in t){var u=t[r],c="style"===r?this._previousStyleCopy:null!=e?e[r]:void 0;if(t.hasOwnProperty(r)&&u!==c&&(null!=u||null!=c))if("style"===r)if(u?u=this._previousStyleCopy=g({},u):this._previousStyleCopy=null,c){for(i in c)!c.hasOwnProperty(i)||u&&u.hasOwnProperty(i)||(a=a||{},a[i]="");for(i in u)u.hasOwnProperty(i)&&c[i]!==u[i]&&(a=a||{},a[i]=u[i])}else a=u;else if(B.hasOwnProperty(r))u?o(this,r,u,n):c&&L(this,r);else if(f(this._tag,t))z.hasOwnProperty(r)||E.setValueForAttribute(F(this),r,u);else if(w.properties[r]||w.isCustomAttribute(r)){var l=F(this);null!=u?E.setValueForProperty(l,r,u):E.deleteValueForProperty(l,r)}}a&&b.setValueForStyles(F(this),a,this)},_updateDOMChildren:function(e,t,n,r){var i=H[typeof e.children]?e.children:null,o=H[typeof t.children]?t.children:null,a=e.dangerouslySetInnerHTML&&e.dangerouslySetInnerHTML.__html,s=t.dangerouslySetInnerHTML&&t.dangerouslySetInnerHTML.__html,u=null!=i?null:e.children,c=null!=o?null:t.children,l=null!=i||null!=a,p=null!=o||null!=s;null!=u&&null==c?this.updateChildren(null,n,r):l&&!p&&this.updateTextContent(""),null!=o?i!==o&&this.updateTextContent(""+o):null!=s?a!==s&&this.updateMarkup(""+s):null!=c&&this.updateChildren(c,n,r)},getHostNode:function(){return F(this)},unmountComponent:function(e){switch(this._tag){case"audio":case"form":case"iframe":case"img":case"link":case"object":case"source":case"video":var t=this._wrapperState.listeners;if(t)for(var n=0;n<t.length;n++)t[n].remove();break;case"html":case"head":case"body":m("66",this._tag)}this.unmountChildren(e),I.uncacheNode(this),x.deleteAllListeners(this),this._rootNodeID=0,this._domID=0,this._wrapperState=null},getPublicInstance:function(){return F(this)}},g(h.prototype,h.Mixin,k.Mixin),e.exports=h},function(e,t,n){"use strict";function r(e,t){var n={_topLevelWrapper:e,_idCounter:1,_ownerDocument:t?t.nodeType===i?t:t.ownerDocument:null,_node:t,_tag:t?t.nodeName.toLowerCase():null,_namespaceURI:t?t.namespaceURI:null};return n}var i=(n(188),9);e.exports=r},function(e,t,n){"use strict";var r=n(13),i=n(87),o=n(16),a=function(e){this._currentElement=null,this._hostNode=null,this._hostParent=null,this._hostContainerInfo=null,this._domID=0};r(a.prototype,{mountComponent:function(e,t,n,r){this._domID=n._idCounter++,this._hostParent=t,this._hostContainerInfo=n;var a=" react-empty: "+this._domID+" ";if(e.useCreateElement){var s=n._ownerDocument,u=s.createComment(a);return o.precacheNode(this,u),i(u)}return e.renderToStaticMarkup?"":"<!--"+a+"-->"},receiveComponent:function(){},getHostNode:function(){return o.getNodeFromInstance(this)},unmountComponent:function(){o.uncacheNode(this)}}),e.exports=a},function(e,t,n){"use strict";e.exports={useCreateElement:!0,useFiber:!1}},function(e,t,n){"use strict";var r=n(173),i=n(16);e.exports={dangerouslyProcessChildrenUpdates:function(e,t){var n=i.getNodeFromInstance(e);r.processUpdates(n,t)}}},function(e,t,n){"use strict";function r(){this._rootNodeID&&d.updateWrapper(this)}function i(e){return"checkbox"===e.type||"radio"===e.type?null!=e.checked:null!=e.value}function o(e){var t=this._currentElement.props,n=c.executeOnChange(t,e);p.asap(r,this);var i=t.name;if("radio"===t.type&&null!=i){for(var o=l.getNodeFromInstance(this),s=o;s.parentNode;)s=s.parentNode;for(var u=s.querySelectorAll("input[name="+JSON.stringify(""+i)+'][type="radio"]'),d=0;d<u.length;d++){var f=u[d];if(f!==o&&f.form===o.form){var h=l.getInstanceFromNode(f);h||a("90"),p.asap(r,h)}}}return n}var a=n(7),s=n(13),u=n(271),c=n(178),l=n(16),p=n(46),d=(n(1),n(5),{getHostProps:function(e,t){var n=c.getValue(t),r=c.getChecked(t);return s({type:void 0,step:void 0,min:void 0,max:void 0},t,{defaultChecked:void 0,defaultValue:void 0,value:null!=n?n:e._wrapperState.initialValue,checked:null!=r?r:e._wrapperState.initialChecked,onChange:e._wrapperState.onChange})},mountWrapper:function(e,t){var n=t.defaultValue;e._wrapperState={initialChecked:null!=t.checked?t.checked:t.defaultChecked,initialValue:null!=t.value?t.value:n,listeners:null,onChange:o.bind(e),controlled:i(t)}},updateWrapper:function(e){var t=e._currentElement.props,n=t.checked;null!=n&&u.setValueForProperty(l.getNodeFromInstance(e),"checked",n||!1);var r=l.getNodeFromInstance(e),i=c.getValue(t);if(null!=i)if(0===i&&""===r.value)r.value="0";else if("number"===t.type){var o=parseFloat(r.value,10)||0;i!=o&&(r.value=""+i)}else i!=r.value&&(r.value=""+i);else null==t.value&&null!=t.defaultValue&&r.defaultValue!==""+t.defaultValue&&(r.defaultValue=""+t.defaultValue),null==t.checked&&null!=t.defaultChecked&&(r.defaultChecked=!!t.defaultChecked)},postMountWrapper:function(e){var t=e._currentElement.props,n=l.getNodeFromInstance(e);switch(t.type){case"submit":case"reset":break;case"color":case"date":case"datetime":case"datetime-local":case"month":case"time":case"week":n.value="",n.value=n.defaultValue;break;default:n.value=n.value}var r=n.name;""!==r&&(n.name=""),n.defaultChecked=!n.defaultChecked,n.defaultChecked=!n.defaultChecked,""!==r&&(n.name=r)}});e.exports=d},function(e,t,n){"use strict";function r(e){var t="";return o.Children.forEach(e,function(e){null!=e&&("string"==typeof e||"number"==typeof e?t+=e:u||(u=!0))}),t}var i=n(13),o=n(90),a=n(16),s=n(273),u=(n(5),!1);e.exports={mountWrapper:function(e,t,n){var i=null;if(null!=n){var o=n;"optgroup"===o._tag&&(o=o._hostParent),null!=o&&"select"===o._tag&&(i=s.getSelectValueContext(o))}var a=null;if(null!=i){var u;if(u=null!=t.value?t.value+"":r(t.children),a=!1,Array.isArray(i)){for(var c=0;c<i.length;c++)if(""+i[c]===u){a=!0;break}}else a=""+i===u}e._wrapperState={selected:a}},postMountWrapper:function(e){var t=e._currentElement.props;if(null!=t.value){a.getNodeFromInstance(e).setAttribute("value",t.value)}},getHostProps:function(e,t){var n=i({selected:void 0,children:void 0},t);null!=e._wrapperState.selected&&(n.selected=e._wrapperState.selected);var o=r(t.children);return o&&(n.children=o),n}}},function(e,t,n){"use strict";function r(e,t,n,r){return e===n&&t===r}function i(e){var t=document.selection,n=t.createRange(),r=n.text.length,i=n.duplicate();i.moveToElementText(e),i.setEndPoint("EndToStart",n);var o=i.text.length;return{start:o,end:o+r}}function o(e){var t=window.getSelection&&window.getSelection();if(!t||0===t.rangeCount)return null;var n=t.anchorNode,i=t.anchorOffset,o=t.focusNode,a=t.focusOffset,s=t.getRangeAt(0);try{}catch(e){return null}var u=r(t.anchorNode,t.anchorOffset,t.focusNode,t.focusOffset),c=u?0:s.toString().length,l=s.cloneRange();l.selectNodeContents(e),l.setEnd(s.startContainer,s.startOffset);var p=r(l.startContainer,l.startOffset,l.endContainer,l.endOffset),d=p?0:l.toString().length,f=d+c,h=document.createRange();h.setStart(n,i),h.setEnd(o,a);var m=h.collapsed;return{start:m?f:d,end:m?d:f}}function a(e,t){var n,r,i=document.selection.createRange().duplicate();void 0===t.end?(n=t.start,r=n):t.start>t.end?(n=t.end,r=t.start):(n=t.start,r=t.end),i.moveToElementText(e),i.moveStart("character",n),i.setEndPoint("EndToStart",i),i.moveEnd("character",r-n),i.select()}function s(e,t){if(window.getSelection){var n=window.getSelection(),r=e[l()].length,i=Math.min(t.start,r),o=void 0===t.end?i:Math.min(t.end,r);if(!n.extend&&i>o){var a=o;o=i,i=a}var s=c(e,i),u=c(e,o);if(s&&u){var p=document.createRange();p.setStart(s.node,s.offset),n.removeAllRanges(),i>o?(n.addRange(p),n.extend(u.node,u.offset)):(p.setEnd(u.node,u.offset),n.addRange(p))}}}var u=n(24),c=n(709),l=n(284),p=u.canUseDOM&&"selection"in document&&!("getSelection"in window);e.exports={getOffsets:p?i:o,setOffsets:p?a:s}},function(e,t,n){"use strict";var r=n(7),i=n(13),o=n(173),a=n(87),s=n(16),u=n(127),c=(n(1),n(188),function(e){this._currentElement=e,this._stringText=""+e,this._hostNode=null,this._hostParent=null,this._domID=0,this._mountIndex=0,this._closingComment=null,this._commentNodes=null});i(c.prototype,{mountComponent:function(e,t,n,r){var i=n._idCounter++,o=" react-text: "+i+" ";if(this._domID=i,this._hostParent=t,e.useCreateElement){var c=n._ownerDocument,l=c.createComment(o),p=c.createComment(" /react-text "),d=a(c.createDocumentFragment());return a.queueChild(d,a(l)),this._stringText&&a.queueChild(d,a(c.createTextNode(this._stringText))),a.queueChild(d,a(p)),s.precacheNode(this,l),this._closingComment=p,d}var f=u(this._stringText);return e.renderToStaticMarkup?f:"<!--"+o+"-->"+f+"<!-- /react-text -->"},receiveComponent:function(e,t){if(e!==this._currentElement){this._currentElement=e;var n=""+e;if(n!==this._stringText){this._stringText=n;var r=this.getHostNode();o.replaceDelimitedText(r[0],r[1],n)}}},getHostNode:function(){var e=this._commentNodes;if(e)return e;if(!this._closingComment)for(var t=s.getNodeFromInstance(this),n=t.nextSibling;;){if(null==n&&r("67",this._domID),8===n.nodeType&&" /react-text "===n.nodeValue){this._closingComment=n;break}n=n.nextSibling}return e=[this._hostNode,this._closingComment],this._commentNodes=e,e},unmountComponent:function(){this._closingComment=null,this._commentNodes=null,s.uncacheNode(this)}}),e.exports=c},function(e,t,n){"use strict";function r(){this._rootNodeID&&l.updateWrapper(this)}function i(e){var t=this._currentElement.props,n=s.executeOnChange(t,e);return c.asap(r,this),n}var o=n(7),a=n(13),s=n(178),u=n(16),c=n(46),l=(n(1),n(5),{getHostProps:function(e,t){return null!=t.dangerouslySetInnerHTML&&o("91"),a({},t,{value:void 0,defaultValue:void 0,children:""+e._wrapperState.initialValue,onChange:e._wrapperState.onChange})},mountWrapper:function(e,t){var n=s.getValue(t),r=n;if(null==n){var a=t.defaultValue,u=t.children;null!=u&&(null!=a&&o("92"),Array.isArray(u)&&(u.length<=1||o("93"),u=u[0]),a=""+u),null==a&&(a=""),r=a}e._wrapperState={initialValue:""+r,listeners:null,onChange:i.bind(e)}},updateWrapper:function(e){var t=e._currentElement.props,n=u.getNodeFromInstance(e),r=s.getValue(t);if(null!=r){var i=""+r;i!==n.value&&(n.value=i),null==t.defaultValue&&(n.defaultValue=i)}null!=t.defaultValue&&(n.defaultValue=t.defaultValue)},postMountWrapper:function(e){var t=u.getNodeFromInstance(e),n=t.textContent;n===e._wrapperState.initialValue&&(t.value=n)}});e.exports=l},function(e,t,n){"use strict";function r(e,t){"_hostNode"in e||u("33"),"_hostNode"in t||u("33");for(var n=0,r=e;r;r=r._hostParent)n++;for(var i=0,o=t;o;o=o._hostParent)i++;for(;n-i>0;)e=e._hostParent,n--;for(;i-n>0;)t=t._hostParent,i--;for(var a=n;a--;){if(e===t)return e;e=e._hostParent,t=t._hostParent}return null}function i(e,t){"_hostNode"in e||u("35"),"_hostNode"in t||u("35");for(;t;){if(t===e)return!0;t=t._hostParent}return!1}function o(e){return"_hostNode"in e||u("36"),e._hostParent}function a(e,t,n){for(var r=[];e;)r.push(e),e=e._hostParent;var i;for(i=r.length;i-- >0;)t(r[i],"captured",n);for(i=0;i<r.length;i++)t(r[i],"bubbled",n)}function s(e,t,n,i,o){for(var a=e&&t?r(e,t):null,s=[];e&&e!==a;)s.push(e),e=e._hostParent;for(var u=[];t&&t!==a;)u.push(t),t=t._hostParent;var c;for(c=0;c<s.length;c++)n(s[c],"bubbled",i);for(c=u.length;c-- >0;)n(u[c],"captured",o)}var u=n(7);n(1);e.exports={isAncestor:i,getLowestCommonAncestor:r,getParentInstance:o,traverseTwoPhase:a,traverseEnterLeave:s}},function(e,t,n){"use strict";function r(){this.reinitializeTransaction()}var i=n(13),o=n(46),a=n(126),s=n(32),u={initialize:s,close:function(){d.isBatchingUpdates=!1}},c={initialize:s,close:o.flushBatchedUpdates.bind(o)},l=[c,u];i(r.prototype,a,{getTransactionWrappers:function(){return l}});var p=new r,d={isBatchingUpdates:!1,batchedUpdates:function(e,t,n,r,i,o){var a=d.isBatchingUpdates;return d.isBatchingUpdates=!0,a?e(t,n,r,i,o):p.perform(e,null,t,n,r,i,o)}};e.exports=d},function(e,t,n){"use strict";function r(){x||(x=!0,b.EventEmitter.injectReactEventListener(v),b.EventPluginHub.injectEventPluginOrder(s),b.EventPluginUtils.injectComponentTree(d),b.EventPluginUtils.injectTreeTraversal(h),b.EventPluginHub.injectEventPluginsByName({SimpleEventPlugin:E,EnterLeaveEventPlugin:u,ChangeEventPlugin:a,SelectEventPlugin:w,BeforeInputEventPlugin:o}),b.HostComponent.injectGenericComponentClass(p),b.HostComponent.injectTextComponentClass(m),b.DOMProperty.injectDOMPropertyConfig(i),b.DOMProperty.injectDOMPropertyConfig(c),b.DOMProperty.injectDOMPropertyConfig(_),b.EmptyComponent.injectEmptyComponentFactory(function(e){return new f(e)}),b.Updates.injectReconcileTransaction(y),b.Updates.injectBatchingStrategy(g),b.Component.injectEnvironment(l))}var i=n(650),o=n(652),a=n(654),s=n(656),u=n(657),c=n(659),l=n(661),p=n(664),d=n(16),f=n(666),h=n(674),m=n(672),g=n(675),v=n(679),b=n(680),y=n(685),_=n(690),w=n(691),E=n(692),x=!1;e.exports={inject:r}},function(e,t,n){"use strict";e.exports="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103},function(e,t,n){"use strict";function r(e){i.enqueueEvents(e),i.processEventQueue(!1)}var i=n(102);e.exports={handleTopLevel:function(e,t,n,o){r(i.extractEvents(e,t,n,o))}}},function(e,t,n){"use strict";function r(e){for(;e._hostParent;)e=e._hostParent;var t=p.getNodeFromInstance(e);return p.getClosestInstanceFromNode(t.parentNode)}function i(e,t){this.topLevelType=e,this.nativeEvent=t,this.ancestors=[]}function o(e){var t=f(e.nativeEvent),n=p.getClosestInstanceFromNode(t),i=n;do{e.ancestors.push(i),i=i&&r(i)}while(i);for(var o=0;o<e.ancestors.length;o++)n=e.ancestors[o],m._handleTopLevel(e.topLevelType,n,e.nativeEvent,f(e.nativeEvent))}function a(e){e(h(window))}var s=n(13),u=n(259),c=n(24),l=n(72),p=n(16),d=n(46),f=n(185),h=n(598);s(i.prototype,{destructor:function(){this.topLevelType=null,this.nativeEvent=null,this.ancestors.length=0}}),l.addPoolingTo(i,l.twoArgumentPooler);var m={_enabled:!0,_handleTopLevel:null,WINDOW_HANDLE:c.canUseDOM?window:null,setHandleTopLevel:function(e){m._handleTopLevel=e},setEnabled:function(e){m._enabled=!!e},isEnabled:function(){return m._enabled},trapBubbledEvent:function(e,t,n){return n?u.listen(n,t,m.dispatchEvent.bind(null,e)):null},trapCapturedEvent:function(e,t,n){return n?u.capture(n,t,m.dispatchEvent.bind(null,e)):null},monitorScrollValue:function(e){var t=a.bind(null,e);u.listen(window,"scroll",t)},dispatchEvent:function(e,t){if(m._enabled){var n=i.getPooled(e,t);try{d.batchedUpdates(o,n)}finally{i.release(n)}}}};e.exports=m},function(e,t,n){"use strict";var r=n(88),i=n(102),o=n(176);e.exports={Component:n(179).injection,DOMProperty:r.injection,EmptyComponent:n(274).injection,EventPluginHub:i.injection,EventPluginUtils:o.injection,EventEmitter:n(124).injection,HostComponent:n(276).injection,Updates:n(46).injection}},function(e,t,n){"use strict";var r=n(703),i=/^<\!\-\-/,o={CHECKSUM_ATTR_NAME:"data-react-checksum",addChecksumToMarkup:function(e){var t=r(e);return i.test(e)?e:e.replace(/\/?>/," "+o.CHECKSUM_ATTR_NAME+'="'+t+'"$&')},canReuseMarkup:function(e,t){var n=t.getAttribute(o.CHECKSUM_ATTR_NAME);return n=n&&parseInt(n,10),r(e)===n}};e.exports=o},function(e,t,n){"use strict";function r(e,t,n){return{type:"INSERT_MARKUP",content:e,fromIndex:null,fromNode:null,toIndex:n,afterNode:t}}function i(e,t,n){return{type:"MOVE_EXISTING",content:null,fromIndex:e._mountIndex,fromNode:d.getHostNode(e),toIndex:n,afterNode:t}}function o(e,t){return{type:"REMOVE_NODE",content:null,fromIndex:e._mountIndex,fromNode:t,toIndex:null,afterNode:null}}function a(e){return{type:"SET_MARKUP",content:e,fromIndex:null,fromNode:null,toIndex:null,afterNode:null}}function s(e){return{type:"TEXT_CONTENT",content:e,fromIndex:null,fromNode:null,toIndex:null,afterNode:null}}function u(e,t){return t&&(e=e||[],e.push(t)),e}function c(e,t){p.processChildrenUpdates(e,t)}var l=n(7),p=n(179),d=(n(104),n(39),n(56),n(89)),f=n(660),h=(n(32),n(706));n(1);e.exports={Mixin:{_reconcilerInstantiateChildren:function(e,t,n){return f.instantiateChildren(e,t,n)},_reconcilerUpdateChildren:function(e,t,n,r,i,o){var a,s=0;return a=h(t,s),f.updateChildren(e,a,n,r,i,this,this._hostContainerInfo,o,s),a},mountChildren:function(e,t,n){var r=this._reconcilerInstantiateChildren(e,t,n);this._renderedChildren=r;var i=[],o=0;for(var a in r)if(r.hasOwnProperty(a)){var s=r[a],u=0,c=d.mountComponent(s,t,this,this._hostContainerInfo,n,u);s._mountIndex=o++,i.push(c)}return i},updateTextContent:function(e){var t=this._renderedChildren;f.unmountChildren(t,!1);for(var n in t)t.hasOwnProperty(n)&&l("118");c(this,[s(e)])},updateMarkup:function(e){var t=this._renderedChildren;f.unmountChildren(t,!1);for(var n in t)t.hasOwnProperty(n)&&l("118");c(this,[a(e)])},updateChildren:function(e,t,n){this._updateChildren(e,t,n)},_updateChildren:function(e,t,n){var r=this._renderedChildren,i={},o=[],a=this._reconcilerUpdateChildren(r,e,o,i,t,n);if(a||r){var s,l=null,p=0,f=0,h=0,m=null;for(s in a)if(a.hasOwnProperty(s)){var g=r&&r[s],v=a[s];g===v?(l=u(l,this.moveChild(g,m,p,f)),f=Math.max(g._mountIndex,f),g._mountIndex=p):(g&&(f=Math.max(g._mountIndex,f)),l=u(l,this._mountChildAtIndex(v,o[h],m,p,t,n)),h++),p++,m=d.getHostNode(v)}for(s in i)i.hasOwnProperty(s)&&(l=u(l,this._unmountChild(r[s],i[s])));l&&c(this,l),this._renderedChildren=a}},unmountChildren:function(e){f.unmountChildren(this._renderedChildren,e),this._renderedChildren=null},moveChild:function(e,t,n,r){if(e._mountIndex<r)return i(e,t,n)},createChild:function(e,t,n){return r(n,t,e._mountIndex)},removeChild:function(e,t){return o(e,t)},_mountChildAtIndex:function(e,t,n,r,i,o){return e._mountIndex=r,this.createChild(e,n,t)},_unmountChild:function(e,t){var n=this.removeChild(e,t);return e._mountIndex=null,n}}}},function(e,t,n){"use strict";function r(e){return!(!e||"function"!=typeof e.attachRef||"function"!=typeof e.detachRef)}var i=n(7);n(1);e.exports={addComponentAsRefTo:function(e,t,n){r(n)||i("119"),n.attachRef(t,e)},removeComponentAsRefFrom:function(e,t,n){r(n)||i("120");var o=n.getPublicInstance();o&&o.refs[t]===e.getPublicInstance()&&n.detachRef(t)}}},function(e,t,n){"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},function(e,t,n){"use strict";function r(e){this.reinitializeTransaction(),this.renderToStaticMarkup=!1,this.reactMountReady=o.getPooled(null),this.useCreateElement=e}var i=n(13),o=n(270),a=n(72),s=n(124),u=n(277),c=(n(39),n(126)),l=n(181),p={initialize:u.getSelectionInformation,close:u.restoreSelection},d={initialize:function(){var e=s.isEnabled();return s.setEnabled(!1),e},close:function(e){s.setEnabled(e)}},f={initialize:function(){this.reactMountReady.reset()},close:function(){this.reactMountReady.notifyAll()}},h=[p,d,f];i(r.prototype,c,{getTransactionWrappers:function(){return h},getReactMountReady:function(){return this.reactMountReady},getUpdateQueue:function(){return l},checkpoint:function(){return this.reactMountReady.checkpoint()},rollback:function(e){this.reactMountReady.rollback(e)},destructor:function(){o.release(this.reactMountReady),this.reactMountReady=null}}),a.addPoolingTo(r),e.exports=r},function(e,t,n){"use strict";function r(e,t,n){"function"==typeof e?e(t.getPublicInstance()):o.addComponentAsRefTo(t,e,n)}function i(e,t,n){"function"==typeof e?e(null):o.removeComponentAsRefFrom(t,e,n)}var o=n(683),a={};a.attachRefs=function(e,t){if(null!==t&&"object"==typeof t){var n=t.ref;null!=n&&r(n,e,t._owner)}},a.shouldUpdateRefs=function(e,t){var n=null,r=null;null!==e&&"object"==typeof e&&(n=e.ref,r=e._owner);var i=null,o=null;return null!==t&&"object"==typeof t&&(i=t.ref,o=t._owner),n!==i||"string"==typeof i&&o!==r},a.detachRefs=function(e,t){if(null!==t&&"object"==typeof t){var n=t.ref;null!=n&&i(n,e,t._owner)}},e.exports=a},function(e,t,n){"use strict";function r(e){this.reinitializeTransaction(),this.renderToStaticMarkup=e,this.useCreateElement=!1,this.updateQueue=new s(this)}var i=n(13),o=n(72),a=n(126),s=(n(39),n(688)),u=[],c={enqueue:function(){}};i(r.prototype,a,{getTransactionWrappers:function(){return u},getReactMountReady:function(){return c},getUpdateQueue:function(){return this.updateQueue},destructor:function(){},checkpoint:function(){},rollback:function(){}}),o.addPoolingTo(r),e.exports=r},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var i=n(181);n(5);e.exports=function(){function e(t){r(this,e),this.transaction=t}return e.prototype.isMounted=function(e){return!1},e.prototype.enqueueCallback=function(e,t,n){this.transaction.isInTransaction()&&i.enqueueCallback(e,t,n)},e.prototype.enqueueForceUpdate=function(e){this.transaction.isInTransaction()&&i.enqueueForceUpdate(e)},e.prototype.enqueueReplaceState=function(e,t){this.transaction.isInTransaction()&&i.enqueueReplaceState(e,t)},e.prototype.enqueueSetState=function(e,t){this.transaction.isInTransaction()&&i.enqueueSetState(e,t)},e}()},function(e,t,n){"use strict";e.exports="15.5.4"},function(e,t,n){"use strict";var r={xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace"},i={accentHeight:"accent-height",accumulate:0,additive:0,alignmentBaseline:"alignment-baseline",allowReorder:"allowReorder",alphabetic:0,amplitude:0,arabicForm:"arabic-form",ascent:0,attributeName:"attributeName",attributeType:"attributeType",autoReverse:"autoReverse",azimuth:0,baseFrequency:"baseFrequency",baseProfile:"baseProfile",baselineShift:"baseline-shift",bbox:0,begin:0,bias:0,by:0,calcMode:"calcMode",capHeight:"cap-height",clip:0,clipPath:"clip-path",clipRule:"clip-rule",clipPathUnits:"clipPathUnits",colorInterpolation:"color-interpolation",colorInterpolationFilters:"color-interpolation-filters",colorProfile:"color-profile",colorRendering:"color-rendering",contentScriptType:"contentScriptType",contentStyleType:"contentStyleType",cursor:0,cx:0,cy:0,d:0,decelerate:0,descent:0,diffuseConstant:"diffuseConstant",direction:0,display:0,divisor:0,dominantBaseline:"dominant-baseline",dur:0,dx:0,dy:0,edgeMode:"edgeMode",elevation:0,enableBackground:"enable-background",end:0,exponent:0,externalResourcesRequired:"externalResourcesRequired",fill:0,fillOpacity:"fill-opacity",fillRule:"fill-rule",filter:0,filterRes:"filterRes",filterUnits:"filterUnits",floodColor:"flood-color",floodOpacity:"flood-opacity",focusable:0,fontFamily:"font-family",fontSize:"font-size",fontSizeAdjust:"font-size-adjust",fontStretch:"font-stretch",fontStyle:"font-style",fontVariant:"font-variant",fontWeight:"font-weight",format:0,from:0,fx:0,fy:0,g1:0,g2:0,glyphName:"glyph-name",glyphOrientationHorizontal:"glyph-orientation-horizontal",glyphOrientationVertical:"glyph-orientation-vertical",glyphRef:"glyphRef",gradientTransform:"gradientTransform",gradientUnits:"gradientUnits",hanging:0,horizAdvX:"horiz-adv-x",horizOriginX:"horiz-origin-x",ideographic:0,imageRendering:"image-rendering",in:0,in2:0,intercept:0,k:0,k1:0,k2:0,k3:0,k4:0,kernelMatrix:"kernelMatrix",kernelUnitLength:"kernelUnitLength",kerning:0,keyPoints:"keyPoints",keySplines:"keySplines",keyTimes:"keyTimes",lengthAdjust:"lengthAdjust",letterSpacing:"letter-spacing",lightingColor:"lighting-color",limitingConeAngle:"limitingConeAngle",local:0,markerEnd:"marker-end",markerMid:"marker-mid",markerStart:"marker-start",markerHeight:"markerHeight",markerUnits:"markerUnits",markerWidth:"markerWidth",mask:0,maskContentUnits:"maskContentUnits",maskUnits:"maskUnits",mathematical:0,mode:0,numOctaves:"numOctaves",offset:0,opacity:0,operator:0,order:0,orient:0,orientation:0,origin:0,overflow:0,overlinePosition:"overline-position",overlineThickness:"overline-thickness",paintOrder:"paint-order",panose1:"panose-1",pathLength:"pathLength",patternContentUnits:"patternContentUnits",patternTransform:"patternTransform",patternUnits:"patternUnits",pointerEvents:"pointer-events",points:0,pointsAtX:"pointsAtX",pointsAtY:"pointsAtY",pointsAtZ:"pointsAtZ",preserveAlpha:"preserveAlpha",preserveAspectRatio:"preserveAspectRatio",primitiveUnits:"primitiveUnits",r:0,radius:0,refX:"refX",refY:"refY",renderingIntent:"rendering-intent",repeatCount:"repeatCount",repeatDur:"repeatDur",requiredExtensions:"requiredExtensions",requiredFeatures:"requiredFeatures",restart:0,result:0,rotate:0,rx:0,ry:0,scale:0,seed:0,shapeRendering:"shape-rendering",slope:0,spacing:0,specularConstant:"specularConstant",specularExponent:"specularExponent",speed:0,spreadMethod:"spreadMethod",startOffset:"startOffset",stdDeviation:"stdDeviation",stemh:0,stemv:0,stitchTiles:"stitchTiles",stopColor:"stop-color",stopOpacity:"stop-opacity",strikethroughPosition:"strikethrough-position",strikethroughThickness:"strikethrough-thickness",string:0,stroke:0,strokeDasharray:"stroke-dasharray",strokeDashoffset:"stroke-dashoffset",strokeLinecap:"stroke-linecap",strokeLinejoin:"stroke-linejoin",strokeMiterlimit:"stroke-miterlimit",strokeOpacity:"stroke-opacity",strokeWidth:"stroke-width",surfaceScale:"surfaceScale",systemLanguage:"systemLanguage",tableValues:"tableValues",targetX:"targetX",targetY:"targetY",textAnchor:"text-anchor",textDecoration:"text-decoration",textRendering:"text-rendering",textLength:"textLength",to:0,transform:0,u1:0,u2:0,underlinePosition:"underline-position",underlineThickness:"underline-thickness",unicode:0,unicodeBidi:"unicode-bidi",unicodeRange:"unicode-range",unitsPerEm:"units-per-em",vAlphabetic:"v-alphabetic",vHanging:"v-hanging",vIdeographic:"v-ideographic",vMathematical:"v-mathematical",values:0,vectorEffect:"vector-effect",version:0,vertAdvY:"vert-adv-y",vertOriginX:"vert-origin-x",vertOriginY:"vert-origin-y",viewBox:"viewBox",viewTarget:"viewTarget",visibility:0,widths:0,wordSpacing:"word-spacing",writingMode:"writing-mode",x:0,xHeight:"x-height",x1:0,x2:0,xChannelSelector:"xChannelSelector",xlinkActuate:"xlink:actuate",xlinkArcrole:"xlink:arcrole",xlinkHref:"xlink:href",xlinkRole:"xlink:role",xlinkShow:"xlink:show",xlinkTitle:"xlink:title",xlinkType:"xlink:type",xmlBase:"xml:base",xmlns:0,xmlnsXlink:"xmlns:xlink",xmlLang:"xml:lang",xmlSpace:"xml:space",y:0,y1:0,y2:0,yChannelSelector:"yChannelSelector",z:0,zoomAndPan:"zoomAndPan"},o={Properties:{},DOMAttributeNamespaces:{xlinkActuate:r.xlink,xlinkArcrole:r.xlink,xlinkHref:r.xlink,xlinkRole:r.xlink,xlinkShow:r.xlink,xlinkTitle:r.xlink,xlinkType:r.xlink,xmlBase:r.xml,xmlLang:r.xml,xmlSpace:r.xml},DOMAttributeNames:{}};Object.keys(i).forEach(function(e){o.Properties[e]=0,i[e]&&(o.DOMAttributeNames[e]=i[e])}),e.exports=o},function(e,t,n){"use strict";function r(e){if("selectionStart"in e&&u.hasSelectionCapabilities(e))return{start:e.selectionStart,end:e.selectionEnd};if(window.getSelection){var t=window.getSelection();return{anchorNode:t.anchorNode,anchorOffset:t.anchorOffset,focusNode:t.focusNode,focusOffset:t.focusOffset}}if(document.selection){var n=document.selection.createRange();return{parentElement:n.parentElement(),text:n.text,top:n.boundingTop,left:n.boundingLeft}}}function i(e,t){if(b||null==m||m!==l())return null;var n=r(m);if(!v||!d(v,n)){v=n;var i=c.getPooled(h.select,g,e,t);return i.type="select",i.target=m,o.accumulateTwoPhaseDispatches(i),i}return null}var o=n(103),a=n(24),s=n(16),u=n(277),c=n(55),l=n(261),p=n(286),d=n(169),f=a.canUseDOM&&"documentMode"in document&&document.documentMode<=11,h={select:{phasedRegistrationNames:{bubbled:"onSelect",captured:"onSelectCapture"},dependencies:["topBlur","topContextMenu","topFocus","topKeyDown","topKeyUp","topMouseDown","topMouseUp","topSelectionChange"]}},m=null,g=null,v=null,b=!1,y=!1;e.exports={eventTypes:h,extractEvents:function(e,t,n,r){if(!y)return null;var o=t?s.getNodeFromInstance(t):window;switch(e){case"topFocus":(p(o)||"true"===o.contentEditable)&&(m=o,g=t,v=null);break;case"topBlur":m=null,g=null,v=null;break;case"topMouseDown":b=!0;break;case"topContextMenu":case"topMouseUp":return b=!1,i(n,r);case"topSelectionChange":if(f)break;case"topKeyDown":case"topKeyUp":return i(n,r)}return null},didPutListener:function(e,t,n){"onSelect"===t&&(y=!0)}}},function(e,t,n){"use strict";function r(e){return"."+e._rootNodeID}function i(e){return"button"===e||"input"===e||"select"===e||"textarea"===e}var o=n(7),a=n(259),s=n(103),u=n(16),c=n(693),l=n(694),p=n(55),d=n(697),f=n(699),h=n(125),m=n(696),g=n(700),v=n(701),b=n(105),y=n(702),_=n(32),w=n(183),E=(n(1),{}),x={};["abort","animationEnd","animationIteration","animationStart","blur","canPlay","canPlayThrough","click","contextMenu","copy","cut","doubleClick","drag","dragEnd","dragEnter","dragExit","dragLeave","dragOver","dragStart","drop","durationChange","emptied","encrypted","ended","error","focus","input","invalid","keyDown","keyPress","keyUp","load","loadedData","loadedMetadata","loadStart","mouseDown","mouseMove","mouseOut","mouseOver","mouseUp","paste","pause","play","playing","progress","rateChange","reset","scroll","seeked","seeking","stalled","submit","suspend","timeUpdate","touchCancel","touchEnd","touchMove","touchStart","transitionEnd","volumeChange","waiting","wheel"].forEach(function(e){var t=e[0].toUpperCase()+e.slice(1),n="on"+t,r="top"+t,i={phasedRegistrationNames:{bubbled:n,captured:n+"Capture"},dependencies:[r]};E[e]=i,x[r]=i});var S={};e.exports={eventTypes:E,extractEvents:function(e,t,n,r){var i=x[e];if(!i)return null;var a;switch(e){case"topAbort":case"topCanPlay":case"topCanPlayThrough":case"topDurationChange":case"topEmptied":case"topEncrypted":case"topEnded":case"topError":case"topInput":case"topInvalid":case"topLoad":case"topLoadedData":case"topLoadedMetadata":case"topLoadStart":case"topPause":case"topPlay":case"topPlaying":case"topProgress":case"topRateChange":case"topReset":case"topSeeked":case"topSeeking":case"topStalled":case"topSubmit":case"topSuspend":case"topTimeUpdate":case"topVolumeChange":case"topWaiting":a=p;break;case"topKeyPress":if(0===w(n))return null;case"topKeyDown":case"topKeyUp":a=f;break;case"topBlur":case"topFocus":a=d;break;case"topClick":if(2===n.button)return null;case"topDoubleClick":case"topMouseDown":case"topMouseMove":case"topMouseUp":case"topMouseOut":case"topMouseOver":case"topContextMenu":a=h;break;case"topDrag":case"topDragEnd":case"topDragEnter":case"topDragExit":case"topDragLeave":case"topDragOver":case"topDragStart":case"topDrop":a=m;break;case"topTouchCancel":case"topTouchEnd":case"topTouchMove":case"topTouchStart":a=g;break;case"topAnimationEnd":case"topAnimationIteration":case"topAnimationStart":a=c;break;case"topTransitionEnd":a=v;break;case"topScroll":a=b;break;case"topWheel":a=y;break;case"topCopy":case"topCut":case"topPaste":a=l}a||o("86",e);var u=a.getPooled(i,t,n,r);return s.accumulateTwoPhaseDispatches(u),u},didPutListener:function(e,t,n){if("onClick"===t&&!i(e._tag)){var o=r(e),s=u.getNodeFromInstance(e);S[o]||(S[o]=a.listen(s,"click",_))}},willDeleteListener:function(e,t){if("onClick"===t&&!i(e._tag)){var n=r(e);S[n].remove(),delete S[n]}}}},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(55);i.augmentClass(r,{animationName:null,elapsedTime:null,pseudoElement:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(55);i.augmentClass(r,{clipboardData:function(e){return"clipboardData"in e?e.clipboardData:window.clipboardData}}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(55);i.augmentClass(r,{data:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(125);i.augmentClass(r,{dataTransfer:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(105);i.augmentClass(r,{relatedTarget:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(55);i.augmentClass(r,{data:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(105),o=n(183),a=n(707),s=n(184);i.augmentClass(r,{key:a,location:null,ctrlKey:null,shiftKey:null,altKey:null,metaKey:null,repeat:null,locale:null,getModifierState:s,charCode:function(e){return"keypress"===e.type?o(e):0},keyCode:function(e){return"keydown"===e.type||"keyup"===e.type?e.keyCode:0},which:function(e){return"keypress"===e.type?o(e):"keydown"===e.type||"keyup"===e.type?e.keyCode:0}}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(105),o=n(184);i.augmentClass(r,{touches:null,targetTouches:null,changedTouches:null,altKey:null,metaKey:null,ctrlKey:null,shiftKey:null,getModifierState:o}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(55);i.augmentClass(r,{propertyName:null,elapsedTime:null,pseudoElement:null}),e.exports=r},function(e,t,n){"use strict";function r(e,t,n,r){return i.call(this,e,t,n,r)}var i=n(125);i.augmentClass(r,{deltaX:function(e){return"deltaX"in e?e.deltaX:"wheelDeltaX"in e?-e.wheelDeltaX:0},deltaY:function(e){return"deltaY"in e?e.deltaY:"wheelDeltaY"in e?-e.wheelDeltaY:"wheelDelta"in e?-e.wheelDelta:0},deltaZ:null,deltaMode:null}),e.exports=r},function(e,t,n){"use strict";function r(e){for(var t=1,n=0,r=0,o=e.length,a=o&-4;r<a;){for(var s=Math.min(r+4096,a);r<s;r+=4)n+=(t+=e.charCodeAt(r))+(t+=e.charCodeAt(r+1))+(t+=e.charCodeAt(r+2))+(t+=e.charCodeAt(r+3));t%=i,n%=i}for(;r<o;r++)n+=t+=e.charCodeAt(r);return t%=i,n%=i,t|n<<16}var i=65521;e.exports=r},function(e,t,n){"use strict";function r(e,t,n){if(null==t||"boolean"==typeof t||""===t)return"";if(isNaN(t)||0===t||o.hasOwnProperty(e)&&o[e])return""+t;if("string"==typeof t){t=t.trim()}return t+"px"}var i=n(269),o=(n(5),i.isUnitlessNumber);e.exports=r},function(e,t,n){"use strict";function r(e){if(null==e)return null;if(1===e.nodeType)return e;var t=a.get(e);if(t)return t=s(t),t?o.getNodeFromInstance(t):null;"function"==typeof e.render?i("44"):i("45",Object.keys(e))}var i=n(7),o=(n(56),n(16)),a=n(104),s=n(283);n(1),n(5);e.exports=r},function(e,t,n){"use strict";(function(t){function r(e,t,n,r){if(e&&"object"==typeof e){var i=e,o=void 0===i[n];o&&null!=t&&(i[n]=t)}}function i(e,t){if(null==e)return e;var n={};return o(e,r,n),n}var o=(n(177),n(288));n(5);void 0!==t&&n.i({NODE_ENV:"production"}),e.exports=i}).call(t,n(106))},function(e,t,n){"use strict";function r(e){if(e.key){var t=o[e.key]||e.key;if("Unidentified"!==t)return t}if("keypress"===e.type){var n=i(e);return 13===n?"Enter":String.fromCharCode(n)}return"keydown"===e.type||"keyup"===e.type?a[e.keyCode]||"Unidentified":""}var i=n(183),o={Esc:"Escape",Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},a={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"};e.exports=r},function(e,t,n){"use strict";function r(e){var t=e&&(i&&e[i]||e[o]);if("function"==typeof t)return t}var i="function"==typeof Symbol&&Symbol.iterator,o="@@iterator";e.exports=r},function(e,t,n){"use strict";function r(e){for(;e&&e.firstChild;)e=e.firstChild;return e}function i(e){for(;e;){if(e.nextSibling)return e.nextSibling;e=e.parentNode}}function o(e,t){for(var n=r(e),o=0,a=0;n;){if(3===n.nodeType){if(a=o+n.textContent.length,o<=t&&a>=t)return{node:n,offset:t-o};o=a}n=r(i(n))}}e.exports=o},function(e,t,n){"use strict";function r(e,t){var n={};return n[e.toLowerCase()]=t.toLowerCase(),n["Webkit"+e]="webkit"+t,n["Moz"+e]="moz"+t,n["ms"+e]="MS"+t,n["O"+e]="o"+t.toLowerCase(),n}function i(e){if(s[e])return s[e];if(!a[e])return e;var t=a[e];for(var n in t)if(t.hasOwnProperty(n)&&n in u)return s[e]=t[n];return""}var o=n(24),a={animationend:r("Animation","AnimationEnd"),animationiteration:r("Animation","AnimationIteration"),animationstart:r("Animation","AnimationStart"),transitionend:r("Transition","TransitionEnd")},s={},u={};o.canUseDOM&&(u=document.createElement("div").style,"AnimationEvent"in window||(delete a.animationend.animation,delete a.animationiteration.animation,delete a.animationstart.animation),"TransitionEvent"in window||delete a.transitionend.transition),e.exports=i},function(e,t,n){"use strict";function r(e){return'"'+i(e)+'"'}var i=n(127);e.exports=r},function(e,t,n){"use strict";e.exports=n(278).renderSubtreeIntoContainer},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function i(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}n.d(t,"a",function(){return l});var a=n(2),s=(n.n(a),n(10)),u=n.n(s),c=n(291),l=(n(189),function(e){function t(n,o){r(this,t);var a=i(this,e.call(this,n,o));return a.store=n.store,a}return o(t,e),t.prototype.getChildContext=function(){return{store:this.store,storeSubscription:null}},t.prototype.render=function(){return a.Children.only(this.props.children)},t}(a.Component));l.propTypes={store:c.a.isRequired,children:u.a.element.isRequired},l.childContextTypes={store:c.a.isRequired,storeSubscription:c.b},l.displayName="Provider"},function(e,t,n){"use strict";function r(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}function i(e,t,n){for(var r=t.length-1;r>=0;r--){var i=t[r](e);if(i)return i}return function(t,r){throw new Error("Invalid value of type "+typeof e+" for "+n+" argument when connecting component "+r.wrappedComponentName+".")}}function o(e,t){return e===t}var a=n(289),s=n(721),u=n(715),c=n(716),l=n(717),p=n(718),d=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e};t.a=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=e.connectHOC,n=void 0===t?a.a:t,f=e.mapStateToPropsFactories,h=void 0===f?c.a:f,m=e.mapDispatchToPropsFactories,g=void 0===m?u.a:m,v=e.mergePropsFactories,b=void 0===v?l.a:v,y=e.selectorFactory,_=void 0===y?p.a:y;return function(e,t,a){var u=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},c=u.pure,l=void 0===c||c,p=u.areStatesEqual,f=void 0===p?o:p,m=u.areOwnPropsEqual,v=void 0===m?s.a:m,y=u.areStatePropsEqual,w=void 0===y?s.a:y,E=u.areMergedPropsEqual,x=void 0===E?s.a:E,S=r(u,["pure","areStatesEqual","areOwnPropsEqual","areStatePropsEqual","areMergedPropsEqual"]),T=i(e,h,"mapStateToProps"),C=i(t,g,"mapDispatchToProps"),I=i(a,b,"mergeProps");return n(_,d({methodName:"connect",getDisplayName:function(e){return"Connect("+e+")"},shouldHandleStateChanges:Boolean(e),initMapStateToProps:T,initMapDispatchToProps:C,initMergeProps:I,pure:l,areStatesEqual:f,areOwnPropsEqual:v,areStatePropsEqual:w,areMergedPropsEqual:x},S))}}()},function(e,t,n){"use strict";function r(e){return"function"==typeof e?n.i(s.a)(e,"mapDispatchToProps"):void 0}function i(e){return e?void 0:n.i(s.b)(function(e){return{dispatch:e}})}function o(e){return e&&"object"==typeof e?n.i(s.b)(function(t){return n.i(a.d)(e,t)}):void 0}var a=n(192),s=n(290);t.a=[r,i,o]},function(e,t,n){"use strict";function r(e){return"function"==typeof e?n.i(o.a)(e,"mapStateToProps"):void 0}function i(e){return e?void 0:n.i(o.b)(function(){return{}})}var o=n(290);t.a=[r,i]},function(e,t,n){"use strict";function r(e,t,n){return s({},n,e,t)}function i(e){return function(t,n){var r=n.pure,i=n.areMergedPropsEqual,o=!1,a=void 0;return function(t,n,s){var u=e(t,n,s);return o?r&&i(u,a)||(a=u):(o=!0,a=u),a}}}function o(e){return"function"==typeof e?i(e):void 0}function a(e){return e?void 0:function(){return r}}var s=(n(292),Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e});t.a=[o,a]},function(e,t,n){"use strict";function r(e,t){var n={};for(var r in e)t.indexOf(r)>=0||Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=e[r]);return n}function i(e,t,n,r){return function(i,o){return n(e(i,o),t(r,o),o)}}function o(e,t,n,r,i){function o(i,o){return h=i,m=o,g=e(h,m),v=t(r,m),b=n(g,v,m),f=!0,b}function a(){return g=e(h,m),t.dependsOnOwnProps&&(v=t(r,m)),b=n(g,v,m)}function s(){return e.dependsOnOwnProps&&(g=e(h,m)),t.dependsOnOwnProps&&(v=t(r,m)),b=n(g,v,m)}function u(){var t=e(h,m),r=!d(t,g);return g=t,r&&(b=n(g,v,m)),b}function c(e,t){var n=!p(t,m),r=!l(e,h);return h=e,m=t,n&&r?a():n?s():r?u():b}var l=i.areStatesEqual,p=i.areOwnPropsEqual,d=i.areStatePropsEqual,f=!1,h=void 0,m=void 0,g=void 0,v=void 0,b=void 0;return function(e,t){return f?c(e,t):o(e,t)}}function a(e,t){var n=t.initMapStateToProps,a=t.initMapDispatchToProps,s=t.initMergeProps,u=r(t,["initMapStateToProps","initMapDispatchToProps","initMergeProps"]),c=n(e,u),l=a(e,u),p=s(e,u);return(u.pure?o:i)(c,l,p,e,u)}t.a=a;n(719)},function(e,t,n){"use strict";n(189)},function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function i(){var e=[],t=[];return{clear:function(){t=o,e=o},notify:function(){for(var n=e=t,r=0;r<n.length;r++)n[r]()},subscribe:function(n){var r=!0;return t===e&&(t=e.slice()),t.push(n),function(){r&&e!==o&&(r=!1,t===e&&(t=e.slice()),t.splice(t.indexOf(n),1))}}}}n.d(t,"a",function(){return s});var o=null,a={notify:function(){}},s=function(){function e(t,n,i){r(this,e),this.store=t,this.parentSub=n,this.onStateChange=i,this.unsubscribe=null,this.listeners=a}return e.prototype.addNestedSub=function(e){return this.trySubscribe(),this.listeners.subscribe(e)},e.prototype.notifyNestedSubs=function(){this.listeners.notify()},e.prototype.isSubscribed=function(){return Boolean(this.unsubscribe)},e.prototype.trySubscribe=function(){this.unsubscribe||(this.unsubscribe=this.parentSub?this.parentSub.addNestedSub(this.onStateChange):this.store.subscribe(this.onStateChange),this.listeners=i())},e.prototype.tryUnsubscribe=function(){this.unsubscribe&&(this.unsubscribe(),this.unsubscribe=null,this.listeners.clear(),this.listeners=a)},e}()},function(e,t,n){"use strict";function r(e,t){return e===t?0!==e||0!==t||1/e==1/t:e!==e&&t!==t}function i(e,t){if(r(e,t))return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var n=Object.keys(e);if(n.length!==Object.keys(t).length)return!1;for(var i=0;i<n.length;i++)if(!o.call(t,n[i])||!r(e[n[i]],t[n[i]]))return!1;return!0}t.a=i;var o=Object.prototype.hasOwnProperty},function(e,t,n){"use strict";function r(e){var t={"=":"=0",":":"=2"};return"$"+(""+e).replace(/[=:]/g,function(e){return t[e]})}function i(e){var t={"=0":"=","=2":":"};return(""+e.substring("."===e[0]&&"$"===e[1]?2:1)).replace(/(=0|=2)/g,function(e){return t[e]})}e.exports={escape:r,unescape:i}},function(e,t,n){"use strict";var r=n(92),i=(n(1),function(e){var t=this;if(t.instancePool.length){var n=t.instancePool.pop();return t.call(n,e),n}return new t(e)}),o=function(e,t){var n=this;if(n.instancePool.length){var r=n.instancePool.pop();return n.call(r,e,t),r}return new n(e,t)},a=function(e,t,n){var r=this;if(r.instancePool.length){var i=r.instancePool.pop();return r.call(i,e,t,n),i}return new r(e,t,n)},s=function(e,t,n,r){var i=this;if(i.instancePool.length){var o=i.instancePool.pop();return i.call(o,e,t,n,r),o}return new i(e,t,n,r)},u=function(e){var t=this;e instanceof t||r("25"),e.destructor(),t.instancePool.length<t.poolSize&&t.instancePool.push(e)},c=i;e.exports={addPoolingTo:function(e,t){var n=e;return n.instancePool=[],n.getPooled=t||c,n.poolSize||(n.poolSize=10),n.release=u,n},oneArgumentPooler:i,twoArgumentPooler:o,threeArgumentPooler:a,fourArgumentPooler:s}},function(e,t,n){"use strict";function r(e){return(""+e).replace(_,"$&/")}function i(e,t){this.func=e,this.context=t,this.count=0}function o(e,t,n){e.func.call(e.context,t,e.count++)}function a(e,t,n){if(null==e)return e;var r=i.getPooled(t,n);v(e,o,r),i.release(r)}function s(e,t,n,r){this.result=e,this.keyPrefix=t,this.func=n,this.context=r,this.count=0}function u(e,t,n){var i=e.result,o=e.keyPrefix,a=e.func,s=e.context,u=a.call(s,t,e.count++);Array.isArray(u)?c(u,i,n,g.thatReturnsArgument):null!=u&&(m.isValidElement(u)&&(u=m.cloneAndReplaceKey(u,o+(!u.key||t&&t.key===u.key?"":r(u.key)+"/")+n)),i.push(u))}function c(e,t,n,i,o){var a="";null!=n&&(a=r(n)+"/");var c=s.getPooled(t,a,i,o);v(e,u,c),s.release(c)}function l(e,t,n){if(null==e)return e;var r=[];return c(e,r,null,t,n),r}function p(e,t,n){return null}function d(e,t){return v(e,p,null)}function f(e){var t=[];return c(e,t,null,g.thatReturnsArgument),t}var h=n(723),m=n(91),g=n(32),v=n(734),b=h.twoArgumentPooler,y=h.fourArgumentPooler,_=/\/+/g;i.prototype.destructor=function(){this.func=null,this.context=null,this.count=0},h.addPoolingTo(i,b),s.prototype.destructor=function(){this.result=null,this.keyPrefix=null,this.func=null,this.context=null,this.count=0},h.addPoolingTo(s,y),e.exports={forEach:a,map:l,mapIntoWithKeyPrefixInternal:c,count:d,toArray:f}},function(e,t,n){"use strict";function r(e){return e}function i(e,t){var n=_.hasOwnProperty(t)?_[t]:null;E.hasOwnProperty(t)&&"OVERRIDE_BASE"!==n&&d("73",t),e&&"DEFINE_MANY"!==n&&"DEFINE_MANY_MERGED"!==n&&d("74",t)}function o(e,t){if(t){"function"==typeof t&&d("75"),m.isValidElement(t)&&d("76");var n=e.prototype,r=n.__reactAutoBindPairs;t.hasOwnProperty(b)&&w.mixins(e,t.mixins);for(var o in t)if(t.hasOwnProperty(o)&&o!==b){var a=t[o],s=n.hasOwnProperty(o);if(i(s,o),w.hasOwnProperty(o))w[o](e,a);else{var l=_.hasOwnProperty(o),p="function"==typeof a,f=p&&!l&&!s&&t.autobind!==!1;if(f)r.push(o,a),n[o]=a;else if(s){var h=_[o];(!l||"DEFINE_MANY_MERGED"!==h&&"DEFINE_MANY"!==h)&&d("77",h,o),"DEFINE_MANY_MERGED"===h?n[o]=u(n[o],a):"DEFINE_MANY"===h&&(n[o]=c(n[o],a))}else n[o]=a}}}else;}function a(e,t){if(t)for(var n in t){var r=t[n];if(t.hasOwnProperty(n)){var i=n in w;i&&d("78",n);var o=n in e;o&&d("79",n),e[n]=r}}}function s(e,t){e&&t&&"object"==typeof e&&"object"==typeof t||d("80");for(var n in t)t.hasOwnProperty(n)&&(void 0!==e[n]&&d("81",n),e[n]=t[n]);return e}function u(e,t){return function(){var n=e.apply(this,arguments),r=t.apply(this,arguments);if(null==n)return r;if(null==r)return n;var i={};return s(i,n),s(i,r),i}}function c(e,t){return function(){e.apply(this,arguments),t.apply(this,arguments)}}function l(e,t){var n=t.bind(e);return n}function p(e){for(var t=e.__reactAutoBindPairs,n=0;n<t.length;n+=2){e[t[n]]=l(e,t[n+1])}}var d=n(92),f=n(13),h=n(190),m=n(91),g=(n(727),n(191)),v=n(100),b=(n(1),n(5),"mixins"),y=[],_={mixins:"DEFINE_MANY",statics:"DEFINE_MANY",propTypes:"DEFINE_MANY",contextTypes:"DEFINE_MANY",childContextTypes:"DEFINE_MANY",getDefaultProps:"DEFINE_MANY_MERGED",getInitialState:"DEFINE_MANY_MERGED",getChildContext:"DEFINE_MANY_MERGED",render:"DEFINE_ONCE",componentWillMount:"DEFINE_MANY",componentDidMount:"DEFINE_MANY",componentWillReceiveProps:"DEFINE_MANY",shouldComponentUpdate:"DEFINE_ONCE",componentWillUpdate:"DEFINE_MANY",componentDidUpdate:"DEFINE_MANY",componentWillUnmount:"DEFINE_MANY",updateComponent:"OVERRIDE_BASE"},w={displayName:function(e,t){e.displayName=t},mixins:function(e,t){if(t)for(var n=0;n<t.length;n++)o(e,t[n])},childContextTypes:function(e,t){e.childContextTypes=f({},e.childContextTypes,t)},contextTypes:function(e,t){e.contextTypes=f({},e.contextTypes,t)},getDefaultProps:function(e,t){e.getDefaultProps=e.getDefaultProps?u(e.getDefaultProps,t):t},propTypes:function(e,t){e.propTypes=f({},e.propTypes,t)},statics:function(e,t){a(e,t)},autobind:function(){}},E={replaceState:function(e,t){this.updater.enqueueReplaceState(this,e),t&&this.updater.enqueueCallback(this,t,"replaceState")},isMounted:function(){return this.updater.isMounted(this)}},x=function(){};f(x.prototype,h.prototype,E);e.exports={createClass:function(e){var t=r(function(e,n,r){this.__reactAutoBindPairs.length&&p(this),this.props=e,this.context=n,this.refs=v,this.updater=r||g,this.state=null;var i=this.getInitialState?this.getInitialState():null;("object"!=typeof i||Array.isArray(i))&&d("82",t.displayName||"ReactCompositeComponent"),this.state=i});t.prototype=new x,t.prototype.constructor=t,t.prototype.__reactAutoBindPairs=[],y.forEach(o.bind(null,t)),o(t,e),t.getDefaultProps&&(t.defaultProps=t.getDefaultProps()),t.prototype.render||d("83");for(var n in _)t.prototype[n]||(t.prototype[n]=null);return t},injection:{injectMixin:function(e){y.push(e)}}}},function(e,t,n){"use strict";var r=n(91),i=r.createFactory;e.exports={a:i("a"),abbr:i("abbr"),address:i("address"),area:i("area"),article:i("article"),aside:i("aside"),audio:i("audio"),b:i("b"),base:i("base"),bdi:i("bdi"),bdo:i("bdo"),big:i("big"),blockquote:i("blockquote"),body:i("body"),br:i("br"),button:i("button"),canvas:i("canvas"),caption:i("caption"),cite:i("cite"),code:i("code"),col:i("col"),colgroup:i("colgroup"),data:i("data"),datalist:i("datalist"),dd:i("dd"),del:i("del"),details:i("details"),dfn:i("dfn"),dialog:i("dialog"),div:i("div"),dl:i("dl"),dt:i("dt"),em:i("em"),embed:i("embed"),fieldset:i("fieldset"),figcaption:i("figcaption"),figure:i("figure"),footer:i("footer"),form:i("form"),h1:i("h1"),h2:i("h2"),h3:i("h3"),h4:i("h4"),h5:i("h5"),h6:i("h6"),head:i("head"),header:i("header"),hgroup:i("hgroup"),hr:i("hr"),html:i("html"),i:i("i"),iframe:i("iframe"),img:i("img"),input:i("input"),ins:i("ins"),kbd:i("kbd"),keygen:i("keygen"),label:i("label"),legend:i("legend"),li:i("li"),link:i("link"),main:i("main"),map:i("map"),mark:i("mark"),menu:i("menu"),menuitem:i("menuitem"),meta:i("meta"),meter:i("meter"),nav:i("nav"),noscript:i("noscript"),object:i("object"),ol:i("ol"),optgroup:i("optgroup"),option:i("option"),output:i("output"),p:i("p"),param:i("param"),picture:i("picture"),pre:i("pre"),progress:i("progress"),q:i("q"),rp:i("rp"),rt:i("rt"),ruby:i("ruby"),s:i("s"),samp:i("samp"),script:i("script"),section:i("section"),select:i("select"),small:i("small"),source:i("source"),span:i("span"),strong:i("strong"),style:i("style"),sub:i("sub"),summary:i("summary"),sup:i("sup"),table:i("table"),tbody:i("tbody"),td:i("td"),textarea:i("textarea"),tfoot:i("tfoot"),th:i("th"),thead:i("thead"),time:i("time"),title:i("title"),tr:i("tr"),track:i("track"),u:i("u"),ul:i("ul"),var:i("var"),video:i("video"),wbr:i("wbr"),circle:i("circle"),clipPath:i("clipPath"),defs:i("defs"),ellipse:i("ellipse"),g:i("g"),image:i("image"),line:i("line"),linearGradient:i("linearGradient"),mask:i("mask"),path:i("path"),pattern:i("pattern"),polygon:i("polygon"),polyline:i("polyline"),radialGradient:i("radialGradient"),rect:i("rect"),stop:i("stop"),svg:i("svg"),text:i("text"),tspan:i("tspan")}},function(e,t,n){"use strict";var r={};e.exports=r},function(e,t,n){"use strict";var r=n(91),i=r.isValidElement;e.exports=n(266)(i)},function(e,t,n){"use strict";function r(e,t,n){this.props=e,this.context=t,this.refs=u,this.updater=n||s}function i(){}var o=n(13),a=n(190),s=n(191),u=n(100);i.prototype=a.prototype,r.prototype=new i,r.prototype.constructor=r,o(r.prototype,a.prototype),r.prototype.isPureReactComponent=!0,e.exports=r},function(e,t,n){"use strict";e.exports="15.5.4"},function(e,t,n){"use strict";function r(e){var t=e&&(i&&e[i]||e[o]);if("function"==typeof t)return t}var i="function"==typeof Symbol&&Symbol.iterator,o="@@iterator";e.exports=r},function(e,t,n){"use strict";function r(){return i++}var i=1;e.exports=r},function(e,t,n){"use strict";function r(e){return o.isValidElement(e)||i("143"),e}var i=n(92),o=n(91);n(1);e.exports=r},function(e,t,n){"use strict";function r(e,t){return e&&"object"==typeof e&&null!=e.key?c.escape(e.key):t.toString(36)}function i(e,t,n,o){var d=typeof e;if("undefined"!==d&&"boolean"!==d||(e=null),null===e||"string"===d||"number"===d||"object"===d&&e.$$typeof===s)return n(o,e,""===t?l+r(e,0):t),1;var f,h,m=0,g=""===t?l:t+p;if(Array.isArray(e))for(var v=0;v<e.length;v++)f=e[v],h=g+r(f,v),m+=i(f,h,n,o);else{var b=u(e);if(b){var y,_=b.call(e);if(b!==e.entries)for(var w=0;!(y=_.next()).done;)f=y.value,h=g+r(f,w++),m+=i(f,h,n,o);else for(;!(y=_.next()).done;){var E=y.value;E&&(f=E[1],h=g+c.escape(E[0])+p+r(f,0),m+=i(f,h,n,o))}}else if("object"===d){var x="",S=String(e);a("31","[object Object]"===S?"object with keys {"+Object.keys(e).join(", ")+"}":S,x)}}return m}function o(e,t,n){return null==e?0:i(e,"",t,n)}var a=n(92),s=(n(56),n(294)),u=n(731),c=(n(1),n(722)),l=(n(5),"."),p=":";e.exports=o},function(e,t,n){"use strict";function r(e){return function(t){var n=t.dispatch,r=t.getState;return function(t){return function(i){return"function"==typeof i?i(n,r,e):t(i)}}}}t.__esModule=!0;var i=r();i.withExtraArgument=r,t.default=i},function(e,t,n){"use strict";function r(){for(var e=arguments.length,t=Array(e),n=0;n<e;n++)t[n]=arguments[n];return function(e){return function(n,r,a){var s=e(n,r,a),u=s.dispatch,c=[],l={getState:s.getState,dispatch:function(e){return u(e)}};return c=t.map(function(e){return e(l)}),u=i.a.apply(void 0,c)(s.dispatch),o({},s,{dispatch:u})}}}t.a=r;var i=n(296),o=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e}},function(e,t,n){"use strict";function r(e,t){return function(){return t(e.apply(void 0,arguments))}}function i(e,t){if("function"==typeof e)return r(e,t);if("object"!=typeof e||null===e)throw new Error("bindActionCreators expected an object or a function, instead received "+(null===e?"null":typeof e)+'. Did you write "import ActionCreators from" instead of "import * as ActionCreators from"?');for(var n=Object.keys(e),i={},o=0;o<n.length;o++){var a=n[o],s=e[a];"function"==typeof s&&(i[a]=r(s,t))}return i}t.a=i},function(e,t,n){"use strict";n(297),n(172),n(298)},function(e,t,n){(function(t,n){!function(t){"use strict";function r(e,t,n,r){var i=t&&t.prototype instanceof o?t:o,a=Object.create(i.prototype);return a._invoke=l(e,n,new h(r||[])),a}function i(e,t,n){try{return{type:"normal",arg:e.call(t,n)}}catch(e){return{type:"throw",arg:e}}}function o(){}function a(){}function s(){}function u(e){["next","throw","return"].forEach(function(t){e[t]=function(e){return this._invoke(t,e)}})}function c(e){function t(n,r,o,a){var s=i(e[n],e,r);if("throw"!==s.type){var u=s.arg,c=u.value;return c&&"object"==typeof c&&y.call(c,"__await")?Promise.resolve(c.__await).then(function(e){t("next",e,o,a)},function(e){t("throw",e,o,a)}):Promise.resolve(c).then(function(e){u.value=e,o(u)},a)}a(s.arg)}function r(e,n){function r(){return new Promise(function(r,i){t(e,n,r,i)})}return o=o?o.then(r,r):r()}"object"==typeof n&&n.domain&&(t=n.domain.bind(t));var o;this._invoke=r}function l(e,t,n){var r=T;return function(o,a){if(r===I)throw new Error("Generator is already running");if(r===M){if("throw"===o)throw a;return g()}for(n.method=o,n.arg=a;;){var s=n.delegate;if(s){var u=p(s,n);if(u){if(u===P)continue;return u}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===T)throw r=M,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=I;var c=i(e,t,n);if("normal"===c.type){if(r=n.done?M:C,c.arg===P)continue;return{value:c.arg,done:n.done}}"throw"===c.type&&(r=M,n.method="throw",n.arg=c.arg)}}}function p(e,t){var n=e.iterator[t.method];if(n===v){if(t.delegate=null,"throw"===t.method){if(e.iterator.return&&(t.method="return",t.arg=v,p(e,t),"throw"===t.method))return P;t.method="throw",t.arg=new TypeError("The iterator does not provide a 'throw' method")}return P}var r=i(n,e.iterator,t.arg);if("throw"===r.type)return t.method="throw",t.arg=r.arg,t.delegate=null,P;var o=r.arg;return o?o.done?(t[e.resultName]=o.value,t.next=e.nextLoc,"return"!==t.method&&(t.method="next",t.arg=v),t.delegate=null,P):o:(t.method="throw",t.arg=new TypeError("iterator result is not an object"),t.delegate=null,P)}function d(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function f(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function h(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(d,this),this.reset(!0)}function m(e){if(e){var t=e[w];if(t)return t.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var n=-1,r=function t(){for(;++n<e.length;)if(y.call(e,n))return t.value=e[n],t.done=!1,t;return t.value=v,t.done=!0,t};return r.next=r}}return{next:g}}function g(){return{value:v,done:!0}}var v,b=Object.prototype,y=b.hasOwnProperty,_="function"==typeof Symbol?Symbol:{},w=_.iterator||"@@iterator",E=_.toStringTag||"@@toStringTag",x="object"==typeof e,S=t.regeneratorRuntime;if(S)return void(x&&(e.exports=S));S=t.regeneratorRuntime=x?e.exports:{},S.wrap=r;var T="suspendedStart",C="suspendedYield",I="executing",M="completed",P={},R={};R[w]=function(){return this};var O=Object.getPrototypeOf,k=O&&O(O(m([])));k&&k!==b&&y.call(k,w)&&(R=k);var A=s.prototype=o.prototype=Object.create(R);a.prototype=A.constructor=s,s.constructor=a,s[E]=a.displayName="GeneratorFunction",S.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===a||"GeneratorFunction"===(t.displayName||t.name))},S.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,s):(e.__proto__=s,E in e||(e[E]="GeneratorFunction")),e.prototype=Object.create(A),e},S.awrap=function(e){return{__await:e}},u(c.prototype),S.AsyncIterator=c,S.async=function(e,t,n,i){var o=new c(r(e,t,n,i));return S.isGeneratorFunction(t)?o:o.next().then(function(e){return e.done?e.value:o.next()})},u(A),A[E]="Generator",A.toString=function(){return"[object Generator]"},S.keys=function(e){var t=[];for(var n in e)t.push(n);return t.reverse(),function n(){for(;t.length;){var r=t.pop();if(r in e)return n.value=r,n.done=!1,n}return n.done=!0,n}},S.values=m,h.prototype={constructor:h,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=v,this.done=!1,this.delegate=null,this.method="next",this.arg=v,this.tryEntries.forEach(f),!e)for(var t in this)"t"===t.charAt(0)&&y.call(this,t)&&!isNaN(+t.slice(1))&&(this[t]=v)},stop:function(){this.done=!0;var e=this.tryEntries[0],t=e.completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(e){function t(t,r){return o.type="throw",o.arg=e,n.next=t,r&&(n.method="next",n.arg=v),!!r}if(this.done)throw e;for(var n=this,r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r],o=i.completion;if("root"===i.tryLoc)return t("end");if(i.tryLoc<=this.prev){var a=y.call(i,"catchLoc"),s=y.call(i,"finallyLoc");if(a&&s){if(this.prev<i.catchLoc)return t(i.catchLoc,!0);if(this.prev<i.finallyLoc)return t(i.finallyLoc)}else if(a){if(this.prev<i.catchLoc)return t(i.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return t(i.finallyLoc)}}}},abrupt:function(e,t){for(var n=this.tryEntries.length-1;n>=0;--n){var r=this.tryEntries[n];if(r.tryLoc<=this.prev&&y.call(r,"finallyLoc")&&this.prev<r.finallyLoc){var i=r;break}}i&&("break"===e||"continue"===e)&&i.tryLoc<=t&&t<=i.finallyLoc&&(i=null);var o=i?i.completion:{};return o.type=e,o.arg=t,i?(this.method="next",this.next=i.finallyLoc,P):this.complete(o)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),P},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.finallyLoc===e)return this.complete(n.completion,n.afterLoc),f(n),P}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.tryLoc===e){var r=n.completion;if("throw"===r.type){var i=r.arg;f(n)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(e,t,n){return this.delegate={iterator:m(e),resultName:t,nextLoc:n},"next"===this.method&&(this.arg=v),P}}}("object"==typeof t?t:"object"==typeof window?window:"object"==typeof self?self:this)}).call(t,n(34),n(106))},function(e,t,n){"use strict";var r=n(123),i=n(251),o=n(252),a=n(299),s=n(300),u=n(741),c=r.call(Function.apply,a),l=function(e,t){o.RequireObjectCoercible(e);var n=[t];return arguments.length>2&&n.push(arguments[2]),c(e,n)};i(l,{getPolyfill:s,implementation:a,shim:u}),e.exports=l},function(e,t,n){"use strict";var r=n(300),i=n(251);e.exports=function(){var e=r();return i(String.prototype,{padStart:e},{padStart:function(){return String.prototype.padStart!==e}}),e}},function(e,t,n){e.exports=n(743)},function(e,t,n){"use strict";(function(e,r){Object.defineProperty(t,"__esModule",{value:!0});var i,o=n(744),a=function(e){return e&&e.__esModule?e:{default:e}}(o);i="undefined"!=typeof self?self:"undefined"!=typeof window?window:void 0!==e?e:r;var s=(0,a.default)(i);t.default=s}).call(t,n(34),n(747)(e))},function(e,t,n){"use strict";function r(e){var t,n=e.Symbol;return"function"==typeof n?n.observable?t=n.observable:(t=n("observable"),n.observable=t):t="@@observable",t}Object.defineProperty(t,"__esModule",{value:!0}),t.default=r},function(e,t,n){var r;!function(i,o){"use strict";var a="model",s="name",u="type",c="vendor",l="version",p="mobile",d="tablet",f={extend:function(e,t){var n={};for(var r in e)n[r]=t[r]&&t[r].length%2==0?t[r].concat(e[r]):e[r];return n},has:function(e,t){return"string"==typeof e&&t.toLowerCase().indexOf(e.toLowerCase())!==-1},lowerize:function(e){return e.toLowerCase()},major:function(e){return"string"==typeof e?e.replace(/[^\d\.]/g,"").split(".")[0]:void 0},trim:function(e){return e.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")}},h={rgx:function(){for(var e,t,n,r,i,o,a,s=0,u=arguments;s<u.length&&!o;){var c=u[s],l=u[s+1];if(void 0===e){e={};for(r in l)l.hasOwnProperty(r)&&(i=l[r],"object"==typeof i?e[i[0]]=void 0:e[i]=void 0)}for(t=n=0;t<c.length&&!o;)if(o=c[t++].exec(this.getUA()))for(r=0;r<l.length;r++)a=o[++n],i=l[r],"object"==typeof i&&i.length>0?2==i.length?e[i[0]]="function"==typeof i[1]?i[1].call(this,a):i[1]:3==i.length?e[i[0]]="function"!=typeof i[1]||i[1].exec&&i[1].test?a?a.replace(i[1],i[2]):void 0:a?i[1].call(this,a,i[2]):void 0:4==i.length&&(e[i[0]]=a?i[3].call(this,a.replace(i[1],i[2])):void 0):e[i]=a?a:void 0;s+=2}return e},str:function(e,t){for(var n in t)if("object"==typeof t[n]&&t[n].length>0){for(var r=0;r<t[n].length;r++)if(f.has(t[n][r],e))return"?"===n?void 0:n}else if(f.has(t[n],e))return"?"===n?void 0:n;return e}},m={browser:{oldsafari:{version:{"1.0":"/8",1.2:"/1",1.3:"/3","2.0":"/412","2.0.2":"/416","2.0.3":"/417","2.0.4":"/419","?":"/"}}},device:{amazon:{model:{"Fire Phone":["SD","KF"]}},sprint:{model:{"Evo Shift 4G":"7373KT"},vendor:{HTC:"APA",Sprint:"Sprint"}}},os:{windows:{version:{ME:"4.90","NT 3.11":"NT3.51","NT 4.0":"NT4.0",2000:"NT 5.0",XP:["NT 5.1","NT 5.2"],Vista:"NT 6.0",7:"NT 6.1",8:"NT 6.2",8.1:"NT 6.3",10:["NT 6.4","NT 10.0"],RT:"ARM"}}}},g={browser:[[/(opera\smini)\/([\w\.-]+)/i,/(opera\s[mobiletab]+).+version\/([\w\.-]+)/i,/(opera).+version\/([\w\.]+)/i,/(opera)[\/\s]+([\w\.]+)/i],[s,l],[/(opios)[\/\s]+([\w\.]+)/i],[[s,"Opera Mini"],l],[/\s(opr)\/([\w\.]+)/i],[[s,"Opera"],l],[/(kindle)\/([\w\.]+)/i,/(lunascape|maxthon|netfront|jasmine|blazer)[\/\s]?([\w\.]+)*/i,/(avant\s|iemobile|slim|baidu)(?:browser)?[\/\s]?([\w\.]*)/i,/(?:ms|\()(ie)\s([\w\.]+)/i,/(rekonq)\/([\w\.]+)*/i,/(chromium|flock|rockmelt|midori|epiphany|silk|skyfire|ovibrowser|bolt|iron|vivaldi|iridium|phantomjs)\/([\w\.-]+)/i],[s,l],[/(trident).+rv[:\s]([\w\.]+).+like\sgecko/i],[[s,"IE"],l],[/(edge)\/((\d+)?[\w\.]+)/i],[s,l],[/(yabrowser)\/([\w\.]+)/i],[[s,"Yandex"],l],[/(comodo_dragon)\/([\w\.]+)/i],[[s,/_/g," "],l],[/(micromessenger)\/([\w\.]+)/i],[[s,"WeChat"],l],[/xiaomi\/miuibrowser\/([\w\.]+)/i],[l,[s,"MIUI Browser"]],[/\swv\).+(chrome)\/([\w\.]+)/i],[[s,/(.+)/,"$1 WebView"],l],[/android.+samsungbrowser\/([\w\.]+)/i,/android.+version\/([\w\.]+)\s+(?:mobile\s?safari|safari)*/i],[l,[s,"Android Browser"]],[/(chrome|omniweb|arora|[tizenoka]{5}\s?browser)\/v?([\w\.]+)/i,/(qqbrowser)[\/\s]?([\w\.]+)/i],[s,l],[/(uc\s?browser)[\/\s]?([\w\.]+)/i,/ucweb.+(ucbrowser)[\/\s]?([\w\.]+)/i,/juc.+(ucweb)[\/\s]?([\w\.]+)/i],[[s,"UCBrowser"],l],[/(dolfin)\/([\w\.]+)/i],[[s,"Dolphin"],l],[/((?:android.+)crmo|crios)\/([\w\.]+)/i],[[s,"Chrome"],l],[/;fbav\/([\w\.]+);/i],[l,[s,"Facebook"]],[/fxios\/([\w\.-]+)/i],[l,[s,"Firefox"]],[/version\/([\w\.]+).+?mobile\/\w+\s(safari)/i],[l,[s,"Mobile Safari"]],[/version\/([\w\.]+).+?(mobile\s?safari|safari)/i],[l,s],[/webkit.+?(mobile\s?safari|safari)(\/[\w\.]+)/i],[s,[l,h.str,m.browser.oldsafari.version]],[/(konqueror)\/([\w\.]+)/i,/(webkit|khtml)\/([\w\.]+)/i],[s,l],[/(navigator|netscape)\/([\w\.-]+)/i],[[s,"Netscape"],l],[/(swiftfox)/i,/(icedragon|iceweasel|camino|chimera|fennec|maemo\sbrowser|minimo|conkeror)[\/\s]?([\w\.\+]+)/i,/(firefox|seamonkey|k-meleon|icecat|iceape|firebird|phoenix)\/([\w\.-]+)/i,/(mozilla)\/([\w\.]+).+rv\:.+gecko\/\d+/i,/(polaris|lynx|dillo|icab|doris|amaya|w3m|netsurf|sleipnir)[\/\s]?([\w\.]+)/i,/(links)\s\(([\w\.]+)/i,/(gobrowser)\/?([\w\.]+)*/i,/(ice\s?browser)\/v?([\w\._]+)/i,/(mosaic)[\/\s]([\w\.]+)/i],[s,l]],cpu:[[/(?:(amd|x(?:(?:86|64)[_-])?|wow|win)64)[;\)]/i],[["architecture","amd64"]],[/(ia32(?=;))/i],[["architecture",f.lowerize]],[/((?:i[346]|x)86)[;\)]/i],[["architecture","ia32"]],[/windows\s(ce|mobile);\sppc;/i],[["architecture","arm"]],[/((?:ppc|powerpc)(?:64)?)(?:\smac|;|\))/i],[["architecture",/ower/,"",f.lowerize]],[/(sun4\w)[;\)]/i],[["architecture","sparc"]],[/((?:avr32|ia64(?=;))|68k(?=\))|arm(?:64|(?=v\d+;))|(?=atmel\s)avr|(?:irix|mips|sparc)(?:64)?(?=;)|pa-risc)/i],[["architecture",f.lowerize]]],device:[[/\((ipad|playbook);[\w\s\);-]+(rim|apple)/i],[a,c,[u,d]],[/applecoremedia\/[\w\.]+ \((ipad)/],[a,[c,"Apple"],[u,d]],[/(apple\s{0,1}tv)/i],[[a,"Apple TV"],[c,"Apple"]],[/(archos)\s(gamepad2?)/i,/(hp).+(touchpad)/i,/(hp).+(tablet)/i,/(kindle)\/([\w\.]+)/i,/\s(nook)[\w\s]+build\/(\w+)/i,/(dell)\s(strea[kpr\s\d]*[\dko])/i],[c,a,[u,d]],[/(kf[A-z]+)\sbuild\/[\w\.]+.*silk\//i],[a,[c,"Amazon"],[u,d]],[/(sd|kf)[0349hijorstuw]+\sbuild\/[\w\.]+.*silk\//i],[[a,h.str,m.device.amazon.model],[c,"Amazon"],[u,p]],[/\((ip[honed|\s\w*]+);.+(apple)/i],[a,c,[u,p]],[/\((ip[honed|\s\w*]+);/i],[a,[c,"Apple"],[u,p]],[/(blackberry)[\s-]?(\w+)/i,/(blackberry|benq|palm(?=\-)|sonyericsson|acer|asus|dell|huawei|meizu|motorola|polytron)[\s_-]?([\w-]+)*/i,/(hp)\s([\w\s]+\w)/i,/(asus)-?(\w+)/i],[c,a,[u,p]],[/\(bb10;\s(\w+)/i],[a,[c,"BlackBerry"],[u,p]],[/android.+(transfo[prime\s]{4,10}\s\w+|eeepc|slider\s\w+|nexus 7|padfone)/i],[a,[c,"Asus"],[u,d]],[/(sony)\s(tablet\s[ps])\sbuild\//i,/(sony)?(?:sgp.+)\sbuild\//i],[[c,"Sony"],[a,"Xperia Tablet"],[u,d]],[/(?:sony)?(?:(?:(?:c|d)\d{4})|(?:so[-l].+))\sbuild\//i],[[c,"Sony"],[a,"Xperia Phone"],[u,p]],[/\s(ouya)\s/i,/(nintendo)\s([wids3u]+)/i],[c,a,[u,"console"]],[/android.+;\s(shield)\sbuild/i],[a,[c,"Nvidia"],[u,"console"]],[/(playstation\s[34portablevi]+)/i],[a,[c,"Sony"],[u,"console"]],[/(sprint\s(\w+))/i],[[c,h.str,m.device.sprint.vendor],[a,h.str,m.device.sprint.model],[u,p]],[/(lenovo)\s?(S(?:5000|6000)+(?:[-][\w+]))/i],[c,a,[u,d]],[/(htc)[;_\s-]+([\w\s]+(?=\))|\w+)*/i,/(zte)-(\w+)*/i,/(alcatel|geeksphone|huawei|lenovo|nexian|panasonic|(?=;\s)sony)[_\s-]?([\w-]+)*/i],[c,[a,/_/g," "],[u,p]],[/(nexus\s9)/i],[a,[c,"HTC"],[u,d]],[/(nexus\s6p)/i],[a,[c,"Huawei"],[u,p]],[/(microsoft);\s(lumia[\s\w]+)/i],[c,a,[u,p]],[/[\s\(;](xbox(?:\sone)?)[\s\);]/i],[a,[c,"Microsoft"],[u,"console"]],[/(kin\.[onetw]{3})/i],[[a,/\./g," "],[c,"Microsoft"],[u,p]],[/\s(milestone|droid(?:[2-4x]|\s(?:bionic|x2|pro|razr))?(:?\s4g)?)[\w\s]+build\//i,/mot[\s-]?(\w+)*/i,/(XT\d{3,4}) build\//i,/(nexus\s6)/i],[a,[c,"Motorola"],[u,p]],[/android.+\s(mz60\d|xoom[\s2]{0,2})\sbuild\//i],[a,[c,"Motorola"],[u,d]],[/hbbtv\/\d+\.\d+\.\d+\s+\([\w\s]*;\s*(\w[^;]*);([^;]*)/i],[[c,f.trim],[a,f.trim],[u,"smarttv"]],[/hbbtv.+maple;(\d+)/i],[[a,/^/,"SmartTV"],[c,"Samsung"],[u,"smarttv"]],[/\(dtv[\);].+(aquos)/i],[a,[c,"Sharp"],[u,"smarttv"]],[/android.+((sch-i[89]0\d|shw-m380s|gt-p\d{4}|gt-n\d+|sgh-t8[56]9|nexus 10))/i,/((SM-T\w+))/i],[[c,"Samsung"],a,[u,d]],[/smart-tv.+(samsung)/i],[c,[u,"smarttv"],a],[/((s[cgp]h-\w+|gt-\w+|galaxy\snexus|sm-\w[\w\d]+))/i,/(sam[sung]*)[\s-]*(\w+-?[\w-]*)*/i,/sec-((sgh\w+))/i],[[c,"Samsung"],a,[u,p]],[/sie-(\w+)*/i],[a,[c,"Siemens"],[u,p]],[/(maemo|nokia).*(n900|lumia\s\d+)/i,/(nokia)[\s_-]?([\w-]+)*/i],[[c,"Nokia"],a,[u,p]],[/android\s3\.[\s\w;-]{10}(a\d{3})/i],[a,[c,"Acer"],[u,d]],[/android\s3\.[\s\w;-]{10}(lg?)-([06cv9]{3,4})/i],[[c,"LG"],a,[u,d]],[/(lg) netcast\.tv/i],[c,a,[u,"smarttv"]],[/(nexus\s[45])/i,/lg[e;\s\/-]+(\w+)*/i],[a,[c,"LG"],[u,p]],[/android.+(ideatab[a-z0-9\-\s]+)/i],[a,[c,"Lenovo"],[u,d]],[/linux;.+((jolla));/i],[c,a,[u,p]],[/((pebble))app\/[\d\.]+\s/i],[c,a,[u,"wearable"]],[/android.+;\s(glass)\s\d/i],[a,[c,"Google"],[u,"wearable"]],[/android.+(\w+)\s+build\/hm\1/i,/android.+(hm[\s\-_]*note?[\s_]*(?:\d\w)?)\s+build/i,/android.+(mi[\s\-_]*(?:one|one[\s_]plus|note lte)?[\s_]*(?:\d\w)?)\s+build/i],[[a,/_/g," "],[c,"Xiaomi"],[u,p]],[/android.+a000(1)\s+build/i],[a,[c,"OnePlus"],[u,p]],[/\s(tablet)[;\/]/i,/\s(mobile)(?:[;\/]|\ssafari)/i],[[u,f.lowerize],c,a]],engine:[[/windows.+\sedge\/([\w\.]+)/i],[l,[s,"EdgeHTML"]],[/(presto)\/([\w\.]+)/i,/(webkit|trident|netfront|netsurf|amaya|lynx|w3m)\/([\w\.]+)/i,/(khtml|tasman|links)[\/\s]\(?([\w\.]+)/i,/(icab)[\/\s]([23]\.[\d\.]+)/i],[s,l],[/rv\:([\w\.]+).*(gecko)/i],[l,s]],os:[[/microsoft\s(windows)\s(vista|xp)/i],[s,l],[/(windows)\snt\s6\.2;\s(arm)/i,/(windows\sphone(?:\sos)*)[\s\/]?([\d\.\s]+\w)*/i,/(windows\smobile|windows)[\s\/]?([ntce\d\.\s]+\w)/i],[s,[l,h.str,m.os.windows.version]],[/(win(?=3|9|n)|win\s9x\s)([nt\d\.]+)/i],[[s,"Windows"],[l,h.str,m.os.windows.version]],[/\((bb)(10);/i],[[s,"BlackBerry"],l],[/(blackberry)\w*\/?([\w\.]+)*/i,/(tizen)[\/\s]([\w\.]+)/i,/(android|webos|palm\sos|qnx|bada|rim\stablet\sos|meego|contiki)[\/\s-]?([\w\.]+)*/i,/linux;.+(sailfish);/i],[s,l],[/(symbian\s?os|symbos|s60(?=;))[\/\s-]?([\w\.]+)*/i],[[s,"Symbian"],l],[/\((series40);/i],[s],[/mozilla.+\(mobile;.+gecko.+firefox/i],[[s,"Firefox OS"],l],[/(nintendo|playstation)\s([wids34portablevu]+)/i,/(mint)[\/\s\(]?(\w+)*/i,/(mageia|vectorlinux)[;\s]/i,/(joli|[kxln]?ubuntu|debian|[open]*suse|gentoo|(?=\s)arch|slackware|fedora|mandriva|centos|pclinuxos|redhat|zenwalk|linpus)[\/\s-]?(?!chrom)([\w\.-]+)*/i,/(hurd|linux)\s?([\w\.]+)*/i,/(gnu)\s?([\w\.]+)*/i],[s,l],[/(cros)\s[\w]+\s([\w\.]+\w)/i],[[s,"Chromium OS"],l],[/(sunos)\s?([\w\.]+\d)*/i],[[s,"Solaris"],l],[/\s([frentopc-]{0,4}bsd|dragonfly)\s?([\w\.]+)*/i],[s,l],[/(haiku)\s(\w+)/i],[s,l],[/(ip[honead]+)(?:.*os\s([\w]+)*\slike\smac|;\sopera)/i],[[s,"iOS"],[l,/_/g,"."]],[/(mac\sos\sx)\s?([\w\s\.]+\w)*/i,/(macintosh|mac(?=_powerpc)\s)/i],[[s,"Mac OS"],[l,/_/g,"."]],[/((?:open)?solaris)[\/\s-]?([\w\.]+)*/i,/(aix)\s((\d)(?=\.|\)|\s)[\w\.]*)*/i,/(plan\s9|minix|beos|os\/2|amigaos|morphos|risc\sos|openvms)/i,/(unix)\s?([\w\.]+)*/i],[s,l]]},v=function(e,t){if(!(this instanceof v))return new v(e,t).getResult();var n=e||(i&&i.navigator&&i.navigator.userAgent?i.navigator.userAgent:""),r=t?f.extend(g,t):g;return this.getBrowser=function(){var e=h.rgx.apply(this,r.browser);return e.major=f.major(e.version),e},this.getCPU=function(){return h.rgx.apply(this,r.cpu)},this.getDevice=function(){return h.rgx.apply(this,r.device)},this.getEngine=function(){return h.rgx.apply(this,r.engine)},this.getOS=function(){return h.rgx.apply(this,r.os)},this.getResult=function(){return{ua:this.getUA(),browser:this.getBrowser(),engine:this.getEngine(),os:this.getOS(),device:this.getDevice(),cpu:this.getCPU()}},this.getUA=function(){return n},this.setUA=function(e){return n=e,this},this};v.VERSION="0.7.12",v.BROWSER={NAME:s,MAJOR:"major",VERSION:l},v.CPU={ARCHITECTURE:"architecture"},v.DEVICE={MODEL:a,VENDOR:c,TYPE:u,CONSOLE:"console",MOBILE:p,SMARTTV:"smarttv",TABLET:d,WEARABLE:"wearable",EMBEDDED:"embedded"},v.ENGINE={NAME:s,VERSION:l},v.OS={NAME:s,VERSION:l},void 0!==t?(void 0!==e&&e.exports&&(t=e.exports=v),t.UAParser=v):n(748)?void 0!==(r=function(){return v}.call(t,n,t,e))&&(e.exports=r):i.UAParser=v;var b=i.jQuery||i.Zepto;if(void 0!==b){var y=new v;b.ua=y.getResult(),b.ua.get=function(){return y.getUA()},b.ua.set=function(e){y.setUA(e);var t=y.getResult();for(var n in t)b.ua[n]=t[n]}}}("object"==typeof window?window:this)},function(e,t,n){(function(t){WebGLDebugUtils=function(){function e(e){if(null==h){h={},m={};for(var t in e)"number"==typeof e[t]&&(h[e[t]]=t,m[t]=e[t])}}function n(){if(null==h)throw"WebGLDebugUtils.init(ctx) not called"}function r(e){return n(),void 0!==h[e]}function i(e){n();var t=h[e];return void 0!==t?"gl."+t:"/*UNKNOWN WebGL ENUM*/ 0x"+e.toString(16)}function o(e,t,n,r){var o=f[e];if(void 0!==o){var o=o[t];if(void 0!==o&&o[n]){if("object"==typeof o[n]&&void 0!==o[n].enumBitwiseOr){for(var a=o[n].enumBitwiseOr,s=0,u=[],c=0;c<a.length;++c){var l=m[a[c]];0!=(r&l)&&(s|=l,u.push(i(l)))}return s===r?u.join(" | "):i(r)}return i(r)}}return null===r?"null":void 0===r?"undefined":r.toString()}function a(e,t){for(var n="",r=t.length,i=0;i<r;++i)n+=(0==i?"":", ")+o(e,r,i,t[i]);return n}function s(e,t,n){e.__defineGetter__(n,function(){return t[n]}),e.__defineSetter__(n,function(e){t[n]=e})}function u(t,n,r,a){function c(e,t){return function(){r&&r(t,arguments);var i=e[t].apply(e,arguments),o=a.getError();return 0!=o&&(l[o]=!0,n(o,t,arguments)),i}}a=a||t,e(t),n=n||function(e,t,n){for(var r="",a=n.length,s=0;s<a;++s)r+=(0==s?"":", ")+o(t,a,s,n[s]);d("WebGL error "+i(e)+" in "+t+"("+r+")")};var l={},p={};for(var f in t)if("function"==typeof t[f])if("getExtension"!=f)p[f]=c(t,f);else{var h=c(t,f);p[f]=function(){return u(h.apply(t,arguments),n,r,a)}}else s(p,t,f);return p.getError=function(){for(var e in l)if(l.hasOwnProperty(e)&&l[e])return l[e]=!1,e;return t.NO_ERROR},p}function c(e){var t=e.getParameter(e.MAX_VERTEX_ATTRIBS),n=e.createBuffer();e.bindBuffer(e.ARRAY_BUFFER,n);for(var r=0;r<t;++r)e.disableVertexAttribArray(r),e.vertexAttribPointer(r,4,e.FLOAT,!1,0,0),e.vertexAttrib1f(r,0);e.deleteBuffer(n);for(var i=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS),r=0;r<i;++r)e.activeTexture(e.TEXTURE0+r),e.bindTexture(e.TEXTURE_CUBE_MAP,null),e.bindTexture(e.TEXTURE_2D,null);for(e.activeTexture(e.TEXTURE0),e.useProgram(null),e.bindBuffer(e.ARRAY_BUFFER,null),e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null),e.bindFramebuffer(e.FRAMEBUFFER,null),e.bindRenderbuffer(e.RENDERBUFFER,null),e.disable(e.BLEND),e.disable(e.CULL_FACE),e.disable(e.DEPTH_TEST),e.disable(e.DITHER),e.disable(e.SCISSOR_TEST),e.blendColor(0,0,0,0),e.blendEquation(e.FUNC_ADD),e.blendFunc(e.ONE,e.ZERO),e.clearColor(0,0,0,0),e.clearDepth(1),e.clearStencil(-1),e.colorMask(!0,!0,!0,!0),e.cullFace(e.BACK),e.depthFunc(e.LESS),e.depthMask(!0),e.depthRange(0,1),e.frontFace(e.CCW),e.hint(e.GENERATE_MIPMAP_HINT,e.DONT_CARE),e.lineWidth(1),e.pixelStorei(e.PACK_ALIGNMENT,4),e.pixelStorei(e.UNPACK_ALIGNMENT,4),e.pixelStorei(e.UNPACK_FLIP_Y_WEBGL,!1),e.pixelStorei(e.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!1),e.UNPACK_COLORSPACE_CONVERSION_WEBGL&&e.pixelStorei(e.UNPACK_COLORSPACE_CONVERSION_WEBGL,e.BROWSER_DEFAULT_WEBGL),e.polygonOffset(0,0),e.sampleCoverage(1,!1),e.scissor(0,0,e.canvas.width,e.canvas.height),e.stencilFunc(e.ALWAYS,0,4294967295),e.stencilMask(4294967295),e.stencilOp(e.KEEP,e.KEEP,e.KEEP),e.viewport(0,0,e.canvas.width,e.canvas.height),e.clear(e.COLOR_BUFFER_BIT|e.DEPTH_BUFFER_BIT|e.STENCIL_BUFFER_BIT);e.getError(););}function l(e){function t(e){return"function"==typeof e?e:function(t){e.handleEvent(t)}}function n(){for(var e=Object.keys(w),t=0;t<e.length;++t)delete w[e]}function r(){++b,m||v==b&&e.loseContext()}function i(e,t){var n=e[t];return function(){if(r(),!m){return n.apply(e,arguments)}}}function o(){for(var e=0;e<g.length;++e){var t=g[e];t instanceof WebGLBuffer?l.deleteBuffer(t):t instanceof WebGLFramebuffer?l.deleteFramebuffer(t):t instanceof WebGLProgram?l.deleteProgram(t):t instanceof WebGLRenderbuffer?l.deleteRenderbuffer(t):t instanceof WebGLShader?l.deleteShader(t):t instanceof WebGLTexture&&l.deleteTexture(t)}}function a(e){return{statusMessage:e,preventDefault:function(){y=!0}}}function u(e){for(var t in e)"function"==typeof e[t]?p[t]=i(e,t):s(p,e,t);p.getError=function(){if(r(),!m)for(var e;e=l.getError();)w[e]=!0;for(var e in w)if(w[e])return delete w[e],e;return p.NO_ERROR};for(var n=["createBuffer","createFramebuffer","createProgram","createRenderbuffer","createShader","createTexture"],o=0;o<n.length;++o){var a=n[o];p[a]=function(t){return function(){if(r(),m)return null;var n=t.apply(e,arguments);return n.__webglDebugContextLostId__=h,g.push(n),n}}(e[a])}for(var u=["getActiveAttrib","getActiveUniform","getBufferParameter","getContextAttributes","getAttachedShaders","getFramebufferAttachmentParameter","getParameter","getProgramParameter","getProgramInfoLog","getRenderbufferParameter","getShaderParameter","getShaderInfoLog","getShaderSource","getTexParameter","getUniform","getUniformLocation","getVertexAttrib"],o=0;o<u.length;++o){var a=u[o];p[a]=function(t){return function(){return r(),m?null:t.apply(e,arguments)}}(p[a])}for(var c=["isBuffer","isEnabled","isFramebuffer","isProgram","isRenderbuffer","isShader","isTexture"],o=0;o<c.length;++o){var a=c[o];p[a]=function(t){return function(){return r(),!m&&t.apply(e,arguments)}}(p[a])}return p.checkFramebufferStatus=function(t){return function(){return r(),m?p.FRAMEBUFFER_UNSUPPORTED:t.apply(e,arguments)}}(p.checkFramebufferStatus),p.getAttribLocation=function(t){return function(){return r(),m?-1:t.apply(e,arguments)}}(p.getAttribLocation),p.getVertexAttribOffset=function(t){return function(){return r(),m?0:t.apply(e,arguments)}}(p.getVertexAttribOffset),p.isContextLost=function(){return m},p}var l,p,d=[],f=[],p={},h=1,m=!1,g=[],v=0,b=0,y=!1,_=0,w={};e.getContext=function(t){return function(){var n=t.apply(e,arguments);if(n instanceof WebGLRenderingContext){if(n!=l){if(l)throw"got different context";l=n,p=u(l)}return p}return n}}(e.getContext);var E=function(e){d.push(t(e))},x=function(e){f.push(t(e))};return function(e){var t=e.addEventListener;e.addEventListener=function(n,r,i){switch(n){case"webglcontextlost":E(r);break;case"webglcontextrestored":x(r);break;default:t.apply(e,arguments)}}}(e),e.loseContext=function(){if(!m){for(m=!0,v=0,++h;l.getError(););n(),w[l.CONTEXT_LOST_WEBGL]=!0;var t=a("context lost"),r=d.slice();setTimeout(function(){for(var n=0;n<r.length;++n)r[n](t);_>=0&&setTimeout(function(){e.restoreContext()},_)},0)}},e.restoreContext=function(){m&&f.length&&setTimeout(function(){if(!y)throw"can not restore. webglcontestlost listener did not call event.preventDefault";o(),c(l),m=!1,b=0,y=!1;for(var e=f.slice(),t=a("context restored"),n=0;n<e.length;++n)e[n](t)},0)},e.loseContextInNCalls=function(e){if(m)throw"You can not ask a lost contet to be lost";v=b+e},e.getNumCalls=function(){return b},e.setRestoreTimeout=function(e){_=e},e}"undefined"==typeof window&&(window=t);var p=function(e){window.console&&window.console.log&&window.console.log(e)},d=function(e){window.console&&window.console.error?window.console.error(e):p(e)},f={enable:{1:{0:!0}},disable:{1:{0:!0}},getParameter:{1:{0:!0}},drawArrays:{3:{0:!0}},drawElements:{4:{0:!0,2:!0}},createShader:{1:{0:!0}},getShaderParameter:{2:{1:!0}},getProgramParameter:{2:{1:!0}},getShaderPrecisionFormat:{2:{0:!0,1:!0}},getVertexAttrib:{2:{1:!0}},vertexAttribPointer:{6:{2:!0}},bindTexture:{2:{0:!0}},activeTexture:{1:{0:!0}},getTexParameter:{2:{0:!0,1:!0}},texParameterf:{3:{0:!0,1:!0}},texParameteri:{3:{0:!0,1:!0,2:!0}},texImage2D:{9:{0:!0,2:!0,6:!0,7:!0},6:{0:!0,2:!0,3:!0,4:!0}},texSubImage2D:{9:{0:!0,6:!0,7:!0},7:{0:!0,4:!0,5:!0}},copyTexImage2D:{8:{0:!0,2:!0}},copyTexSubImage2D:{8:{0:!0}},generateMipmap:{1:{0:!0}},compressedTexImage2D:{7:{0:!0,2:!0}},compressedTexSubImage2D:{8:{0:!0,6:!0}},bindBuffer:{2:{0:!0}},bufferData:{3:{0:!0,2:!0}},bufferSubData:{3:{0:!0}},getBufferParameter:{2:{0:!0,1:!0}},pixelStorei:{2:{0:!0,1:!0}},readPixels:{7:{4:!0,5:!0}},bindRenderbuffer:{2:{0:!0}},bindFramebuffer:{2:{0:!0}},checkFramebufferStatus:{1:{0:!0}},framebufferRenderbuffer:{4:{0:!0,1:!0,2:!0}},framebufferTexture2D:{5:{0:!0,1:!0,2:!0}},getFramebufferAttachmentParameter:{3:{0:!0,1:!0,2:!0}},getRenderbufferParameter:{2:{0:!0,1:!0}},renderbufferStorage:{4:{0:!0,1:!0}},clear:{1:{0:{enumBitwiseOr:["COLOR_BUFFER_BIT","DEPTH_BUFFER_BIT","STENCIL_BUFFER_BIT"]}}},depthFunc:{1:{0:!0}},blendFunc:{2:{0:!0,1:!0}},blendFuncSeparate:{4:{0:!0,1:!0,2:!0,3:!0}},blendEquation:{1:{0:!0}},blendEquationSeparate:{2:{0:!0,1:!0}},stencilFunc:{3:{0:!0}},stencilFuncSeparate:{4:{0:!0,1:!0}},stencilMaskSeparate:{2:{0:!0}},stencilOp:{3:{0:!0,1:!0,2:!0}},stencilOpSeparate:{4:{0:!0,1:!0,2:!0,3:!0}},cullFace:{1:{0:!0}},frontFace:{1:{0:!0}},drawArraysInstancedANGLE:{4:{0:!0}},drawElementsInstancedANGLE:{5:{0:!0,2:!0}},blendEquationEXT:{1:{0:!0}}},h=null,m=null;return{init:e,mightBeEnum:r,glEnumToString:i,glFunctionArgToString:o,glFunctionArgsToString:a,makeDebugContext:u,makeLostContextSimulatingCanvas:l,resetToInitialState:c}}(),e.exports=WebGLDebugUtils}).call(t,n(34))},function(e,t){e.exports=function(e){return e.webpackPolyfill||(e.deprecate=function(){},e.paths=[],e.children||(e.children=[]),Object.defineProperty(e,"loaded",{enumerable:!0,get:function(){return e.l}}),Object.defineProperty(e,"id",{enumerable:!0,get:function(){return e.i}}),e.webpackPolyfill=1),e}},function(e,t){(function(t){e.exports=t}).call(t,{})},function(e,t){e.exports="precision highp float;\nvarying vec3 vnormal;\nvarying vec3 cameraDirection;\nvarying vec3 lightDirection;\nvarying vec2 texcoord;\nuniform float lightRatio;\nuniform sampler2D texture;\nuniform bool showSpinner;\nuniform float tick;\nuniform float spinnerSize;\nuniform vec4 bbox;\nuniform vec2 viewport;\nvoid main ()\n{\n  lowp vec3 col_1;\n  if (showSpinner) {\n    float tmpvar_2;\n    float tmpvar_3;\n    tmpvar_3 = (bbox.w * viewport.y);\n    tmpvar_2 = (1.0/((tmpvar_3 / 2.0)));\n    vec2 tmpvar_4;\n    tmpvar_4.x = ((texcoord.x - 0.5) * ((bbox.z * viewport.x) / tmpvar_3));\n    tmpvar_4.y = (texcoord.y - 0.5);\n    float tmpvar_5;\n    tmpvar_5 = (((spinnerSize * tmpvar_2) * 2.5) / 15.7);\n    float tmpvar_6;\n    tmpvar_6 = (((spinnerSize * tmpvar_2) * 6.75) / 15.7);\n    float tmpvar_7;\n    tmpvar_7 = sqrt(dot (tmpvar_4, tmpvar_4));\n    float tmpvar_8;\n    tmpvar_8 = (((spinnerSize * tmpvar_2) * 0.6) / 15.7);\n    float tmpvar_9;\n    tmpvar_9 = ((spinnerSize * tmpvar_2) / 15.7);\n    vec2 tmpvar_10;\n    float tmpvar_11;\n    tmpvar_11 = (tick * 0.00435);\n    tmpvar_10.x = sin(tmpvar_11);\n    tmpvar_10.y = cos(tmpvar_11);\n    vec2 tmpvar_12;\n    tmpvar_12 = normalize(tmpvar_10);\n    float tmpvar_13;\n    float x_14;\n    x_14 = (dot (tmpvar_4, tmpvar_12) / sqrt(dot (tmpvar_4, tmpvar_4)));\n    tmpvar_13 = (1.570796 - (sign(x_14) * (1.570796 - \n      (sqrt((1.0 - abs(x_14))) * (1.570796 + (abs(x_14) * (-0.2146018 + \n        (abs(x_14) * (0.08656672 + (abs(x_14) * -0.03102955)))\n      ))))\n    )));\n    float edge0_15;\n    edge0_15 = ((tmpvar_5 - tmpvar_8) - tmpvar_2);\n    float tmpvar_16;\n    tmpvar_16 = clamp (((tmpvar_7 - edge0_15) / (\n      (tmpvar_5 - tmpvar_8)\n     - edge0_15)), 0.0, 1.0);\n    float edge0_17;\n    edge0_17 = (tmpvar_5 + tmpvar_8);\n    float tmpvar_18;\n    tmpvar_18 = clamp (((tmpvar_7 - edge0_17) / (\n      ((tmpvar_5 + tmpvar_8) + tmpvar_2)\n     - edge0_17)), 0.0, 1.0);\n    float tmpvar_19;\n    tmpvar_19 = ((tmpvar_16 * (tmpvar_16 * \n      (3.0 - (2.0 * tmpvar_16))\n    )) * (1.0 - (tmpvar_18 * \n      (tmpvar_18 * (3.0 - (2.0 * tmpvar_18)))\n    )));\n    float edge0_20;\n    edge0_20 = ((tmpvar_6 - tmpvar_9) - tmpvar_2);\n    float tmpvar_21;\n    tmpvar_21 = clamp (((tmpvar_7 - edge0_20) / (\n      (tmpvar_6 - tmpvar_9)\n     - edge0_20)), 0.0, 1.0);\n    float edge0_22;\n    edge0_22 = (tmpvar_6 + tmpvar_9);\n    float tmpvar_23;\n    tmpvar_23 = clamp (((tmpvar_7 - edge0_22) / (\n      ((tmpvar_6 + tmpvar_9) + tmpvar_2)\n     - edge0_22)), 0.0, 1.0);\n    float tmpvar_24;\n    tmpvar_24 = ((tmpvar_21 * (tmpvar_21 * \n      (3.0 - (2.0 * tmpvar_21))\n    )) * (1.0 - (tmpvar_23 * \n      (tmpvar_23 * (3.0 - (2.0 * tmpvar_23)))\n    )));\n    vec2 tmpvar_25;\n    tmpvar_25.x = tmpvar_12.y;\n    tmpvar_25.y = -(tmpvar_12.x);\n    vec2 x_26;\n    x_26 = (tmpvar_4 - (tmpvar_25 * tmpvar_6));\n    float tmpvar_27;\n    tmpvar_27 = clamp (((\n      sqrt(dot (x_26, x_26))\n     - tmpvar_9) / (\n      (tmpvar_9 + tmpvar_2)\n     - tmpvar_9)), 0.0, 1.0);\n    float tmpvar_28;\n    tmpvar_28 = (1.0 - (tmpvar_27 * (tmpvar_27 * \n      (3.0 - (2.0 * tmpvar_27))\n    )));\n    vec2 tmpvar_29;\n    tmpvar_29.x = -(tmpvar_12.y);\n    tmpvar_29.y = tmpvar_12.x;\n    vec2 x_30;\n    x_30 = (tmpvar_4 - (tmpvar_29 * tmpvar_6));\n    float tmpvar_31;\n    tmpvar_31 = clamp (((\n      sqrt(dot (x_30, x_30))\n     - tmpvar_9) / (\n      (tmpvar_9 + tmpvar_2)\n     - tmpvar_9)), 0.0, 1.0);\n    float tmpvar_32;\n    tmpvar_32 = (1.0 - (tmpvar_31 * (tmpvar_31 * \n      (3.0 - (2.0 * tmpvar_31))\n    )));\n    float tmpvar_33;\n    tmpvar_33 = (max (tmpvar_19, tmpvar_24) * 0.5);\n    float tmpvar_34;\n    if ((tmpvar_13 < 1.570796)) {\n      tmpvar_34 = tmpvar_24;\n    } else {\n      tmpvar_34 = 0.0;\n    };\n    col_1 = mix (vec3(0.9453125, 0.9453125, 0.9453125), vec3(0.6015625, 0.65625, 0.6601562), max (max (tmpvar_33, tmpvar_34), max (\n      max (tmpvar_28, tmpvar_32)\n    , tmpvar_19)));\n  } else {\n    col_1 = texture2D (texture, texcoord).xyz;\n  };\n  lowp vec3 tmpvar_35;\n  vec3 I_36;\n  I_36 = -(lightDirection);\n  tmpvar_35 = (((\n    ((vec3(0.9, 0.9, 0.9) * col_1) + ((vec3(0.2, 0.2, 0.2) * clamp (\n      dot (vnormal, lightDirection)\n    , 0.0, 1.0)) * col_1))\n   + \n    (vec3(0.3, 0.3, 0.3) * pow (max (dot (\n      (I_36 - (2.0 * (dot (vnormal, I_36) * vnormal)))\n    , cameraDirection), 0.0), 5.0))\n  ) * lightRatio) + ((1.0 - lightRatio) * col_1));\n  mediump vec4 tmpvar_37;\n  tmpvar_37.w = 1.0;\n  tmpvar_37.xyz = tmpvar_35;\n  gl_FragColor = tmpvar_37;\n}\n\n"},function(e,t){e.exports="precision highp float;\nattribute vec3 vertex;\nattribute vec3 normal;\nattribute vec2 textureCoord;\nattribute float perspectiveCorrection;\nuniform mat3 u_matrix;\nuniform mat3 u_texMatrix;\nvarying vec3 vnormal;\nvarying vec3 lightDirection;\nvarying vec3 cameraDirection;\nvarying vec2 texcoord;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = vertex.xy;\n  vec3 tmpvar_2;\n  tmpvar_2.xy = (u_matrix * tmpvar_1).xy;\n  tmpvar_2.z = vertex.z;\n  vnormal = normal;\n  lightDirection = normalize((vec3(10.0, 5.0, 4.0) - tmpvar_2));\n  cameraDirection = normalize((vec3(0.0, 0.0, 1.0) - tmpvar_2));\n  vec3 tmpvar_3;\n  tmpvar_3.z = 1.0;\n  tmpvar_3.xy = textureCoord;\n  texcoord = (u_texMatrix * tmpvar_3).xy;\n  highp vec4 tmpvar_4;\n  tmpvar_4.xy = tmpvar_2.xy;\n  tmpvar_4.z = -(vertex.z);\n  tmpvar_4.w = perspectiveCorrection;\n  gl_Position = tmpvar_4;\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform vec4 u_color;\nvoid main ()\n{\n  gl_FragColor = u_color;\n}\n\n"},function(e,t){e.exports="attribute vec2 a_vertex;\nuniform mat3 u_displayMatrix;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = a_vertex;\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 1.0;\n  tmpvar_2.xyz = (u_displayMatrix * tmpvar_1);\n  gl_Position = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision mediump float;\nuniform sampler2D texture;\nvarying vec2 textureCoordinate;\nuniform float opacity;\nvoid main ()\n{\n  lowp vec4 tmpvar_1;\n  tmpvar_1 = texture2D (texture, textureCoordinate);\n  gl_FragColor = (tmpvar_1 * opacity);\n}\n\n"},function(e,t){e.exports="attribute vec2 vertex;\nuniform vec4 texCoords;\nuniform vec4 bbox;\nuniform vec2 viewport;\nvarying vec2 textureCoordinate;\nvoid main ()\n{\n  vec2 tmpvar_1;\n  tmpvar_1 = ((2.0 * bbox.xz) / viewport.x);\n  vec2 tmpvar_2;\n  tmpvar_2 = ((2.0 * bbox.yw) / viewport.y);\n  highp vec2 tmpvar_3;\n  tmpvar_3.x = ((tmpvar_1.x - 1.0) + (vertex.x * tmpvar_1.y));\n  tmpvar_3.y = ((1.0 - tmpvar_2.x) - (vertex.y * tmpvar_2.y));\n  vec2 tmpvar_4;\n  tmpvar_4.x = (texCoords.x + (vertex.x * texCoords.z));\n  tmpvar_4.y = (texCoords.y + (vertex.y * texCoords.w));\n  textureCoordinate = tmpvar_4;\n  highp vec4 tmpvar_5;\n  tmpvar_5.zw = vec2(0.0, 1.0);\n  tmpvar_5.xy = tmpvar_3;\n  gl_Position = tmpvar_5;\n}\n\n"},function(e,t){e.exports="#extension GL_OES_standard_derivatives : enable\nprecision highp float;\nuniform float opacity;\nuniform float strokeWidth;\nvarying vec4 vBC;\nvoid main ()\n{\n  vec4 tmpvar_1;\n  tmpvar_1.xyz = vec3(0.4627451, 0.6470588, 0.8);\n  tmpvar_1.w = opacity;\n  vec4 tmpvar_2;\n  tmpvar_2.xyz = vec3(0.4627451, 0.6470588, 0.8);\n  tmpvar_2.w = (opacity / 2.0);\n  vec4 tmpvar_3;\n  vec4 tmpvar_4;\n  tmpvar_4 = clamp ((vBC / (\n    (abs(dFdx(vBC)) + abs(dFdy(vBC)))\n   * strokeWidth)), 0.0, 1.0);\n  tmpvar_3 = (tmpvar_4 * (tmpvar_4 * (3.0 - \n    (2.0 * tmpvar_4)\n  )));\n  gl_FragColor = mix (tmpvar_1, tmpvar_2, min (min (tmpvar_3.x, tmpvar_3.y), min (tmpvar_3.z, tmpvar_3.w)));\n}\n\n"},function(e,t){e.exports="attribute vec2 vertex;\nattribute vec4 barycentric;\nuniform vec2 viewport;\nuniform vec4 bbox;\nvarying vec4 vBC;\nvoid main ()\n{\n  vec2 tmpvar_1;\n  tmpvar_1 = ((2.0 * bbox.xz) / viewport.x);\n  vec2 tmpvar_2;\n  tmpvar_2 = ((2.0 * bbox.yw) / viewport.y);\n  highp vec2 tmpvar_3;\n  tmpvar_3.x = ((tmpvar_1.x - 1.0) + (vertex.x * tmpvar_1.y));\n  tmpvar_3.y = ((1.0 - tmpvar_2.x) - (vertex.y * tmpvar_2.y));\n  vBC = barycentric;\n  highp vec4 tmpvar_4;\n  tmpvar_4.zw = vec2(0.0, 1.0);\n  tmpvar_4.xy = tmpvar_3;\n  gl_Position = tmpvar_4;\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform bool backFacing;\nvoid main ()\n{\n  if (backFacing) {\n    gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);\n  } else {\n    gl_FragColor = vec4(0.0, 1.0, 0.0, 1.0);\n  };\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform mat3 u_matrix;\nattribute vec3 vertex;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = vertex.xy;\n  vec3 tmpvar_2;\n  tmpvar_2.xy = (u_matrix * tmpvar_1).xy;\n  tmpvar_2.z = vertex.z;\n  highp vec4 tmpvar_3;\n  tmpvar_3.xy = tmpvar_2.xy;\n  tmpvar_3.z = (-(vertex.z) * 0.8);\n  tmpvar_3.w = (1.0 + (vertex.z * -0.2));\n  gl_Position = tmpvar_3;\n}\n\n"},function(e,t){e.exports="precision highp float;\nuniform vec4 u_color;\nuniform sampler2D u_texture;\nvarying vec2 v_texCoord;\nvoid main ()\n{\n  lowp vec4 tmpvar_1;\n  tmpvar_1.w = 1.0;\n  tmpvar_1.xyz = ((texture2D (u_texture, v_texCoord).xyz * u_color.w) + (u_color.xyz * u_color.w));\n  gl_FragColor = tmpvar_1;\n}\n\n"},function(e,t){e.exports="precision highp float;\nattribute vec2 a_vertex;\nattribute vec2 a_texCoord;\nuniform mat3 u_displayMatrix;\nvarying vec2 v_texCoord;\nvoid main ()\n{\n  v_texCoord = a_texCoord;\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = a_vertex;\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 1.0;\n  tmpvar_2.xyz = (u_displayMatrix * tmpvar_1);\n  gl_Position = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision mediump float;\nuniform sampler2D depthMapTexture;\nvarying vec2 v_shadowTexcoord;\nvarying vec2 v_shadowBlurCoords[8];\nvoid main ()\n{\n  lowp vec4 color_1;\n  color_1 = (texture2D (depthMapTexture, v_shadowBlurCoords[0]) * 0.04436833);\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[1]) * 0.07767442));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[2]) * 0.1158766));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[3]) * 0.1473081));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowTexcoord) * 0.1595769));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[4]) * 0.1473081));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[5]) * 0.1158766));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[6]) * 0.07767442));\n  color_1 = (color_1 + (texture2D (depthMapTexture, v_shadowBlurCoords[7]) * 0.04436833));\n  gl_FragColor = color_1;\n}\n\n"},function(e,t){e.exports="attribute vec3 vertex;\nvarying vec2 v_shadowTexcoord;\nvarying vec2 v_shadowBlurCoords[8];\nvoid main ()\n{\n  vec2 tmpvar_1;\n  tmpvar_1 = ((vertex.xy + vec2(1.0, 1.0)) / vec2(2.0, 2.0));\n  v_shadowTexcoord = tmpvar_1;\n  v_shadowBlurCoords[0] = (tmpvar_1 + vec2(0.0, -0.016));\n  v_shadowBlurCoords[1] = (tmpvar_1 + vec2(0.0, -0.012));\n  v_shadowBlurCoords[2] = (tmpvar_1 + vec2(0.0, -0.008));\n  v_shadowBlurCoords[3] = (tmpvar_1 + vec2(0.0, -0.004));\n  v_shadowBlurCoords[4] = (tmpvar_1 + vec2(0.0, 0.004));\n  v_shadowBlurCoords[5] = (tmpvar_1 + vec2(0.0, 0.008));\n  v_shadowBlurCoords[6] = (tmpvar_1 + vec2(0.0, 0.012));\n  v_shadowBlurCoords[7] = (tmpvar_1 + vec2(0.0, 0.016));\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 1.0;\n  tmpvar_2.xy = vertex.xy;\n  tmpvar_2.z = -(vertex.z);\n  gl_Position = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision highp float;\nvoid main ()\n{\n  highp float tmpvar_1;\n  tmpvar_1 = abs(gl_FragCoord.z);\n  highp vec4 tmpvar_2;\n  tmpvar_2.w = 0.25;\n  tmpvar_2.x = tmpvar_1;\n  tmpvar_2.y = tmpvar_1;\n  tmpvar_2.z = tmpvar_1;\n  gl_FragColor = tmpvar_2;\n}\n\n"},function(e,t){e.exports="precision highp float;\nattribute vec3 vertex;\nuniform mat3 u_matrix;\nvoid main ()\n{\n  vec3 tmpvar_1;\n  tmpvar_1.z = 1.0;\n  tmpvar_1.xy = vertex.xy;\n  vec3 tmpvar_2;\n  tmpvar_2.xy = (u_matrix * tmpvar_1).xy;\n  tmpvar_2.z = vertex.z;\n  highp vec4 tmpvar_3;\n  tmpvar_3.xy = tmpvar_2.xy;\n  tmpvar_3.z = (-(vertex.z) * 0.7);\n  tmpvar_3.w = (1.0 + (vertex.z * -0.35));\n  gl_Position = tmpvar_3;\n}\n\n"},function(e,t,n){"use strict";n.d(t,"a",function(){return i}),window.ga=window.ga||function(){(ga.q=ga.q||[]).push(arguments)},ga.l=+new Date;var r=[{test:function(e){return"/issuu/docs/issuu_digitaltoolkit"===e},prefix:function(e){return e},account:"UA-93458571-5"},{test:function(e){return e.startsWith("/refractionmedia/")},prefix:function(e){return"/issuu.com"+e},account:"UA-98221222-1"},{test:function(e){return e.startsWith("/sostrenegrene/")},prefix:function(e){return"/issuu.com"+e},account:"UA-23207585-1"},{test:function(e){return e.startsWith("/sister_magazine/")},prefix:function(e){return"/issuu.com"+e},account:"UA-61842196-1"},{test:function(e){return e.startsWith("/[username]/")},prefix:function(e){return"/issuu.com"+e},account:"UA-xxxxxxxx-y"},{test:function(e){return"/[username]/docs/[docname]"===e},prefix:function(e){return e},account:"UA-xxxxxxxx-y"}],i=function(){function e(t){babelHelpers.classCallCheck(this,e),t.gaId&&window.ga("create",t.gaId,"auto")}return e.prototype.destroy=function(){},e.prototype._validate=function(e){if(!e.startsWith("/"))throw new Error("GA: The path portion of a URL must start with a slash (/) character.")},e.prototype.sendInitialPageview=function(e){this._validate(e),window.ga("send","pageview",e)},e.prototype.sendVirtualPageview=function(e){this._validate(e),window.ga("send","pageview",e)},e.prototype.handleDocumentLoadByPublisherAccount=function(e,t){r.forEach(function(t){if(t.test(e)){window.ga("create",t.account,"auto","publisherTracker"),window.ga("publisherTracker.send","pageview",""+t.prefix(e))}})},e}()},function(e,t,n){"use strict";function r(){return window.innerWidth<470&&window.innerWidth>window.innerHeight}n.d(t,"a",function(){return u});var i=n(772),o=n(771),a=n(2),s=n.n(a),u=function(){function e(t){var n=t.tracker,r=t.show,i=void 0===r?e.RELATED:r,o=t.alwaysOverlay,a=void 0!==o&&o,s=t.hideWhenNotInFullscreen,u=void 0!==s&&s,c=t.openInNewTab,l=void 0===c||c;babelHelpers.classCallCheck(this,e),this.showMore=!1,this.showAd=!1,this.tracker=n,this.show=i,this.alwaysOverlay=a,this.hideWhenNotInFullscreen=u,this.openInNewTab=l,this.showOwnDocuments=this.show===e.OWN_DOCUMENTS}return e.prototype.load=function(e,t,r,i,a,s){var u=this;return this.showMore=this.shouldShowMore(a,s),this.showOwnDocuments=this.shouldShowOwnDocuments(a),this.showAd=!s,this.publicationId=r,this.username=i,this.showMore?n.i(o.a)(e,t,r,i,this.showOwnDocuments).then(function(e){return u.streamState=e,!0}):Promise.resolve(!1)},e.prototype.loadComplete=function(){return void 0!==this.streamState},e.prototype.shouldShowOwnDocuments=function(t){return this.show===e.OWN_DOCUMENTS&&t},e.prototype.shouldShowRelated=function(t,n){return this.show===e.RELATED||this.show===e.RELATED_FOR_FREE_PUBLISHERS&&!n||this.show===e.OWN_DOCUMENTS&&!t&&!n},e.prototype.shouldShowMore=function(e,t){return this.shouldShowRelated(e,t)||this.shouldShowOwnDocuments(e)},e.prototype.shouldAlwaysBeOverlay=function(){return this.alwaysOverlay},e.prototype.hasStreamData=function(){return this.loadComplete()&&this.streamState.buttonStream&&this.streamState.buttonStream.length>0},e.prototype.shouldRenderButton=function(e,t,n){return!(this.hideWhenNotInFullscreen&&!n)&&(this.hasStreamData()&&this.shouldShowMore(e,t))},e.prototype.shouldRenderExitFullscreenOverlay=function(e,t){return!this.hideWhenNotInFullscreen&&this.hasStreamData()&&this.shouldShowMore(e,t)},e.prototype.getButtonUnreadCount=function(){var e=void 0;return e=void 0!==this.unreadCount?this.unreadCount:this.streamState&&this.streamState.buttonStream?this.streamState.buttonStream.length:void 0,e&&r()&&(e=Math.min(e,3)),e},e.prototype.clearButtonUnreadCount=function(){this.unreadCount=0},e.prototype.render=function(e,t,n,o,a,u){return s.a.createElement(i.a,{config:e,debug:t,exitedFullscreen:n,isLoggedIn:u,isVisible:o,openInNewTab:this.openInNewTab,publicationId:this.publicationId,shouldHackStreamCount:r(),showAd:this.showAd,showAsOverlay:a,showMore:this.showMore,showOwnDocuments:this.showOwnDocuments,streamState:this.streamState,tracker:this.tracker,username:this.username})},e}();u.OWN_DOCUMENTS="READ_MORE_PlUGIN_OWN_DOCUMENTS",u.RELATED_FOR_FREE_PUBLISHERS="READ_MORE_PlUGIN_RELATED_FOR_FREE_PUBLISHERS",u.RELATED="READ_MORE_PlUGIN_RELATED"},,function(e,t,n){"use strict";function r(e,t){return Math.floor(Math.random()*(t-e+1)+e)}n.d(t,"a",function(){return c});var i=n(2),o=n.n(i),a=n(10),s=n.n(a),u=n(302),c=(n.n(u),function(e){function t(){babelHelpers.classCallCheck(this,t);var n=babelHelpers.possibleConstructorReturn(this,e.call(this));return n.adLoaded=!1,n.randomBucketInt=r(1,10),n}return babelHelpers.inherits(t,e),t.prototype.componentDidUpdate=function(){this.props.isVisible&&!this.adLoaded&&this.loadAd()},t.prototype.loadAd=function(){var e=[["pageType","embed"],["isLoggedIn",this.props.isLoggedIn.toString()],["fullUrl","undefined"!=typeof window?window.document.location.href:""],["publicationId",this.props.publicationId],["ownerUsername",this.props.publisherUsername],["randomBucket",this.randomBucketInt],["isDevelopmentTest",(!1).toString()]],t=this.props.fallbackCover;t&&(e.push(["fallbackLink",encodeURIComponent(t.linkUrl)]),e.push(["fallbackCover",encodeURIComponent(t.imageUrl)])),this.adElement=document.createElement("div"),this.adContainer.appendChild(this.adElement),this.ad=u.create({rootElm:this.adElement,dfpTargeting:e,adProviderConfig:{network:"/30443627/Embed_ReadMore",sizes:[[1,1]]},isProductionEnv:!0,trackingKey:"ads-widget.Embed_ReadMore"}),this.ad.show(),this.adLoaded=!0},t.prototype.render=function(){var e=this;return o.a.createElement("div",{className:"item-container stream-list__item"},o.a.createElement("div",{className:"ad-container",ref:function(t){e.adContainer=t}}))},t}(o.a.Component));c.displayName="Ad",c.propTypes={fallbackCover:s.a.object,isLoggedIn:s.a.bool.isRequired,isVisible:s.a.bool.isRequired,publicationId:s.a.string.isRequired,publisherUsername:s.a.string.isRequired},c.defaultProps={}},function(e,t,n){"use strict";function r(e){for(var t=e+"=",n=document.cookie.split(";"),r=0;r<n.length;r++)try{var i=decodeURIComponent(n[r]).trim();if(0===i.indexOf(t))return i.substring(t.length,i.length)}catch(e){continue}return null}function i(){var e=r("issuu.comstream.debug.style");return!!window.ISSUU_STREAM_DEBUG||null!==e}t.a=i},function(e,t,n){"use strict";n.d(t,"a",function(){return p});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(21),u=n.n(s),c=n(57),l=n.n(c),p=function(e){function t(){return babelHelpers.classCallCheck(this,t),babelHelpers.possibleConstructorReturn(this,e.apply(this,arguments))}return babelHelpers.inherits(t,e),t.prototype.shouldComponentUpdate=function(e,t){return!(l()(this.props,e)&&l()(this.state,t))},t.prototype.render=function(){var e=u()("readmore-header",{"readmore-header--large":!!this.props.large,"readmore-header--one-line":!!this.props.oneLine});return i.a.createElement("div",{className:e},i.a.createElement("span",{className:"readmore-header__text"},"Here's more to read..."))},t}(r.Component);p.displayName="Header",p.propTypes={config:a.a.object.isRequired,large:a.a.bool,oneLine:a.a.bool}},function(e,t,n){"use strict";function r(e){return fetch(e).then(function(e){return e.ok?e.json().then(function(e){return"fail"===e.rsp.stat?Promise.reject():e.rsp._content.stream}):Promise.reject()})}function i(e,t,n){return r(""+e+t+"/call/stream/web/embed/read_more_by_button_click/initial?publicationId="+n+"&seed=42&pageSize=8")}function o(e,t,n){return r(""+e+t+"/call/stream/web/embed/read_more_exit_from_fullscreen/initial?publicationId="+n+"&seed=42&pageSize=8")}function a(e,t,n,i){return r(""+e+t+"/call/stream/web/embed/read_more_from_paying_publisher/initial?ownerUsername="+i+"&publicationId="+n+"&pageSize=8")}function s(e,t,n,i){return r(""+e+t+"/call/stream/web/embed/read_more_from_paying_publisher_from_fullscreen/initial?ownerUsername="+i+"&publicationId="+n+"&pageSize=8")}function u(e,t,n,r,u){var l=null,p=null;return u?(l=a(e,t,n,r),p=s(e,t,n,r)):(l=i(e,t,n),p=o(e,t,n)),Promise.all([l,p]).then(function(e){return new c.a(e[0],e[1])})}t.a=u;var c=n(774)},function(e,t,n){"use strict";n.d(t,"a",function(){return d});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(773),u=n(770),c=n(769),l=n(21),p=n.n(l),d=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onClickStreamItem=function(e,t){r.props.tracker.moreContentDocumentClick({revisionId:e.content.revisionId,publicationId:e.content.publicationId,ownerUsername:e.content.ownerUsername,publicationName:e.content.publicationName,streamOrigin:e.origin,streamRanking:t})},r.onClickSeeMore=function(){r.props.tracker.monitor({type:"reader3-readmore-seemore",click:1,msToClick:Date.now()-r._visibilityTime})},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentDidMount=function(){this._streamDebugMode=n.i(c.a)()},t.prototype.componentDidUpdate=function(e,t){!e.isVisible&&this.props.isVisible&&this.trackOnVisible(this.decideStream())},t.prototype.trackOnVisible=function(e){var t=this;e.map(function(e,n){t.props.tracker.moreContentDocumentShow({revisionId:e.content.revisionId,publicationId:e.content.publicationId,ownerUsername:e.content.ownerUsername,publicationName:e.content.publicationName,pageNumber:1,streamOrigin:e.origin,streamRanking:n})}),this.showReadmoreButton(e)&&this.props.tracker.monitorBatched({type:"reader3-readmore-seemore",impression:1}),this.showHeader(e)&&this.props.tracker.monitorBatched({type:"reader3-readmore-logo",impression:1}),this._visibilityTime=Date.now()},t.prototype.decideStream=function(){if(!this.props.streamState)return[];var e=this.props.exitedFullscreen?this.props.streamState.exitFullscreenStream:this.props.streamState.buttonStream;return this.props.shouldHackStreamCount?e.slice(0,3):e},t.prototype.showHeader=function(e){return this.props.showAsOverlay||e.length>1},t.prototype.showReadmoreButton=function(e){return 4===e.length&&(!this.props.showAsOverlay||window.innerHeight>400)},t.prototype.seeMoreUrl=function(){return this.props.showOwnDocuments&&this.props.username?""+this.props.config.getScheme()+this.props.config.hosts.main+"/"+this.props.username:""+this.props.config.getScheme()+this.props.config.hosts.main+"/explore"},t.prototype.render=function(){var e=this.decideStream();if(!e||0===e.length||!this.props.showMore)return null;var t=window.innerWidth<window.innerHeight,n=t&&this.props.showAsOverlay,r=this.seeMoreUrl(),o=p()("readmore",{"readmore--overlay":this.props.showAsOverlay,"readmore--overlay-landscape":this.props.showAsOverlay&&!t,"readmore--overlay-portrait":this.props.showAsOverlay&&t,"readmore--dropdown-4-items":!this.props.showAsOverlay&&4===e.length,"readmore--dropdown-3-items":!this.props.showAsOverlay&&3===e.length,"readmore--dropdown-2-items":!this.props.showAsOverlay&&2===e.length,"readmore--dropdown-1-items":!this.props.showAsOverlay&&1===e.length}),a=this.props.openInNewTab?"_blank":"_top";return i.a.createElement("div",{className:o},this.showHeader(e)&&i.a.createElement(u.a,{config:this.props.config,large:this.props.showAsOverlay&&window.innerHeight>360&&!t,oneLine:!this.props.showAsOverlay}),i.a.createElement(s.a,{animate:!n,config:this.props.config,debug:this.props.debug||this._streamDebugMode,isLoggedIn:this.props.isLoggedIn,isVisible:this.props.isVisible,onClickElement:this.onClickStreamItem,openInNewTab:this.props.openInNewTab,publicationId:this.props.publicationId,publisherUsername:this.props.username,showAd:this.props.showAd,showAsColumns:n,stream:e}),this.showReadmoreButton(e)&&i.a.createElement("div",{className:"readmore__see-more-wrapper"},i.a.createElement("a",{className:"readmore__see-more",href:r,target:a,onClick:this.onClickSeeMore},"See more on issuu")))},t}(r.Component);d.displayName="MoreContent",d.propTypes={config:a.a.object.isRequired,debug:a.a.bool,exitedFullscreen:a.a.bool.isRequired,isLoggedIn:a.a.bool.isRequired,isVisible:a.a.bool.isRequired,openInNewTab:a.a.bool.isRequired,publicationId:a.a.string.isRequired,shouldHackStreamCount:a.a.bool,showAd:a.a.bool.isRequired,showAsOverlay:a.a.bool.isRequired,showMore:a.a.bool.isRequired,showOwnDocuments:a.a.bool.isRequired,streamState:a.a.object,tracker:a.a.object.isRequired,username:a.a.string.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return l});var r=n(2),i=n.n(r),o=n(10),a=n.n(o),s=n(21),u=n.n(s),c=n(768),l=function(e){function t(){var n,r,i;babelHelpers.classCallCheck(this,t);for(var o=arguments.length,a=Array(o),s=0;s<o;s++)a[s]=arguments[s];return n=r=babelHelpers.possibleConstructorReturn(this,e.call.apply(e,[this].concat(a))),r.onClickStreamItem=function(e,t){r.props.onClickElement(e,t)},i=n,babelHelpers.possibleConstructorReturn(r,i)}return babelHelpers.inherits(t,e),t.prototype.componentWillUpdate=function(e,t){!this.props.isVisible&&e.isVisible&&e.animate?this.refs.stream.classList.add("stream-list--animate"):this.props.isVisible&&!e.isVisible&&this.refs.stream.classList.remove("stream-list--animate")},t.prototype._documentPageUrl=function(e,t){var n=""+this.props.config.getScheme()+this.props.config.hosts.main+"/"+e.content.ownerUsername+"/docs/"+e.content.publicationName,r="?streamOrigin="+encodeURIComponent(e.origin.join(";"))+"&streamRanking="+t;return n.toLowerCase()+r},t.prototype._imgUrl=function(e){var t=e.content.revisionId+"-"+e.content.publicationId;return""+this.props.config.getScheme()+this.props.config.hosts.image+"/"+t+"/jpg/page_1_thumb_large.jpg"},t.prototype._getStreamWithAds=function(e,t){var n=e.slice();return n.splice(t,1,{isAd:!0}),n},t.prototype._getCoverMarkup=function(e,t){var n=this,r=e.content.height/e.content.width,o=e.content.revisionId+"-"+e.content.publicationId,a=this._imgUrl(e),s=this._documentPageUrl(e,t),u={backgroundImage:"url("+a+")"},c=this.props.openInNewTab?"_blank":"_top",l=null;return this.props.debug&&(u.border="5px solid "+e.debug_info.color,l=i.a.createElement("span",{className:"stream-list__debug"},e.origin.join(";"))),i.a.createElement("a",{key:o,className:"stream-list__item stream-list__cover",href:s,style:u,target:c,title:e.content.title,onClick:function(r){return n.onClickStreamItem(e,t)}},l,i.a.createElement("div",{className:"stream-list__item-aspect",style:{paddingTop:100*r+"%"}}))},t.prototype.render=function(){var e=this,t=this.props.showAsColumns&&2!==this.props.stream.length,n=u()("stream-list",{"stream-list--columns":t,"stream-list--shelf":!t}),r=this.props.stream.length-1,o=this.props.showAd?this._getStreamWithAds(this.props.stream,r):this.props.stream;return i.a.createElement("div",{ref:"stream",className:n},o.map(function(t,n){return t.isAd?i.a.createElement(c.a,{key:"ad-key-"+r,isVisible:e.props.isVisible,fallbackCover:{linkUrl:e._documentPageUrl(e.props.stream[r],1),imageUrl:e._imgUrl(e.props.stream[r])},isLoggedIn:e.props.isLoggedIn,publicationId:e.props.publicationId,publisherUsername:e.props.publisherUsername}):e._getCoverMarkup(t,n)}))},t}(r.Component);l.displayName="StreamList",l.propTypes={animate:a.a.bool,config:a.a.object.isRequired,debug:a.a.bool,isLoggedIn:a.a.bool.isRequired,isVisible:a.a.bool,onClickElement:a.a.func.isRequired,openInNewTab:a.a.bool.isRequired,publicationId:a.a.string.isRequired,publisherUsername:a.a.string.isRequired,showAd:a.a.bool.isRequired,showAsColumns:a.a.bool.isRequired,stream:a.a.array.isRequired}},function(e,t,n){"use strict";n.d(t,"a",function(){return r});var r=function e(t,n){babelHelpers.classCallCheck(this,e),this.buttonStream=t,this.exitFullscreenStream=n}},function(e,t,n){var r;/*!
 * jsUri
 * https://github.com/derek-watson/jsUri
 *
 * Copyright 2013, Derek Watson
 * Released under the MIT license.
 *
 * Includes parseUri regular expressions
 * http://blog.stevenlevithan.com/archives/parseuri
 * Copyright 2007, Steven Levithan
 * Released under the MIT license.
 */
!function(i){function o(e){return e&&(e=e.toString().replace(c.pluses,"%20"),e=decodeURIComponent(e)),e}function a(e){var t=c.uri_parser,n=["source","protocol","authority","userInfo","user","password","host","port","isColonUri","relative","path","directory","file","query","anchor"],r=t.exec(e||""),i={};return n.forEach(function(e,t){i[e]=r[t]||""}),i}function s(e){var t,n,r,i,a,s,u,l=[];if(void 0===e||null===e||""===e)return l;for(0===e.indexOf("?")&&(e=e.substring(1)),n=e.toString().split(c.query_separator),t=0,u=n.length;t<u;t++)r=n[t],0!==(i=r.indexOf("="))&&(a=o(r.substring(0,i)),s=o(r.substring(i+1)),l.push(i===-1?[r,null]:[a,s]));return l}function u(e){this.uriParts=a(e),this.queryPairs=s(this.uriParts.query),this.hasAuthorityPrefixUserPref=null}var c={starts_with_slashes:/^\/+/,ends_with_slashes:/\/+$/,pluses:/\+/g,query_separator:/[&;]/,uri_parser:/^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@\/]*)(?::([^:@]*))?)?@)?(\[[0-9a-fA-F:.]+\]|[^:\/?#]*)(?::(\d+|(?=:)))?(:)?)((((?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/};Array.prototype.forEach||(Array.prototype.forEach=function(e,t){var n,r;if(null==this)throw new TypeError(" this is null or not defined");var i=Object(this),o=i.length>>>0;if("function"!=typeof e)throw new TypeError(e+" is not a function");for(arguments.length>1&&(n=t),r=0;r<o;){var a;r in i&&(a=i[r],e.call(n,a,r,i)),r++}}),["protocol","userInfo","host","port","path","anchor"].forEach(function(e){u.prototype[e]=function(t){return void 0!==t&&(this.uriParts[e]=t),this.uriParts[e]}}),u.prototype.hasAuthorityPrefix=function(e){return void 0!==e&&(this.hasAuthorityPrefixUserPref=e),null===this.hasAuthorityPrefixUserPref?this.uriParts.source.indexOf("//")!==-1:this.hasAuthorityPrefixUserPref},u.prototype.isColonUri=function(e){if(void 0===e)return!!this.uriParts.isColonUri;this.uriParts.isColonUri=!!e},u.prototype.query=function(e){var t,n,r,i="";for(void 0!==e&&(this.queryPairs=s(e)),t=0,r=this.queryPairs.length;t<r;t++)n=this.queryPairs[t],i.length>0&&(i+="&"),null===n[1]?i+=n[0]:(i+=n[0],i+="=",void 0!==n[1]&&(i+=encodeURIComponent(n[1])));return i.length>0?"?"+i:i},u.prototype.getQueryParamValue=function(e){var t,n,r;for(n=0,r=this.queryPairs.length;n<r;n++)if(t=this.queryPairs[n],e===t[0])return t[1]},u.prototype.getQueryParamValues=function(e){var t,n,r,i=[];for(t=0,r=this.queryPairs.length;t<r;t++)n=this.queryPairs[t],e===n[0]&&i.push(n[1]);return i},u.prototype.deleteQueryParam=function(e,t){var n,r,i,a,s,u=[];for(n=0,s=this.queryPairs.length;n<s;n++)r=this.queryPairs[n],i=o(r[0])===o(e),a=r[1]===t,(1!==arguments.length||i)&&(2!==arguments.length||i&&a)||u.push(r);return this.queryPairs=u,this},u.prototype.addQueryParam=function(e,t,n){return 3===arguments.length&&n!==-1?(n=Math.min(n,this.queryPairs.length),this.queryPairs.splice(n,0,[e,t])):arguments.length>0&&this.queryPairs.push([e,t]),this},u.prototype.hasQueryParam=function(e){var t,n=this.queryPairs.length;for(t=0;t<n;t++)if(this.queryPairs[t][0]==e)return!0;return!1},u.prototype.replaceQueryParam=function(e,t,n){var r,i,a=-1,s=this.queryPairs.length;if(3===arguments.length){for(r=0;r<s;r++)if(i=this.queryPairs[r],o(i[0])===o(e)&&decodeURIComponent(i[1])===o(n)){a=r;break}a>=0&&this.deleteQueryParam(e,o(n)).addQueryParam(e,t,a)}else{for(r=0;r<s;r++)if(i=this.queryPairs[r],o(i[0])===o(e)){a=r;break}this.deleteQueryParam(e),this.addQueryParam(e,t,a)}return this},["protocol","hasAuthorityPrefix","isColonUri","userInfo","host","port","path","query","anchor"].forEach(function(e){u.prototype["set"+e.charAt(0).toUpperCase()+e.slice(1)]=function(t){return this[e](t),this}}),u.prototype.scheme=function(){var e="";return this.protocol()?(e+=this.protocol(),this.protocol().indexOf(":")!==this.protocol().length-1&&(e+=":"),e+="//"):this.hasAuthorityPrefix()&&this.host()&&(e+="//"),e},u.prototype.origin=function(){var e=this.scheme();return this.userInfo()&&this.host()&&(e+=this.userInfo(),this.userInfo().indexOf("@")!==this.userInfo().length-1&&(e+="@")),this.host()&&(e+=this.host(),(this.port()||this.path()&&this.path().substr(0,1).match(/[0-9]/))&&(e+=":"+this.port())),e},u.prototype.addTrailingSlash=function(){var e=this.path()||"";return"/"!==e.substr(-1)&&this.path(e+"/"),this},u.prototype.toString=function(){var e,t=this.origin();return this.isColonUri()?this.path()&&(t+=":"+this.path()):this.path()?(e=this.path(),c.ends_with_slashes.test(t)||c.starts_with_slashes.test(e)?(t&&t.replace(c.ends_with_slashes,"/"),e=e.replace(c.starts_with_slashes,"/")):t+="/",t+=e):this.host()&&(this.query().toString()||this.anchor())&&(t+="/"),this.query().toString()&&(t+=this.query().toString()),this.anchor()&&(0!==this.anchor().indexOf("#")&&(t+="#"),t+=this.anchor()),t},u.prototype.clone=function(){return new u(this.toString())},void 0!==(r=function(){return u}.call(t,n,t,e))&&(e.exports=r)}()},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(86),i=n.n(r),o=n(775),a=n.n(o),s=n(358),u=n(618),c=(n.n(u),n(803)),l=n(766),p=n(108),d=n(804),f=n(802),h=n(765),m=n(805),g=n(801);if(!n.i(m.a)())throw new Error("Document page reader can only be used inside an iframe, which is hosted on *.issuu.com");var v=Date.now(),b=document.getElementById("app"),y=new a.a(document.location.toString()),_=y.getQueryParamValue("u"),w=y.getQueryParamValue("d"),E=parseInt(y.getQueryParamValue("p"),10)||1,x=n.i(g.a)(),S=n.i(g.b)(),T=n.i(d.a)();p.a.install({sessionId:T,extraContext:{username:_,documentName:w,initialPageNumber:E,hostUrl:x,hostReferrer:S},tagsContext:{embed:"document_page"}}),function(){function e(){return window.FEATURE_TEST?"http://":"//"}var t=new u.Tracker({post:function(t,n,r){var i=e()+"pingback.issuu.com"+t;window.fetch(i,{method:"post",headers:n,credentials:"include",body:JSON.stringify(r)}).catch(function(e){e instanceof TypeError||console.error(e)})},handleError:function(e){n.i(p.b)(e,{fingerprint:["issuu-frontend-tracking"],level:"warning",tags:{errorOrigin:"tracker"}})},getWidth:function(){return window.innerWidth},getHeight:function(){return window.innerHeight},getUsername:function(){try{return window.parent.document.cookie.match(/\bsite.model.username=([^;]+);/)[1]}catch(e){return null}},getLocation:function(){return x},getReferrer:function(){return S},getSource:function(){return"internal"},getOrigin:function(){return"reader3-v1.0.1102_documentpage-v1.0.1102"},getLanguage:function(){return"en"},setTimeout:function(e,t){return window.setTimeout(e,t)},clearTimeout:function(e){return window.clearTimeout(e)},setInterval:function(e,t){return window.setInterval(e,t)},clearInterval:function(e){return window.clearInterval(e)},nagleTimeout:1500});window.ISSUU_READER_ARGUMENTS={tracker:t};var r=document.location.search.indexOf("delayTracking")>=0,o=n.i(s.b)({document:{username:_,name:w,initialPageNumber:E},network:{hosts:{api:"api.issuu.com",layers:"layers.isu.pub",main:"issuu.com",image:"image.isu.pub",photo:"photo.isu.pub",publication:"publication.isu.pub"},imagePath:y.getQueryParamValue("image_path"),getScheme:e},features:{controls:[{type:s.a.NAVIGATION_ARROWS_TYPE},{type:s.a.LINKS_TYPE,allowOnSmallReaders:!0},{type:s.a.FULLSCREEN_TYPE,kind:s.a.FULLSCREEN_KIND.NORMAL,overlayOnSmallReaders:!1,showButtons:s.a.FULLSCREEN_BUTTON.ALWAYS},{type:s.a.ZOOM_TYPE},{type:s.a.SHARE_DIALOG_TYPE,hideWhenNotInFullscreen:!0},{type:s.a.INFO_DIALOG_TYPE,hideWhenNotInFullscreen:!0}],autoFlip:!1,backgroundColor:"#353535",disableLicenseCheck:!0,showControlsUntilFirstInteraction:!0,allowUIToOverlayCover:!1,readModeRules:{defaultMode:s.a.READ_MODE.DOUBLE_PAGE_SPREAD,responsiveModeWhen:s.a.READ_MODE.RESPONSIVE.PHONE_ISH_IN_PORTRAIT},enableInPubAds:!1},isLoggedIn:window.ISSUU_IS_LOGGED_IN,gaTracker:new h.a({}),trackerConfig:{streamData:function(){var e=c.a(window.document.location.search),t=null,n=null;return e.streamOrigin&&e.streamRanking&&(t=e.streamOrigin.split(";"),n=parseInt(e.streamRanking,10)),{origin:t,ranking:n}}(),startTrackingOnLoad:!r,loadStartTimestamp:v,sessionId:T,isEmbed:!1},tracker:t,readMorePlugin:new l.a({tracker:t,show:l.a.RELATED,alwaysOverlay:!1,hideWhenNotInFullscreen:!0,openInNewTab:!1}),isFeatureTest:!!window.FEATURE_TEST});i.a.render(o.reader,b),n.i(f.a)(o.api,e()+"issuu.com")}()},,,,,,,,,,,,,function(e,t){},,,,,,,,,,,,function(e,t,n){"use strict";function r(){try{return window.parent.document.location.toString()}catch(e){return null}}function i(){return new a.a(document.location.toString()).getQueryParamValue("r")||""}n.d(t,"a",function(){return r}),n.d(t,"b",function(){return i});var o=n(775),a=n.n(o)},function(e,t,n){"use strict";function r(e){try{window.parent.postMessage(e,"*")}catch(e){}}function i(e,t){window.addEventListener("message",function(n){(n.origin||n.originalEvent&&n.originalEvent.origin||"").replace(/(https?:\/\/)(?:.*\.)?(t?issuu\.com)/,"$1$2").includes(t)&&("KEY_LEFT"===n.data?e.goToPreviousPage():"KEY_RIGHT"===n.data&&e.goToNextPage())},!1),e.setCallback("ON_PAGE_CHANGE_EVENT",function(e){r({type:"pageChanged",data:e})}),e.setCallback("ON_EXIT_FULLSCREEN",function(){r({type:"reader3ExitFullScreen"})}),e.setCallback("ON_ENTER_FULLSCREEN",function(){r({type:"reader3EnterFullScreen"})})}n.d(t,"a",function(){return i})},function(e,t,n){"use strict";function r(e){var t={};return e?(e.slice(1,e.length).split("&").map(function(e){return e.split("=")}).forEach(function(e){t[e[0]]=decodeURIComponent(e[1])}),t):t}t.a=r},function(e,t,n){"use strict";function r(e){return Math.floor(e*Math.random())}function i(){for(var e="abcdefghijklmnopqrstuvwxyz0123456789",t="",n=0;n<12;n++)t+=e.charAt(r(e.length));return t}t.a=i},function(e,t,n){"use strict";function r(){try{document.domain=document.domain.split(".").slice(-2).join(".")}catch(e){}return parent!==window&&/^(.*\.)?t?issuu\.com(:\d+)?$/.test(window.parent.location.host)}n.d(t,"a",function(){return r})},,,,,,,,,,,,,,,,function(e,t,n){n(301),n(194),n(193),n(776),e.exports=n(789)}]);
//# sourceMappingURL=http://sourcemaps.issuu.com/issuu-reader3-embed-files/1102/document-page-reader.js.map